var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 151560;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 151600;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(152427);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,114,101,115,101,114,118,111,105,114,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,1,0,0,0,6,1,0,0,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,114,105,115,105,110,103,0,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,102,97,108,108,105,110,103,0,0,0,0,0,0,0,0,1,0,0,0,7,1,0,0,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,114,97,116,101,0,0,0,1,0,0,0,9,1,0,0,80,84,49,46,84,0,0,0,1,0,0,0,20,1,0,0,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,1,0,0,0,22,1,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,41,32,62,32,48,46,48,32,116,104,101,110,32,115,105,110,107,46,109,101,100,105,117,109,46,104,32,101,108,115,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,41,32,62,32,48,46,48,32,116,104,101,110,32,115,105,110,107,46,109,101,100,105,117,109,46,104,32,101,108,115,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,65,114,101,97,115,91,50,93,0,0,0,0,0,1,0,0,0,28,1,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,44,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,100,44,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,100,44,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,33,1,0,0,112,117,109,112,115,46,114,104,111,32,42,32,57,46,56,48,54,54,52,57,57,57,57,57,57,57,57,57,57,0,0,0,1,0,0,0,38,1,0,0,112,117,109,112,115,46,78,0,1,0,0,0,39,1,0,0,112,117,109,112,115,46,101,116,97,0,0,0,0,0,0,0,1,0,0,0,43,1,0,0,47,42,82,101,97,108,42,47,40,112,117,109,112,115,46,110,80,97,114,97,108,108,101,108,41,0,0,0,0,0,0,0,1,0,0,0,45,1,0,0,112,117,109,112,115,46,114,104,111,0,0,0,0,0,0,0,1,0,0,0,62,1,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,65,1,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,65,114,101,97,115,91,49,93,0,1,0,0,0,77,1,0,0,114,101,115,101,114,118,111,105,114,46,99,114,111,115,115,65,114,101,97,0,0,0,0,0,1,0,0,0,80,1,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,85,1,0,0,112,117,109,112,115,46,109,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,72,9,0,0,25,1,0,0,7,0,0,0,25,1,0,0,90,0,0,0,0,0,0,0,80,97,114,97,109,101,116,101,114,32,108,101,110,103,116,104,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,111,114,32,101,113,117,97,108,32,104,101,105,103,104,116,95,97,98,46,0,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,87,97,116,101,114,73,70,57,55,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,86,101,115,115,101,108,32,105,115,32,111,118,101,114,102,108,111,119,105,110,103,32,40,102,108,117,105,100,76,101,118,101,108,32,62,32,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,61,32,0,0,0,41,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,200,10,0,0,62,1,0,0,9,0,0,0,62,1,0,0,129,0,0,0,0,0,0,0,70,108,117,105,100,32,108,101,118,101,108,32,40,61,32,0,41,32,105,115,32,98,101,108,111,119,32,122,101,114,111,32,109,101,97,110,105,110,103,32,116,104,97,116,32,116,104,101,32,115,111,108,117,116,105,111,110,32,102,97,105,108,101,100,46,0,0,0,0,0,0,0,200,10,0,0,63,1,0,0,9,0,0,0,63,1,0,0,144,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,136,11,0,0,114,1,0,0,3,0,0,0,114,1,0,0,118,0,0,0,0,0,0,0,82,101,118,101,114,116,105,110,103,32,102,108,111,119,32,111,99,99,117,114,115,32,101,118,101,110,32,116,104,111,117,103,104,32,97,108,108,111,119,70,108,111,119,82,101,118,101,114,115,97,108,32,105,115,32,102,97,108,115,101,0,0,0,0,119,97,116,101,114,0,0,0,70,105,120,101,100,66,111,117,110,100,97,114,121,0,0,0,64,10,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,80,117,109,112,105,110,103,83,121,115,116,101,109,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,80,117,109,112,105,110,103,83,121,115,116,101,109,95,105,110,102,111,46,120,109,108,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,115,97,116,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,32,80,97,32,60,61,32,0,32,80,97,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,112,114,101,115,115,117,114,101,41,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,56,15,0,0,82,11,0,0,9,0,0,0,85,11,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,77,97,99,104,105,110,101,115,46,109,111,0,0,176,15,0,0,119,2,0,0,7,0,0,0,121,2,0,0,43,0,0,0,0,0,0,0,87,114,111,110,103,32,112,117,109,112,32,99,117,114,118,101,32,45,45,32,104,101,97,100,95,110,111,109,105,110,97,108,32,109,117,115,116,32,98,101,32,109,111,110,111,116,111,110,105,99,97,108,108,121,32,100,101,99,114,101,97,115,105,110,103,32,119,105,116,104,32,105,110,99,114,101,97,115,105,110,103,32,86,95,102,108,111,119,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,54,52,46,48,32,42,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,50,46,53,49,32,47,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,97,117,120,49,32,42,32,97,98,115,40,100,112,95,102,114,105,99,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,50,46,53,49,32,47,32,97,117,120,50,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,32,47,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,68,101,108,116,97,32,47,32,51,46,55,32,43,32,53,46,55,52,32,47,32,82,101,32,94,32,48,46,57,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,10,87,114,111,110,103,32,118,97,108,117,101,32,111,102,32,112,97,114,97,109,101,116,101,114,32,100,101,102,105,110,101,95,112,32,40,61,32,102,97,108,115,101,41,32,105,110,32,109,111,100,101,108,32,34,0,34,58,10,84,104,101,32,115,101,108,101,99,116,101,100,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,104,97,115,32,77,101,100,105,117,109,46,115,105,110,103,108,101,83,116,97,116,101,61,116,114,117,101,46,10,84,104,101,114,101,102,111,114,101,44,32,97,110,32,98,111,117,110,100,97,114,121,32,100,101,110,115,105,116,121,32,99,97,110,110,111,116,32,98,101,32,100,101,102,105,110,101,100,32,97,110,100,10,100,101,102,105,110,101,95,112,32,61,32,116,114,117,101,32,105,115,32,114,101,113,117,105,114,101,100,46,10,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,85,116,105,108,105,116,105,101,115,46,109,111,0,88,21,0,0,18,0,0,0,5,0,0,0,23,0,0,0,3,0,0,0,0,0,0,0,10,87,114,111,110,103,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,34,32,105,110,32,109,111,100,101,108,32,34,0,0,0,0,34,58,10,84,104,101,32,98,111,117,110,100,97,114,121,32,118,97,108,117,101,32,88,95,98,111,117,110,100,97,114,121,40,0,0,0,0,0,0,0,41,32,61,32,0,0,0,0,10,105,115,32,110,101,103,97,116,105,118,101,46,32,73,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,10,0,0,0,0,0,88,21,0,0,26,0,0,0,7,0,0,0,33,0,0,0,3,0,0,0,0,0,0,0,32,32,32,88,95,98,111,117,110,100,97,114,121,91,0,0,93,32,61,32,0,0,0,0,32,34,0,0,0,0,0,0,34,10,0,0,0,0,0,0,84,104,101,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,100,111,32,110,111,116,32,115,117,109,32,117,112,32,116,111,32,49,46,32,73,110,115,116,101,97,100,44,32,115,117,109,40,88,95,98,111,117,110,100,97,114,121,41,32,61,32,0,58,10,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,97,116,97,32,112,111,105,110,116,115,32,110,111,116,32,115,111,114,116,101,100,32,97,112,112,114,111,112,114,105,97,116,101,108,121,32,40,120,48,32,61,32,0,0,32,62,32,120,49,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,102,108,105,112,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,0,0,0,88,21,0,0,94,2,0,0,5,0,0,0,95,2,0,0,74,0,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,101,114,105,118,97,116,105,118,101,115,32,97,116,32,100,97,116,97,32,112,111,105,110,116,115,32,100,111,32,110,111,116,32,97,108,108,111,119,32,99,111,45,109,111,110,111,116,111,110,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,44,32,97,115,32,98,111,116,104,32,97,114,101,32,110,111,110,45,122,101,114,111,44,32,111,102,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,97,110,100,32,104,97,118,101,32,97,110,32,97,98,115,111,108,117,116,101,32,118,97,108,117,101,32,108,97,114,103,101,114,32,116,104,97,110,32,109,97,99,104,105,110,101,32,101,112,115,32,40,121,48,100,32,61,32,0,44,32,121,49,100,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,99,111,114,114,101,99,116,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,88,21,0,0,101,2,0,0,7,0,0,0,102,2,0,0,79,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,97,116,104,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,104,24,0,0,177,4,0,0,5,0,0,0,179,4,0,0,51,0,0,0,0,0,0,0,83,111,108,118,105,110,103,32,97,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,119,105,116,104,32,102,117,110,99,116,105,111,110,10,34,77,97,116,114,105,99,101,115,46,115,111,108,118,101,34,32,105,115,32,110,111,116,32,112,111,115,115,105,98,108,101,44,32,98,101,99,97,117,115,101,32,116,104,101,32,115,121,115,116,101,109,32,104,97,115,32,101,105,116,104,101,114,10,110,111,32,111,114,32,105,110,102,105,110,105,116,101,108,121,32,109,97,110,121,32,115,111,108,117,116,105,111,110,115,32,40,65,32,105,115,32,115,105,110,103,117,108,97,114,41,46,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,100,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,112,52,0,0,120,52,0,0,0,0,0,0,1,0,0,0,96,51,0,0,104,51,0,0,0,0,0,0,1,0,0,0,80,50,0,0,88,50,0,0,0,0,0,0,1,0,0,0,80,49,0,0,88,49,0,0,0,0,0,0,1,0,0,0,80,48,0,0,88,48,0,0,0,0,0,0,1,0,0,0,80,47,0,0,88,47,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,111,91,50,53,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,56,15,0,0,204,11,0,0,9,0,0,0,206,11,0,0,62,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,112,115,97,116,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,54,49,49,46,54,53,55,32,75,41,46,10,108,111,119,101,114,32,116,104,97,110,32,116,104,101,32,116,114,105,112,108,101,32,112,111,105,110,116,32,116,101,109,112,101,114,97,116,117,114,101,32,50,55,51,46,49,54,32,75,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,32,48,46,48,32,80,97,0,0,56,15,0,0,6,7,0,0,9,0,0,0,8,7,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,48,32,77,112,97,0,0,0,0,0,56,15,0,0,9,7,0,0,9,0,0,0,10,7,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,32,75,41,32,105,115,32,108,111,119,101,114,32,116,104,97,110,32,50,55,51,46,49,53,32,75,33,0,0,0,0,0,56,15,0,0,11,7,0,0,9,0,0,0,12,7,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,116,104,101,32,108,105,109,105,116,32,111,102,32,49,48,55,51,46,49,53,32,75,0,0,0,0,0,0,0,56,15,0,0,13,7,0,0,9,0,0,0,15,7,0,0,55,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,103,46,112,105,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,56,15,0,0,103,6,0,0,9,0,0,0,106,6,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,56,15,0,0,107,6,0,0,9,0,0,0,108,6,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,56,15,0,0,109,6,0,0,9,0,0,0,110,6,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,56,15,0,0,190,8,0,0,9,0,0,0,192,8,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,32,77,112,97,32,105,110,32,114,101,103,105,111,110,32,53,0,0,56,15,0,0,193,8,0,0,9,0,0,0,194,8,0,0,67,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,108,105,109,105,116,32,111,102,32,50,50,55,51,46,49,53,75,32,105,110,32,114,101,103,105,111,110,32,53,0,0,0,0,0,0,0,0,56,15,0,0,195,8,0,0,9,0,0,0,196,8,0,0,77,0,0,0,0,0,0,0,120,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,112,104,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,56,15,0,0,37,10,0,0,9,0,0,0,40,10,0,0,41,0,0,0,0,0,0,0,1,0,0,0,32,47,0,0,40,47,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,112,32,116,111,111,32,108,111,119,10,112,32,61,32,0,0,0,0,32,80,97,32,60,32,0,0,32,80,97,0,0,0,0,0,56,15,0,0,117,19,0,0,9,0,0,0,119,19,0,0,76,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,108,111,119,10,84,32,61,32,0,0,0,0,32,75,32,60,32,0,0,0,32,75,0,0,0,0,0,0,56,15,0,0,120,19,0,0,9,0,0,0,122,19,0,0,73,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,104,105,103,104,10,112,32,61,32,0,0,0,32,80,97,44,32,84,32,61,32,0,0,0,0,0,0,0,56,15,0,0,123,19,0,0,9,0,0,0,125,19,0,0,66,0,0,0,0,0,0,0,56,15,0,0,178,19,0,0,9,0,0,0,178,19,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,111,102,112,116,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,1,0,0,0,40,46,0,0,48,46,0,0,0,0,0,0,1,0,0,0,48,45,0,0,56,45,0,0,0,0,0,0,1,0,0,0,56,44,0,0,64,44,0,0,0,0,0,0,1,0,0,0,48,43,0,0,56,43,0,0,0,0,0,0,1,0,0,0,40,42,0,0,48,42,0,0,0,0,0,0,1,0,0,0,32,41,0,0,40,41,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,111,102,112,84,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,56,15,0,0,19,17,0,0,9,0,0,0,22,17,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,111,102,112,84,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,56,15,0,0,122,16,0,0,9,0,0,0,125,16,0,0,41,0,0,0,0,0,0,0,56,15,0,0,214,19,0,0,11,0,0,0,215,19,0,0,91,0,0,0,0,0,0,0,73,110,118,101,114,115,101,32,105,116,101,114,97,116,105,111,110,32,111,102,32,100,116,32,102,114,111,109,32,112,104,32,99,97,108,108,101,100,32,105,110,32,50,32,112,104,97,115,101,32,114,101,103,105,111,110,58,32,116,104,105,115,32,99,97,110,32,110,111,116,32,119,111,114,107,0,0,0,0,0,56,15,0,0,246,19,0,0,9,0,0,0,247,19,0,0,65,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,116,111,102,112,104,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,56,15,0,0,221,20,0,0,9,0,0,0,221,20,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,116,111,102,112,104,53,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,98,111,117,110,100,97,114,121,50,51,111,102,112,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,56,15,0,0,222,0,0,0,9,0,0,0,225,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,56,15,0,0,80,1,0,0,9,0,0,0,83,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,56,15,0,0,160,1,0,0,9,0,0,0,163,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,56,15,0,0,54,1,0,0,9,0,0,0,57,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,56,15,0,0,238,0,0,0,9,0,0,0,241,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,56,15,0,0,255,0,0,0,9,0,0,0,2,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,56,15,0,0,222,1,0,0,9,0,0,0,225,1,0,0,41,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,114,101,103,105,111,110,32,99,111,109,112,117,116,97,116,105,111,110,32,111,102,32,73,70,57,55,32,115,116,101,97,109,32,116,97,98,108,101,115,40,112,32,61,32,0,0,0,44,32,84,32,61,32,0,0,41,0,0,0,0,0,0,0,56,15,0,0,48,28,0,0,7,0,0,0,49,28,0,0,58,0,0,0,0,0,0,0,1,0,0,0,200,39,0,0,208,39,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,118,105,115,99,95,100,84,112,32,102,111,114,32,118,105,115,99,111,115,105,116,121,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,100,101,110,115,105,116,121,10,100,32,61,32,0,0,0,0,32,60,61,32,0,0,0,0,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,100,101,110,115,105,116,121,41,0,56,15,0,0,87,15,0,0,9,0,0,0,90,15,0,0,37,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,118,105,115,99,95,100,84,112,58,32,118,105,115,99,111,115,105,116,121,32,99,111,109,112,117,116,101,100,32,111,117,116,115,105,100,101,32,116,104,101,32,114,97,110,103,101,10,111,102,32,118,97,108,105,100,105,116,121,32,111,102,32,116,104,101,32,73,70,57,55,32,102,111,114,109,117,108,97,116,105,111,110,58,32,112,32,61,32,0,0,0,32,80,97,44,32,84,99,32,61,32,0,0,0,0,0,0,56,15,0,0,91,15,0,0,9,0,0,0,96,15,0,0,44,0,0,0,0,0,0,0,56,15,0,0,11,25,0,0,7,0,0,0,11,25,0,0,71,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,105,116,101,114,97,116,105,111,110,32,111,102,32,115,116,101,97,109,32,116,97,98,108,101,115,0,0,0,0,0,0,44,32,104,32,61,32,0,0,56,15,0,0,22,25,0,0,7,0,0,0,23,25,0,0,58,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,102,233,84,67,44,108,224,63,94,63,14,148,37,132,212,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,146,76,152,122,231,232,191,208,196,42,148,59,34,200,63,25,161,233,54,242,138,203,63], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([209,13,3,76,207,106,231,63,54,90,14,244,80,219,243,63,203,158,4,54,231,160,247,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,107,108,10,191,47,9,210,191,8,60,48,128,240,33,241,191,149,73,13,109,0,54,244,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,203,126,130,48,92,194,198,63,252,86,235,196,229,120,221,63,107,35,67,51,244,244,205,63,137,194,29,94,198,131,223,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,220,181,41,195,93,98,165,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,251,55,47,78,124,196,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,193,4,234,164,41,144,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,151,88,73,198,146,187,109,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,24,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,50,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,54,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,32,64,32,0,0,0,0,0,0,0,27,82,16,195,221,180,117,63,91,241,78,159,211,197,197,191,232,255,187,127,199,67,38,64,218,1,248,99,246,5,161,192,206,136,30,128,39,149,64,191,48,128,218,26,207,206,225,63,240,4,46,183,154,223,34,192,202,136,215,255,21,16,211,191,53,217,90,128,221,123,87,64,96,90,249,145,239,193,147,63,112,55,147,142,204,253,218,63,163,49,164,161,90,37,76,193,177,214,63,238,242,53,126,191,8,53,151,241,70,180,214,191,219,168,78,20,129,246,255,191,128,189,125,5,23,121,242,63,106,24,188,51,171,51,182,64,51,132,142,203,34,141,128,63,185,137,15,26,189,17,198,63,103,2,133,8,232,174,240,63,117,149,156,29,96,13,211,191,220,149,151,95,192,238,225,63,74,192,30,215,113,157,209,63,201,162,112,86,16,253,194,191,77,228,10,220,83,171,176,191,227,251,230,96,194,101,7,192,83,250,58,253,84,5,177,63,139,233,23,51,210,47,12,64,66,43,165,221,120,248,141,191,205,57,22,215,212,245,1,192,102,59,4,98,115,175,241,63,101,90,82,13,170,237,164,191,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,24,64,30,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,30,0,0,0,0,0,0,0,125,184,117,9,34,88,35,190,173,203,40,168,167,53,78,62,229,95,204,153,121,156,195,62,254,182,180,246,203,101,1,191,18,48,47,21,9,176,81,63,201,60,7,228,82,94,209,191,146,130,40,50,1,39,241,63,80,49,160,27,129,82,235,191,246,174,159,174,28,145,246,190,144,218,49,221,87,56,73,63,102,117,23,114,203,168,113,191,17,114,159,221,142,3,221,63,83,94,100,244,123,63,224,191,136,254,137,238,104,30,89,192,254,28,203,4,207,14,204,191,58,249,102,172,225,175,9,192,18,211,236,226,138,252,130,64,231,85,151,136,54,70,66,63,249,169,122,242,247,255,199,63,70,140,135,102,188,138,130,63,249,126,253,99,70,68,210,63,125,150,168,88,97,228,160,63,230,210,248,105,245,180,206,63,138,172,175,65,105,79,19,64,104,245,29,59,110,155,39,192,119,152,47,138,217,177,197,63,81,88,2,150,187,109,146,191,36,129,254,185,99,9,163,63,224,240,16,12,61,117,171,191,96,179,24,60,39,182,249,63,5,0,0,0,0,0,0,0,248,196,66,103,212,192,117,64,133,199,236,54,203,172,242,191,226,202,254,210,61,179,80,63,25,115,134,86,91,228,129,64,99,5,225,42,114,214,43,64,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,44,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,52,64,0,0,0,0,0,0,54,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,31,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,20,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,40,64,31,0,0,0,0,0,0,0,227,139,224,185,7,240,129,190,199,167,35,43,83,31,211,62,40,114,77,59,34,174,238,190,41,130,212,196,250,47,122,63,63,226,81,247,138,76,119,64,152,254,207,52,139,18,188,192,100,178,19,129,109,128,33,65,128,60,67,165,246,105,68,193,89,239,89,2,195,131,1,191,251,187,130,30,23,35,153,191,195,72,114,66,134,231,71,64,201,118,94,97,66,9,224,62,55,111,232,94,106,7,85,63,170,153,252,205,103,136,145,63,24,215,84,75,40,5,33,192,233,234,135,170,60,245,139,191,125,151,220,87,30,32,208,190,68,241,91,70,74,164,107,63,178,108,175,52,233,166,225,191,206,12,139,3,160,85,231,63,97,97,173,126,173,83,132,191,249,173,4,9,6,139,190,191,51,14,161,48,222,103,233,63,53,239,38,140,197,18,221,63,222,108,213,220,59,225,202,63,33,203,14,111,2,77,122,191,203,46,12,82,120,20,152,191,183,35,106,48,182,169,100,63,238,50,72,229,102,84,127,191,29,139,85,18,145,227,139,63,111,231,135,7,126,62,139,191,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,44,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,33,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,32,64,33,0,0,0,0,0,0,0,77,167,246,65,166,242,0,63,149,115,198,175,185,184,32,191,108,133,64,64,120,47,63,191,140,106,98,88,202,150,89,63,223,23,144,208,200,16,187,63,239,224,44,179,125,118,85,192,164,38,97,234,30,161,134,64,31,236,239,98,140,73,104,63,166,229,119,245,35,71,120,191,219,58,64,176,10,222,137,191,178,42,1,159,147,159,189,191,158,152,86,48,155,57,85,64,166,99,70,220,226,61,134,191,170,142,33,156,255,153,143,63,106,100,216,77,47,54,179,63,132,234,73,145,175,219,153,63,193,132,70,10,49,217,174,191,171,220,81,100,26,156,8,192,247,200,6,135,176,99,173,191,219,94,228,246,139,35,20,64,58,0,51,85,69,154,237,191,184,70,117,189,181,86,15,64,193,109,7,107,34,84,83,192,97,26,42,55,139,138,194,64,245,24,97,50,133,133,53,193,210,177,220,201,81,50,96,65,11,93,150,161,24,142,235,63,150,223,73,71,181,177,212,63,181,166,108,245,236,241,235,63,67,187,199,160,31,242,219,191,232,227,2,191,153,87,210,63,178,144,147,195,28,222,192,191,63,45,198,149,134,183,123,63,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,1,0,0,0,85,0,0,0,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,65,114,101,97,0,0,0,0,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,0,0,0,0,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,50,93,32,42,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,0,0,0,0,0,1,0,0,0,122,0,0,0,112,117,109,112,115,46,78,95,110,111,109,105,110,97,108,0,112,117,109,112,115,46,78,0,112,117,109,112,115,46,114,104,111,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,112,117,109,112,115,46,114,104,111,0,0,0,0,0,0,0,1,0,0,0,145,0,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,146,0,0,0,47,42,82,101,97,108,42,47,40,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,32,43,32,45,49,41,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,1,0,0,0,149,0,0,0,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,0,0,0,0,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,49,93,32,42,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,0,0,0,0,0,1,0,0,0,167,0,0,0,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,254,0,0,0,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,0,0,0,0,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,51,93,32,42,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,0,0,0,0,0,1,0,0,0,17,1,0,0,1,0,0,0,36,1,0,0,1,0,0,0,42,1,0,0,1,0,0,0,57,1,0,0,1,0,0,0,58,1,0,0,1,0,0,0,61,1,0,0,1,0,0,0,71,1,0,0,1,0,0,0,74,1,0,0,114,101,115,101,114,118,111,105,114,46,112,95,97,109,98,105,101,110,116,0,0,0,0,0,1,0,0,0,96,0,0,0,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,65,114,101,97,0,0,0,0,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,0,0,0,0,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,51,93,32,42,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,0,0,0,0,0,248,56,0,0,24,57,0,0,80,57,0,0,136,57,0,0,192,57,0,0,24,58,0,0,192,58,0,0,224,58,0,0,56,59,0,0,144,59,0,0,116,105,109,101,32,60,32,118,97,108,118,101,79,112,101,110,105,110,103,46,115,116,97,114,116,84,105,109,101,0,0,0,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,32,62,61,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,104,101,105,103,104,116,0,0,0,0,0,0,0,0,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,32,62,61,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,0,0,0,0,0,0,0,0,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,32,62,61,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,0,0,0,0,0,0,0,0,114,101,115,101,114,118,111,105,114,46,115,91,51,93,32,62,32,48,46,48,32,111,114,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,104,101,105,103,104,116,32,62,61,32,114,101,115,101,114,118,111,105,114,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,0,0,0,0,0,0,0,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,121,41,32,97,110,100,32,99,111,110,116,114,111,108,108,101,114,46,117,32,60,32,82,101,108,97,116,105,118,101,80,114,101,115,115,117,114,101,83,101,116,80,111,105,110,116,46,107,32,43,32,48,46,53,32,42,32,99,111,110,116,114,111,108,108,101,114,46,98,97,110,100,119,105,100,116,104,32,111,114,32,99,111,110,116,114,111,108,108,101,114,46,117,32,60,32,82,101,108,97,116,105,118,101,80,114,101,115,115,117,114,101,83,101,116,80,111,105,110,116,46,107,32,43,32,45,48,46,53,32,42,32,99,111,110,116,114,111,108,108,101,114,46,98,97,110,100,119,105,100,116,104,0,116,105,109,101,32,60,32,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,84,0,0,0,0,0,0,0,114,101,115,101,114,118,111,105,114,46,115,91,50,93,32,62,32,48,46,48,32,111,114,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,62,61,32,114,101,115,101,114,118,111,105,114,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,0,0,0,0,0,0,0,114,101,115,101,114,118,111,105,114,46,115,91,49,93,32,62,32,48,46,48,32,111,114,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,114,101,115,101,114,118,111,105,114,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,0,0,0,0,0,0,0,112,117,109,112,115,46,115,32,62,32,48,46,48,0,0,0,1,0,0,0,246,0,0,0,1,0,0,0,245,0,0,0,1,0,0,0,243,0,0,0,1,0,0,0,241,0,0,0,1,0,0,0,255,255,255,255,1,0,0,0,2,1,0,0,1,0,0,0,8,1,0,0,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,160,59,0,0,168,59,0,0,176,59,0,0,184,59,0,0,192,59,0,0,200,59,0,0,208,59,0,0,216,59,0,0,224,59,0,0,232,59,0,0,114,101,115,101,114,118,111,105,114,46,115,91,51,93,32,62,32,48,46,48,0,0,0,0,99,111,110,116,114,111,108,108,101,114,46,117,32,60,32,82,101,108,97,116,105,118,101,80,114,101,115,115,117,114,101,83,101,116,80,111,105,110,116,46,107,32,43,32,48,46,53,32,42,32,99,111,110,116,114,111,108,108,101,114,46,98,97,110,100,119,105,100,116,104,0,0,99,111,110,116,114,111,108,108,101,114,46,117,32,60,32,82,101,108,97,116,105,118,101,80,114,101,115,115,117,114,101,83,101,116,80,111,105,110,116,46,107,32,43,32,45,48,46,53,32,42,32,99,111,110,116,114,111,108,108,101,114,46,98,97,110,100,119,105,100,116,104,0,114,101,115,101,114,118,111,105,114,46,115,91,50,93,32,62,32,48,46,48,0,0,0,0,114,101,115,101,114,118,111,105,114,46,115,91,49,93,32,62,32,48,46,48,0,0,0,0,248,56,0,0,24,57,0,0,80,57,0,0,136,57,0,0,24,60,0,0,48,60,0,0,120,60,0,0,192,58,0,0,192,60,0,0,216,60,0,0,144,59,0,0,0,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,50,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,114,101,115,101,114,118,111,105,114,46,95,114,101,103,117,108,97,114,70,108,111,119,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,114,101,115,101,114,118,111,105,114,46,95,114,101,103,117,108,97,114,70,108,111,119,91,50,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,114,101,115,101,114,118,111,105,114,46,95,114,101,103,117,108,97,114,70,108,111,119,91,51,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,114,101,115,101,114,118,111,105,114,46,95,105,110,70,108,111,119,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,114,101,115,101,114,118,111,105,114,46,95,105,110,70,108,111,119,91,50,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,114,101,115,101,114,118,111,105,114,46,95,105,110,70,108,111,119,91,51,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,99,111,110,116,114,111,108,108,101,114,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,95,101,110,100,86,97,108,117,101,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,95,114,97,116,101,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,95,84,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,0,112,117,109,112,115,46,109,101,100,105,117,109,46,84,32,45,32,112,117,109,112,115,46,84,95,115,116,97,114,116,0,0,112,117,109,112,115,46,109,101,100,105,117,109,46,112,32,45,32,112,117,109,112,115,46,112,95,115,116,97,114,116,0,0,45,50,46,50,32,43,32,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,0,0,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,84,32,45,32,114,101,115,101,114,118,111,105,114,46,84,95,115,116,97,114,116,0,0,110,111,116,32,112,114,101,40,99,111,110,116,114,111,108,108,101,114,46,121,41,32,61,61,32,99,111,110,116,114,111,108,108,101,114,46,112,114,101,95,121,95,115,116,97,114,116,0,80,84,49,46,121,32,45,32,80,84,49,46,121,95,115,116,97,114,116,0,0,0,0,0,32,64,0,0,96,64,0,0,144,64,0,0,176,64,0,0,208,64,0,0,232,64,0,0,16,65,0,0,64,65,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,30,0,0,0,112,105,112,101,46,112,101,114,105,109,101,116,101,114,0,0,1,0,0,0,31,0,0,0,1,0,0,0,47,0,0,0,115,105,110,107,46,109,101,100,105,117,109,46,100,0,0,0,1,0,0,0,48,0,0,0,115,111,117,114,99,101,46,109,101,100,105,117,109,46,100,0,1,0,0,0,53,0,0,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,61,0,0,0,80,84,49,46,84,0,0,0,80,84,49,46,107,0,0,0,1,0,0,0,68,0,0,0,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,114,101,115,101,114,118,111,105,114,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,1,0,0,0,88,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,41,32,62,32,48,46,48,32,116,104,101,110,32,115,105,110,107,46,109,101,100,105,117,109,46,104,32,101,108,115,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,41,32,62,32,48,46,48,32,116,104,101,110,32,115,105,110,107,46,109,101,100,105,117,109,46,104,32,101,108,115,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,65,114,101,97,115,91,50,93,0,0,0,0,0,1,0,0,0,91,0,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,85,116,105,108,105,116,105,101,115,46,114,101,103,83,116,101,112,40,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,44,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,100,44,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,100,44,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,115,109,97,108,108,41,0,0,0,0,1,0,0,0,103,0,0,0,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,114,105,115,105,110,103,0,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,102,97,108,108,105,110,103,0,0,0,0,0,0,0,0,1,0,0,0,119,0,0,0,112,117,109,112,115,46,114,104,111,32,42,32,57,46,56,48,54,54,52,57,57,57,57,57,57,57,57,57,57,0,0,0,1,0,0,0,123,0,0,0,112,117,109,112,115,46,78,0,1,0,0,0,124,0,0,0,112,117,109,112,115,46,101,116,97,0,0,0,0,0,0,0,1,0,0,0,127,0,0,0,112,117,109,112,115,46,114,104,111,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,112,117,109,112,115,46,114,104,111,0,0,0,0,0,0,0,68,73,86,73,83,73,79,78,40,104,111,109,111,116,111,112,121,80,97,114,97,109,101,116,101,114,40,41,32,43,32,45,49,46,48,44,32,112,117,109,112,115,46,114,104,111,95,110,111,109,105,110,97,108,41,32,45,32,68,73,86,73,83,73,79,78,40,104,111,109,111,116,111,112,121,80,97,114,97,109,101,116,101,114,40,41,44,32,112,117,109,112,115,46,114,104,111,41,0,0,0,0,0,0,1,0,0,0,128,0,0,0,47,42,82,101,97,108,42,47,40,112,117,109,112,115,46,110,80,97,114,97,108,108,101,108,41,0,0,0,0,0,0,0,1,0,0,0,136,0,0,0,1,0,0,0,154,0,0,0,112,117,109,112,115,46,109,0,1,0,0,0,161,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,65,114,101,97,115,91,49,93,0,1,0,0,0,173,0,0,0,114,101,115,101,114,118,111,105,114,46,99,114,111,115,115,65,114,101,97,0,0,0,0,0,1,0,0,0,176,0,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,177,0,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,111,1,0,0,47,42,82,101,97,108,42,47,40,112,117,109,112,115,46,110,80,97,114,97,108,108,101,108,41,32,42,32,112,117,109,112,115,46,114,104,111,95,110,111,109,105,110,97,108,0,0,0,1,0,0,0,115,1,0,0,47,42,82,101,97,108,42,47,40,45,49,32,43,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,41,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,161,1,0,0,115,111,117,114,99,101,46,109,101,100,105,117,109,46,100,0,1,0,0,0,168,1,0,0,112,105,112,101,46,112,101,114,105,109,101,116,101,114,0,0,1,0,0,0,169,1,0,0,1,0,0,0,174,1,0,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,204,1,0,0,115,105,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,121,115,116,101,109,46,109,111,0,0,0,0,168,74,0,0,32,0,0,0,3,0,0,0,34,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,168,74,0,0,29,0,0,0,3,0,0,0,31,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,168,74,0,0,26,0,0,0,3,0,0,0,28,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,168,74,0,0,47,0,0,0,3,0,0,0,49,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,168,74,0,0,44,0,0,0,3,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,168,74,0,0,63,0,0,0,3,0,0,0,65,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,168,74,0,0,60,0,0,0,3,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,168,74,0,0,57,0,0,0,3,0,0,0,59,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([32,97,110,100,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,168,74,0,0,35,0,0,0,3,0,0,0,38,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,168,74,0,0,22,0,0,0,3,0,0,0,25,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,168,74,0,0,11,0,0,0,3,0,0,0,13,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,168,74,0,0,8,0,0,0,3,0,0,0,10,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,84,49,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,84,49,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,80,84,49,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,67,111,110,116,105,110,117,111,117,115,46,109,111,0,0,0,0,0,0,0,40,83,0,0,76,1,0,0,5,0,0,0,79,1,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,102,97,108,108,105,110,103,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,102,97,108,108,105,110,103,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,76,111,103,105,99,97,108,46,109,111,0,0,8,84,0,0,208,2,0,0,5,0,0,0,209,2,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,114,105,115,105,110,103,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,117,109,112,82,80,77,71,101,110,101,114,97,116,111,114,46,114,105,115,105,110,103,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,8,84,0,0,206,2,0,0,5,0,0,0,207,2,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,115,105,110,107,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,111,117,114,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,105,110,107,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,84,32,62,61,32,49,46,48,32,97,110,100,32,115,105,110,107,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,100,32,62,61,32,48,46,48,32,97,110,100,32,115,105,110,107,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,112,32,62,61,32,48,46,48,32,97,110,100,32,115,105,110,107,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,115,105,110,107,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,224,88,0,0,59,1,0,0,3,0,0,0,61,1,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,100,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,100,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,100,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,88,0,0,56,1,0,0,3,0,0,0,58,1,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,97,108,118,101,115,46,109,111,0,0,0,0,152,90,0,0,49,1,0,0,5,0,0,0,50,1,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,152,90,0,0,46,1,0,0,5,0,0,0,48,1,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,95,115,109,97,108,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,224,88,0,0,63,1,0,0,3,0,0,0,65,1,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,95,115,116,97,114,116,95,101,112,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,95,115,116,97,114,116,95,101,112,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,200,93,0,0,85,0,0,0,3,0,0,0,85,0,0,0,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,200,93,0,0,70,0,0,0,3,0,0,0,72,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,93,0,0,24,1,0,0,9,0,0,0,25,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,200,93,0,0,65,0,0,0,3,0,0,0,67,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,200,93,0,0,62,0,0,0,3,0,0,0,64,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,93,0,0,58,0,0,0,3,0,0,0,58,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,93,0,0,213,0,0,0,9,0,0,0,215,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,200,93,0,0,210,0,0,0,9,0,0,0,212,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,51,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,50,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,93,0,0,43,2,0,0,7,0,0,0,44,2,0,0,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,200,93,0,0,41,2,0,0,7,0,0,0,42,2,0,0,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,200,93,0,0,40,2,0,0,7,0,0,0,40,2,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,200,93,0,0,38,2,0,0,7,0,0,0,39,2,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,88,0,0,236,1,0,0,5,0,0,0,237,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,100,101,108,116,97,95,104,101,97,100,95,105,110,105,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,100,101,108,116,97,95,104,101,97,100,95,105,110,105,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,77,97,99,104,105,110,101,115,46,109,111,0,0,40,111,0,0,66,1,0,0,5,0,0,0,67,1,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,224,88,0,0,45,2,0,0,7,0,0,0,47,2,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,117,109,112,115,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,88,0,0,40,2,0,0,7,0,0,0,42,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,117,109,112,115,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,88,0,0,37,2,0,0,7,0,0,0,39,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,40,111,0,0,58,1,0,0,5,0,0,0,60,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,88,0,0,59,2,0,0,7,0,0,0,61,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,114,104,111,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,111,0,0,79,1,0,0,5,0,0,0,81,1,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,117,109,112,115,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,224,88,0,0,34,2,0,0,7,0,0,0,36,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,117,109,112,115,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,224,88,0,0,31,2,0,0,7,0,0,0,33,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,117,109,112,115,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,40,111,0,0,61,1,0,0,5,0,0,0,63,1,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,40,111,0,0,55,1,0,0,5,0,0,0,57,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,117,109,112,115,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,88,0,0,55,2,0,0,7,0,0,0,58,2,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,112,117,109,112,115,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,224,88,0,0,51,2,0,0,7,0,0,0,54,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,111,0,0,70,1,0,0,5,0,0,0,71,1,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,80,121,0,0,87,4,0,0,13,0,0,0,91,4,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,121,0,0,80,4,0,0,13,0,0,0,82,4,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,121,0,0,26,4,0,0,13,0,0,0,28,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,121,0,0,21,4,0,0,13,0,0,0,23,4,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,121,0,0,229,4,0,0,13,0,0,0,231,4,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,121,0,0,221,4,0,0,13,0,0,0,222,4,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,121,0,0,32,4,0,0,13,0,0,0,34,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,121,0,0,29,4,0,0,13,0,0,0,31,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,121,0,0,14,0,0,0,5,0,0,0,16,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,121,0,0,17,0,0,0,5,0,0,0,19,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,80,121,0,0,11,0,0,0,5,0,0,0,13,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,121,0,0,7,1,0,0,7,0,0,0,9,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,121,0,0,255,0,0,0,7,0,0,0,0,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,121,0,0,248,0,0,0,7,0,0,0,249,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,96,85,0,0,27,0,0,0,5,0,0,0,30,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,96,85,0,0,23,0,0,0,5,0,0,0,26,0,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,84,32,62,61,32,49,46,48,32,97,110,100,32,115,111,117,114,99,101,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,96,85,0,0,20,0,0,0,5,0,0,0,22,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,100,32,62,61,32,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,96,85,0,0,13,0,0,0,5,0,0,0,16,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,112,32,62,61,32,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,96,85,0,0,10,0,0,0,5,0,0,0,12,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,115,111,117,114,99,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,96,85,0,0,20,3,0,0,5,0,0,0,22,3,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,97,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,97,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,97,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,93,0,0,224,0,0,0,9,0,0,0,224,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,105,110,107,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,135,0,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,115,105,110,107,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,200,135,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,115,105,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,135,0,0,150,27,0,0,7,0,0,0,150,27,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,105,110,107,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,200,135,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,100,32,62,61,32,48,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,84,32,62,61,32,49,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,112,143,0,0,145,0,0,0,5,0,0,0,145,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,80,121,0,0,245,4,0,0,13,0,0,0,1,5,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,98,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,98,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,98,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,88,0,0,13,0,0,0,5,0,0,0,14,0,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,115,116,97,116,101,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,115,116,97,116,101,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,115,105,110,107,46,115,116,97,116,101,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,115,116,97,116,101,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,115,116,97,116,101,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,105,110,107,46,115,116,97,116,101,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,115,116,97,116,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,115,116,97,116,101,46,100,32,62,61,32,48,46,48,32,97,110,100,32,115,105,110,107,46,115,116,97,116,101,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,115,105,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,115,105,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,115,105,110,107,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,105,110,107,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,105,110,107,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,115,105,110,107,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,115,116,97,116,101,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,115,116,97,116,101,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,115,111,117,114,99,101,46,115,116,97,116,101,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,115,116,97,116,101,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,115,116,97,116,101,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,115,116,97,116,101,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,112,143,0,0,143,0,0,0,5,0,0,0,143,0,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,115,116,97,116,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,115,116,97,116,101,46,100,32,62,61,32,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,115,116,97,116,101,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,112,143,0,0,144,0,0,0,5,0,0,0,144,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,115,111,117,114,99,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,80,114,101,115,115,117,114,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,224,88,0,0,16,0,0,0,5,0,0,0,17,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,98,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,117,109,112,115,46,109,111,110,105,116,111,114,105,110,103,46,115,116,97,116,101,95,105,110,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,200,135,0,0,74,22,0,0,7,0,0,0,75,22,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([200,135,0,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,112,143,0,0,164,0,0,0,5,0,0,0,168,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,200,135,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,200,135,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,111,114,116,95,98,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,111,114,116,95,98,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,112,111,114,116,95,98,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,152,162,0,0,16,0,0,0,5,0,0,0,17,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,192,164,0,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,192,164,0,0,53,4,0,0,13,0,0,0,53,4,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,192,164,0,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,192,164,0,0,56,4,0,0,13,0,0,0,56,4,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,152,162,0,0,29,4,0,0,9,0,0,0,34,4,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,77,97,99,104,105,110,101,115,46,109,111,0,0,144,171,0,0,140,1,0,0,5,0,0,0,140,1,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,112,172,0,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,112,117,109,112,115,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,112,172,0,0,150,27,0,0,7,0,0,0,150,27,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,114,104,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,114,104,111,32,62,61,32,48,46,48,32,97,110,100,32,112,117,109,112,115,46,114,104,111,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,171,0,0,137,1,0,0,5,0,0,0,137,1,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,117,109,112,115,46,104,101,97,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,117,109,112,115,46,104,101,97,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,171,0,0,139,1,0,0,5,0,0,0,139,1,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,152,162,0,0,74,2,0,0,7,0,0,0,74,2,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,91,51,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,91,51,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,91,51,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,152,162,0,0,15,0,0,0,5,0,0,0,15,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,128,178,0,0,224,0,0,0,9,0,0,0,224,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,128,178,0,0,255,0,0,0,9,0,0,0,0,1,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,128,178,0,0,14,1,0,0,9,0,0,0,15,1,0,0,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,128,178,0,0,53,0,0,0,3,0,0,0,54,0,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,112,172,0,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,112,172,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,112,172,0,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,114,101,115,101,114,118,111,105,114,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,112,172,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,100,32,62,61,32,48,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,169,0,0,144,0,0,0,5,0,0,0,144,0,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,84,32,62,61,32,49,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,115,116,97,116,101,95,97,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,32,169,0,0,145,0,0,0,5,0,0,0,145,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,111,112,101,110,105,110,103,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,111,112,101,110,105,110,103,32,62,61,32,48,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,111,112,101,110,105,110,103,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,97,108,118,101,115,46,109,111,0,0,0,0,200,188,0,0,53,1,0,0,5,0,0,0,61,1,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,112,111,114,116,95,97,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,112,111,114,116,95,97,95,84,32,62,61,32,49,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,112,111,114,116,95,97,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,152,162,0,0,89,1,0,0,3,0,0,0,94,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,112,111,114,116,95,98,95,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,112,111,114,116,95,98,95,84,32,62,61,32,49,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,112,111,114,116,95,98,95,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,152,162,0,0,95,1,0,0,3,0,0,0,100,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,32,62,61,32,45,48,46,48,32,97,110,100,32,117,115,101,114,86,97,108,118,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,152,162,0,0,76,1,0,0,3,0,0,0,78,1,0,0,69,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,80,117,109,112,105,110,103,83,121,115,116,101,109,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,53,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,53,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,53,44,53,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,53,44,48,93,32,61,32,122,101,114,111,115,40,53,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,53,93,32,61,32,122,101,114,111,115,40,48,44,53,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,53,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,80,84,49,80,121,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,114,101,115,101,114,118,111,105,114,80,109,101,100,105,117,109,80,84,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,114,101,115,101,114,118,111,105,114,80,108,101,118,101,108,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,117,109,112,115,80,109,101,100,105,117,109,80,84,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,112,117,109,112,115,80,109,101,100,105,117,109,80,112,32,61,32,120,91,53,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,80,117,109,112,105,110,103,83,121,115,116,101,109,59,10,0,0,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,197,0,0,40,197,0,0,56,197,0,0,80,197,0,0,112,197,0,0,128,197,0,0,152,197,0,0,168,197,0,0,192,197,0,0,224,197,0,0,8,198,0,0,32,198,0,0,64,198,0,0,88,198,0,0,128,198,0,0,160,198,0,0,208,198,0,0,0,199,0,0,24,199,0,0,80,199,0,0,104,199,0,0,152,199,0,0,184,199,0,0,240,199,0,0,24,200,0,0,80,200,0,0,128,200,0,0,144,200,0,0,176,200,0,0,216,200,0,0,248,200,0,0,32,201,0,0,72,201,0,0,96,201,0,0,120,201,0,0,136,201,0,0,160,201,0,0,208,201,0,0,32,202,0,0,96,202,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,144,216,0,0,32,215,0,0,168,213,0,0,48,212,0,0,48,212,0,0,184,210,0,0,168,213,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,88,227,0,0,224,223,0,0,112,222,0,0,0,221,0,0,0,221,0,0,144,219,0,0,112,222,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,160,225,0,0,176,225,0,0,192,225,0,0,144,210,0,0,200,225,0,0,216,225,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,56,229,0,0,64,229,0,0,72,229,0,0,80,229,0,0,200,228,0,0,88,229,0,0,104,229,0,0,112,229,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,99,108,111,110,101,95,98,97,115,101,95,97,114,114,97,121,95,115,112,101,99,0,0,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,0,0,0,0,0,0,0,0,0,0,56,231,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,99,108,111,110,101,95,114,101,118,101,114,115,101,95,98,97,115,101,95,97,114,114,97,121,95,115,112,101,99,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,16,232,0,0,32,232,0,0,40,232,0,0,48,232,0,0,64,232,0,0,80,232,0,0,88,232,0,0,104,232,0,0,120,232,0,0,136,232,0,0,152,232,0,0,168,232,0,0,184,232,0,0,200,232,0,0,216,232,0,0,224,232,0,0,232,232,0,0,248,232,0,0,0,233,0,0,16,233,0,0,32,233,0,0,48,233,0,0,64,233,0,0,80,233,0,0,96,233,0,0,112,233,0,0,128,233,0,0,144,233,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,24,234,0,0,32,234,0,0,32,234,0,0,64,234,0,0,112,234,0,0,144,234,0,0,200,234,0,0,248,234,0,0,40,235,0,0,72,235,0,0,120,235,0,0,144,235,0,0,176,235,0,0,216,235,0,0,248,235,0,0,40,236,0,0,72,236,0,0,112,236,0,0,144,236,0,0,184,236,0,0,232,236,0,0,32,237,0,0,72,237,0,0,120,237,0,0,168,237,0,0,208,237,0,0,0,238,0,0,8,238], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,24,234,0,0,8,241,0,0,16,241,0,0,24,241,0,0,40,232,0,0,32,241,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,105,110,116,101,103,101,114,95,97,114,114,97,121,46,99,0,0,0,0,99,111,112,121,95,105,110,116,101,103,101,114,95,97,114,114,97,121,95,100,97,116,97,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,61,61,50,32,38,38,32,100,101,115,116,45,62,110,100,105,109,115,61,61,50,0,0,0,116,114,97,110,115,112,111,115,101,95,105,110,116,101,103,101,114,95,97,114,114,97,121,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,91,48,93,32,61,61,32,109,32,38,38,32,100,101,115,116,45,62,100,105,109,95,115,105,122,101,91,49,93,32,61,61,32,110,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,100,0,0,0,0,37,100,100,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,144,243,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,168,243,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,192,243,0,0,200,243,0,0,208,243,0,0,224,243,0,0,240,243,0,0,248,243,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,61,61,50,32,38,38,32,100,101,115,116,45,62,110,100,105,109,115,61,61,50,0,0,0,116,114,97,110,115,112,111,115,101,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,91,48,93,32,61,61,32,109,32,38,38,32,100,101,115,116,45,62,100,105,109,95,115,105,122,101,91,49,93,32,61,61,32,110,0,0,0,0,0,0,0,0,109,97,120,95,114,101,97,108,95,97,114,114,97,121,0,0,109,105,110,95,114,101,97,108,95,97,114,114,97,121,0,0,115,117,109,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,160,0,1,0,0,0,0,0,24,0,1,0,0,0,0,0,144,255,0,0,0,0,0,0,8,255,0,0,0,0,0,0,0,254,0,0,0,0,0,0,248,252,0,0,0,0,0,0,240,251,0,0,0,0,0,0,232,250,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,136,2,1,0,152,2,1,0,160,2,1,0,168,2,1,0,184,2,1,0,192,2,1,0,200,2,1,0,208,2,1,0,216,2,1,0,224,2,1,0,232,2,1,0,248,2,1,0,0,3,1,0,16,3,1,0,32,3,1,0,48,3,1,0,56,3,1,0,72,3,1,0,80,3,1,0,96,3,1,0,104,3,1,0,128,3,1,0,136,3,1,0,144,3,1,0,160,3,1,0,168,3,1,0,184,3,1,0,200,3,1,0,208,3,1,0,216,3,1,0,224,3,1,0,232,3,1,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,120,4,1,0,128,4,1,0,200,4,1,0,248,4,1,0,40,5,1,0,112,5,1,0,176,5,1,0,248,5,1,0,40,6,1,0,112,6,1,0,136,6,1,0,168,6,1,0,224,6,1,0,8,7,1,0,48,7,1,0,104,7,1,0,184,7,1,0,24,8,1,0,72,8,1,0,128,8,1,0,176,8,1,0,248,8,1,0,32,9,1,0,80,9,1,0,128,9,1,0,216,9,1,0,32,10,1,0,144,10,1,0,192,10,1,0,8,11,1,0,40,11,1,0,232,3,1,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,120,4,1,0,232,11,1,0,144,12,1,0,248,4,1,0,40,5,1,0,248,12,1,0,176,5,1,0,248,5,1,0,128,13,1,0,192,13,1,0,136,6,1,0,168,6,1,0,96,14,1,0,160,14,1,0,224,14,1,0,104,7,1,0,184,7,1,0,32,15,1,0,88,15,1,0,224,15,1,0,8,16,1,0,248,8,1,0,32,9,1,0,80,9,1,0,112,16,1,0,248,16,1,0,248,17,1,0,144,10,1,0,192,10,1,0,8,11,1,0,40,11,1,0,232,3,1,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,23,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,23,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,23,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,23,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,23,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+65824);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,41,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+76168);
/* memory initializer */ allocate([16,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,47,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,46,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,48,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,48,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,48,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,48,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,49,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,49,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,51,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,51,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,51,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,51,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,51,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,51,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,86,1,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,87,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,88,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,88,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,192,88,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,200,88,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,89,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,89,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,16,89,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,152,101,1,0,184,102,1,0,192,102,1,0,208,102,1,0,224,102,1,0,240,102,1,0,8,103,1,0,32,103,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,152,101,1,0,160,101,1,0,232,101,1,0,16,102,1,0,48,102,1,0,80,102,1,0,120,102,1,0,160,102,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,109,105,120,101,100,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,119,105,116,104,32,105,110,100,101,120,32,37,100,32,97,116,32,116,105,109,101,32,37,101,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,72,111,1,0,88,111,1,0,96,111,1,0,104,111,1,0,112,111,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,144,111,1,0,152,111,1,0,168,111,1,0,184,111,1,0,112,111,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+86852);
/* memory initializer */ allocate([240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,120,138,1,0,64,140,1,0,72,140,1,0,80,140,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,120,138,1,0,128,139,1,0,208,139,1,0,0,140,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,120,138,1,0,64,139,1,0,72,139,1,0,80,139,1,0,96,139,1,0,104,139,1,0,120,139,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,120,138,1,0,128,138,1,0,152,138,1,0,168,138,1,0,240,138,1,0,0,139,1,0,32,139,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,40,150,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,40,150,1,0,10,0,0,0,11,0,0,0,204,149,1,0,68,150,1,0,88,150,1,0,224,149,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,56,80,2,0,248,149,1,0,192,11,2,0,0,0,0,0,104,0,0,0,0,0,0,0,192,11,2,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,192,11,2,0,14,0,0,0,15,0,0,0,0,0,0,0,208,150,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,56,80,2,0,160,150,1,0,184,10,2,0,0,0,0,0,0,0,0,0,88,151,1,0,96,151,1,0,80,151,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,48,151,1,0,64,151,1,0,80,151,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+97094);
/* memory initializer */ allocate([116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,176,167,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,176,167,1,0,20,0,0,0,21,0,0,0,84,167,1,0,204,167,1,0,224,167,1,0,104,167,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,56,80,2,0,128,167,1,0,48,11,2,0,0,0,0,0,108,0,0,0,0,0,0,0,48,11,2,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,48,11,2,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,232,177,1,0,208,179,1,0,216,179,1,0,32,182,1,0,56,180,1,0,72,180,1,0,40,182,1,0,48,182,1,0,56,182,1,0,64,182,1,0,80,182,1,0,96,182,1,0,112,182,1,0,128,182,1,0,144,182,1,0,160,182,1,0,176,182,1,0,200,182,1,0,0,182,1,0,24,182,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,232,177,1,0,208,179,1,0,216,179,1,0,232,179,1,0,56,180,1,0,72,180,1,0,88,180,1,0,120,180,1,0,152,180,1,0,184,180,1,0,224,180,1,0,8,181,1,0,48,181,1,0,88,181,1,0,112,181,1,0,144,181,1,0,176,181,1,0,216,181,1,0,0,182,1,0,24,182,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,232,177,1,0,176,179,1,0,184,179,1,0,192,179,1,0,232,177,1,0,240,178,1,0,64,179,1,0,112,179,1,0,232,177,1,0,176,178,1,0,184,178,1,0,192,178,1,0,208,178,1,0,216,178,1,0,232,178,1,0,0,0,0,0,232,177,1,0,240,177,1,0,8,178,1,0,24,178,1,0,96,178,1,0,112,178,1,0,144,178,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,8,185,1,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,8,185,1,0,29,0,0,0,30,0,0,0,148,184,1,0,36,185,1,0,56,185,1,0,168,184,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,56,80,2,0,192,184,1,0,192,11,2,0,0,0,0,0,56,0,0,0,0,0,0,0,192,11,2,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,192,11,2,0,14,0,0,0,15,0,0,0,0,0,0,0,200,185,1,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,56,80,2,0,128,185,1,0,184,10,2,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+107334);
/* memory initializer */ allocate([101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,88,206,1,0,88,206,1,0,88,206,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,0,209,1,0,16,209,1,0,40,209,1,0,72,209,1,0,104,209,1,0,128,209,1,0,160,209,1,0,184,209,1,0,200,209,1,0,216,209,1,0,240,209,1,0,8,210,1,0,40,210,1,0,72,210,1,0,216,209,1,0,96,210,1,0,128,210,1,0,152,210,1,0,176,210,1,0,200,210,1,0,232,210,1,0,248,210,1,0,24,211,1,0,56,211,1,0,80,211,1,0,104,211,1,0,128,211,1,0,144,211,1,0,168,211,1,0,192,211,1,0,216,211,1,0,248,211,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+117576);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+124840);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,0,253,1,0,8,253,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,24,253,1,0,32,253,1,0,40,253,1,0,48,253,1,0,144,1,0,0,0,0,0,0,160,253,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+130064);
/* memory initializer */ allocate([120,4,2,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,56,80,2,0,88,4,2,0,248,10,2,0,0,0,0,0,0,0,0,0,224,4,2,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,56,80,2,0,200,4,2,0,248,10,2,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,120,5,2,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,56,80,2,0,88,5,2,0,184,10,2,0,0,0,0,0,0,0,0,0,224,5,2,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,56,80,2,0,200,5,2,0,184,10,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,16,80,2,0,240,5,2,0,0,0,0,0,88,6,2,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,7,2,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,56,80,2,0,72,6,2,0,0,0,0,0,0,0,0,0,0,0,0,0,152,6,2,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,56,80,2,0,128,6,2,0,88,6,2,0,0,0,0,0,0,0,0,0,216,6,2,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,56,80,2,0,192,6,2,0,88,6,2,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,56,80,2,0,232,6,2,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,72,7,2,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,56,80,2,0,48,7,2,0,0,7,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,16,80,2,0,88,7,2,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,56,80,2,0,128,7,2,0,120,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,48,10,2,0,49,0,0,0,50,0,0,0,0,0,0,0,184,10,2,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,248,10,2,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,48,11,2,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,48,11,2,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,120,11,2,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,120,11,2,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,192,11,2,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,192,11,2,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,8,12,2,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,8,12,2,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,9,2,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,248,9,2,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,56,80,2,0,176,9,2,0,72,7,2,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,16,80,2,0,224,9,2,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,56,80,2,0,0,10,2,0,248,9,2,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,56,80,2,0,64,10,2,0,248,9,2,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,16,80,2,0,128,10,2,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,16,80,2,0,192,10,2,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,152,80,2,0,0,11,2,0,0,0,0,0,1,0,0,0,48,10,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,152,80,2,0,72,11,2,0,0,0,0,0,1,0,0,0,112,10,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,152,80,2,0,144,11,2,0,0,0,0,0,1,0,0,0,48,10,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,152,80,2,0,216,11,2,0,0,0,0,0,1,0,0,0,112,10,2,0,3,244,255,255,0,0,0,0,104,12,2,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,56,80,2,0,72,12,2,0,152,7,2,0,0,0,0,0,0,0,0,0,144,26,2,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,26,2,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,31,2,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,0,32,2,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,32,2,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,33,2,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,128,28,2,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,128,28,2,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,32,29,2,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,32,29,2,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,176,29,2,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,30,2,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,27,2,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,27,2,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,27,2,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,27,2,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,33,2,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,120,34,2,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,8,35,2,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,152,35,2,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,30,2,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,30,2,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,104,26,2,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,23,2,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,24,2,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,26,2,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,64,26,2,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,120,22,2,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,56,80,2,0,96,22,2,0,16,6,2,0,0,0,0,0,0,0,0,0,8,23,2,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,16,80,2,0,232,22,2,0,152,80,2,0,208,22,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,0,23,2,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,152,80,2,0,40,23,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,0,23,2,0,2,0,0,0,0,0,0,0,216,23,2,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,16,80,2,0,184,23,2,0,152,80,2,0,144,23,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,208,23,2,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,152,80,2,0,248,23,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,208,23,2,0,2,0,0,0,0,0,0,0,152,24,2,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,152,80,2,0,112,24,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,208,23,2,0,2,0,0,0,0,0,0,0,16,25,2,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,152,80,2,0,232,24,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,208,23,2,0,2,0,0,0,0,0,0,0,136,25,2,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,56,80,2,0,96,25,2,0,16,25,2,0,0,0,0,0,0,0,0,0,240,25,2,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,56,80,2,0,200,25,2,0,16,25,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,56,80,2,0,0,26,2,0,120,22,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,56,80,2,0,40,26,2,0,120,22,2,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,56,80,2,0,80,26,2,0,120,22,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,56,80,2,0,120,26,2,0,120,22,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,56,80,2,0,160,26,2,0,120,22,2,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,16,80,2,0,232,26,2,0,152,80,2,0,200,26,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,0,27,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,152,80,2,0,40,27,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,0,27,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,152,80,2,0,104,27,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,0,27,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,152,80,2,0,168,27,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,0,27,2,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,16,80,2,0,48,28,2,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,16,80,2,0,80,28,2,0,152,80,2,0,232,27,2,0,0,0,0,0,3,0,0,0,120,22,2,0,2,0,0,0,72,28,2,0,2,0,0,0,120,28,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,16,80,2,0,240,28,2,0,152,80,2,0,168,28,2,0,0,0,0,0,3,0,0,0,120,22,2,0,2,0,0,0,72,28,2,0,2,0,0,0,24,29,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,16,80,2,0,144,29,2,0,152,80,2,0,72,29,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,168,29,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,152,80,2,0,208,29,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,168,29,2,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,16,80,2,0,80,30,2,0,152,80,2,0,56,30,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,104,30,2,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,152,80,2,0,144,30,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,104,30,2,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,16,80,2,0,40,31,2,0,152,80,2,0,16,31,2,0,0,0,0,0,1,0,0,0,72,31,2,0,0,0,0,0,152,80,2,0,200,30,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,80,31,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,152,80,2,0,208,31,2,0,0,0,0,0,1,0,0,0,72,31,2,0,0,0,0,0,152,80,2,0,136,31,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,232,31,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,16,80,2,0,128,32,2,0,152,80,2,0,104,32,2,0,0,0,0,0,1,0,0,0,160,32,2,0,0,0,0,0,152,80,2,0,32,32,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,168,32,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,152,80,2,0,40,33,2,0,0,0,0,0,1,0,0,0,160,32,2,0,0,0,0,0,152,80,2,0,224,32,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,64,33,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,16,80,2,0,192,33,2,0,152,80,2,0,120,33,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,224,33,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,16,80,2,0,80,34,2,0,152,80,2,0,8,34,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,112,34,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,16,80,2,0,224,34,2,0,152,80,2,0,152,34,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,0,35,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,16,80,2,0,112,35,2,0,152,80,2,0,40,35,2,0,0,0,0,0,2,0,0,0,120,22,2,0,2,0,0,0,144,35,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+132116);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,128,77,2,0,110,0,0,0,136,77,2,0,114,0,0,0,144,77,2,0,102,0,0,0,152,77,2,0,97,0,0,0,160,77,2,0,101,0,0,0,168,77,2,0,119,0,0,0,176,77,2,0,87,0,0,0,192,77,2,0,115,0,0,0,208,77,2,0,83,0,0,0,224,77,2,0,100,0,0,0,240,77,2,0,68,0,0,0,0,78,2,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,136,79,2,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,16,80,2,0,96,79,2,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,56,80,2,0,120,79,2,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,56,80,2,0,152,79,2,0,112,79,2,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,56,80,2,0,208,79,2,0,192,79,2,0,0,0,0,0,0,0,0,0,248,79,2,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,128,80,2,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,56,80,2,0,88,80,2,0,248,79,2,0,0,0,0,0,0,0,0,0,224,80,2,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,56,80,2,0,184,80,2,0,248,79,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,83,2,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,56,80,2,0,16,83,2,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+142456);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }

  var _acos=Math_acos;

  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }

  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

  function _log10(x) {
      return Math.log(x) / Math.LN10;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }


  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._exp;var Va=env._lis_matrix_assemble;var Wa=env._strrchr;var Xa=env._pthread_key_create;var Ya=env._vsscanf;var Za=env.__ZSt9terminatev;var _a=env.___cxa_guard_acquire;var $a=env._log10;var ab=env._fstat;var bb=env._pclose;var cb=env._lis_solver_create;var db=env.___assert_fail;var eb=env.__ZSt18uncaught_exceptionv;var fb=env._longjmp;var gb=env.__isLeapYear;var hb=env._clock_gettime;var ib=env._fsync;var jb=env._signal;var kb=env._GC_collect_a_little;var lb=env._sbrk;var mb=env._strtoull;var nb=env._emscripten_memcpy_big;var ob=env.__parseInt64;var pb=env._close;var qb=env._rewind;var rb=env._cos;var sb=env._fileno;var tb=env._fread;var ub=env._puts;var vb=env._isatty;var wb=env._lis_matrix_set_value;var xb=env._write;var yb=env._isblank;var zb=env._ftell;var Ab=env.__ZNSt9exceptionD2Ev;var Bb=env._xerbla_;var Cb=env._round;var Db=env.___cxa_does_inherit;var Eb=env._strtoll_l;var Fb=env._strstr;var Gb=env.___cxa_rethrow;var Hb=env._llvm_lifetime_end;var Ib=env._catclose;var Jb=env._tmpnam;var Kb=env._lis_vector_get_values;var Lb=env._lis_vector_destroy;var Mb=env._lis_solver_set_option;var Nb=env._tmpfile;var Ob=env._send;var Pb=env._pow;var Qb=env._lis_matrix_set_size;var Rb=env.___cxa_free_exception;var Sb=env.___cxa_find_matching_catch;var Tb=env._isxdigit_l;var Ub=env.___cxa_guard_release;var Vb=env._truncate;var Wb=env._strtol;var Xb=env.__reallyNegative;var Yb=env._sin;var Zb=env._strtok;var _b=env.___setErrNo;var $b=env._newlocale;var ac=env._isdigit_l;var bc=env.___resumeException;var cc=env._freelocale;var dc=env._srand;var ec=env._qsort;var fc=env._putchar;var gc=env._floor;var hc=env._pthread_mutex_unlock;var ic=env._printf;var jc=env._sprintf;var kc=env._fopen;var lc=env._vasprintf;var mc=env._emscripten_get_now;var nc=env._stat;var oc=env._lis_solve;var pc=env._strtoull_l;var qc=env._mkport;var rc=env._read;var sc=env.__addDays;var tc=env._fwrite;var uc=env._time;var vc=env._pthread_mutex_lock;var wc=env._catopen;var xc=env._exit;var yc=env._GC_strdup;var zc=env._freopen;var Ac=env.___ctype_b_loc;var Bc=env._fmod;var Cc=env._strtok_r;var Dc=env._lseek;var Ec=env._access;var Fc=env._vfprintf;var Gc=env.___cxa_allocate_exception;var Hc=env._atoi;var Ic=env._strtoll;var Jc=env._pwrite;var Kc=env._localtime_r;var Lc=env._tzset;var Mc=env._open;var Nc=env._uselocale;var Oc=env._snprintf;var Pc=env.___errno_location;var Qc=env._GC_malloc;var Rc=env.___cxa_end_catch;var Sc=env._perror;var Tc=env.___cxa_begin_catch;var Uc=env._strftime;var Vc=env._ftruncate;var Wc=env._GC_init;var Xc=env._lis_matrix_set_type;var Yc=env._fseek;var Zc=env._isxdigit;var _c=env._fclose;var $c=env._vsnprintf;var ad=env.__parseInt;var bd=env._log;var cd=env._pthread_cond_broadcast;var dd=env._popen;var ed=env._recv;var fd=env._fgetc;var gd=env._sysconf;var hd=env.__getFloat;var id=env._lis_vector_set_value;var jd=env._abort;var kd=env._ceil;var ld=env._isspace;var md=env._localtime;var nd=env._lis_matrix_destroy;var od=env._pthread_getspecific;var pd=env._pthread_cond_wait;var qd=env._llvm_lifetime_start;var rd=env.___cxa_is_number_type;var sd=env._acos;var td=env._ungetc;var ud=env._system;var vd=env._fmin;var wd=env._fmax;var xd=env._fflush;var yd=env._strftime_l;var zd=env._fprintf;var Ad=env._sscanf;var Bd=env._catgets;var Cd=env._lis_solver_destroy;var Dd=env._strdup;var Ed=env._asprintf;var Fd=env.__exit;var Gd=env.___ctype_toupper_loc;var Hd=env._bsearch;var Id=env.__arraySum;var Jd=env.__formatString;var Kd=env._htonl;var Ld=env.___ctype_tolower_loc;var Md=env._unlink;var Nd=env._fputs;var Od=env._GC_malloc_atomic;var Pd=env._pread;var Qd=env._lis_vector_set_size;var Rd=env._fscanf;var Sd=env.__scanString;var Td=env._pthread_setspecific;var Ud=env._copysign;var Vd=env._fputc;var Wd=env.___cxa_throw;var Xd=env._lis_matrix_create;var Yd=env._isdigit;var Zd=env._strerror;var _d=env._emscripten_longjmp;var $d=env._lis_vector_create;var ae=env._atexit;var be=env._sqrt;var ce=env._strerror_r;var de=0.0;
// EMSCRIPTEN_START_FUNCS
function Rw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Sw(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Tw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=Vw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=nw(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 29:{if((c[52368+((d[53648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Uw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 29:{if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=nw(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[52368+((d[53648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Vw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=Ww(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=nw(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Ww(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=nw(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=nw(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Xw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=$w(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=_w(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=nw(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=Zw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=Yw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=nw(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 17:{break b;break};case 29:{if((c[52368+((d[53648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 5:{o=39;break b;break};case 6:{o=42;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 11:{o=90;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=nw(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 24:case 22:{break};case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};case 29:{if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=nw(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 6:{o=81;break d;break};case 17:{break c;break};case 24:case 22:{break d;break};case 29:{o=75;break d;break};case 10:case 9:case 21:{break};case 7:{o=84;break d;break};case 5:{o=78;break d;break};case 11:{o=90;break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=ax(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Yw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=nw(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 8:case 1:case 0:{l=20;break b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Zw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[54688+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function _w(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=nw(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=nw(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{p=62;break b;break};case 29:{if((c[52368+((d[53648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};case 6:{p=31;break b;break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((bx(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=nw(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((bx(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function $w(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=nw(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 6:{n=31;break b;break};case 29:{if((c[52368+((d[53648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{n=37;break b;break};case 7:{n=34;break b;break};case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=nw(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function ax(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=nw(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 7:{l=16;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=nw(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 29:{if((c[52368+((d[52112+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 5:{l=30;break a;break};case 24:case 22:{break};case 7:{l=36;break a;break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 5:{l=10;break a;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=nw(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 29:{if((c[52368+((d[53648+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 6:{l=13;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=nw(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=nw(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 3:{t=Tw(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 2:{l=79;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=nw(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=nw(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 24:case 22:{break d;break};case 11:{l=106;break a;break};case 6:{l=100;break a;break};case 5:{l=97;break a;break};case 7:{l=103;break a;break};case 29:{l=94;break d;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[52368+((d[52112+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function bx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function cx(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=nw(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=nw(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function dx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=Yw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=nw(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=nw(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function ex(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=nw(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 7:{n=34;break b;break};case 29:{if((c[52368+((d[53648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function fx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 13:{k=Px(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((Ae[c[j+352>>2]&127](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((Ae[c[j+340>>2]&127](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{n=15;break};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 19:{k=Rx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((Ae[c[j+348>>2]&127](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((Ae[c[j+336>>2]&127](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=Qx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 15:{k=Lx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((Ae[c[j+344>>2]&127](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((Ae[c[j+332>>2]&127](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 12:{k=Px(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 30:{k=Fx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{n=116;break b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){n=94;break b}p=b;if((Ae[c[j+332>>2]&127](j,b)|0)==0){n=96;break b}b=p+2|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}q=b;if((Ae[c[j+336>>2]&127](j,b)|0)==0){n=101;break b}b=q+3|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}r=b;if((Ae[c[j+340>>2]&127](j,b)|0)==0){n=106;break b}b=r+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{n=91;break b;break};default:{m=19;continue b}}break};case 33:{n=113;break b;break};case 6:{if((e-b|0)<3){n=77;break b}s=b;if((Ae[c[j+336>>2]&127](j,b)|0)==0){n=79;break b}b=s+3|0;continue b;break};case 5:{if((e-b|0)<2){n=72;break b}t=b;if((Ae[c[j+332>>2]&127](j,b)|0)==0){n=74;break b}b=t+2|0;continue b;break};case 7:{if((e-b|0)<4){n=82;break b}u=b;if((Ae[c[j+340>>2]&127](j,b)|0)==0){n=84;break b}b=u+4|0;continue b;break};case 34:{n=110;break b;break};case 29:{n=69;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==110){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function gx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 3:{k=Ex(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+364>>2]&127](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+360>>2]&127](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+356>>2]&127](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 2:{k=Ix(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 7:{if((e-b|0)<4){n=49;break b}if((Ae[c[j+364>>2]&127](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((Ae[c[j+360>>2]&127](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((Ae[c[j+356>>2]&127](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function hx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+364>>2]&127](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+356>>2]&127](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+360>>2]&127](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 7:{if((e-b|0)<4){n=47;break b}if((Ae[c[j+364>>2]&127](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((Ae[c[j+360>>2]&127](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((Ae[c[j+356>>2]&127](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ix(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((Ae[c[j+364>>2]&127](j,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 2:{m=b+1|0;b=m;if((m|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}n=b;if((Ae[c[j+356>>2]&127](j,b)|0)!=0){k=7;break a}b=n+2|0;continue a;break};case 4:{m=b+1|0;b=m;if((m|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 6:{if((e-b|0)<3){k=10;break a}o=b;if((Ae[c[j+360>>2]&127](j,b)|0)!=0){k=12;break a}b=o+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function jx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 10:{m=13;break a;break};case 2:{m=12;break a;break};case 6:{a=a+3|0;continue a;break};case 3:{m=9;break a;break};case 21:{m=23;break a;break};case 9:{m=16;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Ex(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function kx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 9:{m=18;break a;break};case 10:{m=15;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 30:{m=12;break a;break};case 3:{m=9;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Ex(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Fx(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function lx(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};case 5:{break};case 6:{j=5;break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function mx(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function nx(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};default:{break a}}}i=c;return a-b|0}function ox(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function px(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function qx(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Bv(c)|0;g=f;i=b;return g|0}function rx(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function sx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 6:{a=a+3|0;break};case 5:{a=a+2|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 7:{a=a+4|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function tx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 21:{if((a[b]|0)==9){k=5;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function ux(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function vx(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function wx(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[52368+(((d[53648+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function xx(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[52368+(((d[53648+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function yx(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function zx(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[52368+(((d[52112+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Ax(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[52368+(((d[52112+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Bx(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Cx(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Dx(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function Ex(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+348>>2]&127](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+344>>2]&127](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=Gx(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+352>>2]&127](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}m=a;if((Ae[c[h+340>>2]&127](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((Ae[c[h+336>>2]&127](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 29:{l=25;break b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((Ae[c[h+332>>2]&127](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Fx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+348>>2]&127](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+344>>2]&127](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+352>>2]&127](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 18:{l=42;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}m=a;if((Ae[c[h+340>>2]&127](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((Ae[c[h+336>>2]&127](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 29:{l=25;break b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((Ae[c[h+332>>2]&127](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Gx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Hx(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Hx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Ix(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 17:{k=Mx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+352>>2]&127](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=Kx(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=Jx(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{b=b+1|0;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+348>>2]&127](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=Lx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+344>>2]&127](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 17:{break b;break};case 29:{m=33;break b;break};case 11:{m=97;break b;break};case 5:{if((e-b|0)<2){m=36;break b}n=b;if((Ae[c[j+332>>2]&127](j,b)|0)==0){m=38;break b}b=n+2|0;continue b;break};case 7:{if((e-b|0)<4){m=46;break b}o=b;if((Ae[c[j+340>>2]&127](j,b)|0)==0){m=48;break b}b=o+4|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=68;break b}p=b;if((Ae[c[j+352>>2]&127](j,b)|0)==0){m=70;break b}b=p+4|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}q=b;if((Ae[c[j+344>>2]&127](j,b)|0)==0){m=60;break b}b=q+2|0;continue b;break};case 29:{m=55;break b;break};case 6:{if((e-b|0)<3){m=63;break b}r=b;if((Ae[c[j+348>>2]&127](j,b)|0)==0){m=65;break b}b=r+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};default:{m=72;break b}}break};case 6:{if((e-b|0)<3){m=41;break b}s=b;if((Ae[c[j+336>>2]&127](j,b)|0)==0){m=43;break b}b=s+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 17:{break c;break};case 7:{m=88;break d;break};case 11:{m=97;break c;break};case 6:{m=83;break d;break};case 29:{m=76;break d;break};case 24:case 22:{m=77;break d;break};case 10:case 9:case 21:{break};case 5:{m=78;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+344>>2]&127](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+348>>2]&127](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((Ae[c[j+352>>2]&127](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=Nx(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Jx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 8:case 1:case 0:{m=22;break b;break};case 7:{if((e-b|0)<4){m=18;break b}n=b;if((Ae[c[j+364>>2]&127](j,b)|0)!=0){m=20;break b}b=n+4|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((Ae[c[j+360>>2]&127](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}p=b;if((Ae[c[j+356>>2]&127](j,b)|0)!=0){m=10;break b}b=p+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function Kx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[55064+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Lx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((Ae[c[k+348>>2]&127](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((Ae[c[k+344>>2]&127](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((Ae[c[k+352>>2]&127](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{o=68;break b;break};case 7:{if((e-b|0)<4){o=37;break b}p=b;if((Ae[c[k+340>>2]&127](k,b)|0)==0){o=39;break b}b=p+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){o=27;break b}q=b;if((Ae[c[k+332>>2]&127](k,b)|0)==0){o=29;break b}b=q+2|0;continue b;break};case 29:{o=24;break b;break};case 6:{if((e-b|0)<3){o=32;break b}r=b;if((Ae[c[k+336>>2]&127](k,b)|0)==0){o=34;break b}b=r+3|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((Ox(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){o=57;break c}s=b;if((Ae[c[k+364>>2]&127](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}t=b;if((Ae[c[k+360>>2]&127](k,b)|0)!=0){o=54;break c}b=t+3|0;continue c;break};case 5:{if((e-b|0)<2){o=47;break c}u=b;if((Ae[c[k+356>>2]&127](k,b)|0)!=0){o=49;break c}b=u+2|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((Ox(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Mx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+348>>2]&127](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+344>>2]&127](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+352>>2]&127](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=37;break b}m=a;if((Ae[c[h+340>>2]&127](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((Ae[c[h+332>>2]&127](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 29:{l=24;break b;break};case 23:{a=a+1|0;continue b;break};case 11:{l=49;break b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((Ae[c[h+336>>2]&127](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}m=d[h+76+(d[a]|0)|0]|0;if((m|0)==11){l=44;break}else if(!((m|0)==10|(m|0)==9|(m|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function Nx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(Ae[c[k+352>>2]&127](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=m+4;continue a;break};case 29:{l=26;break a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(Ae[c[k+348>>2]&127](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=n+3;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(Ae[c[k+344>>2]&127](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=o+2;continue a;break};default:{l=43;break a}}break};case 29:{l=4;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(Ae[c[k+332>>2]&127](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=p+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(Ae[c[k+336>>2]&127](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=q+3;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}r=b;if(!((r|0)==9|(r|0)==10|(r|0)==21)){l=48;break a}}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}r=(Ae[c[k+340>>2]&127](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!r){l=19;break a}c[j>>2]=s+4;continue a;break};case 14:{break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}r=t;if(!((r|0)==9|(r|0)==10|(r|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}r=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((r|0)==(t|0)){break}switch(r|0){case 3:{u=Ex(k,(c[j>>2]|0)+1|0,e,j)|0;if((u|0)<=0){l=77;break a}else{continue c}break};case 2:{l=80;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}r=(Ae[c[k+364>>2]&127](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(r){l=73;break a}c[j>>2]=v+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}r=(Ae[c[k+356>>2]&127](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(r){l=63;break a}c[j>>2]=w+2;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}r=(Ae[c[k+360>>2]&127](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(r){l=68;break a}c[j>>2]=x+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=89;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 7:{l=101;break d;break};case 6:{l=96;break d;break};case 24:case 22:{l=90;break d;break};case 17:{l=107;break a;break};case 5:{l=91;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}r=(Ae[c[k+344>>2]&127](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!r){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}r=(Ae[c[k+348>>2]&127](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!r){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}r=(Ae[c[k+352>>2]&127](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!r){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((u|0)==0){c[f>>2]=c[j>>2]}B=u;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function Ox(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function Px(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}l=b;if((Ae[c[a+356>>2]&127](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((Ae[c[a+364>>2]&127](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((Ae[c[a+360>>2]&127](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function Qx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==27){j=Jx(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{break a;break};case 30:{l=10;break a;break};case 24:case 22:{break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function Rx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+344>>2]&127](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+352>>2]&127](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((Ae[c[h+348>>2]&127](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=37;break b}m=a;if((Ae[c[h+340>>2]&127](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((Ae[c[h+336>>2]&127](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((Ae[c[h+332>>2]&127](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function Sx(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function Tx(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function Ux(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function Vx(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Ke[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Ke[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Ke[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Ke[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function Wx(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((Yx(Xx(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((Yx(Xx(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=Xx(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((Yx(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=Xx(k,a,b)|0;n=h;}while((Yx(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=Xx(k,a,b)|0;while(1){if((Yx(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=Xx(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=Xx(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function Xx(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;fe[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function Yx(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function Zx(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function _x(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 12:{c[h>>2]=14;j=1;break};case 16:{if((Ke[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,58808)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 11:{c[h>>2]=14;j=55;break};case 14:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 13:{c[h>>2]=14;j=56;break};case 15:{c[h>>2]=14;j=0;break};default:{k=10}}}while(0);if((k|0)==10){j=cy(h,a)|0}i=g;return j|0}function $x(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 26:{j=9;break};case 15:{k=0;break};case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case 33:{c[h>>2]=17;k=0;break};default:{k=by(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=cy(h,a)|0}i=g;return k|0}function ay(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Ke[c[e+28>>2]&63](e,b,d,58792)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b,d,58800)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function by(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 28:{j=60;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 16:{if((Ke[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,58568)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,58576)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,58584)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,58592)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};default:{}}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function cy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function dy(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function ey(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==22){c[e>>2]=25;g=11}else{g=cy(e,a)|0}i=f;return g|0}function fy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=cy(e,a)|0}i=f;return g|0}function gy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=cy(e,a)|0}i=f;return g|0}function hy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=cy(e,a)|0}i=f;return g|0}function iy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=cy(e,a)|0}i=f;return g|0}function jy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==13){g=56}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==15){g=0}else if((b|0)==11){g=55}else{g=cy(e,a)|0}i=f;return g|0}function ky(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Ke[c[e+28>>2]&63](e,b,d,58608)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b,d,58616)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function ly(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=cy(e,a)|0}i=f;return g|0}function my(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=cy(e,a)|0}i=f;return g|0}function ny(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=cy(e,a)|0}i=f;return g|0}function oy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=cy(e,a)|0;h=g;i=f;return h|0}return 0}function py(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==18){if((Ke[c[e+28>>2]&63](e,b,d,58624)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b,d,58632)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function qy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 30:{c[h>>2]=40;j=53;break};case 32:{c[h>>2]=40;j=54;break};case 31:{c[h>>2]=40;j=52;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 15:{j=39;break};case 20:{if((Ke[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,58640)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};default:{k=10}}}while(0);if((k|0)==10){j=cy(h,a)|0}i=g;return j|0}function ry(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else{g=cy(e,a)|0}i=f;return g|0}function sy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 31:{c[e>>2]=40;g=52;break};case 30:{c[e>>2]=40;g=53;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 32:{c[e>>2]=40;g=54;break};case 15:{g=39;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};default:{g=cy(e,a)|0}}i=f;return g|0}function ty(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};default:{g=cy(e,a)|0;h=g;i=f;return h|0}}return 0}function uy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=cy(e,a)|0}i=f;return g|0}function vy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else{g=cy(e,a)|0}i=f;return g|0}function wy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=cy(e,a)|0}i=f;return g|0}function xy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((Ke[m&63](n,o,p,c[58648+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((Ke[m&63](n,o,p,58592)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function yy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((Ke[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,58752)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,58760)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,58776)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function zy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=cy(e,a)|0}i=f;return g|0}function Ay(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=cy(e,a)|0}i=f;return g|0}function By(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=cy(e,a)|0}i=f;return g|0}function Cy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=cy(e,a)|0}i=f;return g|0}function Dy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=cy(e,a)|0}i=f;return g|0}function Ey(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==27){c[e>>2]=27;g=38}else{g=cy(e,a)|0}i=f;return g|0}function Fy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=cy(e,a)|0}i=f;return g|0}function Gy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((Ke[c[e+28>>2]&63](e,b,d,58608)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b,d,58616)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function Hy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=cy(e,a)|0}i=f;return g|0}function Iy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=cy(e,a)|0}i=f;return g|0}function Jy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==18){if((Ke[c[e+28>>2]&63](e,b,d,58784)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function Ky(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=cy(e,a)|0}i=f;return g|0}function Ly(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ke[c[e+28>>2]&63](e,b,d,58608)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b,d,58616)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function My(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=58;g=13}else{g=cy(e,a)|0}i=f;return g|0}function Ny(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=cy(e,a)|0}i=f;return g|0}function Oy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=cy(e,a)|0;h=g;i=f;return h|0}return 0}function Py(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;d=e+12|0;c[d>>2]=(c[d>>2]|0)+1;g=0;h=g;i=f;return h|0}else if((b|0)==15){g=0;h=g;i=f;return h|0}else{g=cy(e,a)|0;h=g;i=f;return h|0}return 0}function Qy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=cy(e,a)|0}i=f;return g|0}function Ry(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 14:{j=0;break};case 16:{if((Ke[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,58808)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 29:{c[h>>2]=16;j=2;break};case 15:{j=0;break};case 11:{j=55;break};case 13:{j=56;break};default:{k=9}}}while(0);if((k|0)==9){j=cy(h,a)|0}i=g;return j|0}function Sy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=cy(e,a)|0}i=f;return g|0}function Ty(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==18){if((Ke[c[e+28>>2]&63](e,b,d,58608)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Ke[c[e+28>>2]&63](e,b,d,58616)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}}while(0);j=cy(h,a)|0;k=j;i=g;return k|0}function Uy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=cy(e,a)|0}i=f;return g|0}function Vy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=cy(e,a)|0}i=f;return g|0}function Wy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else{g=cy(e,a)|0}i=f;return g|0}function Xy(){i=i;return}function Yy(){i=i;return}function Zy(){var a=0;a=i;Xa(58816,0)|0;i=a;return}function _y(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;c[a+8>>2]=b;c[a>>2]=d;b=a+4|0;c[b>>2]=Xz(d)|0;if((d|0)>0){g=0}else{i=f;return}do{a=c[e>>2]|0;h=c[a>>2]|0;c[e>>2]=a+4;c[(c[b>>2]|0)+(g<<2)>>2]=h;g=g+1|0;}while((g|0)<(d|0));i=f;return}function $y(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;tc(58824,29,1,e|0)|0;xd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;tc(58856,54,1,g|0)|0;xd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;tc(58912,47,1,a|0)|0;xd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;zd(k|0,58960,d|0)|0;xd(k|0)|0;f=0;i=b;return f|0}function az(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;zd(j|0,59048,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;zd(n|0,59080,e|0)|0;k=0;i=d;return k|0}function bz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function cz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=Xz(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function dz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=Xz(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function ez(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if(($y(a)|0)==0){db(59128,59024,262,59152)}e=c[a>>2]|0;f=b;c[f>>2]=e;g=Xz(e)|0;c[b+4>>2]=g;if((g|0)==0){db(59176,59024,266,59152)}b=c[f>>2]|0;if((b|0)<=0){i=d;return}f=c[a+4>>2]|0;a=0;do{c[g+(a<<2)>>2]=c[f+(a<<2)>>2];a=a+1|0;}while((a|0)<(b|0));i=d;return}



function FR(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=VA(F)|0;H=WA(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+$A(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}tc(113480,17,1,a|0)|0;tc(116392,12,1,a|0)|0;tc(116408,12,1,a|0)|0;tc(116424,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;zd(a|0,116440,D|0)|0;tc(116480,10,1,a|0)|0;tc(116496,11,1,a|0)|0;tc(116512,11,1,a|0)|0;tc(116528,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];zd(a|0,116544,C|0)|0}else{tc(116568,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;zd(a|0,116168,B|0)|0;tc(116592,13,1,a|0)|0;if(E){tc(116408,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];zd(a|0,116608,A|0)|0}else{tc(116568,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;zd(a|0,116632,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;zd(a|0,116288,y|0)|0;tc(116680,10,1,a|0)|0;tc(116696,10,1,a|0)|0;tc(116680,10,1,a|0)|0;tc(116712,11,1,a|0)|0;c[x>>2]=b;zd(a|0,116728,x|0)|0;c[w>>2]=d;zd(a|0,116752,w|0)|0;tc(116768,33,1,a|0)|0;tc(116808,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;zd(a|0,116848,v|0)|0;tc(116528,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];zd(a|0,116544,u|0)|0}else{tc(116696,10,1,a|0)|0;tc(116680,10,1,a|0)|0;tc(116712,11,1,a|0)|0;c[t>>2]=b;zd(a|0,116728,t|0)|0;c[s>>2]=d;zd(a|0,116752,s|0)|0;tc(116768,33,1,a|0)|0;tc(116808,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;zd(a|0,116848,r|0)|0;tc(116528,10,1,a|0)|0;tc(116568,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;zd(a|0,116168,q|0)|0;tc(116592,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];zd(a|0,116608,p|0)|0}else{tc(116568,17,1,a|0)|0}tc(116880,32,1,a|0)|0;tc(116920,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;zd(a|0,116952,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;zd(a|0,116288,n|0)|0;i=m;return}function GR(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Vd(32,a|0)|0;}while((d|0)!=0);i=c;return}function HR(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==62){tc(116144,4,1,b|0)|0}else if((e|0)==60){tc(116136,4,1,b|0)|0}else if((e|0)==39){tc(116152,6,1,b|0)|0}else if((e|0)==34){tc(116160,6,1,b|0)|0}else{Vd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function IR(a){a=a|0;var b=0,c=0,d=0;b=i;c=kc(a|0,116128)|0;if((c|0)==0){d=-1;i=b;return d|0}Yc(c|0,0,2)|0;a=zb(c|0)|0;_c(c|0)|0;d=a;i=b;return d|0}function JR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=B2((d3(l|0)|0)+15|0)|0;c[f>>2]=l;jc(m|0,115856,f|0)|0;GR(a,2);tc(115872,10,1,a|0)|0;HR(a,m);tc(115888,12,1,a|0)|0;GR(a,2);c[e>>2]=IR(m)|0;zd(a|0,115904,e|0)|0;C2(m);GR(a,2);tc(115936,9,1,a|0)|0;GR(a,4);tc(115952,22,1,a|0)|0;GR(a,4);tc(115976,22,1,a|0)|0;GR(a,4);tc(116e3,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){PR(g,m,n);o=c[l>>2]|0;GR(a,4);tc(116032,8,1,a|0)|0;HR(a,o);tc(116048,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{UR(h,m,l);g=c[n>>2]|0;GR(a,4);tc(116032,8,1,a|0)|0;HR(a,g);tc(116048,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{PR(j,m,q);b=c[t>>2]|0;GR(a,4);tc(116072,8,1,a|0)|0;HR(a,b);tc(116088,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){GR(a,2);v=116112;w=v;x=tc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{UR(k,m,s);e=c[u>>2]|0;GR(a,4);tc(116072,8,1,a|0)|0;HR(a,e);tc(116088,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));GR(a,2);v=116112;w=v;x=tc(w|0,10,1,a|0)|0;i=d;return}function KR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;GR(a,2);c[f>>2]=c[b>>2];zd(a|0,115792,f|0)|0;HR(a,c[b+4>>2]|0);tc(115824,11,1,a|0)|0;HR(a,c[b+8>>2]|0);tc(115496,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];OR(a,4,e);GR(a,2);tc(115840,12,1,a|0)|0;i=d;return}function LR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{PR(p,r,v);FR(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,115608);w=v+9|0;dB(w);GR(a,2);c[o>>2]=c[f>>2];zd(a|0,115616,o|0)|0;GR(a,4);tc(114040,6,1,a|0)|0;HR(a,c[s>>2]|0);tc(114048,8,1,a|0)|0;GR(a,4);c[n>>2]=XA(w)|0;zd(a|0,115392,n|0)|0;GR(a,4);x=+aB(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];zd(a|0,115416,m|0)|0;GR(a,4);x=+$A(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];zd(a|0,114584,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];OR(a,6,j);GR(a,2);tc(115640,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function MR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{GR(a,2);TR(l,d,x);c[j>>2]=c[q>>2];zd(a|0,115464,j|0)|0;TR(m,d,x);HR(a,c[r>>2]|0);tc(115496,3,1,a|0)|0;GR(a,4);tc(115504,7,1,a|0)|0;TR(n,d,x);if((c[s>>2]|0)>0){y=0;do{GR(a,6);c[g>>2]=0;zd(a|0,115512,g|0)|0;y=y+1|0;TR(n,d,x);}while((y|0)<(c[s>>2]|0))}GR(a,4);tc(115536,8,1,a|0)|0;GR(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;TR(o,d,x);z=+ZA(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;TR(p,d,x);A=UA(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;zd(a|0,115552,f|0)|0;GR(a,2);tc(115592,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function NR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{UR(n,o,v-u|0);FR(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,115344);q=v+9|0;dB(q);GR(a,2);tc(115352,15,1,a|0)|0;GR(a,4);c[m>>2]=c[e>>2];zd(a|0,115368,m|0)|0;GR(a,4);c[l>>2]=XA(q)|0;zd(a|0,115392,l|0)|0;GR(a,4);w=+aB(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];zd(a|0,115416,j|0)|0;GR(a,4);w=+$A(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];zd(a|0,114584,g|0)|0;GR(a,2);tc(115440,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function OR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;GR(a,b);tc(115656,16,1,a|0)|0;HR(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?115760:115776;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;zd(a|0,115680,f|0)|0;i=e;return}function PR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){QR(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function QR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=kc(c[o>>2]|0,116992)|0;if((p|0)!=0){q=p;break}p=Zd(c[(Pc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;vz(0,117e3,g)}else{q=0}}while(0);g=iu(0)|0;if((g|0)==0){vz(0,117032,f)}f=a+8|0;c[a+20>>2]=D2(c[f>>2]|0,32)|0;p=a+12|0;o=D2((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=117064;c[o+12>>2]=0;c[o+16>>2]=0;tu(g,h);uu(g,10,75);h=c[n>>2]|0;do{if((h|0)==0){o=j;h3(o|0,0,1024)|0;while(1){r=tb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((vu(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Du(Au(g)|0)|0;s=Bu(g)|0;_c(q|0)|0;pu(g);r=c[a>>2]|0;c[e>>2]=117168;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;vz(0,117104,e)}else if((t|0)==11){_c(q|0)|0;break}}else{if((vu(g,h,d3(h|0)|0,1)|0)!=0){break}s=Du(Au(g)|0)|0;o=Bu(g)|0;pu(g);r=c[n>>2]|0;c[d>>2]=117168;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;vz(0,117208,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){db(117272,117168,295,117312)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{db(117336,117168,297,117312)}}function RR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if(($2(117744,b)|0)==0){if(($2(c[d>>2]|0,117752)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}uz(0,p,117760,l);l=c[29400]|0;p=c[29454]|0;do{if((l|0)==0|(p|0)==0){c[29454]=32;a=B2(1152)|0;c[29400]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[29454]=p<<1;a=E2(l,p*72|0)|0;c[29400]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(XR(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if(($2(117824,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if(($2(117832,u)|0)==0){c[29460]=Dd(c[t+4>>2]|0)|0}else{if(($2(117864,u)|0)==0){c[117844>>2]=Wb(c[t+4>>2]|0,0,10)|0;break}if(($2(117880,u)|0)==0){c[117852>>2]=Wb(c[t+4>>2]|0,0,10)|0;break}if(($2(117888,u)|0)==0){c[117848>>2]=Wb(c[t+4>>2]|0,0,10)|0;break}if(($2(117904,u)|0)==0){c[117856>>2]=Wb(c[t+4>>2]|0,0,10)|0;break}if(($2(117912,u)|0)!=0){v=23;break a}c[117860>>2]=($2(c[t+4>>2]|0,117928)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];vz(0,117936,k)}else if((v|0)==45){i=e;return}}if(($2(117584,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=117168;c[j+4>>2]=k;c[j+8>>2]=v;vz(0,117968,j)}if(($2(118032,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=117168;c[h+4>>2]=j;vz(0,118040,h)}h=Wb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=117168;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;vz(0,118096,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=118160;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if(($2(117528,b)|0)!=0){if(($2(117720,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=118264;m=Dd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=118272;i=e;return}c[117548>>2]=0;c[117552>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if(($2(m,117752)|0)==0){c[117548>>2]=Dd(c[b+4>>2]|0)|0}else{if(($2(m,118216)|0)!=0){break}c[117552>>2]=Dd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[117548>>2]|0)==0){w=0;break}w=(c[117552>>2]|0)!=0|0}}while(0);uz(0,w,118224,f);c[29386]=-1;f=117556|0;w=117840;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function SR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if(($2(117528,b)|0)==0){o=e+0|0;p=117544|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));WR(e);i=d;return}if(($2(117584,b)|0)==0){e=h+24|0;r=B2((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=B2(36)|0;t=s;o=s+0|0;p=(c[29400]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if(($2(117608,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Ed(e+(k*20|0)+8|0,117616,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if(($2(117656,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Ed(h+(k*20|0)+8|0,117672,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if(($2(117720,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function TR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){QR(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function UR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){QR(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;vz(0,117376,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=6;n=m;o=117456;p=o;vz(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=6;n=m;o=117456;p=o;vz(0,p,f)}}function VR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){C2(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){C2(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}C2(k);c[d>>2]=0;i=b;return}function WR(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=B2(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=d3(f|0)|0;c[e+64>>2]=k;k=c[29434]|0;do{if((k|0)==0){c[29434]=e;c[e+44>>2]=0;l=B2(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){xc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=B2(384)|0;c[l>>2]=n;if((n|0)==0){xc(-1)}else{h3(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[29434]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[29434]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=d3(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(d3(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 5:{B=o;C=y;D=18;break};case 10:{E=o;D=13;break};case 7:{F=o;G=y;D=16;break};case 6:{H=o;I=y;D=17;break};case 9:{J=o;D=14;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;E=z;D=13;break};case 8:{K=o;D=15;break};case 2:{L=o;M=x;N=y;D=21;break};case 4:{O=o;P=y;D=19;break};case 1:{Q=o;R=x;S=y;D=22;break};case 3:{T=o;U=x;V=y;D=20;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+E|0;c[p>>2]=o;J=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+J|0;c[p>>2]=o;K=o;D=15}if((D|0)==15){F=K;G=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){H=F;I=((d[A+6|0]|0)<<16)+G|0;D=17}if((D|0)==17){B=H;C=((d[A+5|0]|0)<<8)+I|0;D=18}if((D|0)==18){O=B;P=(d[A+4|0]|0)+C|0;D=19}if((D|0)==19){T=O;U=((d[A+3|0]|0)<<24)+x|0;V=P;D=20}if((D|0)==20){L=T;M=((d[A+2|0]|0)<<16)+U|0;N=V;D=21}if((D|0)==21){Q=L;R=((d[A+1|0]|0)<<8)+M|0;S=N;D=22}if((D|0)==22){W=Q;X=(d[A]|0)+R|0;Y=S}S=X-Y-W^W>>>13;X=Y-W-S^S<<8;Y=W-S-X^X>>>13;W=S-X-Y^Y>>>12;S=X-Y-W^W<<16;X=Y-W-S^S>>>5;Y=W-S-X^X>>>3;W=S-X-Y^Y<<10;S=X-Y-W^W>>>15;c[p>>2]=S;p=(c[29434]|0)+40|0;W=c[p>>2]|0;Y=S&(c[W+4>>2]|0)+ -1;S=c[W>>2]|0;W=S+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[S+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[29434]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[29434]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=B2((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){xc(-1)}h3(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;S=c[j>>2]|0;c[Y+24>>2]=(((S<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((S|0)==0){_=e}else{S=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=S}else{W=S;X=j;while(1){j=X+16|0;R=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];Q=Z+(A*12|0)+4|0;D=(c[Q>>2]|0)+1|0;c[Q>>2]=D;N=c[W+24>>2]|0;if(D>>>0>N>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[Q>>2]|0)>>>0)/(N>>>0)|0}c[X+12>>2]=0;N=Z+(A*12|0)|0;c[j>>2]=c[N>>2];j=c[N>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[N>>2]=X;N=c[h>>2]|0;if((R|0)==0){$=N;break}else{W=N;X=R}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){S=$;Y=W;e=X}else{_=W;break}}}C2(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function XR(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[29434]|0)==0){f=24}else{g=d3(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(d3(a|0)|0)+s|0;switch(v|0){case 1:{x=h;y=t;z=u;f=15;break};case 2:{A=h;B=t;C=u;f=14;break};case 3:{D=h;E=t;F=u;f=13;break};case 5:{G=h;H=u;f=11;break};case 6:{I=h;J=u;f=10;break};case 4:{K=h;L=u;f=12;break};case 11:{M=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 9:{N=h;f=7;break};case 8:{O=h;f=8;break};case 10:{M=h;f=6;break};case 7:{P=h;Q=u;f=9;break};default:{R=h;S=t;T=u}}if((f|0)==6){N=((d[w+9|0]|0)<<16)+M|0;f=7}if((f|0)==7){O=((d[w+8|0]|0)<<8)+N|0;f=8}if((f|0)==8){P=O;Q=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){I=P;J=((d[w+6|0]|0)<<16)+Q|0;f=10}if((f|0)==10){G=I;H=((d[w+5|0]|0)<<8)+J|0;f=11}if((f|0)==11){K=G;L=(d[w+4|0]|0)+H|0;f=12}if((f|0)==12){D=K;E=((d[w+3|0]|0)<<24)+t|0;F=L;f=13}if((f|0)==13){A=D;B=((d[w+2|0]|0)<<16)+E|0;C=F;f=14}if((f|0)==14){x=A;y=((d[w+1|0]|0)<<8)+B|0;z=C;f=15}if((f|0)==15){R=x;S=(d[w]|0)+y|0;T=z}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[29434]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=d3(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((_2(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Fb(a|0,118296)|0)==0){V=0;break}else{W=118320}i=b;return W|0}}while(0);c[e>>2]=a;uz(0,(V|0)!=0|0,118368,e);W=V+4|0;i=b;return W|0}function YR(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((ZR(118424,a,b)|0)!=0){d=1;i=c;return d|0}d=(ZR(118432,a,b)|0)!=0|0;i=c;return d|0}function ZR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if(($2(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function _R(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=($2(c[66676>>2]|0,118440)|0)==0|0;uz(0,m,118456,l);l=($2(c[68580>>2]|0,118440)|0)==0|0;uz(0,l,118512,k);k=($2(c[70572>>2]|0,118440)|0)==0|0;uz(0,k,118568,j);j=118632|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=118760|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[70576+(k<<2)>>2]|0;if((l|0)==2){q=c[66552+(k<<2)>>2]|0;if(!((ZR(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[66552+(k<<2)>>2]|0;if((aS(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((ZR(c[66552+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=118632+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=118632+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[118760+(k<<2)>>2]=$R(q,p)|0;t=j}else if((r|0)==13){r=0;l=118632+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[118760+(k<<2)>>2]=bS(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];tz(1,0,118888,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];tz(1,0,118888,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];tz(1,0,118888,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];tz(1,0,118944,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function $R(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if(($2(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function aS(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(bS(a,b)|0)!=0|0;i=c;return d|0}function bS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=d3(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((a3(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function cS(){i=i;return}function dS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){xc(0)}e=c[r>>2]|0;tc(118976,5,1,e|0)|0;f=b;b=0;while(1){Vd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}tc(118984,20,1,e|0)|0;xc(0);return 0}function eS(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;zd(d|0,119008,e|0)|0;if((b|0)==0){xc(1)}else{xd(d|0)|0;mS();xd(d|0)|0;jb(6,0)|0;jd()}}function fS(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function gS(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function hS(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function iS(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function jS(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function kS(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}h3(p|0,32,b+(d-p)|0)|0;i=f;return}function lS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=120048+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[120092+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[120088+(e*48|0)>>2]|0)==1){nS(b)|0}k=120052+(e*48|0)|0;if((c[k>>2]|0)==0){break}_c(c[f>>2]|0)|0;C2(c[k>>2]|0)}}while(0);do{if((h|0)==10){_c(g|0)|0;b=120052+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Md(k|0)|0;C2(c[b>>2]|0)}}while(0);c[f>>2]=0}c[120084+(e*48|0)>>2]=0;c[120052+(e*48|0)>>2]=0;i=d;return 0}function mS(){var a=0,b=0;a=i;if((c[29754]|0)!=0){i=a;return}c[29754]=1;c[119024>>2]=0;b=0;do{c[119020>>2]=b;lS(119016)|0;b=b+1|0;}while((b|0)<100);i=a;return}function nS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[120064+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=120048+(d*48|0)|0;g=c[f>>2]|0;h=zb(g|0)|0;Yc(g|0,0,2)|0;if((h|0)>=(zb(g|0)|0)){e=0;i=b;return e|0}if((c[120068+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[120076+(d*48|0)>>2]&2|0)!=0){xd(c[f>>2]|0)|0}d=Vc(sb(c[f>>2]|0)|0,h|0)|0;Yc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){pS(111,119032);e=111;i=b;return e|0}else{c[(Pc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function oS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if((ab(sb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(vb(sb(a|0)|0)|0)==0|0;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function pS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Sc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;zd(m|0,119944,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;zd(m|0,119976,j|0)|0;l=m;break}else{n=c[119816+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;zd(m|0,12e4,h|0)|0;l=m;break}}}while(0);h=c[30002]|0;do{if((h|0)==0){tc(124880,29,1,l|0)|0}else{c[g>>2]=(h-120048|0)/48|0;zd(l|0,120016,g|0)|0;b=c[(c[30002]|0)+4>>2]|0;if((b|0)==0){tc(124864,10,1,l|0)|0;break}else{c[f>>2]=b;zd(l|0,124848,f|0)|0;break}}}while(0);f=c[31228]|0;if((f|0)!=0){c[d>>2]=f;zd(l|0,124920,d|0)|0}d=(c[31248]|0)!=0?125e3:125016;f=(c[31256]|0)!=0?125032:125048;g=(c[31266]|0)!=0?125072:125088;c[e>>2]=(c[31242]|0)!=0?124976:124984;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;zd(l|0,124944,e|0)|0;eS(125104,1)}function qS(){var a=0,b=0;a=i;c[31278]=1;b=c[r>>2]|0;c[30012]=b;c[120068>>2]=oS(b)|0;c[120072>>2]=1;c[120088>>2]=1;b=c[s>>2]|0;c[120288>>2]=b;c[120308>>2]=oS(b)|0;c[120312>>2]=1;c[120328>>2]=0;b=c[t>>2]|0;c[120336>>2]=b;c[120356>>2]=oS(b)|0;c[120360>>2]=1;c[120376>>2]=1;i=a;return}function rS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=zc(g|0,c[130360+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[31280]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=zb(c[k>>2]|0)|0;l=zc(c[f>>2]|0,c[130360+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[31280]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Yc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Pc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Yc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function sS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){pS(b,d)}d=c[31282]|0;if((d|0)!=0){Fe[d&7]()|0}c[(Pc()|0)>>2]=b;i=e;return b|0}function tS(a){a=a|0;var b=0,d=0;b=i;c[31312]=0;c[31314]=0;c[31316]=0;d=((uS(a,0)|0)==0)<<31>>31;i=b;return d|0}function uS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[31316]|0;c[31316]=j+1;if((j|0)==1){c[31314]=d}if((zS(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=AS(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function vS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[31312]|0;l=125272+(k<<4)|0;m=c[l>>2]|0;switch(wS(m)|0){case 9:{n=(le[c[31296]&127](l)|0)==0;c[31312]=(c[31312]|0)+1;if(n){break b}else{continue b}break};case 33:{c[32556]=1;c[31312]=k+1;continue b;break};case 16:{if(b){o=28;break a}c[31312]=k+1;continue b;break};case 18:{c[31288]=1;c[31312]=k+1;continue b;break};case 19:case 17:{c[31288]=0;c[31312]=k+1;continue b;break};case 20:{c[31308]=c[125276+(k<<4)>>2];c[31312]=k+1;continue b;break};case 2:{c[32528]=0;c[32544]=0;c[31312]=c[125276+(k<<4)>>2];if(b){o=24;break a}if((c[32540]|0)==0){j=0;o=37;break a}n=Fe[c[31298]&7]()|0;if((n|0)==0){continue b}else{j=n;o=37;break a}break};case 3:{n=c[32528]|0;p=130120+(n<<2)|0;q=c[p>>2]|0;c[p>>2]=q+ -1;if((q|0)<2){c[32528]=n+ -1;c[32544]=(c[32544]|0)+ -1;c[31312]=k+1;continue b}else{n=c[32544]|0;c[32544]=n+ -1;c[31312]=(c[130184+(n<<2)>>2]|0)+1;continue b}break};case 6:{n=c[125276+(k<<4)>>2]|0;q=(c[32528]|0)+1|0;c[32528]=q;c[130120+(q<<2)>>2]=n;c[31312]=k+1;continue b;break};case 8:{n=c[32528]|0;s=130120+(n<<2)|0;t=c[s>>2]|0;if((t|0)>=1){o=10;break b}c[32528]=n+ -1;c[31312]=k+1;continue b;break};case 22:{c[31290]=1;c[31312]=k+1;continue b;break};case 1:{n=c[125276+(k<<4)>>2]|0;q=(c[32544]|0)+1|0;c[32544]=q;c[130184+(q<<2)>>2]=n;c[31312]=k+1;continue b;break};case 21:{c[31290]=0;c[31312]=k+1;continue b;break};default:{o=4;break a}}}if((o|0)==10){o=0;if(b){o=11;break}c[s>>2]=t+ -1;c[32540]=1;k=oe[c[31294]&63](l,g,d)|0;if((k|0)>0){o=13;break}if((k|0)<0){o=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;o=37;break}}if((o|0)==4){h=c[r>>2]|0;d=c[31228]|0;c[f>>2]=m;c[f+4>>2]=d;zd(h|0,130072,f|0)|0;if((c[c[31284]>>2]|0)==0){pS(100,130104);j=100;i=e;return j|0}else{c[(Pc()|0)>>2]=100;j=100;i=e;return j|0}}else if((o|0)==11){j=Fe[c[31282]&7]()|0;i=e;return j|0}else if((o|0)==13){f=c[c[31284]>>2]|0;j=sS(f,c[(Pc()|0)>>2]|0,130168)|0;i=e;return j|0}else if((o|0)==15){if((c[(c[31284]|0)+8>>2]|0)==0){pS(-1,130168);j=-1;i=e;return j|0}else{c[(Pc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((o|0)==24){j=Fe[c[31282]&7]()|0;i=e;return j|0}else if((o|0)==28){j=Fe[c[31282]&7]()|0;i=e;return j|0}else if((o|0)==37){i=e;return j|0}return 0}function wS(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function xS(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=vS(b,0,0)|0;i=a;return d|0}function yS(){c[31304]=0;c[31312]=0;c[32544]=0;c[32528]=0;c[32540]=0;c[32546]=0;c[32530]=0;i=i;return}function zS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[31312]|0;if((g|0)>299){tc(130248,24,1,c[r>>2]|0)|0;eS(c[31228]|0,1)}else{c[125272+(g<<4)>>2]=a;c[125276+(g<<4)>>2]=b;c[125280+(g<<4)>>2]=d;c[125284+(g<<4)>>2]=e;c[31312]=g+1;i=f;return g|0}return 0}function AS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=BS(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[31316]|0)+ -1|0;c[31316]=h;if((h|0)==0){zS(2,c[31314]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{zS(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function BS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((CS(b,e)|0)!=0){g=c[e>>2]|0;break}if((DS(b,e)|0)!=0){g=c[e>>2]|0;break}h=ES(b,f,1)|0;j=zS(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=uS(h,j)|0}}while(0);i=d;return g|0}function CS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 115:case 83:{g=b+1|0;h=a[g]|0;if(h<<24>>24==80|h<<24>>24==112){j=g;k=18}else if(h<<24>>24==83|h<<24>>24==115){j=g;k=19}else{j=b;k=17}zS(k,0,0,0)|0;l=j;m=30;break};case 36:{zS(33,0,0,0)|0;l=b;m=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{n=b;o=0;m=14;break};case 43:{p=0;m=13;break};case 120:case 88:{zS(4,1,0,0)|0;l=b;m=30;break};case 112:case 80:{zS(20,1,0,0)|0;l=b;m=30;break};case 47:{zS(5,0,0,0)|0;l=b;m=30;break};case 58:{zS(16,0,0,0)|0;l=b;m=30;break};case 39:case 34:case 2:{c[125280+((zS(11,0,0,0)|0)<<4)>>2]=b;g=FS(b)|0;c[d>>2]=g;q=(g|0)!=0|0;i=e;return q|0};case 98:case 66:{g=b+1|0;h=a[g]|0;if(h<<24>>24==90|h<<24>>24==122){zS(22,0,0,0)|0;l=g;m=30;break a}else{zS(21,0,0,0)|0;l=g;m=30;break a}break};case 116:case 84:{g=b+1|0;h=a[g]|0;if(h<<24>>24==76|h<<24>>24==108){r=g;s=13}else if(h<<24>>24==82|h<<24>>24==114){r=g;s=14}else{r=b;s=15}g=ES(r+1|0,f,0)|0;if((g|0)==0){m=15;break a}zS(s,c[f>>2]|0,0,0)|0;l=g+ -1|0;m=30;break};case 45:{p=1;m=13;break};default:{q=0;i=e;return q|0}}}while(0);if((m|0)==13){n=b+1|0;o=p;m=14}b:do{if((m|0)==14){p=ES(n,f,0)|0;if((p|0)==0){m=15;break}switch(a[p]|0){case 120:case 88:{zS(4,c[f>>2]|0,0,0)|0;l=p;m=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((o|0)==0){t=b}else{s=0-b|0;c[f>>2]=s;t=s}zS(20,t,0,0)|0;l=p;m=30;break b;break};case 104:case 72:{s=c[f>>2]|0;c[125280+((zS(12,s,0,0)|0)<<4)>>2]=p+1;l=p+s|0;m=30;break b;break};default:{q=0;i=e;return q|0}}}}while(0);if((m|0)==15){c[d>>2]=0;q=1;i=e;return q|0}else if((m|0)==30){c[d>>2]=l+1;q=1;i=e;return q|0}return 0}function DS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=ES(b,f,1)|0;zS(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 111:case 79:{l=32;m=34;n=38;break};case 101:case 69:{o=1;n=3;break};case 105:case 73:{l=7;m=10;n=38;break};case 100:case 68:{p=ES(f,g,0)|0;if((p|0)==0){n=4;break a}q=c[g>>2]|0;if((q|0)==0){r=p;n=45;break a}if((a[p]|0)==46){s=ES(p+1|0,h,0)|0;if((s|0)==0){n=4;break a}t=s;u=c[h>>2]|0}else{c[h>>2]=0;t=p;u=0}zS(26,q,u,0)|0;r=t;n=45;break};case 97:case 65:{q=f;while(1){v=a[q]|0;if(v<<24>>24==32){q=q+1|0}else{break}}if(!((v+ -48<<24>>24&255)<10)){zS(30,0,0,0)|0;r=q;n=45;break a}p=ES(q,g,1)|0;s=c[g>>2]|0;if((s|0)==0){r=p;n=45;break a}zS(31,s,0,0)|0;r=p;n=45;break};case 108:case 76:{p=ES(f,g,0)|0;if((p|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){r=p;n=45;break a}zS(29,s,0,0)|0;r=p;n=45;break};case 122:case 90:{l=35;m=36;n=38;break};case 103:case 71:{o=0;n=3;break};case 102:case 70:{p=ES(f,g,0)|0;if((p|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){r=p;n=45;break a}if((a[p]|0)==46){w=ES(p+1|0,h,0)|0;if((w|0)==0){n=4;break a}x=w;y=c[h>>2]|0}else{c[h>>2]=0;x=p;y=0}zS(23,s,y,0)|0;r=x;n=45;break};default:{c[31312]=(c[31312]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((n|0)==3){b=ES(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){r=b;n=45;break}y=a[b]|0;if(y<<24>>24==46){v=ES(b+1|0,h,0)|0;if((v|0)==0){n=4;break}A=v;B=a[v]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){zS((o|0)==1?24:27,x,c[h>>2]|0,0)|0;r=A;n=45;break}y=ES(A+1|0,j,0)|0;if((y|0)==0){n=4;break}zS((o|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;r=y;n=45}else if((n|0)==38){y=ES(f,g,0)|0;if((y|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){r=y;n=45;break}if((a[y]|0)!=46){zS(l,x,0,0)|0;r=y;n=45;break}b=ES(y+1|0,h,0)|0;if((b|0)==0){n=4;break}zS(m,x,c[h>>2]|0,0)|0;r=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((n|0)==45){c[d>>2]=r;z=1;i=e;return z|0}return 0}function ES(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function FS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[31284]>>2]|0)==0){pS(100,130232);n=0;i=d;return n|0}else{c[(Pc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function GS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[130302|0]=48;k=130302|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=130280+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function HS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[31306]|0;f=c[31302]|0;if((e|0)>(f|0)){c[31302]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[32594]|0)){h=g}else{IS(f,g);h=c[31302]|0}g=c[32596]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Nd(g|0,c[31280]|0)|0;h=d3(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Vd(a[k]|0,c[31280]|0)|0;Nd(h|0,c[31280]|0)|0;b=d3(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function IS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[32596]|0;if((f|0)==130464){c[32594]=1024;g=1024}else{g=c[32594]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[32594]=j;h=j}j=B2(h)|0;if((j|0)==0){pS(113,130864);k=c[32596]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[32596]|0}else{l=k}if((l|0)==130464){m=130384;c[32596]=j;i=e;return}C2(l);m=130384;c[32596]=j;i=e;return}function JS(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[31302]|0;f=c[32594]|0;if((e|0)<(f|0)){g=e}else{IS(e,f);g=c[31302]|0}c[31302]=g+1;a[(c[32596]|0)+g|0]=b;i=d;return}function KS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[31266]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){pS(101,130392);l=101;i=d;return l|0}else{c[(Pc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[31278]|0)==0){qS();m=c[f>>2]|0}else{m=k}k=120048+(m*48|0)|0;c[30002]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){PS(k,c[b+12>>2]|0,j);o=QS(j,h)|0;if((o|0)==(c[120056+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[120060+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=lS(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[120080+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=120064+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[120080+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=120072+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[120072+(m*48|0)>>2]=1;r=1;break}else{c[120072+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];jc(j|0,130400,e|0)|0}else{PS(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){LS(107,130392,b);l=107;i=d;return l|0}else{c[(Pc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=120092+(m*48|0)|0;c[q>>2]=0;c[120084+(m*48|0)>>2]=0;e=120088+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=120076+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 83:case 115:{c[q>>2]=1;o=Nb()|0;c[n>>2]=o;if((o|0)!=0){c[120052+(m*48|0)>>2]=0;c[120060+(m*48|0)>>2]=-1;c[120056+(m*48|0)>>2]=-1;c[120068+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Pc()|0;s=c[k>>2]|0;if(o){LS(s,130392,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 82:case 114:{break};case 78:case 110:{if((Ec(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){LS(128,130392,b);l=128;i=d;return l|0}else{c[(Pc()|0)>>2]=128;l=128;i=d;return l|0}break};case 79:case 111:{if((Ec(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Pc()|0;o=c[k>>2]|0;if(s){LS(o,130392,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=kc(j|0,c[32590]|0)|0;if((o|0)==0){break}_c(o|0)|0}}while(0);q=B2((d3(j|0)|0)+1|0)|0;c[120052+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){LS(113,130416,b);l=113;i=d;return l|0}else{c[(Pc()|0)>>2]=113;l=113;i=d;return l|0}}j3(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=kc(j|0,c[130360+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=kc(j|0,c[130320+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=kc(j|0,c[130360+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Pc()|0;o=c[g>>2]|0;if(h){pS(o,130392);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=120068+(m*48|0)|0;c[r>>2]=oS(u)|0;u=QS(j,120060+(m*48|0)|0)|0;c[120056+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){LS(108,130392,b);l=108;i=d;return l|0}else{c[(Pc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){qb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Yc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){LS(129,130392,b);l=129;i=d;return l|0}else{c[(Pc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function LS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){pS(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[32594]|0)){j=d;k=g}else{IS(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[32596]|0;c[(c[30002]|0)+4>>2]=f;PS(k,j,f);pS(a,b);i=e;return}function MS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;jc(j|0,130400,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=d3(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?130432:130440;c[h+24>>2]=(b|0)==5?130448:130456;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=KS(h)|0;i=e;return a|0}function NS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=120048+(d*48|0)|0;c[30002]=e;if(d>>>0>99){if((c[a>>2]|0)==0){pS(101,130880);f=101;i=b;return f|0}else{c[(Pc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((MS(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){pS(114,130888);f=114;i=b;return f|0}else{c[(Pc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[120072+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){pS(102,130888);f=102;i=b;return f|0}else{c[(Pc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function OS(){var a=0,b=0;a=i;b=xS()|0;c[31228]=0;i=a;return b|0}function PS(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function QS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((nc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function RS(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[31308]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[31288]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];jc(p|0,130896,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(d3(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;ie[c[31292]&255](32);}while((A|0)>0)}if((D|0)!=0){ie[c[31292]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{ie[c[31292]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Hc(A|0)|0)+1|0;c[m>>2]=t-(c[31308]|0);jc(A|0,130904,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;ie[c[31292]&255](32);}while((z|0)>0)}if((x|0)!=0){ie[c[31292]&255]((w|0)!=0?45:43)}z=c[31308]|0;do{if((z|0)<1){ie[c[31292]&255](46);y=c[31292]|0;if((z|0)<0){G=y;J=z;while(1){ie[G&255](48);I=J+1|0;K=c[31292]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}ie[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}ie[c[31292]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[31292]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){ie[P&255](a[J]|0);R=Q+ -1|0;S=c[31292]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}ie[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;ie[c[31292]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){ie[c[31292]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;ie[c[31292]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){ie[c[31292]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;ie[c[31292]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;ie[c[31292]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;ie[c[31292]&255](42);}while((_|0)>0);i=l;return 0}function SS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[31308]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(jc(n|0,130912,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[31288]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;ie[c[31292]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;ie[c[31292]&255](32);}while((b|0)>0)}do{if(q){if((c[31288]|0)==0){break}ie[c[31292]&255](43)}else{ie[c[31292]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;ie[c[31292]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;ie[c[31292]&255](48);}while((z|0)>0);i=j;return 0}function TS(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{ie[c[31292]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[31292]|0;if((h|0)==0){ie[d&255](70);i=g;return 0}else{ie[d&255](84);i=g;return 0}return 0}function US(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[31304]|0)!=0){g=VS()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 32:{WS(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 7:{WS(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 29:{TS(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 25:case 24:case 26:{h=RS(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 34:{XS(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 10:{XS(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 35:{$S(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 28:case 27:{h=_S(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 31:{ZS(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 36:{$S(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 23:{h=SS(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 30:{YS(b,d);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;zd(h|0,130920,f|0)|0;eS(c[31228]|0,1)}}return 0}function VS(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[31304]|0;c[31304]=0;if((c[31266]|0)!=0){if((b|0)>0){d=c[31306]|0;e=c[31302]|0;if((d|0)<=(e|0)){f=b;while(1){ie[c[31292]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[31302]=f;h=0;i=a;return h|0}f=b-d+e|0;c[31302]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){ie[c[31292]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[31302]|0;f=j+b|0;if((f|0)>=0){if((c[31306]|0)<(j|0)){c[31306]=j}c[31302]=f;h=0;i=a;return h|0}if((c[c[31284]>>2]|0)==0){pS(110,131008);h=110;i=a;return h|0}else{c[(Pc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[31302]|0;if((c[31306]|0)<(f|0)){c[31306]=f}j=f+b|0;c[31302]=j;c[31310]=(c[31310]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[31284]>>2]|0)==0){pS(110,131008);h=110;i=a;return h|0}else{c[(Pc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[31302]|0;f=j+b|0;if((f|0)>=(c[(c[31286]|0)+16>>2]|0)){if((c[c[31284]>>2]|0)==0){pS(110,131024);h=110;i=a;return h|0}else{c[(Pc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[31306]|0;if((d|0)<=(j|0)){e=b;while(1){ie[c[31292]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[31310]=(c[31310]|0)+b;c[31302]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[31310]=(c[31310]|0)+f;c[31302]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){ie[c[31292]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function WS(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=GS(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[31288]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{ie[c[31292]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{ie[c[31292]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[31288]|0)==0){break}ie[c[31292]&255](43)}else{ie[c[31292]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){ie[c[31292]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function XS(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=GS(m,k,l,h)|0;h=c[l>>2]|0;g=(c[31288]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{ie[c[31292]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{ie[c[31292]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[31288]|0)==0){break}ie[c[31292]&255](43)}else{ie[c[31292]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){ie[c[31292]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){ie[c[31292]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{ie[c[31292]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function YS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;ie[c[31292]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function ZS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;ie[c[31292]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;ie[c[31292]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function _S(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=RS(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=RS(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[31308]|0;c[31308]=0;p=(e|0)==0?4:e+2|0;e=SS(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{ie[c[31292]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[31308]=o;n=e;i=j;return n|0}function $S(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{ie[c[31292]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;ie[c[31292]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;ie[c[31292]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){ie[c[31292]&255](a[130984+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){ie[c[31292]&255](a[130984+((d[p]|0)>>>4)|0]|0);ie[c[31292]&255](a[130984+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function aT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 15:{c[31304]=(c[a+4>>2]|0)+ -1-(c[31302]|0);f=1;i=b;return f|0};case 5:{f=Fe[c[31300]&7]()|0;i=b;return f|0};case 11:{f=bT(c[a+8>>2]|0)|0;i=b;return f|0};case 4:case 14:{c[31304]=(c[31304]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 13:{g=(c[31304]|0)-(c[a+4>>2]|0)|0;h=0-(c[31302]|0)|0;c[31304]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 12:{f=cT(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;zd(f|0,130952,d|0)|0;eS(c[31228]|0,1)}}return 0}function bT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[31304]|0)!=0){e=VS()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}ie[c[31292]&255](e<<24>>24);n=b}else{ie[c[31292]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function cT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[31304]|0)!=0){f=VS()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;ie[c[31292]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function dT(){var a=0,b=0;a=i;b=HS(10)|0;c[31304]=0;c[31302]=0;c[31306]=0;i=a;return(b|0)==0|0}function eT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[31278]|0)==0){qS()}c[31242]=0;c[31248]=1;c[31256]=1;c[31266]=1;d=NS(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[31284]=a;c[31302]=0;c[31304]=0;c[31306]=0;c[32556]=0;c[31308]=0;d=c[a+12>>2]|0;c[31228]=d;c[31280]=c[c[30002]>>2];if((tS(d)|0)<0){if((c[a>>2]|0)==0){pS(100,131032);e=100;i=b;return e|0}else{c[(Pc()|0)>>2]=100;e=100;i=b;return e|0}}c[31292]=210;c[31294]=45;c[31296]=112;c[31282]=4;c[31298]=5;c[31300]=6;yS();c[31288]=0;d=c[30002]|0;c[31290]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((rS(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Pc()|0;f=c[a>>2]|0;if(d){pS(f,131040);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function fT(){var a=0,b=0;a=i;if((c[32556]|0)==0){b=HS(10)|0}else{HS(0)|0;xd(c[31280]|0)|0;b=0}c[31304]=0;c[31302]=0;c[31306]=0;i=a;return b|0}function gT(){var a=0,b=0,d=0;a=i;if((c[32540]|0)==0){b=0}else{d=HS(10)|0;c[32540]=0;b=d}c[31304]=0;c[31302]=0;c[31306]=0;i=a;return b|0}function hT(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;DT(131768,h,131824);c[32764]=133276;c[131064>>2]=133296;c[131060>>2]=0;uV(131064|0,131768);c[131136>>2]=0;c[131140>>2]=-1;j=c[t>>2]|0;c[32968]=133144;c$(131876|0);k=131880|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[32968]=132384;c[131904>>2]=j;d$(g,131876|0);k=g$(g,135936)|0;l=k;e$(g);c[131908>>2]=l;c[131912>>2]=131832;a[131916|0]=(le[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[32786]=133356;c[131148>>2]=133376;uV(131148|0,131872);c[131220>>2]=0;c[131224>>2]=-1;l=c[r>>2]|0;c[32980]=133144;c$(131924|0);k=131928|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[32980]=132384;c[131952>>2]=l;d$(f,131924|0);k=g$(f,135936)|0;g=k;e$(f);c[131956>>2]=g;c[131960>>2]=131840;a[131964|0]=(le[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[32808]=133356;c[131236>>2]=133376;uV(131236|0,131920);c[131308>>2]=0;c[131312>>2]=-1;g=c[(c[(c[32808]|0)+ -12>>2]|0)+131256>>2]|0;c[32830]=133356;c[131324>>2]=133376;uV(131324|0,g);c[131396>>2]=0;c[131400>>2]=-1;c[(c[(c[32764]|0)+ -12>>2]|0)+131128>>2]=131144;g=(c[(c[32808]|0)+ -12>>2]|0)+131236|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[32808]|0)+ -12>>2]|0)+131304>>2]=131144;pT(131968,h,131848|0);c[32852]=133316;c[131416>>2]=133336;c[131412>>2]=0;uV(131416|0,131968);c[131488>>2]=0;c[131492>>2]=-1;c[33006]=133208;c$(132028|0);h=132032|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[33006]=132128;c[132056>>2]=j;d$(e,132028|0);j=g$(e,135944)|0;h=j;e$(e);c[132060>>2]=h;c[132064>>2]=131856;a[132068|0]=(le[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[32874]=133396;c[131500>>2]=133416;uV(131500|0,132024);c[131572>>2]=0;c[131576>>2]=-1;c[33018]=133208;c$(132076|0);h=132080|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[33018]=132128;c[132104>>2]=l;d$(d,132076|0);l=g$(d,135944)|0;h=l;e$(d);c[132108>>2]=h;c[132112>>2]=131864;a[132116|0]=(le[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[32896]=133396;c[131588>>2]=133416;uV(131588|0,132072);c[131660>>2]=0;c[131664>>2]=-1;h=c[(c[(c[32896]|0)+ -12>>2]|0)+131608>>2]|0;c[32918]=133396;c[131676>>2]=133416;uV(131676|0,h);c[131748>>2]=0;c[131752>>2]=-1;c[(c[(c[32852]|0)+ -12>>2]|0)+131480>>2]=131496;h=(c[(c[32896]|0)+ -12>>2]|0)+131588|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[32896]|0)+ -12>>2]|0)+131656>>2]=131496;i=b;return}function iT(a){a=a|0;a=i;sW(131144)|0;sW(131320)|0;zW(131496)|0;zW(131672)|0;i=a;return}function jT(a){a=a|0;var b=0;b=i;c[a>>2]=133208;e$(a+4|0);i=b;return}function kT(a){a=a|0;var b=0;b=i;c[a>>2]=133208;e$(a+4|0);J2(a);i=b;return}function lT(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;le[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=g$(d,135944)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(le[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function mT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Be[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((tc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((xd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function nT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=tc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((Ae[c[(c[b>>2]|0)+52>>2]&127](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function oT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((tc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Je[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((tc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((tc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function pT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=133208;j=b+4|0;c$(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=132240;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;d$(g,j);j=g$(g,135944)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=le[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(le[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){o_(132336)}else{e$(g);i=f;return}}function qT(a){a=a|0;var b=0;b=i;c[a>>2]=133208;e$(a+4|0);i=b;return}function rT(a){a=a|0;var b=0;b=i;c[a>>2]=133208;e$(a+4|0);J2(a);i=b;return}function sT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=g$(d,135944)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=le[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(le[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){o_(132336)}else{i=e;return}}function tT(a){a=a|0;var b=0,c=0;b=i;c=wT(a,0)|0;i=b;return c|0}function uT(a){a=a|0;var b=0,c=0;b=i;c=wT(a,1)|0;i=b;return c|0}function vT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Je[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((td(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function wT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=fd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Je[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==2){n=-1;y=22;break}else if((x|0)==3){y=14;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=fd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((td(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function xT(a){a=a|0;var b=0;b=i;c[a>>2]=133144;e$(a+4|0);i=b;return}function yT(a){a=a|0;var b=0;b=i;c[a>>2]=133144;e$(a+4|0);J2(a);i=b;return}function zT(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;le[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=g$(d,135936)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(le[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function AT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Be[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((tc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((xd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function BT(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=tc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((Ae[c[(c[b>>2]|0)+52>>2]&127](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function CT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((tc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Je[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((tc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((tc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function DT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=133144;j=b+4|0;c$(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=132496;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;d$(g,j);j=g$(g,135936)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=le[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(le[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){o_(132336)}else{e$(g);i=f;return}}function ET(a){a=a|0;var b=0;b=i;c[a>>2]=133144;e$(a+4|0);i=b;return}function FT(a){a=a|0;var b=0;b=i;c[a>>2]=133144;e$(a+4|0);J2(a);i=b;return}function GT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=g$(d,135936)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=le[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(le[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){o_(132336)}else{i=e;return}}function HT(a){a=a|0;var b=0,c=0;b=i;c=KT(a,0)|0;i=b;return c|0}function IT(a){a=a|0;var b=0,c=0;b=i;c=KT(a,1)|0;i=b;return c|0}function JT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Je[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((td(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function KT(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=fd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Je[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=fd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((td(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function LT(){var a=0;a=i;hT(0);ae(211,131760,q|0)|0;i=a;return}function MT(a){a=a|0;i=i;return}function NT(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function OT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}ie[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function PT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=132640;e=d3(b|0)|0;f=I2(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;f3(g|0,b|0,e+1|0)|0;i=d;return}function QT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=132640;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Ab(h|0);j=a;J2(j);i=b;return}K2((c[d>>2]|0)+ -12|0);g=a;h=g;Ab(h|0);j=a;J2(j);i=b;return}function RT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=132640;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Ab(h|0);i=b;return}K2((c[d>>2]|0)+ -12|0);g=a;h=g;Ab(h|0);i=b;return}function ST(a){a=a|0;i=i;return c[a+4>>2]|0}function TT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=132664;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=d3(f|0)|0;g=I2(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;f3(h|0,f|0,d+1|0)|0;i=e;return}function UT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=132664;e=d3(b|0)|0;f=I2(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;f3(g|0,b|0,e+1|0)|0;i=d;return}function VT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=132664;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Ab(h|0);j=a;J2(j);i=b;return}K2((c[d>>2]|0)+ -12|0);g=a;h=g;Ab(h|0);j=a;J2(j);i=b;return}function WT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=132664;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Ab(h|0);i=b;return}K2((c[d>>2]|0)+ -12|0);g=a;h=g;Ab(h|0);i=b;return}function XT(a){a=a|0;i=i;return c[a+4>>2]|0}function YT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=132640;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Ab(h|0);j=a;J2(j);i=b;return}K2((c[d>>2]|0)+ -12|0);g=a;h=g;Ab(h|0);j=a;J2(j);i=b;return}function ZT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=132640;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Ab(h|0);j=a;J2(j);i=b;return}K2((c[d>>2]|0)+ -12|0);g=a;h=g;Ab(h|0);j=a;J2(j);i=b;return}function _T(a){a=a|0;i=i;return}function $T(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function aU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;He[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function bU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function cU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Zd(e|0)|0;e=d3(f|0)|0;if(e>>>0>4294967279){iU(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;f3(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=H2(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;f3(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function dU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{PU(e,132880,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;He[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}PU(e,o,p)|0;if((a[g]&1)==0){break}J2(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function eU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=d3(e|0)|0;if(j>>>0>4294967279){iU(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=H2(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}f3(k|0,e|0,j|0)|0;a[k+j|0]=0;dU(g,d,h);TT(b,g);if(!((a[g]&1)==0)){J2(c[g+8>>2]|0)}if(!((a[h]&1)==0)){J2(c[h+8>>2]|0)}c[b>>2]=132896;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function fU(a){a=a|0;var b=0;b=i;WT(a);J2(a);i=b;return}function gU(a){a=a|0;var b=0;b=i;WT(a);i=b;return}function hU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;vc(133032)|0;if((c[a>>2]|0)==1){do{pd(133056,133032)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;hc(133032)|0;ie[d&255](b);vc(133032)|0;c[a>>2]=-1;hc(133032)|0;cd(133056)|0;i=e;return}else{hc(133032)|0;i=e;return}}function iU(a){a=a|0;a=Gc(8)|0;PT(a,133104);c[a>>2]=132720;Wd(a|0,132760,41)}function jU(a){a=a|0;a=Gc(8)|0;PT(a,133104);c[a>>2]=132784;Wd(a|0,132824,41)}function kU(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function lU(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function mU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){iU(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=H2(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}f3(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function nU(b){b=b|0;i=i;return(a[b]&1)!=0|0}function oU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){iU(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=H2(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}f3(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function pU(a){a=a|0;i=i;return a|0}function qU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=d3(d|0)|0;if(f>>>0>4294967279){iU(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;f3(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=H2(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;f3(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function rU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){iU(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=H2(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}h3(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function sU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){iU(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;h3(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=H2(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;h3(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function tU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){jU(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){iU(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;f3(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=H2(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;f3(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function uU(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function vU(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function wU(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}J2(c[b+8>>2]|0);i=d;return}function xU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}QU(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}g3(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function yU(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=zU(a,b)|0;i=c;return d|0}function zU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=d3(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}QU(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}g3(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function AU(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function BU(a){a=a|0;i=i;return a+1|0}function CU(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function DU(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function EU(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function FU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){GU(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function GU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){RU(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}h3(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function HU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){GU(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function IU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){iU(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=H2(f)|0}else{p=H2(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}f3(l|0,n|0,q+1|0)|0;if(o){J2(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function JU(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function KU(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function LU(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function MU(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function NU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=PU(b,g,h)|0;i=e;return d|0}function OU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){RU(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function PU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){QU(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}f3(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function QU(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){iU(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=H2(q)|0;if((g|0)!=0){f3(e|0,m|0,g|0)|0}if((j|0)!=0){f3(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){f3(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){J2(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function RU(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){iU(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=H2(p)|0;if((g|0)!=0){f3(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){f3(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}J2(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function SU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;tU(a,b,c,d,0);i=e;return}function TU(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function UU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d3(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function VU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=_2(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function WU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d3(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){jU(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=_2(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function XU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){iU(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;f3(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=H2(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;f3(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function YU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){iU(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=H2(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}c2(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function ZU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){iU(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=H2(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}e2(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function _U(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}J2(c[b+8>>2]|0);i=d;return}function $U(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=aV(a,b,b2(b)|0)|0;i=c;return d|0}function aV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}dV(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}d2(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function bV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){iU(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=H2(f)|0}else{p=H2(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}c2(l,n,q+1|0)|0;if(o){J2(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function cV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){eV(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function dV(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){iU(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=H2(q<<2)|0;p=e;if((g|0)!=0){c2(p,m,g)|0}if((j|0)!=0){c2(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){c2(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){J2(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function eV(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){iU(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=H2(p<<2)|0;o=e;if((g|0)!=0){c2(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){c2(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}J2(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function fV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=d3(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){iU(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=H2(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}f3(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=PU(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=PU(b,m,j)|0;i=f;return}}function gV(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function hV(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function iV(a,b){a=a|0;b=b|0;var c=0;c=i;jV(a,b);i=c;return}function jV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Gc(16)|0;do{if((a[133488]|0)==0){if((_a(133488)|0)==0){break}c[33370]=134184;ae(67,133480,q|0)|0;Ub(133488)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=133480;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];eU(b,f,133536);c[e>>2]=133504;Wd(e|0,133584,63)}function kV(a,b){a=a|0;b=b|0;var d=0;d=i;jV(a,c[a+16>>2]|b);i=d;return}function lV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=133528;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;He[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}e$(a+28|0);C2(c[e>>2]|0);C2(c[f>>2]|0);C2(c[a+48>>2]|0);C2(c[a+60>>2]|0);i=b;return}function mV(a){a=a|0;var b=0;b=i;lV(a);J2(a);i=b;return}function nV(a){a=a|0;var b=0;b=i;lV(a);i=b;return}function oV(a){a=a|0;var b=0;b=i;lV(a);i=b;return}function pV(a){a=a|0;i=i;return c[a+24>>2]|0}function qV(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}d$(d,a+28|0);a=g$(d,135872)|0;f=Ae[c[(c[a>>2]|0)+28>>2]&127](a,32)|0;e$(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function rV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;d$(e,a+28|0);a=g$(e,135872)|0;f=Ae[c[(c[a>>2]|0)+28>>2]&127](a,b)|0;e$(e);i=d;return f|0}function sV(a,b){a=a|0;b=b|0;var c=0;c=i;d$(a,b+28|0);i=c;return}function tV(a){a=a|0;c[a>>2]=133128;i=i;return}function uV(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));c$(b);i=d;return}function vV(a){a=a|0;var b=0;b=i;c[a>>2]=133144;e$(a+4|0);J2(a);i=b;return}function wV(a){a=a|0;var b=0;b=i;c[a>>2]=133144;e$(a+4|0);i=b;return}function xV(a){a=a|0;var b=0;b=i;c[a>>2]=133144;e$(a+4|0);i=b;return}function yV(a,b){a=a|0;b=b|0;var c=0;c=i;d$(a,b+4|0);i=c;return}function zV(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=le[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function AV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=Ae[c[(c[b>>2]|0)+52>>2]&127](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function BV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=oe[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function CV(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=133144;c$(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function DV(a){a=a|0;i=i;return c[a+8>>2]|0}function EV(a){a=a|0;i=i;return c[a+12>>2]|0}function FV(a){a=a|0;i=i;return c[a+16>>2]|0}function GV(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function HV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function IV(a){a=a|0;i=i;return c[a+20>>2]|0}function JV(a){a=a|0;i=i;return c[a+24>>2]|0}function KV(a){a=a|0;i=i;return c[a+28>>2]|0}function LV(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function MV(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function NV(a,b){a=a|0;b=b|0;i=i;return}function OV(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function PV(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function QV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function RV(a){a=a|0;i=i;return 0}function SV(a){a=a|0;i=i;return 0}function TV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=le[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function UV(a){a=a|0;i=i;return-1}function VV(a){a=a|0;var b=0,e=0,f=0;b=i;if((le[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function WV(a,b){a=a|0;b=b|0;i=i;return-1}



function sY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=134664;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);x=c[33940]|0;c[k>>2]=h;h=pY(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;sV(q,f);qY(w,y,k,z,o,p,q);OT(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];UQ(b,j,z,e,o,f,g);i=d;return}function tY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);w=c[33940]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=pY(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;sV(r,f);qY(x,z,l,A,p,q,r);OT(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];UQ(b,k,A,e,p,f,g);i=d;return}function uY(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);r=c[33940]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=pY(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=pY(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[135768]|0)==0;if(F){do{if(o){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);r=c[33940]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=vY(s,r,z,n)|0}else{do{if(o){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);o=c[33940]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=vY(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}O2()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=B2(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}O2()}}while(0);sV(w,f);wY(N,L,G,P,u,v,w);OT(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];UQ(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){C2(O)}if((J|0)==0){i=d;return}C2(J);i=d;return}function vY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Nc(b|0)|0;b=lc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Nc(e|0)|0;i=f;return b|0}function wY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[33968]|0)==-1)){c[m>>2]=135872;c[m+4>>2]=212;c[m+8>>2]=0;hU(135872,m,213)}m=(c[135876>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[34004]|0)==-1)){c[l>>2]=136016;c[l+4>>2]=212;c[l+8>>2]=0;hU(136016,l,213)}l=(c[136020>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Gc(4)|0;v=u;g2(v);w=151432;x=128;Wd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Gc(4)|0;v=u;g2(v);w=151432;x=128;Wd(u|0,w|0,x|0)}x=s;je[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ae[c[(c[j>>2]|0)+28>>2]&127](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=Ae[c[(c[j>>2]|0)+28>>2]&127](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=Ae[c[(c[j>>2]|0)+28>>2]&127](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);w=A+1|0;if((Zc(l<<24>>24|0,c[33940]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);l=D+1|0;if((Yd(A<<24>>24|0,c[33940]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ke[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=le[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=Ae[c[(c[j>>2]|0)+28>>2]&127](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=Ae[c[(c[j>>2]|0)+28>>2]&127](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=le[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Ke[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;wU(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;wU(n);i=k;return}function xY(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);r=c[33940]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=pY(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=pY(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[135768]|0)==0;if(F){do{if(o){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);r=c[33940]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=vY(s,r,z,n)|0}else{do{if(o){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);o=c[33940]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=vY(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}O2()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=B2(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}O2()}}while(0);sV(w,f);wY(N,L,G,P,u,v,w);OT(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];UQ(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){C2(O)}if((J|0)==0){i=d;return}C2(J);i=d;return}function yY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=134672;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);s=c[33940]|0;c[k>>2]=h;h=pY(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;sV(p,f);r=p;p=c[r>>2]|0;if(!((c[33968]|0)==-1)){c[l>>2]=135872;c[l+4>>2]=212;c[l+8>>2]=0;hU(135872,l,213)}l=(c[135876>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}OT(c[r>>2]|0)|0;Ke[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];UQ(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];UQ(b,j,u,z,m,f,g);I=j;i=d;return}function zY(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function AY(a){a=a|0;i=i;return}function BY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ue[p&31](b,d,k,f,g,q);i=j;return}sV(n,f);f=n;n=c[f>>2]|0;if(!((c[34006]|0)==-1)){c[l>>2]=136024;c[l+4>>2]=212;c[l+8>>2]=0;hU(136024,l,213)}l=(c[136028>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Gc(4)|0;u=t;g2(u);v=151432;w=128;Wd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Gc(4)|0;u=t;g2(u);v=151432;w=128;Wd(t|0,v|0,w|0)}w=n;OT(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){je[c[f+24>>2]&127](o,w)}else{je[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=Ae[c[(c[h>>2]|0)+52>>2]&127](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];_U(o);i=j;return}function CY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=134664;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);v=c[33940]|0;c[k>>2]=h;h=pY(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;sV(q,f);DY(w,y,k,z,o,p,q);OT(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];EY(b,j,z,e,o,f,g);i=d;return}function DY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[33966]|0)==-1)){c[m>>2]=135864;c[m+4>>2]=212;c[m+8>>2]=0;hU(135864,m,213)}m=(c[135868>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[34006]|0)==-1)){c[l>>2]=136024;c[l+4>>2]=212;c[l+8>>2]=0;hU(136024,l,213)}l=(c[136028>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Gc(4)|0;v=u;g2(v);w=151432;x=128;Wd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Gc(4)|0;v=u;g2(v);w=151432;x=128;Wd(u|0,w|0,x|0)}x=s;je[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ke[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ae[c[(c[j>>2]|0)+44>>2]&127](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=Ae[c[(c[j>>2]|0)+44>>2]&127](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=Ae[c[(c[j>>2]|0)+44>>2]&127](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=le[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=Ae[c[(c[j>>2]|0)+44>>2]&127](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;wU(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;wU(n);i=k;return}function EY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((oe[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){ZU(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((oe[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){_U(l);break}c[m>>2]=0;c[b>>2]=0;_U(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((oe[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function FY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);w=c[33940]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=pY(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;sV(r,f);DY(x,z,l,A,p,q,r);OT(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];EY(b,k,A,e,p,f,g);i=d;return}function GY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=134664;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);x=c[33940]|0;c[k>>2]=h;h=pY(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;sV(q,f);DY(w,y,k,z,o,p,q);OT(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];EY(b,j,z,e,o,f,g);i=d;return}function HY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);y=c[33940]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=pY(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;sV(r,f);DY(x,z,l,A,p,q,r);OT(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];EY(b,k,A,e,p,f,g);i=d;return}function IY(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);r=c[33940]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=pY(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=pY(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[135768]|0)==0;if(F){do{if(o){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);r=c[33940]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=vY(s,r,z,n)|0}else{do{if(o){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);o=c[33940]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=vY(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}O2()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=B2(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}O2()}}while(0);sV(w,f);JY(N,L,G,P,u,v,w);OT(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];EY(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){C2(O)}if((J|0)==0){i=d;return}C2(J);i=d;return}function JY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[33966]|0)==-1)){c[m>>2]=135864;c[m+4>>2]=212;c[m+8>>2]=0;hU(135864,m,213)}m=(c[135868>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[34006]|0)==-1)){c[l>>2]=136024;c[l+4>>2]=212;c[l+8>>2]=0;hU(136024,l,213)}l=(c[136028>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Gc(4)|0;v=u;g2(v);w=151432;x=128;Wd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Gc(4)|0;v=u;g2(v);w=151432;x=128;Wd(u|0,w|0,x|0)}x=s;je[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ae[c[(c[j>>2]|0)+44>>2]&127](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=Ae[c[(c[j>>2]|0)+44>>2]&127](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=Ae[c[(c[j>>2]|0)+44>>2]&127](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);w=A+1|0;if((Zc(l<<24>>24|0,c[33940]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);l=D+1|0;if((Yd(A<<24>>24|0,c[33940]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ke[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=le[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=Ae[c[(c[j>>2]|0)+44>>2]&127](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=Ae[c[(c[j>>2]|0)+44>>2]&127](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=le[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Ke[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;wU(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;wU(n);i=k;return}function KY(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);r=c[33940]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=pY(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=pY(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[135768]|0)==0;if(F){do{if(o){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);r=c[33940]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=vY(s,r,z,n)|0}else{do{if(o){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);o=c[33940]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=vY(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}O2()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=B2(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}O2()}}while(0);sV(w,f);JY(N,L,G,P,u,v,w);OT(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];EY(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){C2(O)}if((J|0)==0){i=d;return}C2(J);i=d;return}function LY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=134672;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);s=c[33940]|0;c[k>>2]=h;h=pY(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}sV(p,f);u=p;p=c[u>>2]|0;if(!((c[33966]|0)==-1)){c[l>>2]=135864;c[l+4>>2]=212;c[l+8>>2]=0;hU(135864,l,213)}l=(c[135868>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}OT(c[u>>2]|0)|0;u=o;Ke[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];EY(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];EY(b,j,u,z,m,f,g);I=j;i=d;return}function MY(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;sV(r,h);v=r;r=c[v>>2]|0;if(!((c[33968]|0)==-1)){c[q>>2]=135872;c[q+4>>2]=212;c[q+8>>2]=0;hU(135872,q,213)}q=(c[135876>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Gc(4)|0;y=x;g2(y);z=151432;A=128;Wd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Gc(4)|0;y=x;g2(y);z=151432;A=128;Wd(x|0,z|0,A|0)}A=r;OT(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((le[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((le[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((oe[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(le[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=Ae[c[(c[r>>2]|0)+12>>2]&127](A,N)|0;if(H<<24>>24==(Ae[c[(c[r>>2]|0)+12>>2]&127](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=oe[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=oe[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];ze[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((le[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(le[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){le[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){le[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((le[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((le[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function NY(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function OY(a){a=a|0;i=i;return}function PY(a){a=a|0;i=i;return 2}function QY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];MY(a,b,l,k,f,g,h,134776,134784|0);i=j;return}function RY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=le[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];MY(b,d,m,l,g,h,j,s,q);i=k;return}function SY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;sV(n,f);f=n;n=c[f>>2]|0;if(!((c[33968]|0)==-1)){c[m>>2]=135872;c[m+4>>2]=212;c[m+8>>2]=0;hU(135872,m,213)}m=(c[135876>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}s=n;OT(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=le[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=nX(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function TY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;sV(n,f);f=n;n=c[f>>2]|0;if(!((c[33968]|0)==-1)){c[m>>2]=135872;c[m+4>>2]=212;c[m+8>>2]=0;hU(135872,m,213)}m=(c[135876>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}s=n;OT(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=le[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=nX(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function UY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;sV(m,f);f=m;m=c[f>>2]|0;if(!((c[33968]|0)==-1)){c[l>>2]=135872;c[l+4>>2]=212;c[l+8>>2]=0;hU(135872,l,213)}l=(c[135876>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Gc(4)|0;p=o;g2(p);q=151432;r=128;Wd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Gc(4)|0;p=o;g2(p);q=151432;r=128;Wd(o|0,q|0,r|0)}r=m;OT(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=ZY(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function VY(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;sV(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[33968]|0)==-1)){c[ba>>2]=135872;c[ba+4>>2]=212;c[ba+8>>2]=0;hU(135872,ba,213)}ba=(c[135876>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Gc(4)|0;Ga=Fa;g2(Ga);Ha=151432;Ia=128;Wd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Gc(4)|0;Ga=Fa;g2(Ga);Ha=151432;Ia=128;Wd(Fa|0,Ha|0,Ia|0)}Ia=ca;OT(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=le[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(nX(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];xe[Da&63](b,d,s,r,g,h,j);i=l;return};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];MY(ua,d,v,u,g,h,j,134824,134832|0);c[Da>>2]=c[ua>>2];break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=ZY(e,G,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=ca|4;break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Ha=ZY(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<61){c[j>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];MY(oa,d,A,z,g,h,j,134800,134811|0);c[Da>>2]=c[oa>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];YY(0,e,m,h,Ia);break};case 99:{Da=d+8|0;Ha=le[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Fa=a[Ha]|0;if((Fa&1)==0){Ja=Ha+1|0;Ka=Ha+1|0;La=(Fa&255)>>>1}else{Fa=c[Ha+8>>2]|0;Ja=Fa;Ka=Fa;La=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];MY(da,d,O,N,g,h,j,Ka,Ja+La|0);c[Da>>2]=c[da>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=ZY(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];WY(0,e,C,h,Ia);break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];MY(ga,d,L,K,g,h,j,134784,134792|0);c[Da>>2]=c[ga>>2];break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];MY(ra,d,y,x,g,h,j,134816,134821|0);c[Da>>2]=c[ra>>2];break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];MY(ja,d,J,I,g,h,j,134792,134800|0);c[Da>>2]=c[ja>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];XY(d,j+8|0,e,B,h,Ia);break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=ZY(e,E,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=Ha|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=ZY(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=ZY(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};case 88:{Ha=d+8|0;Da=le[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Ma=Da+1|0;Na=Da+1|0;Oa=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Ma=ca;Na=ca;Oa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];MY(za,d,q,p,g,h,j,Na,Ma+Oa|0);c[Ha>>2]=c[za>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Ha=ZY(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<366){c[j+28>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 104:case 66:case 98:{Da=c[f>>2]|0;Ha=d+8|0;ca=le[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(nX(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=ZY(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Pa=Da+2e3|0}else{Pa=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Pa+ -1900;break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=ZY(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=ZY(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function WY(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((le[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((le[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(le[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){le[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((le[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((le[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function XY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=le[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=nX(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function YY(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((le[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((le[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(le[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((oe[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){le[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((le[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((le[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function ZY(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((le[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((le[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(le[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(oe[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){le[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((le[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((le[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(le[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((oe[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){le[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((le[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((le[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function _Y(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;sV(p,f);t=p;p=c[t>>2]|0;if(!((c[33966]|0)==-1)){c[o>>2]=135864;c[o+4>>2]=212;c[o+8>>2]=0;hU(135864,o,213)}o=(c[135868>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}y=p;OT(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=le[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=le[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((oe[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(oe[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=Ae[c[(c[p>>2]|0)+28>>2]&127](y,M)|0;if((C|0)==(Ae[c[(c[p>>2]|0)+28>>2]&127](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=oe[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=oe[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];ze[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(oe[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=le[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=le[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=le[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(oe[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){le[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){le[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=le[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=le[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function $Y(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function aZ(a){a=a|0;i=i;return}function bZ(a){a=a|0;i=i;return 2}function cZ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];_Y(a,b,l,k,f,g,h,134928,134960|0);i=j;return}function dZ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=le[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];_Y(b,d,m,l,g,h,j,s,q);i=k;return}function eZ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;sV(n,f);f=n;n=c[f>>2]|0;if(!((c[33966]|0)==-1)){c[m>>2]=135864;c[m+4>>2]=212;c[m+8>>2]=0;hU(135864,m,213)}m=(c[135868>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}s=n;OT(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=le[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=MX(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function fZ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;sV(n,f);f=n;n=c[f>>2]|0;if(!((c[33966]|0)==-1)){c[m>>2]=135864;c[m+4>>2]=212;c[m+8>>2]=0;hU(135864,m,213)}m=(c[135868>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}s=n;OT(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=le[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=MX(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function gZ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;sV(m,f);f=m;m=c[f>>2]|0;if(!((c[33966]|0)==-1)){c[l>>2]=135864;c[l+4>>2]=212;c[l+8>>2]=0;hU(135864,l,213)}l=(c[135868>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Gc(4)|0;p=o;g2(p);q=151432;r=128;Wd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Gc(4)|0;p=o;g2(p);q=151432;r=128;Wd(o|0,q|0,r|0)}r=m;OT(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=lZ(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function hZ(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;sV(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[33966]|0)==-1)){c[ba>>2]=135864;c[ba+4>>2]=212;c[ba+8>>2]=0;hU(135864,ba,213)}ba=(c[135868>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Gc(4)|0;Ga=Fa;g2(Ga);Ha=151432;Ia=128;Wd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Gc(4)|0;Ga=Fa;g2(Ga);Ha=151432;Ia=128;Wd(Fa|0,Ha|0,Ia|0)}Ia=ca;OT(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 88:{Da=d+8|0;ca=le[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ja=Ha;Ka=Ha;La=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];_Y(za,d,q,p,g,h,j,Ka,Ja+(La<<2)|0);c[Da>>2]=c[za>>2];break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];_Y(ua,d,v,u,g,h,j,135096,135128|0);c[Da>>2]=c[ua>>2];break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=le[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(MX(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=lZ(e,w,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];xe[Ha&63](b,d,s,r,g,h,j);i=l;return};case 99:{Ha=d+8|0;Da=le[c[(c[Ha>>2]|0)+12>>2]&127](Ha)|0;Ha=e;c[ea>>2]=c[Ha>>2];c[fa>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Ma=Da+4|0;Na=Da+4|0;Oa=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Ma=ca;Na=ca;Oa=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];_Y(da,d,O,N,g,h,j,Na,Ma+(Oa<<2)|0);c[Ha>>2]=c[da>>2];break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];_Y(ga,d,L,K,g,h,j,134960,134992|0);c[Ha>>2]=c[ga>>2];break};case 82:{Ha=e;c[sa>>2]=c[Ha>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];_Y(ra,d,y,x,g,h,j,135072,135092|0);c[Ha>>2]=c[ra>>2];break};case 70:{Ha=e;c[ka>>2]=c[Ha>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];_Y(ja,d,J,I,g,h,j,134992,135024|0);c[Ha>>2]=c[ja>>2];break};case 114:{Ha=e;c[pa>>2]=c[Ha>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];_Y(oa,d,A,z,g,h,j,135024,135068|0);c[Ha>>2]=c[oa>>2];break};case 73:{Ha=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=lZ(e,G,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[Ha>>2]=Da;break a}}while(0);c[h>>2]=ca|4;break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];jZ(d,j+8|0,e,B,h,Ia);break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=lZ(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Pa=Da+2e3|0}else{Pa=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Pa+ -1900;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=lZ(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];iZ(0,e,C,h,Ia);break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=lZ(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Ha=lZ(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<366){c[j+28>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Da=lZ(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<24){c[j+8>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 104:case 66:case 98:{Ha=c[f>>2]|0;Da=d+8|0;ca=le[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=Ha;c[P+0>>2]=c[$+0>>2];Ha=(MX(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Ha|0)>=288){break a}c[j+16>>2]=((Ha|0)/12|0|0)%12|0;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];kZ(0,e,m,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Ha=lZ(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<7){c[j+24>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=lZ(e,D,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=lZ(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=ca|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function iZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=le[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=le[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=le[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(oe[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){le[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=le[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=le[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function jZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=le[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=MX(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function kZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=le[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=le[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=le[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((oe[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){le[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=le[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=le[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function lZ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=le[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=le[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=le[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(oe[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(oe[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){le[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=le[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=le[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=le[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(oe[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((oe[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){le[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=le[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=le[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function mZ(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);if((f|0)==(c[33940]|0)){g=b;J2(g);i=d;return}cc(c[e>>2]|0);g=b;J2(g);i=d;return}function nZ(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);if((b|0)==(c[33940]|0)){i=d;return}cc(c[e>>2]|0);i=d;return}function oZ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Uc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(Ae[c[(c[v>>2]|0)+52>>2]&127](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function pZ(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);if((f|0)==(c[33940]|0)){g=b;J2(g);i=d;return}cc(c[e>>2]|0);g=b;J2(g);i=d;return}function qZ(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);if((b|0)==(c[33940]|0)){i=d;return}cc(c[e>>2]|0);i=d;return}function rZ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;sZ(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=Ae[c[(c[q>>2]|0)+52>>2]&127](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function sZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Uc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Nc(c[g>>2]|0)|0;g=E1(d,m,n,l)|0;if((f|0)!=0){Nc(f|0)|0}if((g|0)==-1){o_(136752)}else{c[e>>2]=d+(g<<2);i=j;return}}function tZ(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function uZ(a){a=a|0;i=i;return}function vZ(a){a=a|0;i=i;return 127}function wZ(a){a=a|0;i=i;return 127}function xZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function yZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function zZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function AZ(a,b){a=a|0;b=b|0;b=i;sU(a,1,45);i=b;return}function BZ(a){a=a|0;i=i;return 0}function CZ(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function DZ(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function EZ(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function FZ(a){a=a|0;i=i;return}function GZ(a){a=a|0;i=i;return 127}function HZ(a){a=a|0;i=i;return 127}function IZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function JZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function KZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function LZ(a,b){a=a|0;b=b|0;b=i;sU(a,1,45);i=b;return}function MZ(a){a=a|0;i=i;return 0}function NZ(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function OZ(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function PZ(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function QZ(a){a=a|0;i=i;return}function RZ(a){a=a|0;i=i;return 2147483647}function SZ(a){a=a|0;i=i;return 2147483647}function TZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function UZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function VZ(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function WZ(a,b){a=a|0;b=b|0;b=i;ZU(a,1,45);i=b;return}function XZ(a){a=a|0;i=i;return 0}function YZ(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function ZZ(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function _Z(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function $Z(a){a=a|0;i=i;return}function a_(a){a=a|0;i=i;return 2147483647}function b_(a){a=a|0;i=i;return 2147483647}function c_(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function d_(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function e_(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function f_(a,b){a=a|0;b=b|0;b=i;ZU(a,1,45);i=b;return}function g_(a){a=a|0;i=i;return 0}function h_(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function i_(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function j_(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function k_(a){a=a|0;i=i;return}function l_(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=214;y=o+100|0;sV(r,h);o=r;z=c[o>>2]|0;if(!((c[33968]|0)==-1)){c[n>>2]=135872;c[n+4>>2]=212;c[n+8>>2]=0;hU(135872,n,213)}n=(c[135876>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Gc(4)|0;C=B;g2(C);D=151432;E=128;Wd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Gc(4)|0;C=B;g2(C);D=151432;E=128;Wd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=n_(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ke[c[(c[z>>2]|0)+32>>2]&63](E,135488,135498|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=B2(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}O2()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[135488+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Ad(p|0,135504,m|0)|0)!=1){t=Gc(8)|0;UT(t,135512);Wd(t|0,132864,43)}if((F|0)==0){break}C2(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((le[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((le[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;OT(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ie[c[x>>2]&255](o);i=d;return}function m_(a){a=a|0;i=i;return}function n_(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;r_(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=214;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((le[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((le[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 0:{X=26;break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=(le[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=(le[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}OU(A,ea);X=26;break};case 3:{da=a[y]|0;W=(da&1)==0;if(W){fa=(da&255)>>>1}else{fa=c[G>>2]|0}ba=a[z]|0;ga=(ba&1)==0;if(ga){ha=(ba&255)>>>1}else{ha=c[g>>2]|0}if((fa|0)==(0-ha|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}if(W){oa=(da&255)>>>1}else{oa=c[G>>2]|0}do{if((oa|0)!=0){if(ga){pa=(ba&255)>>>1}else{pa=c[g>>2]|0}if((pa|0)==0){break}qa=c[h>>2]|0;ra=c[qa+12>>2]|0;sa=c[qa+16>>2]|0;if((ra|0)==(sa|0)){ta=(le[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255;ua=c[h>>2]|0;va=ta;wa=c[ua+16>>2]|0;xa=c[ua+12>>2]|0;ya=ua;za=a[y]|0}else{va=a[ra]|0;wa=sa;xa=ra;ya=qa;za=da}qa=ya+12|0;ra=(xa|0)==(wa|0);if(va<<24>>24==(a[(za&1)==0?F:c[H>>2]|0]|0)){if(ra){le[c[(c[ya>>2]|0)+40>>2]&127](ya)|0}else{c[qa>>2]=xa+1}qa=a[y]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Aa>>>0>1?y:S;na=T;break b}if(ra){Ba=(le[c[(c[ya>>2]|0)+36>>2]&127](ya)|0)&255}else{Ba=a[xa]|0}if(!(Ba<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}ra=c[h>>2]|0;qa=ra+12|0;sa=c[qa>>2]|0;if((sa|0)==(c[ra+16>>2]|0)){le[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[qa>>2]=sa+1}a[l]=1;sa=a[z]|0;if((sa&1)==0){Ca=(sa&255)>>>1}else{Ca=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ca>>>0>1?z:S;na=T;break b}}while(0);if(W){Da=(da&255)>>>1}else{Da=c[G>>2]|0}ga=c[h>>2]|0;sa=c[ga+12>>2]|0;qa=(sa|0)==(c[ga+16>>2]|0);if((Da|0)==0){if(qa){ra=(le[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ea=ra;Fa=a[z]|0}else{Ea=a[sa]|0;Fa=ba}if(!(Ea<<24>>24==(a[(Fa&1)==0?m:c[E>>2]|0]|0))){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}ra=c[h>>2]|0;ua=ra+12|0;ta=c[ua>>2]|0;if((ta|0)==(c[ra+16>>2]|0)){le[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[ua>>2]=ta+1}a[l]=1;ta=a[z]|0;if((ta&1)==0){Ga=(ta&255)>>>1}else{Ga=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ga>>>0>1?z:S;na=T;break b}if(qa){qa=(le[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ha=qa;Ia=a[y]|0}else{Ha=a[sa]|0;Ia=da}if(!(Ha<<24>>24==(a[(Ia&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}sa=c[h>>2]|0;qa=sa+12|0;ga=c[qa>>2]|0;if((ga|0)==(c[sa+16>>2]|0)){le[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[qa>>2]=ga+1}ga=a[y]|0;if((ga&1)==0){Ja=(ga&255)>>>1}else{Ja=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ja>>>0>1?y:S;na=T;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Ka=(a[O]|0)!=0}else{Ka=0}if(!(I|Ka)){ia=D;ja=R;ka=r;la=Q;ma=0;na=T;break b}}ga=a[x]|0;qa=(ga&1)==0;sa=qa?j:c[J>>2]|0;c:do{if((p|0)==0){La=Y;Ma=Y;Na=ga;Oa=sa}else{if((d[s+(p+ -1)|0]|0)>=2){La=Y;Ma=Y;Na=ga;Oa=sa;break}ta=sa+(qa?(ga&255)>>>1:c[K>>2]|0)|0;ua=sa;while(1){if((ua|0)==(ta|0)){Pa=ta;break}ra=a[ua]|0;if(!(ra<<24>>24>-1)){Pa=ua;break}if((b[(c[f>>2]|0)+(ra<<24>>24<<1)>>1]&8192)==0){Pa=ua;break}else{ua=ua+1|0}}ua=Pa-sa|0;ta=a[A]|0;ra=(ta&1)==0;if(ra){Qa=(ta&255)>>>1}else{Qa=c[N>>2]|0}if(ua>>>0>Qa>>>0){La=Y;Ma=Y;Na=ga;Oa=sa;break}if(ra){ra=(ta&255)>>>1;Ra=A+1+(ra-ua)|0;Sa=L;Ta=ra}else{ra=c[M>>2]|0;ta=c[N>>2]|0;Ra=ra+(ta-ua)|0;Sa=ra;Ta=ta}ta=Sa+Ta|0;if((Ra|0)==(ta|0)){La=Y;Ma=Y;Na=ga;Oa=Pa;break}else{Ua=sa;Va=Ra}while(1){if((a[Va]|0)!=(a[Ua]|0)){La=Y;Ma=Y;Na=ga;Oa=sa;break c}ra=Va+1|0;if((ra|0)==(ta|0)){La=Y;Ma=Y;Na=ga;Oa=Pa;break}else{Ua=Ua+1|0;Va=ra}}}}while(0);d:while(1){if((Na&1)==0){Wa=j;Xa=(Na&255)>>>1}else{Wa=c[J>>2]|0;Xa=c[K>>2]|0}if((Oa|0)==(Wa+Xa|0)){break}ga=c[h>>2]|0;do{if((ga|0)==0){Ya=0}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){Ya=ga;break}if((le[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[h>>2]=0;Ya=0;break}else{Ya=c[h>>2]|0;break}}}while(0);ga=(Ya|0)==0;do{if((Ma|0)==0){Za=La;X=147}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(ga){_a=La;$a=Ma;break}else{break d}}if((le[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;Za=0;X=147;break}else{if(ga^(La|0)==0){_a=La;$a=La;break}else{break d}}}}while(0);if((X|0)==147){X=0;if(ga){break}else{_a=Za;$a=0}}sa=c[h>>2]|0;qa=c[sa+12>>2]|0;if((qa|0)==(c[sa+16>>2]|0)){ab=(le[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{ab=a[qa]|0}if(!(ab<<24>>24==(a[Oa]|0))){break}qa=c[h>>2]|0;sa=qa+12|0;da=c[sa>>2]|0;if((da|0)==(c[qa+16>>2]|0)){le[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[sa>>2]=da+1}La=_a;Ma=$a;Na=a[x]|0;Oa=Oa+1|0}if(!I){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}da=a[x]|0;if((da&1)==0){bb=j;cb=(da&255)>>>1}else{bb=c[J>>2]|0;cb=c[K>>2]|0}if((Oa|0)==(bb+cb|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T}else{X=162;break a}break};case 4:{da=D;sa=R;qa=r;ba=Q;W=0;ta=T;e:while(1){ra=c[h>>2]|0;do{if((ra|0)==0){db=0}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){db=ra;break}if((le[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[h>>2]=0;db=0;break}else{db=c[h>>2]|0;break}}}while(0);ra=(db|0)==0;ga=c[e>>2]|0;do{if((ga|0)==0){X=173}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){if(ra){break}else{break e}}if((le[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[e>>2]=0;X=173;break}else{if(ra){break}else{break e}}}}while(0);if((X|0)==173){X=0;if(ra){break}}ga=c[h>>2]|0;ua=c[ga+12>>2]|0;if((ua|0)==(c[ga+16>>2]|0)){eb=(le[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{eb=a[ua]|0}do{if(eb<<24>>24>-1){if((b[(c[f>>2]|0)+(eb<<24>>24<<1)>>1]&2048)==0){X=189;break}ua=c[o>>2]|0;if((ua|0)==(da|0)){ga=(c[P>>2]|0)!=214;fb=c[t>>2]|0;gb=da-fb|0;hb=gb>>>0<2147483647?gb<<1:-1;ib=E2(ga?fb:0,hb)|0;if((ib|0)==0){X=182;break a}do{if(ga){c[t>>2]=ib;jb=ib}else{fb=c[t>>2]|0;c[t>>2]=ib;if((fb|0)==0){jb=ib;break}ie[c[P>>2]&255](fb);jb=c[t>>2]|0}}while(0);c[P>>2]=189;ib=jb+gb|0;c[o>>2]=ib;kb=ib;lb=(c[t>>2]|0)+hb|0}else{kb=ua;lb=da}c[o>>2]=kb+1;a[kb]=eb;mb=lb;nb=sa;ob=qa;pb=ba;qb=W+1|0;rb=ta}else{X=189}}while(0);if((X|0)==189){X=0;ra=a[w]|0;if((ra&1)==0){sb=(ra&255)>>>1}else{sb=c[n>>2]|0}if((sb|0)==0|(W|0)==0){break}if(!(eb<<24>>24==(a[v]|0))){break}if((qa|0)==(ba|0)){ra=qa-sa|0;ib=ra>>>0<2147483647?ra<<1:-1;if((ta|0)==214){tb=0}else{tb=sa}ga=E2(tb,ib)|0;if((ga|0)==0){X=198;break a}ub=ga;vb=ga+(ra>>2<<2)|0;wb=ga+(ib>>>2<<2)|0;xb=189}else{ub=sa;vb=qa;wb=ba;xb=ta}c[vb>>2]=W;mb=da;nb=ub;ob=vb+4|0;pb=wb;qb=0;rb=xb}ib=c[h>>2]|0;ga=ib+12|0;ra=c[ga>>2]|0;if((ra|0)==(c[ib+16>>2]|0)){le[c[(c[ib>>2]|0)+40>>2]&127](ib)|0;da=mb;sa=nb;qa=ob;ba=pb;W=qb;ta=rb;continue}else{c[ga>>2]=ra+1;da=mb;sa=nb;qa=ob;ba=pb;W=qb;ta=rb;continue}}if((sa|0)==(qa|0)|(W|0)==0){yb=sa;zb=qa;Ab=ba;Bb=ta}else{if((qa|0)==(ba|0)){ra=qa-sa|0;ga=ra>>>0<2147483647?ra<<1:-1;if((ta|0)==214){Cb=0}else{Cb=sa}ib=E2(Cb,ga)|0;if((ib|0)==0){X=209;break a}Db=ib;Eb=ib+(ra>>2<<2)|0;Fb=ib+(ga>>>2<<2)|0;Gb=189}else{Db=sa;Eb=qa;Fb=ba;Gb=ta}c[Eb>>2]=W;yb=Db;zb=Eb+4|0;Ab=Fb;Bb=Gb}if((c[B>>2]|0)>0){ga=c[h>>2]|0;do{if((ga|0)==0){Hb=0}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){Hb=ga;break}if((le[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[h>>2]=0;Hb=0;break}else{Hb=c[h>>2]|0;break}}}while(0);ga=(Hb|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=223}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(ga){Ib=W;break}else{X=229;break a}}if((le[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=223;break}else{if(ga){Ib=W;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ga){X=229;break a}else{Ib=0}}W=c[h>>2]|0;ta=c[W+12>>2]|0;if((ta|0)==(c[W+16>>2]|0)){Jb=(le[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{Jb=a[ta]|0}if(!(Jb<<24>>24==(a[u]|0))){X=229;break a}ta=c[h>>2]|0;W=ta+12|0;ba=c[W>>2]|0;if((ba|0)==(c[ta+16>>2]|0)){le[c[(c[ta>>2]|0)+40>>2]&127](ta)|0;Kb=Ib;Lb=Ib;Mb=da}else{c[W>>2]=ba+1;Kb=Ib;Lb=Ib;Mb=da}while(1){ba=c[h>>2]|0;do{if((ba|0)==0){Nb=0}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){Nb=ba;break}if((le[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[h>>2]=0;Nb=0;break}else{Nb=c[h>>2]|0;break}}}while(0);ba=(Nb|0)==0;do{if((Lb|0)==0){Ob=Kb;X=243}else{if((c[Lb+12>>2]|0)!=(c[Lb+16>>2]|0)){if(ba){Pb=Kb;Qb=Lb;break}else{X=250;break a}}if((le[c[(c[Lb>>2]|0)+36>>2]&127](Lb)|0)==-1){c[e>>2]=0;Ob=0;X=243;break}else{if(ba^(Kb|0)==0){Pb=Kb;Qb=Kb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ba){X=250;break a}else{Pb=Ob;Qb=0}}W=c[h>>2]|0;ta=c[W+12>>2]|0;if((ta|0)==(c[W+16>>2]|0)){Rb=(le[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{Rb=a[ta]|0}if(!(Rb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Rb<<24>>24<<1)>>1]&2048)==0){X=250;break a}ta=c[o>>2]|0;if((ta|0)==(Mb|0)){W=(c[P>>2]|0)!=214;qa=c[t>>2]|0;sa=Mb-qa|0;ib=sa>>>0<2147483647?sa<<1:-1;ra=E2(W?qa:0,ib)|0;if((ra|0)==0){X=253;break a}do{if(W){c[t>>2]=ra;Sb=ra}else{qa=c[t>>2]|0;c[t>>2]=ra;if((qa|0)==0){Sb=ra;break}ie[c[P>>2]&255](qa);Sb=c[t>>2]|0}}while(0);c[P>>2]=189;ra=Sb+sa|0;c[o>>2]=ra;Tb=ra;Ub=(c[t>>2]|0)+ib|0}else{Tb=ta;Ub=Mb}ra=c[h>>2]|0;W=c[ra+12>>2]|0;if((W|0)==(c[ra+16>>2]|0)){ba=(le[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)&255;Vb=ba;Wb=c[o>>2]|0}else{Vb=a[W]|0;Wb=Tb}c[o>>2]=Wb+1;a[Wb]=Vb;W=(c[B>>2]|0)+ -1|0;c[B>>2]=W;ba=c[h>>2]|0;ra=ba+12|0;qa=c[ra>>2]|0;if((qa|0)==(c[ba+16>>2]|0)){le[c[(c[ba>>2]|0)+40>>2]&127](ba)|0}else{c[ra>>2]=qa+1}if((W|0)>0){Kb=Pb;Lb=Qb;Mb=Ub}else{Xb=Ub;break}}}else{Xb=da}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ia=Xb;ja=yb;ka=zb;la=Ab;ma=S;na=Bb}break};default:{ia=D;ja=R;ka=r;la=Q;ma=S;na=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{Yb=Y;Zb=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){_b=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){_b=U;break}if((le[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;_b=0;break}else{_b=c[h>>2]|0;break}}}while(0);U=(_b|0)==0;do{if((Zb|0)==0){$b=Yb;X=37}else{if((c[Zb+12>>2]|0)!=(c[Zb+16>>2]|0)){if(U){ac=Yb;bc=Zb;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}if((le[c[(c[Zb>>2]|0)+36>>2]&127](Zb)|0)==-1){c[e>>2]=0;$b=0;X=37;break}else{if(U^(Yb|0)==0){ac=Yb;bc=Yb;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}else{ac=$b;bc=0}}ta=c[h>>2]|0;ib=c[ta+12>>2]|0;if((ib|0)==(c[ta+16>>2]|0)){cc=(le[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)&255}else{cc=a[ib]|0}if(!(cc<<24>>24>-1)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}if((b[(c[f>>2]|0)+(cc<<24>>24<<1)>>1]&8192)==0){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}ib=c[h>>2]|0;ta=ib+12|0;sa=c[ta>>2]|0;if((sa|0)==(c[ib+16>>2]|0)){dc=(le[c[(c[ib>>2]|0)+40>>2]&127](ib)|0)&255}else{c[ta>>2]=sa+1;dc=a[sa]|0}OU(A,dc);Yb=ac;Zb=bc}}}while(0);da=p+1|0;if(da>>>0<4){Q=la;r=ka;R=ja;D=ia;p=da;S=ma;T=na}else{Z=ja;_=ka;$=ma;aa=na;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;ec=0;fc=R;gc=T}else if((X|0)==182){O2()}else if((X|0)==198){O2()}else if((X|0)==209){O2()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==253){O2()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;ec=0;fc=yb;gc=Bb}else if((X|0)==269){h:do{if(($|0)!=0){na=$+1|0;ma=$+8|0;ka=$+4|0;ja=1;i:while(1){S=a[$]|0;if((S&1)==0){hc=(S&255)>>>1}else{hc=c[ka>>2]|0}if(!(ja>>>0<hc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){ic=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){ic=S;break}if((le[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;ic=0;break}else{ic=c[h>>2]|0;break}}}while(0);S=(ic|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((le[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){jc=(le[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{jc=a[p]|0}if((a[$]&1)==0){kc=na}else{kc=c[ma>>2]|0}if(!(jc<<24>>24==(a[kc+ja|0]|0))){break}p=ja+1|0;U=c[h>>2]|0;ia=U+12|0;D=c[ia>>2]|0;if((D|0)==(c[U+16>>2]|0)){le[c[(c[U>>2]|0)+40>>2]&127](U)|0;ja=p;continue}else{c[ia>>2]=D+1;ja=p;continue}}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa;break g}}while(0);if((Z|0)==(_|0)){ec=1;fc=_;gc=aa;break}c[C>>2]=0;s_(w,Z,_,C);if((c[C>>2]|0)==0){ec=1;fc=Z;gc=aa;break}c[k>>2]=c[k>>2]|4;ec=0;fc=Z;gc=aa}}while(0);wU(A);wU(z);wU(y);wU(x);wU(w);if((fc|0)==0){i=q;return ec|0}ie[gc&255](fc);i=q;return ec|0}function o_(a){a=a|0;var b=0;b=Gc(8)|0;UT(b,a);Wd(b|0,132864,43)}function p_(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=214;v=n+100|0;sV(q,h);n=q;w=c[n>>2]|0;if(!((c[33968]|0)==-1)){c[m>>2]=135872;c[m+4>>2]=212;c[m+8>>2]=0;hU(135872,m,213)}m=(c[135876>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Gc(4)|0;z=y;g2(z);A=151432;B=128;Wd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Gc(4)|0;z=y;g2(z);A=151432;B=128;Wd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=n_(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){OU(k,Ae[c[(c[w>>2]|0)+28>>2]&127](B,45)|0)}r=Ae[c[(c[w>>2]|0)+28>>2]&127](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);q_(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((le[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((le[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;OT(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ie[c[u>>2]&255](n);i=d;return}function q_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){RU(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}



function XV(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((Ae[c[(c[b>>2]|0)+52>>2]&127](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function YV(a,b){a=a|0;b=b|0;i=i;return-1}function ZV(a){a=a|0;var b=0;b=i;c[a>>2]=133208;e$(a+4|0);J2(a);i=b;return}function _V(a){a=a|0;var b=0;b=i;c[a>>2]=133208;e$(a+4|0);i=b;return}function $V(a,b){a=a|0;b=b|0;i=i;return}function aW(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function bW(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function cW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function dW(a){a=a|0;i=i;return 0}function eW(a){a=a|0;i=i;return 0}function fW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=le[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function gW(a){a=a|0;i=i;return-1}function hW(a){a=a|0;var b=0,d=0,e=0;b=i;if((le[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function iW(a,b){a=a|0;b=b|0;i=i;return-1}function jW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((Ae[c[(c[a>>2]|0)+52>>2]&127](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function kW(a,b){a=a|0;b=b|0;i=i;return-1}function lW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c$(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function mW(a){a=a|0;var b=0;b=i;lV(a+8|0);J2(a);i=b;return}function nW(a){a=a|0;var b=0;b=i;lV(a+8|0);i=b;return}function oW(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;lV(a+(d+8)|0);J2(a+d|0);i=b;return}function pW(a){a=a|0;var b=0;b=i;lV(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function qW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;rW(a,b,c);i=d;return}function rW(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){jV(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){sW(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}d$(h,e+(k+28)|0);k=g$(h,135872)|0;e$(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(le[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(le[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){le[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((le[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;jV(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function sW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{sW(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((le[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;jV(b+h|0,c[b+(h+16)>>2]|1)}}while(0);HW(e);i=d;return b|0}function tW(b){b=b|0;i=i;return(a[b]|0)!=0|0}function uW(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Gb()}}function vW(a){a=a|0;var b=0;b=i;lV(a+8|0);J2(a);i=b;return}function wW(a){a=a|0;var b=0;b=i;lV(a+8|0);i=b;return}function xW(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;lV(a+(d+8)|0);J2(a+d|0);i=b;return}function yW(a){a=a|0;var b=0;b=i;lV(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function zW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{zW(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((le[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;jV(b+h|0,c[b+(h+16)>>2]|1)}}while(0);TW(e);i=d;return b|0}function AW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));c$(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function BW(a){a=a|0;var b=0;b=i;lV(a+4|0);J2(a);i=b;return}function CW(a){a=a|0;var b=0;b=i;lV(a+4|0);i=b;return}function DW(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;lV(a+(d+4)|0);J2(a+d|0);i=b;return}function EW(a){a=a|0;var b=0;b=i;lV(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function FW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){sW(g)|0}a[f]=1;i=e;return}function GW(a){a=a|0;var b=0;b=i;HW(a);i=b;return}function HW(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(eb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((le[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;jV(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function IW(b){b=b|0;i=i;return(a[b]|0)!=0|0}function JW(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=le[b&127](a)|0;i=c;return d|0}function KW(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){HW(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{sW(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;d$(k,b+(p+28)|0);p=g$(k,134592)|0;m=p;e$(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){d$(h,b+(k+28)|0);r=g$(h,135872)|0;s=Ae[c[(c[r>>2]|0)+28>>2]&127](r,32)|0;e$(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];re[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){HW(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;jV(b+l|0,c[b+(l+16)>>2]|5);HW(j);i=e;return b|0}function LW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){HW(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{sW(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;HW(f);i=e;return b|0}if((Ae[c[(c[g>>2]|0)+52>>2]&127](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{HW(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;jV(b+d|0,c[b+(d+16)>>2]|1);HW(f);i=e;return b|0}function MW(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){HW(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){sW(k)|0}a[h]=1;if((e|0)==0){HW(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((oe[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){HW(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;jV(b+e|0,c[b+(e+16)>>2]|1);HW(g);i=f;return b|0}function NW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;ue[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function OW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){HW(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{sW(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Le[l&63](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){HW(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;jV(b+f|0,c[b+(f+16)>>2]|4);HW(h);i=e;return b|0}function PW(a){a=a|0;var b=0;b=i;lV(a+4|0);J2(a);i=b;return}function QW(a){a=a|0;var b=0;b=i;lV(a+4|0);i=b;return}function RW(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;lV(a+(d+4)|0);J2(a+d|0);i=b;return}function SW(a){a=a|0;var b=0;b=i;lV(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function TW(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(eb()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((le[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;jV(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function UW(a){a=a|0;i=i;return 133424}function VW(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){oU(a,133440,35);i=d;return}else{cU(a,b,c);i=d;return}}function WW(a){a=a|0;i=i;return}function XW(a){a=a|0;var b=0;b=i;gU(a);J2(a);i=b;return}function YW(a){a=a|0;var b=0;b=i;gU(a);i=b;return}function ZW(a){a=a|0;var b=0;b=i;lV(a);J2(a);i=b;return}function _W(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function $W(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function aX(a){a=a|0;i=i;return}function bX(a){a=a|0;i=i;return}function cX(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function dX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){iU(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=H2(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function eX(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function fX(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function gX(a){a=a|0;i=i;return}function hX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function iX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){iU(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=H2(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function jX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function kX(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function lX(a){a=a|0;i=i;return}function mX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];xe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}sV(u,g);m=u;u=c[m>>2]|0;if(!((c[33968]|0)==-1)){c[p>>2]=135872;c[p+4>>2]=212;c[p+8>>2]=0;hU(135872,p,213)}p=(c[135876>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Gc(4)|0;D=C;g2(D);E=151432;F=128;Wd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Gc(4)|0;D=C;g2(D);E=151432;F=128;Wd(C|0,E|0,F|0)}F=u;OT(c[m>>2]|0)|0;sV(v,g);g=v;v=c[g>>2]|0;if(!((c[34004]|0)==-1)){c[o>>2]=136016;c[o+4>>2]=212;c[o+8>>2]=0;hU(136016,o,213)}o=(c[136020>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Gc(4)|0;H=G;g2(H);I=151432;J=128;Wd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Gc(4)|0;H=G;g2(H);I=151432;J=128;Wd(G|0,I|0,J|0)}J=v;OT(c[g>>2]|0)|0;g=w;je[c[(c[v>>2]|0)+24>>2]&127](g,J);je[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=nX(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];wU(w+12|0);wU(w);i=k;return}function nX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=B2(l)|0;if((n|0)!=0){o=n;p=n;break}O2()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((le[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((le[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(le[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=Ae[c[(c[g>>2]|0)+12>>2]&127](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(Ae[c[(c[g>>2]|0)+12>>2]&127](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){le[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((le[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((le[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}C2(o);i=k;return _|0}function oX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pX(a,0,k,j,f,g,h);i=b;return}function pX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;fY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((le[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((le[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}FU(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}FU(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(le[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((HX(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=b1(F,c[o>>2]|0,h,t)|0;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((le[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}function qX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];rX(a,0,k,j,f,g,h);i=b;return}function rX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;fY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((le[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((le[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}FU(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}FU(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(le[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((HX(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=a1(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((le[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;wU(n);wU(m);i=d;return}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;wU(n);wU(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;wU(n);wU(m);i=d;return}function sX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];tX(a,0,k,j,f,g,h);i=b;return}function tX(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==64){u=8}else if((t|0)==8){u=16}else{u=10}t=l;fY(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;FU(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((le[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((le[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}FU(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}FU(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(le[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((HX(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){le[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=$0(G,c[p>>2]|0,j,u)|0;s_(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((le[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;wU(o);wU(n);i=e;return}if((le[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;wU(o);wU(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;wU(o);wU(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;wU(o);wU(n);i=e;return}function uX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];vX(a,0,k,j,f,g,h);i=b;return}function vX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;fY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((le[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((le[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}FU(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}FU(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(le[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((HX(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=_0(F,c[o>>2]|0,h,t)|0;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((le[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}function wX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];xX(a,0,k,j,f,g,h);i=b;return}function xX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;fY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((le[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((le[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}FU(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}FU(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(le[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((HX(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=Z0(F,c[o>>2]|0,h,t)|0;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((le[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;wU(n);wU(m);i=d;return}function yX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];zX(a,0,k,j,f,g,h);i=b;return}function zX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;fY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((le[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((le[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}FU(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}FU(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(le[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((HX(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=Y0(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((le[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;wU(n);wU(m);i=d;return}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;wU(n);wU(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;wU(n);wU(m);i=d;return}function AX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];BX(a,0,k,j,f,g,h);i=b;return}function BX(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;gY(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;FU(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((le[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}FU(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}FU(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(le[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((hY(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){le[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+X0(I,c[p>>2]|0,j);s_(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((le[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}if((le[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}function CX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];DX(a,0,k,j,f,g,h);i=b;return}function DX(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;gY(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((le[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}FU(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}FU(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(le[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((hY(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){le[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+W0(I,c[p>>2]|0,j);s_(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((le[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}if((le[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}function EX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];FX(a,0,k,j,f,g,h);i=b;return}function FX(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;gY(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((le[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((le[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}FU(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}FU(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(le[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((hY(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){le[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+V0(I,c[p>>2]|0,j);s_(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((le[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}if((le[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;wU(o);wU(n);i=d;return}function GX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sV(o,g);g=o;o=c[g>>2]|0;if(!((c[33968]|0)==-1)){c[l>>2]=135872;c[l+4>>2]=212;c[l+8>>2]=0;hU(135872,l,213)}l=(c[135876>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}y=m;Ke[c[(c[o>>2]|0)+32>>2]&63](o,134416,134442|0,y)|0;OT(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((le[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((le[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}FU(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}FU(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(le[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((HX(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){le[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);K=c[33940]|0;c[k>>2]=j;if((IX(E,K,134456,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((le[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;wU(p);wU(n);i=d;return}if((le[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;wU(p);wU(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;wU(p);wU(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;wU(p);wU(n);i=d;return}function HX(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[134416+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[134416+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function IX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Nc(b|0)|0;b=Ya(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Nc(e|0)|0;i=f;return b|0}function JX(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function KX(a){a=a|0;i=i;return}function LX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];xe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}sV(u,g);m=u;u=c[m>>2]|0;if(!((c[33966]|0)==-1)){c[p>>2]=135864;c[p+4>>2]=212;c[p+8>>2]=0;hU(135864,p,213)}p=(c[135868>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Gc(4)|0;D=C;g2(D);E=151432;F=128;Wd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Gc(4)|0;D=C;g2(D);E=151432;F=128;Wd(C|0,E|0,F|0)}F=u;OT(c[m>>2]|0)|0;sV(v,g);g=v;v=c[g>>2]|0;if(!((c[34006]|0)==-1)){c[o>>2]=136024;c[o+4>>2]=212;c[o+8>>2]=0;hU(136024,o,213)}o=(c[136028>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Gc(4)|0;H=G;g2(H);I=151432;J=128;Wd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Gc(4)|0;H=G;g2(H);I=151432;J=128;Wd(G|0,I|0,J|0)}J=v;OT(c[g>>2]|0)|0;g=w;je[c[(c[v>>2]|0)+24>>2]&127](g,J);je[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=MX(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];_U(w+12|0);_U(w);i=k;return}function MX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=B2(l)|0;if((n|0)!=0){o=n;p=n;break}O2()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=le[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=le[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=Ae[c[(c[g>>2]|0)+28>>2]&127](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(Ae[c[(c[g>>2]|0)+28>>2]&127](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){le[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}C2(o);i=k;return ba|0}function NX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];OX(a,0,k,j,f,g,h);i=b;return}function OX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;iY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=le[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=le[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}FU(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}FU(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((eY(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=b1(I,c[o>>2]|0,h,t)|0;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=le[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}function PX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];QX(a,0,k,j,f,g,h);i=b;return}function QX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;iY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=le[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=le[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}FU(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}FU(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((eY(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=a1(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=le[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;wU(n);wU(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;wU(n);wU(m);i=d;return}function RX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];SX(a,0,k,j,f,g,h);i=b;return}function SX(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==8){u=16}else if((t|0)==0){u=0}else{u=10}t=l;iY(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;FU(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=le[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=le[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}FU(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}FU(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=le[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((eY(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){le[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=$0(J,c[p>>2]|0,j,u)|0;s_(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=le[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=le[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;wU(o);wU(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;wU(o);wU(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;wU(o);wU(n);i=e;return}function TX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];UX(a,0,k,j,f,g,h);i=b;return}function UX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;iY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=le[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=le[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}FU(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}FU(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((eY(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=_0(I,c[o>>2]|0,h,t)|0;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=le[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}function VX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];WX(a,0,k,j,f,g,h);i=b;return}function WX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;iY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=le[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=le[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}FU(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}FU(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((eY(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=Z0(I,c[o>>2]|0,h,t)|0;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=le[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;wU(n);wU(m);i=d;return}function XX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];YX(a,0,k,j,f,g,h);i=b;return}function YX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;iY(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=le[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=le[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}FU(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}FU(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((eY(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){le[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=Y0(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;s_(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=le[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=le[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;wU(n);wU(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;wU(n);wU(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;wU(n);wU(m);i=d;return}function ZX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_X(a,0,k,j,f,g,h);i=b;return}function _X(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;jY(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;FU(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=le[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=le[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}FU(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}FU(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((kY(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){le[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+X0(L,c[p>>2]|0,j);s_(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=le[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}function $X(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];aY(a,0,k,j,f,g,h);i=b;return}function aY(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;jY(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=le[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=le[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}FU(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}FU(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((kY(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){le[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+W0(L,c[p>>2]|0,j);s_(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=le[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}function bY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];cY(a,0,k,j,f,g,h);i=b;return}function cY(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;jY(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=le[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=le[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}FU(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}FU(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((kY(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){le[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+V0(L,c[p>>2]|0,j);s_(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=le[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=le[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;wU(o);wU(n);i=d;return}function dY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sV(o,g);g=o;o=c[g>>2]|0;if(!((c[33966]|0)==-1)){c[l>>2]=135864;c[l+4>>2]=212;c[l+8>>2]=0;hU(135864,l,213)}l=(c[135868>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Gc(4)|0;w=v;g2(w);x=151432;y=128;Wd(v|0,x|0,y|0)}y=m;Ke[c[(c[o>>2]|0)+48>>2]&63](o,134416,134442|0,y)|0;OT(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;FU(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=le[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=le[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}FU(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}FU(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=le[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((eY(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){le[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);N=c[33940]|0;c[k>>2]=j;if((IX(H,N,134456,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=le[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=le[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;wU(p);wU(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;wU(p);wU(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;wU(p);wU(n);i=d;return}function eY(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[134416+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[134416+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function fY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;sV(k,d);d=k;k=c[d>>2]|0;if(!((c[33968]|0)==-1)){c[j>>2]=135872;c[j+4>>2]=212;c[j+8>>2]=0;hU(135872,j,213)}j=(c[135876>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Gc(4)|0;n=m;g2(n);o=151432;p=128;Wd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Gc(4)|0;n=m;g2(n);o=151432;p=128;Wd(m|0,o|0,p|0)}Ke[c[(c[k>>2]|0)+32>>2]&63](k,134416,134442|0,e)|0;e=c[d>>2]|0;if(!((c[34004]|0)==-1)){c[h>>2]=136016;c[h+4>>2]=212;c[h+8>>2]=0;hU(136016,h,213)}h=(c[136020>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}else{t=e;a[f]=le[c[(c[e>>2]|0)+16>>2]&127](t)|0;je[c[(c[e>>2]|0)+20>>2]&127](b,t);OT(c[d>>2]|0)|0;i=g;return}}function gY(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;sV(l,d);d=l;l=c[d>>2]|0;if(!((c[33968]|0)==-1)){c[k>>2]=135872;c[k+4>>2]=212;c[k+8>>2]=0;hU(135872,k,213)}k=(c[135876>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Gc(4)|0;o=n;g2(o);p=151432;q=128;Wd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Gc(4)|0;o=n;g2(o);p=151432;q=128;Wd(n|0,p|0,q|0)}Ke[c[(c[l>>2]|0)+32>>2]&63](l,134416,134448|0,e)|0;e=c[d>>2]|0;if(!((c[34004]|0)==-1)){c[j>>2]=136016;c[j+4>>2]=212;c[j+8>>2]=0;hU(136016,j,213)}j=(c[136020>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Gc(4)|0;s=r;g2(s);t=151432;u=128;Wd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Gc(4)|0;s=r;g2(s);t=151432;u=128;Wd(r|0,t|0,u|0)}else{u=e;a[f]=le[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=le[c[(c[e>>2]|0)+16>>2]&127](u)|0;je[c[(c[e>>2]|0)+20>>2]&127](b,u);OT(c[d>>2]|0)|0;i=h;return}}function hY(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[134416+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function iY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;sV(j,b);b=j;j=c[b>>2]|0;if(!((c[33966]|0)==-1)){c[h>>2]=135864;c[h+4>>2]=212;c[h+8>>2]=0;hU(135864,h,213)}h=(c[135868>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Gc(4)|0;m=l;g2(m);n=151432;o=128;Wd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Gc(4)|0;m=l;g2(m);n=151432;o=128;Wd(l|0,n|0,o|0)}Ke[c[(c[j>>2]|0)+48>>2]&63](j,134416,134442|0,d)|0;d=c[b>>2]|0;if(!((c[34006]|0)==-1)){c[g>>2]=136024;c[g+4>>2]=212;c[g+8>>2]=0;hU(136024,g,213)}g=(c[136028>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Gc(4)|0;q=p;g2(q);r=151432;s=128;Wd(p|0,r|0,s|0)}else{s=d;c[e>>2]=le[c[(c[d>>2]|0)+16>>2]&127](s)|0;je[c[(c[d>>2]|0)+20>>2]&127](a,s);OT(c[b>>2]|0)|0;i=f;return}}function jY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;sV(k,b);b=k;k=c[b>>2]|0;if(!((c[33966]|0)==-1)){c[j>>2]=135864;c[j+4>>2]=212;c[j+8>>2]=0;hU(135864,j,213)}j=(c[135868>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Gc(4)|0;n=m;g2(n);o=151432;p=128;Wd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Gc(4)|0;n=m;g2(n);o=151432;p=128;Wd(m|0,o|0,p|0)}Ke[c[(c[k>>2]|0)+48>>2]&63](k,134416,134448|0,d)|0;d=c[b>>2]|0;if(!((c[34006]|0)==-1)){c[h>>2]=136024;c[h+4>>2]=212;c[h+8>>2]=0;hU(136024,h,213)}h=(c[136028>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}else{t=d;c[e>>2]=le[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=le[c[(c[d>>2]|0)+16>>2]&127](t)|0;je[c[(c[d>>2]|0)+20>>2]&127](a,t);OT(c[b>>2]|0)|0;i=g;return}}function kY(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[134416+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function lY(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function mY(a){a=a|0;i=i;return}function nY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];ue[p&31](b,d,k,f,g,q);i=j;return}sV(n,f);f=n;n=c[f>>2]|0;if(!((c[34004]|0)==-1)){c[l>>2]=136016;c[l+4>>2]=212;c[l+8>>2]=0;hU(136016,l,213)}l=(c[136020>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Gc(4)|0;u=t;g2(u);v=151432;w=128;Wd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Gc(4)|0;u=t;g2(u);v=151432;w=128;Wd(t|0,v|0,w|0)}w=n;OT(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){je[c[f+24>>2]&127](o,w)}else{je[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((Ae[c[(c[n>>2]|0)+52>>2]&127](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];wU(o);i=j;return}function oY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=134664;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);v=c[33940]|0;c[k>>2]=h;h=pY(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;sV(q,f);qY(w,y,k,z,o,p,q);OT(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];UQ(b,j,z,e,o,f,g);i=d;return}function pY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Nc(d|0)|0;d=$c(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Nc(f|0)|0;i=g;return d|0}function qY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[33968]|0)==-1)){c[m>>2]=135872;c[m+4>>2]=212;c[m+8>>2]=0;hU(135872,m,213)}m=(c[135876>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Gc(4)|0;r=q;g2(r);s=151432;t=128;Wd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[34004]|0)==-1)){c[l>>2]=136016;c[l+4>>2]=212;c[l+8>>2]=0;hU(136016,l,213)}l=(c[136020>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Gc(4)|0;v=u;g2(v);w=151432;x=128;Wd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Gc(4)|0;v=u;g2(v);w=151432;x=128;Wd(u|0,w|0,x|0)}x=s;je[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ke[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=Ae[c[(c[j>>2]|0)+28>>2]&127](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=Ae[c[(c[j>>2]|0)+28>>2]&127](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=Ae[c[(c[j>>2]|0)+28>>2]&127](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=le[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=Ae[c[(c[j>>2]|0)+28>>2]&127](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;wU(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;wU(n);i=k;return}}function rY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);y=c[33940]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=pY(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;sV(r,f);qY(x,z,l,A,p,q,r);OT(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];UQ(b,k,A,e,p,f,g);i=d;return}



function r_(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[33828]|0)==-1)){c[p>>2]=135312;c[p+4>>2]=212;c[p+8>>2]=0;hU(135312,p,213)}p=(c[135316>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Gc(4)|0;C=B;g2(C);D=151432;E=128;Wd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Gc(4)|0;C=B;g2(C);D=151432;E=128;Wd(B|0,D|0,E|0)}E=b;je[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;je[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}IU(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;wU(r);je[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}IU(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;wU(s);a[f]=le[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=le[c[(c[b>>2]|0)+16>>2]&127](E)|0;je[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}IU(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;wU(t);je[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}IU(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;wU(u);F=le[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[33812]|0)==-1)){c[o>>2]=135248;c[o+4>>2]=212;c[o+8>>2]=0;hU(135248,o,213)}o=(c[135252>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Gc(4)|0;H=G;g2(H);I=151432;J=128;Wd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Gc(4)|0;H=G;g2(H);I=151432;J=128;Wd(G|0,I|0,J|0)}J=E;je[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;je[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}IU(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;wU(w);je[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}IU(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;wU(x);a[f]=le[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=le[c[(c[E>>2]|0)+16>>2]&127](J)|0;je[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}IU(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;wU(y);je[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}IU(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;wU(z);F=le[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function s_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function t_(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function u_(a){a=a|0;i=i;return}function v_(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=214;y=o+400|0;sV(r,h);o=r;z=c[o>>2]|0;if(!((c[33966]|0)==-1)){c[n>>2]=135864;c[n+4>>2]=212;c[n+8>>2]=0;hU(135864,n,213)}n=(c[135868>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Gc(4)|0;C=B;g2(C);D=151432;E=128;Wd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Gc(4)|0;C=B;g2(C);D=151432;E=128;Wd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=w_(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ke[c[(c[z>>2]|0)+48>>2]&63](E,135568,135578|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=B2((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}O2()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[135568+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Ad(p|0,135504,m|0)|0)!=1){t=Gc(8)|0;UT(t,135512);Wd(t|0,132864,43)}if((F|0)==0){break}C2(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=le[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=le[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];OT(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ie[c[x>>2]&255](o);i=d;return}function w_(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;z_(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=214;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=le[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=le[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 3:{P=a[y]|0;R=(P&1)==0;if(R){_=(P&255)>>>1}else{_=c[D>>2]|0}$=a[z]|0;aa=($&1)==0;if(aa){ba=($&255)>>>1}else{ba=c[e>>2]|0}if((_|0)==(0-ba|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}if(R){ha=(P&255)>>>1}else{ha=c[D>>2]|0}do{if((ha|0)!=0){if(aa){ia=($&255)>>>1}else{ia=c[e>>2]|0}if((ia|0)==0){break}ja=c[g>>2]|0;ka=c[ja+12>>2]|0;if((ka|0)==(c[ja+16>>2]|0)){la=le[c[(c[ja>>2]|0)+36>>2]&127](ja)|0;ma=la;na=a[y]|0}else{ma=c[ka>>2]|0;na=P}ka=c[g>>2]|0;la=ka+12|0;ja=c[la>>2]|0;oa=(ja|0)==(c[ka+16>>2]|0);if((ma|0)==(c[((na&1)==0?D:c[E>>2]|0)>>2]|0)){if(oa){le[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[la>>2]=ja+4}la=a[y]|0;if((la&1)==0){pa=(la&255)>>>1}else{pa=c[D>>2]|0}ca=M;da=r;ea=L;fa=pa>>>0>1?y:N;ga=O;break b}if(oa){qa=le[c[(c[ka>>2]|0)+36>>2]&127](ka)|0}else{qa=c[ja>>2]|0}if((qa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}ja=c[g>>2]|0;ka=ja+12|0;oa=c[ka>>2]|0;if((oa|0)==(c[ja+16>>2]|0)){le[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[ka>>2]=oa+4}a[k]=1;oa=a[z]|0;if((oa&1)==0){ra=(oa&255)>>>1}else{ra=c[e>>2]|0}ca=M;da=r;ea=L;fa=ra>>>0>1?z:N;ga=O;break b}}while(0);if(R){sa=(P&255)>>>1}else{sa=c[D>>2]|0}aa=c[g>>2]|0;oa=c[aa+12>>2]|0;ka=(oa|0)==(c[aa+16>>2]|0);if((sa|0)==0){if(ka){ja=le[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;ta=ja;ua=a[z]|0}else{ta=c[oa>>2]|0;ua=$}if((ta|0)!=(c[((ua&1)==0?e:c[f>>2]|0)>>2]|0)){ca=M;da=r;ea=L;fa=N;ga=O;break b}ja=c[g>>2]|0;la=ja+12|0;va=c[la>>2]|0;if((va|0)==(c[ja+16>>2]|0)){le[c[(c[ja>>2]|0)+40>>2]&127](ja)|0}else{c[la>>2]=va+4}a[k]=1;va=a[z]|0;if((va&1)==0){wa=(va&255)>>>1}else{wa=c[e>>2]|0}ca=M;da=r;ea=L;fa=wa>>>0>1?z:N;ga=O;break b}if(ka){ka=le[c[(c[aa>>2]|0)+36>>2]&127](aa)|0;xa=ka;ya=a[y]|0}else{xa=c[oa>>2]|0;ya=P}if((xa|0)!=(c[((ya&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ca=M;da=r;ea=L;fa=N;ga=O;break b}oa=c[g>>2]|0;ka=oa+12|0;aa=c[ka>>2]|0;if((aa|0)==(c[oa+16>>2]|0)){le[c[(c[oa>>2]|0)+40>>2]&127](oa)|0}else{c[ka>>2]=aa+4}aa=a[y]|0;if((aa&1)==0){za=(aa&255)>>>1}else{za=c[D>>2]|0}ca=M;da=r;ea=L;fa=za>>>0>1?y:N;ga=O;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}aa=c[g>>2]|0;ka=c[aa+12>>2]|0;if((ka|0)==(c[aa+16>>2]|0)){Aa=le[c[(c[aa>>2]|0)+36>>2]&127](aa)|0}else{Aa=c[ka>>2]|0}if(!(oe[c[(c[l>>2]|0)+12>>2]&63](l,8192,Aa)|0)){T=27;break a}ka=c[g>>2]|0;aa=ka+12|0;oa=c[aa>>2]|0;if((oa|0)==(c[ka+16>>2]|0)){Ba=le[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[aa>>2]=oa+4;Ba=c[oa>>2]|0}cV(A,Ba);T=28;break};case 4:{oa=M;aa=r;ka=L;va=0;la=O;c:while(1){ja=c[g>>2]|0;do{if((ja|0)==0){Ca=1}else{Da=c[ja+12>>2]|0;if((Da|0)==(c[ja+16>>2]|0)){Ea=le[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Ea=c[Da>>2]|0}if((Ea|0)==-1){c[g>>2]=0;Ca=1;break}else{Ca=(c[g>>2]|0)==0;break}}}while(0);ja=c[b>>2]|0;do{if((ja|0)==0){T=188}else{Da=c[ja+12>>2]|0;if((Da|0)==(c[ja+16>>2]|0)){Fa=le[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Fa=c[Da>>2]|0}if((Fa|0)==-1){c[b>>2]=0;T=188;break}else{if(Ca){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(Ca){break}}ja=c[g>>2]|0;Da=c[ja+12>>2]|0;if((Da|0)==(c[ja+16>>2]|0)){Ga=le[c[(c[ja>>2]|0)+36>>2]&127](ja)|0}else{Ga=c[Da>>2]|0}if(oe[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ga)|0){Da=c[n>>2]|0;if((Da|0)==(c[q>>2]|0)){A_(m,n,q);Ha=c[n>>2]|0}else{Ha=Da}c[n>>2]=Ha+4;c[Ha>>2]=Ga;Ia=oa;Ja=aa;Ka=ka;La=va+1|0;Ma=la}else{Da=a[w]|0;if((Da&1)==0){Na=(Da&255)>>>1}else{Na=c[K>>2]|0}if((Na|0)==0|(va|0)==0){break}if((Ga|0)!=(c[v>>2]|0)){break}if((aa|0)==(ka|0)){Da=aa-oa|0;ja=Da>>>0<2147483647?Da<<1:-1;if((la|0)!=214){Oa=oa}else{Oa=0}Pa=E2(Oa,ja)|0;if((Pa|0)==0){T=206;break a}Qa=Pa;Ra=Pa+(Da>>2<<2)|0;Sa=Pa+(ja>>>2<<2)|0;Ta=189}else{Qa=oa;Ra=aa;Sa=ka;Ta=la}c[Ra>>2]=va;Ia=Qa;Ja=Ra+4|0;Ka=Sa;La=0;Ma=Ta}ja=c[g>>2]|0;Pa=ja+12|0;Da=c[Pa>>2]|0;if((Da|0)==(c[ja+16>>2]|0)){le[c[(c[ja>>2]|0)+40>>2]&127](ja)|0;oa=Ia;aa=Ja;ka=Ka;va=La;la=Ma;continue}else{c[Pa>>2]=Da+4;oa=Ia;aa=Ja;ka=Ka;va=La;la=Ma;continue}}if((oa|0)==(aa|0)|(va|0)==0){Ua=oa;Va=aa;Wa=ka;Xa=la}else{if((aa|0)==(ka|0)){P=aa-oa|0;$=P>>>0<2147483647?P<<1:-1;if((la|0)!=214){Ya=oa}else{Ya=0}R=E2(Ya,$)|0;if((R|0)==0){T=217;break a}Za=R;_a=R+(P>>2<<2)|0;$a=R+($>>>2<<2)|0;ab=189}else{Za=oa;_a=aa;$a=ka;ab=la}c[_a>>2]=va;Ua=Za;Va=_a+4|0;Wa=$a;Xa=ab}$=c[B>>2]|0;if(($|0)>0){R=c[g>>2]|0;do{if((R|0)==0){bb=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){cb=le[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{cb=c[P>>2]|0}if((cb|0)==-1){c[g>>2]=0;bb=1;break}else{bb=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=234}else{va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){db=le[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{db=c[va>>2]|0}if((db|0)==-1){c[b>>2]=0;T=234;break}else{if(bb){eb=R;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(bb){T=240;break a}else{eb=0}}R=c[g>>2]|0;va=c[R+12>>2]|0;if((va|0)==(c[R+16>>2]|0)){fb=le[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{fb=c[va>>2]|0}if((fb|0)!=(c[u>>2]|0)){T=240;break a}va=c[g>>2]|0;R=va+12|0;la=c[R>>2]|0;if((la|0)==(c[va+16>>2]|0)){le[c[(c[va>>2]|0)+40>>2]&127](va)|0;gb=eb;hb=$;ib=eb}else{c[R>>2]=la+4;gb=eb;hb=$;ib=eb}while(1){la=c[g>>2]|0;do{if((la|0)==0){jb=1}else{R=c[la+12>>2]|0;if((R|0)==(c[la+16>>2]|0)){kb=le[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{kb=c[R>>2]|0}if((kb|0)==-1){c[g>>2]=0;jb=1;break}else{jb=(c[g>>2]|0)==0;break}}}while(0);do{if((ib|0)==0){lb=gb;T=257}else{la=c[ib+12>>2]|0;if((la|0)==(c[ib+16>>2]|0)){mb=le[c[(c[ib>>2]|0)+36>>2]&127](ib)|0}else{mb=c[la>>2]|0}if((mb|0)==-1){c[b>>2]=0;lb=0;T=257;break}else{if(jb^(gb|0)==0){nb=gb;ob=gb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(jb){T=263;break a}else{nb=lb;ob=0}}la=c[g>>2]|0;R=c[la+12>>2]|0;if((R|0)==(c[la+16>>2]|0)){pb=le[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{pb=c[R>>2]|0}if(!(oe[c[(c[l>>2]|0)+12>>2]&63](l,2048,pb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){A_(m,n,q)}R=c[g>>2]|0;la=c[R+12>>2]|0;if((la|0)==(c[R+16>>2]|0)){qb=le[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{qb=c[la>>2]|0}la=c[n>>2]|0;c[n>>2]=la+4;c[la>>2]=qb;la=hb+ -1|0;c[B>>2]=la;R=c[g>>2]|0;va=R+12|0;ka=c[va>>2]|0;if((ka|0)==(c[R+16>>2]|0)){le[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[va>>2]=ka+4}if((la|0)>0){gb=nb;hb=la;ib=ob}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ca=Ua;da=Va;ea=Wa;fa=N;ga=Xa}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){rb=(a[J]|0)!=0}else{rb=0}if(!(F|rb)){ca=M;da=r;ea=L;fa=0;ga=O;break b}}$=a[x]|0;la=($&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){sb=V;tb=V;ub=$;vb=la}else{if((d[s+(o+ -1)|0]|0)<2){wb=$;xb=la}else{sb=V;tb=V;ub=$;vb=la;break}while(1){if((wb&1)==0){yb=h;zb=(wb&255)>>>1}else{yb=c[G>>2]|0;zb=c[h>>2]|0}if((xb|0)==(yb+(zb<<2)|0)){Ab=wb;break}if(!(oe[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[xb>>2]|0)|0)){T=129;break}wb=a[x]|0;xb=xb+4|0}if((T|0)==129){T=0;Ab=a[x]|0}ka=(Ab&1)==0;va=xb-(ka?h:c[G>>2]|0)>>2;R=a[A]|0;aa=(R&1)==0;if(aa){Bb=(R&255)>>>1}else{Bb=c[H>>2]|0}e:do{if(!(va>>>0>Bb>>>0)){if(aa){Cb=H+(((R&255)>>>1)-va<<2)|0;Db=H;Eb=(R&255)>>>1}else{oa=c[I>>2]|0;P=c[H>>2]|0;Cb=oa+(P-va<<2)|0;Db=oa;Eb=P}P=Db+(Eb<<2)|0;if((Cb|0)==(P|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}else{Fb=ka?h:c[G>>2]|0;Gb=Cb}while(1){if((c[Gb>>2]|0)!=(c[Fb>>2]|0)){break e}oa=Gb+4|0;if((oa|0)==(P|0)){sb=V;tb=V;ub=Ab;vb=xb;break d}Fb=Fb+4|0;Gb=oa}}}while(0);sb=V;tb=V;ub=Ab;vb=ka?h:c[G>>2]|0}}while(0);f:while(1){if((ub&1)==0){Hb=h;Ib=(ub&255)>>>1}else{Hb=c[G>>2]|0;Ib=c[h>>2]|0}if((vb|0)==(Hb+(Ib<<2)|0)){break}la=c[g>>2]|0;do{if((la|0)==0){Jb=1}else{$=c[la+12>>2]|0;if(($|0)==(c[la+16>>2]|0)){Kb=le[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Kb=c[$>>2]|0}if((Kb|0)==-1){c[g>>2]=0;Jb=1;break}else{Jb=(c[g>>2]|0)==0;break}}}while(0);do{if((tb|0)==0){Lb=sb;T=159}else{la=c[tb+12>>2]|0;if((la|0)==(c[tb+16>>2]|0)){Mb=le[c[(c[tb>>2]|0)+36>>2]&127](tb)|0}else{Mb=c[la>>2]|0}if((Mb|0)==-1){c[b>>2]=0;Lb=0;T=159;break}else{if(Jb^(sb|0)==0){Nb=sb;Ob=sb;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(Jb){break}else{Nb=Lb;Ob=0}}la=c[g>>2]|0;ka=c[la+12>>2]|0;if((ka|0)==(c[la+16>>2]|0)){Pb=le[c[(c[la>>2]|0)+36>>2]&127](la)|0}else{Pb=c[ka>>2]|0}if((Pb|0)!=(c[vb>>2]|0)){break}ka=c[g>>2]|0;la=ka+12|0;$=c[la>>2]|0;if(($|0)==(c[ka+16>>2]|0)){le[c[(c[ka>>2]|0)+40>>2]&127](ka)|0}else{c[la>>2]=$+4}sb=Nb;tb=Ob;ub=a[x]|0;vb=vb+4|0}if(!F){ca=M;da=r;ea=L;fa=N;ga=O;break b}$=a[x]|0;if(($&1)==0){Qb=h;Rb=($&255)>>>1}else{Qb=c[G>>2]|0;Rb=c[h>>2]|0}if((vb|0)==(Qb+(Rb<<2)|0)){ca=M;da=r;ea=L;fa=N;ga=O}else{T=174;break a}break};case 0:{T=28;break};default:{ca=M;da=r;ea=L;fa=N;ga=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){$=c[g>>2]|0;do{if(($|0)==0){Ub=1}else{la=c[$+12>>2]|0;if((la|0)==(c[$+16>>2]|0)){Vb=le[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{Vb=c[la>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{$=c[Tb+12>>2]|0;if(($|0)==(c[Tb+16>>2]|0)){Xb=le[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[$>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ca=M;da=r;ea=L;fa=N;ga=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ca=M;da=r;ea=L;fa=N;ga=O;break g}else{Yb=Wb;Zb=0}}$=c[g>>2]|0;la=c[$+12>>2]|0;if((la|0)==(c[$+16>>2]|0)){_b=le[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{_b=c[la>>2]|0}if(!(oe[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ca=M;da=r;ea=L;fa=N;ga=O;break g}la=c[g>>2]|0;$=la+12|0;ka=c[$>>2]|0;if((ka|0)==(c[la+16>>2]|0)){$b=le[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[$>>2]=ka+4;$b=c[ka>>2]|0}cV(A,$b);Sb=Yb;Tb=Zb}}}while(0);ka=o+1|0;if(ka>>>0<4){L=ea;r=da;M=ca;o=ka;N=fa;O=ga}else{W=ca;X=da;Y=fa;Z=ga;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){O2()}else if((T|0)==217){O2()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=Ua;cc=Xa}else if((T|0)==276){i:do{if((Y|0)!=0){ga=Y+4|0;fa=Y+8|0;da=1;j:while(1){ca=a[Y]|0;if((ca&1)==0){dc=(ca&255)>>>1}else{dc=c[ga>>2]|0}if(!(da>>>0<dc>>>0)){break i}ca=c[g>>2]|0;do{if((ca|0)==0){ec=1}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){fc=le[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ca=c[b>>2]|0;do{if((ca|0)==0){T=295}else{N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){gc=le[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ca=c[g>>2]|0;N=c[ca+12>>2]|0;if((N|0)==(c[ca+16>>2]|0)){hc=le[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ga}else{ic=c[fa>>2]|0}if((hc|0)!=(c[ic+(da<<2)>>2]|0)){break}N=da+1|0;ca=c[g>>2]|0;o=ca+12|0;r=c[o>>2]|0;if((r|0)==(c[ca+16>>2]|0)){le[c[(c[ca>>2]|0)+40>>2]&127](ca)|0;da=N;continue}else{c[o>>2]=r+4;da=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;s_(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);_U(A);_U(z);_U(y);_U(x);wU(w);if((bc|0)==0){i=p;return ac|0}ie[cc&255](bc);i=p;return ac|0}function x_(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=214;v=n+400|0;sV(q,h);n=q;w=c[n>>2]|0;if(!((c[33966]|0)==-1)){c[m>>2]=135864;c[m+4>>2]=212;c[m+8>>2]=0;hU(135864,m,213)}m=(c[135868>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Gc(4)|0;z=y;g2(z);A=151432;B=128;Wd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Gc(4)|0;z=y;g2(z);A=151432;B=128;Wd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=w_(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){cV(k,Ae[c[(c[w>>2]|0)+44>>2]&127](B,45)|0)}r=Ae[c[(c[w>>2]|0)+44>>2]&127](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);y_(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=le[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=le[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];OT(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ie[c[u>>2]&255](n);i=d;return}function y_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){eV(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function z_(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[33860]|0)==-1)){c[p>>2]=135440;c[p+4>>2]=212;c[p+8>>2]=0;hU(135440,p,213)}p=(c[135444>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Gc(4)|0;C=B;g2(C);D=151432;E=128;Wd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Gc(4)|0;C=B;g2(C);D=151432;E=128;Wd(B|0,D|0,E|0)}E=b;je[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;je[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}bV(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;_U(r);je[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}bV(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;_U(s);c[f>>2]=le[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=le[c[(c[b>>2]|0)+16>>2]&127](E)|0;je[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}IU(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;wU(t);je[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}bV(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;_U(u);F=le[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[33844]|0)==-1)){c[o>>2]=135376;c[o+4>>2]=212;c[o+8>>2]=0;hU(135376,o,213)}o=(c[135380>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Gc(4)|0;H=G;g2(H);I=151432;J=128;Wd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Gc(4)|0;H=G;g2(H);I=151432;J=128;Wd(G|0,I|0,J|0)}J=E;je[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;je[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}bV(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;_U(w);je[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}bV(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;_U(x);c[f>>2]=le[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=le[c[(c[E>>2]|0)+16>>2]&127](J)|0;je[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}IU(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;wU(y);je[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}bV(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;_U(z);F=le[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function A_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=214;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=E2(m,l)|0;m=a;if((a|0)==0){O2()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}ie[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=189;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function B_(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function C_(a){a=a|0;i=i;return}function D_(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Oc(G|0,100,135624,o|0)|0;do{if(s>>>0>99){do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);o=c[33940]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=vY(r,o,135624,n)|0;o=c[r>>2]|0;if((o|0)==0){O2()}H=B2(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}O2()}else{I=0;J=0;K=q;L=s}}while(0);sV(t,g);s=t;q=c[s>>2]|0;if(!((c[33968]|0)==-1)){c[p>>2]=135872;c[p+4>>2]=212;c[p+8>>2]=0;hU(135872,p,213)}p=(c[135876>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Gc(4)|0;N=M;g2(N);O=151432;P=128;Wd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Gc(4)|0;N=M;g2(N);O=151432;P=128;Wd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Ke[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;E_(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=B2(V)|0;if((T|0)!=0){W=T;X=T;break}O2()}else{W=0;X=t}}while(0);F_(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];UQ(b,m,X,e,D,g,j);if((W|0)!=0){C2(W)}wU(A);wU(z);wU(y);OT(c[s>>2]|0)|0;if((J|0)!=0){C2(J)}if((I|0)==0){i=d;return}C2(I);i=d;return}function E_(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[33828]|0)==-1)){c[p>>2]=135312;c[p+4>>2]=212;c[p+8>>2]=0;hU(135312,p,213)}p=(c[135316>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Gc(4)|0;I=H;g2(I);J=151432;K=128;Wd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Gc(4)|0;I=H;g2(I);J=151432;K=128;Wd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){je[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;je[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}IU(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;wU(s)}else{je[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;je[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}IU(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;wU(v)}a[g]=le[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=le[c[(c[e>>2]|0)+16>>2]&127](K)|0;je[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}IU(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;wU(w);je[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}IU(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;wU(x);L=le[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[33812]|0)==-1)){c[o>>2]=135248;c[o+4>>2]=212;c[o+8>>2]=0;hU(135248,o,213)}o=(c[135252>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Gc(4)|0;N=M;g2(N);O=151432;P=128;Wd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Gc(4)|0;N=M;g2(N);O=151432;P=128;Wd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){je[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;je[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}IU(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;wU(A)}else{je[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;je[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}IU(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;wU(D)}a[g]=le[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=le[c[(c[G>>2]|0)+16>>2]&127](P)|0;je[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}IU(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;wU(E);je[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}IU(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;wU(F);L=le[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function F_(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 0:{c[e>>2]=c[f>>2];I=H;break};case 3:{J=a[r]|0;K=(J&1)==0;if(K){L=(J&255)>>>1}else{L=c[w>>2]|0}if((L|0)==0){I=H;break a}if(K){M=u}else{M=c[v>>2]|0}K=a[M]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=K;I=H;break};case 1:{c[e>>2]=c[f>>2];K=Ae[c[(c[k>>2]|0)+28>>2]&127](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=K;I=H;break};case 4:{K=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){N=J;while(1){O=a[N]|0;if(!(O<<24>>24>-1)){P=N;break b}Q=N+1|0;if((b[(c[F>>2]|0)+(O<<24>>24<<1)>>1]&2048)==0){P=N;break b}if(Q>>>0<j>>>0){N=Q}else{P=Q;break}}}else{P=J}}while(0);N=P;if(B){if(P>>>0>J>>>0){Q=J+(0-N)|0;N=Q>>>0<G>>>0?G:Q;Q=N+s|0;O=K;R=P;S=s;while(1){T=R+ -1|0;U=a[T]|0;c[f>>2]=O+1;a[O]=U;U=S+ -1|0;V=(U|0)>0;if(!(T>>>0>J>>>0&V)){break}O=c[f>>2]|0;S=U;R=T}R=P+N|0;if(V){W=R;X=Q;Y=32}else{Z=0;_=R;$=Q}}else{W=P;X=s;Y=32}if((Y|0)==32){Y=0;Z=Ae[c[(c[k>>2]|0)+28>>2]&127](k,48)|0;_=W;$=X}R=c[f>>2]|0;c[f>>2]=R+1;if(($|0)>0){S=R;O=$;while(1){a[S]=Z;T=O+ -1|0;U=c[f>>2]|0;c[f>>2]=U+1;if((T|0)>0){O=T;S=U}else{aa=U;break}}}else{aa=R}a[aa]=n;ba=_}else{ba=P}if((ba|0)==(J|0)){S=Ae[c[(c[k>>2]|0)+28>>2]&127](k,48)|0;O=c[f>>2]|0;c[f>>2]=O+1;a[O]=S}else{S=a[p]|0;O=(S&1)==0;if(O){ca=(S&255)>>>1}else{ca=c[E>>2]|0}if((ca|0)==0){da=ba;ea=-1;fa=0;ga=0}else{if(O){ha=C}else{ha=c[D>>2]|0}da=ba;ea=a[ha]|0;fa=0;ga=0}while(1){do{if((ga|0)==(ea|0)){O=c[f>>2]|0;c[f>>2]=O+1;a[O]=o;O=fa+1|0;S=a[p]|0;Q=(S&1)==0;if(Q){ia=(S&255)>>>1}else{ia=c[E>>2]|0}if(!(O>>>0<ia>>>0)){ja=ea;ka=O;la=0;break}if(Q){ma=C}else{ma=c[D>>2]|0}if((a[ma+O|0]|0)==127){ja=-1;ka=O;la=0;break}if(Q){na=C}else{na=c[D>>2]|0}ja=a[na+O|0]|0;ka=O;la=0}else{ja=ea;ka=fa;la=ga}}while(0);O=da+ -1|0;Q=a[O]|0;S=c[f>>2]|0;c[f>>2]=S+1;a[S]=Q;if((O|0)==(J|0)){break}else{da=O;ea=ja;fa=ka;ga=la+1|0}}}R=c[f>>2]|0;if((K|0)==(R|0)){I=J;break a}O=R+ -1|0;if(O>>>0>K>>>0){oa=K;pa=O}else{I=J;break a}while(1){O=a[oa]|0;a[oa]=a[pa]|0;a[pa]=O;O=oa+1|0;R=pa+ -1|0;if(O>>>0<R>>>0){pa=R;oa=O}else{I=J;break}}break};case 2:{J=a[q]|0;K=(J&1)==0;if(K){qa=(J&255)>>>1}else{qa=c[A>>2]|0}if((qa|0)==0|x){I=H;break a}if(K){ra=y;sa=(J&255)>>>1}else{ra=c[z>>2]|0;sa=c[A>>2]|0}J=ra+sa|0;K=c[f>>2]|0;if((ra|0)==(J|0)){ta=K}else{O=K;K=ra;while(1){a[O]=a[K]|0;R=K+1|0;Q=O+1|0;if((R|0)==(J|0)){ta=Q;break}else{K=R;O=Q}}}c[f>>2]=ta;I=H;break};default:{I=H}}}while(0);O=h+1|0;if(O>>>0<4){H=I;h=O}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function G_(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;sV(m,g);z=m;A=c[z>>2]|0;if(!((c[33968]|0)==-1)){c[l>>2]=135872;c[l+4>>2]=212;c[l+8>>2]=0;hU(135872,l,213)}l=(c[135876>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Gc(4)|0;D=C;g2(D);E=151432;F=128;Wd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Gc(4)|0;D=C;g2(D);E=151432;F=128;Wd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(Ae[c[(c[A>>2]|0)+28>>2]&127](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;E_(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=B2(P)|0;if((N|0)!=0){Q=N;R=N;break}O2()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}F_(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];UQ(b,k,R,e,w,g,h);if((Q|0)==0){wU(t);wU(s);wU(r);U=c[z>>2]|0;V=U;W=V;X=OT(W)|0;i=d;return}C2(Q);wU(t);wU(s);wU(r);U=c[z>>2]|0;V=U;W=V;X=OT(W)|0;i=d;return}function H_(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function I_(a){a=a|0;i=i;return}function J_(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Oc(G|0,100,135624,o|0)|0;do{if(s>>>0>99){do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);o=c[33940]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=vY(r,o,135624,n)|0;o=c[r>>2]|0;if((o|0)==0){O2()}H=B2(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}O2()}else{J=0;K=0;L=q;M=s}}while(0);sV(t,g);s=t;q=c[s>>2]|0;if(!((c[33966]|0)==-1)){c[p>>2]=135864;c[p+4>>2]=212;c[p+8>>2]=0;hU(135864,p,213)}p=(c[135868>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Gc(4)|0;O=N;g2(O);P=151432;Q=128;Wd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Gc(4)|0;O=N;g2(O);P=151432;Q=128;Wd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Ke[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;K_(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=B2(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}O2()}else{X=0;Y=t}}while(0);L_(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];EY(b,m,Y,e,D,g,j);if((X|0)!=0){C2(X)}_U(A);_U(z);wU(y);OT(c[s>>2]|0)|0;if((K|0)!=0){C2(K)}if((J|0)==0){i=d;return}C2(J);i=d;return}function K_(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[33860]|0)==-1)){c[p>>2]=135440;c[p+4>>2]=212;c[p+8>>2]=0;hU(135440,p,213)}p=(c[135444>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Gc(4)|0;I=H;g2(I);J=151432;K=128;Wd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Gc(4)|0;I=H;g2(I);J=151432;K=128;Wd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){je[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;je[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}bV(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;_U(s)}else{je[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;je[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}bV(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;_U(v)}c[g>>2]=le[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=le[c[(c[e>>2]|0)+16>>2]&127](K)|0;je[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}IU(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;wU(w);je[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}bV(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;_U(x);L=le[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[33844]|0)==-1)){c[o>>2]=135376;c[o+4>>2]=212;c[o+8>>2]=0;hU(135376,o,213)}o=(c[135380>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Gc(4)|0;N=M;g2(N);O=151432;P=128;Wd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Gc(4)|0;N=M;g2(N);O=151432;P=128;Wd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){je[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;je[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}bV(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;_U(A)}else{je[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;je[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}bV(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;_U(D)}c[g>>2]=le[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=le[c[(c[G>>2]|0)+16>>2]&127](P)|0;je[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}IU(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;wU(E);je[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}bV(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;_U(F);L=le[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function L_(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 2:{D=a[p]|0;E=(D&1)==0;if(E){F=(D&255)>>>1}else{F=c[w>>2]|0}if((F|0)==0|v){G=C;break a}if(E){H=w;I=(D&255)>>>1}else{H=c[x>>2]|0;I=c[w>>2]|0}D=H+(I<<2)|0;E=c[e>>2]|0;if((H|0)==(D|0)){J=E}else{K=(H+(I+ -1<<2)+(0-H)|0)>>>2;L=E;M=H;while(1){c[L>>2]=c[M>>2];N=M+4|0;if((N|0)==(D|0)){break}L=L+4|0;M=N}J=E+(K+1<<2)|0}c[e>>2]=J;G=C;break};case 3:{M=a[q]|0;L=(M&1)==0;if(L){O=(M&255)>>>1}else{O=c[t>>2]|0}if((O|0)==0){G=C;break a}if(L){P=t}else{P=c[u>>2]|0}L=c[P>>2]|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 0:{c[d>>2]=c[e>>2];G=C;break};case 1:{c[d>>2]=c[e>>2];L=Ae[c[(c[j>>2]|0)+44>>2]&127](j,32)|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;G=C;break};case 4:{L=c[e>>2]|0;M=k?C+4|0:C;b:do{if(M>>>0<h>>>0){D=M;while(1){N=D+4|0;if(!(oe[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[D>>2]|0)|0)){Q=D;break b}if(N>>>0<h>>>0){D=N}else{Q=N;break}}}else{Q=M}}while(0);if(y){do{if(Q>>>0>M>>>0){K=c[e>>2]|0;E=Q;D=r;while(1){R=E+ -4|0;S=K+4|0;c[K>>2]=c[R>>2];T=D+ -1|0;U=(T|0)>0;if(R>>>0>M>>>0&U){D=T;E=R;K=S}else{break}}c[e>>2]=S;if(U){V=R;W=T;X=34;break}K=c[e>>2]|0;c[e>>2]=K+4;Y=K;Z=R}else{V=Q;W=r;X=34}}while(0);do{if((X|0)==34){X=0;K=Ae[c[(c[j>>2]|0)+44>>2]&127](j,48)|0;E=c[e>>2]|0;D=E+4|0;c[e>>2]=D;if((W|0)>0){_=D;$=E;aa=W}else{Y=E;Z=V;break}while(1){c[$>>2]=K;D=aa+ -1|0;if((D|0)>0){aa=D;$=_;_=_+4|0}else{break}}c[e>>2]=E+(W+1<<2);Y=E+(W<<2)|0;Z=V}}while(0);c[Y>>2]=m;ba=Z}else{ba=Q}if((ba|0)==(M|0)){K=Ae[c[(c[j>>2]|0)+44>>2]&127](j,48)|0;D=c[e>>2]|0;N=D+4|0;c[e>>2]=N;c[D>>2]=K;ca=N}else{N=a[o]|0;K=(N&1)==0;if(K){da=(N&255)>>>1}else{da=c[B>>2]|0}if((da|0)==0){ea=ba;fa=-1;ga=0;ha=0}else{if(K){ia=z}else{ia=c[A>>2]|0}ea=ba;fa=a[ia]|0;ga=0;ha=0}while(1){K=c[e>>2]|0;do{if((ha|0)==(fa|0)){N=K+4|0;c[e>>2]=N;c[K>>2]=n;D=ga+1|0;ja=a[o]|0;ka=(ja&1)==0;if(ka){la=(ja&255)>>>1}else{la=c[B>>2]|0}if(!(D>>>0<la>>>0)){ma=N;na=fa;oa=D;pa=0;break}if(ka){qa=z}else{qa=c[A>>2]|0}if((a[qa+D|0]|0)==127){ma=N;na=-1;oa=D;pa=0;break}if(ka){ra=z}else{ra=c[A>>2]|0}ma=N;na=a[ra+D|0]|0;oa=D;pa=0}else{ma=K;na=fa;oa=ga;pa=ha}}while(0);K=ea+ -4|0;E=c[K>>2]|0;D=ma+4|0;c[e>>2]=D;c[ma>>2]=E;if((K|0)==(M|0)){ca=D;break}else{ea=K;fa=na;ga=oa;ha=pa+1|0}}}if((L|0)==(ca|0)){G=M;break a}K=ca+ -4|0;if(K>>>0>L>>>0){sa=L;ta=K}else{G=M;break a}while(1){K=c[sa>>2]|0;c[sa>>2]=c[ta>>2];c[ta>>2]=K;K=sa+4|0;D=ta+ -4|0;if(K>>>0<D>>>0){ta=D;sa=K}else{G=M;break}}break};default:{G=C}}}while(0);M=g+1|0;if(M>>>0<4){C=G;g=M}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function M_(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;sV(m,g);z=m;A=c[z>>2]|0;if(!((c[33966]|0)==-1)){c[l>>2]=135864;c[l+4>>2]=212;c[l+8>>2]=0;hU(135864,l,213)}l=(c[135868>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Gc(4)|0;D=C;g2(D);E=151432;F=128;Wd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Gc(4)|0;D=C;g2(D);E=151432;F=128;Wd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(Ae[c[(c[A>>2]|0)+44>>2]&127](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;K_(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=B2(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}O2()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}L_(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];EY(b,k,R,e,w,g,h);if((Q|0)==0){_U(t);_U(s);wU(r);U=c[z>>2]|0;V=U;W=V;X=OT(W)|0;i=d;return}C2(Q);_U(t);_U(s);wU(r);U=c[z>>2]|0;V=U;W=V;X=OT(W)|0;i=d;return}function N_(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function O_(a){a=a|0;i=i;return}function P_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=wc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function Q_(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{OU(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=Bd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=d3(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{wU(j);i=d;return}do{OU(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);wU(j);i=d;return}function R_(a,b){a=a|0;b=b|0;a=i;Ib(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function S_(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function T_(a){a=a|0;i=i;return}function U_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=wc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function V_(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=137528;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=137528|0;while(1){c[m>>2]=y;A=(Je[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{OU(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}o_(136752)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=Bd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=137632;D=d3(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){wU(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=137632|0;while(1){c[q>>2]=o;h=(Je[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{cV(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){o_(136752)}else if((E|0)==25){wU(r);i=d;return}}function W_(a,b){a=a|0;b=b|0;a=i;Ib(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function X_(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=135960;e=b+8|0;b=c[e>>2]|0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);if((b|0)==(c[33940]|0)){i=d;return}cc(c[e>>2]|0);i=d;return}function Y_(a){a=a|0;a=Gc(8)|0;PT(a,135752);c[a>>2]=132720;Wd(a|0,132760,41)}function Z_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=135792;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);oU(b+144|0,135776,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[140684>>2]=0;c[35170]=134272;if(!((c[33574]|0)==-1)){c[G>>2]=134296;c[G+4>>2]=212;c[G+8>>2]=0;hU(134296,G,213)}__(b,140680,(c[134300>>2]|0)+ -1|0);c[140676>>2]=0;c[35168]=134312;if(!((c[33584]|0)==-1)){c[F>>2]=134336;c[F+4>>2]=212;c[F+8>>2]=0;hU(134336,F,213)}__(b,140672,(c[134340>>2]|0)+ -1|0);c[140660>>2]=0;c[35164]=135888;c[140664>>2]=0;a[140668|0]=0;F=c[(Ac()|0)>>2]|0;c[140664>>2]=F;if(!((c[33968]|0)==-1)){c[E>>2]=135872;c[E+4>>2]=212;c[E+8>>2]=0;hU(135872,E,213)}__(b,140656,(c[135876>>2]|0)+ -1|0);c[140652>>2]=0;c[35162]=136848;if(!((c[33966]|0)==-1)){c[D>>2]=135864;c[D+4>>2]=212;c[D+8>>2]=0;hU(135864,D,213)}__(b,140648,(c[135868>>2]|0)+ -1|0);c[140644>>2]=0;c[35160]=137064;if(!((c[33984]|0)==-1)){c[C>>2]=135936;c[C+4>>2]=212;c[C+8>>2]=0;hU(135936,C,213)}__(b,140640,(c[135940>>2]|0)+ -1|0);c[140628>>2]=0;c[35156]=135960;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);c[140632>>2]=c[33940];if(!((c[33986]|0)==-1)){c[B>>2]=135944;c[B+4>>2]=212;c[B+8>>2]=0;hU(135944,B,213)}__(b,140624,(c[135948>>2]|0)+ -1|0);c[140620>>2]=0;c[35154]=137288;if(!((c[34e3]|0)==-1)){c[A>>2]=136e3;c[A+4>>2]=212;c[A+8>>2]=0;hU(136e3,A,213)}__(b,140616,(c[136004>>2]|0)+ -1|0);c[140612>>2]=0;c[35152]=137408;if(!((c[34002]|0)==-1)){c[z>>2]=136008;c[z+4>>2]=212;c[z+8>>2]=0;hU(136008,z,213)}__(b,140608,(c[136012>>2]|0)+ -1|0);c[140588>>2]=0;c[35146]=136040;a[140592|0]=46;a[140593|0]=44;z=140596|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[34004]|0)==-1)){c[y>>2]=136016;c[y+4>>2]=212;c[y+8>>2]=0;hU(136016,y,213)}__(b,140584,(c[136020>>2]|0)+ -1|0);c[140556>>2]=0;c[35138]=136080;c[140560>>2]=46;c[140564>>2]=44;y=140568|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[34006]|0)==-1)){c[x>>2]=136024;c[x+4>>2]=212;c[x+8>>2]=0;hU(136024,x,213)}__(b,140552,(c[136028>>2]|0)+ -1|0);c[140548>>2]=0;c[35136]=134352;if(!((c[33602]|0)==-1)){c[w>>2]=134408;c[w+4>>2]=212;c[w+8>>2]=0;hU(134408,w,213)}__(b,140544,(c[134412>>2]|0)+ -1|0);c[140540>>2]=0;c[35134]=134472;if(!((c[33632]|0)==-1)){c[v>>2]=134528;c[v+4>>2]=212;c[v+8>>2]=0;hU(134528,v,213)}__(b,140536,(c[134532>>2]|0)+ -1|0);c[140532>>2]=0;c[35132]=134544;if(!((c[33648]|0)==-1)){c[u>>2]=134592;c[u+4>>2]=212;c[u+8>>2]=0;hU(134592,u,213)}__(b,140528,(c[134596>>2]|0)+ -1|0);c[140524>>2]=0;c[35130]=134608;if(!((c[33664]|0)==-1)){c[t>>2]=134656;c[t+4>>2]=212;c[t+8>>2]=0;hU(134656,t,213)}__(b,140520,(c[134660>>2]|0)+ -1|0);c[140516>>2]=0;c[35128]=135200;if(!((c[33812]|0)==-1)){c[s>>2]=135248;c[s+4>>2]=212;c[s+8>>2]=0;hU(135248,s,213)}__(b,140512,(c[135252>>2]|0)+ -1|0);c[140508>>2]=0;c[35126]=135264;if(!((c[33828]|0)==-1)){c[r>>2]=135312;c[r+4>>2]=212;c[r+8>>2]=0;hU(135312,r,213)}__(b,140504,(c[135316>>2]|0)+ -1|0);c[140500>>2]=0;c[35124]=135328;if(!((c[33844]|0)==-1)){c[q>>2]=135376;c[q+4>>2]=212;c[q+8>>2]=0;hU(135376,q,213)}__(b,140496,(c[135380>>2]|0)+ -1|0);c[140492>>2]=0;c[35122]=135392;if(!((c[33860]|0)==-1)){c[p>>2]=135440;c[p+4>>2]=212;c[p+8>>2]=0;hU(135440,p,213)}__(b,140488,(c[135444>>2]|0)+ -1|0);c[140484>>2]=0;c[35120]=135456;if(!((c[33870]|0)==-1)){c[o>>2]=135480;c[o+4>>2]=212;c[o+8>>2]=0;hU(135480,o,213)}__(b,140480,(c[135484>>2]|0)+ -1|0);c[140476>>2]=0;c[35118]=135536;if(!((c[33890]|0)==-1)){c[n>>2]=135560;c[n+4>>2]=212;c[n+8>>2]=0;hU(135560,n,213)}__(b,140472,(c[135564>>2]|0)+ -1|0);c[140468>>2]=0;c[35116]=135592;if(!((c[33904]|0)==-1)){c[m>>2]=135616;c[m+4>>2]=212;c[m+8>>2]=0;hU(135616,m,213)}__(b,140464,(c[135620>>2]|0)+ -1|0);c[140460>>2]=0;c[35114]=135640;if(!((c[33916]|0)==-1)){c[l>>2]=135664;c[l+4>>2]=212;c[l+8>>2]=0;hU(135664,l,213)}__(b,140456,(c[135668>>2]|0)+ -1|0);c[140444>>2]=0;c[35110]=134688;c[140448>>2]=134736;if(!((c[33692]|0)==-1)){c[k>>2]=134768;c[k+4>>2]=212;c[k+8>>2]=0;hU(134768,k,213)}__(b,140440,(c[134772>>2]|0)+ -1|0);c[140428>>2]=0;c[35106]=134840;c[140432>>2]=134888;if(!((c[33730]|0)==-1)){c[j>>2]=134920;c[j+4>>2]=212;c[j+8>>2]=0;hU(134920,j,213)}__(b,140424,(c[134924>>2]|0)+ -1|0);c[140412>>2]=0;c[35102]=136784;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);c[140416>>2]=c[33940];c[35102]=135136;if(!((c[33788]|0)==-1)){c[h>>2]=135152;c[h+4>>2]=212;c[h+8>>2]=0;hU(135152,h,213)}__(b,140408,(c[135156>>2]|0)+ -1|0);c[140396>>2]=0;c[35098]=136784;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);c[140400>>2]=c[33940];c[35098]=135168;if(!((c[33796]|0)==-1)){c[g>>2]=135184;c[g+4>>2]=212;c[g+8>>2]=0;hU(135184,g,213)}__(b,140392,(c[135188>>2]|0)+ -1|0);c[140388>>2]=0;c[35096]=135680;if(!((c[33926]|0)==-1)){c[f>>2]=135704;c[f+4>>2]=212;c[f+8>>2]=0;hU(135704,f,213)}__(b,140384,(c[135708>>2]|0)+ -1|0);c[140380>>2]=0;c[35094]=135720;if((c[33936]|0)==-1){N=135744;O=135744;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=140376;__(b,T,S);i=e;return}c[H>>2]=135744;c[H+4>>2]=212;c[H+8>>2]=0;hU(135744,H,213);N=135744;O=135744;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=140376;__(b,T,S);i=e;return}function __(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;NT(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){d1(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}OT(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function $_(a){a=a|0;var b=0;b=i;a$(a);J2(a);i=b;return}function a$(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=135792;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{OT(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}wU(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{J2(h);i=d;return}}function b$(){var b=0,d=0,e=0,f=0;b=i;if((a[135848]|0)!=0){d=135840;e=c[33960]|0;i=b;return e|0}if((_a(135848)|0)==0){d=135840;e=c[33960]|0;i=b;return e|0}do{if((a[135824]|0)==0){if((_a(135824)|0)==0){break}Z_(140216,1);c[33952]=140216;c[33954]=135808;Ub(135824)}}while(0);f=c[c[33954]>>2]|0;c[33958]=f;NT(f);c[33960]=135832;Ub(135848);d=135840;e=c[33960]|0;i=b;return e|0}function c$(a){a=a|0;var b=0,d=0;b=i;d=c[(b$()|0)>>2]|0;c[a>>2]=d;NT(d);i=b;return}function d$(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;NT(e);i=d;return}function e$(a){a=a|0;var b=0;b=i;OT(c[a>>2]|0)|0;i=b;return}function f$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=212;c[e+8>>2]=0;hU(a,e,213)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function g$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=212;c[e+8>>2]=0;hU(a,e,213)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Gc(4)|0;h=g;g2(h);j=151432;k=128;Wd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Gc(4)|0;h=g;g2(h);j=151432;k=128;Wd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function h$(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function i$(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}ie[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function j$(a){a=a|0;var b=0;b=c[33964]|0;c[33964]=1+b;c[a+4>>2]=b+1;i=i;return}function k$(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function l$(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(Ac()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function m$(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(Ac()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function n$(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(Ac()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function o$(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(Ac()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function p$(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Gd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function q$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Gd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function r$(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Ld()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function s$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Ld()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function t$(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function u$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function v$(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function w$(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function x$(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=135888;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}K2(e)}}while(0);J2(b);i=d;return}function y$(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=135888;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}K2(e);i=d;return}function z$(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Gd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function A$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Gd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function B$(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Ld()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function C$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Ld()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function D$(a,b){a=a|0;b=b|0;i=i;return b|0}function E$(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function F$(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function G$(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function H$(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function I$(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function J$(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function K$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function L$(a){a=a|0;i=i;return 1}function M$(a){a=a|0;i=i;return 1}function N$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function O$(a){a=a|0;i=i;return 1}function P$(a){a=a|0;var b=0;b=i;X_(a);J2(a);i=b;return}function Q$(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Nc(c[s>>2]|0)|0;A=H1(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Nc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Nc(c[s>>2]|0)|0;A=G1(u,0,d)|0;if((z|0)!=0){Nc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Nc(c[s>>2]|0)|0;G=G1(u,r,n)|0;if((z|0)!=0){Nc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function R$(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Nc(c[r>>2]|0)|0;y=D1(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Nc(x|0)|0}if((y|0)==0){A=2;B=32;break}else if((y|0)==-1){B=10;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){B=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Nc(c[r>>2]|0)|0;F=C1(x,y,1,d)|0;if((w|0)!=0){Nc(w|0)|0}if((F|0)!=0){A=2;B=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((B|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Nc(c[r>>2]|0)|0;y=C1(q,v,z-v|0,n)|0;if((w|0)!=0){Nc(w|0)|0}if((y|0)==0){I=v+1|0}else if((y|0)==-1){B=15;break}else if((y|0)==-2){B=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((B|0)==15){c[g>>2]=v;A=2;i=l;return A|0}else if((B|0)==16){c[g>>2]=v;A=1;i=l;return A|0}}}while(0);c[g>>2]=H;A=(H|0)!=(f|0)|0;i=l;return A|0}else if((B|0)==30){p=c[g>>2]|0;break}else if((B|0)==32){i=l;return A|0}}}while(0);A=(p|0)!=(f|0)|0;i=l;return A|0}function S$(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Nc(c[b+8>>2]|0)|0;b=G1(e,0,d)|0;if((j|0)!=0){Nc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function T$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Nc(c[d>>2]|0)|0;e=F1(0,0,4)|0;if((a|0)!=0){Nc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Nc(a|0)|0;if((g|0)==0){f=0;break}Nc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function U$(a){a=a|0;i=i;return 0}function V$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Nc(c[k>>2]|0)|0;n=B1(a,j-a|0,b)|0;if((m|0)!=0){Nc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function W$(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Nc(d|0)|0;if((a|0)==0){e=4;break}Nc(a|0)|0;e=4}}while(0);i=b;return e|0}function X$(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function Y$(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Z$(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Z$(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function _$(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=$$(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function $$(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function a0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function b0(a){a=a|0;i=i;return 0}function c0(a){a=a|0;i=i;return 0}function d0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=e0(c,d,e,1114111,0)|0;i=b;return a|0}function e0(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function f0(a){a=a|0;i=i;return 4}function g0(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function h0(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=i0(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function i0(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function j0(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=k0(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function k0(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function l0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function m0(a){a=a|0;i=i;return 0}function n0(a){a=a|0;i=i;return 0}function o0(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=p0(c,d,e,1114111,0)|0;i=b;return a|0}function p0(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function q0(a){a=a|0;i=i;return 4}function r0(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function s0(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function t0(a){a=a|0;var b=0;b=i;c[a>>2]=136040;wU(a+12|0);J2(a);i=b;return}function u0(a){a=a|0;var b=0;b=i;c[a>>2]=136040;wU(a+12|0);i=b;return}function v0(a){a=a|0;var b=0;b=i;c[a>>2]=136080;wU(a+16|0);J2(a);i=b;return}function w0(a){a=a|0;var b=0;b=i;c[a>>2]=136080;wU(a+16|0);i=b;return}function x0(b){b=b|0;i=i;return a[b+8|0]|0}function y0(a){a=a|0;i=i;return c[a+8>>2]|0}function z0(b){b=b|0;i=i;return a[b+9|0]|0}function A0(a){a=a|0;i=i;return c[a+12>>2]|0}function B0(a,b){a=a|0;b=b|0;var c=0;c=i;mU(a,b+12|0);i=c;return}function C0(a,b){a=a|0;b=b|0;var c=0;c=i;mU(a,b+16|0);i=c;return}function D0(a,b){a=a|0;b=b|0;b=i;oU(a,136112,4);i=b;return}function E0(a,b){a=a|0;b=b|0;b=i;YU(a,136120,b2(136120)|0);i=b;return}function F0(a,b){a=a|0;b=b|0;b=i;oU(a,136144,5);i=b;return}function G0(a,b){a=a|0;b=b|0;b=i;YU(a,136152,b2(136152)|0);i=b;return}function H0(b){b=b|0;var d=0,e=0;b=i;if((a[136184]|0)!=0){d=136176;e=c[34044]|0;i=b;return e|0}if((_a(136184)|0)==0){d=136176;e=c[34044]|0;i=b;return e|0}do{if((a[143384]|0)==0){if((_a(143384)|0)==0){break}h3(143216,0,168)|0;ae(215,0,q|0)|0;Ub(143384)}}while(0);zU(143216,143392)|0;zU(143228|0,143400)|0;zU(143240|0,143408)|0;zU(143252|0,143416)|0;zU(143264|0,143432)|0;zU(143276|0,143448)|0;zU(143288|0,143456)|0;zU(143300|0,143472)|0;zU(143312|0,143480)|0;zU(143324|0,143488)|0;zU(143336|0,143496)|0;zU(143348|0,143504)|0;zU(143360|0,143512)|0;zU(143372|0,143520)|0;c[34044]=143216;Ub(136184);d=136176;e=c[34044]|0;i=b;return e|0}function I0(b){b=b|0;var d=0,e=0;b=i;if((a[136200]|0)!=0){d=136192;e=c[34048]|0;i=b;return e|0}if((_a(136200)|0)==0){d=136192;e=c[34048]|0;i=b;return e|0}do{if((a[142848]|0)==0){if((_a(142848)|0)==0){break}h3(142680,0,168)|0;ae(216,0,q|0)|0;Ub(142848)}}while(0);$U(142680,142856)|0;$U(142692|0,142888)|0;$U(142704|0,142920)|0;$U(142716|0,142952)|0;$U(142728|0,142992)|0;$U(142740|0,143032)|0;$U(142752|0,143064)|0;$U(142764|0,143104)|0;$U(142776|0,143120)|0;$U(142788|0,143136)|0;$U(142800|0,143152)|0;$U(142812|0,143168)|0;$U(142824|0,143184)|0;$U(142836|0,143200)|0;c[34048]=142680;Ub(136200);d=136192;e=c[34048]|0;i=b;return e|0}function J0(b){b=b|0;var d=0,e=0;b=i;if((a[136216]|0)!=0){d=136208;e=c[34052]|0;i=b;return e|0}if((_a(136216)|0)==0){d=136208;e=c[34052]|0;i=b;return e|0}do{if((a[142456]|0)==0){if((_a(142456)|0)==0){break}h3(142168,0,288)|0;ae(217,0,q|0)|0;Ub(142456)}}while(0);zU(142168,142464)|0;zU(142180|0,142472)|0;zU(142192|0,142488)|0;zU(142204|0,142496)|0;zU(142216|0,142504)|0;zU(142228|0,142512)|0;zU(142240|0,142520)|0;zU(142252|0,142528)|0;zU(142264|0,142536)|0;zU(142276|0,142552)|0;zU(142288|0,142560)|0;zU(142300|0,142576)|0;zU(142312|0,142592)|0;zU(142324|0,142600)|0;zU(142336|0,142608)|0;zU(142348|0,142616)|0;zU(142360|0,142504)|0;zU(142372|0,142624)|0;zU(142384|0,142632)|0;zU(142396|0,142640)|0;zU(142408|0,142648)|0;zU(142420|0,142656)|0;zU(142432|0,142664)|0;zU(142444|0,142672)|0;c[34052]=142168;Ub(136216);d=136208;e=c[34052]|0;i=b;return e|0}function K0(b){b=b|0;var d=0,e=0;b=i;if((a[136232]|0)!=0){d=136224;e=c[34056]|0;i=b;return e|0}if((_a(136232)|0)==0){d=136224;e=c[34056]|0;i=b;return e|0}do{if((a[141616]|0)==0){if((_a(141616)|0)==0){break}h3(141328,0,288)|0;ae(218,0,q|0)|0;Ub(141616)}}while(0);$U(141328,141624)|0;$U(141340|0,141656)|0;$U(141352|0,141696)|0;$U(141364|0,141720)|0;$U(141376|0,142040)|0;$U(141388|0,141744)|0;$U(141400|0,141768)|0;$U(141412|0,141792)|0;$U(141424|0,141824)|0;$U(141436|0,141864)|0;$U(141448|0,141896)|0;$U(141460|0,141936)|0;$U(141472|0,141976)|0;$U(141484|0,141992)|0;$U(141496|0,142008)|0;$U(141508|0,142024)|0;$U(141520|0,142040)|0;$U(141532|0,142056)|0;$U(141544|0,142072)|0;$U(141556|0,142088)|0;$U(141568|0,142104)|0;$U(141580|0,142120)|0;$U(141592|0,142136)|0;$U(141604|0,142152)|0;c[34056]=141328;Ub(136232);d=136224;e=c[34056]|0;i=b;return e|0}function L0(b){b=b|0;var d=0,e=0;b=i;if((a[136248]|0)!=0){d=136240;e=c[34060]|0;i=b;return e|0}if((_a(136248)|0)==0){d=136240;e=c[34060]|0;i=b;return e|0}do{if((a[141304]|0)==0){if((_a(141304)|0)==0){break}h3(141016,0,288)|0;ae(219,0,q|0)|0;Ub(141304)}}while(0);zU(141016,141312)|0;zU(141028|0,141320)|0;c[34060]=141016;Ub(136248);d=136240;e=c[34060]|0;i=b;return e|0}function M0(b){b=b|0;var d=0,e=0;b=i;if((a[136264]|0)!=0){d=136256;e=c[34064]|0;i=b;return e|0}if((_a(136264)|0)==0){d=136256;e=c[34064]|0;i=b;return e|0}do{if((a[140976]|0)==0){if((_a(140976)|0)==0){break}h3(140688,0,288)|0;ae(220,0,q|0)|0;Ub(140976)}}while(0);$U(140688,140984)|0;$U(140700|0,141e3)|0;c[34064]=140688;Ub(136264);d=136256;e=c[34064]|0;i=b;return e|0}function N0(b){b=b|0;var c=0;b=i;if((a[136288]|0)!=0){c=136272;i=b;return c|0}if((_a(136288)|0)==0){c=136272;i=b;return c|0}oU(136272,136296,8);ae(221,136272,q|0)|0;Ub(136288);c=136272;i=b;return c|0}function O0(b){b=b|0;var c=0;b=i;if((a[136328]|0)!=0){c=136312;i=b;return c|0}if((_a(136328)|0)==0){c=136312;i=b;return c|0}YU(136312,136336,b2(136336)|0);ae(222,136312,q|0)|0;Ub(136328);c=136312;i=b;return c|0}function P0(b){b=b|0;var c=0;b=i;if((a[136392]|0)!=0){c=136376;i=b;return c|0}if((_a(136392)|0)==0){c=136376;i=b;return c|0}oU(136376,136400,8);ae(221,136376,q|0)|0;Ub(136392);c=136376;i=b;return c|0}function Q0(b){b=b|0;var c=0;b=i;if((a[136432]|0)!=0){c=136416;i=b;return c|0}if((_a(136432)|0)==0){c=136416;i=b;return c|0}YU(136416,136440,b2(136440)|0);ae(222,136416,q|0)|0;Ub(136432);c=136416;i=b;return c|0}function R0(b){b=b|0;var c=0;b=i;if((a[136496]|0)!=0){c=136480;i=b;return c|0}if((_a(136496)|0)==0){c=136480;i=b;return c|0}oU(136480,136504,20);ae(221,136480,q|0)|0;Ub(136496);c=136480;i=b;return c|0}function S0(b){b=b|0;var c=0;b=i;if((a[136544]|0)!=0){c=136528;i=b;return c|0}if((_a(136544)|0)==0){c=136528;i=b;return c|0}YU(136528,136552,b2(136552)|0);ae(222,136528,q|0)|0;Ub(136544);c=136528;i=b;return c|0}function T0(b){b=b|0;var c=0;b=i;if((a[136656]|0)!=0){c=136640;i=b;return c|0}if((_a(136656)|0)==0){c=136640;i=b;return c|0}oU(136640,136664,11);ae(221,136640,q|0)|0;Ub(136656);c=136640;i=b;return c|0}function U0(b){b=b|0;var c=0;b=i;if((a[136696]|0)!=0){c=136680;i=b;return c|0}if((_a(136696)|0)==0){c=136680;i=b;return c|0}YU(136680,136704,b2(136704)|0);ae(222,136680,q|0)|0;Ub(136696);c=136680;i=b;return c|0}



function rv(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Ke[c[b+16>>2]&63](b,f,g,l)|0){case-1:{o=7;break a;break};case 0:{o=4;break a;break};case 10:{p=Ae[c[b+44>>2]&127](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=yv(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Eu(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case-4:{o=3;break a;break};case 9:{q=(oe[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Eu(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=Qu(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=Hu(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=rv(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 7:case 39:{o=31;break};case 6:{if((Wu(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Eu(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function sv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((oe[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=zv()|0;c[g+240>>2]=le[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Ke[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){ie[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}ie[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function tv(){var a=0,b=0;a=i;i=i+8|0;dc(((uc(0)|0)>>>0)%4294967295|0|0);b=l3()|0;i=a;return b|0}function uv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=Mu(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=Nu(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function vv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=le[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{wv(f+80|0,e);wv(b+104|0,e);xv(b,e);xv(b+20|0,e);xv(b+40|0,e);xv(b+60|0,e);a[b+131|0]=0;xv(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function wv(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function xv(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function yv(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function zv(){i=i;return 1912}function Av(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[58200+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[58276+l|0]|0|0)!=28){if((d[58276+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[58276+q|0]|0|0)!=28){if((d[58276+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[58276+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Bv(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[52368+(((d[52112+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[52368+(((d[53648+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=yv(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=51;c[h+336>>2]=51;c[h+340>>2]=51;c[h+344>>2]=52;c[h+348>>2]=52;c[h+352>>2]=52;c[h+356>>2]=53;c[h+360>>2]=53;c[h+364>>2]=53}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function Bv(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 0:{if((d[58276+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function Cv(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=Ae[c[f+368>>2]&127](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[52368+(((d[53648+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Dv(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=Ae[c[f+368>>2]&127](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[52368+(((d[52112+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Ev(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=Ae[c[e+368>>2]&127](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Bv(a)|0)<0;g=f&1;i=d;return g|0}function Fv(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=yv(Ae[c[h+368>>2]&127](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function Gv(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(Ae[c[h+368>>2]&127](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Hv(){i=i;return 57832}function Iv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Jv(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=35;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Jv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((Xv(d,c[57736+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function Kv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Vx(56176,a,0,b,c,d)|0;i=e;return f|0}function Lv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Vx(56176,a,1,b,c,d)|0;i=e;return f|0}function Mv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;sx(56944,b,c,d);i=a;return}function Nv(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Ov(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Ov(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(Wx(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Ke[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,57680)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((Wx(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Ke[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,57688)|0)!=0){h=Xx(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=oe[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((Wx(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Ke[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,57704)|0)!=0){if((a|0)!=0){break}do{if((Ke[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,57720)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Ke[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,57728)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((Yx(Xx(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function Pv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;fe[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Xv(h,53904)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Jv(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[56176+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Qv(){i=i;return 55808}function Rv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Jv(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=35;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Sv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Vx(53912,a,0,b,c,d)|0;i=e;return f|0}function Tv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=Vx(53912,a,1,b,c,d)|0;i=e;return f|0}function Uv(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=Ov(37,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function Vv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;fe[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((Xv(h,53904)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Jv(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[53912+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function Wv(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Av(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function Xv(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function Yv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 30:{k=pw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 29:{g=b;if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[52368+((d[53648+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=nw(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 19:{k=Bw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=nw(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 16:{k=Aw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=vw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 13:{k=zw(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 12:{k=zw(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=nw(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=nw(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 34:{o=116;break b;break};case 29:{if((c[52368+((d[53648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 5:{o=85;break b;break};case 6:{o=88;break b;break};case 33:{o=119;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=nw(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 6:{o=108;break b;break};case 5:{o=105;break b;break};case 29:{if((c[52368+((d[53648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 7:{o=111;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 7:{o=91;break b;break};case 15:{o=122;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function Zv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 2:{k=sw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=ow(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=nw(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=nw(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function _v(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=nw(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=nw(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=47;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function $v(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=nw(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function aw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=nw(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 21:{n=29;break a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 10:{n=16;break a;break};case 2:{n=15;break a;break};case 9:{n=19;break a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=ow(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=nw(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function bw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=nw(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 10:{n=18;break a;break};case 30:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=ow(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=pw(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=nw(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function cw(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=nw(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 6:{k=8;break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=nw(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function dw(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function ew(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=nw(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function fw(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=nw(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function gw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=nw(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=nw(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function hw(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Bv(c)|0;k=j;i=b;return k|0}function iw(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((f|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function jw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=nw(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=nw(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};case 6:{b=b+3|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function kw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=nw(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function lw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function mw(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function nw(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 219:case 218:case 217:case 216:{d=7;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function ow(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=qw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=nw(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[52368+((d[53648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function pw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=nw(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[52368+((d[53648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function qw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=rw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=nw(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function rw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=nw(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=nw(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function sw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 17:{k=ww(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=vw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=nw(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=tw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=uw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=nw(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 10:case 9:case 21:{o=69;break b;break};case 7:{o=45;break b;break};case 29:{if((c[52368+((d[53648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 11:{o=90;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=nw(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{o=62;break b;break};case 24:case 22:{break};case 7:{o=65;break b;break};case 29:{if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 17:{break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{o=42;break b;break};case 5:{o=39;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=nw(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 6:{o=81;break d;break};case 5:{o=78;break d;break};case 11:{o=90;break c;break};case 7:{o=84;break d;break};case 17:{break c;break};case 29:{o=75;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=xw(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function tw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=nw(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function uw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[54312+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function vw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=nw(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 29:{if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=nw(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 15:{p=62;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};case 29:{if((c[52368+((d[53648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 6:{p=31;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 5:{p=28;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((yw(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=nw(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((yw(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function ww(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=nw(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 11:{n=48;break b;break};case 5:{n=28;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 23:{b=b+2|0;continue b;break};case 29:{if((c[52368+((d[53648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=nw(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function xw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=nw(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 5:{l=10;break a;break};case 29:{if((c[52368+((d[53648+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 7:{l=16;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=nw(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 24:case 22:{break};case 7:{l=36;break a;break};case 29:{if((c[52368+((d[52112+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=nw(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 14:{break};case 6:{l=13;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=nw(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=nw(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 3:{t=ow(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=nw(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=nw(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 17:{l=107;break a;break};case 6:{l=100;break a;break};case 11:{l=106;break a;break};case 24:case 22:{break d;break};case 5:{l=97;break a;break};case 29:{l=94;break d;break};case 10:case 9:case 21:{break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[52368+((d[52112+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function yw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function zw(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=nw(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=nw(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Aw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=nw(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=nw(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=tw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Bw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=nw(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[52368+((d[52112+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=nw(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 29:{if((c[52368+((d[53648+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Cw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 12:{k=cx(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=nw(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=nw(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 15:{k=_w(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=dx(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 10:case 21:{p=25;break};case 24:case 22:{q=18;b=b+2|0;p=77;break};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 19:{k=ex(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=cx(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 29:{g=b;if((c[52368+((d[52112+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;q=18;p=77;break a}if((c[52368+((d[53648+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=76;break a}b=b+2|0;q=19;p=77;break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=Uw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;p=77;break};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}o=b;if((a[r]|0)==0){s=d[j+76+(d[o+1|0]|0)|0]|0}else{s=nw(a[o]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=nw(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 29:{if((c[52368+((d[53648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=83;break b}break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 34:{p=116;break b;break};case 7:{p=91;break b;break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}q=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=nw(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 6:{p=108;break b;break};case 7:{p=111;break b;break};case 29:{if((c[52368+((d[53648+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=103;break b}break};case 5:{p=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{q=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 33:{p=119;break b;break};case 6:{p=88;break b;break};case 5:{p=85;break b;break};case 15:{p=122;break b;break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function Dw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 2:{k=Xw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=nw(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=Tw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=nw(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Ew(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=nw(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=nw(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=nw(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Fw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=nw(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Gw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=nw(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=19;break a;break};case 2:{n=15;break a;break};case 21:{n=29;break a;break};case 10:{n=16;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Tw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=nw(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Hw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=nw(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 9:{n=21;break a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 10:{n=18;break a;break};case 30:{n=15;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Tw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Uw(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=nw(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Iw(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=nw(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 6:{j=8;break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;k=b;b=k+1|0;if((a[e]|0)!=(a[k]|0)){j=15;break a}k=c;c=k+1|0;e=b;b=e+1|0;if((a[k]|0)!=(a[e]|0)){j=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=7;break a}else{j=8}break};default:{j=18;break a}}if((j|0)==8){j=0;k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=9;break}}e=b;b=e+1|0;k=c;c=k+1|0;if((a[e]|0)!=(a[k]|0)){j=11;break}k=b;b=k+1|0;e=c;c=e+1|0;if((a[k]|0)!=(a[e]|0)){j=13;break}}if((j|0)==7){l=0;m=l;i=f;return m|0}else if((j|0)==9){l=0;m=l;i=f;return m|0}else if((j|0)==11){l=0;m=l;i=f;return m|0}else if((j|0)==13){l=0;m=l;i=f;return m|0}else if((j|0)==15){l=0;m=l;i=f;return m|0}else if((j|0)==17){l=0;m=l;i=f;return m|0}else if((j|0)==18){j=c;if((a[c]|0)==0){n=d[g+76+(d[j+1|0]|0)|0]|0}else{n=nw(a[j]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Jw(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Kw(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=nw(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function Lw(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=nw(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function Mw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=nw(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=nw(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Nw(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Bv(c)|0;k=j;i=b;return k|0}function Ow(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((f|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==103){g=62;h=g;i=b;return h|0}else if((j|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function Pw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=nw(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=nw(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Qw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=nw(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}



function Me(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Ne(){return i|0}function Oe(a){a=a|0;i=a}function Pe(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Qe(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Re(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Se(a){a=a|0;J=a}function Te(a){a=a|0;K=a}function Ue(a){a=a|0;L=a}function Ve(a){a=a|0;M=a}function We(a){a=a|0;N=a}function Xe(a){a=a|0;O=a}function Ye(a){a=a|0;P=a}function Ze(a){a=a|0;Q=a}function _e(a){a=a|0;R=a}function $e(a){a=a|0;S=a}function af(a){a=a|0;var b=0,d=0;b=i;oE(a)|0;d=a+540|0;le[c[(c[d>>2]|0)+40>>2]&127](a)|0;le[c[(c[d>>2]|0)+28>>2]&127](a)|0;le[c[(c[d>>2]|0)+32>>2]&127](a)|0;le[c[(c[d>>2]|0)+48>>2]&127](a)|0;le[c[(c[d>>2]|0)+52>>2]&127](a)|0;PC(a);i=b;return}function bf(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=d3(B|0)|0;D=B2(C+11|0)|0;o3(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=kc(D|0,32)|0;if((C|0)==0){B=Zd(c[(Pc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;tz(23,0,40,u);_c(0)|0;F=0}else{F=C}C2(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Fe[c[62260>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{dB(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}dB(2);cB(2)}TA(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rz(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];CC(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rz(23,1,144,r);Z=YD(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}af(b);QC(b);if((c[61204>>2]|0)!=0){ie[c[15416]&255](23)}if((c[2]|0)!=0){cB(4)}A=EC(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rz(7,1,200,q);if((c[118724>>2]|0)==0){je[c[103348>>2]&127](103328,b)}GC(b,c[J>>2]|0,z,d);if((c[61140>>2]|0)!=0){ie[c[15416]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;UC(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){fB(4)}if((iE(b,1,1)|0)!=0){c[B>>2]=1;UC(b)}le[c[(c[K>>2]|0)+88>>2]&127](b)|0;PC(b);YC(b);QC(b);do{if((T|0)==0){_=0}else{cB(7);fB(2);A=(tc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(tc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+ZA(2);if(!$){aa=0;break}aa=(tc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+ZA(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=UA(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(tc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+ZA(ba+9|0);if((ca|0)==0){ka=0}else{ka=(tc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}fB(7);if((la|0)!=0){_=T;break}c[p>>2]=Zd(c[(Pc()|0)>>2]|0)|0;tz(23,0,240,p);_c(T|0)|0;_=0}}while(0);if((c[118724>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;je[c[103348>>2]&127](103328,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[27232]|0)!=0){ca=f;ba=108936;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];jz(M,f);Vd(10,M|0)|0;ba=c[27240]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;rz(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((HD(b,0)|0)!=0){ma=58;break}if((xD(b,0)|0)!=0){ma=58;break}if((kD(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rz(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((HD(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rz(1,0,448,m);U=_;V=-2;break}if((xD(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rz(1,0,536,l);U=_;V=-3;break}T=(kD(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rz(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];rz(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}_c(U|0)|0;i=e;return V|0}function cf(a){a=a|0;i=i;return 0}function df(a){a=a|0;i=i;return 0}function ef(a){a=a|0;i=i;return 0}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+768>>3]=+h[b+32>>3]- +h[(c[a+416>>2]|0)+128>>3];i=i;return}function gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+704>>3]=+h[b+32>>3]*1.0e-5;i=i;return}function hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+696>>3]=+h[b+24>>3]+-273.15;i=i;return}function jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+8>>3]+-273.15;i=i;return}function kf(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Zg(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+32>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+712>>3]=+h[d>>3];i=b;return}function lf(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+760>>3]=+wd(+(+h[d>>3]),.001);i=b;return}function mf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+504>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[27736]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=872;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Le[n&63](m,d,896,e);p=+h[(c[f>>2]|0)+504>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+80>>3]=p+g*+h[f+16>>3]*2.0;i=b;return}function nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+16>>3];wh(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3]+(g*-.1- +h[f+24>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+136>>3]=+h[d>>3];i=b;return}function of(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=b+4|0;l=cD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+24>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;e=k;f=j;break}else{j=b+4|0;k=cD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+24>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;k=b+4|0;j=gD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+24>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;e=k;f=g;break}else{g=b+4|0;k=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+24>>3])|0;a[(c[b+352>>2]|0)+3|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+3|0]=f;i=d;return}function pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+48>>3];wh(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3]+(g*-.1- +h[f+56>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[d>>3];i=b;return}function qf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+2|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;l=cD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+56>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=l;e=k;f=j;break}else{j=b+4|0;k=cD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+56>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;j=gD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+56>>3])|0;a[(c[b+352>>2]|0)+2|0]=j;e=k;f=g;break}else{g=b+4|0;k=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+56>>3])|0;a[(c[b+352>>2]|0)+2|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+4|0]=f;i=d;return}function rf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+80>>3];wh(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3]+(g*-.1- +h[f+88>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[d>>3];i=b;return}function sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+1|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;l=cD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+88>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;e=k;f=j;break}else{j=b+4|0;k=cD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+88>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;j=gD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+88>>3])|0;a[(c[b+352>>2]|0)+1|0]=j;e=k;f=g;break}else{g=b+4|0;k=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+88>>3])|0;a[(c[b+352>>2]|0)+1|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+5|0]=f;i=d;return}function tf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;do{if((a[b+314|0]|0)==0){e=b+416|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+416|0;l=aD(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+672>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+416|0;k=aD(+h[c[c[b+4>>2]>>2]>>3],+h[(c[j>>2]|0)+672>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+416|0;j=dD(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+672>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+416|0;k=dD(+h[c[c[b+4>>2]>>2]>>3],+h[(c[g>>2]|0)+672>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);k=c[e>>2]|0;m=+h[k+664>>3];if(!(f<<24>>24==0)){n=0.0;o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+576|0;A=z;h[A>>3]=o;i=d;return}n=+h[k+680>>3];o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+576|0;A=z;h[A>>3]=o;i=d;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[(c[a+416>>2]|0)+504>>3]*+h[b+16>>3];i=i;return}function vf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Ci(e,c[g>>2]|0,+h[(c[j>>2]|0)+512>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+512>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Ji(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+616>>3]=+h[f>>3];i=b;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=+h[b+632>>3]*+h[b+616>>3];i=i;return}function xf(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+wd(0.0,+(+h[d+16>>3]- +h[e+88>>3]));h[d+128>>3]=+h[e+512>>3]+f*+h[e+776>>3]*+h[d+616>>3];i=b;return}function yf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;Pi(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+128>>3],84013.05815259689,0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+128>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));Ni(f,a,k,84013.05815259689,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+176>>3]=+h[f>>3];i=b;return}function zf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+184>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+184|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+184>>3]);e=c[f>>2]|0;h[c[e+612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+104>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+104|0;h[(c[e+608>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+104>>3]);h[(c[(c[f>>2]|0)+612>>2]|0)+8>>3]=k;GD(a,7)|0;a=c[(c[f>>2]|0)+604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+184>>3]=+h[a>>3];h[f+104>>3]=+h[a+8>>3];i=b;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=+h[b+184>>3]- +h[(c[a+416>>2]|0)+632>>3];i=i;return}function Bf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=c[b+416>>2]|0;l=aD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[k+688>>3]+ +h[k+696>>3]*.5,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;f=j;break}else{j=c[b+416>>2]|0;l=aD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[j+688>>3]+ +h[j+696>>3]*.5,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;l=c[b+416>>2]|0;j=dD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[l+688>>3]+ +h[l+696>>3]*.5)|0;a[(c[b+352>>2]|0)+5|0]=j;f=g;break}else{g=c[b+416>>2]|0;j=dD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[g+688>>3]+ +h[g+696>>3]*.5)|0;a[(c[b+352>>2]|0)+5|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+6|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+6|0]|0;l=c[b+416>>2]|0;k=aD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[l+688>>3]+ +h[l+696>>3]*-.5,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;m=g;break}else{g=c[b+416>>2]|0;k=aD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[g+688>>3]+ +h[g+696>>3]*-.5,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+6|0]|0;k=c[b+416>>2]|0;g=dD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[k+688>>3]+ +h[k+696>>3]*-.5)|0;a[(c[b+352>>2]|0)+6|0]=g;m=j;break}else{j=c[b+416>>2]|0;g=dD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[j+688>>3]+ +h[j+696>>3]*-.5)|0;a[(c[b+352>>2]|0)+6|0]=g;m=g;break}}}}while(0);if(!((a[(c[b+408>>2]|0)+6|0]|0)==0|f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}function Cf(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+7|0]=a[d+6|0]|0;i=i;return}function Df(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+8|0]=(a[d+6|0]|0)==0|0;i=i;return}function Ef(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[e+16>>2]|0;if((a[b+312|0]|0)!=0){g=c[b+416>>2]|0;j=+h[g+720>>3];if((a[f+6|0]|0)==0){k=j}else{k=j+ +h[g+704>>3]}h[(c[e+8>>2]|0)+512>>3]=k;i=d;return}if((a[f+8|0]|0)==0){l=7}else{if((a[(c[b+408>>2]|0)+8|0]|0)!=0){l=7}}do{if((l|0)==7){if((a[f+7|0]|0)!=0){if((a[(c[b+408>>2]|0)+7|0]|0)==0){break}}h[(c[e+8>>2]|0)+512>>3]=+h[(c[b+400>>2]|0)+512>>3];i=d;return}}while(0);l=c[b+416>>2]|0;k=+h[l+720>>3];if((a[f+6|0]|0)==0){m=k}else{m=k+ +h[l+704>>3]}h[(c[e+8>>2]|0)+512>>3]=m;i=d;return}function Ff(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0,s=0.0;d=i;if((a[b+312|0]|0)!=0){e=b+416|0;f=fD(+h[(c[e>>2]|0)+712>>3],0.0)|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[e>>2]|0;do{if(f<<24>>24!=0&(a[(c[j+16>>2]|0)+6|0]|0)!=0){l=+h[k+712>>3];m=+h[k+704>>3];if(l!=0.0){n=m/l;break}if(m==0.0){n=m;break}n=m/+xz(c[b+536>>2]|0,l,1e3,992,+h[j>>3],(a[b+319|0]|0)!=0|0)}else{o=fD(+h[k+728>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+6|0]|0)!=0|o<<24>>24==0){n=0.0;break}o=c[e>>2]|0;l=+h[o+728>>3];m=+h[o+704>>3];q=-m;if(l!=0.0){n=q/l;break}if(m==-0.0){n=q;break}n=q/+xz(c[b+536>>2]|0,l,1024,992,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3]=n;i=d;return}g=b+4|0;e=c[c[g>>2]>>2]|0;k=c[e+16>>2]|0;if((a[k+8|0]|0)==0){r=15}else{if((a[(c[b+408>>2]|0)+8|0]|0)!=0){r=15}}do{if((r|0)==15){if((a[k+7|0]|0)!=0){if((a[(c[b+408>>2]|0)+7|0]|0)==0){break}}h[(c[e+8>>2]|0)+504>>3]=+h[(c[b+400>>2]|0)+504>>3];i=d;return}}while(0);e=b+416|0;k=fD(+h[(c[e>>2]|0)+712>>3],0.0)|0;r=c[c[g>>2]>>2]|0;j=c[e>>2]|0;do{if(k<<24>>24!=0&(a[(c[r+16>>2]|0)+6|0]|0)!=0){n=+h[j+712>>3];l=+h[j+704>>3];if(n!=0.0){s=l/n;break}if(l==0.0){s=l;break}s=l/+xz(c[b+536>>2]|0,n,1e3,992,+h[r>>3],(a[b+319|0]|0)!=0|0)}else{f=fD(+h[j+728>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+6|0]|0)!=0|f<<24>>24==0){s=0.0;break}f=c[e>>2]|0;n=+h[f+728>>3];l=+h[f+704>>3];q=-l;if(n!=0.0){s=q/n;break}if(l==-0.0){s=q;break}s=q/+xz(c[b+536>>2]|0,n,1024,992,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3]=s;i=d;return}function Gf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0,y=0.0,z=0,A=0.0;d=i;e=b+312|0;if((a[e]|0)!=0){f=b+416|0;g=fD(+h[(c[f>>2]|0)+712>>3],0.0)|0;j=fD(+h[(c[f>>2]|0)+728>>3],0.0)|0;k=fD(+U(+(+h[(c[f>>2]|0)+704>>3])),0.0)|0;f=b+4|0;l=c[c[f>>2]>>2]|0;m=a[(c[l+16>>2]|0)+6|0]|0;do{if(m<<24>>24!=0&g<<24>>24==0){n=4}else{if(!(k<<24>>24!=0&(m|j)<<24>>24!=0&(a[e]|0)==0)){n=4;break}o=+h[l>>3];p=c[l+8>>2]|0;q=+h[p+504>>3];r=+h[p+512>>3]- +h[(c[b+400>>2]|0)+520>>3];do{if(q!=0.0){s=l;t=r/q}else{if(r==0.0){s=l;t=r;break}u=r/+xz(c[b+536>>2]|0,q,1064,1056,o,(a[b+319|0]|0)!=0|0);s=c[c[f>>2]>>2]|0;t=u}}while(0);v=s;w=o+t}}while(0);if((n|0)==4){v=l;w=+h[l>>3]}h[(c[v+8>>2]|0)+496>>3]=w;i=d;return}v=b+4|0;l=c[c[v>>2]>>2]|0;s=c[l+16>>2]|0;if((a[s+8|0]|0)==0){n=13}else{if((a[(c[b+408>>2]|0)+8|0]|0)!=0){n=13}}do{if((n|0)==13){if((a[s+7|0]|0)!=0){if((a[(c[b+408>>2]|0)+7|0]|0)==0){break}}h[(c[l+8>>2]|0)+496>>3]=+h[(c[b+400>>2]|0)+496>>3];i=d;return}}while(0);l=b+416|0;s=fD(+h[(c[l>>2]|0)+712>>3],0.0)|0;f=fD(+h[(c[l>>2]|0)+728>>3],0.0)|0;j=fD(+U(+(+h[(c[l>>2]|0)+704>>3])),0.0)|0;l=c[c[v>>2]>>2]|0;m=a[(c[l+16>>2]|0)+6|0]|0;do{if(m<<24>>24!=0&s<<24>>24==0){n=17}else{if(!(j<<24>>24!=0&(m|f)<<24>>24!=0&(a[e]|0)==0)){n=17;break}w=+h[l>>3];k=c[l+8>>2]|0;t=+h[k+504>>3];q=+h[k+512>>3]- +h[(c[b+400>>2]|0)+520>>3];do{if(t!=0.0){x=l;y=q/t}else{if(q==0.0){x=l;y=q;break}r=q/+xz(c[b+536>>2]|0,t,1064,1056,w,(a[b+319|0]|0)!=0|0);x=c[c[v>>2]>>2]|0;y=r}}while(0);z=x;A=w+y}}while(0);if((n|0)==17){z=l;A=+h[l>>3]}h[(c[z+8>>2]|0)+496>>3]=A;i=d;return}function Hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+7|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+7|0]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=aD(+h[l>>3],+h[(c[l+8>>2]|0)+496>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=m;e=k;f=j;break}else{j=b+4|0;k=c[c[j>>2]>>2]|0;m=aD(+h[k>>3],+h[(c[k+8>>2]|0)+496>>3],a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=m;e=j;f=m;break}}else{if(g){g=a[(c[b+356>>2]|0)+7|0]|0;m=b+4|0;j=c[c[m>>2]>>2]|0;k=dD(+h[j>>3],+h[(c[j+8>>2]|0)+496>>3])|0;a[(c[b+352>>2]|0)+7|0]=k;e=m;f=g;break}else{g=b+4|0;m=c[c[g>>2]>>2]|0;k=dD(+h[m>>3],+h[(c[m+8>>2]|0)+496>>3])|0;a[(c[b+352>>2]|0)+7|0]=k;e=g;f=k;break}}}}while(0);b=c[c[e>>2]>>2]|0;e=c[b+8>>2]|0;n=+h[e+512>>3];if(f<<24>>24==0){o=n;p=e;q=p+520|0;r=q;h[r>>3]=o;i=d;return}o=n-(+h[e+496>>3]- +h[b>>3])*+h[e+504>>3];p=e;q=p+520|0;r=q;h[r>>3]=o;i=d;return}function If(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+744>>3];g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[e+736>>3]*+h[k+520>>3]- +h[k>>3];if(f!=0.0){m=k;n=l/f;o=m;p=o+40|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+40|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[b+536>>2]|0,f,1096,1088,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+40|0;q=p;h[q>>3]=n;i=d;return}function Jf(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+wd(0.0,+(+h[d+16>>3]- +h[e+56>>3]));h[d+120>>3]=+h[e+512>>3]+f*+h[e+776>>3]*+h[d+616>>3];i=b;return}function Kf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+120>>3],+h[a+1128>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+120>>3];l=+h[g+1128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+168>>3]=+h[f>>3];i=b;return}function Lf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+96>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+96|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+96>>3]);e=c[f>>2]|0;h[c[e+692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+192>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+192|0;h[(c[e+688>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+192>>3]);h[(c[(c[f>>2]|0)+692>>2]|0)+8>>3]=k;GD(a,8)|0;j=c[(c[f>>2]|0)+684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+96>>3]=+h[j>>3];h[f+192>>3]=+h[j+8>>3];vj(a);wj(a);xj(a);i=b;return}function Mf(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+wd(0.0,+(+h[d+16>>3]- +h[e+24>>3]));h[d+112>>3]=+h[e+512>>3]+f*+h[e+776>>3]*+h[d+616>>3];i=b;return}function Nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Ci(e,c[g>>2]|0,+h[(c[j>>2]|0)+512>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+512>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Hi(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+624>>3]=+h[f>>3];i=b;return}function Of(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+624>>3];k=+h[g+616>>3];l=+h[(c[b+416>>2]|0)+512>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+608|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+608|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,1112,1104,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+608|0;r=q;h[r>>3]=o;i=d;return}function Pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+672>>3]=+h[b+664>>3]*+h[b+608>>3];i=i;return}function Qf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0,y=0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=fD(-+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;m=fD(-+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Pi(g,c[n>>2]|0,+h[o+120>>3],+h[(m<<24>>24==0?o+624|0:o+1128|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+120>>3];s=+h[(l<<24>>24==0?q+624|0:q+1128|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));Ni(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+432>>3];r=+h[p+544>>3];t=-r;if(s!=0.0){u=p;v=t/s;w=u;x=w+408|0;y=x;h[y>>3]=v;i=d;return}if(r==-0.0){u=p;v=t;w=u;x=w+408|0;y=x;h[y>>3]=v;i=d;return}r=t/+xz(c[n>>2]|0,s,1144,1136,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;v=r;w=u;x=w+408|0;y=x;h[y>>3]=v;i=d;return}function Rf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+408>>3];e=c[a+416>>2]|0;h[b+360>>3]=-(+h[b+544>>3]*(d*d*.5+ +h[e+776>>3]*+h[e+56>>3]));i=i;return}function Sf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=fD(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+384>>3]=-(+h[e+544>>3]*+h[(a<<24>>24==0?e+624|0:e+1128|0)>>3]);i=b;return}function Tf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+192>>3],+h[a+624>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+192>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Gi(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+584>>3]=+h[f>>3];i=b;return}function Uf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Pi(e,c[j>>2]|0,+h[l+192>>3],+h[l+1128>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+192>>3];o=+h[m+1128>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));Gi(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;wh(g,c[j>>2]|0,+h[d+544>>3],+h[d+584>>3],+h[f>>3],+h[(c[a+416>>2]|0)+584>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+568>>3]=+h[g>>3];i=b;return}function Vf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+192>>3],+h[a+624>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+192>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+592>>3]=+h[f>>3];i=b;return}function Wf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;wh(e,c[f>>2]|0,+h[j+544>>3],+h[j+592>>3],+h[j+1088>>3],+h[(c[b+416>>2]|0)+584>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+544>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+536|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+536|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[f>>2]|0,k,1520,1512,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+536|0;q=p;h[q>>3]=n;i=d;return}function Xf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+864>>3]=+h[b+624>>3]+ +h[d+776>>3]*+h[d+192>>3];i=i;return}function Yf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;Pi(e,c[j>>2]|0,+h[(c[k>>2]|0)+632>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+624>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+632>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+624>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));Gi(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;wh(g,c[j>>2]|0,-+h[d+544>>3],+h[d+1080>>3],+h[f>>3],+h[(c[k>>2]|0)+584>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+560>>3]=+h[g>>3];i=b;return}function Zf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Ci(e,c[g>>2]|0,+h[a+32>>3],+h[a+24>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+32>>3];l=+h[g+24>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ji(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+688>>3]=+h[f>>3];i=b;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+688>>3]*.05;i=i;return}function $f(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+688>>3]*9.80665;k=+h[g+768>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+680|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+680|0;p=o;h[p>>3]=m;i=d;return}q=k/+xz(c[b+536>>2]|0,j,1648,1640,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+680|0;p=o;h[p>>3]=m;i=d;return}function ag(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+752>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+752|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+752>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+736>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+736|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+736>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+8>>3]=k;GD(a,9)|0;a=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+752>>3]=+h[a>>3];h[f+736>>3]=+h[a+8>>3];i=b;return}function bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+800>>3]=+h[b+736>>3]*+(c[(c[a+420>>2]|0)+20>>2]|0);i=i;return}function cg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0;d=i;i=i+16|0;e=d;f=d+8|0;g=b+536|0;j=c[g>>2]|0;k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;n=+h[m+736>>3];o=+h[m+760>>3];p=+h[(c[b+416>>2]|0)+344>>3];do{if(o!=0.0){q=p/o}else{if(p==0.0){q=p;break}q=p/+xz(j,o,1688,1680,+h[l>>3],(a[b+319|0]|0)!=0|0)}}while(0);ih(e,j,n*q,.8);q=+h[e>>3];ih(f,c[g>>2]|0,0.0,.8);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+784>>3]=q;i=d;return}function dg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+768>>3];k=+h[g+784>>3];l=+h[g+736>>3];if(k!=0.0){m=g;n=l/k;o=j*n;p=m;q=p+792|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j*n;p=m;q=p+792|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,1704,1696,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+792|0;r=q;h[r>>3]=o;i=d;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=+h[b+792>>3]*+(c[(c[a+420>>2]|0)+20>>2]|0);i=i;return}function fg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+776>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+776|0;h[c[g+848>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+776>>3]);h[c[(c[f>>2]|0)+852>>2]>>3]=k;GD(a,10)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+776>>3]=+h[c[(c[f>>2]|0)+844>>2]>>3];i=b;return}function gg(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[(c[b+420>>2]|0)+20>>2]|0;f=+(e|0);g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+776>>3];if((e|0)!=0){m=k;n=l/f;o=m;p=o+744|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+744|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[b+536>>2]|0,f,1728,1720,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+744|0;q=p;h[q>>3]=n;i=d;return}function hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Ci(e,c[g>>2]|0,+h[a+32>>3],+h[a+24>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+32>>3];l=+h[g+24>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Hi(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[f>>3];i=b;return}function ig(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+728>>3];k=+h[g+688>>3];l=+h[g+32>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+720|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+720|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,1768,1760,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+720|0;r=q;h[r>>3]=o;i=d;return}function jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+840>>3]=+h[b+832>>3]*+h[b+720>>3];i=i;return}function kg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+848>>3]=+h[b+728>>3]- +h[d+776>>3]*+h[d+192>>3];i=i;return}function lg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+112>>3],+h[a+848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+112>>3];l=+h[g+848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[f>>3];i=b;return}function mg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+32>>3],+h[a+728>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+32>>3];l=+h[g+728>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+296>>3]=+h[f>>3];i=b;return}function ng(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+32>>3],+h[a+728>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+32>>3];l=+h[g+728>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Gi(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+256>>3]=+h[f>>3];i=b;return}function og(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Fi(d,c[a+536>>2]|0,+h[f+296>>3],+h[f+256>>3],+h[f+32>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+272>>3]=+h[d>>3];i=b;return}function pg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+88>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+88|0;h[c[g+928>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+88>>3]);e=c[f>>2]|0;h[c[e+932>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+924>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+856>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+856|0;h[(c[e+928>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+856>>3]);h[(c[(c[f>>2]|0)+932>>2]|0)+8>>3]=k;GD(a,11)|0;j=c[(c[f>>2]|0)+924>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+88>>3]=+h[j>>3];h[f+856>>3]=+h[j+8>>3];Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Jj(a);Kj(a);i=b;return}function qg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+216>>3]*+h[j+296>>3]*+h[e+160>>3];l=+h[j+224>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+232|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+232|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[b+536>>2]|0,k,1792,1784,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+232|0;q=p;h[q>>3]=n;i=d;return}function rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+224>>3]*+h[(c[a+416>>2]|0)+168>>3];i=i;return}function sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+656>>3]=+h[b+224>>3]- +h[b+544>>3];i=i;return}function tg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;m=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Pi(g,c[n>>2]|0,+h[o+112>>3],+h[(m<<24>>24==0?o+624|0:o+848|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+112>>3];s=+h[(l<<24>>24==0?q+624|0:q+848|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));Ni(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+424>>3];r=+h[p+224>>3];if(s!=0.0){t=p;u=r/s;v=t;w=v+400|0;x=w;h[x>>3]=u;i=d;return}if(r==0.0){t=p;u=r;v=t;w=v+400|0;x=w;h[x>>3]=u;i=d;return}y=r/+xz(c[n>>2]|0,s,1864,1856,+h[e>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[k>>2]>>2]|0)+8>>2]|0;u=y;v=t;w=v+400|0;x=w;h[x>>3]=u;i=d;return}function ug(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=fD(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+376>>3]=+h[e+224>>3]*+h[(a<<24>>24==0?e+624|0:e+848|0)>>3];i=b;return}function vg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+400>>3];e=c[a+416>>2]|0;h[b+352>>3]=+h[b+224>>3]*(d*d*.5+ +h[e+776>>3]*+h[e+24>>3]);i=i;return}function wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=+h[b+376>>3]+(+h[b+384>>3]+(+h[b+352>>3]+ +h[b+360>>3]));i=i;return}function xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+48>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+48|0;h[c[g+1008>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+48>>3]);h[c[(c[f>>2]|0)+1012>>2]>>3]=k;GD(a,12)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[c[(c[f>>2]|0)+1004>>2]>>3];Nj(a);Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);i=b;return}function yg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+504>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+872>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}q=k/+xz(c[b+536>>2]|0,e,2264,2256,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}function zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[b+776>>3]- +h[b+224>>3];i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=-+h[b+824>>3]/-.05;i=i;return}function Bg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+216>>3]*+h[j+304>>3]*+h[e+160>>3];l=+h[j+224>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+240|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+240|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[b+536>>2]|0,k,2296,2288,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+240|0;q=p;h[q>>3]=n;i=d;return}function Cg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(fD(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+288>>3]=+h[(a?e+304|0:e+296|0)>>3];i=b;return}function Dg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(fD(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+264>>3]=+h[(a?e+280|0:e+272|0)>>3];i=b;return}function Eg(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;a=fD(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+776>>3],0.0)|0;e=fD(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=f+728|0;h[f+816>>3]=+h[f+776>>3]*+h[(a<<24>>24==0?d:f+1152|0)>>3]- +h[f+224>>3]*+h[(e<<24>>24==0?d:f+864|0)>>3];i=b;return}function Fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+896>>3]=+h[b+816>>3]+ +h[b+808>>3];i=i;return}function Gg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+832>>3];k=+h[g+896>>3]- +h[g+824>>3]*+h[g+720>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}q=k/+xz(c[b+536>>2]|0,j,2368,2360,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}function Hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+72>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+72|0;h[c[g+1088>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+72>>3]);e=c[f>>2]|0;h[c[e+1092>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1084>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+64>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+64|0;h[(c[e+1088>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+64>>3]);j=c[f>>2]|0;h[(c[j+1092>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+1084>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+920>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+920|0;h[(c[j+1088>>2]|0)+16>>3]=+h[e>>3];k=+ID(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+920>>3]);h[(c[(c[f>>2]|0)+1092>>2]|0)+16>>3]=k;GD(a,13)|0;a=c[(c[f>>2]|0)+1084>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+72>>3]=+h[a>>3];h[f+64>>3]=+h[a+8>>3];h[f+920>>3]=+h[a+16>>3];i=b;return}function Ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((gD(+h[f+168>>3],+h[f+192>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[27736]|0;g=d;j=2448;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Le[a&63](f,d,2472,e);i=b;return}function Jg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((gD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],0.0)|0)<<24>>24==0)){i=b;return}g=gA(gA(gA(gA(2528,eA(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],0,1,6)|0)|0,2544)|0,2568)|0,2584)|0;j=gA(gA(g,eA(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,2616)|0;f=c[a+536>>2]|0;a=c[27736]|0;g=d;k=3144;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Le[a&63](f,d,j,e);i=b;return}function Kg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((gD(+h[(c[f>>2]|0)+512>>3],0.0)|0)<<24>>24==0)){i=b;return}g=gA(gA(gA(gA(2528,eA(+h[(c[f>>2]|0)+512>>3],0,1,6)|0)|0,2544)|0,2568)|0,2584)|0;f=gA(gA(g,eA(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,2616)|0;g=c[a+536>>2]|0;a=c[27736]|0;j=d;k=3144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[a&63](g,d,f,e);i=b;return}function Lg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((eD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[a+416>>2]|0)+528>>3])|0)<<24>>24==0)){i=b;return}g=gA(gA(2696,eA(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,2752)|0;f=c[a+536>>2]|0;a=c[27736]|0;j=d;k=2832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[a&63](f,d,g,e);i=b;return}function Mg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((fD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[a+416>>2]|0)+528>>3]*-1.0e-6)|0)<<24>>24==0)){i=b;return}g=gA(gA(2856,eA(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,2872)|0;f=c[a+536>>2]|0;a=c[27736]|0;j=d;k=2928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Le[a&63](f,d,g,e);i=b;return}function Ng(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((fD(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+544>>3],-+h[(c[a+416>>2]|0)+584>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[27736]|0;g=d;j=3032;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Le[a&63](f,d,3056,e);i=b;return}function Og(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((gD(+h[(c[f>>2]|0)+128>>3],0.0)|0)<<24>>24==0)){i=b;return}g=gA(gA(gA(gA(2528,eA(+h[(c[f>>2]|0)+128>>3],0,1,6)|0)|0,2544)|0,2568)|0,2584)|0;j=gA(gA(g,eA(+h[(c[f>>2]|0)+144>>3],0,1,6)|0)|0,2616)|0;f=c[a+536>>2]|0;a=c[27736]|0;g=d;k=3144;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Le[a&63](f,d,j,e);i=b;return}function Pg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+16|0;mB(h,1,3120,g);g=c[a+416>>2]|0;c[f>>2]=1;uA(j,g,1,f);f=c[a+536>>2]|0;a=e;g=h;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];g=d;a=j;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];sh(f,2568,e,0,1,d,3128);i=b;return}function Qg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((gD(+h[(c[f>>2]|0)+632>>3],0.0)|0)<<24>>24==0)){i=b;return}g=gA(gA(gA(gA(2528,eA(+h[(c[f>>2]|0)+632>>3],0,1,6)|0)|0,2544)|0,2568)|0,2584)|0;j=gA(gA(g,eA(+h[(c[f>>2]|0)+648>>3],0,1,6)|0)|0,2616)|0;f=c[a+536>>2]|0;a=c[27736]|0;g=d;k=3144;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Le[a&63](f,d,j,e);i=b;return}function Rg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+16|0;mB(h,1,3120,g);g=(c[a+416>>2]|0)+120|0;c[f>>2]=1;uA(j,g,1,f);f=c[a+536>>2]|0;a=e;g=h;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];g=d;a=j;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];sh(f,2568,e,0,1,d,3128);i=b;return}function Sg(b){b=b|0;var d=0,e=0;d=i;a[b+315|0]=0;a[b+314|0]=1;ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);e=b+484|0;c[c[(c[e>>2]|0)+60>>2]>>2]=(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+2;c[c[(c[e>>2]|0)+64>>2]>>2]=(c[b+408>>2]|0)+2;jD(b,1)|0;Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);i=d;return 0}function Tg(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Ug(b);i=c;return 0}function Ug(a){a=a|0;var b=0;b=i;ff(a);lf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Of(a);Qf(a);Rf(a);Sf(a);Xf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);hg(a);ig(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Eg(a);Fg(a);Gg(a);Hg(a);i=b;return}function Vg(a,b){a=a|0;b=+b;i=i;return 0}function Wg(a){a=a|0;var b=0;b=i;i=i+8|0;uz(c[a+536>>2]|0,(a|0)!=0|0,3376,b);c[a+540>>2]=3184;c[a+84>>2]=3408;c[a+88>>2]=3408;c[a+92>>2]=3448;c[a+96>>2]=3520;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=5;c[a+116>>2]=154;c[a+120>>2]=3;c[a+124>>2]=11;c[a+128>>2]=9;c[a+132>>2]=0;c[a+136>>2]=105;c[a+140>>2]=25;c[a+144>>2]=52;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=143;c[a+220>>2]=7;c[a+224>>2]=1;c[a+228>>2]=0;c[a+160>>2]=10;c[a+104>>2]=0;c[a+164>>2]=11;c[a+168>>2]=0;c[a+176>>2]=8;c[a+180>>2]=0;c[a+184>>2]=8;c[a+188>>2]=0;c[a+56>>2]=3560;c[a+64>>2]=132;c[a+72>>2]=0;c[a+68>>2]=655;c[a+192>>2]=2;c[a+196>>2]=1;c[a+200>>2]=14;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function Xg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=q3(c[k>>2]|0,e)|0;if((l|0)==0){fb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=62240;F=62264;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[15560]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=q3(c[F>>2]|0,e)|0;if((G|0)==0){fb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[14704]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=q3(c[H>>2]|0,e)|0;if((I|0)==0){fb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ha(48,c[14704]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=q3(c[H>>2]|0,e)|0;if((K|0)==0){fb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;c3(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=q3(c[L>>2]|0,e)|0;if((M|0)==0){fb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;c3(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=q3(c[I>>2]|0,e)|0;if((N|0)==0){fb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ha(48,c[14704]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=q3(c[M>>2]|0,e)|0;if((R|0)==0){fb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=q3(c[M>>2]|0,e)|0;if((V|0)==0){fb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=q3(c[M>>2]|0,e)|0;if((W|0)==0){fb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Ra(34,3608,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=q3(c[M>>2]|0,e)|0;if((ba|0)==0){fb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=q3(c[M>>2]|0,e)|0;if((ca|0)==0){fb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=q3(c[M>>2]|0,e)|0;if((da|0)==0){fb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=q3(c[M>>2]|0,e)|0;if((ea|0)==0){fb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=q3(c[h>>2]|0,e)|0;if((fa|0)==0){fb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=q3(c[h>>2]|0,e)|0;if((ga|0)==0){fb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ha(48,c[14704]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=q3(c[h>>2]|0,e)|0;if((ha|0)==0){fb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=q3(c[h>>2]|0,e)|0;if((ia|0)==0){fb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=q3(c[h>>2]|0,e)|0;if((ja|0)==0){fb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=q3(c[M>>2]|0,e)|0;if((ka|0)==0){fb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function Yg(){var a=0;a=i;xd(0)|0;tc(3768,18,1,c[r>>2]|0)|0;xd(0)|0;i=a;return}function Zg(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=20;wA(ia,1,ha);if(!(d>611.657)){ha=gA(gA(3792,eA(d,0,1,6)|0)|0,3856)|0;ja=gA(gA(ha,eA(611.657,0,1,6)|0)|0,3864)|0;ha=c[27736]|0;ka=f;la=3984;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];Le[ha&63](b,f,ja,ga);}ma=+vd(+d,22064.0e3)*1.0e-6;d=+W(+ma,.25);c[fa>>2]=1;h[(EA(ia,1,fa)|0)>>3]=d;c[ea>>2]=1;d=+h[(EA(ia,1,ea)|0)>>3]*-3232555.0322333;c[da>>2]=2;h[(EA(ia,1,da)|0)>>3]=d;d=+V(+ma);c[ca>>2]=3;h[(EA(ia,1,ca)|0)>>3]=d;c[ba>>2]=3;d=+h[(EA(ia,1,ba)|0)>>3]*-724213.16703206;c[aa>>2]=4;h[(EA(ia,1,aa)|0)>>3]=d;c[$>>2]=2;d=+h[(EA(ia,1,$)|0)>>3];c[_>>2]=4;ma=d+ +h[(EA(ia,1,_)|0)>>3]+405113.40542057;c[Z>>2]=5;h[(EA(ia,1,Z)|0)>>3]=ma;c[Y>>2]=1;ma=+h[(EA(ia,1,Y)|0)>>3]*-17.073846940092;c[X>>2]=6;h[(EA(ia,1,X)|0)>>3]=ma;c[U>>2]=3;ma=+h[(EA(ia,1,U)|0)>>3];c[T>>2]=6;d=ma+ +h[(EA(ia,1,T)|0)>>3]+14.91510861353;c[S>>2]=7;h[(EA(ia,1,S)|0)>>3]=d;c[R>>2]=5;d=+h[(EA(ia,1,R)|0)>>3];c[Q>>2]=7;ma=d*+h[(EA(ia,1,Q)|0)>>3]*-4.0;c[P>>2]=8;h[(EA(ia,1,P)|0)>>3]=ma;c[O>>2]=1;ma=+h[(EA(ia,1,O)|0)>>3]*12020.82470247;c[N>>2]=9;h[(EA(ia,1,N)|0)>>3]=ma;c[M>>2]=3;ma=+h[(EA(ia,1,M)|0)>>3]*1167.0521452767;c[L>>2]=10;h[(EA(ia,1,L)|0)>>3]=ma;c[K>>2]=10;ma=+h[(EA(ia,1,K)|0)>>3];c[J>>2]=9;d=ma+ +h[(EA(ia,1,J)|0)>>3]+-4823.2657361591;c[I>>2]=11;h[(EA(ia,1,I)|0)>>3]=d;c[H>>2]=11;d=+h[(EA(ia,1,H)|0)>>3];c[G>>2]=12;h[(EA(ia,1,G)|0)>>3]=d*d;c[F>>2]=12;d=+h[(EA(ia,1,F)|0)>>3];c[E>>2]=8;ma=d+ +h[(EA(ia,1,E)|0)>>3];c[D>>2]=13;h[(EA(ia,1,D)|0)>>3]=ma;c[C>>2]=13;ma=+V(+(+h[(EA(ia,1,C)|0)>>3]));c[B>>2]=14;h[(EA(ia,1,B)|0)>>3]=ma;c[A>>2]=14;ma=-+h[(EA(ia,1,A)|0)>>3];c[z>>2]=15;h[(EA(ia,1,z)|0)>>3]=ma;c[y>>2]=1;ma=+h[(EA(ia,1,y)|0)>>3]*-12020.82470247;c[x>>2]=16;h[(EA(ia,1,x)|0)>>3]=ma;c[w>>2]=3;ma=+h[(EA(ia,1,w)|0)>>3]*-1167.0521452767;c[v>>2]=17;h[(EA(ia,1,v)|0)>>3]=ma;c[u>>2]=15;ma=+h[(EA(ia,1,u)|0)>>3];c[t>>2]=16;d=+h[(EA(ia,1,t)|0)>>3];c[s>>2]=17;na=ma+(d+ +h[(EA(ia,1,s)|0)>>3])+4823.2657361591;c[r>>2]=18;h[(EA(ia,1,r)|0)>>3]=na;c[q>>2]=18;na=1.0/+h[(EA(ia,1,q)|0)>>3];c[p>>2]=19;h[(EA(ia,1,p)|0)>>3]=na;c[o>>2]=19;na=+h[(EA(ia,1,o)|0)>>3];c[n>>2]=5;d=na*+h[(EA(ia,1,n)|0)>>3]*2.0;c[m>>2]=20;h[(EA(ia,1,m)|0)>>3]=d;c[l>>2]=20;d=+h[(EA(ia,1,l)|0)>>3]+650.17534844798;c[k>>2]=20;na=+h[(EA(ia,1,k)|0)>>3];c[j>>2]=19;ma=+h[(EA(ia,1,j)|0)>>3];c[g>>2]=5;h[a>>3]=(na- +V(+(d*d+(ma*+h[(EA(ia,1,g)|0)>>3]*1300.35069689596+-.23855557567849)*-4.0))+650.17534844798)*.5;i=e;return}function _g(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function $g(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;ah(a,b,c,d,0);i=e;return}function ah(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;Ci(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));Hi(f,0,0.0,0.0,h);i=g;return}function bh(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0.0;g=i;i=i+56|0;f=g;j=g+8|0;k=g+16|0;$g(f,b,d,e,0);l=+h[f>>3];ch(j,b,d,e,0);_g(k,0,1,l,+h[j>>3],e,d);d=+h[k+8>>3];e=+h[k+16>>3];l=+h[k+24>>3];m=+h[k+32>>3];c[a>>2]=c[k>>2];h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=l;h[a+32>>3]=m;i=g;return}function ch(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;dh(a,b,c,d,0);i=e;return}function dh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;Ci(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));Ji(f,0,0.0,0.0,h);i=g;return}function eh(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function fh(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+96|0;h=g;j=g+40|0;k=g+56|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];bh(k,b,d,e,j,0);j=a;a=h+0|0;b=k+0|0;k=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(k|0));eh(j,0,h);i=g;return}function gh(b,d,e,f,g){b=b|0;d=d|0;e=+e;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0;j=i;i=i+64|0;l=j;m=j+24|0;n=j+40|0;o=j+56|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+16|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+16|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+16|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+16|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+16|0;Ba=i;i=i+16|0;Ca=i;i=i+16|0;Da=i;i=i+16|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;c[ra>>2]=3;wA(sa,1,ra);c[qa>>2]=1;Qa=+h[(EA(f,1,qa)|0)>>3];c[pa>>2]=2;Ra=+h[(EA(f,1,pa)|0)>>3];c[oa>>2]=3;Sa=+h[(EA(f,1,oa)|0)>>3];oa=na;h[k>>3]=Ra*Ra;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];oa=na+8|0;h[k>>3]=Sa*Sa;c[oa>>2]=c[k>>2];c[oa+4>>2]=c[k+4>>2];DA(ta,3,Qa*Qa,na);yA(ta,sa);c[ma>>2]=1;Qa=+h[(EA(f,1,ma)|0)>>3];c[la>>2]=2;Sa=+h[(EA(f,1,la)|0)>>3];c[ka>>2]=3;Ra=+h[(EA(f,1,ka)|0)>>3];ka=ja;h[k>>3]=Sa*Sa;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=ja+8|0;h[k>>3]=Ra*Ra;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];DA(ua,3,Qa*Qa,ja);ja=sa;ka=ua;c[ja+0>>2]=c[ka+0>>2];c[ja+4>>2]=c[ka+4>>2];c[ja+8>>2]=c[ka+8>>2];c[ia>>2]=3;wA(va,1,ia);GA(1.0,2,xa);c[ha>>2]=1;GA(+h[(EA(f,1,ha)|0)>>3],2,ya);c[ga>>2]=1;GA(+h[(EA(sa,1,ga)|0)>>3],2,za);GA(1.0,2,Ba);c[fa>>2]=2;GA(+h[(EA(f,1,fa)|0)>>3],2,Ca);c[ea>>2]=2;GA(+h[(EA(sa,1,ea)|0)>>3],2,Da);GA(1.0,2,Fa);c[da>>2]=3;GA(+h[(EA(f,1,da)|0)>>3],2,Ga);c[ca>>2]=3;GA(+h[(EA(sa,1,ca)|0)>>3],2,Ha);c[ba>>2]=ya;c[ba+4>>2]=za;FA(2,wa,3,xa,ba);c[aa>>2]=Ca;c[aa+4>>2]=Da;FA(2,Aa,3,Ba,aa);c[$>>2]=Ga;c[$+4>>2]=Ha;FA(2,Ea,3,Fa,$);c[_>>2]=Aa;c[_+4>>2]=Ea;FA(1,Ia,3,wa,_);c[Z>>2]=1;Qa=+h[(EA(g,1,Z)|0)>>3];c[Y>>2]=2;Ra=+h[(EA(g,1,Y)|0)>>3];c[X>>2]=3;Sa=+h[(EA(g,1,X)|0)>>3];X=W;h[k>>3]=Ra;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];X=W+8|0;h[k>>3]=Sa;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];DA(Ja,3,Qa,W);W=Ka;X=n;Y=Ia;c[X+0>>2]=c[Y+0>>2];c[X+4>>2]=c[Y+4>>2];c[X+8>>2]=c[Y+8>>2];Y=m;X=Ja;c[Y+0>>2]=c[X+0>>2];c[Y+4>>2]=c[X+4>>2];c[Y+8>>2]=c[X+8>>2];hh(W,d,n,m);m=Ka;Ka=va;c[Ka+0>>2]=c[m+0>>2];c[Ka+4>>2]=c[m+4>>2];c[Ka+8>>2]=c[m+8>>2];c[V>>2]=1;Qa=+h[(EA(f,1,V)|0)>>3];c[U>>2]=2;Sa=+h[(EA(f,1,U)|0)>>3];c[T>>2]=3;Ra=+h[(EA(f,1,T)|0)>>3];T=S;h[k>>3]=Sa;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S+8|0;h[k>>3]=Ra;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];DA(La,3,Qa,S);Qa=+JA(La);c[R>>2]=1;Ra=+h[(EA(f,1,R)|0)>>3];c[Q>>2]=2;Sa=+h[(EA(f,1,Q)|0)>>3];c[P>>2]=3;Ta=+h[(EA(f,1,P)|0)>>3];P=O;h[k>>3]=Sa;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];P=O+8|0;h[k>>3]=Ta;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];DA(Ma,3,Ra,O);Ra=+IA(Ma);do{if(!(a[4008]&1)){c[N>>2]=1;Ta=+h[(EA(f,1,N)|0)>>3];c[M>>2]=3;Sa=Ta*+h[(EA(va,1,M)|0)>>3]*2.0;c[L>>2]=2;Ta=Sa+ +h[(EA(va,1,L)|0)>>3];c[K>>2]=2;Sa=+h[(EA(f,1,K)|0)>>3];c[J>>2]=3;Ua=Sa*+h[(EA(va,1,J)|0)>>3]*2.0;c[I>>2]=2;Sa=Ua+ +h[(EA(va,1,I)|0)>>3];c[H>>2]=3;Ua=+h[(EA(f,1,H)|0)>>3];c[G>>2]=3;Va=Ua*+h[(EA(va,1,G)|0)>>3]*2.0;c[F>>2]=2;Ua=Va+ +h[(EA(va,1,F)|0)>>3];Ma=E;h[k>>3]=Sa;c[Ma>>2]=c[k>>2];c[Ma+4>>2]=c[k+4>>2];Ma=E+8|0;h[k>>3]=Ua;c[Ma>>2]=c[k>>2];c[Ma+4>>2]=c[k+4>>2];DA(Na,3,Ta,E);if(+IA(Na)<=-1.0e-60){break}Ma=c[27738]|0;O=l;P=4088;c[O+0>>2]=c[P+0>>2];c[O+4>>2]=c[P+4>>2];c[O+8>>2]=c[P+8>>2];c[O+12>>2]=c[P+12>>2];c[O+16>>2]=c[P+16>>2];c[O+20>>2]=c[P+20>>2];He[Ma&15](l,4112,D);a[4008]=1}}while(0);if(Qa>e){c[C>>2]=1;Ta=+h[(EA(g,1,C)|0)>>3];c[B>>2]=2;Ua=+h[(EA(g,1,B)|0)>>3];c[A>>2]=3;Sa=+h[(EA(g,1,A)|0)>>3];A=z;h[k>>3]=Ua;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Sa;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];DA(Oa,3,Ta,z);Ta=+IA(Oa);c[y>>2]=2;Sa=+h[(EA(va,1,y)|0)>>3];c[x>>2]=3;Wa=Ta+(e-Qa)*(Sa+Qa*+h[(EA(va,1,x)|0)>>3]*2.0);Xa=b;Ya=Xa;h[Ya>>3]=Wa;i=j;return}if(Ra<e){c[w>>2]=1;Qa=+h[(EA(g,1,w)|0)>>3];c[v>>2]=2;Sa=+h[(EA(g,1,v)|0)>>3];c[u>>2]=3;Ta=+h[(EA(g,1,u)|0)>>3];u=t;h[k>>3]=Sa;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t+8|0;h[k>>3]=Ta;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];DA(Pa,3,Qa,t);Qa=+JA(Pa);c[s>>2]=2;Ta=+h[(EA(va,1,s)|0)>>3];c[r>>2]=3;Wa=Qa+(e-Ra)*(Ta+Ra*+h[(EA(va,1,r)|0)>>3]*2.0);Xa=b;Ya=Xa;h[Ya>>3]=Wa;i=j;return}else{c[q>>2]=1;Ra=+h[(EA(va,1,q)|0)>>3];c[p>>2]=2;Ta=+h[(EA(va,1,p)|0)>>3];c[o>>2]=3;Wa=Ra+(Ta+ +h[(EA(va,1,o)|0)>>3]*e)*e;Xa=b;Ya=Xa;h[Ya>>3]=Wa;i=j;return}}function hh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+64|0;g=f;h=f+24|0;j=f+40|0;k=f+56|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=n;c[m>>2]=gz(d,1)|0;wA(q,1,m);c[l>>2]=gz(d,1)|0;wA(o,1,l);l=j;m=d;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=h;l=e;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];yh(p,0,j,h);h=p;j=o;c[j+0>>2]=c[h+0>>2];c[j+4>>2]=c[h+4>>2];c[j+8>>2]=c[h+8>>2];if((c[p+12>>2]|0)==0){yA(o,q);r=a;s=n;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];i=f;return}p=c[27736]|0;h=g;j=6320;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Le[p&63](b,g,6344,k);yA(o,q);r=a;s=n;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];i=f;return}function ih(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=d;i=i;return}function jh(a,b,c,d,e,f,g,j,k,l,m,n,o){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;m=+m;n=+n;o=+o;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;p=i;i=i+112|0;q=p;r=p+16|0;s=p+32|0;t=p+48|0;u=p+64|0;v=p+80|0;w=p+96|0;x=m/k;if(!(x<=.0065)){y=.0065/x}else{y=1.0}m=+vd(+(+W(+(+ca(+y)*745.0),.97)),+o);y=d*l;z=e*l;l=(y+z)*.5;A=+wd(+y,+z)+n;B=+vd(+y,+z)-n;if(A<=c){kh(q,b,c-y,d,e,f,g,j,k,m,o,x);C=+h[q>>3];D=a;E=D;h[E>>3]=C;i=p;return}if(B>=c){kh(r,b,c-z,d,e,f,g,j,k,m,o,x);C=+h[r>>3];D=a;E=D;h[E>>3]=C;i=p;return}kh(s,b,A-y,d,e,f,g,j,k,m,o,x);y=+h[s>>3];n=+h[s+8>>3];kh(t,b,B-z,d,e,f,g,j,k,m,o,x);x=+h[t>>3];o=+h[t+8>>3];lh(u,b,l,B,A,x,y,o,n);m=+h[u+8>>3];if(l<c){lh(v,b,c,l,A,0.0,y,m,n);C=+h[v>>3];D=a;E=D;h[E>>3]=C;i=p;return}else{lh(w,b,c,B,l,x,0.0,o,m);C=+h[w>>3];D=a;E=D;h[E>>3]=C;i=p;return}}function kh(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0,X=0,Y=0,Z=0,_=0;q=i;i=i+128|0;r=q;s=q+24|0;t=q+48|0;u=q+72|0;v=q+96|0;w=q+120|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+16|0;C=d>=0.0;D=C?g:j;j=+U(+d);g=m*m*m*((C?e:f)/(D*D*l));l=j*g*2.0;f=g*2.0;g=l*.015625;e=f*.015625;do{if(g>n){if(!(l>=0.0)){E=c[27736]|0;F=A;h[k>>3]=l;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=v;G=7928;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Le[F&63](b,v,4720,A);F=c[27736]|0;G=z;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=u;E=7928;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Le[G&63](b,u,4720,z);}H=+V(+l);I=p*.27;J=I+2.51/H;if(!(J>0.0)){G=c[27736]|0;E=y;h[k>>3]=J;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=G;G=t;F=7928;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2];c[G+16>>2]=c[F+16>>2];c[G+20>>2]=c[F+20>>2];Le[E&63](b,t,4784,y);}K=H*+$a(+J)*-2.0;J=j*f;if(!(J>=0.0)){E=c[27736]|0;F=x;h[k>>3]=J;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=s;G=7928;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Le[F&63](b,s,4880,x);}H=+V(+J);J=I+2.51/H;if(!(J>0.0)){F=c[27736]|0;G=w;h[k>>3]=J;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=r;E=7928;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Le[G&63](b,r,4960,w);}I=(5.02/(j*J*2.0)- +da(+J)*(f/H))*.4342944819032518;if(!(K<o)){L=K;M=I;break}mh(B,b,l,n,o,p,d);L=+h[B>>3];M=+h[B+8>>3]}else{L=g;M=e}}while(0);if(C){N=L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}N=-L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}function lh(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0;m=i;i=i+56|0;n=m;o=m+24|0;p=m+48|0;q=i;i=i+8|0;if(!(e<f)){r=gA(gA(5872,eA(e,0,1,6)|0)|0,5928)|0;s=gA(gA(r,eA(f,0,1,6)|0)|0,5944)|0;r=c[27736]|0;t=o;u=5976;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];Le[r&63](b,o,s,q);}do{if(!(k*l>=0.0)){if(+U(+k)<1.0e-15){break}if(+U(+l)<1.0e-15){break}q=gA(gA(6e3,eA(k,0,1,6)|0)|0,6176)|0;s=gA(gA(q,eA(l,0,1,6)|0)|0,6192)|0;q=c[27736]|0;o=n;r=6224;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2];c[o+16>>2]=c[r+16>>2];c[o+20>>2]=c[r+20>>2];Le[q&63](b,n,s,p);}}while(0);v=f-e;w=(j-g)/v;x=+U(+w);if(w==0.0){y=0.0;z=(d-e)*w+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}F=w*-2.0;G=F+k+l;if(+U(+G)<1.0e-13){H=d-e;I=k*-2.0;J=w*3.0;K=F+l+k;L=((e+f)*.5-e)/v;y=K*L*L*3.0+((I+(J-l))*L*2.0+k);z=H*(H*((I+(J+(H*(K/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}K=v*k;H=-l;J=((k+l)*e*-3.0+(w*e*6.0+(K*-2.0+(v*w*3.0-v*l))))/(H-k+w*2.0)*.3333333333333333;I=J-e;L=f-J;J=I/v;M=F+l+k;F=k*-2.0;N=w*3.0;O=F+(N-l);P=M*J*J*3.0+(O*J*2.0+k);if(w>0.0){Q=1.0}else{Q=+(w<0.0|0)}J=Q*+vd(+(+U(+P)),+x)*.25;do{if(!(+U(+(k-l))<=1.0e-13)){R=(k*H+(-(l*l)-k*k)+w*(w*-1.5+k+l)*6.0)/(G*3.0);S=0}else{if(!(K+g<j)){R=k;S=0;break}R=k;S=1}}while(0);if(I>0.0&L<v){if(!(w*P<=0.0)){T=19}else{T=22}}else{T=19}do{if((T|0)==19){P=+U(+J);K=+U(+R);if(P<K){if(w*R>=0.0){T=22;break}}if(P<+U(+(w*.1))&S<<24>>24==0){V=K;W=P}else{T=34}}}while(0);do{if((T|0)==22){if(!(S<<24>>24==0)){T=34;break}V=+U(+R);W=+U(+J)}}while(0);if((T|0)==34){P=d-e;K=((e+f)*.5-e)/v;y=M*K*K*3.0+(O*K*2.0+k);z=P*(P*((F+(N+(P*(M/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}do{if(W<V){if(!(w*R>=0.0)){X=J;break}X=R}else{X=J}}while(0);J=w*.1;T=+U(+X)<+U(+J);R=T?J:X;X=(I*k+L*l)/v;if(+U(+(X-R))<1.0e-6){Y=X*.999999}else{Y=R}R=(w-Y)/(X-Y)*3.0;X=I*R;I=L*R;R=X+e;L=f-I;w=(k-Y)/+wd(+(X*X),1.0e-13);X=(l-Y)/+wd(+(I*I),1.0e-13);I=e-R;l=w*I*I*I*-.3333333333333333-Y*e+g;g=f-L;if(R>d){e=d-R;y=Y;z=w*e*e*e*.3333333333333333+(Y*d+l);A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}if(L>d){y=Y;z=Y*d+l;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}else{l=d-L;y=Y;z=X*l*l*l*.3333333333333333+(Y*d+(X*g*g*g*-.3333333333333333-Y*f+j));A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}}function mh(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0;l=i;i=i+224|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=l+96|0;r=l+120|0;s=l+144|0;t=l+168|0;u=l+192|0;v=l+216|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=e*64.0;if(!(F>0.0)){G=c[27736]|0;H=D;h[k>>3]=F;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=u;I=7928;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];Le[H&63](b,u,4224,D);}J=+$a(+F);if(!(e>0.0)){D=c[27736]|0;u=C;h[k>>3]=e;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=D;D=t;H=7928;c[D+0>>2]=c[H+0>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];c[D+12>>2]=c[H+12>>2];c[D+16>>2]=c[H+16>>2];c[D+20>>2]=c[H+20>>2];Le[u&63](b,t,4288,C);}F=+$a(+e);e=g/3.7+5.74/+W(+f,.9);if(!(e>0.0)){C=c[27736]|0;t=B;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;u=7928;c[C+0>>2]=c[u+0>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];c[C+12>>2]=c[u+12>>2];c[C+16>>2]=c[u+16>>2];c[C+20>>2]=c[u+20>>2];Le[t&63](b,s,4352,B);}K=f/+$a(+e);e=K*K*.25;B=e>=0.0;if(!B){s=c[27736]|0;t=A;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s;s=r;u=7928;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];Le[t&63](b,r,4416,A);}K=+V(+e);f=g*.27+2.51/K;if(!B){B=c[27736]|0;A=z;h[k>>3]=e;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=B;B=q;r=7928;c[B+0>>2]=c[r+0>>2];c[B+4>>2]=c[r+4>>2];c[B+8>>2]=c[r+8>>2];c[B+12>>2]=c[r+12>>2];c[B+16>>2]=c[r+16>>2];c[B+20>>2]=c[r+20>>2];Le[A&63](b,q,4416,z);}if(!(f>0.0)){z=c[27736]|0;q=y;h[k>>3]=f;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=z;z=p;A=7928;c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];c[z+16>>2]=c[A+16>>2];c[z+20>>2]=c[A+20>>2];Le[q&63](b,p,4472,y);}g=K*+$a(+f)*-2.0;if(!(e>0.0)){y=c[27736]|0;p=x;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;q=7928;c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[y+16>>2]=c[q+16>>2];c[y+20>>2]=c[q+20>>2];Le[p&63](b,o,4536,x);}K=+$a(+e);if(!(g>0.0)){x=c[27736]|0;o=w;h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=7928;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Le[o&63](b,n,4592,w);}e=+$a(+g);L=1.090079149577162/(f*g)+.5;if(d>0.0){M=+$a(+d);nh(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}w=c[27736]|0;n=v;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=7928;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Le[n&63](b,m,4656,v);M=+$a(+d);nh(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}function nh(a,b,c,d,e,f,g,j,k){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;var l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;l=e-d;do{if(l!=l|0.0!=0.0|l==0.0){e=(f+g)*.5;m=g-f;if(m>0.0){n=1.0e+60;o=e;break}n=+(m<0.0|0)*1.0e+60;o=e}else{e=(c-d)/l;m=e*e;p=e*m;q=m*3.0;n=(m-e)*6.0/l*f+((e*-4.0+q+1.0)*j+((e-m)*6.0/l*g+(e*-2.0+q)*k));o=(m*-3.0+p*2.0+1.0)*f+(l*(p+(e+m*-2.0))*j+((q+p*-2.0)*g+l*(p-m)*k))}}while(0);h[a>>3]=o;h[a+8>>3]=n;i=b;return}function oh(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0,Y=0;j=i;i=i+224|0;l=j;m=j+24|0;n=j+48|0;o=j+72|0;p=j+96|0;q=j+120|0;r=j+144|0;s=j+168|0;t=j+192|0;u=j+216|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;if(!(e>0.0)){D=c[27736]|0;E=C;h[k>>3]=e;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=t;F=7928;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];Le[E&63](b,t,4288,C);}G=+$a(+e);H=e*64.0;if(!(H>0.0)){C=c[27736]|0;t=B;h[k>>3]=H;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;E=7928;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];Le[t&63](b,s,4224,B);}I=+$a(+H);H=+W(+f,.9);J=g/3.7+5.74/H;if(!(J>0.0)){B=c[27736]|0;s=A;h[k>>3]=J;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=B;B=r;t=7928;c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];c[B+16>>2]=c[t+16>>2];c[B+20>>2]=c[t+20>>2];Le[s&63](b,r,4352,A);}K=+$a(+J);L=f/K;M=L*L*.25;A=M>=0.0;if(!A){r=c[27736]|0;s=z;h[k>>3]=M;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r;r=q;t=7928;c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[r+16>>2]=c[t+16>>2];c[r+20>>2]=c[t+20>>2];Le[s&63](b,q,4416,z);}L=g*.27+2.51/+V(+M);if(!A){A=c[27736]|0;z=y;h[k>>3]=M;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=A;A=p;q=7928;c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];c[A+16>>2]=c[q+16>>2];c[A+20>>2]=c[q+20>>2];Le[z&63](b,p,4416,y);}if(!(L>0.0)){y=c[27736]|0;p=x;h[k>>3]=L;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;z=7928;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Le[p&63](b,o,4472,x);}+$a(+L);if(!(f>0.0)){x=c[27736]|0;o=w;h[k>>3]=f;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=7928;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Le[o&63](b,n,5040,w);}L=+$a(+f);if(!(M>0.0)){w=c[27736]|0;n=v;h[k>>3]=M;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=7928;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Le[n&63](b,m,4536,v);}f=1.121782646756099/(H*J*K)*4.0+2.0;K=L-G;G=(+$a(+M)-I)/K;I=(G*3.0+(-2.0-f))/K;M=(f+G*-2.0+1.0)/(K*K);K=d/e;if(K>0.0){N=+$a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}v=c[27736]|0;m=u;h[k>>3]=K;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=v;v=l;n=7928;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+16>>2]=c[n+16>>2];c[v+20>>2]=c[n+20>>2];Le[m&63](b,l,5104,u);N=+$a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}function ph(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;q=i;i=i+32|0;r=q;s=q+24|0;t=i;i=i+8|0;o=n/m;if(!(o<=.0065)){u=.0065/o}else{u=1.0}n=+vd(+(+ca(+u)*745.0),+p);v=d>=0.0;u=v?e:f;f=v?g:j;j=+U(+d)/(f*m)*1.273239544735163;do{if(!(j<=n)){if(!(j>=p)){oh(t,b,j,n,p,o);w=+h[t>>3];break}d=o/3.7+5.74/+W(+j,.9);if(!(d>0.0)){x=c[27736]|0;y=s;h[k>>3]=d;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x;x=r;z=7928;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Le[y&63](b,r,5168,s);}g=j/+$a(+d);w=g*g*.25}else{w=j*64.0}}while(0);j=f*f;f=+oB(m,-3);if(v){A=w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}A=-w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}function qh(a,b,c,d,e,f,g,j){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=g|0;j=+j;var k=0,l=0,m=0,n=0.0;k=i;i=i+16|0;l=k;m=k+8|0;do{if(!(c>=d)){if(c<=-d){n=-(c*c*f);break}if(!(e>=f)){rh(m,b,-c,d,f,e,g,j);n=-+h[m>>3];break}else{rh(l,b,c,d,e,f,g,j);n=+h[l>>3];break}}else{n=c*c*e}}while(0);h[a>>3]=n;i=k;return}function rh(a,b,c,d,e,f,g,j){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=g|0;j=+j;var k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0;b=i;i=i+16|0;k=b;l=b+8|0;m=-d;if(c<=m){n=-(c*c*f);o=a;p=o;h[p>>3]=n;i=b;return}q=d*d;r=q*e;s=q*f;q=d*e;e=q*2.0;t=m*f*-2.0;if(g<<24>>24==0){u=m/d;v=((s*-3.0-t*m)/u-(r*3.0-e*d)*u)/((1.0-u)*d*2.0)}else{v=j}j=q*2.23606797749979;q=+U(+m)*f*2.23606797749979;f=(j<q?j:q)*.9;q=f<v?f:v;if(!(c>=0.0)){vh(l,0,c,m,-s,t,q);n=+h[l>>3];o=a;p=o;h[p>>3]=n;i=b;return}else{vh(k,0,c,d,r,e,q);n=+h[k>>3];o=a;p=o;h[p>>3]=n;i=b;return}}function sh(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+56|0;l=k;m=k+24|0;n=k+48|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=gz(g,1)|0;if(e<<24>>24!=0&f<<24>>24==0){f=gA(gA(gA(gA(5256,j)|0,5312)|0,b)|0,5344)|0;e=c[27736]|0;u=m;v=5536;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[u+16>>2]=c[v+16>>2];c[u+20>>2]=c[v+20>>2];Le[e&63](a,m,f,s);}if((t|0)<1){i=k;return}s=(th(1,1,t)|0)==0;if(!s){f=1;do{c[r>>2]=f;if(!(+h[(EA(g,1,r)|0)>>3]>=0.0)){m=gA(gA(gA(gA(5560,b)|0,5608)|0,j)|0,5624)|0;e=gA(gA(m,dA(f,0,1)|0)|0,5664)|0;c[q>>2]=f;m=gA(gA(e,eA(+h[(EA(g,1,q)|0)>>3],0,1,6)|0)|0,5672)|0;e=c[27736]|0;v=l;u=5712;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[v+20>>2]=c[u+20>>2];Le[e&63](a,l,m,p);}f=f+1|0;}while((th(f,1,t)|0)!=0)}if((t|0)<=0){i=k;return}if(!(+U(+(+KA(g)+-1.0))>1.0e-10)){i=k;return}if(s){w=4216}else{s=4216;f=1;while(1){p=gA(s,5736)|0;l=gA(gA(p,dA(f,0,1)|0)|0,5752)|0;c[o>>2]=f;p=gA(gA(l,eA(+h[(EA(g,1,o)|0)>>3],0,1,6)|0)|0,5760)|0;c[n>>2]=f;l=gA(gA(p,c[(nB(d,1,n)|0)>>2]|0)|0,5768)|0;p=f+1|0;if((th(p,1,t)|0)==0){w=l;break}else{f=p;s=l}}}s=gA(gA(gA(gA(gA(5776,b)|0,5608)|0,j)|0,5768)|0,5816)|0;uh(0,gA(gA(gA(s,eA(+KA(g),0,1,6)|0)|0,5864)|0,w)|0);i=k;return}function th(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function uh(a,b){a=a|0;b=b|0;a=i;rB(b);i=a;return}function vh(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;var j=0.0;j=d*g;g=e*3.0+(j*-2.0-d*f);f=c/d;h[a>>3]=f*(j+f*(g+(-g-j+e)*f));i=i;return}function wh(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;do{if(c>f){g=d}else{if(c<-f){g=e;break}if(f>0.0){j=c/f;g=(d+e)*.5+(e-d)/f*(j*j+-3.0)*c*.25;break}else{g=(d+e)*.5;break}}}while(0);h[a>>3]=g;i=b;return}function xh(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function yh(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;c[l>>2]=0;c[m>>2]=zh(gz(d,1)|0)|0;c[n>>2]=zh(gz(d,1)|0)|0;c[h>>2]=gz(d,1)|0;zz(o,1,h);Fz(o,p);o=gz(d,1)|0;h=gz(d,1)|0;c[g>>2]=o;c[g+4>>2]=h;wA(q,2,g);AA(d,q);LA(q,r);c[s>>2]=Ah(d)|0;c[t>>2]=1;q=j;c[f>>2]=gz(d,1)|0;wA(q,1,f);yA(e,q);f=j;d=e;c[f+0>>2]=c[d+0>>2];c[f+4>>2]=c[d+4>>2];c[f+8>>2]=c[d+8>>2];LA(q,k);d=Bh(c[r+8>>2]|0)|0;r=Ch(c[p+8>>2]|0)|0;au(s,t,d,m,r,Bh(c[k+8>>2]|0)|0,n,l)|0;MA(k,q);c[j+12>>2]=c[l>>2];l=a;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];c[l+12>>2]=c[f+12>>2];i=b;return}function zh(a){a=a|0;i=i;return((a|0)<1?1:a)|0}function Ah(a){a=a|0;var b=0,c=0;b=i;c=gz(a,1)|0;i=b;return c|0}function Bh(a){a=a|0;i=i;return a|0}function Ch(a){a=a|0;i=i;return a|0}function Dh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;ah(a,b,c,d,0);i=e;return}function Eh(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0.0;g=i;i=i+56|0;f=g;j=g+8|0;k=g+16|0;Dh(f,b,d,e,0);l=+h[f>>3];Fh(j,b,d,e,0);xh(k,0,1,l,+h[j>>3],e,d);d=+h[k+8>>3];e=+h[k+16>>3];l=+h[k+24>>3];m=+h[k+32>>3];c[a>>2]=c[k>>2];h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=l;h[a+32>>3]=m;i=g;return}function Fh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;dh(a,b,c,d,0);i=e;return}function Gh(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function Hh(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+96|0;h=g;j=g+40|0;k=g+56|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Eh(k,b,d,e,j,0);j=a;a=h+0|0;b=k+0|0;k=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(k|0));Gh(j,0,h);i=g;return}function Ih(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0;d=+h[c+16>>3];e=+h[c+8>>3];f=+h[c+24>>3];g=+h[c+48>>3];j=d*e*f*(g*2.0+f*+h[c+56>>3]);h[a>>3]=+h[c>>3]*d*e*f*g;h[a+8>>3]=j;i=i;return}



function tE(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;rz(9,0,99952,z);if((f|0)==0){SC(b);TC(b);C=6}else{if((a[f]|0)!=0){uE(b,f,g)}SC(b);TC(b);if((a[f]|0)==0){C=6}}if((C|0)==6){le[c[(c[A>>2]|0)+84>>2]&127](b)|0;le[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=($2(d,101440)|0)==0|0;f=($2(d,101448)|0)==0;z=($2(d,101456)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;tz(1,0,1e5,y);tz(1,0,100032,x);c[w>>2]=101440;c[w+4>>2]=101248;tz(1,0,100056,w);c[v>>2]=101448;c[v+4>>2]=101328;tz(1,0,100056,v);c[u>>2]=101456;c[u+4>>2]=101376;tz(1,0,100056,u);vz(c[b+536>>2]|0,100088,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=($2(e,c[100112+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;tz(1,0,100144,s);tz(1,0,100032,r);t=1;do{u=c[100176+(t<<2)>>2]|0;c[q>>2]=c[100112+(t<<2)>>2];c[q+4>>2]=u;tz(1,0,100056,q);t=t+1|0;}while((t|0)<7);vz(c[b+536>>2]|0,100088,p)}}while(0);p=c[100072+(D<<2)>>2]|0;c[o>>2]=c[99984+(D<<2)>>2];c[o+4>>2]=p;rz(9,0,100208,o);o=(D|0)==2;if(o){p=c[100176+(F<<2)>>2]|0;c[n>>2]=c[100112+(F<<2)>>2];c[n+4>>2]=p;rz(9,0,100248,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=vE(b,F,j)|0;break}if((D|0)==3){wE(b,j);I=0;break}else{vz(c[b+536>>2]|0,100288,m)}}}while(0);if((HD(b,1)|0)!=0){J=-2;sE(b);K=15;L=K;M=100312;N=M;rz(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];BC(b,R,V);W=193;PC(b);X=199;UC(b);Y=194;KC(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=le[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ae[ha&127](b,1)|0;ja=202;QC(b);i=k;return J|0}if((xD(b,1)|0)!=0){J=-3;sE(b);K=15;L=K;M=100312;N=M;rz(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];BC(b,R,V);W=193;PC(b);X=199;UC(b);Y=194;KC(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=le[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ae[ha&127](b,1)|0;ja=202;QC(b);i=k;return J|0}m=(kD(b,1)|0)==0;J=m?I:-4;sE(b);K=15;L=K;M=100312;N=M;rz(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];BC(b,R,V);W=193;PC(b);X=199;UC(b);Y=194;KC(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=le[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=Ae[ha&127](b,1)|0;ja=202;QC(b);i=k;return J|0}function uE(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rz(9,0,101472,z);z=lA(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;vz(C,101512,y)}rz(9,0,101552,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=mA(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=zE(c[d+(C*112|0)+4>>2]|0)|0;E=mA(A,D)|0;C2(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((a3(E,101592,6)|0)==0){if((c[61148>>2]|0)==0){break}}else{D=a3(E,101600,6)|0;if((c[61148>>2]|D|0)==0){break}}c[v>>2]=E;tz(9,0,101608,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;sA(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rz(9,0,101576,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}rz(9,0,101664,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=mA(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=zE(c[G+(w*112|0)+4>>2]|0)|0;v=mA(A,F)|0;C2(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];tz(9,0,101688,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;sA(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];rz(9,0,101576,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}rz(9,0,101744,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=mA(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=zE(c[t+(x*112|0)+4>>2]|0)|0;K=mA(A,C)|0;C2(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];tz(9,0,101688,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;sA(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rz(9,0,101576,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}rz(9,0,101768,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=mA(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=zE(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=mA(A,u)|0;C2(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];tz(9,0,101816,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;sA(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;rz(9,0,101800,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}rz(9,0,101872,l);l=b+144|0;if((c[l>>2]|0)<=0){jA(A);i=f;return}o=b+32|0;b=0;do{x=mA(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=zE(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=mA(A,n)|0;C2(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];tz(9,0,101920,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;sA(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?99864:99872;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;rz(9,0,101904,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));jA(A);i=f;return}function vE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;AC(a,+h[a+240>>3]);PC(a);UC(a);KC(a);WC(a);gE(a);LC(a);PC(a);e=xE(a,b,c)|0;UC(a);KC(a);QC(a);UC(a);i=d;return e|0}function wE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;AC(b,+h[b+240>>3]);PC(b);UC(b);iE(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=D2(c[y>>2]|0,8)|0;A=b+124|0;B=D2(c[A>>2]|0,4)|0;C=b+128|0;D=D2(c[C>>2]|0,1)|0;E=b+132|0;F=D2(c[E>>2]|0,4)|0;G=b+536|0;uz(c[G>>2]|0,(z|0)!=0|0,100344,t);uz(c[G>>2]|0,(B|0)!=0|0,100344,s);uz(c[G>>2]|0,(D|0)!=0|0,100344,r);uz(c[G>>2]|0,(F|0)!=0|0,100344,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[61148>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];jc(x|0,100360,p|0)|0;p=kc(x|0,100376)|0;c[o>>2]=100392;zd(p|0,100384,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];zd(p|0,100384,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Vd(10,p|0)|0;H=p}rz(9,1,100400,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;le[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rz(9,0,100424,l);if((c[61148>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];zd(H|0,100448,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];zd(H|0,100448,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Vd(10,H|0)|0}if((HD(b,0)|0)!=0){break a}if((xD(b,0)|0)!=0){break a}if((kD(b,0)|0)!=0){break a}XC(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);ie[c[15416]&255](9);if((c[61148>>2]|0)!=0){_c(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}C2(z);C2(B);C2(D);C2(F)}else{h[b+304>>3]=1.0;le[c[w+80>>2]&127](b)|0}MC(b);if((iE(b,1,1)|0)!=1){i=e;return}le[c[(c[v>>2]|0)+80>>2]&127](b)|0;MC(b);if((iE(b,1,1)|0)!=1){i=e;return}tz(1,0,100456,f);i=e;return}function xE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=AE(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){rz(9,0,100560,u);if((c[b+184>>2]|0)==0){Ae[c[(c[b+540>>2]|0)+68>>2]&127](b,c[v+48>>2]|0)|0}C2(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){rz(9,0,100592,t);Ae[c[(c[b+540>>2]|0)+68>>2]&127](b,c[v+48>>2]|0)|0;C2(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){rz(9,1,100664,s);t=B2(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+qE(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+qE(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}rz(9,1,100688,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];rz(9,0,100712,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];rz(9,0,100712,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];rz(9,0,100712,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[61148>>2]|0)!=0){ie[c[15416]&255](9);ie[c[15416]&255](9)}C2(t);BE(v);H=AE(b)|0;if((c[H>>2]|0)!=0){$=H;break}rz(9,0,100736,n);C2(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}rz(9,0,100768,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){rz(9,0,100784,l);yE($,d,1,e);rE(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+qE($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){C2(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){C2(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){C2(v);c[l>>2]=0}yE($,d,0,e);rE(b,$);+qE($,1.0)}else{rz(9,0,100808,j)}rz(9,1,100832,g);rE(b,$);b=pE($)|0;if((c[61148>>2]|0)!=0){ie[c[15416]&255](9)}BE($);y=b;i=f;return y|0}function yE(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=B2(c[p>>2]<<3)|0;r=q;s=+qE(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;DE(a,r);C2(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=100960;F=E;rz(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;rz(9,0,100872,m);if(!t){CE(a)}switch(b|0){case 3:{G=ME(a,n,e)|0;break};case 6:{H=14;break a;break};case 4:{H=12;break a;break};case 1:{G=KE(a)|0;break};case 2:{G=IE(a)|0;break};case 5:{H=13;break a;break};default:{H=15;break a}}UC(o);KC(o);QC(o);UC(o);s=+qE(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}rz(9,0,100920,k);rE(o,a);K=s}else{rz(9,0,100936,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){HE(a)|0}else if((H|0)==13){HE(a)|0}else if((H|0)==14){GE(o,a,0)|0}else if((H|0)==15){vz(c[o+536>>2]|0,100896,l)}else if((H|0)==23){DE(a,r);C2(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=100960;F=E;rz(9,0,F,g);i=f;return}}function zE(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=d3(b|0)|0;do{if((d|0)==0){e=B2(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=B2(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((_2(e,101976,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;f3(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((_2(e,101976,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function AE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=B2(64)|0;z=y;uz(0,(y|0)!=0|0,101984,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=D2(Z,8)|0;c[E>>2]=y;uz(0,(y|0)!=0|0,101984,w);w=D2(Z,8)|0;c[F>>2]=w;uz(0,(w|0)!=0|0,101984,v);v=D2(Z,8)|0;c[G>>2]=v;uz(0,(v|0)!=0|0,101984,u);u=D2(Z,8)|0;c[H>>2]=u;uz(0,(u|0)!=0|0,101984,t);t=D2(Z,8)|0;c[I>>2]=t;uz(0,(t|0)!=0|0,101984,s);s=D2(Z,4)|0;t=s;c[J>>2]=t;uz(0,(s|0)!=0|0,101984,r);rz(9,0,102e3,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;rz(9,0,102024,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rz(9,0,102112,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];rz(9,0,102160,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];rz(9,0,102216,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;rz(9,0,102272,l);c[j>>2]=ya;rz(9,0,102344,j);j=D2(sa,8)|0;c[K>>2]=j;uz(0,(j|0)!=0|0,101984,g);g=B2(sa<<3)|0;c[L>>2]=g;uz(0,(g|0)!=0|0,101984,f);f=B2(ya<<3)|0;c[M>>2]=f;uz(0,(f|0)!=0|0,101984,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function BE(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){C2(d)}d=c[a+28>>2]|0;if((d|0)!=0){C2(d)}d=c[a+32>>2]|0;if((d|0)!=0){C2(d)}d=c[a+36>>2]|0;if((d|0)!=0){C2(d)}d=c[a+40>>2]|0;if((d|0)!=0){C2(d)}d=c[a+44>>2]|0;if((d|0)!=0){C2(d)}d=c[a+48>>2]|0;if((d|0)!=0){C2(d)}d=c[a+52>>2]|0;if((d|0)!=0){C2(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;C2(e);i=b;return}C2(d);e=a;C2(e);i=b;return}function CE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=D2(o,8)|0;q=D2(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=D2(s,8)|0;u=D2(s,8)|0;v=D2(o,8)|0;w=D2(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+qE(b,1.0);s=c[n>>2]|0;if((s|0)>0){f3(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+qE(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){f3(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;rz(9,0,102384,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}C2(p);C2(q);C2(t);C2(u);C2(v);C2(w);i=d;return}function DE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function EE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function FE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function GE(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;vz(c[a+536>>2]|0,102456,d);return 0}function HE(a){a=a|0;a=i;i=i+8|0;vz(0,102488,a);return 0}function IE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[61148>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=D2((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;uz(0,(n|0)!=0|0,102528,b);c[25636]=c[a+60>>2];c[25638]=c[a+48>>2];aC(k,j,c[a+24>>2]|0,g,f,d,e,n,7)|0;C2(n);c[25636]=0;c[25638]=0;n=pE(a)|0;i=b;return n|0}function JE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[25638];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[25636];h[d>>3]=+qE(f,1.0);i=e;return}function KE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=B2(x)|0;z=y;A=B2(x)|0;x=A;uz(0,(y|0)!=0|0,102560,n);uz(0,(A|0)!=0|0,102560,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[61148>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+qE(a,1.0);h[o>>3]=D;if(D!=0.0){c[25644]=c[a+60>>2];c[25646]=c[a+48>>2];ZB(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,8,u)|0;c[25644]=0;c[25646]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];rz(9,0,102592,l)}D=+qE(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];rz(9,0,102696,j);j=c[u>>2]|0;do{if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];tz(9,0,102712,g);F=-1;i=b;return F|0}else if((j|0)==4){tz(9,0,102928,d);F=-4;i=b;return F|0}else if((j|0)==3){tz(9,0,102856,e);F=-3;i=b;return F|0}else if((j|0)==2){tz(9,0,102792,f);F=-2;i=b;return F|0}}while(0);F=pE(a)|0;i=b;return F|0}function LE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[25646];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[25644];h[d>>3]=+qE(f,1.0);i=e;return}function ME(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;rz(9,1,102984,g);if((c[61148>>2]|0)==0){l=0}else{l=(k|0)/10|0}NE(a,d,k,l,b,j);c[f>>2]=c[j>>2];rz(9,0,103008,f);ie[c[15416]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=pE(a)|0;if((b|0)==0){m=0;i=e;return m|0}tz(9,0,103024,e);m=b;i=e;return m|0}function NE(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=B2(fa(N,M)|0)|0;P=B2(M<<3)|0;Q=B2(N)|0;R=Q;S=B2(N)|0;T=S;V=B2(N)|0;W=V;X=B2(N)|0;Y=+h[f>>3];if((c[61148>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];jc(N|0,103072,I|0)|0;I=kc(N|0,103088)|0;c[H>>2]=103104;zd(I|0,103096,H|0)|0;c[G>>2]=103120;zd(I|0,103096,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];zd(I|0,103096,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Vd(10,I|0)|0;c[E>>2]=0;zd(I|0,103128,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];zd(I|0,103136,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];zd(I|0,103136,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Vd(10,I|0)|0;Z=I}else{Z=0}uz(0,(O|0)!=0|0,103144,B);uz(0,(P|0)!=0|0,103144,A);uz(0,(Q|0)!=0|0,103144,z);uz(0,(S|0)!=0|0,103144,y);uz(0,(V|0)!=0|0,103144,x);uz(0,(X|0)!=0|0,103144,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{EE(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+qE(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;EE(a,la);+qE(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];rz(9,0,103160,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){h3(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);EE(a,R);za=+qE(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}f3(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}EE(a,T);if(+qE(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}f3(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}f3(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}EE(a,W);Ba=+qE(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}EE(a,W);Ba=+qE(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}f3(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rz(9,0,103200,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;zd(Z|0,103128,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];zd(Z|0,103136,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];zd(Z|0,103136,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Vd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];tz(9,0,103248,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];tz(9,0,103264,p);vz(0,103280,o)}EE(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){C2(S);C2(Q);C2(V);C2(X);C2(P);C2(O);i=j;return}c[n>>2]=ia;zd(Z|0,103128,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];zd(Z|0,103136,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];zd(Z|0,103136,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Vd(10,Z|0)|0;_c(Z|0)|0;C2(S);C2(Q);C2(V);C2(X);C2(P);C2(O);i=j;return}function OE(a,b){a=a|0;b=b|0;i=i;return}function PE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;cB(3);fB(0);w=+ZA(0);cB(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];zd(v|0,103360,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];zd(v|0,103360,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];zd(v|0,103360,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];zd(v|0,103368,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;zd(v|0,103368,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];zd(v|0,103376,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];zd(v|0,103360,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];zd(v|0,103360,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;zd(v|0,103368,l|0)|0;break}else{c[m>>2]=0-E;zd(v|0,103368,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;zd(v|0,103368,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;zd(v|0,103368,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Vd(10,v|0)|0;fB(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];zd(v|0,103376,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Vd(10,v|0)|0;fB(3);i=e;return}function QE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=kc(c[r>>2]|0,103384)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Zd(c[(Pc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;uz(t,(s|0)!=0|0,103392,q);c[p>>2]=103448;zd(s|0,103376,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=103456;zd(s|0,103376,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];zd(s|0,103376,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];zd(s|0,103376,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];zd(s|0,103376,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];zd(s|0,103376,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];zd(s|0,103376,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];zd(s|0,103376,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];zd(s|0,103376,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Vd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];zd(s|0,103376,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Vd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function RE(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;cB(3);_c(d|0)|0;fB(3);i=b;return}function SE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;NW(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];OW(p,f)|0;TE(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;UE(a,b,103472,c[j>>2]|0,c[g>>2]|0,o,8);C2(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];OW(p,e)|0;i=d;return}function TE(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=D2(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;uz(c[b+536>>2]|0,(p|0)!=0|0,103752,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function UE(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;dF(a,b,d,e,f,h);MW(l,g,fa(fa(f,e)|0,h)|0)|0;if(hV(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];vz(l,103704,k)}else{i=j;return}}function VE(a){a=a|0;var b=0;b=i;if((XF(a+4|0)|0)!=0){i=b;return}kV(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function WE(a){a=a|0;Tc(a|0)|0;Za()}function XE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=H2(320)|0;h3(q|0,0,320)|0;YE(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;cB(3);t=a+8|0;u=ZE(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=_E(a,b,u+s|0)|0;u=q+184|0;$E(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;$E(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;aF(q,c[x>>2]|0,36);if(hV(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];vz(y,103528,e)}else{UE(a,b,103560,4,11,103480,1);bF((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;UE(a,b,103568,c[g>>2]|0,c[j>>2]|0,e,1);C2(e);c[f>>2]=0;bF((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;UE(a,b,103576,c[g>>2]|0,c[j>>2]|0,e,1);C2(e);c[f>>2]=0;cF(a,b,k,g,j,c[r>>2]|0,s);UE(a,b,103592,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;NW(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];TE(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;UE(a,b,103472,c[j>>2]|0,c[g>>2]|0,n,8);NW(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=eF(q+240|0)|0;w=eF(q+264|0)|0;p=eF(q+288|0)|0;dF(a,b,103608,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);C2(n);C2(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;sW(s)|0;C2(v);fB(3);i=d;return}}function YE(a){a=a|0;var b=0;b=i;fI(a);i=b;return}function ZE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(jH(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(jH(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(jH(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function _E(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=B2(e<<2)|0;e=l;c[l>>2]=104160;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=104200;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(jH(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(jH(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(jH(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function $E(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;WF(a,b,c);i=d;return}function aF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(VF(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){kV(d,4);i=e;return}else{iV(d,0);i=e;return}}function bF(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=d3(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=D2((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;uz(0,(o|0)!=0|0,103680,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;o3(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;iF(q,d3(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=D2(1,1)|0;c[d>>2]=q;uz(0,(q|0)!=0|0,103680,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function cF(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=D2(c[f>>2]<<2,4)|0;c[e>>2]=g;uz(c[d+536>>2]|0,(g|0)!=0|0,103728,k);g=s+240|0;f=eF(g)|0;h=s+264|0;t=eF(h)|0;u=s+288|0;v=eF(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=eF(g)|0;D=eF(h)|0;E=eF(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==0){jF(l,g,A+(v*52|0)+4|0);lF(m,g);if(!(kF(l,m)|0)){F=w;break}G=(c[(mF(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==1){jF(l,b,A+(v*52|0)+4|0);lF(n,b);if(!(kF(l,n)|0)){F=w;break}G=(c[(mF(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){jF(l,h,G+(t*52|0)+4|0);lF(o,h);H=kF(l,o)|0;J=H?2:0}else if(f<<24>>24==1){jF(l,v,G+(t*52|0)+4|0);lF(p,v);J=(kF(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;n=c[(mF(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=n+1}else{c[f+(w+1<<2)>>2]=~n}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){jF(l,d,y+(t*52|0)+4|0);lF(r,d);M=(kF(l,r)|0)&1}else if(x<<24>>24==0){jF(l,u,y+(t*52|0)+4|0);lF(q,u);x=kF(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(mF(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function dF(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(d3(d|0)|0)+1;e=m;MW(e,l,20)|0;if(hV(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];vz(l,103704,k)}MW(e,d,c[f>>2]|0)|0;if(hV(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];vz(m,103704,j)}else{i=h;return}}function eF(a){a=a|0;var b=0,d=0;b=i;d=c[(SF(a)|0)>>2]|0;i=b;return d|0}function fF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;cB(3);do{if(gV(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];OW(k,e)|0;k=eF(h+240|0)|0;m=eF(h+264|0)|0;l=eF(h+288|0)|0;dF(a,b,103608,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);VE(h)}else{if((h|0)!=0){break}c[g>>2]=0;fB(3);i=d;return}}while(0);gF(j);J2(h);c[g>>2]=0;fB(3);i=d;return}function gF(a){a=a|0;var b=0;b=i;oG(a);i=b;return}function hF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;cB(3);fB(0);h[j>>3]=+ZA(0);cB(0);l=k;m=d+4|0;MW(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){MW(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){MW(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);MW(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);MW(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);MW(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(hV(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];vz(t,103648,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;fB(3);i=e;return}}function iF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((a3(b,103864,4)|0)!=0){i=d;return}c=b;while(1){e=Wa(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((a3(b,103864,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function jF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;EF(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];uF(a,f);i=e;return}function kF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=sF(a,b)|0;i=c;return d|0}function lF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;vF(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];uF(a,e);i=d;return}function mF(a){a=a|0;var b=0,c=0;b=i;c=nF(oF(a)|0)|0;i=b;return c|0}function nF(a){a=a|0;var b=0,c=0;b=i;c=rF(a)|0;i=b;return c|0}function oF(a){a=a|0;var b=0,d=0;b=i;d=pF((c[a>>2]|0)+16|0)|0;i=b;return d|0}function pF(a){a=a|0;var b=0,c=0;b=i;c=qF(a)|0;i=b;return c|0}function qF(a){a=a|0;i=i;return a|0}function rF(a){a=a|0;i=i;return a|0}function sF(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(tF(a,b)|0)^1;i=c;return d|0}function tF(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function uF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];DF(a,e);i=d;return}function vF(a,b){a=a|0;b=b|0;var c=0;c=i;wF(a,xF(b)|0);i=c;return}function wF(a,b){a=a|0;b=b|0;var c=0;c=i;CF(a,b);i=c;return}function xF(a){a=a|0;var b=0,c=0;b=i;c=yF(zF(a+4|0)|0)|0;i=b;return c|0}function yF(a){a=a|0;var b=0,c=0;b=i;c=BF(a)|0;i=b;return c|0}function zF(a){a=a|0;var b=0,c=0;b=i;c=AF(a)|0;i=b;return c|0}function AF(a){a=a|0;i=i;return a|0}function BF(a){a=a|0;i=i;return a|0}function CF(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function DF(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function EF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=GF(b)|0;FF(f,b,d,h,xF(b)|0);vF(g,b);do{if(sF(f,g)|0){h=HF(b)|0;if(IF(h,d,JF(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);vF(a,b);i=e;return}function FF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;NF(h);a:do{if((e|0)==0){j=f}else{k=HF(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(OF(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;NF(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;NF(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);wF(a,j);i=g;return}function GF(a){a=a|0;var b=0,d=0;b=i;d=c[(xF(a)|0)>>2]|0;i=b;return d|0}function HF(a){a=a|0;var b=0,c=0;b=i;c=LF(a+8|0)|0;i=b;return c|0}function IF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=KF(0,b,c)|0;i=a;return d|0}function JF(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function KF(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function LF(a){a=a|0;var b=0,c=0;b=i;c=MF(a)|0;i=b;return c|0}function MF(a){a=a|0;i=i;return a|0}function NF(a){a=a|0;var b=0;b=i;PF(a,-1);i=b;return}function OF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=KF(0,b,c)|0;i=a;return d|0}function PF(a,b){a=a|0;b=b|0;b=i;QF(a,0);i=b;return}function QF(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function RF(a){a=a|0;i=i;return c[a+4>>2]|0}function SF(a){a=a|0;var b=0,c=0;b=i;c=TF(a+8|0)|0;i=b;return c|0}function TF(a){a=a|0;var b=0,c=0;b=i;c=UF(a)|0;i=b;return c|0}function UF(a){a=a|0;i=i;return a|0}function VF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 1:case 17:{h=103776;break};case 60:{h=103848;break};case 13:case 29:{h=103856;break};case 5:case 21:{h=103824;break};case 28:{h=103840;break};case 9:case 25:{h=103808;break};case 8:{h=103784;break};case 48:case 16:{h=103768;break};case 52:case 20:{h=103816;break};case 56:{h=103800;break};case 24:{h=103792;break};case 12:{h=103832;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=kc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Yc(j|0,0,2)|0)==0){g=a;i=e;return g|0}_c(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function WF(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function XF(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}YF(d,f,103);f=le[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((_c(ZF(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}_F(d);g=h;i=b;return g|0}function YF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;fG(a,b,c);i=d;return}function ZF(a){a=a|0;var b=0,d=0;b=i;d=bG(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function _F(a){a=a|0;var b=0;b=i;$F(a);i=b;return}function $F(a){a=a|0;var b=0;b=i;aG(a,0);i=b;return}function aG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=bG(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}le[c[(cG(e)|0)>>2]&127](f)|0;i=d;return}function bG(a){a=a|0;var b=0,c=0;b=i;c=eG(a)|0;i=b;return c|0}function cG(a){a=a|0;var b=0,c=0;b=i;c=dG(a)|0;i=b;return c|0}function dG(a){a=a|0;i=i;return a+4|0}function eG(a){a=a|0;i=i;return a|0}function fG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(hG(f)|0)>>2]|0;gG(a,d,c[(iG(g)|0)>>2]|0);i=e;return}function gG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;jG(a,b,c);i=d;return}function hG(a){a=a|0;i=i;return a|0}function iG(a){a=a|0;i=i;return a|0}function jG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(lG(f)|0)>>2]|0;kG(a,d,c[(mG(g)|0)>>2]|0);i=e;return}function kG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(lG(f)|0)>>2];c[a+4>>2]=c[(mG(g)|0)>>2];i=e;return}function lG(a){a=a|0;i=i;return a|0}function mG(a){a=a|0;i=i;return a|0}function nG(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function oG(a){a=a|0;var b=0;b=i;pG(a+300|0);pG(a+288|0);pG(a+276|0);pG(a+264|0);pG(a+252|0);pG(a+240|0);qG(a);i=b;return}function pG(a){a=a|0;var b=0;b=i;aH(a);i=b;return}function qG(a){a=a|0;var b=0;b=i;rG(a,103912);oV(a+104|0);i=b;return}function rG(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];vG(a+4|0);i=d;return}function sG(a){a=a|0;var b=0;b=i;qG(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function tG(a){a=a|0;var b=0;b=i;qG(a);J2(a);i=b;return}function uG(a){a=a|0;var b=0;b=i;tG(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function vG(a){a=a|0;var b=0;b=i;wG(a);i=b;return}function wG(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=104040;XF(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}K2(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}K2(e)}}while(0);xV(b);i=d;return}function xG(a){a=a|0;var b=0;b=i;vG(a);J2(a);i=b;return}function yG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;le[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=_G(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=$G(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;HV(h,0,0,0);MV(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}K2(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=I2(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=I2(h)|0;a[b+97|0]=1;i=e;return}function zG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;HV(e,0,0,0);MV(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}K2(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}K2(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=I2(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(XG(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=I2(o)|0;a[k]=1;i=f;return e|0}return 0}function AG(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Gc(4)|0;g2(n);Wd(n|0,151432,128)}n=TG(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((le[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){$E(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=w3(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Yc(p|0,q|0,f|0)|0)==0){p=zb(c[m>>2]|0)|0;$E(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];WG(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{$E(a,-1,-1);i=g;return}}}while(0);$E(a,-1,-1);i=g;return}function BG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((le[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=nG(d)|0;if((Yc(j|0,k|0,0)|0)==0){VG(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{$E(a,-1,-1);i=e;return}}}while(0);$E(a,-1,-1);i=e;return}function CG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Gc(4)|0;g2(m);Wd(m|0,151432,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=TG(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=FV(s)|0;u=(fa(t-(EV(s)|0)|0,p)|0)+r|0;v=0;break}p=EV(s)|0;if((p|0)==(FV(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=UG(t,g,x,o,p-(DV(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=FV(w)|0;u=q-(EV(w)|0)|0;v=0}}while(0);if((Yc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;HV(b,0,0,0);c[m>>2]=0}else{q=b;y=JV(q)|0;do{if((y|0)!=(IV(q)|0)){if((Ae[c[(c[b>>2]|0)+52>>2]&127](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=SG(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((tc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((xd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function DG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=NG(b)|0;o=b;if((EV(o)|0)==0){p=e+1|0;HV(o,e,p,p)}if(n){q=0}else{n=FV(o)|0;c[f>>2]=(n-(DV(o)|0)|0)/2|0;c[g>>2]=4;q=c[(OG(f,g)|0)>>2]|0}g=EV(o)|0;do{if((g|0)==(FV(o)|0)){g3(DV(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=FV(o)|0;n=DV(o)|0;p=tb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=DV(o)|0;HV(o,n,n+q|0,n+(p+q)|0);r=LG(a[EV(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;g3(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(OG(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=tb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Gc(4)|0;g2(t);Wd(t|0,151432,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=DV(o)|0;if((PG(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;HV(o,f,f,c[s>>2]|0);r=LG(a[EV(o)|0]|0)|0;break}s=c[k>>2]|0;f=DV(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}HV(o,f,p,s);r=LG(a[EV(o)|0]|0)|0}else{r=LG(a[g]|0)|0}}while(0);if((DV(o)|0)!=(e|0)){m=r;i=d;return m|0}HV(o,0,0,0);m=r;i=d;return m|0}function EG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=DV(g)|0;j=EV(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(HG(d,-1)|0){GV(g,-1);f=KG(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=IG(d)|0;do{if(h){if(MG(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);GV(g,-1);a[EV(g)|0]=b;f=d;i=e;return f|0}function FG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}GG(b);l=b;m=IV(l)|0;n=KV(l)|0;if(!(HG(d,-1)|0)){if((JV(l)|0)==0){MV(l,f,f+1|0)}f=IG(d)|0;a[JV(l)|0]=f;LV(l,1)}f=JV(l)|0;o=IV(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Gc(4)|0;u=t;g2(u);v=151432;w=128;Wd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=IV(l)|0;A=JV(l)|0;B=JG(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=IV(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((tc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;MV(l,B,JV(l)|0);B=KV(l)|0;LV(l,B-(IV(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Gc(4)|0;u=t;g2(u);v=151432;w=128;Wd(t|0,v|0,w|0)}else if((D|0)==14){q=(JV(l)|0)-C|0;if((tc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((tc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);MV(l,m,n)}k=KG(d)|0;i=e;return k|0}function GG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;HV(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;MV(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;MV(f,h,h+(g+ -1)|0);break}}else{MV(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function HG(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function IG(a){a=a|0;i=i;return a&255|0}function JG(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Je[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function KG(a){a=a|0;var b=0,c=0;b=i;c=HG(a,-1)|0;i=b;return(c?0:a)|0}function LG(a){a=a|0;i=i;return a&255|0}function MG(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function NG(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;MV(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;HV(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;HV(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function OG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=QG(b,c,e)|0;i=d;return g|0}function PG(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Je[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function QG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=RG(0,b,a)|0;i=c;return(d?b:a)|0}function RG(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function SG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Be[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function TG(a){a=a|0;var b=0,d=0;b=i;d=le[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function UG(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Be[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function VG(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function WG(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function XG(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=YG(b,c,e)|0;i=d;return g|0}function YG(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=ZG(0,a,b)|0;i=c;return(d?b:a)|0}function ZG(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function _G(a){a=a|0;var b=0,c=0;b=i;c=g$(a,135936)|0;i=b;return c|0}function $G(a){a=a|0;var b=0,d=0;b=i;d=le[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function aH(a){a=a|0;var b=0;b=i;bH(a);i=b;return}function bH(a){a=a|0;var b=0;b=i;cH(a);i=b;return}function cH(a){a=a|0;var b=0;b=i;dH(a,GF(a)|0);i=b;return}function dH(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;NF(d);if((b|0)==0){i=d;return}dH(a,c[b>>2]|0);dH(a,c[b+4>>2]|0);fH(eH(a)|0,b,1);i=d;return}function eH(a){a=a|0;var b=0,c=0;b=i;c=hH(a+4|0)|0;i=b;return c|0}function fH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;gH(0,b,0);i=c;return}function gH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;J2(b);i=c;return}function hH(a){a=a|0;var b=0,c=0;b=i;c=iH(a)|0;i=b;return c|0}function iH(a){a=a|0;i=i;return a|0}function jH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=kH(a,f,b)|0;l=c[k>>2]|0;NF(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}mH(j,a,b);nH(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];lH(g,e);oH(j);j=c[f>>2]|0;pH(a,j,k,qH(g)|0);k=rH(g)|0;oH(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function kH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=GF(h)|0;NF(e);if((a|0)==0){j=xF(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(KF(0,d,a)|0){m=l;j=c[m>>2]|0;NF(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(KF(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;NF(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function lH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];dI(a,e);i=d;return}function mH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=eH(d)|0;d=OH(n,1)|0;PH(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];NH(j,d,h);QH(0,JH((RH(j)|0)+16|0)|0,e);e=SH(j)|0;a[e+4|0]=1;TH(0,IH((RH(j)|0)+20|0)|0);a[e+5|0]=1;UH(m,j);nH(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];lH(b,g);oH(m);oH(j);i=f;return}function nH(a,b){a=a|0;b=b|0;var c=0;c=i;LH(a,b);i=c;return}function oH(a){a=a|0;var b=0;b=i;EH(a);i=b;return}function pH(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;NF(f);c[e>>2]=0;NF(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=wH(a)|0;b=c[c[e>>2]>>2]|0;NF(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(xF(a)|0)>>2]|0;xH(e,c[d>>2]|0);d=yH(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function qH(a){a=a|0;var b=0,d=0;b=i;d=c[(uH(a)|0)>>2]|0;i=b;return d|0}function rH(a){a=a|0;var b=0,d=0;b=i;d=sH(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function sH(a){a=a|0;var b=0,c=0;b=i;c=tH(a)|0;i=b;return c|0}function tH(a){a=a|0;i=i;return a|0}function uH(a){a=a|0;var b=0,c=0;b=i;c=vH(a)|0;i=b;return c|0}function vH(a){a=a|0;i=i;return a|0}function wH(a){a=a|0;i=i;return a|0}function xH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=BH(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;NF(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;NF(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(BH(j)|0){p=j}else{o=c[k>>2]|0;CH(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;DH(p);i=e;return}else if((l|0)==14){if(BH(j)|0){p=c[k>>2]|0;DH(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;CH(q);i=e;return}else if((l|0)==17){i=e;return}}function yH(a){a=a|0;var b=0,c=0;b=i;c=zH(a+8|0)|0;i=b;return c|0}function zH(a){a=a|0;var b=0,c=0;b=i;c=AH(a)|0;i=b;return c|0}function AH(a){a=a|0;i=i;return a|0}function BH(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function CH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;NF(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=BH(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function DH(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;NF(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=BH(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function EH(a){a=a|0;var b=0;b=i;FH(a,0);i=b;return}function FH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=sH(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}HH(GH(e)|0,f);i=d;return}function GH(a){a=a|0;var b=0,c=0;b=i;c=KH(a)|0;i=b;return c|0}function HH(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}fH(c[a>>2]|0,b,1);i=d;return}function IH(a){a=a|0;i=i;return a|0}function JH(a){a=a|0;i=i;return a|0}function KH(a){a=a|0;i=i;return a+4|0}function LH(a,b){a=a|0;b=b|0;var c=0;c=i;MH(a,b);i=c;return}function MH(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function NH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];XH(a,b,f);i=e;return}function OH(a,b){a=a|0;b=b|0;var c=0;a=i;c=WH(0,b,0)|0;i=a;return c|0}function PH(a,b){a=a|0;b=b|0;var c=0;c=i;VH(a,b);i=c;return}function QH(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function RH(a){a=a|0;var b=0,d=0;b=i;d=c[(uH(a)|0)>>2]|0;i=b;return d|0}function SH(a){a=a|0;var b=0,c=0;b=i;c=GH(a)|0;i=b;return c|0}function TH(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function UH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;LH(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];lH(h,f);nH(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];lH(a,e);oH(h);i=d;return}function VH(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function WH(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=H2(b*24|0)|0;i=c;return a|0}function XH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(ZH(g)|0)>>2]|0;g=_H(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];YH(b,a,f);i=e;return}function YH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];$H(a,b,f);i=e;return}function ZH(a){a=a|0;i=i;return a|0}function _H(a){a=a|0;i=i;return a|0}function $H(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(bI(g)|0)>>2]|0;g=cI(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];aI(b,a,f);i=e;return}function aI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(bI(f)|0)>>2];f=cI(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function bI(a){a=a|0;i=i;return a|0}function cI(a){a=a|0;i=i;return a|0}function dI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=rH(eI(b)|0)|0;h=cI(SH(eI(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];YH(g,a,e);i=d;return}function eI(a){a=a|0;i=i;return c[a>>2]|0}function fI(a){a=a|0;var b=0;b=i;i=i+48|0;gI(a);$E(a+184|0,0,0);$E(a+200|0,0,0);hI(a+240|0,b);hI(a+252|0,b+8|0);hI(a+264|0,b+16|0);hI(a+276|0,b+24|0);hI(a+288|0,b+32|0);hI(a+300|0,b+40|0);i=b;return}function gI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;tV(d);e=a;c[e>>2]=103884;f=d;c[f>>2]=103904;d=a+4|0;AW(a,103916|0,d);c[e>>2]=103884;c[f>>2]=103904;uI(d);i=b;return}function hI(a,b){a=a|0;b=b|0;b=i;iI(a,0);i=b;return}function iI(a,b){a=a|0;b=b|0;b=i;i=i+8|0;jI(a,b);i=b;return}function jI(a,b){a=a|0;b=b|0;b=i;kI(a,0);i=b;return}function kI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;lI(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;mI(f,0,e);e=xF(b)|0;c[(wH(b)|0)>>2]=e;i=d;return}function lI(a){a=a|0;var b=0;b=i;qI(a);i=b;return}function mI(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;nI(b,c,f);i=e;return}function nI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(pI(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;oI(d,b,f);i=e;return}function oI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(pI(e)|0)>>2];i=d;return}function pI(a){a=a|0;i=i;return a|0}function qI(a){a=a|0;var b=0;b=i;rI(a);i=b;return}



function ao(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[(c[a+416>>2]|0)+416>>3];i=i;return}function bo(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+(c[(c[b+420>>2]|0)+20>>2]|0)*+h[e+408>>3];g=+h[e+384>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+xz(c[b+536>>2]|0,f,18560,18552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+736>>3]=j;i=d;return}function co(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[(c[a+416>>2]|0)+384>>3];i=i;return}function eo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+760>>3]=+h[(c[a+416>>2]|0)+344>>3];i=i;return}function fo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+776>>3]=+h[(c[a+416>>2]|0)+384>>3];i=i;return}function go(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0;d=i;e=(c[(c[b+420>>2]|0)+8>>2]|0)+ -1|0;f=+(e|0);g=c[b+416>>2]|0;j=+h[g+256>>3]- +h[g+264>>3];do{if((e|0)==0){if(j==0.0){k=j;break}k=j/+xz(c[b+536>>2]|0,f,18616,18608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}else{k=j/f}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+200>>3]=k;i=d;return}function ho(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+224>>3]=+h[(c[a+416>>2]|0)+384>>3];i=i;return}function io(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;rz(9,1,18648,A);if((c[61148>>2]|0)!=0){ie[c[15416]&255](9)}rz(9,1,18672,z);if((c[61148>>2]|0)!=0){ie[c[15416]&255](9)}rz(9,1,18696,y);if((c[61148>>2]|0)!=0){ie[c[15416]&255](9)}Sn(a);Tn(a);Un(a);Vn(a);Wn(a);Xn(a);Yn(a);Zn(a);_n(a);$n(a);ao(a);bo(a);co(a);eo(a);fo(a);go(a);ho(a);rz(9,1,18720,x);x=a+4|0;B=+h[c[(c[c[x>>2]>>2]|0)+8>>2]>>3];y=a+8|0;a=c[y>>2]|0;h[a+96>>3]=B;c[w>>2]=c[a+4>>2];a=w+4|0;h[k>>3]=B;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];rz(9,0,18744,w);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+544>>3];w=c[y>>2]|0;h[w+7712>>3]=B;c[v>>2]=c[w+7620>>2];w=v+4|0;h[k>>3]=B;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rz(9,0,18744,v);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+552>>3];v=c[y>>2]|0;h[v+7824>>3]=B;c[u>>2]=c[v+7732>>2];v=u+4|0;h[k>>3]=B;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];rz(9,0,18744,u);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+8>>3];u=c[y>>2]|0;h[u+208>>3]=B;c[t>>2]=c[u+116>>2];u=t+4|0;h[k>>3]=B;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];rz(9,0,18744,t);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+624>>3];t=c[y>>2]|0;h[t+8832>>3]=B;c[s>>2]=c[t+8740>>2];t=s+4|0;h[k>>3]=B;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];rz(9,0,18744,s);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+104>>3];s=c[y>>2]|0;h[s+1552>>3]=B;c[r>>2]=c[s+1460>>2];s=r+4|0;h[k>>3]=B;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];rz(9,0,18744,r);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+96>>3];r=c[y>>2]|0;h[r+1440>>3]=B;c[q>>2]=c[r+1348>>2];r=q+4|0;h[k>>3]=B;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(9,0,18744,q);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+88>>3];q=c[y>>2]|0;h[q+1328>>3]=B;c[p>>2]=c[q+1236>>2];q=p+4|0;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];rz(9,0,18744,p);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+24>>3];p=c[y>>2]|0;h[p+432>>3]=B;c[o>>2]=c[p+340>>2];p=o+4|0;h[k>>3]=B;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rz(9,0,18744,o);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+728>>3];o=c[y>>2]|0;h[o+10288>>3]=B;c[n>>2]=c[o+10196>>2];o=n+4|0;h[k>>3]=B;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];rz(9,0,18744,n);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+32>>3];n=c[y>>2]|0;h[n+544>>3]=B;c[m>>2]=c[n+452>>2];n=m+4|0;h[k>>3]=B;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rz(9,0,18744,m);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+736>>3];m=c[y>>2]|0;h[m+10400>>3]=B;c[l>>2]=c[m+10308>>2];m=l+4|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];rz(9,0,18744,l);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+752>>3];l=c[y>>2]|0;h[l+10624>>3]=B;c[j>>2]=c[l+10532>>2];l=j+4|0;h[k>>3]=B;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];rz(9,0,18744,j);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+760>>3];j=c[y>>2]|0;h[j+10736>>3]=B;c[g>>2]=c[j+10644>>2];j=g+4|0;h[k>>3]=B;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];rz(9,0,18744,g);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+776>>3];g=c[y>>2]|0;h[g+10960>>3]=B;c[f>>2]=c[g+10868>>2];g=f+4|0;h[k>>3]=B;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];rz(9,0,18744,f);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+200>>3];f=c[y>>2]|0;h[f+2896>>3]=B;c[e>>2]=c[f+2804>>2];f=e+4|0;h[k>>3]=B;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];rz(9,0,18744,e);B=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+224>>3];x=c[y>>2]|0;h[x+3232>>3]=B;c[d>>2]=c[x+3140>>2];x=d+4|0;h[k>>3]=B;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];rz(9,0,18744,d);if((c[61148>>2]|0)==0){i=b;return 0}ie[c[15416]&255](9);i=b;return 0}function jo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+944>>3]=.018015268;i=i;return}function ko(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+952>>3]=461.5236365065454;i=i;return}function lo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=1;i=i;return}function mo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+312>>3]=1.0;i=i;return}function no(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+320>>3]=.6563429036687328;i=i;return}function oo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function po(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+960>>3]=.018015268;i=i;return}function qo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+968>>3]=461.5236365065454;i=i;return}function ro(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=1;i=i;return}function so(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+328>>3]=1.0;i=i;return}function to(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function uo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function vo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+976>>3]=84013.05815259689;i=i;return}function wo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+984>>3]=.018015268;i=i;return}function xo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+992>>3]=461.5236365065454;i=i;return}function yo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=1;i=i;return}function zo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+336>>3]=1.0;i=i;return}function Ao(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=1;i=i;return}function Bo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1016>>3]=.018015268;i=i;return}function Co(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1024>>3]=461.5236365065454;i=i;return}function Do(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=1;i=i;return}function Eo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+344>>3]=1.0;i=i;return}function Fo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=1;i=i;return}function Go(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1048>>3]=0.0;i=i;return}function Ho(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+368>>3]=0.0;i=i;return}function Io(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+392>>3]=0.0;i=i;return}function Jo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+416>>3]=0.0;i=i;return}function Ko(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+80>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+440>>3]=b*b*.7853981633974483;i=i;return}function Lo(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+48>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+432>>3]=b*b*.7853981633974483;i=i;return}function Mo(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+16>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+424>>3]=b*b*.7853981633974483;i=i;return}function No(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=+h[(c[a+416>>2]|0)+144>>3]+-273.15;i=i;return}function Oo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1208>>3]=.05;i=i;return}function Po(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function Qo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=0;i=i;return}function Ro(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+472>>3]=0.0;i=i;return}function So(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1216>>3]=84013.05815259689;i=i;return}function To(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+480>>3]=0.0;i=i;return}function Uo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1224>>3]=0.0;i=i;return}function Vo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+488>>3]=0.0;i=i;return}function Wo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+760>>3];i=i;return}function Xo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1200>>3]=+h[(c[a+416>>2]|0)+128>>3]*1.0e-5;i=i;return}function Yo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+128>>3],+h[k+144>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+128>>3];m=+h[g+144>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Hi(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1152>>3]=+h[f>>3];i=b;return}function Zo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+128>>3],+h[k+144>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+128>>3];m=+h[g+144>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Ji(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1144>>3]=+h[f>>3];i=b;return}function _o(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Zg(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+128>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1136>>3]=+h[d>>3];i=b;return}function $o(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1152>>3];k=+h[g+1144>>3];l=+h[(c[b+416>>2]|0)+128>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+1096|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+1096|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,18768,18760,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+1096|0;r=q;h[r>>3]=o;i=d;return}function ap(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Pi(e,c[g>>2]|0,+h[(c[j>>2]|0)+128>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3],0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+128>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Ni(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1072>>3]=+h[f>>3];i=b;return}function bp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Pi(e,c[g>>2]|0,+h[(c[j>>2]|0)+128>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3],0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+128>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Gi(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1064>>3]=+h[f>>3];i=b;return}function cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+128>>3],+h[k+144>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+128>>3];m=+h[g+144>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Hi(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1008>>3]=+h[f>>3];i=b;return}function dp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+128>>3],+h[k+144>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+128>>3];m=+h[g+144>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Ji(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e3>>3]=+h[f>>3];i=b;return}function ep(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+176>>3];h[b+216>>3]=d*d*.7853981633974483;i=i;return}function fp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+224>>3]=+h[b+176>>3]*3.141592653589793;i=i;return}function gp(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+224>>3];g=+h[e+216>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+xz(c[b+536>>2]|0,f,18792,18784,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+464>>3]=j*4.0;i=d;return}function hp(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+224>>3];g=+h[e+216>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+xz(c[b+536>>2]|0,f,18792,18808,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+456>>3]=j*4.0;i=d;return}function ip(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=(+h[b+456>>3]+ +h[b+464>>3])*.5;i=i;return}function jp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+160>>3];i=i;return}function kp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+296>>3]=+h[b+816>>3];i=i;return}function lp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+288>>3]=+h[b+296>>3]*100.0;i=i;return}function mp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+248>>3];m=+h[k+288>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+xz(g,l,18824,18816,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+248>>3];o=r;p=q}}while(0);l=+h[o+328>>3];m=+h[o+336>>3];q=+h[o+168>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+448>>3];t=+h[o+184>>3];u=(t+t)*.5;t=+h[o+296>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+xz(c[f>>2]|0,n,18824,18816,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);ph(e,g,p,l,l,m,m,q,s,u,w,+h[v+272>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1056>>3]=+h[e>>3];i=d;return}function np(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+12>>2]=(c[b+8>>2]|0)+ -1;i=i;return}function op(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+312>>3]=+h[b+776>>3];i=i;return}function pp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+784>>3];i=i;return}function qp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+344>>3];i=i;return}function rp(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+30|0]=a[d+23|0]|0;i=i;return}function sp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+768>>3];i=i;return}function tp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+816>>3]*100.0;i=i;return}function up(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+816>>3];i=i;return}function vp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+512>>3]=+h[b+760>>3];i=i;return}function wp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1184>>3]=+h[(c[a+416>>2]|0)+512>>3]*1.0e-5;i=i;return}function xp(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Zg(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+512>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1160>>3]=+h[d>>3];i=b;return}function yp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+520>>3]=+h[b+768>>3];i=i;return}function zp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+496>>3];i=i;return}function Ap(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+544>>3]=+h[b+504>>3];i=i;return}function Bp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+552>>3]=+h[b+512>>3];i=i;return}function Cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;DA(e,1,+h[(c[g>>2]|0)+112>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+552>>3];l=+h[a+464>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Hh(f,j,k,l,d,0);h[(c[g>>2]|0)+472>>3]=+h[f>>3];i=b;return}function Dp(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+38|0]=a[d+33|0]|0;i=i;return}function Ep(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+768>>3];i=i;return}function Fp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+816>>3];i=i;return}function Gp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+784>>3];i=i;return}function Hp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+760>>3];i=i;return}function Ip(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1176>>3]=+h[(c[a+416>>2]|0)+632>>3]*1.0e-5;i=i;return}function Jp(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Zg(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+632>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1112>>3]=+h[d>>3];i=b;return}function Kp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+768>>3];i=i;return}function Lp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=+h[(c[a+416>>2]|0)+648>>3]+-273.15;i=i;return}function Mp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+632>>3],+h[k+648>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+632>>3];m=+h[g+648>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Hi(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1128>>3]=+h[f>>3];i=b;return}function Np(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Pi(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1128>>3],0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1128>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Ni(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1088>>3]=+h[f>>3];i=b;return}function Op(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Pi(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1128>>3],0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1128>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Gi(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1080>>3]=+h[f>>3];i=b;return}function Pp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+632>>3],+h[k+648>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+632>>3];m=+h[g+648>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Ji(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1120>>3]=+h[f>>3];i=b;return}function Qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1128>>3];k=+h[g+1120>>3];l=+h[(c[b+416>>2]|0)+632>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+1104|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+1104|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,18864,18856,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+1104|0;r=q;h[r>>3]=o;i=d;return}function Rp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+632>>3],+h[k+648>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+632>>3];m=+h[g+648>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Hi(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1040>>3]=+h[f>>3];i=b;return}function Sp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+632>>3],+h[k+648>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+632>>3];m=+h[g+648>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Ji(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1032>>3]=+h[f>>3];i=b;return}function Tp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+816>>3]*100.0;i=i;return}function Up(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+760>>3];i=i;return}function Vp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+824>>3]*.01;i=i;return}function Wp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+376>>3]=+h[b+824>>3];i=i;return}function Xp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+376>>3];i=i;return}function Yp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+416>>3];i=i;return}function Zp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+200>>3]=+h[b+824>>3];i=i;return}function _p(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+256>>3]=+h[b+200>>3];i=i;return}function $p(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+232>>3]=+h[b+200>>3];i=i;return}function aq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+232>>3];i=i;return}function bq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+768>>3];i=i;return}function cq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+360>>3]=+h[b+832>>3];i=i;return}function dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;DA(e,1,+h[(c[g>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+432>>3];l=+h[a+360>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];fh(f,j,k,l,d,0);h[(c[g>>2]|0)+368>>3]=+h[f>>3];i=b;return}function eq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18880]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+96>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(18896,cA(c[(c[g>>2]|0)+96>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=19184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[18880]=1;i=d;return}function fq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19208]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+92>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+92>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(19216,cA(c[(c[g>>2]|0)+92>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=19448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[19208]=1;i=d;return}function gq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19472]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+88>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(19480,cA(c[(c[g>>2]|0)+88>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=19696;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[19472]=1;i=d;return}function hq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19720]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(19736,aA(+h[(c[g>>2]|0)+832>>3],19728)|0)|0;g=c[27738]|0;j=e;k=19824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[19720]=1;i=d;return}function iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19848]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(19856,aA(+h[(c[g>>2]|0)+824>>3],19728)|0)|0;g=c[27738]|0;j=e;k=19944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[19848]=1;i=d;return}function jq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19968]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(19976,aA(+h[(c[g>>2]|0)+816>>3],19728)|0)|0;g=c[27738]|0;j=e;k=20072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[19968]=1;i=d;return}function kq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20096]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(20104,aA(+h[(c[g>>2]|0)+808>>3],19728)|0)|0;g=c[27738]|0;j=e;k=20192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[20096]=1;i=d;return}function lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20216]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(20224,aA(+h[(c[g>>2]|0)+800>>3],19728)|0)|0;g=c[27738]|0;j=e;k=20320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[20216]=1;i=d;return}function mq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20344]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+84>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(20352,cA(c[(c[g>>2]|0)+84>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=20576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[20344]=1;i=d;return}function nq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20600]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+80>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+80>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(20608,cA(c[(c[g>>2]|0)+80>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=20824;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[20600]=1;i=d;return}function oq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20848]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(20856,aA(+h[(c[g>>2]|0)+768>>3],19728)|0)|0;g=c[27738]|0;j=e;k=20952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[20848]=1;i=d;return}function pq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20976]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(20984,aA(+h[(c[g>>2]|0)+760>>3],19728)|0)|0;g=c[27738]|0;j=e;k=21080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[20976]=1;i=d;return}function qq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21104]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+76>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(21112,cA(c[(c[g>>2]|0)+76>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=21368;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[21104]=1;i=d;return}function rq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21392]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(21400,aA(+h[(c[g>>2]|0)+728>>3],19728)|0)|0;g=c[27738]|0;j=e;k=21584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[21392]=1;i=d;return}function sq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21608]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(21616,aA(+h[(c[g>>2]|0)+712>>3],19728)|0)|0;g=c[27738]|0;j=e;k=21720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[21608]=1;i=d;return}function tq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21744]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+120>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+120>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(21752,aA(+h[(c[g>>2]|0)+120>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[21744]=1;i=d;return}function uq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21928]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+656>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+656>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(21936,aA(+h[(c[g>>2]|0)+656>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[21928]=1;i=d;return}function vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22048]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+648>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+648>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(22056,aA(+h[(c[g>>2]|0)+648>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[22048]=1;i=d;return}function wq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22152]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+640>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+640>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(22160,aA(+h[(c[g>>2]|0)+640>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[22152]=1;i=d;return}function xq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22256]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+632>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(22264,aA(+h[(c[g>>2]|0)+632>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[22256]=1;i=d;return}function yq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22360]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+72>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gA(22368,cA(c[(c[g>>2]|0)+72>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=34184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[22360]=1;i=d;return}function zq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22592]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+616>>3],-1.0e5)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+616>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(22600,aA(+h[(c[g>>2]|0)+616>>3],19728)|0)|0;g=c[27738]|0;j=e;k=22832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[22592]=1;i=d;return}function Aq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22856]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+608>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+608>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(22864,aA(+h[(c[g>>2]|0)+608>>3],19728)|0)|0;g=c[27738]|0;j=e;k=23e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[22856]=1;i=d;return}function Bq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23024]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+600>>3],-1.0e5)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+600>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(23032,aA(+h[(c[g>>2]|0)+600>>3],19728)|0)|0;g=c[27738]|0;j=e;k=23264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[23024]=1;i=d;return}function Cq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23288]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(23296,aA(+h[(c[g>>2]|0)+592>>3],19728)|0)|0;g=c[27738]|0;j=e;k=23400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[23288]=1;i=d;return}function Dq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23424]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+584>>3],-1.0e5)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+584>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(23432,aA(+h[(c[g>>2]|0)+584>>3],19728)|0)|0;g=c[27738]|0;j=e;k=23584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[23424]=1;i=d;return}function Eq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23608]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(23616,aA(+h[(c[g>>2]|0)+576>>3],19728)|0)|0;g=c[27738]|0;j=e;k=28320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[23608]=1;i=d;return}function Fq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23744]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+112>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+112>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(23752,aA(+h[(c[g>>2]|0)+112>>3],19728)|0)|0;g=c[27738]|0;j=e;k=29496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[23744]=1;i=d;return}function Gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23888]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(23896,aA(+h[(c[g>>2]|0)+560>>3],19728)|0)|0;g=c[27738]|0;j=e;k=24080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[23888]=1;i=d;return}function Hq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24104]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+552>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(24112,aA(+h[(c[g>>2]|0)+552>>3],19728)|0)|0;g=c[27738]|0;j=e;k=28680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[24104]=1;i=d;return}function Iq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24248]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+60>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(24256,cA(c[(c[g>>2]|0)+60>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=28928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[24248]=1;i=d;return}function Jq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24480]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+56>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(24488,cA(c[(c[g>>2]|0)+56>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=29184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[24480]=1;i=d;return}function Kq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24728]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(24736,aA(+h[(c[g>>2]|0)+536>>3],19728)|0)|0;g=c[27738]|0;j=e;k=24840;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[24728]=1;i=d;return}function Lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24864]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(24872,aA(+h[(c[g>>2]|0)+528>>3],19728)|0)|0;g=c[27738]|0;j=e;k=24984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[24864]=1;i=d;return}function Mq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25008]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+520>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+520>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(25016,aA(+h[(c[g>>2]|0)+520>>3],19728)|0)|0;g=c[27738]|0;j=e;k=25152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[25008]=1;i=d;return}function Nq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25176]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+512>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+512>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(25184,aA(+h[(c[g>>2]|0)+512>>3],19728)|0)|0;g=c[27738]|0;j=e;k=25320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[25176]=1;i=d;return}function Oq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25344]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+52>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(25352,cA(c[(c[g>>2]|0)+52>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=29896;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[25344]=1;i=d;return}function Pq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25576]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+48>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(25584,cA(c[(c[g>>2]|0)+48>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=30144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[25576]=1;i=d;return}function Qq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25816]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(25824,aA(+h[(c[g>>2]|0)+496>>3],19728)|0)|0;g=c[27738]|0;j=e;k=25920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[25816]=1;i=d;return}function Rq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25944]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(25952,aA(+h[(c[g>>2]|0)+488>>3],19728)|0)|0;g=c[27738]|0;j=e;k=26056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[25944]=1;i=d;return}function Sq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26080]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+480>>3],-1.0e5)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+480>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(26088,aA(+h[(c[g>>2]|0)+480>>3],19728)|0)|0;g=c[27738]|0;j=e;k=26248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[26080]=1;i=d;return}function Tq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26272]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(26280,aA(+h[(c[g>>2]|0)+104>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[26272]=1;i=d;return}function Uq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26400]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+96>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(26408,aA(+h[(c[g>>2]|0)+96>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[26400]=1;i=d;return}function Vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26528]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(26536,aA(+h[(c[g>>2]|0)+88>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[26528]=1;i=d;return}function Wq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26656]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+80>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(26664,aA(+h[(c[g>>2]|0)+80>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[26656]=1;i=d;return}function Xq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26784]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(26792,aA(+h[(c[g>>2]|0)+72>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[26784]=1;i=d;return}function Yq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26912]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+64>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(26920,aA(+h[(c[g>>2]|0)+64>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[26912]=1;i=d;return}function Zq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27040]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(27048,aA(+h[(c[g>>2]|0)+56>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[27040]=1;i=d;return}function _q(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27168]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+48>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(27176,aA(+h[(c[g>>2]|0)+48>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[27168]=1;i=d;return}function $q(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27296]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(27304,aA(+h[(c[g>>2]|0)+40>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[27296]=1;i=d;return}function ar(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27448]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+32>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(27456,aA(+h[(c[g>>2]|0)+32>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[27448]=1;i=d;return}function br(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27600]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(27608,aA(+h[(c[g>>2]|0)+24>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[27600]=1;i=d;return}function cr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27752]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(27760,aA(+h[(c[g>>2]|0)+16>>3],19728)|0)|0;g=c[27738]|0;j=e;k=27880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[27752]=1;i=d;return}function dr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27904]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+472>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+472>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(27912,aA(+h[(c[g>>2]|0)+472>>3],19728)|0)|0;g=c[27738]|0;j=e;k=30640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[27904]=1;i=d;return}function er(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28056]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+464>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+464>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(28064,aA(+h[(c[g>>2]|0)+464>>3],19728)|0)|0;g=c[27738]|0;j=e;k=30792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[28056]=1;i=d;return}function fr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28192]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(28200,aA(+h[(c[g>>2]|0)+456>>3],19728)|0)|0;g=c[27738]|0;j=e;k=28320;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[28192]=1;i=d;return}function gr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28344]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(28352,aA(+h[(c[g>>2]|0)+440>>3],19728)|0)|0;g=c[27738]|0;j=e;k=28528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[28344]=1;i=d;return}function hr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28552]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+432>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+432>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(28560,aA(+h[(c[g>>2]|0)+432>>3],19728)|0)|0;g=c[27738]|0;j=e;k=28680;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[28552]=1;i=d;return}function ir(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28704]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+36>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(28712,cA(c[(c[g>>2]|0)+36>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=28928;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[28704]=1;i=d;return}function jr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28952]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+32>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(28960,cA(c[(c[g>>2]|0)+32>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=29184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[28952]=1;i=d;return}function kr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29208]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+416>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+416>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(29216,aA(+h[(c[g>>2]|0)+416>>3],19728)|0)|0;g=c[27738]|0;j=e;k=29344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[29208]=1;i=d;return}function lr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29368]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+8>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(29376,aA(+h[(c[g>>2]|0)+8>>3],19728)|0)|0;g=c[27738]|0;j=e;k=29496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[29368]=1;i=d;return}function mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29520]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+408>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+408>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(29528,aA(+h[(c[g>>2]|0)+408>>3],19728)|0)|0;g=c[27738]|0;j=e;k=29656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[29520]=1;i=d;return}function nr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29680]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+28>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(29688,cA(c[(c[g>>2]|0)+28>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=29896;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[29680]=1;i=d;return}function or(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29920]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+24>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(29928,cA(c[(c[g>>2]|0)+24>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=30144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[29920]=1;i=d;return}function pr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30168]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+384>>3],-1.0e5)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+384>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(30176,aA(+h[(c[g>>2]|0)+384>>3],19728)|0)|0;g=c[27738]|0;j=e;k=30312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[30168]=1;i=d;return}function qr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30336]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+376>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(30344,aA(+h[(c[g>>2]|0)+376>>3],19728)|0)|0;g=c[27738]|0;j=e;k=30472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[30336]=1;i=d;return}function rr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30496]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+368>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+368>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(30504,aA(+h[(c[g>>2]|0)+368>>3],19728)|0)|0;g=c[27738]|0;j=e;k=30640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[30496]=1;i=d;return}function sr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30664]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+360>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+360>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(30672,aA(+h[(c[g>>2]|0)+360>>3],19728)|0)|0;g=c[27738]|0;j=e;k=30792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[30664]=1;i=d;return}function tr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30816]&1){i=d;return}g=b+420|0;if(!((gD(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=gA(30824,cA(c[(c[g>>2]|0)+20>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=30912;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[30816]=1;i=d;return}function ur(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30936]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(30944,aA(+h[(c[g>>2]|0)+336>>3],19728)|0)|0;g=c[27738]|0;j=e;k=31128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[30936]=1;i=d;return}function vr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31152]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(31160,aA(+h[(c[g>>2]|0)+328>>3],19728)|0)|0;g=c[27738]|0;j=e;k=31272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[31152]=1;i=d;return}function wr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31296]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+320>>3],-1.0e5)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(31304,aA(+h[(c[g>>2]|0)+320>>3],19728)|0)|0;g=c[27738]|0;j=e;k=31472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[31296]=1;i=d;return}function xr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31496]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+16>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gA(31504,cA(c[(c[g>>2]|0)+16>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=31752;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[31496]=1;i=d;return}function yr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31776]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(31784,aA(+h[(c[g>>2]|0)+304>>3],19728)|0)|0;g=c[27738]|0;j=e;k=31888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[31776]=1;i=d;return}function zr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31912]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(31920,aA(+h[(c[g>>2]|0)+280>>3],19728)|0)|0;g=c[27738]|0;j=e;k=32032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[31912]=1;i=d;return}function Ar(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32056]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+264>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(32064,aA(+h[(c[g>>2]|0)+264>>3],19728)|0)|0;g=c[27738]|0;j=e;k=32216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[32056]=1;i=d;return}function Br(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32240]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+256>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(32248,aA(+h[(c[g>>2]|0)+256>>3],19728)|0)|0;g=c[27738]|0;j=e;k=32400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[32240]=1;i=d;return}function Cr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32424]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+232>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(32432,aA(+h[(c[g>>2]|0)+232>>3],19728)|0)|0;g=c[27738]|0;j=e;k=32552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[32424]=1;i=d;return}function Dr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32576]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+208>>3],-1.0e5)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+208>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(32584,aA(+h[(c[g>>2]|0)+208>>3],19728)|0)|0;g=c[27738]|0;j=e;k=32720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[32576]=1;i=d;return}function Er(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32744]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+200>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+200>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(32752,aA(+h[(c[g>>2]|0)+200>>3],19728)|0)|0;g=c[27738]|0;j=e;k=32872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[32744]=1;i=d;return}function Fr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32896]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(32904,aA(+h[(c[g>>2]|0)+184>>3],19728)|0)|0;g=c[27738]|0;j=e;k=32992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[32896]=1;i=d;return}function Gr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33016]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(33024,aA(+h[(c[g>>2]|0)+176>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[33016]=1;i=d;return}function Hr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33136]&1){i=d;return}g=b+416|0;if(!((gD(+h[(c[g>>2]|0)+160>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(33144,aA(+h[(c[g>>2]|0)+160>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33232;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[33136]=1;i=d;return}function Ir(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33256]&1){i=d;return}g=b+416|0;b=gD(+h[c[g>>2]>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[c[g>>2]>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(33264,aA(+h[c[g>>2]>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[33256]=1;i=d;return}function Jr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33392]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+152>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+152>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(33400,aA(+h[(c[g>>2]|0)+152>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[33392]=1;i=d;return}function Kr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33544]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+144>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+144>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(33552,aA(+h[(c[g>>2]|0)+144>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[33544]=1;i=d;return}function Lr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33680]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+136>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+136>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(33688,aA(+h[(c[g>>2]|0)+136>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[33680]=1;i=d;return}function Mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33816]&1){i=d;return}g=b+416|0;b=gD(+h[(c[g>>2]|0)+128>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[g>>2]|0)+128>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(33824,aA(+h[(c[g>>2]|0)+128>>3],19728)|0)|0;g=c[27738]|0;j=e;k=33928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[33816]=1;i=d;return}function Nr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33952]&1){i=d;return}g=b+420|0;b=gD(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[g>>2]|0)+4>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gA(33960,cA(c[(c[g>>2]|0)+4>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=34184;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[33952]=1;i=d;return}function Or(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34208]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1224>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(34216,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1224>>3],19728)|0)|0;g=c[27738]|0;j=e;k=37632;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[34208]=1;i=d;return}function Pr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34384]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(34392,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],19728)|0)|0;g=c[27738]|0;j=e;k=39752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[34384]=1;i=d;return}function Qr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34592]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(34600,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=40808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[34592]=1;i=d;return}function Rr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34832]&1){i=d;return}g=b+4|0;b=gD(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(34840,cA(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=40808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[34832]=1;i=d;return}function Sr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35e3]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1160>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1160>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(35008,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1160>>3],19728)|0)|0;g=c[27738]|0;j=e;k=36248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[35e3]=1;i=d;return}function Tr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35160]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],-1.0e8)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(35168,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],19728)|0)|0;g=c[27738]|0;j=e;k=35336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[35160]=1;i=d;return}function Ur(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35360]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(35368,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],19728)|0)|0;g=c[27738]|0;j=e;k=35928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[35360]=1;i=d;return}function Vr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35504]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(35512,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],19728)|0)|0;g=c[27738]|0;j=e;k=36080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[35504]=1;i=d;return}function Wr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35632]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(35640,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],19728)|0)|0;g=c[27738]|0;j=e;k=36248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[35632]=1;i=d;return}function Xr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35784]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(35792,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],19728)|0)|0;g=c[27738]|0;j=e;k=35928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[35784]=1;i=d;return}function Yr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35952]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(35960,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],19728)|0)|0;g=c[27738]|0;j=e;k=36080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[35952]=1;i=d;return}function Zr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36104]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(36112,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],19728)|0)|0;g=c[27738]|0;j=e;k=36248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[36104]=1;i=d;return}function _r(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36272]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3],-1.0e8)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(36280,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3],19728)|0)|0;g=c[27738]|0;j=e;k=36552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[36272]=1;i=d;return}function $r(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36408]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1096>>3],-1.0e8)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1096>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(36416,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1096>>3],19728)|0)|0;g=c[27738]|0;j=e;k=36552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[36408]=1;i=d;return}function as(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36576]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1088>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1088>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(36584,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1088>>3],19728)|0)|0;g=c[27738]|0;j=e;k=38976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[36576]=1;i=d;return}function bs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36800]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1080>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1080>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(36808,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1080>>3],19728)|0)|0;g=c[27738]|0;j=e;k=37280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[36800]=1;i=d;return}function cs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36944]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1072>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1072>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(36952,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1072>>3],19728)|0)|0;g=c[27738]|0;j=e;k=38976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[36944]=1;i=d;return}function ds(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37112]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1064>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1064>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(37120,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1064>>3],19728)|0)|0;g=c[27738]|0;j=e;k=37280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[37112]=1;i=d;return}function es(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37304]&1){i=d;return}g=b+4|0;if(!((gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(37312,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1056>>3],19728)|0)|0;g=c[27738]|0;j=e;k=37432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[37304]=1;i=d;return}function fs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37456]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1048>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1048>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(37464,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1048>>3],19728)|0)|0;g=c[27738]|0;j=e;k=37632;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[37456]=1;i=d;return}function gs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37656]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(37664,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=40808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[37656]=1;i=d;return}function hs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37784]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1040>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1040>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(37792,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1040>>3],19728)|0)|0;g=c[27738]|0;j=e;k=38824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[37784]=1;i=d;return}function is(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37920]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1032>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1032>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(37928,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1032>>3],19728)|0)|0;g=c[27738]|0;j=e;k=38976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[37920]=1;i=d;return}function js(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38040]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(38048,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],19728)|0)|0;g=c[27738]|0;j=e;k=40968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[38040]=1;i=d;return}function ks(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38168]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(38176,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=41120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[38168]=1;i=d;return}function ls(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38296]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=gA(38304,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],19728)|0)|0;g=c[27738]|0;j=e;k=41272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[38296]=1;i=d;return}function ms(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38424]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],.001)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],.25)|0)<<24>>24==0)){i=d;return}b=gA(38432,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],19728)|0)|0;g=c[27738]|0;j=e;k=41424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[38424]=1;i=d;return}function ns(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38552]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(38560,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=40808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[38552]=1;i=d;return}function os(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38680]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1008>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1008>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(38688,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1008>>3],19728)|0)|0;g=c[27738]|0;j=e;k=38824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[38680]=1;i=d;return}function ps(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38848]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1e3>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1e3>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(38856,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1e3>>3],19728)|0)|0;g=c[27738]|0;j=e;k=38976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[38848]=1;i=d;return}function qs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39e3]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(39008,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],19728)|0)|0;g=c[27738]|0;j=e;k=40968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[39e3]=1;i=d;return}function rs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39136]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(39144,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=41120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[39136]=1;i=d;return}function ss(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39272]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+992>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+992>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=gA(39280,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+992>>3],19728)|0)|0;g=c[27738]|0;j=e;k=41272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[39272]=1;i=d;return}function ts(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39408]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],.001)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],.25)|0)<<24>>24==0)){i=d;return}b=gA(39416,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],19728)|0)|0;g=c[27738]|0;j=e;k=41424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[39408]=1;i=d;return}function us(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39544]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(39552,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],19728)|0)|0;g=c[27738]|0;j=e;k=39752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[39544]=1;i=d;return}function vs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39776]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(39784,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=40808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[39776]=1;i=d;return}function ws(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39920]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(39928,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=40808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[39920]=1;i=d;return}



function xB(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[18748]=c[o>>2];c[o>>2]=0;h[9370]=0.0;a[74976]=0;t=c[b>>2]|0;c[18738]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+hS(75008,j+(v<<3)|0);if(w==+hS(75008,l+((c[18738]|0)+ -1<<3)|0)){break}y=c[18738]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[9370]){break}h[9370]=B;c[o>>2]=y}else{a[74976]=1}}while(0);v=c[18738]|0;u=v+1|0;c[18738]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[74984]=1;c[18750]=c[p>>2];h[g>>3]=+h[r>>3];t=72328;TB(b,l,t,k,t)|0;c[p>>2]=1;a[74968]=0;C=0}else{a[74984]=0;c[o>>2]=c[18748];c[18750]=c[p>>2];if(a[74976]&1){h[g>>3]=+h[r>>3];t=72328;TB(b,l,t,k,t)|0;a[74968]=1;C=1;break}else{t=72328;TB(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[74968]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[74968]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=72328;TB(b,k,t,l,t)|0;t=c[b>>2]|0;c[18738]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[18738]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+hS(75008,j+(u<<3)|0);if(!(A!=+hS(75008,k+((c[18738]|0)+ -1<<3)|0))){break}c[n+((c[18738]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[18738]|0;F=u+1|0;c[18738]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[9370]=0.0;a[74976]=0;t=c[b>>2]|0;c[18738]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+hS(75008,j+(v<<3)|0);if(A==+hS(75008,k+((c[18738]|0)+ -1<<3)|0)){break}y=c[18738]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[9370]){break}h[9370]=I;c[o>>2]=y}else{a[74976]=1}}while(0);v=c[18738]|0;u=v+1|0;c[18738]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[74984]=t&1;if(t){a[74968]=0;c[18750]=0;c[p>>2]=1;break}if(!(a[74976]&1)){t=72328;TB(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=72328;TB(b,k,t,l,t)|0;t=c[b>>2]|0;c[18738]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[18738]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[18738]|0}u=K+1|0;c[18738]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[18750]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function yB(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[9379]=+h[d>>3];h[9378]=+h[e>>3];j=c[a>>2]|0;c[18754]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[9379]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[9379]=o;h[9378]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[9378];a=l+1|0;c[18754]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function zB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[9382]=0.0;e=c[a>>2]|0;c[18760]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[9382]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[18760]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[9381]=0.0;e=c[a>>2]|0;c[18760]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[9381]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[18760]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function AB(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[18778]=0;c[18776]=0;c[18782]=0;h[9394]=+h[b>>3];h[9396]=+zB(f,d,l,0,0);C=c[f>>2]|0;c[18766]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[18766]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[9387]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[18766]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[18766]=G+1}a[75160]=1;c[18768]=0;a[75176]=1;c[C>>2]=(c[C>>2]|0)+1;c[18786]=0;ee[B&7](b,d,e,q,75144,n,o)|0;b:do{if((c[18786]|0)<0){K=35}else{while(1){if(a[75160]&1){c[E>>2]=(c[E>>2]|0)+1;a[75160]=0;DB(f,b,d,e,q,75096,k,75120,l,r,s,t,g,75144,v,j,n,o,x)|0;h[9386]=1.0e6;if((c[18786]|0)<0|(c[18780]|0)!=0){K=35;break b}c[18782]=0}H=c[f>>2]|0;c[18766]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[18766]=H+1}EB(f,q,s,t)|0;I=c[f>>2]|0;c[18766]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[9387]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[18766]=I+1}N=+zB(f,q,l,0,0);h[9398]=N;if(N<=+h[v>>3]*100.0*+h[9396]){break}J=c[18768]|0;if((J|0)>0){h[z>>3]=N/+h[9399];h[A>>3]=1.0/+(J|0);O=+fS(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[9386]=P;Q=+h[9398];R=P}else{h[9399]=N;Q=N;R=+h[9386]}if(R*Q<=.33){break}J=c[18768]|0;H=J+1|0;c[18768]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[75160]=1}c[C>>2]=(c[C>>2]|0)+1;c[18786]=0;ee[B&7](b,d,e,q,75144,n,o)|0;if((c[18786]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[18766]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[18766]=H+1}N=+zB(f,q,l,0,0);h[9398]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[18766]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[9387]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[18766]=J+1}}while(0);if(!(a[75176]&1)){break}H=c[f>>2]|0;c[18766]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[18766]=H+1}N=+zB(f,r,l,0,0);h[9392]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[75176]=0}h[b>>3]=+h[9394];G=c[f>>2]|0;c[18766]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[18766]=G+1}if(a[75176]&1){I=(c[18778]|0)+1|0;c[18778]=I;N=.9/(+h[9392]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[9385]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[18780]|0)!=0){I=(c[18782]|0)+1|0;c[18782]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[18786]|0)>-2)){K=53;break}I=(c[18776]|0)+1|0;c[18776]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function BB(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[18812]=o;p=+h[b>>3]- +h[a>>3];h[9404]=p;a=c[f>>2]|0;c[18804]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[18804]=a+1;q=+h[9404]}h[9400]=1.0;h[9401]=0.0;p=q/+h[k>>3];h[9405]=p;c[18806]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[9401]=u*t+s/+h[a>>3];p=t*s;h[9400]=p;h[9405]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[18804]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[9401]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[9400];g=g+1|0}c[18804]=a+1}g=v+1|0;c[18806]=g;if((v|0)>=(o|0)){break}r=+h[9404];s=+h[9400];t=+h[9405];u=+h[9401];v=g}i=l;return 0}function CB(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[9427]=+h[b>>3];c[18832]=0;c[18840]=0;c[18834]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[9439]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[18828]=(c[I>>2]|0)+1;c[18830]=(c[I>>2]|0)+2;c[18826]=(c[I>>2]|0)+ -1;h[9427]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[18844]=$+1;$=c[18828]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[9430]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[18814]=2;if(($|0)>=2){Y=2;while(1){h[9431]=+h[y+(Y+ -2<<3)>>3];U=+h[9430];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[9431];U=+h[9431]+ +h[k>>3];h[9430]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[18814]=$+1}h[y+($+ -1<<3)>>3]=+h[9430]}h[9437]=0.0;h[9435]=0.0;Y=c[I>>2]|0;c[18814]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[9437]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[9435]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[18814]=Y+1;da=ea}h[9438]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[9437]- +h[9435];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[9412]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[9412]=ha>=ca?ha:ca;h[9430]=.6;h[9431]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[9438]){h[D>>3]=100.0}aa=c[18828]|0;ba=c[18844]|0;if((aa|0)>=(ba|0)){c[18816]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[18814]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[18814]=ba+1}ja=ia+1|0;c[18816]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[18814]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[18814]=ia+1}aa=c[18828]|0;c[18816]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[18814]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[18814]=$+1}la=ba+1|0;c[18816]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[9434]=+zB(f,d,l,0,0);a[75520]=1;c[18818]=0;c[T>>2]=(c[T>>2]|0)+1;c[18848]=0;ee[m&7](b,d,e,r,75392,o,p)|0;if((c[18848]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;DB(f,b,d,e,r,A,k,75344,l,s,t,u,g,75392,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[18848]|0)<0|(c[18836]|0)!=0){X=70;break}c[18840]=0}ba=c[f>>2]|0;c[18814]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[18814]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[9430]=ca;aa=c[f>>2]|0;c[18814]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[9430];ia=ia+1|0;la=ka}c[18814]=aa+1}EB(f,r,t,u)|0;la=c[f>>2]|0;c[18814]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[18814]=la+1}U=+zB(f,r,l,0,0);h[9439]=U;if(U<=+h[F>>3]*100.0*+h[9434]){X=63;break a}ia=c[18818]|0;if((ia|0)>0){h[O>>3]=U/+h[9441];h[P>>3]=1.0/+(ia|0);ca=+fS(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[9439];oa=ga}else{h[9441]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[18818]|0;c[18818]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[18848]=0;ee[m&7](b,d,e,r,75392,o,p)|0;if((c[18848]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[18814]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[18814]=ba+1}U=+zB(f,r,l,0,0);h[9439]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[18814]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[18814]=ia+1}}while(0);if((X|0)==70){X=0;a[75520]=0}c[H>>2]=1;if(a[75520]&1){U=+zB(f,s,l,0,0);h[9433]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[9419]=ga;h[9426]=ga*+(ba+1|0);h[9421]=ga;c[18850]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[18814]=1;if((ba|0)>=1){aa=fa(c[18828]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[18814]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+zB(f,r,l,0,0);h[9428]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[9436]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[18814]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[18814]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+zB(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[9436];if((sa>=ca?sa:ca)>+h[9426]){break}ta=+h[9428];ua=Y}else{if(!(ga<=+h[9426]*.5)){break}else{ta=U;ua=ka}}c[18850]=ua+ -1;h[9421]=ta}}while(0);if(!(+h[9412]*+h[9433]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[9427];Y=c[18828]|0;ia=c[18844]|0;if((Y|0)>=(ia|0)){c[18816]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[9430]=ca;ia=c[f>>2]|0;c[18814]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[9430];ja=ja+1|0}c[18814]=ia+1}ja=aa+1|0;c[18816]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[18814]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[18814]=Y+1}if(!(a[75520]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[18836]|0)!=0){aa=(c[18840]|0)+1|0;c[18840]=aa;h[9410]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[18848]|0)>-2)){X=146;break}aa=(c[18832]|0)+1|0;c[18832]=aa;h[9410]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[18834]=(c[18834]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[18834]|0;if((aa|0)<=1){ja=c[18850]|0;c[I>>2]=ja;sa=+(ja+1|0);h[9431]=sa;h[O>>3]=+h[9421]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+fS(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[9410]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[18850];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[18864]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[18850]|0;E=c[18826]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[18828];za=+h[k>>3]*2.0;h[9423]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[18826]|0;Ba=c[18850]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[18828]|0)>=(c[K>>2]|0)|(c[18864]|0)==1){Fa=G;break}G=c[f>>2]|0;c[18814]=1;if((G|0)>=1){E=fa(c[18830]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[18814]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+zB(f,r,l,0,0);h[9429]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[9426];E=xa<=za;if(+h[9436]<=(E?xa:za)){Ea=c[18826]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[9426]*.5){Fa=S;break}}S=c[18828]|0;c[I>>2]=S;h[9421]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[9421]=+h[9428];Fa=Ea}h[9423]=+h[k>>3];ya=+(Fa+1|0);h[9431]=ya;h[O>>3]=+h[9421]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+fS(O,P);h[9410]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[9423];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[9410]=xa;za=+h[k>>3]*xa;h[9423]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[9423]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[18814]=1;if((k|0)<1){break}u=fa(c[18830]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[18814]=k+1}}while(0);Ca=c[f>>2]|0;c[18814]=1;if((Ca|0)>=1){J=fa(c[18828]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[18814]=Ca+1}Ca=c[18828]|0;c[18822]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[18816]=P;s=c[f>>2]|0;c[18814]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[18814]=s+1}P=Ha+1|0;c[18822]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[18848]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[18834]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}BB(b,b,d,e,f,I,q,y)|0;i=N;return 0}function DB(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==5){P=q+4|0;Q=(c[P>>2]|0)+(c[q>>2]|0)|0;R=Q+1|0;c[18910]=R;S=c[b>>2]|0;c[18900]=(Q|0)<(S|0)?R:S;S=c[q>>2]|0;c[18918]=R+S;c[18904]=S+Q;Q=(c[b>>2]|0)/(R|0)|0;c[18914]=Q+1;R=c[x>>2]|0;c[18912]=R+ -1;c[18922]=R+Q;c[s>>2]=0;h[9454]=+V(+(+h[t>>3]));Q=c[18900]|0;c[18886]=1;if((Q|0)<1){T=75;break}R=r;S=1;while(1){U=c[b>>2]|0;W=c[18910]|0;c[18892]=S;X=(W|0)<0;b:do{if(X?(S|0)>=(U|0):(S|0)<=(U|0)){Y=W;Z=S;_=S;while(1){$=(_-Z|0)/(Y|0)|0;c[18888]=$+1;aa=_+ -1|0;ba=e+(aa<<3)|0;h[p+((c[18912]|0)+$<<3)>>3]=+h[ba>>3];ca=f+(aa<<3)|0;h[p+((c[18922]|0)+$<<3)>>3]=+h[ca>>3];da=+h[ba>>3];h[N>>3]=da;if(!(da>=0.0)){ea=-da}else{ea=da}da=+h[l>>3]*+h[ca>>3];if(!(da>=0.0)){ga=-da}else{ga=da}da=ea>=ga?ea:ga;ha=+h[n+(aa<<3)>>3];if(!(ha>=0.0)){ia=-ha}else{ia=ha}h[9451]=+h[9454]*(da>=ia?da:ia);h[N>>3]=+h[l>>3]*+h[ca>>3];da=+hS(75608,N);h[9451]=da;ca=c[18892]|0;aa=ca+ -1|0;ba=e+(aa<<3)|0;ha=+h[ba>>3];ja=da+ha-ha;h[9451]=ja;h[ba>>3]=+h[ba>>3]+ja;ba=f+(aa<<3)|0;h[ba>>3]=+h[j>>3]*+h[9451]+ +h[ba>>3];ba=ca+W|0;c[18892]=ba;if(!(X?(ba|0)>=(U|0):(ba|0)<=(U|0))){break b}Y=c[18910]|0;Z=c[18886]|0;_=ba}}}while(0);ee[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}U=c[b>>2]|0;X=c[18910]|0;W=c[18886]|0;c[18892]=W;_=(X|0)<0;c:do{if(_?(W|0)>=(U|0):(W|0)<=(U|0)){Z=X;Y=W;ba=W;while(1){ca=(ba-Y|0)/(Z|0)|0;c[18888]=ca+1;aa=ba+ -1|0;$=e+(aa<<3)|0;h[$>>3]=+h[p+((c[18912]|0)+ca<<3)>>3];ja=+h[p+((c[18922]|0)+ca<<3)>>3];ca=f+(aa<<3)|0;h[ca>>3]=ja;ha=+h[$>>3];h[N>>3]=ha;if(!(ha>=0.0)){ka=-ha}else{ka=ha}ha=+h[l>>3]*ja;if(!(ha>=0.0)){la=-ha}else{la=ha}ha=ka>=la?ka:la;ja=+h[n+(aa<<3)>>3];if(!(ja>=0.0)){ma=-ja}else{ma=ja}h[9451]=+h[9454]*(ha>=ma?ha:ma);h[N>>3]=+h[l>>3]*+h[ca>>3];ha=+hS(75608,N);h[9451]=ha;ca=c[18892]|0;ja=+h[e+(ca+ -1<<3)>>3];da=ha+ja-ja;h[9451]=da;ja=1.0/da;h[9460]=ja;aa=ca-(c[P>>2]|0)|0;$=(aa|0)>1?aa:1;c[18894]=$;aa=c[b>>2]|0;na=(c[q>>2]|0)+ca|0;oa=(aa|0)<=(na|0)?aa:na;c[18896]=oa;pa=fa(c[18904]|0,ca)|0;qa=pa-(c[q>>2]|0)|0;c[18898]=qa;c[18884]=$;if(($|0)<=(oa|0)){pa=~aa;aa=~na;na=~((pa|0)>(aa|0)?pa:aa);aa=($|0)>(na|0)?$:na;da=ja;na=$;while(1){$=na+ -1|0;h[p+($+qa<<3)>>3]=(+h[o+($<<3)>>3]- +h[g+($<<3)>>3])*da;if((na|0)>=(oa|0)){break}da=+h[9460];na=na+1|0}c[18884]=aa+1}na=ca+X|0;c[18892]=na;oa=c[18886]|0;if(!(_?(na|0)>=(U|0):(na|0)<=(U|0))){ra=oa;break c}Z=c[18910]|0;Y=oa;ba=na}}else{ra=W}}while(0);W=ra+1|0;c[18886]=W;if((ra|0)<(Q|0)){S=W}else{T=75;break a}}i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[18906]=0;h[9454]=+V(+(+h[t>>3]));S=c[b>>2]|0;c[18884]=1;d:do{if((S|0)>=1){Q=r;P=1;while(1){R=P+ -1|0;da=+h[e+(R<<3)>>3];h[N>>3]=da;if(!(da>=0.0)){sa=-da}else{sa=da}W=f+(R<<3)|0;da=+h[l>>3]*+h[W>>3];if(!(da>=0.0)){ta=-da}else{ta=da}da=sa>=ta?sa:ta;ja=+h[n+(R<<3)>>3];if(!(ja>=0.0)){ua=-ja}else{ua=ja}h[9451]=+h[9454]*(da>=ua?da:ua);h[N>>3]=+h[l>>3]*+h[W>>3];da=+hS(75608,N);h[9451]=da;W=(c[18884]|0)+ -1|0;R=e+(W<<3)|0;ja=+h[R>>3];ha=da+ja-ja;h[9451]=ha;h[9458]=+h[R>>3];U=f+(W<<3)|0;h[9462]=+h[U>>3];h[R>>3]=ha+ +h[R>>3];h[U>>3]=+h[j>>3]*+h[9451]+ +h[U>>3];ee[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ha=1.0/+h[9451];h[9460]=ha;U=c[b>>2]|0;c[18890]=1;R=c[18906]|0;if((U|0)>=1){ja=ha;W=1;_=0;while(1){h[p+(_+R<<3)>>3]=(+h[o+(_<<3)>>3]- +h[g+(_<<3)>>3])*ja;if((W|0)>=(U|0)){break}X=W;ja=+h[9460];W=W+1|0;_=X}c[18890]=U+1}c[18906]=R+(c[b>>2]|0);_=c[18884]|0;W=_+ -1|0;h[e+(W<<3)>>3]=+h[9458];h[f+(W<<3)>>3]=+h[9462];P=_+1|0;c[18884]=P;if((_|0)>=(S|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){T=42;break}c[18906]=0;S=c[b>>2]|0;if((c[61168>>2]|0)==0){T=42;break}P=B2(S*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];rz(14,1,75704,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];rz(14,0,75728,E);rz(14,1,75736,D);c[18888]=0;if((c[b>>2]|0)>0){Q=0;do{ja=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;_=C+4|0;h[k>>3]=ja;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];rz(14,0,75744,C);Q=(c[18888]|0)+1|0;c[18888]=Q;}while((Q|0)<(c[b>>2]|0))}ie[c[15416]&255](14);rz(14,1,75800,B);c[18884]=1;if((S|0)>=1){Q=P+1|0;_=c[18906]|0;W=1;do{X=p+(W+ -1+_<<3)|0;h[X>>3]=+h[j>>3]+ +h[X>>3];a[P]=0;a[Q]=0;c[18890]=1;X=_;ba=0;while(1){ja=+h[p+(ba+X<<3)>>3];c[A>>2]=P;Y=A+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];jc(P|0,75784,A|0)|0;Y=c[18890]|0;c[18890]=Y+1;if((Y|0)>=(S|0)){break}X=c[18906]|0;ba=Y}c[z>>2]=P;rz(14,0,75792,z);ba=c[18906]|0;X=c[18884]|0;Y=p+(ba+ -1+X<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];_=ba+(c[b>>2]|0)|0;c[18906]=_;W=X+1|0;c[18884]=W;}while((X|0)<(S|0))}ie[c[15416]&255](14);ie[c[15416]&255](14);C2(P);T=42}else if((O|0)==3){i=y;return 0}else if((O|0)==4){S=c[q>>2]|0;W=q+4|0;_=c[W>>2]|0;Q=c[b>>2]|0;X=fa(_+1+(S<<1)|0,Q)|0;c[18884]=1;if((X|0)>=1){ba=fa(Q,_+(S<<1)+1|0)|0;S=(ba|0)<1;_=1;while(1){h[p+(_+ -1<<3)>>3]=0.0;if((_|0)<(X|0)){_=_+1|0}else{break}}c[18884]=S?2:ba+1|0}ke[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[18918]=(c[W>>2]|0)+1+(c[q>>2]<<1);T=75}else{_=c[b>>2]|0;X=fa(_,_)|0;c[18884]=1;if((X|0)!=0){_=(X|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(X|0)){P=P+1|0}else{break}}c[18884]=_?2:X+1|0}ke[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){T=42;break}c[18906]=0;P=c[b>>2]|0;if((c[61168>>2]|0)==0){T=42;break}W=B2(P*20|0)|0;ba=M;h[k>>3]=+h[d>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];rz(14,1,75704,M);ba=L;h[k>>3]=+h[j>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];rz(14,0,75728,L);rz(14,1,75736,K);c[18888]=0;if((c[b>>2]|0)>0){ba=0;do{ja=+h[e+(ba<<3)>>3];c[J>>2]=ba+1;S=J+4|0;h[k>>3]=ja;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];rz(14,0,75744,J);ba=(c[18888]|0)+1|0;c[18888]=ba;}while((ba|0)<(c[b>>2]|0))}ie[c[15416]&255](14);rz(14,1,75760,I);c[18884]=1;if((P|0)>=1){ba=W+1|0;X=c[18906]|0;_=1;do{S=p+(_+ -1+X<<3)|0;h[S>>3]=+h[j>>3]+ +h[S>>3];a[W]=0;a[ba]=0;c[18890]=1;S=X;Q=0;while(1){ja=+h[p+(Q+S<<3)>>3];c[H>>2]=W;Y=H+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];jc(W|0,75784,H|0)|0;Y=c[18890]|0;c[18890]=Y+1;if((Y|0)>=(P|0)){break}S=c[18906]|0;Q=Y}c[G>>2]=W;rz(14,0,75792,G);Q=c[18906]|0;S=c[18884]|0;Y=p+(Q+ -1+S<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];X=Q+(c[b>>2]|0)|0;c[18906]=X;_=S+1|0;c[18884]=_;}while((S|0)<(P|0))}ie[c[15416]&255](14);ie[c[15416]&255](14);C2(W);T=42}}while(0);if((T|0)==42){LB(p,b,b,q+80|0,m)|0;i=y;return 0}else if((T|0)==75){RB(p,75672,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function EB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[18956]=(c[g>>2]|0)+1+(c[e>>2]<<1);SB(d,75824,a,e,g,e+80|0,b,75832)|0;i=f;return 0}else{PB(d,a,a,e+80|0,b,75832)|0;i=f;return 0}return 0}function FB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[75840]&1)){a[75840]=1;GB(75888,75856,75936,75872,75920,75944,75928,75952)|0;h[9485]=+(c[18972]|0);f=c[18964]|0;h[9481]=+(f|0);if((c[18984]|0)==0){h[9483]=0.0;c[e>>2]=1-f;g=+gS(75880,e)}else{h[9483]=1.0;c[e>>2]=1-f;g=+gS(75880,e)*.5}h[9484]=g;h[9488]=g*+h[9485];h[9487]=+(c[18980]|0);h[9489]=+(c[18982]|0);j=+h[9493];h[9496]=j;k=1.0/+h[9494];if(!(k>=j)){break}h[9496]=k*(g+1.0)}}while(0);if((YB(b,75976,1,1)|0)!=0){g=+h[9484];h[9495]=g;l=g;i=d;return+l}if((YB(b,75984,1,1)|0)!=0){g=+h[9496];h[9495]=g;l=g;i=d;return+l}if((YB(b,75992,1,1)|0)!=0){g=+h[9485];h[9495]=g;l=g;i=d;return+l}if((YB(b,76e3,1,1)|0)!=0){g=+h[9488];h[9495]=g;l=g;i=d;return+l}if((YB(b,76008,1,1)|0)!=0){g=+h[9481];h[9495]=g;l=g;i=d;return+l}if((YB(b,76016,1,1)|0)!=0){g=+h[9483];h[9495]=g;l=g;i=d;return+l}if((YB(b,76024,1,1)|0)!=0){g=+h[9487];h[9495]=g;l=g;i=d;return+l}if((YB(b,76032,1,1)|0)!=0){g=+h[9493];h[9495]=g;l=g;i=d;return+l}if((YB(b,76040,1,1)|0)!=0){g=+h[9489];h[9495]=g;l=g;i=d;return+l}if((YB(b,76048,1,1)|0)==0){l=+h[9495];i=d;return+l}else{g=+h[9494];h[9495]=g;l=g;i=d;return+l}return 0.0}function GB(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[76160]&1){q=76528;r=c[19132]|0;c[b>>2]=r;s=76464;t=c[19116]|0;c[d>>2]=t;u=76504;v=c[19126]|0;c[e>>2]=v;w=76512;x=+h[9564];h[f>>3]=x;y=76544;z=c[19136]|0;c[g>>2]=z;A=76592;B=+h[9574];h[j>>3]=B;C=76552;D=c[19138]|0;c[k>>2]=D;E=76600;F=+h[9575];h[l>>3]=F;i=m;return 0}a[76160]=1;h[9565]=0.0;h[9559]=1.0;h[9560]=2.0;HB(76528,76464,76504,76616)|0;h[9555]=+(c[19132]|0);c[n>>2]=0-(c[19116]|0);G=+gS(76440,n);h[9554]=G;h[9564]=G;H=+h[9560];h[9555]=H/3.0;I=+h[9559];J=I*.5;h[9562]=J;K=-J;h[o>>3]=K;h[9576]=+IB(76440,o);L=76608;h[9573]=+IB(L,L);h[o>>3]=K;h[9555]=+IB(76584,o);K=+IB(76440,76608);h[9555]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[9555]=K;h[9564]=1.0;M=+h[9565];if(K<1.0&K>M){N=K;while(1){h[9564]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+IB(o,p);h[9556]=K;h[o>>3]=-K;h[9556]=+IB(76496,o);K=+IB(76496,76448);h[9555]=K;h[o>>3]=-K;h[9556]=+IB(76496,o);K=+IB(76496,76448);h[9555]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[9564]=G}G=I/+(c[19132]|0);h[9567]=G;h[9571]=I;c[19114]=1;p=1;O=I;do{h[o>>3]=O*G;O=+IB(o,76520);h[9571]=O;p=p+1|0;c[19114]=p;}while((p|0)<4);h[9554]=+IB(76472,76568);JB(76632,76472,76528)|0;h[o>>3]=-+h[9559];JB(76624,o,76528)|0;JB(76576,76432,76528)|0;h[o>>3]=-+h[9554];JB(76560,o,76528)|0;c[19122]=0;p=c[19158]|0;L=c[19156]|0;P=c[19144]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[19140]|0)){if(Q){c[19136]=p;R=0;S=25;break}if((P-p|0)==3){c[19136]=p+ -1+(c[19116]|0);c[19122]=1;R=1;S=25;break}else{c[19136]=(p|0)<=(P|0)?p:P;a[76168]=1;S=26;break}}else{T=Q&(L|0)==(c[19140]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[19136]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[19136]=(p|0)<=(L|0)?p:L;a[76168]=1;S=26;break}}T=c[19140]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[19136]=(V|0)<=(T|0)?V:T;a[76168]=1;S=26;break}if((P-U|0)==3){c[19136]=((p|0)>=(L|0)?p:L)+ -1+(c[19116]|0);R=0;S=25;break}else{c[19136]=U;a[76168]=1;S=26;break}}}while(0);if((S|0)==25){if(a[76168]&1){S=26}else{W=R}}if((S|0)==26){a[76160]=0;eT(76640)|0;vS(76664,76544,4)|0;OS()|0;W=c[19122]|0}if((W|0)==0){X=(c[19154]|0)!=0|0}else{X=1}c[19122]=X;h[9574]=1.0;X=c[19136]|0;W=1-X|0;c[n>>2]=W;c[19114]=1;if((X|0)<=0){O=+h[9567];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+IB(o,76520);h[9574]=I;n=X+1|0;c[19114]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}KB(76528,76464,76544,76488,76552,76600)|0;q=76528;r=c[19132]|0;c[b>>2]=r;s=76464;t=c[19116]|0;c[d>>2]=t;u=76504;v=c[19126]|0;c[e>>2]=v;w=76512;x=+h[9564];h[f>>3]=x;y=76544;z=c[19136]|0;c[g>>2]=z;A=76592;B=+h[9574];h[j>>3]=B;C=76552;D=c[19138]|0;c[k>>2]=D;E=76600;F=+h[9575];h[l>>3]=F;i=m;return 0}function HB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[76056]&1){l=a[76128]&1;m=c[19034]|0;c[b>>2]=m;n=76104;o=c[19026]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=76152;r=c[19038]|0;c[f>>2]=r;i=g;return 0}a[76056]=1;h[9514]=1.0;h[9508]=1.0;h[9510]=1.0;s=1.0;do{s=s*2.0;h[9508]=s;h[9510]=+IB(76064,76112);h[j>>3]=-s;t=+IB(76080,j);h[9510]=t;}while(t==1.0);h[9509]=1.0;t=+IB(76064,76072);h[9510]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[9509]=v;w=+IB(76064,76072);h[9510]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[9515]=.25;h[9518]=x;h[j>>3]=-s;t=+IB(76080,j);h[9510]=t;y=~~(t+.25);c[19034]=y;t=+(y|0);h[9509]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[9511]=+IB(j,k);w=+IB(76088,76064);h[9510]=w;z=w==s;a[76128]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[9511]=+IB(j,k);w=+IB(76088,76064);h[9510]=w;if(z&w==s){a[76128]=0;A=0}else{A=z}h[j>>3]=u;w=+IB(j,76064);h[9512]=w;h[j>>3]=u;z=w==s&+IB(j,76144)>x;c[19038]=z?A&1:0;c[19026]=0;h[9508]=1.0;h[9510]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[19026]=k;s=x*t;h[9508]=s;h[9510]=+IB(76064,76112);h[j>>3]=-s;w=+IB(76080,j);h[9510]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=76104;o=c[19026]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=76152;r=c[19038]|0;c[f>>2]=r;i=g;return 0}function IB(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function JB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[9584]=g;j=1.0/+(c[d>>2]|0);h[9593]=j;h[9592]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+IB(f,76736);h[9586]=k;h[9588]=g;h[9589]=g;h[9590]=g;h[9591]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[9584]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+IB(f,76736);h[9586]=g;h[f>>3]=g*k;k=+IB(f,76736);h[9588]=k;h[9590]=0.0;c[19170]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[9590]=q;c[19170]=b+1;n=q}h[f>>3]=m*j;p=+IB(f,76736);h[9587]=p;h[f>>3]=p/j;r=+IB(f,76736);h[9589]=r;h[9591]=0.0;o=c[d>>2]|0;c[19170]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[9591]=v;c[19170]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function KB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[19194]=1;c[19202]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[19194]=q;r=l+1|0;c[19202]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[19198]=n;u=n}else{c[19198]=m;c[19202]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[19204]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[19202]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[9600]=x;y=w+-1.0;h[9596]=y;h[9595]=0.0;v=c[b>>2]|0;c[19188]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[9596]=B;if(w<1.0){h[9598]=w}C=+IB(76760,76768);h[9595]=C;e=b+1|0;c[19188]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[9598];h[9595]=A;z=A}}while(0);v=c[f>>2]|0;c[19188]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+IB(k,76824);h[9595]=z;f=E+1|0;c[19188]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function LB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[19210]=1;m=1;do{c[19216]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=MB(j,a+(m+b+(fa(m,l)|0)<<3)|0,76872)|0;q=c[19210]|0;r=p+ -1+q|0;c[19212]=r;c[e+(q+ -1<<2)>>2]=r;r=c[19212]|0;q=c[19210]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[9607]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[9607];t=q}u=fa(t,l)|0;h[9607]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;NB(j,76856,a+(t-l+u<<3)|0,76872)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[19216]|0;c[19208]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[19212]|0;x=fa(w,l)|0;h[9607]=+h[a+(x+b+v<<3)>>3];y=c[19210]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[9607];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=76872;OB(k,76856,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[19208]|0;w=A+1|0;c[19208]=w;}while((A|0)<(u|0))}}while(0);q=c[19210]|0;m=q+1|0;c[19210]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function MB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[19308]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[9655]=k;l=(c[d>>2]|0)+1|0;c[19308]=l;m=c[a>>2]|0;c[19306]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[9655]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[19308]=l;a=n+1|0;c[19306]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[9655]=v;c[19306]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[9655]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[19306]=f+1;g=C;i=e;return g|0}function NB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[19292]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[19292]=l;i=f;return 0}l=(g|0)%5|0;c[19294]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[19292]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[19292]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[19292]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[19292]=o;i=f;return 0}function OB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[19278]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[19276]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[19276]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[19276]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[19276]=s;i=j;return 0}}while(0);c[19280]=1;c[19282]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[19280]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[19282]=s;u=s}else{u=1}s=c[a>>2]|0;c[19276]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[19280]=t;u=x+(c[g>>2]|0)|0;c[19282]=u;a=w+1|0;c[19276]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function PB(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[19228]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[19220]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[19222]=o;p=f+(o+ -1<<3)|0;h[9612]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[9612]}c[k>>2]=(c[d>>2]|0)-m;o=76872;OB(k,76896,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[19220]|0;m=o+1|0;c[19220]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[19226]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[19220]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[9612]=-s;c[k>>2]=g;g=76872;OB(k,76896,a+(p-l<<3)|0,g,f,g)|0;g=c[19226]|0;q=g+1|0;c[19226]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[19220]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=76872;s=+QB(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[9612]=s;q=c[19220]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[19220]=n;}while((q|0)<(m|0));t=c[19228]|0}if((t|0)<1){i=j;return 0}c[19226]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[19220]=n;c[k>>2]=(c[d>>2]|0)-n;b=76872;s=+QB(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[19220]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[19222]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[9612]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[9612]}q=c[19226]|0;m=q+1|0;c[19226]=m;}while((q|0)<(t|0));i=j;return 0}function QB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[9652]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[19298]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[19296]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[9652]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[19296]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[19296]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[9652]=t;u=u+5|0;}while((u|0)<=(m|0));c[19296]=u;k=t;i=g;return+k}}while(0);c[19300]=1;c[19302]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[19300]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[19302]=u;y=u}else{y=1}u=c[a>>2]|0;c[19296]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[9652]=t;x=C+(c[d>>2]|0)|0;c[19300]=x;y=B+(c[f>>2]|0)|0;c[19302]=y;a=z+1|0;c[19296]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function RB(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[19238]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[19244]=n;o=c[d>>2]|0;p=c[19238]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[19246]=o;do{if((q|0)>(n|0)){c[19254]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[19242]=s;t=c[e>>2]|0;c[19230]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[19230]=t+1}u=r+1|0;c[19254]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[19254]=o;c[19252]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[19234]=1;t=o;o=1;while(1){c[19256]=o+1;p=t+1|0;c[19254]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[19230]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[19230]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[19248]=s;c[l>>2]=s+1;s=MB(l,a+((c[19238]|0)+b+(fa(o,m)|0)<<3)|0,76872)|0;p=s+ -1|0;c[19236]=p+(c[19238]|0);s=c[19234]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[19236]|0;p=c[19234]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[19238]|0;if((s|0)==(u|0)){y=s}else{h[9620]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[9620];y=u}h[9620]=-1.0/+h[a+(y+b+n<<3)>>3];NB(76992,76960,a+(y-m+n<<3)|0,76872)|0;u=c[19252]|0;z=(c[g+((c[19234]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[19252]=u;A=c[19238]|0;c[19250]=A;z=c[19256]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[19232]=z;B=z;z=A;while(1){A=(c[19236]|0)+ -1|0;c[19236]=A;C=z+ -1|0;c[19250]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[9620]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[9620];F=C}C=76872;OB(76992,76960,a+((c[19238]|0)-m+(fa(c[19234]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[19232]|0;D=C+1|0;c[19232]=D;if((C|0)>=(u|0)){break a}B=D;z=c[19250]|0}}}while(0);n=c[19234]|0;s=n+1|0;c[19234]=s;if((n|0)>=(r|0)){break}t=c[19254]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[19238]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function SB(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[19262]=n;f=c[d>>2]|0;o=f+ -1|0;c[19274]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[19258]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[19272]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[19260]=k;q=j+(k+ -1<<3)|0;h[9632]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[9632]}k=76872;OB(77088,77056,a+((c[19262]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[19258]|0;f=k+1|0;c[19258]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[19266]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[19258]=k;q=c[19262]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[19272]=s;u=q-s|0;c[19268]=u;q=k-s|0;c[19270]=q;h[9632]=-t;s=76872;OB(77088,77056,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[19266]|0;r=s+1|0;c[19266]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[19258]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[19272]=r;s=o-r|0;c[19268]=s;q=n-r|0;c[19270]=q;r=76872;t=+QB(77088,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[9632]=t;r=c[19258]|0;q=j+(r+ -1<<3)|0;o=c[19262]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[19258]=n;}while((r|0)<(f|0));v=o;w=c[19274]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[19266]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[19258]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[19272]=(n|0)<=(b|0)?n:b;b=76872;t=+QB(77088,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[19258]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[19260]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[9632]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[9632]}n=c[19266]|0;b=n+1|0;c[19266]=b;if((n|0)>=(w|0)){break}o=c[19262]|0;v=b}i=l;return 0}function TB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[19286]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[19284]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[19284]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[19284]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[19284]=o;i=g;return 0}}while(0);c[19288]=1;c[19290]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[19288]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[19290]=o;q=o}else{q=1}o=c[a>>2]|0;c[19284]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[19288]=p;q=s+(c[f>>2]|0)|0;c[19290]=q;a=r+1|0;c[19284]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function UB(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+VB(77248);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+WB(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+WB(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+WB(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+WB(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function VB(a){a=a|0;i=i;return+(+h[77256+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function WB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function XB(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+VB(77288);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Je[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+WB(b,e);c[E>>2]=2;Je[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){dC(b,b,f,g,77296,N,77288,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+WB(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=w3(ga|0,0,Z+ -2|0,0)|0;Z=p3(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}cC(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Je[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);UB(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+WB(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Je[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+WB(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+WB(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+WB(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}fC(b,b,s,t,v,w,x,D)|0;eC(b,b,f,g,w,x)|0;W=77288;eC(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Je[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Je[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function YB(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[77320]=1;f=d[b]|0;c[19326]=f;b=d[e]|0;c[19328]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[19326]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[19328]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}function ZB(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[86852>>2]=6;eT(86848)|0;vS(87592,j,4)|0;OS()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[21014]=0;c[21620]=0;c[21608]=0;a[86456]=0;t=c[e>>2]|0;c[20568]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[21014]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[20568]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[20568]=1;if((v|0)>=1){x=1;while(1){h[78744+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[20568]=v+1}c[21612]=2;x=c[e>>2]|0;c[20568]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[20570]=1;if((E|0)<1){F=C}else{G=1;while(1){h[78744+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[20570]=E+1;F=+h[B>>3]}h[78744+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[21612]=G;D=G}G=z+1|0;c[20568]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[21014]|0;y=z+1|0;c[21010]=y;c[20568]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[20570]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[78744+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[20570]=x+1}oe[u&63](e,b,82104+(z+ -1<<3)|0)|0;c[21620]=(c[21620]|0)+1;if((c[j>>2]|0)>=1){c[86876>>2]=6;eT(86872)|0;vS(87592,86480,4)|0;vS(87592,82104+((c[20568]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[20570]=1;if((v|0)>=1){A=1;do{vS(87592,b+(A+ -1<<3)|0,8)|0;B=c[20570]|0;A=B+1|0;c[20570]=A;}while((B|0)<(v|0))}OS()|0}v=c[20568]|0;z=v+1|0;c[20568]=z;}while((v|0)<(y|0))}y=c[21608]|0;b:while(1){c[21608]=y+1;c[21520]=1;c[21516]=1;C=+h[10263];h[10759]=C;h[10761]=C;z=c[21010]|0;c[20568]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[82104+(A+ -1<<3)>>3];do{if(!(C<=K)){c[21520]=A;L=+h[82104+(A+ -1<<3)>>3];h[10759]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[21516]=A;L=+h[82104+(A+ -1<<3)>>3];h[10761]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[20568]=z+1;H=O}A=c[e>>2]|0;c[20568]=1;if((A|0)>=1){v=1;while(1){h[84224+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[20568]=A+1}c[20568]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[20570]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=84224+(Q+ -1<<3)|0;h[B>>3]=+h[78744+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[20570]=x+1;P=v}}while(0);v=P+1|0;c[20568]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[20570]=1;if((z|0)>=1){K=+(c[21014]|0);v=1;while(1){A=84224+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[20570]=z+1}v=c[e>>2]|0;c[20568]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[84224+(B<<3)>>3];h[86504+(B<<3)>>3]=K+(K- +h[78744+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[20568]=v+1}oe[u&63](e,86504,86496)|0;A=(c[21620]|0)+1|0;c[21620]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[86900>>2]=6;eT(86896)|0;vS(87592,86480,4)|0;vS(87592,86496,8)|0;B=c[e>>2]|0;c[20570]=1;if((B|0)>=1){E=1;do{vS(87592,86504+(E+ -1<<3)|0,8)|0;G=c[20570]|0;E=G+1|0;c[20570]=E;}while((G|0)<(B|0))}OS()|0}}while(0);K=+h[10812];c:do{if(!(K>=+h[10761])){z=c[e>>2]|0;c[20568]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[84224+(v<<3)>>3];h[86672+(v<<3)>>3]=I+(+h[86504+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[20568]=z+1}oe[u&63](e,86672,86664)|0;A=(c[21620]|0)+1|0;c[21620]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[86924>>2]=6;eT(86920)|0;vS(87592,86480,4)|0;vS(87592,86664,8)|0;B=c[e>>2]|0;c[20570]=1;if((B|0)>=1){E=1;do{vS(87592,86672+(E+ -1<<3)|0,8)|0;G=c[20570]|0;E=G+1|0;c[20570]=E;}while((G|0)<(B|0))}OS()|0}}while(0);I=+h[10833];if(I>=+h[10761]){R=118;break}v=c[e>>2]|0;c[20568]=1;A=c[21520]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[78744+((z*21|0)+ -22+A<<3)>>3]=+h[86672+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[20568]=v+1}h[82104+(A+ -1<<3)>>3]=I}else{z=c[21010]|0;c[20568]=1;if((z|0)>=1){B=c[21520]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[82104+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[20568]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[10759])){E=c[e>>2]|0;c[20568]=1;z=c[21520]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[78744+((B*21|0)+ -22+z<<3)>>3]=+h[86504+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[20568]=E+1}h[10759]=K;h[82104+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[20568]=1;if((B|0)>=1){A=c[21520]|0;v=1;while(1){x=v+ -1|0;h[86672+(x<<3)>>3]=+h[78744+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[84224+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[20568]=B+1}oe[u&63](e,86672,86664)|0;v=(c[21620]|0)+1|0;c[21620]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[86948>>2]=6;eT(86944)|0;vS(87592,86480,4)|0;vS(87592,86664,8)|0;z=c[e>>2]|0;c[20570]=1;if((z|0)>=1){E=1;do{vS(87592,86672+(E+ -1<<3)|0,8)|0;x=c[20570]|0;E=x+1|0;c[20570]=E;}while((x|0)<(z|0))}OS()|0}}while(0);I=+h[10833];if(!(I>+h[10759])){A=c[e>>2]|0;c[20568]=1;v=c[21520]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[78744+((B*21|0)+ -22+v<<3)>>3]=+h[86672+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[20568]=A+1}h[82104+(v+ -1<<3)>>3]=I;break}B=c[21010]|0;c[20568]=1;if((B|0)<1){break}else{S=1}do{z=c[21516]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[20570]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=78744+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[78744+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[78744+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[20570]=E+1}oe[u&63](e,b,82104+(S+ -1<<3)|0)|0;G=(c[21620]|0)+1|0;c[21620]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[86972>>2]=6;eT(86968)|0;vS(87592,86480,4)|0;vS(87592,82104+((c[20568]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[20570]=1;if((x|0)>=1){G=1;do{vS(87592,b+(G+ -1<<3)|0,8)|0;T=c[20570]|0;G=T+1|0;c[20570]=G;}while((T|0)<(x|0))}OS()|0}}while(0);z=c[20568]|0;S=z+1|0;c[20568]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[20568]=1;v=c[21520]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[78744+((A*21|0)+ -22+v<<3)>>3]=+h[86504+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[20568]=B+1}h[82104+(v+ -1<<3)>>3]=+h[10812]}A=c[21608]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[10762]=0.0;h[10808]=0.0;A=c[21010]|0;c[20568]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[10808]=0.0/K;c[20568]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[82104+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[10808]=I;c[20568]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[82104+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[10762]=$;c[20568]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[10762]=I;do{if(!(I<=+h[k>>3])){if((c[21620]|0)>(c[g>>2]|0)){break}a[86456]=0;c[21608]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[20568]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[20570]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[78744+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[20570]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[20568]=v+1}oe[u&63](e,b,f)|0;B=(c[21620]|0)+1|0;c[21620]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[86996>>2]=6;eT(86992)|0;vS(87592,86480,4)|0;vS(87592,s,8)|0;z=c[e>>2]|0;c[20570]=1;if((z|0)>=1){E=1;do{vS(87592,b+(E+ -1<<3)|0,8)|0;x=c[20570]|0;E=x+1|0;c[20570]=E;}while((x|0)<(z|0))}OS()|0;ba=c[21620]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[87116>>2]=6;eT(87112)|0;OS()|0;c[87140>>2]=6;eT(87136)|0;B=c[e>>2]|0;c[20568]=1;if((B|0)>=1){A=1;do{vS(87592,b+(A+ -1<<3)|0,8)|0;v=c[20568]|0;A=v+1|0;c[20568]=A;}while((v|0)<(B|0))}OS()|0;c[87164>>2]=6;eT(87160)|0;vS(87592,s,8)|0;OS()|0}if(a[86456]&1){I=+h[10808];K=+h[10854]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[86456]=1;da=+h[10808]}h[10854]=da;c[21608]=0;y=0}if((c[j>>2]|0)>=0){c[87188>>2]=6;eT(87184)|0;vS(87592,86480,4)|0;OS()|0;c[87212>>2]=6;eT(87208)|0;y=c[e>>2]|0;c[20568]=1;if((y|0)>=1){B=1;do{vS(87592,b+(B+ -1<<3)|0,8)|0;A=c[20568]|0;B=A+1|0;c[20568]=B;}while((A|0)<(y|0))}OS()|0;c[87236>>2]=6;eT(87232)|0;vS(87592,s,8)|0;OS()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[87260>>2]=6;eT(87256)|0;OS()|0}h[10761]=+h[f>>3];c[21622]=0;y=c[21010]|0;c[20568]=1;if((y|0)>=1){B=1;while(1){A=82104+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[20568]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[20570]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=78744+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[86672+(E+ -1<<3)>>3]=+h[78744+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[20570]=v+1}oe[u&63](e,86672,A)|0;c[21622]=(c[21622]|0)+1;c[21620]=(c[21620]|0)+1;E=c[20568]|0;I=+h[82104+(E+ -1<<3)>>3];if(I>=+h[10761]){B=E;continue}h[10761]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[87284>>2]=6;eT(87280)|0;vS(87592,86480,4)|0;vS(87592,86088,8)|0;E=c[e>>2]|0;c[20570]=1;if((E|0)>=1){z=1;do{vS(87592,86672+(z+ -1<<3)|0,8)|0;G=c[20570]|0;z=G+1|0;c[20570]=z;}while((G|0)<(E|0))}OS()|0;B=c[20568]|0}}B=c[21014]|0;c[20568]=1;do{if((B|0)<1){h[10288]=+h[10263];c[20568]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[20578]=E;z=c[e>>2]|0;c[20570]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[86504+(A+ -1<<3)>>3]=(+h[78744+(v+ -21<<3)>>3]+ +h[78744+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[20570]=z+1}oe[u&63](e,86504,84064+(y+ -1<<3)|0)|0;c[21622]=(c[21622]|0)+1;c[21620]=(c[21620]|0)+1;A=c[20568]|0;y=A+1|0;c[20568]=y;}while((A|0)<(B|0));y=c[21014]|0;I=+h[10263];h[10288]=I;c[20568]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[20578]=A;c[20580]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[20570]=1;E=1;while(1){v=E+1|0;c[20582]=v;G=c[e>>2]|0;c[20572]=1;if((G|0)>=1){x=c[20580]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[86672+(T+ -1<<3)>>3]=(+h[78744+(U+x<<3)>>3]+ +h[78744+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[20572]=G+1}oe[u&63](e,86672,86664)|0;c[21622]=(c[21622]|0)+1;c[21620]=(c[21620]|0)+1;T=c[20568]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[20570]|0;la=U+x|0;c[20574]=la;I=+h[10288];h[84384+(la+ -1<<3)>>3]=(+h[10833]+I- +h[84064+(v<<3)>>3]- +h[84064+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[20570]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[20568]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[21014]|0;c[20574]=0;c[20568]=1;E=(y|0)<1;if(E){c[20568]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=w3(A|0,0,y+ -2|0,0)|0;A=p3(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[84384+(U+ -1<<3)>>3]=(+h[82104+(v<<3)>>3]+ka- +h[84064+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[20578]=v+1;c[20574]=(z|1)+A;c[20568]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=84064+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[82104+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[20578]=T+1;c[20568]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[20574]=0;c[20568]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[20568]=1;if((B|0)>=1){A=1;while(1){h[86104+(A+ -1<<3)>>3]=+h[78744+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[20568]=B+1}c[20568]=1;do{if(ma){c[20568]=1}else{A=1;while(1){z=A+1|0;c[20578]=z;v=c[e>>2]|0;c[20570]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=78744+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[78744+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[20570]=v+1}c[20568]=z;if((A|0)<(na|0)){A=z}else{break}}c[20568]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[20578]=A;y=c[e>>2]|0;c[20570]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[78744+(T+oa<<3)>>3]=+h[78744+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[20570]=y+1}c[20568]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=84384;_B(B,84056,B,86264,86840,q,86424)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[87308>>2]=6;eT(87304)|0;OS()|0}c[q>>2]=2;if((c[21620]|0)>(c[g>>2]|0)){R=312;break}c[87332>>2]=6;eT(87328)|0;OS()|0;B=c[e>>2]|0;c[20568]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[20568]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[87020>>2]=6;eT(87016)|0;vS(87592,g,4)|0;OS()|0;c[87044>>2]=6;eT(87040)|0;vS(87592,86096,8)|0;OS()|0;c[87068>>2]=6;eT(87064)|0;u=c[e>>2]|0;c[20568]=1;if((u|0)>=1){E=1;do{vS(87592,b+(E+ -1<<3)|0,8)|0;z=c[20568]|0;E=z+1|0;c[20568]=E;}while((z|0)<(u|0))}OS()|0;c[87092>>2]=6;eT(87088)|0;vS(87592,s,8)|0;OS()|0;i=r;return 0}else if((R|0)==226){u=c[21014]|0;c[21618]=u-(c[21710]|0);c[20568]=1;E=(u|0)<1;do{if(E){h[10805]=0.0;c[20568]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[82104+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=82104+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[84384+(sa+ -1<<3)>>3]*+h[84064+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[20574]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[20570]=z;h[10805]=0.0;c[20568]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[82104+(v<<3)>>3]*+h[84064+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[10805]=wa;c[20568]=u+1;qa=wa}}while(0);h[10805]=+h[10288]-qa;s=c[e>>2]|0;c[20568]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[86672+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=86672+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[82104+(T+ -1<<3)>>3]*+h[78744+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[20568]=s+1;c[20570]=xa}v=c[e>>2]|0;c[20568]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=86104+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[86672+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[20568]=v+1}if((c[j>>2]|0)>=0){c[87356>>2]=6;eT(87352)|0;vS(87592,86440,8)|0;z=c[e>>2]|0;c[20568]=1;if((z|0)>=1){s=1;do{vS(87592,86104+(s+ -1<<3)|0,8)|0;u=c[20568]|0;s=u+1|0;c[20568]=s;}while((u|0)<(z|0))}OS()|0;c[87380>>2]=6;eT(87376)|0;OS()|0}z=c[e>>2]|0;c[20568]=1;if((z|0)>=1){s=c[21014]|0;v=1;while(1){c[20570]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[82104+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=82104+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[84384+(Aa+ -1<<3)>>3]*+h[78744+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[20574]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[20572]=E;c[20570]=s+1}T=c[e>>2]|0;c[20570]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=82360+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[82104+(Ea+ -1<<3)>>3]*+h[78744+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[20570]=T+1;c[20574]=Ca;c[20572]=Da}za=v+1|0;c[20568]=za;if((v|0)<(z|0)){v=za}else{break}}}c[20570]=0;v=c[e>>2]|0;c[20568]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[82360+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[20570]=Ga;c[20568]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[87404>>2]=6;eT(87400)|0;vS(87592,86472,4)|0;OS()|0;c[21012]=1;z=1;d:while(1){c[20574]=z;do{if((z|0)>(c[e>>2]|0)){s=c[21012]|0;if((s|0)==1){c[87428>>2]=6;eT(87424)|0;OS()|0;_B(82360,84056,84384,86264,86840,q,86424)|0;c[87452>>2]=6;eT(87448)|0;OS()|0;c[21012]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[21012]=2;c[20584]=0;c[20586]=0;s=c[e>>2]|0;c[20568]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=w3(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=p3(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=82360+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=82360+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[82360+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[20588]=Na;c[20586]=Ta;c[20584]=Ia;c[20570]=Ma;c[20568]=s+1}c[87476>>2]=6;eT(87472)|0;OS()|0;c[20584]=0;u=c[e>>2]|0;c[20568]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=82360+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[20584]=Wa;c[20568]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[20584]=T;s=c[e>>2]|0;c[20568]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[20578]=B;Qa=za+la|0;c[20584]=Qa;Pa=B+5|0;c[20580]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[21012]|0)==3){c[87548>>2]=6;eT(87544)|0;Pa=c[20580]|0;Qa=c[20578]|0;c[20570]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{vS(87592,84384+(B+ -1<<3)|0,8)|0;Qa=c[20570]|0;B=Qa+1|0;c[20570]=B;}while((Qa|0)<(Pa|0))}OS()|0}else{c[87524>>2]=6;eT(87520)|0;Pa=c[20580]|0;B=c[20578]|0;c[20570]=B;if((B|0)<=(Pa|0)){x=B;do{vS(87592,82360+(x+ -1<<3)|0,8)|0;B=c[20570]|0;x=B+1|0;c[20570]=x;}while((B|0)<(Pa|0))}OS()|0}Pa=c[20568]|0;x=Pa+1|0;c[20568]=x;if((Pa|0)>=(s|0)){break e}E=c[20574]|0;la=c[20584]|0;za=x}}}while(0);c[87572>>2]=6;eT(87568)|0;OS()|0;z=(c[20574]|0)+6|0}c[87500>>2]=6;eT(87496)|0;vS(87592,86488,4)|0;OS()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);oe[p&63](e,b,f)|0;i=r;return 0}function _B(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[21918]=c[b>>2];c[g>>2]=1;if((c[21918]|0)<1){i=k;return 0}c[g>>2]=0;$B(a,87672,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[21918]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[21910]=f;c[21916]=g;c[21922]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=w3(a|0,0,g+ -2|0,0)|0;m=p3(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[21902]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=w3(p|0,0,a-n|0,0)|0;p=p3(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[21902]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[21900]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[21900]=j}c[21912]=g;c[21914]=f;c[21920]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[10954]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[10954]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[10954]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[21920]=D;E=v+ -1|0;c[21912]=E;F=w+ -1|0;c[21914]=F;q=D;v=E;w=F}c[21904]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[21906]=t;c[21916]=0;c[21922]=l-g;i=k;return 0}function $B(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[10968]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[10968]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[10968];c[21926]=1;c[21928]=0;n=c[b>>2]|0;c[21940]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[21930]=0;c[21942]=1;do{if((o|0)>=1){p=1;q=c[21928]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[10967]=m;u=(p|0)==(o|0);if(u){l=m*+h[10968];h[10969]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[10967]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[10969]=+h[10969]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[21930]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[21930]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[10967];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[21942]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[21924]=y;c[21932]=x;c[21928]=s;break}else if((D|0)==26){D=0;c[21924]=y;c[21932]=x;c[21928]=s;break}}}while(0);m=+V(+(+h[10969]));h[10969]=m;H=+h[10967];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[21928]|0)+ -1<<3)>>3]=G;G=+h[10969]/+h[10967];h[j+((c[21924]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[21928]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[21926]|0;O=c[21940]|0}}while(0);b=N+O|0;c[21926]=b;o=O+1|0;c[21940]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[21924]=y;c[21932]=x;c[21928]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function aC(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[21966]=n;o=(c[d>>2]|0)-n|0;c[21988]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[21986]=s;a[87888]=1;t=c[b>>2]|0;u=t+1|0;c[21982]=u;v=c[b>>2]|0;w=u+v|0;c[21980]=w;u=w+(c[b>>2]|0)|0;c[21984]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[21974]=w;x=w+(c[d>>2]|0)|0;c[21968]=x;y=x+(c[b>>2]|0)|0;c[21970]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[21976]=z;A=z+(c[d>>2]|0)|0;c[21990]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[21992]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[21964]=C;D=C+(c[b>>2]|0)|0;c[21978]=D;bC(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,87944,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);eT(87976)|0;OS()|0;i=m;return 0}



function bC(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[11082]=.5;h[11073]=1.0;h[11113]=.1;F=(c[a>>2]|0)+1|0;c[22142]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[22134]=H;I=(c[b>>2]|0)-F|0;c[22188]=I;F=c[j>>2]|0;c[22242]=(F|0)<1?1:F;F=c[a>>2]|0;c[22126]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[22128]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[22128]=J+1}L=c[u>>2]|0;c[22124]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[22124]=L+1}K=j+1|0;c[22126]=K;if((j|0)<(F|0)){j=K}else{break}}}c[22130]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[22130]=H+1}H=c[b>>2]|0;c[22128]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[22126]=M;c[22128]=H+1}N=+h[e>>3];O=N*N;h[11118]=O;h[11104]=+h[11073]/O;h[11105]=+V(+(+h[11082]))/O;c[22132]=0;H=y;y=A;M=0;a:while(1){c[22144]=M;F=M-(c[a>>2]|0)|0;c[22168]=F;j=M+1|0;c[22132]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[22218]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[22156]=L;K=L+G|0;c[22154]=K;if((K|0)>(c[a>>2]|0)){c[22218]=L;G=K-(c[a>>2]|0)|0;c[22156]=G;c[22154]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[11095]=O;L=c[22142]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[11095]=N;R=N}else{R=O}O=+h[e>>3];h[11096]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[11096]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[11096];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[22126]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[22126]=S+1}if((M|0)>=(c[22242]|0)){T=j;U=159;break}while(1){oe[H&63](a,d,88488)|0;if((c[g>>2]|0)==3){eT(89016)|0;vS(89184,88528,4)|0;vS(89184,88488,8)|0;I=c[a>>2]|0;c[22124]=1;if((I|0)>=1){F=1;do{vS(89184,d+(F+ -1<<3)|0,8)|0;L=c[22124]|0;F=L+1|0;c[22124]=F;}while((L|0)<(I|0))}OS()|0}I=c[22132]|0;do{if((I|0)>(c[b>>2]|0)){F=c[22172]|0;if((F|0)==-1){break a}h[11114]=0.0;c[22130]=0;L=c[a>>2]|0;c[22126]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[11114]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[11087]=N;if((X|0)==(G|0)){ea=N*+h[11082];h[11087]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[11114]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[22130]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[22124]=Y;c[22126]=L+1;W=Z}J=c[b>>2]|0;c[22128]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[11114]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[22128]=J+1;ia=ja}O=+h[11061];ba=+h[11090];N=O-ba-ia;h[11081]=N;h[11100]=+h[11099];h[11099]=+h[11098];if(!(N>=0.0)){ka=-N}else{ka=N}h[11098]=ka;if(+h[11110]>+h[11076]){c[22216]=I}h[11106]=ba;do{if(O<ba){h[11090]=O;h[11123]=0.0;G=c[a>>2]|0;c[22124]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[11123]=+h[11123]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[22124]=G+1;h[A>>3]=ma}}while(0);c[22214]=F;if((F|0)<=0){O=+h[11114];if(O>=0.0){U=190;break a}ba=+h[11061];N=+h[11106];ea=(ba-N)/O;h[11111]=ea;O=+h[11113];do{if(!(ea<=O)){na=+h[11082]*+h[11103];h[A>>3]=na;oa=+h[11110];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[11103]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[11103]=qa;ra=qa;break}}else{qa=+h[11082]*+h[11110];h[11103]=qa;ra=qa}}while(0);ea=+h[11076];if(!(ra<=ea*1.5)){sa=ra}else{h[11103]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[11118]=ea;c[22230]=0;h[11119]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[22186]|0;c[22230]=J;oa=+h[11073];h[11119]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[22128]=1;if((J|0)<1){va=F}else{L=c[22188]|0;oa=ua;K=1;ca=F;while(1){h[11101]=0.0;c[22126]=1;if((L|0)<1){wa=0.0}else{X=c[22148]|0;aa=K+C|0;qa=+h[11073];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[11087]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[11101]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[22126]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[11083]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[11087]=za;h[11122]=0.0;$=c[a>>2]|0;c[22126]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[11122]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[22126]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[11087]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[11119]=Fa;c[22172]=K;Ga=Fa;Ha=K}aa=K+1|0;c[22128]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}hC(a,b,s,t,88592,u,w,88664,88688,x)|0;ca=c[22172]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[11061];c[22130]=0;J=c[a>>2]|0;c[22124]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[11087]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[11087];G=G+1|0;da=da+1|0}da=X+aa|0;c[22130]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[22126]=La;c[22124]=J+1}h[L>>3]=0.0;X=c[22188]|0;c[22126]=1;aa=(X|0)<1;if(!aa){F=c[22148]|0;K=1;while(1){da=fa(K,B)|0;O=+h[11081]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[11087]=Oa;G=c[b>>2]|0;c[22128]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[11087];$=$+1|0}c[22128]=G+1}$=K+1|0;c[22126]=$;if((K|0)<(X|0)){K=$}else{break}}}h[11092]=0.0;K=c[a>>2]|0;c[22124]=1;if((K|0)>=1){F=1;while(1){O=+h[11081]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[11092]=+h[11092]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[22124]=K+1;h[A>>3]=Pa}F=c[22214]|0;do{if((F|0)==0){if(!(+h[11103]==+h[11076])){break}O=+h[11111];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[22234]=0;break}L=c[b>>2]|0;c[22128]=1;if((L|0)>=1){J=o+((c[22186]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[22128]=L+1}h[11085]=0.0;$=c[a>>2]|0;c[22124]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[11079]=0.0;G=c[b>>2]|0;c[22128]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[11079]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[22128]=G+1;Sa=Ta}h[11085]=+h[11085]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[22124]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[11085]*100.0}J=c[22234]|0;c[22234]=J+1;if(+h[11092]<Ra){c[22234]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[22124]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[22124]=J+1}$=c[22134]|0;c[22130]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[22130]=$+1}c[22126]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[22128]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[22128]=Na+1;Ua=Wa}if((L|0)<(c[22148]|0)){h[J>>3]=-Ua}Va=L+1|0;c[22126]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[22128]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[22126]=Xa;c[22128]=L+1}c[22234]=0}}while(0);O=+h[11061];ea=+h[11106];if(O<ea){c[22186]=ca}oa=+h[11113];if(O<=ea+oa*+h[11114]|(F|0)>0){U=54;break}c[22172]=0;Ia=0;Ja=+h[11103];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[11061];oa=+h[11061];do{if((I|0)==1){h[11080]=oa;h[11090]=oa;c[22186]=1;Ya=1}else{if(!(oa<+h[11090])){Ya=I;break}h[11090]=oa;c[22186]=I;Ya=I}}while(0);F=c[22144]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[22154]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[22156]|0;Va=K+aa|0;c[22130]=Va;if(+h[11095]<0.0){aa=X+(c[a>>2]|0)|0;c[22154]=aa;Za=aa}else{Za=X}if(+h[11096]<0.0){X=K+(c[a>>2]|0)|0;c[22156]=X;_a=X}else{_a=K}K=fa(c[22168]|0,B)|0;h[t+(K-B<<3)>>3]=+h[11104];h[t+(Ya+C+K<<3)>>3]=+h[11104];h[t+(Za-B+K<<3)>>3]=-+h[11104];h[t+(_a-B+K<<3)>>3]=-+h[11104];h[q+(Va+ -1<<3)>>3]=(+h[11080]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[11061])/(+h[11095]*+h[11096])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[22168]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[11082]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[11082]/+h[e>>3];ea=+h[11105];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[11105];h[t+(X+K<<3)>>3]=+h[11105];K=(fa(Va+1|0,Va)|0)/2|0;c[22130]=K;ea=(+h[11080]- +h[11061])/+h[e>>3];h[11087]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[11082]*(+h[X>>3]+ +h[11087]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[11080])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[11073]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[11073]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[11082]*+h[11118]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[11076]=oa;h[11103]=oa;c[22148]=1;h[11098]=0.0;h[11099]=0.0;c[22234]=0;h[11123]=0.0;F=c[a>>2]|0;c[22124]=1;if((F|0)<1){U=53;break}ca=c[22186]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[11123]=+h[11123]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[22124]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[22216]=c[22132];U=54;continue}else if((U|0)==54){U=0;c[22172]=0;I=(c[22142]|0)+ -1|0;K=c[a>>2]|0;gC(a,b,l,n,p,q,r,88824,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,88960)|0;h[11075]=0.0;K=c[a>>2]|0;c[22124]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[11075]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[22124]=K+1;ab=cb}oa=+h[11103];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[11110]=O;ea=+h[11076];if(!(O<+h[11082]*ea)){db=ab;U=62;break}c[22172]=-1;O=+h[11113];N=O*oa;h[11103]=N;h[11111]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[11103]=ea;eb=ea}if((c[22132]|0)<=((c[22216]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[11120]*.125*ea;h[11087]=N;oa=+h[11098];ba=+h[11099];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[11100];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[11122]=O;I=c[b>>2]|0;c[22128]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[11079]=0.0;X=c[a>>2]|0;c[22126]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[11079]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[22126]=X+1;jb=lb}if(jb>ea){c[22172]=F;h[11122]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[22128]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[11111]>0.0){U=54;continue}ea=+h[11110];O=+h[11076];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[11082];h[11103]=O;ea=hb/+h[f>>3];h[11111]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[11076]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[11076]=na;ob=na;break}}else{na=+h[f>>3];h[11076]=na;ob=na}}while(0);h[11103]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){eT(89064)|0;OS()|0}eT(89088)|0;vS(89184,88608,8)|0;vS(89184,88528,4)|0;OS()|0;eT(89112)|0;vS(89184,88720,8)|0;ca=c[a>>2]|0;c[22124]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];vS(89184,y,8)|0;I=c[22124]|0;F=I+1|0;c[22124]=F;}while((I|0)<(ca|0))}OS()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[11082]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[11076];O=na>=ea?na:ea;h[11112]=O;ea=O*O;h[11075]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[11123];if(db<=ea*.001){h[11116]=ea*.25;ca=c[b>>2]|0;c[22128]=1;if((ca|0)>=1){F=1;while(1){h[11079]=0.0;I=c[a>>2]|0;c[22124]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[11079]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[22124]=I+1;pb=qb}h[11087]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[11082]*+h[11123];h[11079]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[22124]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[11087]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[11082]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[11079]*+h[n+(F+C+Va<<3)>>3]+ +h[11116]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[22136]=aa;c[22126]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[22126]=Va;rb=Va}c[22124]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[22128]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[22188]|0;c[22128]=1;if((F|0)>=1){ca=1;while(1){h[11097]=0.0;X=c[b>>2]|0;c[22124]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[11097]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[22124]=I;if((K|0)>=(X|0)){break b}O=+h[11097];K=I}}}while(0);X=c[a>>2]|0;c[22126]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[11116]*+h[11097]*+h[l+(I<<3)>>3];h[11079]=O;Va=c[b>>2]|0;c[22124]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[11079]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[22124]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[22148]|0)){h[11079]=-+h[11079]}L=c[b>>2]|0;c[22124]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[11079]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[22124]=L+1}J=K+1|0;c[22126]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[22124]=1;if((K|0)>=1){X=c[22148]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[22136]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[11087]=ub;c[22126]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[11087];aa=aa+1|0}aa=J+1|0;c[22126]=aa;vb=aa}c[22124]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[22128]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[22130]=0;ca=c[a>>2]|0;c[22126]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[22128]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[11082]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[22128]=aa+1}c[22124]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[22130]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[22124]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[22126]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[22126]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[22126]=J+1}h[11123]=0.0}if((c[22172]|0)>0){F=(c[22142]|0)+ -1|0;tB(a,b,l,n,s,t,88592,u,88688,88896,v,88816,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[22128]=1;if((F|0)>=1){L=1;while(1){h[11088]=0.0;h[11089]=0.0;h[11079]=0.0;ca=c[a>>2]|0;c[22126]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[11088]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[11089]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[11079]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[22126]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[11082]+Ab);h[w+(K<<3)>>3]=+h[11079];K=L+1|0;c[22128]=K;if((L|0)<(F|0)){L=K}else{break}}}h[11083]=0.0;L=c[22188]|0;c[22128]=1;if((L|0)>=1){F=1;while(1){h[11079]=0.0;J=c[b>>2]|0;c[22124]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[11079]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[22124]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[11083];if((F|0)<(c[22148]|0)){h[11083]=O+ea;na=-Eb;h[11079]=na;Gb=na}else{h[11083]=O-ea;Gb=Eb}K=c[b>>2]|0;c[22124]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[11079];X=X+1|0}c[22124]=K+1}X=F+1|0;c[22128]=X;if((F|0)<(L|0)){F=X}else{break}}}h[11091]=0.0;h[11070]=0.0;F=c[a>>2]|0;c[22126]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[11079]=0.0;X=c[b>>2]|0;c[22124]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[11079]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[22124]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[11091]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[22138]=K;Va=c[a>>2]|0;c[22128]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[11079]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[22128]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[11091]+ +h[11079]*+h[ca>>3];h[11091]=O;na=+h[11070]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[11070]=na;aa=L+1|0;c[22126]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[11075];h[11083]=+h[11083]+(Ib*Ib+ea*(Ib+(Ib+ +h[11123])+ea*+h[11082]))-Hb;L=w+((c[22186]|0)+ -1<<3)|0;h[L>>3]=+h[11073]+ +h[L>>3];L=c[22172]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[11073]+ +h[11102]*+h[11083]/(ea*ea);h[11087]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;sB(a,b,l,n,s,t,88592,u,88744,88688,v,x,w,88664,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[22124]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[22124]=L+1}F=c[22132]|0;aa=F+1|0;c[22132]=aa;if((F|0)>=(c[22242]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[22132]=T+ -1;if((c[g>>2]|0)<=0){break}eT(88992)|0;OS()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}eT(89040)|0;OS()|0}}while(0);Nb=+h[11090];if(Nb<=+h[11061]){U=c[a>>2]|0;c[22124]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[22124]=U+1;Ob=+h[11090]}h[11061]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}eT(89136)|0;vS(89184,88528,4)|0;OS()|0;eT(89160)|0;vS(89184,88488,8)|0;g=c[a>>2]|0;c[22124]=1;if((g|0)>=1){a=1;do{vS(89184,d+(a+ -1<<3)|0,8)|0;U=c[22124]|0;a=U+1|0;c[22124]=a;}while((U|0)<(g|0))}OS()|0;i=z;return 0}function cC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){h3(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){h3(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function dC(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+VB(89192);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+WB(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+WB(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+WB(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function eC(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function fC(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+VB(89200);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=w3(u|0,0,t+ -2|0,0)|0;t=p3(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function gC(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[11170]=.5;h[11188]=6.283185307179586;v=+h[l>>3];h[11183]=v*v;c[22362]=0;l=c[b>>2]|0;c[22380]=l;c[22378]=l;w=c[b>>2]|0;c[22302]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[22302]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[22302]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[22302]=w+1}z=c[d>>2]|0;c[22306]=1;if((z|0)>=1){e=1;while(1){h[11174]=0.0;A=c[b>>2]|0;c[22304]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[11174]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[22304]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[11174]=v;C=c[b>>2]|0;c[22302]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[11174];F=F+1|0}c[22302]=C+1}F=e+1|0;c[22306]=F;if((e|0)<(z|0)){e=F}else{break}}}c[22316]=0;e=c[b>>2]|0;c[22304]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[22316]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[22302]=H;c[22304]=e+1}do{if((y|0)==0){h[11172]=0.0;h[11154]=0.0;w=c[b>>2]|0;c[22302]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[11154]=+h[11154]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[22302]=w+1}h[r>>3]=0.0;D=+h[11154];if(D==0.0){O=55;break a}h[11159]=0.0;h[11162]=0.0;h[11157]=D;h[11177]=D;P=D;Q=0.0;R=0.0;S=+h[11183];T=0}else{if((y|0)>(x|0)){h[11156]=0.0;h[11163]=0.0;h[11164]=0.0;z=c[b>>2]|0;c[22302]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[11156]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[11163]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[11164]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[22302]=z+1;U=ba;W=$;Z=aa}D=+h[11170];v=D*(+h[11167]-Z);h[11155]=v;_=+h[11160];ca=_+v;h[11171]=ca;h[11175]=ca;h[11173]=ca;c[22372]=0;a[89288]=1;da=+h[11188]/50.0;h[11174]=da;c[22302]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[11173]=ka;c[22372]=w;h[11184]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[11185]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[11179]=ha;h[11165]=ia;h[11168]=ja;h[11176]=ka;c[22302]=50;h[11175]=ka;if((la|0)==0){h[11184]=ka;O=46}else if((la|0)==49){h[11185]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[11185]}h[11179]=0.0;ga=+h[11184];if(ga!=na){ea=ga-ma;h[11184]=ea;ga=na-ma;h[11185]=ga;oa=D*(ea-ga)/(ea+ga);h[11179]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[11179]=oa;ga=+X(+oa);h[11165]=ga;ea=+Y(+oa);h[11168]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[11180]=oa;h[11157]=0.0;w=c[b>>2]|0;c[22302]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[11165]*+h[J>>3]+ +h[11168]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[11157]+sa*sa;h[11157]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[11168];ea=+h[11165];F=F+1|0;z=K}c[22302]=w+1;qa=ta;ra=+h[11180]}ea=ra+ +h[11172];h[11172]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[11163]=0.0;z=c[b>>2]|0;c[22304]=1;do{if((z|0)<1){ea=+h[11187];h[11178]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[11163]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[22304]=z+1;ea=+h[11187];h[11178]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[11154];h[11174]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[11174]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[11178];oa=+h[11157];v=+h[11163];_=oa/v;ca=ea<=_?ea:_;h[11178]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[11157];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[11170]*Ca);h[11169]=ca;h[11172]=+h[11172]+ca;h[11182]=Ba;h[11157]=0.0;z=c[b>>2]|0;c[22302]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[11178]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[11157]+oa*oa;h[11157]=Ga;Ha=+h[11178];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[22302]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[11187]){if(+h[11169]<=+h[11172]*.01){O=55;break a}if(Fa<=+h[11177]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[11182];h[11174]=ca;h[11154]=0.0;h[11159]=0.0;h[11162]=0.0;w=c[b>>2]|0;c[22302]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[11154]+ca*ca;h[11154]=La;J=m+(F<<3)|0;Ma=+h[11159]+ +h[K>>3]*+h[J>>3];h[11159]=Ma;ca=+h[J>>3];Na=+h[11162]+ca*ca;h[11162]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[11174];Ja=Ja+1|0;Ka=J}c[22302]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[11183];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[22378]=y;ua=+h[11157];va=y}if(ua<=+h[11177]*1.0e-4){O=55;break a}h[11160]=0.0;h[11167]=0.0;z=c[b>>2]|0;c[22302]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[11160]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[11167]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[22302]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[11166]=ca;oa=+h[11183];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[22362]=J;_=+V(+(v-ca*ca));h[11174]=_;v=oa/_;h[11184]=v;oa=ca/_;h[11185]=oa;w=c[b>>2]|0;c[22302]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[11185];Ta=+h[11184];Ua=Ua+1|0;Va=K}c[22302]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[22362]=e;v=S-R;h[11174]=v;h[11187]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function hC(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[11197]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[22400]=t;c[22390]=1;c[22384]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[22390]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[11199]=D;C=+h[x>>3]/D;h[11206]=C;z=+h[f+(B+y<<3)>>3]/D;h[11207]=z;B=c[d>>2]|0;c[22382]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[11199]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[11199];if((x|0)>=(B|0)){break}D=+h[11207];z=+h[11206];x=x+1|0}c[22382]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[22384]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[11206]=z;if((c[g>>2]|0)>1){D=-z;h[11206]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[11207]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[22382]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[11207]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[11206];t=t+1|0;x=A}c[22382]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[11204]=z;x=k+(w<<3)|0;H=+h[x>>3];h[11198]=H;D=H*H;h[11208]=D;h[11205]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[11197];a[89608]=0;do{if((u|0)==1){z=+h[11205];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[11199]=z;D=+h[11206]/z;h[11207]=D;H=+h[11198]/z;h[11206]=H;x=c[d>>2]|0;c[22382]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[11207];D=+h[11206];w=w+1|0;t=s}c[22382]=x+1;J=+h[11199]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[22386]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[22386]=u;M=u}t=u+1-M|0;c[22388]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[11205];z=+h[f+(t+w<<3)>>3]/D;h[11199]=z;h[11206]=z*+h[l>>3];H=+h[11198];h[11207]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[11199]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[11197]/+V(+(+h[11208]+z*N*z));h[11202]=C;if(!(D>=0.0)){O=-D}else{O=D}h[11203]=C*+V(+O);t=c[d>>2]|0;c[22382]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[11203]*(+h[A>>3]- +h[11206]*+h[n+(G<<3)>>3]- +h[11207]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[11199];z=+h[11198];H=+h[11202];v=v+1|0}c[22382]=t+1;P=+h[11205]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[89608]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[22382]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[11199]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[11199];K=Q+1|0;c[22382]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[22384]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[22392]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[11198];N=+h[11205];J=(+h[11204]*+h[f>>3]-O*P)/N;h[11206]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[11207]=P;c[22382]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[22382]=q;if((f|0)>=(b|0)){break a}N=+h[11207];O=+h[11206];f=q}}}while(0);b=R+1|0;c[22384]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function iC(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function jC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((iC(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){db(89672,89688,116,89712)}else if((s|0)==14){i=g;return o|0}return 0}function kC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if(($2(w,c[89720+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[89824+(x<<2)>>2]|0;c[q>>2]=c[89720+(x<<2)>>2];c[q+4>>2]=y;rz(23,0,89896,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=D2(D,8)|0;c[e+40>>2]=B;D=b+536|0;uz(c[D>>2]|0,(B|0)!=0|0,89936,p);B=D2(c[A>>2]|0,4)|0;c[e+36>>2]=B;uz(c[D>>2]|0,(B|0)!=0|0,89936,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=D2(c[C>>2]|0,4)|0;c[e+24>>2]=B2(8)|0;C=B2(4)|0;c[e+20>>2]=C;c[C>>2]=c[61168>>2];uz(c[D>>2]|0,(C|0)!=0|0,89936,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=B2(C)|0;A=e+44|0;c[A>>2]=B2(C)|0;C=D2(15,4)|0;E=e+12|0;c[E>>2]=C;uz(c[D>>2]|0,(C|0)!=0|0,89936,m);C=D2(5,4)|0;c[e+4>>2]=C;uz(c[D>>2]|0,(C|0)!=0|0,89936,l);C=D2(5,4)|0;c[e+8>>2]=C;uz(c[D>>2]|0,(C|0)!=0|0,89936,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=B2(C)|0;c[e+76>>2]=B2(C)|0;c[e+80>>2]=B2(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((le[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){rz(23,0,89952,j)}else{rz(1,0,90024,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[61204>>2]|c[15276]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=89856;W=V;vz(Q,W,r)}c[t>>2]=w;tz(23,1,89752,t);t=1;do{w=c[89824+(t<<2)>>2]|0;c[s>>2]=c[89720+(t<<2)>>2];c[s+4>>2]=w;tz(23,0,89808,s);t=t+1|0;}while((t|0)<8);ie[c[15416]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=6;U=T;V=89856;W=V;vz(Q,W,r);return 0}function lC(a){a=a|0;var b=0;b=i;C2(c[a+40>>2]|0);C2(c[a+36>>2]|0);C2(c[a+20>>2]|0);C2(c[a+12>>2]|0);C2(c[a+4>>2]|0);C2(c[a+8>>2]|0);C2(a);i=b;return 0}function mC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;uz(c[N>>2]|0,(c[M>>2]|0)!=0|0,90120,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){rz(3,0,90152,B);rz(3,0,90192,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];le[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rz(3,0,90216,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];rz(23,0,90256,y);if((c[z>>2]|0)==1){TA(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){oE(a)|0;le[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 7:{vB(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 6:{vB(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 3:{vB(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 5:{vB(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 4:{vB(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){vB(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{vB(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){xd(_|0)|0;xd($|0)|0;tz(3,0,90288,x);rz(3,0,90376,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){xd(_|0)|0;xd($|0)|0;$=vC(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){oE(a)|0;le[c[(c[ba>>2]|0)+40>>2]&127](a)|0}le[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];tz(1,0,90400,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[61124>>2]|0)!=0){rz(3,1,90432,u);c[s>>2]=c[z>>2];rz(3,0,90456,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];rz(3,0,90480,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];rz(3,0,90512,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rz(3,0,90552,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];rz(3,0,90600,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];rz(3,0,90648,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];rz(3,0,90688,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];rz(3,0,90728,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];rz(3,0,90768,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];rz(3,0,90816,f);ie[c[15416]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){db(90856,90888,410,90920)}rz(3,0,90936,e);S=0;i=d;return S|0}function nC(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;oE(g)|0;a=f+540|0;le[c[(c[a>>2]|0)+40>>2]&127](g)|0;le[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function oC(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;oE(l)|0;b=k+540|0;le[c[(c[b>>2]|0)+40>>2]&127](l)|0;le[c[(c[b>>2]|0)+28>>2]&127](l)|0;xC(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function pC(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];oE(g)|0;l=e+540|0;le[c[(c[l>>2]|0)+40>>2]&127](g)|0;le[c[(c[l>>2]|0)+28>>2]&127](g)|0;le[c[(c[l>>2]|0)+32>>2]&127](g)|0;oe[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function qC(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;yC(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function rC(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;oE(l)|0;b=k+540|0;le[c[(c[b>>2]|0)+40>>2]&127](l)|0;le[c[(c[b>>2]|0)+28>>2]&127](l)|0;wC(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function sC(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function tC(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;zC(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function uC(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function vC(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-9:{tz(1,0,91160,f);m=-9;i=b;return m|0};case-33:{tz(1,0,91480,b);m=-33;i=b;return m|0};case-1:{tz(3,0,90288,l);m=1;i=b;return m|0};case-2:{tz(1,0,90960,k);m=-2;i=b;return m|0};case-12:{tz(1,0,91432,c);m=-12;i=b;return m|0};case-8:{tz(1,0,91112,g);m=-8;i=b;return m|0};case-7:{tz(1,0,91072,h);m=-7;i=b;return m|0};case-11:{tz(1,0,91344,d);m=-11;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-10:{tz(1,0,91248,e);m=-10;i=b;return m|0};case-6:{tz(1,0,91e3,j);m=-6;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function wC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}le[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function xC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;le[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function yC(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+wd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+wd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;nC(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function zC(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+wd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+wd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}nC(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function AC(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function BC(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;ie[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function CC(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function DC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=Lz(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{Ae[c[(c[l>>2]|0)+104>>2]&127](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;Jz(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=Lz(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function EC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((DC(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}FC(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(Lz(d)|0)>0;h=b?2:0;i=e;return h|0}function FC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=B2(q)|0;s=r;t=B2(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[23060]=Hz(4)|0;if((r|0)==0){db(92248,92264,308,92296)}if((t|0)==0){db(92312,92264,309,92296)}v=Oz(b)|0;if((v|0)!=0){w=v;do{v=Qz(w)|0;c[l>>2]=c[v>>2];rz(27,0,92328,l);w=Pz(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;f3(t|0,c[a+384>>2]|0,v|0)|0;f3(r|0,l|0,v|0)|0}h[d>>3]=+IC(a,n,o,q,s,c[23060]|0,b);do{if((Lz(c[23060]|0)|0)==0){s=Mz(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=Oz(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=Qz(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=Pz(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];rz(27,0,92376,j);v=Oz(b)|0;if((v|0)==0){break}else{B=v}do{v=Qz(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[23060]|0;Kz(v,Qz(B)|0);v=Qz(B)|0;c[g>>2]=c[v>>2];rz(27,0,92400,g)}B=Pz(B)|0;}while((B|0)!=0)}}while(0);Iz(b);if((c[61140>>2]|0)!=0){Lz(c[23060]|0)|0}if((Lz(c[23060]|0)|0)>0){B=m;do{g=Mz(c[23060]|0)|0;c[m>>2]=c[g>>2];Nz(c[23060]|0);c[f>>2]=c[m>>2];rz(7,0,92424,f);Jz(b,B);}while((Lz(c[23060]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){f3(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}af(a);LC(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){C2(t);C2(r);i=e;return}f3(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;C2(t);C2(r);i=e;return}function GC(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){PC(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rz(7,0,91968,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((Lz(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[61140>>2]|0)!=0){e=Oz(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=Qz(s)|0;x=c[e>>2]|0;e=Ae[c[(c[p>>2]|0)+104>>2]&127](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;qz(7,0,w,91992,l);s=Pz(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=Qz(Oz(d)|0)|0;x=Ae[c[(c[b+540>>2]|0)+104>>2]&127](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;qz(1,0,e,92008,j);c[s>>2]=1}}while(0);Iz(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;KC(b);HC(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function HC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;rz(27,0,92616,b);d=a+344|0;oe[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function IC(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=B2(p<<3)|0;if((q|0)==0){db(92432,92264,409,92448)}if((p|0)>0){f3(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rz(27,0,92464,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rz(27,0,92512,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){C2(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}oE(a)|0;le[c[(c[p>>2]|0)+40>>2]&127](a)|0;le[c[(c[p>>2]|0)+28>>2]&127](a)|0;le[c[(c[p>>2]|0)+32>>2]&127](a)|0;oe[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(JC(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}f3(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}C2(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function JC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;Iz(b);rz(27,0,92536,g);g=Oz(d)|0;if((g|0)==0){j=Lz(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=Qz(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=Qz(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=Qz(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=Qz(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=Qz(a)|0;o=c[g>>2]|0;g=Qz(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?91952:91960;g=Qz(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?91952:91960;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;rz(27,0,92576,f);Jz(b,Qz(a)|0)}a=Pz(a)|0;}while((a|0)!=0);j=Lz(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function KC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;Ae[c[(c[g>>2]|0)+96>>2]&127](b,1)|0;LC(b);MC(b);le[c[(c[g>>2]|0)+36>>2]&127](b)|0;NC(b,8);h=OC(b)|0;j=le[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{MC(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}PC(b);LC(b);NC(b,8);le[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=OC(b)|0;j=le[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){vz(c[b+536>>2]|0,92656,e)}else if((o|0)==7){MC(b);i=d;return}}function LC(a){a=a|0;var b=0;b=i;f3(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function MC(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function NC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[61112+(d<<2)>>2]|0)==0){i=e;return}rz(d,1,93080,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=le[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=le[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;rz(d,0,93104,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}ie[c[15416]&255](d);i=e;return}function OC(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function PC(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;f3(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;f3(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;f3(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;f3(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function QC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}oe[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function RC(a){a=a|0;var b=0;b=i;SC(a);TC(a);PC(a);UC(a);i=b;return}function SC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function TC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function UC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((SA(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];f3(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;f3(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;f3(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;f3(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(SA(c[d>>2]|0)|0));i=b;return}function VC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[61112+(d<<2)>>2]|0)==0){i=e;return}rz(d,1,92752,q);q=b+136|0;if((c[q>>2]|0)>0){rz(d,1,92776,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?92736:92744;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];rz(d,0,92792,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}ie[c[15416]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){rz(d,1,92848,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?92736:92744;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;rz(d,0,92872,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}ie[c[15416]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){rz(d,1,92928,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?92736:92744;v=(a[n+(m*48|0)+40|0]|0)!=0?92736:92744;n=(a[(c[s>>2]|0)+m|0]|0)!=0?92736:92744;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;rz(d,0,92952,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}ie[c[15416]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){rz(d,1,93008,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;rz(d,0,93032,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}ie[c[15416]&255](d)}ie[c[15416]&255](d);i=e;return}function WC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((SA(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];f3(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;f3(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;f3(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;f3(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(SA(c[d>>2]|0)|0));i=b;return}function XC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function YC(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];f3(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;f3(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;f3(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;f3(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function ZC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=NA(3,32)|0;c[o>>2]=p;if((p|0)==0){vz(c[b+536>>2]|0,93136,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=D2(c[p>>2]|0,8)|0;c[q>>2]=z;uz(c[r>>2]|0,(z|0)!=0|0,93192,l);z=D2(c[s>>2]|0,4)|0;c[t>>2]=z;uz(c[r>>2]|0,(z|0)!=0|0,93192,k);z=D2(c[u>>2]|0,1)|0;c[v>>2]=z;uz(c[r>>2]|0,(z|0)!=0|0,93192,j);z=D2(c[w>>2]|0,4)|0;c[x>>2]=z;uz(c[r>>2]|0,(z|0)!=0|0,93192,g);RA(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=D2(3,4)|0;c[b+4>>2]=n;TA(c[o>>2]|0,0,n);c[b+8>>2]=D2(c[p>>2]|0,112)|0;c[b+12>>2]=D2(c[s>>2]|0,60)|0;c[b+16>>2]=D2(c[u>>2]|0,48)|0;c[b+20>>2]=D2(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=D2(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=D2(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=D2(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=D2(g,52)|0;c[b+40>>2]=D2(c[b+216>>2]|0,52)|0;c[b+44>>2]=D2(c[b+220>>2]|0,52)|0;c[b+48>>2]=D2(c[b+224>>2]|0,52)|0;c[b+52>>2]=D2(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=D2(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=D2(x,8)|0;c[b+340>>2]=D2(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=D2(x,8)|0;c[b+348>>2]=D2(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=D2(j,1)|0;c[b+356>>2]=D2(j,1)|0;c[b+360>>2]=D2(j,1)|0;j=B2(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=B2(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=D2(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=D2(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=D2(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=D2(u,4)|0;c[b+400>>2]=D2(x,8)|0;c[b+404>>2]=D2(p,4)|0;c[b+408>>2]=D2(s,1)|0;c[b+412>>2]=D2(u,4)|0;c[b+416>>2]=D2(c[n>>2]|0,8)|0;c[b+420>>2]=D2(o,4)|0;c[b+424>>2]=D2(y,1)|0;c[b+428>>2]=D2(g,4)|0;c[b+432>>2]=D2(c[b+152>>2]|0,8)|0;c[b+436>>2]=D2(c[b+156>>2]|0,8)|0;g=B2((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;ie[c[(c[y>>2]|0)+20>>2]&255](g);g=B2((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;ie[c[(c[y>>2]|0)+16>>2]&255](g);g=B2((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;ie[c[(c[y>>2]|0)+12>>2]&255](g);g=B2((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;je[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=B2((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=D2(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;uz(c[r>>2]|0,(g|0)!=0|0,93208,f);c[b+512>>2]=100;c[b+516>>2]=D2(100,4)|0;c[b+520>>2]=D2(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=B2(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;uz(c[r>>2]|0,(g|0)!=0|0,93192,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=NA(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function _C(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;C2(c[g+8>>2]|0);C2(c[g+12>>2]|0);C2(c[g+16>>2]|0);C2(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);C2(e);OA(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){qB(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}C2(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){qB(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}C2(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){qB(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}C2(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){qB(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}C2(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){qB(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}C2(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){qB(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}C2(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){qB(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}C2(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){qB(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}C2(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){qB(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}C2(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){qB(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}C2(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){qB(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}C2(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){qB(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}C2(v);C2(c[a+108>>2]|0);C2(c[a+336>>2]|0);C2(c[a+340>>2]|0);C2(c[a+344>>2]|0);C2(c[a+348>>2]|0);C2(c[a+352>>2]|0);C2(c[a+356>>2]|0);C2(c[a+360>>2]|0);C2(c[a+368>>2]|0);C2(c[a+384>>2]|0);C2(c[a+388>>2]|0);C2(c[a+392>>2]|0);C2(c[a+396>>2]|0);C2(c[a+400>>2]|0);C2(c[a+404>>2]|0);C2(c[a+408>>2]|0);C2(c[a+412>>2]|0);C2(c[a+416>>2]|0);C2(c[a+420>>2]|0);C2(c[a+424>>2]|0);C2(c[a+428>>2]|0);C2(c[a+488>>2]|0);C2(c[a+484>>2]|0);C2(c[a+476>>2]|0);C2(c[a+468>>2]|0);C2(c[a+464>>2]|0);C2(c[a+432>>2]|0);C2(c[a+436>>2]|0);C2(c[a+320>>2]|0);C2(c[a+516>>2]|0);C2(c[a+520>>2]|0);VR(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;C2(x);i=b;return}else{y=a;z=0}while(1){OA(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;C2(x);i=b;return}function $C(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[11656]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];rz(8,0,93256,d);i=b;return}function aD(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[11656];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function bD(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[11656];f=e+e*+U(+(d?a:b));if(d){g=-f}else{g=f}i=i;return a-b>=g|0}function cD(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(aD(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function dD(a,b){a=+a;b=+b;i=i;return a<b|0}function eD(a,b){a=+a;b=+b;i=i;return a<=b|0}function fD(a,b){a=+a;b=+b;i=i;return a>b|0}function gD(a,b){a=+a;b=+b;i=i;return a>=b|0}function hD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=B2(k)|0;c[e+(h*40|0)+24>>2]=B2(k)|0;if((c[g>>2]|0)!=1){l=5;break}lD(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){vz(c[a+536>>2]|0,93312,d)}else if((l|0)==6){i=b;return 0}return 0}



function xs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40064]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(40072,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+328>>3],19728)|0)|0;g=c[27738]|0;j=e;k=40968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[40064]=1;i=d;return}function ys(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40208]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(40216,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=41120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[40208]=1;i=d;return}function zs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40352]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+968>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+968>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=gA(40360,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+968>>3],19728)|0)|0;g=c[27738]|0;j=e;k=41272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[40352]=1;i=d;return}function As(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40496]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+960>>3],.001)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+960>>3],.25)|0)<<24>>24==0)){i=d;return}b=gA(40504,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+960>>3],19728)|0)|0;g=c[27738]|0;j=e;k=41424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[40496]=1;i=d;return}function Bs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40640]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(40648,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=40808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[40640]=1;i=d;return}function Cs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40832]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(40840,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],19728)|0)|0;g=c[27738]|0;j=e;k=40968;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[40832]=1;i=d;return}function Ds(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40992]&1){i=d;return}g=b+4|0;b=gD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),0.0)|0;if(!(b<<24>>24==0|(eD(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=gA(41e3,cA(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,18888)|0)|0;g=c[27738]|0;h=e;j=41120;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];He[g&15](e,b,f);a[40992]=1;i=d;return}function Es(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41144]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=gA(41152,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],19728)|0)|0;g=c[27738]|0;j=e;k=41272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[41144]=1;i=d;return}function Fs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41296]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],.001)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],.25)|0)<<24>>24==0)){i=d;return}b=gA(41304,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],19728)|0)|0;g=c[27738]|0;j=e;k=41424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[41296]=1;i=d;return}function Gs(a){a=a|0;var b=0;b=i;jo(a);ko(a);lo(a);mo(a);no(a);oo(a);po(a);qo(a);ro(a);so(a);to(a);uo(a);vo(a);wo(a);xo(a);yo(a);zo(a);Ao(a);Bo(a);Co(a);Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);So(a);To(a);Uo(a);Vo(a);Wo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);xp(a);yp(a);zp(a);Ap(a);Bp(a);Cp(a);Dp(a);Ep(a);Fp(a);Gp(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Op(a);Pp(a);Qp(a);Rp(a);Sp(a);Tp(a);Up(a);Vp(a);Wp(a);Xp(a);Yp(a);Zp(a);_p(a);$p(a);aq(a);bq(a);cq(a);dq(a);eq(a);fq(a);gq(a);hq(a);iq(a);jq(a);kq(a);lq(a);mq(a);nq(a);oq(a);pq(a);qq(a);rq(a);sq(a);tq(a);uq(a);vq(a);wq(a);xq(a);yq(a);zq(a);Aq(a);Bq(a);Cq(a);Dq(a);Eq(a);Fq(a);Gq(a);Hq(a);Iq(a);Jq(a);Kq(a);Lq(a);Mq(a);Nq(a);Oq(a);Pq(a);Qq(a);Rq(a);Sq(a);Tq(a);Uq(a);Vq(a);Wq(a);Xq(a);Yq(a);Zq(a);_q(a);$q(a);ar(a);br(a);cr(a);dr(a);er(a);fr(a);gr(a);hr(a);ir(a);jr(a);kr(a);lr(a);mr(a);nr(a);or(a);pr(a);qr(a);rr(a);sr(a);tr(a);ur(a);vr(a);wr(a);xr(a);yr(a);zr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Ir(a);Jr(a);Kr(a);Lr(a);Mr(a);Nr(a);Or(a);Pr(a);Qr(a);Rr(a);Sr(a);Tr(a);Ur(a);Vr(a);Wr(a);Xr(a);Yr(a);Zr(a);_r(a);$r(a);as(a);bs(a);cs(a);ds(a);es(a);fs(a);gs(a);hs(a);is(a);js(a);ks(a);ls(a);ms(a);ns(a);os(a);ps(a);qs(a);rs(a);ss(a);ts(a);us(a);vs(a);ws(a);xs(a);ys(a);zs(a);As(a);Bs(a);Cs(a);Ds(a);Es(a);Fs(a);i=b;return 0}function Hs(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Is(b);i=c;return 0}function Is(a){a=a|0;var b=0;b=i;gf(a);hf(a);jf(a);kf(a);mf(a);Pf(a);Tf(a);Uf(a);Vf(a);Wf(a);Yf(a);gg(a);jg(a);qg(a);rg(a);Bg(a);Cg(a);Dg(a);Ig(a);Jg(a);Kg(a);Lg(a);Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);i=b;return}function Js(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41448]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+864>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+864>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(41464,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+864>>3],41456)|0)|0;g=c[27738]|0;j=e;k=42e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[41448]=1;i=d;return}function Ks(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41704]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(41712,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],41456)|0)|0;g=c[27738]|0;j=e;k=45496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[41704]=1;i=d;return}function Ls(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41832]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+848>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+848>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(41840,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+848>>3],41456)|0)|0;g=c[27738]|0;j=e;k=42e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[41832]=1;i=d;return}function Ms(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42024]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(42032,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],41456)|0)|0;g=c[27738]|0;j=e;k=42400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[42024]=1;i=d;return}function Ns(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42248]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(42256,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],41456)|0)|0;g=c[27738]|0;j=e;k=42400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[42248]=1;i=d;return}function Os(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42424]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(42432,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],41456)|0)|0;g=c[27738]|0;j=e;k=42592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[42424]=1;i=d;return}function Ps(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42616]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(42624,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],41456)|0)|0;g=c[27738]|0;j=e;k=42920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[42616]=1;i=d;return}function Qs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42768]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(42776,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],41456)|0)|0;g=c[27738]|0;j=e;k=42920;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[42768]=1;i=d;return}function Rs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42944]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(42952,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+264>>3],41456)|0)|0;g=c[27738]|0;j=e;k=43112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[42944]=1;i=d;return}function Ss(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43136]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(43144,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+256>>3],41456)|0)|0;g=c[27738]|0;j=e;k=48168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[43136]=1;i=d;return}function Ts(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43376]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(43384,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+248>>3],41456)|0)|0;g=c[27738]|0;j=e;k=48168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[43376]=1;i=d;return}function Us(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43536]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],-0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(43544,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3],41456)|0)|0;g=c[27738]|0;j=e;k=43696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[43536]=1;i=d;return}function Vs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43720]&1){i=d;return}g=b+4|0;if(!((gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(43728,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+832>>3],41456)|0)|0;g=c[27738]|0;j=e;k=45168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[43720]=1;i=d;return}function Ws(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43800]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(43808,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],41456)|0)|0;g=c[27738]|0;j=e;k=43992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[43800]=1;i=d;return}function Xs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44016]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(44024,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],41456)|0)|0;g=c[27738]|0;j=e;k=44216;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[44016]=1;i=d;return}function Ys(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44240]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(44248,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[44240]=1;i=d;return}function Zs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44384]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(44392,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[44384]=1;i=d;return}function _s(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44512]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+720>>3],-1.0e8)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+720>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(44520,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+720>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[44512]=1;i=d;return}function $s(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44656]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+712>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+712>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(44664,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+712>>3],41456)|0)|0;g=c[27738]|0;j=e;k=44808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[44656]=1;i=d;return}function at(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44832]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(44840,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+688>>3],41456)|0)|0;g=c[27738]|0;j=e;k=44944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[44832]=1;i=d;return}function bt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44968]&1){i=d;return}g=b+4|0;if(!((gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(44976,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+680>>3],41456)|0)|0;g=c[27738]|0;j=e;k=45056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[44968]=1;i=d;return}function ct(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45080]&1){i=d;return}g=b+4|0;if(!((gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(45088,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+664>>3],41456)|0)|0;g=c[27738]|0;j=e;k=45168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[45080]=1;i=d;return}function dt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45192]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(45200,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],41456)|0)|0;g=c[27738]|0;j=e;k=45496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[45192]=1;i=d;return}function et(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45344]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(45352,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+184>>3],41456)|0)|0;g=c[27738]|0;j=e;k=45496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[45344]=1;i=d;return}function ft(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45520]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],-1.0e8)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(45528,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],41456)|0)|0;g=c[27738]|0;j=e;k=45944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[45520]=1;i=d;return}function gt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45768]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],-1.0e8)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(45776,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],41456)|0)|0;g=c[27738]|0;j=e;k=45944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[45768]=1;i=d;return}function ht(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45968]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(45976,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],41456)|0)|0;g=c[27738]|0;j=e;k=46472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[45968]=1;i=d;return}function it(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46136]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(46144,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],41456)|0)|0;g=c[27738]|0;j=e;k=46472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[46136]=1;i=d;return}function jt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46304]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(46312,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],41456)|0)|0;g=c[27738]|0;j=e;k=46472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[46304]=1;i=d;return}function kt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46496]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(46504,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[46496]=1;i=d;return}function lt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46672]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(46680,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[46672]=1;i=d;return}function mt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46848]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(46856,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[46848]=1;i=d;return}function nt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47048]&1){i=d;return}g=b+4|0;if(!((gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gA(47056,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[47048]=1;i=d;return}function ot(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47168]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],-1.0e10)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=gA(47176,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[47168]=1;i=d;return}function pt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47352]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(47360,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47496;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[47352]=1;i=d;return}function qt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47520]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(47528,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[47520]=1;i=d;return}function rt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47680]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],-1.0e8)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=gA(47688,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],41456)|0)|0;g=c[27738]|0;j=e;k=47832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[47680]=1;i=d;return}function st(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47856]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(47864,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],41456)|0)|0;g=c[27738]|0;j=e;k=48e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[47856]=1;i=d;return}function tt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48024]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(48032,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],41456)|0)|0;g=c[27738]|0;j=e;k=48168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[48024]=1;i=d;return}function ut(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48192]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],1.0)|0)<<24>>24==0)){i=d;return}b=gA(48200,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],41456)|0)|0;g=c[27738]|0;j=e;k=48400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[48192]=1;i=d;return}function vt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48424]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(48432,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],41456)|0)|0;g=c[27738]|0;j=e;k=48560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[48424]=1;i=d;return}function wt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48584]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],1.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=gA(48592,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],41456)|0)|0;g=c[27738]|0;j=e;k=48720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[48584]=1;i=d;return}function xt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48744]&1){i=d;return}g=b+4|0;b=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],-0.0)|0;if(!(b<<24>>24==0|(eD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=gA(48752,aA(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+544>>3],41456)|0)|0;g=c[27738]|0;j=e;k=48880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];He[g&15](e,b,f);a[48744]=1;i=d;return}function yt(a){a=a|0;var b=0;b=i;Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Qs(a);Rs(a);Ss(a);Ts(a);Us(a);Vs(a);Ws(a);Xs(a);Ys(a);Zs(a);_s(a);$s(a);at(a);bt(a);ct(a);dt(a);et(a);ft(a);gt(a);ht(a);it(a);jt(a);kt(a);lt(a);mt(a);nt(a);ot(a);pt(a);qt(a);rt(a);st(a);tt(a);ut(a);vt(a);wt(a);xt(a);i=b;return 0}function zt(b){b=b|0;var d=0;d=i;Sl(b);a[(c[b+484>>2]|0)+8|0]=a[(c[b+476>>2]|0)+56|0]|0;i=d;return}function At(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;l=bD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+104>>3],0.0,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;e=k;f=j;break}else{j=b+4|0;k=bD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+104>>3],0.0,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;j=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;a[(c[b+352>>2]|0)+4|0]=j;e=k;f=g;break}else{g=b+4|0;k=fD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;a[(c[b+352>>2]|0)+4|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=gD(+h[k+88>>3],+h[k+528>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+5|0]|0)!=0){m=0;n=k;o=n+2|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+2|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+2|0;p=o;a[p]=m;i=d;return}function Bt(b){b=b|0;var d=0;d=i;zf(b);a[(c[b+484>>2]|0)+48|0]=a[(c[b+468>>2]|0)+632|0]|0;i=d;return}function Ct(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;l=bD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+104>>3],0.0,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;e=k;f=j;break}else{j=b+4|0;k=bD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+104>>3],0.0,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;j=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;a[(c[b+352>>2]|0)+4|0]=j;e=k;f=g;break}else{g=b+4|0;k=fD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;a[(c[b+352>>2]|0)+4|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=gD(+h[k+88>>3],+h[k+528>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+5|0]|0)!=0){m=0;n=k;o=n+2|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+2|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+2|0;p=o;a[p]=m;i=d;return}function Dt(a){a=a|0;i=i;return 1}function Et(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=5;c[a+48>>2]=5;c[a+72>>2]=D2(5,8)|0;a=D2(5,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=D2(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=B2(20)|0;c[(c[d>>2]|0)+52>>2]=a;a=B2(84)|0;c[(c[d>>2]|0)+56>>2]=a;a=B2(20)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=5;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e>>2]=3;c[e+4>>2]=8;c[e+8>>2]=13;c[e+12>>2]=17;c[e+16>>2]=21;Ft(e,c[a+56>>2]|0);a=c[d>>2]|0;Gt(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Ht(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;It(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Jt(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+16>>2]=1;c[a+12>>2]=2;c[a+8>>2]=3;c[a+4>>2]=4;c[a>>2]=5;i=b;return 0}function Ft(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=1;c[b+((c[d>>2]|0)+ -3<<2)>>2]=2;c[b+((c[d>>2]|0)+ -2<<2)>>2]=3;c[b+((c[d>>2]|0)+ -1<<2)>>2]=4;i=i;return}function Gt(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=1;c[b+((c[d>>2]|0)+ -3<<2)>>2]=2;c[b+((c[d>>2]|0)+ -2<<2)>>2]=3;c[b+((c[d>>2]|0)+ -1<<2)>>2]=4;i=i;return}function Ht(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=1;c[b+((c[d>>2]|0)+ -3<<2)>>2]=2;c[b+((c[d>>2]|0)+ -2<<2)>>2]=3;c[b+((c[d>>2]|0)+ -1<<2)>>2]=4;i=i;return}function It(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=1;c[b+((c[d>>2]|0)+ -3<<2)>>2]=2;c[b+((c[d>>2]|0)+ -2<<2)>>2]=3;c[b+((c[d>>2]|0)+ -1<<2)>>2]=4;i=i;return}function Jt(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -3<<2)>>2]=0;c[b+((c[a>>2]|0)+ -2<<2)>>2]=3;c[b+((c[a>>2]|0)+ -1<<2)>>2]=4;i=i;return}function Kt(a){a=a|0;i=i;return 1}function Lt(a){a=a|0;i=i;return 1}function Mt(a){a=a|0;i=i;return 1}function Nt(a){a=a|0;i=i;return 0}function Ot(a){a=a|0;i=i;return 0}function Pt(a){a=a|0;i=i;return 0}function Qt(a){a=a|0;i=i;return 0}function Rt(a){a=a|0;i=i;return 0}function St(a,b){a=a|0;b=b|0;i=i;return-1}function Tt(a,b){a=a|0;b=b|0;i=i;return-1}function Ut(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function Vt(){i=i;return 48904}function Wt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function Xt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function Yt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function Zt(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Bb(49648,n|0)|0;i=m;return 0}function _t(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=YB(a,49656)|0;z=YB(b,49656)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((YB(a,49664)|0)!=0){C=5;break}if((YB(a,49672)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((YB(b,49664)|0)!=0){break}if((YB(b,49672)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){h3(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}h3(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}h3(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Bb(49680,r|0)|0;i=q;return 0}function $t(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(YB(a,49688)|0)!=0;v=c[(u?f:g)>>2]|0;w=YB(e,49696)|0;x=YB(b,49704)|0;c[p>>2]=0;do{if(u){y=4}else{if((YB(a,49712)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((YB(b,49688)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((YB(d,49696)|0)==0){if((YB(d,49720)|0)!=0){break}if((YB(d,49728)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((YB(e,49704)|0)==0){if((YB(e,49696)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){h3(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(YB(d,49696)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Bb(49736,p|0)|0;i=o;return 0}function au(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}cu(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}du(49752,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Bb(49744,l|0)|0;i=k;return 0}function bu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+FB(49776);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(Wt(l,z,49784)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){Yt(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;Xt(l,n,d+(x-o+v<<3)|0,49784)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;Zt(l,m,49792,d+(B+y<<3)|0,49784,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Bb(49768,k|0)|0;i=j;return 0}function cu(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=49824;u=fu(49808,49800,49816,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;bu(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;eu(k,d,e,m,l,f,49808)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;eu(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,49808)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;$t(49832,49840,49848,49864,n,k,49872,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=49848;_t(H,H,k,l,n,49880,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,49872,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);bu(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Bb(49800,j|0)|0;i=h;return 0}function du(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(YB(a,49888)|0)!=0;do{if(n){o=5}else{if((YB(a,49896)|0)!=0){o=5;break}if((YB(a,49904)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=49920;eu(d,h,j,q,b,g,q)|0;$t(49928,49936,49944,49960,b,d,49968,e,f,h,j)|0;$t(49928,49976,49944,49984,b,d,49968,e,f,h,j)|0;i=l;return 0}else{$t(49928,49976,5e4,49984,b,d,49968,e,f,h,j)|0;$t(49928,49936,5e4,49960,b,d,49968,e,f,h,j)|0;eu(d,h,j,49920,b,g,50016)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Bb(49912,m|0)|0;i=l;return 0}function eu(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function fu(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d3(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;kS(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;kS(t,o+1|0,1,2);l=m;kS(l,o+3|0,1,3);o=n;kS(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((jS(t,50024,1,2)|0)==0){if((jS(l,50040,1,3)|0)==0){v=2;i=k;return v|0}if((jS(l,50048,1,3)|0)==0){v=2;i=k;return v|0}if((jS(l,50056,1,3)|0)==0){v=2;i=k;return v|0}if((jS(l,50064,1,3)|0)==0){v=2;i=k;return v|0}if((jS(l,50072,1,3)|0)==0){v=2;i=k;return v|0}if((jS(l,50080,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((jS(t,50104,1,2)|0)==0){n=(jS(l,50032,1,3)|0)==0;if(n|(p|q)^1){v=n?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=91}else if(u<<24>>24==68|u<<24>>24==83){w=94}else{v=2;i=k;return v|0}do{if((w|0)==91){if((jS(t,50128,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=94;break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((jS(t,50136,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}n=a[l]|0;if(n<<24>>24==71){if((jS(o,50144,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50152,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50160,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50168,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50176,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50184,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==77){if((jS(o,50144,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50152,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50160,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50168,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50176,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50184,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((jS(t,50200,1,2)|0)!=0){v=2;i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((jS(o,50144,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50152,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50160,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50168,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50176,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50184,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((jS(o,50144,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50152,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50160,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50168,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50176,1,2)|0)==0){v=2;i=k;return v|0}if((jS(o,50184,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else if((m|0)==3){if((jS(t,50024,1,2)|0)==0){if((jS(l,50040,1,3)|0)==0){v=128;i=k;return v|0}if((jS(l,50048,1,3)|0)==0){v=128;i=k;return v|0}if((jS(l,50056,1,3)|0)==0){v=128;i=k;return v|0}if((jS(l,50064,1,3)|0)==0){v=128;i=k;return v|0}if((jS(l,50072,1,3)|0)==0){v=128;i=k;return v|0}m=(jS(l,50080,1,3)|0)==0;v=m?128:0;i=k;return v|0}if((jS(t,50104,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}m=(jS(l,50112,1,3)|0)==0;v=m?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((jS(t,50128,1,2)|0)==0){m=(jS(l,50112,1,3)|0)==0;v=m?32:0;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=141;break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((jS(t,50136,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((jS(o,50144,1,2)|0)!=0){if((jS(o,50152,1,2)|0)==0){break}if((jS(o,50160,1,2)|0)==0){break}if((jS(o,50168,1,2)|0)==0){break}if((jS(o,50176,1,2)|0)==0){break}if((jS(o,50184,1,2)|0)==0){break}if((jS(o,50192,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((jS(t,50200,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((jS(o,50144,1,2)|0)!=0){if((jS(o,50152,1,2)|0)==0){break}if((jS(o,50160,1,2)|0)==0){break}if((jS(o,50168,1,2)|0)==0){break}if((jS(o,50176,1,2)|0)==0){break}if((jS(o,50184,1,2)|0)==0){break}if((jS(o,50192,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else{if((jS(t,50024,1,2)|0)==0){if((jS(l,50032,1,3)|0)==0){v=64;i=k;return v|0}if((jS(l,50040,1,3)|0)==0){v=32;i=k;return v|0}if((jS(l,50048,1,3)|0)==0){v=32;i=k;return v|0}if((jS(l,50056,1,3)|0)==0){v=32;i=k;return v|0}if((jS(l,50064,1,3)|0)==0){v=32;i=k;return v|0}if((jS(l,50072,1,3)|0)==0){v=32;i=k;return v|0}if((jS(l,50080,1,3)|0)==0){v=32;i=k;return v|0}m=(jS(l,50088,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((jS(t,50096,1,2)|0)==0){m=(jS(l,50032,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((jS(t,50104,1,2)|0)==0){m=(jS(l,50032,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(jS(l,50112,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(jS(l,50120,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==68|u<<24>>24==83){w=29}else if(u<<24>>24==67|u<<24>>24==90){if((jS(t,50128,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((jS(l,50032,1,3)|0)==0){v=64;i=k;return v|0}if((jS(l,50112,1,3)|0)==0){v=32;i=k;return v|0}m=(jS(l,50120,1,3)|0)==0;v=m?64:1;i=k;return v|0}}while(0);do{if((w|0)==29){if((jS(t,50136,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((jS(o,50144,1,2)|0)!=0){if((jS(o,50152,1,2)|0)==0){break}if((jS(o,50160,1,2)|0)==0){break}if((jS(o,50168,1,2)|0)==0){break}if((jS(o,50176,1,2)|0)==0){break}if((jS(o,50184,1,2)|0)==0){break}if((jS(o,50192,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((jS(o,50144,1,2)|0)!=0){if((jS(o,50152,1,2)|0)==0){break}if((jS(o,50160,1,2)|0)==0){break}if((jS(o,50168,1,2)|0)==0){break}if((jS(o,50176,1,2)|0)==0){break}if((jS(o,50184,1,2)|0)==0){break}if((jS(o,50192,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((jS(t,50200,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((jS(o,50144,1,2)|0)!=0){if((jS(o,50152,1,2)|0)==0){break}if((jS(o,50160,1,2)|0)==0){break}if((jS(o,50168,1,2)|0)==0){break}if((jS(o,50176,1,2)|0)==0){break}if((jS(o,50184,1,2)|0)==0){break}if((jS(o,50192,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((jS(o,50144,1,2)|0)!=0){if((jS(o,50152,1,2)|0)==0){break}if((jS(o,50160,1,2)|0)==0){break}if((jS(o,50168,1,2)|0)==0){break}if((jS(o,50176,1,2)|0)==0){break}if((jS(o,50184,1,2)|0)==0){break}if((jS(o,50192,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((jS(t,50208,1,2)|0)==0){if((jS(l,50032,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((jS(t,50216,1,2)|0)==0){if((jS(l,50032,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((jS(t,50184,1,2)|0)==0){o=(jS(l,50088,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((jS(t,50224,1,2)|0)==0){o=(jS(l,50232,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((jS(t,50240,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 10:{v=gu(50256,50264,50272)|0;i=k;return v|0};case 11:{v=gu(50280,50264,50272)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=hu(b,d,e,f,g,h,j)|0;i=k;return v|0};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 6:{j=c[f>>2]|0;f=c[g>>2]|0;v=~~(+(((j|0)>(f|0)?f:j)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function gu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function hu(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(iS(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 12:{p=75;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 15:{p=o;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function iu(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=ju(a,0,0)|0;i=b;return c|0}function ju(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=ku(a,b,c,0)|0;i=d;return e|0}function ku(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=le[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=B2(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=50;c[f+8>>2]=189}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=le[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){ie[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=le[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){ie[c[b+20>>2]&255](c[j+392>>2]|0);ie[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=vv(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}ie[c[j+20>>2]&255](c[j+44>>2]|0);ie[c[j+20>>2]&255](c[j+392>>2]|0);ie[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;wv(j+416|0,j+12|0);wv(j+440|0,j+12|0);mu(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}pu(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=Qv()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Hv()|0}k=j;l=k;i=g;return l|0}function lu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function mu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;Zx(f+256|0);if((b|0)!=0){g=nu(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Iv(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function nu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Eu(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function ou(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Eu(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Eu(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Hu(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=nu(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Eu(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Eu(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((Lu(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Eu(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Hu(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function pu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;ie[c[e+20>>2]&255](c[g+36>>2]|0);qu(c[g+44>>2]|0,e);ie[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;ie[c[e+20>>2]&255](f)}qu(c[h+376>>2]|0,e);qu(c[e+372>>2]|0,e);ru(e+416|0);ru(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}su(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);ie[c[e+20>>2]&255](c[e+392>>2]|0);ie[c[e+20>>2]&255](c[e+464>>2]|0);ie[c[e+20>>2]&255](c[e+8>>2]|0);ie[c[e+20>>2]&255](c[e+44>>2]|0);ie[c[e+20>>2]&255](c[e+396>>2]|0);ie[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){ie[c[e+252>>2]&255](c[e+244>>2]|0)}ie[c[e+20>>2]&255](e);i=d;return}function qu(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;ie[c[a+20>>2]&255](c[b+16>>2]|0);ie[c[a+20>>2]&255](b)}i=d;return}function ru(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ie[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ie[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function su(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Fu(f,g+20|0);while(1){d=Gu(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}ie[c[b+8>>2]&255](c[d+20>>2]|0)}Ku(g);Ku(g+132|0);Ku(g+20|0);Ku(g+40|0);Ku(g+60|0);ru(g+80|0);ru(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ie[m&255](o);i=e;return}ie[c[b+8>>2]&255](c[g+184>>2]|0);ie[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ie[m&255](o);i=e;return}function tu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function uu(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function vu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((wu(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=yu(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{f3(f|0,b|0,d|0)|0;j=zu(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Ke[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){Le[c[(c[h+144>>2]|0)+52>>2]&63](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function wu(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=tv()|0}if((a[e+236|0]|0)!=0){f=ou(e,52064)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function xu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function yu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;g3(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=le[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;f3(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;ie[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function zu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((wu(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Ke[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Le[c[(c[g+144>>2]|0)+52>>2]&63](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Au(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Bu(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Le[c[(c[d+144>>2]|0)+52>>2]&63](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Cu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){He[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];fe[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];He[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Du(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[50288+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Eu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;f3((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=Ae[c[(c[d+20>>2]|0)+4>>2]&127](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=le[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){f3(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Fu(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Gu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}



function fz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[27736]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=59200;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Le[p&63](0,f,59224,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function gz(a,b){a=a|0;b=b|0;var d=0;d=i;if(($y(a)|0)==0){db(59280,59024,347,59304)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);db(59336,59024,348,59304);return 0}function hz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if(($y(a)|0)==0){db(59128,59024,355,59368)}e=c[a>>2]|0;f=b;c[f>>2]=e;g=Xz(e)|0;c[b+4>>2]=g;if((g|0)==0){db(59176,59024,359,59368)}b=c[f>>2]|0;if((b|0)<=0){i=d;return}f=c[a+4>>2]|0;a=0;do{c[g+(a<<2)>>2]=c[f+(b+~a<<2)>>2];a=a+1|0;}while((a|0)<(b|0));i=d;return}function iz(){var a=0,b=0,d=0;a=i;b=61112|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=61224|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=61336|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[61116>>2]=1;c[61120>>2]=1;i=a;return}function jz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?61472:61488;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;zd(a|0,61448,e|0)|0;i=d;return}function kz(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=61336+(d<<2)|0;o=61224+(d<<2)|0;p=61536+(b<<2)|0;q=59816+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=61520;ic(61504,l|0)|0;s=61520}else{if((c[15274]|0)==(d|0)){if((c[o>>2]|0)>0){t=61520}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;ic(61504,m|0)|0;do{if((c[15274]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=61520;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;ic(61528,k|0)|0;c[n>>2]=b;c[15274]=d;if((c[o>>2]|0)>0){g=0;while(1){ic(61560,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;ub(e|0)|0;r=0;e=e+(w+1)|0;f=1}ub(e|0)|0;xd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function lz(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[61536+(a<<2)>>2]|0;c[j>>2]=c[59816+(b<<2)>>2];c[j+4>>2]=k;ic(61568,j|0)|0;mz(e);if((g|0)==0){Nd(((d|0)!=0?61608:61656)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=xd(m|0)|0;i=f;return}ub(61736)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];ic(61616,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=xd(m|0)|0;i=f;return}tc(61640,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=xd(m|0)|0;i=f;return}function mz(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==0){break}else if(b<<24>>24==60){tc(61688,4,1,e|0)|0}else if(b<<24>>24==62){tc(61696,4,1,e|0)|0}else if(b<<24>>24==38){tc(61680,5,1,e|0)|0}else{Vd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function nz(a){a=a|0;var b=0;b=61224+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function oz(a){a=a|0;var b=0;b=(a|0)==0;c[15418]=b?1:19;c[15416]=b?7:190;i=i;return}function pz(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;tc(61640,11,1,b|0)|0;xd(b|0)|0;i=a;return}function qz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[61112+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;$c(j|0,2048,e|0,h|0)|0;ue[c[15418]&31](1,a,b,j,0,d);i=g;return}function rz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[61112+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;$c(h|0,2048,d|0,g|0)|0;ue[c[15418]&31](1,a,b,h,0,0);i=f;return}function sz(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[15276]|0)==0){if((c[61112+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;$c(k|0,2048,e|0,j|0)|0;ue[c[15418]&31](2,a,b,k,0,d);i=g;return}function tz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[15276]|0)==0){if((c[61112+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;$c(j|0,2048,d|0,h|0)|0;ue[c[15418]&31](2,a,b,j,0,0);i=f;return}function uz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;$c(b|0,2048,d|0,g|0)|0;ue[c[15418]&31](4,2,0,b,0,0);if((a|0)==0){h=od(c[14704]|0)|0}else{h=a}fb(c[h+76>>2]|0,1)}function vz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;$c(g|0,2048,b|0,f|0)|0;ue[c[15418]&31](5,2,0,g,0,0);if((a|0)==0){h=od(c[14704]|0)|0}else{h=a}fb(c[h+76>>2]|0,1)}function wz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;$c(h|0,2048,d|0,g|0)|0;ue[c[15418]&31](5,2,0,h,0,b);if((a|0)==0){j=od(c[14704]|0)|0}else{j=a}fb(c[j+76>>2]|0,1)}function xz(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;wz(a,e,61808,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;sz(26,0,e,61744,m);i=j;return+b}return 0.0}function yz(a,b){a=a|0;b=b|0;i=i;return c[(c[a+8>>2]|0)+(b<<2)>>2]|0}function zz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=Vz(dz(a,b,f)|0)|0;i=e;return}function Az(a){a=a|0;var b=0;b=i;c[a+8>>2]=Vz(bz(a)|0)|0;i=b;return}function Bz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if(($y(a)|0)==0){db(61856,61880,126,61904)}if(($y(b)|0)==0){db(61928,61880,127,61904)}if((az(a,b)|0)==0){db(61952,61880,128,61904)}e=Cz(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=yz(a,b)|0;Dz(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function Cz(a){a=a|0;var b=0,c=0;b=i;c=bz(a)|0;i=b;return c|0}function Dz(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function Ez(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=c[a>>2]|0;if((e|0)==2){if((c[b>>2]|0)!=2){f=61992;g=f;h=61880;j=h;k=62024;l=k;db(g|0,j|0,1323,l|0)}m=c[a+4>>2]|0;n=c[m>>2]|0;o=c[m+4>>2]|0;m=c[b+4>>2]|0;if((c[m>>2]|0)!=(o|0)){p=62048;q=p;r=61880;s=r;t=62024;u=t;db(q|0,s|0,1328,u|0)}if((c[m+4>>2]|0)!=(n|0)){p=62048;q=p;r=61880;s=r;t=62024;u=t;db(q|0,s|0,1328,u|0)}if((n|0)==0){i=d;return}u=(o|0)==0;s=b+8|0;q=0;do{if(!u){t=fa(q,o)|0;r=0;do{p=(fa(r,n)|0)+q|0;m=yz(a,r+t|0)|0;Dz(c[s>>2]|0,p,m);r=r+1|0;}while(r>>>0<o>>>0)}q=q+1|0;}while(q>>>0<n>>>0);i=d;return}else if((e|0)==1){Bz(a,b);i=d;return}else{f=61992;g=f;h=61880;j=h;k=62024;l=k;db(g|0,j|0,1323,l|0)}}function Fz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;Gz(a,b);Az(b);Ez(a,b);e=c[b>>2]|0;if((e|0)<=0){i=d;return}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;do{c[a+(b<<2)>>2]=c[f+(b<<2)>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function Gz(a,b){a=a|0;b=b|0;var c=0;c=i;hz(a,b);i=c;return}function Hz(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=B2(16)|0;uz(0,(d|0)!=0|0,62104,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function Iz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;C2(c[f>>2]|0);C2(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function Jz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;uz(0,(a|0)!=0|0,62120,f);f=B2(8)|0;g=f;uz(0,(f|0)!=0|0,62104,e);e=a+8|0;h=B2(c[e>>2]|0)|0;c[f>>2]=h;uz(0,(h|0)!=0|0,62104,d);f3(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function Kz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;uz(0,(a|0)!=0|0,62120,f);f=B2(8)|0;g=f;uz(0,(f|0)!=0|0,62104,e);e=a+8|0;h=B2(c[e>>2]|0)|0;c[f>>2]=h;uz(0,(h|0)!=0|0,62104,d);f3(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function Lz(a){a=a|0;var b=0;b=i;i=i+8|0;uz(0,(a|0)!=0|0,62120,b);i=b;return c[a+12>>2]|0}function Mz(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;uz(0,(a|0)!=0|0,62120,d);d=a;uz(0,(c[d>>2]|0)!=0|0,62144,b);i=b;return c[c[d>>2]>>2]|0}function Nz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;C2(c[e>>2]|0);C2(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function Oz(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;uz(0,(a|0)!=0|0,62120,d);d=a;uz(0,(c[d>>2]|0)!=0|0,62160,b);i=b;return c[d>>2]|0}function Pz(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;uz(0,d&1,62192,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function Qz(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;uz(0,(a|0)!=0|0,62192,d);d=a;uz(0,(c[d>>2]|0)!=0|0,62216,b);i=b;return c[d>>2]|0}function Rz(){var a=0,b=0,d=0;a=i;b=B2(16)|0;c[15572]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=B2(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function Sz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=Yz(a)|0;vc(62296)|0;Zz(d);a=c[15572]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;hc(62296)|0;h3(g|0,0,d|0)|0;i=b;return g|0}function Tz(){var a=0,b=0,d=0,e=0;a=i;b=c[15572]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;C2(c[b>>2]|0);C2(b);if((d|0)==0){break}else{b=d}}e=c[15572]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function Uz(a){a=a|0;var b=0,d=0;b=i;d=le[c[62248>>2]&127](a<<3)|0;i=b;return d|0}function Vz(a){a=a|0;var b=0,d=0;b=i;d=le[c[62248>>2]&127](a<<2)|0;i=b;return d|0}function Wz(a){a=a|0;var b=0,d=0;b=i;d=le[c[62248>>2]&127](a<<2)|0;i=b;return d|0}function Xz(a){a=a|0;var b=0,d=0;b=i;d=le[c[62248>>2]&127](a<<2)|0;i=b;return d|0}function Yz(a){a=a|0;i=i;return a+7&-8|0}function Zz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[15572]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=B2(16)|0;c[f+12>>2]=d;c[15572]=f;c[f+4>>2]=0;d=_z((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=B2(d)|0;c[f>>2]=a;i=b;return}function _z(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function $z(a){a=a|0;var b=0,c=0;b=i;c=d3(a|0)|0;i=b;return c|0}function aA(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;j3(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];jc(m|0,l|0,f|0)|0;f=bA(m)|0;i=e;return f|0}function bA(a){a=a|0;var b=0,c=0,d=0;b=i;c=d3(a|0)|0;d=fA(c)|0;f3(d|0,a|0,c|0)|0;i=b;return d|0}function cA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;j3(g+1|0,d|0)|0;c[f>>2]=b;jc(k|0,j|0,f|0)|0;f=bA(k)|0;i=e;return f|0}function dA(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+40|0;l=i;i=i+400|0;m=k;n=l;a[m]=37;l=k+1|0;if(e<<24>>24==0){c[h>>2]=d;jc(l|0,62328,h|0)|0;o=g;p=o;c[p>>2]=b;q=39;r=q;s=jc(n|0,m|0,g|0)|0;t=bA(n)|0;i=f;return t|0}else{c[j>>2]=d;jc(l|0,62320,j|0)|0;o=g;p=o;c[p>>2]=b;q=39;r=q;s=jc(n|0,m|0,g|0)|0;t=bA(n)|0;i=f;return t|0}return 0}function eA(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;jc(o|0,62344,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;jc(o|0,62336,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];jc(q|0,p|0,j|0)|0;j=bA(q)|0;i=g;return j|0}function fA(b){b=b|0;var d=0,e=0;d=i;e=le[c[62252>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function gA(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=$z(a)|0;e=$z(b)|0;f=fA(e+d|0)|0;f3(f|0,a|0,d|0)|0;f3(f+d|0,b|0,e|0)|0;i=c;return f|0}function hA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=$2(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function iA(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}else if((e|0)==2){f=-1;break}switch(d|0){case 3:{f=2;break a;break};case 1:{f=4;break a;break};case 5:{f=1;break a;break};case 4:{f=2;break a;break};case 2:{f=4;break a;break};case 0:{f=8;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function jA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){_c(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){C2(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{C2(c[(c[f>>2]|0)+(g<<4)>>2]|0);C2(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;C2(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){C2(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{C2(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}C2(d);c[g>>2]=0;i=b;return}function kA(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(d3(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function lA(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=kc(b|0,62512)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Zd(c[(Pc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Dd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=tb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=62520;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[62488+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=62544;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=62568;E=131;break}G=iA(D)|0;if((G|0)==-1){n=62600;E=131;break}D=c[q>>2]|0;H=B2(D)|0;if((tb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=62648;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=62672;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if(($2(H,c[62464+(C<<2)>>2]|0)|0)!=0){n=62696;E=131;break}C2(H);H=63272;b:do{switch(C|0){case 0:{if((D|0)!=4){n=62720;E=131;break a}if((I|0)!=11){n=62760;E=131;break a}if((tb(f|0,44,1,c[m>>2]|0)|0)==1){K=0}else{n=62800;E=131;break a}while(1){F=0;do{a[k+F|0]=a[j+((F<<2)+K)|0]|0;F=F+1|0;}while(F>>>0<11);a[k+11|0]=0;if((K|0)==3){break}F=K+1|0;if(F>>>0<4){K=F}else{L=d;E=130;break b}}if((a3(t,c[15592]|0,8)|0)==0){L=1;E=130;break b}if((a3(t,c[15598]|0,9)|0)==0){L=0;E=130}else{n=62832;E=131;break a}break};case 3:{F=fa(I<<2,D)|0;M=B2(F)|0;if((tb(M|0,F|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}F=c[v>>2]|0;G=0;do{c[F+(G<<4)+8>>2]=(c[M+(G<<2)>>2]|0)==1;c[F+(G<<4)+12>>2]=c[M+(D+G<<2)>>2];G=G+1|0;}while(G>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}G=c[v>>2]|0;F=0;do{N=fa(D,F)|0;c[G+(F<<4)+8>>2]=(c[M+(N<<2)>>2]|0)==1;c[G+(F<<4)+12>>2]=c[M+(N+1<<2)>>2];F=F+1|0;}while(F>>>0<I>>>0)}}while(0);C2(M);ec(c[v>>2]|0,c[u>>2]|0,16,55);L=d;E=130;break};case 1:{F=d<<24>>24==0;c[u>>2]=F?D:I;G=B2((F?D:I)<<4)|0;c[v>>2]=G;c:do{if(d<<24>>24==1){if((I|0)==0){O=0;break}N=D+1|0;P=G;Q=0;while(1){c[P+(Q<<4)>>2]=B2(N)|0;if((tb(c[(c[v>>2]|0)+(Q<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=62896;E=131;break a}a[(c[(c[v>>2]|0)+(Q<<4)>>2]|0)+D|0]=0;R=c[v>>2]|0;c[R+(Q<<4)+8>>2]=-1;c[R+(Q<<4)+12>>2]=-1;kA(c[R+(Q<<4)>>2]|0);R=Q+1|0;if(!(R>>>0<I>>>0)){O=I;break c}P=c[v>>2]|0;Q=R}}else{O=I}}while(0);if(!F){L=d;E=130;break b}G=fa(D,O)|0;S=B2(G+1|0)|0;if((tb(S|0,G|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){G=O+1|0;Q=(O|0)==0;P=0;do{N=B2(G)|0;c[(c[v>>2]|0)+(P<<4)>>2]=N;if(!Q){N=0;do{R=a[S+((fa(D,N)|0)+P)|0]|0;a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+N|0]=R;N=N+1|0;}while(N>>>0<O>>>0)}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+O|0]=0;N=c[v>>2]|0;c[N+(P<<4)+8>>2]=-1;c[N+(P<<4)+12>>2]=-1;kA(c[N+(P<<4)>>2]|0);P=P+1|0;}while(P>>>0<D>>>0)}C2(S);L=0;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=62960;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=63016;E=131;break a}c[w>>2]=D;P=fa(I,D)|0;if((a[l]|0)==1){Q=B2(P<<3)|0;c[x>>2]=Q;if((tb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=63056;E=131;break a}}else{Q=B2(P<<2)|0;c[x>>2]=B2(fa(D<<3,I)|0)|0;if((tb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=63056;E=131;break a}if((P|0)!=0){G=c[x>>2]|0;F=0;do{h[G+(F<<3)>>3]=+g[Q+(F<<2)>>2];F=F+1|0;}while(F>>>0<P>>>0)}C2(Q)}P=c[w>>2]|0;if(!(P>>>0>1)){L=1;E=130;break b}F=(I|0)==2;G=1;while(1){if(F){N=c[x>>2]|0;if(+h[N+(G<<3)>>3]!=+h[N+(P+G<<3)>>3]){n=63088;E=131;break a}}N=G+1|0;if(N>>>0<P>>>0){G=N}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){T=d;E=129;break b}if((I|0)==0){n=62960;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=63168;E=131;break a}c[w>>2]=I;G=fa(I,D)|0;if((a[l]|0)==1){P=B2(G<<3)|0;c[x>>2]=B2(fa(D<<3,I)|0)|0;if((tb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=63056;E=131;break a}if((D|0)!=0){F=0;do{Q=c[x>>2]|0;N=0;do{h[Q+((fa(I,F)|0)+N<<3)>>3]=+h[P+((fa(D,N)|0)+F<<3)>>3];N=N+1|0;}while(N>>>0<I>>>0);F=F+1|0;}while(F>>>0<D>>>0)}C2(P)}else{F=B2(G<<2)|0;c[x>>2]=B2(fa(D<<3,I)|0)|0;if((tb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=63056;E=131;break a}if((D|0)!=0){N=0;do{Q=c[x>>2]|0;R=0;do{h[Q+((fa(I,N)|0)+R<<3)>>3]=+g[F+((fa(D,R)|0)+N<<2)>>2];R=R+1|0;}while(R>>>0<I>>>0);N=N+1|0;}while(N>>>0<D>>>0)}C2(F)}N=c[w>>2]|0;if(!(N>>>0>1)){L=d;E=130;break b}G=(D|0)==2;P=1;while(1){if(G){R=c[x>>2]|0;if(+h[R+(P<<3)>>3]!=+h[R+(N+P<<3)>>3]){n=63088;E=131;break a}}R=P+1|0;if(R>>>0<N>>>0){P=R}else{L=d;E=130;break}}break};case 2:{if(d<<24>>24==1){if((I|0)==0){T=1;E=129;break b}P=D+1|0;N=0;while(1){G=B2(P)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=G;if((tb(c[(c[v>>2]|0)+(N<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=62896;E=131;break a}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+D|0]=0;G=N+1|0;if(G>>>0<I>>>0){N=G}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){T=d;E=129;break b}N=fa(D,I)|0;U=B2(N+1|0)|0;if((tb(U|0,N|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){N=I+1|0;P=(I|0)==0;G=0;do{F=B2(N)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=F;if(!P){F=0;do{R=a[U+((fa(D,F)|0)+G)|0]|0;a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+F|0]=R;F=F+1|0;}while(F>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+I|0]=0;G=G+1|0;}while(G>>>0<D>>>0)}C2(U);L=0;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=63208;E=131;break a}c[z>>2]=D;c[A>>2]=zb(c[m>>2]|0)|0;c[B>>2]=D2(c[z>>2]<<1,4)|0;if((Yc(c[m>>2]|0,J|0,1)|0)==-1){n=63240;E=131;break a}else{L=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=63208;E=131;break a}c[z>>2]=I;c[A>>2]=zb(c[m>>2]|0)|0;c[B>>2]=D2(c[z>>2]<<1,4)|0;G=fa(I,D)|0;if((a[l]|0)==1){P=B2(G<<3)|0;if((tb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=63240;E=131;break a}if((I|0)!=0){N=D<<3;F=(D|0)==0;R=D<<3;Q=0;do{V=B2(N)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=V;if(!F){V=P+(fa(R,Q)|0)|0;f3(c[(c[B>>2]|0)+(Q<<2)>>2]|0,V|0,R|0)|0}Q=Q+1|0;}while(Q>>>0<I>>>0)}Q=c[z>>2]|0;R=Q<<1;if(Q>>>0<R>>>0){F=D<<3;N=(D|0)==0;V=Q;do{W=B2(F)|0;c[(c[B>>2]|0)+(V<<2)>>2]=W;if(!N){W=c[B>>2]|0;X=c[W+(V-Q<<2)>>2]|0;Y=c[W+(V<<2)>>2]|0;W=0;do{h[Y+(W<<3)>>3]=-+h[X+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}V=V+1|0;}while(V>>>0<R>>>0)}C2(P)}else{R=B2(G<<2)|0;if((tb(R|0,J|0,1,c[m>>2]|0)|0)!=1){n=63240;E=131;break a}if((I|0)!=0){V=D<<3;Q=(D|0)==0;N=0;do{F=B2(V)|0;c[(c[B>>2]|0)+(N<<2)>>2]=F;if(!Q){F=c[(c[B>>2]|0)+(N<<2)>>2]|0;W=0;do{h[F+(W<<3)>>3]=+g[R+((fa(D,N)|0)+W<<2)>>2];W=W+1|0;}while(W>>>0<D>>>0)}N=N+1|0;}while(N>>>0<I>>>0)}N=c[z>>2]|0;Q=N<<1;if(N>>>0<Q>>>0){V=D<<3;G=(D|0)==0;P=N;do{W=B2(V)|0;c[(c[B>>2]|0)+(P<<2)>>2]=W;if(!G){W=c[B>>2]|0;F=c[W+(P-N<<2)>>2]|0;X=c[W+(P<<2)>>2]|0;W=0;do{h[X+(W<<3)>>3]=-+h[F+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}P=P+1|0;}while(P>>>0<Q>>>0)}C2(R)}if((Yc(c[m>>2]|0,J|0,1)|0)==-1){n=63240;E=131;break a}else{L=d;E=130}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=T;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=L;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){C2(S);n=62896;i=e;return n|0}else if((E|0)==46){C2(U);n=62896;i=e;return n|0}else if((E|0)==52){C2(M);n=62928;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function mA(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Hd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,55)|0;i=d;return b|0}function nA(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=63312;o=n;p=63360;q=p;r=63384;s=r;db(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=63312;o=n;p=63360;q=p;r=63384;s=r;db(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=B2(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Yc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((tb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}C2(r);t=0;i=e;return t|0}else{k=B2(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Yc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((tb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}C2(k);C2(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);C2(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function oA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=63312;r=q;s=63360;t=s;u=63408;v=u;db(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=63312;r=q;s=63360;t=s;u=63408;v=u;db(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Yc(o|0,t+(r<<3)|0,0)|0;f=(tb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Yc(o|0,t+(r<<2)|0,0)|0;if((tb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function pA(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function qA(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function rA(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function sA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+rA(b)<e){q=1;i=f;return q|0}if(+qA(b)>e){q=1;i=f;return q|0}if((nA(b,1)|0)==0){q=1;i=f;return q|0}pA(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+oA(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+oA(a,b,d,o);i=f;return q|0}if(+oA(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+oA(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function tA(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function uA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;_y(a,b,d,g);i=f;return}function vA(a,b){a=a|0;b=b|0;var c=0;c=i;cz(a,b,Uz(b)|0);i=c;return}function wA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=Uz(dz(a,b,f)|0)|0;i=e;return}function xA(a){a=a|0;var b=0;b=i;c[a+8>>2]=Uz(bz(a)|0)|0;i=b;return}function yA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if(($y(a)|0)==0){db(63440,63464,127,63488)}if(($y(b)|0)==0){db(63512,63464,128,63488)}if((az(a,b)|0)==0){db(63536,63464,129,63488)}e=bz(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+tA(a,b);zA(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function zA(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function AA(a,b){a=a|0;b=b|0;var c=0;c=i;ez(a,b);xA(b);yA(a,b);i=c;return}function BA(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function CA(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;zA(c[d+8>>2]|0,b,a);i=e;return}function DA(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;vA(a,b);j=g;c[g>>2]=e;CA(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;CA(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function EA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=fz(a,b,f)|0;f=BA(c[a+8>>2]|0,d)|0;i=e;return f|0}function FA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=B2(d<<2)|0;if((j|0)==0){db(63576,63464,784,63608)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){db(63584,63464,795,63608)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){db(63632,63464,798,63608)}else if((s|0)==17){db(63672,63464,800,63608)}else if((s|0)==22){db(63672,63464,804,63608)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=Uz(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=Xz(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){C2(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+tA(a,k+s|0);zA(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}C2(j);i=g;return}function GA(a,b,d){a=+a;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=d+4|0;c[f>>2]=Xz(b)|0;g=Uz(1)|0;c[d+8>>2]=g;c[d>>2]=b;zA(g,0,a);if((b|0)<=0){i=e;return}g=c[f>>2]|0;f=0;do{c[g+(f<<2)>>2]=1;f=f+1|0;}while((f|0)<(b|0));i=e;return}function HA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0;d=i;e=c[a>>2]|0;if((e|0)==1){yA(a,b);i=d;return}else if((e|0)==2){if((c[b>>2]|0)!=2){f=63744;g=f;h=63464;j=h;k=63776;l=k;db(g|0,j|0,1383,l|0)}e=c[a+4>>2]|0;m=c[e>>2]|0;n=c[e+4>>2]|0;e=c[b+4>>2]|0;if((c[e>>2]|0)!=(n|0)){o=63800;p=o;q=63464;r=q;s=63776;t=s;db(p|0,r|0,1388,t|0)}if((c[e+4>>2]|0)!=(m|0)){o=63800;p=o;q=63464;r=q;s=63776;t=s;db(p|0,r|0,1388,t|0)}if((m|0)==0){i=d;return}t=(n|0)==0;r=b+8|0;b=0;do{if(!t){p=fa(b,n)|0;s=0;do{q=(fa(s,m)|0)+b|0;u=+tA(a,s+p|0);zA(c[r>>2]|0,q,u);s=s+1|0;}while(s>>>0<n>>>0)}b=b+1|0;}while(b>>>0<m>>>0);i=d;return}else{f=63744;g=f;h=63464;j=h;k=63776;l=k;db(g|0,j|0,1383,l|0)}}function IA(a){a=a|0;var b=0,c=0,d=0.0,e=0.0,f=0,g=0.0,h=0.0,j=0;b=i;if(($y(a)|0)==0){db(63720,63464,1502,63856)}c=bz(a)|0;if((c|0)==0){d=0.0;i=b;return+d}e=+tA(a,0);if(c>>>0>1){f=1;g=e}else{d=e;i=b;return+d}while(1){e=+tA(a,f);h=g<e?e:g;j=f+1|0;if(j>>>0<c>>>0){g=h;f=j}else{d=h;break}}i=b;return+d}function JA(a){a=a|0;var b=0,c=0,d=0.0,e=0.0,f=0,g=0.0,h=0.0,j=0;b=i;if(($y(a)|0)==0){db(63720,63464,1524,63872)}c=bz(a)|0;if((c|0)==0){d=0.0;i=b;return+d}e=+tA(a,0);if(c>>>0>1){f=1;g=e}else{d=e;i=b;return+d}while(1){e=+tA(a,f);h=g>e?e:g;j=f+1|0;if(j>>>0<c>>>0){g=h;f=j}else{d=h;break}}i=b;return+d}function KA(a){a=a|0;var b=0,c=0,d=0.0,e=0,f=0.0,g=0.0,h=0;b=i;if(($y(a)|0)==0){db(63720,63464,1547,63888)}c=bz(a)|0;if((c|0)==0){d=0.0;i=b;return+d}else{e=0;f=0.0}while(1){g=f+ +tA(a,e);h=e+1|0;if(h>>>0<c>>>0){f=g;e=h}else{d=g;break}}i=b;return+d}function LA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;hz(a,b);xA(b);HA(a,b);e=c[b>>2]|0;if((e|0)<=0){i=d;return}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;do{c[a+(b<<2)>>2]=c[f+(b<<2)>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function MA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;hz(a,b);xA(b);e=c[b>>2]|0;if((e|0)<=0){HA(a,b);i=d;return}f=c[b+4>>2]|0;g=c[a+4>>2]|0;h=0;do{j=f+(h<<2)|0;k=c[j>>2]|0;l=g+(h<<2)|0;c[j>>2]=c[l>>2];c[l>>2]=k;h=h+1|0;}while((h|0)<(e|0));HA(a,b);i=d;return}function NA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=B2(20)|0;uz(0,(f|0)!=0|0,63904,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=D2(e,b)|0;c[f>>2]=a;uz(0,(a|0)!=0|0,63904,d);i=d;return f|0}function OA(a){a=a|0;var b=0;b=i;C2(c[a>>2]|0);C2(a);i=b;return}function PA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;uz(0,(c[h>>2]|0)>0|0,63920,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;uz(0,(g|0)>(b|0)|0,63944,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;uz(0,(0-f|0)<(b|0)|0,63944,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function QA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=D2(c[d>>2]<<1,c[e>>2]|0)|0;uz(0,(f|0)!=0|0,63904,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=PA(a,j)|0;h=c[e>>2]|0;f3(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;C2(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function RA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){QA(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;f3((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function SA(a){a=a|0;i=i;return c[a+12>>2]|0}function TA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;uz(0,(c[j>>2]|0)>0|0,63920,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;uz(0,(h|0)>(b|0)|0,63944,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;uz(0,b>>>31^1,63944,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=PA(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function UA(a){a=a|0;i=i;return c[(c[15994]|0)+(a<<2)>>2]|0}function VA(a){a=a|0;i=i;return c[(c[15996]|0)+(a<<2)>>2]|0}function WA(a){a=a|0;i=i;return c[(c[15998]|0)+(a<<2)>>2]|0}function XA(a){a=a|0;i=i;return c[(c[16e3]|0)+(a<<2)>>2]|0}function YA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[15996]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[15998]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[15994]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function ZA(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16002]|0;e=+_A(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function _A(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function $A(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16004]|0;e=+_A(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function aB(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[16006]|0;e=+_A(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function bB(a){a=a|0;i=i;return 0}function cB(a){a=a|0;var b=0,d=0;b=i;hb(4,(c[16008]|0)+(a<<3)|0)|0;d=(c[15994]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function dB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[16002]|0;f=e+(a<<3)|0;g=c[16006]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[16e3]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[15994]|0)+(a<<2)>>2]|0);e=c[16004]|0;g=e+(a<<3)|0;eB(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;YA(a);d=c[16002]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[15994]|0)+(a<<2)>>2]=0;i=b;return}function eB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(hB(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function fB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;hb(4,d|0)|0;e=c[16008]|0;f=c[16002]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function gB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=D2(a,8)|0;c[16002]=d;e=D2(a,8)|0;c[16004]=e;f=D2(a,8)|0;c[16006]=f;g=D2(a,8)|0;c[16008]=g;h=D2(a,4)|0;c[15994]=h;j=D2(a,4)|0;c[16e3]=j;k=a<<2;l=B2(k)|0;c[15996]=l;m=D2(a,4)|0;c[15998]=m;h3(l|0,-1,k|0)|0;if((d|0)==0){db(64040,64056,393,64072)}if((e|0)==0){db(64080,64056,394,64072)}if((f|0)==0){db(64096,64056,395,64072)}if((g|0)==0){db(64112,64056,396,64072)}if((h|0)==0){db(64128,64056,397,64072)}if((l|0)==0){db(64152,64056,398,64072)}if((m|0)==0){db(64176,64056,399,64072)}if((j|0)==0){db(64200,64056,400,64072)}else{i=b;return}}function hB(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function iB(a,b){a=a|0;b=b|0;var c=0;c=i;cz(a,b,Wz(b)|0);i=c;return}function jB(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function kB(a,b){a=a|0;b=b|0;i=i;return a+(b<<2)|0}function lB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;jB(c[d+8>>2]|0,b,a);i=e;return}function mB(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;iB(a,b);h=g;c[g>>2]=e;lB(d,0,a);if((b|0)>1){j=1}else{i=f;return}do{d=c[h>>2]|0;e=c[d>>2]|0;c[h>>2]=d+4;lB(e,j,a);j=j+1|0;}while((j|0)<(b|0));i=f;return}function nB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=fz(a,b,f)|0;f=kB(c[a+8>>2]|0,d)|0;i=e;return f|0}function oB(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function pB(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==2){c[j>>2]=c[b+8>>2];n=j+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sz(17,0,o,65984,j);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];j=m+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];sz(17,0,o,65832,m);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];m=g+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];sz(17,0,o,66080,g);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];g=l+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];sz(17,0,o,65880,l);i=e;return}else{l=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=l;l=f+8|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];sz(17,0,o,66144,f);i=e;return}}function qB(a){a=a|0;var b=0;b=i;C2(c[a+12>>2]|0);C2(c[a+4>>2]|0);C2(c[a+8>>2]|0);i=b;return}function rB(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Nd(a|0,d|0)|0;xd(d|0)|0;ie[c[27740]&255](0);i=b;return}function sB(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[8871]=.5;h[8857]=1.0;h[8894]=.25;h[8869]=2.0;h[8896]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[17750]=A;B=c[d>>2]|0;c[17680]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[17680]=D;if((C|0)<(B|0)){C=D}else{break}}}c[17678]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[8872]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[8872]=F;G=F}else{G=E}D=c[d>>2]|0;c[17680]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[17680]=I;if((H|0)>=(D|0)){break a}E=+h[8872];H=I}}}while(0);D=C+1|0;c[17678]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[8876]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[8841]=0.0;h[8843]=0.0;h[8847]=0.0;h[8904]=0.0;c[17676]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[8841]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[8843]+ +h[B>>3]*F;h[8843]=E;F=+h[I>>3];M=+h[8847]+F*F;h[8847]=M;F=+h[H>>3];h[8904]=+h[8904]+F*F;H=A+1|0;c[17676]=H;F=+h[8841];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[17746]=A;E=G/J;h[8893]=E;C=c[d>>2]|0;c[17680]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[8901]=0.0;h[8903]=0.0;I=c[b>>2]|0;c[17676]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[8870]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[8901]=ba;ca=E+aa*aa;h[8903]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[17676]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[17746]=A;h[8893]=E;h[8843]=Z;h[8847]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[17680]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[17676]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[17676]=A+1;da=+h[8843];ea=+h[8847];ga=+h[8841]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[8892]=K;c[17774]=0;h[8900]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[17774]=C;K=+h[8857]/+V(+ga);h[8872]=K;h[8895]=0.0;h[8897]=0.0;B=c[b>>2]|0;c[17676]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[8895]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[8895]=oa;pa=+h[8897]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[8897]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[8843];L=+h[8841];N=+h[8872];D=D+1|0;la=ma}c[17676]=B+1;ia=+h[8841];ja=pa;ka=oa}N=+h[8871];L=ka*N*ka;h[8888]=L;J=ja*N*ja;h[8889]=J;h[8848]=J+(L+ia*(+h[8904]+ia*N));N=+h[8869];h[70792>>3]=N*ka*ia;h[70800>>3]=N*ja*ia;h[70808>>3]=L-J;h[70816>>3]=ka*ja;la=70824|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[17676]=10;la=c[d>>2]|0;c[17680]=1;if((la|0)>=1){D=1;while(1){h[8888]=0.0;h[8889]=0.0;h[8890]=0.0;A=c[b>>2]|0;c[17676]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[8888]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[8889]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[8890]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[17676]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[8894]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[8888]*+h[8890];h[t+(U+D<<3)>>3]=+h[8889]*+h[8890];J=+h[8888];L=+h[8889];h[t+(P+D<<3)>>3]=+h[8894]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[8871]*+h[8888]*+h[8889];na=D+1|0;c[17680]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[17676]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[17688]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[17676]=B;if((la|0)<(D|0)){la=B}else{break}}}c[17684]=1;la=1;do{D=c[d>>2]|0;c[17692]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[17692]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[17680]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[17680]=D+1}na=c[17750]|0;c[17678]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[8868]=0.0;ma=c[d>>2]|0;c[17680]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[8868]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[17680]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[8868]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[17680]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[8868];Ca=Ca+1|0}c[17680]=ta+1}Ca=B+1|0;c[17678]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[17680]=1;if((A|0)<1){break}else{Ea=1}while(1){h[8868]=0.0;B=c[b>>2]|0;c[17678]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[8868]=N;Ca=na+1|0;c[17678]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[17680]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[17678]=1;if((A|0)>=1){ta=1;while(1){h[8868]=0.0;c[17676]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[8868]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[17676]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[17678]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[17684]=la;}while((la|0)<6);la=c[l>>2]|0;c[17680]=1;h[8868]=0.0;c[17676]=1;L=+h[8871];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[70864+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[70864+(A+ -1<<3)>>3]+L;h[8868]=L;A=A+1|0;}while((A|0)<6);h[8848]=+h[8848]- +h[8858]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[8888]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[8889]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[8890]=O;h[70792>>3]=+h[70792>>3]-J-N*(O+K);h[70824>>3]=+h[70824>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[8888]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[8889]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[8890]=J;h[70800>>3]=+h[70800>>3]-O-N*(K-J);h[70832>>3]=+h[70832>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[8888]=J;h[70808>>3]=+h[70880>>3]+(+h[70808>>3]-J- +h[70872>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[8888]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[8889]=K;Oa=+h[8871];h[70816>>3]=+h[70816>>3]-J-K*Oa;h[70840>>3]=+h[70840>>3]- +h[70888>>3]+ +h[70896>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[8888]=K;h[70848>>3]=+h[70848>>3]-Oa*K;h[8868]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[17680]=la+1;c[17676]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[70864+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[70864+(ta+ -1<<3)>>3]+N;h[8868]=N;ta=ta+1|0;c[17676]=ta;}while((ta|0)<6);K=+h[8876];h[8878]=K*+h[8848]+ +h[8858]+N;J=+h[8869];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[8888]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[8889]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[8890]=R;T=R+(K*+h[70792>>3]+O+S);h[71032>>3]=T;O=K*+h[70824>>3]+S-R;h[71064>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[8888]=R;S=+h[I>>3]*+h[ma>>3];h[8889]=S;Z=+h[Ma>>3]*+h[Na>>3];h[8890]=Z;h[71040>>3]=K*+h[70800>>3]+R+S-Z;h[71072>>3]=K*+h[70832>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[8888]=Z;R=+h[70872>>3]+(Z+K*+h[70808>>3])- +h[70880>>3];h[71048>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[8888]=Z;h[71056>>3]=Z+K*+h[70816>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[70840>>3]+ +h[70888>>3]- +h[70896>>3];h[71080>>3]=J;h[71088>>3]=+h[8876]*+h[70848>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[8878]+T+R+O+J;h[8868]=K;h[8898]=K;h[8899]=K;c[17782]=0;J=+h[8896]/50.0;h[8872]=J;h[8858]=+h[8857];c[17676]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[70872>>3]=Z;W=+Y(+Pa);h[70880>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[70864+(Ma+ -1<<3)>>3]=Z;Q=+h[70872>>3]*G+ +h[70880>>3]*W;h[70864+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[70880>>3];ca=+h[70872>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[71024+(Ma<<3)>>3]*+h[70864+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[8899]=Ra;c[17782]=Na;h[8888]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[8889]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[17678]=10;h[8868]=Ra;h[8877]=Pa;h[8902]=O;c[17676]=50;if((Xa|0)==49){h[8889]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[8888]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[8874]=0.0;if(Ya!=Za){S=Ya-Ua;h[8888]=S;T=Za-Ua;h[8889]=T;R=+h[8871]*(S-T)/(S+T);h[8874]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[8877]=R;T=+X(+R);h[70872>>3]=T;S=+Y(+R);h[70880>>3]=S;c[17678]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[70864+(Na+ -1<<3)>>3]=T;W=+h[70872>>3]*G+ +h[70880>>3]*S;h[70864+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[70880>>3];N=+h[70872>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[8899]=0.0;c[17678]=1;Na=1;do{ma=Na+ -1|0;Ma=70864+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[70784+(ma<<3)>>3]*+h[Ma>>3];h[8899]=+h[8899]+ +h[71024+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[17678]=10;Na=c[l>>2]|0;c[17680]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[70864+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[17678]=6;c[17680]=Na+1}h[8867]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[8841]=0.0;h[8888]=0.0;h[8889]=0.0;Ma=c[b>>2]|0;c[17676]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[70872>>3]*+h[la>>3]+ +h[70880>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[8841]=+h[8841]+G*G;bb=+h[8888]+ +h[la>>3]*+h[ta>>3];h[8888]=bb;G=+h[ta>>3];cb=+h[8889]+G*G;h[8889]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[17676]=Ma+1;$a=cb;ab=bb}ma=c[17774]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[8900];S=+h[8898];h[8900]=G>=S?G:S}S=+h[8899];if(!(S>=0.0)){db=-S}else{db=S}G=+h[8900];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[8900]=S;c[17676]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[8872]=N;R=+h[8867]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[8876];la=ta+1|0;c[17676]=la;if((ta|0)>=(Na|0)){break b}S=+h[8889];G=+h[8888];ta=la}}}while(0);Na=c[d>>2]|0;c[17680]=1;if((Na|0)>=1){Ma=1;while(1){h[8868]=0.0;ta=c[b>>2]|0;c[17678]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[8868]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[17678]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[8867]*+h[p+(la+ -1+Ma<<3)>>3]- +h[8876]*+h[q+(Ma+ -1<<3)>>3]);h[8872]=G;c[17676]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[8872];I=I+1|0}c[17676]=la+1}I=Ma+1|0;c[17680]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[8847]=0.0;h[8843]=0.0;Ma=c[b>>2]|0;c[17676]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[8847]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[8843]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[17676]=Ma+1;hb=kb;ib=jb}S=+h[8841];G=S*ib-hb*hb;h[8892]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[70760]=1;C=c[l>>2]|0;c[17680]=1;if((C|0)<1){lb=70856;mb=+h[8857];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[70864+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[17678]=6;c[17680]=C+1;lb=70856;mb=+h[8857];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function tB(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[8924]=.5;h[8920]=1.0;h[8936]=6.283185307179586;z=+h[n>>3];h[8933]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[17854]=A;c[17862]=0;B=c[d>>2]|0;c[17814]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[17814]=B+1}c[17812]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[8925]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[8925]=F;G=F}else{G=z}H=c[d>>2]|0;c[17814]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[8925];I=I+1|0}c[17814]=H+1}I=B+1|0;c[17812]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[8908]=0.0;D=c[b>>2]|0;c[17810]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[8908]=+h[8908]+G*G;A=p+1|0;c[17810]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[17814]=1;if((p|0)>=1){D=1;while(1){h[8925]=0.0;h[8923]=0.0;y=c[b>>2]|0;c[17812]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[8925]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[8923]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[17812]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[8925]=G;h[8923]=+h[g>>3]*L;g=c[b>>2]|0;c[17810]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[8923]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[8925];H=H+1|0}c[17810]=g+1}H=D+1|0;c[17814]=H;if((D|0)<(p|0)){D=H}else{break}}}h[8909]=0.0;h[8911]=0.0;h[8918]=0.0;D=c[b>>2]|0;c[17810]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[8909]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[8911]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[8918]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[17810]=D+1;O=R;P=T;Q=S}S=+h[8908];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[8929]=U;h[8925]=0.0;if(Q*Q>S*.99*O){h[8925]=+h[8920]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[8924]*U*Z);h[8921]=P;if(O*+h[8933]<P*P*.01){h[8925]=+h[8920]}n=c[b>>2]|0;c[17810]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[8929]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[8925]*U;if((D|0)>=(n|0)){break}e=D;P=+h[8929];D=D+1|0;p=e}c[17810]=n+1;_=0}while(1){n=_+1|0;c[17862]=n;h[8908]=0.0;h[8911]=0.0;h[8912]=0.0;p=c[b>>2]|0;c[17810]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[8908]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[8911]=da;Z=+h[H>>3];ea=P+Z*Z;h[8912]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[17810]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[8925]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[8930]=U;D=c[b>>2]|0;c[17810]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[8930];U=+h[8911];O=+h[8908];g=g+1|0;H=e}c[17810]=D+1}H=c[d>>2]|0;c[17814]=1;if((H|0)>=1){g=1;while(1){h[8923]=0.0;p=c[b>>2]|0;c[17812]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[8923]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[17812]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[8923]=O;e=c[b>>2]|0;c[17810]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[8923];l=l+1|0}c[17810]=e+1}l=g+1|0;c[17814]=l;if((g|0)<(H|0)){g=l}else{break}}}h[8913]=0.0;h[8914]=0.0;h[8915]=0.0;h[8916]=0.0;h[8917]=0.0;g=c[b>>2]|0;c[17810]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[8913]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[8914]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[8915]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[8916]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[8917]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[17810]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[8924];O=U*na;h[8913]=O;P=U*ma-O;h[8916]=P;Z=O+la+P;h[8937]=Z;h[8939]=Z;h[8938]=Z;c[17864]=0;a[71280]=1;W=+h[8936]/50.0;h[8925]=W;c[17810]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[8939]=wa;c[17864]=p;h[8934]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[8935]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[8928]=ta;h[8919]=ua;h[8922]=va;h[8921]=wa;c[17810]=50;h[8938]=wa;if((za|0)==0){h[8934]=wa;ga=74}else if((za|0)==49){h[8935]=Z;Ba=Z}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[8935]}h[8926]=0.0;S=+h[8934];if(S!=Ba){Q=S-Aa;h[8934]=Q;S=Ba-Aa;h[8935]=S;T=U*(Q-S)/(Q+S);h[8926]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[8928]=T;S=+X(+T);h[8919]=S;Q=+Y(+T);h[8922]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[8921]=T;p=c[b>>2]|0;c[17810]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[8919]*+h[y>>3]+ +h[8922]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[8922];Q=+h[8919];H=H+1|0;g=e}c[17810]=p+1;Da=+h[8921]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[8937];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function uB(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[71736]=1;a[71728]=1;c[71748>>2]=6;eT(71744)|0;e=c[d>>2]|0;c[17930]=1;if((e|0)>=1){d=1;do{vS(71864,b+(d+ -1)|0,1)|0;o=c[17930]|0;d=o+1|0;c[17930]=d;}while((o|0)<(e|0))}OS()|0;e=c[g>>2]|0;if((e|0)==1){c[71772>>2]=a[71728]&1?6:0;eT(71768)|0;vS(71864,h,4)|0;OS()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[71796>>2]=a[71728]&1?6:0;eT(71792)|0;vS(71864,h,4)|0;vS(71864,j,4)|0;OS()|0}j=c[k>>2]|0;if((j|0)==1){c[71820>>2]=a[71728]&1?6:0;eT(71816)|0;vS(71864,l,8)|0;OS()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[71844>>2]=a[71728]&1?6:0;eT(71840)|0;vS(71864,l,8)|0;vS(71864,m,8)|0;OS()|0}if((c[f>>2]|0)==2){dS(71872,0)|0}else{i=n;return 0}return 0}function vB(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==0){c[17972]=2;C=2;while(1){D=C+1|0;if(!((c[k+(C+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[17972]=D;if((D|0)<12){C=D}else{break}}if((c[d>>2]|0)<1){kS(71944,73640,80,25);C=72248;D=72256;uB(71944,73672,72424,C,72328,d,C,C,D,D,80)|0;break}c[18036]=5;D=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{C=c[D>>2]|0;c[18036]=C;if(!((C+ -1|0)>>>0>4)){E=C;break}kS(71944,73680,80,34);C=72248;F=72256;uB(71944,73720,72416,C,72328,72144,C,C,F,F,80)|0;break a}}while(0);c[D>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;C=fa(F,F)|0;c[18022]=C;c[18034]=C+50+(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0);C=q+12|0;if((c[k+16>>2]|0)==0){c[C>>2]=2;break}else{c[C>>2]=1;break}}else{C=c[q>>2]|0;do{if((C|0)>=0){F=c[d>>2]|0;if((C|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){kS(71944,74504,80,52);I=72248;J=72256;uB(71944,74488,74560,I,72328,G,I,I,J,J,80)|0;break a}c[18022]=fa((C<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[D>>2]|0)+4|0,H)|0;c[18034]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[18022]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[18034]=F+(c[18022]|0);break b}}}while(0);kS(71944,74432,80,52);C=72248;F=72256;uB(71944,74488,74496,C,72328,q,C,C,F,F,80)|0;break a}}while(0);c[18026]=(c[d>>2]|0)+20;c[q+64>>2]=c[18022];if((c[p>>2]|0)<(c[18034]|0)){kS(71944,73728,80,60);D=72248;F=72256;uB(71944,73792,73800,D,72424,72136,p,D,F,F,80)|0;break}if((c[r>>2]|0)<(c[18026]|0)){kS(71944,73808,80,60);F=72248;D=72256;uB(71944,73792,73872,F,72424,72104,r,F,D,D,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){kS(71944,74616,80,24);D=72328;F=72248;C=72256;uB(71944,74648,74656,D,D,w,F,F,C,C,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[9008]=K;if(!(K<=0.0)){break}kS(71944,74112,80,28);C=72248;uB(71944,72824,74144,C,C,C,C,72328,72064,72256,80)|0;break a}}while(0);c[q+60>>2]=0;C=q+36|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[n>>2]=1;B=27}else if((A|0)==-1){kS(71944,72176,80,49);C=72248;F=72256;uB(71944,72232,72240,C,C,C,C,C,F,F,80)|0;kS(71944,72264,80,47);F=72248;C=72256;uB(71944,72312,72320,F,72328,n,F,F,C,C,80)|0;kS(71944,72336,80,41);C=72248;F=72256;uB(71944,72384,72392,72328,C,C,C,C,F,F,80)|0;i=y;return 0}else{B=210}}while(0);c:do{if((B|0)==27){a[72120]=0;K=+h[l>>3];h[9019]=K;L=+h[m>>3];h[9012]=L;A=c[d>>2]|0;c[17972]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[9019]=O;P=+h[m+(F<<3)>>3];h[9012]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[72120]=1;S=1}else{S=p}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}F=E+1|0;c[17972]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[17982]=p;r=p+(c[w>>2]|0)|0;c[17984]=r;p=r+(c[w>>2]|0)|0;c[18006]=p;F=p+(c[w>>2]|0)|0;c[17976]=F;C=F+(c[d>>2]|0)|0;c[18012]=C;D=C+(c[d>>2]|0)|0;c[18018]=D;c[18008]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+D;c[18032]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){C=o+64|0;h[9021]=+h[C>>3];a[72056]=0;h[8990]=+h[o+24>>3];J=o+16|0;h[8985]=+h[J>>3];do{if((c[w>>2]|0)!=0){wB(72424,v,w,d,71920,j,f,o+(F+ -1<<3)|0,o+(D+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,72040,C,0,o,q,s,t)|0;if((c[18102]|0)>0){i=y;return 0}if((c[18010]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=72328;TB(d,o+((c[17976]|0)+ -1<<3)|0,G,g,G)|0;a[72056]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[8985];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[8985]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[8985];if((M-N)*P>0.0){B=220;break}C=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[9020]=O;U=+h[8990];V=U-O;G=V*P>0.0;do{if(C){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[18018]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){BB(71920,j,f,g,d,H,I,X)|0;if((c[18102]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[72056]=1;B=197;break d}}else{Y=71920;BB(Y,Y,f,g,d,H,I,X)|0;if((c[18102]|0)>0){i=y;return 0}else{h[e>>3]=+h[8990];c[n>>2]=1;a[72056]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}BB(71920,j,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[72056]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[9021]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[8985]=W;h[J>>3]=W;break}BB(71920,72160,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[9020];a[72056]=1;B=197;break d}}else{W=+h[8990];if(!C){if(P*(W-N)<0.0){break}BB(71920,j,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[72056]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[18018]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){BB(71920,j,f,g,d,G,X,I)|0;if((c[18102]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[72056]=1;B=197;break d}}else{H=71920;BB(H,H,f,g,d,G,X,I)|0;if((c[18102]|0)>0){i=y;return 0}else{h[e>>3]=+h[8990];c[n>>2]=1;a[72056]=1;B=197;break d}}}}while(0);if(a[72056]&1){B=197}else{B=128}}else{h[8990]=+h[e>>3];c[n>>2]=1;yB(d,k+4|0,l,m,f,o+((c[18012]|0)+ -1<<3)|0,s,t)|0;C=c[d>>2]|0;c[17972]=1;e:do{if((C|0)>=1){J=c[18012]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[17972]=X;if((I|0)<(C|0)){I=X}else{break e}}kS(71944,74248,80,39);I=72248;J=72256;uB(71944,73920,74288,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+FB(72400,1);h[9021]=U;C=o+64|0;h[C>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[9021]*4.0*(aa>=ba?aa:ba);h[9010]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){kS(71944,74296,80,60);J=72248;uB(71944,73792,74360,J,J,J,J,72424,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[8989]=ca*.001;U=+zB(d,g,o+((c[18012]|0)+ -1<<3)|0,s,t);if(U>.5/+h[8989]){h[8989]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+hS(71912,z);h[8989]=U;da=U}else{U=+h[o+16>>3];h[8989]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}kS(71944,74200,80,29);J=72248;I=72256;uB(71944,74232,74240,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[8989]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[9020]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[8989]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{AB(71920,f,g,d,b,u,71912,o+((c[18012]|0)+ -1<<3)|0,n,s,t,o+((c[18018]|0)+ -1<<3)|0,o+400|0,o+((c[17976]|0)+ -1<<3)|0,o+((c[18008]|0)+ -1<<3)|0,q,72080,C,k+36|0,72128)|0;if((c[18102]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[8989]}h[8985]=ja;h[o+16>>3]=ja;J=c[18018]|0;X=(c[d>>2]|0)+J|0;c[18028]=X;G=c[d>>2]|0;c[17972]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[8985]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[17972]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[8985];h[o+232>>3]=+h[8985]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}wB(72328,v,w,d,e,j,f,o+((c[17976]|0)+ -1<<3)|0,o+((c[18018]|0)+ -1<<3)|0,J,Y,o+((c[17982]|0)+ -1<<3)|0,o+((c[17984]|0)+ -1<<3)|0,o+((c[18006]|0)+ -1<<3)|0,x,72040,C,0,o,q,s,t)|0;if((c[18102]|0)>0){i=y;return 0}if((c[18010]|0)!=0){kS(71944,74664,80,47);la=72248;ma=72256;uB(71944,72312,74712,72328,la,la,la,la,ma,ma,80)|0;kS(71944,74720,80,38);ma=72248;la=72256;uB(71944,72472,74712,72328,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}wB(72416,v,w,d,71920,j,f,o+((c[17976]|0)+ -1<<3)|0,o+((c[18018]|0)+ -1<<3)|0,J,Y,o+((c[17982]|0)+ -1<<3)|0,o+((c[17984]|0)+ -1<<3)|0,o+((c[18006]|0)+ -1<<3)|0,x,72040,C,0,o,q,s,t)|0;if((c[18102]|0)>0){i=y;return 0}if((c[18010]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=72328;TB(d,o+((c[17976]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){kS(71944,74040,80,54);p=72248;uB(71944,74096,74104,p,p,p,p,72424,72160,j,80)|0;break c}else if((B|0)==220){kS(71944,74152,80,34);p=72248;uB(71944,73720,74192,p,p,p,p,72424,j,e,80)|0;break c}else if((B|0)==224){kS(71944,74368,80,49);p=72248;uB(71944,72232,74424,p,p,p,p,72424,72160,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;yB(d,oa,l,m,o+((c[18018]|0)+ -1<<3)|0,o+((c[18012]|0)+ -1<<3)|0,s,t)|0;if((c[18102]|0)>0){B=233;break}p=c[d>>2]|0;c[17972]=1;r=c[18012]|0;if((p|0)>=1){E=1;while(1){D=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){B=136;break f}c[17972]=D;if((E|0)<(p|0)){E=D}else{break}}}O=+zB(d,o+((c[18018]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[9021];pa=O*V;h[8987]=pa;if(!(pa<=1.0)){B=138;break}O=+h[8990];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[9010]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[8985];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[8985]=V/O}}while(0);CB(71920,f,g,d,b,u,71880,o+((c[18012]|0)+ -1<<3)|0,k,n,s,t,o+((c[18018]|0)+ -1<<3)|0,o+400|0,o+((c[17976]|0)+ -1<<3)|0,o+((c[18008]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,72080,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,72128)|0;if((c[18102]|0)>0){B=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){wB(72416,v,w,d,71920,j,f,o+((c[17976]|0)+ -1<<3)|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[17982]|0)+ -1<<3)|0,o+((c[17984]|0)+ -1<<3)|0,o+((c[18006]|0)+ -1<<3)|0,x,72040,o+64|0,0,o,q,s,t)|0;if((c[18102]|0)>0){B=233;break f}if((c[18010]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=72328;TB(d,o+((c[17976]|0)+ -1<<3)|0,r,g,r)|0;B=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[8990];V=+h[8985];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){B=128;continue}BB(71920,j,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}BB(71920,j,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(r){if(U>=0.0){BB(71920,j,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[9020];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[9021]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}BB(71920,72160,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[9020];B=197;continue}if(!(U<0.0)){BB(71920,j,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[9020];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[9021]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[8985]=U-O;B=128;continue}else{BB(71920,72160,f,g,d,q+28|0,o+((c[18018]|0)+ -1<<3)|0,o+224|0)|0;if((c[18102]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[9020];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[8990];h[o+16>>3]=+h[8985];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[8987]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[17972]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){C=l+(p<<3)|0;h[C>>3]=O*+h[C>>3];C=m+(E+ -1<<3)|0;h[C>>3]=+h[8987]*+h[C>>3];if((E|0)>=(r|0)){break}C=E;O=+h[8987];E=E+1|0;p=C}c[17972]=r+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);p=0-na|0;c[18028]=p;switch(p|0){case 2:{kS(71944,72560,80,47);p=72248;uB(71944,72312,72608,p,p,p,p,72328,71920,72256,80)|0;kS(71944,72616,80,48);p=72248;E=72256;uB(71944,72544,72672,p,p,p,p,p,E,E,80)|0;kS(71944,72680,80,45);E=72248;p=72256;uB(71944,72728,72736,E,E,E,E,E,p,p,80)|0;break};case 3:{kS(71944,72744,80,38);p=72248;uB(71944,72472,72784,p,p,p,p,72328,71920,72256,80)|0;kS(71944,72792,80,28);p=72248;E=72256;uB(71944,72824,72832,p,p,p,p,p,E,E,80)|0;break};case 6:{kS(71944,72840,80,44);E=72248;uB(71944,72888,72896,E,E,E,E,72424,71920,71880,80)|0;kS(71944,72904,80,57);E=72248;p=72256;uB(71944,72968,72976,E,E,E,E,E,p,p,80)|0;break};case 7:{kS(71944,72840,80,44);p=72248;uB(71944,72888,72984,p,p,p,p,72424,71920,71880,80)|0;kS(71944,72992,80,48);p=72248;E=72256;uB(71944,72544,73048,p,p,p,p,p,E,E,80)|0;kS(71944,73056,80,28);E=72248;p=72256;uB(71944,72824,73088,E,E,E,E,E,p,p,80)|0;break};case 8:{kS(71944,72840,80,44);p=72248;uB(71944,72888,73096,p,p,p,p,72424,71920,71880,80)|0;kS(71944,73104,80,37);p=72248;E=72256;uB(71944,73144,73152,p,p,p,p,p,E,E,80)|0;break};case 9:{kS(71944,72840,80,44);E=72248;uB(71944,72888,73160,E,E,E,E,72424,71920,71880,80)|0;kS(71944,73168,80,49);E=72248;p=72256;uB(71944,72232,73224,E,E,E,E,E,p,p,80)|0;kS(71944,73232,80,38);p=72248;E=72256;uB(71944,72472,73272,p,p,p,p,p,E,E,80)|0;break};case 10:{kS(71944,72840,80,44);E=72248;uB(71944,72888,73280,E,E,E,E,72424,71920,71880,80)|0;kS(71944,73288,80,45);E=72248;p=72256;uB(71944,72728,73336,E,E,E,E,E,p,p,80)|0;kS(71944,73344,80,36);p=72248;E=72256;uB(71944,73384,73392,p,p,p,p,p,E,E,80)|0;break};case 11:{kS(71944,73400,80,40);E=72248;uB(71944,73448,73456,E,E,E,E,72424,71920,71880,80)|0;kS(71944,73464,80,36);E=72248;p=72256;uB(71944,73384,73504,E,E,E,E,E,p,p,80)|0;break};case 12:{kS(71944,72840,80,44);p=72248;uB(71944,72888,73512,p,p,p,p,72424,71920,71912,80)|0;kS(71944,73520,80,45);p=72248;E=72256;uB(71944,72728,73568,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{kS(71944,72432,80,38);E=72248;uB(71944,72472,72480,E,E,E,E,72328,71920,72256,80)|0;kS(71944,72488,80,48);E=72248;p=72256;uB(71944,72544,72552,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[8990];h[o+24>>3]=+h[8990];h[o+16>>3]=+h[8985];i=y;return 0}else if((B|0)==215){kS(71944,73880,80,39);p=72248;E=72256;uB(71944,73920,73928,p,p,p,p,p,E,E,80)|0;break c}else if((B|0)==216){kS(71944,73936,80,39);E=72248;p=72256;uB(71944,73920,73976,E,E,E,E,E,p,p,80)|0;break c}}}while(0);kS(71944,73984,80,47);A=72248;p=72256;uB(71944,72312,74032,A,A,A,A,A,p,p,80)|0}else if((B|0)==210){kS(71944,73576,80,55);p=72248;A=72256;uB(71944,73632,72328,p,p,p,p,p,A,A,80)|0}}while(0);if((B|0)==227){kS(71944,74568,80,39);B=72248;uB(71944,73920,74608,B,B,B,B,72424,j,e,80)|0}if((c[k>>2]|0)==-1){kS(71944,74760,80,46);e=72248;j=72256;uB(71944,74808,74816,e,e,e,e,e,j,j,80)|0;kS(71944,74824,80,47);j=72248;e=72256;uB(71944,72312,74872,72328,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function wB(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[9360]=C;c[t>>2]=0;D=c[e>>2]|0;c[18722]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[18722]|0;E=F+1|0;c[18722]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[9367]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;BB(g,b,k,l,f,o,m,n)|0;if((c[18102]|0)>0){i=v;return 0}D=d;ee[D&7](f,b,k,e,p,y,z)|0;if((c[18102]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[74944]=0;F=c[e>>2]|0;c[18722]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[74944]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[18722]=F+1;if(!M){break}I=+hS(74936,74880);h[9364]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[9360];do{if((H- +h[g>>3])*I<0.0){BB(g,b,k,l,f,o,m,n)|0;if((c[18102]|0)<=0){break}i=v;return 0}else{G=+h[9364]/I;h[9365]=G;N=c[f>>2]|0;c[18722]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[9365];Q=Q+1|0}c[18722]=N+1}}while(0);ee[D&7](f,b,k,e,p,y,z)|0;if((c[18102]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[74944]=0;F=c[e>>2]|0;c[18722]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[74944]=1;V=1;W=c[18722]|0}Q=W+1|0;c[18722]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[9360];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;BB(g,F,k,l,f,o,m,n)|0;if((c[18102]|0)>0){i=v;return 0}E=d;ee[E&7](f,F,k,e,p,y,z)|0;if((c[18102]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[74944]=0;D=c[e>>2]|0;c[18722]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[74944]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[18722]=D+1;if(!aa){i=v;return 0}I=+hS(74936,74880);h[9364]=I;h[F>>3]=I+ +h[F>>3];I=+h[9364]/+h[9360];h[9365]=I;Q=c[f>>2]|0;c[18722]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[9365];R=R+1|0}c[18722]=Q+1}ee[E&7](f,F,k,e,p,y,z)|0;if((c[18102]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[74944]=0;R=c[e>>2]|0;c[18722]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[74944]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[18722]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[9363]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}BB(g,74904,k,l,f,o,m,n)|0;if((c[18102]|0)<=0){break}i=v;return 0}else{h[9363]=Y;j=c[f>>2]|0;c[18722]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[18722]=j+1}}while(0);ga=d;ee[ga&7](f,74904,k,e,q,y,z)|0;if((c[18102]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[18732]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){xB(e,74936,74928,R,74904,p,q,r,74896,s,fa,da,x,ca)|0;if((c[18102]|0)>0){ha=76;break}if((c[18732]|0)>1){ha=73;break}BB(g,74896,k,l,f,o,m,n)|0;if((c[18102]|0)>0){ha=76;break}ee[ga&7](f,74896,k,e,r,y,z)|0;if((c[18102]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[9362];R=72328;TB(e,r,R,p,R)|0;if((c[18732]|0)==4){i=v;return 0}BB(g,74896,k,l,f,o,m,n)|0;if((c[18102]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}



function iD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){C2(c[e+(h*40|0)+20>>2]|0);C2(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;mD(k)|0;C2(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){vz(c[a+536>>2]|0,93312,d)}else if((j|0)==6){i=b;return 0}return 0}function jD(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;if((c[b+296>>2]|0)==1){f=c[b+484>>2]|0;a[f+(d*40|0)+36|0]=oD(b,d)|0;i=e;return 0}else{vz(c[b+536>>2]|0,93312,e)}return 0}function kD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[61180>>2]|c[15276]|0)==0){z=w;A=1;break}TR(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tz(17,1,93344,g);TR(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;TR(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;tz(17,0,93376,f);TR(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ie[c[15416]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function lD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=B2(20)|0;c[b>>2]=f;uz(0,(f|0)!=0|0,93384,e);e=B2(a)|0;c[f>>2]=e;e=B2(a)|0;c[f+4>>2]=e;e=B2(a)|0;c[f+8>>2]=e;e=B2(a)|0;c[f+16>>2]=e;uz(0,(c[b>>2]|0)!=0|0,93416,d);i=d;return 0}function mD(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;C2(c[d>>2]|0);C2(c[d+4>>2]|0);C2(c[d+8>>2]|0);C2(c[d+16>>2]|0);i=b;return 0}function nD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=(c|0)>0;a:do{if(e){f=0;g=0;do{g=((a[b+f|0]|0)==1)+g|0;f=f+1|0;}while((f|0)<(c|0));f=c+ -1|0;if(e){h=f}else{j=f;k=f;l=g;break}while(1){m=h+ -1|0;if((a[b+h|0]|0)!=0){j=f;k=h;l=g;break a}if((h|0)>0){h=m}else{j=f;k=m;l=g;break}}}else{g=c+ -1|0;j=g;k=g;l=0}}while(0);if((l|0)==(c|0)){n=0;i=d;return n|0}if((k|0)==-1){a[b]=1;n=1;i=d;return n|0}if((k|0)<(j|0)){a[b+k|0]=0;a[b+(k+1)|0]=1;n=1;i=d;return n|0}k=c+ -2|0;b:do{if((k|0)>-1){h=0;e=k;g=1;while(1){o=0;p=e;while(1){q=b+p|0;if((a[q]|0)!=0){break}if((p|0)>0){o=o+1|0;p=p+ -1|0}else{break b}}r=p+1|0;if((a[b+r|0]|0)==0){break}if((p|0)>0){h=h+1|0;e=p+ -1|0;g=g+1|0}else{break b}}f=r+g|0;a[q]=0;if((p|0)<(f|0)){h3(b+(e+1-o)|0,1,h+2|0)|0}if((f|0)>=(j|0)){n=1;i=d;return n|0}h3(b+(h+3+e-o)|0,0,c+ -3-h-e+o|0)|0;n=1;i=d;return n|0}}while(0);if((l|0)>=0){h3(b|0,1,l+1|0)|0}if((l|0)>=(j|0)){n=1;i=d;return n|0}h3(b+(l+1)|0,0,j-l|0)|0;n=1;i=d;return n|0}function oD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0;e=i;i=i+16|0;f=e;g=c[b+484>>2]|0;j=c[g+(d*40|0)+28>>2]|0;l=c[g+(d*40|0)+4>>2]|0;m=b+4|0;n=j+16|0;o=g+(d*40|0)|0;h3(c[n>>2]|0,0,c[o>>2]|0)|0;p=c[o>>2]|0;q=g+(d*40|0)+20|0;if((p|0)>0){r=j+8|0;s=0;while(1){a[(c[r>>2]|0)+s|0]=a[c[(c[q>>2]|0)+(s<<2)>>2]|0]|0;t=s+1|0;u=c[o>>2]|0;if((t|0)<(u|0)){s=t}else{v=u;break}}}else{v=p}p=g+(d*40|0)+12|0;s=b;r=g+(d*40|0)+16|0;u=g+(d*40|0)+8|0;t=j+4|0;w=g+(d*40|0)+24|0;d=v;v=0;a:while(1){if((d|0)>0){g=0;do{a[(c[j>>2]|0)+g|0]=a[c[(c[q>>2]|0)+(g<<2)>>2]|0]|0;g=g+1|0;}while((g|0)<(c[o>>2]|0))}ie[c[p>>2]&255](s);ie[c[r>>2]&255](s);if((c[o>>2]|0)>0){g=0;do{a[(c[t>>2]|0)+g|0]=a[c[(c[q>>2]|0)+(g<<2)>>2]|0]|0;g=g+1|0;}while((g|0)<(c[o>>2]|0))}g=a[u]|0;if((OC(b)|0)<<24>>24==0){x=g;y=v}else{LC(b);ie[c[r>>2]&255](s);x=(v|0)>200?-4:g;y=v+1|0}if((x|0)==-1){z=24;break}g=c[o>>2]|0;if((g|0)<=0){z=21;break}A=c[j>>2]|0;B=c[t>>2]|0;C=0;while(1){D=C+1|0;if((a[A+C|0]|0)!=(a[B+C|0]|0)){break}if((D|0)<(g|0)){C=D}else{z=21;break a}}if((nD(c[n>>2]|0,g)|0)<<24>>24==0){z=19;break}C=c[o>>2]|0;if((C|0)>0){B=0;while(1){a[c[(c[q>>2]|0)+(B<<2)>>2]|0]=(a[c[(c[w>>2]|0)+(B<<2)>>2]|0]|0)!=(a[(c[n>>2]|0)+B|0]|0)|0;A=B+1|0;D=c[o>>2]|0;if((A|0)<(D|0)){B=A}else{E=D;break}}}else{E=C}d=E;v=y+1|0}do{if((z|0)==19){if((a[b+312|0]|0)==0){F=+h[c[c[m>>2]>>2]>>3];c[f>>2]=l;y=f+4|0;h[k>>3]=F;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];tz(1,0,93464,f)}a[b+315|0]=1;z=24}else if((z|0)==21){if((c[61180>>2]|0)==0){G=1}else{H=1;break}i=e;return G|0}}while(0);do{if((z|0)==24){if((c[61180>>2]|0)==0){G=0}else{H=0;break}i=e;return G|0}}while(0);ie[c[15416]&255](17);G=H;i=e;return G|0}function pD(a,b){a=a|0;b=b|0;b=i;i=i+8|0;vz(c[a+536>>2]|0,93528,b);return 0}function qD(a){a=a|0;a=i;i=i+8|0;vz(0,93528,a);return 0}function rD(a,b){a=a|0;b=b|0;b=i;i=i+8|0;vz(c[a+536>>2]|0,93528,b);return 0}function sD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=B2(l)|0;c[e+(h<<6)+36>>2]=B2(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=B2(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;yD(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;BD(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){vz(c[a+536>>2]|0,93568,d)}else if((n|0)==8){i=b;return 0}return 0}function tD(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function uD(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;wb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function vD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){C2(c[e+(h<<6)+28>>2]|0);C2(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){CD(e+(h<<6)+24|0)|0}else if((j|0)==1){zD(e+(h<<6)+24|0)|0;C2(c[e+(h<<6)+32>>2]|0)}else{k=6;break}C2(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){vz(c[a+536>>2]|0,93568,d)}else if((k|0)==8){i=b;return 0}return 0}function wD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==2){j=DD(b,d)|0}else if((h|0)==1){j=AD(b,d)|0}else{vz(c[b+536>>2]|0,93568,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function xD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[61172>>2]|c[15276]|0)==0){z=w;A=1;break}TR(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tz(15,1,93600,g);TR(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;TR(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;tz(15,0,93632,f);TR(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ie[c[15416]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function yD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=B2(12)|0;f=B2(a<<2)|0;c[e>>2]=f;uz(0,(f|0)!=0|0,93640,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function zD(a){a=a|0;var b=0;b=i;C2(c[c[a>>2]>>2]|0);i=b;return 0}function AD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;h3(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;je[c[x>>2]&127](C,D);je[c[w+(d<<6)+4>>2]&127](C,D);if((c[61176>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;rz(16,1,93696,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];jc(D|0,93720,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;rz(16,0,93736,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;rz(16,1,93744,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];jc(D|0,93720,o|0)|0;c[n>>2]=D;rz(16,0,93736,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;rz(16,1,93744,s)}}while(0);ie[c[15416]&255](16)}s=w+(d<<6)+36|0;A=y+8|0;au(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;tz(1,0,93760,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;f3(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;f3(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;tz(1,0,93848,l);if((c[61172>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;f3(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];jc(l|0,93952,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];jc(l|0,93952,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;f3(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];jc(l|0,93952,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;f3(M|0,O|0,Q|0)|0;i=e;return F|0}function BD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=B2(32)|0;uz(0,(g|0)!=0|0,93960,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;$d(0,d|0)|0;Qd(c[d>>2]|0,c[b>>2]|0,0)|0;$d(0,g+4|0)|0;Qd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;cb(b|0)|0;Mb(94008,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function CD(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Cd(c[d+12>>2]|0)|0;Lb(c[d+8>>2]|0)|0;Lb(c[d+4>>2]|0)|0;i=b;return 0}function DD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;nd(c[g>>2]|0)|0;Xd(0,g|0)|0;j=g+24|0;Qb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;je[c[f>>2]&127](k,a);Xc(c[g>>2]|0,1)|0;Va(c[g>>2]|0)|0;je[c[e+(b<<6)+4>>2]&127](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){id(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(oc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Kb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;nd(c[g>>2]|0)|0;i=d;return l|0}function ED(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;uz(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,94176,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){uz(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,94216,e);if((le[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=B2(p)|0;c[g+(m*80|0)+52>>2]=B2(p)|0;c[g+(m*80|0)+48>>2]=B2(p)|0;c[g+(m*80|0)+16>>2]=B2(p)|0;c[g+(m*80|0)+8>>2]=B2(p)|0;c[g+(m*80|0)+12>>2]=B2(p)|0;je[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){RD(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==2){pD(a,n)|0;break}else if((p|0)==3){RD(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==1){JD(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){vz(c[j>>2]|0,94256,d)}else if((q|0)==14){i=b;return 0}return 0}function FD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;C2(c[e+(h*80|0)+44>>2]|0);C2(c[e+(h*80|0)+52>>2]|0);C2(c[e+(h*80|0)+48>>2]|0);C2(c[e+(h*80|0)+16>>2]|0);C2(c[e+(h*80|0)+8>>2]|0);C2(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;SD(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;SD(m)|0;l=m;break}else if((k|0)==1){m=e+(h*80|0)+40|0;KD(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else{n=9;break a}}}while(0);C2(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){qD(j)|0}else if((n|0)==9){vz(c[a+536>>2]|0,94256,d)}else if((n|0)==11){i=b;return 0}return 0}function GD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(UD(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=LD(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==2){j=(rD(b,d)|0)&255;break}else if((k|0)==3){j=(UD(b,d)|0)&255;break}else{vz(c[b+536>>2]|0,94256,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function HD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;TR(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];sz(17,1,u,94288,m);do{if((a[b+312|0]|0)==0){TR(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;TR(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;tz(17,0,94488,f);TR(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{tz(17,1,94328,l);TR(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;TR(q,d,c[v>>2]|0);if(($2(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];tz(17,0,94408,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;TR(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;tz(17,0,94448,g);G=E}TR(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[61180>>2]|c[15276]|0)==0){break}ie[c[15416]&255](17)}}while(0);if((c[61180>>2]|c[15276]|0)==0){x=1;i=e;return x|0}ie[c[15416]&255](17);x=1;i=e;return x|0}function ID(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function JD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=B2(144)|0;c[b>>2]=f;uz(0,(f|0)!=0|0,94504,e);c[f>>2]=0;e=a<<3;g=B2(e)|0;c[f+4>>2]=g;g=B2(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=B2(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=B2(e)|0;c[f+24>>2]=g;g=D2(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=B2(e)|0;c[f+64>>2]=g;g=B2(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=D2(g,8)|0;c[f+104>>2]=j;j=D2(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=B2(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=B2(e)|0;c[f+124>>2]=j;j=B2(e)|0;c[f+128>>2]=j;j=B2(e)|0;c[f+132>>2]=j;j=B2(e)|0;c[f+136>>2]=j;j=B2(e)|0;c[f+140>>2]=j;uz(0,(c[b>>2]|0)!=0|0,94536,d);i=d;return 0}function KD(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;C2(c[d+4>>2]|0);C2(c[d+16>>2]|0);C2(c[d+12>>2]|0);C2(c[d+24>>2]|0);C2(c[d+28>>2]|0);C2(c[d+64>>2]|0);C2(c[d+68>>2]|0);C2(c[d+104>>2]|0);C2(c[d+108>>2]|0);C2(c[d+116>>2]|0);C2(c[d+124>>2]|0);C2(c[d+128>>2]|0);C2(c[d+132>>2]|0);C2(c[d+136>>2]|0);C2(c[d+140>>2]|0);i=b;return 0}function LD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=B2(c[Y>>2]|0)|0;if((c[61180>>2]|0)!=0){TR(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];rz(17,1,94576,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];rz(17,1,94632,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];rz(17,0,94648,F);ie[c[15416]&255](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}ie[c[15416]&255](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){f3(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{f3(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+wd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;MD($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+wd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[61184>>2]|0)!=0){ND(c[Q>>2]|0,$,18,94688);ND(c[ca>>2]|0,$,18,94720)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[61184>>2]|0)!=0){ND(c[ca>>2]|0,$,18,94752)}a[da]=R;XB(11,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){TR(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];pB(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;MD($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;MD($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}LC(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[61184>>2]|0)!=0){rz(18,1,94792,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];rz(18,1,94832,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];rz(18,0,94864,C);ie[c[15416]&255](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ie[c[15416]&255](18)}if((c[61188>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;rz(19,1,94896,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];jc(Ja|0,94920,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;rz(19,0,94928,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ie[c[15416]&255](19)}h[K>>3]=+WB($,c[Ia>>2]|0);h[J>>3]=+WB($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}f3(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){f3(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{f3(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];rz(17,0,94976,w);OD(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}rz(17,0,95048,v);OD(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){f3(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{f3(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+wd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}rz(17,0,95112,u);OD(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){f3(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{f3(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+wd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}rz(17,0,95184,t);OD(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}f3(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;f3(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}rz(17,0,95248,s);OD(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){f3(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}rz(17,0,95320,r);OD(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){f3(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{f3(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}rz(17,0,95392,q);OD(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){f3(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{f3(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}rz(17,0,95464,p);OD(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){f3(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}rz(17,0,95528,o);OD(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){f3(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{f3(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}rz(17,0,95600,n);OD(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){f3(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{f3(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];rz(17,0,95736,l);OD(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){f3(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{f3(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}rz(17,0,95664,m);OD(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[61180>>2]|0)!=0){rz(17,1,94936,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;rz(17,0,94952,x);ie[c[15416]&255](17);OD(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}f3(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;MD($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;C2(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;C2(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;C2(Z);i=e;return kb|0}if((a[Ha]|0)==0){TR(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];pB(0,f,hb);}if((c[61180>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;rz(17,0,95808,j);OD(S,L,J,K,17)}f3(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;C2(Z);i=e;return kb|0}return 0}function MD(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[61192>>2]|0)!=0){c[u>>2]=c[y+96>>2];rz(20,0,96056,u);ND(d,b,20,96088)}Le[c[x+(m*80|0)+32>>2]&63](l,d,e,j);if((c[61192>>2]|0)!=0){ND(e,b,20,96104);c[t>>2]=c[y+96>>2];rz(20,0,96120,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[61192>>2]|0)!=0){rz(20,0,96160,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){QD(w,f,d,e,m)}else{PD(w,f,m)}do{if((c[61192>>2]|0)!=0){rz(20,0,96200,r);if((c[61188>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;rz(19,1,94896,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];jc(m|0,96232,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;rz(19,0,94928,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}ie[c[15416]&255](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;vz(g,96248,n)}return 0}function ND(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[61112+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;rz(d,1,94928,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];rz(d,0,96040,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}ie[c[15416]&255](d);i=f;return}function OD(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[61112+(f<<2)>>2]|0)==0){i=g;return}rz(f,1,95848,q);rz(f,1,95864,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];rz(f,0,95880,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}ie[c[15416]&255](f);rz(f,1,95920,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];rz(f,0,95936,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}ie[c[15416]&255](f);rz(f,1,95976,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];rz(f,0,95992,j);ie[c[15416]&255](f);ie[c[15416]&255](f);i=g;return}function PD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;h3(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;h3(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}le[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function QD(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+wd(+(n*+wd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;MD(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function RD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=B2(80)|0;c[b>>2]=f;uz(0,(f|0)!=0|0,96328,e);c[f>>2]=0;e=a<<3;g=B2(e)|0;c[f+4>>2]=g;g=B2(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=B2(e)|0;c[f+16>>2]=g;g=D2(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=B2(fa(e,a)|0)|0;c[f+64>>2]=g;g=B2(e)|0;c[f+68>>2]=g;g=B2(a<<2)|0;c[f+72>>2]=g;uz(0,(c[b>>2]|0)!=0|0,96360,d);i=d;return 0}function SD(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;C2(c[d+4>>2]|0);C2(c[d+8>>2]|0);C2(c[d+16>>2]|0);C2(c[d+20>>2]|0);C2(c[d+64>>2]|0);C2(c[d+68>>2]|0);C2(c[d+72>>2]|0);i=b;return 0}function TD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;h3(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}le[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function UD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;f3(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[61180>>2]|0)==0){J=b+4|0}else{TR(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rz(17,1,96400,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];rz(17,1,96472,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];rz(17,0,96488,t);ie[c[15416]&255](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}ie[c[15416]&255](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];VD(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){TR(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];pB(3,g,P);}$=+WB(H,c[b>>2]|0);aa=+WB(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){f3(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;rz(17,0,96664,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;rz(17,0,96720,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;rz(17,0,96784,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[61180>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;rz(17,0,96536,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];rz(17,0,96576,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];rz(17,0,96632,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){TR(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];pB(0,f,L);if((c[61180>>2]|0)==0){da=0;break}c[m>>2]=V;rz(17,0,96864,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rz(17,0,96576,l);if((c[61180>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rz(17,0,96632,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[61180>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;f3(ma|0,oa|0,qa|0)|0;i=e;return da|0}ie[c[15416]&255](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;f3(ma|0,oa|0,qa|0)|0;i=e;return da|0}function VD(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[61184>>2]|0)!=0){c[z>>2]=j;rz(18,0,96904,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];rz(18,0,96952,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){WD(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){XD(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{TD(E,m,r)|0}if((c[61188>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;rz(19,1,96968,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];jc(F|0,96992,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;rz(19,0,97e3,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}ie[c[15416]&255](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+WB(b,_);if(!(!(J<=H)&!(+WB(b,e)<=H))){$=31;break}au(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;tz(17,0,97008,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;tz(17,0,97040,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+WB(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function WD(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Le[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&63](e,a,b,d);i=g;return 0}function XD(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+wd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;WD(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function YD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){we[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==2){ZD(a,b);f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;_D(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==3){f=mC(a,b)|0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function ZD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[97072+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[97072+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];le[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function _D(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function $D(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=Hz(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=B2(88)|0;rz(23,0,97104,e);j=kC(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[794]|0;g=B2(j<<2)|0;c[24282]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=D2(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[24282]|0;g=n}}else if((f|0)==2){g=B2(8)|0;c[g+4>>2]=4;m=B2(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=D2(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);mE(b)|0;if((c[2]|0)==0){i=e;return k|0}fB(6);cB(1);i=e;return k|0}function aE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){f=b+48|0;g=c[f>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){C2(c[g+(j<<2)>>2]|0);k=c[f>>2]|0;l=c[k>>2]|0;if((j|0)<(c[k+4>>2]|0)){j=j+1|0;g=l}else{m=l;break}}}else{m=h}C2(m);C2(c[f>>2]|0)}else if((e|0)==3){lC(c[b+48>>2]|0)|0}else if((e|0)==4){e=c[794]|0;b=c[24282]|0;if((e|0)>0){f=b;m=0;while(1){C2(c[f+(m<<2)>>2]|0);h=m+1|0;g=c[24282]|0;if((h|0)<(e|0)){m=h;f=g}else{n=g;break}}}else{n=b}C2(n)}nE(a)|0;hE(a);i=d;return 0}function bE(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(196,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=q3(c[s>>2]|0,o)|0;if((t|0)==0){fb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=q3(c[s>>2]|0,o)|0;if((B|0)==0){fb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=q3(c[C>>2]|0,o)|0;if((D|0)==0){fb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=q3(c[C>>2]|0,o)|0;if((E|0)==0){fb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=q3(c[s>>2]|0,o)|0;if((F|0)==0){fb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(197,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=q3(c[s>>2]|0,o)|0;if((G|0)==0){fb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=q3(c[s>>2]|0,o)|0;if((H|0)==0){fb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;c3(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=q3(c[L>>2]|0,o)|0;if((M|0)==0){fb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=q3(c[p>>2]|0,o)|0;if((N|0)==0){fb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,97136,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=q3(c[M>>2]|0,o)|0;if((U|0)==0){fb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=q3(c[M>>2]|0,o)|0;if((V|0)==0){fb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,97232,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=q3(c[M>>2]|0,o)|0;if((X|0)==0){fb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[103352>>2]|0,103328,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=q3(c[M>>2]|0,o)|0;if((Y|0)==0){fb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,97288,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=q3(c[M>>2]|0,o)|0;if((Z|0)==0){fb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(198,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=q3(c[M>>2]|0,o)|0;if(($|0)==0){fb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function cE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];rz(8,0,97384,G);I=b+313|0;a[I]=1;KC(b);if((c[118724>>2]|0)==0){je[c[103348>>2]&127](103328,b)}a[I]=0}}while(0);if((e|0)!=0){dE(Dd(e|0)|0,b)}if((c[61212>>2]|0)==0){i=f;return 0}fB(0);rz(25,0,97432,F);rz(25,1,97456,E);H=+ZA(6);J=+ZA(6);K=J/+ZA(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];rz(25,0,97464,D);K=+ZA(1);H=+ZA(1);J=H/+ZA(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];rz(25,0,97504,C);J=+ZA(2);K=+ZA(2);H=K/+ZA(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rz(25,0,97536,B);H=+ZA(3);J=+ZA(3);K=J/+ZA(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];rz(25,0,97560,A);K=+ZA(4);H=+ZA(4);J=H/+ZA(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];rz(25,0,97600,z);J=+ZA(7);K=+ZA(7);H=K/+ZA(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rz(25,0,97632,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+ZA(0);J=H- +ZA(7);H=J- +ZA(4);J=H- +ZA(3);H=J- +ZA(2);J=H- +ZA(1);H=J- +ZA(6);J=+ZA(0);K=J- +ZA(7);J=K- +ZA(4);K=J- +ZA(3);J=K- +ZA(2);K=J- +ZA(1);J=K- +ZA(6);K=J/+ZA(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rz(25,0,97696,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];rz(25,0,97664,x)}K=+ZA(0);H=+ZA(0);J=H/+ZA(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];rz(25,0,97728,v);ie[c[15416]&255](25);rz(25,1,97752,u);c[t>>2]=c[d+40>>2];rz(25,0,97760,t);c[s>>2]=c[d+44>>2];rz(25,0,97784,s);ie[c[15416]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);rz(25,1,97808,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];rz(25,0,97824,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];rz(25,0,97840,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];rz(25,0,97872,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];rz(25,0,97904,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];rz(25,0,97928,m);ie[c[15416]&255](25)}else if((s|0)!=5){rz(25,1,97960,l);rz(25,0,97968,j);ie[c[15416]&255](25)}rz(25,0,98032,g);cB(0);i=f;return 0}function dE(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Zb(b|0,98504)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];zd(b|0,98512,y|0)|0;if((z|0)==0){C=Vd(10,b|0)|0;D=xd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if(($2(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];zd(b|0,98528,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if(($2(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;zd(b|0,98544,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if(($2(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;zd(b|0,98552,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if(($2(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;zd(b|0,98560,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if(($2(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];zd(b|0,98528,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];zd(b|0,98528,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if(($2(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;zd(b|0,98544,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;zd(b|0,98544,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if(($2(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;zd(b|0,98552,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;zd(b|0,98552,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if(($2(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;zd(b|0,98560,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if(($2(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];zd(b|0,98528,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if(($2(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;zd(b|0,98544,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if(($2(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;zd(b|0,98552,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if(($2(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;zd(b|0,98560,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Zb(0,98504)|0;}while((d|0)!=0);C=Vd(10,b|0)|0;D=xd(b|0)|0;i=e;return}function eE(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 5:{tz(1,0,98128,q);v=1;i=m;return v|0};case 4:{w=c[792]|0;if((w|0)!=0){if(($2(w,98168)|0)==0){break a}}rz(23,0,98184,p);v=1;i=m;return v|0};case 11:case 10:case 9:case 6:case 7:case 8:{tz(1,0,98056,r);v=1;i=m;return v|0};case 18:{w=c[792]|0;do{if((w|0)!=0){if(($2(w,98312)|0)!=0){break}c[u>>2]=4;break a}}while(0);rz(23,0,98336,o);v=1;i=m;return v|0};default:{}}}while(0);o=$D(a,s)|0;Fe[c[62260>>2]&7]()|0;do{if((o|0)==0){r=bE(a,b,d,e,f,g)|0;Fe[c[62260>>2]&7]()|0;if((r|0)!=0){x=r;break}if((c[u>>2]|0)!=5){je[c[103348>>2]&127](103328,a);UC(a)}y=+h[a+248>>3];r=n;h[k>>3]=+h[a+240>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+8|0;h[k>>3]=y;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(23,0,98464,n);r=Ae[c[c[a+540>>2]>>2]&127](a,t)|0;Fe[c[62260>>2]&7]()|0;cE(a,s,l)|0;Fe[c[62260>>2]&7]()|0;x=r}else{Fe[c[62260>>2]&7]()|0;x=o}}while(0);aE(a,s)|0;v=x;i=m;return v|0}function fE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){gE(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((le[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){vz(c[a+536>>2]|0,98576,d)}else if((k|0)==6){gE(a);i=b;return}}function gE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;h3(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function hE(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;C2(c[f+(a*48|0)+28>>2]|0);C2(c[f+(a*48|0)+32>>2]|0);C2(c[f+(a*48|0)+16>>2]|0);C2(c[f+(a*48|0)+20>>2]|0);C2(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function iE(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=B2(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=B2(c[y>>2]<<2)|0;jE(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;f3(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;f3(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((jC(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=kE(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){f3(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;f3(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;C2(x);C2(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;tz(5,1,98632,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];jc(q|0,98664,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;tz(5,0,98672,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=61664;K=c[15416]|0;ie[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=98680;aa=$;vz(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];tz(5,0,98672,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=61664;K=c[15416]|0;ie[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=6;_=Z;$=98680;aa=$;vz(O,aa,g);return 0}function jE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;h3(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}le[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function kE(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=D2(d,4)|0;r=D2(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;C2(q);C2(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;C2(q);C2(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){C2(q);C2(r);i=o;return v|0}if((n|0)==0){v=-1;C2(q);C2(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rz(5,1,98784,p);lE(s,d,f,c[g>>2]|0,j,l,m);if((c[61132>>2]|0)==0){v=-1;C2(q);C2(r);i=o;return v|0}ie[c[15416]&255](5);v=-1;C2(q);C2(r);i=o;return v|0}function lE(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;h3(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];rz(5,0,98816,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function mE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=kc(98832,98856)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=fd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;qb(n|0);do{}while((fd(n|0)|0)!=10);q=c[b+152>>2]|0;r=D2(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=D2(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=D2(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Rd(n|0,98864,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Rd(n|0,98864,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=D2(s,8)|0;x=v}}while(0);ic(98872,j|0)|0;ic(98928,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];ic(98888,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];ic(98912,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}ub(98928)|0;_c(n|0)|0;c[b+460>>2]=0;i=d;return 0}function nE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}C2(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){C2(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}C2(l);i=d;return 0}function oE(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function pE(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+qE(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[61148>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];rz(9,1,98992,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rz(9,0,99104,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}ie[c[15416]&255](9);g=1;i=b;return g|0}function qE(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;FE(b);g=f+540|0;le[c[(c[g>>2]|0)+84>>2]&127](f)|0;le[c[(c[g>>2]|0)+36>>2]&127](f)|0;le[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;Ae[c[(c[g>>2]|0)+68>>2]&127](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function rE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+qE(b,1.0);if((c[61148>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}rz(9,1,99128,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rz(9,0,99192,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(9,0,99152,s)}rz(9,1,99216,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;rz(9,0,99288,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];rz(9,0,99240,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;rz(9,0,99376,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(9,0,99312,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;rz(9,0,99464,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rz(9,0,99408,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}ie[c[15416]&255](9);rz(9,1,99496,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=le[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;rz(9,0,99288,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];rz(9,0,99240,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}ie[c[15416]&255](9);ie[c[15416]&255](9);i=d;return}function sE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[61148>>2]|0)!=0){VC(b,9)}if((c[61208>>2]|0)==0){i=d;return}rz(24,1,99520,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){rz(24,1,99560,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rz(24,0,99584,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}ie[c[15416]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}rz(24,1,99640,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];rz(24,0,99664,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}ie[c[15416]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){rz(24,1,99696,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(24,0,99584,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}ie[c[15416]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){rz(24,1,99720,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;rz(24,0,99744,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}ie[c[15416]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){rz(24,1,99792,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?99864:99872;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?99864:99872;t=(a[(c[l>>2]|0)+n|0]|0)!=0?99864:99872;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;rz(24,0,99816,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}ie[c[15416]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){rz(24,1,99880,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;rz(24,0,99904,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}ie[c[15416]&255](24)}ie[c[15416]&255](24);i=d;return}



function Fj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+856>>3],+h[a+624>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+856>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+304>>3]=+h[f>>3];i=b;return}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+856>>3],+h[a+624>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+856>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Gi(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+248>>3]=+h[f>>3];i=b;return}function Hj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Fi(d,c[a+536>>2]|0,+h[f+304>>3],+h[f+248>>3],+h[f+856>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+280>>3]=+h[d>>3];i=b;return}function Ij(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+208>>3]=+h[b+216>>3]*(+h[d+856>>3]- +h[d+32>>3])*+h[b+248>>3];i=i;return}function Jj(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+216>>3]*+h[e+248>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+208>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}k=l/+xz(c[b+536>>2]|0,f,13984,14360,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}function Kj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0;d=i;i=i+8|0;e=d;f=c[b+536>>2]|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+200>>3];m=+h[k+296>>3];n=+h[k+304>>3];o=+h[k+272>>3];p=+h[k+280>>3];q=b+416|0;r=c[q>>2]|0;s=+h[r+168>>3];t=+h[k+448>>3];u=+h[r+192>>3]*+h[r+312>>3];v=+h[r+184>>3];w=(v+v)*.5;k=(c[(c[b+420>>2]|0)+8>>2]|0)+ -1|0;v=+(k|0);x=+h[r+304>>3];do{if((k|0)==0){if(x==0.0){y=r;z=x;break}A=x/+xz(f,v,14040,14368,+h[j>>3],(a[b+319|0]|0)!=0|0);y=c[q>>2]|0;z=A}else{y=r;z=x/v}}while(0);jh(e,f,l,m,n,o,p,s,t,u,w,z,+h[y+272>>3]);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+224>>3]=+h[e>>3]*+h[(c[q>>2]|0)+248>>3];i=d;return}function Lj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+1312>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+1288>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+1296>>3];h[a+8>>3]=+h[d+12064>>3];h[e+8>>3]=+h[d+12040>>3];h[f+8>>3]=+h[d+12048>>3];i=i;return}function Mj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+88>>3]=+h[d>>3];h[l+856>>3]=+h[d+8>>3];Ej(j);Fj(j);Gj(j);Hj(j);Ij(j);Jj(j);Kj(j);j=c[c[k>>2]>>2]|0;d=c[j+16>>2]|0;do{if((a[d+3|0]|0)==0){l=c[j+8>>2]|0;if((a[d]|0)==0){m=l;n=d;o=+h[l+224>>3];break}else{m=l;n=d;o=+h[l+856>>3]- +h[l+112>>3];break}}else{l=b+416|0;p=c[l>>2]|0;q=+h[p+544>>3];r=c[j+8>>2]|0;s=+h[r+424>>3];do{if(q!=0.0){t=s;u=r;v=j;w=q;x=p;y=s/q}else{if(s==0.0){t=s;u=r;v=j;w=q;x=p;y=s;break}z=s/+xz(c[b+536>>2]|0,q,13792,14376,+h[j>>3],(a[b+319|0]|0)!=0|0);A=c[l>>2]|0;B=c[c[k>>2]>>2]|0;C=c[B+8>>2]|0;t=+h[C+424>>3];u=C;v=B;w=+h[A+544>>3];x=A;y=z}}while(0);do{if(w!=0.0){D=x;E=u;F=v;G=t/w}else{if(t==0.0){D=x;E=u;F=v;G=t;break}q=t/+xz(c[b+536>>2]|0,w,13792,14376,+h[v>>3],(a[b+319|0]|0)!=0|0);p=c[c[k>>2]>>2]|0;D=c[l>>2]|0;E=c[p+8>>2]|0;F=p;G=q}}while(0);p=b+536|0;r=c[p>>2]|0;q=+h[E+224>>3];s=+h[D+488>>3];z=y*y+ +h[D+40>>3]+-1.0;H=+h[E+160>>3];I=+h[E+136>>3];do{if(H!=0.0){J=D;K=I;L=E;M=F;N=I/H}else{if(I==0.0){J=D;K=I;L=E;M=F;N=I;break}O=I/+xz(r,H,14112,14376,+h[F>>3],(a[b+319|0]|0)!=0|0);A=c[c[k>>2]>>2]|0;B=c[A+8>>2]|0;J=c[l>>2]|0;K=+h[B+136>>3];L=B;M=A;N=O}}while(0);H=z*N;I=K*+h[L+616>>3];O=+h[J+32>>3]-G*G+1.0;do{if(I!=0.0){P=O/I}else{if(O==0.0){P=O;break}P=O/+xz(c[p>>2]|0,I,14144,14376,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);qh(g,r,q,s,H,P,0,1.0);I=+h[g>>3];p=c[(c[c[k>>2]>>2]|0)+8>>2]|0;O=+h[p+112>>3];z=O+I*+oB(+h[p+424>>3],-2)*.5;p=c[c[k>>2]>>2]|0;l=c[p+8>>2]|0;m=l;n=c[p+16>>2]|0;o=+h[l+856>>3]-z}}while(0);h[e>>3]=o;if((a[n+3|0]|0)!=0){Q=+h[m+88>>3]-(+h[m+16>>3]- +h[(c[b+416>>2]|0)+24>>3]);R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}if((a[n]|0)==0){U=(+h[m+856>>3]- +h[m+112>>3])*(+h[(c[b+416>>2]|0)+24>>3]- +h[m+16>>3])*9869232667160129.0e-21}else{U=+h[m+224>>3]}Q=+h[m+88>>3]-U;R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}function Nj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Ci(e,c[g>>2]|0,+h[(c[j>>2]|0)+512>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+512>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+8>>3];n=+h[j+48>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Ii(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+928>>3]=+h[f>>3];i=b;return}function Oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Ci(e,c[g>>2]|0,+h[(c[j>>2]|0)+512>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+512>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+8>>3];n=+h[j+48>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Li(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+912>>3]=+h[f>>3];i=b;return}function Pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+616>>3];k=+h[g+928>>3];l=+h[(c[b+416>>2]|0)+512>>3];m=j*j;j=+h[g+912>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+888|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+888|0;t=s;h[t>>3]=q;i=d;return}u=j/+xz(c[b+536>>2]|0,m,14208,14384,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+888|0;t=s;h[t>>3]=q;i=d;return}function Qj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+904>>3]=+h[b+664>>3]*+h[b+888>>3]+ +h[b+656>>3]*+h[b+608>>3];i=i;return}function Rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=+h[b+904>>3]- +h[b+648>>3];i=i;return}function Sj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+512>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+640>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+872|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+872|0;q=p;h[q>>3]=n;i=d;return}k=l/+xz(c[b+536>>2]|0,e,14400,14392,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+872|0;q=p;h[q>>3]=n;i=d;return}function Tj(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+752>>3];h[c[b+8>>2]>>3]=+h[d+728>>3];h[c[b+12>>2]>>3]=+h[d+736>>3];i=i;return}function Uj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3]=+h[b>>3];Nj(f);Oj(f);Pj(f);Qj(f);Rj(f);Sj(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+656>>3]+(-(+h[f+632>>3]*+h[f+912>>3])- +h[f+872>>3]*+h[f+616>>3]);i=e;return}function Vj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+1088>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+1064>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+1072>>3];h[a+8>>3]=+h[d+976>>3];h[e+8>>3]=+h[d+952>>3];h[f+8>>3]=+h[d+960>>3];h[a+16>>3]=+h[d+12960>>3];h[e+16>>3]=+h[d+12936>>3];h[f+16>>3]=+h[d+12944>>3];i=i;return}function Wj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+72>>3]=n;h[p+64>>3]=+h[b+8>>3];q=+h[b+16>>3];h[p+920>>3]=q;r=+h[p+688>>3];s=r*r;b=p+32|0;h[d>>3]=+h[p+880>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+936>>3]));t=a+536|0;Ci(j,c[t>>2]|0,+h[b>>3],+h[p+24>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+32>>3];s=+h[b+24>>3];n=+h[b+72>>3];r=+h[b+64>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));Li(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+936>>3]- +h[l>>3];Ci(k,c[t>>2]|0,+h[g+32>>3],+h[g+24>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+32>>3];n=+h[t+24>>3];s=+h[t+72>>3];q=+h[t+64>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));Ii(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+920>>3]- +h[m>>3];i=e;return}function Xj(a){a=a|0;c[a+4>>2]=85;c[a>>2]=2;c[a+56>>2]=0;c[a+32>>2]=20;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=106;c[a+80>>2]=1;c[a+136>>2]=0;c[a+112>>2]=21;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=108;c[a+160>>2]=1;c[a+216>>2]=0;c[a+192>>2]=22;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=122;c[a+240>>2]=2;c[a+296>>2]=0;c[a+272>>2]=23;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=149;c[a+320>>2]=2;c[a+376>>2]=0;c[a+352>>2]=24;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=158;c[a+400>>2]=3;c[a+456>>2]=0;c[a+432>>2]=25;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=172;c[a+480>>2]=2;c[a+536>>2]=0;c[a+512>>2]=26;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=254;c[a+560>>2]=2;c[a+616>>2]=0;c[a+592>>2]=27;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=273;c[a+640>>2]=2;c[a+696>>2]=0;c[a+672>>2]=28;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=292;c[a+720>>2]=2;c[a+776>>2]=0;c[a+752>>2]=29;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;c[a+804>>2]=298;c[a+800>>2]=1;c[a+856>>2]=0;c[a+832>>2]=30;c[a+820>>2]=0;c[a+824>>2]=0;c[a+828>>2]=-1;c[a+836>>2]=53;c[a+884>>2]=317;c[a+880>>2]=2;c[a+936>>2]=0;c[a+912>>2]=31;c[a+900>>2]=0;c[a+904>>2]=0;c[a+908>>2]=-1;c[a+916>>2]=54;c[a+964>>2]=332;c[a+960>>2]=1;c[a+1016>>2]=0;c[a+992>>2]=32;c[a+980>>2]=0;c[a+984>>2]=0;c[a+988>>2]=-1;c[a+996>>2]=55;c[a+1044>>2]=345;c[a+1040>>2]=3;c[a+1096>>2]=0;c[a+1072>>2]=33;c[a+1060>>2]=0;c[a+1064>>2]=0;c[a+1068>>2]=-1;c[a+1076>>2]=56;i=i;return}function Yj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=d+8|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+16>>2]|0;if((a[j+5|0]|0)==0){k=(a[j+2|0]|0)!=0?1.0:0.0}else{k=1.0}ve[c[f>>2]&3](0,1,-k,0,d);ve[c[f>>2]&3](1,0,-1.0,1,d);j=c[f>>2]|0;f=c[c[g>>2]>>2]|0;g=c[f+16>>2]|0;if((a[g+5|0]|0)!=0){l=0.0;m=-l;ve[j&3](1,1,m,2,d);i=e;return}if((a[g+2|0]|0)!=0){l=0.0;m=-l;ve[j&3](1,1,m,2,d);i=e;return}l=(+h[(c[b+416>>2]|0)+88>>3]- +h[(c[f+8>>2]|0)+16>>3])*-9869232667160129.0e-21;m=-l;ve[j&3](1,1,m,2,d);i=e;return}function Zj(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0.0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0;e=i;i=i+8|0;f=e;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+16>>2]|0;do{if((a[k+5|0]|0)==0){if((a[k+2|0]|0)==0){l=k;m=j;n=-0.0;break}l=k;m=j;n=-+h[(c[j+8>>2]|0)+128>>3]}else{o=b+304|0;p=+h[o>>3];q=b+416|0;r=c[q>>2]|0;s=+h[r+544>>3];t=c[j+8>>2]|0;u=+h[t+440>>3];do{if(s!=0.0){v=u;w=t;x=j;y=s;z=r;A=u/s}else{if(u==0.0){v=u;w=t;x=j;y=s;z=r;A=u;break}B=u/+xz(c[b+536>>2]|0,s,14432,14424,+h[j>>3],(a[b+319|0]|0)!=0|0);C=c[q>>2]|0;D=c[c[g>>2]>>2]|0;E=c[D+8>>2]|0;v=+h[E+440>>3];w=E;x=D;y=+h[C+544>>3];z=C;A=B}}while(0);do{if(y!=0.0){F=w;G=x;H=z;I=v/y}else{if(v==0.0){F=w;G=x;H=z;I=v;break}s=v/+xz(c[b+536>>2]|0,y,14432,14424,+h[x>>3],(a[b+319|0]|0)!=0|0);r=c[c[g>>2]>>2]|0;F=c[r+8>>2]|0;G=r;H=c[q>>2]|0;I=s}}while(0);r=b+536|0;t=c[r>>2]|0;s=+h[H+488>>3];u=A*A+ +h[H+104>>3]+-1.0;B=+h[F+176>>3];J=+h[F+152>>3];do{if(B!=0.0){K=H;L=J;M=F;N=G;O=J/B}else{if(J==0.0){K=H;L=J;M=F;N=G;O=J;break}P=J/+xz(t,B,14456,14424,+h[G>>3],(a[b+319|0]|0)!=0|0);C=c[c[g>>2]>>2]|0;D=c[C+8>>2]|0;K=c[q>>2]|0;L=+h[D+152>>3];M=D;N=C;O=P}}while(0);B=u*O;J=L*+h[M+616>>3];P=+h[K+96>>3]-I*I+1.0;do{if(J!=0.0){Q=P/J}else{if(P==0.0){Q=P;break}Q=P/+xz(c[r>>2]|0,J,14488,14424,+h[N>>3],(a[b+319|0]|0)!=0|0)}}while(0);qh(f,t,-0.0,s,B,Q,0,1.0);J=+h[f>>3];P=+h[o>>3];r=c[(c[c[g>>2]>>2]|0)+8>>2]|0;u=+h[r+128>>3];R=p*(u+J*+oB(+h[r+440>>3],-2)*.5);r=c[c[g>>2]>>2]|0;l=c[r+16>>2]|0;m=r;n=(P+-1.0)*+h[(c[r+8>>2]|0)+128>>3]-R}}while(0);g=c[d+36>>2]|0;h[g>>3]=n;if((a[l+5|0]|0)!=0){S=+h[(c[b+416>>2]|0)+88>>3]- +h[(c[m+8>>2]|0)+16>>3];T=g;U=T+8|0;V=U;h[V>>3]=S;i=e;return}if((a[l+2|0]|0)!=0){S=0.0;T=g;U=T+8|0;V=U;h[V>>3]=S;i=e;return}l=c[m+8>>2]|0;S=+h[l+128>>3]*(+h[(c[b+416>>2]|0)+88>>3]- +h[l+16>>3])*9869232667160129.0e-21;T=g;U=T+8|0;V=U;h[V>>3]=S;i=e;return}function _j(a){a=a|0;c[a+20>>2]=96;c[a+16>>2]=2;c[a+12>>2]=3;c[a>>2]=57;c[a+4>>2]=58;i=i;return}function $j(a,b){a=a|0;b=b|0;i=i;return}function ak(a){a=a|0;i=i;return}function bk(a,b){a=a|0;b=b|0;c[b>>2]=c[15344+(a<<2)>>2];i=i;return c[14544+(a<<2)>>2]|0}function ck(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0;e=i;f=b+4|0;g=b+416|0;j=b+360|0;k=(aD(+h[c[c[f>>2]>>2]>>3],+h[(c[g>>2]|0)+672>>3],a[c[j>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=k?1.0:-1.0;k=(cD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[g>>2]|0)+88>>3],a[(c[j>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=k?1.0:-1.0;k=(cD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[g>>2]|0)+56>>3],a[(c[j>>2]|0)+2|0]|0)|0)<<24>>24!=0;h[d+16>>3]=k?1.0:-1.0;k=(cD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[g>>2]|0)+24>>3],a[(c[j>>2]|0)+3|0]|0)|0)<<24>>24!=0;h[d+24>>3]=k?1.0:-1.0;k=bD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0.0,a[(c[j>>2]|0)+4|0]|0)|0;l=c[g>>2]|0;m=gD(+h[l+88>>3],+h[l+528>>3])|0;if(k<<24>>24==0){n=m<<24>>24!=0?1.0:-1.0}else{n=1.0}h[d+32>>3]=n;m=c[g>>2]|0;k=aD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3],+h[m+688>>3]+ +h[m+696>>3]*.5,a[(c[j>>2]|0)+5|0]|0)|0;m=c[g>>2]|0;l=aD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3],+h[m+688>>3]+ +h[m+696>>3]*-.5,a[(c[j>>2]|0)+6|0]|0)|0;if((a[(c[b+408>>2]|0)+6|0]|0)==0|k<<24>>24==0){o=l<<24>>24!=0?1.0:-1.0}else{o=1.0}h[d+40>>3]=o;l=c[c[f>>2]>>2]|0;k=(aD(+h[l>>3],+h[(c[l+8>>2]|0)+496>>3],a[(c[j>>2]|0)+7|0]|0)|0)<<24>>24!=0;h[d+48>>3]=k?1.0:-1.0;k=bD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],0.0,a[(c[j>>2]|0)+8|0]|0)|0;l=c[g>>2]|0;b=gD(+h[l+56>>3],+h[l+528>>3])|0;if(k<<24>>24==0){p=b<<24>>24!=0?1.0:-1.0}else{p=1.0}h[d+56>>3]=p;b=bD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0.0,a[(c[j>>2]|0)+9|0]|0)|0;k=c[g>>2]|0;g=gD(+h[k+24>>3],+h[k+528>>3])|0;if(!(b<<24>>24==0)){q=1.0;r=d;s=r+64|0;t=s;h[t>>3]=q;u=c[f>>2]|0;v=c[u>>2]|0;w=v;x=w+8|0;y=x;z=c[y>>2]|0;A=z;B=A+752|0;C=B;D=+h[C>>3];E=c[j>>2]|0;F=E;G=F+10|0;H=G;I=a[H]|0;J=bD(D,0.0,I)|0;K=J<<24>>24!=0;L=K?1.0:-1.0;M=d;N=M+72|0;O=N;h[O>>3]=L;i=e;return 0}q=g<<24>>24!=0?1.0:-1.0;r=d;s=r+64|0;t=s;h[t>>3]=q;u=c[f>>2]|0;v=c[u>>2]|0;w=v;x=w+8|0;y=x;z=c[y>>2]|0;A=z;B=A+752|0;C=B;D=+h[C>>3];E=c[j>>2]|0;F=E;G=F+10|0;H=G;I=a[H]|0;J=bD(D,0.0,I)|0;K=J<<24>>24!=0;L=K?1.0:-1.0;M=d;N=M+72|0;O=N;h[O>>3]=L;i=e;return 0}function dk(a){a=a|0;i=i;return c[15600+(a<<2)>>2]|0}function ek(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0.0,l=0,m=0;e=i;f=b+4|0;g=+h[c[c[f>>2]>>2]>>3];j=b+416|0;k=+h[(c[j>>2]|0)+672>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<k|0;a[(c[d>>2]|0)+1|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3]>=+h[(c[j>>2]|0)+88>>3]|0;a[(c[d>>2]|0)+2|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3]>=+h[(c[j>>2]|0)+56>>3]|0;a[(c[d>>2]|0)+3|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3]>=+h[(c[j>>2]|0)+24>>3]|0;a[(c[d>>2]|0)+4|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3]>0.0|0;l=c[j>>2]|0;a[(c[d>>2]|0)+5|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3]<+h[l+688>>3]+ +h[l+696>>3]*.5|0;l=c[j>>2]|0;a[(c[d>>2]|0)+6|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3]<+h[l+688>>3]+ +h[l+696>>3]*-.5|0;l=c[c[f>>2]>>2]|0;a[(c[d>>2]|0)+7|0]=+h[l>>3]<+h[(c[l+8>>2]|0)+496>>3]|0;a[(c[d>>2]|0)+8|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3]>0.0|0;a[(c[d>>2]|0)+9|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3]>0.0|0;a[(c[d>>2]|0)+10|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+752>>3]>0.0|0;i=e;return 0}else{d=b+360|0;l=aD(g,k,a[c[d>>2]|0]|0)|0;m=b+352|0;a[c[m>>2]|0]=l;l=cD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[j>>2]|0)+88>>3],a[(c[d>>2]|0)+1|0]|0)|0;a[(c[m>>2]|0)+1|0]=l;l=cD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[j>>2]|0)+56>>3],a[(c[d>>2]|0)+2|0]|0)|0;a[(c[m>>2]|0)+2|0]=l;l=cD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[j>>2]|0)+24>>3],a[(c[d>>2]|0)+3|0]|0)|0;a[(c[m>>2]|0)+3|0]=l;l=bD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0.0,a[(c[d>>2]|0)+4|0]|0)|0;a[(c[m>>2]|0)+4|0]=l;l=c[j>>2]|0;b=aD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3],+h[l+688>>3]+ +h[l+696>>3]*.5,a[(c[d>>2]|0)+5|0]|0)|0;a[(c[m>>2]|0)+5|0]=b;b=c[j>>2]|0;j=aD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+528>>3],+h[b+688>>3]+ +h[b+696>>3]*-.5,a[(c[d>>2]|0)+6|0]|0)|0;a[(c[m>>2]|0)+6|0]=j;j=c[c[f>>2]>>2]|0;b=aD(+h[j>>3],+h[(c[j+8>>2]|0)+496>>3],a[(c[d>>2]|0)+7|0]|0)|0;a[(c[m>>2]|0)+7|0]=b;b=bD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],0.0,a[(c[d>>2]|0)+8|0]|0)|0;a[(c[m>>2]|0)+8|0]=b;b=bD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0.0,a[(c[d>>2]|0)+9|0]|0)|0;a[(c[m>>2]|0)+9|0]=b;b=bD(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+752>>3],0.0,a[(c[d>>2]|0)+10|0]|0)|0;a[(c[m>>2]|0)+10|0]=b;i=e;return 0}return 0}function fk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;rz(8,1,15648,t);t=b+4|0;u=c[c[t>>2]>>2]|0;v=c[u+16>>2]|0;w=a[v+8|0]|0;x=b+408|0;y=c[x>>2]|0;z=a[y+8|0]|0;if(w<<24>>24==z<<24>>24){A=y;B=v;C=u;D=0}else{c[s>>2]=z<<24>>24;c[s+4>>2]=w<<24>>24;rz(8,0,15680,s);s=c[c[t>>2]>>2]|0;A=c[x>>2]|0;B=c[s+16>>2]|0;C=s;D=1}s=a[B+7|0]|0;w=a[A+7|0]|0;if(s<<24>>24==w<<24>>24){E=A;F=B;G=C;H=D}else{c[r>>2]=w<<24>>24;c[r+4>>2]=s<<24>>24;rz(8,0,15736,r);r=c[c[t>>2]>>2]|0;E=c[x>>2]|0;F=c[r+16>>2]|0;G=r;H=1}r=a[F+3|0]|0;s=a[E+3|0]|0;if(r<<24>>24==s<<24>>24){I=E;J=F;K=G;L=H}else{c[q>>2]=s<<24>>24;c[q+4>>2]=r<<24>>24;rz(8,0,15792,q);q=c[c[t>>2]>>2]|0;I=c[x>>2]|0;J=c[q+16>>2]|0;K=q;L=1}q=a[J+4|0]|0;r=a[I+4|0]|0;if(q<<24>>24==r<<24>>24){M=I;N=J;O=K;P=L}else{c[p>>2]=r<<24>>24;c[p+4>>2]=q<<24>>24;rz(8,0,15856,p);p=c[c[t>>2]>>2]|0;M=c[x>>2]|0;N=c[p+16>>2]|0;O=p;P=1}p=a[N+5|0]|0;q=a[M+5|0]|0;if(p<<24>>24==q<<24>>24){Q=M;R=N;S=O;T=P}else{c[o>>2]=q<<24>>24;c[o+4>>2]=p<<24>>24;rz(8,0,15920,o);o=c[c[t>>2]>>2]|0;Q=c[x>>2]|0;R=c[o+16>>2]|0;S=o;T=1}o=a[R]|0;p=a[Q]|0;if(o<<24>>24==p<<24>>24){U=Q;V=R;W=S;X=T}else{c[n>>2]=p<<24>>24;c[n+4>>2]=o<<24>>24;rz(8,0,15984,n);n=c[c[t>>2]>>2]|0;U=c[x>>2]|0;V=c[n+16>>2]|0;W=n;X=1}n=a[V+1|0]|0;o=a[U+1|0]|0;if(n<<24>>24==o<<24>>24){Y=U;Z=V;_=W;$=X}else{c[m>>2]=o<<24>>24;c[m+4>>2]=n<<24>>24;rz(8,0,16048,m);m=c[c[t>>2]>>2]|0;Y=c[x>>2]|0;Z=c[m+16>>2]|0;_=m;$=1}m=a[Z+2|0]|0;n=a[Y+2|0]|0;if(m<<24>>24==n<<24>>24){aa=Y;ba=Z;ca=_;da=$}else{c[l>>2]=n<<24>>24;c[l+4>>2]=m<<24>>24;rz(8,0,16112,l);l=c[c[t>>2]>>2]|0;aa=c[x>>2]|0;ba=c[l+16>>2]|0;ca=l;da=1}l=a[ba+6|0]|0;ba=a[aa+6|0]|0;if(l<<24>>24==ba<<24>>24){ea=ca;fa=da}else{c[j>>2]=ba<<24>>24;c[j+4>>2]=l<<24>>24;rz(8,0,16176,j);ea=c[c[t>>2]>>2]|0;fa=1}j=c[ea+8>>2]|0;ga=+h[j+512>>3];ea=b+400|0;b=c[ea>>2]|0;ha=+h[b+512>>3];if(ga!=ha){l=g;h[k>>3]=ha;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];l=g+8|0;h[k>>3]=ga;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];rz(8,0,16232,g);ia=c[ea>>2]|0;ja=c[(c[c[t>>2]>>2]|0)+8>>2]|0;ka=1}else{ia=b;ja=j;ka=fa}ga=+h[ja+504>>3];ha=+h[ia+504>>3];if(ga!=ha){fa=f;h[k>>3]=ha;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=f+8|0;h[k>>3]=ga;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];rz(8,0,16296,f);la=c[ea>>2]|0;ma=c[(c[c[t>>2]>>2]|0)+8>>2]|0;na=1}else{la=ia;ma=ja;na=ka}ga=+h[ma+496>>3];ha=+h[la+496>>3];if(ga!=ha){la=e;h[k>>3]=ha;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];la=e+8|0;h[k>>3]=ga;c[la>>2]=c[k>>2];c[la+4>>2]=c[k+4>>2];rz(8,0,16360,e);oa=1}else{oa=na}if((c[61144>>2]|0)==0){i=d;return oa|0}ie[c[15416]&255](8);i=d;return oa|0}function gk(a){a=a|0;i=i;return c[16728+(a<<2)>>2]|0}function hk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+8|0;rz(21,1,16760,q);q=b+416|0;r=c[q>>2]|0;s=+h[r+280>>3]+ +h[r+304>>3]*-1.0e3;h[d>>3]=s;r=gk(0)|0;c[p>>2]=1;c[p+4>>2]=r;r=p+8|0;h[k>>3]=s;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(21,0,16792,p);p=c[q>>2]|0;s=+h[p+304>>3]- +h[p+808>>3];h[d+8>>3]=s;p=gk(1)|0;c[o>>2]=2;c[o+4>>2]=p;p=o+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rz(21,0,16792,o);o=b+4|0;s=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+24>>3]- +h[(c[q>>2]|0)+360>>3];h[d+16>>3]=s;p=gk(2)|0;c[n>>2]=3;c[n+4>>2]=p;p=n+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];rz(21,0,16792,n);s=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+32>>3]- +h[(c[q>>2]|0)+432>>3];h[d+24>>3]=s;n=gk(3)|0;c[m>>2]=4;c[m+4>>2]=n;n=m+8|0;h[k>>3]=s;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];rz(21,0,16792,m);s=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+16>>3]+-2.2;h[d+32>>3]=s;m=gk(4)|0;c[l>>2]=5;c[l+4>>2]=m;m=l+8|0;h[k>>3]=s;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];rz(21,0,16792,l);s=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+8>>3]- +h[(c[q>>2]|0)+464>>3];h[d+40>>3]=s;l=gk(5)|0;c[j>>2]=6;c[j+4>>2]=l;l=j+8|0;h[k>>3]=s;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];rz(21,0,16792,j);j=(a[(c[b+424>>2]|0)+49|0]|0)==0;if((a[(c[b+408>>2]|0)+6|0]|0)==0){t=j?0.0:1.0}else{t=+(j&1|0)}h[d+48>>3]=t;j=gk(6)|0;c[g>>2]=7;c[g+4>>2]=j;j=g+8|0;h[k>>3]=t;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];rz(21,0,16792,g);t=+h[c[(c[c[o>>2]>>2]|0)+8>>2]>>3]- +h[(c[q>>2]|0)+752>>3];h[d+56>>3]=t;d=gk(7)|0;c[f>>2]=8;c[f+4>>2]=d;d=f+8|0;h[k>>3]=t;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];rz(21,0,16792,f);if((c[61196>>2]|0)==0){i=e;return 0}ie[c[15416]&255](21);i=e;return 0}function ik(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=+h[(c[a+8>>2]|0)+656>>3];i=i;return}function jk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+768>>3];i=i;return}function kk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+760>>3];i=i;return}function lk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+768>>3];i=i;return}function mk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+760>>3];i=i;return}function nk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+824>>3]*.01;i=i;return}function ok(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+816>>3];i=i;return}function pk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+544>>3]=+h[b+504>>3];i=i;return}function qk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+496>>3];i=i;return}function rk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+512>>3]=+h[b+760>>3];i=i;return}function sk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+552>>3]=+h[b+512>>3];i=i;return}function tk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+816>>3];i=i;return}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;DA(e,1,+h[(c[g>>2]|0)+112>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+552>>3];l=+h[a+464>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Hh(f,j,k,l,d,0);h[(c[g>>2]|0)+472>>3]=+h[f>>3];i=b;return}function vk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+376>>3]=+h[b+824>>3];i=i;return}function wk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+416>>3]=+h[b+376>>3];i=i;return}function xk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+432>>3]=+h[b+416>>3];i=i;return}function yk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+360>>3]=+h[b+832>>3];i=i;return}function zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;DA(e,1,+h[(c[g>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+432>>3];l=+h[a+360>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];fh(f,j,k,l,d,0);h[(c[g>>2]|0)+368>>3]=+h[f>>3];i=b;return}function Ak(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+312>>3]=+h[b+776>>3];i=i;return}function Bk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+296>>3]=+h[b+816>>3];i=i;return}function Ck(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+288>>3]=+h[b+296>>3]*100.0;i=i;return}function Dk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+160>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+224>>3]=+h[b+176>>3]*3.141592653589793;i=i;return}function Fk(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+176>>3];h[b+216>>3]=d*d*.7853981633974483;i=i;return}function Gk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+200>>3]=+h[b+824>>3];i=i;return}function Hk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+232>>3]=+h[b+200>>3];i=i;return}function Ik(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+232>>3];i=i;return}function Jk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+256>>3]=+h[b+200>>3];i=i;return}function Kk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+760>>3];i=i;return}function Lk(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+224>>3];g=+h[e+216>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+xz(c[b+536>>2]|0,f,16816,16808,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+464>>3]=j*4.0;i=d;return}function Mk(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+224>>3];g=+h[e+216>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+xz(c[b+536>>2]|0,f,16816,16832,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+456>>3]=j*4.0;i=d;return}function Nk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1200>>3]=+h[(c[a+416>>2]|0)+128>>3]*1.0e-5;i=i;return}function Ok(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1184>>3]=+h[(c[a+416>>2]|0)+512>>3]*1.0e-5;i=i;return}function Pk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1176>>3]=+h[(c[a+416>>2]|0)+632>>3]*1.0e-5;i=i;return}function Qk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=+h[(c[a+416>>2]|0)+648>>3]+-273.15;i=i;return}function Rk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=(+h[b+456>>3]+ +h[b+464>>3])*.5;i=i;return}function Sk(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Zg(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+512>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1160>>3]=+h[d>>3];i=b;return}function Tk(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+16>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+424>>3]=b*b*.7853981633974483;i=i;return}function Uk(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+48>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+432>>3]=b*b*.7853981633974483;i=i;return}function Vk(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+80>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+440>>3]=b*b*.7853981633974483;i=i;return}function Wk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+128>>3],+h[k+144>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+128>>3];m=+h[g+144>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Hi(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1152>>3]=+h[f>>3];i=b;return}function Xk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+128>>3],+h[k+144>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+128>>3];m=+h[g+144>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Ji(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1144>>3]=+h[f>>3];i=b;return}function Yk(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Zg(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+128>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1136>>3]=+h[d>>3];i=b;return}function Zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+632>>3],+h[k+648>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+632>>3];m=+h[g+648>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Hi(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1128>>3]=+h[f>>3];i=b;return}function _k(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+632>>3],+h[k+648>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+632>>3];m=+h[g+648>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Ji(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1120>>3]=+h[f>>3];i=b;return}function $k(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Zg(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+632>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1112>>3]=+h[d>>3];i=b;return}function al(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1128>>3];k=+h[g+1120>>3];l=+h[(c[b+416>>2]|0)+632>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+1104|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+1104|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,16848,16840,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+1104|0;r=q;h[r>>3]=o;i=d;return}function bl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1152>>3];k=+h[g+1144>>3];l=+h[(c[b+416>>2]|0)+128>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+1096|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+1096|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,16872,16864,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+1096|0;r=q;h[r>>3]=o;i=d;return}function cl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Pi(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1128>>3],0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1128>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Ni(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1088>>3]=+h[f>>3];i=b;return}function dl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Pi(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1128>>3],0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1128>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Gi(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1080>>3]=+h[f>>3];i=b;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Pi(e,c[g>>2]|0,+h[(c[j>>2]|0)+128>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3],0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+128>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Ni(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1072>>3]=+h[f>>3];i=b;return}function fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Pi(e,c[g>>2]|0,+h[(c[j>>2]|0)+128>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3],0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+128>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Gi(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1064>>3]=+h[f>>3];i=b;return}function gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+248>>3];m=+h[k+288>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+xz(g,l,16896,16888,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+248>>3];o=r;p=q}}while(0);l=+h[o+328>>3];m=+h[o+336>>3];q=+h[o+168>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+448>>3];t=+h[o+184>>3];u=(t+t)*.5;t=+h[o+296>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+xz(c[f>>2]|0,n,16896,16888,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);ph(e,g,p,l,l,m,m,q,s,u,w,+h[v+272>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1056>>3]=+h[e>>3];i=d;return}function hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+632>>3],+h[k+648>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+632>>3];m=+h[g+648>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Hi(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1040>>3]=+h[f>>3];i=b;return}function il(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+632>>3],+h[k+648>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+632>>3];m=+h[g+648>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Ji(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1032>>3]=+h[f>>3];i=b;return}function jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+128>>3],+h[k+144>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+128>>3];m=+h[g+144>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Hi(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1008>>3]=+h[f>>3];i=b;return}function kl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=c[j>>2]|0;Ci(e,c[g>>2]|0,+h[k+128>>3],+h[k+144>>3],0);k=c[g>>2]|0;g=c[j>>2]|0;l=+h[g+128>>3];m=+h[g+144>>3];g=d+0|0;j=e+0|0;e=g+120|0;do{c[g>>2]=c[j>>2];g=g+4|0;j=j+4|0}while((g|0)<(e|0));Ji(f,k,l,m,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e3>>3]=+h[f>>3];i=b;return}function ll(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;do{if((a[b+314|0]|0)==0){e=b+416|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+416|0;l=aD(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+672>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+416|0;k=aD(+h[c[c[b+4>>2]>>2]>>3],+h[(c[j>>2]|0)+672>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+416|0;j=dD(+h[c[c[b+4>>2]>>2]>>3],+h[(c[k>>2]|0)+672>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+416|0;k=dD(+h[c[c[b+4>>2]>>2]>>3],+h[(c[g>>2]|0)+672>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);k=c[e>>2]|0;m=+h[k+664>>3];if(!(f<<24>>24==0)){n=0.0;o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+576|0;A=z;h[A>>3]=o;i=d;return}n=+h[k+680>>3];o=m+n;p=b;q=p+4|0;r=q;s=c[r>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;x=c[w>>2]|0;y=x;z=y+576|0;A=z;h[A>>3]=o;i=d;return}function ml(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+752>>3];i=i;return}function nl(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+760>>3]=+wd(+(+h[d>>3]),.001);i=b;return}function ol(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0.0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0.0,M=0,N=0.0,O=0,P=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+736>>3];j=+h[f+744>>3];k=j!=0.0;l=b+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;o=+h[n>>3];if(g!=0.0){do{if(k){p=g;q=j;r=n;s=o/j}else{if(o==0.0){p=g;q=j;r=n;s=o;break}t=o/+xz(c[b+536>>2]|0,j,16936,16928,+h[m>>3],(a[b+319|0]|0)!=0|0);u=c[e>>2]|0;p=+h[u+736>>3];q=+h[u+744>>3];r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;s=t}}while(0);v=r;w=(s+ +h[r+40>>3])*q/p;x=v;y=x+520|0;z=y;h[z>>3]=w;i=d;return}do{if(k){A=o;B=j;C=f;D=n;E=m;F=o/j}else{if(o==0.0){A=o;B=j;C=f;D=n;E=m;F=o;break}p=o/+xz(c[b+536>>2]|0,j,16936,16928,+h[m>>3],(a[b+319|0]|0)!=0|0);r=c[c[l>>2]>>2]|0;u=c[r+8>>2]|0;G=c[e>>2]|0;A=+h[u>>3];B=+h[G+744>>3];C=G;D=u;E=r;F=p}}while(0);j=+h[D+40>>3];m=B!=0.0;if((F+j)*B==0.0){do{if(m){H=B;I=j;J=D;K=A/B}else{if(A==0.0){H=B;I=j;J=D;K=A;break}F=A/+xz(c[b+536>>2]|0,B,16936,16928,+h[E>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[l>>2]>>2]|0)+8>>2]|0;H=+h[(c[e>>2]|0)+744>>3];I=+h[n+40>>3];J=n;K=F}}while(0);v=J;w=(K+I)*H;x=v;y=x+520|0;z=y;h[z>>3]=w;i=d;return}else{do{if(m){L=B;M=C;N=j;O=E;P=A/B}else{if(A==0.0){L=B;M=C;N=j;O=E;P=A;break}H=A/+xz(c[b+536>>2]|0,B,16936,16928,+h[E>>3],(a[b+319|0]|0)!=0|0);J=c[c[l>>2]>>2]|0;D=c[e>>2]|0;L=+h[D+744>>3];M=D;N=+h[(c[J+8>>2]|0)+40>>3];O=J;P=H}}while(0);B=(P+N)*L/+xz(c[b+536>>2]|0,+h[M+736>>3],16944,16928,+h[O>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[l>>2]>>2]|0)+8>>2]|0;w=B;x=v;y=x+520|0;z=y;h[z>>3]=w;i=d;return}}function pl(b){b=b|0;a[(c[b+408>>2]|0)+6|0]=a[(c[b+424>>2]|0)+49|0]|0;i=i;return}function ql(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+464>>3];i=i;return}function rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[b+8>>3]+-273.15;i=i;return}function sl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Ci(e,c[g>>2]|0,+h[(c[j>>2]|0)+512>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+512>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Ji(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+616>>3]=+h[f>>3];i=b;return}function tl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Ci(e,c[g>>2]|0,+h[(c[j>>2]|0)+512>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+512>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Hi(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+624>>3]=+h[f>>3];i=b;return}function ul(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+864>>3]=+h[b+624>>3]+ +h[d+776>>3]*+h[d+192>>3];i=i;return}function vl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+624>>3];k=+h[g+616>>3];l=+h[(c[b+416>>2]|0)+512>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+608|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+608|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,16960,16952,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+608|0;r=q;h[r>>3]=o;i=d;return}function wl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=2.2;i=i;return}function xl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+504>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[27736]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=16992;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];Le[n&63](m,d,17016,e);p=+h[(c[f>>2]|0)+504>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+80>>3]=p+g*+h[f+16>>3]*2.0;i=b;return}function yl(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+wd(0.0,+(+h[d+16>>3]- +h[e+24>>3]));h[d+112>>3]=+h[e+512>>3]+f*+h[e+776>>3]*+h[d+616>>3];i=b;return}function zl(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+wd(0.0,+(+h[d+16>>3]- +h[e+56>>3]));h[d+120>>3]=+h[e+512>>3]+f*+h[e+776>>3]*+h[d+616>>3];i=b;return}function Al(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+120>>3],+h[a+1128>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+120>>3];l=+h[g+1128>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+168>>3]=+h[f>>3];i=b;return}function Bl(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+wd(0.0,+(+h[d+16>>3]- +h[e+88>>3]));h[d+128>>3]=+h[e+512>>3]+f*+h[e+776>>3]*+h[d+616>>3];i=b;return}function Cl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;Pi(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+128>>3],84013.05815259689,0,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+128>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));Ni(f,a,k,84013.05815259689,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+176>>3]=+h[f>>3];i=b;return}function Dl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+16>>3];wh(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3]+(g*-.1- +h[f+24>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+136>>3]=+h[d>>3];i=b;return}function El(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=b+4|0;l=cD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+24>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=l;e=k;f=j;break}else{j=b+4|0;k=cD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+24>>3],a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;k=b+4|0;j=gD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+24>>3])|0;a[(c[b+352>>2]|0)+3|0]=j;e=k;f=g;break}else{g=b+4|0;k=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+24>>3])|0;a[(c[b+352>>2]|0)+3|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+3|0]=f;i=d;return}function Fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+48>>3];wh(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3]+(g*-.1- +h[f+56>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[d>>3];i=b;return}function Gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+2|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;l=cD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+56>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=l;e=k;f=j;break}else{j=b+4|0;k=cD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+56>>3],a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+2|0]|0;k=b+4|0;j=gD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+56>>3])|0;a[(c[b+352>>2]|0)+2|0]=j;e=k;f=g;break}else{g=b+4|0;k=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+56>>3])|0;a[(c[b+352>>2]|0)+2|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+4|0]=f;i=d;return}function Hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+96>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+96|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+96>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+192>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+192|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+192>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+8>>3]=k;GD(a,0)|0;j=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+96>>3]=+h[j>>3];h[f+192>>3]=+h[j+8>>3];Si(a);Ti(a);Ui(a);i=b;return}function Il(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+416|0;l=a+4|0;Pi(e,c[j>>2]|0,+h[(c[k>>2]|0)+632>>3],+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+624>>3],0,0);a=c[j>>2]|0;m=+h[(c[k>>2]|0)+632>>3];n=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+624>>3];o=d+0|0;p=e+0|0;e=o+120|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(e|0));Gi(f,a,m,n,d);d=c[(c[c[l>>2]>>2]|0)+8>>2]|0;wh(g,c[j>>2]|0,-+h[d+544>>3],+h[d+1080>>3],+h[f>>3],+h[(c[k>>2]|0)+584>>3]);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+560>>3]=+h[g>>3];i=b;return}function Jl(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=fD(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+384>>3]=-(+h[e+544>>3]*+h[(a<<24>>24==0?e+624|0:e+1128|0)>>3]);i=b;return}function Kl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0,y=0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=fD(-+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;m=fD(-+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+544>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Pi(g,c[n>>2]|0,+h[o+120>>3],+h[(m<<24>>24==0?o+624|0:o+1128|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+120>>3];s=+h[(l<<24>>24==0?q+624|0:q+1128|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));Ni(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+432>>3];r=+h[p+544>>3];t=-r;if(s!=0.0){u=p;v=t/s;w=u;x=w+408|0;y=x;h[y>>3]=v;i=d;return}if(r==-0.0){u=p;v=t;w=u;x=w+408|0;y=x;h[y>>3]=v;i=d;return}r=t/+xz(c[n>>2]|0,s,17120,17112,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;v=r;w=u;x=w+408|0;y=x;h[y>>3]=v;i=d;return}function Ll(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+408>>3];e=c[a+416>>2]|0;h[b+360>>3]=-(+h[b+544>>3]*(d*d*.5+ +h[e+776>>3]*+h[e+56>>3]));i=i;return}function Ml(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+192>>3],+h[a+624>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+192>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+592>>3]=+h[f>>3];i=b;return}function Nl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;wh(e,c[f>>2]|0,+h[j+544>>3],+h[j+592>>3],+h[j+1088>>3],+h[(c[b+416>>2]|0)+584>>3]);k=+h[e>>3];e=c[c[g>>2]>>2]|0;j=c[e+8>>2]|0;l=+h[j+544>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+536|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+536|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[f>>2]|0,k,17496,17488,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+536|0;q=p;h[q>>3]=n;i=d;return}function Ol(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+192>>3],+h[a+624>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+192>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Gi(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+584>>3]=+h[f>>3];i=b;return}function Pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+256|0;d=b;e=b+120|0;f=b+240|0;g=b+248|0;j=a+536|0;k=a+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Pi(e,c[j>>2]|0,+h[l+192>>3],+h[l+1128>>3],0,0);l=c[j>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+192>>3];o=+h[m+1128>>3];m=d+0|0;p=e+0|0;e=m+120|0;do{c[m>>2]=c[p>>2];m=m+4|0;p=p+4|0}while((m|0)<(e|0));Gi(f,l,n,o,d);d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;wh(g,c[j>>2]|0,+h[d+544>>3],+h[d+584>>3],+h[f>>3],+h[(c[a+416>>2]|0)+584>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+568>>3]=+h[g>>3];i=b;return}function Ql(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+80>>3];wh(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+16>>3]+(g*-.1- +h[f+88>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[d>>3];i=b;return}function Rl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+1|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;l=cD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+88>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;e=k;f=j;break}else{j=b+4|0;k=cD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+88>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;j=gD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+88>>3])|0;a[(c[b+352>>2]|0)+1|0]=j;e=k;f=g;break}else{g=b+4|0;k=gD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],+h[(c[b+416>>2]|0)+88>>3])|0;a[(c[b+352>>2]|0)+1|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+5|0]=f;i=d;return}function Sl(a){a=a|0;var b=0,d=0,e=0;b=i;wD(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+104>>3]=+h[d>>3];h[e+184>>3]=+h[d+8>>3];i=b;return}function Tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=+h[b+184>>3]- +h[(c[a+416>>2]|0)+632>>3];i=i;return}function Ul(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=c[b+416>>2]|0;l=aD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[k+688>>3]+ +h[k+696>>3]*.5,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;f=j;break}else{j=c[b+416>>2]|0;l=aD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[j+688>>3]+ +h[j+696>>3]*.5,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;f=l;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;l=c[b+416>>2]|0;j=dD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[l+688>>3]+ +h[l+696>>3]*.5)|0;a[(c[b+352>>2]|0)+5|0]=j;f=g;break}else{g=c[b+416>>2]|0;j=dD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[g+688>>3]+ +h[g+696>>3]*.5)|0;a[(c[b+352>>2]|0)+5|0]=j;f=j;break}}}}while(0);do{if((a[e]|0)==0){m=a[(c[b+356>>2]|0)+6|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){g=a[(c[b+356>>2]|0)+6|0]|0;l=c[b+416>>2]|0;k=aD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[l+688>>3]+ +h[l+696>>3]*-.5,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;m=g;break}else{g=c[b+416>>2]|0;k=aD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[g+688>>3]+ +h[g+696>>3]*-.5,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;m=k;break}}else{if(j){j=a[(c[b+356>>2]|0)+6|0]|0;k=c[b+416>>2]|0;g=dD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[k+688>>3]+ +h[k+696>>3]*-.5)|0;a[(c[b+352>>2]|0)+6|0]=g;m=j;break}else{j=c[b+416>>2]|0;g=dD(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+528>>3],+h[j+688>>3]+ +h[j+696>>3]*-.5)|0;a[(c[b+352>>2]|0)+6|0]=g;m=g;break}}}}while(0);if(!((a[(c[b+408>>2]|0)+6|0]|0)==0|f<<24>>24==0)){n=1;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}n=m<<24>>24!=0|0;o=b;p=o+4|0;q=p;r=c[q>>2]|0;s=c[r>>2]|0;t=s;u=t+16|0;v=u;w=c[v>>2]|0;x=w;y=x+6|0;z=y;a[z]=n;i=d;return}function Vl(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+8|0]=(a[d+6|0]|0)==0|0;i=i;return}function Wl(b){b=b|0;var d=0;d=c[(c[c[b+4>>2]>>2]|0)+16>>2]|0;a[d+7|0]=a[d+6|0]|0;i=i;return}function Xl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0.0;d=i;e=b+416|0;f=fD(+h[(c[e>>2]|0)+712>>3],0.0)|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[e>>2]|0;do{if(f<<24>>24!=0&(a[(c[j+16>>2]|0)+6|0]|0)!=0){l=+h[k+712>>3];m=+h[k+704>>3];if(l!=0.0){n=m/l;break}if(m==0.0){n=m;break}n=m/+xz(c[b+536>>2]|0,l,17624,17616,+h[j>>3],(a[b+319|0]|0)!=0|0)}else{o=fD(+h[k+728>>3],0.0)|0;p=c[c[g>>2]>>2]|0;if((a[(c[p+16>>2]|0)+6|0]|0)!=0|o<<24>>24==0){n=0.0;break}o=c[e>>2]|0;l=+h[o+728>>3];m=+h[o+704>>3];q=-m;if(l!=0.0){n=q/l;break}if(m==-0.0){n=q;break}n=q/+xz(c[b+536>>2]|0,l,17648,17616,+h[p>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3]=n;i=d;return}function Yl(b){b=b|0;var d=0,e=0,f=0.0,g=0.0;d=c[c[b+4>>2]>>2]|0;e=c[b+416>>2]|0;f=+h[e+720>>3];if((a[(c[d+16>>2]|0)+6|0]|0)==0){g=f}else{g=f+ +h[e+704>>3]}h[(c[d+8>>2]|0)+512>>3]=g;i=i;return}function Zl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+496>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+496|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+496>>3]);h[c[(c[f>>2]|0)+132>>2]>>3]=k;GD(a,1)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+496>>3]=+h[c[(c[f>>2]|0)+124>>2]>>3];i=b;return}function _l(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0.0;b=i;d=a+400|0;e=(c[d>>2]|0)+520|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[e>>3];h[c[g+208>>2]>>3]=+h[e>>3];j=+h[e>>3];k=+ID(a,j,j);h[c[(c[f>>2]|0)+212>>2]>>3]=k;GD(a,2)|0;h[(c[d>>2]|0)+520>>3]=+h[c[(c[f>>2]|0)+204>>2]>>3];i=b;return}function $l(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+632>>3]=+h[(c[a+416>>2]|0)+504>>3]*+h[b+16>>3];i=i;return}function am(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=+h[b+632>>3]*+h[b+616>>3];i=i;return}function bm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+672>>3]=+h[b+664>>3]*+h[b+608>>3];i=i;return}function cm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[(c[a+416>>2]|0)+432>>3];i=i;return}function dm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+768>>3]=+h[b+32>>3]- +h[(c[a+416>>2]|0)+128>>3];i=i;return}function em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+704>>3]=+h[b+32>>3]*1.0e-5;i=i;return}function fm(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Zg(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+32>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+712>>3]=+h[d>>3];i=b;return}function gm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=+h[(c[a+416>>2]|0)+360>>3];i=i;return}function hm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+696>>3]=+h[b+24>>3]+-273.15;i=i;return}function im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Ci(e,c[g>>2]|0,+h[a+32>>3],+h[a+24>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+32>>3];l=+h[g+24>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ji(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+688>>3]=+h[f>>3];i=b;return}function jm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+688>>3]*9.80665;k=+h[g+768>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+680|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+680|0;p=o;h[p>>3]=m;i=d;return}q=k/+xz(c[b+536>>2]|0,j,17688,17680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+680|0;p=o;h[p>>3]=m;i=d;return}function km(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+736>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+736|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+736>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+752>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+752|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+752>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+8>>3]=k;GD(a,3)|0;a=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+736>>3]=+h[a>>3];h[f+752>>3]=+h[a+8>>3];i=b;return}function lm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0;d=i;i=i+16|0;e=d;f=d+8|0;g=b+304|0;j=+h[g>>3];k=b+536|0;l=c[k>>2]|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+h[o+736>>3];q=+h[o+760>>3];r=+h[(c[b+416>>2]|0)+344>>3];do{if(q!=0.0){s=r/q}else{if(r==0.0){s=r;break}s=r/+xz(l,q,17728,17720,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);ih(e,l,p*s,.8);s=+h[e>>3];p=+h[g>>3];ih(f,c[k>>2]|0,0.0,.8);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+784>>3]=j*s+(1.0-p)*+h[f>>3];i=d;return}function mm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0;d=i;e=+h[b+304>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+768>>3];l=+h[j+784>>3];m=+h[j+736>>3];do{if(l!=0.0){n=j;o=m/l}else{if(m==0.0){n=j;o=m;break}p=m/+xz(c[b+536>>2]|0,l,17744,17736,+h[g>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[f>>2]>>2]|0)+8>>2]|0;o=p}}while(0);h[n+792>>3]=e*k*o;i=d;return}function nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=+h[b+792>>3]*+(c[(c[a+420>>2]|0)+20>>2]|0);i=i;return}function om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+800>>3]=+h[b+736>>3]*+(c[(c[a+420>>2]|0)+20>>2]|0);i=i;return}function pm(b){b=b|0;var d=0,e=0.0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0.0;d=i;e=+h[b+304>>3];f=b+416|0;g=+h[(c[f>>2]|0)+408>>3];j=e+-1.0;do{if(g!=0.0){k=j/g}else{if(j==0.0){k=j;break}k=j/+xz(c[b+536>>2]|0,g,17768,17760,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);l=b+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;g=+h[n+688>>3];do{if(g!=0.0){o=n;p=m;q=e/g}else{if(e==0.0){o=n;p=m;q=e;break}r=e/+xz(c[b+536>>2]|0,g,17792,17760,+h[m>>3],(a[b+319|0]|0)!=0|0);s=c[c[l>>2]>>2]|0;o=c[s+8>>2]|0;p=s;q=r}}while(0);g=+h[o+800>>3];r=-g;if(k-q!=0.0){q=+h[(c[f>>2]|0)+408>>3];do{if(q!=0.0){t=o;u=p;v=j/q}else{if(j==0.0){t=o;u=p;v=j;break}k=j/+xz(c[b+536>>2]|0,q,17768,17760,+h[p>>3],(a[b+319|0]|0)!=0|0);m=c[c[l>>2]>>2]|0;t=c[m+8>>2]|0;u=m;v=k}}while(0);q=+h[t+688>>3];do{if(q!=0.0){w=e/q}else{if(e==0.0){w=e;break}w=e/+xz(c[b+536>>2]|0,q,17792,17760,+h[u>>3],(a[b+319|0]|0)!=0|0)}}while(0);x=r/(v-w);y=c[l>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+776|0;G=F;h[G>>3]=x;i=d;return}if(g==-0.0){x=r;y=c[l>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+776|0;G=F;h[G>>3]=x;i=d;return}u=b+536|0;t=c[u>>2]|0;g=+h[(c[f>>2]|0)+408>>3];do{if(g!=0.0){H=o;I=p;J=j/g}else{if(j==0.0){H=o;I=p;J=j;break}w=j/+xz(t,g,17768,17760,+h[p>>3],(a[b+319|0]|0)!=0|0);f=c[c[l>>2]>>2]|0;H=c[f+8>>2]|0;I=f;J=w}}while(0);g=+h[H+688>>3];do{if(g!=0.0){K=I;L=e/g}else{if(e==0.0){K=I;L=e;break}j=e/+xz(c[u>>2]|0,g,17792,17760,+h[I>>3],(a[b+319|0]|0)!=0|0);K=c[c[l>>2]>>2]|0;L=j}}while(0);x=r/+xz(t,J-L,17808,17760,+h[K>>3],(a[b+319|0]|0)!=0|0);y=c[l>>2]|0;z=c[y>>2]|0;A=z;B=A+8|0;C=B;D=c[C>>2]|0;E=D;F=E+776|0;G=F;h[G>>3]=x;i=d;return}function qm(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[(c[b+420>>2]|0)+20>>2]|0;f=+(e|0);g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+776>>3];if((e|0)!=0){m=k;n=l/f;o=m;p=o+744|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+744|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[b+536>>2]|0,f,17920,17912,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+744|0;q=p;h[q>>3]=n;i=d;return}function rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+688>>3]*.05;i=i;return}function sm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Ci(e,c[g>>2]|0,+h[a+32>>3],+h[a+24>>3],0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+32>>3];l=+h[g+24>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Hi(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[f>>3];i=b;return}function tm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+32>>3],+h[a+728>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+32>>3];l=+h[g+728>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Gi(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+256>>3]=+h[f>>3];i=b;return}function um(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+32>>3],+h[a+728>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+32>>3];l=+h[g+728>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+296>>3]=+h[f>>3];i=b;return}function vm(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Fi(d,c[a+536>>2]|0,+h[f+296>>3],+h[f+256>>3],+h[f+32>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+272>>3]=+h[d>>3];i=b;return}function wm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+848>>3]=+h[b+728>>3]- +h[d+776>>3]*+h[d+192>>3];i=i;return}function xm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+112>>3],+h[a+848>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+112>>3];l=+h[g+848>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[f>>3];i=b;return}function ym(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+728>>3];k=+h[g+688>>3];l=+h[g+32>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+720|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+720|0;r=q;h[r>>3]=o;i=d;return}s=l/+xz(c[b+536>>2]|0,k,17792,17952,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+720|0;r=q;h[r>>3]=o;i=d;return}function zm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+840>>3]=+h[b+832>>3]*+h[b+720>>3];i=i;return}function Am(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+304>>3]=+h[b+808>>3];i=i;return}function Bm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+280>>3]=+h[b+304>>3]*1.0e3;i=i;return}function Cm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+88>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+88|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+88>>3]);e=c[f>>2]|0;h[c[e+372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+856>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+856|0;h[(c[e+368>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+856>>3]);h[(c[(c[f>>2]|0)+372>>2]|0)+8>>3]=k;GD(a,4)|0;j=c[(c[f>>2]|0)+364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+88>>3]=+h[j>>3];h[f+856>>3]=+h[j+8>>3];bj(a);cj(a);dj(a);ej(a);fj(a);gj(a);hj(a);i=b;return}function Dm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[b+776>>3]- +h[b+224>>3];i=i;return}function Em(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=-+h[b+824>>3]/-.05;i=i;return}function Fm(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;a=fD(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+776>>3],0.0)|0;e=fD(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;d=f+728|0;h[f+816>>3]=+h[f+776>>3]*+h[(a<<24>>24==0?d:f+1152|0)>>3]- +h[f+224>>3]*+h[(e<<24>>24==0?d:f+864|0)>>3];i=b;return}function Gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+896>>3]=+h[b+816>>3]+ +h[b+808>>3];i=i;return}function Hm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+832>>3];k=+h[g+896>>3]- +h[g+824>>3]*+h[g+720>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}q=k/+xz(c[b+536>>2]|0,j,17968,17960,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+880|0;p=o;h[p>>3]=m;i=d;return}function Im(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+72>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+72|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+72>>3]);e=c[f>>2]|0;h[c[e+452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+920>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+920|0;h[(c[e+448>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+920>>3]);j=c[f>>2]|0;h[(c[j+452>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+444>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+64>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+64|0;h[(c[j+448>>2]|0)+16>>3]=+h[e>>3];k=+ID(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+64>>3]);h[(c[(c[f>>2]|0)+452>>2]|0)+16>>3]=k;GD(a,5)|0;a=c[(c[f>>2]|0)+444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+72>>3]=+h[a>>3];h[f+920>>3]=+h[a+8>>3];h[f+64>>3]=+h[a+16>>3];i=b;return}function Jm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(fD(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+264>>3]=+h[(a?e+280|0:e+272|0)>>3];i=b;return}function Km(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=fD(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+376>>3]=+h[e+224>>3]*+h[(a<<24>>24==0?e+624|0:e+848|0)>>3];i=b;return}function Lm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;m=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;Pi(g,c[n>>2]|0,+h[o+112>>3],+h[(m<<24>>24==0?o+624|0:o+848|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+112>>3];s=+h[(l<<24>>24==0?q+624|0:q+848|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));Ni(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+424>>3];r=+h[p+224>>3];if(s!=0.0){t=p;u=r/s;v=t;w=v+400|0;x=w;h[x>>3]=u;i=d;return}if(r==0.0){t=p;u=r;v=t;w=v+400|0;x=w;h[x>>3]=u;i=d;return}y=r/+xz(c[n>>2]|0,s,17984,17976,+h[e>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[k>>2]>>2]|0)+8>>2]|0;u=y;v=t;w=v+400|0;x=w;h[x>>3]=u;i=d;return}function Mm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+400>>3];e=c[a+416>>2]|0;h[b+352>>3]=+h[b+224>>3]*(d*d*.5+ +h[e+776>>3]*+h[e+24>>3]);i=i;return}function Nm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=+h[b+376>>3]+(+h[b+384>>3]+(+h[b+352>>3]+ +h[b+360>>3]));i=i;return}function Om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+656>>3]=+h[b+224>>3]- +h[b+544>>3];i=i;return}function Pm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+48>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+48|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+ID(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+48>>3]);e=c[f>>2]|0;h[c[e+532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+872>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+872|0;h[(c[e+528>>2]|0)+8>>3]=+h[g>>3];k=+ID(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+872>>3]);h[(c[(c[f>>2]|0)+532>>2]|0)+8>>3]=k;GD(a,6)|0;j=c[(c[f>>2]|0)+524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+48>>3]=+h[j>>3];h[f+872>>3]=+h[j+8>>3];mj(a);nj(a);oj(a);pj(a);qj(a);i=b;return}function Qm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+504>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+872>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}q=k/+xz(c[b+536>>2]|0,e,18384,18376,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}function Rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+224>>3]*+h[(c[a+416>>2]|0)+168>>3];i=i;return}function Sm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(fD(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+224>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+288>>3]=+h[(a?e+304|0:e+296|0)>>3];i=b;return}function Tm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+216>>3]*+h[j+304>>3]*+h[e+160>>3];l=+h[j+224>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+240|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+240|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[b+536>>2]|0,k,18416,18408,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+240|0;q=p;h[q>>3]=n;i=d;return}function Um(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+216>>3]*+h[j+296>>3]*+h[e+160>>3];l=+h[j+224>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+232|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+232|0;q=p;h[q>>3]=n;i=d;return}r=l/+xz(c[b+536>>2]|0,k,18488,18480,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+232|0;q=p;h[q>>3]=n;i=d;return}function Vm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+816>>3]*100.0;i=i;return}function Wm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+616>>3]=+h[b+784>>3];i=i;return}function Xm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+576>>3]=+h[b+768>>3];i=i;return}function Ym(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+38|0]=a[d+33|0]|0;i=i;return}function Zm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+520>>3]=+h[b+768>>3];i=i;return}function _m(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+816>>3]*100.0;i=i;return}function $m(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+456>>3]=+h[b+768>>3];i=i;return}function an(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+30|0]=a[d+23|0]|0;i=i;return}function bn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+400>>3]=+h[b+344>>3];i=i;return}function cn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+784>>3];i=i;return}function dn(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+12>>2]=(c[b+8>>2]|0)+ -1;i=i;return}function en(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+488>>3]=0.0;i=i;return}function fn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1224>>3]=0.0;i=i;return}function gn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+480>>3]=0.0;i=i;return}function hn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1216>>3]=84013.05815259689;i=i;return}function jn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+472>>3]=0.0;i=i;return}function kn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=0;i=i;return}function ln(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function mn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1208>>3]=.05;i=i;return}function nn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=+h[(c[a+416>>2]|0)+144>>3]+-273.15;i=i;return}function on(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+416>>3]=0.0;i=i;return}function pn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+392>>3]=0.0;i=i;return}function qn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+368>>3]=0.0;i=i;return}function rn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1048>>3]=0.0;i=i;return}function sn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=1;i=i;return}function tn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+344>>3]=1.0;i=i;return}function un(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=1;i=i;return}function vn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1024>>3]=461.5236365065454;i=i;return}function wn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1016>>3]=.018015268;i=i;return}function xn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=1;i=i;return}function yn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+336>>3]=1.0;i=i;return}function zn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=1;i=i;return}function An(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+992>>3]=461.5236365065454;i=i;return}function Bn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+984>>3]=.018015268;i=i;return}function Cn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+976>>3]=84013.05815259689;i=i;return}function Dn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function En(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function Fn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+328>>3]=1.0;i=i;return}function Gn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=1;i=i;return}function Hn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+968>>3]=461.5236365065454;i=i;return}function In(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+960>>3]=.018015268;i=i;return}function Jn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function Kn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+320>>3]=.6563429036687328;i=i;return}function Ln(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+312>>3]=1.0;i=i;return}function Mn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=1;i=i;return}function Nn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+952>>3]=461.5236365065454;i=i;return}function On(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+944>>3]=.018015268;i=i;return}function Pn(b){b=b|0;var d=0,e=0,f=0;d=i;e=b+314|0;a[e]=1;ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);f=b+484|0;c[c[(c[f>>2]|0)+20>>2]>>2]=(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+2;c[c[(c[f>>2]|0)+24>>2]>>2]=(c[b+408>>2]|0)+2;jD(b,0)|0;Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);a[e]=0;i=d;return 0}function Qn(a){a=a|0;c[a+4>>2]=98;c[a>>2]=1;c[a+12>>2]=155;c[a+16>>2]=156;c[a+44>>2]=256;c[a+40>>2]=1;c[a+52>>2]=157;c[a+56>>2]=158;i=i;return}function Rn(a){a=a|0;i=i;return 0}function Sn(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+752>>3];i=i;return}function Tn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+544>>3]=+h[(c[a+416>>2]|0)+616>>3];i=i;return}function Un(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+552>>3]=+h[(c[a+416>>2]|0)+608>>3];i=i;return}function Vn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+464>>3];i=i;return}function Wn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+624>>3]=+h[(c[a+416>>2]|0)+472>>3];i=i;return}function Xn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=+h[(c[a+416>>2]|0)+528>>3];i=i;return}function Yn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=+h[(c[a+416>>2]|0)+528>>3];i=i;return}function Zn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+88>>3]=+h[(c[a+416>>2]|0)+528>>3];i=i;return}function _n(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=+h[(c[a+416>>2]|0)+360>>3];i=i;return}function $n(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=+h[(c[a+416>>2]|0)+368>>3];i=i;return}



function V0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Pc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);l=+Z2(b,g,c[33940]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function W0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Pc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);l=+Z2(b,g,c[33940]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function X0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Pc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);l=+Z2(b,g,c[33940]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function Y0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Pc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);n=mb(b|0,h|0,f|0,c[33940]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function Z0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Pc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);m=mb(b|0,h|0,f|0,c[33940]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function _0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Pc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);m=mb(b|0,h|0,f|0,c[33940]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function $0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Pc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);m=mb(b|0,h|0,f|0,c[33940]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function a1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Pc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);n=Ic(b|0,h|0,f|0,c[33940]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function b1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Pc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[135768]|0)==0){if((_a(135768)|0)==0){break}c[33940]=$b(2147483647,135776,0)|0;Ub(135768)}}while(0);m=Ic(b|0,h|0,f|0,c[33940]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function c1(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;ie[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;ie[h&255](a);i=b;return}}function d1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){Y_(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=H2(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;f3(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{J2(h);i=e;return}}function e1(a){a=a|0;a=i;_U(140964|0);_U(140952|0);_U(140940|0);_U(140928|0);_U(140916|0);_U(140904|0);_U(140892|0);_U(140880|0);_U(140868|0);_U(140856|0);_U(140844|0);_U(140832|0);_U(140820|0);_U(140808|0);_U(140796|0);_U(140784|0);_U(140772|0);_U(140760|0);_U(140748|0);_U(140736|0);_U(140724|0);_U(140712|0);_U(140700|0);_U(140688);i=a;return}function f1(a){a=a|0;a=i;wU(141292|0);wU(141280|0);wU(141268|0);wU(141256|0);wU(141244|0);wU(141232|0);wU(141220|0);wU(141208|0);wU(141196|0);wU(141184|0);wU(141172|0);wU(141160|0);wU(141148|0);wU(141136|0);wU(141124|0);wU(141112|0);wU(141100|0);wU(141088|0);wU(141076|0);wU(141064|0);wU(141052|0);wU(141040|0);wU(141028|0);wU(141016);i=a;return}function g1(a){a=a|0;a=i;_U(141604|0);_U(141592|0);_U(141580|0);_U(141568|0);_U(141556|0);_U(141544|0);_U(141532|0);_U(141520|0);_U(141508|0);_U(141496|0);_U(141484|0);_U(141472|0);_U(141460|0);_U(141448|0);_U(141436|0);_U(141424|0);_U(141412|0);_U(141400|0);_U(141388|0);_U(141376|0);_U(141364|0);_U(141352|0);_U(141340|0);_U(141328);i=a;return}function h1(a){a=a|0;a=i;wU(142444|0);wU(142432|0);wU(142420|0);wU(142408|0);wU(142396|0);wU(142384|0);wU(142372|0);wU(142360|0);wU(142348|0);wU(142336|0);wU(142324|0);wU(142312|0);wU(142300|0);wU(142288|0);wU(142276|0);wU(142264|0);wU(142252|0);wU(142240|0);wU(142228|0);wU(142216|0);wU(142204|0);wU(142192|0);wU(142180|0);wU(142168);i=a;return}function i1(a){a=a|0;a=i;_U(142836|0);_U(142824|0);_U(142812|0);_U(142800|0);_U(142788|0);_U(142776|0);_U(142764|0);_U(142752|0);_U(142740|0);_U(142728|0);_U(142716|0);_U(142704|0);_U(142692|0);_U(142680);i=a;return}function j1(a){a=a|0;a=i;wU(143372|0);wU(143360|0);wU(143348|0);wU(143336|0);wU(143324|0);wU(143312|0);wU(143300|0);wU(143288|0);wU(143276|0);wU(143264|0);wU(143252|0);wU(143240|0);wU(143228|0);wU(143216);i=a;return}function k1(a){a=a|0;var b=0,c=0;b=i;if((q1(a)|0)==0){c=(l1(a)|0)!=0|0}else{c=1}i=b;return c|0}function l1(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[143528+((d[143528+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function m1(a){a=a|0;var b=0,c=0;b=i;c=yb(a|0)|0;i=b;return c|0}function n1(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function o1(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 1:{d=k1(a)|0;break};case 2:{d=l1(a)|0;break};case 7:{d=s1(a)|0;break};case 5:{d=q1(a)|0;break};case 6:{d=r1(a)|0;break};case 11:{d=w1(a)|0;break};case 4:{d=n1(a)|0;break};case 9:{d=u1(a)|0;break};case 10:{d=v1(a)|0;break};case 8:{d=t1(a)|0;break};case 12:{d=x1(a)|0;break};case 3:{d=m1(a)|0;break};default:{d=0}}i=c;return d|0}function p1(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=146504;while(1){if(d<<24>>24==e<<24>>24){if(($2(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function q1(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function r1(a){a=a|0;var b=0,c=0;b=i;if((v1(a)|0)==0){c=(t1(a)|0)!=0|0}else{c=0}i=b;return c|0}function s1(a){a=a|0;var b=0,c=0;b=i;if((y1(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function t1(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function u1(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[146584+((d[146584+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function v1(a){a=a|0;var b=0,c=0;b=i;c=(a2(149752,a)|0)!=0|0;i=b;return c|0}function w1(a){a=a|0;var b=0,c=0;b=i;c=(A1(a)|0)!=(a|0)|0;i=b;return c|0}function x1(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function y1(a){a=a|0;var b=0,c=0;b=i;c=z1(a,0)|0;i=b;return c|0}function z1(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((l1(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[149842+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[149840+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[149843+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[150088+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[150088+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[150088+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function A1(a){a=a|0;var b=0,c=0;b=i;c=z1(a,1)|0;i=b;return c|0}function B1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=C1(0,a,b,(c|0)!=0?c:150792)|0;i=d;return e|0}function C1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?150800:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[150584+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Pc()|0)>>2]=84;k=-1;i=g;return k|0}function D1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=E1(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=C1(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function E1(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[150584+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[150584+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Pc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function F1(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[150584+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Pc()|0)>>2]=84;j=-1;i=g;return j|0}function G1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Pc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function H1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=I1(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=G1(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function I1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=G1(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=G1(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=G1(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}G1(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function J1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=B2(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=B2(2048)|0;c[p+16>>2]=s;if((s|0)==0){C2(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=Z1(0,0)|0;if((s|0)==0){C2(c[p+16>>2]|0);C2(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=K1(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=D2(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=L1(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=B2(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;h3(y|0,-1,v|0)|0;I=H}else{I=0}H=D2(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=D2(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=L1(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=R1(q,x)|0;b:do{if((v|0)==0){y=R1(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==2){T=c[S+4>>2]|0;U=R1(q,L)|0;if((U|0)!=0){V=N;W=U;break c}U=R1(q,S)|0;if((U|0)!=0){V=N;W=U;break c}U=R1(q,1)|0;if((U|0)!=0){V=N;W=U;break c}U=R1(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=R1(q,0)|0;if((U|0)!=0){V=N;W=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{X=L}}if((F|0)==45){F=0;c[j>>2]=0;X=0}Y=X;Z=M+1|0;_=N;break}else if((P|0)==3){T=c[S+4>>2]|0;U=R1(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=R1(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=R1(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}$=R1(q,0)|0}else if((P|0)==0){U=c[S+4>>2]|0;T=c[U>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Y=L;Z=M;_=N;break}T=U+8|0;U=(c[T>>2]|0)+L|0;c[T>>2]=U;if((U|0)<=(c[k>>2]|0)){Y=L;Z=M;_=N;break}c[k>>2]=U;Y=L;Z=M;_=N;break}else if((P|0)==1){P=c[S+4>>2]|0;U=R1(q,c[P+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=R1(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=R1(q,c[P>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}$=R1(q,0)|0}else{Y=L;Z=M;_=N;break}if(($|0)==0){Y=L;Z=M;_=N}else{V=N;W=$;break c}}else if((R|0)==1){U=S+4|0;P=c[U>>2]|0;T=O+ -3|0;c[u>>2]=T;aa=c[Q+(T<<2)>>2]|0;c[j>>2]=aa;T=P+4|0;ba=c[T>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=P;F=51}else{if((c[P+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=P;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=S1(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=$1(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=$1(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[T>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;T=P+8|0;ba=c[T>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=S1(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=$1(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=$1(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=S1(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=$1(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=$1(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=$1(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=$1(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=$1(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=$1(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[T>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}T=$1(s,0,0,1,32)|0;if((T|0)==0){J=12;break b}ba=$1(s,0,0,1,8)|0;P=T+4|0;c[P>>2]=ba;if((ba|0)==0){J=12;break b}c[T>>2]=1;c[T+8>>2]=-1;c[T+12>>2]=-1;c[ba>>2]=ia;c[(c[P>>2]|0)+4>>2]=ra;c[T+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=T;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[U>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}T=M+ -1|0;P=da-aa+N|0;if((T|0)!=0){Y=da;Z=T;_=P;break}c[j>>2]=P;Y=P;Z=0;_=P}else{Y=L;Z=M;_=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Y;M=Z;N=_;O=S}else{V=_;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=$1(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=$1(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=$1(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=$1(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=R1(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=R1(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==3){M=c[ya+4>>2]|0;L=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==0){Q=c[ya>>2]|0;if((Q|0)==3){R=R1(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=R1(q,1)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;P=R1(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}P=R1(q,0)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}P=R1(q,c[c[R>>2]>>2]|0)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}P=R1(q,0)|0;if((P|0)==0){break}else{z=0;A=P;B=0;C=D;break a}}else if((Q|0)==1){P=R1(q,ya)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}P=R1(q,2)|0;if((P|0)!=0){z=0;A=P;B=0;C=D;break a}P=ya+4|0;R=R1(q,c[(c[P>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=R1(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=R1(q,c[c[P>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=R1(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((Q|0)==0){R=c[ya+4>>2]|0;P=c[R>>2]|0;if((P|0)==-4){c[ya+8>>2]=0;T=R+8|0;ba=c[T>>2]|0;la=$1(s,0,0,1,64)|0;if((la|0)==0){F=104;break g}ma=la;c[la>>2]=ba;c[la+4>>2]=0;c[la+8>>2]=1114111;c[la+20>>2]=0;c[la+24>>2]=0;ba=la+28|0;la=ya+24|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[la>>2]=ma;ma=c[T>>2]|0;T=c[R+4>>2]|0;la=$1(s,0,0,1,64)|0;if((la|0)==0){F=106;break g}c[la>>2]=ma;c[la+4>>2]=0;c[la+8>>2]=1114111;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=T;c[la+32>>2]=-1;c[la+36>>2]=-1;c[la+40>>2]=-1;c[ya+28>>2]=la;break}la=ya+8|0;if((P|0)<0){c[la>>2]=1;T=$1(s,0,0,1,32)|0;if((T|0)==0){F=110;break g}c[T>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[ya+24>>2]=T;T=$1(s,0,0,1,32)|0;if((T|0)==0){F=112;break g}c[T>>2]=-1;c[T+4>>2]=-1;c[T+8>>2]=-1;c[ya+28>>2]=T;break}else{c[la>>2]=0;la=R+8|0;T=c[la>>2]|0;ma=R+4|0;ba=c[ma>>2]|0;ka=$1(s,0,0,1,64)|0;if((ka|0)==0){F=115;break g}ea=ka;c[ka>>2]=T;c[ka+4>>2]=P;c[ka+8>>2]=ba;c[ka+20>>2]=0;c[ka+24>>2]=0;ba=ka+28|0;ka=ya+24|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[ka>>2]=ea;ea=c[la>>2]|0;la=c[R>>2]|0;ka=c[ma>>2]|0;ma=c[R+12>>2]|0;ba=c[R+16>>2]|0;R=$1(s,0,0,1,64)|0;if((R|0)==0){F=117;break g}P=R;c[R>>2]=ea;c[R+4>>2]=la;c[R+8>>2]=ka;c[R+20>>2]=ma;c[R+24>>2]=ba;ba=R+28|0;R=ya+28|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[R>>2]=P;break}}else if((Q|0)==2){Q=R1(q,ya)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=R1(q,3)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=R1(q,c[c[ya+4>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=R1(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else{break}}else if((S|0)==1){Q=c[ya+4>>2]|0;P=c[Q>>2]|0;R=Q+4|0;ba=c[R>>2]|0;if((c[P+8>>2]|0)==0){za=(c[ba+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;ma=P1(s,c[P+24>>2]|0,c[ba+24>>2]|0,0,0)|0;c[ya+24>>2]=ma;if((ma|0)==0){z=0;A=12;B=0;C=D;break a}ma=P1(s,c[(c[Q>>2]|0)+28>>2]|0,c[(c[R>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=ma;if((ma|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==2){ma=c[ya+4>>2]|0;R=c[ma>>2]|0;Q=R+8|0;if((c[Q>>2]|0)==0){Aa=0}else{Aa=(c[(c[ma+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[Q>>2]|0)==0){c[ya+24>>2]=c[R+24>>2];Ba=ma+4|0}else{Q=Q1(q,R,0,0,g)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Ca=B2((c[g>>2]<<2)+4|0)|0;Q=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=Q1(q,c[ma>>2]|0,Q,h,0)|0;if((Da|0)!=0){F=150;break g}R=ma+4|0;ba=P1(s,c[(c[R>>2]|0)+24>>2]|0,c[(c[ma>>2]|0)+24>>2]|0,Q,c[h>>2]|0)|0;Q=ya+24|0;c[Q>>2]=ba;C2(Ca);if((c[Q>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=R}}R=c[Ba>>2]|0;if((c[R+8>>2]|0)==0){c[ya+28>>2]=c[R+28>>2];break}Q=Q1(q,R,0,0,g)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Ea=B2((c[g>>2]<<2)+4|0)|0;Q=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=Q1(q,c[Ba>>2]|0,Q,h,0)|0;if((Fa|0)!=0){F=157;break g}R=P1(s,c[(c[ma>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,Q,c[h>>2]|0)|0;Q=ya+28|0;c[Q>>2]=R;C2(Ea);if((c[Q>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){C2(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){C2(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=B2(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=B2(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){h3(O|0,0,((E|0)>1?E<<2:4)|0)|0}M1(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;Q=O+(S<<2)|0;R=K+1+(c[Q>>2]|0)|0;c[Q>>2]=0;Q=S+1|0;if((Q|0)<(E|0)){S=Q;K=R}else{Ga=R;break}}}else{Ga=0}K=D2(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;R=M1(y,S,x,u)|0;if((R|0)!=0){z=x;A=R;B=u;C=D;break}c[w+20>>2]=0;R=v+24|0;S=c[R>>2]|0;if((c[S>>2]|0)>-1){Q=1;ma=S;while(1){S=ma+32|0;ba=Q+1|0;if((c[S>>2]|0)>-1){ma=S;Q=ba}else{Ha=ba;break}}}else{Ha=1}Q=D2(Ha,32)|0;if((Q|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=Q;ma=c[R>>2]|0;y=c[ma>>2]|0;if((y|0)>-1){ba=y;y=ma;ma=0;while(1){c[Q+(ma<<5)+8>>2]=K+(c[N+(ba<<2)>>2]<<5);c[Q+(ma<<5)+12>>2]=ba;S=Q+(ma<<5)+16|0;c[S>>2]=0;P=y+12|0;ka=c[P>>2]|0;if((ka|0)!=0){la=0;while(1){Ia=la+1|0;if((c[ka+(la<<2)>>2]|0)>-1){la=Ia}else{break}}la=Ia<<2;ka=B2(la)|0;c[S>>2]=ka;if((ka|0)==0){z=x;A=12;B=u;C=D;break a}f3(ka|0,c[P>>2]|0,la|0)|0}c[Q+(ma<<5)+20>>2]=c[y+16>>2];la=ma+1|0;ka=y+32|0;ea=c[ka>>2]|0;if((ea|0)>-1){ba=ea;y=ka;ma=la}else{Ja=la;break}}}else{Ja=0}c[Q+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;_1(s);C2(c[p+16>>2]|0);C2(p);C2(O);C2(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);_1(s);C2(c[p+16>>2]|0);C2(p);if((z|0)!=0){C2(z)}if((B|0)!=0){C2(B)}c[b+4>>2]=C;N1(b);r=A;i=f;return r|0}function K1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;R1(m,c[p>>2]|0)|0;R1(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=R1(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 9:{Q=c[q>>2]|0;R=a[Q]|0;switch(R<<24>>24|0){case 63:case 43:{if((c[v>>2]&1|0)==0){S=M;T=N;U=0;break c}else{V=41}break};case 42:{V=41;break};case 92:{W=c[v>>2]|0;if((W&1|0)!=0){S=M;T=N;U=0;break c}X=Q+1|0;if((a[X]|0)!=123){S=M;T=N;U=0;break c}c[q>>2]=X;Y=W;Z=X;break};case 123:{X=c[v>>2]|0;if((X&1|0)==0){S=M;T=N;U=0;break c}else{Y=X;Z=Q}break};default:{S=M;T=N;U=0;break c}}if((V|0)==41){V=0;c[q>>2]=Q+1;Q=c[w>>2]|0;X=$1(Q,0,0,1,32)|0;if((X|0)==0){_=12;V=294;break b}W=$1(Q,0,0,1,16)|0;c[X+4>>2]=W;if((W|0)==0){_=12;V=294;break b}c[X>>2]=2;c[X+8>>2]=-1;c[X+12>>2]=-1;c[W>>2]=N;c[W+4>>2]=R<<24>>24==43;c[W+8>>2]=R<<24>>24==63?1:-1;R=W+12|0;a[R]=a[R]&-2;c[X+16>>2]=c[N+16>>2];S=M;T=X;U=R1(m,9)|0;break c}X=Z+1|0;c[q>>2]=X;R=a[X]|0;if((R+ -48<<24>>24&255)<10){W=R<<24>>24;if((W+ -48|0)>>>0<10){$=W;aa=-1;ba=X}else{_=10;V=294;break b}while(1){W=((aa|0)<0?-48:(aa*10|0)+ -48|0)+$|0;Q=ba+1|0;ca=a[Q]|0;da=ca<<24>>24;if((da+ -48|0)>>>0<10){ba=Q;aa=W;$=da}else{ea=ca;fa=W;ga=Q;break}}}else{ea=R;fa=-1;ga=X}do{if(ea<<24>>24==44){Q=ga+1|0;W=a[Q]|0;ca=W<<24>>24;if((ca+ -48|0)>>>0<10){ha=ca;ia=-1;ja=Q}else{ka=W;la=-1;ma=Q;break}while(1){Q=((ia|0)<0?-48:(ia*10|0)+ -48|0)+ha|0;W=ja+1|0;ca=a[W]|0;da=ca<<24>>24;if((da+ -48|0)>>>0<10){ja=W;ia=Q;ha=da}else{na=ca;oa=Q;pa=W;V=54;break}}}else{na=ea;oa=fa;pa=ga;V=54}}while(0);do{if((V|0)==54){V=0;if(!((oa|0)>-1)){ka=na;la=oa;ma=pa;break}if((fa|0)>(oa|0)|(oa|0)>255){_=10;V=294;break b}else{ka=na;la=oa;ma=pa}}}while(0);if(ka<<24>>24==0){_=9;V=294;break b}if((ma|0)==(X|0)){_=10;V=294;break b}if((Y&1|0)==0){if(!(ka<<24>>24==92)){_=10;V=294;break b}if((a[ma+1|0]|0)!=125){_=10;V=294;break b}qa=ma+2|0}else{if(!(ka<<24>>24==125)){_=10;V=294;break b}qa=ma+1|0}if((la|fa|0)==0){R=c[w>>2]|0;W=$1(R,0,0,1,32)|0;if((W|0)==0){_=12;V=294;break b}Q=$1(R,0,0,1,20)|0;c[W+4>>2]=Q;if((Q|0)==0){_=12;V=294;break b}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;ra=W}else{W=(la&fa|0)<0;Q=c[w>>2]|0;R=$1(Q,0,0,1,32)|0;if((R|0)==0){_=12;V=294;break b}ca=$1(Q,0,0,1,16)|0;c[R+4>>2]=ca;if((ca|0)==0){_=12;V=294;break b}c[R>>2]=2;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ca>>2]=N;c[ca+4>>2]=W?1:fa;c[ca+8>>2]=W?1:la;W=ca+12|0;a[W]=a[W]&-2;c[R+16>>2]=c[N+16>>2];ra=R}c[q>>2]=qa;S=M;T=ra;U=R1(m,9)|0;break};case 4:{R=R1(m,9)|0;if((R|0)!=0){sa=M;ta=R;V=6;break b}S=M;T=N;U=R1(m,1)|0;break};case 8:{R=L+ -2|0;c[n>>2]=R;W=c[P+(R<<2)>>2]|0;R=c[w>>2]|0;ca=$1(R,0,0,1,32)|0;if((ca|0)==0){_=12;V=294;break b}Q=$1(R,0,0,1,8)|0;R=ca+4|0;c[R>>2]=Q;if((Q|0)==0){_=12;V=294;break b}c[ca>>2]=3;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[Q>>2]=W;c[(c[R>>2]|0)+4>>2]=N;c[ca+16>>2]=(c[N+16>>2]|0)+(c[W+16>>2]|0);S=M;T=ca;U=0;break};case 6:{ca=L+ -2|0;c[n>>2]=ca;W=c[P+(ca<<2)>>2]|0;ca=c[w>>2]|0;R=$1(ca,0,0,1,32)|0;if((R|0)==0){_=12;V=294;break b}Q=$1(ca,0,0,1,8)|0;ca=R+4|0;c[ca>>2]=Q;if((Q|0)==0){_=12;V=294;break b}c[R>>2]=1;c[R+8>>2]=-1;c[R+12>>2]=-1;c[Q>>2]=W;c[(c[ca>>2]|0)+4>>2]=N;c[R+16>>2]=(c[N+16>>2]|0)+(c[W+16>>2]|0);S=M;T=R;U=0;break};case 7:{R=c[q>>2]|0;W=a[R]|0;if((W|0)==41){c[q>>2]=R+1;S=M;T=N;U=0;break c}else if((W|0)!=124){S=M;T=N;U=0;break c}W=R1(m,7)|0;if((W|0)!=0){sa=M;ta=W;V=6;break b}W=R1(m,N)|0;if((W|0)!=0){sa=M;ta=W;V=6;break b}W=R1(m,8)|0;if((W|0)!=0){sa=M;ta=W;V=6;break b}W=R1(m,3)|0;if((W|0)!=0){sa=M;ta=W;V=6;break b}c[q>>2]=(c[q>>2]|0)+1;S=M;T=N;U=0;break};case 3:{W=R1(m,5)|0;if((W|0)!=0){sa=M;ta=W;V=6;break b}S=M;T=N;U=R1(m,4)|0;break};case 5:{W=c[q>>2]|0;R=a[W]|0;if(R<<24>>24==0){S=M;T=N;U=0;break c}ca=c[v>>2]&1;Q=(ca|0)!=0;if(Q&R<<24>>24==124){S=M;T=N;U=0;break c}do{if(!(Q&R<<24>>24==41&(M|0)>0)){if((ca|0)==0&R<<24>>24==92){if((a[W+1|0]|0)==41){break}}da=R1(m,5)|0;if((da|0)!=0){sa=M;ta=da;V=6;break b}da=R1(m,N)|0;if((da|0)!=0){sa=M;ta=da;V=6;break b}da=R1(m,6)|0;if((da|0)!=0){sa=M;ta=da;V=6;break b}S=M;T=N;U=R1(m,4)|0;break c}}while(0);R=(ca|M|0)==0?8:0;Q=M+ -1|0;if((ca|0)!=0){S=Q;T=N;U=R;break c}c[q>>2]=W+2;S=Q;T=N;U=R;break};case 1:{R=c[q>>2]|0;d:do{switch(a[R]|0){case 91:{Q=R+1|0;c[q>>2]=Q;X=B2(128)|0;if((X|0)==0){_=12;V=294;break b}if((a[Q]|0)==94){da=R+2|0;c[q>>2]=da;ua=da;va=1}else{ua=Q;va=0}Q=(va|0)==0;da=X;X=0;wa=0;xa=32;ya=ua;e:while(1){za=a[ya]|0;if(za<<24>>24==93){if(ya>>>0>(c[q>>2]|0)>>>0){V=85;break}}else if(za<<24>>24==0){Aa=da;Ba=ya;Ca=7;V=140;break}za=F1(e,ya,-1)|0;if((za|0)<0){c[e>>2]=-1;Da=1}else{Da=za}za=ya+Da|0;do{if((a[za]|0)==45){Ea=Da+1|0;Fa=ya+Ea|0;if((a[Fa]|0)==93){V=94;break}Ga=c[e>>2]|0;Ha=F1(e,Fa,-1)|0;if((Ha|0)<0){c[e>>2]=-1;Ia=-1;Ja=1}else{Ia=c[e>>2]|0;Ja=Ha}Ka=0;La=Ia;Ma=Ga;Na=ya+(Ja+Ea)|0;Oa=Ga>>>0>Ia>>>0?11:0}else{V=94}}while(0);f:do{if((V|0)==94){V=0;Ga=a[ya]|0;do{if(Ga<<24>>24==45){if((a[ya+1|0]|0)==93){Pa=0;break}Pa=(c[q>>2]|0)==(ya|0)?0:11}else if(Ga<<24>>24==91){Ea=a[ya+1|0]|0;if(Ea<<24>>24==61|Ea<<24>>24==46){Aa=da;Ba=ya;Ca=3;V=140;break e}else if(!(Ea<<24>>24==58)){Pa=0;break}Ea=ya+2|0;Ha=Ea;while(1){Fa=a[Ha]|0;Qa=Fa<<24>>24==0;if(Fa<<24>>24!=58&(Qa^1)){Ha=Ha+1|0}else{break}}if(Qa){Aa=da;Ba=ya;Ca=4;V=140;break e}Fa=Ha-ya+ -2|0;Ra=(Fa|0)>63?63:Fa;o3(A|0,Ea|0,Ra|0)|0;a[f+Ra|0]=0;Ra=p1(A)|0;Ka=Ra;La=1114111;Ma=0;Na=Ha+2|0;Oa=(Ra|0)==0?4:0;break f}else{Pa=0}}while(0);Ga=c[e>>2]|0;Ka=0;La=Ga;Ma=Ga;Na=za;Oa=Pa}}while(0);if((Oa|0)!=0){Aa=da;Ba=Na;Ca=Oa;V=140;break}za=(Ka|0)!=0;do{if(Q|za^1){Ga=c[w>>2]|0;if((wa|0)<(xa|0)){Sa=da;Ta=xa}else{if((xa|0)>1024){Aa=da;Ba=Na;Ca=12;V=140;break e}Ra=E2(da,xa<<3)|0;if((Ra|0)==0){Aa=da;Ba=Na;Ca=12;V=140;break e}else{Sa=Ra;Ta=xa<<1}}Ra=$1(Ga,0,0,1,32)|0;if((Ra|0)==0){V=112;break e}Fa=$1(Ga,0,0,1,20)|0;Ga=Ra+4|0;c[Ga>>2]=Fa;if((Fa|0)==0){V=112;break e}c[Ra>>2]=0;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[Fa>>2]=Ma;c[Fa+4>>2]=La;c[Fa+8>>2]=-1;c[Sa+(wa<<2)>>2]=Ra;c[(c[Ga>>2]|0)+12>>2]=Ka;Ua=Sa;Va=X;Wa=wa+1|0;Xa=Ta;Ya=0}else{if((X|0)>63){Ua=da;Va=X;Wa=wa;Xa=xa;Ya=12;break}c[g+(X<<2)>>2]=Ka;Ua=da;Va=X+1|0;Wa=wa;Xa=xa;Ya=0}}while(0);Ga=(Ya|0)==0;if(Ga&(((c[v>>2]&2|0)==0|za)^1)){Za=Ua;_a=Wa;$a=Xa;ab=Ma}else{if(Ga){da=Ua;X=Va;wa=Wa;xa=Xa;ya=Na;continue}else{Aa=Ua;Ba=Na;Ca=Ya;V=140;break}}while(1){Ga=ab;while(1){if(Ga>>>0>La>>>0){da=Za;X=Va;wa=_a;xa=$a;ya=Na;continue e}if((s1(Ga)|0)!=0){V=118;break}bb=Ga+1|0;if((w1(Ga)|0)==0){Ga=bb}else{V=129;break}}if((V|0)==118){V=0;Ra=y1(Ga)|0;Fa=Ga+1|0;g:do{if((s1(Fa)|0)==0){cb=Ra;db=Fa}else{eb=Ra;fb=Fa;while(1){if((y1(fb)|0)!=(eb+1|0)|fb>>>0>La>>>0){cb=eb;db=fb;break g}gb=y1(fb)|0;hb=fb+1|0;if((s1(hb)|0)==0){cb=gb;db=hb;break}else{eb=gb;fb=hb}}}}while(0);Fa=c[w>>2]|0;if((_a|0)<($a|0)){ib=Za;jb=$a}else{if(($a|0)>1024){Aa=Za;Ba=Na;Ca=12;V=140;break e}fb=E2(Za,$a<<3)|0;if((fb|0)==0){Aa=Za;Ba=Na;Ca=12;V=140;break e}else{ib=fb;jb=$a<<1}}fb=$1(Fa,0,0,1,32)|0;eb=fb;do{if((fb|0)==0){kb=0}else{Ha=$1(Fa,0,0,1,20)|0;c[fb+4>>2]=Ha;if((Ha|0)==0){kb=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[Ha>>2]=Ra;c[Ha+4>>2]=cb;c[Ha+8>>2]=-1;kb=eb}}while(0);c[ib+(_a<<2)>>2]=kb;lb=kb;mb=ib;nb=jb;ob=db}else if((V|0)==129){V=0;eb=A1(Ga)|0;h:do{if((w1(bb)|0)==0){pb=eb;qb=bb}else{Ra=eb;fb=bb;while(1){if((A1(fb)|0)!=(Ra+1|0)|fb>>>0>La>>>0){pb=Ra;qb=fb;break h}Fa=fb+1|0;Ha=A1(fb)|0;if((w1(Fa)|0)==0){pb=Ha;qb=Fa;break}else{Ra=Ha;fb=Fa}}}}while(0);Ga=c[w>>2]|0;if((_a|0)<($a|0)){rb=Za;sb=$a}else{if(($a|0)>1024){Aa=Za;Ba=Na;Ca=12;V=140;break e}fb=E2(Za,$a<<3)|0;if((fb|0)==0){Aa=Za;Ba=Na;Ca=12;V=140;break e}else{rb=fb;sb=$a<<1}}fb=$1(Ga,0,0,1,32)|0;Ra=fb;do{if((fb|0)==0){tb=0}else{Fa=$1(Ga,0,0,1,20)|0;c[fb+4>>2]=Fa;if((Fa|0)==0){tb=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[Fa>>2]=eb;c[Fa+4>>2]=pb;c[Fa+8>>2]=-1;tb=Ra}}while(0);c[rb+(_a<<2)>>2]=tb;lb=tb;mb=rb;nb=sb;ob=qb}if((lb|0)==0){V=141;break e}else{Za=mb;_a=_a+1|0;$a=nb;ab=ob}}}i:do{if((V|0)==85){V=0;c[q>>2]=ya+1;xa=(va|0)!=0;if(xa){ec(da|0,wa|0,4,64)}j:do{if((wa|0)>0){Q=(X|0)>0;za=X<<2;Ra=za+4|0;if(xa){ub=0;vb=0;wb=0;xb=0}else{eb=0;fb=0;while(1){Ga=da+(eb<<2)|0;Fa=c[(c[Ga>>2]|0)+4>>2]|0;do{if((Fa|0)==0){yb=fb;zb=0}else{c[Fa+8>>2]=c[x>>2];if(Q){Ha=$1(c[w>>2]|0,0,0,0,Ra)|0;Ea=Fa+16|0;c[Ea>>2]=Ha;if((Ha|0)==0){Ab=da;Bb=fb;Cb=12;break i}f3(Ha|0,z|0,za|0)|0;c[(c[Ea>>2]|0)+(X<<2)>>2]=0}else{c[Fa+16>>2]=0}if((fb|0)==0){yb=c[Ga>>2]|0;zb=0;break}Ea=c[w>>2]|0;Ha=c[Ga>>2]|0;hb=$1(Ea,0,0,1,32)|0;gb=hb;do{if((hb|0)==0){Db=0}else{Eb=$1(Ea,0,0,1,8)|0;Fb=hb+4|0;c[Fb>>2]=Eb;if((Eb|0)==0){Db=0;break}c[hb>>2]=3;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Eb>>2]=fb;c[(c[Fb>>2]|0)+4>>2]=Ha;c[hb+16>>2]=(c[Ha+16>>2]|0)+(c[fb+16>>2]|0);Db=gb}}while(0);yb=Db;zb=(Db|0)==0?12:0}}while(0);Ga=eb+1|0;if((Ga|0)<(wa|0)&(zb|0)==0){eb=Ga;fb=yb}else{Gb=0;Hb=yb;Ib=zb;break j}}}while(1){fb=da+(wb<<2)|0;eb=c[(c[fb>>2]|0)+4>>2]|0;Ga=c[eb>>2]|0;Fa=eb+4|0;gb=c[Fa>>2]|0;do{if((Ga|0)<(ub|0)){Ha=gb+1|0;Jb=(Ha|0)<(ub|0)?ub:Ha;Kb=vb;Lb=xb;Mb=0}else{if((Ga|0)<=(vb|0)){Ha=gb+1|0;Jb=Ha;Kb=Ha;Lb=xb;Mb=0;break}c[eb>>2]=vb;c[Fa>>2]=Ga+ -1;Ha=gb+1|0;if((eb|0)==0){Jb=Ha;Kb=Ha;Lb=xb;Mb=0;break}c[eb+8>>2]=c[x>>2];if(Q){hb=$1(c[w>>2]|0,0,0,0,Ra)|0;Ea=eb+16|0;c[Ea>>2]=hb;if((hb|0)==0){Ab=da;Bb=xb;Cb=12;break i}f3(hb|0,z|0,za|0)|0;c[(c[Ea>>2]|0)+(X<<2)>>2]=0}else{c[eb+16>>2]=0}if((xb|0)==0){Jb=Ha;Kb=Ha;Lb=c[fb>>2]|0;Mb=0;break}Ea=c[w>>2]|0;hb=c[fb>>2]|0;Fb=$1(Ea,0,0,1,32)|0;Eb=Fb;do{if((Fb|0)==0){Nb=0}else{Ob=$1(Ea,0,0,1,8)|0;Pb=Fb+4|0;c[Pb>>2]=Ob;if((Ob|0)==0){Nb=0;break}c[Fb>>2]=3;c[Fb+8>>2]=-1;c[Fb+12>>2]=-1;c[Ob>>2]=xb;c[(c[Pb>>2]|0)+4>>2]=hb;c[Fb+16>>2]=(c[hb+16>>2]|0)+(c[xb+16>>2]|0);Nb=Eb}}while(0);Jb=Ha;Kb=Ha;Lb=Nb;Mb=(Nb|0)==0?12:0}}while(0);fb=wb+1|0;if((fb|0)<(wa|0)&(Mb|0)==0){ub=Jb;vb=Kb;wb=fb;xb=Lb}else{Gb=Kb;Hb=Lb;Ib=Mb;break}}}else{Gb=0;Hb=0;Ib=0}}while(0);if((Ib|0)!=0|xa^1){Ab=da;Bb=Hb;Cb=Ib;break}za=c[w>>2]|0;Ra=c[x>>2]|0;Q=$1(za,0,0,1,32)|0;fb=Q;if((Q|0)==0){Ab=da;Bb=Hb;Cb=12;break}eb=$1(za,0,0,1,20)|0;c[Q+4>>2]=eb;if((eb|0)==0){Ab=da;Bb=Hb;Cb=12;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[eb>>2]=Gb;c[eb+4>>2]=1114111;c[eb+8>>2]=Ra;if((X|0)>0){Ra=X<<2;za=$1(c[w>>2]|0,0,0,0,Ra+4|0)|0;gb=eb+16|0;c[gb>>2]=za;if((za|0)==0){Ab=da;Bb=Hb;Cb=12;break}f3(za|0,z|0,Ra|0)|0;c[(c[gb>>2]|0)+(X<<2)>>2]=0}else{c[eb+16>>2]=0}if((Hb|0)==0){Ab=da;Bb=fb;Cb=0;break}eb=c[w>>2]|0;gb=$1(eb,0,0,1,32)|0;Ra=gb;do{if((gb|0)==0){Qb=0}else{za=$1(eb,0,0,1,8)|0;Ga=gb+4|0;c[Ga>>2]=za;if((za|0)==0){Qb=0;break}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[za>>2]=Hb;c[(c[Ga>>2]|0)+4>>2]=fb;c[gb+16>>2]=(c[Q+16>>2]|0)+(c[Hb+16>>2]|0);Qb=Ra}}while(0);Ab=da;Bb=Qb;Cb=(Qb|0)==0?12:0}else if((V|0)==112){V=0;c[Sa+(wa<<2)>>2]=0;Aa=Sa;Ba=Na;Ca=12;V=140}else if((V|0)==141){V=0;c[q>>2]=Na;Ab=mb;Bb=0;Cb=12}}while(0);if((V|0)==140){V=0;c[q>>2]=Ba;Ab=Aa;Bb=0;Cb=Ca}C2(Ab);c[x>>2]=(c[x>>2]|0)+1;if((Cb|0)==0){S=M;T=Bb;U=0;break c}else{_=Cb;V=294;break b}break};case 92:{wa=R+1|0;da=a[wa]|0;do{if((c[v>>2]&1|0)==0){if(da<<24>>24==40){c[q>>2]=wa;Rb=wa;V=74;break d}else{X=a[R+1|0]|0;if(X<<24>>24==41){V=265;break d}else{Sb=X;break}}}else{Sb=da}}while(0);da=R+1|0;wa=Sb<<24>>24==0;if(wa){_=5;V=294;break b}else{Tb=150812|0;Ub=0}while(1){X=Ub+1|0;if((a[150808+(Ub<<3)|0]|0)==Sb<<24>>24){Vb=Tb;break}ya=150812+(X<<3)|0;if((X|0)==12){Vb=ya;break}else{Tb=ya;Ub=X}}X=c[Vb>>2]|0;if((X|0)!=0){ya=F+0|0;Ra=G+0|0;Q=ya+40|0;do{c[ya>>2]=c[Ra>>2];ya=ya+4|0;Ra=Ra+4|0}while((ya|0)<(Q|0));c[H>>2]=X;c[I>>2]=1;Ra=K1(j)|0;if((Ra|0)!=0){_=Ra;V=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];S=M;T=c[K>>2]|0;U=0;break c}if(wa){_=5;V=294;break b}c[q>>2]=da;Ra=a[da]|0;k:do{switch(Ra|0){case 66:{ya=c[w>>2]|0;Q=$1(ya,0,0,1,32)|0;gb=Q;do{if((Q|0)==0){Xb=0}else{fb=$1(ya,0,0,1,20)|0;c[Q+4>>2]=fb;if((fb|0)==0){Xb=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[fb>>2]=-2;c[fb+4>>2]=128;c[fb+8>>2]=-1;Xb=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Yb=Xb;break};case 62:{gb=c[w>>2]|0;Q=$1(gb,0,0,1,32)|0;ya=Q;do{if((Q|0)==0){Zb=0}else{fb=$1(gb,0,0,1,20)|0;c[Q+4>>2]=fb;if((fb|0)==0){Zb=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[fb>>2]=-2;c[fb+4>>2]=32;c[fb+8>>2]=-1;Zb=ya}}while(0);c[q>>2]=(c[q>>2]|0)+1;Yb=Zb;break};case 98:{ya=c[w>>2]|0;Q=$1(ya,0,0,1,32)|0;gb=Q;do{if((Q|0)==0){_b=0}else{fb=$1(ya,0,0,1,20)|0;c[Q+4>>2]=fb;if((fb|0)==0){_b=0;break}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[fb>>2]=-2;c[fb+4>>2]=64;c[fb+8>>2]=-1;_b=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Yb=_b;break};case 120:{gb=R+2|0;c[q>>2]=gb;Q=a[gb]|0;if(Q<<24>>24==123){gb=R+3|0;c[q>>2]=gb;ya=gb;gb=0;while(1){fb=a[ya]|0;if(fb<<24>>24==0|fb<<24>>24==125){$b=gb;ac=ya;break}if((x1(fb<<24>>24)|0)==0){_=9;V=294;break b}fb=c[q>>2]|0;a[l+gb|0]=a[fb]|0;eb=gb+1|0;xa=fb+1|0;c[q>>2]=xa;if(eb>>>0>31){$b=eb;ac=xa;break}else{ya=xa;gb=eb}}c[q>>2]=ac+1;a[l+$b|0]=0;gb=Wb(C|0,0,16)|0;ya=c[w>>2]|0;eb=c[x>>2]|0;xa=$1(ya,0,0,1,32)|0;fb=xa;do{if((xa|0)==0){bc=0}else{Ga=$1(ya,0,0,1,20)|0;c[xa+4>>2]=Ga;if((Ga|0)==0){bc=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[Ga>>2]=gb;c[Ga+4>>2]=gb;c[Ga+8>>2]=eb;bc=fb}}while(0);c[x>>2]=(c[x>>2]|0)+1;Yb=bc;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;fb=(x1(Q<<24>>24)|0)==0;eb=c[q>>2]|0;if(fb){cc=eb}else{a[D]=a[eb]|0;fb=eb+1|0;c[q>>2]=fb;cc=fb}if((x1(a[cc]|0)|0)!=0){fb=c[q>>2]|0;a[E]=a[fb]|0;c[q>>2]=fb+1}fb=Wb(D|0,0,16)|0;eb=c[w>>2]|0;gb=c[x>>2]|0;xa=$1(eb,0,0,1,32)|0;ya=xa;do{if((xa|0)==0){dc=0}else{Ga=$1(eb,0,0,1,20)|0;c[xa+4>>2]=Ga;if((Ga|0)==0){dc=0;break}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[Ga>>2]=fb;c[Ga+4>>2]=fb;c[Ga+8>>2]=gb;dc=ya}}while(0);c[x>>2]=(c[x>>2]|0)+1;Yb=dc;break k}break};case 60:{ya=c[w>>2]|0;gb=$1(ya,0,0,1,32)|0;fb=gb;do{if((gb|0)==0){fc=0}else{xa=$1(ya,0,0,1,20)|0;c[gb+4>>2]=xa;if((xa|0)==0){fc=0;break}c[gb>>2]=0;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[xa>>2]=-2;c[xa+4>>2]=16;c[xa+8>>2]=-1;fc=fb}}while(0);c[q>>2]=(c[q>>2]|0)+1;Yb=fc;break};default:{if((q1(Ra)|0)!=0){fb=(a[c[q>>2]|0]|0)+ -48|0;gb=c[w>>2]|0;ya=c[x>>2]|0;xa=$1(gb,0,0,1,32)|0;if((xa|0)==0){_=12;V=294;break b}eb=$1(gb,0,0,1,20)|0;c[xa+4>>2]=eb;if((eb|0)==0){_=12;V=294;break b}c[xa>>2]=0;c[xa+8>>2]=-1;c[xa+12>>2]=-1;c[eb>>2]=-4;c[eb+4>>2]=fb;c[eb+8>>2]=ya;c[x>>2]=(c[x>>2]|0)+1;ya=c[B>>2]|0;c[B>>2]=(fb|0)<(ya|0)?ya:fb;c[q>>2]=(c[q>>2]|0)+1;S=M;T=xa;U=0;break c}xa=c[w>>2]|0;fb=a[c[q>>2]|0]|0;ya=c[x>>2]|0;eb=$1(xa,0,0,1,32)|0;gb=eb;do{if((eb|0)==0){gc=0}else{Q=$1(xa,0,0,1,20)|0;c[eb+4>>2]=Q;if((Q|0)==0){gc=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[Q>>2]=fb;c[Q+4>>2]=fb;c[Q+8>>2]=ya;gc=gb}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Yb=gc}}}while(0);if((Yb|0)==0){_=12;V=294;break b}else{S=M;T=Yb;U=0;break c}break};case 46:{Ra=(c[v>>2]&4|0)==0;da=c[w>>2]|0;wa=c[x>>2]|0;X=$1(da,0,0,1,32)|0;gb=X;ya=(X|0)==0;if(Ra){if(ya){_=12;V=294;break b}Ra=$1(da,0,0,1,20)|0;c[X+4>>2]=Ra;if((Ra|0)==0){_=12;V=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Ra>>2]=0;c[Ra+4>>2]=1114111;c[Ra+8>>2]=wa;hc=gb;ic=(c[x>>2]|0)+1|0}else{if(ya){_=12;V=294;break b}ya=$1(da,0,0,1,20)|0;c[X+4>>2]=ya;if((ya|0)==0){_=12;V=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ya>>2]=0;c[ya+4>>2]=9;c[ya+8>>2]=wa;wa=c[w>>2]|0;ya=(c[x>>2]|0)+1|0;da=$1(wa,0,0,1,32)|0;if((da|0)==0){_=12;V=294;break b}Ra=$1(wa,0,0,1,20)|0;c[da+4>>2]=Ra;if((Ra|0)==0){_=12;V=294;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Ra>>2]=11;c[Ra+4>>2]=1114111;c[Ra+8>>2]=ya;ya=c[w>>2]|0;Ra=$1(ya,0,0,1,32)|0;if((Ra|0)==0){_=12;V=294;break b}wa=$1(ya,0,0,1,8)|0;ya=Ra+4|0;c[ya>>2]=wa;if((wa|0)==0){_=12;V=294;break b}c[Ra>>2]=3;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[wa>>2]=gb;c[(c[ya>>2]|0)+4>>2]=da;c[Ra+16>>2]=(c[da+16>>2]|0)+(c[X+16>>2]|0);hc=Ra;ic=(c[x>>2]|0)+2|0}c[x>>2]=ic;c[q>>2]=(c[q>>2]|0)+1;S=M;T=hc;U=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[R+1|0]|0)!=0){break d}}Ra=c[w>>2]|0;X=$1(Ra,0,0,1,32)|0;if((X|0)==0){_=12;V=294;break b}da=$1(Ra,0,0,1,20)|0;c[X+4>>2]=da;if((da|0)==0){_=12;V=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[da>>2]=-2;c[da+4>>2]=2;c[da+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=X;U=0;break c;break};case 63:case 43:case 123:case 124:case 42:{V=264;break};case 0:{V=265;break};case 94:{if((c[v>>2]&1|0)==0){if((R|0)!=(c[r>>2]|0)){break d}X=R1(m,5)|0;if((X|0)!=0){sa=M;ta=X;V=6;break b}}X=c[w>>2]|0;da=$1(X,0,0,1,32)|0;if((da|0)==0){_=12;V=294;break b}Ra=$1(X,0,0,1,20)|0;c[da+4>>2]=Ra;if((Ra|0)==0){_=12;V=294;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Ra>>2]=-2;c[Ra+4>>2]=1;c[Ra+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=da;U=0;break c;break};case 41:{if((M|0)!=0){V=264}break};case 40:{if((c[v>>2]&1|0)!=0){Rb=R;V=74}break};default:{}}}while(0);if((V|0)==74){V=0;W=M+1|0;c[q>>2]=Rb+1;ca=R1(m,c[y>>2]|0)|0;if((ca|0)!=0){sa=W;ta=ca;V=6;break b}ca=R1(m,2)|0;if((ca|0)!=0){sa=W;ta=ca;V=6;break b}ca=R1(m,0)|0;if((ca|0)!=0){sa=W;ta=ca;V=6;break b}c[y>>2]=(c[y>>2]|0)+1;S=W;T=N;U=0;break c}else if((V|0)==264){V=0;if((c[v>>2]&1|0)!=0){V=265}}if((V|0)==265){V=0;W=c[w>>2]|0;ca=$1(W,0,0,1,32)|0;if((ca|0)==0){_=12;V=294;break b}da=$1(W,0,0,1,20)|0;c[ca+4>>2]=da;if((da|0)==0){_=12;V=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[da>>2]=-1;c[da+4>>2]=-1;c[da+8>>2]=-1;S=M;T=ca;U=0;break c}ca=F1(h,R,-1)|0;if((ca|0)<0){c[h>>2]=-1;jc=1}else{jc=ca}do{if((c[v>>2]&2|0)==0){V=280}else{if((w1(c[h>>2]|0)|0)==0){if((s1(c[h>>2]|0)|0)==0){V=280;break}}ca=c[w>>2]|0;da=y1(c[h>>2]|0)|0;W=y1(c[h>>2]|0)|0;Ra=c[x>>2]|0;X=$1(ca,0,0,1,32)|0;if((X|0)==0){_=12;V=294;break b}ya=$1(ca,0,0,1,20)|0;c[X+4>>2]=ya;if((ya|0)==0){_=12;V=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ya>>2]=da;c[ya+4>>2]=W;c[ya+8>>2]=Ra;Ra=c[w>>2]|0;ya=A1(c[h>>2]|0)|0;W=A1(c[h>>2]|0)|0;da=c[x>>2]|0;ca=$1(Ra,0,0,1,32)|0;if((ca|0)==0){_=12;V=294;break b}gb=$1(Ra,0,0,1,20)|0;c[ca+4>>2]=gb;if((gb|0)==0){_=12;V=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[gb>>2]=ya;c[gb+4>>2]=W;c[gb+8>>2]=da;da=c[w>>2]|0;gb=$1(da,0,0,1,32)|0;if((gb|0)==0){_=12;V=294;break b}W=$1(da,0,0,1,8)|0;da=gb+4|0;c[da>>2]=W;if((W|0)==0){_=12;V=294;break b}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[W>>2]=X;c[(c[da>>2]|0)+4>>2]=ca;c[gb+16>>2]=(c[ca+16>>2]|0)+(c[X+16>>2]|0);kc=gb}}while(0);if((V|0)==280){V=0;R=c[w>>2]|0;gb=c[h>>2]|0;X=c[x>>2]|0;ca=$1(R,0,0,1,32)|0;if((ca|0)==0){_=12;V=294;break b}da=$1(R,0,0,1,20)|0;c[ca+4>>2]=da;if((da|0)==0){_=12;V=294;break b}c[ca>>2]=0;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[da>>2]=gb;c[da+4>>2]=gb;c[da+8>>2]=X;kc=ca}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+jc;S=M;T=kc;U=0;break};case 0:{if((c[v>>2]&1|0)!=0){ca=R1(m,7)|0;if((ca|0)!=0){sa=M;ta=ca;V=6;break b}}S=M;T=N;U=R1(m,3)|0;break};case 2:{ca=L+ -2|0;c[n>>2]=ca;X=c[P+(ca<<2)>>2]|0;if((c[N+12>>2]|0)>-1){ca=c[w>>2]|0;da=$1(ca,0,0,1,32)|0;if((da|0)==0){_=12;V=294;break b}gb=$1(ca,0,0,1,20)|0;c[da+4>>2]=gb;if((gb|0)==0){_=12;V=294;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[gb>>2]=-1;c[gb+4>>2]=-1;c[gb+8>>2]=-1;gb=c[w>>2]|0;ca=$1(gb,0,0,1,32)|0;if((ca|0)==0){_=12;V=294;break b}R=$1(gb,0,0,1,8)|0;gb=ca+4|0;c[gb>>2]=R;if((R|0)==0){_=12;V=294;break b}c[ca>>2]=1;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[R>>2]=da;c[(c[gb>>2]|0)+4>>2]=N;gb=N+16|0;R=ca+16|0;c[R>>2]=(c[gb>>2]|0)+(c[da+16>>2]|0);c[R>>2]=c[gb>>2];lc=ca}else{lc=N}c[lc+12>>2]=X;X=lc+16|0;c[X>>2]=(c[X>>2]|0)+1;S=M;T=lc;U=0;break};case 10:{X=L+ -2|0;c[n>>2]=X;c[v>>2]=c[P+(X<<2)>>2];S=M;T=N;U=0;break};default:{S=M;T=N;U=0}}}while(0);P=c[n>>2]|0;O=(U|0)==0;if((P|0)>(o|0)&O){L=P;M=S;N=T}else{mc=O;nc=S;oc=T;pc=U;break a}}if((V|0)==6){mc=(ta|0)==0;nc=sa;oc=N;pc=ta;break}else if((V|0)==294){i=d;return _|0}}else{mc=t;nc=0;oc=0;pc=p}}while(0);p=(nc|0)>0;if(p|mc^1){_=p?8:pc;i=d;return _|0}c[b+8>>2]=oc;_=0;i=d;return _|0}function L1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=B2((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=B2((l<<2)+4|0)|0;if((p|0)==0){C2(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}R1(d,e)|0;e=R1(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 3:{E=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;G=c[D+(u+ -4<<2)>>2]|0;H=u+ -5|0;c[h>>2]=H;if(k){I=c[G+4>>2]|0;J=G+16|0;c[G+20>>2]=(c[(c[I>>2]|0)+20>>2]|0)+(c[D+(H<<2)>>2]|0)+(c[(c[I+4>>2]|0)+20>>2]|0)+((c[J>>2]|0)>0?2:0);K=J;L=c[h>>2]|0}else{K=G+16|0;L=H}H=c[D+(L+ -1<<2)>>2]|0;G=L+ -2|0;c[h>>2]=G;J=c[D+(G<<2)>>2]|0;G=L+ -3|0;c[h>>2]=G;I=c[D+(G<<2)>>2]|0;if((c[K>>2]|0)<=0){M=1;N=w;O=x;P=y;Q=z;R=H;S=0;T=B;break b}if(k){U=0}else{U1(b,E,J)|0;c[(c[r>>2]|0)+(J<<2)>>2]=1;J=U1(b,F,I)|0;c[(c[r>>2]|0)+(I<<2)>>2]=1;U=J}M=1;N=w;O=x;P=y;Q=z+2|0;R=H;S=U;T=B;break};case 6:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;H=0;do{V=A+(H<<2)|0;H=H+1|0}while((c[V>>2]|0)>-1);c[V>>2]=J<<1|1;c[A+(H<<2)>>2]=-1;I=0;while(1){if((c[p+(I<<2)>>2]|0)>-1){I=I+1|0}else{break}}c[p+(I+ -1<<2)>>2]=-1;M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break};case 1:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;if(k){H=c[(c[c[J+4>>2]>>2]|0)+20>>2]|0;F=u+ -3|0;c[h>>2]=F;c[J+20>>2]=(c[D+(F<<2)>>2]|0)+H;M=v;N=-1;O=x;P=y;Q=z;R=A;S=0;T=B;break b}else{H=u+ -3|0;c[h>>2]=H;F=c[D+(H<<2)>>2]|0;H=u+ -4|0;c[h>>2]=H;J=(F|0)==0;M=J&1;N=J?w:c[D+(H<<2)>>2]|0;O=x;P=y;Q=z;R=A;S=0;T=B;break b}break};case 5:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;if(!k){M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break b}H=c[J+4>>2]|0;c[J+20>>2]=(c[(c[H+4>>2]|0)+20>>2]|0)+(c[(c[H>>2]|0)+20>>2]|0);M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break};case 0:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;H=J;F=J+12|0;E=c[F>>2]|0;if((E|0)>-1){G=0;do{W=A+(G<<2)|0;G=G+1|0}while((c[W>>2]|0)>-1);c[W>>2]=E<<1;c[A+(G<<2)>>2]=-1;do{if(!k){I=0;while(1){if((c[p+(I<<2)>>2]|0)>-1){I=I+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((I|0)<=0){break}X=B2((I<<2)+4|0)|0;Y=X;if((X|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=X+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);E=R1(d,c[F>>2]|0)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}E=R1(d,6)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}}E=c[J>>2]|0;do{if((E|0)==3){G=c[J+4>>2]|0;ea=c[G>>2]|0;fa=c[G+4>>2]|0;G=(c[A>>2]|0)>-1;da=x+1|0;X=R1(d,G?da:x)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=R1(d,G?x:B)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=R1(d,A)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=R1(d,(c[A>>2]|0)>>>31^1)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=R1(d,J)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=fa;fa=R1(d,X)|0;if((fa|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=fa;qa=B;break}fa=ea;ea=R1(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=R1(d,3)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=R1(d,X)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=R1(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=R1(d,2)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=R1(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=R1(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}if((c[A>>2]|0)>-1){if(k){ra=w;sa=y;ta=0}else{ea=T1(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){fa=c[t>>2]|0;X=0;while(1){ua=fa+(X<<2)|0;va=X+1|0;if((c[ua>>2]|0)>-1){X=va}else{break}}c[ua>>2]=B;c[fa+(va<<2)>>2]=w;c[fa+(X+2<<2)>>2]=-1;wa=-1;xa=y+1|0}else{wa=w;xa=y}Y=c[A>>2]|0;if((Y|0)>-1){G=c[s>>2]|0;I=Y;Y=0;do{ia=(I|0)/2|0;if((I&1|0)==0){c[G+(ia*12|0)>>2]=B}else{c[G+(ia*12|0)+4>>2]=B}Y=Y+1|0;I=c[A+(Y<<2)>>2]|0;}while((I|0)>-1)}c[A>>2]=-1;ra=wa;sa=xa;ta=ea}c[A>>2]=-1;ya=ra;za=da;Aa=sa;Ba=z+1|0;Ca=ta;Da=x}else{ya=w;za=x;Aa=y;Ba=z;Ca=0;Da=B}if((c[J+16>>2]|0)<=0){ka=v;la=ya;ma=za;na=Aa;oa=Ba;pa=Ca;qa=Da;break}ka=v;la=ya;ma=za+2|0;na=Aa;oa=Ba;pa=Ca;qa=za+1|0}else if((E|0)==2){I=c[J+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Ea=1}else{Ea=a[I+12|0]&1}Y=R1(d,Ea)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}else{Y=R1(d,B)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=R1(d,a[I+12|0]&1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}Y=R1(d,J)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=R1(d,1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=R1(d,c[I>>2]|0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=R1(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[I+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){Fa=w;Ga=y;Ha=0}else{Y=T1(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[I+12|0]&1)==0?v:1;if((w|0)>-1){I=c[t>>2]|0;G=0;while(1){Ia=I+(G<<2)|0;Ja=G+1|0;if((c[Ia>>2]|0)>-1){G=Ja}else{break}}c[Ia>>2]=B;c[I+(Ja<<2)>>2]=w;c[I+(G+2<<2)>>2]=-1;Ka=-1;La=y+1|0}else{Ka=w;La=y}da=c[A>>2]|0;if((da|0)>-1){ea=c[s>>2]|0;X=da;da=0;do{fa=(X|0)/2|0;if((X&1|0)==0){c[ea+(fa*12|0)>>2]=B}else{c[ea+(fa*12|0)+4>>2]=B}da=da+1|0;X=c[A+(da<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;Fa=Ka;Ga=La;Ha=Y}c[A>>2]=-1;ka=0;la=Fa;ma=x+1|0;na=Ga;oa=z+1|0;pa=Ha;qa=x}else if((E|0)==1){X=c[J+4>>2]|0;da=c[X>>2]|0;ea=c[X+4>>2]|0;X=R1(d,J)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=R1(d,5)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=R1(d,ea)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=R1(d,0)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}X=da+20|0;G=R1(d,(c[X>>2]|0)+x|0)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}if((c[X>>2]|0)>0){X=(c[ea+20>>2]|0)>0;Ma=(X&1)+x|0;Na=X?x:-1}else{Ma=x;Na=-1}X=R1(d,Na)|0;if((X|0)!=0){ka=v;la=w;ma=Ma;na=y;oa=z;pa=X;qa=B;break}X=R1(d,4)|0;if((X|0)!=0){ka=v;la=w;ma=Ma;na=y;oa=z;pa=X;qa=B;break}X=R1(d,da)|0;if((X|0)!=0){ka=v;la=w;ma=Ma;na=y;oa=z;pa=X;qa=B;break}ka=v;la=w;ma=Ma;na=y;oa=z;pa=R1(d,0)|0;qa=B}else if((E|0)==0){X=c[c[J+4>>2]>>2]|0;if(!((X|0)>-1|(X|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[J+20>>2]=1;Oa=w;Pa=y;Qa=0}else{X=T1(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){da=c[t>>2]|0;ea=0;while(1){Ra=da+(ea<<2)|0;Sa=ea+1|0;if((c[Ra>>2]|0)>-1){ea=Sa}else{break}}c[Ra>>2]=B;c[da+(Sa<<2)>>2]=w;c[da+(ea+2<<2)>>2]=-1;Ta=-1;Ua=y+1|0}else{Ta=w;Ua=y}Y=c[A>>2]|0;if((Y|0)>-1){G=c[s>>2]|0;I=Y;Y=0;do{fa=(I|0)/2|0;if((I&1|0)==0){c[G+(fa*12|0)>>2]=B}else{c[G+(fa*12|0)+4>>2]=B}Y=Y+1|0;I=c[A+(Y<<2)>>2]|0;}while((I|0)>-1)}c[A>>2]=-1;Oa=Ta;Pa=Ua;Qa=X}c[A>>2]=-1;ka=v;la=Oa;ma=x+1|0;na=Pa;oa=z+1|0;pa=Qa;qa=x}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);H=c[F>>2]|0;if((H|0)>-1){Va=0}else{M=ka;N=la;O=ma;P=na;Q=oa;R=A;S=pa;T=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=H;c[p+(Va<<2)>>2]=-1;M=ka;N=la;O=ma;P=na;Q=oa;R=A;S=pa;T=qa;break};case 2:{F=A;while(1){if((c[F>>2]|0)>-1){F=F+4|0}else{M=v;N=w;O=x;P=y;Q=z;R=F;S=0;T=B;break}}break};case 4:{F=u+ -2|0;c[h>>2]=F;H=c[D+(F<<2)>>2]|0;F=u+ -3|0;c[h>>2]=F;M=v;N=w;O=c[D+(F<<2)>>2]|0;P=y;Q=z;R=A;S=0;T=(H|0)>-1?H:B;break};default:{M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(S|0)==0){u=D;v=M;w=N;x=O;y=P;z=Q;A=R;B=T}else{Z=N;_=P;$=Q;aa=R;ba=S;ca=T;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;T=e;e=0;do{S=(T|0)/2|0;if((T&1|0)==0){c[n+(S*12|0)>>2]=ca}else{c[n+(S*12|0)+4>>2]=ca}e=e+1|0;T=c[aa+(e<<2)>>2]|0;}while((T|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}T=c[f+36>>2]|0;e=0;while(1){Ya=T+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[T+(Za<<2)>>2]=Z;c[T+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;C2(m);C2(p);o=ba;i=g;return o|0}function M1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=M1(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=O1(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=M1(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else if((a|0)==2){n=c[g+4>>2]|0;j=n;if(!((c[n+8>>2]|0)==-1)){m=j;break}h=c[n>>2]|0;n=O1(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function N1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{C2(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}C2(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){C2(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){C2(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}C2(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{C2(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}C2(m)}m=c[d+32>>2]|0;if((m|0)!=0){C2(m)}m=c[d+20>>2]|0;if((m|0)!=0){C2(m)}m=c[d+36>>2]|0;if((m|0)!=0){C2(m)}C2(d);i=b;return}function O1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=B2(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){C2(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=B2((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function P1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=$1(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=$1(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=$1(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function Q1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=R1(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==2){s=c[c[o+4>>2]>>2]|0;if((c[s+8>>2]|0)==0){continue a}B=R1(a,s)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=R1(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=R1(a,r)|0}else if((q|0)==1){r=c[o+4>>2]|0;s=R1(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}B=R1(a,c[r+4>>2]|0)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function R1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=E2(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;R1(a,b)|0;i=d;return 0}return 0}function S1(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;R1(d,e)|0;e=R1(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==0){y=c[u+4>>2]|0;x=c[y+8>>2]|0;D=c[y>>2]|0;E=c[y+4>>2]|0;do{if((D|0)>-1|(D|0)==-4){F=r;G=E;H=D;I=s+1|0;J=(c[g>>2]|0)+x|0}else{if(!((D|0)==-3)){F=r;G=E;H=D;I=s;J=x;break}if(!p){F=r;G=-1;H=-1;I=s;J=-1;break}if(q|(r|0)==0){F=r;G=E;H=-3;I=s;J=x;break}c[h+(E<<2)>>2]=1;F=0;G=E;H=-3;I=s;J=x}}while(0);x=$1(b,0,0,1,32)|0;E=x;do{if((x|0)==0){K=0}else{D=$1(b,0,0,1,20)|0;c[x+4>>2]=D;if((D|0)==0){K=0;break}c[x>>2]=0;c[x+8>>2]=-1;c[x+12>>2]=-1;c[D>>2]=H;c[D+4>>2]=G;c[D+8>>2]=J;K=E}}while(0);c[t>>2]=K;E=(K|0)==0?12:0;if((J|0)<=(c[k>>2]|0)){L=F;M=I;N=t;O=E;break}c[k>>2]=J;L=F;M=I;N=t;O=E}else if((z|0)==2){E=c[u+4>>2]|0;x=R1(d,c[E>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=R1(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[E>>2]|0;D=c[E+4>>2]|0;y=c[E+8>>2]|0;P=a[E+12|0]|0;E=$1(b,0,0,1,32)|0;if((E|0)==0){Q=40;break b}R=$1(b,0,0,1,16)|0;S=E+4|0;c[S>>2]=R;if((R|0)==0){Q=40;break b}c[E>>2]=2;c[E+8>>2]=-1;c[E+12>>2]=-1;c[R>>2]=x;c[R+4>>2]=D;c[R+8>>2]=y;y=R+12|0;a[y]=a[y]&-2|P&1;c[E+16>>2]=c[x+16>>2];c[t>>2]=E;A=s;B=r;t=c[S>>2]|0;s=A;r=B;continue b}else if((z|0)==3){S=c[u+4>>2]|0;E=c[S>>2]|0;x=S+4|0;P=c[x>>2]|0;y=$1(b,0,0,1,32)|0;if((y|0)==0){Q=20;break b}R=$1(b,0,0,1,8)|0;D=y+4|0;c[D>>2]=R;if((R|0)==0){Q=20;break b}c[y>>2]=3;c[y+8>>2]=-1;c[y+12>>2]=-1;c[R>>2]=E;c[(c[D>>2]|0)+4>>2]=P;c[y+16>>2]=(c[P+16>>2]|0)+(c[E+16>>2]|0);c[t>>2]=y;y=c[D>>2]|0;D=R1(d,c[x>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=R1(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=R1(d,y+4|0)|0;if((D|0)!=0){v=s;w=D;break a}D=R1(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=R1(d,c[S>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}L=r;M=s;N=y;O=R1(d,0)|0}else if((z|0)==1){y=c[u+4>>2]|0;D=c[y>>2]|0;S=y+4|0;x=c[S>>2]|0;E=$1(b,0,0,1,32)|0;if((E|0)==0){Q=29;break b}P=$1(b,0,0,1,8)|0;R=E+4|0;c[R>>2]=P;if((P|0)==0){Q=29;break b}c[E>>2]=1;c[E+8>>2]=-1;c[E+12>>2]=-1;c[P>>2]=D;c[(c[R>>2]|0)+4>>2]=x;c[E+16>>2]=(c[x+16>>2]|0)+(c[D+16>>2]|0);c[t>>2]=E;E=c[R>>2]|0;c[E>>2]=0;R=E+4|0;c[R>>2]=0;D=R1(d,c[S>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=R1(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=R1(d,R)|0;if((D|0)!=0){v=s;w=D;break a}D=R1(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=R1(d,c[y>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}L=r;M=s;N=E;O=R1(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((O|0)==0){r=L;s=M;t=N}else{v=M;w=O;break a}}if((Q|0)==20){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==29){c[t>>2]=0;v=s;w=12;break}else if((Q|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function T1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=$1(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=$1(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=$1(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=$1(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function U1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=$1(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=$1(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=$1(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=$1(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function V1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function W1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=151056}else{j=b;k=151056;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((d3(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Oc(e|0,f|0,151344,g|0)|0)+1|0;i=d;return h|0}



function si(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;c[sa>>2]=11;wA(ta,1,sa);ua=d/1653.0e4;va=7.1-ua;wa=1386.0/e+-1.222;c[ra>>2]=1;h[(EA(ta,1,ra)|0)>>3]=wa*wa;c[qa>>2]=1;xa=+h[(EA(ta,1,qa)|0)>>3];c[pa>>2]=2;h[(EA(ta,1,pa)|0)>>3]=xa*xa;c[oa>>2]=2;xa=+h[(EA(ta,1,oa)|0)>>3];c[na>>2]=3;h[(EA(ta,1,na)|0)>>3]=xa*xa;c[ma>>2]=1;xa=+h[(EA(ta,1,ma)|0)>>3];c[la>>2]=2;ya=xa*+h[(EA(ta,1,la)|0)>>3];c[ka>>2]=4;h[(EA(ta,1,ka)|0)>>3]=ya;c[ja>>2]=1;ya=wa*+h[(EA(ta,1,ja)|0)>>3];c[ia>>2]=5;h[(EA(ta,1,ia)|0)>>3]=ya;c[ha>>2]=2;ya=wa*+h[(EA(ta,1,ha)|0)>>3];c[ga>>2]=6;h[(EA(ta,1,ga)|0)>>3]=ya;c[fa>>2]=7;h[(EA(ta,1,fa)|0)>>3]=va*va;c[ea>>2]=7;ya=+h[(EA(ta,1,ea)|0)>>3];c[da>>2]=8;h[(EA(ta,1,da)|0)>>3]=ya*ya;c[ca>>2]=8;ya=+h[(EA(ta,1,ca)|0)>>3];c[ba>>2]=9;h[(EA(ta,1,ba)|0)>>3]=ya*ya;c[aa>>2]=3;ya=+h[(EA(ta,1,aa)|0)>>3];c[$>>2]=10;h[(EA(ta,1,$)|0)>>3]=ya*ya;c[_>>2]=10;ya=+h[(EA(ta,1,_)|0)>>3];c[Z>>2]=11;h[(EA(ta,1,Z)|0)>>3]=ya*ya;c[Y>>2]=2;ya=+h[(EA(ta,1,Y)|0)>>3];c[X>>2]=4;xa=ya*(+h[(EA(ta,1,X)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18;c[W>>2]=2;ya=xa/+h[(EA(ta,1,W)|0)>>3];c[V>>2]=2;xa=+h[(EA(ta,1,V)|0)>>3];c[U>>2]=3;za=xa*+h[(EA(ta,1,U)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[T>>2]=5;xa=+h[(EA(ta,1,T)|0)>>3]*za+89701127632.0e-16;c[S>>2]=6;za=xa/+h[(EA(ta,1,S)|0)>>3];c[R>>2]=3;xa=202584984300585.0e-20/+h[(EA(ta,1,R)|0)>>3];c[Q>>2]=7;Aa=+h[(EA(ta,1,Q)|0)>>3];c[P>>2]=8;Ba=+h[(EA(ta,1,P)|0)>>3];c[O>>2]=9;Ca=+h[(EA(ta,1,O)|0)>>3];c[N>>2]=7;Da=+h[(EA(ta,1,N)|0)>>3];c[M>>2]=7;Ea=+h[(EA(ta,1,M)|0)>>3];c[L>>2]=8;Fa=+h[(EA(ta,1,L)|0)>>3];c[K>>2]=11;Ga=+h[(EA(ta,1,K)|0)>>3];c[J>>2]=3;Ha=va/(wa*Ga*+h[(EA(ta,1,J)|0)>>3])*2.99318679335866e-24;c[I>>2]=11;Ga=+h[(EA(ta,1,I)|0)>>3];c[H>>2]=3;Ia=va*(Ha+-5.65070932023524e-23/(Ga*+h[(EA(ta,1,H)|0)>>3]));c[G>>2]=1;Ga=+h[(EA(ta,1,G)|0)>>3];c[F>>2]=11;Ha=Ga*+h[(EA(ta,1,F)|0)>>3];c[E>>2]=2;Ga=va*(Ia+3.5842867920213e-22/(wa*Ha*+h[(EA(ta,1,E)|0)>>3]));c[D>>2]=1;Ha=+h[(EA(ta,1,D)|0)>>3];c[C>>2]=11;Ia=Ha*+h[(EA(ta,1,C)|0)>>3];c[B>>2]=2;Ha=Ea*Fa*(Ga+-7.63737668221055e-22/(Ia*+h[(EA(ta,1,B)|0)>>3]));c[A>>2]=1;Ia=+h[(EA(ta,1,A)|0)>>3];c[z>>2]=10;Ga=Ia*+h[(EA(ta,1,z)|0)>>3];c[y>>2]=2;Ia=Ga*+h[(EA(ta,1,y)|0)>>3];c[x>>2]=3;Ga=Da*(Ha+-3.33001080055983e-19/(wa*Ia*+h[(EA(ta,1,x)|0)>>3]));c[w>>2]=10;Ia=+h[(EA(ta,1,w)|0)>>3];c[v>>2]=2;Ha=Ia*+h[(EA(ta,1,v)|0)>>3];c[u>>2]=3;Ia=Ba*Ca*va*(Ga+1.44400475720615e-17/(wa*Ha*+h[(EA(ta,1,u)|0)>>3]));c[t>>2]=6;Ha=+h[(EA(ta,1,t)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[s>>2]=1;Ga=+h[(EA(ta,1,s)|0)>>3];c[r>>2]=3;Ca=va*(ya+va*(za+va*(xa+Aa*va*(Ia+Ha/(wa*Ga*+h[(EA(ta,1,r)|0)>>3])))));c[q>>2]=5;Ga=+h[(EA(ta,1,q)|0)>>3];c[p>>2]=1;Ha=+h[(EA(ta,1,p)|0)>>3];c[o>>2]=1;Ia=+h[(EA(ta,1,o)|0)>>3];c[n>>2]=2;Aa=+h[(EA(ta,1,n)|0)>>3];c[m>>2]=3;xa=Ga*(wa*(Ha*(Ia*Aa*+h[(EA(ta,1,m)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534;c[l>>2]=5;Aa=va*(Ca+xa/+h[(EA(ta,1,l)|0)>>3]);c[k>>2]=1;xa=+h[(EA(ta,1,k)|0)>>3];c[j>>2]=4;Ca=+h[(EA(ta,1,j)|0)>>3];c[g>>2]=1;va=xa*(Ca*(wa*(wa*(+h[(EA(ta,1,g)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804;c[f>>2]=3;h[a>>3]=d/(ua*(Aa+va/(wa*+h[(EA(ta,1,f)|0)>>3]))*e*461.526);i=b;return}function ti(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;c[Ia>>2]=12;wA(Ja,1,Ia);Ka=d/1.0e6;La=540.0/e+-.5;c[Ha>>2]=1;h[(EA(Ja,1,Ha)|0)>>3]=La*La;c[Ga>>2]=1;Ma=La*+h[(EA(Ja,1,Ga)|0)>>3];c[Fa>>2]=2;h[(EA(Ja,1,Fa)|0)>>3]=Ma;c[Ea>>2]=1;Ma=+h[(EA(Ja,1,Ea)|0)>>3];c[Da>>2]=3;h[(EA(Ja,1,Da)|0)>>3]=Ma*Ma;c[Ca>>2]=3;Ma=+h[(EA(Ja,1,Ca)|0)>>3];c[Ba>>2]=4;h[(EA(Ja,1,Ba)|0)>>3]=Ma*Ma;c[Aa>>2]=4;Ma=+h[(EA(Ja,1,Aa)|0)>>3];c[za>>2]=5;h[(EA(Ja,1,za)|0)>>3]=Ma*Ma;c[ya>>2]=3;Ma=+h[(EA(Ja,1,ya)|0)>>3];c[xa>>2]=4;Na=+h[(EA(Ja,1,xa)|0)>>3];c[wa>>2]=5;Oa=Ma*Na*La*+h[(EA(Ja,1,wa)|0)>>3];c[va>>2]=6;h[(EA(Ja,1,va)|0)>>3]=Oa;c[ua>>2]=3;Oa=+h[(EA(Ja,1,ua)|0)>>3];c[ta>>2]=4;Na=Oa*La*+h[(EA(Ja,1,ta)|0)>>3];c[sa>>2]=7;h[(EA(Ja,1,sa)|0)>>3]=Na;c[ra>>2]=1;Na=+h[(EA(Ja,1,ra)|0)>>3];c[qa>>2]=3;Oa=+h[(EA(Ja,1,qa)|0)>>3];c[pa>>2]=4;Ma=Na*Oa*+h[(EA(Ja,1,pa)|0)>>3];c[oa>>2]=8;h[(EA(Ja,1,oa)|0)>>3]=Ma;c[na>>2]=9;h[(EA(Ja,1,na)|0)>>3]=Ka*Ka;c[ma>>2]=9;Ma=+h[(EA(Ja,1,ma)|0)>>3];c[la>>2]=10;h[(EA(Ja,1,la)|0)>>3]=Ma*Ma;c[ka>>2]=3;Ma=+h[(EA(Ja,1,ka)|0)>>3];c[ja>>2]=5;Oa=Ma*La*+h[(EA(Ja,1,ja)|0)>>3];c[ia>>2]=11;h[(EA(Ja,1,ia)|0)>>3]=Oa;c[ha>>2]=5;Oa=+h[(EA(Ja,1,ha)|0)>>3];c[ga>>2]=12;h[(EA(Ja,1,ga)|0)>>3]=Oa*Oa;c[fa>>2]=2;Oa=La*(La*(La*(+h[(EA(Ja,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=1;Ma=+h[(EA(Ja,1,ea)|0)>>3];c[da>>2]=2;Na=+h[(EA(Ja,1,da)|0)>>3];c[ca>>2]=6;Pa=La*(La*(Ma*(Na*(+h[(EA(Ja,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=1;Na=+h[(EA(Ja,1,ba)|0)>>3];c[aa>>2]=2;Ma=+h[(EA(Ja,1,aa)|0)>>3];c[$>>2]=6;Qa=La*(Na*(Ma*(+h[(EA(Ja,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=1;Ma=+h[(EA(Ja,1,_)|0)>>3];c[Z>>2]=3;Na=Ma*La*+h[(EA(Ja,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=2;Ma=+h[(EA(Ja,1,Y)|0)>>3];c[X>>2]=7;Ra=+h[(EA(Ja,1,X)|0)>>3];c[W>>2]=1;Sa=+h[(EA(Ja,1,W)|0)>>3];c[V>>2]=5;Ta=Ma*(Ra*(Sa*La*+h[(EA(Ja,1,V)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[U>>2]=1;Sa=+h[(EA(Ja,1,U)|0)>>3];c[T>>2]=4;Ra=+h[(EA(Ja,1,T)|0)>>3];c[S>>2]=8;Ma=Sa*Ra*La*(+h[(EA(Ja,1,S)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[R>>2]=4;Ra=+h[(EA(Ja,1,R)|0)>>3];c[Q>>2]=3;Sa=+h[(EA(Ja,1,Q)|0)>>3];c[P>>2]=4;Ua=+h[(EA(Ja,1,P)|0)>>3];c[O>>2]=5;Va=Ra*(Sa*Ua*+h[(EA(Ja,1,O)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[N>>2]=7;Ua=+h[(EA(Ja,1,N)|0)>>3]*1.78287415218792e-7;c[M>>2]=3;Sa=+h[(EA(Ja,1,M)|0)>>3];c[L>>2]=1;Ra=+h[(EA(Ja,1,L)|0)>>3];c[K>>2]=3;Wa=+h[(EA(Ja,1,K)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[J>>2]=3;Xa=Sa*(Ra*Wa*+h[(EA(Ja,1,J)|0)>>3]+1.0406965210174e-18);c[I>>2]=10;Wa=+h[(EA(Ja,1,I)|0)>>3];c[H>>2]=9;Ra=+h[(EA(Ja,1,H)|0)>>3];c[G>>2]=11;Sa=+h[(EA(Ja,1,G)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[F>>2]=6;Ya=Sa*+h[(EA(Ja,1,F)|0)>>3];c[E>>2]=9;Sa=+h[(EA(Ja,1,E)|0)>>3];c[D>>2]=12;Za=+h[(EA(Ja,1,D)|0)>>3];c[C>>2]=4;_a=+h[(EA(Ja,1,C)|0)>>3];c[B>>2]=5;$a=Za*_a*La*+h[(EA(Ja,1,B)|0)>>3]*-6.05920510335078;c[A>>2]=9;_a=+h[(EA(Ja,1,A)|0)>>3];c[z>>2]=3;Za=+h[(EA(Ja,1,z)|0)>>3];c[y>>2]=5;ab=+h[(EA(Ja,1,y)|0)>>3];c[x>>2]=1;bb=+h[(EA(Ja,1,x)|0)>>3];c[w>>2]=3;cb=+h[(EA(Ja,1,w)|0)>>3];c[v>>2]=4;db=+h[(EA(Ja,1,v)|0)>>3];c[u>>2]=7;eb=Za*ab*(bb*cb*db*La*(+h[(EA(Ja,1,u)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[t>>2]=11;db=+h[(EA(Ja,1,t)|0)>>3]*-1.24017662339842e-24;c[s>>2]=12;cb=+h[(EA(Ja,1,s)|0)>>3];c[r>>2]=3;bb=+h[(EA(Ja,1,r)|0)>>3];c[q>>2]=5;ab=cb*bb*La*+h[(EA(Ja,1,q)|0)>>3]*832192847496054.0e-19;c[p>>2]=1;bb=+h[(EA(Ja,1,p)|0)>>3];c[o>>2]=4;cb=+h[(EA(Ja,1,o)|0)>>3];c[n>>2]=5;Za=+h[(EA(Ja,1,n)|0)>>3];c[m>>2]=1;fb=+h[(EA(Ja,1,m)|0)>>3];c[l>>2]=5;gb=fb*+h[(EA(Ja,1,l)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[k>>2]=8;fb=bb*cb*Za*Ka*(+h[(EA(Ja,1,k)|0)>>3]*gb+1.75410265428146e-27);c[j>>2]=1;gb=+h[(EA(Ja,1,j)|0)>>3];c[g>>2]=12;Za=+h[(EA(Ja,1,g)|0)>>3];c[f>>2]=3;h[a>>3]=d/(Ka*((Ka*(Oa+Ka*(Pa+Ka*(Qa+Ka*(La*(La*(La*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ka*(Na+Ka*(Ta+Ka*(Ma+Ka*(Va+Ka*(Ua+Ka*(Xa+Wa*Ra*(Ya+Sa*($a+_a*(eb+Ka*(db+Ka*(ab+Ka*(fb+gb*Za*La*+h[(EA(Ja,1,f)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ka)*e*461.526);i=b;return}function ui(b,c,d){b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;e=i;i=i+216|0;f=e+8|0;g=e+16|0;j=e+24|0;k=e+112|0;l=e+120|0;m=e+208|0;n=e;o=+vd(+d,22063999.9999999);Zg(f,c,o);p=+h[f>>3];Qh(g,c,p);q=+h[g>>3];g=p>623.15;f=g&1;if(g){hi(k,0,o);r=+h[k>>3];Kh(l,c,r,p);s=+h[l+16>>3];t=+h[l+24>>3];u=+h[l+32>>3];v=+h[l+40>>3];w=+h[l+48>>3];x=+h[l+56>>3];y=+h[l+64>>3];z=+h[l+72>>3];A=+h[l+80>>3];vi(m,0,o);B=r*t*(w-u*A)*461.526;C=p*t*(w*2.0+t*x)*461.526;D=0.0;E=0.0;F=r;G=+h[m>>3];H=s*(u*y-v);I=0.0;J=u*u*z*-461.526}else{Sh(j,c,d,p);z=+h[j+24>>3];u=+h[j+32>>3];v=+h[j+48>>3];y=+h[j+56>>3];s=+h[j+80>>3];r=z*v;x=u*+h[j+64>>3];if(o<d){K=2087546.84511715}else{K=p*x*461.526}o=+h[j+16>>3]*(x- +h[j+40>>3]);x=u*u*+h[j+72>>3]*-461.526;B=-((v-u*s)/(p*z*y)*d);C=p*(v*v/y)*-461.526;D=(r-u*z*s)/d*461.526;E=p*z*z*y*+oB(d,-2)*461.526;F=d/(p*r*461.526);G=K;H=o;I=x;J=0.0}j=b;a[j]=f;f=j+1|0;a[f+0|0]=a[n+0|0]|0;a[f+1|0]=a[n+1|0]|0;a[f+2|0]=a[n+2|0]|0;a[f+3|0]=a[n+3|0]|0;a[f+4|0]=a[n+4|0]|0;a[f+5|0]=a[n+5|0]|0;a[f+6|0]=a[n+6|0]|0;h[b+8>>3]=461.526;h[b+16>>3]=p;h[b+24>>3]=F;h[b+32>>3]=G;h[b+40>>3]=H;h[b+48>>3]=I;h[b+56>>3]=J;h[b+64>>3]=q;h[b+72>>3]=B;h[b+80>>3]=C;h[b+88>>3]=D;h[b+96>>3]=E;i=e;return}function vi(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;d=+_(+(c/22064.0e3));h[a>>3]=(d*(d*(d*(d*(d*(d*(d*(d*.0006616936460057692+-16.98555442961553)+45.66489164833212)+-48.38215180269516)+25.08887602293532)+-6.084122698421623)+.2079670746250689)+.4880153718655694)+1.0)*2087546.84511715;i=i;return}function wi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;c[u>>2]=3;wA(v,1,u);w=7.1-d/1653.0e4;if(!(d>611.657)){u=gA(gA(9104,eA(d,0,1,6)|0)|0,3856)|0;x=gA(gA(u,eA(611.657,0,1,6)|0)|0,3864)|0;u=c[27736]|0;y=f;z=9176;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Le[u&63](b,f,x,t);}c[s>>2]=1;h[(EA(v,1,s)|0)>>3]=w*w;c[r>>2]=1;d=+h[(EA(v,1,r)|0)>>3];c[q>>2]=2;h[(EA(v,1,q)|0)>>3]=d*d;c[p>>2]=2;d=+h[(EA(v,1,p)|0)>>3];c[o>>2]=3;h[(EA(v,1,o)|0)>>3]=d*d;c[n>>2]=1;d=+h[(EA(v,1,n)|0)>>3];c[m>>2]=2;A=+h[(EA(v,1,m)|0)>>3];c[l>>2]=3;B=+h[(EA(v,1,l)|0)>>3];c[k>>2]=1;C=+h[(EA(v,1,k)|0)>>3];c[j>>2]=1;D=+h[(EA(v,1,j)|0)>>3];c[g>>2]=2;h[a>>3]=(w*(w*(w*(w*(w*(d*w*(A*B*w*(C*(D*(w*(w*(w*3.49930466305574e-24+-6.66749357417962e-23)+4.27026404402408e-22)+-9.19148577641497e-22)*+h[(EA(v,1,g)|0)>>3]+-4.18568363667416e-19)+1.86779322717506e-17)+1.46754947271665e-8)+317834967400818.0e-20)+123617764767172.0e-19)+.000125338925082983)+.00143759406818289)+-.00141131225285294)+2.42896927729349)*639675.036;i=e;return}function xi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0.0,hc=0.0,ic=0.0,jc=0.0,kc=0.0,lc=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;c[Eb>>2]=18;wA(Fb,1,Eb);Gb=d/1.0e6;if(!(d>611.657)){Eb=gA(gA(9200,eA(d,0,1,6)|0)|0,3856)|0;Hb=gA(gA(Eb,eA(611.657,0,1,6)|0)|0,3864)|0;Eb=c[27736]|0;Ib=f;Jb=9272;c[Ib+0>>2]=c[Jb+0>>2];c[Ib+4>>2]=c[Jb+4>>2];c[Ib+8>>2]=c[Jb+8>>2];c[Ib+12>>2]=c[Jb+12>>2];c[Ib+16>>2]=c[Jb+16>>2];c[Ib+20>>2]=c[Jb+20>>2];Le[Eb&63](b,f,Hb,Db);}d=+V(+(Gb+-13.91883977887))*31.3220101646784+572.54459862746;Kb=540.0/d+-.5;c[Cb>>2]=1;h[(EA(Fb,1,Cb)|0)>>3]=d*d;c[Bb>>2]=1;Lb=+h[(EA(Fb,1,Bb)|0)>>3];c[Ab>>2]=2;h[(EA(Fb,1,Ab)|0)>>3]=Lb*Lb;c[zb>>2]=2;Lb=+h[(EA(Fb,1,zb)|0)>>3];c[yb>>2]=3;h[(EA(Fb,1,yb)|0)>>3]=Lb*Lb;c[xb>>2]=4;h[(EA(Fb,1,xb)|0)>>3]=Gb*Gb;c[wb>>2]=4;Lb=+h[(EA(Fb,1,wb)|0)>>3];c[vb>>2]=5;h[(EA(Fb,1,vb)|0)>>3]=Lb*Lb;c[ub>>2]=6;h[(EA(Fb,1,ub)|0)>>3]=Kb*Kb;c[tb>>2]=6;Lb=+h[(EA(Fb,1,tb)|0)>>3];c[sb>>2]=7;h[(EA(Fb,1,sb)|0)>>3]=Lb*Lb;c[rb>>2]=6;Lb=+h[(EA(Fb,1,rb)|0)>>3];c[qb>>2]=7;Mb=Lb*+h[(EA(Fb,1,qb)|0)>>3];c[pb>>2]=8;h[(EA(Fb,1,pb)|0)>>3]=Mb;c[ob>>2]=5;Mb=+h[(EA(Fb,1,ob)|0)>>3];c[nb>>2]=9;h[(EA(Fb,1,nb)|0)>>3]=Mb*Mb;c[mb>>2]=7;Mb=+h[(EA(Fb,1,mb)|0)>>3];c[lb>>2]=10;h[(EA(Fb,1,lb)|0)>>3]=Mb*Mb;c[kb>>2]=9;Mb=+h[(EA(Fb,1,kb)|0)>>3];c[jb>>2]=11;h[(EA(Fb,1,jb)|0)>>3]=Mb*Mb;c[ib>>2]=10;Mb=+h[(EA(Fb,1,ib)|0)>>3];c[hb>>2]=12;h[(EA(Fb,1,hb)|0)>>3]=Mb*Mb;c[gb>>2]=12;Mb=+h[(EA(Fb,1,gb)|0)>>3];c[fb>>2]=13;h[(EA(Fb,1,fb)|0)>>3]=Mb*Mb;c[eb>>2]=7;Mb=Kb*+h[(EA(Fb,1,eb)|0)>>3];c[db>>2]=14;h[(EA(Fb,1,db)|0)>>3]=Mb;c[cb>>2]=6;Mb=Kb*+h[(EA(Fb,1,cb)|0)>>3];c[bb>>2]=15;h[(EA(Fb,1,bb)|0)>>3]=Mb;c[ab>>2]=10;Mb=+h[(EA(Fb,1,ab)|0)>>3];c[$a>>2]=6;Lb=Mb*+h[(EA(Fb,1,$a)|0)>>3];c[_a>>2]=16;h[(EA(Fb,1,_a)|0)>>3]=Lb;c[Za>>2]=13;Lb=+h[(EA(Fb,1,Za)|0)>>3];c[Ya>>2]=6;Mb=Lb*+h[(EA(Fb,1,Ya)|0)>>3];c[Xa>>2]=17;h[(EA(Fb,1,Xa)|0)>>3]=Mb;c[Wa>>2]=13;Mb=+h[(EA(Fb,1,Wa)|0)>>3];c[Va>>2]=6;Lb=Mb*Kb*+h[(EA(Fb,1,Va)|0)>>3];c[Ua>>2]=18;h[(EA(Fb,1,Ua)|0)>>3]=Lb;c[Ta>>2]=2;Lb=+h[(EA(Fb,1,Ta)|0)>>3]*3.74686560065793;c[Sa>>2]=1;Mb=+h[(EA(Fb,1,Sa)|0)>>3];c[Ra>>2]=2;Nb=Mb*+h[(EA(Fb,1,Ra)|0)>>3]*357966647812489.0e-20;c[Qa>>2]=3;Mb=+h[(EA(Fb,1,Qa)|0)>>3]*2.81881548488163e-13;c[Pa>>2]=2;Ob=d*+h[(EA(Fb,1,Pa)|0)>>3]*-.00450789338787835;c[Oa>>2]=1;Pb=+h[(EA(Fb,1,Oa)|0)>>3];c[Na>>2]=2;Qb=Pb*d*+h[(EA(Fb,1,Na)|0)>>3]*-1.55131504410292e-9;c[Ma>>2]=1;Pb=+h[(EA(Fb,1,Ma)|0)>>3];c[La>>2]=10;Rb=+h[(EA(Fb,1,La)|0)>>3];c[Ka>>2]=11;Sb=+h[(EA(Fb,1,Ka)|0)>>3];c[Ja>>2]=12;Tb=+h[(EA(Fb,1,Ja)|0)>>3];c[Ia>>2]=13;Ub=+h[(EA(Fb,1,Ia)|0)>>3];c[Ha>>2]=4;Vb=Rb*Sb*Tb*Ub*+h[(EA(Fb,1,Ha)|0)>>3]*-4781981.98764471;c[Ga>>2]=11;Ub=+h[(EA(Fb,1,Ga)|0)>>3];c[Fa>>2]=12;Tb=+h[(EA(Fb,1,Fa)|0)>>3];c[Ea>>2]=13;Sb=+h[(EA(Fb,1,Ea)|0)>>3];c[Da>>2]=4;Rb=+h[(EA(Fb,1,Da)|0)>>3];c[Ca>>2]=5;Wb=+h[(EA(Fb,1,Ca)|0)>>3];c[Ba>>2]=7;Xb=Ub*Tb*Sb*Rb*Wb*+h[(EA(Fb,1,Ba)|0)>>3]*49.9651389369988;c[Aa>>2]=15;Wb=+h[(EA(Fb,1,Aa)|0)>>3];c[za>>2]=4;Rb=+h[(EA(Fb,1,za)|0)>>3];c[ya>>2]=16;Sb=+h[(EA(Fb,1,ya)|0)>>3]*-.00349547959376899;c[xa>>2]=8;Tb=Sb+ +h[(EA(Fb,1,xa)|0)>>3]*-2.55074501962569e-7+1.03746636552761e-13;c[wa>>2]=9;Sb=Wb*Rb*+h[(EA(Fb,1,wa)|0)>>3]*Tb;c[va>>2]=10;Tb=+h[(EA(Fb,1,va)|0)>>3];c[ua>>2]=12;Rb=Tb*+h[(EA(Fb,1,ua)|0)>>3]*-242662.235426958;c[ta>>2]=16;Tb=Rb+ +h[(EA(Fb,1,ta)|0)>>3]*-3.46022402653609;c[sa>>2]=4;Rb=+h[(EA(Fb,1,sa)|0)>>3];c[ra>>2]=5;Wb=Tb*Rb*Gb*+h[(EA(Fb,1,ra)|0)>>3];c[qa>>2]=4;Rb=+h[(EA(Fb,1,qa)|0)>>3];c[pa>>2]=14;Tb=+h[(EA(Fb,1,pa)|0)>>3]*-2248.08924686956;c[oa>>2]=17;Ub=+h[(EA(Fb,1,oa)|0)>>3]*-354742.725841972;c[na>>2]=6;Yb=Rb*Gb*(Tb+(Ub+ +h[(EA(Fb,1,na)|0)>>3]*-24.1331193696374)+.109336249381227);c[ma>>2]=11;Ub=+h[(EA(Fb,1,ma)|0)>>3];c[la>>2]=12;Tb=+h[(EA(Fb,1,la)|0)>>3];c[ka>>2]=5;Rb=+h[(EA(Fb,1,ka)|0)>>3];c[ja>>2]=7;Zb=Ub*Tb*Rb*Gb*+h[(EA(Fb,1,ja)|0)>>3]*-3.09081828396912e-19;c[ia>>2]=11;Rb=+h[(EA(Fb,1,ia)|0)>>3];c[ha>>2]=13;Tb=+h[(EA(Fb,1,ha)|0)>>3];c[ga>>2]=4;Ub=+h[(EA(Fb,1,ga)|0)>>3];c[fa>>2]=5;_b=+h[(EA(Fb,1,fa)|0)>>3];c[ea>>2]=6;$b=+h[(EA(Fb,1,ea)|0)>>3];c[da>>2]=7;ac=Rb*Tb*Ub*_b*$b*Gb*+h[(EA(Fb,1,da)|0)>>3]*-1.24107527851371e-8;c[ca>>2]=5;$b=+h[(EA(Fb,1,ca)|0)>>3];c[ba>>2]=8;_b=$b*Gb*+h[(EA(Fb,1,ba)|0)>>3]*3.99891272904219;c[aa>>2]=10;$b=+h[(EA(Fb,1,aa)|0)>>3];c[$>>2]=7;Ub=+h[(EA(Fb,1,$)|0)>>3];c[_>>2]=9;Tb=$b*Ub*Gb*+h[(EA(Fb,1,_)|0)>>3]*.0641817365250892;c[Z>>2]=14;Ub=+h[(EA(Fb,1,Z)|0)>>3]*-75253.6156722047;c[Y>>2]=6;$b=Gb*(Ub+(Kb*-22926.6247146068+ +h[(EA(Fb,1,Y)|0)>>3]*-43051.9020511789)+-4444.87643334512);c[X>>2]=4;Ub=+h[(EA(Fb,1,X)|0)>>3];c[W>>2]=15;Gb=+h[(EA(Fb,1,W)|0)>>3]*-3927.0508365636;c[U>>2]=18;Rb=+h[(EA(Fb,1,U)|0)>>3]*-239.325789467604;c[T>>2]=8;bc=Ub*(Gb+(Rb+(Kb*-94.4508644545118+ +h[(EA(Fb,1,T)|0)>>3]*-76407.3727417716))+-8.23252840892034);c[S>>2]=5;Rb=(Kb+-.0161221195808321)*(Kb+.0338039844460968)*+h[(EA(Fb,1,S)|0)>>3]*.360567666582363;c[R>>2]=11;Gb=+h[(EA(Fb,1,R)|0)>>3];c[Q>>2]=10;Ub=+h[(EA(Fb,1,Q)|0)>>3];c[P>>2]=12;cc=+h[(EA(Fb,1,P)|0)>>3];c[O>>2]=7;dc=Ub*cc*+h[(EA(Fb,1,O)|0)>>3]*-.000584580992538624;c[N>>2]=12;cc=+h[(EA(Fb,1,N)|0)>>3];c[M>>2]=13;Ub=Gb*(dc+cc*Kb*+h[(EA(Fb,1,M)|0)>>3]*1332480.30241755);c[L>>2]=9;cc=+h[(EA(Fb,1,L)|0)>>3];c[K>>2]=18;dc=+h[(EA(Fb,1,K)|0)>>3]*-73850273.6990986;c[J>>2]=6;Gb=+h[(EA(Fb,1,J)|0)>>3];c[I>>2]=7;ec=cc*(dc+Gb*Kb*+h[(EA(Fb,1,I)|0)>>3]*224425477627799.0e-19);c[H>>2]=4;Gb=+h[(EA(Fb,1,H)|0)>>3];c[G>>2]=5;dc=+h[(EA(Fb,1,G)|0)>>3];c[F>>2]=17;cc=+h[(EA(Fb,1,F)|0)>>3]*-208438767.026518;c[E>>2]=6;fc=+h[(EA(Fb,1,E)|0)>>3]*-124971648677697.0e-19;c[D>>2]=10;gc=+h[(EA(Fb,1,D)|0)>>3];c[C>>2]=6;hc=+h[(EA(Fb,1,C)|0)>>3];c[B>>2]=7;ic=Gb*dc*(cc+(fc+gc*hc*Kb*+h[(EA(Fb,1,B)|0)>>3]*-8442.30378348203));c[A>>2]=11;hc=+h[(EA(Fb,1,A)|0)>>3];c[z>>2]=9;gc=+h[(EA(Fb,1,z)|0)>>3];c[y>>2]=10;fc=+h[(EA(Fb,1,y)|0)>>3];c[x>>2]=12;cc=fc*Kb*+h[(EA(Fb,1,x)|0)>>3]*4.73594929247646e-22;c[w>>2]=10;fc=+h[(EA(Fb,1,w)|0)>>3];c[v>>2]=12;dc=+h[(EA(Fb,1,v)|0)>>3];c[u>>2]=13;Gb=fc*dc*Kb*+h[(EA(Fb,1,u)|0)>>3]*-13.6411358215175;c[t>>2]=13;dc=+h[(EA(Fb,1,t)|0)>>3];c[s>>2]=6;fc=+h[(EA(Fb,1,s)|0)>>3];c[r>>2]=7;jc=gc*(cc+(Gb+dc*fc*Kb*+h[(EA(Fb,1,r)|0)>>3]*5.52427169406836e-10));c[q>>2]=5;fc=+h[(EA(Fb,1,q)|0)>>3];c[p>>2]=17;dc=+h[(EA(Fb,1,p)|0)>>3]*267174673301715.0e-20;c[o>>2]=12;Gb=+h[(EA(Fb,1,o)|0)>>3];c[n>>2]=6;cc=Gb*Kb*+h[(EA(Fb,1,n)|0)>>3]*4.44545133805865e-18;c[m>>2]=10;Gb=+h[(EA(Fb,1,m)|0)>>3];c[l>>2]=13;gc=+h[(EA(Fb,1,l)|0)>>3];c[k>>2]=6;kc=+h[(EA(Fb,1,k)|0)>>3];c[j>>2]=7;lc=Lb+(Nb+(Mb+(d*-76465233.2452145+(Ob+(Qb+Pb*(Vb+(Xb+(Sb+(Wb+(Yb+(Zb+(ac+(_b+(Tb+($b+(bc+(Rb+(Ub+(ec+(ic+hc*(jc+fc*(dc+(cc+Gb*gc*kc*Kb*+h[(EA(Fb,1,j)|0)>>3]*-50.2465185106411)))))))))))))))))+2513837.07870341))))))+4636975733.03507;c[g>>2]=1;h[a>>3]=lc/+h[(EA(Fb,1,g)|0)>>3];i=e;return}function yi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;c[u>>2]=3;wA(v,1,u);w=7.1-d/1653.0e4;if(!(d>611.657)){u=gA(gA(9296,eA(d,0,1,6)|0)|0,3856)|0;x=gA(gA(u,eA(611.657,0,1,6)|0)|0,3864)|0;u=c[27736]|0;y=f;z=9368;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Le[u&63](b,f,x,t);}c[s>>2]=1;h[(EA(v,1,s)|0)>>3]=w*w;c[r>>2]=1;d=+h[(EA(v,1,r)|0)>>3];c[q>>2]=2;h[(EA(v,1,q)|0)>>3]=d*d;c[p>>2]=2;d=+h[(EA(v,1,p)|0)>>3];c[o>>2]=3;h[(EA(v,1,o)|0)>>3]=d*d;c[n>>2]=1;d=+h[(EA(v,1,n)|0)>>3];c[m>>2]=2;A=+h[(EA(v,1,m)|0)>>3];c[l>>2]=3;B=+h[(EA(v,1,l)|0)>>3];c[k>>2]=1;C=+h[(EA(v,1,k)|0)>>3];c[j>>2]=1;D=+h[(EA(v,1,j)|0)>>3];c[g>>2]=2;h[a>>3]=(w*(w*(w*(w*(w*(d*w*(A*B*w*(C*(D*(w*(w*(w*9.64504638626269e-49+-7.06381628462585e-47)+1.73894459122923e-45)+-1.43870236842915e-44)*+h[(EA(v,1,g)|0)>>3]+-8.12140581014818e-38)+5.35429206228374e-35)+8.43755552264362e-14)+1.73545618580828e-11)+-2.41630417490008e-7)+-418695814670391.0e-20)+-.00017146768241932)+-.022914084306349)+.173379420894777)*639675.036;i=e;return}function zi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+24|0;j=d/1.0e6;if(d>611.657){k=j*3.36540214679088e-7;l=k+-203245575263501.0e-19;m=j*l;n=m+-.00979043490246092;o=j*n;p=o+9.01505286876203;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}t=gA(gA(9392,eA(d,0,1,6)|0)|0,3856)|0;u=gA(gA(t,eA(611.657,0,1,6)|0)|0,3864)|0;t=c[27736]|0;v=f;w=9464;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];c[v+20>>2]=c[w+20>>2];Le[t&63](b,f,u,g);k=j*3.36540214679088e-7;l=k+-203245575263501.0e-19;m=j*l;n=m+-.00979043490246092;o=j*n;p=o+9.01505286876203;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}function Ai(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+24|0;j=d/1.0e6;if(d>611.657){k=j*7.5006972718273e-8;l=k+-5.01510211858761e-8;m=j*l;n=m+-.000489898813722568;o=j*n;p=o+15.9838891400332;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}t=gA(gA(9488,eA(d,0,1,6)|0)|0,3856)|0;u=gA(gA(t,eA(611.657,0,1,6)|0)|0,3864)|0;t=c[27736]|0;v=f;w=9560;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];c[v+20>>2]=c[w+20>>2];Le[t&63](b,f,u,g);k=j*7.5006972718273e-8;l=k+-5.01510211858761e-8;m=j*l;n=m+-.000489898813722568;o=j*n;p=o+15.9838891400332;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}function Bi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;c[p>>2]=2;wA(q,1,p);r=d/1.0e6;if(!(d>611.657)){p=gA(gA(9584,eA(d,0,1,6)|0)|0,3856)|0;s=gA(gA(p,eA(611.657,0,1,6)|0)|0,3864)|0;p=c[27736]|0;t=f;u=9656;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];Le[p&63](b,f,s,o);}c[n>>2]=1;h[(EA(q,1,n)|0)>>3]=r*r;c[m>>2]=1;d=+h[(EA(q,1,m)|0)>>3];c[l>>2]=2;h[(EA(q,1,l)|0)>>3]=d*d*d;c[k>>2]=1;d=+h[(EA(q,1,k)|0)>>3];c[j>>2]=1;v=d*((r*(r*(r*(r*1.88543121025106e-84+-1.76117969553159e-103)+8.06630589170884e-129)+-3.71600586812966e-69)+1.6746290980312e-65)*+h[(EA(q,1,j)|0)>>3]+-8.00969737237617e-134)+-7.5656940729795e-74;c[g>>2]=2;h[a>>3]=r*(r*(r*(r*(r*(r*(r*(r*(r*(r*(+h[(EA(q,1,g)|0)>>3]*v+3.37267475986401e-21)+7.16825117265975e-32)+7.56960433802525e-23)+-3.79407294691742e-25)+-1.27295130636232e-10)+4.2261295097284e-15)+-.000172486052272327)+.109090430596056)+-8.53409968320258)+-4518.48617188327)+4160663.37647071;i=e;return}function Ci(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+8|0;m=i;i=i+88|0;n=i;i=i+88|0;o=i;i=i+16|0;p=i;i=i+88|0;q=i;i=i+88|0;if((f|0)==0){Yh(l,b,d,e,0);r=c[l>>2]|0}else{r=f}if((r|0)==2){Sh(n,b,d,e);s=+h[n+24>>3];t=+h[n+32>>3];u=+h[n+48>>3];v=+h[n+56>>3];w=+h[n+72>>3];x=+h[n+80>>3];y=t*+h[n+64>>3];z=(y- +h[n+40>>3])*461.526;A=s*u;B=(A-t*s*x)/d*461.526;C=s*s*v*+oB(d,-2)*e*461.526;s=t*t*w;w=u-t*x;D=0.0;E=0.0;F=B;G=C;H=1.0;I=-B/C;J=y*e*461.526;K=s*-461.526;L=(w*w/v-s)*461.526;M=d/(A*e*461.526);N=z}else if((r|0)==3){ci(o,b,d,e,1.0e-7);z=+h[o>>3];Kh(p,b,z,e);A=+h[p+24>>3];s=+h[p+32>>3];v=+h[p+48>>3];w=s*+h[p+64>>3];y=z*A*(v-s*+h[p+80>>3])*461.526;D=y;E=A*(v*2.0+A*+h[p+56>>3])*e*461.526;F=0.0;G=0.0;H=0.0;I=y;J=(A*v+w)*e*461.526;K=0.0;L=s*s*+h[p+72>>3]*-461.526;M=z;N=(w- +h[p+40>>3])*461.526}else if((r|0)==5){Uh(q,b,d,e);w=+h[q+24>>3];z=+h[q+32>>3];s=+h[q+48>>3];v=+h[q+56>>3];A=+h[q+72>>3];y=+h[q+80>>3];C=z*+h[q+64>>3];B=(C- +h[q+40>>3])*461.526;x=w*s;t=(x-z*w*y)/d*461.526;u=w*w*v*+oB(d,-2)*e*461.526;w=z*z*A;A=s-z*y;D=0.0;E=0.0;F=t;G=u;H=1.0;I=-t/u;J=C*e*461.526;K=w*-461.526;L=(A*A/v-w)*461.526;M=d/(x*e*461.526);N=B}else if((r|0)==1){Th(m,b,d,e);B=+h[m+24>>3];x=+h[m+32>>3];w=+h[m+48>>3];v=+h[m+56>>3];A=+h[m+72>>3];C=+h[m+80>>3];u=x*+h[m+64>>3];t=(u- +h[m+40>>3])*461.526;y=B*w;z=(y-x*B*C)/d*461.526;s=B*B*v*+oB(d,-2)*e*461.526;B=x*x*A;A=w-x*C;D=0.0;E=0.0;F=z;G=s;H=0.0;I=-z/s;J=u*e*461.526;K=B*-461.526;L=(A*A/v-B)*461.526;M=d/(y*e*461.526);N=t}else{m=gA(gA(9680,eA(d,0,1,6)|0)|0,9736)|0;q=gA(gA(m,eA(e,0,1,6)|0)|0,9744)|0;m=c[27736]|0;p=j;o=9752;c[p+0>>2]=c[o+0>>2];c[p+4>>2]=c[o+4>>2];c[p+8>>2]=c[o+8>>2];c[p+12>>2]=c[o+12>>2];c[p+16>>2]=c[o+16>>2];c[p+20>>2]=c[o+20>>2];Le[m&63](b,j,q,k);D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0;J=0.0;K=0.0;L=0.0;M=0.0;N=0.0}c[a>>2]=1;c[a+4>>2]=r;h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=J;h[a+32>>3]=461.526;h[a+40>>3]=K;h[a+48>>3]=L;h[a+56>>3]=M;h[a+64>>3]=N;h[a+72>>3]=D;h[a+80>>3]=E;h[a+88>>3]=F;h[a+96>>3]=G;h[a+104>>3]=H;h[a+112>>3]=I;i=g;return}function Di(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;$h(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));ai(b,0,0.0,f);i=e;return}function Ei(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0;j=i;i=i+104|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=j+32|0;p=j+40|0;q=j+48|0;r=j+56|0;s=j+64|0;t=j+72|0;u=j+80|0;v=j+88|0;w=j+96|0;do{if((g|0)==0){_h(k,b,d);x=+h[k>>3];qi(l,b,d);y=+h[l>>3];if((f|0)==2){z=4;break}yi(m,b,d);A=+h[m>>3];Ai(n,b,d);B=+h[n>>3];Bi(o,b,d);if(d<611.657|d>1.0e8|A>e){z=-1;break}C=d<1.0e7;if(C&B<e){z=-1;break}if(d>=1.0e7&+h[o>>3]<e){z=-1;break}D=e<2087546.84511715;if(!(d<16529200.0)){if(D){wi(v,b,d);if(+h[v>>3]>e){z=1;break}z=x>e|d>22064.0e3?3:4;break}else{xi(w,b,d);if(+h[w>>3]<e){z=2;break}z=y<e|d>22064.0e3?3:4;break}}if(D){if((f|0)==1){z=1;break}Zg(p,b,d);ni(q,b,d,+h[p>>3]);z=+h[q>>3]>e?1:4;break}zi(r,b,d);if(!(+h[r>>3]<e)){if((f|0)==1){z=2;break}Zg(t,b,d);mi(u,b,d,+h[t>>3]);z=+h[u>>3]<e?2:4;break}Ai(s,b,d);if(C){if(+h[s>>3]>e){z=5;break}}z=-2}else{z=g}}while(0);c[a>>2]=z;i=j;return}function Fi(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0;g=i;i=i+56|0;j=g;k=g+24|0;l=g+48|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;c[n>>2]=42;wA(o,1,n);n=o;o=9776;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];p=e+-273.15;q=d/317.763;if(!(d>.004854575724778614)){o=gA(gA(9792,eA(d,0,1,6)|0)|0,9872)|0;n=gA(gA(o,eA(.004854575724778614,0,1,6)|0)|0,9880)|0;o=c[27736]|0;r=k;s=9904;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];c[r+16>>2]=c[s+16>>2];c[r+20>>2]=c[s+20>>2];Le[o&63](b,k,n,m);}if(!(f<=5.0e8)){t=5}else{if(!(p>=0.0&p<=150.0)){t=5}}do{if((t|0)==5){if(f<=35.0e7){if(p>150.0&p<=600.0){break}}if(f<=3.0e8){if(p>600.0&p<=900.0){break}}m=gA(gA(9928,eA(f,0,1,6)|0)|0,10040)|0;n=gA(gA(m,eA(p,0,1,6)|0)|0,8248)|0;m=c[27736]|0;k=j;o=10056;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];Le[m&63](b,j,n,l);}}while(0);p=q+-1.0;f=647.226/e;e=f+-1.0;d=+W(+f,-.5)/(f*(f*(f*-.202354+.579829)+.978197)+1.0);if((th(1,1,6)|0)==0){u=0.0;v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}l=(th(0,0,6)|0)==0;f=0.0;j=1;B=1.0;while(1){if((j|0)==1){C=B}else{C=e*B}if(l){D=f}else{b=j+ -1|0;E=f;t=0;F=1.0;while(1){if((t|0)==0){G=F}else{G=p*F}H=E+ +tA(9776,b+(t*6|0)|0)*C*G;n=t+1|0;if((th(n,0,6)|0)==0){D=H;break}else{E=H;t=n;F=G}}}t=j+1|0;if((th(t,1,6)|0)==0){u=D;break}else{f=D;j=t;B=C}}v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}function Gi(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function Hi(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+24>>3];i=i;return}function Ii(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0;b=i;d=+h[f+56>>3];if((c[f+4>>2]|0)==3){k=+h[f+72>>3];l=+h[f+80>>3];m=(k*e-d*l)*+oB(d,-2)*(g/l);e=d*d*l*+h[f+48>>3]+k*k*+h[f+16>>3];n=m+e*+oB(d,-2)*(j/l);o=a;p=o;h[p>>3]=n;i=b;return}else{n=+h[f+40>>3]*j+(1.0/d- +h[f+16>>3]*+h[f+88>>3])*g;o=a;p=o;h[p>>3]=n;i=b;return}}function Ji(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function Ki(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;ui(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));ai(b,0,0.0,f);i=e;return}function Li(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0.0,l=0,m=0;b=i;if((c[f+4>>2]|0)==3){e=+h[f+80>>3];k=g/e- +h[f+72>>3]*(j/e);l=a;m=l;h[m>>3]=k;i=b;return}else{e=+h[f+56>>3];k=-(e*e*(+h[f+96>>3]*g+ +h[f+88>>3]*j));l=a;m=l;h[m>>3]=k;i=b;return}}function Mi(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Rh(e,b,c);j=+h[e>>3];do{if(c<623.15){si(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}fi(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Ni(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function Oi(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Rh(e,b,c);j=+h[e>>3];do{if(c<623.15){ti(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}hi(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Pi(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0;j=i;i=i+536|0;k=j;l=j+24|0;m=j+48|0;n=j+112|0;o=j+176|0;p=j+264|0;q=j+352|0;r=j+440|0;s=j+528|0;t=i;i=i+8|0;u=i;i=i+64|0;v=i;i=i+64|0;w=i;i=i+88|0;x=i;i=i+88|0;y=i;i=i+88|0;z=i;i=i+88|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+88|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+24|0;G=i;i=i+88|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+88|0;M=i;i=i+88|0;N=i;i=i+64|0;O=i;i=i+64|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+88|0;T=i;i=i+88|0;V=i;i=i+64|0;W=i;i=i+64|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+16|0;_=i;i=i+88|0;do{if((g|0)==0){if((f|0)==2){$=+wd(+d,611.657);aa=+wd(+e,1.0e3);ba=$;ca=2;da=11;break}else{Ei(A,b,d,e,f,0);ea=c[A>>2]|0;da=5;break}}else{ea=g;da=5}}while(0);a:do{if((da|0)==5){if((f|0)==0){fa=(ea|0)==4?2:1}else{fa=f}$=+wd(+d,611.657);ga=+wd(+e,1.0e3);switch(ea|0){case 1:{Wh(B,b,$,ga);ha=+h[B>>3];Th(C,b,d,ha);ia=+h[C+24>>3];ja=+h[C+32>>3];ka=+h[C+48>>3];la=+h[C+56>>3];ma=+h[C+72>>3];na=+h[C+80>>3];oa=(ja*+h[C+64>>3]- +h[C+40>>3])*461.526;pa=ia*ka;qa=(pa-ja*ia*na)/d*461.526;ra=ha*ia*ia*la*+oB(d,-2)*461.526;ia=ja*ja*ma;ma=ka-ja*na;sa=$;ta=fa;ua=0.0;va=0.0;wa=qa;xa=ra;ya=0.0;za=-qa/ra;Aa=ha;Ba=ga;Ca=ia*-461.526;Da=(ma*ma/la-ia)*461.526;Ea=d/(ha*pa*461.526);Fa=oa;Ga=1;break a;break};case 2:{Xh(D,0,$,ga);oa=+h[D>>3];Sh(E,b,d,oa);pa=+h[E+24>>3];ha=+h[E+32>>3];ia=+h[E+48>>3];la=+h[E+56>>3];ma=+h[E+72>>3];ra=+h[E+80>>3];qa=(ha*+h[E+64>>3]- +h[E+40>>3])*461.526;na=pa*ia;ja=(na-ha*pa*ra)/d*461.526;ka=oa*pa*pa*la*+oB(d,-2)*461.526;pa=ha*ha*ma;ma=ia-ha*ra;sa=$;ta=fa;ua=0.0;va=0.0;wa=ja;xa=ka;ya=1.0;za=-ja/ka;Aa=oa;Ba=ga;Ca=pa*-461.526;Da=(ma*ma/la-pa)*461.526;Ea=d/(oa*na*461.526);Fa=qa;Ga=2;break a;break};case 4:{aa=ga;ba=$;ca=fa;da=11;break a;break};case 3:{pi(F,b,$,ga,1.0e-7,1.0e-6);qa=+h[F>>3];na=+h[F+8>>3];Kh(G,b,qa,na);oa=+h[G+24>>3];pa=+h[G+32>>3];la=+h[G+48>>3];ma=pa*+h[G+64>>3];ka=na*oa*(la*2.0+oa*+h[G+56>>3])*461.526;ja=qa*oa*(la-pa*+h[G+80>>3])*461.526;ra=+U(+(pa*pa*+h[G+72>>3]*-461.526));pa=qa*qa;sa=$;ta=fa;ua=ja;va=ka;wa=0.0;xa=0.0;ya=0.0;za=ja;Aa=na;Ba=na*(oa*la+ma)*461.526;Ca=(pa*ra*ka+na*ja*ja)/(pa*ka);Da=ra;Ea=qa;Fa=(ma- +h[G+40>>3])*461.526;Ga=3;break a;break};case 5:{ri(Z,b,$,ga,1.0e-7);ma=+h[Z>>3];if((c[Z+8>>2]|0)!=0){g=c[27736]|0;A=l;Ha=10080;c[A+0>>2]=c[Ha+0>>2];c[A+4>>2]=c[Ha+4>>2];c[A+8>>2]=c[Ha+8>>2];c[A+12>>2]=c[Ha+12>>2];c[A+16>>2]=c[Ha+16>>2];c[A+20>>2]=c[Ha+20>>2];Le[g&63](b,l,10104,t);}Uh(_,b,$,ma);qa=+h[_+24>>3];ra=+h[_+32>>3];ka=+h[_+48>>3];pa=+h[_+56>>3];ja=+h[_+72>>3];na=+h[_+80>>3];la=(ra*+h[_+64>>3]- +h[_+40>>3])*461.526;oa=qa*ka;ha=(oa-ra*qa*na)/d*461.526;ia=ma*qa*qa*pa*+oB(d,-2)*461.526;qa=ra*ra*ja;ja=ka-ra*na;sa=$;ta=fa;ua=0.0;va=0.0;wa=ha;xa=ia;ya=0.0;za=-ha/ia;Aa=ma;Ba=ga;Ca=qa*-461.526;Da=(ja*ja/pa-qa)*461.526;Ea=d/(ma*oa*461.526);Fa=la;Ga=5;break a;break};default:{g=gA(gA(gA(gA(9680,eA(d,0,1,6)|0)|0,10152)|0,eA(e,0,1,6)|0)|0,9744)|0;Ha=c[27736]|0;A=k;Ia=10160;c[A+0>>2]=c[Ia+0>>2];c[A+4>>2]=c[Ia+4>>2];c[A+8>>2]=c[Ia+8>>2];c[A+12>>2]=c[Ia+12>>2];c[A+16>>2]=c[Ia+16>>2];c[A+20>>2]=c[Ia+20>>2];Le[Ha&63](b,k,g,s);sa=$;ta=fa;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0;Aa=0.0;Ba=ga;Ca=0.0;Da=0.0;Ea=0.0;Fa=0.0;Ga=ea;break a}}}}while(0);if((da|0)==11){Di(H,b,d);ga=+h[H>>3];Ki(I,b,d);$=+h[I>>3];if($!=ga){Ja=(e-ga)/($-ga)}else{Ja=1.0}if(d<16529200.0){Wh(J,b,ba,ga);ga=+h[J>>3];Xh(K,0,ba,$);$=+h[K>>3];Th(L,b,ba,ga);e=+h[L+8>>3];la=+h[L+16>>3];oa=+h[L+24>>3];ma=+h[L+32>>3];qa=+h[L+40>>3];pa=+h[L+48>>3];ja=+h[L+56>>3];ia=+h[L+64>>3];ha=+h[L+72>>3];na=+h[L+80>>3];h[w>>3]=+h[L>>3];h[w+8>>3]=e;h[w+16>>3]=la;h[w+24>>3]=oa;h[w+32>>3]=ma;h[w+40>>3]=qa;h[w+48>>3]=pa;h[w+56>>3]=ja;h[w+64>>3]=ia;h[w+72>>3]=ha;h[w+80>>3]=na;Sh(M,b,ba,$);na=+h[M+8>>3];ha=+h[M+16>>3];ia=+h[M+24>>3];ja=+h[M+32>>3];pa=+h[M+40>>3];qa=+h[M+48>>3];ma=+h[M+56>>3];oa=+h[M+64>>3];la=+h[M+72>>3];e=+h[M+80>>3];h[x>>3]=+h[M>>3];h[x+8>>3]=na;h[x+16>>3]=ha;h[x+24>>3]=ia;h[x+32>>3]=ja;h[x+40>>3]=pa;h[x+48>>3]=qa;h[x+56>>3]=ma;h[x+64>>3]=oa;h[x+72>>3]=la;h[x+80>>3]=e;Ka=r+0|0;La=w+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Mh(N,0,r);e=+h[N+8>>3];la=+h[N+16>>3];oa=+h[N+24>>3];ma=+h[N+32>>3];qa=+h[N+40>>3];pa=+h[N+48>>3];ja=+h[N+56>>3];h[u>>3]=+h[N>>3];h[u+8>>3]=e;h[u+16>>3]=la;h[u+24>>3]=oa;h[u+32>>3]=ma;h[u+40>>3]=qa;h[u+48>>3]=pa;h[u+56>>3]=ja;Ka=q+0|0;La=x+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Mh(O,0,q);ja=+h[O>>3];pa=+h[O+8>>3];qa=+h[O+16>>3];ma=+h[O+24>>3];oa=+h[O+32>>3];la=+h[O+40>>3];e=+h[O+48>>3];ia=+h[O+56>>3];h[v>>3]=ja;h[v+8>>3]=pa;h[v+16>>3]=qa;h[v+24>>3]=ma;h[v+32>>3]=oa;h[v+40>>3]=la;h[v+48>>3]=e;h[v+56>>3]=ia;Na=ma;Oa=ja;Pa=ga+Ja*($-ga)}else{Zg(P,b,ba);ga=+h[P>>3];Mi(Q,b,ga);$=+h[Q>>3];Oi(R,b,ga);ja=+h[R>>3];Kh(S,b,$,ga);$=+h[S+8>>3];ma=+h[S+16>>3];ia=+h[S+24>>3];e=+h[S+32>>3];la=+h[S+40>>3];oa=+h[S+48>>3];qa=+h[S+56>>3];pa=+h[S+64>>3];ha=+h[S+72>>3];na=+h[S+80>>3];h[y>>3]=+h[S>>3];h[y+8>>3]=$;h[y+16>>3]=ma;h[y+24>>3]=ia;h[y+32>>3]=e;h[y+40>>3]=la;h[y+48>>3]=oa;h[y+56>>3]=qa;h[y+64>>3]=pa;h[y+72>>3]=ha;h[y+80>>3]=na;Kh(T,b,ja,ga);ja=+h[T+8>>3];na=+h[T+16>>3];ha=+h[T+24>>3];pa=+h[T+32>>3];qa=+h[T+40>>3];oa=+h[T+48>>3];la=+h[T+56>>3];e=+h[T+64>>3];ia=+h[T+72>>3];ma=+h[T+80>>3];h[z>>3]=+h[T>>3];h[z+8>>3]=ja;h[z+16>>3]=na;h[z+24>>3]=ha;h[z+32>>3]=pa;h[z+40>>3]=qa;h[z+48>>3]=oa;h[z+56>>3]=la;h[z+64>>3]=e;h[z+72>>3]=ia;h[z+80>>3]=ma;Ka=p+0|0;La=y+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Lh(V,0,p);ma=+h[V+8>>3];ia=+h[V+16>>3];e=+h[V+24>>3];la=+h[V+32>>3];oa=+h[V+40>>3];qa=+h[V+48>>3];pa=+h[V+56>>3];h[u>>3]=+h[V>>3];h[u+8>>3]=ma;h[u+16>>3]=ia;h[u+24>>3]=e;h[u+32>>3]=la;h[u+40>>3]=oa;h[u+48>>3]=qa;h[u+56>>3]=pa;Ka=o+0|0;La=z+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Lh(W,0,o);pa=+h[W>>3];qa=+h[W+8>>3];oa=+h[W+16>>3];la=+h[W+24>>3];e=+h[W+32>>3];ia=+h[W+40>>3];ma=+h[W+48>>3];ha=+h[W+56>>3];h[v>>3]=pa;h[v+8>>3]=qa;h[v+16>>3]=oa;h[v+24>>3]=la;h[v+32>>3]=e;h[v+40>>3]=ia;h[v+48>>3]=ma;h[v+56>>3]=ha;Na=la;Oa=pa;Pa=ga}W=u;ga=+h[W>>3];if(ga!=Oa){pa=+h[u+24>>3];Qa=Oa;Ra=ga;Sa=Na;Ta=pa;Ua=(Na-pa)*ga*(Oa/(ga-Oa))}else{Qh(X,b,Pa);Qa=+h[v>>3];Ra=+h[W>>3];Sa=+h[v+24>>3];Ta=+h[u+24>>3];Ua=+h[X>>3]}Oa=Ta+Ja*(Sa-Ta);Ta=Ra*(Qa/(Qa+Ja*(Ra-Qa)));Ka=n+0|0;La=u+0|0;Ma=Ka+64|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Ka=m+0|0;La=v+0|0;Ma=Ka+64|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Nh(Y,0,n,m,Ja,Pa,d);d=+h[u+32>>3];Qa=+h[u+48>>3];Ra=+h[u+56>>3];sa=ba;ta=ca;ua=Qa+Ja*(+h[v+48>>3]-Qa);va=Ra+Ja*(+h[v+56>>3]-Ra);wa=0.0;xa=0.0;ya=Ja;za=Ua;Aa=Pa;Ba=aa;Ca=d+Ja*(+h[v+32>>3]-d);Da=+h[Y>>3];Ea=Ta;Fa=Oa;Ga=4}c[a>>2]=ta;c[a+4>>2]=Ga;h[a+8>>3]=sa;h[a+16>>3]=Aa;h[a+24>>3]=Ba;h[a+32>>3]=461.526;h[a+40>>3]=Ca;h[a+48>>3]=Da;h[a+56>>3]=Ea;h[a+64>>3]=Fa;h[a+72>>3]=ua;h[a+80>>3]=va;h[a+88>>3]=wa;h[a+96>>3]=xa;h[a+104>>3]=ya;h[a+112>>3]=za;i=j;return}function Qi(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;rz(4,0,13696,b);rz(4,0,13736,a);i=a;return}function Ri(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}C2(a);c[d>>2]=0;i=b;return}function Si(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+8|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+8|0]|0;k=b+4|0;l=bD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+96>>3],0.0,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=l;e=k;f=j;break}else{j=b+4|0;k=bD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+96>>3],0.0,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+8|0]|0;k=b+4|0;j=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+96>>3],0.0)|0;a[(c[b+352>>2]|0)+8|0]=j;e=k;f=g;break}else{g=b+4|0;k=fD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],0.0)|0;a[(c[b+352>>2]|0)+8|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=gD(+h[k+56>>3],+h[k+528>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+4|0]|0)!=0){m=0;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}function Ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+192>>3]- +h[(c[a+416>>2]|0)+632>>3];i=i;return}function Ui(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+576>>3]*+h[b+552>>3]*.002;i=i;return}function Vi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+1424>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+1400>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+1408>>3];h[a+8>>3]=+h[d+2768>>3];h[e+8>>3]=+h[d+2744>>3];h[f+8>>3]=+h[d+2752>>3];i=i;return}function Wi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0.0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0,W=0,X=0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+96>>3]=+h[d>>3];h[l+192>>3]=+h[d+8>>3];Si(j);Ti(j);Ui(j);j=c[c[k>>2]>>2]|0;d=c[j+16>>2]|0;do{if((a[d+4|0]|0)==0){l=c[j+8>>2]|0;if((a[d+1|0]|0)==0){m=l;n=d;o=-+h[l+544>>3];break}else{m=l;n=d;o=+h[l+192>>3]- +h[l+120>>3];break}}else{l=b+304|0;p=+h[l>>3];q=b+416|0;r=c[q>>2]|0;s=+h[r+544>>3];t=c[j+8>>2]|0;u=+h[t+432>>3];do{if(s!=0.0){v=u;w=t;x=j;y=s;z=r;A=u/s}else{if(u==0.0){v=u;w=t;x=j;y=s;z=r;A=u;break}B=u/+xz(c[b+536>>2]|0,s,13792,13784,+h[j>>3],(a[b+319|0]|0)!=0|0);C=c[q>>2]|0;D=c[c[k>>2]>>2]|0;E=c[D+8>>2]|0;v=+h[E+432>>3];w=E;x=D;y=+h[C+544>>3];z=C;A=B}}while(0);do{if(y!=0.0){F=z;G=w;H=x;I=v/y}else{if(v==0.0){F=z;G=w;H=x;I=v;break}s=v/+xz(c[b+536>>2]|0,y,13792,13784,+h[x>>3],(a[b+319|0]|0)!=0|0);r=c[c[k>>2]>>2]|0;F=c[q>>2]|0;G=c[r+8>>2]|0;H=r;I=s}}while(0);r=b+536|0;t=c[r>>2]|0;s=-+h[G+544>>3];u=+h[F+488>>3];B=A*A+ +h[F+72>>3]+-1.0;J=+h[G+168>>3];K=+h[G+144>>3];do{if(J!=0.0){L=K;M=G;N=H;O=K/J;P=F}else{if(K==0.0){L=K;M=G;N=H;O=K;P=F;break}Q=K/+xz(t,J,13816,13784,+h[H>>3],(a[b+319|0]|0)!=0|0);C=c[c[k>>2]>>2]|0;D=c[C+8>>2]|0;L=+h[D+144>>3];M=D;N=C;O=Q;P=c[q>>2]|0}}while(0);J=B*O;K=L*+h[M+616>>3];Q=+h[P+64>>3]-I*I+1.0;do{if(K!=0.0){R=Q/K}else{if(Q==0.0){R=Q;break}R=Q/+xz(c[r>>2]|0,K,13848,13784,+h[N>>3],(a[b+319|0]|0)!=0|0)}}while(0);qh(g,t,s,u,J,R,0,1.0);K=+h[g>>3];Q=+h[l>>3];r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;B=+h[r+192>>3];S=+h[r+120>>3];T=p*(S+K*+oB(+h[r+432>>3],-2)*.5);r=c[c[k>>2]>>2]|0;q=c[r+8>>2]|0;m=q;n=c[r+16>>2]|0;o=B-(T+(1.0-Q)*+h[q+120>>3])}}while(0);h[e>>3]=o;if((a[n+4|0]|0)!=0){U=+h[m+96>>3]-(+h[m+16>>3]- +h[(c[b+416>>2]|0)+56>>3]);V=e;W=V+8|0;X=W;h[X>>3]=U;i=f;return}o=+h[m+96>>3];if((a[n+1|0]|0)==0){U=o-(+h[m+192>>3]- +h[m+120>>3])*(+h[(c[b+416>>2]|0)+56>>3]- +h[m+16>>3])*9869232667160129.0e-21;V=e;W=V+8|0;X=W;h[X>>3]=U;i=f;return}else{U=o+ +h[m+544>>3];V=e;W=V+8|0;X=W;h[X>>3]=U;i=f;return}}function Xi(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+7024>>3];h[c[b+8>>2]>>3]=+h[d+7e3>>3];h[c[b+12>>2]>>3]=+h[d+7008>>3];i=i;return}function Yi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0;f=i;g=+h[d>>3];d=b+4|0;j=c[c[d>>2]>>2]|0;h[(c[j+8>>2]|0)+496>>3]=g;do{if((a[b+314|0]|0)==0){k=a[(c[b+356>>2]|0)+7|0]|0}else{l=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(l){m=a[(c[b+356>>2]|0)+7|0]|0;n=aD(+h[j>>3],g,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=n;k=m;break}else{m=aD(+h[j>>3],g,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=m;k=m;break}}else{if(l){l=a[(c[b+356>>2]|0)+7|0]|0;m=dD(+h[j>>3],g)|0;a[(c[b+352>>2]|0)+7|0]=m;k=l;break}else{l=dD(+h[j>>3],g)|0;a[(c[b+352>>2]|0)+7|0]=l;k=l;break}}}}while(0);b=c[c[d>>2]>>2]|0;d=c[b+8>>2]|0;g=+h[d+520>>3];o=+h[d+512>>3];if(k<<24>>24==0){p=o;q=g-p;h[e>>3]=q;i=f;return}p=o-(+h[d+496>>3]- +h[b>>3])*+h[d+504>>3];q=g-p;h[e>>3]=q;i=f;return}function Zi(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+7360>>3];h[c[b+8>>2]>>3]=+h[d+7336>>3];h[c[b+12>>2]>>3]=+h[d+7344>>3];i=i;return}function _i(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;h[(c[a+400>>2]|0)+520>>3]=+h[b>>3];b=c[c[a+4>>2]>>2]|0;h[d>>3]=+h[(c[b+8>>2]|0)+496>>3]- +h[b>>3];i=i;return}function $i(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+10384>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+10360>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+10368>>3];h[a+8>>3]=+h[d+10608>>3];h[e+8>>3]=+h[d+10584>>3];h[f+8>>3]=+h[d+10592>>3];i=i;return}function aj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0,$=0,aa=0;f=i;i=i+112|0;g=f;j=f+16|0;l=f+32|0;m=f+48|0;n=f+64|0;o=f+80|0;p=f+96|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=b+4|0;F=c[(c[c[E>>2]>>2]|0)+8>>2]|0;h[F+736>>3]=+h[d>>3];h[F+752>>3]=+h[d+8>>3];d=b+304|0;G=+h[d>>3];F=u;h[k>>3]=.25;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=u+8|0;h[k>>3]=.5;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];DA(v,3,0.0,u);u=t;h[k>>3]=60.0;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t+8|0;h[k>>3]=0.0;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];DA(w,3,100.0,t);t=b+536|0;u=c[t>>2]|0;F=o;H=v;c[F+0>>2]=c[H+0>>2];c[F+4>>2]=c[H+4>>2];c[F+8>>2]=c[H+8>>2];H=n;F=w;c[H+0>>2]=c[F+0>>2];c[H+4>>2]=c[F+4>>2];c[H+8>>2]=c[F+8>>2];gh(B,u,0.0,o,n);I=+h[B>>3];J=+h[d>>3];B=b+314|0;do{if((a[B]|0)==0){K=a[(c[b+356>>2]|0)+10|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){o=a[(c[b+356>>2]|0)+10|0]|0;u=bD(+h[(c[(c[c[E>>2]>>2]|0)+8>>2]|0)+752>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=u;K=o;break}else{o=bD(+h[(c[(c[c[E>>2]>>2]|0)+8>>2]|0)+752>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=o;K=o;break}}else{if(n){n=a[(c[b+356>>2]|0)+10|0]|0;o=fD(+h[(c[(c[c[E>>2]>>2]|0)+8>>2]|0)+752>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=o;K=n;break}else{n=fD(+h[(c[(c[c[E>>2]>>2]|0)+8>>2]|0)+752>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=n;K=n;break}}}}while(0);n=b+416|0;L=+h[(c[n>>2]|0)+344>>3];o=L!=0.0;u=c[c[E>>2]>>2]|0;M=+h[(c[u+8>>2]|0)+760>>3];if(K<<24>>24==0){do{if(o){N=M/L}else{if(M==0.0){N=M;break}N=M/+xz(c[t>>2]|0,L,13912,13904,+h[u>>3],(a[b+319|0]|0)!=0|0)}}while(0);K=q;h[k>>3]=.25;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=q+8|0;h[k>>3]=.5;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];DA(z,3,0.0,q);q=p;h[k>>3]=60.0;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=p+8|0;h[k>>3]=0.0;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];DA(A,3,100.0,p);p=c[t>>2]|0;q=j;K=z;c[q+0>>2]=c[K+0>>2];c[q+4>>2]=c[K+4>>2];c[q+8>>2]=c[K+8>>2];K=g;q=A;c[K+0>>2]=c[q+0>>2];c[K+4>>2]=c[q+4>>2];c[K+8>>2]=c[q+8>>2];gh(D,p,0.0,j,g);g=c[c[E>>2]>>2]|0;j=c[g+8>>2]|0;O=j;P=g;Q=N*N*+h[D>>3]- +h[j+752>>3]}else{do{if(o){R=M/L}else{if(M==0.0){R=M;break}R=M/+xz(c[t>>2]|0,L,13912,13904,+h[u>>3],(a[b+319|0]|0)!=0|0)}}while(0);u=s;h[k>>3]=.25;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=s+8|0;h[k>>3]=.5;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];DA(x,3,0.0,s);s=r;h[k>>3]=60.0;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r+8|0;h[k>>3]=0.0;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];DA(y,3,100.0,r);r=c[t>>2]|0;s=c[c[E>>2]>>2]|0;u=c[s+8>>2]|0;L=+h[u+736>>3];M=+h[u+760>>3];N=+h[(c[n>>2]|0)+344>>3];do{if(M!=0.0){S=N/M}else{if(N==0.0){S=N;break}S=N/+xz(r,M,13928,13904,+h[s>>3],(a[b+319|0]|0)!=0|0)}}while(0);M=L*S;s=m;u=x;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];u=l;s=y;c[u+0>>2]=c[s+0>>2];c[u+4>>2]=c[s+4>>2];c[u+8>>2]=c[s+8>>2];gh(C,r,M,m,l);l=c[c[E>>2]>>2]|0;O=c[l+8>>2]|0;P=l;Q=R*R*+h[C>>3]}R=+h[O+680>>3];M=G+-1.0;G=+h[O+760>>3];S=+h[(c[n>>2]|0)+344>>3];do{if(S!=0.0){T=I/S}else{if(I==0.0){T=I;break}T=I/+xz(c[t>>2]|0,S,13912,13904,+h[P>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[e>>3]=R+(M*G*T-J*Q);Q=+h[d>>3];do{if((a[B]|0)==0){U=a[(c[b+356>>2]|0)+10|0]|0}else{d=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(d){P=a[(c[b+356>>2]|0)+10|0]|0;O=bD(+h[(c[(c[c[E>>2]>>2]|0)+8>>2]|0)+752>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=O;U=P;break}else{P=bD(+h[(c[(c[c[E>>2]>>2]|0)+8>>2]|0)+752>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=P;U=P;break}}else{if(d){d=a[(c[b+356>>2]|0)+10|0]|0;P=fD(+h[(c[(c[c[E>>2]>>2]|0)+8>>2]|0)+752>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=P;U=d;break}else{d=fD(+h[(c[(c[c[E>>2]>>2]|0)+8>>2]|0)+752>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=d;U=d;break}}}}while(0);B=c[c[E>>2]>>2]|0;d=c[B+8>>2]|0;J=+h[d+736>>3];T=Q+-1.0;G=+h[(c[n>>2]|0)+408>>3];M=+h[d+752>>3];do{if(G!=0.0){V=M/G}else{if(M==0.0){V=M;break}V=M/+xz(c[t>>2]|0,G,13936,13904,+h[B>>3],(a[b+319|0]|0)!=0|0)}}while(0);G=T*V;if(U<<24>>24==0){W=0.0;X=Q*W;Y=G-X;Z=J+Y;_=e;$=_+8|0;aa=$;h[aa>>3]=Z;i=f;return}U=c[c[E>>2]>>2]|0;E=c[U+8>>2]|0;V=+h[E+688>>3];T=+h[E+752>>3];if(V!=0.0){W=T/V;X=Q*W;Y=G-X;Z=J+Y;_=e;$=_+8|0;aa=$;h[aa>>3]=Z;i=f;return}if(T==0.0){W=T;X=Q*W;Y=G-X;Z=J+Y;_=e;$=_+8|0;aa=$;h[aa>>3]=Z;i=f;return}W=T/+xz(c[t>>2]|0,V,13960,13904,+h[U>>3],(a[b+319|0]|0)!=0|0);X=Q*W;Y=G-X;Z=J+Y;_=e;$=_+8|0;aa=$;h[aa>>3]=Z;i=f;return}function bj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=b+4|0;l=bD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;e=k;f=j;break}else{j=b+4|0;k=bD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+88>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;k=b+4|0;j=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=j;e=k;f=g;break}else{g=b+4|0;k=fD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=gD(+h[k+24>>3],+h[k+528>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+3|0]|0)!=0){m=0;a[k]=m;i=d;return}if(!(f<<24>>24==0)){m=1;a[k]=m;i=d;return}m=b<<24>>24!=0|0;a[k]=m;i=d;return}function cj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+856>>3],+h[a+624>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+856>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Gi(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+248>>3]=+h[f>>3];i=b;return}function dj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;Pi(e,c[g>>2]|0,+h[a+856>>3],+h[a+624>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+856>>3];l=+h[g+624>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));Ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+304>>3]=+h[f>>3];i=b;return}function ej(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Fi(d,c[a+536>>2]|0,+h[f+304>>3],+h[f+248>>3],+h[f+856>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+280>>3]=+h[d>>3];i=b;return}function fj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+208>>3]=+h[b+216>>3]*(+h[d+856>>3]- +h[d+32>>3])*+h[b+248>>3];i=i;return}function gj(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+216>>3]*+h[e+248>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+208>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}k=l/+xz(c[b+536>>2]|0,f,13984,13976,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+200|0;q=p;h[q>>3]=n;i=d;return}function hj(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=c[j>>2]|0;l=b+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;o=+h[n+200>>3];p=+h[n+296>>3];q=+h[n+304>>3];r=+h[n+272>>3];s=+h[n+280>>3];t=b+416|0;u=c[t>>2]|0;v=+h[u+168>>3];w=+h[n+448>>3];x=+h[u+192>>3]*+h[u+312>>3];y=+h[u+184>>3];z=(y+y)*.5;n=(c[(c[b+420>>2]|0)+8>>2]|0)+ -1|0;y=+(n|0);A=+h[u+304>>3];do{if((n|0)==0){if(A==0.0){B=u;C=A;break}D=A/+xz(k,y,14040,14032,+h[m>>3],(a[b+319|0]|0)!=0|0);B=c[t>>2]|0;C=D}else{B=u;C=A/y}}while(0);jh(e,k,o,p,q,r,s,v,w,x,z,C,+h[B+272>>3]);B=c[t>>2]|0;C=g*+h[e>>3]*+h[B+248>>3];g=1.0- +h[f>>3];f=c[c[l>>2]>>2]|0;e=c[f+8>>2]|0;z=+h[e+200>>3]- +h[B+192>>3]*+h[B+312>>3]*+h[B+328>>3];x=+h[B+280>>3];w=+h[B+288>>3];if(x!=0.0){E=w/x;F=e;G=z*E;H=g*G;I=C+H;J=F;K=J+224|0;L=K;h[L>>3]=I;i=d;return}if(w==0.0){E=w;F=e;G=z*E;H=g*G;I=C+H;J=F;K=J+224|0;L=K;h[L>>3]=I;i=d;return}v=w/+xz(c[j>>2]|0,x,14072,14032,+h[f>>3],(a[b+319|0]|0)!=0|0);E=v;F=c[(c[c[l>>2]>>2]|0)+8>>2]|0;G=z*E;H=g*G;I=C+H;J=F;K=J+224|0;L=K;h[L>>3]=I;i=d;return}function ij(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+1312>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+1288>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+1296>>3];h[a+8>>3]=+h[d+12064>>3];h[e+8>>3]=+h[d+12040>>3];h[f+8>>3]=+h[d+12048>>3];i=i;return}function jj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0,W=0,X=0,Y=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+88>>3]=+h[d>>3];h[l+856>>3]=+h[d+8>>3];bj(j);cj(j);dj(j);ej(j);fj(j);gj(j);hj(j);j=c[c[k>>2]>>2]|0;d=c[j+16>>2]|0;do{if((a[d+3|0]|0)==0){l=c[j+8>>2]|0;if((a[d]|0)==0){m=l;n=d;o=+h[l+224>>3];break}else{m=l;n=d;o=+h[l+856>>3]- +h[l+112>>3];break}}else{l=b+304|0;p=+h[l>>3];q=b+416|0;r=c[q>>2]|0;s=+h[r+544>>3];t=c[j+8>>2]|0;u=+h[t+424>>3];do{if(s!=0.0){v=u;w=t;x=j;y=s;z=r;A=u/s}else{if(u==0.0){v=u;w=t;x=j;y=s;z=r;A=u;break}B=u/+xz(c[b+536>>2]|0,s,13792,14104,+h[j>>3],(a[b+319|0]|0)!=0|0);C=c[q>>2]|0;D=c[c[k>>2]>>2]|0;E=c[D+8>>2]|0;v=+h[E+424>>3];w=E;x=D;y=+h[C+544>>3];z=C;A=B}}while(0);do{if(y!=0.0){F=z;G=w;H=x;I=v/y}else{if(v==0.0){F=z;G=w;H=x;I=v;break}s=v/+xz(c[b+536>>2]|0,y,13792,14104,+h[x>>3],(a[b+319|0]|0)!=0|0);r=c[c[k>>2]>>2]|0;F=c[q>>2]|0;G=c[r+8>>2]|0;H=r;I=s}}while(0);r=b+536|0;t=c[r>>2]|0;s=+h[G+224>>3];u=+h[F+488>>3];B=A*A+ +h[F+40>>3]+-1.0;J=+h[G+160>>3];K=+h[G+136>>3];do{if(J!=0.0){L=G;M=H;N=K/J;O=F;P=K}else{if(K==0.0){L=G;M=H;N=K;O=F;P=K;break}Q=K/+xz(t,J,14112,14104,+h[H>>3],(a[b+319|0]|0)!=0|0);C=c[c[k>>2]>>2]|0;D=c[C+8>>2]|0;L=D;M=C;N=Q;O=c[q>>2]|0;P=+h[D+136>>3]}}while(0);J=B*N;K=P*+h[L+616>>3];Q=+h[O+32>>3]-I*I+1.0;do{if(K!=0.0){R=Q/K}else{if(Q==0.0){R=Q;break}R=Q/+xz(c[r>>2]|0,K,14144,14104,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);qh(g,t,s,u,J,R,0,1.0);K=+h[g>>3];Q=+h[l>>3];r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;B=+h[r+856>>3];S=+h[r+112>>3];T=p*(S+K*+oB(+h[r+424>>3],-2)*.5);r=c[c[k>>2]>>2]|0;q=c[r+8>>2]|0;m=q;n=c[r+16>>2]|0;o=B-(T+(1.0-Q)*+h[q+112>>3])}}while(0);h[e>>3]=o;if((a[n+3|0]|0)!=0){U=+h[m+88>>3]-(+h[m+16>>3]- +h[(c[b+416>>2]|0)+24>>3]);V=e;W=V+8|0;X=W;h[X>>3]=U;i=f;return}if((a[n]|0)==0){Y=(+h[m+856>>3]- +h[m+112>>3])*(+h[(c[b+416>>2]|0)+24>>3]- +h[m+16>>3])*9869232667160129.0e-21}else{Y=+h[m+224>>3]}U=+h[m+88>>3]-Y;V=e;W=V+8|0;X=W;h[X>>3]=U;i=f;return}function kj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+1088>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+1064>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+1072>>3];h[a+8>>3]=+h[d+12960>>3];h[e+8>>3]=+h[d+12936>>3];h[f+8>>3]=+h[d+12944>>3];h[a+16>>3]=+h[d+976>>3];h[e+16>>3]=+h[d+952>>3];h[f+16>>3]=+h[d+960>>3];i=i;return}function lj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0;e=i;i=i+496|0;f=e;g=e+120|0;j=e+240|0;k=e+360|0;l=e+480|0;m=e+488|0;n=+h[b>>3];o=a+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[p+72>>3]=n;q=+h[b+8>>3];h[p+920>>3]=q;h[p+64>>3]=+h[b+16>>3];r=+h[p+688>>3];s=r*r;b=p+32|0;h[d>>3]=+h[p+880>>3]*s+(r*n+(-(s*q)- +h[b>>3]*+h[p+936>>3]));t=a+536|0;Ci(j,c[t>>2]|0,+h[b>>3],+h[p+24>>3],0);p=c[t>>2]|0;b=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[b+32>>3];s=+h[b+24>>3];n=+h[b+72>>3];r=+h[b+64>>3];b=g+0|0;a=j+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));Ii(l,p,q,s,g,n,r);g=c[(c[c[o>>2]>>2]|0)+8>>2]|0;h[d+8>>3]=+h[g+920>>3]- +h[l>>3];Ci(k,c[t>>2]|0,+h[g+32>>3],+h[g+24>>3],0);g=c[t>>2]|0;t=c[(c[c[o>>2]>>2]|0)+8>>2]|0;r=+h[t+32>>3];n=+h[t+24>>3];s=+h[t+72>>3];q=+h[t+64>>3];b=f+0|0;a=k+0|0;j=b+120|0;do{c[b>>2]=c[a>>2];b=b+4|0;a=a+4|0}while((b|0)<(j|0));Li(m,g,r,n,f,s,q);h[d+16>>3]=+h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+936>>3]- +h[m>>3];i=e;return}function mj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Ci(e,c[g>>2]|0,+h[(c[j>>2]|0)+512>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+512>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+8>>3];n=+h[j+48>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Ii(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+928>>3]=+h[f>>3];i=b;return}function nj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;Ci(e,c[g>>2]|0,+h[(c[j>>2]|0)+512>>3],+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+512>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+8>>3];n=+h[j+48>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));Li(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+912>>3]=+h[f>>3];i=b;return}function oj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+616>>3];k=+h[g+928>>3];l=+h[(c[b+416>>2]|0)+512>>3];m=j*j;j=+h[g+912>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+888|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+888|0;t=s;h[t>>3]=q;i=d;return}u=j/+xz(c[b+536>>2]|0,m,14208,14200,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+888|0;t=s;h[t>>3]=q;i=d;return}function pj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=-(+h[(c[a+416>>2]|0)+512>>3]*+h[b+872>>3]);i=i;return}function qj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+904>>3]=+h[b+648>>3]+ +h[b+640>>3];i=i;return}function rj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+752>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+728>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+736>>3];h[a+8>>3]=+h[d+12288>>3];h[e+8>>3]=+h[d+12264>>3];h[f+8>>3]=+h[d+12272>>3];i=i;return}function sj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+48>>3]=+h[b>>3];h[a+872>>3]=+h[b+8>>3];mj(f);nj(f);oj(f);pj(f);qj(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+656|0;h[d>>3]=+h[f+904>>3]+(-(+h[f+664>>3]*+h[f+888>>3])- +h[g>>3]*+h[f+608>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+632>>3]*+h[f+912>>3])- +h[f+872>>3]*+h[f+616>>3]);i=e;return}function tj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2656>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2632>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2640>>3];h[a+8>>3]=+h[d+1536>>3];h[e+8>>3]=+h[d+1512>>3];h[f+8>>3]=+h[d+1520>>3];i=i;return}function uj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0.0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;f=i;i=i+8|0;g=f;j=+h[d>>3];k=b+4|0;l=c[c[k>>2]>>2]|0;m=c[l+8>>2]|0;h[m+184>>3]=j;h[m+104>>3]=+h[d+8>>3];d=c[l+16>>2]|0;do{if((a[d+5|0]|0)==0){if((a[d+2|0]|0)==0){n=m;o=d;p=-0.0;break}n=m;o=d;p=j- +h[m+128>>3]}else{q=b+416|0;r=c[q>>2]|0;s=+h[r+544>>3];t=+h[m+440>>3];do{if(s!=0.0){u=t;v=m;w=l;x=s;y=r;z=t/s}else{if(t==0.0){u=t;v=m;w=l;x=s;y=r;z=t;break}A=t/+xz(c[b+536>>2]|0,s,13792,14240,+h[l>>3],(a[b+319|0]|0)!=0|0);B=c[q>>2]|0;C=c[c[k>>2]>>2]|0;D=c[C+8>>2]|0;u=+h[D+440>>3];v=D;w=C;x=+h[B+544>>3];y=B;z=A}}while(0);do{if(x!=0.0){E=v;F=w;G=y;H=u/x}else{if(u==0.0){E=v;F=w;G=y;H=u;break}s=u/+xz(c[b+536>>2]|0,x,13792,14240,+h[w>>3],(a[b+319|0]|0)!=0|0);r=c[c[k>>2]>>2]|0;E=c[r+8>>2]|0;F=r;G=c[q>>2]|0;H=s}}while(0);r=b+536|0;B=c[r>>2]|0;s=+h[G+488>>3];t=z*z+ +h[G+104>>3]+-1.0;A=+h[E+176>>3];I=+h[E+152>>3];do{if(A!=0.0){J=G;K=I;L=E;M=F;N=I/A}else{if(I==0.0){J=G;K=I;L=E;M=F;N=I;break}O=I/+xz(B,A,14248,14240,+h[F>>3],(a[b+319|0]|0)!=0|0);C=c[c[k>>2]>>2]|0;D=c[C+8>>2]|0;J=c[q>>2]|0;K=+h[D+152>>3];L=D;M=C;N=O}}while(0);A=t*N;I=K*+h[L+616>>3];O=+h[J+96>>3]-H*H+1.0;do{if(I!=0.0){P=O/I}else{if(O==0.0){P=O;break}P=O/+xz(c[r>>2]|0,I,14280,14240,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);qh(g,B,-0.0,s,A,P,0,1.0);I=+h[g>>3];r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;O=+h[r+128>>3];t=O+I*+oB(+h[r+440>>3],-2)*.5;r=c[c[k>>2]>>2]|0;q=c[r+8>>2]|0;n=q;o=c[r+16>>2]|0;p=+h[q+184>>3]-t}}while(0);h[e>>3]=p;if((a[o+5|0]|0)!=0){Q=+h[n+104>>3]-(+h[n+16>>3]- +h[(c[b+416>>2]|0)+88>>3]);R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}p=+h[n+104>>3];if((a[o+2|0]|0)!=0){Q=p;R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}Q=p-(+h[n+184>>3]- +h[n+128>>3])*(+h[(c[b+416>>2]|0)+88>>3]- +h[n+16>>3])*9869232667160129.0e-21;R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}function vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+8|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+8|0]|0;k=b+4|0;l=bD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+96>>3],0.0,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=l;e=k;f=j;break}else{j=b+4|0;k=bD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+96>>3],0.0,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+8|0]|0;k=b+4|0;j=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+96>>3],0.0)|0;a[(c[b+352>>2]|0)+8|0]=j;e=k;f=g;break}else{g=b+4|0;k=fD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],0.0)|0;a[(c[b+352>>2]|0)+8|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=gD(+h[k+56>>3],+h[k+528>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+4|0]|0)!=0){m=0;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}function wj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+192>>3]- +h[(c[a+416>>2]|0)+632>>3];i=i;return}function xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[b+576>>3]*+h[b+552>>3]*.002;i=i;return}function yj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+1424>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+1400>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+1408>>3];h[a+8>>3]=+h[d+2768>>3];h[e+8>>3]=+h[d+2744>>3];h[f+8>>3]=+h[d+2752>>3];i=i;return}function zj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0,N=0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+96>>3]=+h[d>>3];h[l+192>>3]=+h[d+8>>3];vj(j);wj(j);xj(j);j=c[c[k>>2]>>2]|0;d=c[j+16>>2]|0;do{if((a[d+4|0]|0)==0){l=c[j+8>>2]|0;if((a[d+1|0]|0)==0){m=l;n=d;o=-+h[l+544>>3];break}else{m=l;n=d;o=+h[l+192>>3]- +h[l+120>>3];break}}else{l=b+416|0;p=c[l>>2]|0;q=+h[p+544>>3];r=c[j+8>>2]|0;s=+h[r+432>>3];do{if(q!=0.0){t=s;u=r;v=j;w=q;x=p;y=s/q}else{if(s==0.0){t=s;u=r;v=j;w=q;x=p;y=s;break}z=s/+xz(c[b+536>>2]|0,q,13792,14336,+h[j>>3],(a[b+319|0]|0)!=0|0);A=c[l>>2]|0;B=c[c[k>>2]>>2]|0;C=c[B+8>>2]|0;t=+h[C+432>>3];u=C;v=B;w=+h[A+544>>3];x=A;y=z}}while(0);do{if(w!=0.0){D=x;E=u;F=v;G=t/w}else{if(t==0.0){D=x;E=u;F=v;G=t;break}q=t/+xz(c[b+536>>2]|0,w,13792,14336,+h[v>>3],(a[b+319|0]|0)!=0|0);p=c[c[k>>2]>>2]|0;D=c[l>>2]|0;E=c[p+8>>2]|0;F=p;G=q}}while(0);p=b+536|0;r=c[p>>2]|0;q=-+h[E+544>>3];s=+h[D+488>>3];z=y*y+ +h[D+72>>3]+-1.0;H=+h[E+168>>3];I=+h[E+144>>3];do{if(H!=0.0){J=I/H;K=D;L=I;M=E;N=F}else{if(I==0.0){J=I;K=D;L=I;M=E;N=F;break}O=I/+xz(r,H,13816,14336,+h[F>>3],(a[b+319|0]|0)!=0|0);A=c[c[k>>2]>>2]|0;B=c[A+8>>2]|0;J=O;K=c[l>>2]|0;L=+h[B+144>>3];M=B;N=A}}while(0);H=z*J;I=L*+h[M+616>>3];O=+h[K+64>>3]-G*G+1.0;do{if(I!=0.0){P=O/I}else{if(O==0.0){P=O;break}P=O/+xz(c[p>>2]|0,I,13848,14336,+h[N>>3],(a[b+319|0]|0)!=0|0)}}while(0);qh(g,r,q,s,H,P,0,1.0);I=+h[g>>3];p=c[(c[c[k>>2]>>2]|0)+8>>2]|0;O=+h[p+120>>3];z=O+I*+oB(+h[p+432>>3],-2)*.5;p=c[c[k>>2]>>2]|0;l=c[p+8>>2]|0;m=l;n=c[p+16>>2]|0;o=+h[l+192>>3]-z}}while(0);h[e>>3]=o;if((a[n+4|0]|0)!=0){Q=+h[m+96>>3]-(+h[m+16>>3]- +h[(c[b+416>>2]|0)+56>>3]);R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}o=+h[m+96>>3];if((a[n+1|0]|0)==0){Q=o-(+h[m+192>>3]- +h[m+120>>3])*(+h[(c[b+416>>2]|0)+56>>3]- +h[m+16>>3])*9869232667160129.0e-21;R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}else{Q=o+ +h[m+544>>3];R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}}function Aj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+10608>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+10584>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+10592>>3];h[a+8>>3]=+h[d+10384>>3];h[e+8>>3]=+h[d+10360>>3];h[f+8>>3]=+h[d+10368>>3];i=i;return}function Bj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0.0,za=0,Aa=0,Ba=0,Ca=0.0,Da=0.0;f=i;i=i+112|0;g=f;j=f+16|0;l=f+32|0;m=f+48|0;n=f+64|0;o=f+80|0;p=f+96|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=+h[d>>3];F=b+4|0;G=c[(c[c[F>>2]>>2]|0)+8>>2]|0;h[G+752>>3]=E;h[G+736>>3]=+h[d+8>>3];d=b+314|0;do{if((a[d]|0)==0){H=a[(c[b+356>>2]|0)+10|0]|0}else{G=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(G){I=a[(c[b+356>>2]|0)+10|0]|0;J=bD(E,0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=J;H=I;break}else{I=bD(E,0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=I;H=I;break}}else{if(G){G=a[(c[b+356>>2]|0)+10|0]|0;I=fD(E,0.0)|0;a[(c[b+352>>2]|0)+10|0]=I;H=G;break}else{G=fD(E,0.0)|0;a[(c[b+352>>2]|0)+10|0]=G;H=G;break}}}}while(0);do{if(H<<24>>24==0){K=0.0}else{G=c[c[F>>2]>>2]|0;I=c[G+8>>2]|0;E=+h[I+688>>3];L=+h[I+752>>3];if(E!=0.0){K=L/E;break}if(L==0.0){K=L;break}K=L/+xz(c[b+536>>2]|0,E,13960,14344,+h[G>>3],(a[b+319|0]|0)!=0|0)}}while(0);H=c[(c[c[F>>2]>>2]|0)+8>>2]|0;h[e>>3]=+h[H+736>>3]-K;do{if((a[d]|0)==0){M=a[(c[b+356>>2]|0)+10|0]|0}else{G=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(G){I=a[(c[b+356>>2]|0)+10|0]|0;J=bD(+h[H+752>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=J;M=I;break}else{I=bD(+h[H+752>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=I;M=I;break}}else{if(G){G=a[(c[b+356>>2]|0)+10|0]|0;I=fD(+h[H+752>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=I;M=G;break}else{G=fD(+h[H+752>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=G;M=G;break}}}}while(0);H=b+416|0;K=+h[(c[H>>2]|0)+344>>3];d=K!=0.0;G=c[c[F>>2]>>2]|0;E=+h[(c[G+8>>2]|0)+760>>3];if(M<<24>>24==0){do{if(d){N=E/K}else{if(E==0.0){N=E;break}N=E/+xz(c[b+536>>2]|0,K,13912,14344,+h[G>>3],(a[b+319|0]|0)!=0|0)}}while(0);M=s;h[k>>3]=.25;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=s+8|0;h[k>>3]=.5;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];DA(x,3,0.0,s);s=r;h[k>>3]=60.0;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r+8|0;h[k>>3]=0.0;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];DA(y,3,100.0,r);r=c[b+536>>2]|0;s=m;M=x;c[s+0>>2]=c[M+0>>2];c[s+4>>2]=c[M+4>>2];c[s+8>>2]=c[M+8>>2];M=l;s=y;c[M+0>>2]=c[s+0>>2];c[M+4>>2]=c[s+4>>2];c[M+8>>2]=c[s+8>>2];gh(C,r,0.0,m,l);O=N*N*+h[C>>3]- +h[(c[(c[c[F>>2]>>2]|0)+8>>2]|0)+752>>3];P=q;Q=P;h[k>>3]=.25;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];R=q;S=R+8|0;T=S;h[k>>3]=.5;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];U=1;V=U;DA(z,3,0.0,q);W=p;X=W;h[k>>3]=60.0;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];Y=p;Z=Y+8|0;_=Z;h[k>>3]=0.0;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];$=1;aa=$;DA(A,3,100.0,p);ba=b;ca=ba+536|0;da=ca;ea=da;fa=c[da>>2]|0;ga=j;ha=j;ia=z;c[ha+0>>2]=c[ia+0>>2];c[ha+4>>2]=c[ia+4>>2];c[ha+8>>2]=c[ia+8>>2];ja=g;ka=g;la=A;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];gh(D,fa,0.0,j,g);ma=g;na=j;oa=c[F>>2]|0;pa=c[oa>>2]|0;qa=pa;ra=qa+8|0;sa=ra;ta=c[sa>>2]|0;ua=ta;va=ua+680|0;wa=va;xa=+h[wa>>3];ya=xa-O;za=e;Aa=za+8|0;Ba=Aa;h[Ba>>3]=ya;i=f;return}do{if(d){Ca=E/K}else{if(E==0.0){Ca=E;break}Ca=E/+xz(c[b+536>>2]|0,K,13912,14344,+h[G>>3],(a[b+319|0]|0)!=0|0)}}while(0);G=u;h[k>>3]=.25;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=u+8|0;h[k>>3]=.5;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];DA(v,3,0.0,u);u=t;h[k>>3]=60.0;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=t+8|0;h[k>>3]=0.0;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];DA(w,3,100.0,t);t=c[b+536>>2]|0;u=c[c[F>>2]>>2]|0;G=c[u+8>>2]|0;K=+h[G+736>>3];E=+h[G+760>>3];N=+h[(c[H>>2]|0)+344>>3];do{if(E!=0.0){Da=N/E}else{if(N==0.0){Da=N;break}Da=N/+xz(t,E,13928,14344,+h[u>>3],(a[b+319|0]|0)!=0|0)}}while(0);E=K*Da;u=o;H=v;c[u+0>>2]=c[H+0>>2];c[u+4>>2]=c[H+4>>2];c[u+8>>2]=c[H+8>>2];H=n;u=w;c[H+0>>2]=c[u+0>>2];c[H+4>>2]=c[u+4>>2];c[H+8>>2]=c[u+8>>2];gh(B,t,E,o,n);O=Ca*Ca*+h[B>>3];P=q;Q=P;h[k>>3]=.25;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];R=q;S=R+8|0;T=S;h[k>>3]=.5;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];U=1;V=U;DA(z,3,0.0,q);W=p;X=W;h[k>>3]=60.0;c[X>>2]=c[k>>2];c[X+4>>2]=c[k+4>>2];Y=p;Z=Y+8|0;_=Z;h[k>>3]=0.0;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];$=1;aa=$;DA(A,3,100.0,p);ba=b;ca=ba+536|0;da=ca;ea=da;fa=c[da>>2]|0;ga=j;ha=j;ia=z;c[ha+0>>2]=c[ia+0>>2];c[ha+4>>2]=c[ia+4>>2];c[ha+8>>2]=c[ia+8>>2];ja=g;ka=g;la=A;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];gh(D,fa,0.0,j,g);ma=g;na=j;oa=c[F>>2]|0;pa=c[oa>>2]|0;qa=pa;ra=qa+8|0;sa=ra;ta=c[sa>>2]|0;ua=ta;va=ua+680|0;wa=va;xa=+h[wa>>3];ya=xa-O;za=e;Aa=za+8|0;Ba=Aa;h[Ba>>3]=ya;i=f;return}function Cj(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+10944>>3];h[c[b+8>>2]>>3]=+h[d+10920>>3];h[c[b+12>>2]>>3]=+h[d+10928>>3];i=i;return}function Dj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0;f=i;g=+h[d>>3];d=b+4|0;j=c[c[d>>2]>>2]|0;k=c[j+8>>2]|0;h[k+776>>3]=g;l=+h[k+688>>3];do{if(l!=0.0){m=k;n=g/l}else{if(g==0.0){m=k;n=g;break}o=g/+xz(c[b+536>>2]|0,l,13960,14352,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[d>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[e>>3]=+h[m+800>>3]-n;i=f;return}function Ej(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=b+4|0;l=bD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;e=k;f=j;break}else{j=b+4|0;k=bD(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+88>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;k=b+4|0;j=fD(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=j;e=k;f=g;break}else{g=b+4|0;k=fD(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=gD(+h[k+24>>3],+h[k+528>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+3|0]|0)!=0){m=0;a[k]=m;i=d;return}if(!(f<<24>>24==0)){m=1;a[k]=m;i=d;return}m=b<<24>>24!=0|0;a[k]=m;i=d;return}



function Th(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0.0,Be=0.0,Ce=0.0,De=0.0,Ee=0.0,Fe=0.0,Ge=0.0,He=0.0,Ie=0.0,Je=0.0,Ke=0.0,Me=0.0,Ne=0.0,Oe=0.0,Pe=0.0,Qe=0.0,Re=0.0,Se=0.0,Te=0.0,Ue=0.0,Ve=0.0,We=0.0,Xe=0.0,Ye=0.0;f=i;i=i+80|0;g=f;j=f+24|0;k=f+48|0;l=f+72|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+16|0;c[ve>>2]=45;wA(we,1,ve);if(!(d>611.657)){ve=gA(gA(7368,eA(d,0,1,6)|0)|0,3856)|0;xe=gA(gA(ve,eA(611.657,0,1,6)|0)|0,3864)|0;ve=c[27736]|0;ye=k;ze=7432;c[ye+0>>2]=c[ze+0>>2];c[ye+4>>2]=c[ze+4>>2];c[ye+8>>2]=c[ze+8>>2];c[ye+12>>2]=c[ze+12>>2];c[ye+16>>2]=c[ze+16>>2];c[ye+20>>2]=c[ze+20>>2];Le[ve&63](b,k,xe,ue);}if(!(d<=1.0e8)){ue=gA(gA(7456,eA(d,0,1,6)|0)|0,7024)|0;xe=c[27736]|0;k=j;ve=7504;c[k+0>>2]=c[ve+0>>2];c[k+4>>2]=c[ve+4>>2];c[k+8>>2]=c[ve+8>>2];c[k+12>>2]=c[ve+12>>2];c[k+16>>2]=c[ve+16>>2];c[k+20>>2]=c[ve+20>>2];Le[xe&63](b,j,ue,te);}if(!(e>=273.15)){te=gA(gA(7528,eA(e,0,1,6)|0)|0,7128)|0;ue=c[27736]|0;j=g;xe=7576;c[j+0>>2]=c[xe+0>>2];c[j+4>>2]=c[xe+4>>2];c[j+8>>2]=c[xe+8>>2];c[j+12>>2]=c[xe+12>>2];c[j+16>>2]=c[xe+16>>2];c[j+20>>2]=c[xe+20>>2];Le[ue&63](b,g,te,se);}Ae=d/1653.0e4;Be=1386.0/e;Ce=7.1-Ae;De=Be+-1.222;c[re>>2]=1;h[(EA(we,1,re)|0)>>3]=De*De;c[qe>>2]=1;Ee=+h[(EA(we,1,qe)|0)>>3];c[pe>>2]=2;h[(EA(we,1,pe)|0)>>3]=Ee*Ee;c[oe>>2]=2;Ee=+h[(EA(we,1,oe)|0)>>3];c[ne>>2]=3;h[(EA(we,1,ne)|0)>>3]=Ee*Ee;c[me>>2]=3;Ee=De*+h[(EA(we,1,me)|0)>>3];c[le>>2]=4;h[(EA(we,1,le)|0)>>3]=Ee;c[ke>>2]=4;Ee=1.0/+h[(EA(we,1,ke)|0)>>3];c[je>>2]=5;h[(EA(we,1,je)|0)>>3]=Ee;c[ie>>2]=1;Ee=+h[(EA(we,1,ie)|0)>>3];c[he>>2]=2;Fe=Ee*+h[(EA(we,1,he)|0)>>3];c[ge>>2]=6;h[(EA(we,1,ge)|0)>>3]=Fe;c[fe>>2]=1;Fe=De*+h[(EA(we,1,fe)|0)>>3];c[ee>>2]=7;h[(EA(we,1,ee)|0)>>3]=Fe;c[de>>2]=7;Fe=1.0/+h[(EA(we,1,de)|0)>>3];c[ce>>2]=8;h[(EA(we,1,ce)|0)>>3]=Fe;c[be>>2]=1;Fe=+h[(EA(we,1,be)|0)>>3];c[ae>>2]=2;Ee=+h[(EA(we,1,ae)|0)>>3];c[$d>>2]=3;Ge=Fe*Ee*+h[(EA(we,1,$d)|0)>>3];c[_d>>2]=9;h[(EA(we,1,_d)|0)>>3]=Ge;c[Zd>>2]=2;Ge=1.0/+h[(EA(we,1,Zd)|0)>>3];c[Yd>>2]=10;h[(EA(we,1,Yd)|0)>>3]=Ge;c[Xd>>2]=2;Ge=De*+h[(EA(we,1,Xd)|0)>>3];c[Wd>>2]=11;h[(EA(we,1,Wd)|0)>>3]=Ge;c[Vd>>2]=11;Ge=1.0/+h[(EA(we,1,Vd)|0)>>3];c[Ud>>2]=12;h[(EA(we,1,Ud)|0)>>3]=Ge;c[Td>>2]=2;Ge=+h[(EA(we,1,Td)|0)>>3];c[Sd>>2]=3;Ee=Ge*+h[(EA(we,1,Sd)|0)>>3];c[Rd>>2]=13;h[(EA(we,1,Rd)|0)>>3]=Ee;c[Qd>>2]=3;Ee=1.0/+h[(EA(we,1,Qd)|0)>>3];c[Pd>>2]=14;h[(EA(we,1,Pd)|0)>>3]=Ee;c[Od>>2]=15;h[(EA(we,1,Od)|0)>>3]=Ce*Ce;c[Nd>>2]=15;Ee=Ce*+h[(EA(we,1,Nd)|0)>>3];c[Md>>2]=16;h[(EA(we,1,Md)|0)>>3]=Ee;c[Ld>>2]=15;Ee=+h[(EA(we,1,Ld)|0)>>3];c[Kd>>2]=17;h[(EA(we,1,Kd)|0)>>3]=Ee*Ee;c[Jd>>2]=17;Ee=+h[(EA(we,1,Jd)|0)>>3];c[Id>>2]=18;h[(EA(we,1,Id)|0)>>3]=Ee*Ee;c[Hd>>2]=17;Ee=+h[(EA(we,1,Hd)|0)>>3];c[Gd>>2]=18;Ge=Ee*Ce*+h[(EA(we,1,Gd)|0)>>3];c[Fd>>2]=19;h[(EA(we,1,Fd)|0)>>3]=Ge;c[Ed>>2]=15;Ge=+h[(EA(we,1,Ed)|0)>>3];c[Dd>>2]=17;Ee=Ge*+h[(EA(we,1,Dd)|0)>>3];c[Cd>>2]=20;h[(EA(we,1,Cd)|0)>>3]=Ee;c[Bd>>2]=3;Ee=+h[(EA(we,1,Bd)|0)>>3];c[Ad>>2]=21;h[(EA(we,1,Ad)|0)>>3]=Ee*Ee;c[zd>>2]=21;Ee=+h[(EA(we,1,zd)|0)>>3];c[yd>>2]=22;h[(EA(we,1,yd)|0)>>3]=Ee*Ee;c[xd>>2]=22;Ee=+h[(EA(we,1,xd)|0)>>3];c[wd>>2]=3;Ge=Ee*De*+h[(EA(we,1,wd)|0)>>3];c[vd>>2]=23;h[(EA(we,1,vd)|0)>>3]=Ge;c[ud>>2]=23;Ge=1.0/+h[(EA(we,1,ud)|0)>>3];c[td>>2]=24;h[(EA(we,1,td)|0)>>3]=Ge;c[sd>>2]=22;Ge=+h[(EA(we,1,sd)|0)>>3];c[rd>>2]=3;Ee=Ge*+h[(EA(we,1,rd)|0)>>3];c[qd>>2]=25;h[(EA(we,1,qd)|0)>>3]=Ee;c[pd>>2]=25;Ee=1.0/+h[(EA(we,1,pd)|0)>>3];c[od>>2]=26;h[(EA(we,1,od)|0)>>3]=Ee;c[nd>>2]=1;Ee=+h[(EA(we,1,nd)|0)>>3];c[md>>2]=2;Ge=+h[(EA(we,1,md)|0)>>3];c[ld>>2]=22;Fe=Ee*Ge*De*+h[(EA(we,1,ld)|0)>>3];c[kd>>2]=27;h[(EA(we,1,kd)|0)>>3]=Fe;c[jd>>2]=27;Fe=1.0/+h[(EA(we,1,jd)|0)>>3];c[id>>2]=28;h[(EA(we,1,id)|0)>>3]=Fe;c[hd>>2]=1;Fe=+h[(EA(we,1,hd)|0)>>3];c[gd>>2]=2;Ge=+h[(EA(we,1,gd)|0)>>3];c[fd>>2]=22;Ee=Fe*Ge*+h[(EA(we,1,fd)|0)>>3];c[ed>>2]=29;h[(EA(we,1,ed)|0)>>3]=Ee;c[dd>>2]=29;Ee=1.0/+h[(EA(we,1,dd)|0)>>3];c[cd>>2]=30;h[(EA(we,1,cd)|0)>>3]=Ee;c[bd>>2]=1;Ee=+h[(EA(we,1,bd)|0)>>3];c[ad>>2]=2;Ge=+h[(EA(we,1,ad)|0)>>3];c[$c>>2]=21;Fe=+h[(EA(we,1,$c)|0)>>3];c[_c>>2]=3;He=Ee*Ge*Fe*De*+h[(EA(we,1,_c)|0)>>3];c[Zc>>2]=31;h[(EA(we,1,Zc)|0)>>3]=He;c[Yc>>2]=31;He=1.0/+h[(EA(we,1,Yc)|0)>>3];c[Xc>>2]=32;h[(EA(we,1,Xc)|0)>>3]=He;c[Wc>>2]=2;He=+h[(EA(we,1,Wc)|0)>>3];c[Vc>>2]=21;Fe=+h[(EA(we,1,Vc)|0)>>3];c[Uc>>2]=3;Ge=He*Fe*De*+h[(EA(we,1,Uc)|0)>>3];c[Tc>>2]=33;h[(EA(we,1,Tc)|0)>>3]=Ge;c[Sc>>2]=33;Ge=1.0/+h[(EA(we,1,Sc)|0)>>3];c[Rc>>2]=34;h[(EA(we,1,Rc)|0)>>3]=Ge;c[Qc>>2]=1;Ge=+h[(EA(we,1,Qc)|0)>>3];c[Pc>>2]=3;Fe=Ge*De*+h[(EA(we,1,Pc)|0)>>3];c[Oc>>2]=35;h[(EA(we,1,Oc)|0)>>3]=Fe;c[Nc>>2]=35;Fe=1.0/+h[(EA(we,1,Nc)|0)>>3];c[Mc>>2]=36;h[(EA(we,1,Mc)|0)>>3]=Fe;c[Lc>>2]=1;Fe=+h[(EA(we,1,Lc)|0)>>3];c[Kc>>2]=3;Ge=Fe*+h[(EA(we,1,Kc)|0)>>3];c[Jc>>2]=37;h[(EA(we,1,Jc)|0)>>3]=Ge;c[Ic>>2]=37;Ge=1.0/+h[(EA(we,1,Ic)|0)>>3];c[Hc>>2]=38;h[(EA(we,1,Hc)|0)>>3]=Ge;c[Gc>>2]=6;Ge=1.0/+h[(EA(we,1,Gc)|0)>>3];c[Fc>>2]=39;h[(EA(we,1,Fc)|0)>>3]=Ge;c[Ec>>2]=1;Ge=+h[(EA(we,1,Ec)|0)>>3];c[Dc>>2]=22;Fe=+h[(EA(we,1,Dc)|0)>>3];c[Cc>>2]=3;He=Ge*Fe*+h[(EA(we,1,Cc)|0)>>3];c[Bc>>2]=40;h[(EA(we,1,Bc)|0)>>3]=He;c[Ac>>2]=40;He=1.0/+h[(EA(we,1,Ac)|0)>>3];c[zc>>2]=41;h[(EA(we,1,zc)|0)>>3]=He;c[yc>>2]=22;He=1.0/+h[(EA(we,1,yc)|0)>>3];c[xc>>2]=42;h[(EA(we,1,xc)|0)>>3]=He;c[wc>>2]=1;He=+h[(EA(we,1,wc)|0)>>3];c[vc>>2]=2;Fe=+h[(EA(we,1,vc)|0)>>3];c[uc>>2]=21;Ge=+h[(EA(we,1,uc)|0)>>3];c[tc>>2]=3;Ee=He*Fe*Ge*+h[(EA(we,1,tc)|0)>>3];c[sc>>2]=43;h[(EA(we,1,sc)|0)>>3]=Ee;c[rc>>2]=43;Ee=1.0/+h[(EA(we,1,rc)|0)>>3];c[qc>>2]=44;h[(EA(we,1,qc)|0)>>3]=Ee;c[pc>>2]=13;Ee=1.0/+h[(EA(we,1,pc)|0)>>3];c[oc>>2]=45;h[(EA(we,1,oc)|0)>>3]=Ee;c[nc>>2]=10;Ee=+h[(EA(we,1,nc)|0)>>3];c[mc>>2]=2;Ge=+h[(EA(we,1,mc)|0)>>3];c[lc>>2]=6;Fe=Ee*(Ge*(+h[(EA(we,1,lc)|0)>>3]*-8.5205128120103e-10+-28270797985312.0e-19)+-31679644845054.0e-18);c[kc>>2]=12;Ge=+h[(EA(we,1,kc)|0)>>3];c[jc>>2]=13;Ee=+h[(EA(we,1,jc)|0)>>3]*-1.4341729937924e-13+-6.5171222895601e-7;c[ic>>2]=7;He=Ge*(Ee*+h[(EA(we,1,ic)|0)>>3]+-22425281908.0e-16);c[hc>>2]=14;Ee=+h[(EA(we,1,hc)|0)>>3]*-4.0516996860117e-7;c[gc>>2]=16;Ge=+h[(EA(we,1,gc)|0)>>3];c[fc>>2]=11;Ie=+h[(EA(we,1,fc)|0)>>3]*-1.7424871230634e-10+-1.2734301741641e-9;c[ec>>2]=36;Je=Ie*+h[(EA(we,1,ec)|0)>>3];c[dc>>2]=19;Ie=+h[(EA(we,1,dc)|0)>>3];c[cc>>2]=34;Ke=+h[(EA(we,1,cc)|0)>>3]*-6.8762131295531e-19;c[bc>>2]=15;Me=+h[(EA(we,1,bc)|0)>>3];c[ac>>2]=32;Ne=+h[(EA(we,1,ac)|0)>>3]*1.4478307828521e-20;c[$b>>2]=20;Oe=+h[(EA(we,1,$b)|0)>>3];c[_b>>2]=30;Pe=+h[(EA(we,1,_b)|0)>>3]*2.6335781662795e-23;c[Zb>>2]=28;Qe=+h[(EA(we,1,Zb)|0)>>3]*-1.1947622640071e-23;c[Yb>>2]=26;Re=+h[(EA(we,1,Yb)|0)>>3]*1.8228094581404e-24;c[Xb>>2]=24;Se=Ce*(Fe+Ce*(He+Ce*(Ee+Ge*(Je+Ie*(Ke+Me*(Ne+Oe*(Pe+Ce*(Qe+Ce*(Re+Ce*+h[(EA(we,1,Xb)|0)>>3]*-9.3537087292458e-26)))))))));c[Wb>>2]=8;Re=+h[(EA(we,1,Wb)|0)>>3];c[Vb>>2]=7;Qe=+h[(EA(we,1,Vb)|0)>>3];c[Ub>>2]=1;Pe=+h[(EA(we,1,Ub)|0)>>3];c[Tb>>2]=9;Oe=Ce*(Re*(Qe*(De*(Pe*(+h[(EA(we,1,Tb)|0)>>3]*-7.2694996297594e-16+-44141845330846.0e-19)+47661393906987.0e-18)+-.00030001780793026)+-.00047184321073267)+Se);c[Sb>>2]=5;Se=+h[(EA(we,1,Sb)|0)>>3];c[Rb>>2]=1;Pe=+h[(EA(we,1,Rb)|0)>>3];c[Qb>>2]=6;Qe=+h[(EA(we,1,Qb)|0)>>3];c[Pb>>2]=1;Re=Ce*(Oe+Se*(Pe*(Qe*(De*(De*(+h[(EA(we,1,Pb)|0)>>3]*-5283835796993.0e-17+-.021841717175414)+-.032529748770505)+-.018990068218419)+-.00060706301565874)+.00028319080123804));c[Ob>>2]=1;Qe=(De*(De*(De*(De*(De*(De*(De*.00081214629983568+-.016616417199501)+.15772038513228)+-.95791963387872)+3.3855169168385)+-3.756360367204)+-.84548187169114)+.14632971213167)/+h[(EA(we,1,Ob)|0)>>3]+Re;c[Nb>>2]=10;Re=+h[(EA(we,1,Nb)|0)>>3];c[Mb>>2]=2;Pe=+h[(EA(we,1,Mb)|0)>>3];c[Lb>>2]=6;Se=Re*(Pe*(+h[(EA(we,1,Lb)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18);c[Kb>>2]=12;Pe=+h[(EA(we,1,Kb)|0)>>3];c[Jb>>2]=13;Re=+h[(EA(we,1,Jb)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[Ib>>2]=7;Oe=Pe*(Re*+h[(EA(we,1,Ib)|0)>>3]+89701127632.0e-16);c[Hb>>2]=14;Re=+h[(EA(we,1,Hb)|0)>>3]*202584984300585.0e-20;c[Gb>>2]=16;Pe=+h[(EA(we,1,Gb)|0)>>3];c[Fb>>2]=11;Ne=+h[(EA(we,1,Fb)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[Eb>>2]=36;Me=Ne*+h[(EA(we,1,Eb)|0)>>3];c[Db>>2]=19;Ne=+h[(EA(we,1,Db)|0)>>3];c[Cb>>2]=34;Ke=+h[(EA(we,1,Cb)|0)>>3]*1.44400475720615e-17;c[Bb>>2]=15;Ie=+h[(EA(we,1,Bb)|0)>>3];c[Ab>>2]=32;Je=+h[(EA(we,1,Ab)|0)>>3]*-3.3300108005598e-19;c[zb>>2]=20;Ge=+h[(EA(we,1,zb)|0)>>3];c[yb>>2]=30;Ee=+h[(EA(we,1,yb)|0)>>3]*-7.6373766822106e-22;c[xb>>2]=28;He=+h[(EA(we,1,xb)|0)>>3]*3.5842867920213e-22;c[wb>>2]=26;Fe=+h[(EA(we,1,wb)|0)>>3]*-5.6507093202352e-23;c[vb>>2]=24;Te=Ce*(Se+Ce*(Oe+Ce*(Re+Pe*(Me+Ne*(Ke+Ie*(Je+Ge*(Ee+Ce*(He+Ce*(Fe+Ce*+h[(EA(we,1,vb)|0)>>3]*2.99318679335866e-24)))))))));c[ub>>2]=8;Fe=+h[(EA(we,1,ub)|0)>>3];c[tb>>2]=7;He=+h[(EA(we,1,tb)|0)>>3];c[sb>>2]=1;Ee=+h[(EA(we,1,sb)|0)>>3];c[rb>>2]=9;Ge=Ce*(Fe*(He*(De*(Ee*(+h[(EA(we,1,rb)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534)+Te);c[qb>>2]=5;Te=+h[(EA(we,1,qb)|0)>>3];c[pb>>2]=1;Ee=+h[(EA(we,1,pb)|0)>>3];c[ob>>2]=6;He=+h[(EA(we,1,ob)|0)>>3];c[nb>>2]=1;Fe=Ge+Te*(Ee*(He*(De*(De*(+h[(EA(we,1,nb)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804);c[mb>>2]=10;He=+h[(EA(we,1,mb)|0)>>3];c[lb>>2]=2;Ee=+h[(EA(we,1,lb)|0)>>3];c[kb>>2]=6;Te=He*(Ee*(+h[(EA(we,1,kb)|0)>>3]*-5.1123076872062e-9+-169624787911872.0e-19)+-.000190077869070324);c[jb>>2]=12;Ee=+h[(EA(we,1,jb)|0)>>3];c[ib>>2]=13;He=+h[(EA(we,1,ib)|0)>>3]*-1.72100759255088e-12+-78205467474721.0e-19;c[hb>>2]=7;Ge=Ee*(He*+h[(EA(we,1,hb)|0)>>3]+-269103382896.0e-16);c[gb>>2]=14;He=+h[(EA(we,1,gb)|0)>>3]*-81033993720234.0e-19;c[fb>>2]=16;Ee=+h[(EA(we,1,fb)|0)>>3];c[eb>>2]=11;Je=+h[(EA(we,1,eb)|0)>>3]*-9.757927889155e-9+-7.131208975319e-8;c[db>>2]=36;Ie=Je*+h[(EA(we,1,db)|0)>>3];c[cb>>2]=19;Je=+h[(EA(we,1,cb)|0)>>3];c[bb>>2]=34;Ke=+h[(EA(we,1,bb)|0)>>3]*-2.8880095144123e-16;c[ab>>2]=15;Ne=+h[(EA(we,1,ab)|0)>>3];c[$a>>2]=32;Me=+h[(EA(we,1,$a)|0)>>3]*7.3260237612316e-18;c[_a>>2]=20;Pe=+h[(EA(we,1,_a)|0)>>3];c[Za>>2]=30;Re=+h[(EA(we,1,Za)|0)>>3]*2.13846547101895e-20;c[Ya>>2]=28;Oe=+h[(EA(we,1,Ya)|0)>>3]*-1.03944316968618e-20;c[Xa>>2]=26;Se=+h[(EA(we,1,Xa)|0)>>3]*1.69521279607057e-21;c[Wa>>2]=24;Ue=Ce*(Te+Ce*(Ge+Ce*(He+Ee*(Ie+Je*(Ke+Ne*(Me+Pe*(Re+Ce*(Oe+Ce*(Se+Ce*+h[(EA(we,1,Wa)|0)>>3]*-9.2788790594118e-23)))))))));c[Va>>2]=8;Se=+h[(EA(we,1,Va)|0)>>3];c[Ua>>2]=7;Oe=+h[(EA(we,1,Ua)|0)>>3];c[Ta>>2]=1;Re=+h[(EA(we,1,Ta)|0)>>3];c[Sa>>2]=9;Pe=Se*(Oe*(De*(Re*(+h[(EA(we,1,Sa)|0)>>3]*-1.45389992595188e-15+-88283690661692.0e-19)+95322787813974.0e-18)+-.00060003561586052)+-.00094368642146534)+Ue;c[Ra>>2]=38;Ue=+h[(EA(we,1,Ra)|0)>>3];c[Qa>>2]=1;Re=+h[(EA(we,1,Qa)|0)>>3];c[Pa>>2]=1;Oe=+h[(EA(we,1,Pa)|0)>>3]*-.00015851507390979+-.021841717175414;c[Oa>>2]=1;Se=Oe*+h[(EA(we,1,Oa)|0)>>3]+.018990068218419;c[Na>>2]=6;Oe=Ue*(Re*(Se*+h[(EA(we,1,Na)|0)>>3]+.0042494411096112)+-.00254871721114236);c[Ma>>2]=10;Se=+h[(EA(we,1,Ma)|0)>>3];c[La>>2]=2;Re=+h[(EA(we,1,La)|0)>>3];c[Ka>>2]=1;Ue=+h[(EA(we,1,Ka)|0)>>3];c[Ja>>2]=9;Me=Se*(Re*(Ue*(+h[(EA(we,1,Ja)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801);c[Ia>>2]=12;Ue=+h[(EA(we,1,Ia)|0)>>3];c[Ha>>2]=37;Re=Ue*(+h[(EA(we,1,Ha)|0)>>3]*-5.1123076872062e-9+.000126718579380216);c[Ga>>2]=39;Ue=+h[(EA(we,1,Ga)|0)>>3];c[Fa>>2]=13;Se=+h[(EA(we,1,Fa)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20;c[Ea>>2]=7;Ne=Ue*(Se*+h[(EA(we,1,Ea)|0)>>3]+11212640954.0e-15);c[Da>>2]=5;Se=+h[(EA(we,1,Da)|0)>>3]*32413597488094.0e-19;c[Ca>>2]=16;Ue=+h[(EA(we,1,Ca)|0)>>3];c[Ba>>2]=11;Ke=+h[(EA(we,1,Ba)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[Aa>>2]=45;Je=Ke*+h[(EA(we,1,Aa)|0)>>3];c[za>>2]=19;Ke=+h[(EA(we,1,za)|0)>>3];c[ya>>2]=44;Ie=+h[(EA(we,1,ya)|0)>>3]*1.9941018075704e-17;c[xa>>2]=15;Ee=+h[(EA(we,1,xa)|0)>>3];c[wa>>2]=42;He=+h[(EA(we,1,wa)|0)>>3]*-4.4882754268415e-19;c[va>>2]=20;Ge=+h[(EA(we,1,va)|0)>>3];c[ua>>2]=28;Te=+h[(EA(we,1,ua)|0)>>3]*-1.00075970318621e-21;c[ta>>2]=26;Ve=+h[(EA(we,1,ta)|0)>>3]*4.6595728296277e-22;c[sa>>2]=24;We=+h[(EA(we,1,sa)|0)>>3]*-7.2912378325616e-23;c[ra>>2]=41;Xe=Ce*(Oe+Ce*(Me+Ce*(Re+Ce*(Ne+Ce*(Se+Ue*(Je+Ke*(Ie+Ee*(He+Ge*(Te+Ce*(Ve+Ce*(We+Ce*+h[(EA(we,1,ra)|0)>>3]*3.8350205789908e-24)))))))))));c[qa>>2]=8;We=+h[(EA(we,1,qa)|0)>>3];c[pa>>2]=1;Ve=We*(De*((De*(De*(De*(De*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(EA(we,1,pa)|0)>>3]+.84548187169114)+-.29265942426334)+Xe;c[oa>>2]=36;Xe=+h[(EA(we,1,oa)|0)>>3];c[na>>2]=1;We=+h[(EA(we,1,na)|0)>>3];c[ma>>2]=2;Te=+h[(EA(we,1,ma)|0)>>3]*-.00031703014781958+-.037980136436838;c[la>>2]=6;Ge=Xe*(We*(Te*+h[(EA(we,1,la)|0)>>3]+-.033995528876889)+.0254871721114236);c[ka>>2]=12;Te=+h[(EA(we,1,ka)|0)>>3];c[ja>>2]=6;We=+h[(EA(we,1,ja)|0)>>3];c[ia>>2]=9;Xe=Te*(We*(+h[(EA(we,1,ia)|0)>>3]*-1.97730389929456e-13+-264851071985076.0e-19)+-.005662118528792);c[ha>>2]=37;We=+h[(EA(we,1,ha)|0)>>3]*-2.55615384360309e-8+-.00063359289690108;c[ga>>2]=39;Te=We*+h[(EA(we,1,ga)|0)>>3];c[fa>>2]=38;We=+h[(EA(we,1,fa)|0)>>3]*-291722377392842.0e-19;c[ea>>2]=16;He=+h[(EA(we,1,ea)|0)>>3];c[da>>2]=19;Ee=+h[(EA(we,1,da)|0)>>3];c[ca>>2]=32;Ie=+h[(EA(we,1,ca)|0)>>3]*-5.9823054227112e-16;c[ba>>2]=15;Ke=+h[(EA(we,1,ba)|0)>>3];c[aa>>2]=20;Je=+h[(EA(we,1,aa)|0)>>3];c[$>>2]=26;Ue=+h[(EA(we,1,$)|0)>>3]*3.9029628424262e-20;c[_>>2]=24;Se=+h[(EA(we,1,_)|0)>>3]*-1.86382913185108e-20;c[Z>>2]=41;Ne=+h[(EA(we,1,Z)|0)>>3]*2.98940751135026e-21;c[Y>>2]=1;Re=+h[(EA(we,1,Y)|0)>>3];c[X>>2]=22;Me=Re*+h[(EA(we,1,X)|0)>>3];c[W>>2]=3;Re=Je*(Ue+Ce*(Se+Ce*(Ne+Ce/(De*Me*+h[(EA(we,1,W)|0)>>3])*-1.61070864317613e-22)));c[V>>2]=22;Me=Ee*(Ie+Ke*(1.43624813658928e-17/(De*+h[(EA(we,1,V)|0)>>3])+Re));c[U>>2]=11;Re=+h[(EA(we,1,U)|0)>>3]*-7.3184459168663e-9+-1.68092782989661e-7;c[T>>2]=2;Ke=+h[(EA(we,1,T)|0)>>3];c[S>>2]=3;Ie=Ce*(We+He*(Re/(De*Ke*+h[(EA(we,1,S)|0)>>3])+Me));c[R>>2]=13;Me=+h[(EA(we,1,R)|0)>>3]*-1.29075569441316e-11+-39102733737361.0e-19;c[Q>>2]=7;Ke=Me*+h[(EA(we,1,Q)|0)>>3]+-67275845724.0e-15;c[P>>2]=1;Me=+h[(EA(we,1,P)|0)>>3];c[O>>2]=2;Re=Ce*(Ge+Ce*(Xe+Ce*(Te+Ce*(Ie+Ke/(De*Me*+h[(EA(we,1,O)|0)>>3])))));c[N>>2]=10;Me=+h[(EA(we,1,N)|0)>>3];c[M>>2]=7;Ke=Re+Me*(De*((De*(De*(De*.0162429259967136+-.199397006394012)+.94632231079368)+-1.91583926775744)*+h[(EA(we,1,M)|0)>>3]+-1.69096374338228)+.87797827279002);c[L>>2]=38;De=+h[(EA(we,1,L)|0)>>3];c[K>>2]=1;Me=+h[(EA(we,1,K)|0)>>3];c[J>>2]=1;Re=+h[(EA(we,1,J)|0)>>3]*.00015851507390979+.021841717175414;c[I>>2]=1;Ie=Re*+h[(EA(we,1,I)|0)>>3]+-.018990068218419;c[H>>2]=6;Re=De*(Me*(Ie*+h[(EA(we,1,H)|0)>>3]+-.0042494411096112)+.00254871721114236);c[G>>2]=10;Ie=+h[(EA(we,1,G)|0)>>3];c[F>>2]=2;Me=+h[(EA(we,1,F)|0)>>3];c[E>>2]=1;De=+h[(EA(we,1,E)|0)>>3];c[D>>2]=9;Te=Ie*(Me*(De*(+h[(EA(we,1,D)|0)>>3]*2.4716298741182e-14+264851071985076.0e-19)+-95322787813974.0e-18)+-.00283105926439602);c[C>>2]=12;De=+h[(EA(we,1,C)|0)>>3];c[B>>2]=37;Me=De*(+h[(EA(we,1,B)|0)>>3]*1.53369230616185e-8+-.00038015573814065);c[A>>2]=39;De=+h[(EA(we,1,A)|0)>>3];c[z>>2]=13;Ie=+h[(EA(we,1,z)|0)>>3]*5.7366919751696e-12+-52136978316481.0e-19;c[y>>2]=7;Xe=De*(Ie*+h[(EA(we,1,y)|0)>>3]+-44850563816.0e-15);c[x>>2]=5;Ie=+h[(EA(we,1,x)|0)>>3]*-162067987440468.0e-19;c[w>>2]=16;De=+h[(EA(we,1,w)|0)>>3];c[v>>2]=11;Ge=+h[(EA(we,1,v)|0)>>3]*-8.3639381907043e-9+-1.12061855326441e-7;c[u>>2]=45;He=Ge*+h[(EA(we,1,u)|0)>>3];c[t>>2]=19;Ge=+h[(EA(we,1,t)|0)>>3];c[s>>2]=44;We=+h[(EA(we,1,s)|0)>>3]*-4.1876137958978e-16;c[r>>2]=15;Ee=+h[(EA(we,1,r)|0)>>3];c[q>>2]=42;Ne=+h[(EA(we,1,q)|0)>>3]*1.03230334817355e-17;c[p>>2]=20;Se=+h[(EA(we,1,p)|0)>>3];c[o>>2]=28;Ue=+h[(EA(we,1,o)|0)>>3]*2.90220313924001e-20;c[n>>2]=26;Je=+h[(EA(we,1,n)|0)>>3]*-1.39787184888831e-20;c[m>>2]=24;Oe=+h[(EA(we,1,m)|0)>>3]*2.2602837280941e-21;c[l>>2]=41;Ye=Re+Ce*(Te+Ce*(Me+Ce*(Xe+Ce*(Ie+De*(He+Ge*(We+Ee*(Ne+Se*(Ue+Ce*(Je+Ce*(Oe+Ce*+h[(EA(we,1,l)|0)>>3]*-1.22720658527705e-22))))))))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=Ae;h[a+32>>3]=Be;h[a+40>>3]=Qe;h[a+48>>3]=Fe;h[a+56>>3]=Pe;h[a+64>>3]=Ve;h[a+72>>3]=Ke;h[a+80>>3]=Ye;i=f;return}function Uh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=11;wA(ia,1,ha);if(!(d>0.0)){ha=gA(gA(7600,eA(d,0,1,6)|0)|0,6936)|0;ja=c[27736]|0;ka=m;la=7664;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];Le[ja&63](b,m,ha,ga);}if(!(d<=1.0e7)){ga=gA(gA(7688,eA(d,0,1,6)|0)|0,7736)|0;ha=c[27736]|0;m=l;ja=7776;c[m+0>>2]=c[ja+0>>2];c[m+4>>2]=c[ja+4>>2];c[m+8>>2]=c[ja+8>>2];c[m+12>>2]=c[ja+12>>2];c[m+16>>2]=c[ja+16>>2];c[m+20>>2]=c[ja+20>>2];Le[ha&63](b,l,ga,fa);}if(!(e<=2273.15)){fa=gA(gA(7800,eA(e,0,1,6)|0)|0,7848)|0;ga=c[27736]|0;l=j;ha=7904;c[l+0>>2]=c[ha+0>>2];c[l+4>>2]=c[ha+4>>2];c[l+8>>2]=c[ha+8>>2];c[l+12>>2]=c[ha+12>>2];c[l+16>>2]=c[ha+16>>2];c[l+20>>2]=c[ha+20>>2];Le[ga&63](b,j,fa,ea);}ma=d/1.0e6;na=1.0e3/e;c[ca>>2]=1;h[(EA(ia,1,ca)|0)>>3]=na*na;c[ba>>2]=1;oa=+h[(EA(ia,1,ba)|0)>>3]*-.004594282089991;c[aa>>2]=2;h[(EA(ia,1,aa)|0)>>3]=oa;c[$>>2]=2;oa=+h[(EA(ia,1,$)|0)>>3]+.0021774678714571;c[_>>2]=3;h[(EA(ia,1,_)|0)>>3]=oa;c[Z>>2]=3;oa=na*+h[(EA(ia,1,Z)|0)>>3];c[Y>>2]=4;h[(EA(ia,1,Y)|0)>>3]=oa;c[X>>2]=1;oa=na*+h[(EA(ia,1,X)|0)>>3];c[W>>2]=5;h[(EA(ia,1,W)|0)>>3]=oa;c[V>>2]=1;oa=+h[(EA(ia,1,V)|0)>>3];c[U>>2]=6;h[(EA(ia,1,U)|0)>>3]=oa*oa;c[T>>2]=6;oa=+h[(EA(ia,1,T)|0)>>3];c[S>>2]=7;h[(EA(ia,1,S)|0)>>3]=oa*oa;c[R>>2]=7;oa=na*+h[(EA(ia,1,R)|0)>>3];c[Q>>2]=8;h[(EA(ia,1,Q)|0)>>3]=oa;c[P>>2]=8;oa=+h[(EA(ia,1,P)|0)>>3]*-79449656719138.0e-19;c[O>>2]=9;h[(EA(ia,1,O)|0)>>3]=oa;c[N>>2]=10;h[(EA(ia,1,N)|0)>>3]=ma*ma;c[M>>2]=1;oa=+h[(EA(ia,1,M)|0)>>3]*-.013782846269973;c[L>>2]=11;h[(EA(ia,1,L)|0)>>3]=oa;if(!(ma>0.0)){L=c[27736]|0;M=K;h[k>>3]=ma;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=L;L=g;N=7928;c[L+0>>2]=c[N+0>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];c[L+12>>2]=c[N+12>>2];c[L+16>>2]=c[N+16>>2];c[L+20>>2]=c[N+20>>2];Le[M&63](b,g,7312,K);}c[J>>2]=4;oa=+h[(EA(ia,1,J)|0)>>3];c[I>>2]=8;pa=+h[(EA(ia,1,I)|0)>>3]*-39724828359569.0e-19;c[H>>2]=5;qa=ma*(oa+ma*(pa+ma*+h[(EA(ia,1,H)|0)>>3]*1.2919228289784e-7)+-.00012563183589592);pa=na*(na*(na*(na*(na*-.32961626538917+6.8540841634434)+ +da(+ma)+-13.179983674201)+-3.1161318213925)+.36901534980333)+-.024805148933466;c[G>>2]=5;oa=pa/+h[(EA(ia,1,G)|0)>>3]+qa;c[F>>2]=4;qa=+h[(EA(ia,1,F)|0)>>3];c[E>>2]=9;pa=+h[(EA(ia,1,E)|0)>>3];c[D>>2]=5;ra=(ma*(qa+ma*(pa+ma*+h[(EA(ia,1,D)|0)>>3]*3.8757684869352e-7)+-.00012563183589592)+1.0)/ma;c[C>>2]=10;pa=+h[(EA(ia,1,C)|0)>>3];c[B>>2]=9;qa=+h[(EA(ia,1,B)|0)>>3];c[A>>2]=5;sa=pa*(qa+ma*+h[(EA(ia,1,A)|0)>>3]*7.7515369738704e-7)+-1.0;c[z>>2]=10;qa=sa/+h[(EA(ia,1,z)|0)>>3];c[y>>2]=11;sa=+h[(EA(ia,1,y)|0)>>3];c[x>>2]=7;pa=+h[(EA(ia,1,x)|0)>>3]*-35752345523612.0e-18;c[w>>2]=1;ta=ma*(sa+ma*(pa+ma*+h[(EA(ia,1,w)|0)>>3]*3.8757684869352e-7)+.0021774678714571);c[v>>2]=1;pa=na*(na*((na*-.65923253077834+6.8540841634434)*+h[(EA(ia,1,v)|0)>>3]+3.1161318213925)+-.73803069960666)+.074415446800398;c[u>>2]=6;sa=pa/+h[(EA(ia,1,u)|0)>>3]+ta;c[t>>2]=5;ta=na*(na*(+h[(EA(ia,1,t)|0)>>3]*-.65923253077834+-6.232263642785)+2.21409209881998)+-.297661787201592;c[s>>2]=6;pa=ta/(na*+h[(EA(ia,1,s)|0)>>3]);c[r>>2]=1;ta=+h[(EA(ia,1,r)|0)>>3];c[q>>2]=6;ua=pa+ma*(na*-.027565692539946+ma*(ma*na*7.7515369738704e-7+ta*na*+h[(EA(ia,1,q)|0)>>3]*-.000286018764188897));c[p>>2]=11;ta=+h[(EA(ia,1,p)|0)>>3];c[o>>2]=7;pa=+h[(EA(ia,1,o)|0)>>3]*-71504691047224.0e-18;c[n>>2]=1;va=ta+ma*(pa+ma*+h[(EA(ia,1,n)|0)>>3]*116273054608056.0e-20)+.0021774678714571;h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=ma;h[a+32>>3]=na;h[a+40>>3]=oa;h[a+48>>3]=ra;h[a+56>>3]=qa;h[a+64>>3]=sa;h[a+72>>3]=ua;h[a+80>>3]=va;i=f;return}function Vh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0.0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=4;wA(f,1,e);g=d/1.0e6;d=g*g;h[a>>3]=(g*3.74696550136983+(d*-.0219921901054187+g*d*87513168600995.0e-18)+2014.64004206875)*1.0e3;i=b;return}function Wh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;c[v>>2]=3;wA(w,1,v);if(!(d>611.657)){v=gA(gA(7952,eA(d,0,1,6)|0)|0,3856)|0;x=gA(gA(v,eA(611.657,0,1,6)|0)|0,3864)|0;v=c[27736]|0;y=g;z=8016;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Le[v&63](b,g,x,u);}A=d/1.0e6;d=e/25.0e5+1.0;c[t>>2]=1;h[(EA(w,1,t)|0)>>3]=d*d;c[s>>2]=1;e=+h[(EA(w,1,s)|0)>>3];c[r>>2]=2;h[(EA(w,1,r)|0)>>3]=e*e;c[q>>2]=2;e=+h[(EA(w,1,q)|0)>>3];c[p>>2]=3;h[(EA(w,1,p)|0)>>3]=e*e;c[o>>2]=1;e=+h[(EA(w,1,o)|0)>>3];c[n>>2]=2;B=+h[(EA(w,1,n)|0)>>3];c[m>>2]=2;C=+h[(EA(w,1,m)|0)>>3];c[l>>2]=3;D=+h[(EA(w,1,l)|0)>>3];c[k>>2]=1;E=+h[(EA(w,1,k)|0)>>3];c[j>>2]=3;h[a>>3]=A*-13.391744872602+d*(A*43.211039183559+d*(A*-54.010067170506+d*(A*30.535892203916+d*(A*-6.5964749423638+e*(B*(A*(A*(A*6.6456186191635e-8+-25858641282073.0e-18)+.0093965400878363)+C*D*(E*(A*(A*(A*(A*(A*(A*-1.5020185953503e-17+5.8265442020601e-15)+-9.3477771213947e-13)+8.0670734103027e-11)+-4.0644363084799e-9)+1.157364750534e-7)+-10866707695377.0e-19)*+h[(EA(w,1,j)|0)>>3]+-.0001528548241314))+-5.8457616048039)))+113.49746881718)+404.21188637945)+-238.72489924521;i=f;return}function Xh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0,Mb=0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+16|0;c[ib>>2]=8;wA(jb,1,ib);kb=d*1.0e-6;d=e*5.0e-7;lb=e*.001;if(kb<4.0){e=d+-2.1;c[hb>>2]=1;h[(EA(jb,1,hb)|0)>>3]=e*e;c[gb>>2]=1;mb=+h[(EA(jb,1,gb)|0)>>3];c[fb>>2]=2;h[(EA(jb,1,fb)|0)>>3]=mb*mb;c[eb>>2]=3;h[(EA(jb,1,eb)|0)>>3]=kb*kb;c[db>>2]=3;mb=+h[(EA(jb,1,db)|0)>>3];c[cb>>2]=4;h[(EA(jb,1,cb)|0)>>3]=mb*mb;c[bb>>2]=3;mb=kb*+h[(EA(jb,1,bb)|0)>>3];c[ab>>2]=5;h[(EA(jb,1,ab)|0)>>3]=mb;c[$a>>2]=2;mb=+h[(EA(jb,1,$a)|0)>>3];c[_a>>2]=1;nb=+h[(EA(jb,1,_a)|0)>>3];c[Za>>2]=1;ob=+h[(EA(jb,1,Za)|0)>>3];c[Ya>>2]=4;pb=+h[(EA(jb,1,Ya)|0)>>3]*1.3865724283226;c[Xa>>2]=1;qb=+h[(EA(jb,1,Xa)|0)>>3];c[Wa>>2]=2;rb=+h[(EA(jb,1,Wa)|0)>>3];c[Va>>2]=1;sb=+h[(EA(jb,1,Va)|0)>>3];c[Ua>>2]=2;tb=+h[(EA(jb,1,Ua)|0)>>3];c[Ta>>2]=5;ub=+h[(EA(jb,1,Ta)|0)>>3]*-13551.334240775;c[Sa>>2]=2;vb=+h[(EA(jb,1,Sa)|0)>>3];c[Ra>>2]=3;wb=+h[(EA(jb,1,Ra)|0)>>3];c[Qa>>2]=4;xb=wb*kb*+h[(EA(jb,1,Qa)|0)>>3]*-62.459855192507;c[Pa>>2]=2;wb=+h[(EA(jb,1,Pa)|0)>>3];c[Oa>>2]=4;yb=(kb*7399.9835474766+235988.32556514)*+h[(EA(jb,1,Oa)|0)>>3];c[Na>>2]=1;zb=+h[(EA(jb,1,Na)|0)>>3];c[Ma>>2]=3;Ab=+h[(EA(jb,1,Ma)|0)>>3];c[La>>2]=4;Bb=Ab*+h[(EA(jb,1,La)|0)>>3]*19127.72923966;c[Ka>>2]=1;Ab=+h[(EA(jb,1,Ka)|0)>>3];c[Ja>>2]=3;Cb=+h[(EA(jb,1,Ja)|0)>>3];c[Ia>>2]=5;Db=Cb*(+h[(EA(jb,1,Ia)|0)>>3]*-551966.9703006+128127984.04046);c[Ha>>2]=1;Cb=+h[(EA(jb,1,Ha)|0)>>3];c[Ga>>2]=3;Eb=+h[(EA(jb,1,Ga)|0)>>3]*-985549096.23276;c[Fa>>2]=1;Fb=+h[(EA(jb,1,Fa)|0)>>3];c[Ea>>2]=3;Gb=+h[(EA(jb,1,Ea)|0)>>3]*2822454697.3002;c[Da>>2]=1;Hb=+h[(EA(jb,1,Da)|0)>>3];c[Ca>>2]=3;Ib=+h[(EA(jb,1,Ca)|0)>>3];c[Ba>>2]=5;Jb=Ib*(+h[(EA(jb,1,Ba)|0)>>3]*3715408.5996233+-3594897141.0703);c[Aa>>2]=1;Ib=+h[(EA(jb,1,Aa)|0)>>3];c[za>>2]=3;Kb=kb*(kb*-.0061707422868339+1.844574935579)+e*(kb*-4.1792700549624+e*(kb*(kb*-.31078046629583+6.2478196935812)+e*(kb*-17.344563108114+mb*(kb*(kb*11.670873077107+-200.58176862096)+nb*(kb*271.96065473796+ob*(kb*-455.11318285818+e*(pb+qb*rb*(kb*3091.9688604755+sb*(tb*(ub+vb*(xb+wb*(yb+zb*(Bb+Ab*(Db+Cb*(Eb+Fb*(Gb+Hb*(Jb+Ib*kb*(kb*(kb*(kb*(+h[(EA(jb,1,za)|0)>>3]*-415351.64835634+-13105236.545054)+12848734.66465)+1722734991.3197)+252266.40357872)))))))))+11.765048724356)))))+-7.4232016790248)+33.153654801263)+-107.81748091826)+849.51654495535)+1089.8952318288;Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}if(kb<lb*(lb*.00012809002730136+-.67955786399241)+905.84278514723){lb=d+-2.6;Ib=kb+-2.0;c[ya>>2]=1;h[(EA(jb,1,ya)|0)>>3]=Ib*Ib;c[xa>>2]=1;Jb=Ib*+h[(EA(jb,1,xa)|0)>>3];c[wa>>2]=2;h[(EA(jb,1,wa)|0)>>3]=Jb;c[va>>2]=1;Jb=+h[(EA(jb,1,va)|0)>>3];c[ua>>2]=3;h[(EA(jb,1,ua)|0)>>3]=Jb*Jb;c[ta>>2]=4;h[(EA(jb,1,ta)|0)>>3]=lb*lb;c[sa>>2]=4;Jb=+h[(EA(jb,1,sa)|0)>>3];c[ra>>2]=5;h[(EA(jb,1,ra)|0)>>3]=Jb*Jb;c[qa>>2]=4;Jb=+h[(EA(jb,1,qa)|0)>>3];c[pa>>2]=5;Hb=Jb*+h[(EA(jb,1,pa)|0)>>3];c[oa>>2]=6;h[(EA(jb,1,oa)|0)>>3]=Hb;c[na>>2]=5;Hb=+h[(EA(jb,1,na)|0)>>3];c[ma>>2]=7;h[(EA(jb,1,ma)|0)>>3]=Hb*Hb;c[la>>2]=2;Hb=+h[(EA(jb,1,la)|0)>>3];c[ka>>2]=1;Jb=+h[(EA(jb,1,ka)|0)>>3];c[ja>>2]=3;Gb=Hb*(Jb*+h[(EA(jb,1,ja)|0)>>3]*-1.7565233969407e-18+.00011032831789999);c[ia>>2]=2;Jb=Ib*(Ib*(Ib*(Ib*(+h[(EA(jb,1,ia)|0)>>3]*-8.1456365207833e-14+2.8640237477456e-7)+.00018955248387902)+-.021810755324761)+3.3593118604916);c[ha>>2]=5;Hb=+h[(EA(jb,1,ha)|0)>>3];c[ga>>2]=4;Fb=+h[(EA(jb,1,ga)|0)>>3];c[fa>>2]=1;Eb=+h[(EA(jb,1,fa)|0)>>3]*-.10829784403677;c[ea>>2]=5;Cb=+h[(EA(jb,1,ea)|0)>>3];c[da>>2]=1;Db=Ib*((Ib*-10779857357512.0e-18+.0030891541160537)*+h[(EA(jb,1,da)|0)>>3]+.16844539671904);c[ca>>2]=6;Ab=+h[(EA(jb,1,ca)|0)>>3];c[ba>>2]=1;Bb=Ib*(Ib*((Ib*2.821728163504e-7+-76462712454814.0e-18)*+h[(EA(jb,1,ba)|0)>>3]+-.046333324635812)+.73875745236695);c[aa>>2]=6;zb=+h[(EA(jb,1,aa)|0)>>3];c[$>>2]=1;yb=Ib*((Ib*(Ib*12704902271945.0e-19+14052392818316.0e-18)+.0013555504554949)*+h[(EA(jb,1,$)|0)>>3]+-.47128737436186);c[_>>2]=5;wb=+h[(EA(jb,1,_)|0)>>3];c[Z>>2]=2;xb=+h[(EA(jb,1,Z)|0)>>3];c[Y>>2]=1;vb=Ib*(xb*((Ib*-2.5180545682962e-11+-1.1030139238909e-8)*+h[(EA(jb,1,Y)|0)>>3]+-31083814331434.0e-18)+.15020273139707);c[X>>2]=5;xb=+h[(EA(jb,1,X)|0)>>3];c[W>>2]=7;ub=+h[(EA(jb,1,W)|0)>>3];c[V>>2]=1;tb=+h[(EA(jb,1,V)|0)>>3];c[U>>2]=3;Kb=Ib*.93747147377932+lb*(Gb+lb*(Jb+Hb*(Ib*3.3809355601454+Fb*(Eb+Cb*(Db+Ab*(Bb+zb*(yb+wb*(vb+xb*ub*(Ib*(Ib*(tb*(Ib*(+h[(EA(jb,1,U)|0)>>3]*8.6934156344163e-15+7.3803353468292e-8)+-10302738212103.0e-19)+71280351959551.0e-18)+-.002176411421975)+.0085208123431544)+-.47811863648625)+1.1385952129658)+-.63281320016026)+2.4742464705674)))+-97.708318797837)+743.07798314034)+1489.5041079516;Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}else{Ib=d+-1.8;d=kb+25.0;c[T>>2]=1;h[(EA(jb,1,T)|0)>>3]=d*d;c[S>>2]=1;kb=+h[(EA(jb,1,S)|0)>>3];c[R>>2]=2;h[(EA(jb,1,R)|0)>>3]=kb*kb;c[Q>>2]=1;kb=+h[(EA(jb,1,Q)|0)>>3];c[P>>2]=2;tb=kb*d*+h[(EA(jb,1,P)|0)>>3];c[O>>2]=3;h[(EA(jb,1,O)|0)>>3]=tb;c[N>>2]=3;tb=1.0/+h[(EA(jb,1,N)|0)>>3];c[M>>2]=4;h[(EA(jb,1,M)|0)>>3]=tb;c[L>>2]=1;tb=+h[(EA(jb,1,L)|0)>>3];c[K>>2]=2;kb=tb*+h[(EA(jb,1,K)|0)>>3];c[J>>2]=5;h[(EA(jb,1,J)|0)>>3]=kb;c[I>>2]=6;h[(EA(jb,1,I)|0)>>3]=Ib*Ib;c[H>>2]=2;kb=+h[(EA(jb,1,H)|0)>>3];c[G>>2]=7;h[(EA(jb,1,G)|0)>>3]=kb*kb;c[F>>2]=6;kb=+h[(EA(jb,1,F)|0)>>3];c[E>>2]=8;h[(EA(jb,1,E)|0)>>3]=kb*kb;c[D>>2]=1;kb=+h[(EA(jb,1,D)|0)>>3];c[C>>2]=5;tb=kb*(+h[(EA(jb,1,C)|0)>>3]*1.126159740723e-12+482.19755109255)+859777.2253558;c[B>>2]=1;kb=tb/+h[(EA(jb,1,B)|0)>>3];c[A>>2]=2;tb=d*(+h[(EA(jb,1,A)|0)>>3]*31081.088422714+20825544563.171)+-583401318515.9;c[z>>2]=5;ub=tb/+h[(EA(jb,1,z)|0)>>3];c[y>>2]=6;tb=+h[(EA(jb,1,y)|0)>>3];c[x>>2]=8;xb=+h[(EA(jb,1,x)|0)>>3];c[w>>2]=6;vb=+h[(EA(jb,1,w)|0)>>3];c[v>>2]=5;wb=+h[(EA(jb,1,v)|0)>>3]*1.2324579690832e-7;c[u>>2]=6;yb=+h[(EA(jb,1,u)|0)>>3];c[t>>2]=5;zb=+h[(EA(jb,1,t)|0)>>3]*-11606921130984.0e-19;c[s>>2]=8;Bb=+h[(EA(jb,1,s)|0)>>3];c[r>>2]=5;Ab=+h[(EA(jb,1,r)|0)>>3]*27846367088554.0e-18;c[q>>2]=5;Db=+h[(EA(jb,1,q)|0)>>3]*-.00059270038474176;c[p>>2]=5;Cb=+h[(EA(jb,1,p)|0)>>3];c[o>>2]=6;Eb=Db+Cb*+h[(EA(jb,1,o)|0)>>3]*.0012918582991878;c[n>>2]=8;Cb=xb*(d*-10.842984880077+vb*(wb+yb*(zb+Bb*(Ab+ +h[(EA(jb,1,n)|0)>>3]*Eb))));c[m>>2]=4;Eb=+h[(EA(jb,1,m)|0)>>3];c[l>>2]=7;Ab=+h[(EA(jb,1,l)|0)>>3];c[k>>2]=2;Bb=Ib*(kb+Ib*(ub+tb*(Cb+Eb*(Ab*(d*(+h[(EA(jb,1,k)|0)>>3]*-1.7804982240686e-11+-.04536417267666)+3.7966001272486)+7326335090218.1))));c[j>>2]=4;Ab=+h[(EA(jb,1,j)|0)>>3];c[g>>2]=1;Eb=+h[(EA(jb,1,g)|0)>>3];c[f>>2]=5;Kb=Bb+Ab*(d*(d*(Eb*d*(d*(d*(+h[(EA(jb,1,f)|0)>>3]*1.4559115658698e-13+1208.2315865936)+-25745.72360417)+610747.83564516)+-10783068217.47)+358250899454.47)+-3236839855524.2);Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}}function Yh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+16|0;j=g;k=g+8|0;do{if((f|0)==0){if(d<16529200.0){if(e>1073.15){l=5;break}Zg(j,b,d);l=+h[j>>3]<e?2:1;break}else{if(e<623.15){l=1;break}Zh(k,b,d);l=+h[k>>3]>e?3:2;break}}else{l=f}}while(0);c[a>>2]=l;i=g;return}function Zh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+16|0;c[j>>2]=5;wA(k,1,j);j=k;k=8040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];l=d/1.0e6;if(d>611.657){m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}k=gA(gA(9008,eA(d,0,1,6)|0)|0,3856)|0;j=gA(gA(k,eA(611.657,0,1,6)|0)|0,3864)|0;k=c[27736]|0;s=f;t=9080;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];c[s+16>>2]=c[t+16>>2];c[s+20>>2]=c[t+20>>2];Le[k&63](b,f,j,g);m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}function _h(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;$h(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));ai(b,0,0.0,f);i=e;return}function $h(b,c,d){b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;e=i;i=i+216|0;f=e+8|0;g=e+16|0;j=e+24|0;k=e+112|0;l=e+120|0;m=e+208|0;n=e;o=+vd(+d,22063999.9999999);Zg(f,c,o);p=+h[f>>3];Qh(g,c,p);q=+h[g>>3];g=p>623.15;f=g&1;if(g){fi(k,0,o);r=+h[k>>3];Kh(l,c,r,p);s=+h[l+16>>3];t=+h[l+24>>3];u=+h[l+32>>3];v=+h[l+40>>3];w=+h[l+48>>3];x=+h[l+56>>3];y=+h[l+64>>3];z=+h[l+72>>3];A=+h[l+80>>3];li(m,0,o);B=r*t*(w-u*A)*461.526;C=p*t*(w*2.0+t*x)*461.526;D=0.0;E=0.0;F=r;G=+h[m>>3];H=s*(u*y-v);I=0.0;J=u*u*z*-461.526}else{Th(j,c,d,p);z=+h[j+24>>3];u=+h[j+32>>3];v=+h[j+48>>3];y=+h[j+56>>3];s=+h[j+80>>3];r=z*v;x=u*+h[j+64>>3];if(o<d){K=2087546.84511715}else{K=p*x*461.526}o=+h[j+16>>3]*(x- +h[j+40>>3]);x=u*u*+h[j+72>>3]*-461.526;B=-((v-u*s)/(p*z*y)*d);C=p*(v*v/y)*-461.526;D=(r-u*z*s)/d*461.526;E=p*z*z*y*+oB(d,-2)*461.526;F=d/(p*r*461.526);G=K;H=o;I=x;J=0.0}j=b;a[j]=f;f=j+1|0;a[f+0|0]=a[n+0|0]|0;a[f+1|0]=a[n+1|0]|0;a[f+2|0]=a[n+2|0]|0;a[f+3|0]=a[n+3|0]|0;a[f+4|0]=a[n+4|0]|0;a[f+5|0]=a[n+5|0]|0;a[f+6|0]=a[n+6|0]|0;h[b+8>>3]=461.526;h[b+16>>3]=p;h[b+24>>3]=F;h[b+32>>3]=G;h[b+40>>3]=H;h[b+48>>3]=I;h[b+56>>3]=J;h[b+64>>3]=q;h[b+72>>3]=B;h[b+80>>3]=C;h[b+88>>3]=D;h[b+96>>3]=E;i=e;return}function ai(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;h[a>>3]=+h[d+32>>3];i=i;return}function bi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=5;wA(f,1,e);h[a>>3]=((d*.0010192970039326+-1.1671859879975)*d+348.05185628969)*1.0e6;i=b;return}function ci(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0;g=i;i=i+192|0;j=g;k=g+24|0;l=g+112|0;m=g+136|0;n=g+160|0;o=g+184|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+88|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+16|0;if(!(d>=16529200.0)){G=gA(gA(8056,eA(d,0,1,6)|0)|0,8128)|0;H=gA(gA(G,eA(16529200.0,0,1,6)|0)|0,8136)|0;G=c[27736]|0;I=n;J=8144;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];c[I+16>>2]=c[J+16>>2];c[I+20>>2]=c[J+20>>2];Le[G&63](b,n,H,r);}if(!(e>=623.15)){r=gA(gA(8168,eA(e,0,1,6)|0)|0,8240)|0;H=gA(gA(r,eA(623.15,0,1,6)|0)|0,8248)|0;r=c[27736]|0;n=m;G=8256;c[n+0>>2]=c[G+0>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];c[n+12>>2]=c[G+12>>2];c[n+16>>2]=c[G+16>>2];c[n+20>>2]=c[G+20>>2];Le[r&63](b,m,H,q);}bi(t,0,e);if(!(+h[t>>3]<=d)){t=gA(gA(8280,eA(d,0,1,6)|0)|0,8352)|0;q=gA(gA(t,eA(e,0,1,6)|0)|0,8248)|0;t=c[27736]|0;H=l;m=8368;c[H+0>>2]=c[m+0>>2];c[H+4>>2]=c[m+4>>2];c[H+8>>2]=c[m+8>>2];c[H+12>>2]=c[m+12>>2];c[H+16>>2]=c[m+16>>2];c[H+20>>2]=c[m+20>>2];Le[t&63](b,l,q,p);}Zh(u,b,d);do{if(d>22064.0e3){K=+h[u>>3];di(v,0,d);L=+h[v>>3];ei(w,0,d);M=+h[w>>3];N=L-(e+-623.15)*((L-M)/(623.15-K));O=L;P=M}else{Zg(x,b,d);if(+h[x>>3]>e){di(y,0,d);M=+h[y>>3];fi(z,0,d);L=+h[z>>3];gi(A,b,e);N=+h[A>>3]*1.1;O=M;P=L;break}else{hi(B,0,d);L=+h[B>>3];ei(C,0,d);M=+h[C>>3];ii(D,b,e);N=+h[D>>3]*.9;O=L;P=M;break}}}while(0);D=E;C=E+8|0;B=E+16|0;A=E+24|0;z=E+32|0;y=E+40|0;x=E+48|0;w=E+56|0;v=E+64|0;u=E+72|0;p=E+80|0;q=s;l=s+8|0;t=s+16|0;m=s+24|0;H=s+32|0;r=s+40|0;G=s+48|0;n=s+56|0;J=s+64|0;I=s+72|0;Q=s+80|0;R=F;S=F+8|0;M=O+-3.162277660168379e-8;L=P+3.162277660168379e-8;K=N;T=0;while(1){Kh(E,b,K,e);N=+h[C>>3];V=+h[B>>3];W=+h[A>>3];X=+h[z>>3];Y=+h[y>>3];Z=+h[x>>3];_=+h[w>>3];$=+h[v>>3];aa=+h[u>>3];ba=+h[p>>3];h[q>>3]=+h[D>>3];h[l>>3]=N;h[t>>3]=V;h[m>>3]=W;h[H>>3]=X;h[r>>3]=Y;h[G>>3]=Z;h[n>>3]=_;h[J>>3]=$;h[I>>3]=aa;h[Q>>3]=ba;ca=k+0|0;da=s+0|0;ea=ca+88|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(ea|0));Ih(F,0,k);ba=+h[R>>3]-d;fa=!(+U(+(ba/d))<=f);ga=K-ba*(1.0/+h[S>>3]);do{if(ga>P&ga<O){ha=ga}else{if(ga>O){ha=M;break}ha=L}}while(0);da=T+1|0;if((da|0)<50&fa){K=ha;T=da}else{break}}T=fa&1;if(!fa){ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}fa=c[27736]|0;S=j;R=8392;c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];c[S+12>>2]=c[R+12>>2];c[S+16>>2]=c[R+16>>2];c[S+20>>2]=c[R+20>>2];Le[fa&63](b,j,8416,o);ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}function di(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;c[r>>2]=3;wA(s,1,r);t=d*-6.04960677555959e-8+7.1;c[q>>2]=1;h[(EA(s,1,q)|0)>>3]=t*t;c[p>>2]=1;d=+h[(EA(s,1,p)|0)>>3];c[o>>2]=2;h[(EA(s,1,o)|0)>>3]=d*d;c[n>>2]=2;d=+h[(EA(s,1,n)|0)>>3];c[m>>2]=3;h[(EA(s,1,m)|0)>>3]=d*d;c[l>>2]=1;d=+h[(EA(s,1,l)|0)>>3];c[k>>2]=2;u=+h[(EA(s,1,k)|0)>>3];c[j>>2]=3;v=+h[(EA(s,1,j)|0)>>3];c[g>>2]=1;w=+h[(EA(s,1,g)|0)>>3];c[f>>2]=1;x=+h[(EA(s,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=57.4756752485113/(t*(t*(t*(t*(d*t*(u*v*t*(w*(x*(t*(t*(t*2.73712834080283e-24+-5.17859076694812e-23)+3.29199117056433e-22)+-7.02987180039442e-22)*+h[(EA(s,1,e)|0)>>3]+-3.11228834832975e-19)+1.35549330686006e-17)+1.13217858826367e-8)+199080616601101.0e-20)+114683182476084.0e-19)+.000102697173772229)+.00145092247736023)+.0737412153522555);i=b;return}function ei(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+16|0;c[Ka>>2]=13;wA(La,1,Ka);Ma=d/1.0e6;Na=+V(+(Ma+-13.91883977887));c[Ja>>2]=1;h[(EA(La,1,Ja)|0)>>3]=Na;c[Ia>>2]=1;Oa=540.0/(+h[(EA(La,1,Ia)|0)>>3]*31.3220101646784+572.54459862746)+-.5;c[Ha>>2]=2;h[(EA(La,1,Ha)|0)>>3]=Oa*Oa;c[Ga>>2]=2;Pa=Oa*+h[(EA(La,1,Ga)|0)>>3];c[Fa>>2]=3;h[(EA(La,1,Fa)|0)>>3]=Pa;c[Ea>>2]=2;Pa=+h[(EA(La,1,Ea)|0)>>3];c[Da>>2]=4;h[(EA(La,1,Da)|0)>>3]=Pa*Pa;c[Ca>>2]=4;Pa=+h[(EA(La,1,Ca)|0)>>3];c[Ba>>2]=5;h[(EA(La,1,Ba)|0)>>3]=Pa*Pa;c[Aa>>2]=5;Pa=+h[(EA(La,1,Aa)|0)>>3];c[za>>2]=6;h[(EA(La,1,za)|0)>>3]=Pa*Pa;c[ya>>2]=4;Pa=+h[(EA(La,1,ya)|0)>>3];c[xa>>2]=5;Qa=+h[(EA(La,1,xa)|0)>>3];c[wa>>2]=6;Ra=Pa*Qa*Oa*+h[(EA(La,1,wa)|0)>>3];c[va>>2]=7;h[(EA(La,1,va)|0)>>3]=Ra;c[ua>>2]=4;Ra=+h[(EA(La,1,ua)|0)>>3];c[ta>>2]=5;Qa=Ra*Oa*+h[(EA(La,1,ta)|0)>>3];c[sa>>2]=8;h[(EA(La,1,sa)|0)>>3]=Qa;c[ra>>2]=2;Qa=+h[(EA(La,1,ra)|0)>>3];c[qa>>2]=4;Ra=+h[(EA(La,1,qa)|0)>>3];c[pa>>2]=5;Pa=Qa*Ra*+h[(EA(La,1,pa)|0)>>3];c[oa>>2]=9;h[(EA(La,1,oa)|0)>>3]=Pa;c[na>>2]=10;h[(EA(La,1,na)|0)>>3]=Ma*Ma;c[ma>>2]=10;Pa=+h[(EA(La,1,ma)|0)>>3];c[la>>2]=11;h[(EA(La,1,la)|0)>>3]=Pa*Pa;c[ka>>2]=4;Pa=+h[(EA(La,1,ka)|0)>>3];c[ja>>2]=6;Ra=Pa*Oa*+h[(EA(La,1,ja)|0)>>3];c[ia>>2]=12;h[(EA(La,1,ia)|0)>>3]=Ra;c[ha>>2]=6;Ra=+h[(EA(La,1,ha)|0)>>3];c[ga>>2]=13;h[(EA(La,1,ga)|0)>>3]=Ra*Ra;c[fa>>2]=3;Ra=Oa*(Oa*(Oa*(+h[(EA(La,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=2;Pa=+h[(EA(La,1,ea)|0)>>3];c[da>>2]=3;Qa=+h[(EA(La,1,da)|0)>>3];c[ca>>2]=7;Sa=Oa*(Oa*(Pa*(Qa*(+h[(EA(La,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=2;Qa=+h[(EA(La,1,ba)|0)>>3];c[aa>>2]=3;Pa=+h[(EA(La,1,aa)|0)>>3];c[$>>2]=7;Ta=Oa*(Qa*(Pa*(+h[(EA(La,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=2;Pa=+h[(EA(La,1,_)|0)>>3];c[Z>>2]=4;Qa=Pa*Oa*+h[(EA(La,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=3;Pa=+h[(EA(La,1,Y)|0)>>3];c[X>>2]=8;Ua=+h[(EA(La,1,X)|0)>>3];c[W>>2]=2;Va=+h[(EA(La,1,W)|0)>>3];c[U>>2]=6;Wa=Pa*(Ua*(Va*Oa*+h[(EA(La,1,U)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[T>>2]=2;Va=+h[(EA(La,1,T)|0)>>3];c[S>>2]=5;Ua=+h[(EA(La,1,S)|0)>>3];c[R>>2]=9;Pa=Va*Ua*Oa*(+h[(EA(La,1,R)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[Q>>2]=5;Ua=+h[(EA(La,1,Q)|0)>>3];c[P>>2]=4;Va=+h[(EA(La,1,P)|0)>>3];c[O>>2]=5;Xa=+h[(EA(La,1,O)|0)>>3];c[N>>2]=6;Ya=Ua*(Va*Xa*+h[(EA(La,1,N)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[M>>2]=8;Xa=+h[(EA(La,1,M)|0)>>3]*1.78287415218792e-7;c[L>>2]=4;Va=+h[(EA(La,1,L)|0)>>3];c[K>>2]=2;Ua=+h[(EA(La,1,K)|0)>>3];c[J>>2]=4;Za=+h[(EA(La,1,J)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[I>>2]=4;_a=Va*(Ua*Za*+h[(EA(La,1,I)|0)>>3]+1.0406965210174e-18);c[H>>2]=10;Za=+h[(EA(La,1,H)|0)>>3];c[G>>2]=11;Ua=+h[(EA(La,1,G)|0)>>3];c[F>>2]=12;Va=+h[(EA(La,1,F)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[E>>2]=7;$a=Va*+h[(EA(La,1,E)|0)>>3];c[D>>2]=10;Va=+h[(EA(La,1,D)|0)>>3];c[C>>2]=13;ab=+h[(EA(La,1,C)|0)>>3];c[B>>2]=5;bb=+h[(EA(La,1,B)|0)>>3];c[A>>2]=6;cb=ab*bb*Oa*+h[(EA(La,1,A)|0)>>3]*-6.05920510335078;c[z>>2]=10;bb=+h[(EA(La,1,z)|0)>>3];c[y>>2]=4;ab=+h[(EA(La,1,y)|0)>>3];c[x>>2]=6;db=+h[(EA(La,1,x)|0)>>3];c[w>>2]=2;eb=+h[(EA(La,1,w)|0)>>3];c[v>>2]=4;fb=+h[(EA(La,1,v)|0)>>3];c[u>>2]=5;gb=+h[(EA(La,1,u)|0)>>3];c[t>>2]=8;hb=ab*db*(eb*fb*gb*Oa*(+h[(EA(La,1,t)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[s>>2]=12;gb=+h[(EA(La,1,s)|0)>>3]*-1.24017662339842e-24;c[r>>2]=13;fb=+h[(EA(La,1,r)|0)>>3];c[q>>2]=4;eb=+h[(EA(La,1,q)|0)>>3];c[p>>2]=6;db=fb*eb*Oa*+h[(EA(La,1,p)|0)>>3]*832192847496054.0e-19;c[o>>2]=2;eb=+h[(EA(La,1,o)|0)>>3];c[n>>2]=5;fb=+h[(EA(La,1,n)|0)>>3];c[m>>2]=6;ab=+h[(EA(La,1,m)|0)>>3];c[l>>2]=2;ib=+h[(EA(La,1,l)|0)>>3];c[k>>2]=6;jb=ib*+h[(EA(La,1,k)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[j>>2]=9;ib=eb*fb*ab*Ma*(+h[(EA(La,1,j)|0)>>3]*jb+1.75410265428146e-27);c[g>>2]=13;jb=+h[(EA(La,1,g)|0)>>3];c[f>>2]=2;ab=+h[(EA(La,1,f)|0)>>3];c[e>>2]=4;h[a>>3]=d/((Na*31.3220101646784+572.54459862746)*Ma*((Ma*(Ra+Ma*(Sa+Ma*(Ta+Ma*(Oa*(Oa*(Oa*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ma*(Qa+Ma*(Wa+Ma*(Pa+Ma*(Ya+Ma*(Xa+Ma*(_a+Za*Ua*($a+Va*(cb+bb*(hb+Ma*(gb+Ma*(db+Ma*(ib+jb*ab*Oa*+h[(EA(La,1,e)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ma)*461.526);i=b;return}function fi(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*.00052536560808895+-191.4307733640516)+673.2581177021598)+-994.5385383600702)+796.6627910598293)+-369.3676833623383)+94.34196116778385)+-8.191449323843552)+-2.531486180240112)+1.903224079094824)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function gi(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Rh(e,b,c);j=+h[e>>3];do{if(c<623.15){si(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}fi(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function hi(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*-.001115111165833234+725.8761975803782)+-2537.375817253895)+3740.579034867006)+-3015.853540307519)+1437.200724533239)+-403.5391431811611)+59.18702203076563)+-1.144787271887849)+-1.84638508033626)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function ii(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Rh(e,b,c);j=+h[e>>3];do{if(c<623.15){ti(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}hi(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function ji(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=30;wA(k,1,j);j=k;k=8472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=30;wA(l,1,g);g=l;l=8488;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=30;wA(m,1,f);f=m;m=8504;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/28.0e5+-.72;e=d/1.0e8+.0661;d=n*n;o=e*n;p=-2.25196934336318e-9/+oB(e,12);q=n*+oB(e,-12)*1.40674363313486e-8;r=23378408528056.0e-19/+oB(e,8);s=n*+oB(e,-8)*-331833715229001.0e-19;t=n*d;u=t*+oB(e,-8)*.00107956778514318;v=+oB(e,-8);w=v*+oB(n,6)*-.271382067378863;v=+oB(e,-8);x=v*+oB(n,7)*1.07202262490333;v=+oB(e,-8);y=v*+oB(n,8)*-.853821329075382;v=-215214194340526.0e-19/+oB(e,6);z=n*+oB(e,-6)*.00076965608822273;A=d*+oB(e,-6)*-.00431136580433864;B=+oB(e,-6);C=B*+oB(n,5)*.453342167309331;B=+oB(e,-6);D=B*+oB(n,6)*-.507749535873652;B=+oB(e,-6);E=B*+oB(n,10)*-100.475154528389;B=t*+oB(e,-4)*-.219201924648793;t=+oB(e,-4);F=t*+oB(n,6)*-3.21087965668917;t=+oB(e,-4);G=t*+oB(n,10)*607.567815637771;t=e*e;H=d*+oB(e,-3)*.18749904002955;I=n*+oB(e,-2)*.00905368030448107;J=d*+oB(e,-2)*.285417173048685;K=+oB(n,5)/e*-11.8035753702231;h[a>>3]=(p+(q+(r+(s+(u+(w+(x+(y+(v+(z+(A+(C+(D+(E+(B+(F+(G+(.000557686450685932/(e*t)+(H+(I+(J+(.0329924030996098/e+(n/e*.239897419685483+(d*d/e*4.82754995951394+(K+(e*-.0179967222507787+(o*.0371810116332674+(o*o*-.0536288335065096+t*+oB(n,6)*1.6069710109252)))))))))))))))))))))))))))+.169490044091791)*.0088;i=b;return}function ki(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=32;wA(k,1,j);j=k;k=8520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=32;wA(l,1,g);g=l;l=8536;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=32;wA(m,1,f);f=m;m=8552;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/21.0e5+-.727;e=n*n;o=d/1.0e8+.128;d=o*n;p=o*o;q=+oB(o,-12);r=q*+oB(n,6)*.00529944062966028;q=+oB(o,-12);s=q*+oB(n,8)*-.170099690234461;q=+oB(o,-12);t=q*+oB(n,12)*11.1323814312927;q=+oB(o,-12);u=q*+oB(n,18)*-2178.98123145125;q=e*e;v=q*+oB(o,-10)*-.000506061827980875;w=+oB(o,-10);x=w*+oB(n,7)*.556495239685324;w=+oB(o,-10);y=w*+oB(n,10)*-9.43672726094016;w=+oB(o,-8);z=w*+oB(n,5)*-.297856807561527;w=+oB(o,-8);A=w*+oB(n,12)*93.9353943717186;w=n*e;B=w*+oB(o,-6)*.0192944939465981;C=q*+oB(o,-6)*.421740664704763;q=+oB(o,-6);D=q*+oB(n,22)*-3689141.2628233;q=e*+oB(o,-4)*-.00737566847600639;E=w*+oB(o,-4)*-.354753242424366;F=+oB(o,-3);G=F*+oB(n,7)*-1.99768169338727;F=w*+oB(o,-2)*1.15456297059049;H=+oB(o,-2);I=H*+oB(n,16)*5683.6687581596;H=e*+oB(o,5)*1.10533464706142;h[a>>3]=(r+(s+(t+(u+(v+(x+(y+(z+(A+(B+(C+(D+(q+(E+(G+(F+(I+(.00808169540124668/o+(n/o*.172416341519307+(e/o*1.04270175292927+(w/o*-.297691372792847+(n*.275234661176914+(o*-.148347894866012+(d*-.0651142513478515+(o*e*-2.92468715386302+(p*.0664876096952665+(d*d*3.52335014263844+(o*p*-.0146340792313332+(p*p*e*-2.24503486668184+(H+e*+oB(o,8)*-.0408757344495612)))))))))))))))))))))))))))))+.560394465163593)*.0028;i=b;return}function li(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;d=+_(+(c/22064.0e3));h[a>>3]=(d*(d*(d*(d*(d*(d*(d*(d*-.0001152032945617821+-.717981855497894)+3.558919744656498)+-6.75820241066552)+6.679385472887931)+-3.889388153209752)+1.346800016564904)+-.4945586958175176)+1.0)*2087546.84511715;i=i;return}function mi(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+16|0;c[Va>>2]=16;wA(Wa,1,Va);if(!(d>611.657)){Va=gA(gA(8568,eA(d,0,1,6)|0)|0,3856)|0;Xa=gA(gA(Va,eA(611.657,0,1,6)|0)|0,3864)|0;Va=c[27736]|0;Ya=g;Za=8632;c[Ya+0>>2]=c[Za+0>>2];c[Ya+4>>2]=c[Za+4>>2];c[Ya+8>>2]=c[Za+8>>2];c[Ya+12>>2]=c[Za+12>>2];c[Ya+16>>2]=c[Za+16>>2];c[Ya+20>>2]=c[Za+20>>2];Le[Va&63](b,g,Xa,Ua);}_a=d/1.0e6;d=540.0/e;$a=d+-.5;c[Ta>>2]=1;h[(EA(Wa,1,Ta)|0)>>3]=d*d;c[Sa>>2]=1;ab=+h[(EA(Wa,1,Sa)|0)>>3];c[Ra>>2]=2;h[(EA(Wa,1,Ra)|0)>>3]=ab*ab;c[Qa>>2]=3;h[(EA(Wa,1,Qa)|0)>>3]=$a*$a;c[Pa>>2]=3;ab=$a*+h[(EA(Wa,1,Pa)|0)>>3];c[Oa>>2]=4;h[(EA(Wa,1,Oa)|0)>>3]=ab;c[Na>>2]=3;ab=+h[(EA(Wa,1,Na)|0)>>3];c[Ma>>2]=5;h[(EA(Wa,1,Ma)|0)>>3]=ab*ab;c[La>>2]=5;ab=+h[(EA(Wa,1,La)|0)>>3];c[Ka>>2]=6;h[(EA(Wa,1,Ka)|0)>>3]=ab*ab;c[Ja>>2]=6;ab=+h[(EA(Wa,1,Ja)|0)>>3];c[Ia>>2]=7;h[(EA(Wa,1,Ia)|0)>>3]=ab*ab;c[Ha>>2]=5;ab=+h[(EA(Wa,1,Ha)|0)>>3];c[Ga>>2]=6;bb=+h[(EA(Wa,1,Ga)|0)>>3];c[Fa>>2]=7;cb=ab*bb*$a*+h[(EA(Wa,1,Fa)|0)>>3];c[Ea>>2]=8;h[(EA(Wa,1,Ea)|0)>>3]=cb;c[Da>>2]=3;cb=+h[(EA(Wa,1,Da)|0)>>3];c[Ca>>2]=5;bb=cb*+h[(EA(Wa,1,Ca)|0)>>3];c[Ba>>2]=9;h[(EA(Wa,1,Ba)|0)>>3]=bb;c[Aa>>2]=5;bb=+h[(EA(Wa,1,Aa)|0)>>3];c[za>>2]=6;cb=bb*$a*+h[(EA(Wa,1,za)|0)>>3];c[ya>>2]=10;h[(EA(Wa,1,ya)|0)>>3]=cb;c[xa>>2]=3;cb=+h[(EA(Wa,1,xa)|0)>>3];c[wa>>2]=7;bb=cb*$a*+h[(EA(Wa,1,wa)|0)>>3];c[va>>2]=11;h[(EA(Wa,1,va)|0)>>3]=bb;c[ua>>2]=3;bb=+h[(EA(Wa,1,ua)|0)>>3];c[ta>>2]=5;cb=+h[(EA(Wa,1,ta)|0)>>3];c[sa>>2]=6;ab=bb*cb*+h[(EA(Wa,1,sa)|0)>>3];c[ra>>2]=12;h[(EA(Wa,1,ra)|0)>>3]=ab;c[qa>>2]=5;ab=+h[(EA(Wa,1,qa)|0)>>3];c[pa>>2]=6;cb=+h[(EA(Wa,1,pa)|0)>>3];c[oa>>2]=7;bb=ab*cb*+h[(EA(Wa,1,oa)|0)>>3];c[na>>2]=13;h[(EA(Wa,1,na)|0)>>3]=bb;c[ma>>2]=14;h[(EA(Wa,1,ma)|0)>>3]=_a*_a;c[la>>2]=14;bb=+h[(EA(Wa,1,la)|0)>>3];c[ka>>2]=15;h[(EA(Wa,1,ka)|0)>>3]=bb*bb;c[ja>>2]=7;bb=+h[(EA(Wa,1,ja)|0)>>3];c[ia>>2]=16;h[(EA(Wa,1,ia)|0)>>3]=bb*bb;c[ha>>2]=1;bb=d*(d*(d*(d*((d*(d*.06380539059921+-.5681726521544)+10.08665568018)*+h[(EA(Wa,1,ha)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[ga>>2]=2;cb=+h[(EA(Wa,1,ga)|0)>>3];c[fa>>2]=1;ab=bb/(cb*+h[(EA(Wa,1,fa)|0)>>3]);c[ea>>2]=4;cb=$a*($a*(+h[(EA(Wa,1,ea)|0)>>3]*-.30195167236758+-.172743777250296)+-.09199202739273);c[da>>2]=3;bb=+h[(EA(Wa,1,da)|0)>>3];c[ca>>2]=4;db=+h[(EA(Wa,1,ca)|0)>>3];c[ba>>2]=8;eb=$a*(bb*(db*(+h[(EA(Wa,1,ba)|0)>>3]*-.000960283724907132+-.306581069554011)+-.015757110897342)+-.0003789797503263);c[aa>>2]=3;db=+h[(EA(Wa,1,aa)|0)>>3];c[$>>2]=4;bb=+h[(EA(Wa,1,$)|0)>>3];c[_>>2]=8;fb=db*(bb*(+h[(EA(Wa,1,_)|0)>>3]*-1.42338887469272+-.0090203547252888)+-9683303171571.0e-17);c[Z>>2]=9;bb=+h[(EA(Wa,1,Z)|0)>>3]*160454534363627.0e-19;c[Y>>2]=10;db=+h[(EA(Wa,1,Y)|0)>>3];c[X>>2]=11;gb=db*(+h[(EA(Wa,1,X)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11;c[W>>2]=3;db=+h[(EA(Wa,1,W)|0)>>3]*gb;c[V>>2]=12;gb=+h[(EA(Wa,1,V)|0)>>3]*-.973671060893475+-138839897890111.0e-19;c[U>>2]=3;hb=+h[(EA(Wa,1,U)|0)>>3];c[T>>2]=6;ib=gb*hb*+h[(EA(Wa,1,T)|0)>>3];c[S>>2]=13;hb=+h[(EA(Wa,1,S)|0)>>3]*-296.320827232793+9.0049690883672e-11;c[R>>2]=3;gb=+h[(EA(Wa,1,R)|0)>>3];c[Q>>2]=5;jb=hb*gb*$a*+h[(EA(Wa,1,Q)|0)>>3];c[P>>2]=5;gb=+h[(EA(Wa,1,P)|0)>>3];c[O>>2]=6;hb=gb*+h[(EA(Wa,1,O)|0)>>3]*2.57526266427144e-7;c[N>>2]=4;gb=+h[(EA(Wa,1,N)|0)>>3];c[M>>2]=5;kb=+h[(EA(Wa,1,M)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[L>>2]=9;lb=gb*(kb*+h[(EA(Wa,1,L)|0)>>3]+4.1627860840696e-19);c[K>>2]=14;kb=+h[(EA(Wa,1,K)|0)>>3];c[J>>2]=15;gb=+h[(EA(Wa,1,J)|0)>>3];c[I>>2]=13;mb=+h[(EA(Wa,1,I)|0)>>3];c[H>>2]=5;nb=+h[(EA(Wa,1,H)|0)>>3];c[G>>2]=7;ob=mb*(nb*$a*+h[(EA(Wa,1,G)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=14;nb=+h[(EA(Wa,1,F)|0)>>3];c[E>>2]=16;mb=+h[(EA(Wa,1,E)|0)>>3];c[D>>2]=6;pb=+h[(EA(Wa,1,D)|0)>>3];c[C>>2]=7;qb=mb*pb*+h[(EA(Wa,1,C)|0)>>3]*-19.1874828272775;c[B>>2]=14;pb=+h[(EA(Wa,1,B)|0)>>3];c[A>>2]=11;mb=+h[(EA(Wa,1,A)|0)>>3];c[z>>2]=10;rb=+h[(EA(Wa,1,z)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[y>>2]=3;sb=+h[(EA(Wa,1,y)|0)>>3];c[x>>2]=5;tb=+h[(EA(Wa,1,x)|0)>>3];c[w>>2]=6;ub=mb*(rb*sb*tb*$a*+h[(EA(Wa,1,w)|0)>>3]+1.78371690710842e-23);c[v>>2]=5;tb=+h[(EA(Wa,1,v)|0)>>3];c[u>>2]=7;sb=tb*+h[(EA(Wa,1,u)|0)>>3]*-1.24017662339842e-24;c[t>>2]=16;tb=+h[(EA(Wa,1,t)|0)>>3];c[s>>2]=5;rb=+h[(EA(Wa,1,s)|0)>>3];c[r>>2]=7;mb=tb*rb*+h[(EA(Wa,1,r)|0)>>3]*.000200482822351322;c[q>>2]=16;rb=+h[(EA(Wa,1,q)|0)>>3];c[p>>2]=3;tb=+h[(EA(Wa,1,p)|0)>>3];c[o>>2]=5;vb=rb*tb*+h[(EA(Wa,1,o)|0)>>3]*-4.97975748452559e-14;c[n>>2]=6;tb=+h[(EA(Wa,1,n)|0)>>3];c[m>>2]=7;rb=+h[(EA(Wa,1,m)|0)>>3];c[l>>2]=12;wb=+h[(EA(Wa,1,l)|0)>>3];c[k>>2]=3;xb=+h[(EA(Wa,1,k)|0)>>3];c[j>>2]=7;h[a>>3]=d*(ab+_a*(cb+_a*(eb+_a*(fb+_a*($a*($a*144676118155521.0e-20+2.558143570457e-8)+_a*(bb+_a*(db+_a*(ib+_a*(jb+_a*(hb+_a*(lb+kb*gb*(ob+nb*(qb+pb*(ub+_a*(sb+_a*(mb+_a*(vb+tb*rb*_a*$a*(wb*(xb*+h[(EA(Wa,1,j)|0)>>3]*-547344301999018.0e-19+2.21658861403112e-15)+1.90027787547159e-27)))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358))*e*461.526;i=f;return}function ni(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+16|0;c[za>>2]=13;wA(Aa,1,za);Ba=1386.0/e;Ca=7.1-d/1653.0e4;if(!(d>611.657)){za=gA(gA(8656,eA(d,0,1,6)|0)|0,3856)|0;Da=gA(gA(za,eA(611.657,0,1,6)|0)|0,3864)|0;za=c[27736]|0;Ea=g;Fa=8720;c[Ea+0>>2]=c[Fa+0>>2];c[Ea+4>>2]=c[Fa+4>>2];c[Ea+8>>2]=c[Fa+8>>2];c[Ea+12>>2]=c[Fa+12>>2];c[Ea+16>>2]=c[Fa+16>>2];c[Ea+20>>2]=c[Fa+20>>2];Le[za&63](b,g,Da,ya);}d=Ba+-1.222;c[xa>>2]=1;h[(EA(Aa,1,xa)|0)>>3]=d*d;c[wa>>2]=1;Ga=d*+h[(EA(Aa,1,wa)|0)>>3];c[va>>2]=2;h[(EA(Aa,1,va)|0)>>3]=Ga;c[ua>>2]=1;Ga=+h[(EA(Aa,1,ua)|0)>>3];c[ta>>2]=3;h[(EA(Aa,1,ta)|0)>>3]=Ga*Ga;c[sa>>2]=3;Ga=+h[(EA(Aa,1,sa)|0)>>3];c[ra>>2]=4;h[(EA(Aa,1,ra)|0)>>3]=Ga*Ga;c[qa>>2]=1;Ga=+h[(EA(Aa,1,qa)|0)>>3];c[pa>>2]=4;Ha=Ga*+h[(EA(Aa,1,pa)|0)>>3];c[oa>>2]=5;h[(EA(Aa,1,oa)|0)>>3]=Ha;c[na>>2]=1;Ha=+h[(EA(Aa,1,na)|0)>>3];c[ma>>2]=3;Ga=Ha*+h[(EA(Aa,1,ma)|0)>>3];c[la>>2]=6;h[(EA(Aa,1,la)|0)>>3]=Ga;c[ka>>2]=3;Ga=d*+h[(EA(Aa,1,ka)|0)>>3];c[ja>>2]=7;h[(EA(Aa,1,ja)|0)>>3]=Ga;c[ia>>2]=3;Ga=+h[(EA(Aa,1,ia)|0)>>3];c[ha>>2]=4;Ha=Ga*+h[(EA(Aa,1,ha)|0)>>3];c[ga>>2]=8;h[(EA(Aa,1,ga)|0)>>3]=Ha;c[fa>>2]=9;h[(EA(Aa,1,fa)|0)>>3]=Ca*Ca;c[ea>>2]=9;Ha=+h[(EA(Aa,1,ea)|0)>>3];c[da>>2]=10;h[(EA(Aa,1,da)|0)>>3]=Ha*Ha;c[ca>>2]=10;Ha=+h[(EA(Aa,1,ca)|0)>>3];c[ba>>2]=11;h[(EA(Aa,1,ba)|0)>>3]=Ha*Ha;c[aa>>2]=4;Ha=+h[(EA(Aa,1,aa)|0)>>3];c[$>>2]=12;h[(EA(Aa,1,$)|0)>>3]=Ha*Ha;c[_>>2]=12;Ha=+h[(EA(Aa,1,_)|0)>>3];c[Z>>2]=13;h[(EA(Aa,1,Z)|0)>>3]=Ha*Ha;c[Y>>2]=1;Ha=+h[(EA(Aa,1,Y)|0)>>3];c[X>>2]=1;Ga=+h[(EA(Aa,1,X)|0)>>3]*-.00015851507390979+-.021841717175414;c[W>>2]=1;Ia=Ga*+h[(EA(Aa,1,W)|0)>>3]+.018990068218419;c[V>>2]=6;Ga=Ha*(Ia*+h[(EA(Aa,1,V)|0)>>3]+.00424944110961118)+-.00254871721114236;c[U>>2]=5;Ia=Ga/+h[(EA(Aa,1,U)|0)>>3];c[T>>2]=3;Ga=+h[(EA(Aa,1,T)|0)>>3];c[S>>2]=1;Ha=+h[(EA(Aa,1,S)|0)>>3];c[R>>2]=1;Ja=+h[(EA(Aa,1,R)|0)>>3];c[Q>>2]=3;Ka=+h[(EA(Aa,1,Q)|0)>>3];c[P>>2]=4;La=Ga*(Ha*(Ja*Ka*+h[(EA(Aa,1,P)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801;c[O>>2]=3;Ka=La/+h[(EA(Aa,1,O)|0)>>3];c[N>>2]=5;La=+h[(EA(Aa,1,N)|0)>>3]*-5.11230768720618e-9+.000126718579380216;c[M>>2]=7;Ja=La/+h[(EA(Aa,1,M)|0)>>3];c[L>>2]=2;La=+h[(EA(Aa,1,L)|0)>>3];c[K>>2]=8;Ha=La*(+h[(EA(Aa,1,K)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20)+11212640954.0e-15;c[J>>2]=6;La=Ha/+h[(EA(Aa,1,J)|0)>>3];c[I>>2]=9;Ha=+h[(EA(Aa,1,I)|0)>>3];c[H>>2]=7;Ga=+h[(EA(Aa,1,H)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[G>>2]=8;Ma=Ga/+h[(EA(Aa,1,G)|0)>>3];c[F>>2]=10;Ga=+h[(EA(Aa,1,F)|0)>>3];c[E>>2]=11;Na=+h[(EA(Aa,1,E)|0)>>3];c[D>>2]=4;Oa=+h[(EA(Aa,1,D)|0)>>3];c[C>>2]=3;Pa=Oa*+h[(EA(Aa,1,C)|0)>>3];c[B>>2]=12;Oa=Pa*+h[(EA(Aa,1,B)|0)>>3];c[A>>2]=1;Pa=1.9941018075704e-17/(Oa*+h[(EA(Aa,1,A)|0)>>3]);c[z>>2]=9;Oa=+h[(EA(Aa,1,z)|0)>>3];c[y>>2]=10;Qa=+h[(EA(Aa,1,y)|0)>>3];c[x>>2]=9;Ra=+h[(EA(Aa,1,x)|0)>>3];c[w>>2]=4;Sa=+h[(EA(Aa,1,w)|0)>>3];c[v>>2]=13;Ta=4.65957282962769e-22/(Sa*+h[(EA(Aa,1,v)|0)>>3]);c[u>>2]=4;Sa=+h[(EA(Aa,1,u)|0)>>3];c[t>>2]=13;Ua=Sa*+h[(EA(Aa,1,t)|0)>>3];c[s>>2]=1;Sa=Ca/(Ua*+h[(EA(Aa,1,s)|0)>>3])*3.83502057899078e-24;c[r>>2]=4;Ua=d*+h[(EA(Aa,1,r)|0)>>3];c[q>>2]=13;Va=Ca*(Ta+Ca*(Sa+-7.2912378325616e-23/(Ua*+h[(EA(Aa,1,q)|0)>>3])));c[p>>2]=3;Ua=d*+h[(EA(Aa,1,p)|0)>>3];c[o>>2]=13;Sa=Ua*+h[(EA(Aa,1,o)|0)>>3];c[n>>2]=1;Ua=Qa*Ra*(Va+-1.00075970318621e-21/(Sa*+h[(EA(Aa,1,n)|0)>>3]));c[m>>2]=13;Sa=Ha*Ca*(Ma+Ga*Na*Ca*(Pa+Oa*(Ua+-4.48827542684151e-19/+h[(EA(Aa,1,m)|0)>>3])));c[l>>2]=4;Ua=Ca*(Ia+Ca*(Ka+Ca*(Ja+Ca*(La+Ca*(324135974880936.0e-20/(d*+h[(EA(Aa,1,l)|0)>>3])+Sa)))));c[k>>2]=1;Sa=d*((d*(d*(d*(d*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(EA(Aa,1,k)|0)>>3]+.84548187169114)+-.29265942426334;c[j>>2]=2;h[a>>3]=Ba*(Sa/+h[(EA(Aa,1,j)|0)>>3]+Ua)*e*461.526;i=f;return}function oi(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0;b=i;do{if(c>765.0){e=765.0;f=4}else{g=c<110.0?110.0:c;if(!(g<390.0)){e=g;f=4;break}j=g*.809344262+554.3557377;k=g}}while(0);if((f|0)==4){j=e*-.632948717+1116.85;k=e}e=k+-322.0;c=e*e;if(k<322.0){l=c/1.0e6}else{l=c/144.0e4}c=(1.0-l)*647.096;if(c>d){m=c}else{m=j<d?j:d}h[a>>3]=k;h[a+8>>3]=m;i=b;return}function pi(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;j=i;i=i+144|0;k=j;l=j+24|0;m=j+112|0;n=j+136|0;o=i;i=i+8|0;p=i;i=i+88|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+88|0;y=i;i=i+48|0;z=i;i=i+16|0;do{if(d<22064.0e3){_h(q,b,d);if(+h[q>>3]+10.0>e){A=6;break}qi(r,b,d);if(+h[r>>3]+-10.0<e){A=7;break}B=c[27736]|0;C=m;D=8744;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];c[C+12>>2]=c[D+12>>2];c[C+16>>2]=c[D+16>>2];c[C+20>>2]=c[D+20>>2];Le[B&63](b,m,8768,o);A=7}else{Vh(s,0,d);if(+h[s>>3]>e){A=6}else{A=7}}}while(0);if((A|0)==6){Ph(t,0,d,e);E=+h[t>>3];ki(v,0,d,e);F=+h[v>>3];G=E}else if((A|0)==7){Oh(u,0,d,e);E=+h[u>>3];ji(w,0,d,e);F=+h[w>>3];G=E}w=x;u=x+8|0;A=x+16|0;v=x+24|0;t=x+32|0;s=x+40|0;o=x+48|0;m=x+56|0;r=x+64|0;q=x+72|0;B=x+80|0;D=p;C=p+8|0;H=p+16|0;I=p+24|0;J=p+32|0;K=p+40|0;L=p+48|0;M=p+56|0;N=p+64|0;O=p+72|0;P=p+80|0;Q=y;R=y+8|0;S=y+16|0;T=y+24|0;V=y+32|0;W=y+40|0;X=z;Y=z+8|0;E=G;G=1.0/F;Z=0;do{Kh(x,b,G,E);F=+h[u>>3];_=+h[A>>3];$=+h[v>>3];aa=+h[t>>3];ba=+h[s>>3];ca=+h[o>>3];da=+h[m>>3];ea=+h[r>>3];fa=+h[q>>3];ga=+h[B>>3];h[D>>3]=+h[w>>3];h[C>>3]=F;h[H>>3]=_;h[I>>3]=$;h[J>>3]=aa;h[K>>3]=ba;h[L>>3]=ca;h[M>>3]=da;h[N>>3]=ea;h[O>>3]=fa;h[P>>3]=ga;ha=l+0|0;ia=p+0|0;ja=ha+88|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));Jh(y,0,l);ga=+h[S>>3];fa=+h[T>>3];ea=+h[V>>3];da=+h[W>>3];ca=+h[R>>3]-e;ba=+h[Q>>3]-d;do{if(!(+U(+(ca/e))<=g)){ka=1}else{if(!(+U(+(ba/d))<=f)){ka=1;break}ka=0}}while(0);aa=ga*da-fa*ea;Z=Z+1|0;oi(z,0,G-(ba*da-ca*fa)/aa,E-(ga*ca-ba*ea)/aa);G=+h[X>>3];E=+h[Y>>3];}while((Z|0)<50&ka);Z=ka&1;if(!ka){la=a;ma=la;h[ma>>3]=G;na=a;oa=na+8|0;pa=oa;h[pa>>3]=E;qa=a;ra=qa+16|0;sa=ra;c[sa>>2]=Z;i=j;return}ka=c[27736]|0;Y=k;X=8848;c[Y+0>>2]=c[X+0>>2];c[Y+4>>2]=c[X+4>>2];c[Y+8>>2]=c[X+8>>2];c[Y+12>>2]=c[X+12>>2];c[Y+16>>2]=c[X+16>>2];c[Y+20>>2]=c[X+20>>2];Le[ka&63](b,k,8872,n);la=a;ma=la;h[ma>>3]=G;na=a;oa=na+8|0;pa=oa;h[pa>>3]=E;qa=a;ra=qa+16|0;sa=ra;c[sa>>2]=Z;i=j;return}function qi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;ui(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));ai(b,0,0.0,f);i=e;return}function ri(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+88|0;m=l+32|0;n=l+64|0;o=l+72|0;p=1500.0;q=0;do{Uh(l,b,d,p);r=+h[m>>3];s=p*r*+h[n>>3]*461.526-e;t=+U(+(s/e))<f;p=p-s/(r*r*+h[o>>3]*-461.526);q=q+1|0;u=t^1;}while((q|0)<50&u);q=u&1;if(t){v=a;w=v;h[w>>3]=p;x=a;y=x+8|0;z=y;c[z>>2]=q;i=g;return}t=c[27736]|0;u=j;o=8928;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2];c[u+16>>2]=c[o+16>>2];c[u+20>>2]=c[o+20>>2];Le[t&63](b,j,8952,k);v=a;w=v;h[w>>3]=p;x=a;y=x+8|0;z=y;c[z>>2]=q;i=g;return}



function Jh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;d=+h[c+32>>3];e=+h[c+16>>3];f=+h[c>>3];g=+h[c+8>>3];j=+h[c+24>>3];k=+h[c+48>>3];l=j*k;m=e*g*(l+d*+h[c+64>>3]);n=e*g*j*(k*2.0+j*+h[c+56>>3]);o=e*f*j*(k-d*+h[c+80>>3]);k=o/f;j=k-e*d*d*+h[c+72>>3];h[a>>3]=f*e*g*l;h[a+8>>3]=m;h[a+16>>3]=n;h[a+24>>3]=o;h[a+32>>3]=(n-g*k)/f;h[a+40>>3]=j;i=i;return}function Kh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0.0,qd=0.0,rd=0.0,sd=0.0,td=0.0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0;f=i;i=i+32|0;g=f;j=f+24|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+16|0;c[nd>>2]=40;wA(od,1,nd);pd=647.096/e;if(d==322.0&e==647.096){qd=.999999999999999}else{qd=+U(+(d/322.0))}c[md>>2]=1;h[(EA(od,1,md)|0)>>3]=pd*pd;c[ld>>2]=1;rd=+h[(EA(od,1,ld)|0)>>3];c[kd>>2]=2;h[(EA(od,1,kd)|0)>>3]=rd*rd;c[jd>>2]=2;rd=pd*+h[(EA(od,1,jd)|0)>>3];c[id>>2]=3;h[(EA(od,1,id)|0)>>3]=rd;c[hd>>2]=1;rd=pd*+h[(EA(od,1,hd)|0)>>3];c[gd>>2]=4;h[(EA(od,1,gd)|0)>>3]=rd;c[fd>>2]=2;rd=+h[(EA(od,1,fd)|0)>>3];c[ed>>2]=5;h[(EA(od,1,ed)|0)>>3]=rd*rd;c[dd>>2]=1;rd=+h[(EA(od,1,dd)|0)>>3];c[cd>>2]=5;sd=rd*pd*+h[(EA(od,1,cd)|0)>>3];c[bd>>2]=6;h[(EA(od,1,bd)|0)>>3]=sd;c[ad>>2]=5;sd=pd*+h[(EA(od,1,ad)|0)>>3];c[$c>>2]=7;h[(EA(od,1,$c)|0)>>3]=sd;c[_c>>2]=1;sd=+h[(EA(od,1,_c)|0)>>3]*-.64207765181607;c[Zc>>2]=8;h[(EA(od,1,Zc)|0)>>3]=sd;c[Yc>>2]=8;sd=+h[(EA(od,1,Yc)|0)>>3]+.88521043984318;c[Xc>>2]=9;h[(EA(od,1,Xc)|0)>>3]=sd;c[Wc>>2]=7;sd=+h[(EA(od,1,Wc)|0)>>3];c[Vc>>2]=9;rd=sd*+h[(EA(od,1,Vc)|0)>>3];c[Uc>>2]=10;h[(EA(od,1,Uc)|0)>>3]=rd;c[Tc>>2]=10;rd=+h[(EA(od,1,Tc)|0)>>3]+-1.1524407806681;c[Sc>>2]=11;h[(EA(od,1,Sc)|0)>>3]=rd;c[Rc>>2]=11;rd=+h[(EA(od,1,Rc)|0)>>3];c[Qc>>2]=2;sd=rd*+h[(EA(od,1,Qc)|0)>>3];c[Pc>>2]=12;h[(EA(od,1,Pc)|0)>>3]=sd;c[Oc>>2]=12;sd=+h[(EA(od,1,Oc)|0)>>3]+-1.2654315477714;c[Nc>>2]=13;h[(EA(od,1,Nc)|0)>>3]=sd;c[Mc>>2]=1;sd=+h[(EA(od,1,Mc)|0)>>3];c[Lc>>2]=13;rd=sd*+h[(EA(od,1,Lc)|0)>>3];c[Kc>>2]=14;h[(EA(od,1,Kc)|0)>>3]=rd;c[Jc>>2]=1;rd=+h[(EA(od,1,Jc)|0)>>3];c[Ic>>2]=2;sd=+h[(EA(od,1,Ic)|0)>>3];c[Hc>>2]=5;td=rd*sd*pd*+h[(EA(od,1,Hc)|0)>>3];c[Gc>>2]=15;h[(EA(od,1,Gc)|0)>>3]=td;c[Fc>>2]=2;td=+h[(EA(od,1,Fc)|0)>>3];c[Ec>>2]=5;sd=td*+h[(EA(od,1,Ec)|0)>>3];c[Dc>>2]=16;h[(EA(od,1,Dc)|0)>>3]=sd;c[Cc>>2]=1;sd=+h[(EA(od,1,Cc)|0)>>3];c[Bc>>2]=5;td=sd*+h[(EA(od,1,Bc)|0)>>3];c[Ac>>2]=17;h[(EA(od,1,Ac)|0)>>3]=td;c[zc>>2]=5;td=+h[(EA(od,1,zc)|0)>>3];c[yc>>2]=18;h[(EA(od,1,yc)|0)>>3]=td*td;c[xc>>2]=1;td=+h[(EA(od,1,xc)|0)>>3];c[wc>>2]=18;sd=+h[(EA(od,1,wc)|0)>>3];c[vc>>2]=2;rd=td*sd*+h[(EA(od,1,vc)|0)>>3];c[uc>>2]=19;h[(EA(od,1,uc)|0)>>3]=rd;c[tc>>2]=1;rd=+h[(EA(od,1,tc)|0)>>3];c[sc>>2]=18;sd=+h[(EA(od,1,sc)|0)>>3];c[rc>>2]=2;td=rd*sd*pd*+h[(EA(od,1,rc)|0)>>3];c[qc>>2]=20;h[(EA(od,1,qc)|0)>>3]=td;c[pc>>2]=18;td=+h[(EA(od,1,pc)|0)>>3];c[oc>>2]=5;sd=td*+h[(EA(od,1,oc)|0)>>3];c[nc>>2]=21;h[(EA(od,1,nc)|0)>>3]=sd;c[mc>>2]=1;sd=+h[(EA(od,1,mc)|0)>>3];c[lc>>2]=18;td=+h[(EA(od,1,lc)|0)>>3];c[kc>>2]=5;rd=sd*td*+h[(EA(od,1,kc)|0)>>3];c[jc>>2]=22;h[(EA(od,1,jc)|0)>>3]=rd;c[ic>>2]=2;rd=+h[(EA(od,1,ic)|0)>>3]*.25116816848616;c[hc>>2]=23;h[(EA(od,1,hc)|0)>>3]=rd;c[gc>>2]=23;rd=+h[(EA(od,1,gc)|0)>>3]+.078841073758308;c[fc>>2]=24;h[(EA(od,1,fc)|0)>>3]=rd;c[ec>>2]=15;rd=+h[(EA(od,1,ec)|0)>>3];c[dc>>2]=24;td=rd*+h[(EA(od,1,dc)|0)>>3];c[cc>>2]=25;h[(EA(od,1,cc)|0)>>3]=td;c[bc>>2]=25;td=+h[(EA(od,1,bc)|0)>>3]+-6.100523451393;c[ac>>2]=26;h[(EA(od,1,ac)|0)>>3]=td;c[$b>>2]=26;td=pd*+h[(EA(od,1,$b)|0)>>3];c[_b>>2]=27;h[(EA(od,1,_b)|0)>>3]=td;c[Zb>>2]=27;td=+h[(EA(od,1,Zb)|0)>>3]+9.7944563083754;c[Yb>>2]=28;h[(EA(od,1,Yb)|0)>>3]=td;c[Xb>>2]=2;td=+h[(EA(od,1,Xb)|0)>>3];c[Wb>>2]=28;rd=td*+h[(EA(od,1,Wb)|0)>>3];c[Vb>>2]=29;h[(EA(od,1,Vb)|0)>>3]=rd;c[Ub>>2]=29;rd=+h[(EA(od,1,Ub)|0)>>3]+-1.70429417648412;c[Tb>>2]=30;h[(EA(od,1,Tb)|0)>>3]=rd;c[Sb>>2]=1;rd=+h[(EA(od,1,Sb)|0)>>3];c[Rb>>2]=30;td=rd*+h[(EA(od,1,Rb)|0)>>3];c[Qb>>2]=31;h[(EA(od,1,Qb)|0)>>3]=td;c[Pb>>2]=32;h[(EA(od,1,Pb)|0)>>3]=qd*qd;c[Ob>>2]=1;td=+h[(EA(od,1,Ob)|0)>>3]*-10.9153200808732;c[Nb>>2]=33;h[(EA(od,1,Nb)|0)>>3]=td;c[Mb>>2]=33;td=+h[(EA(od,1,Mb)|0)>>3]+13.2781565976477;c[Lb>>2]=34;h[(EA(od,1,Lb)|0)>>3]=td;c[Kb>>2]=34;td=+h[(EA(od,1,Kb)|0)>>3];c[Jb>>2]=7;rd=td*+h[(EA(od,1,Jb)|0)>>3];c[Ib>>2]=35;h[(EA(od,1,Ib)|0)>>3]=rd;c[Hb>>2]=35;rd=+h[(EA(od,1,Hb)|0)>>3]+-6.9146446840086;c[Gb>>2]=36;h[(EA(od,1,Gb)|0)>>3]=rd;c[Fb>>2]=2;rd=+h[(EA(od,1,Fb)|0)>>3];c[Eb>>2]=36;td=rd*+h[(EA(od,1,Eb)|0)>>3];c[Db>>2]=37;h[(EA(od,1,Db)|0)>>3]=td;c[Cb>>2]=37;td=+h[(EA(od,1,Cb)|0)>>3]+-2.5308630955428;c[Bb>>2]=38;h[(EA(od,1,Bb)|0)>>3]=td;c[Ab>>2]=38;td=pd*+h[(EA(od,1,Ab)|0)>>3];c[zb>>2]=39;h[(EA(od,1,zb)|0)>>3]=td;c[yb>>2]=18;td=+h[(EA(od,1,yb)|0)>>3];c[xb>>2]=5;rd=td*pd*+h[(EA(od,1,xb)|0)>>3];c[wb>>2]=40;h[(EA(od,1,wb)|0)>>3]=rd;if(!(qd>0.0)){wb=c[27736]|0;xb=vb;h[k>>3]=qd;c[xb>>2]=c[k>>2];c[xb+4>>2]=c[k+4>>2];xb=wb;wb=g;yb=7928;c[wb+0>>2]=c[yb+0>>2];c[wb+4>>2]=c[yb+4>>2];c[wb+8>>2]=c[yb+8>>2];c[wb+12>>2]=c[yb+12>>2];c[wb+16>>2]=c[yb+16>>2];c[wb+20>>2]=c[yb+20>>2];Le[xb&63](b,g,6512,vb);}c[ub>>2]=3;rd=+h[(EA(od,1,ub)|0)>>3];c[tb>>2]=4;td=+h[(EA(od,1,tb)|0)>>3];c[sb>>2]=1;sd=+h[(EA(od,1,sb)|0)>>3];c[rb>>2]=6;ud=pd*(pd*(rd*(td*(sd*(+h[(EA(od,1,rb)|0)>>3]*-.0084566812812502+1.2053369696517)+-2.808078114862)+2.6185947787954)+-7.6867707878716)+20.944396974307);c[qb>>2]=14;sd=+h[(EA(od,1,qb)|0)>>3];c[pb>>2]=1;td=+h[(EA(od,1,pb)|0)>>3];c[ob>>2]=2;rd=+h[(EA(od,1,ob)|0)>>3];c[nb>>2]=15;vd=+h[(EA(od,1,nb)|0)>>3];c[mb>>2]=2;wd=td*(rd*(pd*(vd*(+h[(EA(od,1,mb)|0)>>3]*.12558408424308+.039420536879154)+-3.0502617256965)+4.8972281541877)+-.85214708824206);c[lb>>2]=1;vd=+h[(EA(od,1,lb)|0)>>3];c[kb>>2]=1;rd=+h[(EA(od,1,kb)|0)>>3];c[jb>>2]=16;td=+h[(EA(od,1,jb)|0)>>3];c[ib>>2]=17;xd=vd*(rd*(td*(+h[(EA(od,1,ib)|0)>>3]*-.47596035734923+-.0082147637173963)+-2.018991502357)+1.389979956946);c[hb>>2]=1;td=+h[(EA(od,1,hb)|0)>>3];c[gb>>2]=1;rd=+h[(EA(od,1,gb)|0)>>3];c[fb>>2]=19;vd=td*(rd*(+h[(EA(od,1,fb)|0)>>3]*.70522450087967+.90572070719733)+-.44476435428739);c[eb>>2]=1;rd=+h[(EA(od,1,eb)|0)>>3];c[db>>2]=21;td=rd*(+h[(EA(od,1,db)|0)>>3]*.16436278447961+.094260751665092);c[cb>>2]=1;rd=+h[(EA(od,1,cb)|0)>>3]*-.013503372241348;c[bb>>2]=22;yd=+h[(EA(od,1,bb)|0)>>3]*-.014834345352472;c[ab>>2]=1;zd=+h[(EA(od,1,ab)|0)>>3];c[$a>>2]=21;Ad=zd*(+h[(EA(od,1,$a)|0)>>3]*.0032308904703711+.00057922953628084);c[_a>>2]=22;zd=qd*(td+qd*(rd+qd*(yd+qd*(Ad+qd*(pd*-.00016557679795037+qd*+h[(EA(od,1,_a)|0)>>3]*-44923899061815.0e-18+80964802996215.0e-18))))+-.022175400873096);c[Za>>2]=1;Ad=+h[(EA(od,1,Za)|0)>>3];c[Ya>>2]=20;yd=ud+(+da(+qd)*1.0658070028513+qd*(sd+qd*(wd+qd*(xd+qd*(vd+qd*(pd*(Ad*(+h[(EA(od,1,Ya)|0)>>3]*-.50871062041158+-.32913623258954)+.10770512626332)+zd)+.0439840744735)+-.2799932969871)+.38493460186671)))+-15.732845290239;c[Xa>>2]=14;zd=+h[(EA(od,1,Xa)|0)>>3];c[Wa>>2]=31;Ad=+h[(EA(od,1,Wa)|0)>>3];c[Va>>2]=1;vd=+h[(EA(od,1,Va)|0)>>3];c[Ua>>2]=1;xd=+h[(EA(od,1,Ua)|0)>>3];c[Ta>>2]=16;wd=+h[(EA(od,1,Ta)|0)>>3];c[Sa>>2]=17;sd=vd*(xd*(wd*(+h[(EA(od,1,Sa)|0)>>3]*-1.42788107204769+-.0246442911521889)+-6.056974507071)+4.169939870838);c[Ra>>2]=1;wd=+h[(EA(od,1,Ra)|0)>>3];c[Qa>>2]=1;xd=+h[(EA(od,1,Qa)|0)>>3];c[Pa>>2]=19;vd=wd*(xd*(+h[(EA(od,1,Pa)|0)>>3]*2.82089800351868+3.6228828287893)+-1.77905741714956);c[Oa>>2]=1;xd=+h[(EA(od,1,Oa)|0)>>3];c[Na>>2]=21;wd=xd*(+h[(EA(od,1,Na)|0)>>3]*.98617670687766+.56556450999055);c[Ma>>2]=1;xd=+h[(EA(od,1,Ma)|0)>>3]*-.094523605689436;c[La>>2]=22;ud=+h[(EA(od,1,La)|0)>>3]*-.118674762819776;c[Ka>>2]=1;rd=+h[(EA(od,1,Ka)|0)>>3];c[Ja>>2]=21;td=rd*(+h[(EA(od,1,Ja)|0)>>3]*.0290780142333399+.0052130658265276);c[Ia>>2]=22;rd=qd*(wd+qd*(xd+qd*(ud+qd*(td+qd*(pd*-.0016557679795037+qd*+h[(EA(od,1,Ia)|0)>>3]*-.00049416288967996+.00080964802996215))))+-.133052405238576);c[Ha>>2]=1;td=+h[(EA(od,1,Ha)|0)>>3];c[Ga>>2]=20;ud=(qd*(zd+qd*(Ad+qd*(sd+qd*(vd+qd*(pd*(td*(+h[(EA(od,1,Ga)|0)>>3]*-2.5435531020579+-1.6456811629477)+.5385256313166)+rd)+.175936297894)+-.8399798909613)+.76986920373342))+1.0658070028513)/qd;c[Fa>>2]=32;rd=+h[(EA(od,1,Fa)|0)>>3];c[Ea>>2]=31;td=+h[(EA(od,1,Ea)|0)>>3];c[Da>>2]=1;vd=+h[(EA(od,1,Da)|0)>>3];c[Ca>>2]=1;sd=+h[(EA(od,1,Ca)|0)>>3];c[Ba>>2]=16;Ad=+h[(EA(od,1,Ba)|0)>>3];c[Aa>>2]=17;zd=vd*(sd*(Ad*(+h[(EA(od,1,Aa)|0)>>3]*-2.85576214409538+-.049288582304378)+-12.113949014142)+8.339879741676);c[za>>2]=1;Ad=+h[(EA(od,1,za)|0)>>3];c[ya>>2]=1;sd=+h[(EA(od,1,ya)|0)>>3];c[xa>>2]=19;vd=Ad*(sd*(+h[(EA(od,1,xa)|0)>>3]*8.462694010556+10.868648486368)+-5.3371722514487);c[wa>>2]=1;sd=+h[(EA(od,1,wa)|0)>>3];c[va>>2]=21;Ad=sd*(+h[(EA(od,1,va)|0)>>3]*4.9308835343883+2.82782254995276);c[ua>>2]=1;sd=+h[(EA(od,1,ua)|0)>>3]*-.56714163413662;c[ta>>2]=22;xd=+h[(EA(od,1,ta)|0)>>3]*-.83072333973843;c[sa>>2]=1;wd=+h[(EA(od,1,sa)|0)>>3];c[ra>>2]=21;Bd=wd*(+h[(EA(od,1,ra)|0)>>3]*.232624113866719+.04170452661222);c[qa>>2]=22;wd=qd*(Ad+qd*(sd+qd*(xd+qd*(Bd+qd*(pd*-.0149019118155333+qd*+h[(EA(od,1,qa)|0)>>3]*-.0049416288967996+.0072868322696594))))+-.66526202619288);c[pa>>2]=1;Bd=+h[(EA(od,1,pa)|0)>>3];c[oa>>2]=20;xd=rd*(td+qd*(zd+qd*(vd+qd*(pd*(Bd*(+h[(EA(od,1,oa)|0)>>3]*-10.1742124082316+-6.5827246517908)+2.1541025252664)+wd)+.527808893682)+-1.6799597819226)+.76986920373342)+-1.0658070028513;c[na>>2]=32;wd=xd/+h[(EA(od,1,na)|0)>>3];c[ma>>2]=3;xd=+h[(EA(od,1,ma)|0)>>3];c[la>>2]=4;Bd=+h[(EA(od,1,la)|0)>>3];c[ka>>2]=1;vd=+h[(EA(od,1,ka)|0)>>3];c[ja>>2]=6;zd=pd*(xd*(Bd*(vd*(+h[(EA(od,1,ja)|0)>>3]*-.194503669468755+14.4640436358204)+-28.08078114862)+18.3301634515678)+-15.3735415757432);c[ia>>2]=39;vd=+h[(EA(od,1,ia)|0)>>3];c[ha>>2]=2;Bd=+h[(EA(od,1,ha)|0)>>3];c[ga>>2]=15;xd=+h[(EA(od,1,ga)|0)>>3];c[fa>>2]=2;td=pd*(Bd*(pd*(xd*(+h[(EA(od,1,fa)|0)>>3]*3.2651861903201+.86725181134139)+-21.3518320798755)+29.3833689251262)+-1.70429417648412);c[ea>>2]=1;xd=+h[(EA(od,1,ea)|0)>>3];c[ca>>2]=16;Bd=+h[(EA(od,1,ca)|0)>>3];c[ba>>2]=17;rd=pd*(xd*(Bd*(+h[(EA(od,1,ba)|0)>>3]*-12.37496929108+-.131436219478341)+-8.075966009428)+2.779959913892);c[aa>>2]=1;Bd=+h[(EA(od,1,aa)|0)>>3];c[$>>2]=19;xd=pd*(Bd*(+h[(EA(od,1,$)|0)>>3]*18.3358370228714+3.6228828287893)+-.88952870857478);c[_>>2]=1;Bd=+h[(EA(od,1,_)|0)>>3];c[Z>>2]=20;sd=Bd*(+h[(EA(od,1,Z)|0)>>3]*-13.2264761307011+-.98740869776862);c[Y>>2]=21;Bd=pd*(+h[(EA(od,1,Y)|0)>>3]*4.2734323964699+.188521503330184);c[X>>2]=40;Ad=+h[(EA(od,1,X)|0)>>3]*-.38569297916427;c[W>>2]=40;Cd=qd*(qd*+h[(EA(od,1,W)|0)>>3]*-.00116802137560719+-.00016557679795037);c[V>>2]=21;Dd=zd+qd*(vd+qd*(td+qd*(rd+qd*(xd+qd*(sd+qd*(Bd+qd*(pd*-.027006744482696+qd*(Ad+qd*(Cd+pd*(+h[(EA(od,1,V)|0)>>3]*.084003152229649+.00115845907256168)))))+.10770512626332)))))+20.944396974307;c[T>>2]=3;Cd=+h[(EA(od,1,T)|0)>>3];c[S>>2]=4;Ad=+h[(EA(od,1,S)|0)>>3];c[R>>2]=1;Bd=+h[(EA(od,1,R)|0)>>3];c[Q>>2]=6;sd=Cd*(Ad*(Bd*(+h[(EA(od,1,Q)|0)>>3]*-4.2790807283126+159.104479994024)+-252.72703033758)+109.980980709407);c[P>>2]=2;Bd=+h[(EA(od,1,P)|0)>>3];c[O>>2]=1;Ad=+h[(EA(od,1,O)|0)>>3]*-174.645121293971+185.894192367068;c[N>>2]=7;Cd=Bd*(Ad*+h[(EA(od,1,N)|0)>>3]+-34.573223420043);c[M>>2]=2;Ad=+h[(EA(od,1,M)|0)>>3];c[L>>2]=15;Bd=+h[(EA(od,1,L)|0)>>3];c[K>>2]=2;xd=Ad*(pd*(Bd*(+h[(EA(od,1,K)|0)>>3]*81.629654758002+18.2122880381691)+-128.110992479253)+146.916844625631);c[J>>2]=1;Bd=+h[(EA(od,1,J)|0)>>3];c[I>>2]=16;Ad=+h[(EA(od,1,I)|0)>>3];c[H>>2]=17;rd=Bd*(Ad*(+h[(EA(od,1,H)|0)>>3]*-309.374232277+-1.97154329217511)+-24.227898028284);c[G>>2]=1;Ad=+h[(EA(od,1,G)|0)>>3];c[F>>2]=19;Bd=Ad*(+h[(EA(od,1,F)|0)>>3]*458.39592557179+10.868648486368);c[E>>2]=21;Ad=+h[(EA(od,1,E)|0)>>3]*106.835809911747;c[D>>2]=21;td=+h[(EA(od,1,D)|0)>>3]*-9.6423244791068;c[C>>2]=21;vd=+h[(EA(od,1,C)|0)>>3]*2.10007880574121;c[B>>2]=21;zd=+h[(EA(od,1,B)|0)>>3];c[A>>2]=32;Ed=qd*(Ad+qd*(qd*(td+qd*(vd+zd*+h[(EA(od,1,A)|0)>>3]*-.0292005343901797+.00115845907256168))+-.027006744482696)+.188521503330184);c[z>>2]=20;zd=sd+qd*(Cd+qd*(xd+qd*(rd+qd*(Bd+qd*(pd*(+h[(EA(od,1,z)|0)>>3]*-330.66190326753+-1.97481739553724)+Ed)+-.88952870857478)+2.779959913892)+-1.70429417648412)+-2.5308630955428)+-15.3735415757432;c[y>>2]=39;Ed=+h[(EA(od,1,y)|0)>>3];c[x>>2]=2;Bd=+h[(EA(od,1,x)|0)>>3];c[w>>2]=15;rd=+h[(EA(od,1,w)|0)>>3];c[v>>2]=2;xd=pd*(Bd*(pd*(rd*(+h[(EA(od,1,v)|0)>>3]*6.5303723806402+1.73450362268278)+-42.703664159751)+58.766737850252)+-3.4085883529682);c[u>>2]=1;rd=+h[(EA(od,1,u)|0)>>3];c[t>>2]=16;Bd=+h[(EA(od,1,t)|0)>>3];c[s>>2]=17;Cd=pd*(rd*(Bd*(+h[(EA(od,1,s)|0)>>3]*-37.12490787324+-.39430865843502)+-24.227898028284)+8.339879741676);c[r>>2]=1;Bd=+h[(EA(od,1,r)|0)>>3];c[q>>2]=19;rd=pd*(Bd*(+h[(EA(od,1,q)|0)>>3]*73.343348091486+14.4915313151573)+-3.5581148342991);c[p>>2]=1;Bd=+h[(EA(od,1,p)|0)>>3];c[o>>2]=20;sd=Bd*(+h[(EA(od,1,o)|0)>>3]*-66.132380653505+-4.9370434888431);c[n>>2]=21;Bd=pd*(+h[(EA(od,1,n)|0)>>3]*25.6405943788192+1.1311290199811);c[m>>2]=40;vd=+h[(EA(od,1,m)|0)>>3]*-3.08554383331418;c[l>>2]=40;td=qd*(qd*+h[(EA(od,1,l)|0)>>3]*-.0128482351316791+-.0016557679795037);c[j>>2]=21;Ad=Ed+qd*(xd+qd*(Cd+qd*(rd+qd*(sd+qd*(Bd+qd*(pd*-.189047211378872+qd*(vd+qd*(td+pd*(+h[(EA(od,1,j)|0)>>3]*.75602837006684+.0104261316530551)))))+.5385256313166))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=qd;h[a+32>>3]=pd;h[a+40>>3]=yd;h[a+48>>3]=ud;h[a+56>>3]=wd;h[a+64>>3]=Dd;h[a+72>>3]=zd;h[a+80>>3]=Ad;i=f;return}function Lh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;d=+h[c+16>>3];e=+h[c>>3];f=+h[c+8>>3];g=+h[c+24>>3];j=+h[c+48>>3];k=g*j;l=+h[c+32>>3];m=l*+h[c+64>>3];n=d*(m- +h[c+40>>3]);o=g*(j-l*+h[c+80>>3]);p=l*l*+h[c+72>>3];l=+h[c+56>>3];h[a>>3]=e;h[a+8>>3]=d*f*(k+m);h[a+16>>3]=d*f*m;h[a+24>>3]=n;h[a+32>>3]=d*(o*o/(k*2.0+g*g*l)-p);h[a+40>>3]=-(d*p);h[a+48>>3]=d*e*o;h[a+56>>3]=d*f*g*(j*2.0+g*l);i=i;return}function Mh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;d=+h[c>>3];e=+h[c+48>>3];f=+h[c+24>>3];g=e*f;j=+h[c+8>>3];k=+h[c+16>>3];l=+h[c+32>>3];m=l*+h[c+64>>3];n=k*(m- +h[c+40>>3]);o=l*l*+h[c+72>>3];p=e-l*+h[c+80>>3];l=+h[c+56>>3];h[a>>3]=d/(g*j*k);h[a+8>>3]=k*j*m;h[a+16>>3]=j*k*(m-g);h[a+24>>3]=n;h[a+32>>3]=-(k*o);h[a+40>>3]=k*(p*p/l-o);h[a+48>>3]=-(d*(p/(l*f*j)));h[a+56>>3]=-(k*j*(e*e/l));i=i;return}function Nh(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;var j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;j=+h[c>>3];k=+h[d>>3];if(j!=k){l=j*(k/(j-k))}else{l=0.0}m=l*(+h[d+24>>3]- +h[c+24>>3]);n=+h[c+48>>3];o=(n-m)/(j*j*+h[c+56>>3]);j=+h[d+48>>3];p=(j-m)/(k*k*+h[d+56>>3]);k=(n*f-g)*o+ +h[c+40>>3];h[a>>3]=k+(((j*f-g)*p+ +h[d+40>>3]-k)*e-l*(o+(p-o)*e)*(+h[d+16>>3]- +h[c+16>>3]));i=i;return}function Oh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=33;wA(k,1,j);j=k;k=6576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=33;wA(l,1,g);g=l;l=6592;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=33;wA(m,1,f);f=m;m=6608;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/28.0e5+-.72;e=n*n;o=d/1.0e8+.298;d=o*o;p=32325457364492.0e-18/+oB(o,12);q=n*+oB(o,-12)*-.000127575556587181;r=-.000475851877356068/+oB(o,10);s=n*+oB(o,-10)*.00156183014181602;t=+oB(o,-10);u=t*+oB(n,5)*.105724860113781;t=+oB(o,-10);v=t*+oB(n,10)*-85.8514221132534;t=+oB(o,-10);w=t*+oB(n,12)*724.140095480911;t=.00296475810273257/+oB(o,8);x=n*+oB(o,-8)*-.00592721983365988;y=e*+oB(o,-8)*-.0126305422818666;z=e*e;A=z*+oB(o,-8)*-.115716196364853;B=+oB(o,-8);C=B*+oB(n,10)*84.9000969739595;B=-.0108602260086615/+oB(o,6);D=n*+oB(o,-6)*.0154304475328851;E=e*+oB(o,-6)*.0750455441524466;F=n*+oB(o,-4)*-.0602507901232996;G=+oB(o,-3);H=G*+oB(n,5)*-3.07622221350501;G=z*+oB(o,-2)*5.03471360939849;I=+oB(n,6)/o*-77.314600713019;J=+oB(n,10)/o*9493.08762098587;K=+oB(n,14)/o*-1410437.19679409;L=+oB(n,16)/o*8491662.30819026;M=n*+oB(o,5)*.286596714529479;N=n*+oB(o,6)*-.131778331276228;h[a>>3]=(p+(q+(r+(s+(u+(v+(w+(t+(x+(y+(A+(C+(B+(D+(E+(.0252520973612982/(d*d)+(F+(H+(-.0574011959864879/d+(G+(e/o*-.925081888584834+(z/o*3.91733882917546+(I+(J+(K+(L+(e*.32334644281172+(o*n*.873281936020439+(n*o*d*-.436653048526683+(M+(N+n*+oB(o,8)*.00676682064330275))))))))))))))))))))))))))))))+.861095729446704)*860.0;i=b;return}function Ph(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=31;wA(k,1,j);j=k;k=6624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=31;wA(l,1,g);g=l;l=6640;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=31;wA(m,1,f);f=m;m=6656;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/23.0e5+-.615;e=n*n;o=d/1.0e8+.24;d=o*o;p=-1.33645667811215e-7/+oB(o,12);q=n*+oB(o,-12)*455912656802978.0e-20;r=e*+oB(o,-12)*-146294640700979.0e-19;s=+oB(o,-12);t=s*+oB(n,6)*.0063934131297008;s=+oB(o,-12);u=s*+oB(n,14)*372.783927268847;s=+oB(o,-12);v=s*+oB(n,16)*-7186.54377460447;s=+oB(o,-12);w=s*+oB(n,20)*573494.7521034;s=+oB(o,-12);x=s*+oB(n,22)*-2675693.29111439;s=n*+oB(o,-10)*-334066283302614.0e-19;y=+oB(o,-10);z=y*+oB(n,5)*-.0245479214069597;y=+oB(o,-10);A=y*+oB(n,12)*47.8087847764996;y=764664131818904.0e-20/+oB(o,8);B=e*+oB(o,-8)*.00128350627676972;C=e*e;D=C*+oB(o,-8)*.0171219081377331;E=+oB(o,-8);F=E*+oB(n,10)*-8.51007304583213;E=e*+oB(o,-5)*-.0136513461629781;G=o*d;H=n*+oB(o,-2)*.00337423807911655;I=n*e;J=I*+oB(o,-2)*-.551624873066791;K=C*+oB(o,-2)*.72920227710747;L=d*d;d=C*+oB(o,10)*.0136176427574291;C=+oB(o,12);h[a>>3]=(p+(q+(r+(t+(u+(v+(w+(x+(s+(z+(A+(y+(B+(D+(F+(E+(-384460997596657.0e-20/G+(H+(J+(K+(-.00992522757376041/o+(e/o*-.119308831407288+(n*.454270731799386+(o*n*.20999859125991+(G*-.00642109823904738+(n*G*-.023515586860454+(L*.00252233108341612+(L*I*-.00764885133368119+(d+C*+oB(n,5)*-.0133027883575669))))))))))))))))))))))))))))+.793929190615421)*760.0;i=b;return}function Qh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;c[Wa>>2]=31;wA(Xa,1,Wa);Ya=+vd(+d,647.096);c[Va>>2]=1;h[(EA(Xa,1,Va)|0)>>3]=Ya+-650.17534844798;c[Ua>>2]=1;d=1.0/+h[(EA(Xa,1,Ua)|0)>>3];c[Ta>>2]=2;h[(EA(Xa,1,Ta)|0)>>3]=d;c[Sa>>2]=2;d=+h[(EA(Xa,1,Sa)|0)>>3]*-.23855557567849;c[Ra>>2]=3;h[(EA(Xa,1,Ra)|0)>>3]=d;c[Qa>>2]=3;d=Ya+ +h[(EA(Xa,1,Qa)|0)>>3];c[Pa>>2]=4;h[(EA(Xa,1,Pa)|0)>>3]=d;c[Oa>>2]=4;d=+h[(EA(Xa,1,Oa)|0)>>3]*-4823.2657361591;c[Na>>2]=5;h[(EA(Xa,1,Na)|0)>>3]=d;c[Ma>>2]=4;d=+h[(EA(Xa,1,Ma)|0)>>3];c[La>>2]=6;h[(EA(Xa,1,La)|0)>>3]=d*d;c[Ka>>2]=6;d=+h[(EA(Xa,1,Ka)|0)>>3]*14.91510861353;c[Ja>>2]=7;h[(EA(Xa,1,Ja)|0)>>3]=d;c[Ia>>2]=5;d=+h[(EA(Xa,1,Ia)|0)>>3];c[Ha>>2]=7;Ya=d+ +h[(EA(Xa,1,Ha)|0)>>3]+405113.40542057;c[Ga>>2]=8;h[(EA(Xa,1,Ga)|0)>>3]=Ya;c[Fa>>2]=8;Ya=+h[(EA(Xa,1,Fa)|0)>>3];c[Ea>>2]=9;h[(EA(Xa,1,Ea)|0)>>3]=Ya*Ya;c[Da>>2]=9;Ya=+h[(EA(Xa,1,Da)|0)>>3];c[Ca>>2]=10;h[(EA(Xa,1,Ca)|0)>>3]=Ya*Ya;c[Ba>>2]=1;Ya=+h[(EA(Xa,1,Ba)|0)>>3];c[Aa>>2]=11;h[(EA(Xa,1,Aa)|0)>>3]=Ya*Ya;c[za>>2]=11;Ya=1.0/+h[(EA(Xa,1,za)|0)>>3];c[ya>>2]=12;h[(EA(Xa,1,ya)|0)>>3]=Ya;c[xa>>2]=12;Ya=+h[(EA(Xa,1,xa)|0)>>3]*.23855557567849;c[wa>>2]=13;h[(EA(Xa,1,wa)|0)>>3]=Ya;c[va>>2]=13;Ya=+h[(EA(Xa,1,va)|0)>>3]+1.0;c[ua>>2]=14;h[(EA(Xa,1,ua)|0)>>3]=Ya;c[ta>>2]=4;Ya=+h[(EA(Xa,1,ta)|0)>>3]*12020.82470247;c[sa>>2]=15;h[(EA(Xa,1,sa)|0)>>3]=Ya;c[ra>>2]=6;Ya=+h[(EA(Xa,1,ra)|0)>>3]*-17.073846940092;c[qa>>2]=16;h[(EA(Xa,1,qa)|0)>>3]=Ya;c[pa>>2]=15;Ya=+h[(EA(Xa,1,pa)|0)>>3];c[oa>>2]=16;d=Ya+ +h[(EA(Xa,1,oa)|0)>>3]+-3232555.0322333;c[na>>2]=17;h[(EA(Xa,1,na)|0)>>3]=d;c[ma>>2]=14;d=+h[(EA(Xa,1,ma)|0)>>3]*-4823.2657361591;c[la>>2]=18;h[(EA(Xa,1,la)|0)>>3]=d;c[ka>>2]=14;d=+h[(EA(Xa,1,ka)|0)>>3];c[ja>>2]=4;Ya=d*+h[(EA(Xa,1,ja)|0)>>3]*29.83021722706;c[ia>>2]=19;h[(EA(Xa,1,ia)|0)>>3]=Ya;c[ha>>2]=18;Ya=+h[(EA(Xa,1,ha)|0)>>3];c[ga>>2]=19;d=Ya+ +h[(EA(Xa,1,ga)|0)>>3];c[fa>>2]=20;h[(EA(Xa,1,fa)|0)>>3]=d;c[ea>>2]=4;d=+h[(EA(Xa,1,ea)|0)>>3]*1167.0521452767;c[da>>2]=21;h[(EA(Xa,1,da)|0)>>3]=d;c[ca>>2]=21;d=+h[(EA(Xa,1,ca)|0)>>3];c[ba>>2]=6;Ya=d+ +h[(EA(Xa,1,ba)|0)>>3]+-724213.16703206;c[aa>>2]=22;h[(EA(Xa,1,aa)|0)>>3]=Ya;c[$>>2]=17;Ya=+h[(EA(Xa,1,$)|0)>>3];c[_>>2]=23;h[(EA(Xa,1,_)|0)>>3]=Ya*Ya;c[Z>>2]=22;Ya=+h[(EA(Xa,1,Z)|0)>>3];c[Y>>2]=8;d=Ya*+h[(EA(Xa,1,Y)|0)>>3]*-4.0;c[X>>2]=24;h[(EA(Xa,1,X)|0)>>3]=d;c[W>>2]=23;d=+h[(EA(Xa,1,W)|0)>>3];c[U>>2]=24;Ya=d+ +h[(EA(Xa,1,U)|0)>>3];c[T>>2]=25;h[(EA(Xa,1,T)|0)>>3]=Ya;c[S>>2]=25;Ya=+h[(EA(Xa,1,S)|0)>>3];if(!(Ya>=0.0)){S=c[27736]|0;T=R;h[k>>3]=Ya;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S;S=f;U=7928;c[S+0>>2]=c[U+0>>2];c[S+4>>2]=c[U+4>>2];c[S+8>>2]=c[U+8>>2];c[S+12>>2]=c[U+12>>2];c[S+16>>2]=c[U+16>>2];c[S+20>>2]=c[U+20>>2];Le[T&63](b,f,6672,R);}d=+V(+Ya);c[Q>>2]=26;h[(EA(Xa,1,Q)|0)>>3]=d;c[P>>2]=4;d=+h[(EA(Xa,1,P)|0)>>3]*-12020.82470247;c[O>>2]=27;h[(EA(Xa,1,O)|0)>>3]=d;c[N>>2]=6;d=+h[(EA(Xa,1,N)|0)>>3]*17.073846940092;c[M>>2]=28;h[(EA(Xa,1,M)|0)>>3]=d;c[L>>2]=26;d=+h[(EA(Xa,1,L)|0)>>3];c[K>>2]=27;Ya=+h[(EA(Xa,1,K)|0)>>3];c[J>>2]=28;Za=d+(Ya+ +h[(EA(Xa,1,J)|0)>>3])+3232555.0322333;c[I>>2]=29;h[(EA(Xa,1,I)|0)>>3]=Za;c[H>>2]=29;Za=+h[(EA(Xa,1,H)|0)>>3];c[G>>2]=30;h[(EA(Xa,1,G)|0)>>3]=Za*Za;c[F>>2]=30;Za=+h[(EA(Xa,1,F)|0)>>3];c[E>>2]=31;h[(EA(Xa,1,E)|0)>>3]=Za*Za;c[D>>2]=10;Za=+h[(EA(Xa,1,D)|0)>>3];c[C>>2]=14;Ya=+h[(EA(Xa,1,C)|0)>>3]*-12020.82470247;c[B>>2]=14;d=+h[(EA(Xa,1,B)|0)>>3];c[A>>2]=4;_a=d*+h[(EA(Xa,1,A)|0)>>3]*34.147693880184;c[z>>2]=20;d=+h[(EA(Xa,1,z)|0)>>3];c[y>>2]=22;$a=d*+h[(EA(Xa,1,y)|0)>>3]*-4.0;c[x>>2]=17;d=+h[(EA(Xa,1,x)|0)>>3];c[w>>2]=14;ab=+h[(EA(Xa,1,w)|0)>>3]*12020.82470247;c[v>>2]=14;bb=+h[(EA(Xa,1,v)|0)>>3];c[u>>2]=4;cb=d*(ab+bb*+h[(EA(Xa,1,u)|0)>>3]*-34.147693880184)*2.0;c[t>>2]=14;bb=+h[(EA(Xa,1,t)|0)>>3]*1167.0521452767;c[s>>2]=14;ab=+h[(EA(Xa,1,s)|0)>>3];c[r>>2]=4;d=bb+ab*+h[(EA(Xa,1,r)|0)>>3]*2.0;c[q>>2]=8;ab=$a+(cb+ +h[(EA(Xa,1,q)|0)>>3]*d*-4.0);c[p>>2]=26;d=Ya+(_a+ab/+h[(EA(Xa,1,p)|0)>>3]*.5);c[o>>2]=31;ab=+h[(EA(Xa,1,o)|0)>>3];c[n>>2]=29;_a=Za*(d/(ab*+h[(EA(Xa,1,n)|0)>>3]))*-64.0;c[m>>2]=20;ab=+h[(EA(Xa,1,m)|0)>>3];c[l>>2]=8;d=+h[(EA(Xa,1,l)|0)>>3];c[j>>2]=9;Za=+h[(EA(Xa,1,j)|0)>>3];c[g>>2]=31;h[a>>3]=(_a+ab*d*(Za/+h[(EA(Xa,1,g)|0)>>3])*64.0)*1.0e6;i=e;return}function Rh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+16|0;c[H>>2]=8;wA(I,1,H);J=+vd(+d,647.096);if(!(d>=273.16)){H=c[27736]|0;K=f;L=6736;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];c[K+16>>2]=c[L+16>>2];c[K+20>>2]=c[L+20>>2];Le[H&63](b,f,6760,G);}c[F>>2]=1;h[(EA(I,1,F)|0)>>3]=J+-650.17534844798;c[E>>2]=1;d=1.0/+h[(EA(I,1,E)|0)>>3];c[D>>2]=2;h[(EA(I,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(EA(I,1,C)|0)>>3]*-.23855557567849;c[B>>2]=3;h[(EA(I,1,B)|0)>>3]=d;c[A>>2]=3;d=J+ +h[(EA(I,1,A)|0)>>3];c[z>>2]=4;h[(EA(I,1,z)|0)>>3]=d;c[y>>2]=4;d=+h[(EA(I,1,y)|0)>>3]*-4823.2657361591;c[x>>2]=5;h[(EA(I,1,x)|0)>>3]=d;c[w>>2]=4;d=+h[(EA(I,1,w)|0)>>3];c[v>>2]=6;h[(EA(I,1,v)|0)>>3]=d*d;c[u>>2]=6;d=+h[(EA(I,1,u)|0)>>3]*14.91510861353;c[t>>2]=7;h[(EA(I,1,t)|0)>>3]=d;c[s>>2]=5;d=+h[(EA(I,1,s)|0)>>3];c[r>>2]=7;J=d+ +h[(EA(I,1,r)|0)>>3]+405113.40542057;c[q>>2]=8;h[(EA(I,1,q)|0)>>3]=J;c[p>>2]=4;J=+h[(EA(I,1,p)|0)>>3]*12020.82470247;c[o>>2]=6;d=J+ +h[(EA(I,1,o)|0)>>3]*-17.073846940092+-3232555.0322333;c[n>>2]=8;J=+h[(EA(I,1,n)|0)>>3];c[m>>2]=4;M=+h[(EA(I,1,m)|0)>>3]*-12020.82470247;c[l>>2]=6;N=+h[(EA(I,1,l)|0)>>3]*17.073846940092;c[k>>2]=4;O=+h[(EA(I,1,k)|0)>>3]*1167.0521452767;c[j>>2]=6;P=O+ +h[(EA(I,1,j)|0)>>3]+-724213.16703206;c[g>>2]=8;O=J/(M+(N+ +V(+(d*d+P*+h[(EA(I,1,g)|0)>>3]*-4.0)))+3232555.0322333);P=O*O;h[a>>3]=P*P*16.0e6;i=e;return}function Sh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,De=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0.0,eg=0.0,fg=0.0,gg=0.0;f=i;i=i+5696|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;De=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+16|0;c[$f>>2]=55;wA(ag,1,$f);if(!(d>0.0)){$f=gA(gA(6872,eA(d,0,1,6)|0)|0,6936)|0;bg=c[27736]|0;cg=f+96|0;c[cg+0>>2]=c[6952+0>>2];c[cg+4>>2]=c[6952+4>>2];c[cg+8>>2]=c[6952+8>>2];c[cg+12>>2]=c[6952+12>>2];c[cg+16>>2]=c[6952+16>>2];c[cg+20>>2]=c[6952+20>>2];Le[bg&63](b,f+96|0,$f,_f);}if(!(d<=1.0e8)){_f=gA(gA(6976,eA(d,0,1,6)|0)|0,7024)|0;$f=c[27736]|0;bg=f+72|0;c[bg+0>>2]=c[7056+0>>2];c[bg+4>>2]=c[7056+4>>2];c[bg+8>>2]=c[7056+8>>2];c[bg+12>>2]=c[7056+12>>2];c[bg+16>>2]=c[7056+16>>2];c[bg+20>>2]=c[7056+20>>2];Le[$f&63](b,f+72|0,_f,Zf);}if(!(e>=273.15)){Zf=gA(gA(7080,eA(e,0,1,6)|0)|0,7128)|0;_f=c[27736]|0;$f=f+48|0;c[$f+0>>2]=c[7160+0>>2];c[$f+4>>2]=c[7160+4>>2];c[$f+8>>2]=c[7160+8>>2];c[$f+12>>2]=c[7160+12>>2];c[$f+16>>2]=c[7160+16>>2];c[$f+20>>2]=c[7160+20>>2];Le[_f&63](b,f+48|0,Zf,Yf);}if(!(e<=1073.15)){Yf=gA(gA(7184,eA(e,0,1,6)|0)|0,7240)|0;Zf=c[27736]|0;_f=f+24|0;c[_f+0>>2]=c[7288+0>>2];c[_f+4>>2]=c[7288+4>>2];c[_f+8>>2]=c[7288+8>>2];c[_f+12>>2]=c[7288+12>>2];c[_f+16>>2]=c[7288+16>>2];c[_f+20>>2]=c[7288+20>>2];Le[Zf&63](b,f+24|0,Yf,Xf);}dg=540.0/e+-.5;c[Wf>>2]=1;h[(EA(ag,1,Wf)|0)>>3]=dg*dg;c[Vf>>2]=1;eg=dg*+h[(EA(ag,1,Vf)|0)>>3];c[Uf>>2]=2;h[(EA(ag,1,Uf)|0)>>3]=eg;c[Tf>>2]=2;eg=+h[(EA(ag,1,Tf)|0)>>3]*-.05032527872793;c[Sf>>2]=3;h[(EA(ag,1,Sf)|0)>>3]=eg;c[Rf>>2]=3;eg=+h[(EA(ag,1,Rf)|0)>>3]+-.057581259083432;c[Qf>>2]=4;h[(EA(ag,1,Qf)|0)>>3]=eg;c[Pf>>2]=4;eg=dg*+h[(EA(ag,1,Pf)|0)>>3];c[Of>>2]=5;h[(EA(ag,1,Of)|0)>>3]=eg;c[Nf>>2]=5;eg=+h[(EA(ag,1,Nf)|0)>>3]+-.045996013696365;c[Mf>>2]=6;h[(EA(ag,1,Mf)|0)>>3]=eg;c[Lf>>2]=6;eg=dg*+h[(EA(ag,1,Lf)|0)>>3];c[Kf>>2]=7;h[(EA(ag,1,Kf)|0)>>3]=eg;c[Jf>>2]=7;eg=+h[(EA(ag,1,Jf)|0)>>3]+-.017834862292358;c[If>>2]=8;h[(EA(ag,1,If)|0)>>3]=eg;c[Hf>>2]=8;eg=dg*+h[(EA(ag,1,Hf)|0)>>3];c[Gf>>2]=9;h[(EA(ag,1,Gf)|0)>>3]=eg;c[Ff>>2]=1;eg=+h[(EA(ag,1,Ff)|0)>>3];c[Ef>>2]=10;h[(EA(ag,1,Ef)|0)>>3]=eg*eg;c[Df>>2]=10;eg=+h[(EA(ag,1,Df)|0)>>3];c[Cf>>2]=11;h[(EA(ag,1,Cf)|0)>>3]=eg*eg;c[Bf>>2]=11;eg=+h[(EA(ag,1,Bf)|0)>>3];c[Af>>2]=12;h[(EA(ag,1,Af)|0)>>3]=eg*eg;c[zf>>2]=10;eg=+h[(EA(ag,1,zf)|0)>>3];c[yf>>2]=11;fg=+h[(EA(ag,1,yf)|0)>>3];c[xf>>2]=12;gg=eg*fg*dg*+h[(EA(ag,1,xf)|0)>>3];c[wf>>2]=13;h[(EA(ag,1,wf)|0)>>3]=gg;c[vf>>2]=1;gg=+h[(EA(ag,1,vf)|0)>>3];c[uf>>2]=10;fg=gg*dg*+h[(EA(ag,1,uf)|0)>>3];c[tf>>2]=14;h[(EA(ag,1,tf)|0)>>3]=fg;c[sf>>2]=10;fg=+h[(EA(ag,1,sf)|0)>>3];c[rf>>2]=11;gg=fg*dg*+h[(EA(ag,1,rf)|0)>>3];c[qf>>2]=15;h[(EA(ag,1,qf)|0)>>3]=gg;c[pf>>2]=1;gg=+h[(EA(ag,1,pf)|0)>>3];c[of>>2]=12;fg=gg*dg*+h[(EA(ag,1,of)|0)>>3];c[nf>>2]=16;h[(EA(ag,1,nf)|0)>>3]=fg;c[mf>>2]=1;fg=+h[(EA(ag,1,mf)|0)>>3];c[lf>>2]=11;gg=fg*dg*+h[(EA(ag,1,lf)|0)>>3];c[kf>>2]=17;h[(EA(ag,1,kf)|0)>>3]=gg;c[jf>>2]=1;gg=+h[(EA(ag,1,jf)|0)>>3];c[hf>>2]=10;fg=+h[(EA(ag,1,hf)|0)>>3];c[gf>>2]=11;eg=gg*fg*+h[(EA(ag,1,gf)|0)>>3];c[ff>>2]=18;h[(EA(ag,1,ff)|0)>>3]=eg;c[ef>>2]=10;eg=+h[(EA(ag,1,ef)|0)>>3];c[df>>2]=11;fg=+h[(EA(ag,1,df)|0)>>3];c[cf>>2]=12;gg=eg*fg*+h[(EA(ag,1,cf)|0)>>3];c[bf>>2]=19;h[(EA(ag,1,bf)|0)>>3]=gg;c[af>>2]=1;gg=+h[(EA(ag,1,af)|0)>>3];c[$e>>2]=10;fg=gg*+h[(EA(ag,1,$e)|0)>>3];c[_e>>2]=20;h[(EA(ag,1,_e)|0)>>3]=fg;c[Ze>>2]=21;h[(EA(ag,1,Ze)|0)>>3]=d/1.0e6*(d/1.0e6);c[Ye>>2]=21;fg=+h[(EA(ag,1,Ye)|0)>>3];c[Xe>>2]=22;h[(EA(ag,1,Xe)|0)>>3]=fg*fg;c[We>>2]=21;fg=+h[(EA(ag,1,We)|0)>>3];c[Ve>>2]=22;gg=fg*+h[(EA(ag,1,Ve)|0)>>3];c[Ue>>2]=23;h[(EA(ag,1,Ue)|0)>>3]=gg;c[Te>>2]=10;gg=+h[(EA(ag,1,Te)|0)>>3];c[Se>>2]=12;fg=gg*dg*+h[(EA(ag,1,Se)|0)>>3];c[Re>>2]=24;h[(EA(ag,1,Re)|0)>>3]=fg;c[Qe>>2]=12;fg=+h[(EA(ag,1,Qe)|0)>>3];c[Pe>>2]=25;h[(EA(ag,1,Pe)|0)>>3]=fg*fg;c[Oe>>2]=11;fg=+h[(EA(ag,1,Oe)|0)>>3];c[Ne>>2]=12;gg=+h[(EA(ag,1,Ne)|0)>>3];c[Me>>2]=25;eg=fg*gg*dg*+h[(EA(ag,1,Me)|0)>>3];c[Ke>>2]=26;h[(EA(ag,1,Ke)|0)>>3]=eg;c[Je>>2]=10;eg=+h[(EA(ag,1,Je)|0)>>3];c[Ie>>2]=12;gg=eg*+h[(EA(ag,1,Ie)|0)>>3];c[He>>2]=27;h[(EA(ag,1,He)|0)>>3]=gg;c[Ge>>2]=1;gg=+h[(EA(ag,1,Ge)|0)>>3];c[Fe>>2]=10;eg=+h[(EA(ag,1,Fe)|0)>>3];c[Ee>>2]=11;fg=gg*eg*dg*+h[(EA(ag,1,Ee)|0)>>3];c[De>>2]=28;h[(EA(ag,1,De)|0)>>3]=fg;c[Ce>>2]=10;fg=+h[(EA(ag,1,Ce)|0)>>3];c[Be>>2]=12;eg=+h[(EA(ag,1,Be)|0)>>3];c[Ae>>2]=25;gg=fg*eg*dg*+h[(EA(ag,1,Ae)|0)>>3];c[ze>>2]=29;h[(EA(ag,1,ze)|0)>>3]=gg;c[ye>>2]=1;gg=+h[(EA(ag,1,ye)|0)>>3];c[xe>>2]=10;eg=+h[(EA(ag,1,xe)|0)>>3];c[we>>2]=25;fg=gg*eg*dg*+h[(EA(ag,1,we)|0)>>3];c[ve>>2]=30;h[(EA(ag,1,ve)|0)>>3]=fg;c[ue>>2]=1;fg=+h[(EA(ag,1,ue)|0)>>3];c[te>>2]=11;eg=+h[(EA(ag,1,te)|0)>>3];c[se>>2]=12;gg=fg*eg*+h[(EA(ag,1,se)|0)>>3];c[re>>2]=31;h[(EA(ag,1,re)|0)>>3]=gg;c[qe>>2]=1;gg=+h[(EA(ag,1,qe)|0)>>3];c[pe>>2]=12;eg=gg*+h[(EA(ag,1,pe)|0)>>3];c[oe>>2]=32;h[(EA(ag,1,oe)|0)>>3]=eg;c[ne>>2]=33;h[(EA(ag,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;eg=+h[(EA(ag,1,me)|0)>>3];c[le>>2]=34;h[(EA(ag,1,le)|0)>>3]=eg*eg;c[ke>>2]=13;eg=+h[(EA(ag,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(EA(ag,1,je)|0)>>3]=eg;c[ie>>2]=35;eg=+h[(EA(ag,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(EA(ag,1,he)|0)>>3]=eg;c[ge>>2]=2;eg=+h[(EA(ag,1,ge)|0)>>3];c[fe>>2]=36;gg=eg*+h[(EA(ag,1,fe)|0)>>3];c[ee>>2]=37;h[(EA(ag,1,ee)|0)>>3]=gg;c[de>>2]=37;gg=+h[(EA(ag,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(EA(ag,1,ce)|0)>>3]=gg;c[be>>2]=1;gg=+h[(EA(ag,1,be)|0)>>3];c[ae>>2]=38;eg=gg*+h[(EA(ag,1,ae)|0)>>3];c[$d>>2]=39;h[(EA(ag,1,$d)|0)>>3]=eg;c[_d>>2]=39;eg=+h[(EA(ag,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(EA(ag,1,Zd)|0)>>3]=eg;c[Yd>>2]=40;eg=dg*+h[(EA(ag,1,Yd)|0)>>3];c[Xd>>2]=41;h[(EA(ag,1,Xd)|0)>>3]=eg;c[Wd>>2]=41;eg=+h[(EA(ag,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(EA(ag,1,Vd)|0)>>3]=eg;c[Ud>>2]=42;eg=dg*+h[(EA(ag,1,Ud)|0)>>3];c[Td>>2]=43;h[(EA(ag,1,Td)|0)>>3]=eg;c[Sd>>2]=44;h[(EA(ag,1,Sd)|0)>>3]=dg*57870447262208.0e-19;c[Rd>>2]=2;eg=+h[(EA(ag,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(EA(ag,1,Qd)|0)>>3]=eg;c[Pd>>2]=45;eg=+h[(EA(ag,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(EA(ag,1,Od)|0)>>3]=eg;c[Nd>>2]=46;eg=dg*+h[(EA(ag,1,Nd)|0)>>3];c[Md>>2]=47;h[(EA(ag,1,Md)|0)>>3]=eg;c[Ld>>2]=47;eg=+h[(EA(ag,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(EA(ag,1,Kd)|0)>>3]=eg;c[Jd>>2]=48;eg=dg*+h[(EA(ag,1,Jd)|0)>>3];c[Id>>2]=49;h[(EA(ag,1,Id)|0)>>3]=eg;c[Hd>>2]=1;eg=+h[(EA(ag,1,Hd)|0)>>3];c[Gd>>2]=11;gg=eg*+h[(EA(ag,1,Gd)|0)>>3];c[Fd>>2]=50;h[(EA(ag,1,Fd)|0)>>3]=gg;c[Ed>>2]=10;gg=+h[(EA(ag,1,Ed)|0)>>3];c[Dd>>2]=11;eg=gg*+h[(EA(ag,1,Dd)|0)>>3];c[Cd>>2]=51;h[(EA(ag,1,Cd)|0)>>3]=eg;c[Bd>>2]=11;c[f+136>>2]=a;c[f+144>>2]=b;g[f+152>>2]=d;g[f+160>>2]=e;g[f+1512>>2]=dg;c[f+2688>>2]=ag;c[f+2720>>2]=pb;c[f+2728>>2]=ob;c[f+2736>>2]=nb;c[f+2752>>2]=mb;c[f+2760>>2]=lb;c[f+2768>>2]=kb;c[f+2776>>2]=jb;c[f+2784>>2]=ib;c[f+2792>>2]=hb;c[f+2800>>2]=gb;c[f+2808>>2]=fb;c[f+2816>>2]=eb;c[f+2824>>2]=db;c[f+2840>>2]=cb;c[f+2848>>2]=bb;c[f+2856>>2]=ab;c[f+2864>>2]=$a;c[f+2872>>2]=_a;c[f+2880>>2]=Za;c[f+2888>>2]=Ya;c[f+2896>>2]=Xa;c[f+2904>>2]=Wa;c[f+2912>>2]=Va;c[f+2928>>2]=Ua;c[f+2936>>2]=Ta;c[f+2944>>2]=Sa;c[f+2952>>2]=Ra;c[f+2960>>2]=Qa;c[f+2968>>2]=Pa;c[f+2976>>2]=Oa;c[f+2984>>2]=Na;c[f+2992>>2]=Ma;c[f+3e3>>2]=La;c[f+3016>>2]=Ka;c[f+3024>>2]=Ja;c[f+3032>>2]=Ia;c[f+3040>>2]=Ha;c[f+3048>>2]=Ga;c[f+3056>>2]=Fa;c[f+3064>>2]=Ea;c[f+3072>>2]=Da;c[f+3080>>2]=Ca;c[f+3088>>2]=Ba;c[f+3104>>2]=Aa;c[f+3112>>2]=za;c[f+3120>>2]=ya;c[f+3128>>2]=xa;c[f+3136>>2]=wa;c[f+3144>>2]=va;c[f+3152>>2]=ua;c[f+3160>>2]=ta;c[f+3168>>2]=sa;c[f+3176>>2]=ra;c[f+3192>>2]=qa;c[f+3200>>2]=pa;c[f+3208>>2]=oa;c[f+3216>>2]=na;c[f+3224>>2]=ma;c[f+3232>>2]=la;c[f+3240>>2]=ka;c[f+3248>>2]=ja;c[f+3256>>2]=ia;c[f+3264>>2]=ha;c[f+3280>>2]=ga;c[f+3288>>2]=fa;c[f+3296>>2]=ea;c[f+3304>>2]=da;c[f+3312>>2]=ca;c[f+3320>>2]=ba;c[f+3328>>2]=aa;c[f+3336>>2]=$;c[f+3344>>2]=_;c[f+3352>>2]=Z;c[f+3368>>2]=Y;c[f+3376>>2]=X;c[f+3392>>2]=W;c[f+3400>>2]=V;c[f+3408>>2]=U;c[f+3416>>2]=T;c[f+3424>>2]=S;c[f+3432>>2]=R;c[f+3440>>2]=Q;c[f+3448>>2]=P;c[f+3464>>2]=O;c[f+3472>>2]=N;c[f+3480>>2]=M;c[f+3488>>2]=L;c[f+3496>>2]=K;c[f+3504>>2]=J;c[f+3512>>2]=G;c[f+3520>>2]=F;c[f+3528>>2]=E;c[f+3536>>2]=D;c[f+3552>>2]=C;c[f+3560>>2]=B;c[f+3568>>2]=z;c[f+3576>>2]=y;c[f+3584>>2]=x;c[f+3592>>2]=w;c[f+3600>>2]=v;c[f+3608>>2]=u;c[f+3616>>2]=t;c[f+3624>>2]=s;c[f+3640>>2]=r;c[f+3648>>2]=q;c[f+3656>>2]=p;c[f+3664>>2]=o;c[f+3672>>2]=n;c[f+3680>>2]=m;c[f+3688>>2]=l;c[f+3696>>2]=k;c[f+3704>>2]=j;c[f+4544>>2]=Bd;c[f+4552>>2]=Ad;c[f+4560>>2]=zd;c[f+4576>>2]=yd;c[f+4584>>2]=xd;c[f+4592>>2]=wd;c[f+4600>>2]=vd;c[f+4608>>2]=ud;c[f+4616>>2]=td;c[f+4624>>2]=sd;c[f+4632>>2]=rd;c[f+4640>>2]=qd;c[f+4648>>2]=pd;c[f+4664>>2]=od;c[f+4672>>2]=nd;c[f+4680>>2]=md;c[f+4688>>2]=ld;c[f+4696>>2]=kd;c[f+4704>>2]=jd;c[f+4712>>2]=id;c[f+4720>>2]=hd;c[f+4728>>2]=gd;c[f+4736>>2]=fd;c[f+4752>>2]=ed;c[f+4760>>2]=dd;c[f+4768>>2]=cd;c[f+4776>>2]=bd;c[f+4784>>2]=ad;c[f+4792>>2]=$c;c[f+4800>>2]=_c;c[f+4808>>2]=Zc;c[f+4816>>2]=Yc;c[f+4824>>2]=Xc;c[f+4840>>2]=Wc;c[f+4848>>2]=Vc;c[f+4856>>2]=Uc;c[f+4864>>2]=Tc;c[f+4872>>2]=Sc;c[f+4880>>2]=Rc;c[f+4888>>2]=Qc;c[f+4896>>2]=Pc;c[f+4904>>2]=Oc;c[f+4912>>2]=Nc;c[f+4928>>2]=Mc;c[f+4936>>2]=Lc;c[f+4952>>2]=Kc;c[f+4960>>2]=Jc;c[f+4968>>2]=Ic;c[f+4976>>2]=Hc;c[f+4984>>2]=Gc;c[f+4992>>2]=Fc;c[f+5e3>>2]=Ec;c[f+5008>>2]=Dc;c[f+5024>>2]=Cc;c[f+5032>>2]=Bc;c[f+5040>>2]=Ac;c[f+5048>>2]=zc;c[f+5056>>2]=yc;c[f+5064>>2]=xc;c[f+5072>>2]=wc;c[f+5080>>2]=vc;c[f+5088>>2]=uc;c[f+5096>>2]=tc;c[f+5112>>2]=sc;c[f+5120>>2]=rc;c[f+5128>>2]=qc;c[f+5136>>2]=pc;c[f+5144>>2]=oc;c[f+5152>>2]=nc;c[f+5160>>2]=mc;c[f+5168>>2]=lc;c[f+5176>>2]=kc;c[f+5184>>2]=jc;c[f+5200>>2]=ic;c[f+5208>>2]=hc;c[f+5216>>2]=gc;c[f+5224>>2]=fc;c[f+5232>>2]=ec;c[f+5240>>2]=dc;c[f+5248>>2]=cc;c[f+5256>>2]=bc;c[f+5264>>2]=ac;c[f+5272>>2]=$b;c[f+5288>>2]=_b;c[f+5296>>2]=Zb;c[f+5304>>2]=Yb;c[f+5312>>2]=Xb;c[f+5320>>2]=Wb;c[f+5328>>2]=Vb;c[f+5336>>2]=Ub;c[f+5344>>2]=Tb;c[f+5352>>2]=Sb;c[f+5360>>2]=Rb;c[f+5376>>2]=Qb;c[f+5384>>2]=Pb;c[f+5392>>2]=Ob;c[f+5400>>2]=Nb;c[f+5408>>2]=Mb;c[f+5416>>2]=Lb;c[f+5424>>2]=Kb;c[f+5432>>2]=Jb;c[f+5440>>2]=Ib;c[f+5448>>2]=Hb;c[f+5464>>2]=Gb;c[f+5472>>2]=Fb;c[f+5480>>2]=Eb;c[f+5488>>2]=Db;c[f+5496>>2]=Cb;c[f+5504>>2]=Bb;c[f+5512>>2]=Ab;c[f+5520>>2]=zb;c[f+5528>>2]=yb;c[f+5536>>2]=xb;c[f+5552>>2]=wb;c[f+5560>>2]=vb;c[f+5568>>2]=ub;c[f+5576>>2]=tb;c[f+5584>>2]=sb;c[f+5592>>2]=rb;c[f+5600>>2]=qb;c[f+5648>>2]=0;c[f+5652>>2]=0;_omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(f);H=c[f+5648>>2]|0;A=c[f+5652>>2]|0;I=+g[f+5652>>2];c[f+5648>>2]=0;c[f+5652>>2]=0;if((H|0)==5){return}}function _omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0.0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0.0,$d=0.0,ae=0.0,be=0.0;b=c[a+136>>2]|0;d=c[a+144>>2]|0;e=+g[a+152>>2];f=+g[a+160>>2];j=+g[a+1512>>2];l=c[a+2688>>2]|0;m=c[a+2720>>2]|0;n=c[a+2728>>2]|0;o=c[a+2736>>2]|0;p=c[a+2752>>2]|0;q=c[a+2760>>2]|0;r=c[a+2768>>2]|0;s=c[a+2776>>2]|0;t=c[a+2784>>2]|0;u=c[a+2792>>2]|0;v=c[a+2800>>2]|0;w=c[a+2808>>2]|0;x=c[a+2816>>2]|0;y=c[a+2824>>2]|0;z=c[a+2840>>2]|0;A=c[a+2848>>2]|0;B=c[a+2856>>2]|0;C=c[a+2864>>2]|0;D=c[a+2872>>2]|0;E=c[a+2880>>2]|0;F=c[a+2888>>2]|0;G=c[a+2896>>2]|0;H=c[a+2904>>2]|0;I=c[a+2912>>2]|0;J=c[a+2928>>2]|0;K=c[a+2936>>2]|0;L=c[a+2944>>2]|0;M=c[a+2952>>2]|0;N=c[a+2960>>2]|0;O=c[a+2968>>2]|0;P=c[a+2976>>2]|0;Q=c[a+2984>>2]|0;R=c[a+2992>>2]|0;S=c[a+3e3>>2]|0;T=c[a+3016>>2]|0;U=c[a+3024>>2]|0;V=c[a+3032>>2]|0;W=c[a+3040>>2]|0;X=c[a+3048>>2]|0;Y=c[a+3056>>2]|0;Z=c[a+3064>>2]|0;_=c[a+3072>>2]|0;$=c[a+3080>>2]|0;aa=c[a+3088>>2]|0;ba=c[a+3104>>2]|0;ca=c[a+3112>>2]|0;ea=c[a+3120>>2]|0;fa=c[a+3128>>2]|0;ga=c[a+3136>>2]|0;ha=c[a+3144>>2]|0;ia=c[a+3152>>2]|0;ja=c[a+3160>>2]|0;ka=c[a+3168>>2]|0;la=c[a+3176>>2]|0;ma=c[a+3192>>2]|0;na=c[a+3200>>2]|0;oa=c[a+3208>>2]|0;pa=c[a+3216>>2]|0;qa=c[a+3224>>2]|0;ra=c[a+3232>>2]|0;sa=c[a+3240>>2]|0;ta=c[a+3248>>2]|0;ua=c[a+3256>>2]|0;va=c[a+3264>>2]|0;wa=c[a+3280>>2]|0;xa=c[a+3288>>2]|0;ya=c[a+3296>>2]|0;za=c[a+3304>>2]|0;Aa=c[a+3312>>2]|0;Ba=c[a+3320>>2]|0;Ca=c[a+3328>>2]|0;Da=c[a+3336>>2]|0;Ea=c[a+3344>>2]|0;Fa=c[a+3352>>2]|0;Ga=c[a+3368>>2]|0;Ha=c[a+3376>>2]|0;Ia=c[a+3392>>2]|0;Ja=c[a+3400>>2]|0;Ka=c[a+3408>>2]|0;La=c[a+3416>>2]|0;Ma=c[a+3424>>2]|0;Na=c[a+3432>>2]|0;Oa=c[a+3440>>2]|0;Pa=c[a+3448>>2]|0;Qa=c[a+3464>>2]|0;Ra=c[a+3472>>2]|0;Sa=c[a+3480>>2]|0;Ta=c[a+3488>>2]|0;Ua=c[a+3496>>2]|0;Va=c[a+3504>>2]|0;Wa=c[a+3512>>2]|0;Xa=c[a+3520>>2]|0;Ya=c[a+3528>>2]|0;Za=c[a+3536>>2]|0;_a=c[a+3552>>2]|0;$a=c[a+3560>>2]|0;ab=c[a+3568>>2]|0;bb=c[a+3576>>2]|0;cb=c[a+3584>>2]|0;db=c[a+3592>>2]|0;eb=c[a+3600>>2]|0;fb=c[a+3608>>2]|0;gb=c[a+3616>>2]|0;hb=c[a+3624>>2]|0;ib=c[a+3640>>2]|0;jb=c[a+3648>>2]|0;kb=c[a+3656>>2]|0;lb=c[a+3664>>2]|0;mb=c[a+3672>>2]|0;nb=c[a+3680>>2]|0;ob=c[a+3688>>2]|0;pb=c[a+3696>>2]|0;qb=c[a+3704>>2]|0;rb=c[a+4544>>2]|0;sb=c[a+4552>>2]|0;tb=c[a+4560>>2]|0;ub=c[a+4576>>2]|0;vb=c[a+4584>>2]|0;wb=c[a+4592>>2]|0;xb=c[a+4600>>2]|0;yb=c[a+4608>>2]|0;zb=c[a+4616>>2]|0;Ab=c[a+4624>>2]|0;Bb=c[a+4632>>2]|0;Cb=c[a+4640>>2]|0;Db=c[a+4648>>2]|0;Eb=c[a+4664>>2]|0;Fb=c[a+4672>>2]|0;Gb=c[a+4680>>2]|0;Hb=c[a+4688>>2]|0;Ib=c[a+4696>>2]|0;Jb=c[a+4704>>2]|0;Kb=c[a+4712>>2]|0;Lb=c[a+4720>>2]|0;Mb=c[a+4728>>2]|0;Nb=c[a+4736>>2]|0;Ob=c[a+4752>>2]|0;Pb=c[a+4760>>2]|0;Qb=c[a+4768>>2]|0;Rb=c[a+4776>>2]|0;Sb=c[a+4784>>2]|0;Tb=c[a+4792>>2]|0;Ub=c[a+4800>>2]|0;Vb=c[a+4808>>2]|0;Wb=c[a+4816>>2]|0;Xb=c[a+4824>>2]|0;Yb=c[a+4840>>2]|0;Zb=c[a+4848>>2]|0;_b=c[a+4856>>2]|0;$b=c[a+4864>>2]|0;ac=c[a+4872>>2]|0;bc=c[a+4880>>2]|0;cc=c[a+4888>>2]|0;dc=c[a+4896>>2]|0;ec=c[a+4904>>2]|0;fc=c[a+4912>>2]|0;gc=c[a+4928>>2]|0;hc=c[a+4936>>2]|0;ic=c[a+4952>>2]|0;jc=c[a+4960>>2]|0;kc=c[a+4968>>2]|0;lc=c[a+4976>>2]|0;mc=c[a+4984>>2]|0;nc=c[a+4992>>2]|0;oc=c[a+5e3>>2]|0;pc=c[a+5008>>2]|0;qc=c[a+5024>>2]|0;rc=c[a+5032>>2]|0;sc=c[a+5040>>2]|0;tc=c[a+5048>>2]|0;uc=c[a+5056>>2]|0;vc=c[a+5064>>2]|0;wc=c[a+5072>>2]|0;xc=c[a+5080>>2]|0;yc=c[a+5088>>2]|0;zc=c[a+5096>>2]|0;Ac=c[a+5112>>2]|0;Bc=c[a+5120>>2]|0;Cc=c[a+5128>>2]|0;Dc=c[a+5136>>2]|0;Ec=c[a+5144>>2]|0;Fc=c[a+5152>>2]|0;Gc=c[a+5160>>2]|0;Hc=c[a+5168>>2]|0;Ic=c[a+5176>>2]|0;Jc=c[a+5184>>2]|0;Kc=c[a+5200>>2]|0;Lc=c[a+5208>>2]|0;Mc=c[a+5216>>2]|0;Nc=c[a+5224>>2]|0;Oc=c[a+5232>>2]|0;Pc=c[a+5240>>2]|0;Qc=c[a+5248>>2]|0;Rc=c[a+5256>>2]|0;Sc=c[a+5264>>2]|0;Tc=c[a+5272>>2]|0;Uc=c[a+5288>>2]|0;Vc=c[a+5296>>2]|0;Wc=c[a+5304>>2]|0;Xc=c[a+5312>>2]|0;Yc=c[a+5320>>2]|0;Zc=c[a+5328>>2]|0;_c=c[a+5336>>2]|0;$c=c[a+5344>>2]|0;ad=c[a+5352>>2]|0;bd=c[a+5360>>2]|0;cd=c[a+5376>>2]|0;dd=c[a+5384>>2]|0;ed=c[a+5392>>2]|0;fd=c[a+5400>>2]|0;gd=c[a+5408>>2]|0;hd=c[a+5416>>2]|0;id=c[a+5424>>2]|0;jd=c[a+5432>>2]|0;kd=c[a+5440>>2]|0;ld=c[a+5448>>2]|0;md=c[a+5464>>2]|0;nd=c[a+5472>>2]|0;od=c[a+5480>>2]|0;pd=c[a+5488>>2]|0;qd=c[a+5496>>2]|0;rd=c[a+5504>>2]|0;sd=c[a+5512>>2]|0;td=c[a+5520>>2]|0;ud=c[a+5528>>2]|0;vd=c[a+5536>>2]|0;wd=c[a+5552>>2]|0;xd=c[a+5560>>2]|0;yd=c[a+5568>>2]|0;zd=c[a+5576>>2]|0;Ad=c[a+5584>>2]|0;Bd=c[a+5592>>2]|0;Cd=c[a+5600>>2]|0;a:do{Dd=+h[(EA(l,1,rb)|0)>>3];c[sb>>2]=12;Ed=+h[(EA(l,1,sb)|0)>>3];c[tb>>2]=25;Fd=Dd*Ed*+h[(EA(l,1,tb)|0)>>3];c[ub>>2]=52;h[(EA(l,1,ub)|0)>>3]=Fd;c[vb>>2]=10;Fd=+h[(EA(l,1,vb)|0)>>3];c[wb>>2]=12;Ed=+h[(EA(l,1,wb)|0)>>3];c[xb>>2]=25;Dd=Fd*Ed*+h[(EA(l,1,xb)|0)>>3];c[yb>>2]=53;h[(EA(l,1,yb)|0)>>3]=Dd;c[zb>>2]=1;Dd=+h[(EA(l,1,zb)|0)>>3];c[Ab>>2]=10;Ed=+h[(EA(l,1,Ab)|0)>>3];c[Bb>>2]=25;Fd=Dd*Ed*+h[(EA(l,1,Bb)|0)>>3];c[Cb>>2]=54;h[(EA(l,1,Cb)|0)>>3]=Fd;c[Db>>2]=11;Fd=+h[(EA(l,1,Db)|0)>>3];c[Eb>>2]=12;Ed=Fd*j*+h[(EA(l,1,Eb)|0)>>3];c[Fb>>2]=55;h[(EA(l,1,Fb)|0)>>3]=Ed;if(!(e/1.0e6>0.0)){Gd=c[27736]|0;h[k>>3]=e/1.0e6;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];c[a+0>>2]=c[7928+0>>2];c[a+4>>2]=c[7928+4>>2];c[a+8>>2]=c[7928+8>>2];c[a+12>>2]=c[7928+12>>2];c[a+16>>2]=c[7928+16>>2];c[a+20>>2]=c[7928+20>>2];Le[Gd&63](d,a,7312,Gb);}c[Hb>>2]=9;Ed=+h[(EA(l,1,Hb)|0)>>3];c[Ib>>2]=1;Fd=+h[(EA(l,1,Ib)|0)>>3];c[Jb>>2]=13;Dd=+h[(EA(l,1,Jb)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[Kb>>2]=2;Hd=j*(j*(Fd*(Dd*+h[(EA(l,1,Kb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[Lb>>2]=1;Dd=+h[(EA(l,1,Lb)|0)>>3];c[Mb>>2]=13;Fd=+h[(EA(l,1,Mb)|0)>>3]*-.040668253562649+-.0015033924542148;c[Nb>>2]=2;Id=j*(Dd*(Fd*+h[(EA(l,1,Nb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[Ob>>2]=14;Fd=+h[(EA(l,1,Ob)|0)>>3]*22922076337661.0e-19;c[Pb>>2]=15;Dd=+h[(EA(l,1,Pb)|0)>>3];c[Qb>>2]=16;Jd=Dd*(+h[(EA(l,1,Qb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Rb>>2]=2;Dd=+h[(EA(l,1,Rb)|0)>>3]*Jd;c[Sb>>2]=17;Jd=+h[(EA(l,1,Sb)|0)>>3];c[Tb>>2]=18;Kd=Jd*(+h[(EA(l,1,Tb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Ub>>2]=11;Jd=+h[(EA(l,1,Ub)|0)>>3];c[Vb>>2]=19;Ld=Jd*(+h[(EA(l,1,Vb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Wb>>2]=15;Jd=+h[(EA(l,1,Wb)|0)>>3]*1.9809712802088e-8;c[Xb>>2]=10;Md=+h[(EA(l,1,Xb)|0)>>3];c[Yb>>2]=10;Nd=+h[(EA(l,1,Yb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Zb>>2]=20;Od=Md*(Nd*+h[(EA(l,1,Zb)|0)>>3]+1.0406965210174e-19);c[_b>>2]=23;Nd=+h[(EA(l,1,_b)|0)>>3];c[$b>>2]=13;Md=+h[(EA(l,1,$b)|0)>>3];c[ac>>2]=24;Pd=Md*(+h[(EA(l,1,ac)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[bc>>2]=21;Md=+h[(EA(l,1,bc)|0)>>3];c[cc>>2]=26;Qd=+h[(EA(l,1,cc)|0)>>3]*-.33662250574171;c[dc>>2]=21;Rd=+h[(EA(l,1,dc)|0)>>3];c[ec>>2]=27;Sd=+h[(EA(l,1,ec)|0)>>3];c[fc>>2]=15;Td=+h[(EA(l,1,fc)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[gc>>2]=28;Ud=Sd*(Td*+h[(EA(l,1,gc)|0)>>3]+8.9185845355421e-25);c[hc>>2]=24;Td=+h[(EA(l,1,hc)|0)>>3]*-5.9056029685639e-26;c[ic>>2]=29;Sd=+h[(EA(l,1,ic)|0)>>3]*37826947613457.0e-19;c[jc>>2]=30;Vd=+h[(EA(l,1,jc)|0)>>3]*-1.2768608934681e-15;c[kc>>2]=31;Wd=+h[(EA(l,1,kc)|0)>>3];c[lc>>2]=18;Xd=+h[(EA(l,1,lc)|0)>>3];c[mc>>2]=32;Yd=e/1.0e6*(Ed+e/1.0e6*(Hd+e/1.0e6*(Id+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Od+Nd*(Pd+Md*(Qd+Rd*(Ud+e/1.0e6*(Td+e/1.0e6*(Sd+e/1.0e6*(Vd+Wd*e/1.0e6*(Xd*(+h[(EA(l,1,mc)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Xd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[nc>>2]=34;Wd=Xd/(540.0/f*+h[(EA(l,1,nc)|0)>>3])+Yd;c[oc>>2]=9;Yd=+h[(EA(l,1,oc)|0)>>3];c[pc>>2]=43;Xd=+h[(EA(l,1,pc)|0)>>3];c[qc>>2]=1;Vd=+h[(EA(l,1,qc)|0)>>3];c[rc>>2]=13;Sd=+h[(EA(l,1,rc)|0)>>3]*-.122004760687947+-.0045101773626444;c[sc>>2]=2;Td=j*(Vd*(Sd*+h[(EA(l,1,sc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[tc>>2]=14;Sd=+h[(EA(l,1,tc)|0)>>3]*114610381688305.0e-19;c[uc>>2]=15;Vd=+h[(EA(l,1,uc)|0)>>3];c[vc>>2]=16;Ud=Vd*(+h[(EA(l,1,vc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[wc>>2]=2;Vd=+h[(EA(l,1,wc)|0)>>3]*Ud;c[xc>>2]=17;Ud=+h[(EA(l,1,xc)|0)>>3];c[yc>>2]=18;Rd=Ud*(+h[(EA(l,1,yc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[zc>>2]=11;Ud=+h[(EA(l,1,zc)|0)>>3];c[Ac>>2]=19;Qd=Ud*(+h[(EA(l,1,Ac)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[Bc>>2]=15;Ud=+h[(EA(l,1,Bc)|0)>>3]*1.78287415218792e-7;c[Cc>>2]=10;Md=+h[(EA(l,1,Cc)|0)>>3];c[Dc>>2]=10;Pd=+h[(EA(l,1,Dc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[Ec>>2]=20;Nd=Md*(Pd*+h[(EA(l,1,Ec)|0)>>3]+1.0406965210174e-18);c[Fc>>2]=23;Pd=+h[(EA(l,1,Fc)|0)>>3];c[Gc>>2]=13;Md=+h[(EA(l,1,Gc)|0)>>3];c[Hc>>2]=24;Od=Md*(+h[(EA(l,1,Hc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[Ic>>2]=21;Md=+h[(EA(l,1,Ic)|0)>>3];c[Jc>>2]=26;Jd=+h[(EA(l,1,Jc)|0)>>3]*-6.0592051033508;c[Kc>>2]=21;Ld=+h[(EA(l,1,Kc)|0)>>3];c[Lc>>2]=27;Kd=+h[(EA(l,1,Lc)|0)>>3];c[Mc>>2]=15;Dd=+h[(EA(l,1,Mc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[Nc>>2]=28;Fd=Kd*(Dd*+h[(EA(l,1,Nc)|0)>>3]+1.78371690710842e-23);c[Oc>>2]=24;Dd=+h[(EA(l,1,Oc)|0)>>3]*-1.24017662339842e-24;c[Pc>>2]=29;Kd=+h[(EA(l,1,Pc)|0)>>3]*83219284749605.0e-18;c[Qc>>2]=30;Id=+h[(EA(l,1,Qc)|0)>>3]*-2.93678005497663e-14;c[Rc>>2]=31;Hd=+h[(EA(l,1,Rc)|0)>>3];c[Sc>>2]=18;Ed=+h[(EA(l,1,Sc)|0)>>3];c[Tc>>2]=32;Zd=(e/1.0e6*(Yd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Qd+e/1.0e6*(Ud+e/1.0e6*(Nd+Pd*(Od+Md*(Jd+Ld*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Id+Hd*e/1.0e6*(Ed*(+h[(EA(l,1,Tc)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Uc>>2]=21;Ed=+h[(EA(l,1,Uc)|0)>>3];c[Vc>>2]=43;Hd=+h[(EA(l,1,Vc)|0)>>3];c[Wc>>2]=1;Id=+h[(EA(l,1,Wc)|0)>>3];c[Xc>>2]=13;Kd=+h[(EA(l,1,Xc)|0)>>3]*-.244009521375894+-.0090203547252888;c[Yc>>2]=2;Dd=j*(Id*(Kd*+h[(EA(l,1,Yc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Zc>>2]=14;Kd=+h[(EA(l,1,Zc)|0)>>3]*45844152675322.0e-18;c[_c>>2]=15;Id=+h[(EA(l,1,_c)|0)>>3];c[$c>>2]=16;Fd=Id*(+h[(EA(l,1,$c)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[ad>>2]=2;Id=+h[(EA(l,1,ad)|0)>>3]*Fd;c[bd>>2]=17;Fd=+h[(EA(l,1,bd)|0)>>3];c[cd>>2]=18;Ld=Fd*(+h[(EA(l,1,cd)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[dd>>2]=11;Fd=+h[(EA(l,1,dd)|0)>>3];c[ed>>2]=19;Jd=Fd*(+h[(EA(l,1,ed)|0)>>3]*-460.94350902879+6.303478361857e-10);c[fd>>2]=15;Fd=+h[(EA(l,1,fd)|0)>>3]*142629932175034.0e-20;c[gd>>2]=10;Md=+h[(EA(l,1,gd)|0)>>3];c[hd>>2]=10;Od=+h[(EA(l,1,hd)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[id>>2]=20;Pd=Md*(Od*+h[(EA(l,1,id)|0)>>3]+9.3662686891566e-18);c[jd>>2]=23;Od=+h[(EA(l,1,jd)|0)>>3];c[kd>>2]=13;Md=+h[(EA(l,1,kd)|0)>>3];c[ld>>2]=24;Nd=Md*(+h[(EA(l,1,ld)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[md>>2]=21;Md=+h[(EA(l,1,md)|0)>>3];c[nd>>2]=26;Ud=+h[(EA(l,1,nd)|0)>>3]*-103.006486756963;c[od>>2]=21;Qd=+h[(EA(l,1,od)|0)>>3];c[pd>>2]=27;Rd=+h[(EA(l,1,pd)|0)>>3];c[qd>>2]=15;Vd=+h[(EA(l,1,qd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[rd>>2]=28;Sd=Rd*(Vd*+h[(EA(l,1,rd)|0)>>3]+3.389062123506e-22);c[sd>>2]=24;Vd=+h[(EA(l,1,sd)|0)>>3]*-2.48035324679684e-23;c[td>>2]=29;Rd=+h[(EA(l,1,td)|0)>>3]*.00174760497974171;c[ud>>2]=30;Td=+h[(EA(l,1,ud)|0)>>3]*-6.4609161209486e-13;c[vd>>2]=31;Xd=+h[(EA(l,1,vd)|0)>>3];c[wd>>2]=18;Yd=+h[(EA(l,1,wd)|0)>>3];c[xd>>2]=32;_d=e/1.0e6*(Kd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Pd+Od*(Nd+Md*(Ud+Qd*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Td+Xd*e/1.0e6*(Yd*(+h[(EA(l,1,xd)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[yd>>2]=44;Yd=Ed*(Hd+e/1.0e6*(Dd+e/1.0e6*(j*(j*(+h[(EA(l,1,yd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+_d)+1.22890426153854e-7))+-1.0;c[zd>>2]=21;_d=Yd/+h[(EA(l,1,zd)|0)>>3];c[Ad>>2]=33;Yd=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(EA(l,1,Ad)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[Bd>>2]=33;Dd=+h[(EA(l,1,Bd)|0)>>3];c[Cd>>2]=34;Hd=Yd/(Dd*+h[(EA(l,1,Cd)|0)>>3]);c[m>>2]=49;Dd=+h[(EA(l,1,m)|0)>>3];c[n>>2]=1;Yd=+h[(EA(l,1,n)|0)>>3];c[o>>2]=13;Ed=+h[(EA(l,1,o)|0)>>3]*-.00096028372490713+-.306581069554011;c[p>>2]=2;Xd=j*(Yd*(Ed*+h[(EA(l,1,p)|0)>>3]+-.015757110897342)+-.0003789797503263);c[q>>2]=1;Ed=+h[(EA(l,1,q)|0)>>3];c[r>>2]=13;Yd=+h[(EA(l,1,r)|0)>>3]*-1.42338887469272+-.0090203547252888;c[s>>2]=2;Td=Ed*(Yd*+h[(EA(l,1,s)|0)>>3]+-9683303171571.0e-17);c[t>>2]=20;Yd=+h[(EA(l,1,t)|0)>>3]*160454534363627.0e-19;c[u>>2]=1;Ed=+h[(EA(l,1,u)|0)>>3];c[v>>2]=15;Rd=+h[(EA(l,1,v)|0)>>3];c[w>>2]=16;Vd=Ed*(Rd*(+h[(EA(l,1,w)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[x>>2]=18;Rd=+h[(EA(l,1,x)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[y>>2]=50;Ed=Rd*+h[(EA(l,1,y)|0)>>3];c[z>>2]=14;Rd=+h[(EA(l,1,z)|0)>>3];c[A>>2]=19;Sd=Rd*(+h[(EA(l,1,A)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[B>>2]=51;Rd=+h[(EA(l,1,B)|0)>>3]*2.57526266427144e-7;c[C>>2]=2;Qd=+h[(EA(l,1,C)|0)>>3];c[D>>2]=10;Ud=+h[(EA(l,1,D)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[E>>2]=20;Md=Qd*(Ud*+h[(EA(l,1,E)|0)>>3]+4.1627860840696e-19);c[F>>2]=23;Ud=+h[(EA(l,1,F)|0)>>3];c[G>>2]=19;Qd=+h[(EA(l,1,G)|0)>>3];c[H>>2]=24;Nd=Qd*(+h[(EA(l,1,H)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[I>>2]=21;Qd=+h[(EA(l,1,I)|0)>>3];c[J>>2]=52;Od=+h[(EA(l,1,J)|0)>>3]*-19.1874828272775;c[K>>2]=21;Pd=+h[(EA(l,1,K)|0)>>3];c[L>>2]=16;Fd=+h[(EA(l,1,L)|0)>>3];c[M>>2]=15;Jd=+h[(EA(l,1,M)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[N>>2]=28;Ld=Fd*(Jd*+h[(EA(l,1,N)|0)>>3]+1.78371690710842e-23);c[O>>2]=27;Jd=+h[(EA(l,1,O)|0)>>3]*-1.24017662339842e-24;c[P>>2]=53;Fd=+h[(EA(l,1,P)|0)>>3]*.000200482822351322;c[Q>>2]=54;Id=+h[(EA(l,1,Q)|0)>>3]*-4.9797574845256e-14;c[R>>2]=18;Kd=+h[(EA(l,1,R)|0)>>3];c[S>>2]=32;$d=Kd*(+h[(EA(l,1,S)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[T>>2]=55;Kd=Hd+e/1.0e6*(Dd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Yd+e/1.0e6*(Vd+e/1.0e6*(Ed+e/1.0e6*(Sd+e/1.0e6*(Rd+e/1.0e6*(Md+Ud*(Nd+Qd*(Od+Pd*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Id+e/1.0e6*+h[(EA(l,1,T)|0)>>3]*$d))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[U>>2]=33;$d=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(EA(l,1,U)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[V>>2]=33;Id=+h[(EA(l,1,V)|0)>>3];c[W>>2]=34;Fd=$d/(540.0/f*Id*+h[(EA(l,1,W)|0)>>3]);c[X>>2]=2;Id=j*(+h[(EA(l,1,X)|0)>>3]*-1.5097583618379+-.34548755450059);c[Y>>2]=1;$d=+h[(EA(l,1,Y)|0)>>3];c[Z>>2]=13;Jd=+h[(EA(l,1,Z)|0)>>3]*-.03360993037175+-1.83948641732407;c[_>>2]=2;Ld=$d*(Jd*+h[(EA(l,1,_)|0)>>3]+-.047271332692026);c[$>>2]=13;Jd=+h[(EA(l,1,$)|0)>>3]*-48.395221739552+-.045101773626444;c[aa>>2]=2;$d=j*(Jd*+h[(EA(l,1,aa)|0)>>3]+-.00019366606343142);c[ba>>2]=10;Jd=j*+h[(EA(l,1,ba)|0)>>3]*96272720618176.0e-18;c[ca>>2]=15;Pd=+h[(EA(l,1,ca)|0)>>3];c[ea>>2]=16;Od=j*(Pd*(+h[(EA(l,1,ea)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[fa>>2]=11;Pd=+h[(EA(l,1,fa)|0)>>3];c[ga>>2]=18;Qd=Pd*j*(+h[(EA(l,1,ga)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ha>>2]=19;Pd=+h[(EA(l,1,ha)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[ia>>2]=20;Nd=Pd*+h[(EA(l,1,ia)|0)>>3];c[ja>>2]=17;Pd=+h[(EA(l,1,ja)|0)>>3]*309031519712573.0e-20;c[ka>>2]=1;Ud=+h[(EA(l,1,ka)|0)>>3];c[la>>2]=10;Md=+h[(EA(l,1,la)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ma>>2]=20;Rd=Ud*(Md*+h[(EA(l,1,ma)|0)>>3]+1.24883582522088e-18);c[na>>2]=23;Md=+h[(EA(l,1,na)|0)>>3];c[oa>>2]=1;Ud=+h[(EA(l,1,oa)|0)>>3];c[pa>>2]=11;Sd=+h[(EA(l,1,pa)|0)>>3];c[qa>>2]=12;Ed=+h[(EA(l,1,qa)|0)>>3];c[ra>>2]=24;Vd=Ud*Sd*Ed*j*(+h[(EA(l,1,ra)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[sa>>2]=21;Ed=+h[(EA(l,1,sa)|0)>>3];c[ta>>2]=1;Sd=+h[(EA(l,1,ta)|0)>>3];c[ua>>2]=10;Ud=+h[(EA(l,1,ua)|0)>>3];c[va>>2]=12;Yd=+h[(EA(l,1,va)|0)>>3];c[wa>>2]=25;Td=Sd*Ud*Yd*j*+h[(EA(l,1,wa)|0)>>3]*-1074.49903832754;c[xa>>2]=21;Yd=+h[(EA(l,1,xa)|0)>>3];c[ya>>2]=15;Ud=+h[(EA(l,1,ya)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[za>>2]=28;Sd=Ud*+h[(EA(l,1,za)|0)>>3]+3.389062123506e-22;c[Aa>>2]=32;Ud=Sd*+h[(EA(l,1,Aa)|0)>>3];c[Ba>>2]=16;Sd=+h[(EA(l,1,Ba)|0)>>3]*-2.48035324679684e-23;c[Ca>>2]=1;Xd=+h[(EA(l,1,Ca)|0)>>3];c[Da>>2]=12;Dd=+h[(EA(l,1,Da)|0)>>3];c[Ea>>2]=25;Hd=Xd*Dd*j*+h[(EA(l,1,Ea)|0)>>3]*.0104251067622687;c[Fa>>2]=11;Dd=+h[(EA(l,1,Fa)|0)>>3];c[Ga>>2]=12;Xd=+h[(EA(l,1,Ga)|0)>>3];c[Ha>>2]=18;ae=+h[(EA(l,1,Ha)|0)>>3];c[Ia>>2]=32;be=Dd*Xd*e/1.0e6*(ae*(+h[(EA(l,1,Ia)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ja>>2]=10;ae=+h[(EA(l,1,Ja)|0)>>3];c[Ka>>2]=25;Xd=Fd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*($d+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Qd+e/1.0e6*(Nd+e/1.0e6*(Pd+e/1.0e6*(Rd+Md*(Vd+Ed*(Td+Yd*(Ud+e/1.0e6*(Sd+e/1.0e6*(Hd+e/1.0e6*(be+ae*j*+h[(EA(l,1,Ka)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[La>>2]=49;ae=+h[(EA(l,1,La)|0)>>3];c[Ma>>2]=1;be=+h[(EA(l,1,Ma)|0)>>3];c[Na>>2]=13;Hd=+h[(EA(l,1,Na)|0)>>3]*-.00192056744981426+-.61316213910802;c[Oa>>2]=2;Sd=j*(be*(Hd*+h[(EA(l,1,Oa)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Pa>>2]=1;Hd=+h[(EA(l,1,Pa)|0)>>3];c[Qa>>2]=13;be=+h[(EA(l,1,Qa)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Ra>>2]=2;Ud=Hd*(be*+h[(EA(l,1,Ra)|0)>>3]+-.00029049909514713);c[Sa>>2]=20;be=+h[(EA(l,1,Sa)|0)>>3]*80227267181813.0e-18;c[Ta>>2]=1;Hd=+h[(EA(l,1,Ta)|0)>>3];c[Ua>>2]=15;Yd=+h[(EA(l,1,Ua)|0)>>3];c[Va>>2]=16;Td=Hd*(Yd*(+h[(EA(l,1,Va)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Wa>>2]=18;Yd=+h[(EA(l,1,Wa)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Xa>>2]=50;Hd=Yd*+h[(EA(l,1,Xa)|0)>>3];c[Ya>>2]=14;Yd=+h[(EA(l,1,Ya)|0)>>3];c[Za>>2]=19;Ed=Yd*(+h[(EA(l,1,Za)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[_a>>2]=51;Yd=+h[(EA(l,1,_a)|0)>>3]*23177363978443.0e-19;c[$a>>2]=2;Vd=+h[(EA(l,1,$a)|0)>>3];c[ab>>2]=10;Md=+h[(EA(l,1,ab)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[bb>>2]=20;Rd=Vd*(Md*+h[(EA(l,1,bb)|0)>>3]+4.1627860840696e-18);c[cb>>2]=23;Md=+h[(EA(l,1,cb)|0)>>3];c[db>>2]=19;Vd=+h[(EA(l,1,db)|0)>>3];c[eb>>2]=24;Pd=Vd*(+h[(EA(l,1,eb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[fb>>2]=21;Vd=+h[(EA(l,1,fb)|0)>>3];c[gb>>2]=52;Nd=+h[(EA(l,1,gb)|0)>>3]*-345.37469089099;c[hb>>2]=21;Qd=+h[(EA(l,1,hb)|0)>>3];c[ib>>2]=16;Od=+h[(EA(l,1,ib)|0)>>3];c[jb>>2]=15;Jd=+h[(EA(l,1,jb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[kb>>2]=28;$d=Od*(Jd*+h[(EA(l,1,kb)|0)>>3]+3.5674338142168e-22);c[lb>>2]=27;Jd=+h[(EA(l,1,lb)|0)>>3]*-2.60437090913668e-23;c[mb>>2]=53;Od=+h[(EA(l,1,mb)|0)>>3]*.0044106220917291;c[nb>>2]=54;Ld=+h[(EA(l,1,nb)|0)>>3]*-1.14534422144089e-12;c[ob>>2]=18;Id=+h[(EA(l,1,ob)|0)>>3];c[pb>>2]=32;Fd=Id*(+h[(EA(l,1,pb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[qb>>2]=55;Id=e/1.0e6*(be+e/1.0e6*(Td+e/1.0e6*(Hd+e/1.0e6*(Ed+e/1.0e6*(Yd+e/1.0e6*(Rd+Md*(Pd+Vd*(Nd+Qd*($d+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Ld+e/1.0e6*+h[(EA(l,1,qb)|0)>>3]*Fd))))))))))));c[(a+120|0)>>2]=44;Fd=ae+e/1.0e6*(Sd+e/1.0e6*(Ud+e/1.0e6*(j*(+h[(EA(l,1,a+120|0)|0)>>3]+1.0232574281828e-7)+Id+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Wd;h[b+48>>3]=Zd;h[b+56>>3]=_d;h[b+64>>3]=Kd;h[b+72>>3]=Xd;h[b+80>>3]=Fd;i=a;c[a+5648>>2]=5;break a}while(0)}



function rI(a){a=a|0;var b=0;b=i;sI(a);i=b;return}function sI(a){a=a|0;var b=0;b=i;tI(a);i=b;return}function tI(a){a=a|0;c[a>>2]=0;i=i;return}function uI(a){a=a|0;var b=0;b=i;vI(a);i=b;return}function vI(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;CV(j);c[d>>2]=104040;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;NF(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;yV(g,j);l=wI(g)|0;e$(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=oe[r&63](d,0,4096)|0;i=e;return}yV(h,j);c[k>>2]=_G(h)|0;e$(h);a[f]=($G(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=oe[r&63](d,0,4096)|0;i=e;return}function wI(a){a=a|0;var b=0,c=0;b=i;c=f$(a,135936)|0;i=b;return c|0}function xI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;cB(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){yI(a,b,c[f>>2]|0,h);fB(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=E2(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;vz(k,104312,e)}yI(a,b,l,h);fB(3);i=d;return}function yI(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;fB(0);k=+ZA(0);cB(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function zI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=B2(24)|0;cB(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;uz(c[m>>2]|0,l>>>31^1,104368,f);f=b+8|0;b=c[a+8>>2]|0;l=AI(b,f)|0;c[g+20>>2]=l;l=AI(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=B2(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;vz(k,104448,e)}else{c[h>>2]=0;c[a+12>>2]=g;fB(3);i=d;return}}function AI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function BI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;cB(3);u=b;v=kc(c[u>>2]|0,104512)|0;if((v|0)==0){CI(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Zd(c[(Pc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;vz(w,104520,q)}tc(104576,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];zd(v|0,104624,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];zd(v|0,104648,o|0)|0;tc(104672,40,1,v|0)|0;tc(104720,11,1,v|0)|0;tc(104736,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];DI(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Vd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{tc(104752,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;DI(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Vd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];zd(v|0,104776,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;DI(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Vd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];zd(v|0,104776,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;DI(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Vd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];zd(v|0,104776,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;DI(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Vd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];zd(v|0,104776,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;DI(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Vd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];zd(v|0,104776,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;DI(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Vd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];zd(v|0,104776,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;DI(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Vd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}CI(t);if((_c(v|0)|0)==0){C2(c[r>>2]|0);c[r>>2]=0;fB(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];vz(e,104792,f)}}function CI(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}C2(a);c[d>>2]=0;i=b;return}function DI(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];zd(a|0,104840,f|0)|0;i=e;return}function EI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=H2(192)|0;h3(m|0,0,192)|0;FI(m);c[a+12>>2]=m;n=m;o=a;aF(n,c[o>>2]|0,36);if(hV(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];vz(a,104880,g)}else{g=m;MW(g,104856,14)|0;NW(h,g);a=nG(h)|0;h=m+184|0;c[h>>2]=a;MW(g,104872,4)|0;GI(n,b+8|0);NW(j,g);b=nG(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;$E(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];OW(g,f)|0;HI(n,-4-m+b|0);b=c[j>>2]|0;$E(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];OW(g,e)|0;fB(3);i=d;return}}function FI(a){a=a|0;var b=0;b=i;_I(a);i=b;return}function GI(a,b){a=a|0;b=b|0;var c=0;c=i;JI(a,3);KI(a,105056);JI(a,0);KI(a,105064);JI(a,2);VI(a,b);WI(a,b);KI(a,105072);JI(a,0);i=c;return}function HI(a,b){a=a|0;b=b|0;var d=0;d=i;c[26262]=Kd(b|0)|0;MW(a,105048,4)|0;i=d;return}function II(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;NW(l,q);r=nG(l)|0;HI(b,0);NW(m,q);l=nG(m)|0;JI(b,1);KI(b,104944);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;LI(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);MI(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{MI(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{NI(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{OI(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{KI(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}NW(n,q);u=nG(n)|0;n=e3(0,r|0,32)|0;$E(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];OW(q,k)|0;HI(b,u-l|0);$E(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];OW(q,j)|0;i=g;return}function JI(b,d){b=b|0;d=d|0;var e=0;e=i;a[105032]=-33;c[26260]=Kd(d|0)|0;d=b;MW(d,105032,1)|0;MW(d,105040,4)|0;i=e;return}function KI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Kd(d3(d|0)|0)|0;a[105024]=-37;g=b;MW(g,105024,1)|0;MW(g,f,4)|0;MW(g,d,d3(d|0)|0)|0;i=e;return}function LI(b,d){b=b|0;d=d|0;var e=0;e=i;a[105008]=-35;c[26254]=Kd(d|0)|0;d=b;MW(d,105008,1)|0;MW(d,105016,4)|0;i=e;return}function MI(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[104992]=-53;UI(c);e=b;MW(e,104992,1)|0;MW(e,105e3,8)|0;i=d;return}function NI(b,d){b=b|0;d=d|0;var e=0;e=i;a[104976]=-46;c[26246]=Kd(d|0)|0;d=b;MW(d,104976,1)|0;MW(d,104984,4)|0;i=e;return}function OI(b,c){b=b|0;c=c|0;var d=0;d=i;a[104968]=c?-61:-62;MW(b,104968,1)|0;i=d;return}function PI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;II(e,+h[f>>3],a,f);II(e,+h[b+248>>3],a,f);i=d;return}function QI(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;NW(j,p);o=nG(j)|0;HI(b,0);NW(k,p);j=nG(k)|0;JI(b,1);KI(b,104952);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;LI(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;MI(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{MI(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{NI(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{OI(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{KI(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}NW(l,p);s=nG(l)|0;l=e3(0,o|0,32)|0;$E(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];OW(p,g)|0;HI(b,s-j|0);$E(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];OW(p,f)|0;i=e;return}function RI(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;VE(a);cB(3);if((a|0)!=0){SI(a);J2(a)}c[d>>2]=0;fB(3);i=b;return}function SI(a){a=a|0;var b=0;b=i;TI(a);i=b;return}function TI(a){a=a|0;var b=0;b=i;qG(a);i=b;return}function UI(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Kd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=105e3;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[105e3+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function VI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;KI(a,104944);JI(a,4);KI(a,105080);JI(a,0);KI(a,105088);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;LI(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);KI(a,105096);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{KI(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{KI(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{KI(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{KI(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=105184;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];XI(a,b,e);KI(a,105120);JI(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);YI(a,105096,105128);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;YI(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;YI(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;YI(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;YI(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function WI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;KI(a,104952);JI(a,4);KI(a,105080);JI(a,0);KI(a,105088);o=g+1+j+l+n|0;LI(a,o);KI(a,105096);if((c[f>>2]|0)>0){n=b;l=0;do{KI(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{KI(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{KI(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{KI(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=105104;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];XI(a,b,e);KI(a,105120);JI(a,o);YI(a,105096,105128);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;YI(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;YI(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;YI(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;YI(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function XI(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;KI(b,105152);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}JI(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?105096:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}ZI(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?105096:w;if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}ZI(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?105096:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}ZI(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?105096:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}ZI(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function YI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;KI(a,b);JI(a,1);KI(a,105136);KI(a,c);i=d;return}function ZI(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;KI(a,b);JI(a,d?2:1);KI(a,105160);KI(a,c);if(!d){i=e;return}KI(a,105168);KI(a,105176);i=e;return}function _I(a){a=a|0;var b=0;b=i;gI(a);i=b;return}function $I(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;qU(e,105200);mU(d,bJ(a,e)|0);aJ(d,b+4|0);wU(d);wU(e);qU(g,105208);mU(f,bJ(a,g)|0);cJ(f,b);wU(f);wU(g);qU(j,105224);mU(h,bJ(a,j)|0);aJ(h,b+8|0);wU(h);wU(j);qU(l,105240);mU(k,bJ(a,l)|0);aJ(k,b+12|0);wU(k);wU(l);qU(n,105256);mU(m,bJ(a,n)|0);dJ(m,b+16|0,0);wU(m);wU(n);qU(p,105272);mU(o,bJ(a,p)|0);dJ(o,b+20|0,0);wU(o);wU(p);qU(r,105288);mU(q,bJ(a,r)|0);dJ(q,b+24|0,0);wU(q);wU(r);qU(t,105296);mU(s,bJ(a,t)|0);dJ(s,b+28|0,0);wU(s);wU(t);qU(v,105312);mU(u,bJ(a,v)|0);dJ(u,b+32|0,0);wU(u);wU(v);i=c;return}function aJ(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){tz(22,0,108520,d);i=d;return}else{c[b>>2]=Dd(TU(a)|0)|0;i=d;return}}function bJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=mN(a,f,b)|0;l=c[k>>2]|0;NF(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}oN(j,a,b);pN(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];nN(g,e);qN(j);j=c[f>>2]|0;rN(a,j,k,sN(g)|0);k=tN(g)|0;qN(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function cJ(a,b){a=a|0;b=b|0;var d=0;d=i;if((WU(a,105488)|0)==0){c[b>>2]=1;i=d;return}if((WU(a,105496)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Hc(TU(a)|0)|0;i=d;return}}function dJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((WU(a,105464)|0)==0){c[b>>2]=d}if((WU(a,105488)|0)==0){c[b>>2]=1;i=e;return}if((WU(a,105496)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Hc(TU(a)|0)|0;i=e;return}}function eJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;qU(j,105328);mU(g,bJ(b,j)|0);y=d+48|0;fJ(g,y);wU(g);wU(j);qU(m,105344);mU(l,bJ(b,m)|0);j=d+56|0;gJ(l,j,0.0);wU(l);wU(m);qU(o,105352);mU(n,bJ(b,o)|0);m=d+32|0;fJ(n,m);wU(n);wU(o);qU(q,105360);mU(p,bJ(b,q)|0);o=d+33|0;fJ(p,o);wU(p);wU(q);qU(s,105376);mU(r,bJ(b,s)|0);q=d+40|0;gJ(r,q,1.0);wU(r);wU(s);qU(u,105384);mU(t,bJ(b,u)|0);s=d+16|0;gJ(t,s,-1.7976931348623157e+308);wU(t);wU(u);qU(w,105392);mU(v,bJ(b,w)|0);u=d+24|0;gJ(v,u,1.7976931348623157e+308);wU(v);wU(w);qU(x,105200);w=TU(bJ(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?105488:105496;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?105464:105472;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?105464:105480;c[f+20>>2]=j;c[f+24>>2]=m?105464:105472;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?105464:105480;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];rz(4,0,105400,f);wU(x);i=e;return}function fJ(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(WU(b,105488)|0)==0|0;i=d;return}function gJ(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((WU(a,105464)|0)==0){h[b>>3]=c;i=d;return}if((WU(a,105488)|0)==0){h[b>>3]=1.0;i=d;return}if((WU(a,105496)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+X2(TU(a)|0);i=d;return}}function hJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;qU(h,105328);mU(g,bJ(b,h)|0);s=d+13|0;fJ(g,s);wU(g);wU(h);qU(k,105344);mU(j,bJ(b,k)|0);h=d+16|0;dJ(j,h,0);wU(j);wU(k);qU(m,105352);mU(l,bJ(b,m)|0);k=d+12|0;fJ(l,k);wU(l);wU(m);qU(o,105384);mU(n,bJ(b,o)|0);m=d+4|0;dJ(n,m,-2147483648);wU(n);wU(o);qU(q,105392);mU(p,bJ(b,q)|0);o=d+8|0;dJ(p,o,2147483647);wU(p);wU(q);qU(r,105200);q=TU(bJ(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?105488:105496;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?105464:105472;c[f+8>>2]=s;c[f+12>>2]=b?105464:105480;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;rz(4,0,105504,f);wU(r);i=e;return}function iJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;qU(h,105328);mU(g,bJ(b,h)|0);o=d+5|0;fJ(g,o);wU(g);wU(h);qU(k,105344);mU(j,bJ(b,k)|0);h=d+6|0;fJ(j,h);wU(j);wU(k);qU(m,105352);mU(l,bJ(b,m)|0);k=d+4|0;fJ(l,k);wU(l);wU(m);qU(n,105200);m=TU(bJ(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?105488:105496;h=(a[k]|0)!=0?105488:105496;c[f>>2]=m;c[f+4>>2]=b?105464:105472;c[f+8>>2]=o;c[f+12>>2]=b?105464:105480;c[f+16>>2]=h;rz(4,0,105560,f);wU(n);i=e;return}function jJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;qU(h,105328);mU(g,bJ(b,h)|0);m=d+4|0;fJ(g,m);wU(g);wU(h);qU(k,105344);mU(j,bJ(b,k)|0);h=d+8|0;aJ(j,h);wU(j);wU(k);qU(l,105200);k=TU(bJ(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?105464:105472;c[f+8>>2]=m;c[f+12>>2]=b?105464:105480;rz(4,0,105600,f);wU(l);i=e;return}function kJ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;jc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;lJ(qa);kU(ra);mJ(sa,ta);mJ(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[118648>>2]|0)==0){qU(za,c[b+80>>2]|0);nJ(ya,za,105624);xU(ra,ya)|0;wU(ya);wU(za)}else{yU(ra,c[118776>>2]|0)|0}ta=kc(TU(ra)|0,105640)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=TU(ra)|0;vz(0,105648,pa)}else{Wc=0}}while(0);pa=iu(0)|0;if((pa|0)==0){_c(Wc|0)|0;vz(0,105752,oa)}tu(pa,Vc);uu(pa,9,60);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;h3(oa|0,0,1024)|0;while(1){za=tb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((vu(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){_c(Wc|0)|0;oa=TU(ra)|0;ya=Du(Au(pa)|0)|0;za=Bu(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;tz(1,0,105832,na);pu(pa);vz(0,105920,ma)}else if((Xc|0)==14){_c(Wc|0)|0;break}}else{if((vu(pa,Vc,d3(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Du(Au(pa)|0)|0;ta=Bu(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;zd(za|0,105944,la|0)|0;za=c[va>>2]|0;ta=Du(Au(pa)|0)|0;oa=Bu(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;tz(1,0,105960,ka);pu(pa);vz(0,105920,ja)}}while(0);ja=qa;qU(Ca,106048);rJ(Ba,ja,Ca);sJ(Da,ja);ka=qJ(Ba,Da)|0;wU(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=TU(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;tz(1,0,106056,ia)}else{qU(Ea,106048);Ba=$2(Da,TU(bJ(ja,Ea)|0)|0)|0;wU(Ea);if((Ba|0)==0){break}pu(pa);qU(Fa,106048);Ba=TU(bJ(ja,Fa)|0)|0;va=TU(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;tz(1,0,106104,ha);wU(Fa);vz(0,105920,ga)}}while(0);tJ(qa,b,c[118860>>2]|0,c[118864>>2]|0);rz(23,1,106200,fa);fa=qa+12|0;qU(Ha,106240);mU(Ga,bJ(fa,Ha)|0);ga=d;gJ(Ga,ga,0.0);wU(Ga);wU(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];rz(23,0,106256,ea);qU(Ja,106272);mU(Ia,bJ(fa,Ja)|0);ea=d+8|0;gJ(Ia,ea,1.0);wU(Ia);wU(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];rz(23,0,106288,da);qU(La,106304);mU(Ka,bJ(fa,La)|0);da=d+24|0;gJ(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);wU(Ka);wU(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];rz(23,0,106320,ca);qU(Na,106336);mU(Ma,bJ(fa,Na)|0);ca=d+32|0;gJ(Ma,ca,1.0e-5);wU(Ma);wU(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];rz(23,0,106352,ba);qU(Pa,106368);mU(Oa,bJ(fa,Pa)|0);ba=d+40|0;aJ(Oa,ba);wU(Oa);wU(Pa);c[aa>>2]=c[ba>>2];rz(23,0,106376,aa);qU(Ra,106400);mU(Qa,bJ(fa,Ra)|0);aa=d+44|0;aJ(Qa,aa);wU(Qa);wU(Ra);c[$>>2]=c[aa>>2];rz(23,0,106416,$);qU(Ta,106440);mU(Sa,bJ(fa,Ta)|0);fa=d+48|0;aJ(Sa,fa);wU(Sa);wU(Ta);c[_>>2]=c[fa>>2];rz(23,0,106456,_);qU(Va,106480);mU(Ua,bJ(ja,Va)|0);_=d+268|0;aJ(Ua,_);wU(Ua);wU(Va);c[Z>>2]=c[_>>2];rz(23,0,106504,Z);if((c[61204>>2]|0)!=0){ie[c[15416]&255](23)}qU(eb,106528);mU(db,bJ(ja,eb)|0);dJ(db,Wa,0);wU(db);wU(eb);qU(gb,106560);mU(fb,bJ(ja,gb)|0);dJ(fb,Xa,0);wU(fb);wU(gb);qU(ib,106592);mU(hb,bJ(ja,ib)|0);dJ(hb,Ya,0);wU(hb);wU(ib);qU(kb,106616);mU(jb,bJ(ja,kb)|0);dJ(jb,_a,0);wU(jb);wU(kb);qU(mb,106648);mU(lb,bJ(ja,mb)|0);dJ(lb,Za,0);wU(lb);wU(mb);qU(ob,106688);mU(nb,bJ(ja,ob)|0);dJ(nb,ab,0);wU(nb);wU(ob);qU(qb,106720);mU(pb,bJ(ja,qb)|0);dJ(pb,$a,0);wU(pb);wU(qb);qU(sb,106760);mU(rb,bJ(ja,sb)|0);dJ(rb,cb,0);wU(rb);wU(sb);qU(vb,106792);mU(ub,bJ(ja,vb)|0);dJ(ub,bb,0);wU(ub);wU(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}sb=b+132|0;if((c[_a>>2]|0)!=(c[sb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=107336;rz(4,1,107312,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=uJ(lb,wb)|0;$I(ib,jb+(kb*112|0)|0);eJ(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(xb,107352);jb=(WU(bJ(ib,xb)|0,105488)|0)==0;wU(xb);if(!jb){break}c[N>>2]=c[hb>>2];rz(4,0,107368,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);qU(yb,c[hb>>2]|0);c[(vJ(sa,yb)|0)>>2]=kb;wU(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[M>>2]=107400;rz(4,1,107312,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=uJ(lb,zb)|0;$I(fb,gb+(jb*112|0)|0);eJ(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Ab,107352);gb=(WU(bJ(fb,Ab)|0,105488)|0)==0;wU(Ab);if(!gb){break}c[L>>2]=c[eb>>2];rz(4,0,107368,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);qU(Bb,c[eb>>2]|0);c[(vJ(sa,Bb)|0)>>2]=jb;wU(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[K>>2]=107424;rz(4,1,107312,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=uJ(mb,Cb)|0;$I(gb,hb+(fb*112|0)|0);eJ(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Db,107352);hb=(WU(bJ(gb,Db)|0,105488)|0)==0;wU(Db);if(!hb){break}c[J>>2]=c[db>>2];rz(4,0,107368,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);qU(Eb,c[db>>2]|0);c[(vJ(sa,Eb)|0)>>2]=fb;wU(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[I>>2]=107440;rz(4,1,107312,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=uJ(ub,Fb)|0;$I(mb,kb+(ib*60|0)|0);hJ(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Gb,107352);kb=(WU(bJ(mb,Gb)|0,105488)|0)==0;wU(Gb);if(!kb){break}c[H>>2]=c[gb>>2];rz(4,0,107368,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);qU(Hb,c[gb>>2]|0);c[(vJ(sa,Hb)|0)>>2]=ib;wU(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[G>>2]=107464;rz(4,1,107312,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=uJ(ib,Ib)|0;$I(mb,ub+(lb*48|0)|0);iJ(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Jb,107352);ub=(WU(bJ(mb,Jb)|0,105488)|0)==0;wU(Jb);if(!ub){break}c[F>>2]=c[fb>>2];rz(4,0,107368,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);qU(Kb,c[fb>>2]|0);c[(vJ(sa,Kb)|0)>>2]=lb;wU(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[E>>2]=107488;rz(4,1,107312,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=uJ(lb,Lb)|0;$I(mb,ib+(rb*52|0)|0);jJ(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Mb,107352);ib=(WU(bJ(mb,Mb)|0,105488)|0)==0;wU(Mb);if(!ib){break}c[D>>2]=c[gb>>2];rz(4,0,107368,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);qU(Nb,c[gb>>2]|0);c[(vJ(sa,Nb)|0)>>2]=rb;wU(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[C>>2]=107512;rz(4,1,107312,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=uJ(rb,Ob)|0;$I(mb,lb+(pb*112|0)|0);eJ(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Pb,107352);lb=(WU(bJ(mb,Pb)|0,105488)|0)==0;wU(Pb);if(!lb){break}c[B>>2]=c[fb>>2];rz(4,0,107368,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);qU(Qb,c[fb>>2]|0);c[(vJ(ua,Qb)|0)>>2]=pb;wU(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[A>>2]=107528;rz(4,1,107312,A);if((c[sb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=uJ(pb,Rb)|0;$I(mb,rb+(nb*60|0)|0);hJ(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Sb,107352);rb=(WU(bJ(mb,Sb)|0,105488)|0)==0;wU(Sb);if(!rb){break}c[z>>2]=c[gb>>2];rz(4,0,107368,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);qU(Tb,c[gb>>2]|0);c[(vJ(ua,Tb)|0)>>2]=nb;wU(Tb);nb=nb+1|0;}while((nb|0)<(c[sb>>2]|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[y>>2]=107552;rz(4,1,107312,y);if((c[qb>>2]|0)>0){sb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[sb>>2]|0;c[Ub>>2]=ja;mb=uJ(nb,Ub)|0;$I(mb,pb+(ja*48|0)|0);iJ(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Vb,107352);pb=(WU(bJ(mb,Vb)|0,105488)|0)==0;wU(Vb);if(!pb){break}c[x>>2]=c[fb>>2];rz(4,0,107368,x);a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);qU(Wb,c[fb>>2]|0);c[(vJ(ua,Wb)|0)>>2]=ja;wU(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}c[w>>2]=107576;rz(4,1,107312,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;sb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=sb;mb=uJ(ja,Xb)|0;$I(mb,nb+(sb*52|0)|0);jJ(mb,nb+(sb*52|0)+36|0);gb=nb+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[118644>>2]|0)!=0){break}qU(Yb,107352);nb=(WU(bJ(mb,Yb)|0,105488)|0)==0;wU(Yb);if(!nb){break}c[v>>2]=c[gb>>2];rz(4,0,107368,v);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);qU(Zb,c[gb>>2]|0);c[(vJ(ua,Zb)|0)>>2]=sb;wU(Zb);sb=sb+1|0;}while((sb|0)<(c[ob>>2]|0))}if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}rz(4,1,107600,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){sb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=uJ(sb,_b)|0;$I(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);kU($b);c[bc>>2]=ja;mb=uJ(sb,bc)|0;qU(cc,107640);mU(ac,bJ(mb,cc)|0);wJ(ac,$b);wU(ac);wU(cc);mb=(WU($b,107648)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;rz(4,0,107664,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=uJ(sb,ec)|0;qU(fc,107704);mU(dc,bJ(nb,fc)|0);wJ(dc,$b);wU(dc);wU(fc);xJ(wa,sa,$b);xJ(xa,ua,$b);zJ(gc,sa);do{if(yJ(wa,gc)|0){nb=c[(AJ(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{zJ(hc,ua);if(yJ(xa,hc)|0){fb=c[(AJ(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((WU($b,107720)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);wU($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}fV(jc,107728,$b);nJ(ic,jc,107752);wU(jc);c[s>>2]=TU(ic)|0;vz(0,107768,s)}}while(0);if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}rz(4,1,107776,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;sb=0;while(1){c[lc>>2]=sb;gb=uJ(ja,lc)|0;$I(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);kU(mc);c[oc>>2]=sb;gb=uJ(ja,oc)|0;qU(pc,107640);mU(nc,bJ(gb,pc)|0);wJ(nc,mc);wU(nc);wU(pc);gb=(WU(mc,107648)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[p>>2]=c[nb+(sb*52|0)+16>>2];c[p+4>>2]=fb;rz(4,0,107664,p);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[rc>>2]=sb;fb=uJ(ja,rc)|0;qU(sc,107704);mU(qc,bJ(fb,sc)|0);wJ(qc,mc);wU(qc);wU(sc);xJ(wa,sa,mc);xJ(xa,ua,mc);zJ(tc,sa);if(yJ(wa,tc)|0){fb=c[(AJ(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{zJ(uc,ua);if(!(yJ(xa,uc)|0)){break}nb=c[(AJ(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}wU(mc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break c}}fV(wc,107816,mc);nJ(vc,wc,107752);wU(wc);c[o>>2]=TU(vc)|0;vz(0,107768,o)}}while(0);if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}rz(4,1,107840,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){sb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=uJ(sb,xc)|0;$I(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);kU(yc);c[Ac>>2]=ja;fb=uJ(sb,Ac)|0;qU(Bc,107640);mU(zc,bJ(fb,Bc)|0);wJ(zc,yc);wU(zc);wU(Bc);fb=(WU(yc,107648)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;rz(4,0,107664,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=uJ(sb,Dc)|0;qU(Ec,107704);mU(Cc,bJ(gb,Ec)|0);wJ(Cc,yc);wU(Cc);wU(Ec);xJ(wa,sa,yc);xJ(xa,ua,yc);zJ(Fc,sa);if(yJ(wa,Fc)|0){gb=c[(AJ(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{zJ(Gc,ua);if(!(yJ(xa,Gc)|0)){break}nb=c[(AJ(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}wU(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}fV(Ic,107880,yc);nJ(Hc,Ic,107752);wU(Ic);c[l>>2]=TU(Hc)|0;vz(0,107768,l)}}while(0);if((c[61128>>2]|0)!=0){ie[c[15416]&255](4)}rz(4,1,107904,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;sb=0;while(1){c[Jc>>2]=sb;gb=uJ(ja,Jc)|0;$I(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);kU(Kc);c[Mc>>2]=sb;gb=uJ(ja,Mc)|0;qU(Nc,107640);mU(Lc,bJ(gb,Nc)|0);wJ(Lc,Kc);wU(Lc);wU(Nc);gb=(WU(Kc,107648)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[g>>2]=c[nb+(sb*52|0)+16>>2];c[g+4>>2]=fb;rz(4,0,107664,g);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[Pc>>2]=sb;fb=uJ(ja,Pc)|0;qU(Qc,107704);mU(Oc,bJ(fb,Qc)|0);wJ(Oc,Kc);wU(Oc);wU(Qc);xJ(wa,sa,Kc);xJ(xa,ua,Kc);zJ(Rc,sa);if(yJ(wa,Rc)|0){fb=c[(AJ(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{zJ(Sc,ua);if(!(yJ(xa,Sc)|0)){break}nb=c[(AJ(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}wU(Kc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break e}}fV(Uc,107944,Kc);nJ(Tc,Uc,107752);wU(Uc);c[f>>2]=TU(Tc)|0;vz(0,107768,f)}}while(0);if((c[61128>>2]|0)==0){pu(pa);BJ(ua);BJ(sa);wU(ra);CJ(qa);i=e;return}ie[c[15416]&255](4);pu(pa);BJ(ua);BJ(sa);wU(ra);CJ(qa);i=e;return}}while(0);if((c[61200>>2]|c[15276]|0)==0){pu(pa);Yc=xd(0)|0;Fd(-1)}tz(22,1,106832,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;tz(22,0,106880,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;tz(22,0,106928,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;tz(22,0,106976,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;tz(22,0,107024,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;tz(22,0,107072,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;tz(22,0,107120,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;tz(22,0,107168,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;tz(22,0,107216,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;tz(22,0,107264,P);ie[c[15416]&255](22);pu(pa);Yc=xd(0)|0;Fd(-1)}function lJ(a){a=a|0;var b=0;b=i;nQ(a);i=b;return}function mJ(a,b){a=a|0;b=b|0;b=i;UL(a,0);i=b;return}function nJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;lU(a,d);e=uU(b)|0;f=aK(c)|0;XU(a,vU(b)|0,e,f+e|0);PU(a,c,f)|0;i=d;return}function oJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if(($2(b,108576)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{qU(g,v);w=bJ(u,g)|0;yU(w,c[d+((t|1)<<2)>>2]|0)|0;wU(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if(($2(b,108600)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{qU(h,g);u=bJ(t,h)|0;yU(u,c[d+((v|1)<<2)>>2]|0)|0;wU(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if(($2(b,108624)|0)!=0){do{if(($2(b,108880)|0)!=0){if(($2(b,108888)|0)==0){break}if(($2(b,108896)|0)==0){break}if(($2(b,108904)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=uJ(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){qU(r,c[t>>2]|0);w=bJ(g,r)|0;yU(w,c[d+((u|1)<<2)>>2]|0)|0;wU(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=uJ(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}qU(s,108912);yU(bJ(x,s)|0,b)|0;wU(s);i=e;return}DJ(j,k);kU(l);kU(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{qU(n,g);t=bJ(j,n)|0;yU(t,c[d+((x|1)<<2)>>2]|0)|0;wU(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}qU(o,108640);xU(l,bJ(j,o)|0)|0;wU(o);qU(p,108656);xU(m,bJ(j,p)|0)|0;wU(p);c[k>>2]=Hc(TU(l)|0)|0;if((WU(m,108672)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((WU(m,108680)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((WU(m,108688)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((WU(m,108696)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((WU(m,108704)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((WU(m,108712)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((WU(m,108720)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((WU(m,108728)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((WU(m,108736)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((WU(m,108744)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((WU(m,108752)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((WU(m,108760)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((WU(m,108768)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((WU(m,108776)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=TU(m)|0;qU(q,105200);N=TU(bJ(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;uz(0,(O|0)!=0|0,108784,f);wU(q);SO(uJ(c[b>>2]|0,s)|0,j)|0;wU(m);wU(l);LJ(j);i=e;return}function pJ(a,b){a=a|0;b=b|0;i=i;return}function qJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=DL(a,b)|0;i=c;return d|0}function rJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;ML(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];EL(a,f);i=e;return}function sJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;FL(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];EL(a,e);i=d;return}function tJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Xb=i;i=i+16|0;Yb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;DJ(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){vz(0,107968,n)}if(p){ec=Dd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;rz(23,0,108112,m);EJ(q);FJ(q,e,8);if(!(GJ(q)|0)){c[l>>2]=e;vz(0,108152,l)}kU(r);l=q;HJ(l,r)|0;mU(s,r);while(1){e=HJ(l,r)|0;if(!(gV(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}fV(t,108232,r);NU(s,t)|0;wU(t)}t=Dd(TU(s)|0)|0;IJ(q);wU(s);wU(r);JJ(q);fc=t}if((fc|0)==0){rz(23,0,108320,g);LJ(o);i=f;return}kU(u);kU(v);c[k>>2]=fc;rz(23,0,108240,k);k=Zb(fc|0,108232)|0;if((k|0)!=0){g=k;do{k=H2(12)|0;qU(k,g);t=UU(k,108272,0)|0;SU(w,k,0,t);xU(u,w)|0;wU(w);SU(x,k,t+1|0,(DU(k)|0)+~t|0);xU(v,x)|0;wU(x);xU(bJ(o,u)|0,v)|0;t=TU(u)|0;k=TU(v)|0;c[j>>2]=t;c[j+4>>2]=k;rz(23,0,108280,j);g=Zb(0,108232)|0;}while((g|0)!=0)}C2(fc);fc=a+12|0;qU(y,106368);g=bJ(fc,y)|0;qU(z,106368);if((KJ(o,z)|0)==0){qU(B,106368);gc=1;hc=0;ic=bJ(fc,B)|0}else{qU(A,106368);gc=0;hc=1;ic=bJ(o,A)|0}xU(g,ic)|0;if(gc){wU(B)}if(hc){wU(A)}wU(z);wU(y);qU(C,106240);y=bJ(fc,C)|0;qU(D,106240);if((KJ(o,D)|0)==0){qU(F,106240);jc=1;kc=0;lc=bJ(fc,F)|0}else{qU(E,106240);jc=0;kc=1;lc=bJ(o,E)|0}xU(y,lc)|0;if(jc){wU(F)}if(kc){wU(E)}wU(D);wU(C);qU(G,106272);C=bJ(fc,G)|0;qU(H,106272);if((KJ(o,H)|0)==0){qU(J,106272);mc=1;nc=0;oc=bJ(fc,J)|0}else{qU(I,106272);mc=0;nc=1;oc=bJ(o,I)|0}xU(C,oc)|0;if(mc){wU(J)}if(nc){wU(I)}wU(H);wU(G);qU(K,106304);G=bJ(fc,K)|0;qU(L,106304);if((KJ(o,L)|0)==0){qU(N,106304);pc=0;qc=1;rc=bJ(fc,N)|0}else{qU(M,106304);pc=1;qc=0;rc=bJ(o,M)|0}xU(G,rc)|0;if(qc){wU(N)}if(pc){wU(M)}wU(L);wU(K);qU(O,106336);K=bJ(fc,O)|0;qU(P,106336);if((KJ(o,P)|0)==0){qU(R,106336);sc=1;tc=0;uc=bJ(fc,R)|0}else{qU(Q,106336);sc=0;tc=1;uc=bJ(o,Q)|0}xU(K,uc)|0;if(sc){wU(R)}if(tc){wU(Q)}wU(P);wU(O);qU(S,106400);O=bJ(fc,S)|0;qU(T,106400);if((KJ(o,T)|0)==0){qU(V,106400);vc=1;wc=0;xc=bJ(fc,V)|0}else{qU(U,106400);vc=0;wc=1;xc=bJ(o,U)|0}xU(O,xc)|0;if(vc){wU(V)}if(wc){wU(U)}wU(T);wU(S);qU(W,106440);S=bJ(fc,W)|0;qU(X,106440);if((KJ(o,X)|0)==0){qU(Z,106440);yc=1;zc=0;Ac=bJ(fc,Z)|0}else{qU(Y,106440);yc=0;zc=1;Ac=bJ(o,Y)|0}xU(S,Ac)|0;if(yc){wU(Z)}if(zc){wU(Y)}wU(X);wU(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=uJ(Y,_)|0;qU($,105344);Ac=bJ(yc,$)|0;c[aa>>2]=Z;yc=uJ(Y,aa)|0;qU(ba,105200);if((KJ(o,bJ(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=uJ(Y,ea)|0;qU(fa,105344);Bc=1;Cc=0;Dc=bJ(yc,fa)|0}else{c[ca>>2]=Z;yc=uJ(Y,ca)|0;qU(da,105200);Bc=0;Cc=1;Dc=bJ(o,bJ(yc,da)|0)|0}xU(Ac,Dc)|0;if(Bc){wU(fa)}if(Cc){wU(da)}wU(ba);wU($);c[ga>>2]=Z;Ac=uJ(zc,ga)|0;qU(ha,105344);yc=bJ(Ac,ha)|0;c[ia>>2]=Z;Ac=uJ(zc,ia)|0;qU(ja,105200);if((KJ(o,bJ(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=uJ(zc,ma)|0;qU(na,105344);Ec=1;Fc=0;Gc=bJ(Ac,na)|0}else{c[ka>>2]=Z;Ac=uJ(zc,ka)|0;qU(la,105200);Ec=0;Fc=1;Gc=bJ(o,bJ(Ac,la)|0)|0}xU(yc,Gc)|0;if(Ec){wU(na)}if(Fc){wU(la)}wU(ja);wU(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=uJ(Hc,oa)|0;qU(pa,105344);ja=bJ(ha,pa)|0;c[qa>>2]=Z;ha=uJ(Hc,qa)|0;qU(ra,105200);if((KJ(o,bJ(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=uJ(Hc,ua)|0;qU(va,105344);Ic=1;Jc=0;Kc=bJ(ha,va)|0}else{c[sa>>2]=Z;ha=uJ(Hc,sa)|0;qU(ta,105200);Ic=0;Jc=1;Kc=bJ(o,bJ(ha,ta)|0)|0}xU(ja,Kc)|0;if(Ic){wU(va)}if(Jc){wU(ta)}wU(ra);wU(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=uJ(X,wa)|0;qU(xa,105344);ra=bJ(pa,xa)|0;c[ya>>2]=Z;pa=uJ(X,ya)|0;qU(za,105200);if((KJ(o,bJ(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=uJ(X,Ca)|0;qU(Da,105344);Lc=1;Mc=0;Nc=bJ(pa,Da)|0}else{c[Aa>>2]=Z;pa=uJ(X,Aa)|0;qU(Ba,105200);Lc=0;Mc=1;Nc=bJ(o,bJ(pa,Ba)|0)|0}xU(ra,Nc)|0;if(Lc){wU(Da)}if(Mc){wU(Ba)}wU(za);wU(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=uJ(Z,Ea)|0;qU(Fa,105344);Ba=bJ(za,Fa)|0;c[Ga>>2]=xa;za=uJ(Z,Ga)|0;qU(Ha,105200);if((KJ(o,bJ(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=uJ(Z,Ka)|0;qU(La,105344);Oc=1;Pc=0;Qc=bJ(za,La)|0}else{c[Ia>>2]=xa;za=uJ(Z,Ia)|0;qU(Ja,105200);Oc=0;Pc=1;Qc=bJ(o,bJ(za,Ja)|0)|0}xU(Ba,Qc)|0;if(Oc){wU(La)}if(Pc){wU(Ja)}wU(Ha);wU(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=uJ(xa,Ma)|0;qU(Na,105344);Ja=bJ(Ha,Na)|0;c[Oa>>2]=Fa;Ha=uJ(xa,Oa)|0;qU(Pa,105200);if((KJ(o,bJ(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=uJ(xa,Sa)|0;qU(Ta,105344);Rc=1;Sc=0;Tc=bJ(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=uJ(xa,Qa)|0;qU(Ra,105200);Rc=0;Sc=1;Tc=bJ(o,bJ(Ha,Ra)|0)|0}xU(Ja,Tc)|0;if(Rc){wU(Ta)}if(Sc){wU(Ra)}wU(Pa);wU(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=uJ(Fa,Ua)|0;qU(Va,105344);Ra=bJ(Pa,Va)|0;c[Wa>>2]=Na;Pa=uJ(Fa,Wa)|0;qU(Xa,105200);if((KJ(o,bJ(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=uJ(Fa,_a)|0;qU($a,105344);Uc=1;Vc=0;Wc=bJ(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=uJ(Fa,Ya)|0;qU(Za,105200);Uc=0;Vc=1;Wc=bJ(o,bJ(Pa,Za)|0)|0}xU(Ra,Wc)|0;if(Uc){wU($a)}if(Vc){wU(Za)}wU(Xa);wU(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=uJ(Na,ab)|0;qU(bb,105344);Za=bJ(Xa,bb)|0;c[cb>>2]=Va;Xa=uJ(Na,cb)|0;qU(db,105200);if((KJ(o,bJ(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=uJ(Na,gb)|0;qU(hb,105344);Xc=1;Yc=0;Zc=bJ(Xa,hb)|0}else{c[eb>>2]=Va;Xa=uJ(Na,eb)|0;qU(fb,105200);Xc=0;Yc=1;Zc=bJ(o,bJ(Xa,fb)|0)|0}xU(Za,Zc)|0;if(Xc){wU(hb)}if(Yc){wU(fb)}wU(db);wU(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=uJ(Va,ib)|0;qU(jb,105344);fb=bJ(db,jb)|0;c[kb>>2]=bb;db=uJ(Va,kb)|0;qU(lb,105200);if((KJ(o,bJ(db,lb)|0)|0)==0){c[ob>>2]=bb;db=uJ(Va,ob)|0;qU(pb,105344);_c=1;$c=0;ad=bJ(db,pb)|0}else{c[mb>>2]=bb;db=uJ(Va,mb)|0;qU(nb,105200);_c=0;$c=1;ad=bJ(o,bJ(db,nb)|0)|0}xU(fb,ad)|0;if(_c){wU(pb)}if($c){wU(nb)}wU(lb);wU(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=uJ(bb,qb)|0;qU(rb,105344);nb=bJ(lb,rb)|0;c[sb>>2]=jb;lb=uJ(bb,sb)|0;qU(tb,105200);if((KJ(o,bJ(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=uJ(bb,wb)|0;qU(xb,105344);bd=1;cd=0;dd=bJ(lb,xb)|0}else{c[ub>>2]=jb;lb=uJ(bb,ub)|0;qU(vb,105200);bd=0;cd=1;dd=bJ(o,bJ(lb,vb)|0)|0}xU(nb,dd)|0;if(bd){wU(xb)}if(cd){wU(vb)}wU(tb);wU(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=uJ(jb,yb)|0;qU(zb,105344);vb=bJ(tb,zb)|0;c[Ab>>2]=rb;tb=uJ(jb,Ab)|0;qU(Bb,105200);if((KJ(o,bJ(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=uJ(jb,Eb)|0;qU(Fb,105344);ed=1;fd=0;gd=bJ(tb,Fb)|0}else{c[Cb>>2]=rb;tb=uJ(jb,Cb)|0;qU(Db,105200);ed=0;fd=1;gd=bJ(o,bJ(tb,Db)|0)|0}xU(vb,gd)|0;if(ed){wU(Fb)}if(fd){wU(Db)}wU(Bb);wU(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=uJ(rb,Gb)|0;qU(Hb,105344);Db=bJ(Bb,Hb)|0;c[Ib>>2]=zb;Bb=uJ(rb,Ib)|0;qU(Jb,105200);if((KJ(o,bJ(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=uJ(rb,Mb)|0;qU(Nb,105344);hd=0;id=1;jd=bJ(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=uJ(rb,Kb)|0;qU(Lb,105200);hd=1;id=0;jd=bJ(o,bJ(Bb,Lb)|0)|0}xU(Db,jd)|0;if(id){wU(Nb)}if(hd){wU(Lb)}wU(Jb);wU(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=uJ(zb,Ob)|0;qU(Pb,105344);Lb=bJ(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=uJ(zb,Qb)|0;qU(Rb,105200);if((KJ(o,bJ(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=uJ(zb,Ub)|0;qU(Vb,105344);kd=1;ld=0;md=bJ(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=uJ(zb,Sb)|0;qU(Tb,105200);kd=0;ld=1;md=bJ(o,bJ(Jb,Tb)|0)|0}xU(Lb,md)|0;if(kd){wU(Vb)}if(ld){wU(Tb)}wU(Rb);wU(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=uJ(b,Wb)|0;qU(Xb,105344);Pb=bJ(Hb,Xb)|0;c[Yb>>2]=a;Hb=uJ(b,Yb)|0;qU(_b,105200);if((KJ(o,bJ(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=uJ(b,bc)|0;qU(cc,105344);nd=1;od=0;pd=bJ(Hb,cc)|0}else{c[$b>>2]=a;Hb=uJ(b,$b)|0;qU(ac,105200);nd=0;od=1;pd=bJ(o,bJ(Hb,ac)|0)|0}xU(Pb,pd)|0;if(nd){wU(cc)}if(od){wU(ac)}wU(_b);wU(Xb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}rz(23,0,108304,h);wU(v);wU(u);LJ(o);i=f;return}function uJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=bM(a,f,b)|0;l=c[k>>2]|0;NF(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}dM(j,a,b);eM(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];cM(g,e);fM(j);j=c[f>>2]|0;gM(a,j,k,hM(g)|0);k=iM(g)|0;fM(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function vJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=FK(a,f,b)|0;l=c[k>>2]|0;NF(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}HK(j,a,b);IK(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];GK(g,e);JK(j);j=c[f>>2]|0;KK(a,j,k,LK(g)|0);k=MK(g)|0;JK(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function wJ(a,b){a=a|0;b=b|0;var c=0;c=i;xU(b,a)|0;i=c;return}function xJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;wK(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];oK(a,f);i=e;return}function yJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=mK(a,b)|0;i=c;return d|0}function zJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;pK(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];oK(a,e);i=d;return}function AJ(a){a=a|0;var b=0,c=0;b=i;c=jK(a)|0;i=b;return c|0}function BJ(a){a=a|0;var b=0;b=i;IO(a);i=b;return}function CJ(a){a=a|0;var b=0;b=i;vO(a);i=b;return}function DJ(a,b){a=a|0;b=b|0;b=i;cN(a,0);i=b;return}function EJ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;tV(d);e=a;c[e>>2]=108372;f=d;c[f>>2]=108392;d=a+8|0;lW(a,108404|0,d);c[e>>2]=108372;c[f>>2]=108392;uI(d);i=b;return}function FJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(VF(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){kV(d,4);i=e;return}else{iV(d,0);i=e;return}}function GJ(a){a=a|0;var b=0,c=0;b=i;c=eK(a+8|0)|0;i=b;return c|0}function HJ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=dK(a,b,rV(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function IJ(a){a=a|0;var b=0;b=i;if((XF(a+8|0)|0)!=0){i=b;return}kV(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function JJ(a){a=a|0;var b=0;b=i;iK(a,108400);oV(a+108|0);i=b;return}function KJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=MJ(a,b)|0;i=c;return d|0}function LJ(a){a=a|0;var b=0;b=i;kO(a);i=b;return}function MJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=OJ(a)|0;NF(e);if((f|0)==0){g=0;i=d;return g|0}h=PJ(a)|0;a=f;while(1){f=a+16|0;if(QJ(h,b,f)|0){j=a}else{if(!(RJ(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;NF(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function NJ(a){a=a|0;var b=0,c=0;b=i;c=yF(XJ(a+4|0)|0)|0;i=b;return c|0}function OJ(a){a=a|0;var b=0,d=0;b=i;d=c[(NJ(a)|0)>>2]|0;i=b;return d|0}function PJ(a){a=a|0;var b=0,c=0;b=i;c=VJ(a+8|0)|0;i=b;return c|0}function QJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=SJ(0,b,c)|0;i=a;return d|0}function RJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=SJ(0,b,c)|0;i=a;return d|0}function SJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=TJ(b,c)|0;i=a;return d|0}function TJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(VU(a,b)|0)<0;i=c;return d|0}function UJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=_2(a,b,c)|0;i=d;return e|0}function VJ(a){a=a|0;var b=0,c=0;b=i;c=WJ(a)|0;i=b;return c|0}function WJ(a){a=a|0;i=i;return a|0}function XJ(a){a=a|0;var b=0,c=0;b=i;c=YJ(a)|0;i=b;return c|0}function YJ(a){a=a|0;i=i;return a|0}function ZJ(a,b){a=a|0;b=b|0;var c=0;a=i;c=$J(0,b,0)|0;i=a;return c|0}function _J(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function $J(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=H2(b)|0;i=c;return a|0}function aK(a){a=a|0;var b=0,c=0;b=i;c=d3(a|0)|0;i=b;return c|0}function bK(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=cK(b,c,e)|0;i=d;return g|0}function cK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=RG(0,a,b)|0;i=c;return(d?b:a)|0}function dK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;qW(f,a,1);if(!(tW(f)|0)){i=e;return a|0}MU(b);f=0;while(1){g=zV(pV(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(HG(g,-1)|0){h=2;j=f;break}k=f+1|0;l=IG(g)|0;if(MG(l,d)|0){h=0;j=k;break}OU(b,l);if((uU(b)|0)==-17){h=4;j=k;break}else{f=k}}kV(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function eK(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function fK(a){a=a|0;var b=0;b=i;JJ(a);J2(a);i=b;return}function gK(a){a=a|0;var b=0;b=i;JJ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function hK(a){a=a|0;var b=0;b=i;fK(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function iK(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];vG(a+8|0);i=d;return}function jK(a){a=a|0;var b=0,d=0;b=i;d=kK((c[a>>2]|0)+16|0)|0;i=b;return d|0}function kK(a){a=a|0;var b=0,c=0;b=i;c=lK(a)|0;i=b;return c|0}function lK(a){a=a|0;i=i;return a|0}function mK(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(nK(a,b)|0)^1;i=c;return d|0}function nK(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function oK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];vK(a,e);i=d;return}function pK(a,b){a=a|0;b=b|0;var c=0;c=i;qK(a,rK(b)|0);i=c;return}function qK(a,b){a=a|0;b=b|0;var c=0;c=i;uK(a,b);i=c;return}function rK(a){a=a|0;var b=0,c=0;b=i;c=yF(sK(a+4|0)|0)|0;i=b;return c|0}function sK(a){a=a|0;var b=0,c=0;b=i;c=tK(a)|0;i=b;return c|0}function tK(a){a=a|0;i=i;return a|0}function uK(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function vK(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function wK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=yK(b)|0;xK(f,b,d,h,rK(b)|0);pK(g,b);do{if(mK(f,g)|0){h=zK(b)|0;if(AK(h,d,BK(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);pK(a,b);i=e;return}function xK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;NF(h);a:do{if((e|0)==0){j=f}else{k=zK(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(EK(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;NF(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;NF(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);qK(a,j);i=g;return}function yK(a){a=a|0;var b=0,d=0;b=i;d=c[(rK(a)|0)>>2]|0;i=b;return d|0}function zK(a){a=a|0;var b=0,c=0;b=i;c=CK(a+8|0)|0;i=b;return c|0}function AK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=SJ(0,b,c)|0;i=a;return d|0}function BK(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function CK(a){a=a|0;var b=0,c=0;b=i;c=DK(a)|0;i=b;return c|0}function DK(a){a=a|0;i=i;return a|0}function EK(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=SJ(0,b,c)|0;i=a;return d|0}function FK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=yK(h)|0;NF(e);if((a|0)==0){j=rK(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(SJ(0,d,a)|0){m=l;j=c[m>>2]|0;NF(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(SJ(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;NF(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function GK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];BL(a,e);i=d;return}function HK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=gL(d)|0;d=iL(n,1)|0;jL(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];hL(j,d,h);kL(0,$K((lL(j)|0)+16|0)|0,e);e=mL(j)|0;a[e+4|0]=1;nL(0,ZK((lL(j)|0)+28|0)|0);a[e+5|0]=1;oL(m,j);IK(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];GK(b,g);JK(m);JK(j);i=f;return}function IK(a,b){a=a|0;b=b|0;var c=0;c=i;eL(a,b);i=c;return}function JK(a){a=a|0;var b=0;b=i;VK(a);i=b;return}function KK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;NF(f);c[e>>2]=0;NF(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=RK(a)|0;b=c[c[e>>2]>>2]|0;NF(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(rK(a)|0)>>2]|0;xH(e,c[d>>2]|0);d=SK(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function LK(a){a=a|0;var b=0,d=0;b=i;d=c[(PK(a)|0)>>2]|0;i=b;return d|0}function MK(a){a=a|0;var b=0,d=0;b=i;d=NK(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function NK(a){a=a|0;var b=0,c=0;b=i;c=OK(a)|0;i=b;return c|0}function OK(a){a=a|0;i=i;return a|0}function PK(a){a=a|0;var b=0,c=0;b=i;c=QK(a)|0;i=b;return c|0}function QK(a){a=a|0;i=i;return a|0}function RK(a){a=a|0;i=i;return a|0}function SK(a){a=a|0;var b=0,c=0;b=i;c=TK(a+8|0)|0;i=b;return c|0}function TK(a){a=a|0;var b=0,c=0;b=i;c=UK(a)|0;i=b;return c|0}function UK(a){a=a|0;i=i;return a|0}function VK(a){a=a|0;var b=0;b=i;WK(a,0);i=b;return}function WK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=NK(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}YK(XK(e)|0,f);i=d;return}function XK(a){a=a|0;var b=0,c=0;b=i;c=dL(a)|0;i=b;return c|0}function YK(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;_K(f,$K(d+16|0)|0)}if((d|0)==0){i=e;return}aL(c[b>>2]|0,d,1);i=e;return}function ZK(a){a=a|0;i=i;return a|0}function _K(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;cL(d,0,c);i=b;return}function $K(a){a=a|0;i=i;return a|0}function aL(a,b,c){a=a|0;b=b|0;c=c|0;c=i;bL(0,b,0);i=c;return}function bL(a,b,c){a=a|0;b=b|0;c=c|0;c=i;J2(b);i=c;return}function cL(a,b,c){a=a|0;b=b|0;c=c|0;b=i;wU(c);i=b;return}function dL(a){a=a|0;i=i;return a+4|0}function eL(a,b){a=a|0;b=b|0;var c=0;c=i;fL(a,b);i=c;return}function fL(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function gL(a){a=a|0;var b=0,c=0;b=i;c=zL(a+4|0)|0;i=b;return c|0}function hL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];rL(a,b,f);i=e;return}function iL(a,b){a=a|0;b=b|0;var c=0;a=i;c=qL(0,b,0)|0;i=a;return c|0}function jL(a,b){a=a|0;b=b|0;var c=0;c=i;pL(a,b);i=c;return}function kL(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}mU(b,c);i=a;return}function lL(a){a=a|0;var b=0,d=0;b=i;d=c[(PK(a)|0)>>2]|0;i=b;return d|0}function mL(a){a=a|0;var b=0,c=0;b=i;c=XK(a)|0;i=b;return c|0}function nL(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function oL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;eL(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];GK(h,f);IK(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];GK(a,e);JK(h);i=d;return}function pL(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function qL(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=H2(b<<5)|0;i=c;return a|0}function rL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(tL(g)|0)>>2]|0;g=uL(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];sL(b,a,f);i=e;return}function sL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];vL(a,b,f);i=e;return}function tL(a){a=a|0;i=i;return a|0}function uL(a){a=a|0;i=i;return a|0}function vL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(xL(g)|0)>>2]|0;g=yL(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];wL(b,a,f);i=e;return}function wL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(xL(f)|0)>>2];f=yL(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}



function xL(a){a=a|0;i=i;return a|0}function yL(a){a=a|0;i=i;return a|0}function zL(a){a=a|0;var b=0,c=0;b=i;c=AL(a)|0;i=b;return c|0}function AL(a){a=a|0;i=i;return a|0}function BL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=MK(CL(b)|0)|0;h=yL(mL(CL(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];sL(g,a,e);i=d;return}function CL(a){a=a|0;i=i;return c[a>>2]|0}function DL(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function EL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];LL(a,e);i=d;return}function FL(a,b){a=a|0;b=b|0;var c=0;c=i;GL(a,HL(b)|0);i=c;return}function GL(a,b){a=a|0;b=b|0;var c=0;c=i;KL(a,b);i=c;return}function HL(a){a=a|0;var b=0,c=0;b=i;c=yF(IL(a+4|0)|0)|0;i=b;return c|0}function IL(a){a=a|0;var b=0,c=0;b=i;c=JL(a)|0;i=b;return c|0}function JL(a){a=a|0;i=i;return a|0}function KL(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function LL(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function ML(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=OL(b)|0;NL(f,b,d,h,HL(b)|0);FL(g,b);do{if(PL(f,g)|0){h=QL(b)|0;if(QJ(h,d,RL(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);FL(a,b);i=e;return}function NL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;NF(h);a:do{if((e|0)==0){j=f}else{k=QL(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(RJ(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;NF(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;NF(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);GL(a,j);i=g;return}function OL(a){a=a|0;var b=0,d=0;b=i;d=c[(HL(a)|0)>>2]|0;i=b;return d|0}function PL(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(DL(a,b)|0)^1;i=c;return d|0}function QL(a){a=a|0;var b=0,c=0;b=i;c=SL(a+8|0)|0;i=b;return c|0}function RL(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function SL(a){a=a|0;var b=0,c=0;b=i;c=TL(a)|0;i=b;return c|0}function TL(a){a=a|0;i=i;return a|0}function UL(a,b){a=a|0;b=b|0;b=i;i=i+8|0;VL(a,b);i=b;return}function VL(a,b){a=a|0;b=b|0;b=i;WL(a,0);i=b;return}function WL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;XL(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;YL(f,0,e);e=rK(b)|0;c[(RK(b)|0)>>2]=e;i=d;return}function XL(a){a=a|0;var b=0;b=i;$L(a);i=b;return}function YL(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;ZL(b,c,f);i=e;return}function ZL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(pI(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;_L(d,b,f);i=e;return}function _L(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(pI(e)|0)>>2];i=d;return}function $L(a){a=a|0;var b=0;b=i;aM(a);i=b;return}function aM(a){a=a|0;var b=0;b=i;sI(a);i=b;return}function bM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=bN(h)|0;NF(e);if((a|0)==0){j=oM(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(KF(0,d,a)|0){m=l;j=c[m>>2]|0;NF(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(KF(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;NF(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function cM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];$M(a,e);i=d;return}function dM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=GM(d)|0;d=IM(n,1)|0;JM(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];HM(j,d,h);KM(0,JH((LM(j)|0)+16|0)|0,e);e=MM(j)|0;a[e+4|0]=1;NM(0,zM((LM(j)|0)+20|0)|0);a[e+5|0]=1;OM(m,j);eM(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];cM(b,g);fM(m);fM(j);i=f;return}function eM(a,b){a=a|0;b=b|0;var c=0;c=i;EM(a,b);i=c;return}function fM(a){a=a|0;var b=0;b=i;uM(a);i=b;return}function gM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;NF(f);c[e>>2]=0;NF(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=nM(a)|0;b=c[c[e>>2]>>2]|0;NF(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(oM(a)|0)>>2]|0;xH(e,c[d>>2]|0);d=pM(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function hM(a){a=a|0;var b=0,d=0;b=i;d=c[(lM(a)|0)>>2]|0;i=b;return d|0}function iM(a){a=a|0;var b=0,d=0;b=i;d=jM(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function jM(a){a=a|0;var b=0,c=0;b=i;c=kM(a)|0;i=b;return c|0}function kM(a){a=a|0;i=i;return a|0}function lM(a){a=a|0;var b=0,c=0;b=i;c=mM(a)|0;i=b;return c|0}function mM(a){a=a|0;i=i;return a|0}function nM(a){a=a|0;i=i;return a|0}function oM(a){a=a|0;var b=0,c=0;b=i;c=yF(sM(a+4|0)|0)|0;i=b;return c|0}function pM(a){a=a|0;var b=0,c=0;b=i;c=qM(a+8|0)|0;i=b;return c|0}function qM(a){a=a|0;var b=0,c=0;b=i;c=rM(a)|0;i=b;return c|0}function rM(a){a=a|0;i=i;return a|0}function sM(a){a=a|0;var b=0,c=0;b=i;c=tM(a)|0;i=b;return c|0}function tM(a){a=a|0;i=i;return a|0}function uM(a){a=a|0;var b=0;b=i;vM(a,0);i=b;return}function vM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=jM(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}xM(wM(e)|0,f);i=d;return}function wM(a){a=a|0;var b=0,c=0;b=i;c=DM(a)|0;i=b;return c|0}function xM(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;yM(f,zM(d+20|0)|0)}if((d|0)==0){i=e;return}AM(c[b>>2]|0,d,1);i=e;return}function yM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;CM(d,0,c);i=b;return}function zM(a){a=a|0;i=i;return a|0}function AM(a,b,c){a=a|0;b=b|0;c=c|0;c=i;BM(0,b,0);i=c;return}function BM(a,b,c){a=a|0;b=b|0;c=c|0;c=i;J2(b);i=c;return}function CM(a,b,c){a=a|0;b=b|0;c=c|0;b=i;LJ(c);i=b;return}function DM(a){a=a|0;i=i;return a+4|0}function EM(a,b){a=a|0;b=b|0;var c=0;c=i;FM(a,b);i=c;return}function FM(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function GM(a){a=a|0;var b=0,c=0;b=i;c=ZM(a+4|0)|0;i=b;return c|0}function HM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];RM(a,b,f);i=e;return}function IM(a,b){a=a|0;b=b|0;var c=0;a=i;c=QM(0,b,0)|0;i=a;return c|0}function JM(a,b){a=a|0;b=b|0;var c=0;c=i;PM(a,b);i=c;return}function KM(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function LM(a){a=a|0;var b=0,d=0;b=i;d=c[(lM(a)|0)>>2]|0;i=b;return d|0}function MM(a){a=a|0;var b=0,c=0;b=i;c=wM(a)|0;i=b;return c|0}function NM(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}DJ(b,a);i=a;return}function OM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;EM(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];cM(h,f);eM(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];cM(a,e);fM(h);i=d;return}function PM(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function QM(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=H2(b<<5)|0;i=c;return a|0}function RM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(TM(g)|0)>>2]|0;g=UM(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];SM(b,a,f);i=e;return}function SM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];VM(a,b,f);i=e;return}function TM(a){a=a|0;i=i;return a|0}function UM(a){a=a|0;i=i;return a|0}function VM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(XM(g)|0)>>2]|0;g=YM(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];WM(b,a,f);i=e;return}function WM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(XM(f)|0)>>2];f=YM(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function XM(a){a=a|0;i=i;return a|0}function YM(a){a=a|0;i=i;return a|0}function ZM(a){a=a|0;var b=0,c=0;b=i;c=_M(a)|0;i=b;return c|0}function _M(a){a=a|0;i=i;return a|0}function $M(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=iM(aN(b)|0)|0;h=YM(MM(aN(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];SM(g,a,e);i=d;return}function aN(a){a=a|0;i=i;return c[a>>2]|0}function bN(a){a=a|0;var b=0,d=0;b=i;d=c[(oM(a)|0)>>2]|0;i=b;return d|0}function cN(a,b){a=a|0;b=b|0;b=i;i=i+8|0;dN(a,b);i=b;return}function dN(a,b){a=a|0;b=b|0;b=i;eN(a,0);i=b;return}function eN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;fN(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;gN(f,0,e);e=HL(b)|0;c[(hN(b)|0)>>2]=e;i=d;return}function fN(a){a=a|0;var b=0;b=i;kN(a);i=b;return}function gN(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;iN(b,c,f);i=e;return}function hN(a){a=a|0;i=i;return a|0}function iN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(pI(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;jN(d,b,f);i=e;return}function jN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(pI(e)|0)>>2];i=d;return}function kN(a){a=a|0;var b=0;b=i;lN(a);i=b;return}function lN(a){a=a|0;var b=0;b=i;sI(a);i=b;return}function mN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=OL(h)|0;NF(e);if((a|0)==0){j=HL(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(SJ(0,d,a)|0){m=l;j=c[m>>2]|0;NF(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(SJ(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;NF(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function nN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];iO(a,e);i=d;return}function oN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=PN(d)|0;d=RN(n,1)|0;SN(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];QN(j,d,h);TN(0,$K((UN(j)|0)+16|0)|0,e);e=VN(j)|0;a[e+4|0]=1;WN(0,GN((UN(j)|0)+28|0)|0);a[e+5|0]=1;XN(m,j);pN(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];nN(b,g);qN(m);qN(j);i=f;return}function pN(a,b){a=a|0;b=b|0;var c=0;c=i;NN(a,b);i=c;return}function qN(a){a=a|0;var b=0;b=i;BN(a);i=b;return}function rN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;NF(f);c[e>>2]=0;NF(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=hN(a)|0;b=c[c[e>>2]>>2]|0;NF(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(HL(a)|0)>>2]|0;xH(e,c[d>>2]|0);d=yN(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function sN(a){a=a|0;var b=0,d=0;b=i;d=c[(wN(a)|0)>>2]|0;i=b;return d|0}function tN(a){a=a|0;var b=0,d=0;b=i;d=uN(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function uN(a){a=a|0;var b=0,c=0;b=i;c=vN(a)|0;i=b;return c|0}function vN(a){a=a|0;i=i;return a|0}function wN(a){a=a|0;var b=0,c=0;b=i;c=xN(a)|0;i=b;return c|0}function xN(a){a=a|0;i=i;return a|0}function yN(a){a=a|0;var b=0,c=0;b=i;c=zN(a+8|0)|0;i=b;return c|0}function zN(a){a=a|0;var b=0,c=0;b=i;c=AN(a)|0;i=b;return c|0}function AN(a){a=a|0;i=i;return a|0}function BN(a){a=a|0;var b=0;b=i;CN(a,0);i=b;return}function CN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=uN(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}EN(DN(e)|0,f);i=d;return}function DN(a){a=a|0;var b=0,c=0;b=i;c=MN(a)|0;i=b;return c|0}function EN(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;FN(f,GN(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;HN(f,$K(d+16|0)|0)}if((d|0)==0){i=e;return}IN(c[b>>2]|0,d,1);i=e;return}function FN(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;LN(d,0,c);i=b;return}function GN(a){a=a|0;i=i;return a|0}function HN(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;KN(d,0,c);i=b;return}function IN(a,b,c){a=a|0;b=b|0;c=c|0;c=i;JN(0,b,0);i=c;return}function JN(a,b,c){a=a|0;b=b|0;c=c|0;c=i;J2(b);i=c;return}function KN(a,b,c){a=a|0;b=b|0;c=c|0;b=i;wU(c);i=b;return}function LN(a,b,c){a=a|0;b=b|0;c=c|0;b=i;wU(c);i=b;return}function MN(a){a=a|0;i=i;return a+4|0}function NN(a,b){a=a|0;b=b|0;var c=0;c=i;ON(a,b);i=c;return}function ON(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function PN(a){a=a|0;var b=0,c=0;b=i;c=gO(a+4|0)|0;i=b;return c|0}function QN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];_N(a,b,f);i=e;return}function RN(a,b){a=a|0;b=b|0;var c=0;a=i;c=ZN(0,b,0)|0;i=a;return c|0}function SN(a,b){a=a|0;b=b|0;var c=0;c=i;YN(a,b);i=c;return}function TN(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}mU(b,c);i=a;return}function UN(a){a=a|0;var b=0,d=0;b=i;d=c[(wN(a)|0)>>2]|0;i=b;return d|0}function VN(a){a=a|0;var b=0,c=0;b=i;c=DN(a)|0;i=b;return c|0}function WN(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}kU(b);i=a;return}function XN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;NN(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];nN(h,f);pN(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];nN(a,e);qN(h);i=d;return}function YN(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function ZN(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=H2(b*40|0)|0;i=c;return a|0}function _N(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(aO(g)|0)>>2]|0;g=bO(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];$N(b,a,f);i=e;return}function $N(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];cO(a,b,f);i=e;return}function aO(a){a=a|0;i=i;return a|0}function bO(a){a=a|0;i=i;return a|0}function cO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(eO(g)|0)>>2]|0;g=fO(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];dO(b,a,f);i=e;return}function dO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(eO(f)|0)>>2];f=fO(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function eO(a){a=a|0;i=i;return a|0}function fO(a){a=a|0;i=i;return a|0}function gO(a){a=a|0;var b=0,c=0;b=i;c=hO(a)|0;i=b;return c|0}function hO(a){a=a|0;i=i;return a|0}function iO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=tN(jO(b)|0)|0;h=fO(VN(jO(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];$N(g,a,e);i=d;return}function jO(a){a=a|0;i=i;return c[a>>2]|0}function kO(a){a=a|0;var b=0;b=i;lO(a);i=b;return}function lO(a){a=a|0;var b=0;b=i;mO(a);i=b;return}function mO(a){a=a|0;var b=0;b=i;nO(a,OL(a)|0);i=b;return}function nO(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;NF(d);if((b|0)==0){i=d;return}nO(a,c[b>>2]|0);nO(a,c[b+4>>2]|0);e=PN(a)|0;oO(e,pO(b+16|0)|0);IN(e,b,1);i=d;return}function oO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;qO(d,0,c);i=b;return}function pO(a){a=a|0;i=i;return a|0}function qO(a,b,c){a=a|0;b=b|0;c=c|0;b=i;rO(c);i=b;return}function rO(a){a=a|0;var b=0;b=i;sO(a);i=b;return}function sO(a){a=a|0;var b=0;b=i;tO(a);i=b;return}function tO(a){a=a|0;var b=0;b=i;uO(a);i=b;return}function uO(a){a=a|0;var b=0;b=i;wU(a+12|0);wU(a);i=b;return}function vO(a){a=a|0;var b=0;b=i;wO(a+180|0);wO(a+168|0);wO(a+156|0);wO(a+144|0);wO(a+132|0);wO(a+120|0);wO(a+108|0);wO(a+96|0);wO(a+84|0);wO(a+72|0);wO(a+60|0);wO(a+48|0);wO(a+36|0);wO(a+24|0);LJ(a+12|0);LJ(a);i=b;return}function wO(a){a=a|0;var b=0;b=i;xO(a);i=b;return}function xO(a){a=a|0;var b=0;b=i;yO(a);i=b;return}function yO(a){a=a|0;var b=0;b=i;zO(a);i=b;return}function zO(a){a=a|0;var b=0;b=i;AO(a,bN(a)|0);i=b;return}function AO(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;NF(d);if((b|0)==0){i=d;return}AO(a,c[b>>2]|0);AO(a,c[b+4>>2]|0);e=GM(a)|0;BO(e,CO(b+16|0)|0);AM(e,b,1);i=d;return}function BO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;DO(d,0,c);i=b;return}function CO(a){a=a|0;i=i;return a|0}function DO(a,b,c){a=a|0;b=b|0;c=c|0;b=i;EO(c);i=b;return}function EO(a){a=a|0;var b=0;b=i;FO(a);i=b;return}function FO(a){a=a|0;var b=0;b=i;GO(a);i=b;return}function GO(a){a=a|0;var b=0;b=i;HO(a);i=b;return}function HO(a){a=a|0;var b=0;b=i;LJ(a+4|0);i=b;return}function IO(a){a=a|0;var b=0;b=i;JO(a);i=b;return}function JO(a){a=a|0;var b=0;b=i;KO(a);i=b;return}function KO(a){a=a|0;var b=0;b=i;LO(a,yK(a)|0);i=b;return}function LO(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;NF(d);if((b|0)==0){i=d;return}LO(a,c[b>>2]|0);LO(a,c[b+4>>2]|0);e=gL(a)|0;MO(e,lK(b+16|0)|0);aL(e,b,1);i=d;return}function MO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;NO(d,0,c);i=b;return}function NO(a,b,c){a=a|0;b=b|0;c=c|0;b=i;OO(c);i=b;return}function OO(a){a=a|0;var b=0;b=i;PO(a);i=b;return}function PO(a){a=a|0;var b=0;b=i;QO(a);i=b;return}function QO(a){a=a|0;var b=0;b=i;RO(a);i=b;return}function RO(a){a=a|0;var b=0;b=i;wU(a);i=b;return}function SO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;TO(a);VO(g,b);WO(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];UO(a,f,e);i=d;return a|0}function TO(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;nO(a,OL(a)|0);c[(yN(a)|0)>>2]=0;d=HL(a)|0;c[(hN(a)|0)>>2]=d;NF(b);c[d>>2]=0;i=b;return}function UO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;cP(h,a);if(!(dP(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];XO(j,g);o=fP(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];eP(l,a,f,o);gP(b)|0;}while(dP(b,d)|0);i=e;return}function VO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;aP(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];XO(a,e);i=d;return}function WO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;YO(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];XO(a,e);i=d;return}function XO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];$O(a,e);i=d;return}function YO(a,b){a=a|0;b=b|0;var c=0;c=i;ZO(a,NJ(b)|0);i=c;return}function ZO(a,b){a=a|0;b=b|0;var c=0;c=i;_O(a,b);i=c;return}function _O(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function $O(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function aP(a,b){a=a|0;b=b|0;var d=0;d=i;ZO(a,c[(bP(b)|0)>>2]|0);i=d;return}function bP(a){a=a|0;i=i;return a|0}function cP(a,b){a=a|0;b=b|0;var c=0;c=i;WO(a,b);i=c;return}function dP(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=mQ(a,b)|0;i=c;return d|0}function eP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];oP(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];nP(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];EL(a,g);rO(l);i=f;return}function fP(a){a=a|0;var b=0,c=0;b=i;c=kP(a)|0;i=b;return c|0}function gP(a){a=a|0;var b=0;b=i;hP(a)|0;i=b;return a|0}function hP(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=iP(c[d>>2]|0)|0;i=b;return a|0}function iP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;NF(b);if((e|0)==0){e=a;while(1){a=BH(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=jP(c[d>>2]|0)|0;i=b;return g|0}return 0}function jP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;NF(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;NF(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function kP(a){a=a|0;var b=0,d=0;b=i;d=lP((c[a>>2]|0)+16|0)|0;i=b;return d|0}function lP(a){a=a|0;var b=0,c=0;b=i;c=mP(a)|0;i=b;return c|0}function mP(a){a=a|0;i=i;return a|0}function nP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=sP(b,h,j,e)|0;h=c[p>>2]|0;NF(l);if((h|0)!=0){q=h;GL(a,q);i=f;return}uP(o,b,e);vP(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];tP(m,g);wP(o);o=c[j>>2]|0;rN(b,o,p,xP(m)|0);p=yP(m)|0;wP(m);q=p;GL(a,q);i=f;return}function oP(a,b){a=a|0;b=b|0;var c=0;c=i;pP(a,b);i=c;return}function pP(a,b){a=a|0;b=b|0;var c=0;c=i;qP(a,b);i=c;return}function qP(a,b){a=a|0;b=b|0;var c=0;c=i;rP(a,b);i=c;return}function rP(a,b){a=a|0;b=b|0;var c=0;c=i;mU(a,b);mU(a+12|0,b+12|0);i=c;return}function sP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;FL(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];aQ(l,k);do{if(!($P(b,l)|0)){k=QL(a)|0;x=cQ(b)|0;if(bQ(k,e,x)|0){break}w=bQ(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];gQ(r,h,1,0);FL(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];aQ(t,g);do{if(!($P(r,t)|0)){if(bQ(k,e,cQ(r)|0)|0){break}y=fQ(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;NF(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;dQ(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];aQ(o,j);do{if(!($P(n,o)|0)){j=QL(a)|0;if(bQ(j,cQ(eQ(n)|0)|0,e)|0){break}y=fQ(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;NF(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function tP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];ZP(a,e);i=d;return}function uP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=PN(d)|0;d=RN(n,1)|0;LP(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];KP(j,d,h);MP(0,pO((NP(j)|0)+16|0)|0,e);a[(OP(j)|0)+4|0]=1;PP(m,j);vP(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];tP(b,g);wP(m);wP(j);i=f;return}function vP(a,b){a=a|0;b=b|0;var c=0;c=i;IP(a,b);i=c;return}function wP(a){a=a|0;var b=0;b=i;DP(a);i=b;return}function xP(a){a=a|0;var b=0,d=0;b=i;d=c[(BP(a)|0)>>2]|0;i=b;return d|0}function yP(a){a=a|0;var b=0,d=0;b=i;d=zP(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function zP(a){a=a|0;var b=0,c=0;b=i;c=AP(a)|0;i=b;return c|0}function AP(a){a=a|0;i=i;return a|0}function BP(a){a=a|0;var b=0,c=0;b=i;c=CP(a)|0;i=b;return c|0}function CP(a){a=a|0;i=i;return a|0}function DP(a){a=a|0;var b=0;b=i;EP(a,0);i=b;return}function EP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=zP(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}GP(FP(e)|0,f);i=d;return}function FP(a){a=a|0;var b=0,c=0;b=i;c=HP(a)|0;i=b;return c|0}function GP(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;oO(f,pO(d+16|0)|0)}if((d|0)==0){i=e;return}IN(c[b>>2]|0,d,1);i=e;return}function HP(a){a=a|0;i=i;return a+4|0}function IP(a,b){a=a|0;b=b|0;var c=0;c=i;JP(a,b);i=c;return}function JP(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function KP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];TP(a,b,f);i=e;return}function LP(a,b){a=a|0;b=b|0;var c=0;c=i;SP(a,b);i=c;return}function MP(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}QP(b,c);i=a;return}function NP(a){a=a|0;var b=0,d=0;b=i;d=c[(BP(a)|0)>>2]|0;i=b;return d|0}function OP(a){a=a|0;var b=0,c=0;b=i;c=FP(a)|0;i=b;return c|0}function PP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;IP(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];tP(h,f);vP(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];tP(a,e);wP(h);i=d;return}function QP(a,b){a=a|0;b=b|0;var c=0;c=i;RP(a,b);i=c;return}function RP(a,b){a=a|0;b=b|0;var c=0;c=i;qP(a,b);i=c;return}function SP(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function TP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(aO(g)|0)>>2]|0;g=VP(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];UP(b,a,f);i=e;return}function UP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];WP(a,b,f);i=e;return}function VP(a){a=a|0;i=i;return a|0}function WP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(eO(g)|0)>>2]|0;g=YP(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];XP(b,a,f);i=e;return}function XP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(eO(f)|0)>>2];f=YP(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function YP(a){a=a|0;i=i;return a|0}function ZP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=yP(_P(b)|0)|0;h=YP(OP(_P(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];UP(g,a,e);i=d;return}function _P(a){a=a|0;i=i;return c[a>>2]|0}function $P(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function aQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];lQ(a,e);i=d;return}function bQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=SJ(0,b,c)|0;i=a;return d|0}function cQ(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function dQ(a,b){a=a|0;b=b|0;var d=0;d=i;GL(a,c[(hN(b)|0)>>2]|0);i=d;return}function eQ(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=jQ(c[d>>2]|0)|0;i=b;return a|0}function fQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=OL(a)|0;NF(e);if((h|0)==0){j=HL(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=QL(a)|0;a=h;while(1){h=a+16|0;if(bQ(j,d,h)|0){l=a;m=c[l>>2]|0;NF(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(bQ(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;NF(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function gQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;hQ(b,d);c[a>>2]=c[b>>2];i=e;return}function hQ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;iQ(b,c,e);i=d;return}function iQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{eQ(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{hP(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function jQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;NF(b);if((e|0)==0){e=a;while(1){a=BH(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=kQ(c[d>>2]|0)|0;i=b;return g|0}return 0}function kQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;NF(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;NF(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function lQ(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function mQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=($P(a,b)|0)^1;i=c;return d|0}function nQ(a){a=a|0;var b=0;b=i;i=i+128|0;DJ(a,b);DJ(a+12|0,b+8|0);oQ(a+24|0,b+16|0);oQ(a+36|0,b+24|0);oQ(a+48|0,b+32|0);oQ(a+60|0,b+40|0);oQ(a+72|0,b+48|0);oQ(a+84|0,b+56|0);oQ(a+96|0,b+64|0);oQ(a+108|0,b+72|0);oQ(a+120|0,b+80|0);oQ(a+132|0,b+88|0);oQ(a+144|0,b+96|0);oQ(a+156|0,b+104|0);oQ(a+168|0,b+112|0);oQ(a+180|0,b+120|0);i=b;return}function oQ(a,b){a=a|0;b=b|0;b=i;pQ(a,0);i=b;return}function pQ(a,b){a=a|0;b=b|0;b=i;i=i+8|0;qQ(a,b);i=b;return}function qQ(a,b){a=a|0;b=b|0;b=i;rQ(a,0);i=b;return}function rQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;sQ(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;tQ(f,0,e);e=oM(b)|0;c[(nM(b)|0)>>2]=e;i=d;return}function sQ(a){a=a|0;var b=0;b=i;wQ(a);i=b;return}function tQ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;uQ(b,c,f);i=e;return}function uQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(pI(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;vQ(d,b,f);i=e;return}function vQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(pI(e)|0)>>2];i=d;return}function wQ(a){a=a|0;var b=0;b=i;xQ(a);i=b;return}function xQ(a){a=a|0;var b=0;b=i;sI(a);i=b;return}function yQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[118836>>2]|0;if((m|0)==0){n=0}else{o=H2(12)|0;qU(o,m);n=o}if((c[118752>>2]|0)!=0){c[15276]=1}if((n|0)==0){c[61116>>2]=1;c[61120>>2]=1;i=b;return}do{if((UU(n,108976,0)|0)==-1){mU(g,n);kU(h);o=c[14850]|0;m=(o|0)<28;while(1){p=UU(g,108984,0)|0;q=(p|0)!=-1;if(q){SU(j,g,0,p);xU(h,j)|0;wU(j);SU(k,g,p+1|0,-1);xU(g,k)|0;wU(k)}else{xU(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){qU(l,c[59816+(s<<2)>>2]|0);p=zQ(h,l)|0;wU(l);if(p){c[61112+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){tz(1,1,108992,f);if(m){v=o}else{w=61664;x=c[15416]|0;ie[x&255](1);y=TU(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=109032;E=D;vz(0,E,a)}do{p=c[60984+(v<<2)>>2]|0;c[e>>2]=c[59816+(v<<2)>>2];c[e+4>>2]=p;tz(1,0,109016,e);v=v+1|0;}while((v|0)<28);w=61664;x=c[15416]|0;ie[x&255](1);y=TU(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=109032;E=D;vz(0,E,a)}else if((t|0)==20){tz(1,1,108992,d);w=61664;x=c[15416]|0;ie[x&255](1);y=TU(n)|0;z=a;A=z;c[A>>2]=y;B=6;C=B;D=109032;E=D;vz(0,E,a)}else if((t|0)==23){wU(h);wU(g);break}}else{o=1;do{c[61112+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[61116>>2]=1;c[61120>>2]=1;if((c[61148>>2]|0)!=0){c[61208>>2]=1}if((c[61204>>2]|0)==1){c[61212>>2]=1}if((c[61184>>2]|0)!=0){c[61180>>2]=1}if((c[61192>>2]|0)!=0){c[61180>>2]=1}if((c[61144>>2]|0)!=0){c[61140>>2]=1}if((c[61188>>2]|0)!=0){c[61180>>2]=1}if((c[61136>>2]|0)!=0){c[61132>>2]=1}wU(n);J2(n);i=b;return}function zQ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=uU(b)|0;if((e|0)!=(uU(c)|0)){f=0;i=d;return f|0}g=vU(b)|0;h=vU(c)|0;if(nU(b)|0){f=(UJ(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function AQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[118844>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=H2(12)|0;l=k;qU(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(BQ(l,c[94072+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=TU(l)|0;tz(1,1,109064,g);g=c[94156>>2]|0;c[f>>2]=c[94076>>2];c[f+4>>2]=g;tz(1,0,109016,f);f=c[94160>>2]|0;c[e>>2]=c[94080>>2];c[e+4>>2]=f;tz(1,0,109016,e);e=c[94164>>2]|0;c[d>>2]=c[94084>>2];c[d+4>>2]=e;tz(1,0,109016,d);ie[c[15416]&255](1);vz(0,109120,a)}else if((n|0)==6){i=b;return j|0}return 0}function BQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(WU(a,b)|0)==0;i=c;return d|0}function CQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[118828>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=H2(12)|0;l=k;qU(l,h);if((k|0)==0){j=1;i=b;return j|0}qU(f,109144);k=zQ(l,f)|0;wU(f);if(k){j=1;i=b;return j|0}qU(g,109152);k=zQ(l,g)|0;wU(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=TU(l)|0;tz(1,1,109160,e);c[d>>2]=109144;c[d+4>>2]=109216;tz(1,0,109016,d);c[a>>2]=109152;c[a+4>>2]=109232;tz(1,0,109016,a);ie[c[15416]&255](1);vz(0,109120,b)}return 0}function DQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;FW(f,a);if(!(IW(f)|0)){GW(f);i=d;return a|0}j=aK(b)|0;RQ(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((RF(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=qV(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];UQ(h,e,b,m,k,l,n);if(!(SQ(h)|0)){GW(f);i=d;return a|0}kV(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);GW(f);i=d;return a|0}function EQ(a){a=a|0;var b=0;b=i;LW(a,rV(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;sW(a)|0;i=b;return a|0}function FQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;qU(h,d);fV(k,109240,h);nJ(j,k,109248);wU(k);k=TU(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if(($2(c[n+4>>2]|0,109256)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if(($2(k,109264)|0)==0){wU(j);wU(h);i=f;return}d=J1(g,k,1)|0;if((d|0)!=0){m=l;h3(m|0,0,2048)|0;W1(d,g,m,2048)|0;JW(DQ(DQ(DQ(DQ(DQ(131232,109272)|0,k)|0,109312)|0,m)|0,109328)|0,104)|0;wU(j);wU(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(X1(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==0){r=(X1(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==1){q=(X1(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){d=b+4|0;m=o;o=0;while(1){p=c[d>>2]|0;if((a[p+(o*60|0)+56|0]|0)==0){l=(X1(g,c[p+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(o*60|0)+56|0]=l;s=c[k>>2]|0}else{s=m}l=o+1|0;if((l|0)<(s|0)){m=s;o=l}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;m=b+4|0;k=(e|0)==0;d=b+20|0;l=0;do{p=c[s>>2]|0;do{if((a[p+(l*52|0)+48|0]|0)==0){n=a[p+(l*52|0)+8|0]|0;if(n<<24>>24==1){q=(X1(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(l*52|0)+48|0]|0)!=0|k){break}a[(c[d>>2]|0)+((c[q+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(X1(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(l*52|0)+48|0]|0)!=0){break}a[(c[m>>2]|0)+((c[n+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);l=l+1|0;}while((l|0)<(c[o>>2]|0))}o=b+120|0;l=c[o>>2]|0;if((l|0)>0){m=b+8|0;s=l;l=0;while(1){d=c[m>>2]|0;if((a[d+(l*48|0)+44|0]|0)==0){k=(X1(g,c[d+(l*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[m>>2]|0)+(l*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=l+1|0;if((k|0)<(t|0)){s=t;l=k}else{break}}}l=b+216|0;if((c[l>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;m=b+24|0;k=0;do{d=c[t>>2]|0;do{if((a[d+(k*52|0)+48|0]|0)==0){p=a[d+(k*52|0)+8|0]|0;if(p<<24>>24==0){n=(X1(g,c[d+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(p<<24>>24==1){p=(X1(g,c[d+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=p;p=c[t>>2]|0;if((a[p+(k*52|0)+48|0]|0)!=0|o){break}a[(c[m>>2]|0)+((c[p+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[l>>2]|0))}l=b+124|0;k=c[l>>2]|0;if((k|0)>0){m=b+12|0;o=k;k=0;while(1){t=c[m>>2]|0;if((a[t+(k*52|0)+48|0]|0)==0){s=(X1(g,c[t+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[m>>2]|0)+(k*52|0)+48|0]=s;u=c[l>>2]|0}else{u=o}s=k+1|0;if((s|0)<(u|0)){o=u;k=s}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;o=b+12|0;l=(e|0)==0;e=b+28|0;b=0;do{m=c[u>>2]|0;do{if((a[m+(b*52|0)+48|0]|0)==0){s=a[m+(b*52|0)+8|0]|0;if(s<<24>>24==1){t=(X1(g,c[m+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0|l){break}a[(c[e>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(s<<24>>24==0){s=(X1(g,c[m+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=s;s=c[u>>2]|0;if((a[s+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[s+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}N1(g);wU(j);wU(h);i=f;return}function GQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[118692>>2]|0;H=c[118820>>2]|0;I=c[2]|0;if((c[61212>>2]|0)==0){if(!((c[118640>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Cb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;rz(23,0,109376,l);l=c[118764>>2]|0;do{if((l|0)==0){M=0}else{if(($2(l,109400)|0)==0){M=1;break}if(($2(l,109408)|0)==0){M=0;break}if(($2(l,109416)|0)==0){M=2;break}c[j>>2]=l;tz(1,0,109424,j);M=0}}while(0);if((bB(M)|0)!=0){c[g>>2]=l;tz(1,0,109496,g)}if((c[2]|0)!=0){QR(d+56|0);gB((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);cB(0);cB(6);dB(3);dB(4);dB(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+X2(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];rz(1,0,109584,f)}do{if((c[118748>>2]|0)!=0){f=H2(12)|0;J=f;qU(J,c[118876>>2]|0);if((f|0)==0){break}f=TU(J)|0;c[d+280>>2]=f;c[e>>2]=f;rz(23,0,109640,e)}}while(0);e=c[118872>>2]|0;kU(m);if((e|0)==0){qU(p,c[d+88>>2]|0);qU(q,109688);HQ(o,p,q);nJ(n,o,c[d+284>>2]|0);xU(m,n)|0;wU(n);wU(o);wU(q);wU(p)}else{yU(m,e)|0}qU(r,109696);qU(s,109696);qU(t,109696);qU(u,109696);qU(v,109696);qU(w,109696);e=c[118640>>2]|0;if((c[118660>>2]|0)!=0){yU(r,c[118788>>2]|0)|0}if((c[118676>>2]|0)!=0){yU(s,c[118804>>2]|0)|0}if((c[118656>>2]|0)!=0){yU(t,c[118784>>2]|0)|0}if((c[118664>>2]|0)==0){O=0.0}else{yU(u,c[118792>>2]|0)|0;O=+X2(TU(u)|0)}if((c[118668>>2]|0)==0){P=1}else{yU(v,c[118796>>2]|0)|0;P=Hc(TU(v)|0)|0}if((c[118728>>2]|0)!=0){yU(w,c[118856>>2]|0)|0}mU(x,m);mU(y,r);mU(z,s);mU(A,t);mU(B,w);p=IQ(d,x,y,z,A,O,P,B,e)|0;wU(B);wU(A);wU(z);wU(y);wU(x);if((p|0)!=0|g^1){Q=p}else{cB(5);p=fR(d)|0;fB(5);rz(1,0,109704,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;wU(w);wU(v);wU(u);wU(t);wU(s);wU(r);wU(m);i=b;return R|0}Q=d+88|0;qU(D,c[Q>>2]|0);nJ(C,D,109736);wU(D);qU(F,c[Q>>2]|0);nJ(E,F,109752);wU(F);fB(0);F=c[118840>>2]|0;Q=TU(C)|0;D=TU(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;ER(d,Q,D,(F|0)!=0?F:109768,I,p,TU(m)|0)|0;wU(E);wU(C);R=0;wU(w);wU(v);wU(u);wU(t);wU(s);wU(r);wU(m);i=b;return R|0}function HQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;lU(a,d);e=uU(b)|0;f=uU(c)|0;XU(a,vU(b)|0,e,f+e|0);PU(a,vU(c)|0,f)|0;i=d;return}function IQ(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((uU(j)|0)==0){u=0}else{u=TU(j)|0}mU(r,b);b=(JQ(a,r,k)|0)==0;wU(r);if(!b){v=-1;i=l;return v|0}qU(s,109696);b=a+280|0;r=BQ(s,c[b>>2]|0)|0;wU(s);do{if(r){w=3}else{s=1;k=0;do{qU(t,c[109912+(s<<2)>>2]|0);j=BQ(t,c[b>>2]|0)|0;wU(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];tz(1,0,109992,q);tz(1,0,108992,p);s=1;do{j=c[110024+(s<<2)>>2]|0;c[o>>2]=c[109912+(s<<2)>>2];c[o+4>>2]=j;tz(1,0,109016,o);s=s+1|0;}while((s|0)<20);vz(c[a+536>>2]|0,109120,n)}}while(0);c[m>>2]=c[109912+(w<<2)>>2];rz(23,0,110104,m);m=TU(d)|0;d=TU(e)|0;e=eE(a,m,d,TU(f)|0,g,h,w,u)|0;je[c[103356>>2]&127](103328,a);v=e;i=l;return v|0}function JQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[25832]=Dd(TU(b)|0)|0;c[103332>>2]=g;c[103336>>2]=d;d=a+284|0;do{if((c[27242]|0)==0){g=c[d>>2]|0;if(($2(109776,g)|0)==0){h=0;break}if(($2(109784,g)|0)==0){c[103344>>2]=61;c[103348>>2]=62;c[103356>>2]=63;h=0;break}if(($2(109792,g)|0)==0){c[103344>>2]=64;c[103348>>2]=65;c[103352>>2]=66;c[103356>>2]=67;h=1;break}if(($2(109800,g)|0)==0){c[103344>>2]=68;c[103348>>2]=69;c[103352>>2]=70;c[103356>>2]=71;h=1;break}if(($2(109808,g)|0)==0){c[103344>>2]=72;c[103348>>2]=73;c[103356>>2]=74;h=0;break}g=DQ(131232,109816)|0;JW(DQ(g,c[d>>2]|0)|0,104)|0;j=1;i=e;return j|0}else{h=0}}while(0);FQ(a+8|0,c[a+288>>2]|0,h);je[c[103344>>2]&127](103328,a);a=c[25832]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;rz(23,0,109840,f);j=0;i=e;return j|0}function KQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;iz();do{if((YR(a,b)|0)==0){if((_R(a,b)|0)!=0){break}do{if((c[118696>>2]|0)!=0){w=c[118824>>2]|0;if(($2(w,110224)|0)==0){oz(1);break}if(($2(w,110232)|0)==0){oz(0);break}else{c[p>>2]=w;tz(1,0,110240,p);xd(0)|0;Fd(0)}}}while(0);if((c[118652>>2]|0)==0){yQ(0,0);ZC(d);if((d|0)==0){JW(DQ(131232,110608)|0,104)|0}c[d+300>>2]=AQ(0,0)|0;c[d+292>>2]=CQ(0,0)|0;kJ(d+8|0,d+240|0);hD(d)|0;sD(d)|0;ED(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}JW(DQ(131232,110672)|0,104)|0;x=1;i=e;return x|0}}while(0);c[27242]=c[118720>>2];x=0;i=e;return x|0}qU(u,c[118780>>2]|0);w=1;while(1){y=66552+(w<<2)|0;qU(v,c[y>>2]|0);z=zQ(u,v)|0;wU(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=TU(u)|0;tz(1,0,110512,g);c[f>>2]=c[b>>2];tz(1,0,110552,f);xd(0)|0;Fd(0)}A=c[70576+(w<<2)>>2]|0;do{if((A|0)==1){z=c[70448+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;rz(1,1,110312,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[70448+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;rz(1,1,110352,n);break}else{c[m>>2]=z;tz(1,1,110192,m);break}}}while(0);if((w|0)==19){A=c[14850]|0;if((A|0)<28){D=A}else{E=61664;F=c[15416]|0;ie[F&255](1);G=xd(0)|0;Fd(0)}do{A=c[60984+(D<<2)>>2]|0;c[l>>2]=c[59816+(D<<2)>>2];c[l+4>>2]=A;rz(1,0,109016,l);D=D+1|0;}while((D|0)<28);E=61664;F=c[15416]|0;ie[F&255](1);G=xd(0)|0;Fd(0)}else if((w|0)==29){A=1;do{z=c[110024+(A<<2)>>2]|0;c[h>>2]=c[109912+(A<<2)>>2];c[h+4>>2]=z;rz(1,0,109016,h);A=A+1|0;}while((A|0)<20);E=61664;F=c[15416]|0;ie[F&255](1);G=xd(0)|0;Fd(0)}else if((w|0)==11){A=1;do{z=c[110480+(A<<2)>>2]|0;c[j>>2]=c[110448+(A<<2)>>2];c[j+4>>2]=z;rz(1,0,109016,j);A=A+1|0;}while((A|0)<7);E=61664;F=c[15416]|0;ie[F&255](1);G=xd(0)|0;Fd(0)}else if((w|0)==7){A=1;do{z=c[110432+(A<<2)>>2]|0;c[k>>2]=c[110416+(A<<2)>>2];c[k+4>>2]=z;rz(1,0,109016,k);A=A+1|0;}while((A|0)<4);E=61664;F=c[15416]|0;ie[F&255](1);G=xd(0)|0;Fd(0)}else{E=61664;F=c[15416]|0;ie[F&255](1);G=xd(0)|0;Fd(0)}}}while(0);c[t>>2]=c[b>>2];rz(1,1,110128,t);t=1;do{b=c[70576+(t<<2)>>2]|0;do{if((b|0)==1){G=c[68456+(t<<2)>>2]|0;c[s>>2]=c[66552+(t<<2)>>2];c[s+4>>2]=G;rz(1,0,110144,s)}else{G=c[66552+(t<<2)>>2]|0;if((b|0)==2){F=c[68456+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;rz(1,0,110160,r);break}else{c[q>>2]=G;tz(1,0,110192,q);break}}}while(0);t=t+1|0;}while((t|0)<31);ie[c[15416]&255](1);xd(0)|0;Fd(0);return 0}function LQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[27676]|0;ub(112352)|0;c[l>>2]=c[m+88>>2];ic(110712,l|0)|0;ub(112368)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];ic(110736,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];ic(110776,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ic(110808,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];ic(110840,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];ic(110872,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];ic(110904,b|0)|0;ub(112392)|0;i=a;return}function MQ(a,b){a=a|0;b=+b;i=i;return}function NQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;c3(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=q3(c[g>>2]|0,f)|0;if((k|0)==0){fb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(42,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=q3(c[g>>2]|0,f)|0;if((m|0)==0){fb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[27676]=d;u=0;Ha(63,10,208)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=q3(c[k>>2]|0,f)|0;if((p|0)==0){fb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(43,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=q3(c[g>>2]|0,f)|0;if((q|0)==0){fb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=q3(c[g>>2]|0,f)|0;if((r|0)==0){fb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=q3(c[g>>2]|0,f)|0;if((s|0)==0){fb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(111,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=q3(c[g>>2]|0,f)|0;if((t|0)==0){fb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=q3(c[g>>2]|0,f)|0;if((w|0)==0){fb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(209,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=q3(c[g>>2]|0,f)|0;if((x|0)==0){fb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=q3(c[g>>2]|0,f)|0;if((y|0)==0){fb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=q3(c[k>>2]|0,f)|0;if((A|0)==0){fb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function OQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=od(c[14704]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 1:{c[f>>2]=e;a=c[r>>2]|0;tc(111040,7,1,a|0)|0;Fc(a|0,d|0,f|0)|0;Vd(10,a|0)|0;xd(0)|0;fb(c[g+80>>2]|0,1);break};case 3:{if((c[61180>>2]|0)==0){i=b;return}c[f>>2]=e;a=c[r>>2]|0;tc(111040,7,1,a|0)|0;Fc(a|0,d|0,f|0)|0;Vd(10,a|0)|0;xd(0)|0;i=b;return};case 5:case 4:{i=b;return};case 2:{if((c[61124>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;fb(n|0,1)}c[f>>2]=e;e=c[r>>2]|0;tc(111040,7,1,e|0)|0;Fc(e|0,d|0,f|0)|0;Vd(10,e|0)|0;xd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;fb(n|0,1);break};default:{vz(g,111048,b)}}}function PQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;tc(111024,9,1,d|0)|0;Fc(d|0,b|0,e|0)|0;Vd(10,d|0)|0;xd(0)|0;i=a;return}function QQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;XQ(110968,b);c[27234]=109696;b=108940|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[108956>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;fb(k|0,1)}d=od(c[14704]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;fb(k|0,1)}function RQ(a,b){a=a|0;b=b|0;var c=0;c=i;TQ(a,b);i=c;return}function SQ(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function TQ(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=pV(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function UQ(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;NF(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=VQ(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((BV(b,d,r)|0)==(r|0)){break}NF(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){rU(l,s,h);if((BV(b,vU(l)|0,s)|0)==(s|0)){wU(l);break}NF(m);c[o>>2]=0;c[a>>2]=0;wU(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((BV(b,e,l)|0)==(l|0)){break}NF(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);WQ(g,0)|0;c[a>>2]=b;i=j;return}function VQ(a){a=a|0;i=i;return c[a+12>>2]|0}function WQ(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function XQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[27240]|0;if((g|0)==0){c[e>>2]=(d3(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(bK(e,f)|0)>>2]|0;c[27754]=h;f=B2(h)|0;c[27240]=f;j=h;k=f}else{j=c[27754]|0;k=g}g=$c(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[27754]|0)>>>0){i=d;return}C2(c[27240]|0);j=g<<1|1;c[27754]=j;g=B2(j)|0;c[27240]=g;$c(g|0,j|0,a|0,b|0)|0;i=d;return}function YQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;ZQ(g,16);_Q(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){$Q(a,g);aR(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){DQ(KW(m,+h[b+(p<<3)>>3])|0,112408)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){KW(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){DQ(m,112416)|0}}while((e|0)<(d|0));$Q(a,g);aR(g);i=f;return}function ZQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;tV(e);f=a;c[f>>2]=112788;g=e;c[g>>2]=112808;e=a+4|0;AW(a,112820|0,e);c[f>>2]=112788;c[g>>2]=112808;mR(e,b|16);i=d;return}function _Q(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function $Q(a,b){a=a|0;b=b|0;var c=0;c=i;gR(a,b+4|0);i=c;return}function aR(a){a=a|0;var b=0;b=i;qR(a,112816);oV(a+56|0);i=b;return}function bR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[61168>>2]|0)!=0){ub(113112)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(14,0,112424,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);le[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rz(14,0,112496,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[61168>>2]|0)==0){i=d;return 0}rz(14,0,112544,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ic(112560,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}fc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function cR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[61168>>2]|0)!=0){ub(113112)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(14,0,112424,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);le[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rz(14,0,112496,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[61168>>2]|0)==0){i=d;return 0}rz(14,0,112544,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ic(112560,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}fc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function dR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[61168>>2]|0)!=0){ub(113112)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(14,0,112424,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);le[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rz(14,0,112496,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[61168>>2]|0)==0){i=d;return 0}rz(14,0,112544,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ic(112560,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}fc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function eR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[61168>>2]|0)!=0){ub(113112)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];rz(14,0,112424,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);le[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];rz(14,0,112496,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[61168>>2]|0)==0){i=d;return 0}rz(14,0,112544,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];ic(112560,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}fc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function fR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=D2(fa(F,F)|0,8)|0;J=I;K=D2(fa(G,F)|0,8)|0;L=K;M=D2(fa(H,F)|0,8)|0;N=M;O=D2(fa(H,G)|0,8)|0;P=O;kU(p);kU(q);kU(r);kU(s);kU(t);kU(u);kU(v);Q=a+536|0;uz(c[Q>>2]|0,(I|0)!=0|0,112568,o);uz(c[Q>>2]|0,(K|0)!=0|0,112568,n);uz(c[Q>>2]|0,(M|0)!=0|0,112568,m);uz(c[Q>>2]|0,(O|0)!=0|0,112568,l);l=a+540|0;m=a;if((le[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;bR(a,J)|0;uz(n,1,112584,k)}YQ(w,J,F,F);xU(p,w)|0;wU(w);if((le[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;cR(a,L)|0;uz(w,1,112616,j)}YQ(x,L,F,G);xU(q,x)|0;wU(x);if((le[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;dR(a,N)|0;uz(x,1,112648,h)}YQ(y,N,H,F);xU(r,y)|0;wU(y);if((le[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;eR(a,P)|0;uz(m,1,112680,g)}YQ(z,P,H,G);xU(s,z)|0;wU(z);if((F|0)==0){yU(t,112712)|0}else{YQ(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);xU(t,A)|0;wU(A)}if((G|0)==0){yU(u,112712)|0}else{YQ(B,c[a+432>>2]|0,1,G);xU(u,B)|0;wU(B)}C2(I);C2(K);C2(M);C2(O);qU(E,c[a+84>>2]|0);fV(D,112728,E);nJ(C,D,112736);xU(v,C)|0;wU(C);wU(D);wU(E);E=kc(TU(v)|0,112744)|0;D=c[Q>>2]|0;c[f>>2]=TU(v)|0;uz(D,(E|0)!=0|0,112752,f);f=Fe[c[(c[l>>2]|0)+176>>2]&7]()|0;D=TU(t)|0;Q=TU(u)|0;C=TU(p)|0;a=TU(q)|0;O=TU(r)|0;M=TU(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;zd(E|0,f|0,e|0)|0;if((c[61212>>2]|0)==0){R=xd(E|0)|0;S=_c(E|0)|0;wU(v);wU(u);wU(t);wU(s);wU(r);wU(q);wU(p);i=b;return 0}e=Fe[c[(c[l>>2]|0)+176>>2]&7]()|0;l=TU(t)|0;f=TU(u)|0;M=TU(p)|0;O=TU(q)|0;a=TU(r)|0;C=TU(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;rz(25,0,e,d);R=xd(E|0)|0;S=_c(E|0)|0;wU(v);wU(u);wU(t);wU(s);wU(r);wU(q);wU(p);i=b;return 0}function gR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=JV(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}hR(a,IV(l)|0,n,e);i=d;return}if((h&8|0)==0){lU(a,g);i=d;return}else{g=b;b=DV(g)|0;hR(a,b,FV(g)|0,f);i=d;return}}function hR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;iR(a,b,c,0);i=d;return}function iR(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;jR(a,b,c);i=d;return}function jR(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=kR(c,d)|0;if(g>>>0>4294967279){iU(0)}if(g>>>0<11){CU(b,g);h=BU(b)|0}else{j=JU(g)|0;k=j+1|0;j=ZJ(pU(b)|0,k)|0;LU(b,j);KU(b,k);AU(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;_J(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){_J(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;_J(l,f);i=e;return}function kR(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=lR(b,c,e)|0;i=d;return g|0}function lR(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function mR(a,b){a=a|0;b=b|0;var c=0;c=i;CR(a,b);i=c;return}function nR(a){a=a|0;var b=0;b=i;aR(a);J2(a);i=b;return}function oR(a){a=a|0;var b=0;b=i;aR(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function pR(a){a=a|0;var b=0;b=i;nR(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function qR(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];rR(a+4|0);i=d;return}function rR(a){a=a|0;var b=0;b=i;sR(a);i=b;return}function sR(a){a=a|0;var b=0;b=i;c[a>>2]=112968;wU(a+32|0);xV(a);i=b;return}function tR(a){a=a|0;var b=0;b=i;rR(a);J2(a);i=b;return}function uR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=JV(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){$E(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}$E(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=JV(l)|0;j=m-(IV(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=EV(l)|0;m=j-(DV(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(vU(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){$E(a,-1,-1);i=h;return}q=n3(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(vU(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((EV(l)|0)!=0){break}$E(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((JV(l)|0)!=0){break}$E(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=DV(l)|0;HV(l,p,p+q|0,n)}if((g&16|0)!=0){p=IV(l)|0;MV(l,p,KV(l)|0);LV(l,q)}$E(a,q,e);i=h;return}}while(0);$E(a,-1,-1);i=h;return}function vR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=nG(d)|0;ue[g&31](a,b,h,J,0,e);i=f;return}function wR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=JV(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((FV(g)|0)>>>0<j>>>0){b=DV(g)|0;HV(g,b,EV(g)|0,j)}j=EV(g)|0;if(!(j>>>0<(FV(g)|0)>>>0)){k=-1;i=d;return k|0}k=LG(a[j]|0)|0;i=d;return k|0}function xR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=JV(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=DV(h)|0;j=EV(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(HG(d,-1)|0){HV(h,g,j+ -1|0,k);l=KG(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=IG(d)|0;do{if(g){if(MG(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=DV(h)|0;HV(h,j,(EV(h)|0)+ -1|0,k);a[EV(h)|0]=b;l=d;i=e;return l|0}function yR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(HG(b,-1)|0){f=KG(b)|0;i=d;return f|0}g=a;h=EV(g)|0;j=h-(DV(g)|0)|0;h=JV(g)|0;do{if((h|0)==(KV(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=IV(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;OU(o,0);HU(o,EU(o)|0);p=vU(o)|0;MV(g,p,p+(uU(o)|0)|0);LV(g,h-l|0);c[m>>2]=(IV(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(JV(g)|0)+1;h=c[(zR(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=vU(a+32|0)|0;HV(g,q,q+j|0,h)}f=AV(g,b&255)|0;i=d;return f|0}function zR(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=AR(b,c,e)|0;i=d;return g|0}function AR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=BR(0,a,b)|0;i=c;return(d?b:a)|0}function BR(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function CR(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;CV(a);c[a>>2]=112968;kU(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;kU(e);DR(a,e);wU(e);i=d;return}function DR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;xU(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=vU(e)|0;j=g+(uU(e)|0)|0;c[b>>2]=j;g=vU(e)|0;HV(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=uU(e)|0;c[b>>2]=(vU(e)|0)+h;HU(e,EU(e)|0);b=a;a=vU(e)|0;MV(b,a,a+(uU(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}LV(b,h);i=d;return}function ER(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=kc(d|0,113392)|0;J=dd(113400,113392)|0;K=(J|0)!=0;L=Pc()|0;if(K){M=c[b+536>>2]|0;N=Zd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;uz(M,(I|0)!=0|0,113456,E);tc(113480,17,1,J|0)|0;tc(113504,10,1,J|0)|0;tc(113520,18,1,J|0)|0;FR(J,f,113544,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,113576)}else{c[G>>2]=Zd(c[L>>2]|0)|0;tz(26,0,113408,G);G=c[b+536>>2]|0;E=Zd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;uz(G,(I|0)!=0|0,113456,F)}tc(113584,348,1,I|0)|0;if((uc(H|0)|0)<0){c[D>>2]=Zd(c[L>>2]|0)|0;tz(26,0,113936,D);_c(I|0)|0;bb(J|0)|0;O=1;i=j;return O|0}if((Uc(113136,250,113960,md(H|0)|0)|0)==0){tz(26,0,113984,C);_c(I|0)|0;O=1;i=j;return O|0}tc(114008,13,1,I|0)|0;tc(114024,12,1,I|0)|0;GR(I,2);tc(114040,6,1,I|0)|0;HR(I,c[b+84>>2]|0);tc(114048,8,1,I|0)|0;GR(I,2);tc(114064,8,1,I|0)|0;C=b+88|0;HR(I,c[C>>2]|0);tc(114080,10,1,I|0)|0;GR(I,2);tc(114096,6,1,I|0)|0;HR(I,113136);tc(114104,8,1,I|0)|0;GR(I,2);tc(114120,8,1,I|0)|0;HR(I,c[b+280>>2]|0);tc(114136,10,1,I|0)|0;GR(I,2);tc(114152,14,1,I|0)|0;HR(I,c[b+284>>2]|0);tc(114168,16,1,I|0)|0;GR(I,2);tc(114192,16,1,I|0)|0;HR(I,l);tc(114216,18,1,I|0)|0;GR(I,2);c[B>>2]=IR(l)|0;zd(I|0,114240,B|0)|0;GR(I,2);P=+ZA(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];zd(I|0,114280,A|0)|0;GR(I,2);P=+ZA(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];zd(I|0,114320,z|0)|0;GR(I,2);P=+ZA(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];zd(I|0,114352,y|0)|0;GR(I,2);P=+ZA(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];zd(I|0,114384,x|0)|0;GR(I,2);P=+ZA(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];zd(I|0,114416,w|0)|0;GR(I,2);P=+ZA(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];zd(I|0,114448,v|0)|0;GR(I,2);P=+ZA(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];zd(I|0,114488,u|0)|0;GR(I,2);P=+aB(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];zd(I|0,114520,t|0)|0;GR(I,2);c[s>>2]=XA(2)|0;zd(I|0,114560,s|0)|0;GR(I,2);P=+$A(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];zd(I|0,114584,r|0)|0;tc(114616,13,1,I|0)|0;tc(114632,16,1,I|0)|0;GR(I,2);P=+ZA(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];zd(I|0,114656,q|0)|0;GR(I,2);c[p>>2]=UA(8)|0;zd(I|0,114680,p|0)|0;tc(114720,17,1,I|0)|0;tc(114744,22,1,I|0)|0;JR(I,b);tc(114768,23,1,I|0)|0;tc(114792,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{KR(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{KR(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{KR(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{KR(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{KR(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{KR(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{KR(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{KR(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}tc(114808,13,1,I|0)|0;tc(114824,12,1,I|0)|0;LR(I,J,f,c[C>>2]|0,b);tc(114840,13,1,I|0)|0;tc(114856,12,1,I|0)|0;MR(I,c[b+68>>2]|0,b+56|0);tc(114872,13,1,I|0)|0;tc(114888,16,1,I|0)|0;NR(I,J,f,b);tc(114912,17,1,I|0)|0;tc(114936,14,1,I|0)|0;_c(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((d3(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(d3(K|0)|0)<<1}else{Q=0}I=B2(b+Q|0)|0;if((I|0)==0){db(114952,114960,404,114984)}if((bb(J|0)|0)!=0){tz(26,0,115e3,o)}if(e){e=c[C>>2]|0;c[n>>2]=115032;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;jc(I|0,115048,n|0)|0;if((ud(I|0)|0)!=0){R=42}}else{n=I+0|0;e=115128|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;tz(1,0,115160,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;rz(1,0,115224,g);C2(I);O=0;i=j;return O|0}



function X1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=B2(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=B2(y)|0;if((z|0)==0){A=12;break}h3(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=F1(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((k1(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((k1(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((k1(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((k1(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(k1(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(k1(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(k1(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(k1(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){h3(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=F1(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((k1(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((k1(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((k1(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((k1(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(k1(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(k1(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(k1(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(k1(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((o1(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=A1(X)|0;qb=_a+24|0;if((o1(fb,c[qb>>2]|0)|0)!=0){break}fb=y1(X)|0;if((o1(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((o1(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=y1(X)|0;if((o1(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=A1(X)|0;if((o1(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}C2(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=Z1(0,0)|0;if((S|0)==0){A=12;break}R=$1(S,0,0,0,32)|0;Q=R;if((R|0)==0){_1(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=B2(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=B2(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=B2(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){h3(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){h3(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=F1(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((k1(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((k1(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((k1(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((k1(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(k1(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(k1(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(k1(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(k1(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=$1(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=$1(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;Y1(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((a3(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=F1(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=F1(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((k1(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((k1(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((k1(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((k1(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(k1(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(k1(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(k1(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(k1(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((o1(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=A1(tc)|0;aa=Ca+24|0;if((o1(qa,c[aa>>2]|0)|0)!=0){break}qa=y1(tc)|0;if((o1(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((o1(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=y1(tc)|0;if((o1(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=A1(tc)|0;if((o1(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=$1(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=$1(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){_1(S);if((Eb|0)!=0){C2(O)}if((Kb|0)!=0){C2(Kb)}if((Lb|0)==0){A=12;break a}C2(N);A=12;break a}else if((sa|0)==67){_1(S);if((Eb|0)!=0){C2(O)}if((Kb|0)!=0){C2(Kb)}if((Lb|0)==0){A=12;break a}C2(N);A=12;break a}else if((sa|0)==169){_1(S);if((Eb|0)!=0){C2(O)}if((Kb|0)!=0){C2(Kb)}if((Lb|0)==0){A=12;break a}C2(N);A=12;break a}else if((sa|0)==176){_1(S);if((Eb|0)!=0){C2(O)}if((Kb|0)!=0){C2(Kb)}if((Lb|0)==0){A=12;break a}C2(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);_1(S);if((Jb|0)!=0){C2(Jb)}if((Gb|0)!=0){C2(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}C2(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}Y1(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}C2(m);p=A;i=g;return p|0}function Y1(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function Z1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=D2(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function _1(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;C2(e);i=b;return}else{f=d}while(1){C2(c[f>>2]|0);d=c[f+4>>2]|0;C2(f);if((d|0)==0){break}else{f=d}}e=a;C2(e);i=b;return}function $1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=B2(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=B2(p)|0;c[o>>2]=r;if((r|0)==0){C2(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}h3(m|0,0,h|0)|0;j=m;i=g;return j|0}function a2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((b2(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function b2(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function c2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function d2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function e2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function f2(a){a=a|0;i=i;return}function g2(a){a=a|0;c[a>>2]=151360;i=i;return}function h2(a){a=a|0;var b=0;b=i;Ab(a|0);J2(a);i=b;return}function i2(a){a=a|0;var b=0;b=i;Ab(a|0);i=b;return}function j2(a){a=a|0;i=i;return 151376}function k2(a){a=a|0;i=i;return}function l2(a){a=a|0;i=i;return}function m2(a){a=a|0;i=i;return}function n2(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function o2(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function p2(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function q2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=u2(b,151488,151544,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Le[c[(c[h>>2]|0)+28>>2]&63](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function r2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function s2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Le[c[(c[h>>2]|0)+28>>2]&63](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function t2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Le[c[(c[l>>2]|0)+28>>2]&63](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Le[c[(c[m>>2]|0)+28>>2]&63](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function u2(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;ue[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}fe[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function v2(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;ue[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;fe[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;fe[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;fe[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;fe[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function w2(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;fe[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;ue[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function x2(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function y2(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;ue[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;ue[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function z2(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;ue[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function A2(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function B2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[37948]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=151832+(j<<2)|0;l=151832+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[37948]=f&~(1<<h)}else{if(n>>>0<(c[151808>>2]|0)>>>0){jd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{jd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[151800>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=151832+(r<<2)|0;o=151832+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[37948]=f&~(1<<t)}else{if(n>>>0<(c[151808>>2]|0)>>>0){jd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{jd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[151800>>2]|0;if((n|0)!=0){f=c[151812>>2]|0;e=n>>>3;n=e<<1;g=151832+(n<<2)|0;m=c[37948]|0;j=1<<e;do{if((m&j|0)==0){c[37948]=m|j;u=151832+(n+2<<2)|0;v=g}else{e=151832+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[151808>>2]|0)>>>0)){u=e;v=h;break}jd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[151800>>2]=o;c[151812>>2]=s;p=k;i=b;return p|0}n=c[151796>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[152096+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[151808>>2]|0;if(h>>>0<k>>>0){jd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){jd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){jd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){jd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){jd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{jd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=152096+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[151796>>2]=c[151796>>2]&~(1<<h);break a}else{if(s>>>0<(c[151808>>2]|0)>>>0){jd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[151808>>2]|0)>>>0){jd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[151800>>2]|0;if((h|0)!=0){s=c[151812>>2]|0;k=h>>>3;h=k<<1;f=151832+(h<<2)|0;m=c[37948]|0;g=1<<k;do{if((m&g|0)==0){c[37948]=m|g;A=151832+(h+2<<2)|0;B=f}else{k=151832+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[151808>>2]|0)>>>0)){A=k;B=e;break}jd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[151800>>2]=t;c[151812>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[151796>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[152096+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[152096+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[151800>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[151808>>2]|0;if(t>>>0<f>>>0){jd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){jd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){jd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){jd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){jd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{jd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=152096+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[151796>>2]=c[151796>>2]&~(1<<e);break c}else{if(t>>>0<(c[151808>>2]|0)>>>0){jd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[151808>>2]|0)>>>0){jd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=151832+(t<<2)|0;s=c[37948]|0;r=1<<e;do{if((s&r|0)==0){c[37948]=s|r;S=151832+(t+2<<2)|0;T=f}else{e=151832+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[151808>>2]|0)>>>0)){S=e;T=k;break}jd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=152096+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[151796>>2]|0;l=1<<U;if((f&l|0)==0){c[151796>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[151808>>2]|0;if(W>>>0<k>>>0){jd()}if(r>>>0<k>>>0){jd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[151800>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[151812>>2]|0;if(W>>>0>15){c[151812>>2]=X+q;c[151800>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[151800>>2]=0;c[151812>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[151804>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[151804>>2]=W;X=c[151816>>2]|0;c[151816>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[38066]|0)==0){X=gd(30)|0;if((X+ -1&X|0)==0){c[152272>>2]=X;c[152268>>2]=X;c[152276>>2]=-1;c[152280>>2]=-1;c[152284>>2]=0;c[152236>>2]=0;c[38066]=(uc(0)|0)&-16^1431655768;break}else{jd()}}}while(0);X=q+48|0;W=c[152272>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[152232>>2]|0;do{if((U|0)!=0){T=c[152224>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[152236>>2]&4|0)==0){U=c[151816>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=152240|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[151804>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=lb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=lb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[152268>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[152224>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[152232>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=lb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[152272>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((lb(t|0)|0)==(-1|0)){lb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[152236>>2]=c[152236>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=lb(W|0)|0;ha=lb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[152224>>2]|0)+ga|0;c[152224>>2]=ia;if(ia>>>0>(c[152228>>2]|0)>>>0){c[152228>>2]=ia}ia=c[151816>>2]|0;W=152240|0;i:do{if((ia|0)==0){aa=c[151808>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[151808>>2]=fa}c[152240>>2]=fa;c[152244>>2]=ga;c[152252>>2]=0;c[151828>>2]=c[38066];c[151824>>2]=-1;aa=0;do{ha=aa<<1;$=151832+(ha<<2)|0;c[151832+(ha+3<<2)>>2]=$;c[151832+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[151816>>2]=fa+ja;c[151804>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[151820>>2]=c[152280>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[151804>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[151816>>2]=ia+na;c[151804>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[151820>>2]=c[152280>>2];break i}}while(0);if(fa>>>0<(c[151808>>2]|0)>>>0){c[151808>>2]=fa}aa=fa+ga|0;$=152240|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[151816>>2]|0)){ca=(c[151804>>2]|0)+X|0;c[151804>>2]=ca;c[151816>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[151812>>2]|0)){ca=(c[151800>>2]|0)+X|0;c[151800>>2]=ca;c[151812>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=151832+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[151808>>2]|0)>>>0){jd()}if((c[V+12>>2]|0)==(ha|0)){break}jd()}}while(0);if((L|0)==(V|0)){c[37948]=c[37948]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[151808>>2]|0)>>>0){jd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}jd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[151808>>2]|0)>>>0){jd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){jd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{jd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=152096+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[151796>>2]=c[151796>>2]&~(1<<t);break k}else{if(T>>>0<(c[151808>>2]|0)>>>0){jd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[151808>>2]|0)>>>0){jd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=151832+(Z<<2)|0;t=c[37948]|0;T=1<<ca;do{if((t&T|0)==0){c[37948]=t|T;xa=151832+(Z+2<<2)|0;ya=ea}else{ca=151832+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[151808>>2]|0)>>>0)){xa=ca;ya=V;break}jd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=152096+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[151796>>2]|0;L=1<<za;if((ea&L|0)==0){c[151796>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[151808>>2]|0;if(Ba>>>0<S>>>0){jd()}if(T>>>0<S>>>0){jd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=152240|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[151816>>2]=fa+Ha;c[151804>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[151820>>2]=c[152280>>2];c[ba+4>>2]=27;X=152240|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[152240>>2]=fa;c[152244>>2]=ga;c[152252>>2]=0;c[152248>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=151832+(da<<2)|0;aa=c[37948]|0;f=1<<M;do{if((aa&f|0)==0){c[37948]=aa|f;Ia=151832+(da+2<<2)|0;Ja=ha}else{M=151832+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[151808>>2]|0)>>>0)){Ia=M;Ja=T;break}jd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=152096+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[151796>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[151796>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[151808>>2]|0;if(Ma>>>0<f>>>0){jd()}if(M>>>0<f>>>0){jd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[151804>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[151804>>2]=W;ia=c[151816>>2]|0;c[151816>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Pc()|0)>>2]=12;p=0;i=b;return p|0}function C2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[151808>>2]|0;if(d>>>0<f>>>0){jd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){jd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){jd()}if((p|0)==(c[151812>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[151800>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=151832+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){jd()}if((c[m+12>>2]|0)==(p|0)){break}jd()}}while(0);if((u|0)==(m|0)){c[37948]=c[37948]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){jd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}jd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){jd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){jd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){jd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{jd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=152096+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[151796>>2]=c[151796>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[151808>>2]|0)>>>0){jd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[151808>>2]|0)>>>0){jd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){jd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){jd()}do{if((C&2|0)==0){if((l|0)==(c[151816>>2]|0)){f=(c[151804>>2]|0)+t|0;c[151804>>2]=f;c[151816>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[151812>>2]|0)){i=b;return}c[151812>>2]=0;c[151800>>2]=0;i=b;return}if((l|0)==(c[151812>>2]|0)){f=(c[151800>>2]|0)+t|0;c[151800>>2]=f;c[151812>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=151832+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[151808>>2]|0)>>>0){jd()}if((c[E+12>>2]|0)==(l|0)){break}jd()}}while(0);if((w|0)==(E|0)){c[37948]=c[37948]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[151808>>2]|0)>>>0){jd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}jd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[151808>>2]|0)>>>0){jd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){jd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{jd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=152096+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[151796>>2]=c[151796>>2]&~(1<<g);break b}else{if(d>>>0<(c[151808>>2]|0)>>>0){jd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[151808>>2]|0)>>>0){jd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[151812>>2]|0)){J=f;break}c[151800>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=151832+(C<<2)|0;G=c[37948]|0;j=1<<t;do{if((G&j|0)==0){c[37948]=G|j;K=151832+(C+2<<2)|0;L=e}else{t=151832+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[151808>>2]|0)>>>0)){K=t;L=a;break}jd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=152096+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[151796>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[151796>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[151808>>2]|0;if(O>>>0<K>>>0){jd()}if(f>>>0<K>>>0){jd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[151824>>2]|0)+ -1|0;c[151824>>2]=s;if((s|0)==0){Q=152248|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[151824>>2]=-1;i=b;return}function D2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=B2(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}h3(b|0,0,e|0)|0;i=d;return b|0}function E2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=B2(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Pc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=F2(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=B2(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;f3(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;C2(a);e=g;i=d;return e|0}function F2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[151808>>2]|0;if(h>>>0<l>>>0){jd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){jd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){jd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[152272>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;G2(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[151816>>2]|0)){m=(c[151804>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[151816>>2]=a+b;c[151804>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[151812>>2]|0)){h=(c[151800>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[151800>>2]=r;c[151812>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=151832+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){jd()}if((c[h+12>>2]|0)==(k|0)){break}jd()}}while(0);if((m|0)==(h|0)){c[37948]=c[37948]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){jd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}jd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){jd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){jd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){jd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{jd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=152096+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[151796>>2]=c[151796>>2]&~(1<<u);break a}else{if(t>>>0<(c[151808>>2]|0)>>>0){jd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[151808>>2]|0)>>>0){jd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;G2(a+b|0,r);o=a;i=d;return o|0}return 0}function G2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[151808>>2]|0;if(j>>>0<m>>>0){jd()}if((k|0)==(c[151812>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[151800>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=151832+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){jd()}if((c[q+12>>2]|0)==(k|0)){break}jd()}}while(0);if((r|0)==(q|0)){c[37948]=c[37948]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){jd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}jd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){jd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){jd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){jd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{jd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=152096+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[151796>>2]=c[151796>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[151808>>2]|0)>>>0){jd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[151808>>2]|0)>>>0){jd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[151808>>2]|0;if(e>>>0<z>>>0){jd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[151816>>2]|0)){t=(c[151804>>2]|0)+p|0;c[151804>>2]=t;c[151816>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[151812>>2]|0)){i=d;return}c[151812>>2]=0;c[151800>>2]=0;i=d;return}if((f|0)==(c[151812>>2]|0)){t=(c[151800>>2]|0)+p|0;c[151800>>2]=t;c[151812>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=151832+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){jd()}if((c[u+12>>2]|0)==(f|0)){break}jd()}}while(0);if((h|0)==(u|0)){c[37948]=c[37948]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){jd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}jd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){jd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){jd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){jd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{jd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=152096+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[151796>>2]=c[151796>>2]&~(1<<j);break b}else{if(m>>>0<(c[151808>>2]|0)>>>0){jd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[151808>>2]|0)>>>0){jd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[151808>>2]|0)>>>0){jd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[151812>>2]|0)){G=t;break}c[151800>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=151832+(B<<2)|0;D=c[37948]|0;b=1<<p;do{if((D&b|0)==0){c[37948]=D|b;H=151832+(B+2<<2)|0;I=A}else{p=151832+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[151808>>2]|0)>>>0)){H=p;I=a;break}jd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=152096+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[151796>>2]|0;B=1<<J;if((a&B|0)==0){c[151796>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[151808>>2]|0)>>>0){jd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[151808>>2]|0;if(L>>>0<B>>>0){jd()}if(G>>>0<B>>>0){jd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function H2(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=B2(d)|0;if((e|0)!=0){f=6;break}a=c[38072]|0;c[38072]=0+a;if((a|0)==0){f=5;break}Ie[a&7]()}if((f|0)==5){d=Gc(4)|0;c[d>>2]=152304;Wd(d|0,152352,136)}else if((f|0)==6){i=b;return e|0}return 0}function I2(a){a=a|0;var b=0,c=0;b=i;c=H2(a)|0;i=b;return c|0}function J2(a){a=a|0;var b=0;b=i;if((a|0)!=0){C2(a)}i=b;return}function K2(a){a=a|0;var b=0;b=i;J2(a);i=b;return}function L2(a){a=a|0;var b=0;b=i;Ab(a|0);J2(a);i=b;return}function M2(a){a=a|0;var b=0;b=i;Ab(a|0);i=b;return}function N2(a){a=a|0;i=i;return 152320}function O2(){var a=0;a=Gc(4)|0;c[a>>2]=152304;Wd(a|0,152352,136)}



function Hu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=le[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){h3(c[m>>2]|0,0,g|0)|0;g=Iu(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Iu(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Ju(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=le[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}h3(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Iu(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}ie[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=le[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){h3(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Iu(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Ju(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function Ku(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}ie[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}ie[e&255](c[d>>2]|0);i=b;return}function Lu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[51872+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[51912+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=Ae[c[j+16>>2]&127](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=le[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=le[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}ie[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;f3(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}He[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function Mu(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((oe[((a[e+236|0]&255|0)!=0?34:35)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=sv(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function Nu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Ke[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Ou(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function Ou(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=Be[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=Qu(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 1:{t=Pu(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=Hu(o,l+132|0,51944,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Ke[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=Qu(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}Ru(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 7:{if((c[o+84>>2]|0)==0){break c}fe[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;lu(o+416|0);h=0;break};case 57:{v=Pu(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=Uu(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){fe[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);lu(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=Hu(o,l+132|0,51944,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((Be[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((le[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}ie[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=Tu(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=52048}else{x=(s|0)==32?52032:52056}if((Vu(o+416|0,x)|0)==0){r=111;break a}if((Wu(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=51952;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=51960;r=102;break};case 25:{c[o+332>>2]=51968;r=102;break};case 26:{c[o+332>>2]=51976;r=102;break};case 27:{c[o+332>>2]=51984;r=102;break};case 28:{c[o+332>>2]=51992;r=102;break};case 29:{c[o+332>>2]=52008;r=102;break};case 30:{c[o+332>>2]=52016;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((Xu(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Eu(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Eu(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ue[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);lu(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=Qu(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=51944}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((le[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Hu(o,l+132|0,51944,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=Yu(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((Xu(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Eu(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Eu(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;ue[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);lu(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=Zu(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;ze[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ze[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=Qu(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;ue[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;ze[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((oe[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=Qu(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=Hu(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=Qu(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=Hu(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=Qu(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Cu(o,b,e,c[n>>2]|0)}h=0;D=_u(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((Ke[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=Qu(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}Ru(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=Qu(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;fe[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);lu(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;fe[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);lu(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=le[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=Ae[u&127](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=Ae[c[o+16>>2]&127](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=av(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=Qu(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=Hu(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}He[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=bv(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(Be[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((le[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=Tu(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=le[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;He[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((ev(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((dv(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Ke[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=Qu(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=av(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=Tu(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=cv(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;He[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=Qu(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}Ru(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Cu(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Ke[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((Be[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=Hu(o,l+132|0,51944,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((Be[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((le[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=Su(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function Pu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((ke[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=Qu(n+440|0,p,b,s+(Ae[c[(c[n+144>>2]|0)+32>>2]&127](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=Qu(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Le[c[n+140>>2]&63](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Cu(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=Qu(n+440|0,e,d,m+(Ae[c[(c[n+144>>2]|0)+32>>2]&127](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=sv(n,f)|0;lu(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){lu(n+440|0)}q=0;r=q;i=g;return r|0}function Qu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((Wu(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Eu(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function Ru(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function Su(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=hv(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((pv(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Tu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=Qu(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Hu(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((qv(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function Uu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Eu(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=Qu(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Hu(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Hu(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Eu(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Eu(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Hu(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function Vu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Eu(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function Wu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Eu(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){fe[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Eu(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function Xu(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=le[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=Ae[c[g+16>>2]&127](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function Yu(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=rv(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Eu(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function Zu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Eu(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Ke[c[b+20>>2]&63](b,e,f,j)|0){case 0:{r=49;break a;break};case 10:{s=Ae[c[b+44>>2]&127](b,e)|0;if((s|0)<0){r=33;break a}s=yv(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Eu(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-1:{r=46;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=Qu(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=Hu(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=Zu(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(Be[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case-4:{r=24;break a;break};case 6:case 9:{if((Wu(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 7:{r=28;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Eu(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function _u(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Ke[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){Cu(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function $u(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=_u(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=Nu(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=le[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=Ae[c[g+4>>2]&127](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=le[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function bv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=le[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Ke[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=Ou(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=hv(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function cv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=le[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;gv(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function dv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Cu(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(Ae[c[a+32>>2]&127](a,b)|0)|0;k=Qu(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=Ae[c[a+36>>2]&127](a,e)|0;e=Qu(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){fv(e);He[c[g+64>>2]&15](c[g+4>>2]|0,k,e);lu(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function ev(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Cu(g,a,b,d)}h=1;j=h;i=f;return j|0}k=Qu(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){fv(k);je[c[g+68>>2]&127](c[g+4>>2]|0,k);lu(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function fv(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function gv(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}gv(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function hv(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Ke[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-3:{B=6;break a;break};case-2:{B=28;break a;break};case-4:{B=17;break a;break};case 9:{a[p]=oe[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){He[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}Cu(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=Qu(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}D=Hu(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((D|0)!=0){break}E=y;if((c[y+120>>2]|0)!=0){He[c[E+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[E+80>>2]|0)==0){break b}Cu(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((D|0)==0){B=41;break a}if((a[D+34|0]|0)==0){B=43;break a}}if((a[D+32|0]|0)!=0){B=50;break a}if((c[D+28>>2]|0)!=0){B=52;break a}C=y;if((c[D+4>>2]|0)!=0){E=y;if((a[C+308|0]|0)!=0){F=bv(E,D,0)|0;if((F|0)!=0){B=60;break a}else{break b}}G=y;if((c[E+120>>2]|0)!=0){He[c[G+120>>2]&15](c[y+4>>2]|0,c[D>>2]|0,0);break b}if((c[G+80>>2]|0)==0){break b}Cu(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Cu(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[D+32|0]=1;C=jv(y)|0;a[D+32|0]=0;if((C|0)==0){B=63;break a}if((Be[c[y+112>>2]&63](c[y+116>>2]|0,C,c[D+20>>2]|0,c[D+16>>2]|0,c[D+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){H=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{H=le[c[C+12>>2]&127](48)|0;if((H|0)==0){B=72;break a}c[H+36>>2]=le[c[y+12>>2]&127](32)|0;if((c[H+36>>2]|0)==0){B=74;break a}c[H+40>>2]=(c[H+36>>2]|0)+32}c[H+44>>2]=0;c[H>>2]=c[y+364>>2];c[y+364>>2]=H;c[H+16>>2]=0;c[H+20>>2]=0;c[H+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[H+8>>2]=Ae[c[e+32>>2]&127](e,c[H+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[H+4>>2]|0)+(c[H+8>>2]|0)|0;c[r>>2]=c[H+4>>2];c[q>>2]=c[H+36>>2];while(1){fe[c[e+60>>2]&31](e,r,C,q,(c[H+40>>2]|0)+ -1|0);I=(c[q>>2]|0)-(c[H+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}G=(c[H+40>>2]|0)-(c[H+36>>2]|0)<<1;E=Ae[c[y+16>>2]&127](c[H+36>>2]|0,G)|0;if((E|0)==0){B=80;break a}c[H+36>>2]=E;c[H+40>>2]=E+G;c[q>>2]=E+I}c[H+24>>2]=I;c[H+12>>2]=c[H+36>>2];a[c[q>>2]|0]=0;J=kv(y,e,c[m>>2]|0,H+12|0,H+44|0)|0;if((J|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){He[c[C+52>>2]&15](c[y+4>>2]|0,c[H+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Cu(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);lu(y+416|0);break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;D=1;c[t>>2]=Qu(y+416|0,e,C,C+(Ae[c[e+32>>2]&127](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];K=kv(y,e,c[m>>2]|0,t,s)|0;if((K|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){He[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);D=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}je[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);D=0}do{if((D&255|0)!=0){if((c[y+80>>2]|0)==0){break}Cu(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);lu(y+416|0);while(1){if((c[s>>2]|0)==0){break}D=c[s>>2]|0;if((c[y+104>>2]|0)!=0){je[c[y+104>>2]&127](c[y+4>>2]|0,c[c[D>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[D+4>>2]=c[y+376>>2];c[y+376>>2]=D;c[(c[D>>2]|0)+4>>2]=c[D+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}D=c[y+364>>2]|0;c[y+364>>2]=c[D>>2];c[D>>2]=c[y+368>>2];c[y+368>>2]=D;L=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;C=Ae[c[e+32>>2]&127](e,L)|0;if((C|0)!=(c[D+8>>2]|0)){B=112;break a}if((_2(c[D+4>>2]|0,L,C)|0)!=0){B=112;break a}C=y+312|0;c[C>>2]=(c[C>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){C=c[D+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((C|0)==0){break}E=(c[D+12>>2]|0)+(c[D+28>>2]|0)|0;while(1){if((a[C]|0)==0){break}G=C;C=G+1|0;M=E;E=M+1|0;a[M]=a[G]|0}G=c[D+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}M=E;E=M+1|0;a[M]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}M=G;G=M+1|0;N=E;E=N+1|0;a[N]=a[M]|0}}}while(0);a[E]=0}}while(0);je[c[y+56>>2]&127](c[y+4>>2]|0,c[D+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Cu(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[D+44>>2]|0)==0){break}C=c[D+44>>2]|0;if((c[y+104>>2]|0)!=0){je[c[y+104>>2]&127](c[y+4>>2]|0,c[c[C>>2]>>2]|0)}c[D+44>>2]=c[(c[D+44>>2]|0)+4>>2];c[C+4>>2]=c[y+376>>2];c[y+376>>2]=C;c[(c[C>>2]|0)+4>>2]=c[C+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;He[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Cu(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{D=Ae[c[e+44>>2]&127](e,c[m>>2]|0)|0;if((D|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){G=c[C+60>>2]|0;M=c[y+4>>2]|0;N=yv(D,u)|0;He[G&15](M,u,N);break b}if((c[C+80>>2]|0)==0){break b}Cu(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){ie[c[C+72>>2]&255](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Cu(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=mv(y,e,n,g,h,j)|0;if((O|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{C=c[y+60>>2]|0;if((C|0)==0){if((c[y+80>>2]|0)==0){break b}Cu(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){He[C&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];fe[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];He[C&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((dv(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((ev(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 0:{B=24;break a;break};case-1:{B=25;break a;break};default:{if((c[y+80>>2]|0)==0){break b}Cu(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==2){B=181;break}else if((f|0)==3){B=180;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;He[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Cu(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=F;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){ie[c[y+20>>2]&255](H);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=J;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=K;Q=P;i=l;return Q|0}else if((B|0)==107){P=lv(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=L;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=lv(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=O;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=42;P=O;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){He[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];fe[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);He[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Cu(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function iv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Ke[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=Ou(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=hv(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=Ke[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=Ou(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=hv(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function jv(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Eu(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Eu(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Fu(e,b+60|0);a:while(1){k=Gu(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Eu(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Eu(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Eu(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Eu(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Fu(e,b);b:while(1){b=Gu(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Eu(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Eu(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Eu(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function kv(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Hu(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=nu(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Hu(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((qv(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Ke[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=Ae[c[k+16>>2]&127](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Ke[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=Uu(k,b,v,w+(Ae[c[b+32>>2]&127](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=Qu(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=Yu(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=Lu(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=Lu(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=Ae[c[k+16>>2]&127](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Hu(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Eu(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Eu(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Eu(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=le[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;f3(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}ie[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;f3(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;f3(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function lv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Ke[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 15:{if((c[j+80>>2]|0)==0){break b}Cu(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-1:{k=15;break a;break};case-2:{k=18;break a;break};case-15:{k=3;break a;break};case 13:{if((ev(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-4:{k=7;break a;break};case 11:{if((dv(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 0:{k=14;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Cu(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function mv(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Ke[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-4:case-1:{r=28;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Cu(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){He[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];fe[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];He[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 0:{r=24;break a;break};case-2:{r=25;break a;break};case 40:{r=6;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;He[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Cu(o,b,c[k>>2]|0,c[l>>2]|0);break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){m=o;do{if((c[o+76>>2]|0)!=0){ie[c[m+76>>2]&255](c[o+4>>2]|0)}else{if((c[m+80>>2]|0)==0){break}Cu(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function nv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=mv(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=ov(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=Su(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function ov(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=hv(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((pv(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function pv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=Ae[c[d+16>>2]&127](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}f3(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function qv(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Eu(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Eu(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Hu(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}



function P2(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0.0,la=0,ma=0.0,na=0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0.0,Fa=0,Ga=0.0,Ha=0.0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0.0,xc=0,yc=0,zc=0.0,Ac=0.0,Cc=0.0,Dc=0.0,Ec=0.0,Fc=0.0,Gc=0,Hc=0,Ic=0.0,Jc=0,Kc=0.0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=S2(b)|0}}while((ld(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=S2(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[152368+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=S2(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[152384+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=S2(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==3){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=S2(b)|0}if((B|0)==40){C=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0}else{D=S2(b)|0}if(!((D+ -48|0)>>>0<10|(D+ -65|0)>>>0<26)){if(!((D+ -97|0)>>>0<26|(D|0)==95)){break}}C=C+1|0}if((D|0)==41){l=+y;i=g;return+l}o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Pc()|0)>>2]=22;R2(b,0);l=0.0;i=g;return+l}if((C|0)==0|o){l=+y;i=g;return+l}else{E=C}while(1){o=E+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((o|0)==0){l=+y;break}else{E=o}}i=g;return+l}else if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=d[o]|0}else{F=S2(b)|0}if((F|32|0)!=120){if((c[m>>2]|0)==0){G=48;break}c[e>>2]=(c[e>>2]|0)+ -1;G=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=0}else{H=S2(b)|0;I=0}while(1){if((H|0)==46){v=70;break}else if((H|0)!=48){K=0;L=0;M=0;N=0;O=H;P=I;Q=0;R=0;S=1.0;T=0;V=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;H=d[o]|0;I=1;continue}else{H=S2(b)|0;I=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;W=d[o]|0}else{W=S2(b)|0}if((W|0)==48){X=-1;Y=-1}else{K=0;L=0;M=0;N=0;O=W;P=I;Q=1;R=0;S=1.0;T=0;V=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;Z=d[o]|0}else{Z=S2(b)|0}if((Z|0)!=48){K=X;L=Y;M=0;N=0;O=Z;P=1;Q=1;R=0;S=1.0;T=0;V=0.0;break b}o=n3(X|0,Y|0,-1,-1)|0;X=o;Y=J}}}while(0);c:while(1){o=O+ -48|0;do{if(o>>>0<10){_=o;v=84}else{q=O|32;n=(O|0)==46;if(!((q+ -97|0)>>>0<6|n)){$=O;break c}if(n){if((Q|0)==0){aa=M;ba=N;ca=M;da=N;ea=P;ga=1;ha=R;ia=S;ja=T;ka=V;break}else{$=46;break c}}else{_=(O|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((N|0)<0|(N|0)==0&M>>>0<8){la=R;ma=S;na=_+(T<<4)|0;oa=V}else{if((N|0)<0|(N|0)==0&M>>>0<14){pa=S*.0625;la=R;ma=pa;na=T;oa=V+pa*+(_|0);break}if(!((_|0)!=0&(R|0)==0)){la=R;ma=S;na=T;oa=V;break}la=1;ma=S;na=T;oa=V+S*.5}}while(0);o=n3(M|0,N|0,1,0)|0;aa=K;ba=L;ca=o;da=J;ea=1;ga=Q;ha=la;ia=ma;ja=na;ka=oa}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;K=aa;L=ba;M=ca;N=da;O=d[o]|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}else{K=aa;L=ba;M=ca;N=da;O=S2(b)|0;P=ea;Q=ga;R=ha;S=ia;T=ja;V=ka;continue}}if((P|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){R2(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((Q|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(Q|0)==0;q=o?M:K;n=o?N:L;if((N|0)<0|(N|0)==0&M>>>0<8){o=M;p=N;qa=T;while(1){ra=qa<<4;sa=n3(o|0,p|0,1,0)|0;ta=J;if((ta|0)<0|(ta|0)==0&sa>>>0<8){qa=ra;p=ta;o=sa}else{ua=ra;break}}}else{ua=T}do{if(($|32|0)==112){o=Q2(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){va=o;wa=p;break}if(u){R2(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0;break}}else{if((c[m>>2]|0)==0){va=0;wa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;va=0;wa=0}}while(0);p=i3(q|0,n|0,2)|0;o=n3(p|0,J|0,-32,-1)|0;p=n3(o|0,J|0,va|0,wa|0)|0;o=J;if((ua|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Pc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}qa=k+ -106|0;ra=((qa|0)<0)<<31>>31;if((o|0)<(ra|0)|(o|0)==(ra|0)&p>>>0<qa>>>0){c[(Pc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((ua|0)>-1){qa=p;ra=o;sa=ua;pa=V;while(1){ta=sa<<1;if(!(pa>=.5)){xa=pa;ya=ta}else{xa=pa+-1.0;ya=ta|1}za=pa+xa;ta=n3(qa|0,ra|0,-1,-1)|0;Aa=J;if((ya|0)>-1){qa=ta;ra=Aa;sa=ya;pa=za}else{Ba=ta;Ca=Aa;Da=ya;Ea=za;break}}}else{Ba=p;Ca=o;Da=ua;Ea=V}sa=m3(32,0,k|0,((k|0)<0)<<31>>31|0)|0;ra=n3(Ba|0,Ca|0,sa|0,J|0)|0;sa=J;if(0>(sa|0)|0==(sa|0)&j>>>0>ra>>>0){Fa=(ra|0)<0?0:ra}else{Fa=j}do{if((Fa|0)<53){pa=+(r|0);za=+Ud(+(+T2(1.0,84-Fa|0)),+pa);if(!((Fa|0)<32&Ea!=0.0)){Ga=pa;Ha=za;Ia=Da;Ja=Ea;break}ra=Da&1;Ga=pa;Ha=za;Ia=(ra^1)+Da|0;Ja=(ra|0)==0?0.0:Ea}else{Ga=+(r|0);Ha=0.0;Ia=Da;Ja=Ea}}while(0);za=Ga*Ja+(Ha+Ga*+(Ia>>>0))-Ha;if(!(za!=0.0)){c[(Pc()|0)>>2]=34}l=+U2(za,Ba);i=g;return+l}else{G=w}}while(0);o=k+j|0;p=0-o|0;ra=G;sa=0;while(1){if((ra|0)==46){v=139;break}else if((ra|0)!=48){Ka=ra;La=0;Ma=0;Na=sa;Oa=0;break}qa=c[e>>2]|0;if(qa>>>0<(c[m>>2]|0)>>>0){c[e>>2]=qa+1;ra=d[qa]|0;sa=1;continue}else{ra=S2(b)|0;sa=1;continue}}d:do{if((v|0)==139){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Pa=d[ra]|0}else{Pa=S2(b)|0}if((Pa|0)==48){Qa=-1;Ra=-1}else{Ka=Pa;La=0;Ma=0;Na=sa;Oa=1;break}while(1){ra=c[e>>2]|0;if(ra>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ra+1;Sa=d[ra]|0}else{Sa=S2(b)|0}if((Sa|0)!=48){Ka=Sa;La=Qa;Ma=Ra;Na=1;Oa=1;break d}ra=n3(Qa|0,Ra|0,-1,-1)|0;Qa=ra;Ra=J}}}while(0);sa=h;c[sa>>2]=0;ra=Ka+ -48|0;qa=(Ka|0)==46;e:do{if(ra>>>0<10|qa){n=h+496|0;q=Ka;Aa=qa;ta=ra;Ta=0;Ua=0;Va=La;Wa=Ma;Xa=Na;Ya=Oa;Za=0;_a=0;$a=0;while(1){do{if(Aa){if((Ya|0)==0){ab=Ta;bb=Ua;cb=Ta;db=Ua;eb=Xa;fb=1;gb=Za;hb=_a;ib=$a}else{jb=q;kb=Ta;lb=Ua;mb=Va;nb=Wa;ob=Xa;pb=Za;qb=_a;rb=$a;break e}}else{sb=n3(Ta|0,Ua|0,1,0)|0;tb=J;ub=(q|0)!=48;if((_a|0)>=125){if(!ub){ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}c[n>>2]=c[n>>2]|1;ab=Va;bb=Wa;cb=sb;db=tb;eb=Xa;fb=Ya;gb=Za;hb=_a;ib=$a;break}vb=h+(_a<<2)|0;if((Za|0)==0){wb=ta}else{wb=q+ -48+((c[vb>>2]|0)*10|0)|0}c[vb>>2]=wb;vb=Za+1|0;xb=(vb|0)==9;ab=Va;bb=Wa;cb=sb;db=tb;eb=1;fb=Ya;gb=xb?0:vb;hb=(xb&1)+_a|0;ib=ub?sb:$a}}while(0);sb=c[e>>2]|0;if(sb>>>0<(c[m>>2]|0)>>>0){c[e>>2]=sb+1;yb=d[sb]|0}else{yb=S2(b)|0}sb=yb+ -48|0;ub=(yb|0)==46;if(sb>>>0<10|ub){q=yb;Aa=ub;ta=sb;Ta=cb;Ua=db;Va=ab;Wa=bb;Xa=eb;Ya=fb;Za=gb;_a=hb;$a=ib}else{zb=yb;Ab=cb;Bb=db;Cb=ab;Db=bb;Eb=eb;Fb=fb;Gb=gb;Hb=hb;Ib=ib;v=162;break}}}else{zb=Ka;Ab=0;Bb=0;Cb=La;Db=Ma;Eb=Na;Fb=Oa;Gb=0;Hb=0;Ib=0;v=162}}while(0);if((v|0)==162){ra=(Fb|0)==0;jb=zb;kb=Ab;lb=Bb;mb=ra?Ab:Cb;nb=ra?Bb:Db;ob=Eb;pb=Gb;qb=Hb;rb=Ib}ra=(ob|0)!=0;do{if(ra){if((jb|32|0)!=101){v=171;break}qa=Q2(b,f)|0;$a=J;do{if((qa|0)==0&($a|0)==-2147483648){if(u){R2(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Jb=0;Kb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Jb=0;Kb=0;break}}else{Jb=qa;Kb=$a}}while(0);$a=n3(Jb|0,Kb|0,mb|0,nb|0)|0;Lb=$a;Mb=J}else{v=171}}while(0);do{if((v|0)==171){if(!((jb|0)>-1)){Lb=mb;Mb=nb;break}if((c[m>>2]|0)==0){Lb=mb;Mb=nb;break}c[e>>2]=(c[e>>2]|0)+ -1;Lb=mb;Mb=nb}}while(0);if(!ra){c[(Pc()|0)>>2]=22;R2(b,0);l=0.0;i=g;return+l}u=c[sa>>2]|0;if((u|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Lb|0)==(kb|0)&(Mb|0)==(lb|0)&((lb|0)<0|(lb|0)==0&kb>>>0<10)){if(!(j>>>0>30)){if((u>>>j|0)!=0){break}}l=+(r|0)*+(u>>>0);i=g;return+l}}while(0);u=(k|0)/-2|0;ra=((u|0)<0)<<31>>31;if((Mb|0)>(ra|0)|(Mb|0)==(ra|0)&Lb>>>0>u>>>0){c[(Pc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}u=k+ -106|0;ra=((u|0)<0)<<31>>31;if((Mb|0)<(ra|0)|(Mb|0)==(ra|0)&Lb>>>0<u>>>0){c[(Pc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((pb|0)==0){Nb=qb}else{if((pb|0)<9){u=h+(qb<<2)|0;ra=c[u>>2]|0;$a=pb;do{ra=ra*10|0;$a=$a+1|0;}while(($a|0)<9);c[u>>2]=ra}Nb=qb+1|0}do{if((rb|0)<9){if(!((rb|0)<=(Lb|0)&(Lb|0)<18)){break}if((Lb|0)==9){l=+(r|0)*+((c[sa>>2]|0)>>>0);i=g;return+l}if((Lb|0)<9){l=+(r|0)*+((c[sa>>2]|0)>>>0)/+(c[152400+(8-Lb<<2)>>2]|0);i=g;return+l}$a=j+27+(fa(Lb,-3)|0)|0;qa=c[sa>>2]|0;if(($a|0)<=30){if((qa>>>$a|0)!=0){break}}l=+(r|0)*+(qa>>>0)*+(c[152400+(Lb+ -10<<2)>>2]|0);i=g;return+l}}while(0);sa=(Lb|0)%9|0;if((sa|0)==0){Ob=0;Pb=0;Qb=Lb;Rb=Nb}else{ra=(Lb|0)>-1?sa:sa+9|0;sa=c[152400+(8-ra<<2)>>2]|0;do{if((Nb|0)==0){Sb=0;Tb=Lb;Ub=0}else{u=1e9/(sa|0)|0;qa=0;$a=0;_a=0;Za=Lb;while(1){Ya=h+(_a<<2)|0;Xa=c[Ya>>2]|0;Wa=((Xa>>>0)/(sa>>>0)|0)+$a|0;c[Ya>>2]=Wa;Vb=fa((Xa>>>0)%(sa>>>0)|0,u)|0;Xa=_a+1|0;if((_a|0)==(qa|0)&(Wa|0)==0){Wb=Xa&127;Xb=Za+ -9|0}else{Wb=qa;Xb=Za}if((Xa|0)==(Nb|0)){break}else{qa=Wb;Za=Xb;_a=Xa;$a=Vb}}if((Vb|0)==0){Sb=Wb;Tb=Xb;Ub=Nb;break}c[h+(Nb<<2)>>2]=Vb;Sb=Wb;Tb=Xb;Ub=Nb+1|0}}while(0);Ob=Sb;Pb=0;Qb=9-ra+Tb|0;Rb=Ub}f:while(1){sa=h+(Ob<<2)|0;if((Qb|0)<18){$a=Pb;_a=Rb;while(1){Za=0;qa=_a+127|0;u=_a;while(1){Xa=qa&127;Wa=h+(Xa<<2)|0;Ya=i3(c[Wa>>2]|0,0,29)|0;Va=n3(Ya|0,J|0,Za|0,0)|0;Ya=J;if(Ya>>>0>0|(Ya|0)==0&Va>>>0>1e9){Ua=x3(Va|0,Ya|0,1e9,0)|0;Ta=y3(Va|0,Ya|0,1e9,0)|0;Yb=Ta;Zb=Ua}else{Yb=Va;Zb=0}c[Wa>>2]=Yb;Wa=(Xa|0)==(Ob|0);if((Xa|0)!=(u+127&127|0)|Wa){_b=u}else{_b=(Yb|0)==0?Xa:u}if(Wa){break}else{Za=Zb;qa=Xa+ -1|0;u=_b}}u=$a+ -29|0;if((Zb|0)==0){$a=u;_a=_b}else{$b=u;ac=Zb;bc=_b;break}}}else{if((Qb|0)==18){cc=Pb;dc=Rb}else{ec=Ob;fc=Pb;gc=Qb;hc=Rb;break}while(1){if(!((c[sa>>2]|0)>>>0<9007199)){ec=Ob;fc=cc;gc=18;hc=dc;break f}_a=0;$a=dc+127|0;u=dc;while(1){qa=$a&127;Za=h+(qa<<2)|0;Xa=i3(c[Za>>2]|0,0,29)|0;Wa=n3(Xa|0,J|0,_a|0,0)|0;Xa=J;if(Xa>>>0>0|(Xa|0)==0&Wa>>>0>1e9){Va=x3(Wa|0,Xa|0,1e9,0)|0;Ua=y3(Wa|0,Xa|0,1e9,0)|0;ic=Ua;jc=Va}else{ic=Wa;jc=0}c[Za>>2]=ic;Za=(qa|0)==(Ob|0);if((qa|0)!=(u+127&127|0)|Za){kc=u}else{kc=(ic|0)==0?qa:u}if(Za){break}else{_a=jc;$a=qa+ -1|0;u=kc}}u=cc+ -29|0;if((jc|0)==0){cc=u;dc=kc}else{$b=u;ac=jc;bc=kc;break}}}sa=Ob+127&127;if((sa|0)==(bc|0)){u=bc+127&127;$a=h+((bc+126&127)<<2)|0;c[$a>>2]=c[$a>>2]|c[h+(u<<2)>>2];lc=u}else{lc=bc}c[h+(sa<<2)>>2]=ac;Ob=sa;Pb=$b;Qb=Qb+9|0;Rb=lc}g:while(1){mc=hc+1&127;ra=h+((hc+127&127)<<2)|0;sa=ec;u=fc;$a=gc;while(1){_a=($a|0)==18;qa=($a|0)>27?9:1;nc=sa;oc=u;while(1){Za=0;while(1){Wa=Za+nc&127;if((Wa|0)==(hc|0)){pc=2;break}Va=c[h+(Wa<<2)>>2]|0;Wa=c[152392+(Za<<2)>>2]|0;if(Va>>>0<Wa>>>0){pc=2;break}Ua=Za+1|0;if(Va>>>0>Wa>>>0){pc=Za;break}if((Ua|0)<2){Za=Ua}else{pc=Ua;break}}if((pc|0)==2&_a){break g}qc=qa+oc|0;if((nc|0)==(hc|0)){nc=hc;oc=qc}else{break}}_a=(1<<qa)+ -1|0;Za=1e9>>>qa;rc=nc;sc=0;Ua=nc;tc=$a;do{Wa=h+(Ua<<2)|0;Va=c[Wa>>2]|0;Xa=(Va>>>qa)+sc|0;c[Wa>>2]=Xa;sc=fa(Va&_a,Za)|0;Va=(Ua|0)==(rc|0)&(Xa|0)==0;Ua=Ua+1&127;tc=Va?tc+ -9|0:tc;rc=Va?Ua:rc;}while((Ua|0)!=(hc|0));if((sc|0)==0){sa=rc;u=qc;$a=tc;continue}if((mc|0)!=(rc|0)){break}c[ra>>2]=c[ra>>2]|1;sa=rc;u=qc;$a=tc}c[h+(hc<<2)>>2]=sc;ec=rc;fc=qc;gc=tc;hc=mc}$a=nc&127;if(($a|0)==(hc|0)){c[h+(mc+ -1<<2)>>2]=0;uc=mc}else{uc=hc}za=+((c[h+($a<<2)>>2]|0)>>>0);$a=nc+1&127;if(($a|0)==(uc|0)){u=uc+1&127;c[h+(u+ -1<<2)>>2]=0;vc=u}else{vc=uc}pa=+(r|0);wc=pa*(za*1.0e9+ +((c[h+($a<<2)>>2]|0)>>>0));$a=oc+53|0;u=$a-k|0;if((u|0)<(j|0)){xc=(u|0)<0?0:u;yc=1}else{xc=j;yc=0}if((xc|0)<53){za=+Ud(+(+T2(1.0,105-xc|0)),+wc);zc=+Bc(+wc,+(+T2(1.0,53-xc|0)));Ac=za;Cc=zc;Dc=za+(wc-zc)}else{Ac=0.0;Cc=0.0;Dc=wc}sa=nc+2&127;do{if((sa|0)==(vc|0)){Ec=Cc}else{ra=c[h+(sa<<2)>>2]|0;do{if(ra>>>0<5e8){if((ra|0)==0){if((nc+3&127|0)==(vc|0)){Fc=Cc;break}}Fc=pa*.25+Cc}else{if(ra>>>0>5e8){Fc=pa*.75+Cc;break}if((nc+3&127|0)==(vc|0)){Fc=pa*.5+Cc;break}else{Fc=pa*.75+Cc;break}}}while(0);if((53-xc|0)<=1){Ec=Fc;break}if(+Bc(+Fc,1.0)!=0.0){Ec=Fc;break}Ec=Fc+1.0}}while(0);pa=Dc+Ec-Ac;do{if(($a&2147483647|0)>(-2-o|0)){if(!(+U(+pa)>=9007199254740992.0)){Gc=yc;Hc=oc;Ic=pa}else{Gc=(yc|0)!=0&(xc|0)==(u|0)?0:yc;Hc=oc+1|0;Ic=pa*.5}if((Hc+50|0)<=(p|0)){if(!((Gc|0)!=0&Ec!=0.0)){Jc=Hc;Kc=Ic;break}}c[(Pc()|0)>>2]=34;Jc=Hc;Kc=Ic}else{Jc=oc;Kc=pa}}while(0);l=+U2(Kc,Jc);i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Pc()|0)>>2]=22;R2(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function Q2(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=S2(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=S2(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=S2(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=w3(q|0,m|0,10,0)|0;b=J;g=n3(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=n3(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=S2(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=S2(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=m3(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function R2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function S2(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=W2(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function T2(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=i3(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function U2(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+T2(a,b);i=c;return+d}function V2(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){oe[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function W2(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((V2(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((oe[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function X2(a){a=a|0;var b=0,c=0.0;b=i;c=+Y2(a,0);i=b;return+c}function Y2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;R2(e,0);h=+P2(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function Z2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;R2(e,0);h=+P2(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function _2(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function $2(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function a3(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function b3(){c[33176]=p;c[33218]=p;c[37860]=p;c[38090]=p}function c3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}fc(116);fc(111);fc(111);fc(32);fc(109);fc(97);fc(110);fc(121);fc(32);fc(115);fc(101);fc(116);fc(106);fc(109);fc(112);fc(115);fc(32);fc(105);fc(110);fc(32);fc(97);fc(32);fc(102);fc(117);fc(110);fc(99);fc(116);fc(105);fc(111);fc(110);fc(32);fc(99);fc(97);fc(108);fc(108);fc(44);fc(32);fc(98);fc(117);fc(105);fc(108);fc(100);fc(32);fc(119);fc(105);fc(116);fc(104);fc(32);fc(97);fc(32);fc(104);fc(105);fc(103);fc(104);fc(101);fc(114);fc(32);fc(118);fc(97);fc(108);fc(117);fc(101);fc(32);fc(102);fc(111);fc(114);fc(32);fc(77);fc(65);fc(88);fc(95);fc(83);fc(69);fc(84);fc(74);fc(77);fc(80);fc(83);fc(10);ga(0);return 0}function d3(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function e3(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function f3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return nb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function g3(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{f3(b,c,d)|0}return b|0}function h3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function i3(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function j3(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function k3(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function l3(){return k3(o)|0}function m3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function n3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function o3(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function p3(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function q3(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function r3(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function s3(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function t3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function u3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=m3(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=m3((z3(i,b,m3(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function v3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=m3(h^a,j^b,h,j)|0;b=J;z3(m,b,m3(k^d,l^e,k,l)|0,J,g)|0;l=m3(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function w3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=t3(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function x3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=z3(a,b,c,d,0)|0;return(J=J,e)|0}function y3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;z3(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function z3(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((s3(l|0)|0)>>>0);return(J=n,o)|0}p=(r3(l|0)|0)-(r3(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(r3(l|0)|0)-(r3(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(r3(j|0)|0)+33-(r3(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=s3(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=n3(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;m3(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=m3(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function A3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return ee[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function B3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;fe[a&31](b|0,c|0,d|0,e|0,f|0)}function C3(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return ge[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function D3(a,b){a=a|0;b=+b;he[a&1](+b)}function E3(a,b){a=a|0;b=b|0;ie[a&255](b|0)}function F3(a,b,c){a=a|0;b=b|0;c=c|0;je[a&127](b|0,c|0)}function G3(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ke[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function H3(a,b){a=a|0;b=b|0;return le[a&127](b|0)|0}function I3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;me[a&1](b|0,c|0,+d,e|0)}function J3(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return ne[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function K3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return oe[a&63](b|0,c|0,d|0)|0}function L3(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return pe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function M3(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function N3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;re[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function O3(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;se[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function P3(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return te[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function Q3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ue[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function R3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ve[a&3](b|0,c|0,+d,e|0,f|0)}function S3(a,b,c){a=a|0;b=b|0;c=+c;return we[a&1](b|0,+c)|0}function T3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;xe[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function U3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ye[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function V3(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ze[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function W3(a,b,c){a=a|0;b=b|0;c=c|0;return Ae[a&127](b|0,c|0)|0}function X3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Be[a&63](b|0,c|0,d|0,e|0,f|0)|0}function Y3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return Ce[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function Z3(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+De[a&1](b|0,+c,+d)}function _3(a,b,c){a=a|0;b=b|0;c=c|0;return+Ee[a&1](b|0,c|0)}function $3(a){a=a|0;return Fe[a&7]()|0}function a4(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Ge[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function b4(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;He[a&15](b|0,c|0,d|0)}function c4(a){a=a|0;Ie[a&7]()}function d4(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Je[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function e4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ke[a&63](b|0,c|0,d|0,e|0)|0}function f4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Le[a&63](b|0,c|0,d|0,e|0)}function g4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function h4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function i4(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function j4(a){a=+a;ga(3)}function k4(a){a=a|0;ga(4)}function l4(a){a=a|0;Fd(a|0)}function m4(a,b){a=a|0;b=b|0;ga(5)}function n4(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function o4(a){a=a|0;ga(7);return 0}function p4(a){a=a|0;return Qc(a|0)|0}function q4(a){a=a|0;return Od(a|0)|0}function r4(a){a=a|0;return yc(a|0)|0}function s4(a){a=a|0;return Dd(a|0)|0}function t4(a){a=a|0;return od(a|0)|0}function u4(a){a=a|0;return xd(a|0)|0}function v4(a){a=a|0;return _c(a|0)|0}function w4(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function x4(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function y4(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function z4(a,b,c){a=a|0;b=b|0;c=c|0;return zd(a|0,b|0,c|0)|0}function A4(a,b,c){a=a|0;b=b|0;c=c|0;return jc(a|0,b|0,c|0)|0}function B4(a,b,c){a=a|0;b=b|0;c=c|0;return Rd(a|0,b|0,c|0)|0}function C4(a,b,c){a=a|0;b=b|0;c=c|0;return Ed(a|0,b|0,c|0)|0}function D4(a,b,c){a=a|0;b=b|0;c=c|0;return Ad(a|0,b|0,c|0)|0}function E4(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function F4(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function G4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function H4(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function I4(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function J4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function K4(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function L4(a,b){a=a|0;b=+b;ga(18);return 0}function M4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function N4(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function O4(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function P4(a,b){a=a|0;b=b|0;ga(22);return 0}function Q4(a,b){a=a|0;b=b|0;return Td(a|0,b|0)|0}function R4(a,b){a=a|0;b=b|0;return ic(a|0,b|0)|0}function S4(a,b){a=a|0;b=b|0;return jb(a|0,b|0)|0}function T4(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function U4(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function V4(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function W4(a,b){a=a|0;b=b|0;ga(26);return 0.0}function X4(){ga(27);return 0}function Y4(){return kb()|0}function Z4(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function _4(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function $4(){ga(30)}function a5(){Wc()}function b5(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function c5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function d5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return tc(a|0,b|0,c|0,d|0)|0}function e5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Oc(a|0,b|0,c|0,d|0)|0}function f5(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}




// EMSCRIPTEN_END_FUNCS
var ee=[g4,nC,pC,uC,ER,g4,g4,g4];var fe=[h4,lw,mw,Rw,Sw,ux,vx,Sx,Tx,Ux,x2,w2,v2,FA,Fv,Gv,sz,qz,h4,h4,h4,h4,h4,h4,h4,h4,h4,h4,h4,h4,h4,h4];var ge=[i4,eE];var he=[j4,$C];var ie=[k4,Qi,Ri,Xj,_j,Qn,ak,nz,qG,tG,sG,uG,CW,BW,EW,DW,vG,xG,JJ,fK,gK,hK,nW,mW,pW,oW,QQ,aR,nR,oR,pR,rR,tR,jT,kT,qT,rT,xT,yT,ET,FT,RT,QT,WT,VT,YT,ZT,gU,fU,nV,mV,wV,vV,_V,ZV,wW,vW,yW,xW,QW,PW,SW,RW,YW,XW,lV,ZW,WW,_W,aX,$W,i$,gX,fX,lX,kX,KX,JX,mY,lY,AY,zY,OY,NY,aZ,$Y,nZ,mZ,qZ,pZ,uZ,tZ,FZ,EZ,QZ,PZ,$Z,_Z,k_,j_,u_,t_,C_,B_,I_,H_,O_,N_,T_,S_,a$,$_,y$,x$,X_,P$,u0,t0,w0,v0,bX,h$,k$,H$,X$,g0,r0,s0,i2,h2,k2,n2,l2,m2,o2,p2,M2,L2,Wg,l4,Si,Ti,Ui,bj,cj,dj,ej,fj,gj,hj,mj,nj,oj,pj,qj,zt,At,Bt,Ct,gf,hf,jf,kf,mf,Pf,Tf,Uf,Vf,Wf,Yf,gg,jg,qg,rg,Bg,Cg,Dg,Ig,Jg,Kg,Lg,Mg,Ng,Og,Pg,Qg,Rg,Sl,zf,C2,pz,af,LC,PC,KC,hE,RC,fE,fB,UC,SC,TC,QC,WC,gE,XC,MC,ZC,LQ,_C,JS,iT,j$,c1,m_,j1,i1,h1,g1,f1,e1,wU,_U,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4,k4];var je=[m4,$j,OE,yG,NV,lT,sT,zT,GT,$V,xZ,yZ,zZ,AZ,CZ,DZ,IZ,JZ,KZ,LZ,NZ,OZ,TZ,UZ,VZ,WZ,YZ,ZZ,c_,d_,e_,f_,h_,i_,R_,W_,B0,D0,F0,C0,E0,G0,CC,Vi,Xi,Zi,$i,ij,kj,rj,tj,yj,Aj,Cj,Lj,Tj,Vj,Yj,Zj,VC,pJ,QE,PE,RE,XE,hF,SE,fF,EI,QI,PI,RI,zI,xI,BI,SR,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4,m4];var ke=[n4,Uv,Nv,oC,qC,rC,sC,tC];var le=[o4,Tg,Hs,Sg,cf,df,ef,Rn,io,gk,Pn,Gs,yt,fk,dk,Dt,Et,Kt,Lt,Mt,Nt,Ot,Pt,Qt,Rt,p4,q4,r4,Sz,B2,s4,CG,SV,DG,VV,RV,wR,mT,eW,gW,hW,dW,tT,uT,AT,UV,HT,IT,ST,XT,UW,PY,H0,J0,L0,R0,T0,N0,P0,bZ,I0,K0,M0,S0,U0,O0,Q0,vZ,wZ,BZ,GZ,HZ,MZ,RZ,SZ,XZ,a_,b_,g_,T$,U$,W$,x0,z0,y0,A0,L$,M$,O$,b0,c0,f0,m0,n0,q0,j2,N2,oE,t4,u4,OC,mE,nE,v4,EQ,fR,hD,sD,ED,iD,vD,FD,aT,W2,o4,o4,o4,o4,o4,o4,o4,o4,o4,o4,o4,o4,o4,o4];var me=[w4,DA];var ne=[x4,ZB];var oe=[y4,ck,cw,iw,Iw,Ow,lx,rx,zG,TV,XV,OV,aW,fW,nT,jW,BT,aU,bU,eX,jX,P_,U_,A$,C$,F$,l$,q$,s$,v$,q2,NQ,EA,nB,Rv,Iv,Pv,Vv,z4,A4,B4,iE,KQ,GQ,C4,US,D4,y4,y4,y4,y4,y4,y4,y4,y4,y4,y4,y4,y4,y4,y4,y4,y4,y4];var pe=[E4,bC];var qe=[F4,vB];var re=[G4,uY,xY,IY,KY,G4,G4,G4];var se=[H4,oZ,rZ,l_,p_,v_,x_,H4];var te=[I4,XB];var ue=[J4,kz,AG,uR,bW,PV,nY,oY,sY,yY,BY,CY,GY,LY,Q_,V_,A2,z2,y2,lz,J4,J4,J4,J4,J4,J4,J4,J4,J4,J4,J4,J4];var ve=[K4,tD,uD,K4];var we=[L4,Vg];var xe=[M4,mX,oX,qX,sX,uX,wX,yX,AX,CX,EX,GX,LX,NX,PX,RX,TX,VX,XX,ZX,$X,bY,dY,rY,tY,FY,HY,QY,RY,SY,TY,UY,cZ,dZ,eZ,fZ,gZ,G_,M_,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4,M4];var ye=[N4,D_,J_,N4];var ze=[O4,VY,hZ,O4];var Ae=[P4,bf,hk,ek,bk,St,Tt,ew,fw,hw,Kw,Lw,Nw,nx,ox,qx,wx,xx,yx,zx,Ax,Bx,Cx,Dx,EG,FG,xR,yR,iW,oT,vT,kW,WV,CT,JT,YV,z$,B$,D$,p$,r$,t$,YD,HD,xD,kD,GD,jD,Q4,wD,E2,Cv,Dv,Ev,R4,hA,oD,AD,DD,pD,UD,LD,rD,S4,V1,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4,P4];var Be=[T4,cX,hX,G$,S$,V$,w$,K$,N$,a0,d0,l0,o0,_x,Ry,Sy,dy,ay,Py,Qy,ey,fy,gy,hy,iy,Fy,Gy,wy,py,ky,jy,ly,my,oy,ny,by,$x,qy,ry,sy,ty,uy,vy,xy,yy,zy,Ay,Ey,Cy,By,Dy,Ly,Hy,Iy,Jy,Ky,My,Ny,Oy,Ty,Uy,Vy,Wy,pY];var Ce=[U4,tE];var De=[V4,ID];var Ee=[W4,FB];var Fe=[X4,Vt,Y4,Tz,fT,gT,dT,X4];var Ge=[Z4,aC];var He=[_4,PQ,$T,VW,wA,zz,vz,JE,LE,oJ,RR,_4,_4,_4,_4,_4];var Ie=[$4,a5,Rz,Zy,Yg,$4,$4,$4];var Je=[b5,Ut,Q$,R$,I$,J$,Y$,_$,h0,j0,au,MD,b5,b5,b5,b5];var Ke=[c5,Yv,Zv,_v,$v,aw,bw,dw,gw,kw,Cw,Dw,Ew,Fw,Gw,Hw,Jw,Mw,Qw,fx,gx,hx,ix,jx,kx,mx,px,tx,E$,m$,n$,o$,u$,EC,d5,YB,uv,xu,Su,$u,Nu,iv,nv,lv,ov,Wv,Av,Kv,Lv,Sv,Tv,IX,vY,e5,c5,c5,c5,c5,c5,c5,c5,c5,c5,c5];var Le=[f5,jw,Pw,sx,BG,OQ,vR,cW,QV,dX,iX,r2,s2,t2,tz,rz,GC,mB,uA,uz,Wi,Yi,_i,aj,jj,lj,sj,uj,zj,Bj,Dj,Mj,Uj,Wj,kS,Mv,wz,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5,f5];return{_testSetjmp:q3,_saveSetjmp:c3,_free:C2,_main:Xg,_rand_r:k3,_realloc:E2,_i64Add:n3,_memmove:g3,_bitshift64Ashr:e3,_memset:h3,_malloc:B2,_strncpy:o3,_memcpy:f3,_strlen:d3,_bitshift64Lshr:p3,_bitshift64Shl:i3,_i64Subtract:m3,_strcpy:j3,_calloc:D2,_rand:l3,__GLOBAL__I_a:LT,runPostSets:b3,stackAlloc:Me,stackSave:Ne,stackRestore:Oe,setThrew:Pe,setTempRet0:Se,setTempRet1:Te,setTempRet2:Ue,setTempRet3:Ve,setTempRet4:We,setTempRet5:Xe,setTempRet6:Ye,setTempRet7:Ze,setTempRet8:_e,setTempRet9:$e,dynCall_iiiiiiii:A3,dynCall_viiiii:B3,dynCall_iiiiidiii:C3,dynCall_vd:D3,dynCall_vi:E3,dynCall_vii:F3,dynCall_iiiiiiiiiii:G3,dynCall_ii:H3,dynCall_viidi:I3,dynCall_iiiiiiiiiiiiii:J3,dynCall_iiii:K3,dynCall_iiiiiiiiiiiiiiiiiiiiiii:L3,dynCall_iiiiiiiiiiiiiiiiiiiii:M3,dynCall_viiiiid:N3,dynCall_viiiiiiii:O3,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:P3,dynCall_viiiiii:Q3,dynCall_viidii:R3,dynCall_iid:S3,dynCall_viiiiiii:T3,dynCall_viiiiiid:U3,dynCall_viiiiiiiii:V3,dynCall_iii:W3,dynCall_iiiiii:X3,dynCall_iiiiidi:Y3,dynCall_didd:Z3,dynCall_dii:_3,dynCall_i:$3,dynCall_iiiiiiiiii:a4,dynCall_viii:b4,dynCall_v:c4,dynCall_iiiiiiiii:d4,dynCall_iiiii:e4,dynCall_viiii:f4}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "_log10": _log10, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "__reallyNegative": __reallyNegative, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_acos": _acos, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






