var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 156592;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 156632;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(157459);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,245,0,0,0,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,117,112,112,101,114,84,97,110,107,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,1,0,0,0,4,1,0,0,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,96,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,108,111,119,101,114,84,97,110,107,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,1,0,0,0,42,1,0,0,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,0,0,0,1,0,0,0,43,1,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,95,105,110,32,62,32,48,46,48,32,116,104,101,110,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,95,105,110,32,62,32,48,46,48,32,116,104,101,110,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,49,93,0,0,0,0,0,0,0,1,0,0,0,46,1,0,0,49,101,45,49,53,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,62,32,48,46,48,32,116,104,101,110,32,68,73,86,73,83,73,79,78,40,56,46,52,48,49,51,48,53,56,49,53,50,53,57,54,56,57,101,45,49,49,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,32,42,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,44,32,49,101,45,49,53,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,41,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,62,32,48,46,48,32,116,104,101,110,32,68,73,86,73,83,73,79,78,40,56,46,52,48,49,51,48,53,56,49,53,50,53,57,54,56,57,101,45,49,49,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,32,42,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,44,32,49,101,45,49,53,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,41,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,50,93,0,0,0,0,0,1,0,0,0,47,1,0,0,1,0,0,0,49,1,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,51,1,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,49,93,0,1,0,0,0,53,1,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,81,1,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,50,93,0,1,0,0,0,85,1,0,0,111,118,101,114,102,108,111,119,46,99,114,111,115,115,65,114,101,97,32,42,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,111,118,101,114,102,108,111,119,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,86,1,0,0,111,118,101,114,102,108,111,119,46,99,114,111,115,115,65,114,101,97,32,42,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,111,118,101,114,102,108,111,119,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,90,1,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,62,32,48,46,48,32,116,104,101,110,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,62,32,48,46,48,32,116,104,101,110,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,51,93,0,0,0,1,0,0,0,104,1,0,0,108,111,119,101,114,84,97,110,107,46,99,114,111,115,115,65,114,101,97,0,0,0,0,0,1,0,0,0,115,1,0,0,117,112,112,101,114,84,97,110,107,46,99,114,111,115,115,65,114,101,97,0,0,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,87,97,116,101,114,73,70,57,55,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,86,101,115,115,101,108,32,105,115,32,111,118,101,114,102,108,111,119,105,110,103,32,40,102,108,117,105,100,76,101,118,101,108,32,62,32,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,61,32,0,0,0,41,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,70,108,117,105,100,32,108,101,118,101,108,32,40,61,32,0,41,32,105,115,32,98,101,108,111,119,32,122,101,114,111,32,109,101,97,110,105,110,103,32,116,104,97,116,32,116,104,101,32,115,111,108,117,116,105,111,110,32,102,97,105,108,101,100,46,0,0,0,0,0,0,0,119,97,116,101,114,0,0,0,77,97,115,115,70,108,111,119,83,111,117,114,99,101,95,84,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,80,97,114,97,109,101,116,101,114,32,108,101,110,103,116,104,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,111,114,32,101,113,117,97,108,32,104,101,105,103,104,116,95,97,98,46,0,0,0,0,160,15,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,40,16,0,0,62,1,0,0,9,0,0,0,62,1,0,0,129,0,0,0,0,0,0,0,40,16,0,0,63,1,0,0,9,0,0,0,63,1,0,0,144,0,0,0,0,0,0,0,216,16,0,0,25,1,0,0,7,0,0,0,25,1,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,84,97,110,107,115,46,84,97,110,107,115,87,105,116,104,79,118,101,114,102,108,111,119,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,84,97,110,107,115,46,84,97,110,107,115,87,105,116,104,79,118,101,114,102,108,111,119,95,105,110,102,111,46,120,109,108,0,0,0,0,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,111,102,112,84,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,32,80,97,32,60,61,32,0,32,80,97,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,112,114,101,115,115,117,114,101,41,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,168,20,0,0,122,16,0,0,9,0,0,0,125,16,0,0,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,54,52,46,48,32,42,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,50,46,53,49,32,47,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,97,117,120,49,32,42,32,97,98,115,40,100,112,95,102,114,105,99,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,50,46,53,49,32,47,32,97,117,120,50,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,32,47,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,68,101,108,116,97,32,47,32,51,46,55,32,43,32,53,46,55,52,32,47,32,82,101,32,94,32,48,46,57,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,10,87,114,111,110,103,32,118,97,108,117,101,32,111,102,32,112,97,114,97,109,101,116,101,114,32,100,101,102,105,110,101,95,112,32,40,61,32,102,97,108,115,101,41,32,105,110,32,109,111,100,101,108,32,34,0,34,58,10,84,104,101,32,115,101,108,101,99,116,101,100,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,104,97,115,32,77,101,100,105,117,109,46,115,105,110,103,108,101,83,116,97,116,101,61,116,114,117,101,46,10,84,104,101,114,101,102,111,114,101,44,32,97,110,32,98,111,117,110,100,97,114,121,32,100,101,110,115,105,116,121,32,99,97,110,110,111,116,32,98,101,32,100,101,102,105,110,101,100,32,97,110,100,10,100,101,102,105,110,101,95,112,32,61,32,116,114,117,101,32,105,115,32,114,101,113,117,105,114,101,100,46,10,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,85,116,105,108,105,116,105,101,115,46,109,111,0,248,25,0,0,18,0,0,0,5,0,0,0,23,0,0,0,3,0,0,0,0,0,0,0,10,87,114,111,110,103,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,34,32,105,110,32,109,111,100,101,108,32,34,0,0,0,0,34,58,10,84,104,101,32,98,111,117,110,100,97,114,121,32,118,97,108,117,101,32,88,95,98,111,117,110,100,97,114,121,40,0,0,0,0,0,0,0,41,32,61,32,0,0,0,0,10,105,115,32,110,101,103,97,116,105,118,101,46,32,73,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,10,0,0,0,0,0,248,25,0,0,26,0,0,0,7,0,0,0,33,0,0,0,3,0,0,0,0,0,0,0,32,32,32,88,95,98,111,117,110,100,97,114,121,91,0,0,93,32,61,32,0,0,0,0,32,34,0,0,0,0,0,0,34,10,0,0,0,0,0,0,84,104,101,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,100,111,32,110,111,116,32,115,117,109,32,117,112,32,116,111,32,49,46,32,73,110,115,116,101,97,100,44,32,115,117,109,40,88,95,98,111,117,110,100,97,114,121,41,32,61,32,0,58,10,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,97,116,97,32,112,111,105,110,116,115,32,110,111,116,32,115,111,114,116,101,100,32,97,112,112,114,111,112,114,105,97,116,101,108,121,32,40,120,48,32,61,32,0,0,32,62,32,120,49,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,102,108,105,112,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,0,0,0,248,25,0,0,94,2,0,0,5,0,0,0,95,2,0,0,74,0,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,101,114,105,118,97,116,105,118,101,115,32,97,116,32,100,97,116,97,32,112,111,105,110,116,115,32,100,111,32,110,111,116,32,97,108,108,111,119,32,99,111,45,109,111,110,111,116,111,110,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,44,32,97,115,32,98,111,116,104,32,97,114,101,32,110,111,110,45,122,101,114,111,44,32,111,102,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,97,110,100,32,104,97,118,101,32,97,110,32,97,98,115,111,108,117,116,101,32,118,97,108,117,101,32,108,97,114,103,101,114,32,116,104,97,110,32,109,97,99,104,105,110,101,32,101,112,115,32,40,121,48,100,32,61,32,0,44,32,121,49,100,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,99,111,114,114,101,99,116,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,248,25,0,0,101,2,0,0,7,0,0,0,102,2,0,0,79,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,112,104,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,168,20,0,0,37,10,0,0,9,0,0,0,40,10,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,32,80,97,32,60,61,32,32,48,46,48,32,80,97,0,0,168,20,0,0,6,7,0,0,9,0,0,0,8,7,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,48,32,77,112,97,0,0,0,0,0,168,20,0,0,9,7,0,0,9,0,0,0,10,7,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,32,75,41,32,105,115,32,108,111,119,101,114,32,116,104,97,110,32,50,55,51,46,49,53,32,75,33,0,0,0,0,0,168,20,0,0,11,7,0,0,9,0,0,0,12,7,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,50,58,32,116,104,101,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,116,104,101,32,108,105,109,105,116,32,111,102,32,49,48,55,51,46,49,53,32,75,0,0,0,0,0,0,0,168,20,0,0,13,7,0,0,9,0,0,0,15,7,0,0,55,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,103,46,112,105,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,102,46,100,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,1,0,0,0,8,56,0,0,16,56,0,0,0,0,0,0,1,0,0,0,248,54,0,0,0,55,0,0,0,0,0,0,1,0,0,0,232,53,0,0,240,53,0,0,0,0,0,0,1,0,0,0,232,52,0,0,240,52,0,0,0,0,0,0,1,0,0,0,232,51,0,0,240,51,0,0,0,0,0,0,1,0,0,0,232,50,0,0,240,50,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,111,91,50,53,93,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,168,20,0,0,103,6,0,0,9,0,0,0,106,6,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,168,20,0,0,107,6,0,0,9,0,0,0,108,6,0,0,56,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,49,58,32,116,104,101,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,0,0,168,20,0,0,109,6,0,0,9,0,0,0,110,6,0,0,53,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,168,20,0,0,190,8,0,0,9,0,0,0,192,8,0,0,40,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,112,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,0,32,80,97,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,49,48,32,77,112,97,32,105,110,32,114,101,103,105,111,110,32,53,0,0,168,20,0,0,193,8,0,0,9,0,0,0,194,8,0,0,67,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,103,53,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,0,0,32,75,41,32,105,115,32,104,105,103,104,101,114,32,116,104,97,110,32,108,105,109,105,116,32,111,102,32,50,50,55,51,46,49,53,75,32,105,110,32,114,101,103,105,111,110,32,53,0,0,0,0,0,0,0,0,168,20,0,0,195,8,0,0,9,0,0,0,196,8,0,0,77,0,0,0,0,0,0,0,24,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,20,0,0,204,11,0,0,9,0,0,0,206,11,0,0,62,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,112,115,97,116,58,32,105,110,112,117,116,32,116,101,109,112,101,114,97,116,117,114,101,32,40,61,32,54,49,49,46,54,53,55,32,75,41,46,10,108,111,119,101,114,32,116,104,97,110,32,116,104,101,32,116,114,105,112,108,101,32,112,111,105,110,116,32,116,101,109,112,101,114,97,116,117,114,101,32,50,55,51,46,49,54,32,75,0,0,0,0,168,20,0,0,214,19,0,0,11,0,0,0,215,19,0,0,91,0,0,0,0,0,0,0,73,110,118,101,114,115,101,32,105,116,101,114,97,116,105,111,110,32,111,102,32,100,116,32,102,114,111,109,32,112,104,32,99,97,108,108,101,100,32,105,110,32,50,32,112,104,97,115,101,32,114,101,103,105,111,110,58,32,116,104,105,115,32,99,97,110,32,110,111,116,32,119,111,114,107,0,0,0,0,0,168,20,0,0,246,19,0,0,9,0,0,0,247,19,0,0,65,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,116,111,102,112,104,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,1,0,0,0,240,49,0,0,248,49,0,0,0,0,0,0,1,0,0,0,248,48,0,0,0,49,0,0,0,0,0,0,1,0,0,0,0,48,0,0,8,48,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,116,115,97,116,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,168,20,0,0,82,11,0,0,9,0,0,0,85,11,0,0,41,0,0,0,0,0,0,0,1,0,0,0,248,46,0,0,0,47,0,0,0,0,0,0,1,0,0,0,240,45,0,0,248,45,0,0,0,0,0,0,1,0,0,0,232,44,0,0,240,44,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,112,32,116,111,111,32,108,111,119,10,112,32,61,32,0,0,0,0,32,80,97,32,60,32,0,0,32,80,97,0,0,0,0,0,168,20,0,0,117,19,0,0,9,0,0,0,119,19,0,0,76,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,108,111,119,10,84,32,61,32,0,0,0,0,32,75,32,60,32,0,0,0,32,75,0,0,0,0,0,0,168,20,0,0,120,19,0,0,9,0,0,0,122,19,0,0,73,0,0,0,0,0,0,0,66,97,115,101,73,70,57,55,46,100,111,102,112,116,51,58,32,102,117,110,99,116,105,111,110,32,99,97,108,108,101,100,32,111,117,116,115,105,100,101,32,111,102,32,114,101,103,105,111,110,32,51,33,32,84,32,116,111,111,32,104,105,103,104,10,112,32,61,32,0,0,0,32,80,97,44,32,84,32,61,32,0,0,0,0,0,0,0,168,20,0,0,123,19,0,0,9,0,0,0,125,19,0,0,66,0,0,0,0,0,0,0,168,20,0,0,178,19,0,0,9,0,0,0,178,19,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,100,111,102,112,116,51,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,168,20,0,0,221,20,0,0,9,0,0,0,221,20,0,0,81,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,102,117,110,99,116,105,111,110,32,116,111,102,112,104,53,58,32,105,116,101,114,97,116,105,111,110,32,102,97,105,108,101,100,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,111,102,112,84,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,168,20,0,0,19,17,0,0,9,0,0,0,22,17,0,0,41,0,0,0,0,0,0,0,1,0,0,0,184,44,0,0,192,44,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,98,111,117,110,100,97,114,121,50,51,111,102,112,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,168,20,0,0,222,0,0,0,9,0,0,0,225,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,49,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,168,20,0,0,80,1,0,0,9,0,0,0,83,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,168,20,0,0,160,1,0,0,9,0,0,0,163,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,49,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,168,20,0,0,54,1,0,0,9,0,0,0,57,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,108,111,119,101,114,111,102,112,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,168,20,0,0,238,0,0,0,9,0,0,0,241,0,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,53,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,168,20,0,0,255,0,0,0,9,0,0,0,2,1,0,0,41,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,104,117,112,112,101,114,111,102,112,50,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,112,114,101,115,115,117,114,101,10,112,32,61,32,0,0,0,0,0,0,0,168,20,0,0,222,1,0,0,9,0,0,0,225,1,0,0,41,0,0,0,0,0,0,0,168,20,0,0,11,25,0,0,7,0,0,0,11,25,0,0,71,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,118,101,114,115,101,32,105,116,101,114,97,116,105,111,110,32,111,102,32,115,116,101,97,109,32,116,97,98,108,101,115,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,114,101,103,105,111,110,32,99,111,109,112,117,116,97,116,105,111,110,32,111,102,32,73,70,57,55,32,115,116,101,97,109,32,116,97,98,108,101,115,40,112,32,61,32,0,0,0,44,32,104,32,61,32,0,0,41,0,0,0,0,0,0,0,168,20,0,0,22,25,0,0,7,0,0,0,23,25,0,0,58,0,0,0,0,0,0,0,1,0,0,0,96,43,0,0,104,43,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,118,105,115,99,95,100,84,112,32,102,111,114,32,118,105,115,99,111,115,105,116,121,32,99,97,108,108,101,100,32,119,105,116,104,32,116,111,111,32,108,111,119,32,100,101,110,115,105,116,121,10,100,32,61,32,0,0,0,0,32,60,61,32,0,0,0,0,32,40,116,114,105,112,108,101,32,112,111,105,110,116,32,100,101,110,115,105,116,121,41,0,168,20,0,0,87,15,0,0,9,0,0,0,90,15,0,0,37,0,0,0,0,0,0,0,73,70,57,55,32,109,101,100,105,117,109,32,102,117,110,99,116,105,111,110,32,118,105,115,99,95,100,84,112,58,32,118,105,115,99,111,115,105,116,121,32,99,111,109,112,117,116,101,100,32,111,117,116,115,105,100,101,32,116,104,101,32,114,97,110,103,101,10,111,102,32,118,97,108,105,100,105,116,121,32,111,102,32,116,104,101,32,73,70,57,55,32,102,111,114,109,117,108,97,116,105,111,110,58,32,112,32,61,32,0,0,0,32,80,97,44,32,84,99,32,61,32,0,0,0,0,0,0,168,20,0,0,91,15,0,0,9,0,0,0,96,15,0,0,44,0,0,0,0,0,0,0,44,32,84,32,61,32,0,0,168,20,0,0,48,28,0,0,7,0,0,0,49,28,0,0,58,0,0,0,0,0,0,0,42,0,0,0,0,0,0,0,102,233,84,67,44,108,224,63,94,63,14,148,37,132,212,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,146,76,152,122,231,232,191,208,196,42,148,59,34,200,63,25,161,233,54,242,138,203,63,209,13,3,76,207,106,231,63,54,90,14,244,80,219,243,63,203,158,4,54,231,160,247,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,107,108,10,191,47,9,210,191,8,60,48,128,240,33,241,191,149,73,13,109,0,54,244,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,203,126,130,48,92,194,198,63,252,86,235,196,229,120,221,63,107,35,67,51,244,244,205,63,137,194,29,94,198,131,223,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,220,181,41,195,93,98,165,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,251,55,47,78,124,196,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,193,4,234,164,41,144,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,151,88,73,198,146,187,109,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,0,0,0,0,0,0,0,248,196,66,103,212,192,117,64,133,199,236,54,203,172,242,191,226,202,254,210,61,179,80,63,25,115,134,86,91,228,129,64,99,5,225,42,114,214,43,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,24,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,50,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,54,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,32,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,32,64,32,0,0,0,0,0,0,0,27,82,16,195,221,180,117,63,91,241,78,159,211,197,197,191,232,255,187,127,199,67,38,64,218,1,248,99,246,5,161,192,206,136,30,128,39,149,64,191,48,128,218,26,207,206,225,63,240,4,46,183,154,223,34,192,202,136,215,255,21,16,211,191,53,217,90,128,221,123,87,64,96,90,249,145,239,193,147,63,112,55,147,142,204,253,218,63,163,49,164,161,90,37,76,193,177,214,63,238,242,53,126,191,8,53,151,241,70,180,214,191,219,168,78,20,129,246,255,191,128,189,125,5,23,121,242,63,106,24,188,51,171,51,182,64,51,132,142,203,34,141,128,63,185,137,15,26,189,17,198,63,103,2,133,8,232,174,240,63,117,149,156,29,96,13,211,191,220,149,151,95,192,238,225,63,74,192,30,215,113,157,209,63,201,162,112,86,16,253,194,191,77,228,10,220,83,171,176,191,227,251,230,96,194,101,7,192,83,250,58,253,84,5,177,63,139,233,23,51,210,47,12,64,66,43,165,221,120,248,141,191,205,57,22,215,212,245,1,192,102,59,4,98,115,175,241,63,101,90,82,13,170,237,164,191,30,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,28,64,0,0,0,0,0,0,32,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,24,64,30,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,64,30,0,0,0,0,0,0,0,125,184,117,9,34,88,35,190,173,203,40,168,167,53,78,62,229,95,204,153,121,156,195,62,254,182,180,246,203,101,1,191,18,48,47,21,9,176,81,63,201,60,7,228,82,94,209,191,146,130,40,50,1,39,241,63,80,49,160,27,129,82,235,191,246,174,159,174,28,145,246,190,144,218,49,221,87,56,73,63,102,117,23,114,203,168,113,191,17,114,159,221,142,3,221,63,83,94,100,244,123,63,224,191,136,254,137,238,104,30,89,192,254,28,203,4,207,14,204,191,58,249,102,172,225,175,9,192,18,211,236,226,138,252,130,64,231,85,151,136,54,70,66,63,249,169,122,242,247,255,199,63,70,140,135,102,188,138,130,63,249,126,253,99,70,68,210,63,125,150,168,88,97,228,160,63,230,210,248,105,245,180,206,63,138,172,175,65,105,79,19,64,104,245,29,59,110,155,39,192,119,152,47,138,217,177,197,63,81,88,2,150,187,109,146,191,36,129,254,185,99,9,163,63,224,240,16,12,61,117,171,191,96,179,24,60,39,182,249,63,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,44,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,52,64,0,0,0,0,0,0,54,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,20,64,31,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,20,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,8,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,40,64,31,0,0,0,0,0,0,0,227,139,224,185,7,240,129,190,199,167,35,43,83,31,211,62,40,114,77,59,34,174,238,190,41,130,212,196,250,47,122,63,63,226,81,247,138,76,119,64,152,254,207,52,139,18,188,192,100,178,19,129,109,128,33,65,128,60,67,165,246,105,68,193,89,239,89,2,195,131,1,191,251,187,130,30,23,35,153,191,195,72,114,66,134,231,71,64,201,118,94,97,66,9,224,62,55,111,232,94,106,7,85,63,170,153,252,205,103,136,145,63,24,215,84,75,40,5,33,192,233,234,135,170,60,245,139,191,125,151,220,87,30,32,208,190,68,241,91,70,74,164,107,63,178,108,175,52,233,166,225,191,206,12,139,3,160,85,231,63,97,97,173,126,173,83,132,191,249,173,4,9,6,139,190,191,51,14,161,48,222,103,233,63,53,239,38,140,197,18,221,63,222,108,213,220,59,225,202,63,33,203,14,111,2,77,122,191,203,46,12,82,120,20,152,191,183,35,106,48,182,169,100,63,238,50,72,229,102,84,127,191,29,139,85,18,145,227,139,63,111,231,135,7,126,62,139,191,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,40,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,20,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,64,0,0,0,0,0,0,0,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,36,64,0,0,0,0,0,0,44,64,0,0,0,0,0,0,48,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,63,33,0,0,0,0,0,0,0,0,0,0,0,0,0,40,192,0,0,0,0,0,0,40,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,36,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,32,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,24,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,16,192,0,0,0,0,0,0,8,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,192,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,20,64,0,0,0,0,0,0,24,64,0,0,0,0,0,0,32,64,33,0,0,0,0,0,0,0,77,167,246,65,166,242,0,63,149,115,198,175,185,184,32,191,108,133,64,64,120,47,63,191,140,106,98,88,202,150,89,63,223,23,144,208,200,16,187,63,239,224,44,179,125,118,85,192,164,38,97,234,30,161,134,64,31,236,239,98,140,73,104,63,166,229,119,245,35,71,120,191,219,58,64,176,10,222,137,191,178,42,1,159,147,159,189,191,158,152,86,48,155,57,85,64,166,99,70,220,226,61,134,191,170,142,33,156,255,153,143,63,106,100,216,77,47,54,179,63,132,234,73,145,175,219,153,63,193,132,70,10,49,217,174,191,171,220,81,100,26,156,8,192,247,200,6,135,176,99,173,191,219,94,228,246,139,35,20,64,58,0,51,85,69,154,237,191,184,70,117,189,181,86,15,64,193,109,7,107,34,84,83,192,97,26,42,55,139,138,194,64,245,24,97,50,133,133,53,193,210,177,220,201,81,50,96,65,11,93,150,161,24,142,235,63,150,223,73,71,181,177,212,63,181,166,108,245,236,241,235,63,67,187,199,160,31,242,219,191,232,227,2,191,153,87,210,63,178,144,147,195,28,222,192,191,63,45,198,149,134,183,123,63,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,1,0,0,0,89,0,0,0,49,101,45,49,53,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,1,0,0,0,93,0,0,0,49,101,45,49,53,32,43,32,109,97,120,40,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,0,1,0,0,0,100,0,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,106,0,0,0,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,65,114,101,97,0,0,0,0,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,0,0,0,0,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,50,93,32,42,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,65,114,101,97,0,0,0,0,108,111,119,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,0,0,0,0,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,49,93,32,42,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,47,42,82,101,97,108,42,47,40,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,32,43,32,45,49,41,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,1,0,0,0,114,0,0,0,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,0,0,0,0,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,49,93,32,42,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,1,0,0,0,145,0,0,0,111,118,101,114,102,108,111,119,46,99,114,111,115,115,65,114,101,97,32,42,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,148,0,0,0,47,42,82,101,97,108,42,47,40,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,110,32,43,32,45,49,41,0,0,0,0,0,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,1,0,0,0,153,0,0,0,108,111,119,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,0,0,0,0,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,50,93,32,42,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,0,0,0,0,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,112,101,110,101,116,114,97,116,105,111,110,91,51,93,32,42,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,1,0,0,0,163,0,0,0,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,181,0,0,0,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,32,94,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,10,1,0,0,1,0,0,0,18,1,0,0,1,0,0,0,21,1,0,0,1,0,0,0,27,1,0,0,1,0,0,0,35,1,0,0,1,0,0,0,67,1,0,0,1,0,0,0,73,1,0,0,1,0,0,0,78,1,0,0,1,0,0,0,97,1,0,0,1,0,0,0,100,1,0,0,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,0,0,0,0,0,1,0,0,0,108,1,0,0,1,0,0,0,111,1,0,0,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,0,0,0,0,0,0,62,0,0,56,62,0,0,112,62,0,0,24,64,0,0,80,64,0,0,136,64,0,0,192,64,0,0,104,66,0,0,192,66,0,0,24,67,0,0,112,67,0,0,200,67,0,0,128,69,0,0,216,69,0,0,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,32,62,61,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,0,0,0,0,0,0,0,0,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,32,62,61,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,0,0,0,0,0,0,0,0,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,32,62,61,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,104,101,105,103,104,116,0,0,0,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,32,62,61,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,0,0,0,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,32,62,61,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,0,0,0,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,41,41,32,111,114,32,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,115,91,50,93,32,62,32,48,46,48,32,111,114,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,62,61,32,117,112,112,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,0,0,0,0,0,0,0,108,111,119,101,114,84,97,110,107,46,115,91,49,93,32,62,32,48,46,48,32,111,114,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,108,111,119,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,0,0,0,0,0,0,0,112,114,101,115,115,117,114,101,46,112,32,62,32,104,121,115,116,101,114,101,115,105,115,46,117,72,105,103,104,32,111,114,32,112,114,101,40,104,121,115,116,101,114,101,115,105,115,46,121,41,32,97,110,100,32,112,114,101,115,115,117,114,101,46,112,32,62,61,32,104,121,115,116,101,114,101,115,105,115,46,117,76,111,119,0,0,0,0,117,112,112,101,114,84,97,110,107,46,115,91,49,93,32,62,32,48,46,48,32,111,114,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,117,112,112,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,0,0,0,0,0,0,0,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,41,41,32,111,114,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,0,0,108,111,119,101,114,84,97,110,107,46,115,91,50,93,32,62,32,48,46,48,32,111,114,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,62,61,32,108,111,119,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,0,0,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,115,91,51,93,32,62,32,48,46,48,32,111,114,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,104,101,105,103,104,116,32,62,61,32,117,112,112,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,0,0,0,0,0,0,0,1,0,0,0,58,1,0,0,1,0,0,0,7,1,0,0,1,0,0,0,254,0,0,0,1,0,0,0,252,0,0,0,1,0,0,0,250,0,0,0,1,0,0,0,248,0,0,0,1,0,0,0,238,0,0,0,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,1,0,0,0,28,1,0,0,1,0,0,0,255,255,255,255,1,0,0,0,38,1,0,0,1,0,0,0,255,255,255,255,1,0,0,0,255,255,255,255,48,70,0,0,56,70,0,0,64,70,0,0,72,70,0,0,80,70,0,0,88,70,0,0,96,70,0,0,104,70,0,0,112,70,0,0,120,70,0,0,128,70,0,0,136,70,0,0,144,70,0,0,152,70,0,0,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,41,41,0,0,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,41,41,0,0,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,41,41,0,0,0,0,0,0,117,112,112,101,114,84,97,110,107,46,115,91,50,93,32,62,32,48,46,48,0,0,0,0,108,111,119,101,114,84,97,110,107,46,115,91,49,93,32,62,32,48,46,48,0,0,0,0,112,114,101,115,115,117,114,101,46,112,32,62,32,104,121,115,116,101,114,101,115,105,115,46,117,72,105,103,104,0,0,0,112,114,101,115,115,117,114,101,46,112,32,62,61,32,104,121,115,116,101,114,101,115,105,115,46,117,76,111,119,0,0,0,117,112,112,101,114,84,97,110,107,46,115,91,49,93,32,62,32,48,46,48,0,0,0,0,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,60,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,98,111,105,108,105,110,103,99,117,114,118,101,95,112,40,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,41,41,0,0,0,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,62,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,104,118,108,95,112,40,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,66,97,115,101,73,70,57,55,46,82,101,103,105,111,110,115,46,100,101,119,99,117,114,118,101,95,112,40,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,41,41,0,0,0,0,0,0,0,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,32,62,32,50,50,48,54,52,48,48,48,46,48,0,0,0,0,0,0,108,111,119,101,114,84,97,110,107,46,115,91,50,93,32,62,32,48,46,48,0,0,0,0,117,112,112,101,114,84,97,110,107,46,115,91,51,93,32,62,32,48,46,48,0,0,0,0,0,62,0,0,56,62,0,0,216,70,0,0,152,71,0,0,24,64,0,0,80,64,0,0,136,64,0,0,88,72,0,0,24,73,0,0,216,73,0,0,240,73,0,0,8,74,0,0,40,74,0,0,72,74,0,0,96,74,0,0,40,75,0,0,240,75,0,0,24,76,0,0,48,76,0,0,0,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,117,112,112,101,114,84,97,110,107,46,95,114,101,103,117,108,97,114,70,108,111,119,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,117,112,112,101,114,84,97,110,107,46,95,114,101,103,117,108,97,114,70,108,111,119,91,50,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,117,112,112,101,114,84,97,110,107,46,95,114,101,103,117,108,97,114,70,108,111,119,91,51,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,117,112,112,101,114,84,97,110,107,46,95,105,110,70,108,111,119,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,117,112,112,101,114,84,97,110,107,46,95,105,110,70,108,111,119,91,50,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,117,112,112,101,114,84,97,110,107,46,95,105,110,70,108,111,119,91,51,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,117,112,112,101,114,84,97,110,107,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,108,111,119,101,114,84,97,110,107,46,95,114,101,103,117,108,97,114,70,108,111,119,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,108,111,119,101,114,84,97,110,107,46,95,114,101,103,117,108,97,114,70,108,111,119,91,50,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,108,111,119,101,114,84,97,110,107,46,95,105,110,70,108,111,119,91,49,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,108,111,119,101,114,84,97,110,107,46,95,105,110,70,108,111,119,91,50,93,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,108,111,119,101,114,84,97,110,107,46,95,109,101,100,105,117,109,46,95,112,104,97,115,101,32,102,114,111,109,32,37,108,100,32,116,111,32,37,108,100,0,0,100,105,115,99,114,101,116,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([32,118,97,114,32,99,104,97,110,103,101,100,58,32,104,121,115,116,101,114,101,115,105,115,46,95,121,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,0,0,45,50,46,48,32,43,32,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,0,0,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,45,32,117,112,112,101,114,84,97,110,107,46,104,95,115,116,97,114,116,0,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,0,0,0,0,45,50,46,48,32,43,32,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,0,0,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,45,32,108,111,119,101,114,84,97,110,107,46,104,95,115,116,97,114,116,0,0,110,111,116,32,112,114,101,40,104,121,115,116,101,114,101,115,105,115,46,121,41,32,61,61,32,104,121,115,116,101,114,101,115,105,115,46,112,114,101,95,121,95,115,116,97,114,116,0,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,45,49,48,48,48,46,48,32,42,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,0,0,0,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,45,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,0,0,0,56,80,0,0,80,80,0,0,120,80,0,0,184,80,0,0,232,80,0,0,0,81,0,0,40,81,0,0,88,81,0,0,160,81,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,28,0,0,0,111,118,101,114,102,108,111,119,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,29,0,0,0,1,0,0,0,30,0,0,0,112,105,112,101,46,112,101,114,105,109,101,116,101,114,0,0,1,0,0,0,31,0,0,0,1,0,0,0,43,0,0,0,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,44,0,0,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,52,0,0,0,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,108,111,119,101,114,84,97,110,107,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,1,0,0,0,72,0,0,0,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,0,0,0,0,0,0,224,82,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,51,46,49,52,49,53,57,50,54,53,51,53,56,57,55,57,51,32,42,32,117,112,112,101,114,84,97,110,107,46,99,114,111,115,115,65,114,101,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,1,0,0,0,116,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,95,105,110,32,62,32,48,46,48,32,116,104,101,110,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,95,105,110,32,62,32,48,46,48,32,116,104,101,110,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,49,93,0,0,0,0,0,0,0,1,0,0,0,124,0,0,0,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,0,0,0,1,0,0,0,126,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,49,93,0,1,0,0,0,129,0,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,130,0,0,0,49,101,45,49,53,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,0,0,1,0,0,0,131,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,62,32,48,46,48,32,116,104,101,110,32,68,73,86,73,83,73,79,78,40,56,46,52,48,49,51,48,53,56,49,53,50,53,57,54,56,57,101,45,49,49,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,32,42,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,44,32,49,101,45,49,53,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,41,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,62,32,48,46,48,32,116,104,101,110,32,68,73,86,73,83,73,79,78,40,56,46,52,48,49,51,48,53,56,49,53,50,53,57,54,56,57,101,45,49,49,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,32,42,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,44,32,49,101,45,49,53,32,43,32,109,97,120,40,45,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,44,32,49,101,45,49,53,41,41,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,50,93,0,0,0,0,0,1,0,0,0,134,0,0,0,112,105,112,101,46,99,114,111,115,115,65,114,101,97,32,42,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,156,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,32,48,46,48,32,116,104,101,110,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,50,93,0,1,0,0,0,167,0,0,0,108,111,119,101,114,84,97,110,107,46,99,114,111,115,115,65,114,101,97,0,0,0,0,0,1,0,0,0,169,0,0,0,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,114,104,111,95,112,114,111,112,115,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,62,32,48,46,48,32,116,104,101,110,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,77,111,100,101,108,105,99,97,46,77,101,100,105,97,46,87,97,116,101,114,46,73,70,57,55,95,85,116,105,108,105,116,105,101,115,46,119,97,116,101,114,66,97,115,101,80,114,111,112,95,112,104,40,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,44,32,115,109,111,111,116,104,40,48,44,32,105,102,32,40,45,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,41,32,62,32,48,46,48,32,116,104,101,110,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,101,108,115,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,41,44,32,48,44,32,48,41,41,32,42,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,65,114,101,97,115,91,51,93,0,0,0,1,0,0,0,173,0,0,0,111,118,101,114,102,108,111,119,46,99,114,111,115,115,65,114,101,97,32,42,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,42,32,111,118,101,114,102,108,111,119,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,176,0,0,0,111,118,101,114,102,108,111,119,46,99,114,111,115,115,65,114,101,97,32,42,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,42,32,111,118,101,114,102,108,111,119,46,110,80,97,114,97,108,108,101,108,0,0,0,0,1,0,0,0,187,0,0,0,117,112,112,101,114,84,97,110,107,46,99,114,111,115,115,65,114,101,97,0,0,0,0,0,1,0,0,0,126,1,0,0,47,42,82,101,97,108,42,47,40,45,49,32,43,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,110,41,0,0,0,0,0,1,0,0,0,131,1,0,0,47,42,82,101,97,108,42,47,40,45,49,32,43,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,41,0,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,182,1,0,0,112,105,112,101,46,112,101,114,105,109,101,116,101,114,0,0,1,0,0,0,183,1,0,0,1,0,0,0,191,1,0,0,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,1,0,0,0,210,1,0,0,111,118,101,114,102,108,111,119,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,1,0,0,0,211,1,0,0,1,0,0,0,219,1,0,0,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,95,115,116,97,114,116,95,101,112,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,95,115,116,97,114,116,95,101,112,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,96,0,0,87,4,0,0,13,0,0,0,91,4], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,96,0,0,80,4,0,0,13,0,0,0,82,4,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,136,96,0,0,26,4,0,0,13,0,0,0,28,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,96,0,0,21,4,0,0,13,0,0,0,23,4,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,96,0,0,229,4,0,0,13,0,0,0,231,4,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,96,0,0,221,4,0,0,13,0,0,0,222,4,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,96,0,0,32,4,0,0,13,0,0,0,34,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,96,0,0,29,4,0,0,13,0,0,0,31,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,96,0,0,14,0,0,0,5,0,0,0,16,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,96,0,0,17,0,0,0,5,0,0,0,19,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,96,0,0,11,0,0,0,5,0,0,0,13,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,96,0,0,7,1,0,0,7,0,0,0,9,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,136,96,0,0,255,0,0,0,7,0,0,0,0,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,96,0,0,248,0,0,0,7,0,0,0,249,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,121,115,116,101,109,46,109,111,0,0,0,0,40,129,0,0,32,0,0,0,3,0,0,0,34,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,40,129,0,0,29,0,0,0,3,0,0,0,31,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,40,129,0,0,26,0,0,0,3,0,0,0,28,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,129,0,0,47,0,0,0,3,0,0,0,49,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,129,0,0,44,0,0,0,3,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,40,129,0,0,63,0,0,0,3,0,0,0,65,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,40,129,0,0,60,0,0,0,3,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,40,129,0,0,57,0,0,0,3,0,0,0,59,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,129,0,0,35,0,0,0,3,0,0,0,38,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,40,129,0,0,22,0,0,0,3,0,0,0,25,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,40,129,0,0,11,0,0,0,3,0,0,0,13,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,40,129,0,0,8,0,0,0,3,0,0,0,10,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,111,117,114,99,101,115,46,109,111,0,0,0,112,137,0,0,208,1,0,0,5,0,0,0,211,1,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,84,32,62,61,32,49,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,112,137,0,0,204,1,0,0,5,0,0,0,207,1,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,137,0,0,200,1,0,0,5,0,0,0,203,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,112,137,0,0,74,3,0,0,5,0,0,0,76,3,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,240,104,0,0,236,1,0,0,5,0,0,0,237,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,240,104,0,0,59,2,0,0,7,0,0,0,61,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,95,115,116,97,114,116,95,101,112,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,95,115,116,97,114,116,95,101,112,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,106,0,0,85,0,0,0,3,0,0,0,85,0,0,0,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,240,104,0,0,45,2,0,0,7,0,0,0,47,2,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,240,104,0,0,40,2,0,0,7,0,0,0,42,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,240,104,0,0,37,2,0,0,7,0,0,0,39,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,106,0,0,70,0,0,0,3,0,0,0,72,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,72,106,0,0,24,1,0,0,9,0,0,0,25,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,84,95,97,109,98,105,101,110,116,32,62,61,32,49,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,84,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,72,106,0,0,65,0,0,0,3,0,0,0,67,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,112,95,97,109,98,105,101,110,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,72,106,0,0,62,0,0,0,3,0,0,0,64,0,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,240,104,0,0,34,2,0,0,7,0,0,0,36,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,240,104,0,0,31,2,0,0,7,0,0,0,33,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,72,106,0,0,58,0,0,0,3,0,0,0,58,0,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,72,106,0,0,213,0,0,0,9,0,0,0,215,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,72,106,0,0,210,0,0,0,9,0,0,0,212,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,51,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,50,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,105,110,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,72,106,0,0,43,2,0,0,7,0,0,0,44,2,0,0,104,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,122,101,116,97,95,111,117,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,72,106,0,0,41,2,0,0,7,0,0,0,42,2,0,0,105,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,72,106,0,0,40,2,0,0,7,0,0,0,40,2,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,68,97,116,97,91,49,93,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,72,106,0,0,38,2,0,0,7,0,0,0,39,2,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,240,104,0,0,55,2,0,0,7,0,0,0,58,2,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,240,104,0,0,51,2,0,0,7,0,0,0,54,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,88,159,0,0,74,22,0,0,7,0,0,0,75,22,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,114,101,115,115,117,114,101,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,114,101,115,115,117,114,101,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,114,101,115,115,117,114,101,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,240,104,0,0,16,0,0,0,5,0,0,0,17,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,114,101,115,115,117,114,101,46,112,111,114,116,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,114,101,115,115,117,114,101,46,112,111,114,116,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,112,114,101,115,115,117,114,101,46,112,111,114,116,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,240,104,0,0,13,0,0,0,5,0,0,0,14,0,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,88,159,0,0,150,27,0,0,7,0,0,0,150,27,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,96,0,0,245,4,0,0,13,0,0,0,1,5,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,88,159,0,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,88,159,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,88,159,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,87,97,116,101,114,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,117,112,112,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,117,112,112,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,117,112,112,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,24,179,0,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,24,179,0,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,62,61,32,49,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,115,97,116,46,84,115,97,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,24,179,0,0,150,27,0,0,7,0,0,0,150,27,0,0,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,95,105,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,95,105,110,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,109,97,115,115,70,108,111,119,82,97,116,101,46,109,95,102,108,111,119,95,105,110,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,111,117,114,99,101,115,46,109,111,0,0,0,80,187,0,0,217,1,0,0,5,0,0,0,220,1,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,114,101,115,115,117,114,101,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,114,101,115,115,117,114,101,46,112,32,62,61,32,48,46,48,32,97,110,100,32,112,114,101,115,115,117,114,101,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,101,110,115,111,114,115,46,109,111,0,0,0,40,188,0,0,9,0,0,0,5,0,0,0,14,0,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,181,0,0,143,0,0,0,5,0,0,0,143,0,0,0,43,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,105,112,101,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,171,0,0,74,2,0,0,7,0,0,0,74,2,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,172,0,0,224,0,0,0,9,0,0,0,224,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,62], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,104,172,0,0,255,0,0,0,9,0,0,0,0,1,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,118,101,115,115,101,108,95,112,115,95,115,116,97,116,105,99,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,104,172,0,0,14,1,0,0,9,0,0,0,15,1,0,0,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,108,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,172,0,0,53,0,0,0,3,0,0,0,54,0,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,24,179,0,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,24,179,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,24,179,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,62,61,32,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,109,101,100,105,117,109,46,112,104,97,115,101,32,60,61,32,50,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,181,0,0,164,0,0,0,5,0,0,0,168,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,119,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,119,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,49,46,48,32,97,110,100,32,108,111,119,101,114,84,97,110,107,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,104,171,0,0,247,1,0,0,5,0,0,0,248,1,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,104,171,0,0,15,0,0,0,5,0,0,0,15,0,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,97,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,112,111,114,116,95,98,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,104,171,0,0,16,0,0,0,5,0,0,0,17,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,112,190,0,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,112,190,0,0,53,4,0,0,13,0,0,0,53,4,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,112,190,0,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,112,190,0,0,56,4,0,0,13,0,0,0,56,4,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,115,116,97,116,101,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,181,0,0,145,0,0,0,5,0,0,0,145,0,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,111,118,101,114,102,108,111,119,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,171,0,0,29,4,0,0,9,0,0,0,34,4,0,0,39,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,97,110,107,115,95,84,97,110,107,115,87,105,116,104,79,118,101,114,102,108,111,119,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,52,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,52,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,52,44,52,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,52,44,48,93,32,61,32,122,101,114,111,115,40,52,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,52,93,32,61,32,122,101,114,111,115,40,48,44,52,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,52,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,108,111,119,101,114,84,97,110,107,80,109,101,100,105,117,109,80,104,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,108,111,119,101,114,84,97,110,107,80,108,101,118,101,108,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,117,112,112,101,114,84,97,110,107,80,109,101,100,105,117,109,80,104,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,117,112,112,101,114,84,97,110,107,80,108,101,118,101,108,32,61,32,120,91,52,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,97,110,107,115,95,84,97,110,107,115,87,105,116,104,79,118,101,114,102,108,111,119,59,10,0,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,221,0,0,80,221,0,0,96,221,0,0,120,221,0,0,152,221,0,0,168,221,0,0,192,221,0,0,208,221,0,0,232,221,0,0,8,222,0,0,48,222,0,0,72,222,0,0,104,222,0,0,128,222,0,0,168,222,0,0,200,222,0,0,248,222,0,0,40,223,0,0,64,223,0,0,120,223,0,0,144,223,0,0,192,223,0,0,224,223,0,0,24,224,0,0,64,224,0,0,120,224,0,0,168,224,0,0,184,224,0,0,216,224,0,0,0,225,0,0,32,225,0,0,72,225,0,0,112,225,0,0,136,225,0,0,160,225,0,0,176,225,0,0,200,225,0,0,248,225,0,0,72,226,0,0,136,226,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,184,240,0,0,72,239,0,0,208,237,0,0,88,236,0,0,88,236,0,0,224,234,0,0,208,237,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,128,251,0,0,8,248,0,0,152,246,0,0,40,245,0,0,40,245,0,0,184,243,0,0,152,246,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,200,249,0,0,216,249,0,0,232,249,0,0,184,234,0,0,240,249,0,0,0,250,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,96,253,0,0,104,253,0,0,112,253,0,0,120,253,0,0,240,252,0,0,128,253,0,0,144,253,0,0,152,253,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,254,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,136,255,0,0,152,255,0,0,160,255,0,0,168,255,0,0,184,255,0,0,200,255,0,0,208,255,0,0,224,255,0,0,240,255,0,0,0,0,1,0,16,0,1,0,32,0,1,0,48,0,1,0,64,0,1,0,80,0,1,0,88,0,1,0,96,0,1,0,112,0,1,0,120,0,1,0,136,0,1,0,152,0,1,0,168,0,1,0,184,0,1,0,200,0,1,0,216,0,1,0,232,0,1,0,248,0,1,0,8,1,1,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,144,1,1,0,152,1,1,0,152,1,1,0,184,1,1,0,232,1,1,0,8,2,1,0,64,2,1,0,112,2,1,0,160,2,1,0,192,2,1,0,240,2,1,0,8,3,1,0,40,3,1,0,80,3,1,0,112,3,1,0,160,3,1,0,192,3,1,0,232,3,1,0,8,4,1,0,48,4,1,0,96,4,1,0,152,4,1,0,192,4,1,0,240,4,1,0,32,5,1,0,72,5,1,0,120,5,1,0,128,5,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,144,1,1,0,128,8,1,0,136,8,1,0,144,8,1,0,160,255,0,0,152,8,1,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,100,0,0,0,0,37,100,100,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,16,10,1,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,40,10,1,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,64,10,1,0,72,10,1,0,80,10,1,0,96,10,1,0,112,10,1,0,120,10,1,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,117,109,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,144,21,1,0,0,0,0,0,8,21,1,0,0,0,0,0,128,20,1,0,0,0,0,0,248,19,1,0,0,0,0,0,240,18,1,0,0,0,0,0,232,17,1,0,0,0,0,0,224,16,1,0,0,0,0,0,216,15,1,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,120,23,1,0,136,23,1,0,144,23,1,0,152,23,1,0,168,23,1,0,176,23,1,0,184,23,1,0,192,23,1,0,200,23,1,0,208,23,1,0,216,23,1,0,232,23,1,0,240,23,1,0,0,24,1,0,16,24,1,0,32,24,1,0,40,24,1,0,56,24,1,0,64,24,1,0,80,24,1,0,88,24,1,0,112,24,1,0,120,24,1,0,128,24,1,0,144,24,1,0,152,24,1,0,168,24,1,0,184,24,1,0,192,24,1,0,200,24,1,0,208,24,1,0,216,24,1,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,104,25,1,0,112,25,1,0,184,25,1,0,232,25,1,0,24,26,1,0,96,26,1,0,160,26,1,0,232,26,1,0,24,27,1,0,96,27,1,0,120,27,1,0,152,27,1,0,208,27,1,0,248,27,1,0,32,28,1,0,88,28,1,0,168,28,1,0,8,29,1,0,56,29,1,0,112,29,1,0,160,29,1,0,232,29,1,0,16,30,1,0,64,30,1,0,112,30,1,0,200,30,1,0,16,31,1,0,128,31,1,0,176,31,1,0,248,31,1,0,24,32,1,0,216,24,1,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,104,25,1,0,216,32,1,0,128,33,1,0,232,25,1,0,24,26,1,0,232,33,1,0,160,26,1,0,232,26,1,0,112,34,1,0,176,34,1,0,120,27,1,0,152,27,1,0,80,35,1,0,144,35,1,0,208,35,1,0,88,28,1,0,168,28,1,0,16,36,1,0,72,36,1,0,208,36,1,0,248,36,1,0,232,29,1,0,16,30,1,0,64,30,1,0,96,37,1,0,232,37,1,0,232,38,1,0,128,31,1,0,176,31,1,0,248,31,1,0,24,32,1,0,216,24,1,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,44,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,44,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,44,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,44,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,44,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71184);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,128,62,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81528);
/* memory initializer */ allocate([67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,68,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,67,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,69,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,69,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,69,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,69,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,70,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,70,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,71,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,72,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,72,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,72,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,72,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,72,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,208,107,1,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,176,108,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,109,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,88,109,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,176,109,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,184,109,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,110,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,80,110,1,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,110,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,136,122,1,0,168,123,1,0,176,123,1,0,192,123,1,0,208,123,1,0,224,123,1,0,248,123,1,0,16,124,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,136,122,1,0,144,122,1,0,216,122,1,0,0,123,1,0,32,123,1,0,64,123,1,0,104,123,1,0,144,123,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,240,130,1,0,0,131,1,0,8,131,1,0,16,131,1,0,24,131,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,56,131,1,0,64,131,1,0,80,131,1,0,96,131,1,0,24,131,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+92213);
/* memory initializer */ allocate([35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,32,158,1,0,232,159,1,0,240,159,1,0,248,159,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,32,158,1,0,40,159,1,0,120,159,1,0,168,159,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,32,158,1,0,232,158,1,0,240,158,1,0,248,158,1,0,8,159,1,0,16,159,1,0,32,159,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,32,158,1,0,40,158,1,0,64,158,1,0,80,158,1,0,152,158,1,0,168,158,1,0,200,158,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,208,169,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,208,169,1,0,10,0,0,0,11,0,0,0,116,169,1,0,236,169,1,0,0,170,1,0,136,169,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,224,99,2,0,160,169,1,0,104,31,2,0,0,0,0,0,104,0,0,0,0,0,0,0,104,31,2,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,104,31,2,0,14,0,0,0,15,0,0,0,0,0,0,0,120,170,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,224,99,2,0,72,170,1,0,96,30,2,0,0,0,0,0,0,0,0,0,0,171,1,0,8,171,1,0,248,170,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,216,170,1,0,232,170,1,0,248,170,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102456);
/* memory initializer */ allocate([32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,88,187,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,88,187,1,0,20,0,0,0,21,0,0,0,252,186,1,0,116,187,1,0,136,187,1,0,16,187,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,224,99,2,0,40,187,1,0,216,30,2,0,0,0,0,0,108,0,0,0,0,0,0,0,216,30,2,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,216,30,2,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,144,197,1,0,120,199,1,0,128,199,1,0,200,201,1,0,224,199,1,0,240,199,1,0,208,201,1,0,216,201,1,0,224,201,1,0,232,201,1,0,248,201,1,0,8,202,1,0,24,202,1,0,40,202,1,0,56,202,1,0,72,202,1,0,88,202,1,0,112,202,1,0,168,201,1,0,192,201,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,144,197,1,0,120,199,1,0,128,199,1,0,144,199,1,0,224,199,1,0,240,199,1,0,0,200,1,0,32,200,1,0,64,200,1,0,96,200,1,0,136,200,1,0,176,200,1,0,216,200,1,0,0,201,1,0,24,201,1,0,56,201,1,0,88,201,1,0,128,201,1,0,168,201,1,0,192,201,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,144,197,1,0,88,199,1,0,96,199,1,0,104,199,1,0,144,197,1,0,152,198,1,0,232,198,1,0,24,199,1,0,144,197,1,0,88,198,1,0,96,198,1,0,104,198,1,0,120,198,1,0,128,198,1,0,144,198,1,0,0,0,0,0,144,197,1,0,152,197,1,0,176,197,1,0,192,197,1,0,8,198,1,0,24,198,1,0,56,198,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,176,204,1,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,176,204,1,0,29,0,0,0,30,0,0,0,60,204,1,0,204,204,1,0,224,204,1,0,80,204,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,224,99,2,0,104,204,1,0,104,31,2,0,0,0,0,0,56,0,0,0,0,0,0,0,104,31,2,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,104,31,2,0,14,0,0,0,15,0,0,0,0,0,0,0,112,205,1,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,224,99,2,0,40,205,1,0,96,30,2,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112696);
/* memory initializer */ allocate([114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,0,226,1,0,0,226,1,0,0,226,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,168,228,1,0,184,228,1,0,208,228,1,0,240,228,1,0,16,229,1,0,40,229,1,0,72,229,1,0,96,229,1,0,112,229,1,0,128,229,1,0,152,229,1,0,176,229,1,0,208,229,1,0,240,229,1,0,128,229,1,0,8,230,1,0,40,230,1,0,64,230,1,0,88,230,1,0,112,230,1,0,144,230,1,0,160,230,1,0,192,230,1,0,224,230,1,0,248,230,1,0,16,231,1,0,40,231,1,0,56,231,1,0,80,231,1,0,104,231,1,0,128,231,1,0,160,231,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+122936);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+129872);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,168,16,2,0,176,16,2,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,192,16,2,0,200,16,2,0,208,16,2,0,216,16,2,0,144,1,0,0,0,0,0,0,72,17,2,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+135096);
/* memory initializer */ allocate([32,24,2,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,224,99,2,0,0,24,2,0,160,30,2,0,0,0,0,0,0,0,0,0,136,24,2,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,224,99,2,0,112,24,2,0,160,30,2,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,32,25,2,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,224,99,2,0,0,25,2,0,96,30,2,0,0,0,0,0,0,0,0,0,136,25,2,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,224,99,2,0,112,25,2,0,96,30,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,184,99,2,0,152,25,2,0,0,0,0,0,0,26,2,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,168,26,2,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,224,99,2,0,240,25,2,0,0,0,0,0,0,0,0,0,0,0,0,0,64,26,2,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,224,99,2,0,40,26,2,0,0,26,2,0,0,0,0,0,0,0,0,0,128,26,2,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,224,99,2,0,104,26,2,0,0,26,2,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,224,99,2,0,144,26,2,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,240,26,2,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,224,99,2,0,216,26,2,0,168,26,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,184,99,2,0,0,27,2,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,224,99,2,0,40,27,2,0,32,27,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,216,29,2,0,49,0,0,0,50,0,0,0,0,0,0,0,96,30,2,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,160,30,2,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,216,30,2,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,216,30,2,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,32,31,2,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,32,31,2,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,104,31,2,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,104,31,2,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,176,31,2,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,176,31,2,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,29,2,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,160,29,2,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,224,99,2,0,88,29,2,0,240,26,2,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,184,99,2,0,136,29,2,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,224,99,2,0,168,29,2,0,160,29,2,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,224,99,2,0,232,29,2,0,160,29,2,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,184,99,2,0,40,30,2,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,184,99,2,0,104,30,2,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,64,100,2,0,168,30,2,0,0,0,0,0,1,0,0,0,216,29,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,64,100,2,0,240,30,2,0,0,0,0,0,1,0,0,0,24,30,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,64,100,2,0,56,31,2,0,0,0,0,0,1,0,0,0,216,29,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,64,100,2,0,128,31,2,0,0,0,0,0,1,0,0,0,24,30,2,0,3,244,255,255,0,0,0,0,16,32,2,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,224,99,2,0,240,31,2,0,64,27,2,0,0,0,0,0,0,0,0,0,56,46,2,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,46,2,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,51,2,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,168,51,2,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,52,2,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,53,2,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,40,48,2,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,40,48,2,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,200,48,2,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,200,48,2,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,88,49,2,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,49,2,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,46,2,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,46,2,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,47,2,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,47,2,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,53,2,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,32,54,2,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,176,54,2,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,64,55,2,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,50,2,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,50,2,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,16,46,2,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,42,2,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,43,2,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,45,2,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,232,45,2,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,32,42,2,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,224,99,2,0,8,42,2,0,184,25,2,0,0,0,0,0,0,0,0,0,176,42,2,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,184,99,2,0,144,42,2,0,64,100,2,0,120,42,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,168,42,2,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,64,100,2,0,208,42,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,168,42,2,0,2,0,0,0,0,0,0,0,128,43,2,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,184,99,2,0,96,43,2,0,64,100,2,0,56,43,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,120,43,2,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,64,100,2,0,160,43,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,120,43,2,0,2,0,0,0,0,0,0,0,64,44,2,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,64,100,2,0,24,44,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,120,43,2,0,2,0,0,0,0,0,0,0,184,44,2,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,64,100,2,0,144,44,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,120,43,2,0,2,0,0,0,0,0,0,0,48,45,2,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,224,99,2,0,8,45,2,0,184,44,2,0,0,0,0,0,0,0,0,0,152,45,2,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,224,99,2,0,112,45,2,0,184,44,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,224,99,2,0,168,45,2,0,32,42,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,224,99,2,0,208,45,2,0,32,42,2,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,224,99,2,0,248,45,2,0,32,42,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,224,99,2,0,32,46,2,0,32,42,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,224,99,2,0,72,46,2,0,32,42,2,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,184,99,2,0,144,46,2,0,64,100,2,0,112,46,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,168,46,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,64,100,2,0,208,46,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,168,46,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,64,100,2,0,16,47,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,168,46,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,64,100,2,0,80,47,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,168,46,2,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,184,99,2,0,216,47,2,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,184,99,2,0,248,47,2,0,64,100,2,0,144,47,2,0,0,0,0,0,3,0,0,0,32,42,2,0,2,0,0,0,240,47,2,0,2,0,0,0,32,48,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,184,99,2,0,152,48,2,0,64,100,2,0,80,48,2,0,0,0,0,0,3,0,0,0,32,42,2,0,2,0,0,0,240,47,2,0,2,0,0,0,192,48,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,184,99,2,0,56,49,2,0,64,100,2,0,240,48,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,80,49,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,64,100,2,0,120,49,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,80,49,2,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,184,99,2,0,248,49,2,0,64,100,2,0,224,49,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,16,50,2,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,64,100,2,0,56,50,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,16,50,2,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,184,99,2,0,208,50,2,0,64,100,2,0,184,50,2,0,0,0,0,0,1,0,0,0,240,50,2,0,0,0,0,0,64,100,2,0,112,50,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,248,50,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,64,100,2,0,120,51,2,0,0,0,0,0,1,0,0,0,240,50,2,0,0,0,0,0,64,100,2,0,48,51,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,144,51,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,184,99,2,0,40,52,2,0,64,100,2,0,16,52,2,0,0,0,0,0,1,0,0,0,72,52,2,0,0,0,0,0,64,100,2,0,200,51,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,80,52,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,64,100,2,0,208,52,2,0,0,0,0,0,1,0,0,0,72,52,2,0,0,0,0,0,64,100,2,0,136,52,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,232,52,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,184,99,2,0,104,53,2,0,64,100,2,0,32,53,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,136,53,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,184,99,2,0,248,53,2,0,64,100,2,0,176,53,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,24,54,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,184,99,2,0,136,54,2,0,64,100,2,0,64,54,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,168,54,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,184,99,2,0,24,55,2,0,64,100,2,0,208,54,2,0,0,0,0,0,2,0,0,0,32,42,2,0,2,0,0,0,56,55,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+137148);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,40,97,2,0,110,0,0,0,48,97,2,0,114,0,0,0,56,97,2,0,102,0,0,0,64,97,2,0,97,0,0,0,72,97,2,0,101,0,0,0,80,97,2,0,119,0,0,0,88,97,2,0,87,0,0,0,104,97,2,0,115,0,0,0,120,97,2,0,83,0,0,0,136,97,2,0,100,0,0,0,152,97,2,0,68,0,0,0,168,97,2,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,48,99,2,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,184,99,2,0,8,99,2,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,224,99,2,0,32,99,2,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,224,99,2,0,64,99,2,0,24,99,2,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,224,99,2,0,120,99,2,0,104,99,2,0,0,0,0,0,0,0,0,0,160,99,2,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,40,100,2,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,224,99,2,0,0,100,2,0,160,99,2,0,0,0,0,0,0,0,0,0,136,100,2,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,224,99,2,0,96,100,2,0,160,99,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,102,2,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,224,99,2,0,184,102,2,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+147488);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  var _acos=Math_acos;

  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

  function _log10(x) {
      return Math.log(x) / Math.LN10;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }


  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  var _exp=Math_exp;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._exp;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env._log10;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env.__isLeapYear;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env.__parseInt64;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env._isblank;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_destroy;var Kb=env._lis_solver_set_option;var Lb=env._tmpfile;var Mb=env._send;var Nb=env._pow;var Ob=env.___cxa_is_number_type;var Pb=env.___cxa_free_exception;var Qb=env.___cxa_find_matching_catch;var Rb=env._isxdigit_l;var Sb=env.___cxa_guard_release;var Tb=env._truncate;var Ub=env._strtol;var Vb=env.__reallyNegative;var Wb=env._sin;var Xb=env._strtok;var Yb=env.___setErrNo;var Zb=env._newlocale;var _b=env._isdigit_l;var $b=env.___resumeException;var ac=env._freelocale;var bc=env._srand;var cc=env._fscanf;var dc=env._qsort;var ec=env._putchar;var fc=env._floor;var gc=env._pthread_mutex_unlock;var hc=env._printf;var ic=env._sprintf;var jc=env._fopen;var kc=env._vasprintf;var lc=env._emscripten_get_now;var mc=env._stat;var nc=env._vsnprintf;var oc=env._strtoull_l;var pc=env._read;var qc=env.__addDays;var rc=env._fwrite;var sc=env._time;var tc=env._pthread_mutex_lock;var uc=env._catopen;var vc=env._exit;var wc=env._GC_strdup;var xc=env._freopen;var yc=env.___ctype_b_loc;var zc=env._fmod;var Ac=env._strtok_r;var Bc=env._lseek;var Cc=env._access;var Dc=env._vfprintf;var Ec=env.___cxa_allocate_exception;var Fc=env._atoi;var Gc=env._strtoll;var Hc=env._pwrite;var Ic=env._localtime_r;var Jc=env._tzset;var Kc=env._open;var Lc=env._uselocale;var Mc=env._snprintf;var Nc=env.___errno_location;var Oc=env._GC_malloc;var Pc=env.___cxa_end_catch;var Qc=env._perror;var Rc=env.___cxa_begin_catch;var Sc=env._strftime;var Tc=env._ftruncate;var Uc=env._GC_init;var Vc=env._fseek;var Wc=env._isxdigit;var Xc=env._fclose;var Yc=env.__parseInt;var Zc=env._log;var _c=env._pthread_cond_broadcast;var $c=env._popen;var ad=env._recv;var bd=env._fgetc;var cd=env._sysconf;var dd=env.__getFloat;var ed=env._abort;var fd=env._ceil;var gd=env._isspace;var hd=env._localtime;var id=env._pthread_getspecific;var jd=env._pthread_cond_wait;var kd=env._llvm_lifetime_start;var ld=env._acos;var md=env._ungetc;var nd=env._system;var od=env._fmin;var pd=env._fmax;var qd=env._fflush;var rd=env._strftime_l;var sd=env._fprintf;var td=env._sscanf;var ud=env._catgets;var vd=env._strdup;var wd=env._asprintf;var xd=env.__exit;var yd=env.___ctype_toupper_loc;var zd=env._bsearch;var Ad=env.__arraySum;var Bd=env.__formatString;var Cd=env._htonl;var Dd=env.___ctype_tolower_loc;var Ed=env._unlink;var Fd=env._fputs;var Gd=env._GC_malloc_atomic;var Hd=env._pread;var Id=env._lis_vector_set_size;var Jd=env._mkport;var Kd=env.__scanString;var Ld=env._pthread_setspecific;var Md=env._copysign;var Nd=env._fputc;var Od=env.___cxa_throw;var Pd=env._lis_solver_destroy;var Qd=env._isdigit;var Rd=env._strerror;var Sd=env._emscripten_longjmp;var Td=env._lis_vector_create;var Ud=env._atexit;var Vd=env._sqrt;var Wd=env._strerror_r;var Xd=0.0;
// EMSCRIPTEN_START_FUNCS
function _w(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function $w(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=bx(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=ax(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{b=b+1|0;break};case 17:{k=dx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 15:{k=cx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){m=58;break b}n=b;if((se[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=n+2|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}o=b;if((se[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=o+4|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}p=b;if((se[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=p+3|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};case 29:{m=33;break b;break};case 10:case 9:case 21:{m=73;break b;break};case 5:{if((e-b|0)<2){m=36;break b}q=b;if((se[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=q+2|0;continue b;break};case 6:{if((e-b|0)<3){m=41;break b}r=b;if((se[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=r+3|0;continue b;break};case 17:{break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){m=46;break b}s=b;if((se[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=s+4|0;continue b;break};case 11:{m=97;break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{m=78;break d;break};case 29:{m=76;break d;break};case 17:{break c;break};case 24:case 22:{m=77;break d;break};case 6:{m=83;break d;break};case 7:{m=88;break d;break};case 10:case 9:case 21:{break};case 11:{m=97;break c;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=ex(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function ax(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{m=22;break b;break};case 5:{if((e-b|0)<2){m=8;break b}n=b;if((se[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=n+2|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((se[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((se[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function bx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[61248+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function cx(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((se[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{o=41;break b;break};case 5:{if((e-b|0)<2){o=27;break b}p=b;if((se[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=p+2|0;continue b;break};case 15:{o=68;break b;break};case 29:{o=24;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 7:{if((e-b|0)<4){o=37;break b}q=b;if((se[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=q+4|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}r=b;if((se[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=r+3|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((fx(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){o=57;break c}s=b;if((se[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=s+4|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 5:{if((e-b|0)<2){o=47;break c}t=b;if((se[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=t+2|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((se[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((fx(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function dx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 10:case 9:case 21:{l=41;break b;break};case 11:{l=49;break b;break};case 5:{if((b-a|0)<2){l=27;break b}m=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 23:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}n=d[h+76+(d[a]|0)|0]|0;if((n|0)==11){l=44;break}else if(!((n|0)==10|(n|0)==9|(n|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function ex(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(se[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=m+3;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}b=(se[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=41;break a}c[j>>2]=n+4;continue a;break};case 29:{l=26;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}b=(se[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;o=c[j>>2]|0;if(!b){l=31;break a}c[j>>2]=o+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}b=(se[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!b){l=36;break a}c[j>>2]=p+3;continue a;break};default:{l=43;break a}}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(se[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=q+2;continue a;break};case 29:{l=4;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}r=b;if(!((r|0)==9|(r|0)==10|(r|0)==21)){l=48;break a}}break};case 14:{break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}r=(se[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!r){l=19;break a}c[j>>2]=s+4;continue a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}r=t;if(!((r|0)==9|(r|0)==10|(r|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}r=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((r|0)==(t|0)){break}switch(r|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}r=(se[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(r){l=63;break a}c[j>>2]=u+2;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}r=(se[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(r){l=73;break a}c[j>>2]=v+4;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 3:{w=Xw(k,(c[j>>2]|0)+1|0,e,j)|0;if((w|0)<=0){l=77;break a}else{continue c}break};case 2:{l=80;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}r=(se[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(r){l=68;break a}c[j>>2]=x+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 17:{l=107;break a;break};case 7:{l=101;break d;break};case 5:{l=91;break d;break};case 11:{l=106;break a;break};case 29:{l=89;break a;break};case 10:case 9:case 21:{break};case 24:case 22:{l=90;break d;break};case 6:{l=96;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}r=(se[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!r){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}r=(se[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!r){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}r=(se[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!r){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=o;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((w|0)==0){c[f>>2]=c[j>>2]}B=w;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function fx(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function gx(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 6:{if((e-b|0)<3){k=10;break a}l=b;if((se[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=l+3|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 5:{if((e-b|0)<2){k=5;break a}m=b;if((se[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=m+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((se[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function hx(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 30:{l=10;break a;break};case 10:case 9:case 21:{break a;break};case 24:case 22:{break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==27){j=ax(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function ix(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=37;break b}m=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function jx(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function kx(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function lx(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function mx(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Ce[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function nx(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((px(ox(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((px(ox(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=ox(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((px(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=ox(k,a,b)|0;n=h;}while((px(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=ox(k,a,b)|0;while(1){if((px(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=ox(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=ox(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function ox(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function px(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function qx(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function rx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{c[h>>2]=14;j=0;break};case 14:{j=0;break};case 11:{c[h>>2]=14;j=55;break};case 29:{c[h>>2]=16;j=2;break};case 13:{c[h>>2]=14;j=56;break};case 12:{c[h>>2]=14;j=1;break};case 16:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,64992)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};default:{k=10}}}while(0);if((k|0)==10){j=vx(h,a)|0}i=g;return j|0}function sx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case 33:{c[h>>2]=17;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 15:{k=0;break};case 26:{j=9;break};default:{k=ux(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=vx(h,a)|0}i=g;return k|0}function tx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((Ce[c[e+28>>2]&63](e,b,d,64976)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((Ce[c[e+28>>2]&63](e,b,d,64984)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=vx(h,a)|0;l=k;i=g;return l|0}function ux(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 13:{j=56;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case 16:{if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,64752)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,64760)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,64768)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,64776)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};default:{}}}while(0);j=vx(h,a)|0;k=j;i=g;return k|0}function vx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function wx(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function xx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=26;g=9}else{g=vx(e,a)|0}i=f;return g|0}function yx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=vx(e,a)|0}i=f;return g|0}function zx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=vx(e,a)|0}i=f;return g|0}function Ax(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=29;g=18}else if((b|0)==15){g=17}else{g=vx(e,a)|0}i=f;return g|0}function Bx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=vx(e,a)|0}i=f;return g|0}function Cx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==15){g=0}else if((b|0)==13){g=56}else if((b|0)==11){g=55}else{g=vx(e,a)|0}i=f;return g|0}function Dx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=17;l=k;i=g;return l|0}do{if((j|0)==3){if((Ce[c[e+28>>2]&63](e,b,d,64792)|0)!=0){c[h>>2]=31;k=17;l=k;i=g;return l|0}if((Ce[c[e+28>>2]&63](e,b,d,64800)|0)==0){break}c[h>>2]=32;k=17;l=k;i=g;return l|0}}while(0);k=vx(h,a)|0;l=k;i=g;return l|0}function Ex(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=vx(e,a)|0}i=f;return g|0}function Fx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=vx(e,a)|0}i=f;return g|0}function Gx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=vx(e,a)|0}i=f;return g|0}function Hx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=vx(e,a)|0;h=g;i=f;return h|0}return 0}function Ix(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,64808)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,64816)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=vx(h,a)|0;k=j;i=g;return k|0}function Jx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 41:case 18:{c[h>>2]=40;j=51;break};case 31:{c[h>>2]=40;j=52;break};case 32:{c[h>>2]=40;j=54;break};case 30:{c[h>>2]=40;j=53;break};case 15:{j=39;break};case 20:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,64824)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};default:{k=10}}}while(0);if((k|0)==10){j=vx(h,a)|0}i=g;return j|0}function Kx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else{g=vx(e,a)|0}i=f;return g|0}function Lx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 15:{g=39;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 30:{c[e>>2]=40;g=53;break};case 32:{c[e>>2]=40;g=54;break};case 31:{c[e>>2]=40;g=52;break};default:{g=vx(e,a)|0}}i=f;return g|0}function Mx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};default:{g=vx(e,a)|0;h=g;i=f;return h|0}}return 0}function Nx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=vx(e,a)|0}i=f;return g|0}function Ox(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==21){c[e>>2]=41;g=39}else{g=vx(e,a)|0}i=f;return g|0}function Px(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=vx(e,a)|0}i=f;return g|0}function Qx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((Ce[m&63](n,o,p,c[64832+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((Ce[m&63](n,o,p,64776)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}}while(0);j=vx(h,a)|0;k=j;i=g;return k|0}function Rx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==20){if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,64936)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,64944)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,64960)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=vx(h,a)|0;k=j;i=g;return k|0}function Sx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==23){c[e>>2]=48;g=33}else{g=vx(e,a)|0}i=f;return g|0}function Tx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=vx(e,a)|0}i=f;return g|0}function Ux(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=vx(e,a)|0}i=f;return g|0}function Vx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=vx(e,a)|0}i=f;return g|0}function Wx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=vx(e,a)|0}i=f;return g|0}function Xx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=vx(e,a)|0}i=f;return g|0}function Yx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=vx(e,a)|0}i=f;return g|0}function Zx(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,64792)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,64800)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=vx(h,a)|0;k=j;i=g;return k|0}function _x(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=vx(e,a)|0}i=f;return g|0}function $x(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=vx(e,a)|0}i=f;return g|0}function ay(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;f=a;do{if((f|0)==18){if((Ce[c[b+28>>2]&63](b,d,e,64968)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=vx(h,a)|0;k=j;i=g;return k|0}function by(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=vx(e,a)|0}i=f;return g|0}function cy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,64792)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,64800)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=vx(h,a)|0;k=j;i=g;return k|0}function dy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=58;g=13}else{g=vx(e,a)|0}i=f;return g|0}function ey(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=56;g=14}else if((b|0)==15){g=11}else{g=vx(e,a)|0}i=f;return g|0}function fy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else{g=vx(e,a)|0;h=g;i=f;return h|0}return 0}function gy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=vx(e,a)|0;h=g;i=f;return h|0}return 0}function hy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=vx(e,a)|0}i=f;return g|0}function iy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 29:{c[h>>2]=16;j=2;break};case 15:{j=0;break};case 16:{if((Ce[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,64992)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 14:{j=0;break};case 13:{j=56;break};case 11:{j=55;break};default:{k=9}}}while(0);if((k|0)==9){j=vx(h,a)|0}i=g;return j|0}function jy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else{g=vx(e,a)|0}i=f;return g|0}function ky(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==18){if((Ce[c[e+28>>2]&63](e,b,d,64792)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Ce[c[e+28>>2]&63](e,b,d,64800)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}}while(0);j=vx(h,a)|0;k=j;i=g;return k|0}function ly(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=vx(e,a)|0}i=f;return g|0}function my(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=60;g=6}else{g=vx(e,a)|0}i=f;return g|0}function ny(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==15){g=3}else{g=vx(e,a)|0}i=f;return g|0}function oy(){i=i;return}function py(){i=i;return}function qy(){var a=0;a=i;Wa(65e3,0)|0;i=a;return}function ry(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;rc(65008,29,1,e|0)|0;qd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;rc(65040,54,1,g|0)|0;qd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;rc(65096,47,1,a|0)|0;qd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;sd(k|0,65144,d|0)|0;qd(k|0)|0;f=0;i=b;return f|0}function sy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function ty(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=az(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function uy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=az(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function vy(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[28994]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=65240;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];De[p&31](0,f,65264,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function wy(a,b){a=a|0;b=b|0;var d=0;d=i;if((ry(a)|0)==0){cb(65320,65208,347,65344)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);cb(65376,65208,348,65344);return 0}function xy(){var a=0,b=0,d=0;a=i;b=67120|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=67232|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=67344|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[67124>>2]=1;c[67128>>2]=1;i=a;return}function yy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?67480:67496;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;sd(a|0,67456,e|0)|0;i=d;return}function zy(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=67344+(d<<2)|0;o=67232+(d<<2)|0;p=67544+(b<<2)|0;q=65824+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=67528;hc(67512,l|0)|0;s=67528}else{if((c[16776]|0)==(d|0)){if((c[o>>2]|0)>0){t=67528}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;hc(67512,m|0)|0;do{if((c[16776]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=67528;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;hc(67536,k|0)|0;c[n>>2]=b;c[16776]=d;if((c[o>>2]|0)>0){g=0;while(1){hc(67568,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;qd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function Ay(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[67544+(a<<2)>>2]|0;c[j>>2]=c[65824+(b<<2)>>2];c[j+4>>2]=k;hc(67576,j|0)|0;By(e);if((g|0)==0){Fd(((d|0)!=0?67616:67664)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}tb(67744)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];hc(67624,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}rc(67648,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=qd(m|0)|0;i=f;return}function By(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==62){rc(67704,4,1,e|0)|0}else if(b<<24>>24==38){rc(67688,5,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==60){rc(67696,4,1,e|0)|0}else{Nd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function Cy(a){a=a|0;var b=0;b=67232+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function Dy(a){a=a|0;var b=0;b=(a|0)==0;c[16920]=b?1:19;c[16918]=b?7:212;i=i;return}function Ey(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;rc(67648,11,1,b|0)|0;qd(b|0)|0;i=a;return}function Fy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[67120+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;nc(j|0,2048,e|0,h|0)|0;me[c[16920]&31](1,a,b,j,0,d);i=g;return}function Gy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[67120+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;nc(h|0,2048,d|0,g|0)|0;me[c[16920]&31](1,a,b,h,0,0);i=f;return}function Hy(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[16778]|0)==0){if((c[67120+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;nc(k|0,2048,e|0,j|0)|0;me[c[16920]&31](2,a,b,k,0,d);i=g;return}function Iy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[16778]|0)==0){if((c[67120+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;nc(j|0,2048,d|0,h|0)|0;me[c[16920]&31](2,a,b,j,0,0);i=f;return}function Jy(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;nc(b|0,2048,d|0,g|0)|0;me[c[16920]&31](4,2,0,b,0,0);if((a|0)==0){h=id(c[16250]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function Ky(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;nc(g|0,2048,b|0,f|0)|0;me[c[16920]&31](5,2,0,g,0,0);if((a|0)==0){h=id(c[16250]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function Ly(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;nc(h|0,2048,d|0,g|0)|0;me[c[16920]&31](5,2,0,h,0,b);if((a|0)==0){j=id(c[16250]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function My(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;Ly(a,e,67816,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;Hy(26,0,e,67752,m);i=j;return+b}return 0.0}function Ny(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=p1(16)|0;Jy(0,(d|0)!=0|0,67864,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function Oy(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;q1(c[f>>2]|0);q1(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function Py(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Jy(0,(a|0)!=0|0,67880,f);f=p1(8)|0;g=f;Jy(0,(f|0)!=0|0,67864,e);e=a+8|0;h=p1(c[e>>2]|0)|0;c[f>>2]=h;Jy(0,(h|0)!=0|0,67864,d);V1(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function Qy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;Jy(0,(a|0)!=0|0,67880,f);f=p1(8)|0;g=f;Jy(0,(f|0)!=0|0,67864,e);e=a+8|0;h=p1(c[e>>2]|0)|0;c[f>>2]=h;Jy(0,(h|0)!=0|0,67864,d);V1(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function Ry(a){a=a|0;var b=0;b=i;i=i+8|0;Jy(0,(a|0)!=0|0,67880,b);i=b;return c[a+12>>2]|0}function Sy(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Jy(0,(a|0)!=0|0,67880,d);d=a;Jy(0,(c[d>>2]|0)!=0|0,67904,b);i=b;return c[c[d>>2]>>2]|0}function Ty(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;q1(c[e>>2]|0);q1(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function Uy(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Jy(0,(a|0)!=0|0,67880,d);d=a;Jy(0,(c[d>>2]|0)!=0|0,67920,b);i=b;return c[d>>2]|0}function Vy(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;Jy(0,d&1,67952,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function Wy(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;Jy(0,(a|0)!=0|0,67952,d);d=a;Jy(0,(c[d>>2]|0)!=0|0,67976,b);i=b;return c[d>>2]|0}function Xy(){var a=0,b=0,d=0;a=i;b=p1(16)|0;c[17012]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=p1(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function Yy(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=bz(a)|0;tc(68056)|0;cz(d);a=c[17012]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;gc(68056)|0;X1(g|0,0,d|0)|0;i=b;return g|0}function Zy(){var a=0,b=0,d=0,e=0;a=i;b=c[17012]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;q1(c[b>>2]|0);q1(b);if((d|0)==0){break}else{b=d}}e=c[17012]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function _y(a){a=a|0;var b=0,d=0;b=i;d=de[c[68008>>2]&127](a<<3)|0;i=b;return d|0}function $y(a){a=a|0;var b=0,d=0;b=i;d=de[c[68008>>2]&127](a<<2)|0;i=b;return d|0}function az(a){a=a|0;var b=0,d=0;b=i;d=de[c[68008>>2]&127](a<<2)|0;i=b;return d|0}function bz(a){a=a|0;i=i;return a+7&-8|0}function cz(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[17012]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=p1(16)|0;c[f+12>>2]=d;c[17012]=f;c[f+4>>2]=0;d=dz((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=p1(d)|0;c[f>>2]=a;i=b;return}function dz(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function ez(a){a=a|0;var b=0,c=0;b=i;c=T1(a|0)|0;i=b;return c|0}function fz(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;Z1(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];ic(m|0,l|0,f|0)|0;f=gz(m)|0;i=e;return f|0}function gz(a){a=a|0;var b=0,c=0,d=0;b=i;c=T1(a|0)|0;d=kz(c)|0;V1(d|0,a|0,c|0)|0;i=b;return d|0}function hz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;Z1(g+1|0,d|0)|0;c[f>>2]=b;ic(k|0,j|0,f|0)|0;f=gz(k)|0;i=e;return f|0}function iz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+40|0;l=i;i=i+400|0;m=k;n=l;a[m]=37;l=k+1|0;if(e<<24>>24==0){c[h>>2]=d;ic(l|0,68088,h|0)|0;o=g;p=o;c[p>>2]=b;q=39;r=q;s=ic(n|0,m|0,g|0)|0;t=gz(n)|0;i=f;return t|0}else{c[j>>2]=d;ic(l|0,68080,j|0)|0;o=g;p=o;c[p>>2]=b;q=39;r=q;s=ic(n|0,m|0,g|0)|0;t=gz(n)|0;i=f;return t|0}return 0}function jz(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;ic(o|0,68104,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;ic(o|0,68096,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];ic(q|0,p|0,j|0)|0;j=gz(q)|0;i=g;return j|0}function kz(b){b=b|0;var d=0,e=0;d=i;e=de[c[68012>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function lz(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=ez(a)|0;e=ez(b)|0;f=kz(e+d|0)|0;V1(f|0,a|0,d|0)|0;V1(f+d|0,b|0,e|0)|0;i=c;return f|0}function mz(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=P1(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function nz(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 1:{f=4;break a;break};case 0:{f=8;break a;break};case 3:{f=2;break a;break};case 5:{f=1;break a;break};case 2:{f=4;break a;break};case 4:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function oz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Xc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){q1(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{q1(c[(c[f>>2]|0)+(g<<4)>>2]|0);q1(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;q1(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){q1(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{q1(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}q1(d);c[g>>2]=0;i=b;return}function pz(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(T1(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function qz(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=jc(b|0,68272)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Rd(c[(Nc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=vd(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=68280;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[68248+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=68304;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=68328;E=131;break}G=nz(D)|0;if((G|0)==-1){n=68360;E=131;break}D=c[q>>2]|0;H=p1(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=68408;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=68432;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((P1(H,c[68224+(C<<2)>>2]|0)|0)!=0){n=68456;E=131;break}q1(H);H=69032;b:do{switch(C|0){case 2:{if(d<<24>>24==1){if((I|0)==0){K=1;E=129;break b}F=D+1|0;G=0;while(1){L=p1(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=L;if((sb(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=68656;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;L=G+1|0;if(L>>>0<I>>>0){G=L}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}G=fa(D,I)|0;N=p1(G+1|0)|0;if((sb(N|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;F=(I|0)==0;L=0;do{O=p1(G)|0;c[(c[v>>2]|0)+(L<<4)+4>>2]=O;if(!F){O=0;do{P=a[N+((fa(D,O)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+O|0]=P;O=O+1|0;}while(O>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+I|0]=0;L=L+1|0;}while(L>>>0<D>>>0)}q1(N);M=0;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=68968;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=r1(c[z>>2]<<1,4)|0;if((Vc(c[m>>2]|0,J|0,1)|0)==-1){n=69e3;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=68968;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=r1(c[z>>2]<<1,4)|0;L=fa(I,D)|0;if((a[l]|0)==1){F=p1(L<<3)|0;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=69e3;E=131;break a}if((I|0)!=0){G=D<<3;O=(D|0)==0;P=D<<3;Q=0;do{R=p1(G)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=R;if(!O){R=F+(fa(P,Q)|0)|0;V1(c[(c[B>>2]|0)+(Q<<2)>>2]|0,R|0,P|0)|0}Q=Q+1|0;}while(Q>>>0<I>>>0)}Q=c[z>>2]|0;P=Q<<1;if(Q>>>0<P>>>0){O=D<<3;G=(D|0)==0;R=Q;do{S=p1(O)|0;c[(c[B>>2]|0)+(R<<2)>>2]=S;if(!G){S=c[B>>2]|0;T=c[S+(R-Q<<2)>>2]|0;U=c[S+(R<<2)>>2]|0;S=0;do{h[U+(S<<3)>>3]=-+h[T+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}R=R+1|0;}while(R>>>0<P>>>0)}q1(F)}else{P=p1(L<<2)|0;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=69e3;E=131;break a}if((I|0)!=0){R=D<<3;Q=(D|0)==0;G=0;do{O=p1(R)|0;c[(c[B>>2]|0)+(G<<2)>>2]=O;if(!Q){O=c[(c[B>>2]|0)+(G<<2)>>2]|0;S=0;do{h[O+(S<<3)>>3]=+g[P+((fa(D,G)|0)+S<<2)>>2];S=S+1|0;}while(S>>>0<D>>>0)}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;Q=G<<1;if(G>>>0<Q>>>0){R=D<<3;L=(D|0)==0;F=G;do{S=p1(R)|0;c[(c[B>>2]|0)+(F<<2)>>2]=S;if(!L){S=c[B>>2]|0;O=c[S+(F-G<<2)>>2]|0;T=c[S+(F<<2)>>2]|0;S=0;do{h[T+(S<<3)>>3]=-+h[O+(S<<3)>>3];S=S+1|0;}while(S>>>0<D>>>0)}F=F+1|0;}while(F>>>0<Q>>>0)}q1(P)}if((Vc(c[m>>2]|0,J|0,1)|0)==-1){n=69e3;E=131;break a}else{M=d;E=130}break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=68720;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=68776;E=131;break a}c[w>>2]=D;Q=fa(I,D)|0;if((a[l]|0)==1){F=p1(Q<<3)|0;c[x>>2]=F;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=68816;E=131;break a}}else{F=p1(Q<<2)|0;c[x>>2]=p1(fa(D<<3,I)|0)|0;if((sb(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=68816;E=131;break a}if((Q|0)!=0){G=c[x>>2]|0;L=0;do{h[G+(L<<3)>>3]=+g[F+(L<<2)>>2];L=L+1|0;}while(L>>>0<Q>>>0)}q1(F)}Q=c[w>>2]|0;if(!(Q>>>0>1)){M=1;E=130;break b}L=(I|0)==2;G=1;while(1){if(L){P=c[x>>2]|0;if(+h[P+(G<<3)>>3]!=+h[P+(Q+G<<3)>>3]){n=68848;E=131;break a}}P=G+1|0;if(P>>>0<Q>>>0){G=P}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}if((I|0)==0){n=68720;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=68928;E=131;break a}c[w>>2]=I;G=fa(I,D)|0;if((a[l]|0)==1){Q=p1(G<<3)|0;c[x>>2]=p1(fa(D<<3,I)|0)|0;if((sb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=68816;E=131;break a}if((D|0)!=0){L=0;do{F=c[x>>2]|0;P=0;do{h[F+((fa(I,L)|0)+P<<3)>>3]=+h[Q+((fa(D,P)|0)+L<<3)>>3];P=P+1|0;}while(P>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}q1(Q)}else{L=p1(G<<2)|0;c[x>>2]=p1(fa(D<<3,I)|0)|0;if((sb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=68816;E=131;break a}if((D|0)!=0){P=0;do{F=c[x>>2]|0;R=0;do{h[F+((fa(I,P)|0)+R<<3)>>3]=+g[L+((fa(D,R)|0)+P<<2)>>2];R=R+1|0;}while(R>>>0<I>>>0);P=P+1|0;}while(P>>>0<D>>>0)}q1(L)}P=c[w>>2]|0;if(!(P>>>0>1)){M=d;E=130;break b}G=(D|0)==2;Q=1;while(1){if(G){R=c[x>>2]|0;if(+h[R+(Q<<3)>>3]!=+h[R+(P+Q<<3)>>3]){n=68848;E=131;break a}}R=Q+1|0;if(R>>>0<P>>>0){Q=R}else{M=d;E=130;break}}break};case 0:{if((D|0)!=4){n=68480;E=131;break a}if((I|0)!=11){n=68520;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){V=0}else{n=68560;E=131;break a}while(1){Q=0;do{a[k+Q|0]=a[j+((Q<<2)+V)|0]|0;Q=Q+1|0;}while(Q>>>0<11);a[k+11|0]=0;if((V|0)==3){break}Q=V+1|0;if(Q>>>0<4){V=Q}else{M=d;E=130;break b}}if((Q1(t,c[17032]|0,8)|0)==0){M=1;E=130;break b}if((Q1(t,c[17038]|0,9)|0)==0){M=0;E=130}else{n=68592;E=131;break a}break};case 3:{Q=fa(I<<2,D)|0;W=p1(Q)|0;if((sb(W|0,Q|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==0){if((D|0)==0){break}Q=c[v>>2]|0;P=0;do{c[Q+(P<<4)+8>>2]=(c[W+(P<<2)>>2]|0)==1;c[Q+(P<<4)+12>>2]=c[W+(D+P<<2)>>2];P=P+1|0;}while(P>>>0<D>>>0)}else if(d<<24>>24==1){if((I|0)==0){break}P=c[v>>2]|0;Q=0;do{G=fa(D,Q)|0;c[P+(Q<<4)+8>>2]=(c[W+(G<<2)>>2]|0)==1;c[P+(Q<<4)+12>>2]=c[W+(G+1<<2)>>2];Q=Q+1|0;}while(Q>>>0<I>>>0)}}while(0);q1(W);dc(c[v>>2]|0,c[u>>2]|0,16,53);M=d;E=130;break};case 1:{Q=d<<24>>24==0;c[u>>2]=Q?D:I;P=p1((Q?D:I)<<4)|0;c[v>>2]=P;c:do{if(d<<24>>24==1){if((I|0)==0){X=0;break}G=D+1|0;L=P;R=0;while(1){c[L+(R<<4)>>2]=p1(G)|0;if((sb(c[(c[v>>2]|0)+(R<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=68656;E=131;break a}a[(c[(c[v>>2]|0)+(R<<4)>>2]|0)+D|0]=0;F=c[v>>2]|0;c[F+(R<<4)+8>>2]=-1;c[F+(R<<4)+12>>2]=-1;pz(c[F+(R<<4)>>2]|0);F=R+1|0;if(!(F>>>0<I>>>0)){X=I;break c}L=c[v>>2]|0;R=F}}else{X=I}}while(0);if(!Q){M=d;E=130;break b}P=fa(D,X)|0;Y=p1(P+1|0)|0;if((sb(Y|0,P|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){P=X+1|0;R=(X|0)==0;L=0;do{G=p1(P)|0;c[(c[v>>2]|0)+(L<<4)>>2]=G;if(!R){G=0;do{F=a[Y+((fa(D,G)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)>>2]|0)+G|0]=F;G=G+1|0;}while(G>>>0<X>>>0)}a[(c[(c[v>>2]|0)+(L<<4)>>2]|0)+X|0]=0;G=c[v>>2]|0;c[G+(L<<4)+8>>2]=-1;c[G+(L<<4)+12>>2]=-1;pz(c[G+(L<<4)>>2]|0);L=L+1|0;}while(L>>>0<D>>>0)}q1(Y);M=0;E=130;break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=K;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){q1(Y);n=68656;i=e;return n|0}else if((E|0)==46){q1(N);n=68656;i=e;return n|0}else if((E|0)==52){q1(W);n=68688;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function rz(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=zd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,53)|0;i=d;return b|0}function sz(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=69072;o=n;p=69120;q=p;r=69144;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=69072;o=n;p=69120;q=p;r=69144;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=p1(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Vc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}q1(r);t=0;i=e;return t|0}else{k=p1(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Vc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}q1(k);q1(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);q1(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function tz(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=69072;r=q;s=69120;t=s;u=69168;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=69072;r=q;s=69120;t=s;u=69168;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Vc(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Vc(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function uz(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function vz(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function wz(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function xz(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+wz(b)<e){q=1;i=f;return q|0}if(+vz(b)>e){q=1;i=f;return q|0}if((sz(b,1)|0)==0){q=1;i=f;return q|0}uz(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+tz(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+tz(a,b,d,o);i=f;return q|0}if(+tz(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+tz(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function yz(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function zz(a,b){a=a|0;b=b|0;var c=0;c=i;ty(a,b,_y(b)|0);i=c;return}function Az(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=_y(uy(a,b,f)|0)|0;i=e;return}function Bz(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function Cz(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function Dz(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;Bz(c[d+8>>2]|0,b,a);i=e;return}function Ez(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;zz(a,b);j=g;c[g>>2]=e;Dz(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;Dz(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function Fz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=vy(a,b,f)|0;f=Cz(c[a+8>>2]|0,d)|0;i=e;return f|0}function Gz(a){a=a|0;var b=0,c=0,d=0.0,e=0,f=0.0,g=0.0,h=0;b=i;if((ry(a)|0)==0){cb(69224,69200,1547,69248)}c=sy(a)|0;if((c|0)==0){d=0.0;i=b;return+d}else{e=0;f=0.0}while(1){g=f+ +yz(a,e);h=e+1|0;if(h>>>0<c>>>0){f=g;e=h}else{d=g;break}}i=b;return+d}function Hz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=p1(20)|0;Jy(0,(f|0)!=0|0,69264,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=r1(e,b)|0;c[f>>2]=a;Jy(0,(a|0)!=0|0,69264,d);i=d;return f|0}function Iz(a){a=a|0;var b=0;b=i;q1(c[a>>2]|0);q1(a);i=b;return}function Jz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;Jy(0,(c[h>>2]|0)>0|0,69280,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;Jy(0,(g|0)>(b|0)|0,69304,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;Jy(0,(0-f|0)<(b|0)|0,69304,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function Kz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=r1(c[d>>2]<<1,c[e>>2]|0)|0;Jy(0,(f|0)!=0|0,69264,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=Jz(a,j)|0;h=c[e>>2]|0;V1(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;q1(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function Lz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){Kz(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;V1((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function Mz(a){a=a|0;i=i;return c[a+12>>2]|0}function Nz(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;Jy(0,(c[j>>2]|0)>0|0,69280,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;Jy(0,(h|0)>(b|0)|0,69304,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;Jy(0,b>>>31^1,69304,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=Jz(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function Oz(a){a=a|0;i=i;return c[(c[17334]|0)+(a<<2)>>2]|0}function Pz(a){a=a|0;i=i;return c[(c[17336]|0)+(a<<2)>>2]|0}function Qz(a){a=a|0;i=i;return c[(c[17338]|0)+(a<<2)>>2]|0}function Rz(a){a=a|0;i=i;return c[(c[17340]|0)+(a<<2)>>2]|0}function Sz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[17336]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[17338]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[17334]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function Tz(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[17342]|0;e=+Uz(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Uz(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function Vz(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[17344]|0;e=+Uz(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Wz(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[17346]|0;e=+Uz(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function Xz(a){a=a|0;i=i;return 0}function Yz(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[17348]|0)+(a<<3)|0)|0;d=(c[17334]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function Zz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[17342]|0;f=e+(a<<3)|0;g=c[17346]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[17340]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[17334]|0)+(a<<2)>>2]|0);e=c[17344]|0;g=e+(a<<3)|0;_z(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;Sz(a);d=c[17342]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[17334]|0)+(a<<2)>>2]=0;i=b;return}function _z(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(bA(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function $z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[17348]|0;f=c[17342]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function aA(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=r1(a,8)|0;c[17342]=d;e=r1(a,8)|0;c[17344]=e;f=r1(a,8)|0;c[17346]=f;g=r1(a,8)|0;c[17348]=g;h=r1(a,4)|0;c[17334]=h;j=r1(a,4)|0;c[17340]=j;k=a<<2;l=p1(k)|0;c[17336]=l;m=r1(a,4)|0;c[17338]=m;X1(l|0,-1,k|0)|0;if((d|0)==0){cb(69400,69416,393,69432)}if((e|0)==0){cb(69440,69416,394,69432)}if((f|0)==0){cb(69456,69416,395,69432)}if((g|0)==0){cb(69472,69416,396,69432)}if((h|0)==0){cb(69488,69416,397,69432)}if((l|0)==0){cb(69512,69416,398,69432)}if((m|0)==0){cb(69536,69416,399,69432)}if((j|0)==0){cb(69560,69416,400,69432)}else{i=b;return}}function bA(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function cA(a,b){a=a|0;b=b|0;var c=0;c=i;ty(a,b,$y(b)|0);i=c;return}function dA(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function eA(a,b){a=a|0;b=b|0;i=i;return a+(b<<2)|0}function fA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;dA(c[d+8>>2]|0,b,a);i=e;return}function gA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;cA(a,b);h=g;c[g>>2]=e;fA(d,0,a);if((b|0)>1){j=1}else{i=f;return}do{d=c[h>>2]|0;e=c[d>>2]|0;c[h>>2]=d+4;fA(e,j,a);j=j+1|0;}while((j|0)<(b|0));i=f;return}function hA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=vy(a,b,f)|0;f=eA(c[a+8>>2]|0,d)|0;i=e;return f|0}function iA(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function jA(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==0){c[m>>2]=c[b+8>>2];n=m+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Hy(17,0,o,71192,m);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];m=l+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Hy(17,0,o,71240,l);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];l=j+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Hy(17,0,o,71344,j);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];j=g+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Hy(17,0,o,71440,g);i=e;return}else{g=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=g;g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Hy(17,0,o,71504,f);i=e;return}}function kA(a){a=a|0;var b=0;b=i;q1(c[a+12>>2]|0);q1(c[a+4>>2]|0);q1(c[a+8>>2]|0);i=b;return}function lA(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Fd(a|0,d|0)|0;qd(d|0)|0;ae[c[28998]&255](0);i=b;return}function mA(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[9541]=.5;h[9527]=1.0;h[9564]=.25;h[9539]=2.0;h[9566]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[19090]=A;B=c[d>>2]|0;c[19020]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[19020]=D;if((C|0)<(B|0)){C=D}else{break}}}c[19018]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[9542]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[9542]=F;G=F}else{G=E}D=c[d>>2]|0;c[19020]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[19020]=I;if((H|0)>=(D|0)){break a}E=+h[9542];H=I}}}while(0);D=C+1|0;c[19018]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[9546]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[9511]=0.0;h[9513]=0.0;h[9517]=0.0;h[9574]=0.0;c[19016]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[9511]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[9513]+ +h[B>>3]*F;h[9513]=E;F=+h[I>>3];M=+h[9517]+F*F;h[9517]=M;F=+h[H>>3];h[9574]=+h[9574]+F*F;H=A+1|0;c[19016]=H;F=+h[9511];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[19086]=A;E=G/J;h[9563]=E;C=c[d>>2]|0;c[19020]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[9571]=0.0;h[9573]=0.0;I=c[b>>2]|0;c[19016]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[9540]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[9571]=ba;ca=E+aa*aa;h[9573]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[19016]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[19086]=A;h[9563]=E;h[9513]=Z;h[9517]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[19020]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[19016]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[19016]=A+1;da=+h[9513];ea=+h[9517];ga=+h[9511]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[9562]=K;c[19114]=0;h[9570]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[19114]=C;K=+h[9527]/+V(+ga);h[9542]=K;h[9565]=0.0;h[9567]=0.0;B=c[b>>2]|0;c[19016]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[9565]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[9565]=oa;pa=+h[9567]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[9567]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[9513];L=+h[9511];N=+h[9542];D=D+1|0;la=ma}c[19016]=B+1;ia=+h[9511];ja=pa;ka=oa}N=+h[9541];L=ka*N*ka;h[9558]=L;J=ja*N*ja;h[9559]=J;h[9518]=J+(L+ia*(+h[9574]+ia*N));N=+h[9539];h[76152>>3]=N*ka*ia;h[76160>>3]=N*ja*ia;h[76168>>3]=L-J;h[76176>>3]=ka*ja;la=76184|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[19016]=10;la=c[d>>2]|0;c[19020]=1;if((la|0)>=1){D=1;while(1){h[9558]=0.0;h[9559]=0.0;h[9560]=0.0;A=c[b>>2]|0;c[19016]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[9558]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[9559]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[9560]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[19016]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[9564]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[9558]*+h[9560];h[t+(U+D<<3)>>3]=+h[9559]*+h[9560];J=+h[9558];L=+h[9559];h[t+(P+D<<3)>>3]=+h[9564]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[9541]*+h[9558]*+h[9559];na=D+1|0;c[19020]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[19016]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[19028]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[19016]=B;if((la|0)<(D|0)){la=B}else{break}}}c[19024]=1;la=1;do{D=c[d>>2]|0;c[19032]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[19032]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[19020]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[19020]=D+1}na=c[19090]|0;c[19018]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[9538]=0.0;ma=c[d>>2]|0;c[19020]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[9538]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[19020]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[9538]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[19020]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[9538];Ca=Ca+1|0}c[19020]=ta+1}Ca=B+1|0;c[19018]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[19020]=1;if((A|0)<1){break}else{Ea=1}while(1){h[9538]=0.0;B=c[b>>2]|0;c[19018]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[9538]=N;Ca=na+1|0;c[19018]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[19020]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[19018]=1;if((A|0)>=1){ta=1;while(1){h[9538]=0.0;c[19016]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[9538]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[19016]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[19018]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[19024]=la;}while((la|0)<6);la=c[l>>2]|0;c[19020]=1;h[9538]=0.0;c[19016]=1;L=+h[9541];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[76224+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[76224+(A+ -1<<3)>>3]+L;h[9538]=L;A=A+1|0;}while((A|0)<6);h[9518]=+h[9518]- +h[9528]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[9558]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[9559]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[9560]=O;h[76152>>3]=+h[76152>>3]-J-N*(O+K);h[76184>>3]=+h[76184>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[9558]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[9559]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[9560]=J;h[76160>>3]=+h[76160>>3]-O-N*(K-J);h[76192>>3]=+h[76192>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[9558]=J;h[76168>>3]=+h[76240>>3]+(+h[76168>>3]-J- +h[76232>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[9558]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[9559]=K;Oa=+h[9541];h[76176>>3]=+h[76176>>3]-J-K*Oa;h[76200>>3]=+h[76200>>3]- +h[76248>>3]+ +h[76256>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[9558]=K;h[76208>>3]=+h[76208>>3]-Oa*K;h[9538]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[19020]=la+1;c[19016]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[76224+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[76224+(ta+ -1<<3)>>3]+N;h[9538]=N;ta=ta+1|0;c[19016]=ta;}while((ta|0)<6);K=+h[9546];h[9548]=K*+h[9518]+ +h[9528]+N;J=+h[9539];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[9558]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[9559]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[9560]=R;T=R+(K*+h[76152>>3]+O+S);h[76392>>3]=T;O=K*+h[76184>>3]+S-R;h[76424>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[9558]=R;S=+h[I>>3]*+h[ma>>3];h[9559]=S;Z=+h[Ma>>3]*+h[Na>>3];h[9560]=Z;h[76400>>3]=K*+h[76160>>3]+R+S-Z;h[76432>>3]=K*+h[76192>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[9558]=Z;R=+h[76232>>3]+(Z+K*+h[76168>>3])- +h[76240>>3];h[76408>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[9558]=Z;h[76416>>3]=Z+K*+h[76176>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[76200>>3]+ +h[76248>>3]- +h[76256>>3];h[76440>>3]=J;h[76448>>3]=+h[9546]*+h[76208>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[9548]+T+R+O+J;h[9538]=K;h[9568]=K;h[9569]=K;c[19122]=0;J=+h[9566]/50.0;h[9542]=J;h[9528]=+h[9527];c[19016]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[76232>>3]=Z;W=+Y(+Pa);h[76240>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[76224+(Ma+ -1<<3)>>3]=Z;Q=+h[76232>>3]*G+ +h[76240>>3]*W;h[76224+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[76240>>3];ca=+h[76232>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[76384+(Ma<<3)>>3]*+h[76224+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[9569]=Ra;c[19122]=Na;h[9558]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[9559]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[19018]=10;h[9538]=Ra;h[9547]=Pa;h[9572]=O;c[19016]=50;if((Xa|0)==49){h[9559]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[9558]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[9544]=0.0;if(Ya!=Za){S=Ya-Ua;h[9558]=S;T=Za-Ua;h[9559]=T;R=+h[9541]*(S-T)/(S+T);h[9544]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[9547]=R;T=+X(+R);h[76232>>3]=T;S=+Y(+R);h[76240>>3]=S;c[19018]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[76224+(Na+ -1<<3)>>3]=T;W=+h[76232>>3]*G+ +h[76240>>3]*S;h[76224+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[76240>>3];N=+h[76232>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[9569]=0.0;c[19018]=1;Na=1;do{ma=Na+ -1|0;Ma=76224+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[76144+(ma<<3)>>3]*+h[Ma>>3];h[9569]=+h[9569]+ +h[76384+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[19018]=10;Na=c[l>>2]|0;c[19020]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[76224+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[19018]=6;c[19020]=Na+1}h[9537]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[9511]=0.0;h[9558]=0.0;h[9559]=0.0;Ma=c[b>>2]|0;c[19016]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[76232>>3]*+h[la>>3]+ +h[76240>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[9511]=+h[9511]+G*G;bb=+h[9558]+ +h[la>>3]*+h[ta>>3];h[9558]=bb;G=+h[ta>>3];cb=+h[9559]+G*G;h[9559]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[19016]=Ma+1;$a=cb;ab=bb}ma=c[19114]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[9570];S=+h[9568];h[9570]=G>=S?G:S}S=+h[9569];if(!(S>=0.0)){db=-S}else{db=S}G=+h[9570];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[9570]=S;c[19016]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[9542]=N;R=+h[9537]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[9546];la=ta+1|0;c[19016]=la;if((ta|0)>=(Na|0)){break b}S=+h[9559];G=+h[9558];ta=la}}}while(0);Na=c[d>>2]|0;c[19020]=1;if((Na|0)>=1){Ma=1;while(1){h[9538]=0.0;ta=c[b>>2]|0;c[19018]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[9538]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[19018]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[9537]*+h[p+(la+ -1+Ma<<3)>>3]- +h[9546]*+h[q+(Ma+ -1<<3)>>3]);h[9542]=G;c[19016]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[9542];I=I+1|0}c[19016]=la+1}I=Ma+1|0;c[19020]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[9517]=0.0;h[9513]=0.0;Ma=c[b>>2]|0;c[19016]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[9517]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[9513]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[19016]=Ma+1;hb=kb;ib=jb}S=+h[9511];G=S*ib-hb*hb;h[9562]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[76120]=1;C=c[l>>2]|0;c[19020]=1;if((C|0)<1){lb=76216;mb=+h[9527];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[76224+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[19018]=6;c[19020]=C+1;lb=76216;mb=+h[9527];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function nA(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[9594]=.5;h[9590]=1.0;h[9606]=6.283185307179586;z=+h[n>>3];h[9603]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[19194]=A;c[19202]=0;B=c[d>>2]|0;c[19154]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[19154]=B+1}c[19152]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[9595]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[9595]=F;G=F}else{G=z}H=c[d>>2]|0;c[19154]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[9595];I=I+1|0}c[19154]=H+1}I=B+1|0;c[19152]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[9578]=0.0;D=c[b>>2]|0;c[19150]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[9578]=+h[9578]+G*G;A=p+1|0;c[19150]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[19154]=1;if((p|0)>=1){D=1;while(1){h[9595]=0.0;h[9593]=0.0;y=c[b>>2]|0;c[19152]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[9595]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[9593]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[19152]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[9595]=G;h[9593]=+h[g>>3]*L;g=c[b>>2]|0;c[19150]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[9593]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[9595];H=H+1|0}c[19150]=g+1}H=D+1|0;c[19154]=H;if((D|0)<(p|0)){D=H}else{break}}}h[9579]=0.0;h[9581]=0.0;h[9588]=0.0;D=c[b>>2]|0;c[19150]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[9579]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[9581]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[9588]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[19150]=D+1;O=R;P=T;Q=S}S=+h[9578];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[9599]=U;h[9595]=0.0;if(Q*Q>S*.99*O){h[9595]=+h[9590]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[9594]*U*Z);h[9591]=P;if(O*+h[9603]<P*P*.01){h[9595]=+h[9590]}n=c[b>>2]|0;c[19150]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[9599]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[9595]*U;if((D|0)>=(n|0)){break}e=D;P=+h[9599];D=D+1|0;p=e}c[19150]=n+1;_=0}while(1){n=_+1|0;c[19202]=n;h[9578]=0.0;h[9581]=0.0;h[9582]=0.0;p=c[b>>2]|0;c[19150]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[9578]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[9581]=da;Z=+h[H>>3];ea=P+Z*Z;h[9582]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[19150]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[9595]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[9600]=U;D=c[b>>2]|0;c[19150]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[9600];U=+h[9581];O=+h[9578];g=g+1|0;H=e}c[19150]=D+1}H=c[d>>2]|0;c[19154]=1;if((H|0)>=1){g=1;while(1){h[9593]=0.0;p=c[b>>2]|0;c[19152]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[9593]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[19152]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[9593]=O;e=c[b>>2]|0;c[19150]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[9593];l=l+1|0}c[19150]=e+1}l=g+1|0;c[19154]=l;if((g|0)<(H|0)){g=l}else{break}}}h[9583]=0.0;h[9584]=0.0;h[9585]=0.0;h[9586]=0.0;h[9587]=0.0;g=c[b>>2]|0;c[19150]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[9583]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[9584]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[9585]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[9586]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[9587]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[19150]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[9594];O=U*na;h[9583]=O;P=U*ma-O;h[9586]=P;Z=O+la+P;h[9607]=Z;h[9609]=Z;h[9608]=Z;c[19204]=0;a[76640]=1;W=+h[9606]/50.0;h[9595]=W;c[19150]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[9609]=wa;c[19204]=p;h[9604]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[9605]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[9598]=ta;h[9589]=ua;h[9592]=va;h[9591]=wa;c[19150]=50;h[9608]=wa;if((za|0)==0){h[9604]=wa;ga=74}else if((za|0)==49){h[9605]=Z;Ba=Z}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[9605]}h[9596]=0.0;S=+h[9604];if(S!=Ba){Q=S-Aa;h[9604]=Q;S=Ba-Aa;h[9605]=S;T=U*(Q-S)/(Q+S);h[9596]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[9598]=T;S=+X(+T);h[9589]=S;Q=+Y(+T);h[9592]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[9591]=T;p=c[b>>2]|0;c[19150]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[9589]*+h[y>>3]+ +h[9592]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[9592];Q=+h[9589];H=H+1|0;g=e}c[19150]=p+1;Da=+h[9591]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[9607];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}



function kS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=bd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Be[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=bd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((md(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function lS(a){a=a|0;var b=0;b=i;c[a>>2]=138176;UZ(a+4|0);i=b;return}function mS(a){a=a|0;var b=0;b=i;c[a>>2]=138176;UZ(a+4|0);x1(a);i=b;return}function nS(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=WZ(d,140968)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(de[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function oS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=te[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((qd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function pS(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=rc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((se[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function qS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Be[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function rS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=138176;j=b+4|0;SZ(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=137528;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;TZ(g,j);j=WZ(g,140968)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=de[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(de[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){cZ(137368)}else{UZ(g);i=f;return}}function sS(a){a=a|0;var b=0;b=i;c[a>>2]=138176;UZ(a+4|0);i=b;return}function tS(a){a=a|0;var b=0;b=i;c[a>>2]=138176;UZ(a+4|0);x1(a);i=b;return}function uS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=WZ(d,140968)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=de[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(de[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){cZ(137368)}else{i=e;return}}function vS(a){a=a|0;var b=0,c=0;b=i;c=yS(a,0)|0;i=b;return c|0}function wS(a){a=a|0;var b=0,c=0;b=i;c=yS(a,1)|0;i=b;return c|0}function xS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Be[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((md(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function yS(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=bd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Be[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=bd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((md(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function zS(){var a=0;a=i;XR(0);Ud(233,136792,q|0)|0;i=a;return}function AS(a){a=a|0;i=i;return}function BS(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function CS(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}ae[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function DS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=137672;e=T1(b|0)|0;f=w1(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;V1(g|0,b|0,e+1|0)|0;i=d;return}function ES(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=137672;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;x1(j);i=b;return}y1((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;x1(j);i=b;return}function FS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=137672;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}y1((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function GS(a){a=a|0;i=i;return c[a+4>>2]|0}function HS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=137696;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=T1(f|0)|0;g=w1(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;V1(h|0,f|0,d+1|0)|0;i=e;return}function IS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=137696;e=T1(b|0)|0;f=w1(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;V1(g|0,b|0,e+1|0)|0;i=d;return}function JS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=137696;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;x1(j);i=b;return}y1((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;x1(j);i=b;return}function KS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=137696;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}y1((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function LS(a){a=a|0;i=i;return c[a+4>>2]|0}function MS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=137672;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;x1(j);i=b;return}y1((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;x1(j);i=b;return}function NS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=137672;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;x1(j);i=b;return}y1((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;x1(j);i=b;return}function OS(a){a=a|0;i=i;return}function PS(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function QS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;ze[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function RS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function SS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Rd(e|0)|0;e=T1(f|0)|0;if(e>>>0>4294967279){YS(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;V1(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=v1(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;V1(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function TS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{DT(e,137912,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;ze[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}DT(e,o,p)|0;if((a[g]&1)==0){break}x1(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function US(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=T1(e|0)|0;if(j>>>0>4294967279){YS(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=v1(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}V1(k|0,e|0,j|0)|0;a[k+j|0]=0;TS(g,d,h);HS(b,g);if(!((a[g]&1)==0)){x1(c[g+8>>2]|0)}if(!((a[h]&1)==0)){x1(c[h+8>>2]|0)}c[b>>2]=137928;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function VS(a){a=a|0;var b=0;b=i;KS(a);x1(a);i=b;return}function WS(a){a=a|0;var b=0;b=i;KS(a);i=b;return}function XS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;tc(138064)|0;if((c[a>>2]|0)==1){do{jd(138088,138064)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;gc(138064)|0;ae[d&255](b);tc(138064)|0;c[a>>2]=-1;gc(138064)|0;_c(138088)|0;i=e;return}else{gc(138064)|0;i=e;return}}function YS(a){a=a|0;a=Ec(8)|0;DS(a,138136);c[a>>2]=137752;Od(a|0,137792,41)}function ZS(a){a=a|0;a=Ec(8)|0;DS(a,138136);c[a>>2]=137816;Od(a|0,137856,41)}function _S(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function $S(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function aT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){YS(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=v1(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}V1(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function bT(b){b=b|0;i=i;return(a[b]&1)!=0|0}function cT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){YS(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=v1(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}V1(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function dT(a){a=a|0;i=i;return a|0}function eT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=T1(d|0)|0;if(f>>>0>4294967279){YS(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;V1(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=v1(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;V1(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function fT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){YS(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=v1(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}X1(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function gT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){YS(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;X1(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=v1(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;X1(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function hT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){ZS(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){YS(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;V1(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=v1(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;V1(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function iT(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function jT(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function kT(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}x1(c[b+8>>2]|0);i=d;return}function lT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}ET(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}W1(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function mT(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=nT(a,b)|0;i=c;return d|0}function nT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=T1(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}ET(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}W1(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function oT(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function pT(a){a=a|0;i=i;return a+1|0}function qT(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function rT(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function sT(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function tT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){uT(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function uT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){FT(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}X1(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function vT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){uT(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function wT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){YS(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=v1(f)|0}else{p=v1(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}V1(l|0,n|0,q+1|0)|0;if(o){x1(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function xT(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function yT(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function zT(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function AT(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function BT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=DT(b,g,h)|0;i=e;return d|0}function CT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){FT(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function DT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){ET(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}V1(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function ET(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){YS(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=v1(q)|0;if((g|0)!=0){V1(e|0,m|0,g|0)|0}if((j|0)!=0){V1(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){V1(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){x1(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function FT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){YS(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=v1(p)|0;if((g|0)!=0){V1(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){V1(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}x1(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function GT(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;hT(a,b,c,d,0);i=e;return}function HT(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function IT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=T1(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function JT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=O1(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function KT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=T1(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){ZS(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=O1(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function LT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){YS(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;V1(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=v1(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;V1(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function MT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){YS(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=v1(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}S0(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function NT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){YS(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=v1(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}U0(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function OT(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}x1(c[b+8>>2]|0);i=d;return}function PT(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=QT(a,b,R0(b)|0)|0;i=c;return d|0}function QT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}TT(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}T0(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function RT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){YS(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=v1(f)|0}else{p=v1(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}S0(l,n,q+1|0)|0;if(o){x1(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function ST(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){UT(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function TT(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){YS(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=v1(q<<2)|0;p=e;if((g|0)!=0){S0(p,m,g)|0}if((j|0)!=0){S0(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){S0(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){x1(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function UT(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){YS(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=v1(p<<2)|0;o=e;if((g|0)!=0){S0(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){S0(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}x1(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function VT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=T1(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){YS(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=v1(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}V1(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=DT(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=DT(b,m,j)|0;i=f;return}}function WT(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function XT(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function YT(a,b){a=a|0;b=b|0;var c=0;c=i;ZT(a,b);i=c;return}function ZT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ec(16)|0;do{if((a[138520]|0)==0){if((Za(138520)|0)==0){break}c[34628]=139216;Ud(67,138512,q|0)|0;Sb(138520)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=138512;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];US(b,f,138568);c[e>>2]=138536;Od(e|0,138616,63)}function _T(a,b){a=a|0;b=b|0;var d=0;d=i;ZT(a,c[a+16>>2]|b);i=d;return}function $T(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=138560;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;ze[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}UZ(a+28|0);q1(c[e>>2]|0);q1(c[f>>2]|0);q1(c[a+48>>2]|0);q1(c[a+60>>2]|0);i=b;return}function aU(a){a=a|0;var b=0;b=i;$T(a);x1(a);i=b;return}function bU(a){a=a|0;var b=0;b=i;$T(a);i=b;return}function cU(a){a=a|0;var b=0;b=i;$T(a);i=b;return}function dU(a){a=a|0;i=i;return c[a+24>>2]|0}function eU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}TZ(d,a+28|0);a=WZ(d,140904)|0;f=se[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;UZ(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function fU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;TZ(e,a+28|0);a=WZ(e,140904)|0;f=se[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;UZ(e);i=d;return f|0}function gU(a,b){a=a|0;b=b|0;var c=0;c=i;TZ(a,b+28|0);i=c;return}function hU(a){a=a|0;c[a>>2]=138160;i=i;return}function iU(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));SZ(b);i=d;return}function jU(a){a=a|0;var b=0;b=i;c[a>>2]=138176;UZ(a+4|0);x1(a);i=b;return}function kU(a){a=a|0;var b=0;b=i;c[a>>2]=138176;UZ(a+4|0);i=b;return}function lU(a){a=a|0;var b=0;b=i;c[a>>2]=138176;UZ(a+4|0);i=b;return}function mU(a,b){a=a|0;b=b|0;var c=0;c=i;TZ(a,b+4|0);i=c;return}function nU(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=de[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function oU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=se[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function pU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=ge[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function qU(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=138176;SZ(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function rU(a){a=a|0;i=i;return c[a+8>>2]|0}function sU(a){a=a|0;i=i;return c[a+12>>2]|0}function tU(a){a=a|0;i=i;return c[a+16>>2]|0}function uU(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function vU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function wU(a){a=a|0;i=i;return c[a+20>>2]|0}function xU(a){a=a|0;i=i;return c[a+24>>2]|0}function yU(a){a=a|0;i=i;return c[a+28>>2]|0}function zU(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function AU(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function BU(a,b){a=a|0;b=b|0;i=i;return}function CU(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function DU(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function EU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function FU(a){a=a|0;i=i;return 0}function GU(a){a=a|0;i=i;return 0}function HU(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=de[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function IU(a){a=a|0;i=i;return-1}function JU(a){a=a|0;var b=0,e=0,f=0;b=i;if((de[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function KU(a,b){a=a|0;b=b|0;i=i;return-1}function LU(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((se[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function MU(a,b){a=a|0;b=b|0;i=i;return-1}function NU(a){a=a|0;var b=0;b=i;c[a>>2]=138240;UZ(a+4|0);x1(a);i=b;return}function OU(a){a=a|0;var b=0;b=i;c[a>>2]=138240;UZ(a+4|0);i=b;return}function PU(a,b){a=a|0;b=b|0;i=i;return}function QU(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function RU(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function SU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function TU(a){a=a|0;i=i;return 0}function UU(a){a=a|0;i=i;return 0}function VU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=de[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function WU(a){a=a|0;i=i;return-1}function XU(a){a=a|0;var b=0,d=0,e=0;b=i;if((de[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function YU(a,b){a=a|0;b=b|0;i=i;return-1}function ZU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((se[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function _U(a,b){a=a|0;b=b|0;i=i;return-1}function $U(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));SZ(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function aV(a){a=a|0;var b=0;b=i;$T(a+8|0);x1(a);i=b;return}function bV(a){a=a|0;var b=0;b=i;$T(a+8|0);i=b;return}function cV(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;$T(a+(d+8)|0);x1(a+d|0);i=b;return}function dV(a){a=a|0;var b=0;b=i;$T(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function eV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;fV(a,b,c);i=d;return}function fV(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){ZT(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){gV(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}TZ(h,e+(k+28)|0);k=WZ(h,140904)|0;UZ(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(de[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){de[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((de[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;ZT(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function gV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{gV(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((de[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;ZT(b+h|0,c[b+(h+16)>>2]|1)}}while(0);vV(e);i=d;return b|0}function hV(b){b=b|0;i=i;return(a[b]|0)!=0|0}function iV(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function jV(a){a=a|0;var b=0;b=i;$T(a+8|0);x1(a);i=b;return}function kV(a){a=a|0;var b=0;b=i;$T(a+8|0);i=b;return}function lV(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;$T(a+(d+8)|0);x1(a+d|0);i=b;return}function mV(a){a=a|0;var b=0;b=i;$T(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function nV(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{nV(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((de[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;ZT(b+h|0,c[b+(h+16)>>2]|1)}}while(0);HV(e);i=d;return b|0}function oV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));SZ(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function pV(a){a=a|0;var b=0;b=i;$T(a+4|0);x1(a);i=b;return}function qV(a){a=a|0;var b=0;b=i;$T(a+4|0);i=b;return}function rV(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;$T(a+(d+4)|0);x1(a+d|0);i=b;return}function sV(a){a=a|0;var b=0;b=i;$T(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function tV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){gV(g)|0}a[f]=1;i=e;return}function uV(a){a=a|0;var b=0;b=i;vV(a);i=b;return}function vV(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((de[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;ZT(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function wV(b){b=b|0;i=i;return(a[b]|0)!=0|0}function xV(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=de[b&127](a)|0;i=c;return d|0}function yV(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){vV(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{gV(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;TZ(k,b+(p+28)|0);p=WZ(k,139624)|0;m=p;UZ(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){TZ(h,b+(k+28)|0);r=WZ(h,140904)|0;s=se[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;UZ(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];je[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){vV(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;ZT(b+l|0,c[b+(l+16)>>2]|5);vV(j);i=e;return b|0}function zV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){vV(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{gV(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;vV(f);i=e;return b|0}if((se[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{vV(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;ZT(b+d|0,c[b+(d+16)>>2]|1);vV(f);i=e;return b|0}function AV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){vV(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){gV(k)|0}a[h]=1;if((e|0)==0){vV(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((ge[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){vV(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;ZT(b+e|0,c[b+(e+16)>>2]|1);vV(g);i=f;return b|0}function BV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;me[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function CV(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){vV(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{gV(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];De[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){vV(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;ZT(b+f|0,c[b+(f+16)>>2]|4);vV(h);i=e;return b|0}function DV(a){a=a|0;var b=0;b=i;$T(a+4|0);x1(a);i=b;return}function EV(a){a=a|0;var b=0;b=i;$T(a+4|0);i=b;return}function FV(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;$T(a+(d+4)|0);x1(a+d|0);i=b;return}function GV(a){a=a|0;var b=0;b=i;$T(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function HV(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((de[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;ZT(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function IV(a){a=a|0;i=i;return 138456}function JV(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){cT(a,138472,35);i=d;return}else{SS(a,b,c);i=d;return}}function KV(a){a=a|0;i=i;return}function LV(a){a=a|0;var b=0;b=i;WS(a);x1(a);i=b;return}function MV(a){a=a|0;var b=0;b=i;WS(a);i=b;return}function NV(a){a=a|0;var b=0;b=i;$T(a);x1(a);i=b;return}function OV(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function PV(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function QV(a){a=a|0;i=i;return}function RV(a){a=a|0;i=i;return}function SV(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function TV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){YS(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=v1(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function UV(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function VV(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function WV(a){a=a|0;i=i;return}function XV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function YV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){YS(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=v1(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function ZV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function _V(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function $V(a){a=a|0;i=i;return}function aW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];pe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}gU(u,g);m=u;u=c[m>>2]|0;if(!((c[35226]|0)==-1)){c[p>>2]=140904;c[p+4>>2]=234;c[p+8>>2]=0;XS(140904,p,235)}p=(c[140908>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;W0(D);E=156464;F=128;Od(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;W0(D);E=156464;F=128;Od(C|0,E|0,F|0)}F=u;CS(c[m>>2]|0)|0;gU(v,g);g=v;v=c[g>>2]|0;if(!((c[35262]|0)==-1)){c[o>>2]=141048;c[o+4>>2]=234;c[o+8>>2]=0;XS(141048,o,235)}o=(c[141052>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;W0(H);I=156464;J=128;Od(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;W0(H);I=156464;J=128;Od(G|0,I|0,J|0)}J=v;CS(c[g>>2]|0)|0;g=w;be[c[(c[v>>2]|0)+24>>2]&127](g,J);be[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=bW(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];kT(w+12|0);kT(w);i=k;return}function bW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=p1(l)|0;if((n|0)!=0){o=n;p=n;break}C1()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((de[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((de[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=se[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(se[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){de[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((de[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}q1(o);i=k;return _|0}function cW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];dW(a,0,k,j,f,g,h);i=b;return}function dW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;VW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}tT(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}tT(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((vW(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=R$(F,c[o>>2]|0,h,t)|0;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}function eW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];fW(a,0,k,j,f,g,h);i=b;return}function fW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;VW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}tT(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}tT(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((vW(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=Q$(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;kT(n);kT(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;kT(n);kT(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;kT(n);kT(m);i=d;return}function gW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];hW(a,0,k,j,f,g,h);i=b;return}function hW(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==0){u=0}else if((t|0)==8){u=16}else if((t|0)==64){u=8}else{u=10}t=l;VW(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;tT(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((de[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}tT(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}tT(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((vW(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){de[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=P$(G,c[p>>2]|0,j,u)|0;gZ(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;kT(o);kT(n);i=e;return}if((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;kT(o);kT(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;kT(o);kT(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;kT(o);kT(n);i=e;return}function iW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];jW(a,0,k,j,f,g,h);i=b;return}function jW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;VW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}tT(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}tT(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((vW(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=O$(F,c[o>>2]|0,h,t)|0;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}function kW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];lW(a,0,k,j,f,g,h);i=b;return}function lW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;VW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}tT(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}tT(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((vW(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=N$(F,c[o>>2]|0,h,t)|0;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;kT(n);kT(m);i=d;return}function mW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];nW(a,0,k,j,f,g,h);i=b;return}function nW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;VW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}tT(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}tT(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(de[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((vW(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=M$(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((de[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;kT(n);kT(m);i=d;return}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;kT(n);kT(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;kT(n);kT(m);i=d;return}function oW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pW(a,0,k,j,f,g,h);i=b;return}function pW(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;WW(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;tT(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}tT(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}tT(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((XW(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+L$(I,c[p>>2]|0,j);gZ(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}function qW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];rW(a,0,k,j,f,g,h);i=b;return}function rW(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;WW(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}tT(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}tT(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((XW(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+K$(I,c[p>>2]|0,j);gZ(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}function sW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];tW(a,0,k,j,f,g,h);i=b;return}function tW(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;WW(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}tT(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}tT(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(de[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((XW(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+J$(I,c[p>>2]|0,j);gZ(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((de[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}if((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;kT(o);kT(n);i=d;return}function uW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;gU(o,g);g=o;o=c[g>>2]|0;if(!((c[35226]|0)==-1)){c[l>>2]=140904;c[l+4>>2]=234;c[l+8>>2]=0;XS(140904,l,235)}l=(c[140908>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}y=m;Ce[c[(c[o>>2]|0)+32>>2]&63](o,139448,139474|0,y)|0;CS(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((de[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((de[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}tT(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}tT(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(de[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((vW(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){de[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);K=c[35198]|0;c[k>>2]=j;if((wW(E,K,139488,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;kT(p);kT(n);i=d;return}if((de[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;kT(p);kT(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;kT(p);kT(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;kT(p);kT(n);i=d;return}function vW(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[139448+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[139448+h|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function wW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function xW(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function yW(a){a=a|0;i=i;return}function zW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];pe[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}gU(u,g);m=u;u=c[m>>2]|0;if(!((c[35224]|0)==-1)){c[p>>2]=140896;c[p+4>>2]=234;c[p+8>>2]=0;XS(140896,p,235)}p=(c[140900>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;W0(D);E=156464;F=128;Od(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;W0(D);E=156464;F=128;Od(C|0,E|0,F|0)}F=u;CS(c[m>>2]|0)|0;gU(v,g);g=v;v=c[g>>2]|0;if(!((c[35264]|0)==-1)){c[o>>2]=141056;c[o+4>>2]=234;c[o+8>>2]=0;XS(141056,o,235)}o=(c[141060>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;W0(H);I=156464;J=128;Od(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;W0(H);I=156464;J=128;Od(G|0,I|0,J|0)}J=v;CS(c[g>>2]|0)|0;g=w;be[c[(c[v>>2]|0)+24>>2]&127](g,J);be[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=AW(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];OT(w+12|0);OT(w);i=k;return}function AW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=p1(l)|0;if((n|0)!=0){o=n;p=n;break}C1()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=se[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(se[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){de[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}q1(o);i=k;return ba|0}function BW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];CW(a,0,k,j,f,g,h);i=b;return}function CW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;YW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}tT(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}tT(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((UW(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=R$(I,c[o>>2]|0,h,t)|0;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}function DW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];EW(a,0,k,j,f,g,h);i=b;return}function EW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;YW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}tT(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}tT(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((UW(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=Q$(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;kT(n);kT(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;kT(n);kT(m);i=d;return}function FW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];GW(a,0,k,j,f,g,h);i=b;return}function GW(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==0){u=0}else if((t|0)==64){u=8}else{u=10}t=l;YW(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;tT(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=de[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}tT(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}tT(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((UW(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){de[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=P$(J,c[p>>2]|0,j,u)|0;gZ(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=de[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;kT(o);kT(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;kT(o);kT(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;kT(o);kT(n);i=e;return}function HW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];IW(a,0,k,j,f,g,h);i=b;return}function IW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;YW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}tT(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}tT(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((UW(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=O$(I,c[o>>2]|0,h,t)|0;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}function JW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];KW(a,0,k,j,f,g,h);i=b;return}function KW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;YW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}tT(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}tT(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((UW(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=N$(I,c[o>>2]|0,h,t)|0;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;kT(n);kT(m);i=d;return}function LW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];MW(a,0,k,j,f,g,h);i=b;return}



function MW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;YW(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=de[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=de[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}tT(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}tT(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((UW(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){de[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=M$(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;gZ(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=de[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=de[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;kT(n);kT(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;kT(n);kT(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;kT(n);kT(m);i=d;return}function NW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];OW(a,0,k,j,f,g,h);i=b;return}function OW(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;ZW(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;tT(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}tT(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}tT(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((_W(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+L$(L,c[p>>2]|0,j);gZ(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}function PW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];QW(a,0,k,j,f,g,h);i=b;return}function QW(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;ZW(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}tT(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}tT(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((_W(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+K$(L,c[p>>2]|0,j);gZ(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}function RW(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];SW(a,0,k,j,f,g,h);i=b;return}function SW(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;ZW(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}tT(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}tT(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((_W(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+J$(L,c[p>>2]|0,j);gZ(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=de[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;kT(o);kT(n);i=d;return}function TW(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;gU(o,g);g=o;o=c[g>>2]|0;if(!((c[35224]|0)==-1)){c[l>>2]=140896;c[l+4>>2]=234;c[l+8>>2]=0;XS(140896,l,235)}l=(c[140900>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}y=m;Ce[c[(c[o>>2]|0)+48>>2]&63](o,139448,139474|0,y)|0;CS(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;tT(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=de[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=de[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}tT(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}tT(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((UW(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){de[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);N=c[35198]|0;c[k>>2]=j;if((wW(H,N,139488,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=de[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=de[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;kT(p);kT(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;kT(p);kT(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;kT(p);kT(n);i=d;return}function UW(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[139448+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[139448+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function VW(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;gU(k,d);d=k;k=c[d>>2]|0;if(!((c[35226]|0)==-1)){c[j>>2]=140904;c[j+4>>2]=234;c[j+8>>2]=0;XS(140904,j,235)}j=(c[140908>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;W0(n);o=156464;p=128;Od(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;W0(n);o=156464;p=128;Od(m|0,o|0,p|0)}Ce[c[(c[k>>2]|0)+32>>2]&63](k,139448,139474|0,e)|0;e=c[d>>2]|0;if(!((c[35262]|0)==-1)){c[h>>2]=141048;c[h+4>>2]=234;c[h+8>>2]=0;XS(141048,h,235)}h=(c[141052>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}else{t=e;a[f]=de[c[(c[e>>2]|0)+16>>2]&127](t)|0;be[c[(c[e>>2]|0)+20>>2]&127](b,t);CS(c[d>>2]|0)|0;i=g;return}}function WW(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;gU(l,d);d=l;l=c[d>>2]|0;if(!((c[35226]|0)==-1)){c[k>>2]=140904;c[k+4>>2]=234;c[k+8>>2]=0;XS(140904,k,235)}k=(c[140908>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ec(4)|0;o=n;W0(o);p=156464;q=128;Od(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ec(4)|0;o=n;W0(o);p=156464;q=128;Od(n|0,p|0,q|0)}Ce[c[(c[l>>2]|0)+32>>2]&63](l,139448,139480|0,e)|0;e=c[d>>2]|0;if(!((c[35262]|0)==-1)){c[j>>2]=141048;c[j+4>>2]=234;c[j+8>>2]=0;XS(141048,j,235)}j=(c[141052>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ec(4)|0;s=r;W0(s);t=156464;u=128;Od(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ec(4)|0;s=r;W0(s);t=156464;u=128;Od(r|0,t|0,u|0)}else{u=e;a[f]=de[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=de[c[(c[e>>2]|0)+16>>2]&127](u)|0;be[c[(c[e>>2]|0)+20>>2]&127](b,u);CS(c[d>>2]|0)|0;i=h;return}}function XW(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[139448+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function YW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;gU(j,b);b=j;j=c[b>>2]|0;if(!((c[35224]|0)==-1)){c[h>>2]=140896;c[h+4>>2]=234;c[h+8>>2]=0;XS(140896,h,235)}h=(c[140900>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ec(4)|0;m=l;W0(m);n=156464;o=128;Od(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ec(4)|0;m=l;W0(m);n=156464;o=128;Od(l|0,n|0,o|0)}Ce[c[(c[j>>2]|0)+48>>2]&63](j,139448,139474|0,d)|0;d=c[b>>2]|0;if(!((c[35264]|0)==-1)){c[g>>2]=141056;c[g+4>>2]=234;c[g+8>>2]=0;XS(141056,g,235)}g=(c[141060>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}else{s=d;c[e>>2]=de[c[(c[d>>2]|0)+16>>2]&127](s)|0;be[c[(c[d>>2]|0)+20>>2]&127](a,s);CS(c[b>>2]|0)|0;i=f;return}}function ZW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;gU(k,b);b=k;k=c[b>>2]|0;if(!((c[35224]|0)==-1)){c[j>>2]=140896;c[j+4>>2]=234;c[j+8>>2]=0;XS(140896,j,235)}j=(c[140900>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;W0(n);o=156464;p=128;Od(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;W0(n);o=156464;p=128;Od(m|0,o|0,p|0)}Ce[c[(c[k>>2]|0)+48>>2]&63](k,139448,139480|0,d)|0;d=c[b>>2]|0;if(!((c[35264]|0)==-1)){c[h>>2]=141056;c[h+4>>2]=234;c[h+8>>2]=0;XS(141056,h,235)}h=(c[141060>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}else{t=d;c[e>>2]=de[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=de[c[(c[d>>2]|0)+16>>2]&127](t)|0;be[c[(c[d>>2]|0)+20>>2]&127](a,t);CS(c[b>>2]|0)|0;i=g;return}}function _W(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[139448+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function $W(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function aX(a){a=a|0;i=i;return}function bX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];me[p&31](b,d,k,f,g,q);i=j;return}gU(n,f);f=n;n=c[f>>2]|0;if(!((c[35262]|0)==-1)){c[l>>2]=141048;c[l+4>>2]=234;c[l+8>>2]=0;XS(141048,l,235)}l=(c[141052>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;W0(u);v=156464;w=128;Od(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;W0(u);v=156464;w=128;Od(t|0,v|0,w|0)}w=n;CS(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){be[c[f+24>>2]&127](o,w)}else{be[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((se[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];kT(o);i=j;return}function cX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=139696;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);v=c[35198]|0;c[k>>2]=h;h=dX(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;gU(q,f);eX(w,y,k,z,o,p,q);CS(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];IP(b,j,z,e,o,f,g);i=d;return}function dX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Lc(d|0)|0;d=nc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Lc(f|0)|0;i=g;return d|0}function eX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[35226]|0)==-1)){c[m>>2]=140904;c[m+4>>2]=234;c[m+8>>2]=0;XS(140904,m,235)}m=(c[140908>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[35262]|0)==-1)){c[l>>2]=141048;c[l+4>>2]=234;c[l+8>>2]=0;XS(141048,l,235)}l=(c[141052>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;W0(v);w=156464;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;W0(v);w=156464;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ce[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=se[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=se[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=se[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;kT(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;kT(n);i=k;return}}function fX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);y=c[35198]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=dX(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;gU(r,f);eX(x,z,l,A,p,q,r);CS(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];IP(b,k,A,e,p,f,g);i=d;return}function gX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=139696;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);x=c[35198]|0;c[k>>2]=h;h=dX(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;gU(q,f);eX(w,y,k,z,o,p,q);CS(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];IP(b,j,z,e,o,f,g);i=d;return}function hX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);w=c[35198]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=dX(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;gU(r,f);eX(x,z,l,A,p,q,r);CS(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];IP(b,k,A,e,p,f,g);i=d;return}function iX(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);r=c[35198]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=dX(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=dX(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[140800]|0)==0;if(F){do{if(o){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);r=c[35198]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=jX(s,r,z,n)|0}else{do{if(o){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);o=c[35198]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=jX(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}C1()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=p1(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}C1()}}while(0);gU(w,f);kX(N,L,G,P,u,v,w);CS(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];IP(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){q1(O)}if((J|0)==0){i=d;return}q1(J);i=d;return}function jX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=kc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function kX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[35226]|0)==-1)){c[m>>2]=140904;c[m+4>>2]=234;c[m+8>>2]=0;XS(140904,m,235)}m=(c[140908>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[35262]|0)==-1)){c[l>>2]=141048;c[l+4>>2]=234;c[l+8>>2]=0;XS(141048,l,235)}l=(c[141052>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;W0(v);w=156464;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;W0(v);w=156464;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=se[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=se[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);w=A+1|0;if((Wc(l<<24>>24|0,c[35198]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);l=D+1|0;if((Qd(A<<24>>24|0,c[35198]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ce[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=se[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=se[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=de[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Ce[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;kT(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;kT(n);i=k;return}function lX(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);r=c[35198]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=dX(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=dX(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[140800]|0)==0;if(F){do{if(o){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);r=c[35198]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=jX(s,r,z,n)|0}else{do{if(o){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);o=c[35198]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=jX(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}C1()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=p1(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}C1()}}while(0);gU(w,f);kX(N,L,G,P,u,v,w);CS(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];IP(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){q1(O)}if((J|0)==0){i=d;return}q1(J);i=d;return}function mX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=139704;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);s=c[35198]|0;c[k>>2]=h;h=dX(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}u=o;gU(p,f);r=p;p=c[r>>2]|0;if(!((c[35226]|0)==-1)){c[l>>2]=140904;c[l+4>>2]=234;c[l+8>>2]=0;XS(140904,l,235)}l=(c[140908>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}CS(c[r>>2]|0)|0;Ce[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];IP(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];IP(b,j,u,z,m,f,g);I=j;i=d;return}function nX(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function oX(a){a=a|0;i=i;return}function pX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];me[p&31](b,d,k,f,g,q);i=j;return}gU(n,f);f=n;n=c[f>>2]|0;if(!((c[35264]|0)==-1)){c[l>>2]=141056;c[l+4>>2]=234;c[l+8>>2]=0;XS(141056,l,235)}l=(c[141060>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;W0(u);v=156464;w=128;Od(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;W0(u);v=156464;w=128;Od(t|0,v|0,w|0)}w=n;CS(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){be[c[f+24>>2]&127](o,w)}else{be[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=se[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];OT(o);i=j;return}function qX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=139696;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);v=c[35198]|0;c[k>>2]=h;h=dX(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;gU(q,f);rX(w,y,k,z,o,p,q);CS(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];sX(b,j,z,e,o,f,g);i=d;return}function rX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[35224]|0)==-1)){c[m>>2]=140896;c[m+4>>2]=234;c[m+8>>2]=0;XS(140896,m,235)}m=(c[140900>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[35264]|0)==-1)){c[l>>2]=141056;c[l+4>>2]=234;c[l+8>>2]=0;XS(141056,l,235)}l=(c[141060>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;W0(v);w=156464;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;W0(v);w=156464;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ce[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=se[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=se[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=se[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;kT(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;kT(n);i=k;return}function sX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((ge[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){NT(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((ge[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){OT(l);break}c[m>>2]=0;c[b>>2]=0;OT(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((ge[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function tX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);w=c[35198]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=dX(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;gU(r,f);rX(x,z,l,A,p,q,r);CS(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];sX(b,k,A,e,p,f,g);i=d;return}function uX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=139696;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);v=c[35198]|0;c[k>>2]=h;h=dX(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;gU(q,f);rX(w,y,k,z,o,p,q);CS(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];sX(b,j,z,e,o,f,g);i=d;return}function vX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);y=c[35198]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=dX(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;gU(r,f);rX(x,z,l,A,p,q,r);CS(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];sX(b,k,A,e,p,f,g);i=d;return}function wX(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);r=c[35198]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=dX(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=dX(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[140800]|0)==0;if(F){do{if(o){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);r=c[35198]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=jX(s,r,z,n)|0}else{do{if(o){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);o=c[35198]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=jX(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}C1()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=p1(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}C1()}}while(0);gU(w,f);xX(N,L,G,P,u,v,w);CS(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];sX(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){q1(O)}if((J|0)==0){i=d;return}q1(J);i=d;return}function xX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[35224]|0)==-1)){c[m>>2]=140896;c[m+4>>2]=234;c[m+8>>2]=0;XS(140896,m,235)}m=(c[140900>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;W0(r);s=156464;t=128;Od(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[35264]|0)==-1)){c[l>>2]=141056;c[l+4>>2]=234;c[l+8>>2]=0;XS(141056,l,235)}l=(c[141060>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;W0(v);w=156464;x=128;Od(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;W0(v);w=156464;x=128;Od(u|0,w|0,x|0)}x=s;be[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=se[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=se[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=se[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);w=A+1|0;if((Wc(l<<24>>24|0,c[35198]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);l=D+1|0;if((Qd(A<<24>>24|0,c[35198]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ce[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=de[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=se[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=se[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=de[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Ce[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;kT(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;kT(n);i=k;return}function yX(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);r=c[35198]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=dX(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=dX(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[140800]|0)==0;if(F){do{if(o){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);r=c[35198]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=jX(s,r,z,n)|0}else{do{if(o){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);o=c[35198]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=jX(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}C1()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=p1(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}C1()}}while(0);gU(w,f);xX(N,L,G,P,u,v,w);CS(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];sX(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){q1(O)}if((J|0)==0){i=d;return}q1(J);i=d;return}function zX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=139704;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);s=c[35198]|0;c[k>>2]=h;h=dX(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}gU(p,f);u=p;p=c[u>>2]|0;if(!((c[35224]|0)==-1)){c[l>>2]=140896;c[l+4>>2]=234;c[l+8>>2]=0;XS(140896,l,235)}l=(c[140900>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}CS(c[u>>2]|0)|0;u=o;Ce[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];sX(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];sX(b,j,u,z,m,f,g);I=j;i=d;return}function AX(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;gU(r,h);v=r;r=c[v>>2]|0;if(!((c[35226]|0)==-1)){c[q>>2]=140904;c[q+4>>2]=234;c[q+8>>2]=0;XS(140904,q,235)}q=(c[140908>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ec(4)|0;y=x;W0(y);z=156464;A=128;Od(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ec(4)|0;y=x;W0(y);z=156464;A=128;Od(x|0,z|0,A|0)}A=r;CS(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((de[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((ge[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(de[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=se[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(se[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=ge[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=ge[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];re[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((de[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((de[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(de[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){de[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){de[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((de[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((de[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function BX(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function CX(a){a=a|0;i=i;return}function DX(a){a=a|0;i=i;return 2}function EX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];AX(a,b,l,k,f,g,h,139808,139816|0);i=j;return}function FX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=de[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];AX(b,d,m,l,g,h,j,s,q);i=k;return}function GX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;gU(n,f);f=n;n=c[f>>2]|0;if(!((c[35226]|0)==-1)){c[m>>2]=140904;c[m+4>>2]=234;c[m+8>>2]=0;XS(140904,m,235)}m=(c[140908>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}s=n;CS(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=bW(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function HX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;gU(n,f);f=n;n=c[f>>2]|0;if(!((c[35226]|0)==-1)){c[m>>2]=140904;c[m+4>>2]=234;c[m+8>>2]=0;XS(140904,m,235)}m=(c[140908>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}s=n;CS(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=bW(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function IX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;gU(m,f);f=m;m=c[f>>2]|0;if(!((c[35226]|0)==-1)){c[l>>2]=140904;c[l+4>>2]=234;c[l+8>>2]=0;XS(140904,l,235)}l=(c[140908>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;W0(p);q=156464;r=128;Od(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;W0(p);q=156464;r=128;Od(o|0,q|0,r|0)}r=m;CS(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=NX(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function JX(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;gU(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[35226]|0)==-1)){c[ba>>2]=140904;c[ba+4>>2]=234;c[ba+8>>2]=0;XS(140904,ba,235)}ba=(c[140908>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;W0(Ga);Ha=156464;Ia=128;Od(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;W0(Ga);Ha=156464;Ia=128;Od(Fa|0,Ha|0,Ia|0)}Ia=ca;CS(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=NX(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];LX(d,j+8|0,e,B,h,Ia);break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=de[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(bW(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=NX(e,t,h,Ia,1)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];MX(0,e,m,h,Ia);break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];AX(ua,d,v,u,g,h,j,139856,139864|0);c[Ha>>2]=c[ua>>2];break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Ha=NX(e,H,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<24){c[j+8>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];AX(ra,d,y,x,g,h,j,139848,139853|0);c[ca>>2]=c[ra>>2];break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=NX(e,G,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[ca>>2]=Ha;break a}}while(0);c[h>>2]=Da|4;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Ha=NX(e,F,h,Ia,3)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<366){c[j+28>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];AX(oa,d,A,z,g,h,j,139832,139843|0);c[ca>>2]=c[oa>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=NX(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ja=ca+2e3|0}else{Ja=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ja+ -1900;break};case 99:{ca=d+8|0;Ha=de[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Fa=a[Ha]|0;if((Fa&1)==0){Ka=Ha+1|0;La=Ha+1|0;Ma=(Fa&255)>>>1}else{Fa=c[Ha+8>>2]|0;Ka=Fa;La=Fa;Ma=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];AX(da,d,O,N,g,h,j,La,Ka+Ma|0);c[ca>>2]=c[da>>2];break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];AX(ga,d,L,K,g,h,j,139816,139824|0);c[ca>>2]=c[ga>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];KX(0,e,C,h,Ia);break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=NX(e,D,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 88:{Ha=d+8|0;ca=de[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];Fa=a[ca]|0;if((Fa&1)==0){Na=ca+1|0;Oa=ca+1|0;Pa=(Fa&255)>>>1}else{Fa=c[ca+8>>2]|0;Na=Fa;Oa=Fa;Pa=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];AX(za,d,q,p,g,h,j,Oa,Na+Pa|0);c[Ha>>2]=c[za>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Ha=NX(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Ha+ -1900;break};case 70:{Ha=e;c[ka>>2]=c[Ha>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];AX(ja,d,J,I,g,h,j,139824,139832|0);c[Ha>>2]=c[ja>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=NX(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=NX(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[ca>>2]=Ha;break a}}while(0);c[h>>2]=Fa|4;break};case 65:case 97:{Ha=c[f>>2]|0;ca=d+8|0;Da=de[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Ha;c[Q+0>>2]=c[aa+0>>2];Ha=(bW(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((Ha|0)>=168){break a}c[j+24>>2]=((Ha|0)/12|0|0)%7|0;break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];pe[Ha&63](b,d,s,r,g,h,j);i=l;return};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function KX(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((de[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(de[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){de[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((de[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((de[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function LX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=de[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=bW(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function MX(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((de[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(de[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((ge[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){de[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((de[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function NX(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((de[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(de[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(ge[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((de[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((de[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(de[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((ge[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((de[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((de[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function OX(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;gU(p,f);t=p;p=c[t>>2]|0;if(!((c[35224]|0)==-1)){c[o>>2]=140896;c[o+4>>2]=234;c[o+8>>2]=0;XS(140896,o,235)}o=(c[140900>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;W0(w);x=156464;y=128;Od(v|0,x|0,y|0)}y=p;CS(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((ge[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=de[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=se[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(se[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=ge[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=ge[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];re[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=de[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=de[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(ge[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){de[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){de[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=de[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function PX(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function QX(a){a=a|0;i=i;return}function RX(a){a=a|0;i=i;return 2}function SX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];OX(a,b,l,k,f,g,h,139960,139992|0);i=j;return}function TX(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=de[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];OX(b,d,m,l,g,h,j,s,q);i=k;return}function UX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;gU(n,f);f=n;n=c[f>>2]|0;if(!((c[35224]|0)==-1)){c[m>>2]=140896;c[m+4>>2]=234;c[m+8>>2]=0;XS(140896,m,235)}m=(c[140900>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}s=n;CS(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=AW(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function VX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;gU(n,f);f=n;n=c[f>>2]|0;if(!((c[35224]|0)==-1)){c[m>>2]=140896;c[m+4>>2]=234;c[m+8>>2]=0;XS(140896,m,235)}m=(c[140900>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;W0(q);r=156464;s=128;Od(p|0,r|0,s|0)}s=n;CS(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=de[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=AW(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function WX(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;gU(m,f);f=m;m=c[f>>2]|0;if(!((c[35224]|0)==-1)){c[l>>2]=140896;c[l+4>>2]=234;c[l+8>>2]=0;XS(140896,l,235)}l=(c[140900>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;W0(p);q=156464;r=128;Od(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;W0(p);q=156464;r=128;Od(o|0,q|0,r|0)}r=m;CS(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=$X(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function XX(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;gU(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[35224]|0)==-1)){c[ba>>2]=140896;c[ba+4>>2]=234;c[ba+8>>2]=0;XS(140896,ba,235)}ba=(c[140900>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;W0(Ga);Ha=156464;Ia=128;Od(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;W0(Ga);Ha=156464;Ia=128;Od(Fa|0,Ha|0,Ia|0)}Ia=ca;CS(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];OX(ja,d,J,I,g,h,j,140024,140056|0);c[Da>>2]=c[ja>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=$X(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=$X(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=$X(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ja=Da+2e3|0}else{Ja=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ja+ -1900;break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];OX(ua,d,v,u,g,h,j,140128,140160|0);c[Da>>2]=c[ua>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=$X(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 99:{ca=d+8|0;Da=de[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Ka=Da+4|0;La=Da+4|0;Ma=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Ka=Ha;La=Ha;Ma=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];OX(da,d,O,N,g,h,j,La,Ka+(Ma<<2)|0);c[ca>>2]=c[da>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];ZX(d,j+8|0,e,B,h,Ia);break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];OX(ra,d,y,x,g,h,j,140104,140124|0);c[ca>>2]=c[ra>>2];break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=$X(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=de[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(AW(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 104:case 66:case 98:{Da=c[f>>2]|0;Ha=d+8|0;ca=de[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(AW(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=$X(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=$X(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];YX(0,e,C,h,Ia);break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=$X(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];OX(oa,d,A,z,g,h,j,140056,140100|0);c[Da>>2]=c[oa>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];_X(0,e,m,h,Ia);break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];OX(ga,d,L,K,g,h,j,139992,140024|0);c[Da>>2]=c[ga>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=$X(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 88:{ca=d+8|0;Da=de[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Fa=a[Da]|0;if((Fa&1)==0){Na=Da+4|0;Oa=Da+4|0;Pa=(Fa&255)>>>1}else{Fa=c[Da+8>>2]|0;Na=Fa;Oa=Fa;Pa=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];OX(za,d,q,p,g,h,j,Oa,Na+(Pa<<2)|0);c[ca>>2]=c[za>>2];break};case 101:case 100:{ca=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=$X(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];pe[Da&63](b,d,s,r,g,h,j);i=l;return};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function YX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(ge[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){de[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=de[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=de[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function ZX(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=de[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=AW(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}



function Ov(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=Gv(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 29:{if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Gv(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};case 29:{if((c[58552+((d[59832+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 10:case 9:case 21:{p=37;break b;break};case 6:{p=31;break b;break};case 15:{p=62;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Rv(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=Gv(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Rv(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Pv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Gv(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 11:{n=48;break b;break};case 29:{if((c[58552+((d[59832+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 23:{b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 10:case 9:case 21:{n=37;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Gv(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Qv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=Gv(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 6:{l=13;break a;break};case 7:{l=16;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 14:{break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=Gv(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 29:{if((c[58552+((d[59832+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=Gv(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 6:{l=33;break a;break};case 5:{l=30;break a;break};case 7:{l=36;break a;break};case 24:case 22:{break};case 29:{if((c[58552+((d[58296+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 5:{l=10;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Gv(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=Gv(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 2:{l=79;break a;break};case 3:{t=Hv(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=Gv(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=Gv(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 29:{l=94;break d;break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};case 7:{l=103;break a;break};case 11:{l=106;break a;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[58552+((d[58296+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Rv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Sv(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=Gv(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=Gv(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Tv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=Mv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Gv(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Gv(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Uv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Gv(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[58552+((d[59832+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Vv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 19:{k=xw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=Gv(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 16:{k=ww(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=rw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=Gv(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=lw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 29:{g=b;if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[58552+((d[59832+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 12:{k=vw(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 13:{k=vw(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=Gv(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=Gv(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 15:{o=122;break b;break};case 6:{o=88;break b;break};case 5:{o=85;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=Gv(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 29:{if((c[58552+((d[59832+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=103;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=105;break b;break};case 7:{o=111;break b;break};case 6:{o=108;break b;break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[58552+((d[59832+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=83;break b}break};case 34:{o=116;break b;break};case 33:{o=119;break b;break};case 7:{o=91;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function Wv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Gv(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 2:{k=ow(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=kw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Gv(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Xv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Gv(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Gv(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{r=b;if((e-b|0)<3){p=50;break b}b=r+3|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Yv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=Gv(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Zv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Gv(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 2:{n=15;break a;break};case 9:{n=19;break a;break};case 10:{n=16;break a;break};case 7:{b=b+4|0;continue a;break};case 21:{n=29;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=kw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Gv(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function _v(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Gv(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 10:{n=18;break a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=21;break a;break};case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=kw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=lw(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Gv(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function $v(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=Gv(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=Gv(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function aw(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function bw(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=Gv(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};default:{break a}}}i=e;return b-c|0}function cw(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=Gv(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function dw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=Gv(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Gv(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function ew(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Uu(c)|0;k=j;i=b;return k|0}function fw(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function gw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Gv(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Gv(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 7:{b=b+4|0;break};case 5:{b=b+2|0;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function hw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Gv(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function iw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function jw(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function kw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=mw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Gv(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 29:{if((c[58552+((d[59832+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function lw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 29:{if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Gv(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 29:{if((c[58552+((d[59832+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function mw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=nw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Gv(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function nw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Gv(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Gv(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function ow(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Gv(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=qw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=pw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=sw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=rw(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=Gv(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{o=42;break b;break};case 11:{o=90;break b;break};case 17:{break b;break};case 10:case 9:case 21:{o=69;break b;break};case 5:{o=39;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Gv(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 24:case 22:{break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};case 7:{o=65;break b;break};case 29:{if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=45;break b;break};case 29:{if((c[58552+((d[59832+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=Gv(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 24:case 22:{break d;break};case 17:{break c;break};case 5:{o=78;break d;break};case 10:case 9:case 21:{break};case 6:{o=81;break d;break};case 29:{o=75;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=tw(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function pw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Gv(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function qw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[60872+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function rw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=Gv(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Gv(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{p=62;break b;break};case 29:{if((c[58552+((d[59832+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};case 6:{p=31;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((uw(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=Gv(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((uw(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function sw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Gv(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};case 29:{if((c[58552+((d[59832+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 7:{n=34;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Gv(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function tw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=Gv(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=Gv(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 14:{break};case 6:{l=13;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){p=d[k+76+(d[o+1|0]|0)|0]|0}else{p=Gv(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(p|0){case 5:{l=30;break a;break};case 24:case 22:{break};case 29:{if((c[58552+((d[58296+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 7:{l=16;break a;break};case 5:{l=10;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 29:{if((c[58552+((d[59832+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Gv(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[o+1|0]|0)|0]|0}else{s=Gv(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 2:{l=79;break a;break};case 3:{t=kw(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 8:case 1:case 0:{l=74;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[o+1|0]|0)|0]|0}else{u=Gv(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[o+1|0]|0)|0]|0}else{v=Gv(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 29:{l=94;break d;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 24:case 22:{break d;break};case 5:{l=97;break a;break};case 7:{l=103;break a;break};case 17:{l=107;break a;break};case 6:{l=100;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[58552+((d[58296+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function uw(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function vw(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=Gv(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=Gv(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function ww(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Gv(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Gv(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=pw(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function xw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Gv(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[58552+((d[58296+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Gv(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[58552+((d[59832+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function yw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 12:{k=gx(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 19:{k=ix(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((se[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((se[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((se[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((se[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{k=cx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=hx(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{n=15;break};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 30:{k=Yw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((se[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((se[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 13:{k=gx(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){n=82;break b}p=b;if((se[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=p+4|0;continue b;break};case 29:{n=69;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){n=72;break b}q=b;if((se[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=q+2|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){n=104;break b}r=b;if((se[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=r+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{n=91;break b;break};case 5:{if((e-b|0)<2){n=94;break b}s=b;if((se[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=s+2|0;continue b;break};case 6:{if((e-b|0)<3){n=99;break b}t=b;if((se[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=t+3|0;continue b;break};default:{m=19;continue b}}break};case 15:{n=116;break b;break};case 33:{n=113;break b;break};case 6:{if((e-b|0)<3){n=77;break b}u=b;if((se[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=u+3|0;continue b;break};case 34:{n=110;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==110){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){r=b;if((m|0)==19){c[f>>2]=r;k=0;l=k;i=h;return l|0}else{c[f>>2]=r+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function zw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 2:{k=$w(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=Xw(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((se[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 7:{if((e-b|0)<4){n=49;break b}if((se[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((se[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Aw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((se[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 5:{if((e-b|0)<2){n=39;break b}if((se[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((se[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((se[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Bw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((se[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((se[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((se[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 2:{o=b+1|0;b=o;if((o|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}o=b+1|0;b=o;if((o|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 4:{o=b+1|0;b=o;if((o|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}o=b+1|0;b=o;if((o|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function Cw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 21:{m=23;break a;break};case 3:{m=9;break a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 9:{m=16;break a;break};case 5:{a=a+2|0;continue a;break};case 2:{m=12;break a;break};case 10:{m=13;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Xw(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Dw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 3:{m=9;break a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 10:{m=15;break a;break};case 5:{a=a+2|0;continue a;break};case 30:{m=12;break a;break};case 9:{m=18;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Xw(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Yw(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Ew(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 6:{j=5;break};case 5:{break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function Fw(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function Gw(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};default:{break a}}}i=c;return a-b|0}function Hw(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function Iw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function Jw(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Uu(c)|0;g=f;i=b;return g|0}function Kw(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==103){f=62;g=f;i=b;return g|0}else if((d|0)==108){f=60;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function Lw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 5:{a=a+2|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};case 6:{a=a+3|0;break};case 7:{a=a+4|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function Mw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function Nw(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Ow(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function Pw(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[58552+(((d[59832+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Qw(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[58552+(((d[59832+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Rw(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function Sw(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[58552+(((d[58296+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Tw(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[58552+(((d[58296+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Uw(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Vw(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Ww(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function Xw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=Zw(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 29:{l=25;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Yw(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((se[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=33;break b}m=a;if((se[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=m+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((se[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 18:{l=42;break b;break};case 29:{l=25;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=28;break b}o=a;if((se[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=o+2|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Zw(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=_w(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}



function _X(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=de[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=de[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((ge[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){de[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=de[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=de[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function $X(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=de[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=de[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=de[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(ge[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(ge[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){de[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=de[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=de[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(ge[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((ge[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){de[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=de[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=de[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function aY(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);if((f|0)==(c[35198]|0)){g=b;x1(g);i=d;return}ac(c[e>>2]|0);g=b;x1(g);i=d;return}function bY(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);if((b|0)==(c[35198]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function cY(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Sc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(se[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function dY(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);if((f|0)==(c[35198]|0)){g=b;x1(g);i=d;return}ac(c[e>>2]|0);g=b;x1(g);i=d;return}function eY(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);if((b|0)==(c[35198]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function fY(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;gY(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=se[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function gY(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Sc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Lc(c[g>>2]|0)|0;g=s0(d,m,n,l)|0;if((f|0)!=0){Lc(f|0)|0}if((g|0)==-1){cZ(141784)}else{c[e>>2]=d+(g<<2);i=j;return}}function hY(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function iY(a){a=a|0;i=i;return}function jY(a){a=a|0;i=i;return 127}function kY(a){a=a|0;i=i;return 127}function lY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function mY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function nY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function oY(a,b){a=a|0;b=b|0;b=i;gT(a,1,45);i=b;return}function pY(a){a=a|0;i=i;return 0}function qY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function rY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function sY(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function tY(a){a=a|0;i=i;return}function uY(a){a=a|0;i=i;return 127}function vY(a){a=a|0;i=i;return 127}function wY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function xY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function yY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function zY(a,b){a=a|0;b=b|0;b=i;gT(a,1,45);i=b;return}function AY(a){a=a|0;i=i;return 0}function BY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function CY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function DY(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function EY(a){a=a|0;i=i;return}function FY(a){a=a|0;i=i;return 2147483647}function GY(a){a=a|0;i=i;return 2147483647}function HY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function IY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function JY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function KY(a,b){a=a|0;b=b|0;b=i;NT(a,1,45);i=b;return}function LY(a){a=a|0;i=i;return 0}function MY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function NY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function OY(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function PY(a){a=a|0;i=i;return}function QY(a){a=a|0;i=i;return 2147483647}function RY(a){a=a|0;i=i;return 2147483647}function SY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function TY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function UY(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function VY(a,b){a=a|0;b=b|0;b=i;NT(a,1,45);i=b;return}function WY(a){a=a|0;i=i;return 0}function XY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function YY(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function ZY(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function _Y(a){a=a|0;i=i;return}function $Y(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=236;y=o+100|0;gU(r,h);o=r;z=c[o>>2]|0;if(!((c[35226]|0)==-1)){c[n>>2]=140904;c[n+4>>2]=234;c[n+8>>2]=0;XS(140904,n,235)}n=(c[140908>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;W0(C);D=156464;E=128;Od(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;W0(C);D=156464;E=128;Od(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=bZ(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ce[c[(c[z>>2]|0)+32>>2]&63](E,140520,140530|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=p1(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}C1()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[140520+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((td(p|0,140536,m|0)|0)!=1){t=Ec(8)|0;IS(t,140544);Od(t|0,137896,43)}if((F|0)==0){break}q1(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;CS(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ae[c[x>>2]&255](o);i=d;return}function aZ(a){a=a|0;i=i;return}function bZ(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;fZ(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=236;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((de[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 3:{W=a[y]|0;ba=(W&1)==0;if(ba){ca=(W&255)>>>1}else{ca=c[G>>2]|0}da=a[z]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[g>>2]|0}if((ca|0)==(0-fa|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}if(ba){ma=(W&255)>>>1}else{ma=c[G>>2]|0}do{if((ma|0)!=0){if(ea){na=(da&255)>>>1}else{na=c[g>>2]|0}if((na|0)==0){break}oa=c[h>>2]|0;pa=c[oa+12>>2]|0;qa=c[oa+16>>2]|0;if((pa|0)==(qa|0)){ra=(de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255;sa=c[h>>2]|0;ta=ra;ua=c[sa+16>>2]|0;va=c[sa+12>>2]|0;wa=sa;xa=a[y]|0}else{ta=a[pa]|0;ua=qa;va=pa;wa=oa;xa=W}oa=wa+12|0;pa=(va|0)==(ua|0);if(ta<<24>>24==(a[(xa&1)==0?F:c[H>>2]|0]|0)){if(pa){de[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[oa>>2]=va+1}oa=a[y]|0;if((oa&1)==0){ya=(oa&255)>>>1}else{ya=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=ya>>>0>1?y:S;la=T;break b}if(pa){za=(de[c[(c[wa>>2]|0)+36>>2]&127](wa)|0)&255}else{za=a[va]|0}if(!(za<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}pa=c[h>>2]|0;oa=pa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){de[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[oa>>2]=qa+1}a[l]=1;qa=a[z]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Aa>>>0>1?z:S;la=T;break b}}while(0);if(ba){Ba=(W&255)>>>1}else{Ba=c[G>>2]|0}ea=c[h>>2]|0;qa=c[ea+12>>2]|0;oa=(qa|0)==(c[ea+16>>2]|0);if((Ba|0)==0){if(oa){pa=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Ca=pa;Da=a[z]|0}else{Ca=a[qa]|0;Da=da}if(!(Ca<<24>>24==(a[(Da&1)==0?m:c[E>>2]|0]|0))){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){de[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[sa>>2]=ra+1}a[l]=1;ra=a[z]|0;if((ra&1)==0){Ea=(ra&255)>>>1}else{Ea=c[g>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ea>>>0>1?z:S;la=T;break b}if(oa){oa=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255;Fa=oa;Ga=a[y]|0}else{Fa=a[qa]|0;Ga=W}if(!(Fa<<24>>24==(a[(Ga&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=c[h>>2]|0;oa=qa+12|0;ea=c[oa>>2]|0;if((ea|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=ea+1}ea=a[y]|0;if((ea&1)==0){Ha=(ea&255)>>>1}else{Ha=c[G>>2]|0}ga=D;ha=R;ia=r;ja=Q;ka=Ha>>>0>1?y:S;la=T;break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ea=c[h>>2]|0;oa=c[ea+12>>2]|0;if((oa|0)==(c[ea+16>>2]|0)){Ia=(de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{Ia=a[oa]|0}if(!(Ia<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Ia<<24>>24<<1)>>1]&8192)==0){X=25;break a}oa=c[h>>2]|0;ea=oa+12|0;qa=c[ea>>2]|0;if((qa|0)==(c[oa+16>>2]|0)){Ja=(de[c[(c[oa>>2]|0)+40>>2]&127](oa)|0)&255}else{c[ea>>2]=qa+1;Ja=a[qa]|0}CT(A,Ja);X=26;break};case 4:{qa=D;ea=R;oa=r;ra=Q;sa=0;pa=T;c:while(1){Ka=c[h>>2]|0;do{if((Ka|0)==0){La=0}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){La=Ka;break}if((de[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[h>>2]=0;La=0;break}else{La=c[h>>2]|0;break}}}while(0);Ka=(La|0)==0;Ma=c[e>>2]|0;do{if((Ma|0)==0){X=173}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(Ka){break}else{break c}}if((de[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ka){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(Ka){break}}Ma=c[h>>2]|0;Na=c[Ma+12>>2]|0;if((Na|0)==(c[Ma+16>>2]|0)){Oa=(de[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)&255}else{Oa=a[Na]|0}do{if(Oa<<24>>24>-1){if((b[(c[f>>2]|0)+(Oa<<24>>24<<1)>>1]&2048)==0){X=189;break}Na=c[o>>2]|0;if((Na|0)==(qa|0)){Ma=(c[P>>2]|0)!=236;Pa=c[t>>2]|0;Qa=qa-Pa|0;Ra=Qa>>>0<2147483647?Qa<<1:-1;Sa=s1(Ma?Pa:0,Ra)|0;if((Sa|0)==0){X=182;break a}do{if(Ma){c[t>>2]=Sa;Ta=Sa}else{Pa=c[t>>2]|0;c[t>>2]=Sa;if((Pa|0)==0){Ta=Sa;break}ae[c[P>>2]&255](Pa);Ta=c[t>>2]|0}}while(0);c[P>>2]=211;Sa=Ta+Qa|0;c[o>>2]=Sa;Ua=Sa;Va=(c[t>>2]|0)+Ra|0}else{Ua=Na;Va=qa}c[o>>2]=Ua+1;a[Ua]=Oa;Wa=Va;Xa=ea;Ya=oa;Za=ra;_a=sa+1|0;$a=pa}else{X=189}}while(0);if((X|0)==189){X=0;Ka=a[w]|0;if((Ka&1)==0){ab=(Ka&255)>>>1}else{ab=c[n>>2]|0}if((ab|0)==0|(sa|0)==0){break}if(!(Oa<<24>>24==(a[v]|0))){break}if((oa|0)==(ra|0)){Ka=oa-ea|0;Sa=Ka>>>0<2147483647?Ka<<1:-1;if((pa|0)==236){bb=0}else{bb=ea}Ma=s1(bb,Sa)|0;if((Ma|0)==0){X=198;break a}cb=Ma;db=Ma+(Ka>>2<<2)|0;eb=Ma+(Sa>>>2<<2)|0;fb=211}else{cb=ea;db=oa;eb=ra;fb=pa}c[db>>2]=sa;Wa=qa;Xa=cb;Ya=db+4|0;Za=eb;_a=0;$a=fb}Sa=c[h>>2]|0;Ma=Sa+12|0;Ka=c[Ma>>2]|0;if((Ka|0)==(c[Sa+16>>2]|0)){de[c[(c[Sa>>2]|0)+40>>2]&127](Sa)|0;qa=Wa;ea=Xa;oa=Ya;ra=Za;sa=_a;pa=$a;continue}else{c[Ma>>2]=Ka+1;qa=Wa;ea=Xa;oa=Ya;ra=Za;sa=_a;pa=$a;continue}}if((ea|0)==(oa|0)|(sa|0)==0){gb=ea;hb=oa;ib=ra;jb=pa}else{if((oa|0)==(ra|0)){W=oa-ea|0;da=W>>>0<2147483647?W<<1:-1;if((pa|0)==236){kb=0}else{kb=ea}ba=s1(kb,da)|0;if((ba|0)==0){X=209;break a}lb=ba;mb=ba+(W>>2<<2)|0;nb=ba+(da>>>2<<2)|0;ob=211}else{lb=ea;mb=oa;nb=ra;ob=pa}c[mb>>2]=sa;gb=lb;hb=mb+4|0;ib=nb;jb=ob}if((c[B>>2]|0)>0){da=c[h>>2]|0;do{if((da|0)==0){pb=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){pb=da;break}if((de[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;pb=0;break}else{pb=c[h>>2]|0;break}}}while(0);da=(pb|0)==0;sa=c[e>>2]|0;do{if((sa|0)==0){X=223}else{if((c[sa+12>>2]|0)!=(c[sa+16>>2]|0)){if(da){qb=sa;break}else{X=229;break a}}if((de[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)==-1){c[e>>2]=0;X=223;break}else{if(da){qb=sa;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(da){X=229;break a}else{qb=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){rb=(de[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{rb=a[pa]|0}if(!(rb<<24>>24==(a[u]|0))){X=229;break a}pa=c[h>>2]|0;sa=pa+12|0;ra=c[sa>>2]|0;if((ra|0)==(c[pa+16>>2]|0)){de[c[(c[pa>>2]|0)+40>>2]&127](pa)|0;sb=qb;tb=qb;ub=qa}else{c[sa>>2]=ra+1;sb=qb;tb=qb;ub=qa}while(1){ra=c[h>>2]|0;do{if((ra|0)==0){vb=0}else{if((c[ra+12>>2]|0)!=(c[ra+16>>2]|0)){vb=ra;break}if((de[c[(c[ra>>2]|0)+36>>2]&127](ra)|0)==-1){c[h>>2]=0;vb=0;break}else{vb=c[h>>2]|0;break}}}while(0);ra=(vb|0)==0;do{if((tb|0)==0){wb=sb;X=243}else{if((c[tb+12>>2]|0)!=(c[tb+16>>2]|0)){if(ra){xb=sb;yb=tb;break}else{X=250;break a}}if((de[c[(c[tb>>2]|0)+36>>2]&127](tb)|0)==-1){c[e>>2]=0;wb=0;X=243;break}else{if(ra^(sb|0)==0){xb=sb;yb=sb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ra){X=250;break a}else{xb=wb;yb=0}}sa=c[h>>2]|0;pa=c[sa+12>>2]|0;if((pa|0)==(c[sa+16>>2]|0)){zb=(de[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{zb=a[pa]|0}if(!(zb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(zb<<24>>24<<1)>>1]&2048)==0){X=250;break a}pa=c[o>>2]|0;if((pa|0)==(ub|0)){sa=(c[P>>2]|0)!=236;oa=c[t>>2]|0;ea=ub-oa|0;ba=ea>>>0<2147483647?ea<<1:-1;W=s1(sa?oa:0,ba)|0;if((W|0)==0){X=253;break a}do{if(sa){c[t>>2]=W;Ab=W}else{oa=c[t>>2]|0;c[t>>2]=W;if((oa|0)==0){Ab=W;break}ae[c[P>>2]&255](oa);Ab=c[t>>2]|0}}while(0);c[P>>2]=211;W=Ab+ea|0;c[o>>2]=W;Bb=W;Cb=(c[t>>2]|0)+ba|0}else{Bb=pa;Cb=ub}W=c[h>>2]|0;sa=c[W+12>>2]|0;if((sa|0)==(c[W+16>>2]|0)){ra=(de[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255;Db=ra;Eb=c[o>>2]|0}else{Db=a[sa]|0;Eb=Bb}c[o>>2]=Eb+1;a[Eb]=Db;sa=(c[B>>2]|0)+ -1|0;c[B>>2]=sa;ra=c[h>>2]|0;W=ra+12|0;oa=c[W>>2]|0;if((oa|0)==(c[ra+16>>2]|0)){de[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[W>>2]=oa+1}if((sa|0)>0){sb=xb;tb=yb;ub=Cb}else{Fb=Cb;break}}}else{Fb=qa}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ga=Fb;ha=gb;ia=hb;ja=ib;ka=S;la=jb}break};case 0:{X=26;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Gb=(a[O]|0)!=0}else{Gb=0}if(!(I|Gb)){ga=D;ha=R;ia=r;ja=Q;ka=0;la=T;break b}}da=a[x]|0;sa=(da&1)==0;oa=sa?j:c[J>>2]|0;d:do{if((p|0)==0){Hb=Y;Ib=Y;Jb=da;Kb=oa}else{if((d[s+(p+ -1)|0]|0)>=2){Hb=Y;Ib=Y;Jb=da;Kb=oa;break}W=oa+(sa?(da&255)>>>1:c[K>>2]|0)|0;ra=oa;while(1){if((ra|0)==(W|0)){Lb=W;break}Ka=a[ra]|0;if(!(Ka<<24>>24>-1)){Lb=ra;break}if((b[(c[f>>2]|0)+(Ka<<24>>24<<1)>>1]&8192)==0){Lb=ra;break}else{ra=ra+1|0}}ra=Lb-oa|0;W=a[A]|0;pa=(W&1)==0;if(pa){Mb=(W&255)>>>1}else{Mb=c[N>>2]|0}if(ra>>>0>Mb>>>0){Hb=Y;Ib=Y;Jb=da;Kb=oa;break}if(pa){pa=(W&255)>>>1;Nb=A+1+(pa-ra)|0;Ob=L;Pb=pa}else{pa=c[M>>2]|0;W=c[N>>2]|0;Nb=pa+(W-ra)|0;Ob=pa;Pb=W}W=Ob+Pb|0;if((Nb|0)==(W|0)){Hb=Y;Ib=Y;Jb=da;Kb=Lb;break}else{Qb=oa;Rb=Nb}while(1){if((a[Rb]|0)!=(a[Qb]|0)){Hb=Y;Ib=Y;Jb=da;Kb=oa;break d}pa=Rb+1|0;if((pa|0)==(W|0)){Hb=Y;Ib=Y;Jb=da;Kb=Lb;break}else{Qb=Qb+1|0;Rb=pa}}}}while(0);e:while(1){if((Jb&1)==0){Sb=j;Tb=(Jb&255)>>>1}else{Sb=c[J>>2]|0;Tb=c[K>>2]|0}if((Kb|0)==(Sb+Tb|0)){break}da=c[h>>2]|0;do{if((da|0)==0){Ub=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Ub=da;break}if((de[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Ub=0;break}else{Ub=c[h>>2]|0;break}}}while(0);da=(Ub|0)==0;do{if((Ib|0)==0){Vb=Hb;X=147}else{if((c[Ib+12>>2]|0)!=(c[Ib+16>>2]|0)){if(da){Wb=Hb;Xb=Ib;break}else{break e}}if((de[c[(c[Ib>>2]|0)+36>>2]&127](Ib)|0)==-1){c[e>>2]=0;Vb=0;X=147;break}else{if(da^(Hb|0)==0){Wb=Hb;Xb=Hb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(da){break}else{Wb=Vb;Xb=0}}oa=c[h>>2]|0;sa=c[oa+12>>2]|0;if((sa|0)==(c[oa+16>>2]|0)){Yb=(de[c[(c[oa>>2]|0)+36>>2]&127](oa)|0)&255}else{Yb=a[sa]|0}if(!(Yb<<24>>24==(a[Kb]|0))){break}sa=c[h>>2]|0;oa=sa+12|0;qa=c[oa>>2]|0;if((qa|0)==(c[sa+16>>2]|0)){de[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[oa>>2]=qa+1}Hb=Wb;Ib=Xb;Jb=a[x]|0;Kb=Kb+1|0}if(!I){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break b}qa=a[x]|0;if((qa&1)==0){Zb=j;_b=(qa&255)>>>1}else{Zb=c[J>>2]|0;_b=c[K>>2]|0}if((Kb|0)==(Zb+_b|0)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}else{X=162;break a}break};default:{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}if((de[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}else{dc=cc;ec=0}}da=c[h>>2]|0;qa=c[da+12>>2]|0;if((qa|0)==(c[da+16>>2]|0)){fc=(de[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255}else{fc=a[qa]|0}if(!(fc<<24>>24>-1)){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ga=D;ha=R;ia=r;ja=Q;ka=S;la=T;break f}qa=c[h>>2]|0;da=qa+12|0;oa=c[da>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){gc=(de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0)&255}else{c[da>>2]=oa+1;gc=a[oa]|0}CT(A,gc);$b=dc;ac=ec}}}while(0);oa=p+1|0;if(oa>>>0<4){Q=ja;r=ia;R=ha;D=ga;p=oa;S=ka;T=la}else{Z=ha;_=ia;$=ka;aa=la;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){C1()}else if((X|0)==198){C1()}else if((X|0)==209){C1()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==253){C1()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==269){h:do{if(($|0)!=0){la=$+1|0;ka=$+8|0;ia=$+4|0;ha=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ia>>2]|0}if(!(ha>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((de[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((de[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(de[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=la}else{nc=c[ka>>2]|0}if(!(mc<<24>>24==(a[nc+ha|0]|0))){break}p=ha+1|0;U=c[h>>2]|0;ga=U+12|0;D=c[ga>>2]|0;if((D|0)==(c[U+16>>2]|0)){de[c[(c[U>>2]|0)+40>>2]&127](U)|0;ha=p;continue}else{c[ga>>2]=D+1;ha=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;gZ(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);kT(A);kT(z);kT(y);kT(x);kT(w);if((ic|0)==0){i=q;return hc|0}ae[jc&255](ic);i=q;return hc|0}function cZ(a){a=a|0;var b=0;b=Ec(8)|0;IS(b,a);Od(b|0,137896,43)}function dZ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=236;v=n+100|0;gU(q,h);n=q;w=c[n>>2]|0;if(!((c[35226]|0)==-1)){c[m>>2]=140904;c[m+4>>2]=234;c[m+8>>2]=0;XS(140904,m,235)}m=(c[140908>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;W0(z);A=156464;B=128;Od(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;W0(z);A=156464;B=128;Od(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=bZ(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){CT(k,se[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=se[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);eZ(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((de[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((de[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;CS(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ae[c[u>>2]&255](n);i=d;return}function eZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){FT(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function fZ(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[35086]|0)==-1)){c[p>>2]=140344;c[p+4>>2]=234;c[p+8>>2]=0;XS(140344,p,235)}p=(c[140348>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;W0(C);D=156464;E=128;Od(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;W0(C);D=156464;E=128;Od(B|0,D|0,E|0)}E=b;be[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;be[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}wT(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;kT(r);be[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}wT(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;kT(s);a[f]=de[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=de[c[(c[b>>2]|0)+16>>2]&127](E)|0;be[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}wT(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;kT(t);be[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}wT(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;kT(u);F=de[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[35070]|0)==-1)){c[o>>2]=140280;c[o+4>>2]=234;c[o+8>>2]=0;XS(140280,o,235)}o=(c[140284>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;W0(H);I=156464;J=128;Od(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;W0(H);I=156464;J=128;Od(G|0,I|0,J|0)}J=E;be[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;be[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}wT(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;kT(w);be[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}wT(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;kT(x);a[f]=de[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=de[c[(c[E>>2]|0)+16>>2]&127](J)|0;be[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}wT(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;kT(y);be[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}wT(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;kT(z);F=de[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function gZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function hZ(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function iZ(a){a=a|0;i=i;return}function jZ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=236;y=o+400|0;gU(r,h);o=r;z=c[o>>2]|0;if(!((c[35224]|0)==-1)){c[n>>2]=140896;c[n+4>>2]=234;c[n+8>>2]=0;XS(140896,n,235)}n=(c[140900>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;W0(C);D=156464;E=128;Od(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;W0(C);D=156464;E=128;Od(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=kZ(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ce[c[(c[z>>2]|0)+48>>2]&63](E,140600,140610|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=p1((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}C1()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[140600+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((td(p|0,140536,m|0)|0)!=1){t=Ec(8)|0;IS(t,140544);Od(t|0,137896,43)}if((F|0)==0){break}q1(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=de[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];CS(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}ae[c[x>>2]&255](o);i=d;return}function kZ(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;nZ(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=236;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 0:{T=28;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=de[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}ST(A,aa);T=28;break};case 3:{$=a[y]|0;P=($&1)==0;if(P){ba=($&255)>>>1}else{ba=c[D>>2]|0}R=a[z]|0;ca=(R&1)==0;if(ca){da=(R&255)>>>1}else{da=c[e>>2]|0}if((ba|0)==(0-da|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break b}if(P){ja=($&255)>>>1}else{ja=c[D>>2]|0}do{if((ja|0)!=0){if(ca){ka=(R&255)>>>1}else{ka=c[e>>2]|0}if((ka|0)==0){break}la=c[g>>2]|0;ma=c[la+12>>2]|0;if((ma|0)==(c[la+16>>2]|0)){na=de[c[(c[la>>2]|0)+36>>2]&127](la)|0;oa=na;pa=a[y]|0}else{oa=c[ma>>2]|0;pa=$}ma=c[g>>2]|0;na=ma+12|0;la=c[na>>2]|0;qa=(la|0)==(c[ma+16>>2]|0);if((oa|0)==(c[((pa&1)==0?D:c[E>>2]|0)>>2]|0)){if(qa){de[c[(c[ma>>2]|0)+40>>2]&127](ma)|0}else{c[na>>2]=la+4}na=a[y]|0;if((na&1)==0){ra=(na&255)>>>1}else{ra=c[D>>2]|0}ea=M;fa=r;ga=L;ha=ra>>>0>1?y:N;ia=O;break b}if(qa){sa=de[c[(c[ma>>2]|0)+36>>2]&127](ma)|0}else{sa=c[la>>2]|0}if((sa|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}la=c[g>>2]|0;ma=la+12|0;qa=c[ma>>2]|0;if((qa|0)==(c[la+16>>2]|0)){de[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[ma>>2]=qa+4}a[k]=1;qa=a[z]|0;if((qa&1)==0){ta=(qa&255)>>>1}else{ta=c[e>>2]|0}ea=M;fa=r;ga=L;ha=ta>>>0>1?z:N;ia=O;break b}}while(0);if(P){ua=($&255)>>>1}else{ua=c[D>>2]|0}ca=c[g>>2]|0;qa=c[ca+12>>2]|0;ma=(qa|0)==(c[ca+16>>2]|0);if((ua|0)==0){if(ma){la=de[c[(c[ca>>2]|0)+36>>2]&127](ca)|0;va=la;wa=a[z]|0}else{va=c[qa>>2]|0;wa=R}if((va|0)!=(c[((wa&1)==0?e:c[f>>2]|0)>>2]|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break b}la=c[g>>2]|0;na=la+12|0;xa=c[na>>2]|0;if((xa|0)==(c[la+16>>2]|0)){de[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[na>>2]=xa+4}a[k]=1;xa=a[z]|0;if((xa&1)==0){ya=(xa&255)>>>1}else{ya=c[e>>2]|0}ea=M;fa=r;ga=L;ha=ya>>>0>1?z:N;ia=O;break b}if(ma){ma=de[c[(c[ca>>2]|0)+36>>2]&127](ca)|0;za=ma;Aa=a[y]|0}else{za=c[qa>>2]|0;Aa=$}if((za|0)!=(c[((Aa&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;ea=M;fa=r;ga=L;ha=N;ia=O;break b}qa=c[g>>2]|0;ma=qa+12|0;ca=c[ma>>2]|0;if((ca|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[ma>>2]=ca+4}ca=a[y]|0;if((ca&1)==0){Ba=(ca&255)>>>1}else{Ba=c[D>>2]|0}ea=M;fa=r;ga=L;ha=Ba>>>0>1?y:N;ia=O;break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){Ca=(a[J]|0)!=0}else{Ca=0}if(!(F|Ca)){ea=M;fa=r;ga=L;ha=0;ia=O;break b}}ca=a[x]|0;ma=(ca&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){Da=V;Ea=V;Fa=ca;Ga=ma}else{if((d[s+(o+ -1)|0]|0)<2){Ha=ca;Ia=ma}else{Da=V;Ea=V;Fa=ca;Ga=ma;break}while(1){if((Ha&1)==0){Ja=h;Ka=(Ha&255)>>>1}else{Ja=c[G>>2]|0;Ka=c[h>>2]|0}if((Ia|0)==(Ja+(Ka<<2)|0)){La=Ha;break}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[Ia>>2]|0)|0)){T=129;break}Ha=a[x]|0;Ia=Ia+4|0}if((T|0)==129){T=0;La=a[x]|0}qa=(La&1)==0;xa=Ia-(qa?h:c[G>>2]|0)>>2;na=a[A]|0;la=(na&1)==0;if(la){Ma=(na&255)>>>1}else{Ma=c[H>>2]|0}d:do{if(!(xa>>>0>Ma>>>0)){if(la){Na=H+(((na&255)>>>1)-xa<<2)|0;Oa=H;Pa=(na&255)>>>1}else{Qa=c[I>>2]|0;Ra=c[H>>2]|0;Na=Qa+(Ra-xa<<2)|0;Oa=Qa;Pa=Ra}Ra=Oa+(Pa<<2)|0;if((Na|0)==(Ra|0)){Da=V;Ea=V;Fa=La;Ga=Ia;break c}else{Sa=qa?h:c[G>>2]|0;Ta=Na}while(1){if((c[Ta>>2]|0)!=(c[Sa>>2]|0)){break d}Qa=Ta+4|0;if((Qa|0)==(Ra|0)){Da=V;Ea=V;Fa=La;Ga=Ia;break c}Sa=Sa+4|0;Ta=Qa}}}while(0);Da=V;Ea=V;Fa=La;Ga=qa?h:c[G>>2]|0}}while(0);e:while(1){if((Fa&1)==0){Ua=h;Va=(Fa&255)>>>1}else{Ua=c[G>>2]|0;Va=c[h>>2]|0}if((Ga|0)==(Ua+(Va<<2)|0)){break}ma=c[g>>2]|0;do{if((ma|0)==0){Wa=1}else{ca=c[ma+12>>2]|0;if((ca|0)==(c[ma+16>>2]|0)){Xa=de[c[(c[ma>>2]|0)+36>>2]&127](ma)|0}else{Xa=c[ca>>2]|0}if((Xa|0)==-1){c[g>>2]=0;Wa=1;break}else{Wa=(c[g>>2]|0)==0;break}}}while(0);do{if((Ea|0)==0){Ya=Da;T=159}else{ma=c[Ea+12>>2]|0;if((ma|0)==(c[Ea+16>>2]|0)){Za=de[c[(c[Ea>>2]|0)+36>>2]&127](Ea)|0}else{Za=c[ma>>2]|0}if((Za|0)==-1){c[b>>2]=0;Ya=0;T=159;break}else{if(Wa^(Da|0)==0){_a=Da;$a=Da;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Wa){break}else{_a=Ya;$a=0}}ma=c[g>>2]|0;qa=c[ma+12>>2]|0;if((qa|0)==(c[ma+16>>2]|0)){ab=de[c[(c[ma>>2]|0)+36>>2]&127](ma)|0}else{ab=c[qa>>2]|0}if((ab|0)!=(c[Ga>>2]|0)){break}qa=c[g>>2]|0;ma=qa+12|0;ca=c[ma>>2]|0;if((ca|0)==(c[qa+16>>2]|0)){de[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[ma>>2]=ca+4}Da=_a;Ea=$a;Fa=a[x]|0;Ga=Ga+4|0}if(!F){ea=M;fa=r;ga=L;ha=N;ia=O;break b}ca=a[x]|0;if((ca&1)==0){bb=h;cb=(ca&255)>>>1}else{bb=c[G>>2]|0;cb=c[h>>2]|0}if((Ga|0)==(bb+(cb<<2)|0)){ea=M;fa=r;ga=L;ha=N;ia=O}else{T=174;break a}break};case 4:{ca=M;ma=r;qa=L;$=0;R=O;f:while(1){P=c[g>>2]|0;do{if((P|0)==0){db=1}else{xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){eb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{eb=c[xa>>2]|0}if((eb|0)==-1){c[g>>2]=0;db=1;break}else{db=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=188}else{xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){fb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{fb=c[xa>>2]|0}if((fb|0)==-1){c[b>>2]=0;T=188;break}else{if(db){break}else{break f}}}}while(0);if((T|0)==188){T=0;if(db){break}}P=c[g>>2]|0;xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){gb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{gb=c[xa>>2]|0}if(ge[c[(c[l>>2]|0)+12>>2]&63](l,2048,gb)|0){xa=c[n>>2]|0;if((xa|0)==(c[q>>2]|0)){oZ(m,n,q);hb=c[n>>2]|0}else{hb=xa}c[n>>2]=hb+4;c[hb>>2]=gb;ib=ca;jb=ma;kb=qa;lb=$+1|0;mb=R}else{xa=a[w]|0;if((xa&1)==0){nb=(xa&255)>>>1}else{nb=c[K>>2]|0}if((nb|0)==0|($|0)==0){break}if((gb|0)!=(c[v>>2]|0)){break}if((ma|0)==(qa|0)){xa=ma-ca|0;P=xa>>>0<2147483647?xa<<1:-1;if((R|0)!=236){ob=ca}else{ob=0}na=s1(ob,P)|0;if((na|0)==0){T=206;break a}pb=na;qb=na+(xa>>2<<2)|0;rb=na+(P>>>2<<2)|0;sb=211}else{pb=ca;qb=ma;rb=qa;sb=R}c[qb>>2]=$;ib=pb;jb=qb+4|0;kb=rb;lb=0;mb=sb}P=c[g>>2]|0;na=P+12|0;xa=c[na>>2]|0;if((xa|0)==(c[P+16>>2]|0)){de[c[(c[P>>2]|0)+40>>2]&127](P)|0;ca=ib;ma=jb;qa=kb;$=lb;R=mb;continue}else{c[na>>2]=xa+4;ca=ib;ma=jb;qa=kb;$=lb;R=mb;continue}}if((ca|0)==(ma|0)|($|0)==0){tb=ca;ub=ma;vb=qa;wb=R}else{if((ma|0)==(qa|0)){xa=ma-ca|0;na=xa>>>0<2147483647?xa<<1:-1;if((R|0)!=236){xb=ca}else{xb=0}P=s1(xb,na)|0;if((P|0)==0){T=217;break a}yb=P;zb=P+(xa>>2<<2)|0;Ab=P+(na>>>2<<2)|0;Bb=211}else{yb=ca;zb=ma;Ab=qa;Bb=R}c[zb>>2]=$;tb=yb;ub=zb+4|0;vb=Ab;wb=Bb}na=c[B>>2]|0;if((na|0)>0){P=c[g>>2]|0;do{if((P|0)==0){Cb=1}else{xa=c[P+12>>2]|0;if((xa|0)==(c[P+16>>2]|0)){Db=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Db=c[xa>>2]|0}if((Db|0)==-1){c[g>>2]=0;Cb=1;break}else{Cb=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=234}else{$=c[P+12>>2]|0;if(($|0)==(c[P+16>>2]|0)){Eb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Eb=c[$>>2]|0}if((Eb|0)==-1){c[b>>2]=0;T=234;break}else{if(Cb){Fb=P;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Cb){T=240;break a}else{Fb=0}}P=c[g>>2]|0;$=c[P+12>>2]|0;if(($|0)==(c[P+16>>2]|0)){Gb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Gb=c[$>>2]|0}if((Gb|0)!=(c[u>>2]|0)){T=240;break a}$=c[g>>2]|0;P=$+12|0;R=c[P>>2]|0;if((R|0)==(c[$+16>>2]|0)){de[c[(c[$>>2]|0)+40>>2]&127]($)|0;Hb=Fb;Ib=na;Jb=Fb}else{c[P>>2]=R+4;Hb=Fb;Ib=na;Jb=Fb}while(1){R=c[g>>2]|0;do{if((R|0)==0){Kb=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Lb=de[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Lb=c[P>>2]|0}if((Lb|0)==-1){c[g>>2]=0;Kb=1;break}else{Kb=(c[g>>2]|0)==0;break}}}while(0);do{if((Jb|0)==0){Mb=Hb;T=257}else{R=c[Jb+12>>2]|0;if((R|0)==(c[Jb+16>>2]|0)){Nb=de[c[(c[Jb>>2]|0)+36>>2]&127](Jb)|0}else{Nb=c[R>>2]|0}if((Nb|0)==-1){c[b>>2]=0;Mb=0;T=257;break}else{if(Kb^(Hb|0)==0){Ob=Hb;Pb=Hb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Kb){T=263;break a}else{Ob=Mb;Pb=0}}R=c[g>>2]|0;P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Qb=de[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Qb=c[P>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,2048,Qb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){oZ(m,n,q)}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){Rb=de[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Rb=c[R>>2]|0}R=c[n>>2]|0;c[n>>2]=R+4;c[R>>2]=Rb;R=Ib+ -1|0;c[B>>2]=R;P=c[g>>2]|0;$=P+12|0;qa=c[$>>2]|0;if((qa|0)==(c[P+16>>2]|0)){de[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[$>>2]=qa+4}if((R|0)>0){Hb=Ob;Ib=R;Jb=Pb}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{ea=tb;fa=ub;ga=vb;ha=N;ia=wb}break};default:{ea=M;fa=r;ga=L;ha=N;ia=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){na=c[g>>2]|0;do{if((na|0)==0){Ub=1}else{R=c[na+12>>2]|0;if((R|0)==(c[na+16>>2]|0)){Vb=de[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Vb=c[R>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{na=c[Tb+12>>2]|0;if((na|0)==(c[Tb+16>>2]|0)){Xb=de[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[na>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{ea=M;fa=r;ga=L;ha=N;ia=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){ea=M;fa=r;ga=L;ha=N;ia=O;break g}else{Yb=Wb;Zb=0}}na=c[g>>2]|0;R=c[na+12>>2]|0;if((R|0)==(c[na+16>>2]|0)){_b=de[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{_b=c[R>>2]|0}if(!(ge[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){ea=M;fa=r;ga=L;ha=N;ia=O;break g}R=c[g>>2]|0;na=R+12|0;qa=c[na>>2]|0;if((qa|0)==(c[R+16>>2]|0)){$b=de[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[na>>2]=qa+4;$b=c[qa>>2]|0}ST(A,$b);Sb=Yb;Tb=Zb}}}while(0);qa=o+1|0;if(qa>>>0<4){L=ga;r=fa;M=ea;o=qa;N=ha;O=ia}else{W=ea;X=fa;Y=ha;Z=ia;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){C1()}else if((T|0)==217){C1()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==276){i:do{if((Y|0)!=0){ia=Y+4|0;ha=Y+8|0;fa=1;j:while(1){ea=a[Y]|0;if((ea&1)==0){dc=(ea&255)>>>1}else{dc=c[ia>>2]|0}if(!(fa>>>0<dc>>>0)){break i}ea=c[g>>2]|0;do{if((ea|0)==0){ec=1}else{N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){fc=de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);ea=c[b>>2]|0;do{if((ea|0)==0){T=295}else{N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){gc=de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}ea=c[g>>2]|0;N=c[ea+12>>2]|0;if((N|0)==(c[ea+16>>2]|0)){hc=de[c[(c[ea>>2]|0)+36>>2]&127](ea)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=ia}else{ic=c[ha>>2]|0}if((hc|0)!=(c[ic+(fa<<2)>>2]|0)){break}N=fa+1|0;ea=c[g>>2]|0;o=ea+12|0;r=c[o>>2]|0;if((r|0)==(c[ea+16>>2]|0)){de[c[(c[ea>>2]|0)+40>>2]&127](ea)|0;fa=N;continue}else{c[o>>2]=r+4;fa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;gZ(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);OT(A);OT(z);OT(y);OT(x);kT(w);if((bc|0)==0){i=p;return ac|0}ae[cc&255](bc);i=p;return ac|0}function lZ(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=236;v=n+400|0;gU(q,h);n=q;w=c[n>>2]|0;if(!((c[35224]|0)==-1)){c[m>>2]=140896;c[m+4>>2]=234;c[m+8>>2]=0;XS(140896,m,235)}m=(c[140900>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;W0(z);A=156464;B=128;Od(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;W0(z);A=156464;B=128;Od(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=kZ(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){ST(k,se[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=se[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);mZ(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=de[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=de[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];CS(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}ae[c[u>>2]&255](n);i=d;return}function mZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){UT(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function nZ(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[35118]|0)==-1)){c[p>>2]=140472;c[p+4>>2]=234;c[p+8>>2]=0;XS(140472,p,235)}p=(c[140476>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;W0(C);D=156464;E=128;Od(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;W0(C);D=156464;E=128;Od(B|0,D|0,E|0)}E=b;be[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;be[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}RT(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;OT(r);be[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}RT(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;OT(s);c[f>>2]=de[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=de[c[(c[b>>2]|0)+16>>2]&127](E)|0;be[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}wT(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;kT(t);be[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}RT(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;OT(u);F=de[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[35102]|0)==-1)){c[o>>2]=140408;c[o+4>>2]=234;c[o+8>>2]=0;XS(140408,o,235)}o=(c[140412>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;W0(H);I=156464;J=128;Od(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;W0(H);I=156464;J=128;Od(G|0,I|0,J|0)}J=E;be[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;be[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}RT(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;OT(w);be[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}RT(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;OT(x);c[f>>2]=de[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=de[c[(c[E>>2]|0)+16>>2]&127](J)|0;be[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}wT(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;kT(y);be[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}RT(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;OT(z);F=de[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function oZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=236;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=s1(m,l)|0;m=a;if((a|0)==0){C1()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}ae[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=211;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function pZ(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function qZ(a){a=a|0;i=i;return}function rZ(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,140656,o|0)|0;do{if(s>>>0>99){do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);o=c[35198]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=jX(r,o,140656,n)|0;o=c[r>>2]|0;if((o|0)==0){C1()}H=p1(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}C1()}else{I=0;J=0;K=q;L=s}}while(0);gU(t,g);s=t;q=c[s>>2]|0;if(!((c[35226]|0)==-1)){c[p>>2]=140904;c[p+4>>2]=234;c[p+8>>2]=0;XS(140904,p,235)}p=(c[140908>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ec(4)|0;N=M;W0(N);O=156464;P=128;Od(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ec(4)|0;N=M;W0(N);O=156464;P=128;Od(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Ce[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;sZ(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=p1(V)|0;if((T|0)!=0){W=T;X=T;break}C1()}else{W=0;X=t}}while(0);tZ(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];IP(b,m,X,e,D,g,j);if((W|0)!=0){q1(W)}kT(A);kT(z);kT(y);CS(c[s>>2]|0)|0;if((J|0)!=0){q1(J)}if((I|0)==0){i=d;return}q1(I);i=d;return}function sZ(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[35086]|0)==-1)){c[p>>2]=140344;c[p+4>>2]=234;c[p+8>>2]=0;XS(140344,p,235)}p=(c[140348>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;W0(I);J=156464;K=128;Od(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;W0(I);J=156464;K=128;Od(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){be[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;be[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}wT(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;kT(s)}else{be[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;be[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}wT(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;kT(v)}a[g]=de[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=de[c[(c[e>>2]|0)+16>>2]&127](K)|0;be[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}wT(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;kT(w);be[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}wT(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;kT(x);L=de[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[35070]|0)==-1)){c[o>>2]=140280;c[o+4>>2]=234;c[o+8>>2]=0;XS(140280,o,235)}o=(c[140284>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;W0(N);O=156464;P=128;Od(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;W0(N);O=156464;P=128;Od(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){be[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;be[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}wT(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;kT(A)}else{be[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;be[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}wT(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;kT(D)}a[g]=de[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=de[c[(c[G>>2]|0)+16>>2]&127](P)|0;be[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}wT(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;kT(E);be[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}wT(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;kT(F);L=de[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function tZ(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 3:{I=a[r]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[w>>2]|0}if((K|0)==0){L=H;break a}if(J){M=u}else{M=c[v>>2]|0}J=a[M]|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};case 1:{c[e>>2]=c[f>>2];J=se[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 4:{J=c[f>>2]|0;I=l?H+1|0:H;b:do{if(I>>>0<j>>>0){N=I;while(1){O=a[N]|0;if(!(O<<24>>24>-1)){P=N;break b}Q=N+1|0;if((b[(c[F>>2]|0)+(O<<24>>24<<1)>>1]&2048)==0){P=N;break b}if(Q>>>0<j>>>0){N=Q}else{P=Q;break}}}else{P=I}}while(0);N=P;if(B){if(P>>>0>I>>>0){Q=I+(0-N)|0;N=Q>>>0<G>>>0?G:Q;Q=N+s|0;O=J;R=P;S=s;while(1){T=R+ -1|0;U=a[T]|0;c[f>>2]=O+1;a[O]=U;U=S+ -1|0;V=(U|0)>0;if(!(T>>>0>I>>>0&V)){break}O=c[f>>2]|0;S=U;R=T}R=P+N|0;if(V){W=R;X=Q;Y=32}else{Z=0;_=R;$=Q}}else{W=P;X=s;Y=32}if((Y|0)==32){Y=0;Z=se[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;_=W;$=X}R=c[f>>2]|0;c[f>>2]=R+1;if(($|0)>0){S=R;O=$;while(1){a[S]=Z;T=O+ -1|0;U=c[f>>2]|0;c[f>>2]=U+1;if((T|0)>0){O=T;S=U}else{aa=U;break}}}else{aa=R}a[aa]=n;ba=_}else{ba=P}if((ba|0)==(I|0)){S=se[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;O=c[f>>2]|0;c[f>>2]=O+1;a[O]=S}else{S=a[p]|0;O=(S&1)==0;if(O){ca=(S&255)>>>1}else{ca=c[E>>2]|0}if((ca|0)==0){da=ba;ea=-1;fa=0;ga=0}else{if(O){ha=C}else{ha=c[D>>2]|0}da=ba;ea=a[ha]|0;fa=0;ga=0}while(1){do{if((ga|0)==(ea|0)){O=c[f>>2]|0;c[f>>2]=O+1;a[O]=o;O=fa+1|0;S=a[p]|0;Q=(S&1)==0;if(Q){ia=(S&255)>>>1}else{ia=c[E>>2]|0}if(!(O>>>0<ia>>>0)){ja=ea;ka=O;la=0;break}if(Q){ma=C}else{ma=c[D>>2]|0}if((a[ma+O|0]|0)==127){ja=-1;ka=O;la=0;break}if(Q){na=C}else{na=c[D>>2]|0}ja=a[na+O|0]|0;ka=O;la=0}else{ja=ea;ka=fa;la=ga}}while(0);O=da+ -1|0;Q=a[O]|0;S=c[f>>2]|0;c[f>>2]=S+1;a[S]=Q;if((O|0)==(I|0)){break}else{da=O;ea=ja;fa=ka;ga=la+1|0}}}R=c[f>>2]|0;if((J|0)==(R|0)){L=I;break a}O=R+ -1|0;if(O>>>0>J>>>0){oa=J;pa=O}else{L=I;break a}while(1){O=a[oa]|0;a[oa]=a[pa]|0;a[pa]=O;O=oa+1|0;R=pa+ -1|0;if(O>>>0<R>>>0){pa=R;oa=O}else{L=I;break}}break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){qa=(I&255)>>>1}else{qa=c[A>>2]|0}if((qa|0)==0|x){L=H;break a}if(J){ra=y;sa=(I&255)>>>1}else{ra=c[z>>2]|0;sa=c[A>>2]|0}I=ra+sa|0;J=c[f>>2]|0;if((ra|0)==(I|0)){ta=J}else{O=J;J=ra;while(1){a[O]=a[J]|0;R=J+1|0;Q=O+1|0;if((R|0)==(I|0)){ta=Q;break}else{J=R;O=Q}}}c[f>>2]=ta;L=H;break};default:{L=H}}}while(0);O=h+1|0;if(O>>>0<4){H=L;h=O}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function uZ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;gU(m,g);z=m;A=c[z>>2]|0;if(!((c[35226]|0)==-1)){c[l>>2]=140904;c[l+4>>2]=234;c[l+8>>2]=0;XS(140904,l,235)}l=(c[140908>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;W0(D);E=156464;F=128;Od(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;W0(D);E=156464;F=128;Od(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(se[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;sZ(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=p1(P)|0;if((N|0)!=0){Q=N;R=N;break}C1()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}tZ(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];IP(b,k,R,e,w,g,h);if((Q|0)==0){kT(t);kT(s);kT(r);U=c[z>>2]|0;V=U;W=V;X=CS(W)|0;i=d;return}q1(Q);kT(t);kT(s);kT(r);U=c[z>>2]|0;V=U;W=V;X=CS(W)|0;i=d;return}function vZ(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function wZ(a){a=a|0;i=i;return}function xZ(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,140656,o|0)|0;do{if(s>>>0>99){do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);o=c[35198]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=jX(r,o,140656,n)|0;o=c[r>>2]|0;if((o|0)==0){C1()}H=p1(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}C1()}else{J=0;K=0;L=q;M=s}}while(0);gU(t,g);s=t;q=c[s>>2]|0;if(!((c[35224]|0)==-1)){c[p>>2]=140896;c[p+4>>2]=234;c[p+8>>2]=0;XS(140896,p,235)}p=(c[140900>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ec(4)|0;O=N;W0(O);P=156464;Q=128;Od(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ec(4)|0;O=N;W0(O);P=156464;Q=128;Od(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Ce[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;yZ(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=p1(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}C1()}else{X=0;Y=t}}while(0);zZ(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];sX(b,m,Y,e,D,g,j);if((X|0)!=0){q1(X)}OT(A);OT(z);kT(y);CS(c[s>>2]|0)|0;if((K|0)!=0){q1(K)}if((J|0)==0){i=d;return}q1(J);i=d;return}function yZ(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[35118]|0)==-1)){c[p>>2]=140472;c[p+4>>2]=234;c[p+8>>2]=0;XS(140472,p,235)}p=(c[140476>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;W0(I);J=156464;K=128;Od(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;W0(I);J=156464;K=128;Od(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){be[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;be[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}RT(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;OT(s)}else{be[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;be[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}RT(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;OT(v)}c[g>>2]=de[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=de[c[(c[e>>2]|0)+16>>2]&127](K)|0;be[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}wT(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;kT(w);be[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}RT(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;OT(x);L=de[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[35102]|0)==-1)){c[o>>2]=140408;c[o+4>>2]=234;c[o+8>>2]=0;XS(140408,o,235)}o=(c[140412>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;W0(N);O=156464;P=128;Od(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;W0(N);O=156464;P=128;Od(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){be[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;be[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}RT(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;OT(A)}else{be[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;be[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}RT(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;OT(D)}c[g>>2]=de[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=de[c[(c[G>>2]|0)+16>>2]&127](P)|0;be[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}wT(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;kT(E);be[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}RT(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;OT(F);L=de[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function zZ(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 4:{D=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){F=E;while(1){G=F+4|0;if(!(ge[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[F>>2]|0)|0)){H=F;break b}if(G>>>0<h>>>0){F=G}else{H=G;break}}}else{H=E}}while(0);if(y){do{if(H>>>0>E>>>0){F=c[e>>2]|0;G=H;I=r;while(1){J=G+ -4|0;K=F+4|0;c[F>>2]=c[J>>2];L=I+ -1|0;M=(L|0)>0;if(J>>>0>E>>>0&M){I=L;G=J;F=K}else{break}}c[e>>2]=K;if(M){N=J;O=L;P=34;break}F=c[e>>2]|0;c[e>>2]=F+4;Q=F;R=J}else{N=H;O=r;P=34}}while(0);do{if((P|0)==34){P=0;F=se[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;G=c[e>>2]|0;I=G+4|0;c[e>>2]=I;if((O|0)>0){S=I;T=G;U=O}else{Q=G;R=N;break}while(1){c[T>>2]=F;I=U+ -1|0;if((I|0)>0){U=I;T=S;S=S+4|0}else{break}}c[e>>2]=G+(O+1<<2);Q=G+(O<<2)|0;R=N}}while(0);c[Q>>2]=m;V=R}else{V=H}if((V|0)==(E|0)){F=se[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;I=c[e>>2]|0;W=I+4|0;c[e>>2]=W;c[I>>2]=F;X=W}else{W=a[o]|0;F=(W&1)==0;if(F){Y=(W&255)>>>1}else{Y=c[B>>2]|0}if((Y|0)==0){Z=V;_=-1;$=0;aa=0}else{if(F){ba=z}else{ba=c[A>>2]|0}Z=V;_=a[ba]|0;$=0;aa=0}while(1){F=c[e>>2]|0;do{if((aa|0)==(_|0)){W=F+4|0;c[e>>2]=W;c[F>>2]=n;I=$+1|0;ca=a[o]|0;da=(ca&1)==0;if(da){ea=(ca&255)>>>1}else{ea=c[B>>2]|0}if(!(I>>>0<ea>>>0)){fa=W;ga=_;ha=I;ia=0;break}if(da){ja=z}else{ja=c[A>>2]|0}if((a[ja+I|0]|0)==127){fa=W;ga=-1;ha=I;ia=0;break}if(da){ka=z}else{ka=c[A>>2]|0}fa=W;ga=a[ka+I|0]|0;ha=I;ia=0}else{fa=F;ga=_;ha=$;ia=aa}}while(0);F=Z+ -4|0;G=c[F>>2]|0;I=fa+4|0;c[e>>2]=I;c[fa>>2]=G;if((F|0)==(E|0)){X=I;break}else{Z=F;_=ga;$=ha;aa=ia+1|0}}}if((D|0)==(X|0)){la=E;break a}F=X+ -4|0;if(F>>>0>D>>>0){ma=D;na=F}else{la=E;break a}while(1){F=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=F;F=ma+4|0;I=na+ -4|0;if(F>>>0<I>>>0){na=I;ma=F}else{la=E;break}}break};case 3:{E=a[q]|0;D=(E&1)==0;if(D){oa=(E&255)>>>1}else{oa=c[t>>2]|0}if((oa|0)==0){la=C;break a}if(D){pa=t}else{pa=c[u>>2]|0}D=c[pa>>2]|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;la=C;break};case 2:{D=a[p]|0;E=(D&1)==0;if(E){qa=(D&255)>>>1}else{qa=c[w>>2]|0}if((qa|0)==0|v){la=C;break a}if(E){ra=w;sa=(D&255)>>>1}else{ra=c[x>>2]|0;sa=c[w>>2]|0}D=ra+(sa<<2)|0;E=c[e>>2]|0;if((ra|0)==(D|0)){ta=E}else{F=(ra+(sa+ -1<<2)+(0-ra)|0)>>>2;I=E;G=ra;while(1){c[I>>2]=c[G>>2];W=G+4|0;if((W|0)==(D|0)){break}I=I+4|0;G=W}ta=E+(F+1<<2)|0}c[e>>2]=ta;la=C;break};case 0:{c[d>>2]=c[e>>2];la=C;break};case 1:{c[d>>2]=c[e>>2];G=se[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;I=c[e>>2]|0;c[e>>2]=I+4;c[I>>2]=G;la=C;break};default:{la=C}}}while(0);G=g+1|0;if(G>>>0<4){C=la;g=G}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==16){i=s;return}else if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else{c[d>>2]=b;i=s;return}}function AZ(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;gU(m,g);z=m;A=c[z>>2]|0;if(!((c[35224]|0)==-1)){c[l>>2]=140896;c[l+4>>2]=234;c[l+8>>2]=0;XS(140896,l,235)}l=(c[140900>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;W0(D);E=156464;F=128;Od(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;W0(D);E=156464;F=128;Od(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(se[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;yZ(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=p1(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}C1()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}zZ(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];sX(b,k,R,e,w,g,h);if((Q|0)==0){OT(t);OT(s);kT(r);U=c[z>>2]|0;V=U;W=V;X=CS(W)|0;i=d;return}q1(Q);OT(t);OT(s);kT(r);U=c[z>>2]|0;V=U;W=V;X=CS(W)|0;i=d;return}function BZ(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function CZ(a){a=a|0;i=i;return}function DZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function EZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{CT(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=ud(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=T1(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{kT(j);i=d;return}do{CT(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);kT(j);i=d;return}function FZ(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function GZ(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function HZ(a){a=a|0;i=i;return}function IZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function JZ(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=142560;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=142560|0;while(1){c[m>>2]=y;A=(Be[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{CT(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}cZ(141784)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=ud(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=142664;D=T1(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){kT(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=142664|0;while(1){c[q>>2]=o;h=(Be[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{ST(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){cZ(141784)}else if((E|0)==25){kT(r);i=d;return}}function KZ(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function LZ(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=140992;e=b+8|0;b=c[e>>2]|0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);if((b|0)==(c[35198]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function MZ(a){a=a|0;a=Ec(8)|0;DS(a,140784);c[a>>2]=137752;Od(a|0,137792,41)}function NZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=140824;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);cT(b+144|0,140808,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[145716>>2]=0;c[36428]=139304;if(!((c[34832]|0)==-1)){c[G>>2]=139328;c[G+4>>2]=234;c[G+8>>2]=0;XS(139328,G,235)}OZ(b,145712,(c[139332>>2]|0)+ -1|0);c[145708>>2]=0;c[36426]=139344;if(!((c[34842]|0)==-1)){c[F>>2]=139368;c[F+4>>2]=234;c[F+8>>2]=0;XS(139368,F,235)}OZ(b,145704,(c[139372>>2]|0)+ -1|0);c[145692>>2]=0;c[36422]=140920;c[145696>>2]=0;a[145700|0]=0;F=c[(yc()|0)>>2]|0;c[145696>>2]=F;if(!((c[35226]|0)==-1)){c[E>>2]=140904;c[E+4>>2]=234;c[E+8>>2]=0;XS(140904,E,235)}OZ(b,145688,(c[140908>>2]|0)+ -1|0);c[145684>>2]=0;c[36420]=141880;if(!((c[35224]|0)==-1)){c[D>>2]=140896;c[D+4>>2]=234;c[D+8>>2]=0;XS(140896,D,235)}OZ(b,145680,(c[140900>>2]|0)+ -1|0);c[145676>>2]=0;c[36418]=142096;if(!((c[35242]|0)==-1)){c[C>>2]=140968;c[C+4>>2]=234;c[C+8>>2]=0;XS(140968,C,235)}OZ(b,145672,(c[140972>>2]|0)+ -1|0);c[145660>>2]=0;c[36414]=140992;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);c[145664>>2]=c[35198];if(!((c[35244]|0)==-1)){c[B>>2]=140976;c[B+4>>2]=234;c[B+8>>2]=0;XS(140976,B,235)}OZ(b,145656,(c[140980>>2]|0)+ -1|0);c[145652>>2]=0;c[36412]=142320;if(!((c[35258]|0)==-1)){c[A>>2]=141032;c[A+4>>2]=234;c[A+8>>2]=0;XS(141032,A,235)}OZ(b,145648,(c[141036>>2]|0)+ -1|0);c[145644>>2]=0;c[36410]=142440;if(!((c[35260]|0)==-1)){c[z>>2]=141040;c[z+4>>2]=234;c[z+8>>2]=0;XS(141040,z,235)}OZ(b,145640,(c[141044>>2]|0)+ -1|0);c[145620>>2]=0;c[36404]=141072;a[145624|0]=46;a[145625|0]=44;z=145628|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[35262]|0)==-1)){c[y>>2]=141048;c[y+4>>2]=234;c[y+8>>2]=0;XS(141048,y,235)}OZ(b,145616,(c[141052>>2]|0)+ -1|0);c[145588>>2]=0;c[36396]=141112;c[145592>>2]=46;c[145596>>2]=44;y=145600|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[35264]|0)==-1)){c[x>>2]=141056;c[x+4>>2]=234;c[x+8>>2]=0;XS(141056,x,235)}OZ(b,145584,(c[141060>>2]|0)+ -1|0);c[145580>>2]=0;c[36394]=139384;if(!((c[34860]|0)==-1)){c[w>>2]=139440;c[w+4>>2]=234;c[w+8>>2]=0;XS(139440,w,235)}OZ(b,145576,(c[139444>>2]|0)+ -1|0);c[145572>>2]=0;c[36392]=139504;if(!((c[34890]|0)==-1)){c[v>>2]=139560;c[v+4>>2]=234;c[v+8>>2]=0;XS(139560,v,235)}OZ(b,145568,(c[139564>>2]|0)+ -1|0);c[145564>>2]=0;c[36390]=139576;if(!((c[34906]|0)==-1)){c[u>>2]=139624;c[u+4>>2]=234;c[u+8>>2]=0;XS(139624,u,235)}OZ(b,145560,(c[139628>>2]|0)+ -1|0);c[145556>>2]=0;c[36388]=139640;if(!((c[34922]|0)==-1)){c[t>>2]=139688;c[t+4>>2]=234;c[t+8>>2]=0;XS(139688,t,235)}OZ(b,145552,(c[139692>>2]|0)+ -1|0);c[145548>>2]=0;c[36386]=140232;if(!((c[35070]|0)==-1)){c[s>>2]=140280;c[s+4>>2]=234;c[s+8>>2]=0;XS(140280,s,235)}OZ(b,145544,(c[140284>>2]|0)+ -1|0);c[145540>>2]=0;c[36384]=140296;if(!((c[35086]|0)==-1)){c[r>>2]=140344;c[r+4>>2]=234;c[r+8>>2]=0;XS(140344,r,235)}OZ(b,145536,(c[140348>>2]|0)+ -1|0);c[145532>>2]=0;c[36382]=140360;if(!((c[35102]|0)==-1)){c[q>>2]=140408;c[q+4>>2]=234;c[q+8>>2]=0;XS(140408,q,235)}OZ(b,145528,(c[140412>>2]|0)+ -1|0);c[145524>>2]=0;c[36380]=140424;if(!((c[35118]|0)==-1)){c[p>>2]=140472;c[p+4>>2]=234;c[p+8>>2]=0;XS(140472,p,235)}OZ(b,145520,(c[140476>>2]|0)+ -1|0);c[145516>>2]=0;c[36378]=140488;if(!((c[35128]|0)==-1)){c[o>>2]=140512;c[o+4>>2]=234;c[o+8>>2]=0;XS(140512,o,235)}OZ(b,145512,(c[140516>>2]|0)+ -1|0);c[145508>>2]=0;c[36376]=140568;if(!((c[35148]|0)==-1)){c[n>>2]=140592;c[n+4>>2]=234;c[n+8>>2]=0;XS(140592,n,235)}OZ(b,145504,(c[140596>>2]|0)+ -1|0);c[145500>>2]=0;c[36374]=140624;if(!((c[35162]|0)==-1)){c[m>>2]=140648;c[m+4>>2]=234;c[m+8>>2]=0;XS(140648,m,235)}OZ(b,145496,(c[140652>>2]|0)+ -1|0);c[145492>>2]=0;c[36372]=140672;if(!((c[35174]|0)==-1)){c[l>>2]=140696;c[l+4>>2]=234;c[l+8>>2]=0;XS(140696,l,235)}OZ(b,145488,(c[140700>>2]|0)+ -1|0);c[145476>>2]=0;c[36368]=139720;c[145480>>2]=139768;if(!((c[34950]|0)==-1)){c[k>>2]=139800;c[k+4>>2]=234;c[k+8>>2]=0;XS(139800,k,235)}OZ(b,145472,(c[139804>>2]|0)+ -1|0);c[145460>>2]=0;c[36364]=139872;c[145464>>2]=139920;if(!((c[34988]|0)==-1)){c[j>>2]=139952;c[j+4>>2]=234;c[j+8>>2]=0;XS(139952,j,235)}OZ(b,145456,(c[139956>>2]|0)+ -1|0);c[145444>>2]=0;c[36360]=141816;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);c[145448>>2]=c[35198];c[36360]=140168;if(!((c[35046]|0)==-1)){c[h>>2]=140184;c[h+4>>2]=234;c[h+8>>2]=0;XS(140184,h,235)}OZ(b,145440,(c[140188>>2]|0)+ -1|0);c[145428>>2]=0;c[36356]=141816;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);c[145432>>2]=c[35198];c[36356]=140200;if(!((c[35054]|0)==-1)){c[g>>2]=140216;c[g+4>>2]=234;c[g+8>>2]=0;XS(140216,g,235)}OZ(b,145424,(c[140220>>2]|0)+ -1|0);c[145420>>2]=0;c[36354]=140712;if(!((c[35184]|0)==-1)){c[f>>2]=140736;c[f+4>>2]=234;c[f+8>>2]=0;XS(140736,f,235)}OZ(b,145416,(c[140740>>2]|0)+ -1|0);c[145412>>2]=0;c[36352]=140752;if((c[35194]|0)==-1){N=140776;O=140776;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=145408;OZ(b,T,S);i=e;return}c[H>>2]=140776;c[H+4>>2]=234;c[H+8>>2]=0;XS(140776,H,235);N=140776;O=140776;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=145408;OZ(b,T,S);i=e;return}function OZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;BS(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){T$(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}CS(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function PZ(a){a=a|0;var b=0;b=i;QZ(a);x1(a);i=b;return}function QZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=140824;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{CS(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}kT(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{x1(h);i=d;return}}function RZ(){var b=0,d=0,e=0,f=0;b=i;if((a[140880]|0)!=0){d=140872;e=c[35218]|0;i=b;return e|0}if((Za(140880)|0)==0){d=140872;e=c[35218]|0;i=b;return e|0}do{if((a[140856]|0)==0){if((Za(140856)|0)==0){break}NZ(145248,1);c[35210]=145248;c[35212]=140840;Sb(140856)}}while(0);f=c[c[35212]>>2]|0;c[35216]=f;BS(f);c[35218]=140864;Sb(140880);d=140872;e=c[35218]|0;i=b;return e|0}function SZ(a){a=a|0;var b=0,d=0;b=i;d=c[(RZ()|0)>>2]|0;c[a>>2]=d;BS(d);i=b;return}function TZ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;BS(e);i=d;return}function UZ(a){a=a|0;var b=0;b=i;CS(c[a>>2]|0)|0;i=b;return}function VZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=234;c[e+8>>2]=0;XS(a,e,235)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function WZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=234;c[e+8>>2]=0;XS(a,e,235)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ec(4)|0;h=g;W0(h);j=156464;k=128;Od(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ec(4)|0;h=g;W0(h);j=156464;k=128;Od(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function XZ(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function YZ(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}ae[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function ZZ(a){a=a|0;var b=0;b=c[35222]|0;c[35222]=1+b;c[a+4>>2]=b+1;i=i;return}function _Z(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function $Z(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function a_(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(yc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function b_(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function c_(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(yc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function d_(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(yd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function e_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(yd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function f_(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function g_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function h_(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}



function BP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;S1(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=e2(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(42,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=e2(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[28934]=d;u=0;Ha(58,10,230)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=e2(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(43,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=e2(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=e2(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=e2(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=e2(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=e2(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(231,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=e2(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=e2(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=e2(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function CP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=id(c[16250]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[67132>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;rc(116072,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Nd(10,a|0)|0;qd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 5:case 4:{i=b;return};case 3:{if((c[67188>>2]|0)==0){i=b;return}c[f>>2]=e;n=c[r>>2]|0;rc(116072,7,1,n|0)|0;Dc(n|0,d|0,f|0)|0;Nd(10,n|0)|0;qd(0)|0;i=b;return};case 1:{c[f>>2]=e;e=c[r>>2]|0;rc(116072,7,1,e|0)|0;Dc(e|0,d|0,f|0)|0;Nd(10,e|0)|0;qd(0)|0;eb(c[g+80>>2]|0,1);break};default:{Ky(g,116080,b)}}}function DP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;rc(116056,9,1,d|0)|0;Dc(d|0,b|0,e|0)|0;Nd(10,d|0)|0;qd(0)|0;i=a;return}function EP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;LP(116e3,b);c[28492]=114728;b=113972|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[113988>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}d=id(c[16250]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}function FP(a,b){a=a|0;b=b|0;var c=0;c=i;HP(a,b);i=c;return}function GP(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function HP(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=dU(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function IP(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;BE(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=JP(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((pU(b,d,r)|0)==(r|0)){break}BE(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){fT(l,s,h);if((pU(b,jT(l)|0,s)|0)==(s|0)){kT(l);break}BE(m);c[o>>2]=0;c[a>>2]=0;kT(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((pU(b,e,l)|0)==(l|0)){break}BE(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);KP(g,0)|0;c[a>>2]=b;i=j;return}function JP(a){a=a|0;i=i;return c[a+12>>2]|0}function KP(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function LP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[28498]|0;if((g|0)==0){c[e>>2]=(T1(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(RI(e,f)|0)>>2]|0;c[29012]=h;f=p1(h)|0;c[28498]=f;j=h;k=f}else{j=c[29012]|0;k=g}g=nc(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[29012]|0)>>>0){i=d;return}q1(c[28498]|0);j=g<<1|1;c[29012]=j;g=p1(j)|0;c[28498]=g;nc(g|0,j|0,a|0,b|0)|0;i=d;return}function MP(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;NP(g,16);OP(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){PP(a,g);QP(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){rP(yV(m,+h[b+(p<<3)>>3])|0,117440)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){yV(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){rP(m,117448)|0}}while((e|0)<(d|0));PP(a,g);QP(g);i=f;return}function NP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;hU(e);f=a;c[f>>2]=117820;g=e;c[g>>2]=117840;e=a+4|0;oV(a,117852|0,e);c[f>>2]=117820;c[g>>2]=117840;aQ(e,b|16);i=d;return}function OP(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function PP(a,b){a=a|0;b=b|0;var c=0;c=i;WP(a,b+4|0);i=c;return}function QP(a){a=a|0;var b=0;b=i;eQ(a,117848);cU(a+56|0);i=b;return}function RP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[67176>>2]|0)!=0){tb(118144)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(14,0,117456,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Gy(14,0,117528,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[67176>>2]|0)==0){i=d;return 0}Gy(14,0,117576,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(117592,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function SP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[67176>>2]|0)!=0){tb(118144)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(14,0,117456,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Gy(14,0,117528,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[67176>>2]|0)==0){i=d;return 0}Gy(14,0,117576,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(117592,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function TP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[67176>>2]|0)!=0){tb(118144)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(14,0,117456,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Gy(14,0,117528,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[67176>>2]|0)==0){i=d;return 0}Gy(14,0,117576,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(117592,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function UP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[67176>>2]|0)!=0){tb(118144)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(14,0,117456,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);de[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Gy(14,0,117528,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[67176>>2]|0)==0){i=d;return 0}Gy(14,0,117576,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];hc(117592,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ec(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function VP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=r1(fa(F,F)|0,8)|0;J=I;K=r1(fa(G,F)|0,8)|0;L=K;M=r1(fa(H,F)|0,8)|0;N=M;O=r1(fa(H,G)|0,8)|0;P=O;_S(p);_S(q);_S(r);_S(s);_S(t);_S(u);_S(v);Q=a+536|0;Jy(c[Q>>2]|0,(I|0)!=0|0,117600,o);Jy(c[Q>>2]|0,(K|0)!=0|0,117600,n);Jy(c[Q>>2]|0,(M|0)!=0|0,117600,m);Jy(c[Q>>2]|0,(O|0)!=0|0,117600,l);l=a+540|0;m=a;if((de[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;RP(a,J)|0;Jy(n,1,117616,k)}MP(w,J,F,F);lT(p,w)|0;kT(w);if((de[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;SP(a,L)|0;Jy(w,1,117648,j)}MP(x,L,F,G);lT(q,x)|0;kT(x);if((de[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;TP(a,N)|0;Jy(x,1,117680,h)}MP(y,N,H,F);lT(r,y)|0;kT(y);if((de[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;UP(a,P)|0;Jy(m,1,117712,g)}MP(z,P,H,G);lT(s,z)|0;kT(z);if((F|0)==0){mT(t,117744)|0}else{MP(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);lT(t,A)|0;kT(A)}if((G|0)==0){mT(u,117744)|0}else{MP(B,c[a+432>>2]|0,1,G);lT(u,B)|0;kT(B)}q1(I);q1(K);q1(M);q1(O);eT(E,c[a+84>>2]|0);VT(D,117760,E);bI(C,D,117768);lT(v,C)|0;kT(C);kT(D);kT(E);E=jc(HT(v)|0,117776)|0;D=c[Q>>2]|0;c[f>>2]=HT(v)|0;Jy(D,(E|0)!=0|0,117784,f);f=xe[c[(c[l>>2]|0)+176>>2]&7]()|0;D=HT(t)|0;Q=HT(u)|0;C=HT(p)|0;a=HT(q)|0;O=HT(r)|0;M=HT(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;sd(E|0,f|0,e|0)|0;if((c[67220>>2]|0)==0){R=qd(E|0)|0;S=Xc(E|0)|0;kT(v);kT(u);kT(t);kT(s);kT(r);kT(q);kT(p);i=b;return 0}e=xe[c[(c[l>>2]|0)+176>>2]&7]()|0;l=HT(t)|0;f=HT(u)|0;M=HT(p)|0;O=HT(q)|0;a=HT(r)|0;C=HT(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;Gy(25,0,e,d);R=qd(E|0)|0;S=Xc(E|0)|0;kT(v);kT(u);kT(t);kT(s);kT(r);kT(q);kT(p);i=b;return 0}function WP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=xU(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}XP(a,wU(l)|0,n,e);i=d;return}if((h&8|0)==0){$S(a,g);i=d;return}else{g=b;b=rU(g)|0;XP(a,b,tU(g)|0,f);i=d;return}}function XP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;YP(a,b,c,0);i=d;return}function YP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;ZP(a,b,c);i=d;return}function ZP(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=_P(c,d)|0;if(g>>>0>4294967279){YS(0)}if(g>>>0<11){qT(b,g);h=pT(b)|0}else{j=xT(g)|0;k=j+1|0;j=NI(dT(b)|0,k)|0;zT(b,j);yT(b,k);oT(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;OI(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){OI(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;OI(l,f);i=e;return}function _P(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=$P(b,c,e)|0;i=d;return g|0}function $P(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function aQ(a,b){a=a|0;b=b|0;var c=0;c=i;qQ(a,b);i=c;return}function bQ(a){a=a|0;var b=0;b=i;QP(a);x1(a);i=b;return}function cQ(a){a=a|0;var b=0;b=i;QP(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function dQ(a){a=a|0;var b=0;b=i;bQ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function eQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];fQ(a+4|0);i=d;return}function fQ(a){a=a|0;var b=0;b=i;gQ(a);i=b;return}function gQ(a){a=a|0;var b=0;b=i;c[a>>2]=118e3;kT(a+32|0);lU(a);i=b;return}function hQ(a){a=a|0;var b=0;b=i;fQ(a);x1(a);i=b;return}function iQ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=xU(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}PD(a,-1,-1);i=h;return}else if((k|0)==0){PD(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=xU(l)|0;j=m-(wU(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=sU(l)|0;m=j-(rU(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(jT(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){PD(a,-1,-1);i=h;return}q=b2(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(jT(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((sU(l)|0)!=0){break}PD(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((xU(l)|0)!=0){break}PD(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=rU(l)|0;vU(l,p,p+q|0,n)}if((g&16|0)!=0){p=wU(l)|0;AU(l,p,yU(l)|0);zU(l,q)}PD(a,q,e);i=h;return}}while(0);PD(a,-1,-1);i=h;return}function jQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=bF(d)|0;me[g&31](a,b,h,J,0,e);i=f;return}function kQ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=xU(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((tU(g)|0)>>>0<j>>>0){b=rU(g)|0;vU(g,b,sU(g)|0,j)}j=sU(g)|0;if(!(j>>>0<(tU(g)|0)>>>0)){k=-1;i=d;return k|0}k=zF(a[j]|0)|0;i=d;return k|0}function lQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=xU(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=rU(h)|0;j=sU(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(vF(d,-1)|0){vU(h,g,j+ -1|0,k);l=yF(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=wF(d)|0;do{if(g){if(AF(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=rU(h)|0;vU(h,j,(sU(h)|0)+ -1|0,k);a[sU(h)|0]=b;l=d;i=e;return l|0}function mQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(vF(b,-1)|0){f=yF(b)|0;i=d;return f|0}g=a;h=sU(g)|0;j=h-(rU(g)|0)|0;h=xU(g)|0;do{if((h|0)==(yU(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=wU(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;CT(o,0);vT(o,sT(o)|0);p=jT(o)|0;AU(g,p,p+(iT(o)|0)|0);zU(g,h-l|0);c[m>>2]=(wU(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(xU(g)|0)+1;h=c[(nQ(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=jT(a+32|0)|0;vU(g,q,q+j|0,h)}f=oU(g,b&255)|0;i=d;return f|0}function nQ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=oQ(b,c,e)|0;i=d;return g|0}function oQ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=pQ(0,a,b)|0;i=c;return(d?b:a)|0}function pQ(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function qQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;qU(a);c[a>>2]=118e3;_S(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;_S(e);rQ(a,e);kT(e);i=d;return}function rQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;lT(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=jT(e)|0;j=g+(iT(e)|0)|0;c[b>>2]=j;g=jT(e)|0;vU(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=iT(e)|0;c[b>>2]=(jT(e)|0)+h;vT(e,sT(e)|0);b=a;a=jT(e)|0;AU(b,a,a+(iT(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}zU(b,h);i=d;return}function sQ(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=jc(d|0,118424)|0;J=$c(118432,118424)|0;K=(J|0)!=0;L=Nc()|0;if(K){M=c[b+536>>2]|0;N=Rd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;Jy(M,(I|0)!=0|0,118488,E);rc(118512,17,1,J|0)|0;rc(118536,10,1,J|0)|0;rc(118552,18,1,J|0)|0;tQ(J,f,118576,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,118608)}else{c[G>>2]=Rd(c[L>>2]|0)|0;Iy(26,0,118440,G);G=c[b+536>>2]|0;E=Rd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;Jy(G,(I|0)!=0|0,118488,F)}rc(118616,348,1,I|0)|0;if((sc(H|0)|0)<0){c[D>>2]=Rd(c[L>>2]|0)|0;Iy(26,0,118968,D);Xc(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Sc(118168,250,118992,hd(H|0)|0)|0)==0){Iy(26,0,119016,C);Xc(I|0)|0;O=1;i=j;return O|0}rc(119040,13,1,I|0)|0;rc(119056,12,1,I|0)|0;uQ(I,2);rc(119072,6,1,I|0)|0;vQ(I,c[b+84>>2]|0);rc(119080,8,1,I|0)|0;uQ(I,2);rc(119096,8,1,I|0)|0;C=b+88|0;vQ(I,c[C>>2]|0);rc(119112,10,1,I|0)|0;uQ(I,2);rc(119128,6,1,I|0)|0;vQ(I,118168);rc(119136,8,1,I|0)|0;uQ(I,2);rc(119152,8,1,I|0)|0;vQ(I,c[b+280>>2]|0);rc(119168,10,1,I|0)|0;uQ(I,2);rc(119184,14,1,I|0)|0;vQ(I,c[b+284>>2]|0);rc(119200,16,1,I|0)|0;uQ(I,2);rc(119224,16,1,I|0)|0;vQ(I,l);rc(119248,18,1,I|0)|0;uQ(I,2);c[B>>2]=wQ(l)|0;sd(I|0,119272,B|0)|0;uQ(I,2);P=+Tz(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(I|0,119312,A|0)|0;uQ(I,2);P=+Tz(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];sd(I|0,119352,z|0)|0;uQ(I,2);P=+Tz(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sd(I|0,119384,y|0)|0;uQ(I,2);P=+Tz(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(I|0,119416,x|0)|0;uQ(I,2);P=+Tz(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];sd(I|0,119448,w|0)|0;uQ(I,2);P=+Tz(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sd(I|0,119480,v|0)|0;uQ(I,2);P=+Tz(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sd(I|0,119520,u|0)|0;uQ(I,2);P=+Wz(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];sd(I|0,119552,t|0)|0;uQ(I,2);c[s>>2]=Rz(2)|0;sd(I|0,119592,s|0)|0;uQ(I,2);P=+Vz(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];sd(I|0,119616,r|0)|0;rc(119648,13,1,I|0)|0;rc(119664,16,1,I|0)|0;uQ(I,2);P=+Tz(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];sd(I|0,119688,q|0)|0;uQ(I,2);c[p>>2]=Oz(8)|0;sd(I|0,119712,p|0)|0;rc(119752,17,1,I|0)|0;rc(119776,22,1,I|0)|0;xQ(I,b);rc(119800,23,1,I|0)|0;rc(119824,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{yQ(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{yQ(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{yQ(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{yQ(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{yQ(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{yQ(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{yQ(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{yQ(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}rc(119840,13,1,I|0)|0;rc(119856,12,1,I|0)|0;zQ(I,J,f,c[C>>2]|0,b);rc(119872,13,1,I|0)|0;rc(119888,12,1,I|0)|0;AQ(I,c[b+68>>2]|0,b+56|0);rc(119904,13,1,I|0)|0;rc(119920,16,1,I|0)|0;BQ(I,J,f,b);rc(119944,17,1,I|0)|0;rc(119968,14,1,I|0)|0;Xc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((T1(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(T1(K|0)|0)<<1}else{Q=0}I=p1(b+Q|0)|0;if((I|0)==0){cb(119984,119992,404,120016)}if((ab(J|0)|0)!=0){Iy(26,0,120032,o)}if(e){e=c[C>>2]|0;c[n>>2]=120064;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;ic(I|0,120080,n|0)|0;if((nd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=120160|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;Iy(1,0,120192,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;Gy(1,0,120256,g);q1(I);O=0;i=j;return O|0}function tQ(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=Pz(F)|0;H=Qz(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+Vz(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}rc(118512,17,1,a|0)|0;rc(121424,12,1,a|0)|0;rc(121440,12,1,a|0)|0;rc(121456,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;sd(a|0,121472,D|0)|0;rc(121512,10,1,a|0)|0;rc(121528,11,1,a|0)|0;rc(121544,11,1,a|0)|0;rc(121560,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];sd(a|0,121576,C|0)|0}else{rc(121600,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;sd(a|0,121200,B|0)|0;rc(121624,13,1,a|0)|0;if(E){rc(121440,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(a|0,121640,A|0)|0}else{rc(121600,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;sd(a|0,121664,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;sd(a|0,121320,y|0)|0;rc(121712,10,1,a|0)|0;rc(121728,10,1,a|0)|0;rc(121712,10,1,a|0)|0;rc(121744,11,1,a|0)|0;c[x>>2]=b;sd(a|0,121760,x|0)|0;c[w>>2]=d;sd(a|0,121784,w|0)|0;rc(121800,33,1,a|0)|0;rc(121840,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;sd(a|0,121880,v|0)|0;rc(121560,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];sd(a|0,121576,u|0)|0}else{rc(121728,10,1,a|0)|0;rc(121712,10,1,a|0)|0;rc(121744,11,1,a|0)|0;c[t>>2]=b;sd(a|0,121760,t|0)|0;c[s>>2]=d;sd(a|0,121784,s|0)|0;rc(121800,33,1,a|0)|0;rc(121840,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;sd(a|0,121880,r|0)|0;rc(121560,10,1,a|0)|0;rc(121600,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;sd(a|0,121200,q|0)|0;rc(121624,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];sd(a|0,121640,p|0)|0}else{rc(121600,17,1,a|0)|0}rc(121912,32,1,a|0)|0;rc(121952,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;sd(a|0,121984,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;sd(a|0,121320,n|0)|0;i=m;return}function uQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Nd(32,a|0)|0;}while((d|0)!=0);i=c;return}function vQ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==62){rc(121176,4,1,b|0)|0}else if((e|0)==34){rc(121192,6,1,b|0)|0}else if((e|0)==39){rc(121184,6,1,b|0)|0}else if((e|0)==60){rc(121168,4,1,b|0)|0}else{Nd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function wQ(a){a=a|0;var b=0,c=0,d=0;b=i;c=jc(a|0,121160)|0;if((c|0)==0){d=-1;i=b;return d|0}Vc(c|0,0,2)|0;a=yb(c|0)|0;Xc(c|0)|0;d=a;i=b;return d|0}function xQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=p1((T1(l|0)|0)+15|0)|0;c[f>>2]=l;ic(m|0,120888,f|0)|0;uQ(a,2);rc(120904,10,1,a|0)|0;vQ(a,m);rc(120920,12,1,a|0)|0;uQ(a,2);c[e>>2]=wQ(m)|0;sd(a|0,120936,e|0)|0;q1(m);uQ(a,2);rc(120968,9,1,a|0)|0;uQ(a,4);rc(120984,22,1,a|0)|0;uQ(a,4);rc(121008,22,1,a|0)|0;uQ(a,4);rc(121032,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){DQ(g,m,n);o=c[l>>2]|0;uQ(a,4);rc(121064,8,1,a|0)|0;vQ(a,o);rc(121080,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{IQ(h,m,l);g=c[n>>2]|0;uQ(a,4);rc(121064,8,1,a|0)|0;vQ(a,g);rc(121080,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{DQ(j,m,q);b=c[t>>2]|0;uQ(a,4);rc(121104,8,1,a|0)|0;vQ(a,b);rc(121120,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){uQ(a,2);v=121144;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{IQ(k,m,s);e=c[u>>2]|0;uQ(a,4);rc(121104,8,1,a|0)|0;vQ(a,e);rc(121120,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));uQ(a,2);v=121144;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}function yQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;uQ(a,2);c[f>>2]=c[b>>2];sd(a|0,120824,f|0)|0;vQ(a,c[b+4>>2]|0);rc(120856,11,1,a|0)|0;vQ(a,c[b+8>>2]|0);rc(120528,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];CQ(a,4,e);uQ(a,2);rc(120872,12,1,a|0)|0;i=d;return}function zQ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{DQ(p,r,v);tQ(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,120640);w=v+9|0;Zz(w);uQ(a,2);c[o>>2]=c[f>>2];sd(a|0,120648,o|0)|0;uQ(a,4);rc(119072,6,1,a|0)|0;vQ(a,c[s>>2]|0);rc(119080,8,1,a|0)|0;uQ(a,4);c[n>>2]=Rz(w)|0;sd(a|0,120424,n|0)|0;uQ(a,4);x=+Wz(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(a|0,120448,m|0)|0;uQ(a,4);x=+Vz(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];sd(a|0,119616,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];CQ(a,6,j);uQ(a,2);rc(120672,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function AQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{uQ(a,2);HQ(l,d,x);c[j>>2]=c[q>>2];sd(a|0,120496,j|0)|0;HQ(m,d,x);vQ(a,c[r>>2]|0);rc(120528,3,1,a|0)|0;uQ(a,4);rc(120536,7,1,a|0)|0;HQ(n,d,x);if((c[s>>2]|0)>0){y=0;do{uQ(a,6);c[g>>2]=0;sd(a|0,120544,g|0)|0;y=y+1|0;HQ(n,d,x);}while((y|0)<(c[s>>2]|0))}uQ(a,4);rc(120568,8,1,a|0)|0;uQ(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;HQ(o,d,x);z=+Tz(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;HQ(p,d,x);A=Oz(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;sd(a|0,120584,f|0)|0;uQ(a,2);rc(120624,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function BQ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{IQ(n,o,v-u|0);tQ(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,120376);q=v+9|0;Zz(q);uQ(a,2);rc(120384,15,1,a|0)|0;uQ(a,4);c[m>>2]=c[e>>2];sd(a|0,120400,m|0)|0;uQ(a,4);c[l>>2]=Rz(q)|0;sd(a|0,120424,l|0)|0;uQ(a,4);w=+Wz(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];sd(a|0,120448,j|0)|0;uQ(a,4);w=+Vz(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];sd(a|0,119616,g|0)|0;uQ(a,2);rc(120472,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function CQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;uQ(a,b);rc(120688,16,1,a|0)|0;vQ(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?120792:120808;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;sd(a|0,120712,f|0)|0;i=e;return}function DQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){EQ(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function EQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=jc(c[o>>2]|0,122024)|0;if((p|0)!=0){q=p;break}p=Rd(c[(Nc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;Ky(0,122032,g)}else{q=0}}while(0);g=Bt(0)|0;if((g|0)==0){Ky(0,122064,f)}f=a+8|0;c[a+20>>2]=r1(c[f>>2]|0,32)|0;p=a+12|0;o=r1((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=122096;c[o+12>>2]=0;c[o+16>>2]=0;Mt(g,h);Nt(g,9,69);h=c[n>>2]|0;do{if((h|0)==0){o=j;X1(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Ot(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Wt(Tt(g)|0)|0;s=Ut(g)|0;Xc(q|0)|0;It(g);r=c[a>>2]|0;c[e>>2]=122200;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;Ky(0,122136,e)}else if((t|0)==11){Xc(q|0)|0;break}}else{if((Ot(g,h,T1(h|0)|0,1)|0)!=0){break}s=Wt(Tt(g)|0)|0;o=Ut(g)|0;It(g);r=c[n>>2]|0;c[d>>2]=122200;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;Ky(0,122240,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(122304,122200,295,122344)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(122368,122200,297,122344)}}function FQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((P1(122776,b)|0)==0){if((P1(c[d>>2]|0,122784)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}Jy(0,p,122792,l);l=c[30658]|0;p=c[30712]|0;do{if((l|0)==0|(p|0)==0){c[30712]=32;a=p1(1152)|0;c[30658]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[30712]=p<<1;a=s1(l,p*72|0)|0;c[30658]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(LQ(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((P1(122856,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((P1(122864,u)|0)==0){c[30718]=vd(c[t+4>>2]|0)|0}else{if((P1(122896,u)|0)==0){c[122876>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((P1(122912,u)|0)==0){c[122884>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((P1(122920,u)|0)==0){c[122880>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((P1(122936,u)|0)==0){c[122888>>2]=Ub(c[t+4>>2]|0,0,10)|0;break}if((P1(122944,u)|0)!=0){v=23;break a}c[122892>>2]=(P1(c[t+4>>2]|0,122960)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];Ky(0,122968,k)}else if((v|0)==45){i=e;return}}if((P1(122616,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=122200;c[j+4>>2]=k;c[j+8>>2]=v;Ky(0,123e3,j)}if((P1(123064,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=122200;c[h+4>>2]=j;Ky(0,123072,h)}h=Ub(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=122200;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;Ky(0,123128,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=123192;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((P1(122560,b)|0)!=0){if((P1(122752,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=123296;m=vd(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=123304;i=e;return}c[122580>>2]=0;c[122584>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((P1(m,122784)|0)==0){c[122580>>2]=vd(c[b+4>>2]|0)|0}else{if((P1(m,123248)|0)!=0){break}c[122584>>2]=vd(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[122580>>2]|0)==0){w=0;break}w=(c[122584>>2]|0)!=0|0}}while(0);Jy(0,w,123256,f);c[30644]=-1;f=122588|0;w=122872;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function GQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((P1(122560,b)|0)==0){o=e+0|0;p=122576|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));KQ(e);i=d;return}if((P1(122616,b)|0)==0){e=h+24|0;r=p1((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=p1(36)|0;t=s;o=s+0|0;p=(c[30658]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((P1(122640,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;wd(e+(k*20|0)+8|0,122648,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((P1(122688,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;wd(h+(k*20|0)+8|0,122704,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((P1(122752,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function HQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){EQ(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function IQ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){EQ(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;Ky(0,122408,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=122488;p=o;Ky(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=122488;p=o;Ky(0,p,f)}}function JQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){q1(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){q1(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}q1(k);c[d>>2]=0;i=b;return}function KQ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=p1(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=T1(f|0)|0;c[e+64>>2]=k;k=c[30692]|0;do{if((k|0)==0){c[30692]=e;c[e+44>>2]=0;l=p1(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){vc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=p1(384)|0;c[l>>2]=n;if((n|0)==0){vc(-1)}else{X1(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[30692]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[30692]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=T1(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(T1(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 1:{B=o;C=x;D=y;E=22;break};case 4:{F=o;G=y;E=19;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;H=z;E=13;break};case 3:{I=o;J=x;K=y;E=20;break};case 5:{L=o;M=y;E=18;break};case 9:{N=o;E=14;break};case 2:{O=o;P=x;Q=y;E=21;break};case 10:{H=o;E=13;break};case 7:{R=o;S=y;E=16;break};case 8:{T=o;E=15;break};case 6:{U=o;V=y;E=17;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+H|0;c[p>>2]=o;N=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+N|0;c[p>>2]=o;T=o;E=15}if((E|0)==15){R=T;S=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){U=R;V=((d[A+6|0]|0)<<16)+S|0;E=17}if((E|0)==17){L=U;M=((d[A+5|0]|0)<<8)+V|0;E=18}if((E|0)==18){F=L;G=(d[A+4|0]|0)+M|0;E=19}if((E|0)==19){I=F;J=((d[A+3|0]|0)<<24)+x|0;K=G;E=20}if((E|0)==20){O=I;P=((d[A+2|0]|0)<<16)+J|0;Q=K;E=21}if((E|0)==21){B=O;C=((d[A+1|0]|0)<<8)+P|0;D=Q;E=22}if((E|0)==22){W=B;X=(d[A]|0)+C|0;Y=D}D=X-Y-W^W>>>13;X=Y-W-D^D<<8;Y=W-D-X^X>>>13;W=D-X-Y^Y>>>12;D=X-Y-W^W<<16;X=Y-W-D^D>>>5;Y=W-D-X^X>>>3;W=D-X-Y^Y<<10;D=X-Y-W^W>>>15;c[p>>2]=D;p=(c[30692]|0)+40|0;W=c[p>>2]|0;Y=D&(c[W+4>>2]|0)+ -1;D=c[W>>2]|0;W=D+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[D+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[30692]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[30692]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=p1((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){vc(-1)}X1(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;D=c[j>>2]|0;c[Y+24>>2]=(((D<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((D|0)==0){_=e}else{D=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=D}else{W=D;X=j;while(1){j=X+16|0;C=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];B=Z+(A*12|0)+4|0;E=(c[B>>2]|0)+1|0;c[B>>2]=E;Q=c[W+24>>2]|0;if(E>>>0>Q>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[B>>2]|0)>>>0)/(Q>>>0)|0}c[X+12>>2]=0;Q=Z+(A*12|0)|0;c[j>>2]=c[Q>>2];j=c[Q>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[Q>>2]=X;Q=c[h>>2]|0;if((C|0)==0){$=Q;break}else{W=Q;X=C}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){D=$;Y=W;e=X}else{_=W;break}}}q1(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function LQ(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[30692]|0)==0){f=24}else{g=T1(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(T1(a|0)|0)+s|0;switch(v|0){case 1:{x=h;y=t;z=u;f=15;break};case 3:{A=h;B=t;C=u;f=13;break};case 2:{D=h;E=t;F=u;f=14;break};case 7:{G=h;H=u;f=9;break};case 10:{I=h;f=6;break};case 4:{J=h;K=u;f=12;break};case 5:{L=h;M=u;f=11;break};case 9:{N=h;f=7;break};case 11:{I=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 6:{O=h;P=u;f=10;break};case 8:{Q=h;f=8;break};default:{R=h;S=t;T=u}}if((f|0)==6){N=((d[w+9|0]|0)<<16)+I|0;f=7}if((f|0)==7){Q=((d[w+8|0]|0)<<8)+N|0;f=8}if((f|0)==8){G=Q;H=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){O=G;P=((d[w+6|0]|0)<<16)+H|0;f=10}if((f|0)==10){L=O;M=((d[w+5|0]|0)<<8)+P|0;f=11}if((f|0)==11){J=L;K=(d[w+4|0]|0)+M|0;f=12}if((f|0)==12){A=J;B=((d[w+3|0]|0)<<24)+t|0;C=K;f=13}if((f|0)==13){D=A;E=((d[w+2|0]|0)<<16)+B|0;F=C;f=14}if((f|0)==14){x=D;y=((d[w+1|0]|0)<<8)+E|0;z=F;f=15}if((f|0)==15){R=x;S=(d[w]|0)+y|0;T=z}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[30692]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=T1(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((O1(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,123328)|0)==0){V=0;break}else{W=123352}i=b;return W|0}}while(0);c[e>>2]=a;Jy(0,(V|0)!=0|0,123400,e);W=V+4|0;i=b;return W|0}function MQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((NQ(123456,a,b)|0)!=0){d=1;i=c;return d|0}d=(NQ(123464,a,b)|0)!=0|0;i=c;return d|0}function NQ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((P1(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function OQ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(P1(c[72036>>2]|0,123472)|0)==0|0;Jy(0,m,123488,l);l=(P1(c[73940>>2]|0,123472)|0)==0|0;Jy(0,l,123544,k);k=(P1(c[75932>>2]|0,123472)|0)==0|0;Jy(0,k,123600,j);j=123664|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=123792|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[75936+(k<<2)>>2]|0;if((l|0)==1){if((NQ(c[71912+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[71912+(k<<2)>>2]|0;if(!((NQ(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[71912+(k<<2)>>2]|0;if((QQ(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=123664+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=123664+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[123792+(k<<2)>>2]=PQ(r,p)|0;t=j}else if((q|0)==13){q=0;l=123664+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[123792+(k<<2)>>2]=RQ(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];Iy(1,0,123920,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];Iy(1,0,123920,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];Iy(1,0,123920,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];Iy(1,0,123976,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function PQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((P1(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function QQ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(RQ(a,b)|0)!=0|0;i=c;return d|0}function RQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=T1(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((Q1(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function SQ(){i=i;return}function TQ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){vc(0)}e=c[r>>2]|0;rc(124008,5,1,e|0)|0;f=b;b=0;while(1){Nd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}rc(124016,20,1,e|0)|0;vc(0);return 0}function UQ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;sd(d|0,124040,e|0)|0;if((b|0)==0){vc(1)}else{qd(d|0)|0;aR();qd(d|0)|0;ib(6,0)|0;ed()}}function VQ(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function WQ(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function XQ(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function YQ(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function ZQ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function _Q(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}X1(p|0,32,b+(d-p)|0)|0;i=f;return}function $Q(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=125080+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[125124+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[125120+(e*48|0)>>2]|0)==1){bR(b)|0}k=125084+(e*48|0)|0;if((c[k>>2]|0)==0){break}Xc(c[f>>2]|0)|0;q1(c[k>>2]|0)}}while(0);do{if((h|0)==10){Xc(g|0)|0;b=125084+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Ed(k|0)|0;q1(c[b>>2]|0)}}while(0);c[f>>2]=0}c[125116+(e*48|0)>>2]=0;c[125084+(e*48|0)>>2]=0;i=d;return 0}function aR(){var a=0,b=0;a=i;if((c[31012]|0)!=0){i=a;return}c[31012]=1;c[124056>>2]=0;b=0;do{c[124052>>2]=b;$Q(124048)|0;b=b+1|0;}while((b|0)<100);i=a;return}function bR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[125096+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=125080+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;Vc(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[125100+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[125108+(d*48|0)>>2]&2|0)!=0){qd(c[f>>2]|0)|0}d=Tc(rb(c[f>>2]|0)|0,h|0)|0;Vc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){dR(111,124064);e=111;i=b;return e|0}else{c[(Nc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function cR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function dR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Qc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;sd(m|0,124976,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;sd(m|0,125008,j|0)|0;l=m;break}else{n=c[124848+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;sd(m|0,125032,h|0)|0;l=m;break}}}while(0);h=c[31260]|0;do{if((h|0)==0){rc(129912,29,1,l|0)|0}else{c[g>>2]=(h-125080|0)/48|0;sd(l|0,125048,g|0)|0;b=c[(c[31260]|0)+4>>2]|0;if((b|0)==0){rc(129896,10,1,l|0)|0;break}else{c[f>>2]=b;sd(l|0,129880,f|0)|0;break}}}while(0);f=c[32486]|0;if((f|0)!=0){c[d>>2]=f;sd(l|0,129952,d|0)|0}d=(c[32506]|0)!=0?130032:130048;f=(c[32514]|0)!=0?130064:130080;g=(c[32524]|0)!=0?130104:130120;c[e>>2]=(c[32500]|0)!=0?130008:130016;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;sd(l|0,129976,e|0)|0;UQ(130136,1)}function eR(){var a=0,b=0;a=i;c[32536]=1;b=c[r>>2]|0;c[31270]=b;c[125100>>2]=cR(b)|0;c[125104>>2]=1;c[125120>>2]=1;b=c[s>>2]|0;c[125320>>2]=b;c[125340>>2]=cR(b)|0;c[125344>>2]=1;c[125360>>2]=0;b=c[t>>2]|0;c[125368>>2]=b;c[125388>>2]=cR(b)|0;c[125392>>2]=1;c[125408>>2]=1;i=a;return}function fR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=xc(g|0,c[135392+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[32538]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=xc(c[f>>2]|0,c[135392+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[32538]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Vc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Nc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Vc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function gR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){dR(b,d)}d=c[32540]|0;if((d|0)!=0){xe[d&7]()|0}c[(Nc()|0)>>2]=b;i=e;return b|0}function hR(a){a=a|0;var b=0,d=0;b=i;c[32570]=0;c[32572]=0;c[32574]=0;d=((iR(a,0)|0)==0)<<31>>31;i=b;return d|0}function iR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==32){f=g}else if(b<<24>>24==40){break}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[32574]|0;c[32574]=j+1;if((j|0)==1){c[32572]=d}if((nR(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=oR(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function jR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[32570]|0;l=130304+(k<<4)|0;m=c[l>>2]|0;switch(kR(m)|0){case 18:{c[32546]=1;c[32570]=k+1;continue b;break};case 9:{n=(de[c[32554]&127](l)|0)==0;c[32570]=(c[32570]|0)+1;if(n){break b}else{continue b}break};case 33:{c[33814]=1;c[32570]=k+1;continue b;break};case 16:{if(b){o=28;break a}c[32570]=k+1;continue b;break};case 6:{n=c[130308+(k<<4)>>2]|0;p=(c[33786]|0)+1|0;c[33786]=p;c[135152+(p<<2)>>2]=n;c[32570]=k+1;continue b;break};case 20:{c[32566]=c[130308+(k<<4)>>2];c[32570]=k+1;continue b;break};case 8:{n=c[33786]|0;q=135152+(n<<2)|0;s=c[q>>2]|0;if((s|0)>=1){o=10;break b}c[33786]=n+ -1;c[32570]=k+1;continue b;break};case 1:{n=c[130308+(k<<4)>>2]|0;p=(c[33802]|0)+1|0;c[33802]=p;c[135216+(p<<2)>>2]=n;c[32570]=k+1;continue b;break};case 19:case 17:{c[32546]=0;c[32570]=k+1;continue b;break};case 21:{c[32548]=0;c[32570]=k+1;continue b;break};case 2:{c[33786]=0;c[33802]=0;c[32570]=c[130308+(k<<4)>>2];if(b){o=24;break a}if((c[33798]|0)==0){j=0;o=37;break a}n=xe[c[32556]&7]()|0;if((n|0)==0){continue b}else{j=n;o=37;break a}break};case 22:{c[32548]=1;c[32570]=k+1;continue b;break};case 3:{n=c[33786]|0;p=135152+(n<<2)|0;t=c[p>>2]|0;c[p>>2]=t+ -1;if((t|0)<2){c[33786]=n+ -1;c[33802]=(c[33802]|0)+ -1;c[32570]=k+1;continue b}else{k=c[33802]|0;c[33802]=k+ -1;c[32570]=(c[135216+(k<<2)>>2]|0)+1;continue b}break};default:{o=4;break a}}}if((o|0)==10){o=0;if(b){o=11;break}c[q>>2]=s+ -1;c[33798]=1;k=ge[c[32552]&63](l,g,d)|0;if((k|0)>0){o=13;break}if((k|0)<0){o=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;o=37;break}}if((o|0)==4){h=c[r>>2]|0;d=c[32486]|0;c[f>>2]=m;c[f+4>>2]=d;sd(h|0,135104,f|0)|0;if((c[c[32542]>>2]|0)==0){dR(100,135136);j=100;i=e;return j|0}else{c[(Nc()|0)>>2]=100;j=100;i=e;return j|0}}else if((o|0)==11){j=xe[c[32540]&7]()|0;i=e;return j|0}else if((o|0)==13){f=c[c[32542]>>2]|0;j=gR(f,c[(Nc()|0)>>2]|0,135200)|0;i=e;return j|0}else if((o|0)==15){if((c[(c[32542]|0)+8>>2]|0)==0){dR(-1,135200);j=-1;i=e;return j|0}else{c[(Nc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((o|0)==24){j=xe[c[32540]&7]()|0;i=e;return j|0}else if((o|0)==28){j=xe[c[32540]&7]()|0;i=e;return j|0}else if((o|0)==37){i=e;return j|0}return 0}function kR(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function lR(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=jR(b,0,0)|0;i=a;return d|0}function mR(){c[32562]=0;c[32570]=0;c[33802]=0;c[33786]=0;c[33798]=0;c[33804]=0;c[33788]=0;i=i;return}function nR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[32570]|0;if((g|0)>299){rc(135280,24,1,c[r>>2]|0)|0;UQ(c[32486]|0,1)}else{c[130304+(g<<4)>>2]=a;c[130308+(g<<4)>>2]=b;c[130312+(g<<4)>>2]=d;c[130316+(g<<4)>>2]=e;c[32570]=g+1;i=f;return g|0}return 0}function oR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=pR(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[32574]|0)+ -1|0;c[32574]=h;if((h|0)==0){nR(2,c[32572]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{nR(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function pR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((qR(b,e)|0)!=0){g=c[e>>2]|0;break}if((rR(b,e)|0)!=0){g=c[e>>2]|0;break}h=sR(b,f,1)|0;j=nR(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=iR(h,j)|0}}while(0);i=d;return g|0}function qR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 120:case 88:{nR(4,1,0,0)|0;g=b;h=30;break};case 116:case 84:{j=b+1|0;k=a[j]|0;if(k<<24>>24==82|k<<24>>24==114){l=j;m=14}else if(k<<24>>24==76|k<<24>>24==108){l=j;m=13}else{l=b;m=15}j=sR(l+1|0,f,0)|0;if((j|0)==0){h=15;break a}nR(m,c[f>>2]|0,0,0)|0;g=j+ -1|0;h=30;break};case 47:{nR(5,0,0,0)|0;g=b;h=30;break};case 39:case 34:case 2:{c[130312+((nR(11,0,0,0)|0)<<4)>>2]=b;j=tR(b)|0;c[d>>2]=j;n=(j|0)!=0|0;i=e;return n|0};case 45:{o=1;h=13;break};case 43:{o=0;h=13;break};case 58:{nR(16,0,0,0)|0;g=b;h=30;break};case 112:case 80:{nR(20,1,0,0)|0;g=b;h=30;break};case 98:case 66:{j=b+1|0;k=a[j]|0;if(k<<24>>24==90|k<<24>>24==122){nR(22,0,0,0)|0;g=j;h=30;break a}else{nR(21,0,0,0)|0;g=j;h=30;break a}break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{p=b;q=0;h=14;break};case 36:{nR(33,0,0,0)|0;g=b;h=30;break};case 115:case 83:{j=b+1|0;k=a[j]|0;if(k<<24>>24==83|k<<24>>24==115){r=j;s=19}else if(k<<24>>24==80|k<<24>>24==112){r=j;s=18}else{r=b;s=17}nR(s,0,0,0)|0;g=r;h=30;break};default:{n=0;i=e;return n|0}}}while(0);if((h|0)==13){p=b+1|0;q=o;h=14}b:do{if((h|0)==14){o=sR(p,f,0)|0;if((o|0)==0){h=15;break}switch(a[o]|0){case 104:case 72:{b=c[f>>2]|0;c[130312+((nR(12,b,0,0)|0)<<4)>>2]=o+1;g=o+b|0;h=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((q|0)==0){t=b}else{r=0-b|0;c[f>>2]=r;t=r}nR(20,t,0,0)|0;g=o;h=30;break b;break};case 120:case 88:{nR(4,c[f>>2]|0,0,0)|0;g=o;h=30;break b;break};default:{n=0;i=e;return n|0}}}}while(0);if((h|0)==15){c[d>>2]=0;n=1;i=e;return n|0}else if((h|0)==30){c[d>>2]=g+1;n=1;i=e;return n|0}return 0}function rR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=sR(b,f,1)|0;nR(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 102:case 70:{l=sR(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=sR(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}nR(23,n,r,0)|0;o=q;m=45;break};case 108:case 76:{n=sR(f,g,0)|0;if((n|0)==0){m=4;break a}l=c[g>>2]|0;if((l|0)==0){o=n;m=45;break a}nR(29,l,0,0)|0;o=n;m=45;break};case 111:case 79:{s=32;t=34;m=38;break};case 97:case 65:{n=f;while(1){u=a[n]|0;if(u<<24>>24==32){n=n+1|0}else{break}}if(!((u+ -48<<24>>24&255)<10)){nR(30,0,0,0)|0;o=n;m=45;break a}l=sR(n,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}nR(31,p,0,0)|0;o=l;m=45;break};case 100:case 68:{l=sR(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}if((a[l]|0)==46){v=sR(l+1|0,h,0)|0;if((v|0)==0){m=4;break a}w=v;x=c[h>>2]|0}else{c[h>>2]=0;w=l;x=0}nR(26,p,x,0)|0;o=w;m=45;break};case 103:case 71:{y=0;m=3;break};case 101:case 69:{y=1;m=3;break};case 105:case 73:{s=7;t=10;m=38;break};case 122:case 90:{s=35;t=36;m=38;break};default:{c[32570]=(c[32570]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((m|0)==3){b=sR(f,g,0)|0;if((b|0)==0){m=4;break}w=c[g>>2]|0;if((w|0)==0){o=b;m=45;break}x=a[b]|0;if(x<<24>>24==46){u=sR(b+1|0,h,0)|0;if((u|0)==0){m=4;break}A=u;B=a[u]|0}else{c[h>>2]=0;A=b;B=x}if(!(B<<24>>24==101|B<<24>>24==69)){nR((y|0)==1?24:27,w,c[h>>2]|0,0)|0;o=A;m=45;break}x=sR(A+1|0,j,0)|0;if((x|0)==0){m=4;break}nR((y|0)==1?25:28,w,c[h>>2]|0,c[j>>2]|0)|0;o=x;m=45}else if((m|0)==38){x=sR(f,g,0)|0;if((x|0)==0){m=4;break}w=c[g>>2]|0;if((w|0)==0){o=x;m=45;break}if((a[x]|0)!=46){nR(s,w,0,0)|0;o=x;m=45;break}b=sR(x+1|0,h,0)|0;if((b|0)==0){m=4;break}nR(t,w,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((m|0)==45){c[d>>2]=o;z=1;i=e;return z|0}return 0}function sR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function tR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[32542]>>2]|0)==0){dR(100,135264);n=0;i=d;return n|0}else{c[(Nc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function uR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[135334|0]=48;k=135334|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=135312+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function vR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[32564]|0;f=c[32560]|0;if((e|0)>(f|0)){c[32560]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[33852]|0)){h=g}else{wR(f,g);h=c[32560]|0}g=c[33854]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Fd(g|0,c[32538]|0)|0;h=T1(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Nd(a[k]|0,c[32538]|0)|0;Fd(h|0,c[32538]|0)|0;b=T1(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function wR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[33854]|0;if((f|0)==135496){c[33852]=1024;g=1024}else{g=c[33852]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[33852]=j;h=j}j=p1(h)|0;if((j|0)==0){dR(113,135896);k=c[33854]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[33854]|0}else{l=k}if((l|0)==135496){m=135416;c[33854]=j;i=e;return}q1(l);m=135416;c[33854]=j;i=e;return}function xR(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[32560]|0;f=c[33852]|0;if((e|0)<(f|0)){g=e}else{wR(e,f);g=c[32560]|0}c[32560]=g+1;a[(c[33854]|0)+g|0]=b;i=d;return}function yR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[32524]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){dR(101,135424);l=101;i=d;return l|0}else{c[(Nc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[32536]|0)==0){eR();m=c[f>>2]|0}else{m=k}k=125080+(m*48|0)|0;c[31260]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){DR(k,c[b+12>>2]|0,j);o=ER(j,h)|0;if((o|0)==(c[125088+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[125092+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=$Q(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[125112+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=125096+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[125112+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=125104+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[125104+(m*48|0)>>2]=1;r=1;break}else{c[125104+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];ic(j|0,135432,e|0)|0}else{DR(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){zR(107,135424,b);l=107;i=d;return l|0}else{c[(Nc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=125124+(m*48|0)|0;c[q>>2]=0;c[125116+(m*48|0)>>2]=0;e=125120+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=125108+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 78:case 110:{if((Cc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){zR(128,135424,b);l=128;i=d;return l|0}else{c[(Nc()|0)>>2]=128;l=128;i=d;return l|0}break};case 79:case 111:{if((Cc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Nc()|0;s=c[k>>2]|0;if(o){zR(s,135424,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;s=Lb()|0;c[n>>2]=s;if((s|0)!=0){c[125084+(m*48|0)>>2]=0;c[125092+(m*48|0)>>2]=-1;c[125088+(m*48|0)>>2]=-1;c[125100+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Nc()|0;o=c[k>>2]|0;if(s){zR(o,135424,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=jc(j|0,c[33848]|0)|0;if((o|0)==0){break}Xc(o|0)|0}}while(0);q=p1((T1(j|0)|0)+1|0)|0;c[125084+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){zR(113,135448,b);l=113;i=d;return l|0}else{c[(Nc()|0)>>2]=113;l=113;i=d;return l|0}}Z1(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=jc(j|0,c[135392+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=jc(j|0,c[135352+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=jc(j|0,c[135392+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Nc()|0;o=c[g>>2]|0;if(h){dR(o,135424);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=125100+(m*48|0)|0;c[r>>2]=cR(u)|0;u=ER(j,125092+(m*48|0)|0)|0;c[125088+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){zR(108,135424,b);l=108;i=d;return l|0}else{c[(Nc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Vc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){zR(129,135424,b);l=129;i=d;return l|0}else{c[(Nc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function zR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){dR(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[33852]|0)){j=d;k=g}else{wR(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[33854]|0;c[(c[31260]|0)+4>>2]=f;DR(k,j,f);dR(a,b);i=e;return}function AR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;ic(j|0,135432,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=T1(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?135464:135472;c[h+24>>2]=(b|0)==5?135480:135488;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=yR(h)|0;i=e;return a|0}function BR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=125080+(d*48|0)|0;c[31260]=e;if(d>>>0>99){if((c[a>>2]|0)==0){dR(101,135912);f=101;i=b;return f|0}else{c[(Nc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((AR(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){dR(114,135920);f=114;i=b;return f|0}else{c[(Nc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[125104+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){dR(102,135920);f=102;i=b;return f|0}else{c[(Nc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function CR(){var a=0,b=0;a=i;b=lR()|0;c[32486]=0;i=a;return b|0}function DR(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function ER(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((mc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function FR(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[32566]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[32546]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];ic(p|0,135928,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(T1(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;ae[c[32550]&255](32);}while((A|0)>0)}if((D|0)!=0){ae[c[32550]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{ae[c[32550]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Fc(A|0)|0)+1|0;c[m>>2]=t-(c[32566]|0);ic(A|0,135936,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;ae[c[32550]&255](32);}while((z|0)>0)}if((x|0)!=0){ae[c[32550]&255]((w|0)!=0?45:43)}z=c[32566]|0;do{if((z|0)<1){ae[c[32550]&255](46);y=c[32550]|0;if((z|0)<0){G=y;J=z;while(1){ae[G&255](48);I=J+1|0;K=c[32550]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}ae[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}ae[c[32550]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[32550]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){ae[P&255](a[J]|0);R=Q+ -1|0;S=c[32550]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}ae[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;ae[c[32550]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){ae[c[32550]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;ae[c[32550]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){ae[c[32550]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;ae[c[32550]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;ae[c[32550]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;ae[c[32550]&255](42);}while((_|0)>0);i=l;return 0}function GR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[32566]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(ic(n|0,135944,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[32546]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;ae[c[32550]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;ae[c[32550]&255](32);}while((b|0)>0)}do{if(q){if((c[32546]|0)==0){break}ae[c[32550]&255](43)}else{ae[c[32550]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;ae[c[32550]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;ae[c[32550]&255](48);}while((z|0)>0);i=j;return 0}function HR(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{ae[c[32550]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[32550]|0;if((h|0)==0){ae[d&255](70);i=g;return 0}else{ae[d&255](84);i=g;return 0}return 0}function IR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[32562]|0)!=0){g=JR()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 34:{LR(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 10:{LR(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 7:{KR(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 28:case 27:{h=OR(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 23:{h=GR(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 30:{MR(b,d);h=0;i=e;return h|0};case 32:{KR(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 29:{HR(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 31:{NR(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=FR(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 36:{PR(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 35:{PR(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;sd(h|0,135952,f|0)|0;UQ(c[32486]|0,1)}}return 0}function JR(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[32562]|0;c[32562]=0;if((c[32524]|0)!=0){if((b|0)>0){d=c[32564]|0;e=c[32560]|0;if((d|0)<=(e|0)){f=b;while(1){ae[c[32550]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[32560]=f;h=0;i=a;return h|0}f=b-d+e|0;c[32560]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){ae[c[32550]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[32560]|0;f=j+b|0;if((f|0)>=0){if((c[32564]|0)<(j|0)){c[32564]=j}c[32560]=f;h=0;i=a;return h|0}if((c[c[32542]>>2]|0)==0){dR(110,136040);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[32560]|0;if((c[32564]|0)<(f|0)){c[32564]=f}j=f+b|0;c[32560]=j;c[32568]=(c[32568]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[32542]>>2]|0)==0){dR(110,136040);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[32560]|0;f=j+b|0;if((f|0)>=(c[(c[32544]|0)+16>>2]|0)){if((c[c[32542]>>2]|0)==0){dR(110,136056);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[32564]|0;if((d|0)<=(j|0)){e=b;while(1){ae[c[32550]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[32568]=(c[32568]|0)+b;c[32560]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[32568]=(c[32568]|0)+f;c[32560]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){ae[c[32550]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function KR(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==1){l=a[d]|0}else if((f|0)==4){l=c[d>>2]|0}else{l=b[d>>1]|0}d=uR(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[32546]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{ae[c[32550]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{ae[c[32550]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[32546]|0)==0){break}ae[c[32550]&255](43)}else{ae[c[32550]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){ae[c[32550]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function LR(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=uR(m,k,l,h)|0;h=c[l>>2]|0;g=(c[32546]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{ae[c[32550]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{ae[c[32550]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[32546]|0)==0){break}ae[c[32550]&255](43)}else{ae[c[32550]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){ae[c[32550]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){ae[c[32550]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{ae[c[32550]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function MR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;ae[c[32550]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function NR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;ae[c[32550]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;ae[c[32550]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function OR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=FR(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=FR(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[32566]|0;c[32566]=0;p=(e|0)==0?4:e+2|0;e=GR(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{ae[c[32550]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[32566]=o;n=e;i=j;return n|0}function PR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{ae[c[32550]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;ae[c[32550]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;ae[c[32550]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){ae[c[32550]&255](a[136016+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){ae[c[32550]&255](a[136016+((d[p]|0)>>>4)|0]|0);ae[c[32550]&255](a[136016+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function QR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 15:{c[32562]=(c[a+4>>2]|0)+ -1-(c[32560]|0);f=1;i=b;return f|0};case 5:{f=xe[c[32558]&7]()|0;i=b;return f|0};case 11:{f=RR(c[a+8>>2]|0)|0;i=b;return f|0};case 13:{g=(c[32562]|0)-(c[a+4>>2]|0)|0;h=0-(c[32560]|0)|0;c[32562]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 4:case 14:{c[32562]=(c[32562]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 12:{f=SR(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;sd(f|0,135984,d|0)|0;UQ(c[32486]|0,1)}}return 0}function RR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[32562]|0)!=0){e=JR()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}ae[c[32550]&255](e<<24>>24);n=b}else{ae[c[32550]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function SR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[32562]|0)!=0){f=JR()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;ae[c[32550]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function TR(){var a=0,b=0;a=i;b=vR(10)|0;c[32562]=0;c[32560]=0;c[32564]=0;i=a;return(b|0)==0|0}function UR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[32536]|0)==0){eR()}c[32500]=0;c[32506]=1;c[32514]=1;c[32524]=1;d=BR(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[32542]=a;c[32560]=0;c[32562]=0;c[32564]=0;c[33814]=0;c[32566]=0;d=c[a+12>>2]|0;c[32486]=d;c[32538]=c[c[31260]>>2];if((hR(d)|0)<0){if((c[a>>2]|0)==0){dR(100,136064);e=100;i=b;return e|0}else{c[(Nc()|0)>>2]=100;e=100;i=b;return e|0}}c[32550]=232;c[32552]=45;c[32554]=111;c[32540]=4;c[32556]=5;c[32558]=6;mR();c[32546]=0;d=c[31260]|0;c[32548]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((fR(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Nc()|0;f=c[a>>2]|0;if(d){dR(f,136072);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function VR(){var a=0,b=0;a=i;if((c[33814]|0)==0){b=vR(10)|0}else{vR(0)|0;qd(c[32538]|0)|0;b=0}c[32562]=0;c[32560]=0;c[32564]=0;i=a;return b|0}function WR(){var a=0,b=0,d=0;a=i;if((c[33798]|0)==0){b=0}else{d=vR(10)|0;c[33798]=0;b=d}c[32562]=0;c[32560]=0;c[32564]=0;i=a;return b|0}function XR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;rS(136800,h,136856);c[34022]=138308;c[136096>>2]=138328;c[136092>>2]=0;iU(136096|0,136800);c[136168>>2]=0;c[136172>>2]=-1;j=c[t>>2]|0;c[34226]=138176;SZ(136908|0);k=136912|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[34226]=137416;c[136936>>2]=j;TZ(g,136908|0);k=WZ(g,140968)|0;l=k;UZ(g);c[136940>>2]=l;c[136944>>2]=136864;a[136948|0]=(de[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[34044]=138388;c[136180>>2]=138408;iU(136180|0,136904);c[136252>>2]=0;c[136256>>2]=-1;l=c[r>>2]|0;c[34238]=138176;SZ(136956|0);k=136960|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[34238]=137416;c[136984>>2]=l;TZ(f,136956|0);k=WZ(f,140968)|0;g=k;UZ(f);c[136988>>2]=g;c[136992>>2]=136872;a[136996|0]=(de[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[34066]=138388;c[136268>>2]=138408;iU(136268|0,136952);c[136340>>2]=0;c[136344>>2]=-1;g=c[(c[(c[34066]|0)+ -12>>2]|0)+136288>>2]|0;c[34088]=138388;c[136356>>2]=138408;iU(136356|0,g);c[136428>>2]=0;c[136432>>2]=-1;c[(c[(c[34022]|0)+ -12>>2]|0)+136160>>2]=136176;g=(c[(c[34066]|0)+ -12>>2]|0)+136268|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[34066]|0)+ -12>>2]|0)+136336>>2]=136176;dS(137e3,h,136880|0);c[34110]=138348;c[136448>>2]=138368;c[136444>>2]=0;iU(136448|0,137e3);c[136520>>2]=0;c[136524>>2]=-1;c[34264]=138240;SZ(137060|0);h=137064|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[34264]=137160;c[137088>>2]=j;TZ(e,137060|0);j=WZ(e,140976)|0;h=j;UZ(e);c[137092>>2]=h;c[137096>>2]=136888;a[137100|0]=(de[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[34132]=138428;c[136532>>2]=138448;iU(136532|0,137056);c[136604>>2]=0;c[136608>>2]=-1;c[34276]=138240;SZ(137108|0);h=137112|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[34276]=137160;c[137136>>2]=l;TZ(d,137108|0);l=WZ(d,140976)|0;h=l;UZ(d);c[137140>>2]=h;c[137144>>2]=136896;a[137148|0]=(de[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[34154]=138428;c[136620>>2]=138448;iU(136620|0,137104);c[136692>>2]=0;c[136696>>2]=-1;h=c[(c[(c[34154]|0)+ -12>>2]|0)+136640>>2]|0;c[34176]=138428;c[136708>>2]=138448;iU(136708|0,h);c[136780>>2]=0;c[136784>>2]=-1;c[(c[(c[34110]|0)+ -12>>2]|0)+136512>>2]=136528;h=(c[(c[34154]|0)+ -12>>2]|0)+136620|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[34154]|0)+ -12>>2]|0)+136688>>2]=136528;i=b;return}function YR(a){a=a|0;a=i;gV(136176)|0;gV(136352)|0;nV(136528)|0;nV(136704)|0;i=a;return}function ZR(a){a=a|0;var b=0;b=i;c[a>>2]=138240;UZ(a+4|0);i=b;return}function _R(a){a=a|0;var b=0;b=i;c[a>>2]=138240;UZ(a+4|0);x1(a);i=b;return}function $R(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=WZ(d,140976)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(de[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function aS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=te[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((qd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function bS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=rc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((se[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function cS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Be[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function dS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=138240;j=b+4|0;SZ(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=137272;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;TZ(g,j);j=WZ(g,140976)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=de[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(de[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){cZ(137368)}else{UZ(g);i=f;return}}function eS(a){a=a|0;var b=0;b=i;c[a>>2]=138240;UZ(a+4|0);i=b;return}function fS(a){a=a|0;var b=0;b=i;c[a>>2]=138240;UZ(a+4|0);x1(a);i=b;return}function gS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=WZ(d,140976)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=de[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(de[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){cZ(137368)}else{i=e;return}}function hS(a){a=a|0;var b=0,c=0;b=i;c=kS(a,0)|0;i=b;return c|0}function iS(a){a=a|0;var b=0,c=0;b=i;c=kS(a,1)|0;i=b;return c|0}function jS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Be[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((md(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}



function Ee(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Fe(){return i|0}function Ge(a){a=a|0;i=a}function He(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ie(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Je(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ke(a){a=a|0;J=a}function Le(a){a=a|0;K=a}function Me(a){a=a|0;L=a}function Ne(a){a=a|0;M=a}function Oe(a){a=a|0;N=a}function Pe(a){a=a|0;O=a}function Qe(a){a=a|0;P=a}function Re(a){a=a|0;Q=a}function Se(a){a=a|0;R=a}function Te(a){a=a|0;S=a}function Ue(a){a=a|0;var b=0,d=0;b=i;cD(a)|0;d=a+540|0;de[c[(c[d>>2]|0)+40>>2]&127](a)|0;de[c[(c[d>>2]|0)+28>>2]&127](a)|0;de[c[(c[d>>2]|0)+32>>2]&127](a)|0;de[c[(c[d>>2]|0)+48>>2]&127](a)|0;de[c[(c[d>>2]|0)+52>>2]&127](a)|0;JB(a);i=b;return}function Ve(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=T1(B|0)|0;D=p1(C+11|0)|0;c2(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=jc(D|0,32)|0;if((C|0)==0){B=Rd(c[(Nc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;Iy(23,0,40,u);Xc(0)|0;F=0}else{F=C}q1(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}xe[c[68020>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{Zz(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}Zz(2);Yz(2)}Nz(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Gy(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];wB(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Gy(23,1,144,r);Z=MC(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ue(b);KB(b);if((c[67212>>2]|0)!=0){ae[c[16918]&255](23)}if((c[2]|0)!=0){Yz(4)}A=yB(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Gy(7,1,200,q);if((c[123756>>2]|0)==0){be[c[108380>>2]&127](108360,b)}AB(b,c[J>>2]|0,z,d);if((c[67148>>2]|0)!=0){ae[c[16918]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;OB(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){$z(4)}if((YC(b,1,1)|0)!=0){c[B>>2]=1;OB(b)}de[c[(c[K>>2]|0)+88>>2]&127](b)|0;JB(b);SB(b);KB(b);do{if((T|0)==0){_=0}else{Yz(7);$z(2);A=(rc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(rc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+Tz(2);if(!$){aa=0;break}aa=(rc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+Tz(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=Oz(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(rc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+Tz(ba+9|0);if((ca|0)==0){ka=0}else{ka=(rc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}$z(7);if((la|0)!=0){_=T;break}c[p>>2]=Rd(c[(Nc()|0)>>2]|0)|0;Iy(23,0,240,p);Xc(T|0)|0;_=0}}while(0);if((c[123756>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;be[c[108380>>2]&127](108360,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[28490]|0)!=0){ca=f;ba=113968;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];yy(M,f);Nd(10,M|0)|0;ba=c[28498]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;Gy(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((vC(b,0)|0)!=0){ma=58;break}if((nC(b,0)|0)!=0){ma=58;break}if((dC(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((vC(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(1,0,448,m);U=_;V=-2;break}if((nC(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(1,0,536,l);U=_;V=-3;break}T=(dC(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Xc(U|0)|0;i=e;return V|0}function We(a){a=a|0;i=i;return 0}function Xe(a){a=a|0;i=i;return 0}function Ye(a){a=a|0;i=i;return 0}function Ze(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;Wh(k,c[p>>2]|0,+h[(c[q>>2]|0)+232>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+232>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+7|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+7|0]|0;g=WB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=g;v=t;break}else{t=WB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+7|0]|0;t=ZB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+7|0]=t;v=f;break}else{f=ZB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+7|0]=f;v=f;break}}}}while(0);Yh(m,c[p>>2]|0,+h[(c[q>>2]|0)+232>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+232>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+8|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+8|0]|0;m=XB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=m;w=e;break}else{e=XB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+8|0]|0;e=$B(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+8|0]=e;w=n;break}else{n=$B(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+8|0]=n;w=n;break}}}}while(0);l=$B(+h[(c[q>>2]|0)+232>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+24|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+24|0;J=I;c[J>>2]=x;i=d;return}function _e(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+232>>3],+h[(c[a+8>>2]|0)+16>>3],c[(c[a+12>>2]|0)+24>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+232>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));ni(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+440>>3]=+h[f>>3];i=b;return}function $e(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+440>>3]+-273.15;i=i;return}function af(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+232>>3],+h[(c[a+8>>2]|0)+16>>3],c[(c[a+12>>2]|0)+24>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+232>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));ri(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+984>>3]=+h[f>>3];i=b;return}function bf(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+24>>3]- +h[e+8>>3]));h[d+480>>3]=+h[e+232>>3]+f*+h[e+336>>3]*+h[d+984>>3];i=b;return}function cf(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+24>>3]- +h[e+40>>3]));h[d+488>>3]=+h[e+232>>3]+f*+h[e+336>>3]*+h[d+984>>3];i=b;return}function df(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+24>>3]- +h[e+72>>3]));h[d+496>>3]=+h[e+232>>3]+f*+h[e+336>>3]*+h[d+984>>3];i=b;return}function ef(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=+h[g+984>>3];l=+h[(c[b+416>>2]|0)+232>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+976|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+976|0;r=q;h[r>>3]=o;i=d;return}s=l/+My(c[b+536>>2]|0,k,880,872,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+976|0;r=q;h[r>>3]=o;i=d;return}function ff(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+224>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[28994]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=1032;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];De[n&31](m,d,904,e);p=+h[(c[f>>2]|0)+224>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+448>>3]=p+g*+h[f+24>>3]*2.0;i=b;return}function gf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]+(g*-.1- +h[f+8>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+504>>3]=+h[d>>3];i=b;return}function hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+8>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+8>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+8>>3])|0;a[(c[b+352>>2]|0)+6|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+8>>3])|0;a[(c[b+352>>2]|0)+6|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+7|0]=f;i=d;return}function jf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+32>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]+(g*-.1- +h[f+40>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+512>>3]=+h[d>>3];i=b;return}function kf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+40>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+40>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+40>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+40>>3])|0;a[(c[b+352>>2]|0)+5|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+8|0]=f;i=d;return}function lf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+64>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]+(g*-.1- +h[f+72>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+520>>3]=+h[d>>3];i=b;return}function mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+72>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+72>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+72>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+72>>3])|0;a[(c[b+352>>2]|0)+4|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+9|0]=f;i=d;return}function nf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+880>>3]=+h[b>>3]+ +h[d+336>>3]*+h[d+432>>3];i=i;return}function of(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;Wh(k,c[p>>2]|0,+h[(c[q>>2]|0)+632>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+632>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+2|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+2|0]|0;g=WB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=g;v=t;break}else{t=WB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+2|0]|0;t=ZB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+2|0]=t;v=f;break}else{f=ZB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+2|0]=f;v=f;break}}}}while(0);Yh(m,c[p>>2]|0,+h[(c[q>>2]|0)+632>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+632>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+3|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+3|0]|0;m=XB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=m;w=e;break}else{e=XB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+3|0]|0;e=$B(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+3|0]=e;w=n;break}else{n=$B(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+3|0]=n;w=n;break}}}}while(0);l=$B(+h[(c[q>>2]|0)+632>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+16|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+16|0;J=I;c[J>>2]=x;i=d;return}function pf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[c[a+8>>2]>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];m=+h[c[(c[c[k>>2]>>2]|0)+8>>2]>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));ni(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3]=+h[f>>3];i=b;return}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+800>>3]=+h[b+176>>3]+-273.15;i=i;return}function rf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[c[a+8>>2]>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];m=+h[c[(c[c[k>>2]>>2]|0)+8>>2]>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));ri(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+816>>3]=+h[f>>3];i=b;return}function sf(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+8>>3]- +h[e+120>>3]));h[d+208>>3]=+h[e+632>>3]+f*+h[e+336>>3]*+h[d+816>>3];i=b;return}function tf(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+8>>3]- +h[e+152>>3]));h[d+216>>3]=+h[e+632>>3]+f*+h[e+336>>3]*+h[d+816>>3];i=b;return}function uf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=+h[g+816>>3];l=+h[(c[b+416>>2]|0)+632>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+808|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+808|0;r=q;h[r>>3]=o;i=d;return}s=l/+My(c[b+536>>2]|0,k,1008,1e3,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+808|0;r=q;h[r>>3]=o;i=d;return}function vf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+624>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[28994]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=1032;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];De[n&31](m,d,1056,e);p=+h[(c[f>>2]|0)+624>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+184>>3]=p+g*+h[f+8>>3]*2.0;i=b;return}function wf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+112>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]+(g*-.1- +h[f+120>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+224>>3]=+h[d>>3];i=b;return}function xf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+1|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+120>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+120>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+120>>3])|0;a[(c[b+352>>2]|0)+1|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+120>>3])|0;a[(c[b+352>>2]|0)+1|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+2|0]=f;i=d;return}function yf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+192>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+192|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+192>>3]);e=c[f>>2]|0;h[c[e+452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+464>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+464|0;h[(c[e+448>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+464>>3]);j=c[f>>2]|0;h[(c[j+452>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+444>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+888>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+888|0;h[(c[j+448>>2]|0)+16>>3]=+h[e>>3];k=+wC(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+888>>3]);g=c[f>>2]|0;h[(c[g+452>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+444>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+312>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+312|0;h[(c[g+448>>2]|0)+24>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+312>>3]);e=c[f>>2]|0;h[(c[e+452>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+344>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+344|0;h[(c[e+448>>2]|0)+32>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+344>>3]);h[(c[(c[f>>2]|0)+452>>2]|0)+32>>3]=k;uC(a,5)|0;j=c[(c[f>>2]|0)+444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+192>>3]=+h[j>>3];h[f+464>>3]=+h[j+8>>3];h[f+888>>3]=+h[j+16>>3];h[f+312>>3]=+h[j+24>>3];h[f+344>>3]=+h[j+32>>3];oj(a);pj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);xj(a);yj(a);zj(a);Aj(a);Bj(a);i=b;return}function zf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+11|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+11|0]|0;k=XB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+712>>3],a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;f=j;break}else{j=XB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+712>>3],a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+11|0]|0;j=$B(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+712>>3])|0;a[(c[b+352>>2]|0)+11|0]=j;f=g;break}else{g=$B(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+712>>3])|0;a[(c[b+352>>2]|0)+11|0]=g;f=g;break}}}}while(0);do{if((a[e]|0)==0){l=a[(c[b+356>>2]|0)+12|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+12|0]|0;k=YB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+704>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;l=j;break}else{j=YB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+704>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=j;l=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+12|0]|0;j=aC(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+704>>3])|0;a[(c[b+352>>2]|0)+12|0]=j;l=g;break}else{g=aC(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+704>>3])|0;a[(c[b+352>>2]|0)+12|0]=g;l=g;break}}}}while(0);if(!(f<<24>>24==0)){m=1;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+16|0;u=t;v=c[u>>2]|0;w=v;x=w+10|0;y=x;a[y]=m;i=d;return}if((a[(c[b+408>>2]|0)+10|0]|0)==0){m=0;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+16|0;u=t;v=c[u>>2]|0;w=v;x=w+10|0;y=x;a[y]=m;i=d;return}m=l<<24>>24!=0|0;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+16|0;u=t;v=c[u>>2]|0;w=v;x=w+10|0;y=x;a[y]=m;i=d;return}function Af(b){b=b|0;var d=0,e=0;d=c[c[b+4>>2]>>2]|0;e=c[b+416>>2]|0;h[(c[d+8>>2]|0)+896>>3]=+h[((a[(c[d+16>>2]|0)+10|0]|0)==0?e+728|0:e+720|0)>>3];i=i;return}function Bf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+456>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+456|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+456>>3]);e=c[f>>2]|0;h[c[e+532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+960>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+960|0;h[(c[e+528>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+960>>3]);h[(c[(c[f>>2]|0)+532>>2]|0)+8>>3]=k;uC(a,6)|0;j=c[(c[f>>2]|0)+524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+456>>3]=+h[j>>3];h[f+960>>3]=+h[j+8>>3];Ej(a);Fj(a);Gj(a);i=b;return}function Cf(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Ih(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+960>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+920>>3]=+h[d>>3];i=b;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+912>>3]=+h[b+960>>3]*1.0e-5;i=i;return}function Ef(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;Wh(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+14|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+14|0]|0;g=WB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=g;v=t;break}else{t=WB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+14|0]|0;t=ZB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u)|0;a[(c[b+352>>2]|0)+14|0]=t;v=f;break}else{f=ZB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u)|0;a[(c[b+352>>2]|0)+14|0]=f;v=f;break}}}}while(0);Yh(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+15|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+15|0]|0;m=XB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=m;w=e;break}else{e=XB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+15|0]|0;e=$B(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u)|0;a[(c[b+352>>2]|0)+15|0]=e;w=n;break}else{n=$B(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u)|0;a[(c[b+352>>2]|0)+15|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+16|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+16|0]|0;m=XB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=m;x=e;break}else{e=XB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+16|0]|0;e=$B(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+16|0]=e;x=n;break}else{n=$B(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+16|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+20|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+20|0;H=G;c[H>>2]=y;i=d;return}function Ff(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;ii(e,c[g>>2]|0,+h[k+960>>3],+h[k+952>>3],c[(c[a+12>>2]|0)+20>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+960>>3];m=+h[g+952>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));ri(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+944>>3]=+h[f>>3];i=b;return}function Gf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;ii(e,c[g>>2]|0,+h[k+960>>3],+h[k+952>>3],c[(c[a+12>>2]|0)+20>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+960>>3];m=+h[g+952>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));ni(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+936>>3]=+h[f>>3];i=b;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+904>>3]=+h[b+936>>3]+-273.15;i=i;return}function If(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+952>>3];k=+h[g+944>>3];l=+h[g+960>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+928|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+928|0;r=q;h[r>>3]=o;i=d;return}s=l/+My(c[b+536>>2]|0,k,1160,1152,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+928|0;r=q;h[r>>3]=o;i=d;return}function Jf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+896>>3],0.0)|0;m=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+896>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;ii(g,c[n>>2]|0,+h[o+480>>3],+h[(m<<24>>24==0?o+16|0:o+952|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+480>>3];s=+h[(l<<24>>24==0?q+16|0:q+952|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));ri(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+688>>3];r=+h[p+896>>3];if(s!=0.0){t=p;u=r/s;v=t;w=v+552|0;x=w;h[x>>3]=u;i=d;return}if(r==0.0){t=p;u=r;v=t;w=v+552|0;x=w;h[x>>3]=u;i=d;return}y=r/+My(c[n>>2]|0,s,1192,1184,+h[e>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[k>>2]>>2]|0)+8>>2]|0;u=y;v=t;w=v+552|0;x=w;h[x>>3]=u;i=d;return}function Kf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=$B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+896>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+600>>3]=+h[e+896>>3]*+h[(a<<24>>24==0?e+16|0:e+952|0)>>3];i=b;return}function Lf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+552>>3];e=c[a+416>>2]|0;h[b+528>>3]=+h[b+896>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+8>>3]);i=i;return}function Mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0,C=0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=f;l=b+4|0;m=$B(-+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;n=$B(-+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;o=b+536|0;p=c[o>>2]|0;q=c[c[l>>2]>>2]|0;r=c[q+8>>2]|0;s=+h[r+488>>3];do{if(n<<24>>24==0){t=+h[r+16>>3]}else{u=+pd(+-+h[r+344>>3],1.0e-15);v=u+1.0e-15;w=u*+h[r+880>>3]+8.40130581525969e-11;if(v!=0.0){t=w/v;break}if(w==0.0){t=w;break}t=w/+My(p,v,1592,1584,+h[q>>3],(a[b+319|0]|0)!=0|0)}}while(0);ii(g,p,s,t,0,0);p=k+0|0;k=g+0|0;g=p+120|0;do{c[p>>2]=c[k>>2];p=p+4|0;k=k+4|0}while((p|0)<(g|0));q=c[o>>2]|0;r=c[c[l>>2]>>2]|0;n=c[r+8>>2]|0;t=+h[n+488>>3];do{if(m<<24>>24==0){x=+h[n+16>>3]}else{s=+pd(+-+h[n+344>>3],1.0e-15);v=s+1.0e-15;w=s*+h[n+880>>3]+8.40130581525969e-11;if(v!=0.0){x=w/v;break}if(w==0.0){x=w;break}x=w/+My(q,v,1592,1584,+h[r>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=e+0|0;k=f+0|0;g=p+120|0;do{c[p>>2]=c[k>>2];p=p+4|0;k=k+4|0}while((p|0)<(g|0));ri(j,q,t,x,e);e=c[c[l>>2]>>2]|0;q=c[e+8>>2]|0;x=+h[j>>3]*+h[q+696>>3];t=+h[q+344>>3];v=-t;if(x!=0.0){y=q;z=v/x;A=y;B=A+560|0;C=B;h[C>>3]=z;i=d;return}if(t==-0.0){y=q;z=v;A=y;B=A+560|0;C=B;h[C>>3]=z;i=d;return}t=v/+My(c[o>>2]|0,x,1640,1584,+h[e>>3],(a[b+319|0]|0)!=0|0);y=c[(c[c[l>>2]>>2]|0)+8>>2]|0;z=t;A=y;B=A+560|0;C=B;h[C>>3]=z;i=d;return}function Nf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;d=i;e=b+4|0;f=$B(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+344>>3];do{if(f<<24>>24==0){l=j;m=+h[j+16>>3]}else{n=+pd(+k,1.0e-15);o=n+1.0e-15;p=n*+h[j+880>>3]+8.40130581525969e-11;if(o!=0.0){l=j;m=p/o;break}if(p==0.0){l=j;m=p;break}n=p/+My(c[b+536>>2]|0,o,1592,2288,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+608>>3]=m*k;i=d;return}function Of(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+560>>3];e=c[a+416>>2]|0;h[b+536>>3]=-(+h[b+344>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+40>>3]));i=i;return}function Pf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+456>>3]*+h[j+424>>3]*+h[e+400>>3];l=+h[j+344>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}r=l/+My(c[b+536>>2]|0,k,2304,2296,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=+h[b+344>>3]*+h[(c[a+416>>2]|0)+408>>3];i=i;return}function Rf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;m=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;ii(g,c[n>>2]|0,+h[o+208>>3],+h[(m<<24>>24==0?o:o+872|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+208>>3];s=+h[(l<<24>>24==0?q:q+872|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));ri(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+664>>3];r=+h[p+344>>3];if(s!=0.0){t=p;u=r/s;v=t;w=v+256|0;x=w;h[x>>3]=u;i=d;return}if(r==0.0){t=p;u=r;v=t;w=v+256|0;x=w;h[x>>3]=u;i=d;return}y=r/+My(c[n>>2]|0,s,2376,2368,+h[e>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[k>>2]>>2]|0)+8>>2]|0;u=y;v=t;w=v+256|0;x=w;h[x>>3]=u;i=d;return}function Sf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=($B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+392>>3]=+h[(a?e+408|0:e+400|0)>>3];i=b;return}function Tf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+456>>3]*+h[j+432>>3]*+h[e+400>>3];l=+h[j+344>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}r=l/+My(c[b+536>>2]|0,k,2776,2768,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}function Uf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=($B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+416>>3]=+h[(a?e+432|0:e+424|0)>>3];i=b;return}function Vf(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=$B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+288>>3]=+h[e+344>>3]*+h[(a<<24>>24==0?e:e+872|0)>>3];i=b;return}function Wf(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+256>>3];e=c[a+416>>2]|0;h[b+240>>3]=+h[b+344>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+120>>3]);i=i;return}function Xf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+144>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]+(g*-.1- +h[f+152>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+232>>3]=+h[d>>3];i=b;return}function Yf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+152>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+152>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+152>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+152>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+3|0]=f;i=d;return}function Zf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+776>>3]=+h[b+16>>3]- +h[d+336>>3]*+h[d+768>>3];i=i;return}function _f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+216>>3],+h[a+776>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+776>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+280>>3]=+h[f>>3];i=b;return}function $f(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+784>>3]=+h[b>>3]+ +h[d+336>>3]*+h[d+768>>3];i=i;return}function ag(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+496>>3],+h[a+784>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+496>>3];l=+h[g+784>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+592>>3]=+h[f>>3];i=b;return}function bg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+472>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+472|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+472>>3]);e=c[f>>2]|0;h[c[e+612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+200>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+200|0;h[(c[e+608>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+200>>3]);j=c[f>>2]|0;h[(c[j+612>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+604>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+792>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+792|0;h[(c[j+608>>2]|0)+16>>3]=+h[e>>3];k=+wC(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+792>>3]);g=c[f>>2]|0;h[(c[g+612>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+604>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+304>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+304|0;h[(c[g+608>>2]|0)+24>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+304>>3]);h[(c[(c[f>>2]|0)+612>>2]|0)+24>>3]=k;uC(a,7)|0;e=c[(c[f>>2]|0)+604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+472>>3]=+h[e>>3];h[f+200>>3]=+h[e+8>>3];h[f+792>>3]=+h[e+16>>3];h[f+304>>3]=+h[e+24>>3];Jj(a);Kj(a);Lj(a);Mj(a);Nj(a);Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);Tj(a);i=b;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+896>>3]+(-+h[b+344>>3]- +h[b+88>>3]);i=i;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=+h[b+344>>3]+ +h[b+88>>3];i=i;return}function eg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;m=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;ii(g,c[n>>2]|0,+h[o+216>>3],+h[(m<<24>>24==0?o:o+776|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+216>>3];s=+h[(l<<24>>24==0?q:q+776|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));ri(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+672>>3];r=+h[p+88>>3];if(s!=0.0){t=p;u=r/s;v=t;w=v+264|0;x=w;h[x>>3]=u;i=d;return}if(r==0.0){t=p;u=r;v=t;w=v+264|0;x=w;h[x>>3]=u;i=d;return}y=r/+My(c[n>>2]|0,s,2848,2840,+h[e>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[k>>2]>>2]|0)+8>>2]|0;u=y;v=t;w=v+264|0;x=w;h[x>>3]=u;i=d;return}function fg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=$B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+296>>3]=+h[e+88>>3]*+h[(a<<24>>24==0?e:e+776|0)>>3];i=b;return}function gg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+264>>3];e=c[a+416>>2]|0;h[b+248>>3]=+h[b+88>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+152>>3]);i=i;return}function hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+840>>3]=+h[b+288>>3]+(+h[b+296>>3]+(+h[b+240>>3]+ +h[b+248>>3]));i=i;return}function ig(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+792>>3]*+h[j+168>>3]*+h[e+736>>3];l=+h[j+88>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}r=l/+My(c[b+536>>2]|0,k,3264,3256,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}function jg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+792>>3]*+h[j+160>>3]*+h[e+736>>3];l=+h[j+88>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}r=l/+My(c[b+536>>2]|0,k,3344,3336,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}function kg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=($B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+152>>3]=+h[(a?e+168|0:e+160|0)>>3];i=b;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=+h[b+88>>3]*+h[(c[a+416>>2]|0)+744>>3];i=i;return}function mg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=($B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+128>>3]=+h[(a?e+144|0:e+136|0)>>3];i=b;return}function ng(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0,y=0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=$B(-+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;m=$B(-+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;ii(g,c[n>>2]|0,+h[o+496>>3],+h[(m<<24>>24==0?o+16|0:o+784|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+496>>3];s=+h[(l<<24>>24==0?q+16|0:q+784|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));ri(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+704>>3];r=+h[p+88>>3];t=-r;if(s!=0.0){u=p;v=t/s;w=u;x=w+568|0;y=x;h[y>>3]=v;i=d;return}if(r==-0.0){u=p;v=t;w=u;x=w+568|0;y=x;h[y>>3]=v;i=d;return}r=t/+My(c[n>>2]|0,s,3424,3416,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;v=r;w=u;x=w+568|0;y=x;h[y>>3]=v;i=d;return}function og(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+568>>3];e=c[a+416>>2]|0;h[b+544>>3]=-(+h[b+88>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+72>>3]));i=i;return}function pg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=$B(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+616>>3]=-(+h[e+88>>3]*+h[(a<<24>>24==0?e+16|0:e+784|0)>>3]);i=b;return}function qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+600>>3]+(+h[b+608>>3]+(+h[b+616>>3]+(+h[b+528>>3]+(+h[b+536>>3]+ +h[b+544>>3]))));i=i;return}function rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[(c[a+416>>2]|0)+624>>3]*+h[b+8>>3];i=i;return}function sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=+h[b+824>>3]*+h[b+816>>3];i=i;return}function tg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+864>>3]=+h[b+856>>3]*+h[b+808>>3];i=i;return}function ug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+32|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+32>>3]);e=c[f>>2]|0;h[c[e+692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1096>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1096|0;h[(c[e+688>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1096>>3]);h[(c[(c[f>>2]|0)+692>>2]|0)+8>>3]=k;uC(a,8)|0;j=c[(c[f>>2]|0)+684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+32>>3]=+h[j>>3];h[f+1096>>3]=+h[j+8>>3];Wj(a);Xj(a);Yj(a);Zj(a);i=b;return}function vg(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+624>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1048>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}q=k/+My(c[b+536>>2]|0,e,3848,3840,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}function wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[(c[a+416>>2]|0)+224>>3]*+h[b+24>>3];i=i;return}function xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=+h[b+992>>3]*+h[b+984>>3];i=i;return}function yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1032>>3]=+h[b+1024>>3]*+h[b+976>>3];i=i;return}function zg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+48>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+48|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+48>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1088>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1088|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1088>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+8>>3]=k;uC(a,9)|0;j=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+48>>3]=+h[j>>3];h[f+1088>>3]=+h[j+8>>3];ak(a);bk(a);ck(a);dk(a);i=b;return}function Ag(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+224>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1040>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}q=k/+My(c[b+536>>2]|0,e,3880,3872,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}function Bg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((aC(+h[(c[f>>2]|0)+232>>3],0.0)|0)<<24>>24==0)){i=b;return}g=lz(lz(lz(lz(3904,jz(+h[(c[f>>2]|0)+232>>3],0,1,6)|0)|0,3920)|0,3944)|0,3960)|0;f=lz(lz(g,jz(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+440>>3],0,1,6)|0)|0,3992)|0;g=c[a+536>>2]|0;a=c[28994]|0;j=d;k=4440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](g,d,f,e);i=b;return}function Cg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((_B(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[a+416>>2]|0)+248>>3])|0)<<24>>24==0)){i=b;return}g=lz(lz(4072,jz(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,4128)|0;f=c[a+536>>2]|0;a=c[28994]|0;j=d;k=4464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Dg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!(($B(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[a+416>>2]|0)+248>>3]*-1.0e-6)|0)<<24>>24==0)){i=b;return}g=lz(lz(4208,jz(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,4224)|0;f=c[a+536>>2]|0;a=c[28994]|0;j=d;k=4488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Eg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((aC(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+960>>3],0.0)|0)<<24>>24==0)){i=b;return}g=lz(lz(lz(lz(3904,jz(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+960>>3],0,1,6)|0)|0,3920)|0,3944)|0,3960)|0;j=lz(lz(g,jz(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+936>>3],0,1,6)|0)|0,3992)|0;f=c[a+536>>2]|0;a=c[28994]|0;g=d;k=4440;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];De[a&31](f,d,j,e);i=b;return}function Fg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+40|0;d=b;e=b+16|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;gA(g,1,4280,f);Ez(h,1,1.0,b+32|0);f=c[a+536>>2]|0;a=e;j=g;c[a+0>>2]=c[j+0>>2];c[a+4>>2]=c[j+4>>2];c[a+8>>2]=c[j+8>>2];j=d;a=h;c[j+0>>2]=c[a+0>>2];c[j+4>>2]=c[a+4>>2];c[j+8>>2]=c[a+8>>2];ah(f,3944,e,0,1,d,4288);i=b;return}function Gg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((aC(+h[f+408>>3],+h[f+432>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[28994]|0;g=d;j=4512;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];De[a&31](f,d,4384,e);i=b;return}function Hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;if(!((aC(+h[(c[f>>2]|0)+632>>3],0.0)|0)<<24>>24==0)){i=b;return}g=lz(lz(lz(lz(3904,jz(+h[(c[f>>2]|0)+632>>3],0,1,6)|0)|0,3920)|0,3944)|0,3960)|0;f=lz(lz(g,jz(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+176>>3],0,1,6)|0)|0,3992)|0;g=c[a+536>>2]|0;a=c[28994]|0;j=d;k=4440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](g,d,f,e);i=b;return}function Ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((_B(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[a+416>>2]|0)+648>>3])|0)<<24>>24==0)){i=b;return}g=lz(lz(4072,jz(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,4128)|0;f=c[a+536>>2]|0;a=c[28994]|0;j=d;k=4464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Jg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!(($B(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[a+416>>2]|0)+648>>3]*-1.0e-6)|0)<<24>>24==0)){i=b;return}g=lz(lz(4208,jz(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,4224)|0;f=c[a+536>>2]|0;a=c[28994]|0;j=d;k=4488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];De[a&31](f,d,g,e);i=b;return}function Kg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((aC(+h[f+744>>3],+h[f+768>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[28994]|0;g=d;j=4512;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];De[a&31](f,d,4384,e);i=b;return}function Lg(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;Ze(b);_e(b);$e(b);af(b);bf(b);cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);i=c;return 0}function Mg(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Ng(b);i=c;return 0}function Ng(a){a=a|0;var b=0;b=i;Ze(a);af(a);bf(a);cf(a);df(a);ef(a);gf(a);hf(a);jf(a);kf(a);lf(a);mf(a);nf(a);of(a);rf(a);sf(a);tf(a);uf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Of(a);Rf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);ug(a);vg(a);wg(a);xg(a);zg(a);Ag(a);i=b;return}function Og(a,b){a=a|0;b=+b;i=i;return 0}function Pg(a){a=a|0;var b=0;b=i;i=i+8|0;Jy(c[a+536>>2]|0,(a|0)!=0|0,4744,b);c[a+540>>2]=4552;c[a+84>>2]=4776;c[a+88>>2]=4776;c[a+92>>2]=4824;c[a+96>>2]=4896;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=4;c[a+116>>2]=153;c[a+120>>2]=0;c[a+124>>2]=7;c[a+128>>2]=11;c[a+132>>2]=0;c[a+136>>2]=115;c[a+140>>2]=25;c[a+144>>2]=53;c[a+148>>2]=0;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=144;c[a+220>>2]=5;c[a+224>>2]=1;c[a+228>>2]=0;c[a+160>>2]=14;c[a+104>>2]=0;c[a+164>>2]=19;c[a+168>>2]=0;c[a+176>>2]=9;c[a+180>>2]=0;c[a+184>>2]=9;c[a+188>>2]=0;c[a+56>>2]=4936;c[a+64>>2]=111;c[a+72>>2]=0;c[a+68>>2]=659;c[a+192>>2]=0;c[a+196>>2]=0;c[a+200>>2]=10;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function Qg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=e2(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=68e3;F=68024;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[17e3]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=e2(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[16250]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=e2(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(47,c[16250]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=e2(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;S1(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=e2(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;S1(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=e2(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(47,c[16250]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=e2(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=e2(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=e2(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Ra(34,5e3,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=e2(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=e2(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=e2(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=e2(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=e2(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=e2(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(47,c[16250]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=e2(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=e2(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=e2(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=e2(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function Rg(){var a=0;a=i;qd(0)|0;rc(5160,18,1,c[r>>2]|0)|0;qd(0)|0;i=a;return}function Sg(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+16|0;c[za>>2]=13;Az(Aa,1,za);Ba=1386.0/e;Ca=7.1-d/1653.0e4;if(!(d>611.657)){za=lz(lz(5184,jz(d,0,1,6)|0)|0,5248)|0;Da=lz(lz(za,jz(611.657,0,1,6)|0)|0,5256)|0;za=c[28994]|0;Ea=g;Fa=5376;c[Ea+0>>2]=c[Fa+0>>2];c[Ea+4>>2]=c[Fa+4>>2];c[Ea+8>>2]=c[Fa+8>>2];c[Ea+12>>2]=c[Fa+12>>2];c[Ea+16>>2]=c[Fa+16>>2];c[Ea+20>>2]=c[Fa+20>>2];De[za&31](b,g,Da,ya);}d=Ba+-1.222;c[xa>>2]=1;h[(Fz(Aa,1,xa)|0)>>3]=d*d;c[wa>>2]=1;Ga=d*+h[(Fz(Aa,1,wa)|0)>>3];c[va>>2]=2;h[(Fz(Aa,1,va)|0)>>3]=Ga;c[ua>>2]=1;Ga=+h[(Fz(Aa,1,ua)|0)>>3];c[ta>>2]=3;h[(Fz(Aa,1,ta)|0)>>3]=Ga*Ga;c[sa>>2]=3;Ga=+h[(Fz(Aa,1,sa)|0)>>3];c[ra>>2]=4;h[(Fz(Aa,1,ra)|0)>>3]=Ga*Ga;c[qa>>2]=1;Ga=+h[(Fz(Aa,1,qa)|0)>>3];c[pa>>2]=4;Ha=Ga*+h[(Fz(Aa,1,pa)|0)>>3];c[oa>>2]=5;h[(Fz(Aa,1,oa)|0)>>3]=Ha;c[na>>2]=1;Ha=+h[(Fz(Aa,1,na)|0)>>3];c[ma>>2]=3;Ga=Ha*+h[(Fz(Aa,1,ma)|0)>>3];c[la>>2]=6;h[(Fz(Aa,1,la)|0)>>3]=Ga;c[ka>>2]=3;Ga=d*+h[(Fz(Aa,1,ka)|0)>>3];c[ja>>2]=7;h[(Fz(Aa,1,ja)|0)>>3]=Ga;c[ia>>2]=3;Ga=+h[(Fz(Aa,1,ia)|0)>>3];c[ha>>2]=4;Ha=Ga*+h[(Fz(Aa,1,ha)|0)>>3];c[ga>>2]=8;h[(Fz(Aa,1,ga)|0)>>3]=Ha;c[fa>>2]=9;h[(Fz(Aa,1,fa)|0)>>3]=Ca*Ca;c[ea>>2]=9;Ha=+h[(Fz(Aa,1,ea)|0)>>3];c[da>>2]=10;h[(Fz(Aa,1,da)|0)>>3]=Ha*Ha;c[ca>>2]=10;Ha=+h[(Fz(Aa,1,ca)|0)>>3];c[ba>>2]=11;h[(Fz(Aa,1,ba)|0)>>3]=Ha*Ha;c[aa>>2]=4;Ha=+h[(Fz(Aa,1,aa)|0)>>3];c[$>>2]=12;h[(Fz(Aa,1,$)|0)>>3]=Ha*Ha;c[_>>2]=12;Ha=+h[(Fz(Aa,1,_)|0)>>3];c[Z>>2]=13;h[(Fz(Aa,1,Z)|0)>>3]=Ha*Ha;c[Y>>2]=1;Ha=+h[(Fz(Aa,1,Y)|0)>>3];c[X>>2]=1;Ga=+h[(Fz(Aa,1,X)|0)>>3]*-.00015851507390979+-.021841717175414;c[W>>2]=1;Ia=Ga*+h[(Fz(Aa,1,W)|0)>>3]+.018990068218419;c[V>>2]=6;Ga=Ha*(Ia*+h[(Fz(Aa,1,V)|0)>>3]+.00424944110961118)+-.00254871721114236;c[U>>2]=5;Ia=Ga/+h[(Fz(Aa,1,U)|0)>>3];c[T>>2]=3;Ga=+h[(Fz(Aa,1,T)|0)>>3];c[S>>2]=1;Ha=+h[(Fz(Aa,1,S)|0)>>3];c[R>>2]=1;Ja=+h[(Fz(Aa,1,R)|0)>>3];c[Q>>2]=3;Ka=+h[(Fz(Aa,1,Q)|0)>>3];c[P>>2]=4;La=Ga*(Ha*(Ja*Ka*+h[(Fz(Aa,1,P)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801;c[O>>2]=3;Ka=La/+h[(Fz(Aa,1,O)|0)>>3];c[N>>2]=5;La=+h[(Fz(Aa,1,N)|0)>>3]*-5.11230768720618e-9+.000126718579380216;c[M>>2]=7;Ja=La/+h[(Fz(Aa,1,M)|0)>>3];c[L>>2]=2;La=+h[(Fz(Aa,1,L)|0)>>3];c[K>>2]=8;Ha=La*(+h[(Fz(Aa,1,K)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20)+11212640954.0e-15;c[J>>2]=6;La=Ha/+h[(Fz(Aa,1,J)|0)>>3];c[I>>2]=9;Ha=+h[(Fz(Aa,1,I)|0)>>3];c[H>>2]=7;Ga=+h[(Fz(Aa,1,H)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[G>>2]=8;Ma=Ga/+h[(Fz(Aa,1,G)|0)>>3];c[F>>2]=10;Ga=+h[(Fz(Aa,1,F)|0)>>3];c[E>>2]=11;Na=+h[(Fz(Aa,1,E)|0)>>3];c[D>>2]=4;Oa=+h[(Fz(Aa,1,D)|0)>>3];c[C>>2]=3;Pa=Oa*+h[(Fz(Aa,1,C)|0)>>3];c[B>>2]=12;Oa=Pa*+h[(Fz(Aa,1,B)|0)>>3];c[A>>2]=1;Pa=1.9941018075704e-17/(Oa*+h[(Fz(Aa,1,A)|0)>>3]);c[z>>2]=9;Oa=+h[(Fz(Aa,1,z)|0)>>3];c[y>>2]=10;Qa=+h[(Fz(Aa,1,y)|0)>>3];c[x>>2]=9;Ra=+h[(Fz(Aa,1,x)|0)>>3];c[w>>2]=4;Sa=+h[(Fz(Aa,1,w)|0)>>3];c[v>>2]=13;Ta=4.65957282962769e-22/(Sa*+h[(Fz(Aa,1,v)|0)>>3]);c[u>>2]=4;Sa=+h[(Fz(Aa,1,u)|0)>>3];c[t>>2]=13;Ua=Sa*+h[(Fz(Aa,1,t)|0)>>3];c[s>>2]=1;Sa=Ca/(Ua*+h[(Fz(Aa,1,s)|0)>>3])*3.83502057899078e-24;c[r>>2]=4;Ua=d*+h[(Fz(Aa,1,r)|0)>>3];c[q>>2]=13;Va=Ca*(Ta+Ca*(Sa+-7.2912378325616e-23/(Ua*+h[(Fz(Aa,1,q)|0)>>3])));c[p>>2]=3;Ua=d*+h[(Fz(Aa,1,p)|0)>>3];c[o>>2]=13;Sa=Ua*+h[(Fz(Aa,1,o)|0)>>3];c[n>>2]=1;Ua=Qa*Ra*(Va+-1.00075970318621e-21/(Sa*+h[(Fz(Aa,1,n)|0)>>3]));c[m>>2]=13;Sa=Ha*Ca*(Ma+Ga*Na*Ca*(Pa+Oa*(Ua+-4.48827542684151e-19/+h[(Fz(Aa,1,m)|0)>>3])));c[l>>2]=4;Ua=Ca*(Ia+Ca*(Ka+Ca*(Ja+Ca*(La+Ca*(324135974880936.0e-20/(d*+h[(Fz(Aa,1,l)|0)>>3])+Sa)))));c[k>>2]=1;Sa=d*((d*(d*(d*(d*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(Fz(Aa,1,k)|0)>>3]+.84548187169114)+-.29265942426334;c[j>>2]=2;h[a>>3]=Ba*(Sa/+h[(Fz(Aa,1,j)|0)>>3]+Ua)*e*461.526;i=f;return}function Tg(a,b,c,d,e,f,g,j,k,l,m,n,o){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;m=+m;n=+n;o=+o;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;p=i;i=i+112|0;q=p;r=p+16|0;s=p+32|0;t=p+48|0;u=p+64|0;v=p+80|0;w=p+96|0;x=m/k;if(!(x<=.0065)){y=.0065/x}else{y=1.0}m=+od(+(+W(+(+ca(+y)*745.0),.97)),+o);y=d*l;z=e*l;l=(y+z)*.5;A=+pd(+y,+z)+n;B=+od(+y,+z)-n;if(A<=c){Ug(q,b,c-y,d,e,f,g,j,k,m,o,x);C=+h[q>>3];D=a;E=D;h[E>>3]=C;i=p;return}if(B>=c){Ug(r,b,c-z,d,e,f,g,j,k,m,o,x);C=+h[r>>3];D=a;E=D;h[E>>3]=C;i=p;return}Ug(s,b,A-y,d,e,f,g,j,k,m,o,x);y=+h[s>>3];n=+h[s+8>>3];Ug(t,b,B-z,d,e,f,g,j,k,m,o,x);x=+h[t>>3];o=+h[t+8>>3];Vg(u,b,l,B,A,x,y,o,n);m=+h[u+8>>3];if(l<c){Vg(v,b,c,l,A,0.0,y,m,n);C=+h[v>>3];D=a;E=D;h[E>>3]=C;i=p;return}else{Vg(w,b,c,B,l,x,0.0,o,m);C=+h[w>>3];D=a;E=D;h[E>>3]=C;i=p;return}}function Ug(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0,X=0,Y=0,Z=0,_=0;q=i;i=i+128|0;r=q;s=q+24|0;t=q+48|0;u=q+72|0;v=q+96|0;w=q+120|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+16|0;C=d>=0.0;D=C?g:j;j=+U(+d);g=m*m*m*((C?e:f)/(D*D*l));l=j*g*2.0;f=g*2.0;g=l*.015625;e=f*.015625;do{if(g>n){if(!(l>=0.0)){E=c[28994]|0;F=A;h[k>>3]=l;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=v;G=8800;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];De[F&31](b,v,5904,A);F=c[28994]|0;G=z;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=u;E=8800;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];De[G&31](b,u,5904,z);}H=+V(+l);I=p*.27;J=I+2.51/H;if(!(J>0.0)){G=c[28994]|0;E=y;h[k>>3]=J;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=G;G=t;F=8800;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2];c[G+16>>2]=c[F+16>>2];c[G+20>>2]=c[F+20>>2];De[E&31](b,t,5968,y);}K=H*+_a(+J)*-2.0;J=j*f;if(!(J>=0.0)){E=c[28994]|0;F=x;h[k>>3]=J;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=s;G=8800;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];De[F&31](b,s,6064,x);}H=+V(+J);J=I+2.51/H;if(!(J>0.0)){F=c[28994]|0;G=w;h[k>>3]=J;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=r;E=8800;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];De[G&31](b,r,6144,w);}I=(5.02/(j*J*2.0)- +da(+J)*(f/H))*.4342944819032518;if(!(K<o)){L=K;M=I;break}Wg(B,b,l,n,o,p,d);L=+h[B>>3];M=+h[B+8>>3]}else{L=g;M=e}}while(0);if(C){N=L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}N=-L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}function Vg(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0;m=i;i=i+56|0;n=m;o=m+24|0;p=m+48|0;q=i;i=i+8|0;if(!(e<f)){r=lz(lz(7056,jz(e,0,1,6)|0)|0,7112)|0;s=lz(lz(r,jz(f,0,1,6)|0)|0,7128)|0;r=c[28994]|0;t=o;u=7160;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];De[r&31](b,o,s,q);}do{if(!(k*l>=0.0)){if(+U(+k)<1.0e-15){break}if(+U(+l)<1.0e-15){break}q=lz(lz(7184,jz(k,0,1,6)|0)|0,7360)|0;s=lz(lz(q,jz(l,0,1,6)|0)|0,7376)|0;q=c[28994]|0;o=n;r=7408;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2];c[o+16>>2]=c[r+16>>2];c[o+20>>2]=c[r+20>>2];De[q&31](b,n,s,p);}}while(0);v=f-e;w=(j-g)/v;x=+U(+w);if(w==0.0){y=0.0;z=(d-e)*w+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}F=w*-2.0;G=F+k+l;if(+U(+G)<1.0e-13){H=d-e;I=k*-2.0;J=w*3.0;K=F+l+k;L=((e+f)*.5-e)/v;y=K*L*L*3.0+((I+(J-l))*L*2.0+k);z=H*(H*((I+(J+(H*(K/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}K=v*k;H=-l;J=((k+l)*e*-3.0+(w*e*6.0+(K*-2.0+(v*w*3.0-v*l))))/(H-k+w*2.0)*.3333333333333333;I=J-e;L=f-J;J=I/v;M=F+l+k;F=k*-2.0;N=w*3.0;O=F+(N-l);P=M*J*J*3.0+(O*J*2.0+k);if(w>0.0){Q=1.0}else{Q=+(w<0.0|0)}J=Q*+od(+(+U(+P)),+x)*.25;do{if(!(+U(+(k-l))<=1.0e-13)){R=(k*H+(-(l*l)-k*k)+w*(w*-1.5+k+l)*6.0)/(G*3.0);S=0}else{if(!(K+g<j)){R=k;S=0;break}R=k;S=1}}while(0);if(I>0.0&L<v){if(!(w*P<=0.0)){T=19}else{T=22}}else{T=19}do{if((T|0)==19){P=+U(+J);K=+U(+R);if(P<K){if(w*R>=0.0){T=22;break}}if(P<+U(+(w*.1))&S<<24>>24==0){V=K;W=P}else{T=34}}}while(0);do{if((T|0)==22){if(!(S<<24>>24==0)){T=34;break}V=+U(+R);W=+U(+J)}}while(0);if((T|0)==34){P=d-e;K=((e+f)*.5-e)/v;y=M*K*K*3.0+(O*K*2.0+k);z=P*(P*((F+(N+(P*(M/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}do{if(W<V){if(!(w*R>=0.0)){X=J;break}X=R}else{X=J}}while(0);J=w*.1;T=+U(+X)<+U(+J);R=T?J:X;X=(I*k+L*l)/v;if(+U(+(X-R))<1.0e-6){Y=X*.999999}else{Y=R}R=(w-Y)/(X-Y)*3.0;X=I*R;I=L*R;R=X+e;L=f-I;w=(k-Y)/+pd(+(X*X),1.0e-13);X=(l-Y)/+pd(+(I*I),1.0e-13);I=e-R;l=w*I*I*I*-.3333333333333333-Y*e+g;g=f-L;if(R>d){e=d-R;y=Y;z=w*e*e*e*.3333333333333333+(Y*d+l);A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}if(L>d){y=Y;z=Y*d+l;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}else{l=d-L;y=Y;z=X*l*l*l*.3333333333333333+(Y*d+(X*g*g*g*-.3333333333333333-Y*f+j));A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}}function Wg(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0;l=i;i=i+224|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=l+96|0;r=l+120|0;s=l+144|0;t=l+168|0;u=l+192|0;v=l+216|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=e*64.0;if(!(F>0.0)){G=c[28994]|0;H=D;h[k>>3]=F;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=u;I=8800;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];De[H&31](b,u,5408,D);}J=+_a(+F);if(!(e>0.0)){D=c[28994]|0;u=C;h[k>>3]=e;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=D;D=t;H=8800;c[D+0>>2]=c[H+0>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];c[D+12>>2]=c[H+12>>2];c[D+16>>2]=c[H+16>>2];c[D+20>>2]=c[H+20>>2];De[u&31](b,t,5472,C);}F=+_a(+e);e=g/3.7+5.74/+W(+f,.9);if(!(e>0.0)){C=c[28994]|0;t=B;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;u=8800;c[C+0>>2]=c[u+0>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];c[C+12>>2]=c[u+12>>2];c[C+16>>2]=c[u+16>>2];c[C+20>>2]=c[u+20>>2];De[t&31](b,s,5536,B);}K=f/+_a(+e);e=K*K*.25;B=e>=0.0;if(!B){s=c[28994]|0;t=A;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s;s=r;u=8800;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];De[t&31](b,r,5600,A);}K=+V(+e);f=g*.27+2.51/K;if(!B){B=c[28994]|0;A=z;h[k>>3]=e;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=B;B=q;r=8800;c[B+0>>2]=c[r+0>>2];c[B+4>>2]=c[r+4>>2];c[B+8>>2]=c[r+8>>2];c[B+12>>2]=c[r+12>>2];c[B+16>>2]=c[r+16>>2];c[B+20>>2]=c[r+20>>2];De[A&31](b,q,5600,z);}if(!(f>0.0)){z=c[28994]|0;q=y;h[k>>3]=f;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=z;z=p;A=8800;c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];c[z+16>>2]=c[A+16>>2];c[z+20>>2]=c[A+20>>2];De[q&31](b,p,5656,y);}g=K*+_a(+f)*-2.0;if(!(e>0.0)){y=c[28994]|0;p=x;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;q=8800;c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[y+16>>2]=c[q+16>>2];c[y+20>>2]=c[q+20>>2];De[p&31](b,o,5720,x);}K=+_a(+e);if(!(g>0.0)){x=c[28994]|0;o=w;h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=8800;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];De[o&31](b,n,5776,w);}e=+_a(+g);L=1.090079149577162/(f*g)+.5;if(d>0.0){M=+_a(+d);Xg(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}w=c[28994]|0;n=v;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=8800;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];De[n&31](b,m,5840,v);M=+_a(+d);Xg(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}function Xg(a,b,c,d,e,f,g,j,k){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;var l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;l=e-d;do{if(l!=l|0.0!=0.0|l==0.0){e=(f+g)*.5;m=g-f;if(m>0.0){n=1.0e+60;o=e;break}n=+(m<0.0|0)*1.0e+60;o=e}else{e=(c-d)/l;m=e*e;p=e*m;q=m*3.0;n=(m-e)*6.0/l*f+((e*-4.0+q+1.0)*j+((e-m)*6.0/l*g+(e*-2.0+q)*k));o=(m*-3.0+p*2.0+1.0)*f+(l*(p+(e+m*-2.0))*j+((q+p*-2.0)*g+l*(p-m)*k))}}while(0);h[a>>3]=o;h[a+8>>3]=n;i=b;return}function Yg(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0,Y=0;j=i;i=i+224|0;l=j;m=j+24|0;n=j+48|0;o=j+72|0;p=j+96|0;q=j+120|0;r=j+144|0;s=j+168|0;t=j+192|0;u=j+216|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;if(!(e>0.0)){D=c[28994]|0;E=C;h[k>>3]=e;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=t;F=8800;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];De[E&31](b,t,5472,C);}G=+_a(+e);H=e*64.0;if(!(H>0.0)){C=c[28994]|0;t=B;h[k>>3]=H;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;E=8800;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];De[t&31](b,s,5408,B);}I=+_a(+H);H=+W(+f,.9);J=g/3.7+5.74/H;if(!(J>0.0)){B=c[28994]|0;s=A;h[k>>3]=J;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=B;B=r;t=8800;c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];c[B+16>>2]=c[t+16>>2];c[B+20>>2]=c[t+20>>2];De[s&31](b,r,5536,A);}K=+_a(+J);L=f/K;M=L*L*.25;A=M>=0.0;if(!A){r=c[28994]|0;s=z;h[k>>3]=M;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r;r=q;t=8800;c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[r+16>>2]=c[t+16>>2];c[r+20>>2]=c[t+20>>2];De[s&31](b,q,5600,z);}L=g*.27+2.51/+V(+M);if(!A){A=c[28994]|0;z=y;h[k>>3]=M;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=A;A=p;q=8800;c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];c[A+16>>2]=c[q+16>>2];c[A+20>>2]=c[q+20>>2];De[z&31](b,p,5600,y);}if(!(L>0.0)){y=c[28994]|0;p=x;h[k>>3]=L;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;z=8800;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];De[p&31](b,o,5656,x);}+_a(+L);if(!(f>0.0)){x=c[28994]|0;o=w;h[k>>3]=f;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=8800;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];De[o&31](b,n,6224,w);}L=+_a(+f);if(!(M>0.0)){w=c[28994]|0;n=v;h[k>>3]=M;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=8800;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];De[n&31](b,m,5720,v);}f=1.121782646756099/(H*J*K)*4.0+2.0;K=L-G;G=(+_a(+M)-I)/K;I=(G*3.0+(-2.0-f))/K;M=(f+G*-2.0+1.0)/(K*K);K=d/e;if(K>0.0){N=+_a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}v=c[28994]|0;m=u;h[k>>3]=K;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=v;v=l;n=8800;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+16>>2]=c[n+16>>2];c[v+20>>2]=c[n+20>>2];De[m&31](b,l,6288,u);N=+_a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}function Zg(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;q=i;i=i+32|0;r=q;s=q+24|0;t=i;i=i+8|0;o=n/m;if(!(o<=.0065)){u=.0065/o}else{u=1.0}n=+od(+(+ca(+u)*745.0),+p);v=d>=0.0;u=v?e:f;f=v?g:j;j=+U(+d)/(f*m)*1.273239544735163;do{if(!(j<=n)){if(!(j>=p)){Yg(t,b,j,n,p,o);w=+h[t>>3];break}d=o/3.7+5.74/+W(+j,.9);if(!(d>0.0)){x=c[28994]|0;y=s;h[k>>3]=d;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x;x=r;z=8800;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];De[y&31](b,r,6352,s);}g=j/+_a(+d);w=g*g*.25}else{w=j*64.0}}while(0);j=f*f;f=+iA(m,-3);if(v){A=w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}A=-w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}function _g(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;do{if(c>f){g=d}else{if(c<-f){g=e;break}if(f>0.0){j=c/f;g=(d+e)*.5+(e-d)/f*(j*j+-3.0)*c*.25;break}else{g=(d+e)*.5;break}}}while(0);h[a>>3]=g;i=b;return}function $g(a,b,c,d,e,f,g){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;var j=0.0;j=d*g;g=e*3.0+(j*-2.0-d*f);f=c/d;h[a>>3]=f*(j+f*(g+(-g-j+e)*f));i=i;return}function ah(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+56|0;l=k;m=k+24|0;n=k+48|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=wy(g,1)|0;if(e<<24>>24!=0&f<<24>>24==0){f=lz(lz(lz(lz(6440,j)|0,6496)|0,b)|0,6528)|0;e=c[28994]|0;u=m;v=6720;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[u+16>>2]=c[v+16>>2];c[u+20>>2]=c[v+20>>2];De[e&31](a,m,f,s);}if((t|0)<1){i=k;return}s=(bh(1,1,t)|0)==0;if(!s){f=1;do{c[r>>2]=f;if(!(+h[(Fz(g,1,r)|0)>>3]>=0.0)){m=lz(lz(lz(lz(6744,b)|0,6792)|0,j)|0,6808)|0;e=lz(lz(m,iz(f,0,1)|0)|0,6848)|0;c[q>>2]=f;m=lz(lz(e,jz(+h[(Fz(g,1,q)|0)>>3],0,1,6)|0)|0,6856)|0;e=c[28994]|0;v=l;u=6896;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[v+20>>2]=c[u+20>>2];De[e&31](a,l,m,p);}f=f+1|0;}while((bh(f,1,t)|0)!=0)}if((t|0)<=0){i=k;return}if(!(+U(+(+Gz(g)+-1.0))>1.0e-10)){i=k;return}if(s){w=5400}else{s=5400;f=1;while(1){p=lz(s,6920)|0;l=lz(lz(p,iz(f,0,1)|0)|0,6936)|0;c[o>>2]=f;p=lz(lz(l,jz(+h[(Fz(g,1,o)|0)>>3],0,1,6)|0)|0,6944)|0;c[n>>2]=f;l=lz(lz(p,c[(hA(d,1,n)|0)>>2]|0)|0,6952)|0;p=f+1|0;if((bh(p,1,t)|0)==0){w=l;break}else{f=p;s=l}}}s=lz(lz(lz(lz(lz(6960,b)|0,6792)|0,j)|0,6952)|0,7e3)|0;ch(0,lz(lz(lz(s,jz(+Gz(g),0,1,6)|0)|0,7048)|0,w)|0);i=k;return}function bh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function ch(a,b){a=a|0;b=b|0;a=i;lA(b);i=a;return}function dh(a,b,c,d,e,f,g,j){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=g|0;j=+j;var k=0,l=0,m=0.0;b=i;i=i+16|0;k=b;l=b+8|0;do{if(!(c>=d)){if(c<=-d){m=-(c*c*f);break}if(!(e>=f)){eh(l,0,-c,d,f,e,g,j);m=-+h[l>>3];break}else{eh(k,0,c,d,e,f,g,j);m=+h[k>>3];break}}else{m=c*c*e}}while(0);h[a>>3]=m;i=b;return}function eh(a,b,c,d,e,f,g,j){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=g|0;j=+j;var k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0;b=i;i=i+16|0;k=b;l=b+8|0;m=-d;if(c<=m){n=-(c*c*f);o=a;p=o;h[p>>3]=n;i=b;return}q=d*d;r=q*e;s=q*f;q=d*e;e=q*2.0;t=m*f*-2.0;if(g<<24>>24==0){u=m/d;v=((s*-3.0-t*m)/u-(r*3.0-e*d)*u)/((1.0-u)*d*2.0)}else{v=j}j=q*2.23606797749979;q=+U(+m)*f*2.23606797749979;f=(j<q?j:q)*.9;q=f<v?f:v;if(!(c>=0.0)){$g(l,0,c,m,-s,t,q);n=+h[l>>3];o=a;p=o;h[p>>3]=n;i=b;return}else{$g(k,0,c,d,r,e,q);n=+h[k>>3];o=a;p=o;h[p>>3]=n;i=b;return}}function fh(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;j=+j;c[a>>2]=d;h[a+8>>3]=e;h[a+16>>3]=f;h[a+24>>3]=g;h[a+32>>3]=j;i=i;return}function gh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;hh(a,b,c,d,0);i=e;return}function hh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;qi(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));oi(f,0,0.0,0.0,h);i=g;return}function ih(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0.0;g=i;i=i+56|0;f=g;j=g+8|0;k=g+16|0;gh(f,b,d,e,0);l=+h[f>>3];jh(j,b,d,e,0);fh(k,0,1,l,+h[j>>3],e,d);d=+h[k+8>>3];e=+h[k+16>>3];l=+h[k+24>>3];m=+h[k+32>>3];c[a>>2]=c[k>>2];h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=l;h[a+32>>3]=m;i=g;return}function jh(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;e=i;kh(a,b,c,d,0);i=e;return}



function i_(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function j_(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function k_(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function l_(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=140920;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}y1(e)}}while(0);x1(b);i=d;return}function m_(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=140920;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}y1(e);i=d;return}function n_(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(yd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function o_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(yd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function p_(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function q_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Dd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function r_(a,b){a=a|0;b=b|0;i=i;return b|0}function s_(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function t_(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function u_(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function v_(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function w_(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function x_(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function y_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function z_(a){a=a|0;i=i;return 1}function A_(a){a=a|0;i=i;return 1}function B_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function C_(a){a=a|0;i=i;return 1}function D_(a){a=a|0;var b=0;b=i;LZ(a);x1(a);i=b;return}function E_(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Lc(c[s>>2]|0)|0;A=v0(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Lc(c[s>>2]|0)|0;A=u0(u,0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Lc(c[s>>2]|0)|0;G=u0(u,r,n)|0;if((z|0)!=0){Lc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function F_(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Lc(c[r>>2]|0)|0;y=r0(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Lc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Lc(c[r>>2]|0)|0;F=q0(x,y,1,d)|0;if((w|0)!=0){Lc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Lc(c[r>>2]|0)|0;y=q0(q,v,z-v|0,n)|0;if((w|0)!=0){Lc(w|0)|0}if((y|0)==0){I=v+1|0}else if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function G_(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Lc(c[b+8>>2]|0)|0;b=u0(e,0,d)|0;if((j|0)!=0){Lc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function H_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Lc(c[d>>2]|0)|0;e=t0(0,0,4)|0;if((a|0)!=0){Lc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Lc(a|0)|0;if((g|0)==0){f=0;break}Lc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function I_(a){a=a|0;i=i;return 0}function J_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Lc(c[k>>2]|0)|0;n=p0(a,j-a|0,b)|0;if((m|0)!=0){Lc(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function K_(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Lc(d|0)|0;if((a|0)==0){e=4;break}Lc(a|0)|0;e=4}}while(0);i=b;return e|0}function L_(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function M_(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=N_(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function N_(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function O_(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=P_(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function P_(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function Q_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function R_(a){a=a|0;i=i;return 0}function S_(a){a=a|0;i=i;return 0}function T_(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=U_(c,d,e,1114111,0)|0;i=b;return a|0}function U_(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function V_(a){a=a|0;i=i;return 4}function W_(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function X_(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Y_(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Y_(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function Z_(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=__(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function __(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function $_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function a$(a){a=a|0;i=i;return 0}function b$(a){a=a|0;i=i;return 0}function c$(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=d$(c,d,e,1114111,0)|0;i=b;return a|0}function d$(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function e$(a){a=a|0;i=i;return 4}function f$(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function g$(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function h$(a){a=a|0;var b=0;b=i;c[a>>2]=141072;kT(a+12|0);x1(a);i=b;return}function i$(a){a=a|0;var b=0;b=i;c[a>>2]=141072;kT(a+12|0);i=b;return}function j$(a){a=a|0;var b=0;b=i;c[a>>2]=141112;kT(a+16|0);x1(a);i=b;return}function k$(a){a=a|0;var b=0;b=i;c[a>>2]=141112;kT(a+16|0);i=b;return}function l$(b){b=b|0;i=i;return a[b+8|0]|0}function m$(a){a=a|0;i=i;return c[a+8>>2]|0}function n$(b){b=b|0;i=i;return a[b+9|0]|0}function o$(a){a=a|0;i=i;return c[a+12>>2]|0}function p$(a,b){a=a|0;b=b|0;var c=0;c=i;aT(a,b+12|0);i=c;return}function q$(a,b){a=a|0;b=b|0;var c=0;c=i;aT(a,b+16|0);i=c;return}function r$(a,b){a=a|0;b=b|0;b=i;cT(a,141144,4);i=b;return}function s$(a,b){a=a|0;b=b|0;b=i;MT(a,141152,R0(141152)|0);i=b;return}function t$(a,b){a=a|0;b=b|0;b=i;cT(a,141176,5);i=b;return}function u$(a,b){a=a|0;b=b|0;b=i;MT(a,141184,R0(141184)|0);i=b;return}function v$(b){b=b|0;var d=0,e=0;b=i;if((a[141216]|0)!=0){d=141208;e=c[35302]|0;i=b;return e|0}if((Za(141216)|0)==0){d=141208;e=c[35302]|0;i=b;return e|0}do{if((a[148416]|0)==0){if((Za(148416)|0)==0){break}X1(148248,0,168)|0;Ud(237,0,q|0)|0;Sb(148416)}}while(0);nT(148248,148424)|0;nT(148260|0,148432)|0;nT(148272|0,148440)|0;nT(148284|0,148448)|0;nT(148296|0,148464)|0;nT(148308|0,148480)|0;nT(148320|0,148488)|0;nT(148332|0,148504)|0;nT(148344|0,148512)|0;nT(148356|0,148520)|0;nT(148368|0,148528)|0;nT(148380|0,148536)|0;nT(148392|0,148544)|0;nT(148404|0,148552)|0;c[35302]=148248;Sb(141216);d=141208;e=c[35302]|0;i=b;return e|0}function w$(b){b=b|0;var d=0,e=0;b=i;if((a[141232]|0)!=0){d=141224;e=c[35306]|0;i=b;return e|0}if((Za(141232)|0)==0){d=141224;e=c[35306]|0;i=b;return e|0}do{if((a[147880]|0)==0){if((Za(147880)|0)==0){break}X1(147712,0,168)|0;Ud(238,0,q|0)|0;Sb(147880)}}while(0);PT(147712,147888)|0;PT(147724|0,147920)|0;PT(147736|0,147952)|0;PT(147748|0,147984)|0;PT(147760|0,148024)|0;PT(147772|0,148064)|0;PT(147784|0,148096)|0;PT(147796|0,148136)|0;PT(147808|0,148152)|0;PT(147820|0,148168)|0;PT(147832|0,148184)|0;PT(147844|0,148200)|0;PT(147856|0,148216)|0;PT(147868|0,148232)|0;c[35306]=147712;Sb(141232);d=141224;e=c[35306]|0;i=b;return e|0}function x$(b){b=b|0;var d=0,e=0;b=i;if((a[141248]|0)!=0){d=141240;e=c[35310]|0;i=b;return e|0}if((Za(141248)|0)==0){d=141240;e=c[35310]|0;i=b;return e|0}do{if((a[147488]|0)==0){if((Za(147488)|0)==0){break}X1(147200,0,288)|0;Ud(239,0,q|0)|0;Sb(147488)}}while(0);nT(147200,147496)|0;nT(147212|0,147504)|0;nT(147224|0,147520)|0;nT(147236|0,147528)|0;nT(147248|0,147536)|0;nT(147260|0,147544)|0;nT(147272|0,147552)|0;nT(147284|0,147560)|0;nT(147296|0,147568)|0;nT(147308|0,147584)|0;nT(147320|0,147592)|0;nT(147332|0,147608)|0;nT(147344|0,147624)|0;nT(147356|0,147632)|0;nT(147368|0,147640)|0;nT(147380|0,147648)|0;nT(147392|0,147536)|0;nT(147404|0,147656)|0;nT(147416|0,147664)|0;nT(147428|0,147672)|0;nT(147440|0,147680)|0;nT(147452|0,147688)|0;nT(147464|0,147696)|0;nT(147476|0,147704)|0;c[35310]=147200;Sb(141248);d=141240;e=c[35310]|0;i=b;return e|0}function y$(b){b=b|0;var d=0,e=0;b=i;if((a[141264]|0)!=0){d=141256;e=c[35314]|0;i=b;return e|0}if((Za(141264)|0)==0){d=141256;e=c[35314]|0;i=b;return e|0}do{if((a[146648]|0)==0){if((Za(146648)|0)==0){break}X1(146360,0,288)|0;Ud(240,0,q|0)|0;Sb(146648)}}while(0);PT(146360,146656)|0;PT(146372|0,146688)|0;PT(146384|0,146728)|0;PT(146396|0,146752)|0;PT(146408|0,147072)|0;PT(146420|0,146776)|0;PT(146432|0,146800)|0;PT(146444|0,146824)|0;PT(146456|0,146856)|0;PT(146468|0,146896)|0;PT(146480|0,146928)|0;PT(146492|0,146968)|0;PT(146504|0,147008)|0;PT(146516|0,147024)|0;PT(146528|0,147040)|0;PT(146540|0,147056)|0;PT(146552|0,147072)|0;PT(146564|0,147088)|0;PT(146576|0,147104)|0;PT(146588|0,147120)|0;PT(146600|0,147136)|0;PT(146612|0,147152)|0;PT(146624|0,147168)|0;PT(146636|0,147184)|0;c[35314]=146360;Sb(141264);d=141256;e=c[35314]|0;i=b;return e|0}function z$(b){b=b|0;var d=0,e=0;b=i;if((a[141280]|0)!=0){d=141272;e=c[35318]|0;i=b;return e|0}if((Za(141280)|0)==0){d=141272;e=c[35318]|0;i=b;return e|0}do{if((a[146336]|0)==0){if((Za(146336)|0)==0){break}X1(146048,0,288)|0;Ud(241,0,q|0)|0;Sb(146336)}}while(0);nT(146048,146344)|0;nT(146060|0,146352)|0;c[35318]=146048;Sb(141280);d=141272;e=c[35318]|0;i=b;return e|0}function A$(b){b=b|0;var d=0,e=0;b=i;if((a[141296]|0)!=0){d=141288;e=c[35322]|0;i=b;return e|0}if((Za(141296)|0)==0){d=141288;e=c[35322]|0;i=b;return e|0}do{if((a[146008]|0)==0){if((Za(146008)|0)==0){break}X1(145720,0,288)|0;Ud(242,0,q|0)|0;Sb(146008)}}while(0);PT(145720,146016)|0;PT(145732|0,146032)|0;c[35322]=145720;Sb(141296);d=141288;e=c[35322]|0;i=b;return e|0}function B$(b){b=b|0;var c=0;b=i;if((a[141320]|0)!=0){c=141304;i=b;return c|0}if((Za(141320)|0)==0){c=141304;i=b;return c|0}cT(141304,141328,8);Ud(243,141304,q|0)|0;Sb(141320);c=141304;i=b;return c|0}function C$(b){b=b|0;var c=0;b=i;if((a[141360]|0)!=0){c=141344;i=b;return c|0}if((Za(141360)|0)==0){c=141344;i=b;return c|0}MT(141344,141368,R0(141368)|0);Ud(244,141344,q|0)|0;Sb(141360);c=141344;i=b;return c|0}function D$(b){b=b|0;var c=0;b=i;if((a[141424]|0)!=0){c=141408;i=b;return c|0}if((Za(141424)|0)==0){c=141408;i=b;return c|0}cT(141408,141432,8);Ud(243,141408,q|0)|0;Sb(141424);c=141408;i=b;return c|0}function E$(b){b=b|0;var c=0;b=i;if((a[141464]|0)!=0){c=141448;i=b;return c|0}if((Za(141464)|0)==0){c=141448;i=b;return c|0}MT(141448,141472,R0(141472)|0);Ud(244,141448,q|0)|0;Sb(141464);c=141448;i=b;return c|0}function F$(b){b=b|0;var c=0;b=i;if((a[141528]|0)!=0){c=141512;i=b;return c|0}if((Za(141528)|0)==0){c=141512;i=b;return c|0}cT(141512,141536,20);Ud(243,141512,q|0)|0;Sb(141528);c=141512;i=b;return c|0}function G$(b){b=b|0;var c=0;b=i;if((a[141576]|0)!=0){c=141560;i=b;return c|0}if((Za(141576)|0)==0){c=141560;i=b;return c|0}MT(141560,141584,R0(141584)|0);Ud(244,141560,q|0)|0;Sb(141576);c=141560;i=b;return c|0}function H$(b){b=b|0;var c=0;b=i;if((a[141688]|0)!=0){c=141672;i=b;return c|0}if((Za(141688)|0)==0){c=141672;i=b;return c|0}cT(141672,141696,11);Ud(243,141672,q|0)|0;Sb(141688);c=141672;i=b;return c|0}function I$(b){b=b|0;var c=0;b=i;if((a[141728]|0)!=0){c=141712;i=b;return c|0}if((Za(141728)|0)==0){c=141712;i=b;return c|0}MT(141712,141736,R0(141736)|0);Ud(244,141712,q|0)|0;Sb(141728);c=141712;i=b;return c|0}function J$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);l=+N1(b,g,c[35198]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function K$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);l=+N1(b,g,c[35198]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function L$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);l=+N1(b,g,c[35198]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function M$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);n=lb(b|0,h|0,f|0,c[35198]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function N$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);m=lb(b|0,h|0,f|0,c[35198]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function O$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);m=lb(b|0,h|0,f|0,c[35198]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function P$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);m=lb(b|0,h|0,f|0,c[35198]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function Q$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);n=Gc(b|0,h|0,f|0,c[35198]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function R$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[140800]|0)==0){if((Za(140800)|0)==0){break}c[35198]=Zb(2147483647,140808,0)|0;Sb(140800)}}while(0);m=Gc(b|0,h|0,f|0,c[35198]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function S$(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;ae[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;ae[h&255](a);i=b;return}}function T$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){MZ(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=v1(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;V1(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{x1(h);i=e;return}}function U$(a){a=a|0;a=i;OT(145996|0);OT(145984|0);OT(145972|0);OT(145960|0);OT(145948|0);OT(145936|0);OT(145924|0);OT(145912|0);OT(145900|0);OT(145888|0);OT(145876|0);OT(145864|0);OT(145852|0);OT(145840|0);OT(145828|0);OT(145816|0);OT(145804|0);OT(145792|0);OT(145780|0);OT(145768|0);OT(145756|0);OT(145744|0);OT(145732|0);OT(145720);i=a;return}function V$(a){a=a|0;a=i;kT(146324|0);kT(146312|0);kT(146300|0);kT(146288|0);kT(146276|0);kT(146264|0);kT(146252|0);kT(146240|0);kT(146228|0);kT(146216|0);kT(146204|0);kT(146192|0);kT(146180|0);kT(146168|0);kT(146156|0);kT(146144|0);kT(146132|0);kT(146120|0);kT(146108|0);kT(146096|0);kT(146084|0);kT(146072|0);kT(146060|0);kT(146048);i=a;return}function W$(a){a=a|0;a=i;OT(146636|0);OT(146624|0);OT(146612|0);OT(146600|0);OT(146588|0);OT(146576|0);OT(146564|0);OT(146552|0);OT(146540|0);OT(146528|0);OT(146516|0);OT(146504|0);OT(146492|0);OT(146480|0);OT(146468|0);OT(146456|0);OT(146444|0);OT(146432|0);OT(146420|0);OT(146408|0);OT(146396|0);OT(146384|0);OT(146372|0);OT(146360);i=a;return}function X$(a){a=a|0;a=i;kT(147476|0);kT(147464|0);kT(147452|0);kT(147440|0);kT(147428|0);kT(147416|0);kT(147404|0);kT(147392|0);kT(147380|0);kT(147368|0);kT(147356|0);kT(147344|0);kT(147332|0);kT(147320|0);kT(147308|0);kT(147296|0);kT(147284|0);kT(147272|0);kT(147260|0);kT(147248|0);kT(147236|0);kT(147224|0);kT(147212|0);kT(147200);i=a;return}function Y$(a){a=a|0;a=i;OT(147868|0);OT(147856|0);OT(147844|0);OT(147832|0);OT(147820|0);OT(147808|0);OT(147796|0);OT(147784|0);OT(147772|0);OT(147760|0);OT(147748|0);OT(147736|0);OT(147724|0);OT(147712);i=a;return}function Z$(a){a=a|0;a=i;kT(148404|0);kT(148392|0);kT(148380|0);kT(148368|0);kT(148356|0);kT(148344|0);kT(148332|0);kT(148320|0);kT(148308|0);kT(148296|0);kT(148284|0);kT(148272|0);kT(148260|0);kT(148248);i=a;return}function _$(a){a=a|0;var b=0,c=0;b=i;if((e0(a)|0)==0){c=($$(a)|0)!=0|0}else{c=1}i=b;return c|0}function $$(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[148560+((d[148560+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function a0(a){a=a|0;var b=0,c=0;b=i;c=xb(a|0)|0;i=b;return c|0}function b0(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function c0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 11:{d=k0(a)|0;break};case 4:{d=b0(a)|0;break};case 9:{d=i0(a)|0;break};case 5:{d=e0(a)|0;break};case 7:{d=g0(a)|0;break};case 10:{d=j0(a)|0;break};case 12:{d=l0(a)|0;break};case 8:{d=h0(a)|0;break};case 6:{d=f0(a)|0;break};case 1:{d=_$(a)|0;break};case 3:{d=a0(a)|0;break};case 2:{d=$$(a)|0;break};default:{d=0}}i=c;return d|0}function d0(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=151536;while(1){if(d<<24>>24==e<<24>>24){if((P1(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function e0(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function f0(a){a=a|0;var b=0,c=0;b=i;if((j0(a)|0)==0){c=(h0(a)|0)!=0|0}else{c=0}i=b;return c|0}function g0(a){a=a|0;var b=0,c=0;b=i;if((m0(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function h0(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function i0(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[151616+((d[151616+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function j0(a){a=a|0;var b=0,c=0;b=i;c=(Q0(154784,a)|0)!=0|0;i=b;return c|0}function k0(a){a=a|0;var b=0,c=0;b=i;c=(o0(a)|0)!=(a|0)|0;i=b;return c|0}function l0(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function m0(a){a=a|0;var b=0,c=0;b=i;c=n0(a,0)|0;i=b;return c|0}function n0(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if(($$(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[154874+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[154872+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[154875+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[155120+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[155120+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[155120+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function o0(a){a=a|0;var b=0,c=0;b=i;c=n0(a,1)|0;i=b;return c|0}function p0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=q0(0,a,b,(c|0)!=0?c:155824)|0;i=d;return e|0}function q0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?155832:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[155616+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Nc()|0)>>2]=84;k=-1;i=g;return k|0}function r0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=s0(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=q0(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function s0(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[155616+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[155616+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Nc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function t0(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[155616+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Nc()|0)>>2]=84;j=-1;i=g;return j|0}function u0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Nc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function v0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=w0(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=u0(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function w0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=u0(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=u0(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=u0(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}u0(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function x0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=p1(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=p1(2048)|0;c[p+16>>2]=s;if((s|0)==0){q1(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=N0(0,0)|0;if((s|0)==0){q1(c[p+16>>2]|0);q1(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=y0(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=r1(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=z0(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=p1(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;X1(y|0,-1,v|0)|0;I=H}else{I=0}H=r1(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=r1(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=z0(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=F0(q,x)|0;b:do{if((v|0)==0){y=F0(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==3){T=c[S+4>>2]|0;U=F0(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=F0(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=F0(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}X=F0(q,0)|0}else if((P|0)==2){U=c[S+4>>2]|0;T=F0(q,L)|0;if((T|0)!=0){V=N;W=T;break c}T=F0(q,S)|0;if((T|0)!=0){V=N;W=T;break c}T=F0(q,1)|0;if((T|0)!=0){V=N;W=T;break c}T=F0(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=F0(q,0)|0;if((T|0)!=0){V=N;W=T;break c}if((c[U+4>>2]|0)>1){F=45}else{if((c[U+8>>2]|0)>1){F=45}else{Y=L}}if((F|0)==45){F=0;c[j>>2]=0;Y=0}Z=Y;_=M+1|0;$=N;break}else if((P|0)==1){U=c[S+4>>2]|0;T=F0(q,c[U+4>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=F0(q,0)|0;if((T|0)!=0){V=N;W=T;break c}T=F0(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}X=F0(q,0)|0}else if((P|0)==0){P=c[S+4>>2]|0;T=c[P>>2]|0;if(!((T|0)>-1|(T|0)==-4)){Z=L;_=M;$=N;break}T=P+8|0;P=(c[T>>2]|0)+L|0;c[T>>2]=P;if((P|0)<=(c[k>>2]|0)){Z=L;_=M;$=N;break}c[k>>2]=P;Z=L;_=M;$=N;break}else{Z=L;_=M;$=N;break}if((X|0)==0){Z=L;_=M;$=N}else{V=N;W=X;break c}}else if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;aa=c[Q+(U<<2)>>2]|0;c[j>>2]=aa;U=T+4|0;ba=c[U>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=T;F=51}else{if((c[T+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=T;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=G0(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=P0(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=P0(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[U>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;U=T+8|0;ba=c[U>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=G0(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=P0(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=P0(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=G0(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=P0(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=P0(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=P0(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=P0(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=P0(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=P0(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[U>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}U=P0(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}ba=P0(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=ba;if((ba|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=ia;c[(c[T>>2]|0)+4>>2]=ra;c[U+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=U;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[P>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}U=M+ -1|0;T=da-aa+N|0;if((U|0)!=0){Z=da;_=U;$=T;break}c[j>>2]=T;Z=T;_=0;$=T}else{Z=L;_=M;$=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Z;M=_;N=$;O=S}else{V=$;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=P0(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=P0(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=P0(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=P0(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=F0(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=F0(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==1){M=c[ya+4>>2]|0;L=c[M>>2]|0;Q=M+4|0;R=c[Q>>2]|0;if((c[L+8>>2]|0)==0){za=(c[R+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;T=D0(s,c[L+24>>2]|0,c[R+24>>2]|0,0,0)|0;c[ya+24>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}T=D0(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Q>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){T=c[ya>>2]|0;if((T|0)==0){Q=c[ya+4>>2]|0;M=c[Q>>2]|0;if((M|0)==-4){c[ya+8>>2]=0;R=Q+8|0;L=c[R>>2]|0;U=P0(s,0,0,1,64)|0;if((U|0)==0){F=104;break g}ba=U;c[U>>2]=L;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;L=U+28|0;U=ya+24|0;c[L+0>>2]=-1;c[L+4>>2]=-1;c[L+8>>2]=-1;c[L+12>>2]=-1;c[U>>2]=ba;ba=c[R>>2]|0;R=c[Q+4>>2]|0;U=P0(s,0,0,1,64)|0;if((U|0)==0){F=106;break g}c[U>>2]=ba;c[U+4>>2]=0;c[U+8>>2]=1114111;c[U+20>>2]=0;c[U+24>>2]=0;c[U+28>>2]=R;c[U+32>>2]=-1;c[U+36>>2]=-1;c[U+40>>2]=-1;c[ya+28>>2]=U;break}U=ya+8|0;if((M|0)<0){c[U>>2]=1;R=P0(s,0,0,1,32)|0;if((R|0)==0){F=110;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+24>>2]=R;R=P0(s,0,0,1,32)|0;if((R|0)==0){F=112;break g}c[R>>2]=-1;c[R+4>>2]=-1;c[R+8>>2]=-1;c[ya+28>>2]=R;break}else{c[U>>2]=0;U=Q+8|0;R=c[U>>2]|0;ba=Q+4|0;L=c[ba>>2]|0;la=P0(s,0,0,1,64)|0;if((la|0)==0){F=115;break g}ma=la;c[la>>2]=R;c[la+4>>2]=M;c[la+8>>2]=L;c[la+20>>2]=0;c[la+24>>2]=0;L=la+28|0;la=ya+24|0;c[L+0>>2]=-1;c[L+4>>2]=-1;c[L+8>>2]=-1;c[L+12>>2]=-1;c[la>>2]=ma;ma=c[U>>2]|0;U=c[Q>>2]|0;la=c[ba>>2]|0;ba=c[Q+12>>2]|0;L=c[Q+16>>2]|0;Q=P0(s,0,0,1,64)|0;if((Q|0)==0){F=117;break g}M=Q;c[Q>>2]=ma;c[Q+4>>2]=U;c[Q+8>>2]=la;c[Q+20>>2]=ba;c[Q+24>>2]=L;L=Q+28|0;Q=ya+28|0;c[L+0>>2]=-1;c[L+4>>2]=-1;c[L+8>>2]=-1;c[L+12>>2]=-1;c[Q>>2]=M;break}}else if((T|0)==2){M=F0(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=F0(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=F0(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=F0(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else if((T|0)==3){M=F0(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=F0(q,1)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=ya+4|0;Q=F0(q,c[(c[M>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=F0(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=F0(q,c[c[M>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=F0(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else if((T|0)==1){T=F0(q,ya)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=F0(q,2)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=ya+4|0;Q=F0(q,c[(c[T>>2]|0)+4>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=F0(q,0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=F0(q,c[c[T>>2]>>2]|0)|0;if((Q|0)!=0){z=0;A=Q;B=0;C=D;break a}Q=F0(q,0)|0;if((Q|0)==0){break}else{z=0;A=Q;B=0;C=D;break a}}else{break}}else if((S|0)==3){Q=c[ya+4>>2]|0;T=c[Q>>2]|0;do{if((c[Q+4>>2]|0)==0){F=141}else{if((c[T+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[T+24>>2];c[ya+28>>2]=c[(c[Q>>2]|0)+28>>2]}else if((S|0)==2){M=c[ya+4>>2]|0;L=c[M>>2]|0;ba=L+8|0;if((c[ba>>2]|0)==0){Aa=0}else{Aa=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[ba>>2]|0)==0){c[ya+24>>2]=c[L+24>>2];Ba=M+4|0}else{ba=E0(q,L,0,0,g)|0;if((ba|0)!=0){z=0;A=ba;B=0;C=D;break a}Ca=p1((c[g>>2]<<2)+4|0)|0;ba=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=E0(q,c[M>>2]|0,ba,h,0)|0;if((Da|0)!=0){F=150;break g}L=M+4|0;la=D0(s,c[(c[L>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,ba,c[h>>2]|0)|0;ba=ya+24|0;c[ba>>2]=la;q1(Ca);if((c[ba>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=L}}L=c[Ba>>2]|0;if((c[L+8>>2]|0)==0){c[ya+28>>2]=c[L+28>>2];break}ba=E0(q,L,0,0,g)|0;if((ba|0)!=0){z=0;A=ba;B=0;C=D;break a}Ea=p1((c[g>>2]<<2)+4|0)|0;ba=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=E0(q,c[Ba>>2]|0,ba,h,0)|0;if((Fa|0)!=0){F=157;break g}L=D0(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,ba,c[h>>2]|0)|0;ba=ya+28|0;c[ba>>2]=L;q1(Ea);if((c[ba>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){q1(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){q1(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=p1(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=p1(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){X1(O|0,0,((E|0)>1?E<<2:4)|0)|0}A0(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;ba=O+(S<<2)|0;L=K+1+(c[ba>>2]|0)|0;c[ba>>2]=0;ba=S+1|0;if((ba|0)<(E|0)){S=ba;K=L}else{Ga=L;break}}}else{Ga=0}K=r1(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;L=A0(y,S,x,u)|0;if((L|0)!=0){z=x;A=L;B=u;C=D;break}c[w+20>>2]=0;L=v+24|0;S=c[L>>2]|0;if((c[S>>2]|0)>-1){ba=1;M=S;while(1){S=M+32|0;la=ba+1|0;if((c[S>>2]|0)>-1){M=S;ba=la}else{Ha=la;break}}}else{Ha=1}ba=r1(Ha,32)|0;if((ba|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=ba;M=c[L>>2]|0;y=c[M>>2]|0;if((y|0)>-1){la=y;y=M;M=0;while(1){c[ba+(M<<5)+8>>2]=K+(c[N+(la<<2)>>2]<<5);c[ba+(M<<5)+12>>2]=la;S=ba+(M<<5)+16|0;c[S>>2]=0;U=y+12|0;ma=c[U>>2]|0;if((ma|0)!=0){R=0;while(1){Ia=R+1|0;if((c[ma+(R<<2)>>2]|0)>-1){R=Ia}else{break}}R=Ia<<2;ma=p1(R)|0;c[S>>2]=ma;if((ma|0)==0){z=x;A=12;B=u;C=D;break a}V1(ma|0,c[U>>2]|0,R|0)|0}c[ba+(M<<5)+20>>2]=c[y+16>>2];R=M+1|0;ma=y+32|0;ka=c[ma>>2]|0;if((ka|0)>-1){la=ka;y=ma;M=R}else{Ja=R;break}}}else{Ja=0}c[ba+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;O0(s);q1(c[p+16>>2]|0);q1(p);q1(O);q1(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);O0(s);q1(c[p+16>>2]|0);q1(p);if((z|0)!=0){q1(z)}if((B|0)!=0){q1(B)}c[b+4>>2]=C;B0(b);r=A;i=f;return r|0}function y0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;F0(m,c[p>>2]|0)|0;F0(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=F0(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 0:{if((c[v>>2]&1|0)!=0){Q=F0(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}}U=M;V=N;W=F0(m,3)|0;break};case 3:{Q=F0(m,5)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=F0(m,4)|0;break};case 8:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;Q=c[w>>2]|0;Y=P0(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=P0(Q,0,0,1,8)|0;Q=Y+4|0;c[Q>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=X;c[(c[Q>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[X+16>>2]|0);U=M;V=Y;W=0;break};case 9:{Y=c[q>>2]|0;X=a[Y]|0;switch(X<<24>>24|0){case 42:{T=41;break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};case 123:{Q=c[v>>2]|0;if((Q&1|0)==0){U=M;V=N;W=0;break c}else{$=Q;aa=Y}break};case 92:{Q=c[v>>2]|0;if((Q&1|0)!=0){U=M;V=N;W=0;break c}_=Y+1|0;if((a[_]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=_;$=Q;aa=_;break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=Y+1;Y=c[w>>2]|0;_=P0(Y,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}Q=P0(Y,0,0,1,16)|0;c[_+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[_>>2]=2;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Q>>2]=N;c[Q+4>>2]=X<<24>>24==43;c[Q+8>>2]=X<<24>>24==63?1:-1;X=Q+12|0;a[X]=a[X]&-2;c[_+16>>2]=c[N+16>>2];U=M;V=_;W=F0(m,9)|0;break c}_=aa+1|0;c[q>>2]=_;X=a[_]|0;if((X+ -48<<24>>24&255)<10){Q=X<<24>>24;if((Q+ -48|0)>>>0<10){ba=Q;ca=-1;da=_}else{Z=10;T=294;break b}while(1){Q=((ca|0)<0?-48:(ca*10|0)+ -48|0)+ba|0;Y=da+1|0;ea=a[Y]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){da=Y;ca=Q;ba=fa}else{ga=ea;ha=Q;ia=Y;break}}}else{ga=X;ha=-1;ia=_}do{if(ga<<24>>24==44){Y=ia+1|0;Q=a[Y]|0;ea=Q<<24>>24;if((ea+ -48|0)>>>0<10){ja=ea;ka=-1;la=Y}else{ma=Q;na=-1;oa=Y;break}while(1){Y=((ka|0)<0?-48:(ka*10|0)+ -48|0)+ja|0;Q=la+1|0;ea=a[Q]|0;fa=ea<<24>>24;if((fa+ -48|0)>>>0<10){la=Q;ka=Y;ja=fa}else{pa=ea;qa=Y;ra=Q;T=54;break}}}else{pa=ga;qa=ha;ra=ia;T=54}}while(0);do{if((T|0)==54){T=0;if(!((qa|0)>-1)){ma=pa;na=qa;oa=ra;break}if((ha|0)>(qa|0)|(qa|0)>255){Z=10;T=294;break b}else{ma=pa;na=qa;oa=ra}}}while(0);if(ma<<24>>24==0){Z=9;T=294;break b}if((oa|0)==(_|0)){Z=10;T=294;break b}if(($&1|0)==0){if(!(ma<<24>>24==92)){Z=10;T=294;break b}if((a[oa+1|0]|0)!=125){Z=10;T=294;break b}sa=oa+2|0}else{if(!(ma<<24>>24==125)){Z=10;T=294;break b}sa=oa+1|0}if((na|ha|0)==0){X=c[w>>2]|0;Q=P0(X,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}Y=P0(X,0,0,1,20)|0;c[Q+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;ta=Q}else{Q=(na&ha|0)<0;Y=c[w>>2]|0;X=P0(Y,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}ea=P0(Y,0,0,1,16)|0;c[X+4>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[X>>2]=2;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ea>>2]=N;c[ea+4>>2]=Q?1:ha;c[ea+8>>2]=Q?1:na;Q=ea+12|0;a[Q]=a[Q]&-2;c[X+16>>2]=c[N+16>>2];ta=X}c[q>>2]=sa;U=M;V=ta;W=F0(m,9)|0;break};case 6:{X=L+ -2|0;c[n>>2]=X;Q=c[P+(X<<2)>>2]|0;X=c[w>>2]|0;ea=P0(X,0,0,1,32)|0;if((ea|0)==0){Z=12;T=294;break b}Y=P0(X,0,0,1,8)|0;X=ea+4|0;c[X>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[ea>>2]=1;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[Y>>2]=Q;c[(c[X>>2]|0)+4>>2]=N;c[ea+16>>2]=(c[N+16>>2]|0)+(c[Q+16>>2]|0);U=M;V=ea;W=0;break};case 7:{ea=c[q>>2]|0;Q=a[ea]|0;if((Q|0)==41){c[q>>2]=ea+1;U=M;V=N;W=0;break c}else if((Q|0)!=124){U=M;V=N;W=0;break c}Q=F0(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=F0(m,N)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=F0(m,8)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}Q=F0(m,3)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 4:{Q=F0(m,9)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=F0(m,1)|0;break};case 2:{Q=L+ -2|0;c[n>>2]=Q;ea=c[P+(Q<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Q=c[w>>2]|0;X=P0(Q,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}Y=P0(Q,0,0,1,20)|0;c[X+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Y>>2]=-1;c[Y+4>>2]=-1;c[Y+8>>2]=-1;Y=c[w>>2]|0;Q=P0(Y,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}fa=P0(Y,0,0,1,8)|0;Y=Q+4|0;c[Y>>2]=fa;if((fa|0)==0){Z=12;T=294;break b}c[Q>>2]=1;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[fa>>2]=X;c[(c[Y>>2]|0)+4>>2]=N;Y=N+16|0;fa=Q+16|0;c[fa>>2]=(c[Y>>2]|0)+(c[X+16>>2]|0);c[fa>>2]=c[Y>>2];ua=Q}else{ua=N}c[ua+12>>2]=ea;ea=ua+16|0;c[ea>>2]=(c[ea>>2]|0)+1;U=M;V=ua;W=0;break};case 10:{ea=L+ -2|0;c[n>>2]=ea;c[v>>2]=c[P+(ea<<2)>>2];U=M;V=N;W=0;break};case 5:{ea=c[q>>2]|0;Q=a[ea]|0;if(Q<<24>>24==0){U=M;V=N;W=0;break c}Y=c[v>>2]&1;fa=(Y|0)!=0;if(fa&Q<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(fa&Q<<24>>24==41&(M|0)>0)){if((Y|0)==0&Q<<24>>24==92){if((a[ea+1|0]|0)==41){break}}X=F0(m,5)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=F0(m,N)|0;if((X|0)!=0){R=M;S=X;T=6;break b}X=F0(m,6)|0;if((X|0)!=0){R=M;S=X;T=6;break b}U=M;V=N;W=F0(m,4)|0;break c}}while(0);Q=(Y|M|0)==0?8:0;fa=M+ -1|0;if((Y|0)!=0){U=fa;V=N;W=Q;break c}c[q>>2]=ea+2;U=fa;V=N;W=Q;break};case 1:{Q=c[q>>2]|0;d:do{switch(a[Q]|0){case 40:{if((c[v>>2]&1|0)!=0){va=Q;T=74}break};case 91:{fa=Q+1|0;c[q>>2]=fa;_=p1(128)|0;if((_|0)==0){Z=12;T=294;break b}if((a[fa]|0)==94){X=Q+2|0;c[q>>2]=X;wa=X;xa=1}else{wa=fa;xa=0}fa=(xa|0)==0;X=_;_=0;ya=0;za=32;Aa=wa;e:while(1){Ba=a[Aa]|0;if(Ba<<24>>24==0){Ca=X;Da=Aa;Ea=7;T=140;break}else if(Ba<<24>>24==93){if(Aa>>>0>(c[q>>2]|0)>>>0){T=85;break}}Ba=t0(e,Aa,-1)|0;if((Ba|0)<0){c[e>>2]=-1;Fa=1}else{Fa=Ba}Ba=Aa+Fa|0;do{if((a[Ba]|0)==45){Ga=Fa+1|0;Ha=Aa+Ga|0;if((a[Ha]|0)==93){T=94;break}Ia=c[e>>2]|0;Ja=t0(e,Ha,-1)|0;if((Ja|0)<0){c[e>>2]=-1;Ka=-1;La=1}else{Ka=c[e>>2]|0;La=Ja}Ma=0;Na=Ka;Oa=Ia;Pa=Aa+(La+Ga)|0;Qa=Ia>>>0>Ka>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;Ia=a[Aa]|0;do{if(Ia<<24>>24==91){Ga=a[Aa+1|0]|0;if(Ga<<24>>24==61|Ga<<24>>24==46){Ca=X;Da=Aa;Ea=3;T=140;break e}else if(!(Ga<<24>>24==58)){Ra=0;break}Ga=Aa+2|0;Ja=Ga;while(1){Ha=a[Ja]|0;Sa=Ha<<24>>24==0;if(Ha<<24>>24!=58&(Sa^1)){Ja=Ja+1|0}else{break}}if(Sa){Ca=X;Da=Aa;Ea=4;T=140;break e}Ha=Ja-Aa+ -2|0;Ta=(Ha|0)>63?63:Ha;c2(A|0,Ga|0,Ta|0)|0;a[f+Ta|0]=0;Ta=d0(A)|0;Ma=Ta;Na=1114111;Oa=0;Pa=Ja+2|0;Qa=(Ta|0)==0?4:0;break f}else if(Ia<<24>>24==45){if((a[Aa+1|0]|0)==93){Ra=0;break}Ra=(c[q>>2]|0)==(Aa|0)?0:11}else{Ra=0}}while(0);Ia=c[e>>2]|0;Ma=0;Na=Ia;Oa=Ia;Pa=Ba;Qa=Ra}}while(0);if((Qa|0)!=0){Ca=X;Da=Pa;Ea=Qa;T=140;break}Ba=(Ma|0)!=0;do{if(fa|Ba^1){Ia=c[w>>2]|0;if((ya|0)<(za|0)){Ua=X;Va=za}else{if((za|0)>1024){Ca=X;Da=Pa;Ea=12;T=140;break e}Ta=s1(X,za<<3)|0;if((Ta|0)==0){Ca=X;Da=Pa;Ea=12;T=140;break e}else{Ua=Ta;Va=za<<1}}Ta=P0(Ia,0,0,1,32)|0;if((Ta|0)==0){T=112;break e}Ha=P0(Ia,0,0,1,20)|0;Ia=Ta+4|0;c[Ia>>2]=Ha;if((Ha|0)==0){T=112;break e}c[Ta>>2]=0;c[Ta+8>>2]=-1;c[Ta+12>>2]=-1;c[Ha>>2]=Oa;c[Ha+4>>2]=Na;c[Ha+8>>2]=-1;c[Ua+(ya<<2)>>2]=Ta;c[(c[Ia>>2]|0)+12>>2]=Ma;Wa=Ua;Xa=_;Ya=ya+1|0;Za=Va;_a=0}else{if((_|0)>63){Wa=X;Xa=_;Ya=ya;Za=za;_a=12;break}c[g+(_<<2)>>2]=Ma;Wa=X;Xa=_+1|0;Ya=ya;Za=za;_a=0}}while(0);Ia=(_a|0)==0;if(Ia&(((c[v>>2]&2|0)==0|Ba)^1)){$a=Wa;ab=Ya;bb=Za;cb=Oa}else{if(Ia){X=Wa;_=Xa;ya=Ya;za=Za;Aa=Pa;continue}else{Ca=Wa;Da=Pa;Ea=_a;T=140;break}}while(1){Ia=cb;while(1){if(Ia>>>0>Na>>>0){X=$a;_=Xa;ya=ab;za=bb;Aa=Pa;continue e}if((g0(Ia)|0)!=0){T=118;break}db=Ia+1|0;if((k0(Ia)|0)==0){Ia=db}else{T=129;break}}if((T|0)==118){T=0;Ta=m0(Ia)|0;Ha=Ia+1|0;g:do{if((g0(Ha)|0)==0){eb=Ta;fb=Ha}else{gb=Ta;hb=Ha;while(1){if((m0(hb)|0)!=(gb+1|0)|hb>>>0>Na>>>0){eb=gb;fb=hb;break g}ib=m0(hb)|0;jb=hb+1|0;if((g0(jb)|0)==0){eb=ib;fb=jb;break}else{gb=ib;hb=jb}}}}while(0);Ha=c[w>>2]|0;if((ab|0)<(bb|0)){kb=$a;lb=bb}else{if((bb|0)>1024){Ca=$a;Da=Pa;Ea=12;T=140;break e}hb=s1($a,bb<<3)|0;if((hb|0)==0){Ca=$a;Da=Pa;Ea=12;T=140;break e}else{kb=hb;lb=bb<<1}}hb=P0(Ha,0,0,1,32)|0;gb=hb;do{if((hb|0)==0){mb=0}else{Ja=P0(Ha,0,0,1,20)|0;c[hb+4>>2]=Ja;if((Ja|0)==0){mb=0;break}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Ja>>2]=Ta;c[Ja+4>>2]=eb;c[Ja+8>>2]=-1;mb=gb}}while(0);c[kb+(ab<<2)>>2]=mb;nb=mb;ob=kb;pb=lb;qb=fb}else if((T|0)==129){T=0;gb=o0(Ia)|0;h:do{if((k0(db)|0)==0){rb=gb;sb=db}else{Ta=gb;hb=db;while(1){if((o0(hb)|0)!=(Ta+1|0)|hb>>>0>Na>>>0){rb=Ta;sb=hb;break h}Ha=hb+1|0;Ja=o0(hb)|0;if((k0(Ha)|0)==0){rb=Ja;sb=Ha;break}else{Ta=Ja;hb=Ha}}}}while(0);Ia=c[w>>2]|0;if((ab|0)<(bb|0)){tb=$a;ub=bb}else{if((bb|0)>1024){Ca=$a;Da=Pa;Ea=12;T=140;break e}hb=s1($a,bb<<3)|0;if((hb|0)==0){Ca=$a;Da=Pa;Ea=12;T=140;break e}else{tb=hb;ub=bb<<1}}hb=P0(Ia,0,0,1,32)|0;Ta=hb;do{if((hb|0)==0){vb=0}else{Ha=P0(Ia,0,0,1,20)|0;c[hb+4>>2]=Ha;if((Ha|0)==0){vb=0;break}c[hb>>2]=0;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Ha>>2]=gb;c[Ha+4>>2]=rb;c[Ha+8>>2]=-1;vb=Ta}}while(0);c[tb+(ab<<2)>>2]=vb;nb=vb;ob=tb;pb=ub;qb=sb}if((nb|0)==0){T=141;break e}else{$a=ob;ab=ab+1|0;bb=pb;cb=qb}}}i:do{if((T|0)==85){T=0;c[q>>2]=Aa+1;za=(xa|0)!=0;if(za){dc(X|0,ya|0,4,59)}j:do{if((ya|0)>0){fa=(_|0)>0;Ba=_<<2;Ta=Ba+4|0;if(za){wb=0;xb=0;yb=0;zb=0}else{gb=0;hb=0;while(1){Ia=X+(gb<<2)|0;Ha=c[(c[Ia>>2]|0)+4>>2]|0;do{if((Ha|0)==0){Ab=hb;Bb=0}else{c[Ha+8>>2]=c[x>>2];if(fa){Ja=P0(c[w>>2]|0,0,0,0,Ta)|0;Ga=Ha+16|0;c[Ga>>2]=Ja;if((Ja|0)==0){Cb=X;Db=hb;Eb=12;break i}V1(Ja|0,z|0,Ba|0)|0;c[(c[Ga>>2]|0)+(_<<2)>>2]=0}else{c[Ha+16>>2]=0}if((hb|0)==0){Ab=c[Ia>>2]|0;Bb=0;break}Ga=c[w>>2]|0;Ja=c[Ia>>2]|0;jb=P0(Ga,0,0,1,32)|0;ib=jb;do{if((jb|0)==0){Fb=0}else{Gb=P0(Ga,0,0,1,8)|0;Hb=jb+4|0;c[Hb>>2]=Gb;if((Gb|0)==0){Fb=0;break}c[jb>>2]=3;c[jb+8>>2]=-1;c[jb+12>>2]=-1;c[Gb>>2]=hb;c[(c[Hb>>2]|0)+4>>2]=Ja;c[jb+16>>2]=(c[Ja+16>>2]|0)+(c[hb+16>>2]|0);Fb=ib}}while(0);Ab=Fb;Bb=(Fb|0)==0?12:0}}while(0);Ia=gb+1|0;if((Ia|0)<(ya|0)&(Bb|0)==0){gb=Ia;hb=Ab}else{Ib=0;Jb=Ab;Kb=Bb;break j}}}while(1){hb=X+(yb<<2)|0;gb=c[(c[hb>>2]|0)+4>>2]|0;Ia=c[gb>>2]|0;Ha=gb+4|0;ib=c[Ha>>2]|0;do{if((Ia|0)<(wb|0)){Ja=ib+1|0;Lb=(Ja|0)<(wb|0)?wb:Ja;Mb=xb;Nb=zb;Ob=0}else{if((Ia|0)<=(xb|0)){Ja=ib+1|0;Lb=Ja;Mb=Ja;Nb=zb;Ob=0;break}c[gb>>2]=xb;c[Ha>>2]=Ia+ -1;Ja=ib+1|0;if((gb|0)==0){Lb=Ja;Mb=Ja;Nb=zb;Ob=0;break}c[gb+8>>2]=c[x>>2];if(fa){jb=P0(c[w>>2]|0,0,0,0,Ta)|0;Ga=gb+16|0;c[Ga>>2]=jb;if((jb|0)==0){Cb=X;Db=zb;Eb=12;break i}V1(jb|0,z|0,Ba|0)|0;c[(c[Ga>>2]|0)+(_<<2)>>2]=0}else{c[gb+16>>2]=0}if((zb|0)==0){Lb=Ja;Mb=Ja;Nb=c[hb>>2]|0;Ob=0;break}Ga=c[w>>2]|0;jb=c[hb>>2]|0;Hb=P0(Ga,0,0,1,32)|0;Gb=Hb;do{if((Hb|0)==0){Pb=0}else{Qb=P0(Ga,0,0,1,8)|0;Rb=Hb+4|0;c[Rb>>2]=Qb;if((Qb|0)==0){Pb=0;break}c[Hb>>2]=3;c[Hb+8>>2]=-1;c[Hb+12>>2]=-1;c[Qb>>2]=zb;c[(c[Rb>>2]|0)+4>>2]=jb;c[Hb+16>>2]=(c[jb+16>>2]|0)+(c[zb+16>>2]|0);Pb=Gb}}while(0);Lb=Ja;Mb=Ja;Nb=Pb;Ob=(Pb|0)==0?12:0}}while(0);hb=yb+1|0;if((hb|0)<(ya|0)&(Ob|0)==0){wb=Lb;xb=Mb;yb=hb;zb=Nb}else{Ib=Mb;Jb=Nb;Kb=Ob;break}}}else{Ib=0;Jb=0;Kb=0}}while(0);if((Kb|0)!=0|za^1){Cb=X;Db=Jb;Eb=Kb;break}Ba=c[w>>2]|0;Ta=c[x>>2]|0;fa=P0(Ba,0,0,1,32)|0;hb=fa;if((fa|0)==0){Cb=X;Db=Jb;Eb=12;break}gb=P0(Ba,0,0,1,20)|0;c[fa+4>>2]=gb;if((gb|0)==0){Cb=X;Db=Jb;Eb=12;break}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[gb>>2]=Ib;c[gb+4>>2]=1114111;c[gb+8>>2]=Ta;if((_|0)>0){Ta=_<<2;Ba=P0(c[w>>2]|0,0,0,0,Ta+4|0)|0;ib=gb+16|0;c[ib>>2]=Ba;if((Ba|0)==0){Cb=X;Db=Jb;Eb=12;break}V1(Ba|0,z|0,Ta|0)|0;c[(c[ib>>2]|0)+(_<<2)>>2]=0}else{c[gb+16>>2]=0}if((Jb|0)==0){Cb=X;Db=hb;Eb=0;break}gb=c[w>>2]|0;ib=P0(gb,0,0,1,32)|0;Ta=ib;do{if((ib|0)==0){Sb=0}else{Ba=P0(gb,0,0,1,8)|0;Ia=ib+4|0;c[Ia>>2]=Ba;if((Ba|0)==0){Sb=0;break}c[ib>>2]=3;c[ib+8>>2]=-1;c[ib+12>>2]=-1;c[Ba>>2]=Jb;c[(c[Ia>>2]|0)+4>>2]=hb;c[ib+16>>2]=(c[fa+16>>2]|0)+(c[Jb+16>>2]|0);Sb=Ta}}while(0);Cb=X;Db=Sb;Eb=(Sb|0)==0?12:0}else if((T|0)==112){T=0;c[Ua+(ya<<2)>>2]=0;Ca=Ua;Da=Pa;Ea=12;T=140}else if((T|0)==141){T=0;c[q>>2]=Pa;Cb=ob;Db=0;Eb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=Da;Cb=Ca;Db=0;Eb=Ea}q1(Cb);c[x>>2]=(c[x>>2]|0)+1;if((Eb|0)==0){U=M;V=Db;W=0;break c}else{Z=Eb;T=294;break b}break};case 46:{ya=(c[v>>2]&4|0)==0;X=c[w>>2]|0;_=c[x>>2]|0;Aa=P0(X,0,0,1,32)|0;Ta=Aa;fa=(Aa|0)==0;if(ya){if(fa){Z=12;T=294;break b}ya=P0(X,0,0,1,20)|0;c[Aa+4>>2]=ya;if((ya|0)==0){Z=12;T=294;break b}c[Aa>>2]=0;c[Aa+8>>2]=-1;c[Aa+12>>2]=-1;c[ya>>2]=0;c[ya+4>>2]=1114111;c[ya+8>>2]=_;Tb=Ta;Vb=(c[x>>2]|0)+1|0}else{if(fa){Z=12;T=294;break b}fa=P0(X,0,0,1,20)|0;c[Aa+4>>2]=fa;if((fa|0)==0){Z=12;T=294;break b}c[Aa>>2]=0;c[Aa+8>>2]=-1;c[Aa+12>>2]=-1;c[fa>>2]=0;c[fa+4>>2]=9;c[fa+8>>2]=_;_=c[w>>2]|0;fa=(c[x>>2]|0)+1|0;X=P0(_,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}ya=P0(_,0,0,1,20)|0;c[X+4>>2]=ya;if((ya|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ya>>2]=11;c[ya+4>>2]=1114111;c[ya+8>>2]=fa;fa=c[w>>2]|0;ya=P0(fa,0,0,1,32)|0;if((ya|0)==0){Z=12;T=294;break b}_=P0(fa,0,0,1,8)|0;fa=ya+4|0;c[fa>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[ya>>2]=3;c[ya+8>>2]=-1;c[ya+12>>2]=-1;c[_>>2]=Ta;c[(c[fa>>2]|0)+4>>2]=X;c[ya+16>>2]=(c[X+16>>2]|0)+(c[Aa+16>>2]|0);Tb=ya;Vb=(c[x>>2]|0)+2|0}c[x>>2]=Vb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Tb;W=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((Q|0)!=(c[r>>2]|0)){break d}ya=F0(m,5)|0;if((ya|0)!=0){R=M;S=ya;T=6;break b}}ya=c[w>>2]|0;Aa=P0(ya,0,0,1,32)|0;if((Aa|0)==0){Z=12;T=294;break b}X=P0(ya,0,0,1,20)|0;c[Aa+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[Aa>>2]=0;c[Aa+8>>2]=-1;c[Aa+12>>2]=-1;c[X>>2]=-2;c[X+4>>2]=1;c[X+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Aa;W=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[Q+1|0]|0)!=0){break d}}Aa=c[w>>2]|0;X=P0(Aa,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}ya=P0(Aa,0,0,1,20)|0;c[X+4>>2]=ya;if((ya|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[ya>>2]=-2;c[ya+4>>2]=2;c[ya+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=X;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 41:{if((M|0)!=0){T=264}break};case 92:{X=Q+1|0;ya=a[X]|0;do{if((c[v>>2]&1|0)==0){if(ya<<24>>24==40){c[q>>2]=X;va=X;T=74;break d}else{Aa=a[Q+1|0]|0;if(Aa<<24>>24==41){T=265;break d}else{Wb=Aa;break}}}else{Wb=ya}}while(0);ya=Q+1|0;X=Wb<<24>>24==0;if(X){Z=5;T=294;break b}else{Xb=155844|0;Yb=0}while(1){Aa=Yb+1|0;if((a[155840+(Yb<<3)|0]|0)==Wb<<24>>24){Zb=Xb;break}fa=155844+(Aa<<3)|0;if((Aa|0)==12){Zb=fa;break}else{Xb=fa;Yb=Aa}}Aa=c[Zb>>2]|0;if((Aa|0)!=0){fa=F+0|0;Ta=G+0|0;_=fa+40|0;do{c[fa>>2]=c[Ta>>2];fa=fa+4|0;Ta=Ta+4|0}while((fa|0)<(_|0));c[H>>2]=Aa;c[I>>2]=1;Ta=y0(j)|0;if((Ta|0)!=0){Z=Ta;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(X){Z=5;T=294;break b}c[q>>2]=ya;Ta=a[ya]|0;k:do{switch(Ta|0){case 60:{fa=c[w>>2]|0;_=P0(fa,0,0,1,32)|0;ib=_;do{if((_|0)==0){_b=0}else{hb=P0(fa,0,0,1,20)|0;c[_+4>>2]=hb;if((hb|0)==0){_b=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[hb>>2]=-2;c[hb+4>>2]=16;c[hb+8>>2]=-1;_b=ib}}while(0);c[q>>2]=(c[q>>2]|0)+1;$b=_b;break};case 62:{ib=c[w>>2]|0;_=P0(ib,0,0,1,32)|0;fa=_;do{if((_|0)==0){ac=0}else{hb=P0(ib,0,0,1,20)|0;c[_+4>>2]=hb;if((hb|0)==0){ac=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[hb>>2]=-2;c[hb+4>>2]=32;c[hb+8>>2]=-1;ac=fa}}while(0);c[q>>2]=(c[q>>2]|0)+1;$b=ac;break};case 66:{fa=c[w>>2]|0;_=P0(fa,0,0,1,32)|0;ib=_;do{if((_|0)==0){bc=0}else{hb=P0(fa,0,0,1,20)|0;c[_+4>>2]=hb;if((hb|0)==0){bc=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[hb>>2]=-2;c[hb+4>>2]=128;c[hb+8>>2]=-1;bc=ib}}while(0);c[q>>2]=(c[q>>2]|0)+1;$b=bc;break};case 98:{ib=c[w>>2]|0;_=P0(ib,0,0,1,32)|0;fa=_;do{if((_|0)==0){cc=0}else{hb=P0(ib,0,0,1,20)|0;c[_+4>>2]=hb;if((hb|0)==0){cc=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[hb>>2]=-2;c[hb+4>>2]=64;c[hb+8>>2]=-1;cc=fa}}while(0);c[q>>2]=(c[q>>2]|0)+1;$b=cc;break};case 120:{fa=Q+2|0;c[q>>2]=fa;_=a[fa]|0;if(_<<24>>24==123){fa=Q+3|0;c[q>>2]=fa;ib=fa;fa=0;while(1){hb=a[ib]|0;if(hb<<24>>24==0|hb<<24>>24==125){ec=fa;fc=ib;break}if((l0(hb<<24>>24)|0)==0){Z=9;T=294;break b}hb=c[q>>2]|0;a[l+fa|0]=a[hb]|0;gb=fa+1|0;za=hb+1|0;c[q>>2]=za;if(gb>>>0>31){ec=gb;fc=za;break}else{ib=za;fa=gb}}c[q>>2]=fc+1;a[l+ec|0]=0;fa=Ub(C|0,0,16)|0;ib=c[w>>2]|0;gb=c[x>>2]|0;za=P0(ib,0,0,1,32)|0;hb=za;do{if((za|0)==0){gc=0}else{Ia=P0(ib,0,0,1,20)|0;c[za+4>>2]=Ia;if((Ia|0)==0){gc=0;break}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[Ia>>2]=fa;c[Ia+4>>2]=fa;c[Ia+8>>2]=gb;gc=hb}}while(0);c[x>>2]=(c[x>>2]|0)+1;$b=gc;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;hb=(l0(_<<24>>24)|0)==0;gb=c[q>>2]|0;if(hb){hc=gb}else{a[D]=a[gb]|0;hb=gb+1|0;c[q>>2]=hb;hc=hb}if((l0(a[hc]|0)|0)!=0){hb=c[q>>2]|0;a[E]=a[hb]|0;c[q>>2]=hb+1}hb=Ub(D|0,0,16)|0;gb=c[w>>2]|0;fa=c[x>>2]|0;za=P0(gb,0,0,1,32)|0;ib=za;do{if((za|0)==0){ic=0}else{Ia=P0(gb,0,0,1,20)|0;c[za+4>>2]=Ia;if((Ia|0)==0){ic=0;break}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[Ia>>2]=hb;c[Ia+4>>2]=hb;c[Ia+8>>2]=fa;ic=ib}}while(0);c[x>>2]=(c[x>>2]|0)+1;$b=ic;break k}break};default:{if((e0(Ta)|0)!=0){ib=(a[c[q>>2]|0]|0)+ -48|0;fa=c[w>>2]|0;hb=c[x>>2]|0;za=P0(fa,0,0,1,32)|0;if((za|0)==0){Z=12;T=294;break b}gb=P0(fa,0,0,1,20)|0;c[za+4>>2]=gb;if((gb|0)==0){Z=12;T=294;break b}c[za>>2]=0;c[za+8>>2]=-1;c[za+12>>2]=-1;c[gb>>2]=-4;c[gb+4>>2]=ib;c[gb+8>>2]=hb;c[x>>2]=(c[x>>2]|0)+1;hb=c[B>>2]|0;c[B>>2]=(ib|0)<(hb|0)?hb:ib;c[q>>2]=(c[q>>2]|0)+1;U=M;V=za;W=0;break c}za=c[w>>2]|0;ib=a[c[q>>2]|0]|0;hb=c[x>>2]|0;gb=P0(za,0,0,1,32)|0;fa=gb;do{if((gb|0)==0){jc=0}else{_=P0(za,0,0,1,20)|0;c[gb+4>>2]=_;if((_|0)==0){jc=0;break}c[gb>>2]=0;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[_>>2]=ib;c[_+4>>2]=ib;c[_+8>>2]=hb;jc=fa}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;$b=jc}}}while(0);if(($b|0)==0){Z=12;T=294;break b}else{U=M;V=$b;W=0;break c}break};default:{}}}while(0);if((T|0)==74){T=0;ea=M+1|0;c[q>>2]=va+1;Y=F0(m,c[y>>2]|0)|0;if((Y|0)!=0){R=ea;S=Y;T=6;break b}Y=F0(m,2)|0;if((Y|0)!=0){R=ea;S=Y;T=6;break b}Y=F0(m,0)|0;if((Y|0)!=0){R=ea;S=Y;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=ea;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;ea=c[w>>2]|0;Y=P0(ea,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}Ta=P0(ea,0,0,1,20)|0;c[Y+4>>2]=Ta;if((Ta|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Ta>>2]=-1;c[Ta+4>>2]=-1;c[Ta+8>>2]=-1;U=M;V=Y;W=0;break c}Y=t0(h,Q,-1)|0;if((Y|0)<0){c[h>>2]=-1;kc=1}else{kc=Y}do{if((c[v>>2]&2|0)==0){T=280}else{if((k0(c[h>>2]|0)|0)==0){if((g0(c[h>>2]|0)|0)==0){T=280;break}}Y=c[w>>2]|0;Ta=m0(c[h>>2]|0)|0;ea=m0(c[h>>2]|0)|0;ya=c[x>>2]|0;X=P0(Y,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}Aa=P0(Y,0,0,1,20)|0;c[X+4>>2]=Aa;if((Aa|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Aa>>2]=Ta;c[Aa+4>>2]=ea;c[Aa+8>>2]=ya;ya=c[w>>2]|0;Aa=o0(c[h>>2]|0)|0;ea=o0(c[h>>2]|0)|0;Ta=c[x>>2]|0;Y=P0(ya,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}fa=P0(ya,0,0,1,20)|0;c[Y+4>>2]=fa;if((fa|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[fa>>2]=Aa;c[fa+4>>2]=ea;c[fa+8>>2]=Ta;Ta=c[w>>2]|0;fa=P0(Ta,0,0,1,32)|0;if((fa|0)==0){Z=12;T=294;break b}ea=P0(Ta,0,0,1,8)|0;Ta=fa+4|0;c[Ta>>2]=ea;if((ea|0)==0){Z=12;T=294;break b}c[fa>>2]=3;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[ea>>2]=X;c[(c[Ta>>2]|0)+4>>2]=Y;c[fa+16>>2]=(c[Y+16>>2]|0)+(c[X+16>>2]|0);lc=fa}}while(0);if((T|0)==280){T=0;Q=c[w>>2]|0;fa=c[h>>2]|0;X=c[x>>2]|0;Y=P0(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}Ta=P0(Q,0,0,1,20)|0;c[Y+4>>2]=Ta;if((Ta|0)==0){Z=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Ta>>2]=fa;c[Ta+4>>2]=fa;c[Ta+8>>2]=X;lc=Y}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+kc;U=M;V=lc;W=0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{mc=O;nc=U;oc=V;pc=W;break a}}if((T|0)==6){mc=(S|0)==0;nc=R;oc=N;pc=S;break}else if((T|0)==294){i=d;return Z|0}}else{mc=t;nc=0;oc=0;pc=p}}while(0);p=(nc|0)>0;if(p|mc^1){Z=p?8:pc;i=d;return Z|0}c[b+8>>2]=oc;Z=0;i=d;return Z|0}



function tB(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+pd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+pd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}hB(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function uB(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function vB(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;ae[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function wB(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function xB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=Ry(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{se[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;Py(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=Ry(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function yB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((xB(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}zB(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(Ry(d)|0)>0;h=b?2:0;i=e;return h|0}function zB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=p1(q)|0;s=r;t=p1(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[24400]=Ny(4)|0;if((r|0)==0){cb(97608,97624,308,97656)}if((t|0)==0){cb(97672,97624,309,97656)}v=Uy(b)|0;if((v|0)!=0){w=v;do{v=Wy(w)|0;c[l>>2]=c[v>>2];Gy(27,0,97688,l);w=Vy(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;V1(t|0,c[a+384>>2]|0,v|0)|0;V1(r|0,l|0,v|0)|0}h[d>>3]=+CB(a,n,o,q,s,c[24400]|0,b);do{if((Ry(c[24400]|0)|0)==0){s=Sy(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=Uy(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=Wy(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=Vy(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Gy(27,0,97736,j);v=Uy(b)|0;if((v|0)==0){break}else{B=v}do{v=Wy(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[24400]|0;Qy(v,Wy(B)|0);v=Wy(B)|0;c[g>>2]=c[v>>2];Gy(27,0,97760,g)}B=Vy(B)|0;}while((B|0)!=0)}}while(0);Oy(b);if((c[67148>>2]|0)!=0){Ry(c[24400]|0)|0}if((Ry(c[24400]|0)|0)>0){B=m;do{g=Sy(c[24400]|0)|0;c[m>>2]=c[g>>2];Ty(c[24400]|0);c[f>>2]=c[m>>2];Gy(7,0,97784,f);Py(b,B);}while((Ry(c[24400]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){V1(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ue(a);FB(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){q1(t);q1(r);i=e;return}V1(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;q1(t);q1(r);i=e;return}function AB(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){JB(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Gy(7,0,97328,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((Ry(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[67148>>2]|0)!=0){e=Uy(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=Wy(s)|0;x=c[e>>2]|0;e=se[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;Fy(7,0,w,97352,l);s=Vy(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=Wy(Uy(d)|0)|0;x=se[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;Fy(1,0,e,97368,j);c[s>>2]=1}}while(0);Oy(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;EB(b);BB(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function BB(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;Gy(27,0,97976,b);d=a+344|0;ge[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function CB(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=p1(p<<3)|0;if((q|0)==0){cb(97792,97624,409,97808)}if((p|0)>0){V1(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Gy(27,0,97824,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Gy(27,0,97872,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){q1(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}cD(a)|0;de[c[(c[p>>2]|0)+40>>2]&127](a)|0;de[c[(c[p>>2]|0)+28>>2]&127](a)|0;de[c[(c[p>>2]|0)+32>>2]&127](a)|0;ge[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(DB(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}V1(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}q1(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function DB(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;Oy(b);Gy(27,0,97896,g);g=Uy(d)|0;if((g|0)==0){j=Ry(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=Wy(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=Wy(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=Wy(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=Wy(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=Wy(a)|0;o=c[g>>2]|0;g=Wy(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?97312:97320;g=Wy(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?97312:97320;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;Gy(27,0,97936,f);Py(b,Wy(a)|0)}a=Vy(a)|0;}while((a|0)!=0);j=Ry(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function EB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;se[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;FB(b);GB(b);de[c[(c[g>>2]|0)+36>>2]&127](b)|0;HB(b,8);h=IB(b)|0;j=de[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{GB(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}JB(b);FB(b);HB(b,8);de[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=IB(b)|0;j=de[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){Ky(c[b+536>>2]|0,98016,e)}else if((o|0)==7){GB(b);i=d;return}}function FB(a){a=a|0;var b=0;b=i;V1(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function GB(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function HB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[67120+(d<<2)>>2]|0)==0){i=e;return}Gy(d,1,98440,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=de[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=de[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;Gy(d,0,98464,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}ae[c[16918]&255](d);i=e;return}function IB(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function JB(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;V1(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;V1(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;V1(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;V1(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function KB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}ge[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function LB(a){a=a|0;var b=0;b=i;MB(a);NB(a);JB(a);OB(a);i=b;return}function MB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function NB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function OB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Mz(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];V1(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;V1(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;V1(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;V1(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Mz(c[d>>2]|0)|0));i=b;return}function PB(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[67120+(d<<2)>>2]|0)==0){i=e;return}Gy(d,1,98112,q);q=b+136|0;if((c[q>>2]|0)>0){Gy(d,1,98136,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?98096:98104;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Gy(d,0,98152,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}ae[c[16918]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){Gy(d,1,98208,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?98096:98104;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;Gy(d,0,98232,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}ae[c[16918]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){Gy(d,1,98288,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?98096:98104;v=(a[n+(m*48|0)+40|0]|0)!=0?98096:98104;n=(a[(c[s>>2]|0)+m|0]|0)!=0?98096:98104;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;Gy(d,0,98312,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}ae[c[16918]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){Gy(d,1,98368,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;Gy(d,0,98392,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}ae[c[16918]&255](d)}ae[c[16918]&255](d);i=e;return}function QB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((Mz(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];V1(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;V1(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;V1(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;V1(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(Mz(c[d>>2]|0)|0));i=b;return}function RB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function SB(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];V1(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;V1(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;V1(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;V1(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function TB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=Hz(3,32)|0;c[o>>2]=p;if((p|0)==0){Ky(c[b+536>>2]|0,98496,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=r1(c[p>>2]|0,8)|0;c[q>>2]=z;Jy(c[r>>2]|0,(z|0)!=0|0,98552,l);z=r1(c[s>>2]|0,4)|0;c[t>>2]=z;Jy(c[r>>2]|0,(z|0)!=0|0,98552,k);z=r1(c[u>>2]|0,1)|0;c[v>>2]=z;Jy(c[r>>2]|0,(z|0)!=0|0,98552,j);z=r1(c[w>>2]|0,4)|0;c[x>>2]=z;Jy(c[r>>2]|0,(z|0)!=0|0,98552,g);Lz(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=r1(3,4)|0;c[b+4>>2]=n;Nz(c[o>>2]|0,0,n);c[b+8>>2]=r1(c[p>>2]|0,112)|0;c[b+12>>2]=r1(c[s>>2]|0,60)|0;c[b+16>>2]=r1(c[u>>2]|0,48)|0;c[b+20>>2]=r1(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=r1(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=r1(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=r1(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=r1(g,52)|0;c[b+40>>2]=r1(c[b+216>>2]|0,52)|0;c[b+44>>2]=r1(c[b+220>>2]|0,52)|0;c[b+48>>2]=r1(c[b+224>>2]|0,52)|0;c[b+52>>2]=r1(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=r1(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=r1(x,8)|0;c[b+340>>2]=r1(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=r1(x,8)|0;c[b+348>>2]=r1(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=r1(j,1)|0;c[b+356>>2]=r1(j,1)|0;c[b+360>>2]=r1(j,1)|0;j=p1(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=p1(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=r1(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=r1(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=r1(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=r1(u,4)|0;c[b+400>>2]=r1(x,8)|0;c[b+404>>2]=r1(p,4)|0;c[b+408>>2]=r1(s,1)|0;c[b+412>>2]=r1(u,4)|0;c[b+416>>2]=r1(c[n>>2]|0,8)|0;c[b+420>>2]=r1(o,4)|0;c[b+424>>2]=r1(y,1)|0;c[b+428>>2]=r1(g,4)|0;c[b+432>>2]=r1(c[b+152>>2]|0,8)|0;c[b+436>>2]=r1(c[b+156>>2]|0,8)|0;g=p1((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;ae[c[(c[y>>2]|0)+20>>2]&255](g);g=p1((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;ae[c[(c[y>>2]|0)+16>>2]&255](g);g=p1((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;ae[c[(c[y>>2]|0)+12>>2]&255](g);g=p1((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;be[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=p1((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=r1(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;Jy(c[r>>2]|0,(g|0)!=0|0,98568,f);c[b+512>>2]=100;c[b+516>>2]=r1(100,4)|0;c[b+520>>2]=r1(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=p1(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;Jy(c[r>>2]|0,(g|0)!=0|0,98552,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=Hz(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function UB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;q1(c[g+8>>2]|0);q1(c[g+12>>2]|0);q1(c[g+16>>2]|0);q1(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);q1(e);Iz(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){kA(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}q1(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){kA(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}q1(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){kA(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}q1(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){kA(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}q1(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){kA(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}q1(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){kA(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}q1(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){kA(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}q1(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){kA(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}q1(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){kA(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}q1(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){kA(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}q1(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){kA(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}q1(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){kA(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}q1(v);q1(c[a+108>>2]|0);q1(c[a+336>>2]|0);q1(c[a+340>>2]|0);q1(c[a+344>>2]|0);q1(c[a+348>>2]|0);q1(c[a+352>>2]|0);q1(c[a+356>>2]|0);q1(c[a+360>>2]|0);q1(c[a+368>>2]|0);q1(c[a+384>>2]|0);q1(c[a+388>>2]|0);q1(c[a+392>>2]|0);q1(c[a+396>>2]|0);q1(c[a+400>>2]|0);q1(c[a+404>>2]|0);q1(c[a+408>>2]|0);q1(c[a+412>>2]|0);q1(c[a+416>>2]|0);q1(c[a+420>>2]|0);q1(c[a+424>>2]|0);q1(c[a+428>>2]|0);q1(c[a+488>>2]|0);q1(c[a+484>>2]|0);q1(c[a+476>>2]|0);q1(c[a+468>>2]|0);q1(c[a+464>>2]|0);q1(c[a+432>>2]|0);q1(c[a+436>>2]|0);q1(c[a+320>>2]|0);q1(c[a+516>>2]|0);q1(c[a+520>>2]|0);JQ(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;q1(x);i=b;return}else{y=a;z=0}while(1){Iz(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;q1(x);i=b;return}function VB(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[12326]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];Gy(8,0,98616,d);i=b;return}function WB(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[12326];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function XB(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[12326];f=e+e*+U(+(d?a:b));if(d){g=-f}else{g=f}i=i;return a-b>=g|0}function YB(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(WB(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function ZB(a,b){a=+a;b=+b;i=i;return a<b|0}function _B(a,b){a=+a;b=+b;i=i;return a<=b|0}function $B(a,b){a=+a;b=+b;i=i;return a>b|0}function aC(a,b){a=+a;b=+b;i=i;return a>=b|0}function bC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=p1(k)|0;c[e+(h*40|0)+24>>2]=p1(k)|0;if((c[g>>2]|0)!=1){l=5;break}eC(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){Ky(c[a+536>>2]|0,98672,d)}else if((l|0)==6){i=b;return 0}return 0}function cC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){q1(c[e+(h*40|0)+20>>2]|0);q1(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;fC(k)|0;q1(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){Ky(c[a+536>>2]|0,98672,d)}else if((j|0)==6){i=b;return 0}return 0}function dC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[67188>>2]|c[16778]|0)==0){z=w;A=1;break}HQ(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Iy(17,1,98704,g);HQ(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;HQ(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Iy(17,0,98736,f);HQ(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ae[c[16918]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function eC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=p1(20)|0;c[b>>2]=f;Jy(0,(f|0)!=0|0,98744,e);e=p1(a)|0;c[f>>2]=e;e=p1(a)|0;c[f+4>>2]=e;e=p1(a)|0;c[f+8>>2]=e;e=p1(a)|0;c[f+16>>2]=e;Jy(0,(c[b>>2]|0)!=0|0,98776,d);i=d;return 0}function fC(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;q1(c[d>>2]|0);q1(c[d+4>>2]|0);q1(c[d+8>>2]|0);q1(c[d+16>>2]|0);i=b;return 0}function gC(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Ky(c[a+536>>2]|0,98824,b);return 0}function hC(a){a=a|0;a=i;i=i+8|0;Ky(0,98824,a);return 0}function iC(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Ky(c[a+536>>2]|0,98824,b);return 0}function jC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=p1(l)|0;c[e+(h<<6)+36>>2]=p1(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=p1(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;oC(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;qC(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){Ky(c[a+536>>2]|0,98864,d)}else if((n|0)==8){i=b;return 0}return 0}function kC(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function lC(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function mC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){q1(c[e+(h<<6)+28>>2]|0);q1(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){pC(e+(h<<6)+24|0)|0;q1(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){rC(e+(h<<6)+24|0)|0}else{k=6;break}q1(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){Ky(c[a+536>>2]|0,98864,d)}else if((k|0)==8){i=b;return 0}return 0}function nC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[67180>>2]|c[16778]|0)==0){z=w;A=1;break}HQ(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Iy(15,1,98896,g);HQ(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;HQ(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;Iy(15,0,98928,f);HQ(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}ae[c[16918]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function oC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=p1(12)|0;f=p1(a<<2)|0;c[e>>2]=f;Jy(0,(f|0)!=0|0,98936,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function pC(a){a=a|0;var b=0;b=i;q1(c[c[a>>2]>>2]|0);i=b;return 0}function qC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=p1(32)|0;Jy(0,(g|0)!=0|0,98992,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Td(0,d|0)|0;Id(c[d>>2]|0,c[b>>2]|0,0)|0;Td(0,g+4|0)|0;Id(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Kb(99040,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function rC(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Pd(c[d+12>>2]|0)|0;Jb(c[d+8>>2]|0)|0;Jb(c[d+4>>2]|0)|0;i=b;return 0}function sC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;Jy(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,99208,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){Jy(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,99248,e);if((de[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=p1(p)|0;c[g+(m*80|0)+52>>2]=p1(p)|0;c[g+(m*80|0)+48>>2]=p1(p)|0;c[g+(m*80|0)+16>>2]=p1(p)|0;c[g+(m*80|0)+8>>2]=p1(p)|0;c[g+(m*80|0)+12>>2]=p1(p)|0;be[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){FC(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==1){xC(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){gC(a,n)|0;break}else if((p|0)==3){FC(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){Ky(c[j>>2]|0,99288,d)}else if((q|0)==14){i=b;return 0}return 0}function tC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;q1(c[e+(h*80|0)+44>>2]|0);q1(c[e+(h*80|0)+52>>2]|0);q1(c[e+(h*80|0)+48>>2]|0);q1(c[e+(h*80|0)+16>>2]|0);q1(c[e+(h*80|0)+8>>2]|0);q1(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;GC(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==1){m=e+(h*80|0)+40|0;yC(m)|0;l=m;break}else if((k|0)==3){m=e+(h*80|0)+40|0;GC(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else{n=9;break a}}}while(0);q1(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){hC(j)|0}else if((n|0)==9){Ky(c[a+536>>2]|0,99288,d)}else if((n|0)==11){i=b;return 0}return 0}function uC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(IC(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==2){j=(iC(b,d)|0)&255;break}else if((k|0)==3){j=(IC(b,d)|0)&255;break}else if((k|0)==1){k=b+536|0;l=(c[k>>2]|0)+84|0;m=c[l>>2]|0;c[l>>2]=3;l=zC(b,d)|0;c[(c[k>>2]|0)+84>>2]=m;j=l&255;break}else{Ky(c[b+536>>2]|0,99288,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function vC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;HQ(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Hy(17,1,u,99320,m);do{if((a[b+312|0]|0)==0){HQ(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;HQ(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;Iy(17,0,99520,f);HQ(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{Iy(17,1,99360,l);HQ(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;HQ(q,d,c[v>>2]|0);if((P1(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Iy(17,0,99440,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;HQ(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;Iy(17,0,99480,g);G=E}HQ(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[67188>>2]|c[16778]|0)==0){break}ae[c[16918]&255](17)}}while(0);if((c[67188>>2]|c[16778]|0)==0){x=1;i=e;return x|0}ae[c[16918]&255](17);x=1;i=e;return x|0}function wC(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function xC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=p1(144)|0;c[b>>2]=f;Jy(0,(f|0)!=0|0,99536,e);c[f>>2]=0;e=a<<3;g=p1(e)|0;c[f+4>>2]=g;g=p1(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=p1(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=p1(e)|0;c[f+24>>2]=g;g=r1(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=p1(e)|0;c[f+64>>2]=g;g=p1(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=r1(g,8)|0;c[f+104>>2]=j;j=r1(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=p1(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=p1(e)|0;c[f+124>>2]=j;j=p1(e)|0;c[f+128>>2]=j;j=p1(e)|0;c[f+132>>2]=j;j=p1(e)|0;c[f+136>>2]=j;j=p1(e)|0;c[f+140>>2]=j;Jy(0,(c[b>>2]|0)!=0|0,99568,d);i=d;return 0}function yC(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;q1(c[d+4>>2]|0);q1(c[d+16>>2]|0);q1(c[d+12>>2]|0);q1(c[d+24>>2]|0);q1(c[d+28>>2]|0);q1(c[d+64>>2]|0);q1(c[d+68>>2]|0);q1(c[d+104>>2]|0);q1(c[d+108>>2]|0);q1(c[d+116>>2]|0);q1(c[d+124>>2]|0);q1(c[d+128>>2]|0);q1(c[d+132>>2]|0);q1(c[d+136>>2]|0);q1(c[d+140>>2]|0);i=b;return 0}function zC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=p1(c[Y>>2]|0)|0;if((c[67188>>2]|0)!=0){HQ(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];Gy(17,1,99608,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Gy(17,1,99664,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];Gy(17,0,99680,F);ae[c[16918]&255](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}ae[c[16918]&255](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){V1(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{V1(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+pd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;AC($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+pd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[67192>>2]|0)!=0){BC(c[Q>>2]|0,$,18,99720);BC(c[ca>>2]|0,$,18,99752)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[67192>>2]|0)!=0){BC(c[ca>>2]|0,$,18,99784)}a[da]=R;RA(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){HQ(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];jA(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;AC($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;AC($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}FB(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[67192>>2]|0)!=0){Gy(18,1,99824,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Gy(18,1,99864,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Gy(18,0,99896,C);ae[c[16918]&255](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ae[c[16918]&255](18)}if((c[67196>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;Gy(19,1,99928,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];ic(Ja|0,99952,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;Gy(19,0,99960,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}ae[c[16918]&255](19)}h[K>>3]=+QA($,c[Ia>>2]|0);h[J>>3]=+QA($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}V1(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){V1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{V1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];Gy(17,0,100008,w);CC(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Gy(17,0,100080,v);CC(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){V1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{V1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+pd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Gy(17,0,100144,u);CC(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){V1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{V1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+pd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Gy(17,0,100216,t);CC(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}V1(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;V1(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}Gy(17,0,100280,s);CC(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){V1(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}Gy(17,0,100352,r);CC(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){V1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{V1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Gy(17,0,100424,q);CC(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){V1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{V1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Gy(17,0,100496,p);CC(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){V1(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Gy(17,0,100560,o);CC(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){V1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{V1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}Gy(17,0,100632,n);CC(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){V1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{V1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];Gy(17,0,100768,l);CC(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){V1(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{V1(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}Gy(17,0,100696,m);CC(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[67188>>2]|0)!=0){Gy(17,1,99968,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;Gy(17,0,99984,x);ae[c[16918]&255](17);CC(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}V1(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;AC($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;q1(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;q1(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;q1(Z);i=e;return kb|0}if((a[Ha]|0)==0){HQ(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];jA(0,f,hb);}if((c[67188>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;Gy(17,0,100840,j);CC(S,L,J,K,17)}V1(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;q1(Z);i=e;return kb|0}return 0}function AC(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[67200>>2]|0)!=0){Gy(20,0,101192,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){EC(w,f,d,e,m)}else{DC(w,f,m)}do{if((c[67200>>2]|0)!=0){Gy(20,0,101232,r);if((c[67196>>2]|0)==0){break}w=v;s=c[b>>2]|0;c[q>>2]=s;c[q+4>>2]=s;Gy(19,1,99928,q);s=c[b>>2]|0;if((s|0)>0){C=y+20|0;D=s;s=0;do{a[w]=0;if((D|0)>0){E=0;do{F=+h[f+((fa(c[C>>2]|0,s)|0)+E<<3)>>3];c[p>>2]=w;G=p+4|0;h[k>>3]=F;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];ic(w|0,101264,p|0)|0;E=E+1|0;}while((E|0)<(c[b>>2]|0))}c[o>>2]=w;Gy(19,0,99960,o);s=s+1|0;D=c[b>>2]|0;}while((s|0)<(D|0))}ae[c[16918]&255](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else if((A|0)==1){z=y+8|0;do{if((c[z>>2]|0)!=0){B=c[b>>2]|0;if((B|0)<=0){break}o=c[y+12>>2]|0;p=0;do{f=d+(p<<3)|0;h[f>>3]=+h[f>>3]*+h[o+(p<<3)>>3];p=p+1|0;}while((p|0)<(B|0))}}while(0);if((c[67200>>2]|0)!=0){c[u>>2]=c[y+96>>2];Gy(20,0,101088,u);BC(d,b,20,101120)}De[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[67200>>2]|0)!=0){BC(e,b,20,101136);c[t>>2]=c[y+96>>2];Gy(20,0,101152,t)}if((c[z>>2]|0)==0){i=g;return 0}z=c[b>>2]|0;if((z|0)<=0){i=g;return 0}b=c[y+12>>2]|0;y=0;do{t=d+(y<<3)|0;h[t>>3]=1.0/+h[b+(y<<3)>>3]*+h[t>>3];y=y+1|0;}while((y|0)<(z|0));i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;Ky(g,101280,n)}return 0}function BC(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[67120+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;Gy(d,1,99960,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];Gy(d,0,101072,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}ae[c[16918]&255](d);i=f;return}function CC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[67120+(f<<2)>>2]|0)==0){i=g;return}Gy(f,1,100880,q);Gy(f,1,100896,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Gy(f,0,100912,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}ae[c[16918]&255](f);Gy(f,1,100952,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Gy(f,0,100968,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}ae[c[16918]&255](f);Gy(f,1,101008,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Gy(f,0,101024,j);ae[c[16918]&255](f);ae[c[16918]&255](f);i=g;return}function DC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;X1(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;X1(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}de[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function EC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+pd(+(n*+pd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;AC(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function FC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=p1(80)|0;c[b>>2]=f;Jy(0,(f|0)!=0|0,101360,e);c[f>>2]=0;e=a<<3;g=p1(e)|0;c[f+4>>2]=g;g=p1(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=p1(e)|0;c[f+16>>2]=g;g=r1(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=p1(fa(e,a)|0)|0;c[f+64>>2]=g;g=p1(e)|0;c[f+68>>2]=g;g=p1(a<<2)|0;c[f+72>>2]=g;Jy(0,(c[b>>2]|0)!=0|0,101392,d);i=d;return 0}function GC(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;q1(c[d+4>>2]|0);q1(c[d+8>>2]|0);q1(c[d+16>>2]|0);q1(c[d+20>>2]|0);q1(c[d+64>>2]|0);q1(c[d+68>>2]|0);q1(c[d+72>>2]|0);i=b;return 0}function HC(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;X1(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}de[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function IC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;V1(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[67188>>2]|0)==0){J=b+4|0}else{HQ(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Gy(17,1,101432,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];Gy(17,1,101504,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];Gy(17,0,101520,t);ae[c[16918]&255](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}ae[c[16918]&255](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];JC(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){HQ(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];jA(3,g,P);}$=+QA(H,c[b>>2]|0);aa=+QA(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){V1(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;Gy(17,0,101696,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;Gy(17,0,101752,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;Gy(17,0,101816,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[67188>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;Gy(17,0,101568,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];Gy(17,0,101608,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];Gy(17,0,101664,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){HQ(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];jA(0,f,L);if((c[67188>>2]|0)==0){da=0;break}c[m>>2]=V;Gy(17,0,101896,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Gy(17,0,101608,l);if((c[67188>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Gy(17,0,101664,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[67188>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;V1(ma|0,oa|0,qa|0)|0;i=e;return da|0}ae[c[16918]&255](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;V1(ma|0,oa|0,qa|0)|0;i=e;return da|0}function JC(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[67192>>2]|0)!=0){c[z>>2]=j;Gy(18,0,101936,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];Gy(18,0,101984,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){KC(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){LC(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{HC(E,m,r)|0}if((c[67196>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;Gy(19,1,102e3,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];ic(F|0,102024,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;Gy(19,0,102032,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}ae[c[16918]&255](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+QA(b,_);if(!(!(J<=H)&!(+QA(b,e)<=H))){$=31;break}tt(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;Iy(17,0,102040,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;Iy(17,0,102072,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+QA(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function KC(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;De[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function LC(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+pd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;KC(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function MC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){NC(a,b);f=0;i=d;return f|0}else if((e|0)==4){oe[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==1){g=c[a+4>>2]|0;j=c[g+4>>2]|0;OC(c[g>>2]|0,+h[j>>3],c[j+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else if((e|0)==3){f=gB(a,b)|0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function NC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[102104+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[102104+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];de[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function OC(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function PC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=Ny(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=p1(88)|0;Gy(23,0,102136,e);j=eB(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==4){j=c[1136]|0;g=p1(j<<2)|0;c[25540]=g;if((j|0)<=0){k=0;break}l=c[b+116>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=r1(l,8)|0;n=g+1|0;if((n|0)>=(j|0)){k=0;break a}m=c[25540]|0;g=n}}else if((f|0)==2){g=p1(8)|0;c[g+4>>2]=4;m=p1(20)|0;c[g>>2]=m;j=c[b+112>>2]|0;l=m;m=0;while(1){c[l+(m<<2)>>2]=r1(j,8)|0;if((m|0)>=4){break}l=c[g>>2]|0;m=m+1|0}c[d+48>>2]=g;k=0}else{k=0}}while(0);aD(b)|0;if((c[2]|0)==0){i=e;return k|0}$z(6);Yz(1);i=e;return k|0}function QC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){f=b+48|0;g=c[f>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){q1(c[g+(j<<2)>>2]|0);k=c[f>>2]|0;l=c[k>>2]|0;if((j|0)<(c[k+4>>2]|0)){j=j+1|0;g=l}else{m=l;break}}}else{m=h}q1(m);q1(c[f>>2]|0)}else if((e|0)==3){fB(c[b+48>>2]|0)|0}else if((e|0)==4){e=c[1136]|0;b=c[25540]|0;if((e|0)>0){f=b;m=0;while(1){q1(c[f+(m<<2)>>2]|0);h=m+1|0;g=c[25540]|0;if((h|0)<(e|0)){m=h;f=g}else{n=g;break}}}else{n=b}q1(n)}bD(a)|0;XC(a);i=d;return 0}function RC(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(218,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=e2(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=e2(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=e2(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=e2(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=e2(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(219,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=e2(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=e2(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;S1(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=e2(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=e2(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,102168,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=e2(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=e2(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,102264,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=e2(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[108384>>2]|0,108360,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=e2(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,102320,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=e2(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(220,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=e2(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function SC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Gy(8,0,102416,G);I=b+313|0;a[I]=1;EB(b);if((c[123756>>2]|0)==0){be[c[108380>>2]&127](108360,b)}a[I]=0}}while(0);if((e|0)!=0){TC(vd(e|0)|0,b)}if((c[67220>>2]|0)==0){i=f;return 0}$z(0);Gy(25,0,102464,F);Gy(25,1,102488,E);H=+Tz(6);J=+Tz(6);K=J/+Tz(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Gy(25,0,102496,D);K=+Tz(1);H=+Tz(1);J=H/+Tz(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Gy(25,0,102536,C);J=+Tz(2);K=+Tz(2);H=K/+Tz(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Gy(25,0,102568,B);H=+Tz(3);J=+Tz(3);K=J/+Tz(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Gy(25,0,102592,A);K=+Tz(4);H=+Tz(4);J=H/+Tz(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Gy(25,0,102632,z);J=+Tz(7);K=+Tz(7);H=K/+Tz(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Gy(25,0,102664,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+Tz(0);J=H- +Tz(7);H=J- +Tz(4);J=H- +Tz(3);H=J- +Tz(2);J=H- +Tz(1);H=J- +Tz(6);J=+Tz(0);K=J- +Tz(7);J=K- +Tz(4);K=J- +Tz(3);J=K- +Tz(2);K=J- +Tz(1);J=K- +Tz(6);K=J/+Tz(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Gy(25,0,102728,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Gy(25,0,102696,x)}K=+Tz(0);H=+Tz(0);J=H/+Tz(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Gy(25,0,102760,v);ae[c[16918]&255](25);Gy(25,1,102784,u);c[t>>2]=c[d+40>>2];Gy(25,0,102792,t);c[s>>2]=c[d+44>>2];Gy(25,0,102816,s);ae[c[16918]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);Gy(25,1,102840,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];Gy(25,0,102856,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];Gy(25,0,102872,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];Gy(25,0,102904,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];Gy(25,0,102936,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];Gy(25,0,102960,m);ae[c[16918]&255](25)}else if((s|0)!=5){Gy(25,1,102992,l);Gy(25,0,103e3,j);ae[c[16918]&255](25)}Gy(25,0,103064,g);Yz(0);i=f;return 0}function TC(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Xb(b|0,103536)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];sd(b|0,103544,y|0)|0;if((z|0)==0){C=Nd(10,b|0)|0;D=qd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((P1(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,103560,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((P1(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;sd(b|0,103576,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((P1(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;sd(b|0,103584,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((P1(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;sd(b|0,103592,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((P1(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,103560,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];sd(b|0,103560,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((P1(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;sd(b|0,103576,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;sd(b|0,103576,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((P1(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;sd(b|0,103584,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;sd(b|0,103584,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((P1(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;sd(b|0,103592,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((P1(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];sd(b|0,103560,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((P1(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;sd(b|0,103576,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((P1(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;sd(b|0,103584,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((P1(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;sd(b|0,103592,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Xb(0,103536)|0;}while((d|0)!=0);C=Nd(10,b|0)|0;D=qd(b|0)|0;i=e;return}function UC(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 4:{v=c[1134]|0;if((v|0)!=0){if((P1(v,103200)|0)==0){break a}}Gy(23,0,103216,p);w=1;i=m;return w|0};case 5:{Iy(1,0,103160,q);w=1;i=m;return w|0};case 11:case 10:case 9:case 6:case 7:case 8:{Iy(1,0,103088,r);w=1;i=m;return w|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 18:{v=c[1134]|0;do{if((v|0)!=0){if((P1(v,103344)|0)!=0){break}c[u>>2]=4;break a}}while(0);Gy(23,0,103368,o);w=1;i=m;return w|0};default:{}}}while(0);o=PC(a,s)|0;xe[c[68020>>2]&7]()|0;do{if((o|0)==0){r=RC(a,b,d,e,f,g)|0;xe[c[68020>>2]&7]()|0;if((r|0)!=0){x=r;break}if((c[u>>2]|0)!=5){be[c[108380>>2]&127](108360,a);OB(a)}y=+h[a+248>>3];r=n;h[k>>3]=+h[a+240>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+8|0;h[k>>3]=y;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(23,0,103496,n);r=se[c[c[a+540>>2]>>2]&63](a,t)|0;xe[c[68020>>2]&7]()|0;SC(a,s,l)|0;xe[c[68020>>2]&7]()|0;x=r}else{xe[c[68020>>2]&7]()|0;x=o}}while(0);QC(a,s)|0;w=x;i=m;return w|0}function VC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){WC(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((de[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){Ky(c[a+536>>2]|0,103608,d)}else if((k|0)==6){WC(a);i=b;return}}function WC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;X1(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function XC(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;q1(c[f+(a*48|0)+28>>2]|0);q1(c[f+(a*48|0)+32>>2]|0);q1(c[f+(a*48|0)+16>>2]|0);q1(c[f+(a*48|0)+20>>2]|0);q1(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}



function oA(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[77096]=1;a[77088]=1;c[77108>>2]=6;UR(77104)|0;e=c[d>>2]|0;c[19270]=1;if((e|0)>=1){d=1;do{jR(77224,b+(d+ -1)|0,1)|0;o=c[19270]|0;d=o+1|0;c[19270]=d;}while((o|0)<(e|0))}CR()|0;e=c[g>>2]|0;if((e|0)==1){c[77132>>2]=a[77088]&1?6:0;UR(77128)|0;jR(77224,h,4)|0;CR()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[77156>>2]=a[77088]&1?6:0;UR(77152)|0;jR(77224,h,4)|0;jR(77224,j,4)|0;CR()|0}j=c[k>>2]|0;if((j|0)==1){c[77180>>2]=a[77088]&1?6:0;UR(77176)|0;jR(77224,l,8)|0;CR()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[77204>>2]=a[77088]&1?6:0;UR(77200)|0;jR(77224,l,8)|0;jR(77224,m,8)|0;CR()|0}if((c[f>>2]|0)==2){TQ(77232,0)|0}else{i=n;return 0}return 0}function pA(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==0){c[19312]=2;C=2;while(1){D=C+1|0;if(!((c[k+(C+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[19312]=D;if((D|0)<12){C=D}else{break}}if((c[d>>2]|0)<1){_Q(77304,79e3,80,25);C=77608;D=77616;oA(77304,79032,77784,C,77688,d,C,C,D,D,80)|0;break}c[19376]=5;D=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{C=c[D>>2]|0;c[19376]=C;if(!((C+ -1|0)>>>0>4)){E=C;break}_Q(77304,79040,80,34);C=77608;F=77616;oA(77304,79080,77776,C,77688,77504,C,C,F,F,80)|0;break a}}while(0);c[D>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;C=fa(F,F)|0;c[19362]=C;c[19374]=C+50+(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0);C=q+12|0;if((c[k+16>>2]|0)==0){c[C>>2]=2;break}else{c[C>>2]=1;break}}else{C=c[q>>2]|0;do{if((C|0)>=0){F=c[d>>2]|0;if((C|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){_Q(77304,79864,80,52);I=77608;J=77616;oA(77304,79848,79920,I,77688,G,I,I,J,J,80)|0;break a}c[19362]=fa((C<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[D>>2]|0)+4|0,H)|0;c[19374]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[19362]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[19374]=F+(c[19362]|0);break b}}}while(0);_Q(77304,79792,80,52);C=77608;F=77616;oA(77304,79848,79856,C,77688,q,C,C,F,F,80)|0;break a}}while(0);c[19366]=(c[d>>2]|0)+20;c[q+64>>2]=c[19362];if((c[p>>2]|0)<(c[19374]|0)){_Q(77304,79088,80,60);D=77608;F=77616;oA(77304,79152,79160,D,77784,77496,p,D,F,F,80)|0;break}if((c[r>>2]|0)<(c[19366]|0)){_Q(77304,79168,80,60);F=77608;D=77616;oA(77304,79152,79232,F,77784,77464,r,F,D,D,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){_Q(77304,79976,80,24);D=77688;F=77608;C=77616;oA(77304,80008,80016,D,D,w,F,F,C,C,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[9678]=K;if(!(K<=0.0)){break}_Q(77304,79472,80,28);C=77608;oA(77304,78184,79504,C,C,C,C,77688,77424,77616,80)|0;break a}}while(0);c[q+60>>2]=0;C=q+36|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[n>>2]=1;B=27}else if((A|0)==-1){_Q(77304,77536,80,49);C=77608;F=77616;oA(77304,77592,77600,C,C,C,C,C,F,F,80)|0;_Q(77304,77624,80,47);F=77608;C=77616;oA(77304,77672,77680,F,77688,n,F,F,C,C,80)|0;_Q(77304,77696,80,41);C=77608;F=77616;oA(77304,77744,77752,77688,C,C,C,C,F,F,80)|0;i=y;return 0}else{B=210}}while(0);c:do{if((B|0)==27){a[77480]=0;K=+h[l>>3];h[9689]=K;L=+h[m>>3];h[9682]=L;A=c[d>>2]|0;c[19312]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[9689]=O;P=+h[m+(F<<3)>>3];h[9682]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[77480]=1;S=1}else{S=p}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}F=E+1|0;c[19312]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[19322]=p;r=p+(c[w>>2]|0)|0;c[19324]=r;p=r+(c[w>>2]|0)|0;c[19346]=p;F=p+(c[w>>2]|0)|0;c[19316]=F;C=F+(c[d>>2]|0)|0;c[19352]=C;D=C+(c[d>>2]|0)|0;c[19358]=D;c[19348]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+D;c[19372]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){C=o+64|0;h[9691]=+h[C>>3];a[77416]=0;h[9660]=+h[o+24>>3];J=o+16|0;h[9655]=+h[J>>3];do{if((c[w>>2]|0)!=0){qA(77784,v,w,d,77280,j,f,o+(F+ -1<<3)|0,o+(D+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,77400,C,0,o,q,s,t)|0;if((c[19442]|0)>0){i=y;return 0}if((c[19350]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=77688;NA(d,o+((c[19316]|0)+ -1<<3)|0,G,g,G)|0;a[77416]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[9655];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[9655]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[9655];if((M-N)*P>0.0){B=220;break}C=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[9690]=O;U=+h[9660];V=U-O;G=V*P>0.0;do{if(C){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[19358]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){vA(77280,j,f,g,d,H,I,X)|0;if((c[19442]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[77416]=1;B=197;break d}}else{Y=77280;vA(Y,Y,f,g,d,H,I,X)|0;if((c[19442]|0)>0){i=y;return 0}else{h[e>>3]=+h[9660];c[n>>2]=1;a[77416]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}vA(77280,j,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[77416]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[9691]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[9655]=W;h[J>>3]=W;break}vA(77280,77520,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[9690];a[77416]=1;B=197;break d}}else{W=+h[9660];if(!C){if(P*(W-N)<0.0){break}vA(77280,j,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[77416]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[19358]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){vA(77280,j,f,g,d,G,X,I)|0;if((c[19442]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[77416]=1;B=197;break d}}else{H=77280;vA(H,H,f,g,d,G,X,I)|0;if((c[19442]|0)>0){i=y;return 0}else{h[e>>3]=+h[9660];c[n>>2]=1;a[77416]=1;B=197;break d}}}}while(0);if(a[77416]&1){B=197}else{B=128}}else{h[9660]=+h[e>>3];c[n>>2]=1;sA(d,k+4|0,l,m,f,o+((c[19352]|0)+ -1<<3)|0,s,t)|0;C=c[d>>2]|0;c[19312]=1;e:do{if((C|0)>=1){J=c[19352]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[19312]=X;if((I|0)<(C|0)){I=X}else{break e}}_Q(77304,79608,80,39);I=77608;J=77616;oA(77304,79280,79648,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+zA(77760,1);h[9691]=U;C=o+64|0;h[C>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[9691]*4.0*(aa>=ba?aa:ba);h[9680]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){_Q(77304,79656,80,60);J=77608;oA(77304,79152,79720,J,J,J,J,77784,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[9659]=ca*.001;U=+tA(d,g,o+((c[19352]|0)+ -1<<3)|0,s,t);if(U>.5/+h[9659]){h[9659]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+XQ(77272,z);h[9659]=U;da=U}else{U=+h[o+16>>3];h[9659]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}_Q(77304,79560,80,29);J=77608;I=77616;oA(77304,79592,79600,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[9659]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[9690]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[9659]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{uA(77280,f,g,d,b,u,77272,o+((c[19352]|0)+ -1<<3)|0,n,s,t,o+((c[19358]|0)+ -1<<3)|0,o+400|0,o+((c[19316]|0)+ -1<<3)|0,o+((c[19348]|0)+ -1<<3)|0,q,77440,C,k+36|0,77488)|0;if((c[19442]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[9659]}h[9655]=ja;h[o+16>>3]=ja;J=c[19358]|0;X=(c[d>>2]|0)+J|0;c[19368]=X;G=c[d>>2]|0;c[19312]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[9655]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[19312]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[9655];h[o+232>>3]=+h[9655]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}qA(77688,v,w,d,e,j,f,o+((c[19316]|0)+ -1<<3)|0,o+((c[19358]|0)+ -1<<3)|0,J,Y,o+((c[19322]|0)+ -1<<3)|0,o+((c[19324]|0)+ -1<<3)|0,o+((c[19346]|0)+ -1<<3)|0,x,77400,C,0,o,q,s,t)|0;if((c[19442]|0)>0){i=y;return 0}if((c[19350]|0)!=0){_Q(77304,80024,80,47);la=77608;ma=77616;oA(77304,77672,80072,77688,la,la,la,la,ma,ma,80)|0;_Q(77304,80080,80,38);ma=77608;la=77616;oA(77304,77832,80072,77688,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}qA(77776,v,w,d,77280,j,f,o+((c[19316]|0)+ -1<<3)|0,o+((c[19358]|0)+ -1<<3)|0,J,Y,o+((c[19322]|0)+ -1<<3)|0,o+((c[19324]|0)+ -1<<3)|0,o+((c[19346]|0)+ -1<<3)|0,x,77400,C,0,o,q,s,t)|0;if((c[19442]|0)>0){i=y;return 0}if((c[19350]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=77688;NA(d,o+((c[19316]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){_Q(77304,79400,80,54);p=77608;oA(77304,79456,79464,p,p,p,p,77784,77520,j,80)|0;break c}else if((B|0)==220){_Q(77304,79512,80,34);p=77608;oA(77304,79080,79552,p,p,p,p,77784,j,e,80)|0;break c}else if((B|0)==224){_Q(77304,79728,80,49);p=77608;oA(77304,77592,79784,p,p,p,p,77784,77520,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;sA(d,oa,l,m,o+((c[19358]|0)+ -1<<3)|0,o+((c[19352]|0)+ -1<<3)|0,s,t)|0;if((c[19442]|0)>0){B=233;break}p=c[d>>2]|0;c[19312]=1;r=c[19352]|0;if((p|0)>=1){E=1;while(1){D=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){B=136;break f}c[19312]=D;if((E|0)<(p|0)){E=D}else{break}}}O=+tA(d,o+((c[19358]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[9691];pa=O*V;h[9657]=pa;if(!(pa<=1.0)){B=138;break}O=+h[9660];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[9680]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[9655];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[9655]=V/O}}while(0);wA(77280,f,g,d,b,u,77240,o+((c[19352]|0)+ -1<<3)|0,k,n,s,t,o+((c[19358]|0)+ -1<<3)|0,o+400|0,o+((c[19316]|0)+ -1<<3)|0,o+((c[19348]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,77440,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,77488)|0;if((c[19442]|0)>0){B=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){qA(77776,v,w,d,77280,j,f,o+((c[19316]|0)+ -1<<3)|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[19322]|0)+ -1<<3)|0,o+((c[19324]|0)+ -1<<3)|0,o+((c[19346]|0)+ -1<<3)|0,x,77400,o+64|0,0,o,q,s,t)|0;if((c[19442]|0)>0){B=233;break f}if((c[19350]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=77688;NA(d,o+((c[19316]|0)+ -1<<3)|0,r,g,r)|0;B=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[9660];V=+h[9655];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){B=128;continue}vA(77280,j,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}vA(77280,j,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(r){if(U>=0.0){vA(77280,j,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[9690];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[9691]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}vA(77280,77520,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[9690];B=197;continue}if(!(U<0.0)){vA(77280,j,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[9690];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[9691]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[9655]=U-O;B=128;continue}else{vA(77280,77520,f,g,d,q+28|0,o+((c[19358]|0)+ -1<<3)|0,o+224|0)|0;if((c[19442]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[9690];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[9660];h[o+16>>3]=+h[9655];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[9657]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[19312]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){C=l+(p<<3)|0;h[C>>3]=O*+h[C>>3];C=m+(E+ -1<<3)|0;h[C>>3]=+h[9657]*+h[C>>3];if((E|0)>=(r|0)){break}C=E;O=+h[9657];E=E+1|0;p=C}c[19312]=r+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);p=0-na|0;c[19368]=p;switch(p|0){case 2:{_Q(77304,77920,80,47);p=77608;oA(77304,77672,77968,p,p,p,p,77688,77280,77616,80)|0;_Q(77304,77976,80,48);p=77608;E=77616;oA(77304,77904,78032,p,p,p,p,p,E,E,80)|0;_Q(77304,78040,80,45);E=77608;p=77616;oA(77304,78088,78096,E,E,E,E,E,p,p,80)|0;break};case 3:{_Q(77304,78104,80,38);p=77608;oA(77304,77832,78144,p,p,p,p,77688,77280,77616,80)|0;_Q(77304,78152,80,28);p=77608;E=77616;oA(77304,78184,78192,p,p,p,p,p,E,E,80)|0;break};case 6:{_Q(77304,78200,80,44);E=77608;oA(77304,78248,78256,E,E,E,E,77784,77280,77240,80)|0;_Q(77304,78264,80,57);E=77608;p=77616;oA(77304,78328,78336,E,E,E,E,E,p,p,80)|0;break};case 7:{_Q(77304,78200,80,44);p=77608;oA(77304,78248,78344,p,p,p,p,77784,77280,77240,80)|0;_Q(77304,78352,80,48);p=77608;E=77616;oA(77304,77904,78408,p,p,p,p,p,E,E,80)|0;_Q(77304,78416,80,28);E=77608;p=77616;oA(77304,78184,78448,E,E,E,E,E,p,p,80)|0;break};case 8:{_Q(77304,78200,80,44);p=77608;oA(77304,78248,78456,p,p,p,p,77784,77280,77240,80)|0;_Q(77304,78464,80,37);p=77608;E=77616;oA(77304,78504,78512,p,p,p,p,p,E,E,80)|0;break};case 9:{_Q(77304,78200,80,44);E=77608;oA(77304,78248,78520,E,E,E,E,77784,77280,77240,80)|0;_Q(77304,78528,80,49);E=77608;p=77616;oA(77304,77592,78584,E,E,E,E,E,p,p,80)|0;_Q(77304,78592,80,38);p=77608;E=77616;oA(77304,77832,78632,p,p,p,p,p,E,E,80)|0;break};case 10:{_Q(77304,78200,80,44);E=77608;oA(77304,78248,78640,E,E,E,E,77784,77280,77240,80)|0;_Q(77304,78648,80,45);E=77608;p=77616;oA(77304,78088,78696,E,E,E,E,E,p,p,80)|0;_Q(77304,78704,80,36);p=77608;E=77616;oA(77304,78744,78752,p,p,p,p,p,E,E,80)|0;break};case 11:{_Q(77304,78760,80,40);E=77608;oA(77304,78808,78816,E,E,E,E,77784,77280,77240,80)|0;_Q(77304,78824,80,36);E=77608;p=77616;oA(77304,78744,78864,E,E,E,E,E,p,p,80)|0;break};case 12:{_Q(77304,78200,80,44);p=77608;oA(77304,78248,78872,p,p,p,p,77784,77280,77272,80)|0;_Q(77304,78880,80,45);p=77608;E=77616;oA(77304,78088,78928,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{_Q(77304,77792,80,38);E=77608;oA(77304,77832,77840,E,E,E,E,77688,77280,77616,80)|0;_Q(77304,77848,80,48);E=77608;p=77616;oA(77304,77904,77912,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[9660];h[o+24>>3]=+h[9660];h[o+16>>3]=+h[9655];i=y;return 0}else if((B|0)==215){_Q(77304,79240,80,39);p=77608;E=77616;oA(77304,79280,79288,p,p,p,p,p,E,E,80)|0;break c}else if((B|0)==216){_Q(77304,79296,80,39);E=77608;p=77616;oA(77304,79280,79336,E,E,E,E,E,p,p,80)|0;break c}}}while(0);_Q(77304,79344,80,47);A=77608;p=77616;oA(77304,77672,79392,A,A,A,A,A,p,p,80)|0}else if((B|0)==210){_Q(77304,78936,80,55);p=77608;A=77616;oA(77304,78992,77688,p,p,p,p,p,A,A,80)|0}}while(0);if((B|0)==227){_Q(77304,79928,80,39);B=77608;oA(77304,79280,79968,B,B,B,B,77784,j,e,80)|0}if((c[k>>2]|0)==-1){_Q(77304,80120,80,46);e=77608;j=77616;oA(77304,80168,80176,e,e,e,e,e,j,j,80)|0;_Q(77304,80184,80,47);j=77608;e=77616;oA(77304,77672,80232,77688,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function qA(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[10030]=C;c[t>>2]=0;D=c[e>>2]|0;c[20062]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[20062]|0;E=F+1|0;c[20062]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[10037]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==3){J=C;K=+h[g>>3]}else if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;vA(g,b,k,l,f,o,m,n)|0;if((c[19442]|0)>0){i=v;return 0}D=d;Yd[D&7](f,b,k,e,p,y,z)|0;if((c[19442]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[80304]=0;F=c[e>>2]|0;c[20062]=1;if((F|0)<1){break}else{L=0;M=1}while(1){I=+h[p+(M+ -1<<3)>>3];if(!(I>=0.0)){N=-I}else{N=I}if(!(N<=0.0)){O=L}else{a[80304]=1;O=1}if((M|0)<(F|0)){L=O;M=M+1|0}else{break}}c[20062]=F+1;if(!O){break}I=+XQ(80296,80240);h[10034]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[10030];do{if((H- +h[g>>3])*I<0.0){vA(g,b,k,l,f,o,m,n)|0;if((c[19442]|0)<=0){break}i=v;return 0}else{G=+h[10034]/I;h[10035]=G;P=c[f>>2]|0;c[20062]=1;if((P|0)<1){break}Q=(A<<1)+B|0;R=G;S=1;while(1){T=k+(S+ -1<<3)|0;h[T>>3]=+h[T>>3]+R*+h[m+(Q+S<<3)>>3];if((S|0)>=(P|0)){break}R=+h[10035];S=S+1|0}c[20062]=P+1}}while(0);Yd[D&7](f,b,k,e,p,y,z)|0;if((c[19442]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[80304]=0;F=c[e>>2]|0;c[20062]=1;if((F|0)<1){break}else{U=0;V=1}while(1){S=V+ -1|0;I=+h[p+(S<<3)>>3];if(!(I>=0.0)){W=-I}else{W=I}if(W>0.0){X=U;Y=V}else{c[s+(S<<2)>>2]=1;a[80304]=1;X=1;Y=c[20062]|0}S=Y+1|0;c[20062]=S;if((Y|0)<(F|0)){U=X;V=S}else{break}}if(!X){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{J=+h[10030];K=I;break}}else{F=w+320|0;vA(g,F,k,l,f,o,m,n)|0;if((c[19442]|0)>0){i=v;return 0}E=d;Yd[E&7](f,F,k,e,p,y,z)|0;if((c[19442]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[80304]=0;D=c[e>>2]|0;c[20062]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[80304]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[20062]=D+1;if(!aa){i=v;return 0}I=+XQ(80296,80240);h[10034]=I;h[F>>3]=I+ +h[F>>3];I=+h[10034]/+h[10030];h[10035]=I;S=c[f>>2]|0;c[20062]=1;if((S|0)>=1){Q=(A<<1)+B|0;H=I;T=1;while(1){ba=k+(T+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(Q+T<<3)>>3];if((T|0)>=(S|0)){break}H=+h[10035];T=T+1|0}c[20062]=S+1}Yd[E&7](f,F,k,e,p,y,z)|0;if((c[19442]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[80304]=0;T=c[e>>2]|0;c[20062]=1;if((T|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[80304]=1;fa=1}if((da|0)<(T|0)){ca=fa;da=da+1|0}else{break}}c[20062]=T+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-K)*J>=0.0)){h[10033]=ea;if((ea- +h[w+320>>3])*J<=0.0){i=v;return 0}vA(g,80264,k,l,f,o,m,n)|0;if((c[19442]|0)<=0){break}i=v;return 0}else{h[10033]=K;j=c[f>>2]|0;c[20062]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[20062]=j+1}}while(0);ga=d;Yd[ga&7](f,80264,k,e,q,y,z)|0;if((c[19442]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[20072]=0;T=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){rA(e,80296,80288,T,80264,p,q,r,80256,s,fa,da,x,ca)|0;if((c[19442]|0)>0){ha=76;break}if((c[20072]|0)>1){ha=73;break}vA(g,80256,k,l,f,o,m,n)|0;if((c[19442]|0)>0){ha=76;break}Yd[ga&7](f,80256,k,e,r,y,z)|0;if((c[19442]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[T>>3]=+h[10032];T=77688;NA(e,r,T,p,T)|0;if((c[20072]|0)==4){i=v;return 0}vA(g,80256,k,l,f,o,m,n)|0;if((c[19442]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function rA(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[20088]=c[o>>2];c[o>>2]=0;h[10040]=0.0;a[80336]=0;t=c[b>>2]|0;c[20078]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+XQ(80368,j+(v<<3)|0);if(w==+XQ(80368,l+((c[20078]|0)+ -1<<3)|0)){break}y=c[20078]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[10040]){break}h[10040]=B;c[o>>2]=y}else{a[80336]=1}}while(0);v=c[20078]|0;u=v+1|0;c[20078]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[80344]=1;c[20090]=c[p>>2];h[g>>3]=+h[r>>3];t=77688;NA(b,l,t,k,t)|0;c[p>>2]=1;a[80328]=0;C=0}else{a[80344]=0;c[o>>2]=c[20088];c[20090]=c[p>>2];if(a[80336]&1){h[g>>3]=+h[r>>3];t=77688;NA(b,l,t,k,t)|0;a[80328]=1;C=1;break}else{t=77688;NA(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[80328]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[80328]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=77688;NA(b,k,t,l,t)|0;t=c[b>>2]|0;c[20078]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[20078]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+XQ(80368,j+(u<<3)|0);if(!(A!=+XQ(80368,k+((c[20078]|0)+ -1<<3)|0))){break}c[n+((c[20078]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[20078]|0;F=u+1|0;c[20078]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[10040]=0.0;a[80336]=0;t=c[b>>2]|0;c[20078]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+XQ(80368,j+(v<<3)|0);if(A==+XQ(80368,k+((c[20078]|0)+ -1<<3)|0)){break}y=c[20078]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[10040]){break}h[10040]=I;c[o>>2]=y}else{a[80336]=1}}while(0);v=c[20078]|0;u=v+1|0;c[20078]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[80344]=t&1;if(t){a[80328]=0;c[20090]=0;c[p>>2]=1;break}if(!(a[80336]&1)){t=77688;NA(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=77688;NA(b,k,t,l,t)|0;t=c[b>>2]|0;c[20078]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[20078]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[20078]|0}u=K+1|0;c[20078]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[20090]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function sA(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[10049]=+h[d>>3];h[10048]=+h[e>>3];j=c[a>>2]|0;c[20094]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[10049]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[10049]=o;h[10048]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[10048];a=l+1|0;c[20094]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function tA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[10052]=0.0;e=c[a>>2]|0;c[20100]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[10052]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[20100]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[10051]=0.0;e=c[a>>2]|0;c[20100]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[10051]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[20100]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function uA(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[20118]=0;c[20116]=0;c[20122]=0;h[10064]=+h[b>>3];h[10066]=+tA(f,d,l,0,0);C=c[f>>2]|0;c[20106]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[20106]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[10057]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[20106]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[20106]=G+1}a[80520]=1;c[20108]=0;a[80536]=1;c[C>>2]=(c[C>>2]|0)+1;c[20126]=0;Yd[B&7](b,d,e,q,80504,n,o)|0;b:do{if((c[20126]|0)<0){K=35}else{while(1){if(a[80520]&1){c[E>>2]=(c[E>>2]|0)+1;a[80520]=0;xA(f,b,d,e,q,80456,k,80480,l,r,s,t,g,80504,v,j,n,o,x)|0;h[10056]=1.0e6;if((c[20126]|0)<0|(c[20120]|0)!=0){K=35;break b}c[20122]=0}H=c[f>>2]|0;c[20106]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[20106]=H+1}yA(f,q,s,t)|0;I=c[f>>2]|0;c[20106]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[10057]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[20106]=I+1}N=+tA(f,q,l,0,0);h[10068]=N;if(N<=+h[v>>3]*100.0*+h[10066]){break}J=c[20108]|0;if((J|0)>0){h[z>>3]=N/+h[10069];h[A>>3]=1.0/+(J|0);O=+VQ(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[10056]=P;Q=+h[10068];R=P}else{h[10069]=N;Q=N;R=+h[10056]}if(R*Q<=.33){break}J=c[20108]|0;H=J+1|0;c[20108]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[80520]=1}c[C>>2]=(c[C>>2]|0)+1;c[20126]=0;Yd[B&7](b,d,e,q,80504,n,o)|0;if((c[20126]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[20106]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[20106]=H+1}N=+tA(f,q,l,0,0);h[10068]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[20106]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[10057]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[20106]=J+1}}while(0);if(!(a[80536]&1)){break}H=c[f>>2]|0;c[20106]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[20106]=H+1}N=+tA(f,r,l,0,0);h[10062]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[80536]=0}h[b>>3]=+h[10064];G=c[f>>2]|0;c[20106]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[20106]=G+1}if(a[80536]&1){I=(c[20118]|0)+1|0;c[20118]=I;N=.9/(+h[10062]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[10055]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[20120]|0)!=0){I=(c[20122]|0)+1|0;c[20122]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[20126]|0)>-2)){K=53;break}I=(c[20116]|0)+1|0;c[20116]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function vA(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[20152]=o;p=+h[b>>3]- +h[a>>3];h[10074]=p;a=c[f>>2]|0;c[20144]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[20144]=a+1;q=+h[10074]}h[10070]=1.0;h[10071]=0.0;p=q/+h[k>>3];h[10075]=p;c[20146]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[10071]=u*t+s/+h[a>>3];p=t*s;h[10070]=p;h[10075]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[20144]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[10071]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[10070];g=g+1|0}c[20144]=a+1}g=v+1|0;c[20146]=g;if((v|0)>=(o|0)){break}r=+h[10074];s=+h[10070];t=+h[10075];u=+h[10071];v=g}i=l;return 0}function wA(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[10097]=+h[b>>3];c[20172]=0;c[20180]=0;c[20174]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[10109]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[20168]=(c[I>>2]|0)+1;c[20170]=(c[I>>2]|0)+2;c[20166]=(c[I>>2]|0)+ -1;h[10097]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[20184]=$+1;$=c[20168]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[10100]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[20154]=2;if(($|0)>=2){Y=2;while(1){h[10101]=+h[y+(Y+ -2<<3)>>3];U=+h[10100];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[10101];U=+h[10101]+ +h[k>>3];h[10100]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[20154]=$+1}h[y+($+ -1<<3)>>3]=+h[10100]}h[10107]=0.0;h[10105]=0.0;Y=c[I>>2]|0;c[20154]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[10107]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[10105]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[20154]=Y+1;da=ea}h[10108]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[10107]- +h[10105];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[10082]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[10082]=ha>=ca?ha:ca;h[10100]=.6;h[10101]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[10108]){h[D>>3]=100.0}aa=c[20168]|0;ba=c[20184]|0;if((aa|0)>=(ba|0)){c[20156]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[20154]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[20154]=ba+1}ja=ia+1|0;c[20156]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[20154]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[20154]=ia+1}aa=c[20168]|0;c[20156]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[20154]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[20154]=$+1}la=ba+1|0;c[20156]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[10104]=+tA(f,d,l,0,0);a[80880]=1;c[20158]=0;c[T>>2]=(c[T>>2]|0)+1;c[20188]=0;Yd[m&7](b,d,e,r,80752,o,p)|0;if((c[20188]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;xA(f,b,d,e,r,A,k,80704,l,s,t,u,g,80752,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[20188]|0)<0|(c[20176]|0)!=0){X=70;break}c[20180]=0}ba=c[f>>2]|0;c[20154]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[20154]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[10100]=ca;aa=c[f>>2]|0;c[20154]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[10100];ia=ia+1|0;la=ka}c[20154]=aa+1}yA(f,r,t,u)|0;la=c[f>>2]|0;c[20154]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[20154]=la+1}U=+tA(f,r,l,0,0);h[10109]=U;if(U<=+h[F>>3]*100.0*+h[10104]){X=63;break a}ia=c[20158]|0;if((ia|0)>0){h[O>>3]=U/+h[10111];h[P>>3]=1.0/+(ia|0);ca=+VQ(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[10109];oa=ga}else{h[10111]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[20158]|0;c[20158]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[20188]=0;Yd[m&7](b,d,e,r,80752,o,p)|0;if((c[20188]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[20154]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[20154]=ba+1}U=+tA(f,r,l,0,0);h[10109]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[20154]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[20154]=ia+1}}while(0);if((X|0)==70){X=0;a[80880]=0}c[H>>2]=1;if(a[80880]&1){U=+tA(f,s,l,0,0);h[10103]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[10089]=ga;h[10096]=ga*+(ba+1|0);h[10091]=ga;c[20190]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[20154]=1;if((ba|0)>=1){aa=fa(c[20168]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[20154]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+tA(f,r,l,0,0);h[10098]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[10106]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[20154]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[20154]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+tA(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[10106];if((sa>=ca?sa:ca)>+h[10096]){break}ta=+h[10098];ua=Y}else{if(!(ga<=+h[10096]*.5)){break}else{ta=U;ua=ka}}c[20190]=ua+ -1;h[10091]=ta}}while(0);if(!(+h[10082]*+h[10103]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[10097];Y=c[20168]|0;ia=c[20184]|0;if((Y|0)>=(ia|0)){c[20156]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[10100]=ca;ia=c[f>>2]|0;c[20154]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[10100];ja=ja+1|0}c[20154]=ia+1}ja=aa+1|0;c[20156]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[20154]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[20154]=Y+1}if(!(a[80880]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[20176]|0)!=0){aa=(c[20180]|0)+1|0;c[20180]=aa;h[10080]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[20188]|0)>-2)){X=146;break}aa=(c[20172]|0)+1|0;c[20172]=aa;h[10080]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[20174]=(c[20174]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[20174]|0;if((aa|0)<=1){ja=c[20190]|0;c[I>>2]=ja;sa=+(ja+1|0);h[10101]=sa;h[O>>3]=+h[10091]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+VQ(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[10080]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[20190];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[20204]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[20190]|0;E=c[20166]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[20168];za=+h[k>>3]*2.0;h[10093]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[20166]|0;Ba=c[20190]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[20168]|0)>=(c[K>>2]|0)|(c[20204]|0)==1){Fa=G;break}G=c[f>>2]|0;c[20154]=1;if((G|0)>=1){E=fa(c[20170]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[20154]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+tA(f,r,l,0,0);h[10099]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[10096];E=xa<=za;if(+h[10106]<=(E?xa:za)){Ea=c[20166]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[10096]*.5){Fa=S;break}}S=c[20168]|0;c[I>>2]=S;h[10091]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[10091]=+h[10098];Fa=Ea}h[10093]=+h[k>>3];ya=+(Fa+1|0);h[10101]=ya;h[O>>3]=+h[10091]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+VQ(O,P);h[10080]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[10093];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[10080]=xa;za=+h[k>>3]*xa;h[10093]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[10093]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[20154]=1;if((k|0)<1){break}u=fa(c[20170]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[20154]=k+1}}while(0);Ca=c[f>>2]|0;c[20154]=1;if((Ca|0)>=1){J=fa(c[20168]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[20154]=Ca+1}Ca=c[20168]|0;c[20162]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[20156]=P;s=c[f>>2]|0;c[20154]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[20154]=s+1}P=Ha+1|0;c[20162]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[20188]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[20174]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}vA(b,b,d,e,f,I,q,y)|0;i=N;return 0}function xA(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0.0,xa=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==4){P=c[q>>2]|0;Q=q+4|0;R=c[Q>>2]|0;S=c[b>>2]|0;T=fa(R+1+(P<<1)|0,S)|0;c[20224]=1;if((T|0)>=1){U=fa(S,R+(P<<1)+1|0)|0;P=(U|0)<1;R=1;while(1){h[p+(R+ -1<<3)>>3]=0.0;if((R|0)<(T|0)){R=R+1|0}else{break}}c[20224]=P?2:U+1|0}ce[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[20258]=(c[Q>>2]|0)+1+(c[q>>2]<<1);W=75}else if((O|0)==5){R=q+4|0;T=(c[R>>2]|0)+(c[q>>2]|0)|0;S=T+1|0;c[20250]=S;X=c[b>>2]|0;c[20240]=(T|0)<(X|0)?S:X;X=c[q>>2]|0;c[20258]=S+X;c[20244]=X+T;T=(c[b>>2]|0)/(S|0)|0;c[20254]=T+1;S=c[x>>2]|0;c[20252]=S+ -1;c[20262]=S+T;c[s>>2]=0;h[10124]=+V(+(+h[t>>3]));T=c[20240]|0;c[20226]=1;if((T|0)<1){W=75;break}S=r;X=1;while(1){Y=c[b>>2]|0;Z=c[20250]|0;c[20232]=X;_=(Z|0)<0;b:do{if(_?(X|0)>=(Y|0):(X|0)<=(Y|0)){$=Z;aa=X;ba=X;while(1){ca=(ba-aa|0)/($|0)|0;c[20228]=ca+1;da=ba+ -1|0;ea=e+(da<<3)|0;h[p+((c[20252]|0)+ca<<3)>>3]=+h[ea>>3];ga=f+(da<<3)|0;h[p+((c[20262]|0)+ca<<3)>>3]=+h[ga>>3];ha=+h[ea>>3];h[N>>3]=ha;if(!(ha>=0.0)){ia=-ha}else{ia=ha}ha=+h[l>>3]*+h[ga>>3];if(!(ha>=0.0)){ja=-ha}else{ja=ha}ha=ia>=ja?ia:ja;ka=+h[n+(da<<3)>>3];if(!(ka>=0.0)){la=-ka}else{la=ka}h[10121]=+h[10124]*(ha>=la?ha:la);h[N>>3]=+h[l>>3]*+h[ga>>3];ha=+XQ(80968,N);h[10121]=ha;ga=c[20232]|0;da=ga+ -1|0;ea=e+(da<<3)|0;ka=+h[ea>>3];ma=ha+ka-ka;h[10121]=ma;h[ea>>3]=+h[ea>>3]+ma;ea=f+(da<<3)|0;h[ea>>3]=+h[j>>3]*+h[10121]+ +h[ea>>3];ea=ga+Z|0;c[20232]=ea;if(!(_?(ea|0)>=(Y|0):(ea|0)<=(Y|0))){break b}$=c[20250]|0;aa=c[20226]|0;ba=ea}}}while(0);Yd[S&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}Y=c[b>>2]|0;_=c[20250]|0;Z=c[20226]|0;c[20232]=Z;ba=(_|0)<0;c:do{if(ba?(Z|0)>=(Y|0):(Z|0)<=(Y|0)){aa=_;$=Z;ea=Z;while(1){ga=(ea-$|0)/(aa|0)|0;c[20228]=ga+1;da=ea+ -1|0;ca=e+(da<<3)|0;h[ca>>3]=+h[p+((c[20252]|0)+ga<<3)>>3];ma=+h[p+((c[20262]|0)+ga<<3)>>3];ga=f+(da<<3)|0;h[ga>>3]=ma;ka=+h[ca>>3];h[N>>3]=ka;if(!(ka>=0.0)){na=-ka}else{na=ka}ka=+h[l>>3]*ma;if(!(ka>=0.0)){oa=-ka}else{oa=ka}ka=na>=oa?na:oa;ma=+h[n+(da<<3)>>3];if(!(ma>=0.0)){pa=-ma}else{pa=ma}h[10121]=+h[10124]*(ka>=pa?ka:pa);h[N>>3]=+h[l>>3]*+h[ga>>3];ka=+XQ(80968,N);h[10121]=ka;ga=c[20232]|0;ma=+h[e+(ga+ -1<<3)>>3];ha=ka+ma-ma;h[10121]=ha;ma=1.0/ha;h[10130]=ma;da=ga-(c[R>>2]|0)|0;ca=(da|0)>1?da:1;c[20234]=ca;da=c[b>>2]|0;qa=(c[q>>2]|0)+ga|0;ra=(da|0)<=(qa|0)?da:qa;c[20236]=ra;sa=fa(c[20244]|0,ga)|0;ta=sa-(c[q>>2]|0)|0;c[20238]=ta;c[20224]=ca;if((ca|0)<=(ra|0)){sa=~da;da=~qa;qa=~((sa|0)>(da|0)?sa:da);da=(ca|0)>(qa|0)?ca:qa;ha=ma;qa=ca;while(1){ca=qa+ -1|0;h[p+(ca+ta<<3)>>3]=(+h[o+(ca<<3)>>3]- +h[g+(ca<<3)>>3])*ha;if((qa|0)>=(ra|0)){break}ha=+h[10130];qa=qa+1|0}c[20224]=da+1}qa=ga+_|0;c[20232]=qa;ra=c[20226]|0;if(!(ba?(qa|0)>=(Y|0):(qa|0)<=(Y|0))){ua=ra;break c}aa=c[20250]|0;$=ra;ea=qa}}else{ua=Z}}while(0);Z=ua+1|0;c[20226]=Z;if((ua|0)<(T|0)){X=Z}else{W=75;break a}}i=y;return 0}else if((O|0)==3){i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[20246]=0;h[10124]=+V(+(+h[t>>3]));X=c[b>>2]|0;c[20224]=1;d:do{if((X|0)>=1){T=r;R=1;while(1){S=R+ -1|0;ha=+h[e+(S<<3)>>3];h[N>>3]=ha;if(!(ha>=0.0)){va=-ha}else{va=ha}Q=f+(S<<3)|0;ha=+h[l>>3]*+h[Q>>3];if(!(ha>=0.0)){wa=-ha}else{wa=ha}ha=va>=wa?va:wa;ma=+h[n+(S<<3)>>3];if(!(ma>=0.0)){xa=-ma}else{xa=ma}h[10121]=+h[10124]*(ha>=xa?ha:xa);h[N>>3]=+h[l>>3]*+h[Q>>3];ha=+XQ(80968,N);h[10121]=ha;Q=(c[20224]|0)+ -1|0;S=e+(Q<<3)|0;ma=+h[S>>3];ka=ha+ma-ma;h[10121]=ka;h[10128]=+h[S>>3];U=f+(Q<<3)|0;h[10132]=+h[U>>3];h[S>>3]=ka+ +h[S>>3];h[U>>3]=+h[j>>3]*+h[10121]+ +h[U>>3];Yd[T&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ka=1.0/+h[10121];h[10130]=ka;U=c[b>>2]|0;c[20230]=1;S=c[20246]|0;if((U|0)>=1){ma=ka;Q=1;P=0;while(1){h[p+(P+S<<3)>>3]=(+h[o+(P<<3)>>3]- +h[g+(P<<3)>>3])*ma;if((Q|0)>=(U|0)){break}Z=Q;ma=+h[10130];Q=Q+1|0;P=Z}c[20230]=U+1}c[20246]=S+(c[b>>2]|0);P=c[20224]|0;Q=P+ -1|0;h[e+(Q<<3)>>3]=+h[10128];h[f+(Q<<3)>>3]=+h[10132];R=P+1|0;c[20224]=R;if((P|0)>=(X|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){W=42;break}c[20246]=0;X=c[b>>2]|0;if((c[67176>>2]|0)==0){W=42;break}R=p1(X*20|0)|0;T=F;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(14,1,81064,F);T=E;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(14,0,81088,E);Gy(14,1,81096,D);c[20228]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[C>>2]=T+1;P=C+4|0;h[k>>3]=ma;c[P>>2]=c[k>>2];c[P+4>>2]=c[k+4>>2];Gy(14,0,81104,C);T=(c[20228]|0)+1|0;c[20228]=T;}while((T|0)<(c[b>>2]|0))}ae[c[16918]&255](14);Gy(14,1,81160,B);c[20224]=1;if((X|0)>=1){T=R+1|0;P=c[20246]|0;Q=1;do{Z=p+(Q+ -1+P<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[20230]=1;Z=P;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[A>>2]=R;ba=A+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ic(R|0,81144,A|0)|0;ba=c[20230]|0;c[20230]=ba+1;if((ba|0)>=(X|0)){break}Z=c[20246]|0;Y=ba}c[z>>2]=R;Gy(14,0,81152,z);Y=c[20246]|0;Z=c[20224]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];P=Y+(c[b>>2]|0)|0;c[20246]=P;Q=Z+1|0;c[20224]=Q;}while((Z|0)<(X|0))}ae[c[16918]&255](14);ae[c[16918]&255](14);q1(R);W=42}else{X=c[b>>2]|0;Q=fa(X,X)|0;c[20224]=1;if((Q|0)!=0){X=(Q|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(Q|0)){P=P+1|0}else{break}}c[20224]=X?2:Q+1|0}ce[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){W=42;break}c[20246]=0;P=c[b>>2]|0;if((c[67176>>2]|0)==0){W=42;break}R=p1(P*20|0)|0;T=M;h[k>>3]=+h[d>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(14,1,81064,M);T=L;h[k>>3]=+h[j>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];Gy(14,0,81088,L);Gy(14,1,81096,K);c[20228]=0;if((c[b>>2]|0)>0){T=0;do{ma=+h[e+(T<<3)>>3];c[J>>2]=T+1;Z=J+4|0;h[k>>3]=ma;c[Z>>2]=c[k>>2];c[Z+4>>2]=c[k+4>>2];Gy(14,0,81104,J);T=(c[20228]|0)+1|0;c[20228]=T;}while((T|0)<(c[b>>2]|0))}ae[c[16918]&255](14);Gy(14,1,81120,I);c[20224]=1;if((P|0)>=1){T=R+1|0;Q=c[20246]|0;X=1;do{Z=p+(X+ -1+Q<<3)|0;h[Z>>3]=+h[j>>3]+ +h[Z>>3];a[R]=0;a[T]=0;c[20230]=1;Z=Q;Y=0;while(1){ma=+h[p+(Y+Z<<3)>>3];c[H>>2]=R;ba=H+4|0;h[k>>3]=ma;c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];ic(R|0,81144,H|0)|0;ba=c[20230]|0;c[20230]=ba+1;if((ba|0)>=(P|0)){break}Z=c[20246]|0;Y=ba}c[G>>2]=R;Gy(14,0,81152,G);Y=c[20246]|0;Z=c[20224]|0;ba=p+(Y+ -1+Z<<3)|0;h[ba>>3]=+h[ba>>3]- +h[j>>3];Q=Y+(c[b>>2]|0)|0;c[20246]=Q;X=Z+1|0;c[20224]=X;}while((Z|0)<(P|0))}ae[c[16918]&255](14);ae[c[16918]&255](14);q1(R);W=42}}while(0);if((W|0)==42){FA(p,b,b,q+80|0,m)|0;i=y;return 0}else if((W|0)==75){LA(p,81032,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function yA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[20296]=(c[g>>2]|0)+1+(c[e>>2]<<1);MA(d,81184,a,e,g,e+80|0,b,81192)|0;i=f;return 0}else{JA(d,a,a,e+80|0,b,81192)|0;i=f;return 0}return 0}function zA(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[81200]&1)){a[81200]=1;AA(81248,81216,81296,81232,81280,81304,81288,81312)|0;h[10155]=+(c[20312]|0);f=c[20304]|0;h[10151]=+(f|0);if((c[20324]|0)==0){h[10153]=0.0;c[e>>2]=1-f;g=+WQ(81240,e)}else{h[10153]=1.0;c[e>>2]=1-f;g=+WQ(81240,e)*.5}h[10154]=g;h[10158]=g*+h[10155];h[10157]=+(c[20320]|0);h[10159]=+(c[20322]|0);j=+h[10163];h[10166]=j;k=1.0/+h[10164];if(!(k>=j)){break}h[10166]=k*(g+1.0)}}while(0);if((SA(b,81336,1,1)|0)!=0){g=+h[10154];h[10165]=g;l=g;i=d;return+l}if((SA(b,81344,1,1)|0)!=0){g=+h[10166];h[10165]=g;l=g;i=d;return+l}if((SA(b,81352,1,1)|0)!=0){g=+h[10155];h[10165]=g;l=g;i=d;return+l}if((SA(b,81360,1,1)|0)!=0){g=+h[10158];h[10165]=g;l=g;i=d;return+l}if((SA(b,81368,1,1)|0)!=0){g=+h[10151];h[10165]=g;l=g;i=d;return+l}if((SA(b,81376,1,1)|0)!=0){g=+h[10153];h[10165]=g;l=g;i=d;return+l}if((SA(b,81384,1,1)|0)!=0){g=+h[10157];h[10165]=g;l=g;i=d;return+l}if((SA(b,81392,1,1)|0)!=0){g=+h[10163];h[10165]=g;l=g;i=d;return+l}if((SA(b,81400,1,1)|0)!=0){g=+h[10159];h[10165]=g;l=g;i=d;return+l}if((SA(b,81408,1,1)|0)==0){l=+h[10165];i=d;return+l}else{g=+h[10164];h[10165]=g;l=g;i=d;return+l}return 0.0}function AA(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[81520]&1){q=81888;r=c[20472]|0;c[b>>2]=r;s=81824;t=c[20456]|0;c[d>>2]=t;u=81864;v=c[20466]|0;c[e>>2]=v;w=81872;x=+h[10234];h[f>>3]=x;y=81904;z=c[20476]|0;c[g>>2]=z;A=81952;B=+h[10244];h[j>>3]=B;C=81912;D=c[20478]|0;c[k>>2]=D;E=81960;F=+h[10245];h[l>>3]=F;i=m;return 0}a[81520]=1;h[10235]=0.0;h[10229]=1.0;h[10230]=2.0;BA(81888,81824,81864,81976)|0;h[10225]=+(c[20472]|0);c[n>>2]=0-(c[20456]|0);G=+WQ(81800,n);h[10224]=G;h[10234]=G;H=+h[10230];h[10225]=H/3.0;I=+h[10229];J=I*.5;h[10232]=J;K=-J;h[o>>3]=K;h[10246]=+CA(81800,o);L=81968;h[10243]=+CA(L,L);h[o>>3]=K;h[10225]=+CA(81944,o);K=+CA(81800,81968);h[10225]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[10225]=K;h[10234]=1.0;M=+h[10235];if(K<1.0&K>M){N=K;while(1){h[10234]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+CA(o,p);h[10226]=K;h[o>>3]=-K;h[10226]=+CA(81856,o);K=+CA(81856,81808);h[10225]=K;h[o>>3]=-K;h[10226]=+CA(81856,o);K=+CA(81856,81808);h[10225]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[10234]=G}G=I/+(c[20472]|0);h[10237]=G;h[10241]=I;c[20454]=1;p=1;O=I;do{h[o>>3]=O*G;O=+CA(o,81880);h[10241]=O;p=p+1|0;c[20454]=p;}while((p|0)<4);h[10224]=+CA(81832,81928);DA(81992,81832,81888)|0;h[o>>3]=-+h[10229];DA(81984,o,81888)|0;DA(81936,81792,81888)|0;h[o>>3]=-+h[10224];DA(81920,o,81888)|0;c[20462]=0;p=c[20498]|0;L=c[20496]|0;P=c[20484]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[20480]|0)){if(Q){c[20476]=p;R=0;S=25;break}if((P-p|0)==3){c[20476]=p+ -1+(c[20456]|0);c[20462]=1;R=1;S=25;break}else{c[20476]=(p|0)<=(P|0)?p:P;a[81528]=1;S=26;break}}else{T=Q&(L|0)==(c[20480]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[20476]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[20476]=(p|0)<=(L|0)?p:L;a[81528]=1;S=26;break}}T=c[20480]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[20476]=(V|0)<=(T|0)?V:T;a[81528]=1;S=26;break}if((P-U|0)==3){c[20476]=((p|0)>=(L|0)?p:L)+ -1+(c[20456]|0);R=0;S=25;break}else{c[20476]=U;a[81528]=1;S=26;break}}}while(0);if((S|0)==25){if(a[81528]&1){S=26}else{W=R}}if((S|0)==26){a[81520]=0;UR(82e3)|0;jR(82024,81904,4)|0;CR()|0;W=c[20462]|0}if((W|0)==0){X=(c[20494]|0)!=0|0}else{X=1}c[20462]=X;h[10244]=1.0;X=c[20476]|0;W=1-X|0;c[n>>2]=W;c[20454]=1;if((X|0)<=0){O=+h[10237];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+CA(o,81880);h[10244]=I;n=X+1|0;c[20454]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}EA(81888,81824,81904,81848,81912,81960)|0;q=81888;r=c[20472]|0;c[b>>2]=r;s=81824;t=c[20456]|0;c[d>>2]=t;u=81864;v=c[20466]|0;c[e>>2]=v;w=81872;x=+h[10234];h[f>>3]=x;y=81904;z=c[20476]|0;c[g>>2]=z;A=81952;B=+h[10244];h[j>>3]=B;C=81912;D=c[20478]|0;c[k>>2]=D;E=81960;F=+h[10245];h[l>>3]=F;i=m;return 0}function BA(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[81416]&1){l=a[81488]&1;m=c[20374]|0;c[b>>2]=m;n=81464;o=c[20366]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=81512;r=c[20378]|0;c[f>>2]=r;i=g;return 0}a[81416]=1;h[10184]=1.0;h[10178]=1.0;h[10180]=1.0;s=1.0;do{s=s*2.0;h[10178]=s;h[10180]=+CA(81424,81472);h[j>>3]=-s;t=+CA(81440,j);h[10180]=t;}while(t==1.0);h[10179]=1.0;t=+CA(81424,81432);h[10180]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[10179]=v;w=+CA(81424,81432);h[10180]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[10185]=.25;h[10188]=x;h[j>>3]=-s;t=+CA(81440,j);h[10180]=t;y=~~(t+.25);c[20374]=y;t=+(y|0);h[10179]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[10181]=+CA(j,k);w=+CA(81448,81424);h[10180]=w;z=w==s;a[81488]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[10181]=+CA(j,k);w=+CA(81448,81424);h[10180]=w;if(z&w==s){a[81488]=0;A=0}else{A=z}h[j>>3]=u;w=+CA(j,81424);h[10182]=w;h[j>>3]=u;z=w==s&+CA(j,81504)>x;c[20378]=z?A&1:0;c[20366]=0;h[10178]=1.0;h[10180]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[20366]=k;s=x*t;h[10178]=s;h[10180]=+CA(81424,81472);h[j>>3]=-s;w=+CA(81440,j);h[10180]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=81464;o=c[20366]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=81512;r=c[20378]|0;c[f>>2]=r;i=g;return 0}function CA(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function DA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[10254]=g;j=1.0/+(c[d>>2]|0);h[10263]=j;h[10262]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+CA(f,82096);h[10256]=k;h[10258]=g;h[10259]=g;h[10260]=g;h[10261]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[10254]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+CA(f,82096);h[10256]=g;h[f>>3]=g*k;k=+CA(f,82096);h[10258]=k;h[10260]=0.0;c[20510]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[10260]=q;c[20510]=b+1;n=q}h[f>>3]=m*j;p=+CA(f,82096);h[10257]=p;h[f>>3]=p/j;r=+CA(f,82096);h[10259]=r;h[10261]=0.0;o=c[d>>2]|0;c[20510]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[10261]=v;c[20510]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function EA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[20534]=1;c[20542]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[20534]=q;r=l+1|0;c[20542]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[20538]=n;u=n}else{c[20538]=m;c[20542]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[20544]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[20542]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[10270]=x;y=w+-1.0;h[10266]=y;h[10265]=0.0;v=c[b>>2]|0;c[20528]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[10266]=B;if(w<1.0){h[10268]=w}C=+CA(82120,82128);h[10265]=C;e=b+1|0;c[20528]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[10268];h[10265]=A;z=A}}while(0);v=c[f>>2]|0;c[20528]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+CA(k,82184);h[10265]=z;f=E+1|0;c[20528]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function FA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[20550]=1;m=1;do{c[20556]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=GA(j,a+(m+b+(fa(m,l)|0)<<3)|0,82232)|0;q=c[20550]|0;r=p+ -1+q|0;c[20552]=r;c[e+(q+ -1<<2)>>2]=r;r=c[20552]|0;q=c[20550]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[10277]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[10277];t=q}u=fa(t,l)|0;h[10277]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;HA(j,82216,a+(t-l+u<<3)|0,82232)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[20556]|0;c[20548]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[20552]|0;x=fa(w,l)|0;h[10277]=+h[a+(x+b+v<<3)>>3];y=c[20550]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[10277];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=82232;IA(k,82216,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[20548]|0;w=A+1|0;c[20548]=w;}while((A|0)<(u|0))}}while(0);q=c[20550]|0;m=q+1|0;c[20550]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function GA(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[20648]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[10325]=k;l=(c[d>>2]|0)+1|0;c[20648]=l;m=c[a>>2]|0;c[20646]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[10325]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[20648]=l;a=n+1|0;c[20646]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[10325]=v;c[20646]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[10325]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[20646]=f+1;g=C;i=e;return g|0}function HA(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[20632]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[20632]=l;i=f;return 0}l=(g|0)%5|0;c[20634]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[20632]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[20632]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[20632]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[20632]=o;i=f;return 0}function IA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[20618]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[20616]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[20616]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[20616]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[20616]=s;i=j;return 0}}while(0);c[20620]=1;c[20622]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[20620]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[20622]=s;u=s}else{u=1}s=c[a>>2]|0;c[20616]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[20620]=t;u=x+(c[g>>2]|0)|0;c[20622]=u;a=w+1|0;c[20616]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function JA(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[20568]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[20560]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[20562]=o;p=f+(o+ -1<<3)|0;h[10282]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[10282]}c[k>>2]=(c[d>>2]|0)-m;o=82232;IA(k,82256,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[20560]|0;m=o+1|0;c[20560]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[20566]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[20560]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[10282]=-s;c[k>>2]=g;g=82232;IA(k,82256,a+(p-l<<3)|0,g,f,g)|0;g=c[20566]|0;q=g+1|0;c[20566]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[20560]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=82232;s=+KA(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[10282]=s;q=c[20560]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[20560]=n;}while((q|0)<(m|0));t=c[20568]|0}if((t|0)<1){i=j;return 0}c[20566]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[20560]=n;c[k>>2]=(c[d>>2]|0)-n;b=82232;s=+KA(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[20560]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[20562]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[10282]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[10282]}q=c[20566]|0;m=q+1|0;c[20566]=m;}while((q|0)<(t|0));i=j;return 0}function KA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[10322]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[20638]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[20636]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[10322]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[20636]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[20636]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[10322]=t;u=u+5|0;}while((u|0)<=(m|0));c[20636]=u;k=t;i=g;return+k}}while(0);c[20640]=1;c[20642]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[20640]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[20642]=u;y=u}else{y=1}u=c[a>>2]|0;c[20636]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[10322]=t;x=C+(c[d>>2]|0)|0;c[20640]=x;y=B+(c[f>>2]|0)|0;c[20642]=y;a=z+1|0;c[20636]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function LA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[20578]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[20584]=n;o=c[d>>2]|0;p=c[20578]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[20586]=o;do{if((q|0)>(n|0)){c[20594]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[20582]=s;t=c[e>>2]|0;c[20570]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[20570]=t+1}u=r+1|0;c[20594]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[20594]=o;c[20592]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[20574]=1;t=o;o=1;while(1){c[20596]=o+1;p=t+1|0;c[20594]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[20570]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[20570]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[20588]=s;c[l>>2]=s+1;s=GA(l,a+((c[20578]|0)+b+(fa(o,m)|0)<<3)|0,82232)|0;p=s+ -1|0;c[20576]=p+(c[20578]|0);s=c[20574]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[20576]|0;p=c[20574]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[20578]|0;if((s|0)==(u|0)){y=s}else{h[10290]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[10290];y=u}h[10290]=-1.0/+h[a+(y+b+n<<3)>>3];HA(82352,82320,a+(y-m+n<<3)|0,82232)|0;u=c[20592]|0;z=(c[g+((c[20574]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[20592]=u;A=c[20578]|0;c[20590]=A;z=c[20596]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[20572]=z;B=z;z=A;while(1){A=(c[20576]|0)+ -1|0;c[20576]=A;C=z+ -1|0;c[20590]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[10290]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[10290];F=C}C=82232;IA(82352,82320,a+((c[20578]|0)-m+(fa(c[20574]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[20572]|0;D=C+1|0;c[20572]=D;if((C|0)>=(u|0)){break a}B=D;z=c[20590]|0}}}while(0);n=c[20574]|0;s=n+1|0;c[20574]=s;if((n|0)>=(r|0)){break}t=c[20594]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[20578]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function MA(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[20602]=n;f=c[d>>2]|0;o=f+ -1|0;c[20614]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[20598]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[20612]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[20600]=k;q=j+(k+ -1<<3)|0;h[10302]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[10302]}k=82232;IA(82448,82416,a+((c[20602]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[20598]|0;f=k+1|0;c[20598]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[20606]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[20598]=k;q=c[20602]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[20612]=s;u=q-s|0;c[20608]=u;q=k-s|0;c[20610]=q;h[10302]=-t;s=82232;IA(82448,82416,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[20606]|0;r=s+1|0;c[20606]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[20598]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[20612]=r;s=o-r|0;c[20608]=s;q=n-r|0;c[20610]=q;r=82232;t=+KA(82448,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[10302]=t;r=c[20598]|0;q=j+(r+ -1<<3)|0;o=c[20602]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[20598]=n;}while((r|0)<(f|0));v=o;w=c[20614]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[20606]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[20598]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[20612]=(n|0)<=(b|0)?n:b;b=82232;t=+KA(82448,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[20598]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[20600]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[10302]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[10302]}n=c[20606]|0;b=n+1|0;c[20606]=b;if((n|0)>=(w|0)){break}o=c[20602]|0;v=b}i=l;return 0}function NA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[20626]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[20624]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[20624]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[20624]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[20624]=o;i=g;return 0}}while(0);c[20628]=1;c[20630]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[20628]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[20630]=o;q=o}else{q=1}o=c[a>>2]|0;c[20624]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[20628]=p;q=s+(c[f>>2]|0)|0;c[20630]=q;a=r+1|0;c[20624]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function OA(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+PA(82608);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+QA(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+QA(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+QA(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+QA(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function PA(a){a=a|0;i=i;return+(+h[82616+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function QA(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function RA(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+PA(82648);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Be[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+QA(b,e);c[E>>2]=2;Be[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){ZA(b,b,f,g,82656,N,82648,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+QA(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=k2(ga|0,0,Z+ -2|0,0)|0;Z=d2(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}YA(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Be[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);OA(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+QA(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Be[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+QA(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+QA(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+QA(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}$A(b,b,s,t,v,w,x,D)|0;_A(b,b,f,g,w,x)|0;W=82648;_A(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Be[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Be[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function SA(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[82680]=1;f=d[b]|0;c[20666]=f;b=d[e]|0;c[20668]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[20666]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[20668]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}



function YC(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=p1(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=p1(c[y>>2]<<2)|0;ZC(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;V1(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;V1(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((dB(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=_C(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){V1(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;V1(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;q1(x);q1(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;Iy(5,1,103664,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];ic(q|0,103696,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;Iy(5,0,103704,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=67672;K=c[16918]|0;ae[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=103712;aa=$;Ky(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];Iy(5,0,103704,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=67672;K=c[16918]|0;ae[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=103712;aa=$;Ky(O,aa,g);return 0}function ZC(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;X1(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}de[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function _C(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=r1(d,4)|0;r=r1(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;q1(q);q1(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;q1(q);q1(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){q1(q);q1(r);i=o;return v|0}if((n|0)==0){v=-1;q1(q);q1(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Gy(5,1,103816,p);$C(s,d,f,c[g>>2]|0,j,l,m);if((c[67140>>2]|0)==0){v=-1;q1(q);q1(r);i=o;return v|0}ae[c[16918]&255](5);v=-1;q1(q);q1(r);i=o;return v|0}function $C(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;X1(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];Gy(5,0,103848,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function aD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=jc(103864,103888)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=bd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((bd(n|0)|0)!=10);q=c[b+152>>2]|0;r=r1(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=r1(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=r1(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=cc(n|0,103896,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=cc(n|0,103896,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=r1(s,8)|0;x=v}}while(0);hc(103904,j|0)|0;hc(103960,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];hc(103920,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];hc(103944,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(103960)|0;Xc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function bD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}q1(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){q1(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}q1(l);i=d;return 0}function cD(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function dD(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+eD(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[67156>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Gy(9,1,104024,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Gy(9,0,104136,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}ae[c[16918]&255](9);g=1;i=b;return g|0}function eD(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;tD(b);g=f+540|0;de[c[(c[g>>2]|0)+84>>2]&127](f)|0;de[c[(c[g>>2]|0)+36>>2]&127](f)|0;de[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;se[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function fD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+eD(b,1.0);if((c[67156>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}Gy(9,1,104160,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Gy(9,0,104224,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(9,0,104184,s)}Gy(9,1,104248,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;Gy(9,0,104320,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];Gy(9,0,104272,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;Gy(9,0,104408,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(9,0,104344,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;Gy(9,0,104496,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Gy(9,0,104440,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}ae[c[16918]&255](9);Gy(9,1,104528,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=de[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;Gy(9,0,104320,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Gy(9,0,104272,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}ae[c[16918]&255](9);ae[c[16918]&255](9);i=d;return}function gD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[67156>>2]|0)!=0){PB(b,9)}if((c[67216>>2]|0)==0){i=d;return}Gy(24,1,104552,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){Gy(24,1,104592,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Gy(24,0,104616,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}ae[c[16918]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}Gy(24,1,104672,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Gy(24,0,104696,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}ae[c[16918]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){Gy(24,1,104728,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(24,0,104616,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}ae[c[16918]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){Gy(24,1,104752,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;Gy(24,0,104776,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}ae[c[16918]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){Gy(24,1,104824,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?104896:104904;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?104896:104904;t=(a[(c[l>>2]|0)+n|0]|0)!=0?104896:104904;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;Gy(24,0,104848,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}ae[c[16918]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){Gy(24,1,104912,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;Gy(24,0,104936,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}ae[c[16918]&255](24)}ae[c[16918]&255](24);i=d;return}function hD(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;Gy(9,0,104984,z);if((f|0)==0){MB(b);NB(b);C=6}else{if((a[f]|0)!=0){iD(b,f,g)}MB(b);NB(b);if((a[f]|0)==0){C=6}}if((C|0)==6){de[c[(c[A>>2]|0)+84>>2]&127](b)|0;de[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(P1(d,106472)|0)==0|0;f=(P1(d,106480)|0)==0;z=(P1(d,106488)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;Iy(1,0,105032,y);Iy(1,0,105064,x);c[w>>2]=106472;c[w+4>>2]=106280;Iy(1,0,105088,w);c[v>>2]=106480;c[v+4>>2]=106360;Iy(1,0,105088,v);c[u>>2]=106488;c[u+4>>2]=106408;Iy(1,0,105088,u);Ky(c[b+536>>2]|0,105120,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(P1(e,c[105144+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;Iy(1,0,105176,s);Iy(1,0,105064,r);t=1;do{u=c[105208+(t<<2)>>2]|0;c[q>>2]=c[105144+(t<<2)>>2];c[q+4>>2]=u;Iy(1,0,105088,q);t=t+1|0;}while((t|0)<7);Ky(c[b+536>>2]|0,105120,p)}}while(0);p=c[105104+(D<<2)>>2]|0;c[o>>2]=c[105016+(D<<2)>>2];c[o+4>>2]=p;Gy(9,0,105240,o);o=(D|0)==2;if(o){p=c[105208+(F<<2)>>2]|0;c[n>>2]=c[105144+(F<<2)>>2];c[n+4>>2]=p;Gy(9,0,105280,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=jD(b,F,j)|0;break}if((D|0)==3){kD(b,j);I=0;break}else{Ky(c[b+536>>2]|0,105320,m)}}}while(0);if((vC(b,1)|0)!=0){J=-2;gD(b);K=15;L=K;M=105344;N=M;Gy(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];vB(b,R,V);W=215;JB(b);X=221;OB(b);Y=216;EB(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=224;KB(b);i=k;return J|0}if((nC(b,1)|0)!=0){J=-3;gD(b);K=15;L=K;M=105344;N=M;Gy(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];vB(b,R,V);W=215;JB(b);X=221;OB(b);Y=216;EB(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=224;KB(b);i=k;return J|0}m=(dC(b,1)|0)==0;J=m?I:-4;gD(b);K=15;L=K;M=105344;N=M;Gy(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];vB(b,R,V);W=215;JB(b);X=221;OB(b);Y=216;EB(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=de[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=se[ha&63](b,1)|0;ja=224;KB(b);i=k;return J|0}function iD(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Gy(9,0,106504,z);z=qz(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;Ky(C,106544,y)}Gy(9,0,106584,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=rz(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=nD(c[d+(C*112|0)+4>>2]|0)|0;E=rz(A,D)|0;q1(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((Q1(E,106624,6)|0)==0){if((c[67156>>2]|0)==0){break}}else{D=Q1(E,106632,6)|0;if((c[67156>>2]|D|0)==0){break}}c[v>>2]=E;Iy(9,0,106640,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;xz(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Gy(9,0,106608,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}Gy(9,0,106696,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=rz(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=nD(c[G+(w*112|0)+4>>2]|0)|0;v=rz(A,F)|0;q1(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];Iy(9,0,106720,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;xz(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Gy(9,0,106608,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}Gy(9,0,106776,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=rz(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=nD(c[t+(x*112|0)+4>>2]|0)|0;K=rz(A,C)|0;q1(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];Iy(9,0,106720,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;xz(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Gy(9,0,106608,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}Gy(9,0,106800,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=rz(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=nD(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=rz(A,u)|0;q1(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];Iy(9,0,106848,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;xz(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;Gy(9,0,106832,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}Gy(9,0,106904,l);l=b+144|0;if((c[l>>2]|0)<=0){oz(A);i=f;return}o=b+32|0;b=0;do{x=rz(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=nD(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=rz(A,n)|0;q1(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];Iy(9,0,106952,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;xz(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?104896:104904;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;Gy(9,0,106936,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));oz(A);i=f;return}function jD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;uB(a,+h[a+240>>3]);JB(a);OB(a);EB(a);QB(a);WC(a);FB(a);JB(a);e=lD(a,b,c)|0;OB(a);EB(a);KB(a);OB(a);i=d;return e|0}function kD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;uB(b,+h[b+240>>3]);JB(b);OB(b);YC(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=r1(c[y>>2]|0,8)|0;A=b+124|0;B=r1(c[A>>2]|0,4)|0;C=b+128|0;D=r1(c[C>>2]|0,1)|0;E=b+132|0;F=r1(c[E>>2]|0,4)|0;G=b+536|0;Jy(c[G>>2]|0,(z|0)!=0|0,105376,t);Jy(c[G>>2]|0,(B|0)!=0|0,105376,s);Jy(c[G>>2]|0,(D|0)!=0|0,105376,r);Jy(c[G>>2]|0,(F|0)!=0|0,105376,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[67156>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];ic(x|0,105392,p|0)|0;p=jc(x|0,105408)|0;c[o>>2]=105424;sd(p|0,105416,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];sd(p|0,105416,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Nd(10,p|0)|0;H=p}Gy(9,1,105432,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;de[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Gy(9,0,105456,l);if((c[67156>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(H|0,105480,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];sd(H|0,105480,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Nd(10,H|0)|0}if((vC(b,0)|0)!=0){break a}if((nC(b,0)|0)!=0){break a}if((dC(b,0)|0)!=0){break a}RB(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);ae[c[16918]&255](9);if((c[67156>>2]|0)!=0){Xc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}q1(z);q1(B);q1(D);q1(F)}else{h[b+304>>3]=1.0;de[c[w+80>>2]&127](b)|0}GB(b);if((YC(b,1,1)|0)!=1){i=e;return}de[c[(c[v>>2]|0)+80>>2]&127](b)|0;GB(b);if((YC(b,1,1)|0)!=1){i=e;return}Iy(1,0,105488,f);i=e;return}function lD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=oD(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){Gy(9,0,105592,u);if((c[b+184>>2]|0)==0){se[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}q1(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){Gy(9,0,105624,t);se[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;q1(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){Gy(9,1,105696,s);t=p1(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+eD(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+eD(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}Gy(9,1,105720,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Gy(9,0,105744,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];Gy(9,0,105744,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];Gy(9,0,105744,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[67156>>2]|0)!=0){ae[c[16918]&255](9);ae[c[16918]&255](9)}q1(t);pD(v);H=oD(b)|0;if((c[H>>2]|0)!=0){$=H;break}Gy(9,0,105768,n);q1(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}Gy(9,0,105800,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){Gy(9,0,105816,l);mD($,d,1,e);fD(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+eD($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){q1(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){q1(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){q1(v);c[l>>2]=0}mD($,d,0,e);fD(b,$);+eD($,1.0)}else{Gy(9,0,105840,j)}Gy(9,1,105864,g);fD(b,$);b=dD($)|0;if((c[67156>>2]|0)!=0){ae[c[16918]&255](9)}pD($);y=b;i=f;return y|0}function mD(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=p1(c[p>>2]<<3)|0;r=q;s=+eD(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;rD(a,r);q1(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=105992;F=E;Gy(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;Gy(9,0,105904,m);if(!t){qD(a)}switch(b|0){case 2:{G=wD(a)|0;break};case 4:{H=12;break a;break};case 1:{G=yD(a)|0;break};case 5:{H=13;break a;break};case 3:{G=AD(a,n,e)|0;break};case 6:{H=14;break a;break};default:{H=15;break a}}OB(o);EB(o);KB(o);OB(o);s=+eD(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}Gy(9,0,105952,k);fD(o,a);K=s}else{Gy(9,0,105968,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){vD(a)|0}else if((H|0)==13){vD(a)|0}else if((H|0)==14){uD(o,a,0)|0}else if((H|0)==15){Ky(c[o+536>>2]|0,105928,l)}else if((H|0)==23){rD(a,r);q1(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=105992;F=E;Gy(9,0,F,g);i=f;return}}function nD(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=T1(b|0)|0;do{if((d|0)==0){e=p1(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=p1(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((O1(e,107008,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;V1(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((O1(e,107008,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function oD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=p1(64)|0;z=y;Jy(0,(y|0)!=0|0,107016,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=r1(Z,8)|0;c[E>>2]=y;Jy(0,(y|0)!=0|0,107016,w);w=r1(Z,8)|0;c[F>>2]=w;Jy(0,(w|0)!=0|0,107016,v);v=r1(Z,8)|0;c[G>>2]=v;Jy(0,(v|0)!=0|0,107016,u);u=r1(Z,8)|0;c[H>>2]=u;Jy(0,(u|0)!=0|0,107016,t);t=r1(Z,8)|0;c[I>>2]=t;Jy(0,(t|0)!=0|0,107016,s);s=r1(Z,4)|0;t=s;c[J>>2]=t;Jy(0,(s|0)!=0|0,107016,r);Gy(9,0,107032,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;Gy(9,0,107056,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Gy(9,0,107144,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Gy(9,0,107192,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Gy(9,0,107248,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;Gy(9,0,107304,l);c[j>>2]=ya;Gy(9,0,107376,j);j=r1(sa,8)|0;c[K>>2]=j;Jy(0,(j|0)!=0|0,107016,g);g=p1(sa<<3)|0;c[L>>2]=g;Jy(0,(g|0)!=0|0,107016,f);f=p1(ya<<3)|0;c[M>>2]=f;Jy(0,(f|0)!=0|0,107016,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function pD(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){q1(d)}d=c[a+28>>2]|0;if((d|0)!=0){q1(d)}d=c[a+32>>2]|0;if((d|0)!=0){q1(d)}d=c[a+36>>2]|0;if((d|0)!=0){q1(d)}d=c[a+40>>2]|0;if((d|0)!=0){q1(d)}d=c[a+44>>2]|0;if((d|0)!=0){q1(d)}d=c[a+48>>2]|0;if((d|0)!=0){q1(d)}d=c[a+52>>2]|0;if((d|0)!=0){q1(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;q1(e);i=b;return}q1(d);e=a;q1(e);i=b;return}function qD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=r1(o,8)|0;q=r1(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=r1(s,8)|0;u=r1(s,8)|0;v=r1(o,8)|0;w=r1(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+eD(b,1.0);s=c[n>>2]|0;if((s|0)>0){V1(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+eD(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){V1(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;Gy(9,0,107416,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}q1(p);q1(q);q1(t);q1(u);q1(v);q1(w);i=d;return}function rD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function sD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function tD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function uD(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;Ky(c[a+536>>2]|0,107488,d);return 0}function vD(a){a=a|0;a=i;i=i+8|0;Ky(0,107520,a);return 0}function wD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[67156>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=r1((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;Jy(0,(n|0)!=0|0,107560,b);c[26894]=c[a+60>>2];c[26896]=c[a+48>>2];WA(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;q1(n);c[26894]=0;c[26896]=0;n=dD(a)|0;i=b;return n|0}function xD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[26896];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[26894];h[d>>3]=+eD(f,1.0);i=e;return}function yD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=p1(x)|0;z=y;A=p1(x)|0;x=A;Jy(0,(y|0)!=0|0,107592,n);Jy(0,(A|0)!=0|0,107592,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[67156>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+eD(a,1.0);h[o>>3]=D;if(D!=0.0){c[26902]=c[a+60>>2];c[26904]=c[a+48>>2];TA(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[26902]=0;c[26904]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Gy(9,0,107624,l)}D=+eD(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Gy(9,0,107728,j);j=c[u>>2]|0;do{if((j|0)==4){Iy(9,0,107960,d);F=-4;i=b;return F|0}else if((j|0)==2){Iy(9,0,107824,f);F=-2;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];Iy(9,0,107744,g);F=-1;i=b;return F|0}else if((j|0)==3){Iy(9,0,107888,e);F=-3;i=b;return F|0}}while(0);F=dD(a)|0;i=b;return F|0}function zD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[26904];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[26902];h[d>>3]=+eD(f,1.0);i=e;return}function AD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;Gy(9,1,108016,g);if((c[67156>>2]|0)==0){l=0}else{l=(k|0)/10|0}BD(a,d,k,l,b,j);c[f>>2]=c[j>>2];Gy(9,0,108040,f);ae[c[16918]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=dD(a)|0;if((b|0)==0){m=0;i=e;return m|0}Iy(9,0,108056,e);m=b;i=e;return m|0}function BD(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=p1(fa(N,M)|0)|0;P=p1(M<<3)|0;Q=p1(N)|0;R=Q;S=p1(N)|0;T=S;V=p1(N)|0;W=V;X=p1(N)|0;Y=+h[f>>3];if((c[67156>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];ic(N|0,108104,I|0)|0;I=jc(N|0,108120)|0;c[H>>2]=108136;sd(I|0,108128,H|0)|0;c[G>>2]=108152;sd(I|0,108128,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];sd(I|0,108128,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Nd(10,I|0)|0;c[E>>2]=0;sd(I|0,108160,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];sd(I|0,108168,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];sd(I|0,108168,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Nd(10,I|0)|0;Z=I}else{Z=0}Jy(0,(O|0)!=0|0,108176,B);Jy(0,(P|0)!=0|0,108176,A);Jy(0,(Q|0)!=0|0,108176,z);Jy(0,(S|0)!=0|0,108176,y);Jy(0,(V|0)!=0|0,108176,x);Jy(0,(X|0)!=0|0,108176,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{sD(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+eD(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;sD(a,la);+eD(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Gy(9,0,108192,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){X1(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);sD(a,R);za=+eD(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}V1(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}sD(a,T);if(+eD(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}V1(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}V1(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}sD(a,W);Ba=+eD(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}sD(a,W);Ba=+eD(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}V1(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Gy(9,0,108232,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;sd(Z|0,108160,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];sd(Z|0,108168,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];sd(Z|0,108168,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Nd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];Iy(9,0,108280,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Iy(9,0,108296,p);Ky(0,108312,o)}sD(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){q1(S);q1(Q);q1(V);q1(X);q1(P);q1(O);i=j;return}c[n>>2]=ia;sd(Z|0,108160,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(Z|0,108168,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];sd(Z|0,108168,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Nd(10,Z|0)|0;Xc(Z|0)|0;q1(S);q1(Q);q1(V);q1(X);q1(P);q1(O);i=j;return}function CD(a,b){a=a|0;b=b|0;i=i;return}function DD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;Yz(3);$z(0);w=+Tz(0);Yz(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];sd(v|0,108392,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];sd(v|0,108392,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];sd(v|0,108392,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];sd(v|0,108400,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;sd(v|0,108400,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];sd(v|0,108408,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];sd(v|0,108392,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];sd(v|0,108392,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;sd(v|0,108400,l|0)|0;break}else{c[m>>2]=0-E;sd(v|0,108400,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;sd(v|0,108400,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;sd(v|0,108400,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Nd(10,v|0)|0;$z(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];sd(v|0,108408,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Nd(10,v|0)|0;$z(3);i=e;return}function ED(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=jc(c[r>>2]|0,108416)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Rd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;Jy(t,(s|0)!=0|0,108424,q);c[p>>2]=108480;sd(s|0,108408,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=108488;sd(s|0,108408,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];sd(s|0,108408,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];sd(s|0,108408,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];sd(s|0,108408,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];sd(s|0,108408,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];sd(s|0,108408,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];sd(s|0,108408,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];sd(s|0,108408,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Nd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];sd(s|0,108408,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Nd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function FD(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;Yz(3);Xc(d|0)|0;$z(3);i=b;return}function GD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;BV(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];CV(p,f)|0;HD(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;ID(a,b,108504,c[j>>2]|0,c[g>>2]|0,o,8);q1(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];CV(p,e)|0;i=d;return}function HD(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=r1(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;Jy(c[b+536>>2]|0,(p|0)!=0|0,108784,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function ID(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;TD(a,b,d,e,f,h);AV(l,g,fa(fa(f,e)|0,h)|0)|0;if(XT(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Ky(l,108736,k)}else{i=j;return}}function JD(a){a=a|0;var b=0;b=i;if((LE(a+4|0)|0)!=0){i=b;return}_T(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function KD(a){a=a|0;Rc(a|0)|0;Ya()}function LD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=v1(320)|0;X1(q|0,0,320)|0;MD(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;Yz(3);t=a+8|0;u=ND(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=OD(a,b,u+s|0)|0;u=q+184|0;PD(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;PD(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;QD(q,c[x>>2]|0,36);if(XT(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];Ky(y,108560,e)}else{ID(a,b,108592,4,11,108512,1);RD((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;ID(a,b,108600,c[g>>2]|0,c[j>>2]|0,e,1);q1(e);c[f>>2]=0;RD((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;ID(a,b,108608,c[g>>2]|0,c[j>>2]|0,e,1);q1(e);c[f>>2]=0;SD(a,b,k,g,j,c[r>>2]|0,s);ID(a,b,108624,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;BV(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];HD(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;ID(a,b,108504,c[j>>2]|0,c[g>>2]|0,n,8);BV(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=UD(q+240|0)|0;w=UD(q+264|0)|0;p=UD(q+288|0)|0;TD(a,b,108640,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);q1(n);q1(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;gV(s)|0;q1(v);$z(3);i=d;return}}function MD(a){a=a|0;var b=0;b=i;VG(a);i=b;return}function ND(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(ZF(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(ZF(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(ZF(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function OD(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=p1(e<<2)|0;e=l;c[l>>2]=109192;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=109232;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(ZF(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(ZF(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(ZF(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function PD(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;KE(a,b,c);i=d;return}function QD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(JE(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){_T(d,4);i=e;return}else{YT(d,0);i=e;return}}function RD(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=T1(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=r1((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;Jy(0,(o|0)!=0|0,108712,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;c2(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;YD(q,T1(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=r1(1,1)|0;c[d>>2]=q;Jy(0,(q|0)!=0|0,108712,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function SD(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=r1(c[f>>2]<<2,4)|0;c[e>>2]=g;Jy(c[d+536>>2]|0,(g|0)!=0|0,108760,k);g=s+240|0;f=UD(g)|0;h=s+264|0;t=UD(h)|0;u=s+288|0;v=UD(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=UD(g)|0;D=UD(h)|0;E=UD(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==2){F=1;G=2}else if(z<<24>>24==1){ZD(l,b,A+(v*52|0)+4|0);$D(n,b);if(!(_D(l,n)|0)){H=w;break}F=(c[(aE(l)|0)+4>>2]|0)+1|0;G=1}else if(z<<24>>24==0){ZD(l,g,A+(v*52|0)+4|0);$D(m,g);if(!(_D(l,m)|0)){H=w;break}F=(c[(aE(l)|0)+4>>2]|0)+1|0;G=2}else{H=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=G;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=F}else{c[z+(w+1<<2)>>2]=0-F}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;H=w+4|0}else{H=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=H;v=A}else{I=H;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){H=d+44|0;v=s+276|0;w=I;t=0;while(1){F=c[H>>2]|0;do{if((a[F+(t*52|0)+48|0]|0)==0){f=a[F+(t*52|0)+8|0]|0;if(f<<24>>24==1){ZD(l,v,F+(t*52|0)+4|0);$D(p,v);J=(_D(l,p)|0)&1}else if(f<<24>>24==0){ZD(l,h,F+(t*52|0)+4|0);$D(o,h);f=_D(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;G=(c[(c[H>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(aE(l)|0)+4>>2]|0;if(G){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);F=t+1|0;if((F|0)<(c[x>>2]|0)){w=K;t=F}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){ZD(l,d,y+(t*52|0)+4|0);$D(r,d);M=(_D(l,r)|0)&1}else if(x<<24>>24==0){ZD(l,u,y+(t*52|0)+4|0);$D(q,u);x=_D(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(aE(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function TD(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(T1(d|0)|0)+1;e=m;AV(e,l,20)|0;if(XT(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];Ky(l,108736,k)}AV(e,d,c[f>>2]|0)|0;if(XT(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];Ky(m,108736,j)}else{i=h;return}}function UD(a){a=a|0;var b=0,d=0;b=i;d=c[(GE(a)|0)>>2]|0;i=b;return d|0}function VD(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;Yz(3);do{if(WT(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];CV(k,e)|0;k=UD(h+240|0)|0;m=UD(h+264|0)|0;l=UD(h+288|0)|0;TD(a,b,108640,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);JD(h)}else{if((h|0)!=0){break}c[g>>2]=0;$z(3);i=d;return}}while(0);WD(j);x1(h);c[g>>2]=0;$z(3);i=d;return}function WD(a){a=a|0;var b=0;b=i;cF(a);i=b;return}function XD(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;Yz(3);$z(0);h[j>>3]=+Tz(0);Yz(0);l=k;m=d+4|0;AV(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){AV(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){AV(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);AV(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);AV(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);AV(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(XT(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];Ky(t,108680,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;$z(3);i=e;return}}function YD(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((Q1(b,108896,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((Q1(b,108896,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function ZD(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;sE(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];iE(a,f);i=e;return}function _D(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=gE(a,b)|0;i=c;return d|0}function $D(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;jE(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];iE(a,e);i=d;return}function aE(a){a=a|0;var b=0,c=0;b=i;c=bE(cE(a)|0)|0;i=b;return c|0}function bE(a){a=a|0;var b=0,c=0;b=i;c=fE(a)|0;i=b;return c|0}function cE(a){a=a|0;var b=0,d=0;b=i;d=dE((c[a>>2]|0)+16|0)|0;i=b;return d|0}function dE(a){a=a|0;var b=0,c=0;b=i;c=eE(a)|0;i=b;return c|0}function eE(a){a=a|0;i=i;return a|0}function fE(a){a=a|0;i=i;return a|0}function gE(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(hE(a,b)|0)^1;i=c;return d|0}function hE(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function iE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];rE(a,e);i=d;return}function jE(a,b){a=a|0;b=b|0;var c=0;c=i;kE(a,lE(b)|0);i=c;return}function kE(a,b){a=a|0;b=b|0;var c=0;c=i;qE(a,b);i=c;return}function lE(a){a=a|0;var b=0,c=0;b=i;c=mE(nE(a+4|0)|0)|0;i=b;return c|0}function mE(a){a=a|0;var b=0,c=0;b=i;c=pE(a)|0;i=b;return c|0}function nE(a){a=a|0;var b=0,c=0;b=i;c=oE(a)|0;i=b;return c|0}function oE(a){a=a|0;i=i;return a|0}function pE(a){a=a|0;i=i;return a|0}function qE(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function rE(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function sE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=uE(b)|0;tE(f,b,d,h,lE(b)|0);jE(g,b);do{if(gE(f,g)|0){h=vE(b)|0;if(wE(h,d,xE(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);jE(a,b);i=e;return}function tE(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;BE(h);a:do{if((e|0)==0){j=f}else{k=vE(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(CE(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;BE(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;BE(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);kE(a,j);i=g;return}function uE(a){a=a|0;var b=0,d=0;b=i;d=c[(lE(a)|0)>>2]|0;i=b;return d|0}function vE(a){a=a|0;var b=0,c=0;b=i;c=zE(a+8|0)|0;i=b;return c|0}function wE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=yE(0,b,c)|0;i=a;return d|0}function xE(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function yE(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function zE(a){a=a|0;var b=0,c=0;b=i;c=AE(a)|0;i=b;return c|0}function AE(a){a=a|0;i=i;return a|0}function BE(a){a=a|0;var b=0;b=i;DE(a,-1);i=b;return}function CE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=yE(0,b,c)|0;i=a;return d|0}function DE(a,b){a=a|0;b=b|0;b=i;EE(a,0);i=b;return}function EE(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function FE(a){a=a|0;i=i;return c[a+4>>2]|0}function GE(a){a=a|0;var b=0,c=0;b=i;c=HE(a+8|0)|0;i=b;return c|0}function HE(a){a=a|0;var b=0,c=0;b=i;c=IE(a)|0;i=b;return c|0}function IE(a){a=a|0;i=i;return a|0}function JE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 56:{h=108832;break};case 5:case 21:{h=108856;break};case 13:case 29:{h=108888;break};case 52:case 20:{h=108848;break};case 1:case 17:{h=108808;break};case 24:{h=108824;break};case 12:{h=108864;break};case 9:case 25:{h=108840;break};case 48:case 16:{h=108800;break};case 60:{h=108880;break};case 28:{h=108872;break};case 8:{h=108816;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=jc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Vc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Xc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function KE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function LE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}ME(d,f,102);f=de[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Xc(NE(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}OE(d);g=h;i=b;return g|0}function ME(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;VE(a,b,c);i=d;return}



function Qq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36048]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+96>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+96>>3],1.0)|0)<<24>>24==0)){i=d;return}b=lz(36056,fz(+h[(c[g>>2]|0)+96>>3],24584)|0)|0;g=c[28996]|0;j=e;k=36192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[36048]=1;i=d;return}function Rq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36216]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(36224,fz(+h[(c[g>>2]|0)+280>>3],24584)|0)|0;g=c[28996]|0;j=e;k=36336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[36216]=1;i=d;return}function Sq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36360]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+272>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+272>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(36368,fz(+h[(c[g>>2]|0)+272>>3],24584)|0)|0;g=c[28996]|0;j=e;k=36504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[36360]=1;i=d;return}function Tq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36528]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+16>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(36536,hz(c[(c[g>>2]|0)+16>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=36760;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[36528]=1;i=d;return}function Uq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36784]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+12>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(36792,hz(c[(c[g>>2]|0)+12>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=37032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[36784]=1;i=d;return}function Vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37056]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(37064,fz(+h[(c[g>>2]|0)+256>>3],24584)|0)|0;g=c[28996]|0;j=e;k=37168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[37056]=1;i=d;return}function Wq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37192]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(37200,fz(+h[(c[g>>2]|0)+248>>3],24584)|0)|0;g=c[28996]|0;j=e;k=37312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[37192]=1;i=d;return}function Xq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37336]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+240>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+240>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(37344,fz(+h[(c[g>>2]|0)+240>>3],24584)|0)|0;g=c[28996]|0;j=e;k=37480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[37336]=1;i=d;return}function Yq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37504]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+232>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+232>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(37512,fz(+h[(c[g>>2]|0)+232>>3],24584)|0)|0;g=c[28996]|0;j=e;k=37648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[37504]=1;i=d;return}function Zq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37672]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+8>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(37680,hz(c[(c[g>>2]|0)+8>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=37904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[37672]=1;i=d;return}function _q(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37928]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+4>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(37936,hz(c[(c[g>>2]|0)+4>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=38168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[37928]=1;i=d;return}function $q(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38192]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(38200,fz(+h[(c[g>>2]|0)+216>>3],24584)|0)|0;g=c[28996]|0;j=e;k=38296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[38192]=1;i=d;return}function ar(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38320]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(38328,fz(+h[(c[g>>2]|0)+208>>3],24584)|0)|0;g=c[28996]|0;j=e;k=38432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[38320]=1;i=d;return}function br(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38456]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+200>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+200>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(38464,fz(+h[(c[g>>2]|0)+200>>3],24584)|0)|0;g=c[28996]|0;j=e;k=38624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[38456]=1;i=d;return}function cr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38648]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(38656,fz(+h[(c[g>>2]|0)+88>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[38648]=1;i=d;return}function dr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38776]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+80>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(38784,fz(+h[(c[g>>2]|0)+80>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[38776]=1;i=d;return}function er(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38904]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+72>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(38912,fz(+h[(c[g>>2]|0)+72>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[38904]=1;i=d;return}function fr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39032]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+64>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(39040,fz(+h[(c[g>>2]|0)+64>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[39032]=1;i=d;return}function gr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39160]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(39168,fz(+h[(c[g>>2]|0)+56>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[39160]=1;i=d;return}function hr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39288]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+48>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(39296,fz(+h[(c[g>>2]|0)+48>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[39288]=1;i=d;return}function ir(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39416]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(39424,fz(+h[(c[g>>2]|0)+40>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[39416]=1;i=d;return}function jr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39544]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+32>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(39552,fz(+h[(c[g>>2]|0)+32>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[39544]=1;i=d;return}function kr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39672]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(39680,fz(+h[(c[g>>2]|0)+24>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[39672]=1;i=d;return}function lr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39824]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(39832,fz(+h[(c[g>>2]|0)+16>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[39824]=1;i=d;return}function mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39976]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+8>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(39984,fz(+h[(c[g>>2]|0)+8>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[39976]=1;i=d;return}function nr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40128]&1){i=d;return}g=b+416|0;if(!((aC(+h[c[g>>2]>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(40136,fz(+h[c[g>>2]>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[40128]=1;i=d;return}function or(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40280]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+192>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+192>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(40288,fz(+h[(c[g>>2]|0)+192>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[40280]=1;i=d;return}function pr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40456]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+184>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+184>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(40464,fz(+h[(c[g>>2]|0)+184>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[40456]=1;i=d;return}function qr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40616]&1){i=d;return}g=b+4|0;b=aC(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lz(40624,hz(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=41376;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[40616]=1;i=d;return}function rr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40864]&1){i=d;return}g=b+4|0;b=aC(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lz(40872,hz(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=41376;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[40864]=1;i=d;return}function sr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41040]&1){i=d;return}g=b+4|0;b=aC(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lz(41048,hz(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=41376;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[41040]=1;i=d;return}function tr(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41208]&1){i=d;return}g=b+4|0;b=aC(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_B(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lz(41216,hz(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=41376;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[41208]=1;i=d;return}function ur(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41400]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(41408,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],24584)|0)|0;g=c[28996]|0;j=e;k=41568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[41400]=1;i=d;return}function vr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41592]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1208>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1208>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(41600,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1208>>3],24584)|0)|0;g=c[28996]|0;j=e;k=41736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[41592]=1;i=d;return}function wr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41760]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1176>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1176>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(41768,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1176>>3],24584)|0)|0;g=c[28996]|0;j=e;k=42080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[41760]=1;i=d;return}function xr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41920]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1168>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1168>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(41928,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1168>>3],24584)|0)|0;g=c[28996]|0;j=e;k=42080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[41920]=1;i=d;return}function yr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42104]&1){i=d;return}g=b+4|0;if(!((aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(42112,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1160>>3],24584)|0)|0;g=c[28996]|0;j=e;k=42368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[42104]=1;i=d;return}function zr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42240]&1){i=d;return}g=b+4|0;if(!((aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(42248,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],24584)|0)|0;g=c[28996]|0;j=e;k=42368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[42240]=1;i=d;return}function Ar(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42392]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],1.0)|0)<<24>>24==0)){i=d;return}b=lz(42400,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+648>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[42392]=1;i=d;return}function Br(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42536]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=lz(42544,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[42536]=1;i=d;return}function Cr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42680]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],.001)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],.25)|0)<<24>>24==0)){i=d;return}b=lz(42688,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[42680]=1;i=d;return}function Dr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42824]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],1.0)|0)<<24>>24==0)){i=d;return}b=lz(42832,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+632>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[42824]=1;i=d;return}function Er(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42976]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=lz(42984,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[42976]=1;i=d;return}function Fr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43128]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],.001)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],.25)|0)<<24>>24==0)){i=d;return}b=lz(43136,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[43128]=1;i=d;return}function Gr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43280]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],1.0)|0)<<24>>24==0)){i=d;return}b=lz(43288,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+624>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[43280]=1;i=d;return}function Hr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43448]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=lz(43456,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[43448]=1;i=d;return}function Ir(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43616]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3],.001)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3],.25)|0)<<24>>24==0)){i=d;return}b=lz(43624,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1104>>3],24584)|0)|0;g=c[28996]|0;j=e;k=43760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[43616]=1;i=d;return}function Jr(a){a=a|0;var b=0;b=i;Wn(a);Xn(a);Yn(a);Zn(a);_n(a);$n(a);ao(a);bo(a);co(a);eo(a);fo(a);go(a);ho(a);io(a);jo(a);ko(a);lo(a);mo(a);no(a);oo(a);po(a);qo(a);ro(a);so(a);to(a);uo(a);vo(a);wo(a);xo(a);yo(a);zo(a);Ao(a);Bo(a);Co(a);Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);So(a);To(a);Uo(a);Vo(a);Wo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);xp(a);yp(a);zp(a);Ap(a);Bp(a);Cp(a);Dp(a);Ep(a);Fp(a);Gp(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Op(a);Pp(a);Qp(a);Rp(a);Sp(a);Tp(a);Up(a);Vp(a);Wp(a);Xp(a);Yp(a);Zp(a);_p(a);$p(a);aq(a);bq(a);cq(a);dq(a);eq(a);fq(a);gq(a);hq(a);iq(a);jq(a);kq(a);lq(a);mq(a);nq(a);oq(a);pq(a);qq(a);rq(a);sq(a);tq(a);uq(a);vq(a);wq(a);xq(a);yq(a);zq(a);Aq(a);Bq(a);Cq(a);Dq(a);Eq(a);Fq(a);Gq(a);Hq(a);Iq(a);Jq(a);Kq(a);Lq(a);Mq(a);Nq(a);Oq(a);Pq(a);Qq(a);Rq(a);Sq(a);Tq(a);Uq(a);Vq(a);Wq(a);Xq(a);Yq(a);Zq(a);_q(a);$q(a);ar(a);br(a);cr(a);dr(a);er(a);fr(a);gr(a);hr(a);ir(a);jr(a);kr(a);lr(a);mr(a);nr(a);or(a);pr(a);qr(a);rr(a);sr(a);tr(a);ur(a);vr(a);wr(a);xr(a);yr(a);zr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Ir(a);i=b;return 0}function Kr(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Lr(b);i=c;return 0}function Lr(a){a=a|0;var b=0;b=i;_e(a);$e(a);ff(a);pf(a);qf(a);vf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Pf(a);Qf(a);Sf(a);Tf(a);Uf(a);ig(a);jg(a);kg(a);lg(a);mg(a);tg(a);yg(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);i=b;return}function Mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43784]&1){i=d;return}g=b+4|0;if(!((aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(43800,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],43792)|0)|0;g=c[28996]|0;j=e;k=50400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[43784]=1;i=d;return}function Nr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43960]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],-1.0e8)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(43968,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[43960]=1;i=d;return}function Or(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44208]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],-1.0e8)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(44216,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[44208]=1;i=d;return}function Pr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44384]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],-1.0e8)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(44392,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[44384]=1;i=d;return}function Qr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44560]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(44568,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[44560]=1;i=d;return}function Rr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44728]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(44736,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[44728]=1;i=d;return}function Sr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44896]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(44904,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[44896]=1;i=d;return}function Tr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45064]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(45072,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[45064]=1;i=d;return}function Ur(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45240]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(45248,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+488>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[45240]=1;i=d;return}function Vr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45416]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(45424,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+496>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[45416]=1;i=d;return}function Wr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45592]&1){i=d;return}g=b+4|0;if(!((aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(45600,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[45592]=1;i=d;return}function Xr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45688]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(45696,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[45688]=1;i=d;return}function Yr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45920]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(45928,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+984>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[45920]=1;i=d;return}function Zr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46064]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],-1.0e8)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(46072,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+976>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[46064]=1;i=d;return}function _r(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46216]&1){i=d;return}g=b+4|0;b=aC(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lz(46232,hz(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,46224)|0)|0;g=c[28996]|0;h=e;j=52632;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[46216]=1;i=d;return}function $r(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46448]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(46456,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[46448]=1;i=d;return}function as(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46616]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+960>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+960>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(46624,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+960>>3],43792)|0)|0;g=c[28996]|0;j=e;k=46768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[46616]=1;i=d;return}function bs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46792]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(46800,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+952>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[46792]=1;i=d;return}function cs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46960]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(46968,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[46960]=1;i=d;return}function ds(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47112]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+936>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+936>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(47120,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+936>>3],43792)|0)|0;g=c[28996]|0;j=e;k=47264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[47112]=1;i=d;return}function es(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47288]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+928>>3],-1.0e8)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+928>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(47296,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+928>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[47288]=1;i=d;return}function fs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47448]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+920>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+920>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(47456,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+920>>3],43792)|0)|0;g=c[28996]|0;j=e;k=47616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[47448]=1;i=d;return}function gs(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47640]&1){i=d;return}g=b+4|0;b=aC(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lz(47648,hz(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,46224)|0)|0;g=c[28996]|0;h=e;j=52632;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[47640]=1;i=d;return}function hs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47792]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(47800,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],43792)|0)|0;g=c[28996]|0;j=e;k=48024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[47792]=1;i=d;return}function is(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48048]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+888>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+888>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(48056,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+888>>3],43792)|0)|0;g=c[28996]|0;j=e;k=48240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[48048]=1;i=d;return}function js(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48264]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+880>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+880>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(48272,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+880>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[48264]=1;i=d;return}function ks(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48432]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+872>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+872>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(48440,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+872>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[48432]=1;i=d;return}function ls(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48600]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(48608,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[48600]=1;i=d;return}function ms(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48824]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(48832,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+432>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[48824]=1;i=d;return}function ns(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48976]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(48984,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[48976]=1;i=d;return}function os(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49144]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(49152,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[49144]=1;i=d;return}function ps(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49296]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(49304,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[49296]=1;i=d;return}function qs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49448]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(49456,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[49448]=1;i=d;return}function rs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49616]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(49624,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+384>>3],43792)|0)|0;g=c[28996]|0;j=e;k=49800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[49616]=1;i=d;return}function ss(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49824]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(49832,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+376>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[49824]=1;i=d;return}function ts(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49984]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(49992,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+368>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[49984]=1;i=d;return}function us(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50144]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(50152,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],43792)|0)|0;g=c[28996]|0;j=e;k=55064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[50144]=1;i=d;return}function vs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50312]&1){i=d;return}g=b+4|0;if(!((aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(50320,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],43792)|0)|0;g=c[28996]|0;j=e;k=50400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[50312]=1;i=d;return}function ws(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50424]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(50432,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+312>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[50424]=1;i=d;return}function xs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50576]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(50584,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+304>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[50576]=1;i=d;return}function ys(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50728]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],-1.0e8)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(50736,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+288>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[50728]=1;i=d;return}function zs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50904]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],-1.0e8)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(50912,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+296>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[50904]=1;i=d;return}function As(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51104]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(51112,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+272>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[51104]=1;i=d;return}function Bs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51272]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(51280,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+280>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[51272]=1;i=d;return}function Cs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51464]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(51472,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+208>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[51464]=1;i=d;return}function Ds(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51640]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(51648,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+216>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[51640]=1;i=d;return}function Es(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51840]&1){i=d;return}g=b+4|0;if(!((aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(51848,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],43792)|0)|0;g=c[28996]|0;j=e;k=51936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[51840]=1;i=d;return}function Fs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51960]&1){i=d;return}g=b+4|0;b=aC(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(51968,fz(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[51960]=1;i=d;return}function Gs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52144]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+816>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+816>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(52152,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+816>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[52144]=1;i=d;return}function Hs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52312]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3],-1.0e8)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(52320,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[52312]=1;i=d;return}function Is(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52488]&1){i=d;return}g=b+4|0;b=aC(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),0.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),2.0)|0)<<24>>24==0)){i=d;return}b=lz(52496,hz(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,46224)|0)|0;g=c[28996]|0;h=e;j=52632;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[52488]=1;i=d;return}function Js(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52656]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(52664,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+176>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[52656]=1;i=d;return}function Ks(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52848]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(52856,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],43792)|0)|0;g=c[28996]|0;j=e;k=52992;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[52848]=1;i=d;return}function Ls(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53016]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(53024,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[53016]=1;i=d;return}function Ms(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53192]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(53200,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[53192]=1;i=d;return}function Ns(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53392]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(53400,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[53392]=1;i=d;return}function Os(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53560]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(53568,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+168>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[53560]=1;i=d;return}function Ps(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53752]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(53760,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],43792)|0)|0;g=c[28996]|0;j=e;k=53928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[53752]=1;i=d;return}function Qs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53952]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(53960,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[53952]=1;i=d;return}function Rs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54120]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(54128,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+144>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[54120]=1;i=d;return}function Ss(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54312]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(54320,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[54312]=1;i=d;return}function Ts(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54512]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(54520,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[54512]=1;i=d;return}function Us(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54688]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(54696,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],43792)|0)|0;g=c[28996]|0;j=e;k=54864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[54688]=1;i=d;return}function Vs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54888]&1){i=d;return}g=b+4|0;b=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(54896,fz(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],43792)|0)|0;g=c[28996]|0;j=e;k=55064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[54888]=1;i=d;return}function Ws(a){a=a|0;var b=0;b=i;Mr(a);Nr(a);Or(a);Pr(a);Qr(a);Rr(a);Sr(a);Tr(a);Ur(a);Vr(a);Wr(a);Xr(a);Yr(a);Zr(a);_r(a);$r(a);as(a);bs(a);cs(a);ds(a);es(a);fs(a);gs(a);hs(a);is(a);js(a);ks(a);ls(a);ms(a);ns(a);os(a);ps(a);qs(a);rs(a);ss(a);ts(a);us(a);vs(a);ws(a);xs(a);ys(a);zs(a);As(a);Bs(a);Cs(a);Ds(a);Es(a);Fs(a);Gs(a);Hs(a);Is(a);Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Qs(a);Rs(a);Ss(a);Ts(a);Us(a);Vs(a);i=b;return 0}function Xs(a){a=a|0;i=i;return 1}function Ys(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=4;c[a+48>>2]=4;c[a+72>>2]=r1(4,8)|0;a=r1(4,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=r1(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=p1(16)|0;c[(c[d>>2]|0)+52>>2]=a;a=p1(64)|0;c[(c[d>>2]|0)+56>>2]=a;a=p1(16)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=4;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e>>2]=4;c[e+4>>2]=8;c[e+8>>2]=12;c[e+12>>2]=16;Zs(e,c[a+56>>2]|0);a=c[d>>2]|0;_s(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;$s(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;at(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+12>>2]=1;c[a+8>>2]=2;c[a+4>>2]=3;c[a>>2]=4;i=b;return 0}function Zs(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=2;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function _s(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=2;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function $s(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=1;c[b+((c[d>>2]|0)+ -2<<2)>>2]=2;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function at(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -4<<2)>>2]=0;c[b+((c[a>>2]|0)+ -3<<2)>>2]=1;c[b+((c[a>>2]|0)+ -2<<2)>>2]=2;c[b+((c[a>>2]|0)+ -1<<2)>>2]=3;i=i;return}function bt(a){a=a|0;i=i;return 1}function ct(a){a=a|0;i=i;return 1}function dt(a){a=a|0;i=i;return 1}function et(a){a=a|0;i=i;return 0}function ft(a){a=a|0;i=i;return 0}function gt(a){a=a|0;i=i;return 0}function ht(a){a=a|0;i=i;return 0}function it(a){a=a|0;i=i;return 0}function jt(a,b){a=a|0;b=b|0;i=i;return-1}function kt(a,b){a=a|0;b=b|0;i=i;return-1}function lt(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function mt(){i=i;return 55088}function nt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function ot(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function pt(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function qt(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(55832,n|0)|0;i=m;return 0}function rt(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=SA(a,55840)|0;z=SA(b,55840)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((SA(a,55848)|0)!=0){C=5;break}if((SA(a,55856)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((SA(b,55848)|0)!=0){break}if((SA(b,55856)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){X1(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}X1(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}X1(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(55864,r|0)|0;i=q;return 0}function st(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(SA(a,55872)|0)!=0;v=c[(u?f:g)>>2]|0;w=SA(e,55880)|0;x=SA(b,55888)|0;c[p>>2]=0;do{if(u){y=4}else{if((SA(a,55896)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((SA(b,55872)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((SA(d,55880)|0)==0){if((SA(d,55904)|0)!=0){break}if((SA(d,55912)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((SA(e,55888)|0)==0){if((SA(e,55880)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){X1(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(SA(d,55880)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(55920,p|0)|0;i=o;return 0}function tt(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}vt(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}wt(55936,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(55928,l|0)|0;i=k;return 0}function ut(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+zA(55960);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(nt(l,z,55968)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){pt(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;ot(l,n,d+(x-o+v<<3)|0,55968)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;qt(l,m,55976,d+(B+y<<3)|0,55968,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(55952,k|0)|0;i=j;return 0}



function TA(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[92212>>2]=6;UR(92208)|0;jR(92952,j,4)|0;CR()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[22354]=0;c[22960]=0;c[22948]=0;a[91816]=0;t=c[e>>2]|0;c[21908]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[22354]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[21908]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[21908]=1;if((v|0)>=1){x=1;while(1){h[84104+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[21908]=v+1}c[22952]=2;x=c[e>>2]|0;c[21908]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[21910]=1;if((E|0)<1){F=C}else{G=1;while(1){h[84104+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[21910]=E+1;F=+h[B>>3]}h[84104+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[22952]=G;D=G}G=z+1|0;c[21908]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[22354]|0;y=z+1|0;c[22350]=y;c[21908]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[21910]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[84104+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[21910]=x+1}ge[u&63](e,b,87464+(z+ -1<<3)|0)|0;c[22960]=(c[22960]|0)+1;if((c[j>>2]|0)>=1){c[92236>>2]=6;UR(92232)|0;jR(92952,91840,4)|0;jR(92952,87464+((c[21908]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[21910]=1;if((v|0)>=1){A=1;do{jR(92952,b+(A+ -1<<3)|0,8)|0;B=c[21910]|0;A=B+1|0;c[21910]=A;}while((B|0)<(v|0))}CR()|0}v=c[21908]|0;z=v+1|0;c[21908]=z;}while((v|0)<(y|0))}y=c[22948]|0;b:while(1){c[22948]=y+1;c[22860]=1;c[22856]=1;C=+h[10933];h[11429]=C;h[11431]=C;z=c[22350]|0;c[21908]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[87464+(A+ -1<<3)>>3];do{if(!(C<=K)){c[22860]=A;L=+h[87464+(A+ -1<<3)>>3];h[11429]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[22856]=A;L=+h[87464+(A+ -1<<3)>>3];h[11431]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[21908]=z+1;H=O}A=c[e>>2]|0;c[21908]=1;if((A|0)>=1){v=1;while(1){h[89584+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[21908]=A+1}c[21908]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[21910]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=89584+(Q+ -1<<3)|0;h[B>>3]=+h[84104+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[21910]=x+1;P=v}}while(0);v=P+1|0;c[21908]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[21910]=1;if((z|0)>=1){K=+(c[22354]|0);v=1;while(1){A=89584+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[21910]=z+1}v=c[e>>2]|0;c[21908]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[89584+(B<<3)>>3];h[91864+(B<<3)>>3]=K+(K- +h[84104+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[21908]=v+1}ge[u&63](e,91864,91856)|0;A=(c[22960]|0)+1|0;c[22960]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[92260>>2]=6;UR(92256)|0;jR(92952,91840,4)|0;jR(92952,91856,8)|0;B=c[e>>2]|0;c[21910]=1;if((B|0)>=1){E=1;do{jR(92952,91864+(E+ -1<<3)|0,8)|0;G=c[21910]|0;E=G+1|0;c[21910]=E;}while((G|0)<(B|0))}CR()|0}}while(0);K=+h[11482];c:do{if(!(K>=+h[11431])){z=c[e>>2]|0;c[21908]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[89584+(v<<3)>>3];h[92032+(v<<3)>>3]=I+(+h[91864+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[21908]=z+1}ge[u&63](e,92032,92024)|0;A=(c[22960]|0)+1|0;c[22960]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[92284>>2]=6;UR(92280)|0;jR(92952,91840,4)|0;jR(92952,92024,8)|0;B=c[e>>2]|0;c[21910]=1;if((B|0)>=1){E=1;do{jR(92952,92032+(E+ -1<<3)|0,8)|0;G=c[21910]|0;E=G+1|0;c[21910]=E;}while((G|0)<(B|0))}CR()|0}}while(0);I=+h[11503];if(I>=+h[11431]){R=118;break}v=c[e>>2]|0;c[21908]=1;A=c[22860]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[84104+((z*21|0)+ -22+A<<3)>>3]=+h[92032+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[21908]=v+1}h[87464+(A+ -1<<3)>>3]=I}else{z=c[22350]|0;c[21908]=1;if((z|0)>=1){B=c[22860]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[87464+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[21908]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[11429])){E=c[e>>2]|0;c[21908]=1;z=c[22860]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[84104+((B*21|0)+ -22+z<<3)>>3]=+h[91864+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[21908]=E+1}h[11429]=K;h[87464+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[21908]=1;if((B|0)>=1){A=c[22860]|0;v=1;while(1){x=v+ -1|0;h[92032+(x<<3)>>3]=+h[84104+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[89584+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[21908]=B+1}ge[u&63](e,92032,92024)|0;v=(c[22960]|0)+1|0;c[22960]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[92308>>2]=6;UR(92304)|0;jR(92952,91840,4)|0;jR(92952,92024,8)|0;z=c[e>>2]|0;c[21910]=1;if((z|0)>=1){E=1;do{jR(92952,92032+(E+ -1<<3)|0,8)|0;x=c[21910]|0;E=x+1|0;c[21910]=E;}while((x|0)<(z|0))}CR()|0}}while(0);I=+h[11503];if(!(I>+h[11429])){A=c[e>>2]|0;c[21908]=1;v=c[22860]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[84104+((B*21|0)+ -22+v<<3)>>3]=+h[92032+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[21908]=A+1}h[87464+(v+ -1<<3)>>3]=I;break}B=c[22350]|0;c[21908]=1;if((B|0)<1){break}else{S=1}do{z=c[22856]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[21910]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=84104+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[84104+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[84104+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[21910]=E+1}ge[u&63](e,b,87464+(S+ -1<<3)|0)|0;G=(c[22960]|0)+1|0;c[22960]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[92332>>2]=6;UR(92328)|0;jR(92952,91840,4)|0;jR(92952,87464+((c[21908]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[21910]=1;if((x|0)>=1){G=1;do{jR(92952,b+(G+ -1<<3)|0,8)|0;T=c[21910]|0;G=T+1|0;c[21910]=G;}while((T|0)<(x|0))}CR()|0}}while(0);z=c[21908]|0;S=z+1|0;c[21908]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[21908]=1;v=c[22860]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[84104+((A*21|0)+ -22+v<<3)>>3]=+h[91864+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[21908]=B+1}h[87464+(v+ -1<<3)>>3]=+h[11482]}A=c[22948]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[11432]=0.0;h[11478]=0.0;A=c[22350]|0;c[21908]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[11478]=0.0/K;c[21908]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[87464+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[11478]=I;c[21908]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[87464+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[11432]=$;c[21908]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[11432]=I;do{if(!(I<=+h[k>>3])){if((c[22960]|0)>(c[g>>2]|0)){break}a[91816]=0;c[22948]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[21908]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[21910]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[84104+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[21910]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[21908]=v+1}ge[u&63](e,b,f)|0;B=(c[22960]|0)+1|0;c[22960]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[92356>>2]=6;UR(92352)|0;jR(92952,91840,4)|0;jR(92952,s,8)|0;z=c[e>>2]|0;c[21910]=1;if((z|0)>=1){E=1;do{jR(92952,b+(E+ -1<<3)|0,8)|0;x=c[21910]|0;E=x+1|0;c[21910]=E;}while((x|0)<(z|0))}CR()|0;ba=c[22960]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[92476>>2]=6;UR(92472)|0;CR()|0;c[92500>>2]=6;UR(92496)|0;B=c[e>>2]|0;c[21908]=1;if((B|0)>=1){A=1;do{jR(92952,b+(A+ -1<<3)|0,8)|0;v=c[21908]|0;A=v+1|0;c[21908]=A;}while((v|0)<(B|0))}CR()|0;c[92524>>2]=6;UR(92520)|0;jR(92952,s,8)|0;CR()|0}if(a[91816]&1){I=+h[11478];K=+h[11524]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[91816]=1;da=+h[11478]}h[11524]=da;c[22948]=0;y=0}if((c[j>>2]|0)>=0){c[92548>>2]=6;UR(92544)|0;jR(92952,91840,4)|0;CR()|0;c[92572>>2]=6;UR(92568)|0;y=c[e>>2]|0;c[21908]=1;if((y|0)>=1){B=1;do{jR(92952,b+(B+ -1<<3)|0,8)|0;A=c[21908]|0;B=A+1|0;c[21908]=B;}while((A|0)<(y|0))}CR()|0;c[92596>>2]=6;UR(92592)|0;jR(92952,s,8)|0;CR()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[92620>>2]=6;UR(92616)|0;CR()|0}h[11431]=+h[f>>3];c[22962]=0;y=c[22350]|0;c[21908]=1;if((y|0)>=1){B=1;while(1){A=87464+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[21908]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[21910]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=84104+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[92032+(E+ -1<<3)>>3]=+h[84104+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[21910]=v+1}ge[u&63](e,92032,A)|0;c[22962]=(c[22962]|0)+1;c[22960]=(c[22960]|0)+1;E=c[21908]|0;I=+h[87464+(E+ -1<<3)>>3];if(I>=+h[11431]){B=E;continue}h[11431]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[92644>>2]=6;UR(92640)|0;jR(92952,91840,4)|0;jR(92952,91448,8)|0;E=c[e>>2]|0;c[21910]=1;if((E|0)>=1){z=1;do{jR(92952,92032+(z+ -1<<3)|0,8)|0;G=c[21910]|0;z=G+1|0;c[21910]=z;}while((G|0)<(E|0))}CR()|0;B=c[21908]|0}}B=c[22354]|0;c[21908]=1;do{if((B|0)<1){h[10958]=+h[10933];c[21908]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[21918]=E;z=c[e>>2]|0;c[21910]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[91864+(A+ -1<<3)>>3]=(+h[84104+(v+ -21<<3)>>3]+ +h[84104+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[21910]=z+1}ge[u&63](e,91864,89424+(y+ -1<<3)|0)|0;c[22962]=(c[22962]|0)+1;c[22960]=(c[22960]|0)+1;A=c[21908]|0;y=A+1|0;c[21908]=y;}while((A|0)<(B|0));y=c[22354]|0;I=+h[10933];h[10958]=I;c[21908]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[21918]=A;c[21920]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[21910]=1;E=1;while(1){v=E+1|0;c[21922]=v;G=c[e>>2]|0;c[21912]=1;if((G|0)>=1){x=c[21920]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[92032+(T+ -1<<3)>>3]=(+h[84104+(U+x<<3)>>3]+ +h[84104+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[21912]=G+1}ge[u&63](e,92032,92024)|0;c[22962]=(c[22962]|0)+1;c[22960]=(c[22960]|0)+1;T=c[21908]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[21910]|0;la=U+x|0;c[21914]=la;I=+h[10958];h[89744+(la+ -1<<3)>>3]=(+h[11503]+I- +h[89424+(v<<3)>>3]- +h[89424+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[21910]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[21908]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[22354]|0;c[21914]=0;c[21908]=1;E=(y|0)<1;if(E){c[21908]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=k2(A|0,0,y+ -2|0,0)|0;A=d2(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[89744+(U+ -1<<3)>>3]=(+h[87464+(v<<3)>>3]+ka- +h[89424+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[21918]=v+1;c[21914]=(z|1)+A;c[21908]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=89424+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[87464+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[21918]=T+1;c[21908]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[21914]=0;c[21908]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[21908]=1;if((B|0)>=1){A=1;while(1){h[91464+(A+ -1<<3)>>3]=+h[84104+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[21908]=B+1}c[21908]=1;do{if(ma){c[21908]=1}else{A=1;while(1){z=A+1|0;c[21918]=z;v=c[e>>2]|0;c[21910]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=84104+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[84104+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[21910]=v+1}c[21908]=z;if((A|0)<(na|0)){A=z}else{break}}c[21908]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[21918]=A;y=c[e>>2]|0;c[21910]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[84104+(T+oa<<3)>>3]=+h[84104+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[21910]=y+1}c[21908]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=89744;UA(B,89416,B,91624,92200,q,91784)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[92668>>2]=6;UR(92664)|0;CR()|0}c[q>>2]=2;if((c[22960]|0)>(c[g>>2]|0)){R=312;break}c[92692>>2]=6;UR(92688)|0;CR()|0;B=c[e>>2]|0;c[21908]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[21908]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[92380>>2]=6;UR(92376)|0;jR(92952,g,4)|0;CR()|0;c[92404>>2]=6;UR(92400)|0;jR(92952,91456,8)|0;CR()|0;c[92428>>2]=6;UR(92424)|0;u=c[e>>2]|0;c[21908]=1;if((u|0)>=1){E=1;do{jR(92952,b+(E+ -1<<3)|0,8)|0;z=c[21908]|0;E=z+1|0;c[21908]=E;}while((z|0)<(u|0))}CR()|0;c[92452>>2]=6;UR(92448)|0;jR(92952,s,8)|0;CR()|0;i=r;return 0}else if((R|0)==226){u=c[22354]|0;c[22958]=u-(c[23050]|0);c[21908]=1;E=(u|0)<1;do{if(E){h[11475]=0.0;c[21908]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[87464+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=87464+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[89744+(sa+ -1<<3)>>3]*+h[89424+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[21914]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[21910]=z;h[11475]=0.0;c[21908]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[87464+(v<<3)>>3]*+h[89424+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[11475]=wa;c[21908]=u+1;qa=wa}}while(0);h[11475]=+h[10958]-qa;s=c[e>>2]|0;c[21908]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[92032+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=92032+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[87464+(T+ -1<<3)>>3]*+h[84104+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[21908]=s+1;c[21910]=xa}v=c[e>>2]|0;c[21908]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=91464+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[92032+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[21908]=v+1}if((c[j>>2]|0)>=0){c[92716>>2]=6;UR(92712)|0;jR(92952,91800,8)|0;z=c[e>>2]|0;c[21908]=1;if((z|0)>=1){s=1;do{jR(92952,91464+(s+ -1<<3)|0,8)|0;u=c[21908]|0;s=u+1|0;c[21908]=s;}while((u|0)<(z|0))}CR()|0;c[92740>>2]=6;UR(92736)|0;CR()|0}z=c[e>>2]|0;c[21908]=1;if((z|0)>=1){s=c[22354]|0;v=1;while(1){c[21910]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[87464+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=87464+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[89744+(Aa+ -1<<3)>>3]*+h[84104+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[21914]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[21912]=E;c[21910]=s+1}T=c[e>>2]|0;c[21910]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=87720+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[87464+(Ea+ -1<<3)>>3]*+h[84104+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[21910]=T+1;c[21914]=Ca;c[21912]=Da}za=v+1|0;c[21908]=za;if((v|0)<(z|0)){v=za}else{break}}}c[21910]=0;v=c[e>>2]|0;c[21908]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[87720+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[21910]=Ga;c[21908]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[92764>>2]=6;UR(92760)|0;jR(92952,91832,4)|0;CR()|0;c[22352]=1;z=1;d:while(1){c[21914]=z;do{if((z|0)>(c[e>>2]|0)){s=c[22352]|0;if((s|0)==1){c[92788>>2]=6;UR(92784)|0;CR()|0;UA(87720,89416,89744,91624,92200,q,91784)|0;c[92812>>2]=6;UR(92808)|0;CR()|0;c[22352]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[22352]=2;c[21924]=0;c[21926]=0;s=c[e>>2]|0;c[21908]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=k2(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=d2(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=87720+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=87720+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[87720+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[21928]=Na;c[21926]=Ta;c[21924]=Ia;c[21910]=Ma;c[21908]=s+1}c[92836>>2]=6;UR(92832)|0;CR()|0;c[21924]=0;u=c[e>>2]|0;c[21908]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=87720+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[21924]=Wa;c[21908]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[21924]=T;s=c[e>>2]|0;c[21908]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[21918]=B;Qa=za+la|0;c[21924]=Qa;Pa=B+5|0;c[21920]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[22352]|0)==3){c[92908>>2]=6;UR(92904)|0;Pa=c[21920]|0;Qa=c[21918]|0;c[21910]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{jR(92952,89744+(B+ -1<<3)|0,8)|0;Qa=c[21910]|0;B=Qa+1|0;c[21910]=B;}while((Qa|0)<(Pa|0))}CR()|0}else{c[92884>>2]=6;UR(92880)|0;Pa=c[21920]|0;B=c[21918]|0;c[21910]=B;if((B|0)<=(Pa|0)){x=B;do{jR(92952,87720+(x+ -1<<3)|0,8)|0;B=c[21910]|0;x=B+1|0;c[21910]=x;}while((B|0)<(Pa|0))}CR()|0}Pa=c[21908]|0;x=Pa+1|0;c[21908]=x;if((Pa|0)>=(s|0)){break e}E=c[21914]|0;la=c[21924]|0;za=x}}}while(0);c[92932>>2]=6;UR(92928)|0;CR()|0;z=(c[21914]|0)+6|0}c[92860>>2]=6;UR(92856)|0;jR(92952,91848,4)|0;CR()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);ge[p&63](e,b,f)|0;i=r;return 0}function UA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[23258]=c[b>>2];c[g>>2]=1;if((c[23258]|0)<1){i=k;return 0}c[g>>2]=0;VA(a,93032,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[23258]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[23250]=f;c[23256]=g;c[23262]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=k2(a|0,0,g+ -2|0,0)|0;m=d2(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[23242]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=k2(p|0,0,a-n|0,0)|0;p=d2(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[23242]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[23240]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[23240]=j}c[23252]=g;c[23254]=f;c[23260]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[11624]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[11624]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[11624]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[23260]=D;E=v+ -1|0;c[23252]=E;F=w+ -1|0;c[23254]=F;q=D;v=E;w=F}c[23244]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[23246]=t;c[23256]=0;c[23262]=l-g;i=k;return 0}function VA(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[11638]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[11638]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[11638];c[23266]=1;c[23268]=0;n=c[b>>2]|0;c[23280]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[23270]=0;c[23282]=1;do{if((o|0)>=1){p=1;q=c[23268]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[11637]=m;u=(p|0)==(o|0);if(u){l=m*+h[11638];h[11639]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[11637]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[11639]=+h[11639]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[23270]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[23270]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[11637];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[23282]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[23264]=y;c[23272]=x;c[23268]=s;break}else if((D|0)==26){D=0;c[23264]=y;c[23272]=x;c[23268]=s;break}}}while(0);m=+V(+(+h[11639]));h[11639]=m;H=+h[11637];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[23268]|0)+ -1<<3)>>3]=G;G=+h[11639]/+h[11637];h[j+((c[23264]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[23268]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[23266]|0;O=c[23280]|0}}while(0);b=N+O|0;c[23266]=b;o=O+1|0;c[23280]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[23264]=y;c[23272]=x;c[23268]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function WA(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[23306]=n;o=(c[d>>2]|0)-n|0;c[23328]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[23326]=s;a[93248]=1;t=c[b>>2]|0;u=t+1|0;c[23322]=u;v=c[b>>2]|0;w=u+v|0;c[23320]=w;u=w+(c[b>>2]|0)|0;c[23324]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[23314]=w;x=w+(c[d>>2]|0)|0;c[23308]=x;y=x+(c[b>>2]|0)|0;c[23310]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[23316]=z;A=z+(c[d>>2]|0)|0;c[23330]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[23332]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[23304]=C;D=C+(c[b>>2]|0)|0;c[23318]=D;XA(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,93304,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);UR(93336)|0;CR()|0;i=m;return 0}function XA(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[11752]=.5;h[11743]=1.0;h[11783]=.1;F=(c[a>>2]|0)+1|0;c[23482]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[23474]=H;I=(c[b>>2]|0)-F|0;c[23528]=I;F=c[j>>2]|0;c[23582]=(F|0)<1?1:F;F=c[a>>2]|0;c[23466]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[23468]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[23468]=J+1}L=c[u>>2]|0;c[23464]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[23464]=L+1}K=j+1|0;c[23466]=K;if((j|0)<(F|0)){j=K}else{break}}}c[23470]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[23470]=H+1}H=c[b>>2]|0;c[23468]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[23466]=M;c[23468]=H+1}N=+h[e>>3];O=N*N;h[11788]=O;h[11774]=+h[11743]/O;h[11775]=+V(+(+h[11752]))/O;c[23472]=0;H=y;y=A;M=0;a:while(1){c[23484]=M;F=M-(c[a>>2]|0)|0;c[23508]=F;j=M+1|0;c[23472]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[23558]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[23496]=L;K=L+G|0;c[23494]=K;if((K|0)>(c[a>>2]|0)){c[23558]=L;G=K-(c[a>>2]|0)|0;c[23496]=G;c[23494]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[11765]=O;L=c[23482]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[11765]=N;R=N}else{R=O}O=+h[e>>3];h[11766]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[11766]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[11766];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[23466]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[23466]=S+1}if((M|0)>=(c[23582]|0)){T=j;U=159;break}while(1){ge[H&63](a,d,93848)|0;if((c[g>>2]|0)==3){UR(94376)|0;jR(94544,93888,4)|0;jR(94544,93848,8)|0;I=c[a>>2]|0;c[23464]=1;if((I|0)>=1){F=1;do{jR(94544,d+(F+ -1<<3)|0,8)|0;L=c[23464]|0;F=L+1|0;c[23464]=F;}while((L|0)<(I|0))}CR()|0}I=c[23472]|0;do{if((I|0)>(c[b>>2]|0)){F=c[23512]|0;if((F|0)==-1){break a}h[11784]=0.0;c[23470]=0;L=c[a>>2]|0;c[23466]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[11784]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[11757]=N;if((X|0)==(G|0)){ea=N*+h[11752];h[11757]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[11784]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[23470]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[23464]=Y;c[23466]=L+1;W=Z}J=c[b>>2]|0;c[23468]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[11784]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[23468]=J+1;ia=ja}O=+h[11731];ba=+h[11760];N=O-ba-ia;h[11751]=N;h[11770]=+h[11769];h[11769]=+h[11768];if(!(N>=0.0)){ka=-N}else{ka=N}h[11768]=ka;if(+h[11780]>+h[11746]){c[23556]=I}h[11776]=ba;do{if(O<ba){h[11760]=O;h[11793]=0.0;G=c[a>>2]|0;c[23464]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[11793]=+h[11793]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[23464]=G+1;h[A>>3]=ma}}while(0);c[23554]=F;if((F|0)<=0){O=+h[11784];if(O>=0.0){U=190;break a}ba=+h[11731];N=+h[11776];ea=(ba-N)/O;h[11781]=ea;O=+h[11783];do{if(!(ea<=O)){na=+h[11752]*+h[11773];h[A>>3]=na;oa=+h[11780];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[11773]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[11773]=qa;ra=qa;break}}else{qa=+h[11752]*+h[11780];h[11773]=qa;ra=qa}}while(0);ea=+h[11746];if(!(ra<=ea*1.5)){sa=ra}else{h[11773]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[11788]=ea;c[23570]=0;h[11789]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[23526]|0;c[23570]=J;oa=+h[11743];h[11789]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[23468]=1;if((J|0)<1){va=F}else{L=c[23528]|0;oa=ua;K=1;ca=F;while(1){h[11771]=0.0;c[23466]=1;if((L|0)<1){wa=0.0}else{X=c[23488]|0;aa=K+C|0;qa=+h[11743];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[11757]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[11771]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[23466]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[11753]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[11757]=za;h[11792]=0.0;$=c[a>>2]|0;c[23466]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[11792]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[23466]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[11757]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[11789]=Fa;c[23512]=K;Ga=Fa;Ha=K}aa=K+1|0;c[23468]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}bB(a,b,s,t,93952,u,w,94024,94048,x)|0;ca=c[23512]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[11731];c[23470]=0;J=c[a>>2]|0;c[23464]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[11757]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[11757];G=G+1|0;da=da+1|0}da=X+aa|0;c[23470]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[23466]=La;c[23464]=J+1}h[L>>3]=0.0;X=c[23528]|0;c[23466]=1;aa=(X|0)<1;if(!aa){F=c[23488]|0;K=1;while(1){da=fa(K,B)|0;O=+h[11751]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[11757]=Oa;G=c[b>>2]|0;c[23468]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[11757];$=$+1|0}c[23468]=G+1}$=K+1|0;c[23466]=$;if((K|0)<(X|0)){K=$}else{break}}}h[11762]=0.0;K=c[a>>2]|0;c[23464]=1;if((K|0)>=1){F=1;while(1){O=+h[11751]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[11762]=+h[11762]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[23464]=K+1;h[A>>3]=Pa}F=c[23554]|0;do{if((F|0)==0){if(!(+h[11773]==+h[11746])){break}O=+h[11781];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[23574]=0;break}L=c[b>>2]|0;c[23468]=1;if((L|0)>=1){J=o+((c[23526]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[23468]=L+1}h[11755]=0.0;$=c[a>>2]|0;c[23464]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[11749]=0.0;G=c[b>>2]|0;c[23468]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[11749]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[23468]=G+1;Sa=Ta}h[11755]=+h[11755]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[23464]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[11755]*100.0}J=c[23574]|0;c[23574]=J+1;if(+h[11762]<Ra){c[23574]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[23464]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[23464]=J+1}$=c[23474]|0;c[23470]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[23470]=$+1}c[23466]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[23468]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[23468]=Na+1;Ua=Wa}if((L|0)<(c[23488]|0)){h[J>>3]=-Ua}Va=L+1|0;c[23466]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[23468]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[23466]=Xa;c[23468]=L+1}c[23574]=0}}while(0);O=+h[11731];ea=+h[11776];if(O<ea){c[23526]=ca}oa=+h[11783];if(O<=ea+oa*+h[11784]|(F|0)>0){U=54;break}c[23512]=0;Ia=0;Ja=+h[11773];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[11731];oa=+h[11731];do{if((I|0)==1){h[11750]=oa;h[11760]=oa;c[23526]=1;Ya=1}else{if(!(oa<+h[11760])){Ya=I;break}h[11760]=oa;c[23526]=I;Ya=I}}while(0);F=c[23484]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[23494]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[23496]|0;Va=K+aa|0;c[23470]=Va;if(+h[11765]<0.0){aa=X+(c[a>>2]|0)|0;c[23494]=aa;Za=aa}else{Za=X}if(+h[11766]<0.0){X=K+(c[a>>2]|0)|0;c[23496]=X;_a=X}else{_a=K}K=fa(c[23508]|0,B)|0;h[t+(K-B<<3)>>3]=+h[11774];h[t+(Ya+C+K<<3)>>3]=+h[11774];h[t+(Za-B+K<<3)>>3]=-+h[11774];h[t+(_a-B+K<<3)>>3]=-+h[11774];h[q+(Va+ -1<<3)>>3]=(+h[11750]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[11731])/(+h[11765]*+h[11766])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[23508]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[11752]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[11752]/+h[e>>3];ea=+h[11775];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[11775];h[t+(X+K<<3)>>3]=+h[11775];K=(fa(Va+1|0,Va)|0)/2|0;c[23470]=K;ea=(+h[11750]- +h[11731])/+h[e>>3];h[11757]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[11752]*(+h[X>>3]+ +h[11757]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[11750])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[11743]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[11743]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[11752]*+h[11788]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[11746]=oa;h[11773]=oa;c[23488]=1;h[11768]=0.0;h[11769]=0.0;c[23574]=0;h[11793]=0.0;F=c[a>>2]|0;c[23464]=1;if((F|0)<1){U=53;break}ca=c[23526]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[11793]=+h[11793]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[23464]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[23556]=c[23472];U=54;continue}else if((U|0)==54){U=0;c[23512]=0;I=(c[23482]|0)+ -1|0;K=c[a>>2]|0;aB(a,b,l,n,p,q,r,94184,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,94320)|0;h[11745]=0.0;K=c[a>>2]|0;c[23464]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[11745]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[23464]=K+1;ab=cb}oa=+h[11773];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[11780]=O;ea=+h[11746];if(!(O<+h[11752]*ea)){db=ab;U=62;break}c[23512]=-1;O=+h[11783];N=O*oa;h[11773]=N;h[11781]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[11773]=ea;eb=ea}if((c[23472]|0)<=((c[23556]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[11790]*.125*ea;h[11757]=N;oa=+h[11768];ba=+h[11769];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[11770];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[11792]=O;I=c[b>>2]|0;c[23468]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[11749]=0.0;X=c[a>>2]|0;c[23466]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[11749]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[23466]=X+1;jb=lb}if(jb>ea){c[23512]=F;h[11792]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[23468]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[11781]>0.0){U=54;continue}ea=+h[11780];O=+h[11746];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[11752];h[11773]=O;ea=hb/+h[f>>3];h[11781]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[11746]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[11746]=na;ob=na;break}}else{na=+h[f>>3];h[11746]=na;ob=na}}while(0);h[11773]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){UR(94424)|0;CR()|0}UR(94448)|0;jR(94544,93968,8)|0;jR(94544,93888,4)|0;CR()|0;UR(94472)|0;jR(94544,94080,8)|0;ca=c[a>>2]|0;c[23464]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];jR(94544,y,8)|0;I=c[23464]|0;F=I+1|0;c[23464]=F;}while((I|0)<(ca|0))}CR()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[11752]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[11746];O=na>=ea?na:ea;h[11782]=O;ea=O*O;h[11745]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[11793];if(db<=ea*.001){h[11786]=ea*.25;ca=c[b>>2]|0;c[23468]=1;if((ca|0)>=1){F=1;while(1){h[11749]=0.0;I=c[a>>2]|0;c[23464]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[11749]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[23464]=I+1;pb=qb}h[11757]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[11752]*+h[11793];h[11749]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[23464]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[11757]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[11752]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[11749]*+h[n+(F+C+Va<<3)>>3]+ +h[11786]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[23476]=aa;c[23466]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[23466]=Va;rb=Va}c[23464]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[23468]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[23528]|0;c[23468]=1;if((F|0)>=1){ca=1;while(1){h[11767]=0.0;X=c[b>>2]|0;c[23464]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[11767]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[23464]=I;if((K|0)>=(X|0)){break b}O=+h[11767];K=I}}}while(0);X=c[a>>2]|0;c[23466]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[11786]*+h[11767]*+h[l+(I<<3)>>3];h[11749]=O;Va=c[b>>2]|0;c[23464]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[11749]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[23464]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[23488]|0)){h[11749]=-+h[11749]}L=c[b>>2]|0;c[23464]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[11749]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[23464]=L+1}J=K+1|0;c[23466]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[23464]=1;if((K|0)>=1){X=c[23488]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[23476]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[11757]=ub;c[23466]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[11757];aa=aa+1|0}aa=J+1|0;c[23466]=aa;vb=aa}c[23464]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[23468]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[23470]=0;ca=c[a>>2]|0;c[23466]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[23468]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[11752]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[23468]=aa+1}c[23464]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[23470]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[23464]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[23466]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[23466]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[23466]=J+1}h[11793]=0.0}if((c[23512]|0)>0){F=(c[23482]|0)+ -1|0;nA(a,b,l,n,s,t,93952,u,94048,94256,v,94176,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[23468]=1;if((F|0)>=1){L=1;while(1){h[11758]=0.0;h[11759]=0.0;h[11749]=0.0;ca=c[a>>2]|0;c[23466]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[11758]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[11759]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[11749]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[23466]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[11752]+Ab);h[w+(K<<3)>>3]=+h[11749];K=L+1|0;c[23468]=K;if((L|0)<(F|0)){L=K}else{break}}}h[11753]=0.0;L=c[23528]|0;c[23468]=1;if((L|0)>=1){F=1;while(1){h[11749]=0.0;J=c[b>>2]|0;c[23464]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[11749]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[23464]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[11753];if((F|0)<(c[23488]|0)){h[11753]=O+ea;na=-Eb;h[11749]=na;Gb=na}else{h[11753]=O-ea;Gb=Eb}K=c[b>>2]|0;c[23464]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[11749];X=X+1|0}c[23464]=K+1}X=F+1|0;c[23468]=X;if((F|0)<(L|0)){F=X}else{break}}}h[11761]=0.0;h[11740]=0.0;F=c[a>>2]|0;c[23466]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[11749]=0.0;X=c[b>>2]|0;c[23464]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[11749]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[23464]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[11761]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[23478]=K;Va=c[a>>2]|0;c[23468]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[11749]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[23468]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[11761]+ +h[11749]*+h[ca>>3];h[11761]=O;na=+h[11740]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[11740]=na;aa=L+1|0;c[23466]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[11745];h[11753]=+h[11753]+(Ib*Ib+ea*(Ib+(Ib+ +h[11793])+ea*+h[11752]))-Hb;L=w+((c[23526]|0)+ -1<<3)|0;h[L>>3]=+h[11743]+ +h[L>>3];L=c[23512]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[11743]+ +h[11772]*+h[11753]/(ea*ea);h[11757]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;mA(a,b,l,n,s,t,93952,u,94104,94048,v,x,w,94024,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[23464]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[23464]=L+1}F=c[23472]|0;aa=F+1|0;c[23472]=aa;if((F|0)>=(c[23582]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[23472]=T+ -1;if((c[g>>2]|0)<=0){break}UR(94352)|0;CR()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}UR(94400)|0;CR()|0}}while(0);Nb=+h[11760];if(Nb<=+h[11731]){U=c[a>>2]|0;c[23464]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[23464]=U+1;Ob=+h[11760]}h[11731]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}UR(94496)|0;jR(94544,93888,4)|0;CR()|0;UR(94520)|0;jR(94544,93848,8)|0;g=c[a>>2]|0;c[23464]=1;if((g|0)>=1){a=1;do{jR(94544,d+(a+ -1<<3)|0,8)|0;U=c[23464]|0;a=U+1|0;c[23464]=a;}while((U|0)<(g|0))}CR()|0;i=z;return 0}function YA(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){X1(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){X1(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function ZA(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+PA(94552);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+QA(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+QA(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+QA(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function _A(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function $A(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+PA(94560);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=k2(u|0,0,t+ -2|0,0)|0;t=d2(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function aB(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[11840]=.5;h[11858]=6.283185307179586;v=+h[l>>3];h[11853]=v*v;c[23702]=0;l=c[b>>2]|0;c[23720]=l;c[23718]=l;w=c[b>>2]|0;c[23642]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[23642]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[23642]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[23642]=w+1}z=c[d>>2]|0;c[23646]=1;if((z|0)>=1){e=1;while(1){h[11844]=0.0;A=c[b>>2]|0;c[23644]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[11844]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[23644]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[11844]=v;C=c[b>>2]|0;c[23642]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[11844];F=F+1|0}c[23642]=C+1}F=e+1|0;c[23646]=F;if((e|0)<(z|0)){e=F}else{break}}}c[23656]=0;e=c[b>>2]|0;c[23644]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[23656]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[23642]=H;c[23644]=e+1}do{if((y|0)==0){h[11842]=0.0;h[11824]=0.0;w=c[b>>2]|0;c[23642]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[11824]=+h[11824]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[23642]=w+1}h[r>>3]=0.0;D=+h[11824];if(D==0.0){O=55;break a}h[11829]=0.0;h[11832]=0.0;h[11827]=D;h[11847]=D;P=D;Q=0.0;R=0.0;S=+h[11853];T=0}else{if((y|0)>(x|0)){h[11826]=0.0;h[11833]=0.0;h[11834]=0.0;z=c[b>>2]|0;c[23642]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[11826]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[11833]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[11834]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[23642]=z+1;U=ba;W=$;Z=aa}D=+h[11840];v=D*(+h[11837]-Z);h[11825]=v;_=+h[11830];ca=_+v;h[11841]=ca;h[11845]=ca;h[11843]=ca;c[23712]=0;a[94648]=1;da=+h[11858]/50.0;h[11844]=da;c[23642]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[11843]=ka;c[23712]=w;h[11854]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[11855]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[11849]=ha;h[11835]=ia;h[11838]=ja;h[11846]=ka;c[23642]=50;h[11845]=ka;if((la|0)==0){h[11854]=ka;O=46}else if((la|0)==49){h[11855]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[11855]}h[11849]=0.0;ga=+h[11854];if(ga!=na){ea=ga-ma;h[11854]=ea;ga=na-ma;h[11855]=ga;oa=D*(ea-ga)/(ea+ga);h[11849]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[11849]=oa;ga=+X(+oa);h[11835]=ga;ea=+Y(+oa);h[11838]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[11850]=oa;h[11827]=0.0;w=c[b>>2]|0;c[23642]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[11835]*+h[J>>3]+ +h[11838]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[11827]+sa*sa;h[11827]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[11838];ea=+h[11835];F=F+1|0;z=K}c[23642]=w+1;qa=ta;ra=+h[11850]}ea=ra+ +h[11842];h[11842]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[11833]=0.0;z=c[b>>2]|0;c[23644]=1;do{if((z|0)<1){ea=+h[11857];h[11848]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[11833]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[23644]=z+1;ea=+h[11857];h[11848]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[11824];h[11844]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[11844]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[11848];oa=+h[11827];v=+h[11833];_=oa/v;ca=ea<=_?ea:_;h[11848]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[11827];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[11840]*Ca);h[11839]=ca;h[11842]=+h[11842]+ca;h[11852]=Ba;h[11827]=0.0;z=c[b>>2]|0;c[23642]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[11848]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[11827]+oa*oa;h[11827]=Ga;Ha=+h[11848];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[23642]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[11857]){if(+h[11839]<=+h[11842]*.01){O=55;break a}if(Fa<=+h[11847]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[11852];h[11844]=ca;h[11824]=0.0;h[11829]=0.0;h[11832]=0.0;w=c[b>>2]|0;c[23642]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[11824]+ca*ca;h[11824]=La;J=m+(F<<3)|0;Ma=+h[11829]+ +h[K>>3]*+h[J>>3];h[11829]=Ma;ca=+h[J>>3];Na=+h[11832]+ca*ca;h[11832]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[11844];Ja=Ja+1|0;Ka=J}c[23642]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[11853];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[23718]=y;ua=+h[11827];va=y}if(ua<=+h[11847]*1.0e-4){O=55;break a}h[11830]=0.0;h[11837]=0.0;z=c[b>>2]|0;c[23642]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[11830]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[11837]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[23642]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[11836]=ca;oa=+h[11853];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[23702]=J;_=+V(+(v-ca*ca));h[11844]=_;v=oa/_;h[11854]=v;oa=ca/_;h[11855]=oa;w=c[b>>2]|0;c[23642]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[11855];Ta=+h[11854];Ua=Ua+1|0;Va=K}c[23642]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[23702]=e;v=S-R;h[11844]=v;h[11857]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function bB(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[11867]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[23740]=t;c[23730]=1;c[23724]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[23730]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[11869]=D;C=+h[x>>3]/D;h[11876]=C;z=+h[f+(B+y<<3)>>3]/D;h[11877]=z;B=c[d>>2]|0;c[23722]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[11869]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[11869];if((x|0)>=(B|0)){break}D=+h[11877];z=+h[11876];x=x+1|0}c[23722]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[23724]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[11876]=z;if((c[g>>2]|0)>1){D=-z;h[11876]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[11877]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[23722]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[11877]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[11876];t=t+1|0;x=A}c[23722]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[11874]=z;x=k+(w<<3)|0;H=+h[x>>3];h[11868]=H;D=H*H;h[11878]=D;h[11875]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[11867];a[94968]=0;do{if((u|0)==1){z=+h[11875];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[11869]=z;D=+h[11876]/z;h[11877]=D;H=+h[11868]/z;h[11876]=H;x=c[d>>2]|0;c[23722]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[11877];D=+h[11876];w=w+1|0;t=s}c[23722]=x+1;J=+h[11869]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[23726]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[23726]=u;M=u}t=u+1-M|0;c[23728]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[11875];z=+h[f+(t+w<<3)>>3]/D;h[11869]=z;h[11876]=z*+h[l>>3];H=+h[11868];h[11877]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[11869]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[11867]/+V(+(+h[11878]+z*N*z));h[11872]=C;if(!(D>=0.0)){O=-D}else{O=D}h[11873]=C*+V(+O);t=c[d>>2]|0;c[23722]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[11873]*(+h[A>>3]- +h[11876]*+h[n+(G<<3)>>3]- +h[11877]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[11869];z=+h[11868];H=+h[11872];v=v+1|0}c[23722]=t+1;P=+h[11875]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[94968]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[23722]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[11869]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[11869];K=Q+1|0;c[23722]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[23724]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[23732]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[11868];N=+h[11875];J=(+h[11874]*+h[f>>3]-O*P)/N;h[11876]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[11877]=P;c[23722]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[23722]=q;if((f|0)>=(b|0)){break a}N=+h[11877];O=+h[11876];f=q}}}while(0);b=R+1|0;c[23724]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function cB(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function dB(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((cB(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(95032,95048,116,95072)}else if((s|0)==14){i=g;return o|0}return 0}function eB(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((P1(w,c[95080+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[95184+(x<<2)>>2]|0;c[q>>2]=c[95080+(x<<2)>>2];c[q+4>>2]=y;Gy(23,0,95256,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=r1(D,8)|0;c[e+40>>2]=B;D=b+536|0;Jy(c[D>>2]|0,(B|0)!=0|0,95296,p);B=r1(c[A>>2]|0,4)|0;c[e+36>>2]=B;Jy(c[D>>2]|0,(B|0)!=0|0,95296,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=r1(c[C>>2]|0,4)|0;c[e+24>>2]=p1(8)|0;C=p1(4)|0;c[e+20>>2]=C;c[C>>2]=c[67176>>2];Jy(c[D>>2]|0,(C|0)!=0|0,95296,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=p1(C)|0;A=e+44|0;c[A>>2]=p1(C)|0;C=r1(15,4)|0;E=e+12|0;c[E>>2]=C;Jy(c[D>>2]|0,(C|0)!=0|0,95296,m);C=r1(5,4)|0;c[e+4>>2]=C;Jy(c[D>>2]|0,(C|0)!=0|0,95296,l);C=r1(5,4)|0;c[e+8>>2]=C;Jy(c[D>>2]|0,(C|0)!=0|0,95296,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=p1(C)|0;c[e+76>>2]=p1(C)|0;c[e+80>>2]=p1(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((de[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){Gy(23,0,95312,j)}else{Gy(1,0,95384,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[67212>>2]|c[16778]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=95216;W=V;Ky(Q,W,r)}c[t>>2]=w;Iy(23,1,95112,t);t=1;do{w=c[95184+(t<<2)>>2]|0;c[s>>2]=c[95080+(t<<2)>>2];c[s+4>>2]=w;Iy(23,0,95168,s);t=t+1|0;}while((t|0)<8);ae[c[16918]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=95216;W=V;Ky(Q,W,r);return 0}function fB(a){a=a|0;var b=0;b=i;q1(c[a+40>>2]|0);q1(c[a+36>>2]|0);q1(c[a+20>>2]|0);q1(c[a+12>>2]|0);q1(c[a+4>>2]|0);q1(c[a+8>>2]|0);q1(a);i=b;return 0}function gB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;Jy(c[N>>2]|0,(c[M>>2]|0)!=0|0,95480,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){Gy(3,0,95512,B);Gy(3,0,95552,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];de[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Gy(3,0,95576,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];Gy(23,0,95616,y);if((c[z>>2]|0)==1){Nz(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){cD(a)|0;de[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 7:{pA(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 4:{pA(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 6:{pA(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 5:{pA(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 3:{pA(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){pA(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{pA(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){qd(_|0)|0;qd($|0)|0;Iy(3,0,95648,x);Gy(3,0,95736,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){qd(_|0)|0;qd($|0)|0;$=pB(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){cD(a)|0;de[c[(c[ba>>2]|0)+40>>2]&127](a)|0}de[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Iy(1,0,95760,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[67132>>2]|0)!=0){Gy(3,1,95792,u);c[s>>2]=c[z>>2];Gy(3,0,95816,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Gy(3,0,95840,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Gy(3,0,95872,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Gy(3,0,95912,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Gy(3,0,95960,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];Gy(3,0,96008,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];Gy(3,0,96048,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];Gy(3,0,96088,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];Gy(3,0,96128,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];Gy(3,0,96176,f);ae[c[16918]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(96216,96248,410,96280)}Gy(3,0,96296,e);S=0;i=d;return S|0}function hB(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;cD(g)|0;a=f+540|0;de[c[(c[a>>2]|0)+40>>2]&127](g)|0;de[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function iB(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;cD(l)|0;b=k+540|0;de[c[(c[b>>2]|0)+40>>2]&127](l)|0;de[c[(c[b>>2]|0)+28>>2]&127](l)|0;rB(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function jB(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];cD(g)|0;l=e+540|0;de[c[(c[l>>2]|0)+40>>2]&127](g)|0;de[c[(c[l>>2]|0)+28>>2]&127](g)|0;de[c[(c[l>>2]|0)+32>>2]&127](g)|0;ge[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function kB(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;sB(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function lB(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;cD(l)|0;b=k+540|0;de[c[(c[b>>2]|0)+40>>2]&127](l)|0;de[c[(c[b>>2]|0)+28>>2]&127](l)|0;qB(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function mB(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function nB(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;tB(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function oB(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function pB(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-3:{m=-3;i=b;return m|0};case-9:{Iy(1,0,96520,f);m=-9;i=b;return m|0};case-11:{Iy(1,0,96704,d);m=-11;i=b;return m|0};case-12:{Iy(1,0,96792,c);m=-12;i=b;return m|0};case-1:{Iy(3,0,95648,l);m=1;i=b;return m|0};case-6:{Iy(1,0,96360,j);m=-6;i=b;return m|0};case-10:{Iy(1,0,96608,e);m=-10;i=b;return m|0};case-2:{Iy(1,0,96320,k);m=-2;i=b;return m|0};case-8:{Iy(1,0,96472,g);m=-8;i=b;return m|0};case-7:{Iy(1,0,96432,h);m=-7;i=b;return m|0};case-33:{Iy(1,0,96840,b);m=-33;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function qB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}de[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function rB(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;de[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function sB(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+pd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+pd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;hB(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}



function Xl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+192>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+192|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+192>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+464>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+464|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+464>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+344>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+344|0;h[(c[j+48>>2]|0)+16>>3]=+h[e>>3];k=+wC(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+344>>3]);g=c[f>>2]|0;h[(c[g+52>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+44>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+312>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+312|0;h[(c[g+48>>2]|0)+24>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+312>>3]);e=c[f>>2]|0;h[(c[e+52>>2]|0)+24>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+32>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+888>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+888|0;h[(c[e+48>>2]|0)+32>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+888>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+32>>3]=k;uC(a,0)|0;j=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+192>>3]=+h[j>>3];h[f+464>>3]=+h[j+8>>3];h[f+344>>3]=+h[j+16>>3];h[f+312>>3]=+h[j+24>>3];h[f+888>>3]=+h[j+32>>3];wi(a);xi(a);yi(a);zi(a);Ai(a);Bi(a);Ci(a);Di(a);Ei(a);Fi(a);Gi(a);Hi(a);Ii(a);Ji(a);i=b;return}function Yl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+11|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+11|0]|0;k=XB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+712>>3],a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;f=j;break}else{j=XB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+712>>3],a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+11|0]|0;j=$B(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+712>>3])|0;a[(c[b+352>>2]|0)+11|0]=j;f=g;break}else{g=$B(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+712>>3])|0;a[(c[b+352>>2]|0)+11|0]=g;f=g;break}}}}while(0);do{if((a[e]|0)==0){l=a[(c[b+356>>2]|0)+12|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+12|0]|0;k=YB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+704>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;l=j;break}else{j=YB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+704>>3],a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=j;l=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+12|0]|0;j=aC(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+704>>3])|0;a[(c[b+352>>2]|0)+12|0]=j;l=g;break}else{g=aC(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[b+416>>2]|0)+704>>3])|0;a[(c[b+352>>2]|0)+12|0]=g;l=g;break}}}}while(0);if(!(f<<24>>24==0)){m=1;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+16|0;u=t;v=c[u>>2]|0;w=v;x=w+10|0;y=x;a[y]=m;i=d;return}if((a[(c[b+408>>2]|0)+10|0]|0)==0){m=0;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+16|0;u=t;v=c[u>>2]|0;w=v;x=w+10|0;y=x;a[y]=m;i=d;return}m=l<<24>>24!=0|0;n=b;o=n+4|0;p=o;q=c[p>>2]|0;r=c[q>>2]|0;s=r;t=s+16|0;u=t;v=c[u>>2]|0;w=v;x=w+10|0;y=x;a[y]=m;i=d;return}function Zl(b){b=b|0;var d=0,e=0;d=c[c[b+4>>2]>>2]|0;e=c[b+416>>2]|0;h[(c[d+8>>2]|0)+896>>3]=+h[((a[(c[d+16>>2]|0)+10|0]|0)==0?e+728|0:e+720|0)>>3];i=i;return}function _l(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+456>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+456|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+456>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+960>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+960|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+960>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+8>>3]=k;uC(a,1)|0;j=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+456>>3]=+h[j>>3];h[f+960>>3]=+h[j+8>>3];Mi(a);Ni(a);Oi(a);i=b;return}function $l(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=$B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+896>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+600>>3]=+h[e+896>>3]*+h[(a<<24>>24==0?e+16|0:e+952|0)>>3];i=b;return}function am(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+896>>3],0.0)|0;m=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+896>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;ii(g,c[n>>2]|0,+h[o+480>>3],+h[(m<<24>>24==0?o+16|0:o+952|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+480>>3];s=+h[(l<<24>>24==0?q+16|0:q+952|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));ri(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+688>>3];r=+h[p+896>>3];if(s!=0.0){t=p;u=r/s;v=t;w=v+552|0;x=w;h[x>>3]=u;i=d;return}if(r==0.0){t=p;u=r;v=t;w=v+552|0;x=w;h[x>>3]=u;i=d;return}y=r/+My(c[n>>2]|0,s,21480,21472,+h[e>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[k>>2]>>2]|0)+8>>2]|0;u=y;v=t;w=v+552|0;x=w;h[x>>3]=u;i=d;return}function bm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+552>>3];e=c[a+416>>2]|0;h[b+528>>3]=+h[b+896>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+8>>3]);i=i;return}function cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+912>>3]=+h[b+960>>3]*1.0e-5;i=i;return}function dm(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Ih(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+960>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+920>>3]=+h[d>>3];i=b;return}function em(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+4|0;Wh(k,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+14|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+14|0]|0;g=WB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=g;v=t;break}else{t=WB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+14|0]|0;t=ZB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u)|0;a[(c[b+352>>2]|0)+14|0]=t;v=f;break}else{f=ZB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u)|0;a[(c[b+352>>2]|0)+14|0]=f;v=f;break}}}}while(0);Yh(m,c[p>>2]|0,+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+15|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+15|0]|0;m=XB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=m;w=e;break}else{e=XB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+15|0]|0;e=$B(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u)|0;a[(c[b+352>>2]|0)+15|0]=e;w=n;break}else{n=$B(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+952>>3],u)|0;a[(c[b+352>>2]|0)+15|0]=n;w=n;break}}}}while(0);do{if((a[l]|0)==0){x=a[(c[b+356>>2]|0)+16|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+16|0]|0;m=XB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=m;x=e;break}else{e=XB(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=e;x=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+16|0]|0;e=$B(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+16|0]=e;x=n;break}else{n=$B(+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3)|0;a[(c[b+352>>2]|0)+16|0]=n;x=n;break}}}}while(0);if(!((w|v)<<24>>24==0)){y=1;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+20|0;H=G;c[H>>2]=y;i=d;return}y=x<<24>>24!=0?1:2;z=c[q>>2]|0;A=c[z>>2]|0;B=A;C=B+12|0;D=C;E=c[D>>2]|0;F=E;G=F+20|0;H=G;c[H>>2]=y;i=d;return}function fm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;ii(e,c[g>>2]|0,+h[k+960>>3],+h[k+952>>3],c[(c[a+12>>2]|0)+20>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+960>>3];m=+h[g+952>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));ni(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+936>>3]=+h[f>>3];i=b;return}function gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+904>>3]=+h[b+936>>3]+-273.15;i=i;return}function hm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[c[j>>2]>>2]|0;k=c[a+8>>2]|0;ii(e,c[g>>2]|0,+h[k+960>>3],+h[k+952>>3],c[(c[a+12>>2]|0)+20>>2]|0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;l=+h[g+960>>3];m=+h[g+952>>3];g=d+0|0;k=e+0|0;e=g+120|0;do{c[g>>2]=c[k>>2];g=g+4|0;k=k+4|0}while((g|0)<(e|0));ri(f,a,l,m,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+944>>3]=+h[f>>3];i=b;return}function im(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+952>>3];k=+h[g+944>>3];l=+h[g+960>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+928|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+928|0;r=q;h[r>>3]=o;i=d;return}s=l/+My(c[b+536>>2]|0,k,21880,21872,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+928|0;r=q;h[r>>3]=o;i=d;return}function jm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=$B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+288>>3]=+h[e+344>>3]*+h[(a<<24>>24==0?e:e+872|0)>>3];i=b;return}function km(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;m=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;ii(g,c[n>>2]|0,+h[o+208>>3],+h[(m<<24>>24==0?o:o+872|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+208>>3];s=+h[(l<<24>>24==0?q:q+872|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));ri(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+664>>3];r=+h[p+344>>3];if(s!=0.0){t=p;u=r/s;v=t;w=v+256|0;x=w;h[x>>3]=u;i=d;return}if(r==0.0){t=p;u=r;v=t;w=v+256|0;x=w;h[x>>3]=u;i=d;return}y=r/+My(c[n>>2]|0,s,21912,21904,+h[e>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[k>>2]>>2]|0)+8>>2]|0;u=y;v=t;w=v+256|0;x=w;h[x>>3]=u;i=d;return}function lm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+256>>3];e=c[a+416>>2]|0;h[b+240>>3]=+h[b+344>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+120>>3]);i=i;return}function mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=+h[b+344>>3]*+h[(c[a+416>>2]|0)+408>>3];i=i;return}function nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+456>>3]*+h[j+424>>3]*+h[e+400>>3];l=+h[j+344>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}r=l/+My(c[b+536>>2]|0,k,22312,22304,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}function om(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;d=i;e=b+4|0;f=$B(-+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=-+h[j+344>>3];do{if(f<<24>>24==0){l=j;m=+h[j+16>>3]}else{n=+pd(+k,1.0e-15);o=n+1.0e-15;p=n*+h[j+880>>3]+8.40130581525969e-11;if(o!=0.0){l=j;m=p/o;break}if(p==0.0){l=j;m=p;break}n=p/+My(c[b+536>>2]|0,o,22384,22376,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+608>>3]=m*k;i=d;return}function pm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0,B=0,C=0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=f;l=b+4|0;m=$B(-+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;n=$B(-+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0;o=b+536|0;p=c[o>>2]|0;q=c[c[l>>2]>>2]|0;r=c[q+8>>2]|0;s=+h[r+488>>3];do{if(n<<24>>24==0){t=+h[r+16>>3]}else{u=+pd(+-+h[r+344>>3],1.0e-15);v=u+1.0e-15;w=u*+h[r+880>>3]+8.40130581525969e-11;if(v!=0.0){t=w/v;break}if(w==0.0){t=w;break}t=w/+My(p,v,22384,22432,+h[q>>3],(a[b+319|0]|0)!=0|0)}}while(0);ii(g,p,s,t,0,0);p=k+0|0;k=g+0|0;g=p+120|0;do{c[p>>2]=c[k>>2];p=p+4|0;k=k+4|0}while((p|0)<(g|0));q=c[o>>2]|0;r=c[c[l>>2]>>2]|0;n=c[r+8>>2]|0;t=+h[n+488>>3];do{if(m<<24>>24==0){x=+h[n+16>>3]}else{s=+pd(+-+h[n+344>>3],1.0e-15);v=s+1.0e-15;w=s*+h[n+880>>3]+8.40130581525969e-11;if(v!=0.0){x=w/v;break}if(w==0.0){x=w;break}x=w/+My(q,v,22384,22432,+h[r>>3],(a[b+319|0]|0)!=0|0)}}while(0);p=e+0|0;k=f+0|0;g=p+120|0;do{c[p>>2]=c[k>>2];p=p+4|0;k=k+4|0}while((p|0)<(g|0));ri(j,q,t,x,e);e=c[c[l>>2]>>2]|0;q=c[e+8>>2]|0;x=+h[j>>3]*+h[q+696>>3];t=+h[q+344>>3];v=-t;if(x!=0.0){y=q;z=v/x;A=y;B=A+560|0;C=B;h[C>>3]=z;i=d;return}if(t==-0.0){y=q;z=v;A=y;B=A+560|0;C=B;h[C>>3]=z;i=d;return}t=v/+My(c[o>>2]|0,x,22440,22432,+h[e>>3],(a[b+319|0]|0)!=0|0);y=c[(c[c[l>>2]>>2]|0)+8>>2]|0;z=t;A=y;B=A+560|0;C=B;h[C>>3]=z;i=d;return}function qm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+560>>3];e=c[a+416>>2]|0;h[b+536>>3]=-(+h[b+344>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+40>>3]));i=i;return}function rm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=($B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+416>>3]=+h[(a?e+432|0:e+424|0)>>3];i=b;return}function sm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+456>>3]*+h[j+432>>3]*+h[e+400>>3];l=+h[j+344>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}r=l/+My(c[b+536>>2]|0,k,23096,23088,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}function tm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=($B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+392>>3]=+h[(a?e+408|0:e+400|0)>>3];i=b;return}function um(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+64>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]+(g*-.1- +h[f+72>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+520>>3]=+h[d>>3];i=b;return}function vm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+4|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+72>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+72>>3],a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+4|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+72>>3])|0;a[(c[b+352>>2]|0)+4|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+72>>3])|0;a[(c[b+352>>2]|0)+4|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+9|0]=f;i=d;return}function wm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+472>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+472|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+472>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+200>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+200|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+200>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+304>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+304|0;h[(c[j+208>>2]|0)+16>>3]=+h[e>>3];k=+wC(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+304>>3]);g=c[f>>2]|0;h[(c[g+212>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+204>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+792>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+792|0;h[(c[g+208>>2]|0)+24>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+792>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+24>>3]=k;uC(a,2)|0;e=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+472>>3]=+h[e>>3];h[f+200>>3]=+h[e+8>>3];h[f+304>>3]=+h[e+16>>3];h[f+792>>3]=+h[e+24>>3];Ri(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);Yi(a);Zi(a);_i(a);$i(a);i=b;return}function xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=+h[b+88>>3]*+h[(c[a+416>>2]|0)+744>>3];i=i;return}function ym(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=$B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+296>>3]=+h[e+88>>3]*+h[(a<<24>>24==0?e:e+776|0)>>3];i=b;return}function zm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0,w=0,x=0,y=0.0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;m=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;ii(g,c[n>>2]|0,+h[o+216>>3],+h[(m<<24>>24==0?o:o+776|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+216>>3];s=+h[(l<<24>>24==0?q:q+776|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));ri(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+672>>3];r=+h[p+88>>3];if(s!=0.0){t=p;u=r/s;v=t;w=v+264|0;x=w;h[x>>3]=u;i=d;return}if(r==0.0){t=p;u=r;v=t;w=v+264|0;x=w;h[x>>3]=u;i=d;return}y=r/+My(c[n>>2]|0,s,23168,23160,+h[e>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[k>>2]>>2]|0)+8>>2]|0;u=y;v=t;w=v+264|0;x=w;h[x>>3]=u;i=d;return}function Am(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+264>>3];e=c[a+416>>2]|0;h[b+248>>3]=+h[b+88>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+152>>3]);i=i;return}function Bm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+840>>3]=+h[b+288>>3]+(+h[b+296>>3]+(+h[b+240>>3]+ +h[b+248>>3]));i=i;return}function Cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+848>>3]=+h[b+344>>3]+ +h[b+88>>3];i=i;return}function Dm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+32>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+32|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+32>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1048>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1048|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1048>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+8>>3]=k;uC(a,3)|0;j=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+32>>3]=+h[j>>3];h[f+1048>>3]=+h[j+8>>3];cj(a);dj(a);ej(a);fj(a);i=b;return}function Em(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+624>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1048>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}q=k/+My(c[b+536>>2]|0,e,23584,23576,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+40|0;p=o;h[p>>3]=m;i=d;return}function Fm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=$B(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+616>>3]=-(+h[e+88>>3]*+h[(a<<24>>24==0?e+16|0:e+784|0)>>3]);i=b;return}function Gm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0,x=0,y=0;d=i;i=i+368|0;e=d;f=d+120|0;g=d+240|0;j=d+360|0;k=b+4|0;l=$B(-+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;m=$B(-+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0;n=b+536|0;o=c[(c[c[k>>2]>>2]|0)+8>>2]|0;ii(g,c[n>>2]|0,+h[o+496>>3],+h[(m<<24>>24==0?o+16|0:o+784|0)>>3],0,0);o=f+0|0;m=g+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));p=c[n>>2]|0;q=c[(c[c[k>>2]>>2]|0)+8>>2]|0;r=+h[q+496>>3];s=+h[(l<<24>>24==0?q+16|0:q+784|0)>>3];o=e+0|0;m=f+0|0;g=o+120|0;do{c[o>>2]=c[m>>2];o=o+4|0;m=m+4|0}while((o|0)<(g|0));ri(j,p,r,s,e);e=c[c[k>>2]>>2]|0;p=c[e+8>>2]|0;s=+h[j>>3]*+h[p+704>>3];r=+h[p+88>>3];t=-r;if(s!=0.0){u=p;v=t/s;w=u;x=w+568|0;y=x;h[y>>3]=v;i=d;return}if(r==-0.0){u=p;v=t;w=u;x=w+568|0;y=x;h[y>>3]=v;i=d;return}r=t/+My(c[n>>2]|0,s,23616,23608,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[k>>2]>>2]|0)+8>>2]|0;v=r;w=u;x=w+568|0;y=x;h[y>>3]=v;i=d;return}function Hm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+568>>3];e=c[a+416>>2]|0;h[b+544>>3]=-(+h[b+88>>3]*(d*d*.5+ +h[e+336>>3]*+h[e+72>>3]));i=i;return}function Im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+600>>3]+(+h[b+608>>3]+(+h[b+616>>3]+(+h[b+528>>3]+(+h[b+536>>3]+ +h[b+544>>3]))));i=i;return}function Jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+896>>3]+(-+h[b+344>>3]- +h[b+88>>3]);i=i;return}function Km(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+792>>3]*+h[j+168>>3]*+h[e+736>>3];l=+h[j+88>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}r=l/+My(c[b+536>>2]|0,k,24040,24032,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+104|0;q=p;h[q>>3]=n;i=d;return}function Lm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=($B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+128>>3]=+h[(a?e+144|0:e+136|0)>>3];i=b;return}function Mm(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=($B(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+88>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+152>>3]=+h[(a?e+168|0:e+160|0)>>3];i=b;return}function Nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+792>>3]*+h[j+160>>3]*+h[e+736>>3];l=+h[j+88>>3];if(k!=0.0){m=j;n=l/k;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=j;n=l;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}r=l/+My(c[b+536>>2]|0,k,24120,24112,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+96|0;q=p;h[q>>3]=n;i=d;return}function Om(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[(c[a+416>>2]|0)+224>>3]*+h[b+24>>3];i=i;return}function Pm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=+h[b+992>>3]*+h[b+984>>3];i=i;return}function Qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1032>>3]=+h[b+1024>>3]*+h[b+976>>3];i=i;return}function Rm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+48>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+48|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+wC(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+48>>3]);e=c[f>>2]|0;h[c[e+372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1040>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1040|0;h[(c[e+368>>2]|0)+8>>3]=+h[g>>3];k=+wC(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1040>>3]);h[(c[(c[f>>2]|0)+372>>2]|0)+8>>3]=k;uC(a,4)|0;j=c[(c[f>>2]|0)+364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+48>>3]=+h[j>>3];h[f+1040>>3]=+h[j+8>>3];ij(a);jj(a);kj(a);lj(a);i=b;return}function Sm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+224>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1040>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}q=k/+My(c[b+536>>2]|0,e,24200,24192,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+56|0;p=o;h[p>>3]=m;i=d;return}function Tm(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+92>>2]=(c[b+88>>2]|0)+ -1;i=i;return}function Um(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+320>>3];i=i;return}function Vm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+384>>3];i=i;return}function Wm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+440>>3];i=i;return}function Xm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+472>>3];i=i;return}function Ym(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+440>>3];i=i;return}function Zm(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+776>>3]=+h[b+384>>3];i=i;return}function _m(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+776>>3];i=i;return}function $m(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+808>>3];i=i;return}function an(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+776>>3];i=i;return}function bn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+696>>3]=+h[b+328>>3];i=i;return}function cn(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+37|0]=a[d+32|0]|0;i=i;return}function dn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+640>>3]=+h[b+328>>3];i=i;return}function en(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+376>>3]*100.0;i=i;return}function fn(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+56>>2]=(c[b+52>>2]|0)+ -1;i=i;return}function gn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+376>>3]*100.0;i=i;return}function hn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+296>>3]=+h[b+328>>3];i=i;return}function jn(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+7|0]=a[d+2|0]|0;i=i;return}function kn(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+328>>3];i=i;return}function ln(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+200>>3]=+h[b+376>>3]*100.0;i=i;return}function mn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+768>>3]=0.0;i=i;return}function nn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+760>>3]=0.0;i=i;return}function on(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=0.0;i=i;return}function pn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function qn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function rn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=0.0;i=i;return}function sn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=0;i=i;return}function tn(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function un(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1216>>3]=84013.05815259689;i=i;return}function vn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1208>>3]=0.0;i=i;return}function wn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1200>>3]=293.15;i=i;return}function xn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+648>>3]=1.0;i=i;return}function yn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1144>>3]=461.5236365065454;i=i;return}function zn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1136>>3]=.018015268;i=i;return}function An(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+640>>3]=1.0;i=i;return}function Bn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+632>>3]=1.0;i=i;return}function Cn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1128>>3]=461.5236365065454;i=i;return}function Dn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1120>>3]=.018015268;i=i;return}function En(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+624>>3]=1.0;i=i;return}function Fn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1112>>3]=461.5236365065454;i=i;return}function Gn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=.018015268;i=i;return}function Hn(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);a[d]=0;i=c;return 0}function In(a){a=a|0;i=i;return}function Jn(a){a=a|0;i=i;return 0}function Kn(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0;d=i;e=(c[(c[b+420>>2]|0)+88>>2]|0)+ -1|0;f=+(e|0);g=c[b+416>>2]|0;j=+h[g+832>>3]- +h[g+840>>3];do{if((e|0)==0){if(j==0.0){k=j;break}k=j/+My(c[b+536>>2]|0,f,24232,24224,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}else{k=j/f}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+64>>3]=k;i=d;return}function Ln(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+176>>3]=+h[(c[a+416>>2]|0)+584>>3];i=i;return}function Mn(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+592>>3];i=i;return}function Nn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+200>>3]=+h[(c[a+416>>2]|0)+648>>3];i=i;return}function On(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+192>>3]=+h[(c[a+416>>2]|0)+648>>3];i=i;return}function Pn(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0.0,k=0.0;d=i;e=(c[(c[b+420>>2]|0)+52>>2]|0)+ -1|0;f=+(e|0);g=c[b+416>>2]|0;j=+h[g+496>>3]- +h[g+504>>3];do{if((e|0)==0){if(j==0.0){k=j;break}k=j/+My(c[b+536>>2]|0,f,24280,24272,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}else{k=j/f}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+320>>3]=k;i=d;return}function Qn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+440>>3]=+h[(c[a+416>>2]|0)+184>>3];i=i;return}function Rn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+192>>3];i=i;return}function Sn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+472>>3]=+h[(c[a+416>>2]|0)+248>>3];i=i;return}function Tn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+464>>3]=+h[(c[a+416>>2]|0)+248>>3];i=i;return}function Un(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+456>>3]=+h[(c[a+416>>2]|0)+248>>3];i=i;return}function Vn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;Gy(9,1,24312,u);if((c[67156>>2]|0)!=0){ae[c[16918]&255](9)}Gy(9,1,24336,t);if((c[67156>>2]|0)!=0){ae[c[16918]&255](9)}Gy(9,1,24360,s);if((c[67156>>2]|0)!=0){ae[c[16918]&255](9)}Kn(a);Ln(a);Mn(a);Nn(a);On(a);Pn(a);Qn(a);Rn(a);Sn(a);Tn(a);Un(a);Gy(9,1,24384,r);r=a+4|0;v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+64>>3];s=a+8|0;a=c[s>>2]|0;h[a+992>>3]=v;c[q>>2]=c[a+900>>2];a=q+4|0;h[k>>3]=v;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];Gy(9,0,24408,q);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+176>>3];q=c[s>>2]|0;h[q+2560>>3]=v;c[p>>2]=c[q+2468>>2];q=p+4|0;h[k>>3]=v;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Gy(9,0,24408,p);v=+h[c[(c[c[r>>2]>>2]|0)+8>>2]>>3];p=c[s>>2]|0;h[p+96>>3]=v;c[o>>2]=c[p+4>>2];p=o+4|0;h[k>>3]=v;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Gy(9,0,24408,o);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+200>>3];o=c[s>>2]|0;h[o+2896>>3]=v;c[n>>2]=c[o+2804>>2];o=n+4|0;h[k>>3]=v;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Gy(9,0,24408,n);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+192>>3];n=c[s>>2]|0;h[n+2784>>3]=v;c[m>>2]=c[n+2692>>2];n=m+4|0;h[k>>3]=v;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Gy(9,0,24408,m);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+320>>3];m=c[s>>2]|0;h[m+4576>>3]=v;c[l>>2]=c[m+4484>>2];m=l+4|0;h[k>>3]=v;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Gy(9,0,24408,l);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+440>>3];l=c[s>>2]|0;h[l+6256>>3]=v;c[j>>2]=c[l+6164>>2];l=j+4|0;h[k>>3]=v;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Gy(9,0,24408,j);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+16>>3];j=c[s>>2]|0;h[j+320>>3]=v;c[g>>2]=c[j+228>>2];j=g+4|0;h[k>>3]=v;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Gy(9,0,24408,g);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+472>>3];g=c[s>>2]|0;h[g+6704>>3]=v;c[f>>2]=c[g+6612>>2];g=f+4|0;h[k>>3]=v;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Gy(9,0,24408,f);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+464>>3];f=c[s>>2]|0;h[f+6592>>3]=v;c[e>>2]=c[f+6500>>2];f=e+4|0;h[k>>3]=v;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];Gy(9,0,24408,e);v=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+456>>3];r=c[s>>2]|0;h[r+6480>>3]=v;c[d>>2]=c[r+6388>>2];r=d+4|0;h[k>>3]=v;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(9,0,24408,d);if((c[67156>>2]|0)==0){i=b;return 0}ae[c[16918]&255](9);i=b;return 0}function Wn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=.018015268;i=i;return}function Xn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1112>>3]=461.5236365065454;i=i;return}function Yn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+624>>3]=1.0;i=i;return}function Zn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1120>>3]=.018015268;i=i;return}function _n(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1128>>3]=461.5236365065454;i=i;return}function $n(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+632>>3]=1.0;i=i;return}function ao(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+640>>3]=1.0;i=i;return}function bo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1136>>3]=.018015268;i=i;return}function co(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1144>>3]=461.5236365065454;i=i;return}function eo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+648>>3]=1.0;i=i;return}function fo(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+144>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+672>>3]=b*b*.7853981633974483;i=i;return}function go(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+112>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+664>>3]=b*b*.7853981633974483;i=i;return}function ho(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+64>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+704>>3]=b*b*.7853981633974483;i=i;return}function io(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+32>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+696>>3]=b*b*.7853981633974483;i=i;return}function jo(a){a=a|0;var b=0.0;b=+h[c[a+416>>2]>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+688>>3]=b*b*.7853981633974483;i=i;return}function ko(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1200>>3]=293.15;i=i;return}function lo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1208>>3]=0.0;i=i;return}function mo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1216>>3]=84013.05815259689;i=i;return}function no(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function oo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=0;i=i;return}function po(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=0.0;i=i;return}function qo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function ro(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function so(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=0.0;i=i;return}function to(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+760>>3]=0.0;i=i;return}function uo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+768>>3]=0.0;i=i;return}function vo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+200>>3]=+h[b+376>>3]*100.0;i=i;return}function wo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+208>>3]=+h[b+376>>3];i=i;return}function xo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+232>>3]=+h[b+320>>3];i=i;return}function yo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=+h[(c[a+416>>2]|0)+232>>3]*1.0e-5;i=i;return}function zo(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Ih(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+232>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1176>>3]=+h[d>>3];i=b;return}function Ao(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+240>>3]=+h[b+328>>3];i=i;return}function Bo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+216>>3];i=i;return}function Co(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+224>>3];i=i;return}function Do(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+272>>3]=+h[b+232>>3];i=i;return}function Eo(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+7|0]=a[d+2|0]|0;i=i;return}function Fo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+296>>3]=+h[b+328>>3];i=i;return}function Go(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+352>>3]=+h[b+376>>3]*100.0;i=i;return}function Ho(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+384>>3]=+h[b+320>>3];i=i;return}function Io(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+328>>3];i=i;return}function Jo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+184>>3]=+h[b+392>>3];i=i;return}function Ko(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;Ez(e,1,+h[(c[g>>2]|0)+96>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+272>>3];l=+h[a+184>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];mh(f,j,k,l,d,0);h[(c[g>>2]|0)+192>>3]=+h[f>>3];i=b;return}function Lo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+384>>3];i=i;return}function Mo(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+416>>3];h[b+456>>3]=d*d*.7853981633974483;i=i;return}function No(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+416>>3]*3.141592653589793;i=i;return}function Oo(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+464>>3];g=+h[e+456>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+My(c[b+536>>2]|0,f,24432,24424,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+720>>3]=j*4.0;i=d;return}function Po(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+464>>3];g=+h[e+456>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+My(c[b+536>>2]|0,f,24432,24448,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+712>>3]=j*4.0;i=d;return}function Qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=(+h[b+712>>3]+ +h[b+720>>3])*.5;i=i;return}function Ro(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+472>>3]=+h[b+440>>3];i=i;return}function So(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+400>>3];i=i;return}function To(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+440>>3];i=i;return}function Uo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+472>>3];i=i;return}function Vo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+536>>3]=+h[b+376>>3];i=i;return}function Wo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+536>>3]*100.0;i=i;return}function Xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+488>>3];m=+h[k+528>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+My(g,l,24464,24456,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+488>>3];o=r;p=q}}while(0);l=+h[o+568>>3];m=+h[o+576>>3];q=+h[o+408>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+680>>3];t=+h[o+424>>3];u=(t+t)*.5;t=+h[o+536>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+My(c[f>>2]|0,n,24464,24456,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);Zg(e,g,p,l,l,m,m,q,s,u,w,+h[v+512>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3]=+h[e>>3];i=d;return}function Yo(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+56>>2]=(c[b+52>>2]|0)+ -1;i=i;return}function Zo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+552>>3]=+h[b+336>>3];i=i;return}function _o(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+392>>3];i=i;return}function $o(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+600>>3]=+h[b+376>>3]*100.0;i=i;return}function ap(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+376>>3];i=i;return}function bp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+320>>3];i=i;return}function cp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1184>>3]=+h[(c[a+416>>2]|0)+632>>3]*1.0e-5;i=i;return}function dp(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Ih(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+632>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=+h[d>>3];i=b;return}function ep(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+640>>3]=+h[b+328>>3];i=i;return}function fp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+616>>3];i=i;return}function gp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+624>>3];i=i;return}function hp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+672>>3]=+h[b+632>>3];i=i;return}function ip(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;Ez(e,1,+h[(c[g>>2]|0)+176>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+672>>3];l=+h[a+584>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];mh(f,j,k,l,d,0);h[(c[g>>2]|0)+592>>3]=+h[f>>3];i=b;return}function jp(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+37|0]=a[d+32|0]|0;i=i;return}function kp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+696>>3]=+h[b+328>>3];i=i;return}function lp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+776>>3]=+h[b+384>>3];i=i;return}function mp(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+752>>3];h[b+792>>3]=d*d*.7853981633974483;i=i;return}function np(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+752>>3]*3.141592653589793;i=i;return}function op(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+800>>3];g=+h[e+792>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+My(c[b+536>>2]|0,f,24504,24496,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+744>>3]=j*4.0;i=d;return}function pp(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+800>>3];g=+h[e+792>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+My(c[b+536>>2]|0,f,24504,24528,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+736>>3]=j*4.0;i=d;return}function qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+656>>3]=(+h[b+736>>3]+ +h[b+744>>3])*.5;i=i;return}function rp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+776>>3];i=i;return}function sp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+736>>3];i=i;return}function tp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+776>>3];i=i;return}function up(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+808>>3];i=i;return}function vp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+376>>3];i=i;return}function wp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+872>>3]*100.0;i=i;return}function xp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+824>>3];m=+h[k+864>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+My(g,l,24544,24536,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+824>>3];o=r;p=q}}while(0);l=+h[o+904>>3];m=+h[o+912>>3];q=+h[o+744>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+656>>3];t=+h[o+760>>3];u=(t+t)*.5;t=+h[o+872>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+My(c[f>>2]|0,n,24544,24536,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);Zg(e,g,p,l,l,m,m,q,s,u,w,+h[v+848>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1160>>3]=+h[e>>3];i=d;return}function yp(a){a=a|0;var b=0;b=c[a+420>>2]|0;c[b+92>>2]=(c[b+88>>2]|0)+ -1;i=i;return}function zp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+336>>3];i=i;return}function Ap(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24576]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(24592,fz(+h[(c[g>>2]|0)+912>>3],24584)|0)|0;g=c[28996]|0;j=e;k=30712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24576]=1;i=d;return}function Bp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24784]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(24792,fz(+h[(c[g>>2]|0)+904>>3],24584)|0)|0;g=c[28996]|0;j=e;k=30856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24784]=1;i=d;return}function Cp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24912]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+896>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+896>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(24920,fz(+h[(c[g>>2]|0)+896>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[24912]=1;i=d;return}function Dp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25096]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+96>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(25112,hz(c[(c[g>>2]|0)+96>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=31336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[25096]=1;i=d;return}function Ep(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25376]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(25384,fz(+h[(c[g>>2]|0)+880>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25376]=1;i=d;return}function Fp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25496]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(25504,fz(+h[(c[g>>2]|0)+856>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25496]=1;i=d;return}function Gp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25624]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+840>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+840>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(25632,fz(+h[(c[g>>2]|0)+840>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25624]=1;i=d;return}function Hp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25800]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+832>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+832>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(25808,fz(+h[(c[g>>2]|0)+832>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25800]=1;i=d;return}function Ip(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25976]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+808>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+808>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(25984,fz(+h[(c[g>>2]|0)+808>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[25976]=1;i=d;return}function Jp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26120]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+784>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(26128,fz(+h[(c[g>>2]|0)+784>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26120]=1;i=d;return}function Kp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26272]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+776>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(26280,fz(+h[(c[g>>2]|0)+776>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26272]=1;i=d;return}function Lp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26416]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(26424,fz(+h[(c[g>>2]|0)+760>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26416]=1;i=d;return}function Mp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26520]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(26528,fz(+h[(c[g>>2]|0)+752>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26520]=1;i=d;return}function Np(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26624]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+736>>3],1.0)|0)<<24>>24==0)){i=d;return}b=lz(26632,fz(+h[(c[g>>2]|0)+736>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26624]=1;i=d;return}function Op(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26728]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(26736,fz(+h[(c[g>>2]|0)+696>>3],24584)|0)|0;g=c[28996]|0;j=e;k=36024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26728]=1;i=d;return}function Pp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26944]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+176>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+176>>3],1.0)|0)<<24>>24==0)){i=d;return}b=lz(26952,fz(+h[(c[g>>2]|0)+176>>3],24584)|0)|0;g=c[28996]|0;j=e;k=36192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[26944]=1;i=d;return}function Qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27088]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(27096,fz(+h[(c[g>>2]|0)+680>>3],24584)|0)|0;g=c[28996]|0;j=e;k=36336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27088]=1;i=d;return}function Rp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27280]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+672>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+672>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(27288,fz(+h[(c[g>>2]|0)+672>>3],24584)|0)|0;g=c[28996]|0;j=e;k=36504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27280]=1;i=d;return}function Sp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27424]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+80>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+80>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(27432,hz(c[(c[g>>2]|0)+80>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=36760;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[27424]=1;i=d;return}function Tp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27656]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+76>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(27664,hz(c[(c[g>>2]|0)+76>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=37032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[27656]=1;i=d;return}function Up(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27904]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(27912,fz(+h[(c[g>>2]|0)+656>>3],24584)|0)|0;g=c[28996]|0;j=e;k=37168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[27904]=1;i=d;return}function Vp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28016]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(28024,fz(+h[(c[g>>2]|0)+648>>3],24584)|0)|0;g=c[28996]|0;j=e;k=37312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28016]=1;i=d;return}function Wp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28136]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+640>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+640>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(28144,fz(+h[(c[g>>2]|0)+640>>3],24584)|0)|0;g=c[28996]|0;j=e;k=37480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28136]=1;i=d;return}function Xp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28280]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+632>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(28288,fz(+h[(c[g>>2]|0)+632>>3],24584)|0)|0;g=c[28996]|0;j=e;k=37648;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28280]=1;i=d;return}function Yp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28424]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+72>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(28432,hz(c[(c[g>>2]|0)+72>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=37904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[28424]=1;i=d;return}function Zp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28656]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+68>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(28664,hz(c[(c[g>>2]|0)+68>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=38168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[28656]=1;i=d;return}function _p(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28896]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(28904,fz(+h[(c[g>>2]|0)+616>>3],24584)|0)|0;g=c[28996]|0;j=e;k=38296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[28896]=1;i=d;return}function $p(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29e3]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(29008,fz(+h[(c[g>>2]|0)+608>>3],24584)|0)|0;g=c[28996]|0;j=e;k=38432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[29e3]=1;i=d;return}function aq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29112]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+600>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+600>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(29120,fz(+h[(c[g>>2]|0)+600>>3],24584)|0)|0;g=c[28996]|0;j=e;k=38624;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[29112]=1;i=d;return}function bq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29280]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(29288,fz(+h[(c[g>>2]|0)+168>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[29280]=1;i=d;return}function cq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29408]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(29416,fz(+h[(c[g>>2]|0)+160>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[29408]=1;i=d;return}function dq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29536]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(29544,fz(+h[(c[g>>2]|0)+152>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[29536]=1;i=d;return}function eq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29664]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(29672,fz(+h[(c[g>>2]|0)+144>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[29664]=1;i=d;return}function fq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29792]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(29800,fz(+h[(c[g>>2]|0)+136>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[29792]=1;i=d;return}function gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29920]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(29928,fz(+h[(c[g>>2]|0)+128>>3],24584)|0)|0;g=c[28996]|0;j=e;k=39952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[29920]=1;i=d;return}function hq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30048]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(30056,fz(+h[(c[g>>2]|0)+120>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[30048]=1;i=d;return}function iq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30176]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(30184,fz(+h[(c[g>>2]|0)+112>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[30176]=1;i=d;return}function jq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30304]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+592>>3],-1.0e10)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+592>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=lz(30312,fz(+h[(c[g>>2]|0)+592>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40432;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[30304]=1;i=d;return}function kq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30456]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+584>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+584>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(30464,fz(+h[(c[g>>2]|0)+584>>3],24584)|0)|0;g=c[28996]|0;j=e;k=40592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[30456]=1;i=d;return}function lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30592]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(30600,fz(+h[(c[g>>2]|0)+576>>3],24584)|0)|0;g=c[28996]|0;j=e;k=30712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[30592]=1;i=d;return}function mq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30736]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(30744,fz(+h[(c[g>>2]|0)+568>>3],24584)|0)|0;g=c[28996]|0;j=e;k=30856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[30736]=1;i=d;return}function nq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30880]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+560>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+560>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(30888,fz(+h[(c[g>>2]|0)+560>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[30880]=1;i=d;return}function oq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31080]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+60>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(31088,hz(c[(c[g>>2]|0)+60>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=31336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[31080]=1;i=d;return}function pq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31360]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(31368,fz(+h[(c[g>>2]|0)+544>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[31360]=1;i=d;return}function qq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31496]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(31504,fz(+h[(c[g>>2]|0)+520>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[31496]=1;i=d;return}function rq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31640]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+504>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+504>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(31648,fz(+h[(c[g>>2]|0)+504>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[31640]=1;i=d;return}function sq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31824]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+496>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+496>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(31832,fz(+h[(c[g>>2]|0)+496>>3],24584)|0)|0;g=c[28996]|0;j=e;k=31984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[31824]=1;i=d;return}function tq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32008]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+472>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+472>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(32016,fz(+h[(c[g>>2]|0)+472>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[32008]=1;i=d;return}function uq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32160]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+448>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+448>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(32168,fz(+h[(c[g>>2]|0)+448>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[32160]=1;i=d;return}function vq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32328]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+440>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+440>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=lz(32336,fz(+h[(c[g>>2]|0)+440>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[32328]=1;i=d;return}function wq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32480]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(32488,fz(+h[(c[g>>2]|0)+424>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[32480]=1;i=d;return}function xq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32600]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(32608,fz(+h[(c[g>>2]|0)+416>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[32600]=1;i=d;return}function yq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32720]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+400>>3],1.0)|0)<<24>>24==0)){i=d;return}b=lz(32728,fz(+h[(c[g>>2]|0)+400>>3],24584)|0)|0;g=c[28996]|0;j=e;k=32816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[32720]=1;i=d;return}function zq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32840]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+48>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(32848,hz(c[(c[g>>2]|0)+48>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=33136;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[32840]=1;i=d;return}function Aq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33160]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+44>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+44>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(33168,hz(c[(c[g>>2]|0)+44>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=33400;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[33160]=1;i=d;return}function Bq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33424]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+40>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(33432,hz(c[(c[g>>2]|0)+40>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=33648;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[33424]=1;i=d;return}function Cq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33672]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(33680,fz(+h[(c[g>>2]|0)+392>>3],24584)|0)|0;g=c[28996]|0;j=e;k=33768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[33672]=1;i=d;return}function Dq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33792]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(33800,fz(+h[(c[g>>2]|0)+384>>3],24584)|0)|0;g=c[28996]|0;j=e;k=33888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[33792]=1;i=d;return}function Eq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33912]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(33920,fz(+h[(c[g>>2]|0)+376>>3],24584)|0)|0;g=c[28996]|0;j=e;k=34016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[33912]=1;i=d;return}function Fq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34040]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(34048,fz(+h[(c[g>>2]|0)+368>>3],24584)|0)|0;g=c[28996]|0;j=e;k=34136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[34040]=1;i=d;return}function Gq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34160]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(34168,fz(+h[(c[g>>2]|0)+360>>3],24584)|0)|0;g=c[28996]|0;j=e;k=34264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[34160]=1;i=d;return}function Hq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34288]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+36>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(34296,hz(c[(c[g>>2]|0)+36>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=34520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[34288]=1;i=d;return}function Iq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34544]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+32>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=lz(34552,hz(c[(c[g>>2]|0)+32>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=34768;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[34544]=1;i=d;return}function Jq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34792]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(34800,fz(+h[(c[g>>2]|0)+328>>3],24584)|0)|0;g=c[28996]|0;j=e;k=34896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[34792]=1;i=d;return}function Kq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34920]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(34928,fz(+h[(c[g>>2]|0)+320>>3],24584)|0)|0;g=c[28996]|0;j=e;k=35024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[34920]=1;i=d;return}function Lq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35048]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+104>>3],1.0)|0)<<24>>24==0)){i=d;return}b=lz(35056,fz(+h[(c[g>>2]|0)+104>>3],24584)|0)|0;g=c[28996]|0;j=e;k=35256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[35048]=1;i=d;return}function Mq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35280]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+312>>3],1.0)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+312>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=lz(35288,fz(+h[(c[g>>2]|0)+312>>3],24584)|0)|0;g=c[28996]|0;j=e;k=35408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[35280]=1;i=d;return}function Nq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35432]&1){i=d;return}g=b+416|0;b=aC(+h[(c[g>>2]|0)+304>>3],-1.0e5)|0;if(!(b<<24>>24==0|(_B(+h[(c[g>>2]|0)+304>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=lz(35440,fz(+h[(c[g>>2]|0)+304>>3],24584)|0)|0;g=c[28996]|0;j=e;k=35584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[35432]=1;i=d;return}function Oq(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35608]&1){i=d;return}g=b+420|0;b=aC(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(_B(+(c[(c[g>>2]|0)+28>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=lz(35616,hz(c[(c[g>>2]|0)+28>>2]|0,25104)|0)|0;g=c[28996]|0;h=e;j=35864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];ze[g&15](e,b,f);a[35608]=1;i=d;return}function Pq(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35888]&1){i=d;return}g=b+416|0;if(!((aC(+h[(c[g>>2]|0)+296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=lz(35896,fz(+h[(c[g>>2]|0)+296>>3],24584)|0)|0;g=c[28996]|0;j=e;k=36024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];ze[g&15](e,b,f);a[35888]=1;i=d;return}



function Xh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+16|0;c[Va>>2]=16;Az(Wa,1,Va);if(!(d>611.657)){Va=lz(lz(9824,jz(d,0,1,6)|0)|0,5248)|0;Xa=lz(lz(Va,jz(611.657,0,1,6)|0)|0,5256)|0;Va=c[28994]|0;Ya=g;Za=9888;c[Ya+0>>2]=c[Za+0>>2];c[Ya+4>>2]=c[Za+4>>2];c[Ya+8>>2]=c[Za+8>>2];c[Ya+12>>2]=c[Za+12>>2];c[Ya+16>>2]=c[Za+16>>2];c[Ya+20>>2]=c[Za+20>>2];De[Va&31](b,g,Xa,Ua);}_a=d/1.0e6;d=540.0/e;$a=d+-.5;c[Ta>>2]=1;h[(Fz(Wa,1,Ta)|0)>>3]=d*d;c[Sa>>2]=1;ab=+h[(Fz(Wa,1,Sa)|0)>>3];c[Ra>>2]=2;h[(Fz(Wa,1,Ra)|0)>>3]=ab*ab;c[Qa>>2]=3;h[(Fz(Wa,1,Qa)|0)>>3]=$a*$a;c[Pa>>2]=3;ab=$a*+h[(Fz(Wa,1,Pa)|0)>>3];c[Oa>>2]=4;h[(Fz(Wa,1,Oa)|0)>>3]=ab;c[Na>>2]=3;ab=+h[(Fz(Wa,1,Na)|0)>>3];c[Ma>>2]=5;h[(Fz(Wa,1,Ma)|0)>>3]=ab*ab;c[La>>2]=5;ab=+h[(Fz(Wa,1,La)|0)>>3];c[Ka>>2]=6;h[(Fz(Wa,1,Ka)|0)>>3]=ab*ab;c[Ja>>2]=6;ab=+h[(Fz(Wa,1,Ja)|0)>>3];c[Ia>>2]=7;h[(Fz(Wa,1,Ia)|0)>>3]=ab*ab;c[Ha>>2]=5;ab=+h[(Fz(Wa,1,Ha)|0)>>3];c[Ga>>2]=6;bb=+h[(Fz(Wa,1,Ga)|0)>>3];c[Fa>>2]=7;cb=ab*bb*$a*+h[(Fz(Wa,1,Fa)|0)>>3];c[Ea>>2]=8;h[(Fz(Wa,1,Ea)|0)>>3]=cb;c[Da>>2]=3;cb=+h[(Fz(Wa,1,Da)|0)>>3];c[Ca>>2]=5;bb=cb*+h[(Fz(Wa,1,Ca)|0)>>3];c[Ba>>2]=9;h[(Fz(Wa,1,Ba)|0)>>3]=bb;c[Aa>>2]=5;bb=+h[(Fz(Wa,1,Aa)|0)>>3];c[za>>2]=6;cb=bb*$a*+h[(Fz(Wa,1,za)|0)>>3];c[ya>>2]=10;h[(Fz(Wa,1,ya)|0)>>3]=cb;c[xa>>2]=3;cb=+h[(Fz(Wa,1,xa)|0)>>3];c[wa>>2]=7;bb=cb*$a*+h[(Fz(Wa,1,wa)|0)>>3];c[va>>2]=11;h[(Fz(Wa,1,va)|0)>>3]=bb;c[ua>>2]=3;bb=+h[(Fz(Wa,1,ua)|0)>>3];c[ta>>2]=5;cb=+h[(Fz(Wa,1,ta)|0)>>3];c[sa>>2]=6;ab=bb*cb*+h[(Fz(Wa,1,sa)|0)>>3];c[ra>>2]=12;h[(Fz(Wa,1,ra)|0)>>3]=ab;c[qa>>2]=5;ab=+h[(Fz(Wa,1,qa)|0)>>3];c[pa>>2]=6;cb=+h[(Fz(Wa,1,pa)|0)>>3];c[oa>>2]=7;bb=ab*cb*+h[(Fz(Wa,1,oa)|0)>>3];c[na>>2]=13;h[(Fz(Wa,1,na)|0)>>3]=bb;c[ma>>2]=14;h[(Fz(Wa,1,ma)|0)>>3]=_a*_a;c[la>>2]=14;bb=+h[(Fz(Wa,1,la)|0)>>3];c[ka>>2]=15;h[(Fz(Wa,1,ka)|0)>>3]=bb*bb;c[ja>>2]=7;bb=+h[(Fz(Wa,1,ja)|0)>>3];c[ia>>2]=16;h[(Fz(Wa,1,ia)|0)>>3]=bb*bb;c[ha>>2]=1;bb=d*(d*(d*(d*((d*(d*.06380539059921+-.5681726521544)+10.08665568018)*+h[(Fz(Wa,1,ha)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[ga>>2]=2;cb=+h[(Fz(Wa,1,ga)|0)>>3];c[fa>>2]=1;ab=bb/(cb*+h[(Fz(Wa,1,fa)|0)>>3]);c[ea>>2]=4;cb=$a*($a*(+h[(Fz(Wa,1,ea)|0)>>3]*-.30195167236758+-.172743777250296)+-.09199202739273);c[da>>2]=3;bb=+h[(Fz(Wa,1,da)|0)>>3];c[ca>>2]=4;db=+h[(Fz(Wa,1,ca)|0)>>3];c[ba>>2]=8;eb=$a*(bb*(db*(+h[(Fz(Wa,1,ba)|0)>>3]*-.000960283724907132+-.306581069554011)+-.015757110897342)+-.0003789797503263);c[aa>>2]=3;db=+h[(Fz(Wa,1,aa)|0)>>3];c[$>>2]=4;bb=+h[(Fz(Wa,1,$)|0)>>3];c[_>>2]=8;fb=db*(bb*(+h[(Fz(Wa,1,_)|0)>>3]*-1.42338887469272+-.0090203547252888)+-9683303171571.0e-17);c[Z>>2]=9;bb=+h[(Fz(Wa,1,Z)|0)>>3]*160454534363627.0e-19;c[Y>>2]=10;db=+h[(Fz(Wa,1,Y)|0)>>3];c[X>>2]=11;gb=db*(+h[(Fz(Wa,1,X)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11;c[W>>2]=3;db=+h[(Fz(Wa,1,W)|0)>>3]*gb;c[V>>2]=12;gb=+h[(Fz(Wa,1,V)|0)>>3]*-.973671060893475+-138839897890111.0e-19;c[U>>2]=3;hb=+h[(Fz(Wa,1,U)|0)>>3];c[T>>2]=6;ib=gb*hb*+h[(Fz(Wa,1,T)|0)>>3];c[S>>2]=13;hb=+h[(Fz(Wa,1,S)|0)>>3]*-296.320827232793+9.0049690883672e-11;c[R>>2]=3;gb=+h[(Fz(Wa,1,R)|0)>>3];c[Q>>2]=5;jb=hb*gb*$a*+h[(Fz(Wa,1,Q)|0)>>3];c[P>>2]=5;gb=+h[(Fz(Wa,1,P)|0)>>3];c[O>>2]=6;hb=gb*+h[(Fz(Wa,1,O)|0)>>3]*2.57526266427144e-7;c[N>>2]=4;gb=+h[(Fz(Wa,1,N)|0)>>3];c[M>>2]=5;kb=+h[(Fz(Wa,1,M)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[L>>2]=9;lb=gb*(kb*+h[(Fz(Wa,1,L)|0)>>3]+4.1627860840696e-19);c[K>>2]=14;kb=+h[(Fz(Wa,1,K)|0)>>3];c[J>>2]=15;gb=+h[(Fz(Wa,1,J)|0)>>3];c[I>>2]=13;mb=+h[(Fz(Wa,1,I)|0)>>3];c[H>>2]=5;nb=+h[(Fz(Wa,1,H)|0)>>3];c[G>>2]=7;ob=mb*(nb*$a*+h[(Fz(Wa,1,G)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[F>>2]=14;nb=+h[(Fz(Wa,1,F)|0)>>3];c[E>>2]=16;mb=+h[(Fz(Wa,1,E)|0)>>3];c[D>>2]=6;pb=+h[(Fz(Wa,1,D)|0)>>3];c[C>>2]=7;qb=mb*pb*+h[(Fz(Wa,1,C)|0)>>3]*-19.1874828272775;c[B>>2]=14;pb=+h[(Fz(Wa,1,B)|0)>>3];c[A>>2]=11;mb=+h[(Fz(Wa,1,A)|0)>>3];c[z>>2]=10;rb=+h[(Fz(Wa,1,z)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[y>>2]=3;sb=+h[(Fz(Wa,1,y)|0)>>3];c[x>>2]=5;tb=+h[(Fz(Wa,1,x)|0)>>3];c[w>>2]=6;ub=mb*(rb*sb*tb*$a*+h[(Fz(Wa,1,w)|0)>>3]+1.78371690710842e-23);c[v>>2]=5;tb=+h[(Fz(Wa,1,v)|0)>>3];c[u>>2]=7;sb=tb*+h[(Fz(Wa,1,u)|0)>>3]*-1.24017662339842e-24;c[t>>2]=16;tb=+h[(Fz(Wa,1,t)|0)>>3];c[s>>2]=5;rb=+h[(Fz(Wa,1,s)|0)>>3];c[r>>2]=7;mb=tb*rb*+h[(Fz(Wa,1,r)|0)>>3]*.000200482822351322;c[q>>2]=16;rb=+h[(Fz(Wa,1,q)|0)>>3];c[p>>2]=3;tb=+h[(Fz(Wa,1,p)|0)>>3];c[o>>2]=5;vb=rb*tb*+h[(Fz(Wa,1,o)|0)>>3]*-4.97975748452559e-14;c[n>>2]=6;tb=+h[(Fz(Wa,1,n)|0)>>3];c[m>>2]=7;rb=+h[(Fz(Wa,1,m)|0)>>3];c[l>>2]=12;wb=+h[(Fz(Wa,1,l)|0)>>3];c[k>>2]=3;xb=+h[(Fz(Wa,1,k)|0)>>3];c[j>>2]=7;h[a>>3]=d*(ab+_a*(cb+_a*(eb+_a*(fb+_a*($a*($a*144676118155521.0e-20+2.558143570457e-8)+_a*(bb+_a*(db+_a*(ib+_a*(jb+_a*(hb+_a*(lb+kb*gb*(ob+nb*(qb+pb*(ub+_a*(sb+_a*(mb+_a*(vb+tb*rb*_a*$a*(wb*(xb*+h[(Fz(Wa,1,j)|0)>>3]*-547344301999018.0e-19+2.21658861403112e-15)+1.90027787547159e-27)))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358))*e*461.526;i=f;return}function Yh(b,c,d){b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;e=i;i=i+216|0;f=e+8|0;g=e+16|0;j=e+24|0;k=e+112|0;l=e+120|0;m=e+208|0;n=e;o=+od(+d,22063999.9999999);Ih(f,c,o);p=+h[f>>3];xh(g,c,p);q=+h[g>>3];g=p>623.15;f=g&1;if(g){Rh(k,0,o);r=+h[k>>3];uh(l,c,r,p);s=+h[l+16>>3];t=+h[l+24>>3];u=+h[l+32>>3];v=+h[l+40>>3];w=+h[l+48>>3];x=+h[l+56>>3];y=+h[l+64>>3];z=+h[l+72>>3];A=+h[l+80>>3];Zh(m,0,o);B=r*t*(w-u*A)*461.526;C=p*t*(w*2.0+t*x)*461.526;D=0.0;E=0.0;F=r;G=+h[m>>3];H=s*(u*y-v);I=0.0;J=u*u*z*-461.526}else{th(j,c,d,p);z=+h[j+24>>3];u=+h[j+32>>3];v=+h[j+48>>3];y=+h[j+56>>3];s=+h[j+80>>3];r=z*v;x=u*+h[j+64>>3];if(o<d){K=2087546.84511715}else{K=p*x*461.526}o=+h[j+16>>3]*(x- +h[j+40>>3]);x=u*u*+h[j+72>>3]*-461.526;B=-((v-u*s)/(p*z*y)*d);C=p*(v*v/y)*-461.526;D=(r-u*z*s)/d*461.526;E=p*z*z*y*+iA(d,-2)*461.526;F=d/(p*r*461.526);G=K;H=o;I=x;J=0.0}j=b;a[j]=f;f=j+1|0;a[f+0|0]=a[n+0|0]|0;a[f+1|0]=a[n+1|0]|0;a[f+2|0]=a[n+2|0]|0;a[f+3|0]=a[n+3|0]|0;a[f+4|0]=a[n+4|0]|0;a[f+5|0]=a[n+5|0]|0;a[f+6|0]=a[n+6|0]|0;h[b+8>>3]=461.526;h[b+16>>3]=p;h[b+24>>3]=F;h[b+32>>3]=G;h[b+40>>3]=H;h[b+48>>3]=I;h[b+56>>3]=J;h[b+64>>3]=q;h[b+72>>3]=B;h[b+80>>3]=C;h[b+88>>3]=D;h[b+96>>3]=E;i=e;return}function Zh(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;d=+_(+(c/22064.0e3));h[a>>3]=(d*(d*(d*(d*(d*(d*(d*(d*.0006616936460057692+-16.98555442961553)+45.66489164833212)+-48.38215180269516)+25.08887602293532)+-6.084122698421623)+.2079670746250689)+.4880153718655694)+1.0)*2087546.84511715;i=i;return}function _h(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0.0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;c[Ia>>2]=12;Az(Ja,1,Ia);Ka=d/1.0e6;La=540.0/e+-.5;c[Ha>>2]=1;h[(Fz(Ja,1,Ha)|0)>>3]=La*La;c[Ga>>2]=1;Ma=La*+h[(Fz(Ja,1,Ga)|0)>>3];c[Fa>>2]=2;h[(Fz(Ja,1,Fa)|0)>>3]=Ma;c[Ea>>2]=1;Ma=+h[(Fz(Ja,1,Ea)|0)>>3];c[Da>>2]=3;h[(Fz(Ja,1,Da)|0)>>3]=Ma*Ma;c[Ca>>2]=3;Ma=+h[(Fz(Ja,1,Ca)|0)>>3];c[Ba>>2]=4;h[(Fz(Ja,1,Ba)|0)>>3]=Ma*Ma;c[Aa>>2]=4;Ma=+h[(Fz(Ja,1,Aa)|0)>>3];c[za>>2]=5;h[(Fz(Ja,1,za)|0)>>3]=Ma*Ma;c[ya>>2]=3;Ma=+h[(Fz(Ja,1,ya)|0)>>3];c[xa>>2]=4;Na=+h[(Fz(Ja,1,xa)|0)>>3];c[wa>>2]=5;Oa=Ma*Na*La*+h[(Fz(Ja,1,wa)|0)>>3];c[va>>2]=6;h[(Fz(Ja,1,va)|0)>>3]=Oa;c[ua>>2]=3;Oa=+h[(Fz(Ja,1,ua)|0)>>3];c[ta>>2]=4;Na=Oa*La*+h[(Fz(Ja,1,ta)|0)>>3];c[sa>>2]=7;h[(Fz(Ja,1,sa)|0)>>3]=Na;c[ra>>2]=1;Na=+h[(Fz(Ja,1,ra)|0)>>3];c[qa>>2]=3;Oa=+h[(Fz(Ja,1,qa)|0)>>3];c[pa>>2]=4;Ma=Na*Oa*+h[(Fz(Ja,1,pa)|0)>>3];c[oa>>2]=8;h[(Fz(Ja,1,oa)|0)>>3]=Ma;c[na>>2]=9;h[(Fz(Ja,1,na)|0)>>3]=Ka*Ka;c[ma>>2]=9;Ma=+h[(Fz(Ja,1,ma)|0)>>3];c[la>>2]=10;h[(Fz(Ja,1,la)|0)>>3]=Ma*Ma;c[ka>>2]=3;Ma=+h[(Fz(Ja,1,ka)|0)>>3];c[ja>>2]=5;Oa=Ma*La*+h[(Fz(Ja,1,ja)|0)>>3];c[ia>>2]=11;h[(Fz(Ja,1,ia)|0)>>3]=Oa;c[ha>>2]=5;Oa=+h[(Fz(Ja,1,ha)|0)>>3];c[ga>>2]=12;h[(Fz(Ja,1,ga)|0)>>3]=Oa*Oa;c[fa>>2]=2;Oa=La*(La*(La*(+h[(Fz(Ja,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=1;Ma=+h[(Fz(Ja,1,ea)|0)>>3];c[da>>2]=2;Na=+h[(Fz(Ja,1,da)|0)>>3];c[ca>>2]=6;Pa=La*(La*(Ma*(Na*(+h[(Fz(Ja,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=1;Na=+h[(Fz(Ja,1,ba)|0)>>3];c[aa>>2]=2;Ma=+h[(Fz(Ja,1,aa)|0)>>3];c[$>>2]=6;Qa=La*(Na*(Ma*(+h[(Fz(Ja,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=1;Ma=+h[(Fz(Ja,1,_)|0)>>3];c[Z>>2]=3;Na=Ma*La*+h[(Fz(Ja,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=2;Ma=+h[(Fz(Ja,1,Y)|0)>>3];c[X>>2]=7;Ra=+h[(Fz(Ja,1,X)|0)>>3];c[W>>2]=1;Sa=+h[(Fz(Ja,1,W)|0)>>3];c[V>>2]=5;Ta=Ma*(Ra*(Sa*La*+h[(Fz(Ja,1,V)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[U>>2]=1;Sa=+h[(Fz(Ja,1,U)|0)>>3];c[T>>2]=4;Ra=+h[(Fz(Ja,1,T)|0)>>3];c[S>>2]=8;Ma=Sa*Ra*La*(+h[(Fz(Ja,1,S)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[R>>2]=4;Ra=+h[(Fz(Ja,1,R)|0)>>3];c[Q>>2]=3;Sa=+h[(Fz(Ja,1,Q)|0)>>3];c[P>>2]=4;Ua=+h[(Fz(Ja,1,P)|0)>>3];c[O>>2]=5;Va=Ra*(Sa*Ua*+h[(Fz(Ja,1,O)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[N>>2]=7;Ua=+h[(Fz(Ja,1,N)|0)>>3]*1.78287415218792e-7;c[M>>2]=3;Sa=+h[(Fz(Ja,1,M)|0)>>3];c[L>>2]=1;Ra=+h[(Fz(Ja,1,L)|0)>>3];c[K>>2]=3;Wa=+h[(Fz(Ja,1,K)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[J>>2]=3;Xa=Sa*(Ra*Wa*+h[(Fz(Ja,1,J)|0)>>3]+1.0406965210174e-18);c[I>>2]=10;Wa=+h[(Fz(Ja,1,I)|0)>>3];c[H>>2]=9;Ra=+h[(Fz(Ja,1,H)|0)>>3];c[G>>2]=11;Sa=+h[(Fz(Ja,1,G)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[F>>2]=6;Ya=Sa*+h[(Fz(Ja,1,F)|0)>>3];c[E>>2]=9;Sa=+h[(Fz(Ja,1,E)|0)>>3];c[D>>2]=12;Za=+h[(Fz(Ja,1,D)|0)>>3];c[C>>2]=4;_a=+h[(Fz(Ja,1,C)|0)>>3];c[B>>2]=5;$a=Za*_a*La*+h[(Fz(Ja,1,B)|0)>>3]*-6.05920510335078;c[A>>2]=9;_a=+h[(Fz(Ja,1,A)|0)>>3];c[z>>2]=3;Za=+h[(Fz(Ja,1,z)|0)>>3];c[y>>2]=5;ab=+h[(Fz(Ja,1,y)|0)>>3];c[x>>2]=1;bb=+h[(Fz(Ja,1,x)|0)>>3];c[w>>2]=3;cb=+h[(Fz(Ja,1,w)|0)>>3];c[v>>2]=4;db=+h[(Fz(Ja,1,v)|0)>>3];c[u>>2]=7;eb=Za*ab*(bb*cb*db*La*(+h[(Fz(Ja,1,u)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[t>>2]=11;db=+h[(Fz(Ja,1,t)|0)>>3]*-1.24017662339842e-24;c[s>>2]=12;cb=+h[(Fz(Ja,1,s)|0)>>3];c[r>>2]=3;bb=+h[(Fz(Ja,1,r)|0)>>3];c[q>>2]=5;ab=cb*bb*La*+h[(Fz(Ja,1,q)|0)>>3]*832192847496054.0e-19;c[p>>2]=1;bb=+h[(Fz(Ja,1,p)|0)>>3];c[o>>2]=4;cb=+h[(Fz(Ja,1,o)|0)>>3];c[n>>2]=5;Za=+h[(Fz(Ja,1,n)|0)>>3];c[m>>2]=1;fb=+h[(Fz(Ja,1,m)|0)>>3];c[l>>2]=5;gb=fb*+h[(Fz(Ja,1,l)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[k>>2]=8;fb=bb*cb*Za*Ka*(+h[(Fz(Ja,1,k)|0)>>3]*gb+1.75410265428146e-27);c[j>>2]=1;gb=+h[(Fz(Ja,1,j)|0)>>3];c[g>>2]=12;Za=+h[(Fz(Ja,1,g)|0)>>3];c[f>>2]=3;h[a>>3]=d/(Ka*((Ka*(Oa+Ka*(Pa+Ka*(Qa+Ka*(La*(La*(La*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ka*(Na+Ka*(Ta+Ka*(Ma+Ka*(Va+Ka*(Ua+Ka*(Xa+Wa*Ra*(Ya+Sa*($a+_a*(eb+Ka*(db+Ka*(ab+Ka*(fb+gb*Za*La*+h[(Fz(Ja,1,f)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ka)*e*461.526);i=b;return}function $h(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;h[a>>3]=+h[d+32>>3];i=i;return}function ai(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;c[u>>2]=3;Az(v,1,u);w=7.1-d/1653.0e4;if(!(d>611.657)){u=lz(lz(10024,jz(d,0,1,6)|0)|0,5248)|0;x=lz(lz(u,jz(611.657,0,1,6)|0)|0,5256)|0;u=c[28994]|0;y=f;z=10096;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];De[u&31](b,f,x,t);}c[s>>2]=1;h[(Fz(v,1,s)|0)>>3]=w*w;c[r>>2]=1;d=+h[(Fz(v,1,r)|0)>>3];c[q>>2]=2;h[(Fz(v,1,q)|0)>>3]=d*d;c[p>>2]=2;d=+h[(Fz(v,1,p)|0)>>3];c[o>>2]=3;h[(Fz(v,1,o)|0)>>3]=d*d;c[n>>2]=1;d=+h[(Fz(v,1,n)|0)>>3];c[m>>2]=2;A=+h[(Fz(v,1,m)|0)>>3];c[l>>2]=3;B=+h[(Fz(v,1,l)|0)>>3];c[k>>2]=1;C=+h[(Fz(v,1,k)|0)>>3];c[j>>2]=1;D=+h[(Fz(v,1,j)|0)>>3];c[g>>2]=2;h[a>>3]=(w*(w*(w*(w*(w*(d*w*(A*B*w*(C*(D*(w*(w*(w*3.49930466305574e-24+-6.66749357417962e-23)+4.27026404402408e-22)+-9.19148577641497e-22)*+h[(Fz(v,1,g)|0)>>3]+-4.18568363667416e-19)+1.86779322717506e-17)+1.46754947271665e-8)+317834967400818.0e-20)+123617764767172.0e-19)+.000125338925082983)+.00143759406818289)+-.00141131225285294)+2.42896927729349)*639675.036;i=e;return}function bi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0.0,Hb=0,Ib=0,Jb=0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0.0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0.0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0.0,Zb=0.0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0.0,hc=0.0,ic=0.0,jc=0.0,kc=0.0,lc=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;c[Eb>>2]=18;Az(Fb,1,Eb);Gb=d/1.0e6;if(!(d>611.657)){Eb=lz(lz(10120,jz(d,0,1,6)|0)|0,5248)|0;Hb=lz(lz(Eb,jz(611.657,0,1,6)|0)|0,5256)|0;Eb=c[28994]|0;Ib=f;Jb=10192;c[Ib+0>>2]=c[Jb+0>>2];c[Ib+4>>2]=c[Jb+4>>2];c[Ib+8>>2]=c[Jb+8>>2];c[Ib+12>>2]=c[Jb+12>>2];c[Ib+16>>2]=c[Jb+16>>2];c[Ib+20>>2]=c[Jb+20>>2];De[Eb&31](b,f,Hb,Db);}d=+V(+(Gb+-13.91883977887))*31.3220101646784+572.54459862746;Kb=540.0/d+-.5;c[Cb>>2]=1;h[(Fz(Fb,1,Cb)|0)>>3]=d*d;c[Bb>>2]=1;Lb=+h[(Fz(Fb,1,Bb)|0)>>3];c[Ab>>2]=2;h[(Fz(Fb,1,Ab)|0)>>3]=Lb*Lb;c[zb>>2]=2;Lb=+h[(Fz(Fb,1,zb)|0)>>3];c[yb>>2]=3;h[(Fz(Fb,1,yb)|0)>>3]=Lb*Lb;c[xb>>2]=4;h[(Fz(Fb,1,xb)|0)>>3]=Gb*Gb;c[wb>>2]=4;Lb=+h[(Fz(Fb,1,wb)|0)>>3];c[vb>>2]=5;h[(Fz(Fb,1,vb)|0)>>3]=Lb*Lb;c[ub>>2]=6;h[(Fz(Fb,1,ub)|0)>>3]=Kb*Kb;c[tb>>2]=6;Lb=+h[(Fz(Fb,1,tb)|0)>>3];c[sb>>2]=7;h[(Fz(Fb,1,sb)|0)>>3]=Lb*Lb;c[rb>>2]=6;Lb=+h[(Fz(Fb,1,rb)|0)>>3];c[qb>>2]=7;Mb=Lb*+h[(Fz(Fb,1,qb)|0)>>3];c[pb>>2]=8;h[(Fz(Fb,1,pb)|0)>>3]=Mb;c[ob>>2]=5;Mb=+h[(Fz(Fb,1,ob)|0)>>3];c[nb>>2]=9;h[(Fz(Fb,1,nb)|0)>>3]=Mb*Mb;c[mb>>2]=7;Mb=+h[(Fz(Fb,1,mb)|0)>>3];c[lb>>2]=10;h[(Fz(Fb,1,lb)|0)>>3]=Mb*Mb;c[kb>>2]=9;Mb=+h[(Fz(Fb,1,kb)|0)>>3];c[jb>>2]=11;h[(Fz(Fb,1,jb)|0)>>3]=Mb*Mb;c[ib>>2]=10;Mb=+h[(Fz(Fb,1,ib)|0)>>3];c[hb>>2]=12;h[(Fz(Fb,1,hb)|0)>>3]=Mb*Mb;c[gb>>2]=12;Mb=+h[(Fz(Fb,1,gb)|0)>>3];c[fb>>2]=13;h[(Fz(Fb,1,fb)|0)>>3]=Mb*Mb;c[eb>>2]=7;Mb=Kb*+h[(Fz(Fb,1,eb)|0)>>3];c[db>>2]=14;h[(Fz(Fb,1,db)|0)>>3]=Mb;c[cb>>2]=6;Mb=Kb*+h[(Fz(Fb,1,cb)|0)>>3];c[bb>>2]=15;h[(Fz(Fb,1,bb)|0)>>3]=Mb;c[ab>>2]=10;Mb=+h[(Fz(Fb,1,ab)|0)>>3];c[$a>>2]=6;Lb=Mb*+h[(Fz(Fb,1,$a)|0)>>3];c[_a>>2]=16;h[(Fz(Fb,1,_a)|0)>>3]=Lb;c[Za>>2]=13;Lb=+h[(Fz(Fb,1,Za)|0)>>3];c[Ya>>2]=6;Mb=Lb*+h[(Fz(Fb,1,Ya)|0)>>3];c[Xa>>2]=17;h[(Fz(Fb,1,Xa)|0)>>3]=Mb;c[Wa>>2]=13;Mb=+h[(Fz(Fb,1,Wa)|0)>>3];c[Va>>2]=6;Lb=Mb*Kb*+h[(Fz(Fb,1,Va)|0)>>3];c[Ua>>2]=18;h[(Fz(Fb,1,Ua)|0)>>3]=Lb;c[Ta>>2]=2;Lb=+h[(Fz(Fb,1,Ta)|0)>>3]*3.74686560065793;c[Sa>>2]=1;Mb=+h[(Fz(Fb,1,Sa)|0)>>3];c[Ra>>2]=2;Nb=Mb*+h[(Fz(Fb,1,Ra)|0)>>3]*357966647812489.0e-20;c[Qa>>2]=3;Mb=+h[(Fz(Fb,1,Qa)|0)>>3]*2.81881548488163e-13;c[Pa>>2]=2;Ob=d*+h[(Fz(Fb,1,Pa)|0)>>3]*-.00450789338787835;c[Oa>>2]=1;Pb=+h[(Fz(Fb,1,Oa)|0)>>3];c[Na>>2]=2;Qb=Pb*d*+h[(Fz(Fb,1,Na)|0)>>3]*-1.55131504410292e-9;c[Ma>>2]=1;Pb=+h[(Fz(Fb,1,Ma)|0)>>3];c[La>>2]=10;Rb=+h[(Fz(Fb,1,La)|0)>>3];c[Ka>>2]=11;Sb=+h[(Fz(Fb,1,Ka)|0)>>3];c[Ja>>2]=12;Tb=+h[(Fz(Fb,1,Ja)|0)>>3];c[Ia>>2]=13;Ub=+h[(Fz(Fb,1,Ia)|0)>>3];c[Ha>>2]=4;Vb=Rb*Sb*Tb*Ub*+h[(Fz(Fb,1,Ha)|0)>>3]*-4781981.98764471;c[Ga>>2]=11;Ub=+h[(Fz(Fb,1,Ga)|0)>>3];c[Fa>>2]=12;Tb=+h[(Fz(Fb,1,Fa)|0)>>3];c[Ea>>2]=13;Sb=+h[(Fz(Fb,1,Ea)|0)>>3];c[Da>>2]=4;Rb=+h[(Fz(Fb,1,Da)|0)>>3];c[Ca>>2]=5;Wb=+h[(Fz(Fb,1,Ca)|0)>>3];c[Ba>>2]=7;Xb=Ub*Tb*Sb*Rb*Wb*+h[(Fz(Fb,1,Ba)|0)>>3]*49.9651389369988;c[Aa>>2]=15;Wb=+h[(Fz(Fb,1,Aa)|0)>>3];c[za>>2]=4;Rb=+h[(Fz(Fb,1,za)|0)>>3];c[ya>>2]=16;Sb=+h[(Fz(Fb,1,ya)|0)>>3]*-.00349547959376899;c[xa>>2]=8;Tb=Sb+ +h[(Fz(Fb,1,xa)|0)>>3]*-2.55074501962569e-7+1.03746636552761e-13;c[wa>>2]=9;Sb=Wb*Rb*+h[(Fz(Fb,1,wa)|0)>>3]*Tb;c[va>>2]=10;Tb=+h[(Fz(Fb,1,va)|0)>>3];c[ua>>2]=12;Rb=Tb*+h[(Fz(Fb,1,ua)|0)>>3]*-242662.235426958;c[ta>>2]=16;Tb=Rb+ +h[(Fz(Fb,1,ta)|0)>>3]*-3.46022402653609;c[sa>>2]=4;Rb=+h[(Fz(Fb,1,sa)|0)>>3];c[ra>>2]=5;Wb=Tb*Rb*Gb*+h[(Fz(Fb,1,ra)|0)>>3];c[qa>>2]=4;Rb=+h[(Fz(Fb,1,qa)|0)>>3];c[pa>>2]=14;Tb=+h[(Fz(Fb,1,pa)|0)>>3]*-2248.08924686956;c[oa>>2]=17;Ub=+h[(Fz(Fb,1,oa)|0)>>3]*-354742.725841972;c[na>>2]=6;Yb=Rb*Gb*(Tb+(Ub+ +h[(Fz(Fb,1,na)|0)>>3]*-24.1331193696374)+.109336249381227);c[ma>>2]=11;Ub=+h[(Fz(Fb,1,ma)|0)>>3];c[la>>2]=12;Tb=+h[(Fz(Fb,1,la)|0)>>3];c[ka>>2]=5;Rb=+h[(Fz(Fb,1,ka)|0)>>3];c[ja>>2]=7;Zb=Ub*Tb*Rb*Gb*+h[(Fz(Fb,1,ja)|0)>>3]*-3.09081828396912e-19;c[ia>>2]=11;Rb=+h[(Fz(Fb,1,ia)|0)>>3];c[ha>>2]=13;Tb=+h[(Fz(Fb,1,ha)|0)>>3];c[ga>>2]=4;Ub=+h[(Fz(Fb,1,ga)|0)>>3];c[fa>>2]=5;_b=+h[(Fz(Fb,1,fa)|0)>>3];c[ea>>2]=6;$b=+h[(Fz(Fb,1,ea)|0)>>3];c[da>>2]=7;ac=Rb*Tb*Ub*_b*$b*Gb*+h[(Fz(Fb,1,da)|0)>>3]*-1.24107527851371e-8;c[ca>>2]=5;$b=+h[(Fz(Fb,1,ca)|0)>>3];c[ba>>2]=8;_b=$b*Gb*+h[(Fz(Fb,1,ba)|0)>>3]*3.99891272904219;c[aa>>2]=10;$b=+h[(Fz(Fb,1,aa)|0)>>3];c[$>>2]=7;Ub=+h[(Fz(Fb,1,$)|0)>>3];c[_>>2]=9;Tb=$b*Ub*Gb*+h[(Fz(Fb,1,_)|0)>>3]*.0641817365250892;c[Z>>2]=14;Ub=+h[(Fz(Fb,1,Z)|0)>>3]*-75253.6156722047;c[Y>>2]=6;$b=Gb*(Ub+(Kb*-22926.6247146068+ +h[(Fz(Fb,1,Y)|0)>>3]*-43051.9020511789)+-4444.87643334512);c[X>>2]=4;Ub=+h[(Fz(Fb,1,X)|0)>>3];c[W>>2]=15;Gb=+h[(Fz(Fb,1,W)|0)>>3]*-3927.0508365636;c[U>>2]=18;Rb=+h[(Fz(Fb,1,U)|0)>>3]*-239.325789467604;c[T>>2]=8;bc=Ub*(Gb+(Rb+(Kb*-94.4508644545118+ +h[(Fz(Fb,1,T)|0)>>3]*-76407.3727417716))+-8.23252840892034);c[S>>2]=5;Rb=(Kb+-.0161221195808321)*(Kb+.0338039844460968)*+h[(Fz(Fb,1,S)|0)>>3]*.360567666582363;c[R>>2]=11;Gb=+h[(Fz(Fb,1,R)|0)>>3];c[Q>>2]=10;Ub=+h[(Fz(Fb,1,Q)|0)>>3];c[P>>2]=12;cc=+h[(Fz(Fb,1,P)|0)>>3];c[O>>2]=7;dc=Ub*cc*+h[(Fz(Fb,1,O)|0)>>3]*-.000584580992538624;c[N>>2]=12;cc=+h[(Fz(Fb,1,N)|0)>>3];c[M>>2]=13;Ub=Gb*(dc+cc*Kb*+h[(Fz(Fb,1,M)|0)>>3]*1332480.30241755);c[L>>2]=9;cc=+h[(Fz(Fb,1,L)|0)>>3];c[K>>2]=18;dc=+h[(Fz(Fb,1,K)|0)>>3]*-73850273.6990986;c[J>>2]=6;Gb=+h[(Fz(Fb,1,J)|0)>>3];c[I>>2]=7;ec=cc*(dc+Gb*Kb*+h[(Fz(Fb,1,I)|0)>>3]*224425477627799.0e-19);c[H>>2]=4;Gb=+h[(Fz(Fb,1,H)|0)>>3];c[G>>2]=5;dc=+h[(Fz(Fb,1,G)|0)>>3];c[F>>2]=17;cc=+h[(Fz(Fb,1,F)|0)>>3]*-208438767.026518;c[E>>2]=6;fc=+h[(Fz(Fb,1,E)|0)>>3]*-124971648677697.0e-19;c[D>>2]=10;gc=+h[(Fz(Fb,1,D)|0)>>3];c[C>>2]=6;hc=+h[(Fz(Fb,1,C)|0)>>3];c[B>>2]=7;ic=Gb*dc*(cc+(fc+gc*hc*Kb*+h[(Fz(Fb,1,B)|0)>>3]*-8442.30378348203));c[A>>2]=11;hc=+h[(Fz(Fb,1,A)|0)>>3];c[z>>2]=9;gc=+h[(Fz(Fb,1,z)|0)>>3];c[y>>2]=10;fc=+h[(Fz(Fb,1,y)|0)>>3];c[x>>2]=12;cc=fc*Kb*+h[(Fz(Fb,1,x)|0)>>3]*4.73594929247646e-22;c[w>>2]=10;fc=+h[(Fz(Fb,1,w)|0)>>3];c[v>>2]=12;dc=+h[(Fz(Fb,1,v)|0)>>3];c[u>>2]=13;Gb=fc*dc*Kb*+h[(Fz(Fb,1,u)|0)>>3]*-13.6411358215175;c[t>>2]=13;dc=+h[(Fz(Fb,1,t)|0)>>3];c[s>>2]=6;fc=+h[(Fz(Fb,1,s)|0)>>3];c[r>>2]=7;jc=gc*(cc+(Gb+dc*fc*Kb*+h[(Fz(Fb,1,r)|0)>>3]*5.52427169406836e-10));c[q>>2]=5;fc=+h[(Fz(Fb,1,q)|0)>>3];c[p>>2]=17;dc=+h[(Fz(Fb,1,p)|0)>>3]*267174673301715.0e-20;c[o>>2]=12;Gb=+h[(Fz(Fb,1,o)|0)>>3];c[n>>2]=6;cc=Gb*Kb*+h[(Fz(Fb,1,n)|0)>>3]*4.44545133805865e-18;c[m>>2]=10;Gb=+h[(Fz(Fb,1,m)|0)>>3];c[l>>2]=13;gc=+h[(Fz(Fb,1,l)|0)>>3];c[k>>2]=6;kc=+h[(Fz(Fb,1,k)|0)>>3];c[j>>2]=7;lc=Lb+(Nb+(Mb+(d*-76465233.2452145+(Ob+(Qb+Pb*(Vb+(Xb+(Sb+(Wb+(Yb+(Zb+(ac+(_b+(Tb+($b+(bc+(Rb+(Ub+(ec+(ic+hc*(jc+fc*(dc+(cc+Gb*gc*kc*Kb*+h[(Fz(Fb,1,j)|0)>>3]*-50.2465185106411)))))))))))))))))+2513837.07870341))))))+4636975733.03507;c[g>>2]=1;h[a>>3]=lc/+h[(Fz(Fb,1,g)|0)>>3];i=e;return}function ci(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;c[u>>2]=3;Az(v,1,u);w=7.1-d/1653.0e4;if(!(d>611.657)){u=lz(lz(10216,jz(d,0,1,6)|0)|0,5248)|0;x=lz(lz(u,jz(611.657,0,1,6)|0)|0,5256)|0;u=c[28994]|0;y=f;z=10288;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];De[u&31](b,f,x,t);}c[s>>2]=1;h[(Fz(v,1,s)|0)>>3]=w*w;c[r>>2]=1;d=+h[(Fz(v,1,r)|0)>>3];c[q>>2]=2;h[(Fz(v,1,q)|0)>>3]=d*d;c[p>>2]=2;d=+h[(Fz(v,1,p)|0)>>3];c[o>>2]=3;h[(Fz(v,1,o)|0)>>3]=d*d;c[n>>2]=1;d=+h[(Fz(v,1,n)|0)>>3];c[m>>2]=2;A=+h[(Fz(v,1,m)|0)>>3];c[l>>2]=3;B=+h[(Fz(v,1,l)|0)>>3];c[k>>2]=1;C=+h[(Fz(v,1,k)|0)>>3];c[j>>2]=1;D=+h[(Fz(v,1,j)|0)>>3];c[g>>2]=2;h[a>>3]=(w*(w*(w*(w*(w*(d*w*(A*B*w*(C*(D*(w*(w*(w*9.64504638626269e-49+-7.06381628462585e-47)+1.73894459122923e-45)+-1.43870236842915e-44)*+h[(Fz(v,1,g)|0)>>3]+-8.12140581014818e-38)+5.35429206228374e-35)+8.43755552264362e-14)+1.73545618580828e-11)+-2.41630417490008e-7)+-418695814670391.0e-20)+-.00017146768241932)+-.022914084306349)+.173379420894777)*639675.036;i=e;return}function di(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+24|0;j=d/1.0e6;if(d>611.657){k=j*3.36540214679088e-7;l=k+-203245575263501.0e-19;m=j*l;n=m+-.00979043490246092;o=j*n;p=o+9.01505286876203;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}t=lz(lz(10312,jz(d,0,1,6)|0)|0,5248)|0;u=lz(lz(t,jz(611.657,0,1,6)|0)|0,5256)|0;t=c[28994]|0;v=f;w=10384;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];c[v+20>>2]=c[w+20>>2];De[t&31](b,f,u,g);k=j*3.36540214679088e-7;l=k+-203245575263501.0e-19;m=j*l;n=m+-.00979043490246092;o=j*n;p=o+9.01505286876203;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}function ei(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+24|0;j=d/1.0e6;if(d>611.657){k=j*7.5006972718273e-8;l=k+-5.01510211858761e-8;m=j*l;n=m+-.000489898813722568;o=j*n;p=o+15.9838891400332;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}t=lz(lz(10408,jz(d,0,1,6)|0)|0,5248)|0;u=lz(lz(t,jz(611.657,0,1,6)|0)|0,5256)|0;t=c[28994]|0;v=f;w=10480;c[v+0>>2]=c[w+0>>2];c[v+4>>2]=c[w+4>>2];c[v+8>>2]=c[w+8>>2];c[v+12>>2]=c[w+12>>2];c[v+16>>2]=c[w+16>>2];c[v+20>>2]=c[w+20>>2];De[t&31](b,f,u,g);k=j*7.5006972718273e-8;l=k+-5.01510211858761e-8;m=j*l;n=m+-.000489898813722568;o=j*n;p=o+15.9838891400332;q=p*461526.0;r=a;s=r;h[s>>3]=q;i=e;return}function fi(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0,v=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;c[p>>2]=2;Az(q,1,p);r=d/1.0e6;if(!(d>611.657)){p=lz(lz(10504,jz(d,0,1,6)|0)|0,5248)|0;s=lz(lz(p,jz(611.657,0,1,6)|0)|0,5256)|0;p=c[28994]|0;t=f;u=10576;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];De[p&31](b,f,s,o);}c[n>>2]=1;h[(Fz(q,1,n)|0)>>3]=r*r;c[m>>2]=1;d=+h[(Fz(q,1,m)|0)>>3];c[l>>2]=2;h[(Fz(q,1,l)|0)>>3]=d*d*d;c[k>>2]=1;d=+h[(Fz(q,1,k)|0)>>3];c[j>>2]=1;v=d*((r*(r*(r*(r*1.88543121025106e-84+-1.76117969553159e-103)+8.06630589170884e-129)+-3.71600586812966e-69)+1.6746290980312e-65)*+h[(Fz(q,1,j)|0)>>3]+-8.00969737237617e-134)+-7.5656940729795e-74;c[g>>2]=2;h[a>>3]=r*(r*(r*(r*(r*(r*(r*(r*(r*(r*(+h[(Fz(q,1,g)|0)>>3]*v+3.37267475986401e-21)+7.16825117265975e-32)+7.56960433802525e-23)+-3.79407294691742e-25)+-1.27295130636232e-10)+4.2261295097284e-15)+-.000172486052272327)+.109090430596056)+-8.53409968320258)+-4518.48617188327)+4160663.37647071;i=e;return}function gi(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0;j=i;i=i+104|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=j+32|0;p=j+40|0;q=j+48|0;r=j+56|0;s=j+64|0;t=j+72|0;u=j+80|0;v=j+88|0;w=j+96|0;do{if((g|0)==0){Dh(k,b,d);x=+h[k>>3];Eh(l,b,d);y=+h[l>>3];if((f|0)==2){z=4;break}ci(m,b,d);A=+h[m>>3];ei(n,b,d);B=+h[n>>3];fi(o,b,d);if(d<611.657|d>1.0e8|A>e){z=-1;break}C=d<1.0e7;if(C&B<e){z=-1;break}if(d>=1.0e7&+h[o>>3]<e){z=-1;break}D=e<2087546.84511715;if(!(d<16529200.0)){if(D){ai(v,b,d);if(+h[v>>3]>e){z=1;break}z=x>e|d>22064.0e3?3:4;break}else{bi(w,b,d);if(+h[w>>3]<e){z=2;break}z=y<e|d>22064.0e3?3:4;break}}if(D){if((f|0)==1){z=1;break}Ih(p,b,d);Sg(q,b,d,+h[p>>3]);z=+h[q>>3]>e?1:4;break}di(r,b,d);if(!(+h[r>>3]<e)){if((f|0)==1){z=2;break}Ih(t,b,d);Xh(u,b,d,+h[t>>3]);z=+h[u>>3]<e?2:4;break}ei(s,b,d);if(C){if(+h[s>>3]>e){z=5;break}}z=-2}else{z=g}}while(0);c[a>>2]=z;i=j;return}function hi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0;g=i;i=i+16|0;j=g;k=g+8|0;do{if((f|0)==0){if(d<16529200.0){if(e>1073.15){l=5;break}Ih(j,b,d);l=+h[j>>3]<e?2:1;break}else{if(e<623.15){l=1;break}Mh(k,b,d);l=+h[k>>3]>e?3:2;break}}else{l=f}}while(0);c[a>>2]=l;i=g;return}function ii(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0;j=i;i=i+536|0;k=j;l=j+24|0;m=j+48|0;n=j+112|0;o=j+176|0;p=j+264|0;q=j+352|0;r=j+440|0;s=j+528|0;t=i;i=i+8|0;u=i;i=i+64|0;v=i;i=i+64|0;w=i;i=i+88|0;x=i;i=i+88|0;y=i;i=i+88|0;z=i;i=i+88|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+88|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+24|0;G=i;i=i+88|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+88|0;M=i;i=i+88|0;N=i;i=i+64|0;O=i;i=i+64|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+88|0;T=i;i=i+88|0;V=i;i=i+64|0;W=i;i=i+64|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+16|0;_=i;i=i+88|0;do{if((g|0)==0){if((f|0)==2){$=+pd(+d,611.657);aa=+pd(+e,1.0e3);ba=$;ca=2;da=11;break}else{gi(A,b,d,e,f,0);ea=c[A>>2]|0;da=5;break}}else{ea=g;da=5}}while(0);a:do{if((da|0)==5){if((f|0)==0){fa=(ea|0)==4?2:1}else{fa=f}$=+pd(+d,611.657);ga=+pd(+e,1.0e3);switch(ea|0){case 1:{sh(B,b,$,ga);ha=+h[B>>3];yh(C,b,d,ha);ia=+h[C+24>>3];ja=+h[C+32>>3];ka=+h[C+48>>3];la=+h[C+56>>3];ma=+h[C+72>>3];na=+h[C+80>>3];oa=(ja*+h[C+64>>3]- +h[C+40>>3])*461.526;pa=ia*ka;qa=(pa-ja*ia*na)/d*461.526;ra=ha*ia*ia*la*+iA(d,-2)*461.526;ia=ja*ja*ma;ma=ka-ja*na;sa=$;ta=fa;ua=0.0;va=0.0;wa=qa;xa=ra;ya=0.0;za=-qa/ra;Aa=ha;Ba=ga;Ca=ia*-461.526;Da=(ma*ma/la-ia)*461.526;Ea=d/(ha*pa*461.526);Fa=oa;Ga=1;break a;break};case 2:{Jh(D,0,$,ga);oa=+h[D>>3];th(E,b,d,oa);pa=+h[E+24>>3];ha=+h[E+32>>3];ia=+h[E+48>>3];la=+h[E+56>>3];ma=+h[E+72>>3];ra=+h[E+80>>3];qa=(ha*+h[E+64>>3]- +h[E+40>>3])*461.526;na=pa*ia;ja=(na-ha*pa*ra)/d*461.526;ka=oa*pa*pa*la*+iA(d,-2)*461.526;pa=ha*ha*ma;ma=ia-ha*ra;sa=$;ta=fa;ua=0.0;va=0.0;wa=ja;xa=ka;ya=1.0;za=-ja/ka;Aa=oa;Ba=ga;Ca=pa*-461.526;Da=(ma*ma/la-pa)*461.526;Ea=d/(oa*na*461.526);Fa=qa;Ga=2;break a;break};case 3:{Ch(F,b,$,ga,1.0e-7,1.0e-6);qa=+h[F>>3];na=+h[F+8>>3];uh(G,b,qa,na);oa=+h[G+24>>3];pa=+h[G+32>>3];la=+h[G+48>>3];ma=pa*+h[G+64>>3];ka=na*oa*(la*2.0+oa*+h[G+56>>3])*461.526;ja=qa*oa*(la-pa*+h[G+80>>3])*461.526;ra=+U(+(pa*pa*+h[G+72>>3]*-461.526));pa=qa*qa;sa=$;ta=fa;ua=ja;va=ka;wa=0.0;xa=0.0;ya=0.0;za=ja;Aa=na;Ba=na*(oa*la+ma)*461.526;Ca=(pa*ra*ka+na*ja*ja)/(pa*ka);Da=ra;Ea=qa;Fa=(ma- +h[G+40>>3])*461.526;Ga=3;break a;break};case 4:{aa=ga;ba=$;ca=fa;da=11;break a;break};case 5:{Th(Z,b,$,ga,1.0e-7);ma=+h[Z>>3];if((c[Z+8>>2]|0)!=0){g=c[28994]|0;A=l;Ha=10600;c[A+0>>2]=c[Ha+0>>2];c[A+4>>2]=c[Ha+4>>2];c[A+8>>2]=c[Ha+8>>2];c[A+12>>2]=c[Ha+12>>2];c[A+16>>2]=c[Ha+16>>2];c[A+20>>2]=c[Ha+20>>2];De[g&31](b,l,10624,t);}Ah(_,b,$,ma);qa=+h[_+24>>3];ra=+h[_+32>>3];ka=+h[_+48>>3];pa=+h[_+56>>3];ja=+h[_+72>>3];na=+h[_+80>>3];la=(ra*+h[_+64>>3]- +h[_+40>>3])*461.526;oa=qa*ka;ha=(oa-ra*qa*na)/d*461.526;ia=ma*qa*qa*pa*+iA(d,-2)*461.526;qa=ra*ra*ja;ja=ka-ra*na;sa=$;ta=fa;ua=0.0;va=0.0;wa=ha;xa=ia;ya=0.0;za=-ha/ia;Aa=ma;Ba=ga;Ca=qa*-461.526;Da=(ja*ja/pa-qa)*461.526;Ea=d/(ma*oa*461.526);Fa=la;Ga=5;break a;break};default:{g=lz(lz(lz(lz(10672,jz(d,0,1,6)|0)|0,10728)|0,jz(e,0,1,6)|0)|0,10736)|0;Ha=c[28994]|0;A=k;Ia=10744;c[A+0>>2]=c[Ia+0>>2];c[A+4>>2]=c[Ia+4>>2];c[A+8>>2]=c[Ia+8>>2];c[A+12>>2]=c[Ia+12>>2];c[A+16>>2]=c[Ia+16>>2];c[A+20>>2]=c[Ia+20>>2];De[Ha&31](b,k,g,s);sa=$;ta=fa;ua=0.0;va=0.0;wa=0.0;xa=0.0;ya=0.0;za=0.0;Aa=0.0;Ba=ga;Ca=0.0;Da=0.0;Ea=0.0;Fa=0.0;Ga=ea;break a}}}}while(0);if((da|0)==11){ji(H,b,d);ga=+h[H>>3];ki(I,b,d);$=+h[I>>3];if($!=ga){Ja=(e-ga)/($-ga)}else{Ja=1.0}if(d<16529200.0){sh(J,b,ba,ga);ga=+h[J>>3];Jh(K,0,ba,$);$=+h[K>>3];yh(L,b,ba,ga);e=+h[L+8>>3];la=+h[L+16>>3];oa=+h[L+24>>3];ma=+h[L+32>>3];qa=+h[L+40>>3];pa=+h[L+48>>3];ja=+h[L+56>>3];ia=+h[L+64>>3];ha=+h[L+72>>3];na=+h[L+80>>3];h[w>>3]=+h[L>>3];h[w+8>>3]=e;h[w+16>>3]=la;h[w+24>>3]=oa;h[w+32>>3]=ma;h[w+40>>3]=qa;h[w+48>>3]=pa;h[w+56>>3]=ja;h[w+64>>3]=ia;h[w+72>>3]=ha;h[w+80>>3]=na;th(M,b,ba,$);na=+h[M+8>>3];ha=+h[M+16>>3];ia=+h[M+24>>3];ja=+h[M+32>>3];pa=+h[M+40>>3];qa=+h[M+48>>3];ma=+h[M+56>>3];oa=+h[M+64>>3];la=+h[M+72>>3];e=+h[M+80>>3];h[x>>3]=+h[M>>3];h[x+8>>3]=na;h[x+16>>3]=ha;h[x+24>>3]=ia;h[x+32>>3]=ja;h[x+40>>3]=pa;h[x+48>>3]=qa;h[x+56>>3]=ma;h[x+64>>3]=oa;h[x+72>>3]=la;h[x+80>>3]=e;Ka=r+0|0;La=w+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));qh(N,0,r);e=+h[N+8>>3];la=+h[N+16>>3];oa=+h[N+24>>3];ma=+h[N+32>>3];qa=+h[N+40>>3];pa=+h[N+48>>3];ja=+h[N+56>>3];h[u>>3]=+h[N>>3];h[u+8>>3]=e;h[u+16>>3]=la;h[u+24>>3]=oa;h[u+32>>3]=ma;h[u+40>>3]=qa;h[u+48>>3]=pa;h[u+56>>3]=ja;Ka=q+0|0;La=x+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));qh(O,0,q);ja=+h[O>>3];pa=+h[O+8>>3];qa=+h[O+16>>3];ma=+h[O+24>>3];oa=+h[O+32>>3];la=+h[O+40>>3];e=+h[O+48>>3];ia=+h[O+56>>3];h[v>>3]=ja;h[v+8>>3]=pa;h[v+16>>3]=qa;h[v+24>>3]=ma;h[v+32>>3]=oa;h[v+40>>3]=la;h[v+48>>3]=e;h[v+56>>3]=ia;Na=ma;Oa=ja;Pa=ga+Ja*($-ga)}else{Ih(P,b,ba);ga=+h[P>>3];li(Q,b,ga);$=+h[Q>>3];mi(R,b,ga);ja=+h[R>>3];uh(S,b,$,ga);$=+h[S+8>>3];ma=+h[S+16>>3];ia=+h[S+24>>3];e=+h[S+32>>3];la=+h[S+40>>3];oa=+h[S+48>>3];qa=+h[S+56>>3];pa=+h[S+64>>3];ha=+h[S+72>>3];na=+h[S+80>>3];h[y>>3]=+h[S>>3];h[y+8>>3]=$;h[y+16>>3]=ma;h[y+24>>3]=ia;h[y+32>>3]=e;h[y+40>>3]=la;h[y+48>>3]=oa;h[y+56>>3]=qa;h[y+64>>3]=pa;h[y+72>>3]=ha;h[y+80>>3]=na;uh(T,b,ja,ga);ja=+h[T+8>>3];na=+h[T+16>>3];ha=+h[T+24>>3];pa=+h[T+32>>3];qa=+h[T+40>>3];oa=+h[T+48>>3];la=+h[T+56>>3];e=+h[T+64>>3];ia=+h[T+72>>3];ma=+h[T+80>>3];h[z>>3]=+h[T>>3];h[z+8>>3]=ja;h[z+16>>3]=na;h[z+24>>3]=ha;h[z+32>>3]=pa;h[z+40>>3]=qa;h[z+48>>3]=oa;h[z+56>>3]=la;h[z+64>>3]=e;h[z+72>>3]=ia;h[z+80>>3]=ma;Ka=p+0|0;La=y+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));ph(V,0,p);ma=+h[V+8>>3];ia=+h[V+16>>3];e=+h[V+24>>3];la=+h[V+32>>3];oa=+h[V+40>>3];qa=+h[V+48>>3];pa=+h[V+56>>3];h[u>>3]=+h[V>>3];h[u+8>>3]=ma;h[u+16>>3]=ia;h[u+24>>3]=e;h[u+32>>3]=la;h[u+40>>3]=oa;h[u+48>>3]=qa;h[u+56>>3]=pa;Ka=o+0|0;La=z+0|0;Ma=Ka+88|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));ph(W,0,o);pa=+h[W>>3];qa=+h[W+8>>3];oa=+h[W+16>>3];la=+h[W+24>>3];e=+h[W+32>>3];ia=+h[W+40>>3];ma=+h[W+48>>3];ha=+h[W+56>>3];h[v>>3]=pa;h[v+8>>3]=qa;h[v+16>>3]=oa;h[v+24>>3]=la;h[v+32>>3]=e;h[v+40>>3]=ia;h[v+48>>3]=ma;h[v+56>>3]=ha;Na=la;Oa=pa;Pa=ga}W=u;ga=+h[W>>3];if(ga!=Oa){pa=+h[u+24>>3];Qa=Oa;Ra=ga;Sa=Na;Ta=pa;Ua=(Na-pa)*ga*(Oa/(ga-Oa))}else{xh(X,b,Pa);Qa=+h[v>>3];Ra=+h[W>>3];Sa=+h[v+24>>3];Ta=+h[u+24>>3];Ua=+h[X>>3]}Oa=Ta+Ja*(Sa-Ta);Ta=Ra*(Qa/(Qa+Ja*(Ra-Qa)));Ka=n+0|0;La=u+0|0;Ma=Ka+64|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));Ka=m+0|0;La=v+0|0;Ma=Ka+64|0;do{c[Ka>>2]=c[La>>2];Ka=Ka+4|0;La=La+4|0}while((Ka|0)<(Ma|0));rh(Y,0,n,m,Ja,Pa,d);d=+h[u+32>>3];Qa=+h[u+48>>3];Ra=+h[u+56>>3];sa=ba;ta=ca;ua=Qa+Ja*(+h[v+48>>3]-Qa);va=Ra+Ja*(+h[v+56>>3]-Ra);wa=0.0;xa=0.0;ya=Ja;za=Ua;Aa=Pa;Ba=aa;Ca=d+Ja*(+h[v+32>>3]-d);Da=+h[Y>>3];Ea=Ta;Fa=Oa;Ga=4}c[a>>2]=ta;c[a+4>>2]=Ga;h[a+8>>3]=sa;h[a+16>>3]=Aa;h[a+24>>3]=Ba;h[a+32>>3]=461.526;h[a+40>>3]=Ca;h[a+48>>3]=Da;h[a+56>>3]=Ea;h[a+64>>3]=Fa;h[a+72>>3]=ua;h[a+80>>3]=va;h[a+88>>3]=wa;h[a+96>>3]=xa;h[a+104>>3]=ya;h[a+112>>3]=za;i=j;return}function ji(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;Wh(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));$h(b,0,0.0,f);i=e;return}function ki(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;Yh(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));$h(b,0,0.0,f);i=e;return}function li(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Bh(e,b,c);j=+h[e>>3];do{if(c<623.15){Vh(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Ph(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function mi(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Bh(e,b,c);j=+h[e>>3];do{if(c<623.15){_h(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Rh(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function ni(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+16>>3];i=i;return}function oi(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+24>>3];i=i;return}function pi(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0;g=i;i=i+56|0;j=g;k=g+24|0;l=g+48|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;c[n>>2]=42;Az(o,1,n);n=o;o=10768;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];c[n+8>>2]=c[o+8>>2];p=e+-273.15;q=d/317.763;if(!(d>.004854575724778614)){o=lz(lz(10784,jz(d,0,1,6)|0)|0,10864)|0;n=lz(lz(o,jz(.004854575724778614,0,1,6)|0)|0,10872)|0;o=c[28994]|0;r=k;s=10896;c[r+0>>2]=c[s+0>>2];c[r+4>>2]=c[s+4>>2];c[r+8>>2]=c[s+8>>2];c[r+12>>2]=c[s+12>>2];c[r+16>>2]=c[s+16>>2];c[r+20>>2]=c[s+20>>2];De[o&31](b,k,n,m);}if(!(f<=5.0e8)){t=5}else{if(!(p>=0.0&p<=150.0)){t=5}}do{if((t|0)==5){if(f<=35.0e7){if(p>150.0&p<=600.0){break}}if(f<=3.0e8){if(p>600.0&p<=900.0){break}}m=lz(lz(10920,jz(f,0,1,6)|0)|0,11032)|0;n=lz(lz(m,jz(p,0,1,6)|0)|0,9520)|0;m=c[28994]|0;k=j;o=11048;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];c[k+16>>2]=c[o+16>>2];c[k+20>>2]=c[o+20>>2];De[m&31](b,j,n,l);}}while(0);p=q+-1.0;f=647.226/e;e=f+-1.0;d=+W(+f,-.5)/(f*(f*(f*-.202354+.579829)+.978197)+1.0);if((bh(1,1,6)|0)==0){u=0.0;v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}l=(bh(0,0,6)|0)==0;f=0.0;j=1;B=1.0;while(1){if((j|0)==1){C=B}else{C=e*B}if(l){D=f}else{b=j+ -1|0;E=f;t=0;F=1.0;while(1){if((t|0)==0){G=F}else{G=p*F}H=E+ +yz(10768,b+(t*6|0)|0)*C*G;n=t+1|0;if((bh(n,0,6)|0)==0){D=H;break}else{E=H;t=n;F=G}}}t=j+1|0;if((bh(t,1,6)|0)==0){u=D;break}else{f=D;j=t;B=C}}v=q*u;w=+ca(+v);x=d*w;y=x*55071.0e-9;z=a;A=z;h[A>>3]=y;i=g;return}function qi(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+8|0;m=i;i=i+88|0;n=i;i=i+88|0;o=i;i=i+16|0;p=i;i=i+88|0;q=i;i=i+88|0;if((f|0)==0){hi(l,b,d,e,0);r=c[l>>2]|0}else{r=f}if((r|0)==3){Kh(o,b,d,e,1.0e-7);s=+h[o>>3];uh(p,b,s,e);t=+h[p+24>>3];u=+h[p+32>>3];v=+h[p+48>>3];w=u*+h[p+64>>3];x=s*t*(v-u*+h[p+80>>3])*461.526;y=x;z=t*(v*2.0+t*+h[p+56>>3])*e*461.526;A=0.0;B=0.0;C=0.0;D=x;E=(t*v+w)*e*461.526;F=0.0;G=u*u*+h[p+72>>3]*-461.526;H=s;I=(w- +h[p+40>>3])*461.526}else if((r|0)==1){yh(m,b,d,e);w=+h[m+24>>3];s=+h[m+32>>3];u=+h[m+48>>3];v=+h[m+56>>3];t=+h[m+72>>3];x=+h[m+80>>3];J=s*+h[m+64>>3];K=(J- +h[m+40>>3])*461.526;L=w*u;M=(L-s*w*x)/d*461.526;N=w*w*v*+iA(d,-2)*e*461.526;w=s*s*t;t=u-s*x;y=0.0;z=0.0;A=M;B=N;C=0.0;D=-M/N;E=J*e*461.526;F=w*-461.526;G=(t*t/v-w)*461.526;H=d/(L*e*461.526);I=K}else if((r|0)==5){Ah(q,b,d,e);K=+h[q+24>>3];L=+h[q+32>>3];w=+h[q+48>>3];v=+h[q+56>>3];t=+h[q+72>>3];J=+h[q+80>>3];N=L*+h[q+64>>3];M=(N- +h[q+40>>3])*461.526;x=K*w;s=(x-L*K*J)/d*461.526;u=K*K*v*+iA(d,-2)*e*461.526;K=L*L*t;t=w-L*J;y=0.0;z=0.0;A=s;B=u;C=1.0;D=-s/u;E=N*e*461.526;F=K*-461.526;G=(t*t/v-K)*461.526;H=d/(x*e*461.526);I=M}else if((r|0)==2){th(n,b,d,e);M=+h[n+24>>3];x=+h[n+32>>3];K=+h[n+48>>3];v=+h[n+56>>3];t=+h[n+72>>3];N=+h[n+80>>3];u=x*+h[n+64>>3];s=(u- +h[n+40>>3])*461.526;J=M*K;L=(J-x*M*N)/d*461.526;w=M*M*v*+iA(d,-2)*e*461.526;M=x*x*t;t=K-x*N;y=0.0;z=0.0;A=L;B=w;C=1.0;D=-L/w;E=u*e*461.526;F=M*-461.526;G=(t*t/v-M)*461.526;H=d/(J*e*461.526);I=s}else{n=lz(lz(10672,jz(d,0,1,6)|0)|0,11072)|0;q=lz(lz(n,jz(e,0,1,6)|0)|0,10736)|0;n=c[28994]|0;m=j;p=11080;c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];c[m+12>>2]=c[p+12>>2];c[m+16>>2]=c[p+16>>2];c[m+20>>2]=c[p+20>>2];De[n&31](b,j,q,k);y=0.0;z=0.0;A=0.0;B=0.0;C=0.0;D=0.0;E=0.0;F=0.0;G=0.0;H=0.0;I=0.0}c[a>>2]=1;c[a+4>>2]=r;h[a+8>>3]=d;h[a+16>>3]=e;h[a+24>>3]=E;h[a+32>>3]=461.526;h[a+40>>3]=F;h[a+48>>3]=G;h[a+56>>3]=H;h[a+64>>3]=I;h[a+72>>3]=y;h[a+80>>3]=z;h[a+88>>3]=A;h[a+96>>3]=B;h[a+104>>3]=C;h[a+112>>3]=D;i=g;return}function ri(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function si(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=+g;j=+j;var k=0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0;b=i;k=c[f+4>>2]|0;if((k|0)==4){e=+h[f+56>>3];d=+h[f+112>>3];l=d*+h[f+16>>3];m=e*(e*(+h[f+48>>3]/d)+1.0)*(g/l)-e*e/l*j;n=a;o=n;h[o>>3]=m;i=b;return}l=+h[f+56>>3];if((k|0)==3){e=+h[f+72>>3];d=+h[f+48>>3];p=l*l;q=p*d*+h[f+80>>3]+e*e*+h[f+16>>3];m=l*(e+l*d)*(g/q)-p*e*(j/q);n=a;o=n;h[o>>3]=m;i=b;return}else{q=+h[f+88>>3];e=+h[f+40>>3];m=-(l*l*((+h[f+96>>3]+(q*q*+h[f+16>>3]-q/l)/e)*g+q*(j/e)));n=a;o=n;h[o>>3]=m;i=b;return}}function ti(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=+d;e=e|0;h[a>>3]=+h[e+56>>3];i=i;return}function ui(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;Gy(4,0,14616,b);Gy(4,0,14656,a);i=a;return}function vi(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}q1(a);c[d>>2]=0;i=b;return}function wi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+464>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+464>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+40>>3],+h[k+248>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+8|0]|0)!=0){m=0;n=k;o=n+5|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+5|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+5|0;p=o;a[p]=m;i=d;return}function xi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+10|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+10|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+192>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+192>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+10|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+192>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+120>>3],+h[k+648>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+2|0]|0)!=0){m=0;a[k]=m;i=d;return}if(!(f<<24>>24==0)){m=1;a[k]=m;i=d;return}m=b<<24>>24!=0|0;a[k]=m;i=d;return}function yi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;d=i;i=i+248|0;e=d;f=d+120|0;g=d+240|0;j=b+536|0;k=c[j>>2]|0;l=b+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;o=+h[n+488>>3];p=+pd(+-+h[n+344>>3],1.0e-15);q=p+1.0e-15;r=p*+h[n+880>>3]+8.40130581525969e-11;do{if(q!=0.0){s=r/q}else{if(r==0.0){s=r;break}s=r/+My(k,q,14712,14704,+h[m>>3],(a[b+319|0]|0)!=0|0)}}while(0);ii(f,k,o,s,0,0);k=c[j>>2]|0;j=c[c[l>>2]>>2]|0;m=c[j+8>>2]|0;s=+h[m+488>>3];o=+pd(+-+h[m+344>>3],1.0e-15);q=o+1.0e-15;r=o*+h[m+880>>3]+8.40130581525969e-11;do{if(q!=0.0){t=r/q}else{if(r==0.0){t=r;break}t=r/+My(k,q,14712,14704,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=e+0|0;j=f+0|0;f=b+120|0;do{c[b>>2]=c[j>>2];b=b+4|0;j=j+4|0}while((b|0)<(f|0));ri(g,k,s,t,e);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+584>>3]=+h[g>>3];i=d;return}function zi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+312>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+368>>3]=+h[f>>3];i=b;return}function Ai(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+312>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+432>>3]=+h[f>>3];i=b;return}function Bi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;pi(d,c[a+536>>2]|0,+h[f+432>>3],+h[f+368>>3],+h[f+312>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+408>>3]=+h[d>>3];i=b;return}function Ci(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+344>>3]),1.0e-15);k=j+1.0e-15;l=j*+h[g+16>>3]+8.40130581525969e-11;if(k!=0.0){m=g;n=l/k;o=m;p=o+384|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+384|0;q=p;h[q>>3]=n;i=d;return}j=l/+My(c[b+536>>2]|0,k,14768,14760,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+384|0;q=p;h[q>>3]=n;i=d;return}function Di(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+872>>3]=+h[b+384>>3]- +h[d+336>>3]*+h[d+432>>3];i=i;return}function Ei(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+208>>3],+h[a+872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+208>>3];l=+h[g+872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+272>>3]=+h[f>>3];i=b;return}function Fi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+888>>3],+h[a+384>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+888>>3];l=+h[g+384>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+424>>3]=+h[f>>3];i=b;return}function Gi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+888>>3],+h[a+384>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+888>>3];l=+h[g+384>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+376>>3]=+h[f>>3];i=b;return}function Hi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;pi(d,c[a+536>>2]|0,+h[f+424>>3],+h[f+376>>3],+h[f+888>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+400>>3]=+h[d>>3];i=b;return}function Ii(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+328>>3]=+h[b+456>>3]*(+h[d+312>>3]- +h[d+888>>3])*+h[b+488>>3];i=i;return}function Ji(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+456>>3]*+h[e+488>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+328>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}k=l/+My(c[b+536>>2]|0,f,14824,14816,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}function Ki(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2768>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2744>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2752>>3];h[a+8>>3]=+h[d+6576>>3];h[e+8>>3]=+h[d+6552>>3];h[f+8>>3]=+h[d+6560>>3];h[a+16>>3]=+h[d+4896>>3];h[e+16>>3]=+h[d+4872>>3];h[f+16>>3]=+h[d+4880>>3];h[a+24>>3]=+h[d+4448>>3];h[e+24>>3]=+h[d+4424>>3];h[f+24>>3]=+h[d+4432>>3];h[a+32>>3]=+h[d+12512>>3];h[e+32>>3]=+h[d+12488>>3];h[f+32>>3]=+h[d+12496>>3];i=i;return}function Li(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0.0,N=0.0,O=0,P=0.0,Q=0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0,aa=0,ba=0.0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0.0,ia=0,ja=0.0,ka=0,la=0,ma=0.0,na=0.0,oa=0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0,ua=0.0,va=0.0,wa=0,xa=0,ya=0,za=0.0;f=i;i=i+24|0;g=f;j=f+8|0;k=f+16|0;l=b;m=b+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;h[n+192>>3]=+h[d>>3];h[n+464>>3]=+h[d+8>>3];h[n+344>>3]=+h[d+16>>3];h[n+312>>3]=+h[d+24>>3];h[n+888>>3]=+h[d+32>>3];wi(l);xi(l);yi(l);zi(l);Ai(l);Bi(l);Ci(l);Di(l);Ei(l);Fi(l);Gi(l);Hi(l);Ii(l);Ji(l);l=c[c[m>>2]>>2]|0;d=c[l+16>>2]|0;do{if((a[d+8|0]|0)==0){n=c[l+8>>2]|0;if((a[d+5|0]|0)==0){o=n;p=d;q=l;r=-+h[n+344>>3];break}else{o=n;p=d;q=l;r=+h[n+888>>3]- +h[n+488>>3];break}}else{n=b+304|0;s=+h[n>>3];t=b+416|0;u=c[t>>2]|0;v=+h[u+264>>3];w=c[l+8>>2]|0;x=+h[w+696>>3];do{if(v!=0.0){y=x;z=w;A=l;B=v;C=u;D=x/v}else{if(x==0.0){y=x;z=w;A=l;B=v;C=u;D=x;break}E=x/+My(c[b+536>>2]|0,v,14880,14872,+h[l>>3],(a[b+319|0]|0)!=0|0);F=c[t>>2]|0;G=c[c[m>>2]>>2]|0;H=c[G+8>>2]|0;y=+h[H+696>>3];z=H;A=G;B=+h[F+264>>3];C=F;D=E}}while(0);do{if(B!=0.0){I=C;J=z;K=A;L=y/B}else{if(y==0.0){I=C;J=z;K=A;L=y;break}v=y/+My(c[b+536>>2]|0,B,14880,14872,+h[A>>3],(a[b+319|0]|0)!=0|0);u=c[c[m>>2]>>2]|0;I=c[t>>2]|0;J=c[u+8>>2]|0;K=u;L=v}}while(0);u=b+536|0;w=c[u>>2]|0;v=-+h[J+344>>3];x=+h[I+208>>3];E=D*D+ +h[I+56>>3]+-1.0;M=+h[J+584>>3];N=+h[J+512>>3];do{if(M!=0.0){O=I;P=N;Q=J;R=K;S=N/M}else{if(N==0.0){O=I;P=N;Q=J;R=K;S=N;break}T=N/+My(w,M,14904,14872,+h[K>>3],(a[b+319|0]|0)!=0|0);F=c[c[m>>2]>>2]|0;G=c[F+8>>2]|0;O=c[t>>2]|0;P=+h[G+512>>3];Q=G;R=F;S=T}}while(0);M=E*S;N=P*+h[Q+984>>3];T=+h[O+48>>3]-L*L+1.0;do{if(N!=0.0){U=T/N}else{if(T==0.0){U=T;break}U=T/+My(c[u>>2]|0,N,14936,14872,+h[R>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(g,w,v,x,M,U,0,1.0);N=+h[g>>3];T=+h[n>>3];u=c[(c[c[m>>2]>>2]|0)+8>>2]|0;E=+h[u+888>>3];V=+h[u+488>>3];W=s*(V+N*+iA(+h[u+696>>3],-2)*.5);u=c[c[m>>2]>>2]|0;t=c[u+8>>2]|0;o=t;p=c[u+16>>2]|0;q=u;r=E-(W+(1.0-T)*+h[t+488>>3])}}while(0);h[e>>3]=r;do{if((a[p+2|0]|0)==0){if((a[p]|0)==0){X=o;Y=q;Z=+h[o+344>>3];break}else{X=o;Y=q;Z=+h[o+312>>3]- +h[o+208>>3];break}}else{g=b+304|0;r=+h[g>>3];R=b+416|0;O=c[R>>2]|0;U=+h[O+664>>3];L=+h[o+664>>3];do{if(U!=0.0){_=L;$=o;aa=q;ba=U;ca=O;da=L/U}else{if(L==0.0){_=L;$=o;aa=q;ba=U;ca=O;da=L;break}P=L/+My(c[b+536>>2]|0,U,14992,14872,+h[q>>3],(a[b+319|0]|0)!=0|0);Q=c[R>>2]|0;K=c[c[m>>2]>>2]|0;J=c[K+8>>2]|0;_=+h[J+664>>3];$=J;aa=K;ba=+h[Q+664>>3];ca=Q;da=P}}while(0);do{if(ba!=0.0){ea=ca;fa=$;ga=aa;ha=_/ba}else{if(_==0.0){ea=ca;fa=$;ga=aa;ha=_;break}U=_/+My(c[b+536>>2]|0,ba,14992,14872,+h[aa>>3],(a[b+319|0]|0)!=0|0);O=c[c[m>>2]>>2]|0;ea=c[R>>2]|0;fa=c[O+8>>2]|0;ga=O;ha=U}}while(0);O=b+536|0;n=c[O>>2]|0;U=+h[fa+344>>3];L=+h[ea+608>>3];s=da*da+ +h[ea+136>>3]+-1.0;M=+h[fa+272>>3];x=+h[fa+224>>3];do{if(M!=0.0){ia=ea;ja=x;ka=fa;la=ga;ma=x/M}else{if(x==0.0){ia=ea;ja=x;ka=fa;la=ga;ma=x;break}v=x/+My(n,M,15016,14872,+h[ga>>3],(a[b+319|0]|0)!=0|0);w=c[c[m>>2]>>2]|0;Q=c[w+8>>2]|0;ia=c[R>>2]|0;ja=+h[Q+224>>3];ka=Q;la=w;ma=v}}while(0);M=s*ma;x=ja*+h[ka+816>>3];v=+h[ia+128>>3]-ha*ha+1.0;do{if(x!=0.0){na=v/x}else{if(v==0.0){na=v;break}na=v/+My(c[O>>2]|0,x,15048,14872,+h[la>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(j,n,U,L,M,na,0,1.0);x=+h[j>>3];v=+h[g>>3];O=c[(c[c[m>>2]>>2]|0)+8>>2]|0;s=+h[O+312>>3];P=+h[O+208>>3];S=r*(P+x*+iA(+h[O+664>>3],-2)*.5);O=c[c[m>>2]>>2]|0;R=c[O+8>>2]|0;X=R;Y=O;Z=s-(S+(1.0-v)*+h[R+208>>3])}}while(0);h[e+8>>3]=Z;Z=+h[b+304>>3];j=b+536|0;la=c[j>>2]|0;na=+h[X+320>>3];ha=+h[X+424>>3];ja=+h[X+432>>3];ma=+h[X+400>>3];da=+h[X+408>>3];ia=b+416|0;ka=c[ia>>2]|0;ba=+h[ka+408>>3];_=+h[X+680>>3];v=+h[ka+432>>3]*+h[ka+552>>3];S=+h[ka+424>>3];s=(S+S)*.5;X=(c[(c[b+420>>2]|0)+52>>2]|0)+ -1|0;S=+(X|0);x=+h[ka+544>>3];do{if((X|0)==0){if(x==0.0){oa=ka;pa=x;break}P=x/+My(la,S,15104,14872,+h[Y>>3],(a[b+319|0]|0)!=0|0);oa=c[ia>>2]|0;pa=P}else{oa=ka;pa=x/S}}while(0);Tg(k,la,na,ha,ja,ma,da,ba,_,v,s,pa,+h[oa+512>>3]);pa=+h[k>>3];k=c[c[m>>2]>>2]|0;oa=c[k+8>>2]|0;s=+h[oa+344>>3];v=Z+-1.0;la=c[ia>>2]|0;_=+h[oa+320>>3]- +h[la+432>>3]*+h[la+552>>3]*+h[la+568>>3];ba=+h[la+520>>3];da=+h[la+528>>3];do{if(ba!=0.0){qa=k;ra=la;sa=da/ba}else{if(da==0.0){qa=k;ra=la;sa=da;break}ma=da/+My(c[j>>2]|0,ba,15136,14872,+h[k>>3],(a[b+319|0]|0)!=0|0);qa=c[c[m>>2]>>2]|0;ra=c[ia>>2]|0;sa=ma}}while(0);h[e+16>>3]=s+(v*_*sa-Z*pa*+h[ra+488>>3]);ia=c[qa+16>>2]|0;do{if((a[ia+8|0]|0)==0){m=c[qa+8>>2]|0;pa=+h[m+464>>3];if((a[ia+5|0]|0)==0){ta=m;ua=pa-(+h[m+888>>3]- +h[m+488>>3])*(+h[ra+40>>3]- +h[m+24>>3])*9869232667160129.0e-21;break}else{ta=m;ua=pa+ +h[m+344>>3];break}}else{m=c[qa+8>>2]|0;ta=m;ua=+h[m+464>>3]-(+h[m+24>>3]- +h[ra+40>>3])}}while(0);h[e+24>>3]=ua;if((a[ia+2|0]|0)!=0){va=+h[ta+192>>3]-(+h[ta+8>>3]- +h[ra+120>>3]);wa=e;xa=wa+32|0;ya=xa;h[ya>>3]=va;i=f;return}if((a[ia]|0)==0){za=(+h[ta+312>>3]- +h[ta+208>>3])*(+h[ra+120>>3]- +h[ta+8>>3])*9869232667160129.0e-21}else{za=+h[ta+344>>3]}va=+h[ta+192>>3]-za;wa=e;xa=wa+32|0;ya=xa;h[ya>>3]=va;i=f;return}function Mi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+13|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+13|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+456>>3],0.0,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+456>>3],0.0,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+13|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0;a[(c[b+352>>2]|0)+13|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0;a[(c[b+352>>2]|0)+13|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+8>>3],+h[k+248>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+7|0]|0)!=0){m=0;n=k;o=n+4|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+4|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+4|0;p=o;a[p]=m;i=d;return}function Ni(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;qi(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+960>>3],293.15,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+960>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));oi(f,a,k,293.15,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+952>>3]=+h[f>>3];i=b;return}function Oi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+480>>3],+h[a+952>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+480>>3];l=+h[g+952>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+576>>3]=+h[f>>3];i=b;return}function Pi(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6464>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6440>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6448>>3];h[a+8>>3]=+h[d+13520>>3];h[e+8>>3]=+h[d+13496>>3];h[f+8>>3]=+h[d+13504>>3];i=i;return}function Qi(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,V=0,W=0,X=0,Y=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+456>>3]=+h[d>>3];h[l+960>>3]=+h[d+8>>3];Mi(j);Ni(j);Oi(j);j=c[c[k>>2]>>2]|0;d=c[j+16>>2]|0;do{if((a[d+7|0]|0)==0){l=c[j+8>>2]|0;if((a[d+4|0]|0)==0){m=l;n=d;o=+h[l+896>>3];break}else{m=l;n=d;o=+h[l+960>>3]- +h[l+480>>3];break}}else{l=b+304|0;p=+h[l>>3];q=b+416|0;r=c[q>>2]|0;s=+h[r+264>>3];t=c[j+8>>2]|0;u=+h[t+688>>3];do{if(s!=0.0){v=u;w=t;x=j;y=s;z=r;A=u/s}else{if(u==0.0){v=u;w=t;x=j;y=s;z=r;A=u;break}B=u/+My(c[b+536>>2]|0,s,14880,15168,+h[j>>3],(a[b+319|0]|0)!=0|0);C=c[q>>2]|0;D=c[c[k>>2]>>2]|0;E=c[D+8>>2]|0;v=+h[E+688>>3];w=E;x=D;y=+h[C+264>>3];z=C;A=B}}while(0);do{if(y!=0.0){F=z;G=w;H=x;I=v/y}else{if(v==0.0){F=z;G=w;H=x;I=v;break}s=v/+My(c[b+536>>2]|0,y,14880,15168,+h[x>>3],(a[b+319|0]|0)!=0|0);r=c[c[k>>2]>>2]|0;F=c[q>>2]|0;G=c[r+8>>2]|0;H=r;I=s}}while(0);r=b+536|0;t=c[r>>2]|0;s=+h[G+896>>3];u=+h[F+208>>3];B=A*A+ +h[F+24>>3]+-1.0;J=+h[G+576>>3];K=+h[G+504>>3];do{if(J!=0.0){L=G;M=H;N=K/J;O=F;P=K}else{if(K==0.0){L=G;M=H;N=K;O=F;P=K;break}Q=K/+My(t,J,15176,15168,+h[H>>3],(a[b+319|0]|0)!=0|0);C=c[c[k>>2]>>2]|0;D=c[C+8>>2]|0;L=D;M=C;N=Q;O=c[q>>2]|0;P=+h[D+504>>3]}}while(0);J=B*N;K=P*+h[L+984>>3];Q=+h[O+16>>3]-I*I+1.0;do{if(K!=0.0){R=Q/K}else{if(Q==0.0){R=Q;break}R=Q/+My(c[r>>2]|0,K,15208,15168,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(g,t,s,u,J,R,0,1.0);K=+h[g>>3];Q=+h[l>>3];r=c[(c[c[k>>2]>>2]|0)+8>>2]|0;B=+h[r+960>>3];S=+h[r+480>>3];T=p*(S+K*+iA(+h[r+688>>3],-2)*.5);r=c[c[k>>2]>>2]|0;q=c[r+8>>2]|0;m=q;n=c[r+16>>2]|0;o=B-(T+(1.0-Q)*+h[q+480>>3])}}while(0);h[e>>3]=o;if((a[n+7|0]|0)!=0){U=+h[m+456>>3]-(+h[m+24>>3]- +h[(c[b+416>>2]|0)+8>>3]);V=e;W=V+8|0;X=W;h[X>>3]=U;i=f;return}if((a[n+4|0]|0)==0){Y=(+h[m+960>>3]- +h[m+480>>3])*(+h[(c[b+416>>2]|0)+8>>3]- +h[m+24>>3])*9869232667160129.0e-21}else{Y=+h[m+896>>3]}U=+h[m+456>>3]-Y;V=e;W=V+8|0;X=W;h[X>>3]=U;i=f;return}function Ri(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+18|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+18|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+472>>3],0.0,a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+472>>3],0.0,a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+18|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0;a[(c[b+352>>2]|0)+18|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0;a[(c[b+352>>2]|0)+18|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+72>>3],+h[k+248>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+9|0]|0)!=0){m=0;n=k;o=n+6|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+6|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+6|0;p=o;a[p]=m;i=d;return}function Si(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+17|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+17|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+200>>3],0.0,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+200>>3],0.0,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+17|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0;a[(c[b+352>>2]|0)+17|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0;a[(c[b+352>>2]|0)+17|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+152>>3],+h[k+648>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+3|0]|0)!=0){m=0;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}function Ti(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+304>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+304>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+112>>3]=+h[f>>3];i=b;return}function Ui(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+304>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+304>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+168>>3]=+h[f>>3];i=b;return}function Vi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;pi(d,c[a+536>>2]|0,+h[f+168>>3],+h[f+112>>3],+h[f+304>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[d>>3];i=b;return}function Wi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+792>>3],+h[a+16>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+792>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+120>>3]=+h[f>>3];i=b;return}function Xi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+72>>3]=+h[b+792>>3]*(+h[d+304>>3]- +h[d+792>>3])*+h[b+824>>3];i=i;return}function Yi(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+792>>3]*+h[e+824>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+72>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+64|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+64|0;q=p;h[q>>3]=n;i=d;return}k=l/+My(c[b+536>>2]|0,f,15272,15264,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+64|0;q=p;h[q>>3]=n;i=d;return}function Zi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+792>>3],+h[a+16>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+792>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[f>>3];i=b;return}function _i(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;pi(d,c[a+536>>2]|0,+h[f+160>>3],+h[f+120>>3],+h[f+792>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+136>>3]=+h[d>>3];i=b;return}function $i(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=c[j>>2]|0;l=b+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;o=+h[n+64>>3];p=+h[n+160>>3];q=+h[n+168>>3];r=+h[n+136>>3];s=+h[n+144>>3];t=b+416|0;u=c[t>>2]|0;v=+h[u+744>>3];w=+h[n+656>>3];x=+h[u+768>>3]*+h[u+888>>3];y=+h[u+760>>3];z=(y+y)*.5;n=(c[(c[b+420>>2]|0)+88>>2]|0)+ -1|0;y=+(n|0);A=+h[u+880>>3];do{if((n|0)==0){if(A==0.0){B=u;C=A;break}D=A/+My(k,y,15336,15328,+h[m>>3],(a[b+319|0]|0)!=0|0);B=c[t>>2]|0;C=D}else{B=u;C=A/y}}while(0);Tg(e,k,o,p,q,r,s,v,w,x,z,C,+h[B+848>>3]);B=c[t>>2]|0;C=g*+h[e>>3]*+h[B+824>>3];g=1.0- +h[f>>3];f=c[c[l>>2]>>2]|0;e=c[f+8>>2]|0;z=+h[e+64>>3]- +h[B+768>>3]*+h[B+888>>3]*+h[B+904>>3];x=+h[B+856>>3];w=+h[B+864>>3];if(x!=0.0){E=w/x;F=e;G=z*E;H=g*G;I=C+H;J=F;K=J+88|0;L=K;h[L>>3]=I;i=d;return}if(w==0.0){E=w;F=e;G=z*E;H=g*G;I=C+H;J=F;K=J+88|0;L=K;h[L>>3]=I;i=d;return}v=w/+My(c[j>>2]|0,x,15376,15328,+h[f>>3],(a[b+319|0]|0)!=0|0);E=v;F=c[(c[c[l>>2]>>2]|0)+8>>2]|0;G=z*E;H=g*G;I=C+H;J=F;K=J+88|0;L=K;h[L>>3]=I;i=d;return}function aj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6688>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6664>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6672>>3];h[a+8>>3]=+h[d+2880>>3];h[e+8>>3]=+h[d+2856>>3];h[f+8>>3]=+h[d+2864>>3];h[a+16>>3]=+h[d+4336>>3];h[e+16>>3]=+h[d+4312>>3];h[f+16>>3]=+h[d+4320>>3];h[a+24>>3]=+h[d+11168>>3];h[e+24>>3]=+h[d+11144>>3];h[f+24>>3]=+h[d+11152>>3];i=i;return}function bj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0.0,s=0,t=0,u=0.0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0,X=0,Y=0.0,Z=0.0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0,ea=0,fa=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0;f=i;i=i+16|0;g=f;j=f+8|0;k=b;l=b+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+472>>3]=+h[d>>3];h[m+200>>3]=+h[d+8>>3];h[m+304>>3]=+h[d+16>>3];h[m+792>>3]=+h[d+24>>3];Ri(k);Si(k);Ti(k);Ui(k);Vi(k);Wi(k);Xi(k);Yi(k);Zi(k);_i(k);$i(k);k=c[c[l>>2]>>2]|0;d=c[k+16>>2]|0;do{if((a[d+3|0]|0)==0){m=c[k+8>>2]|0;if((a[d+1|0]|0)==0){n=m;o=d;p=k;q=+h[m+88>>3];break}else{n=m;o=d;p=k;q=+h[m+304>>3]- +h[m+216>>3];break}}else{m=b+304|0;r=+h[m>>3];s=b+416|0;t=c[s>>2]|0;u=+h[t+664>>3];v=c[k+8>>2]|0;w=+h[v+672>>3];do{if(u!=0.0){x=w;y=v;z=k;A=u;B=t;C=w/u}else{if(w==0.0){x=w;y=v;z=k;A=u;B=t;C=w;break}D=w/+My(c[b+536>>2]|0,u,14992,15408,+h[k>>3],(a[b+319|0]|0)!=0|0);E=c[s>>2]|0;F=c[c[l>>2]>>2]|0;G=c[F+8>>2]|0;x=+h[G+672>>3];y=G;z=F;A=+h[E+664>>3];B=E;C=D}}while(0);do{if(A!=0.0){H=B;I=y;J=z;K=x/A}else{if(x==0.0){H=B;I=y;J=z;K=x;break}u=x/+My(c[b+536>>2]|0,A,14992,15408,+h[z>>3],(a[b+319|0]|0)!=0|0);t=c[c[l>>2]>>2]|0;H=c[s>>2]|0;I=c[t+8>>2]|0;J=t;K=u}}while(0);t=b+536|0;v=c[t>>2]|0;u=+h[I+88>>3];w=+h[H+608>>3];D=C*C+ +h[H+168>>3]+-1.0;L=+h[I+280>>3];M=+h[I+232>>3];do{if(L!=0.0){N=H;O=M;P=I;Q=J;R=M/L}else{if(M==0.0){N=H;O=M;P=I;Q=J;R=M;break}S=M/+My(v,L,15416,15408,+h[J>>3],(a[b+319|0]|0)!=0|0);E=c[c[l>>2]>>2]|0;F=c[E+8>>2]|0;N=c[s>>2]|0;O=+h[F+232>>3];P=F;Q=E;R=S}}while(0);L=D*R;M=O*+h[P+816>>3];S=+h[N+160>>3]-K*K+1.0;do{if(M!=0.0){T=S/M}else{if(S==0.0){T=S;break}T=S/+My(c[t>>2]|0,M,15448,15408,+h[Q>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(g,v,u,w,L,T,0,1.0);M=+h[g>>3];S=+h[m>>3];t=c[(c[c[l>>2]>>2]|0)+8>>2]|0;D=+h[t+304>>3];U=+h[t+216>>3];V=r*(U+M*+iA(+h[t+672>>3],-2)*.5);t=c[c[l>>2]>>2]|0;s=c[t+8>>2]|0;n=s;o=c[t+16>>2]|0;p=t;q=D-(V+(1.0-S)*+h[s+216>>3])}}while(0);h[e>>3]=q;do{if((a[o+9|0]|0)==0){if((a[o+6|0]|0)==0){W=n;X=o;Y=-+h[n+88>>3];break}else{W=n;X=o;Y=+h[n+792>>3]- +h[n+496>>3];break}}else{g=b+304|0;q=+h[g>>3];Q=b+416|0;N=c[Q>>2]|0;T=+h[N+264>>3];K=+h[n+704>>3];do{if(T!=0.0){Z=K;_=n;$=p;aa=T;ba=N;ca=K/T}else{if(K==0.0){Z=K;_=n;$=p;aa=T;ba=N;ca=K;break}O=K/+My(c[b+536>>2]|0,T,14880,15408,+h[p>>3],(a[b+319|0]|0)!=0|0);P=c[Q>>2]|0;J=c[c[l>>2]>>2]|0;I=c[J+8>>2]|0;Z=+h[I+704>>3];_=I;$=J;aa=+h[P+264>>3];ba=P;ca=O}}while(0);do{if(aa!=0.0){da=ba;ea=_;fa=$;ga=Z/aa}else{if(Z==0.0){da=ba;ea=_;fa=$;ga=Z;break}T=Z/+My(c[b+536>>2]|0,aa,14880,15408,+h[$>>3],(a[b+319|0]|0)!=0|0);N=c[c[l>>2]>>2]|0;da=c[Q>>2]|0;ea=c[N+8>>2]|0;fa=N;ga=T}}while(0);N=b+536|0;m=c[N>>2]|0;T=-+h[ea+88>>3];K=+h[da+208>>3];r=ca*ca+ +h[da+88>>3]+-1.0;L=+h[ea+592>>3];w=+h[ea+520>>3];do{if(L!=0.0){ha=da;ia=w;ja=ea;ka=fa;la=w/L}else{if(w==0.0){ha=da;ia=w;ja=ea;ka=fa;la=w;break}u=w/+My(m,L,15504,15408,+h[fa>>3],(a[b+319|0]|0)!=0|0);v=c[c[l>>2]>>2]|0;P=c[v+8>>2]|0;ha=c[Q>>2]|0;ia=+h[P+520>>3];ja=P;ka=v;la=u}}while(0);L=r*la;w=ia*+h[ja+984>>3];u=+h[ha+80>>3]-ga*ga+1.0;do{if(w!=0.0){ma=u/w}else{if(u==0.0){ma=u;break}ma=u/+My(c[N>>2]|0,w,15536,15408,+h[ka>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(j,m,T,K,L,ma,0,1.0);w=+h[j>>3];u=+h[g>>3];N=c[(c[c[l>>2]>>2]|0)+8>>2]|0;r=+h[N+792>>3];O=+h[N+496>>3];R=q*(O+w*+iA(+h[N+704>>3],-2)*.5);N=c[c[l>>2]>>2]|0;Q=c[N+8>>2]|0;W=Q;X=c[N+16>>2]|0;Y=r-(R+(1.0-u)*+h[Q+496>>3])}}while(0);h[e+8>>3]=Y;if((a[X+3|0]|0)==0){if((a[X+1|0]|0)==0){na=(+h[W+304>>3]- +h[W+216>>3])*(+h[(c[b+416>>2]|0)+152>>3]- +h[W+8>>3])*9869232667160129.0e-21}else{na=+h[W+88>>3]}oa=+h[W+200>>3]-na}else{oa=+h[W+200>>3]-(+h[W+8>>3]- +h[(c[b+416>>2]|0)+152>>3])}h[e+16>>3]=oa;if((a[X+9|0]|0)!=0){pa=+h[W+472>>3]-(+h[W+24>>3]- +h[(c[b+416>>2]|0)+72>>3]);qa=e;ra=qa+24|0;sa=ra;h[sa>>3]=pa;i=f;return}oa=+h[W+472>>3];if((a[X+6|0]|0)==0){pa=oa-(+h[W+792>>3]- +h[W+496>>3])*(+h[(c[b+416>>2]|0)+72>>3]- +h[W+24>>3])*9869232667160129.0e-21;qa=e;ra=qa+24|0;sa=ra;h[sa>>3]=pa;i=f;return}else{pa=oa+ +h[W+88>>3];qa=e;ra=qa+24|0;sa=ra;h[sa>>3]=pa;i=f;return}}function cj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[c[a+8>>2]>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j>>3];n=+h[j+32>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));si(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1096>>3]=+h[f>>3];i=b;return}function dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=-(+h[(c[a+416>>2]|0)+632>>3]*+h[b+1048>>3]);i=i;return}function ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+840>>3]+ +h[b+832>>3];i=i;return}function fj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+816>>3];k=+h[g+32>>3];l=+h[(c[b+416>>2]|0)+632>>3];m=j*j;j=+h[g+1096>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+1064|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+1064|0;t=s;h[t>>3]=q;i=d;return}u=j/+My(c[b+536>>2]|0,m,15600,15592,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+1064|0;t=s;h[t>>3]=q;i=d;return}function gj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+528>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+504>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+512>>3];h[a+8>>3]=+h[d+14752>>3];h[e+8>>3]=+h[d+14728>>3];h[f+8>>3]=+h[d+14736>>3];i=i;return}function hj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+32>>3]=+h[b>>3];h[a+1048>>3]=+h[b+8>>3];cj(f);dj(f);ej(f);fj(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+848|0;h[d>>3]=+h[f+1080>>3]+(-(+h[f+856>>3]*+h[f+1064>>3])- +h[g>>3]*+h[f+808>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+824>>3]*+h[f+1096>>3])- +h[f+1048>>3]*+h[f+816>>3]);i=e;return}function ij(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+232>>3],+h[(c[a+8>>2]|0)+16>>3],c[(c[a+12>>2]|0)+24>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+232>>3];j=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=+h[j+16>>3];n=+h[j+48>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));si(f,a,l,m,d,0.0,n);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1088>>3]=+h[f>>3];i=b;return}



function jj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+984>>3];k=+h[g+48>>3];l=+h[(c[b+416>>2]|0)+232>>3];m=j*j;j=+h[g+1088>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+1056|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+1056|0;t=s;h[t>>3]=q;i=d;return}u=j/+My(c[b+536>>2]|0,m,15640,15632,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+1056|0;t=s;h[t>>3]=q;i=d;return}function kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=-(+h[(c[a+416>>2]|0)+232>>3]*+h[b+1040>>3]);i=i;return}function lj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=+h[b+1008>>3]+ +h[b+1e3>>3];i=i;return}function mj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+752>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+728>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+736>>3];h[a+8>>3]=+h[d+14640>>3];h[e+8>>3]=+h[d+14616>>3];h[f+8>>3]=+h[d+14624>>3];i=i;return}function nj(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+48>>3]=+h[b>>3];h[a+1040>>3]=+h[b+8>>3];ij(f);jj(f);kj(f);lj(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1016|0;h[d>>3]=+h[f+1072>>3]+(-(+h[f+1024>>3]*+h[f+1056>>3])- +h[g>>3]*+h[f+976>>3]);h[d+8>>3]=+h[g>>3]+(-(+h[f+992>>3]*+h[f+1088>>3])- +h[f+1040>>3]*+h[f+984>>3]);i=e;return}function oj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+10|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+10|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+192>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+192>>3],0.0,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+10|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+192>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+192>>3],0.0)|0;a[(c[b+352>>2]|0)+10|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+120>>3],+h[k+648>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+2|0]|0)!=0){m=0;a[k]=m;i=d;return}if(!(f<<24>>24==0)){m=1;a[k]=m;i=d;return}m=b<<24>>24!=0|0;a[k]=m;i=d;return}function pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+464>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+464>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+40>>3],+h[k+248>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+8|0]|0)!=0){m=0;n=k;o=n+5|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+5|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+5|0;p=o;a[p]=m;i=d;return}function qj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+pd(+(+h[g+344>>3]),1.0e-15);k=j+1.0e-15;l=j*+h[g+16>>3]+8.40130581525969e-11;if(k!=0.0){m=g;n=l/k;o=m;p=o+384|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=g;n=l;o=m;p=o+384|0;q=p;h[q>>3]=n;i=d;return}j=l/+My(c[b+536>>2]|0,k,14768,15672,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=j;o=m;p=o+384|0;q=p;h[q>>3]=n;i=d;return}function rj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+872>>3]=+h[b+384>>3]- +h[d+336>>3]*+h[d+432>>3];i=i;return}function sj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+208>>3],+h[a+872>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+208>>3];l=+h[g+872>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+272>>3]=+h[f>>3];i=b;return}function tj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+888>>3],+h[a+384>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+888>>3];l=+h[g+384>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+424>>3]=+h[f>>3];i=b;return}function uj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+312>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+432>>3]=+h[f>>3];i=b;return}function vj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+312>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+312>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+368>>3]=+h[f>>3];i=b;return}function wj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;pi(d,c[a+536>>2]|0,+h[f+432>>3],+h[f+368>>3],+h[f+312>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+408>>3]=+h[d>>3];i=b;return}function xj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+328>>3]=+h[b+456>>3]*(+h[d+312>>3]- +h[d+888>>3])*+h[b+488>>3];i=i;return}function yj(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+456>>3]*+h[e+488>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+328>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}k=l/+My(c[b+536>>2]|0,f,14824,15680,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+320|0;q=p;h[q>>3]=n;i=d;return}function zj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+888>>3],+h[a+384>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+888>>3];l=+h[g+384>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+376>>3]=+h[f>>3];i=b;return}function Aj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;pi(d,c[a+536>>2]|0,+h[f+424>>3],+h[f+376>>3],+h[f+888>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+400>>3]=+h[d>>3];i=b;return}function Bj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0;d=i;i=i+248|0;e=d;f=d+120|0;g=d+240|0;j=b+536|0;k=c[j>>2]|0;l=b+4|0;m=c[c[l>>2]>>2]|0;n=c[m+8>>2]|0;o=+h[n+488>>3];p=+pd(+-+h[n+344>>3],1.0e-15);q=p+1.0e-15;r=p*+h[n+880>>3]+8.40130581525969e-11;do{if(q!=0.0){s=r/q}else{if(r==0.0){s=r;break}s=r/+My(k,q,14712,15688,+h[m>>3],(a[b+319|0]|0)!=0|0)}}while(0);ii(f,k,o,s,0,0);k=c[j>>2]|0;j=c[c[l>>2]>>2]|0;m=c[j+8>>2]|0;s=+h[m+488>>3];o=+pd(+-+h[m+344>>3],1.0e-15);q=o+1.0e-15;r=o*+h[m+880>>3]+8.40130581525969e-11;do{if(q!=0.0){t=r/q}else{if(r==0.0){t=r;break}t=r/+My(k,q,14712,15688,+h[j>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=e+0|0;j=f+0|0;f=b+120|0;do{c[b>>2]=c[j>>2];b=b+4|0;j=j+4|0}while((b|0)<(f|0));ri(g,k,s,t,e);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+584>>3]=+h[g>>3];i=d;return}function Cj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2768>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2744>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2752>>3];h[a+8>>3]=+h[d+6576>>3];h[e+8>>3]=+h[d+6552>>3];h[f+8>>3]=+h[d+6560>>3];h[a+16>>3]=+h[d+12512>>3];h[e+16>>3]=+h[d+12488>>3];h[f+16>>3]=+h[d+12496>>3];h[a+24>>3]=+h[d+4448>>3];h[e+24>>3]=+h[d+4424>>3];h[f+24>>3]=+h[d+4432>>3];h[a+32>>3]=+h[d+4896>>3];h[e+32>>3]=+h[d+4872>>3];h[f+32>>3]=+h[d+4880>>3];i=i;return}function Dj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0,aa=0,ba=0.0,ca=0.0,da=0,ea=0,fa=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0,la=0.0,ma=0,na=0.0,oa=0,pa=0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0,va=0,wa=0,xa=0.0;f=i;i=i+24|0;g=f;j=f+8|0;k=f+16|0;l=b;m=b+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;h[n+192>>3]=+h[d>>3];h[n+464>>3]=+h[d+8>>3];h[n+888>>3]=+h[d+16>>3];h[n+312>>3]=+h[d+24>>3];h[n+344>>3]=+h[d+32>>3];oj(l);pj(l);qj(l);rj(l);sj(l);tj(l);uj(l);vj(l);wj(l);xj(l);yj(l);zj(l);Aj(l);Bj(l);l=b+536|0;d=c[l>>2]|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+h[o+320>>3];q=+h[o+424>>3];r=+h[o+432>>3];s=+h[o+400>>3];t=+h[o+408>>3];u=b+416|0;v=c[u>>2]|0;w=+h[v+408>>3];x=+h[o+680>>3];y=+h[v+432>>3]*+h[v+552>>3];z=+h[v+424>>3];A=(z+z)*.5;o=(c[(c[b+420>>2]|0)+52>>2]|0)+ -1|0;z=+(o|0);B=+h[v+544>>3];do{if((o|0)==0){if(B==0.0){C=v;D=B;break}E=B/+My(d,z,15104,15696,+h[n>>3],(a[b+319|0]|0)!=0|0);C=c[u>>2]|0;D=E}else{C=v;D=B/z}}while(0);Tg(g,d,p,q,r,s,t,w,x,y,A,D,+h[C+512>>3]);C=c[u>>2]|0;d=c[c[m>>2]>>2]|0;v=c[d+8>>2]|0;n=v+344|0;h[e>>3]=+h[n>>3]- +h[g>>3]*+h[C+488>>3];g=c[d+16>>2]|0;do{if((a[g+2|0]|0)==0){if((a[g]|0)==0){F=v;G=g;H=d;I=+h[n>>3];break}else{F=v;G=g;H=d;I=+h[v+312>>3]- +h[v+208>>3];break}}else{D=+h[C+664>>3];A=+h[v+664>>3];do{if(D!=0.0){J=A;K=v;L=d;M=D;N=C;O=A/D}else{if(A==0.0){J=A;K=v;L=d;M=D;N=C;O=A;break}y=A/+My(c[l>>2]|0,D,14992,15696,+h[d>>3],(a[b+319|0]|0)!=0|0);o=c[u>>2]|0;P=c[c[m>>2]>>2]|0;Q=c[P+8>>2]|0;J=+h[Q+664>>3];K=Q;L=P;M=+h[o+664>>3];N=o;O=y}}while(0);do{if(M!=0.0){R=N;S=K;T=L;U=J/M}else{if(J==0.0){R=N;S=K;T=L;U=J;break}D=J/+My(c[l>>2]|0,M,14992,15696,+h[L>>3],(a[b+319|0]|0)!=0|0);o=c[c[m>>2]>>2]|0;R=c[u>>2]|0;S=c[o+8>>2]|0;T=o;U=D}}while(0);o=c[l>>2]|0;D=+h[S+344>>3];A=+h[R+608>>3];y=O*O+ +h[R+136>>3]+-1.0;x=+h[S+272>>3];w=+h[S+224>>3];do{if(x!=0.0){V=R;W=w;X=S;Y=T;Z=w/x}else{if(w==0.0){V=R;W=w;X=S;Y=T;Z=w;break}t=w/+My(o,x,15016,15696,+h[T>>3],(a[b+319|0]|0)!=0|0);P=c[c[m>>2]>>2]|0;Q=c[P+8>>2]|0;V=c[u>>2]|0;W=+h[Q+224>>3];X=Q;Y=P;Z=t}}while(0);x=y*Z;w=W*+h[X+816>>3];t=+h[V+128>>3]-U*U+1.0;do{if(w!=0.0){_=t/w}else{if(t==0.0){_=t;break}_=t/+My(c[l>>2]|0,w,15048,15696,+h[Y>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(j,o,D,A,x,_,0,1.0);w=+h[j>>3];P=c[(c[c[m>>2]>>2]|0)+8>>2]|0;t=+h[P+208>>3];y=t+w*+iA(+h[P+664>>3],-2)*.5;P=c[c[m>>2]>>2]|0;Q=c[P+8>>2]|0;F=Q;G=c[P+16>>2]|0;H=P;I=+h[Q+312>>3]-y}}while(0);h[e+8>>3]=I;do{if((a[G+8|0]|0)==0){if((a[G+5|0]|0)==0){$=F;aa=G;ba=-+h[F+344>>3];break}else{$=F;aa=G;ba=+h[F+888>>3]- +h[F+488>>3];break}}else{j=c[u>>2]|0;I=+h[j+264>>3];_=+h[F+696>>3];do{if(I!=0.0){ca=_;da=F;ea=H;fa=I;ga=j;ha=_/I}else{if(_==0.0){ca=_;da=F;ea=H;fa=I;ga=j;ha=_;break}U=_/+My(c[l>>2]|0,I,14880,15696,+h[H>>3],(a[b+319|0]|0)!=0|0);Y=c[u>>2]|0;V=c[c[m>>2]>>2]|0;X=c[V+8>>2]|0;ca=+h[X+696>>3];da=X;ea=V;fa=+h[Y+264>>3];ga=Y;ha=U}}while(0);do{if(fa!=0.0){ia=ga;ja=da;ka=ea;la=ca/fa}else{if(ca==0.0){ia=ga;ja=da;ka=ea;la=ca;break}I=ca/+My(c[l>>2]|0,fa,14880,15696,+h[ea>>3],(a[b+319|0]|0)!=0|0);j=c[c[m>>2]>>2]|0;ia=c[u>>2]|0;ja=c[j+8>>2]|0;ka=j;la=I}}while(0);j=c[l>>2]|0;I=-+h[ja+344>>3];_=+h[ia+208>>3];x=ha*ha+ +h[ia+56>>3]+-1.0;A=+h[ja+584>>3];D=+h[ja+512>>3];do{if(A!=0.0){ma=ia;na=D;oa=ja;pa=ka;qa=D/A}else{if(D==0.0){ma=ia;na=D;oa=ja;pa=ka;qa=D;break}U=D/+My(j,A,14904,15696,+h[ka>>3],(a[b+319|0]|0)!=0|0);o=c[c[m>>2]>>2]|0;Y=c[o+8>>2]|0;ma=c[u>>2]|0;na=+h[Y+512>>3];oa=Y;pa=o;qa=U}}while(0);A=x*qa;D=na*+h[oa+984>>3];U=+h[ma+48>>3]-la*la+1.0;do{if(D!=0.0){ra=U/D}else{if(U==0.0){ra=U;break}ra=U/+My(c[l>>2]|0,D,14936,15696,+h[pa>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(k,j,I,_,A,ra,0,1.0);D=+h[k>>3];o=c[(c[c[m>>2]>>2]|0)+8>>2]|0;U=+h[o+488>>3];x=U+D*+iA(+h[o+696>>3],-2)*.5;o=c[c[m>>2]>>2]|0;Y=c[o+8>>2]|0;$=Y;aa=c[o+16>>2]|0;ba=+h[Y+888>>3]-x}}while(0);h[e+16>>3]=ba;do{if((a[aa+8|0]|0)==0){ba=+h[$+464>>3];if((a[aa+5|0]|0)==0){sa=ba-(+h[$+888>>3]- +h[$+488>>3])*(+h[(c[u>>2]|0)+40>>3]- +h[$+24>>3])*9869232667160129.0e-21;break}else{sa=ba+ +h[$+344>>3];break}}else{sa=+h[$+464>>3]-(+h[$+24>>3]- +h[(c[u>>2]|0)+40>>3])}}while(0);h[e+24>>3]=sa;if((a[aa+2|0]|0)!=0){ta=+h[$+192>>3]-(+h[$+8>>3]- +h[(c[u>>2]|0)+120>>3]);ua=e;va=ua+32|0;wa=va;h[wa>>3]=ta;i=f;return}if((a[aa]|0)==0){xa=(+h[$+312>>3]- +h[$+208>>3])*(+h[(c[u>>2]|0)+120>>3]- +h[$+8>>3])*9869232667160129.0e-21}else{xa=+h[$+344>>3]}ta=+h[$+192>>3]-xa;ua=e;va=ua+32|0;wa=va;h[wa>>3]=ta;i=f;return}function Ej(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+13|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+13|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+456>>3],0.0,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+456>>3],0.0,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+13|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0;a[(c[b+352>>2]|0)+13|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0;a[(c[b+352>>2]|0)+13|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+8>>3],+h[k+248>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+7|0]|0)!=0){m=0;n=k;o=n+4|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+4|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+4|0;p=o;a[p]=m;i=d;return}function Fj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;qi(e,c[g>>2]|0,+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+960>>3],293.15,0);a=c[g>>2]|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+960>>3];g=d+0|0;l=e+0|0;e=g+120|0;do{c[g>>2]=c[l>>2];g=g+4|0;l=l+4|0}while((g|0)<(e|0));oi(f,a,k,293.15,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+952>>3]=+h[f>>3];i=b;return}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+480>>3],+h[a+952>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+480>>3];l=+h[g+952>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+576>>3]=+h[f>>3];i=b;return}function Hj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6464>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6440>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6448>>3];h[a+8>>3]=+h[d+13520>>3];h[e+8>>3]=+h[d+13496>>3];h[f+8>>3]=+h[d+13504>>3];i=i;return}function Ij(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;h[l+456>>3]=+h[d>>3];h[l+960>>3]=+h[d+8>>3];Ej(j);Fj(j);Gj(j);j=c[c[k>>2]>>2]|0;d=c[j+16>>2]|0;do{if((a[d+7|0]|0)==0){l=c[j+8>>2]|0;if((a[d+4|0]|0)==0){m=l;n=d;o=+h[l+896>>3];break}else{m=l;n=d;o=+h[l+960>>3]- +h[l+480>>3];break}}else{l=b+416|0;p=c[l>>2]|0;q=+h[p+264>>3];r=c[j+8>>2]|0;s=+h[r+688>>3];do{if(q!=0.0){t=s;u=r;v=j;w=q;x=p;y=s/q}else{if(s==0.0){t=s;u=r;v=j;w=q;x=p;y=s;break}z=s/+My(c[b+536>>2]|0,q,14880,15704,+h[j>>3],(a[b+319|0]|0)!=0|0);A=c[l>>2]|0;B=c[c[k>>2]>>2]|0;C=c[B+8>>2]|0;t=+h[C+688>>3];u=C;v=B;w=+h[A+264>>3];x=A;y=z}}while(0);do{if(w!=0.0){D=x;E=u;F=v;G=t/w}else{if(t==0.0){D=x;E=u;F=v;G=t;break}q=t/+My(c[b+536>>2]|0,w,14880,15704,+h[v>>3],(a[b+319|0]|0)!=0|0);p=c[c[k>>2]>>2]|0;D=c[l>>2]|0;E=c[p+8>>2]|0;F=p;G=q}}while(0);p=b+536|0;r=c[p>>2]|0;q=+h[E+896>>3];s=+h[D+208>>3];z=y*y+ +h[D+24>>3]+-1.0;H=+h[E+576>>3];I=+h[E+504>>3];do{if(H!=0.0){J=D;K=I;L=E;M=F;N=I/H}else{if(I==0.0){J=D;K=I;L=E;M=F;N=I;break}O=I/+My(r,H,15176,15704,+h[F>>3],(a[b+319|0]|0)!=0|0);A=c[c[k>>2]>>2]|0;B=c[A+8>>2]|0;J=c[l>>2]|0;K=+h[B+504>>3];L=B;M=A;N=O}}while(0);H=z*N;I=K*+h[L+984>>3];O=+h[J+16>>3]-G*G+1.0;do{if(I!=0.0){P=O/I}else{if(O==0.0){P=O;break}P=O/+My(c[p>>2]|0,I,15208,15704,+h[M>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(g,r,q,s,H,P,0,1.0);I=+h[g>>3];p=c[(c[c[k>>2]>>2]|0)+8>>2]|0;O=+h[p+480>>3];z=O+I*+iA(+h[p+688>>3],-2)*.5;p=c[c[k>>2]>>2]|0;l=c[p+8>>2]|0;m=l;n=c[p+16>>2]|0;o=+h[l+960>>3]-z}}while(0);h[e>>3]=o;if((a[n+7|0]|0)!=0){Q=+h[m+456>>3]-(+h[m+24>>3]- +h[(c[b+416>>2]|0)+8>>3]);R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}if((a[n+4|0]|0)==0){U=(+h[m+960>>3]- +h[m+480>>3])*(+h[(c[b+416>>2]|0)+8>>3]- +h[m+24>>3])*9869232667160129.0e-21}else{U=+h[m+896>>3]}Q=+h[m+456>>3]-U;R=e;S=R+8|0;T=S;h[T>>3]=Q;i=f;return}function Jj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+18|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+18|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+472>>3],0.0,a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+472>>3],0.0,a[(c[b+360>>2]|0)+18|0]|0)|0;a[(c[b+352>>2]|0)+18|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+18|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0;a[(c[b+352>>2]|0)+18|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0;a[(c[b+352>>2]|0)+18|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+72>>3],+h[k+248>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+9|0]|0)!=0){m=0;n=k;o=n+6|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+6|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+6|0;p=o;a[p]=m;i=d;return}function Kj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+17|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+17|0]|0;k=b+4|0;l=XB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+200>>3],0.0,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=l;e=k;f=j;break}else{j=b+4|0;k=XB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+200>>3],0.0,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+17|0]|0;k=b+4|0;j=$B(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0;a[(c[b+352>>2]|0)+17|0]=j;e=k;f=g;break}else{g=b+4|0;k=$B(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+200>>3],0.0)|0;a[(c[b+352>>2]|0)+17|0]=k;e=g;f=k;break}}}}while(0);k=c[b+416>>2]|0;b=aC(+h[k+152>>3],+h[k+648>>3])|0;k=c[(c[c[e>>2]>>2]|0)+16>>2]|0;if((a[k+3|0]|0)!=0){m=0;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}if(!(f<<24>>24==0)){m=1;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}m=b<<24>>24!=0|0;n=k;o=n+1|0;p=o;a[p]=m;i=d;return}function Lj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+792>>3],+h[a+16>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+792>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[f>>3];i=b;return}function Mj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+72>>3]=+h[b+792>>3]*(+h[d+304>>3]- +h[d+792>>3])*+h[b+824>>3];i=i;return}function Nj(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+792>>3]*+h[e+824>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+72>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+64|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+64|0;q=p;h[q>>3]=n;i=d;return}k=l/+My(c[b+536>>2]|0,f,15272,15712,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+64|0;q=p;h[q>>3]=n;i=d;return}function Oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+304>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+304>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+168>>3]=+h[f>>3];i=b;return}function Pj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+304>>3],+h[a>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+304>>3];l=+h[g>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+112>>3]=+h[f>>3];i=b;return}function Qj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;pi(d,c[a+536>>2]|0,+h[f+168>>3],+h[f+112>>3],+h[f+304>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[d>>3];i=b;return}function Rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+792>>3],+h[a+16>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+792>>3];l=+h[g+16>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ni(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+120>>3]=+h[f>>3];i=b;return}function Sj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;pi(d,c[a+536>>2]|0,+h[f+160>>3],+h[f+120>>3],+h[f+792>>3],0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+136>>3]=+h[d>>3];i=b;return}function Tj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0.0,A=0.0;d=i;i=i+8|0;e=d;f=c[b+536>>2]|0;g=b+4|0;j=c[c[g>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+64>>3];m=+h[k+160>>3];n=+h[k+168>>3];o=+h[k+136>>3];p=+h[k+144>>3];q=b+416|0;r=c[q>>2]|0;s=+h[r+744>>3];t=+h[k+656>>3];u=+h[r+768>>3]*+h[r+888>>3];v=+h[r+760>>3];w=(v+v)*.5;k=(c[(c[b+420>>2]|0)+88>>2]|0)+ -1|0;v=+(k|0);x=+h[r+880>>3];do{if((k|0)==0){if(x==0.0){y=r;z=x;break}A=x/+My(f,v,15336,15720,+h[j>>3],(a[b+319|0]|0)!=0|0);y=c[q>>2]|0;z=A}else{y=r;z=x/v}}while(0);Tg(e,f,l,m,n,o,p,s,t,u,w,z,+h[y+848>>3]);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3]=+h[e>>3]*+h[(c[q>>2]|0)+824>>3];i=d;return}function Uj(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+6688>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+6664>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+6672>>3];h[a+8>>3]=+h[d+2880>>3];h[e+8>>3]=+h[d+2856>>3];h[f+8>>3]=+h[d+2864>>3];h[a+16>>3]=+h[d+11168>>3];h[e+16>>3]=+h[d+11144>>3];h[f+16>>3]=+h[d+11152>>3];h[a+24>>3]=+h[d+4336>>3];h[e+24>>3]=+h[d+4312>>3];h[f+24>>3]=+h[d+4320>>3];i=i;return}function Vj(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0,T=0,U=0.0,V=0.0,W=0,X=0,Y=0.0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0.0,da=0,ea=0.0,fa=0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0,na=0,oa=0;f=i;i=i+16|0;g=f;j=f+8|0;k=b;l=b+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+472>>3]=+h[d>>3];h[m+200>>3]=+h[d+8>>3];h[m+792>>3]=+h[d+16>>3];h[m+304>>3]=+h[d+24>>3];Jj(k);Kj(k);Lj(k);Mj(k);Nj(k);Oj(k);Pj(k);Qj(k);Rj(k);Sj(k);Tj(k);k=c[c[l>>2]>>2]|0;d=c[k+16>>2]|0;do{if((a[d+9|0]|0)==0){m=c[k+8>>2]|0;if((a[d+6|0]|0)==0){n=m;o=d;p=k;q=-+h[m+88>>3];break}else{n=m;o=d;p=k;q=+h[m+792>>3]- +h[m+496>>3];break}}else{m=b+416|0;r=c[m>>2]|0;s=+h[r+264>>3];t=c[k+8>>2]|0;u=+h[t+704>>3];do{if(s!=0.0){v=u;w=t;x=k;y=s;z=r;A=u/s}else{if(u==0.0){v=u;w=t;x=k;y=s;z=r;A=u;break}B=u/+My(c[b+536>>2]|0,s,14880,15728,+h[k>>3],(a[b+319|0]|0)!=0|0);C=c[m>>2]|0;D=c[c[l>>2]>>2]|0;E=c[D+8>>2]|0;v=+h[E+704>>3];w=E;x=D;y=+h[C+264>>3];z=C;A=B}}while(0);do{if(y!=0.0){F=z;G=w;H=x;I=v/y}else{if(v==0.0){F=z;G=w;H=x;I=v;break}s=v/+My(c[b+536>>2]|0,y,14880,15728,+h[x>>3],(a[b+319|0]|0)!=0|0);r=c[c[l>>2]>>2]|0;F=c[m>>2]|0;G=c[r+8>>2]|0;H=r;I=s}}while(0);r=b+536|0;t=c[r>>2]|0;s=-+h[G+88>>3];u=+h[F+208>>3];B=A*A+ +h[F+88>>3]+-1.0;J=+h[G+592>>3];K=+h[G+520>>3];do{if(J!=0.0){L=F;M=K;N=G;O=H;P=K/J}else{if(K==0.0){L=F;M=K;N=G;O=H;P=K;break}Q=K/+My(t,J,15504,15728,+h[H>>3],(a[b+319|0]|0)!=0|0);C=c[c[l>>2]>>2]|0;D=c[C+8>>2]|0;L=c[m>>2]|0;M=+h[D+520>>3];N=D;O=C;P=Q}}while(0);J=B*P;K=M*+h[N+984>>3];Q=+h[L+80>>3]-I*I+1.0;do{if(K!=0.0){R=Q/K}else{if(Q==0.0){R=Q;break}R=Q/+My(c[r>>2]|0,K,15536,15728,+h[O>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(g,t,s,u,J,R,0,1.0);K=+h[g>>3];r=c[(c[c[l>>2]>>2]|0)+8>>2]|0;Q=+h[r+496>>3];B=Q+K*+iA(+h[r+704>>3],-2)*.5;r=c[c[l>>2]>>2]|0;m=c[r+8>>2]|0;n=m;o=c[r+16>>2]|0;p=r;q=+h[m+792>>3]-B}}while(0);h[e>>3]=q;do{if((a[o+3|0]|0)==0){if((a[o+1|0]|0)==0){S=n;T=o;U=+h[n+88>>3];break}else{S=n;T=o;U=+h[n+304>>3]- +h[n+216>>3];break}}else{g=b+416|0;O=c[g>>2]|0;q=+h[O+664>>3];R=+h[n+672>>3];do{if(q!=0.0){V=R;W=n;X=p;Y=q;Z=O;_=R/q}else{if(R==0.0){V=R;W=n;X=p;Y=q;Z=O;_=R;break}I=R/+My(c[b+536>>2]|0,q,14992,15728,+h[p>>3],(a[b+319|0]|0)!=0|0);L=c[g>>2]|0;N=c[c[l>>2]>>2]|0;H=c[N+8>>2]|0;V=+h[H+672>>3];W=H;X=N;Y=+h[L+664>>3];Z=L;_=I}}while(0);do{if(Y!=0.0){$=Z;aa=W;ba=X;ca=V/Y}else{if(V==0.0){$=Z;aa=W;ba=X;ca=V;break}q=V/+My(c[b+536>>2]|0,Y,14992,15728,+h[X>>3],(a[b+319|0]|0)!=0|0);O=c[c[l>>2]>>2]|0;$=c[g>>2]|0;aa=c[O+8>>2]|0;ba=O;ca=q}}while(0);O=b+536|0;t=c[O>>2]|0;q=+h[aa+88>>3];R=+h[$+608>>3];J=_*_+ +h[$+168>>3]+-1.0;u=+h[aa+280>>3];s=+h[aa+232>>3];do{if(u!=0.0){da=$;ea=s;fa=aa;ga=ba;ha=s/u}else{if(s==0.0){da=$;ea=s;fa=aa;ga=ba;ha=s;break}I=s/+My(t,u,15416,15728,+h[ba>>3],(a[b+319|0]|0)!=0|0);L=c[c[l>>2]>>2]|0;N=c[L+8>>2]|0;da=c[g>>2]|0;ea=+h[N+232>>3];fa=N;ga=L;ha=I}}while(0);u=J*ha;s=ea*+h[fa+816>>3];I=+h[da+160>>3]-ca*ca+1.0;do{if(s!=0.0){ia=I/s}else{if(I==0.0){ia=I;break}ia=I/+My(c[O>>2]|0,s,15448,15728,+h[ga>>3],(a[b+319|0]|0)!=0|0)}}while(0);dh(j,t,q,R,u,ia,0,1.0);s=+h[j>>3];O=c[(c[c[l>>2]>>2]|0)+8>>2]|0;I=+h[O+216>>3];J=I+s*+iA(+h[O+672>>3],-2)*.5;O=c[c[l>>2]>>2]|0;g=c[O+8>>2]|0;S=g;T=c[O+16>>2]|0;U=+h[g+304>>3]-J}}while(0);h[e+8>>3]=U;if((a[T+3|0]|0)==0){if((a[T+1|0]|0)==0){ja=(+h[S+304>>3]- +h[S+216>>3])*(+h[(c[b+416>>2]|0)+152>>3]- +h[S+8>>3])*9869232667160129.0e-21}else{ja=+h[S+88>>3]}ka=+h[S+200>>3]-ja}else{ka=+h[S+200>>3]-(+h[S+8>>3]- +h[(c[b+416>>2]|0)+152>>3])}h[e+16>>3]=ka;if((a[T+9|0]|0)!=0){la=+h[S+472>>3]-(+h[S+24>>3]- +h[(c[b+416>>2]|0)+72>>3]);ma=e;na=ma+24|0;oa=na;h[oa>>3]=la;i=f;return}ka=+h[S+472>>3];if((a[T+6|0]|0)==0){la=ka-(+h[S+792>>3]- +h[S+496>>3])*(+h[(c[b+416>>2]|0)+72>>3]- +h[S+24>>3])*9869232667160129.0e-21;ma=e;na=ma+24|0;oa=na;h[oa>>3]=la;i=f;return}else{la=ka+ +h[S+88>>3];ma=e;na=ma+24|0;oa=na;h[oa>>3]=la;i=f;return}}function Wj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+816>>3];k=+h[g+32>>3];l=+h[(c[b+416>>2]|0)+632>>3];m=j*j;j=+h[g+1096>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+1064|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+1064|0;t=s;h[t>>3]=q;i=d;return}u=j/+My(c[b+536>>2]|0,m,15600,15736,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+1064|0;t=s;h[t>>3]=q;i=d;return}function Xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+856>>3]*+h[b+1064>>3]+ +h[b+848>>3]*+h[b+808>>3];i=i;return}function Yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+832>>3]=+h[b+1080>>3]- +h[b+840>>3];i=i;return}function Zj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+632>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+832>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+1048|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1048|0;q=p;h[q>>3]=n;i=d;return}k=l/+My(c[b+536>>2]|0,e,15752,15744,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1048|0;q=p;h[q>>3]=n;i=d;return}function _j(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+528>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+504>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+512>>3];h[a+8>>3]=+h[d+15424>>3];h[e+8>>3]=+h[d+15400>>3];h[f+8>>3]=+h[d+15408>>3];i=i;return}function $j(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a;l=a+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+32>>3]=+h[b>>3];h[m+1096>>3]=+h[b+8>>3];Wj(k);Xj(k);Yj(k);Zj(k);k=a+536|0;b=a+416|0;a=c[c[l>>2]>>2]|0;ii(g,c[k>>2]|0,+h[(c[b>>2]|0)+632>>3],+h[c[a+8>>2]>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[k>>2]|0;n=+h[(c[b>>2]|0)+632>>3];b=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[b>>3];p=+h[b+32>>3];b=f+0|0;k=g+0|0;g=b+120|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(g|0));si(j,a,n,o,f,0.0,p);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;l=f+1096|0;h[d>>3]=+h[l>>3]- +h[j>>3];h[d+8>>3]=+h[f+848>>3]+(-(+h[f+824>>3]*+h[l>>3])- +h[f+1048>>3]*+h[f+816>>3]);i=e;return}function ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+984>>3];k=+h[g+48>>3];l=+h[(c[b+416>>2]|0)+232>>3];m=j*j;j=+h[g+1088>>3];if(m!=0.0){n=g;o=j/m;p=l*o;q=k+p;r=n;s=r+1056|0;t=s;h[t>>3]=q;i=d;return}if(j==0.0){n=g;o=j;p=l*o;q=k+p;r=n;s=r+1056|0;t=s;h[t>>3]=q;i=d;return}u=j/+My(c[b+536>>2]|0,m,15640,15776,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=u;p=l*o;q=k+p;r=n;s=r+1056|0;t=s;h[t>>3]=q;i=d;return}function bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=+h[b+1024>>3]*+h[b+1056>>3]+ +h[b+1016>>3]*+h[b+976>>3];i=i;return}function ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[b+1072>>3]- +h[b+1008>>3];i=i;return}function dk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+232>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1e3>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+1040|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1040|0;q=p;h[q>>3]=n;i=d;return}k=l/+My(c[b+536>>2]|0,e,15792,15784,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1040|0;q=p;h[q>>3]=n;i=d;return}function ek(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+752>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+728>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+736>>3];h[a+8>>3]=+h[d+15312>>3];h[e+8>>3]=+h[d+15288>>3];h[f+8>>3]=+h[d+15296>>3];i=i;return}function fk(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0;e=i;i=i+248|0;f=e;g=e+120|0;j=e+240|0;k=a;l=a+4|0;m=c[(c[c[l>>2]>>2]|0)+8>>2]|0;h[m+48>>3]=+h[b>>3];h[m+1088>>3]=+h[b+8>>3];ak(k);bk(k);ck(k);dk(k);k=a+536|0;b=a+416|0;a=c[c[l>>2]>>2]|0;ii(g,c[k>>2]|0,+h[(c[b>>2]|0)+232>>3],+h[(c[a+8>>2]|0)+16>>3],c[(c[a+12>>2]|0)+24>>2]|0,0);a=c[k>>2]|0;n=+h[(c[b>>2]|0)+232>>3];b=c[(c[c[l>>2]>>2]|0)+8>>2]|0;o=+h[b+16>>3];p=+h[b+48>>3];b=f+0|0;k=g+0|0;g=b+120|0;do{c[b>>2]=c[k>>2];b=b+4|0;k=k+4|0}while((b|0)<(g|0));si(j,a,n,o,f,0.0,p);f=c[(c[c[l>>2]>>2]|0)+8>>2]|0;l=f+1088|0;h[d>>3]=+h[l>>3]- +h[j>>3];h[d+8>>3]=+h[f+1016>>3]+(-(+h[f+992>>3]*+h[l>>3])- +h[f+1040>>3]*+h[f+984>>3]);i=e;return}function gk(a){a=a|0;c[a+4>>2]=106;c[a>>2]=5;c[a+56>>2]=0;c[a+32>>2]=19;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=114;c[a+80>>2]=2;c[a+136>>2]=0;c[a+112>>2]=20;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=153;c[a+160>>2]=4;c[a+216>>2]=0;c[a+192>>2]=21;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=166;c[a+240>>2]=2;c[a+296>>2]=0;c[a+272>>2]=22;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=186;c[a+320>>2]=2;c[a+376>>2]=0;c[a+352>>2]=23;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=283;c[a+400>>2]=5;c[a+456>>2]=0;c[a+432>>2]=24;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=291;c[a+480>>2]=2;c[a+536>>2]=0;c[a+512>>2]=25;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=334;c[a+560>>2]=4;c[a+616>>2]=0;c[a+592>>2]=26;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=359;c[a+640>>2]=2;c[a+696>>2]=0;c[a+672>>2]=27;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=370;c[a+720>>2]=2;c[a+776>>2]=0;c[a+752>>2]=28;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;i=i;return}function hk(a){a=a|0;i=i;return}function ik(a,b){a=a|0;b=b|0;i=i;return}function jk(a){a=a|0;i=i;return}function kk(a,b){a=a|0;b=b|0;c[b>>2]=c[18080+(a<<2)>>2];i=i;return c[15816+(a<<2)>>2]|0}function lk(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0;e=i;i=i+1920|0;f=e;g=e+104|0;j=e+208|0;k=e+312|0;l=e+416|0;m=e+520|0;n=e+624|0;o=e+728|0;p=e+832|0;q=e+936|0;r=e+1040|0;s=e+1144|0;t=e+1248|0;u=e+1352|0;v=e+1360|0;w=e+1464|0;x=e+1472|0;y=e+1576|0;z=e+1584|0;A=e+1688|0;B=e+1696|0;C=e+1800|0;D=e+1808|0;E=e+1912|0;F=o;G=p;H=q;I=r;J=s;K=b+4|0;L=b+416|0;M=b+360|0;N=(YB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[L>>2]|0)+152>>3],a[c[M>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=N?1.0:-1.0;N=(YB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[L>>2]|0)+120>>3],a[(c[M>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=N?1.0:-1.0;N=b+536|0;Wh(t,c[N>>2]|0,+h[(c[L>>2]|0)+632>>3]);O=n+0|0;P=t+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));Q=c[N>>2]|0;R=+h[(c[L>>2]|0)+632>>3];O=m+0|0;P=n+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));$h(u,Q,R,m);m=WB(+h[c[(c[c[K>>2]>>2]|0)+8>>2]>>3],+h[u>>3],a[(c[M>>2]|0)+2|0]|0)|0;Yh(v,c[N>>2]|0,+h[(c[L>>2]|0)+632>>3]);O=F+0|0;P=v+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));v=c[N>>2]|0;R=+h[(c[L>>2]|0)+632>>3];O=l+0|0;P=o+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));$h(w,v,R,l);l=XB(+h[c[(c[c[K>>2]>>2]|0)+8>>2]>>3],+h[w>>3],a[(c[M>>2]|0)+3|0]|0)|0;w=$B(+h[(c[L>>2]|0)+632>>3],22064.0e3)|0;if((l|m)<<24>>24==0){S=w<<24>>24!=0?1.0:-1.0}else{S=1.0}h[d+16>>3]=S;w=(YB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[L>>2]|0)+72>>3],a[(c[M>>2]|0)+4|0]|0)|0)<<24>>24!=0;h[d+24>>3]=w?1.0:-1.0;w=(YB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[L>>2]|0)+40>>3],a[(c[M>>2]|0)+5|0]|0)|0)<<24>>24!=0;h[d+32>>3]=w?1.0:-1.0;w=(YB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[L>>2]|0)+8>>3],a[(c[M>>2]|0)+6|0]|0)|0)<<24>>24!=0;h[d+40>>3]=w?1.0:-1.0;Wh(x,c[N>>2]|0,+h[(c[L>>2]|0)+232>>3]);O=G+0|0;P=x+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));x=c[N>>2]|0;S=+h[(c[L>>2]|0)+232>>3];O=k+0|0;P=p+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));$h(y,x,S,k);k=WB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+16>>3],+h[y>>3],a[(c[M>>2]|0)+7|0]|0)|0;Yh(z,c[N>>2]|0,+h[(c[L>>2]|0)+232>>3]);O=H+0|0;P=z+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));z=c[N>>2]|0;S=+h[(c[L>>2]|0)+232>>3];O=j+0|0;P=q+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));$h(A,z,S,j);j=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+16>>3],+h[A>>3],a[(c[M>>2]|0)+8|0]|0)|0;A=$B(+h[(c[L>>2]|0)+232>>3],22064.0e3)|0;if((j|k)<<24>>24==0){T=A<<24>>24!=0?1.0:-1.0}else{T=1.0}h[d+48>>3]=T;A=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+464>>3],0.0,a[(c[M>>2]|0)+9|0]|0)|0;k=c[L>>2]|0;j=aC(+h[k+40>>3],+h[k+248>>3])|0;if(A<<24>>24==0){U=j<<24>>24!=0?1.0:-1.0}else{U=1.0}h[d+56>>3]=U;j=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+192>>3],0.0,a[(c[M>>2]|0)+10|0]|0)|0;A=c[L>>2]|0;k=aC(+h[A+120>>3],+h[A+648>>3])|0;if(j<<24>>24==0){V=k<<24>>24!=0?1.0:-1.0}else{V=1.0}h[d+64>>3]=V;k=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[L>>2]|0)+712>>3],a[(c[M>>2]|0)+11|0]|0)|0;j=YB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[L>>2]|0)+704>>3],a[(c[M>>2]|0)+12|0]|0)|0;do{if(k<<24>>24==0){if((a[(c[b+408>>2]|0)+10|0]|0)==0){W=-1.0;break}W=j<<24>>24!=0?1.0:-1.0}else{W=1.0}}while(0);h[d+72>>3]=W;j=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+456>>3],0.0,a[(c[M>>2]|0)+13|0]|0)|0;b=c[L>>2]|0;k=aC(+h[b+8>>3],+h[b+248>>3])|0;if(j<<24>>24==0){X=k<<24>>24!=0?1.0:-1.0}else{X=1.0}h[d+80>>3]=X;Wh(B,c[N>>2]|0,+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+960>>3]);O=I+0|0;P=B+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));B=c[N>>2]|0;X=+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+960>>3];O=g+0|0;P=r+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));$h(C,B,X,g);g=WB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+952>>3],+h[C>>3],a[(c[M>>2]|0)+14|0]|0)|0;Yh(D,c[N>>2]|0,+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+960>>3]);O=J+0|0;P=D+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));D=c[N>>2]|0;X=+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+960>>3];O=f+0|0;P=s+0|0;t=O+104|0;do{c[O>>2]=c[P>>2];O=O+4|0;P=P+4|0}while((O|0)<(t|0));$h(E,D,X,f);f=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+952>>3],+h[E>>3],a[(c[M>>2]|0)+15|0]|0)|0;E=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3,a[(c[M>>2]|0)+16|0]|0)|0;if((f|g)<<24>>24==0){Y=E<<24>>24!=0?1.0:-1.0}else{Y=1.0}h[d+88>>3]=Y;E=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+200>>3],0.0,a[(c[M>>2]|0)+17|0]|0)|0;g=c[L>>2]|0;f=aC(+h[g+152>>3],+h[g+648>>3])|0;if(E<<24>>24==0){Z=f<<24>>24!=0?1.0:-1.0}else{Z=1.0}h[d+96>>3]=Z;f=XB(+h[(c[(c[c[K>>2]>>2]|0)+8>>2]|0)+472>>3],0.0,a[(c[M>>2]|0)+18|0]|0)|0;M=c[L>>2]|0;L=aC(+h[M+72>>3],+h[M+248>>3])|0;if(!(f<<24>>24==0)){_=1.0;$=d;aa=$+104|0;ba=aa;h[ba>>3]=_;i=e;return 0}_=L<<24>>24!=0?1.0:-1.0;$=d;aa=$+104|0;ba=aa;h[ba>>3]=_;i=e;return 0}function mk(a){a=a|0;i=i;return c[19528+(a<<2)>>2]|0}function nk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0.0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0,Z=0,_=0;e=i;i=i+2592|0;f=e;g=e+104|0;j=e+208|0;k=e+312|0;l=e+416|0;m=e+520|0;n=e+624|0;o=e+728|0;p=e+832|0;q=e+936|0;r=e+1040|0;s=e+1144|0;t=e+1248|0;u=e+1352|0;v=e+1456|0;w=e+1560|0;x=e+1664|0;y=e+1768|0;z=e+1872|0;A=e+1976|0;B=e+2080|0;C=e+2184|0;D=e+2288|0;E=e+2392|0;F=e+2496|0;G=e+2504|0;H=e+2512|0;I=e+2520|0;J=e+2528|0;K=e+2536|0;L=e+2544|0;M=e+2552|0;N=e+2560|0;O=e+2568|0;P=e+2576|0;Q=e+2584|0;R=b+4|0;S=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+8>>3];T=b+416|0;U=+h[(c[T>>2]|0)+152>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=S>=U|0;a[(c[d>>2]|0)+1|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+8>>3]>=+h[(c[T>>2]|0)+120>>3]|0;V=b+536|0;Wh(z,c[V>>2]|0,+h[(c[T>>2]|0)+632>>3]);W=c[V>>2]|0;X=+h[(c[T>>2]|0)+632>>3];Y=m+0|0;Z=z+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(L,W,X,m);a[(c[d>>2]|0)+2|0]=+h[c[(c[c[R>>2]>>2]|0)+8>>2]>>3]<+h[L>>3]|0;Yh(A,c[V>>2]|0,+h[(c[T>>2]|0)+632>>3]);L=c[V>>2]|0;X=+h[(c[T>>2]|0)+632>>3];Y=l+0|0;Z=A+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(M,L,X,l);a[(c[d>>2]|0)+3|0]=+h[c[(c[c[R>>2]>>2]|0)+8>>2]>>3]>+h[M>>3]|0;a[(c[d>>2]|0)+4|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+24>>3]>=+h[(c[T>>2]|0)+72>>3]|0;a[(c[d>>2]|0)+5|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+24>>3]>=+h[(c[T>>2]|0)+40>>3]|0;a[(c[d>>2]|0)+6|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+24>>3]>=+h[(c[T>>2]|0)+8>>3]|0;Wh(B,c[V>>2]|0,+h[(c[T>>2]|0)+232>>3]);M=c[V>>2]|0;X=+h[(c[T>>2]|0)+232>>3];Y=k+0|0;Z=B+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(N,M,X,k);a[(c[d>>2]|0)+7|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+16>>3]<+h[N>>3]|0;Yh(C,c[V>>2]|0,+h[(c[T>>2]|0)+232>>3]);N=c[V>>2]|0;X=+h[(c[T>>2]|0)+232>>3];Y=j+0|0;Z=C+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(O,N,X,j);a[(c[d>>2]|0)+8|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+16>>3]>+h[O>>3]|0;a[(c[d>>2]|0)+9|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+464>>3]>0.0|0;a[(c[d>>2]|0)+10|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+192>>3]>0.0|0;a[(c[d>>2]|0)+11|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+888>>3]>+h[(c[T>>2]|0)+712>>3]|0;a[(c[d>>2]|0)+12|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+888>>3]>=+h[(c[T>>2]|0)+704>>3]|0;a[(c[d>>2]|0)+13|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+456>>3]>0.0|0;Wh(D,c[V>>2]|0,+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3]);O=c[V>>2]|0;X=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3];Y=g+0|0;Z=D+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(P,O,X,g);a[(c[d>>2]|0)+14|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+952>>3]<+h[P>>3]|0;Yh(E,c[V>>2]|0,+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3]);P=c[V>>2]|0;X=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3];Y=f+0|0;Z=E+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(Q,P,X,f);a[(c[d>>2]|0)+15|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+952>>3]>+h[Q>>3]|0;a[(c[d>>2]|0)+16|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3]>22064.0e3|0;a[(c[d>>2]|0)+17|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+200>>3]>0.0|0;a[(c[d>>2]|0)+18|0]=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+472>>3]>0.0|0;i=e;return 0}else{d=b+360|0;Q=YB(S,U,a[c[d>>2]|0]|0)|0;f=b+352|0;a[c[f>>2]|0]=Q;Q=YB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[T>>2]|0)+120>>3],a[(c[d>>2]|0)+1|0]|0)|0;a[(c[f>>2]|0)+1|0]=Q;Q=b+536|0;Wh(t,c[Q>>2]|0,+h[(c[T>>2]|0)+632>>3]);b=c[Q>>2]|0;U=+h[(c[T>>2]|0)+632>>3];Y=s+0|0;Z=t+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(F,b,U,s);s=WB(+h[c[(c[c[R>>2]>>2]|0)+8>>2]>>3],+h[F>>3],a[(c[d>>2]|0)+2|0]|0)|0;a[(c[f>>2]|0)+2|0]=s;Yh(u,c[Q>>2]|0,+h[(c[T>>2]|0)+632>>3]);s=c[Q>>2]|0;U=+h[(c[T>>2]|0)+632>>3];Y=r+0|0;Z=u+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(G,s,U,r);r=XB(+h[c[(c[c[R>>2]>>2]|0)+8>>2]>>3],+h[G>>3],a[(c[d>>2]|0)+3|0]|0)|0;a[(c[f>>2]|0)+3|0]=r;r=YB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[T>>2]|0)+72>>3],a[(c[d>>2]|0)+4|0]|0)|0;a[(c[f>>2]|0)+4|0]=r;r=YB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[T>>2]|0)+40>>3],a[(c[d>>2]|0)+5|0]|0)|0;a[(c[f>>2]|0)+5|0]=r;r=YB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[T>>2]|0)+8>>3],a[(c[d>>2]|0)+6|0]|0)|0;a[(c[f>>2]|0)+6|0]=r;Wh(v,c[Q>>2]|0,+h[(c[T>>2]|0)+232>>3]);r=c[Q>>2]|0;U=+h[(c[T>>2]|0)+232>>3];Y=q+0|0;Z=v+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(H,r,U,q);q=WB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+16>>3],+h[H>>3],a[(c[d>>2]|0)+7|0]|0)|0;a[(c[f>>2]|0)+7|0]=q;Yh(w,c[Q>>2]|0,+h[(c[T>>2]|0)+232>>3]);q=c[Q>>2]|0;U=+h[(c[T>>2]|0)+232>>3];Y=p+0|0;Z=w+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(I,q,U,p);p=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+16>>3],+h[I>>3],a[(c[d>>2]|0)+8|0]|0)|0;a[(c[f>>2]|0)+8|0]=p;p=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+464>>3],0.0,a[(c[d>>2]|0)+9|0]|0)|0;a[(c[f>>2]|0)+9|0]=p;p=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+192>>3],0.0,a[(c[d>>2]|0)+10|0]|0)|0;a[(c[f>>2]|0)+10|0]=p;p=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[T>>2]|0)+712>>3],a[(c[d>>2]|0)+11|0]|0)|0;a[(c[f>>2]|0)+11|0]=p;p=YB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+888>>3],+h[(c[T>>2]|0)+704>>3],a[(c[d>>2]|0)+12|0]|0)|0;a[(c[f>>2]|0)+12|0]=p;p=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+456>>3],0.0,a[(c[d>>2]|0)+13|0]|0)|0;a[(c[f>>2]|0)+13|0]=p;Wh(x,c[Q>>2]|0,+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3]);p=c[Q>>2]|0;U=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3];Y=o+0|0;Z=x+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(J,p,U,o);o=WB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+952>>3],+h[J>>3],a[(c[d>>2]|0)+14|0]|0)|0;a[(c[f>>2]|0)+14|0]=o;Yh(y,c[Q>>2]|0,+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3]);o=c[Q>>2]|0;U=+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3];Y=n+0|0;Z=y+0|0;_=Y+104|0;do{c[Y>>2]=c[Z>>2];Y=Y+4|0;Z=Z+4|0}while((Y|0)<(_|0));$h(K,o,U,n);n=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+952>>3],+h[K>>3],a[(c[d>>2]|0)+15|0]|0)|0;a[(c[f>>2]|0)+15|0]=n;n=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+960>>3],22064.0e3,a[(c[d>>2]|0)+16|0]|0)|0;a[(c[f>>2]|0)+16|0]=n;n=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+200>>3],0.0,a[(c[d>>2]|0)+17|0]|0)|0;a[(c[f>>2]|0)+17|0]=n;n=XB(+h[(c[(c[c[R>>2]>>2]|0)+8>>2]|0)+472>>3],0.0,a[(c[d>>2]|0)+18|0]|0)|0;a[(c[f>>2]|0)+18|0]=n;i=e;return 0}return 0}function ok(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;Gy(8,1,19608,t);t=b+4|0;u=c[c[t>>2]>>2]|0;v=c[u+16>>2]|0;w=a[v+7|0]|0;x=b+408|0;y=c[x>>2]|0;z=a[y+7|0]|0;if(w<<24>>24==z<<24>>24){A=y;B=v;C=u;D=0}else{c[s>>2]=z<<24>>24;c[s+4>>2]=w<<24>>24;Gy(8,0,19640,s);s=c[c[t>>2]>>2]|0;A=c[x>>2]|0;B=c[s+16>>2]|0;C=s;D=1}s=a[B+8|0]|0;w=a[A+8|0]|0;if(s<<24>>24==w<<24>>24){E=A;F=B;G=C;H=D}else{c[r>>2]=w<<24>>24;c[r+4>>2]=s<<24>>24;Gy(8,0,19704,r);r=c[c[t>>2]>>2]|0;E=c[x>>2]|0;F=c[r+16>>2]|0;G=r;H=1}r=a[F+9|0]|0;s=a[E+9|0]|0;if(r<<24>>24==s<<24>>24){I=E;J=F;K=G;L=H}else{c[q>>2]=s<<24>>24;c[q+4>>2]=r<<24>>24;Gy(8,0,19768,q);q=c[c[t>>2]>>2]|0;I=c[x>>2]|0;J=c[q+16>>2]|0;K=q;L=1}q=a[J+4|0]|0;r=a[I+4|0]|0;if(q<<24>>24==r<<24>>24){M=I;N=J;O=K;P=L}else{c[p>>2]=r<<24>>24;c[p+4>>2]=q<<24>>24;Gy(8,0,19832,p);p=c[c[t>>2]>>2]|0;M=c[x>>2]|0;N=c[p+16>>2]|0;O=p;P=1}p=a[N+5|0]|0;q=a[M+5|0]|0;if(p<<24>>24==q<<24>>24){Q=M;R=N;S=O;T=P}else{c[o>>2]=q<<24>>24;c[o+4>>2]=p<<24>>24;Gy(8,0,19896,o);o=c[c[t>>2]>>2]|0;Q=c[x>>2]|0;R=c[o+16>>2]|0;S=o;T=1}o=a[R+6|0]|0;R=a[Q+6|0]|0;if(o<<24>>24==R<<24>>24){U=S;V=T}else{c[n>>2]=R<<24>>24;c[n+4>>2]=o<<24>>24;Gy(8,0,19960,n);U=c[c[t>>2]>>2]|0;V=1}n=c[U+12>>2]|0;o=c[n+24>>2]|0;R=b+404|0;b=c[R>>2]|0;T=c[b+24>>2]|0;if((o|0)==(T|0)){W=b;X=n;Y=U;Z=V}else{c[m>>2]=T;c[m+4>>2]=o;Gy(8,0,20024,m);m=c[c[t>>2]>>2]|0;W=c[R>>2]|0;X=c[m+12>>2]|0;Y=m;Z=1}m=c[X+20>>2]|0;X=c[W+20>>2]|0;if((m|0)==(X|0)){_=Y;$=Z}else{c[l>>2]=X;c[l+4>>2]=m;Gy(8,0,20088,l);_=c[c[t>>2]>>2]|0;$=1}l=c[_+16>>2]|0;m=a[l+2|0]|0;X=c[x>>2]|0;Z=a[X+2|0]|0;if(m<<24>>24==Z<<24>>24){aa=X;ba=l;ca=_;da=$}else{c[k>>2]=Z<<24>>24;c[k+4>>2]=m<<24>>24;Gy(8,0,20160,k);k=c[c[t>>2]>>2]|0;aa=c[x>>2]|0;ba=c[k+16>>2]|0;ca=k;da=1}k=a[ba+3|0]|0;m=a[aa+3|0]|0;if(k<<24>>24==m<<24>>24){ea=aa;fa=ba;ga=ca;ha=da}else{c[j>>2]=m<<24>>24;c[j+4>>2]=k<<24>>24;Gy(8,0,20224,j);j=c[c[t>>2]>>2]|0;ea=c[x>>2]|0;fa=c[j+16>>2]|0;ga=j;ha=1}j=a[fa]|0;k=a[ea]|0;if(j<<24>>24==k<<24>>24){ia=ea;ja=fa;ka=ga;la=ha}else{c[h>>2]=k<<24>>24;c[h+4>>2]=j<<24>>24;Gy(8,0,20288,h);h=c[c[t>>2]>>2]|0;ia=c[x>>2]|0;ja=c[h+16>>2]|0;ka=h;la=1}h=a[ja+1|0]|0;ja=a[ia+1|0]|0;if(h<<24>>24==ja<<24>>24){ma=ka;na=la}else{c[g>>2]=ja<<24>>24;c[g+4>>2]=h<<24>>24;Gy(8,0,20352,g);ma=c[c[t>>2]>>2]|0;na=1}g=c[(c[ma+12>>2]|0)+16>>2]|0;h=c[(c[R>>2]|0)+16>>2]|0;if((g|0)==(h|0)){oa=ma;pa=na}else{c[f>>2]=h;c[f+4>>2]=g;Gy(8,0,20416,f);oa=c[c[t>>2]>>2]|0;pa=1}t=a[(c[oa+16>>2]|0)+10|0]|0;oa=a[(c[x>>2]|0)+10|0]|0;if(t<<24>>24==oa<<24>>24){qa=pa}else{c[e>>2]=oa<<24>>24;c[e+4>>2]=t<<24>>24;Gy(8,0,20480,e);qa=1}if((c[67152>>2]|0)==0){i=d;return qa|0}ae[c[16918]&255](8);i=d;return qa|0}function pk(a){a=a|0;i=i;return c[20944+(a<<2)>>2]|0}function qk(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0.0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;Gy(21,1,20984,r);r=b+4|0;s=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+24>>3]+-2.0;h[d>>3]=s;t=pk(0)|0;c[q>>2]=1;c[q+4>>2]=t;t=q+8|0;h[k>>3]=s;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];Gy(21,0,21016,q);q=b+416|0;s=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[(c[q>>2]|0)+192>>3];h[d+8>>3]=s;t=pk(1)|0;c[p>>2]=2;c[p+4>>2]=t;t=p+8|0;h[k>>3]=s;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];Gy(21,0,21016,p);p=c[q>>2]|0;s=+h[p+520>>3]+ +h[p+544>>3]*-1.0e3;h[d+16>>3]=s;p=pk(2)|0;c[o>>2]=3;c[o+4>>2]=p;p=o+8|0;h[k>>3]=s;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Gy(21,0,21016,o);o=c[q>>2]|0;s=+h[o+544>>3]- +h[o+368>>3];h[d+24>>3]=s;o=pk(3)|0;c[n>>2]=4;c[n+4>>2]=o;o=n+8|0;h[k>>3]=s;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Gy(21,0,21016,n);s=+h[(c[(c[c[r>>2]>>2]|0)+8>>2]|0)+8>>3]+-2.0;h[d+32>>3]=s;n=pk(4)|0;c[m>>2]=5;c[m+4>>2]=n;n=m+8|0;h[k>>3]=s;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Gy(21,0,21016,m);s=+h[c[(c[c[r>>2]>>2]|0)+8>>2]>>3]- +h[(c[q>>2]|0)+592>>3];h[d+40>>3]=s;r=pk(5)|0;c[l>>2]=6;c[l+4>>2]=r;r=l+8|0;h[k>>3]=s;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Gy(21,0,21016,l);l=(a[(c[b+424>>2]|0)+38|0]|0)==0;if((a[(c[b+408>>2]|0)+10|0]|0)==0){u=l?0.0:1.0}else{u=+(l&1|0)}h[d+48>>3]=u;l=pk(6)|0;c[j>>2]=7;c[j+4>>2]=l;l=j+8|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];Gy(21,0,21016,j);j=c[q>>2]|0;u=+h[j+856>>3]+ +h[j+880>>3]*-1.0e3;h[d+56>>3]=u;j=pk(7)|0;c[g>>2]=8;c[g+4>>2]=j;j=g+8|0;h[k>>3]=u;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];Gy(21,0,21016,g);g=c[q>>2]|0;u=+h[g+880>>3]- +h[g+368>>3];h[d+64>>3]=u;d=pk(8)|0;c[f>>2]=9;c[f+4>>2]=d;d=f+8|0;h[k>>3]=u;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];Gy(21,0,21016,f);if((c[67204>>2]|0)==0){i=e;return 0}ae[c[16918]&255](21);i=e;return 0}function rk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+888>>3]=+h[b+336>>3];i=i;return}function sk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+376>>3];i=i;return}function tk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+872>>3]*100.0;i=i;return}function uk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+736>>3];i=i;return}function vk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+752>>3]*3.141592653589793;i=i;return}function wk(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+752>>3];h[b+792>>3]=d*d*.7853981633974483;i=i;return}function xk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+664>>3]=+h[b+624>>3];i=i;return}function yk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+648>>3]=+h[b+616>>3];i=i;return}function zk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+632>>3]=+h[b+320>>3];i=i;return}function Ak(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+672>>3]=+h[b+632>>3];i=i;return}function Bk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+608>>3]=+h[b+376>>3];i=i;return}function Ck(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+552>>3]=+h[b+336>>3];i=i;return}function Dk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+536>>3]=+h[b+376>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+536>>3]*100.0;i=i;return}function Fk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+400>>3];i=i;return}function Gk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+464>>3]=+h[b+416>>3]*3.141592653589793;i=i;return}function Hk(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+416>>3];h[b+456>>3]=d*d*.7853981633974483;i=i;return}function Ik(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+392>>3]=+h[b+328>>3];i=i;return}function Jk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+584>>3]=+h[b+392>>3];i=i;return}function Kk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;Ez(e,1,+h[(c[g>>2]|0)+176>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+672>>3];l=+h[a+584>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];mh(f,j,k,l,d,0);h[(c[g>>2]|0)+592>>3]=+h[f>>3];i=b;return}function Lk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+264>>3]=+h[b+224>>3];i=i;return}function Mk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+248>>3]=+h[b+216>>3];i=i;return}function Nk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+232>>3]=+h[b+320>>3];i=i;return}function Ok(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+272>>3]=+h[b+232>>3];i=i;return}function Pk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+208>>3]=+h[b+376>>3];i=i;return}function Qk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+184>>3]=+h[b+392>>3];i=i;return}function Rk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+416|0;Ez(e,1,+h[(c[g>>2]|0)+96>>3],b+16|0);j=c[a+536>>2]|0;a=c[g>>2]|0;k=+h[a+272>>3];l=+h[a+184>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];mh(f,j,k,l,d,0);h[(c[g>>2]|0)+192>>3]=+h[f>>3];i=b;return}function Sk(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+800>>3];g=+h[e+792>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+My(c[b+536>>2]|0,f,21040,21032,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+744>>3]=j*4.0;i=d;return}function Tk(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+800>>3];g=+h[e+792>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+My(c[b+536>>2]|0,f,21040,21064,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+736>>3]=j*4.0;i=d;return}function Uk(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+464>>3];g=+h[e+456>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+My(c[b+536>>2]|0,f,21080,21072,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+720>>3]=j*4.0;i=d;return}function Vk(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+464>>3];g=+h[e+456>>3];do{if(f!=0.0){j=g/f}else{if(g==0.0){j=g;break}j=g/+My(c[b+536>>2]|0,f,21080,21096,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+712>>3]=j*4.0;i=d;return}function Wk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=+h[(c[a+416>>2]|0)+232>>3]*1.0e-5;i=i;return}function Xk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1184>>3]=+h[(c[a+416>>2]|0)+632>>3]*1.0e-5;i=i;return}function Yk(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Ih(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+232>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1176>>3]=+h[d>>3];i=b;return}function Zk(a){a=a|0;var b=0.0;b=+h[c[a+416>>2]>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+688>>3]=b*b*.7853981633974483;i=i;return}function _k(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+32>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+696>>3]=b*b*.7853981633974483;i=i;return}function $k(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+64>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+704>>3]=b*b*.7853981633974483;i=i;return}function al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=(+h[b+712>>3]+ +h[b+720>>3])*.5;i=i;return}function bl(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=b;Ih(d,c[a+536>>2]|0,+h[(c[a+416>>2]|0)+632>>3]);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=+h[d>>3];i=b;return}function cl(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+112>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+664>>3]=b*b*.7853981633974483;i=i;return}function dl(a){a=a|0;var b=0.0;b=+h[(c[a+416>>2]|0)+144>>3];h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+672>>3]=b*b*.7853981633974483;i=i;return}function el(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+656>>3]=(+h[b+736>>3]+ +h[b+744>>3])*.5;i=i;return}function fl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+824>>3];m=+h[k+864>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+My(g,l,21112,21104,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+824>>3];o=r;p=q}}while(0);l=+h[o+904>>3];m=+h[o+912>>3];q=+h[o+744>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+656>>3];t=+h[o+760>>3];u=(t+t)*.5;t=+h[o+872>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+My(c[f>>2]|0,n,21112,21104,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);Zg(e,g,p,l,l,m,m,q,s,u,w,+h[v+848>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1160>>3]=+h[e>>3];i=d;return}function gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=c[f>>2]|0;j=b+416|0;k=c[j>>2]|0;l=+h[k+488>>3];m=+h[k+528>>3];do{if(l!=0.0){n=l;o=k;p=m/l}else{if(m==0.0){n=l;o=k;p=m;break}q=m/+My(g,l,21152,21144,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);r=c[j>>2]|0;n=+h[r+488>>3];o=r;p=q}}while(0);l=+h[o+568>>3];m=+h[o+576>>3];q=+h[o+408>>3];k=b+4|0;r=c[c[k>>2]>>2]|0;s=+h[(c[r+8>>2]|0)+680>>3];t=+h[o+424>>3];u=(t+t)*.5;t=+h[o+536>>3];do{if(n!=0.0){v=o;w=t/n}else{if(t==0.0){v=o;w=t;break}x=t/+My(c[f>>2]|0,n,21152,21144,+h[r>>3],(a[b+319|0]|0)!=0|0);v=c[j>>2]|0;w=x}}while(0);Zg(e,g,p,l,l,m,m,q,s,u,w,+h[v+512>>3]);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1152>>3]=+h[e>>3];i=d;return}function hl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+368>>3];i=i;return}function il(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+880>>3]*1.0e3;i=i;return}function jl(b){b=b|0;a[(c[b+408>>2]|0)+10|0]=a[(c[b+424>>2]|0)+38|0]|0;i=i;return}function kl(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+592>>3];i=i;return}function ll(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+880>>3]=+h[b>>3]+ +h[d+336>>3]*+h[d+432>>3];i=i;return}function ml(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;Wh(k,c[p>>2]|0,+h[(c[q>>2]|0)+632>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+632>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+2|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+2|0]|0;g=WB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=g;v=t;break}else{t=WB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+2|0]|0;t=ZB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+2|0]=t;v=f;break}else{f=ZB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+2|0]=f;v=f;break}}}}while(0);Yh(m,c[p>>2]|0,+h[(c[q>>2]|0)+632>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+632>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+3|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+3|0]|0;m=XB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=m;w=e;break}else{e=XB(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+3|0]|0;e=$B(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+3|0]=e;w=n;break}else{n=$B(+h[c[(c[c[b+4>>2]>>2]|0)+8>>2]>>3],u)|0;a[(c[b+352>>2]|0)+3|0]=n;w=n;break}}}}while(0);l=$B(+h[(c[q>>2]|0)+632>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+16|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+16|0;J=I;c[J>>2]=x;i=d;return}function nl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[c[a+8>>2]>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];m=+h[c[(c[c[k>>2]>>2]|0)+8>>2]>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));ri(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+816>>3]=+h[f>>3];i=b;return}function ol(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=+h[g+816>>3];l=+h[(c[b+416>>2]|0)+632>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+808|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+808|0;r=q;h[r>>3]=o;i=d;return}s=l/+My(c[b+536>>2]|0,k,21192,21184,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+808|0;r=q;h[r>>3]=o;i=d;return}function pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+632>>3],+h[c[a+8>>2]>>3],c[(c[a+12>>2]|0)+16>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+632>>3];m=+h[c[(c[c[k>>2]>>2]|0)+8>>2]>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));ni(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+176>>3]=+h[f>>3];i=b;return}function ql(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+800>>3]=+h[b+176>>3]+-273.15;i=i;return}function rl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+784>>3]=+h[b>>3]+ +h[d+336>>3]*+h[d+768>>3];i=i;return}function sl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=2.0;i=i;return}function tl(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+8>>3]- +h[e+152>>3]));h[d+216>>3]=+h[e+632>>3]+f*+h[e+336>>3]*+h[d+816>>3];i=b;return}function ul(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+8>>3]- +h[e+120>>3]));h[d+208>>3]=+h[e+632>>3]+f*+h[e+336>>3]*+h[d+816>>3];i=b;return}function vl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+624>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[28994]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=21352;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];De[n&31](m,d,21224,e);p=+h[(c[f>>2]|0)+624>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+184>>3]=p+g*+h[f+8>>3]*2.0;i=b;return}function wl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+112>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]+(g*-.1- +h[f+120>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+224>>3]=+h[d>>3];i=b;return}function xl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+1|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+120>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+120>>3],a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+1|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+120>>3])|0;a[(c[b+352>>2]|0)+1|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+120>>3])|0;a[(c[b+352>>2]|0)+1|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+2|0]=f;i=d;return}function yl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+144>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+8>>3]+(g*-.1- +h[f+152>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+232>>3]=+h[d>>3];i=b;return}function zl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+152>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+152>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+152>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],+h[(c[b+416>>2]|0)+152>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+3|0]=f;i=d;return}function Al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[(c[a+416>>2]|0)+624>>3]*+h[b+8>>3];i=i;return}function Bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=+h[b+824>>3]*+h[b+816>>3];i=i;return}function Cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+864>>3]=+h[b+856>>3]*+h[b+808>>3];i=i;return}function Dl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+544>>3]=+h[b+368>>3];i=i;return}function El(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+520>>3]=+h[b+544>>3]*1.0e3;i=i;return}function Fl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+192>>3];i=i;return}function Gl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+640|0;e=d;f=d+104|0;g=d+208|0;j=d+312|0;k=d+416|0;l=d+520|0;m=d+528|0;n=d+632|0;o=j;p=b+536|0;q=b+416|0;Wh(k,c[p>>2]|0,+h[(c[q>>2]|0)+232>>3]);r=g+0|0;s=k+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));t=c[p>>2]|0;u=+h[(c[q>>2]|0)+232>>3];r=f+0|0;s=g+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(l,t,u,f);u=+h[l>>3];l=b+314|0;do{if((a[l]|0)==0){v=a[(c[b+356>>2]|0)+7|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){t=a[(c[b+356>>2]|0)+7|0]|0;g=WB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=g;v=t;break}else{t=WB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=t;v=t;break}}else{if(f){f=a[(c[b+356>>2]|0)+7|0]|0;t=ZB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+7|0]=t;v=f;break}else{f=ZB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+7|0]=f;v=f;break}}}}while(0);Yh(m,c[p>>2]|0,+h[(c[q>>2]|0)+232>>3]);r=o+0|0;s=m+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));m=c[p>>2]|0;u=+h[(c[q>>2]|0)+232>>3];r=e+0|0;s=j+0|0;k=r+104|0;do{c[r>>2]=c[s>>2];r=r+4|0;s=s+4|0}while((r|0)<(k|0));$h(n,m,u,e);u=+h[n>>3];do{if((a[l]|0)==0){w=a[(c[b+356>>2]|0)+8|0]|0}else{n=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(n){e=a[(c[b+356>>2]|0)+8|0]|0;m=XB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=m;w=e;break}else{e=XB(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=e;w=e;break}}else{if(n){n=a[(c[b+356>>2]|0)+8|0]|0;e=$B(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+8|0]=e;w=n;break}else{n=$B(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+16>>3],u)|0;a[(c[b+352>>2]|0)+8|0]=n;w=n;break}}}}while(0);l=$B(+h[(c[q>>2]|0)+232>>3],22064.0e3)|0;if(!((w|v)<<24>>24==0)){x=1;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+24|0;J=I;c[J>>2]=x;i=d;return}x=l<<24>>24!=0?1:2;y=b;z=y+4|0;A=z;B=c[A>>2]|0;C=c[B>>2]|0;D=C;E=D+12|0;F=E;G=c[F>>2]|0;H=G;I=H+24|0;J=I;c[J>>2]=x;i=d;return}function Hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+232>>3],+h[(c[a+8>>2]|0)+16>>3],c[(c[a+12>>2]|0)+24>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+232>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));ri(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+984>>3]=+h[f>>3];i=b;return}function Il(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=+h[g+984>>3];l=+h[(c[b+416>>2]|0)+232>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+976|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+976|0;r=q;h[r>>3]=o;i=d;return}s=l/+My(c[b+536>>2]|0,k,21328,21320,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+976|0;r=q;h[r>>3]=o;i=d;return}function Jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+416|0;k=a+4|0;a=c[c[k>>2]>>2]|0;ii(e,c[g>>2]|0,+h[(c[j>>2]|0)+232>>3],+h[(c[a+8>>2]|0)+16>>3],c[(c[a+12>>2]|0)+24>>2]|0,0);a=c[g>>2]|0;l=+h[(c[j>>2]|0)+232>>3];m=+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+16>>3];j=d+0|0;g=e+0|0;e=j+120|0;do{c[j>>2]=c[g>>2];j=j+4|0;g=g+4|0}while((j|0)<(e|0));ni(f,a,l,m,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+440>>3]=+h[f>>3];i=b;return}function Kl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+440>>3]+-273.15;i=i;return}function Ll(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+776>>3]=+h[b+16>>3]- +h[d+336>>3]*+h[d+768>>3];i=i;return}function Ml(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+216>>3],+h[a+776>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+216>>3];l=+h[g+776>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+280>>3]=+h[f>>3];i=b;return}function Nl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=2.0;i=i;return}function Ol(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+24>>3]- +h[e+72>>3]));h[d+496>>3]=+h[e+232>>3]+f*+h[e+336>>3]*+h[d+984>>3];i=b;return}function Pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+248|0;d=b;e=b+120|0;f=b+240|0;g=a+536|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;ii(e,c[g>>2]|0,+h[a+496>>3],+h[a+784>>3],0,0);a=c[g>>2]|0;g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[g+496>>3];l=+h[g+784>>3];g=d+0|0;m=e+0|0;e=g+120|0;do{c[g>>2]=c[m>>2];g=g+4|0;m=m+4|0}while((g|0)<(e|0));ri(f,a,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+592>>3]=+h[f>>3];i=b;return}function Ql(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+24>>3]- +h[e+40>>3]));h[d+488>>3]=+h[e+232>>3]+f*+h[e+336>>3]*+h[d+984>>3];i=b;return}function Rl(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;f=+pd(0.0,+(+h[d+24>>3]- +h[e+8>>3]));h[d+480>>3]=+h[e+232>>3]+f*+h[e+336>>3]*+h[d+984>>3];i=b;return}function Sl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0.0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=+h[(c[f>>2]|0)+224>>3];j=g*3.141592653589793;if(!(j>=0.0)){l=c[28994]|0;m=c[a+536>>2]|0;n=e;h[k>>3]=j;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l;l=d;o=21352;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];c[l+16>>2]=c[o+16>>2];c[l+20>>2]=c[o+20>>2];De[n&31](m,d,21376,e);p=+h[(c[f>>2]|0)+224>>3]}else{p=g}g=+V(+j);f=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[f+448>>3]=p+g*+h[f+24>>3]*2.0;i=b;return}function Tl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]+(g*-.1- +h[f+8>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+504>>3]=+h[d>>3];i=b;return}function Ul(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+8>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+8>>3],a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+8>>3])|0;a[(c[b+352>>2]|0)+6|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+8>>3])|0;a[(c[b+352>>2]|0)+6|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+7|0]=f;i=d;return}function Vl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[a+416>>2]|0;g=+h[f+32>>3];_g(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]+(g*-.1- +h[f+40>>3]),1.0,.001,g*.1);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+512>>3]=+h[d>>3];i=b;return}function Wl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[(c[b+356>>2]|0)+5|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+5|0]|0;k=b+4|0;l=YB(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+40>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=l;e=k;f=j;break}else{j=b+4|0;k=YB(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+40>>3],a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;e=j;f=k;break}}else{if(g){g=a[(c[b+356>>2]|0)+5|0]|0;k=b+4|0;j=aC(+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+40>>3])|0;a[(c[b+352>>2]|0)+5|0]=j;e=k;f=g;break}else{g=b+4|0;k=aC(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],+h[(c[b+416>>2]|0)+40>>3])|0;a[(c[b+352>>2]|0)+5|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+8|0]=f;i=d;return}



function Au(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Ce[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 0:{B=24;break a;break};case-1:{B=25;break a;break};case-4:{B=17;break a;break};case-3:{B=6;break a;break};case 9:{a[p]=ge[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){ze[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}Vt(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=hu(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}D=_t(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((D|0)!=0){break}E=y;if((c[y+120>>2]|0)!=0){ze[c[E+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[E+80>>2]|0)==0){break b}Vt(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((D|0)==0){B=41;break a}if((a[D+34|0]|0)==0){B=43;break a}}if((a[D+32|0]|0)!=0){B=50;break a}if((c[D+28>>2]|0)!=0){B=52;break a}C=y;if((c[D+4>>2]|0)!=0){E=y;if((a[C+308|0]|0)!=0){F=uu(E,D,0)|0;if((F|0)!=0){B=60;break a}else{break b}}G=y;if((c[E+120>>2]|0)!=0){ze[c[G+120>>2]&15](c[y+4>>2]|0,c[D>>2]|0,0);break b}if((c[G+80>>2]|0)==0){break b}Vt(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Vt(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[D+32|0]=1;C=Cu(y)|0;a[D+32|0]=0;if((C|0)==0){B=63;break a}if((te[c[y+112>>2]&63](c[y+116>>2]|0,C,c[D+20>>2]|0,c[D+16>>2]|0,c[D+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){H=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{H=de[c[C+12>>2]&127](48)|0;if((H|0)==0){B=72;break a}c[H+36>>2]=de[c[y+12>>2]&127](32)|0;if((c[H+36>>2]|0)==0){B=74;break a}c[H+40>>2]=(c[H+36>>2]|0)+32}c[H+44>>2]=0;c[H>>2]=c[y+364>>2];c[y+364>>2]=H;c[H+16>>2]=0;c[H+20>>2]=0;c[H+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[H+8>>2]=se[c[e+32>>2]&63](e,c[H+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[H+4>>2]|0)+(c[H+8>>2]|0)|0;c[r>>2]=c[H+4>>2];c[q>>2]=c[H+36>>2];while(1){Zd[c[e+60>>2]&31](e,r,C,q,(c[H+40>>2]|0)+ -1|0);I=(c[q>>2]|0)-(c[H+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}G=(c[H+40>>2]|0)-(c[H+36>>2]|0)<<1;E=se[c[y+16>>2]&63](c[H+36>>2]|0,G)|0;if((E|0)==0){B=80;break a}c[H+36>>2]=E;c[H+40>>2]=E+G;c[q>>2]=E+I}c[H+24>>2]=I;c[H+12>>2]=c[H+36>>2];a[c[q>>2]|0]=0;J=Du(y,e,c[m>>2]|0,H+12|0,H+44|0)|0;if((J|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){ze[c[C+52>>2]&15](c[y+4>>2]|0,c[H+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Vt(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Et(y+416|0);break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;D=1;c[t>>2]=hu(y+416|0,e,C,C+(se[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];K=Du(y,e,c[m>>2]|0,t,s)|0;if((K|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){ze[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);D=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}be[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);D=0}do{if((D&255|0)!=0){if((c[y+80>>2]|0)==0){break}Vt(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Et(y+416|0);while(1){if((c[s>>2]|0)==0){break}D=c[s>>2]|0;if((c[y+104>>2]|0)!=0){be[c[y+104>>2]&127](c[y+4>>2]|0,c[c[D>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[D+4>>2]=c[y+376>>2];c[y+376>>2]=D;c[(c[D>>2]|0)+4>>2]=c[D+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}D=c[y+364>>2]|0;c[y+364>>2]=c[D>>2];c[D>>2]=c[y+368>>2];c[y+368>>2]=D;L=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;C=se[c[e+32>>2]&63](e,L)|0;if((C|0)!=(c[D+8>>2]|0)){B=112;break a}if((O1(c[D+4>>2]|0,L,C)|0)!=0){B=112;break a}C=y+312|0;c[C>>2]=(c[C>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){C=c[D+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((C|0)==0){break}E=(c[D+12>>2]|0)+(c[D+28>>2]|0)|0;while(1){if((a[C]|0)==0){break}G=C;C=G+1|0;M=E;E=M+1|0;a[M]=a[G]|0}G=c[D+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}M=E;E=M+1|0;a[M]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}M=G;G=M+1|0;N=E;E=N+1|0;a[N]=a[M]|0}}}while(0);a[E]=0}}while(0);be[c[y+56>>2]&127](c[y+4>>2]|0,c[D+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Vt(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[D+44>>2]|0)==0){break}C=c[D+44>>2]|0;if((c[y+104>>2]|0)!=0){be[c[y+104>>2]&127](c[y+4>>2]|0,c[c[C>>2]>>2]|0)}c[D+44>>2]=c[(c[D+44>>2]|0)+4>>2];c[C+4>>2]=c[y+376>>2];c[y+376>>2]=C;c[(c[C>>2]|0)+4>>2]=c[C+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;ze[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Vt(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{D=se[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((D|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){G=c[C+60>>2]|0;M=c[y+4>>2]|0;N=Ru(D,u)|0;ze[G&15](M,u,N);break b}if((c[C+80>>2]|0)==0){break b}Vt(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){ae[c[C+72>>2]&255](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}Vt(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=Fu(y,e,n,g,h,j)|0;if((O|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{C=c[y+60>>2]|0;if((C|0)==0){if((c[y+80>>2]|0)==0){break b}Vt(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){ze[C&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];Zd[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];ze[C&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((wu(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((xu(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case-2:{B=28;break a;break};default:{if((c[y+80>>2]|0)==0){break b}Vt(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==2){B=181;break}else if((f|0)==3){B=180;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;ze[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Vt(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=F;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){ae[c[y+20>>2]&255](H);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=J;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=K;Q=P;i=l;return Q|0}else if((B|0)==107){P=Eu(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=L;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=Eu(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=O;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=42;P=O;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){ze[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];Zd[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);ze[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Vt(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function Bu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Ce[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=fu(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=Au(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=fu(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=Au(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function Cu(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Xt(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Xt(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Yt(e,b+60|0);a:while(1){k=Zt(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Xt(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Xt(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Xt(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Xt(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Yt(e,b);b:while(1){b=Zt(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Xt(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Xt(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Xt(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function Du(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=_t(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=Gt(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=_t(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((Ju(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Ce[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=se[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Ce[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=lu(k,b,v,w+(se[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=hu(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=pu(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=cu(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=cu(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=se[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(_t(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Xt(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Xt(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Xt(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=de[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;V1(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}ae[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;V1(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;V1(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function Eu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-2:{k=18;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}Vt(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case 11:{if((wu(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case-1:{k=15;break a;break};case-15:{k=3;break a;break};case-4:{k=7;break a;break};case 13:{if((xu(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case 0:{k=14;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Vt(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function Fu(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Ce[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 6:{r=c[o+60>>2]|0;if((r|0)==0){if((c[o+80>>2]|0)==0){break b}Vt(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){ze[r&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];Zd[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];ze[r&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 40:{s=6;break a;break};case-4:case-1:{s=28;break a;break};case-2:{s=25;break a;break};case 0:{s=24;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;ze[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Vt(o,b,c[k>>2]|0,c[l>>2]|0);break};default:{s=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){s=33;break}else if((h|0)==2){s=34;break}}if((s|0)==6){m=o;do{if((c[o+76>>2]|0)!=0){ae[c[m+76>>2]&255](c[o+4>>2]|0)}else{if((c[m+80>>2]|0)==0){break}Vt(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((s|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((s|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((s|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((s|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((s|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((s|0)==34){t=35;u=t;i=j;return u|0}return 0}function Gu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Fu(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=Hu(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=ju(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function Hu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Au(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Iu(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Iu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=se[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}V1(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function Ju(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Xt(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Xt(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=_t(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function Ku(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Ce[c[b+16>>2]&63](b,f,g,l)|0){case-1:{o=7;break a;break};case 9:{p=(ge[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(p<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Xt(h)|0)<<24>>24!=0)){o=42;break a}}q=h+12|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;break b}p=hu(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((p|0)==0){o=44;break a}r=_t(n,j,p,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){s=(c[n+300>>2]|0)!=0}else{s=(a[j+129|0]|0)!=0}t=((s^1)&1|0)!=0}else{t=0}u=t&1}else{if((a[j+129|0]|0)!=0){v=(d[j+130|0]|0)!=0}else{v=1}u=v&1}p=(r|0)!=0;if(u<<24>>24!=0){if(!p){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!p){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}p=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;w=Ku(n,c[n+228>>2]|0,e,c[r+4>>2]|0,p,h)|0;a[r+32|0]=0;if((w|0)!=0){o=74;break a}break};case 6:{if((nu(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case 7:case 39:{o=31;break};case 0:{o=4;break a;break};case-4:{o=3;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case 10:{r=se[c[b+44>>2]&63](b,f)|0;if((r|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((r|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);r=Ru(r,m)|0;if((r|0)==0){o=19;break a}p=0;while(1){if((p|0)>=(r|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Xt(h)|0)<<24>>24!=0)){o=27;break a}}q=a[m+p|0]|0;x=h+12|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=q;p=p+1|0}break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Xt(h)|0)<<24>>24!=0)){o=37;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=w;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function Lu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((ge[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=Su()|0;c[g+240>>2]=de[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Ce[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){ae[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}ae[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function Mu(){var a=0,b=0;a=i;i=i+8|0;bc(((sc(0)|0)>>>0)%4294967295|0|0);b=$1()|0;i=a;return b|0}function Nu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=du(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=eu(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function Ou(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=de[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{Pu(f+80|0,e);Pu(b+104|0,e);Qu(b,e);Qu(b+20|0,e);Qu(b+40|0,e);Qu(b+60|0,e);a[b+131|0]=0;Qu(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function Pu(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function Qu(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function Ru(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function Su(){i=i;return 1912}function Tu(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[64384+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[64460+l|0]|0|0)!=28){if((d[64460+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[64460+q|0]|0|0)!=28){if((d[64460+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[64460+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Uu(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[58552+(((d[58296+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[58552+(((d[59832+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=Ru(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=49;c[h+336>>2]=49;c[h+340>>2]=49;c[h+344>>2]=50;c[h+348>>2]=50;c[h+352>>2]=50;c[h+356>>2]=51;c[h+360>>2]=51;c[h+364>>2]=51}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function Uu(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 0:{if((d[64460+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function Vu(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=se[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[58552+(((d[59832+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Wu(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=se[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[58552+(((d[58296+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Xu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=se[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Uu(a)|0)<0;g=f&1;i=d;return g|0}function Yu(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=Ru(se[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function Zu(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(se[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function _u(){i=i;return 64016}function $u(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=av(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=30;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((ov(d,c[63920+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function bv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=mx(62360,a,0,b,c,d)|0;i=e;return f|0}function cv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=mx(62360,a,1,b,c,d)|0;i=e;return f|0}function dv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;Lw(63128,b,c,d);i=a;return}function ev(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=fv(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function fv(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(nx(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,63864)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((nx(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,63872)|0)!=0){h=ox(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=ge[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((nx(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Ce[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,63888)|0)!=0){if((a|0)!=0){break}do{if((Ce[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,63904)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Ce[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,63912)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((px(ox(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function gv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((ov(h,60088)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=av(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[62360+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function hv(){i=i;return 61992}function iv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=av(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=30;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function jv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=mx(60096,a,0,b,c,d)|0;i=e;return f|0}function kv(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=mx(60096,a,1,b,c,d)|0;i=e;return f|0}function lv(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=fv(37,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function mv(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;Zd[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((ov(h,60088)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=av(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[60096+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function nv(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Tu(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function ov(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function pv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:case 21:{n=25;break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=Gv(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 24:case 22:{p=18;b=b+2|0;n=77;break};case 19:{k=Uv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=Iv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{g=b;if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;p=18;n=77;break a}if((c[58552+((d[59832+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=76;break a}b=b+2|0;p=19;n=77;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=Sv(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{p=19;b=b+2|0;n=77;break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=Gv(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 16:{k=Tv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=Ov(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 13:{k=Sv(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=Gv(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=Gv(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 15:{n=122;break b;break};case 29:{if((c[58552+((d[59832+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=83;break b}break};case 6:{n=88;break b;break};case 5:{n=85;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 23:{b=b+2|0;r=p;if((r|0)==41){p=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}p=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=Gv(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[58552+((d[59832+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=103;break b}break};case 5:{n=105;break b;break};case 7:{n=111;break b;break};case 6:{n=108;break b;break};default:{p=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 34:{n=116;break b;break};case 33:{n=119;break b;break};case 7:{n=91;break b;break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=p;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((p|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-p|0;l=k;i=h;return l|0}}return 0}function qv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 3:{k=Hv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=Lv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Gv(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Gv(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function rv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Gv(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Gv(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=53;break b}b=r+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function sv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=Gv(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function tv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Gv(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 2:{n=15;break a;break};case 21:{n=29;break a;break};case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=19;break a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Hv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Gv(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function uv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Gv(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 9:{n=21;break a;break};case 5:{b=b+2|0;continue a;break};case 30:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 10:{n=18;break a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Hv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Iv(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Gv(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function vv(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=Gv(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};case 5:{break};case 6:{k=8;break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=Gv(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function wv(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function xv(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=Gv(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function yv(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=Gv(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function zv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=Gv(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 17:case 11:{if((g|0)!=2){break a}break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Gv(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function Av(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Uu(c)|0;k=j;i=b;return k|0}function Bv(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((f|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function Cv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Gv(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Gv(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};case 6:{b=b+3|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function Dv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Gv(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Ev(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Fv(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Gv(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 219:case 218:case 217:case 216:{d=7;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 223:case 222:case 221:case 220:{d=8;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function Hv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=Jv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Gv(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 29:{if((c[58552+((d[59832+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Iv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Gv(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 29:{if((c[58552+((d[59832+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Jv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=Kv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Gv(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Kv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Gv(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Gv(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Lv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Gv(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Gv(a[g+1|0]|0,a[b]|0)|0}if((n|0)==20){k=Nv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=Mv(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=Pv(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=Ov(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=Gv(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 17:{break b;break};case 10:case 9:case 21:{o=69;break b;break};case 11:{o=90;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=45;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Gv(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 29:{if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};case 24:case 22:{break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 6:{o=42;break b;break};case 29:{if((c[58552+((d[59832+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 5:{o=39;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=Gv(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 10:case 9:case 21:{break};case 17:{break c;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 5:{o=78;break d;break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[58552+((d[58296+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Qv(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Mv(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Gv(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Nv(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[60496+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}



function z0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=p1((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=p1((l<<2)+4|0)|0;if((p|0)==0){q1(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}F0(d,e)|0;e=F0(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 3:{E=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;G=c[D+(u+ -4<<2)>>2]|0;H=u+ -5|0;c[h>>2]=H;if(k){I=c[G+4>>2]|0;J=G+16|0;c[G+20>>2]=(c[(c[I>>2]|0)+20>>2]|0)+(c[D+(H<<2)>>2]|0)+(c[(c[I+4>>2]|0)+20>>2]|0)+((c[J>>2]|0)>0?2:0);K=J;L=c[h>>2]|0}else{K=G+16|0;L=H}H=c[D+(L+ -1<<2)>>2]|0;G=L+ -2|0;c[h>>2]=G;J=c[D+(G<<2)>>2]|0;G=L+ -3|0;c[h>>2]=G;I=c[D+(G<<2)>>2]|0;if((c[K>>2]|0)<=0){M=1;N=w;O=x;P=y;Q=z;R=H;S=0;T=B;break b}if(k){U=0}else{I0(b,E,J)|0;c[(c[r>>2]|0)+(J<<2)>>2]=1;J=I0(b,F,I)|0;c[(c[r>>2]|0)+(I<<2)>>2]=1;U=J}M=1;N=w;O=x;P=y;Q=z+2|0;R=H;S=U;T=B;break};case 1:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;if(k){H=c[(c[c[J+4>>2]>>2]|0)+20>>2]|0;I=u+ -3|0;c[h>>2]=I;c[J+20>>2]=(c[D+(I<<2)>>2]|0)+H;M=v;N=-1;O=x;P=y;Q=z;R=A;S=0;T=B;break b}else{H=u+ -3|0;c[h>>2]=H;I=c[D+(H<<2)>>2]|0;H=u+ -4|0;c[h>>2]=H;J=(I|0)==0;M=J&1;N=J?w:c[D+(H<<2)>>2]|0;O=x;P=y;Q=z;R=A;S=0;T=B;break b}break};case 6:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;H=0;do{V=A+(H<<2)|0;H=H+1|0}while((c[V>>2]|0)>-1);c[V>>2]=J<<1|1;c[A+(H<<2)>>2]=-1;I=0;while(1){if((c[p+(I<<2)>>2]|0)>-1){I=I+1|0}else{break}}c[p+(I+ -1<<2)>>2]=-1;M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break};case 4:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;H=u+ -3|0;c[h>>2]=H;M=v;N=w;O=c[D+(H<<2)>>2]|0;P=y;Q=z;R=A;S=0;T=(J|0)>-1?J:B;break};case 0:{J=u+ -2|0;c[h>>2]=J;H=c[D+(J<<2)>>2]|0;J=H;F=H+12|0;E=c[F>>2]|0;if((E|0)>-1){G=0;do{W=A+(G<<2)|0;G=G+1|0}while((c[W>>2]|0)>-1);c[W>>2]=E<<1;c[A+(G<<2)>>2]=-1;do{if(!k){I=0;while(1){if((c[p+(I<<2)>>2]|0)>-1){I=I+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((I|0)<=0){break}X=p1((I<<2)+4|0)|0;Y=X;if((X|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=X+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);E=F0(d,c[F>>2]|0)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}E=F0(d,6)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}}E=c[H>>2]|0;do{if((E|0)==0){G=c[c[H+4>>2]>>2]|0;if(!((G|0)>-1|(G|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[H+20>>2]=1;ra=w;sa=y;ta=0}else{G=H0(b,J,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;fa=0;while(1){ua=ea+(fa<<2)|0;va=fa+1|0;if((c[ua>>2]|0)>-1){fa=va}else{break}}c[ua>>2]=B;c[ea+(va<<2)>>2]=w;c[ea+(fa+2<<2)>>2]=-1;wa=-1;xa=y+1|0}else{wa=w;xa=y}Y=c[A>>2]|0;if((Y|0)>-1){da=c[s>>2]|0;X=Y;Y=0;do{I=(X|0)/2|0;if((X&1|0)==0){c[da+(I*12|0)>>2]=B}else{c[da+(I*12|0)+4>>2]=B}Y=Y+1|0;X=c[A+(Y<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;ra=wa;sa=xa;ta=G}c[A>>2]=-1;ka=v;la=ra;ma=x+1|0;na=sa;oa=z+1|0;pa=ta;qa=x}else if((E|0)==3){X=c[H+4>>2]|0;Y=c[X>>2]|0;da=c[X+4>>2]|0;X=(c[A>>2]|0)>-1;fa=x+1|0;ea=F0(d,X?fa:x)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,X?x:B)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,A)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,(c[A>>2]|0)>>>31^1)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,H)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=da;da=F0(d,ea)|0;if((da|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=da;qa=B;break}da=Y;Y=F0(d,da)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=F0(d,3)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=F0(d,ea)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=F0(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=F0(d,2)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=F0(d,da)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=F0(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if((c[A>>2]|0)>-1){if(k){ya=w;za=y;Aa=0}else{Y=H0(b,J,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){da=c[t>>2]|0;ea=0;while(1){Ba=da+(ea<<2)|0;Ca=ea+1|0;if((c[Ba>>2]|0)>-1){ea=Ca}else{break}}c[Ba>>2]=B;c[da+(Ca<<2)>>2]=w;c[da+(ea+2<<2)>>2]=-1;Da=-1;Ea=y+1|0}else{Da=w;Ea=y}G=c[A>>2]|0;if((G|0)>-1){X=c[s>>2]|0;I=G;G=0;do{ia=(I|0)/2|0;if((I&1|0)==0){c[X+(ia*12|0)>>2]=B}else{c[X+(ia*12|0)+4>>2]=B}G=G+1|0;I=c[A+(G<<2)>>2]|0;}while((I|0)>-1)}c[A>>2]=-1;ya=Da;za=Ea;Aa=Y}c[A>>2]=-1;Fa=ya;Ga=fa;Ha=za;Ia=z+1|0;Ja=Aa;Ka=x}else{Fa=w;Ga=x;Ha=y;Ia=z;Ja=0;Ka=B}if((c[H+16>>2]|0)<=0){ka=v;la=Fa;ma=Ga;na=Ha;oa=Ia;pa=Ja;qa=Ka;break}ka=v;la=Fa;ma=Ga+2|0;na=Ha;oa=Ia;pa=Ja;qa=Ga+1|0}else if((E|0)==2){I=c[H+4>>2]|0;if(k){if((c[A>>2]|0)>-1){La=1}else{La=a[I+12|0]&1}G=F0(d,La)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}}else{G=F0(d,B)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=F0(d,a[I+12|0]&1)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}}G=F0(d,H)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=F0(d,1)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=F0(d,c[I>>2]|0)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}G=F0(d,0)|0;if((G|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=G;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[I+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){Ma=w;Na=y;Oa=0}else{G=H0(b,J,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[I+12|0]&1)==0?v:1;if((w|0)>-1){I=c[t>>2]|0;X=0;while(1){Pa=I+(X<<2)|0;Qa=X+1|0;if((c[Pa>>2]|0)>-1){X=Qa}else{break}}c[Pa>>2]=B;c[I+(Qa<<2)>>2]=w;c[I+(X+2<<2)>>2]=-1;Ra=-1;Sa=y+1|0}else{Ra=w;Sa=y}fa=c[A>>2]|0;if((fa|0)>-1){Y=c[s>>2]|0;ea=fa;fa=0;do{da=(ea|0)/2|0;if((ea&1|0)==0){c[Y+(da*12|0)>>2]=B}else{c[Y+(da*12|0)+4>>2]=B}fa=fa+1|0;ea=c[A+(fa<<2)>>2]|0;}while((ea|0)>-1)}c[A>>2]=-1;Ma=Ra;Na=Sa;Oa=G}c[A>>2]=-1;ka=0;la=Ma;ma=x+1|0;na=Na;oa=z+1|0;pa=Oa;qa=x}else if((E|0)==1){ea=c[H+4>>2]|0;fa=c[ea>>2]|0;Y=c[ea+4>>2]|0;ea=F0(d,H)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,5)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,Y)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=fa+20|0;X=F0(d,(c[ea>>2]|0)+x|0)|0;if((X|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=X;qa=B;break}if((c[ea>>2]|0)>0){ea=(c[Y+20>>2]|0)>0;Ta=(ea&1)+x|0;Ua=ea?x:-1}else{Ta=x;Ua=-1}ea=F0(d,Ua)|0;if((ea|0)!=0){ka=v;la=w;ma=Ta;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,4)|0;if((ea|0)!=0){ka=v;la=w;ma=Ta;na=y;oa=z;pa=ea;qa=B;break}ea=F0(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=Ta;na=y;oa=z;pa=ea;qa=B;break}ka=v;la=w;ma=Ta;na=y;oa=z;pa=F0(d,0)|0;qa=B}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);H=c[F>>2]|0;if((H|0)>-1){Va=0}else{M=ka;N=la;O=ma;P=na;Q=oa;R=A;S=pa;T=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=H;c[p+(Va<<2)>>2]=-1;M=ka;N=la;O=ma;P=na;Q=oa;R=A;S=pa;T=qa;break};case 2:{F=A;while(1){if((c[F>>2]|0)>-1){F=F+4|0}else{M=v;N=w;O=x;P=y;Q=z;R=F;S=0;T=B;break}}break};case 5:{F=u+ -2|0;c[h>>2]=F;H=c[D+(F<<2)>>2]|0;if(!k){M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break b}F=c[H+4>>2]|0;c[H+20>>2]=(c[(c[F+4>>2]|0)+20>>2]|0)+(c[(c[F>>2]|0)+20>>2]|0);M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break};default:{M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(S|0)==0){u=D;v=M;w=N;x=O;y=P;z=Q;A=R;B=T}else{Z=N;_=P;$=Q;aa=R;ba=S;ca=T;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;T=e;e=0;do{S=(T|0)/2|0;if((T&1|0)==0){c[n+(S*12|0)>>2]=ca}else{c[n+(S*12|0)+4>>2]=ca}e=e+1|0;T=c[aa+(e<<2)>>2]|0;}while((T|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}T=c[f+36>>2]|0;e=0;while(1){Ya=T+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[T+(Za<<2)>>2]=Z;c[T+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;q1(m);q1(p);o=ba;i=g;return o|0}function A0(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;k=C0(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((k|0)!=0){l=k;m=10;break a}k=A0(c[h>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else if((a|0)==3){k=c[g+4>>2]|0;j=A0(c[k>>2]|0,b,d,e)|0;if((j|0)!=0){l=j;m=10;break a}n=k+4|0}else if((a|0)==2){k=c[g+4>>2]|0;j=k;if(!((c[k+8>>2]|0)==-1)){n=j;break}h=c[k>>2]|0;k=C0(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else{l=0;m=10;break a}}while(0);g=c[n>>2]|0}if((m|0)==10){i=f;return l|0}return 0}function B0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{q1(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}q1(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){q1(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){q1(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}q1(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{q1(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}q1(m)}m=c[d+32>>2]|0;if((m|0)!=0){q1(m)}m=c[d+20>>2]|0;if((m|0)!=0){q1(m)}m=c[d+36>>2]|0;if((m|0)!=0){q1(m)}q1(d);i=b;return}function C0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=p1(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){q1(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=p1((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function D0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=P0(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=P0(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=P0(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function E0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=F0(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==1){s=c[o+4>>2]|0;r=F0(a,c[s>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}B=F0(a,c[s+4>>2]|0)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=F0(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=F0(a,r)|0}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=F0(a,r)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function F0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=s1(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;F0(a,b)|0;i=d;return 0}return 0}function G0(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;F0(d,e)|0;e=F0(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==3){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=P0(b,0,0,1,32)|0;if((F|0)==0){G=20;break b}H=P0(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=20;break b}c[F>>2]=3;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;I=F0(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,F+4|0)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=F;M=F0(d,0)|0}else if((z|0)==0){F=c[u+4>>2]|0;I=c[F+8>>2]|0;y=c[F>>2]|0;D=c[F+4>>2]|0;do{if((y|0)>-1|(y|0)==-4){N=r;O=D;P=y;Q=s+1|0;R=(c[g>>2]|0)+I|0}else{if(!((y|0)==-3)){N=r;O=D;P=y;Q=s;R=I;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=D;P=-3;Q=s;R=I;break}c[h+(D<<2)>>2]=1;N=0;O=D;P=-3;Q=s;R=I}}while(0);I=P0(b,0,0,1,32)|0;D=I;do{if((I|0)==0){S=0}else{y=P0(b,0,0,1,20)|0;c[I+4>>2]=y;if((y|0)==0){S=0;break}c[I>>2]=0;c[I+8>>2]=-1;c[I+12>>2]=-1;c[y>>2]=P;c[y+4>>2]=O;c[y+8>>2]=R;S=D}}while(0);c[t>>2]=S;D=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=D;break}c[k>>2]=R;J=N;K=Q;L=t;M=D}else if((z|0)==1){D=c[u+4>>2]|0;I=c[D>>2]|0;y=D+4|0;F=c[y>>2]|0;x=P0(b,0,0,1,32)|0;if((x|0)==0){G=29;break b}E=P0(b,0,0,1,8)|0;H=x+4|0;c[H>>2]=E;if((E|0)==0){G=29;break b}c[x>>2]=1;c[x+8>>2]=-1;c[x+12>>2]=-1;c[E>>2]=I;c[(c[H>>2]|0)+4>>2]=F;c[x+16>>2]=(c[F+16>>2]|0)+(c[I+16>>2]|0);c[t>>2]=x;x=c[H>>2]|0;c[x>>2]=0;H=x+4|0;c[H>>2]=0;I=F0(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,H)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=x;M=F0(d,0)|0}else if((z|0)==2){x=c[u+4>>2]|0;I=F0(d,c[x>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=F0(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=c[x>>2]|0;D=c[x+4>>2]|0;H=c[x+8>>2]|0;y=a[x+12|0]|0;x=P0(b,0,0,1,32)|0;if((x|0)==0){G=40;break b}F=P0(b,0,0,1,16)|0;E=x+4|0;c[E>>2]=F;if((F|0)==0){G=40;break b}c[x>>2]=2;c[x+8>>2]=-1;c[x+12>>2]=-1;c[F>>2]=I;c[F+4>>2]=D;c[F+8>>2]=H;H=F+12|0;a[H]=a[H]&-2|y&1;c[x+16>>2]=c[I+16>>2];c[t>>2]=x;A=s;B=r;t=c[E>>2]|0;s=A;r=B;continue b}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function H0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=P0(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=P0(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=P0(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=P0(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function I0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=P0(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=P0(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=P0(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=P0(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function J0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function K0(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=156088}else{j=b;k=156088;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((T1(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Mc(e|0,f|0,156376,g|0)|0)+1|0;i=d;return h|0}function L0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=p1(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=p1(y)|0;if((z|0)==0){A=12;break}X1(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=t0(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((_$(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((_$(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((_$(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((_$(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(_$(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(_$(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(_$(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(_$(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){X1(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=t0(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((_$(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((_$(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((_$(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((_$(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(_$(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(_$(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(_$(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(_$(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((c0(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=o0(X)|0;qb=_a+24|0;if((c0(fb,c[qb>>2]|0)|0)!=0){break}fb=m0(X)|0;if((c0(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((c0(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=m0(X)|0;if((c0(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=o0(X)|0;if((c0(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}q1(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=N0(0,0)|0;if((S|0)==0){A=12;break}R=P0(S,0,0,0,32)|0;Q=R;if((R|0)==0){O0(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=p1(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=p1(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=p1(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){X1(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){X1(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=t0(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((_$(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((_$(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((_$(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((_$(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(_$(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(_$(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(_$(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(_$(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=P0(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=P0(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;M0(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((Q1(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=t0(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=t0(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((_$(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((_$(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((_$(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((_$(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(_$(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(_$(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(_$(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(_$(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((c0(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=o0(tc)|0;aa=Ca+24|0;if((c0(qa,c[aa>>2]|0)|0)!=0){break}qa=m0(tc)|0;if((c0(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((c0(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=m0(tc)|0;if((c0(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=o0(tc)|0;if((c0(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=P0(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=P0(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){O0(S);if((Eb|0)!=0){q1(O)}if((Kb|0)!=0){q1(Kb)}if((Lb|0)==0){A=12;break a}q1(N);A=12;break a}else if((sa|0)==67){O0(S);if((Eb|0)!=0){q1(O)}if((Kb|0)!=0){q1(Kb)}if((Lb|0)==0){A=12;break a}q1(N);A=12;break a}else if((sa|0)==169){O0(S);if((Eb|0)!=0){q1(O)}if((Kb|0)!=0){q1(Kb)}if((Lb|0)==0){A=12;break a}q1(N);A=12;break a}else if((sa|0)==176){O0(S);if((Eb|0)!=0){q1(O)}if((Kb|0)!=0){q1(Kb)}if((Lb|0)==0){A=12;break a}q1(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);O0(S);if((Jb|0)!=0){q1(Jb)}if((Gb|0)!=0){q1(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}q1(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}M0(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}q1(m);p=A;i=g;return p|0}function M0(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function N0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=r1(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function O0(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;q1(e);i=b;return}else{f=d}while(1){q1(c[f>>2]|0);d=c[f+4>>2]|0;q1(f);if((d|0)==0){break}else{f=d}}e=a;q1(e);i=b;return}function P0(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=p1(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=p1(p)|0;c[o>>2]=r;if((r|0)==0){q1(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}X1(m|0,0,h|0)|0;j=m;i=g;return j|0}function Q0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((R0(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function R0(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function S0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function T0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function U0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function V0(a){a=a|0;i=i;return}function W0(a){a=a|0;c[a>>2]=156392;i=i;return}function X0(a){a=a|0;var b=0;b=i;zb(a|0);x1(a);i=b;return}function Y0(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function Z0(a){a=a|0;i=i;return 156408}function _0(a){a=a|0;i=i;return}function $0(a){a=a|0;i=i;return}function a1(a){a=a|0;i=i;return}function b1(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function c1(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function d1(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function e1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=i1(b,156520,156576,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;De[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function f1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function g1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;De[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function h1(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;De[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;De[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function i1(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;me[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}Zd[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function j1(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;me[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;Zd[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;Zd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;Zd[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;Zd[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function k1(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;Zd[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;me[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function l1(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function m1(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;me[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;me[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function n1(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;me[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function o1(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function p1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[39206]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=156864+(j<<2)|0;l=156864+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[39206]=f&~(1<<h)}else{if(n>>>0<(c[156840>>2]|0)>>>0){ed()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{ed()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[156832>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=156864+(r<<2)|0;o=156864+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[39206]=f&~(1<<t)}else{if(n>>>0<(c[156840>>2]|0)>>>0){ed()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{ed()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[156832>>2]|0;if((n|0)!=0){f=c[156844>>2]|0;e=n>>>3;n=e<<1;g=156864+(n<<2)|0;m=c[39206]|0;j=1<<e;do{if((m&j|0)==0){c[39206]=m|j;u=156864+(n+2<<2)|0;v=g}else{e=156864+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[156840>>2]|0)>>>0)){u=e;v=h;break}ed()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[156832>>2]=o;c[156844>>2]=s;p=k;i=b;return p|0}n=c[156828>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[157128+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[156840>>2]|0;if(h>>>0<k>>>0){ed()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){ed()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){ed()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){ed()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){ed()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{ed()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=157128+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[156828>>2]=c[156828>>2]&~(1<<h);break a}else{if(s>>>0<(c[156840>>2]|0)>>>0){ed()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[156840>>2]|0)>>>0){ed()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[156832>>2]|0;if((h|0)!=0){s=c[156844>>2]|0;k=h>>>3;h=k<<1;f=156864+(h<<2)|0;m=c[39206]|0;g=1<<k;do{if((m&g|0)==0){c[39206]=m|g;A=156864+(h+2<<2)|0;B=f}else{k=156864+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[156840>>2]|0)>>>0)){A=k;B=e;break}ed()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[156832>>2]=t;c[156844>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[156828>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[157128+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[157128+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[156832>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[156840>>2]|0;if(t>>>0<f>>>0){ed()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){ed()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){ed()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){ed()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){ed()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{ed()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=157128+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[156828>>2]=c[156828>>2]&~(1<<e);break c}else{if(t>>>0<(c[156840>>2]|0)>>>0){ed()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[156840>>2]|0)>>>0){ed()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=156864+(t<<2)|0;s=c[39206]|0;r=1<<e;do{if((s&r|0)==0){c[39206]=s|r;S=156864+(t+2<<2)|0;T=f}else{e=156864+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[156840>>2]|0)>>>0)){S=e;T=k;break}ed()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=157128+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[156828>>2]|0;l=1<<U;if((f&l|0)==0){c[156828>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[156840>>2]|0;if(W>>>0<k>>>0){ed()}if(r>>>0<k>>>0){ed()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[156832>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[156844>>2]|0;if(W>>>0>15){c[156844>>2]=X+q;c[156832>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[156832>>2]=0;c[156844>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[156836>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[156836>>2]=W;X=c[156848>>2]|0;c[156848>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[39324]|0)==0){X=cd(30)|0;if((X+ -1&X|0)==0){c[157304>>2]=X;c[157300>>2]=X;c[157308>>2]=-1;c[157312>>2]=-1;c[157316>>2]=0;c[157268>>2]=0;c[39324]=(sc(0)|0)&-16^1431655768;break}else{ed()}}}while(0);X=q+48|0;W=c[157304>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[157264>>2]|0;do{if((U|0)!=0){T=c[157256>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[157268>>2]&4|0)==0){U=c[156848>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=157272|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[156836>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[157300>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[157256>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[157264>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[157304>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[157268>>2]=c[157268>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[157256>>2]|0)+ga|0;c[157256>>2]=ia;if(ia>>>0>(c[157260>>2]|0)>>>0){c[157260>>2]=ia}ia=c[156848>>2]|0;W=157272|0;i:do{if((ia|0)==0){aa=c[156840>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[156840>>2]=fa}c[157272>>2]=fa;c[157276>>2]=ga;c[157284>>2]=0;c[156860>>2]=c[39324];c[156856>>2]=-1;aa=0;do{ha=aa<<1;$=156864+(ha<<2)|0;c[156864+(ha+3<<2)>>2]=$;c[156864+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[156848>>2]=fa+ja;c[156836>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[156852>>2]=c[157312>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[156836>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[156848>>2]=ia+na;c[156836>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[156852>>2]=c[157312>>2];break i}}while(0);if(fa>>>0<(c[156840>>2]|0)>>>0){c[156840>>2]=fa}aa=fa+ga|0;$=157272|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[156848>>2]|0)){ca=(c[156836>>2]|0)+X|0;c[156836>>2]=ca;c[156848>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[156844>>2]|0)){ca=(c[156832>>2]|0)+X|0;c[156832>>2]=ca;c[156844>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=156864+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[156840>>2]|0)>>>0){ed()}if((c[V+12>>2]|0)==(ha|0)){break}ed()}}while(0);if((L|0)==(V|0)){c[39206]=c[39206]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[156840>>2]|0)>>>0){ed()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}ed()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[156840>>2]|0)>>>0){ed()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){ed()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{ed()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=157128+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[156828>>2]=c[156828>>2]&~(1<<t);break k}else{if(T>>>0<(c[156840>>2]|0)>>>0){ed()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[156840>>2]|0)>>>0){ed()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=156864+(Z<<2)|0;t=c[39206]|0;T=1<<ca;do{if((t&T|0)==0){c[39206]=t|T;xa=156864+(Z+2<<2)|0;ya=ea}else{ca=156864+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[156840>>2]|0)>>>0)){xa=ca;ya=V;break}ed()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=157128+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[156828>>2]|0;L=1<<za;if((ea&L|0)==0){c[156828>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[156840>>2]|0;if(Ba>>>0<S>>>0){ed()}if(T>>>0<S>>>0){ed()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=157272|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[156848>>2]=fa+Ha;c[156836>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[156852>>2]=c[157312>>2];c[ba+4>>2]=27;X=157272|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[157272>>2]=fa;c[157276>>2]=ga;c[157284>>2]=0;c[157280>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=156864+(da<<2)|0;aa=c[39206]|0;f=1<<M;do{if((aa&f|0)==0){c[39206]=aa|f;Ia=156864+(da+2<<2)|0;Ja=ha}else{M=156864+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[156840>>2]|0)>>>0)){Ia=M;Ja=T;break}ed()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=157128+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[156828>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[156828>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[156840>>2]|0;if(Ma>>>0<f>>>0){ed()}if(M>>>0<f>>>0){ed()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[156836>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[156836>>2]=W;ia=c[156848>>2]|0;c[156848>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Nc()|0)>>2]=12;p=0;i=b;return p|0}



function kh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0;g=i;i=i+240|0;h=g;j=g+120|0;qi(j,b,d,e,f);f=a;a=h+0|0;b=j+0|0;j=a+120|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(j|0));ti(f,0,0.0,0.0,h);i=g;return}function lh(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function mh(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+96|0;h=g;j=g+40|0;k=g+56|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];ih(k,b,d,e,j,0);j=a;a=h+0|0;b=k+0|0;k=a+40|0;do{c[a>>2]=c[b>>2];a=a+4|0;b=b+4|0}while((a|0)<(k|0));lh(j,0,h);i=g;return}function nh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0;d=+h[c+16>>3];e=+h[c+8>>3];f=+h[c+24>>3];g=+h[c+48>>3];j=d*e*f*(g*2.0+f*+h[c+56>>3]);h[a>>3]=+h[c>>3]*d*e*f*g;h[a+8>>3]=j;i=i;return}function oh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0;d=+h[c+32>>3];e=+h[c+16>>3];f=+h[c>>3];g=+h[c+8>>3];j=+h[c+24>>3];k=+h[c+48>>3];l=j*k;m=e*g*(l+d*+h[c+64>>3]);n=e*g*j*(k*2.0+j*+h[c+56>>3]);o=e*f*j*(k-d*+h[c+80>>3]);k=o/f;j=k-e*d*d*+h[c+72>>3];h[a>>3]=f*e*g*l;h[a+8>>3]=m;h[a+16>>3]=n;h[a+24>>3]=o;h[a+32>>3]=(n-g*k)/f;h[a+40>>3]=j;i=i;return}function ph(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;d=+h[c+16>>3];e=+h[c>>3];f=+h[c+8>>3];g=+h[c+24>>3];j=+h[c+48>>3];k=g*j;l=+h[c+32>>3];m=l*+h[c+64>>3];n=d*(m- +h[c+40>>3]);o=g*(j-l*+h[c+80>>3]);p=l*l*+h[c+72>>3];l=+h[c+56>>3];h[a>>3]=e;h[a+8>>3]=d*f*(k+m);h[a+16>>3]=d*f*m;h[a+24>>3]=n;h[a+32>>3]=d*(o*o/(k*2.0+g*g*l)-p);h[a+40>>3]=-(d*p);h[a+48>>3]=d*e*o;h[a+56>>3]=d*f*g*(j*2.0+g*l);i=i;return}function qh(a,b,c){a=a|0;b=b|0;c=c|0;var d=0.0,e=0.0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;d=+h[c>>3];e=+h[c+48>>3];f=+h[c+24>>3];g=e*f;j=+h[c+8>>3];k=+h[c+16>>3];l=+h[c+32>>3];m=l*+h[c+64>>3];n=k*(m- +h[c+40>>3]);o=l*l*+h[c+72>>3];p=e-l*+h[c+80>>3];l=+h[c+56>>3];h[a>>3]=d/(g*j*k);h[a+8>>3]=k*j*m;h[a+16>>3]=j*k*(m-g);h[a+24>>3]=n;h[a+32>>3]=-(k*o);h[a+40>>3]=k*(p*p/l-o);h[a+48>>3]=-(d*(p/(l*f*j)));h[a+56>>3]=-(k*j*(e*e/l));i=i;return}function rh(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;var j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;j=+h[c>>3];k=+h[d>>3];if(j!=k){l=j*(k/(j-k))}else{l=0.0}m=l*(+h[d+24>>3]- +h[c+24>>3]);n=+h[c+48>>3];o=(n-m)/(j*j*+h[c+56>>3]);j=+h[d+48>>3];p=(j-m)/(k*k*+h[d+56>>3]);k=(n*f-g)*o+ +h[c+40>>3];h[a>>3]=k+(((j*f-g)*p+ +h[d+40>>3]-k)*e-l*(o+(p-o)*e)*(+h[d+16>>3]- +h[c+16>>3]));i=i;return}function sh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0;f=i;i=i+32|0;g=f;j=f+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;c[v>>2]=3;Az(w,1,v);if(!(d>611.657)){v=lz(lz(7432,jz(d,0,1,6)|0)|0,5248)|0;x=lz(lz(v,jz(611.657,0,1,6)|0)|0,5256)|0;v=c[28994]|0;y=g;z=7496;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];De[v&31](b,g,x,u);}A=d/1.0e6;d=e/25.0e5+1.0;c[t>>2]=1;h[(Fz(w,1,t)|0)>>3]=d*d;c[s>>2]=1;e=+h[(Fz(w,1,s)|0)>>3];c[r>>2]=2;h[(Fz(w,1,r)|0)>>3]=e*e;c[q>>2]=2;e=+h[(Fz(w,1,q)|0)>>3];c[p>>2]=3;h[(Fz(w,1,p)|0)>>3]=e*e;c[o>>2]=1;e=+h[(Fz(w,1,o)|0)>>3];c[n>>2]=2;B=+h[(Fz(w,1,n)|0)>>3];c[m>>2]=2;C=+h[(Fz(w,1,m)|0)>>3];c[l>>2]=3;D=+h[(Fz(w,1,l)|0)>>3];c[k>>2]=1;E=+h[(Fz(w,1,k)|0)>>3];c[j>>2]=3;h[a>>3]=A*-13.391744872602+d*(A*43.211039183559+d*(A*-54.010067170506+d*(A*30.535892203916+d*(A*-6.5964749423638+e*(B*(A*(A*(A*6.6456186191635e-8+-25858641282073.0e-18)+.0093965400878363)+C*D*(E*(A*(A*(A*(A*(A*(A*-1.5020185953503e-17+5.8265442020601e-15)+-9.3477771213947e-13)+8.0670734103027e-11)+-4.0644363084799e-9)+1.157364750534e-7)+-10866707695377.0e-19)*+h[(Fz(w,1,j)|0)>>3]+-.0001528548241314))+-5.8457616048039)))+113.49746881718)+404.21188637945)+-238.72489924521;i=f;return}function th(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,B=0,C=0,D=0,E=0,F=0,G=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0,Be=0,Ce=0,Ee=0,Fe=0,Ge=0,He=0,Ie=0,Je=0,Ke=0,Le=0,Me=0,Ne=0,Oe=0,Pe=0,Qe=0,Re=0,Se=0,Te=0,Ue=0,Ve=0,We=0,Xe=0,Ye=0,Ze=0,_e=0,$e=0,af=0,bf=0,cf=0,df=0,ef=0,ff=0,gf=0,hf=0,jf=0,kf=0,lf=0,mf=0,nf=0,of=0,pf=0,qf=0,rf=0,sf=0,tf=0,uf=0,vf=0,wf=0,xf=0,yf=0,zf=0,Af=0,Bf=0,Cf=0,Df=0,Ef=0,Ff=0,Gf=0,Hf=0,If=0,Jf=0,Kf=0,Lf=0,Mf=0,Nf=0,Of=0,Pf=0,Qf=0,Rf=0,Sf=0,Tf=0,Uf=0,Vf=0,Wf=0,Xf=0,Yf=0,Zf=0,_f=0,$f=0,ag=0,bg=0,cg=0,dg=0.0,eg=0.0,fg=0.0,gg=0.0;f=i;i=i+5696|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+8|0;xe=i;i=i+8|0;ye=i;i=i+8|0;ze=i;i=i+8|0;Ae=i;i=i+8|0;Be=i;i=i+8|0;Ce=i;i=i+8|0;Ee=i;i=i+8|0;Fe=i;i=i+8|0;Ge=i;i=i+8|0;He=i;i=i+8|0;Ie=i;i=i+8|0;Je=i;i=i+8|0;Ke=i;i=i+8|0;Le=i;i=i+8|0;Me=i;i=i+8|0;Ne=i;i=i+8|0;Oe=i;i=i+8|0;Pe=i;i=i+8|0;Qe=i;i=i+8|0;Re=i;i=i+8|0;Se=i;i=i+8|0;Te=i;i=i+8|0;Ue=i;i=i+8|0;Ve=i;i=i+8|0;We=i;i=i+8|0;Xe=i;i=i+8|0;Ye=i;i=i+8|0;Ze=i;i=i+8|0;_e=i;i=i+8|0;$e=i;i=i+8|0;af=i;i=i+8|0;bf=i;i=i+8|0;cf=i;i=i+8|0;df=i;i=i+8|0;ef=i;i=i+8|0;ff=i;i=i+8|0;gf=i;i=i+8|0;hf=i;i=i+8|0;jf=i;i=i+8|0;kf=i;i=i+8|0;lf=i;i=i+8|0;mf=i;i=i+8|0;nf=i;i=i+8|0;of=i;i=i+8|0;pf=i;i=i+8|0;qf=i;i=i+8|0;rf=i;i=i+8|0;sf=i;i=i+8|0;tf=i;i=i+8|0;uf=i;i=i+8|0;vf=i;i=i+8|0;wf=i;i=i+8|0;xf=i;i=i+8|0;yf=i;i=i+8|0;zf=i;i=i+8|0;Af=i;i=i+8|0;Bf=i;i=i+8|0;Cf=i;i=i+8|0;Df=i;i=i+8|0;Ef=i;i=i+8|0;Ff=i;i=i+8|0;Gf=i;i=i+8|0;Hf=i;i=i+8|0;If=i;i=i+8|0;Jf=i;i=i+8|0;Kf=i;i=i+8|0;Lf=i;i=i+8|0;Mf=i;i=i+8|0;Nf=i;i=i+8|0;Of=i;i=i+8|0;Pf=i;i=i+8|0;Qf=i;i=i+8|0;Rf=i;i=i+8|0;Sf=i;i=i+8|0;Tf=i;i=i+8|0;Uf=i;i=i+8|0;Vf=i;i=i+8|0;Wf=i;i=i+8|0;Xf=i;i=i+8|0;Yf=i;i=i+8|0;Zf=i;i=i+8|0;_f=i;i=i+8|0;$f=i;i=i+8|0;ag=i;i=i+16|0;c[$f>>2]=55;Az(ag,1,$f);if(!(d>0.0)){$f=lz(lz(7520,jz(d,0,1,6)|0)|0,7584)|0;bg=c[28994]|0;cg=f+96|0;c[cg+0>>2]=c[7600+0>>2];c[cg+4>>2]=c[7600+4>>2];c[cg+8>>2]=c[7600+8>>2];c[cg+12>>2]=c[7600+12>>2];c[cg+16>>2]=c[7600+16>>2];c[cg+20>>2]=c[7600+20>>2];De[bg&31](b,f+96|0,$f,_f);}if(!(d<=1.0e8)){_f=lz(lz(7624,jz(d,0,1,6)|0)|0,7672)|0;$f=c[28994]|0;bg=f+72|0;c[bg+0>>2]=c[7704+0>>2];c[bg+4>>2]=c[7704+4>>2];c[bg+8>>2]=c[7704+8>>2];c[bg+12>>2]=c[7704+12>>2];c[bg+16>>2]=c[7704+16>>2];c[bg+20>>2]=c[7704+20>>2];De[$f&31](b,f+72|0,_f,Zf);}if(!(e>=273.15)){Zf=lz(lz(7728,jz(e,0,1,6)|0)|0,7776)|0;_f=c[28994]|0;$f=f+48|0;c[$f+0>>2]=c[7808+0>>2];c[$f+4>>2]=c[7808+4>>2];c[$f+8>>2]=c[7808+8>>2];c[$f+12>>2]=c[7808+12>>2];c[$f+16>>2]=c[7808+16>>2];c[$f+20>>2]=c[7808+20>>2];De[_f&31](b,f+48|0,Zf,Yf);}if(!(e<=1073.15)){Yf=lz(lz(7832,jz(e,0,1,6)|0)|0,7888)|0;Zf=c[28994]|0;_f=f+24|0;c[_f+0>>2]=c[7936+0>>2];c[_f+4>>2]=c[7936+4>>2];c[_f+8>>2]=c[7936+8>>2];c[_f+12>>2]=c[7936+12>>2];c[_f+16>>2]=c[7936+16>>2];c[_f+20>>2]=c[7936+20>>2];De[Zf&31](b,f+24|0,Yf,Xf);}dg=540.0/e+-.5;c[Wf>>2]=1;h[(Fz(ag,1,Wf)|0)>>3]=dg*dg;c[Vf>>2]=1;eg=dg*+h[(Fz(ag,1,Vf)|0)>>3];c[Uf>>2]=2;h[(Fz(ag,1,Uf)|0)>>3]=eg;c[Tf>>2]=2;eg=+h[(Fz(ag,1,Tf)|0)>>3]*-.05032527872793;c[Sf>>2]=3;h[(Fz(ag,1,Sf)|0)>>3]=eg;c[Rf>>2]=3;eg=+h[(Fz(ag,1,Rf)|0)>>3]+-.057581259083432;c[Qf>>2]=4;h[(Fz(ag,1,Qf)|0)>>3]=eg;c[Pf>>2]=4;eg=dg*+h[(Fz(ag,1,Pf)|0)>>3];c[Of>>2]=5;h[(Fz(ag,1,Of)|0)>>3]=eg;c[Nf>>2]=5;eg=+h[(Fz(ag,1,Nf)|0)>>3]+-.045996013696365;c[Mf>>2]=6;h[(Fz(ag,1,Mf)|0)>>3]=eg;c[Lf>>2]=6;eg=dg*+h[(Fz(ag,1,Lf)|0)>>3];c[Kf>>2]=7;h[(Fz(ag,1,Kf)|0)>>3]=eg;c[Jf>>2]=7;eg=+h[(Fz(ag,1,Jf)|0)>>3]+-.017834862292358;c[If>>2]=8;h[(Fz(ag,1,If)|0)>>3]=eg;c[Hf>>2]=8;eg=dg*+h[(Fz(ag,1,Hf)|0)>>3];c[Gf>>2]=9;h[(Fz(ag,1,Gf)|0)>>3]=eg;c[Ff>>2]=1;eg=+h[(Fz(ag,1,Ff)|0)>>3];c[Ef>>2]=10;h[(Fz(ag,1,Ef)|0)>>3]=eg*eg;c[Df>>2]=10;eg=+h[(Fz(ag,1,Df)|0)>>3];c[Cf>>2]=11;h[(Fz(ag,1,Cf)|0)>>3]=eg*eg;c[Bf>>2]=11;eg=+h[(Fz(ag,1,Bf)|0)>>3];c[Af>>2]=12;h[(Fz(ag,1,Af)|0)>>3]=eg*eg;c[zf>>2]=10;eg=+h[(Fz(ag,1,zf)|0)>>3];c[yf>>2]=11;fg=+h[(Fz(ag,1,yf)|0)>>3];c[xf>>2]=12;gg=eg*fg*dg*+h[(Fz(ag,1,xf)|0)>>3];c[wf>>2]=13;h[(Fz(ag,1,wf)|0)>>3]=gg;c[vf>>2]=1;gg=+h[(Fz(ag,1,vf)|0)>>3];c[uf>>2]=10;fg=gg*dg*+h[(Fz(ag,1,uf)|0)>>3];c[tf>>2]=14;h[(Fz(ag,1,tf)|0)>>3]=fg;c[sf>>2]=10;fg=+h[(Fz(ag,1,sf)|0)>>3];c[rf>>2]=11;gg=fg*dg*+h[(Fz(ag,1,rf)|0)>>3];c[qf>>2]=15;h[(Fz(ag,1,qf)|0)>>3]=gg;c[pf>>2]=1;gg=+h[(Fz(ag,1,pf)|0)>>3];c[of>>2]=12;fg=gg*dg*+h[(Fz(ag,1,of)|0)>>3];c[nf>>2]=16;h[(Fz(ag,1,nf)|0)>>3]=fg;c[mf>>2]=1;fg=+h[(Fz(ag,1,mf)|0)>>3];c[lf>>2]=11;gg=fg*dg*+h[(Fz(ag,1,lf)|0)>>3];c[kf>>2]=17;h[(Fz(ag,1,kf)|0)>>3]=gg;c[jf>>2]=1;gg=+h[(Fz(ag,1,jf)|0)>>3];c[hf>>2]=10;fg=+h[(Fz(ag,1,hf)|0)>>3];c[gf>>2]=11;eg=gg*fg*+h[(Fz(ag,1,gf)|0)>>3];c[ff>>2]=18;h[(Fz(ag,1,ff)|0)>>3]=eg;c[ef>>2]=10;eg=+h[(Fz(ag,1,ef)|0)>>3];c[df>>2]=11;fg=+h[(Fz(ag,1,df)|0)>>3];c[cf>>2]=12;gg=eg*fg*+h[(Fz(ag,1,cf)|0)>>3];c[bf>>2]=19;h[(Fz(ag,1,bf)|0)>>3]=gg;c[af>>2]=1;gg=+h[(Fz(ag,1,af)|0)>>3];c[$e>>2]=10;fg=gg*+h[(Fz(ag,1,$e)|0)>>3];c[_e>>2]=20;h[(Fz(ag,1,_e)|0)>>3]=fg;c[Ze>>2]=21;h[(Fz(ag,1,Ze)|0)>>3]=d/1.0e6*(d/1.0e6);c[Ye>>2]=21;fg=+h[(Fz(ag,1,Ye)|0)>>3];c[Xe>>2]=22;h[(Fz(ag,1,Xe)|0)>>3]=fg*fg;c[We>>2]=21;fg=+h[(Fz(ag,1,We)|0)>>3];c[Ve>>2]=22;gg=fg*+h[(Fz(ag,1,Ve)|0)>>3];c[Ue>>2]=23;h[(Fz(ag,1,Ue)|0)>>3]=gg;c[Te>>2]=10;gg=+h[(Fz(ag,1,Te)|0)>>3];c[Se>>2]=12;fg=gg*dg*+h[(Fz(ag,1,Se)|0)>>3];c[Re>>2]=24;h[(Fz(ag,1,Re)|0)>>3]=fg;c[Qe>>2]=12;fg=+h[(Fz(ag,1,Qe)|0)>>3];c[Pe>>2]=25;h[(Fz(ag,1,Pe)|0)>>3]=fg*fg;c[Oe>>2]=11;fg=+h[(Fz(ag,1,Oe)|0)>>3];c[Ne>>2]=12;gg=+h[(Fz(ag,1,Ne)|0)>>3];c[Me>>2]=25;eg=fg*gg*dg*+h[(Fz(ag,1,Me)|0)>>3];c[Le>>2]=26;h[(Fz(ag,1,Le)|0)>>3]=eg;c[Ke>>2]=10;eg=+h[(Fz(ag,1,Ke)|0)>>3];c[Je>>2]=12;gg=eg*+h[(Fz(ag,1,Je)|0)>>3];c[Ie>>2]=27;h[(Fz(ag,1,Ie)|0)>>3]=gg;c[He>>2]=1;gg=+h[(Fz(ag,1,He)|0)>>3];c[Ge>>2]=10;eg=+h[(Fz(ag,1,Ge)|0)>>3];c[Fe>>2]=11;fg=gg*eg*dg*+h[(Fz(ag,1,Fe)|0)>>3];c[Ee>>2]=28;h[(Fz(ag,1,Ee)|0)>>3]=fg;c[Ce>>2]=10;fg=+h[(Fz(ag,1,Ce)|0)>>3];c[Be>>2]=12;eg=+h[(Fz(ag,1,Be)|0)>>3];c[Ae>>2]=25;gg=fg*eg*dg*+h[(Fz(ag,1,Ae)|0)>>3];c[ze>>2]=29;h[(Fz(ag,1,ze)|0)>>3]=gg;c[ye>>2]=1;gg=+h[(Fz(ag,1,ye)|0)>>3];c[xe>>2]=10;eg=+h[(Fz(ag,1,xe)|0)>>3];c[we>>2]=25;fg=gg*eg*dg*+h[(Fz(ag,1,we)|0)>>3];c[ve>>2]=30;h[(Fz(ag,1,ve)|0)>>3]=fg;c[ue>>2]=1;fg=+h[(Fz(ag,1,ue)|0)>>3];c[te>>2]=11;eg=+h[(Fz(ag,1,te)|0)>>3];c[se>>2]=12;gg=fg*eg*+h[(Fz(ag,1,se)|0)>>3];c[re>>2]=31;h[(Fz(ag,1,re)|0)>>3]=gg;c[qe>>2]=1;gg=+h[(Fz(ag,1,qe)|0)>>3];c[pe>>2]=12;eg=gg*+h[(Fz(ag,1,pe)|0)>>3];c[oe>>2]=32;h[(Fz(ag,1,oe)|0)>>3]=eg;c[ne>>2]=33;h[(Fz(ag,1,ne)|0)>>3]=540.0/e*(540.0/e);c[me>>2]=33;eg=+h[(Fz(ag,1,me)|0)>>3];c[le>>2]=34;h[(Fz(ag,1,le)|0)>>3]=eg*eg;c[ke>>2]=13;eg=+h[(Fz(ag,1,ke)|0)>>3]*-53349095828174.0e-18;c[je>>2]=35;h[(Fz(ag,1,je)|0)>>3]=eg;c[ie>>2]=35;eg=+h[(Fz(ag,1,ie)|0)>>3]+-.087594591301146;c[he>>2]=36;h[(Fz(ag,1,he)|0)>>3]=eg;c[ge>>2]=2;eg=+h[(Fz(ag,1,ge)|0)>>3];c[fe>>2]=36;gg=eg*+h[(Fz(ag,1,fe)|0)>>3];c[ee>>2]=37;h[(Fz(ag,1,ee)|0)>>3]=gg;c[de>>2]=37;gg=+h[(Fz(ag,1,de)|0)>>3]+-.007878555448671;c[ce>>2]=38;h[(Fz(ag,1,ce)|0)>>3]=gg;c[be>>2]=1;gg=+h[(Fz(ag,1,be)|0)>>3];c[ae>>2]=38;eg=gg*+h[(Fz(ag,1,ae)|0)>>3];c[$d>>2]=39;h[(Fz(ag,1,$d)|0)>>3]=eg;c[_d>>2]=39;eg=+h[(Fz(ag,1,_d)|0)>>3]+-.0003789797503263;c[Zd>>2]=40;h[(Fz(ag,1,Zd)|0)>>3]=eg;c[Yd>>2]=40;eg=dg*+h[(Fz(ag,1,Yd)|0)>>3];c[Xd>>2]=41;h[(Fz(ag,1,Xd)|0)>>3]=eg;c[Wd>>2]=41;eg=+h[(Fz(ag,1,Wd)|0)>>3]+-66065283340406.0e-18;c[Vd>>2]=42;h[(Fz(ag,1,Vd)|0)>>3]=eg;c[Ud>>2]=42;eg=dg*+h[(Fz(ag,1,Ud)|0)>>3];c[Td>>2]=43;h[(Fz(ag,1,Td)|0)>>3]=eg;c[Sd>>2]=44;h[(Fz(ag,1,Sd)|0)>>3]=dg*57870447262208.0e-19;c[Rd>>2]=2;eg=+h[(Fz(ag,1,Rd)|0)>>3]*-.30195167236758;c[Qd>>2]=45;h[(Fz(ag,1,Qd)|0)>>3]=eg;c[Pd>>2]=45;eg=+h[(Fz(ag,1,Pd)|0)>>3]+-.172743777250296;c[Od>>2]=46;h[(Fz(ag,1,Od)|0)>>3]=eg;c[Nd>>2]=46;eg=dg*+h[(Fz(ag,1,Nd)|0)>>3];c[Md>>2]=47;h[(Fz(ag,1,Md)|0)>>3]=eg;c[Ld>>2]=47;eg=+h[(Fz(ag,1,Ld)|0)>>3]+-.09199202739273;c[Kd>>2]=48;h[(Fz(ag,1,Kd)|0)>>3]=eg;c[Jd>>2]=48;eg=dg*+h[(Fz(ag,1,Jd)|0)>>3];c[Id>>2]=49;h[(Fz(ag,1,Id)|0)>>3]=eg;c[Hd>>2]=1;eg=+h[(Fz(ag,1,Hd)|0)>>3];c[Gd>>2]=11;gg=eg*+h[(Fz(ag,1,Gd)|0)>>3];c[Fd>>2]=50;h[(Fz(ag,1,Fd)|0)>>3]=gg;c[Ed>>2]=10;gg=+h[(Fz(ag,1,Ed)|0)>>3];c[Dd>>2]=11;eg=gg*+h[(Fz(ag,1,Dd)|0)>>3];c[Cd>>2]=51;h[(Fz(ag,1,Cd)|0)>>3]=eg;c[Bd>>2]=11;c[f+136>>2]=a;c[f+144>>2]=b;g[f+152>>2]=d;g[f+160>>2]=e;g[f+1512>>2]=dg;c[f+2688>>2]=ag;c[f+2720>>2]=pb;c[f+2728>>2]=ob;c[f+2736>>2]=nb;c[f+2752>>2]=mb;c[f+2760>>2]=lb;c[f+2768>>2]=kb;c[f+2776>>2]=jb;c[f+2784>>2]=ib;c[f+2792>>2]=hb;c[f+2800>>2]=gb;c[f+2808>>2]=fb;c[f+2816>>2]=eb;c[f+2824>>2]=db;c[f+2840>>2]=cb;c[f+2848>>2]=bb;c[f+2856>>2]=ab;c[f+2864>>2]=$a;c[f+2872>>2]=_a;c[f+2880>>2]=Za;c[f+2888>>2]=Ya;c[f+2896>>2]=Xa;c[f+2904>>2]=Wa;c[f+2912>>2]=Va;c[f+2928>>2]=Ua;c[f+2936>>2]=Ta;c[f+2944>>2]=Sa;c[f+2952>>2]=Ra;c[f+2960>>2]=Qa;c[f+2968>>2]=Pa;c[f+2976>>2]=Oa;c[f+2984>>2]=Na;c[f+2992>>2]=Ma;c[f+3e3>>2]=La;c[f+3016>>2]=Ka;c[f+3024>>2]=Ja;c[f+3032>>2]=Ia;c[f+3040>>2]=Ha;c[f+3048>>2]=Ga;c[f+3056>>2]=Fa;c[f+3064>>2]=Ea;c[f+3072>>2]=Da;c[f+3080>>2]=Ca;c[f+3088>>2]=Ba;c[f+3104>>2]=Aa;c[f+3112>>2]=za;c[f+3120>>2]=ya;c[f+3128>>2]=xa;c[f+3136>>2]=wa;c[f+3144>>2]=va;c[f+3152>>2]=ua;c[f+3160>>2]=ta;c[f+3168>>2]=sa;c[f+3176>>2]=ra;c[f+3192>>2]=qa;c[f+3200>>2]=pa;c[f+3208>>2]=oa;c[f+3216>>2]=na;c[f+3224>>2]=ma;c[f+3232>>2]=la;c[f+3240>>2]=ka;c[f+3248>>2]=ja;c[f+3256>>2]=ia;c[f+3264>>2]=ha;c[f+3280>>2]=ga;c[f+3288>>2]=fa;c[f+3296>>2]=ea;c[f+3304>>2]=da;c[f+3312>>2]=ca;c[f+3320>>2]=ba;c[f+3328>>2]=aa;c[f+3336>>2]=$;c[f+3344>>2]=_;c[f+3352>>2]=Z;c[f+3368>>2]=Y;c[f+3376>>2]=X;c[f+3392>>2]=W;c[f+3400>>2]=V;c[f+3408>>2]=U;c[f+3416>>2]=T;c[f+3424>>2]=S;c[f+3432>>2]=R;c[f+3440>>2]=Q;c[f+3448>>2]=P;c[f+3464>>2]=O;c[f+3472>>2]=N;c[f+3480>>2]=M;c[f+3488>>2]=L;c[f+3496>>2]=K;c[f+3504>>2]=J;c[f+3512>>2]=G;c[f+3520>>2]=F;c[f+3528>>2]=E;c[f+3536>>2]=D;c[f+3552>>2]=C;c[f+3560>>2]=B;c[f+3568>>2]=z;c[f+3576>>2]=y;c[f+3584>>2]=x;c[f+3592>>2]=w;c[f+3600>>2]=v;c[f+3608>>2]=u;c[f+3616>>2]=t;c[f+3624>>2]=s;c[f+3640>>2]=r;c[f+3648>>2]=q;c[f+3656>>2]=p;c[f+3664>>2]=o;c[f+3672>>2]=n;c[f+3680>>2]=m;c[f+3688>>2]=l;c[f+3696>>2]=k;c[f+3704>>2]=j;c[f+4544>>2]=Bd;c[f+4552>>2]=Ad;c[f+4560>>2]=zd;c[f+4576>>2]=yd;c[f+4584>>2]=xd;c[f+4592>>2]=wd;c[f+4600>>2]=vd;c[f+4608>>2]=ud;c[f+4616>>2]=td;c[f+4624>>2]=sd;c[f+4632>>2]=rd;c[f+4640>>2]=qd;c[f+4648>>2]=pd;c[f+4664>>2]=od;c[f+4672>>2]=nd;c[f+4680>>2]=md;c[f+4688>>2]=ld;c[f+4696>>2]=kd;c[f+4704>>2]=jd;c[f+4712>>2]=id;c[f+4720>>2]=hd;c[f+4728>>2]=gd;c[f+4736>>2]=fd;c[f+4752>>2]=ed;c[f+4760>>2]=dd;c[f+4768>>2]=cd;c[f+4776>>2]=bd;c[f+4784>>2]=ad;c[f+4792>>2]=$c;c[f+4800>>2]=_c;c[f+4808>>2]=Zc;c[f+4816>>2]=Yc;c[f+4824>>2]=Xc;c[f+4840>>2]=Wc;c[f+4848>>2]=Vc;c[f+4856>>2]=Uc;c[f+4864>>2]=Tc;c[f+4872>>2]=Sc;c[f+4880>>2]=Rc;c[f+4888>>2]=Qc;c[f+4896>>2]=Pc;c[f+4904>>2]=Oc;c[f+4912>>2]=Nc;c[f+4928>>2]=Mc;c[f+4936>>2]=Lc;c[f+4952>>2]=Kc;c[f+4960>>2]=Jc;c[f+4968>>2]=Ic;c[f+4976>>2]=Hc;c[f+4984>>2]=Gc;c[f+4992>>2]=Fc;c[f+5e3>>2]=Ec;c[f+5008>>2]=Dc;c[f+5024>>2]=Cc;c[f+5032>>2]=Bc;c[f+5040>>2]=Ac;c[f+5048>>2]=zc;c[f+5056>>2]=yc;c[f+5064>>2]=xc;c[f+5072>>2]=wc;c[f+5080>>2]=vc;c[f+5088>>2]=uc;c[f+5096>>2]=tc;c[f+5112>>2]=sc;c[f+5120>>2]=rc;c[f+5128>>2]=qc;c[f+5136>>2]=pc;c[f+5144>>2]=oc;c[f+5152>>2]=nc;c[f+5160>>2]=mc;c[f+5168>>2]=lc;c[f+5176>>2]=kc;c[f+5184>>2]=jc;c[f+5200>>2]=ic;c[f+5208>>2]=hc;c[f+5216>>2]=gc;c[f+5224>>2]=fc;c[f+5232>>2]=ec;c[f+5240>>2]=dc;c[f+5248>>2]=cc;c[f+5256>>2]=bc;c[f+5264>>2]=ac;c[f+5272>>2]=$b;c[f+5288>>2]=_b;c[f+5296>>2]=Zb;c[f+5304>>2]=Yb;c[f+5312>>2]=Xb;c[f+5320>>2]=Wb;c[f+5328>>2]=Vb;c[f+5336>>2]=Ub;c[f+5344>>2]=Tb;c[f+5352>>2]=Sb;c[f+5360>>2]=Rb;c[f+5376>>2]=Qb;c[f+5384>>2]=Pb;c[f+5392>>2]=Ob;c[f+5400>>2]=Nb;c[f+5408>>2]=Mb;c[f+5416>>2]=Lb;c[f+5424>>2]=Kb;c[f+5432>>2]=Jb;c[f+5440>>2]=Ib;c[f+5448>>2]=Hb;c[f+5464>>2]=Gb;c[f+5472>>2]=Fb;c[f+5480>>2]=Eb;c[f+5488>>2]=Db;c[f+5496>>2]=Cb;c[f+5504>>2]=Bb;c[f+5512>>2]=Ab;c[f+5520>>2]=zb;c[f+5528>>2]=yb;c[f+5536>>2]=xb;c[f+5552>>2]=wb;c[f+5560>>2]=vb;c[f+5568>>2]=ub;c[f+5576>>2]=tb;c[f+5584>>2]=sb;c[f+5592>>2]=rb;c[f+5600>>2]=qb;c[f+5648>>2]=0;c[f+5652>>2]=0;_omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(f);H=c[f+5648>>2]|0;A=c[f+5652>>2]|0;I=+g[f+5652>>2];c[f+5648>>2]=0;c[f+5652>>2]=0;if((H|0)==5){return}}function uh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0.0,qd=0.0,rd=0.0,sd=0.0,td=0.0,ud=0.0,vd=0.0,wd=0.0,xd=0.0,yd=0.0,zd=0.0,Ad=0.0,Bd=0.0,Cd=0.0,Dd=0.0,Ed=0.0;f=i;i=i+32|0;g=f;j=f+24|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+16|0;c[nd>>2]=40;Az(od,1,nd);pd=647.096/e;if(d==322.0&e==647.096){qd=.999999999999999}else{qd=+U(+(d/322.0))}c[md>>2]=1;h[(Fz(od,1,md)|0)>>3]=pd*pd;c[ld>>2]=1;rd=+h[(Fz(od,1,ld)|0)>>3];c[kd>>2]=2;h[(Fz(od,1,kd)|0)>>3]=rd*rd;c[jd>>2]=2;rd=pd*+h[(Fz(od,1,jd)|0)>>3];c[id>>2]=3;h[(Fz(od,1,id)|0)>>3]=rd;c[hd>>2]=1;rd=pd*+h[(Fz(od,1,hd)|0)>>3];c[gd>>2]=4;h[(Fz(od,1,gd)|0)>>3]=rd;c[fd>>2]=2;rd=+h[(Fz(od,1,fd)|0)>>3];c[ed>>2]=5;h[(Fz(od,1,ed)|0)>>3]=rd*rd;c[dd>>2]=1;rd=+h[(Fz(od,1,dd)|0)>>3];c[cd>>2]=5;sd=rd*pd*+h[(Fz(od,1,cd)|0)>>3];c[bd>>2]=6;h[(Fz(od,1,bd)|0)>>3]=sd;c[ad>>2]=5;sd=pd*+h[(Fz(od,1,ad)|0)>>3];c[$c>>2]=7;h[(Fz(od,1,$c)|0)>>3]=sd;c[_c>>2]=1;sd=+h[(Fz(od,1,_c)|0)>>3]*-.64207765181607;c[Zc>>2]=8;h[(Fz(od,1,Zc)|0)>>3]=sd;c[Yc>>2]=8;sd=+h[(Fz(od,1,Yc)|0)>>3]+.88521043984318;c[Xc>>2]=9;h[(Fz(od,1,Xc)|0)>>3]=sd;c[Wc>>2]=7;sd=+h[(Fz(od,1,Wc)|0)>>3];c[Vc>>2]=9;rd=sd*+h[(Fz(od,1,Vc)|0)>>3];c[Uc>>2]=10;h[(Fz(od,1,Uc)|0)>>3]=rd;c[Tc>>2]=10;rd=+h[(Fz(od,1,Tc)|0)>>3]+-1.1524407806681;c[Sc>>2]=11;h[(Fz(od,1,Sc)|0)>>3]=rd;c[Rc>>2]=11;rd=+h[(Fz(od,1,Rc)|0)>>3];c[Qc>>2]=2;sd=rd*+h[(Fz(od,1,Qc)|0)>>3];c[Pc>>2]=12;h[(Fz(od,1,Pc)|0)>>3]=sd;c[Oc>>2]=12;sd=+h[(Fz(od,1,Oc)|0)>>3]+-1.2654315477714;c[Nc>>2]=13;h[(Fz(od,1,Nc)|0)>>3]=sd;c[Mc>>2]=1;sd=+h[(Fz(od,1,Mc)|0)>>3];c[Lc>>2]=13;rd=sd*+h[(Fz(od,1,Lc)|0)>>3];c[Kc>>2]=14;h[(Fz(od,1,Kc)|0)>>3]=rd;c[Jc>>2]=1;rd=+h[(Fz(od,1,Jc)|0)>>3];c[Ic>>2]=2;sd=+h[(Fz(od,1,Ic)|0)>>3];c[Hc>>2]=5;td=rd*sd*pd*+h[(Fz(od,1,Hc)|0)>>3];c[Gc>>2]=15;h[(Fz(od,1,Gc)|0)>>3]=td;c[Fc>>2]=2;td=+h[(Fz(od,1,Fc)|0)>>3];c[Ec>>2]=5;sd=td*+h[(Fz(od,1,Ec)|0)>>3];c[Dc>>2]=16;h[(Fz(od,1,Dc)|0)>>3]=sd;c[Cc>>2]=1;sd=+h[(Fz(od,1,Cc)|0)>>3];c[Bc>>2]=5;td=sd*+h[(Fz(od,1,Bc)|0)>>3];c[Ac>>2]=17;h[(Fz(od,1,Ac)|0)>>3]=td;c[zc>>2]=5;td=+h[(Fz(od,1,zc)|0)>>3];c[yc>>2]=18;h[(Fz(od,1,yc)|0)>>3]=td*td;c[xc>>2]=1;td=+h[(Fz(od,1,xc)|0)>>3];c[wc>>2]=18;sd=+h[(Fz(od,1,wc)|0)>>3];c[vc>>2]=2;rd=td*sd*+h[(Fz(od,1,vc)|0)>>3];c[uc>>2]=19;h[(Fz(od,1,uc)|0)>>3]=rd;c[tc>>2]=1;rd=+h[(Fz(od,1,tc)|0)>>3];c[sc>>2]=18;sd=+h[(Fz(od,1,sc)|0)>>3];c[rc>>2]=2;td=rd*sd*pd*+h[(Fz(od,1,rc)|0)>>3];c[qc>>2]=20;h[(Fz(od,1,qc)|0)>>3]=td;c[pc>>2]=18;td=+h[(Fz(od,1,pc)|0)>>3];c[oc>>2]=5;sd=td*+h[(Fz(od,1,oc)|0)>>3];c[nc>>2]=21;h[(Fz(od,1,nc)|0)>>3]=sd;c[mc>>2]=1;sd=+h[(Fz(od,1,mc)|0)>>3];c[lc>>2]=18;td=+h[(Fz(od,1,lc)|0)>>3];c[kc>>2]=5;rd=sd*td*+h[(Fz(od,1,kc)|0)>>3];c[jc>>2]=22;h[(Fz(od,1,jc)|0)>>3]=rd;c[ic>>2]=2;rd=+h[(Fz(od,1,ic)|0)>>3]*.25116816848616;c[hc>>2]=23;h[(Fz(od,1,hc)|0)>>3]=rd;c[gc>>2]=23;rd=+h[(Fz(od,1,gc)|0)>>3]+.078841073758308;c[fc>>2]=24;h[(Fz(od,1,fc)|0)>>3]=rd;c[ec>>2]=15;rd=+h[(Fz(od,1,ec)|0)>>3];c[dc>>2]=24;td=rd*+h[(Fz(od,1,dc)|0)>>3];c[cc>>2]=25;h[(Fz(od,1,cc)|0)>>3]=td;c[bc>>2]=25;td=+h[(Fz(od,1,bc)|0)>>3]+-6.100523451393;c[ac>>2]=26;h[(Fz(od,1,ac)|0)>>3]=td;c[$b>>2]=26;td=pd*+h[(Fz(od,1,$b)|0)>>3];c[_b>>2]=27;h[(Fz(od,1,_b)|0)>>3]=td;c[Zb>>2]=27;td=+h[(Fz(od,1,Zb)|0)>>3]+9.7944563083754;c[Yb>>2]=28;h[(Fz(od,1,Yb)|0)>>3]=td;c[Xb>>2]=2;td=+h[(Fz(od,1,Xb)|0)>>3];c[Wb>>2]=28;rd=td*+h[(Fz(od,1,Wb)|0)>>3];c[Vb>>2]=29;h[(Fz(od,1,Vb)|0)>>3]=rd;c[Ub>>2]=29;rd=+h[(Fz(od,1,Ub)|0)>>3]+-1.70429417648412;c[Tb>>2]=30;h[(Fz(od,1,Tb)|0)>>3]=rd;c[Sb>>2]=1;rd=+h[(Fz(od,1,Sb)|0)>>3];c[Rb>>2]=30;td=rd*+h[(Fz(od,1,Rb)|0)>>3];c[Qb>>2]=31;h[(Fz(od,1,Qb)|0)>>3]=td;c[Pb>>2]=32;h[(Fz(od,1,Pb)|0)>>3]=qd*qd;c[Ob>>2]=1;td=+h[(Fz(od,1,Ob)|0)>>3]*-10.9153200808732;c[Nb>>2]=33;h[(Fz(od,1,Nb)|0)>>3]=td;c[Mb>>2]=33;td=+h[(Fz(od,1,Mb)|0)>>3]+13.2781565976477;c[Lb>>2]=34;h[(Fz(od,1,Lb)|0)>>3]=td;c[Kb>>2]=34;td=+h[(Fz(od,1,Kb)|0)>>3];c[Jb>>2]=7;rd=td*+h[(Fz(od,1,Jb)|0)>>3];c[Ib>>2]=35;h[(Fz(od,1,Ib)|0)>>3]=rd;c[Hb>>2]=35;rd=+h[(Fz(od,1,Hb)|0)>>3]+-6.9146446840086;c[Gb>>2]=36;h[(Fz(od,1,Gb)|0)>>3]=rd;c[Fb>>2]=2;rd=+h[(Fz(od,1,Fb)|0)>>3];c[Eb>>2]=36;td=rd*+h[(Fz(od,1,Eb)|0)>>3];c[Db>>2]=37;h[(Fz(od,1,Db)|0)>>3]=td;c[Cb>>2]=37;td=+h[(Fz(od,1,Cb)|0)>>3]+-2.5308630955428;c[Bb>>2]=38;h[(Fz(od,1,Bb)|0)>>3]=td;c[Ab>>2]=38;td=pd*+h[(Fz(od,1,Ab)|0)>>3];c[zb>>2]=39;h[(Fz(od,1,zb)|0)>>3]=td;c[yb>>2]=18;td=+h[(Fz(od,1,yb)|0)>>3];c[xb>>2]=5;rd=td*pd*+h[(Fz(od,1,xb)|0)>>3];c[wb>>2]=40;h[(Fz(od,1,wb)|0)>>3]=rd;if(!(qd>0.0)){wb=c[28994]|0;xb=vb;h[k>>3]=qd;c[xb>>2]=c[k>>2];c[xb+4>>2]=c[k+4>>2];xb=wb;wb=g;yb=8800;c[wb+0>>2]=c[yb+0>>2];c[wb+4>>2]=c[yb+4>>2];c[wb+8>>2]=c[yb+8>>2];c[wb+12>>2]=c[yb+12>>2];c[wb+16>>2]=c[yb+16>>2];c[wb+20>>2]=c[yb+20>>2];De[xb&31](b,g,8016,vb);}c[ub>>2]=3;rd=+h[(Fz(od,1,ub)|0)>>3];c[tb>>2]=4;td=+h[(Fz(od,1,tb)|0)>>3];c[sb>>2]=1;sd=+h[(Fz(od,1,sb)|0)>>3];c[rb>>2]=6;ud=pd*(pd*(rd*(td*(sd*(+h[(Fz(od,1,rb)|0)>>3]*-.0084566812812502+1.2053369696517)+-2.808078114862)+2.6185947787954)+-7.6867707878716)+20.944396974307);c[qb>>2]=14;sd=+h[(Fz(od,1,qb)|0)>>3];c[pb>>2]=1;td=+h[(Fz(od,1,pb)|0)>>3];c[ob>>2]=2;rd=+h[(Fz(od,1,ob)|0)>>3];c[nb>>2]=15;vd=+h[(Fz(od,1,nb)|0)>>3];c[mb>>2]=2;wd=td*(rd*(pd*(vd*(+h[(Fz(od,1,mb)|0)>>3]*.12558408424308+.039420536879154)+-3.0502617256965)+4.8972281541877)+-.85214708824206);c[lb>>2]=1;vd=+h[(Fz(od,1,lb)|0)>>3];c[kb>>2]=1;rd=+h[(Fz(od,1,kb)|0)>>3];c[jb>>2]=16;td=+h[(Fz(od,1,jb)|0)>>3];c[ib>>2]=17;xd=vd*(rd*(td*(+h[(Fz(od,1,ib)|0)>>3]*-.47596035734923+-.0082147637173963)+-2.018991502357)+1.389979956946);c[hb>>2]=1;td=+h[(Fz(od,1,hb)|0)>>3];c[gb>>2]=1;rd=+h[(Fz(od,1,gb)|0)>>3];c[fb>>2]=19;vd=td*(rd*(+h[(Fz(od,1,fb)|0)>>3]*.70522450087967+.90572070719733)+-.44476435428739);c[eb>>2]=1;rd=+h[(Fz(od,1,eb)|0)>>3];c[db>>2]=21;td=rd*(+h[(Fz(od,1,db)|0)>>3]*.16436278447961+.094260751665092);c[cb>>2]=1;rd=+h[(Fz(od,1,cb)|0)>>3]*-.013503372241348;c[bb>>2]=22;yd=+h[(Fz(od,1,bb)|0)>>3]*-.014834345352472;c[ab>>2]=1;zd=+h[(Fz(od,1,ab)|0)>>3];c[$a>>2]=21;Ad=zd*(+h[(Fz(od,1,$a)|0)>>3]*.0032308904703711+.00057922953628084);c[_a>>2]=22;zd=qd*(td+qd*(rd+qd*(yd+qd*(Ad+qd*(pd*-.00016557679795037+qd*+h[(Fz(od,1,_a)|0)>>3]*-44923899061815.0e-18+80964802996215.0e-18))))+-.022175400873096);c[Za>>2]=1;Ad=+h[(Fz(od,1,Za)|0)>>3];c[Ya>>2]=20;yd=ud+(+da(+qd)*1.0658070028513+qd*(sd+qd*(wd+qd*(xd+qd*(vd+qd*(pd*(Ad*(+h[(Fz(od,1,Ya)|0)>>3]*-.50871062041158+-.32913623258954)+.10770512626332)+zd)+.0439840744735)+-.2799932969871)+.38493460186671)))+-15.732845290239;c[Xa>>2]=14;zd=+h[(Fz(od,1,Xa)|0)>>3];c[Wa>>2]=31;Ad=+h[(Fz(od,1,Wa)|0)>>3];c[Va>>2]=1;vd=+h[(Fz(od,1,Va)|0)>>3];c[Ua>>2]=1;xd=+h[(Fz(od,1,Ua)|0)>>3];c[Ta>>2]=16;wd=+h[(Fz(od,1,Ta)|0)>>3];c[Sa>>2]=17;sd=vd*(xd*(wd*(+h[(Fz(od,1,Sa)|0)>>3]*-1.42788107204769+-.0246442911521889)+-6.056974507071)+4.169939870838);c[Ra>>2]=1;wd=+h[(Fz(od,1,Ra)|0)>>3];c[Qa>>2]=1;xd=+h[(Fz(od,1,Qa)|0)>>3];c[Pa>>2]=19;vd=wd*(xd*(+h[(Fz(od,1,Pa)|0)>>3]*2.82089800351868+3.6228828287893)+-1.77905741714956);c[Oa>>2]=1;xd=+h[(Fz(od,1,Oa)|0)>>3];c[Na>>2]=21;wd=xd*(+h[(Fz(od,1,Na)|0)>>3]*.98617670687766+.56556450999055);c[Ma>>2]=1;xd=+h[(Fz(od,1,Ma)|0)>>3]*-.094523605689436;c[La>>2]=22;ud=+h[(Fz(od,1,La)|0)>>3]*-.118674762819776;c[Ka>>2]=1;rd=+h[(Fz(od,1,Ka)|0)>>3];c[Ja>>2]=21;td=rd*(+h[(Fz(od,1,Ja)|0)>>3]*.0290780142333399+.0052130658265276);c[Ia>>2]=22;rd=qd*(wd+qd*(xd+qd*(ud+qd*(td+qd*(pd*-.0016557679795037+qd*+h[(Fz(od,1,Ia)|0)>>3]*-.00049416288967996+.00080964802996215))))+-.133052405238576);c[Ha>>2]=1;td=+h[(Fz(od,1,Ha)|0)>>3];c[Ga>>2]=20;ud=(qd*(zd+qd*(Ad+qd*(sd+qd*(vd+qd*(pd*(td*(+h[(Fz(od,1,Ga)|0)>>3]*-2.5435531020579+-1.6456811629477)+.5385256313166)+rd)+.175936297894)+-.8399798909613)+.76986920373342))+1.0658070028513)/qd;c[Fa>>2]=32;rd=+h[(Fz(od,1,Fa)|0)>>3];c[Ea>>2]=31;td=+h[(Fz(od,1,Ea)|0)>>3];c[Da>>2]=1;vd=+h[(Fz(od,1,Da)|0)>>3];c[Ca>>2]=1;sd=+h[(Fz(od,1,Ca)|0)>>3];c[Ba>>2]=16;Ad=+h[(Fz(od,1,Ba)|0)>>3];c[Aa>>2]=17;zd=vd*(sd*(Ad*(+h[(Fz(od,1,Aa)|0)>>3]*-2.85576214409538+-.049288582304378)+-12.113949014142)+8.339879741676);c[za>>2]=1;Ad=+h[(Fz(od,1,za)|0)>>3];c[ya>>2]=1;sd=+h[(Fz(od,1,ya)|0)>>3];c[xa>>2]=19;vd=Ad*(sd*(+h[(Fz(od,1,xa)|0)>>3]*8.462694010556+10.868648486368)+-5.3371722514487);c[wa>>2]=1;sd=+h[(Fz(od,1,wa)|0)>>3];c[va>>2]=21;Ad=sd*(+h[(Fz(od,1,va)|0)>>3]*4.9308835343883+2.82782254995276);c[ua>>2]=1;sd=+h[(Fz(od,1,ua)|0)>>3]*-.56714163413662;c[ta>>2]=22;xd=+h[(Fz(od,1,ta)|0)>>3]*-.83072333973843;c[sa>>2]=1;wd=+h[(Fz(od,1,sa)|0)>>3];c[ra>>2]=21;Bd=wd*(+h[(Fz(od,1,ra)|0)>>3]*.232624113866719+.04170452661222);c[qa>>2]=22;wd=qd*(Ad+qd*(sd+qd*(xd+qd*(Bd+qd*(pd*-.0149019118155333+qd*+h[(Fz(od,1,qa)|0)>>3]*-.0049416288967996+.0072868322696594))))+-.66526202619288);c[pa>>2]=1;Bd=+h[(Fz(od,1,pa)|0)>>3];c[oa>>2]=20;xd=rd*(td+qd*(zd+qd*(vd+qd*(pd*(Bd*(+h[(Fz(od,1,oa)|0)>>3]*-10.1742124082316+-6.5827246517908)+2.1541025252664)+wd)+.527808893682)+-1.6799597819226)+.76986920373342)+-1.0658070028513;c[na>>2]=32;wd=xd/+h[(Fz(od,1,na)|0)>>3];c[ma>>2]=3;xd=+h[(Fz(od,1,ma)|0)>>3];c[la>>2]=4;Bd=+h[(Fz(od,1,la)|0)>>3];c[ka>>2]=1;vd=+h[(Fz(od,1,ka)|0)>>3];c[ja>>2]=6;zd=pd*(xd*(Bd*(vd*(+h[(Fz(od,1,ja)|0)>>3]*-.194503669468755+14.4640436358204)+-28.08078114862)+18.3301634515678)+-15.3735415757432);c[ia>>2]=39;vd=+h[(Fz(od,1,ia)|0)>>3];c[ha>>2]=2;Bd=+h[(Fz(od,1,ha)|0)>>3];c[ga>>2]=15;xd=+h[(Fz(od,1,ga)|0)>>3];c[fa>>2]=2;td=pd*(Bd*(pd*(xd*(+h[(Fz(od,1,fa)|0)>>3]*3.2651861903201+.86725181134139)+-21.3518320798755)+29.3833689251262)+-1.70429417648412);c[ea>>2]=1;xd=+h[(Fz(od,1,ea)|0)>>3];c[ca>>2]=16;Bd=+h[(Fz(od,1,ca)|0)>>3];c[ba>>2]=17;rd=pd*(xd*(Bd*(+h[(Fz(od,1,ba)|0)>>3]*-12.37496929108+-.131436219478341)+-8.075966009428)+2.779959913892);c[aa>>2]=1;Bd=+h[(Fz(od,1,aa)|0)>>3];c[$>>2]=19;xd=pd*(Bd*(+h[(Fz(od,1,$)|0)>>3]*18.3358370228714+3.6228828287893)+-.88952870857478);c[_>>2]=1;Bd=+h[(Fz(od,1,_)|0)>>3];c[Z>>2]=20;sd=Bd*(+h[(Fz(od,1,Z)|0)>>3]*-13.2264761307011+-.98740869776862);c[Y>>2]=21;Bd=pd*(+h[(Fz(od,1,Y)|0)>>3]*4.2734323964699+.188521503330184);c[X>>2]=40;Ad=+h[(Fz(od,1,X)|0)>>3]*-.38569297916427;c[W>>2]=40;Cd=qd*(qd*+h[(Fz(od,1,W)|0)>>3]*-.00116802137560719+-.00016557679795037);c[V>>2]=21;Dd=zd+qd*(vd+qd*(td+qd*(rd+qd*(xd+qd*(sd+qd*(Bd+qd*(pd*-.027006744482696+qd*(Ad+qd*(Cd+pd*(+h[(Fz(od,1,V)|0)>>3]*.084003152229649+.00115845907256168)))))+.10770512626332)))))+20.944396974307;c[T>>2]=3;Cd=+h[(Fz(od,1,T)|0)>>3];c[S>>2]=4;Ad=+h[(Fz(od,1,S)|0)>>3];c[R>>2]=1;Bd=+h[(Fz(od,1,R)|0)>>3];c[Q>>2]=6;sd=Cd*(Ad*(Bd*(+h[(Fz(od,1,Q)|0)>>3]*-4.2790807283126+159.104479994024)+-252.72703033758)+109.980980709407);c[P>>2]=2;Bd=+h[(Fz(od,1,P)|0)>>3];c[O>>2]=1;Ad=+h[(Fz(od,1,O)|0)>>3]*-174.645121293971+185.894192367068;c[N>>2]=7;Cd=Bd*(Ad*+h[(Fz(od,1,N)|0)>>3]+-34.573223420043);c[M>>2]=2;Ad=+h[(Fz(od,1,M)|0)>>3];c[L>>2]=15;Bd=+h[(Fz(od,1,L)|0)>>3];c[K>>2]=2;xd=Ad*(pd*(Bd*(+h[(Fz(od,1,K)|0)>>3]*81.629654758002+18.2122880381691)+-128.110992479253)+146.916844625631);c[J>>2]=1;Bd=+h[(Fz(od,1,J)|0)>>3];c[I>>2]=16;Ad=+h[(Fz(od,1,I)|0)>>3];c[H>>2]=17;rd=Bd*(Ad*(+h[(Fz(od,1,H)|0)>>3]*-309.374232277+-1.97154329217511)+-24.227898028284);c[G>>2]=1;Ad=+h[(Fz(od,1,G)|0)>>3];c[F>>2]=19;Bd=Ad*(+h[(Fz(od,1,F)|0)>>3]*458.39592557179+10.868648486368);c[E>>2]=21;Ad=+h[(Fz(od,1,E)|0)>>3]*106.835809911747;c[D>>2]=21;td=+h[(Fz(od,1,D)|0)>>3]*-9.6423244791068;c[C>>2]=21;vd=+h[(Fz(od,1,C)|0)>>3]*2.10007880574121;c[B>>2]=21;zd=+h[(Fz(od,1,B)|0)>>3];c[A>>2]=32;Ed=qd*(Ad+qd*(qd*(td+qd*(vd+zd*+h[(Fz(od,1,A)|0)>>3]*-.0292005343901797+.00115845907256168))+-.027006744482696)+.188521503330184);c[z>>2]=20;zd=sd+qd*(Cd+qd*(xd+qd*(rd+qd*(Bd+qd*(pd*(+h[(Fz(od,1,z)|0)>>3]*-330.66190326753+-1.97481739553724)+Ed)+-.88952870857478)+2.779959913892)+-1.70429417648412)+-2.5308630955428)+-15.3735415757432;c[y>>2]=39;Ed=+h[(Fz(od,1,y)|0)>>3];c[x>>2]=2;Bd=+h[(Fz(od,1,x)|0)>>3];c[w>>2]=15;rd=+h[(Fz(od,1,w)|0)>>3];c[v>>2]=2;xd=pd*(Bd*(pd*(rd*(+h[(Fz(od,1,v)|0)>>3]*6.5303723806402+1.73450362268278)+-42.703664159751)+58.766737850252)+-3.4085883529682);c[u>>2]=1;rd=+h[(Fz(od,1,u)|0)>>3];c[t>>2]=16;Bd=+h[(Fz(od,1,t)|0)>>3];c[s>>2]=17;Cd=pd*(rd*(Bd*(+h[(Fz(od,1,s)|0)>>3]*-37.12490787324+-.39430865843502)+-24.227898028284)+8.339879741676);c[r>>2]=1;Bd=+h[(Fz(od,1,r)|0)>>3];c[q>>2]=19;rd=pd*(Bd*(+h[(Fz(od,1,q)|0)>>3]*73.343348091486+14.4915313151573)+-3.5581148342991);c[p>>2]=1;Bd=+h[(Fz(od,1,p)|0)>>3];c[o>>2]=20;sd=Bd*(+h[(Fz(od,1,o)|0)>>3]*-66.132380653505+-4.9370434888431);c[n>>2]=21;Bd=pd*(+h[(Fz(od,1,n)|0)>>3]*25.6405943788192+1.1311290199811);c[m>>2]=40;vd=+h[(Fz(od,1,m)|0)>>3]*-3.08554383331418;c[l>>2]=40;td=qd*(qd*+h[(Fz(od,1,l)|0)>>3]*-.0128482351316791+-.0016557679795037);c[j>>2]=21;Ad=Ed+qd*(xd+qd*(Cd+qd*(rd+qd*(sd+qd*(Bd+qd*(pd*-.189047211378872+qd*(vd+qd*(td+pd*(+h[(Fz(od,1,j)|0)>>3]*.75602837006684+.0104261316530551)))))+.5385256313166))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=qd;h[a+32>>3]=pd;h[a+40>>3]=yd;h[a+48>>3]=ud;h[a+56>>3]=wd;h[a+64>>3]=Dd;h[a+72>>3]=zd;h[a+80>>3]=Ad;i=f;return}function vh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=33;Az(k,1,j);j=k;k=8080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=33;Az(l,1,g);g=l;l=8096;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=33;Az(m,1,f);f=m;m=8112;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/28.0e5+-.72;e=n*n;o=d/1.0e8+.298;d=o*o;p=32325457364492.0e-18/+iA(o,12);q=n*+iA(o,-12)*-.000127575556587181;r=-.000475851877356068/+iA(o,10);s=n*+iA(o,-10)*.00156183014181602;t=+iA(o,-10);u=t*+iA(n,5)*.105724860113781;t=+iA(o,-10);v=t*+iA(n,10)*-85.8514221132534;t=+iA(o,-10);w=t*+iA(n,12)*724.140095480911;t=.00296475810273257/+iA(o,8);x=n*+iA(o,-8)*-.00592721983365988;y=e*+iA(o,-8)*-.0126305422818666;z=e*e;A=z*+iA(o,-8)*-.115716196364853;B=+iA(o,-8);C=B*+iA(n,10)*84.9000969739595;B=-.0108602260086615/+iA(o,6);D=n*+iA(o,-6)*.0154304475328851;E=e*+iA(o,-6)*.0750455441524466;F=n*+iA(o,-4)*-.0602507901232996;G=+iA(o,-3);H=G*+iA(n,5)*-3.07622221350501;G=z*+iA(o,-2)*5.03471360939849;I=+iA(n,6)/o*-77.314600713019;J=+iA(n,10)/o*9493.08762098587;K=+iA(n,14)/o*-1410437.19679409;L=+iA(n,16)/o*8491662.30819026;M=n*+iA(o,5)*.286596714529479;N=n*+iA(o,6)*-.131778331276228;h[a>>3]=(p+(q+(r+(s+(u+(v+(w+(t+(x+(y+(A+(C+(B+(D+(E+(.0252520973612982/(d*d)+(F+(H+(-.0574011959864879/d+(G+(e/o*-.925081888584834+(z/o*3.91733882917546+(I+(J+(K+(L+(e*.32334644281172+(o*n*.873281936020439+(n*o*d*-.436653048526683+(M+(N+n*+iA(o,8)*.00676682064330275))))))))))))))))))))))))))))))+.861095729446704)*860.0;i=b;return}function wh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=31;Az(k,1,j);j=k;k=8128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=31;Az(l,1,g);g=l;l=8144;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=31;Az(m,1,f);f=m;m=8160;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/23.0e5+-.615;e=n*n;o=d/1.0e8+.24;d=o*o;p=-1.33645667811215e-7/+iA(o,12);q=n*+iA(o,-12)*455912656802978.0e-20;r=e*+iA(o,-12)*-146294640700979.0e-19;s=+iA(o,-12);t=s*+iA(n,6)*.0063934131297008;s=+iA(o,-12);u=s*+iA(n,14)*372.783927268847;s=+iA(o,-12);v=s*+iA(n,16)*-7186.54377460447;s=+iA(o,-12);w=s*+iA(n,20)*573494.7521034;s=+iA(o,-12);x=s*+iA(n,22)*-2675693.29111439;s=n*+iA(o,-10)*-334066283302614.0e-19;y=+iA(o,-10);z=y*+iA(n,5)*-.0245479214069597;y=+iA(o,-10);A=y*+iA(n,12)*47.8087847764996;y=764664131818904.0e-20/+iA(o,8);B=e*+iA(o,-8)*.00128350627676972;C=e*e;D=C*+iA(o,-8)*.0171219081377331;E=+iA(o,-8);F=E*+iA(n,10)*-8.51007304583213;E=e*+iA(o,-5)*-.0136513461629781;G=o*d;H=n*+iA(o,-2)*.00337423807911655;I=n*e;J=I*+iA(o,-2)*-.551624873066791;K=C*+iA(o,-2)*.72920227710747;L=d*d;d=C*+iA(o,10)*.0136176427574291;C=+iA(o,12);h[a>>3]=(p+(q+(r+(t+(u+(v+(w+(x+(s+(z+(A+(y+(B+(D+(F+(E+(-384460997596657.0e-20/G+(H+(J+(K+(-.00992522757376041/o+(e/o*-.119308831407288+(n*.454270731799386+(o*n*.20999859125991+(G*-.00642109823904738+(n*G*-.023515586860454+(L*.00252233108341612+(L*I*-.00764885133368119+(d+C*+iA(n,5)*-.0133027883575669))))))))))))))))))))))))))))+.793929190615421)*760.0;i=b;return}function xh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;c[Wa>>2]=31;Az(Xa,1,Wa);Ya=+od(+d,647.096);c[Va>>2]=1;h[(Fz(Xa,1,Va)|0)>>3]=Ya+-650.17534844798;c[Ua>>2]=1;d=1.0/+h[(Fz(Xa,1,Ua)|0)>>3];c[Ta>>2]=2;h[(Fz(Xa,1,Ta)|0)>>3]=d;c[Sa>>2]=2;d=+h[(Fz(Xa,1,Sa)|0)>>3]*-.23855557567849;c[Ra>>2]=3;h[(Fz(Xa,1,Ra)|0)>>3]=d;c[Qa>>2]=3;d=Ya+ +h[(Fz(Xa,1,Qa)|0)>>3];c[Pa>>2]=4;h[(Fz(Xa,1,Pa)|0)>>3]=d;c[Oa>>2]=4;d=+h[(Fz(Xa,1,Oa)|0)>>3]*-4823.2657361591;c[Na>>2]=5;h[(Fz(Xa,1,Na)|0)>>3]=d;c[Ma>>2]=4;d=+h[(Fz(Xa,1,Ma)|0)>>3];c[La>>2]=6;h[(Fz(Xa,1,La)|0)>>3]=d*d;c[Ka>>2]=6;d=+h[(Fz(Xa,1,Ka)|0)>>3]*14.91510861353;c[Ja>>2]=7;h[(Fz(Xa,1,Ja)|0)>>3]=d;c[Ia>>2]=5;d=+h[(Fz(Xa,1,Ia)|0)>>3];c[Ha>>2]=7;Ya=d+ +h[(Fz(Xa,1,Ha)|0)>>3]+405113.40542057;c[Ga>>2]=8;h[(Fz(Xa,1,Ga)|0)>>3]=Ya;c[Fa>>2]=8;Ya=+h[(Fz(Xa,1,Fa)|0)>>3];c[Ea>>2]=9;h[(Fz(Xa,1,Ea)|0)>>3]=Ya*Ya;c[Da>>2]=9;Ya=+h[(Fz(Xa,1,Da)|0)>>3];c[Ca>>2]=10;h[(Fz(Xa,1,Ca)|0)>>3]=Ya*Ya;c[Ba>>2]=1;Ya=+h[(Fz(Xa,1,Ba)|0)>>3];c[Aa>>2]=11;h[(Fz(Xa,1,Aa)|0)>>3]=Ya*Ya;c[za>>2]=11;Ya=1.0/+h[(Fz(Xa,1,za)|0)>>3];c[ya>>2]=12;h[(Fz(Xa,1,ya)|0)>>3]=Ya;c[xa>>2]=12;Ya=+h[(Fz(Xa,1,xa)|0)>>3]*.23855557567849;c[wa>>2]=13;h[(Fz(Xa,1,wa)|0)>>3]=Ya;c[va>>2]=13;Ya=+h[(Fz(Xa,1,va)|0)>>3]+1.0;c[ua>>2]=14;h[(Fz(Xa,1,ua)|0)>>3]=Ya;c[ta>>2]=4;Ya=+h[(Fz(Xa,1,ta)|0)>>3]*12020.82470247;c[sa>>2]=15;h[(Fz(Xa,1,sa)|0)>>3]=Ya;c[ra>>2]=6;Ya=+h[(Fz(Xa,1,ra)|0)>>3]*-17.073846940092;c[qa>>2]=16;h[(Fz(Xa,1,qa)|0)>>3]=Ya;c[pa>>2]=15;Ya=+h[(Fz(Xa,1,pa)|0)>>3];c[oa>>2]=16;d=Ya+ +h[(Fz(Xa,1,oa)|0)>>3]+-3232555.0322333;c[na>>2]=17;h[(Fz(Xa,1,na)|0)>>3]=d;c[ma>>2]=14;d=+h[(Fz(Xa,1,ma)|0)>>3]*-4823.2657361591;c[la>>2]=18;h[(Fz(Xa,1,la)|0)>>3]=d;c[ka>>2]=14;d=+h[(Fz(Xa,1,ka)|0)>>3];c[ja>>2]=4;Ya=d*+h[(Fz(Xa,1,ja)|0)>>3]*29.83021722706;c[ia>>2]=19;h[(Fz(Xa,1,ia)|0)>>3]=Ya;c[ha>>2]=18;Ya=+h[(Fz(Xa,1,ha)|0)>>3];c[ga>>2]=19;d=Ya+ +h[(Fz(Xa,1,ga)|0)>>3];c[fa>>2]=20;h[(Fz(Xa,1,fa)|0)>>3]=d;c[ea>>2]=4;d=+h[(Fz(Xa,1,ea)|0)>>3]*1167.0521452767;c[da>>2]=21;h[(Fz(Xa,1,da)|0)>>3]=d;c[ca>>2]=21;d=+h[(Fz(Xa,1,ca)|0)>>3];c[ba>>2]=6;Ya=d+ +h[(Fz(Xa,1,ba)|0)>>3]+-724213.16703206;c[aa>>2]=22;h[(Fz(Xa,1,aa)|0)>>3]=Ya;c[$>>2]=17;Ya=+h[(Fz(Xa,1,$)|0)>>3];c[_>>2]=23;h[(Fz(Xa,1,_)|0)>>3]=Ya*Ya;c[Z>>2]=22;Ya=+h[(Fz(Xa,1,Z)|0)>>3];c[Y>>2]=8;d=Ya*+h[(Fz(Xa,1,Y)|0)>>3]*-4.0;c[X>>2]=24;h[(Fz(Xa,1,X)|0)>>3]=d;c[W>>2]=23;d=+h[(Fz(Xa,1,W)|0)>>3];c[U>>2]=24;Ya=d+ +h[(Fz(Xa,1,U)|0)>>3];c[T>>2]=25;h[(Fz(Xa,1,T)|0)>>3]=Ya;c[S>>2]=25;Ya=+h[(Fz(Xa,1,S)|0)>>3];if(!(Ya>=0.0)){S=c[28994]|0;T=R;h[k>>3]=Ya;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];T=S;S=f;U=8800;c[S+0>>2]=c[U+0>>2];c[S+4>>2]=c[U+4>>2];c[S+8>>2]=c[U+8>>2];c[S+12>>2]=c[U+12>>2];c[S+16>>2]=c[U+16>>2];c[S+20>>2]=c[U+20>>2];De[T&31](b,f,8176,R);}d=+V(+Ya);c[Q>>2]=26;h[(Fz(Xa,1,Q)|0)>>3]=d;c[P>>2]=4;d=+h[(Fz(Xa,1,P)|0)>>3]*-12020.82470247;c[O>>2]=27;h[(Fz(Xa,1,O)|0)>>3]=d;c[N>>2]=6;d=+h[(Fz(Xa,1,N)|0)>>3]*17.073846940092;c[M>>2]=28;h[(Fz(Xa,1,M)|0)>>3]=d;c[L>>2]=26;d=+h[(Fz(Xa,1,L)|0)>>3];c[K>>2]=27;Ya=+h[(Fz(Xa,1,K)|0)>>3];c[J>>2]=28;Za=d+(Ya+ +h[(Fz(Xa,1,J)|0)>>3])+3232555.0322333;c[I>>2]=29;h[(Fz(Xa,1,I)|0)>>3]=Za;c[H>>2]=29;Za=+h[(Fz(Xa,1,H)|0)>>3];c[G>>2]=30;h[(Fz(Xa,1,G)|0)>>3]=Za*Za;c[F>>2]=30;Za=+h[(Fz(Xa,1,F)|0)>>3];c[E>>2]=31;h[(Fz(Xa,1,E)|0)>>3]=Za*Za;c[D>>2]=10;Za=+h[(Fz(Xa,1,D)|0)>>3];c[C>>2]=14;Ya=+h[(Fz(Xa,1,C)|0)>>3]*-12020.82470247;c[B>>2]=14;d=+h[(Fz(Xa,1,B)|0)>>3];c[A>>2]=4;_a=d*+h[(Fz(Xa,1,A)|0)>>3]*34.147693880184;c[z>>2]=20;d=+h[(Fz(Xa,1,z)|0)>>3];c[y>>2]=22;$a=d*+h[(Fz(Xa,1,y)|0)>>3]*-4.0;c[x>>2]=17;d=+h[(Fz(Xa,1,x)|0)>>3];c[w>>2]=14;ab=+h[(Fz(Xa,1,w)|0)>>3]*12020.82470247;c[v>>2]=14;bb=+h[(Fz(Xa,1,v)|0)>>3];c[u>>2]=4;cb=d*(ab+bb*+h[(Fz(Xa,1,u)|0)>>3]*-34.147693880184)*2.0;c[t>>2]=14;bb=+h[(Fz(Xa,1,t)|0)>>3]*1167.0521452767;c[s>>2]=14;ab=+h[(Fz(Xa,1,s)|0)>>3];c[r>>2]=4;d=bb+ab*+h[(Fz(Xa,1,r)|0)>>3]*2.0;c[q>>2]=8;ab=$a+(cb+ +h[(Fz(Xa,1,q)|0)>>3]*d*-4.0);c[p>>2]=26;d=Ya+(_a+ab/+h[(Fz(Xa,1,p)|0)>>3]*.5);c[o>>2]=31;ab=+h[(Fz(Xa,1,o)|0)>>3];c[n>>2]=29;_a=Za*(d/(ab*+h[(Fz(Xa,1,n)|0)>>3]))*-64.0;c[m>>2]=20;ab=+h[(Fz(Xa,1,m)|0)>>3];c[l>>2]=8;d=+h[(Fz(Xa,1,l)|0)>>3];c[j>>2]=9;Za=+h[(Fz(Xa,1,j)|0)>>3];c[g>>2]=31;h[a>>3]=(_a+ab*d*(Za/+h[(Fz(Xa,1,g)|0)>>3])*64.0)*1.0e6;i=e;return}function _omc_Modelica_Media_Water_IF97__Utilities_BaseIF97_Basic_g2$0(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0.0,Ed=0.0,Fd=0.0,Gd=0,Hd=0.0,Id=0.0,Jd=0.0,Kd=0.0,Ld=0.0,Md=0.0,Nd=0.0,Od=0.0,Pd=0.0,Qd=0.0,Rd=0.0,Sd=0.0,Td=0.0,Ud=0.0,Vd=0.0,Wd=0.0,Xd=0.0,Yd=0.0,Zd=0.0,_d=0.0,$d=0.0,ae=0.0,be=0.0;b=c[a+136>>2]|0;d=c[a+144>>2]|0;e=+g[a+152>>2];f=+g[a+160>>2];j=+g[a+1512>>2];l=c[a+2688>>2]|0;m=c[a+2720>>2]|0;n=c[a+2728>>2]|0;o=c[a+2736>>2]|0;p=c[a+2752>>2]|0;q=c[a+2760>>2]|0;r=c[a+2768>>2]|0;s=c[a+2776>>2]|0;t=c[a+2784>>2]|0;u=c[a+2792>>2]|0;v=c[a+2800>>2]|0;w=c[a+2808>>2]|0;x=c[a+2816>>2]|0;y=c[a+2824>>2]|0;z=c[a+2840>>2]|0;A=c[a+2848>>2]|0;B=c[a+2856>>2]|0;C=c[a+2864>>2]|0;D=c[a+2872>>2]|0;E=c[a+2880>>2]|0;F=c[a+2888>>2]|0;G=c[a+2896>>2]|0;H=c[a+2904>>2]|0;I=c[a+2912>>2]|0;J=c[a+2928>>2]|0;K=c[a+2936>>2]|0;L=c[a+2944>>2]|0;M=c[a+2952>>2]|0;N=c[a+2960>>2]|0;O=c[a+2968>>2]|0;P=c[a+2976>>2]|0;Q=c[a+2984>>2]|0;R=c[a+2992>>2]|0;S=c[a+3e3>>2]|0;T=c[a+3016>>2]|0;U=c[a+3024>>2]|0;V=c[a+3032>>2]|0;W=c[a+3040>>2]|0;X=c[a+3048>>2]|0;Y=c[a+3056>>2]|0;Z=c[a+3064>>2]|0;_=c[a+3072>>2]|0;$=c[a+3080>>2]|0;aa=c[a+3088>>2]|0;ba=c[a+3104>>2]|0;ca=c[a+3112>>2]|0;ea=c[a+3120>>2]|0;fa=c[a+3128>>2]|0;ga=c[a+3136>>2]|0;ha=c[a+3144>>2]|0;ia=c[a+3152>>2]|0;ja=c[a+3160>>2]|0;ka=c[a+3168>>2]|0;la=c[a+3176>>2]|0;ma=c[a+3192>>2]|0;na=c[a+3200>>2]|0;oa=c[a+3208>>2]|0;pa=c[a+3216>>2]|0;qa=c[a+3224>>2]|0;ra=c[a+3232>>2]|0;sa=c[a+3240>>2]|0;ta=c[a+3248>>2]|0;ua=c[a+3256>>2]|0;va=c[a+3264>>2]|0;wa=c[a+3280>>2]|0;xa=c[a+3288>>2]|0;ya=c[a+3296>>2]|0;za=c[a+3304>>2]|0;Aa=c[a+3312>>2]|0;Ba=c[a+3320>>2]|0;Ca=c[a+3328>>2]|0;Da=c[a+3336>>2]|0;Ea=c[a+3344>>2]|0;Fa=c[a+3352>>2]|0;Ga=c[a+3368>>2]|0;Ha=c[a+3376>>2]|0;Ia=c[a+3392>>2]|0;Ja=c[a+3400>>2]|0;Ka=c[a+3408>>2]|0;La=c[a+3416>>2]|0;Ma=c[a+3424>>2]|0;Na=c[a+3432>>2]|0;Oa=c[a+3440>>2]|0;Pa=c[a+3448>>2]|0;Qa=c[a+3464>>2]|0;Ra=c[a+3472>>2]|0;Sa=c[a+3480>>2]|0;Ta=c[a+3488>>2]|0;Ua=c[a+3496>>2]|0;Va=c[a+3504>>2]|0;Wa=c[a+3512>>2]|0;Xa=c[a+3520>>2]|0;Ya=c[a+3528>>2]|0;Za=c[a+3536>>2]|0;_a=c[a+3552>>2]|0;$a=c[a+3560>>2]|0;ab=c[a+3568>>2]|0;bb=c[a+3576>>2]|0;cb=c[a+3584>>2]|0;db=c[a+3592>>2]|0;eb=c[a+3600>>2]|0;fb=c[a+3608>>2]|0;gb=c[a+3616>>2]|0;hb=c[a+3624>>2]|0;ib=c[a+3640>>2]|0;jb=c[a+3648>>2]|0;kb=c[a+3656>>2]|0;lb=c[a+3664>>2]|0;mb=c[a+3672>>2]|0;nb=c[a+3680>>2]|0;ob=c[a+3688>>2]|0;pb=c[a+3696>>2]|0;qb=c[a+3704>>2]|0;rb=c[a+4544>>2]|0;sb=c[a+4552>>2]|0;tb=c[a+4560>>2]|0;ub=c[a+4576>>2]|0;vb=c[a+4584>>2]|0;wb=c[a+4592>>2]|0;xb=c[a+4600>>2]|0;yb=c[a+4608>>2]|0;zb=c[a+4616>>2]|0;Ab=c[a+4624>>2]|0;Bb=c[a+4632>>2]|0;Cb=c[a+4640>>2]|0;Db=c[a+4648>>2]|0;Eb=c[a+4664>>2]|0;Fb=c[a+4672>>2]|0;Gb=c[a+4680>>2]|0;Hb=c[a+4688>>2]|0;Ib=c[a+4696>>2]|0;Jb=c[a+4704>>2]|0;Kb=c[a+4712>>2]|0;Lb=c[a+4720>>2]|0;Mb=c[a+4728>>2]|0;Nb=c[a+4736>>2]|0;Ob=c[a+4752>>2]|0;Pb=c[a+4760>>2]|0;Qb=c[a+4768>>2]|0;Rb=c[a+4776>>2]|0;Sb=c[a+4784>>2]|0;Tb=c[a+4792>>2]|0;Ub=c[a+4800>>2]|0;Vb=c[a+4808>>2]|0;Wb=c[a+4816>>2]|0;Xb=c[a+4824>>2]|0;Yb=c[a+4840>>2]|0;Zb=c[a+4848>>2]|0;_b=c[a+4856>>2]|0;$b=c[a+4864>>2]|0;ac=c[a+4872>>2]|0;bc=c[a+4880>>2]|0;cc=c[a+4888>>2]|0;dc=c[a+4896>>2]|0;ec=c[a+4904>>2]|0;fc=c[a+4912>>2]|0;gc=c[a+4928>>2]|0;hc=c[a+4936>>2]|0;ic=c[a+4952>>2]|0;jc=c[a+4960>>2]|0;kc=c[a+4968>>2]|0;lc=c[a+4976>>2]|0;mc=c[a+4984>>2]|0;nc=c[a+4992>>2]|0;oc=c[a+5e3>>2]|0;pc=c[a+5008>>2]|0;qc=c[a+5024>>2]|0;rc=c[a+5032>>2]|0;sc=c[a+5040>>2]|0;tc=c[a+5048>>2]|0;uc=c[a+5056>>2]|0;vc=c[a+5064>>2]|0;wc=c[a+5072>>2]|0;xc=c[a+5080>>2]|0;yc=c[a+5088>>2]|0;zc=c[a+5096>>2]|0;Ac=c[a+5112>>2]|0;Bc=c[a+5120>>2]|0;Cc=c[a+5128>>2]|0;Dc=c[a+5136>>2]|0;Ec=c[a+5144>>2]|0;Fc=c[a+5152>>2]|0;Gc=c[a+5160>>2]|0;Hc=c[a+5168>>2]|0;Ic=c[a+5176>>2]|0;Jc=c[a+5184>>2]|0;Kc=c[a+5200>>2]|0;Lc=c[a+5208>>2]|0;Mc=c[a+5216>>2]|0;Nc=c[a+5224>>2]|0;Oc=c[a+5232>>2]|0;Pc=c[a+5240>>2]|0;Qc=c[a+5248>>2]|0;Rc=c[a+5256>>2]|0;Sc=c[a+5264>>2]|0;Tc=c[a+5272>>2]|0;Uc=c[a+5288>>2]|0;Vc=c[a+5296>>2]|0;Wc=c[a+5304>>2]|0;Xc=c[a+5312>>2]|0;Yc=c[a+5320>>2]|0;Zc=c[a+5328>>2]|0;_c=c[a+5336>>2]|0;$c=c[a+5344>>2]|0;ad=c[a+5352>>2]|0;bd=c[a+5360>>2]|0;cd=c[a+5376>>2]|0;dd=c[a+5384>>2]|0;ed=c[a+5392>>2]|0;fd=c[a+5400>>2]|0;gd=c[a+5408>>2]|0;hd=c[a+5416>>2]|0;id=c[a+5424>>2]|0;jd=c[a+5432>>2]|0;kd=c[a+5440>>2]|0;ld=c[a+5448>>2]|0;md=c[a+5464>>2]|0;nd=c[a+5472>>2]|0;od=c[a+5480>>2]|0;pd=c[a+5488>>2]|0;qd=c[a+5496>>2]|0;rd=c[a+5504>>2]|0;sd=c[a+5512>>2]|0;td=c[a+5520>>2]|0;ud=c[a+5528>>2]|0;vd=c[a+5536>>2]|0;wd=c[a+5552>>2]|0;xd=c[a+5560>>2]|0;yd=c[a+5568>>2]|0;zd=c[a+5576>>2]|0;Ad=c[a+5584>>2]|0;Bd=c[a+5592>>2]|0;Cd=c[a+5600>>2]|0;a:do{Dd=+h[(Fz(l,1,rb)|0)>>3];c[sb>>2]=12;Ed=+h[(Fz(l,1,sb)|0)>>3];c[tb>>2]=25;Fd=Dd*Ed*+h[(Fz(l,1,tb)|0)>>3];c[ub>>2]=52;h[(Fz(l,1,ub)|0)>>3]=Fd;c[vb>>2]=10;Fd=+h[(Fz(l,1,vb)|0)>>3];c[wb>>2]=12;Ed=+h[(Fz(l,1,wb)|0)>>3];c[xb>>2]=25;Dd=Fd*Ed*+h[(Fz(l,1,xb)|0)>>3];c[yb>>2]=53;h[(Fz(l,1,yb)|0)>>3]=Dd;c[zb>>2]=1;Dd=+h[(Fz(l,1,zb)|0)>>3];c[Ab>>2]=10;Ed=+h[(Fz(l,1,Ab)|0)>>3];c[Bb>>2]=25;Fd=Dd*Ed*+h[(Fz(l,1,Bb)|0)>>3];c[Cb>>2]=54;h[(Fz(l,1,Cb)|0)>>3]=Fd;c[Db>>2]=11;Fd=+h[(Fz(l,1,Db)|0)>>3];c[Eb>>2]=12;Ed=Fd*j*+h[(Fz(l,1,Eb)|0)>>3];c[Fb>>2]=55;h[(Fz(l,1,Fb)|0)>>3]=Ed;if(!(e/1.0e6>0.0)){Gd=c[28994]|0;h[k>>3]=e/1.0e6;c[Gb>>2]=c[k>>2];c[Gb+4>>2]=c[k+4>>2];c[a+0>>2]=c[8800+0>>2];c[a+4>>2]=c[8800+4>>2];c[a+8>>2]=c[8800+8>>2];c[a+12>>2]=c[8800+12>>2];c[a+16>>2]=c[8800+16>>2];c[a+20>>2]=c[8800+20>>2];De[Gd&31](d,a,7960,Gb);}c[Hb>>2]=9;Ed=+h[(Fz(l,1,Hb)|0)>>3];c[Ib>>2]=1;Fd=+h[(Fz(l,1,Ib)|0)>>3];c[Jb>>2]=13;Dd=+h[(Fz(l,1,Jb)|0)>>3]*-26674547914087.0e-18+-.043797295650573;c[Kb>>2]=2;Hd=j*(j*(Fd*(Dd*+h[(Fz(l,1,Kb)|0)>>3]+-.0039392777243355)+-.00018948987516315)+-33032641670203.0e-18);c[Lb>>2]=1;Dd=+h[(Fz(l,1,Lb)|0)>>3];c[Mb>>2]=13;Fd=+h[(Fz(l,1,Mb)|0)>>3]*-.040668253562649+-.0015033924542148;c[Nb>>2]=2;Id=j*(Dd*(Fd*+h[(Fz(l,1,Nb)|0)>>3]+-3227767723857.0e-17)+4.3870667284435e-7);c[Ob>>2]=14;Fd=+h[(Fz(l,1,Ob)|0)>>3]*22922076337661.0e-19;c[Pb>>2]=15;Dd=+h[(Fz(l,1,Pb)|0)>>3];c[Qb>>2]=16;Jd=Dd*(+h[(Fz(l,1,Qb)|0)>>3]*-23.895741934104+-.0021171472321355)+-1.6714766451061e-11;c[Rb>>2]=2;Dd=+h[(Fz(l,1,Rb)|0)>>3]*Jd;c[Sb>>2]=17;Jd=+h[(Fz(l,1,Sb)|0)>>3];c[Tb>>2]=18;Kd=Jd*(+h[(Fz(l,1,Tb)|0)>>3]*-.038946842435739+-12621808899101.0e-19);c[Ub>>2]=11;Jd=+h[(Fz(l,1,Ub)|0)>>3];c[Vb>>2]=19;Ld=Jd*(+h[(Fz(l,1,Vb)|0)>>3]*-8.2311340897998+1.1256211360459e-11);c[Wb>>2]=15;Jd=+h[(Fz(l,1,Wb)|0)>>3]*1.9809712802088e-8;c[Xb>>2]=10;Md=+h[(Fz(l,1,Xb)|0)>>3];c[Yb>>2]=10;Nd=+h[(Fz(l,1,Yb)|0)>>3]*-1.0018179379511e-9+-1.0234747095929e-13;c[Zb>>2]=20;Od=Md*(Nd*+h[(Fz(l,1,Zb)|0)>>3]+1.0406965210174e-19);c[_b>>2]=23;Nd=+h[(Fz(l,1,_b)|0)>>3];c[$b>>2]=13;Md=+h[(Fz(l,1,$b)|0)>>3];c[ac>>2]=24;Pd=Md*(+h[(Fz(l,1,ac)|0)>>3]*.10693031879409+-8.0882908646985e-11);c[bc>>2]=21;Md=+h[(Fz(l,1,bc)|0)>>3];c[cc>>2]=26;Qd=+h[(Fz(l,1,cc)|0)>>3]*-.33662250574171;c[dc>>2]=21;Rd=+h[(Fz(l,1,dc)|0)>>3];c[ec>>2]=27;Sd=+h[(Fz(l,1,ec)|0)>>3];c[fc>>2]=15;Td=+h[(Fz(l,1,fc)|0)>>3]*-42002467698208.0e-19+3.0629316876232e-13;c[gc>>2]=28;Ud=Sd*(Td*+h[(Fz(l,1,gc)|0)>>3]+8.9185845355421e-25);c[hc>>2]=24;Td=+h[(Fz(l,1,hc)|0)>>3]*-5.9056029685639e-26;c[ic>>2]=29;Sd=+h[(Fz(l,1,ic)|0)>>3]*37826947613457.0e-19;c[jc>>2]=30;Vd=+h[(Fz(l,1,jc)|0)>>3]*-1.2768608934681e-15;c[kc>>2]=31;Wd=+h[(Fz(l,1,kc)|0)>>3];c[lc>>2]=18;Xd=+h[(Fz(l,1,lc)|0)>>3];c[mc>>2]=32;Yd=e/1.0e6*(Ed+e/1.0e6*(Hd+e/1.0e6*(Id+e/1.0e6*(j*(j*(j*4.8225372718507e-7+1.2790717852285e-8)+-7.8847309559367e-10)+e/1.0e6*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Od+Nd*(Pd+Md*(Qd+Rd*(Ud+e/1.0e6*(Td+e/1.0e6*(Sd+e/1.0e6*(Vd+Wd*e/1.0e6*(Xd*(+h[(Fz(l,1,mc)|0)>>3]*-9.436970724121e-7+5.5414715350778e-17)+7.3087610595061e-29))))))))))+-5.905956432427e-18))))+2.0481737692309e-8))+-.0017731742473213);Xd=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.02126846353307+-.2840863260772)+10.08665568018)+ +da(+(e/1.0e6))+-9.692768600217)+-4.38395111945)+1.424081971444)+-.4071049823928)+.07145273881455)+-.00560879118302;c[nc>>2]=34;Wd=Xd/(540.0/f*+h[(Fz(l,1,nc)|0)>>3])+Yd;c[oc>>2]=9;Yd=+h[(Fz(l,1,oc)|0)>>3];c[pc>>2]=43;Xd=+h[(Fz(l,1,pc)|0)>>3];c[qc>>2]=1;Vd=+h[(Fz(l,1,qc)|0)>>3];c[rc>>2]=13;Sd=+h[(Fz(l,1,rc)|0)>>3]*-.122004760687947+-.0045101773626444;c[sc>>2]=2;Td=j*(Vd*(Sd*+h[(Fz(l,1,sc)|0)>>3]+-9683303171571.0e-17)+131612001853305.0e-20);c[tc>>2]=14;Sd=+h[(Fz(l,1,tc)|0)>>3]*114610381688305.0e-19;c[uc>>2]=15;Vd=+h[(Fz(l,1,uc)|0)>>3];c[vc>>2]=16;Ud=Vd*(+h[(Fz(l,1,vc)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10;c[wc>>2]=2;Vd=+h[(Fz(l,1,wc)|0)>>3]*Ud;c[xc>>2]=17;Ud=+h[(Fz(l,1,xc)|0)>>3];c[yc>>2]=18;Rd=Ud*(+h[(Fz(l,1,yc)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[zc>>2]=11;Ud=+h[(Fz(l,1,zc)|0)>>3];c[Ac>>2]=19;Qd=Ud*(+h[(Fz(l,1,Ac)|0)>>3]*-65.849072718398+9.0049690883672e-11);c[Bc>>2]=15;Ud=+h[(Fz(l,1,Bc)|0)>>3]*1.78287415218792e-7;c[Cc>>2]=10;Md=+h[(Fz(l,1,Cc)|0)>>3];c[Dc>>2]=10;Pd=+h[(Fz(l,1,Dc)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[Ec>>2]=20;Nd=Md*(Pd*+h[(Fz(l,1,Ec)|0)>>3]+1.0406965210174e-18);c[Fc>>2]=23;Pd=+h[(Fz(l,1,Fc)|0)>>3];c[Gc>>2]=13;Md=+h[(Fz(l,1,Gc)|0)>>3];c[Hc>>2]=24;Od=Md*(+h[(Fz(l,1,Hc)|0)>>3]*1.71088510070544+-1.29412653835176e-9);c[Ic>>2]=21;Md=+h[(Fz(l,1,Ic)|0)>>3];c[Jc>>2]=26;Jd=+h[(Fz(l,1,Jc)|0)>>3]*-6.0592051033508;c[Kc>>2]=21;Ld=+h[(Fz(l,1,Kc)|0)>>3];c[Lc>>2]=27;Kd=+h[(Fz(l,1,Lc)|0)>>3];c[Mc>>2]=15;Dd=+h[(Fz(l,1,Mc)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12;c[Nc>>2]=28;Fd=Kd*(Dd*+h[(Fz(l,1,Nc)|0)>>3]+1.78371690710842e-23);c[Oc>>2]=24;Dd=+h[(Fz(l,1,Oc)|0)>>3]*-1.24017662339842e-24;c[Pc>>2]=29;Kd=+h[(Fz(l,1,Pc)|0)>>3]*83219284749605.0e-18;c[Qc>>2]=30;Id=+h[(Fz(l,1,Qc)|0)>>3]*-2.93678005497663e-14;c[Rc>>2]=31;Hd=+h[(Fz(l,1,Rc)|0)>>3];c[Sc>>2]=18;Ed=+h[(Fz(l,1,Sc)|0)>>3];c[Tc>>2]=32;Zd=(e/1.0e6*(Yd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*(j*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+e/1.0e6*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Qd+e/1.0e6*(Ud+e/1.0e6*(Nd+Pd*(Od+Md*(Jd+Ld*(Fd+e/1.0e6*(Dd+e/1.0e6*(Kd+e/1.0e6*(Id+Hd*e/1.0e6*(Ed*(+h[(Fz(l,1,Tc)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15)+1.75410265428146e-27))))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/(e/1.0e6);c[Uc>>2]=21;Ed=+h[(Fz(l,1,Uc)|0)>>3];c[Vc>>2]=43;Hd=+h[(Fz(l,1,Vc)|0)>>3];c[Wc>>2]=1;Id=+h[(Fz(l,1,Wc)|0)>>3];c[Xc>>2]=13;Kd=+h[(Fz(l,1,Xc)|0)>>3]*-.244009521375894+-.0090203547252888;c[Yc>>2]=2;Dd=j*(Id*(Kd*+h[(Fz(l,1,Yc)|0)>>3]+-.00019366606343142)+26322400370661.0e-19);c[Zc>>2]=14;Kd=+h[(Fz(l,1,Zc)|0)>>3]*45844152675322.0e-18;c[_c>>2]=15;Id=+h[(Fz(l,1,_c)|0)>>3];c[$c>>2]=16;Fd=Id*(+h[(Fz(l,1,$c)|0)>>3]*-716.87225802312+-.063514416964065)+-5.0144299353183e-10;c[ad>>2]=2;Id=+h[(Fz(l,1,ad)|0)>>3]*Fd;c[bd>>2]=17;Fd=+h[(Fz(l,1,bd)|0)>>3];c[cd>>2]=18;Ld=Fd*(+h[(Fz(l,1,cd)|0)>>3]*-1.63576738230104+-53011597376224.0e-18);c[dd>>2]=11;Fd=+h[(Fz(l,1,dd)|0)>>3];c[ed>>2]=19;Jd=Fd*(+h[(Fz(l,1,ed)|0)>>3]*-460.94350902879+6.303478361857e-10);c[fd>>2]=15;Fd=+h[(Fz(l,1,fd)|0)>>3]*142629932175034.0e-20;c[gd>>2]=10;Md=+h[(Fz(l,1,gd)|0)>>3];c[hd>>2]=10;Od=+h[(Fz(l,1,hd)|0)>>3]*-9.0163614415599e-8+-9.2112723863361e-12;c[id>>2]=20;Pd=Md*(Od*+h[(Fz(l,1,id)|0)>>3]+9.3662686891566e-18);c[jd>>2]=23;Od=+h[(Fz(l,1,jd)|0)>>3];c[kd>>2]=13;Md=+h[(Fz(l,1,kd)|0)>>3];c[ld>>2]=24;Nd=Md*(+h[(Fz(l,1,ld)|0)>>3]*25.6632765105816+-1.94118980752764e-8);c[md>>2]=21;Md=+h[(Fz(l,1,md)|0)>>3];c[nd>>2]=26;Ud=+h[(Fz(l,1,nd)|0)>>3]*-103.006486756963;c[od>>2]=21;Qd=+h[(Fz(l,1,od)|0)>>3];c[pd>>2]=27;Rd=+h[(Fz(l,1,pd)|0)>>3];c[qd>>2]=15;Vd=+h[(Fz(l,1,qd)|0)>>3]*-.0015960937725319+1.16391404129682e-10;c[rd>>2]=28;Sd=Rd*(Vd*+h[(Fz(l,1,rd)|0)>>3]+3.389062123506e-22);c[sd>>2]=24;Vd=+h[(Fz(l,1,sd)|0)>>3]*-2.48035324679684e-23;c[td>>2]=29;Rd=+h[(Fz(l,1,td)|0)>>3]*.00174760497974171;c[ud>>2]=30;Td=+h[(Fz(l,1,ud)|0)>>3]*-6.4609161209486e-13;c[vd>>2]=31;Xd=+h[(Fz(l,1,vd)|0)>>3];c[wd>>2]=18;Yd=+h[(Fz(l,1,wd)|0)>>3];c[xd>>2]=32;_d=e/1.0e6*(Kd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Pd+Od*(Nd+Md*(Ud+Qd*(Sd+e/1.0e6*(Vd+e/1.0e6*(Rd+e/1.0e6*(Td+Xd*e/1.0e6*(Yd*(+h[(Fz(l,1,xd)|0)>>3]*-.00052092078397148+3.05889228736295e-14)+4.0344361048474e-26))))))))))+-2.48050170161934e-16)));c[yd>>2]=44;Yd=Ed*(Hd+e/1.0e6*(Dd+e/1.0e6*(j*(j*(+h[(Fz(l,1,yd)|0)>>3]+1.5348861422742e-7)+-9.461677147124e-9)+_d)+1.22890426153854e-7))+-1.0;c[zd>>2]=21;_d=Yd/+h[(Fz(l,1,zd)|0)>>3];c[Ad>>2]=33;Yd=540.0/f*(540.0/f*(540.0/f*(540.0/f*((540.0/f*(540.0/f*.06380539059921+-.5681726521544)+10.08665568018)*+h[(Fz(l,1,Ad)|0)>>3]+4.38395111945)+-2.848163942888)+1.2213149471784)+-.2858109552582)+.0280439559151;c[Bd>>2]=33;Dd=+h[(Fz(l,1,Bd)|0)>>3];c[Cd>>2]=34;Hd=Yd/(Dd*+h[(Fz(l,1,Cd)|0)>>3]);c[m>>2]=49;Dd=+h[(Fz(l,1,m)|0)>>3];c[n>>2]=1;Yd=+h[(Fz(l,1,n)|0)>>3];c[o>>2]=13;Ed=+h[(Fz(l,1,o)|0)>>3]*-.00096028372490713+-.306581069554011;c[p>>2]=2;Xd=j*(Yd*(Ed*+h[(Fz(l,1,p)|0)>>3]+-.015757110897342)+-.0003789797503263);c[q>>2]=1;Ed=+h[(Fz(l,1,q)|0)>>3];c[r>>2]=13;Yd=+h[(Fz(l,1,r)|0)>>3]*-1.42338887469272+-.0090203547252888;c[s>>2]=2;Td=Ed*(Yd*+h[(Fz(l,1,s)|0)>>3]+-9683303171571.0e-17);c[t>>2]=20;Yd=+h[(Fz(l,1,t)|0)>>3]*160454534363627.0e-19;c[u>>2]=1;Ed=+h[(Fz(l,1,u)|0)>>3];c[v>>2]=15;Rd=+h[(Fz(l,1,v)|0)>>3];c[w>>2]=16;Vd=Ed*(Rd*(+h[(Fz(l,1,w)|0)>>3]*-836.35096769364+-.033874355714168)+-5.0144299353183e-11);c[x>>2]=18;Rd=+h[(Fz(l,1,x)|0)>>3]*-.97367106089347+-138839897890111.0e-19;c[y>>2]=50;Ed=Rd*+h[(Fz(l,1,y)|0)>>3];c[z>>2]=14;Rd=+h[(Fz(l,1,z)|0)>>3];c[A>>2]=19;Sd=Rd*(+h[(Fz(l,1,A)|0)>>3]*-296.320827232793+9.0049690883672e-11);c[B>>2]=51;Rd=+h[(Fz(l,1,B)|0)>>3]*2.57526266427144e-7;c[C>>2]=2;Qd=+h[(Fz(l,1,C)|0)>>3];c[D>>2]=10;Ud=+h[(Fz(l,1,D)|0)>>3]*-1.40254511313154e-8+-1.0234747095929e-12;c[E>>2]=20;Md=Qd*(Ud*+h[(Fz(l,1,E)|0)>>3]+4.1627860840696e-19);c[F>>2]=23;Ud=+h[(Fz(l,1,F)|0)>>3];c[G>>2]=19;Qd=+h[(Fz(l,1,G)|0)>>3];c[H>>2]=24;Nd=Qd*(+h[(Fz(l,1,H)|0)>>3]*5.3465159397045+-2.34560435076256e-9);c[I>>2]=21;Qd=+h[(Fz(l,1,I)|0)>>3];c[J>>2]=52;Od=+h[(Fz(l,1,J)|0)>>3]*-19.1874828272775;c[K>>2]=21;Pd=+h[(Fz(l,1,K)|0)>>3];c[L>>2]=16;Fd=+h[(Fz(l,1,L)|0)>>3];c[M>>2]=15;Jd=+h[(Fz(l,1,M)|0)>>3]*-.000201611844951398+1.07202609066812e-11;c[N>>2]=28;Ld=Fd*(Jd*+h[(Fz(l,1,N)|0)>>3]+1.78371690710842e-23);c[O>>2]=27;Jd=+h[(Fz(l,1,O)|0)>>3]*-1.24017662339842e-24;c[P>>2]=53;Fd=+h[(Fz(l,1,P)|0)>>3]*.000200482822351322;c[Q>>2]=54;Id=+h[(Fz(l,1,Q)|0)>>3]*-4.9797574845256e-14;c[R>>2]=18;Kd=+h[(Fz(l,1,R)|0)>>3];c[S>>2]=32;$d=Kd*(+h[(Fz(l,1,S)|0)>>3]*-54734430199902.0e-18+2.21658861403112e-15)+1.90027787547159e-27;c[T>>2]=55;Kd=Hd+e/1.0e6*(Dd+e/1.0e6*(Xd+e/1.0e6*(Td+e/1.0e6*(j*(j*144676118155521.0e-20+2.558143570457e-8)+e/1.0e6*(Yd+e/1.0e6*(Vd+e/1.0e6*(Ed+e/1.0e6*(Sd+e/1.0e6*(Rd+e/1.0e6*(Md+Ud*(Nd+Qd*(Od+Pd*(Ld+e/1.0e6*(Jd+e/1.0e6*(Fd+e/1.0e6*(Id+e/1.0e6*+h[(Fz(l,1,T)|0)>>3]*$d))))))))))))+-7.8847309559367e-10)+4.3870667284435e-7)+-33032641670203.0e-18)+-.017834862292358);c[U>>2]=33;$d=540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*(540.0/f*.12761078119842+-.5681726521544)*+h[(Fz(l,1,U)|0)>>3]+-8.7679022389)+8.544491828664)+-4.8852597887136)+1.429054776291)+-.1682637354906;c[V>>2]=33;Id=+h[(Fz(l,1,V)|0)>>3];c[W>>2]=34;Fd=$d/(540.0/f*Id*+h[(Fz(l,1,W)|0)>>3]);c[X>>2]=2;Id=j*(+h[(Fz(l,1,X)|0)>>3]*-1.5097583618379+-.34548755450059);c[Y>>2]=1;$d=+h[(Fz(l,1,Y)|0)>>3];c[Z>>2]=13;Jd=+h[(Fz(l,1,Z)|0)>>3]*-.03360993037175+-1.83948641732407;c[_>>2]=2;Ld=$d*(Jd*+h[(Fz(l,1,_)|0)>>3]+-.047271332692026);c[$>>2]=13;Jd=+h[(Fz(l,1,$)|0)>>3]*-48.395221739552+-.045101773626444;c[aa>>2]=2;$d=j*(Jd*+h[(Fz(l,1,aa)|0)>>3]+-.00019366606343142);c[ba>>2]=10;Jd=j*+h[(Fz(l,1,ba)|0)>>3]*96272720618176.0e-18;c[ca>>2]=15;Pd=+h[(Fz(l,1,ca)|0)>>3];c[ea>>2]=16;Od=j*(Pd*(+h[(Fz(l,1,ea)|0)>>3]*-28435.9329015838+-.50811533571252)+-1.00288598706366e-10);c[fa>>2]=11;Pd=+h[(Fz(l,1,fa)|0)>>3];c[ga>>2]=18;Qd=Pd*j*(+h[(Fz(l,1,ga)|0)>>3]*-23.3681054614434+-.000138839897890111);c[ha>>2]=19;Pd=+h[(Fz(l,1,ha)|0)>>3]*-10371.2289531477+6.303478361857e-10;c[ia>>2]=20;Nd=Pd*+h[(Fz(l,1,ia)|0)>>3];c[ja>>2]=17;Pd=+h[(Fz(l,1,ja)|0)>>3]*309031519712573.0e-20;c[ka>>2]=1;Ud=+h[(Fz(l,1,ka)|0)>>3];c[la>>2]=10;Md=+h[(Fz(l,1,la)|0)>>3]*-1.823308647071e-7+-9.2112723863361e-12;c[ma>>2]=20;Rd=Ud*(Md*+h[(Fz(l,1,ma)|0)>>3]+1.24883582522088e-18);c[na>>2]=23;Md=+h[(Fz(l,1,na)|0)>>3];c[oa>>2]=1;Ud=+h[(Fz(l,1,oa)|0)>>3];c[pa>>2]=11;Sd=+h[(Fz(l,1,pa)|0)>>3];c[qa>>2]=12;Ed=+h[(Fz(l,1,qa)|0)>>3];c[ra>>2]=24;Vd=Ud*Sd*Ed*j*(+h[(Fz(l,1,ra)|0)>>3]*261.979281045521+-6.5676921821352e-8);c[sa>>2]=21;Ed=+h[(Fz(l,1,sa)|0)>>3];c[ta>>2]=1;Sd=+h[(Fz(l,1,ta)|0)>>3];c[ua>>2]=10;Ud=+h[(Fz(l,1,ua)|0)>>3];c[va>>2]=12;Yd=+h[(Fz(l,1,va)|0)>>3];c[wa>>2]=25;Td=Sd*Ud*Yd*j*+h[(Fz(l,1,wa)|0)>>3]*-1074.49903832754;c[xa>>2]=21;Yd=+h[(Fz(l,1,xa)|0)>>3];c[ya>>2]=15;Ud=+h[(Fz(l,1,ya)|0)>>3]*-.0094757567127157+3.6448887082716e-10;c[za>>2]=28;Sd=Ud*+h[(Fz(l,1,za)|0)>>3]+3.389062123506e-22;c[Aa>>2]=32;Ud=Sd*+h[(Fz(l,1,Aa)|0)>>3];c[Ba>>2]=16;Sd=+h[(Fz(l,1,Ba)|0)>>3]*-2.48035324679684e-23;c[Ca>>2]=1;Xd=+h[(Fz(l,1,Ca)|0)>>3];c[Da>>2]=12;Dd=+h[(Fz(l,1,Da)|0)>>3];c[Ea>>2]=25;Hd=Xd*Dd*j*+h[(Fz(l,1,Ea)|0)>>3]*.0104251067622687;c[Fa>>2]=11;Dd=+h[(Fz(l,1,Fa)|0)>>3];c[Ga>>2]=12;Xd=+h[(Fz(l,1,Ga)|0)>>3];c[Ha>>2]=18;ae=+h[(Fz(l,1,Ha)|0)>>3];c[Ia>>2]=32;be=Dd*Xd*e/1.0e6*(ae*(+h[(Fz(l,1,Ia)|0)>>3]*-.0031198625213944+8.6446955947214e-14)+4.750694688679e-26);c[Ja>>2]=10;ae=+h[(Fz(l,1,Ja)|0)>>3];c[Ka>>2]=25;Xd=Fd+e/1.0e6*(Id+e/1.0e6*(Ld+e/1.0e6*($d+e/1.0e6*(j*289352236311042.0e-20+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Qd+e/1.0e6*(Nd+e/1.0e6*(Pd+e/1.0e6*(Rd+Md*(Vd+Ed*(Td+Yd*(Ud+e/1.0e6*(Sd+e/1.0e6*(Hd+e/1.0e6*(be+ae*j*+h[(Fz(l,1,Ka)|0)>>3]*-1.89230784411972e-12))))))))))))+2.558143570457e-8))+-.0003789797503263)+-.09199202739273);c[La>>2]=49;ae=+h[(Fz(l,1,La)|0)>>3];c[Ma>>2]=1;be=+h[(Fz(l,1,Ma)|0)>>3];c[Na>>2]=13;Hd=+h[(Fz(l,1,Na)|0)>>3]*-.00192056744981426+-.61316213910802;c[Oa>>2]=2;Sd=j*(be*(Hd*+h[(Fz(l,1,Oa)|0)>>3]+-.031514221794684)+-.0007579595006526);c[Pa>>2]=1;Hd=+h[(Fz(l,1,Pa)|0)>>3];c[Qa>>2]=13;be=+h[(Fz(l,1,Qa)|0)>>3]*-4.2701666240781+-.0270610641758664;c[Ra>>2]=2;Ud=Hd*(be*+h[(Fz(l,1,Ra)|0)>>3]+-.00029049909514713);c[Sa>>2]=20;be=+h[(Fz(l,1,Sa)|0)>>3]*80227267181813.0e-18;c[Ta>>2]=1;Hd=+h[(Fz(l,1,Ta)|0)>>3];c[Ua>>2]=15;Yd=+h[(Fz(l,1,Ua)|0)>>3];c[Va>>2]=16;Td=Hd*(Yd*(+h[(Fz(l,1,Va)|0)>>3]*-5018.1058061618+-.203246134285008)+-3.00865796119098e-10);c[Wa>>2]=18;Yd=+h[(Fz(l,1,Wa)|0)>>3]*-6.8156974262543+-97187928523078.0e-18;c[Xa>>2]=50;Hd=Yd*+h[(Fz(l,1,Xa)|0)>>3];c[Ya>>2]=14;Yd=+h[(Fz(l,1,Ya)|0)>>3];c[Za>>2]=19;Ed=Yd*(+h[(Fz(l,1,Za)|0)>>3]*-2370.56661786234+7.2039752706938e-10);c[_a>>2]=51;Yd=+h[(Fz(l,1,_a)|0)>>3]*23177363978443.0e-19;c[$a>>2]=2;Vd=+h[(Fz(l,1,$a)|0)>>3];c[ab>>2]=10;Md=+h[(Fz(l,1,ab)|0)>>3]*-1.40254511313154e-7+-1.0234747095929e-11;c[bb>>2]=20;Rd=Vd*(Md*+h[(Fz(l,1,bb)|0)>>3]+4.1627860840696e-18);c[cb>>2]=23;Md=+h[(Fz(l,1,cb)|0)>>3];c[db>>2]=19;Vd=+h[(Fz(l,1,db)|0)>>3];c[eb>>2]=24;Pd=Vd*(+h[(Fz(l,1,eb)|0)>>3]*85.544255035272+-3.7529669612201e-8);c[fb>>2]=21;Vd=+h[(Fz(l,1,fb)|0)>>3];c[gb>>2]=52;Nd=+h[(Fz(l,1,gb)|0)>>3]*-345.37469089099;c[hb>>2]=21;Qd=+h[(Fz(l,1,hb)|0)>>3];c[ib>>2]=16;Od=+h[(Fz(l,1,ib)|0)>>3];c[jb>>2]=15;Jd=+h[(Fz(l,1,jb)|0)>>3]*-.004032236899028+2.14405218133624e-10;c[kb>>2]=28;$d=Od*(Jd*+h[(Fz(l,1,kb)|0)>>3]+3.5674338142168e-22);c[lb>>2]=27;Jd=+h[(Fz(l,1,lb)|0)>>3]*-2.60437090913668e-23;c[mb>>2]=53;Od=+h[(Fz(l,1,mb)|0)>>3]*.0044106220917291;c[nb>>2]=54;Ld=+h[(Fz(l,1,nb)|0)>>3]*-1.14534422144089e-12;c[ob>>2]=18;Id=+h[(Fz(l,1,ob)|0)>>3];c[pb>>2]=32;Fd=Id*(+h[(Fz(l,1,pb)|0)>>3]*-.00131362632479764+5.3198126736747e-14)+4.5606669011318e-26;c[qb>>2]=55;Id=e/1.0e6*(be+e/1.0e6*(Td+e/1.0e6*(Hd+e/1.0e6*(Ed+e/1.0e6*(Yd+e/1.0e6*(Rd+Md*(Pd+Vd*(Nd+Qd*($d+e/1.0e6*(Jd+e/1.0e6*(Od+e/1.0e6*(Ld+e/1.0e6*+h[(Fz(l,1,qb)|0)>>3]*Fd))))))))))));c[(a+120|0)>>2]=44;Fd=ae+e/1.0e6*(Sd+e/1.0e6*(Ud+e/1.0e6*(j*(+h[(Fz(l,1,a+120|0)|0)>>3]+1.0232574281828e-7)+Id+-3.15389238237468e-9)+131612001853305.0e-20)+-66065283340406.0e-18)+-.017834862292358;h[b>>3]=e;h[b+8>>3]=f;h[b+16>>3]=461.526;h[b+24>>3]=e/1.0e6;h[b+32>>3]=540.0/f;h[b+40>>3]=Wd;h[b+48>>3]=Zd;h[b+56>>3]=_d;h[b+64>>3]=Kd;h[b+72>>3]=Xd;h[b+80>>3]=Fd;i=a;c[a+5648>>2]=5;break a}while(0)}



function hI(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;rI(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){Ky(0,113e3,n)}if(p){ec=vd(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;Gy(23,0,113144,m);sI(q);tI(q,e,8);if(!(uI(q)|0)){c[l>>2]=e;Ky(0,113184,l)}_S(r);l=q;vI(l,r)|0;aT(s,r);while(1){e=vI(l,r)|0;if(!(WT(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}VT(t,113264,r);BT(s,t)|0;kT(t)}t=vd(HT(s)|0)|0;wI(q);kT(s);kT(r);xI(q);fc=t}if((fc|0)==0){Gy(23,0,113352,g);zI(o);i=f;return}_S(u);_S(v);c[k>>2]=fc;Gy(23,0,113272,k);k=Xb(fc|0,113264)|0;if((k|0)!=0){g=k;do{k=v1(12)|0;eT(k,g);t=IT(k,113304,0)|0;GT(w,k,0,t);lT(u,w)|0;kT(w);GT(x,k,t+1|0,(rT(k)|0)+~t|0);lT(v,x)|0;kT(x);lT(RH(o,u)|0,v)|0;t=HT(u)|0;k=HT(v)|0;c[j>>2]=t;c[j+4>>2]=k;Gy(23,0,113312,j);g=Xb(0,113264)|0;}while((g|0)!=0)}q1(fc);fc=a+12|0;eT(y,111400);g=RH(fc,y)|0;eT(z,111400);if((yI(o,z)|0)==0){eT(B,111400);gc=1;hc=0;ic=RH(fc,B)|0}else{eT(A,111400);gc=0;hc=1;ic=RH(o,A)|0}lT(g,ic)|0;if(gc){kT(B)}if(hc){kT(A)}kT(z);kT(y);eT(C,111272);y=RH(fc,C)|0;eT(D,111272);if((yI(o,D)|0)==0){eT(F,111272);jc=1;kc=0;lc=RH(fc,F)|0}else{eT(E,111272);jc=0;kc=1;lc=RH(o,E)|0}lT(y,lc)|0;if(jc){kT(F)}if(kc){kT(E)}kT(D);kT(C);eT(G,111304);C=RH(fc,G)|0;eT(H,111304);if((yI(o,H)|0)==0){eT(J,111304);mc=1;nc=0;oc=RH(fc,J)|0}else{eT(I,111304);mc=0;nc=1;oc=RH(o,I)|0}lT(C,oc)|0;if(mc){kT(J)}if(nc){kT(I)}kT(H);kT(G);eT(K,111336);G=RH(fc,K)|0;eT(L,111336);if((yI(o,L)|0)==0){eT(N,111336);pc=0;qc=1;rc=RH(fc,N)|0}else{eT(M,111336);pc=1;qc=0;rc=RH(o,M)|0}lT(G,rc)|0;if(qc){kT(N)}if(pc){kT(M)}kT(L);kT(K);eT(O,111368);K=RH(fc,O)|0;eT(P,111368);if((yI(o,P)|0)==0){eT(R,111368);sc=1;tc=0;uc=RH(fc,R)|0}else{eT(Q,111368);sc=0;tc=1;uc=RH(o,Q)|0}lT(K,uc)|0;if(sc){kT(R)}if(tc){kT(Q)}kT(P);kT(O);eT(S,111432);O=RH(fc,S)|0;eT(T,111432);if((yI(o,T)|0)==0){eT(V,111432);vc=1;wc=0;xc=RH(fc,V)|0}else{eT(U,111432);vc=0;wc=1;xc=RH(o,U)|0}lT(O,xc)|0;if(vc){kT(V)}if(wc){kT(U)}kT(T);kT(S);eT(W,111472);S=RH(fc,W)|0;eT(X,111472);if((yI(o,X)|0)==0){eT(Z,111472);yc=1;zc=0;Ac=RH(fc,Z)|0}else{eT(Y,111472);yc=0;zc=1;Ac=RH(o,Y)|0}lT(S,Ac)|0;if(yc){kT(Z)}if(zc){kT(Y)}kT(X);kT(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=iI(Y,_)|0;eT($,110376);Ac=RH(yc,$)|0;c[aa>>2]=Z;yc=iI(Y,aa)|0;eT(ba,110232);if((yI(o,RH(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=iI(Y,ea)|0;eT(fa,110376);Bc=1;Cc=0;Dc=RH(yc,fa)|0}else{c[ca>>2]=Z;yc=iI(Y,ca)|0;eT(da,110232);Bc=0;Cc=1;Dc=RH(o,RH(yc,da)|0)|0}lT(Ac,Dc)|0;if(Bc){kT(fa)}if(Cc){kT(da)}kT(ba);kT($);c[ga>>2]=Z;Ac=iI(zc,ga)|0;eT(ha,110376);yc=RH(Ac,ha)|0;c[ia>>2]=Z;Ac=iI(zc,ia)|0;eT(ja,110232);if((yI(o,RH(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=iI(zc,ma)|0;eT(na,110376);Ec=1;Fc=0;Gc=RH(Ac,na)|0}else{c[ka>>2]=Z;Ac=iI(zc,ka)|0;eT(la,110232);Ec=0;Fc=1;Gc=RH(o,RH(Ac,la)|0)|0}lT(yc,Gc)|0;if(Ec){kT(na)}if(Fc){kT(la)}kT(ja);kT(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=iI(Hc,oa)|0;eT(pa,110376);ja=RH(ha,pa)|0;c[qa>>2]=Z;ha=iI(Hc,qa)|0;eT(ra,110232);if((yI(o,RH(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=iI(Hc,ua)|0;eT(va,110376);Ic=1;Jc=0;Kc=RH(ha,va)|0}else{c[sa>>2]=Z;ha=iI(Hc,sa)|0;eT(ta,110232);Ic=0;Jc=1;Kc=RH(o,RH(ha,ta)|0)|0}lT(ja,Kc)|0;if(Ic){kT(va)}if(Jc){kT(ta)}kT(ra);kT(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=iI(X,wa)|0;eT(xa,110376);ra=RH(pa,xa)|0;c[ya>>2]=Z;pa=iI(X,ya)|0;eT(za,110232);if((yI(o,RH(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=iI(X,Ca)|0;eT(Da,110376);Lc=1;Mc=0;Nc=RH(pa,Da)|0}else{c[Aa>>2]=Z;pa=iI(X,Aa)|0;eT(Ba,110232);Lc=0;Mc=1;Nc=RH(o,RH(pa,Ba)|0)|0}lT(ra,Nc)|0;if(Lc){kT(Da)}if(Mc){kT(Ba)}kT(za);kT(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=iI(Z,Ea)|0;eT(Fa,110376);Ba=RH(za,Fa)|0;c[Ga>>2]=xa;za=iI(Z,Ga)|0;eT(Ha,110232);if((yI(o,RH(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=iI(Z,Ka)|0;eT(La,110376);Oc=1;Pc=0;Qc=RH(za,La)|0}else{c[Ia>>2]=xa;za=iI(Z,Ia)|0;eT(Ja,110232);Oc=0;Pc=1;Qc=RH(o,RH(za,Ja)|0)|0}lT(Ba,Qc)|0;if(Oc){kT(La)}if(Pc){kT(Ja)}kT(Ha);kT(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=iI(xa,Ma)|0;eT(Na,110376);Ja=RH(Ha,Na)|0;c[Oa>>2]=Fa;Ha=iI(xa,Oa)|0;eT(Pa,110232);if((yI(o,RH(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=iI(xa,Sa)|0;eT(Ta,110376);Rc=1;Sc=0;Tc=RH(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=iI(xa,Qa)|0;eT(Ra,110232);Rc=0;Sc=1;Tc=RH(o,RH(Ha,Ra)|0)|0}lT(Ja,Tc)|0;if(Rc){kT(Ta)}if(Sc){kT(Ra)}kT(Pa);kT(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=iI(Fa,Ua)|0;eT(Va,110376);Ra=RH(Pa,Va)|0;c[Wa>>2]=Na;Pa=iI(Fa,Wa)|0;eT(Xa,110232);if((yI(o,RH(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=iI(Fa,_a)|0;eT($a,110376);Uc=1;Vc=0;Wc=RH(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=iI(Fa,Ya)|0;eT(Za,110232);Uc=0;Vc=1;Wc=RH(o,RH(Pa,Za)|0)|0}lT(Ra,Wc)|0;if(Uc){kT($a)}if(Vc){kT(Za)}kT(Xa);kT(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=iI(Na,ab)|0;eT(bb,110376);Za=RH(Xa,bb)|0;c[cb>>2]=Va;Xa=iI(Na,cb)|0;eT(db,110232);if((yI(o,RH(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=iI(Na,gb)|0;eT(hb,110376);Xc=1;Yc=0;Zc=RH(Xa,hb)|0}else{c[eb>>2]=Va;Xa=iI(Na,eb)|0;eT(fb,110232);Xc=0;Yc=1;Zc=RH(o,RH(Xa,fb)|0)|0}lT(Za,Zc)|0;if(Xc){kT(hb)}if(Yc){kT(fb)}kT(db);kT(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=iI(Va,ib)|0;eT(jb,110376);fb=RH(db,jb)|0;c[kb>>2]=bb;db=iI(Va,kb)|0;eT(lb,110232);if((yI(o,RH(db,lb)|0)|0)==0){c[ob>>2]=bb;db=iI(Va,ob)|0;eT(pb,110376);_c=1;$c=0;ad=RH(db,pb)|0}else{c[mb>>2]=bb;db=iI(Va,mb)|0;eT(nb,110232);_c=0;$c=1;ad=RH(o,RH(db,nb)|0)|0}lT(fb,ad)|0;if(_c){kT(pb)}if($c){kT(nb)}kT(lb);kT(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=iI(bb,qb)|0;eT(rb,110376);nb=RH(lb,rb)|0;c[sb>>2]=jb;lb=iI(bb,sb)|0;eT(tb,110232);if((yI(o,RH(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=iI(bb,wb)|0;eT(xb,110376);bd=1;cd=0;dd=RH(lb,xb)|0}else{c[ub>>2]=jb;lb=iI(bb,ub)|0;eT(vb,110232);bd=0;cd=1;dd=RH(o,RH(lb,vb)|0)|0}lT(nb,dd)|0;if(bd){kT(xb)}if(cd){kT(vb)}kT(tb);kT(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=iI(jb,yb)|0;eT(zb,110376);vb=RH(tb,zb)|0;c[Ab>>2]=rb;tb=iI(jb,Ab)|0;eT(Bb,110232);if((yI(o,RH(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=iI(jb,Eb)|0;eT(Fb,110376);ed=1;fd=0;gd=RH(tb,Fb)|0}else{c[Cb>>2]=rb;tb=iI(jb,Cb)|0;eT(Db,110232);ed=0;fd=1;gd=RH(o,RH(tb,Db)|0)|0}lT(vb,gd)|0;if(ed){kT(Fb)}if(fd){kT(Db)}kT(Bb);kT(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=iI(rb,Gb)|0;eT(Hb,110376);Db=RH(Bb,Hb)|0;c[Ib>>2]=zb;Bb=iI(rb,Ib)|0;eT(Jb,110232);if((yI(o,RH(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=iI(rb,Mb)|0;eT(Nb,110376);hd=0;id=1;jd=RH(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=iI(rb,Kb)|0;eT(Lb,110232);hd=1;id=0;jd=RH(o,RH(Bb,Lb)|0)|0}lT(Db,jd)|0;if(id){kT(Nb)}if(hd){kT(Lb)}kT(Jb);kT(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=iI(zb,Ob)|0;eT(Pb,110376);Lb=RH(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=iI(zb,Qb)|0;eT(Rb,110232);if((yI(o,RH(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=iI(zb,Ub)|0;eT(Vb,110376);kd=1;ld=0;md=RH(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=iI(zb,Sb)|0;eT(Tb,110232);kd=0;ld=1;md=RH(o,RH(Jb,Tb)|0)|0}lT(Lb,md)|0;if(kd){kT(Vb)}if(ld){kT(Tb)}kT(Rb);kT(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=iI(b,Wb)|0;eT(Yb,110376);Pb=RH(Hb,Yb)|0;c[Zb>>2]=a;Hb=iI(b,Zb)|0;eT(_b,110232);if((yI(o,RH(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=iI(b,bc)|0;eT(cc,110376);nd=1;od=0;pd=RH(Hb,cc)|0}else{c[$b>>2]=a;Hb=iI(b,$b)|0;eT(ac,110232);nd=0;od=1;pd=RH(o,RH(Hb,ac)|0)|0}lT(Pb,pd)|0;if(nd){kT(cc)}if(od){kT(ac)}kT(_b);kT(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}Gy(23,0,113336,h);kT(v);kT(u);zI(o);i=f;return}function iI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=RK(a,f,b)|0;l=c[k>>2]|0;BE(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}TK(j,a,b);UK(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];SK(g,e);VK(j);j=c[f>>2]|0;WK(a,j,k,XK(g)|0);k=YK(g)|0;VK(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function jI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=tJ(a,f,b)|0;l=c[k>>2]|0;BE(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}vJ(j,a,b);wJ(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];uJ(g,e);xJ(j);j=c[f>>2]|0;yJ(a,j,k,zJ(g)|0);k=AJ(g)|0;xJ(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function kI(a,b){a=a|0;b=b|0;var c=0;c=i;lT(b,a)|0;i=c;return}function lI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;kJ(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];cJ(a,f);i=e;return}function mI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=aJ(a,b)|0;i=c;return d|0}function nI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;dJ(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];cJ(a,e);i=d;return}function oI(a){a=a|0;var b=0,c=0;b=i;c=ZI(a)|0;i=b;return c|0}function pI(a){a=a|0;var b=0;b=i;wN(a);i=b;return}function qI(a){a=a|0;var b=0;b=i;jN(a);i=b;return}function rI(a,b){a=a|0;b=b|0;b=i;SL(a,0);i=b;return}function sI(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;hU(d);e=a;c[e>>2]=113404;f=d;c[f>>2]=113424;d=a+8|0;$U(a,113436|0,d);c[e>>2]=113404;c[f>>2]=113424;iH(d);i=b;return}function tI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(JE(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){_T(d,4);i=e;return}else{YT(d,0);i=e;return}}function uI(a){a=a|0;var b=0,c=0;b=i;c=UI(a+8|0)|0;i=b;return c|0}function vI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=TI(a,b,fU(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function wI(a){a=a|0;var b=0;b=i;if((LE(a+8|0)|0)!=0){i=b;return}_T(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function xI(a){a=a|0;var b=0;b=i;YI(a,113432);cU(a+108|0);i=b;return}function yI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=AI(a,b)|0;i=c;return d|0}function zI(a){a=a|0;var b=0;b=i;_M(a);i=b;return}function AI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=CI(a)|0;BE(e);if((f|0)==0){g=0;i=d;return g|0}h=DI(a)|0;a=f;while(1){f=a+16|0;if(EI(h,b,f)|0){j=a}else{if(!(FI(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;BE(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function BI(a){a=a|0;var b=0,c=0;b=i;c=mE(LI(a+4|0)|0)|0;i=b;return c|0}function CI(a){a=a|0;var b=0,d=0;b=i;d=c[(BI(a)|0)>>2]|0;i=b;return d|0}function DI(a){a=a|0;var b=0,c=0;b=i;c=JI(a+8|0)|0;i=b;return c|0}function EI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=GI(0,b,c)|0;i=a;return d|0}function FI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=GI(0,b,c)|0;i=a;return d|0}function GI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=HI(b,c)|0;i=a;return d|0}function HI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(JT(a,b)|0)<0;i=c;return d|0}function II(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=O1(a,b,c)|0;i=d;return e|0}function JI(a){a=a|0;var b=0,c=0;b=i;c=KI(a)|0;i=b;return c|0}function KI(a){a=a|0;i=i;return a|0}function LI(a){a=a|0;var b=0,c=0;b=i;c=MI(a)|0;i=b;return c|0}function MI(a){a=a|0;i=i;return a|0}function NI(a,b){a=a|0;b=b|0;var c=0;a=i;c=PI(0,b,0)|0;i=a;return c|0}function OI(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function PI(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=v1(b)|0;i=c;return a|0}function QI(a){a=a|0;var b=0,c=0;b=i;c=T1(a|0)|0;i=b;return c|0}function RI(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=SI(b,c,e)|0;i=d;return g|0}function SI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=FF(0,a,b)|0;i=c;return(d?b:a)|0}function TI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;eV(f,a,1);if(!(hV(f)|0)){i=e;return a|0}AT(b);f=0;while(1){g=nU(dU(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(vF(g,-1)|0){h=2;j=f;break}k=f+1|0;l=wF(g)|0;if(AF(l,d)|0){h=0;j=k;break}CT(b,l);if((iT(b)|0)==-17){h=4;j=k;break}else{f=k}}_T(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function UI(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function VI(a){a=a|0;var b=0;b=i;xI(a);x1(a);i=b;return}function WI(a){a=a|0;var b=0;b=i;xI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function XI(a){a=a|0;var b=0;b=i;VI(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function YI(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];jF(a+8|0);i=d;return}function ZI(a){a=a|0;var b=0,d=0;b=i;d=_I((c[a>>2]|0)+16|0)|0;i=b;return d|0}function _I(a){a=a|0;var b=0,c=0;b=i;c=$I(a)|0;i=b;return c|0}function $I(a){a=a|0;i=i;return a|0}function aJ(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(bJ(a,b)|0)^1;i=c;return d|0}function bJ(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function cJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];jJ(a,e);i=d;return}function dJ(a,b){a=a|0;b=b|0;var c=0;c=i;eJ(a,fJ(b)|0);i=c;return}function eJ(a,b){a=a|0;b=b|0;var c=0;c=i;iJ(a,b);i=c;return}function fJ(a){a=a|0;var b=0,c=0;b=i;c=mE(gJ(a+4|0)|0)|0;i=b;return c|0}function gJ(a){a=a|0;var b=0,c=0;b=i;c=hJ(a)|0;i=b;return c|0}function hJ(a){a=a|0;i=i;return a|0}function iJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function jJ(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function kJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=mJ(b)|0;lJ(f,b,d,h,fJ(b)|0);dJ(g,b);do{if(aJ(f,g)|0){h=nJ(b)|0;if(oJ(h,d,pJ(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);dJ(a,b);i=e;return}function lJ(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;BE(h);a:do{if((e|0)==0){j=f}else{k=nJ(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(sJ(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;BE(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;BE(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);eJ(a,j);i=g;return}function mJ(a){a=a|0;var b=0,d=0;b=i;d=c[(fJ(a)|0)>>2]|0;i=b;return d|0}function nJ(a){a=a|0;var b=0,c=0;b=i;c=qJ(a+8|0)|0;i=b;return c|0}function oJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=GI(0,b,c)|0;i=a;return d|0}function pJ(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function qJ(a){a=a|0;var b=0,c=0;b=i;c=rJ(a)|0;i=b;return c|0}function rJ(a){a=a|0;i=i;return a|0}function sJ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=GI(0,b,c)|0;i=a;return d|0}function tJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=mJ(h)|0;BE(e);if((a|0)==0){j=fJ(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(GI(0,d,a)|0){m=l;j=c[m>>2]|0;BE(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(GI(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;BE(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function uJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];pK(a,e);i=d;return}function vJ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=WJ(d)|0;d=YJ(n,1)|0;ZJ(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];XJ(j,d,h);_J(0,PJ(($J(j)|0)+16|0)|0,e);e=aK(j)|0;a[e+4|0]=1;bK(0,NJ(($J(j)|0)+28|0)|0);a[e+5|0]=1;cK(m,j);wJ(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];uJ(b,g);xJ(m);xJ(j);i=f;return}function wJ(a,b){a=a|0;b=b|0;var c=0;c=i;UJ(a,b);i=c;return}function xJ(a){a=a|0;var b=0;b=i;JJ(a);i=b;return}function yJ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;BE(f);c[e>>2]=0;BE(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=FJ(a)|0;b=c[c[e>>2]>>2]|0;BE(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(fJ(a)|0)>>2]|0;lG(e,c[d>>2]|0);d=GJ(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function zJ(a){a=a|0;var b=0,d=0;b=i;d=c[(DJ(a)|0)>>2]|0;i=b;return d|0}function AJ(a){a=a|0;var b=0,d=0;b=i;d=BJ(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function BJ(a){a=a|0;var b=0,c=0;b=i;c=CJ(a)|0;i=b;return c|0}function CJ(a){a=a|0;i=i;return a|0}function DJ(a){a=a|0;var b=0,c=0;b=i;c=EJ(a)|0;i=b;return c|0}function EJ(a){a=a|0;i=i;return a|0}function FJ(a){a=a|0;i=i;return a|0}function GJ(a){a=a|0;var b=0,c=0;b=i;c=HJ(a+8|0)|0;i=b;return c|0}function HJ(a){a=a|0;var b=0,c=0;b=i;c=IJ(a)|0;i=b;return c|0}function IJ(a){a=a|0;i=i;return a|0}function JJ(a){a=a|0;var b=0;b=i;KJ(a,0);i=b;return}function KJ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=BJ(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}MJ(LJ(e)|0,f);i=d;return}function LJ(a){a=a|0;var b=0,c=0;b=i;c=TJ(a)|0;i=b;return c|0}function MJ(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;OJ(f,PJ(d+16|0)|0)}if((d|0)==0){i=e;return}QJ(c[b>>2]|0,d,1);i=e;return}function NJ(a){a=a|0;i=i;return a|0}function OJ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;SJ(d,0,c);i=b;return}function PJ(a){a=a|0;i=i;return a|0}function QJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;RJ(0,b,0);i=c;return}function RJ(a,b,c){a=a|0;b=b|0;c=c|0;c=i;x1(b);i=c;return}function SJ(a,b,c){a=a|0;b=b|0;c=c|0;b=i;kT(c);i=b;return}function TJ(a){a=a|0;i=i;return a+4|0}function UJ(a,b){a=a|0;b=b|0;var c=0;c=i;VJ(a,b);i=c;return}function VJ(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function WJ(a){a=a|0;var b=0,c=0;b=i;c=nK(a+4|0)|0;i=b;return c|0}function XJ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];fK(a,b,f);i=e;return}function YJ(a,b){a=a|0;b=b|0;var c=0;a=i;c=eK(0,b,0)|0;i=a;return c|0}function ZJ(a,b){a=a|0;b=b|0;var c=0;c=i;dK(a,b);i=c;return}function _J(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}aT(b,c);i=a;return}function $J(a){a=a|0;var b=0,d=0;b=i;d=c[(DJ(a)|0)>>2]|0;i=b;return d|0}function aK(a){a=a|0;var b=0,c=0;b=i;c=LJ(a)|0;i=b;return c|0}function bK(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function cK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;UJ(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];uJ(h,f);wJ(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];uJ(a,e);xJ(h);i=d;return}function dK(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function eK(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=v1(b<<5)|0;i=c;return a|0}function fK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(hK(g)|0)>>2]|0;g=iK(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];gK(b,a,f);i=e;return}function gK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];jK(a,b,f);i=e;return}function hK(a){a=a|0;i=i;return a|0}function iK(a){a=a|0;i=i;return a|0}function jK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(lK(g)|0)>>2]|0;g=mK(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];kK(b,a,f);i=e;return}function kK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(lK(f)|0)>>2];f=mK(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function lK(a){a=a|0;i=i;return a|0}function mK(a){a=a|0;i=i;return a|0}function nK(a){a=a|0;var b=0,c=0;b=i;c=oK(a)|0;i=b;return c|0}function oK(a){a=a|0;i=i;return a|0}function pK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=AJ(qK(b)|0)|0;h=mK(aK(qK(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];gK(g,a,e);i=d;return}function qK(a){a=a|0;i=i;return c[a>>2]|0}function rK(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function sK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];zK(a,e);i=d;return}function tK(a,b){a=a|0;b=b|0;var c=0;c=i;uK(a,vK(b)|0);i=c;return}function uK(a,b){a=a|0;b=b|0;var c=0;c=i;yK(a,b);i=c;return}function vK(a){a=a|0;var b=0,c=0;b=i;c=mE(wK(a+4|0)|0)|0;i=b;return c|0}function wK(a){a=a|0;var b=0,c=0;b=i;c=xK(a)|0;i=b;return c|0}function xK(a){a=a|0;i=i;return a|0}function yK(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function zK(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function AK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=CK(b)|0;BK(f,b,d,h,vK(b)|0);tK(g,b);do{if(DK(f,g)|0){h=EK(b)|0;if(EI(h,d,FK(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);tK(a,b);i=e;return}function BK(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;BE(h);a:do{if((e|0)==0){j=f}else{k=EK(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(FI(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;BE(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;BE(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);uK(a,j);i=g;return}function CK(a){a=a|0;var b=0,d=0;b=i;d=c[(vK(a)|0)>>2]|0;i=b;return d|0}function DK(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(rK(a,b)|0)^1;i=c;return d|0}function EK(a){a=a|0;var b=0,c=0;b=i;c=GK(a+8|0)|0;i=b;return c|0}function FK(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function GK(a){a=a|0;var b=0,c=0;b=i;c=HK(a)|0;i=b;return c|0}function HK(a){a=a|0;i=i;return a|0}function IK(a,b){a=a|0;b=b|0;b=i;i=i+8|0;JK(a,b);i=b;return}function JK(a,b){a=a|0;b=b|0;b=i;KK(a,0);i=b;return}function KK(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;LK(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;MK(f,0,e);e=fJ(b)|0;c[(FJ(b)|0)>>2]=e;i=d;return}function LK(a){a=a|0;var b=0;b=i;PK(a);i=b;return}function MK(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;NK(b,c,f);i=e;return}function NK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(dH(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;OK(d,b,f);i=e;return}function OK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(dH(e)|0)>>2];i=d;return}function PK(a){a=a|0;var b=0;b=i;QK(a);i=b;return}function QK(a){a=a|0;var b=0;b=i;gH(a);i=b;return}function RK(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=RL(h)|0;BE(e);if((a|0)==0){j=cL(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(yE(0,d,a)|0){m=l;j=c[m>>2]|0;BE(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(yE(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;BE(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function SK(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];PL(a,e);i=d;return}function TK(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=uL(d)|0;d=wL(n,1)|0;xL(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];vL(j,d,h);yL(0,xG((zL(j)|0)+16|0)|0,e);e=AL(j)|0;a[e+4|0]=1;BL(0,nL((zL(j)|0)+20|0)|0);a[e+5|0]=1;CL(m,j);UK(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];SK(b,g);VK(m);VK(j);i=f;return}function UK(a,b){a=a|0;b=b|0;var c=0;c=i;sL(a,b);i=c;return}function VK(a){a=a|0;var b=0;b=i;iL(a);i=b;return}function WK(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;BE(f);c[e>>2]=0;BE(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=bL(a)|0;b=c[c[e>>2]>>2]|0;BE(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(cL(a)|0)>>2]|0;lG(e,c[d>>2]|0);d=dL(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function XK(a){a=a|0;var b=0,d=0;b=i;d=c[($K(a)|0)>>2]|0;i=b;return d|0}function YK(a){a=a|0;var b=0,d=0;b=i;d=ZK(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function ZK(a){a=a|0;var b=0,c=0;b=i;c=_K(a)|0;i=b;return c|0}function _K(a){a=a|0;i=i;return a|0}function $K(a){a=a|0;var b=0,c=0;b=i;c=aL(a)|0;i=b;return c|0}function aL(a){a=a|0;i=i;return a|0}function bL(a){a=a|0;i=i;return a|0}function cL(a){a=a|0;var b=0,c=0;b=i;c=mE(gL(a+4|0)|0)|0;i=b;return c|0}function dL(a){a=a|0;var b=0,c=0;b=i;c=eL(a+8|0)|0;i=b;return c|0}function eL(a){a=a|0;var b=0,c=0;b=i;c=fL(a)|0;i=b;return c|0}function fL(a){a=a|0;i=i;return a|0}function gL(a){a=a|0;var b=0,c=0;b=i;c=hL(a)|0;i=b;return c|0}function hL(a){a=a|0;i=i;return a|0}function iL(a){a=a|0;var b=0;b=i;jL(a,0);i=b;return}function jL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=ZK(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}lL(kL(e)|0,f);i=d;return}function kL(a){a=a|0;var b=0,c=0;b=i;c=rL(a)|0;i=b;return c|0}function lL(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;mL(f,nL(d+20|0)|0)}if((d|0)==0){i=e;return}oL(c[b>>2]|0,d,1);i=e;return}function mL(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;qL(d,0,c);i=b;return}function nL(a){a=a|0;i=i;return a|0}function oL(a,b,c){a=a|0;b=b|0;c=c|0;c=i;pL(0,b,0);i=c;return}function pL(a,b,c){a=a|0;b=b|0;c=c|0;c=i;x1(b);i=c;return}function qL(a,b,c){a=a|0;b=b|0;c=c|0;b=i;zI(c);i=b;return}function rL(a){a=a|0;i=i;return a+4|0}function sL(a,b){a=a|0;b=b|0;var c=0;c=i;tL(a,b);i=c;return}function tL(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function uL(a){a=a|0;var b=0,c=0;b=i;c=NL(a+4|0)|0;i=b;return c|0}function vL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];FL(a,b,f);i=e;return}function wL(a,b){a=a|0;b=b|0;var c=0;a=i;c=EL(0,b,0)|0;i=a;return c|0}function xL(a,b){a=a|0;b=b|0;var c=0;c=i;DL(a,b);i=c;return}function yL(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function zL(a){a=a|0;var b=0,d=0;b=i;d=c[($K(a)|0)>>2]|0;i=b;return d|0}function AL(a){a=a|0;var b=0,c=0;b=i;c=kL(a)|0;i=b;return c|0}function BL(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}rI(b,a);i=a;return}function CL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;sL(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];SK(h,f);UK(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];SK(a,e);VK(h);i=d;return}function DL(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function EL(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=v1(b<<5)|0;i=c;return a|0}function FL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(HL(g)|0)>>2]|0;g=IL(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];GL(b,a,f);i=e;return}function GL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];JL(a,b,f);i=e;return}function HL(a){a=a|0;i=i;return a|0}function IL(a){a=a|0;i=i;return a|0}function JL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(LL(g)|0)>>2]|0;g=ML(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];KL(b,a,f);i=e;return}function KL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(LL(f)|0)>>2];f=ML(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function LL(a){a=a|0;i=i;return a|0}function ML(a){a=a|0;i=i;return a|0}function NL(a){a=a|0;var b=0,c=0;b=i;c=OL(a)|0;i=b;return c|0}function OL(a){a=a|0;i=i;return a|0}function PL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=YK(QL(b)|0)|0;h=ML(AL(QL(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];GL(g,a,e);i=d;return}function QL(a){a=a|0;i=i;return c[a>>2]|0}function RL(a){a=a|0;var b=0,d=0;b=i;d=c[(cL(a)|0)>>2]|0;i=b;return d|0}function SL(a,b){a=a|0;b=b|0;b=i;i=i+8|0;TL(a,b);i=b;return}function TL(a,b){a=a|0;b=b|0;b=i;UL(a,0);i=b;return}function UL(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;VL(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;WL(f,0,e);e=vK(b)|0;c[(XL(b)|0)>>2]=e;i=d;return}function VL(a){a=a|0;var b=0;b=i;_L(a);i=b;return}function WL(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;YL(b,c,f);i=e;return}function XL(a){a=a|0;i=i;return a|0}function YL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(dH(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;ZL(d,b,f);i=e;return}function ZL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(dH(e)|0)>>2];i=d;return}function _L(a){a=a|0;var b=0;b=i;$L(a);i=b;return}function $L(a){a=a|0;var b=0;b=i;gH(a);i=b;return}function aM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=CK(h)|0;BE(e);if((a|0)==0){j=vK(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(GI(0,d,a)|0){m=l;j=c[m>>2]|0;BE(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(GI(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;BE(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function bM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];YM(a,e);i=d;return}function cM(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=DM(d)|0;d=FM(n,1)|0;GM(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];EM(j,d,h);HM(0,PJ((IM(j)|0)+16|0)|0,e);e=JM(j)|0;a[e+4|0]=1;KM(0,uM((IM(j)|0)+28|0)|0);a[e+5|0]=1;LM(m,j);dM(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];bM(b,g);eM(m);eM(j);i=f;return}function dM(a,b){a=a|0;b=b|0;var c=0;c=i;BM(a,b);i=c;return}function eM(a){a=a|0;var b=0;b=i;pM(a);i=b;return}function fM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;BE(f);c[e>>2]=0;BE(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=XL(a)|0;b=c[c[e>>2]>>2]|0;BE(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(vK(a)|0)>>2]|0;lG(e,c[d>>2]|0);d=mM(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function gM(a){a=a|0;var b=0,d=0;b=i;d=c[(kM(a)|0)>>2]|0;i=b;return d|0}function hM(a){a=a|0;var b=0,d=0;b=i;d=iM(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function iM(a){a=a|0;var b=0,c=0;b=i;c=jM(a)|0;i=b;return c|0}function jM(a){a=a|0;i=i;return a|0}function kM(a){a=a|0;var b=0,c=0;b=i;c=lM(a)|0;i=b;return c|0}function lM(a){a=a|0;i=i;return a|0}function mM(a){a=a|0;var b=0,c=0;b=i;c=nM(a+8|0)|0;i=b;return c|0}function nM(a){a=a|0;var b=0,c=0;b=i;c=oM(a)|0;i=b;return c|0}function oM(a){a=a|0;i=i;return a|0}function pM(a){a=a|0;var b=0;b=i;qM(a,0);i=b;return}function qM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=iM(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}sM(rM(e)|0,f);i=d;return}function rM(a){a=a|0;var b=0,c=0;b=i;c=AM(a)|0;i=b;return c|0}function sM(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;tM(f,uM(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;vM(f,PJ(d+16|0)|0)}if((d|0)==0){i=e;return}wM(c[b>>2]|0,d,1);i=e;return}function tM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;zM(d,0,c);i=b;return}function uM(a){a=a|0;i=i;return a|0}function vM(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;yM(d,0,c);i=b;return}function wM(a,b,c){a=a|0;b=b|0;c=c|0;c=i;xM(0,b,0);i=c;return}function xM(a,b,c){a=a|0;b=b|0;c=c|0;c=i;x1(b);i=c;return}function yM(a,b,c){a=a|0;b=b|0;c=c|0;b=i;kT(c);i=b;return}function zM(a,b,c){a=a|0;b=b|0;c=c|0;b=i;kT(c);i=b;return}function AM(a){a=a|0;i=i;return a+4|0}function BM(a,b){a=a|0;b=b|0;var c=0;c=i;CM(a,b);i=c;return}function CM(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function DM(a){a=a|0;var b=0,c=0;b=i;c=WM(a+4|0)|0;i=b;return c|0}function EM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];OM(a,b,f);i=e;return}function FM(a,b){a=a|0;b=b|0;var c=0;a=i;c=NM(0,b,0)|0;i=a;return c|0}function GM(a,b){a=a|0;b=b|0;var c=0;c=i;MM(a,b);i=c;return}function HM(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}aT(b,c);i=a;return}function IM(a){a=a|0;var b=0,d=0;b=i;d=c[(kM(a)|0)>>2]|0;i=b;return d|0}function JM(a){a=a|0;var b=0,c=0;b=i;c=rM(a)|0;i=b;return c|0}function KM(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}_S(b);i=a;return}function LM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;BM(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];bM(h,f);dM(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];bM(a,e);eM(h);i=d;return}function MM(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function NM(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=v1(b*40|0)|0;i=c;return a|0}function OM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(QM(g)|0)>>2]|0;g=RM(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];PM(b,a,f);i=e;return}function PM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];SM(a,b,f);i=e;return}function QM(a){a=a|0;i=i;return a|0}function RM(a){a=a|0;i=i;return a|0}function SM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(UM(g)|0)>>2]|0;g=VM(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];TM(b,a,f);i=e;return}function TM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(UM(f)|0)>>2];f=VM(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function UM(a){a=a|0;i=i;return a|0}function VM(a){a=a|0;i=i;return a|0}function WM(a){a=a|0;var b=0,c=0;b=i;c=XM(a)|0;i=b;return c|0}function XM(a){a=a|0;i=i;return a|0}function YM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=hM(ZM(b)|0)|0;h=VM(JM(ZM(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];PM(g,a,e);i=d;return}function ZM(a){a=a|0;i=i;return c[a>>2]|0}function _M(a){a=a|0;var b=0;b=i;$M(a);i=b;return}function $M(a){a=a|0;var b=0;b=i;aN(a);i=b;return}function aN(a){a=a|0;var b=0;b=i;bN(a,CK(a)|0);i=b;return}function bN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;BE(d);if((b|0)==0){i=d;return}bN(a,c[b>>2]|0);bN(a,c[b+4>>2]|0);e=DM(a)|0;cN(e,dN(b+16|0)|0);wM(e,b,1);i=d;return}function cN(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;eN(d,0,c);i=b;return}function dN(a){a=a|0;i=i;return a|0}function eN(a,b,c){a=a|0;b=b|0;c=c|0;b=i;fN(c);i=b;return}function fN(a){a=a|0;var b=0;b=i;gN(a);i=b;return}function gN(a){a=a|0;var b=0;b=i;hN(a);i=b;return}function hN(a){a=a|0;var b=0;b=i;iN(a);i=b;return}function iN(a){a=a|0;var b=0;b=i;kT(a+12|0);kT(a);i=b;return}function jN(a){a=a|0;var b=0;b=i;kN(a+180|0);kN(a+168|0);kN(a+156|0);kN(a+144|0);kN(a+132|0);kN(a+120|0);kN(a+108|0);kN(a+96|0);kN(a+84|0);kN(a+72|0);kN(a+60|0);kN(a+48|0);kN(a+36|0);kN(a+24|0);zI(a+12|0);zI(a);i=b;return}function kN(a){a=a|0;var b=0;b=i;lN(a);i=b;return}function lN(a){a=a|0;var b=0;b=i;mN(a);i=b;return}function mN(a){a=a|0;var b=0;b=i;nN(a);i=b;return}function nN(a){a=a|0;var b=0;b=i;oN(a,RL(a)|0);i=b;return}function oN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;BE(d);if((b|0)==0){i=d;return}oN(a,c[b>>2]|0);oN(a,c[b+4>>2]|0);e=uL(a)|0;pN(e,qN(b+16|0)|0);oL(e,b,1);i=d;return}function pN(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;rN(d,0,c);i=b;return}function qN(a){a=a|0;i=i;return a|0}function rN(a,b,c){a=a|0;b=b|0;c=c|0;b=i;sN(c);i=b;return}function sN(a){a=a|0;var b=0;b=i;tN(a);i=b;return}function tN(a){a=a|0;var b=0;b=i;uN(a);i=b;return}function uN(a){a=a|0;var b=0;b=i;vN(a);i=b;return}function vN(a){a=a|0;var b=0;b=i;zI(a+4|0);i=b;return}function wN(a){a=a|0;var b=0;b=i;xN(a);i=b;return}function xN(a){a=a|0;var b=0;b=i;yN(a);i=b;return}function yN(a){a=a|0;var b=0;b=i;zN(a,mJ(a)|0);i=b;return}function zN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;BE(d);if((b|0)==0){i=d;return}zN(a,c[b>>2]|0);zN(a,c[b+4>>2]|0);e=WJ(a)|0;AN(e,$I(b+16|0)|0);QJ(e,b,1);i=d;return}function AN(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;BN(d,0,c);i=b;return}function BN(a,b,c){a=a|0;b=b|0;c=c|0;b=i;CN(c);i=b;return}function CN(a){a=a|0;var b=0;b=i;DN(a);i=b;return}function DN(a){a=a|0;var b=0;b=i;EN(a);i=b;return}function EN(a){a=a|0;var b=0;b=i;FN(a);i=b;return}function FN(a){a=a|0;var b=0;b=i;kT(a);i=b;return}function GN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;HN(a);JN(g,b);KN(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];IN(a,f,e);i=d;return a|0}function HN(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;bN(a,CK(a)|0);c[(mM(a)|0)>>2]=0;d=vK(a)|0;c[(XL(a)|0)>>2]=d;BE(b);c[d>>2]=0;i=b;return}function IN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;SN(h,a);if(!(TN(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];LN(j,g);o=VN(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];UN(l,a,f,o);WN(b)|0;}while(TN(b,d)|0);i=e;return}function JN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;QN(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];LN(a,e);i=d;return}function KN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;MN(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];LN(a,e);i=d;return}function LN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];PN(a,e);i=d;return}function MN(a,b){a=a|0;b=b|0;var c=0;c=i;NN(a,BI(b)|0);i=c;return}function NN(a,b){a=a|0;b=b|0;var c=0;c=i;ON(a,b);i=c;return}function ON(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function PN(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function QN(a,b){a=a|0;b=b|0;var d=0;d=i;NN(a,c[(RN(b)|0)>>2]|0);i=d;return}function RN(a){a=a|0;i=i;return a|0}function SN(a,b){a=a|0;b=b|0;var c=0;c=i;KN(a,b);i=c;return}function TN(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=aP(a,b)|0;i=c;return d|0}function UN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];cO(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];bO(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];sK(a,g);fN(l);i=f;return}function VN(a){a=a|0;var b=0,c=0;b=i;c=_N(a)|0;i=b;return c|0}function WN(a){a=a|0;var b=0;b=i;XN(a)|0;i=b;return a|0}function XN(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=YN(c[d>>2]|0)|0;i=b;return a|0}function YN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;BE(b);if((e|0)==0){e=a;while(1){a=pG(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=ZN(c[d>>2]|0)|0;i=b;return g|0}return 0}function ZN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;BE(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;BE(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function _N(a){a=a|0;var b=0,d=0;b=i;d=$N((c[a>>2]|0)+16|0)|0;i=b;return d|0}function $N(a){a=a|0;var b=0,c=0;b=i;c=aO(a)|0;i=b;return c|0}function aO(a){a=a|0;i=i;return a|0}function bO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=gO(b,h,j,e)|0;h=c[p>>2]|0;BE(l);if((h|0)!=0){q=h;uK(a,q);i=f;return}iO(o,b,e);jO(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];hO(m,g);kO(o);o=c[j>>2]|0;fM(b,o,p,lO(m)|0);p=mO(m)|0;kO(m);q=p;uK(a,q);i=f;return}function cO(a,b){a=a|0;b=b|0;var c=0;c=i;dO(a,b);i=c;return}function dO(a,b){a=a|0;b=b|0;var c=0;c=i;eO(a,b);i=c;return}function eO(a,b){a=a|0;b=b|0;var c=0;c=i;fO(a,b);i=c;return}function fO(a,b){a=a|0;b=b|0;var c=0;c=i;aT(a,b);aT(a+12|0,b+12|0);i=c;return}function gO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;tK(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];QO(l,k);do{if(!(PO(b,l)|0)){k=EK(a)|0;x=SO(b)|0;if(RO(k,e,x)|0){break}w=RO(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];WO(r,h,1,0);tK(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];QO(t,g);do{if(!(PO(r,t)|0)){if(RO(k,e,SO(r)|0)|0){break}y=VO(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;BE(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;TO(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];QO(o,j);do{if(!(PO(n,o)|0)){j=EK(a)|0;if(RO(j,SO(UO(n)|0)|0,e)|0){break}y=VO(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;BE(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function hO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];NO(a,e);i=d;return}function iO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=DM(d)|0;d=FM(n,1)|0;zO(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];yO(j,d,h);AO(0,dN((BO(j)|0)+16|0)|0,e);a[(CO(j)|0)+4|0]=1;DO(m,j);jO(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];hO(b,g);kO(m);kO(j);i=f;return}function jO(a,b){a=a|0;b=b|0;var c=0;c=i;wO(a,b);i=c;return}function kO(a){a=a|0;var b=0;b=i;rO(a);i=b;return}function lO(a){a=a|0;var b=0,d=0;b=i;d=c[(pO(a)|0)>>2]|0;i=b;return d|0}function mO(a){a=a|0;var b=0,d=0;b=i;d=nO(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function nO(a){a=a|0;var b=0,c=0;b=i;c=oO(a)|0;i=b;return c|0}function oO(a){a=a|0;i=i;return a|0}function pO(a){a=a|0;var b=0,c=0;b=i;c=qO(a)|0;i=b;return c|0}function qO(a){a=a|0;i=i;return a|0}function rO(a){a=a|0;var b=0;b=i;sO(a,0);i=b;return}function sO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=nO(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}uO(tO(e)|0,f);i=d;return}function tO(a){a=a|0;var b=0,c=0;b=i;c=vO(a)|0;i=b;return c|0}function uO(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;cN(f,dN(d+16|0)|0)}if((d|0)==0){i=e;return}wM(c[b>>2]|0,d,1);i=e;return}function vO(a){a=a|0;i=i;return a+4|0}function wO(a,b){a=a|0;b=b|0;var c=0;c=i;xO(a,b);i=c;return}function xO(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function yO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];HO(a,b,f);i=e;return}function zO(a,b){a=a|0;b=b|0;var c=0;c=i;GO(a,b);i=c;return}function AO(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}EO(b,c);i=a;return}function BO(a){a=a|0;var b=0,d=0;b=i;d=c[(pO(a)|0)>>2]|0;i=b;return d|0}function CO(a){a=a|0;var b=0,c=0;b=i;c=tO(a)|0;i=b;return c|0}function DO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;wO(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];hO(h,f);jO(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];hO(a,e);kO(h);i=d;return}function EO(a,b){a=a|0;b=b|0;var c=0;c=i;FO(a,b);i=c;return}function FO(a,b){a=a|0;b=b|0;var c=0;c=i;eO(a,b);i=c;return}function GO(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function HO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(QM(g)|0)>>2]|0;g=JO(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];IO(b,a,f);i=e;return}function IO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];KO(a,b,f);i=e;return}function JO(a){a=a|0;i=i;return a|0}function KO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(UM(g)|0)>>2]|0;g=MO(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];LO(b,a,f);i=e;return}function LO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(UM(f)|0)>>2];f=MO(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function MO(a){a=a|0;i=i;return a|0}function NO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=mO(OO(b)|0)|0;h=MO(CO(OO(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];IO(g,a,e);i=d;return}function OO(a){a=a|0;i=i;return c[a>>2]|0}function PO(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function QO(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];$O(a,e);i=d;return}function RO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=GI(0,b,c)|0;i=a;return d|0}function SO(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function TO(a,b){a=a|0;b=b|0;var d=0;d=i;uK(a,c[(XL(b)|0)>>2]|0);i=d;return}function UO(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=ZO(c[d>>2]|0)|0;i=b;return a|0}function VO(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=CK(a)|0;BE(e);if((h|0)==0){j=vK(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=EK(a)|0;a=h;while(1){h=a+16|0;if(RO(j,d,h)|0){l=a;m=c[l>>2]|0;BE(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(RO(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;BE(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function WO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;XO(b,d);c[a>>2]=c[b>>2];i=e;return}function XO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;YO(b,c,e);i=d;return}function YO(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{UO(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{XN(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function ZO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;BE(b);if((e|0)==0){e=a;while(1){a=pG(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=_O(c[d>>2]|0)|0;i=b;return g|0}return 0}function _O(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;BE(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;BE(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function $O(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function aP(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(PO(a,b)|0)^1;i=c;return d|0}function bP(a){a=a|0;var b=0;b=i;i=i+128|0;rI(a,b);rI(a+12|0,b+8|0);cP(a+24|0,b+16|0);cP(a+36|0,b+24|0);cP(a+48|0,b+32|0);cP(a+60|0,b+40|0);cP(a+72|0,b+48|0);cP(a+84|0,b+56|0);cP(a+96|0,b+64|0);cP(a+108|0,b+72|0);cP(a+120|0,b+80|0);cP(a+132|0,b+88|0);cP(a+144|0,b+96|0);cP(a+156|0,b+104|0);cP(a+168|0,b+112|0);cP(a+180|0,b+120|0);i=b;return}function cP(a,b){a=a|0;b=b|0;b=i;dP(a,0);i=b;return}function dP(a,b){a=a|0;b=b|0;b=i;i=i+8|0;eP(a,b);i=b;return}function eP(a,b){a=a|0;b=b|0;b=i;fP(a,0);i=b;return}function fP(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;gP(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;hP(f,0,e);e=cL(b)|0;c[(bL(b)|0)>>2]=e;i=d;return}function gP(a){a=a|0;var b=0;b=i;kP(a);i=b;return}function hP(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;iP(b,c,f);i=e;return}function iP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(dH(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;jP(d,b,f);i=e;return}function jP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(dH(e)|0)>>2];i=d;return}function kP(a){a=a|0;var b=0;b=i;lP(a);i=b;return}function lP(a){a=a|0;var b=0;b=i;gH(a);i=b;return}function mP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[123868>>2]|0;if((m|0)==0){n=0}else{o=v1(12)|0;eT(o,m);n=o}if((c[123784>>2]|0)!=0){c[16778]=1}if((n|0)==0){c[67124>>2]=1;c[67128>>2]=1;i=b;return}do{if((IT(n,114008,0)|0)==-1){aT(g,n);_S(h);o=c[16352]|0;m=(o|0)<28;while(1){p=IT(g,114016,0)|0;q=(p|0)!=-1;if(q){GT(j,g,0,p);lT(h,j)|0;kT(j);GT(k,g,p+1|0,-1);lT(g,k)|0;kT(k)}else{lT(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){eT(l,c[65824+(s<<2)>>2]|0);p=nP(h,l)|0;kT(l);if(p){c[67120+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){Iy(1,1,114024,f);if(m){v=o}else{w=67672;x=c[16918]|0;ae[x&255](1);y=HT(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=114064;E=D;Ky(0,E,a)}do{p=c[66992+(v<<2)>>2]|0;c[e>>2]=c[65824+(v<<2)>>2];c[e+4>>2]=p;Iy(1,0,114048,e);v=v+1|0;}while((v|0)<28);w=67672;x=c[16918]|0;ae[x&255](1);y=HT(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=114064;E=D;Ky(0,E,a)}else if((t|0)==20){Iy(1,1,114024,d);w=67672;x=c[16918]|0;ae[x&255](1);y=HT(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=114064;E=D;Ky(0,E,a)}else if((t|0)==23){kT(h);kT(g);break}}else{o=1;do{c[67120+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[67124>>2]=1;c[67128>>2]=1;if((c[67156>>2]|0)!=0){c[67216>>2]=1}if((c[67212>>2]|0)==1){c[67220>>2]=1}if((c[67192>>2]|0)!=0){c[67188>>2]=1}if((c[67200>>2]|0)!=0){c[67188>>2]=1}if((c[67152>>2]|0)!=0){c[67148>>2]=1}if((c[67196>>2]|0)!=0){c[67188>>2]=1}if((c[67144>>2]|0)!=0){c[67140>>2]=1}kT(n);x1(n);i=b;return}function nP(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=iT(b)|0;if((e|0)!=(iT(c)|0)){f=0;i=d;return f|0}g=jT(b)|0;h=jT(c)|0;if(bT(b)|0){f=(II(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function oP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[123876>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=v1(12)|0;l=k;eT(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(pP(l,c[99104+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=HT(l)|0;Iy(1,1,114096,g);g=c[99188>>2]|0;c[f>>2]=c[99108>>2];c[f+4>>2]=g;Iy(1,0,114048,f);f=c[99192>>2]|0;c[e>>2]=c[99112>>2];c[e+4>>2]=f;Iy(1,0,114048,e);e=c[99196>>2]|0;c[d>>2]=c[99116>>2];c[d+4>>2]=e;Iy(1,0,114048,d);ae[c[16918]&255](1);Ky(0,114152,a)}else if((n|0)==6){i=b;return j|0}return 0}function pP(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(KT(a,b)|0)==0;i=c;return d|0}function qP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[123860>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=v1(12)|0;l=k;eT(l,h);if((k|0)==0){j=1;i=b;return j|0}eT(f,114176);k=nP(l,f)|0;kT(f);if(k){j=1;i=b;return j|0}eT(g,114184);k=nP(l,g)|0;kT(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=HT(l)|0;Iy(1,1,114192,e);c[d>>2]=114176;c[d+4>>2]=114248;Iy(1,0,114048,d);c[a>>2]=114184;c[a+4>>2]=114264;Iy(1,0,114048,a);ae[c[16918]&255](1);Ky(0,114152,b)}return 0}function rP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;tV(f,a);if(!(wV(f)|0)){uV(f);i=d;return a|0}j=QI(b)|0;FP(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((FE(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=eU(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];IP(h,e,b,m,k,l,n);if(!(GP(h)|0)){uV(f);i=d;return a|0}_T(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);uV(f);i=d;return a|0}function sP(a){a=a|0;var b=0;b=i;zV(a,fU(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;gV(a)|0;i=b;return a|0}function tP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;eT(h,d);VT(k,114272,h);bI(j,k,114280);kT(k);k=HT(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((P1(c[n+4>>2]|0,114288)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((P1(k,114296)|0)==0){kT(j);kT(h);i=f;return}d=x0(g,k,1)|0;if((d|0)!=0){m=l;X1(m|0,0,2048)|0;K0(d,g,m,2048)|0;xV(rP(rP(rP(rP(rP(136264,114304)|0,k)|0,114344)|0,m)|0,114360)|0,103)|0;kT(j);kT(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(L0(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==1){r=(L0(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==0){q=(L0(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){l=b+4|0;p=o;o=0;while(1){d=c[l>>2]|0;if((a[d+(o*60|0)+56|0]|0)==0){m=(L0(g,c[d+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(o*60|0)+56|0]=m;s=c[k>>2]|0}else{s=p}m=o+1|0;if((m|0)<(s|0)){p=s;o=m}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;p=b+4|0;k=(e|0)==0;l=b+20|0;m=0;do{d=c[s>>2]|0;do{if((a[d+(m*52|0)+48|0]|0)==0){n=a[d+(m*52|0)+8|0]|0;if(n<<24>>24==0){q=(L0(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(m*52|0)+48|0]|0)!=0){break}a[(c[p>>2]|0)+((c[q+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(L0(g,c[d+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(m*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|k){break}a[(c[l>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[o>>2]|0))}o=b+120|0;m=c[o>>2]|0;if((m|0)>0){l=b+8|0;k=m;m=0;while(1){s=c[l>>2]|0;if((a[s+(m*48|0)+44|0]|0)==0){p=(L0(g,c[s+(m*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[l>>2]|0)+(m*48|0)+44|0]=p;t=c[o>>2]|0}else{t=k}p=m+1|0;if((p|0)<(t|0)){k=t;m=p}else{break}}}m=b+216|0;if((c[m>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;l=b+24|0;p=0;do{s=c[t>>2]|0;do{if((a[s+(p*52|0)+48|0]|0)==0){d=a[s+(p*52|0)+8|0]|0;if(d<<24>>24==1){n=(L0(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(p*52|0)+48|0]|0)!=0|o){break}a[(c[l>>2]|0)+((c[n+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(d<<24>>24==0){d=(L0(g,c[s+(p*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(p*52|0)+48|0]=d;d=c[t>>2]|0;if((a[d+(p*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[d+(p*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);p=p+1|0;}while((p|0)<(c[m>>2]|0))}m=b+124|0;p=c[m>>2]|0;if((p|0)>0){k=b+12|0;t=p;p=0;while(1){l=c[k>>2]|0;if((a[l+(p*52|0)+48|0]|0)==0){o=(L0(g,c[l+(p*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[k>>2]|0)+(p*52|0)+48|0]=o;u=c[m>>2]|0}else{u=t}o=p+1|0;if((o|0)<(u|0)){t=u;p=o}else{break}}}p=b+220|0;if((c[p>>2]|0)>0){u=b+44|0;t=b+12|0;m=(e|0)==0;e=b+28|0;b=0;do{k=c[u>>2]|0;do{if((a[k+(b*52|0)+48|0]|0)==0){o=a[k+(b*52|0)+8|0]|0;if(o<<24>>24==0){l=(L0(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=l;l=c[u>>2]|0;if((a[l+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[l+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==1){o=(L0(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0|m){break}a[(c[e>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[p>>2]|0))}B0(g);kT(j);kT(h);i=f;return}function uP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[123724>>2]|0;H=c[123852>>2]|0;I=c[2]|0;if((c[67220>>2]|0)==0){if(!((c[123672>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;Gy(23,0,114408,l);l=c[123796>>2]|0;do{if((l|0)==0){M=0}else{if((P1(l,114432)|0)==0){M=1;break}if((P1(l,114440)|0)==0){M=0;break}if((P1(l,114448)|0)==0){M=2;break}c[j>>2]=l;Iy(1,0,114456,j);M=0}}while(0);if((Xz(M)|0)!=0){c[g>>2]=l;Iy(1,0,114528,g)}if((c[2]|0)!=0){EQ(d+56|0);aA((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);Yz(0);Yz(6);Zz(3);Zz(4);Zz(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+L1(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];Gy(1,0,114616,f)}do{if((c[123780>>2]|0)!=0){f=v1(12)|0;J=f;eT(J,c[123908>>2]|0);if((f|0)==0){break}f=HT(J)|0;c[d+280>>2]=f;c[e>>2]=f;Gy(23,0,114672,e)}}while(0);e=c[123904>>2]|0;_S(m);if((e|0)==0){eT(p,c[d+88>>2]|0);eT(q,114720);vP(o,p,q);bI(n,o,c[d+284>>2]|0);lT(m,n)|0;kT(n);kT(o);kT(q);kT(p)}else{mT(m,e)|0}eT(r,114728);eT(s,114728);eT(t,114728);eT(u,114728);eT(v,114728);eT(w,114728);e=c[123672>>2]|0;if((c[123692>>2]|0)!=0){mT(r,c[123820>>2]|0)|0}if((c[123708>>2]|0)!=0){mT(s,c[123836>>2]|0)|0}if((c[123688>>2]|0)!=0){mT(t,c[123816>>2]|0)|0}if((c[123696>>2]|0)==0){O=0.0}else{mT(u,c[123824>>2]|0)|0;O=+L1(HT(u)|0)}if((c[123700>>2]|0)==0){P=1}else{mT(v,c[123828>>2]|0)|0;P=Fc(HT(v)|0)|0}if((c[123760>>2]|0)!=0){mT(w,c[123888>>2]|0)|0}aT(x,m);aT(y,r);aT(z,s);aT(A,t);aT(B,w);p=wP(d,x,y,z,A,O,P,B,e)|0;kT(B);kT(A);kT(z);kT(y);kT(x);if((p|0)!=0|g^1){Q=p}else{Yz(5);p=VP(d)|0;$z(5);Gy(1,0,114736,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;kT(w);kT(v);kT(u);kT(t);kT(s);kT(r);kT(m);i=b;return R|0}Q=d+88|0;eT(D,c[Q>>2]|0);bI(C,D,114768);kT(D);eT(F,c[Q>>2]|0);bI(E,F,114784);kT(F);$z(0);F=c[123872>>2]|0;Q=HT(C)|0;D=HT(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;sQ(d,Q,D,(F|0)!=0?F:114800,I,p,HT(m)|0)|0;kT(E);kT(C);R=0;kT(w);kT(v);kT(u);kT(t);kT(s);kT(r);kT(m);i=b;return R|0}function vP(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;$S(a,d);e=iT(b)|0;f=iT(c)|0;LT(a,jT(b)|0,e,f+e|0);DT(a,jT(c)|0,f)|0;i=d;return}function wP(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((iT(j)|0)==0){u=0}else{u=HT(j)|0}aT(r,b);b=(xP(a,r,k)|0)==0;kT(r);if(!b){v=-1;i=l;return v|0}eT(s,114728);b=a+280|0;r=pP(s,c[b>>2]|0)|0;kT(s);do{if(r){w=3}else{s=1;k=0;do{eT(t,c[114944+(s<<2)>>2]|0);j=pP(t,c[b>>2]|0)|0;kT(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];Iy(1,0,115024,q);Iy(1,0,114024,p);s=1;do{j=c[115056+(s<<2)>>2]|0;c[o>>2]=c[114944+(s<<2)>>2];c[o+4>>2]=j;Iy(1,0,114048,o);s=s+1|0;}while((s|0)<20);Ky(c[a+536>>2]|0,114152,n)}}while(0);c[m>>2]=c[114944+(w<<2)>>2];Gy(23,0,115136,m);m=HT(d)|0;d=HT(e)|0;e=UC(a,m,d,HT(f)|0,g,h,w,u)|0;be[c[108388>>2]&127](108360,a);v=e;i=l;return v|0}function xP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[27090]=vd(HT(b)|0)|0;c[108364>>2]=g;c[108368>>2]=d;d=a+284|0;do{if((c[28500]|0)==0){g=c[d>>2]|0;if((P1(114808,g)|0)==0){h=0;break}if((P1(114816,g)|0)==0){c[108376>>2]=55;c[108380>>2]=56;c[108388>>2]=57;h=0;break}if((P1(114824,g)|0)==0){c[108376>>2]=58;c[108380>>2]=59;c[108384>>2]=60;c[108388>>2]=61;h=1;break}if((P1(114832,g)|0)==0){c[108376>>2]=62;c[108380>>2]=63;c[108384>>2]=64;c[108388>>2]=65;h=1;break}if((P1(114840,g)|0)==0){c[108376>>2]=66;c[108380>>2]=67;c[108388>>2]=68;h=0;break}g=rP(136264,114848)|0;xV(rP(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);tP(a+8|0,c[a+288>>2]|0,h);be[c[108376>>2]&127](108360,a);a=c[27090]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;Gy(23,0,114872,f);j=0;i=e;return j|0}function yP(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;xy();do{if((MQ(a,b)|0)==0){if((OQ(a,b)|0)!=0){break}do{if((c[123728>>2]|0)!=0){w=c[123856>>2]|0;if((P1(w,115256)|0)==0){Dy(1);break}if((P1(w,115264)|0)==0){Dy(0);break}else{c[p>>2]=w;Iy(1,0,115272,p);qd(0)|0;xd(0)}}}while(0);if((c[123684>>2]|0)==0){mP(0,0);TB(d);if((d|0)==0){xV(rP(136264,115640)|0,103)|0}c[d+300>>2]=oP(0,0)|0;c[d+292>>2]=qP(0,0)|0;_H(d+8|0,d+240|0);bC(d)|0;jC(d)|0;sC(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}xV(rP(136264,115704)|0,103)|0;x=1;i=e;return x|0}}while(0);c[28500]=c[123752>>2];x=0;i=e;return x|0}eT(u,c[123812>>2]|0);w=1;while(1){y=71912+(w<<2)|0;eT(v,c[y>>2]|0);z=nP(u,v)|0;kT(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=HT(u)|0;Iy(1,0,115544,g);c[f>>2]=c[b>>2];Iy(1,0,115584,f);qd(0)|0;xd(0)}A=c[75936+(w<<2)>>2]|0;do{if((A|0)==1){z=c[75808+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;Gy(1,1,115344,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[75808+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;Gy(1,1,115384,n);break}else{c[m>>2]=z;Iy(1,1,115224,m);break}}}while(0);if((w|0)==19){A=c[16352]|0;if((A|0)<28){D=A}else{E=67672;F=c[16918]|0;ae[F&255](1);G=qd(0)|0;xd(0)}do{A=c[66992+(D<<2)>>2]|0;c[l>>2]=c[65824+(D<<2)>>2];c[l+4>>2]=A;Gy(1,0,114048,l);D=D+1|0;}while((D|0)<28);E=67672;F=c[16918]|0;ae[F&255](1);G=qd(0)|0;xd(0)}else if((w|0)==7){A=1;do{z=c[115464+(A<<2)>>2]|0;c[k>>2]=c[115448+(A<<2)>>2];c[k+4>>2]=z;Gy(1,0,114048,k);A=A+1|0;}while((A|0)<4);E=67672;F=c[16918]|0;ae[F&255](1);G=qd(0)|0;xd(0)}else if((w|0)==11){A=1;do{z=c[115512+(A<<2)>>2]|0;c[j>>2]=c[115480+(A<<2)>>2];c[j+4>>2]=z;Gy(1,0,114048,j);A=A+1|0;}while((A|0)<7);E=67672;F=c[16918]|0;ae[F&255](1);G=qd(0)|0;xd(0)}else if((w|0)==29){A=1;do{z=c[115056+(A<<2)>>2]|0;c[h>>2]=c[114944+(A<<2)>>2];c[h+4>>2]=z;Gy(1,0,114048,h);A=A+1|0;}while((A|0)<20);E=67672;F=c[16918]|0;ae[F&255](1);G=qd(0)|0;xd(0)}else{E=67672;F=c[16918]|0;ae[F&255](1);G=qd(0)|0;xd(0)}}}while(0);c[t>>2]=c[b>>2];Gy(1,1,115160,t);t=1;do{b=c[75936+(t<<2)>>2]|0;do{if((b|0)==1){G=c[73816+(t<<2)>>2]|0;c[s>>2]=c[71912+(t<<2)>>2];c[s+4>>2]=G;Gy(1,0,115176,s)}else{G=c[71912+(t<<2)>>2]|0;if((b|0)==2){F=c[73816+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;Gy(1,0,115192,r);break}else{c[q>>2]=G;Iy(1,0,115224,q);break}}}while(0);t=t+1|0;}while((t|0)<31);ae[c[16918]&255](1);qd(0)|0;xd(0);return 0}function zP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[28934]|0;tb(117384)|0;c[l>>2]=c[m+88>>2];hc(115744,l|0)|0;tb(117400)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];hc(115768,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];hc(115808,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];hc(115840,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];hc(115872,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];hc(115904,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];hc(115936,b|0)|0;tb(117424)|0;i=a;return}function AP(a,b){a=a|0;b=+b;i=i;return}



function NE(a){a=a|0;var b=0,d=0;b=i;d=RE(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function OE(a){a=a|0;var b=0;b=i;PE(a);i=b;return}function PE(a){a=a|0;var b=0;b=i;QE(a,0);i=b;return}function QE(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=RE(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}de[c[(SE(e)|0)>>2]&127](f)|0;i=d;return}function RE(a){a=a|0;var b=0,c=0;b=i;c=UE(a)|0;i=b;return c|0}function SE(a){a=a|0;var b=0,c=0;b=i;c=TE(a)|0;i=b;return c|0}function TE(a){a=a|0;i=i;return a+4|0}function UE(a){a=a|0;i=i;return a|0}function VE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(XE(f)|0)>>2]|0;WE(a,d,c[(YE(g)|0)>>2]|0);i=e;return}function WE(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;ZE(a,b,c);i=d;return}function XE(a){a=a|0;i=i;return a|0}function YE(a){a=a|0;i=i;return a|0}function ZE(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[($E(f)|0)>>2]|0;_E(a,d,c[(aF(g)|0)>>2]|0);i=e;return}function _E(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[($E(f)|0)>>2];c[a+4>>2]=c[(aF(g)|0)>>2];i=e;return}function $E(a){a=a|0;i=i;return a|0}function aF(a){a=a|0;i=i;return a|0}function bF(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function cF(a){a=a|0;var b=0;b=i;dF(a+300|0);dF(a+288|0);dF(a+276|0);dF(a+264|0);dF(a+252|0);dF(a+240|0);eF(a);i=b;return}function dF(a){a=a|0;var b=0;b=i;QF(a);i=b;return}function eF(a){a=a|0;var b=0;b=i;fF(a,108944);cU(a+104|0);i=b;return}function fF(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];jF(a+4|0);i=d;return}function gF(a){a=a|0;var b=0;b=i;eF(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function hF(a){a=a|0;var b=0;b=i;eF(a);x1(a);i=b;return}function iF(a){a=a|0;var b=0;b=i;hF(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function jF(a){a=a|0;var b=0;b=i;kF(a);i=b;return}function kF(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=109072;LE(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}y1(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}y1(e)}}while(0);lU(b);i=d;return}function lF(a){a=a|0;var b=0;b=i;jF(a);x1(a);i=b;return}function mF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;de[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=OF(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=PF(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;vU(h,0,0,0);AU(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}y1(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=w1(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=w1(h)|0;a[b+97|0]=1;i=e;return}function nF(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;vU(e,0,0,0);AU(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}y1(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}y1(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=w1(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(LF(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=w1(o)|0;a[k]=1;i=f;return e|0}return 0}function oF(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ec(4)|0;W0(n);Od(n|0,156464,128)}n=HF(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((de[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){PD(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=k2(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Vc(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;PD(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];KF(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{PD(a,-1,-1);i=g;return}}}while(0);PD(a,-1,-1);i=g;return}function pF(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((de[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=bF(d)|0;if((Vc(j|0,k|0,0)|0)==0){JF(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{PD(a,-1,-1);i=e;return}}}while(0);PD(a,-1,-1);i=e;return}function qF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ec(4)|0;W0(m);Od(m|0,156464,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=HF(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=tU(s)|0;u=(fa(t-(sU(s)|0)|0,p)|0)+r|0;v=0;break}p=sU(s)|0;if((p|0)==(tU(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=IF(t,g,x,o,p-(rU(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=tU(w)|0;u=q-(sU(w)|0)|0;v=0}}while(0);if((Vc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;vU(b,0,0,0);c[m>>2]=0}else{q=b;y=xU(q)|0;do{if((y|0)!=(wU(q)|0)){if((se[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=GF(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((rc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((qd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function rF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=BF(b)|0;o=b;if((sU(o)|0)==0){p=e+1|0;vU(o,e,p,p)}if(n){q=0}else{n=tU(o)|0;c[f>>2]=(n-(rU(o)|0)|0)/2|0;c[g>>2]=4;q=c[(CF(f,g)|0)>>2]|0}g=sU(o)|0;do{if((g|0)==(tU(o)|0)){W1(rU(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=tU(o)|0;n=rU(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=rU(o)|0;vU(o,n,n+q|0,n+(p+q)|0);r=zF(a[sU(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;W1(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(CF(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ec(4)|0;W0(t);Od(t|0,156464,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=rU(o)|0;if((DF(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;vU(o,f,f,c[s>>2]|0);r=zF(a[sU(o)|0]|0)|0;break}s=c[k>>2]|0;f=rU(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}vU(o,f,p,s);r=zF(a[sU(o)|0]|0)|0}else{r=zF(a[g]|0)|0}}while(0);if((rU(o)|0)!=(e|0)){m=r;i=d;return m|0}vU(o,0,0,0);m=r;i=d;return m|0}function sF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=rU(g)|0;j=sU(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(vF(d,-1)|0){uU(g,-1);f=yF(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=wF(d)|0;do{if(h){if(AF(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);uU(g,-1);a[sU(g)|0]=b;f=d;i=e;return f|0}function tF(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}uF(b);l=b;m=wU(l)|0;n=yU(l)|0;if(!(vF(d,-1)|0)){if((xU(l)|0)==0){AU(l,f,f+1|0)}f=wF(d)|0;a[xU(l)|0]=f;zU(l,1)}f=xU(l)|0;o=wU(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ec(4)|0;u=t;W0(u);v=156464;w=128;Od(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=wU(l)|0;A=xU(l)|0;B=xF(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=wU(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((rc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;AU(l,B,xU(l)|0);B=yU(l)|0;zU(l,B-(wU(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ec(4)|0;u=t;W0(u);v=156464;w=128;Od(t|0,v|0,w|0)}else if((D|0)==14){q=(xU(l)|0)-C|0;if((rc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((rc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);AU(l,m,n)}k=yF(d)|0;i=e;return k|0}function uF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;vU(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;AU(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;AU(f,h,h+(g+ -1)|0);break}}else{AU(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function vF(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function wF(a){a=a|0;i=i;return a&255|0}function xF(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Be[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function yF(a){a=a|0;var b=0,c=0;b=i;c=vF(a,-1)|0;i=b;return(c?0:a)|0}function zF(a){a=a|0;i=i;return a&255|0}function AF(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function BF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;AU(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;vU(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;vU(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function CF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=EF(b,c,e)|0;i=d;return g|0}function DF(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Be[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function EF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=FF(0,b,a)|0;i=c;return(d?b:a)|0}function FF(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function GF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=te[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function HF(a){a=a|0;var b=0,d=0;b=i;d=de[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function IF(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=te[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function JF(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function KF(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function LF(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=MF(b,c,e)|0;i=d;return g|0}function MF(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=NF(0,a,b)|0;i=c;return(d?b:a)|0}function NF(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function OF(a){a=a|0;var b=0,c=0;b=i;c=WZ(a,140968)|0;i=b;return c|0}function PF(a){a=a|0;var b=0,d=0;b=i;d=de[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function QF(a){a=a|0;var b=0;b=i;RF(a);i=b;return}function RF(a){a=a|0;var b=0;b=i;SF(a);i=b;return}function SF(a){a=a|0;var b=0;b=i;TF(a,uE(a)|0);i=b;return}function TF(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;BE(d);if((b|0)==0){i=d;return}TF(a,c[b>>2]|0);TF(a,c[b+4>>2]|0);VF(UF(a)|0,b,1);i=d;return}function UF(a){a=a|0;var b=0,c=0;b=i;c=XF(a+4|0)|0;i=b;return c|0}function VF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;WF(0,b,0);i=c;return}function WF(a,b,c){a=a|0;b=b|0;c=c|0;c=i;x1(b);i=c;return}function XF(a){a=a|0;var b=0,c=0;b=i;c=YF(a)|0;i=b;return c|0}function YF(a){a=a|0;i=i;return a|0}function ZF(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=_F(a,f,b)|0;l=c[k>>2]|0;BE(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}aG(j,a,b);bG(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];$F(g,e);cG(j);j=c[f>>2]|0;dG(a,j,k,eG(g)|0);k=fG(g)|0;cG(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function _F(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=uE(h)|0;BE(e);if((a|0)==0){j=lE(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(yE(0,d,a)|0){m=l;j=c[m>>2]|0;BE(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(yE(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;BE(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function $F(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];TG(a,e);i=d;return}function aG(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=UF(d)|0;d=CG(n,1)|0;DG(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];BG(j,d,h);EG(0,xG((FG(j)|0)+16|0)|0,e);e=GG(j)|0;a[e+4|0]=1;HG(0,wG((FG(j)|0)+20|0)|0);a[e+5|0]=1;IG(m,j);bG(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];$F(b,g);cG(m);cG(j);i=f;return}function bG(a,b){a=a|0;b=b|0;var c=0;c=i;zG(a,b);i=c;return}function cG(a){a=a|0;var b=0;b=i;sG(a);i=b;return}function dG(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;BE(f);c[e>>2]=0;BE(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=kG(a)|0;b=c[c[e>>2]>>2]|0;BE(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(lE(a)|0)>>2]|0;lG(e,c[d>>2]|0);d=mG(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function eG(a){a=a|0;var b=0,d=0;b=i;d=c[(iG(a)|0)>>2]|0;i=b;return d|0}function fG(a){a=a|0;var b=0,d=0;b=i;d=gG(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function gG(a){a=a|0;var b=0,c=0;b=i;c=hG(a)|0;i=b;return c|0}function hG(a){a=a|0;i=i;return a|0}function iG(a){a=a|0;var b=0,c=0;b=i;c=jG(a)|0;i=b;return c|0}function jG(a){a=a|0;i=i;return a|0}function kG(a){a=a|0;i=i;return a|0}function lG(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=pG(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;BE(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;BE(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(pG(j)|0){p=j}else{o=c[k>>2]|0;qG(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;rG(p);i=e;return}else if((l|0)==14){if(pG(j)|0){p=c[k>>2]|0;rG(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;qG(q);i=e;return}else if((l|0)==17){i=e;return}}function mG(a){a=a|0;var b=0,c=0;b=i;c=nG(a+8|0)|0;i=b;return c|0}function nG(a){a=a|0;var b=0,c=0;b=i;c=oG(a)|0;i=b;return c|0}function oG(a){a=a|0;i=i;return a|0}function pG(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function qG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;BE(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=pG(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function rG(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;BE(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=pG(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function sG(a){a=a|0;var b=0;b=i;tG(a,0);i=b;return}function tG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=gG(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}vG(uG(e)|0,f);i=d;return}function uG(a){a=a|0;var b=0,c=0;b=i;c=yG(a)|0;i=b;return c|0}function vG(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}VF(c[a>>2]|0,b,1);i=d;return}function wG(a){a=a|0;i=i;return a|0}function xG(a){a=a|0;i=i;return a|0}function yG(a){a=a|0;i=i;return a+4|0}function zG(a,b){a=a|0;b=b|0;var c=0;c=i;AG(a,b);i=c;return}function AG(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function BG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];LG(a,b,f);i=e;return}function CG(a,b){a=a|0;b=b|0;var c=0;a=i;c=KG(0,b,0)|0;i=a;return c|0}function DG(a,b){a=a|0;b=b|0;var c=0;c=i;JG(a,b);i=c;return}function EG(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function FG(a){a=a|0;var b=0,d=0;b=i;d=c[(iG(a)|0)>>2]|0;i=b;return d|0}function GG(a){a=a|0;var b=0,c=0;b=i;c=uG(a)|0;i=b;return c|0}function HG(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function IG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;zG(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];$F(h,f);bG(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];$F(a,e);cG(h);i=d;return}function JG(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function KG(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=v1(b*24|0)|0;i=c;return a|0}function LG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(NG(g)|0)>>2]|0;g=OG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];MG(b,a,f);i=e;return}function MG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];PG(a,b,f);i=e;return}function NG(a){a=a|0;i=i;return a|0}function OG(a){a=a|0;i=i;return a|0}function PG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(RG(g)|0)>>2]|0;g=SG(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];QG(b,a,f);i=e;return}function QG(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(RG(f)|0)>>2];f=SG(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function RG(a){a=a|0;i=i;return a|0}function SG(a){a=a|0;i=i;return a|0}function TG(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=fG(UG(b)|0)|0;h=SG(GG(UG(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];MG(g,a,e);i=d;return}function UG(a){a=a|0;i=i;return c[a>>2]|0}function VG(a){a=a|0;var b=0;b=i;i=i+48|0;WG(a);PD(a+184|0,0,0);PD(a+200|0,0,0);XG(a+240|0,b);XG(a+252|0,b+8|0);XG(a+264|0,b+16|0);XG(a+276|0,b+24|0);XG(a+288|0,b+32|0);XG(a+300|0,b+40|0);i=b;return}function WG(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;hU(d);e=a;c[e>>2]=108916;f=d;c[f>>2]=108936;d=a+4|0;oV(a,108948|0,d);c[e>>2]=108916;c[f>>2]=108936;iH(d);i=b;return}function XG(a,b){a=a|0;b=b|0;b=i;YG(a,0);i=b;return}function YG(a,b){a=a|0;b=b|0;b=i;i=i+8|0;ZG(a,b);i=b;return}function ZG(a,b){a=a|0;b=b|0;b=i;_G(a,0);i=b;return}function _G(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;$G(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;aH(f,0,e);e=lE(b)|0;c[(kG(b)|0)>>2]=e;i=d;return}function $G(a){a=a|0;var b=0;b=i;eH(a);i=b;return}function aH(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;bH(b,c,f);i=e;return}function bH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(dH(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;cH(d,b,f);i=e;return}function cH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(dH(e)|0)>>2];i=d;return}function dH(a){a=a|0;i=i;return a|0}function eH(a){a=a|0;var b=0;b=i;fH(a);i=b;return}function fH(a){a=a|0;var b=0;b=i;gH(a);i=b;return}function gH(a){a=a|0;var b=0;b=i;hH(a);i=b;return}function hH(a){a=a|0;c[a>>2]=0;i=i;return}function iH(a){a=a|0;var b=0;b=i;jH(a);i=b;return}function jH(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;qU(j);c[d>>2]=109072;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;BE(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;mU(g,j);l=kH(g)|0;UZ(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ge[r&63](d,0,4096)|0;i=e;return}mU(h,j);c[k>>2]=OF(h)|0;UZ(h);a[f]=(PF(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=ge[r&63](d,0,4096)|0;i=e;return}function kH(a){a=a|0;var b=0,c=0;b=i;c=VZ(a,140968)|0;i=b;return c|0}function lH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;Yz(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){mH(a,b,c[f>>2]|0,h);$z(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=s1(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;Ky(k,109344,e)}mH(a,b,l,h);$z(3);i=d;return}function mH(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;$z(0);k=+Tz(0);Yz(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function nH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=p1(24)|0;Yz(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;Jy(c[m>>2]|0,l>>>31^1,109400,f);f=b+8|0;b=c[a+8>>2]|0;l=oH(b,f)|0;c[g+20>>2]=l;l=oH(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=p1(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;Ky(k,109480,e)}else{c[h>>2]=0;c[a+12>>2]=g;$z(3);i=d;return}}function oH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function pH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;Yz(3);u=b;v=jc(c[u>>2]|0,109544)|0;if((v|0)==0){qH(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Rd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;Ky(w,109552,q)}rc(109608,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];sd(v|0,109656,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];sd(v|0,109680,o|0)|0;rc(109704,40,1,v|0)|0;rc(109752,11,1,v|0)|0;rc(109768,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];rH(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Nd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{rc(109784,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;rH(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Nd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];sd(v|0,109808,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;rH(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Nd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];sd(v|0,109808,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;rH(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Nd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];sd(v|0,109808,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;rH(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Nd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];sd(v|0,109808,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;rH(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Nd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];sd(v|0,109808,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;rH(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Nd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];sd(v|0,109808,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;rH(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Nd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}qH(t);if((Xc(v|0)|0)==0){q1(c[r>>2]|0);c[r>>2]=0;$z(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];Ky(e,109824,f)}}function qH(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}q1(a);c[d>>2]=0;i=b;return}function rH(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];sd(a|0,109872,f|0)|0;i=e;return}function sH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=v1(192)|0;X1(m|0,0,192)|0;tH(m);c[a+12>>2]=m;n=m;o=a;QD(n,c[o>>2]|0,36);if(XT(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];Ky(a,109912,g)}else{g=m;AV(g,109888,14)|0;BV(h,g);a=bF(h)|0;h=m+184|0;c[h>>2]=a;AV(g,109904,4)|0;uH(n,b+8|0);BV(j,g);b=bF(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;PD(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];CV(g,f)|0;vH(n,-4-m+b|0);b=c[j>>2]|0;PD(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];CV(g,e)|0;$z(3);i=d;return}}function tH(a){a=a|0;var b=0;b=i;OH(a);i=b;return}function uH(a,b){a=a|0;b=b|0;var c=0;c=i;xH(a,3);yH(a,110088);xH(a,0);yH(a,110096);xH(a,2);JH(a,b);KH(a,b);yH(a,110104);xH(a,0);i=c;return}function vH(a,b){a=a|0;b=b|0;var d=0;d=i;c[27520]=Cd(b|0)|0;AV(a,110080,4)|0;i=d;return}function wH(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;BV(l,q);r=bF(l)|0;vH(b,0);BV(m,q);l=bF(m)|0;xH(b,1);yH(b,109976);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;zH(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);AH(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{AH(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{BH(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{CH(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{yH(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}BV(n,q);u=bF(n)|0;n=U1(0,r|0,32)|0;PD(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];CV(q,k)|0;vH(b,u-l|0);PD(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];CV(q,j)|0;i=g;return}function xH(b,d){b=b|0;d=d|0;var e=0;e=i;a[110064]=-33;c[27518]=Cd(d|0)|0;d=b;AV(d,110064,1)|0;AV(d,110072,4)|0;i=e;return}function yH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Cd(T1(d|0)|0)|0;a[110056]=-37;g=b;AV(g,110056,1)|0;AV(g,f,4)|0;AV(g,d,T1(d|0)|0)|0;i=e;return}function zH(b,d){b=b|0;d=d|0;var e=0;e=i;a[110040]=-35;c[27512]=Cd(d|0)|0;d=b;AV(d,110040,1)|0;AV(d,110048,4)|0;i=e;return}function AH(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[110024]=-53;IH(c);e=b;AV(e,110024,1)|0;AV(e,110032,8)|0;i=d;return}function BH(b,d){b=b|0;d=d|0;var e=0;e=i;a[110008]=-46;c[27504]=Cd(d|0)|0;d=b;AV(d,110008,1)|0;AV(d,110016,4)|0;i=e;return}function CH(b,c){b=b|0;c=c|0;var d=0;d=i;a[11e4]=c?-61:-62;AV(b,11e4,1)|0;i=d;return}function DH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;wH(e,+h[f>>3],a,f);wH(e,+h[b+248>>3],a,f);i=d;return}function EH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;BV(j,p);o=bF(j)|0;vH(b,0);BV(k,p);j=bF(k)|0;xH(b,1);yH(b,109984);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;zH(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;AH(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{AH(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{BH(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{CH(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{yH(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}BV(l,p);s=bF(l)|0;l=U1(0,o|0,32)|0;PD(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];CV(p,g)|0;vH(b,s-j|0);PD(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];CV(p,f)|0;i=e;return}function FH(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;JD(a);Yz(3);if((a|0)!=0){GH(a);x1(a)}c[d>>2]=0;$z(3);i=b;return}function GH(a){a=a|0;var b=0;b=i;HH(a);i=b;return}function HH(a){a=a|0;var b=0;b=i;eF(a);i=b;return}function IH(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Cd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=110032;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[110032+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function JH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;yH(a,109976);xH(a,4);yH(a,110112);xH(a,0);yH(a,110120);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;zH(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);yH(a,110128);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{yH(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{yH(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{yH(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{yH(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=110216;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];LH(a,b,e);yH(a,110152);xH(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);MH(a,110128,110160);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;MH(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;MH(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;MH(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;MH(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function KH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;yH(a,109984);xH(a,4);yH(a,110112);xH(a,0);yH(a,110120);o=g+1+j+l+n|0;zH(a,o);yH(a,110128);if((c[f>>2]|0)>0){n=b;l=0;do{yH(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{yH(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{yH(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{yH(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=110136;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];LH(a,b,e);yH(a,110152);xH(a,o);MH(a,110128,110160);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;MH(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;MH(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;MH(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;MH(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function LH(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;yH(b,110184);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}xH(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?110128:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}NH(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?110128:w;if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}NH(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{s=k<<24>>24==2?110128:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=s}NH(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?110128:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}NH(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function MH(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;yH(a,b);xH(a,1);yH(a,110168);yH(a,c);i=d;return}function NH(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;yH(a,b);xH(a,d?2:1);yH(a,110192);yH(a,c);if(!d){i=e;return}yH(a,110200);yH(a,110208);i=e;return}function OH(a){a=a|0;var b=0;b=i;WG(a);i=b;return}function PH(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;eT(e,110232);aT(d,RH(a,e)|0);QH(d,b+4|0);kT(d);kT(e);eT(g,110240);aT(f,RH(a,g)|0);SH(f,b);kT(f);kT(g);eT(j,110256);aT(h,RH(a,j)|0);QH(h,b+8|0);kT(h);kT(j);eT(l,110272);aT(k,RH(a,l)|0);QH(k,b+12|0);kT(k);kT(l);eT(n,110288);aT(m,RH(a,n)|0);TH(m,b+16|0,0);kT(m);kT(n);eT(p,110304);aT(o,RH(a,p)|0);TH(o,b+20|0,0);kT(o);kT(p);eT(r,110320);aT(q,RH(a,r)|0);TH(q,b+24|0,0);kT(q);kT(r);eT(t,110328);aT(s,RH(a,t)|0);TH(s,b+28|0,0);kT(s);kT(t);eT(v,110344);aT(u,RH(a,v)|0);TH(u,b+32|0,0);kT(u);kT(v);i=c;return}function QH(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){Iy(22,0,113552,d);i=d;return}else{c[b>>2]=vd(HT(a)|0)|0;i=d;return}}function RH(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=aM(a,f,b)|0;l=c[k>>2]|0;BE(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}cM(j,a,b);dM(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];bM(g,e);eM(j);j=c[f>>2]|0;fM(a,j,k,gM(g)|0);k=hM(g)|0;eM(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function SH(a,b){a=a|0;b=b|0;var d=0;d=i;if((KT(a,110520)|0)==0){c[b>>2]=1;i=d;return}if((KT(a,110528)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Fc(HT(a)|0)|0;i=d;return}}function TH(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((KT(a,110496)|0)==0){c[b>>2]=d}if((KT(a,110520)|0)==0){c[b>>2]=1;i=e;return}if((KT(a,110528)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Fc(HT(a)|0)|0;i=e;return}}function UH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;eT(j,110360);aT(g,RH(b,j)|0);y=d+48|0;VH(g,y);kT(g);kT(j);eT(m,110376);aT(l,RH(b,m)|0);j=d+56|0;WH(l,j,0.0);kT(l);kT(m);eT(o,110384);aT(n,RH(b,o)|0);m=d+32|0;VH(n,m);kT(n);kT(o);eT(q,110392);aT(p,RH(b,q)|0);o=d+33|0;VH(p,o);kT(p);kT(q);eT(s,110408);aT(r,RH(b,s)|0);q=d+40|0;WH(r,q,1.0);kT(r);kT(s);eT(u,110416);aT(t,RH(b,u)|0);s=d+16|0;WH(t,s,-1.7976931348623157e+308);kT(t);kT(u);eT(w,110424);aT(v,RH(b,w)|0);u=d+24|0;WH(v,u,1.7976931348623157e+308);kT(v);kT(w);eT(x,110232);w=HT(RH(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?110520:110528;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?110496:110504;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?110496:110512;c[f+20>>2]=j;c[f+24>>2]=m?110496:110504;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?110496:110512;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];Gy(4,0,110432,f);kT(x);i=e;return}function VH(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(KT(b,110520)|0)==0|0;i=d;return}function WH(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((KT(a,110496)|0)==0){h[b>>3]=c;i=d;return}if((KT(a,110520)|0)==0){h[b>>3]=1.0;i=d;return}if((KT(a,110528)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+L1(HT(a)|0);i=d;return}}function XH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;eT(h,110360);aT(g,RH(b,h)|0);s=d+13|0;VH(g,s);kT(g);kT(h);eT(k,110376);aT(j,RH(b,k)|0);h=d+16|0;TH(j,h,0);kT(j);kT(k);eT(m,110384);aT(l,RH(b,m)|0);k=d+12|0;VH(l,k);kT(l);kT(m);eT(o,110416);aT(n,RH(b,o)|0);m=d+4|0;TH(n,m,-2147483648);kT(n);kT(o);eT(q,110424);aT(p,RH(b,q)|0);o=d+8|0;TH(p,o,2147483647);kT(p);kT(q);eT(r,110232);q=HT(RH(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?110520:110528;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?110496:110504;c[f+8>>2]=s;c[f+12>>2]=b?110496:110512;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;Gy(4,0,110536,f);kT(r);i=e;return}function YH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;eT(h,110360);aT(g,RH(b,h)|0);o=d+5|0;VH(g,o);kT(g);kT(h);eT(k,110376);aT(j,RH(b,k)|0);h=d+6|0;VH(j,h);kT(j);kT(k);eT(m,110384);aT(l,RH(b,m)|0);k=d+4|0;VH(l,k);kT(l);kT(m);eT(n,110232);m=HT(RH(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?110520:110528;h=(a[k]|0)!=0?110520:110528;c[f>>2]=m;c[f+4>>2]=b?110496:110504;c[f+8>>2]=o;c[f+12>>2]=b?110496:110512;c[f+16>>2]=h;Gy(4,0,110592,f);kT(n);i=e;return}function ZH(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;eT(h,110360);aT(g,RH(b,h)|0);m=d+4|0;VH(g,m);kT(g);kT(h);eT(k,110376);aT(j,RH(b,k)|0);h=d+8|0;QH(j,h);kT(j);kT(k);eT(l,110232);k=HT(RH(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?110496:110504;c[f+8>>2]=m;c[f+12>>2]=b?110496:110512;Gy(4,0,110632,f);kT(l);i=e;return}function _H(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Yc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;$H(qa);_S(ra);aI(sa,ta);aI(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[123680>>2]|0)==0){eT(za,c[b+80>>2]|0);bI(ya,za,110656);lT(ra,ya)|0;kT(ya);kT(za)}else{mT(ra,c[123808>>2]|0)|0}ta=jc(HT(ra)|0,110672)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=HT(ra)|0;Ky(0,110680,pa)}else{Wc=0}}while(0);pa=Bt(0)|0;if((pa|0)==0){Xc(Wc|0)|0;Ky(0,110784,oa)}Mt(pa,Vc);Nt(pa,8,54);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;X1(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((Ot(pa,oa,za,ya&1)|0)==0){Yc=12;break}if(ya){Yc=14;break}}if((Yc|0)==12){Xc(Wc|0)|0;oa=HT(ra)|0;ya=Wt(Tt(pa)|0)|0;za=Ut(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;Iy(1,0,110864,na);It(pa);Ky(0,110952,ma)}else if((Yc|0)==14){Xc(Wc|0)|0;break}}else{if((Ot(pa,Vc,T1(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Wt(Tt(pa)|0)|0;ta=Ut(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;sd(za|0,110976,la|0)|0;za=c[va>>2]|0;ta=Wt(Tt(pa)|0)|0;oa=Ut(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;Iy(1,0,110992,ka);It(pa);Ky(0,110952,ja)}}while(0);ja=qa;eT(Ca,111080);fI(Ba,ja,Ca);gI(Da,ja);ka=eI(Ba,Da)|0;kT(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=HT(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;Iy(1,0,111088,ia)}else{eT(Ea,111080);Ba=P1(Da,HT(RH(ja,Ea)|0)|0)|0;kT(Ea);if((Ba|0)==0){break}It(pa);eT(Fa,111080);Ba=HT(RH(ja,Fa)|0)|0;va=HT(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;Iy(1,0,111136,ha);kT(Fa);Ky(0,110952,ga)}}while(0);hI(qa,b,c[123892>>2]|0,c[123896>>2]|0);Gy(23,1,111232,fa);fa=qa+12|0;eT(Ha,111272);aT(Ga,RH(fa,Ha)|0);ga=d;WH(Ga,ga,0.0);kT(Ga);kT(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];Gy(23,0,111288,ea);eT(Ja,111304);aT(Ia,RH(fa,Ja)|0);ea=d+8|0;WH(Ia,ea,1.0);kT(Ia);kT(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];Gy(23,0,111320,da);eT(La,111336);aT(Ka,RH(fa,La)|0);da=d+24|0;WH(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);kT(Ka);kT(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];Gy(23,0,111352,ca);eT(Na,111368);aT(Ma,RH(fa,Na)|0);ca=d+32|0;WH(Ma,ca,1.0e-5);kT(Ma);kT(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];Gy(23,0,111384,ba);eT(Pa,111400);aT(Oa,RH(fa,Pa)|0);ba=d+40|0;QH(Oa,ba);kT(Oa);kT(Pa);c[aa>>2]=c[ba>>2];Gy(23,0,111408,aa);eT(Ra,111432);aT(Qa,RH(fa,Ra)|0);aa=d+44|0;QH(Qa,aa);kT(Qa);kT(Ra);c[$>>2]=c[aa>>2];Gy(23,0,111448,$);eT(Ta,111472);aT(Sa,RH(fa,Ta)|0);fa=d+48|0;QH(Sa,fa);kT(Sa);kT(Ta);c[_>>2]=c[fa>>2];Gy(23,0,111488,_);eT(Va,111512);aT(Ua,RH(ja,Va)|0);_=d+268|0;QH(Ua,_);kT(Ua);kT(Va);c[Z>>2]=c[_>>2];Gy(23,0,111536,Z);if((c[67212>>2]|0)!=0){ae[c[16918]&255](23)}eT(eb,111560);aT(db,RH(ja,eb)|0);TH(db,Wa,0);kT(db);kT(eb);eT(gb,111592);aT(fb,RH(ja,gb)|0);TH(fb,Xa,0);kT(fb);kT(gb);eT(ib,111624);aT(hb,RH(ja,ib)|0);TH(hb,Ya,0);kT(hb);kT(ib);eT(kb,111648);aT(jb,RH(ja,kb)|0);TH(jb,_a,0);kT(jb);kT(kb);eT(mb,111680);aT(lb,RH(ja,mb)|0);TH(lb,Za,0);kT(lb);kT(mb);eT(ob,111720);aT(nb,RH(ja,ob)|0);TH(nb,ab,0);kT(nb);kT(ob);eT(qb,111752);aT(pb,RH(ja,qb)|0);TH(pb,$a,0);kT(pb);kT(qb);eT(tb,111792);aT(rb,RH(ja,tb)|0);TH(rb,cb,0);kT(rb);kT(tb);eT(vb,111824);aT(ub,RH(ja,vb)|0);TH(ub,bb,0);kT(ub);kT(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=112368;Gy(4,1,112344,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=iI(lb,wb)|0;PH(ib,jb+(kb*112|0)|0);UH(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(xb,112384);jb=(KT(RH(ib,xb)|0,110520)|0)==0;kT(xb);if(!jb){break}c[N>>2]=c[hb>>2];Gy(4,0,112400,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);eT(yb,c[hb>>2]|0);c[(jI(sa,yb)|0)>>2]=kb;kT(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[M>>2]=112432;Gy(4,1,112344,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=iI(lb,zb)|0;PH(fb,gb+(jb*112|0)|0);UH(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Ab,112384);gb=(KT(RH(fb,Ab)|0,110520)|0)==0;kT(Ab);if(!gb){break}c[L>>2]=c[eb>>2];Gy(4,0,112400,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);eT(Bb,c[eb>>2]|0);c[(jI(sa,Bb)|0)>>2]=jb;kT(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[K>>2]=112456;Gy(4,1,112344,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=iI(mb,Cb)|0;PH(gb,hb+(fb*112|0)|0);UH(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Db,112384);hb=(KT(RH(gb,Db)|0,110520)|0)==0;kT(Db);if(!hb){break}c[J>>2]=c[db>>2];Gy(4,0,112400,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);eT(Eb,c[db>>2]|0);c[(jI(sa,Eb)|0)>>2]=fb;kT(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[I>>2]=112472;Gy(4,1,112344,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=iI(ub,Fb)|0;PH(mb,kb+(ib*60|0)|0);XH(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Gb,112384);kb=(KT(RH(mb,Gb)|0,110520)|0)==0;kT(Gb);if(!kb){break}c[H>>2]=c[gb>>2];Gy(4,0,112400,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);eT(Hb,c[gb>>2]|0);c[(jI(sa,Hb)|0)>>2]=ib;kT(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[G>>2]=112496;Gy(4,1,112344,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=iI(ib,Ib)|0;PH(mb,ub+(lb*48|0)|0);YH(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Jb,112384);ub=(KT(RH(mb,Jb)|0,110520)|0)==0;kT(Jb);if(!ub){break}c[F>>2]=c[fb>>2];Gy(4,0,112400,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);eT(Kb,c[fb>>2]|0);c[(jI(sa,Kb)|0)>>2]=lb;kT(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[E>>2]=112520;Gy(4,1,112344,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=iI(lb,Lb)|0;PH(mb,ib+(rb*52|0)|0);ZH(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Mb,112384);ib=(KT(RH(mb,Mb)|0,110520)|0)==0;kT(Mb);if(!ib){break}c[D>>2]=c[gb>>2];Gy(4,0,112400,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);eT(Nb,c[gb>>2]|0);c[(jI(sa,Nb)|0)>>2]=rb;kT(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[C>>2]=112544;Gy(4,1,112344,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=iI(rb,Ob)|0;PH(mb,lb+(pb*112|0)|0);UH(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Pb,112384);lb=(KT(RH(mb,Pb)|0,110520)|0)==0;kT(Pb);if(!lb){break}c[B>>2]=c[fb>>2];Gy(4,0,112400,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);eT(Qb,c[fb>>2]|0);c[(jI(ua,Qb)|0)>>2]=pb;kT(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[A>>2]=112560;Gy(4,1,112344,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=iI(pb,Rb)|0;PH(mb,rb+(nb*60|0)|0);XH(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Sb,112384);rb=(KT(RH(mb,Sb)|0,110520)|0)==0;kT(Sb);if(!rb){break}c[z>>2]=c[gb>>2];Gy(4,0,112400,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);eT(Tb,c[gb>>2]|0);c[(jI(ua,Tb)|0)>>2]=nb;kT(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[y>>2]=112584;Gy(4,1,112344,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=iI(nb,Ub)|0;PH(mb,pb+(ja*48|0)|0);YH(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Vb,112384);pb=(KT(RH(mb,Vb)|0,110520)|0)==0;kT(Vb);if(!pb){break}c[x>>2]=c[fb>>2];Gy(4,0,112400,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);eT(Wb,c[fb>>2]|0);c[(jI(ua,Wb)|0)>>2]=ja;kT(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}c[w>>2]=112608;Gy(4,1,112344,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=iI(ja,Xb)|0;PH(mb,nb+(tb*52|0)|0);ZH(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[123676>>2]|0)!=0){break}eT(Yb,112384);nb=(KT(RH(mb,Yb)|0,110520)|0)==0;kT(Yb);if(!nb){break}c[v>>2]=c[gb>>2];Gy(4,0,112400,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);eT(Zb,c[gb>>2]|0);c[(jI(ua,Zb)|0)>>2]=tb;kT(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}Gy(4,1,112632,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=iI(tb,_b)|0;PH(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);_S($b);c[bc>>2]=ja;mb=iI(tb,bc)|0;eT(cc,112672);aT(ac,RH(mb,cc)|0);kI(ac,$b);kT(ac);kT(cc);mb=(KT($b,112680)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;Gy(4,0,112696,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=iI(tb,ec)|0;eT(fc,112736);aT(dc,RH(nb,fc)|0);kI(dc,$b);kT(dc);kT(fc);lI(wa,sa,$b);lI(xa,ua,$b);nI(gc,sa);do{if(mI(wa,gc)|0){nb=c[(oI(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{nI(hc,ua);if(mI(xa,hc)|0){fb=c[(oI(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((KT($b,112752)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);kT($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}VT(kc,112760,$b);bI(ic,kc,112784);kT(kc);c[s>>2]=HT(ic)|0;Ky(0,112800,s)}}while(0);if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}Gy(4,1,112808,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=iI(ja,lc)|0;PH(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);_S(mc);c[oc>>2]=tb;gb=iI(ja,oc)|0;eT(pc,112672);aT(nc,RH(gb,pc)|0);kI(nc,mc);kT(nc);kT(pc);gb=(KT(mc,112680)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;Gy(4,0,112696,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=iI(ja,rc)|0;eT(sc,112736);aT(qc,RH(fb,sc)|0);kI(qc,mc);kT(qc);kT(sc);lI(wa,sa,mc);lI(xa,ua,mc);nI(tc,sa);if(mI(wa,tc)|0){fb=c[(oI(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{nI(uc,ua);if(!(mI(xa,uc)|0)){break}nb=c[(oI(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}kT(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}VT(wc,112848,mc);bI(vc,wc,112784);kT(wc);c[o>>2]=HT(vc)|0;Ky(0,112800,o)}}while(0);if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}Gy(4,1,112872,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=iI(tb,xc)|0;PH(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);_S(yc);c[Ac>>2]=ja;fb=iI(tb,Ac)|0;eT(Bc,112672);aT(zc,RH(fb,Bc)|0);kI(zc,yc);kT(zc);kT(Bc);fb=(KT(yc,112680)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;Gy(4,0,112696,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=iI(tb,Dc)|0;eT(Ec,112736);aT(Cc,RH(gb,Ec)|0);kI(Cc,yc);kT(Cc);kT(Ec);lI(wa,sa,yc);lI(xa,ua,yc);nI(Fc,sa);if(mI(wa,Fc)|0){gb=c[(oI(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{nI(Gc,ua);if(!(mI(xa,Gc)|0)){break}nb=c[(oI(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}kT(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}VT(Ic,112912,yc);bI(Hc,Ic,112784);kT(Ic);c[l>>2]=HT(Hc)|0;Ky(0,112800,l)}}while(0);if((c[67136>>2]|0)!=0){ae[c[16918]&255](4)}Gy(4,1,112936,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=iI(ja,Jc)|0;PH(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);_S(Kc);c[Mc>>2]=tb;gb=iI(ja,Mc)|0;eT(Nc,112672);aT(Lc,RH(gb,Nc)|0);kI(Lc,Kc);kT(Lc);kT(Nc);gb=(KT(Kc,112680)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;Gy(4,0,112696,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=iI(ja,Pc)|0;eT(Qc,112736);aT(Oc,RH(fb,Qc)|0);kI(Oc,Kc);kT(Oc);kT(Qc);lI(wa,sa,Kc);lI(xa,ua,Kc);nI(Rc,sa);if(mI(wa,Rc)|0){fb=c[(oI(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{nI(Sc,ua);if(!(mI(xa,Sc)|0)){break}nb=c[(oI(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}kT(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}VT(Uc,112976,Kc);bI(Tc,Uc,112784);kT(Uc);c[f>>2]=HT(Tc)|0;Ky(0,112800,f)}}while(0);if((c[67136>>2]|0)==0){It(pa);pI(ua);pI(sa);kT(ra);qI(qa);i=e;return}ae[c[16918]&255](4);It(pa);pI(ua);pI(sa);kT(ra);qI(qa);i=e;return}}while(0);if((c[67208>>2]|c[16778]|0)==0){It(pa);Zc=qd(0)|0;xd(-1)}Iy(22,1,111864,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;Iy(22,0,111912,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;Iy(22,0,111960,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;Iy(22,0,112008,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;Iy(22,0,112056,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;Iy(22,0,112104,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;Iy(22,0,112152,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;Iy(22,0,112200,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;Iy(22,0,112248,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;Iy(22,0,112296,P);ae[c[16918]&255](22);It(pa);Zc=qd(0)|0;xd(-1)}function $H(a){a=a|0;var b=0;b=i;bP(a);i=b;return}function aI(a,b){a=a|0;b=b|0;b=i;IK(a,0);i=b;return}function bI(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;$S(a,d);e=iT(b)|0;f=QI(c)|0;LT(a,jT(b)|0,e,f+e|0);DT(a,c,f)|0;i=d;return}function cI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((P1(b,113608)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{eT(g,v);w=RH(u,g)|0;mT(w,c[d+((t|1)<<2)>>2]|0)|0;kT(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((P1(b,113632)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{eT(h,g);u=RH(t,h)|0;mT(u,c[d+((v|1)<<2)>>2]|0)|0;kT(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((P1(b,113656)|0)!=0){do{if((P1(b,113912)|0)!=0){if((P1(b,113920)|0)==0){break}if((P1(b,113928)|0)==0){break}if((P1(b,113936)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=iI(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){eT(r,c[t>>2]|0);w=RH(g,r)|0;mT(w,c[d+((u|1)<<2)>>2]|0)|0;kT(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=iI(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}eT(s,113944);mT(RH(x,s)|0,b)|0;kT(s);i=e;return}rI(j,k);_S(l);_S(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{eT(n,g);t=RH(j,n)|0;mT(t,c[d+((x|1)<<2)>>2]|0)|0;kT(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}eT(o,113672);lT(l,RH(j,o)|0)|0;kT(o);eT(p,113688);lT(m,RH(j,p)|0)|0;kT(p);c[k>>2]=Fc(HT(l)|0)|0;if((KT(m,113704)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((KT(m,113712)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((KT(m,113720)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((KT(m,113728)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((KT(m,113736)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((KT(m,113744)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((KT(m,113752)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((KT(m,113760)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((KT(m,113768)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((KT(m,113776)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((KT(m,113784)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((KT(m,113792)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((KT(m,113800)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((KT(m,113808)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=HT(m)|0;eT(q,110232);N=HT(RH(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;Jy(0,(O|0)!=0|0,113816,f);kT(q);GN(iI(c[b>>2]|0,s)|0,j)|0;kT(m);kT(l);zI(j);i=e;return}function dI(a,b){a=a|0;b=b|0;i=i;return}function eI(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rK(a,b)|0;i=c;return d|0}function fI(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;AK(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];sK(a,f);i=e;return}function gI(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;tK(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];sK(a,e);i=d;return}



function yh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0,qd=0,rd=0,sd=0,td=0,ud=0,vd=0,wd=0,xd=0,yd=0,zd=0,Ad=0,Bd=0,Cd=0,Dd=0,Ed=0,Fd=0,Gd=0,Hd=0,Id=0,Jd=0,Kd=0,Ld=0,Md=0,Nd=0,Od=0,Pd=0,Qd=0,Rd=0,Sd=0,Td=0,Ud=0,Vd=0,Wd=0,Xd=0,Yd=0,Zd=0,_d=0,$d=0,ae=0,be=0,ce=0,de=0,ee=0,fe=0,ge=0,he=0,ie=0,je=0,ke=0,le=0,me=0,ne=0,oe=0,pe=0,qe=0,re=0,se=0,te=0,ue=0,ve=0,we=0,xe=0,ye=0,ze=0,Ae=0.0,Be=0.0,Ce=0.0,Ee=0.0,Fe=0.0,Ge=0.0,He=0.0,Ie=0.0,Je=0.0,Ke=0.0,Le=0.0,Me=0.0,Ne=0.0,Oe=0.0,Pe=0.0,Qe=0.0,Re=0.0,Se=0.0,Te=0.0,Ue=0.0,Ve=0.0,We=0.0,Xe=0.0,Ye=0.0;f=i;i=i+80|0;g=f;j=f+24|0;k=f+48|0;l=f+72|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+8|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+8|0;zb=i;i=i+8|0;Ab=i;i=i+8|0;Bb=i;i=i+8|0;Cb=i;i=i+8|0;Db=i;i=i+8|0;Eb=i;i=i+8|0;Fb=i;i=i+8|0;Gb=i;i=i+8|0;Hb=i;i=i+8|0;Ib=i;i=i+8|0;Jb=i;i=i+8|0;Kb=i;i=i+8|0;Lb=i;i=i+8|0;Mb=i;i=i+8|0;Nb=i;i=i+8|0;Ob=i;i=i+8|0;Pb=i;i=i+8|0;Qb=i;i=i+8|0;Rb=i;i=i+8|0;Sb=i;i=i+8|0;Tb=i;i=i+8|0;Ub=i;i=i+8|0;Vb=i;i=i+8|0;Wb=i;i=i+8|0;Xb=i;i=i+8|0;Yb=i;i=i+8|0;Zb=i;i=i+8|0;_b=i;i=i+8|0;$b=i;i=i+8|0;ac=i;i=i+8|0;bc=i;i=i+8|0;cc=i;i=i+8|0;dc=i;i=i+8|0;ec=i;i=i+8|0;fc=i;i=i+8|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+8|0;jc=i;i=i+8|0;kc=i;i=i+8|0;lc=i;i=i+8|0;mc=i;i=i+8|0;nc=i;i=i+8|0;oc=i;i=i+8|0;pc=i;i=i+8|0;qc=i;i=i+8|0;rc=i;i=i+8|0;sc=i;i=i+8|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+8|0;wc=i;i=i+8|0;xc=i;i=i+8|0;yc=i;i=i+8|0;zc=i;i=i+8|0;Ac=i;i=i+8|0;Bc=i;i=i+8|0;Cc=i;i=i+8|0;Dc=i;i=i+8|0;Ec=i;i=i+8|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+8|0;Ic=i;i=i+8|0;Jc=i;i=i+8|0;Kc=i;i=i+8|0;Lc=i;i=i+8|0;Mc=i;i=i+8|0;Nc=i;i=i+8|0;Oc=i;i=i+8|0;Pc=i;i=i+8|0;Qc=i;i=i+8|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+8|0;Uc=i;i=i+8|0;Vc=i;i=i+8|0;Wc=i;i=i+8|0;Xc=i;i=i+8|0;Yc=i;i=i+8|0;Zc=i;i=i+8|0;_c=i;i=i+8|0;$c=i;i=i+8|0;ad=i;i=i+8|0;bd=i;i=i+8|0;cd=i;i=i+8|0;dd=i;i=i+8|0;ed=i;i=i+8|0;fd=i;i=i+8|0;gd=i;i=i+8|0;hd=i;i=i+8|0;id=i;i=i+8|0;jd=i;i=i+8|0;kd=i;i=i+8|0;ld=i;i=i+8|0;md=i;i=i+8|0;nd=i;i=i+8|0;od=i;i=i+8|0;pd=i;i=i+8|0;qd=i;i=i+8|0;rd=i;i=i+8|0;sd=i;i=i+8|0;td=i;i=i+8|0;ud=i;i=i+8|0;vd=i;i=i+8|0;wd=i;i=i+8|0;xd=i;i=i+8|0;yd=i;i=i+8|0;zd=i;i=i+8|0;Ad=i;i=i+8|0;Bd=i;i=i+8|0;Cd=i;i=i+8|0;Dd=i;i=i+8|0;Ed=i;i=i+8|0;Fd=i;i=i+8|0;Gd=i;i=i+8|0;Hd=i;i=i+8|0;Id=i;i=i+8|0;Jd=i;i=i+8|0;Kd=i;i=i+8|0;Ld=i;i=i+8|0;Md=i;i=i+8|0;Nd=i;i=i+8|0;Od=i;i=i+8|0;Pd=i;i=i+8|0;Qd=i;i=i+8|0;Rd=i;i=i+8|0;Sd=i;i=i+8|0;Td=i;i=i+8|0;Ud=i;i=i+8|0;Vd=i;i=i+8|0;Wd=i;i=i+8|0;Xd=i;i=i+8|0;Yd=i;i=i+8|0;Zd=i;i=i+8|0;_d=i;i=i+8|0;$d=i;i=i+8|0;ae=i;i=i+8|0;be=i;i=i+8|0;ce=i;i=i+8|0;de=i;i=i+8|0;ee=i;i=i+8|0;fe=i;i=i+8|0;ge=i;i=i+8|0;he=i;i=i+8|0;ie=i;i=i+8|0;je=i;i=i+8|0;ke=i;i=i+8|0;le=i;i=i+8|0;me=i;i=i+8|0;ne=i;i=i+8|0;oe=i;i=i+8|0;pe=i;i=i+8|0;qe=i;i=i+8|0;re=i;i=i+8|0;se=i;i=i+8|0;te=i;i=i+8|0;ue=i;i=i+8|0;ve=i;i=i+8|0;we=i;i=i+16|0;c[ve>>2]=45;Az(we,1,ve);if(!(d>611.657)){ve=lz(lz(8240,jz(d,0,1,6)|0)|0,5248)|0;xe=lz(lz(ve,jz(611.657,0,1,6)|0)|0,5256)|0;ve=c[28994]|0;ye=k;ze=8304;c[ye+0>>2]=c[ze+0>>2];c[ye+4>>2]=c[ze+4>>2];c[ye+8>>2]=c[ze+8>>2];c[ye+12>>2]=c[ze+12>>2];c[ye+16>>2]=c[ze+16>>2];c[ye+20>>2]=c[ze+20>>2];De[ve&31](b,k,xe,ue);}if(!(d<=1.0e8)){ue=lz(lz(8328,jz(d,0,1,6)|0)|0,7672)|0;xe=c[28994]|0;k=j;ve=8376;c[k+0>>2]=c[ve+0>>2];c[k+4>>2]=c[ve+4>>2];c[k+8>>2]=c[ve+8>>2];c[k+12>>2]=c[ve+12>>2];c[k+16>>2]=c[ve+16>>2];c[k+20>>2]=c[ve+20>>2];De[xe&31](b,j,ue,te);}if(!(e>=273.15)){te=lz(lz(8400,jz(e,0,1,6)|0)|0,7776)|0;ue=c[28994]|0;j=g;xe=8448;c[j+0>>2]=c[xe+0>>2];c[j+4>>2]=c[xe+4>>2];c[j+8>>2]=c[xe+8>>2];c[j+12>>2]=c[xe+12>>2];c[j+16>>2]=c[xe+16>>2];c[j+20>>2]=c[xe+20>>2];De[ue&31](b,g,te,se);}Ae=d/1653.0e4;Be=1386.0/e;Ce=7.1-Ae;Ee=Be+-1.222;c[re>>2]=1;h[(Fz(we,1,re)|0)>>3]=Ee*Ee;c[qe>>2]=1;Fe=+h[(Fz(we,1,qe)|0)>>3];c[pe>>2]=2;h[(Fz(we,1,pe)|0)>>3]=Fe*Fe;c[oe>>2]=2;Fe=+h[(Fz(we,1,oe)|0)>>3];c[ne>>2]=3;h[(Fz(we,1,ne)|0)>>3]=Fe*Fe;c[me>>2]=3;Fe=Ee*+h[(Fz(we,1,me)|0)>>3];c[le>>2]=4;h[(Fz(we,1,le)|0)>>3]=Fe;c[ke>>2]=4;Fe=1.0/+h[(Fz(we,1,ke)|0)>>3];c[je>>2]=5;h[(Fz(we,1,je)|0)>>3]=Fe;c[ie>>2]=1;Fe=+h[(Fz(we,1,ie)|0)>>3];c[he>>2]=2;Ge=Fe*+h[(Fz(we,1,he)|0)>>3];c[ge>>2]=6;h[(Fz(we,1,ge)|0)>>3]=Ge;c[fe>>2]=1;Ge=Ee*+h[(Fz(we,1,fe)|0)>>3];c[ee>>2]=7;h[(Fz(we,1,ee)|0)>>3]=Ge;c[de>>2]=7;Ge=1.0/+h[(Fz(we,1,de)|0)>>3];c[ce>>2]=8;h[(Fz(we,1,ce)|0)>>3]=Ge;c[be>>2]=1;Ge=+h[(Fz(we,1,be)|0)>>3];c[ae>>2]=2;Fe=+h[(Fz(we,1,ae)|0)>>3];c[$d>>2]=3;He=Ge*Fe*+h[(Fz(we,1,$d)|0)>>3];c[_d>>2]=9;h[(Fz(we,1,_d)|0)>>3]=He;c[Zd>>2]=2;He=1.0/+h[(Fz(we,1,Zd)|0)>>3];c[Yd>>2]=10;h[(Fz(we,1,Yd)|0)>>3]=He;c[Xd>>2]=2;He=Ee*+h[(Fz(we,1,Xd)|0)>>3];c[Wd>>2]=11;h[(Fz(we,1,Wd)|0)>>3]=He;c[Vd>>2]=11;He=1.0/+h[(Fz(we,1,Vd)|0)>>3];c[Ud>>2]=12;h[(Fz(we,1,Ud)|0)>>3]=He;c[Td>>2]=2;He=+h[(Fz(we,1,Td)|0)>>3];c[Sd>>2]=3;Fe=He*+h[(Fz(we,1,Sd)|0)>>3];c[Rd>>2]=13;h[(Fz(we,1,Rd)|0)>>3]=Fe;c[Qd>>2]=3;Fe=1.0/+h[(Fz(we,1,Qd)|0)>>3];c[Pd>>2]=14;h[(Fz(we,1,Pd)|0)>>3]=Fe;c[Od>>2]=15;h[(Fz(we,1,Od)|0)>>3]=Ce*Ce;c[Nd>>2]=15;Fe=Ce*+h[(Fz(we,1,Nd)|0)>>3];c[Md>>2]=16;h[(Fz(we,1,Md)|0)>>3]=Fe;c[Ld>>2]=15;Fe=+h[(Fz(we,1,Ld)|0)>>3];c[Kd>>2]=17;h[(Fz(we,1,Kd)|0)>>3]=Fe*Fe;c[Jd>>2]=17;Fe=+h[(Fz(we,1,Jd)|0)>>3];c[Id>>2]=18;h[(Fz(we,1,Id)|0)>>3]=Fe*Fe;c[Hd>>2]=17;Fe=+h[(Fz(we,1,Hd)|0)>>3];c[Gd>>2]=18;He=Fe*Ce*+h[(Fz(we,1,Gd)|0)>>3];c[Fd>>2]=19;h[(Fz(we,1,Fd)|0)>>3]=He;c[Ed>>2]=15;He=+h[(Fz(we,1,Ed)|0)>>3];c[Dd>>2]=17;Fe=He*+h[(Fz(we,1,Dd)|0)>>3];c[Cd>>2]=20;h[(Fz(we,1,Cd)|0)>>3]=Fe;c[Bd>>2]=3;Fe=+h[(Fz(we,1,Bd)|0)>>3];c[Ad>>2]=21;h[(Fz(we,1,Ad)|0)>>3]=Fe*Fe;c[zd>>2]=21;Fe=+h[(Fz(we,1,zd)|0)>>3];c[yd>>2]=22;h[(Fz(we,1,yd)|0)>>3]=Fe*Fe;c[xd>>2]=22;Fe=+h[(Fz(we,1,xd)|0)>>3];c[wd>>2]=3;He=Fe*Ee*+h[(Fz(we,1,wd)|0)>>3];c[vd>>2]=23;h[(Fz(we,1,vd)|0)>>3]=He;c[ud>>2]=23;He=1.0/+h[(Fz(we,1,ud)|0)>>3];c[td>>2]=24;h[(Fz(we,1,td)|0)>>3]=He;c[sd>>2]=22;He=+h[(Fz(we,1,sd)|0)>>3];c[rd>>2]=3;Fe=He*+h[(Fz(we,1,rd)|0)>>3];c[qd>>2]=25;h[(Fz(we,1,qd)|0)>>3]=Fe;c[pd>>2]=25;Fe=1.0/+h[(Fz(we,1,pd)|0)>>3];c[od>>2]=26;h[(Fz(we,1,od)|0)>>3]=Fe;c[nd>>2]=1;Fe=+h[(Fz(we,1,nd)|0)>>3];c[md>>2]=2;He=+h[(Fz(we,1,md)|0)>>3];c[ld>>2]=22;Ge=Fe*He*Ee*+h[(Fz(we,1,ld)|0)>>3];c[kd>>2]=27;h[(Fz(we,1,kd)|0)>>3]=Ge;c[jd>>2]=27;Ge=1.0/+h[(Fz(we,1,jd)|0)>>3];c[id>>2]=28;h[(Fz(we,1,id)|0)>>3]=Ge;c[hd>>2]=1;Ge=+h[(Fz(we,1,hd)|0)>>3];c[gd>>2]=2;He=+h[(Fz(we,1,gd)|0)>>3];c[fd>>2]=22;Fe=Ge*He*+h[(Fz(we,1,fd)|0)>>3];c[ed>>2]=29;h[(Fz(we,1,ed)|0)>>3]=Fe;c[dd>>2]=29;Fe=1.0/+h[(Fz(we,1,dd)|0)>>3];c[cd>>2]=30;h[(Fz(we,1,cd)|0)>>3]=Fe;c[bd>>2]=1;Fe=+h[(Fz(we,1,bd)|0)>>3];c[ad>>2]=2;He=+h[(Fz(we,1,ad)|0)>>3];c[$c>>2]=21;Ge=+h[(Fz(we,1,$c)|0)>>3];c[_c>>2]=3;Ie=Fe*He*Ge*Ee*+h[(Fz(we,1,_c)|0)>>3];c[Zc>>2]=31;h[(Fz(we,1,Zc)|0)>>3]=Ie;c[Yc>>2]=31;Ie=1.0/+h[(Fz(we,1,Yc)|0)>>3];c[Xc>>2]=32;h[(Fz(we,1,Xc)|0)>>3]=Ie;c[Wc>>2]=2;Ie=+h[(Fz(we,1,Wc)|0)>>3];c[Vc>>2]=21;Ge=+h[(Fz(we,1,Vc)|0)>>3];c[Uc>>2]=3;He=Ie*Ge*Ee*+h[(Fz(we,1,Uc)|0)>>3];c[Tc>>2]=33;h[(Fz(we,1,Tc)|0)>>3]=He;c[Sc>>2]=33;He=1.0/+h[(Fz(we,1,Sc)|0)>>3];c[Rc>>2]=34;h[(Fz(we,1,Rc)|0)>>3]=He;c[Qc>>2]=1;He=+h[(Fz(we,1,Qc)|0)>>3];c[Pc>>2]=3;Ge=He*Ee*+h[(Fz(we,1,Pc)|0)>>3];c[Oc>>2]=35;h[(Fz(we,1,Oc)|0)>>3]=Ge;c[Nc>>2]=35;Ge=1.0/+h[(Fz(we,1,Nc)|0)>>3];c[Mc>>2]=36;h[(Fz(we,1,Mc)|0)>>3]=Ge;c[Lc>>2]=1;Ge=+h[(Fz(we,1,Lc)|0)>>3];c[Kc>>2]=3;He=Ge*+h[(Fz(we,1,Kc)|0)>>3];c[Jc>>2]=37;h[(Fz(we,1,Jc)|0)>>3]=He;c[Ic>>2]=37;He=1.0/+h[(Fz(we,1,Ic)|0)>>3];c[Hc>>2]=38;h[(Fz(we,1,Hc)|0)>>3]=He;c[Gc>>2]=6;He=1.0/+h[(Fz(we,1,Gc)|0)>>3];c[Fc>>2]=39;h[(Fz(we,1,Fc)|0)>>3]=He;c[Ec>>2]=1;He=+h[(Fz(we,1,Ec)|0)>>3];c[Dc>>2]=22;Ge=+h[(Fz(we,1,Dc)|0)>>3];c[Cc>>2]=3;Ie=He*Ge*+h[(Fz(we,1,Cc)|0)>>3];c[Bc>>2]=40;h[(Fz(we,1,Bc)|0)>>3]=Ie;c[Ac>>2]=40;Ie=1.0/+h[(Fz(we,1,Ac)|0)>>3];c[zc>>2]=41;h[(Fz(we,1,zc)|0)>>3]=Ie;c[yc>>2]=22;Ie=1.0/+h[(Fz(we,1,yc)|0)>>3];c[xc>>2]=42;h[(Fz(we,1,xc)|0)>>3]=Ie;c[wc>>2]=1;Ie=+h[(Fz(we,1,wc)|0)>>3];c[vc>>2]=2;Ge=+h[(Fz(we,1,vc)|0)>>3];c[uc>>2]=21;He=+h[(Fz(we,1,uc)|0)>>3];c[tc>>2]=3;Fe=Ie*Ge*He*+h[(Fz(we,1,tc)|0)>>3];c[sc>>2]=43;h[(Fz(we,1,sc)|0)>>3]=Fe;c[rc>>2]=43;Fe=1.0/+h[(Fz(we,1,rc)|0)>>3];c[qc>>2]=44;h[(Fz(we,1,qc)|0)>>3]=Fe;c[pc>>2]=13;Fe=1.0/+h[(Fz(we,1,pc)|0)>>3];c[oc>>2]=45;h[(Fz(we,1,oc)|0)>>3]=Fe;c[nc>>2]=10;Fe=+h[(Fz(we,1,nc)|0)>>3];c[mc>>2]=2;He=+h[(Fz(we,1,mc)|0)>>3];c[lc>>2]=6;Ge=Fe*(He*(+h[(Fz(we,1,lc)|0)>>3]*-8.5205128120103e-10+-28270797985312.0e-19)+-31679644845054.0e-18);c[kc>>2]=12;He=+h[(Fz(we,1,kc)|0)>>3];c[jc>>2]=13;Fe=+h[(Fz(we,1,jc)|0)>>3]*-1.4341729937924e-13+-6.5171222895601e-7;c[ic>>2]=7;Ie=He*(Fe*+h[(Fz(we,1,ic)|0)>>3]+-22425281908.0e-16);c[hc>>2]=14;Fe=+h[(Fz(we,1,hc)|0)>>3]*-4.0516996860117e-7;c[gc>>2]=16;He=+h[(Fz(we,1,gc)|0)>>3];c[fc>>2]=11;Je=+h[(Fz(we,1,fc)|0)>>3]*-1.7424871230634e-10+-1.2734301741641e-9;c[ec>>2]=36;Ke=Je*+h[(Fz(we,1,ec)|0)>>3];c[dc>>2]=19;Je=+h[(Fz(we,1,dc)|0)>>3];c[cc>>2]=34;Le=+h[(Fz(we,1,cc)|0)>>3]*-6.8762131295531e-19;c[bc>>2]=15;Me=+h[(Fz(we,1,bc)|0)>>3];c[ac>>2]=32;Ne=+h[(Fz(we,1,ac)|0)>>3]*1.4478307828521e-20;c[$b>>2]=20;Oe=+h[(Fz(we,1,$b)|0)>>3];c[_b>>2]=30;Pe=+h[(Fz(we,1,_b)|0)>>3]*2.6335781662795e-23;c[Zb>>2]=28;Qe=+h[(Fz(we,1,Zb)|0)>>3]*-1.1947622640071e-23;c[Yb>>2]=26;Re=+h[(Fz(we,1,Yb)|0)>>3]*1.8228094581404e-24;c[Xb>>2]=24;Se=Ce*(Ge+Ce*(Ie+Ce*(Fe+He*(Ke+Je*(Le+Me*(Ne+Oe*(Pe+Ce*(Qe+Ce*(Re+Ce*+h[(Fz(we,1,Xb)|0)>>3]*-9.3537087292458e-26)))))))));c[Wb>>2]=8;Re=+h[(Fz(we,1,Wb)|0)>>3];c[Vb>>2]=7;Qe=+h[(Fz(we,1,Vb)|0)>>3];c[Ub>>2]=1;Pe=+h[(Fz(we,1,Ub)|0)>>3];c[Tb>>2]=9;Oe=Ce*(Re*(Qe*(Ee*(Pe*(+h[(Fz(we,1,Tb)|0)>>3]*-7.2694996297594e-16+-44141845330846.0e-19)+47661393906987.0e-18)+-.00030001780793026)+-.00047184321073267)+Se);c[Sb>>2]=5;Se=+h[(Fz(we,1,Sb)|0)>>3];c[Rb>>2]=1;Pe=+h[(Fz(we,1,Rb)|0)>>3];c[Qb>>2]=6;Qe=+h[(Fz(we,1,Qb)|0)>>3];c[Pb>>2]=1;Re=Ce*(Oe+Se*(Pe*(Qe*(Ee*(Ee*(+h[(Fz(we,1,Pb)|0)>>3]*-5283835796993.0e-17+-.021841717175414)+-.032529748770505)+-.018990068218419)+-.00060706301565874)+.00028319080123804));c[Ob>>2]=1;Qe=(Ee*(Ee*(Ee*(Ee*(Ee*(Ee*(Ee*.00081214629983568+-.016616417199501)+.15772038513228)+-.95791963387872)+3.3855169168385)+-3.756360367204)+-.84548187169114)+.14632971213167)/+h[(Fz(we,1,Ob)|0)>>3]+Re;c[Nb>>2]=10;Re=+h[(Fz(we,1,Nb)|0)>>3];c[Mb>>2]=2;Pe=+h[(Fz(we,1,Mb)|0)>>3];c[Lb>>2]=6;Se=Re*(Pe*(+h[(Fz(we,1,Lb)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18);c[Kb>>2]=12;Pe=+h[(Fz(we,1,Kb)|0)>>3];c[Jb>>2]=13;Re=+h[(Fz(we,1,Jb)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[Ib>>2]=7;Oe=Pe*(Re*+h[(Fz(we,1,Ib)|0)>>3]+89701127632.0e-16);c[Hb>>2]=14;Re=+h[(Fz(we,1,Hb)|0)>>3]*202584984300585.0e-20;c[Gb>>2]=16;Pe=+h[(Fz(we,1,Gb)|0)>>3];c[Fb>>2]=11;Ne=+h[(Fz(we,1,Fb)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[Eb>>2]=36;Me=Ne*+h[(Fz(we,1,Eb)|0)>>3];c[Db>>2]=19;Ne=+h[(Fz(we,1,Db)|0)>>3];c[Cb>>2]=34;Le=+h[(Fz(we,1,Cb)|0)>>3]*1.44400475720615e-17;c[Bb>>2]=15;Je=+h[(Fz(we,1,Bb)|0)>>3];c[Ab>>2]=32;Ke=+h[(Fz(we,1,Ab)|0)>>3]*-3.3300108005598e-19;c[zb>>2]=20;He=+h[(Fz(we,1,zb)|0)>>3];c[yb>>2]=30;Fe=+h[(Fz(we,1,yb)|0)>>3]*-7.6373766822106e-22;c[xb>>2]=28;Ie=+h[(Fz(we,1,xb)|0)>>3]*3.5842867920213e-22;c[wb>>2]=26;Ge=+h[(Fz(we,1,wb)|0)>>3]*-5.6507093202352e-23;c[vb>>2]=24;Te=Ce*(Se+Ce*(Oe+Ce*(Re+Pe*(Me+Ne*(Le+Je*(Ke+He*(Fe+Ce*(Ie+Ce*(Ge+Ce*+h[(Fz(we,1,vb)|0)>>3]*2.99318679335866e-24)))))))));c[ub>>2]=8;Ge=+h[(Fz(we,1,ub)|0)>>3];c[tb>>2]=7;Ie=+h[(Fz(we,1,tb)|0)>>3];c[sb>>2]=1;Fe=+h[(Fz(we,1,sb)|0)>>3];c[rb>>2]=9;He=Ce*(Ge*(Ie*(Ee*(Fe*(+h[(Fz(we,1,rb)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534)+Te);c[qb>>2]=5;Te=+h[(Fz(we,1,qb)|0)>>3];c[pb>>2]=1;Fe=+h[(Fz(we,1,pb)|0)>>3];c[ob>>2]=6;Ie=+h[(Fz(we,1,ob)|0)>>3];c[nb>>2]=1;Ge=He+Te*(Fe*(Ie*(Ee*(Ee*(+h[(Fz(we,1,nb)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804);c[mb>>2]=10;Ie=+h[(Fz(we,1,mb)|0)>>3];c[lb>>2]=2;Fe=+h[(Fz(we,1,lb)|0)>>3];c[kb>>2]=6;Te=Ie*(Fe*(+h[(Fz(we,1,kb)|0)>>3]*-5.1123076872062e-9+-169624787911872.0e-19)+-.000190077869070324);c[jb>>2]=12;Fe=+h[(Fz(we,1,jb)|0)>>3];c[ib>>2]=13;Ie=+h[(Fz(we,1,ib)|0)>>3]*-1.72100759255088e-12+-78205467474721.0e-19;c[hb>>2]=7;He=Fe*(Ie*+h[(Fz(we,1,hb)|0)>>3]+-269103382896.0e-16);c[gb>>2]=14;Ie=+h[(Fz(we,1,gb)|0)>>3]*-81033993720234.0e-19;c[fb>>2]=16;Fe=+h[(Fz(we,1,fb)|0)>>3];c[eb>>2]=11;Ke=+h[(Fz(we,1,eb)|0)>>3]*-9.757927889155e-9+-7.131208975319e-8;c[db>>2]=36;Je=Ke*+h[(Fz(we,1,db)|0)>>3];c[cb>>2]=19;Ke=+h[(Fz(we,1,cb)|0)>>3];c[bb>>2]=34;Le=+h[(Fz(we,1,bb)|0)>>3]*-2.8880095144123e-16;c[ab>>2]=15;Ne=+h[(Fz(we,1,ab)|0)>>3];c[$a>>2]=32;Me=+h[(Fz(we,1,$a)|0)>>3]*7.3260237612316e-18;c[_a>>2]=20;Pe=+h[(Fz(we,1,_a)|0)>>3];c[Za>>2]=30;Re=+h[(Fz(we,1,Za)|0)>>3]*2.13846547101895e-20;c[Ya>>2]=28;Oe=+h[(Fz(we,1,Ya)|0)>>3]*-1.03944316968618e-20;c[Xa>>2]=26;Se=+h[(Fz(we,1,Xa)|0)>>3]*1.69521279607057e-21;c[Wa>>2]=24;Ue=Ce*(Te+Ce*(He+Ce*(Ie+Fe*(Je+Ke*(Le+Ne*(Me+Pe*(Re+Ce*(Oe+Ce*(Se+Ce*+h[(Fz(we,1,Wa)|0)>>3]*-9.2788790594118e-23)))))))));c[Va>>2]=8;Se=+h[(Fz(we,1,Va)|0)>>3];c[Ua>>2]=7;Oe=+h[(Fz(we,1,Ua)|0)>>3];c[Ta>>2]=1;Re=+h[(Fz(we,1,Ta)|0)>>3];c[Sa>>2]=9;Pe=Se*(Oe*(Ee*(Re*(+h[(Fz(we,1,Sa)|0)>>3]*-1.45389992595188e-15+-88283690661692.0e-19)+95322787813974.0e-18)+-.00060003561586052)+-.00094368642146534)+Ue;c[Ra>>2]=38;Ue=+h[(Fz(we,1,Ra)|0)>>3];c[Qa>>2]=1;Re=+h[(Fz(we,1,Qa)|0)>>3];c[Pa>>2]=1;Oe=+h[(Fz(we,1,Pa)|0)>>3]*-.00015851507390979+-.021841717175414;c[Oa>>2]=1;Se=Oe*+h[(Fz(we,1,Oa)|0)>>3]+.018990068218419;c[Na>>2]=6;Oe=Ue*(Re*(Se*+h[(Fz(we,1,Na)|0)>>3]+.0042494411096112)+-.00254871721114236);c[Ma>>2]=10;Se=+h[(Fz(we,1,Ma)|0)>>3];c[La>>2]=2;Re=+h[(Fz(we,1,La)|0)>>3];c[Ka>>2]=1;Ue=+h[(Fz(we,1,Ka)|0)>>3];c[Ja>>2]=9;Me=Se*(Re*(Ue*(+h[(Fz(we,1,Ja)|0)>>3]*-1.2358149370591e-14+-132425535992538.0e-19)+47661393906987.0e-18)+.00141552963219801);c[Ia>>2]=12;Ue=+h[(Fz(we,1,Ia)|0)>>3];c[Ha>>2]=37;Re=Ue*(+h[(Fz(we,1,Ha)|0)>>3]*-5.1123076872062e-9+.000126718579380216);c[Ga>>2]=39;Ue=+h[(Fz(we,1,Ga)|0)>>3];c[Fa>>2]=13;Se=+h[(Fz(we,1,Fa)|0)>>3]*-1.4341729937924e-12+130342445791202.0e-20;c[Ea>>2]=7;Ne=Ue*(Se*+h[(Fz(we,1,Ea)|0)>>3]+11212640954.0e-15);c[Da>>2]=5;Se=+h[(Fz(we,1,Da)|0)>>3]*32413597488094.0e-19;c[Ca>>2]=16;Ue=+h[(Fz(we,1,Ca)|0)>>3];c[Ba>>2]=11;Le=+h[(Fz(we,1,Ba)|0)>>3]*1.04549227383804e-9+1.40077319158051e-8;c[Aa>>2]=45;Ke=Le*+h[(Fz(we,1,Aa)|0)>>3];c[za>>2]=19;Le=+h[(Fz(we,1,za)|0)>>3];c[ya>>2]=44;Je=+h[(Fz(we,1,ya)|0)>>3]*1.9941018075704e-17;c[xa>>2]=15;Fe=+h[(Fz(we,1,xa)|0)>>3];c[wa>>2]=42;Ie=+h[(Fz(we,1,wa)|0)>>3]*-4.4882754268415e-19;c[va>>2]=20;He=+h[(Fz(we,1,va)|0)>>3];c[ua>>2]=28;Te=+h[(Fz(we,1,ua)|0)>>3]*-1.00075970318621e-21;c[ta>>2]=26;Ve=+h[(Fz(we,1,ta)|0)>>3]*4.6595728296277e-22;c[sa>>2]=24;We=+h[(Fz(we,1,sa)|0)>>3]*-7.2912378325616e-23;c[ra>>2]=41;Xe=Ce*(Oe+Ce*(Me+Ce*(Re+Ce*(Ne+Ce*(Se+Ue*(Ke+Le*(Je+Fe*(Ie+He*(Te+Ce*(Ve+Ce*(We+Ce*+h[(Fz(we,1,ra)|0)>>3]*3.8350205789908e-24)))))))))));c[qa>>2]=8;We=+h[(Fz(we,1,qa)|0)>>3];c[pa>>2]=1;Ve=We*(Ee*((Ee*(Ee*(Ee*(Ee*.0040607314991784+-.066465668798004)+.47316115539684)+-1.91583926775744)+3.3855169168385)*+h[(Fz(we,1,pa)|0)>>3]+.84548187169114)+-.29265942426334)+Xe;c[oa>>2]=36;Xe=+h[(Fz(we,1,oa)|0)>>3];c[na>>2]=1;We=+h[(Fz(we,1,na)|0)>>3];c[ma>>2]=2;Te=+h[(Fz(we,1,ma)|0)>>3]*-.00031703014781958+-.037980136436838;c[la>>2]=6;He=Xe*(We*(Te*+h[(Fz(we,1,la)|0)>>3]+-.033995528876889)+.0254871721114236);c[ka>>2]=12;Te=+h[(Fz(we,1,ka)|0)>>3];c[ja>>2]=6;We=+h[(Fz(we,1,ja)|0)>>3];c[ia>>2]=9;Xe=Te*(We*(+h[(Fz(we,1,ia)|0)>>3]*-1.97730389929456e-13+-264851071985076.0e-19)+-.005662118528792);c[ha>>2]=37;We=+h[(Fz(we,1,ha)|0)>>3]*-2.55615384360309e-8+-.00063359289690108;c[ga>>2]=39;Te=We*+h[(Fz(we,1,ga)|0)>>3];c[fa>>2]=38;We=+h[(Fz(we,1,fa)|0)>>3]*-291722377392842.0e-19;c[ea>>2]=16;Ie=+h[(Fz(we,1,ea)|0)>>3];c[da>>2]=19;Fe=+h[(Fz(we,1,da)|0)>>3];c[ca>>2]=32;Je=+h[(Fz(we,1,ca)|0)>>3]*-5.9823054227112e-16;c[ba>>2]=15;Le=+h[(Fz(we,1,ba)|0)>>3];c[aa>>2]=20;Ke=+h[(Fz(we,1,aa)|0)>>3];c[$>>2]=26;Ue=+h[(Fz(we,1,$)|0)>>3]*3.9029628424262e-20;c[_>>2]=24;Se=+h[(Fz(we,1,_)|0)>>3]*-1.86382913185108e-20;c[Z>>2]=41;Ne=+h[(Fz(we,1,Z)|0)>>3]*2.98940751135026e-21;c[Y>>2]=1;Re=+h[(Fz(we,1,Y)|0)>>3];c[X>>2]=22;Me=Re*+h[(Fz(we,1,X)|0)>>3];c[W>>2]=3;Re=Ke*(Ue+Ce*(Se+Ce*(Ne+Ce/(Ee*Me*+h[(Fz(we,1,W)|0)>>3])*-1.61070864317613e-22)));c[V>>2]=22;Me=Fe*(Je+Le*(1.43624813658928e-17/(Ee*+h[(Fz(we,1,V)|0)>>3])+Re));c[U>>2]=11;Re=+h[(Fz(we,1,U)|0)>>3]*-7.3184459168663e-9+-1.68092782989661e-7;c[T>>2]=2;Le=+h[(Fz(we,1,T)|0)>>3];c[S>>2]=3;Je=Ce*(We+Ie*(Re/(Ee*Le*+h[(Fz(we,1,S)|0)>>3])+Me));c[R>>2]=13;Me=+h[(Fz(we,1,R)|0)>>3]*-1.29075569441316e-11+-39102733737361.0e-19;c[Q>>2]=7;Le=Me*+h[(Fz(we,1,Q)|0)>>3]+-67275845724.0e-15;c[P>>2]=1;Me=+h[(Fz(we,1,P)|0)>>3];c[O>>2]=2;Re=Ce*(He+Ce*(Xe+Ce*(Te+Ce*(Je+Le/(Ee*Me*+h[(Fz(we,1,O)|0)>>3])))));c[N>>2]=10;Me=+h[(Fz(we,1,N)|0)>>3];c[M>>2]=7;Le=Re+Me*(Ee*((Ee*(Ee*(Ee*.0162429259967136+-.199397006394012)+.94632231079368)+-1.91583926775744)*+h[(Fz(we,1,M)|0)>>3]+-1.69096374338228)+.87797827279002);c[L>>2]=38;Ee=+h[(Fz(we,1,L)|0)>>3];c[K>>2]=1;Me=+h[(Fz(we,1,K)|0)>>3];c[J>>2]=1;Re=+h[(Fz(we,1,J)|0)>>3]*.00015851507390979+.021841717175414;c[I>>2]=1;Je=Re*+h[(Fz(we,1,I)|0)>>3]+-.018990068218419;c[H>>2]=6;Re=Ee*(Me*(Je*+h[(Fz(we,1,H)|0)>>3]+-.0042494411096112)+.00254871721114236);c[G>>2]=10;Je=+h[(Fz(we,1,G)|0)>>3];c[F>>2]=2;Me=+h[(Fz(we,1,F)|0)>>3];c[E>>2]=1;Ee=+h[(Fz(we,1,E)|0)>>3];c[D>>2]=9;Te=Je*(Me*(Ee*(+h[(Fz(we,1,D)|0)>>3]*2.4716298741182e-14+264851071985076.0e-19)+-95322787813974.0e-18)+-.00283105926439602);c[C>>2]=12;Ee=+h[(Fz(we,1,C)|0)>>3];c[B>>2]=37;Me=Ee*(+h[(Fz(we,1,B)|0)>>3]*1.53369230616185e-8+-.00038015573814065);c[A>>2]=39;Ee=+h[(Fz(we,1,A)|0)>>3];c[z>>2]=13;Je=+h[(Fz(we,1,z)|0)>>3]*5.7366919751696e-12+-52136978316481.0e-19;c[y>>2]=7;Xe=Ee*(Je*+h[(Fz(we,1,y)|0)>>3]+-44850563816.0e-15);c[x>>2]=5;Je=+h[(Fz(we,1,x)|0)>>3]*-162067987440468.0e-19;c[w>>2]=16;Ee=+h[(Fz(we,1,w)|0)>>3];c[v>>2]=11;He=+h[(Fz(we,1,v)|0)>>3]*-8.3639381907043e-9+-1.12061855326441e-7;c[u>>2]=45;Ie=He*+h[(Fz(we,1,u)|0)>>3];c[t>>2]=19;He=+h[(Fz(we,1,t)|0)>>3];c[s>>2]=44;We=+h[(Fz(we,1,s)|0)>>3]*-4.1876137958978e-16;c[r>>2]=15;Fe=+h[(Fz(we,1,r)|0)>>3];c[q>>2]=42;Ne=+h[(Fz(we,1,q)|0)>>3]*1.03230334817355e-17;c[p>>2]=20;Se=+h[(Fz(we,1,p)|0)>>3];c[o>>2]=28;Ue=+h[(Fz(we,1,o)|0)>>3]*2.90220313924001e-20;c[n>>2]=26;Ke=+h[(Fz(we,1,n)|0)>>3]*-1.39787184888831e-20;c[m>>2]=24;Oe=+h[(Fz(we,1,m)|0)>>3]*2.2602837280941e-21;c[l>>2]=41;Ye=Re+Ce*(Te+Ce*(Me+Ce*(Xe+Ce*(Je+Ee*(Ie+He*(We+Fe*(Ne+Se*(Ue+Ce*(Ke+Ce*(Oe+Ce*+h[(Fz(we,1,l)|0)>>3]*-1.22720658527705e-22))))))))));h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=Ae;h[a+32>>3]=Be;h[a+40>>3]=Qe;h[a+48>>3]=Ge;h[a+56>>3]=Pe;h[a+64>>3]=Ve;h[a+72>>3]=Le;h[a+80>>3]=Ye;i=f;return}function zh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0.0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=4;Az(f,1,e);g=d/1.0e6;d=g*g;h[a>>3]=(g*3.74696550136983+(d*-.0219921901054187+g*d*87513168600995.0e-18)+2014.64004206875)*1.0e3;i=b;return}function Ah(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0;f=i;i=i+104|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=11;Az(ia,1,ha);if(!(d>0.0)){ha=lz(lz(8472,jz(d,0,1,6)|0)|0,7584)|0;ja=c[28994]|0;ka=m;la=8536;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];De[ja&31](b,m,ha,ga);}if(!(d<=1.0e7)){ga=lz(lz(8560,jz(d,0,1,6)|0)|0,8608)|0;ha=c[28994]|0;m=l;ja=8648;c[m+0>>2]=c[ja+0>>2];c[m+4>>2]=c[ja+4>>2];c[m+8>>2]=c[ja+8>>2];c[m+12>>2]=c[ja+12>>2];c[m+16>>2]=c[ja+16>>2];c[m+20>>2]=c[ja+20>>2];De[ha&31](b,l,ga,fa);}if(!(e<=2273.15)){fa=lz(lz(8672,jz(e,0,1,6)|0)|0,8720)|0;ga=c[28994]|0;l=j;ha=8776;c[l+0>>2]=c[ha+0>>2];c[l+4>>2]=c[ha+4>>2];c[l+8>>2]=c[ha+8>>2];c[l+12>>2]=c[ha+12>>2];c[l+16>>2]=c[ha+16>>2];c[l+20>>2]=c[ha+20>>2];De[ga&31](b,j,fa,ea);}ma=d/1.0e6;na=1.0e3/e;c[ca>>2]=1;h[(Fz(ia,1,ca)|0)>>3]=na*na;c[ba>>2]=1;oa=+h[(Fz(ia,1,ba)|0)>>3]*-.004594282089991;c[aa>>2]=2;h[(Fz(ia,1,aa)|0)>>3]=oa;c[$>>2]=2;oa=+h[(Fz(ia,1,$)|0)>>3]+.0021774678714571;c[_>>2]=3;h[(Fz(ia,1,_)|0)>>3]=oa;c[Z>>2]=3;oa=na*+h[(Fz(ia,1,Z)|0)>>3];c[Y>>2]=4;h[(Fz(ia,1,Y)|0)>>3]=oa;c[X>>2]=1;oa=na*+h[(Fz(ia,1,X)|0)>>3];c[W>>2]=5;h[(Fz(ia,1,W)|0)>>3]=oa;c[V>>2]=1;oa=+h[(Fz(ia,1,V)|0)>>3];c[U>>2]=6;h[(Fz(ia,1,U)|0)>>3]=oa*oa;c[T>>2]=6;oa=+h[(Fz(ia,1,T)|0)>>3];c[S>>2]=7;h[(Fz(ia,1,S)|0)>>3]=oa*oa;c[R>>2]=7;oa=na*+h[(Fz(ia,1,R)|0)>>3];c[Q>>2]=8;h[(Fz(ia,1,Q)|0)>>3]=oa;c[P>>2]=8;oa=+h[(Fz(ia,1,P)|0)>>3]*-79449656719138.0e-19;c[O>>2]=9;h[(Fz(ia,1,O)|0)>>3]=oa;c[N>>2]=10;h[(Fz(ia,1,N)|0)>>3]=ma*ma;c[M>>2]=1;oa=+h[(Fz(ia,1,M)|0)>>3]*-.013782846269973;c[L>>2]=11;h[(Fz(ia,1,L)|0)>>3]=oa;if(!(ma>0.0)){L=c[28994]|0;M=K;h[k>>3]=ma;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];M=L;L=g;N=8800;c[L+0>>2]=c[N+0>>2];c[L+4>>2]=c[N+4>>2];c[L+8>>2]=c[N+8>>2];c[L+12>>2]=c[N+12>>2];c[L+16>>2]=c[N+16>>2];c[L+20>>2]=c[N+20>>2];De[M&31](b,g,7960,K);}c[J>>2]=4;oa=+h[(Fz(ia,1,J)|0)>>3];c[I>>2]=8;pa=+h[(Fz(ia,1,I)|0)>>3]*-39724828359569.0e-19;c[H>>2]=5;qa=ma*(oa+ma*(pa+ma*+h[(Fz(ia,1,H)|0)>>3]*1.2919228289784e-7)+-.00012563183589592);pa=na*(na*(na*(na*(na*-.32961626538917+6.8540841634434)+ +da(+ma)+-13.179983674201)+-3.1161318213925)+.36901534980333)+-.024805148933466;c[G>>2]=5;oa=pa/+h[(Fz(ia,1,G)|0)>>3]+qa;c[F>>2]=4;qa=+h[(Fz(ia,1,F)|0)>>3];c[E>>2]=9;pa=+h[(Fz(ia,1,E)|0)>>3];c[D>>2]=5;ra=(ma*(qa+ma*(pa+ma*+h[(Fz(ia,1,D)|0)>>3]*3.8757684869352e-7)+-.00012563183589592)+1.0)/ma;c[C>>2]=10;pa=+h[(Fz(ia,1,C)|0)>>3];c[B>>2]=9;qa=+h[(Fz(ia,1,B)|0)>>3];c[A>>2]=5;sa=pa*(qa+ma*+h[(Fz(ia,1,A)|0)>>3]*7.7515369738704e-7)+-1.0;c[z>>2]=10;qa=sa/+h[(Fz(ia,1,z)|0)>>3];c[y>>2]=11;sa=+h[(Fz(ia,1,y)|0)>>3];c[x>>2]=7;pa=+h[(Fz(ia,1,x)|0)>>3]*-35752345523612.0e-18;c[w>>2]=1;ta=ma*(sa+ma*(pa+ma*+h[(Fz(ia,1,w)|0)>>3]*3.8757684869352e-7)+.0021774678714571);c[v>>2]=1;pa=na*(na*((na*-.65923253077834+6.8540841634434)*+h[(Fz(ia,1,v)|0)>>3]+3.1161318213925)+-.73803069960666)+.074415446800398;c[u>>2]=6;sa=pa/+h[(Fz(ia,1,u)|0)>>3]+ta;c[t>>2]=5;ta=na*(na*(+h[(Fz(ia,1,t)|0)>>3]*-.65923253077834+-6.232263642785)+2.21409209881998)+-.297661787201592;c[s>>2]=6;pa=ta/(na*+h[(Fz(ia,1,s)|0)>>3]);c[r>>2]=1;ta=+h[(Fz(ia,1,r)|0)>>3];c[q>>2]=6;ua=pa+ma*(na*-.027565692539946+ma*(ma*na*7.7515369738704e-7+ta*na*+h[(Fz(ia,1,q)|0)>>3]*-.000286018764188897));c[p>>2]=11;ta=+h[(Fz(ia,1,p)|0)>>3];c[o>>2]=7;pa=+h[(Fz(ia,1,o)|0)>>3]*-71504691047224.0e-18;c[n>>2]=1;va=ta+ma*(pa+ma*+h[(Fz(ia,1,n)|0)>>3]*116273054608056.0e-20)+.0021774678714571;h[a>>3]=d;h[a+8>>3]=e;h[a+16>>3]=461.526;h[a+24>>3]=ma;h[a+32>>3]=na;h[a+40>>3]=oa;h[a+48>>3]=ra;h[a+56>>3]=qa;h[a+64>>3]=sa;h[a+72>>3]=ua;h[a+80>>3]=va;i=f;return}function Bh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0,P=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+16|0;c[H>>2]=8;Az(I,1,H);J=+od(+d,647.096);if(!(d>=273.16)){H=c[28994]|0;K=f;L=8824;c[K+0>>2]=c[L+0>>2];c[K+4>>2]=c[L+4>>2];c[K+8>>2]=c[L+8>>2];c[K+12>>2]=c[L+12>>2];c[K+16>>2]=c[L+16>>2];c[K+20>>2]=c[L+20>>2];De[H&31](b,f,8848,G);}c[F>>2]=1;h[(Fz(I,1,F)|0)>>3]=J+-650.17534844798;c[E>>2]=1;d=1.0/+h[(Fz(I,1,E)|0)>>3];c[D>>2]=2;h[(Fz(I,1,D)|0)>>3]=d;c[C>>2]=2;d=+h[(Fz(I,1,C)|0)>>3]*-.23855557567849;c[B>>2]=3;h[(Fz(I,1,B)|0)>>3]=d;c[A>>2]=3;d=J+ +h[(Fz(I,1,A)|0)>>3];c[z>>2]=4;h[(Fz(I,1,z)|0)>>3]=d;c[y>>2]=4;d=+h[(Fz(I,1,y)|0)>>3]*-4823.2657361591;c[x>>2]=5;h[(Fz(I,1,x)|0)>>3]=d;c[w>>2]=4;d=+h[(Fz(I,1,w)|0)>>3];c[v>>2]=6;h[(Fz(I,1,v)|0)>>3]=d*d;c[u>>2]=6;d=+h[(Fz(I,1,u)|0)>>3]*14.91510861353;c[t>>2]=7;h[(Fz(I,1,t)|0)>>3]=d;c[s>>2]=5;d=+h[(Fz(I,1,s)|0)>>3];c[r>>2]=7;J=d+ +h[(Fz(I,1,r)|0)>>3]+405113.40542057;c[q>>2]=8;h[(Fz(I,1,q)|0)>>3]=J;c[p>>2]=4;J=+h[(Fz(I,1,p)|0)>>3]*12020.82470247;c[o>>2]=6;d=J+ +h[(Fz(I,1,o)|0)>>3]*-17.073846940092+-3232555.0322333;c[n>>2]=8;J=+h[(Fz(I,1,n)|0)>>3];c[m>>2]=4;M=+h[(Fz(I,1,m)|0)>>3]*-12020.82470247;c[l>>2]=6;N=+h[(Fz(I,1,l)|0)>>3]*17.073846940092;c[k>>2]=4;O=+h[(Fz(I,1,k)|0)>>3]*1167.0521452767;c[j>>2]=6;P=O+ +h[(Fz(I,1,j)|0)>>3]+-724213.16703206;c[g>>2]=8;O=J/(M+(N+ +V(+(d*d+P*+h[(Fz(I,1,g)|0)>>3]*-4.0)))+3232555.0322333);P=O*O;h[a>>3]=P*P*16.0e6;i=e;return}function Ch(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,fa=0.0,ga=0.0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0;j=i;i=i+144|0;k=j;l=j+24|0;m=j+112|0;n=j+136|0;o=i;i=i+8|0;p=i;i=i+88|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+88|0;y=i;i=i+48|0;z=i;i=i+16|0;do{if(d<22064.0e3){Dh(q,b,d);if(+h[q>>3]+10.0>e){A=6;break}Eh(r,b,d);if(+h[r>>3]+-10.0<e){A=7;break}B=c[28994]|0;C=m;D=8960;c[C+0>>2]=c[D+0>>2];c[C+4>>2]=c[D+4>>2];c[C+8>>2]=c[D+8>>2];c[C+12>>2]=c[D+12>>2];c[C+16>>2]=c[D+16>>2];c[C+20>>2]=c[D+20>>2];De[B&31](b,m,8984,o);A=7}else{zh(s,0,d);if(+h[s>>3]>e){A=6}else{A=7}}}while(0);if((A|0)==6){wh(t,0,d,e);E=+h[t>>3];Fh(v,0,d,e);F=+h[v>>3];G=E}else if((A|0)==7){vh(u,0,d,e);E=+h[u>>3];Gh(w,0,d,e);F=+h[w>>3];G=E}w=x;u=x+8|0;A=x+16|0;v=x+24|0;t=x+32|0;s=x+40|0;o=x+48|0;m=x+56|0;r=x+64|0;q=x+72|0;B=x+80|0;D=p;C=p+8|0;H=p+16|0;I=p+24|0;J=p+32|0;K=p+40|0;L=p+48|0;M=p+56|0;N=p+64|0;O=p+72|0;P=p+80|0;Q=y;R=y+8|0;S=y+16|0;T=y+24|0;V=y+32|0;W=y+40|0;X=z;Y=z+8|0;E=G;G=1.0/F;Z=0;do{uh(x,b,G,E);F=+h[u>>3];_=+h[A>>3];$=+h[v>>3];aa=+h[t>>3];ba=+h[s>>3];ca=+h[o>>3];da=+h[m>>3];ea=+h[r>>3];fa=+h[q>>3];ga=+h[B>>3];h[D>>3]=+h[w>>3];h[C>>3]=F;h[H>>3]=_;h[I>>3]=$;h[J>>3]=aa;h[K>>3]=ba;h[L>>3]=ca;h[M>>3]=da;h[N>>3]=ea;h[O>>3]=fa;h[P>>3]=ga;ha=l+0|0;ia=p+0|0;ja=ha+88|0;do{c[ha>>2]=c[ia>>2];ha=ha+4|0;ia=ia+4|0}while((ha|0)<(ja|0));oh(y,0,l);ga=+h[S>>3];fa=+h[T>>3];ea=+h[V>>3];da=+h[W>>3];ca=+h[R>>3]-e;ba=+h[Q>>3]-d;do{if(!(+U(+(ca/e))<=g)){ka=1}else{if(!(+U(+(ba/d))<=f)){ka=1;break}ka=0}}while(0);aa=ga*da-fa*ea;Z=Z+1|0;Hh(z,0,G-(ba*da-ca*fa)/aa,E-(ga*ca-ba*ea)/aa);G=+h[X>>3];E=+h[Y>>3];}while((Z|0)<50&ka);Z=ka&1;if(!ka){la=a;ma=la;h[ma>>3]=G;na=a;oa=na+8|0;pa=oa;h[pa>>3]=E;qa=a;ra=qa+16|0;sa=ra;c[sa>>2]=Z;i=j;return}ka=c[28994]|0;Y=k;X=9064;c[Y+0>>2]=c[X+0>>2];c[Y+4>>2]=c[X+4>>2];c[Y+8>>2]=c[X+8>>2];c[Y+12>>2]=c[X+12>>2];c[Y+16>>2]=c[X+16>>2];c[Y+20>>2]=c[X+20>>2];De[ka&31](b,k,9088,n);la=a;ma=la;h[ma>>3]=G;na=a;oa=na+8|0;pa=oa;h[pa>>3]=E;qa=a;ra=qa+16|0;sa=ra;c[sa>>2]=Z;i=j;return}function Dh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;Wh(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));$h(b,0,0.0,f);i=e;return}function Eh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,h=0;e=i;i=i+208|0;f=e;g=e+104|0;Yh(g,b,d);b=a;a=f+0|0;h=g+0|0;g=a+104|0;do{c[a>>2]=c[h>>2];a=a+4|0;h=h+4|0}while((a|0)<(g|0));$h(b,0,0.0,f);i=e;return}function Fh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=32;Az(k,1,j);j=k;k=9280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=32;Az(l,1,g);g=l;l=9296;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=32;Az(m,1,f);f=m;m=9312;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/21.0e5+-.727;e=n*n;o=d/1.0e8+.128;d=o*n;p=o*o;q=+iA(o,-12);r=q*+iA(n,6)*.00529944062966028;q=+iA(o,-12);s=q*+iA(n,8)*-.170099690234461;q=+iA(o,-12);t=q*+iA(n,12)*11.1323814312927;q=+iA(o,-12);u=q*+iA(n,18)*-2178.98123145125;q=e*e;v=q*+iA(o,-10)*-.000506061827980875;w=+iA(o,-10);x=w*+iA(n,7)*.556495239685324;w=+iA(o,-10);y=w*+iA(n,10)*-9.43672726094016;w=+iA(o,-8);z=w*+iA(n,5)*-.297856807561527;w=+iA(o,-8);A=w*+iA(n,12)*93.9353943717186;w=n*e;B=w*+iA(o,-6)*.0192944939465981;C=q*+iA(o,-6)*.421740664704763;q=+iA(o,-6);D=q*+iA(n,22)*-3689141.2628233;q=e*+iA(o,-4)*-.00737566847600639;E=w*+iA(o,-4)*-.354753242424366;F=+iA(o,-3);G=F*+iA(n,7)*-1.99768169338727;F=w*+iA(o,-2)*1.15456297059049;H=+iA(o,-2);I=H*+iA(n,16)*5683.6687581596;H=e*+iA(o,5)*1.10533464706142;h[a>>3]=(r+(s+(t+(u+(v+(x+(y+(z+(A+(B+(C+(D+(q+(E+(G+(F+(I+(.00808169540124668/o+(n/o*.172416341519307+(e/o*1.04270175292927+(w/o*-.297691372792847+(n*.275234661176914+(o*-.148347894866012+(d*-.0651142513478515+(o*e*-2.92468715386302+(p*.0664876096952665+(d*d*3.52335014263844+(o*p*-.0146340792313332+(p*p*e*-2.24503486668184+(H+e*+iA(o,8)*-.0408757344495612)))))))))))))))))))))))))))))+.560394465163593)*.0028;i=b;return}function Gh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;c[j>>2]=30;Az(k,1,j);j=k;k=9144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[g>>2]=30;Az(l,1,g);g=l;l=9160;c[g+0>>2]=c[l+0>>2];c[g+4>>2]=c[l+4>>2];c[g+8>>2]=c[l+8>>2];c[f>>2]=30;Az(m,1,f);f=m;m=9176;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];n=e/28.0e5+-.72;e=d/1.0e8+.0661;d=n*n;o=e*n;p=-2.25196934336318e-9/+iA(e,12);q=n*+iA(e,-12)*1.40674363313486e-8;r=23378408528056.0e-19/+iA(e,8);s=n*+iA(e,-8)*-331833715229001.0e-19;t=n*d;u=t*+iA(e,-8)*.00107956778514318;v=+iA(e,-8);w=v*+iA(n,6)*-.271382067378863;v=+iA(e,-8);x=v*+iA(n,7)*1.07202262490333;v=+iA(e,-8);y=v*+iA(n,8)*-.853821329075382;v=-215214194340526.0e-19/+iA(e,6);z=n*+iA(e,-6)*.00076965608822273;A=d*+iA(e,-6)*-.00431136580433864;B=+iA(e,-6);C=B*+iA(n,5)*.453342167309331;B=+iA(e,-6);D=B*+iA(n,6)*-.507749535873652;B=+iA(e,-6);E=B*+iA(n,10)*-100.475154528389;B=t*+iA(e,-4)*-.219201924648793;t=+iA(e,-4);F=t*+iA(n,6)*-3.21087965668917;t=+iA(e,-4);G=t*+iA(n,10)*607.567815637771;t=e*e;H=d*+iA(e,-3)*.18749904002955;I=n*+iA(e,-2)*.00905368030448107;J=d*+iA(e,-2)*.285417173048685;K=+iA(n,5)/e*-11.8035753702231;h[a>>3]=(p+(q+(r+(s+(u+(w+(x+(y+(v+(z+(A+(C+(D+(E+(B+(F+(G+(.000557686450685932/(e*t)+(H+(I+(J+(.0329924030996098/e+(n/e*.239897419685483+(d*d/e*4.82754995951394+(K+(e*-.0179967222507787+(o*.0371810116332674+(o*o*-.0536288335065096+t*+iA(n,6)*1.6069710109252)))))))))))))))))))))))))))+.169490044091791)*.0088;i=b;return}function Hh(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0.0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0;b=i;do{if(c>765.0){e=765.0;f=4}else{g=c<110.0?110.0:c;if(!(g<390.0)){e=g;f=4;break}j=g*.809344262+554.3557377;k=g}}while(0);if((f|0)==4){j=e*-.632948717+1116.85;k=e}e=k+-322.0;c=e*e;if(k<322.0){l=c/1.0e6}else{l=c/144.0e4}c=(1.0-l)*647.096;if(c>d){m=c}else{m=j<d?j:d}h[a>>3]=k;h[a+8>>3]=m;i=b;return}function Ih(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0.0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+16|0;c[ha>>2]=20;Az(ia,1,ha);if(!(d>611.657)){ha=lz(lz(9192,jz(d,0,1,6)|0)|0,5248)|0;ja=lz(lz(ha,jz(611.657,0,1,6)|0)|0,5256)|0;ha=c[28994]|0;ka=f;la=9256;c[ka+0>>2]=c[la+0>>2];c[ka+4>>2]=c[la+4>>2];c[ka+8>>2]=c[la+8>>2];c[ka+12>>2]=c[la+12>>2];c[ka+16>>2]=c[la+16>>2];c[ka+20>>2]=c[la+20>>2];De[ha&31](b,f,ja,ga);}ma=+od(+d,22064.0e3)*1.0e-6;d=+W(+ma,.25);c[fa>>2]=1;h[(Fz(ia,1,fa)|0)>>3]=d;c[ea>>2]=1;d=+h[(Fz(ia,1,ea)|0)>>3]*-3232555.0322333;c[da>>2]=2;h[(Fz(ia,1,da)|0)>>3]=d;d=+V(+ma);c[ca>>2]=3;h[(Fz(ia,1,ca)|0)>>3]=d;c[ba>>2]=3;d=+h[(Fz(ia,1,ba)|0)>>3]*-724213.16703206;c[aa>>2]=4;h[(Fz(ia,1,aa)|0)>>3]=d;c[$>>2]=2;d=+h[(Fz(ia,1,$)|0)>>3];c[_>>2]=4;ma=d+ +h[(Fz(ia,1,_)|0)>>3]+405113.40542057;c[Z>>2]=5;h[(Fz(ia,1,Z)|0)>>3]=ma;c[Y>>2]=1;ma=+h[(Fz(ia,1,Y)|0)>>3]*-17.073846940092;c[X>>2]=6;h[(Fz(ia,1,X)|0)>>3]=ma;c[U>>2]=3;ma=+h[(Fz(ia,1,U)|0)>>3];c[T>>2]=6;d=ma+ +h[(Fz(ia,1,T)|0)>>3]+14.91510861353;c[S>>2]=7;h[(Fz(ia,1,S)|0)>>3]=d;c[R>>2]=5;d=+h[(Fz(ia,1,R)|0)>>3];c[Q>>2]=7;ma=d*+h[(Fz(ia,1,Q)|0)>>3]*-4.0;c[P>>2]=8;h[(Fz(ia,1,P)|0)>>3]=ma;c[O>>2]=1;ma=+h[(Fz(ia,1,O)|0)>>3]*12020.82470247;c[N>>2]=9;h[(Fz(ia,1,N)|0)>>3]=ma;c[M>>2]=3;ma=+h[(Fz(ia,1,M)|0)>>3]*1167.0521452767;c[L>>2]=10;h[(Fz(ia,1,L)|0)>>3]=ma;c[K>>2]=10;ma=+h[(Fz(ia,1,K)|0)>>3];c[J>>2]=9;d=ma+ +h[(Fz(ia,1,J)|0)>>3]+-4823.2657361591;c[I>>2]=11;h[(Fz(ia,1,I)|0)>>3]=d;c[H>>2]=11;d=+h[(Fz(ia,1,H)|0)>>3];c[G>>2]=12;h[(Fz(ia,1,G)|0)>>3]=d*d;c[F>>2]=12;d=+h[(Fz(ia,1,F)|0)>>3];c[E>>2]=8;ma=d+ +h[(Fz(ia,1,E)|0)>>3];c[D>>2]=13;h[(Fz(ia,1,D)|0)>>3]=ma;c[C>>2]=13;ma=+V(+(+h[(Fz(ia,1,C)|0)>>3]));c[B>>2]=14;h[(Fz(ia,1,B)|0)>>3]=ma;c[A>>2]=14;ma=-+h[(Fz(ia,1,A)|0)>>3];c[z>>2]=15;h[(Fz(ia,1,z)|0)>>3]=ma;c[y>>2]=1;ma=+h[(Fz(ia,1,y)|0)>>3]*-12020.82470247;c[x>>2]=16;h[(Fz(ia,1,x)|0)>>3]=ma;c[w>>2]=3;ma=+h[(Fz(ia,1,w)|0)>>3]*-1167.0521452767;c[v>>2]=17;h[(Fz(ia,1,v)|0)>>3]=ma;c[u>>2]=15;ma=+h[(Fz(ia,1,u)|0)>>3];c[t>>2]=16;d=+h[(Fz(ia,1,t)|0)>>3];c[s>>2]=17;na=ma+(d+ +h[(Fz(ia,1,s)|0)>>3])+4823.2657361591;c[r>>2]=18;h[(Fz(ia,1,r)|0)>>3]=na;c[q>>2]=18;na=1.0/+h[(Fz(ia,1,q)|0)>>3];c[p>>2]=19;h[(Fz(ia,1,p)|0)>>3]=na;c[o>>2]=19;na=+h[(Fz(ia,1,o)|0)>>3];c[n>>2]=5;d=na*+h[(Fz(ia,1,n)|0)>>3]*2.0;c[m>>2]=20;h[(Fz(ia,1,m)|0)>>3]=d;c[l>>2]=20;d=+h[(Fz(ia,1,l)|0)>>3]+650.17534844798;c[k>>2]=20;na=+h[(Fz(ia,1,k)|0)>>3];c[j>>2]=19;ma=+h[(Fz(ia,1,j)|0)>>3];c[g>>2]=5;h[a>>3]=(na- +V(+(d*d+(ma*+h[(Fz(ia,1,g)|0)>>3]*1300.35069689596+-.23855557567849)*-4.0))+650.17534844798)*.5;i=e;return}function Jh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0.0,lb=0.0,mb=0.0,nb=0.0,ob=0.0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0.0,ub=0.0,vb=0.0,wb=0.0,xb=0.0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0,Mb=0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+16|0;c[ib>>2]=8;Az(jb,1,ib);kb=d*1.0e-6;d=e*5.0e-7;lb=e*.001;if(kb<4.0){e=d+-2.1;c[hb>>2]=1;h[(Fz(jb,1,hb)|0)>>3]=e*e;c[gb>>2]=1;mb=+h[(Fz(jb,1,gb)|0)>>3];c[fb>>2]=2;h[(Fz(jb,1,fb)|0)>>3]=mb*mb;c[eb>>2]=3;h[(Fz(jb,1,eb)|0)>>3]=kb*kb;c[db>>2]=3;mb=+h[(Fz(jb,1,db)|0)>>3];c[cb>>2]=4;h[(Fz(jb,1,cb)|0)>>3]=mb*mb;c[bb>>2]=3;mb=kb*+h[(Fz(jb,1,bb)|0)>>3];c[ab>>2]=5;h[(Fz(jb,1,ab)|0)>>3]=mb;c[$a>>2]=2;mb=+h[(Fz(jb,1,$a)|0)>>3];c[_a>>2]=1;nb=+h[(Fz(jb,1,_a)|0)>>3];c[Za>>2]=1;ob=+h[(Fz(jb,1,Za)|0)>>3];c[Ya>>2]=4;pb=+h[(Fz(jb,1,Ya)|0)>>3]*1.3865724283226;c[Xa>>2]=1;qb=+h[(Fz(jb,1,Xa)|0)>>3];c[Wa>>2]=2;rb=+h[(Fz(jb,1,Wa)|0)>>3];c[Va>>2]=1;sb=+h[(Fz(jb,1,Va)|0)>>3];c[Ua>>2]=2;tb=+h[(Fz(jb,1,Ua)|0)>>3];c[Ta>>2]=5;ub=+h[(Fz(jb,1,Ta)|0)>>3]*-13551.334240775;c[Sa>>2]=2;vb=+h[(Fz(jb,1,Sa)|0)>>3];c[Ra>>2]=3;wb=+h[(Fz(jb,1,Ra)|0)>>3];c[Qa>>2]=4;xb=wb*kb*+h[(Fz(jb,1,Qa)|0)>>3]*-62.459855192507;c[Pa>>2]=2;wb=+h[(Fz(jb,1,Pa)|0)>>3];c[Oa>>2]=4;yb=(kb*7399.9835474766+235988.32556514)*+h[(Fz(jb,1,Oa)|0)>>3];c[Na>>2]=1;zb=+h[(Fz(jb,1,Na)|0)>>3];c[Ma>>2]=3;Ab=+h[(Fz(jb,1,Ma)|0)>>3];c[La>>2]=4;Bb=Ab*+h[(Fz(jb,1,La)|0)>>3]*19127.72923966;c[Ka>>2]=1;Ab=+h[(Fz(jb,1,Ka)|0)>>3];c[Ja>>2]=3;Cb=+h[(Fz(jb,1,Ja)|0)>>3];c[Ia>>2]=5;Db=Cb*(+h[(Fz(jb,1,Ia)|0)>>3]*-551966.9703006+128127984.04046);c[Ha>>2]=1;Cb=+h[(Fz(jb,1,Ha)|0)>>3];c[Ga>>2]=3;Eb=+h[(Fz(jb,1,Ga)|0)>>3]*-985549096.23276;c[Fa>>2]=1;Fb=+h[(Fz(jb,1,Fa)|0)>>3];c[Ea>>2]=3;Gb=+h[(Fz(jb,1,Ea)|0)>>3]*2822454697.3002;c[Da>>2]=1;Hb=+h[(Fz(jb,1,Da)|0)>>3];c[Ca>>2]=3;Ib=+h[(Fz(jb,1,Ca)|0)>>3];c[Ba>>2]=5;Jb=Ib*(+h[(Fz(jb,1,Ba)|0)>>3]*3715408.5996233+-3594897141.0703);c[Aa>>2]=1;Ib=+h[(Fz(jb,1,Aa)|0)>>3];c[za>>2]=3;Kb=kb*(kb*-.0061707422868339+1.844574935579)+e*(kb*-4.1792700549624+e*(kb*(kb*-.31078046629583+6.2478196935812)+e*(kb*-17.344563108114+mb*(kb*(kb*11.670873077107+-200.58176862096)+nb*(kb*271.96065473796+ob*(kb*-455.11318285818+e*(pb+qb*rb*(kb*3091.9688604755+sb*(tb*(ub+vb*(xb+wb*(yb+zb*(Bb+Ab*(Db+Cb*(Eb+Fb*(Gb+Hb*(Jb+Ib*kb*(kb*(kb*(kb*(+h[(Fz(jb,1,za)|0)>>3]*-415351.64835634+-13105236.545054)+12848734.66465)+1722734991.3197)+252266.40357872)))))))))+11.765048724356)))))+-7.4232016790248)+33.153654801263)+-107.81748091826)+849.51654495535)+1089.8952318288;Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}if(kb<lb*(lb*.00012809002730136+-.67955786399241)+905.84278514723){lb=d+-2.6;Ib=kb+-2.0;c[ya>>2]=1;h[(Fz(jb,1,ya)|0)>>3]=Ib*Ib;c[xa>>2]=1;Jb=Ib*+h[(Fz(jb,1,xa)|0)>>3];c[wa>>2]=2;h[(Fz(jb,1,wa)|0)>>3]=Jb;c[va>>2]=1;Jb=+h[(Fz(jb,1,va)|0)>>3];c[ua>>2]=3;h[(Fz(jb,1,ua)|0)>>3]=Jb*Jb;c[ta>>2]=4;h[(Fz(jb,1,ta)|0)>>3]=lb*lb;c[sa>>2]=4;Jb=+h[(Fz(jb,1,sa)|0)>>3];c[ra>>2]=5;h[(Fz(jb,1,ra)|0)>>3]=Jb*Jb;c[qa>>2]=4;Jb=+h[(Fz(jb,1,qa)|0)>>3];c[pa>>2]=5;Hb=Jb*+h[(Fz(jb,1,pa)|0)>>3];c[oa>>2]=6;h[(Fz(jb,1,oa)|0)>>3]=Hb;c[na>>2]=5;Hb=+h[(Fz(jb,1,na)|0)>>3];c[ma>>2]=7;h[(Fz(jb,1,ma)|0)>>3]=Hb*Hb;c[la>>2]=2;Hb=+h[(Fz(jb,1,la)|0)>>3];c[ka>>2]=1;Jb=+h[(Fz(jb,1,ka)|0)>>3];c[ja>>2]=3;Gb=Hb*(Jb*+h[(Fz(jb,1,ja)|0)>>3]*-1.7565233969407e-18+.00011032831789999);c[ia>>2]=2;Jb=Ib*(Ib*(Ib*(Ib*(+h[(Fz(jb,1,ia)|0)>>3]*-8.1456365207833e-14+2.8640237477456e-7)+.00018955248387902)+-.021810755324761)+3.3593118604916);c[ha>>2]=5;Hb=+h[(Fz(jb,1,ha)|0)>>3];c[ga>>2]=4;Fb=+h[(Fz(jb,1,ga)|0)>>3];c[fa>>2]=1;Eb=+h[(Fz(jb,1,fa)|0)>>3]*-.10829784403677;c[ea>>2]=5;Cb=+h[(Fz(jb,1,ea)|0)>>3];c[da>>2]=1;Db=Ib*((Ib*-10779857357512.0e-18+.0030891541160537)*+h[(Fz(jb,1,da)|0)>>3]+.16844539671904);c[ca>>2]=6;Ab=+h[(Fz(jb,1,ca)|0)>>3];c[ba>>2]=1;Bb=Ib*(Ib*((Ib*2.821728163504e-7+-76462712454814.0e-18)*+h[(Fz(jb,1,ba)|0)>>3]+-.046333324635812)+.73875745236695);c[aa>>2]=6;zb=+h[(Fz(jb,1,aa)|0)>>3];c[$>>2]=1;yb=Ib*((Ib*(Ib*12704902271945.0e-19+14052392818316.0e-18)+.0013555504554949)*+h[(Fz(jb,1,$)|0)>>3]+-.47128737436186);c[_>>2]=5;wb=+h[(Fz(jb,1,_)|0)>>3];c[Z>>2]=2;xb=+h[(Fz(jb,1,Z)|0)>>3];c[Y>>2]=1;vb=Ib*(xb*((Ib*-2.5180545682962e-11+-1.1030139238909e-8)*+h[(Fz(jb,1,Y)|0)>>3]+-31083814331434.0e-18)+.15020273139707);c[X>>2]=5;xb=+h[(Fz(jb,1,X)|0)>>3];c[W>>2]=7;ub=+h[(Fz(jb,1,W)|0)>>3];c[V>>2]=1;tb=+h[(Fz(jb,1,V)|0)>>3];c[U>>2]=3;Kb=Ib*.93747147377932+lb*(Gb+lb*(Jb+Hb*(Ib*3.3809355601454+Fb*(Eb+Cb*(Db+Ab*(Bb+zb*(yb+wb*(vb+xb*ub*(Ib*(Ib*(tb*(Ib*(+h[(Fz(jb,1,U)|0)>>3]*8.6934156344163e-15+7.3803353468292e-8)+-10302738212103.0e-19)+71280351959551.0e-18)+-.002176411421975)+.0085208123431544)+-.47811863648625)+1.1385952129658)+-.63281320016026)+2.4742464705674)))+-97.708318797837)+743.07798314034)+1489.5041079516;Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}else{Ib=d+-1.8;d=kb+25.0;c[T>>2]=1;h[(Fz(jb,1,T)|0)>>3]=d*d;c[S>>2]=1;kb=+h[(Fz(jb,1,S)|0)>>3];c[R>>2]=2;h[(Fz(jb,1,R)|0)>>3]=kb*kb;c[Q>>2]=1;kb=+h[(Fz(jb,1,Q)|0)>>3];c[P>>2]=2;tb=kb*d*+h[(Fz(jb,1,P)|0)>>3];c[O>>2]=3;h[(Fz(jb,1,O)|0)>>3]=tb;c[N>>2]=3;tb=1.0/+h[(Fz(jb,1,N)|0)>>3];c[M>>2]=4;h[(Fz(jb,1,M)|0)>>3]=tb;c[L>>2]=1;tb=+h[(Fz(jb,1,L)|0)>>3];c[K>>2]=2;kb=tb*+h[(Fz(jb,1,K)|0)>>3];c[J>>2]=5;h[(Fz(jb,1,J)|0)>>3]=kb;c[I>>2]=6;h[(Fz(jb,1,I)|0)>>3]=Ib*Ib;c[H>>2]=2;kb=+h[(Fz(jb,1,H)|0)>>3];c[G>>2]=7;h[(Fz(jb,1,G)|0)>>3]=kb*kb;c[F>>2]=6;kb=+h[(Fz(jb,1,F)|0)>>3];c[E>>2]=8;h[(Fz(jb,1,E)|0)>>3]=kb*kb;c[D>>2]=1;kb=+h[(Fz(jb,1,D)|0)>>3];c[C>>2]=5;tb=kb*(+h[(Fz(jb,1,C)|0)>>3]*1.126159740723e-12+482.19755109255)+859777.2253558;c[B>>2]=1;kb=tb/+h[(Fz(jb,1,B)|0)>>3];c[A>>2]=2;tb=d*(+h[(Fz(jb,1,A)|0)>>3]*31081.088422714+20825544563.171)+-583401318515.9;c[z>>2]=5;ub=tb/+h[(Fz(jb,1,z)|0)>>3];c[y>>2]=6;tb=+h[(Fz(jb,1,y)|0)>>3];c[x>>2]=8;xb=+h[(Fz(jb,1,x)|0)>>3];c[w>>2]=6;vb=+h[(Fz(jb,1,w)|0)>>3];c[v>>2]=5;wb=+h[(Fz(jb,1,v)|0)>>3]*1.2324579690832e-7;c[u>>2]=6;yb=+h[(Fz(jb,1,u)|0)>>3];c[t>>2]=5;zb=+h[(Fz(jb,1,t)|0)>>3]*-11606921130984.0e-19;c[s>>2]=8;Bb=+h[(Fz(jb,1,s)|0)>>3];c[r>>2]=5;Ab=+h[(Fz(jb,1,r)|0)>>3]*27846367088554.0e-18;c[q>>2]=5;Db=+h[(Fz(jb,1,q)|0)>>3]*-.00059270038474176;c[p>>2]=5;Cb=+h[(Fz(jb,1,p)|0)>>3];c[o>>2]=6;Eb=Db+Cb*+h[(Fz(jb,1,o)|0)>>3]*.0012918582991878;c[n>>2]=8;Cb=xb*(d*-10.842984880077+vb*(wb+yb*(zb+Bb*(Ab+ +h[(Fz(jb,1,n)|0)>>3]*Eb))));c[m>>2]=4;Eb=+h[(Fz(jb,1,m)|0)>>3];c[l>>2]=7;Ab=+h[(Fz(jb,1,l)|0)>>3];c[k>>2]=2;Bb=Ib*(kb+Ib*(ub+tb*(Cb+Eb*(Ab*(d*(+h[(Fz(jb,1,k)|0)>>3]*-1.7804982240686e-11+-.04536417267666)+3.7966001272486)+7326335090218.1))));c[j>>2]=4;Ab=+h[(Fz(jb,1,j)|0)>>3];c[g>>2]=1;Eb=+h[(Fz(jb,1,g)|0)>>3];c[f>>2]=5;Kb=Bb+Ab*(d*(d*(Eb*d*(d*(d*(+h[(Fz(jb,1,f)|0)>>3]*1.4559115658698e-13+1208.2315865936)+-25745.72360417)+610747.83564516)+-10783068217.47)+358250899454.47)+-3236839855524.2);Lb=a;Mb=Lb;h[Mb>>3]=Kb;i=b;return}}function Kh(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0,R=0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0,da=0,ea=0,fa=0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0;g=i;i=i+192|0;j=g;k=g+24|0;l=g+112|0;m=g+136|0;n=g+160|0;o=g+184|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+88|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+88|0;F=i;i=i+16|0;if(!(d>=16529200.0)){G=lz(lz(9328,jz(d,0,1,6)|0)|0,9400)|0;H=lz(lz(G,jz(16529200.0,0,1,6)|0)|0,9408)|0;G=c[28994]|0;I=n;J=9416;c[I+0>>2]=c[J+0>>2];c[I+4>>2]=c[J+4>>2];c[I+8>>2]=c[J+8>>2];c[I+12>>2]=c[J+12>>2];c[I+16>>2]=c[J+16>>2];c[I+20>>2]=c[J+20>>2];De[G&31](b,n,H,r);}if(!(e>=623.15)){r=lz(lz(9440,jz(e,0,1,6)|0)|0,9512)|0;H=lz(lz(r,jz(623.15,0,1,6)|0)|0,9520)|0;r=c[28994]|0;n=m;G=9528;c[n+0>>2]=c[G+0>>2];c[n+4>>2]=c[G+4>>2];c[n+8>>2]=c[G+8>>2];c[n+12>>2]=c[G+12>>2];c[n+16>>2]=c[G+16>>2];c[n+20>>2]=c[G+20>>2];De[r&31](b,m,H,q);}Lh(t,0,e);if(!(+h[t>>3]<=d)){t=lz(lz(9552,jz(d,0,1,6)|0)|0,9624)|0;q=lz(lz(t,jz(e,0,1,6)|0)|0,9520)|0;t=c[28994]|0;H=l;m=9640;c[H+0>>2]=c[m+0>>2];c[H+4>>2]=c[m+4>>2];c[H+8>>2]=c[m+8>>2];c[H+12>>2]=c[m+12>>2];c[H+16>>2]=c[m+16>>2];c[H+20>>2]=c[m+20>>2];De[t&31](b,l,q,p);}Mh(u,b,d);do{if(d>22064.0e3){K=+h[u>>3];Nh(v,0,d);L=+h[v>>3];Oh(w,0,d);M=+h[w>>3];N=L-(e+-623.15)*((L-M)/(623.15-K));O=L;P=M}else{Ih(x,b,d);if(+h[x>>3]>e){Nh(y,0,d);M=+h[y>>3];Ph(z,0,d);L=+h[z>>3];Qh(A,b,e);N=+h[A>>3]*1.1;O=M;P=L;break}else{Rh(B,0,d);L=+h[B>>3];Oh(C,0,d);M=+h[C>>3];Sh(D,b,e);N=+h[D>>3]*.9;O=L;P=M;break}}}while(0);D=E;C=E+8|0;B=E+16|0;A=E+24|0;z=E+32|0;y=E+40|0;x=E+48|0;w=E+56|0;v=E+64|0;u=E+72|0;p=E+80|0;q=s;l=s+8|0;t=s+16|0;m=s+24|0;H=s+32|0;r=s+40|0;G=s+48|0;n=s+56|0;J=s+64|0;I=s+72|0;Q=s+80|0;R=F;S=F+8|0;M=O+-3.162277660168379e-8;L=P+3.162277660168379e-8;K=N;T=0;while(1){uh(E,b,K,e);N=+h[C>>3];V=+h[B>>3];W=+h[A>>3];X=+h[z>>3];Y=+h[y>>3];Z=+h[x>>3];_=+h[w>>3];$=+h[v>>3];aa=+h[u>>3];ba=+h[p>>3];h[q>>3]=+h[D>>3];h[l>>3]=N;h[t>>3]=V;h[m>>3]=W;h[H>>3]=X;h[r>>3]=Y;h[G>>3]=Z;h[n>>3]=_;h[J>>3]=$;h[I>>3]=aa;h[Q>>3]=ba;ca=k+0|0;da=s+0|0;ea=ca+88|0;do{c[ca>>2]=c[da>>2];ca=ca+4|0;da=da+4|0}while((ca|0)<(ea|0));nh(F,0,k);ba=+h[R>>3]-d;fa=!(+U(+(ba/d))<=f);ga=K-ba*(1.0/+h[S>>3]);do{if(ga>P&ga<O){ha=ga}else{if(ga>O){ha=M;break}ha=L}}while(0);da=T+1|0;if((da|0)<50&fa){K=ha;T=da}else{break}}T=fa&1;if(!fa){ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}fa=c[28994]|0;S=j;R=9664;c[S+0>>2]=c[R+0>>2];c[S+4>>2]=c[R+4>>2];c[S+8>>2]=c[R+8>>2];c[S+12>>2]=c[R+12>>2];c[S+16>>2]=c[R+16>>2];c[S+20>>2]=c[R+20>>2];De[fa&31](b,j,9688,o);ia=a;ja=ia;h[ja>>3]=ga;ka=a;la=ka+8|0;ma=la;c[ma>>2]=T;i=g;return}function Lh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0;b=i;i=i+8|0;e=b;f=i;i=i+16|0;c[e>>2]=5;Az(f,1,e);h[a>>3]=((d*.0010192970039326+-1.1671859879975)*d+348.05185628969)*1.0e6;i=b;return}function Mh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0,t=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;k=i;i=i+16|0;c[j>>2]=5;Az(k,1,j);j=k;k=9912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];l=d/1.0e6;if(d>611.657){m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}k=lz(lz(9928,jz(d,0,1,6)|0)|0,5248)|0;j=lz(lz(k,jz(611.657,0,1,6)|0)|0,5256)|0;k=c[28994]|0;s=f;t=1e4;c[s+0>>2]=c[t+0>>2];c[s+4>>2]=c[t+4>>2];c[s+8>>2]=c[t+8>>2];c[s+12>>2]=c[t+12>>2];c[s+16>>2]=c[t+16>>2];c[s+20>>2]=c[t+20>>2];De[k&31](b,f,j,g);m=l/.0010192970039326;n=m+-13655.33276873084;o=+V(+n);p=o+572.54459862746;q=a;r=q;h[r>>3]=p;i=e;return}function Nh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;c[r>>2]=3;Az(s,1,r);t=d*-6.04960677555959e-8+7.1;c[q>>2]=1;h[(Fz(s,1,q)|0)>>3]=t*t;c[p>>2]=1;d=+h[(Fz(s,1,p)|0)>>3];c[o>>2]=2;h[(Fz(s,1,o)|0)>>3]=d*d;c[n>>2]=2;d=+h[(Fz(s,1,n)|0)>>3];c[m>>2]=3;h[(Fz(s,1,m)|0)>>3]=d*d;c[l>>2]=1;d=+h[(Fz(s,1,l)|0)>>3];c[k>>2]=2;u=+h[(Fz(s,1,k)|0)>>3];c[j>>2]=3;v=+h[(Fz(s,1,j)|0)>>3];c[g>>2]=1;w=+h[(Fz(s,1,g)|0)>>3];c[f>>2]=1;x=+h[(Fz(s,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=57.4756752485113/(t*(t*(t*(t*(d*t*(u*v*t*(w*(x*(t*(t*(t*2.73712834080283e-24+-5.17859076694812e-23)+3.29199117056433e-22)+-7.02987180039442e-22)*+h[(Fz(s,1,e)|0)>>3]+-3.11228834832975e-19)+1.35549330686006e-17)+1.13217858826367e-8)+199080616601101.0e-20)+114683182476084.0e-19)+.000102697173772229)+.00145092247736023)+.0737412153522555);i=b;return}function Oh(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0.0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+16|0;c[Ka>>2]=13;Az(La,1,Ka);Ma=d/1.0e6;Na=+V(+(Ma+-13.91883977887));c[Ja>>2]=1;h[(Fz(La,1,Ja)|0)>>3]=Na;c[Ia>>2]=1;Oa=540.0/(+h[(Fz(La,1,Ia)|0)>>3]*31.3220101646784+572.54459862746)+-.5;c[Ha>>2]=2;h[(Fz(La,1,Ha)|0)>>3]=Oa*Oa;c[Ga>>2]=2;Pa=Oa*+h[(Fz(La,1,Ga)|0)>>3];c[Fa>>2]=3;h[(Fz(La,1,Fa)|0)>>3]=Pa;c[Ea>>2]=2;Pa=+h[(Fz(La,1,Ea)|0)>>3];c[Da>>2]=4;h[(Fz(La,1,Da)|0)>>3]=Pa*Pa;c[Ca>>2]=4;Pa=+h[(Fz(La,1,Ca)|0)>>3];c[Ba>>2]=5;h[(Fz(La,1,Ba)|0)>>3]=Pa*Pa;c[Aa>>2]=5;Pa=+h[(Fz(La,1,Aa)|0)>>3];c[za>>2]=6;h[(Fz(La,1,za)|0)>>3]=Pa*Pa;c[ya>>2]=4;Pa=+h[(Fz(La,1,ya)|0)>>3];c[xa>>2]=5;Qa=+h[(Fz(La,1,xa)|0)>>3];c[wa>>2]=6;Ra=Pa*Qa*Oa*+h[(Fz(La,1,wa)|0)>>3];c[va>>2]=7;h[(Fz(La,1,va)|0)>>3]=Ra;c[ua>>2]=4;Ra=+h[(Fz(La,1,ua)|0)>>3];c[ta>>2]=5;Qa=Ra*Oa*+h[(Fz(La,1,ta)|0)>>3];c[sa>>2]=8;h[(Fz(La,1,sa)|0)>>3]=Qa;c[ra>>2]=2;Qa=+h[(Fz(La,1,ra)|0)>>3];c[qa>>2]=4;Ra=+h[(Fz(La,1,qa)|0)>>3];c[pa>>2]=5;Pa=Qa*Ra*+h[(Fz(La,1,pa)|0)>>3];c[oa>>2]=9;h[(Fz(La,1,oa)|0)>>3]=Pa;c[na>>2]=10;h[(Fz(La,1,na)|0)>>3]=Ma*Ma;c[ma>>2]=10;Pa=+h[(Fz(La,1,ma)|0)>>3];c[la>>2]=11;h[(Fz(La,1,la)|0)>>3]=Pa*Pa;c[ka>>2]=4;Pa=+h[(Fz(La,1,ka)|0)>>3];c[ja>>2]=6;Ra=Pa*Oa*+h[(Fz(La,1,ja)|0)>>3];c[ia>>2]=12;h[(Fz(La,1,ia)|0)>>3]=Ra;c[ha>>2]=6;Ra=+h[(Fz(La,1,ha)|0)>>3];c[ga>>2]=13;h[(Fz(La,1,ga)|0)>>3]=Ra*Ra;c[fa>>2]=3;Ra=Oa*(Oa*(Oa*(+h[(Fz(La,1,fa)|0)>>3]*-.05032527872793+-.057581259083432)+-.045996013696365)+-.017834862292358);c[ea>>2]=2;Pa=+h[(Fz(La,1,ea)|0)>>3];c[da>>2]=3;Qa=+h[(Fz(La,1,da)|0)>>3];c[ca>>2]=7;Sa=Oa*(Oa*(Pa*(Qa*(+h[(Fz(La,1,ca)|0)>>3]*-53349095828174.0e-18+-.087594591301146)+-.007878555448671)+-.0003789797503263)+-66065283340406.0e-18);c[ba>>2]=2;Qa=+h[(Fz(La,1,ba)|0)>>3];c[aa>>2]=3;Pa=+h[(Fz(La,1,aa)|0)>>3];c[$>>2]=7;Ta=Oa*(Qa*(Pa*(+h[(Fz(La,1,$)|0)>>3]*-.122004760687947+-.0045101773626444)+-9683303171571.0e-17)+131612001853305.0e-20);c[_>>2]=2;Pa=+h[(Fz(La,1,_)|0)>>3];c[Z>>2]=4;Qa=Pa*Oa*+h[(Fz(La,1,Z)|0)>>3]*114610381688305.0e-19;c[Y>>2]=3;Pa=+h[(Fz(La,1,Y)|0)>>3];c[X>>2]=8;Ua=+h[(Fz(La,1,X)|0)>>3];c[W>>2]=2;Va=+h[(Fz(La,1,W)|0)>>3];c[U>>2]=6;Wa=Pa*(Ua*(Va*Oa*+h[(Fz(La,1,U)|0)>>3]*-143.374451604624+-.012702883392813)+-1.00288598706366e-10);c[T>>2]=2;Va=+h[(Fz(La,1,T)|0)>>3];c[S>>2]=5;Ua=+h[(Fz(La,1,S)|0)>>3];c[R>>2]=9;Pa=Va*Ua*Oa*(+h[(Fz(La,1,R)|0)>>3]*-.272627897050173+-88352662293707.0e-19);c[Q>>2]=5;Ua=+h[(Fz(La,1,Q)|0)>>3];c[P>>2]=4;Va=+h[(Fz(La,1,P)|0)>>3];c[O>>2]=5;Xa=+h[(Fz(La,1,O)|0)>>3];c[N>>2]=6;Ya=Ua*(Va*Xa*+h[(Fz(La,1,N)|0)>>3]*-65.8490727183984+9.0049690883672e-11);c[M>>2]=8;Xa=+h[(Fz(La,1,M)|0)>>3]*1.78287415218792e-7;c[L>>2]=4;Va=+h[(Fz(La,1,L)|0)>>3];c[K>>2]=2;Ua=+h[(Fz(La,1,K)|0)>>3];c[J>>2]=4;Za=+h[(Fz(La,1,J)|0)>>3]*-1.0018179379511e-8+-1.0234747095929e-12;c[I>>2]=4;_a=Va*(Ua*Za*+h[(Fz(La,1,I)|0)>>3]+1.0406965210174e-18);c[H>>2]=10;Za=+h[(Fz(La,1,H)|0)>>3];c[G>>2]=11;Ua=+h[(Fz(La,1,G)|0)>>3];c[F>>2]=12;Va=+h[(Fz(La,1,F)|0)>>3]*1.71088510070544+-1.29412653835176e-9;c[E>>2]=7;$a=Va*+h[(Fz(La,1,E)|0)>>3];c[D>>2]=10;Va=+h[(Fz(La,1,D)|0)>>3];c[C>>2]=13;ab=+h[(Fz(La,1,C)|0)>>3];c[B>>2]=5;bb=+h[(Fz(La,1,B)|0)>>3];c[A>>2]=6;cb=ab*bb*Oa*+h[(Fz(La,1,A)|0)>>3]*-6.05920510335078;c[z>>2]=10;bb=+h[(Fz(La,1,z)|0)>>3];c[y>>2]=4;ab=+h[(Fz(La,1,y)|0)>>3];c[x>>2]=6;db=+h[(Fz(La,1,x)|0)>>3];c[w>>2]=2;eb=+h[(Fz(La,1,w)|0)>>3];c[v>>2]=4;fb=+h[(Fz(La,1,v)|0)>>3];c[u>>2]=5;gb=+h[(Fz(La,1,u)|0)>>3];c[t>>2]=8;hb=ab*db*(eb*fb*gb*Oa*(+h[(Fz(La,1,t)|0)>>3]*-84004935396416.0e-18+6.1258633752464e-12)+1.78371690710842e-23);c[s>>2]=12;gb=+h[(Fz(La,1,s)|0)>>3]*-1.24017662339842e-24;c[r>>2]=13;fb=+h[(Fz(La,1,r)|0)>>3];c[q>>2]=4;eb=+h[(Fz(La,1,q)|0)>>3];c[p>>2]=6;db=fb*eb*Oa*+h[(Fz(La,1,p)|0)>>3]*832192847496054.0e-19;c[o>>2]=2;eb=+h[(Fz(La,1,o)|0)>>3];c[n>>2]=5;fb=+h[(Fz(La,1,n)|0)>>3];c[m>>2]=6;ab=+h[(Fz(La,1,m)|0)>>3];c[l>>2]=2;ib=+h[(Fz(La,1,l)|0)>>3];c[k>>2]=6;jb=ib*+h[(Fz(La,1,k)|0)>>3]*-226487297378904.0e-19+1.32995316841867e-15;c[j>>2]=9;ib=eb*fb*ab*Ma*(+h[(Fz(La,1,j)|0)>>3]*jb+1.75410265428146e-27);c[g>>2]=13;jb=+h[(Fz(La,1,g)|0)>>3];c[f>>2]=2;ab=+h[(Fz(La,1,f)|0)>>3];c[e>>2]=4;h[a>>3]=d/((Na*31.3220101646784+572.54459862746)*Ma*((Ma*(Ra+Ma*(Sa+Ma*(Ta+Ma*(Oa*(Oa*(Oa*192901490874028.0e-20+5.116287140914e-8)+-3.15389238237468e-9)+Ma*(Qa+Ma*(Wa+Ma*(Pa+Ma*(Ya+Ma*(Xa+Ma*(_a+Za*Ua*($a+Va*(cb+bb*(hb+Ma*(gb+Ma*(db+Ma*(ib+jb*ab*Oa*+h[(Fz(La,1,e)|0)>>3]*-2.93678005497663e-14)))))))))+-4.1341695026989e-17))))+6.1445213076927e-8))+-.0017731742473213)+1.0)/Ma)*461.526);i=b;return}function Ph(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*.00052536560808895+-191.4307733640516)+673.2581177021598)+-994.5385383600702)+796.6627910598293)+-369.3676833623383)+94.34196116778385)+-8.191449323843552)+-2.531486180240112)+1.903224079094824)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function Qh(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Bh(e,b,c);j=+h[e>>3];do{if(c<623.15){Vh(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Ph(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Rh(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0,e=0,f=0,g=0.0;b=i;if(!(c<22064.0e3)){d=322.0;e=a;f=e;h[f>>3]=d;i=b;return}g=+_(+(c/22064.0e3));d=(g*(g*(g*(g*(g*(g*(g*(g*(g*(g*-.001115111165833234+725.8761975803782)+-2537.375817253895)+3740.579034867006)+-3015.853540307519)+1437.200724533239)+-403.5391431811611)+59.18702203076563)+-1.144787271887849)+-1.84638508033626)+1.0)*322.0;e=a;f=e;h[f>>3]=d;i=b;return}function Sh(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0,g=0,j=0.0,k=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;Bh(e,b,c);j=+h[e>>3];do{if(c<623.15){_h(f,0,j,c);k=+h[f>>3]}else{if(!(c<647.096)){k=322.0;break}Rh(g,0,j);k=+h[g>>3]}}while(0);h[a>>3]=k;i=d;return}function Th(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;i=i+32|0;j=g;k=g+24|0;l=i;i=i+88|0;m=l+32|0;n=l+64|0;o=l+72|0;p=1500.0;q=0;do{Ah(l,b,d,p);r=+h[m>>3];s=p*r*+h[n>>3]*461.526-e;t=+U(+(s/e))<f;p=p-s/(r*r*+h[o>>3]*-461.526);q=q+1|0;u=t^1;}while((q|0)<50&u);q=u&1;if(t){v=a;w=v;h[w>>3]=p;x=a;y=x+8|0;z=y;c[z>>2]=q;i=g;return}t=c[28994]|0;u=j;o=9744;c[u+0>>2]=c[o+0>>2];c[u+4>>2]=c[o+4>>2];c[u+8>>2]=c[o+8>>2];c[u+12>>2]=c[o+12>>2];c[u+16>>2]=c[o+16>>2];c[u+20>>2]=c[o+20>>2];De[t&31](b,j,9768,k);v=a;w=v;h[w>>3]=p;x=a;y=x+8|0;z=y;c[z>>2]=q;i=g;return}function Uh(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;d=+_(+(c/22064.0e3));h[a>>3]=(d*(d*(d*(d*(d*(d*(d*(d*-.0001152032945617821+-.717981855497894)+3.558919744656498)+-6.75820241066552)+6.679385472887931)+-3.889388153209752)+1.346800016564904)+-.4945586958175176)+1.0)*2087546.84511715;i=i;return}function Vh(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;c[sa>>2]=11;Az(ta,1,sa);ua=d/1653.0e4;va=7.1-ua;wa=1386.0/e+-1.222;c[ra>>2]=1;h[(Fz(ta,1,ra)|0)>>3]=wa*wa;c[qa>>2]=1;xa=+h[(Fz(ta,1,qa)|0)>>3];c[pa>>2]=2;h[(Fz(ta,1,pa)|0)>>3]=xa*xa;c[oa>>2]=2;xa=+h[(Fz(ta,1,oa)|0)>>3];c[na>>2]=3;h[(Fz(ta,1,na)|0)>>3]=xa*xa;c[ma>>2]=1;xa=+h[(Fz(ta,1,ma)|0)>>3];c[la>>2]=2;ya=xa*+h[(Fz(ta,1,la)|0)>>3];c[ka>>2]=4;h[(Fz(ta,1,ka)|0)>>3]=ya;c[ja>>2]=1;ya=wa*+h[(Fz(ta,1,ja)|0)>>3];c[ia>>2]=5;h[(Fz(ta,1,ia)|0)>>3]=ya;c[ha>>2]=2;ya=wa*+h[(Fz(ta,1,ha)|0)>>3];c[ga>>2]=6;h[(Fz(ta,1,ga)|0)>>3]=ya;c[fa>>2]=7;h[(Fz(ta,1,fa)|0)>>3]=va*va;c[ea>>2]=7;ya=+h[(Fz(ta,1,ea)|0)>>3];c[da>>2]=8;h[(Fz(ta,1,da)|0)>>3]=ya*ya;c[ca>>2]=8;ya=+h[(Fz(ta,1,ca)|0)>>3];c[ba>>2]=9;h[(Fz(ta,1,ba)|0)>>3]=ya*ya;c[aa>>2]=3;ya=+h[(Fz(ta,1,aa)|0)>>3];c[$>>2]=10;h[(Fz(ta,1,$)|0)>>3]=ya*ya;c[_>>2]=10;ya=+h[(Fz(ta,1,_)|0)>>3];c[Z>>2]=11;h[(Fz(ta,1,Z)|0)>>3]=ya*ya;c[Y>>2]=2;ya=+h[(Fz(ta,1,Y)|0)>>3];c[X>>2]=4;xa=ya*(+h[(Fz(ta,1,X)|0)>>3]*2.55615384360309e-9+84812393955936.0e-19)+95038934535162.0e-18;c[W>>2]=2;ya=xa/+h[(Fz(ta,1,W)|0)>>3];c[V>>2]=2;xa=+h[(Fz(ta,1,V)|0)>>3];c[U>>2]=3;za=xa*+h[(Fz(ta,1,U)|0)>>3]*5.7366919751696e-13+260684891582404.0e-20;c[T>>2]=5;xa=+h[(Fz(ta,1,T)|0)>>3]*za+89701127632.0e-16;c[S>>2]=6;za=xa/+h[(Fz(ta,1,S)|0)>>3];c[R>>2]=3;xa=202584984300585.0e-20/+h[(Fz(ta,1,R)|0)>>3];c[Q>>2]=7;Aa=+h[(Fz(ta,1,Q)|0)>>3];c[P>>2]=8;Ba=+h[(Fz(ta,1,P)|0)>>3];c[O>>2]=9;Ca=+h[(Fz(ta,1,O)|0)>>3];c[N>>2]=7;Da=+h[(Fz(ta,1,N)|0)>>3];c[M>>2]=7;Ea=+h[(Fz(ta,1,M)|0)>>3];c[L>>2]=8;Fa=+h[(Fz(ta,1,L)|0)>>3];c[K>>2]=11;Ga=+h[(Fz(ta,1,K)|0)>>3];c[J>>2]=3;Ha=va/(wa*Ga*+h[(Fz(ta,1,J)|0)>>3])*2.99318679335866e-24;c[I>>2]=11;Ga=+h[(Fz(ta,1,I)|0)>>3];c[H>>2]=3;Ia=va*(Ha+-5.65070932023524e-23/(Ga*+h[(Fz(ta,1,H)|0)>>3]));c[G>>2]=1;Ga=+h[(Fz(ta,1,G)|0)>>3];c[F>>2]=11;Ha=Ga*+h[(Fz(ta,1,F)|0)>>3];c[E>>2]=2;Ga=va*(Ia+3.5842867920213e-22/(wa*Ha*+h[(Fz(ta,1,E)|0)>>3]));c[D>>2]=1;Ha=+h[(Fz(ta,1,D)|0)>>3];c[C>>2]=11;Ia=Ha*+h[(Fz(ta,1,C)|0)>>3];c[B>>2]=2;Ha=Ea*Fa*(Ga+-7.63737668221055e-22/(Ia*+h[(Fz(ta,1,B)|0)>>3]));c[A>>2]=1;Ia=+h[(Fz(ta,1,A)|0)>>3];c[z>>2]=10;Ga=Ia*+h[(Fz(ta,1,z)|0)>>3];c[y>>2]=2;Ia=Ga*+h[(Fz(ta,1,y)|0)>>3];c[x>>2]=3;Ga=Da*(Ha+-3.33001080055983e-19/(wa*Ia*+h[(Fz(ta,1,x)|0)>>3]));c[w>>2]=10;Ia=+h[(Fz(ta,1,w)|0)>>3];c[v>>2]=2;Ha=Ia*+h[(Fz(ta,1,v)|0)>>3];c[u>>2]=3;Ia=Ba*Ca*va*(Ga+1.44400475720615e-17/(wa*Ha*+h[(Fz(ta,1,u)|0)>>3]));c[t>>2]=6;Ha=+h[(Fz(ta,1,t)|0)>>3]*1.39398969845072e-9+1.01874413933128e-8;c[s>>2]=1;Ga=+h[(Fz(ta,1,s)|0)>>3];c[r>>2]=3;Ca=va*(ya+va*(za+va*(xa+Aa*va*(Ia+Ha/(wa*Ga*+h[(Fz(ta,1,r)|0)>>3])))));c[q>>2]=5;Ga=+h[(Fz(ta,1,q)|0)>>3];c[p>>2]=1;Ha=+h[(Fz(ta,1,p)|0)>>3];c[o>>2]=1;Ia=+h[(Fz(ta,1,o)|0)>>3];c[n>>2]=2;Aa=+h[(Fz(ta,1,n)|0)>>3];c[m>>2]=3;xa=Ga*(wa*(Ha*(Ia*Aa*+h[(Fz(ta,1,m)|0)>>3]*1.45389992595188e-15+88283690661692.0e-19)+-95322787813974.0e-18)+.00060003561586052)+.00094368642146534;c[l>>2]=5;Aa=va*(Ca+xa/+h[(Fz(ta,1,l)|0)>>3]);c[k>>2]=1;xa=+h[(Fz(ta,1,k)|0)>>3];c[j>>2]=4;Ca=+h[(Fz(ta,1,j)|0)>>3];c[g>>2]=1;va=xa*(Ca*(wa*(wa*(+h[(Fz(ta,1,g)|0)>>3]*5283835796993.0e-17+.021841717175414)+.032529748770505)+.018990068218419)+.00060706301565874)+-.00028319080123804;c[f>>2]=3;h[a>>3]=d/(ua*(Aa+va/(wa*+h[(Fz(ta,1,f)|0)>>3]))*e*461.526);i=b;return}function Wh(b,c,d){b=b|0;c=c|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0;e=i;i=i+216|0;f=e+8|0;g=e+16|0;j=e+24|0;k=e+112|0;l=e+120|0;m=e+208|0;n=e;o=+od(+d,22063999.9999999);Ih(f,c,o);p=+h[f>>3];xh(g,c,p);q=+h[g>>3];g=p>623.15;f=g&1;if(g){Ph(k,0,o);r=+h[k>>3];uh(l,c,r,p);s=+h[l+16>>3];t=+h[l+24>>3];u=+h[l+32>>3];v=+h[l+40>>3];w=+h[l+48>>3];x=+h[l+56>>3];y=+h[l+64>>3];z=+h[l+72>>3];A=+h[l+80>>3];Uh(m,0,o);B=r*t*(w-u*A)*461.526;C=p*t*(w*2.0+t*x)*461.526;D=0.0;E=0.0;F=r;G=+h[m>>3];H=s*(u*y-v);I=0.0;J=u*u*z*-461.526}else{yh(j,c,d,p);z=+h[j+24>>3];u=+h[j+32>>3];v=+h[j+48>>3];y=+h[j+56>>3];s=+h[j+80>>3];r=z*v;x=u*+h[j+64>>3];if(o<d){K=2087546.84511715}else{K=p*x*461.526}o=+h[j+16>>3]*(x- +h[j+40>>3]);x=u*u*+h[j+72>>3]*-461.526;B=-((v-u*s)/(p*z*y)*d);C=p*(v*v/y)*-461.526;D=(r-u*z*s)/d*461.526;E=p*z*z*y*+iA(d,-2)*461.526;F=d/(p*r*461.526);G=K;H=o;I=x;J=0.0}j=b;a[j]=f;f=j+1|0;a[f+0|0]=a[n+0|0]|0;a[f+1|0]=a[n+1|0]|0;a[f+2|0]=a[n+2|0]|0;a[f+3|0]=a[n+3|0]|0;a[f+4|0]=a[n+4|0]|0;a[f+5|0]=a[n+5|0]|0;a[f+6|0]=a[n+6|0]|0;h[b+8>>3]=461.526;h[b+16>>3]=p;h[b+24>>3]=F;h[b+32>>3]=G;h[b+40>>3]=H;h[b+48>>3]=I;h[b+56>>3]=J;h[b+64>>3]=q;h[b+72>>3]=B;h[b+80>>3]=C;h[b+88>>3]=D;h[b+96>>3]=E;i=e;return}



function vt(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=56008;u=yt(55992,55984,56e3,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;ut(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;xt(k,d,e,m,l,f,55992)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;xt(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,55992)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;st(56016,56024,56032,56048,n,k,56056,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=56032;rt(H,H,k,l,n,56064,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,56056,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);ut(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(55984,j|0)|0;i=h;return 0}function wt(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(SA(a,56072)|0)!=0;do{if(n){o=5}else{if((SA(a,56080)|0)!=0){o=5;break}if((SA(a,56088)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=56104;xt(d,h,j,q,b,g,q)|0;st(56112,56120,56128,56144,b,d,56152,e,f,h,j)|0;st(56112,56160,56128,56168,b,d,56152,e,f,h,j)|0;i=l;return 0}else{st(56112,56160,56184,56168,b,d,56152,e,f,h,j)|0;st(56112,56120,56184,56144,b,d,56152,e,f,h,j)|0;xt(d,h,j,56104,b,g,56200)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(56096,m|0)|0;i=l;return 0}function xt(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function yt(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=T1(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;_Q(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;_Q(t,o+1|0,1,2);l=m;_Q(l,o+3|0,1,3);o=n;_Q(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((ZQ(t,56208,1,2)|0)==0){if((ZQ(l,56224,1,3)|0)==0){v=2;i=k;return v|0}if((ZQ(l,56232,1,3)|0)==0){v=2;i=k;return v|0}if((ZQ(l,56240,1,3)|0)==0){v=2;i=k;return v|0}if((ZQ(l,56248,1,3)|0)==0){v=2;i=k;return v|0}if((ZQ(l,56256,1,3)|0)==0){v=2;i=k;return v|0}if((ZQ(l,56264,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((ZQ(t,56288,1,2)|0)==0){n=(ZQ(l,56216,1,3)|0)==0;if(n|(p|q)^1){v=n?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==68|u<<24>>24==83){w=94}else if(u<<24>>24==67|u<<24>>24==90){w=91}else{v=2;i=k;return v|0}do{if((w|0)==91){if((ZQ(t,56312,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=94;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((ZQ(t,56320,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((ZQ(o,56328,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56336,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56344,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56352,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56360,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56368,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((ZQ(o,56328,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56336,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56344,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56352,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56360,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56368,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((ZQ(t,56384,1,2)|0)!=0){v=2;i=k;return v|0}n=a[l]|0;if(n<<24>>24==77){if((ZQ(o,56328,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56336,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56344,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56352,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56360,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56368,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==71){if((ZQ(o,56328,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56336,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56344,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56352,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56360,1,2)|0)==0){v=2;i=k;return v|0}if((ZQ(o,56368,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else if((m|0)==3){if((ZQ(t,56208,1,2)|0)==0){if((ZQ(l,56224,1,3)|0)==0){v=128;i=k;return v|0}if((ZQ(l,56232,1,3)|0)==0){v=128;i=k;return v|0}if((ZQ(l,56240,1,3)|0)==0){v=128;i=k;return v|0}if((ZQ(l,56248,1,3)|0)==0){v=128;i=k;return v|0}if((ZQ(l,56256,1,3)|0)==0){v=128;i=k;return v|0}m=(ZQ(l,56264,1,3)|0)==0;v=m?128:0;i=k;return v|0}if((ZQ(t,56288,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}m=(ZQ(l,56296,1,3)|0)==0;v=m?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((ZQ(t,56312,1,2)|0)==0){m=(ZQ(l,56296,1,3)|0)==0;v=m?32:0;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=141;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((ZQ(t,56320,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((ZQ(o,56328,1,2)|0)!=0){if((ZQ(o,56336,1,2)|0)==0){break}if((ZQ(o,56344,1,2)|0)==0){break}if((ZQ(o,56352,1,2)|0)==0){break}if((ZQ(o,56360,1,2)|0)==0){break}if((ZQ(o,56368,1,2)|0)==0){break}if((ZQ(o,56376,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((ZQ(t,56384,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((ZQ(o,56328,1,2)|0)!=0){if((ZQ(o,56336,1,2)|0)==0){break}if((ZQ(o,56344,1,2)|0)==0){break}if((ZQ(o,56352,1,2)|0)==0){break}if((ZQ(o,56360,1,2)|0)==0){break}if((ZQ(o,56368,1,2)|0)==0){break}if((ZQ(o,56376,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else{if((ZQ(t,56208,1,2)|0)==0){if((ZQ(l,56216,1,3)|0)==0){v=64;i=k;return v|0}if((ZQ(l,56224,1,3)|0)==0){v=32;i=k;return v|0}if((ZQ(l,56232,1,3)|0)==0){v=32;i=k;return v|0}if((ZQ(l,56240,1,3)|0)==0){v=32;i=k;return v|0}if((ZQ(l,56248,1,3)|0)==0){v=32;i=k;return v|0}if((ZQ(l,56256,1,3)|0)==0){v=32;i=k;return v|0}if((ZQ(l,56264,1,3)|0)==0){v=32;i=k;return v|0}m=(ZQ(l,56272,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((ZQ(t,56280,1,2)|0)==0){m=(ZQ(l,56216,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((ZQ(t,56288,1,2)|0)==0){m=(ZQ(l,56216,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(ZQ(l,56296,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(ZQ(l,56304,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==68|u<<24>>24==83){w=29}else if(u<<24>>24==67|u<<24>>24==90){if((ZQ(t,56312,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((ZQ(l,56216,1,3)|0)==0){v=64;i=k;return v|0}if((ZQ(l,56296,1,3)|0)==0){v=32;i=k;return v|0}m=(ZQ(l,56304,1,3)|0)==0;v=m?64:1;i=k;return v|0}}while(0);do{if((w|0)==29){if((ZQ(t,56320,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((ZQ(o,56328,1,2)|0)!=0){if((ZQ(o,56336,1,2)|0)==0){break}if((ZQ(o,56344,1,2)|0)==0){break}if((ZQ(o,56352,1,2)|0)==0){break}if((ZQ(o,56360,1,2)|0)==0){break}if((ZQ(o,56368,1,2)|0)==0){break}if((ZQ(o,56376,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((ZQ(o,56328,1,2)|0)!=0){if((ZQ(o,56336,1,2)|0)==0){break}if((ZQ(o,56344,1,2)|0)==0){break}if((ZQ(o,56352,1,2)|0)==0){break}if((ZQ(o,56360,1,2)|0)==0){break}if((ZQ(o,56368,1,2)|0)==0){break}if((ZQ(o,56376,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((ZQ(t,56384,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((ZQ(o,56328,1,2)|0)!=0){if((ZQ(o,56336,1,2)|0)==0){break}if((ZQ(o,56344,1,2)|0)==0){break}if((ZQ(o,56352,1,2)|0)==0){break}if((ZQ(o,56360,1,2)|0)==0){break}if((ZQ(o,56368,1,2)|0)==0){break}if((ZQ(o,56376,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((ZQ(o,56328,1,2)|0)!=0){if((ZQ(o,56336,1,2)|0)==0){break}if((ZQ(o,56344,1,2)|0)==0){break}if((ZQ(o,56352,1,2)|0)==0){break}if((ZQ(o,56360,1,2)|0)==0){break}if((ZQ(o,56368,1,2)|0)==0){break}if((ZQ(o,56376,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((ZQ(t,56392,1,2)|0)==0){if((ZQ(l,56216,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((ZQ(t,56400,1,2)|0)==0){if((ZQ(l,56216,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((ZQ(t,56368,1,2)|0)==0){o=(ZQ(l,56272,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((ZQ(t,56408,1,2)|0)==0){o=(ZQ(l,56416,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((ZQ(t,56424,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 11:{v=zt(56464,56448,56456)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=At(b,d,e,f,g,h,j)|0;i=k;return v|0};case 6:{j=c[f>>2]|0;f=c[g>>2]|0;v=~~(+(((j|0)>(f|0)?f:j)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 9:{v=25;i=k;return v|0};case 10:{v=zt(56440,56448,56456)|0;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function zt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function At(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(YQ(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 14:{p=14;i=j;return p|0};case 12:{p=75;i=j;return p|0};case 15:{p=o;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function Bt(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=Ct(a,0,0)|0;i=b;return c|0}function Ct(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=Dt(a,b,c,0)|0;i=d;return e|0}function Dt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=de[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=p1(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=48;c[f+8>>2]=211}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=de[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){ae[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=de[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){ae[c[b+20>>2]&255](c[j+392>>2]|0);ae[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=Ou(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}ae[c[j+20>>2]&255](c[j+44>>2]|0);ae[c[j+20>>2]&255](c[j+392>>2]|0);ae[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;Pu(j+416|0,j+12|0);Pu(j+440|0,j+12|0);Ft(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}It(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=hv()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=_u()|0}k=j;l=k;i=g;return l|0}function Et(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function Ft(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;qx(f+256|0);if((b|0)!=0){g=Gt(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;$u(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function Gt(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Xt(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function Ht(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Xt(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Xt(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=_t(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=Gt(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Xt(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Xt(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((cu(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Xt(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=_t(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function It(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;ae[c[e+20>>2]&255](c[g+36>>2]|0);Jt(c[g+44>>2]|0,e);ae[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;ae[c[e+20>>2]&255](f)}Jt(c[h+376>>2]|0,e);Jt(c[e+372>>2]|0,e);Kt(e+416|0);Kt(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}Lt(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);ae[c[e+20>>2]&255](c[e+392>>2]|0);ae[c[e+20>>2]&255](c[e+464>>2]|0);ae[c[e+20>>2]&255](c[e+8>>2]|0);ae[c[e+20>>2]&255](c[e+44>>2]|0);ae[c[e+20>>2]&255](c[e+396>>2]|0);ae[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){ae[c[e+252>>2]&255](c[e+244>>2]|0)}ae[c[e+20>>2]&255](e);i=d;return}function Jt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;ae[c[a+20>>2]&255](c[b+16>>2]|0);ae[c[a+20>>2]&255](b)}i=d;return}function Kt(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ae[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;ae[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function Lt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Yt(f,g+20|0);while(1){d=Zt(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}ae[c[b+8>>2]&255](c[d+20>>2]|0)}bu(g);bu(g+132|0);bu(g+20|0);bu(g+40|0);bu(g+60|0);Kt(g+80|0);Kt(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ae[m&255](o);i=e;return}ae[c[b+8>>2]&255](c[g+184>>2]|0);ae[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;ae[m&255](o);i=e;return}function Mt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Nt(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Ot(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((Pt(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=Rt(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{V1(f|0,b|0,d|0)|0;j=St(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Ce[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==1|(d|0)==0){c[h+480>>2]=2}else if((d|0)==3){De[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}j=1;k=j;i=g;return k|0}function Pt(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=Mu()|0}if((a[e+236|0]|0)!=0){f=Ht(e,58248)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function Qt(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function Rt(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;W1(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=de[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;V1(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;ae[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function St(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((Pt(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Ce[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);De[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Tt(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Ut(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}De[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Vt(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){ze[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];Zd[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];ze[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Wt(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[56472+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Xt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;V1((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=se[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=de[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){V1(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Yt(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Zt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function _t(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=de[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){X1(c[m>>2]|0,0,g|0)|0;g=$t(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=$t(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((au(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=de[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}X1(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=$t(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}ae[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=de[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){X1(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function $t(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function au(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function bu(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}ae[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}ae[e&255](c[d>>2]|0);i=b;return}function cu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[58056+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[58096+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=se[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=de[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=de[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}ae[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;V1(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}ze[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function du(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((ge[((a[e+236|0]&255|0)!=0?34:35)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=Lu(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function eu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Ce[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=fu(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function fu(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=te[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=hu(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 1:{t=gu(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=_t(o,l+132|0,58128,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=hu(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}iu(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 7:{if((c[o+84>>2]|0)==0){break c}Zd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;Et(o+416|0);h=0;break};case 57:{v=gu(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=lu(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){Zd[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);Et(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=_t(o,l+132|0,58128,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}ae[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=ku(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=58232}else{x=(s|0)==32?58216:58240}if((mu(o+416|0,x)|0)==0){r=111;break a}if((nu(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=58136;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=58144;r=102;break};case 25:{c[o+332>>2]=58152;r=102;break};case 26:{c[o+332>>2]=58160;r=102;break};case 27:{c[o+332>>2]=58168;r=102;break};case 28:{c[o+332>>2]=58176;r=102;break};case 29:{c[o+332>>2]=58192;r=102;break};case 30:{c[o+332>>2]=58200;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((ou(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Xt(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Xt(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;me[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);Et(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=hu(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=58128}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=_t(o,l+132|0,58128,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=pu(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((ou(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Xt(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Xt(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;me[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);Et(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=qu(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=hu(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;me[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;re[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((ge[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=hu(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=_t(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=hu(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=_t(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=hu(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Vt(o,b,e,c[n>>2]|0)}h=0;D=ru(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=hu(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}iu(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=hu(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;Zd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);Et(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;Zd[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);Et(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=de[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=se[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=se[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=tu(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=hu(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=_t(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}ze[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=uu(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=ku(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=de[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;ze[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((xu(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((wu(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Ce[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=hu(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=tu(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=ku(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=vu(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;ze[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=hu(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}iu(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Vt(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Ce[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((te[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=_t(o,l+132|0,58128,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((te[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((de[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=ju(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function gu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((ce[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=hu(n+440|0,p,b,s+(se[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=hu(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);De[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Vt(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=hu(n+440|0,e,d,m+(se[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=Lu(n,f)|0;Et(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){Et(n+440|0)}q=0;r=q;i=g;return r|0}function hu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((nu(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Xt(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function iu(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function ju(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=Au(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Iu(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function ku(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=hu(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=_t(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((Ju(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function lu(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Xt(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=hu(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=_t(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=_t(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Xt(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Xt(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=_t(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function mu(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Xt(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function nu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Xt(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){Zd[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Xt(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function ou(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=de[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=se[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function pu(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=Ku(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Xt(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function qu(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Xt(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Ce[c[b+20>>2]&63](b,e,f,j)|0){case-1:{r=46;break a;break};case 10:{s=se[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=Ru(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Xt(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-4:{r=24;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}t=hu(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((t|0)==0){r=8;break a}s=_t(l,g+132|0,t,0)|0;c[l+428>>2]=c[l+432>>2];if((s|0)==0){r=10;break a}if((a[s+32|0]|0)!=0){r=12;break a}if((c[s+16>>2]|0)==0){a[s+32|0]=1;n=qu(l,c[l+228>>2]|0,c[s+4>>2]|0,(c[s+4>>2]|0)+(c[s+8>>2]|0)|0)|0;a[s+32|0]=0;if((n|0)!=0){break a}else{break b}}t=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[t+130|0]|0;break b}a[t+131|0]=0;a[s+32|0]=1;t=(te[c[l+112>>2]&63](c[l+116>>2]|0,0,c[s+20>>2]|0,c[s+16>>2]|0,c[s+24>>2]|0)|0)!=0;a[s+32|0]=0;if(!t){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 7:{r=28;break};case 6:case 9:{if((nu(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 0:{r=49;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Xt(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function ru(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Ce[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case 42:{if((c[k+80>>2]|0)!=0){Vt(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function su(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=ru(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=eu(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function tu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=de[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=se[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=de[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function uu(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=de[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Ce[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=fu(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=Au(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function vu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=de[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;zu(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function wu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Vt(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(se[c[a+32>>2]&63](a,b)|0)|0;k=hu(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=se[c[a+36>>2]&63](a,e)|0;e=hu(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){yu(e);ze[c[g+64>>2]&15](c[g+4>>2]|0,k,e);Et(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function xu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Vt(g,a,b,d)}h=1;j=h;i=f;return j|0}k=hu(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){yu(k);be[c[g+68>>2]&127](c[g+4>>2]|0,k);Et(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function yu(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function zu(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}zu(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}



function q1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[156840>>2]|0;if(d>>>0<f>>>0){ed()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){ed()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){ed()}if((p|0)==(c[156844>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[156832>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=156864+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){ed()}if((c[m+12>>2]|0)==(p|0)){break}ed()}}while(0);if((u|0)==(m|0)){c[39206]=c[39206]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){ed()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}ed()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){ed()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){ed()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){ed()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{ed()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=157128+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[156828>>2]=c[156828>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[156840>>2]|0)>>>0){ed()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[156840>>2]|0)>>>0){ed()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){ed()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){ed()}do{if((C&2|0)==0){if((l|0)==(c[156848>>2]|0)){f=(c[156836>>2]|0)+t|0;c[156836>>2]=f;c[156848>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[156844>>2]|0)){i=b;return}c[156844>>2]=0;c[156832>>2]=0;i=b;return}if((l|0)==(c[156844>>2]|0)){f=(c[156832>>2]|0)+t|0;c[156832>>2]=f;c[156844>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=156864+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[156840>>2]|0)>>>0){ed()}if((c[E+12>>2]|0)==(l|0)){break}ed()}}while(0);if((w|0)==(E|0)){c[39206]=c[39206]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[156840>>2]|0)>>>0){ed()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}ed()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[156840>>2]|0)>>>0){ed()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){ed()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{ed()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=157128+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[156828>>2]=c[156828>>2]&~(1<<g);break b}else{if(d>>>0<(c[156840>>2]|0)>>>0){ed()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[156840>>2]|0)>>>0){ed()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[156844>>2]|0)){J=f;break}c[156832>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=156864+(C<<2)|0;G=c[39206]|0;j=1<<t;do{if((G&j|0)==0){c[39206]=G|j;K=156864+(C+2<<2)|0;L=e}else{t=156864+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[156840>>2]|0)>>>0)){K=t;L=a;break}ed()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=157128+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[156828>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[156828>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[156840>>2]|0;if(O>>>0<K>>>0){ed()}if(f>>>0<K>>>0){ed()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[156856>>2]|0)+ -1|0;c[156856>>2]=s;if((s|0)==0){Q=157280|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[156856>>2]=-1;i=b;return}function r1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=p1(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}X1(b|0,0,e|0)|0;i=d;return b|0}function s1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=p1(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Nc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=t1(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=p1(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;V1(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;q1(a);e=g;i=d;return e|0}function t1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[156840>>2]|0;if(h>>>0<l>>>0){ed()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){ed()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){ed()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[157304>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;u1(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[156848>>2]|0)){m=(c[156836>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[156848>>2]=a+b;c[156836>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[156844>>2]|0)){h=(c[156832>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[156832>>2]=r;c[156844>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=156864+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){ed()}if((c[h+12>>2]|0)==(k|0)){break}ed()}}while(0);if((m|0)==(h|0)){c[39206]=c[39206]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){ed()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}ed()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){ed()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){ed()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){ed()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{ed()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=157128+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[156828>>2]=c[156828>>2]&~(1<<u);break a}else{if(t>>>0<(c[156840>>2]|0)>>>0){ed()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[156840>>2]|0)>>>0){ed()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;u1(a+b|0,r);o=a;i=d;return o|0}return 0}function u1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[156840>>2]|0;if(j>>>0<m>>>0){ed()}if((k|0)==(c[156844>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[156832>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=156864+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){ed()}if((c[q+12>>2]|0)==(k|0)){break}ed()}}while(0);if((r|0)==(q|0)){c[39206]=c[39206]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){ed()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}ed()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){ed()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){ed()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){ed()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{ed()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=157128+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[156828>>2]=c[156828>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[156840>>2]|0)>>>0){ed()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[156840>>2]|0)>>>0){ed()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[156840>>2]|0;if(e>>>0<z>>>0){ed()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[156848>>2]|0)){t=(c[156836>>2]|0)+p|0;c[156836>>2]=t;c[156848>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[156844>>2]|0)){i=d;return}c[156844>>2]=0;c[156832>>2]=0;i=d;return}if((f|0)==(c[156844>>2]|0)){t=(c[156832>>2]|0)+p|0;c[156832>>2]=t;c[156844>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=156864+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){ed()}if((c[u+12>>2]|0)==(f|0)){break}ed()}}while(0);if((h|0)==(u|0)){c[39206]=c[39206]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){ed()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}ed()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){ed()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){ed()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){ed()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{ed()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=157128+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[156828>>2]=c[156828>>2]&~(1<<j);break b}else{if(m>>>0<(c[156840>>2]|0)>>>0){ed()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[156840>>2]|0)>>>0){ed()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[156840>>2]|0)>>>0){ed()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[156844>>2]|0)){G=t;break}c[156832>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=156864+(B<<2)|0;D=c[39206]|0;b=1<<p;do{if((D&b|0)==0){c[39206]=D|b;H=156864+(B+2<<2)|0;I=A}else{p=156864+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[156840>>2]|0)>>>0)){H=p;I=a;break}ed()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=157128+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[156828>>2]|0;B=1<<J;if((a&B|0)==0){c[156828>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[156840>>2]|0)>>>0){ed()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[156840>>2]|0;if(L>>>0<B>>>0){ed()}if(G>>>0<B>>>0){ed()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function v1(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=p1(d)|0;if((e|0)!=0){f=6;break}a=c[39330]|0;c[39330]=0+a;if((a|0)==0){f=5;break}Ae[a&7]()}if((f|0)==5){d=Ec(4)|0;c[d>>2]=157336;Od(d|0,157384,136)}else if((f|0)==6){i=b;return e|0}return 0}function w1(a){a=a|0;var b=0,c=0;b=i;c=v1(a)|0;i=b;return c|0}function x1(a){a=a|0;var b=0;b=i;if((a|0)!=0){q1(a)}i=b;return}function y1(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function z1(a){a=a|0;var b=0;b=i;zb(a|0);x1(a);i=b;return}function A1(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function B1(a){a=a|0;i=i;return 157352}function C1(){var a=0;a=Ec(4)|0;c[a>>2]=157336;Od(a|0,157384,136)}function D1(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==1){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else if((e|0)==2){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=G1(b)|0}}while((gd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=G1(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[157400+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=G1(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[157416+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=G1(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=G1(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=G1(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=G1(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=G1(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=G1(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=b2(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=b2(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=G1(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){F1(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=b2(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=E1(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){F1(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=Y1(q|0,n|0,2)|0;o=b2(p|0,J|0,-32,-1)|0;p=b2(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=b2(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=a2(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=b2(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Md(+(+H1(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Nc()|0)>>2]=34}l=+I1(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=G1(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=G1(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=G1(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=b2(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=b2(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=G1(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=E1(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){F1(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=b2(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Nc()|0)>>2]=22;F1(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[157432+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[157432+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[157432+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=Y1(c[Ra>>2]|0,0,29)|0;Qa=b2(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=l2(Qa|0,Ta|0,1e9,0)|0;pa=m2(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=Y1(c[Ua>>2]|0,0,29)|0;Ra=b2(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=l2(Ra|0,Sa|0,1e9,0)|0;Pa=m2(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[157424+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Md(+(+H1(1.0,105-tc|0)),+sc);vc=+zc(+sc,+(+H1(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=xc;break}}Bc=la*.25+xc}else{if(na>>>0>5e8){Bc=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+xc;break}else{Bc=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+zc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=yc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Nc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+I1(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=G1(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=G1(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Nc()|0)>>2]=22;F1(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Nc()|0)>>2]=22;F1(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function E1(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=G1(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=G1(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=G1(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=k2(q|0,m|0,10,0)|0;b=J;g=b2(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=b2(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=G1(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=G1(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=a2(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function F1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function G1(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=K1(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function H1(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=Y1(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function I1(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+H1(a,b);i=c;return+d}function J1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){ge[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function K1(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((J1(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((ge[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function L1(a){a=a|0;var b=0,c=0.0;b=i;c=+M1(a,0);i=b;return+c}function M1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;F1(e,0);h=+D1(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function N1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;F1(e,0);h=+D1(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function O1(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function P1(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function Q1(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function R1(){c[34434]=p;c[34476]=p;c[39118]=p;c[39348]=p}function S1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}ec(116);ec(111);ec(111);ec(32);ec(109);ec(97);ec(110);ec(121);ec(32);ec(115);ec(101);ec(116);ec(106);ec(109);ec(112);ec(115);ec(32);ec(105);ec(110);ec(32);ec(97);ec(32);ec(102);ec(117);ec(110);ec(99);ec(116);ec(105);ec(111);ec(110);ec(32);ec(99);ec(97);ec(108);ec(108);ec(44);ec(32);ec(98);ec(117);ec(105);ec(108);ec(100);ec(32);ec(119);ec(105);ec(116);ec(104);ec(32);ec(97);ec(32);ec(104);ec(105);ec(103);ec(104);ec(101);ec(114);ec(32);ec(118);ec(97);ec(108);ec(117);ec(101);ec(32);ec(102);ec(111);ec(114);ec(32);ec(77);ec(65);ec(88);ec(95);ec(83);ec(69);ec(84);ec(74);ec(77);ec(80);ec(83);ec(10);ga(0);return 0}function T1(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function U1(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function V1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function W1(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{V1(b,c,d)|0}return b|0}function X1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function Y1(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function Z1(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function _1(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function $1(){return _1(o)|0}function a2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function b2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function c2(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function d2(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function e2(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function f2(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function g2(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function h2(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function i2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=a2(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=a2((n2(i,b,a2(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function j2(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=a2(h^a,j^b,h,j)|0;b=J;n2(m,b,a2(k^d,l^e,k,l)|0,J,g)|0;l=a2(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function k2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=h2(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function l2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=n2(a,b,c,d,0)|0;return(J=J,e)|0}function m2(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;n2(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function n2(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((g2(l|0)|0)>>>0);return(J=n,o)|0}p=(f2(l|0)|0)-(f2(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(f2(l|0)|0)-(f2(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(f2(j|0)|0)+33-(f2(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=g2(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=b2(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;a2(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=a2(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function o2(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return Yd[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function p2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;Zd[a&31](b|0,c|0,d|0,e|0,f|0)}function q2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return _d[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function r2(a,b){a=a|0;b=+b;$d[a&1](+b)}function s2(a,b){a=a|0;b=b|0;ae[a&255](b|0)}function t2(a,b,c){a=a|0;b=b|0;c=c|0;be[a&127](b|0,c|0)}function u2(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ce[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function v2(a,b){a=a|0;b=b|0;return de[a&127](b|0)|0}function w2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;ee[a&1](b|0,c|0,+d,e|0)}function x2(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return fe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function y2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return ge[a&63](b|0,c|0,d|0)|0}function z2(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return he[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function A2(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ie[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function B2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;je[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function C2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ke[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function D2(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return le[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function E2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;me[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function F2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ne[a&3](b|0,c|0,+d,e|0,f|0)}function G2(a,b,c){a=a|0;b=b|0;c=+c;return oe[a&1](b|0,+c)|0}function H2(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;pe[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function I2(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;qe[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function J2(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;re[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function K2(a,b,c){a=a|0;b=b|0;c=c|0;return se[a&63](b|0,c|0)|0}function L2(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return te[a&63](b|0,c|0,d|0,e|0,f|0)|0}function M2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ue[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function N2(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+ve[a&1](b|0,+c,+d)}function O2(a,b,c){a=a|0;b=b|0;c=c|0;return+we[a&1](b|0,c|0)}function P2(a){a=a|0;return xe[a&7]()|0}function Q2(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return ye[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function R2(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ze[a&15](b|0,c|0,d|0)}function S2(a){a=a|0;Ae[a&7]()}function T2(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Be[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function U2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ce[a&63](b|0,c|0,d|0,e|0)|0}function V2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;De[a&31](b|0,c|0,d|0,e|0)}function W2(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function X2(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function Y2(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function Z2(a){a=+a;ga(3)}function _2(a){a=a|0;ga(4)}function $2(a){a=a|0;xd(a|0)}function a3(a,b){a=a|0;b=b|0;ga(5)}function b3(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function c3(a){a=a|0;ga(7);return 0}function d3(a){a=a|0;return Oc(a|0)|0}function e3(a){a=a|0;return Gd(a|0)|0}function f3(a){a=a|0;return wc(a|0)|0}function g3(a){a=a|0;return vd(a|0)|0}function h3(a){a=a|0;return id(a|0)|0}function i3(a){a=a|0;return qd(a|0)|0}function j3(a){a=a|0;return Xc(a|0)|0}function k3(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function l3(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function m3(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function n3(a,b,c){a=a|0;b=b|0;c=c|0;return sd(a|0,b|0,c|0)|0}function o3(a,b,c){a=a|0;b=b|0;c=c|0;return ic(a|0,b|0,c|0)|0}function p3(a,b,c){a=a|0;b=b|0;c=c|0;return cc(a|0,b|0,c|0)|0}function q3(a,b,c){a=a|0;b=b|0;c=c|0;return wd(a|0,b|0,c|0)|0}function r3(a,b,c){a=a|0;b=b|0;c=c|0;return td(a|0,b|0,c|0)|0}function s3(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function t3(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function u3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function v3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function w3(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function x3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function y3(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function z3(a,b){a=a|0;b=+b;ga(18);return 0}function A3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function B3(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function C3(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function D3(a,b){a=a|0;b=b|0;ga(22);return 0}function E3(a,b){a=a|0;b=b|0;return Ld(a|0,b|0)|0}function F3(a,b){a=a|0;b=b|0;return hc(a|0,b|0)|0}function G3(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function H3(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function I3(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function J3(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function K3(a,b){a=a|0;b=b|0;ga(26);return 0.0}function L3(){ga(27);return 0}function M3(){return jb()|0}function N3(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function O3(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function P3(){ga(30)}function Q3(){Uc()}function R3(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function S3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function T3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rc(a|0,b|0,c|0,d|0)|0}function U3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Mc(a|0,b|0,c|0,d|0)|0}function V3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}




// EMSCRIPTEN_END_FUNCS
var Yd=[W2,hB,jB,oB,sQ,W2,W2,W2];var Zd=[X2,Ev,Fv,iw,jw,Nw,Ow,jx,kx,lx,l1,k1,j1,Yu,Zu,Hy,Fy,X2,X2,X2,X2,X2,X2,X2,X2,X2,X2,X2,X2,X2,X2,X2];var _d=[Y2,UC];var $d=[Z2,VB];var ae=[_2,ui,vi,gk,hk,In,jk,Cy,eF,hF,gF,iF,qV,pV,sV,rV,jF,lF,xI,VI,WI,XI,bV,aV,dV,cV,EP,QP,bQ,cQ,dQ,fQ,hQ,ZR,_R,eS,fS,lS,mS,sS,tS,FS,ES,KS,JS,MS,NS,WS,VS,bU,aU,kU,jU,OU,NU,kV,jV,mV,lV,EV,DV,GV,FV,MV,LV,$T,NV,KV,OV,QV,PV,YZ,WV,VV,$V,_V,yW,xW,aX,$W,oX,nX,CX,BX,QX,PX,bY,aY,eY,dY,iY,hY,tY,sY,EY,DY,PY,OY,_Y,ZY,iZ,hZ,qZ,pZ,wZ,vZ,CZ,BZ,HZ,GZ,QZ,PZ,m_,l_,LZ,D_,i$,h$,k$,j$,RV,XZ,_Z,v_,L_,W_,f$,g$,Y0,X0,_0,b1,$0,a1,c1,d1,A1,z1,Pg,$2,wi,xi,yi,zi,Ai,Bi,Ci,Di,Ei,Fi,Gi,Hi,Ii,Ji,Mi,Ni,Oi,Ri,Si,Ti,Ui,Vi,Wi,Xi,Yi,Zi,_i,$i,cj,dj,ej,fj,ij,jj,kj,lj,_e,$e,ff,pf,qf,vf,Cf,Df,Ef,Ff,Gf,Hf,If,Pf,Qf,Sf,Tf,Uf,ig,jg,kg,lg,mg,tg,yg,Bg,Cg,Dg,Eg,Fg,Gg,Hg,Ig,Jg,Kg,q1,Ey,Ue,FB,JB,EB,XC,LB,VC,$z,OB,MB,NB,KB,QB,WC,RB,GB,TB,zP,UB,xR,YR,ZZ,S$,aZ,Z$,Y$,X$,W$,V$,U$,kT,OT,_2,_2,_2,_2,_2,_2,_2,_2,_2,_2,_2];var be=[a3,ik,CD,mF,BU,$R,gS,nS,uS,PU,lY,mY,nY,oY,qY,rY,wY,xY,yY,zY,BY,CY,HY,IY,JY,KY,MY,NY,SY,TY,UY,VY,XY,YY,FZ,KZ,p$,r$,t$,q$,s$,u$,wB,Ki,Pi,aj,gj,mj,Cj,Hj,Uj,_j,ek,PB,dI,ED,DD,FD,LD,XD,GD,VD,sH,EH,DH,FH,nH,lH,pH,GQ,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3,a3];var ce=[b3,lv,ev,iB,kB,lB,mB,nB];var de=[c3,Mg,Kr,Lg,We,Xe,Ye,Jn,Vn,pk,Hn,Jr,Ws,ok,mk,Xs,Ys,bt,ct,dt,et,ft,gt,ht,it,d3,e3,f3,Yy,p1,g3,qF,GU,rF,JU,FU,kQ,aS,UU,WU,XU,TU,hS,iS,oS,IU,vS,wS,GS,LS,IV,DX,v$,x$,z$,F$,H$,B$,D$,RX,w$,y$,A$,G$,I$,C$,E$,jY,kY,pY,uY,vY,AY,FY,GY,LY,QY,RY,WY,H_,I_,K_,l$,n$,m$,o$,z_,A_,C_,R_,S_,V_,a$,b$,e$,Z0,B1,cD,h3,i3,aD,bD,j3,sP,VP,bC,jC,sC,cC,mC,tC,QR,K1,c3,c3,c3,c3,c3,c3,c3,c3,c3,c3,c3,c3,c3,c3,c3];var ee=[k3,Ez];var fe=[l3,TA];var ge=[m3,lk,vv,Bv,$v,fw,Ew,Kw,nF,HU,LU,CU,QU,VU,bS,ZU,pS,QS,RS,UV,ZV,DZ,IZ,o_,q_,t_,$Z,e_,g_,j_,e1,BP,Fz,hA,iv,$u,gv,mv,n3,o3,p3,YC,yP,uP,q3,IR,r3,m3,m3,m3,m3,m3,m3,m3,m3,m3,m3,m3,m3,m3,m3,m3,m3,m3];var he=[s3,XA];var ie=[t3,pA];var je=[u3,iX,lX,wX,yX,u3,u3,u3];var ke=[v3,cY,fY,$Y,dZ,jZ,lZ,v3];var le=[w3,RA];var me=[x3,zy,oF,iQ,RU,DU,bX,cX,gX,mX,pX,qX,uX,zX,EZ,JZ,o1,n1,m1,Ay,x3,x3,x3,x3,x3,x3,x3,x3,x3,x3,x3,x3];var ne=[y3,kC,lC,y3];var oe=[z3,Og];var pe=[A3,aW,cW,eW,gW,iW,kW,mW,oW,qW,sW,uW,zW,BW,DW,FW,HW,JW,LW,NW,PW,RW,TW,fX,hX,tX,vX,EX,FX,GX,HX,IX,SX,TX,UX,VX,WX,uZ,AZ,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3,A3];var qe=[B3,rZ,xZ,B3];var re=[C3,JX,XX,C3];var se=[D3,Ve,qk,nk,kk,jt,kt,xv,yv,Av,bw,cw,ew,Gw,Hw,Jw,Pw,Qw,Rw,Sw,Tw,Uw,Vw,Ww,sF,tF,lQ,mQ,YU,cS,jS,_U,KU,qS,xS,MU,n_,p_,r_,d_,f_,h_,MC,vC,nC,dC,uC,E3,s1,Vu,Wu,Xu,F3,mz,gC,IC,zC,iC,G3,J0,D3,D3,D3,D3];var te=[H3,SV,XV,u_,G_,J_,k_,y_,B_,Q_,T_,$_,c$,rx,iy,jy,wx,tx,gy,hy,xx,yx,zx,Ax,Bx,Yx,Zx,Px,Ix,Dx,Cx,Ex,Fx,Hx,Gx,ux,sx,Jx,Kx,Lx,Mx,Nx,Ox,Qx,Rx,Sx,Tx,Xx,Vx,Ux,Wx,cy,_x,$x,ay,by,dy,ey,fy,ky,ly,my,ny,dX];var ue=[I3,hD];var ve=[J3,wC];var we=[K3,zA];var xe=[L3,mt,M3,Zy,VR,WR,TR,L3];var ye=[N3,WA];var ze=[O3,DP,PS,JV,Az,Ky,xD,zD,cI,FQ,O3,O3,O3,O3,O3,O3];var Ae=[P3,Q3,Xy,qy,Rg,P3,P3,P3];var Be=[R3,lt,E_,F_,w_,x_,M_,O_,X_,Z_,AC,R3,R3,R3,R3,R3];var Ce=[S3,pv,qv,rv,sv,tv,uv,wv,zv,Dv,Vv,Wv,Xv,Yv,Zv,_v,aw,dw,hw,yw,zw,Aw,Bw,Cw,Dw,Fw,Iw,Mw,s_,a_,b_,c_,i_,yB,T3,SA,Nu,Qt,ju,su,eu,Bu,Gu,Eu,Hu,nv,Tu,bv,cv,jv,kv,wW,jX,U3,S3,S3,S3,S3,S3,S3,S3,S3,S3,S3];var De=[V3,Cv,gw,Lw,pF,CP,jQ,SU,EU,TV,YV,f1,g1,h1,Iy,Gy,AB,gA,Jy,Li,Qi,bj,hj,nj,Dj,Ij,Vj,$j,fk,_Q,dv,Ly];return{_testSetjmp:e2,_saveSetjmp:S1,_free:q1,_main:Qg,_rand_r:_1,_realloc:s1,_i64Add:b2,_memmove:W1,_bitshift64Ashr:U1,_memset:X1,_malloc:p1,_strncpy:c2,_memcpy:V1,_strlen:T1,_bitshift64Lshr:d2,_bitshift64Shl:Y1,_i64Subtract:a2,_strcpy:Z1,_calloc:r1,_rand:$1,__GLOBAL__I_a:zS,runPostSets:R1,stackAlloc:Ee,stackSave:Fe,stackRestore:Ge,setThrew:He,setTempRet0:Ke,setTempRet1:Le,setTempRet2:Me,setTempRet3:Ne,setTempRet4:Oe,setTempRet5:Pe,setTempRet6:Qe,setTempRet7:Re,setTempRet8:Se,setTempRet9:Te,dynCall_iiiiiiii:o2,dynCall_viiiii:p2,dynCall_iiiiidiii:q2,dynCall_vd:r2,dynCall_vi:s2,dynCall_vii:t2,dynCall_iiiiiiiiiii:u2,dynCall_ii:v2,dynCall_viidi:w2,dynCall_iiiiiiiiiiiiii:x2,dynCall_iiii:y2,dynCall_iiiiiiiiiiiiiiiiiiiiiii:z2,dynCall_iiiiiiiiiiiiiiiiiiiii:A2,dynCall_viiiiid:B2,dynCall_viiiiiiii:C2,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:D2,dynCall_viiiiii:E2,dynCall_viidii:F2,dynCall_iid:G2,dynCall_viiiiiii:H2,dynCall_viiiiiid:I2,dynCall_viiiiiiiii:J2,dynCall_iii:K2,dynCall_iiiiii:L2,dynCall_iiiiidi:M2,dynCall_didd:N2,dynCall_dii:O2,dynCall_i:P2,dynCall_iiiiiiiiii:Q2,dynCall_viii:R2,dynCall_v:S2,dynCall_iiiiiiiii:T2,dynCall_iiiii:U2,dynCall_viiii:V2}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "_log10": _log10, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "__reallyNegative": __reallyNegative, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_fscanf": _fscanf, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_acos": _acos, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






