var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 205968;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 206008;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(206835);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,124,2,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,0,0,1,0,0,0,16,32,0,0,24,32,0,0,0,0,0,0,1,0,0,0,127,2,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,1,0,0,0,128,2,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,1,0,0,0,133,2,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,136,2,0,0,49,46,48,32,45,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,1,0,0,0,137,2,0,0,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,82,32,42,32,50,57,51,46,49,53,0,0,1,0,0,0,138,2,0,0,1,0,0,0,139,2,0,0,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,1,0,0,0,147,2,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,0,0,1,0,0,0,148,2,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,0,0,1,0,0,0,154,2,0,0,109,97,120,40,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,1,0,0,0,158,2,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,161,2,0,0,49,46,48,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,0,0,1,0,0,0,163,2,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,82,0,0,0,0,0,0,0,1,0,0,0,167,2,0,0,100,117,99,116,73,110,46,109,115,91,50,93,0,0,0,0,1,0,0,0,168,2,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,169,2,0,0,1,0,0,0,173,2,0,0,109,97,120,40,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,1,0,0,0,175,2,0,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,0,0,0,1,0,0,0,186,2,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,189,2,0,0,49,46,48,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,0,0,1,0,0,0,191,2,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,82,0,0,0,0,0,0,0,1,0,0,0,195,2,0,0,100,117,99,116,73,110,46,109,115,91,49,93,0,0,0,0,1,0,0,0,197,2,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,198,2,0,0,1,0,0,0,202,2,0,0,109,97,120,40,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,1,0,0,0,204,2,0,0,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,1,0,0,0,213,2,0,0,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,44,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,84,44,32,123,98,111,117,110,100,97,114,121,52,46,88,91,49,93,44,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,125,41,41,32,42,32,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,217,2,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,220,2,0,0,49,46,48,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,0,1,0,0,0,222,2,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,82,0,0,0,0,0,1,0,0,0,226,2,0,0,100,117,99,116,79,117,116,46,109,115,91,50,93,0,0,0,1,0,0,0,228,2,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,0,0,1,0,0,0,229,2,0,0,1,0,0,0,234,2,0,0,109,97,120,40,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,1,0,0,0,236,2,0,0,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,1,0,0,0,243,2,0,0,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,32,42,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,50,93,0,0,0,0,0,0,0,0,1,0,0,0,247,2,0,0,100,117,99,116,79,117,116,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,1,0,0,0,251,2,0,0,1,0,0,0,254,2,0,0,1,0,0,0,11,3,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,14,3,0,0,49,46,48,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,0,1,0,0,0,16,3,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,82,0,0,0,0,0,1,0,0,0,20,3,0,0,100,117,99,116,79,117,116,46,109,115,91,49,93,0,0,0,1,0,0,0,24,3,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,0,0,1,0,0,0,25,3,0,0,1,0,0,0,37,3,0,0,109,97,120,40,45,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,49,101,45,49,53,0,0,1,0,0,0,39,3,0,0,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,84,44,32,123,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,49,93,44,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,125,41,41,32,42,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,50,93,0,0,0,0,0,0,0,0,1,0,0,0,44,3,0,0,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,42,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,50,93,0,0,0,1,0,0,0,48,3,0,0,100,117,99,116,73,110,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,1,0,0,0,49,3,0,0,1,0,0,0,51,3,0,0,109,97,120,40,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,49,101,45,49,53,0,0,0,1,0,0,0,52,3,0,0,1,0,0,0,53,3,0,0,1,0,0,0,56,3,0,0,72,50,79,0,0,0,0,0,1,0,0,0,208,31,0,0,216,31,0,0,0,0,0,0,1,0,0,0,184,31,0,0,192,31,0,0,0,0,0,0,1,0,0,0,120,31,0,0,128,31,0,0,0,0,0,0,1,0,0,0,96,31,0,0,104,31,0,0,0,0,0,0,1,0,0,0,68,3,0,0,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,1,0,0,0,75,3,0,0,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,32,42,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,79,3,0,0,100,117,99,116,79,117,116,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,1,0,0,0,82,3,0,0,1,0,0,0,87,3,0,0,118,111,108,117,109,101,46,86,0,0,0,0,0,0,0,0,1,0,0,0,89,3,0,0,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,123,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,44,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,125,41,41,32,42,32,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,94,3,0,0,1,0,0,0,106,3,0,0,1,0,0,0,110,3,0,0,109,97,120,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,1,0,0,0,112,3,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,115,3,0,0,49,46,48,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,0,1,0,0,0,117,3,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,0,0,0,0,0,0,0,1,0,0,0,121,3,0,0,118,111,108,117,109,101,46,109,0,0,0,0,0,0,0,0,1,0,0,0,133,3,0,0,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,42,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,1,0,0,0,136,3,0,0,100,117,99,116,73,110,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,1,0,0,0,139,3,0,0,1,0,0,0,153,3,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,115,116,97,116,101,95,97,46,112,32,45,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,156,3,0,0,49,46,48,32,45,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,1,0,0,0,158,3,0,0,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,82,32,42,32,50,57,51,46,49,53,0,0,0,0,0,0,1,0,0,0,159,3,0,0,1,0,0,0,160,3,0,0,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,1,0,0,0,169,3,0,0,1,0,0,0,179,3,0,0,1,0,0,0,72,31,0,0,80,31,0,0,0,0,0,0,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,100,117,99,116,73,110,46,115,116,97,116,101,95,97,46,112,44,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,53,49,40,82,101,97,108,91,50,93,41,35,41,41,32,42,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,0,0,1,0,0,0,186,3,0,0,1,0,0,0,189,3,0,0,109,97,120,40,45,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,0,0,1,0,0,0,192,3,0,0,1,0,0,0,195,3,0,0,1,0,0,0,197,3,0,0,1,0,0,0,198,3,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,41,0,0,0,0,0,1,0,0,0,199,3,0,0,10,84,101,109,112,101,114,97,116,117,114,101,32,84,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,97,108,108,111,119,101,100,32,114,97,110,103,101,10,49,57,48,46,48,32,75,32,60,61,32,40,84,32,61,0,0,0,0,0,0,32,75,41,32,60,61,32,54,52,55,46,48,32,75,10,114,101,113,117,105,114,101,100,32,102,114,111,109,32,109,101,100,105,117,109,32,109,111,100,101,108,32,34,0,0,0,0,0,77,111,105,115,116,32,97,105,114,0,0,0,0,0,0,0,34,46,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,49,93,32,61,32,0,0,0,111,102,32,115,117,98,115,116,97,110,99,101,32,0,0,0,119,97,116,101,114,0,0,0,10,111,102,32,109,101,100,105,117,109,32,0,0,0,0,0,32,105,115,32,110,111,116,32,105,110,32,116,104,101,32,114,97,110,103,101,32,48,46,46,49,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,77,97,115,115,32,102,114,97,99,116,105,111,110,32,88,91,50,93,32,61,32,0,0,0,97,105,114,0,0,0,0,0,80,114,101,115,115,117,114,101,32,40,61,32,0,0,0,0,32,80,97,41,32,111,102,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,105,115,32,110,101,103,97,116,105,118,101,10,40,84,101,109,112,101,114,97,116,117,114,101,32,61,32,0,0,0,32,75,41,0,0,0,0,0,70,105,120,101,100,66,111,117,110,100,97,114,121,0,0,0,77,97,115,115,70,108,111,119,83,111,117,114,99,101,95,84,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,111,117,114,99,101,115,46,109,111,0,0,0,208,24,0,0,78,3,0,0,5,0,0,0,78,3,0,0,146,0,0,0,0,0,0,0,70,108,111,119,83,111,117,114,99,101,32,111,110,108,121,32,115,117,112,112,111,114,116,115,32,111,110,101,32,99,111,110,110,101,99,116,105,111,110,32,119,105,116,104,32,102,108,111,119,0,0,0,0,0,0,0,86,101,115,115,101,108,32,105,115,32,111,118,101,114,102,108,111,119,105,110,103,32,40,102,108,117,105,100,76,101,118,101,108,32,62,32,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,61,32,0,0,0,41,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,168,25,0,0,62,1,0,0,9,0,0,0,62,1,0,0,129,0,0,0,0,0,0,0,70,108,117,105,100,32,108,101,118,101,108,32,40,61,32,0,41,32,105,115,32,98,101,108,111,119,32,122,101,114,111,32,109,101,97,110,105,110,103,32,116,104,97,116,32,116,104,101,32,115,111,108,117,116,105,111,110,32,102,97,105,108,101,100,46,0,0,0,0,0,0,0,168,25,0,0,63,1,0,0,9,0,0,0,63,1,0,0,144,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,80,97,114,97,109,101,116,101,114,32,108,101,110,103,116,104,32,109,117,115,116,32,98,101,32,103,114,101,97,116,101,114,32,111,114,32,101,113,117,97,108,32,104,101,105,103,104,116,95,97,98,46,0,0,0,0,76,105,109,105,116,101,114,58,32,76,105,109,105,116,115,32,109,117,115,116,32,98,101,32,99,111,110,115,105,115,116,101,110,116,46,32,72,111,119,101,118,101,114,44,32,117,77,97,120,32,40,61,0,0,0,0,41,32,60,32,117,77,105,110,32,40,61,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,78,111,110,108,105,110,101,97,114,46,109,111,0,0,0,0,0,0,0,0,48,27,0,0,18,0,0,0,9,0,0,0,19,0,0,0,65,0,0,0,0,0,0,0,76,105,109,80,73,68,58,32,76,105,109,105,116,115,32,109,117,115,116,32,98,101,32,99,111,110,115,105,115,116,101,110,116,46,32,72,111,119,101,118,101,114,44,32,121,77,97,120,32,40,61,0,0,0,0,0,41,32,60,32,121,77,105,110,32,40,61,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,67,111,110,116,105,110,117,111,117,115,46,109,111,0,0,0,0,0,0,0,224,27,0,0,210,3,0,0,5,0,0,0,211,3,0,0,61,0,0,0,0,0,0,0,64,23,0,0,64,0,0,0,7,0,0,0,67,0,0,0,53,0,0,0,0,0,0,0,240,23,0,0,74,17,0,0,11,0,0,0,77,17,0,0,41,0,0,0,0,0,0,0,240,23,0,0,82,17,0,0,7,0,0,0,83,17,0,0,76,0,0,0,0,0,0,0,104,26,0,0,25,1,0,0,7,0,0,0,25,1,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,46,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,69,120,97,109,112,108,101,115,0,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,46,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,95,105,110,102,111,46,120,109,108,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,2,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,174,71,225,122,20,174,239,63,2,0,0,0,0,0,0,0,12,229,68,187,110,9,203,192,19,83,84,195,159,233,31,192,7,0,0,0,0,0,0,0,121,233,38,49,184,149,47,65,117,32,235,169,101,217,162,192,175,197,118,16,158,149,18,64,4,118,172,56,171,198,98,63,93,203,6,236,202,240,166,190,56,28,173,173,73,233,217,61,3,149,235,130,211,183,245,188,2,0,0,0,0,0,0,0,181,166,121,199,247,33,224,192,76,254,39,127,247,61,49,64,7,0,0,0,0,0,0,0,197,143,49,119,243,70,227,192,45,90,128,182,149,252,129,64,8,175,179,218,41,209,237,63,23,132,90,56,144,149,125,63,249,233,45,205,2,204,222,190,111,33,62,192,32,72,53,62,140,233,235,22,3,133,119,189,1,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,54,52,46,48,32,42,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,76,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,97,117,120,53,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,1,0,0,0,104,44,0,0,112,44,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,50,46,53,49,32,47,32,115,113,114,116,40,108,97,109,98,100,97,50,41,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,97,117,120,49,32,42,32,97,98,115,40,100,112,95,102,114,105,99,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,50,46,53,49,32,47,32,97,117,120,50,32,43,32,48,46,50,55,32,42,32,68,101,108,116,97,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,68,101,108,116,97,32,47,32,51,46,55,32,43,32,53,46,55,52,32,47,32,82,101,32,94,32,48,46,57,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,49,48,40,82,101,32,47,32,82,101,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,1,0,0,0,48,44,0,0,56,44,0,0,0,0,0,0,1,0,0,0,248,43,0,0,0,44,0,0,0,0,0,0,84,104,101,32,97,114,103,117,109,101,110,116,115,32,120,95,109,105,110,32,97,110,100,32,120,95,109,97,120,32,116,111,32,79,110,101,78,111,110,76,105,110,101,97,114,69,113,117,97,116,105,111,110,46,115,111,108,118,101,40,46,46,41,10,100,111,32,110,111,116,32,98,114,97,99,107,101,116,32,116,104,101,32,114,111,111,116,32,111,102,32,116,104,101,32,115,105,110,103,108,101,32,110,111,110,45,108,105,110,101,97,114,32,101,113,117,97,116,105,111,110,58,10,32,32,120,95,109,105,110,32,32,61,32,0,0,10,0,0,0,0,0,0,0,32,32,120,95,109,97,120,32,32,61,32,0,0,0,0,0,32,32,121,95,122,101,114,111,32,61,32,0,0,0,0,0,32,32,102,97,32,61,32,102,40,120,95,109,105,110,41,32,45,32,121,95,122,101,114,111,32,61,32,0,0,0,0,0,32,32,102,98,32,61,32,102,40,120,95,109,97,120,41,32,45,32,121,95,122,101,114,111,32,61,32,0,0,0,0,0,102,97,32,97,110,100,32,102,98,32,109,117,115,116,32,104,97,118,101,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,119,104,105,99,104,32,105,115,32,110,111,116,32,116,104,101,32,99,97,115,101,0,72,50,79,0,0,0,0,0,1,0,0,0,184,43,0,0,192,43,0,0,0,0,0,0,1,0,0,0,160,43,0,0,168,43,0,0,0,0,0,0,1,0,0,0,96,43,0,0,104,43,0,0,0,0,0,0,1,0,0,0,72,43,0,0,80,43,0,0,0,0,0,0,65,105,114,0,0,0,0,0,1,0,0,0,8,43,0,0,16,43,0,0,0,0,0,0,1,0,0,0,240,42,0,0,248,42,0,0,0,0,0,0,1,0,0,0,176,42,0,0,184,42,0,0,0,0,0,0,1,0,0,0,152,42,0,0,160,42,0,0,0,0,0,0,1,0,0,0,128,42,0,0,136,42,0,0,0,0,0,0,1,0,0,0,104,42,0,0,112,42,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,97,116,97,32,112,111,105,110,116,115,32,110,111,116,32,115,111,114,116,101,100,32,97,112,112,114,111,112,114,105,97,116,101,108,121,32,40,120,48,32,61,32,0,0,32,62,32,120,49,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,102,108,105,112,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,85,116,105,108,105,116,105,101,115,46,109,111,0,160,38,0,0,94,2,0,0,5,0,0,0,95,2,0,0,74,0,0,0,0,0,0,0,114,101,103,70,117,110,51,40,41,58,32,68,101,114,105,118,97,116,105,118,101,115,32,97,116,32,100,97,116,97,32,112,111,105,110,116,115,32,100,111,32,110,111,116,32,97,108,108,111,119,32,99,111,45,109,111,110,111,116,111,110,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,44,32,97,115,32,98,111,116,104,32,97,114,101,32,110,111,110,45,122,101,114,111,44,32,111,102,32,111,112,112,111,115,105,116,101,32,115,105,103,110,32,97,110,100,32,104,97,118,101,32,97,110,32,97,98,115,111,108,117,116,101,32,118,97,108,117,101,32,108,97,114,103,101,114,32,116,104,97,110,32,109,97,99,104,105,110,101,32,101,112,115,32,40,121,48,100,32,61,32,0,44,32,121,49,100,32,61,32,0,0,0,0,0,0,0,0,41,46,32,80,108,101,97,115,101,32,99,111,114,114,101,99,116,32,97,114,103,117,109,101,110,116,115,46,0,0,0,0,160,38,0,0,101,2,0,0,7,0,0,0,102,2,0,0,79,0,0,0,0,0,0,0,10,87,114,111,110,103,32,118,97,108,117,101,32,111,102,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([112,97,114,97,109,101,116,101,114,32,100,101,102,105,110,101,95,112,32,40,61,32,102,97,108,115,101,41,32,105,110,32,109,111,100,101,108,32,34,0,34,58,10,84,104,101,32,115,101,108,101,99,116,101,100,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,0,0,34,32,104,97,115,32,77,101,100,105,117,109,46,115,105,110,103,108,101,83,116,97,116,101,61,116,114,117,101,46,10,84,104,101,114,101,102,111,114,101,44,32,97,110,32,98,111,117,110,100,97,114,121,32,100,101,110,115,105,116,121,32,99,97,110,110,111,116,32,98,101,32,100,101,102,105,110,101,100,32,97,110,100,10,100,101,102,105,110,101,95,112,32,61,32,116,114,117,101,32,105,115,32,114,101,113,117,105,114,101,100,46,10,0,0,0,0,0,0,0,160,38,0,0,18,0,0,0,5,0,0,0,23,0,0,0,3,0,0,0,0,0,0,0,10,87,114,111,110,103,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,0,0,0,0,0,34,32,105,110,32,109,111,100,101,108,32,34,0,0,0,0,34,58,10,84,104,101,32,98,111,117,110,100,97,114,121,32,118,97,108,117,101,32,88,95,98,111,117,110,100,97,114,121,40,0,0,0,0,0,0,0,41,32,61,32,0,0,0,0,10,105,115,32,110,101,103,97,116,105,118,101,46,32,73,116,32,109,117,115,116,32,98,101,32,112,111,115,105,116,105,118,101,46,10,0,0,0,0,0,160,38,0,0,26,0,0,0,7,0,0,0,33,0,0,0,3,0,0,0,0,0,0,0,32,32,32,88,95,98,111,117,110,100,97,114,121,91,0,0,93,32,61,32,0,0,0,0,32,34,0,0,0,0,0,0,34,10,0,0,0,0,0,0,84,104,101,32,98,111,117,110,100,97,114,121,32,109,97,115,115,32,102,114,97,99,116,105,111,110,115,32,105,110,32,109,101,100,105,117,109,32,34,0,100,111,32,110,111,116,32,115,117,109,32,117,112,32,116,111,32,49,46,32,73,110,115,116,101,97,100,44,32,115,117,109,40,88,95,98,111,117,110,100,97,114,121,41,32,61,32,0,58,10,0,0,0,0,0,0,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,248,191,0,0,0,0,0,0,244,191,2,0,0,0,0,0,0,0,114,82,152,247,56,219,43,192,76,42,100,248,153,90,65,64,2,0,0,0,0,0,0,0,162,122,107,96,67,62,185,64,57,8,190,146,121,75,32,192,7,0,0,0,0,0,0,0,129,149,67,139,139,123,13,65,84,116,36,151,127,167,147,192,86,3,32,48,7,148,20,64,191,0,235,104,193,7,44,191,112,212,172,6,48,247,114,62,222,123,98,114,234,143,167,189,158,71,225,37,243,178,199,60,2,0,0,0,0,0,0,0,179,150,2,210,126,25,102,192,177,1,108,155,61,95,15,192,7,0,0,0,0,0,0,0,214,197,109,52,192,185,195,64,62,206,52,97,123,154,104,192,70,42,8,245,95,9,20,64,80,152,254,88,220,152,119,191,28,23,112,31,169,95,230,62,241,202,212,151,57,13,65,190,85,166,72,110,180,56,131,61,2,0,0,0,0,0,0,0,12,229,68,187,110,9,203,192,19,83,84,195,159,233,31,192,7,0,0,0,0,0,0,0,121,233,38,49,184,149,47,65,117,32,235,169,101,217,162,192,175,197,118,16,158,149,18,64,4,118,172,56,171,198,98,63,93,203,6,236,202,240,166,190,56,28,173,173,73,233,217,61,3,149,235,130,211,183,245,188,2,0,0,0,0,0,0,0,181,166,121,199,247,33,224,192,76,254,39,127,247,61,49,64,7,0,0,0,0,0,0,0,197,143,49,119,243,70,227,192,45,90,128,182,149,252,129,64,8,175,179,218,41,209,237,63,23,132,90,56,144,149,125,63,249,233,45,205,2,204,222,190,111,33,62,192,32,72,53,62,140,233,235,22,3,133,119,189,6,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,248,63,0,0,0,0,0,0,8,64,0,0,0,0,0,0,12,64,0,0,0,0,0,0,16,64,0,0,0,0,0,0,30,64,6,0,0,0,0,0,0,0,46,183,40,113,37,112,31,192,131,196,242,190,92,129,253,63,1,209,221,191,195,146,39,192,6,139,121,12,69,174,54,64,253,225,66,121,122,236,47,192,238,48,154,83,209,209,252,63,6,0,0,0,0,0,0,0,0,0,0,0,55,238,5,61,1,100,56,253,164,60,193,189,194,40,108,148,139,22,103,62,124,86,91,163,224,10,4,191,47,124,109,174,174,209,169,63,119,72,9,39,64,61,49,64,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,78,111,78,97,109,101,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,4,1,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,7,1,0,0,40,49,46,48,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,8,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,0,1,0,0,0,66,1,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,69,1,0,0,40,49,46,48,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,0,0,0,0,0,0,1,0,0,0,70,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,0,1,0,0,0,80,1,0,0,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,82,1,0,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,1,0,0,0,86,1,0,0,109,97,120,40,45,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,49,101,45,49,53,0,0,72,50,79,0,0,0,0,0,1,0,0,0,114,1,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,117,1,0,0,40,49,46,48,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,118,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,0,0,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,41,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,0,0,1,0,0,0,160,1,0,0,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,1,0,0,0,164,1,0,0,1,0,0,0,196,1,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,199,1,0,0,40,49,46,48,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,0,0,0,0,0,0,0,1,0,0,0,200,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,0,0,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,41,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,0,0,1,0,0,0,213,1,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,216,1,0,0,40,49,46,48,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,41,32,94,32,50,46,48,0,0,0,0,1,0,0,0,217,1,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,108,111,103,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,32,48,0,0,0,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,0,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,32,42,32,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,85,116,105,108,105,116,105,101,115,46,115,112,108,105,99,101,70,117,110,99,116,105,111,110,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,115,97,116,117,114,97,116,105,111,110,80,114,101,115,115,117,114,101,76,105,113,117,105,100,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,44,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,86,101,115,115,101,108,115,46,67,108,111,115,101,100,86,111,108,117,109,101,46,77,101,100,105,117,109,46,115,117,98,108,105,109,97,116,105,111,110,80,114,101,115,115,117,114,101,73,99,101,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,41,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,43,32,45,50,55,51,46,49,54,44,32,49,46,48,41,41,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,0,1,0,0,0,0,3,0,0,1,0,0,0,2,3,0,0,1,0,0,0,5,3,0,0,1,0,0,0,28,3,0,0,1,0,0,0,35,3,0,0,1,0,0,0,57,3,0,0,1,0,0,0,59,3,0,0,1,0,0,0,62,3,0,0,1,0,0,0,95,3,0,0,1,0,0,0,97,3,0,0,1,0,0,0,100,3,0,0,1,0,0,0,149,3,0,0,1,0,0,0,170,3,0,0,1,0,0,0,172,3,0,0,1,0,0,0,175,3,0,0,1,0,0,0,201,3,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,202,3,0,0,1,0,0,0,205,3,0,0,116,105,109,101,32,62,61,32,112,114,101,40,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,110,101,120,116,84,105,109,101,69,118,101,110,116,41,0,0,0,0,0,0,0,1,0,0,0,112,2,0,0,0,72,0,0,0,0,0,0,208,71,0,0,0,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,36,119,104,101,110,67,111,110,100,105,116,105,111,110,49,32,102,114,111,109,32,37,100,32,116,111,32,37,100,0,0,0,0,0,100,105,115,99,114,101,116,101,32,118,97,114,32,99,104,97,110,103,101,100,58,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,95,110,101,120,116,84,105,109,101,69,118,101,110,116,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,45,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,0,0,0,0,0,0,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,45,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,0,118,111,108,117,109,101,46,109,67,95,115,99,97,108,101,100,91,49,93,32,43,32,45,54,53,56,46,51,50,55,56,52,55,50,54,55,57,51,57,52,32,42,32,118,111,108,117,109,101,46,67,95,115,116,97,114,116,91,49,93,32,42,32,118,111,108,117,109,101,46,109,0,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,40,45,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,103,41,32,42,32,40,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,93,32,43,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,50,93,32,43,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,51,93,41,32,42,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,45,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,0,0,0,0,0,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,43,32,40,45,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,41,32,42,32,68,73,86,73,83,73,79,78,40,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,109,97,108,108,44,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,41,0,0,45,50,57,51,46,49,53,32,43,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,45,50,57,51,46,49,53,32,43,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,45,49,48,49,51,50,53,46,48,32,43,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,0,0,0,0,0,0,0,0,45,49,48,49,51,50,53,46,48,32,43,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,0,0,0,0,0,0,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,45,32,100,117,99,116,79,117,116,46,88,95,115,116,97,114,116,91,49,93,0,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,45,32,100,117,99,116,79,117,116,46,88,95,115,116,97,114,116,91,49,93,0,0,0,100,117,99,116,79,117,116,46,67,115,91,49,44,49,93,32,45,32,100,117,99,116,79,117,116,46,67,95,115,116,97,114,116,91,49,93,0,0,0,0,100,117,99,116,79,117,116,46,67,115,91,50,44,49,93,32,45,32,100,117,99,116,79,117,116,46,67,95,115,116,97,114,116,91,49,93,0,0,0,0,80,73,68,46,73,46,121,32,45,32,80,73,68,46,73,46,121,95,115,116,97,114,116,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,43,32,40,45,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,103,41,32,42,32,40,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,49,93,32,43,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,50,93,32,43,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,104,101,105,103,104,116,115,91,51,93,41,32,42,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,45,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,0,0,0,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,43,32,40,45,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,41,32,42,32,68,73,86,73,83,73,79,78,40,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,109,97,108,108,44,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,41,0,0,0,0,0,0,45,50,57,51,46,49,53,32,43,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,0,0,0,45,50,57,51,46,49,53,32,43,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,0,0,0,45,49,48,49,51,50,53,46,48,32,43,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,0,45,49,48,49,51,50,53,46,48,32,43,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,45,32,100,117,99,116,73,110,46,88,95,115,116,97,114,116,91,49,93,0,0,0,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,45,32,100,117,99,116,73,110,46,88,95,115,116,97,114,116,91,49,93,0,0,0,0,0,100,117,99,116,73,110,46,67,115,91,49,44,49,93,32,45,32,100,117,99,116,73,110,46,67,95,115,116,97,114,116,91,49,93,0,0,0,0,0,0,100,117,99,116,73,110,46,67,115,91,50,44,49,93,32,45,32,100,117,99,116,73,110,46,67,95,115,116,97,114,116,91,49,93,0,0,0,0,0,0,116,114,97,99,101,86,111,108,117,109,101,46,105,110,100,32,45,32,36,84,77,80,95,116,114,97,99,101,86,111,108,117,109,101,36,80,105,110,100,95,53,56,57,0,0,0,0,0,116,114,97,99,101,68,117,99,116,73,110,46,105,110,100,32,45,32,36,84,77,80,95,116,114,97,99,101,68,117,99,116,73,110,36,80,105,110,100,95,53,57,49,0,0,0,0,0,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,116,97,98,108,101,79,110,70,105,108,101,82,101,97,100,32,45,32,36,84,77,80,95,78,117,109,98,101,114,79,102,80,101,111,112,108,101,36,80,116,97,98,108,101,79,110,70,105,108,101,82,101,97,100,95,53,57,51,0,0,0,0,0,0,0,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,116,95,109,105,110,32,45,32,36,84,77,80,95,78,117,109,98,101,114,79,102,80,101,111,112,108,101,36,80,116,95,109,105,110,95,53,57,51,0,0,0,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,116,95,109,97,120,32,45,32,36,84,77,80,95,78,117,109,98,101,114,79,102,80,101,111,112,108,101,36,80,116,95,109,97,120,95,53,57,51,0,0,0,116,114,97,99,101,68,117,99,116,79,117,116,46,105,110,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([32,45,32,36,84,77,80,95,116,114,97,99,101,68,117,99,116,79,117,116,36,80,105,110,100,95,53,57,55,0,0,0,184,72,0,0,224,72,0,0,8,73,0,0,48,73,0,0,120,73,0,0,88,74,0,0,232,74,0,0,8,75,0,0,40,75,0,0,80,75,0,0,120,75,0,0,168,75,0,0,216,75,0,0,0,76,0,0,40,76,0,0,64,76,0,0,24,77,0,0,168,77,0,0,200,77,0,0,232,77,0,0,8,78,0,0,40,78,0,0,88,78,0,0,136,78,0,0,176,78,0,0,216,78,0,0,8,79,0,0,56,79,0,0,136,79,0,0,192,79,0,0,248,79,0,0,0,0,0,0,67,79,50,0,0,0,0,0,78,85,76,76,32,61,61,32,34,105,110,100,101,120,32,111,117,116,32,111,102,32,98,111,117,110,100,115,34,0,0,0,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,69,120,97,109,112,108,101,115,46,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,46,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,95,48,54,105,110,122,46,99,0,0,0,0,0,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,95,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,95,101,113,70,117,110,99,116,105,111,110,95,53,57,48,0,0,0,0,0,0,84,114,97,99,101,32,115,117,98,115,116,97,110,99,101,32,39,0,0,0,0,0,0,0,39,32,105,115,32,110,111,116,32,112,114,101,115,101,110,116,32,105,110,32,109,101,100,105,117,109,32,39,0,0,0,0,77,111,105,115,116,32,97,105,114,0,0,0,0,0,0,0,39,46,10,0,0,0,0,0,67,104,101,99,107,32,115,101,110,115,111,114,32,112,97,114,97,109,101,116,101,114,32,97,110,100,32,109,101,100,105,117,109,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,101,110,115,111,114,115,46,109,111,0,0,0,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,95,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,95,101,113,70,117,110,99,116,105,111,110,95,53,57,50,0,0,0,0,0,0,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,95,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,95,101,113,70,117,110,99,116,105,111,110,95,53,57,56,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,0,0,0,0,0,0,0,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,0,1,0,0,0,16,0,0,0,100,117,99,116,73,110,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,0,0,1,0,0,0,17,0,0,0,1,0,0,0,20,0,0,0,80,73,68,46,78,105,32,42,32,80,73,68,46,107,0,0,1,0,0,0,22,0,0,0,80,73,68,46,84,105,0,0,1,0,0,0,37,0,0,0,100,117,99,116,79,117,116,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,38,0,0,0,1,0,0,0,76,0,0,0,109,97,120,40,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,0,1,0,0,0,79,0,0,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,1,0,0,0,80,0,0,0,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,72,50,79,0,0,0,0,0,1,0,0,0,240,106,0,0,248,106,0,0,0,0,0,0,1,0,0,0,216,106,0,0,224,106,0,0,0,0,0,0,1,0,0,0,152,106,0,0,160,106,0,0,0,0,0,0,1,0,0,0,128,106,0,0,136,106,0,0,0,0,0,0,1,0,0,0,90,0,0,0,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,41,0,0,0,0,1,0,0,0,91,0,0,0,109,97,120,40,49,101,45,49,51,44,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,32,45,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,92,0,0,0,1,0,0,0,95,0,0,0,49,46,48,32,45,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,97,0,0,0,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,84,32,42,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,0,1,0,0,0,103,0,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,0,0,1,0,0,0,105,0,0,0,109,97,120,40,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,1,0,0,0,107,0,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,0,0,1,0,0,0,109,0,0,0,109,97,120,40,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,1,0,0,0,121,0,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,122,0,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,123,0,0,0,1,0,0,0,126,0,0,0,49,46,48,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,0,0,1,0,0,0,127,0,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,82,0,0,0,0,0,0,0,1,0,0,0,139,0,0,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,0,0,0,1,0,0,0,143,0,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,144,0,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,0,0,0,0,0,1,0,0,0,145,0,0,0,1,0,0,0,148,0,0,0,49,46,48,32,45,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,0,0,1,0,0,0,149,0,0,0,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,82,0,0,0,0,0,0,0,1,0,0,0,156,0,0,0,1,0,0,0,158,0,0,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,0,1,0,0,0,174,0,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,1,0,0,0,176,0,0,0,109,97,120,40,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,1,0,0,0,178,0,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,1,0,0,0,180,0,0,0,109,97,120,40,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,1,0,0,0,190,0,0,0,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,1,0,0,0,194,0,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,195,0,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,41,0,0,0,0,0,1,0,0,0,196,0,0,0,1,0,0,0,199,0,0,0,49,46,48,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,0,1,0,0,0,200,0,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,32,42,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,82,0,0,0,0,0,1,0,0,0,212,0,0,0,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,32,42,32,40,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,43,32,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,50,93,41,0,0,0,1,0,0,0,216,0,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,0,1,0,0,0,217,0,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,41,0,0,0,0,0,1,0,0,0,218,0,0,0,1,0,0,0,221,0,0,0,49,46,48,32,45,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,0,1,0,0,0,222,0,0,0,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,32,42,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,82,0,0,0,0,0,1,0,0,0,229,0,0,0,1,0,0,0,231,0,0,0,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,0,0,0,0,1,0,0,0,239,0,0,0,1,0,0,0,241,0,0,0,100,117,99,116,79,117,116,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,1,0,0,0,242,0,0,0,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,32,42,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,50,93,0,0,0,0,0,0,0,0,1,0,0,0,246,0,0,0,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,50,93,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,44,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,84,44,32,123,98,111,117,110,100,97,114,121,52,46,88,91,49,93,44,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,125,41,41,32,42,32,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,0,0,1,0,0,0,253,0,0,0,100,117,99,116,79,117,116,46,109,115,91,50,93,0,0,0,1,0,0,0,2,1,0,0,1,0,0,0,16,1,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,0,0,0,0,0,0,1,0,0,0,20,1,0,0,109,97,120,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,1,0,0,0,112,106,0,0,120,106,0,0,0,0,0,0,1,0,0,0,27,1,0,0,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,1,0,0,0,28,1,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,29,1,0,0,1,0,0,0,32,1,0,0,49,46,48,32,45,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,0,0,0,1,0,0,0,33,1,0,0,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,82,32,42,32,50,57,51,46,49,53,0,0,1,0,0,0,46,1,0,0,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,49,93,32,42,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,1,0,0,0,47,1,0,0,1,0,0,0,51,1,0,0,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,123,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,44,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,125,41,41,32,42,32,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,58,1,0,0,100,117,99,116,79,117,116,46,109,115,91,49,93,0,0,0,1,0,0,0,60,1,0,0,100,117,99,116,79,117,116,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,1,0,0,0,61,1,0,0,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,32,42,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,100,117,99,116,79,117,116,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,0,0,0,0,0,1,0,0,0,64,1,0,0,1,0,0,0,88,1,0,0,118,111,108,117,109,101,46,86,0,0,0,0,0,0,0,0,1,0,0,0,89,1,0,0,109,97,120,40,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,49,101,45,49,53,0,0,0,1,0,0,0,90,1,0,0,1,0,0,0,92,1,0,0,1,0,0,0,95,1,0,0,100,117,99,116,73,110,46,102,108,117,105,100,86,111,108,117,109,101,115,91,50,93,0,0,1,0,0,0,96,1,0,0,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,42,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,100,32,42,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,50,93,0,0,0,1,0,0,0,100,1,0,0,109,97,120,40,45,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,49,101,45,49,53,0,0,1,0,0,0,102,1,0,0,100,117,99,116,73,110,46,109,115,91,50,93,0,0,0,0,1,0,0,0,104,1,0,0,1,0,0,0,107,1,0,0,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,44,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,84,44,32,123,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,49,93,44,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,125,41,41,32,42,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,50,93,0,0,0,0,0,0,0,0,1,0,0,0,112,1,0,0,1,0,0,0,123,1,0,0,109,97,120,40,49,101,45,49,51,44,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,1,0,0,0,124,1,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,41,0,0,0,0,0,1,0,0,0,125,1,0,0,1,0,0,0,128,1,0,0,49,46,48,32,45,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,0,0,1,0,0,0,129,1,0,0,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,42,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,0,0,0,0,0,0,0,1,0,0,0,133,1,0,0,118,111,108,117,109,101,46,109,0,0,0,0,0,0,0,0,1,0,0,0,135,1,0,0,1,0,0,0,136,1,0,0,1,0,0,0,141,1,0,0,109,97,120,40,45,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,32,43,32,109,97,120,40,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,44,32,49,101,45,49,53,41,0,0,1,0,0,0,142,1,0,0,1,0,0,0,170,1,0,0,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,0,0,0,0,0,1,0,0,0,171,1,0,0,109,97,120,40,49,101,45,49,51,44,32,100,117,99,116,73,110,46,115,116,97,116,101,95,97,46,112,32,45,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,0,0,0,1,0,0,0,172,1,0,0,1,0,0,0,175,1,0,0,49,46,48,32,45,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,0,1,0,0,0,176,1,0,0,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,82,32,42,32,50,57,51,46,49,53,0,0,0,0,0,0,1,0,0,0,178,1,0,0,1,0,0,0,88,106,0,0,96,106,0,0,0,0,0,0,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,42,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,100,101,110,115,105,116,121,40,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,80,105,112,101,115,46,68,121,110,97,109,105,99,80,105,112,101,46,77,101,100,105,117,109,46,84,104,101,114,109,111,100,121,110,97,109,105,99,83,116,97,116,101,40,100,117,99,116,73,110,46,115,116,97,116,101,95,97,46,112,44,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,49,93,46,84,44,32,35,83,72,65,82,69,68,95,76,73,84,69,82,65,76,95,53,49,40,82,101,97,108,91,50,93,41,35,41,41,32,42,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,0,0,1,0,0,0,188,1,0,0,100,117,99,116,73,110,46,109,115,91,49,93,0,0,0,0,1,0,0,0,190,1,0,0,100,117,99,116,73,110,46,102,108,117,105,100,86,111,108,117,109,101,115,91,49,93,0,0,1,0,0,0,191,1,0,0,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,42,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,100,32,42,32,100,117,99,116,73,110,46,99,114,111,115,115,65,114,101,97,115,91,49,93,0,0,0,1,0,0,0,194,1,0,0,1,0,0,0,211,1,0,0,1,0,0,0,17,2,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,95,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,95,101,113,70,117,110,99,116,105,111,110,95,53,56,54,0,0,0,0,0,0,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,95,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,95,101,113,70,117,110,99,116,105,111,110,95,53,56,55,0,0,0,0,0,0,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,95,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,95,101,113,70,117,110,99,116,105,111,110,95,53,56,56,0,0,0,0,0,0,232,81,0,0,35,2,0,0,5,0,0,0,37,2,0,0,57,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,174,71,225,122,20,174,239,63,1,0,0,0,0,0,0,0,123,20,174,71,225,122,132,63,2,0,0,0,0,0,0,0,12,229,68,187,110,9,203,192,19,83,84,195,159,233,31,192,7,0,0,0,0,0,0,0,121,233,38,49,184,149,47,65,117,32,235,169,101,217,162,192,175,197,118,16,158,149,18,64,4,118,172,56,171,198,98,63,93,203,6,236,202,240,166,190,56,28,173,173,73,233,217,61,3,149,235,130,211,183,245,188,2,0,0,0,0,0,0,0,181,166,121,199,247,33,224,192,76,254,39,127,247,61,49,64,7,0,0,0,0,0,0,0,197,143,49,119,243,70,227,192,45,90,128,182,149,252,129,64,8,175,179,218,41,209,237,63,23,132,90,56,144,149,125,63,249,233,45,205,2,204,222,190,111,33,62,192,32,72,53,62,140,233,235,22,3,133,119,189,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,72,50,79,0,0,0,0,0,1,0,0,0,72,219,0,0,80,219,0,0,0,0,0,0,1,0,0,0,48,219,0,0,56,219,0,0,0,0,0,0,1,0,0,0,240,218,0,0,248,218,0,0,0,0,0,0,1,0,0,0,216,218,0,0,224,218,0,0,0,0,0,0,1,0,0,0,75,4,0,0,109,97,120,40,49,101,45,49,51,44,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,32,45,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,41,0,0,0,1,0,0,0,77,4,0,0,109,97,120,40,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,44,32,49,101,45,49,51,41,0,0,0,0,0,0,0,1,0,0,0,78,4,0,0,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,42,32,40,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,43,32,48,46,54,50,49,57,54,52,55,49,51,48,55,55,52,57,56,57,32,42,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,41,0,0,0,0,1,0,0,0,79,4,0,0,1,0,0,0,82,4,0,0,49,46,48,32,45,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,0,1,0,0,0,84,4,0,0,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,84,32,42,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,0,1,0,0,0,85,4,0,0,51,52,46,53,50,52,50,56,55,56,56,54,53,56,56,52,51,32,43,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,47,32,48,46,48,49,56,48,49,53,50,56,32,45,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,47,32,48,46,48,50,56,57,54,53,49,49,53,57,0,1,0,0,0,161,4,0,0,100,117,99,116,79,117,116,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,162,4,0,0,1,0,0,0,166,4,0,0,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,1,0,0,0,172,4,0,0,80,73,68,46,84,105,0,0,1,0,0,0,174,4,0,0,80,73,68,46,78,105,32,42,32,80,73,68,46,107,0,0,1,0,0,0,199,4,0,0,100,117,99,116,73,110,46,112,101,114,105,109,101,116,101,114,0,0,0,0,0,0,0,0,1,0,0,0,200,4,0,0,1,0,0,0,204,4,0,0,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,110,80,97,114,97,108,108,101,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,73,110,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([114,118,97,108,58,32,100,117,99,116,73,110,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,73,110,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,67,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,67,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,73,110,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,73,110,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,73,110,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,100,117,99,116,73,110,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,73,110,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,73,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,73,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,80,73,68,46,73,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,67,111,110,116,105,110,117,111,117,115,46,109,111,0,0,0,0,0,0,0,48,130,0,0,15,0,0,0,5,0,0,0,18,0,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,80,73,68,46,78,111,73,110,105,116,32,97,110,100,32,80,73,68,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,80,73,68,46,68,111,78,111,116,85,115,101,95,73,110,105,116,105,97,108,73,110,116,101,103,114,97,116,111,114,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,48,130,0,0,128,3,0,0,5,0,0,0,131,3,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,78,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,78,100,32,62,61,32,49,101,45,49,51,32,104,97,115,32,118,97,108,117,101,58,32,0,48,130,0,0,124,3,0,0,5,0,0,0,127,3,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,78,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,78,105,32,62,61,32,49,101,45,49,51,32,104,97,115,32,118,97,108,117,101,58,32,0,48,130,0,0,120,3,0,0,5,0,0,0,123,3,0,0,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,119,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,119,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,48,130,0,0,117,3,0,0,5,0,0,0,119,3,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,119,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,119,112,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,48,130,0,0,115,3,0,0,5,0,0,0,116,3,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,84,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,84,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,48,130,0,0,109,3,0,0,5,0,0,0,112,3,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,84,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,84,105,32,62,61,32,49,101,45,54,48,32,104,97,115,32,118,97,108,117,101,58,32,0,48,130,0,0,105,3,0,0,5,0,0,0,108,3,0,0,94,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,107,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,107,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,48,130,0,0,104,3,0,0,5,0,0,0,104,3,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,80,73,68,46,99,111,110,116,114,111,108,108,101,114,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,80,73,68,46,99,111,110,116,114,111,108,108,101,114,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,83,105,109,112,108,101,67,111,110,116,114,111,108,108,101,114,46,80,32,97,110,100,32,80,73,68,46,99,111,110,116,114,111,108,108,101,114,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,83,105,109,112,108,101,67,111,110,116,114,111,108,108,101,114,46,80,73,68,32,104,97,115,32,118,97,108,117,101,58,32,0,48,130,0,0,102,3,0,0,5,0,0,0,103,3,0,0,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,110,111,117,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,110,111,117,116,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,168,135,0,0,33,1,0,0,5,0,0,0,33,1,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,101,120,116,114,97,112,111,108,97,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,101,120,116,114,97,112,111,108,97,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,69,120,116,114,97,112,111,108,97,116,105,111,110,46,72,111,108,100,76,97,115,116,80,111,105,110,116,32,97,110,100,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,101,120,116,114,97,112,111,108,97,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,69,120,116,114,97,112,111,108,97,116,105,111,110,46,78,111,69,120,116,114,97,112,111,108,97,116,105,111,110,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,83,111,117,114,99,101,115,46,109,111,0,0,16,137,0,0,218,8,0,0,5,0,0,0,220,8,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,115,109,111,111,116,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,115,109,111,111,116,104,110,101,115,115,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,83,109,111,111,116,104,110,101,115,115,46,76,105,110,101,97,114,83,101,103,109,101,110,116,115,32,97,110,100,32,78,117,109,98,101,114,79,102,80,101,111,112,108,101,46,115,109,111,111,116,104,110,101,115,115,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,83,109,111,111,116,104,110,101,115,115,46,67,111,110,115,116,97,110,116,83,101,103,109,101,110,116,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,16,137,0,0,215,8,0,0,5,0,0,0,217,8,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,67,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,67,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,111,117,114,99,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,84,32,62,61,32,49,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,114,111,117,103,104,110,101,115,115,101,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,114,111,117,103,104,110,101,115,115,101,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,111,0,0,68,1,0,0,7,0,0,0,70,1,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,144,111,0,0,87,4,0,0,13,0,0,0,91,4,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,111,0,0,80,4,0,0,13,0,0,0,82,4,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,144,111,0,0,26,4,0,0,13,0,0,0,28,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,144,111,0,0,21,4,0,0,13,0,0,0,23,4,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,111,0,0,229,4,0,0,13,0,0,0,231,4,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,144,111,0,0,221,4,0,0,13,0,0,0,222,4,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,144,111,0,0,32,4,0,0,13,0,0,0,34,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,144,111,0,0,29,4,0,0,13,0,0,0,31,4,0,0,97,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,112,115,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,112,115,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,112,115,95,115,116,97,114,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,112,115,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,112,115,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,112,115,95,115,116,97,114,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,208,110,0,0,73,3,0,0,3,0,0,0,75,3,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,112,95,98,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,112,95,98,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,112,95,98,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,110,0,0,70,3,0,0,3,0,0,0,72,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,79,117,116,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,208,110,0,0,62,3,0,0,3,0,0,0,64,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,79,117,116,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,110,0,0,59,3,0,0,3,0,0,0,61,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,67,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,67,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,208,110,0,0,95,3,0,0,3,0,0,0,98,3,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,110,0,0,92,3,0,0,3,0,0,0,94,3,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,144,111,0,0,83,1,0,0,7,0,0,0,85,1,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,79,117,116,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,144,111,0,0,78,1,0,0,7,0,0,0,80,1,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,112,95,97,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,112,95,97,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,112,95,97,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,110,0,0,67,3,0,0,3,0,0,0,69,3,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,79,117,116,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,208,110,0,0,56,3,0,0,3,0,0,0,58,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,100,117,99,116,79,117,116,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,208,110,0,0,53,3,0,0,3,0,0,0,55,3,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,118,95,118,98,32,97,110,100,32,100,117,99,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([79,117,116,46,109,111,100,101,108,83,116,114,117,99,116,117,114,101,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,77,111,100,101,108,83,116,114,117,99,116,117,114,101,46,97,95,118,98,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,144,111,0,0,91,1,0,0,7,0,0,0,93,1,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,110,78,111,100,101,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,110,78,111,100,101,115,32,62,61,32,49,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,111,0,0,88,1,0,0,7,0,0,0,89,1,0,0,57,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,208,110,0,0,86,3,0,0,3,0,0,0,91,3,0,0,88,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,208,110,0,0,80,3,0,0,3,0,0,0,85,3,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,114,111,117,103,104,110,101,115,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,114,111,117,103,104,110,101,115,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,111,0,0,7,1,0,0,7,0,0,0,9,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,144,111,0,0,255,0,0,0,7,0,0,0,0,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,110,80,97,114,97,108,108,101,108,32,62,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,111,0,0,248,0,0,0,7,0,0,0,249,0,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,110,0,0,236,1,0,0,5,0,0,0,237,1,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,67,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,67,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,110,0,0,62,2,0,0,7,0,0,0,65,2,0,0,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,88,95,115,116,97,114,116,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,110,0,0,59,2,0,0,7,0,0,0,61,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,208,110,0,0,40,2,0,0,7,0,0,0,42,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,110,0,0,37,2,0,0,7,0,0,0,39,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,208,110,0,0,45,2,0,0,7,0,0,0,47,2,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,208,110,0,0,34,2,0,0,7,0,0,0,36,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,118,111,108,117,109,101,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,208,110,0,0,31,2,0,0,7,0,0,0,33,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,102,108,117,105,100,76,101,118,101,108,95,109,97,120,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,224,170,0,0,24,1,0,0,9,0,0,0,25,1,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,170,0,0,213,0,0,0,9,0,0,0,215,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,95,102,108,111,119,95,110,111,109,105,110,97,108,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,170,0,0,210,0,0,0,9,0,0,0,212,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,104,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,208,110,0,0,55,2,0,0,7,0,0,0,58,2,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,46,84,95,115,116,97,114,116,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,110,0,0,51,2,0,0,7,0,0,0,54,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,67,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,67,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,232,138,0,0,212,1,0,0,5,0,0,0,216,1,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,232,138,0,0,208,1,0,0,5,0,0,0,211,1,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,84,32,62,61,32,49,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,232,138,0,0,204,1,0,0,5,0,0,0,207,1,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,95,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,232,138,0,0,200,1,0,0,5,0,0,0,203,1,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,102,114,101,115,104,65,105,114,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,232,138,0,0,74,3,0,0,5,0,0,0,76,3,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,116,114,97,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,121,115,116,101,109,46,109,111,0,0,0,0,64,178,0,0,32,0,0,0,3,0,0,0,34,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,115,117,98,115,116,97,110,99,101,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,64,178,0,0,29,0,0,0,3,0,0,0,31,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,97,115,115,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,64,178,0,0,26,0,0,0,3,0,0,0,28,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,64,178,0,0,47,0,0,0,3,0,0,0,49,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,115,116,97,114,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,64,178,0,0,44,0,0,0,3,0,0,0,46,0,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,95,102,108,111,119,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,64,178,0,0,63,0,0,0,3,0,0,0,65,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,100,112,95,115,109,97,108,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,64,178,0,0,60,0,0,0,3,0,0,0,62,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,112,115,95,109,95,102,108,111,119,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,64,178,0,0,57,0,0,0,3,0,0,0,59,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,109,111,109,101,110,116,117,109,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,64,178,0,0,35,0,0,0,3,0,0,0,38,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,68,121,110,97,109,105,99,70,114,101,101,73,110,105,116,105,97,108,32,97,110,100,32,115,121,115,116,101,109,46,101,110,101,114,103,121,68,121,110,97,109,105,99,115,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,68,121,110,97,109,105,99,115,46,83,116,101,97,100,121,83,116,97,116,101,32,104,97,115,32,118,97,108,117,101,58,32,0,64,178,0,0,22,0,0,0,3,0,0,0,25,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,84,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,64,178,0,0,11,0,0,0,3,0,0,0,13,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,121,115,116,101,109,46,112,95,97,109,98,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,64,178,0,0,8,0,0,0,3,0,0,0,10,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,67,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,67,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,232,138,0,0,32,0,0,0,5,0,0,0,35,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,232,138,0,0,27,0,0,0,5,0,0,0,30,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,232,138,0,0,23,0,0,0,5,0,0,0,26,0,0,0,39,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,84,32,62,61,32,49,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,232,138,0,0,20,0,0,0,5,0,0,0,22,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,100,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,232,138,0,0,13,0,0,0,5,0,0,0,16,0,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,112,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,232,138,0,0,10,0,0,0,5,0,0,0,12,0,0,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,62,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,69,110,116,101,114,105,110,103,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,102,108,111,119,68,105,114,101,99,116,105,111,110,32,60,61,32,77,111,100,101,108,105,99,97,46,70,108,117,105,100,46,84,121,112,101,115,46,80,111,114,116,70,108,111,119,68,105,114,101,99,116,105,111,110,46,66,105,100,105,114,101,99,116,105,111,110,97,108,32,104,97,115,32,118,97,108,117,101,58,32,0,232,138,0,0,20,3,0,0,5,0,0,0,22,3,0,0,95,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,67,95,111,117,116,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,67,95,111,117,116,102,108,111,119,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,109,95,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,109,95,102,108,111,119,32,62,61,32,48,46,48,32,97,110,100,32,116,114,97,99,101,68,117,99,116,79,117,116,46,112,111,114,116,46,109,95,102,108,111,119,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,208,110,0,0,13,0,0,0,5,0,0,0,14,0,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,67,95,111,117,116,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,67,95,111,117,116,102,108,111,119,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,116,114,97,99,101,86,111,108,117,109,101,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,102,108,117,105,100,76,101,118,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,102,108,117,105,100,76,101,118,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,170,0,0,22,1,0,0,9,0,0,0,23,1,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,152,197,0,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,152,197,0,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,52,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,224,170,0,0,224,0,0,0,9,0,0,0,224,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,52,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,52,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,52,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,224,170,0,0,225,0,0,0,9,0,0,0,225,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,152,197,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,197,0,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,152,197,0,0,126,21,0,0,7,0,0,0,127,21,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,205,0,0,51,0,0,0,7,0,0,0,51,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,152,197,0,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,152,205,0,0,62,0,0,0,7,0,0,0,62,0,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,100,112,95,102,114,105,99,95,110,111,109,105,110,97,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,144,111,0,0,245,4,0,0,13,0,0,0,1,5,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,67,95,111,117,116,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,67,95,111,117,116,102,108,111,119,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,208,110,0,0,20,0,0,0,5,0,0,0,21,0,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,88,105,95,111,117,116,102,108,111,119,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,208,110,0,0,18,0,0,0,5,0,0,0,19,0,0,0,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,116,114,97,99,101,68,117,99,116,73,110,46,112,111,114,116,46,104,95,111,117,116,102,108,111,119,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,208,110,0,0,16,0,0,0,5,0,0,0,17,0,0,0,84,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,152,197,0,0,125,21,0,0,7,0,0,0,125,21,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,111,0,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,144,111,0,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,152,205,0,0,60,0,0,0,7,0,0,0,61,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,152,205,0,0,58,0,0,0,7,0,0,0,59,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,152,205,0,0,55,0,0,0,7,0,0,0,55,0,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,152,205,0,0,56,0,0,0,7,0,0,0,56,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,152,197,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,152,197,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,98,111,117,110,100,97,114,121,52,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,152,197,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,12,229,68,187,110,9,203,192,19,83,84,195,159,233,31,192,7,0,0,0,0,0,0,0,121,233,38,49,184,149,47,65,117,32,235,169,101,217,162,192,175,197,118,16,158,149,18,64,4,118,172,56,171,198,98,63,93,203,6,236,202,240,166,190,56,28,173,173,73,233,217,61,3,149,235,130,211,183,245,188,2,0,0,0,0,0,0,0,181,166,121,199,247,33,224,192,76,254,39,127,247,61,49,64,7,0,0,0,0,0,0,0,197,143,49,119,243,70,227,192,45,90,128,182,149,252,129,64,8,175,179,218,41,209,237,63,23,132,90,56,144,149,125,63,249,233,45,205,2,204,222,190,111,33,62,192,32,72,53,62,140,233,235,22,3,133,119,189,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,86,111,108,117,109,101,46,67,86,101,99,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,86,111,108,117,109,101,46,67,86,101,99,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,83,101,110,115,111,114,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,100,105,97,47,65,105,114,47,77,111,105,115,116,65,105,114,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,102,114,101,115,104,65,105,114,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,73,110,116,101,114,102,97,99,101,115,46,109,111,0,0,0,0,0,0,0,0,104,226,0,0,74,2,0,0,7,0,0,0,74,2,0,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,88,105,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,104,226,0,0,75,2,0,0,7,0,0,0,75,2,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,67,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,67,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,226,0,0,76,2,0,0,7,0,0,0,76,2,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,98,88,105,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,98,88,105,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,98,88,105,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,226,0,0,83,2,0,0,7,0,0,0,84,2,0,0,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,86,101,115,115,101,108,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,115,95,72,95,102,108,111,119,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,24,229,0,0,224,0,0,0,9,0,0,0,224,0,0,0,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,115,95,109,88,105,95,102,108,111,119,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,24,229,0,0,225,0,0,0,9,0,0,0,225,0,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,112,111,114,116,73,110,68,101,110,115,105,116,105,101,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,24,229,0,0,255,0,0,0,9,0,0,0,0,1,0,0,56,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,62,61,32,49,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,220,0,0,36,17,0,0,7,0,0,0,37,17,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,118,111,108,117,109,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,109,67,95,115,99,97,108,101,100,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,109,67,95,115,99,97,108,101,100,91,49,93,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,226,0,0,95,2,0,0,7,0,0,0,96,2,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,118,111,108,117,109,101,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,118,111,108,117,109,101,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,49,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,88,105,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,88,105,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,88,105,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,88,105,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,67,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,67,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,67,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,67,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,67,115,95,115,99,97,108,101,100,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,67,115,95,115,99,97,108,101,100,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,67,115,95,115,99,97,108,101,100,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,67,115,95,115,99,97,108,101,100,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,67,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,67,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,67,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,67,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,70,108,117,105,100,47,80,105,112,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,100,117,99,116,79,117,116,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,67,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,79,117,116,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,79,117,116,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,79,117,116,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,100,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,82,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,112,101,111,112,108,101,83,111,117,114,99,101,46,109,101,100,105,117,109,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,103,97,105,110,46,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,103,97,105,110,46,121,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,103,97,105,110,46,121,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,77,97,116,104,46,109,111,0,0,0,0,0,104,39,1,0,122,2,0,0,9,0,0,0,124,2,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,116,97,116,101,95,97,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,115,116,97,116,101,95,97,46,112,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,115,116,97,116,101,95,97,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,220,0,0,124,21,0,0,7,0,0,0,124,21,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,50,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,51,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,220,0,0,125,21,0,0,7,0,0,0,125,21,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,115,116,97,116,101,115,70,77,91,52,93,46,88,91,50,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,216,220,0,0,126,21,0,0,7,0,0,0,127,21,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,226,0,0,102,3,0,0,3,0,0,0,102,3,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,88,105,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,88,105,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,88,105,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,88,105,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,104,226,0,0,103,3,0,0,3,0,0,0,103,3,0,0,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,67,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,67,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,67,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,67,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,104,226,0,0,104,3,0,0,3,0,0,0,104,3,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,67,115,95,115,99,97,108,101,100,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,67,115,95,115,99,97,108,101,100,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,67,115,95,115,99,97,108,101,100,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,67,115,95,115,99,97,108,101,100,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,104,226,0,0,107,3,0,0,3,0,0,0,107,3,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,67,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,67,115,91,49,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,67,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,67,115,91,50,44,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,104,226,0,0,108,3,0,0,3,0,0,0,108,3,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,98,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,98,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,98,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,98,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,98,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,98,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,104,226,0,0,118,3,0,0,3,0,0,0,118,3,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,98,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,98,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,104,226,0,0,119,3,0,0,3,0,0,0,120,3,0,0,52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,49,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,50,93,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,97,110,100,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,24,254,0,0,144,1,0,0,7,0,0,0,147,1,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,88,105,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,24,254,0,0,148,1,0,0,7,0,0,0,149,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,49,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,49,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,49,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,50,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,50,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,50,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,51,44,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,51,44,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,67,95,102,108,111,119,115,91,51,44,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,24,254,0,0,150,1,0,0,7,0,0,0,151,1,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,49,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,50,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,51,93,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,72,95,102,108,111,119,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,24,254,0,0,152,1,0,0,7,0,0,0,153,1,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,91,52,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,24,254,0,0,52,4,0,0,13,0,0,0,52,4,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,114,104,111,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,24,254,0,0,53,4,0,0,13,0,0,0,53,4,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71680);
/* memory initializer */ allocate([32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,91,52,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,24,254,0,0,55,4,0,0,13,0,0,0,55,4,0,0,125,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,49,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,50,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,117,115,95,97,99,116,91,51,93,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,24,254,0,0,56,4,0,0,13,0,0,0,56,4,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,49,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,49,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,50,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,50,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,51,93,32,62,61,32,45,49,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,102,108,111,119,77,111,100,101,108,46,109,95,102,108,111,119,115,95,116,117,114,98,117,108,101,110,116,91,51,93,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,24,254,0,0,73,4,0,0,13,0,0,0,75,4,0,0,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,49,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,216,220,0,0,30,17,0,0,7,0,0,0,30,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,105,91,49,93,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,216,220,0,0,31,17,0,0,7,0,0,0,32,17,0,0,50,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,104,32,62,61,32,45,49,48,48,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,104,32,60,61,32,49,48,48,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,220,0,0,33,17,0,0,7,0,0,0,33,17,0,0,60,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,100,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,100,32,60,61,32,49,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,216,220,0,0,34,17,0,0,7,0,0,0,34,17,0,0,36,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,32,62,61,32,49,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,84,32,60,61,32,49,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,216,220,0,0,35,17,0,0,7,0,0,0,35,17,0,0,44,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,117,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,117,32,62,61,32,45,49,48,48,48,48,48,48,48,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,117,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,216,220,0,0,38,17,0,0,7,0,0,0,38,17,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,82,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,82,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,82,32,60,61,32,49,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,216,220,0,0,39,17,0,0,7,0,0,0,39,17,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,62,61,32,48,46,48,48,49,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,77,77,32,60,61,32,48,46,50,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,216,220,0,0,40,17,0,0,7,0,0,0,40,17,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,120,95,119,97,116,101,114,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,96,223,0,0,51,0,0,0,7,0,0,0,51,0,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,108,105,113,117,105,100,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,96,223,0,0,55,0,0,0,7,0,0,0,55,0,0,0,69,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,116,101,97,109,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,96,223,0,0,56,0,0,0,7,0,0,0,56,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,88,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,96,223,0,0,58,0,0,0,7,0,0,0,59,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,120,95,115,97,116,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,96,223,0,0,60,0,0,0,7,0,0,0,61,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,62,61,32,48,46,48,32,97,110,100,32,100,117,99,116,73,110,46,109,101,100,105,117,109,115,91,50,93,46,112,95,115,116,101,97,109,95,115,97,116,32,60,61,32,49,48,48,48,48,48,48,48,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,96,223,0,0,62,0,0,0,7,0,0,0,62,0,0,0,74,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,117,99,116,73,110,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,117,99,116,73,110,46,104,101,97,116,84,114,97,110,115,102,101,114,46,84,115,91,50,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,104,226,0,0,247,1,0,0,5,0,0,0,248,1,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,116,114,97,99,101,68,117,99,116,79,117,116,46,67,86,101,99,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,116,114,97,99,101,68,117,99,116,79,117,116,46,67,86,101,99,91,49,93,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,248,219,0,0,25,2,0,0,5,0,0,0,27,2,0,0,108,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,95,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,50,49,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,50,49,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,50,49,44,50,49,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,50,49,44,48,93,32,61,32,122,101,114,111,115,40,50,49,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,50,49,93,32,61,32,122,101,114,111,115,40,48,44,50,49,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,50,49,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,73,110,80,109,101,100,105,117,109,115,108,66,50,114,66,80,84,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,73,110,80,109,101,100,105,117,109,115,108,66,50,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,73,110,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,73,110,80,109,101,100,105,117,109,115,108,66,49,114,66,80,84,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,73,110,80,109,101,100,105,117,109,115,108,66,49,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,73,110,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,73,110,80,109,67,115,95,115,99,97,108,101,100,108,66,49,99,49,114,66,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,73,110,80,109,67,115,95,115,99,97,108,101,100,108,66,50,99,49,114,66,32,61,32,120,91,56,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,79,117,116,80,109,101,100,105,117,109,115,108,66,50,114,66,80,84,32,61,32,120,91,57,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,79,117,116,80,109,101,100,105,117,109,115,108,66,50,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,49,48,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,79,117,116,80,109,101,100,105,117,109,115,108,66,50,114,66,80,112,32,61,32,120,91,49,49,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,79,117,116,80,109,101,100,105,117,109,115,108,66,49,114,66,80,84,32,61,32,120,91,49,50,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,79,117,116,80,109,101,100,105,117,109,115,108,66,49,114,66,80,88,105,108,66,49,114,66,32,61,32,120,91,49,51,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,79,117,116,80,109,101,100,105,117,109,115,108,66,49,114,66,80,112,32,61,32,120,91,49,52,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,79,117,116,80,109,67,115,95,115,99,97,108,101,100,108,66,49,99,49,114,66,32,61,32,120,91,49,53,93,59,10,32,32,82,101,97,108,32,120,95,80,100,117,99,116,79,117,116,80,109,67,115,95,115,99,97,108,101,100,108,66,50,99,49,114,66,32,61,32,120,91,49,54,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,67,95,115,99,97,108,101,100,108,66,49,114,66,32,61,32,120,91,49,55,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,88,105,108,66,49,114,66,32,61,32,120,91,49,56,93,59,10,32,32,82,101,97,108,32,120,95,80,80,73,68,80,73,80,121,32,61,32,120,91,49,57,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,84,32,61,32,120,91,50,48,93,59,10,32,32,82,101,97,108,32,120,95,80,118,111,108,117,109,101,80,109,101,100,105,117,109,80,112,32,61,32,120,91,50,49,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,70,108,117,105,100,95,69,120,97,109,112,108,101,115,95,84,114,97,99,101,83,117,98,115,116,97,110,99,101,115,95,82,111,111,109,67,79,50,87,105,116,104,67,111,110,116,114,111,108,115,59,10,0,0,0,0,0,77,101,109,111,114,121,32,97,108,108,111,99,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,0,0,0,0,84,97,98,108,101,32,115,111,117,114,99,101,32,101,114,114,111,114,10,0,0,0,0,0,85,110,107,110,111,119,110,32,115,109,111,111,116,104,110,101,115,115,32,107,105,110,100,10,0,0,0,0,0,0,0,0,69,120,116,114,97,112,111,108,97,116,105,111,110,32,101,114,114,111,114,10,0,0,0,0,85,110,107,110,111,119,110,32,101,120,116,114,97,112,111,108,97,116,105,111,110,32,107,105,110,100,10,0,0,0,0,0,78,111,32,116,97,98,108,101,32,100,97,116,97,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,100,101,116,101,99,116,105,111,110,32,111,102,32,116,105,109,101,32,101,118,101,110,116,115,10,0,0,0,70,117,110,99,116,105,111,110,32,34,117,115,101,114,116,97,98,34,32,105,115,32,110,111,116,32,105,109,112,108,101,109,101,110,116,101,100,10,0,0,46,109,97,116,0,0,0,0,46,77,65,84,0,0,0,0,46,46,46,32,108,111,97,100,105,110,103,32,34,37,115,34,32,102,114,111,109,32,34,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,78,111,116,32,112,111,115,115,105,98,108,101,32,116,111,32,111,112,101,110,32,102,105,108,101,32,34,37,115,34,58,32,78,111,32,115,117,99,104,32,102,105,108,101,32,111,114,32,100,105,114,101,99,116,111,114,121,10,0,0,0,0,0,0,69,114,114,111,114,32,114,101,97,100,105,110,103,32,102,105,114,115,116,32,108,105,110,101,32,102,114,111,109,32,102,105,108,101,32,34,37,115,34,58,32,69,110,100,45,79,102,45,70,105,108,101,32,114,101,97,99,104,101,100,46,10,0,0,35,49,0,0,0,0,0,0,69,114,114,111,114,32,114,101,97,100,105,110,103,32,102,111,114,109,97,116,32,97,110,100,32,118,101,114,115,105,111,110,32,105,110,102,111,114,109,97,116,105,111,110,32,105,110,32,102,105,114,115,116,32,108,105,110,101,32,111,102,32,102,105,108,101,32,34,37,115,34,58,32,34,35,49,34,32,101,120,112,101,99,116,101,100,46,10,0,0,0,0,0,0,0,0,69,114,114,111,114,32,114,101,97,100,105,110,103,32,102,111,114,109,97,116,32,97,110,100,32,118,101,114,115,105,111,110,32,105,110,102,111,114,109,97,116,105,111,110,32,105,110,32,102,105,114,115,116,32,108,105,110,101,32,111,102,32,102,105,108,101,32,34,37,115,34,58,32,34,35,49,34,32,101,120,112,101,99,116,101,100,44,32,98,117,116,32,34,37,99,34,32,102,111,117,110,100,46,10,0,0,0,0,0,0,0,0,69,114,114,111,114,32,114,101,97,100,105,110,103,32,102,111,114,109,97,116,32,97,110,100,32,118,101,114,115,105,111,110,32,105,110,102,111,114,109,97,116,105,111,110,32,105,110,32,102,105,114,115,116,32,108,105,110,101,32,111,102,32,102,105,108,101,32,34,37,115,34,58,32,34,35,49,34,32,101,120,112,101,99,116,101,100,44,32,98,117,116,32,34,37,99,37,99,34,32,102,111,117,110,100,46,10,0,0,0,0,0,0,32,9,40,44,41,13,0,0,100,111,117,98,108,101,0,0,102,108,111,97,116,0,0,0,32,9,44,59,13,0,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,34,32,110,111,116,32,102,111,117,110,100,32,111,110,32,102,105,108,101,32,34,37,115,34,46,10,0,0,0,0,0,0,69,110,100,45,111,102,45,102,105,108,101,32,114,101,97,99,104,101,100,32,119,104,101,110,32,114,101,97,100,105,110,103,32,110,117,109,101,114,105,99,32,100,97,116,97,32,111,102,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,102,114,111,109,32,102,105,108,101,32,34,37,115,34,10,0,0,0,69,114,114,111,114,32,105,110,32,108,105,110,101,32,37,108,117,32,119,104,101,110,32,114,101,97,100,105,110,103,32,110,117,109,101,114,105,99,32,100,97,116,97,32,111,102,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,102,114,111,109,32,102,105,108,101,32,34,37,115,34,10,0,0,0,0,0,84,97,98,108,101,32,97,114,114,97,121,32,34,37,115,34,32,104,97,115,32,110,111,116,32,116,104,101,32,114,101,113,117,105,114,101,100,32,114,97,110,107,32,50,46,10,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,34,32,104,97,115,32,110,111,116,32,116,104,101,32,114,101,113,117,105,114,101,100,32,100,111,117,98,108,101,32,112,114,101,99,105,115,105,111,110,32,99,108,97,115,115,46,10,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,34,32,109,117,115,116,32,110,111,116,32,98,101,32,99,111,109,112,108,101,120,46,10,0,69,114,114,111,114,32,119,104,101,110,32,114,101,97,100,105,110,103,32,110,117,109,101,114,105,99,32,100,97,116,97,32,111,102,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,102,114,111,109,32,102,105,108,101,32,34,37,115,34,10,0,84,104,101,32,102,105,108,101,32,110,97,109,101,32,102,111,114,32,97,32,116,97,98,108,101,32,40,61,32,34,37,115,34,41,32,105,115,32,100,101,102,105,110,101,100,44,32,98,117,116,32,110,111,116,32,116,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,116,97,98,108,101,32,110,97,109,101,46,10,0,0,0,78,111,78,97,109,101,0,0,84,104,101,32,118,97,108,117,101,115,32,111,102,32,116,104,101,32,102,105,114,115,116,32,99,111,108,117,109,110,32,111,102,32,116,97,98,108,101,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,97,114,101,32,110,111,116,32,115,116,114,105,99,116,108,121,32,105,110,99,114,101,97,115,105,110,103,32,98,101,99,97,117,115,101,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,32,62,61,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,46,10,0,0,0,0,0,0,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,97,112,112,114,111,112,114,105,97,116,101,32,100,105,109,101,110,115,105,111,110,115,32,102,111,114,32,116,105,109,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,46,10,0,0,0,0,0,0,0,0,84,97,98,108,101,32,109,97,116,114,105,120,32,34,37,115,34,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,97,32,112,111,115,105,116,105,118,101,32,112,101,114,105,111,100,47,99,121,108,99,101,32,116,105,109,101,32,102,111,114,32,116,105,109,101,32,105,110,116,101,114,112,111,108,97,116,105,111,110,32,119,105,116,104,32,112,101,114,105,111,100,105,99,32,101,120,116,114,97,112,111,108,97,116,105,111,110,46,10,0,0,0,0,0,0,0,84,104,101,32,118,97,108,117,101,115,32,111,102,32,116,104,101,32,102,105,114,115,116,32,99,111,108,117,109,110,32,111,102,32,116,97,98,108,101,32,34,37,115,40,37,108,117,44,37,108,117,41,34,32,97,114,101,32,110,111,116,32,109,111,110,111,116,111,110,105,99,97,108,108,121,32,105,110,99,114,101,97,115,105,110,103,32,98,101,99,97,117,115,101,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,32,62,32,37,115,40,37,108,117,44,49,41,32,40,61,37,108,102,41,46,10,0,0,0,0,73,110,102,108,97,116,101,83,107,105,112,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,0,0,73,110,102,108,97,116,101,86,97,114,84,97,103,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,73,110,102,108,97,116,101,65,114,114,97,121,70,108,97,103,115,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,73,110,102,108,97,116,101,68,105,109,101,110,115,105,111,110,115,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,73,110,102,108,97,116,101,68,105,109,101,110,115,105,111,110,115,58,32,82,101,97,100,105,110,103,32,100,105,109,101,110,115,105,111,110,115,32,101,120,112,101,99,116,101,100,32,116,121,112,101,32,77,65,84,95,84,95,73,78,84,51,50,0,73,110,102,108,97,116,101,86,97,114,78,97,109,101,84,97,103,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,73,110,102,108,97,116,101,86,97,114,78,97,109,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81920);
/* memory initializer */ allocate([105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,73,110,102,108,97,116,101,68,97,116,97,84,121,112,101,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,73,110,102,108,97,116,101,68,97,116,97,58,32,110,66,121,116,101,115,32,109,117,115,116,32,98,101,32,62,32,48,0,73,110,102,108,97,116,101,68,97,116,97,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,0,0,73,110,102,108,97,116,101,70,105,101,108,100,78,97,109,101,76,101,110,103,116,104,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,73,110,102,108,97,116,101,70,105,101,108,100,78,97,109,101,115,84,97,103,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,0,73,110,102,108,97,116,101,70,105,101,108,100,78,97,109,101,115,58,32,105,110,102,108,97,116,101,32,114,101,116,117,114,110,101,100,32,37,100,0,0,37,115,10,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,77,65,84,32,102,105,108,101,0,0,0,0,0,0,37,115,32,100,111,101,115,32,110,111,116,32,115,101,101,109,32,116,111,32,98,101,32,97,32,118,97,108,105,100,32,77,65,84,32,102,105,108,101,0,37,115,0,0,0,0,0,0,78,111,32,72,68,70,53,32,115,117,112,112,111,114,116,32,119,104,105,99,104,32,105,115,32,114,101,113,117,105,114,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,118,55,46,51,32,77,65,84,32,102,105,108,101,32,34,37,115,34,0,0,0,0,0,0,0,0,65,110,32,101,114,114,111,114,32,111,99,99,117,114,114,101,100,32,105,110,32,114,101,97,100,105,110,103,32,116,104,101,32,77,65,84,32,102,105,108,101,0,0,0,0,0,0,0,119,98,0,0,0,0,0,0,77,65,84,76,65,66,32,53,46,48,32,77,65,84,45,102,105,108,101,44,32,80,108,97,116,102,111,114,109,58,32,37,115,44,32,67,114,101,97,116,101,100,32,98,121,58,32,108,105,98,109,97,116,105,111,32,118,37,100,46,37,100,46,37,100,32,111,110,32,37,115,0,85,78,75,78,79,87,78,0,32,32,32,32,32,32,32,32,32,32,32,32,0,0,0,0,49,46,50,46,53,0,0,0,105,110,102,108,97,116,101,73,110,105,116,50,32,114,101,116,117,114,110,101,100,32,37,100,0,0,0,0,0,0,0,0,85,110,99,111,109,112,114,101,115,115,101,100,32,116,121,112,101,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,0,0,0,0,0,0,78,111,116,32,112,111,115,115,105,98,108,101,32,116,111,32,114,101,97,100,32,99,111,109,112,114,101,115,115,101,100,32,118,55,32,77,65,84,32,102,105,108,101,32,34,37,115,34,0,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,37,115,45,62,100,97,116,97,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,99,101,108,108,32,37,100,0,0,0,99,101,108,108,115,91,37,100,93,44,32,85,110,99,111,109,112,114,101,115,115,101,100,32,116,121,112,101,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,0,0,0,69,120,112,101,99,116,101,100,32,77,65,84,95,84,95,85,73,78,84,51,50,32,102,111,114,32,65,114,114,97,121,32,84,97,103,115,44,32,103,111,116,32,37,100,0,0,0,0,105,110,102,108,97,116,101,67,111,112,121,32,114,101,116,117,114,110,101,100,32,101,114,114,111,114,32,37,100,0,0,0,99,101,108,108,115,91,37,100,93,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,44,32,102,112,111,115,32,61,32,37,108,100,0,0,69,114,114,111,114,32,103,101,116,116,105,110,103,32,102,105,101,108,100,110,97,109,101,32,115,105,122,101,0,0,0,0,102,105,101,108,100,115,91,37,100,93,44,32,85,110,99,111,109,112,114,101,115,115,101,100,32,116,121,112,101,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,0,0,102,105,101,108,100,115,91,37,100,93,32,110,111,116,32,77,65,84,95,84,95,77,65,84,82,73,88,44,32,102,112,111,115,32,61,32,37,108,100,0,40,78,85,76,76,41,0,0,60,78,85,76,76,62,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,0,0,0,0,0,0,0,0,49,46,50,46,56,0,0,0,16,0,17,0,18,0,0,0,8,0,7,0,9,0,6,0,10,0,5,0,11,0,4,0,12,0,3,0,13,0,2,0,14,0,1,0,15,0,0,0,105,110,99,111,114,114,101,99,116,32,104,101,97,100,101,114,32,99,104,101,99,107,0,0,117,110,107,110,111,119,110,32,99,111,109,112,114,101,115,115,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,105,110,118,97,108,105,100,32,119,105,110,100,111,119,32,115,105,122,101,0,0,0,0,0,117,110,107,110,111,119,110,32,104,101,97,100,101,114,32,102,108,97,103,115,32,115,101,116,0,0,0,0,0,0,0,0,104,101,97,100,101,114,32,99,114,99,32,109,105,115,109,97,116,99,104,0,0,0,0,0,105,110,118,97,108,105,100,32,98,108,111,99,107,32,116,121,112,101,0,0,0,0,0,0,105,110,118,97,108,105,100,32,115,116,111,114,101,100,32,98,108,111,99,107,32,108,101,110,103,116,104,115,0,0,0,0,116,111,111,32,109,97,110,121,32,108,101,110,103,116,104,32,111,114,32,100,105,115,116,97,110,99,101,32,115,121,109,98,111,108,115,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,100,101,32,108,101,110,103,116,104,115,32,115,101,116,0,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,98,105,116,32,108,101,110,103,116,104,32,114,101,112,101,97,116,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,100,101,32,45,45,32,109,105,115,115,105,110,103,32,101,110,100,45,111,102,45,98,108,111,99,107,0,0,0,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,115,32,115,101,116,0,0,0,0,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,115,32,115,101,116,0,0,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,0,0,0,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,0,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,0,0,105,110,99,111,114,114,101,99,116,32,100,97,116,97,32,99,104,101,99,107,0,0,0,0,105,110,99,111,114,114,101,99,116,32,108,101,110,103,116,104,32,99,104,101,99,107,0,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,192,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,160,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,224,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,144,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,208,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,176,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,240,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,200,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,168,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,232,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,152,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,216,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,184,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,248,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,196,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,164,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,228,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,148,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,212,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,180,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,244,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,204,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,172,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,236,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,156,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,220,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,188,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,252,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,194,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,162,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,226,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,146,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,210,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,178,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,242,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,202,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,170,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,234,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,154,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,218,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,186,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,250,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,198,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,166,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,230,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,150,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,214,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,182,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,246,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,206,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,174,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,238,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,158,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,222,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,190,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,254,0,96,7,0,0,0,8,80,0,0,8,16,0,20,8,115,0,18,7,31,0,0,8,112,0,0,8,48,0,0,9,193,0,16,7,10,0,0,8,96,0,0,8,32,0,0,9,161,0,0,8,0,0,0,8,128,0,0,8,64,0,0,9,225,0,16,7,6,0,0,8,88,0,0,8,24,0,0,9,145,0,19,7,59,0,0,8,120,0,0,8,56,0,0,9,209,0,17,7,17,0,0,8,104,0,0,8,40,0,0,9,177,0,0,8,8,0,0,8,136,0,0,8,72,0,0,9,241,0,16,7,4,0,0,8,84,0,0,8,20,0,21,8,227,0,19,7,43,0,0,8,116,0,0,8,52,0,0,9,201,0,17,7,13,0,0,8,100,0,0,8,36,0,0,9,169,0,0,8,4,0,0,8,132,0,0,8,68,0,0,9,233,0,16,7,8,0,0,8,92,0,0,8,28,0,0,9,153,0,20,7,83,0,0,8,124,0,0,8,60,0,0,9,217,0,18,7,23,0,0,8,108,0,0,8,44,0,0,9,185,0,0,8,12,0,0,8,140,0,0,8,76,0,0,9,249,0,16,7,3,0,0,8,82,0,0,8,18,0,21,8,163,0,19,7,35,0,0,8,114,0,0,8,50,0,0,9,197,0,17,7,11,0,0,8,98,0,0,8,34,0,0,9,165,0,0,8,2,0,0,8,130,0,0,8,66,0,0,9,229,0,16,7,7,0,0,8,90,0,0,8,26,0,0,9,149,0,20,7,67,0,0,8,122,0,0,8,58,0,0,9,213,0,18,7,19,0,0,8,106,0,0,8,42,0,0,9,181,0,0,8,10,0,0,8,138,0,0,8,74,0,0,9,245,0,16,7,5,0,0,8,86,0,0,8,22,0,64,8,0,0,19,7,51,0,0,8,118,0,0,8,54,0,0,9,205,0,17,7,15,0,0,8,102,0,0,8,38,0,0,9,173,0,0,8,6,0,0,8,134,0,0,8,70,0,0,9,237,0,16,7,9,0,0,8,94,0,0,8,30,0,0,9,157,0,20,7,99,0,0,8,126,0,0,8,62,0,0,9,221,0,18,7,27,0,0,8,110,0,0,8,46,0,0,9,189,0,0,8,14,0,0,8,142,0,0,8,78,0,0,9,253,0,96,7,0,0,0,8,81,0,0,8,17,0,21,8,131,0,18,7,31,0,0,8,113,0,0,8,49,0,0,9,195,0,16,7,10,0,0,8,97,0,0,8,33,0,0,9,163,0,0,8,1,0,0,8,129,0,0,8,65,0,0,9,227,0,16,7,6,0,0,8,89,0,0,8,25,0,0,9,147,0,19,7,59,0,0,8,121,0,0,8,57,0,0,9,211,0,17,7,17,0,0,8,105,0,0,8,41,0,0,9,179,0,0,8,9,0,0,8,137,0,0,8,73,0,0,9,243,0,16,7,4,0,0,8,85,0,0,8,21,0,16,8,2,1,19,7,43,0,0,8,117,0,0,8,53,0,0,9,203,0,17,7,13,0,0,8,101,0,0,8,37,0,0,9,171,0,0,8,5,0,0,8,133,0,0,8,69,0,0,9,235,0,16,7,8,0,0,8,93,0,0,8,29,0,0,9,155,0,20,7,83,0,0,8,125,0,0,8,61,0,0,9,219,0,18,7,23,0,0,8,109,0,0,8,45,0,0,9,187,0,0,8,13,0,0,8,141,0,0,8,77,0,0,9,251,0,16,7,3,0,0,8,83,0,0,8,19,0,21,8,195,0,19,7,35,0,0,8,115,0,0,8,51,0,0,9,199,0,17,7,11,0,0,8,99,0,0,8,35,0,0,9,167,0,0,8,3,0,0,8,131,0,0,8,67,0,0,9,231,0,16,7,7,0,0,8,91,0,0,8,27,0,0,9,151,0,20,7,67,0,0,8,123,0,0,8,59,0,0,9,215,0,18,7,19,0,0,8,107,0,0,8,43,0,0,9,183,0,0,8,11,0,0,8,139,0,0,8,75,0,0,9,247,0,16,7,5,0,0,8,87,0,0,8,23,0,64,8,0,0,19,7,51,0,0,8,119,0,0,8,55,0,0,9,207,0,17,7,15,0,0,8,103,0,0,8,39,0,0,9,175,0,0,8,7,0,0,8,135,0,0,8,71,0,0,9,239,0,16,7,9,0,0,8,95,0,0,8,31,0,0,9,159,0,20,7,99,0,0,8,127,0,0,8,63,0,0,9,223,0,18,7,27,0,0,8,111,0,0,8,47,0,0,9,191,0,0,8,15,0,0,8,143,0,0,8,79,0,0,9,255,0,16,5,1,0,23,5,1,1,19,5,17,0,27,5,1,16,17,5,5,0,25,5,1,4,21,5,65,0,29,5,1,64,16,5,3,0,24,5,1,2,20,5,33,0,28,5,1,32,18,5,9,0,26,5,1,8,22,5,129,0,64,5,0,0,16,5,2,0,23,5,129,1,19,5,25,0,27,5,1,24,17,5,7,0,25,5,1,6,21,5,97,0,29,5,1,96,16,5,4,0,24,5,1,3,20,5,49,0,28,5,1,48,18,5,13,0,26,5,1,12,22,5,193,0,64,5,0,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,10,0,11,0,13,0,15,0,17,0,19,0,23,0,27,0,31,0,35,0,43,0,51,0,59,0,67,0,83,0,99,0,115,0,131,0,163,0,195,0,227,0,2,1,0,0,0,0,0,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,16,0,17,0,17,0,17,0,17,0,18,0,18,0,18,0,18,0,19,0,19,0,19,0,19,0,20,0,20,0,20,0,20,0,21,0,21,0,21,0,21,0,16,0,72,0,78,0,0,0,1,0,2,0,3,0,4,0,5,0,7,0,9,0,13,0,17,0,25,0,33,0,49,0,65,0,97,0,129,0,193,0,1,1,129,1,1,2,1,3,1,4,1,6,1,8,1,12,1,16,1,24,1,32,1,48,1,64,1,96,0,0,0,0,16,0,16,0,16,0,16,0,17,0,17,0,18,0,18,0,19,0,19,0,20,0,20,0,21,0,21,0,22,0,22,0,23,0,23,0,24,0,24,0,25,0,25,0,26,0,26,0,27,0,27,0,28,0,28,0,29,0,29,0,64,0,64,0,0,0,0,0,150,48,7,119,44,97,14,238,186,81,9,153,25,196,109,7,143,244,106,112,53,165,99,233,163,149,100,158,50,136,219,14,164,184,220,121,30,233,213,224,136,217,210,151,43,76,182,9,189,124,177,126,7,45,184,231,145,29,191,144,100,16,183,29,242,32,176,106,72,113,185,243,222,65,190,132,125,212,218,26,235,228,221,109,81,181,212,244,199,133,211,131,86,152,108,19,192,168,107,100,122,249,98,253,236,201,101,138,79,92,1,20,217,108,6,99,99,61,15,250,245,13,8,141,200,32,110,59,94,16,105,76,228,65,96,213,114,113,103,162,209,228,3,60,71,212,4,75,253,133,13,210,107,181,10,165,250,168,181,53,108,152,178,66,214,201,187,219,64,249,188,172,227,108,216,50,117,92,223,69,207,13,214,220,89,61,209,171,172,48,217,38,58,0,222,81,128,81,215,200,22,97,208,191,181,244,180,33,35,196,179,86,153,149,186,207,15,165,189,184,158,184,2,40,8,136,5,95,178,217,12,198,36,233,11,177,135,124,111,47,17,76,104,88,171,29,97,193,61,45,102,182,144,65,220,118,6,113,219,1,188,32,210,152,42,16,213,239,137,133,177,113,31,181,182,6,165,228,191,159,51,212,184,232,162,201,7,120,52,249,0,15,142,168,9,150,24,152,14,225,187,13,106,127,45,61,109,8,151,108,100,145,1,92,99,230,244,81,107,107,98,97,108,28,216,48,101,133,78,0,98,242,237,149,6,108,123,165,1,27,193,244,8,130,87,196,15,245,198,217,176,101,80,233,183,18,234,184,190,139,124,136,185,252,223,29,221,98,73,45,218,21,243,124,211,140,101,76,212,251,88,97,178,77,206,81,181,58,116,0,188,163,226,48,187,212,65,165,223,74,215,149,216,61,109,196,209,164,251,244,214,211,106,233,105,67,252,217,110,52,70,136,103,173,208,184,96,218,115,45,4,68,229,29,3,51,95,76,10,170,201,124,13,221,60,113,5,80,170,65,2,39,16,16,11,190,134,32,12,201,37,181,104,87,179,133,111,32,9,212,102,185,159,228,97,206,14,249,222,94,152,201,217,41,34,152,208,176,180,168,215,199,23,61,179,89,129,13,180,46,59,92,189,183,173,108,186,192,32,131,184,237,182,179,191,154,12,226,182,3,154,210,177,116,57,71,213,234,175,119,210,157,21,38,219,4,131,22,220,115,18,11,99,227,132,59,100,148,62,106,109,13,168,90,106,122,11,207,14,228,157,255,9,147,39,174,0,10,177,158,7,125,68,147,15,240,210,163,8,135,104,242,1,30,254,194,6,105,93,87,98,247,203,103,101,128,113,54,108,25,231,6,107,110,118,27,212,254,224,43,211,137,90,122,218,16,204,74,221,103,111,223,185,249,249,239,190,142,67,190,183,23,213,142,176,96,232,163,214,214,126,147,209,161,196,194,216,56,82,242,223,79,241,103,187,209,103,87,188,166,221,6,181,63,75,54,178,72,218,43,13,216,76,27,10,175,246,74,3,54,96,122,4,65,195,239,96,223,85,223,103,168,239,142,110,49,121,190,105,70,140,179,97,203,26,131,102,188,160,210,111,37,54,226,104,82,149,119,12,204,3,71,11,187,185,22,2,34,47,38,5,85,190,59,186,197,40,11,189,178,146,90,180,43,4,106,179,92,167,255,215,194,49,207,208,181,139,158,217,44,29,174,222,91,176,194,100,155,38,242,99,236,156,163,106,117,10,147,109,2,169,6,9,156,63,54,14,235,133,103,7,114,19,87,0,5,130,74,191,149,20,122,184,226,174,43,177,123,56,27,182,12,155,142,210,146,13,190,213,229,183,239,220,124,33,223,219,11,212,210,211,134,66,226,212,241,248,179,221,104,110,131,218,31,205,22,190,129,91,38,185,246,225,119,176,111,119,71,183,24,230,90,8,136,112,106,15,255,202,59,6,102,92,11,1,17,255,158,101,143,105,174,98,248,211,255,107,97,69,207,108,22,120,226,10,160,238,210,13,215,84,131,4,78,194,179,3,57,97,38,103,167,247,22,96,208,77,71,105,73,219,119,110,62,74,106,209,174,220,90,214,217,102,11,223,64,240,59,216,55,83,174,188,169,197,158,187,222,127,207,178,71,233,255,181,48,28,242,189,189,138,194,186,202,48,147,179,83,166,163,180,36,5,54,208,186,147,6,215,205,41,87,222,84,191,103,217,35,46,122,102,179,184,74,97,196,2,27,104,93,148,43,111,42,55,190,11,180,161,142,12,195,27,223,5,90,141,239,2,45,0,0,0,0,65,49,27,25,130,98,54,50,195,83,45,43,4,197,108,100,69,244,119,125,134,167,90,86,199,150,65,79,8,138,217,200,73,187,194,209,138,232,239,250,203,217,244,227,12,79,181,172,77,126,174,181,142,45,131,158,207,28,152,135,81,18,194,74,16,35,217,83,211,112,244,120,146,65,239,97,85,215,174,46,20,230,181,55,215,181,152,28,150,132,131,5,89,152,27,130,24,169,0,155,219,250,45,176,154,203,54,169,93,93,119,230,28,108,108,255,223,63,65,212,158,14,90,205,162,36,132,149,227,21,159,140,32,70,178,167,97,119,169,190,166,225,232,241,231,208,243,232,36,131,222,195,101,178,197,218,170,174,93,93,235,159,70,68,40,204,107,111,105,253,112,118,174,107,49,57,239,90,42,32,44,9,7,11,109,56,28,18,243,54,70,223,178,7,93,198,113,84,112,237,48,101,107,244,247,243,42,187,182,194,49,162,117,145,28,137,52,160,7,144,251,188,159,23,186,141,132,14,121,222,169,37,56,239,178,60,255,121,243,115,190,72,232,106,125,27,197,65,60,42,222,88,5,79,121,240,68,126,98,233,135,45,79,194,198,28,84,219,1,138,21,148,64,187,14,141,131,232,35,166,194,217,56,191,13,197,160,56,76,244,187,33,143,167,150,10,206,150,141,19,9,0,204,92,72,49,215,69,139,98,250,110,202,83,225,119,84,93,187,186,21,108,160,163,214,63,141,136,151,14,150,145,80,152,215,222,17,169,204,199,210,250,225,236,147,203,250,245,92,215,98,114,29,230,121,107,222,181,84,64,159,132,79,89,88,18,14,22,25,35,21,15,218,112,56,36,155,65,35,61,167,107,253,101,230,90,230,124,37,9,203,87,100,56,208,78,163,174,145,1,226,159,138,24,33,204,167,51,96,253,188,42,175,225,36,173,238,208,63,180,45,131,18,159,108,178,9,134,171,36,72,201,234,21,83,208,41,70,126,251,104,119,101,226,246,121,63,47,183,72,36,54,116,27,9,29,53,42,18,4,242,188,83,75,179,141,72,82,112,222,101,121,49,239,126,96,254,243,230,231,191,194,253,254,124,145,208,213,61,160,203,204,250,54,138,131,187,7,145,154,120,84,188,177,57,101,167,168,75,152,131,59,10,169,152,34,201,250,181,9,136,203,174,16,79,93,239,95,14,108,244,70,205,63,217,109,140,14,194,116,67,18,90,243,2,35,65,234,193,112,108,193,128,65,119,216,71,215,54,151,6,230,45,142,197,181,0,165,132,132,27,188,26,138,65,113,91,187,90,104,152,232,119,67,217,217,108,90,30,79,45,21,95,126,54,12,156,45,27,39,221,28,0,62,18,0,152,185,83,49,131,160,144,98,174,139,209,83,181,146,22,197,244,221,87,244,239,196,148,167,194,239,213,150,217,246,233,188,7,174,168,141,28,183,107,222,49,156,42,239,42,133,237,121,107,202,172,72,112,211,111,27,93,248,46,42,70,225,225,54,222,102,160,7,197,127,99,84,232,84,34,101,243,77,229,243,178,2,164,194,169,27,103,145,132,48,38,160,159,41,184,174,197,228,249,159,222,253,58,204,243,214,123,253,232,207,188,107,169,128,253,90,178,153,62,9,159,178,127,56,132,171,176,36,28,44,241,21,7,53,50,70,42,30,115,119,49,7,180,225,112,72,245,208,107,81,54,131,70,122,119,178,93,99,78,215,250,203,15,230,225,210,204,181,204,249,141,132,215,224,74,18,150,175,11,35,141,182,200,112,160,157,137,65,187,132,70,93,35,3,7,108,56,26,196,63,21,49,133,14,14,40,66,152,79,103,3,169,84,126,192,250,121,85,129,203,98,76,31,197,56,129,94,244,35,152,157,167,14,179,220,150,21,170,27,0,84,229,90,49,79,252,153,98,98,215,216,83,121,206,23,79,225,73,86,126,250,80,149,45,215,123,212,28,204,98,19,138,141,45,82,187,150,52,145,232,187,31,208,217,160,6,236,243,126,94,173,194,101,71,110,145,72,108,47,160,83,117,232,54,18,58,169,7,9,35,106,84,36,8,43,101,63,17,228,121,167,150,165,72,188,143,102,27,145,164,39,42,138,189,224,188,203,242,161,141,208,235,98,222,253,192,35,239,230,217,189,225,188,20,252,208,167,13,63,131,138,38,126,178,145,63,185,36,208,112,248,21,203,105,59,70,230,66,122,119,253,91,181,107,101,220,244,90,126,197,55,9,83,238,118,56,72,247,177,174,9,184,240,159,18,161,51,204,63,138,114,253,36,147,0,0,0,0,55,106,194,1,110,212,132,3,89,190,70,2,220,168,9,7,235,194,203,6,178,124,141,4,133,22,79,5,184,81,19,14,143,59,209,15,214,133,151,13,225,239,85,12,100,249,26,9,83,147,216,8,10,45,158,10,61,71,92,11,112,163,38,28,71,201,228,29,30,119,162,31,41,29,96,30,172,11,47,27,155,97,237,26,194,223,171,24,245,181,105,25,200,242,53,18,255,152,247,19,166,38,177,17,145,76,115,16,20,90,60,21,35,48,254,20,122,142,184,22,77,228,122,23,224,70,77,56,215,44,143,57,142,146,201,59,185,248,11,58,60,238,68,63,11,132,134,62,82,58,192,60,101,80,2,61,88,23,94,54,111,125,156,55,54,195,218,53,1,169,24,52,132,191,87,49,179,213,149,48,234,107,211,50,221,1,17,51,144,229,107,36,167,143,169,37,254,49,239,39,201,91,45,38,76,77,98,35,123,39,160,34,34,153,230,32,21,243,36,33,40,180,120,42,31,222,186,43,70,96,252,41,113,10,62,40,244,28,113,45,195,118,179,44,154,200,245,46,173,162,55,47,192,141,154,112,247,231,88,113,174,89,30,115,153,51,220,114,28,37,147,119,43,79,81,118,114,241,23,116,69,155,213,117,120,220,137,126,79,182,75,127,22,8,13,125,33,98,207,124,164,116,128,121,147,30,66,120,202,160,4,122,253,202,198,123,176,46,188,108,135,68,126,109,222,250,56,111,233,144,250,110,108,134,181,107,91,236,119,106,2,82,49,104,53,56,243,105,8,127,175,98,63,21,109,99,102,171,43,97,81,193,233,96,212,215,166,101,227,189,100,100,186,3,34,102,141,105,224,103,32,203,215,72,23,161,21,73,78,31,83,75,121,117,145,74,252,99,222,79,203,9,28,78,146,183,90,76,165,221,152,77,152,154,196,70,175,240,6,71,246,78,64,69,193,36,130,68,68,50,205,65,115,88,15,64,42,230,73,66,29,140,139,67,80,104,241,84,103,2,51,85,62,188,117,87,9,214,183,86,140,192,248,83,187,170,58,82,226,20,124,80,213,126,190,81,232,57,226,90,223,83,32,91,134,237,102,89,177,135,164,88,52,145,235,93,3,251,41,92,90,69,111,94,109,47,173,95,128,27,53,225,183,113,247,224,238,207,177,226,217,165,115,227,92,179,60,230,107,217,254,231,50,103,184,229,5,13,122,228,56,74,38,239,15,32,228,238,86,158,162,236,97,244,96,237,228,226,47,232,211,136,237,233,138,54,171,235,189,92,105,234,240,184,19,253,199,210,209,252,158,108,151,254,169,6,85,255,44,16,26,250,27,122,216,251,66,196,158,249,117,174,92,248,72,233,0,243,127,131,194,242,38,61,132,240,17,87,70,241,148,65,9,244,163,43,203,245,250,149,141,247,205,255,79,246,96,93,120,217,87,55,186,216,14,137,252,218,57,227,62,219,188,245,113,222,139,159,179,223,210,33,245,221,229,75,55,220,216,12,107,215,239,102,169,214,182,216,239,212,129,178,45,213,4,164,98,208,51,206,160,209,106,112,230,211,93,26,36,210,16,254,94,197,39,148,156,196,126,42,218,198,73,64,24,199,204,86,87,194,251,60,149,195,162,130,211,193,149,232,17,192,168,175,77,203,159,197,143,202,198,123,201,200,241,17,11,201,116,7,68,204,67,109,134,205,26,211,192,207,45,185,2,206,64,150,175,145,119,252,109,144,46,66,43,146,25,40,233,147,156,62,166,150,171,84,100,151,242,234,34,149,197,128,224,148,248,199,188,159,207,173,126,158,150,19,56,156,161,121,250,157,36,111,181,152,19,5,119,153,74,187,49,155,125,209,243,154,48,53,137,141,7,95,75,140,94,225,13,142,105,139,207,143,236,157,128,138,219,247,66,139,130,73,4,137,181,35,198,136,136,100,154,131,191,14,88,130,230,176,30,128,209,218,220,129,84,204,147,132,99,166,81,133,58,24,23,135,13,114,213,134,160,208,226,169,151,186,32,168,206,4,102,170,249,110,164,171,124,120,235,174,75,18,41,175,18,172,111,173,37,198,173,172,24,129,241,167,47,235,51,166,118,85,117,164,65,63,183,165,196,41,248,160,243,67,58,161,170,253,124,163,157,151,190,162,208,115,196,181,231,25,6,180,190,167,64,182,137,205,130,183,12,219,205,178,59,177,15,179,98,15,73,177,85,101,139,176,104,34,215,187,95,72,21,186,6,246,83,184,49,156,145,185,180,138,222,188,131,224,28,189,218,94,90,191,237,52,152,190,0,0,0,0,101,103,188,184,139,200,9,170,238,175,181,18,87,151,98,143,50,240,222,55,220,95,107,37,185,56,215,157,239,40,180,197,138,79,8,125,100,224,189,111,1,135,1,215,184,191,214,74,221,216,106,242,51,119,223,224,86,16,99,88,159,87,25,80,250,48,165,232,20,159,16,250,113,248,172,66,200,192,123,223,173,167,199,103,67,8,114,117,38,111,206,205,112,127,173,149,21,24,17,45,251,183,164,63,158,208,24,135,39,232,207,26,66,143,115,162,172,32,198,176,201,71,122,8,62,175,50,160,91,200,142,24,181,103,59,10,208,0,135,178,105,56,80,47,12,95,236,151,226,240,89,133,135,151,229,61,209,135,134,101,180,224,58,221,90,79,143,207,63,40,51,119,134,16,228,234,227,119,88,82,13,216,237,64,104,191,81,248,161,248,43,240,196,159,151,72,42,48,34,90,79,87,158,226,246,111,73,127,147,8,245,199,125,167,64,213,24,192,252,109,78,208,159,53,43,183,35,141,197,24,150,159,160,127,42,39,25,71,253,186,124,32,65,2,146,143,244,16,247,232,72,168,61,88,20,155,88,63,168,35,182,144,29,49,211,247,161,137,106,207,118,20,15,168,202,172,225,7,127,190,132,96,195,6,210,112,160,94,183,23,28,230,89,184,169,244,60,223,21,76,133,231,194,209,224,128,126,105,14,47,203,123,107,72,119,195,162,15,13,203,199,104,177,115,41,199,4,97,76,160,184,217,245,152,111,68,144,255,211,252,126,80,102,238,27,55,218,86,77,39,185,14,40,64,5,182,198,239,176,164,163,136,12,28,26,176,219,129,127,215,103,57,145,120,210,43,244,31,110,147,3,247,38,59,102,144,154,131,136,63,47,145,237,88,147,41,84,96,68,180,49,7,248,12,223,168,77,30,186,207,241,166,236,223,146,254,137,184,46,70,103,23,155,84,2,112,39,236,187,72,240,113,222,47,76,201,48,128,249,219,85,231,69,99,156,160,63,107,249,199,131,211,23,104,54,193,114,15,138,121,203,55,93,228,174,80,225,92,64,255,84,78,37,152,232,246,115,136,139,174,22,239,55,22,248,64,130,4,157,39,62,188,36,31,233,33,65,120,85,153,175,215,224,139,202,176,92,51,59,182,89,237,94,209,229,85,176,126,80,71,213,25,236,255,108,33,59,98,9,70,135,218,231,233,50,200,130,142,142,112,212,158,237,40,177,249,81,144,95,86,228,130,58,49,88,58,131,9,143,167,230,110,51,31,8,193,134,13,109,166,58,181,164,225,64,189,193,134,252,5,47,41,73,23,74,78,245,175,243,118,34,50,150,17,158,138,120,190,43,152,29,217,151,32,75,201,244,120,46,174,72,192,192,1,253,210,165,102,65,106,28,94,150,247,121,57,42,79,151,150,159,93,242,241,35,229,5,25,107,77,96,126,215,245,142,209,98,231,235,182,222,95,82,142,9,194,55,233,181,122,217,70,0,104,188,33,188,208,234,49,223,136,143,86,99,48,97,249,214,34,4,158,106,154,189,166,189,7,216,193,1,191,54,110,180,173,83,9,8,21,154,78,114,29,255,41,206,165,17,134,123,183,116,225,199,15,205,217,16,146,168,190,172,42,70,17,25,56,35,118,165,128,117,102,198,216,16,1,122,96,254,174,207,114,155,201,115,202,34,241,164,87,71,150,24,239,169,57,173,253,204,94,17,69,6,238,77,118,99,137,241,206,141,38,68,220,232,65,248,100,81,121,47,249,52,30,147,65,218,177,38,83,191,214,154,235,233,198,249,179,140,161,69,11,98,14,240,25,7,105,76,161,190,81,155,60,219,54,39,132,53,153,146,150,80,254,46,46,153,185,84,38,252,222,232,158,18,113,93,140,119,22,225,52,206,46,54,169,171,73,138,17,69,230,63,3,32,129,131,187,118,145,224,227,19,246,92,91,253,89,233,73,152,62,85,241,33,6,130,108,68,97,62,212,170,206,139,198,207,169,55,126,56,65,127,214,93,38,195,110,179,137,118,124,214,238,202,196,111,214,29,89,10,177,161,225,228,30,20,243,129,121,168,75,215,105,203,19,178,14,119,171,92,161,194,185,57,198,126,1,128,254,169,156,229,153,21,36,11,54,160,54,110,81,28,142,167,22,102,134,194,113,218,62,44,222,111,44,73,185,211,148,240,129,4,9,149,230,184,177,123,73,13,163,30,46,177,27,72,62,210,67,45,89,110,251,195,246,219,233,166,145,103,81,31,169,176,204,122,206,12,116,148,97,185,102,241,6,5,222,0,0,0,0,119,7,48,150,238,14,97,44,153,9,81,186,7,109,196,25,112,106,244,143,233,99,165,53,158,100,149,163,14,219,136,50,121,220,184,164,224,213,233,30,151,210,217,136,9,182,76,43,126,177,124,189,231,184,45,7,144,191,29,145,29,183,16,100,106,176,32,242,243,185,113,72,132,190,65,222,26,218,212,125,109,221,228,235,244,212,181,81,131,211,133,199,19,108,152,86,100,107,168,192,253,98,249,122,138,101,201,236,20,1,92,79,99,6,108,217,250,15,61,99,141,8,13,245,59,110,32,200,76,105,16,94,213,96,65,228,162,103,113,114,60,3,228,209,75,4,212,71,210,13,133,253,165,10,181,107,53,181,168,250,66,178,152,108,219,187,201,214,172,188,249,64,50,216,108,227,69,223,92,117,220,214,13,207,171,209,61,89,38,217,48,172,81,222,0,58,200,215,81,128,191,208,97,22,33,180,244,181,86,179,196,35,207,186,149,153,184,189,165,15,40,2,184,158,95,5,136,8,198,12,217,178,177,11,233,36,47,111,124,135,88,104,76,17,193,97,29,171,182,102,45,61,118,220,65,144,1,219,113,6,152,210,32,188,239,213,16,42,113,177,133,137,6,182,181,31,159,191,228,165,232,184,212,51,120,7,201,162,15,0,249,52,150,9,168,142,225,14,152,24,127,106,13,187,8,109,61,45,145,100,108,151,230,99,92,1,107,107,81,244,28,108,97,98,133,101,48,216,242,98,0,78,108,6,149,237,27,1,165,123,130,8,244,193,245,15,196,87,101,176,217,198,18,183,233,80,139,190,184,234,252,185,136,124,98,221,29,223,21,218,45,73,140,211,124,243,251,212,76,101,77,178,97,88,58,181,81,206,163,188,0,116,212,187,48,226,74,223,165,65,61,216,149,215,164,209,196,109,211,214,244,251,67,105,233,106,52,110,217,252,173,103,136,70,218,96,184,208,68,4,45,115,51,3,29,229,170,10,76,95,221,13,124,201,80,5,113,60,39,2,65,170,190,11,16,16,201,12,32,134,87,104,181,37,32,111,133,179,185,102,212,9,206,97,228,159,94,222,249,14,41,217,201,152,176,208,152,34,199,215,168,180,89,179,61,23,46,180,13,129,183,189,92,59,192,186,108,173,237,184,131,32,154,191,179,182,3,182,226,12,116,177,210,154,234,213,71,57,157,210,119,175,4,219,38,21,115,220,22,131,227,99,11,18,148,100,59,132,13,109,106,62,122,106,90,168,228,14,207,11,147,9,255,157,10,0,174,39,125,7,158,177,240,15,147,68,135,8,163,210,30,1,242,104,105,6,194,254,247,98,87,93,128,101,103,203,25,108,54,113,110,107,6,231,254,212,27,118,137,211,43,224,16,218,122,90,103,221,74,204,249,185,223,111,142,190,239,249,23,183,190,67,96,176,142,213,214,214,163,232,161,209,147,126,56,216,194,196,79,223,242,82,209,187,103,241,166,188,87,103,63,181,6,221,72,178,54,75,216,13,43,218,175,10,27,76,54,3,74,246,65,4,122,96,223,96,239,195,168,103,223,85,49,110,142,239,70,105,190,121,203,97,179,140,188,102,131,26,37,111,210,160,82,104,226,54,204,12,119,149,187,11,71,3,34,2,22,185,85,5,38,47,197,186,59,190,178,189,11,40,43,180,90,146,92,179,106,4,194,215,255,167,181,208,207,49,44,217,158,139,91,222,174,29,155,100,194,176,236,99,242,38,117,106,163,156,2,109,147,10,156,9,6,169,235,14,54,63,114,7,103,133,5,0,87,19,149,191,74,130,226,184,122,20,123,177,43,174,12,182,27,56,146,210,142,155,229,213,190,13,124,220,239,183,11,219,223,33,134,211,210,212,241,212,226,66,104,221,179,248,31,218,131,110,129,190,22,205,246,185,38,91,111,176,119,225,24,183,71,119,136,8,90,230,255,15,106,112,102,6,59,202,17,1,11,92,143,101,158,255,248,98,174,105,97,107,255,211,22,108,207,69,160,10,226,120,215,13,210,238,78,4,131,84,57,3,179,194,167,103,38,97,208,96,22,247,73,105,71,77,62,110,119,219,174,209,106,74,217,214,90,220,64,223,11,102,55,216,59,240,169,188,174,83,222,187,158,197,71,178,207,127,48,181,255,233,189,189,242,28,202,186,194,138,83,179,147,48,36,180,163,166,186,208,54,5,205,215,6,147,84,222,87,41,35,217,103,191,179,102,122,46,196,97,74,184,93,104,27,2,42,111,43,148,180,11,190,55,195,12,142,161,90,5,223,27,45,2,239,141,0,0,0,0,25,27,49,65,50,54,98,130,43,45,83,195,100,108,197,4,125,119,244,69,86,90,167,134,79,65,150,199,200,217,138,8,209,194,187,73,250,239,232,138,227,244,217,203,172,181,79,12,181,174,126,77,158,131,45,142,135,152,28,207,74,194,18,81,83,217,35,16,120,244,112,211,97,239,65,146,46,174,215,85,55,181,230,20,28,152,181,215,5,131,132,150,130,27,152,89,155,0,169,24,176,45,250,219,169,54,203,154,230,119,93,93,255,108,108,28,212,65,63,223,205,90,14,158,149,132,36,162,140,159,21,227,167,178,70,32,190,169,119,97,241,232,225,166,232,243,208,231,195,222,131,36,218,197,178,101,93,93,174,170,68,70,159,235,111,107,204,40,118,112,253,105,57,49,107,174,32,42,90,239,11,7,9,44,18,28,56,109,223,70,54,243,198,93,7,178,237,112,84,113,244,107,101,48,187,42,243,247,162,49,194,182,137,28,145,117,144,7,160,52,23,159,188,251,14,132,141,186,37,169,222,121,60,178,239,56,115,243,121,255,106,232,72,190,65,197,27,125,88,222,42,60,240,121,79,5,233,98,126,68,194,79,45,135,219,84,28,198,148,21,138,1,141,14,187,64,166,35,232,131,191,56,217,194,56,160,197,13,33,187,244,76,10,150,167,143,19,141,150,206,92,204,0,9,69,215,49,72,110,250,98,139,119,225,83,202,186,187,93,84,163,160,108,21,136,141,63,214,145,150,14,151,222,215,152,80,199,204,169,17,236,225,250,210,245,250,203,147,114,98,215,92,107,121,230,29,64,84,181,222,89,79,132,159,22,14,18,88,15,21,35,25,36,56,112,218,61,35,65,155,101,253,107,167,124,230,90,230,87,203,9,37,78,208,56,100,1,145,174,163,24,138,159,226,51,167,204,33,42,188,253,96,173,36,225,175,180,63,208,238,159,18,131,45,134,9,178,108,201,72,36,171,208,83,21,234,251,126,70,41,226,101,119,104,47,63,121,246,54,36,72,183,29,9,27,116,4,18,42,53,75,83,188,242,82,72,141,179,121,101,222,112,96,126,239,49,231,230,243,254,254,253,194,191,213,208,145,124,204,203,160,61,131,138,54,250,154,145,7,187,177,188,84,120,168,167,101,57,59,131,152,75,34,152,169,10,9,181,250,201,16,174,203,136,95,239,93,79,70,244,108,14,109,217,63,205,116,194,14,140,243,90,18,67,234,65,35,2,193,108,112,193,216,119,65,128,151,54,215,71,142,45,230,6,165,0,181,197,188,27,132,132,113,65,138,26,104,90,187,91,67,119,232,152,90,108,217,217,21,45,79,30,12,54,126,95,39,27,45,156,62,0,28,221,185,152,0,18,160,131,49,83,139,174,98,144,146,181,83,209,221,244,197,22,196,239,244,87,239,194,167,148,246,217,150,213,174,7,188,233,183,28,141,168,156,49,222,107,133,42,239,42,202,107,121,237,211,112,72,172,248,93,27,111,225,70,42,46,102,222,54,225,127,197,7,160,84,232,84,99,77,243,101,34,2,178,243,229,27,169,194,164,48,132,145,103,41,159,160,38,228,197,174,184,253,222,159,249,214,243,204,58,207,232,253,123,128,169,107,188,153,178,90,253,178,159,9,62,171,132,56,127,44,28,36,176,53,7,21,241,30,42,70,50,7,49,119,115,72,112,225,180,81,107,208,245,122,70,131,54,99,93,178,119,203,250,215,78,210,225,230,15,249,204,181,204,224,215,132,141,175,150,18,74,182,141,35,11,157,160,112,200,132,187,65,137,3,35,93,70,26,56,108,7,49,21,63,196,40,14,14,133,103,79,152,66,126,84,169,3,85,121,250,192,76,98,203,129,129,56,197,31,152,35,244,94,179,14,167,157,170,21,150,220,229,84,0,27,252,79,49,90,215,98,98,153,206,121,83,216,73,225,79,23,80,250,126,86,123,215,45,149,98,204,28,212,45,141,138,19,52,150,187,82,31,187,232,145,6,160,217,208,94,126,243,236,71,101,194,173,108,72,145,110,117,83,160,47,58,18,54,232,35,9,7,169,8,36,84,106,17,63,101,43], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+92160);
/* memory initializer */ allocate([150,167,121,228,143,188,72,165,164,145,27,102,189,138,42,39,242,203,188,224,235,208,141,161,192,253,222,98,217,230,239,35,20,188,225,189,13,167,208,252,38,138,131,63,63,145,178,126,112,208,36,185,105,203,21,248,66,230,70,59,91,253,119,122,220,101,107,181,197,126,90,244,238,83,9,55,247,72,56,118,184,9,174,177,161,18,159,240,138,63,204,51,147,36,253,114,0,0,0,0,1,194,106,55,3,132,212,110,2,70,190,89,7,9,168,220,6,203,194,235,4,141,124,178,5,79,22,133,14,19,81,184,15,209,59,143,13,151,133,214,12,85,239,225,9,26,249,100,8,216,147,83,10,158,45,10,11,92,71,61,28,38,163,112,29,228,201,71,31,162,119,30,30,96,29,41,27,47,11,172,26,237,97,155,24,171,223,194,25,105,181,245,18,53,242,200,19,247,152,255,17,177,38,166,16,115,76,145,21,60,90,20,20,254,48,35,22,184,142,122,23,122,228,77,56,77,70,224,57,143,44,215,59,201,146,142,58,11,248,185,63,68,238,60,62,134,132,11,60,192,58,82,61,2,80,101,54,94,23,88,55,156,125,111,53,218,195,54,52,24,169,1,49,87,191,132,48,149,213,179,50,211,107,234,51,17,1,221,36,107,229,144,37,169,143,167,39,239,49,254,38,45,91,201,35,98,77,76,34,160,39,123,32,230,153,34,33,36,243,21,42,120,180,40,43,186,222,31,41,252,96,70,40,62,10,113,45,113,28,244,44,179,118,195,46,245,200,154,47,55,162,173,112,154,141,192,113,88,231,247,115,30,89,174,114,220,51,153,119,147,37,28,118,81,79,43,116,23,241,114,117,213,155,69,126,137,220,120,127,75,182,79,125,13,8,22,124,207,98,33,121,128,116,164,120,66,30,147,122,4,160,202,123,198,202,253,108,188,46,176,109,126,68,135,111,56,250,222,110,250,144,233,107,181,134,108,106,119,236,91,104,49,82,2,105,243,56,53,98,175,127,8,99,109,21,63,97,43,171,102,96,233,193,81,101,166,215,212,100,100,189,227,102,34,3,186,103,224,105,141,72,215,203,32,73,21,161,23,75,83,31,78,74,145,117,121,79,222,99,252,78,28,9,203,76,90,183,146,77,152,221,165,70,196,154,152,71,6,240,175,69,64,78,246,68,130,36,193,65,205,50,68,64,15,88,115,66,73,230,42,67,139,140,29,84,241,104,80,85,51,2,103,87,117,188,62,86,183,214,9,83,248,192,140,82,58,170,187,80,124,20,226,81,190,126,213,90,226,57,232,91,32,83,223,89,102,237,134,88,164,135,177,93,235,145,52,92,41,251,3,94,111,69,90,95,173,47,109,225,53,27,128,224,247,113,183,226,177,207,238,227,115,165,217,230,60,179,92,231,254,217,107,229,184,103,50,228,122,13,5,239,38,74,56,238,228,32,15,236,162,158,86,237,96,244,97,232,47,226,228,233,237,136,211,235,171,54,138,234,105,92,189,253,19,184,240,252,209,210,199,254,151,108,158,255,85,6,169,250,26,16,44,251,216,122,27,249,158,196,66,248,92,174,117,243,0,233,72,242,194,131,127,240,132,61,38,241,70,87,17,244,9,65,148,245,203,43,163,247,141,149,250,246,79,255,205,217,120,93,96,216,186,55,87,218,252,137,14,219,62,227,57,222,113,245,188,223,179,159,139,221,245,33,210,220,55,75,229,215,107,12,216,214,169,102,239,212,239,216,182,213,45,178,129,208,98,164,4,209,160,206,51,211,230,112,106,210,36,26,93,197,94,254,16,196,156,148,39,198,218,42,126,199,24,64,73,194,87,86,204,195,149,60,251,193,211,130,162,192,17,232,149,203,77,175,168,202,143,197,159,200,201,123,198,201,11,17,241,204,68,7,116,205,134,109,67,207,192,211,26,206,2,185,45,145,175,150,64,144,109,252,119,146,43,66,46,147,233,40,25,150,166,62,156,151,100,84,171,149,34,234,242,148,224,128,197,159,188,199,248,158,126,173,207,156,56,19,150,157,250,121,161,152,181,111,36,153,119,5,19,155,49,187,74,154,243,209,125,141,137,53,48,140,75,95,7,142,13,225,94,143,207,139,105,138,128,157,236,139,66,247,219,137,4,73,130,136,198,35,181,131,154,100,136,130,88,14,191,128,30,176,230,129,220,218,209,132,147,204,84,133,81,166,99,135,23,24,58,134,213,114,13,169,226,208,160,168,32,186,151,170,102,4,206,171,164,110,249,174,235,120,124,175,41,18,75,173,111,172,18,172,173,198,37,167,241,129,24,166,51,235,47,164,117,85,118,165,183,63,65,160,248,41,196,161,58,67,243,163,124,253,170,162,190,151,157,181,196,115,208,180,6,25,231,182,64,167,190,183,130,205,137,178,205,219,12,179,15,177,59,177,73,15,98,176,139,101,85,187,215,34,104,186,21,72,95,184,83,246,6,185,145,156,49,188,222,138,180,189,28,224,131,191,90,94,218,190,152,52,237,0,0,0,0,184,188,103,101,170,9,200,139,18,181,175,238,143,98,151,87,55,222,240,50,37,107,95,220,157,215,56,185,197,180,40,239,125,8,79,138,111,189,224,100,215,1,135,1,74,214,191,184,242,106,216,221,224,223,119,51,88,99,16,86,80,25,87,159,232,165,48,250,250,16,159,20,66,172,248,113,223,123,192,200,103,199,167,173,117,114,8,67,205,206,111,38,149,173,127,112,45,17,24,21,63,164,183,251,135,24,208,158,26,207,232,39,162,115,143,66,176,198,32,172,8,122,71,201,160,50,175,62,24,142,200,91,10,59,103,181,178,135,0,208,47,80,56,105,151,236,95,12,133,89,240,226,61,229,151,135,101,134,135,209,221,58,224,180,207,143,79,90,119,51,40,63,234,228,16,134,82,88,119,227,64,237,216,13,248,81,191,104,240,43,248,161,72,151,159,196,90,34,48,42,226,158,87,79,127,73,111,246,199,245,8,147,213,64,167,125,109,252,192,24,53,159,208,78,141,35,183,43,159,150,24,197,39,42,127,160,186,253,71,25,2,65,32,124,16,244,143,146,168,72,232,247,155,20,88,61,35,168,63,88,49,29,144,182,137,161,247,211,20,118,207,106,172,202,168,15,190,127,7,225,6,195,96,132,94,160,112,210,230,28,23,183,244,169,184,89,76,21,223,60,209,194,231,133,105,126,128,224,123,203,47,14,195,119,72,107,203,13,15,162,115,177,104,199,97,4,199,41,217,184,160,76,68,111,152,245,252,211,255,144,238,102,80,126,86,218,55,27,14,185,39,77,182,5,64,40,164,176,239,198,28,12,136,163,129,219,176,26,57,103,215,127,43,210,120,145,147,110,31,244,59,38,247,3,131,154,144,102,145,47,63,136,41,147,88,237,180,68,96,84,12,248,7,49,30,77,168,223,166,241,207,186,254,146,223,236,70,46,184,137,84,155,23,103,236,39,112,2,113,240,72,187,201,76,47,222,219,249,128,48,99,69,231,85,107,63,160,156,211,131,199,249,193,54,104,23,121,138,15,114,228,93,55,203,92,225,80,174,78,84,255,64,246,232,152,37,174,139,136,115,22,55,239,22,4,130,64,248,188,62,39,157,33,233,31,36,153,85,120,65,139,224,215,175,51,92,176,202,237,89,182,59,85,229,209,94,71,80,126,176,255,236,25,213,98,59,33,108,218,135,70,9,200,50,233,231,112,142,142,130,40,237,158,212,144,81,249,177,130,228,86,95,58,88,49,58,167,143,9,131,31,51,110,230,13,134,193,8,181,58,166,109,189,64,225,164,5,252,134,193,23,73,41,47,175,245,78,74,50,34,118,243,138,158,17,150,152,43,190,120,32,151,217,29,120,244,201,75,192,72,174,46,210,253,1,192,106,65,102,165,247,150,94,28,79,42,57,121,93,159,150,151,229,35,241,242,77,107,25,5,245,215,126,96,231,98,209,142,95,222,182,235,194,9,142,82,122,181,233,55,104,0,70,217,208,188,33,188,136,223,49,234,48,99,86,143,34,214,249,97,154,106,158,4,7,189,166,189,191,1,193,216,173,180,110,54,21,8,9,83,29,114,78,154,165,206,41,255,183,123,134,17,15,199,225,116,146,16,217,205,42,172,190,168,56,25,17,70,128,165,118,35,216,198,102,117,96,122,1,16,114,207,174,254,202,115,201,155,87,164,241,34,239,24,150,71,253,173,57,169,69,17,94,204,118,77,238,6,206,241,137,99,220,68,38,141,100,248,65,232,249,47,121,81,65,147,30,52,83,38,177,218,235,154,214,191,179,249,198,233,11,69,161,140,25,240,14,98,161,76,105,7,60,155,81,190,132,39,54,219,150,146,153,53,46,46,254,80,38,84,185,153,158,232,222,252,140,93,113,18,52,225,22,119,169,54,46,206,17,138,73,171,3,63,230,69,187,131,129,32,227,224,145,118,91,92,246,19,73,233,89,253,241,85,62,152,108,130,6,33,212,62,97,68,198,139,206,170,126,55,169,207,214,127,65,56,110,195,38,93,124,118,137,179,196,202,238,214,89,29,214,111,225,161,177,10,243,20,30,228,75,168,121,129,19,203,105,215,171,119,14,178,185,194,161,92,1,126,198,57,156,169,254,128,36,21,153,229,54,160,54,11,142,28,81,110,134,102,22,167,62,218,113,194,44,111,222,44,148,211,185,73,9,4,129,240,177,184,230,149,163,13,73,123,27,177,46,30,67,210,62,72,251,110,89,45,233,219,246,195,81,103,145,166,204,176,169,31,116,12,206,122,102,185,97,148,222,5,6,241,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,116,111,111,32,102,97,114,32,98,97,99,107,0,0,0,105,110,118,97,108,105,100,32,100,105,115,116,97,110,99,101,32,99,111,100,101,0,0,0,105,110,118,97,108,105,100,32,108,105,116,101,114,97,108,47,108,101,110,103,116,104,32,99,111,100,101,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,155,1,0,248,155,1,0,8,156,1,0,32,156,1,0,64,156,1,0,80,156,1,0,104,156,1,0,120,156,1,0,144,156,1,0,176,156,1,0,216,156,1,0,240,156,1,0,16,157,1,0,40,157,1,0,80,157,1,0,112,157,1,0,160,157,1,0,208,157,1,0,232,157,1,0,32,158,1,0,56,158,1,0,104,158,1,0,136,158,1,0,192,158,1,0,232,158,1,0,32,159,1,0,80,159,1,0,96,159,1,0,128,159,1,0,168,159,1,0,200,159,1,0,240,159,1,0,24,160,1,0,48,160,1,0,72,160,1,0,88,160,1,0,112,160,1,0,160,160,1,0,240,160,1,0,48,161,1,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,96,175,1,0,240,173,1,0,120,172,1,0,0,171,1,0,0,171,1,0,136,169,1,0,120,172,1,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,40,186,1,0,176,182,1,0,64,181,1,0,208,179,1,0,208,179,1,0,96,178,1,0,64,181,1,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102400);
/* memory initializer */ allocate([118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,112,184,1,0,128,184,1,0,144,184,1,0,96,169,1,0,152,184,1,0,168,184,1,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,8,188,1,0,16,188,1,0,24,188,1,0,32,188,1,0,152,187,1,0,40,188,1,0,56,188,1,0,64,188,1,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,101,108,116,115,91,105,93,45,62,110,100,105,109,115,32,61,61,32,110,100,105,109,115,32,38,38,32,34,78,111,116,32,115,97,109,101,32,110,117,109,98,101,114,32,111,102,32,100,105,109,101,110,115,105,111,110,115,34,0,0,0,0,0,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,104,101,99,107,95,98,97,115,101,95,97,114,114,97,121,95,100,105,109,95,115,105,122,101,115,0,0,0,0,0,0,100,105,109,115,105,122,101,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,99,117,114,100,105,109,93,32,38,38,32,34,68,105,109,101,110,115,105,111,110,115,32,115,105,122,101,32,110,111,116,32,115,97,109,101,34,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,112,190,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,105,122,101,95,111,102,95,100,105,109,101,110,115,105,111,110,95,98,97,115,101,95,97,114,114,97,121,0,0,0,0,40,105,32,62,32,48,41,32,38,38,32,40,105,32,60,61,32,97,45,62,110,100,105,109,115,41,0,0,0,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,40,191,1,0,56,191,1,0,64,191,1,0,72,191,1,0,88,191,1,0,104,191,1,0,112,191,1,0,128,191,1,0,144,191,1,0,160,191,1,0,176,191,1,0,192,191,1,0,208,191,1,0,224,191,1,0,240,191,1,0,248,191,1,0,0,192,1,0,16,192,1,0,24,192,1,0,40,192,1,0,56,192,1,0,72,192,1,0,88,192,1,0,104,192,1,0,120,192,1,0,136,192,1,0,152,192,1,0,168,192,1,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,48,193,1,0,56,193,1,0,56,193,1,0,88,193,1,0,136,193,1,0,168,193,1,0,224,193,1,0,16,194,1,0,64,194,1,0,96,194,1,0,144,194,1,0,168,194,1,0,200,194,1,0,240,194,1,0,16,195,1,0,64,195,1,0,96,195,1,0,136,195,1,0,168,195,1,0,208,195,1,0,0,196,1,0,56,196,1,0,96,196,1,0,144,196,1,0,192,196,1,0,232,196,1,0,24,197,1,0,32,197,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,48,193,1,0,32,200,1,0,40,200,1,0,48,200,1,0,64,191,1,0,56,200,1,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,45,37,100,100,0,0,0,0,37,100,100,0,0,0,0,0,45,37,100,46,37,100,103,0,37,100,46,37,100,103,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,176,201,1,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,200,201,1,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,224,201,1,0,232,201,1,0,240,201,1,0,0,202,1,0,16,202,1,0,24,202,1,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,97,114,114,97,121,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,48,32,38,38,32,34,68,105,109,101,110,115,105,111,110,32,115,105,122,101,32,62,32,52,32,110,111,116,32,105,109,112,108,46,32,121,101,116,34,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,97,41,0,0,0,0,0,0,0,0,115,117,109,95,114,101,97,108,95,97,114,114,97,121,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,112,214,1,0,0,0,0,0,232,213,1,0,0,0,0,0,96,213,1,0,0,0,0,0,216,212,1,0,0,0,0,0,208,211,1,0,0,0,0,0,200,210,1,0,0,0,0,0,192,209,1,0,0,0,0,0,184,208,1,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112664);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,88,216,1,0,104,216,1,0,112,216,1,0,120,216,1,0,136,216,1,0,144,216,1,0,152,216,1,0,160,216,1,0,168,216,1,0,176,216,1,0,184,216,1,0,200,216,1,0,208,216,1,0,224,216,1,0,240,216,1,0,0,217,1,0,8,217,1,0,24,217,1,0,32,217,1,0,48,217,1,0,56,217,1,0,80,217,1,0,88,217,1,0,96,217,1,0,112,217,1,0,120,217,1,0,136,217,1,0,152,217,1,0,160,217,1,0,168,217,1,0,176,217,1,0,184,217,1,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,72,218,1,0,80,218,1,0,152,218,1,0,200,218,1,0,248,218,1,0,64,219,1,0,128,219,1,0,200,219,1,0,248,219,1,0,64,220,1,0,88,220,1,0,120,220,1,0,176,220,1,0,216,220,1,0,0,221,1,0,56,221,1,0,136,221,1,0,232,221,1,0,24,222,1,0,80,222,1,0,128,222,1,0,200,222,1,0,240,222,1,0,32,223,1,0,80,223,1,0,168,223,1,0,240,223,1,0,96,224,1,0,144,224,1,0,216,224,1,0,248,224,1,0,184,217,1,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,72,218,1,0,184,225,1,0,96,226,1,0,200,218,1,0,248,218,1,0,200,226,1,0,128,219,1,0,200,219,1,0,80,227,1,0,144,227,1,0,88,220,1,0,120,220,1,0,48,228,1,0,112,228,1,0,176,228,1,0,56,221,1,0,136,221,1,0,240,228,1,0,40,229,1,0,176,229,1,0,216,229,1,0,200,222,1,0,240,222,1,0,32,223,1,0,64,230,1,0,200,230,1,0,200,231,1,0,96,224,1,0,144,224,1,0,216,224,1,0,248,224,1,0,184,217,1,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,237,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,237,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,237,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,237,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,237,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+120560);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,96,255,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+130904);
/* memory initializer */ allocate([224,3,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,5,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,4,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,6,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,6,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,6,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,6,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,184,7,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,8,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,9,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,9,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,9,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,9,2,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,176,44,2,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,45,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,45,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,56,46,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,144,46,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,152,46,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,46,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,48,47,2,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,224,46,2,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,104,59,2,0,136,60,2,0,144,60,2,0,160,60,2,0,176,60,2,0,192,60,2,0,216,60,2,0,240,60,2,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,104,59,2,0,112,59,2,0,184,59,2,0,224,59,2,0,0,60,2,0,32,60,2,0,72,60,2,0,112,60,2,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,208,67,2,0,224,67,2,0,232,67,2,0,240,67,2,0,248,67,2,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,24,68,2,0,32,68,2,0,48,68,2,0,64,68,2,0,248,67,2,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111,114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+141588);
/* memory initializer */ allocate([35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,95,2,0,200,96,2,0,208,96,2,0,216,96,2,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,95,2,0,8,96,2,0,88,96,2,0,136,96,2,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,0,95,2,0,200,95,2,0,208,95,2,0,216,95,2,0,232,95,2,0,240,95,2,0,0,96,2,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,0,95,2,0,8,95,2,0,32,95,2,0,48,95,2,0,120,95,2,0,136,95,2,0,168,95,2,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,176,106,2,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,176,106,2,0,10,0,0,0,11,0,0,0,84,106,2,0,204,106,2,0,224,106,2,0,104,106,2,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,192,36,3,0,128,106,2,0,72,224,2,0,0,0,0,0,104,0,0,0,0,0,0,0,72,224,2,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,72,224,2,0,14,0,0,0,15,0,0,0,0,0,0,0,88,107,2,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,192,36,3,0,40,107,2,0,64,223,2,0,0,0,0,0,0,0,0,0,224,107,2,0,232,107,2,0,216,107,2,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,184,107,2,0,200,107,2,0,216,107,2,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108,32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+151832);
/* memory initializer */ allocate([32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,56,124,2,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,56,124,2,0,20,0,0,0,21,0,0,0,220,123,2,0,84,124,2,0,104,124,2,0,240,123,2,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,192,36,3,0,8,124,2,0,184,223,2,0,0,0,0,0,108,0,0,0,0,0,0,0,184,223,2,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,184,223,2,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,112,134,2,0,88,136,2,0,96,136,2,0,168,138,2,0,192,136,2,0,208,136,2,0,176,138,2,0,184,138,2,0,192,138,2,0,200,138,2,0,216,138,2,0,232,138,2,0,248,138,2,0,8,139,2,0,24,139,2,0,40,139,2,0,56,139,2,0,80,139,2,0,136,138,2,0,160,138,2,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,112,134,2,0,88,136,2,0,96,136,2,0,112,136,2,0,192,136,2,0,208,136,2,0,224,136,2,0,0,137,2,0,32,137,2,0,64,137,2,0,104,137,2,0,144,137,2,0,184,137,2,0,224,137,2,0,248,137,2,0,24,138,2,0,56,138,2,0,96,138,2,0,136,138,2,0,160,138,2,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,112,134,2,0,56,136,2,0,64,136,2,0,72,136,2,0,112,134,2,0,120,135,2,0,200,135,2,0,248,135,2,0,112,134,2,0,56,135,2,0,64,135,2,0,72,135,2,0,88,135,2,0,96,135,2,0,112,135,2,0,0,0,0,0,112,134,2,0,120,134,2,0,144,134,2,0,160,134,2,0,232,134,2,0,248,134,2,0,24,135,2,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,26,0,0,0,0,0,0,0,65,115,115,101,114,116,105,111,110,32,116,114,105,103,103,101,114,101,100,32,98,121,32,101,120,116,101,114,110,97,108,32,67,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,144,141,2,0,27,0,0,0,28,0,0,0,200,255,255,255,200,255,255,255,144,141,2,0,29,0,0,0,30,0,0,0,28,141,2,0,172,141,2,0,192,141,2,0,48,141,2,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,192,36,3,0,72,141,2,0,72,224,2,0,0,0,0,0,56,0,0,0,0,0,0,0,72,224,2,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,72,224,2,0,14,0,0,0,15,0,0,0,0,0,0,0,80,142,2,0,31,0,0,0,32,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,192,36,3,0,8,142,2,0,64,223,2,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+162072);
/* memory initializer */ allocate([114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,224,162,2,0,224,162,2,0,224,162,2,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,136,165,2,0,152,165,2,0,176,165,2,0,208,165,2,0,240,165,2,0,8,166,2,0,40,166,2,0,64,166,2,0,80,166,2,0,96,166,2,0,120,166,2,0,144,166,2,0,176,166,2,0,208,166,2,0,96,166,2,0,232,166,2,0,8,167,2,0,32,167,2,0,56,167,2,0,80,167,2,0,112,167,2,0,128,167,2,0,160,167,2,0,192,167,2,0,216,167,2,0,240,167,2,0,8,168,2,0,24,168,2,0,48,168,2,0,72,168,2,0,96,168,2,0,128,168,2,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+172312);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+179248);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,136,209,2,0,144,209,2,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,160,209,2,0,168,209,2,0,176,209,2,0,184,209,2,0,144,1,0,0,0,0,0,0,40,210,2,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+184472);
/* memory initializer */ allocate([217,2,0,33,0,0,0,34,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,192,36,3,0,224,216,2,0,128,223,2,0,0,0,0,0,0,0,0,0,104,217,2,0,35,0,0,0,36,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,192,36,3,0,80,217,2,0,128,223,2,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,0,218,2,0,37,0,0,0,38,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,192,36,3,0,224,217,2,0,64,223,2,0,0,0,0,0,0,0,0,0,104,218,2,0,39,0,0,0,40,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,192,36,3,0,80,218,2,0,64,223,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,152,36,3,0,120,218,2,0,0,0,0,0,224,218,2,0,41,0,0,0,42,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,136,219,2,0,43,0,0,0,44,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,192,36,3,0,208,218,2,0,0,0,0,0,0,0,0,0,0,0,0,0,32,219,2,0,41,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,192,36,3,0,8,219,2,0,224,218,2,0,0,0,0,0,0,0,0,0,96,219,2,0,41,0,0,0,46,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,192,36,3,0,72,219,2,0,224,218,2,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,192,36,3,0,112,219,2,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,208,219,2,0,47,0,0,0,48,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,192,36,3,0,184,219,2,0,136,219,2,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,152,36,3,0,224,219,2,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,192,36,3,0,8,220,2,0,0,220,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,184,222,2,0,49,0,0,0,50,0,0,0,0,0,0,0,64,223,2,0,51,0,0,0,52,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,128,223,2,0,53,0,0,0,54,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,184,223,2,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,184,223,2,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,0,224,2,0,55,0,0,0,56,0,0,0,248,255,255,255,248,255,255,255,0,224,2,0,57,0,0,0,58,0,0,0,4,0,0,0,0,0,0,0,72,224,2,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,72,224,2,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,144,224,2,0,59,0,0,0,60,0,0,0,252,255,255,255,252,255,255,255,144,224,2,0,61,0,0,0,62,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,222,2,0,63,0,0,0,64,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,128,222,2,0,65,0,0,0,66,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,192,36,3,0,56,222,2,0,208,219,2,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,152,36,3,0,104,222,2,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,192,36,3,0,136,222,2,0,128,222,2,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,192,36,3,0,200,222,2,0,128,222,2,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,152,36,3,0,8,223,2,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,152,36,3,0,72,223,2,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,32,37,3,0,136,223,2,0,0,0,0,0,1,0,0,0,184,222,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,32,37,3,0,208,223,2,0,0,0,0,0,1,0,0,0,248,222,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,32,37,3,0,24,224,2,0,0,0,0,0,1,0,0,0,184,222,2,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,32,37,3,0,96,224,2,0,0,0,0,0,1,0,0,0,248,222,2,0,3,244,255,255,0,0,0,0,240,224,2,0,67,0,0,0,68,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,192,36,3,0,208,224,2,0,32,220,2,0,0,0,0,0,0,0,0,0,24,239,2,0,69,0,0,0,70,0,0,0,71,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,239,2,0,72,0,0,0,73,0,0,0,71,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,243,2,0,74,0,0,0,75,0,0,0,71,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,136,244,2,0,76,0,0,0,77,0,0,0,71,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,245,2,0,78,0,0,0,79,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,245,2,0,80,0,0,0,81,0,0,0,71,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,8,241,2,0,82,0,0,0,83,0,0,0,71,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,8,241,2,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,168,241,2,0,84,0,0,0,85,0,0,0,71,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,168,241,2,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,56,242,2,0,86,0,0,0,87,0,0,0,71,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,242,2,0,88,0,0,0,89,0,0,0,71,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,239,2,0,90,0,0,0,91,0,0,0,71,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,239,2,0,92,0,0,0,93,0,0,0,71,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,240,2,0,94,0,0,0,95,0,0,0,71,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,240,2,0,96,0,0,0,97,0,0,0,71,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,246,2,0,98,0,0,0,99,0,0,0,71,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,0,247,2,0,100,0,0,0,101,0,0,0,71,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,144,247,2,0,102,0,0,0,103,0,0,0,71,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,32,248,2,0,104,0,0,0,105,0,0,0,71,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,242,2,0,106,0,0,0,107,0,0,0,71,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,243,2,0,108,0,0,0,109,0,0,0,71,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,240,238,2,0,110,0,0,0,111,0,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,235,2,0,112,0,0,0,113,0,0,0,71,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,236,2,0,114,0,0,0,115,0,0,0,71,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,238,2,0,116,0,0,0,117,0,0,0,71,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,200,238,2,0,118,0,0,0,119,0,0,0,71,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,0,235,2,0,120,0,0,0,121,0,0,0,71,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,192,36,3,0,232,234,2,0,152,218,2,0,0,0,0,0,0,0,0,0,144,235,2,0,120,0,0,0,122,0,0,0,71,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,152,36,3,0,112,235,2,0,32,37,3,0,88,235,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,136,235,2,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,32,37,3,0,176,235,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,136,235,2,0,2,0,0,0,0,0,0,0,96,236,2,0,120,0,0,0,123,0,0,0,71,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,152,36,3,0,64,236,2,0,32,37,3,0,24,236,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,88,236,2,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,32,37,3,0,128,236,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,88,236,2,0,2,0,0,0,0,0,0,0,32,237,2,0,120,0,0,0,124,0,0,0,71,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,32,37,3,0,248,236,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,88,236,2,0,2,0,0,0,0,0,0,0,152,237,2,0,120,0,0,0,125,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,32,37,3,0,112,237,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,88,236,2,0,2,0,0,0,0,0,0,0,16,238,2,0,120,0,0,0,126,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,192,36,3,0,232,237,2,0,152,237,2,0,0,0,0,0,0,0,0,0,120,238,2,0,120,0,0,0,127,0,0,0,71,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,192,36,3,0,80,238,2,0,152,237,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,192,36,3,0,136,238,2,0,0,235,2,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,192,36,3,0,176,238,2,0,0,235,2,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,192,36,3,0,216,238,2,0,0,235,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,192,36,3,0,0,239,2,0,0,235,2,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,192,36,3,0,40,239,2,0,0,235,2,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,152,36,3,0,112,239,2,0,32,37,3,0,80,239,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,136,239,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,32,37,3,0,176,239,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,136,239,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,32,37,3,0,240,239,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,136,239,2,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,32,37,3,0,48,240,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,136,239,2,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,152,36,3,0,184,240,2,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,152,36,3,0,216,240,2,0,32,37,3,0,112,240,2,0,0,0,0,0,3,0,0,0,0,235,2,0,2,0,0,0,208,240,2,0,2,0,0,0,0,241,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,152,36,3,0,120,241,2,0,32,37,3,0,48,241,2,0,0,0,0,0,3,0,0,0,0,235,2,0,2,0,0,0,208,240,2,0,2,0,0,0,160,241,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,152,36,3,0,24,242,2,0,32,37,3,0,208,241,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,48,242,2,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,32,37,3,0,88,242,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,48,242,2,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,152,36,3,0,216,242,2,0,32,37,3,0,192,242,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,240,242,2,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,32,37,3,0,24,243,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,240,242,2,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,152,36,3,0,176,243,2,0,32,37,3,0,152,243,2,0,0,0,0,0,1,0,0,0,208,243,2,0,0,0,0,0,32,37,3,0,80,243,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,216,243,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,32,37,3,0,88,244,2,0,0,0,0,0,1,0,0,0,208,243,2,0,0,0,0,0,32,37,3,0,16,244,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,112,244,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,152,36,3,0,8,245,2,0,32,37,3,0,240,244,2,0,0,0,0,0,1,0,0,0,40,245,2,0,0,0,0,0,32,37,3,0,168,244,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,48,245,2,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,32,37,3,0,176,245,2,0,0,0,0,0,1,0,0,0,40,245,2,0,0,0,0,0,32,37,3,0,104,245,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,200,245,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,152,36,3,0,72,246,2,0,32,37,3,0,0,246,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,104,246,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,152,36,3,0,216,246,2,0,32,37,3,0,144,246,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,248,246,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,152,36,3,0,104,247,2,0,32,37,3,0,32,247,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,136,247,2,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,152,36,3,0,248,247,2,0,32,37,3,0,176,247,2,0,0,0,0,0,2,0,0,0,0,235,2,0,2,0,0,0,24,248,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+186525);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,8,34,3,0,110,0,0,0,16,34,3,0,114,0,0,0,24,34,3,0,102,0,0,0,32,34,3,0,97,0,0,0,40,34,3,0,101,0,0,0,48,34,3,0,119,0,0,0,56,34,3,0,87,0,0,0,72,34,3,0,115,0,0,0,88,34,3,0,83,0,0,0,104,34,3,0,100,0,0,0,120,34,3,0,68,0,0,0,136,34,3,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,16,36,3,0,128,0,0,0,129,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,152,36,3,0,232,35,3,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,192,36,3,0,0,36,3,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,192,36,3,0,32,36,3,0,248,35,3,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,192,36,3,0,88,36,3,0,72,36,3,0,0,0,0,0,0,0,0,0,128,36,3,0,130,0,0,0,131,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,8,37,3,0,130,0,0,0,134,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,192,36,3,0,224,36,3,0,128,36,3,0,0,0,0,0,0,0,0,0,104,37,3,0,130,0,0,0,135,0,0,0,132,0,0,0,133,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,192,36,3,0,64,37,3,0,128,36,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,39,3,0,136,0,0,0,137,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,192,36,3,0,152,39,3,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+196864);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  var _DtoILow=true;

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

  
  
  var ___tm_formatted=allocate(44, "i8", ALLOC_STATIC);
  
  
  function _mktime(tmPtr) {
      _tzset();
      var year = HEAP32[(((tmPtr)+(20))>>2)];
      var timestamp = new Date(year >= 1900 ? year : year + 1900,
                               HEAP32[(((tmPtr)+(16))>>2)],
                               HEAP32[(((tmPtr)+(12))>>2)],
                               HEAP32[(((tmPtr)+(8))>>2)],
                               HEAP32[(((tmPtr)+(4))>>2)],
                               HEAP32[((tmPtr)>>2)],
                               0).getTime() / 1000;
      HEAP32[(((tmPtr)+(24))>>2)]=new Date(timestamp).getDay();
      var yday = Math.round((timestamp - (new Date(year, 0, 1)).getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      return timestamp;
    }function _asctime_r(tmPtr, buf) {
      var date = new Date(_mktime(tmPtr)*1000);
      var formatted = date.toString();
      var datePart = formatted.replace(/\d{4}.*/, '').replace(/ 0/, '  ');
      var timePart = formatted.match(/\d{2}:\d{2}:\d{2}/)[0];
      formatted = datePart + timePart + ' ' + date.getFullYear() + '\n';
      formatted.split('').forEach(function(chr, index) {
        HEAP8[(((buf)+(index))|0)]=chr.charCodeAt(0);
      });
      HEAP8[(((buf)+(25))|0)]=0;
      return buf;
    }function _asctime(tmPtr) {
      return _asctime_r(tmPtr, ___tm_formatted);
    }function _ctime(timer) {
      return _asctime(_localtime(timer));
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  function _sinh(x) {
      var p = Math.pow(Math.E, x);
      return (p - (1 / p)) / 2;
    }
  
  function _cosh(x) {
      var p = Math.pow(Math.E, x);
      return (p + (1 / p)) / 2;
    }function _tanh(x) {
      return _sinh(x) / _cosh(x);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }

  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }

  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _fgets(s, n, stream) {
      // char *fgets(char *restrict s, int n, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgets.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return 0;
      if (streamObj.error || streamObj.eof) return 0;
      var byte_;
      for (var i = 0; i < n - 1 && byte_ != 10; i++) {
        byte_ = _fgetc(stream);
        if (byte_ == -1) {
          if (streamObj.error || (streamObj.eof && i == 0)) return 0;
          else if (streamObj.eof) break;
        }
        HEAP8[(((s)+(i))|0)]=byte_;
      }
      HEAP8[(((s)+(i))|0)]=0;
      return s;
    }

  function _strchr(ptr, chr) {
      ptr--;
      do {
        ptr++;
        var val = HEAP8[(ptr)];
        if (val == chr) return ptr;
      } while (val);
      return 0;
    }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  var _FtoIHigh=true;

  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  var _putc=_fputc;

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

  function _log10(x) {
      return Math.log(x) / Math.LN10;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }

  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  function _localeconv() {
      // %struct.timeval = type { char* decimal point, other stuff... }
      // var indexes = Runtime.calculateStructAlignment({ fields: ['i32', 'i32'] });
      var me = _localeconv;
      if (!me.ret) {
      // These are defaults from the "C" locale
        me.ret = allocate([
          allocate(intArrayFromString('.'), 'i8', ALLOC_NORMAL),0,0,0, // decimal_point
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // thousands_sep
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // grouping
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // int_curr_symbol
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // currency_symbol
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // mon_decimal_point
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // mon_thousands_sep
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // mon_grouping
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0, // positive_sign
          allocate(intArrayFromString(''), 'i8', ALLOC_NORMAL),0,0,0 // negative_sign
        ], 'i8*', ALLOC_NORMAL); // Allocate strings in lconv, still don't allocate chars
      }
      return me.ret;
    }



  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }


  var _ftello=_ftell;

  var _DtoIHigh=true;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }




  var _tan=Math_tan;

  function _feof(stream) {
      // int feof(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/feof.html
      stream = FS.getStreamFromPtr(stream);
      return Number(stream && stream.eof);
    }

  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;


  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



   
  Module["_tolower"] = _tolower;

  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_prep_setjmp=true;

  var _emscripten_setjmp=true;

  var _BItoD=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _exp=Math_exp;

  var _FtoILow=true;

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._exp;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env._fscanf;var Za=env.___cxa_guard_acquire;var _a=env._log10;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env._isblank;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env._sinh;var ob=env._sysconf;var pb=env._close;var qb=env._rewind;var rb=env._cos;var sb=env._fileno;var tb=env._tanh;var ub=env._fread;var vb=env._puts;var wb=env._isatty;var xb=env._lis_matrix_set_value;var yb=env._write;var zb=env.__isLeapYear;var Ab=env._ftell;var Bb=env.__ZNSt9exceptionD2Ev;var Cb=env._xerbla_;var Db=env._round;var Eb=env.___cxa_does_inherit;var Fb=env._strtoll_l;var Gb=env._strstr;var Hb=env.___cxa_rethrow;var Ib=env._llvm_lifetime_end;var Jb=env._catclose;var Kb=env._tmpnam;var Lb=env._lis_vector_destroy;var Mb=env._lis_solver_set_option;var Nb=env._tmpfile;var Ob=env._send;var Pb=env._pow;var Qb=env._ctime;var Rb=env.___cxa_is_number_type;var Sb=env.___cxa_free_exception;var Tb=env.___cxa_find_matching_catch;var Ub=env._isxdigit_l;var Vb=env.___cxa_guard_release;var Wb=env._truncate;var Xb=env._strtol;var Yb=env.__reallyNegative;var Zb=env._sin;var _b=env._strtok;var $b=env.___setErrNo;var ac=env._newlocale;var bc=env._isdigit_l;var cc=env.___resumeException;var dc=env._freelocale;var ec=env._srand;var fc=env._strchr;var gc=env._mktime;var hc=env._qsort;var ic=env._putchar;var jc=env._floor;var kc=env._pthread_mutex_unlock;var lc=env._localeconv;var mc=env._printf;var nc=env._sprintf;var oc=env._fopen;var pc=env._vasprintf;var qc=env._emscripten_get_now;var rc=env._stat;var sc=env._vsnprintf;var tc=env._strtoull_l;var uc=env._asctime;var vc=env._read;var wc=env.__addDays;var xc=env._fwrite;var yc=env._time;var zc=env._pthread_mutex_lock;var Ac=env._catopen;var Bc=env._exit;var Cc=env._GC_strdup;var Dc=env._freopen;var Ec=env.___ctype_b_loc;var Fc=env._fmod;var Gc=env._strtok_r;var Hc=env._lseek;var Ic=env._access;var Jc=env._vfprintf;var Kc=env.___cxa_allocate_exception;var Lc=env._atoi;var Mc=env._strtoll;var Nc=env._pwrite;var Oc=env._localtime_r;var Pc=env._tzset;var Qc=env._open;var Rc=env._uselocale;var Sc=env._snprintf;var Tc=env.___errno_location;var Uc=env._GC_malloc;var Vc=env.___cxa_end_catch;var Wc=env._perror;var Xc=env.___cxa_begin_catch;var Yc=env._strftime;var Zc=env._ftruncate;var _c=env._GC_init;var $c=env._fseek;var ad=env.__ZSt9terminatev;var bd=env._asctime_r;var cd=env._isxdigit;var dd=env._fclose;var ed=env.__parseInt;var fd=env._log;var gd=env._pthread_cond_broadcast;var hd=env._popen;var id=env._recv;var jd=env._tan;var kd=env._copysign;var ld=env.__parseInt64;var md=env.__getFloat;var nd=env._abort;var od=env._ceil;var pd=env._isspace;var qd=env._localtime;var rd=env._pthread_getspecific;var sd=env._pthread_cond_wait;var td=env._llvm_lifetime_start;var ud=env._cosh;var vd=env._ungetc;var wd=env._system;var xd=env._fmin;var yd=env._fmax;var zd=env._fflush;var Ad=env._strftime_l;var Bd=env._fprintf;var Cd=env._sscanf;var Dd=env._catgets;var Ed=env._strdup;var Fd=env._asprintf;var Gd=env.__formatString;var Hd=env.__exit;var Id=env.___ctype_toupper_loc;var Jd=env._bsearch;var Kd=env.__arraySum;var Ld=env._lis_vector_create;var Md=env._htonl;var Nd=env.___ctype_tolower_loc;var Od=env._unlink;var Pd=env._fputs;var Qd=env._GC_malloc_atomic;var Rd=env._pread;var Sd=env._lis_vector_set_size;var Td=env._mkport;var Ud=env._feof;var Vd=env.__scanString;var Wd=env._pthread_setspecific;var Xd=env._fgetc;var Yd=env._fputc;var Zd=env.___cxa_throw;var _d=env._lis_solver_destroy;var $d=env._isdigit;var ae=env._strerror;var be=env._emscripten_longjmp;var ce=env._fgets;var de=env._atexit;var ee=env._sqrt;var fe=env._strerror_r;var ge=0.0;
// EMSCRIPTEN_START_FUNCS
function cQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 2:{k=wQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=OP(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 3:{k=sQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=OP(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function dQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=OP(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=OP(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=53;break b}b=r+4|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function eQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=OP(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function fQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=OP(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 10:{n=16;break a;break};case 21:{n=29;break a;break};case 2:{n=15;break a;break};case 9:{n=19;break a;break};case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=sQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=OP(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function gQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=OP(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 10:{n=18;break a;break};case 6:{b=b+3|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=sQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=tQ(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=OP(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function hQ(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=OP(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 6:{k=8;break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=OP(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function iQ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function jQ(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=OP(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function kQ(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=OP(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function lQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=OP(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=OP(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function mQ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=aP(c)|0;k=j;i=b;return k|0}function nQ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==108){g=60;h=g;i=b;return h|0}else if((f|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==4){if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((j|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function oQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=OP(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=OP(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 5:{b=b+2|0;break};case 6:{b=b+3|0;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function pQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=OP(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function qQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g+1|0]|0;o=((l&3)<<4|(a[g]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function rQ(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function sQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=uQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=OP(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 29:{if((c[107360+((d[108640+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function tQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=OP(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 29:{if((c[107360+((d[108640+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function uQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=vQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=OP(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function vQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=OP(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=OP(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function wQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 15:{k=zQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=OP(a[g]|0,a[b+1|0]|0)|0}if((n|0)==27){k=xQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=yQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=AQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=OP(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=OP(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 24:case 22:{break};case 7:{o=65;break b;break};case 29:{if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 6:{o=62;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 6:{o=42;break b;break};case 5:{o=39;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{o=69;break b;break};case 29:{if((c[107360+((d[108640+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 7:{o=45;break b;break};case 17:{break b;break};case 11:{o=90;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=OP(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 7:{o=84;break d;break};case 5:{o=78;break d;break};case 6:{o=81;break d;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 17:{break c;break};case 29:{o=75;break d;break};case 11:{o=90;break c;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=BQ(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function xQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=OP(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function yQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[109680+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function zQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=OP(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 29:{if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=OP(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 10:case 9:case 21:{p=37;break b;break};case 15:{p=62;break b;break};case 6:{p=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};case 29:{if((c[107360+((d[108640+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 5:{p=28;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((CQ(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=OP(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((CQ(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function AQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=OP(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=28;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 6:{n=31;break b;break};case 29:{if((c[107360+((d[108640+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 11:{n=48;break b;break};case 23:{b=b+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=OP(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function BQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=OP(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=OP(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 29:{if((c[107360+((d[107104+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 7:{l=36;break a;break};case 5:{l=30;break a;break};case 24:case 22:{break};case 6:{l=33;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 14:{break};case 7:{l=16;break a;break};case 5:{l=10;break a;break};case 29:{if((c[107360+((d[108640+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=OP(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 6:{l=13;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=OP(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=OP(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 8:case 1:case 0:{l=74;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 2:{l=79;break a;break};case 3:{t=sQ(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=OP(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=OP(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 11:{l=106;break a;break};case 6:{l=100;break a;break};case 5:{l=97;break a;break};case 10:case 9:case 21:{break};case 7:{l=103;break a;break};case 29:{l=94;break d;break};case 24:case 22:{break d;break};case 17:{l=107;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[107360+((d[107104+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function CQ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function DQ(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=OP(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=OP(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function EQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=xQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=OP(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 24:case 22:{break};case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=OP(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function FQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=OP(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 6:{n=31;break b;break};case 29:{if((c[107360+((d[108640+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function GQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 30:{k=eR(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((De[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((De[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((De[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((De[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((De[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((De[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 16:{k=pR(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=kR(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 13:{k=oR(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 12:{k=oR(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 19:{k=qR(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 24:case 22:{m=18;b=b+1|0;break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){n=82;break b}p=b;if((De[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=p+4|0;continue b;break};case 6:{if((e-b|0)<3){n=77;break b}q=b;if((De[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=q+3|0;continue b;break};case 5:{if((e-b|0)<2){n=72;break b}r=b;if((De[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=r+2|0;continue b;break};case 29:{n=69;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){n=99;break b}s=b;if((De[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=s+3|0;continue b;break};case 7:{if((e-b|0)<4){n=104;break b}t=b;if((De[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=t+4|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}u=b;if((De[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=u+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{n=91;break b;break};default:{m=19;continue b}}break};case 15:{n=116;break b;break};case 34:{n=110;break b;break};case 33:{n=113;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==110){t=b;if((m|0)==19){c[f>>2]=t;k=0;l=k;i=h;return l|0}else{c[f>>2]=t+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){t=b;if((m|0)==19){c[f>>2]=t;k=0;l=k;i=h;return l|0}else{c[f>>2]=t+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){t=b;if((m|0)==19){c[f>>2]=t;k=0;l=k;i=h;return l|0}else{c[f>>2]=t+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function HQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=dR(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 2:{k=hR(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((De[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((De[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 7:{if((e-b|0)<4){n=49;break b}if((De[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function IQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 7:{if((e-b|0)<4){n=47;break b}if((De[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((De[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 6:{if((e-b|0)<3){n=43;break b}if((De[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function JQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((De[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 2:{m=b+1|0;b=m;if((m|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((De[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 4:{m=b+1|0;b=m;if((m|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}o=b;if((De[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=o+3|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function KQ(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 9:{m=16;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};case 3:{m=9;break a;break};case 7:{a=a+4|0;continue a;break};case 21:{m=23;break a;break};case 2:{m=12;break a;break};case 10:{m=13;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=dR(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function LQ(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 10:{m=15;break a;break};case 6:{a=a+3|0;continue a;break};case 9:{m=18;break a;break};case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 30:{m=12;break a;break};case 3:{m=9;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=dR(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=eR(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function MQ(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 7:{e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=4;break a}else{j=5}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{h=c;c=h+1|0;e=b;b=e+1|0;if((a[h]|0)!=(a[e]|0)){j=12;break a}else{continue a}break};case 6:{j=5;break};case 5:{break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function NQ(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function OQ(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};default:{break a}}}i=c;return a-b|0}function PQ(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function QQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 17:case 11:{if((g|0)!=2){break a}break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function RQ(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=aP(c)|0;g=f;i=b;return g|0}function SQ(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function TQ(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 7:{a=a+4|0;break};case 6:{a=a+3|0;break};case 5:{a=a+2|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function UQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function VQ(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function WQ(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==5){p=j;j=p+2|0;b[p>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}o=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;o=o-65536|0;b[j>>1]=o>>>10|55296;b[j+2>>1]=o&1023|56320;j=j+4|0;m=m+4|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function XQ(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[107360+(((d[108640+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function YQ(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[107360+(((d[108640+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function ZQ(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function _Q(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[107360+(((d[107104+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function $Q(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[107360+(((d[107104+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function aR(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function bR(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function cR(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function dR(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 19:{j=fR(h,a+1|0,b,e)|0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}m=a;if((De[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((De[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((De[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function eR(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 18:{l=42;break b;break};case 5:{if((b-a|0)<2){l=28;break b}m=a;if((De[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((De[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 29:{l=25;break b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((De[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function fR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=gR(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function gR(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function hR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 17:{k=lR(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==27){k=iR(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==20){k=jR(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 15:{k=kR(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:case 21:{m=73;break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=68;break b}n=b;if((De[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=n+4|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 6:{if((e-b|0)<3){m=63;break b}o=b;if((De[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=o+3|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}p=b;if((De[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=p+2|0;continue b;break};case 29:{m=55;break b;break};default:{m=72;break b}}break};case 11:{m=97;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=33;break b;break};case 7:{if((e-b|0)<4){m=46;break b}q=b;if((De[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=q+4|0;continue b;break};case 17:{break b;break};case 6:{if((e-b|0)<3){m=41;break b}r=b;if((De[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=r+3|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}s=b;if((De[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=s+2|0;continue b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 11:{m=97;break c;break};case 6:{m=83;break d;break};case 17:{break c;break};case 24:case 22:{m=77;break d;break};case 10:case 9:case 21:{break};case 7:{m=88;break d;break};case 29:{m=76;break d;break};case 5:{m=78;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((De[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=mR(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function iR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=18;break b}n=b;if((De[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=n+4|0;continue b;break};case 6:{if((e-b|0)<3){m=13;break b}o=b;if((De[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=o+3|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 8:case 1:case 0:{m=22;break b;break};case 5:{if((e-b|0)<2){m=8;break b}p=b;if((De[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=p+2|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function jR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[110056+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function kR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((De[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((De[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((De[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){o=32;break b}p=b;if((De[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=p+3|0;continue b;break};case 15:{o=68;break b;break};case 29:{o=24;break b;break};case 7:{if((e-b|0)<4){o=37;break b}q=b;if((De[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=q+4|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){o=27;break b}r=b;if((De[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=r+2|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((nR(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){o=52;break c}s=b;if((De[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=s+3|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((De[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 5:{if((e-b|0)<2){o=47;break c}u=b;if((De[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=u+2|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((nR(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function lR(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 11:{l=49;break b;break};case 6:{if((b-a|0)<3){l=32;break b}m=a;if((De[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 29:{l=24;break b;break};case 23:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((De[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((De[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}n=d[h+76+(d[a]|0)|0]|0;if((n|0)==11){l=44;break}else if(!((n|0)==10|(n|0)==9|(n|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function mR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(De[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=m+2;continue a;break};case 14:{break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}b=(De[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=19;break a}c[j>>2]=n+4;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=48;break a}}break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}o=(De[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!o){l=36;break a}c[j>>2]=p+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}o=(De[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!o){l=41;break a}c[j>>2]=q+4;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}o=(De[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!o){l=31;break a}c[j>>2]=r+2;continue a;break};case 29:{l=26;break a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=43;break a}}break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}o=(De[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!o){l=14;break a}c[j>>2]=s+3;continue a;break};case 29:{l=4;break a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}o=t;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}o=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((o|0)==(t|0)){break}switch(o|0){case 3:{u=dR(k,(c[j>>2]|0)+1|0,e,j)|0;if((u|0)<=0){l=77;break a}else{continue c}break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}o=(De[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(o){l=68;break a}c[j>>2]=v+3;continue c;break};case 2:{l=80;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}o=(De[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(o){l=73;break a}c[j>>2]=w+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}o=(De[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(o){l=63;break a}c[j>>2]=x+2;continue c;break};case 8:case 1:case 0:{l=75;break a;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=89;break a;break};case 7:{l=101;break d;break};case 5:{l=91;break d;break};case 17:{l=107;break a;break};case 24:case 22:{l=90;break d;break};case 11:{l=106;break a;break};case 6:{l=96;break d;break};case 10:case 9:case 21:{break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}o=(De[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!o){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}o=(De[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!o){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}o=(De[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!o){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((u|0)==0){c[f>>2]=c[j>>2]}B=u;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function nR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function oR(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}l=b;if((De[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}m=b;if((De[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=m+4|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((De[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function pR(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 30:{l=10;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==27){j=iR(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function qR(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((De[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 5:{if((b-a|0)<2){l=27;break b}m=a;if((De[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((De[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 29:{l=24;break b;break};case 6:{if((b-a|0)<3){l=32;break b}o=a;if((De[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=o+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function rR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function sR(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function tR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}



function Iaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=Xd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Me[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=Xd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((vd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function Jaa(a){a=a|0;var b=0;b=i;c[a>>2]=187552;qia(a+4|0);i=b;return}function Kaa(a){a=a|0;var b=0;b=i;c[a>>2]=187552;qia(a+4|0);Vla(a);i=b;return}function Laa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;oe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=sia(d,190344)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(oe[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function Maa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Ee[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((xc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((zd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function Naa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=xc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((De[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function Oaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((xc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Me[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((xc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((xc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Paa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=187552;j=b+4|0;oia(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=186904;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;pia(g,j);j=sia(g,190344)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=oe[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(oe[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Aha(186744)}else{qia(g);i=f;return}}function Qaa(a){a=a|0;var b=0;b=i;c[a>>2]=187552;qia(a+4|0);i=b;return}function Raa(a){a=a|0;var b=0;b=i;c[a>>2]=187552;qia(a+4|0);Vla(a);i=b;return}function Saa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=sia(d,190344)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=oe[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(oe[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Aha(186744)}else{i=e;return}}function Taa(a){a=a|0;var b=0,c=0;b=i;c=Waa(a,0)|0;i=b;return c|0}function Uaa(a){a=a|0;var b=0,c=0;b=i;c=Waa(a,1)|0;i=b;return c|0}function Vaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Me[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((vd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function Waa(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=Xd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Me[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==2){o=-1;z=23;break}else if((y|0)==3){z=14;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=Xd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((vd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function Xaa(){var a=0;a=i;taa(0);de(305,186168,q|0)|0;i=a;return}function Yaa(a){a=a|0;i=i;return}function Zaa(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function _aa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}le[c[(c[a>>2]|0)+8>>2]&511](a);f=1;i=b;return f|0}function $aa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=187048;e=pma(b|0)|0;f=Ula(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;rma(g|0,b|0,e+1|0)|0;i=d;return}function aba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=187048;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);j=a;Vla(j);i=b;return}Wla((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);j=a;Vla(j);i=b;return}function bba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=187048;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);i=b;return}Wla((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);i=b;return}function cba(a){a=a|0;i=i;return c[a+4>>2]|0}function dba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=187072;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=pma(f|0)|0;g=Ula(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;rma(h|0,f|0,d+1|0)|0;i=e;return}function eba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=187072;e=pma(b|0)|0;f=Ula(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;rma(g|0,b|0,e+1|0)|0;i=d;return}function fba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=187072;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);j=a;Vla(j);i=b;return}Wla((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);j=a;Vla(j);i=b;return}function gba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=187072;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);i=b;return}Wla((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);i=b;return}function hba(a){a=a|0;i=i;return c[a+4>>2]|0}function iba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=187048;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);j=a;Vla(j);i=b;return}Wla((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);j=a;Vla(j);i=b;return}function jba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=187048;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;Bb(h|0);j=a;Vla(j);i=b;return}Wla((c[d>>2]|0)+ -12|0);g=a;h=g;Bb(h|0);j=a;Vla(j);i=b;return}function kba(a){a=a|0;i=i;return}function lba(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function mba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Ke[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function nba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function oba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=ae(e|0)|0;e=pma(f|0)|0;if(e>>>0>4294967279){uba(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;rma(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=Tla(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;rma(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function pba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{$ba(e,187288,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Ke[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}$ba(e,o,p)|0;if((a[g]&1)==0){break}Vla(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function qba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=pma(e|0)|0;if(j>>>0>4294967279){uba(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=Tla(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}rma(k|0,e|0,j|0)|0;a[k+j|0]=0;pba(g,d,h);dba(b,g);if(!((a[g]&1)==0)){Vla(c[g+8>>2]|0)}if(!((a[h]&1)==0)){Vla(c[h+8>>2]|0)}c[b>>2]=187304;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function rba(a){a=a|0;var b=0;b=i;gba(a);Vla(a);i=b;return}function sba(a){a=a|0;var b=0;b=i;gba(a);i=b;return}function tba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;zc(187440)|0;if((c[a>>2]|0)==1){do{sd(187464,187440)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;kc(187440)|0;le[d&511](b);zc(187440)|0;c[a>>2]=-1;kc(187440)|0;gd(187464)|0;i=e;return}else{kc(187440)|0;i=e;return}}function uba(a){a=a|0;a=Kc(8)|0;$aa(a,187512);c[a>>2]=187128;Zd(a|0,187168,41)}function vba(a){a=a|0;a=Kc(8)|0;$aa(a,187512);c[a>>2]=187192;Zd(a|0,187232,41)}function wba(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function xba(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function yba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){uba(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=Tla(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}rma(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function zba(b){b=b|0;i=i;return(a[b]&1)!=0|0}function Aba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){uba(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=Tla(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}rma(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function Bba(a){a=a|0;i=i;return a|0}function Cba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=pma(d|0)|0;if(f>>>0>4294967279){uba(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;rma(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=Tla(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;rma(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function Dba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){uba(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=Tla(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}tma(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function Eba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){uba(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;tma(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=Tla(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;tma(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function Fba(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){vba(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){uba(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;rma(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=Tla(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;rma(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function Gba(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Hba(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function Iba(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}Vla(c[b+8>>2]|0);i=d;return}function Jba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}aca(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}sma(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function Kba(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Lba(a,b)|0;i=c;return d|0}function Lba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=pma(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}aca(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}sma(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function Mba(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function Nba(a){a=a|0;i=i;return a+1|0}function Oba(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function Pba(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Qba(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function Rba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){Sba(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function Sba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){bca(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}tma(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function Tba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){Sba(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function Uba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){uba(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=Tla(f)|0}else{p=Tla(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}rma(l|0,n|0,q+1|0)|0;if(o){Vla(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function Vba(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function Wba(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function Xba(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function Yba(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function Zba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=$ba(b,g,h)|0;i=e;return d|0}function _ba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){bca(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function $ba(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){aca(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}rma(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function aca(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){uba(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=Tla(q)|0;if((g|0)!=0){rma(e|0,m|0,g|0)|0}if((j|0)!=0){rma(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){rma(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){Vla(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function bca(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){uba(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=Tla(p)|0;if((g|0)!=0){rma(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){rma(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}Vla(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function cca(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Fba(a,b,c,d,0);i=e;return}function dca(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function eca(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=pma(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function fca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=kma(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function gca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=pma(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){vba(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=kma(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function hca(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){uba(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;rma(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=Tla(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;rma(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function ica(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){uba(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=Tla(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}ola(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function jca(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){uba(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=Tla(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}qla(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function kca(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}Vla(c[b+8>>2]|0);i=d;return}function lca(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=mca(a,b,nla(b)|0)|0;i=c;return d|0}function mca(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}pca(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}pla(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function nca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){uba(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=Tla(f)|0}else{p=Tla(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}ola(l,n,q+1|0)|0;if(o){Vla(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function oca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){qca(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function pca(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){uba(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=Tla(q<<2)|0;p=e;if((g|0)!=0){ola(p,m,g)|0}if((j|0)!=0){ola(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){ola(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){Vla(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function qca(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){uba(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=Tla(p<<2)|0;o=e;if((g|0)!=0){ola(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){ola(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}Vla(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function rca(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=pma(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){uba(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=Tla(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}rma(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=$ba(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=$ba(b,m,j)|0;i=f;return}}function sca(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function tca(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function uca(a,b){a=a|0;b=b|0;var c=0;c=i;vca(a,b);i=c;return}function vca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Kc(16)|0;do{if((a[187896]|0)==0){if((Za(187896)|0)==0){break}c[46972]=188592;de(67,187888,q|0)|0;Vb(187896)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=187888;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];qba(b,f,187944);c[e>>2]=187912;Zd(e|0,187992,63)}function wca(a,b){a=a|0;b=b|0;var d=0;d=i;vca(a,c[a+16>>2]|b);i=d;return}function xca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=187936;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Ke[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}qia(a+28|0);Ola(c[e>>2]|0);Ola(c[f>>2]|0);Ola(c[a+48>>2]|0);Ola(c[a+60>>2]|0);i=b;return}function yca(a){a=a|0;var b=0;b=i;xca(a);Vla(a);i=b;return}function zca(a){a=a|0;var b=0;b=i;xca(a);i=b;return}function Aca(a){a=a|0;var b=0;b=i;xca(a);i=b;return}function Bca(a){a=a|0;i=i;return c[a+24>>2]|0}function Cca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}pia(d,a+28|0);a=sia(d,190280)|0;f=De[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;qia(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function Dca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;pia(e,a+28|0);a=sia(e,190280)|0;f=De[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;qia(e);i=d;return f|0}function Eca(a,b){a=a|0;b=b|0;var c=0;c=i;pia(a,b+28|0);i=c;return}function Fca(a){a=a|0;c[a>>2]=187536;i=i;return}function Gca(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));oia(b);i=d;return}function Hca(a){a=a|0;var b=0;b=i;c[a>>2]=187552;qia(a+4|0);Vla(a);i=b;return}function Ica(a){a=a|0;var b=0;b=i;c[a>>2]=187552;qia(a+4|0);i=b;return}function Jca(a){a=a|0;var b=0;b=i;c[a>>2]=187552;qia(a+4|0);i=b;return}function Kca(a,b){a=a|0;b=b|0;var c=0;c=i;pia(a,b+4|0);i=c;return}function Lca(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=oe[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function Mca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=De[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function Nca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=re[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function Oca(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=187552;oia(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function Pca(a){a=a|0;i=i;return c[a+8>>2]|0}function Qca(a){a=a|0;i=i;return c[a+12>>2]|0}function Rca(a){a=a|0;i=i;return c[a+16>>2]|0}function Sca(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function Tca(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function Uca(a){a=a|0;i=i;return c[a+20>>2]|0}function Vca(a){a=a|0;i=i;return c[a+24>>2]|0}function Wca(a){a=a|0;i=i;return c[a+28>>2]|0}function Xca(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function Yca(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function Zca(a,b){a=a|0;b=b|0;i=i;return}function _ca(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function $ca(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function ada(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function bda(a){a=a|0;i=i;return 0}function cda(a){a=a|0;i=i;return 0}function dda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=oe[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function eda(a){a=a|0;i=i;return-1}function fda(a){a=a|0;var b=0,e=0,f=0;b=i;if((oe[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function gda(a,b){a=a|0;b=b|0;i=i;return-1}function hda(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((De[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function ida(a,b){a=a|0;b=b|0;i=i;return-1}function jda(a){a=a|0;var b=0;b=i;c[a>>2]=187616;qia(a+4|0);Vla(a);i=b;return}function kda(a){a=a|0;var b=0;b=i;c[a>>2]=187616;qia(a+4|0);i=b;return}function lda(a,b){a=a|0;b=b|0;i=i;return}function mda(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function nda(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function oda(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function pda(a){a=a|0;i=i;return 0}function qda(a){a=a|0;i=i;return 0}function rda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=oe[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function sda(a){a=a|0;i=i;return-1}function tda(a){a=a|0;var b=0,d=0,e=0;b=i;if((oe[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function uda(a,b){a=a|0;b=b|0;i=i;return-1}function vda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((De[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function wda(a,b){a=a|0;b=b|0;i=i;return-1}function xda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));oia(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function yda(a){a=a|0;var b=0;b=i;xca(a+8|0);Vla(a);i=b;return}function zda(a){a=a|0;var b=0;b=i;xca(a+8|0);i=b;return}function Ada(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;xca(a+(d+8)|0);Vla(a+d|0);i=b;return}function Bda(a){a=a|0;var b=0;b=i;xca(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Cda(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Dda(a,b,c);i=d;return}function Dda(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){vca(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){Eda(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}pia(h,e+(k+28)|0);k=sia(h,190280)|0;qia(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(oe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(oe[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){oe[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((oe[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;vca(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function Eda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Eda(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((oe[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;vca(b+h|0,c[b+(h+16)>>2]|1)}}while(0);Tda(e);i=d;return b|0}function Fda(b){b=b|0;i=i;return(a[b]|0)!=0|0}function Gda(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Hb()}}function Hda(a){a=a|0;var b=0;b=i;xca(a+8|0);Vla(a);i=b;return}function Ida(a){a=a|0;var b=0;b=i;xca(a+8|0);i=b;return}function Jda(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;xca(a+(d+8)|0);Vla(a+d|0);i=b;return}function Kda(a){a=a|0;var b=0;b=i;xca(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Lda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Lda(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((oe[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;vca(b+h|0,c[b+(h+16)>>2]|1)}}while(0);dea(e);i=d;return b|0}function Mda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));oia(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function Nda(a){a=a|0;var b=0;b=i;xca(a+4|0);Vla(a);i=b;return}function Oda(a){a=a|0;var b=0;b=i;xca(a+4|0);i=b;return}function Pda(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;xca(a+(d+4)|0);Vla(a+d|0);i=b;return}function Qda(a){a=a|0;var b=0;b=i;xca(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function Rda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){Eda(g)|0}a[f]=1;i=e;return}function Sda(a){a=a|0;var b=0;b=i;Tda(a);i=b;return}function Tda(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((oe[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;vca(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function Uda(b){b=b|0;i=i;return(a[b]|0)!=0|0}function Vda(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=oe[b&127](a)|0;i=c;return d|0}function Wda(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){Tda(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{Eda(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;pia(k,b+(p+28)|0);p=sia(k,189e3)|0;m=p;qia(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){pia(h,b+(k+28)|0);r=sia(h,190280)|0;s=De[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;qia(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];ue[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){Tda(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;vca(b+l|0,c[b+(l+16)>>2]|5);Tda(j);i=e;return b|0}function Xda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){Tda(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{Eda(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;Tda(f);i=e;return b|0}if((De[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{Tda(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;vca(b+d|0,c[b+(d+16)>>2]|1);Tda(f);i=e;return b|0}function Yda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){Tda(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){Eda(k)|0}a[h]=1;if((e|0)==0){Tda(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((re[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){Tda(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;vca(b+e|0,c[b+(e+16)>>2]|1);Tda(g);i=f;return b|0}function Zda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;xe[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function _da(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){Tda(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{Eda(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Oe[l&63](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){Tda(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;vca(b+f|0,c[b+(f+16)>>2]|4);Tda(h);i=e;return b|0}function $da(a){a=a|0;var b=0;b=i;xca(a+4|0);Vla(a);i=b;return}function aea(a){a=a|0;var b=0;b=i;xca(a+4|0);i=b;return}function bea(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;xca(a+(d+4)|0);Vla(a+d|0);i=b;return}function cea(a){a=a|0;var b=0;b=i;xca(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function dea(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((oe[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;vca(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function eea(a){a=a|0;i=i;return 187832}function fea(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){Aba(a,187848,35);i=d;return}else{oba(a,b,c);i=d;return}}function gea(a){a=a|0;i=i;return}function hea(a){a=a|0;var b=0;b=i;sba(a);Vla(a);i=b;return}function iea(a){a=a|0;var b=0;b=i;sba(a);i=b;return}function jea(a){a=a|0;var b=0;b=i;xca(a);Vla(a);i=b;return}function kea(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function lea(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function mea(a){a=a|0;i=i;return}function nea(a){a=a|0;i=i;return}function oea(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function pea(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){uba(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=Tla(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function qea(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function rea(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function sea(a){a=a|0;i=i;return}function tea(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function uea(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){uba(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=Tla(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function vea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function wea(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function xea(a){a=a|0;i=i;return}function yea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];Ae[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Eca(u,g);m=u;u=c[m>>2]|0;if(!((c[47570]|0)==-1)){c[p>>2]=190280;c[p+4>>2]=306;c[p+8>>2]=0;tba(190280,p,307)}p=(c[190284>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Kc(4)|0;D=C;sla(D);E=205840;F=128;Zd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Kc(4)|0;D=C;sla(D);E=205840;F=128;Zd(C|0,E|0,F|0)}F=u;_aa(c[m>>2]|0)|0;Eca(v,g);g=v;v=c[g>>2]|0;if(!((c[47606]|0)==-1)){c[o>>2]=190424;c[o+4>>2]=306;c[o+8>>2]=0;tba(190424,o,307)}o=(c[190428>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Kc(4)|0;H=G;sla(H);I=205840;J=128;Zd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Kc(4)|0;H=G;sla(H);I=205840;J=128;Zd(G|0,I|0,J|0)}J=v;_aa(c[g>>2]|0)|0;g=w;me[c[(c[v>>2]|0)+24>>2]&127](g,J);me[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=zea(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];Iba(w+12|0);Iba(w);i=k;return}function zea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=Nla(l)|0;if((n|0)!=0){o=n;p=n;break}_la()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((oe[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((oe[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=De[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(De[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){oe[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((oe[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}Ola(o);i=k;return _|0}function Aea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Bea(a,0,k,j,f,g,h);i=b;return}function Bea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;rfa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Rba(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Rba(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Tea(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=nka(F,c[o>>2]|0,h,t)|0;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}function Cea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Dea(a,0,k,j,f,g,h);i=b;return}function Dea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;rfa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}Rba(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Rba(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((Tea(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=mka(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Iba(n);Iba(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Iba(n);Iba(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Iba(n);Iba(m);i=d;return}function Eea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Fea(a,0,k,j,f,g,h);i=b;return}function Fea(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==64){u=8}else if((t|0)==0){u=0}else{u=10}t=l;rfa(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Rba(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((oe[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}Rba(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}Rba(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((Tea(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){oe[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=lka(G,c[p>>2]|0,j,u)|0;Eha(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;Iba(o);Iba(n);i=e;return}if((oe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;Iba(o);Iba(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;Iba(o);Iba(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;Iba(o);Iba(n);i=e;return}function Gea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Hea(a,0,k,j,f,g,h);i=b;return}function Hea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;rfa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Rba(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Rba(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Tea(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=kka(F,c[o>>2]|0,h,t)|0;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}function Iea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Jea(a,0,k,j,f,g,h);i=b;return}function Jea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;rfa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Rba(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Rba(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Tea(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=jka(F,c[o>>2]|0,h,t)|0;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Iba(n);Iba(m);i=d;return}function Kea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Lea(a,0,k,j,f,g,h);i=b;return}function Lea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;rfa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}Rba(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Rba(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((Tea(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=ika(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((oe[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Iba(n);Iba(m);i=d;return}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Iba(n);Iba(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Iba(n);Iba(m);i=d;return}function Mea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Nea(a,0,k,j,f,g,h);i=b;return}function Nea(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;sfa(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Rba(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Rba(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Rba(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((tfa(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+hka(I,c[p>>2]|0,j);Eha(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}if((oe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}function Oea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Pea(a,0,k,j,f,g,h);i=b;return}function Pea(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;sfa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Rba(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Rba(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((tfa(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+gka(I,c[p>>2]|0,j);Eha(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}if((oe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}function Qea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Rea(a,0,k,j,f,g,h);i=b;return}function Rea(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;sfa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Rba(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Rba(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((tfa(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+fka(I,c[p>>2]|0,j);Eha(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((oe[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}if((oe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Iba(o);Iba(n);i=d;return}function Sea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Eca(o,g);g=o;o=c[g>>2]|0;if(!((c[47570]|0)==-1)){c[l>>2]=190280;c[l+4>>2]=306;c[l+8>>2]=0;tba(190280,l,307)}l=(c[190284>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}y=m;Ne[c[(c[o>>2]|0)+32>>2]&63](o,188824,188850|0,y)|0;_aa(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((oe[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((oe[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}Rba(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}Rba(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(oe[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((Tea(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){oe[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);K=c[47542]|0;c[k>>2]=j;if((Uea(E,K,188864,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((oe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;Iba(p);Iba(n);i=d;return}if((oe[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;Iba(p);Iba(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;Iba(p);Iba(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;Iba(p);Iba(n);i=d;return}function Tea(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[188824+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[188824+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function Uea(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Rc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Rc(e|0)|0;i=f;return b|0}function Vea(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Wea(a){a=a|0;i=i;return}function Xea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];Ae[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Eca(u,g);m=u;u=c[m>>2]|0;if(!((c[47568]|0)==-1)){c[p>>2]=190272;c[p+4>>2]=306;c[p+8>>2]=0;tba(190272,p,307)}p=(c[190276>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Kc(4)|0;D=C;sla(D);E=205840;F=128;Zd(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Kc(4)|0;D=C;sla(D);E=205840;F=128;Zd(C|0,E|0,F|0)}F=u;_aa(c[m>>2]|0)|0;Eca(v,g);g=v;v=c[g>>2]|0;if(!((c[47608]|0)==-1)){c[o>>2]=190432;c[o+4>>2]=306;c[o+8>>2]=0;tba(190432,o,307)}o=(c[190436>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Kc(4)|0;H=G;sla(H);I=205840;J=128;Zd(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Kc(4)|0;H=G;sla(H);I=205840;J=128;Zd(G|0,I|0,J|0)}J=v;_aa(c[g>>2]|0)|0;g=w;me[c[(c[v>>2]|0)+24>>2]&127](g,J);me[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=Yea(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];kca(w+12|0);kca(w);i=k;return}function Yea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=Nla(l)|0;if((n|0)!=0){o=n;p=n;break}_la()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=oe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=oe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=De[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(De[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){oe[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}Ola(o);i=k;return ba|0}function Zea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];_ea(a,0,k,j,f,g,h);i=b;return}function _ea(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;ufa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Rba(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Rba(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((qfa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=nka(I,c[o>>2]|0,h,t)|0;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}function $ea(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];afa(a,0,k,j,f,g,h);i=b;return}function afa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;ufa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}Rba(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Rba(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((qfa(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=mka(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Iba(n);Iba(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Iba(n);Iba(m);i=d;return}function bfa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];cfa(a,0,k,j,f,g,h);i=b;return}function cfa(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==0){u=0}else if((t|0)==64){u=8}else{u=10}t=l;ufa(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Rba(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=oe[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}Rba(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}Rba(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=oe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((qfa(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){oe[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=lka(J,c[p>>2]|0,j,u)|0;Eha(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=oe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=oe[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;Iba(o);Iba(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;Iba(o);Iba(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;Iba(o);Iba(n);i=e;return}function dfa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];efa(a,0,k,j,f,g,h);i=b;return}function efa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;ufa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Rba(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Rba(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((qfa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=kka(I,c[o>>2]|0,h,t)|0;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}function ffa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];gfa(a,0,k,j,f,g,h);i=b;return}function gfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;ufa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Rba(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Rba(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((qfa(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=jka(I,c[o>>2]|0,h,t)|0;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Iba(n);Iba(m);i=d;return}function hfa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ifa(a,0,k,j,f,g,h);i=b;return}



function ifa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;ufa(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=oe[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=oe[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}Rba(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Rba(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((qfa(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){oe[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=ika(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Eha(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=oe[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=oe[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Iba(n);Iba(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Iba(n);Iba(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Iba(n);Iba(m);i=d;return}function jfa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];kfa(a,0,k,j,f,g,h);i=b;return}function kfa(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;vfa(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Rba(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=oe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Rba(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Rba(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((wfa(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+hka(L,c[p>>2]|0,j);Eha(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=oe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}function lfa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];mfa(a,0,k,j,f,g,h);i=b;return}function mfa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;vfa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=oe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Rba(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Rba(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((wfa(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+gka(L,c[p>>2]|0,j);Eha(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=oe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}function nfa(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ofa(a,0,k,j,f,g,h);i=b;return}function ofa(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;vfa(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=oe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Rba(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Rba(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((wfa(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+fka(L,c[p>>2]|0,j);Eha(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=oe[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Iba(o);Iba(n);i=d;return}function pfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Eca(o,g);g=o;o=c[g>>2]|0;if(!((c[47568]|0)==-1)){c[l>>2]=190272;c[l+4>>2]=306;c[l+8>>2]=0;tba(190272,l,307)}l=(c[190276>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}y=m;Ne[c[(c[o>>2]|0)+48>>2]&63](o,188824,188850|0,y)|0;_aa(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Rba(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=oe[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=oe[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}Rba(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Rba(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((qfa(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){oe[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);N=c[47542]|0;c[k>>2]=j;if((Uea(H,N,188864,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=oe[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=oe[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;Iba(p);Iba(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;Iba(p);Iba(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;Iba(p);Iba(n);i=d;return}function qfa(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[188824+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}}while(0);e=a[188824+m|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function rfa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Eca(k,d);d=k;k=c[d>>2]|0;if(!((c[47570]|0)==-1)){c[j>>2]=190280;c[j+4>>2]=306;c[j+8>>2]=0;tba(190280,j,307)}j=(c[190284>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Kc(4)|0;n=m;sla(n);o=205840;p=128;Zd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Kc(4)|0;n=m;sla(n);o=205840;p=128;Zd(m|0,o|0,p|0)}Ne[c[(c[k>>2]|0)+32>>2]&63](k,188824,188850|0,e)|0;e=c[d>>2]|0;if(!((c[47606]|0)==-1)){c[h>>2]=190424;c[h+4>>2]=306;c[h+8>>2]=0;tba(190424,h,307)}h=(c[190428>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}else{t=e;a[f]=oe[c[(c[e>>2]|0)+16>>2]&127](t)|0;me[c[(c[e>>2]|0)+20>>2]&127](b,t);_aa(c[d>>2]|0)|0;i=g;return}}function sfa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;Eca(l,d);d=l;l=c[d>>2]|0;if(!((c[47570]|0)==-1)){c[k>>2]=190280;c[k+4>>2]=306;c[k+8>>2]=0;tba(190280,k,307)}k=(c[190284>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Kc(4)|0;o=n;sla(o);p=205840;q=128;Zd(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Kc(4)|0;o=n;sla(o);p=205840;q=128;Zd(n|0,p|0,q|0)}Ne[c[(c[l>>2]|0)+32>>2]&63](l,188824,188856|0,e)|0;e=c[d>>2]|0;if(!((c[47606]|0)==-1)){c[j>>2]=190424;c[j+4>>2]=306;c[j+8>>2]=0;tba(190424,j,307)}j=(c[190428>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Kc(4)|0;s=r;sla(s);t=205840;u=128;Zd(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Kc(4)|0;s=r;sla(s);t=205840;u=128;Zd(r|0,t|0,u|0)}else{u=e;a[f]=oe[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=oe[c[(c[e>>2]|0)+16>>2]&127](u)|0;me[c[(c[e>>2]|0)+20>>2]&127](b,u);_aa(c[d>>2]|0)|0;i=h;return}}function tfa(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[188824+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function ufa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;Eca(j,b);b=j;j=c[b>>2]|0;if(!((c[47568]|0)==-1)){c[h>>2]=190272;c[h+4>>2]=306;c[h+8>>2]=0;tba(190272,h,307)}h=(c[190276>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Kc(4)|0;m=l;sla(m);n=205840;o=128;Zd(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Kc(4)|0;m=l;sla(m);n=205840;o=128;Zd(l|0,n|0,o|0)}Ne[c[(c[j>>2]|0)+48>>2]&63](j,188824,188850|0,d)|0;d=c[b>>2]|0;if(!((c[47608]|0)==-1)){c[g>>2]=190432;c[g+4>>2]=306;c[g+8>>2]=0;tba(190432,g,307)}g=(c[190436>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}else{s=d;c[e>>2]=oe[c[(c[d>>2]|0)+16>>2]&127](s)|0;me[c[(c[d>>2]|0)+20>>2]&127](a,s);_aa(c[b>>2]|0)|0;i=f;return}}function vfa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Eca(k,b);b=k;k=c[b>>2]|0;if(!((c[47568]|0)==-1)){c[j>>2]=190272;c[j+4>>2]=306;c[j+8>>2]=0;tba(190272,j,307)}j=(c[190276>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Kc(4)|0;n=m;sla(n);o=205840;p=128;Zd(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Kc(4)|0;n=m;sla(n);o=205840;p=128;Zd(m|0,o|0,p|0)}Ne[c[(c[k>>2]|0)+48>>2]&63](k,188824,188856|0,d)|0;d=c[b>>2]|0;if(!((c[47608]|0)==-1)){c[h>>2]=190432;c[h+4>>2]=306;c[h+8>>2]=0;tba(190432,h,307)}h=(c[190436>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}else{t=d;c[e>>2]=oe[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=oe[c[(c[d>>2]|0)+16>>2]&127](t)|0;me[c[(c[d>>2]|0)+20>>2]&127](a,t);_aa(c[b>>2]|0)|0;i=g;return}}function wfa(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[188824+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function xfa(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function yfa(a){a=a|0;i=i;return}function zfa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];xe[p&31](b,d,k,f,g,q);i=j;return}Eca(n,f);f=n;n=c[f>>2]|0;if(!((c[47606]|0)==-1)){c[l>>2]=190424;c[l+4>>2]=306;c[l+8>>2]=0;tba(190424,l,307)}l=(c[190428>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Kc(4)|0;u=t;sla(u);v=205840;w=128;Zd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Kc(4)|0;u=t;sla(u);v=205840;w=128;Zd(t|0,v|0,w|0)}w=n;_aa(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){me[c[f+24>>2]&127](o,w)}else{me[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((De[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];Iba(o);i=j;return}function Afa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=189072;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);x=c[47542]|0;c[k>>2]=h;h=Bfa(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Eca(q,f);Cfa(w,y,k,z,o,p,q);_aa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];e8(b,j,z,e,o,f,g);i=d;return}function Bfa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Rc(d|0)|0;d=sc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Rc(f|0)|0;i=g;return d|0}function Cfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[47570]|0)==-1)){c[m>>2]=190280;c[m+4>>2]=306;c[m+8>>2]=0;tba(190280,m,307)}m=(c[190284>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[47606]|0)==-1)){c[l>>2]=190424;c[l+4>>2]=306;c[l+8>>2]=0;tba(190424,l,307)}l=(c[190428>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Kc(4)|0;v=u;sla(v);w=205840;x=128;Zd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Kc(4)|0;v=u;sla(v);w=205840;x=128;Zd(u|0,w|0,x|0)}x=s;me[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ne[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=De[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=De[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=De[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=oe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=De[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;Iba(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;Iba(n);i=k;return}}function Dfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);w=c[47542]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=Bfa(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Eca(r,f);Cfa(x,z,l,A,p,q,r);_aa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];e8(b,k,A,e,p,f,g);i=d;return}function Efa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=189072;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);x=c[47542]|0;c[k>>2]=h;h=Bfa(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Eca(q,f);Cfa(w,y,k,z,o,p,q);_aa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];e8(b,j,z,e,o,f,g);i=d;return}function Ffa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);w=c[47542]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=Bfa(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Eca(r,f);Cfa(x,z,l,A,p,q,r);_aa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];e8(b,k,A,e,p,f,g);i=d;return}function Gfa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);r=c[47542]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Bfa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Bfa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[190176]|0)==0;if(F){do{if(o){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);r=c[47542]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Hfa(s,r,z,n)|0}else{do{if(o){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);o=c[47542]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Hfa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}_la()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Nla(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}_la()}}while(0);Eca(w,f);Ifa(N,L,G,P,u,v,w);_aa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];e8(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Ola(O)}if((J|0)==0){i=d;return}Ola(J);i=d;return}function Hfa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Rc(b|0)|0;b=pc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Rc(e|0)|0;i=f;return b|0}function Ifa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[47570]|0)==-1)){c[m>>2]=190280;c[m+4>>2]=306;c[m+8>>2]=0;tba(190280,m,307)}m=(c[190284>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[47606]|0)==-1)){c[l>>2]=190424;c[l+4>>2]=306;c[l+8>>2]=0;tba(190424,l,307)}l=(c[190428>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Kc(4)|0;v=u;sla(v);w=205840;x=128;Zd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Kc(4)|0;v=u;sla(v);w=205840;x=128;Zd(u|0,w|0,x|0)}x=s;me[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=De[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=De[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=De[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);w=A+1|0;if((cd(l<<24>>24|0,c[47542]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);l=D+1|0;if(($d(A<<24>>24|0,c[47542]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ne[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=oe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=De[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=De[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=oe[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);Ne[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;Iba(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;Iba(n);i=k;return}function Jfa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);r=c[47542]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Bfa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Bfa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[190176]|0)==0;if(F){do{if(o){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);r=c[47542]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Hfa(s,r,z,n)|0}else{do{if(o){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);o=c[47542]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Hfa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}_la()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Nla(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}_la()}}while(0);Eca(w,f);Ifa(N,L,G,P,u,v,w);_aa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];e8(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Ola(O)}if((J|0)==0){i=d;return}Ola(J);i=d;return}function Kfa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=189080;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);s=c[47542]|0;c[k>>2]=h;h=Bfa(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;Eca(p,f);r=p;p=c[r>>2]|0;if(!((c[47570]|0)==-1)){c[l>>2]=190280;c[l+4>>2]=306;c[l+8>>2]=0;tba(190280,l,307)}l=(c[190284>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}_aa(c[r>>2]|0)|0;Ne[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];e8(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];e8(b,j,u,z,m,f,g);I=j;i=d;return}function Lfa(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Mfa(a){a=a|0;i=i;return}function Nfa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];xe[p&31](b,d,k,f,g,q);i=j;return}Eca(n,f);f=n;n=c[f>>2]|0;if(!((c[47608]|0)==-1)){c[l>>2]=190432;c[l+4>>2]=306;c[l+8>>2]=0;tba(190432,l,307)}l=(c[190436>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Kc(4)|0;u=t;sla(u);v=205840;w=128;Zd(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Kc(4)|0;u=t;sla(u);v=205840;w=128;Zd(t|0,v|0,w|0)}w=n;_aa(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){me[c[f+24>>2]&127](o,w)}else{me[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=De[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];kca(o);i=j;return}function Ofa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=189072;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);x=c[47542]|0;c[k>>2]=h;h=Bfa(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Eca(q,f);Pfa(w,y,k,z,o,p,q);_aa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Qfa(b,j,z,e,o,f,g);i=d;return}function Pfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[47568]|0)==-1)){c[m>>2]=190272;c[m+4>>2]=306;c[m+8>>2]=0;tba(190272,m,307)}m=(c[190276>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[47608]|0)==-1)){c[l>>2]=190432;c[l+4>>2]=306;c[l+8>>2]=0;tba(190432,l,307)}l=(c[190436>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Kc(4)|0;v=u;sla(v);w=205840;x=128;Zd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Kc(4)|0;v=u;sla(v);w=205840;x=128;Zd(u|0,w|0,x|0)}x=s;me[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){Ne[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=De[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=De[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=De[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=oe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=De[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;Iba(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;Iba(n);i=k;return}function Qfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((re[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){jca(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((re[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){kca(l);break}c[m>>2]=0;c[b>>2]=0;kca(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((re[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function Rfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);y=c[47542]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Bfa(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Eca(r,f);Pfa(x,z,l,A,p,q,r);_aa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Qfa(b,k,A,e,p,f,g);i=d;return}function Sfa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=189072;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);v=c[47542]|0;c[k>>2]=h;h=Bfa(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Eca(q,f);Pfa(w,y,k,z,o,p,q);_aa(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Qfa(b,j,z,e,o,f,g);i=d;return}function Tfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);y=c[47542]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Bfa(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Eca(r,f);Pfa(x,z,l,A,p,q,r);_aa(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Qfa(b,k,A,e,p,f,g);i=d;return}function Ufa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);r=c[47542]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Bfa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Bfa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[190176]|0)==0;if(F){do{if(o){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);r=c[47542]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Hfa(s,r,z,n)|0}else{do{if(o){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);o=c[47542]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Hfa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}_la()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Nla(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}_la()}}while(0);Eca(w,f);Vfa(N,L,G,P,u,v,w);_aa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Qfa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Ola(O)}if((J|0)==0){i=d;return}Ola(J);i=d;return}function Vfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[47568]|0)==-1)){c[m>>2]=190272;c[m+4>>2]=306;c[m+8>>2]=0;tba(190272,m,307)}m=(c[190276>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Kc(4)|0;r=q;sla(r);s=205840;t=128;Zd(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[47608]|0)==-1)){c[l>>2]=190432;c[l+4>>2]=306;c[l+8>>2]=0;tba(190432,l,307)}l=(c[190436>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Kc(4)|0;v=u;sla(v);w=205840;x=128;Zd(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Kc(4)|0;v=u;sla(v);w=205840;x=128;Zd(u|0,w|0,x|0)}x=s;me[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=De[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=De[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=De[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);w=A+1|0;if((cd(l<<24>>24|0,c[47542]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);l=D+1|0;if(($d(A<<24>>24|0,c[47542]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){Ne[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=oe[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=De[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=De[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=oe[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);Ne[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;Iba(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;Iba(n);i=k;return}function Wfa(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);r=c[47542]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Bfa(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Bfa(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[190176]|0)==0;if(F){do{if(o){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);r=c[47542]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Hfa(s,r,z,n)|0}else{do{if(o){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);o=c[47542]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Hfa(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}_la()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Nla(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}_la()}}while(0);Eca(w,f);Vfa(N,L,G,P,u,v,w);_aa(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Qfa(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Ola(O)}if((J|0)==0){i=d;return}Ola(J);i=d;return}function Xfa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=189080;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);s=c[47542]|0;c[k>>2]=h;h=Bfa(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}Eca(p,f);u=p;p=c[u>>2]|0;if(!((c[47568]|0)==-1)){c[l>>2]=190272;c[l+4>>2]=306;c[l+8>>2]=0;tba(190272,l,307)}l=(c[190276>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}_aa(c[u>>2]|0)|0;u=o;Ne[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Qfa(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Qfa(b,j,u,z,m,f,g);I=j;i=d;return}function Yfa(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;Eca(r,h);v=r;r=c[v>>2]|0;if(!((c[47570]|0)==-1)){c[q>>2]=190280;c[q+4>>2]=306;c[q+8>>2]=0;tba(190280,q,307)}q=(c[190284>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Kc(4)|0;y=x;sla(y);z=205840;A=128;Zd(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Kc(4)|0;y=x;sla(y);z=205840;A=128;Zd(x|0,z|0,A|0)}A=r;_aa(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((oe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((oe[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((re[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(oe[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=De[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(De[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=re[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=re[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];Ce[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((oe[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((oe[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){oe[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){oe[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((oe[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((oe[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function Zfa(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function _fa(a){a=a|0;i=i;return}function $fa(a){a=a|0;i=i;return 2}function aga(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];Yfa(a,b,l,k,f,g,h,189184,189192|0);i=j;return}function bga(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=oe[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];Yfa(b,d,m,l,g,h,j,s,q);i=k;return}function cga(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Eca(n,f);f=n;n=c[f>>2]|0;if(!((c[47570]|0)==-1)){c[m>>2]=190280;c[m+4>>2]=306;c[m+8>>2]=0;tba(190280,m,307)}m=(c[190284>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}s=n;_aa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=oe[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=zea(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function dga(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Eca(n,f);f=n;n=c[f>>2]|0;if(!((c[47570]|0)==-1)){c[m>>2]=190280;c[m+4>>2]=306;c[m+8>>2]=0;tba(190280,m,307)}m=(c[190284>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}s=n;_aa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=oe[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=zea(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function ega(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Eca(m,f);f=m;m=c[f>>2]|0;if(!((c[47570]|0)==-1)){c[l>>2]=190280;c[l+4>>2]=306;c[l+8>>2]=0;tba(190280,l,307)}l=(c[190284>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Kc(4)|0;p=o;sla(p);q=205840;r=128;Zd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Kc(4)|0;p=o;sla(p);q=205840;r=128;Zd(o|0,q|0,r|0)}r=m;_aa(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=jga(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function fga(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Eca(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[47570]|0)==-1)){c[ba>>2]=190280;c[ba+4>>2]=306;c[ba+8>>2]=0;tba(190280,ba,307)}ba=(c[190284>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Kc(4)|0;Ga=Fa;sla(Ga);Ha=205840;Ia=128;Zd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Kc(4)|0;Ga=Fa;sla(Ga);Ha=205840;Ia=128;Zd(Fa|0,Ha|0,Ia|0)}Ia=ca;_aa(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];gga(0,e,C,h,Ia);break};case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Ha=oe[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(zea(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=jga(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ja=Da+2e3|0}else{Ja=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ja+ -1900;break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];Yfa(ja,d,J,I,g,h,j,189200,189208|0);c[Da>>2]=c[ja>>2];break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=jga(e,G,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=ca|4;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];iga(0,e,m,h,Ia);break};case 65:case 97:{Ha=c[f>>2]|0;Da=d+8|0;Fa=oe[c[c[Da>>2]>>2]&127](Da)|0;c[aa>>2]=Ha;c[Q+0>>2]=c[aa+0>>2];Ha=(zea(e,Q,Fa,Fa+168|0,Ia,h,0)|0)-Fa|0;if((Ha|0)>=168){break a}c[j+24>>2]=((Ha|0)/12|0|0)%7|0;break};case 88:{Ha=d+8|0;Fa=oe[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];Da=a[Fa]|0;if((Da&1)==0){Ka=Fa+1|0;La=Fa+1|0;Ma=(Da&255)>>>1}else{Da=c[Fa+8>>2]|0;Ka=Da;La=Da;Ma=c[Fa+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];Yfa(za,d,q,p,g,h,j,La,Ka+Ma|0);c[Ha>>2]=c[za>>2];break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Ha=jga(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Ha+ -1900;break};case 120:{Ha=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];Ae[Ha&63](b,d,s,r,g,h,j);i=l;return};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Ha=jga(e,w,h,Ia,2)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(Ha|0)<61){c[j>>2]=Ha;break a}else{c[h>>2]=Fa|4;break a}break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Fa=jga(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Fa|0)<366){c[j+28>>2]=Fa;break a}else{c[h>>2]=Ha|4;break a}break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=jga(e,E,h,Ia,2)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=Fa|4;break a}break};case 101:case 100:{Fa=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Ha=jga(e,M,h,Ia,2)|0;Da=c[h>>2]|0;do{if((Da&4|0)==0){if(!((Ha+ -1|0)>>>0<31)){break}c[Fa>>2]=Ha;break a}}while(0);c[h>>2]=Da|4;break};case 68:{Ha=e;c[ha>>2]=c[Ha>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];Yfa(ga,d,L,K,g,h,j,189192,189200|0);c[Ha>>2]=c[ga>>2];break};case 82:{Ha=e;c[sa>>2]=c[Ha>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];Yfa(ra,d,y,x,g,h,j,189224,189229|0);c[Ha>>2]=c[ra>>2];break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];Yfa(ua,d,v,u,g,h,j,189232,189240|0);c[Ha>>2]=c[ua>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Ha=jga(e,t,h,Ia,1)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(Ha|0)<7){c[j+24>>2]=Ha;break a}else{c[h>>2]=Fa|4;break a}break};case 99:{Fa=d+8|0;Ha=oe[c[(c[Fa>>2]|0)+12>>2]&127](Fa)|0;Fa=e;c[ea>>2]=c[Fa>>2];c[fa>>2]=c[f>>2];ca=a[Ha]|0;if((ca&1)==0){Na=Ha+1|0;Oa=Ha+1|0;Pa=(ca&255)>>>1}else{ca=c[Ha+8>>2]|0;Na=ca;Oa=ca;Pa=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];Yfa(da,d,O,N,g,h,j,Oa,Na+Pa|0);c[Fa>>2]=c[da>>2];break};case 114:{Fa=e;c[pa>>2]=c[Fa>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];Yfa(oa,d,A,z,g,h,j,189208,189219|0);c[Fa>>2]=c[oa>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];hga(d,j+8|0,e,B,h,Ia);break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];Fa=jga(e,H,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Fa|0)<24){c[j+8>>2]=Fa;break a}else{c[h>>2]=Ha|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=jga(e,D,h,Ia,2)|0;Fa=c[h>>2]|0;if((Fa&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=Fa|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function gga(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((oe[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){oe[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((oe[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((oe[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function hga(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=oe[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=zea(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function iga(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((oe[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(oe[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((re[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){oe[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((oe[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function jga(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((oe[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(oe[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(re[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){oe[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((oe[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((oe[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((re[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){oe[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((oe[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((oe[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function kga(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;Eca(p,f);t=p;p=c[t>>2]|0;if(!((c[47568]|0)==-1)){c[o>>2]=190272;c[o+4>>2]=306;c[o+8>>2]=0;tba(190272,o,307)}o=(c[190276>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Kc(4)|0;w=v;sla(w);x=205840;y=128;Zd(v|0,x|0,y|0)}y=p;_aa(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((re[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(re[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=oe[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=De[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(De[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=re[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=re[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];Ce[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(re[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=oe[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=oe[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(re[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){oe[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){oe[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=oe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function lga(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function mga(a){a=a|0;i=i;return}function nga(a){a=a|0;i=i;return 2}function oga(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];kga(a,b,l,k,f,g,h,189336,189368|0);i=j;return}function pga(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=oe[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];kga(b,d,m,l,g,h,j,s,q);i=k;return}function qga(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Eca(n,f);f=n;n=c[f>>2]|0;if(!((c[47568]|0)==-1)){c[m>>2]=190272;c[m+4>>2]=306;c[m+8>>2]=0;tba(190272,m,307)}m=(c[190276>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}s=n;_aa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=oe[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Yea(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function rga(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Eca(n,f);f=n;n=c[f>>2]|0;if(!((c[47568]|0)==-1)){c[m>>2]=190272;c[m+4>>2]=306;c[m+8>>2]=0;tba(190272,m,307)}m=(c[190276>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Kc(4)|0;q=p;sla(q);r=205840;s=128;Zd(p|0,r|0,s|0)}s=n;_aa(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=oe[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Yea(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function sga(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Eca(m,f);f=m;m=c[f>>2]|0;if(!((c[47568]|0)==-1)){c[l>>2]=190272;c[l+4>>2]=306;c[l+8>>2]=0;tba(190272,l,307)}l=(c[190276>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Kc(4)|0;p=o;sla(p);q=205840;r=128;Zd(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Kc(4)|0;p=o;sla(p);q=205840;r=128;Zd(o|0,q|0,r|0)}r=m;_aa(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=xga(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function tga(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Eca(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[47568]|0)==-1)){c[ba>>2]=190272;c[ba+4>>2]=306;c[ba+8>>2]=0;tba(190272,ba,307)}ba=(c[190276>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Kc(4)|0;Ga=Fa;sla(Ga);Ha=205840;Ia=128;Zd(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Kc(4)|0;Ga=Fa;sla(Ga);Ha=205840;Ia=128;Zd(Fa|0,Ha|0,Ia|0)}Ia=ca;_aa(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 88:{Da=d+8|0;ca=oe[c[(c[Da>>2]|0)+24>>2]&127](Da)|0;Da=e;c[Aa>>2]=c[Da>>2];c[Ba>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ja=ca+4|0;Ka=ca+4|0;La=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ja=Ha;Ka=Ha;La=c[ca+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];kga(za,d,q,p,g,h,j,Ka,Ja+(La<<2)|0);c[Da>>2]=c[za>>2];break};case 104:case 66:case 98:{Da=c[f>>2]|0;ca=d+8|0;Ha=oe[c[(c[ca>>2]|0)+4>>2]&127](ca)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(Yea(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=xga(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Ma=Da+2e3|0}else{Ma=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Ma+ -1900;break};case 65:case 97:{Da=c[f>>2]|0;Ha=d+8|0;ca=oe[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(Yea(e,Q,ca,ca+168|0,Ia,h,0)|0)-ca|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];kga(ja,d,J,I,g,h,j,189400,189432|0);c[Da>>2]=c[ja>>2];break};case 99:{Da=d+8|0;ca=oe[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Na=ca+4|0;Oa=ca+4|0;Pa=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];kga(da,d,O,N,g,h,j,Oa,Na+(Pa<<2)|0);c[Da>>2]=c[da>>2];break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=xga(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];uga(0,e,C,h,Ia);break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];wga(0,e,m,h,Ia);break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=xga(e,E,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Da|4;break a}break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=xga(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];Ae[Da&63](b,d,s,r,g,h,j);i=l;return};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=xga(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];kga(ra,d,y,x,g,h,j,189480,189500|0);c[ca>>2]=c[ra>>2];break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=xga(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];kga(ga,d,L,K,g,h,j,189368,189400|0);c[Da>>2]=c[ga>>2];break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];kga(ua,d,v,u,g,h,j,189504,189536|0);c[Da>>2]=c[ua>>2];break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];Da=xga(e,t,h,Ia,1)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<7){c[j+24>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];kga(oa,d,A,z,g,h,j,189432,189476|0);c[ca>>2]=c[oa>>2];break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];vga(d,j+8|0,e,B,h,Ia);break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=xga(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=xga(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 73:{ca=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Da=xga(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<12)){break}c[ca>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function uga(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(re[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){oe[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=oe[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=oe[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function vga(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=oe[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=Yea(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}



function wga(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=oe[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=oe[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((re[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){oe[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=oe[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=oe[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function xga(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=oe[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=oe[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=oe[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(re[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(re[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){oe[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=oe[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=oe[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(re[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((re[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){oe[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=oe[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=oe[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function yga(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);if((f|0)==(c[47542]|0)){g=b;Vla(g);i=d;return}dc(c[e>>2]|0);g=b;Vla(g);i=d;return}function zga(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);if((b|0)==(c[47542]|0)){i=d;return}dc(c[e>>2]|0);i=d;return}function Aga(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Yc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(De[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function Bga(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);if((f|0)==(c[47542]|0)){g=b;Vla(g);i=d;return}dc(c[e>>2]|0);g=b;Vla(g);i=d;return}function Cga(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);if((b|0)==(c[47542]|0)){i=d;return}dc(c[e>>2]|0);i=d;return}function Dga(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;Ega(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=De[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function Ega(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Yc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Rc(c[g>>2]|0)|0;g=Qka(d,m,n,l)|0;if((f|0)!=0){Rc(f|0)|0}if((g|0)==-1){Aha(191160)}else{c[e>>2]=d+(g<<2);i=j;return}}function Fga(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Gga(a){a=a|0;i=i;return}function Hga(a){a=a|0;i=i;return 127}function Iga(a){a=a|0;i=i;return 127}function Jga(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Kga(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Lga(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Mga(a,b){a=a|0;b=b|0;b=i;Eba(a,1,45);i=b;return}function Nga(a){a=a|0;i=i;return 0}function Oga(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Pga(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Qga(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Rga(a){a=a|0;i=i;return}function Sga(a){a=a|0;i=i;return 127}function Tga(a){a=a|0;i=i;return 127}function Uga(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Vga(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Wga(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Xga(a,b){a=a|0;b=b|0;b=i;Eba(a,1,45);i=b;return}function Yga(a){a=a|0;i=i;return 0}function Zga(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function _ga(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function $ga(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function aha(a){a=a|0;i=i;return}function bha(a){a=a|0;i=i;return 2147483647}function cha(a){a=a|0;i=i;return 2147483647}function dha(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function eha(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function fha(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function gha(a,b){a=a|0;b=b|0;b=i;jca(a,1,45);i=b;return}function hha(a){a=a|0;i=i;return 0}function iha(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function jha(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function kha(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function lha(a){a=a|0;i=i;return}function mha(a){a=a|0;i=i;return 2147483647}function nha(a){a=a|0;i=i;return 2147483647}function oha(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function pha(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function qha(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function rha(a,b){a=a|0;b=b|0;b=i;jca(a,1,45);i=b;return}function sha(a){a=a|0;i=i;return 0}function tha(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function uha(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function vha(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function wha(a){a=a|0;i=i;return}function xha(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=308;y=o+100|0;Eca(r,h);o=r;z=c[o>>2]|0;if(!((c[47570]|0)==-1)){c[n>>2]=190280;c[n+4>>2]=306;c[n+8>>2]=0;tba(190280,n,307)}n=(c[190284>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Kc(4)|0;C=B;sla(C);D=205840;E=128;Zd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Kc(4)|0;C=B;sla(C);D=205840;E=128;Zd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=zha(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ne[c[(c[z>>2]|0)+32>>2]&63](E,189896,189906|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=Nla(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}_la()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[189896+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Cd(p|0,189912,m|0)|0)!=1){t=Kc(8)|0;eba(t,189920);Zd(t|0,187272,43)}if((F|0)==0){break}Ola(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;_aa(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}le[c[x>>2]&511](o);i=d;return}function yha(a){a=a|0;i=i;return}function zha(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Dha(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=308;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((oe[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=(oe[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=(oe[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}_ba(A,ea);X=26;break};case 3:{da=a[y]|0;W=(da&1)==0;if(W){fa=(da&255)>>>1}else{fa=c[G>>2]|0}ba=a[z]|0;ga=(ba&1)==0;if(ga){ha=(ba&255)>>>1}else{ha=c[g>>2]|0}if((fa|0)==(0-ha|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}if(W){oa=(da&255)>>>1}else{oa=c[G>>2]|0}do{if((oa|0)!=0){if(ga){pa=(ba&255)>>>1}else{pa=c[g>>2]|0}if((pa|0)==0){break}qa=c[h>>2]|0;ra=c[qa+12>>2]|0;sa=c[qa+16>>2]|0;if((ra|0)==(sa|0)){ta=(oe[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255;ua=c[h>>2]|0;va=ta;wa=c[ua+16>>2]|0;xa=c[ua+12>>2]|0;ya=ua;za=a[y]|0}else{va=a[ra]|0;wa=sa;xa=ra;ya=qa;za=da}qa=ya+12|0;ra=(xa|0)==(wa|0);if(va<<24>>24==(a[(za&1)==0?F:c[H>>2]|0]|0)){if(ra){oe[c[(c[ya>>2]|0)+40>>2]&127](ya)|0}else{c[qa>>2]=xa+1}qa=a[y]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Aa>>>0>1?y:S;na=T;break b}if(ra){Ba=(oe[c[(c[ya>>2]|0)+36>>2]&127](ya)|0)&255}else{Ba=a[xa]|0}if(!(Ba<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}ra=c[h>>2]|0;qa=ra+12|0;sa=c[qa>>2]|0;if((sa|0)==(c[ra+16>>2]|0)){oe[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[qa>>2]=sa+1}a[l]=1;sa=a[z]|0;if((sa&1)==0){Ca=(sa&255)>>>1}else{Ca=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ca>>>0>1?z:S;na=T;break b}}while(0);if(W){Da=(da&255)>>>1}else{Da=c[G>>2]|0}ga=c[h>>2]|0;sa=c[ga+12>>2]|0;qa=(sa|0)==(c[ga+16>>2]|0);if((Da|0)==0){if(qa){ra=(oe[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ea=ra;Fa=a[z]|0}else{Ea=a[sa]|0;Fa=ba}if(!(Ea<<24>>24==(a[(Fa&1)==0?m:c[E>>2]|0]|0))){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}ra=c[h>>2]|0;ua=ra+12|0;ta=c[ua>>2]|0;if((ta|0)==(c[ra+16>>2]|0)){oe[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[ua>>2]=ta+1}a[l]=1;ta=a[z]|0;if((ta&1)==0){Ga=(ta&255)>>>1}else{Ga=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ga>>>0>1?z:S;na=T;break b}if(qa){qa=(oe[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ha=qa;Ia=a[y]|0}else{Ha=a[sa]|0;Ia=da}if(!(Ha<<24>>24==(a[(Ia&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}sa=c[h>>2]|0;qa=sa+12|0;ga=c[qa>>2]|0;if((ga|0)==(c[sa+16>>2]|0)){oe[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[qa>>2]=ga+1}ga=a[y]|0;if((ga&1)==0){Ja=(ga&255)>>>1}else{Ja=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ja>>>0>1?y:S;na=T;break};case 4:{ga=D;qa=R;sa=r;ta=Q;ua=0;ra=T;c:while(1){Ka=c[h>>2]|0;do{if((Ka|0)==0){La=0}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){La=Ka;break}if((oe[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[h>>2]=0;La=0;break}else{La=c[h>>2]|0;break}}}while(0);Ka=(La|0)==0;Ma=c[e>>2]|0;do{if((Ma|0)==0){X=173}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(Ka){break}else{break c}}if((oe[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ka){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(Ka){break}}Ma=c[h>>2]|0;Na=c[Ma+12>>2]|0;if((Na|0)==(c[Ma+16>>2]|0)){Oa=(oe[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)&255}else{Oa=a[Na]|0}do{if(Oa<<24>>24>-1){if((b[(c[f>>2]|0)+(Oa<<24>>24<<1)>>1]&2048)==0){X=189;break}Na=c[o>>2]|0;if((Na|0)==(ga|0)){Ma=(c[P>>2]|0)!=308;Pa=c[t>>2]|0;Qa=ga-Pa|0;Ra=Qa>>>0<2147483647?Qa<<1:-1;Sa=Qla(Ma?Pa:0,Ra)|0;if((Sa|0)==0){X=182;break a}do{if(Ma){c[t>>2]=Sa;Ta=Sa}else{Pa=c[t>>2]|0;c[t>>2]=Sa;if((Pa|0)==0){Ta=Sa;break}le[c[P>>2]&511](Pa);Ta=c[t>>2]|0}}while(0);c[P>>2]=283;Sa=Ta+Qa|0;c[o>>2]=Sa;Ua=Sa;Va=(c[t>>2]|0)+Ra|0}else{Ua=Na;Va=ga}c[o>>2]=Ua+1;a[Ua]=Oa;Wa=Va;Xa=qa;Ya=sa;Za=ta;_a=ua+1|0;$a=ra}else{X=189}}while(0);if((X|0)==189){X=0;Ka=a[w]|0;if((Ka&1)==0){ab=(Ka&255)>>>1}else{ab=c[n>>2]|0}if((ab|0)==0|(ua|0)==0){break}if(!(Oa<<24>>24==(a[v]|0))){break}if((sa|0)==(ta|0)){Ka=sa-qa|0;Sa=Ka>>>0<2147483647?Ka<<1:-1;if((ra|0)==308){bb=0}else{bb=qa}Ma=Qla(bb,Sa)|0;if((Ma|0)==0){X=198;break a}cb=Ma;db=Ma+(Ka>>2<<2)|0;eb=Ma+(Sa>>>2<<2)|0;fb=283}else{cb=qa;db=sa;eb=ta;fb=ra}c[db>>2]=ua;Wa=ga;Xa=cb;Ya=db+4|0;Za=eb;_a=0;$a=fb}Sa=c[h>>2]|0;Ma=Sa+12|0;Ka=c[Ma>>2]|0;if((Ka|0)==(c[Sa+16>>2]|0)){oe[c[(c[Sa>>2]|0)+40>>2]&127](Sa)|0;ga=Wa;qa=Xa;sa=Ya;ta=Za;ua=_a;ra=$a;continue}else{c[Ma>>2]=Ka+1;ga=Wa;qa=Xa;sa=Ya;ta=Za;ua=_a;ra=$a;continue}}if((qa|0)==(sa|0)|(ua|0)==0){gb=qa;hb=sa;ib=ta;jb=ra}else{if((sa|0)==(ta|0)){da=sa-qa|0;ba=da>>>0<2147483647?da<<1:-1;if((ra|0)==308){kb=0}else{kb=qa}W=Qla(kb,ba)|0;if((W|0)==0){X=209;break a}lb=W;mb=W+(da>>2<<2)|0;nb=W+(ba>>>2<<2)|0;ob=283}else{lb=qa;mb=sa;nb=ta;ob=ra}c[mb>>2]=ua;gb=lb;hb=mb+4|0;ib=nb;jb=ob}if((c[B>>2]|0)>0){ba=c[h>>2]|0;do{if((ba|0)==0){pb=0}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){pb=ba;break}if((oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[h>>2]=0;pb=0;break}else{pb=c[h>>2]|0;break}}}while(0);ba=(pb|0)==0;ua=c[e>>2]|0;do{if((ua|0)==0){X=223}else{if((c[ua+12>>2]|0)!=(c[ua+16>>2]|0)){if(ba){qb=ua;break}else{X=229;break a}}if((oe[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)==-1){c[e>>2]=0;X=223;break}else{if(ba){qb=ua;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ba){X=229;break a}else{qb=0}}ua=c[h>>2]|0;ra=c[ua+12>>2]|0;if((ra|0)==(c[ua+16>>2]|0)){rb=(oe[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)&255}else{rb=a[ra]|0}if(!(rb<<24>>24==(a[u]|0))){X=229;break a}ra=c[h>>2]|0;ua=ra+12|0;ta=c[ua>>2]|0;if((ta|0)==(c[ra+16>>2]|0)){oe[c[(c[ra>>2]|0)+40>>2]&127](ra)|0;sb=qb;tb=qb;ub=ga}else{c[ua>>2]=ta+1;sb=qb;tb=qb;ub=ga}while(1){ta=c[h>>2]|0;do{if((ta|0)==0){vb=0}else{if((c[ta+12>>2]|0)!=(c[ta+16>>2]|0)){vb=ta;break}if((oe[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)==-1){c[h>>2]=0;vb=0;break}else{vb=c[h>>2]|0;break}}}while(0);ta=(vb|0)==0;do{if((tb|0)==0){wb=sb;X=243}else{if((c[tb+12>>2]|0)!=(c[tb+16>>2]|0)){if(ta){xb=sb;yb=tb;break}else{X=250;break a}}if((oe[c[(c[tb>>2]|0)+36>>2]&127](tb)|0)==-1){c[e>>2]=0;wb=0;X=243;break}else{if(ta^(sb|0)==0){xb=sb;yb=sb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ta){X=250;break a}else{xb=wb;yb=0}}ua=c[h>>2]|0;ra=c[ua+12>>2]|0;if((ra|0)==(c[ua+16>>2]|0)){zb=(oe[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)&255}else{zb=a[ra]|0}if(!(zb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(zb<<24>>24<<1)>>1]&2048)==0){X=250;break a}ra=c[o>>2]|0;if((ra|0)==(ub|0)){ua=(c[P>>2]|0)!=308;sa=c[t>>2]|0;qa=ub-sa|0;W=qa>>>0<2147483647?qa<<1:-1;da=Qla(ua?sa:0,W)|0;if((da|0)==0){X=253;break a}do{if(ua){c[t>>2]=da;Ab=da}else{sa=c[t>>2]|0;c[t>>2]=da;if((sa|0)==0){Ab=da;break}le[c[P>>2]&511](sa);Ab=c[t>>2]|0}}while(0);c[P>>2]=283;da=Ab+qa|0;c[o>>2]=da;Bb=da;Cb=(c[t>>2]|0)+W|0}else{Bb=ra;Cb=ub}da=c[h>>2]|0;ua=c[da+12>>2]|0;if((ua|0)==(c[da+16>>2]|0)){ta=(oe[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255;Db=ta;Eb=c[o>>2]|0}else{Db=a[ua]|0;Eb=Bb}c[o>>2]=Eb+1;a[Eb]=Db;ua=(c[B>>2]|0)+ -1|0;c[B>>2]=ua;ta=c[h>>2]|0;da=ta+12|0;sa=c[da>>2]|0;if((sa|0)==(c[ta+16>>2]|0)){oe[c[(c[ta>>2]|0)+40>>2]&127](ta)|0}else{c[da>>2]=sa+1}if((ua|0)>0){sb=xb;tb=yb;ub=Cb}else{Fb=Cb;break}}}else{Fb=ga}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ia=Fb;ja=gb;ka=hb;la=ib;ma=S;na=jb}break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Gb=(a[O]|0)!=0}else{Gb=0}if(!(I|Gb)){ia=D;ja=R;ka=r;la=Q;ma=0;na=T;break b}}ba=a[x]|0;ua=(ba&1)==0;sa=ua?j:c[J>>2]|0;d:do{if((p|0)==0){Hb=Y;Ib=Y;Jb=ba;Kb=sa}else{if((d[s+(p+ -1)|0]|0)>=2){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break}da=sa+(ua?(ba&255)>>>1:c[K>>2]|0)|0;ta=sa;while(1){if((ta|0)==(da|0)){Lb=da;break}Ka=a[ta]|0;if(!(Ka<<24>>24>-1)){Lb=ta;break}if((b[(c[f>>2]|0)+(Ka<<24>>24<<1)>>1]&8192)==0){Lb=ta;break}else{ta=ta+1|0}}ta=Lb-sa|0;da=a[A]|0;ra=(da&1)==0;if(ra){Mb=(da&255)>>>1}else{Mb=c[N>>2]|0}if(ta>>>0>Mb>>>0){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break}if(ra){ra=(da&255)>>>1;Nb=A+1+(ra-ta)|0;Ob=L;Pb=ra}else{ra=c[M>>2]|0;da=c[N>>2]|0;Nb=ra+(da-ta)|0;Ob=ra;Pb=da}da=Ob+Pb|0;if((Nb|0)==(da|0)){Hb=Y;Ib=Y;Jb=ba;Kb=Lb;break}else{Qb=sa;Rb=Nb}while(1){if((a[Rb]|0)!=(a[Qb]|0)){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break d}ra=Rb+1|0;if((ra|0)==(da|0)){Hb=Y;Ib=Y;Jb=ba;Kb=Lb;break}else{Qb=Qb+1|0;Rb=ra}}}}while(0);e:while(1){if((Jb&1)==0){Sb=j;Tb=(Jb&255)>>>1}else{Sb=c[J>>2]|0;Tb=c[K>>2]|0}if((Kb|0)==(Sb+Tb|0)){break}ba=c[h>>2]|0;do{if((ba|0)==0){Ub=0}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){Ub=ba;break}if((oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[h>>2]=0;Ub=0;break}else{Ub=c[h>>2]|0;break}}}while(0);ba=(Ub|0)==0;do{if((Ib|0)==0){Vb=Hb;X=147}else{if((c[Ib+12>>2]|0)!=(c[Ib+16>>2]|0)){if(ba){Wb=Hb;Xb=Ib;break}else{break e}}if((oe[c[(c[Ib>>2]|0)+36>>2]&127](Ib)|0)==-1){c[e>>2]=0;Vb=0;X=147;break}else{if(ba^(Hb|0)==0){Wb=Hb;Xb=Hb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(ba){break}else{Wb=Vb;Xb=0}}sa=c[h>>2]|0;ua=c[sa+12>>2]|0;if((ua|0)==(c[sa+16>>2]|0)){Yb=(oe[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{Yb=a[ua]|0}if(!(Yb<<24>>24==(a[Kb]|0))){break}ua=c[h>>2]|0;sa=ua+12|0;ga=c[sa>>2]|0;if((ga|0)==(c[ua+16>>2]|0)){oe[c[(c[ua>>2]|0)+40>>2]&127](ua)|0}else{c[sa>>2]=ga+1}Hb=Wb;Ib=Xb;Jb=a[x]|0;Kb=Kb+1|0}if(!I){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}ga=a[x]|0;if((ga&1)==0){Zb=j;_b=(ga&255)>>>1}else{Zb=c[J>>2]|0;_b=c[K>>2]|0}if((Kb|0)==(Zb+_b|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T}else{X=162;break a}break};case 0:{X=26;break};default:{ia=D;ja=R;ka=r;la=Q;ma=S;na=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}if((oe[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}else{dc=cc;ec=0}}ba=c[h>>2]|0;ga=c[ba+12>>2]|0;if((ga|0)==(c[ba+16>>2]|0)){fc=(oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{fc=a[ga]|0}if(!(fc<<24>>24>-1)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}ga=c[h>>2]|0;ba=ga+12|0;sa=c[ba>>2]|0;if((sa|0)==(c[ga+16>>2]|0)){gc=(oe[c[(c[ga>>2]|0)+40>>2]&127](ga)|0)&255}else{c[ba>>2]=sa+1;gc=a[sa]|0}_ba(A,gc);$b=dc;ac=ec}}}while(0);sa=p+1|0;if(sa>>>0<4){Q=la;r=ka;R=ja;D=ia;p=sa;S=ma;T=na}else{Z=ja;_=ka;$=ma;aa=na;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){_la()}else if((X|0)==198){_la()}else if((X|0)==209){_la()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==253){_la()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==269){h:do{if(($|0)!=0){na=$+1|0;ma=$+8|0;ka=$+4|0;ja=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ka>>2]|0}if(!(ja>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((oe[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(oe[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=na}else{nc=c[ma>>2]|0}if(!(mc<<24>>24==(a[nc+ja|0]|0))){break}p=ja+1|0;U=c[h>>2]|0;ia=U+12|0;D=c[ia>>2]|0;if((D|0)==(c[U+16>>2]|0)){oe[c[(c[U>>2]|0)+40>>2]&127](U)|0;ja=p;continue}else{c[ia>>2]=D+1;ja=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;Eha(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);Iba(A);Iba(z);Iba(y);Iba(x);Iba(w);if((ic|0)==0){i=q;return hc|0}le[jc&511](ic);i=q;return hc|0}function Aha(a){a=a|0;var b=0;b=Kc(8)|0;eba(b,a);Zd(b|0,187272,43)}function Bha(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=308;v=n+100|0;Eca(q,h);n=q;w=c[n>>2]|0;if(!((c[47570]|0)==-1)){c[m>>2]=190280;c[m+4>>2]=306;c[m+8>>2]=0;tba(190280,m,307)}m=(c[190284>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Kc(4)|0;z=y;sla(z);A=205840;B=128;Zd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Kc(4)|0;z=y;sla(z);A=205840;B=128;Zd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=zha(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){_ba(k,De[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=De[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Cha(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((oe[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((oe[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;_aa(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}le[c[u>>2]&511](n);i=d;return}function Cha(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){bca(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function Dha(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[47430]|0)==-1)){c[p>>2]=189720;c[p+4>>2]=306;c[p+8>>2]=0;tba(189720,p,307)}p=(c[189724>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Kc(4)|0;C=B;sla(C);D=205840;E=128;Zd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Kc(4)|0;C=B;sla(C);D=205840;E=128;Zd(B|0,D|0,E|0)}E=b;me[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;me[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Uba(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Iba(r);me[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Uba(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Iba(s);a[f]=oe[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=oe[c[(c[b>>2]|0)+16>>2]&127](E)|0;me[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Uba(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Iba(t);me[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Uba(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Iba(u);F=oe[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[47414]|0)==-1)){c[o>>2]=189656;c[o+4>>2]=306;c[o+8>>2]=0;tba(189656,o,307)}o=(c[189660>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Kc(4)|0;H=G;sla(H);I=205840;J=128;Zd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Kc(4)|0;H=G;sla(H);I=205840;J=128;Zd(G|0,I|0,J|0)}J=E;me[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;me[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Uba(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Iba(w);me[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Uba(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Iba(x);a[f]=oe[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=oe[c[(c[E>>2]|0)+16>>2]&127](J)|0;me[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Uba(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Iba(y);me[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Uba(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Iba(z);F=oe[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Eha(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function Fha(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Gha(a){a=a|0;i=i;return}function Hha(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=308;y=o+400|0;Eca(r,h);o=r;z=c[o>>2]|0;if(!((c[47568]|0)==-1)){c[n>>2]=190272;c[n+4>>2]=306;c[n+8>>2]=0;tba(190272,n,307)}n=(c[190276>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Kc(4)|0;C=B;sla(C);D=205840;E=128;Zd(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Kc(4)|0;C=B;sla(C);D=205840;E=128;Zd(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Iha(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;Ne[c[(c[z>>2]|0)+48>>2]&63](E,189976,189986|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=Nla((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}_la()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[189976+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((Cd(p|0,189912,m|0)|0)!=1){t=Kc(8)|0;eba(t,189920);Zd(t|0,187272,43)}if((F|0)==0){break}Ola(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=oe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=oe[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];_aa(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}le[c[x>>2]&511](o);i=d;return}function Iha(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Lha(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=308;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=oe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=oe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}P=c[g>>2]|0;R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){_=oe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{_=c[R>>2]|0}if(!(re[c[(c[l>>2]|0)+12>>2]&63](l,8192,_)|0)){T=27;break a}R=c[g>>2]|0;P=R+12|0;$=c[P>>2]|0;if(($|0)==(c[R+16>>2]|0)){aa=oe[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=$+4;aa=c[$>>2]|0}oca(A,aa);T=28;break};case 0:{T=28;break};case 4:{$=M;P=r;R=L;ba=0;ca=O;c:while(1){da=c[g>>2]|0;do{if((da|0)==0){ea=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ga=oe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ga=c[fa>>2]|0}if((ga|0)==-1){c[g>>2]=0;ea=1;break}else{ea=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=188}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ha=oe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ha=c[fa>>2]|0}if((ha|0)==-1){c[b>>2]=0;T=188;break}else{if(ea){break}else{break c}}}}while(0);if((T|0)==188){T=0;if(ea){break}}da=c[g>>2]|0;fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){ia=oe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{ia=c[fa>>2]|0}if(re[c[(c[l>>2]|0)+12>>2]&63](l,2048,ia)|0){fa=c[n>>2]|0;if((fa|0)==(c[q>>2]|0)){Mha(m,n,q);ja=c[n>>2]|0}else{ja=fa}c[n>>2]=ja+4;c[ja>>2]=ia;ka=$;la=P;ma=R;na=ba+1|0;oa=ca}else{fa=a[w]|0;if((fa&1)==0){pa=(fa&255)>>>1}else{pa=c[K>>2]|0}if((pa|0)==0|(ba|0)==0){break}if((ia|0)!=(c[v>>2]|0)){break}if((P|0)==(R|0)){fa=P-$|0;da=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=308){qa=$}else{qa=0}ra=Qla(qa,da)|0;if((ra|0)==0){T=206;break a}sa=ra;ta=ra+(fa>>2<<2)|0;ua=ra+(da>>>2<<2)|0;va=283}else{sa=$;ta=P;ua=R;va=ca}c[ta>>2]=ba;ka=sa;la=ta+4|0;ma=ua;na=0;oa=va}da=c[g>>2]|0;ra=da+12|0;fa=c[ra>>2]|0;if((fa|0)==(c[da+16>>2]|0)){oe[c[(c[da>>2]|0)+40>>2]&127](da)|0;$=ka;P=la;R=ma;ba=na;ca=oa;continue}else{c[ra>>2]=fa+4;$=ka;P=la;R=ma;ba=na;ca=oa;continue}}if(($|0)==(P|0)|(ba|0)==0){wa=$;xa=P;ya=R;za=ca}else{if((P|0)==(R|0)){fa=P-$|0;ra=fa>>>0<2147483647?fa<<1:-1;if((ca|0)!=308){Aa=$}else{Aa=0}da=Qla(Aa,ra)|0;if((da|0)==0){T=217;break a}Ba=da;Ca=da+(fa>>2<<2)|0;Da=da+(ra>>>2<<2)|0;Ea=283}else{Ba=$;Ca=P;Da=R;Ea=ca}c[Ca>>2]=ba;wa=Ba;xa=Ca+4|0;ya=Da;za=Ea}ra=c[B>>2]|0;if((ra|0)>0){da=c[g>>2]|0;do{if((da|0)==0){Fa=1}else{fa=c[da+12>>2]|0;if((fa|0)==(c[da+16>>2]|0)){Ga=oe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ga=c[fa>>2]|0}if((Ga|0)==-1){c[g>>2]=0;Fa=1;break}else{Fa=(c[g>>2]|0)==0;break}}}while(0);da=c[b>>2]|0;do{if((da|0)==0){T=234}else{ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ha=oe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ha=c[ba>>2]|0}if((Ha|0)==-1){c[b>>2]=0;T=234;break}else{if(Fa){Ia=da;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Fa){T=240;break a}else{Ia=0}}da=c[g>>2]|0;ba=c[da+12>>2]|0;if((ba|0)==(c[da+16>>2]|0)){Ja=oe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ja=c[ba>>2]|0}if((Ja|0)!=(c[u>>2]|0)){T=240;break a}ba=c[g>>2]|0;da=ba+12|0;ca=c[da>>2]|0;if((ca|0)==(c[ba+16>>2]|0)){oe[c[(c[ba>>2]|0)+40>>2]&127](ba)|0;Ka=Ia;La=ra;Ma=Ia}else{c[da>>2]=ca+4;Ka=Ia;La=ra;Ma=Ia}while(1){ca=c[g>>2]|0;do{if((ca|0)==0){Na=1}else{da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Oa=oe[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Oa=c[da>>2]|0}if((Oa|0)==-1){c[g>>2]=0;Na=1;break}else{Na=(c[g>>2]|0)==0;break}}}while(0);do{if((Ma|0)==0){Pa=Ka;T=257}else{ca=c[Ma+12>>2]|0;if((ca|0)==(c[Ma+16>>2]|0)){Qa=oe[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0}else{Qa=c[ca>>2]|0}if((Qa|0)==-1){c[b>>2]=0;Pa=0;T=257;break}else{if(Na^(Ka|0)==0){Ra=Ka;Sa=Ka;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Na){T=263;break a}else{Ra=Pa;Sa=0}}ca=c[g>>2]|0;da=c[ca+12>>2]|0;if((da|0)==(c[ca+16>>2]|0)){Ta=oe[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{Ta=c[da>>2]|0}if(!(re[c[(c[l>>2]|0)+12>>2]&63](l,2048,Ta)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){Mha(m,n,q)}da=c[g>>2]|0;ca=c[da+12>>2]|0;if((ca|0)==(c[da+16>>2]|0)){Ua=oe[c[(c[da>>2]|0)+36>>2]&127](da)|0}else{Ua=c[ca>>2]|0}ca=c[n>>2]|0;c[n>>2]=ca+4;c[ca>>2]=Ua;ca=La+ -1|0;c[B>>2]=ca;da=c[g>>2]|0;ba=da+12|0;R=c[ba>>2]|0;if((R|0)==(c[da+16>>2]|0)){oe[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[ba>>2]=R+4}if((ca|0)>0){Ka=Ra;La=ca;Ma=Sa}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{Va=wa;Wa=xa;Xa=ya;Ya=N;Za=za}break};case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_a=(a[J]|0)!=0}else{_a=0}if(!(F|_a)){Va=M;Wa=r;Xa=L;Ya=0;Za=O;break b}}ra=a[x]|0;ca=(ra&1)==0?h:c[G>>2]|0;d:do{if((o|0)==0){$a=V;ab=V;bb=ra;cb=ca}else{if((d[s+(o+ -1)|0]|0)<2){db=ra;eb=ca}else{$a=V;ab=V;bb=ra;cb=ca;break}while(1){if((db&1)==0){fb=h;gb=(db&255)>>>1}else{fb=c[G>>2]|0;gb=c[h>>2]|0}if((eb|0)==(fb+(gb<<2)|0)){hb=db;break}if(!(re[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[eb>>2]|0)|0)){T=129;break}db=a[x]|0;eb=eb+4|0}if((T|0)==129){T=0;hb=a[x]|0}R=(hb&1)==0;ba=eb-(R?h:c[G>>2]|0)>>2;da=a[A]|0;P=(da&1)==0;if(P){ib=(da&255)>>>1}else{ib=c[H>>2]|0}e:do{if(!(ba>>>0>ib>>>0)){if(P){jb=H+(((da&255)>>>1)-ba<<2)|0;kb=H;lb=(da&255)>>>1}else{$=c[I>>2]|0;fa=c[H>>2]|0;jb=$+(fa-ba<<2)|0;kb=$;lb=fa}fa=kb+(lb<<2)|0;if((jb|0)==(fa|0)){$a=V;ab=V;bb=hb;cb=eb;break d}else{mb=R?h:c[G>>2]|0;nb=jb}while(1){if((c[nb>>2]|0)!=(c[mb>>2]|0)){break e}$=nb+4|0;if(($|0)==(fa|0)){$a=V;ab=V;bb=hb;cb=eb;break d}mb=mb+4|0;nb=$}}}while(0);$a=V;ab=V;bb=hb;cb=R?h:c[G>>2]|0}}while(0);f:while(1){if((bb&1)==0){ob=h;pb=(bb&255)>>>1}else{ob=c[G>>2]|0;pb=c[h>>2]|0}if((cb|0)==(ob+(pb<<2)|0)){break}ca=c[g>>2]|0;do{if((ca|0)==0){qb=1}else{ra=c[ca+12>>2]|0;if((ra|0)==(c[ca+16>>2]|0)){rb=oe[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{rb=c[ra>>2]|0}if((rb|0)==-1){c[g>>2]=0;qb=1;break}else{qb=(c[g>>2]|0)==0;break}}}while(0);do{if((ab|0)==0){sb=$a;T=159}else{ca=c[ab+12>>2]|0;if((ca|0)==(c[ab+16>>2]|0)){tb=oe[c[(c[ab>>2]|0)+36>>2]&127](ab)|0}else{tb=c[ca>>2]|0}if((tb|0)==-1){c[b>>2]=0;sb=0;T=159;break}else{if(qb^($a|0)==0){ub=$a;vb=$a;break}else{break f}}}}while(0);if((T|0)==159){T=0;if(qb){break}else{ub=sb;vb=0}}ca=c[g>>2]|0;R=c[ca+12>>2]|0;if((R|0)==(c[ca+16>>2]|0)){wb=oe[c[(c[ca>>2]|0)+36>>2]&127](ca)|0}else{wb=c[R>>2]|0}if((wb|0)!=(c[cb>>2]|0)){break}R=c[g>>2]|0;ca=R+12|0;ra=c[ca>>2]|0;if((ra|0)==(c[R+16>>2]|0)){oe[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[ca>>2]=ra+4}$a=ub;ab=vb;bb=a[x]|0;cb=cb+4|0}if(!F){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}ra=a[x]|0;if((ra&1)==0){xb=h;yb=(ra&255)>>>1}else{xb=c[G>>2]|0;yb=c[h>>2]|0}if((cb|0)==(xb+(yb<<2)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O}else{T=174;break a}break};case 3:{ra=a[y]|0;ca=(ra&1)==0;if(ca){zb=(ra&255)>>>1}else{zb=c[D>>2]|0}R=a[z]|0;ba=(R&1)==0;if(ba){Ab=(R&255)>>>1}else{Ab=c[e>>2]|0}if((zb|0)==(0-Ab|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}if(ca){Bb=(ra&255)>>>1}else{Bb=c[D>>2]|0}do{if((Bb|0)!=0){if(ba){Cb=(R&255)>>>1}else{Cb=c[e>>2]|0}if((Cb|0)==0){break}da=c[g>>2]|0;P=c[da+12>>2]|0;if((P|0)==(c[da+16>>2]|0)){fa=oe[c[(c[da>>2]|0)+36>>2]&127](da)|0;Db=fa;Eb=a[y]|0}else{Db=c[P>>2]|0;Eb=ra}P=c[g>>2]|0;fa=P+12|0;da=c[fa>>2]|0;$=(da|0)==(c[P+16>>2]|0);if((Db|0)==(c[((Eb&1)==0?D:c[E>>2]|0)>>2]|0)){if($){oe[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[fa>>2]=da+4}fa=a[y]|0;if((fa&1)==0){Fb=(fa&255)>>>1}else{Fb=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=Fb>>>0>1?y:N;Za=O;break b}if($){Gb=oe[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{Gb=c[da>>2]|0}if((Gb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}da=c[g>>2]|0;P=da+12|0;$=c[P>>2]|0;if(($|0)==(c[da+16>>2]|0)){oe[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[P>>2]=$+4}a[k]=1;$=a[z]|0;if(($&1)==0){Hb=($&255)>>>1}else{Hb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=Hb>>>0>1?z:N;Za=O;break b}}while(0);if(ca){Ib=(ra&255)>>>1}else{Ib=c[D>>2]|0}ba=c[g>>2]|0;$=c[ba+12>>2]|0;P=($|0)==(c[ba+16>>2]|0);if((Ib|0)==0){if(P){da=oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;Jb=da;Kb=a[z]|0}else{Jb=c[$>>2]|0;Kb=R}if((Jb|0)!=(c[((Kb&1)==0?e:c[f>>2]|0)>>2]|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}da=c[g>>2]|0;fa=da+12|0;Lb=c[fa>>2]|0;if((Lb|0)==(c[da+16>>2]|0)){oe[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[fa>>2]=Lb+4}a[k]=1;Lb=a[z]|0;if((Lb&1)==0){Mb=(Lb&255)>>>1}else{Mb=c[e>>2]|0}Va=M;Wa=r;Xa=L;Ya=Mb>>>0>1?z:N;Za=O;break b}if(P){P=oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0;Nb=P;Ob=a[y]|0}else{Nb=c[$>>2]|0;Ob=ra}if((Nb|0)!=(c[((Ob&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;Va=M;Wa=r;Xa=L;Ya=N;Za=O;break b}$=c[g>>2]|0;P=$+12|0;ba=c[P>>2]|0;if((ba|0)==(c[$+16>>2]|0)){oe[c[(c[$>>2]|0)+40>>2]&127]($)|0}else{c[P>>2]=ba+4}ba=a[y]|0;if((ba&1)==0){Pb=(ba&255)>>>1}else{Pb=c[D>>2]|0}Va=M;Wa=r;Xa=L;Ya=Pb>>>0>1?y:N;Za=O;break};default:{Va=M;Wa=r;Xa=L;Ya=N;Za=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Qb=V;Rb=V}while(1){ba=c[g>>2]|0;do{if((ba|0)==0){Sb=1}else{P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){Tb=oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Tb=c[P>>2]|0}if((Tb|0)==-1){c[g>>2]=0;Sb=1;break}else{Sb=(c[g>>2]|0)==0;break}}}while(0);do{if((Rb|0)==0){Ub=Qb;T=42}else{ba=c[Rb+12>>2]|0;if((ba|0)==(c[Rb+16>>2]|0)){Vb=oe[c[(c[Rb>>2]|0)+36>>2]&127](Rb)|0}else{Vb=c[ba>>2]|0}if((Vb|0)==-1){c[b>>2]=0;Ub=0;T=42;break}else{if(Sb^(Qb|0)==0){Wb=Qb;Xb=Qb;break}else{Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}}}}while(0);if((T|0)==42){T=0;if(Sb){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}else{Wb=Ub;Xb=0}}ba=c[g>>2]|0;P=c[ba+12>>2]|0;if((P|0)==(c[ba+16>>2]|0)){Yb=oe[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{Yb=c[P>>2]|0}if(!(re[c[(c[l>>2]|0)+12>>2]&63](l,8192,Yb)|0)){Va=M;Wa=r;Xa=L;Ya=N;Za=O;break g}P=c[g>>2]|0;ba=P+12|0;$=c[ba>>2]|0;if(($|0)==(c[P+16>>2]|0)){Zb=oe[c[(c[P>>2]|0)+40>>2]&127](P)|0}else{c[ba>>2]=$+4;Zb=c[$>>2]|0}oca(A,Zb);Qb=Wb;Rb=Xb}}}while(0);ra=o+1|0;if(ra>>>0<4){L=Xa;r=Wa;M=Va;o=ra;N=Ya;O=Za}else{W=Va;X=Wa;Y=Ya;Z=Za;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==206){_la()}else if((T|0)==217){_la()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==263){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==274){c[j>>2]=c[j>>2]|4;_b=0;$b=wa;ac=za}else if((T|0)==276){i:do{if((Y|0)!=0){Za=Y+4|0;Ya=Y+8|0;Wa=1;j:while(1){Va=a[Y]|0;if((Va&1)==0){bc=(Va&255)>>>1}else{bc=c[Za>>2]|0}if(!(Wa>>>0<bc>>>0)){break i}Va=c[g>>2]|0;do{if((Va|0)==0){cc=1}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){dc=oe[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{dc=c[N>>2]|0}if((dc|0)==-1){c[g>>2]=0;cc=1;break}else{cc=(c[g>>2]|0)==0;break}}}while(0);Va=c[b>>2]|0;do{if((Va|0)==0){T=295}else{N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){ec=oe[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{ec=c[N>>2]|0}if((ec|0)==-1){c[b>>2]=0;T=295;break}else{if(cc){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(cc){break}}Va=c[g>>2]|0;N=c[Va+12>>2]|0;if((N|0)==(c[Va+16>>2]|0)){fc=oe[c[(c[Va>>2]|0)+36>>2]&127](Va)|0}else{fc=c[N>>2]|0}if((a[Y]&1)==0){gc=Za}else{gc=c[Ya>>2]|0}if((fc|0)!=(c[gc+(Wa<<2)>>2]|0)){break}N=Wa+1|0;Va=c[g>>2]|0;o=Va+12|0;r=c[o>>2]|0;if((r|0)==(c[Va+16>>2]|0)){oe[c[(c[Va>>2]|0)+40>>2]&127](Va)|0;Wa=N;continue}else{c[o>>2]=r+4;Wa=N;continue}}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z;break h}}while(0);if((W|0)==(X|0)){_b=1;$b=X;ac=Z;break}c[C>>2]=0;Eha(w,W,X,C);if((c[C>>2]|0)==0){_b=1;$b=W;ac=Z;break}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z}}while(0);kca(A);kca(z);kca(y);kca(x);Iba(w);if(($b|0)==0){i=p;return _b|0}le[ac&511]($b);i=p;return _b|0}function Jha(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=308;v=n+400|0;Eca(q,h);n=q;w=c[n>>2]|0;if(!((c[47568]|0)==-1)){c[m>>2]=190272;c[m+4>>2]=306;c[m+8>>2]=0;tba(190272,m,307)}m=(c[190276>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Kc(4)|0;z=y;sla(z);A=205840;B=128;Zd(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Kc(4)|0;z=y;sla(z);A=205840;B=128;Zd(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Iha(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){oca(k,De[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=De[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Kha(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=oe[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=oe[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];_aa(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}le[c[u>>2]&511](n);i=d;return}function Kha(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){qca(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function Lha(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[47462]|0)==-1)){c[p>>2]=189848;c[p+4>>2]=306;c[p+8>>2]=0;tba(189848,p,307)}p=(c[189852>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Kc(4)|0;C=B;sla(C);D=205840;E=128;Zd(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Kc(4)|0;C=B;sla(C);D=205840;E=128;Zd(B|0,D|0,E|0)}E=b;me[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;me[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}nca(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;kca(r);me[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}nca(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;kca(s);c[f>>2]=oe[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=oe[c[(c[b>>2]|0)+16>>2]&127](E)|0;me[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Uba(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Iba(t);me[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}nca(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;kca(u);F=oe[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[47446]|0)==-1)){c[o>>2]=189784;c[o+4>>2]=306;c[o+8>>2]=0;tba(189784,o,307)}o=(c[189788>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Kc(4)|0;H=G;sla(H);I=205840;J=128;Zd(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Kc(4)|0;H=G;sla(H);I=205840;J=128;Zd(G|0,I|0,J|0)}J=E;me[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;me[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}nca(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;kca(w);me[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}nca(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;kca(x);c[f>>2]=oe[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=oe[c[(c[E>>2]|0)+16>>2]&127](J)|0;me[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Uba(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Iba(y);me[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}nca(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;kca(z);F=oe[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Mha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=308;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=Qla(m,l)|0;m=a;if((a|0)==0){_la()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}le[c[f>>2]&511](a);n=c[h>>2]|0}}while(0);c[f>>2]=283;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function Nha(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Oha(a){a=a|0;i=i;return}function Pha(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Sc(G|0,100,190032,o|0)|0;do{if(s>>>0>99){do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);o=c[47542]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Hfa(r,o,190032,n)|0;o=c[r>>2]|0;if((o|0)==0){_la()}H=Nla(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}_la()}else{I=0;J=0;K=q;L=s}}while(0);Eca(t,g);s=t;q=c[s>>2]|0;if(!((c[47570]|0)==-1)){c[p>>2]=190280;c[p+4>>2]=306;c[p+8>>2]=0;tba(190280,p,307)}p=(c[190284>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Kc(4)|0;N=M;sla(N);O=205840;P=128;Zd(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Kc(4)|0;N=M;sla(N);O=205840;P=128;Zd(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;Ne[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Qha(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=Nla(V)|0;if((T|0)!=0){W=T;X=T;break}_la()}else{W=0;X=t}}while(0);Rha(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];e8(b,m,X,e,D,g,j);if((W|0)!=0){Ola(W)}Iba(A);Iba(z);Iba(y);_aa(c[s>>2]|0)|0;if((J|0)!=0){Ola(J)}if((I|0)==0){i=d;return}Ola(I);i=d;return}function Qha(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[47430]|0)==-1)){c[p>>2]=189720;c[p+4>>2]=306;c[p+8>>2]=0;tba(189720,p,307)}p=(c[189724>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Kc(4)|0;I=H;sla(I);J=205840;K=128;Zd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Kc(4)|0;I=H;sla(I);J=205840;K=128;Zd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){me[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;me[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Uba(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Iba(s)}else{me[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;me[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Uba(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Iba(v)}a[g]=oe[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=oe[c[(c[e>>2]|0)+16>>2]&127](K)|0;me[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Uba(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Iba(w);me[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Uba(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Iba(x);L=oe[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[47414]|0)==-1)){c[o>>2]=189656;c[o+4>>2]=306;c[o+8>>2]=0;tba(189656,o,307)}o=(c[189660>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Kc(4)|0;N=M;sla(N);O=205840;P=128;Zd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Kc(4)|0;N=M;sla(N);O=205840;P=128;Zd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){me[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;me[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Uba(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Iba(A)}else{me[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;me[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Uba(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Iba(D)}a[g]=oe[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=oe[c[(c[G>>2]|0)+16>>2]&127](P)|0;me[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Uba(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Iba(E);me[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Uba(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Iba(F);L=oe[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function Rha(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 3:{I=a[r]|0;J=(I&1)==0;if(J){K=(I&255)>>>1}else{K=c[w>>2]|0}if((K|0)==0){L=H;break a}if(J){M=u}else{M=c[v>>2]|0}J=a[M]|0;I=c[f>>2]|0;c[f>>2]=I+1;a[I]=J;L=H;break};case 2:{J=a[q]|0;I=(J&1)==0;if(I){N=(J&255)>>>1}else{N=c[A>>2]|0}if((N|0)==0|x){L=H;break a}if(I){O=y;P=(J&255)>>>1}else{O=c[z>>2]|0;P=c[A>>2]|0}J=O+P|0;I=c[f>>2]|0;if((O|0)==(J|0)){Q=I}else{R=I;I=O;while(1){a[R]=a[I]|0;S=I+1|0;T=R+1|0;if((S|0)==(J|0)){Q=T;break}else{I=S;R=T}}}c[f>>2]=Q;L=H;break};case 4:{R=c[f>>2]|0;I=l?H+1|0:H;b:do{if(I>>>0<j>>>0){J=I;while(1){T=a[J]|0;if(!(T<<24>>24>-1)){U=J;break b}S=J+1|0;if((b[(c[F>>2]|0)+(T<<24>>24<<1)>>1]&2048)==0){U=J;break b}if(S>>>0<j>>>0){J=S}else{U=S;break}}}else{U=I}}while(0);J=U;if(B){if(U>>>0>I>>>0){S=I+(0-J)|0;J=S>>>0<G>>>0?G:S;S=J+s|0;T=R;V=U;W=s;while(1){X=V+ -1|0;Y=a[X]|0;c[f>>2]=T+1;a[T]=Y;Y=W+ -1|0;Z=(Y|0)>0;if(!(X>>>0>I>>>0&Z)){break}T=c[f>>2]|0;W=Y;V=X}V=U+J|0;if(Z){_=V;$=S;aa=32}else{ba=0;ca=V;da=S}}else{_=U;$=s;aa=32}if((aa|0)==32){aa=0;ba=De[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;ca=_;da=$}V=c[f>>2]|0;c[f>>2]=V+1;if((da|0)>0){W=V;T=da;while(1){a[W]=ba;X=T+ -1|0;Y=c[f>>2]|0;c[f>>2]=Y+1;if((X|0)>0){T=X;W=Y}else{ea=Y;break}}}else{ea=V}a[ea]=n;fa=ca}else{fa=U}if((fa|0)==(I|0)){W=De[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;T=c[f>>2]|0;c[f>>2]=T+1;a[T]=W}else{W=a[p]|0;T=(W&1)==0;if(T){ga=(W&255)>>>1}else{ga=c[E>>2]|0}if((ga|0)==0){ha=fa;ia=-1;ja=0;ka=0}else{if(T){la=C}else{la=c[D>>2]|0}ha=fa;ia=a[la]|0;ja=0;ka=0}while(1){do{if((ka|0)==(ia|0)){T=c[f>>2]|0;c[f>>2]=T+1;a[T]=o;T=ja+1|0;W=a[p]|0;S=(W&1)==0;if(S){ma=(W&255)>>>1}else{ma=c[E>>2]|0}if(!(T>>>0<ma>>>0)){na=ia;oa=T;pa=0;break}if(S){qa=C}else{qa=c[D>>2]|0}if((a[qa+T|0]|0)==127){na=-1;oa=T;pa=0;break}if(S){ra=C}else{ra=c[D>>2]|0}na=a[ra+T|0]|0;oa=T;pa=0}else{na=ia;oa=ja;pa=ka}}while(0);T=ha+ -1|0;S=a[T]|0;W=c[f>>2]|0;c[f>>2]=W+1;a[W]=S;if((T|0)==(I|0)){break}else{ha=T;ia=na;ja=oa;ka=pa+1|0}}}V=c[f>>2]|0;if((R|0)==(V|0)){L=I;break a}T=V+ -1|0;if(T>>>0>R>>>0){sa=R;ta=T}else{L=I;break a}while(1){T=a[sa]|0;a[sa]=a[ta]|0;a[ta]=T;T=sa+1|0;V=ta+ -1|0;if(T>>>0<V>>>0){ta=V;sa=T}else{L=I;break}}break};case 1:{c[e>>2]=c[f>>2];I=De[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=I;L=H;break};case 0:{c[e>>2]=c[f>>2];L=H;break};default:{L=H}}}while(0);I=h+1|0;if(I>>>0<4){H=L;h=I}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function Sha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Eca(m,g);z=m;A=c[z>>2]|0;if(!((c[47570]|0)==-1)){c[l>>2]=190280;c[l+4>>2]=306;c[l+8>>2]=0;tba(190280,l,307)}l=(c[190284>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Kc(4)|0;D=C;sla(D);E=205840;F=128;Zd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Kc(4)|0;D=C;sla(D);E=205840;F=128;Zd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(De[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Qha(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=Nla(P)|0;if((N|0)!=0){Q=N;R=N;break}_la()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}Rha(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];e8(b,k,R,e,w,g,h);if((Q|0)==0){Iba(t);Iba(s);Iba(r);U=c[z>>2]|0;V=U;W=V;X=_aa(W)|0;i=d;return}Ola(Q);Iba(t);Iba(s);Iba(r);U=c[z>>2]|0;V=U;W=V;X=_aa(W)|0;i=d;return}function Tha(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Uha(a){a=a|0;i=i;return}function Vha(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Sc(G|0,100,190032,o|0)|0;do{if(s>>>0>99){do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);o=c[47542]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Hfa(r,o,190032,n)|0;o=c[r>>2]|0;if((o|0)==0){_la()}H=Nla(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}_la()}else{J=0;K=0;L=q;M=s}}while(0);Eca(t,g);s=t;q=c[s>>2]|0;if(!((c[47568]|0)==-1)){c[p>>2]=190272;c[p+4>>2]=306;c[p+8>>2]=0;tba(190272,p,307)}p=(c[190276>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Kc(4)|0;O=N;sla(O);P=205840;Q=128;Zd(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Kc(4)|0;O=N;sla(O);P=205840;Q=128;Zd(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;Ne[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Wha(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=Nla(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}_la()}else{X=0;Y=t}}while(0);Xha(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];Qfa(b,m,Y,e,D,g,j);if((X|0)!=0){Ola(X)}kca(A);kca(z);Iba(y);_aa(c[s>>2]|0)|0;if((K|0)!=0){Ola(K)}if((J|0)==0){i=d;return}Ola(J);i=d;return}function Wha(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[47462]|0)==-1)){c[p>>2]=189848;c[p+4>>2]=306;c[p+8>>2]=0;tba(189848,p,307)}p=(c[189852>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Kc(4)|0;I=H;sla(I);J=205840;K=128;Zd(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Kc(4)|0;I=H;sla(I);J=205840;K=128;Zd(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){me[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;me[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}nca(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;kca(s)}else{me[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;me[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}nca(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;kca(v)}c[g>>2]=oe[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=oe[c[(c[e>>2]|0)+16>>2]&127](K)|0;me[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Uba(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Iba(w);me[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}nca(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;kca(x);L=oe[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[47446]|0)==-1)){c[o>>2]=189784;c[o+4>>2]=306;c[o+8>>2]=0;tba(189784,o,307)}o=(c[189788>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Kc(4)|0;N=M;sla(N);O=205840;P=128;Zd(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Kc(4)|0;N=M;sla(N);O=205840;P=128;Zd(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){me[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;me[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}nca(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;kca(A)}else{me[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;me[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}nca(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;kca(D)}c[g>>2]=oe[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=oe[c[(c[G>>2]|0)+16>>2]&127](P)|0;me[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Uba(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Iba(E);me[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}nca(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;kca(F);L=oe[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function Xha(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 0:{c[d>>2]=c[e>>2];D=C;break};case 1:{c[d>>2]=c[e>>2];E=De[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;F=c[e>>2]|0;c[e>>2]=F+4;c[F>>2]=E;D=C;break};case 2:{E=a[p]|0;F=(E&1)==0;if(F){G=(E&255)>>>1}else{G=c[w>>2]|0}if((G|0)==0|v){D=C;break a}if(F){H=w;I=(E&255)>>>1}else{H=c[x>>2]|0;I=c[w>>2]|0}E=H+(I<<2)|0;F=c[e>>2]|0;if((H|0)==(E|0)){J=F}else{K=(H+(I+ -1<<2)+(0-H)|0)>>>2;L=F;M=H;while(1){c[L>>2]=c[M>>2];N=M+4|0;if((N|0)==(E|0)){break}L=L+4|0;M=N}J=F+(K+1<<2)|0}c[e>>2]=J;D=C;break};case 3:{M=a[q]|0;L=(M&1)==0;if(L){O=(M&255)>>>1}else{O=c[t>>2]|0}if((O|0)==0){D=C;break a}if(L){P=t}else{P=c[u>>2]|0}L=c[P>>2]|0;M=c[e>>2]|0;c[e>>2]=M+4;c[M>>2]=L;D=C;break};case 4:{L=c[e>>2]|0;M=k?C+4|0:C;b:do{if(M>>>0<h>>>0){E=M;while(1){N=E+4|0;if(!(re[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[E>>2]|0)|0)){Q=E;break b}if(N>>>0<h>>>0){E=N}else{Q=N;break}}}else{Q=M}}while(0);if(y){do{if(Q>>>0>M>>>0){K=c[e>>2]|0;F=Q;E=r;while(1){R=F+ -4|0;S=K+4|0;c[K>>2]=c[R>>2];T=E+ -1|0;U=(T|0)>0;if(R>>>0>M>>>0&U){E=T;F=R;K=S}else{break}}c[e>>2]=S;if(U){V=R;W=T;X=34;break}K=c[e>>2]|0;c[e>>2]=K+4;Y=K;Z=R}else{V=Q;W=r;X=34}}while(0);do{if((X|0)==34){X=0;K=De[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;F=c[e>>2]|0;E=F+4|0;c[e>>2]=E;if((W|0)>0){_=E;$=F;aa=W}else{Y=F;Z=V;break}while(1){c[$>>2]=K;E=aa+ -1|0;if((E|0)>0){aa=E;$=_;_=_+4|0}else{break}}c[e>>2]=F+(W+1<<2);Y=F+(W<<2)|0;Z=V}}while(0);c[Y>>2]=m;ba=Z}else{ba=Q}if((ba|0)==(M|0)){K=De[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;N=E+4|0;c[e>>2]=N;c[E>>2]=K;ca=N}else{N=a[o]|0;K=(N&1)==0;if(K){da=(N&255)>>>1}else{da=c[B>>2]|0}if((da|0)==0){ea=ba;fa=-1;ga=0;ha=0}else{if(K){ia=z}else{ia=c[A>>2]|0}ea=ba;fa=a[ia]|0;ga=0;ha=0}while(1){K=c[e>>2]|0;do{if((ha|0)==(fa|0)){N=K+4|0;c[e>>2]=N;c[K>>2]=n;E=ga+1|0;ja=a[o]|0;ka=(ja&1)==0;if(ka){la=(ja&255)>>>1}else{la=c[B>>2]|0}if(!(E>>>0<la>>>0)){ma=N;na=fa;oa=E;pa=0;break}if(ka){qa=z}else{qa=c[A>>2]|0}if((a[qa+E|0]|0)==127){ma=N;na=-1;oa=E;pa=0;break}if(ka){ra=z}else{ra=c[A>>2]|0}ma=N;na=a[ra+E|0]|0;oa=E;pa=0}else{ma=K;na=fa;oa=ga;pa=ha}}while(0);K=ea+ -4|0;F=c[K>>2]|0;E=ma+4|0;c[e>>2]=E;c[ma>>2]=F;if((K|0)==(M|0)){ca=E;break}else{ea=K;fa=na;ga=oa;ha=pa+1|0}}}if((L|0)==(ca|0)){D=M;break a}K=ca+ -4|0;if(K>>>0>L>>>0){sa=L;ta=K}else{D=M;break a}while(1){K=c[sa>>2]|0;c[sa>>2]=c[ta>>2];c[ta>>2]=K;K=sa+4|0;E=ta+ -4|0;if(K>>>0<E>>>0){ta=E;sa=K}else{D=M;break}}break};default:{D=C}}}while(0);M=g+1|0;if(M>>>0<4){C=D;g=M}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function Yha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Eca(m,g);z=m;A=c[z>>2]|0;if(!((c[47568]|0)==-1)){c[l>>2]=190272;c[l+4>>2]=306;c[l+8>>2]=0;tba(190272,l,307)}l=(c[190276>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Kc(4)|0;D=C;sla(D);E=205840;F=128;Zd(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Kc(4)|0;D=C;sla(D);E=205840;F=128;Zd(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(De[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Wha(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=Nla(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}_la()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}Xha(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];Qfa(b,k,R,e,w,g,h);if((Q|0)==0){kca(t);kca(s);Iba(r);U=c[z>>2]|0;V=U;W=V;X=_aa(W)|0;i=d;return}Ola(Q);kca(t);kca(s);Iba(r);U=c[z>>2]|0;V=U;W=V;X=_aa(W)|0;i=d;return}function Zha(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function _ha(a){a=a|0;i=i;return}function $ha(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=Ac(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function aia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{_ba(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=Dd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=pma(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{Iba(j);i=d;return}do{_ba(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);Iba(j);i=d;return}function bia(a,b){a=a|0;b=b|0;a=i;Jb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function cia(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function dia(a){a=a|0;i=i;return}function eia(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=Ac(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function fia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=191936;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=191936|0;while(1){c[m>>2]=y;A=(Me[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{_ba(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}Aha(191160)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=Dd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=192040;D=pma(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){Iba(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=192040|0;while(1){c[q>>2]=o;h=(Me[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{oca(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){Aha(191160)}else if((E|0)==25){Iba(r);i=d;return}}function gia(a,b){a=a|0;b=b|0;a=i;Jb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function hia(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=190368;e=b+8|0;b=c[e>>2]|0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);if((b|0)==(c[47542]|0)){i=d;return}dc(c[e>>2]|0);i=d;return}function iia(a){a=a|0;a=Kc(8)|0;$aa(a,190160);c[a>>2]=187128;Zd(a|0,187168,41)}function jia(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=190200;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);Aba(b+144|0,190184,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[195092>>2]=0;c[48772]=188680;if(!((c[47176]|0)==-1)){c[G>>2]=188704;c[G+4>>2]=306;c[G+8>>2]=0;tba(188704,G,307)}kia(b,195088,(c[188708>>2]|0)+ -1|0);c[195084>>2]=0;c[48770]=188720;if(!((c[47186]|0)==-1)){c[F>>2]=188744;c[F+4>>2]=306;c[F+8>>2]=0;tba(188744,F,307)}kia(b,195080,(c[188748>>2]|0)+ -1|0);c[195068>>2]=0;c[48766]=190296;c[195072>>2]=0;a[195076|0]=0;F=c[(Ec()|0)>>2]|0;c[195072>>2]=F;if(!((c[47570]|0)==-1)){c[E>>2]=190280;c[E+4>>2]=306;c[E+8>>2]=0;tba(190280,E,307)}kia(b,195064,(c[190284>>2]|0)+ -1|0);c[195060>>2]=0;c[48764]=191256;if(!((c[47568]|0)==-1)){c[D>>2]=190272;c[D+4>>2]=306;c[D+8>>2]=0;tba(190272,D,307)}kia(b,195056,(c[190276>>2]|0)+ -1|0);c[195052>>2]=0;c[48762]=191472;if(!((c[47586]|0)==-1)){c[C>>2]=190344;c[C+4>>2]=306;c[C+8>>2]=0;tba(190344,C,307)}kia(b,195048,(c[190348>>2]|0)+ -1|0);c[195036>>2]=0;c[48758]=190368;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);c[195040>>2]=c[47542];if(!((c[47588]|0)==-1)){c[B>>2]=190352;c[B+4>>2]=306;c[B+8>>2]=0;tba(190352,B,307)}kia(b,195032,(c[190356>>2]|0)+ -1|0);c[195028>>2]=0;c[48756]=191696;if(!((c[47602]|0)==-1)){c[A>>2]=190408;c[A+4>>2]=306;c[A+8>>2]=0;tba(190408,A,307)}kia(b,195024,(c[190412>>2]|0)+ -1|0);c[195020>>2]=0;c[48754]=191816;if(!((c[47604]|0)==-1)){c[z>>2]=190416;c[z+4>>2]=306;c[z+8>>2]=0;tba(190416,z,307)}kia(b,195016,(c[190420>>2]|0)+ -1|0);c[194996>>2]=0;c[48748]=190448;a[195e3|0]=46;a[195001|0]=44;z=195004|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[47606]|0)==-1)){c[y>>2]=190424;c[y+4>>2]=306;c[y+8>>2]=0;tba(190424,y,307)}kia(b,194992,(c[190428>>2]|0)+ -1|0);c[194964>>2]=0;c[48740]=190488;c[194968>>2]=46;c[194972>>2]=44;y=194976|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[47608]|0)==-1)){c[x>>2]=190432;c[x+4>>2]=306;c[x+8>>2]=0;tba(190432,x,307)}kia(b,194960,(c[190436>>2]|0)+ -1|0);c[194956>>2]=0;c[48738]=188760;if(!((c[47204]|0)==-1)){c[w>>2]=188816;c[w+4>>2]=306;c[w+8>>2]=0;tba(188816,w,307)}kia(b,194952,(c[188820>>2]|0)+ -1|0);c[194948>>2]=0;c[48736]=188880;if(!((c[47234]|0)==-1)){c[v>>2]=188936;c[v+4>>2]=306;c[v+8>>2]=0;tba(188936,v,307)}kia(b,194944,(c[188940>>2]|0)+ -1|0);c[194940>>2]=0;c[48734]=188952;if(!((c[47250]|0)==-1)){c[u>>2]=189e3;c[u+4>>2]=306;c[u+8>>2]=0;tba(189e3,u,307)}kia(b,194936,(c[189004>>2]|0)+ -1|0);c[194932>>2]=0;c[48732]=189016;if(!((c[47266]|0)==-1)){c[t>>2]=189064;c[t+4>>2]=306;c[t+8>>2]=0;tba(189064,t,307)}kia(b,194928,(c[189068>>2]|0)+ -1|0);c[194924>>2]=0;c[48730]=189608;if(!((c[47414]|0)==-1)){c[s>>2]=189656;c[s+4>>2]=306;c[s+8>>2]=0;tba(189656,s,307)}kia(b,194920,(c[189660>>2]|0)+ -1|0);c[194916>>2]=0;c[48728]=189672;if(!((c[47430]|0)==-1)){c[r>>2]=189720;c[r+4>>2]=306;c[r+8>>2]=0;tba(189720,r,307)}kia(b,194912,(c[189724>>2]|0)+ -1|0);c[194908>>2]=0;c[48726]=189736;if(!((c[47446]|0)==-1)){c[q>>2]=189784;c[q+4>>2]=306;c[q+8>>2]=0;tba(189784,q,307)}kia(b,194904,(c[189788>>2]|0)+ -1|0);c[194900>>2]=0;c[48724]=189800;if(!((c[47462]|0)==-1)){c[p>>2]=189848;c[p+4>>2]=306;c[p+8>>2]=0;tba(189848,p,307)}kia(b,194896,(c[189852>>2]|0)+ -1|0);c[194892>>2]=0;c[48722]=189864;if(!((c[47472]|0)==-1)){c[o>>2]=189888;c[o+4>>2]=306;c[o+8>>2]=0;tba(189888,o,307)}kia(b,194888,(c[189892>>2]|0)+ -1|0);c[194884>>2]=0;c[48720]=189944;if(!((c[47492]|0)==-1)){c[n>>2]=189968;c[n+4>>2]=306;c[n+8>>2]=0;tba(189968,n,307)}kia(b,194880,(c[189972>>2]|0)+ -1|0);c[194876>>2]=0;c[48718]=19e4;if(!((c[47506]|0)==-1)){c[m>>2]=190024;c[m+4>>2]=306;c[m+8>>2]=0;tba(190024,m,307)}kia(b,194872,(c[190028>>2]|0)+ -1|0);c[194868>>2]=0;c[48716]=190048;if(!((c[47518]|0)==-1)){c[l>>2]=190072;c[l+4>>2]=306;c[l+8>>2]=0;tba(190072,l,307)}kia(b,194864,(c[190076>>2]|0)+ -1|0);c[194852>>2]=0;c[48712]=189096;c[194856>>2]=189144;if(!((c[47294]|0)==-1)){c[k>>2]=189176;c[k+4>>2]=306;c[k+8>>2]=0;tba(189176,k,307)}kia(b,194848,(c[189180>>2]|0)+ -1|0);c[194836>>2]=0;c[48708]=189248;c[194840>>2]=189296;if(!((c[47332]|0)==-1)){c[j>>2]=189328;c[j+4>>2]=306;c[j+8>>2]=0;tba(189328,j,307)}kia(b,194832,(c[189332>>2]|0)+ -1|0);c[194820>>2]=0;c[48704]=191192;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);c[194824>>2]=c[47542];c[48704]=189544;if(!((c[47390]|0)==-1)){c[h>>2]=189560;c[h+4>>2]=306;c[h+8>>2]=0;tba(189560,h,307)}kia(b,194816,(c[189564>>2]|0)+ -1|0);c[194804>>2]=0;c[48700]=191192;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);c[194808>>2]=c[47542];c[48700]=189576;if(!((c[47398]|0)==-1)){c[g>>2]=189592;c[g+4>>2]=306;c[g+8>>2]=0;tba(189592,g,307)}kia(b,194800,(c[189596>>2]|0)+ -1|0);c[194796>>2]=0;c[48698]=190088;if(!((c[47528]|0)==-1)){c[f>>2]=190112;c[f+4>>2]=306;c[f+8>>2]=0;tba(190112,f,307)}kia(b,194792,(c[190116>>2]|0)+ -1|0);c[194788>>2]=0;c[48696]=190128;if((c[47538]|0)==-1){N=190152;O=190152;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=194784;kia(b,T,S);i=e;return}c[H>>2]=190152;c[H+4>>2]=306;c[H+8>>2]=0;tba(190152,H,307);N=190152;O=190152;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=194784;kia(b,T,S);i=e;return}function kia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;Zaa(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){pka(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}_aa(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function lia(a){a=a|0;var b=0;b=i;mia(a);Vla(a);i=b;return}function mia(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=190200;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{_aa(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}Iba(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{Vla(h);i=d;return}}function nia(){var b=0,d=0,e=0,f=0;b=i;if((a[190256]|0)!=0){d=190248;e=c[47562]|0;i=b;return e|0}if((Za(190256)|0)==0){d=190248;e=c[47562]|0;i=b;return e|0}do{if((a[190232]|0)==0){if((Za(190232)|0)==0){break}jia(194624,1);c[47554]=194624;c[47556]=190216;Vb(190232)}}while(0);f=c[c[47556]>>2]|0;c[47560]=f;Zaa(f);c[47562]=190240;Vb(190256);d=190248;e=c[47562]|0;i=b;return e|0}function oia(a){a=a|0;var b=0,d=0;b=i;d=c[(nia()|0)>>2]|0;c[a>>2]=d;Zaa(d);i=b;return}function pia(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;Zaa(e);i=d;return}function qia(a){a=a|0;var b=0;b=i;_aa(c[a>>2]|0)|0;i=b;return}function ria(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=306;c[e+8>>2]=0;tba(a,e,307)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function sia(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=306;c[e+8>>2]=0;tba(a,e,307)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Kc(4)|0;h=g;sla(h);j=205840;k=128;Zd(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Kc(4)|0;h=g;sla(h);j=205840;k=128;Zd(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function tia(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function uia(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}le[c[(c[a>>2]|0)+4>>2]&511](a);i=b;return}function via(a){a=a|0;var b=0;b=c[47566]|0;c[47566]=1+b;c[a+4>>2]=b+1;i=i;return}function wia(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function xia(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(Ec()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function yia(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(Ec()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function zia(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(Ec()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function Aia(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(Ec()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function Bia(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Cia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Dia(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Nd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Eia(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Nd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Fia(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}



function Z7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;oma(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=Cma(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(43,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=Cma(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[41278]=d;u=0;Ha(59,10,302)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=Cma(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(44,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=Cma(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=Cma(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=Cma(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=Cma(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=Cma(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(303,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=Cma(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=Cma(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=Cma(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function _7(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=rd(c[28452]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[116188>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;xc(165448,7,1,a|0)|0;Jc(a|0,d|0,f|0)|0;Yd(10,a|0)|0;zd(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 5:case 4:{i=b;return};case 1:{c[f>>2]=e;n=c[r>>2]|0;xc(165448,7,1,n|0)|0;Jc(n|0,d|0,f|0)|0;Yd(10,n|0)|0;zd(0)|0;eb(c[g+80>>2]|0,1);break};case 3:{if((c[116244>>2]|0)==0){i=b;return}c[f>>2]=e;e=c[r>>2]|0;xc(165448,7,1,e|0)|0;Jc(e|0,d|0,f|0)|0;Yd(10,e|0)|0;zd(0)|0;i=b;return};default:{VS(g,165456,b)}}}function $7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;xc(165432,9,1,d|0)|0;Jc(d|0,b|0,e|0)|0;Yd(10,d|0)|0;zd(0)|0;i=a;return}function a8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;h8(165376,b);c[40836]=164104;b=163348|0;c[b+0>>2]=-1;c[b+4>>2]=-1;c[b+8>>2]=-1;c[b+12>>2]=-1;c[163364>>2]=1;if((a|0)!=0){d=a;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}d=rd(c[28452]|0)|0;e=d;f=e+76|0;g=f;h=c[g>>2]|0;j=h;k=j;eb(k|0,1)}function b8(a,b){a=a|0;b=b|0;var c=0;c=i;d8(a,b);i=c;return}function c8(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function d8(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=Bca(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function e8(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;ZY(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=f8(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((Nca(b,d,r)|0)==(r|0)){break}ZY(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){Dba(l,s,h);if((Nca(b,Hba(l)|0,s)|0)==(s|0)){Iba(l);break}ZY(m);c[o>>2]=0;c[a>>2]=0;Iba(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((Nca(b,e,l)|0)==(l|0)){break}ZY(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);g8(g,0)|0;c[a>>2]=b;i=j;return}function f8(a){a=a|0;i=i;return c[a+12>>2]|0}function g8(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function h8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=d+8|0;g=c[40842]|0;if((g|0)==0){c[e>>2]=(pma(a|0)|0)<<1|1;c[f>>2]=2048;h=c[(n1(e,f)|0)>>2]|0;c[41356]=h;f=Nla(h)|0;c[40842]=f;j=h;k=f}else{j=c[41356]|0;k=g}g=sc(k|0,j|0,a|0,b|0)|0;if(g>>>0<(c[41356]|0)>>>0){i=d;return}Ola(c[40842]|0);j=g<<1|1;c[41356]=j;g=Nla(j)|0;c[40842]=g;sc(g|0,j|0,a|0,b|0)|0;i=d;return}function i8(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;j8(g,16);k8(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){l8(a,g);m8(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){P7(Wda(m,+h[b+(p<<3)>>3])|0,166816)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){Wda(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){P7(m,166824)|0}}while((e|0)<(d|0));l8(a,g);m8(g);i=f;return}function j8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;Fca(e);f=a;c[f>>2]=167196;g=e;c[g>>2]=167216;e=a+4|0;Mda(a,167228|0,e);c[f>>2]=167196;c[g>>2]=167216;y8(e,b|16);i=d;return}function k8(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function l8(a,b){a=a|0;b=b|0;var c=0;c=i;s8(a,b+4|0);i=c;return}function m8(a){a=a|0;var b=0;b=i;C8(a,167224);Aca(a+56|0);i=b;return}function n8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[116232>>2]|0)!=0){vb(167520)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(14,0,166832,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);oe[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(14,0,166904,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[116232>>2]|0)==0){i=d;return 0}RS(14,0,166952,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];mc(166968,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ic(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function o8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[116232>>2]|0)!=0){vb(167520)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(14,0,166832,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);oe[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(14,0,166904,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[116232>>2]|0)==0){i=d;return 0}RS(14,0,166952,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];mc(166968,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ic(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function p8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[116232>>2]|0)!=0){vb(167520)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(14,0,166832,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);oe[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(14,0,166904,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[116232>>2]|0)==0){i=d;return 0}RS(14,0,166952,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];mc(166968,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ic(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function q8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[116232>>2]|0)!=0){vb(167520)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(14,0,166832,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);oe[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(14,0,166904,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[116232>>2]|0)==0){i=d;return 0}RS(14,0,166952,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];mc(166968,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}ic(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function r8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=Pla(fa(F,F)|0,8)|0;J=I;K=Pla(fa(G,F)|0,8)|0;L=K;M=Pla(fa(H,F)|0,8)|0;N=M;O=Pla(fa(H,G)|0,8)|0;P=O;wba(p);wba(q);wba(r);wba(s);wba(t);wba(u);wba(v);Q=a+536|0;US(c[Q>>2]|0,(I|0)!=0|0,166976,o);US(c[Q>>2]|0,(K|0)!=0|0,166976,n);US(c[Q>>2]|0,(M|0)!=0|0,166976,m);US(c[Q>>2]|0,(O|0)!=0|0,166976,l);l=a+540|0;m=a;if((oe[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;n8(a,J)|0;US(n,1,166992,k)}i8(w,J,F,F);Jba(p,w)|0;Iba(w);if((oe[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;o8(a,L)|0;US(w,1,167024,j)}i8(x,L,F,G);Jba(q,x)|0;Iba(x);if((oe[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;p8(a,N)|0;US(x,1,167056,h)}i8(y,N,H,F);Jba(r,y)|0;Iba(y);if((oe[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;q8(a,P)|0;US(m,1,167088,g)}i8(z,P,H,G);Jba(s,z)|0;Iba(z);if((F|0)==0){Kba(t,167120)|0}else{i8(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);Jba(t,A)|0;Iba(A)}if((G|0)==0){Kba(u,167120)|0}else{i8(B,c[a+432>>2]|0,1,G);Jba(u,B)|0;Iba(B)}Ola(I);Ola(K);Ola(M);Ola(O);Cba(E,c[a+84>>2]|0);rca(D,167136,E);z0(C,D,167144);Jba(v,C)|0;Iba(C);Iba(D);Iba(E);E=oc(dca(v)|0,167152)|0;D=c[Q>>2]|0;c[f>>2]=dca(v)|0;US(D,(E|0)!=0|0,167160,f);f=Ie[c[(c[l>>2]|0)+176>>2]&7]()|0;D=dca(t)|0;Q=dca(u)|0;C=dca(p)|0;a=dca(q)|0;O=dca(r)|0;M=dca(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;Bd(E|0,f|0,e|0)|0;if((c[116276>>2]|0)==0){R=zd(E|0)|0;S=dd(E|0)|0;Iba(v);Iba(u);Iba(t);Iba(s);Iba(r);Iba(q);Iba(p);i=b;return 0}e=Ie[c[(c[l>>2]|0)+176>>2]&7]()|0;l=dca(t)|0;f=dca(u)|0;M=dca(p)|0;O=dca(q)|0;a=dca(r)|0;C=dca(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;RS(25,0,e,d);R=zd(E|0)|0;S=dd(E|0)|0;Iba(v);Iba(u);Iba(t);Iba(s);Iba(r);Iba(q);Iba(p);i=b;return 0}function s8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=Vca(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}t8(a,Uca(l)|0,n,e);i=d;return}if((h&8|0)==0){xba(a,g);i=d;return}else{g=b;b=Pca(g)|0;t8(a,b,Rca(g)|0,f);i=d;return}}function t8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;u8(a,b,c,0);i=d;return}function u8(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;v8(a,b,c);i=d;return}function v8(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=w8(c,d)|0;if(g>>>0>4294967279){uba(0)}if(g>>>0<11){Oba(b,g);h=Nba(b)|0}else{j=Vba(g)|0;k=j+1|0;j=j1(Bba(b)|0,k)|0;Xba(b,j);Wba(b,k);Mba(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;k1(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){k1(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;k1(l,f);i=e;return}function w8(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=x8(b,c,e)|0;i=d;return g|0}function x8(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function y8(a,b){a=a|0;b=b|0;var c=0;c=i;O8(a,b);i=c;return}function z8(a){a=a|0;var b=0;b=i;m8(a);Vla(a);i=b;return}function A8(a){a=a|0;var b=0;b=i;m8(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function B8(a){a=a|0;var b=0;b=i;z8(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function C8(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];D8(a+4|0);i=d;return}function D8(a){a=a|0;var b=0;b=i;E8(a);i=b;return}function E8(a){a=a|0;var b=0;b=i;c[a>>2]=167376;Iba(a+32|0);Jca(a);i=b;return}function F8(a){a=a|0;var b=0;b=i;D8(a);Vla(a);i=b;return}function G8(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=Vca(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){lY(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}lY(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=Vca(l)|0;j=m-(Uca(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=Qca(l)|0;m=j-(Pca(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(Hba(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){lY(a,-1,-1);i=h;return}o=zma(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(Hba(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((Qca(l)|0)!=0){break}lY(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((Vca(l)|0)!=0){break}lY(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=Pca(l)|0;Tca(l,q,q+o|0,n)}if((g&16|0)!=0){q=Uca(l)|0;Yca(l,q,Wca(l)|0);Xca(l,o)}lY(a,o,e);i=h;return}}while(0);lY(a,-1,-1);i=h;return}function H8(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=zZ(d)|0;xe[g&31](a,b,h,J,0,e);i=f;return}function I8(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=Vca(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((Rca(g)|0)>>>0<j>>>0){b=Pca(g)|0;Tca(g,b,Qca(g)|0,j)}j=Qca(g)|0;if(!(j>>>0<(Rca(g)|0)>>>0)){k=-1;i=d;return k|0}k=XZ(a[j]|0)|0;i=d;return k|0}function J8(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=Vca(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=Pca(h)|0;j=Qca(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(TZ(d,-1)|0){Tca(h,g,j+ -1|0,k);l=WZ(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=UZ(d)|0;do{if(g){if(YZ(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=Pca(h)|0;Tca(h,j,(Qca(h)|0)+ -1|0,k);a[Qca(h)|0]=b;l=d;i=e;return l|0}function K8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(TZ(b,-1)|0){f=WZ(b)|0;i=d;return f|0}g=a;h=Qca(g)|0;j=h-(Pca(g)|0)|0;h=Vca(g)|0;do{if((h|0)==(Wca(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=Uca(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;_ba(o,0);Tba(o,Qba(o)|0);p=Hba(o)|0;Yca(g,p,p+(Gba(o)|0)|0);Xca(g,h-l|0);c[m>>2]=(Uca(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(Vca(g)|0)+1;h=c[(L8(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=Hba(a+32|0)|0;Tca(g,q,q+j|0,h)}f=Mca(g,b&255)|0;i=d;return f|0}function L8(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=M8(b,c,e)|0;i=d;return g|0}function M8(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=N8(0,a,b)|0;i=c;return(d?b:a)|0}function N8(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function O8(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;Oca(a);c[a>>2]=167376;wba(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;wba(e);P8(a,e);Iba(e);i=d;return}function P8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;Jba(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=Hba(e)|0;j=g+(Gba(e)|0)|0;c[b>>2]=j;g=Hba(e)|0;Tca(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=Gba(e)|0;c[b>>2]=(Hba(e)|0)+h;Tba(e,Qba(e)|0);b=a;a=Hba(e)|0;Yca(b,a,a+(Gba(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}Xca(b,h);i=d;return}function Q8(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=oc(d|0,167800)|0;J=hd(167808,167800)|0;K=(J|0)!=0;L=Tc()|0;if(K){M=c[b+536>>2]|0;N=ae(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;US(M,(I|0)!=0|0,167864,E);xc(167888,17,1,J|0)|0;xc(167912,10,1,J|0)|0;xc(167928,18,1,J|0)|0;R8(J,f,167952,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,167984)}else{c[G>>2]=ae(c[L>>2]|0)|0;TS(26,0,167816,G);G=c[b+536>>2]|0;E=ae(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;US(G,(I|0)!=0|0,167864,F)}xc(167992,348,1,I|0)|0;if((yc(H|0)|0)<0){c[D>>2]=ae(c[L>>2]|0)|0;TS(26,0,168344,D);dd(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Yc(167544,250,168368,qd(H|0)|0)|0)==0){TS(26,0,168392,C);dd(I|0)|0;O=1;i=j;return O|0}xc(168416,13,1,I|0)|0;xc(168432,12,1,I|0)|0;S8(I,2);xc(168448,6,1,I|0)|0;T8(I,c[b+84>>2]|0);xc(168456,8,1,I|0)|0;S8(I,2);xc(168472,8,1,I|0)|0;C=b+88|0;T8(I,c[C>>2]|0);xc(168488,10,1,I|0)|0;S8(I,2);xc(168504,6,1,I|0)|0;T8(I,167544);xc(168512,8,1,I|0)|0;S8(I,2);xc(168528,8,1,I|0)|0;T8(I,c[b+280>>2]|0);xc(168544,10,1,I|0)|0;S8(I,2);xc(168560,14,1,I|0)|0;T8(I,c[b+284>>2]|0);xc(168576,16,1,I|0)|0;S8(I,2);xc(168600,16,1,I|0)|0;T8(I,l);xc(168624,18,1,I|0)|0;S8(I,2);c[B>>2]=U8(l)|0;Bd(I|0,168648,B|0)|0;S8(I,2);P=+mU(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Bd(I|0,168688,A|0)|0;S8(I,2);P=+mU(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];Bd(I|0,168728,z|0)|0;S8(I,2);P=+mU(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Bd(I|0,168760,y|0)|0;S8(I,2);P=+mU(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Bd(I|0,168792,x|0)|0;S8(I,2);P=+mU(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Bd(I|0,168824,w|0)|0;S8(I,2);P=+mU(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Bd(I|0,168856,v|0)|0;S8(I,2);P=+mU(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Bd(I|0,168896,u|0)|0;S8(I,2);P=+pU(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];Bd(I|0,168928,t|0)|0;S8(I,2);c[s>>2]=kU(2)|0;Bd(I|0,168968,s|0)|0;S8(I,2);P=+oU(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];Bd(I|0,168992,r|0)|0;xc(169024,13,1,I|0)|0;xc(169040,16,1,I|0)|0;S8(I,2);P=+mU(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];Bd(I|0,169064,q|0)|0;S8(I,2);c[p>>2]=hU(8)|0;Bd(I|0,169088,p|0)|0;xc(169128,17,1,I|0)|0;xc(169152,22,1,I|0)|0;V8(I,b);xc(169176,23,1,I|0)|0;xc(169200,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{W8(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{W8(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{W8(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{W8(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{W8(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{W8(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{W8(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{W8(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}xc(169216,13,1,I|0)|0;xc(169232,12,1,I|0)|0;X8(I,J,f,c[C>>2]|0,b);xc(169248,13,1,I|0)|0;xc(169264,12,1,I|0)|0;Y8(I,c[b+68>>2]|0,b+56|0);xc(169280,13,1,I|0)|0;xc(169296,16,1,I|0)|0;Z8(I,J,f,b);xc(169320,17,1,I|0)|0;xc(169344,14,1,I|0)|0;dd(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((pma(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(pma(K|0)|0)<<1}else{Q=0}I=Nla(b+Q|0)|0;if((I|0)==0){cb(169360,169368,404,169392)}if((ab(J|0)|0)!=0){TS(26,0,169408,o)}if(e){e=c[C>>2]|0;c[n>>2]=169440;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;nc(I|0,169456,n|0)|0;if((wd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=169536|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;TS(1,0,169568,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;RS(1,0,169632,g);Ola(I);O=0;i=j;return O|0}function R8(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=iU(F)|0;H=jU(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+oU(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}xc(167888,17,1,a|0)|0;xc(170800,12,1,a|0)|0;xc(170816,12,1,a|0)|0;xc(170832,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;Bd(a|0,170848,D|0)|0;xc(170888,10,1,a|0)|0;xc(170904,11,1,a|0)|0;xc(170920,11,1,a|0)|0;xc(170936,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];Bd(a|0,170952,C|0)|0}else{xc(170976,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;Bd(a|0,170576,B|0)|0;xc(171e3,13,1,a|0)|0;if(E){xc(170816,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Bd(a|0,171016,A|0)|0}else{xc(170976,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;Bd(a|0,171040,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;Bd(a|0,170696,y|0)|0;xc(171088,10,1,a|0)|0;xc(171104,10,1,a|0)|0;xc(171088,10,1,a|0)|0;xc(171120,11,1,a|0)|0;c[x>>2]=b;Bd(a|0,171136,x|0)|0;c[w>>2]=d;Bd(a|0,171160,w|0)|0;xc(171176,33,1,a|0)|0;xc(171216,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;Bd(a|0,171256,v|0)|0;xc(170936,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];Bd(a|0,170952,u|0)|0}else{xc(171104,10,1,a|0)|0;xc(171088,10,1,a|0)|0;xc(171120,11,1,a|0)|0;c[t>>2]=b;Bd(a|0,171136,t|0)|0;c[s>>2]=d;Bd(a|0,171160,s|0)|0;xc(171176,33,1,a|0)|0;xc(171216,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;Bd(a|0,171256,r|0)|0;xc(170936,10,1,a|0)|0;xc(170976,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;Bd(a|0,170576,q|0)|0;xc(171e3,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];Bd(a|0,171016,p|0)|0}else{xc(170976,17,1,a|0)|0}xc(171288,32,1,a|0)|0;xc(171328,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;Bd(a|0,171360,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;Bd(a|0,170696,n|0)|0;i=m;return}function S8(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Yd(32,a|0)|0;}while((d|0)!=0);i=c;return}function T8(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==39){xc(170560,6,1,b|0)|0}else if((e|0)==60){xc(170544,4,1,b|0)|0}else if((e|0)==62){xc(170552,4,1,b|0)|0}else if((e|0)==34){xc(170568,6,1,b|0)|0}else{Yd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function U8(a){a=a|0;var b=0,c=0,d=0;b=i;c=oc(a|0,170536)|0;if((c|0)==0){d=-1;i=b;return d|0}$c(c|0,0,2)|0;a=Ab(c|0)|0;dd(c|0)|0;d=a;i=b;return d|0}function V8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=Nla((pma(l|0)|0)+15|0)|0;c[f>>2]=l;nc(m|0,170264,f|0)|0;S8(a,2);xc(170280,10,1,a|0)|0;T8(a,m);xc(170296,12,1,a|0)|0;S8(a,2);c[e>>2]=U8(m)|0;Bd(a|0,170312,e|0)|0;Ola(m);S8(a,2);xc(170344,9,1,a|0)|0;S8(a,4);xc(170360,22,1,a|0)|0;S8(a,4);xc(170384,22,1,a|0)|0;S8(a,4);xc(170408,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){$8(g,m,n);o=c[l>>2]|0;S8(a,4);xc(170440,8,1,a|0)|0;T8(a,o);xc(170456,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{e9(h,m,l);g=c[n>>2]|0;S8(a,4);xc(170440,8,1,a|0)|0;T8(a,g);xc(170456,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{$8(j,m,q);b=c[t>>2]|0;S8(a,4);xc(170480,8,1,a|0)|0;T8(a,b);xc(170496,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){S8(a,2);v=170520;w=v;x=xc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{e9(k,m,s);e=c[u>>2]|0;S8(a,4);xc(170480,8,1,a|0)|0;T8(a,e);xc(170496,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));S8(a,2);v=170520;w=v;x=xc(w|0,10,1,a|0)|0;i=d;return}function W8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;S8(a,2);c[f>>2]=c[b>>2];Bd(a|0,170200,f|0)|0;T8(a,c[b+4>>2]|0);xc(170232,11,1,a|0)|0;T8(a,c[b+8>>2]|0);xc(169904,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];_8(a,4,e);S8(a,2);xc(170248,12,1,a|0)|0;i=d;return}function X8(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{$8(p,r,v);R8(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,170016);w=v+9|0;sU(w);S8(a,2);c[o>>2]=c[f>>2];Bd(a|0,170024,o|0)|0;S8(a,4);xc(168448,6,1,a|0)|0;T8(a,c[s>>2]|0);xc(168456,8,1,a|0)|0;S8(a,4);c[n>>2]=kU(w)|0;Bd(a|0,169800,n|0)|0;S8(a,4);x=+pU(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Bd(a|0,169824,m|0)|0;S8(a,4);x=+oU(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];Bd(a|0,168992,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];_8(a,6,j);S8(a,2);xc(170048,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function Y8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{S8(a,2);d9(l,d,x);c[j>>2]=c[q>>2];Bd(a|0,169872,j|0)|0;d9(m,d,x);T8(a,c[r>>2]|0);xc(169904,3,1,a|0)|0;S8(a,4);xc(169912,7,1,a|0)|0;d9(n,d,x);if((c[s>>2]|0)>0){y=0;do{S8(a,6);c[g>>2]=0;Bd(a|0,169920,g|0)|0;y=y+1|0;d9(n,d,x);}while((y|0)<(c[s>>2]|0))}S8(a,4);xc(169944,8,1,a|0)|0;S8(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;d9(o,d,x);z=+mU(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;d9(p,d,x);A=hU(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;Bd(a|0,169960,f|0)|0;S8(a,2);xc(17e4,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function Z8(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{e9(n,o,v-u|0);R8(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,169752);q=v+9|0;sU(q);S8(a,2);xc(169760,15,1,a|0)|0;S8(a,4);c[m>>2]=c[e>>2];Bd(a|0,169776,m|0)|0;S8(a,4);c[l>>2]=kU(q)|0;Bd(a|0,169800,l|0)|0;S8(a,4);w=+pU(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];Bd(a|0,169824,j|0)|0;S8(a,4);w=+oU(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];Bd(a|0,168992,g|0)|0;S8(a,2);xc(169848,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function _8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;S8(a,b);xc(170064,16,1,a|0)|0;T8(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?170168:170184;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;Bd(a|0,170088,f|0)|0;i=e;return}function $8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){a9(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function a9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=oc(c[o>>2]|0,171400)|0;if((p|0)!=0){q=p;break}p=ae(c[(Tc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;VS(0,171408,g)}else{q=0}}while(0);g=JN(0)|0;if((g|0)==0){VS(0,171440,f)}f=a+8|0;c[a+20>>2]=Pla(c[f>>2]|0,32)|0;p=a+12|0;o=Pla((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=171472;c[o+12>>2]=0;c[o+16>>2]=0;UN(g,h);VN(g,9,78);h=c[n>>2]|0;do{if((h|0)==0){o=j;tma(o|0,0,1024)|0;while(1){r=ub(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((WN(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=cO($N(g)|0)|0;s=aO(g)|0;dd(q|0)|0;QN(g);r=c[a>>2]|0;c[e>>2]=171576;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;VS(0,171512,e)}else if((t|0)==11){dd(q|0)|0;break}}else{if((WN(g,h,pma(h|0)|0,1)|0)!=0){break}s=cO($N(g)|0)|0;o=aO(g)|0;QN(g);r=c[n>>2]|0;c[d>>2]=171576;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;VS(0,171616,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(171680,171576,295,171720)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(171744,171576,297,171720)}}function b9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((lma(172152,b)|0)==0){if((lma(c[d>>2]|0,172160)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}US(0,p,172168,l);l=c[43002]|0;p=c[43056]|0;do{if((l|0)==0|(p|0)==0){c[43056]=32;a=Nla(1152)|0;c[43002]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[43056]=p<<1;a=Qla(l,p*72|0)|0;c[43002]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(h9(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((lma(172232,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((lma(172240,u)|0)==0){c[43062]=Ed(c[t+4>>2]|0)|0}else{if((lma(172272,u)|0)==0){c[172252>>2]=Xb(c[t+4>>2]|0,0,10)|0;break}if((lma(172288,u)|0)==0){c[172260>>2]=Xb(c[t+4>>2]|0,0,10)|0;break}if((lma(172296,u)|0)==0){c[172256>>2]=Xb(c[t+4>>2]|0,0,10)|0;break}if((lma(172312,u)|0)==0){c[172264>>2]=Xb(c[t+4>>2]|0,0,10)|0;break}if((lma(172320,u)|0)!=0){v=23;break a}c[172268>>2]=(lma(c[t+4>>2]|0,172336)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];VS(0,172344,k)}else if((v|0)==45){i=e;return}}if((lma(171992,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=171576;c[j+4>>2]=k;c[j+8>>2]=v;VS(0,172376,j)}if((lma(172440,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=171576;c[h+4>>2]=j;VS(0,172448,h)}h=Xb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=171576;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;VS(0,172504,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=172568;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((lma(171936,b)|0)!=0){if((lma(172128,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=172672;m=Ed(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=172680;i=e;return}c[171956>>2]=0;c[171960>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((lma(m,172160)|0)==0){c[171956>>2]=Ed(c[b+4>>2]|0)|0}else{if((lma(m,172624)|0)!=0){break}c[171960>>2]=Ed(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[171956>>2]|0)==0){w=0;break}w=(c[171960>>2]|0)!=0|0}}while(0);US(0,w,172632,f);c[42988]=-1;f=171964|0;w=172248;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function c9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((lma(171936,b)|0)==0){o=e+0|0;p=171952|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));g9(e);i=d;return}if((lma(171992,b)|0)==0){e=h+24|0;r=Nla((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=Nla(36)|0;t=s;o=s+0|0;p=(c[43002]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((lma(172016,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Fd(e+(k*20|0)+8|0,172024,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((lma(172064,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Fd(h+(k*20|0)+8|0,172080,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((lma(172128,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function d9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){a9(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function e9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){a9(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;VS(0,171784,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=171864;p=o;VS(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=171864;p=o;VS(0,p,f)}}function f9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){Ola(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){Ola(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}Ola(k);c[d>>2]=0;i=b;return}function g9(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=Nla(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=pma(f|0)|0;c[e+64>>2]=k;k=c[43036]|0;do{if((k|0)==0){c[43036]=e;c[e+44>>2]=0;l=Nla(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){Bc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=Nla(384)|0;c[l>>2]=n;if((n|0)==0){Bc(-1)}else{tma(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[43036]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[43036]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=pma(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(pma(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;B=z;C=13;break};case 8:{D=o;C=15;break};case 4:{E=o;F=y;C=19;break};case 2:{G=o;H=x;I=y;C=21;break};case 3:{J=o;K=x;L=y;C=20;break};case 5:{M=o;N=y;C=18;break};case 10:{B=o;C=13;break};case 1:{O=o;P=x;Q=y;C=22;break};case 6:{R=o;S=y;C=17;break};case 7:{T=o;U=y;C=16;break};case 9:{V=o;C=14;break};default:{W=o;X=x;Y=y}}if((C|0)==13){o=((d[A+9|0]|0)<<16)+B|0;c[p>>2]=o;V=o;C=14}if((C|0)==14){o=((d[A+8|0]|0)<<8)+V|0;c[p>>2]=o;D=o;C=15}if((C|0)==15){T=D;U=((d[A+7|0]|0)<<24)+y|0;C=16}if((C|0)==16){R=T;S=((d[A+6|0]|0)<<16)+U|0;C=17}if((C|0)==17){M=R;N=((d[A+5|0]|0)<<8)+S|0;C=18}if((C|0)==18){E=M;F=(d[A+4|0]|0)+N|0;C=19}if((C|0)==19){J=E;K=((d[A+3|0]|0)<<24)+x|0;L=F;C=20}if((C|0)==20){G=J;H=((d[A+2|0]|0)<<16)+K|0;I=L;C=21}if((C|0)==21){O=G;P=((d[A+1|0]|0)<<8)+H|0;Q=I;C=22}if((C|0)==22){W=O;X=(d[A]|0)+P|0;Y=Q}Q=X-Y-W^W>>>13;X=Y-W-Q^Q<<8;Y=W-Q-X^X>>>13;W=Q-X-Y^Y>>>12;Q=X-Y-W^W<<16;X=Y-W-Q^Q>>>5;Y=W-Q-X^X>>>3;W=Q-X-Y^Y<<10;Q=X-Y-W^W>>>15;c[p>>2]=Q;p=(c[43036]|0)+40|0;W=c[p>>2]|0;Y=Q&(c[W+4>>2]|0)+ -1;Q=c[W>>2]|0;W=Q+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[Q+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[43036]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[43036]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=Nla((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){Bc(-1)}tma(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;Q=c[j>>2]|0;c[Y+24>>2]=(((Q<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((Q|0)==0){_=e}else{Q=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=Q}else{W=Q;X=j;while(1){j=X+16|0;P=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];O=Z+(A*12|0)+4|0;C=(c[O>>2]|0)+1|0;c[O>>2]=C;I=c[W+24>>2]|0;if(C>>>0>I>>>0){C=W+28|0;c[C>>2]=(c[C>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[O>>2]|0)>>>0)/(I>>>0)|0}c[X+12>>2]=0;I=Z+(A*12|0)|0;c[j>>2]=c[I>>2];j=c[I>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[I>>2]=X;I=c[h>>2]|0;if((P|0)==0){$=I;break}else{W=I;X=P}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){Q=$;Y=W;e=X}else{_=W;break}}}Ola(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function h9(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[43036]|0)==0){f=24}else{g=pma(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(pma(a|0)|0)+s|0;switch(v|0){case 8:{x=h;f=8;break};case 5:{y=h;z=u;f=11;break};case 3:{A=h;B=t;C=u;f=13;break};case 7:{D=h;E=u;f=9;break};case 9:{F=h;f=7;break};case 6:{G=h;H=u;f=10;break};case 10:{I=h;f=6;break};case 2:{J=h;K=t;L=u;f=14;break};case 1:{M=h;N=t;O=u;f=15;break};case 4:{P=h;Q=u;f=12;break};case 11:{I=((d[w+10|0]|0)<<24)+h|0;f=6;break};default:{R=h;S=t;T=u}}if((f|0)==6){F=((d[w+9|0]|0)<<16)+I|0;f=7}if((f|0)==7){x=((d[w+8|0]|0)<<8)+F|0;f=8}if((f|0)==8){D=x;E=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){G=D;H=((d[w+6|0]|0)<<16)+E|0;f=10}if((f|0)==10){y=G;z=((d[w+5|0]|0)<<8)+H|0;f=11}if((f|0)==11){P=y;Q=(d[w+4|0]|0)+z|0;f=12}if((f|0)==12){A=P;B=((d[w+3|0]|0)<<24)+t|0;C=Q;f=13}if((f|0)==13){J=A;K=((d[w+2|0]|0)<<16)+B|0;L=C;f=14}if((f|0)==14){M=J;N=((d[w+1|0]|0)<<8)+K|0;O=L;f=15}if((f|0)==15){R=M;S=(d[w]|0)+N|0;T=O}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[43036]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=pma(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((kma(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Gb(a|0,172704)|0)==0){V=0;break}else{W=172728}i=b;return W|0}}while(0);c[e>>2]=a;US(0,(V|0)!=0|0,172776,e);W=V+4|0;i=b;return W|0}function i9(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((j9(172832,a,b)|0)!=0){d=1;i=c;return d|0}d=(j9(172840,a,b)|0)!=0|0;i=c;return d|0}function j9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((lma(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function k9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(lma(c[121412>>2]|0,172848)|0)==0|0;US(0,m,172864,l);l=(lma(c[123316>>2]|0,172848)|0)==0|0;US(0,l,172920,k);k=(lma(c[125308>>2]|0,172848)|0)==0|0;US(0,k,172976,j);j=173040|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=173168|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[125312+(k<<2)>>2]|0;if((l|0)==1){if((j9(c[121288+(k<<2)>>2]|0,1,p)|0)!=0){q=5;break}}else if((l|0)==2){r=c[121288+(k<<2)>>2]|0;if(!((j9(r,1,p)|0)==0|(j|0)>=(a|0))){q=9;break}s=c[121288+(k<<2)>>2]|0;if((m9(s,p)|0)!=0){q=13;break}}l=k+1|0;if((l|0)<31){k=l}else{q=17;break a}}if((q|0)==5){q=0;l=173040+(k<<2)|0;if((c[l>>2]|0)!=0){q=6;break}c[l>>2]=1;t=n}else if((q|0)==9){q=0;l=173040+(k<<2)|0;if((c[l>>2]|0)!=0){q=10;break}c[l>>2]=1;c[173168+(k<<2)>>2]=l9(r,p)|0;t=j}else if((q|0)==13){q=0;l=173040+(k<<2)|0;if((c[l>>2]|0)!=0){q=14;break}c[l>>2]=1;c[173168+(k<<2)>>2]=n9(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;q=19;break}}if((q|0)==6){c[h>>2]=c[p>>2];TS(1,0,173296,h);o=1;i=d;return o|0}else if((q|0)==10){c[g>>2]=c[p>>2];TS(1,0,173296,g);o=1;i=d;return o|0}else if((q|0)==14){c[f>>2]=c[p>>2];TS(1,0,173296,f);o=1;i=d;return o|0}else if((q|0)==17){c[e>>2]=c[p>>2];TS(1,0,173352,e);o=1;i=d;return o|0}else if((q|0)==19){i=d;return o|0}return 0}function l9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((lma(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function m9(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(n9(a,b)|0)!=0|0;i=c;return d|0}function n9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=pma(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((mma(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function o9(){i=i;return}function p9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){Bc(0)}e=c[r>>2]|0;xc(173384,5,1,e|0)|0;f=b;b=0;while(1){Yd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}xc(173392,20,1,e|0)|0;Bc(0);return 0}function q9(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;Bd(d|0,173416,e|0)|0;if((b|0)==0){Bc(1)}else{zd(d|0)|0;y9();zd(d|0)|0;ib(6,0)|0;nd()}}function r9(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function s9(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function t9(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function u9(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function v9(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function w9(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}tma(p|0,32,b+(d-p)|0)|0;i=f;return}function x9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=174456+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[174500+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[174496+(e*48|0)>>2]|0)==1){z9(b)|0}k=174460+(e*48|0)|0;if((c[k>>2]|0)==0){break}dd(c[f>>2]|0)|0;Ola(c[k>>2]|0)}}while(0);do{if((h|0)==10){dd(g|0)|0;b=174460+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Od(k|0)|0;Ola(c[b>>2]|0)}}while(0);c[f>>2]=0}c[174492+(e*48|0)>>2]=0;c[174460+(e*48|0)>>2]=0;i=d;return 0}function y9(){var a=0,b=0;a=i;if((c[43356]|0)!=0){i=a;return}c[43356]=1;c[173432>>2]=0;b=0;do{c[173428>>2]=b;x9(173424)|0;b=b+1|0;}while((b|0)<100);i=a;return}function z9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[174472+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=174456+(d*48|0)|0;g=c[f>>2]|0;h=Ab(g|0)|0;$c(g|0,0,2)|0;if((h|0)>=(Ab(g|0)|0)){e=0;i=b;return e|0}if((c[174476+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[174484+(d*48|0)>>2]&2|0)!=0){zd(c[f>>2]|0)|0}d=Zc(sb(c[f>>2]|0)|0,h|0)|0;$c(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){B9(111,173440);e=111;i=b;return e|0}else{c[(Tc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function A9(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(sb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(wb(sb(a|0)|0)|0)==0|0;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else if((f|0)==24576){e=1;break}else{e=0;break}}}while(0);i=b;return e|0}function B9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Wc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;Bd(m|0,174352,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;Bd(m|0,174384,j|0)|0;l=m;break}else{n=c[174224+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;Bd(m|0,174408,h|0)|0;l=m;break}}}while(0);h=c[43604]|0;do{if((h|0)==0){xc(179288,29,1,l|0)|0}else{c[g>>2]=(h-174456|0)/48|0;Bd(l|0,174424,g|0)|0;b=c[(c[43604]|0)+4>>2]|0;if((b|0)==0){xc(179272,10,1,l|0)|0;break}else{c[f>>2]=b;Bd(l|0,179256,f|0)|0;break}}}while(0);f=c[44830]|0;if((f|0)!=0){c[d>>2]=f;Bd(l|0,179328,d|0)|0}d=(c[44850]|0)!=0?179408:179424;f=(c[44858]|0)!=0?179440:179456;g=(c[44868]|0)!=0?179480:179496;c[e>>2]=(c[44844]|0)!=0?179384:179392;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;Bd(l|0,179352,e|0)|0;q9(179512,1)}function C9(){var a=0,b=0;a=i;c[44880]=1;b=c[r>>2]|0;c[43614]=b;c[174476>>2]=A9(b)|0;c[174480>>2]=1;c[174496>>2]=1;b=c[s>>2]|0;c[174696>>2]=b;c[174716>>2]=A9(b)|0;c[174720>>2]=1;c[174736>>2]=0;b=c[t>>2]|0;c[174744>>2]=b;c[174764>>2]=A9(b)|0;c[174768>>2]=1;c[174784>>2]=1;i=a;return}function D9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=Dc(g|0,c[184768+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[44882]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=Ab(c[k>>2]|0)|0;l=Dc(c[f>>2]|0,c[184768+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[44882]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;$c(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Tc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}$c(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function E9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){B9(b,d)}d=c[44884]|0;if((d|0)!=0){Ie[d&7]()|0}c[(Tc()|0)>>2]=b;i=e;return b|0}function F9(a){a=a|0;var b=0,d=0;b=i;c[44914]=0;c[44916]=0;c[44918]=0;d=((G9(a,0)|0)==0)<<31>>31;i=b;return d|0}function G9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[44918]|0;c[44918]=j+1;if((j|0)==1){c[44916]=d}if((L9(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=M9(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function H9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[44914]|0;l=179680+(k<<4)|0;m=c[l>>2]|0;switch(I9(m)|0){case 6:{n=c[179684+(k<<4)>>2]|0;o=(c[46130]|0)+1|0;c[46130]=o;c[184528+(o<<2)>>2]=n;c[44914]=k+1;continue b;break};case 1:{n=c[179684+(k<<4)>>2]|0;o=(c[46146]|0)+1|0;c[46146]=o;c[184592+(o<<2)>>2]=n;c[44914]=k+1;continue b;break};case 2:{c[46130]=0;c[46146]=0;c[44914]=c[179684+(k<<4)>>2];if(b){p=24;break a}if((c[46142]|0)==0){j=0;p=37;break a}n=Ie[c[44900]&7]()|0;if((n|0)==0){continue b}else{j=n;p=37;break a}break};case 3:{n=c[46130]|0;o=184528+(n<<2)|0;q=c[o>>2]|0;c[o>>2]=q+ -1;if((q|0)<2){c[46130]=n+ -1;c[46146]=(c[46146]|0)+ -1;c[44914]=k+1;continue b}else{n=c[46146]|0;c[46146]=n+ -1;c[44914]=(c[184592+(n<<2)>>2]|0)+1;continue b}break};case 22:{c[44892]=1;c[44914]=k+1;continue b;break};case 21:{c[44892]=0;c[44914]=k+1;continue b;break};case 33:{c[46158]=1;c[44914]=k+1;continue b;break};case 16:{if(b){p=28;break a}c[44914]=k+1;continue b;break};case 20:{c[44910]=c[179684+(k<<4)>>2];c[44914]=k+1;continue b;break};case 18:{c[44890]=1;c[44914]=k+1;continue b;break};case 8:{n=c[46130]|0;s=184528+(n<<2)|0;t=c[s>>2]|0;if((t|0)>=1){p=10;break b}c[46130]=n+ -1;c[44914]=k+1;continue b;break};case 9:{n=(oe[c[44898]&127](l)|0)==0;c[44914]=(c[44914]|0)+1;if(n){break b}else{continue b}break};case 19:case 17:{c[44890]=0;c[44914]=k+1;continue b;break};default:{p=4;break a}}}if((p|0)==10){p=0;if(b){p=11;break}c[s>>2]=t+ -1;c[46142]=1;k=re[c[44896]&63](l,g,d)|0;if((k|0)>0){p=13;break}if((k|0)<0){p=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;p=37;break}}if((p|0)==4){h=c[r>>2]|0;d=c[44830]|0;c[f>>2]=m;c[f+4>>2]=d;Bd(h|0,184480,f|0)|0;if((c[c[44886]>>2]|0)==0){B9(100,184512);j=100;i=e;return j|0}else{c[(Tc()|0)>>2]=100;j=100;i=e;return j|0}}else if((p|0)==11){j=Ie[c[44884]&7]()|0;i=e;return j|0}else if((p|0)==13){f=c[c[44886]>>2]|0;j=E9(f,c[(Tc()|0)>>2]|0,184576)|0;i=e;return j|0}else if((p|0)==15){if((c[(c[44886]|0)+8>>2]|0)==0){B9(-1,184576);j=-1;i=e;return j|0}else{c[(Tc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((p|0)==24){j=Ie[c[44884]&7]()|0;i=e;return j|0}else if((p|0)==28){j=Ie[c[44884]&7]()|0;i=e;return j|0}else if((p|0)==37){i=e;return j|0}return 0}function I9(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function J9(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=H9(b,0,0)|0;i=a;return d|0}function K9(){c[44906]=0;c[44914]=0;c[46146]=0;c[46130]=0;c[46142]=0;c[46148]=0;c[46132]=0;i=i;return}function L9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[44914]|0;if((g|0)>299){xc(184656,24,1,c[r>>2]|0)|0;q9(c[44830]|0,1)}else{c[179680+(g<<4)>>2]=a;c[179684+(g<<4)>>2]=b;c[179688+(g<<4)>>2]=d;c[179692+(g<<4)>>2]=e;c[44914]=g+1;i=f;return g|0}return 0}function M9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=N9(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[44918]|0)+ -1|0;c[44918]=h;if((h|0)==0){L9(2,c[44916]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{L9(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function N9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((O9(b,e)|0)!=0){g=c[e>>2]|0;break}if((P9(b,e)|0)!=0){g=c[e>>2]|0;break}h=Q9(b,f,1)|0;j=L9(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=G9(h,j)|0}}while(0);i=d;return g|0}function O9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 36:{L9(33,0,0,0)|0;g=b;h=30;break};case 115:case 83:{j=b+1|0;k=a[j]|0;if(k<<24>>24==80|k<<24>>24==112){l=j;m=18}else if(k<<24>>24==83|k<<24>>24==115){l=j;m=19}else{l=b;m=17}L9(m,0,0,0)|0;g=l;h=30;break};case 116:case 84:{j=b+1|0;k=a[j]|0;if(k<<24>>24==76|k<<24>>24==108){n=j;o=13}else if(k<<24>>24==82|k<<24>>24==114){n=j;o=14}else{n=b;o=15}j=Q9(n+1|0,f,0)|0;if((j|0)==0){h=15;break a}L9(o,c[f>>2]|0,0,0)|0;g=j+ -1|0;h=30;break};case 45:{p=1;h=13;break};case 39:case 34:case 2:{c[179688+((L9(11,0,0,0)|0)<<4)>>2]=b;j=R9(b)|0;c[d>>2]=j;q=(j|0)!=0|0;i=e;return q|0};case 58:{L9(16,0,0,0)|0;g=b;h=30;break};case 120:case 88:{L9(4,1,0,0)|0;g=b;h=30;break};case 112:case 80:{L9(20,1,0,0)|0;g=b;h=30;break};case 47:{L9(5,0,0,0)|0;g=b;h=30;break};case 98:case 66:{j=b+1|0;k=a[j]|0;if(k<<24>>24==90|k<<24>>24==122){L9(22,0,0,0)|0;g=j;h=30;break a}else{L9(21,0,0,0)|0;g=j;h=30;break a}break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{r=b;s=0;h=14;break};case 43:{p=0;h=13;break};default:{q=0;i=e;return q|0}}}while(0);if((h|0)==13){r=b+1|0;s=p;h=14}b:do{if((h|0)==14){p=Q9(r,f,0)|0;if((p|0)==0){h=15;break}switch(a[p]|0){case 112:case 80:{b=c[f>>2]|0;if((s|0)==0){t=b}else{o=0-b|0;c[f>>2]=o;t=o}L9(20,t,0,0)|0;g=p;h=30;break b;break};case 104:case 72:{o=c[f>>2]|0;c[179688+((L9(12,o,0,0)|0)<<4)>>2]=p+1;g=p+o|0;h=30;break b;break};case 120:case 88:{L9(4,c[f>>2]|0,0,0)|0;g=p;h=30;break b;break};default:{q=0;i=e;return q|0}}}}while(0);if((h|0)==15){c[d>>2]=0;q=1;i=e;return q|0}else if((h|0)==30){c[d>>2]=g+1;q=1;i=e;return q|0}return 0}function P9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=Q9(b,f,1)|0;L9(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 100:case 68:{l=Q9(f,g,0)|0;if((l|0)==0){m=4;break a}n=c[g>>2]|0;if((n|0)==0){o=l;m=45;break a}if((a[l]|0)==46){p=Q9(l+1|0,h,0)|0;if((p|0)==0){m=4;break a}q=p;r=c[h>>2]|0}else{c[h>>2]=0;q=l;r=0}L9(26,n,r,0)|0;o=q;m=45;break};case 101:case 69:{s=1;m=3;break};case 97:case 65:{n=f;while(1){t=a[n]|0;if(t<<24>>24==32){n=n+1|0}else{break}}if(!((t+ -48<<24>>24&255)<10)){L9(30,0,0,0)|0;o=n;m=45;break a}l=Q9(n,g,1)|0;p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}L9(31,p,0,0)|0;o=l;m=45;break};case 105:case 73:{u=7;v=10;m=38;break};case 111:case 79:{u=32;v=34;m=38;break};case 108:case 76:{l=Q9(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}L9(29,p,0,0)|0;o=l;m=45;break};case 102:case 70:{l=Q9(f,g,0)|0;if((l|0)==0){m=4;break a}p=c[g>>2]|0;if((p|0)==0){o=l;m=45;break a}if((a[l]|0)==46){w=Q9(l+1|0,h,0)|0;if((w|0)==0){m=4;break a}x=w;y=c[h>>2]|0}else{c[h>>2]=0;x=l;y=0}L9(23,p,y,0)|0;o=x;m=45;break};case 122:case 90:{u=35;v=36;m=38;break};case 103:case 71:{s=0;m=3;break};default:{c[44914]=(c[44914]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((m|0)==3){b=Q9(f,g,0)|0;if((b|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=b;m=45;break}y=a[b]|0;if(y<<24>>24==46){t=Q9(b+1|0,h,0)|0;if((t|0)==0){m=4;break}A=t;B=a[t]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){L9((s|0)==1?24:27,x,c[h>>2]|0,0)|0;o=A;m=45;break}y=Q9(A+1|0,j,0)|0;if((y|0)==0){m=4;break}L9((s|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;o=y;m=45}else if((m|0)==38){y=Q9(f,g,0)|0;if((y|0)==0){m=4;break}x=c[g>>2]|0;if((x|0)==0){o=y;m=45;break}if((a[y]|0)!=46){L9(u,x,0,0)|0;o=y;m=45;break}b=Q9(y+1|0,h,0)|0;if((b|0)==0){m=4;break}L9(v,x,c[h>>2]|0,0)|0;o=b;m=45}}while(0);if((m|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((m|0)==45){c[d>>2]=o;z=1;i=e;return z|0}return 0}function Q9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function R9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[44886]>>2]|0)==0){B9(100,184640);n=0;i=d;return n|0}else{c[(Tc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function S9(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[184710|0]=48;k=184710|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=184688+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function T9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[44908]|0;f=c[44904]|0;if((e|0)>(f|0)){c[44904]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[46196]|0)){h=g}else{U9(f,g);h=c[44904]|0}g=c[46198]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Pd(g|0,c[44882]|0)|0;h=pma(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Yd(a[k]|0,c[44882]|0)|0;Pd(h|0,c[44882]|0)|0;b=pma(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function U9(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[46198]|0;if((f|0)==184872){c[46196]=1024;g=1024}else{g=c[46196]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[46196]=j;h=j}j=Nla(h)|0;if((j|0)==0){B9(113,185272);k=c[46198]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[46198]|0}else{l=k}if((l|0)==184872){m=184792;c[46198]=j;i=e;return}Ola(l);m=184792;c[46198]=j;i=e;return}function V9(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[44904]|0;f=c[46196]|0;if((e|0)<(f|0)){g=e}else{U9(e,f);g=c[44904]|0}c[44904]=g+1;a[(c[46198]|0)+g|0]=b;i=d;return}function W9(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[44868]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){B9(101,184800);l=101;i=d;return l|0}else{c[(Tc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[44880]|0)==0){C9();m=c[f>>2]|0}else{m=k}k=174456+(m*48|0)|0;c[43604]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){$9(k,c[b+12>>2]|0,j);o=aaa(j,h)|0;if((o|0)==(c[174464+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[174468+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=x9(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[174488+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=174472+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[174488+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=174480+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[174480+(m*48|0)>>2]=1;r=1;break}else{c[174480+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];nc(j|0,184808,e|0)|0}else{$9(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){X9(107,184800,b);l=107;i=d;return l|0}else{c[(Tc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=174500+(m*48|0)|0;c[q>>2]=0;c[174492+(m*48|0)>>2]=0;e=174496+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=174484+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 78:case 110:{if((Ic(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){X9(128,184800,b);l=128;i=d;return l|0}else{c[(Tc()|0)>>2]=128;l=128;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;o=Nb()|0;c[n>>2]=o;if((o|0)!=0){c[174460+(m*48|0)>>2]=0;c[174468+(m*48|0)>>2]=-1;c[174464+(m*48|0)>>2]=-1;c[174476+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Tc()|0;s=c[k>>2]|0;if(o){X9(s,184800,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 79:case 111:{if((Ic(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Tc()|0;o=c[k>>2]|0;if(s){X9(o,184800,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 82:case 114:{break};default:{break b}}}while(0);o=oc(j|0,c[46192]|0)|0;if((o|0)==0){break}dd(o|0)|0}}while(0);q=Nla((pma(j|0)|0)+1|0)|0;c[174460+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){X9(113,184824,b);l=113;i=d;return l|0}else{c[(Tc()|0)>>2]=113;l=113;i=d;return l|0}}vma(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=oc(j|0,c[184768+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=oc(j|0,c[184728+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=oc(j|0,c[184768+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Tc()|0;o=c[g>>2]|0;if(h){B9(o,184800);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=174476+(m*48|0)|0;c[r>>2]=A9(u)|0;u=aaa(j,174468+(m*48|0)|0)|0;c[174464+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){X9(108,184800,b);l=108;i=d;return l|0}else{c[(Tc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){qb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if(($c(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){X9(129,184800,b);l=129;i=d;return l|0}else{c[(Tc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function X9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){B9(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[46196]|0)){j=d;k=g}else{U9(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[46198]|0;c[(c[43604]|0)+4>>2]=f;$9(k,j,f);B9(a,b);i=e;return}function Y9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;nc(j|0,184808,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=pma(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?184840:184848;c[h+24>>2]=(b|0)==5?184856:184864;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=W9(h)|0;i=e;return a|0}function Z9(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=174456+(d*48|0)|0;c[43604]=e;if(d>>>0>99){if((c[a>>2]|0)==0){B9(101,185288);f=101;i=b;return f|0}else{c[(Tc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((Y9(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){B9(114,185296);f=114;i=b;return f|0}else{c[(Tc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[174480+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){B9(102,185296);f=102;i=b;return f|0}else{c[(Tc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function _9(){var a=0,b=0;a=i;b=J9()|0;c[44830]=0;i=a;return b|0}function $9(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function aaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((rc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function baa(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[44910]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[44890]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];nc(p|0,185304,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(pma(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;le[c[44894]&511](32);}while((A|0)>0)}if((D|0)!=0){le[c[44894]&511]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{le[c[44894]&511](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Lc(A|0)|0)+1|0;c[m>>2]=t-(c[44910]|0);nc(A|0,185312,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;le[c[44894]&511](32);}while((z|0)>0)}if((x|0)!=0){le[c[44894]&511]((w|0)!=0?45:43)}z=c[44910]|0;do{if((z|0)<1){le[c[44894]&511](46);y=c[44894]|0;if((z|0)<0){G=y;J=z;while(1){le[G&511](48);I=J+1|0;K=c[44894]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}le[N&511](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}le[c[44894]&511](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[44894]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){le[P&511](a[J]|0);R=Q+ -1|0;S=c[44894]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}le[T&511](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;le[c[44894]&511](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){le[c[44894]&511](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;le[c[44894]&511](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){le[c[44894]&511](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;le[c[44894]&511](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;le[c[44894]&511](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;le[c[44894]&511](42);}while((_|0)>0);i=l;return 0}function caa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[44910]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(nc(n|0,185320,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[44890]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;le[c[44894]&511](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;le[c[44894]&511](32);}while((b|0)>0)}do{if(q){if((c[44890]|0)==0){break}le[c[44894]&511](43)}else{le[c[44894]&511](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;le[c[44894]&511](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;le[c[44894]&511](48);}while((z|0)>0);i=j;return 0}function daa(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{le[c[44894]&511](32);e=e+1|0;}while((e|0)<(d|0))}d=c[44894]|0;if((h|0)==0){le[d&511](70);i=g;return 0}else{le[d&511](84);i=g;return 0}return 0}function eaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[44906]|0)!=0){g=faa()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 35:{laa(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 31:{jaa(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 23:{h=caa(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 28:case 27:{h=kaa(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 7:{gaa(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 30:{iaa(b,d);h=0;i=e;return h|0};case 36:{laa(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=baa(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 10:{haa(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 29:{daa(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 32:{gaa(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 34:{haa(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;Bd(h|0,185328,f|0)|0;q9(c[44830]|0,1)}}return 0}function faa(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[44906]|0;c[44906]=0;if((c[44868]|0)!=0){if((b|0)>0){d=c[44908]|0;e=c[44904]|0;if((d|0)<=(e|0)){f=b;while(1){le[c[44894]&511](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[44904]=f;h=0;i=a;return h|0}f=b-d+e|0;c[44904]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){le[c[44894]&511](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[44904]|0;f=j+b|0;if((f|0)>=0){if((c[44908]|0)<(j|0)){c[44908]=j}c[44904]=f;h=0;i=a;return h|0}if((c[c[44886]>>2]|0)==0){B9(110,185416);h=110;i=a;return h|0}else{c[(Tc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[44904]|0;if((c[44908]|0)<(f|0)){c[44908]=f}j=f+b|0;c[44904]=j;c[44912]=(c[44912]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[44886]>>2]|0)==0){B9(110,185416);h=110;i=a;return h|0}else{c[(Tc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[44904]|0;f=j+b|0;if((f|0)>=(c[(c[44888]|0)+16>>2]|0)){if((c[c[44886]>>2]|0)==0){B9(110,185432);h=110;i=a;return h|0}else{c[(Tc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[44908]|0;if((d|0)<=(j|0)){e=b;while(1){le[c[44894]&511](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[44912]=(c[44912]|0)+b;c[44904]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[44912]=(c[44912]|0)+f;c[44904]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){le[c[44894]&511](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function gaa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==1){l=a[d]|0}else if((f|0)==4){l=c[d>>2]|0}else{l=b[d>>1]|0}d=S9(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[44890]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{le[c[44894]&511](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{le[c[44894]&511](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[44890]|0)==0){break}le[c[44894]&511](43)}else{le[c[44894]&511](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){le[c[44894]&511](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function haa(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=S9(m,k,l,h)|0;h=c[l>>2]|0;g=(c[44890]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{le[c[44894]&511](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{le[c[44894]&511](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[44890]|0)==0){break}le[c[44894]&511](43)}else{le[c[44894]&511](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){le[c[44894]&511](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){le[c[44894]&511](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{le[c[44894]&511](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function iaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;le[c[44894]&511](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function jaa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;le[c[44894]&511](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;le[c[44894]&511](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function kaa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=baa(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=baa(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[44910]|0;c[44910]=0;p=(e|0)==0?4:e+2|0;e=caa(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{le[c[44894]&511](32);f=f+1|0;}while((f|0)<(p|0))}c[44910]=o;n=e;i=j;return n|0}function laa(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{le[c[44894]&511](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;le[c[44894]&511](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;le[c[44894]&511](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){le[c[44894]&511](a[185392+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){le[c[44894]&511](a[185392+((d[p]|0)>>>4)|0]|0);le[c[44894]&511](a[185392+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function maa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 5:{f=Ie[c[44902]&7]()|0;i=b;return f|0};case 15:{c[44906]=(c[a+4>>2]|0)+ -1-(c[44904]|0);f=1;i=b;return f|0};case 11:{f=naa(c[a+8>>2]|0)|0;i=b;return f|0};case 12:{f=oaa(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 13:{g=(c[44906]|0)-(c[a+4>>2]|0)|0;h=0-(c[44904]|0)|0;c[44906]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 4:case 14:{c[44906]=(c[44906]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;Bd(f|0,185360,d|0)|0;q9(c[44830]|0,1)}}return 0}function naa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[44906]|0)!=0){e=faa()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}le[c[44894]&511](e<<24>>24);n=b}else{le[c[44894]&511](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function oaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[44906]|0)!=0){f=faa()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;le[c[44894]&511](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function paa(){var a=0,b=0;a=i;b=T9(10)|0;c[44906]=0;c[44904]=0;c[44908]=0;i=a;return(b|0)==0|0}function qaa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[44880]|0)==0){C9()}c[44844]=0;c[44850]=1;c[44858]=1;c[44868]=1;d=Z9(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[44886]=a;c[44904]=0;c[44906]=0;c[44908]=0;c[46158]=0;c[44910]=0;d=c[a+12>>2]|0;c[44830]=d;c[44882]=c[c[43604]>>2];if((F9(d)|0)<0){if((c[a>>2]|0)==0){B9(100,185440);e=100;i=b;return e|0}else{c[(Tc()|0)>>2]=100;e=100;i=b;return e|0}}c[44894]=304;c[44896]=46;c[44898]=111;c[44884]=4;c[44900]=5;c[44902]=6;K9();c[44890]=0;d=c[43604]|0;c[44892]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((D9(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Tc()|0;f=c[a>>2]|0;if(d){B9(f,185448);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function raa(){var a=0,b=0;a=i;if((c[46158]|0)==0){b=T9(10)|0}else{T9(0)|0;zd(c[44882]|0)|0;b=0}c[44906]=0;c[44904]=0;c[44908]=0;i=a;return b|0}function saa(){var a=0,b=0,d=0;a=i;if((c[46142]|0)==0){b=0}else{d=T9(10)|0;c[46142]=0;b=d}c[44906]=0;c[44904]=0;c[44908]=0;i=a;return b|0}function taa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;Paa(186176,h,186232);c[46366]=187684;c[185472>>2]=187704;c[185468>>2]=0;Gca(185472|0,186176);c[185544>>2]=0;c[185548>>2]=-1;j=c[t>>2]|0;c[46570]=187552;oia(186284|0);k=186288|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[46570]=186792;c[186312>>2]=j;pia(g,186284|0);k=sia(g,190344)|0;l=k;qia(g);c[186316>>2]=l;c[186320>>2]=186240;a[186324|0]=(oe[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[46388]=187764;c[185556>>2]=187784;Gca(185556|0,186280);c[185628>>2]=0;c[185632>>2]=-1;l=c[r>>2]|0;c[46582]=187552;oia(186332|0);k=186336|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[46582]=186792;c[186360>>2]=l;pia(f,186332|0);k=sia(f,190344)|0;g=k;qia(f);c[186364>>2]=g;c[186368>>2]=186248;a[186372|0]=(oe[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[46410]=187764;c[185644>>2]=187784;Gca(185644|0,186328);c[185716>>2]=0;c[185720>>2]=-1;g=c[(c[(c[46410]|0)+ -12>>2]|0)+185664>>2]|0;c[46432]=187764;c[185732>>2]=187784;Gca(185732|0,g);c[185804>>2]=0;c[185808>>2]=-1;c[(c[(c[46366]|0)+ -12>>2]|0)+185536>>2]=185552;g=(c[(c[46410]|0)+ -12>>2]|0)+185644|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[46410]|0)+ -12>>2]|0)+185712>>2]=185552;Baa(186376,h,186256|0);c[46454]=187724;c[185824>>2]=187744;c[185820>>2]=0;Gca(185824|0,186376);c[185896>>2]=0;c[185900>>2]=-1;c[46608]=187616;oia(186436|0);h=186440|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[46608]=186536;c[186464>>2]=j;pia(e,186436|0);j=sia(e,190352)|0;h=j;qia(e);c[186468>>2]=h;c[186472>>2]=186264;a[186476|0]=(oe[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[46476]=187804;c[185908>>2]=187824;Gca(185908|0,186432);c[185980>>2]=0;c[185984>>2]=-1;c[46620]=187616;oia(186484|0);h=186488|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[46620]=186536;c[186512>>2]=l;pia(d,186484|0);l=sia(d,190352)|0;h=l;qia(d);c[186516>>2]=h;c[186520>>2]=186272;a[186524|0]=(oe[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[46498]=187804;c[185996>>2]=187824;Gca(185996|0,186480);c[186068>>2]=0;c[186072>>2]=-1;h=c[(c[(c[46498]|0)+ -12>>2]|0)+186016>>2]|0;c[46520]=187804;c[186084>>2]=187824;Gca(186084|0,h);c[186156>>2]=0;c[186160>>2]=-1;c[(c[(c[46454]|0)+ -12>>2]|0)+185888>>2]=185904;h=(c[(c[46498]|0)+ -12>>2]|0)+185996|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[46498]|0)+ -12>>2]|0)+186064>>2]=185904;i=b;return}function uaa(a){a=a|0;a=i;Eda(185552)|0;Eda(185728)|0;Lda(185904)|0;Lda(186080)|0;i=a;return}function vaa(a){a=a|0;var b=0;b=i;c[a>>2]=187616;qia(a+4|0);i=b;return}function waa(a){a=a|0;var b=0;b=i;c[a>>2]=187616;qia(a+4|0);Vla(a);i=b;return}function xaa(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;oe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=sia(d,190352)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(oe[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function yaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=Ee[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((xc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((zd(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function zaa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=xc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((De[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function Aaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((xc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Me[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((xc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((xc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Baa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=187616;j=b+4|0;oia(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=186648;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;pia(g,j);j=sia(g,190352)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=oe[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(oe[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Aha(186744)}else{qia(g);i=f;return}}function Caa(a){a=a|0;var b=0;b=i;c[a>>2]=187616;qia(a+4|0);i=b;return}function Daa(a){a=a|0;var b=0;b=i;c[a>>2]=187616;qia(a+4|0);Vla(a);i=b;return}function Eaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=sia(d,190352)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=oe[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(oe[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Aha(186744)}else{i=e;return}}function Faa(a){a=a|0;var b=0,c=0;b=i;c=Iaa(a,0)|0;i=b;return c|0}function Gaa(a){a=a|0;var b=0,c=0;b=i;c=Iaa(a,1)|0;i=b;return c|0}function Haa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Me[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((vd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}



function Pe(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Qe(){return i|0}function Re(a){a=a|0;i=a}function Se(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Te(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Ue(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Ve(a){a=a|0;J=a}function We(a){a=a|0;K=a}function Xe(a){a=a|0;L=a}function Ye(a){a=a|0;M=a}function Ze(a){a=a|0;N=a}function _e(a){a=a|0;O=a}function $e(a){a=a|0;P=a}function af(a){a=a|0;Q=a}function bf(a){a=a|0;R=a}function cf(a){a=a|0;S=a}function df(a){a=a|0;var b=0,d=0;b=i;AX(a)|0;d=a+540|0;oe[c[(c[d>>2]|0)+40>>2]&127](a)|0;oe[c[(c[d>>2]|0)+28>>2]&127](a)|0;oe[c[(c[d>>2]|0)+32>>2]&127](a)|0;oe[c[(c[d>>2]|0)+48>>2]&127](a)|0;oe[c[(c[d>>2]|0)+52>>2]&127](a)|0;gW(a);i=b;return}function ef(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=pma(B|0)|0;D=Nla(C+11|0)|0;Ama(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=oc(D|0,32)|0;if((C|0)==0){B=ae(c[(Tc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;TS(23,0,40,u);dd(0)|0;F=0}else{F=C}Ola(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Ie[c[117076>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{sU(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}sU(2);rU(2)}gU(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];RS(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];VV(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];RS(23,1,144,r);Z=iX(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}df(b);hW(b);if((c[116268>>2]|0)!=0){le[c[29182]&511](23)}if((c[2]|0)!=0){rU(4)}A=XV(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];RS(7,1,200,q);if((c[173132>>2]|0)==0){me[c[157756>>2]&127](157736,b)}ZV(b,c[J>>2]|0,z,d);if((c[116204>>2]|0)!=0){le[c[29182]&511](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;lW(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){uU(4)}if((uX(b,1,1)|0)!=0){c[B>>2]=1;lW(b)}oe[c[(c[K>>2]|0)+88>>2]&127](b)|0;gW(b);pW(b);hW(b);do{if((T|0)==0){_=0}else{rU(7);uU(2);A=(xc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(xc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+mU(2);if(!$){aa=0;break}aa=(xc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+mU(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=hU(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(xc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+mU(ba+9|0);if((ca|0)==0){ka=0}else{ka=(xc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}uU(7);if((la|0)!=0){_=T;break}c[p>>2]=ae(c[(Tc()|0)>>2]|0)|0;TS(23,0,240,p);dd(T|0)|0;_=0}}while(0);if((c[173132>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;me[c[157756>>2]&127](157736,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[40834]|0)!=0){ca=f;ba=163344;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];JS(M,f);Yd(10,M|0)|0;ba=c[40842]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;RS(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((TW(b,0)|0)!=0){ma=58;break}if((LW(b,0)|0)!=0){ma=58;break}if((BW(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];RS(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((TW(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];RS(1,0,448,m);U=_;V=-2;break}if((LW(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];RS(1,0,536,l);U=_;V=-3;break}T=(BW(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];RS(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];RS(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}dd(U|0)|0;i=e;return V|0}function ff(a){a=a|0;i=i;return 0}function gf(a){a=a|0;i=i;return 0}function hf(a){a=a|0;i=i;return 0}function jf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+4|0;l=uW(+h[c[c[k>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+4|0;k=uW(+h[c[c[j>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+4|0;j=yW(+h[c[c[k>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+4|0;k=yW(+h[c[c[g>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+8|0]=f;i=d;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3456>>3]=+h[b+160>>3]*1.0e-5;i=i;return}function lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3448>>3]=+h[b+152>>3]+-273.15;i=i;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+104>>3]*1.0e-5;i=i;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+88>>3]+-273.15;i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1208>>3]=+h[b+80>>3]*1.0e-5;i=i;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1200>>3]=+h[b+64>>3]+-273.15;i=i;return}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3360>>3]=+h[b+160>>3]*1.0e-5;i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+24>>3]+-273.15;i=i;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[b+16>>3]*1.0e-5;i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[b>>3]+-273.15;i=i;return}function vf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+136>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3520|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,872,864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3520|0;q=p;h[q>>3]=n;i=d;return}function wf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;m=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+160>>3];a=e;n=968;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];ln(f,k,m,45263.2387446934,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];bn(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+1944>>3]=+h[g>>3];i=b;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+128>>3]*.001519;i=i;return}function yf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+96>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,992,984,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}function zf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+72>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1272|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,1104,1096,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1272|0;q=p;h[q>>3]=n;i=d;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=1.0- +h[b+136>>3];i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+112>>3]*.001519;i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1816>>3]=+h[b+120>>3]*.001519;i=i;return}function Df(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;Jm(d,c[a+536>>2]|0,293.15);e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3368>>3]=+xd(+(+h[d>>3]),+(+h[e+160>>3]*.999));i=b;return}function Ef(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));if(k!=0.0){l=k;m=g;n=.99/l;o=j*n;p=o*.6219647130774989;q=+xd(+p,1.0);r=m;s=r+3384|0;t=s;h[t>>3]=q;i=d;return}u=+XS(c[b+536>>2]|0,k,1216,1208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=u;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=.99/l;o=j*n;p=o*.6219647130774989;q=+xd(+p,1.0);r=m;s=r+3384|0;t=s;h[t>>3]=q;i=d;return}function Ff(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3400>>3]=+yd(+(.01- +h[d+3384>>3]),0.0);i=b;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3392>>3]=.01- +h[b+3400>>3];i=i;return}function Hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3400>>3];k=1.0-j;if(k!=0.0){l=k;m=j;n=g;o=f}else{j=+XS(c[b+536>>2]|0,k,1288,1280,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=j;m=+h[g+3400>>3];n=g;o=f}j=284.1807127034489/l;l=1.0-m;m=+h[n+3392>>3];if(l!=0.0){p=n;q=m/l;r=q*461.5233290850878;s=j+r;t=p;u=t+3416|0;v=u;h[v>>3]=s;i=d;return}if(m==0.0){p=n;q=m;r=q*461.5233290850878;s=j+r;t=p;u=t+3416|0;v=u;h[v>>3]=s;i=d;return}k=m/+XS(c[b+536>>2]|0,l,1288,1280,+h[o>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=k;r=q*461.5233290850878;s=j+r;t=p;u=t+3416|0;v=u;h[v>>3]=s;i=d;return}function If(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3416>>3]*293.15;k=+h[g+160>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3432|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3432|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,1336,1328,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3432|0;p=o;h[p>>3]=m;i=d;return}function Jf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,1216,1368,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3376>>3]=m*.6219647130774989;i=d;return}function Kf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=+h[g+160>>3];do{if(j!=0.0){l=g;m=k/j}else{if(k==0.0){l=g;m=k;break}n=k/+XS(c[b+536>>2]|0,j,1384,1376,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3408>>3]=m*.01598094902253916;i=d;return}function Lf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0;b=i;i=i+24|0;d=b;e=b+16|0;f=c[a+536>>2]|0;g=a+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3];a=d;k=968;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];Pm(e,f,j,293.15,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3440>>3]=+h[e>>3];i=b;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3424>>3]=+h[b+3440>>3]+ +h[b+3416>>3]*-293.15;i=i;return}function Nf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;a=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[a+160>>3];n=+h[a+3440>>3];a=e;o=968;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];ln(f,k,m,n,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];bn(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+1928>>3]=+h[g>>3];i=b;return}function Of(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;if((a[b+312|0]|0)!=0){g=b+4|0;Il(e,c[b+536>>2]|0,c[c[b+320>>2]>>2]|0,+h[c[c[g>>2]>>2]>>3],+h[(c[b+416>>2]|0)+1056>>3]);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3352>>3]=+h[e>>3];i=d;return}e=b+4|0;g=c[c[e>>2]>>2]|0;do{if((a[(c[g+16>>2]|0)+8|0]|0)!=0){if((a[(c[b+408>>2]|0)+8|0]|0)!=0){break}Il(f,c[b+536>>2]|0,c[c[b+320>>2]>>2]|0,+h[g>>3],+h[(c[b+416>>2]|0)+1056>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3352>>3]=+h[f>>3];i=d;return}}while(0);h[(c[g+8>>2]|0)+3352>>3]=+h[(c[b+400>>2]|0)+3352>>3];i=d;return}function Pf(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;Gl(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,1,+h[f>>3],+h[(c[f+8>>2]|0)+3352>>3],+h[(c[a+400>>2]|0)+3352>>3],+h[(c[a+416>>2]|0)+1056>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1160>>3]=+h[d>>3];i=b;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3344>>3]=+h[(c[a+416>>2]|0)+1064>>3]*+h[b+1160>>3];i=i;return}function Rf(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3344>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=+h[e+136>>3]}else{f=.01}h[e+2768>>3]=f*+h[e+3344>>3];i=b;return}function Sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+32>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,1424,1416,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}function Tf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+448|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,1536,1528,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+448|0;q=p;h[q>>3]=n;i=d;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1048>>3]=+h[b+48>>3]*.001519;i=i;return}function Vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1056>>3]=+h[b+56>>3]*.001519;i=i;return}function Wf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vm(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3]=+h[f>>3];i=b;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=1.0- +h[b+8>>3];i=i;return}function Yf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+1136>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ol(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];am(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+352>>3]=+h[l>>3];i=b;return}function Zf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1136>>3]),1.0e-13);k=+h[g+8>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,1648,1640,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}function _f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+1136>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+768>>3]=+h[l>>3];i=b;return}function $f(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+1136>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+824>>3]=+h[l>>3];i=b;return}function ag(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;jm(d,c[a+536>>2]|0,+h[c[(c[c[e>>2]>>2]|0)+8>>2]>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+392>>3]=+xd(+(+h[d>>3]),+(+h[a+16>>3]*.999));i=b;return}function bg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+392>>3];k=+yd(1.0e-13,+(+h[g+16>>3]-j));l=+h[g+1136>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,1696,1688,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+408>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function cg(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+424>>3]=+yd(+(+h[d+8>>3]- +h[d+408>>3]),0.0);i=b;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=+h[b+8>>3]- +h[b+424>>3];i=i;return}function eg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=1.0-j;l=+h[g+1136>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,1768,1760,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+424>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+416>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,1768,1760,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}function fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+480>>3]- +h[b+456>>3]*+h[b>>3];i=i;return}function gg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3]*+h[g+456>>3];k=+h[g+16>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,1816,1808,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}function hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+3128>>3]*+h[b+472>>3];i=i;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=+h[b+8>>3]*+h[b+1088>>3];i=i;return}function jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1104>>3]=+h[b+1088>>3]*+h[b+464>>3];i=i;return}function kg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1088>>3];k=+h[g+1056>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1040|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,1872,1864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1040|0;p=o;h[p>>3]=m;i=d;return}function lg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=+h[g+8>>3];l=+h[g+392>>3]*(k+ +h[g+1136>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+432|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+432|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,1896,1888,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+432|0;r=q;h[r>>3]=o;i=d;return}function mg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+392>>3];k=+yd(1.0e-13,+(+h[g+16>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,1696,2008,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+400>>3]=m*.6219647130774989;i=d;return}function ng(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+24>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vm(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3]=+h[f>>3];i=b;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1144>>3]=1.0- +h[b+32>>3];i=i;return}function pg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+1144>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ol(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];am(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+344>>3]=+h[l>>3];i=b;return}function qg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1144>>3]),1.0e-13);k=+h[g+32>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,2024,2016,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}function rg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+8>>3];v=l;h[k>>3]=+h[t+1136>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+16>>3];w=+h[t>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+32>>3];f=j;h[k>>3]=+h[q+1144>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+40>>3];y=+h[f+24>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+688>>3]=(+h[d+496>>3]+ +h[d+504>>3])*(w- +h[r>>3])*+h[d+1440>>3]*.5;i=b;return}function sg(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+1440>>3]*(+h[e+496>>3]+ +h[e+504>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+688>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+632|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+632|0;q=p;h[q>>3]=n;i=d;return}r=k/+XS(c[b+536>>2]|0,f,2072,2064,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+632|0;q=p;h[q>>3]=n;i=d;return}function tg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+1144>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+760>>3]=+h[l>>3];i=b;return}function ug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+1144>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+816>>3]=+h[l>>3];i=b;return}function vg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;_l(d,c[a+536>>2]|0,+h[f+632>>3],+h[f+816>>3],+h[f+824>>3],+h[f+760>>3],+h[f+768>>3],+h[f+3144>>3],+h[f+2696>>3],+h[f+2672>>3]*+h[j+1504>>3],(+h[j+528>>3]+ +h[j+536>>3])*.5,+h[j+1496>>3]/3.0,+h[j+1464>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+936>>3]=+h[d>>3]*+h[(c[g>>2]|0)+1440>>3];i=b;return}function wg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+936>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+736>>3]=+h[(a?e+768|0:e+760|0)>>3];i=b;return}function xg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+608>>3]=+h[b+1440>>3]*(+h[b+512>>3]+ +h[b+520>>3])*+h[d+736>>3]*+h[b+1464>>3]*.3926990816987241;i=i;return}function yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+936>>3]*+h[b+3144>>3];i=i;return}function zg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+936>>3];h[b+864>>3]=d*+h[(!(d>=0.0)?b+480|0:b+592|0)>>3];i=i;return}function Ag(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+936>>3];h[b+912>>3]=d*+h[(!(d>=0.0)?b+8|0:b+32|0)>>3];i=i;return}function Bg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+936>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+792>>3]=+h[(a?e+824|0:e+816|0)>>3];i=b;return}function Cg(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;jm(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+504>>3]=+xd(+(+h[d>>3]),+(+h[a+40>>3]*.999));i=b;return}function Dg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+504>>3];k=+yd(1.0e-13,+(+h[g+40>>3]-j));l=+h[g+1144>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,2160,2152,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+520>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function Eg(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+536>>3]=+yd(+(+h[d+32>>3]- +h[d+520>>3]),0.0);i=b;return}function Fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=+h[b+32>>3]- +h[b+536>>3];i=i;return}function Gg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+536>>3];k=1.0-j;l=+h[g+1144>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,2232,2224,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+536>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+528>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+568|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+568|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,2232,2224,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+568|0;z=y;h[z>>3]=w;i=d;return}function Hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+592>>3]- +h[b+568>>3]*+h[b+24>>3];i=i;return}function Ig(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+24>>3]*+h[g+568>>3];k=+h[g+40>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+584|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,2280,2272,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+584|0;p=o;h[p>>3]=m;i=d;return}function Jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+3120>>3]*+h[b+584>>3];i=i;return}function Kg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1064>>3]=+h[b+32>>3]*+h[b+1080>>3];i=i;return}function Lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1096>>3]=+h[b+1080>>3]*+h[b+576>>3];i=i;return}function Mg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1080>>3];k=+h[g+1048>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1032|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1032|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,2336,2328,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1032|0;p=o;h[p>>3]=m;i=d;return}function Ng(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+936>>3];h[b+888>>3]=d*+h[(!(d>=0.0)?b+1040|0:b+1032|0)>>3];i=i;return}function Og(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+40>>3];k=+h[g+32>>3];l=+h[g+504>>3]*(k+ +h[g+1144>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+544|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+544|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,2360,2352,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+544|0;r=q;h[r>>3]=o;i=d;return}function Pg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+504>>3];k=+yd(1.0e-13,+(+h[g+40>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,2160,2472,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+512>>3]=m*.6219647130774989;i=d;return}function Qg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+80>>3];l=+h[a+64>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vm(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1304>>3]=+h[f>>3];i=b;return}function Rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1872>>3]=1.0- +h[b+72>>3];i=i;return}function Sg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+72>>3];p=f;h[k>>3]=+h[n+1872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+80>>3];q=+h[p+64>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ol(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];am(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1176>>3]=+h[l>>3];i=b;return}function Tg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1872>>3]),1.0e-13);k=+h[g+72>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,2488,2480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}function Ug(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+416|0;t=+h[c[s>>2]>>3];u=a+4|0;v=l;h[k>>3]=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+2712>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,t,l);l=a+536|0;a=c[l>>2]|0;v=c[(c[c[u>>2]>>2]|0)+8>>2]|0;t=+h[v+3912>>3];w=+h[v+2384>>3];v=g;x=m;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];Ml(n,a,t,w,g);g=c[l>>2]|0;a=f;x=n;c[a+0>>2]=c[x+0>>2];c[a+4>>2]=c[x+4>>2];c[a+8>>2]=c[x+8>>2];c[a+12>>2]=c[x+12>>2];c[a+16>>2]=c[x+16>>2];c[a+20>>2]=c[x+20>>2];c[a+24>>2]=c[x+24>>2];c[a+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[u>>2]>>2]|0)+8>>2]|0;t=+h[q+72>>3];f=j;h[k>>3]=+h[q+1872>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,t,j);j=c[l>>2]|0;f=c[(c[c[u>>2]>>2]|0)+8>>2]|0;t=+h[f+80>>3];y=+h[f+64>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,t,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[s>>2]|0;h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+1520>>3]=+h[d+136>>3]*(w- +h[r>>3])*+h[d+896>>3];i=b;return}function Vg(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+136>>3]*+h[e+896>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1520>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1464|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1464|0;q=p;h[q>>3]=n;i=d;return}k=l/+XS(c[b+536>>2]|0,f,2536,2528,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1464|0;q=p;h[q>>3]=n;i=d;return}function Wg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+72>>3];p=f;h[k>>3]=+h[n+1872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+80>>3];q=+h[p+64>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2368>>3]=+h[l>>3];i=b;return}function Xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+72>>3];p=f;h[k>>3]=+h[n+1872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+80>>3];q=+h[p+64>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2336>>3]=+h[l>>3];i=b;return}function Yg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;k=+h[j+168>>3];_l(d,c[a+536>>2]|0,+h[f+1464>>3],+h[f+2336>>3],+h[f+2344>>3],+h[f+2368>>3],+h[f+2376>>3],+h[f+3040>>3],+h[j+152>>3],+h[f+2656>>3]*+h[j+960>>3],(k+k)*.5,+h[j+952>>3]/3.0,+h[j+920>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1704>>3]=+h[d>>3]*+h[(c[g>>2]|0)+896>>3];i=b;return}function Zg(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1704>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1568>>3]=+h[(a?e+2376|0:e+2368|0)>>3];i=b;return}function _g(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1440>>3]=+h[b+896>>3]*+h[b+152>>3]*+h[d+1568>>3]*+h[b+920>>3]*.7853981633974483;i=i;return}function $g(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+1704>>3]*+h[b+3040>>3];i=i;return}function ah(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1704>>3];h[b+1632>>3]=d*+h[(!(d>=0.0)?b+3856|0:b+1304|0)>>3];i=i;return}function bh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1704>>3];if(!(d>=0.0)){e=c[a+416>>2]|0}else{e=b+72|0}h[b+1680>>3]=d*+h[e>>3];i=i;return}function ch(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+416|0;p=+h[c[o>>2]>>3];q=b+4|0;r=g;h[k>>3]=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+2712>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];YT(j,2,p,g);g=b+536|0;r=c[g>>2]|0;s=c[(c[c[q>>2]>>2]|0)+8>>2]|0;p=+h[s+3912>>3];t=+h[s+2384>>3];s=f;u=j;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];im(m,r,p,t,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];mm(n,r,e);e=c[o>>2]|0;t=+h[n>>3]*+h[e+136>>3]*+h[e+792>>3];e=c[c[q>>2]>>2]|0;n=c[e+8>>2]|0;p=+h[n+1704>>3];if(t!=0.0){v=n;w=p/t;x=v;y=x+1600|0;z=y;h[z>>3]=w;i=d;return}if(p==0.0){v=n;w=p;x=v;y=x+1600|0;z=y;h[z>>3]=w;i=d;return}A=p/+XS(c[g>>2]|0,t,2600,2592,+h[e>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[q>>2]>>2]|0)+8>>2]|0;w=A;x=v;y=x+1600|0;z=y;h[z>>3]=w;i=d;return}function dh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+1600>>3],+h[f+2344>>3],+h[f+2376>>3],+h[(c[a+416>>2]|0)+152>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1496>>3]=+h[d>>3];i=b;return}function eh(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1704>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1592>>3]=+h[(a?e+2344|0:e+2336|0)>>3];i=b;return}function fh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;jm(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+64>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1216>>3]=+xd(+(+h[d>>3]),+(+h[a+80>>3]*.999));i=b;return}function gh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1216>>3];k=+yd(1.0e-13,+(+h[g+80>>3]-j));l=+h[g+1872>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,2848,2840,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1232>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function hh(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1248>>3]=+yd(+(+h[d+72>>3]- +h[d+1232>>3]),0.0);i=b;return}function ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[b+72>>3]- +h[b+1248>>3];i=i;return}function jh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1248>>3];k=1.0-j;l=+h[g+1872>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,2928,2920,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1248>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1240>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1280|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1280|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,2928,2920,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1280|0;z=y;h[z>>3]=w;i=d;return}function kh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1288>>3]=+h[b+1304>>3]- +h[b+1280>>3]*+h[b+64>>3];i=i;return}function lh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+64>>3]*+h[g+1280>>3];k=+h[g+80>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,2976,2968,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}function mh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1848>>3]=+h[b+3016>>3]*+h[b+1296>>3];i=i;return}function nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1832>>3]=+h[b+72>>3]*+h[b+1848>>3];i=i;return}function oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+1848>>3]*+h[b+1288>>3];i=i;return}function ph(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1848>>3];k=+h[g+1816>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1800|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1800|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3032,3024,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1800|0;p=o;h[p>>3]=m;i=d;return}function qh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1704>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+16|0}else{e=b+1800|0}h[b+1656>>3]=d*+h[e>>3];i=i;return}function rh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+80>>3];k=+h[g+72>>3];l=+h[g+1216>>3]*(k+ +h[g+1872>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1256|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1256|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,3056,3048,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1256|0;r=q;h[r>>3]=o;i=d;return}function sh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1216>>3];k=+yd(1.0e-13,+(+h[g+80>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,2848,3168,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1224>>3]=m*.6219647130774989;i=d;return}function th(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+104>>3];l=+h[a+88>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vm(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1416>>3]=+h[f>>3];i=b;return}function uh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+56|0;d=b;e=b+32|0;f=i;i=i+16|0;g=i;i=i+32|0;j=i;i=i+8|0;k=a+4|0;YT(f,1,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+96>>3],b+48|0);l=a+536|0;a=c[l>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+160>>3];o=+h[m+1416>>3];m=e;p=f;c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];ln(g,a,n,o,e);e=c[l>>2]|0;l=d;a=g;c[l+0>>2]=c[a+0>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];c[l+16>>2]=c[a+16>>2];c[l+20>>2]=c[a+20>>2];c[l+24>>2]=c[a+24>>2];c[l+28>>2]=c[a+28>>2];bn(j,e,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1936>>3]=+h[j>>3];i=b;return}function vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1880>>3]=1.0- +h[b+96>>3];i=i;return}function wh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+96>>3];p=f;h[k>>3]=+h[n+1880>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+104>>3];q=+h[p+88>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ol(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];am(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1168>>3]=+h[l>>3];i=b;return}function xh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1880>>3]),1.0e-13);k=+h[g+96>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1376|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1376|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3184,3176,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1376|0;p=o;h[p>>3]=m;i=d;return}function yh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+72>>3];v=l;h[k>>3]=+h[t+1872>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+80>>3];w=+h[t+64>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+96>>3];f=j;h[k>>3]=+h[q+1880>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+104>>3];y=+h[f+88>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+1512>>3]=(+h[d+128>>3]+ +h[d+136>>3])*(w- +h[r>>3])*+h[d+896>>3]*.5;i=b;return}function zh(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+896>>3]*(+h[e+128>>3]+ +h[e+136>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1512>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+1456|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+1456|0;q=p;h[q>>3]=n;i=d;return}r=k/+XS(c[b+536>>2]|0,f,3232,3224,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+1456|0;q=p;h[q>>3]=n;i=d;return}function Ah(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+96>>3];p=f;h[k>>3]=+h[n+1880>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+104>>3];q=+h[p+88>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2360>>3]=+h[l>>3];i=b;return}function Bh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+96>>3];p=f;h[k>>3]=+h[n+1880>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+104>>3];q=+h[p+88>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2328>>3]=+h[l>>3];i=b;return}function Ch(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;_l(d,c[a+536>>2]|0,+h[f+1456>>3],+h[f+2328>>3],+h[f+2336>>3],+h[f+2360>>3],+h[f+2368>>3],+h[f+3032>>3],+h[f+2720>>3],+h[f+2648>>3]*+h[j+960>>3],(+h[j+160>>3]+ +h[j+168>>3])*.5,+h[j+952>>3]/3.0,+h[j+920>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1696>>3]=+h[d>>3]*+h[(c[g>>2]|0)+896>>3];i=b;return}function Dh(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1696>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1560>>3]=+h[(a?e+2368|0:e+2360|0)>>3];i=b;return}function Eh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1432>>3]=+h[b+896>>3]*(+h[b+144>>3]+ +h[b+152>>3])*+h[d+1560>>3]*+h[b+920>>3]*.3926990816987241;i=i;return}function Fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+1696>>3]*+h[b+3032>>3];i=i;return}function Gh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+792>>3]*+h[j+1296>>3]*+h[e+136>>3];l=+h[j+1696>>3]+ +h[j+1704>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1192|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1192|0;r=q;h[r>>3]=o;i=d;return}s=l/+XS(c[b+536>>2]|0,k,3320,3312,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1192|0;r=q;h[r>>3]=o;i=d;return}function Hh(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+1192>>3],+h[f+2336>>3],+h[f+2368>>3],+h[(c[a+416>>2]|0)+152>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1488>>3]=+h[d>>3];i=b;return}function Ih(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1720>>3]=+h[b+1192>>3]*+h[d+136>>3]*+h[d+792>>3]*((+h[b+3912>>3]- +h[b+104>>3])/1.5+(+h[b+1456>>3]*.5+ +h[b+1464>>3]));i=i;return}function Jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1784>>3]=+h[b+1696>>3]- +h[b+1704>>3];i=i;return}function Kh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3016>>3];k=+h[g+1784>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2280|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3400,3392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2280|0;p=o;h[p>>3]=m;i=d;return}function Lh(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1696>>3];h[b+1624>>3]=d*+h[(!(d>=0.0)?b+1304|0:b+1416|0)>>3];i=i;return}function Mh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1736>>3]=+h[b+1624>>3]- +h[b+1632>>3];i=i;return}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2096>>3]=+h[b+1736>>3]+ +h[b+1720>>3];i=i;return}function Oh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1848>>3];k=+h[g+2096>>3]- +h[g+1784>>3]*+h[g+1288>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2016|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2016|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3032,3424,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2016|0;p=o;h[p>>3]=m;i=d;return}function Ph(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1696>>3];h[b+1672>>3]=d*+h[(!(d>=0.0)?b+72|0:b+96|0)>>3];i=i;return}function Qh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1768>>3]=+h[b+1672>>3]- +h[b+1680>>3];i=i;return}function Rh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1848>>3];k=+h[g+1768>>3]- +h[g+72>>3]*+h[g+1784>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3032,3432,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}function Sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=-+h[b+240>>3];i=i;return}function Th(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+232>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+232|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+232>>3]);e=c[f>>2]|0;h[c[e+612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+248>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+248|0;h[(c[e+608>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+248>>3]);h[(c[(c[f>>2]|0)+612>>2]|0)+8>>3]=k;SW(a,7)|0;j=c[(c[f>>2]|0)+604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+232>>3]=+h[j>>3];h[f+248>>3]=+h[j+8>>3];vo(a);wo(a);xo(a);yo(a);zo(a);Ao(a);i=b;return}function Uh(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1696>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1584>>3]=+h[(a?e+2336|0:e+2328|0)>>3];i=b;return}function Vh(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;jm(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+88>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1328>>3]=+xd(+(+h[d>>3]),+(+h[a+104>>3]*.999));i=b;return}function Wh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1328>>3];k=+yd(1.0e-13,+(+h[g+104>>3]-j));l=+h[g+1880>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,3448,3440,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1344>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function Xh(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1360>>3]=+yd(+(+h[d+96>>3]- +h[d+1344>>3]),0.0);i=b;return}function Yh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[b+96>>3]- +h[b+1360>>3];i=i;return}function Zh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1360>>3];k=1.0-j;l=+h[g+1880>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,3528,3520,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1360>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1352>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1392|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1392|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,3528,3520,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1392|0;z=y;h[z>>3]=w;i=d;return}function _h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1400>>3]=+h[b+1416>>3]- +h[b+1392>>3]*+h[b+88>>3];i=i;return}function $h(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+88>>3]*+h[g+1392>>3];k=+h[g+104>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1408|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3576,3568,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1408|0;p=o;h[p>>3]=m;i=d;return}function ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1840>>3]=+h[b+3008>>3]*+h[b+1408>>3];i=i;return}function bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1824>>3]=+h[b+96>>3]*+h[b+1840>>3];i=i;return}function ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+1840>>3]*+h[b+1400>>3];i=i;return}function di(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1840>>3];k=+h[g+1808>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1792|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1792|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3632,3624,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1792|0;p=o;h[p>>3]=m;i=d;return}function ei(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1696>>3];h[b+1648>>3]=d*+h[(!(d>=0.0)?b+1800|0:b+1792|0)>>3];i=i;return}function fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1752>>3]=+h[b+1648>>3]- +h[b+1656>>3];i=i;return}function gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+1752>>3]/.001519;i=i;return}function hi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+104>>3];k=+h[g+96>>3];l=+h[g+1328>>3]*(k+ +h[g+1880>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1368|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1368|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,3656,3648,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1368|0;r=q;h[r>>3]=o;i=d;return}function ii(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1328>>3];k=+yd(1.0e-13,+(+h[g+104>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,3448,3768,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1336>>3]=m*.6219647130774989;i=d;return}function ji(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+160>>3];l=+h[a+152>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];mn(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3552>>3]=+h[f>>3];i=b;return}function ki(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1112>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1112|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1112>>3]);e=c[f>>2]|0;h[c[e+692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1128>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1128|0;h[(c[e+688>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1128>>3]);j=c[f>>2]|0;h[(c[j+692>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+684>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1120>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1120|0;h[(c[j+688>>2]|0)+16>>3]=+h[e>>3];k=+UW(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1120>>3]);h[(c[(c[f>>2]|0)+692>>2]|0)+16>>3]=k;SW(a,8)|0;g=c[(c[f>>2]|0)+684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1112>>3]=+h[g>>3];h[f+1128>>3]=+h[g+8>>3];h[f+1120>>3]=+h[g+16>>3];Do(a);Eo(a);Fo(a);Go(a);Ho(a);i=b;return}function li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=+h[b+944>>3]*+h[b+3152>>3];i=i;return}function mi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+944>>3];if(j>=0.0){k=g;l=j*+h[g+8>>3];m=k;n=m+920|0;o=n;h[o>>3]=l;i=d;return}p=+yd(+-j,1.0e-15);q=p+1.0e-15;r=p*+h[g+136>>3]+1.0e-17;do{if(q!=0.0){s=j;t=g;u=r/q}else{if(r==0.0){s=j;t=g;u=r;break}p=r/+XS(c[b+536>>2]|0,q,3784,3776,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;s=+h[v+944>>3];t=v;u=p}}while(0);k=t;l=u*s;m=k;n=m+920|0;o=n;h[o>>3]=l;i=d;return}function ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+912>>3]- +h[b+920>>3];i=i;return}function oi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+1112>>3];r=g;h[k>>3]=+h[p+1120>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];YT(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+160>>3];s=+h[p+1128>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];im(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];mm(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+1336>>3]*+h[e+504>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+944>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+840|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+840|0;y=x;h[y>>3]=v;i=d;return}z=q/+XS(c[g>>2]|0,s,3832,3824,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+840|0;y=x;h[y>>3]=v;i=d;return}function pi(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+840>>3],+h[f+832>>3],+h[f+776>>3],+h[(c[a+416>>2]|0)+520>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+672>>3]=+h[d>>3];i=b;return}function qi(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+744>>3]=+h[(a?e+776|0:e+768|0)>>3];i=b;return}function ri(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+616>>3]=+h[b+1440>>3]*+h[b+520>>3]*+h[d+744>>3]*+h[b+1464>>3]*.7853981633974483;i=i;return}function si(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+800>>3]=+h[(a?e+832|0:e+824|0)>>3];i=b;return}function ti(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1336>>3]*+h[j+472>>3]*+h[e+504>>3];l=+h[j+936>>3]+ +h[j+944>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}s=l/+XS(c[b+536>>2]|0,k,4088,4080,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}function ui(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+368>>3],+h[f+824>>3],+h[f+768>>3],+h[(c[a+416>>2]|0)+520>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+664>>3]=+h[d>>3];i=b;return}function vi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+960>>3]=+h[b+368>>3]*+h[d+504>>3]*+h[d+1336>>3]*((+h[b+160>>3]- +h[b+40>>3])/1.5+(+h[b+632>>3]*.5+ +h[b+640>>3]));i=i;return}function wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=+h[b+936>>3]- +h[b+944>>3];i=i;return}function xi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3128>>3];k=+h[g+1024>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2312|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,4160,4152,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2312|0;p=o;h[p>>3]=m;i=d;return}function yi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1088>>3];k=+h[g+1008>>3]- +h[g+8>>3]*+h[g+1024>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,1872,4184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}function zi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=-+h[b+176>>3];i=i;return}function Ai(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(xW(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=j;l=+h[j+136>>3]}else{m=+yd(+(+h[j+944>>3]),1.0e-15);n=m+1.0e-15;o=m*+h[j+8>>3]+1.0e-17;if(n!=0.0){k=j;l=o/n;break}if(o==0.0){k=j;l=o;break}m=o/+XS(c[b+536>>2]|0,n,4200,4192,+h[g>>3],(a[b+319|0]|0)!=0|0);k=c[(c[c[e>>2]>>2]|0)+8>>2]|0;l=m}}while(0);h[k+2760>>3]=l*+h[k+944>>3];i=d;return}function Bi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;k=i;i=i+32|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+yd(+(+h[o+944>>3]),1.0e-15);q=p+1.0e-15;r=p*+h[o+8>>3]+1.0e-17;do{if(q!=0.0){s=r/q}else{if(r==0.0){s=r;break}s=r/+XS(c[b+536>>2]|0,q,4200,4240,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);YT(j,1,s,g);g=b+536|0;n=c[g>>2]|0;o=c[c[m>>2]>>2]|0;t=c[o+8>>2]|0;s=+h[t+160>>3];q=+yd(+(+h[t+944>>3]),1.0e-15);r=q+1.0e-15;p=q*+h[t+480>>3]+4.52632387446934e-11;do{if(r!=0.0){u=p/r}else{if(p==0.0){u=p;break}u=p/+XS(n,r,4200,4240,+h[o>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=f;o=j;c[b+0>>2]=c[o+0>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];ln(k,n,s,u,f);f=c[g>>2]|0;g=e;n=k;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[g+16>>2]=c[n+16>>2];c[g+20>>2]=c[n+20>>2];c[g+24>>2]=c[n+24>>2];c[g+28>>2]=c[n+28>>2];bn(l,f,e);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1920>>3]=+h[l>>3];i=d;return}function Ci(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+944>>3];if(j>=0.0){k=g;l=j*+h[g+480>>3];m=k;n=m+872|0;o=n;h[o>>3]=l;i=d;return}p=+yd(+-j,1.0e-15);q=p+1.0e-15;r=p*+h[g+3552>>3]+4.52632387446934e-11;do{if(q!=0.0){s=j;t=g;u=r/q}else{if(r==0.0){s=j;t=g;u=r;break}p=r/+XS(c[b+536>>2]|0,q,3784,4248,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;s=+h[v+944>>3];t=v;u=p}}while(0);k=t;l=u*s;m=k;n=m+872|0;o=n;h[o>>3]=l;i=d;return}function Di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+976>>3]=+h[b+864>>3]- +h[b+872>>3];i=i;return}function Ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+976>>3]+ +h[b+960>>3];i=i;return}function Fi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1088>>3];k=+h[g+2112>>3]- +h[g+1024>>3]*+h[g+464>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2064|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2064|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,1872,4256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2064|0;p=o;h[p>>3]=m;i=d;return}function Gi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+184>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+184|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+184>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+168>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+168|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+168>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+8>>3]=k;SW(a,9)|0;j=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+184>>3]=+h[j>>3];h[f+168>>3]=+h[j+8>>3];Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);i=b;return}function Hi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;b=i;i=i+120|0;d=b;e=b+96|0;f=i;i=i+16|0;g=i;i=i+96|0;j=i;i=i+8|0;k=a+4|0;YT(f,1,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],b+112|0);c[g>>2]=4264;h[g+8>>3]=.01801528;h[g+16>>3]=-13423382.81725291;h[g+24>>3]=549760.6476280135;h[g+32>>3]=1.0e3;l=g+40|0;m=4272;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=g+52|0;l=4288;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];l=g+64|0;m=4304;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=g+76|0;l=4320;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];h[g+88>>3]=461.5233290850878;l=c[a+536>>2]|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[a+3552>>3];o=+h[a+160>>3];a=e;m=f;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];m=d+0|0;a=g+0|0;g=m+96|0;do{c[m>>2]=c[a>>2];m=m+4|0;a=a+4|0}while((m|0)<(g|0));em(j,l,n,190.0,647.0,o,e,d,1.0e-13);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1896>>3]=+h[j>>3];i=b;return}function Ii(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+96>>3];v=l;h[k>>3]=+h[t+1880>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+104>>3];w=+h[t+88>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+136>>3];f=j;h[k>>3]=+h[q+1888>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+160>>3];y=+h[f+1896>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+1504>>3]=+h[d+128>>3]*(w- +h[r>>3])*+h[d+896>>3];i=b;return}function Ji(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+128>>3]*+h[e+896>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1504>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}k=l/+XS(c[b+536>>2]|0,f,4344,4336,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}function Ki(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+136>>3];p=f;h[k>>3]=+h[n+1888>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+1896>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2352>>3]=+h[l>>3];i=b;return}function Li(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+136>>3];p=f;h[k>>3]=+h[n+1888>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+1896>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[l>>3];i=b;return}function Mi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;k=+h[j+160>>3];_l(d,c[a+536>>2]|0,+h[f+1448>>3],+h[f+2320>>3],+h[f+2328>>3],+h[f+2352>>3],+h[f+2360>>3],+h[f+3024>>3],+h[j+144>>3],+h[f+2640>>3]*+h[j+960>>3],(k+k)*.5,+h[j+952>>3]/3.0,+h[j+920>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1688>>3]=+h[d>>3]*+h[(c[g>>2]|0)+896>>3];i=b;return}function Ni(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1552>>3]=+h[(a?e+2360|0:e+2352|0)>>3];i=b;return}function Oi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1424>>3]=+h[b+896>>3]*+h[b+144>>3]*+h[d+1552>>3]*+h[b+920>>3]*.7853981633974483;i=i;return}function Pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1528>>3]=+h[b+1688>>3]*+h[b+3024>>3];i=i;return}function Qi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+792>>3]*+h[j+1408>>3]*+h[e+128>>3];l=+h[j+1688>>3]+ +h[j+1696>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1184|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1184|0;r=q;h[r>>3]=o;i=d;return}s=l/+XS(c[b+536>>2]|0,k,4408,4400,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1184|0;r=q;h[r>>3]=o;i=d;return}function Ri(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+1184>>3],+h[f+2328>>3],+h[f+2360>>3],+h[(c[a+416>>2]|0)+144>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1480>>3]=+h[d>>3];i=b;return}function Si(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1712>>3]=+h[b+1184>>3]*+h[d+128>>3]*+h[d+792>>3]*((+h[b+80>>3]- +h[b+160>>3])/1.5+(+h[b+1448>>3]+ +h[b+1456>>3]*.5));i=i;return}function Ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=+h[b+1688>>3]- +h[b+1696>>3];i=i;return}function Ui(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3008>>3];k=+h[g+1776>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2264|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,4488,4480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2264|0;p=o;h[p>>3]=m;i=d;return}function Vi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1688>>3];h[b+1664>>3]=d*+h[(!(d>=0.0)?b+96|0:b+136|0)>>3];i=i;return}function Wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=+h[b+1664>>3]- +h[b+1672>>3];i=i;return}function Xi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1840>>3];k=+h[g+1760>>3]- +h[g+96>>3]*+h[g+1776>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+264|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3632,4512,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+264|0;p=o;h[p>>3]=m;i=d;return}function Yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=-+h[b+264>>3];i=i;return}function Zi(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2776>>3]=-(+h[(a?e+136|0:e+96|0)>>3]*+h[e+1688>>3]);i=b;return}function _i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+2760>>3]+(+h[b+2768>>3]+ +h[b+2776>>3]);i=i;return}function $i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=+h[b+944>>3]+(+h[b+3344>>3]- +h[b+1688>>3]);i=i;return}function aj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+752>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3568>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+3736|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+3736|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,e,4528,4520,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3736|0;p=o;h[p>>3]=m;i=d;return}function bj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1576>>3]=+h[(a?e+2328|0:e+2320|0)>>3];i=b;return}function cj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+136>>3];r=g;h[k>>3]=+h[p+1888>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];YT(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+160>>3];s=+h[p+1896>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];im(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];mm(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+792>>3]*+h[e+128>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+1688>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+1608|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+1608|0;y=x;h[y>>3]=v;i=d;return}z=q/+XS(c[g>>2]|0,s,4552,4544,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+1608|0;y=x;h[y>>3]=v;i=d;return}function dj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+1608>>3],+h[f+2320>>3],+h[f+2352>>3],+h[(c[a+416>>2]|0)+144>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1472>>3]=+h[d>>3];i=b;return}function ej(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1688>>3];h[b+1616>>3]=d*+h[(!(d>=0.0)?b+1416|0:b+3552|0)>>3];i=i;return}function fj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1728>>3]=+h[b+1616>>3]- +h[b+1624>>3];i=i;return}function gj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+1728>>3]+ +h[b+1712>>3];i=i;return}function hj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1840>>3];k=+h[g+2088>>3]- +h[g+1776>>3]*+h[g+1400>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,3632,4800,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}function ij(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+272>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+272|0;h[c[g+848>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+272>>3]);e=c[f>>2]|0;h[c[e+852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+256>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+256|0;h[(c[e+848>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+256>>3]);h[(c[(c[f>>2]|0)+852>>2]|0)+8>>3]=k;SW(a,10)|0;j=c[(c[f>>2]|0)+844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+272>>3]=+h[j>>3];h[f+256>>3]=+h[j+8>>3];So(a);To(a);Uo(a);Vo(a);Wo(a);Xo(a);i=b;return}function jj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=xW(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2808>>3]=-(+h[e+1688>>3]*+h[(a<<24>>24==0?e+3552|0:e+1416|0)>>3]);i=b;return}function kj(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3344>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2800>>3]=+h[e+3344>>3]*+h[(a<<24>>24==0?e+3552|0:e+3440|0)>>3];i=b;return}function lj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;d=i;e=b+4|0;f=xW(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+944>>3];do{if(f<<24>>24==0){l=j;m=+h[j+3552>>3]}else{n=+yd(+k,1.0e-15);o=n+1.0e-15;p=n*+h[j+480>>3]+4.52632387446934e-11;if(o!=0.0){l=j;m=p/o;break}if(p==0.0){l=j;m=p;break}n=p/+XS(c[b+536>>2]|0,o,4200,4808,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+2792>>3]=k*m;i=d;return}function mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=+h[b+2792>>3]+(+h[b+2800>>3]+ +h[b+2808>>3]);i=i;return}function nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=1.0- +h[b+136>>3];i=i;return}function oj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+136>>3];p=f;h[k>>3]=+h[n+1912>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+152>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Wm(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vm(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1904>>3]=+h[l>>3];i=b;return}function pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1912>>3]),1.0e-13);k=+h[g+136>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3512|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,4824,4816,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3512|0;p=o;h[p>>3]=m;i=d;return}function qj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;dn(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+152>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3464>>3]=+xd(+(+h[d>>3]),+(+h[a+160>>3]*.999));i=b;return}function rj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3464>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));l=+h[g+1912>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,4864,4856,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3480>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function sj(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3496>>3]=+yd(+(+h[d+136>>3]- +h[d+3480>>3]),0.0);i=b;return}function tj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3488>>3]=+h[b+136>>3]- +h[b+3496>>3];i=i;return}function uj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3496>>3];k=1.0-j;l=+h[g+1912>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,4928,4920,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3496>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3488>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3528|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3528|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,4928,4920,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3528|0;z=y;h[z>>3]=w;i=d;return}function vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3536>>3]=+h[b+3552>>3]- +h[b+3528>>3]*+h[b+152>>3];i=i;return}function wj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+152>>3]*+h[g+3528>>3];k=+h[g+160>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,4968,4960,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}function xj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=+h[(c[a+416>>2]|0)+752>>3]*+h[b+3544>>3];i=i;return}function yj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[b+136>>3]*+h[b+3576>>3];i=i;return}function zj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3584>>3]=+h[b+3576>>3]*+h[b+3536>>3];i=i;return}function Aj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3576>>3];k=+h[g+1968>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1984|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1984|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,5016,5008,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1984|0;p=o;h[p>>3]=m;i=d;return}function Bj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1688>>3];h[b+1640>>3]=d*+h[(!(d>=0.0)?b+1792|0:b+1984|0)>>3];i=i;return}function Cj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1744>>3]=+h[b+1640>>3]- +h[b+1648>>3];i=i;return}function Dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+1744>>3]/.001519;i=i;return}



function qr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;b=i;i=i+120|0;d=b;e=b+96|0;f=i;i=i+16|0;g=i;i=i+96|0;j=i;i=i+8|0;YT(f,1,+h[c[a+416>>2]>>3],b+112|0);c[g>>2]=21568;h[g+8>>3]=.01801528;h[g+16>>3]=-13423382.81725291;h[g+24>>3]=549760.6476280135;h[g+32>>3]=1.0e3;k=g+40|0;l=21576;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=g+52|0;k=21592;c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];k=g+64|0;l=21608;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=g+76|0;k=21624;c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];h[g+88>>3]=461.5233290850878;k=c[a+536>>2]|0;l=a+4|0;a=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[a+3856>>3];n=+h[a+3912>>3];a=e;o=f;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];o=d+0|0;a=g+0|0;g=o+96|0;do{c[o>>2]=c[a>>2];o=o+4|0;a=a+4|0}while((o|0)<(g|0));em(j,k,m,190.0,647.0,n,e,d,1.0e-13);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2384>>3]=+h[j>>3];i=b;return}function rr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=+h[c[a+416>>2]>>3];n=a+4|0;o=f;h[k>>3]=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+2712>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];YT(g,2,m,f);f=a+536|0;a=c[f>>2]|0;o=c[(c[c[n>>2]>>2]|0)+8>>2]|0;m=+h[o+3912>>3];p=+h[o+2384>>3];o=e;q=g;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];Ml(j,a,m,p,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+2376>>3]=+h[l>>3];i=b;return}function sr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=+h[c[a+416>>2]>>3];n=a+4|0;o=f;h[k>>3]=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+2712>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];YT(g,2,m,f);f=a+536|0;a=c[f>>2]|0;o=c[(c[c[n>>2]>>2]|0)+8>>2]|0;m=+h[o+3912>>3];p=+h[o+2384>>3];o=e;q=g;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];Ml(j,a,m,p,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+2344>>3]=+h[l>>3];i=b;return}function tr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3912>>3];k=+h[c[b+416>>2]>>3];l=+h[g+3848>>3]*(k+ +h[g+2896>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3800|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3800|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,21648,21640,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3800|0;r=q;h[r>>3]=o;i=d;return}function ur(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3848>>3];k=+yd(1.0e-13,+(+h[g+3912>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,21752,21744,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3792>>3]=m*.6219647130774989;i=d;return}function vr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3848>>3];k=+yd(1.0e-13,+(+h[g+3912>>3]-j));l=+h[g+2896>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,21752,21816,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3784>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function wr(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3776>>3]=+yd(+(+h[c[a+416>>2]>>3]- +h[d+3784>>3]),0.0);i=b;return}function xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3768>>3]=+h[c[a+416>>2]>>3]- +h[b+3776>>3];i=i;return}function yr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3776>>3];k=1.0-j;l=+h[g+2896>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,21832,21824,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3776>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3768>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3760|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3760|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,21832,21824,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3760|0;z=y;h[z>>3]=w;i=d;return}function zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3752>>3]=+h[b+3856>>3]- +h[b+3760>>3]*+h[b+3904>>3];i=i;return}function Ar(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3904>>3]*+h[g+3760>>3];k=+h[g+3912>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3744|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3744|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,21872,21864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3744|0;p=o;h[p>>3]=m;i=d;return}function Br(a){a=a|0;h[(c[a+400>>2]|0)+3352>>3]=0.0;i=i;return}function Cr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0;d=i;do{if((a[b+314|0]|0)==0){e=b+4|0;f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=b+4|0;l=uW(+h[c[c[k>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=l;e=k;f=j;break}else{j=b+4|0;k=uW(+h[c[c[j>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3],a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;e=j;f=k;break}}else{if(g){g=a[c[b+356>>2]|0]|0;k=b+4|0;j=yW(+h[c[c[k>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3])|0;a[c[b+352>>2]|0]=j;e=k;f=g;break}else{g=b+4|0;k=yW(+h[c[c[g>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3])|0;a[c[b+352>>2]|0]=k;e=g;f=k;break}}}}while(0);a[(c[(c[c[e>>2]>>2]|0)+16>>2]|0)+8|0]=f;i=d;return}function Dr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1040>>3]=+h[(c[a+416>>2]|0)+456>>3];i=i;return}function Er(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1032>>3]=+h[(c[a+416>>2]|0)+456>>3];i=i;return}function Fr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+440>>3];i=i;return}function Gr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+8>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+448|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,21920,21912,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+448|0;q=p;h[q>>3]=n;i=d;return}function Hr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=1.0- +h[b+8>>3];i=i;return}function Ir(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1136>>3]),1.0e-13);k=+h[g+8>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,22032,22024,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+440|0;p=o;h[p>>3]=m;i=d;return}function Jr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=+h[(c[a+416>>2]|0)+440>>3];i=i;return}function Kr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+32>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,22080,22072,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+560|0;q=p;h[q>>3]=n;i=d;return}function Lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1144>>3]=1.0- +h[b+32>>3];i=i;return}function Mr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1144>>3]),1.0e-13);k=+h[g+32>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,22192,22184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+552|0;p=o;h[p>>3]=m;i=d;return}function Nr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=101325.0;i=i;return}function Or(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[b+16>>3]*1.0e-5;i=i;return}function Pr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=101325.0;i=i;return}function Qr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+496>>3]=+h[b+40>>3]*1.0e-5;i=i;return}function Rr(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=293.15;i=i;return}function Sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[b>>3]+-273.15;i=i;return}function Tr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+1136>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+824>>3]=+h[l>>3];i=b;return}function Ur(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+1136>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+768>>3]=+h[l>>3];i=b;return}function Vr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+8>>3];p=f;h[k>>3]=+h[n+1136>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+16>>3];q=+h[p>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ol(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];am(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+352>>3]=+h[l>>3];i=b;return}function Wr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+16>>3];l=+h[a>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vm(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3]=+h[f>>3];i=b;return}function Xr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;jm(d,c[a+536>>2]|0,+h[c[(c[c[e>>2]>>2]|0)+8>>2]>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+392>>3]=+xd(+(+h[d>>3]),+(+h[a+16>>3]*.999));i=b;return}function Yr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+392>>3];k=+yd(1.0e-13,+(+h[g+16>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,22240,22232,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+400>>3]=m*.6219647130774989;i=d;return}function Zr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+16>>3];k=+h[g+8>>3];l=+h[g+392>>3]*(k+ +h[g+1136>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+432|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+432|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,22312,22304,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+432|0;r=q;h[r>>3]=o;i=d;return}function _r(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+392>>3];k=+yd(1.0e-13,+(+h[g+16>>3]-j));l=+h[g+1136>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,22240,22424,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+408>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function $r(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+424>>3]=+yd(+(+h[d+8>>3]- +h[d+408>>3]),0.0);i=b;return}function as(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=+h[b+8>>3]- +h[b+424>>3];i=i;return}function bs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=1.0-j;l=+h[g+1136>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,22440,22432,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+424>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+416>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,22440,22432,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+456|0;z=y;h[z>>3]=w;i=d;return}function cs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3]*+h[g+456>>3];k=+h[g+16>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,22488,22480,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+472|0;p=o;h[p>>3]=m;i=d;return}function ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+3128>>3]*+h[b+472>>3];i=i;return}function es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1056>>3]=+h[b+1040>>3]*+h[b+1088>>3];i=i;return}function fs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=-+h[b+1056>>3]/-.001519;i=i;return}function gs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=+h[b+8>>3]*+h[b+1088>>3];i=i;return}function hs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+480>>3]- +h[b+456>>3]*+h[b>>3];i=i;return}function is(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1104>>3]=+h[b+1088>>3]*+h[b+464>>3];i=i;return}function js(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=293.15;i=i;return}function ks(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+24>>3]+-273.15;i=i;return}function ls(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+1144>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+816>>3]=+h[l>>3];i=b;return}function ms(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+1144>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+760>>3]=+h[l>>3];i=b;return}function ns(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+8>>3];v=l;h[k>>3]=+h[t+1136>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+16>>3];w=+h[t>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+32>>3];f=j;h[k>>3]=+h[q+1144>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+40>>3];y=+h[f+24>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+688>>3]=(+h[d+496>>3]+ +h[d+504>>3])*(w- +h[r>>3])*+h[d+1440>>3]*.5;i=b;return}function os(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+1440>>3]*(+h[e+496>>3]+ +h[e+504>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+688>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+632|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+632|0;q=p;h[q>>3]=n;i=d;return}r=k/+XS(c[b+536>>2]|0,f,22544,22536,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+632|0;q=p;h[q>>3]=n;i=d;return}function ps(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+32>>3];p=f;h[k>>3]=+h[n+1144>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+40>>3];q=+h[p+24>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ol(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];am(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+344>>3]=+h[l>>3];i=b;return}function qs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+40>>3];l=+h[a+24>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vm(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3]=+h[f>>3];i=b;return}function rs(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;jm(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+24>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+504>>3]=+xd(+(+h[d>>3]),+(+h[a+40>>3]*.999));i=b;return}function ss(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+504>>3];k=+yd(1.0e-13,+(+h[g+40>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,22632,22624,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+512>>3]=m*.6219647130774989;i=d;return}function ts(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+40>>3];k=+h[g+32>>3];l=+h[g+504>>3]*(k+ +h[g+1144>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+544|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+544|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,22704,22696,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+544|0;r=q;h[r>>3]=o;i=d;return}function us(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+504>>3];k=+yd(1.0e-13,+(+h[g+40>>3]-j));l=+h[g+1144>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,22632,22816,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+520>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function vs(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+536>>3]=+yd(+(+h[d+32>>3]- +h[d+520>>3]),0.0);i=b;return}function ws(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+528>>3]=+h[b+32>>3]- +h[b+536>>3];i=i;return}function xs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+536>>3];k=1.0-j;l=+h[g+1144>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,22832,22824,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+536>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+528>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+568|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+568|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,22832,22824,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+568|0;z=y;h[z>>3]=w;i=d;return}function ys(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+24>>3]*+h[g+568>>3];k=+h[g+40>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+584|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+584|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,22880,22872,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+584|0;p=o;h[p>>3]=m;i=d;return}function zs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+3120>>3]*+h[b+584>>3];i=i;return}function As(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1048>>3]=+h[b+1032>>3]*+h[b+1080>>3];i=i;return}function Bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=-+h[b+1048>>3]/-.001519;i=i;return}function Cs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1064>>3]=+h[b+32>>3]*+h[b+1080>>3];i=i;return}function Ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=+h[b+592>>3]- +h[b+568>>3]*+h[b+24>>3];i=i;return}function Es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1096>>3]=+h[b+1080>>3]*+h[b+576>>3];i=i;return}function Fs(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=+h[(c[e+8>>2]|0)+3840>>3];g=b+416|0;j=c[g>>2]|0;k=+h[j+1480>>3];l=+h[j+1488>>3];do{if(k!=0.0){m=j;n=l/k}else{if(l==0.0){m=j;n=l;break}o=l/+XS(c[b+536>>2]|0,k,21288,22928,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[g>>2]|0;n=o}}while(0);h[m+1496>>3]=f*n;i=d;return}function Gs(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[d+1472>>3]=+h[b+3840>>3]+ +h[d+1504>>3]*+h[d+1520>>3]*(+h[b+2664>>3]+(+h[b+2672>>3]+ +h[b+2680>>3]));i=i;return}function Hs(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;_l(e,c[j>>2]|0,+h[l+632>>3],+h[l+816>>3],+h[l+824>>3],+h[l+760>>3],+h[l+768>>3],+h[l+3144>>3],+h[l+2696>>3],+h[l+2672>>3]*+h[n+1504>>3],(+h[n+528>>3]+ +h[n+536>>3])*.5,+h[n+1496>>3]/3.0,+h[n+1464>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+1440>>3];g=1.0- +h[f>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;p=+h[e+632>>3]- +h[e+2672>>3]*+h[n+1504>>3]*+h[n+1520>>3];q=+h[n+1472>>3];r=+h[n+1480>>3];if(q!=0.0){s=e;t=r/q;u=p*t;v=g*u;w=o+v;x=s;y=x+936|0;z=y;h[z>>3]=w;i=d;return}if(r==0.0){s=e;t=r;u=p*t;v=g*u;w=o+v;x=s;y=x+936|0;z=y;h[z>>3]=w;i=d;return}A=r/+XS(c[j>>2]|0,q,22944,22936,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[k>>2]>>2]|0)+8>>2]|0;t=A;u=p*t;v=g*u;w=o+v;x=s;y=x+936|0;z=y;h[z>>3]=w;i=d;return}function Is(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+936>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+792>>3]=+h[(a?e+824|0:e+816|0)>>3];i=b;return}function Js(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+936>>3];h[b+888>>3]=d*+h[(!(d>=0.0)?b+1040|0:b+1032|0)>>3];i=i;return}function Ks(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+936>>3];h[b+912>>3]=d*+h[(!(d>=0.0)?b+8|0:b+32|0)>>3];i=i;return}function Ls(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+936>>3];h[b+864>>3]=d*+h[(!(d>=0.0)?b+480|0:b+592|0)>>3];i=i;return}function Ms(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+936>>3]*+h[b+3144>>3];i=i;return}function Ns(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+936>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+736>>3]=+h[(a?e+768|0:e+760|0)>>3];i=b;return}function Os(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+608>>3]=+h[b+1440>>3]*(+h[b+512>>3]+ +h[b+520>>3])*+h[d+736>>3]*+h[b+1464>>3]*.3926990816987241;i=i;return}function Ps(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[(c[a+416>>2]|0)+1256>>3];i=i;return}function Qs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=c[b+424>>2]|0;if((a[j+54|0]|0)==0){h[(c[b+416>>2]|0)+1056>>3]=1.0;k=b+320|0;l=b+536|0;m=1.0}else{n=b+536|0;o=b+320|0;Kl(e,c[n>>2]|0,c[c[o>>2]>>2]|0,0,a[j+55|0]|0);p=+h[e>>3];h[(c[b+416>>2]|0)+1056>>3]=p;k=o;l=n;m=p}n=b+416|0;Jl(f,c[l>>2]|0,c[c[k>>2]>>2]|0,m);b=c[n>>2]|0;h[b+1040>>3]=+h[f>>3];Hl(g,c[l>>2]|0,c[c[k>>2]>>2]|0,+h[b+1056>>3]);h[(c[n>>2]|0)+1048>>3]=+h[g>>3];i=d;return}function Rs(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Il(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,+h[c[c[e>>2]>>2]>>3],+h[(c[a+416>>2]|0)+1056>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3352>>3]=+h[d>>3];i=b;return}function Ss(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[c[e>>2]>>2]|0;Gl(d,c[a+536>>2]|0,c[c[a+320>>2]>>2]|0,1,+h[f>>3],+h[(c[f+8>>2]|0)+3352>>3],+h[(c[a+400>>2]|0)+3352>>3],+h[(c[a+416>>2]|0)+1056>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1160>>3]=+h[d>>3];i=b;return}function Ts(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3344>>3]=+h[(c[a+416>>2]|0)+1064>>3]*+h[b+1160>>3];i=i;return}function Us(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1800>>3]=+h[(c[a+416>>2]|0)+88>>3];i=i;return}function Vs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1792>>3]=+h[(c[a+416>>2]|0)+88>>3];i=i;return}function Ws(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+72>>3]=+h[(c[a+416>>2]|0)+72>>3];i=i;return}function Xs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+72>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1272|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,22984,22976,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1272|0;q=p;h[q>>3]=n;i=d;return}function Ys(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1872>>3]=1.0- +h[b+72>>3];i=i;return}function Zs(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1872>>3]),1.0e-13);k=+h[g+72>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,23096,23088,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1264|0;p=o;h[p>>3]=m;i=d;return}function _s(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=+h[(c[a+416>>2]|0)+72>>3];i=i;return}function $s(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+96>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,23144,23136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+1384|0;q=p;h[q>>3]=n;i=d;return}function at(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1880>>3]=1.0- +h[b+96>>3];i=i;return}function bt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1880>>3]),1.0e-13);k=+h[g+96>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1376|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1376|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,23256,23248,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1376|0;p=o;h[p>>3]=m;i=d;return}function ct(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+80>>3]=101325.0;i=i;return}function dt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1208>>3]=+h[b+80>>3]*1.0e-5;i=i;return}function et(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=101325.0;i=i;return}function ft(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1320>>3]=+h[b+104>>3]*1.0e-5;i=i;return}function gt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+64>>3]=293.15;i=i;return}function ht(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1200>>3]=+h[b+64>>3]+-273.15;i=i;return}function it(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+72>>3];p=f;h[k>>3]=+h[n+1872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+80>>3];q=+h[p+64>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2336>>3]=+h[l>>3];i=b;return}function jt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+72>>3];p=f;h[k>>3]=+h[n+1872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+80>>3];q=+h[p+64>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2368>>3]=+h[l>>3];i=b;return}function kt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+416|0;t=+h[c[s>>2]>>3];u=a+4|0;v=l;h[k>>3]=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+2712>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,t,l);l=a+536|0;a=c[l>>2]|0;v=c[(c[c[u>>2]>>2]|0)+8>>2]|0;t=+h[v+3912>>3];w=+h[v+2384>>3];v=g;x=m;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];Ml(n,a,t,w,g);g=c[l>>2]|0;a=f;x=n;c[a+0>>2]=c[x+0>>2];c[a+4>>2]=c[x+4>>2];c[a+8>>2]=c[x+8>>2];c[a+12>>2]=c[x+12>>2];c[a+16>>2]=c[x+16>>2];c[a+20>>2]=c[x+20>>2];c[a+24>>2]=c[x+24>>2];c[a+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[u>>2]>>2]|0)+8>>2]|0;t=+h[q+72>>3];f=j;h[k>>3]=+h[q+1872>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,t,j);j=c[l>>2]|0;f=c[(c[c[u>>2]>>2]|0)+8>>2]|0;t=+h[f+80>>3];y=+h[f+64>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,t,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[s>>2]|0;h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+1520>>3]=+h[d+136>>3]*(w- +h[r>>3])*+h[d+896>>3];i=b;return}function lt(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+136>>3]*+h[e+896>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1520>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1464|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1464|0;q=p;h[q>>3]=n;i=d;return}k=l/+XS(c[b+536>>2]|0,f,23304,23296,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1464|0;q=p;h[q>>3]=n;i=d;return}function mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+72>>3];p=f;h[k>>3]=+h[n+1872>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+80>>3];q=+h[p+64>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ol(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];am(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1176>>3]=+h[l>>3];i=b;return}function nt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+80>>3];l=+h[a+64>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vm(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1304>>3]=+h[f>>3];i=b;return}function ot(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;jm(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+64>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1216>>3]=+xd(+(+h[d>>3]),+(+h[a+80>>3]*.999));i=b;return}function pt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1216>>3];k=+yd(1.0e-13,+(+h[g+80>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,23368,23360,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1224>>3]=m*.6219647130774989;i=d;return}function qt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+80>>3];k=+h[g+72>>3];l=+h[g+1216>>3]*(k+ +h[g+1872>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1256|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1256|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,23448,23440,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1256|0;r=q;h[r>>3]=o;i=d;return}function rt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1216>>3];k=+yd(1.0e-13,+(+h[g+80>>3]-j));l=+h[g+1872>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,23368,23560,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1232>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function st(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1248>>3]=+yd(+(+h[d+72>>3]- +h[d+1232>>3]),0.0);i=b;return}function tt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[b+72>>3]- +h[b+1248>>3];i=i;return}function ut(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1248>>3];k=1.0-j;l=+h[g+1872>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,23576,23568,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1248>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1240>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1280|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1280|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,23576,23568,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1280|0;z=y;h[z>>3]=w;i=d;return}function vt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+64>>3]*+h[g+1280>>3];k=+h[g+80>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,23624,23616,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1296|0;p=o;h[p>>3]=m;i=d;return}function wt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1848>>3]=+h[b+3016>>3]*+h[b+1296>>3];i=i;return}function xt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1816>>3]=+h[b+1800>>3]*+h[b+1848>>3];i=i;return}function yt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=-+h[b+1816>>3]/-.001519;i=i;return}function zt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1832>>3]=+h[b+72>>3]*+h[b+1848>>3];i=i;return}function At(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1288>>3]=+h[b+1304>>3]- +h[b+1280>>3]*+h[b+64>>3];i=i;return}function Bt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[b+1848>>3]*+h[b+1288>>3];i=i;return}function Ct(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+88>>3]=293.15;i=i;return}function Dt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+88>>3]+-273.15;i=i;return}function Et(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+96>>3];p=f;h[k>>3]=+h[n+1880>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+104>>3];q=+h[p+88>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2328>>3]=+h[l>>3];i=b;return}function Ft(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+96>>3];p=f;h[k>>3]=+h[n+1880>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+104>>3];q=+h[p+88>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2360>>3]=+h[l>>3];i=b;return}function Gt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+72>>3];v=l;h[k>>3]=+h[t+1872>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+80>>3];w=+h[t+64>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+96>>3];f=j;h[k>>3]=+h[q+1880>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+104>>3];y=+h[f+88>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+1512>>3]=(+h[d+128>>3]+ +h[d+136>>3])*(w- +h[r>>3])*+h[d+896>>3]*.5;i=b;return}function Ht(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;e=c[b+416>>2]|0;f=+h[e+896>>3]*(+h[e+128>>3]+ +h[e+136>>3]);e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1512>>3];if(f!=0.0){l=j;m=k/f;n=m*-2.0;o=l;p=o+1456|0;q=p;h[q>>3]=n;i=d;return}if(k==0.0){l=j;m=k;n=m*-2.0;o=l;p=o+1456|0;q=p;h[q>>3]=n;i=d;return}r=k/+XS(c[b+536>>2]|0,f,23680,23672,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=r;n=m*-2.0;o=l;p=o+1456|0;q=p;h[q>>3]=n;i=d;return}function It(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+96>>3];p=f;h[k>>3]=+h[n+1880>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+104>>3];q=+h[p+88>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ol(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];am(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1168>>3]=+h[l>>3];i=b;return}function Jt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+104>>3];l=+h[a+88>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];vm(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1416>>3]=+h[f>>3];i=b;return}function Kt(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;jm(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+88>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+1328>>3]=+xd(+(+h[d>>3]),+(+h[a+104>>3]*.999));i=b;return}function Lt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1328>>3];k=+yd(1.0e-13,+(+h[g+104>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,23768,23760,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+1336>>3]=m*.6219647130774989;i=d;return}function Mt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+104>>3];k=+h[g+96>>3];l=+h[g+1328>>3]*(k+ +h[g+1880>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+1368|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+1368|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,23848,23840,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+1368|0;r=q;h[r>>3]=o;i=d;return}function Nt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1328>>3];k=+yd(1.0e-13,+(+h[g+104>>3]-j));l=+h[g+1880>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,23768,23960,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+1344>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function Ot(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1360>>3]=+yd(+(+h[d+96>>3]- +h[d+1344>>3]),0.0);i=b;return}function Pt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[b+96>>3]- +h[b+1360>>3];i=i;return}function Qt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1360>>3];k=1.0-j;l=+h[g+1880>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,23976,23968,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+1360>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+1352>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+1392|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+1392|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,23976,23968,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+1392|0;z=y;h[z>>3]=w;i=d;return}function Rt(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+88>>3]*+h[g+1392>>3];k=+h[g+104>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1408|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1408|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,24024,24016,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1408|0;p=o;h[p>>3]=m;i=d;return}function St(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1840>>3]=+h[b+3008>>3]*+h[b+1408>>3];i=i;return}function Tt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1808>>3]=+h[b+1792>>3]*+h[b+1840>>3];i=i;return}function Ut(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=-+h[b+1808>>3]/-.001519;i=i;return}function Vt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1824>>3]=+h[b+96>>3]*+h[b+1840>>3];i=i;return}function Wt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1400>>3]=+h[b+1416>>3]- +h[b+1392>>3]*+h[b+88>>3];i=i;return}function Xt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1856>>3]=+h[b+1840>>3]*+h[b+1400>>3];i=i;return}function Yt(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=c[c[b+4>>2]>>2]|0;f=+h[(c[e+8>>2]|0)+3832>>3];g=b+416|0;j=c[g>>2]|0;k=+h[j+936>>3];l=+h[j+944>>3];do{if(k!=0.0){m=j;n=l/k}else{if(l==0.0){m=j;n=l;break}o=l/+XS(c[b+536>>2]|0,k,21248,24072,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[g>>2]|0;n=o}}while(0);h[m+952>>3]=f*n;i=d;return}function Zt(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[d+928>>3]=+h[b+3832>>3]+ +h[d+960>>3]*+h[d+976>>3]*(+h[b+2640>>3]+(+h[b+2648>>3]+ +h[b+2656>>3]));i=i;return}function _t(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;_l(e,c[j>>2]|0,+h[l+1456>>3],+h[l+2328>>3],+h[l+2336>>3],+h[l+2360>>3],+h[l+2368>>3],+h[l+3032>>3],+h[l+2720>>3],+h[l+2648>>3]*+h[n+960>>3],(+h[n+160>>3]+ +h[n+168>>3])*.5,+h[n+952>>3]/3.0,+h[n+920>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+896>>3];g=1.0- +h[f>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;p=+h[e+1456>>3]- +h[e+2648>>3]*+h[n+960>>3]*+h[n+976>>3];q=+h[n+928>>3];r=+h[n+936>>3];if(q!=0.0){s=e;t=r/q;u=p*t;v=g*u;w=o+v;x=s;y=x+1696|0;z=y;h[z>>3]=w;i=d;return}if(r==0.0){s=e;t=r;u=p*t;v=g*u;w=o+v;x=s;y=x+1696|0;z=y;h[z>>3]=w;i=d;return}A=r/+XS(c[j>>2]|0,q,24088,24080,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[k>>2]>>2]|0)+8>>2]|0;t=A;u=p*t;v=g*u;w=o+v;x=s;y=x+1696|0;z=y;h[z>>3]=w;i=d;return}function $t(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1696>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1584>>3]=+h[(a?e+2336|0:e+2328|0)>>3];i=b;return}function au(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1696>>3];h[b+1648>>3]=d*+h[(!(d>=0.0)?b+1800|0:b+1792|0)>>3];i=i;return}function bu(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1696>>3];h[b+1672>>3]=d*+h[(!(d>=0.0)?b+72|0:b+96|0)>>3];i=i;return}function cu(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1696>>3];h[b+1624>>3]=d*+h[(!(d>=0.0)?b+1304|0:b+1416|0)>>3];i=i;return}function du(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1536>>3]=+h[b+1696>>3]*+h[b+3032>>3];i=i;return}function eu(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1696>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1560>>3]=+h[(a?e+2368|0:e+2360|0)>>3];i=b;return}function fu(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1432>>3]=+h[b+896>>3]*(+h[b+144>>3]+ +h[b+152>>3])*+h[d+1560>>3]*+h[b+920>>3]*.3926990816987241;i=i;return}function gu(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;o=+h[n+168>>3];_l(e,c[j>>2]|0,+h[l+1464>>3],+h[l+2336>>3],+h[l+2344>>3],+h[l+2368>>3],+h[l+2376>>3],+h[l+3040>>3],+h[n+152>>3],+h[l+2656>>3]*+h[n+960>>3],(o+o)*.5,+h[n+952>>3]/3.0,+h[n+920>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+896>>3];g=1.0- +h[f>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;p=+h[e+1464>>3]- +h[e+2656>>3]*+h[n+960>>3]*+h[n+976>>3];q=+h[n+928>>3];r=+h[n+936>>3];if(q!=0.0){s=e;t=r/q;u=p*t;v=g*u;w=o+v;x=s;y=x+1704|0;z=y;h[z>>3]=w;i=d;return}if(r==0.0){s=e;t=r;u=p*t;v=g*u;w=o+v;x=s;y=x+1704|0;z=y;h[z>>3]=w;i=d;return}A=r/+XS(c[j>>2]|0,q,24088,24120,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[k>>2]>>2]|0)+8>>2]|0;t=A;u=p*t;v=g*u;w=o+v;x=s;y=x+1704|0;z=y;h[z>>3]=w;i=d;return}function hu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1784>>3]=+h[b+1696>>3]- +h[b+1704>>3];i=i;return}function iu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3016>>3];k=+h[g+1784>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2280|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,24136,24128,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2280|0;p=o;h[p>>3]=m;i=d;return}function ju(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+792>>3]*+h[j+1296>>3]*+h[e+136>>3];l=+h[j+1696>>3]+ +h[j+1704>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1192|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1192|0;r=q;h[r>>3]=o;i=d;return}s=l/+XS(c[b+536>>2]|0,k,24168,24160,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1192|0;r=q;h[r>>3]=o;i=d;return}function ku(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1720>>3]=+h[b+1192>>3]*+h[d+136>>3]*+h[d+792>>3]*((+h[b+3912>>3]- +h[b+104>>3])/1.5+(+h[b+1456>>3]*.5+ +h[b+1464>>3]));i=i;return}function lu(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+1192>>3],+h[f+2336>>3],+h[f+2368>>3],+h[(c[a+416>>2]|0)+152>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1488>>3]=+h[d>>3];i=b;return}function mu(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1704>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1592>>3]=+h[(a?e+2344|0:e+2336|0)>>3];i=b;return}function nu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+416|0;p=+h[c[o>>2]>>3];q=b+4|0;r=g;h[k>>3]=+h[(c[(c[c[q>>2]>>2]|0)+8>>2]|0)+2712>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];YT(j,2,p,g);g=b+536|0;r=c[g>>2]|0;s=c[(c[c[q>>2]>>2]|0)+8>>2]|0;p=+h[s+3912>>3];t=+h[s+2384>>3];s=f;u=j;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];im(m,r,p,t,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];mm(n,r,e);e=c[o>>2]|0;t=+h[n>>3]*+h[e+136>>3]*+h[e+792>>3];e=c[c[q>>2]>>2]|0;n=c[e+8>>2]|0;p=+h[n+1704>>3];if(t!=0.0){v=n;w=p/t;x=v;y=x+1600|0;z=y;h[z>>3]=w;i=d;return}if(p==0.0){v=n;w=p;x=v;y=x+1600|0;z=y;h[z>>3]=w;i=d;return}A=p/+XS(c[g>>2]|0,t,24248,24240,+h[e>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[q>>2]>>2]|0)+8>>2]|0;w=A;x=v;y=x+1600|0;z=y;h[z>>3]=w;i=d;return}function ou(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+1600>>3],+h[f+2344>>3],+h[f+2376>>3],+h[(c[a+416>>2]|0)+152>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1496>>3]=+h[d>>3];i=b;return}function pu(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1704>>3];if(!(d>=0.0)){e=(c[a+416>>2]|0)+16|0}else{e=b+1800|0}h[b+1656>>3]=d*+h[e>>3];i=i;return}function qu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1752>>3]=+h[b+1648>>3]- +h[b+1656>>3];i=i;return}function ru(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+288>>3]=+h[b+1752>>3]/.001519;i=i;return}function su(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1704>>3];if(!(d>=0.0)){e=c[a+416>>2]|0}else{e=b+72|0}h[b+1680>>3]=d*+h[e>>3];i=i;return}function tu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1768>>3]=+h[b+1672>>3]- +h[b+1680>>3];i=i;return}function uu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1848>>3];k=+h[g+1768>>3]- +h[g+72>>3]*+h[g+1784>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,24496,24488,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+240|0;p=o;h[p>>3]=m;i=d;return}function vu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=-+h[b+240>>3];i=i;return}function wu(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1704>>3];h[b+1632>>3]=d*+h[(!(d>=0.0)?b+3856|0:b+1304|0)>>3];i=i;return}function xu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1736>>3]=+h[b+1624>>3]- +h[b+1632>>3];i=i;return}function yu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2096>>3]=+h[b+1736>>3]+ +h[b+1720>>3];i=i;return}function zu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1848>>3];k=+h[g+2096>>3]- +h[g+1784>>3]*+h[g+1288>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2016|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2016|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,24496,24512,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2016|0;p=o;h[p>>3]=m;i=d;return}function Au(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+248>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+248|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+248>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+232>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+232|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+232>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+8>>3]=k;SW(a,0)|0;j=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+248>>3]=+h[j>>3];h[f+232>>3]=+h[j+8>>3];tn(a);un(a);vn(a);wn(a);xn(a);yn(a);i=b;return}function Bu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1544>>3]=+h[b+1704>>3]*+h[b+3040>>3];i=i;return}function Cu(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1704>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1568>>3]=+h[(a?e+2376|0:e+2368|0)>>3];i=b;return}function Du(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1440>>3]=+h[b+896>>3]*+h[b+152>>3]*+h[d+1568>>3]*+h[b+920>>3]*.7853981633974483;i=i;return}function Eu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+136>>3]=+h[(c[a+416>>2]|0)+48>>3];i=i;return}function Fu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+136>>3];k=j/.01801528-j/.0289651159+34.52428788658843;if(k!=0.0){l=k;m=g;n=1.0/l;o=m;p=o+3520|0;q=p;h[q>>3]=n;i=d;return}j=+XS(c[b+536>>2]|0,k,24528,24520,+h[f>>3],(a[b+319|0]|0)!=0|0);l=j;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=1.0/l;o=m;p=o+3520|0;q=p;h[q>>3]=n;i=d;return}function Gu(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3344>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=+h[e+136>>3]}else{f=.01}h[e+2768>>3]=f*+h[e+3344>>3];i=b;return}function Hu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=1.0- +h[b+136>>3];i=i;return}function Iu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1912>>3]=1.0- +h[b+136>>3];i=i;return}function Ju(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+1912>>3]),1.0e-13);k=+h[g+136>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3512|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3512|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,24632,24624,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3512|0;p=o;h[p>>3]=m;i=d;return}function Ku(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[(c[a+416>>2]|0)+760>>3];i=i;return}function Lu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3456>>3]=+h[b+160>>3]*1.0e-5;i=i;return}function Mu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3360>>3]=+h[b+160>>3]*1.0e-5;i=i;return}function Nu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0;b=i;i=i+56|0;d=b;e=b+32|0;f=i;i=i+16|0;g=i;i=i+32|0;j=i;i=i+8|0;k=a+4|0;YT(f,1,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+96>>3],b+48|0);l=a+536|0;a=c[l>>2]|0;m=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[m+160>>3];o=+h[m+1416>>3];m=e;p=f;c[m+0>>2]=c[p+0>>2];c[m+4>>2]=c[p+4>>2];c[m+8>>2]=c[p+8>>2];ln(g,a,n,o,e);e=c[l>>2]|0;l=d;a=g;c[l+0>>2]=c[a+0>>2];c[l+4>>2]=c[a+4>>2];c[l+8>>2]=c[a+8>>2];c[l+12>>2]=c[a+12>>2];c[l+16>>2]=c[a+16>>2];c[l+20>>2]=c[a+20>>2];c[l+24>>2]=c[a+24>>2];c[l+28>>2]=c[a+28>>2];bn(j,e,d);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1936>>3]=+h[j>>3];i=b;return}function Ou(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;m=+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+160>>3];a=e;n=24664;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];ln(f,k,m,45263.2387446934,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];bn(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+1944>>3]=+h[g>>3];i=b;return}function Pu(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;Jm(d,c[a+536>>2]|0,293.15);e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3368>>3]=+xd(+(+h[d>>3]),+(+h[e+160>>3]*.999));i=b;return}function Qu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=+h[g+160>>3];do{if(j!=0.0){l=g;m=k/j}else{if(k==0.0){l=g;m=k;break}n=k/+XS(c[b+536>>2]|0,j,24688,24680,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3408>>3]=m*.01598094902253916;i=d;return}function Ru(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,24728,24720,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3376>>3]=m*.6219647130774989;i=d;return}function Su(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3368>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));if(k!=0.0){l=k;m=g;n=.99/l;o=j*n;p=o*.6219647130774989;q=+xd(+p,1.0);r=m;s=r+3384|0;t=s;h[t>>3]=q;i=d;return}u=+XS(c[b+536>>2]|0,k,24728,24792,+h[f>>3],(a[b+319|0]|0)!=0|0);l=u;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=.99/l;o=j*n;p=o*.6219647130774989;q=+xd(+p,1.0);r=m;s=r+3384|0;t=s;h[t>>3]=q;i=d;return}function Tu(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3400>>3]=+yd(+(.01- +h[d+3384>>3]),0.0);i=b;return}function Uu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3392>>3]=.01- +h[b+3400>>3];i=i;return}function Vu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3400>>3];k=1.0-j;if(k!=0.0){l=k;m=j;n=g;o=f}else{j=+XS(c[b+536>>2]|0,k,24808,24800,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=j;m=+h[g+3400>>3];n=g;o=f}j=284.1807127034489/l;l=1.0-m;m=+h[n+3392>>3];if(l!=0.0){p=n;q=m/l;r=q*461.5233290850878;s=j+r;t=p;u=t+3416|0;v=u;h[v>>3]=s;i=d;return}if(m==0.0){p=n;q=m;r=q*461.5233290850878;s=j+r;t=p;u=t+3416|0;v=u;h[v>>3]=s;i=d;return}k=m/+XS(c[b+536>>2]|0,l,24808,24800,+h[o>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=k;r=q*461.5233290850878;s=j+r;t=p;u=t+3416|0;v=u;h[v>>3]=s;i=d;return}function Wu(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3416>>3]*293.15;k=+h[g+160>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3432|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3432|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,24856,24848,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3432|0;p=o;h[p>>3]=m;i=d;return}function Xu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,k=0;b=i;i=i+24|0;d=b;e=b+16|0;f=c[a+536>>2]|0;g=a+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3];a=d;k=24664;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];Pm(e,f,j,293.15,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3440>>3]=+h[e>>3];i=b;return}function Yu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;b=i;i=i+88|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=a+536|0;k=c[j>>2]|0;l=a+4|0;a=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[a+160>>3];n=+h[a+3440>>3];a=e;o=24664;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];ln(f,k,m,n,e);e=c[j>>2]|0;j=d;k=f;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];c[j+24>>2]=c[k+24>>2];c[j+28>>2]=c[k+28>>2];bn(g,e,d);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+1928>>3]=+h[g>>3];i=b;return}function Zu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3424>>3]=+h[b+3440>>3]+ +h[b+3416>>3]*-293.15;i=i;return}function _u(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[(c[a+416>>2]|0)+712>>3];i=i;return}function $u(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3448>>3]=+h[b+152>>3]+-273.15;i=i;return}function av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+136>>3];p=f;h[k>>3]=+h[n+1912>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+152>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Wm(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vm(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1904>>3]=+h[l>>3];i=b;return}function bv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=a+4|0;YT(e,1,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],b+16|0);j=c[a+536>>2]|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[a+160>>3];l=+h[a+152>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];mn(f,j,k,l,d);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3552>>3]=+h[f>>3];i=b;return}function cv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3344>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2800>>3]=+h[e+3344>>3]*+h[(a<<24>>24==0?e+3552|0:e+3440|0)>>3];i=b;return}function dv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0;b=i;i=i+120|0;d=b;e=b+96|0;f=i;i=i+16|0;g=i;i=i+96|0;j=i;i=i+8|0;k=a+4|0;YT(f,1,+h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+136>>3],b+112|0);c[g>>2]=21568;h[g+8>>3]=.01801528;h[g+16>>3]=-13423382.81725291;h[g+24>>3]=549760.6476280135;h[g+32>>3]=1.0e3;l=g+40|0;m=21576;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=g+52|0;l=21592;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];l=g+64|0;m=21608;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=g+76|0;l=21624;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];h[g+88>>3]=461.5233290850878;l=c[a+536>>2]|0;a=c[(c[c[k>>2]>>2]|0)+8>>2]|0;n=+h[a+3552>>3];o=+h[a+160>>3];a=e;m=f;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];m=d+0|0;a=g+0|0;g=m+96|0;do{c[m>>2]=c[a>>2];m=m+4|0;a=a+4|0}while((m|0)<(g|0));em(j,l,n,190.0,647.0,o,e,d,1.0e-13);h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+1896>>3]=+h[j>>3];i=b;return}function ev(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+136>>3];p=f;h[k>>3]=+h[n+1888>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+1896>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2320>>3]=+h[l>>3];i=b;return}function fv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+136>>3];p=f;h[k>>3]=+h[n+1888>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+1896>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+2352>>3]=+h[l>>3];i=b;return}function gv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+96>>3];v=l;h[k>>3]=+h[t+1880>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+104>>3];w=+h[t+88>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+136>>3];f=j;h[k>>3]=+h[q+1888>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+160>>3];y=+h[f+1896>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+1504>>3]=+h[d+128>>3]*(w- +h[r>>3])*+h[d+896>>3];i=b;return}function hv(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+128>>3]*+h[e+896>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+1504>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}k=l/+XS(c[b+536>>2]|0,f,24896,24888,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+1448|0;q=p;h[q>>3]=n;i=d;return}function iv(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;o=+h[n+160>>3];_l(e,c[j>>2]|0,+h[l+1448>>3],+h[l+2320>>3],+h[l+2328>>3],+h[l+2352>>3],+h[l+2360>>3],+h[l+3024>>3],+h[n+144>>3],+h[l+2640>>3]*+h[n+960>>3],(o+o)*.5,+h[n+952>>3]/3.0,+h[n+920>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+896>>3];g=1.0- +h[f>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;p=+h[e+1448>>3]- +h[e+2640>>3]*+h[n+960>>3]*+h[n+976>>3];q=+h[n+928>>3];r=+h[n+936>>3];if(q!=0.0){s=e;t=r/q;u=p*t;v=g*u;w=o+v;x=s;y=x+1688|0;z=y;h[z>>3]=w;i=d;return}if(r==0.0){s=e;t=r;u=p*t;v=g*u;w=o+v;x=s;y=x+1688|0;z=y;h[z>>3]=w;i=d;return}A=r/+XS(c[j>>2]|0,q,24088,24952,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[k>>2]>>2]|0)+8>>2]|0;t=A;u=p*t;v=g*u;w=o+v;x=s;y=x+1688|0;z=y;h[z>>3]=w;i=d;return}function jv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=xW(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2808>>3]=-(+h[e+1688>>3]*+h[(a<<24>>24==0?e+3552|0:e+1416|0)>>3]);i=b;return}function kv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2776>>3]=-(+h[(a?e+136|0:e+96|0)>>3]*+h[e+1688>>3]);i=b;return}function lv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1576>>3]=+h[(a?e+2328|0:e+2320|0)>>3];i=b;return}function mv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+136>>3];r=g;h[k>>3]=+h[p+1888>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];YT(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+160>>3];s=+h[p+1896>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];im(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];mm(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+792>>3]*+h[e+128>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+1688>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+1608|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+1608|0;y=x;h[y>>3]=v;i=d;return}z=q/+XS(c[g>>2]|0,s,24968,24960,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+1608|0;y=x;h[y>>3]=v;i=d;return}function nv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+1608>>3],+h[f+2320>>3],+h[f+2352>>3],+h[(c[a+416>>2]|0)+144>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1472>>3]=+h[d>>3];i=b;return}function ov(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1688>>3];h[b+1664>>3]=d*+h[(!(d>=0.0)?b+96|0:b+136|0)>>3];i=i;return}function pv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=+h[b+1664>>3]- +h[b+1672>>3];i=i;return}function qv(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1688>>3];h[b+1616>>3]=d*+h[(!(d>=0.0)?b+1416|0:b+3552|0)>>3];i=i;return}function rv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1728>>3]=+h[b+1616>>3]- +h[b+1624>>3];i=i;return}function sv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1776>>3]=+h[b+1688>>3]- +h[b+1696>>3];i=i;return}function tv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1840>>3];k=+h[g+1760>>3]- +h[g+96>>3]*+h[g+1776>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+264|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,25224,25216,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+264|0;p=o;h[p>>3]=m;i=d;return}function uv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=-+h[b+264>>3];i=i;return}function vv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3008>>3];k=+h[g+1776>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2264|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2264|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,25248,25240,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2264|0;p=o;h[p>>3]=m;i=d;return}function wv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+792>>3]*+h[j+1408>>3]*+h[e+128>>3];l=+h[j+1688>>3]+ +h[j+1696>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+1184|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+1184|0;r=q;h[r>>3]=o;i=d;return}s=l/+XS(c[b+536>>2]|0,k,25280,25272,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+1184|0;r=q;h[r>>3]=o;i=d;return}function xv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1712>>3]=+h[b+1184>>3]*+h[d+128>>3]*+h[d+792>>3]*((+h[b+80>>3]- +h[b+160>>3])/1.5+(+h[b+1448>>3]+ +h[b+1456>>3]*.5));i=i;return}function yv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2088>>3]=+h[b+1728>>3]+ +h[b+1712>>3];i=i;return}function zv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1840>>3];k=+h[g+2088>>3]- +h[g+1776>>3]*+h[g+1400>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,25224,25352,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1992|0;p=o;h[p>>3]=m;i=d;return}function Av(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+272>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+272|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+272>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+256>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+256|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+256>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+8>>3]=k;SW(a,1)|0;j=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+272>>3]=+h[j>>3];h[f+256>>3]=+h[j+8>>3];Bn(a);Cn(a);Dn(a);En(a);Fn(a);Gn(a);i=b;return}function Bv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+1184>>3],+h[f+2328>>3],+h[f+2360>>3],+h[(c[a+416>>2]|0)+144>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+1480>>3]=+h[d>>3];i=b;return}function Cv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1528>>3]=+h[b+1688>>3]*+h[b+3024>>3];i=i;return}function Dv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+1552>>3]=+h[(a?e+2360|0:e+2352|0)>>3];i=b;return}function Ev(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1424>>3]=+h[b+896>>3]*+h[b+144>>3]*+h[d+1552>>3]*+h[b+920>>3]*.7853981633974483;i=i;return}function Fv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1128>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1128|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1128>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+1120>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+1120|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+1120>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+1112>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+1112|0;h[(c[j+208>>2]|0)+16>>3]=+h[e>>3];k=+UW(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+1112>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+16>>3]=k;SW(a,2)|0;g=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1128>>3]=+h[g>>3];h[f+1120>>3]=+h[g+8>>3];h[f+1112>>3]=+h[g+16>>3];Jn(a);Kn(a);Ln(a);Mn(a);Nn(a);i=b;return}function Gv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=+h[b+944>>3]+(+h[b+3344>>3]- +h[b+1688>>3]);i=i;return}function Hv(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+752>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+3568>>3];if(e!=0.0){l=j;m=k/e;n=l;o=n+3736|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+3736|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,e,25368,25360,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3736|0;p=o;h[p>>3]=m;i=d;return}function Iv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;k=i;i=i+32|0;l=i;i=i+8|0;m=b+4|0;n=c[c[m>>2]>>2]|0;o=c[n+8>>2]|0;p=+yd(+(+h[o+944>>3]),1.0e-15);q=p+1.0e-15;r=p*+h[o+8>>3]+1.0e-17;do{if(q!=0.0){s=r/q}else{if(r==0.0){s=r;break}s=r/+XS(c[b+536>>2]|0,q,25392,25384,+h[n>>3],(a[b+319|0]|0)!=0|0)}}while(0);YT(j,1,s,g);g=b+536|0;n=c[g>>2]|0;o=c[c[m>>2]>>2]|0;t=c[o+8>>2]|0;s=+h[t+160>>3];q=+yd(+(+h[t+944>>3]),1.0e-15);r=q+1.0e-15;p=q*+h[t+480>>3]+4.52632387446934e-11;do{if(r!=0.0){u=p/r}else{if(p==0.0){u=p;break}u=p/+XS(n,r,25392,25384,+h[o>>3],(a[b+319|0]|0)!=0|0)}}while(0);b=f;o=j;c[b+0>>2]=c[o+0>>2];c[b+4>>2]=c[o+4>>2];c[b+8>>2]=c[o+8>>2];ln(k,n,s,u,f);f=c[g>>2]|0;g=e;n=k;c[g+0>>2]=c[n+0>>2];c[g+4>>2]=c[n+4>>2];c[g+8>>2]=c[n+8>>2];c[g+12>>2]=c[n+12>>2];c[g+16>>2]=c[n+16>>2];c[g+20>>2]=c[n+20>>2];c[g+24>>2]=c[n+24>>2];c[g+28>>2]=c[n+28>>2];bn(l,f,e);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+1920>>3]=+h[l>>3];i=d;return}function Jv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0,o=0.0,p=0.0;d=i;e=b+4|0;f=xW(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+944>>3];do{if(f<<24>>24==0){l=j;m=+h[j+3552>>3]}else{n=+yd(+k,1.0e-15);o=n+1.0e-15;p=n*+h[j+480>>3]+4.52632387446934e-11;if(o!=0.0){l=j;m=p/o;break}if(p==0.0){l=j;m=p;break}n=p/+XS(c[b+536>>2]|0,o,25392,25432,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+2792>>3]=k*m;i=d;return}function Kv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=+h[b+2792>>3]+(+h[b+2800>>3]+ +h[b+2808>>3]);i=i;return}function Lv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(xW(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=j;l=+h[j+136>>3]}else{m=+yd(+(+h[j+944>>3]),1.0e-15);n=m+1.0e-15;o=m*+h[j+8>>3]+1.0e-17;if(n!=0.0){k=j;l=o/n;break}if(o==0.0){k=j;l=o;break}m=o/+XS(c[b+536>>2]|0,n,25392,25440,+h[g>>3],(a[b+319|0]|0)!=0|0);k=c[(c[c[e>>2]>>2]|0)+8>>2]|0;l=m}}while(0);h[k+2760>>3]=l*+h[k+944>>3];i=d;return}function Mv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+2760>>3]+(+h[b+2768>>3]+ +h[b+2776>>3]);i=i;return}function Nv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1024>>3]=+h[b+936>>3]- +h[b+944>>3];i=i;return}function Ov(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3128>>3];k=+h[g+1024>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2312|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,25456,25448,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2312|0;p=o;h[p>>3]=m;i=d;return}function Pv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1336>>3]*+h[j+472>>3]*+h[e+504>>3];l=+h[j+936>>3]+ +h[j+944>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}s=l/+XS(c[b+536>>2]|0,k,25488,25480,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+368|0;r=q;h[r>>3]=o;i=d;return}function Qv(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+368>>3],+h[f+824>>3],+h[f+768>>3],+h[(c[a+416>>2]|0)+520>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+664>>3]=+h[d>>3];i=b;return}function Rv(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+744>>3]=+h[(a?e+776|0:e+768|0)>>3];i=b;return}function Sv(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+616>>3]=+h[b+1440>>3]*+h[b+520>>3]*+h[d+744>>3]*+h[b+1464>>3]*.7853981633974483;i=i;return}function Tv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+944>>3];if(j>=0.0){k=g;l=j*+h[g+8>>3];m=k;n=m+920|0;o=n;h[o>>3]=l;i=d;return}p=+yd(+-j,1.0e-15);q=p+1.0e-15;r=p*+h[g+136>>3]+1.0e-17;do{if(q!=0.0){s=j;t=g;u=r/q}else{if(r==0.0){s=j;t=g;u=r;break}p=r/+XS(c[b+536>>2]|0,q,25560,25552,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;s=+h[v+944>>3];t=v;u=p}}while(0);k=t;l=u*s;m=k;n=m+920|0;o=n;h[o>>3]=l;i=d;return}function Uv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=+h[b+912>>3]- +h[b+920>>3];i=i;return}function Vv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1088>>3];k=+h[g+1008>>3]- +h[g+8>>3]*+h[g+1024>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,25608,25600,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+176|0;p=o;h[p>>3]=m;i=d;return}function Wv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=-+h[b+176>>3];i=i;return}function Xv(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+944>>3];if(j>=0.0){k=g;l=j*+h[g+480>>3];m=k;n=m+872|0;o=n;h[o>>3]=l;i=d;return}p=+yd(+-j,1.0e-15);q=p+1.0e-15;r=p*+h[g+3552>>3]+4.52632387446934e-11;do{if(q!=0.0){s=j;t=g;u=r/q}else{if(r==0.0){s=j;t=g;u=r;break}p=r/+XS(c[b+536>>2]|0,q,25560,25624,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;s=+h[v+944>>3];t=v;u=p}}while(0);k=t;l=u*s;m=k;n=m+872|0;o=n;h[o>>3]=l;i=d;return}function Yv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+976>>3]=+h[b+864>>3]- +h[b+872>>3];i=i;return}function Zv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=+h[b+944>>3]*+h[b+3152>>3];i=i;return}function _v(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0.0;d=i;i=i+56|0;e=d;f=d+32|0;g=d+48|0;j=i;i=i+16|0;l=i;i=i+32|0;m=i;i=i+32|0;n=i;i=i+8|0;o=b+4|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+1112>>3];r=g;h[k>>3]=+h[p+1120>>3];c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];YT(j,2,q,g);g=b+536|0;r=c[g>>2]|0;p=c[(c[c[o>>2]>>2]|0)+8>>2]|0;q=+h[p+160>>3];s=+h[p+1128>>3];p=f;t=j;c[p+0>>2]=c[t+0>>2];c[p+4>>2]=c[t+4>>2];c[p+8>>2]=c[t+8>>2];im(m,r,q,s,f);f=l;r=m;c[f+0>>2]=c[r+0>>2];c[f+4>>2]=c[r+4>>2];c[f+8>>2]=c[r+8>>2];c[f+12>>2]=c[r+12>>2];c[f+16>>2]=c[r+16>>2];c[f+20>>2]=c[r+20>>2];c[f+24>>2]=c[r+24>>2];c[f+28>>2]=c[r+28>>2];r=c[g>>2]|0;f=e;m=l;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];mm(n,r,e);e=c[b+416>>2]|0;s=+h[n>>3]*+h[e+1336>>3]*+h[e+504>>3];e=c[c[o>>2]>>2]|0;n=c[e+8>>2]|0;q=+h[n+944>>3];if(s!=0.0){u=n;v=q/s;w=u;x=w+840|0;y=x;h[y>>3]=v;i=d;return}if(q==0.0){u=n;v=q;w=u;x=w+840|0;y=x;h[y>>3]=v;i=d;return}z=q/+XS(c[g>>2]|0,s,25640,25632,+h[e>>3],(a[b+319|0]|0)!=0|0);u=c[(c[c[o>>2]>>2]|0)+8>>2]|0;v=z;w=u;x=w+840|0;y=x;h[y>>3]=v;i=d;return}function $v(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+800>>3]=+h[(a?e+832|0:e+824|0)>>3];i=b;return}function aw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+840>>3],+h[f+832>>3],+h[f+776>>3],+h[(c[a+416>>2]|0)+520>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+672>>3]=+h[d>>3];i=b;return}function bw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+960>>3]=+h[b+368>>3]*+h[d+504>>3]*+h[d+1336>>3]*((+h[b+160>>3]- +h[b+40>>3])/1.5+(+h[b+632>>3]*.5+ +h[b+640>>3]));i=i;return}function cw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2112>>3]=+h[b+976>>3]+ +h[b+960>>3];i=i;return}function dw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1088>>3];k=+h[g+2112>>3]- +h[g+1024>>3]*+h[g+464>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2064|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2064|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,25608,25888,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2064|0;p=o;h[p>>3]=m;i=d;return}



function Ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3336>>3]=+h[(c[a+416>>2]|0)+1080>>3]*+h[b+1984>>3];i=i;return}function Fj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3320>>3]=+h[b+1232>>3]*+h[b+1088>>3]+ +h[b+1240>>3]*+h[d+3336>>3];i=i;return}function Gj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3312>>3]=+h[(c[a+416>>2]|0)+1184>>3]*+h[b+3320>>3];i=i;return}function Hj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3304>>3]=+h[b+1192>>3]*+h[d+3312>>3]+(+h[b+1200>>3]*+h[b+1312>>3]+ +h[b+1208>>3]*+h[d+144>>3]);i=i;return}function Ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3272>>3]=+h[(c[a+416>>2]|0)+1216>>3]*+h[b+3304>>3];i=i;return}function Jj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=a+416|0;do{if((xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3272>>3],+h[(c[e>>2]|0)+1320>>3])|0)<<24>>24==0){if((vW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3272>>3],+h[(c[e>>2]|0)+1328>>3])|0)<<24>>24==0){f=(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3272|0;break}else{f=(c[e>>2]|0)+1328|0;break}}else{f=(c[e>>2]|0)+1320|0}}while(0);h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3328>>3]=+h[f>>3];i=b;return}function Kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[(c[a+416>>2]|0)+1072>>3]*+h[b+3328>>3];i=i;return}function Lj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+704>>3]=+h[b+928>>3]*+h[b+3136>>3];i=i;return}function Mj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1336>>3]*+h[j+584>>3]*+h[e+496>>3];l=+h[j+928>>3]+ +h[j+936>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+360|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+360|0;r=q;h[r>>3]=o;i=d;return}s=l/+XS(c[b+536>>2]|0,k,5040,5032,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+360|0;r=q;h[r>>3]=o;i=d;return}function Nj(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+360>>3],+h[f+816>>3],+h[f+760>>3],+h[(c[a+416>>2]|0)+512>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+656>>3]=+h[d>>3];i=b;return}function Oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+928>>3]- +h[b+936>>3];i=i;return}function Pj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3120>>3];k=+h[g+1016>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2296|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2296|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,5112,5104,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2296|0;p=o;h[p>>3]=m;i=d;return}function Qj(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+928>>3];if(!(d>=0.0)){e=+h[b+32>>3]}else{e=.01}h[b+904>>3]=d*e;i=i;return}function Rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[b+904>>3]- +h[b+912>>3];i=i;return}function Sj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1080>>3];k=+h[g+1e3>>3]- +h[g+32>>3]*+h[g+1016>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,2336,5136,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}function Tj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=-+h[b+200>>3];i=i;return}function Uj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+928>>3];if(!(d>=0.0)){e=b+1032|0}else{e=(c[a+416>>2]|0)+576|0}h[b+880>>3]=d*+h[e>>3];i=i;return}function Vj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+984>>3]=+h[b+880>>3]- +h[b+888>>3];i=i;return}function Wj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+984>>3]/.001519;i=i;return}function Xj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3256>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3256|0;h[c[g+928>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3256>>3]);h[c[(c[f>>2]|0)+932>>2]>>3]=k;SW(a,11)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3256>>3]=+h[c[(c[f>>2]|0)+924>>2]>>3];_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);i=b;return}function Yj(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;Jm(d,c[a+536>>2]|0,293.15);e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3600>>3]=+xd(+(+h[d>>3]),+(+h[e+3256>>3]*.999));i=b;return}function Zj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3600>>3];k=+yd(1.0e-13,+(+h[g+3256>>3]-j));if(k!=0.0){l=k;m=g;n=.99/l;o=j*n;p=o*.6219647130774989;q=+xd(+p,1.0);r=m;s=r+3616|0;t=s;h[t>>3]=q;i=d;return}u=+XS(c[b+536>>2]|0,k,5152,5144,+h[f>>3],(a[b+319|0]|0)!=0|0);l=u;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=.99/l;o=j*n;p=o*.6219647130774989;q=+xd(+p,1.0);r=m;s=r+3616|0;t=s;h[t>>3]=q;i=d;return}function _j(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3632>>3]=+yd(+(.01- +h[d+3616>>3]),0.0);i=b;return}function $j(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=.01- +h[b+3632>>3];i=i;return}function ak(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3632>>3];k=1.0-j;if(k!=0.0){l=k;m=j;n=g;o=f}else{j=+XS(c[b+536>>2]|0,k,5224,5216,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=j;m=+h[g+3632>>3];n=g;o=f}j=284.1807127034489/l;l=1.0-m;m=+h[n+3624>>3];if(l!=0.0){p=n;q=m/l;r=q*461.5233290850878;s=j+r;t=p;u=t+3648|0;v=u;h[v>>3]=s;i=d;return}if(m==0.0){p=n;q=m;r=q*461.5233290850878;s=j+r;t=p;u=t+3648|0;v=u;h[v>>3]=s;i=d;return}k=m/+XS(c[b+536>>2]|0,l,5224,5216,+h[o>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=k;r=q*461.5233290850878;s=j+r;t=p;u=t+3648|0;v=u;h[v>>3]=s;i=d;return}function bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3656>>3]=+h[b+3672>>3]+ +h[b+3648>>3]*-293.15;i=i;return}function ck(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3648>>3]*293.15;k=+h[g+3256>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3664|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3664|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,5264,5256,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3664|0;p=o;h[p>>3]=m;i=d;return}function dk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3600>>3];k=+yd(1.0e-13,+(+h[g+3256>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,5152,5296,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3608>>3]=m*.6219647130774989;i=d;return}function ek(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3600>>3];k=+h[g+3256>>3];do{if(j!=0.0){l=g;m=k/j}else{if(k==0.0){l=g;m=k;break}n=k/+XS(c[b+536>>2]|0,j,5312,5304,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3640>>3]=m*.01598094902253916;i=d;return}function fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=+h[b+3256>>3]*1.0e-5;i=i;return}function gk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+952>>3]=+h[b+360>>3]*+h[d+496>>3]*+h[d+1336>>3]*((+h[b+16>>3]- +h[b+3256>>3])/1.5+(+h[b+624>>3]+ +h[b+632>>3]*.5));i=i;return}function hk(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+928>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+784>>3]=+h[(a?e+816|0:e+808|0)>>3];i=b;return}function ik(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+928>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+728>>3]=+h[(a?e+760|0:e+752|0)>>3];i=b;return}function jk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+600>>3]=+h[b+1440>>3]*+h[b+512>>3]*+h[d+728>>3]*+h[b+1464>>3]*.7853981633974483;i=i;return}function kk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+928>>3];h[b+856>>3]=d*+h[(!(d>=0.0)?b+592|0:b+3672|0)>>3];i=i;return}function lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+856>>3]- +h[b+864>>3];i=i;return}function mk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2104>>3]=+h[b+968>>3]+ +h[b+952>>3];i=i;return}function nk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1080>>3];k=+h[g+2104>>3]- +h[g+1016>>3]*+h[g+576>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2040|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,2336,5344,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2040|0;p=o;h[p>>3]=m;i=d;return}function ok(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1004>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+208>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+208|0;h[c[g+1008>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+208>>3]);e=c[f>>2]|0;h[c[e+1012>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1004>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+192>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+192|0;h[(c[e+1008>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+192>>3]);h[(c[(c[f>>2]|0)+1012>>2]|0)+8>>3]=k;SW(a,12)|0;j=c[(c[f>>2]|0)+1004>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+208>>3]=+h[j>>3];h[f+192>>3]=+h[j+8>>3];gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);i=b;return}function pk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0;d=i;i=i+120|0;e=d;f=d+32|0;g=d+48|0;j=d+80|0;k=d+112|0;l=b+536|0;m=c[l>>2]|0;n=b+4|0;o=c[(c[c[n>>2]>>2]|0)+8>>2]|0;p=+h[o+3256>>3];q=+h[o+1152>>3];o=f;r=5360;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];im(j,m,p,q,f);f=g;m=j;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];m=c[l>>2]|0;f=e;j=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];c[f+28>>2]=c[j+28>>2];mm(k,m,e);e=c[b+416>>2]|0;q=+h[k>>3]*+h[e+1336>>3]*+h[e+496>>3];e=c[c[n>>2]>>2]|0;k=c[e+8>>2]|0;p=+h[k+928>>3];if(q!=0.0){s=k;t=p/q;u=s;v=u+848|0;w=v;h[w>>3]=t;i=d;return}if(p==0.0){s=k;t=p;u=s;v=u+848|0;w=v;h[w>>3]=t;i=d;return}x=p/+XS(c[l>>2]|0,q,5376,5352,+h[e>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[n>>2]>>2]|0)+8>>2]|0;t=x;u=s;v=u+848|0;w=v;h[w>>3]=t;i=d;return}function qk(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+848>>3],+h[f+808>>3],+h[f+752>>3],+h[(c[a+416>>2]|0)+512>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+648>>3]=+h[d>>3];i=b;return}function rk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3264>>3]=+h[b+1288>>3]*+h[d+3328>>3]+ +h[b+1296>>3]*+h[d+3272>>3];i=i;return}function sk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3280>>3]=+h[(c[a+416>>2]|0)+1304>>3]*+h[b+3264>>3];i=i;return}function tk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3288>>3]=+h[b+1264>>3]*+h[b+1088>>3]+(+h[b+1272>>3]*+h[d+3336>>3]+ +h[b+1280>>3]*+h[d+3280>>3]);i=i;return}function uk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[(c[a+416>>2]|0)+1248>>3]*+h[b+3288>>3];i=i;return}function vk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3296>>3]=+h[(c[a+416>>2]|0)+1088>>3]- +h[b+3336>>3];i=i;return}function wk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+944>>3];if(j>=0.0){k=g;l=j*+h[g+1040>>3];m=k;n=m+896|0;o=n;h[o>>3]=l;i=d;return}p=+yd(+-j,1.0e-15);q=p+1.0e-15;r=p*+h[g+1984>>3];do{if(q!=0.0){s=j;t=g;u=r/q}else{if(r==0.0){s=j;t=g;u=r;break}p=r/+XS(c[b+536>>2]|0,q,3784,5600,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;s=+h[v+944>>3];t=v;u=p}}while(0);k=t;l=u*s;m=k;n=m+896|0;o=n;h[o>>3]=l;i=d;return}function xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[b+888>>3]- +h[b+896>>3];i=i;return}function yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+992>>3]/.001519;i=i;return}function zk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+944>>3];k=+yd(+-j,1.0e-15);l=+yd(+j,1.0e-15);j=k+l;m=k*+h[g+1984>>3]+l*+h[g+1040>>3];if(j!=0.0){n=g;o=m/j;p=n;q=p+336|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+336|0;r=q;h[r>>3]=o;i=d;return}l=m/+XS(c[b+536>>2]|0,j,5616,5608,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+336|0;r=q;h[r>>3]=o;i=d;return}function Ak(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2744>>3]=-(+h[(a?e+1984|0:e+1792|0)>>3]*+h[e+1688>>3]);i=b;return}function Bk(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3344>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=+h[e+1984>>3]}else{f=100.0}h[e+2736>>3]=f*+h[e+3344>>3];i=b;return}function Ck(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(xW(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=j;l=+h[j+1984>>3]}else{m=+yd(+(+h[j+944>>3]),1.0e-15);n=m+1.0e-15;o=m*+h[j+1040>>3];if(n!=0.0){k=j;l=o/n;break}if(o==0.0){k=j;l=o;break}m=o/+XS(c[b+536>>2]|0,n,4200,5680,+h[g>>3],(a[b+319|0]|0)!=0|0);k=c[(c[c[e>>2]>>2]|0)+8>>2]|0;l=m}}while(0);h[k+2728>>3]=l*+h[k+944>>3];i=d;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+2728>>3]+(+h[b+2736>>3]+ +h[b+2744>>3]);i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+1952>>3]/.001519;i=i;return}function Fk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3576>>3];k=+h[g+1960>>3]- +h[g+136>>3]*+h[g+3568>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,5016,5688,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}function Gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=-+h[b+304>>3];i=i;return}function Hk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3576>>3];k=+h[g+3560>>3]- +h[g+3568>>3]*+h[g+3536>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,5016,5696,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}function Ik(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+160>>3];k=+h[g+136>>3];l=+h[g+3464>>3]*(k+ +h[g+1912>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3504|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3504|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,5712,5704,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3504|0;r=q;h[r>>3]=o;i=d;return}function Jk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3464>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,4864,5808,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3472>>3]=m*.6219647130774989;i=d;return}function Kk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+1084>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+320>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+320|0;h[c[g+1088>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+320>>3]);e=c[f>>2]|0;h[c[e+1092>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+1084>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+328>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+328|0;h[(c[e+1088>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+328>>3]);h[(c[(c[f>>2]|0)+1092>>2]|0)+8>>3]=k;SW(a,13)|0;j=c[(c[f>>2]|0)+1084>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+320>>3]=+h[j>>3];h[f+328>>3]=+h[j+8>>3];op(a);pp(a);qp(a);rp(a);sp(a);tp(a);i=b;return}function Lk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3904>>3],190.0)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3904>>3],647.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(5816,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3904>>3],0,1,6)|0)|0,5880)|0,5928)|0,5944)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function Mk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=yW(+h[c[f>>2]>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[c[f>>2]>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6032,AT(+h[c[f>>2]>>3],0,1,6)|0)|0,6056)|0,6072)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function Nk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2896>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2896>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6200,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+2896>>3],0,1,6)|0)|0,6056)|0,6224)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function Ok(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3912>>3],0.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(6232,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3912>>3],0,1,6)|0)|0,6248)|0,5928)|0,6272)|0;j=CT(CT(g,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3904>>3],0,1,6)|0)|0,6304)|0;f=c[a+536>>2]|0;a=c[41338]|0;g=d;k=7288;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&63](f,d,j,e);i=b;return}function Pk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+16|0;c[g>>2]=6224;BU(h,2,6072,g);g=c[a+416>>2]|0;c[f>>2]=2;QT(j,g,1,f);f=c[a+536>>2]|0;a=e;g=h;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];g=d;a=j;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Rm(f,5928,e,0,1,d,6312);i=b;return}function Qk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3256>>3],0.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(6232,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+3256>>3],0,1,6)|0)|0,6248)|0,5928)|0,6272)|0;f=CT(CT(g,AT(293.15,0,1,6)|0)|0,6304)|0;g=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](g,d,f,e);i=b;return}function Rk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+16|0;c[g>>2]=6224;BU(j,2,6072,g);g=f;h[k>>3]=.99;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];YT(l,2,.01,f);f=c[a+536>>2]|0;a=e;g=j;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];g=d;a=l;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Rm(f,5928,e,0,1,d,6328);i=b;return}function Sk(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+U(+-+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+928>>3]);if(!((wW(+U(+(f- +yd(-0.0,+f))),1.0e-60)|0)<<24>>24==0)){i=b;return}g=c[a+536>>2]|0;a=c[41338]|0;j=d;k=6424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](g,d,6448,e);i=b;return}function Tk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],190.0)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],647.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(5816,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],0,1,6)|0)|0,5880)|0,5928)|0,5944)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function Uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+136>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+136>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6032,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+136>>3],0,1,6)|0)|0,6056)|0,6072)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function Vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1912>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1912>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6200,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1912>>3],0,1,6)|0)|0,6056)|0,6224)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function Wk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(6232,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],0,1,6)|0)|0,6248)|0,5928)|0,6272)|0;j=CT(CT(g,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+152>>3],0,1,6)|0)|0,6304)|0;f=c[a+536>>2]|0;a=c[41338]|0;g=d;k=7288;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&63](f,d,j,e);i=b;return}function Xk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((wW(0.0,+h[(c[a+416>>2]|0)+744>>3])|0)<<24>>24==0)){i=b;return}f=CT(CT(6504,AT(0.0,0,1,6)|0)|0,6560)|0;g=c[a+536>>2]|0;a=c[41338]|0;j=d;k=6640;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](g,d,f,e);i=b;return}function Yk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((xW(0.0,+h[(c[a+416>>2]|0)+744>>3]*-1.0e-6)|0)<<24>>24==0)){i=b;return}f=CT(CT(6664,AT(0.0,0,1,6)|0)|0,6680)|0;g=c[a+536>>2]|0;a=c[41338]|0;j=d;k=6736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](g,d,f,e);i=b;return}function Zk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],190.0)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],647.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(5816,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0,1,6)|0)|0,5880)|0,5928)|0,5944)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function _k(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6032,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+96>>3],0,1,6)|0)|0,6056)|0,6072)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function $k(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1880>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1880>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6200,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1880>>3],0,1,6)|0)|0,6056)|0,6224)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function al(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(6232,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+104>>3],0,1,6)|0)|0,6248)|0,5928)|0,6272)|0;j=CT(CT(g,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+88>>3],0,1,6)|0)|0,6304)|0;f=c[a+536>>2]|0;a=c[41338]|0;g=d;k=7288;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&63](f,d,j,e);i=b;return}function bl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+64>>3],190.0)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+64>>3],647.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(5816,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+64>>3],0,1,6)|0)|0,5880)|0,5928)|0,5944)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function cl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6032,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72>>3],0,1,6)|0)|0,6056)|0,6072)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function dl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1872>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1872>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6200,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1872>>3],0,1,6)|0)|0,6056)|0,6224)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],0.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(6232,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+80>>3],0,1,6)|0)|0,6248)|0,5928)|0,6272)|0;j=CT(CT(g,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+64>>3],0,1,6)|0)|0,6304)|0;f=c[a+536>>2]|0;a=c[41338]|0;g=d;k=7288;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&63](f,d,j,e);i=b;return}function fl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((yW(+h[f+800>>3],+h[f+824>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41338]|0;g=d;j=7312;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Oe[a&63](f,d,6832,e);i=b;return}function gl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(6232,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+160>>3],0,1,6)|0)|0,6248)|0,5928)|0,6272)|0;f=CT(CT(g,AT(293.15,0,1,6)|0)|0,6304)|0;g=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](g,d,f,e);i=b;return}function hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+16|0;c[g>>2]=6224;BU(j,2,6072,g);g=f;h[k>>3]=.99;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];YT(l,2,.01,f);f=c[a+536>>2]|0;a=e;g=j;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];g=d;a=l;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];Rm(f,5928,e,0,1,d,6328);i=b;return}function il(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=c[f>>2]|0;if(!((yW(+h[g+1320>>3],+h[g+1328>>3])|0)<<24>>24==0)){i=b;return}g=CT(CT(6888,AT(+h[(c[f>>2]|0)+1320>>3],0,1,6)|0)|0,6944)|0;j=CT(CT(g,AT(+h[(c[f>>2]|0)+1328>>3],0,1,6)|0)|0,6560)|0;f=c[a+536>>2]|0;a=c[41338]|0;g=d;k=7040;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&63](f,d,j,e);i=b;return}function jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+416|0;g=c[f>>2]|0;if(!((yW(+h[g+1120>>3],+h[g+1224>>3])|0)<<24>>24==0)){i=b;return}g=CT(CT(7064,AT(+h[(c[f>>2]|0)+1120>>3],0,1,6)|0)|0,7120)|0;j=CT(CT(g,AT(+h[(c[f>>2]|0)+1224>>3],0,1,6)|0)|0,6560)|0;f=c[a+536>>2]|0;a=c[41338]|0;g=d;k=7216;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&63](f,d,j,e);i=b;return}function kl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],190.0)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],647.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(5816,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,5880)|0,5928)|0,5944)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function ll(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6032,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+32>>3],0,1,6)|0)|0,6056)|0,6072)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function ml(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1144>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1144>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6200,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1144>>3],0,1,6)|0)|0,6056)|0,6224)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function nl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(6232,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+40>>3],0,1,6)|0)|0,6248)|0,5928)|0,6272)|0;j=CT(CT(g,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+24>>3],0,1,6)|0)|0,6304)|0;f=c[a+536>>2]|0;a=c[41338]|0;g=d;k=7288;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&63](f,d,j,e);i=b;return}function ol(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],190.0)|0;if(!(g<<24>>24==0|(wW(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],647.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(5816,AT(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],0,1,6)|0)|0,5880)|0,5928)|0,5944)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function pl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6032,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+8>>3],0,1,6)|0)|0,6056)|0,6072)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function ql(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;g=yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1136>>3],-1.0e-5)|0;if(!(g<<24>>24==0|(wW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1136>>3],1.00001)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(CT(CT(6200,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+1136>>3],0,1,6)|0)|0,6056)|0,6224)|0,6080)|0,5928)|0,6096)|0;f=c[a+536>>2]|0;a=c[41338]|0;j=d;k=7264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Oe[a&63](f,d,g,e);i=b;return}function rl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0;b=i;i=i+32|0;d=b;e=b+24|0;f=a+4|0;if(!((yW(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=b;return}g=CT(CT(CT(CT(6232,AT(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+16>>3],0,1,6)|0)|0,6248)|0,5928)|0,6272)|0;j=CT(CT(g,AT(+h[c[(c[c[f>>2]>>2]|0)+8>>2]>>3],0,1,6)|0)|0,6304)|0;f=c[a+536>>2]|0;a=c[41338]|0;g=d;k=7288;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[g+12>>2]=c[k+12>>2];c[g+16>>2]=c[k+16>>2];c[g+20>>2]=c[k+20>>2];Oe[a&63](f,d,j,e);i=b;return}function sl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((yW(+h[f+1344>>3],+h[f+1368>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[41338]|0;g=d;j=7312;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Oe[a&63](f,d,6832,e);i=b;return}function tl(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);i=c;return 0}function ul(b){b=b|0;var c=0;c=i;a[b+314|0]=0;vl(b);i=c;return 0}function vl(a){a=a|0;var b=0;b=i;jf(a);xf(a);Af(a);Bf(a);Cf(a);Lf(a);Pf(a);Qf(a);Rf(a);Uf(a);Vf(a);Wf(a);Xf(a);_f(a);$f(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);kg(a);ng(a);og(a);rg(a);sg(a);tg(a);ug(a);vg(a);zg(a);Ag(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Mg(a);Ng(a);Qg(a);Rg(a);Ug(a);Vg(a);Wg(a);Xg(a);Yg(a);ah(a);bh(a);fh(a);gh(a);hh(a);ih(a);jh(a);kh(a);lh(a);mh(a);ph(a);qh(a);th(a);vh(a);yh(a);zh(a);Ah(a);Bh(a);Ch(a);Gh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Qh(a);Rh(a);Sh(a);Th(a);Vh(a);Wh(a);Xh(a);Yh(a);Zh(a);_h(a);$h(a);ai(a);di(a);ei(a);fi(a);gi(a);ji(a);ki(a);mi(a);ni(a);ti(a);vi(a);wi(a);xi(a);yi(a);zi(a);Ai(a);Ci(a);Di(a);Ei(a);Fi(a);Gi(a);Hi(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Qi(a);Si(a);Ti(a);Ui(a);Vi(a);Wi(a);Xi(a);Yi(a);Zi(a);_i(a);$i(a);aj(a);ej(a);fj(a);gj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);qj(a);rj(a);sj(a);tj(a);uj(a);vj(a);wj(a);xj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Jj(a);Kj(a);Mj(a);Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Xj(a);gk(a);kk(a);lk(a);mk(a);nk(a);ok(a);rk(a);sk(a);tk(a);uk(a);wk(a);xk(a);yk(a);Ak(a);Bk(a);Ck(a);Dk(a);Ek(a);Fk(a);Gk(a);Hk(a);Kk(a);i=b;return}function wl(a,b){a=a|0;b=+b;i=i;return 0}function xl(a){a=a|0;var b=0;b=i;i=i+8|0;US(c[a+536>>2]|0,(a|0)!=0|0,7544,b);c[a+540>>2]=7352;c[a+84>>2]=7576;c[a+88>>2]=7576;c[a+92>>2]=7640;c[a+96>>2]=7712;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=21;c[a+116>>2]=505;c[a+120>>2]=1;c[a+124>>2]=3;c[a+128>>2]=9;c[a+132>>2]=0;c[a+136>>2]=195;c[a+140>>2]=59;c[a+144>>2]=82;c[a+148>>2]=5;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=5;c[a+216>>2]=391;c[a+220>>2]=0;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=1;c[a+104>>2]=0;c[a+164>>2]=1;c[a+168>>2]=0;c[a+176>>2]=25;c[a+180>>2]=6;c[a+184>>2]=31;c[a+188>>2]=1;c[a+56>>2]=7752;c[a+64>>2]=116;c[a+72>>2]=0;c[a+68>>2]=1602;c[a+192>>2]=0;c[a+196>>2]=0;c[a+200>>2]=14;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function yl(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=Cma(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=k}else if((l|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=k;D=7}else{E=117056;F=117080;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[29264]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=Cma(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==1){m=0;n=0;o=0;p=0;q=0;s=0;t=F;break}else if((G|0)==2){w=0;x=0;y=0;z=0;A=0;B=0;C=F;D=7;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[28452]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=Cma(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((I|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}u=0;Ha(47,c[28452]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=Cma(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==1){m=0;n=0;o=0;p=0;q=E;s=F;t=H;break}else if((K|0)==2){w=0;x=0;y=0;z=0;A=E;B=F;C=H;D=7;break}H=h;c[g>>2]=h;oma(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Cma(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==1){m=0;n=0;o=0;p=H;q=E;s=F;t=L;break}else if((M|0)==2){w=0;x=0;y=0;z=H;A=E;B=F;C=L;D=7;break}w=0;x=0;y=0;z=H;A=E;B=F;C=0;D=7}}while(0);while(1){if((D|0)==7){D=0;if((C|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;oma(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=Cma(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==1){m=K;n=h;o=M;p=z;q=A;s=B;t=I;continue}else if((N|0)==2){O=B;P=A;Q=z;w=K;x=h;y=M;C=I;B=O;A=P;z=Q;D=7;continue}m=K;n=h;o=M;p=z;q=A;s=B;t=0;continue}else{u=0;Ha(47,c[28452]|0,A|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=Cma(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((R|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Cma(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==1){m=w;n=x;o=y;p=z;q=A;s=B;t=M;continue}else if((V|0)==2){O=B;P=A;Q=z;S=y;T=x;U=w;C=M;B=O;A=P;z=Q;y=S;x=T;w=U;D=7;continue}else{D=18;break}}}if((t|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=Cma(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((W|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}M=c[r>>2]|0;u=0;Ra(34,7824,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=Cma(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ba|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=Cma(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ca|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=Cma(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((da|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}else{D=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=Cma(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ea|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=Cma(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((fa|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}c[n>>2]=m;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=Cma(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ga|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;Ha(47,c[28452]|0,q|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=Cma(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ha|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=Cma(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ia|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=Cma(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=h;s=X;q=Y;p=Z;o=_;n=$;m=aa;continue}else if((ja|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=h;D=7;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=Cma(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==1){X=s;Y=q;Z=p;_=o;$=n;aa=m;t=M;s=X;q=Y;p=Z;o=_;n=$;m=aa}else if((ka|0)==2){w=m;x=n;y=o;z=p;A=q;B=s;C=M;D=7}else{D=26;break}}if((D|0)==15){la=p;ma=s;i=d;return 1}else if((D|0)==18){la=z;ma=B;i=d;return 1}return 0}function zl(){var a=0;a=i;zd(0)|0;xc(7984,18,1,c[r>>2]|0)|0;zd(0)|0;i=a;return}function Al(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function Bl(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0;b=i;l=Cl(c[f+8>>2]|0)|0;m=Dl(f,1)|0;n=Dl(f,2)|0;f=El(c[h+8>>2]|0)|0;c[a>>2]=qL(d,e,l,m,n,g,f,Fl(h)|0,j,k)|0;i=b;return}function Cl(a){a=a|0;i=i;return a|0}function Dl(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=HS(a,b)|0;i=c;return d|0}function El(a){a=a|0;i=i;return a|0}function Fl(a){a=a|0;var b=0,c=0;b=i;c=HS(a,1)|0;i=b;return c|0}function Gl(a,b,c,d,e,f,g,j){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=+f;g=+g;j=+j;b=i;h[a>>3]=+xL(c,d,e,f,g);i=b;return}function Hl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;b=i;h[a>>3]=+CL(c);i=b;return}function Il(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=+e;b=i;h[a>>3]=+DL(c,d);i=b;return}function Jl(a,b,c,d){a=a|0;b=b|0;c=c|0;d=+d;b=i;h[a>>3]=+BL(c);i=b;return}function Kl(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;h[a>>3]=+EL(c,d<<24>>24,e<<24>>24);i=b;return}function Ll(a,b){a=a|0;b=b|0;a=i;vL(b);i=a;return}function Ml(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function Nl(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;h[a>>3]=+U(+c)*f/e*d;i=i;return}function Ol(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function Pl(a,b,d,e,f,g,j){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0;l=i;i=i+224|0;m=l;n=l+24|0;o=l+48|0;p=l+72|0;q=l+96|0;r=l+120|0;s=l+144|0;t=l+168|0;u=l+192|0;v=l+216|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=e*64.0;if(!(F>0.0)){G=c[41338]|0;H=D;h[k>>3]=F;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=G;G=u;I=10776;c[G+0>>2]=c[I+0>>2];c[G+4>>2]=c[I+4>>2];c[G+8>>2]=c[I+8>>2];c[G+12>>2]=c[I+12>>2];c[G+16>>2]=c[I+16>>2];c[G+20>>2]=c[I+20>>2];Oe[H&63](b,u,8232,D);}J=+_a(+F);if(!(e>0.0)){D=c[41338]|0;u=C;h[k>>3]=e;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];u=D;D=t;H=10776;c[D+0>>2]=c[H+0>>2];c[D+4>>2]=c[H+4>>2];c[D+8>>2]=c[H+8>>2];c[D+12>>2]=c[H+12>>2];c[D+16>>2]=c[H+16>>2];c[D+20>>2]=c[H+20>>2];Oe[u&63](b,t,8296,C);}F=+_a(+e);e=g/3.7+5.74/+W(+f,.9);if(!(e>0.0)){C=c[41338]|0;t=B;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;u=10776;c[C+0>>2]=c[u+0>>2];c[C+4>>2]=c[u+4>>2];c[C+8>>2]=c[u+8>>2];c[C+12>>2]=c[u+12>>2];c[C+16>>2]=c[u+16>>2];c[C+20>>2]=c[u+20>>2];Oe[t&63](b,s,8360,B);}K=f/+_a(+e);e=K*K*.25;B=e>=0.0;if(!B){s=c[41338]|0;t=A;h[k>>3]=e;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=s;s=r;u=10776;c[s+0>>2]=c[u+0>>2];c[s+4>>2]=c[u+4>>2];c[s+8>>2]=c[u+8>>2];c[s+12>>2]=c[u+12>>2];c[s+16>>2]=c[u+16>>2];c[s+20>>2]=c[u+20>>2];Oe[t&63](b,r,8424,A);}K=+V(+e);f=g*.27+2.51/K;if(!B){B=c[41338]|0;A=z;h[k>>3]=e;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=B;B=q;r=10776;c[B+0>>2]=c[r+0>>2];c[B+4>>2]=c[r+4>>2];c[B+8>>2]=c[r+8>>2];c[B+12>>2]=c[r+12>>2];c[B+16>>2]=c[r+16>>2];c[B+20>>2]=c[r+20>>2];Oe[A&63](b,q,8424,z);}if(!(f>0.0)){z=c[41338]|0;q=y;h[k>>3]=f;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=z;z=p;A=10776;c[z+0>>2]=c[A+0>>2];c[z+4>>2]=c[A+4>>2];c[z+8>>2]=c[A+8>>2];c[z+12>>2]=c[A+12>>2];c[z+16>>2]=c[A+16>>2];c[z+20>>2]=c[A+20>>2];Oe[q&63](b,p,8480,y);}g=K*+_a(+f)*-2.0;if(!(e>0.0)){y=c[41338]|0;p=x;h[k>>3]=e;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;q=10776;c[y+0>>2]=c[q+0>>2];c[y+4>>2]=c[q+4>>2];c[y+8>>2]=c[q+8>>2];c[y+12>>2]=c[q+12>>2];c[y+16>>2]=c[q+16>>2];c[y+20>>2]=c[q+20>>2];Oe[p&63](b,o,8544,x);}K=+_a(+e);if(!(g>0.0)){x=c[41338]|0;o=w;h[k>>3]=g;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=10776;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Oe[o&63](b,n,8600,w);}e=+_a(+g);L=1.090079149577162/(f*g)+.5;if(d>0.0){M=+_a(+d);Ql(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}w=c[41338]|0;n=v;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=10776;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Oe[n&63](b,m,8664,v);M=+_a(+d);Ql(E,0,M,J,K,F,e,1.0,L);N=E;O=N;P=+h[O>>3];Q=E;R=Q+8|0;S=R;T=+h[S>>3];X=+W(10.0,+P);Y=+U(+j);Z=T/Y;_=X*Z;$=a;aa=$;h[aa>>3]=X;ba=a;ca=ba+8|0;da=ca;h[da>>3]=_;i=l;return}function Ql(a,b,c,d,e,f,g,j,k){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;var l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;l=e-d;do{if(l!=l|0.0!=0.0|l==0.0){e=(f+g)*.5;m=g-f;if(m>0.0){n=1.0e+60;o=e;break}n=+(m<0.0|0)*1.0e+60;o=e}else{e=(c-d)/l;m=e*e;p=e*m;q=m*3.0;n=(m-e)*6.0/l*f+((e*-4.0+q+1.0)*j+((e-m)*6.0/l*g+(e*-2.0+q)*k));o=(m*-3.0+p*2.0+1.0)*f+(l*(p+(e+m*-2.0))*j+((q+p*-2.0)*g+l*(p-m)*k))}}while(0);h[a>>3]=o;h[a+8>>3]=n;i=b;return}function Rl(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function Sl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0.0;e=i;i=i+48|0;f=e;g=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;Tl(g,0,123.15);m=+h[g>>3];Tl(j,0,1273.15);n=+h[j>>3];Tl(k,0,+h[d+8>>3]);o=+h[k>>3];k=f;d=8728;c[k+0>>2]=c[d+0>>2];c[k+4>>2]=c[d+4>>2];c[k+8>>2]=c[d+8>>2];Ul(l,b,f,m,n,o);h[a>>3]=+h[l>>3]*1.0e-6;i=e;return}function Tl(a,b,c){a=a|0;b=b|0;c=+c;h[a>>3]=c+-273.15;i=i;return}function Ul(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=+e;f=+f;g=+g;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0;b=i;i=i+120|0;j=b;k=b+16|0;l=b+32|0;m=b+48|0;n=b+64|0;o=b+80|0;p=b+88|0;q=b+96|0;r=b+104|0;s=b+112|0;if(g<e){t=n;u=d;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];nn(o,0,n,e);v=+h[o>>3];w=e-g;o=m;n=d;c[o+0>>2]=c[n+0>>2];c[o+4>>2]=c[n+4>>2];c[o+8>>2]=c[n+8>>2];on(p,0,m,e,w);x=v- +h[p>>3];y=a;z=y;h[z>>3]=x;i=b;return}if(g>f){p=l;m=d;c[p+0>>2]=c[m+0>>2];c[p+4>>2]=c[m+4>>2];c[p+8>>2]=c[m+8>>2];nn(q,0,l,f);v=+h[q>>3];w=g-f;q=k;l=d;c[q+0>>2]=c[l+0>>2];c[q+4>>2]=c[l+4>>2];c[q+8>>2]=c[l+8>>2];on(r,0,k,f,w);x=v+ +h[r>>3];y=a;z=y;h[z>>3]=x;i=b;return}else{r=j;k=d;c[r+0>>2]=c[k+0>>2];c[r+4>>2]=c[k+4>>2];c[r+8>>2]=c[k+8>>2];nn(s,0,j,g);x=+h[s>>3];y=a;z=y;h[z>>3]=x;i=b;return}}function Vl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;b=i;i=i+40|0;e=b;f=b+32|0;g=e;j=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];Wl(f,0,e);h[a>>3]=+h[d>>3]/(+h[f>>3]*+h[d+8>>3]);i=b;return}function Wl(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=d+16|0;c[f>>2]=1;j=(1.0- +h[(ZT(g,1,f)|0)>>3])*287.0512249529787;c[e>>2]=1;h[a>>3]=j+ +h[(ZT(g,1,e)|0)>>3]*461.5233290850878;i=b;return}function Xl(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,W=0,X=0,Y=0,Z=0,_=0;q=i;i=i+128|0;r=q;s=q+24|0;t=q+48|0;u=q+72|0;v=q+96|0;w=q+120|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+16|0;C=d>=0.0;D=C?g:j;j=+U(+d);g=m*m*m*((C?e:f)/(D*D*l));l=j*g*2.0;f=g*2.0;g=l*.015625;e=f*.015625;do{if(g>n){if(!(l>=0.0)){E=c[41338]|0;F=A;h[k>>3]=l;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=v;G=10776;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Oe[F&63](b,v,8744,A);F=c[41338]|0;G=z;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=u;E=10776;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Oe[G&63](b,u,8744,z);}H=+V(+l);I=p*.27;J=I+2.51/H;if(!(J>0.0)){G=c[41338]|0;E=y;h[k>>3]=J;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=G;G=t;F=10776;c[G+0>>2]=c[F+0>>2];c[G+4>>2]=c[F+4>>2];c[G+8>>2]=c[F+8>>2];c[G+12>>2]=c[F+12>>2];c[G+16>>2]=c[F+16>>2];c[G+20>>2]=c[F+20>>2];Oe[E&63](b,t,8808,y);}K=H*+_a(+J)*-2.0;J=j*f;if(!(J>=0.0)){E=c[41338]|0;F=x;h[k>>3]=J;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E;E=s;G=10776;c[E+0>>2]=c[G+0>>2];c[E+4>>2]=c[G+4>>2];c[E+8>>2]=c[G+8>>2];c[E+12>>2]=c[G+12>>2];c[E+16>>2]=c[G+16>>2];c[E+20>>2]=c[G+20>>2];Oe[F&63](b,s,8904,x);}H=+V(+J);J=I+2.51/H;if(!(J>0.0)){F=c[41338]|0;G=w;h[k>>3]=J;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=F;F=r;E=10776;c[F+0>>2]=c[E+0>>2];c[F+4>>2]=c[E+4>>2];c[F+8>>2]=c[E+8>>2];c[F+12>>2]=c[E+12>>2];c[F+16>>2]=c[E+16>>2];c[F+20>>2]=c[E+20>>2];Oe[G&63](b,r,8984,w);}I=(5.02/(j*J*2.0)- +da(+J)*(f/H))*.4342944819032518;if(!(K<o)){L=K;M=I;break}Pl(B,b,l,n,o,p,d);L=+h[B>>3];M=+h[B+8>>3]}else{L=g;M=e}}while(0);if(C){N=L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}N=-L;O=D*N;P=O*m;Q=P*.7853981633974483;R=D*M;S=R*m;T=S*.7853981633974483;W=a;X=W;h[X>>3]=Q;Y=a;Z=Y+8|0;_=Z;h[_>>3]=T;i=q;return}function Yl(a,b,d,e,f,g,j,l,m,n,o,p){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;l=+l;m=+m;n=+n;o=+o;p=+p;var q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0,H=0;q=i;i=i+32|0;r=q;s=q+24|0;t=i;i=i+8|0;o=n/m;if(!(o<=.0065)){u=.0065/o}else{u=1.0}n=+xd(+(+ca(+u)*745.0),+p);v=d>=0.0;u=v?e:f;f=v?g:j;j=+U(+d)/(f*m)*1.273239544735163;do{if(!(j<=n)){if(!(j>=p)){Zl(t,b,j,n,p,o);w=+h[t>>3];break}d=o/3.7+5.74/+W(+j,.9);if(!(d>0.0)){x=c[41338]|0;y=s;h[k>>3]=d;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];y=x;x=r;z=10776;c[x+0>>2]=c[z+0>>2];c[x+4>>2]=c[z+4>>2];c[x+8>>2]=c[z+8>>2];c[x+12>>2]=c[z+12>>2];c[x+16>>2]=c[z+16>>2];c[x+20>>2]=c[z+20>>2];Oe[y&63](b,r,9064,s);}g=j/+_a(+d);w=g*g*.25}else{w=j*64.0}}while(0);j=f*f;f=+DU(m,-3);if(v){A=w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}A=-w;B=A/u;C=f*B;D=j*C;E=D*l;F=E*.5;G=a;H=G;h[H>>3]=F;i=q;return}function Zl(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,X=0,Y=0;j=i;i=i+224|0;l=j;m=j+24|0;n=j+48|0;o=j+72|0;p=j+96|0;q=j+120|0;r=j+144|0;s=j+168|0;t=j+192|0;u=j+216|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;if(!(e>0.0)){D=c[41338]|0;E=C;h[k>>3]=e;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D;D=t;F=10776;c[D+0>>2]=c[F+0>>2];c[D+4>>2]=c[F+4>>2];c[D+8>>2]=c[F+8>>2];c[D+12>>2]=c[F+12>>2];c[D+16>>2]=c[F+16>>2];c[D+20>>2]=c[F+20>>2];Oe[E&63](b,t,8296,C);}G=+_a(+e);H=e*64.0;if(!(H>0.0)){C=c[41338]|0;t=B;h[k>>3]=H;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];t=C;C=s;E=10776;c[C+0>>2]=c[E+0>>2];c[C+4>>2]=c[E+4>>2];c[C+8>>2]=c[E+8>>2];c[C+12>>2]=c[E+12>>2];c[C+16>>2]=c[E+16>>2];c[C+20>>2]=c[E+20>>2];Oe[t&63](b,s,8232,B);}I=+_a(+H);H=+W(+f,.9);J=g/3.7+5.74/H;if(!(J>0.0)){B=c[41338]|0;s=A;h[k>>3]=J;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=B;B=r;t=10776;c[B+0>>2]=c[t+0>>2];c[B+4>>2]=c[t+4>>2];c[B+8>>2]=c[t+8>>2];c[B+12>>2]=c[t+12>>2];c[B+16>>2]=c[t+16>>2];c[B+20>>2]=c[t+20>>2];Oe[s&63](b,r,8360,A);}K=+_a(+J);L=f/K;M=L*L*.25;A=M>=0.0;if(!A){r=c[41338]|0;s=z;h[k>>3]=M;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=r;r=q;t=10776;c[r+0>>2]=c[t+0>>2];c[r+4>>2]=c[t+4>>2];c[r+8>>2]=c[t+8>>2];c[r+12>>2]=c[t+12>>2];c[r+16>>2]=c[t+16>>2];c[r+20>>2]=c[t+20>>2];Oe[s&63](b,q,8424,z);}L=g*.27+2.51/+V(+M);if(!A){A=c[41338]|0;z=y;h[k>>3]=M;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=A;A=p;q=10776;c[A+0>>2]=c[q+0>>2];c[A+4>>2]=c[q+4>>2];c[A+8>>2]=c[q+8>>2];c[A+12>>2]=c[q+12>>2];c[A+16>>2]=c[q+16>>2];c[A+20>>2]=c[q+20>>2];Oe[z&63](b,p,8424,y);}if(!(L>0.0)){y=c[41338]|0;p=x;h[k>>3]=L;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=y;y=o;z=10776;c[y+0>>2]=c[z+0>>2];c[y+4>>2]=c[z+4>>2];c[y+8>>2]=c[z+8>>2];c[y+12>>2]=c[z+12>>2];c[y+16>>2]=c[z+16>>2];c[y+20>>2]=c[z+20>>2];Oe[p&63](b,o,8480,x);}+_a(+L);if(!(f>0.0)){x=c[41338]|0;o=w;h[k>>3]=f;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=x;x=n;p=10776;c[x+0>>2]=c[p+0>>2];c[x+4>>2]=c[p+4>>2];c[x+8>>2]=c[p+8>>2];c[x+12>>2]=c[p+12>>2];c[x+16>>2]=c[p+16>>2];c[x+20>>2]=c[p+20>>2];Oe[o&63](b,n,9152,w);}L=+_a(+f);if(!(M>0.0)){w=c[41338]|0;n=v;h[k>>3]=M;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=w;w=m;o=10776;c[w+0>>2]=c[o+0>>2];c[w+4>>2]=c[o+4>>2];c[w+8>>2]=c[o+8>>2];c[w+12>>2]=c[o+12>>2];c[w+16>>2]=c[o+16>>2];c[w+20>>2]=c[o+20>>2];Oe[n&63](b,m,8544,v);}f=1.121782646756099/(H*J*K)*4.0+2.0;K=L-G;G=(+_a(+M)-I)/K;I=(G*3.0+(-2.0-f))/K;M=(f+G*-2.0+1.0)/(K*K);K=d/e;if(K>0.0){N=+_a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}v=c[41338]|0;m=u;h[k>>3]=K;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=v;v=l;n=10776;c[v+0>>2]=c[n+0>>2];c[v+4>>2]=c[n+4>>2];c[v+8>>2]=c[n+8>>2];c[v+12>>2]=c[n+12>>2];c[v+16>>2]=c[n+16>>2];c[v+20>>2]=c[n+20>>2];Oe[m&63](b,l,9216,u);N=+_a(+K);O=M*N;P=I+O;Q=N*P;R=Q+1.0;S=+W(+K,+R);T=S*e;U=T*64.0;X=a;Y=X;h[Y>>3]=U;i=j;return}function _l(a,b,c,d,e,f,g,j,k,l,m,n,o){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;m=+m;n=+n;o=+o;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0;p=i;i=i+112|0;q=p;r=p+16|0;s=p+32|0;t=p+48|0;u=p+64|0;v=p+80|0;w=p+96|0;x=m/k;if(!(x<=.0065)){y=.0065/x}else{y=1.0}m=+xd(+(+W(+(+ca(+y)*745.0),.97)),+o);y=d*l;z=e*l;l=(y+z)*.5;A=+yd(+y,+z)+n;B=+xd(+y,+z)-n;if(A<=c){Xl(q,b,c-y,d,e,f,g,j,k,m,o,x);C=+h[q>>3];D=a;E=D;h[E>>3]=C;i=p;return}if(B>=c){Xl(r,b,c-z,d,e,f,g,j,k,m,o,x);C=+h[r>>3];D=a;E=D;h[E>>3]=C;i=p;return}Xl(s,b,A-y,d,e,f,g,j,k,m,o,x);y=+h[s>>3];n=+h[s+8>>3];Xl(t,b,B-z,d,e,f,g,j,k,m,o,x);x=+h[t>>3];o=+h[t+8>>3];$l(u,b,l,B,A,x,y,o,n);m=+h[u+8>>3];if(l<c){$l(v,b,c,l,A,0.0,y,m,n);C=+h[v>>3];D=a;E=D;h[E>>3]=C;i=p;return}else{$l(w,b,c,B,l,x,0.0,o,m);C=+h[w>>3];D=a;E=D;h[E>>3]=C;i=p;return}}function $l(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0,V=0.0,W=0.0,X=0.0,Y=0.0;m=i;i=i+56|0;n=m;o=m+24|0;p=m+48|0;q=i;i=i+8|0;if(!(e<f)){r=CT(CT(9784,AT(e,0,1,6)|0)|0,9840)|0;s=CT(CT(r,AT(f,0,1,6)|0)|0,9856)|0;r=c[41338]|0;t=o;u=9960;c[t+0>>2]=c[u+0>>2];c[t+4>>2]=c[u+4>>2];c[t+8>>2]=c[u+8>>2];c[t+12>>2]=c[u+12>>2];c[t+16>>2]=c[u+16>>2];c[t+20>>2]=c[u+20>>2];Oe[r&63](b,o,s,q);}do{if(!(k*l>=0.0)){if(+U(+k)<1.0e-15){break}if(+U(+l)<1.0e-15){break}q=CT(CT(9984,AT(k,0,1,6)|0)|0,10160)|0;s=CT(CT(q,AT(l,0,1,6)|0)|0,10176)|0;q=c[41338]|0;o=n;r=10208;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];c[o+12>>2]=c[r+12>>2];c[o+16>>2]=c[r+16>>2];c[o+20>>2]=c[r+20>>2];Oe[q&63](b,n,s,p);}}while(0);v=f-e;w=(j-g)/v;x=+U(+w);if(w==0.0){y=0.0;z=(d-e)*w+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}F=w*-2.0;G=F+k+l;if(+U(+G)<1.0e-13){H=d-e;I=k*-2.0;J=w*3.0;K=F+l+k;L=((e+f)*.5-e)/v;y=K*L*L*3.0+((I+(J-l))*L*2.0+k);z=H*(H*((I+(J+(H*(K/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}K=v*k;H=-l;J=((k+l)*e*-3.0+(w*e*6.0+(K*-2.0+(v*w*3.0-v*l))))/(H-k+w*2.0)*.3333333333333333;I=J-e;L=f-J;J=I/v;M=F+l+k;F=k*-2.0;N=w*3.0;O=F+(N-l);P=M*J*J*3.0+(O*J*2.0+k);if(w>0.0){Q=1.0}else{Q=+(w<0.0|0)}J=Q*+xd(+(+U(+P)),+x)*.25;do{if(!(+U(+(k-l))<=1.0e-13)){R=(k*H+(-(l*l)-k*k)+w*(w*-1.5+k+l)*6.0)/(G*3.0);S=0}else{if(!(K+g<j)){R=k;S=0;break}R=k;S=1}}while(0);if(I>0.0&L<v){if(!(w*P<=0.0)){T=19}else{T=22}}else{T=19}do{if((T|0)==19){P=+U(+J);K=+U(+R);if(P<K){if(w*R>=0.0){T=22;break}}if(P<+U(+(w*.1))&S<<24>>24==0){V=K;W=P}else{T=34}}}while(0);do{if((T|0)==22){if(!(S<<24>>24==0)){T=34;break}V=+U(+R);W=+U(+J)}}while(0);if((T|0)==34){P=d-e;K=((e+f)*.5-e)/v;y=M*K*K*3.0+(O*K*2.0+k);z=P*(P*((F+(N+(P*(M/v)-l)))/v)+k)+g;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}do{if(W<V){if(!(w*R>=0.0)){X=J;break}X=R}else{X=J}}while(0);J=w*.1;T=+U(+X)<+U(+J);R=T?J:X;X=(I*k+L*l)/v;if(+U(+(X-R))<1.0e-6){Y=X*.999999}else{Y=R}R=(w-Y)/(X-Y)*3.0;X=I*R;I=L*R;R=X+e;L=f-I;w=(k-Y)/+yd(+(X*X),1.0e-13);X=(l-Y)/+yd(+(I*I),1.0e-13);I=e-R;l=w*I*I*I*-.3333333333333333-Y*e+g;g=f-L;if(R>d){e=d-R;y=Y;z=w*e*e*e*.3333333333333333+(Y*d+l);A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}if(L>d){y=Y;z=Y*d+l;A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}else{l=d-L;y=Y;z=X*l*l*l*.3333333333333333+(Y*d+(X*g*g*g*-.3333333333333333-Y*f+j));A=a;B=A;h[B>>3]=z;C=a;D=C+8|0;E=D;h[E>>3]=y;i=m;return}}function am(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function bm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function cm(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;w=1.0-d/647.096;c[t>>2]=6;ST(u,1,t);t=u;x=9280;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[s>>2]=6;ST(v,1,s);s=v;x=9296;c[s+0>>2]=c[x+0>>2];c[s+4>>2]=c[x+4>>2];c[s+8>>2]=c[x+8>>2];c[r>>2]=1;y=+h[(ZT(u,1,r)|0)>>3];c[q>>2]=1;z=y*+W(+w,+(+h[(ZT(v,1,q)|0)>>3]));c[p>>2]=2;y=+h[(ZT(u,1,p)|0)>>3];c[o>>2]=2;A=y*+W(+w,+(+h[(ZT(v,1,o)|0)>>3]));c[n>>2]=3;y=+h[(ZT(u,1,n)|0)>>3];c[m>>2]=3;B=y*+W(+w,+(+h[(ZT(v,1,m)|0)>>3]));c[l>>2]=4;y=+h[(ZT(u,1,l)|0)>>3];c[k>>2]=4;C=y*+W(+w,+(+h[(ZT(v,1,k)|0)>>3]));c[j>>2]=5;y=+h[(ZT(u,1,j)|0)>>3];c[g>>2]=5;D=y*+W(+w,+(+h[(ZT(v,1,g)|0)>>3]));c[f>>2]=6;y=+h[(ZT(u,1,f)|0)>>3];c[e>>2]=6;h[a>>3]=+ca(+(647.096/d*(z+(A+(B+(C+(D+y*+W(+w,+(+h[(ZT(v,1,e)|0)>>3])))))))))*22064.0e3;i=b;return}function dm(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+tb(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function em(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0;m=i;i=i+360|0;n=m;o=m+96|0;p=m+112|0;q=m+208|0;r=m+224|0;s=m+320|0;t=m+336|0;u=m+344|0;v=m+352|0;w=e+-1.0e-10;e=f+1.0e-10;x=s;y=j;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=r+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));fm(t,b,w,g,s,r);f=+h[t>>3]-d;t=q;r=j;c[t+0>>2]=c[r+0>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];y=p+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));fm(u,b,e,g,q,p);A=+h[u>>3]-d;if(f>0.0&A>0.0){B=3}else{if(f<0.0&A<0.0){B=3}}if((B|0)==3){B=CT(CT(CT(9312,AT(w,0,1,6)|0)|0,9448)|0,9456)|0;u=CT(CT(CT(B,AT(e,0,1,6)|0)|0,9448)|0,9472)|0;B=CT(CT(CT(u,AT(d,0,1,6)|0)|0,9448)|0,9488)|0;u=CT(CT(CT(B,AT(f,0,1,6)|0)|0,9448)|0,9520)|0;gm(0,CT(CT(CT(u,AT(A,0,1,6)|0)|0,9448)|0,9552)|0)}C=e-w;u=v;D=w;E=e;e=w;w=C;F=C;C=f;G=A;A=f;while(1){if(+U(+A)<+U(+G)){H=E;I=e;J=E;K=G;L=A;M=G}else{H=D;I=E;J=e;K=C;L=G;M=A}f=+U(+I)*2.0e-15+l;N=J*.5+I*-.5;if(+U(+N)<=f|L==0.0){break}do{if(+U(+F)<f){O=N;P=N}else{if(+U(+K)<=+U(+L)){O=N;P=N;break}Q=L/K;if(H==J){R=N*Q*2.0;S=1.0-Q}else{T=K/M;V=L/M;W=V+-1.0;R=Q*(N*T*(T-V)*2.0-(I-H)*W);S=(T+-1.0)*(Q+-1.0)*W}if(R>0.0){X=R;Y=-S}else{X=-R;Y=S}if(!(X*2.0<N*Y*3.0- +U(+(f*Y)))){O=N;P=N;break}if(!(X<+U(+(F*Y*.5)))){O=N;P=N;break}O=X/Y;P=w}}while(0);do{if(+U(+O)>f){Z=O}else{if(N>0.0){Z=f;break}Z=-f}}while(0);f=I+Z;B=o;p=j;c[B+0>>2]=c[p+0>>2];c[B+4>>2]=c[p+4>>2];c[B+8>>2]=c[p+8>>2];y=n+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));fm(v,b,f,g,o,n);N=+h[u>>3]-d;if(!(N>0.0&M>0.0)){if(!(N<0.0&M<0.0)){D=I;E=f;e=J;w=O;F=P;C=L;G=N;A=M;continue}}W=f-I;D=I;E=f;e=I;w=W;F=W;C=L;G=N;A=L}h[a>>3]=I;i=m;return}function fm(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;i=i+16|0;h=g;j=a;a=h;k=f;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];hm(j,b,e,d,h);i=g;return}function gm(a,b){a=a|0;b=b|0;a=i;IU(b);i=a;return}function hm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;g=i;i=i+200|0;j=g;k=g+96|0;l=g+192|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+96|0;q=i;i=i+96|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;jm(r,b,e);v=+h[r>>3];c[o>>2]=1;w=1.0- +h[(ZT(f,1,o)|0)>>3];x=+xd(+(v*(w/+yd(1.0e-13,+(d-v)))*.6219647130774989),1.0);c[n>>2]=1;v=+yd(+(+h[(ZT(f,1,n)|0)>>3]-x),0.0);c[m>>2]=1;x=+h[(ZT(f,1,m)|0)>>3]-v;c[l>>2]=1;d=1.0- +h[(ZT(f,1,l)|0)>>3];c[p>>2]=9608;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;l=p+40|0;f=9616;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+52|0;l=9632;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=p+64|0;f=9648;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+76|0;l=9664;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];h[p+88>>3]=461.5233290850878;l=k+0|0;f=p+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));km(s,b,k,e,1,3,2547494.319);w=+h[s>>3];c[q>>2]=9680;h[q+8>>3]=.0289651159;h[q+16>>3]=-4333.833858403446;h[q+24>>3]=298609.6803431054;h[q+32>>3]=1.0e3;s=q+40|0;k=9688;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+52|0;s=9704;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];s=q+64|0;k=9720;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+76|0;s=9736;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];h[q+88>>3]=287.0512249529787;l=j+0|0;f=q+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));km(t,b,j,e,1,3,25104.684);y=+h[t>>3];lm(u,0,e);h[a>>3]=x*w+(d*y+v*+h[u>>3]);i=g;return}function im(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function jm(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0.0;b=i;i=i+16|0;d=b;e=b+8|0;cm(d,0,c);f=+h[d>>3];pm(e,0,c);dm(a,0,f,+h[e>>3],c+-273.16,1.0);i=b;return}function km(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=+e;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0;l=i;i=i+32|0;m=l;n=l+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;if(!(e>0.0)){w=c[41338]|0;x=v;h[k>>3]=e;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=w;w=m;y=10776;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];Oe[x&63](b,m,10800,v);}z=+h[d+88>>3];c[u>>2]=1;A=+h[(ZT(d+52|0,1,u)|0)>>3];u=d+40|0;c[t>>2]=2;B=+h[(ZT(u,1,t)|0)>>3]*+da(+e);c[s>>2]=3;C=+h[(ZT(u,1,s)|0)>>3];c[r>>2]=4;D=+h[(ZT(u,1,r)|0)>>3]*.5;c[q>>2]=5;E=+h[(ZT(u,1,q)|0)>>3]*.3333333333333333;c[p>>2]=6;F=+h[(ZT(u,1,p)|0)>>3]*.25;c[o>>2]=7;G=(A+(B+(C+(D+(E+(F+ +h[(ZT(u,1,o)|0)>>3]*e*.2)*e)*e)*e)*e))*e;c[n>>2]=1;F=z*((G- +h[(ZT(u,1,n)|0)>>3])/e);if(f<<24>>24==0){H=0.0}else{H=-+h[d+16>>3]}if((g|0)!=1){I=0.0;J=(g|0)==3;K=J?j:0.0;L=K+I;M=H+L;N=F+M;O=a;P=O;h[P>>3]=N;i=l;return}I=+h[d+24>>3];J=(g|0)==3;K=J?j:0.0;L=K+I;M=H+L;N=F+M;O=a;P=O;h[P>>3]=N;i=l;return}function lm(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;b=i;d=c+-273.15;dm(a,0,d*4200.0,d*2050.0+-333.0e3,c+-273.16,.1);i=b;return}function mm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;b=i;i=i+40|0;e=b;f=b+32|0;g=e;j=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];nm(f,0,e);h[a>>3]=+h[d>>3]/(+h[f>>3]*+h[d+8>>3]);i=b;return}function nm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=d+16|0;c[f>>2]=1;j=(1.0- +h[(ZT(g,1,f)|0)>>3])*287.0512249529787;c[e>>2]=1;h[a>>3]=j+ +h[(ZT(g,1,e)|0)>>3]*461.5233290850878;i=b;return}function om(a,b,c,d,e,f,g,j,k,l){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;b=i;m=e/f;e=m*1.570796326794897;n=(k-m*l)/f;do{if(!(m<=-.99999999999)){if(m>=.9999999999){o=1.0;break}o=+tb(+(+Z(+e)))*.5+.5}else{o=0.0}}while(0);f=o*g+(1.0-o)*j;if(!(+U(+m)<1.0)){p=f;q=a;r=q;h[r>>3]=p;i=b;return}m=+ud(+(+Z(+e)))*+X(+e);p=f+(c-d)*(n/(m*m))*.7853981633974483;q=a;r=q;h[r>>3]=p;i=b;return}function pm(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=d/273.16;c[n>>2]=2;ST(o,1,n);n=o;r=9752;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[m>>2]=2;ST(p,1,m);m=p;r=9768;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[l>>2]=1;d=+h[(ZT(o,1,l)|0)>>3];c[k>>2]=2;s=+h[(ZT(o,1,k)|0)>>3];c[j>>2]=1;t=+h[(ZT(o,1,j)|0)>>3];c[g>>2]=1;u=-(t*+W(+q,+(+h[(ZT(p,1,g)|0)>>3])));c[f>>2]=2;t=+h[(ZT(o,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=+ca(+(d+(s+(u-t*+W(+q,+(+h[(ZT(p,1,e)|0)>>3]))))))*611.657;i=b;return}function qm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(ZT(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(ZT(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];YT(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];hm(d,b,o,p,f);i=e;return}function rm(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;b=i;i=i+32|0;e=b;f=b+8|0;g=b+16|0;j=b+24|0;cm(e,0,c);k=+h[e>>3];pm(f,0,c);l=+h[f>>3];sm(g,0,c,d);m=+h[g>>3];tm(j,0,c,d);om(a,0,k,l,c+-273.16,1.0,m,+h[j>>3],d,0.0);i=b;return}function sm(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+16|0;O=i;i=i+16|0;P=1.0-d/647.096;Q=-e/647.096;c[M>>2]=6;ST(N,1,M);M=N;R=9280;c[M+0>>2]=c[R+0>>2];c[M+4>>2]=c[R+4>>2];c[M+8>>2]=c[R+8>>2];c[L>>2]=6;ST(O,1,L);L=O;R=9296;c[L+0>>2]=c[R+0>>2];c[L+4>>2]=c[R+4>>2];c[L+8>>2]=c[R+8>>2];c[K>>2]=1;S=+h[(ZT(N,1,K)|0)>>3];c[J>>2]=1;T=S*+W(+P,+(+h[(ZT(O,1,J)|0)>>3]));c[I>>2]=2;S=+h[(ZT(N,1,I)|0)>>3];c[H>>2]=2;U=S*+W(+P,+(+h[(ZT(O,1,H)|0)>>3]));c[G>>2]=3;S=+h[(ZT(N,1,G)|0)>>3];c[F>>2]=3;V=S*+W(+P,+(+h[(ZT(O,1,F)|0)>>3]));c[E>>2]=4;S=+h[(ZT(N,1,E)|0)>>3];c[D>>2]=4;X=S*+W(+P,+(+h[(ZT(O,1,D)|0)>>3]));c[C>>2]=5;S=+h[(ZT(N,1,C)|0)>>3];c[B>>2]=5;Y=S*+W(+P,+(+h[(ZT(O,1,B)|0)>>3]));c[A>>2]=6;S=+h[(ZT(N,1,A)|0)>>3];c[z>>2]=6;Z=T+(U+(V+(X+(Y+S*+W(+P,+(+h[(ZT(O,1,z)|0)>>3]))))));S=647.096/d;Y=+ca(+(S*Z));c[y>>2]=1;X=+h[(ZT(N,1,y)|0)>>3];c[x>>2]=1;V=+W(+P,+(+h[(ZT(O,1,x)|0)>>3]+-1.0));c[w>>2]=1;U=X*V*Q*+h[(ZT(O,1,w)|0)>>3];c[v>>2]=2;V=+h[(ZT(N,1,v)|0)>>3];c[u>>2]=2;X=+W(+P,+(+h[(ZT(O,1,u)|0)>>3]+-1.0));c[t>>2]=2;T=V*X*Q*+h[(ZT(O,1,t)|0)>>3];c[s>>2]=3;X=+h[(ZT(N,1,s)|0)>>3];c[r>>2]=3;V=+W(+P,+(+h[(ZT(O,1,r)|0)>>3]+-1.0));c[q>>2]=3;_=X*V*Q*+h[(ZT(O,1,q)|0)>>3];c[p>>2]=4;V=+h[(ZT(N,1,p)|0)>>3];c[o>>2]=4;X=+W(+P,+(+h[(ZT(O,1,o)|0)>>3]+-1.0));c[n>>2]=4;$=V*X*Q*+h[(ZT(O,1,n)|0)>>3];c[m>>2]=5;X=+h[(ZT(N,1,m)|0)>>3];c[l>>2]=5;V=+W(+P,+(+h[(ZT(O,1,l)|0)>>3]+-1.0));c[k>>2]=5;aa=X*V*Q*+h[(ZT(O,1,k)|0)>>3];c[j>>2]=6;V=+h[(ZT(N,1,j)|0)>>3];c[g>>2]=6;X=+W(+P,+(+h[(ZT(O,1,g)|0)>>3]+-1.0));c[f>>2]=6;h[a>>3]=Y*(S*(U+(T+(_+($+(aa+V*X*Q*+h[(ZT(O,1,f)|0)>>3])))))-Z*e/(d*d)*647.096)*22064.0e3;i=b;return}function tm(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=d/273.16;d=e/273.16;c[u>>2]=2;ST(v,1,u);u=v;y=9752;c[u+0>>2]=c[y+0>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2];c[t>>2]=2;ST(w,1,t);t=w;y=9768;c[t+0>>2]=c[y+0>>2];c[t+4>>2]=c[y+4>>2];c[t+8>>2]=c[y+8>>2];c[s>>2]=1;e=+h[(ZT(v,1,s)|0)>>3];c[r>>2]=2;z=+h[(ZT(v,1,r)|0)>>3];c[q>>2]=1;A=+h[(ZT(v,1,q)|0)>>3];c[p>>2]=1;B=-(A*+W(+x,+(+h[(ZT(w,1,p)|0)>>3])));c[o>>2]=2;A=+h[(ZT(v,1,o)|0)>>3];c[n>>2]=2;C=+ca(+(e+(z+(B-A*+W(+x,+(+h[(ZT(w,1,n)|0)>>3]))))));c[m>>2]=1;A=+h[(ZT(v,1,m)|0)>>3];c[l>>2]=1;B=+W(+x,+(+h[(ZT(w,1,l)|0)>>3]+-1.0));c[k>>2]=1;z=-(A*B*d*+h[(ZT(w,1,k)|0)>>3]);c[j>>2]=2;B=+h[(ZT(v,1,j)|0)>>3];c[g>>2]=2;A=+W(+x,+(+h[(ZT(w,1,g)|0)>>3]+-1.0));c[f>>2]=2;h[a>>3]=C*(z-B*A*d*+h[(ZT(w,1,f)|0)>>3])*611.657;i=b;return}function um(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;ST(u,1,n);c[m>>2]=2;ST(u,1,m);if((HS(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];im(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +$T(f);YT(q,1,w,l);c[k>>2]=q;_T(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];im(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];TT(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function vm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];um(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];qm(j,b,h);i=g;return}function wm(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c>>3];i=i;return}function xm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function ym(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;b=i;d=c+-273.15;zm(a,0,d*4200.0,d*2050.0+-333.0e3,c+-273.16,.1);i=b;return}function zm(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+tb(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function Am(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;g=i;i=i+200|0;j=g;k=g+96|0;l=g+192|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+96|0;q=i;i=i+96|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;Bm(r,b,e);v=+h[r>>3];c[o>>2]=1;w=1.0- +h[(ZT(f,1,o)|0)>>3];x=+xd(+(v*(w/+yd(1.0e-13,+(d-v)))*.6219647130774989),1.0);c[n>>2]=1;v=+yd(+(+h[(ZT(f,1,n)|0)>>3]-x),0.0);c[m>>2]=1;x=+h[(ZT(f,1,m)|0)>>3]-v;c[l>>2]=1;d=1.0- +h[(ZT(f,1,l)|0)>>3];c[p>>2]=9608;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;l=p+40|0;f=9616;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+52|0;l=9632;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=p+64|0;f=9648;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+76|0;l=9664;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];h[p+88>>3]=461.5233290850878;l=k+0|0;f=p+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));km(s,b,k,e,1,3,2547494.319);w=+h[s>>3];c[q>>2]=9680;h[q+8>>3]=.0289651159;h[q+16>>3]=-4333.833858403446;h[q+24>>3]=298609.6803431054;h[q+32>>3]=1.0e3;s=q+40|0;k=9688;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+52|0;s=9704;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];s=q+64|0;k=9720;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+76|0;s=9736;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];h[q+88>>3]=287.0512249529787;l=j+0|0;f=q+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));km(t,b,j,e,1,3,25104.684);y=+h[t>>3];ym(u,b,e);h[a>>3]=x*w+(d*y+v*+h[u>>3]);i=g;return}function Bm(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0.0;b=i;i=i+16|0;d=b;e=b+8|0;Em(d,0,c);f=+h[d>>3];Fm(e,0,c);zm(a,0,f,+h[e>>3],c+-273.16,1.0);i=b;return}function Cm(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function Dm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(ZT(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(ZT(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];YT(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Am(d,b,o,p,f);i=e;return}function Em(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;w=1.0-d/647.096;c[t>>2]=6;ST(u,1,t);t=u;x=9280;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[s>>2]=6;ST(v,1,s);s=v;x=9296;c[s+0>>2]=c[x+0>>2];c[s+4>>2]=c[x+4>>2];c[s+8>>2]=c[x+8>>2];c[r>>2]=1;y=+h[(ZT(u,1,r)|0)>>3];c[q>>2]=1;z=y*+W(+w,+(+h[(ZT(v,1,q)|0)>>3]));c[p>>2]=2;y=+h[(ZT(u,1,p)|0)>>3];c[o>>2]=2;A=y*+W(+w,+(+h[(ZT(v,1,o)|0)>>3]));c[n>>2]=3;y=+h[(ZT(u,1,n)|0)>>3];c[m>>2]=3;B=y*+W(+w,+(+h[(ZT(v,1,m)|0)>>3]));c[l>>2]=4;y=+h[(ZT(u,1,l)|0)>>3];c[k>>2]=4;C=y*+W(+w,+(+h[(ZT(v,1,k)|0)>>3]));c[j>>2]=5;y=+h[(ZT(u,1,j)|0)>>3];c[g>>2]=5;D=y*+W(+w,+(+h[(ZT(v,1,g)|0)>>3]));c[f>>2]=6;y=+h[(ZT(u,1,f)|0)>>3];c[e>>2]=6;h[a>>3]=+ca(+(647.096/d*(z+(A+(B+(C+(D+y*+W(+w,+(+h[(ZT(v,1,e)|0)>>3])))))))))*22064.0e3;i=b;return}function Fm(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=d/273.16;c[n>>2]=2;ST(o,1,n);n=o;r=9752;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[m>>2]=2;ST(p,1,m);m=p;r=9768;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[l>>2]=1;d=+h[(ZT(o,1,l)|0)>>3];c[k>>2]=2;s=+h[(ZT(o,1,k)|0)>>3];c[j>>2]=1;t=+h[(ZT(o,1,j)|0)>>3];c[g>>2]=1;u=-(t*+W(+q,+(+h[(ZT(p,1,g)|0)>>3])));c[f>>2]=2;t=+h[(ZT(o,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=+ca(+(d+(s+(u-t*+W(+q,+(+h[(ZT(p,1,e)|0)>>3]))))))*611.657;i=b;return}function Gm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;ST(u,1,n);c[m>>2]=2;ST(u,1,m);if((HS(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];xm(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +$T(f);YT(q,1,w,l);c[k>>2]=q;_T(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];xm(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];TT(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function Hm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Gm(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];Dm(j,b,h);i=g;return}function Im(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;ST(u,1,n);c[m>>2]=2;ST(u,1,m);if((HS(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];bm(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +$T(f);YT(q,1,w,l);c[k>>2]=q;_T(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];bm(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];TT(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function Jm(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0.0;b=i;i=i+16|0;d=b;e=b+8|0;Km(d,0,c);f=+h[d>>3];Lm(e,0,c);Mm(a,0,f,+h[e>>3],c+-273.16,1.0);i=b;return}



function LO(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=gO(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=ON(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=gO(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((RO(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=Ne[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=De[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}Ne[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=tO(k,b,v,w+(De[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=pO(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=xO(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=kO(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=kO(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=De[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(gO(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((dO(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((dO(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((dO(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=oe[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;rma(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}le[c[k+20>>2]&511](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;rma(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;rma(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function MO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=44;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=Ne[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-1:{k=15;break a;break};case 11:{if((EO(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 13:{if((FO(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case 0:{k=14;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}bO(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-15:{k=3;break a;break};case-2:{k=18;break a;break};case-4:{k=7;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==2){k=24;break}else if((f|0)==3){k=23;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){bO(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function NO(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=Ne[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-2:{r=25;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Ke[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}bO(o,b,c[k>>2]|0,c[l>>2]|0);break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}bO(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Ke[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];ie[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Ke[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 0:{r=24;break a;break};case-4:case-1:{r=28;break a;break};case 40:{r=6;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){le[c[n+76>>2]&511](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}bO(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function OO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=NO(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=45;k=PO(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=rO(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function PO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=IO(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((QO(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function QO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=De[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}rma(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function RO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((dO(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((dO(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=gO(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function SO(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(Ne[c[b+16>>2]&63](b,f,g,l)|0){case 6:{if((vO(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case-1:{o=7;break a;break};case-4:{o=3;break a;break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};case 10:{p=De[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=ZO(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((dO(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 0:{o=4;break a;break};case 9:{q=(re[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((dO(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=pO(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=gO(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=SO(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 7:case 39:{o=31;break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((dO(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function TO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((re[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=_O()|0;c[g+240>>2]=oe[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=Ne[((a[g+236|0]&255|0)!=0?46:47)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){le[c[f+1032>>2]&511](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}le[c[f+1032>>2]&511](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function UO(){var a=0,b=0;a=i;i=i+8|0;ec(((yc(0)|0)>>>0)%4294967295|0|0);b=xma()|0;i=a;return b|0}function VO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=lO(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=41;h=mO(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function WO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=oe[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{XO(f+80|0,e);XO(b+104|0,e);YO(b,e);YO(b+20|0,e);YO(b+40|0,e);YO(b+60|0,e);a[b+131|0]=0;YO(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function XO(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function YO(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function ZO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function _O(){i=i;return 1912}function $O(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[113192+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[113268+l|0]|0|0)!=28){if((d[113268+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[113268+q|0]|0|0)!=28){if((d[113268+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[113268+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((aP(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[107360+(((d[107104+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[107360+(((d[108640+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=ZO(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=50;c[h+336>>2]=50;c[h+340>>2]=50;c[h+344>>2]=51;c[h+348>>2]=51;c[h+352>>2]=51;c[h+356>>2]=52;c[h+360>>2]=52;c[h+364>>2]=52}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function aP(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 0:{if((d[113268+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function bP(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=De[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[107360+(((d[108640+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function cP(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=De[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[107360+(((d[107104+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function dP(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=De[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(aP(a)|0)<0;g=f&1;i=d;return g|0}function eP(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=ZO(De[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function fP(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(De[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function gP(){i=i;return 112824}function hP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=iP(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=48;c[g+4>>2]=49;c[g+52>>2]=37;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function iP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((wP(d,c[112728+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function jP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=uR(111168,a,0,b,c,d)|0;i=e;return f|0}function kP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=uR(111168,a,1,b,c,d)|0;i=e;return f|0}function lP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;TQ(111936,b,c,d);i=a;return}function mP(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=nP(37,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function nP(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(vR(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((Ne[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,112672)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((vR(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((Ne[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,112680)|0)!=0){h=wR(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=re[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((vR(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((Ne[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,112696)|0)!=0){if((a|0)!=0){break}do{if((Ne[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,112712)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((Ne[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,112720)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((xR(wR(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function oP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ie[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((wP(h,108896)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=iP(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[111168+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function pP(){i=i;return 110800}function qP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=iP(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=50;c[g+4>>2]=51;c[g+52>>2]=37;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function rP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=uR(108904,a,0,b,c,d)|0;i=e;return f|0}function sP(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=uR(108904,a,1,b,c,d)|0;i=e;return f|0}function tP(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=nP(38,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function uP(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ie[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((wP(h,108896)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=iP(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[108904+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function vP(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=$O(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function wP(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function xP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=QP(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[107360+((d[108640+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 10:case 21:{o=25;break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=OP(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 12:{k=_P(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=_P(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=OP(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=$P(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=WP(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 19:{k=aQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=OP(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=OP(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=OP(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 6:{o=108;break b;break};case 5:{o=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[107360+((d[108640+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 7:{o=111;break b;break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 15:{o=122;break b;break};case 34:{o=116;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 7:{o=91;break b;break};case 29:{if((c[107360+((d[108640+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 5:{o=85;break b;break};case 33:{o=119;break b;break};case 6:{o=88;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function yP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=OP(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 3:{k=PP(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{k=TP(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=OP(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 5:{s=b;if((e-b|0)<2){p=49;break b}b=s+2|0;continue b;break};case 7:{t=b;if((e-b|0)<4){p=55;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function zP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=OP(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=OP(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{t=b;if((e-b|0)<4){p=53;break b}b=t+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function AP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=OP(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function BP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=OP(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 9:{n=19;break a;break};case 7:{b=b+4|0;continue a;break};case 10:{n=16;break a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 21:{n=29;break a;break};case 2:{n=15;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=PP(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=OP(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function CP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=OP(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 10:{n=18;break a;break};case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=PP(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=QP(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=OP(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function DP(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=OP(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 6:{k=8;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=OP(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function EP(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function FP(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=OP(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function GP(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=OP(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function HP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=OP(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=OP(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function IP(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=aP(c)|0;k=j;i=b;return k|0}function JP(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((f|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function KP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=OP(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=OP(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 6:{b=b+3|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function LP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=OP(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function MP(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g]|0;n=((l&3)<<4|(a[g+1|0]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function NP(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function OP(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 219:case 218:case 217:case 216:{d=7;break};case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function PP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=RP(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=OP(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 29:{if((c[107360+((d[108640+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function QP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=OP(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[107360+((d[108640+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function RP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=SP(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=OP(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function SP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=OP(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=OP(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function TP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 17:{k=XP(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=WP(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=OP(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=UP(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=VP(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=OP(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=OP(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 24:case 22:{break};case 6:{o=62;break b;break};case 29:{if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 6:{o=42;break b;break};case 7:{o=45;break b;break};case 11:{o=90;break b;break};case 29:{if((c[107360+((d[108640+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 10:case 9:case 21:{o=69;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 17:{break b;break};case 5:{o=39;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=OP(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 6:{o=81;break d;break};case 11:{o=90;break c;break};case 24:case 22:{break d;break};case 29:{o=75;break d;break};case 10:case 9:case 21:{break};case 5:{o=78;break d;break};case 17:{break c;break};case 7:{o=84;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=YP(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function UP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=OP(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function VP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[109304+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function WP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=OP(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=OP(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{p=28;break b;break};case 29:{if((c[107360+((d[108640+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 6:{p=31;break b;break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 15:{p=62;break b;break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((ZP(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=OP(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((ZP(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function XP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=OP(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 11:{n=48;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 29:{if((c[107360+((d[108640+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 5:{n=28;break b;break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=OP(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function YP(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=OP(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 5:{l=10;break a;break};case 7:{l=16;break a;break};case 6:{l=13;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=OP(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 29:{if((c[107360+((d[108640+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){p=d[k+76+(d[o]|0)|0]|0}else{p=OP(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(p|0){case 5:{l=30;break a;break};case 7:{l=36;break a;break};case 29:{if((c[107360+((d[107104+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};case 6:{l=33;break a;break};case 24:case 22:{break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 14:{break};case 27:case 26:case 25:case 24:case 22:{l=9;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=OP(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[o]|0)|0]|0}else{s=OP(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 2:{l=79;break a;break};case 3:{t=PP(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[o]|0)|0]|0}else{u=OP(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[o]|0)|0]|0}else{v=OP(a[o+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 24:case 22:{break d;break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 17:{l=107;break a;break};case 6:{l=100;break a;break};case 10:case 9:case 21:{break};case 5:{l=97;break a;break};case 11:{l=106;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[107360+((d[107104+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function ZP(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function _P(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=OP(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 8:case 1:case 0:{l=16;break a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=OP(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function $P(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}if((m|0)==27){k=UP(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=OP(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=OP(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function aQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=OP(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[107360+((d[107104+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=OP(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 6:{n=31;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 29:{if((c[107360+((d[108640+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function bQ(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=OP(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 19:{k=FQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=OP(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 12:{k=DQ(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=OP(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 15:{k=zQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=EQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 10:case 21:{p=25;break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 24:case 22:{o=18;b=b+2|0;p=77;break};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 29:{g=b;if((c[107360+((d[107104+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[107360+((d[108640+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 13:{k=DQ(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=tQ(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=OP(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=OP(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 7:{p=91;break b;break};case 33:{p=119;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 15:{p=122;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=OP(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 29:{if((c[107360+((d[108640+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=103;break b}break};case 5:{p=105;break b;break};case 7:{p=111;break b;break};case 6:{p=108;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 34:{p=116;break b;break};case 6:{p=88;break b;break};case 29:{if((c[107360+((d[108640+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=83;break b}break};case 5:{p=85;break b;break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}



function Km(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;w=1.0-d/647.096;c[t>>2]=6;ST(u,1,t);t=u;x=9280;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[s>>2]=6;ST(v,1,s);s=v;x=9296;c[s+0>>2]=c[x+0>>2];c[s+4>>2]=c[x+4>>2];c[s+8>>2]=c[x+8>>2];c[r>>2]=1;y=+h[(ZT(u,1,r)|0)>>3];c[q>>2]=1;z=y*+W(+w,+(+h[(ZT(v,1,q)|0)>>3]));c[p>>2]=2;y=+h[(ZT(u,1,p)|0)>>3];c[o>>2]=2;A=y*+W(+w,+(+h[(ZT(v,1,o)|0)>>3]));c[n>>2]=3;y=+h[(ZT(u,1,n)|0)>>3];c[m>>2]=3;B=y*+W(+w,+(+h[(ZT(v,1,m)|0)>>3]));c[l>>2]=4;y=+h[(ZT(u,1,l)|0)>>3];c[k>>2]=4;C=y*+W(+w,+(+h[(ZT(v,1,k)|0)>>3]));c[j>>2]=5;y=+h[(ZT(u,1,j)|0)>>3];c[g>>2]=5;D=y*+W(+w,+(+h[(ZT(v,1,g)|0)>>3]));c[f>>2]=6;y=+h[(ZT(u,1,f)|0)>>3];c[e>>2]=6;h[a>>3]=+ca(+(647.096/d*(z+(A+(B+(C+(D+y*+W(+w,+(+h[(ZT(v,1,e)|0)>>3])))))))))*22064.0e3;i=b;return}function Lm(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=d/273.16;c[n>>2]=2;ST(o,1,n);n=o;r=9752;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[m>>2]=2;ST(p,1,m);m=p;r=9768;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[l>>2]=1;d=+h[(ZT(o,1,l)|0)>>3];c[k>>2]=2;s=+h[(ZT(o,1,k)|0)>>3];c[j>>2]=1;t=+h[(ZT(o,1,j)|0)>>3];c[g>>2]=1;u=-(t*+W(+q,+(+h[(ZT(p,1,g)|0)>>3])));c[f>>2]=2;t=+h[(ZT(o,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=+ca(+(d+(s+(u-t*+W(+q,+(+h[(ZT(p,1,e)|0)>>3]))))))*611.657;i=b;return}function Mm(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+tb(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function Nm(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;b=i;d=c+-273.15;Mm(a,0,d*4200.0,d*2050.0+-333.0e3,c+-273.16,.1);i=b;return}function Om(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;g=i;i=i+200|0;j=g;k=g+96|0;l=g+192|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+96|0;q=i;i=i+96|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;Jm(r,b,e);v=+h[r>>3];c[o>>2]=1;w=1.0- +h[(ZT(f,1,o)|0)>>3];x=+xd(+(v*(w/+yd(1.0e-13,+(d-v)))*.6219647130774989),1.0);c[n>>2]=1;v=+yd(+(+h[(ZT(f,1,n)|0)>>3]-x),0.0);c[m>>2]=1;x=+h[(ZT(f,1,m)|0)>>3]-v;c[l>>2]=1;d=1.0- +h[(ZT(f,1,l)|0)>>3];c[p>>2]=9608;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;l=p+40|0;f=9616;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+52|0;l=9632;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=p+64|0;f=9648;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+76|0;l=9664;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];h[p+88>>3]=461.5233290850878;l=k+0|0;f=p+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));km(s,b,k,e,1,3,2547494.319);w=+h[s>>3];c[q>>2]=9680;h[q+8>>3]=.0289651159;h[q+16>>3]=-4333.833858403446;h[q+24>>3]=298609.6803431054;h[q+32>>3]=1.0e3;s=q+40|0;k=9688;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+52|0;s=9704;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];s=q+64|0;k=9720;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+76|0;s=9736;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];h[q+88>>3]=287.0512249529787;l=j+0|0;f=q+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));km(t,b,j,e,1,3,25104.684);y=+h[t>>3];Nm(u,0,e);h[a>>3]=x*w+(d*y+v*+h[u>>3]);i=g;return}function Pm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];Im(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];Qm(j,b,h);i=g;return}function Qm(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(ZT(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(ZT(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];YT(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Om(d,b,o,p,f);i=e;return}function Rm(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+56|0;l=k;m=k+24|0;n=k+48|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=HS(g,1)|0;if(e<<24>>24!=0&f<<24>>24==0){f=CT(CT(CT(CT(10232,j)|0,10288)|0,b)|0,10320)|0;e=c[41338]|0;u=m;v=10440;c[u+0>>2]=c[v+0>>2];c[u+4>>2]=c[v+4>>2];c[u+8>>2]=c[v+8>>2];c[u+12>>2]=c[v+12>>2];c[u+16>>2]=c[v+16>>2];c[u+20>>2]=c[v+20>>2];Oe[e&63](a,m,f,s);}if((t|0)<1){i=k;return}s=(Sm(1,1,t)|0)==0;if(!s){f=1;do{c[r>>2]=f;if(!(+h[(ZT(g,1,r)|0)>>3]>=0.0)){m=CT(CT(CT(CT(10464,b)|0,10512)|0,j)|0,10528)|0;e=CT(CT(m,zT(f,0,1)|0)|0,10568)|0;c[q>>2]=f;m=CT(CT(e,AT(+h[(ZT(g,1,q)|0)>>3],0,1,6)|0)|0,10576)|0;e=c[41338]|0;v=l;u=10616;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[v+12>>2]=c[u+12>>2];c[v+16>>2]=c[u+16>>2];c[v+20>>2]=c[u+20>>2];Oe[e&63](a,l,m,p);}f=f+1|0;}while((Sm(f,1,t)|0)!=0)}if((t|0)<=0){i=k;return}if(!(+U(+(+$T(g)+-1.0))>1.0e-10)){i=k;return}if(s){w=8224}else{s=8224;f=1;while(1){p=CT(s,10640)|0;l=CT(CT(p,zT(f,0,1)|0)|0,10656)|0;c[o>>2]=f;p=CT(CT(l,AT(+h[(ZT(g,1,o)|0)>>3],0,1,6)|0)|0,10664)|0;c[n>>2]=f;l=CT(CT(p,c[(CU(d,1,n)|0)>>2]|0)|0,10672)|0;p=f+1|0;if((Sm(p,1,t)|0)==0){w=l;break}else{f=p;s=l}}}s=CT(CT(CT(CT(CT(10680,b)|0,10512)|0,j)|0,10672)|0,10720)|0;gm(0,CT(CT(CT(s,AT(+$T(g),0,1,6)|0)|0,10768)|0,w)|0);i=k;return}function Sm(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;if((b|0)>(c|0)){if((a|0)<(c|0)|(a|0)>(b|0)){e=4}else{f=1}}else{if((a|0)<(b|0)|(a|0)>(c|0)){e=4}else{f=1}}if((e|0)==4){f=0}i=d;return f|0}function Tm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0.0;g=i;i=i+120|0;j=g;k=g+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+96|0;c[l>>2]=1;o=+h[(ZT(f,1,l)|0)>>3];YT(m,1,o,g+112|0);c[n>>2]=9608;h[n+8>>3]=.01801528;h[n+16>>3]=-13423382.81725291;h[n+24>>3]=549760.6476280135;h[n+32>>3]=1.0e3;l=n+40|0;f=9616;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=n+52|0;l=9632;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=n+64|0;f=9648;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=n+76|0;l=9664;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];h[n+88>>3]=461.5233290850878;l=a;a=k;f=m;c[a+0>>2]=c[f+0>>2];c[a+4>>2]=c[f+4>>2];c[a+8>>2]=c[f+8>>2];f=j+0|0;a=n+0|0;n=f+96|0;do{c[f>>2]=c[a>>2];f=f+4|0;a=a+4|0}while((f|0)<(n|0));Um(l,b,e,190.0,647.0,d,k,j,1.0e-13);i=g;return}function Um(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=+d;e=+e;f=+f;g=+g;j=j|0;k=k|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,V=0.0,W=0.0,X=0.0,Y=0.0,Z=0.0;m=i;i=i+360|0;n=m;o=m+96|0;p=m+112|0;q=m+208|0;r=m+224|0;s=m+320|0;t=m+336|0;u=m+344|0;v=m+352|0;w=e+-1.0e-10;e=f+1.0e-10;x=s;y=j;c[x+0>>2]=c[y+0>>2];c[x+4>>2]=c[y+4>>2];c[x+8>>2]=c[y+8>>2];y=r+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));Xm(t,b,w,g,s,r);f=+h[t>>3]-d;t=q;r=j;c[t+0>>2]=c[r+0>>2];c[t+4>>2]=c[r+4>>2];c[t+8>>2]=c[r+8>>2];y=p+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));Xm(u,b,e,g,q,p);A=+h[u>>3]-d;if(f>0.0&A>0.0){B=3}else{if(f<0.0&A<0.0){B=3}}if((B|0)==3){B=CT(CT(CT(9312,AT(w,0,1,6)|0)|0,9448)|0,9456)|0;u=CT(CT(CT(B,AT(e,0,1,6)|0)|0,9448)|0,9472)|0;B=CT(CT(CT(u,AT(d,0,1,6)|0)|0,9448)|0,9488)|0;u=CT(CT(CT(B,AT(f,0,1,6)|0)|0,9448)|0,9520)|0;gm(0,CT(CT(CT(u,AT(A,0,1,6)|0)|0,9448)|0,9552)|0)}C=e-w;u=v;D=w;E=e;e=w;w=C;F=C;C=f;G=A;A=f;while(1){if(+U(+A)<+U(+G)){H=E;I=e;J=E;K=G;L=A;M=G}else{H=D;I=E;J=e;K=C;L=G;M=A}f=+U(+I)*2.0e-15+l;N=J*.5+I*-.5;if(+U(+N)<=f|L==0.0){break}do{if(+U(+F)<f){O=N;P=N}else{if(+U(+K)<=+U(+L)){O=N;P=N;break}Q=L/K;if(H==J){R=N*Q*2.0;S=1.0-Q}else{T=K/M;V=L/M;W=V+-1.0;R=Q*(N*T*(T-V)*2.0-(I-H)*W);S=(T+-1.0)*(Q+-1.0)*W}if(R>0.0){X=R;Y=-S}else{X=-R;Y=S}if(!(X*2.0<N*Y*3.0- +U(+(f*Y)))){O=N;P=N;break}if(!(X<+U(+(F*Y*.5)))){O=N;P=N;break}O=X/Y;P=w}}while(0);do{if(+U(+O)>f){Z=O}else{if(N>0.0){Z=f;break}Z=-f}}while(0);f=I+Z;B=o;p=j;c[B+0>>2]=c[p+0>>2];c[B+4>>2]=c[p+4>>2];c[B+8>>2]=c[p+8>>2];y=n+0|0;x=k+0|0;z=y+96|0;do{c[y>>2]=c[x>>2];y=y+4|0;x=x+4|0}while((y|0)<(z|0));Xm(v,b,f,g,o,n);N=+h[u>>3]-d;if(!(N>0.0&M>0.0)){if(!(N<0.0&M<0.0)){D=I;E=f;e=J;w=O;F=P;C=L;G=N;A=M;continue}}W=f-I;D=I;E=f;e=I;w=W;F=W;C=L;G=N;A=L}h[a>>3]=I;i=m;return}function Vm(a,b,c){a=a|0;b=b|0;c=c|0;h[a>>3]=+h[c+8>>3];i=i;return}function Wm(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0;b=i;i=i+16|0;g=b;j=f;f=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];j=g;h[a>>3]=d;h[a+8>>3]=e;g=a+16|0;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];i=b;return}function Xm(a,b,d,e,f,g){a=a|0;b=b|0;d=+d;e=+e;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;i=i+16|0;h=g;j=a;a=h;k=f;c[a+0>>2]=c[k+0>>2];c[a+4>>2]=c[k+4>>2];c[a+8>>2]=c[k+8>>2];Ym(j,b,e,d,h);i=g;return}function Ym(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0.0,x=0.0,y=0.0;g=i;i=i+200|0;j=g;k=g+96|0;l=g+192|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+96|0;q=i;i=i+96|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;dn(r,b,e);v=+h[r>>3];c[o>>2]=1;w=1.0- +h[(ZT(f,1,o)|0)>>3];x=+xd(+(v*(w/+yd(1.0e-13,+(d-v)))*.6219647130774989),1.0);c[n>>2]=1;v=+yd(+(+h[(ZT(f,1,n)|0)>>3]-x),0.0);c[m>>2]=1;x=+h[(ZT(f,1,m)|0)>>3]-v;c[l>>2]=1;d=1.0- +h[(ZT(f,1,l)|0)>>3];c[p>>2]=9608;h[p+8>>3]=.01801528;h[p+16>>3]=-13423382.81725291;h[p+24>>3]=549760.6476280135;h[p+32>>3]=1.0e3;l=p+40|0;f=9616;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+52|0;l=9632;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];l=p+64|0;f=9648;c[l+0>>2]=c[f+0>>2];c[l+4>>2]=c[f+4>>2];c[l+8>>2]=c[f+8>>2];f=p+76|0;l=9664;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];h[p+88>>3]=461.5233290850878;l=k+0|0;f=p+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));km(s,b,k,e,1,3,2547494.319);w=+h[s>>3];c[q>>2]=9680;h[q+8>>3]=.0289651159;h[q+16>>3]=-4333.833858403446;h[q+24>>3]=298609.6803431054;h[q+32>>3]=1.0e3;s=q+40|0;k=9688;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+52|0;s=9704;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];s=q+64|0;k=9720;c[s+0>>2]=c[k+0>>2];c[s+4>>2]=c[k+4>>2];c[s+8>>2]=c[k+8>>2];k=q+76|0;s=9736;c[k+0>>2]=c[s+0>>2];c[k+4>>2]=c[s+4>>2];c[k+8>>2]=c[s+8>>2];h[q+88>>3]=287.0512249529787;l=j+0|0;f=q+0|0;p=l+96|0;do{c[l>>2]=c[f>>2];l=l+4|0;f=f+4|0}while((l|0)<(p|0));km(t,b,j,e,1,3,25104.684);y=+h[t>>3];_m(u,b,e);h[a>>3]=x*w+(d*y+v*+h[u>>3]);i=g;return}function Zm(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;w=1.0-d/647.096;c[t>>2]=6;ST(u,1,t);t=u;x=9280;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];c[s>>2]=6;ST(v,1,s);s=v;x=9296;c[s+0>>2]=c[x+0>>2];c[s+4>>2]=c[x+4>>2];c[s+8>>2]=c[x+8>>2];c[r>>2]=1;y=+h[(ZT(u,1,r)|0)>>3];c[q>>2]=1;z=y*+W(+w,+(+h[(ZT(v,1,q)|0)>>3]));c[p>>2]=2;y=+h[(ZT(u,1,p)|0)>>3];c[o>>2]=2;A=y*+W(+w,+(+h[(ZT(v,1,o)|0)>>3]));c[n>>2]=3;y=+h[(ZT(u,1,n)|0)>>3];c[m>>2]=3;B=y*+W(+w,+(+h[(ZT(v,1,m)|0)>>3]));c[l>>2]=4;y=+h[(ZT(u,1,l)|0)>>3];c[k>>2]=4;C=y*+W(+w,+(+h[(ZT(v,1,k)|0)>>3]));c[j>>2]=5;y=+h[(ZT(u,1,j)|0)>>3];c[g>>2]=5;D=y*+W(+w,+(+h[(ZT(v,1,g)|0)>>3]));c[f>>2]=6;y=+h[(ZT(u,1,f)|0)>>3];c[e>>2]=6;h[a>>3]=+ca(+(647.096/d*(z+(A+(B+(C+(D+y*+W(+w,+(+h[(ZT(v,1,e)|0)>>3])))))))))*22064.0e3;i=b;return}function _m(a,b,c){a=a|0;b=b|0;c=+c;var d=0.0;b=i;d=c+-273.15;$m(a,0,d*4200.0,d*2050.0+-333.0e3,c+-273.16,.1);i=b;return}function $m(a,b,c,d,e,f){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;var g=0.0,j=0.0;b=i;g=e/f;f=g*1.570796326794897;do{if(!(g<=-.999999999)){if(g>=.999999999){j=1.0;break}j=+tb(+(+Z(+f)))*.5+.5}else{j=0.0}}while(0);h[a>>3]=j*c+(1.0-j)*d;i=b;return}function an(a,b,c,d,e,f,g,j,k,l){a=a|0;b=b|0;c=+c;d=+d;e=+e;f=+f;g=+g;j=+j;k=+k;l=+l;var m=0.0,n=0.0,o=0.0,p=0.0,q=0,r=0;b=i;m=e/f;e=m*1.570796326794897;n=(k-m*l)/f;do{if(!(m<=-.99999999999)){if(m>=.9999999999){o=1.0;break}o=+tb(+(+Z(+e)))*.5+.5}else{o=0.0}}while(0);f=o*g+(1.0-o)*j;if(!(+U(+m)<1.0)){p=f;q=a;r=q;h[r>>3]=p;i=b;return}m=+ud(+(+Z(+e)))*+X(+e);p=f+(c-d)*(n/(m*m))*.7853981633974483;q=a;r=q;h[r>>3]=p;i=b;return}function bn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0;b=i;i=i+40|0;e=b;f=b+32|0;g=e;j=d;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];c[g+24>>2]=c[j+24>>2];c[g+28>>2]=c[j+28>>2];cn(f,0,e);h[a>>3]=+h[d>>3]/(+h[f>>3]*+h[d+8>>3]);i=b;return}function cn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=d+16|0;c[f>>2]=1;j=(1.0- +h[(ZT(g,1,f)|0)>>3])*287.0512249529787;c[e>>2]=1;h[a>>3]=j+ +h[(ZT(g,1,e)|0)>>3]*461.5233290850878;i=b;return}function dn(a,b,c){a=a|0;b=b|0;c=+c;var d=0,e=0,f=0.0;b=i;i=i+16|0;d=b;e=b+8|0;Zm(d,0,c);f=+h[d>>3];en(e,0,c);$m(a,0,f,+h[e>>3],c+-273.16,1.0);i=b;return}function en(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0.0,t=0.0,u=0.0;b=i;i=i+8|0;e=b;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=d/273.16;c[n>>2]=2;ST(o,1,n);n=o;r=9752;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[m>>2]=2;ST(p,1,m);m=p;r=9768;c[m+0>>2]=c[r+0>>2];c[m+4>>2]=c[r+4>>2];c[m+8>>2]=c[r+8>>2];c[l>>2]=1;d=+h[(ZT(o,1,l)|0)>>3];c[k>>2]=2;s=+h[(ZT(o,1,k)|0)>>3];c[j>>2]=1;t=+h[(ZT(o,1,j)|0)>>3];c[g>>2]=1;u=-(t*+W(+q,+(+h[(ZT(p,1,g)|0)>>3])));c[f>>2]=2;t=+h[(ZT(o,1,f)|0)>>3];c[e>>2]=2;h[a>>3]=+ca(+(d+(s+(u-t*+W(+q,+(+h[(ZT(p,1,e)|0)>>3]))))))*611.657;i=b;return}function fn(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0;e=i;i=i+24|0;f=e;g=e+16|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=d+16|0;c[l>>2]=1;o=+h[(ZT(n,1,l)|0)>>3];c[j>>2]=2;p=+h[(ZT(n,1,j)|0)>>3];j=g;h[k>>3]=p;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];YT(m,2,o,g);o=+h[d>>3];p=+h[d+8>>3];d=a;a=f;g=m;c[a+0>>2]=c[g+0>>2];c[a+4>>2]=c[g+4>>2];c[a+8>>2]=c[g+8>>2];Ym(d,b,o,p,f);i=e;return}function gn(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0;b=i;i=i+40|0;g=b;j=b+16|0;k=b+32|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+32|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+32|0;t=i;i=i+32|0;u=o+16|0;c[n>>2]=2;ST(u,1,n);c[m>>2]=2;ST(u,1,m);if((HS(f,1)|0)==2){m=p;n=j;v=f;c[n+0>>2]=c[v+0>>2];c[n+4>>2]=c[v+4>>2];c[n+8>>2]=c[v+8>>2];Al(m,0,d,e,j);j=p;p=t;c[p+0>>2]=c[j+0>>2];c[p+4>>2]=c[j+4>>2];c[p+8>>2]=c[j+8>>2];c[p+12>>2]=c[j+12>>2];c[p+16>>2]=c[j+16>>2];c[p+20>>2]=c[j+20>>2];c[p+24>>2]=c[j+24>>2];c[p+28>>2]=c[j+28>>2]}else{w=1.0- +$T(f);YT(q,1,w,l);c[k>>2]=q;_T(1,r,2,f,k);k=s;f=g;q=r;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Al(k,0,d,e,g);g=s;s=t;c[s+0>>2]=c[g+0>>2];c[s+4>>2]=c[g+4>>2];c[s+8>>2]=c[g+8>>2];c[s+12>>2]=c[g+12>>2];c[s+16>>2]=c[g+16>>2];c[s+20>>2]=c[g+20>>2];c[s+24>>2]=c[g+24>>2];c[s+28>>2]=c[g+28>>2]}h[o>>3]=+h[t>>3];h[o+8>>3]=+h[t+8>>3];TT(t+16|0,u);u=o;o=a;c[o+0>>2]=c[u+0>>2];c[o+4>>2]=c[u+4>>2];c[o+8>>2]=c[u+8>>2];c[o+12>>2]=c[u+12>>2];c[o+16>>2]=c[u+16>>2];c[o+20>>2]=c[u+20>>2];c[o+24>>2]=c[u+24>>2];c[o+28>>2]=c[u+28>>2];i=b;return}function hn(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;var e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;b=i;i=i+32|0;e=b;f=b+8|0;g=b+16|0;j=b+24|0;Zm(e,0,c);k=+h[e>>3];en(f,0,c);l=+h[f>>3];jn(g,0,c,d);m=+h[g>>3];kn(j,0,c,d);an(a,0,k,l,c+-273.16,1.0,m,+h[j>>3],d,0.0);i=b;return}function jn(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0.0,T=0.0,U=0.0,V=0.0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+16|0;O=i;i=i+16|0;P=1.0-d/647.096;Q=-e/647.096;c[M>>2]=6;ST(N,1,M);M=N;R=9280;c[M+0>>2]=c[R+0>>2];c[M+4>>2]=c[R+4>>2];c[M+8>>2]=c[R+8>>2];c[L>>2]=6;ST(O,1,L);L=O;R=9296;c[L+0>>2]=c[R+0>>2];c[L+4>>2]=c[R+4>>2];c[L+8>>2]=c[R+8>>2];c[K>>2]=1;S=+h[(ZT(N,1,K)|0)>>3];c[J>>2]=1;T=S*+W(+P,+(+h[(ZT(O,1,J)|0)>>3]));c[I>>2]=2;S=+h[(ZT(N,1,I)|0)>>3];c[H>>2]=2;U=S*+W(+P,+(+h[(ZT(O,1,H)|0)>>3]));c[G>>2]=3;S=+h[(ZT(N,1,G)|0)>>3];c[F>>2]=3;V=S*+W(+P,+(+h[(ZT(O,1,F)|0)>>3]));c[E>>2]=4;S=+h[(ZT(N,1,E)|0)>>3];c[D>>2]=4;X=S*+W(+P,+(+h[(ZT(O,1,D)|0)>>3]));c[C>>2]=5;S=+h[(ZT(N,1,C)|0)>>3];c[B>>2]=5;Y=S*+W(+P,+(+h[(ZT(O,1,B)|0)>>3]));c[A>>2]=6;S=+h[(ZT(N,1,A)|0)>>3];c[z>>2]=6;Z=T+(U+(V+(X+(Y+S*+W(+P,+(+h[(ZT(O,1,z)|0)>>3]))))));S=647.096/d;Y=+ca(+(S*Z));c[y>>2]=1;X=+h[(ZT(N,1,y)|0)>>3];c[x>>2]=1;V=+W(+P,+(+h[(ZT(O,1,x)|0)>>3]+-1.0));c[w>>2]=1;U=X*V*Q*+h[(ZT(O,1,w)|0)>>3];c[v>>2]=2;V=+h[(ZT(N,1,v)|0)>>3];c[u>>2]=2;X=+W(+P,+(+h[(ZT(O,1,u)|0)>>3]+-1.0));c[t>>2]=2;T=V*X*Q*+h[(ZT(O,1,t)|0)>>3];c[s>>2]=3;X=+h[(ZT(N,1,s)|0)>>3];c[r>>2]=3;V=+W(+P,+(+h[(ZT(O,1,r)|0)>>3]+-1.0));c[q>>2]=3;_=X*V*Q*+h[(ZT(O,1,q)|0)>>3];c[p>>2]=4;V=+h[(ZT(N,1,p)|0)>>3];c[o>>2]=4;X=+W(+P,+(+h[(ZT(O,1,o)|0)>>3]+-1.0));c[n>>2]=4;$=V*X*Q*+h[(ZT(O,1,n)|0)>>3];c[m>>2]=5;X=+h[(ZT(N,1,m)|0)>>3];c[l>>2]=5;V=+W(+P,+(+h[(ZT(O,1,l)|0)>>3]+-1.0));c[k>>2]=5;aa=X*V*Q*+h[(ZT(O,1,k)|0)>>3];c[j>>2]=6;V=+h[(ZT(N,1,j)|0)>>3];c[g>>2]=6;X=+W(+P,+(+h[(ZT(O,1,g)|0)>>3]+-1.0));c[f>>2]=6;h[a>>3]=Y*(S*(U+(T+(_+($+(aa+V*X*Q*+h[(ZT(O,1,f)|0)>>3])))))-Z*e/(d*d)*647.096)*22064.0e3;i=b;return}function kn(a,b,d,e){a=a|0;b=b|0;d=+d;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=d/273.16;d=e/273.16;c[u>>2]=2;ST(v,1,u);u=v;y=9752;c[u+0>>2]=c[y+0>>2];c[u+4>>2]=c[y+4>>2];c[u+8>>2]=c[y+8>>2];c[t>>2]=2;ST(w,1,t);t=w;y=9768;c[t+0>>2]=c[y+0>>2];c[t+4>>2]=c[y+4>>2];c[t+8>>2]=c[y+8>>2];c[s>>2]=1;e=+h[(ZT(v,1,s)|0)>>3];c[r>>2]=2;z=+h[(ZT(v,1,r)|0)>>3];c[q>>2]=1;A=+h[(ZT(v,1,q)|0)>>3];c[p>>2]=1;B=-(A*+W(+x,+(+h[(ZT(w,1,p)|0)>>3])));c[o>>2]=2;A=+h[(ZT(v,1,o)|0)>>3];c[n>>2]=2;C=+ca(+(e+(z+(B-A*+W(+x,+(+h[(ZT(w,1,n)|0)>>3]))))));c[m>>2]=1;A=+h[(ZT(v,1,m)|0)>>3];c[l>>2]=1;B=+W(+x,+(+h[(ZT(w,1,l)|0)>>3]+-1.0));c[k>>2]=1;z=-(A*B*d*+h[(ZT(w,1,k)|0)>>3]);c[j>>2]=2;B=+h[(ZT(v,1,j)|0)>>3];c[g>>2]=2;A=+W(+x,+(+h[(ZT(w,1,g)|0)>>3]+-1.0));c[f>>2]=2;h[a>>3]=C*(z-B*A*d*+h[(ZT(w,1,f)|0)>>3])*611.657;i=b;return}function ln(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;i=i+72|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+32|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+32|0;w=i;i=i+32|0;x=i;i=i+8|0;y=i;i=i+8|0;z=r+16|0;c[q>>2]=2;ST(z,1,q);c[p>>2]=2;ST(z,1,p);if((HS(f,1)|0)==2){p=m;q=f;c[p+0>>2]=c[q+0>>2];c[p+4>>2]=c[q+4>>2];c[p+8>>2]=c[q+8>>2];Tm(x,b,d,e,m);A=+h[x>>3];x=s;m=l;q=f;c[m+0>>2]=c[q+0>>2];c[m+4>>2]=c[q+4>>2];c[m+8>>2]=c[q+8>>2];Al(x,0,d,A,l);l=s;s=w;c[s+0>>2]=c[l+0>>2];c[s+4>>2]=c[l+4>>2];c[s+8>>2]=c[l+8>>2];c[s+12>>2]=c[l+12>>2];c[s+16>>2]=c[l+16>>2];c[s+20>>2]=c[l+20>>2];c[s+24>>2]=c[l+24>>2];c[s+28>>2]=c[l+28>>2];B=w;C=B;D=+h[C>>3];E=r;F=E;h[F>>3]=D;G=w;H=G+8|0;I=H;J=+h[I>>3];K=r;L=K+8|0;M=L;h[M>>3]=J;N=w;O=N+16|0;P=O;TT(P,z);Q=r;R=a;c[R+0>>2]=c[Q+0>>2];c[R+4>>2]=c[Q+4>>2];c[R+8>>2]=c[Q+8>>2];c[R+12>>2]=c[Q+12>>2];c[R+16>>2]=c[Q+16>>2];c[R+20>>2]=c[Q+20>>2];c[R+24>>2]=c[Q+24>>2];c[R+28>>2]=c[Q+28>>2];i=g;return}else{l=k;s=f;c[l+0>>2]=c[s+0>>2];c[l+4>>2]=c[s+4>>2];c[l+8>>2]=c[s+8>>2];Tm(y,b,d,e,k);e=+h[y>>3];A=1.0- +$T(f);YT(t,1,A,o);c[n>>2]=t;_T(1,u,2,f,n);n=v;f=j;t=u;c[f+0>>2]=c[t+0>>2];c[f+4>>2]=c[t+4>>2];c[f+8>>2]=c[t+8>>2];Al(n,0,d,e,j);j=v;v=w;c[v+0>>2]=c[j+0>>2];c[v+4>>2]=c[j+4>>2];c[v+8>>2]=c[j+8>>2];c[v+12>>2]=c[j+12>>2];c[v+16>>2]=c[j+16>>2];c[v+20>>2]=c[j+20>>2];c[v+24>>2]=c[j+24>>2];c[v+28>>2]=c[j+28>>2];B=w;C=B;D=+h[C>>3];E=r;F=E;h[F>>3]=D;G=w;H=G+8|0;I=H;J=+h[I>>3];K=r;L=K+8|0;M=L;h[M>>3]=J;N=w;O=N+16|0;P=O;TT(P,z);Q=r;R=a;c[R+0>>2]=c[Q+0>>2];c[R+4>>2]=c[Q+4>>2];c[R+8>>2]=c[Q+8>>2];c[R+12>>2]=c[Q+12>>2];c[R+16>>2]=c[Q+16>>2];c[R+20>>2]=c[Q+20>>2];c[R+24>>2]=c[Q+24>>2];c[R+28>>2]=c[Q+28>>2];i=g;return}}function mn(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+80|0;h=g;j=g+32|0;k=g+48|0;l=j;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];gn(k,0,d,e,j);j=a;a=h;m=k;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];c[a+12>>2]=c[m+12>>2];c[a+16>>2]=c[m+16>>2];c[a+20>>2]=c[m+20>>2];c[a+24>>2]=c[m+24>>2];c[a+28>>2]=c[m+28>>2];fn(j,b,h);i=g;return}function nn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;c[g>>2]=1;j=+h[(ZT(d,1,g)|0)>>3];g=HS(d,1)|0;if((g|0)<2){k=j;l=a;m=l;h[m>>3]=k;i=b;return}if((Sm(2,2,g)|0)==0){k=j;l=a;m=l;h[m>>3]=k;i=b;return}else{n=2;o=j}while(1){c[f>>2]=n;j=o*e+ +h[(ZT(d,1,f)|0)>>3];p=n+1|0;if((Sm(p,2,g)|0)==0){k=j;break}else{o=j;n=p}}l=a;m=l;h[m>>3]=k;i=b;return}function on(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=+e;f=+f;var g=0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0.0,s=0;b=i;i=i+8|0;g=b;j=i;i=i+8|0;k=HS(d,1)|0;c[j>>2]=1;l=+h[(ZT(d,1,j)|0)>>3]*+(k+ -1|0);j=HS(d,1)|0;m=j+ -1|0;if((j|0)<3){n=l;o=n*f;p=a;q=p;h[q>>3]=o;i=b;return}if((Sm(2,2,m)|0)==0){n=l;o=n*f;p=a;q=p;h[q>>3]=o;i=b;return}else{r=l;s=2}while(1){c[g>>2]=s;l=r*e+ +(k-s|0)*+h[(ZT(d,1,g)|0)>>3];j=s+1|0;if((Sm(j,2,m)|0)==0){n=l;break}else{s=j;r=l}}o=n*f;p=a;q=p;h[q>>3]=o;i=b;return}function pn(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;d=i;i=i+8|0;h=d;qn(h,0,e,f,g);a[b]=(c[h>>2]|0)==2|0;i=d;return}function qn(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;b=i;c[a>>2]=pL(d,e,f<<24>>24)|0;i=b;return}function rn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;b=i;i=i+40|0;d=b;e=b+16|0;f=b+32|0;g=i;i=i+8|0;j=i;i=i+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+8|0;RS(4,0,11424,x);x=w;h[k>>3]=0.0;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];YT(z,2,0.0,w);w=v;h[k>>3]=0.0;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];YT(A,2,32400.0,v);v=u;h[k>>3]=10.0;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(B,2,32400.0,u);u=t;h[k>>3]=10.0;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];YT(C,2,39600.0,t);t=s;h[k>>3]=2.0;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];YT(D,2,39600.0,s);s=r;h[k>>3]=2.0;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];YT(E,2,46800.0,r);r=q;h[k>>3]=15.0;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];YT(F,2,46800.0,q);q=p;h[k>>3]=15.0;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];YT(G,2,54.0e3,p);p=o;h[k>>3]=5.0;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(H,2,54.0e3,o);o=n;h[k>>3]=5.0;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];YT(I,2,64800.0,n);n=m;h[k>>3]=0.0;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(J,2,64800.0,m);m=l;h[k>>3]=0.0;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(K,2,86400.0,l);c[j>>2]=A;c[j+4>>2]=B;c[j+8>>2]=C;c[j+12>>2]=D;c[j+16>>2]=E;c[j+20>>2]=F;c[j+24>>2]=G;c[j+28>>2]=H;c[j+32>>2]=I;c[j+36>>2]=J;c[j+40>>2]=K;XT(y,12,z,j);$S(L,1,2,g);g=c[a+536>>2]|0;j=e;z=y;c[j+0>>2]=c[z+0>>2];c[j+4>>2]=c[z+4>>2];c[j+8>>2]=c[z+8>>2];z=d;j=L;c[z+0>>2]=c[j+0>>2];c[z+4>>2]=c[j+4>>2];c[z+8>>2]=c[j+8>>2];j=11464;Bl(M,g,j,j,e,0.0,d,1,2);c[c[a+320>>2]>>2]=c[M>>2];RS(4,0,11472,f);i=b;return}function sn(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+320|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}Ll(c[a+536>>2]|0,c[e>>2]|0);Ola(c[d>>2]|0);c[d>>2]=0;i=b;return}function tn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;jm(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+248>>3]*.999;l=j;m=l+2184|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;rm(e,c[f>>2]|0,+h[d+64>>3],+h[d+232>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+2184|0;n=m;h[n>>3]=k;i=b;return}}function un(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1216>>3];k=+yd(1.0e-13,+(+h[g+80>>3]-j));l=+h[g+1872>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,11536,11528,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2032|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+80>>3]- +h[f+1216>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1216>>3];j=+h[x+80>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2136>>3];k=+h[x+1872>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+248>>3]- +h[x+2184>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+248>>3]- +h[x+2184>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+248>>3]- +h[x+2184>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+248>>3]- +h[x+2184>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,11608,11528,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1872>>3];C=+h[L+1216>>3];D=+h[L+80>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+2184>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,11536,11528,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2032|0;w=v;h[w>>3]=n;i=d;return}function vn(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+72>>3]- +h[a+1232>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+2176|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+240>>3]- +h[a+2032>>3];g=a;j=g+2176|0;k=j;h[k>>3]=f;i=b;return}function wn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[b+240>>3]- +h[b+2176>>3];i=i;return}function xn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1248>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+2176>>3];o=+h[g+2136>>3]*k+ +h[g+1872>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,11752,11744,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+2176>>3];q=+h[v+1248>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+2024>>3]*(1.0-q)+ +h[r+1240>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+2168|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+2168|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,11752,11744,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+2168|0;C=B;h[C>>3]=z;i=d;return}function yn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,11808,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}cm(t,c[ib>>2]|0,jb);jb=+h[t>>3];pm(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);jb=+h[v>>3];cm(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);pb=+h[w>>3];pm(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+72>>3];qb=+yd(1.0e-13,+(+h[w+80>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,11880,11800,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{cm(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);sb=+h[z>>3];pm(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);sb=+h[B>>3];cm(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);jb=+h[C>>3];pm(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+80>>3]- +h[E>>3]));pb=1.0- +h[C+72>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,11880,11800,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{cm(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);vb=+h[F>>3];pm(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);vb=+h[H>>3];cm(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);sb=+h[I>>3];pm(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);sb=+h[K>>3];cm(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);jb=+h[L>>3];pm(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+80>>3]- +h[N>>3])|0)<<24>>24==0){cm(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);jb=+h[O>>3];pm(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Q,c[ib>>2]|0,+h[P+64>>3],+h[P+232>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(R,c[ib>>2]|0,+h[Q+64>>3],+h[Q+232>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(S,c[ib>>2]|0,jb,pb,+h[Q+64>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+232>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+248>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}cm(T,c[ib>>2]|0,+h[xb+64>>3]);qb=+h[T>>3];pm(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);qb=+h[V>>3];cm(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);pb=+h[W>>3];pm(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);pb=+h[Y>>3];cm(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);jb=+h[Z>>3];pm(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm($,c[ib>>2]|0,+h[_+64>>3],+h[_+232>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(aa,c[ib>>2]|0,+h[$+64>>3],+h[$+232>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(ba,c[ib>>2]|0,jb,rb,+h[$+64>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+232>>3],0.0);zb=+h[ba>>3];cm(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);rb=+h[ca>>3];pm(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+80>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+240>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+72>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,12192,11800,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+72>>3];Cb=+h[ca+80>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,11880,11800,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+240>>3]-wb}wb=+h[tb+64>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,11808,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,11808,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}cm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];pm(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Hb=+h[ia>>3];cm(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Fb=+h[ja>>3];pm(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,11808,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,11808,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,11808,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}qb=Kb+-273.15;dm(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];cm(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[na>>3];pm(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);qb=+h[pa>>3];cm(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Eb=+h[qa>>3];pm(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+72>>3];rb=+yd(1.0e-13,+(+h[qa+80>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,11880,11800,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{cm(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Lb=+h[ta>>3];pm(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Lb=+h[va>>3];cm(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[wa>>3];pm(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+80>>3]- +h[ya>>3]));Eb=1.0- +h[wa+72>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,11880,11800,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{cm(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Ob=+h[za>>3];pm(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Ob=+h[Ba>>3];cm(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Lb=+h[Ca>>3];pm(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Lb=+h[Ea>>3];cm(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[Fa>>3];pm(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+80>>3]- +h[Ha>>3])|0)<<24>>24==0){cm(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[Ia>>3];pm(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Ka,c[ib>>2]|0,+h[Ja+64>>3],+h[Ja+232>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(La,c[ib>>2]|0,+h[Ka+64>>3],+h[Ka+232>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+64>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+232>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+248>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}cm(Na,c[ib>>2]|0,+h[Qb+64>>3]);rb=+h[Na>>3];pm(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);rb=+h[Pa>>3];cm(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Eb=+h[Qa>>3];pm(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Eb=+h[Sa>>3];cm(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[Ta>>3];pm(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Va,c[ib>>2]|0,+h[Ua+64>>3],+h[Ua+232>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(Wa,c[ib>>2]|0,+h[Va+64>>3],+h[Va+232>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Xa,c[ib>>2]|0,qb,Bb,+h[Va+64>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+232>>3],0.0);Cb=+h[Xa>>3];cm(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Bb=+h[Ya>>3];pm(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+80>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+240>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+72>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,12192,11800,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+72>>3];Tb=+h[Ya+80>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,11880,11800,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+240>>3]-Pb}Pb=+h[Mb+64>>3];Wb=Pb+-273.15;Cb=+h[Mb+232>>3];om($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];cm(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Pb=+h[ab>>3];pm(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Pb=+h[cb>>3];cm(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Wb=+h[db>>3];pm(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+64>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,12816,11800,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+64>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+240>>3]-ub);ub=+h[Yb+232>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,12816,11800,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+232>>3];ac=+h[Yb+64>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+72>>3];Gb=+yd(1.0e-13,+(+h[Yb+80>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,11880,11800,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+64>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,12816,11800,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+64>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+240>>3];ic=+h[gc+232>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,12816,11800,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+232>>3];kc=+h[gc+64>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+72>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+80>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2272|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2272|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,11880,11800,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2272|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function zn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+3552>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+3528>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+3536>>3];h[a+8>>3]=+h[d+3328>>3];h[e+8>>3]=+h[d+3304>>3];h[f+8>>3]=+h[d+3312>>3];i=i;return}function An(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+248>>3]=+h[b>>3];h[a+232>>3]=+h[b+8>>3];tn(f);un(f);vn(f);wn(f);xn(f);yn(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1280|0;j=+h[g>>3];b=f+64|0;k=+h[b>>3];l=j*k;a=f+232|0;m=f+2168|0;h[d>>3]=+h[f+2280>>3]*l*l+(+h[f+80>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+248>>3]);h[d+8>>3]=+h[f+2016>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+2272>>3]));i=e;return}function Bn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;jm(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+272>>3]*.999;l=j;m=l+2160|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;rm(e,c[f>>2]|0,+h[d+88>>3],+h[d+256>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+2160|0;n=m;h[n>>3]=k;i=b;return}}function Cn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1328>>3];k=+yd(1.0e-13,+(+h[g+104>>3]-j));l=+h[g+1880>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,12848,12840,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2008|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+104>>3]- +h[f+1328>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1328>>3];j=+h[x+104>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2128>>3];k=+h[x+1880>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+272>>3]- +h[x+2160>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+272>>3]- +h[x+2160>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+272>>3]- +h[x+2160>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+272>>3]- +h[x+2160>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,12920,12840,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1880>>3];C=+h[L+1328>>3];D=+h[L+104>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+2160>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,12848,12840,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2008|0;w=v;h[w>>3]=n;i=d;return}function Dn(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+96>>3]- +h[a+1344>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+2152|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+264>>3]- +h[a+2008>>3];g=a;j=g+2152|0;k=j;h[k>>3]=f;i=b;return}function En(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+264>>3]- +h[b+2152>>3];i=i;return}function Fn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1360>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+2152>>3];o=+h[g+2128>>3]*k+ +h[g+1880>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,13064,13056,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+2152>>3];q=+h[v+1360>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+2e3>>3]*(1.0-q)+ +h[r+1352>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+2144|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+2144|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,13064,13056,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+2144|0;C=B;h[C>>3]=z;i=d;return}function Gn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,13120,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}cm(t,c[ib>>2]|0,jb);jb=+h[t>>3];pm(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);jb=+h[v>>3];cm(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);pb=+h[w>>3];pm(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+96>>3];qb=+yd(1.0e-13,+(+h[w+104>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,13192,13112,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{cm(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);sb=+h[z>>3];pm(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);sb=+h[B>>3];cm(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);jb=+h[C>>3];pm(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+104>>3]- +h[E>>3]));pb=1.0- +h[C+96>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,13192,13112,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{cm(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);vb=+h[F>>3];pm(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);vb=+h[H>>3];cm(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);sb=+h[I>>3];pm(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);sb=+h[K>>3];cm(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);jb=+h[L>>3];pm(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+104>>3]- +h[N>>3])|0)<<24>>24==0){cm(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);jb=+h[O>>3];pm(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Q,c[ib>>2]|0,+h[P+88>>3],+h[P+256>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(R,c[ib>>2]|0,+h[Q+88>>3],+h[Q+256>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(S,c[ib>>2]|0,jb,pb,+h[Q+88>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+256>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+272>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}cm(T,c[ib>>2]|0,+h[xb+88>>3]);qb=+h[T>>3];pm(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);qb=+h[V>>3];cm(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);pb=+h[W>>3];pm(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);pb=+h[Y>>3];cm(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);jb=+h[Z>>3];pm(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm($,c[ib>>2]|0,+h[_+88>>3],+h[_+256>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(aa,c[ib>>2]|0,+h[$+88>>3],+h[$+256>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(ba,c[ib>>2]|0,jb,rb,+h[$+88>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+256>>3],0.0);zb=+h[ba>>3];cm(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);rb=+h[ca>>3];pm(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+104>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+264>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+96>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,13504,13112,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+96>>3];Cb=+h[ca+104>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,13192,13112,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+264>>3]-wb}wb=+h[tb+88>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,13120,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,13120,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}cm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];pm(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Hb=+h[ia>>3];cm(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Fb=+h[ja>>3];pm(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,13120,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,13120,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,13120,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}qb=Kb+-273.15;dm(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];cm(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[na>>3];pm(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);qb=+h[pa>>3];cm(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Eb=+h[qa>>3];pm(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+96>>3];rb=+yd(1.0e-13,+(+h[qa+104>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,13192,13112,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{cm(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Lb=+h[ta>>3];pm(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Lb=+h[va>>3];cm(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[wa>>3];pm(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+104>>3]- +h[ya>>3]));Eb=1.0- +h[wa+96>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,13192,13112,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{cm(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Ob=+h[za>>3];pm(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Ob=+h[Ba>>3];cm(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Lb=+h[Ca>>3];pm(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Lb=+h[Ea>>3];cm(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[Fa>>3];pm(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+104>>3]- +h[Ha>>3])|0)<<24>>24==0){cm(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[Ia>>3];pm(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Ka,c[ib>>2]|0,+h[Ja+88>>3],+h[Ja+256>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(La,c[ib>>2]|0,+h[Ka+88>>3],+h[Ka+256>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+88>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+256>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+272>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}cm(Na,c[ib>>2]|0,+h[Qb+88>>3]);rb=+h[Na>>3];pm(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);rb=+h[Pa>>3];cm(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Eb=+h[Qa>>3];pm(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Eb=+h[Sa>>3];cm(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[Ta>>3];pm(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Va,c[ib>>2]|0,+h[Ua+88>>3],+h[Ua+256>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(Wa,c[ib>>2]|0,+h[Va+88>>3],+h[Va+256>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Xa,c[ib>>2]|0,qb,Bb,+h[Va+88>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+256>>3],0.0);Cb=+h[Xa>>3];cm(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Bb=+h[Ya>>3];pm(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+104>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+264>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+96>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,13504,13112,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+96>>3];Tb=+h[Ya+104>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,13192,13112,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+264>>3]-Pb}Pb=+h[Mb+88>>3];Wb=Pb+-273.15;Cb=+h[Mb+256>>3];om($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];cm(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Pb=+h[ab>>3];pm(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Pb=+h[cb>>3];cm(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Wb=+h[db>>3];pm(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+88>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,14128,13112,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+88>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+264>>3]-ub);ub=+h[Yb+256>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,14128,13112,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+256>>3];ac=+h[Yb+88>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+96>>3];Gb=+yd(1.0e-13,+(+h[Yb+104>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,13192,13112,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+88>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,14128,13112,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+88>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+264>>3];ic=+h[gc+256>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,14128,13112,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+256>>3];kc=+h[gc+88>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+96>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+104>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2256|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2256|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,13192,13112,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2256|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function Hn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+3888>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+3864>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+3872>>3];h[a+8>>3]=+h[d+3664>>3];h[e+8>>3]=+h[d+3640>>3];h[f+8>>3]=+h[d+3648>>3];i=i;return}function In(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+272>>3]=+h[b>>3];h[a+256>>3]=+h[b+8>>3];Bn(f);Cn(f);Dn(f);En(f);Fn(f);Gn(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1392|0;j=+h[g>>3];b=f+88|0;k=+h[b>>3];l=j*k;a=f+256|0;m=f+2144|0;h[d>>3]=+h[f+2264>>3]*l*l+(+h[f+104>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+272>>3]);h[d+8>>3]=+h[f+1992>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+2256>>3]));i=e;return}function Jn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+1112>>3];p=f;h[k>>3]=+h[n+1120>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+1128>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+832>>3]=+h[l>>3];i=b;return}function Kn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+1112>>3];v=l;h[k>>3]=+h[t+1120>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+160>>3];w=+h[t+1128>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+8>>3];f=j;h[k>>3]=+h[q+1136>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+16>>3];y=+h[f>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+696>>3]=+h[d+504>>3]*(w- +h[r>>3])*+h[d+1440>>3];i=b;return}function Ln(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+504>>3]*+h[e+1440>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+696>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+640|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+640|0;q=p;h[q>>3]=n;i=d;return}k=l/+XS(c[b+536>>2]|0,f,14160,14152,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+640|0;q=p;h[q>>3]=n;i=d;return}function Mn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+1112>>3];p=f;h[k>>3]=+h[n+1120>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+1128>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+776>>3]=+h[l>>3];i=b;return}function Nn(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0;d=i;i=i+8|0;e=d;f=b+304|0;g=+h[f>>3];j=b+536|0;k=b+4|0;l=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;o=+h[n+536>>3];_l(e,c[j>>2]|0,+h[l+640>>3],+h[l+824>>3],+h[l+832>>3],+h[l+768>>3],+h[l+776>>3],+h[l+3152>>3],+h[n+520>>3],+h[l+2680>>3]*+h[n+1504>>3],(o+o)*.5,+h[n+1496>>3]/3.0,+h[n+1464>>3]);n=c[m>>2]|0;o=g*+h[e>>3]*+h[n+1440>>3];g=1.0- +h[f>>3];f=c[c[k>>2]>>2]|0;e=c[f+8>>2]|0;p=+h[e+640>>3]- +h[e+2680>>3]*+h[n+1504>>3]*+h[n+1520>>3];q=+h[n+1472>>3];r=+h[n+1480>>3];if(q!=0.0){s=e;t=r/q;u=p*t;v=g*u;w=o+v;x=s;y=x+944|0;z=y;h[z>>3]=w;i=d;return}if(r==0.0){s=e;t=r;u=p*t;v=g*u;w=o+v;x=s;y=x+944|0;z=y;h[z>>3]=w;i=d;return}A=r/+XS(c[j>>2]|0,q,14224,14216,+h[f>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[k>>2]>>2]|0)+8>>2]|0;t=A;u=p*t;v=g*u;w=o+v;x=s;y=x+944|0;z=y;h[z>>3]=w;i=d;return}function On(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+15872>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+15848>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+15856>>3];h[a+8>>3]=+h[d+15760>>3];h[e+8>>3]=+h[d+15736>>3];h[f+8>>3]=+h[d+15744>>3];h[a+16>>3]=+h[d+15648>>3];h[e+16>>3]=+h[d+15624>>3];h[f+16>>3]=+h[d+15632>>3];i=i;return}function Pn(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0;f=i;i=i+120|0;g=f;j=f+96|0;l=f+112|0;m=i;i=i+48|0;n=i;i=i+8|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+96|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+8|0;x=b;y=b+4|0;z=c[(c[c[y>>2]>>2]|0)+8>>2]|0;h[z+1128>>3]=+h[d>>3];h[z+1120>>3]=+h[d+8>>3];h[z+1112>>3]=+h[d+16>>3];Jn(x);Kn(x);Ln(x);Mn(x);Nn(x);x=c[c[y>>2]>>2]|0;d=c[x+8>>2]|0;A=+h[d+1120>>3];z=d+944|0;B=+yd(+-+h[z>>3],1.0e-15);C=d+136|0;h[e>>3]=A*(B+1.0e-15)+(B*+h[C>>3]-B)+-9.900000000000001e-16;B=+h[d+1112>>3];A=+yd(+-+h[z>>3],1.0e-15);h[e+8>>3]=B*(A+1.0e-15)-A*+h[C>>3]+-1.0e-17;A=+yd(+-+h[z>>3],1.0e-15);B=A+1.0e-15;D=A*+h[C>>3]+1.0e-17;do{if(B!=0.0){E=D/B}else{if(D==0.0){E=D;break}E=D/+XS(c[b+536>>2]|0,B,14264,14256,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);YT(q,1,E,p);p=o;h[k>>3]=575.573102;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+8|0;h[k>>3]=.931782653;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+16|0;h[k>>3]=.00722271286;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+24|0;h[k>>3]=-734255737.0e-14;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+32|0;h[k>>3]=4.95504349e-9;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+40|0;h[k>>3]=-1.336933246e-12;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(s,7,-39479.6083,o);o=n;h[k>>3]=17.24205775;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];YT(t,2,-33039.7431,n);n=m;h[k>>3]=-2412.698562;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+8|0;h[k>>3]=4.64611078;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+16|0;h[k>>3]=.002291998307;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+24|0;h[k>>3]=-6.836830479999999e-7;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+32|0;h[k>>3]=9.426468930000001e-11;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+40|0;h[k>>3]=-4.82238053e-15;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(u,7,1034972.096,m);m=l;h[k>>3]=-7.97814851;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(v,2,-13842.86509,l);c[r>>2]=14304;h[r+8>>3]=.01801528;h[r+16>>3]=-13423382.81725291;h[r+24>>3]=549760.6476280135;h[r+32>>3]=1.0e3;l=r+40|0;m=s;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=r+52|0;l=t;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];l=r+64|0;m=u;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=r+76|0;l=v;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];h[r+88>>3]=461.5233290850878;l=c[b+536>>2]|0;m=c[c[y>>2]>>2]|0;v=c[m+8>>2]|0;E=+yd(+-+h[v+944>>3],1.0e-15);B=E+1.0e-15;D=E*+h[v+3552>>3]+4.52632387446934e-11;do{if(B!=0.0){F=v;G=D/B}else{if(D==0.0){F=v;G=D;break}E=D/+XS(l,B,14264,14256,+h[m>>3],(a[b+319|0]|0)!=0|0);F=c[(c[c[y>>2]>>2]|0)+8>>2]|0;G=E}}while(0);B=+h[F+160>>3];F=j;b=q;c[F+0>>2]=c[b+0>>2];c[F+4>>2]=c[b+4>>2];c[F+8>>2]=c[b+8>>2];b=g+0|0;F=r+0|0;r=b+96|0;do{c[b>>2]=c[F>>2];b=b+4|0;F=F+4|0}while((b|0)<(r|0));em(w,l,G,190.0,647.0,B,j,g,1.0e-13);h[e+16>>3]=+h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+1128>>3]- +h[w>>3];i=f;return}function Qn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;jm(d,c[f>>2]|0,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+184>>3]*.999;l=j;m=l+2248|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;rm(e,c[f>>2]|0,+h[d>>3],+h[d+168>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+2248|0;n=m;h[n>>3]=k;i=b;return}}function Rn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+392>>3];k=+yd(1.0e-13,+(+h[g+16>>3]-j));l=+h[g+1136>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,14320,14312,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2080|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+16>>3]- +h[f+392>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+392>>3];j=+h[x+16>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2200>>3];k=+h[x+1136>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+184>>3]- +h[x+2248>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+184>>3]- +h[x+2248>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+184>>3]- +h[x+2248>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+184>>3]- +h[x+2248>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,14384,14312,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1136>>3];C=+h[L+392>>3];D=+h[L+16>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+2248>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,14320,14312,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2080|0;w=v;h[w>>3]=n;i=d;return}function Sn(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+8>>3]- +h[a+408>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+2240|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+176>>3]- +h[a+2080>>3];g=a;j=g+2240|0;k=j;h[k>>3]=f;i=b;return}function Tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+176>>3]- +h[b+2240>>3];i=i;return}function Un(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+2240>>3];o=+h[g+2200>>3]*k+ +h[g+1136>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,14528,14520,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+2240>>3];q=+h[v+424>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+2072>>3]*(1.0-q)+ +h[r+416>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+2232|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+2232|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,14528,14520,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+2232|0;C=B;h[C>>3]=z;i=d;return}



function vo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,11808,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}cm(t,c[ib>>2]|0,jb);jb=+h[t>>3];pm(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);jb=+h[v>>3];cm(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);pb=+h[w>>3];pm(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+72>>3];qb=+yd(1.0e-13,+(+h[w+80>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,11880,18216,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{cm(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);sb=+h[z>>3];pm(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);sb=+h[B>>3];cm(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);jb=+h[C>>3];pm(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+80>>3]- +h[E>>3]));pb=1.0- +h[C+72>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,11880,18216,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{cm(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);vb=+h[F>>3];pm(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);vb=+h[H>>3];cm(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);sb=+h[I>>3];pm(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);sb=+h[K>>3];cm(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);jb=+h[L>>3];pm(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+80>>3]- +h[N>>3])|0)<<24>>24==0){cm(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);jb=+h[O>>3];pm(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Q,c[ib>>2]|0,+h[P+64>>3],+h[P+232>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(R,c[ib>>2]|0,+h[Q+64>>3],+h[Q+232>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(S,c[ib>>2]|0,jb,pb,+h[Q+64>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+232>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+248>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}cm(T,c[ib>>2]|0,+h[xb+64>>3]);qb=+h[T>>3];pm(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);qb=+h[V>>3];cm(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);pb=+h[W>>3];pm(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);pb=+h[Y>>3];cm(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);jb=+h[Z>>3];pm(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm($,c[ib>>2]|0,+h[_+64>>3],+h[_+232>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(aa,c[ib>>2]|0,+h[$+64>>3],+h[$+232>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(ba,c[ib>>2]|0,jb,rb,+h[$+64>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+232>>3],0.0);zb=+h[ba>>3];cm(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);rb=+h[ca>>3];pm(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+80>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+240>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+72>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,12192,18216,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+72>>3];Cb=+h[ca+80>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,11880,18216,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+240>>3]-wb}wb=+h[tb+64>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,11808,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,11808,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}cm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];pm(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Hb=+h[ia>>3];cm(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Fb=+h[ja>>3];pm(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,11808,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,11808,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,11808,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]}qb=Kb+-273.15;dm(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];cm(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[na>>3];pm(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);qb=+h[pa>>3];cm(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Eb=+h[qa>>3];pm(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+72>>3];rb=+yd(1.0e-13,+(+h[qa+80>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,11880,18216,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{cm(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Lb=+h[ta>>3];pm(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Lb=+h[va>>3];cm(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[wa>>3];pm(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+80>>3]- +h[ya>>3]));Eb=1.0- +h[wa+72>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,11880,18216,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{cm(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Ob=+h[za>>3];pm(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Ob=+h[Ba>>3];cm(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Lb=+h[Ca>>3];pm(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Lb=+h[Ea>>3];cm(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[Fa>>3];pm(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+80>>3]- +h[Ha>>3])|0)<<24>>24==0){cm(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[Ia>>3];pm(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Ka,c[ib>>2]|0,+h[Ja+64>>3],+h[Ja+232>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(La,c[ib>>2]|0,+h[Ka+64>>3],+h[Ka+232>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+64>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+232>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+248>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}cm(Na,c[ib>>2]|0,+h[Qb+64>>3]);rb=+h[Na>>3];pm(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);rb=+h[Pa>>3];cm(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Eb=+h[Qa>>3];pm(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Eb=+h[Sa>>3];cm(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);qb=+h[Ta>>3];pm(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Va,c[ib>>2]|0,+h[Ua+64>>3],+h[Ua+232>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(Wa,c[ib>>2]|0,+h[Va+64>>3],+h[Va+232>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Xa,c[ib>>2]|0,qb,Bb,+h[Va+64>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+232>>3],0.0);Cb=+h[Xa>>3];cm(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Bb=+h[Ya>>3];pm(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+80>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+240>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+72>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,12192,18216,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+72>>3];Tb=+h[Ya+80>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,11880,18216,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+240>>3]-Pb}Pb=+h[Mb+64>>3];Wb=Pb+-273.15;Cb=+h[Mb+232>>3];om($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];cm(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Pb=+h[ab>>3];pm(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Pb=+h[cb>>3];cm(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);Wb=+h[db>>3];pm(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]);dm(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+64>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+64>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,12816,18216,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+64>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+240>>3]-ub);ub=+h[Yb+232>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,12816,18216,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+232>>3];ac=+h[Yb+64>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+72>>3];Gb=+yd(1.0e-13,+(+h[Yb+80>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,11880,18216,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+64>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,12816,18216,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+64>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+240>>3];ic=+h[gc+232>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,12816,18216,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+232>>3];kc=+h[gc+64>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+72>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+80>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2272|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2272|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,11880,18216,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2272|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function wo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;jm(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+248>>3]*.999;l=j;m=l+2184|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;rm(e,c[f>>2]|0,+h[d+64>>3],+h[d+232>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+2184|0;n=m;h[n>>3]=k;i=b;return}}function xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1216>>3];k=+yd(1.0e-13,+(+h[g+80>>3]-j));l=+h[g+1872>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,11536,18224,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2032|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+80>>3]- +h[f+1216>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1216>>3];j=+h[x+80>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2136>>3];k=+h[x+1872>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+248>>3]- +h[x+2184>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+248>>3]- +h[x+2184>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+248>>3]- +h[x+2184>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+248>>3]- +h[x+2184>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,11608,18224,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1872>>3];C=+h[L+1216>>3];D=+h[L+80>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+2184>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,11536,18224,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2032|0;w=v;h[w>>3]=n;i=d;return}function yo(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+72>>3]- +h[a+1232>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+2176|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+240>>3]- +h[a+2032>>3];g=a;j=g+2176|0;k=j;h[k>>3]=f;i=b;return}function zo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2024>>3]=+h[b+240>>3]- +h[b+2176>>3];i=i;return}function Ao(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1248>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+2176>>3];o=+h[g+2136>>3]*k+ +h[g+1872>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,11752,18232,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+2176>>3];q=+h[v+1248>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+2024>>3]*(1.0-q)+ +h[r+1240>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+2168|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+2168|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,11752,18232,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+2168|0;C=B;h[C>>3]=z;i=d;return}function Bo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+3328>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+3304>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+3312>>3];h[a+8>>3]=+h[d+3552>>3];h[e+8>>3]=+h[d+3528>>3];h[f+8>>3]=+h[d+3536>>3];i=i;return}function Co(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+232>>3]=+h[b>>3];h[a+248>>3]=+h[b+8>>3];vo(f);wo(f);xo(f);yo(f);zo(f);Ao(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1280|0;j=+h[g>>3];b=f+64|0;k=+h[b>>3];l=j*k;a=f+232|0;m=f+2168|0;h[d>>3]=+h[f+2280>>3]*l*l+(+h[f+80>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+248>>3]);h[d+8>>3]=+h[f+2016>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+2272>>3]));i=e;return}function Do(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+1112>>3];v=l;h[k>>3]=+h[t+1120>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+160>>3];w=+h[t+1128>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+8>>3];f=j;h[k>>3]=+h[q+1136>>3];c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];YT(o,2,u,j);j=c[l>>2]|0;f=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[f+16>>3];y=+h[f>>3];f=e;q=o;c[f+0>>2]=c[q+0>>2];c[f+4>>2]=c[q+4>>2];c[f+8>>2]=c[q+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+696>>3]=+h[d+504>>3]*(w- +h[r>>3])*+h[d+1440>>3];i=b;return}function Eo(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+504>>3]*+h[e+1440>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+696>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+640|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+640|0;q=p;h[q>>3]=n;i=d;return}k=l/+XS(c[b+536>>2]|0,f,14160,18240,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+640|0;q=p;h[q>>3]=n;i=d;return}function Fo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+1112>>3];p=f;h[k>>3]=+h[n+1120>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+1128>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+776>>3]=+h[l>>3];i=b;return}function Go(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+4|0;n=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[n+1112>>3];p=f;h[k>>3]=+h[n+1120>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;a=c[f>>2]|0;p=c[(c[c[m>>2]>>2]|0)+8>>2]|0;o=+h[p+160>>3];q=+h[p+1128>>3];p=e;n=g;c[p+0>>2]=c[n+0>>2];c[p+4>>2]=c[n+4>>2];c[p+8>>2]=c[n+8>>2];Ml(j,a,o,q,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+832>>3]=+h[l>>3];i=b;return}function Ho(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=a+416|0;j=c[g>>2]|0;k=+h[j+536>>3];_l(d,c[a+536>>2]|0,+h[f+640>>3],+h[f+824>>3],+h[f+832>>3],+h[f+768>>3],+h[f+776>>3],+h[f+3152>>3],+h[j+520>>3],+h[f+2680>>3]*+h[j+1504>>3],(k+k)*.5,+h[j+1496>>3]/3.0,+h[j+1464>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3]=+h[d>>3]*+h[(c[g>>2]|0)+1440>>3];i=b;return}function Io(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+15648>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+15624>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+15632>>3];h[a+8>>3]=+h[d+15872>>3];h[e+8>>3]=+h[d+15848>>3];h[f+8>>3]=+h[d+15856>>3];h[a+16>>3]=+h[d+15760>>3];h[e+16>>3]=+h[d+15736>>3];h[f+16>>3]=+h[d+15744>>3];i=i;return}function Jo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0;f=i;i=i+120|0;g=f;j=f+96|0;l=f+112|0;m=i;i=i+48|0;n=i;i=i+8|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+96|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+8|0;x=b;y=b+4|0;z=c[(c[c[y>>2]>>2]|0)+8>>2]|0;h[z+1112>>3]=+h[d>>3];h[z+1128>>3]=+h[d+8>>3];h[z+1120>>3]=+h[d+16>>3];Do(x);Eo(x);Fo(x);Go(x);Ho(x);x=c[c[y>>2]>>2]|0;d=c[x+8>>2]|0;A=+h[d+1120>>3];z=d+944|0;B=+yd(+-+h[z>>3],1.0e-15);C=d+136|0;h[e>>3]=A*(B+1.0e-15)+(B*+h[C>>3]-B)+-9.900000000000001e-16;B=+yd(+-+h[z>>3],1.0e-15);A=B+1.0e-15;D=B*+h[C>>3]+1.0e-17;do{if(A!=0.0){E=D/A}else{if(D==0.0){E=D;break}E=D/+XS(c[b+536>>2]|0,A,14264,18248,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);YT(q,1,E,p);p=o;h[k>>3]=575.573102;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+8|0;h[k>>3]=.931782653;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+16|0;h[k>>3]=.00722271286;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+24|0;h[k>>3]=-734255737.0e-14;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+32|0;h[k>>3]=4.95504349e-9;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=o+40|0;h[k>>3]=-1.336933246e-12;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(s,7,-39479.6083,o);o=n;h[k>>3]=17.24205775;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];YT(t,2,-33039.7431,n);n=m;h[k>>3]=-2412.698562;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+8|0;h[k>>3]=4.64611078;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+16|0;h[k>>3]=.002291998307;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+24|0;h[k>>3]=-6.836830479999999e-7;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+32|0;h[k>>3]=9.426468930000001e-11;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=m+40|0;h[k>>3]=-4.82238053e-15;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(u,7,1034972.096,m);m=l;h[k>>3]=-7.97814851;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(v,2,-13842.86509,l);c[r>>2]=14304;h[r+8>>3]=.01801528;h[r+16>>3]=-13423382.81725291;h[r+24>>3]=549760.6476280135;h[r+32>>3]=1.0e3;l=r+40|0;m=s;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=r+52|0;l=t;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];l=r+64|0;m=u;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];m=r+76|0;l=v;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];h[r+88>>3]=461.5233290850878;l=c[b+536>>2]|0;m=c[c[y>>2]>>2]|0;v=c[m+8>>2]|0;E=+yd(+-+h[v+944>>3],1.0e-15);A=E+1.0e-15;D=E*+h[v+3552>>3]+4.52632387446934e-11;do{if(A!=0.0){F=v;G=D/A}else{if(D==0.0){F=v;G=D;break}E=D/+XS(l,A,14264,18248,+h[m>>3],(a[b+319|0]|0)!=0|0);F=c[(c[c[y>>2]>>2]|0)+8>>2]|0;G=E}}while(0);A=+h[F+160>>3];F=j;b=q;c[F+0>>2]=c[b+0>>2];c[F+4>>2]=c[b+4>>2];c[F+8>>2]=c[b+8>>2];b=g+0|0;F=r+0|0;r=b+96|0;do{c[b>>2]=c[F>>2];b=b+4|0;F=F+4|0}while((b|0)<(r|0));em(w,l,G,190.0,647.0,A,j,g,1.0e-13);g=c[(c[c[y>>2]>>2]|0)+8>>2]|0;h[e+8>>3]=+h[g+1128>>3]- +h[w>>3];A=+h[g+1112>>3];G=+yd(+-+h[g+944>>3],1.0e-15);h[e+16>>3]=A*(G+1.0e-15)-G*+h[g+136>>3]+-1.0e-17;i=f;return}function Ko(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,14584,s);ib=lb;jb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}cm(t,c[ib>>2]|0,jb);jb=+h[t>>3];pm(u,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(v,c[ib>>2]|0,jb,+h[u>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);jb=+h[v>>3];cm(w,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[w>>3];pm(x,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(y,c[ib>>2]|0,pb,+h[x>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+8>>3];qb=+yd(1.0e-13,+(+h[w+16>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,14656,18256,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{cm(z,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);sb=+h[z>>3];pm(A,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(B,c[ib>>2]|0,sb,+h[A>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);sb=+h[B>>3];cm(C,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[C>>3];pm(D,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(E,c[ib>>2]|0,jb,+h[D>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+16>>3]- +h[E>>3]));pb=1.0- +h[C+8>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,14656,18256,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{cm(F,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);vb=+h[F>>3];pm(G,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(H,c[ib>>2]|0,vb,+h[G>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);vb=+h[H>>3];cm(I,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);sb=+h[I>>3];pm(J,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(K,c[ib>>2]|0,sb,+h[J>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);sb=+h[K>>3];cm(L,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[L>>3];pm(M,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(N,c[ib>>2]|0,jb,+h[M>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[N>>3])|0)<<24>>24==0){cm(O,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[O>>3];pm(P,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Q,c[ib>>2]|0,+h[P>>3],+h[P+168>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(R,c[ib>>2]|0,+h[Q>>3],+h[Q+168>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(S,c[ib>>2]|0,jb,pb,+h[Q>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+168>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+184>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}cm(T,c[ib>>2]|0,+h[xb>>3]);qb=+h[T>>3];pm(U,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(V,c[ib>>2]|0,qb,+h[U>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);qb=+h[V>>3];cm(W,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[W>>3];pm(X,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Y,c[ib>>2]|0,pb,+h[X>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);pb=+h[Y>>3];cm(Z,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[Z>>3];pm(_,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm($,c[ib>>2]|0,+h[_>>3],+h[_+168>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(aa,c[ib>>2]|0,+h[$>>3],+h[$+168>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(ba,c[ib>>2]|0,jb,rb,+h[$>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+168>>3],0.0);zb=+h[ba>>3];cm(ca,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);rb=+h[ca>>3];pm(ea,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+16>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+176>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+8>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,14968,18256,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+8>>3];Cb=+h[ca+16>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,14656,18256,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+176>>3]-wb}wb=+h[tb>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,14584,r);Gb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,14584,q);Hb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}cm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];pm(ha,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Hb=+h[ia>>3];cm(ja,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Fb=+h[ja>>3];pm(ka,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,14584,p);Ib=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,14584,o);Jb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,14584,n);Kb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}qb=Kb+-273.15;dm(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];cm(na,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[na>>3];pm(oa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);qb=+h[pa>>3];cm(qa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[qa>>3];pm(ra,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+8>>3];rb=+yd(1.0e-13,+(+h[qa+16>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,14656,18256,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{cm(ta,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Lb=+h[ta>>3];pm(ua,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Lb=+h[va>>3];cm(wa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[wa>>3];pm(xa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+16>>3]- +h[ya>>3]));Eb=1.0- +h[wa+8>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,14656,18256,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{cm(za,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Ob=+h[za>>3];pm(Aa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Ob=+h[Ba>>3];cm(Ca,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Lb=+h[Ca>>3];pm(Da,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Lb=+h[Ea>>3];cm(Fa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Fa>>3];pm(Ga,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[Ha>>3])|0)<<24>>24==0){cm(Ia,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Ia>>3];pm(Ja,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Ka,c[ib>>2]|0,+h[Ja>>3],+h[Ja+168>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(La,c[ib>>2]|0,+h[Ka>>3],+h[Ka+168>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Ma,c[ib>>2]|0,qb,Eb,+h[Ka>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+168>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+184>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}cm(Na,c[ib>>2]|0,+h[Qb>>3]);rb=+h[Na>>3];pm(Oa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);rb=+h[Pa>>3];cm(Qa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[Qa>>3];pm(Ra,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Eb=+h[Sa>>3];cm(Ta,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Ta>>3];pm(Ua,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Va,c[ib>>2]|0,+h[Ua>>3],+h[Ua+168>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(Wa,c[ib>>2]|0,+h[Va>>3],+h[Va+168>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Xa,c[ib>>2]|0,qb,Bb,+h[Va>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+168>>3],0.0);Cb=+h[Xa>>3];cm(Ya,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Bb=+h[Ya>>3];pm(Za,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+16>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+176>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+8>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,14968,18256,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+8>>3];Tb=+h[Ya+16>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,14656,18256,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+176>>3]-Pb}Pb=+h[Mb>>3];Wb=Pb+-273.15;Cb=+h[Mb+168>>3];om($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];cm(ab,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Pb=+h[ab>>3];pm(bb,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Pb=+h[cb>>3];cm(db,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Wb=+h[db>>3];pm(eb,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,15584,18256,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+176>>3]-ub);ub=+h[Yb+168>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,15584,18256,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+168>>3];ac=+h[Yb>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+8>>3];Gb=+yd(1.0e-13,+(+h[Yb+16>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,14656,18256,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,15584,18256,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+176>>3];ic=+h[gc+168>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,15584,18256,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+168>>3];kc=+h[gc>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+8>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+16>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2304|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2304|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,14656,18256,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2304|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function Lo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;jm(d,c[f>>2]|0,+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+184>>3]*.999;l=j;m=l+2248|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;rm(e,c[f>>2]|0,+h[d>>3],+h[d+168>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+2248|0;n=m;h[n>>3]=k;i=b;return}}function Mo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+392>>3];k=+yd(1.0e-13,+(+h[g+16>>3]-j));l=+h[g+1136>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,14320,18264,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2080|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+16>>3]- +h[f+392>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+392>>3];j=+h[x+16>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2200>>3];k=+h[x+1136>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+184>>3]- +h[x+2248>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+184>>3]- +h[x+2248>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+184>>3]- +h[x+2248>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+184>>3]- +h[x+2248>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,14384,18264,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1136>>3];C=+h[L+392>>3];D=+h[L+16>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+2248>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,14320,18264,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2080|0;w=v;h[w>>3]=n;i=d;return}function No(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+8>>3]- +h[a+408>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+2240|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+176>>3]- +h[a+2080>>3];g=a;j=g+2240|0;k=j;h[k>>3]=f;i=b;return}function Oo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+176>>3]- +h[b+2240>>3];i=i;return}function Po(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+424>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+2240>>3];o=+h[g+2200>>3]*k+ +h[g+1136>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,14528,18272,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+2240>>3];q=+h[v+424>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+2072>>3]*(1.0-q)+ +h[r+416>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+2232|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+2232|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,14528,18272,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+2232|0;C=B;h[C>>3]=z;i=d;return}function Qo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2656>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2632>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2640>>3];h[a+8>>3]=+h[d+2432>>3];h[e+8>>3]=+h[d+2408>>3];h[f+8>>3]=+h[d+2416>>3];i=i;return}function Ro(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+184>>3]=+h[b>>3];h[a+168>>3]=+h[b+8>>3];Ko(f);Lo(f);Mo(f);No(f);Oo(f);Po(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+456|0;j=+h[g>>3];k=+h[f>>3];l=j*k;b=f+168|0;a=f+2232|0;h[d>>3]=+h[f+2312>>3]*l*l+(+h[f+16>>3]*(j*+h[b>>3]+k*+h[a>>3])-l*+h[f+184>>3]);h[d+8>>3]=+h[f+2064>>3]+(+h[a>>3]*+h[f>>3]+(+h[g>>3]*+h[b>>3]- +h[f+2304>>3]));i=e;return}function So(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,13120,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}cm(t,c[ib>>2]|0,jb);jb=+h[t>>3];pm(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);jb=+h[v>>3];cm(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);pb=+h[w>>3];pm(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+96>>3];qb=+yd(1.0e-13,+(+h[w+104>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,13192,18280,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{cm(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);sb=+h[z>>3];pm(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);sb=+h[B>>3];cm(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);jb=+h[C>>3];pm(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+104>>3]- +h[E>>3]));pb=1.0- +h[C+96>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,13192,18280,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{cm(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);vb=+h[F>>3];pm(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);vb=+h[H>>3];cm(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);sb=+h[I>>3];pm(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);sb=+h[K>>3];cm(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);jb=+h[L>>3];pm(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+104>>3]- +h[N>>3])|0)<<24>>24==0){cm(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);jb=+h[O>>3];pm(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Q,c[ib>>2]|0,+h[P+88>>3],+h[P+256>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(R,c[ib>>2]|0,+h[Q+88>>3],+h[Q+256>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(S,c[ib>>2]|0,jb,pb,+h[Q+88>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+256>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+272>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}cm(T,c[ib>>2]|0,+h[xb+88>>3]);qb=+h[T>>3];pm(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);qb=+h[V>>3];cm(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);pb=+h[W>>3];pm(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);pb=+h[Y>>3];cm(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);jb=+h[Z>>3];pm(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm($,c[ib>>2]|0,+h[_+88>>3],+h[_+256>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(aa,c[ib>>2]|0,+h[$+88>>3],+h[$+256>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(ba,c[ib>>2]|0,jb,rb,+h[$+88>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+256>>3],0.0);zb=+h[ba>>3];cm(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);rb=+h[ca>>3];pm(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+104>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+264>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+96>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,13504,18280,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+96>>3];Cb=+h[ca+104>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,13192,18280,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+264>>3]-wb}wb=+h[tb+88>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,13120,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,13120,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}cm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];pm(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Hb=+h[ia>>3];cm(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Fb=+h[ja>>3];pm(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,13120,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,13120,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,13120,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]}qb=Kb+-273.15;dm(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];cm(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[na>>3];pm(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);qb=+h[pa>>3];cm(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Eb=+h[qa>>3];pm(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+96>>3];rb=+yd(1.0e-13,+(+h[qa+104>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,13192,18280,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{cm(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Lb=+h[ta>>3];pm(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Lb=+h[va>>3];cm(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[wa>>3];pm(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+104>>3]- +h[ya>>3]));Eb=1.0- +h[wa+96>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,13192,18280,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{cm(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Ob=+h[za>>3];pm(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Ob=+h[Ba>>3];cm(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Lb=+h[Ca>>3];pm(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Lb=+h[Ea>>3];cm(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[Fa>>3];pm(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+104>>3]- +h[Ha>>3])|0)<<24>>24==0){cm(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[Ia>>3];pm(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Ka,c[ib>>2]|0,+h[Ja+88>>3],+h[Ja+256>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(La,c[ib>>2]|0,+h[Ka+88>>3],+h[Ka+256>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+88>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+256>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+272>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}cm(Na,c[ib>>2]|0,+h[Qb+88>>3]);rb=+h[Na>>3];pm(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);rb=+h[Pa>>3];cm(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Eb=+h[Qa>>3];pm(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Eb=+h[Sa>>3];cm(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);qb=+h[Ta>>3];pm(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Va,c[ib>>2]|0,+h[Ua+88>>3],+h[Ua+256>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(Wa,c[ib>>2]|0,+h[Va+88>>3],+h[Va+256>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Xa,c[ib>>2]|0,qb,Bb,+h[Va+88>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+256>>3],0.0);Cb=+h[Xa>>3];cm(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Bb=+h[Ya>>3];pm(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+104>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+264>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+96>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,13504,18280,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+96>>3];Tb=+h[Ya+104>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,13192,18280,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+264>>3]-Pb}Pb=+h[Mb+88>>3];Wb=Pb+-273.15;Cb=+h[Mb+256>>3];om($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];cm(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Pb=+h[ab>>3];pm(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Pb=+h[cb>>3];cm(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);Wb=+h[db>>3];pm(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]);dm(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+88>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+88>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,14128,18280,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+88>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+264>>3]-ub);ub=+h[Yb+256>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,14128,18280,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+256>>3];ac=+h[Yb+88>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+96>>3];Gb=+yd(1.0e-13,+(+h[Yb+104>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,13192,18280,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+88>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,14128,18280,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+88>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+264>>3];ic=+h[gc+256>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,14128,18280,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+256>>3];kc=+h[gc+88>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+96>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+104>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2256|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2256|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,13192,18280,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2256|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function To(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;jm(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+272>>3]*.999;l=j;m=l+2160|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;rm(e,c[f>>2]|0,+h[d+88>>3],+h[d+256>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+2160|0;n=m;h[n>>3]=k;i=b;return}}function Uo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1328>>3];k=+yd(1.0e-13,+(+h[g+104>>3]-j));l=+h[g+1880>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,12848,18288,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2008|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+104>>3]- +h[f+1328>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+1328>>3];j=+h[x+104>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2128>>3];k=+h[x+1880>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+272>>3]- +h[x+2160>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+272>>3]- +h[x+2160>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+272>>3]- +h[x+2160>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+272>>3]- +h[x+2160>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,12920,18288,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1880>>3];C=+h[L+1328>>3];D=+h[L+104>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+2160>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,12848,18288,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2008|0;w=v;h[w>>3]=n;i=d;return}function Vo(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+96>>3]- +h[a+1344>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+2152|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+264>>3]- +h[a+2008>>3];g=a;j=g+2152|0;k=j;h[k>>3]=f;i=b;return}function Wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+264>>3]- +h[b+2152>>3];i=i;return}function Xo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1360>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+2152>>3];o=+h[g+2128>>3]*k+ +h[g+1880>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,13064,18296,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+2152>>3];q=+h[v+1360>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+2e3>>3]*(1.0-q)+ +h[r+1352>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+2144|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+2144|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,13064,18296,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+2144|0;C=B;h[C>>3]=z;i=d;return}function Yo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+3888>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+3864>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+3872>>3];h[a+8>>3]=+h[d+3664>>3];h[e+8>>3]=+h[d+3640>>3];h[f+8>>3]=+h[d+3648>>3];i=i;return}function Zo(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+272>>3]=+h[b>>3];h[a+256>>3]=+h[b+8>>3];So(f);To(f);Uo(f);Vo(f);Wo(f);Xo(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+1392|0;j=+h[g>>3];b=f+88|0;k=+h[b>>3];l=j*k;a=f+256|0;m=f+2144|0;h[d>>3]=+h[f+2264>>3]*l*l+(+h[f+104>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+272>>3]);h[d+8>>3]=+h[f+1992>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+2256>>3]));i=e;return}function _o(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;YT(e,1,.01,b+16|0);g=c[a+536>>2]|0;j=a+4|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3256>>3];a=d;l=e;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];Pm(f,g,k,293.15,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3672>>3]=+h[f>>3];i=b;return}function $o(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0;b=i;i=i+120|0;d=b;e=b+96|0;f=b+112|0;g=i;i=i+48|0;j=i;i=i+8|0;l=i;i=i+48|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+96|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;YT(n,1,.01,m);m=l;h[k>>3]=575.573102;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=.931782653;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+16|0;h[k>>3]=.00722271286;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+24|0;h[k>>3]=-734255737.0e-14;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+32|0;h[k>>3]=4.95504349e-9;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+40|0;h[k>>3]=-1.336933246e-12;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(p,7,-39479.6083,l);l=j;h[k>>3]=17.24205775;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];YT(q,2,-33039.7431,j);j=g;h[k>>3]=-2412.698562;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+8|0;h[k>>3]=4.64611078;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+16|0;h[k>>3]=.002291998307;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+24|0;h[k>>3]=-6.836830479999999e-7;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+32|0;h[k>>3]=9.426468930000001e-11;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+40|0;h[k>>3]=-4.82238053e-15;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];YT(r,7,1034972.096,g);g=f;h[k>>3]=-7.97814851;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];YT(s,2,-13842.86509,f);c[o>>2]=14304;h[o+8>>3]=.01801528;h[o+16>>3]=-13423382.81725291;h[o+24>>3]=549760.6476280135;h[o+32>>3]=1.0e3;f=o+40|0;g=p;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];g=o+52|0;f=q;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];f=o+64|0;g=r;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];g=o+76|0;f=s;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];h[o+88>>3]=461.5233290850878;f=c[a+536>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;u=+h[a+3672>>3];v=+h[a+3256>>3];a=e;s=n;c[a+0>>2]=c[s+0>>2];c[a+4>>2]=c[s+4>>2];c[a+8>>2]=c[s+8>>2];s=d+0|0;a=o+0|0;o=s+96|0;do{c[s>>2]=c[a>>2];s=s+4|0;a=a+4|0}while((s|0)<(o|0));em(t,f,u,190.0,647.0,v,e,d,1.0e-13);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3]=+h[t>>3];i=b;return}function ap(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=f;h[k>>3]=.99;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(g,2,.01,f);f=a+536|0;m=c[f>>2]|0;n=a+4|0;a=c[(c[c[n>>2]>>2]|0)+8>>2]|0;o=+h[a+3256>>3];p=+h[a+1152>>3];a=e;q=g;c[a+0>>2]=c[q+0>>2];c[a+4>>2]=c[q+4>>2];c[a+8>>2]=c[q+8>>2];Ml(j,m,o,p,e);e=c[f>>2]|0;f=d;m=j;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];Sl(l,e,d);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[l>>3];i=b;return}function bp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=f;h[k>>3]=.99;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(g,2,.01,f);f=a+536|0;m=c[f>>2]|0;n=a+4|0;a=c[(c[c[n>>2]>>2]|0)+8>>2]|0;o=+h[a+3256>>3];p=+h[a+1152>>3];a=e;q=g;c[a+0>>2]=c[q+0>>2];c[a+4>>2]=c[q+4>>2];c[a+8>>2]=c[q+8>>2];Ml(j,m,o,p,e);e=c[f>>2]|0;f=d;m=j;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];Vl(l,e,d);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+808>>3]=+h[l>>3];i=b;return}function cp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+32>>3];v=l;h[k>>3]=+h[t+1144>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+40>>3];w=+h[t+24>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=j;h[k>>3]=.99;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];YT(o,2,.01,j);j=c[l>>2]|0;q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+3256>>3];y=+h[q+1152>>3];q=e;f=o;c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+680>>3]=+h[d+496>>3]*(w- +h[r>>3])*+h[d+1440>>3];i=b;return}function dp(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+496>>3]*+h[e+1440>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+680>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+624|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+624|0;q=p;h[q>>3]=n;i=d;return}k=l/+XS(c[b+536>>2]|0,f,15616,18304,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+624|0;q=p;h[q>>3]=n;i=d;return}function ep(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+45664>>3];h[c[b+8>>2]>>3]=+h[d+45640>>3];h[c[b+12>>2]>>3]=+h[d+45648>>3];i=i;return}function fp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0.0;e=i;i=i+8|0;f=e;g=a;j=a+4|0;h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3256>>3]=+h[b>>3];_o(g);$o(g);ap(g);bp(g);cp(g);dp(g);g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;b=a+416|0;k=c[b>>2]|0;l=+h[k+528>>3];_l(f,c[a+536>>2]|0,+h[g+624>>3],+h[g+808>>3],+h[g+816>>3],+h[g+752>>3],+h[g+760>>3],+h[g+3136>>3],+h[k+512>>3],+h[g+2664>>3]*+h[k+1504>>3],(l+l)*.5,+h[k+1496>>3]/3.0,+h[k+1464>>3]);h[d>>3]=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+928>>3]- +h[f>>3]*+h[(c[b>>2]|0)+1440>>3];i=e;return}



function Gia(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function Hia(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function Iia(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function Jia(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=190296;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}Wla(e)}}while(0);Vla(b);i=d;return}function Kia(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=190296;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}Wla(e);i=d;return}function Lia(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function Mia(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Id()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function Nia(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Nd()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function Oia(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Nd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function Pia(a,b){a=a|0;b=b|0;i=i;return b|0}function Qia(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function Ria(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function Sia(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function Tia(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Uia(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function Via(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function Wia(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function Xia(a){a=a|0;i=i;return 1}function Yia(a){a=a|0;i=i;return 1}function Zia(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function _ia(a){a=a|0;i=i;return 1}function $ia(a){a=a|0;var b=0;b=i;hia(a);Vla(a);i=b;return}function aja(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Rc(c[s>>2]|0)|0;A=Tka(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Rc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Rc(c[s>>2]|0)|0;A=Ska(u,0,d)|0;if((z|0)!=0){Rc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Rc(c[s>>2]|0)|0;G=Ska(u,r,n)|0;if((z|0)!=0){Rc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function bja(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Rc(c[r>>2]|0)|0;y=Pka(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Rc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Rc(c[r>>2]|0)|0;F=Oka(x,y,1,d)|0;if((w|0)!=0){Rc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Rc(c[r>>2]|0)|0;y=Oka(q,v,z-v|0,n)|0;if((w|0)!=0){Rc(w|0)|0}if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else if((y|0)==0){I=v+1|0}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function cja(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Rc(c[b+8>>2]|0)|0;b=Ska(e,0,d)|0;if((j|0)!=0){Rc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function dja(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Rc(c[d>>2]|0)|0;e=Rka(0,0,4)|0;if((a|0)!=0){Rc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Rc(a|0)|0;if((g|0)==0){f=0;break}Rc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function eja(a){a=a|0;i=i;return 0}function fja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Rc(c[k>>2]|0)|0;n=Nka(a,j-a|0,b)|0;if((m|0)!=0){Rc(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function gja(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Rc(d|0)|0;if((a|0)==0){e=4;break}Rc(a|0)|0;e=4}}while(0);i=b;return e|0}function hja(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function ija(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=jja(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function jja(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function kja(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=lja(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function lja(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function mja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function nja(a){a=a|0;i=i;return 0}function oja(a){a=a|0;i=i;return 0}function pja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=qja(c,d,e,1114111,0)|0;i=b;return a|0}function qja(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function rja(a){a=a|0;i=i;return 4}function sja(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function tja(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=uja(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function uja(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function vja(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=wja(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function wja(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function xja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function yja(a){a=a|0;i=i;return 0}function zja(a){a=a|0;i=i;return 0}function Aja(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=Bja(c,d,e,1114111,0)|0;i=b;return a|0}function Bja(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function Cja(a){a=a|0;i=i;return 4}function Dja(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Eja(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Fja(a){a=a|0;var b=0;b=i;c[a>>2]=190448;Iba(a+12|0);Vla(a);i=b;return}function Gja(a){a=a|0;var b=0;b=i;c[a>>2]=190448;Iba(a+12|0);i=b;return}function Hja(a){a=a|0;var b=0;b=i;c[a>>2]=190488;Iba(a+16|0);Vla(a);i=b;return}function Ija(a){a=a|0;var b=0;b=i;c[a>>2]=190488;Iba(a+16|0);i=b;return}function Jja(b){b=b|0;i=i;return a[b+8|0]|0}function Kja(a){a=a|0;i=i;return c[a+8>>2]|0}function Lja(b){b=b|0;i=i;return a[b+9|0]|0}function Mja(a){a=a|0;i=i;return c[a+12>>2]|0}function Nja(a,b){a=a|0;b=b|0;var c=0;c=i;yba(a,b+12|0);i=c;return}function Oja(a,b){a=a|0;b=b|0;var c=0;c=i;yba(a,b+16|0);i=c;return}function Pja(a,b){a=a|0;b=b|0;b=i;Aba(a,190520,4);i=b;return}function Qja(a,b){a=a|0;b=b|0;b=i;ica(a,190528,nla(190528)|0);i=b;return}function Rja(a,b){a=a|0;b=b|0;b=i;Aba(a,190552,5);i=b;return}function Sja(a,b){a=a|0;b=b|0;b=i;ica(a,190560,nla(190560)|0);i=b;return}function Tja(b){b=b|0;var d=0,e=0;b=i;if((a[190592]|0)!=0){d=190584;e=c[47646]|0;i=b;return e|0}if((Za(190592)|0)==0){d=190584;e=c[47646]|0;i=b;return e|0}do{if((a[197792]|0)==0){if((Za(197792)|0)==0){break}tma(197624,0,168)|0;de(309,0,q|0)|0;Vb(197792)}}while(0);Lba(197624,197800)|0;Lba(197636|0,197808)|0;Lba(197648|0,197816)|0;Lba(197660|0,197824)|0;Lba(197672|0,197840)|0;Lba(197684|0,197856)|0;Lba(197696|0,197864)|0;Lba(197708|0,197880)|0;Lba(197720|0,197888)|0;Lba(197732|0,197896)|0;Lba(197744|0,197904)|0;Lba(197756|0,197912)|0;Lba(197768|0,197920)|0;Lba(197780|0,197928)|0;c[47646]=197624;Vb(190592);d=190584;e=c[47646]|0;i=b;return e|0}function Uja(b){b=b|0;var d=0,e=0;b=i;if((a[190608]|0)!=0){d=190600;e=c[47650]|0;i=b;return e|0}if((Za(190608)|0)==0){d=190600;e=c[47650]|0;i=b;return e|0}do{if((a[197256]|0)==0){if((Za(197256)|0)==0){break}tma(197088,0,168)|0;de(310,0,q|0)|0;Vb(197256)}}while(0);lca(197088,197264)|0;lca(197100|0,197296)|0;lca(197112|0,197328)|0;lca(197124|0,197360)|0;lca(197136|0,197400)|0;lca(197148|0,197440)|0;lca(197160|0,197472)|0;lca(197172|0,197512)|0;lca(197184|0,197528)|0;lca(197196|0,197544)|0;lca(197208|0,197560)|0;lca(197220|0,197576)|0;lca(197232|0,197592)|0;lca(197244|0,197608)|0;c[47650]=197088;Vb(190608);d=190600;e=c[47650]|0;i=b;return e|0}function Vja(b){b=b|0;var d=0,e=0;b=i;if((a[190624]|0)!=0){d=190616;e=c[47654]|0;i=b;return e|0}if((Za(190624)|0)==0){d=190616;e=c[47654]|0;i=b;return e|0}do{if((a[196864]|0)==0){if((Za(196864)|0)==0){break}tma(196576,0,288)|0;de(311,0,q|0)|0;Vb(196864)}}while(0);Lba(196576,196872)|0;Lba(196588|0,196880)|0;Lba(196600|0,196896)|0;Lba(196612|0,196904)|0;Lba(196624|0,196912)|0;Lba(196636|0,196920)|0;Lba(196648|0,196928)|0;Lba(196660|0,196936)|0;Lba(196672|0,196944)|0;Lba(196684|0,196960)|0;Lba(196696|0,196968)|0;Lba(196708|0,196984)|0;Lba(196720|0,197e3)|0;Lba(196732|0,197008)|0;Lba(196744|0,197016)|0;Lba(196756|0,197024)|0;Lba(196768|0,196912)|0;Lba(196780|0,197032)|0;Lba(196792|0,197040)|0;Lba(196804|0,197048)|0;Lba(196816|0,197056)|0;Lba(196828|0,197064)|0;Lba(196840|0,197072)|0;Lba(196852|0,197080)|0;c[47654]=196576;Vb(190624);d=190616;e=c[47654]|0;i=b;return e|0}function Wja(b){b=b|0;var d=0,e=0;b=i;if((a[190640]|0)!=0){d=190632;e=c[47658]|0;i=b;return e|0}if((Za(190640)|0)==0){d=190632;e=c[47658]|0;i=b;return e|0}do{if((a[196024]|0)==0){if((Za(196024)|0)==0){break}tma(195736,0,288)|0;de(312,0,q|0)|0;Vb(196024)}}while(0);lca(195736,196032)|0;lca(195748|0,196064)|0;lca(195760|0,196104)|0;lca(195772|0,196128)|0;lca(195784|0,196448)|0;lca(195796|0,196152)|0;lca(195808|0,196176)|0;lca(195820|0,196200)|0;lca(195832|0,196232)|0;lca(195844|0,196272)|0;lca(195856|0,196304)|0;lca(195868|0,196344)|0;lca(195880|0,196384)|0;lca(195892|0,196400)|0;lca(195904|0,196416)|0;lca(195916|0,196432)|0;lca(195928|0,196448)|0;lca(195940|0,196464)|0;lca(195952|0,196480)|0;lca(195964|0,196496)|0;lca(195976|0,196512)|0;lca(195988|0,196528)|0;lca(196e3|0,196544)|0;lca(196012|0,196560)|0;c[47658]=195736;Vb(190640);d=190632;e=c[47658]|0;i=b;return e|0}function Xja(b){b=b|0;var d=0,e=0;b=i;if((a[190656]|0)!=0){d=190648;e=c[47662]|0;i=b;return e|0}if((Za(190656)|0)==0){d=190648;e=c[47662]|0;i=b;return e|0}do{if((a[195712]|0)==0){if((Za(195712)|0)==0){break}tma(195424,0,288)|0;de(313,0,q|0)|0;Vb(195712)}}while(0);Lba(195424,195720)|0;Lba(195436|0,195728)|0;c[47662]=195424;Vb(190656);d=190648;e=c[47662]|0;i=b;return e|0}function Yja(b){b=b|0;var d=0,e=0;b=i;if((a[190672]|0)!=0){d=190664;e=c[47666]|0;i=b;return e|0}if((Za(190672)|0)==0){d=190664;e=c[47666]|0;i=b;return e|0}do{if((a[195384]|0)==0){if((Za(195384)|0)==0){break}tma(195096,0,288)|0;de(314,0,q|0)|0;Vb(195384)}}while(0);lca(195096,195392)|0;lca(195108|0,195408)|0;c[47666]=195096;Vb(190672);d=190664;e=c[47666]|0;i=b;return e|0}function Zja(b){b=b|0;var c=0;b=i;if((a[190696]|0)!=0){c=190680;i=b;return c|0}if((Za(190696)|0)==0){c=190680;i=b;return c|0}Aba(190680,190704,8);de(315,190680,q|0)|0;Vb(190696);c=190680;i=b;return c|0}function _ja(b){b=b|0;var c=0;b=i;if((a[190736]|0)!=0){c=190720;i=b;return c|0}if((Za(190736)|0)==0){c=190720;i=b;return c|0}ica(190720,190744,nla(190744)|0);de(316,190720,q|0)|0;Vb(190736);c=190720;i=b;return c|0}function $ja(b){b=b|0;var c=0;b=i;if((a[190800]|0)!=0){c=190784;i=b;return c|0}if((Za(190800)|0)==0){c=190784;i=b;return c|0}Aba(190784,190808,8);de(315,190784,q|0)|0;Vb(190800);c=190784;i=b;return c|0}function aka(b){b=b|0;var c=0;b=i;if((a[190840]|0)!=0){c=190824;i=b;return c|0}if((Za(190840)|0)==0){c=190824;i=b;return c|0}ica(190824,190848,nla(190848)|0);de(316,190824,q|0)|0;Vb(190840);c=190824;i=b;return c|0}function bka(b){b=b|0;var c=0;b=i;if((a[190904]|0)!=0){c=190888;i=b;return c|0}if((Za(190904)|0)==0){c=190888;i=b;return c|0}Aba(190888,190912,20);de(315,190888,q|0)|0;Vb(190904);c=190888;i=b;return c|0}function cka(b){b=b|0;var c=0;b=i;if((a[190952]|0)!=0){c=190936;i=b;return c|0}if((Za(190952)|0)==0){c=190936;i=b;return c|0}ica(190936,190960,nla(190960)|0);de(316,190936,q|0)|0;Vb(190952);c=190936;i=b;return c|0}function dka(b){b=b|0;var c=0;b=i;if((a[191064]|0)!=0){c=191048;i=b;return c|0}if((Za(191064)|0)==0){c=191048;i=b;return c|0}Aba(191048,191072,11);de(315,191048,q|0)|0;Vb(191064);c=191048;i=b;return c|0}function eka(b){b=b|0;var c=0;b=i;if((a[191104]|0)!=0){c=191088;i=b;return c|0}if((Za(191104)|0)==0){c=191088;i=b;return c|0}ica(191088,191112,nla(191112)|0);de(316,191088,q|0)|0;Vb(191104);c=191088;i=b;return c|0}function fka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Tc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);l=+jma(b,g,c[47542]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function gka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Tc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);l=+jma(b,g,c[47542]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function hka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Tc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);l=+jma(b,g,c[47542]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function ika(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Tc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);n=lb(b|0,h|0,f|0,c[47542]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function jka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Tc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);m=lb(b|0,h|0,f|0,c[47542]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function kka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Tc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);m=lb(b|0,h|0,f|0,c[47542]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function lka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Tc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);m=lb(b|0,h|0,f|0,c[47542]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function mka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Tc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);n=Mc(b|0,h|0,f|0,c[47542]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function nka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Tc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[190176]|0)==0){if((Za(190176)|0)==0){break}c[47542]=ac(2147483647,190184,0)|0;Vb(190176)}}while(0);m=Mc(b|0,h|0,f|0,c[47542]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function oka(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;le[h&511](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;le[h&511](a);i=b;return}}function pka(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){iia(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=Tla(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;rma(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{Vla(h);i=e;return}}function qka(a){a=a|0;a=i;kca(195372|0);kca(195360|0);kca(195348|0);kca(195336|0);kca(195324|0);kca(195312|0);kca(195300|0);kca(195288|0);kca(195276|0);kca(195264|0);kca(195252|0);kca(195240|0);kca(195228|0);kca(195216|0);kca(195204|0);kca(195192|0);kca(195180|0);kca(195168|0);kca(195156|0);kca(195144|0);kca(195132|0);kca(195120|0);kca(195108|0);kca(195096);i=a;return}function rka(a){a=a|0;a=i;Iba(195700|0);Iba(195688|0);Iba(195676|0);Iba(195664|0);Iba(195652|0);Iba(195640|0);Iba(195628|0);Iba(195616|0);Iba(195604|0);Iba(195592|0);Iba(195580|0);Iba(195568|0);Iba(195556|0);Iba(195544|0);Iba(195532|0);Iba(195520|0);Iba(195508|0);Iba(195496|0);Iba(195484|0);Iba(195472|0);Iba(195460|0);Iba(195448|0);Iba(195436|0);Iba(195424);i=a;return}function ska(a){a=a|0;a=i;kca(196012|0);kca(196e3|0);kca(195988|0);kca(195976|0);kca(195964|0);kca(195952|0);kca(195940|0);kca(195928|0);kca(195916|0);kca(195904|0);kca(195892|0);kca(195880|0);kca(195868|0);kca(195856|0);kca(195844|0);kca(195832|0);kca(195820|0);kca(195808|0);kca(195796|0);kca(195784|0);kca(195772|0);kca(195760|0);kca(195748|0);kca(195736);i=a;return}function tka(a){a=a|0;a=i;Iba(196852|0);Iba(196840|0);Iba(196828|0);Iba(196816|0);Iba(196804|0);Iba(196792|0);Iba(196780|0);Iba(196768|0);Iba(196756|0);Iba(196744|0);Iba(196732|0);Iba(196720|0);Iba(196708|0);Iba(196696|0);Iba(196684|0);Iba(196672|0);Iba(196660|0);Iba(196648|0);Iba(196636|0);Iba(196624|0);Iba(196612|0);Iba(196600|0);Iba(196588|0);Iba(196576);i=a;return}function uka(a){a=a|0;a=i;kca(197244|0);kca(197232|0);kca(197220|0);kca(197208|0);kca(197196|0);kca(197184|0);kca(197172|0);kca(197160|0);kca(197148|0);kca(197136|0);kca(197124|0);kca(197112|0);kca(197100|0);kca(197088);i=a;return}function vka(a){a=a|0;a=i;Iba(197780|0);Iba(197768|0);Iba(197756|0);Iba(197744|0);Iba(197732|0);Iba(197720|0);Iba(197708|0);Iba(197696|0);Iba(197684|0);Iba(197672|0);Iba(197660|0);Iba(197648|0);Iba(197636|0);Iba(197624);i=a;return}function wka(a){a=a|0;var b=0,c=0;b=i;if((Cka(a)|0)==0){c=(xka(a)|0)!=0|0}else{c=1}i=b;return c|0}function xka(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[197936+((d[197936+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function yka(a){a=a|0;var b=0,c=0;b=i;c=fb(a|0)|0;i=b;return c|0}function zka(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function Aka(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 9:{d=Gka(a)|0;break};case 3:{d=yka(a)|0;break};case 8:{d=Fka(a)|0;break};case 11:{d=Ika(a)|0;break};case 6:{d=Dka(a)|0;break};case 4:{d=zka(a)|0;break};case 7:{d=Eka(a)|0;break};case 10:{d=Hka(a)|0;break};case 12:{d=Jka(a)|0;break};case 2:{d=xka(a)|0;break};case 5:{d=Cka(a)|0;break};case 1:{d=wka(a)|0;break};default:{d=0}}i=c;return d|0}function Bka(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=200912;while(1){if(d<<24>>24==e<<24>>24){if((lma(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function Cka(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function Dka(a){a=a|0;var b=0,c=0;b=i;if((Hka(a)|0)==0){c=(Fka(a)|0)!=0|0}else{c=0}i=b;return c|0}function Eka(a){a=a|0;var b=0,c=0;b=i;if((Kka(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function Fka(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function Gka(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[200992+((d[200992+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function Hka(a){a=a|0;var b=0,c=0;b=i;c=(mla(204160,a)|0)!=0|0;i=b;return c|0}function Ika(a){a=a|0;var b=0,c=0;b=i;c=(Mka(a)|0)!=(a|0)|0;i=b;return c|0}function Jka(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function Kka(a){a=a|0;var b=0,c=0;b=i;c=Lka(a,0)|0;i=b;return c|0}function Lka(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((xka(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[204250+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[204248+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[204251+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[204496+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[204496+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[204496+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function Mka(a){a=a|0;var b=0,c=0;b=i;c=Lka(a,1)|0;i=b;return c|0}function Nka(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Oka(0,a,b,(c|0)!=0?c:205200)|0;i=d;return e|0}function Oka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?205208:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[204992+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Tc()|0)>>2]=84;k=-1;i=g;return k|0}function Pka(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=Qka(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=Oka(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function Qka(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[204992+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[204992+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Tc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function Rka(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[204992+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Tc()|0)>>2]=84;j=-1;i=g;return j|0}function Ska(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Tc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function Tka(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=Uka(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=Ska(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function Uka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=Ska(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=Ska(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=Ska(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}Ska(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function Vka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=Nla(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=Nla(2048)|0;c[p+16>>2]=s;if((s|0)==0){Ola(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=jla(0,0)|0;if((s|0)==0){Ola(c[p+16>>2]|0);Ola(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=Wka(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=Pla(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=Xka(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=Nla(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;tma(y|0,-1,v|0)|0;I=H}else{I=0}H=Pla(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=Pla(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=Xka(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=bla(q,x)|0;b:do{if((v|0)==0){y=bla(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=cla(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=lla(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=lla(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=cla(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=lla(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=lla(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=cla(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=lla(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=lla(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=lla(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=lla(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=lla(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=lla(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=lla(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=lla(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==1){U=c[S+4>>2]|0;W=bla(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=bla(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=bla(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=bla(q,0)|0}else if((T|0)==3){W=c[S+4>>2]|0;U=bla(q,c[W+4>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=bla(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}U=bla(q,c[W>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}wa=bla(q,0)|0}else if((T|0)==0){U=c[S+4>>2]|0;W=c[U>>2]|0;if(!((W|0)>-1|(W|0)==-4)){ra=L;sa=M;ta=N;break}W=U+8|0;U=(c[W>>2]|0)+L|0;c[W>>2]=U;if((U|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=U;ra=L;sa=M;ta=N;break}else if((T|0)==2){T=c[S+4>>2]|0;U=bla(q,L)|0;if((U|0)!=0){ua=N;va=U;break c}U=bla(q,S)|0;if((U|0)!=0){ua=N;va=U;break c}U=bla(q,1)|0;if((U|0)!=0){ua=N;va=U;break c}U=bla(q,c[T>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=bla(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}if((c[T+4>>2]|0)>1){F=45}else{if((c[T+8>>2]|0)>1){F=45}else{xa=L}}if((F|0)==45){F=0;c[j>>2]=0;xa=0}ra=xa;sa=M+1|0;ta=N;break}else{ra=L;sa=M;ta=N;break}if((wa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=wa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=lla(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=lla(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=lla(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=lla(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=bla(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=bla(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==3){M=c[ya+4>>2]|0;L=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[L+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[L+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==1){R=c[ya+4>>2]|0;Q=c[R>>2]|0;T=R+4|0;U=c[T>>2]|0;if((c[Q+8>>2]|0)==0){za=(c[U+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;W=$ka(s,c[Q+24>>2]|0,c[U+24>>2]|0,0,0)|0;c[ya+24>>2]=W;if((W|0)==0){z=0;A=12;B=0;C=D;break a}W=$ka(s,c[(c[R>>2]|0)+28>>2]|0,c[(c[T>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=W;if((W|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==2){W=c[ya+4>>2]|0;T=c[W>>2]|0;R=T+8|0;if((c[R>>2]|0)==0){Aa=0}else{Aa=(c[(c[W+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[R>>2]|0)==0){c[ya+24>>2]=c[T+24>>2];Ba=W+4|0}else{R=ala(q,T,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ca=Nla((c[g>>2]<<2)+4|0)|0;R=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=ala(q,c[W>>2]|0,R,h,0)|0;if((Da|0)!=0){F=150;break g}T=W+4|0;U=$ka(s,c[(c[T>>2]|0)+24>>2]|0,c[(c[W>>2]|0)+24>>2]|0,R,c[h>>2]|0)|0;R=ya+24|0;c[R>>2]=U;Ola(Ca);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=T}}T=c[Ba>>2]|0;if((c[T+8>>2]|0)==0){c[ya+28>>2]=c[T+28>>2];break}R=ala(q,T,0,0,g)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}Ea=Nla((c[g>>2]<<2)+4|0)|0;R=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=ala(q,c[Ba>>2]|0,R,h,0)|0;if((Fa|0)!=0){F=157;break g}T=$ka(s,c[(c[W>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,R,c[h>>2]|0)|0;R=ya+28|0;c[R>>2]=T;Ola(Ea);if((c[R>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){R=c[ya>>2]|0;if((R|0)==1){T=bla(q,ya)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=bla(q,2)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=ya+4|0;W=bla(q,c[(c[T>>2]|0)+4>>2]|0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=bla(q,0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=bla(q,c[c[T>>2]>>2]|0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=bla(q,0)|0;if((W|0)==0){break}else{z=0;A=W;B=0;C=D;break a}}else if((R|0)==2){W=bla(q,ya)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=bla(q,3)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=bla(q,c[c[ya+4>>2]>>2]|0)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=bla(q,0)|0;if((W|0)==0){break}else{z=0;A=W;B=0;C=D;break a}}else if((R|0)==3){W=bla(q,ya)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=bla(q,1)|0;if((W|0)!=0){z=0;A=W;B=0;C=D;break a}W=ya+4|0;T=bla(q,c[(c[W>>2]|0)+4>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=bla(q,0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=bla(q,c[c[W>>2]>>2]|0)|0;if((T|0)!=0){z=0;A=T;B=0;C=D;break a}T=bla(q,0)|0;if((T|0)==0){break}else{z=0;A=T;B=0;C=D;break a}}else if((R|0)==0){R=c[ya+4>>2]|0;T=c[R>>2]|0;if((T|0)==-4){c[ya+8>>2]=0;W=R+8|0;U=c[W>>2]|0;Q=lla(s,0,0,1,64)|0;if((Q|0)==0){F=104;break g}ea=Q;c[Q>>2]=U;c[Q+4>>2]=0;c[Q+8>>2]=1114111;c[Q+20>>2]=0;c[Q+24>>2]=0;U=Q+28|0;Q=ya+24|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[Q>>2]=ea;ea=c[W>>2]|0;W=c[R+4>>2]|0;Q=lla(s,0,0,1,64)|0;if((Q|0)==0){F=106;break g}c[Q>>2]=ea;c[Q+4>>2]=0;c[Q+8>>2]=1114111;c[Q+20>>2]=0;c[Q+24>>2]=0;c[Q+28>>2]=W;c[Q+32>>2]=-1;c[Q+36>>2]=-1;c[Q+40>>2]=-1;c[ya+28>>2]=Q;break}Q=ya+8|0;if((T|0)<0){c[Q>>2]=1;W=lla(s,0,0,1,32)|0;if((W|0)==0){F=110;break g}c[W>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[ya+24>>2]=W;W=lla(s,0,0,1,32)|0;if((W|0)==0){F=112;break g}c[W>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[ya+28>>2]=W;break}else{c[Q>>2]=0;Q=R+8|0;W=c[Q>>2]|0;ea=R+4|0;U=c[ea>>2]|0;fa=lla(s,0,0,1,64)|0;if((fa|0)==0){F=115;break g}da=fa;c[fa>>2]=W;c[fa+4>>2]=T;c[fa+8>>2]=U;c[fa+20>>2]=0;c[fa+24>>2]=0;U=fa+28|0;fa=ya+24|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[fa>>2]=da;da=c[Q>>2]|0;Q=c[R>>2]|0;fa=c[ea>>2]|0;ea=c[R+12>>2]|0;U=c[R+16>>2]|0;R=lla(s,0,0,1,64)|0;if((R|0)==0){F=117;break g}T=R;c[R>>2]=da;c[R+4>>2]=Q;c[R+8>>2]=fa;c[R+20>>2]=ea;c[R+24>>2]=U;U=R+28|0;R=ya+28|0;c[U+0>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[R>>2]=T;break}}else{break}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){Ola(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){Ola(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=Nla(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=Nla(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){tma(O|0,0,((E|0)>1?E<<2:4)|0)|0}Yka(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;T=O+(S<<2)|0;R=K+1+(c[T>>2]|0)|0;c[T>>2]=0;T=S+1|0;if((T|0)<(E|0)){S=T;K=R}else{Ga=R;break}}}else{Ga=0}K=Pla(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;R=Yka(y,S,x,u)|0;if((R|0)!=0){z=x;A=R;B=u;C=D;break}c[w+20>>2]=0;R=v+24|0;S=c[R>>2]|0;if((c[S>>2]|0)>-1){T=1;U=S;while(1){S=U+32|0;ea=T+1|0;if((c[S>>2]|0)>-1){U=S;T=ea}else{Ha=ea;break}}}else{Ha=1}T=Pla(Ha,32)|0;if((T|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=T;U=c[R>>2]|0;y=c[U>>2]|0;if((y|0)>-1){ea=y;y=U;U=0;while(1){c[T+(U<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[T+(U<<5)+12>>2]=ea;S=T+(U<<5)+16|0;c[S>>2]=0;fa=y+12|0;Q=c[fa>>2]|0;if((Q|0)!=0){da=0;while(1){Ia=da+1|0;if((c[Q+(da<<2)>>2]|0)>-1){da=Ia}else{break}}da=Ia<<2;Q=Nla(da)|0;c[S>>2]=Q;if((Q|0)==0){z=x;A=12;B=u;C=D;break a}rma(Q|0,c[fa>>2]|0,da|0)|0}c[T+(U<<5)+20>>2]=c[y+16>>2];da=U+1|0;Q=y+32|0;W=c[Q>>2]|0;if((W|0)>-1){ea=W;y=Q;U=da}else{Ja=da;break}}}else{Ja=0}c[T+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;kla(s);Ola(c[p+16>>2]|0);Ola(p);Ola(O);Ola(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);kla(s);Ola(c[p+16>>2]|0);Ola(p);if((z|0)!=0){Ola(z)}if((B|0)!=0){Ola(B)}c[b+4>>2]=C;Zka(b);r=A;i=f;return r|0}function Wka(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;bla(m,c[p>>2]|0)|0;bla(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=bla(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 5:{Q=c[q>>2]|0;R=a[Q]|0;if(R<<24>>24==0){S=M;T=N;U=0;break c}V=c[v>>2]&1;W=(V|0)!=0;if(W&R<<24>>24==124){S=M;T=N;U=0;break c}do{if(!(W&R<<24>>24==41&(M|0)>0)){if((V|0)==0&R<<24>>24==92){if((a[Q+1|0]|0)==41){break}}X=bla(m,5)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}X=bla(m,N)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}X=bla(m,6)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}S=M;T=N;U=bla(m,4)|0;break c}}while(0);R=(V|M|0)==0?8:0;W=M+ -1|0;if((V|0)!=0){S=W;T=N;U=R;break c}c[q>>2]=Q+2;S=W;T=N;U=R;break};case 9:{R=c[q>>2]|0;W=a[R]|0;switch(W<<24>>24|0){case 63:case 43:{if((c[v>>2]&1|0)==0){S=M;T=N;U=0;break c}else{_=41}break};case 123:{X=c[v>>2]|0;if((X&1|0)==0){S=M;T=N;U=0;break c}else{$=X;aa=R}break};case 42:{_=41;break};case 92:{X=c[v>>2]|0;if((X&1|0)!=0){S=M;T=N;U=0;break c}ba=R+1|0;if((a[ba]|0)!=123){S=M;T=N;U=0;break c}c[q>>2]=ba;$=X;aa=ba;break};default:{S=M;T=N;U=0;break c}}if((_|0)==41){_=0;c[q>>2]=R+1;R=c[w>>2]|0;ba=lla(R,0,0,1,32)|0;if((ba|0)==0){ca=12;_=294;break b}X=lla(R,0,0,1,16)|0;c[ba+4>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[ba>>2]=2;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=W<<24>>24==43;c[X+8>>2]=W<<24>>24==63?1:-1;W=X+12|0;a[W]=a[W]&-2;c[ba+16>>2]=c[N+16>>2];S=M;T=ba;U=bla(m,9)|0;break c}ba=aa+1|0;c[q>>2]=ba;W=a[ba]|0;if((W+ -48<<24>>24&255)<10){X=W<<24>>24;if((X+ -48|0)>>>0<10){da=X;ea=-1;fa=ba}else{ca=10;_=294;break b}while(1){X=((ea|0)<0?-48:(ea*10|0)+ -48|0)+da|0;R=fa+1|0;ga=a[R]|0;ha=ga<<24>>24;if((ha+ -48|0)>>>0<10){fa=R;ea=X;da=ha}else{ia=ga;ja=X;ka=R;break}}}else{ia=W;ja=-1;ka=ba}do{if(ia<<24>>24==44){Q=ka+1|0;V=a[Q]|0;R=V<<24>>24;if((R+ -48|0)>>>0<10){la=R;ma=-1;na=Q}else{oa=V;pa=-1;qa=Q;break}while(1){Q=((ma|0)<0?-48:(ma*10|0)+ -48|0)+la|0;V=na+1|0;R=a[V]|0;X=R<<24>>24;if((X+ -48|0)>>>0<10){na=V;ma=Q;la=X}else{ra=R;sa=Q;ta=V;_=54;break}}}else{ra=ia;sa=ja;ta=ka;_=54}}while(0);do{if((_|0)==54){_=0;if(!((sa|0)>-1)){oa=ra;pa=sa;qa=ta;break}if((ja|0)>(sa|0)|(sa|0)>255){ca=10;_=294;break b}else{oa=ra;pa=sa;qa=ta}}}while(0);if(oa<<24>>24==0){ca=9;_=294;break b}if((qa|0)==(ba|0)){ca=10;_=294;break b}if(($&1|0)==0){if(!(oa<<24>>24==92)){ca=10;_=294;break b}if((a[qa+1|0]|0)!=125){ca=10;_=294;break b}ua=qa+2|0}else{if(!(oa<<24>>24==125)){ca=10;_=294;break b}ua=qa+1|0}if((pa|ja|0)==0){W=c[w>>2]|0;V=lla(W,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}Q=lla(W,0,0,1,20)|0;c[V+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[V>>2]=0;c[V+8>>2]=-1;c[V+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;va=V}else{V=(pa&ja|0)<0;Q=c[w>>2]|0;W=lla(Q,0,0,1,32)|0;if((W|0)==0){ca=12;_=294;break b}R=lla(Q,0,0,1,16)|0;c[W+4>>2]=R;if((R|0)==0){ca=12;_=294;break b}c[W>>2]=2;c[W+8>>2]=-1;c[W+12>>2]=-1;c[R>>2]=N;c[R+4>>2]=V?1:ja;c[R+8>>2]=V?1:pa;V=R+12|0;a[V]=a[V]&-2;c[W+16>>2]=c[N+16>>2];va=W}c[q>>2]=ua;S=M;T=va;U=bla(m,9)|0;break};case 4:{W=bla(m,9)|0;if((W|0)!=0){Y=M;Z=W;_=6;break b}S=M;T=N;U=bla(m,1)|0;break};case 7:{W=c[q>>2]|0;V=a[W]|0;if((V|0)==41){c[q>>2]=W+1;S=M;T=N;U=0;break c}else if((V|0)!=124){S=M;T=N;U=0;break c}V=bla(m,7)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=bla(m,N)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=bla(m,8)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}V=bla(m,3)|0;if((V|0)!=0){Y=M;Z=V;_=6;break b}c[q>>2]=(c[q>>2]|0)+1;S=M;T=N;U=0;break};case 2:{V=L+ -2|0;c[n>>2]=V;W=c[P+(V<<2)>>2]|0;if((c[N+12>>2]|0)>-1){V=c[w>>2]|0;R=lla(V,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}Q=lla(V,0,0,1,20)|0;c[R+4>>2]=Q;if((Q|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;Q=c[w>>2]|0;V=lla(Q,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}X=lla(Q,0,0,1,8)|0;Q=V+4|0;c[Q>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[V>>2]=1;c[V+8>>2]=-1;c[V+12>>2]=-1;c[X>>2]=R;c[(c[Q>>2]|0)+4>>2]=N;Q=N+16|0;X=V+16|0;c[X>>2]=(c[Q>>2]|0)+(c[R+16>>2]|0);c[X>>2]=c[Q>>2];wa=V}else{wa=N}c[wa+12>>2]=W;W=wa+16|0;c[W>>2]=(c[W>>2]|0)+1;S=M;T=wa;U=0;break};case 8:{W=L+ -2|0;c[n>>2]=W;V=c[P+(W<<2)>>2]|0;W=c[w>>2]|0;Q=lla(W,0,0,1,32)|0;if((Q|0)==0){ca=12;_=294;break b}X=lla(W,0,0,1,8)|0;W=Q+4|0;c[W>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[X>>2]=V;c[(c[W>>2]|0)+4>>2]=N;c[Q+16>>2]=(c[N+16>>2]|0)+(c[V+16>>2]|0);S=M;T=Q;U=0;break};case 0:{if((c[v>>2]&1|0)!=0){Q=bla(m,7)|0;if((Q|0)!=0){Y=M;Z=Q;_=6;break b}}S=M;T=N;U=bla(m,3)|0;break};case 10:{Q=L+ -2|0;c[n>>2]=Q;c[v>>2]=c[P+(Q<<2)>>2];S=M;T=N;U=0;break};case 1:{Q=c[q>>2]|0;d:do{switch(a[Q]|0){case 92:{V=Q+1|0;W=a[V]|0;do{if((c[v>>2]&1|0)==0){if(W<<24>>24==40){c[q>>2]=V;xa=V;_=74;break d}else{X=a[Q+1|0]|0;if(X<<24>>24==41){_=265;break d}else{ya=X;break}}}else{ya=W}}while(0);W=Q+1|0;V=ya<<24>>24==0;if(V){ca=5;_=294;break b}else{za=205220|0;Aa=0}while(1){X=Aa+1|0;if((a[205216+(Aa<<3)|0]|0)==ya<<24>>24){Ba=za;break}R=205220+(X<<3)|0;if((X|0)==12){Ba=R;break}else{za=R;Aa=X}}X=c[Ba>>2]|0;if((X|0)!=0){R=F+0|0;ga=G+0|0;ha=R+40|0;do{c[R>>2]=c[ga>>2];R=R+4|0;ga=ga+4|0}while((R|0)<(ha|0));c[H>>2]=X;c[I>>2]=1;ga=Wka(j)|0;if((ga|0)!=0){ca=ga;_=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];S=M;T=c[K>>2]|0;U=0;break c}if(V){ca=5;_=294;break b}c[q>>2]=W;ga=a[W]|0;e:do{switch(ga|0){case 98:{R=c[w>>2]|0;ha=lla(R,0,0,1,32)|0;Ca=ha;do{if((ha|0)==0){Da=0}else{Ea=lla(R,0,0,1,20)|0;c[ha+4>>2]=Ea;if((Ea|0)==0){Da=0;break}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=64;c[Ea+8>>2]=-1;Da=Ca}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Da;break};case 60:{Ca=c[w>>2]|0;ha=lla(Ca,0,0,1,32)|0;R=ha;do{if((ha|0)==0){Ga=0}else{Ea=lla(Ca,0,0,1,20)|0;c[ha+4>>2]=Ea;if((Ea|0)==0){Ga=0;break}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=16;c[Ea+8>>2]=-1;Ga=R}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Ga;break};case 62:{R=c[w>>2]|0;ha=lla(R,0,0,1,32)|0;Ca=ha;do{if((ha|0)==0){Ha=0}else{Ea=lla(R,0,0,1,20)|0;c[ha+4>>2]=Ea;if((Ea|0)==0){Ha=0;break}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[Ea>>2]=-2;c[Ea+4>>2]=32;c[Ea+8>>2]=-1;Ha=Ca}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Ha;break};case 120:{Ca=Q+2|0;c[q>>2]=Ca;ha=a[Ca]|0;if(ha<<24>>24==123){Ca=Q+3|0;c[q>>2]=Ca;R=Ca;Ca=0;while(1){Ea=a[R]|0;if(Ea<<24>>24==0|Ea<<24>>24==125){Ia=Ca;Ja=R;break}if((Jka(Ea<<24>>24)|0)==0){ca=9;_=294;break b}Ea=c[q>>2]|0;a[l+Ca|0]=a[Ea]|0;Ka=Ca+1|0;La=Ea+1|0;c[q>>2]=La;if(Ka>>>0>31){Ia=Ka;Ja=La;break}else{R=La;Ca=Ka}}c[q>>2]=Ja+1;a[l+Ia|0]=0;Ca=Xb(C|0,0,16)|0;R=c[w>>2]|0;Ka=c[x>>2]|0;La=lla(R,0,0,1,32)|0;Ea=La;do{if((La|0)==0){Ma=0}else{Na=lla(R,0,0,1,20)|0;c[La+4>>2]=Na;if((Na|0)==0){Ma=0;break}c[La>>2]=0;c[La+8>>2]=-1;c[La+12>>2]=-1;c[Na>>2]=Ca;c[Na+4>>2]=Ca;c[Na+8>>2]=Ka;Ma=Ea}}while(0);c[x>>2]=(c[x>>2]|0)+1;Fa=Ma;break e}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;Ea=(Jka(ha<<24>>24)|0)==0;Ka=c[q>>2]|0;if(Ea){Oa=Ka}else{a[D]=a[Ka]|0;Ea=Ka+1|0;c[q>>2]=Ea;Oa=Ea}if((Jka(a[Oa]|0)|0)!=0){Ea=c[q>>2]|0;a[E]=a[Ea]|0;c[q>>2]=Ea+1}Ea=Xb(D|0,0,16)|0;Ka=c[w>>2]|0;Ca=c[x>>2]|0;La=lla(Ka,0,0,1,32)|0;R=La;do{if((La|0)==0){Pa=0}else{Na=lla(Ka,0,0,1,20)|0;c[La+4>>2]=Na;if((Na|0)==0){Pa=0;break}c[La>>2]=0;c[La+8>>2]=-1;c[La+12>>2]=-1;c[Na>>2]=Ea;c[Na+4>>2]=Ea;c[Na+8>>2]=Ca;Pa=R}}while(0);c[x>>2]=(c[x>>2]|0)+1;Fa=Pa;break e}break};case 66:{R=c[w>>2]|0;Ca=lla(R,0,0,1,32)|0;Ea=Ca;do{if((Ca|0)==0){Qa=0}else{La=lla(R,0,0,1,20)|0;c[Ca+4>>2]=La;if((La|0)==0){Qa=0;break}c[Ca>>2]=0;c[Ca+8>>2]=-1;c[Ca+12>>2]=-1;c[La>>2]=-2;c[La+4>>2]=128;c[La+8>>2]=-1;Qa=Ea}}while(0);c[q>>2]=(c[q>>2]|0)+1;Fa=Qa;break};default:{if((Cka(ga)|0)!=0){Ea=(a[c[q>>2]|0]|0)+ -48|0;Ca=c[w>>2]|0;R=c[x>>2]|0;La=lla(Ca,0,0,1,32)|0;if((La|0)==0){ca=12;_=294;break b}Ka=lla(Ca,0,0,1,20)|0;c[La+4>>2]=Ka;if((Ka|0)==0){ca=12;_=294;break b}c[La>>2]=0;c[La+8>>2]=-1;c[La+12>>2]=-1;c[Ka>>2]=-4;c[Ka+4>>2]=Ea;c[Ka+8>>2]=R;c[x>>2]=(c[x>>2]|0)+1;R=c[B>>2]|0;c[B>>2]=(Ea|0)<(R|0)?R:Ea;c[q>>2]=(c[q>>2]|0)+1;S=M;T=La;U=0;break c}La=c[w>>2]|0;Ea=a[c[q>>2]|0]|0;R=c[x>>2]|0;Ka=lla(La,0,0,1,32)|0;Ca=Ka;do{if((Ka|0)==0){Ra=0}else{ha=lla(La,0,0,1,20)|0;c[Ka+4>>2]=ha;if((ha|0)==0){Ra=0;break}c[Ka>>2]=0;c[Ka+8>>2]=-1;c[Ka+12>>2]=-1;c[ha>>2]=Ea;c[ha+4>>2]=Ea;c[ha+8>>2]=R;Ra=Ca}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;Fa=Ra}}}while(0);if((Fa|0)==0){ca=12;_=294;break b}else{S=M;T=Fa;U=0;break c}break};case 36:{if((c[v>>2]&1|0)==0){if((a[Q+1|0]|0)!=0){break d}}ga=c[w>>2]|0;W=lla(ga,0,0,1,32)|0;if((W|0)==0){ca=12;_=294;break b}V=lla(ga,0,0,1,20)|0;c[W+4>>2]=V;if((V|0)==0){ca=12;_=294;break b}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[V>>2]=-2;c[V+4>>2]=2;c[V+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=W;U=0;break c;break};case 41:{if((M|0)!=0){_=264}break};case 63:case 43:case 123:case 124:case 42:{_=264;break};case 0:{_=265;break};case 91:{W=Q+1|0;c[q>>2]=W;V=Nla(128)|0;if((V|0)==0){ca=12;_=294;break b}if((a[W]|0)==94){ga=Q+2|0;c[q>>2]=ga;Sa=ga;Ta=1}else{Sa=W;Ta=0}W=(Ta|0)==0;ga=V;V=0;X=0;Ca=32;R=Sa;f:while(1){Ea=a[R]|0;if(Ea<<24>>24==93){if(R>>>0>(c[q>>2]|0)>>>0){_=85;break}}else if(Ea<<24>>24==0){Ua=ga;Va=R;Wa=7;_=140;break}Ea=Rka(e,R,-1)|0;if((Ea|0)<0){c[e>>2]=-1;Xa=1}else{Xa=Ea}Ea=R+Xa|0;do{if((a[Ea]|0)==45){Ka=Xa+1|0;La=R+Ka|0;if((a[La]|0)==93){_=94;break}ha=c[e>>2]|0;Na=Rka(e,La,-1)|0;if((Na|0)<0){c[e>>2]=-1;Ya=-1;Za=1}else{Ya=c[e>>2]|0;Za=Na}_a=0;$a=Ya;ab=ha;bb=R+(Za+Ka)|0;cb=ha>>>0>Ya>>>0?11:0}else{_=94}}while(0);g:do{if((_|0)==94){_=0;ha=a[R]|0;do{if(ha<<24>>24==45){if((a[R+1|0]|0)==93){db=0;break}db=(c[q>>2]|0)==(R|0)?0:11}else if(ha<<24>>24==91){Ka=a[R+1|0]|0;if(Ka<<24>>24==61|Ka<<24>>24==46){Ua=ga;Va=R;Wa=3;_=140;break f}else if(!(Ka<<24>>24==58)){db=0;break}Ka=R+2|0;Na=Ka;while(1){La=a[Na]|0;eb=La<<24>>24==0;if(La<<24>>24!=58&(eb^1)){Na=Na+1|0}else{break}}if(eb){Ua=ga;Va=R;Wa=4;_=140;break f}La=Na-R+ -2|0;fb=(La|0)>63?63:La;Ama(A|0,Ka|0,fb|0)|0;a[f+fb|0]=0;fb=Bka(A)|0;_a=fb;$a=1114111;ab=0;bb=Na+2|0;cb=(fb|0)==0?4:0;break g}else{db=0}}while(0);ha=c[e>>2]|0;_a=0;$a=ha;ab=ha;bb=Ea;cb=db}}while(0);if((cb|0)!=0){Ua=ga;Va=bb;Wa=cb;_=140;break}Ea=(_a|0)!=0;do{if(W|Ea^1){ha=c[w>>2]|0;if((X|0)<(Ca|0)){gb=ga;hb=Ca}else{if((Ca|0)>1024){Ua=ga;Va=bb;Wa=12;_=140;break f}fb=Qla(ga,Ca<<3)|0;if((fb|0)==0){Ua=ga;Va=bb;Wa=12;_=140;break f}else{gb=fb;hb=Ca<<1}}fb=lla(ha,0,0,1,32)|0;if((fb|0)==0){_=112;break f}La=lla(ha,0,0,1,20)|0;ha=fb+4|0;c[ha>>2]=La;if((La|0)==0){_=112;break f}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[La>>2]=ab;c[La+4>>2]=$a;c[La+8>>2]=-1;c[gb+(X<<2)>>2]=fb;c[(c[ha>>2]|0)+12>>2]=_a;ib=gb;jb=V;kb=X+1|0;lb=hb;mb=0}else{if((V|0)>63){ib=ga;jb=V;kb=X;lb=Ca;mb=12;break}c[g+(V<<2)>>2]=_a;ib=ga;jb=V+1|0;kb=X;lb=Ca;mb=0}}while(0);ha=(mb|0)==0;if(ha&(((c[v>>2]&2|0)==0|Ea)^1)){nb=ib;ob=kb;pb=lb;qb=ab}else{if(ha){ga=ib;V=jb;X=kb;Ca=lb;R=bb;continue}else{Ua=ib;Va=bb;Wa=mb;_=140;break}}while(1){ha=qb;while(1){if(ha>>>0>$a>>>0){ga=nb;V=jb;X=ob;Ca=pb;R=bb;continue f}if((Eka(ha)|0)!=0){_=118;break}rb=ha+1|0;if((Ika(ha)|0)==0){ha=rb}else{_=129;break}}if((_|0)==118){_=0;fb=Kka(ha)|0;La=ha+1|0;h:do{if((Eka(La)|0)==0){sb=fb;tb=La}else{ub=fb;vb=La;while(1){if((Kka(vb)|0)!=(ub+1|0)|vb>>>0>$a>>>0){sb=ub;tb=vb;break h}wb=Kka(vb)|0;xb=vb+1|0;if((Eka(xb)|0)==0){sb=wb;tb=xb;break}else{ub=wb;vb=xb}}}}while(0);La=c[w>>2]|0;if((ob|0)<(pb|0)){yb=nb;zb=pb}else{if((pb|0)>1024){Ua=nb;Va=bb;Wa=12;_=140;break f}vb=Qla(nb,pb<<3)|0;if((vb|0)==0){Ua=nb;Va=bb;Wa=12;_=140;break f}else{yb=vb;zb=pb<<1}}vb=lla(La,0,0,1,32)|0;ub=vb;do{if((vb|0)==0){Ab=0}else{Na=lla(La,0,0,1,20)|0;c[vb+4>>2]=Na;if((Na|0)==0){Ab=0;break}c[vb>>2]=0;c[vb+8>>2]=-1;c[vb+12>>2]=-1;c[Na>>2]=fb;c[Na+4>>2]=sb;c[Na+8>>2]=-1;Ab=ub}}while(0);c[yb+(ob<<2)>>2]=Ab;Bb=Ab;Cb=yb;Db=zb;Eb=tb}else if((_|0)==129){_=0;ub=Mka(ha)|0;i:do{if((Ika(rb)|0)==0){Fb=ub;Gb=rb}else{fb=ub;vb=rb;while(1){if((Mka(vb)|0)!=(fb+1|0)|vb>>>0>$a>>>0){Fb=fb;Gb=vb;break i}La=vb+1|0;Na=Mka(vb)|0;if((Ika(La)|0)==0){Fb=Na;Gb=La;break}else{fb=Na;vb=La}}}}while(0);ha=c[w>>2]|0;if((ob|0)<(pb|0)){Hb=nb;Ib=pb}else{if((pb|0)>1024){Ua=nb;Va=bb;Wa=12;_=140;break f}vb=Qla(nb,pb<<3)|0;if((vb|0)==0){Ua=nb;Va=bb;Wa=12;_=140;break f}else{Hb=vb;Ib=pb<<1}}vb=lla(ha,0,0,1,32)|0;fb=vb;do{if((vb|0)==0){Jb=0}else{La=lla(ha,0,0,1,20)|0;c[vb+4>>2]=La;if((La|0)==0){Jb=0;break}c[vb>>2]=0;c[vb+8>>2]=-1;c[vb+12>>2]=-1;c[La>>2]=ub;c[La+4>>2]=Fb;c[La+8>>2]=-1;Jb=fb}}while(0);c[Hb+(ob<<2)>>2]=Jb;Bb=Jb;Cb=Hb;Db=Ib;Eb=Gb}if((Bb|0)==0){_=141;break f}else{nb=Cb;ob=ob+1|0;pb=Db;qb=Eb}}}j:do{if((_|0)==85){_=0;c[q>>2]=R+1;Ca=(Ta|0)!=0;if(Ca){hc(ga|0,X|0,4,60)}k:do{if((X|0)>0){W=(V|0)>0;Ea=V<<2;fb=Ea+4|0;if(Ca){Kb=0;Lb=0;Mb=0;Nb=0}else{ub=0;vb=0;while(1){ha=ga+(ub<<2)|0;La=c[(c[ha>>2]|0)+4>>2]|0;do{if((La|0)==0){Ob=vb;Pb=0}else{c[La+8>>2]=c[x>>2];if(W){Na=lla(c[w>>2]|0,0,0,0,fb)|0;Ka=La+16|0;c[Ka>>2]=Na;if((Na|0)==0){Qb=ga;Rb=vb;Sb=12;break j}rma(Na|0,z|0,Ea|0)|0;c[(c[Ka>>2]|0)+(V<<2)>>2]=0}else{c[La+16>>2]=0}if((vb|0)==0){Ob=c[ha>>2]|0;Pb=0;break}Ka=c[w>>2]|0;Na=c[ha>>2]|0;xb=lla(Ka,0,0,1,32)|0;wb=xb;do{if((xb|0)==0){Tb=0}else{Ub=lla(Ka,0,0,1,8)|0;Vb=xb+4|0;c[Vb>>2]=Ub;if((Ub|0)==0){Tb=0;break}c[xb>>2]=3;c[xb+8>>2]=-1;c[xb+12>>2]=-1;c[Ub>>2]=vb;c[(c[Vb>>2]|0)+4>>2]=Na;c[xb+16>>2]=(c[Na+16>>2]|0)+(c[vb+16>>2]|0);Tb=wb}}while(0);Ob=Tb;Pb=(Tb|0)==0?12:0}}while(0);ha=ub+1|0;if((ha|0)<(X|0)&(Pb|0)==0){ub=ha;vb=Ob}else{Wb=0;Yb=Ob;Zb=Pb;break k}}}while(1){vb=ga+(Mb<<2)|0;ub=c[(c[vb>>2]|0)+4>>2]|0;ha=c[ub>>2]|0;La=ub+4|0;wb=c[La>>2]|0;do{if((ha|0)<(Kb|0)){Na=wb+1|0;_b=(Na|0)<(Kb|0)?Kb:Na;$b=Lb;ac=Nb;bc=0}else{if((ha|0)<=(Lb|0)){Na=wb+1|0;_b=Na;$b=Na;ac=Nb;bc=0;break}c[ub>>2]=Lb;c[La>>2]=ha+ -1;Na=wb+1|0;if((ub|0)==0){_b=Na;$b=Na;ac=Nb;bc=0;break}c[ub+8>>2]=c[x>>2];if(W){xb=lla(c[w>>2]|0,0,0,0,fb)|0;Ka=ub+16|0;c[Ka>>2]=xb;if((xb|0)==0){Qb=ga;Rb=Nb;Sb=12;break j}rma(xb|0,z|0,Ea|0)|0;c[(c[Ka>>2]|0)+(V<<2)>>2]=0}else{c[ub+16>>2]=0}if((Nb|0)==0){_b=Na;$b=Na;ac=c[vb>>2]|0;bc=0;break}Ka=c[w>>2]|0;xb=c[vb>>2]|0;Vb=lla(Ka,0,0,1,32)|0;Ub=Vb;do{if((Vb|0)==0){cc=0}else{dc=lla(Ka,0,0,1,8)|0;ec=Vb+4|0;c[ec>>2]=dc;if((dc|0)==0){cc=0;break}c[Vb>>2]=3;c[Vb+8>>2]=-1;c[Vb+12>>2]=-1;c[dc>>2]=Nb;c[(c[ec>>2]|0)+4>>2]=xb;c[Vb+16>>2]=(c[xb+16>>2]|0)+(c[Nb+16>>2]|0);cc=Ub}}while(0);_b=Na;$b=Na;ac=cc;bc=(cc|0)==0?12:0}}while(0);vb=Mb+1|0;if((vb|0)<(X|0)&(bc|0)==0){Kb=_b;Lb=$b;Mb=vb;Nb=ac}else{Wb=$b;Yb=ac;Zb=bc;break}}}else{Wb=0;Yb=0;Zb=0}}while(0);if((Zb|0)!=0|Ca^1){Qb=ga;Rb=Yb;Sb=Zb;break}Ea=c[w>>2]|0;fb=c[x>>2]|0;W=lla(Ea,0,0,1,32)|0;vb=W;if((W|0)==0){Qb=ga;Rb=Yb;Sb=12;break}ub=lla(Ea,0,0,1,20)|0;c[W+4>>2]=ub;if((ub|0)==0){Qb=ga;Rb=Yb;Sb=12;break}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[ub>>2]=Wb;c[ub+4>>2]=1114111;c[ub+8>>2]=fb;if((V|0)>0){fb=V<<2;Ea=lla(c[w>>2]|0,0,0,0,fb+4|0)|0;wb=ub+16|0;c[wb>>2]=Ea;if((Ea|0)==0){Qb=ga;Rb=Yb;Sb=12;break}rma(Ea|0,z|0,fb|0)|0;c[(c[wb>>2]|0)+(V<<2)>>2]=0}else{c[ub+16>>2]=0}if((Yb|0)==0){Qb=ga;Rb=vb;Sb=0;break}ub=c[w>>2]|0;wb=lla(ub,0,0,1,32)|0;fb=wb;do{if((wb|0)==0){fc=0}else{Ea=lla(ub,0,0,1,8)|0;ha=wb+4|0;c[ha>>2]=Ea;if((Ea|0)==0){fc=0;break}c[wb>>2]=3;c[wb+8>>2]=-1;c[wb+12>>2]=-1;c[Ea>>2]=Yb;c[(c[ha>>2]|0)+4>>2]=vb;c[wb+16>>2]=(c[W+16>>2]|0)+(c[Yb+16>>2]|0);fc=fb}}while(0);Qb=ga;Rb=fc;Sb=(fc|0)==0?12:0}else if((_|0)==112){_=0;c[gb+(X<<2)>>2]=0;Ua=gb;Va=bb;Wa=12;_=140}else if((_|0)==141){_=0;c[q>>2]=bb;Qb=Cb;Rb=0;Sb=12}}while(0);if((_|0)==140){_=0;c[q>>2]=Va;Qb=Ua;Rb=0;Sb=Wa}Ola(Qb);c[x>>2]=(c[x>>2]|0)+1;if((Sb|0)==0){S=M;T=Rb;U=0;break c}else{ca=Sb;_=294;break b}break};case 40:{if((c[v>>2]&1|0)!=0){xa=Q;_=74}break};case 46:{X=(c[v>>2]&4|0)==0;ga=c[w>>2]|0;V=c[x>>2]|0;R=lla(ga,0,0,1,32)|0;fb=R;W=(R|0)==0;if(X){if(W){ca=12;_=294;break b}X=lla(ga,0,0,1,20)|0;c[R+4>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[X>>2]=0;c[X+4>>2]=1114111;c[X+8>>2]=V;gc=fb;ic=(c[x>>2]|0)+1|0}else{if(W){ca=12;_=294;break b}W=lla(ga,0,0,1,20)|0;c[R+4>>2]=W;if((W|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[W>>2]=0;c[W+4>>2]=9;c[W+8>>2]=V;V=c[w>>2]|0;W=(c[x>>2]|0)+1|0;ga=lla(V,0,0,1,32)|0;if((ga|0)==0){ca=12;_=294;break b}X=lla(V,0,0,1,20)|0;c[ga+4>>2]=X;if((X|0)==0){ca=12;_=294;break b}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[X>>2]=11;c[X+4>>2]=1114111;c[X+8>>2]=W;W=c[w>>2]|0;X=lla(W,0,0,1,32)|0;if((X|0)==0){ca=12;_=294;break b}V=lla(W,0,0,1,8)|0;W=X+4|0;c[W>>2]=V;if((V|0)==0){ca=12;_=294;break b}c[X>>2]=3;c[X+8>>2]=-1;c[X+12>>2]=-1;c[V>>2]=fb;c[(c[W>>2]|0)+4>>2]=ga;c[X+16>>2]=(c[ga+16>>2]|0)+(c[R+16>>2]|0);gc=X;ic=(c[x>>2]|0)+2|0}c[x>>2]=ic;c[q>>2]=(c[q>>2]|0)+1;S=M;T=gc;U=0;break c;break};case 94:{if((c[v>>2]&1|0)==0){if((Q|0)!=(c[r>>2]|0)){break d}X=bla(m,5)|0;if((X|0)!=0){Y=M;Z=X;_=6;break b}}X=c[w>>2]|0;R=lla(X,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}ga=lla(X,0,0,1,20)|0;c[R+4>>2]=ga;if((ga|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ga>>2]=-2;c[ga+4>>2]=1;c[ga+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;S=M;T=R;U=0;break c;break};default:{}}}while(0);if((_|0)==74){_=0;ba=M+1|0;c[q>>2]=xa+1;R=bla(m,c[y>>2]|0)|0;if((R|0)!=0){Y=ba;Z=R;_=6;break b}R=bla(m,2)|0;if((R|0)!=0){Y=ba;Z=R;_=6;break b}R=bla(m,0)|0;if((R|0)!=0){Y=ba;Z=R;_=6;break b}c[y>>2]=(c[y>>2]|0)+1;S=ba;T=N;U=0;break c}else if((_|0)==264){_=0;if((c[v>>2]&1|0)!=0){_=265}}if((_|0)==265){_=0;ba=c[w>>2]|0;R=lla(ba,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}ga=lla(ba,0,0,1,20)|0;c[R+4>>2]=ga;if((ga|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ga>>2]=-1;c[ga+4>>2]=-1;c[ga+8>>2]=-1;S=M;T=R;U=0;break c}R=Rka(h,Q,-1)|0;if((R|0)<0){c[h>>2]=-1;jc=1}else{jc=R}do{if((c[v>>2]&2|0)==0){_=280}else{if((Ika(c[h>>2]|0)|0)==0){if((Eka(c[h>>2]|0)|0)==0){_=280;break}}R=c[w>>2]|0;ga=Kka(c[h>>2]|0)|0;ba=Kka(c[h>>2]|0)|0;X=c[x>>2]|0;W=lla(R,0,0,1,32)|0;if((W|0)==0){ca=12;_=294;break b}fb=lla(R,0,0,1,20)|0;c[W+4>>2]=fb;if((fb|0)==0){ca=12;_=294;break b}c[W>>2]=0;c[W+8>>2]=-1;c[W+12>>2]=-1;c[fb>>2]=ga;c[fb+4>>2]=ba;c[fb+8>>2]=X;X=c[w>>2]|0;fb=Mka(c[h>>2]|0)|0;ba=Mka(c[h>>2]|0)|0;ga=c[x>>2]|0;R=lla(X,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}V=lla(X,0,0,1,20)|0;c[R+4>>2]=V;if((V|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[V>>2]=fb;c[V+4>>2]=ba;c[V+8>>2]=ga;ga=c[w>>2]|0;V=lla(ga,0,0,1,32)|0;if((V|0)==0){ca=12;_=294;break b}ba=lla(ga,0,0,1,8)|0;ga=V+4|0;c[ga>>2]=ba;if((ba|0)==0){ca=12;_=294;break b}c[V>>2]=3;c[V+8>>2]=-1;c[V+12>>2]=-1;c[ba>>2]=W;c[(c[ga>>2]|0)+4>>2]=R;c[V+16>>2]=(c[R+16>>2]|0)+(c[W+16>>2]|0);kc=V}}while(0);if((_|0)==280){_=0;Q=c[w>>2]|0;V=c[h>>2]|0;W=c[x>>2]|0;R=lla(Q,0,0,1,32)|0;if((R|0)==0){ca=12;_=294;break b}ga=lla(Q,0,0,1,20)|0;c[R+4>>2]=ga;if((ga|0)==0){ca=12;_=294;break b}c[R>>2]=0;c[R+8>>2]=-1;c[R+12>>2]=-1;c[ga>>2]=V;c[ga+4>>2]=V;c[ga+8>>2]=W;kc=R}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+jc;S=M;T=kc;U=0;break};case 6:{R=L+ -2|0;c[n>>2]=R;W=c[P+(R<<2)>>2]|0;R=c[w>>2]|0;ga=lla(R,0,0,1,32)|0;if((ga|0)==0){ca=12;_=294;break b}V=lla(R,0,0,1,8)|0;R=ga+4|0;c[R>>2]=V;if((V|0)==0){ca=12;_=294;break b}c[ga>>2]=1;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[V>>2]=W;c[(c[R>>2]|0)+4>>2]=N;c[ga+16>>2]=(c[N+16>>2]|0)+(c[W+16>>2]|0);S=M;T=ga;U=0;break};case 3:{ga=bla(m,5)|0;if((ga|0)!=0){Y=M;Z=ga;_=6;break b}S=M;T=N;U=bla(m,4)|0;break};default:{S=M;T=N;U=0}}}while(0);P=c[n>>2]|0;O=(U|0)==0;if((P|0)>(o|0)&O){L=P;M=S;N=T}else{lc=O;mc=S;nc=T;oc=U;break a}}if((_|0)==6){lc=(Z|0)==0;mc=Y;nc=N;oc=Z;break}else if((_|0)==294){i=d;return ca|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){ca=p?8:oc;i=d;return ca|0}c[b+8>>2]=nc;ca=0;i=d;return ca|0}



function SV(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+yd(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+yd(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}GV(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function TV(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function UV(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;le[c[(c[a+540>>2]|0)+112>>2]&511](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function VV(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function WV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=fT(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{De[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;dT(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=fT(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function XV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((WV(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}YV(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(fT(d)|0)>0;h=b?2:0;i=e;return h|0}function YV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=Nla(q)|0;s=r;t=Nla(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[36744]=bT(4)|0;if((r|0)==0){cb(146984,147e3,308,147032)}if((t|0)==0){cb(147048,147e3,309,147032)}v=iT(b)|0;if((v|0)!=0){w=v;do{v=kT(w)|0;c[l>>2]=c[v>>2];RS(27,0,147064,l);w=jT(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;rma(t|0,c[a+384>>2]|0,v|0)|0;rma(r|0,l|0,v|0)|0}h[d>>3]=+$V(a,n,o,q,s,c[36744]|0,b);do{if((fT(c[36744]|0)|0)==0){s=gT(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=iT(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=kT(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=jT(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];RS(27,0,147112,j);v=iT(b)|0;if((v|0)==0){break}else{B=v}do{v=kT(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[36744]|0;eT(v,kT(B)|0);v=kT(B)|0;c[g>>2]=c[v>>2];RS(27,0,147136,g)}B=jT(B)|0;}while((B|0)!=0)}}while(0);cT(b);if((c[116204>>2]|0)!=0){fT(c[36744]|0)|0}if((fT(c[36744]|0)|0)>0){B=m;do{g=gT(c[36744]|0)|0;c[m>>2]=c[g>>2];hT(c[36744]|0);c[f>>2]=c[m>>2];RS(7,0,147160,f);dT(b,B);}while((fT(c[36744]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){rma(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}df(a);cW(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){Ola(t);Ola(r);i=e;return}rma(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;Ola(t);Ola(r);i=e;return}function ZV(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){gW(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];RS(7,0,146704,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((fT(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[116204>>2]|0)!=0){e=iT(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=kT(s)|0;x=c[e>>2]|0;e=De[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;QS(7,0,w,146728,l);s=jT(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=kT(iT(d)|0)|0;x=De[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;QS(1,0,e,146744,j);c[s>>2]=1}}while(0);cT(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;bW(b);_V(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function _V(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;RS(27,0,147352,b);d=a+344|0;re[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function $V(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=Nla(p<<3)|0;if((q|0)==0){cb(147168,147e3,409,147184)}if((p|0)>0){rma(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];RS(27,0,147200,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];RS(27,0,147248,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){Ola(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}AX(a)|0;oe[c[(c[p>>2]|0)+40>>2]&127](a)|0;oe[c[(c[p>>2]|0)+28>>2]&127](a)|0;oe[c[(c[p>>2]|0)+32>>2]&127](a)|0;re[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(aW(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}rma(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}Ola(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function aW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;cT(b);RS(27,0,147272,g);g=iT(d)|0;if((g|0)==0){j=fT(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=kT(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=kT(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=kT(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=kT(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=kT(a)|0;o=c[g>>2]|0;g=kT(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?146688:146696;g=kT(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?146688:146696;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;RS(27,0,147312,f);dT(b,kT(a)|0)}a=jT(a)|0;}while((a|0)!=0);j=fT(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function bW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;De[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;cW(b);dW(b);oe[c[(c[g>>2]|0)+36>>2]&127](b)|0;eW(b,8);h=fW(b)|0;j=oe[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{dW(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}gW(b);cW(b);eW(b,8);oe[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=fW(b)|0;j=oe[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){VS(c[b+536>>2]|0,147392,e)}else if((o|0)==7){dW(b);i=d;return}}function cW(a){a=a|0;var b=0;b=i;rma(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function dW(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function eW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[116176+(d<<2)>>2]|0)==0){i=e;return}RS(d,1,147816,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=oe[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=oe[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;RS(d,0,147840,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}le[c[29182]&511](d);i=e;return}function fW(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function gW(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;rma(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;rma(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;rma(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;rma(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function hW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}re[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function iW(a){a=a|0;var b=0;b=i;jW(a);kW(a);gW(a);lW(a);i=b;return}function jW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function kW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function lW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((fU(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];rma(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;rma(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;rma(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;rma(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(fU(c[d>>2]|0)|0));i=b;return}function mW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[116176+(d<<2)>>2]|0)==0){i=e;return}RS(d,1,147488,q);q=b+136|0;if((c[q>>2]|0)>0){RS(d,1,147512,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?147472:147480;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];RS(d,0,147528,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}le[c[29182]&511](d)}s=b+140|0;if((c[s>>2]|0)>0){RS(d,1,147584,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?147472:147480;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;RS(d,0,147608,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}le[c[29182]&511](d)}o=b+144|0;if((c[o>>2]|0)>0){RS(d,1,147664,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?147472:147480;v=(a[n+(m*48|0)+40|0]|0)!=0?147472:147480;n=(a[(c[s>>2]|0)+m|0]|0)!=0?147472:147480;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;RS(d,0,147688,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}le[c[29182]&511](d)}m=b+148|0;if((c[m>>2]|0)>0){RS(d,1,147744,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;RS(d,0,147768,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}le[c[29182]&511](d)}le[c[29182]&511](d);i=e;return}function nW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((fU(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];rma(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;rma(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;rma(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;rma(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(fU(c[d>>2]|0)|0));i=b;return}function oW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function pW(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];rma(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;rma(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;rma(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;rma(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function qW(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=aU(3,32)|0;c[o>>2]=p;if((p|0)==0){VS(c[b+536>>2]|0,147872,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=Pla(c[p>>2]|0,8)|0;c[q>>2]=z;US(c[r>>2]|0,(z|0)!=0|0,147928,l);z=Pla(c[s>>2]|0,4)|0;c[t>>2]=z;US(c[r>>2]|0,(z|0)!=0|0,147928,k);z=Pla(c[u>>2]|0,1)|0;c[v>>2]=z;US(c[r>>2]|0,(z|0)!=0|0,147928,j);z=Pla(c[w>>2]|0,4)|0;c[x>>2]=z;US(c[r>>2]|0,(z|0)!=0|0,147928,g);eU(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=Pla(3,4)|0;c[b+4>>2]=n;gU(c[o>>2]|0,0,n);c[b+8>>2]=Pla(c[p>>2]|0,112)|0;c[b+12>>2]=Pla(c[s>>2]|0,60)|0;c[b+16>>2]=Pla(c[u>>2]|0,48)|0;c[b+20>>2]=Pla(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=Pla(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=Pla(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=Pla(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=Pla(g,52)|0;c[b+40>>2]=Pla(c[b+216>>2]|0,52)|0;c[b+44>>2]=Pla(c[b+220>>2]|0,52)|0;c[b+48>>2]=Pla(c[b+224>>2]|0,52)|0;c[b+52>>2]=Pla(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=Pla(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=Pla(x,8)|0;c[b+340>>2]=Pla(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=Pla(x,8)|0;c[b+348>>2]=Pla(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=Pla(j,1)|0;c[b+356>>2]=Pla(j,1)|0;c[b+360>>2]=Pla(j,1)|0;j=Nla(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=Nla(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=Pla(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=Pla(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=Pla(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=Pla(u,4)|0;c[b+400>>2]=Pla(x,8)|0;c[b+404>>2]=Pla(p,4)|0;c[b+408>>2]=Pla(s,1)|0;c[b+412>>2]=Pla(u,4)|0;c[b+416>>2]=Pla(c[n>>2]|0,8)|0;c[b+420>>2]=Pla(o,4)|0;c[b+424>>2]=Pla(y,1)|0;c[b+428>>2]=Pla(g,4)|0;c[b+432>>2]=Pla(c[b+152>>2]|0,8)|0;c[b+436>>2]=Pla(c[b+156>>2]|0,8)|0;g=Nla((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;le[c[(c[y>>2]|0)+20>>2]&511](g);g=Nla((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;le[c[(c[y>>2]|0)+16>>2]&511](g);g=Nla((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;le[c[(c[y>>2]|0)+12>>2]&511](g);g=Nla((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;me[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=Nla((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=Pla(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;US(c[r>>2]|0,(g|0)!=0|0,147944,f);c[b+512>>2]=100;c[b+516>>2]=Pla(100,4)|0;c[b+520>>2]=Pla(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=Nla(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;US(c[r>>2]|0,(g|0)!=0|0,147928,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=aU(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function rW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;Ola(c[g+8>>2]|0);Ola(c[g+12>>2]|0);Ola(c[g+16>>2]|0);Ola(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);Ola(e);bU(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){FU(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}Ola(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){FU(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}Ola(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){FU(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}Ola(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){FU(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}Ola(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){FU(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}Ola(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){FU(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}Ola(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){FU(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}Ola(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){FU(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}Ola(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){FU(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}Ola(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){FU(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}Ola(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){FU(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}Ola(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){FU(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}Ola(v);Ola(c[a+108>>2]|0);Ola(c[a+336>>2]|0);Ola(c[a+340>>2]|0);Ola(c[a+344>>2]|0);Ola(c[a+348>>2]|0);Ola(c[a+352>>2]|0);Ola(c[a+356>>2]|0);Ola(c[a+360>>2]|0);Ola(c[a+368>>2]|0);Ola(c[a+384>>2]|0);Ola(c[a+388>>2]|0);Ola(c[a+392>>2]|0);Ola(c[a+396>>2]|0);Ola(c[a+400>>2]|0);Ola(c[a+404>>2]|0);Ola(c[a+408>>2]|0);Ola(c[a+412>>2]|0);Ola(c[a+416>>2]|0);Ola(c[a+420>>2]|0);Ola(c[a+424>>2]|0);Ola(c[a+428>>2]|0);Ola(c[a+488>>2]|0);Ola(c[a+484>>2]|0);Ola(c[a+476>>2]|0);Ola(c[a+468>>2]|0);Ola(c[a+464>>2]|0);Ola(c[a+432>>2]|0);Ola(c[a+436>>2]|0);Ola(c[a+320>>2]|0);Ola(c[a+516>>2]|0);Ola(c[a+520>>2]|0);f9(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;Ola(x);i=b;return}else{y=a;z=0}while(1){bU(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;Ola(x);i=b;return}function sW(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[18498]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];RS(8,0,147992,d);i=b;return}function tW(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[18498];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function uW(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0;d=i;e=(tW(a,b,c<<24>>24==0|0)|0)<<24>>24==0|0;i=d;return e|0}function vW(a,b){a=+a;b=+b;i=i;return a<b|0}function wW(a,b){a=+a;b=+b;i=i;return a<=b|0}function xW(a,b){a=+a;b=+b;i=i;return a>b|0}function yW(a,b){a=+a;b=+b;i=i;return a>=b|0}function zW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=Nla(k)|0;c[e+(h*40|0)+24>>2]=Nla(k)|0;if((c[g>>2]|0)!=1){l=5;break}CW(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){VS(c[a+536>>2]|0,148048,d)}else if((l|0)==6){i=b;return 0}return 0}function AW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){Ola(c[e+(h*40|0)+20>>2]|0);Ola(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;DW(k)|0;Ola(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){VS(c[a+536>>2]|0,148048,d)}else if((j|0)==6){i=b;return 0}return 0}function BW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[116244>>2]|c[29042]|0)==0){z=w;A=1;break}d9(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];TS(17,1,148080,g);d9(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;d9(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;TS(17,0,148112,f);d9(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}le[c[29182]&511](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function CW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Nla(20)|0;c[b>>2]=f;US(0,(f|0)!=0|0,148120,e);e=Nla(a)|0;c[f>>2]=e;e=Nla(a)|0;c[f+4>>2]=e;e=Nla(a)|0;c[f+8>>2]=e;e=Nla(a)|0;c[f+16>>2]=e;US(0,(c[b>>2]|0)!=0|0,148152,d);i=d;return 0}function DW(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Ola(c[d>>2]|0);Ola(c[d+4>>2]|0);Ola(c[d+8>>2]|0);Ola(c[d+16>>2]|0);i=b;return 0}function EW(a,b){a=a|0;b=b|0;b=i;i=i+8|0;VS(c[a+536>>2]|0,148200,b);return 0}function FW(a){a=a|0;a=i;i=i+8|0;VS(0,148200,a);return 0}function GW(a,b){a=a|0;b=b|0;b=i;i=i+8|0;VS(c[a+536>>2]|0,148200,b);return 0}function HW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=Nla(l)|0;c[e+(h<<6)+36>>2]=Nla(l)|0;m=c[g>>2]|0;if((m|0)==2){c[e+(h<<6)+8>>2]=2;OW(j,j,k,e+(h<<6)+24|0)|0}else if((m|0)==1){c[e+(h<<6)+32>>2]=Nla(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;MW(j,e+(h<<6)+24|0)|0}else{n=6;break}j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{n=8;break}}if((n|0)==6){VS(c[a+536>>2]|0,148240,d)}else if((n|0)==8){i=b;return 0}return 0}function IW(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function JW(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;xb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function KW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){Ola(c[e+(h<<6)+28>>2]|0);Ola(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==1){NW(e+(h<<6)+24|0)|0;Ola(c[e+(h<<6)+32>>2]|0)}else if((j|0)==2){PW(e+(h<<6)+24|0)|0}else{k=6;break}Ola(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){VS(c[a+536>>2]|0,148240,d)}else if((k|0)==8){i=b;return 0}return 0}function LW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[116236>>2]|c[29042]|0)==0){z=w;A=1;break}d9(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];TS(15,1,148272,g);d9(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;d9(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;TS(15,0,148304,f);d9(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}le[c[29182]&511](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function MW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=Nla(12)|0;f=Nla(a<<2)|0;c[e>>2]=f;US(0,(f|0)!=0|0,148312,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function NW(a){a=a|0;var b=0;b=i;Ola(c[c[a>>2]>>2]|0);i=b;return 0}function OW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=Nla(32)|0;US(0,(g|0)!=0|0,148368,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Ld(0,d|0)|0;Sd(c[d>>2]|0,c[b>>2]|0,0)|0;Ld(0,g+4|0)|0;Sd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Mb(148416,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function PW(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;_d(c[d+12>>2]|0)|0;Lb(c[d+8>>2]|0)|0;Lb(c[d+4>>2]|0)|0;i=b;return 0}function QW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;US(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,148584,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){US(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,148624,e);if((oe[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=Nla(p)|0;c[g+(m*80|0)+52>>2]=Nla(p)|0;c[g+(m*80|0)+48>>2]=Nla(p)|0;c[g+(m*80|0)+16>>2]=Nla(p)|0;c[g+(m*80|0)+8>>2]=Nla(p)|0;c[g+(m*80|0)+12>>2]=Nla(p)|0;me[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){bX(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==1){VW(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==3){bX(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){EW(a,n)|0;break}else{q=12;break a}}}while(0);n=m+1|0;if((n|0)<(c[h>>2]|0)){m=n}else{q=14;break}}if((q|0)==12){VS(c[j>>2]|0,148664,d)}else if((q|0)==14){i=b;return 0}return 0}function RW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;Ola(c[e+(h*80|0)+44>>2]|0);Ola(c[e+(h*80|0)+52>>2]|0);Ola(c[e+(h*80|0)+48>>2]|0);Ola(c[e+(h*80|0)+16>>2]|0);Ola(c[e+(h*80|0)+8>>2]|0);Ola(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;cX(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==2){m=7;break a}else if((k|0)==3){n=e+(h*80|0)+40|0;cX(n)|0;l=n;break}else if((k|0)==1){k=e+(h*80|0)+40|0;WW(k)|0;l=k;break}else{m=9;break a}}}while(0);Ola(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{m=11;break}}if((m|0)==7){FW(j)|0}else if((m|0)==9){VS(c[a+536>>2]|0,148664,d)}else if((m|0)==11){i=b;return 0}return 0}function SW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(eX(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==2){j=(GW(b,d)|0)&255;break}else if((k|0)==3){j=(eX(b,d)|0)&255;break}else if((k|0)==1){k=b+536|0;l=(c[k>>2]|0)+84|0;m=c[l>>2]|0;c[l>>2]=3;l=XW(b,d)|0;c[(c[k>>2]|0)+84>>2]=m;j=l&255;break}else{VS(c[b+536>>2]|0,148664,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function TW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;d9(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];SS(17,1,u,148696,m);do{if((a[b+312|0]|0)==0){d9(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;d9(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;TS(17,0,148896,f);d9(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{TS(17,1,148736,l);d9(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;d9(q,d,c[v>>2]|0);if((lma(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];TS(17,0,148816,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;d9(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;TS(17,0,148856,g);G=E}d9(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[116244>>2]|c[29042]|0)==0){break}le[c[29182]&511](17)}}while(0);if((c[116244>>2]|c[29042]|0)==0){x=1;i=e;return x|0}le[c[29182]&511](17);x=1;i=e;return x|0}function UW(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function VW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Nla(144)|0;c[b>>2]=f;US(0,(f|0)!=0|0,148912,e);c[f>>2]=0;e=a<<3;g=Nla(e)|0;c[f+4>>2]=g;g=Nla(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=Nla(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=Nla(e)|0;c[f+24>>2]=g;g=Pla(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=Nla(e)|0;c[f+64>>2]=g;g=Nla(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=Pla(g,8)|0;c[f+104>>2]=j;j=Pla(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=Nla(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=Nla(e)|0;c[f+124>>2]=j;j=Nla(e)|0;c[f+128>>2]=j;j=Nla(e)|0;c[f+132>>2]=j;j=Nla(e)|0;c[f+136>>2]=j;j=Nla(e)|0;c[f+140>>2]=j;US(0,(c[b>>2]|0)!=0|0,148944,d);i=d;return 0}function WW(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Ola(c[d+4>>2]|0);Ola(c[d+16>>2]|0);Ola(c[d+12>>2]|0);Ola(c[d+24>>2]|0);Ola(c[d+28>>2]|0);Ola(c[d+64>>2]|0);Ola(c[d+68>>2]|0);Ola(c[d+104>>2]|0);Ola(c[d+108>>2]|0);Ola(c[d+116>>2]|0);Ola(c[d+124>>2]|0);Ola(c[d+128>>2]|0);Ola(c[d+132>>2]|0);Ola(c[d+136>>2]|0);Ola(c[d+140>>2]|0);i=b;return 0}function XW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=Nla(c[Y>>2]|0)|0;if((c[116244>>2]|0)!=0){d9(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];RS(17,1,148984,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];RS(17,1,149040,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];RS(17,0,149056,F);le[c[29182]&511](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}le[c[29182]&511](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){rma(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{rma(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+yd(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;YW($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+yd(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[116248>>2]|0)!=0){ZW(c[Q>>2]|0,$,18,149096);ZW(c[ca>>2]|0,$,18,149128)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[116248>>2]|0)!=0){ZW(c[ca>>2]|0,$,18,149160)}a[da]=R;oV(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){d9(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];EU(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;YW($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;YW($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}cW(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[116248>>2]|0)!=0){RS(18,1,149200,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];RS(18,1,149240,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];RS(18,0,149272,C);le[c[29182]&511](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}le[c[29182]&511](18)}if((c[116252>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;RS(19,1,149304,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];nc(Ja|0,149328,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;RS(19,0,149336,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}le[c[29182]&511](19)}h[K>>3]=+nV($,c[Ia>>2]|0);h[J>>3]=+nV($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}rma(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){rma(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{rma(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];RS(17,0,149384,w);_W(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}RS(17,0,149456,v);_W(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){rma(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{rma(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+yd(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}RS(17,0,149520,u);_W(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){rma(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{rma(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+yd(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}RS(17,0,149592,t);_W(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}rma(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;rma(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}RS(17,0,149656,s);_W(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){rma(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}RS(17,0,149728,r);_W(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){rma(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{rma(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}RS(17,0,149800,q);_W(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){rma(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{rma(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}RS(17,0,149872,p);_W(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){rma(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}RS(17,0,149936,o);_W(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){rma(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{rma(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}RS(17,0,150008,n);_W(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){rma(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{rma(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];RS(17,0,150144,l);_W(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){rma(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{rma(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}RS(17,0,150072,m);_W(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[116244>>2]|0)!=0){RS(17,1,149344,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;RS(17,0,149360,x);le[c[29182]&511](17);_W(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}rma(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;YW($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;Ola(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;Ola(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;Ola(Z);i=e;return kb|0}if((a[Ha]|0)==0){d9(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];EU(0,f,hb);}if((c[116244>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;RS(17,0,150216,j);_W(S,L,J,K,17)}rma(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;Ola(Z);i=e;return kb|0}return 0}function YW(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[116256>>2]|0)!=0){c[u>>2]=c[y+96>>2];RS(20,0,150464,u);ZW(d,b,20,150496)}Oe[c[x+(m*80|0)+32>>2]&63](l,d,e,j);if((c[116256>>2]|0)!=0){ZW(e,b,20,150512);c[t>>2]=c[y+96>>2];RS(20,0,150528,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[116256>>2]|0)!=0){RS(20,0,150568,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){aX(w,f,d,e,m)}else{$W(w,f,m)}do{if((c[116256>>2]|0)!=0){RS(20,0,150608,r);if((c[116252>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;RS(19,1,149304,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];nc(m|0,150640,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;RS(19,0,149336,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}le[c[29182]&511](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;VS(g,150656,n)}return 0}function ZW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[116176+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;RS(d,1,149336,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];RS(d,0,150448,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}le[c[29182]&511](d);i=f;return}function _W(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[116176+(f<<2)>>2]|0)==0){i=g;return}RS(f,1,150256,q);RS(f,1,150272,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];RS(f,0,150288,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}le[c[29182]&511](f);RS(f,1,150328,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];RS(f,0,150344,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}le[c[29182]&511](f);RS(f,1,150384,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];RS(f,0,150400,j);le[c[29182]&511](f);le[c[29182]&511](f);i=g;return}function $W(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;tma(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;tma(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}oe[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function aX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+yd(+(n*+yd(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;YW(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function bX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Nla(80)|0;c[b>>2]=f;US(0,(f|0)!=0|0,150736,e);c[f>>2]=0;e=a<<3;g=Nla(e)|0;c[f+4>>2]=g;g=Nla(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=Nla(e)|0;c[f+16>>2]=g;g=Pla(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=Nla(fa(e,a)|0)|0;c[f+64>>2]=g;g=Nla(e)|0;c[f+68>>2]=g;g=Nla(a<<2)|0;c[f+72>>2]=g;US(0,(c[b>>2]|0)!=0|0,150768,d);i=d;return 0}function cX(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Ola(c[d+4>>2]|0);Ola(c[d+8>>2]|0);Ola(c[d+16>>2]|0);Ola(c[d+20>>2]|0);Ola(c[d+64>>2]|0);Ola(c[d+68>>2]|0);Ola(c[d+72>>2]|0);i=b;return 0}function dX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;tma(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}oe[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function eX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;rma(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[116244>>2]|0)==0){J=b+4|0}else{d9(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];RS(17,1,150808,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];RS(17,1,150880,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];RS(17,0,150896,t);le[c[29182]&511](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}le[c[29182]&511](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];fX(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){d9(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];EU(3,g,P);}$=+nV(H,c[b>>2]|0);aa=+nV(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){rma(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;RS(17,0,151072,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;RS(17,0,151128,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;RS(17,0,151192,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[116244>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;RS(17,0,150944,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];RS(17,0,150984,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];RS(17,0,151040,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){d9(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];EU(0,f,L);if((c[116244>>2]|0)==0){da=0;break}c[m>>2]=V;RS(17,0,151272,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];RS(17,0,150984,l);if((c[116244>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];RS(17,0,151040,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[116244>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;rma(ma|0,oa|0,qa|0)|0;i=e;return da|0}le[c[29182]&511](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;rma(ma|0,oa|0,qa|0)|0;i=e;return da|0}function fX(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[116248>>2]|0)!=0){c[z>>2]=j;RS(18,0,151312,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];RS(18,0,151360,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){gX(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){hX(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{dX(E,m,r)|0}if((c[116252>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;RS(19,1,151376,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];nc(F|0,151400,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;RS(19,0,151408,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}le[c[29182]&511](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+nV(b,_);if(!(!(J<=H)&!(+nV(b,e)<=H))){$=31;break}BN(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;TS(17,0,151416,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;TS(17,0,151448,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+nV(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function gX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Oe[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&63](e,a,b,d);i=g;return 0}function hX(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+yd(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;gX(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function iX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){jX(a,b);f=0;i=d;return f|0}else if((e|0)==3){f=FV(a,b)|0;i=d;return f|0}else if((e|0)==4){ze[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==1){e=c[a+4>>2]|0;g=c[e+4>>2]|0;kX(c[e>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function jX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[151480+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[151480+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];oe[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function kX(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function lX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=bT(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==2){j=Nla(8)|0;c[j+4>>2]=4;k=Nla(20)|0;c[j>>2]=k;l=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=Pla(l,8)|0;if((k|0)>=4){break}m=c[j>>2]|0;k=k+1|0}c[d+48>>2]=j;n=0}else if((g|0)==3){k=Nla(88)|0;RS(23,0,151512,f);m=DV(b,d,k)|0;c[d+48>>2]=k;n=m}else if((g|0)==4){m=c[1836]|0;k=Nla(m<<2)|0;c[37884]=k;if((m|0)<=0){n=0;break}l=c[b+116>>2]|0;o=k;k=0;while(1){c[o+(k<<2)>>2]=Pla(l,8)|0;p=k+1|0;if((p|0)>=(m|0)){n=0;break a}o=c[37884]|0;k=p}}else{n=0}}while(0);yX(b)|0;if((c[2]|0)==0){i=e;return n|0}uU(6);rU(1);i=e;return n|0}function mX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[b+24>>2]|0;if((e|0)==3){EV(c[b+48>>2]|0)|0}else if((e|0)==2){f=b+48|0;b=c[f>>2]|0;g=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=g;h=0;while(1){Ola(c[b+(h<<2)>>2]|0);j=c[f>>2]|0;k=c[j>>2]|0;if((h|0)<(c[j+4>>2]|0)){h=h+1|0;b=k}else{l=k;break}}}else{l=g}Ola(l);Ola(c[f>>2]|0)}else if((e|0)==4){e=c[1836]|0;f=c[37884]|0;if((e|0)>0){l=f;g=0;while(1){Ola(c[l+(g<<2)>>2]|0);b=g+1|0;h=c[37884]|0;if((b|0)<(e|0)){g=b;l=h}else{m=h;break}}}else{m=f}Ola(m)}zX(a)|0;tX(a);i=d;return 0}function nX(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(290,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=Cma(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=Cma(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=Cma(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=Cma(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=Cma(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(291,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=Cma(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=Cma(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;oma(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Cma(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=Cma(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,151544,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=Cma(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Cma(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,151640,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=Cma(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[157760>>2]|0,157736,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=Cma(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,151696,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=Cma(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(292,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=Cma(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function oX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];RS(8,0,151792,G);I=b+313|0;a[I]=1;bW(b);if((c[173132>>2]|0)==0){me[c[157756>>2]&127](157736,b)}a[I]=0}}while(0);if((e|0)!=0){pX(Ed(e|0)|0,b)}if((c[116276>>2]|0)==0){i=f;return 0}uU(0);RS(25,0,151840,F);RS(25,1,151864,E);H=+mU(6);J=+mU(6);K=J/+mU(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];RS(25,0,151872,D);K=+mU(1);H=+mU(1);J=H/+mU(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];RS(25,0,151912,C);J=+mU(2);K=+mU(2);H=K/+mU(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];RS(25,0,151944,B);H=+mU(3);J=+mU(3);K=J/+mU(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];RS(25,0,151968,A);K=+mU(4);H=+mU(4);J=H/+mU(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];RS(25,0,152008,z);J=+mU(7);K=+mU(7);H=K/+mU(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(25,0,152040,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+mU(0);J=H- +mU(7);H=J- +mU(4);J=H- +mU(3);H=J- +mU(2);J=H- +mU(1);H=J- +mU(6);J=+mU(0);K=J- +mU(7);J=K- +mU(4);K=J- +mU(3);J=K- +mU(2);K=J- +mU(1);J=K- +mU(6);K=J/+mU(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(25,0,152104,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];RS(25,0,152072,x)}K=+mU(0);H=+mU(0);J=H/+mU(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];RS(25,0,152136,v);le[c[29182]&511](25);RS(25,1,152160,u);c[t>>2]=c[d+40>>2];RS(25,0,152168,t);c[s>>2]=c[d+44>>2];RS(25,0,152192,s);le[c[29182]&511](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);RS(25,1,152216,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];RS(25,0,152232,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];RS(25,0,152248,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];RS(25,0,152280,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];RS(25,0,152312,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];RS(25,0,152336,m);le[c[29182]&511](25)}else if((s|0)!=5){RS(25,1,152368,l);RS(25,0,152376,j);le[c[29182]&511](25)}RS(25,0,152440,g);rU(0);i=f;return 0}function pX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=_b(b|0,152912)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];Bd(b|0,152920,y|0)|0;if((z|0)==0){C=Yd(10,b|0)|0;D=zd(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((lma(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Bd(b|0,152936,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((lma(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;Bd(b|0,152952,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((lma(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;Bd(b|0,152960,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((lma(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;Bd(b|0,152968,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((lma(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Bd(b|0,152936,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];Bd(b|0,152936,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((lma(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;Bd(b|0,152952,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;Bd(b|0,152952,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((lma(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;Bd(b|0,152960,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;Bd(b|0,152960,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((lma(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;Bd(b|0,152968,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((lma(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];Bd(b|0,152936,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((lma(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;Bd(b|0,152952,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((lma(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;Bd(b|0,152960,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((lma(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;Bd(b|0,152968,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=_b(0,152912)|0;}while((d|0)!=0);C=Yd(10,b|0)|0;D=zd(b|0)|0;i=e;return}function qX(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 4:{v=c[1834]|0;if((v|0)!=0){if((lma(v,152576)|0)==0){break a}}RS(23,0,152592,p);w=1;i=m;return w|0};case 11:case 10:case 9:case 6:case 7:case 8:{TS(1,0,152464,r);w=1;i=m;return w|0};case 5:{TS(1,0,152536,q);w=1;i=m;return w|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 18:{v=c[1834]|0;do{if((v|0)!=0){if((lma(v,152720)|0)!=0){break}c[u>>2]=4;break a}}while(0);RS(23,0,152744,o);w=1;i=m;return w|0};default:{}}}while(0);o=lX(a,s)|0;Ie[c[117076>>2]&7]()|0;do{if((o|0)==0){q=nX(a,b,d,e,f,g)|0;Ie[c[117076>>2]&7]()|0;if((q|0)!=0){x=q;break}if((c[u>>2]|0)!=5){me[c[157756>>2]&127](157736,a);lW(a)}y=+h[a+248>>3];q=n;h[k>>3]=+h[a+240>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];q=n+8|0;h[k>>3]=y;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];RS(23,0,152872,n);q=De[c[c[a+540>>2]>>2]&63](a,t)|0;Ie[c[117076>>2]&7]()|0;oX(a,s,l)|0;Ie[c[117076>>2]&7]()|0;x=q}else{Ie[c[117076>>2]&7]()|0;x=o}}while(0);mX(a,s)|0;w=x;i=m;return w|0}function rX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){sX(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((oe[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){VS(c[a+536>>2]|0,152984,d)}else if((k|0)==6){sX(a);i=b;return}}function sX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;tma(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function tX(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;Ola(c[f+(a*48|0)+28>>2]|0);Ola(c[f+(a*48|0)+32>>2]|0);Ola(c[f+(a*48|0)+16>>2]|0);Ola(c[f+(a*48|0)+20>>2]|0);Ola(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}



function OU(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==0){c[31656]=2;B=2;while(1){C=B+1|0;if(!((c[k+(B+ -1<<2)>>2]|0)>>>0<2)){D=210;break a}c[31656]=C;if((C|0)<12){B=C}else{break}}if((c[d>>2]|0)<1){w9(126680,128376,80,25);B=126984;C=126992;NU(126680,128408,127160,B,127064,d,B,B,C,C,80)|0;break}c[31720]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{B=c[C>>2]|0;c[31720]=B;if(!((B+ -1|0)>>>0>4)){E=B;break}w9(126680,128416,80,34);B=126984;F=126992;NU(126680,128456,127152,B,127064,126880,B,B,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;B=fa(F,F)|0;c[31706]=B;c[31718]=B+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);B=q+12|0;if((c[k+16>>2]|0)==0){c[B>>2]=2;break}else{c[B>>2]=1;break}}else{B=c[q>>2]|0;do{if((B|0)>=0){F=c[d>>2]|0;if((B|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){w9(126680,129240,80,52);I=126984;J=126992;NU(126680,129224,129296,I,127064,G,I,I,J,J,80)|0;break a}c[31706]=fa((B<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[31718]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[31706]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[31718]=F+(c[31706]|0);break b}}}while(0);w9(126680,129168,80,52);B=126984;F=126992;NU(126680,129224,129232,B,127064,q,B,B,F,F,80)|0;break a}}while(0);c[31710]=(c[d>>2]|0)+20;c[q+64>>2]=c[31706];if((c[p>>2]|0)<(c[31718]|0)){w9(126680,128464,80,60);C=126984;F=126992;NU(126680,128528,128536,C,127160,126872,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[31710]|0)){w9(126680,128544,80,60);F=126984;C=126992;NU(126680,128528,128608,F,127160,126840,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){D=227;break}if((c[w>>2]|0)<0){w9(126680,129352,80,24);C=127064;F=126984;B=126992;NU(126680,129384,129392,C,C,w,F,F,B,B,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[15850]=K;if(!(K<=0.0)){break}w9(126680,128848,80,28);B=126984;NU(126680,127560,128880,B,B,B,B,127064,126800,126992,80)|0;break a}}while(0);c[q+60>>2]=0;B=q+36|0;c[B+0>>2]=0;c[B+4>>2]=0;c[B+8>>2]=0;c[B+12>>2]=0;c[n>>2]=1;D=27}else if((A|0)==1){c[q+36>>2]=c[q+40>>2];D=27}else if((A|0)==-1){w9(126680,126912,80,49);B=126984;F=126992;NU(126680,126968,126976,B,B,B,B,B,F,F,80)|0;w9(126680,127e3,80,47);F=126984;B=126992;NU(126680,127048,127056,F,127064,n,F,F,B,B,80)|0;w9(126680,127072,80,41);B=126984;F=126992;NU(126680,127120,127128,127064,B,B,B,B,F,F,80)|0;i=y;return 0}else{D=210}}while(0);c:do{if((D|0)==27){a[126856]=0;K=+h[l>>3];h[15861]=K;L=+h[m>>3];h[15854]=L;A=c[d>>2]|0;c[31656]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[15861]=O;P=+h[m+(F<<3)>>3];h[15854]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[126856]=1;S=1}else{S=p}if(Q<0.0){D=215;break}if(R<0.0){D=216;break}F=E+1|0;c[31656]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{D=36;break}}if((D|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[31666]=p;r=p+(c[w>>2]|0)|0;c[31668]=r;p=r+(c[w>>2]|0)|0;c[31690]=p;F=p+(c[w>>2]|0)|0;c[31660]=F;B=F+(c[d>>2]|0)|0;c[31696]=B;C=B+(c[d>>2]|0)|0;c[31702]=C;c[31692]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[31716]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){B=o+64|0;h[15863]=+h[B>>3];a[126792]=0;h[15832]=+h[o+24>>3];J=o+16|0;h[15827]=+h[J>>3];do{if((c[w>>2]|0)!=0){PU(127160,v,w,d,126656,j,f,o+(F+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,126776,B,0,o,q,s,t)|0;if((c[31786]|0)>0){i=y;return 0}if((c[31694]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=127064;kV(d,o+((c[31660]|0)+ -1<<3)|0,G,g,G)|0;a[126792]=1;D=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[15827];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[15827]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){D=227;break c}P=+h[15827];if((M-N)*P>0.0){D=220;break}B=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[15862]=O;U=+h[15832];V=U-O;G=V*P>0.0;do{if(B){if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[31702]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){UU(126656,j,f,g,d,H,I,X)|0;if((c[31786]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[126792]=1;D=197;break d}}else{Y=126656;UU(Y,Y,f,g,d,H,I,X)|0;if((c[31786]|0)>0){i=y;return 0}else{h[e>>3]=+h[15832];c[n>>2]=1;a[126792]=1;D=197;break d}}}else{if(G){D=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){D=218;break d}if(P*(U-W)<0.0){break}UU(126656,j,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[126792]=1;D=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[15863]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[15827]=W;h[J>>3]=W;break}UU(126656,126896,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[15862];a[126792]=1;D=197;break d}}else{W=+h[15832];if(!B){if(P*(W-N)<0.0){break}UU(126656,j,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[126792]=1;D=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[31702]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){UU(126656,j,f,g,d,G,X,I)|0;if((c[31786]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[126792]=1;D=197;break d}}else{H=126656;UU(H,H,f,g,d,G,X,I)|0;if((c[31786]|0)>0){i=y;return 0}else{h[e>>3]=+h[15832];c[n>>2]=1;a[126792]=1;D=197;break d}}}}while(0);if(a[126792]&1){D=197}else{D=128}}else{h[15832]=+h[e>>3];c[n>>2]=1;RU(d,k+4|0,l,m,f,o+((c[31696]|0)+ -1<<3)|0,s,t)|0;B=c[d>>2]|0;c[31656]=1;e:do{if((B|0)>=1){J=c[31696]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[31656]=X;if((I|0)<(B|0)){I=X}else{break e}}w9(126680,128984,80,39);I=126984;J=126992;NU(126680,128656,129024,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+YU(127136,1);h[15863]=U;B=o+64|0;h[B>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[15863]*4.0*(aa>=ba?aa:ba);h[15852]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){w9(126680,129032,80,60);J=126984;NU(126680,128528,129096,J,J,J,J,127160,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[15831]=ca*.001;U=+SU(d,g,o+((c[31696]|0)+ -1<<3)|0,s,t);if(U>.5/+h[15831]){h[15831]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+t9(126648,z);h[15831]=U;da=U}else{U=+h[o+16>>3];h[15831]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){D=220;break d}if(!(U==0.0)){da=U;break}w9(126680,128936,80,29);J=126984;I=126992;NU(126680,128968,128976,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[15831]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[15862]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){D=224;break}if(ea*(U+ea-O)>0.0){h[15831]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){D=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{TU(126656,f,g,d,b,u,126648,o+((c[31696]|0)+ -1<<3)|0,n,s,t,o+((c[31702]|0)+ -1<<3)|0,o+400|0,o+((c[31660]|0)+ -1<<3)|0,o+((c[31692]|0)+ -1<<3)|0,q,126816,B,k+36|0,126864)|0;if((c[31786]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;D=129;break}ja=+h[15831]}h[15827]=ja;h[o+16>>3]=ja;J=c[31702]|0;X=(c[d>>2]|0)+J|0;c[31712]=X;G=c[d>>2]|0;c[31656]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[15827]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[31656]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[15827];h[o+232>>3]=+h[15827]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){D=128;break}PU(127064,v,w,d,e,j,f,o+((c[31660]|0)+ -1<<3)|0,o+((c[31702]|0)+ -1<<3)|0,J,Y,o+((c[31666]|0)+ -1<<3)|0,o+((c[31668]|0)+ -1<<3)|0,o+((c[31690]|0)+ -1<<3)|0,x,126776,B,0,o,q,s,t)|0;if((c[31786]|0)>0){i=y;return 0}if((c[31694]|0)!=0){w9(126680,129400,80,47);la=126984;ma=126992;NU(126680,127048,129448,127064,la,la,la,la,ma,ma,80)|0;w9(126680,129456,80,38);ma=126984;la=126992;NU(126680,127208,129448,127064,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){D=128;break}if((c[I>>2]|0)==0){D=128;break}PU(127152,v,w,d,126656,j,f,o+((c[31660]|0)+ -1<<3)|0,o+((c[31702]|0)+ -1<<3)|0,J,Y,o+((c[31666]|0)+ -1<<3)|0,o+((c[31668]|0)+ -1<<3)|0,o+((c[31690]|0)+ -1<<3)|0,x,126776,B,0,o,q,s,t)|0;if((c[31786]|0)>0){i=y;return 0}if((c[31694]|0)!=1){D=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=127064;kV(d,o+((c[31660]|0)+ -1<<3)|0,H,g,H)|0;D=197}}while(0);if((D|0)==218){w9(126680,128776,80,54);p=126984;NU(126680,128832,128840,p,p,p,p,127160,126896,j,80)|0;break c}else if((D|0)==220){w9(126680,128888,80,34);p=126984;NU(126680,128456,128928,p,p,p,p,127160,j,e,80)|0;break c}else if((D|0)==224){w9(126680,129104,80,49);p=126984;NU(126680,126968,129160,p,p,p,p,127160,126896,e,80)|0;break c}f:while(1){if((D|0)==128){D=0;ka=c[n>>2]|0;D=129;continue}else if((D|0)==129){D=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){D=131;break}oa=k+4|0;RU(d,oa,l,m,o+((c[31702]|0)+ -1<<3)|0,o+((c[31696]|0)+ -1<<3)|0,s,t)|0;if((c[31786]|0)>0){D=233;break}p=c[d>>2]|0;c[31656]=1;r=c[31696]|0;if((p|0)>=1){E=1;while(1){C=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){D=136;break f}c[31656]=C;if((E|0)<(p|0)){E=C}else{break}}}O=+SU(d,o+((c[31702]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[15863];pa=O*V;h[15829]=pa;if(!(pa<=1.0)){D=138;break}O=+h[15832];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[15852]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[15827];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[15827]=V/O}}while(0);VU(126656,f,g,d,b,u,126616,o+((c[31696]|0)+ -1<<3)|0,k,n,s,t,o+((c[31702]|0)+ -1<<3)|0,o+400|0,o+((c[31660]|0)+ -1<<3)|0,o+((c[31692]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,126816,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,126864)|0;if((c[31786]|0)>0){D=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){PU(127152,v,w,d,126656,j,f,o+((c[31660]|0)+ -1<<3)|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[31666]|0)+ -1<<3)|0,o+((c[31668]|0)+ -1<<3)|0,o+((c[31690]|0)+ -1<<3)|0,x,126776,o+64|0,0,o,q,s,t)|0;if((c[31786]|0)>0){D=233;break f}if((c[31694]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=127064;kV(d,o+((c[31660]|0)+ -1<<3)|0,r,g,r)|0;D=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[15832];V=+h[15827];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){D=128;continue}UU(126656,j,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;D=197;continue}UU(126656,j,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){D=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];D=197;continue}if(r){if(U>=0.0){UU(126656,j,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}N=O- +h[15862];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[15863]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;D=197;continue}UU(126656,126896,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[15862];D=197;continue}if(!(U<0.0)){UU(126656,j,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){D=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;D=197;continue}U=+h[15862];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[15863]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){D=128;continue}h[15827]=U-O;D=128;continue}else{UU(126656,126896,f,g,d,q+28|0,o+((c[31702]|0)+ -1<<3)|0,o+224|0)|0;if((c[31786]|0)>0){D=233;break}c[n>>2]=2;h[e>>3]=+h[15862];D=197;continue}}else if((D|0)==197){D=0;h[o+24>>3]=+h[15832];h[o+16>>3]=+h[15827];h[o+328>>3]=+h[e>>3];D=233;break}}do{if((D|0)==131){c[n>>2]=-1;na=-1}else if((D|0)==136){c[n>>2]=-3;na=-3}else if((D|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[15829]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[31656]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){B=l+(p<<3)|0;h[B>>3]=O*+h[B>>3];B=m+(E+ -1<<3)|0;h[B>>3]=+h[15829]*+h[B>>3];if((E|0)>=(r|0)){break}B=E;O=+h[15829];E=E+1|0;p=B}c[31656]=r+1}c[n>>2]=-2;na=-2}else if((D|0)==233){i=y;return 0}}while(0);p=0-na|0;c[31712]=p;switch(p|0){case 2:{w9(126680,127296,80,47);p=126984;NU(126680,127048,127344,p,p,p,p,127064,126656,126992,80)|0;w9(126680,127352,80,48);p=126984;E=126992;NU(126680,127280,127408,p,p,p,p,p,E,E,80)|0;w9(126680,127416,80,45);E=126984;p=126992;NU(126680,127464,127472,E,E,E,E,E,p,p,80)|0;break};case 3:{w9(126680,127480,80,38);p=126984;NU(126680,127208,127520,p,p,p,p,127064,126656,126992,80)|0;w9(126680,127528,80,28);p=126984;E=126992;NU(126680,127560,127568,p,p,p,p,p,E,E,80)|0;break};case 9:{w9(126680,127576,80,44);E=126984;NU(126680,127624,127896,E,E,E,E,127160,126656,126616,80)|0;w9(126680,127904,80,49);E=126984;p=126992;NU(126680,126968,127960,E,E,E,E,E,p,p,80)|0;w9(126680,127968,80,38);p=126984;E=126992;NU(126680,127208,128008,p,p,p,p,p,E,E,80)|0;break};case 10:{w9(126680,127576,80,44);E=126984;NU(126680,127624,128016,E,E,E,E,127160,126656,126616,80)|0;w9(126680,128024,80,45);E=126984;p=126992;NU(126680,127464,128072,E,E,E,E,E,p,p,80)|0;w9(126680,128080,80,36);p=126984;E=126992;NU(126680,128120,128128,p,p,p,p,p,E,E,80)|0;break};case 6:{w9(126680,127576,80,44);E=126984;NU(126680,127624,127632,E,E,E,E,127160,126656,126616,80)|0;w9(126680,127640,80,57);E=126984;p=126992;NU(126680,127704,127712,E,E,E,E,E,p,p,80)|0;break};case 7:{w9(126680,127576,80,44);p=126984;NU(126680,127624,127720,p,p,p,p,127160,126656,126616,80)|0;w9(126680,127728,80,48);p=126984;E=126992;NU(126680,127280,127784,p,p,p,p,p,E,E,80)|0;w9(126680,127792,80,28);E=126984;p=126992;NU(126680,127560,127824,E,E,E,E,E,p,p,80)|0;break};case 8:{w9(126680,127576,80,44);p=126984;NU(126680,127624,127832,p,p,p,p,127160,126656,126616,80)|0;w9(126680,127840,80,37);p=126984;E=126992;NU(126680,127880,127888,p,p,p,p,p,E,E,80)|0;break};case 11:{w9(126680,128136,80,40);E=126984;NU(126680,128184,128192,E,E,E,E,127160,126656,126616,80)|0;w9(126680,128200,80,36);E=126984;p=126992;NU(126680,128120,128240,E,E,E,E,E,p,p,80)|0;break};case 12:{w9(126680,127576,80,44);p=126984;NU(126680,127624,128248,p,p,p,p,127160,126656,126648,80)|0;w9(126680,128256,80,45);p=126984;E=126992;NU(126680,127464,128304,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{w9(126680,127168,80,38);E=126984;NU(126680,127208,127216,E,E,E,E,127064,126656,126992,80)|0;w9(126680,127224,80,48);E=126984;p=126992;NU(126680,127280,127288,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[15832];h[o+24>>3]=+h[15832];h[o+16>>3]=+h[15827];i=y;return 0}else if((D|0)==215){w9(126680,128616,80,39);p=126984;E=126992;NU(126680,128656,128664,p,p,p,p,p,E,E,80)|0;break c}else if((D|0)==216){w9(126680,128672,80,39);E=126984;p=126992;NU(126680,128656,128712,E,E,E,E,E,p,p,80)|0;break c}}}while(0);w9(126680,128720,80,47);A=126984;p=126992;NU(126680,127048,128768,A,A,A,A,A,p,p,80)|0}else if((D|0)==210){w9(126680,128312,80,55);p=126984;A=126992;NU(126680,128368,127064,p,p,p,p,p,A,A,80)|0}}while(0);if((D|0)==227){w9(126680,129304,80,39);D=126984;NU(126680,128656,129344,D,D,D,D,127160,j,e,80)|0}if((c[k>>2]|0)==-1){w9(126680,129496,80,46);e=126984;j=126992;NU(126680,129544,129552,e,e,e,e,e,j,j,80)|0;w9(126680,129560,80,47);j=126984;e=126992;NU(126680,127048,129608,127064,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function PU(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[16202]=C;c[t>>2]=0;D=c[e>>2]|0;c[32406]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[32406]|0;E=F+1|0;c[32406]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[16209]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;UU(g,b,k,l,f,o,m,n)|0;if((c[31786]|0)>0){i=v;return 0}D=d;he[D&7](f,b,k,e,p,y,z)|0;if((c[31786]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[129680]=0;F=c[e>>2]|0;c[32406]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[129680]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[32406]=F+1;if(!M){break}I=+t9(129672,129616);h[16206]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[16202];do{if((H- +h[g>>3])*I<0.0){UU(g,b,k,l,f,o,m,n)|0;if((c[31786]|0)<=0){break}i=v;return 0}else{G=+h[16206]/I;h[16207]=G;N=c[f>>2]|0;c[32406]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[16207];Q=Q+1|0}c[32406]=N+1}}while(0);he[D&7](f,b,k,e,p,y,z)|0;if((c[31786]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[129680]=0;F=c[e>>2]|0;c[32406]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[129680]=1;V=1;W=c[32406]|0}Q=W+1|0;c[32406]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[16202];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;UU(g,F,k,l,f,o,m,n)|0;if((c[31786]|0)>0){i=v;return 0}E=d;he[E&7](f,F,k,e,p,y,z)|0;if((c[31786]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[129680]=0;D=c[e>>2]|0;c[32406]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[129680]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[32406]=D+1;if(!aa){i=v;return 0}I=+t9(129672,129616);h[16206]=I;h[F>>3]=I+ +h[F>>3];I=+h[16206]/+h[16202];h[16207]=I;Q=c[f>>2]|0;c[32406]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[16207];R=R+1|0}c[32406]=Q+1}he[E&7](f,F,k,e,p,y,z)|0;if((c[31786]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[129680]=0;R=c[e>>2]|0;c[32406]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[129680]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[32406]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[16205]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}UU(g,129640,k,l,f,o,m,n)|0;if((c[31786]|0)<=0){break}i=v;return 0}else{h[16205]=Y;j=c[f>>2]|0;c[32406]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[32406]=j+1}}while(0);ga=d;he[ga&7](f,129640,k,e,q,y,z)|0;if((c[31786]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[32416]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){QU(e,129672,129664,R,129640,p,q,r,129632,s,fa,da,x,ca)|0;if((c[31786]|0)>0){ha=76;break}if((c[32416]|0)>1){ha=73;break}UU(g,129632,k,l,f,o,m,n)|0;if((c[31786]|0)>0){ha=76;break}he[ga&7](f,129632,k,e,r,y,z)|0;if((c[31786]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[16204];R=127064;kV(e,r,R,p,R)|0;if((c[32416]|0)==4){i=v;return 0}UU(g,129632,k,l,f,o,m,n)|0;if((c[31786]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function QU(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[32432]=c[o>>2];c[o>>2]=0;h[16212]=0.0;a[129712]=0;t=c[b>>2]|0;c[32422]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+t9(129744,j+(v<<3)|0);if(w==+t9(129744,l+((c[32422]|0)+ -1<<3)|0)){break}y=c[32422]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[16212]){break}h[16212]=B;c[o>>2]=y}else{a[129712]=1}}while(0);v=c[32422]|0;u=v+1|0;c[32422]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[129720]=1;c[32434]=c[p>>2];h[g>>3]=+h[r>>3];t=127064;kV(b,l,t,k,t)|0;c[p>>2]=1;a[129704]=0;C=0}else{a[129720]=0;c[o>>2]=c[32432];c[32434]=c[p>>2];if(a[129712]&1){h[g>>3]=+h[r>>3];t=127064;kV(b,l,t,k,t)|0;a[129704]=1;C=1;break}else{t=127064;kV(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[129704]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[129704]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=127064;kV(b,k,t,l,t)|0;t=c[b>>2]|0;c[32422]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[32422]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+t9(129744,j+(u<<3)|0);if(!(A!=+t9(129744,k+((c[32422]|0)+ -1<<3)|0))){break}c[n+((c[32422]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[32422]|0;F=u+1|0;c[32422]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[16212]=0.0;a[129712]=0;t=c[b>>2]|0;c[32422]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+t9(129744,j+(v<<3)|0);if(A==+t9(129744,k+((c[32422]|0)+ -1<<3)|0)){break}y=c[32422]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[16212]){break}h[16212]=I;c[o>>2]=y}else{a[129712]=1}}while(0);v=c[32422]|0;u=v+1|0;c[32422]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[129720]=t&1;if(t){a[129704]=0;c[32434]=0;c[p>>2]=1;break}if(!(a[129712]&1)){t=127064;kV(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=127064;kV(b,k,t,l,t)|0;t=c[b>>2]|0;c[32422]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[32422]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[32422]|0}u=K+1|0;c[32422]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[32434]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function RU(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[16221]=+h[d>>3];h[16220]=+h[e>>3];j=c[a>>2]|0;c[32438]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[16221]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[16221]=o;h[16220]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[16220];a=l+1|0;c[32438]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function SU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[16224]=0.0;e=c[a>>2]|0;c[32444]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[16224]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[32444]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[16223]=0.0;e=c[a>>2]|0;c[32444]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[16223]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[32444]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function TU(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[32462]=0;c[32460]=0;c[32466]=0;h[16236]=+h[b>>3];h[16238]=+SU(f,d,l,0,0);C=c[f>>2]|0;c[32450]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[32450]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[16229]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[32450]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[32450]=G+1}a[129896]=1;c[32452]=0;a[129912]=1;c[C>>2]=(c[C>>2]|0)+1;c[32470]=0;he[B&7](b,d,e,q,129880,n,o)|0;b:do{if((c[32470]|0)<0){K=35}else{while(1){if(a[129896]&1){c[E>>2]=(c[E>>2]|0)+1;a[129896]=0;WU(f,b,d,e,q,129832,k,129856,l,r,s,t,g,129880,v,j,n,o,x)|0;h[16228]=1.0e6;if((c[32470]|0)<0|(c[32464]|0)!=0){K=35;break b}c[32466]=0}H=c[f>>2]|0;c[32450]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[32450]=H+1}XU(f,q,s,t)|0;I=c[f>>2]|0;c[32450]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[16229]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[32450]=I+1}N=+SU(f,q,l,0,0);h[16240]=N;if(N<=+h[v>>3]*100.0*+h[16238]){break}J=c[32452]|0;if((J|0)>0){h[z>>3]=N/+h[16241];h[A>>3]=1.0/+(J|0);O=+r9(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[16228]=P;Q=+h[16240];R=P}else{h[16241]=N;Q=N;R=+h[16228]}if(R*Q<=.33){break}J=c[32452]|0;H=J+1|0;c[32452]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[129896]=1}c[C>>2]=(c[C>>2]|0)+1;c[32470]=0;he[B&7](b,d,e,q,129880,n,o)|0;if((c[32470]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[32450]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[32450]=H+1}N=+SU(f,q,l,0,0);h[16240]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[32450]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[16229]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[32450]=J+1}}while(0);if(!(a[129912]&1)){break}H=c[f>>2]|0;c[32450]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[32450]=H+1}N=+SU(f,r,l,0,0);h[16234]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[129912]=0}h[b>>3]=+h[16236];G=c[f>>2]|0;c[32450]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[32450]=G+1}if(a[129912]&1){I=(c[32462]|0)+1|0;c[32462]=I;N=.9/(+h[16234]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[16227]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[32464]|0)!=0){I=(c[32466]|0)+1|0;c[32466]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[32470]|0)>-2)){K=53;break}I=(c[32460]|0)+1|0;c[32460]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function UU(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[32496]=o;p=+h[b>>3]- +h[a>>3];h[16246]=p;a=c[f>>2]|0;c[32488]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[32488]=a+1;q=+h[16246]}h[16242]=1.0;h[16243]=0.0;p=q/+h[k>>3];h[16247]=p;c[32490]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[16243]=u*t+s/+h[a>>3];p=t*s;h[16242]=p;h[16247]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[32488]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[16243]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[16242];g=g+1|0}c[32488]=a+1}g=v+1|0;c[32490]=g;if((v|0)>=(o|0)){break}r=+h[16246];s=+h[16242];t=+h[16247];u=+h[16243];v=g}i=l;return 0}function VU(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[16269]=+h[b>>3];c[32516]=0;c[32524]=0;c[32518]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[16281]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[32512]=(c[I>>2]|0)+1;c[32514]=(c[I>>2]|0)+2;c[32510]=(c[I>>2]|0)+ -1;h[16269]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[32528]=$+1;$=c[32512]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[16272]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[32498]=2;if(($|0)>=2){Y=2;while(1){h[16273]=+h[y+(Y+ -2<<3)>>3];U=+h[16272];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[16273];U=+h[16273]+ +h[k>>3];h[16272]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[32498]=$+1}h[y+($+ -1<<3)>>3]=+h[16272]}h[16279]=0.0;h[16277]=0.0;Y=c[I>>2]|0;c[32498]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[16279]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[16277]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[32498]=Y+1;da=ea}h[16280]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[16279]- +h[16277];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[16254]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[16254]=ha>=ca?ha:ca;h[16272]=.6;h[16273]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[16280]){h[D>>3]=100.0}aa=c[32512]|0;ba=c[32528]|0;if((aa|0)>=(ba|0)){c[32500]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[32498]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[32498]=ba+1}ja=ia+1|0;c[32500]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[32498]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[32498]=ia+1}aa=c[32512]|0;c[32500]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[32498]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[32498]=$+1}la=ba+1|0;c[32500]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[16276]=+SU(f,d,l,0,0);a[130256]=1;c[32502]=0;c[T>>2]=(c[T>>2]|0)+1;c[32532]=0;he[m&7](b,d,e,r,130128,o,p)|0;if((c[32532]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;WU(f,b,d,e,r,A,k,130080,l,s,t,u,g,130128,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[32532]|0)<0|(c[32520]|0)!=0){X=70;break}c[32524]=0}ba=c[f>>2]|0;c[32498]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[32498]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[16272]=ca;aa=c[f>>2]|0;c[32498]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[16272];ia=ia+1|0;la=ka}c[32498]=aa+1}XU(f,r,t,u)|0;la=c[f>>2]|0;c[32498]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[32498]=la+1}U=+SU(f,r,l,0,0);h[16281]=U;if(U<=+h[F>>3]*100.0*+h[16276]){X=63;break a}ia=c[32502]|0;if((ia|0)>0){h[O>>3]=U/+h[16283];h[P>>3]=1.0/+(ia|0);ca=+r9(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[16281];oa=ga}else{h[16283]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[32502]|0;c[32502]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[32532]=0;he[m&7](b,d,e,r,130128,o,p)|0;if((c[32532]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[32498]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[32498]=ba+1}U=+SU(f,r,l,0,0);h[16281]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[32498]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[32498]=ia+1}}while(0);if((X|0)==70){X=0;a[130256]=0}c[H>>2]=1;if(a[130256]&1){U=+SU(f,s,l,0,0);h[16275]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[16261]=ga;h[16268]=ga*+(ba+1|0);h[16263]=ga;c[32534]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[32498]=1;if((ba|0)>=1){aa=fa(c[32512]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[32498]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+SU(f,r,l,0,0);h[16270]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[16278]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[32498]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[32498]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+SU(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[16278];if((sa>=ca?sa:ca)>+h[16268]){break}ta=+h[16270];ua=Y}else{if(!(ga<=+h[16268]*.5)){break}else{ta=U;ua=ka}}c[32534]=ua+ -1;h[16263]=ta}}while(0);if(!(+h[16254]*+h[16275]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[16269];Y=c[32512]|0;ia=c[32528]|0;if((Y|0)>=(ia|0)){c[32500]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[16272]=ca;ia=c[f>>2]|0;c[32498]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[16272];ja=ja+1|0}c[32498]=ia+1}ja=aa+1|0;c[32500]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[32498]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[32498]=Y+1}if(!(a[130256]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[32520]|0)!=0){aa=(c[32524]|0)+1|0;c[32524]=aa;h[16252]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[32532]|0)>-2)){X=146;break}aa=(c[32516]|0)+1|0;c[32516]=aa;h[16252]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[32518]=(c[32518]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[32518]|0;if((aa|0)<=1){ja=c[32534]|0;c[I>>2]=ja;sa=+(ja+1|0);h[16273]=sa;h[O>>3]=+h[16263]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+r9(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[16252]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[32534];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[32548]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[32534]|0;E=c[32510]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[32512];za=+h[k>>3]*2.0;h[16265]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[32510]|0;Ba=c[32534]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[32512]|0)>=(c[K>>2]|0)|(c[32548]|0)==1){Fa=G;break}G=c[f>>2]|0;c[32498]=1;if((G|0)>=1){E=fa(c[32514]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[32498]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+SU(f,r,l,0,0);h[16271]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[16268];E=xa<=za;if(+h[16278]<=(E?xa:za)){Ea=c[32510]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[16268]*.5){Fa=S;break}}S=c[32512]|0;c[I>>2]=S;h[16263]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[16263]=+h[16270];Fa=Ea}h[16265]=+h[k>>3];ya=+(Fa+1|0);h[16273]=ya;h[O>>3]=+h[16263]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+r9(O,P);h[16252]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[16265];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[16252]=xa;za=+h[k>>3]*xa;h[16265]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[16265]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[32498]=1;if((k|0)<1){break}u=fa(c[32514]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[32498]=k+1}}while(0);Ca=c[f>>2]|0;c[32498]=1;if((Ca|0)>=1){J=fa(c[32512]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[32498]=Ca+1}Ca=c[32512]|0;c[32506]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[32500]=P;s=c[f>>2]|0;c[32498]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[32498]=s+1}P=Ha+1|0;c[32506]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[32532]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[32518]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}UU(b,b,d,e,f,I,q,y)|0;i=N;return 0}function WU(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==2){c[s>>2]=0;c[32590]=0;h[16296]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[32568]=1;b:do{if((P|0)>=1){Q=r;R=1;while(1){S=R+ -1|0;T=+h[e+(S<<3)>>3];h[N>>3]=T;if(!(T>=0.0)){U=-T}else{U=T}W=f+(S<<3)|0;T=+h[l>>3]*+h[W>>3];if(!(T>=0.0)){X=-T}else{X=T}T=U>=X?U:X;Y=+h[n+(S<<3)>>3];if(!(Y>=0.0)){Z=-Y}else{Z=Y}h[16293]=+h[16296]*(T>=Z?T:Z);h[N>>3]=+h[l>>3]*+h[W>>3];T=+t9(130344,N);h[16293]=T;W=(c[32568]|0)+ -1|0;S=e+(W<<3)|0;Y=+h[S>>3];_=T+Y-Y;h[16293]=_;h[16300]=+h[S>>3];$=f+(W<<3)|0;h[16304]=+h[$>>3];h[S>>3]=_+ +h[S>>3];h[$>>3]=+h[j>>3]*+h[16293]+ +h[$>>3];he[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}_=1.0/+h[16293];h[16302]=_;$=c[b>>2]|0;c[32574]=1;S=c[32590]|0;if(($|0)>=1){Y=_;W=1;aa=0;while(1){h[p+(aa+S<<3)>>3]=(+h[o+(aa<<3)>>3]- +h[g+(aa<<3)>>3])*Y;if((W|0)>=($|0)){break}ba=W;Y=+h[16302];W=W+1|0;aa=ba}c[32574]=$+1}c[32590]=S+(c[b>>2]|0);aa=c[32568]|0;W=aa+ -1|0;h[e+(W<<3)>>3]=+h[16300];h[f+(W<<3)>>3]=+h[16304];R=aa+1|0;c[32568]=R;if((aa|0)>=(P|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){ca=42;break}c[32590]=0;P=c[b>>2]|0;if((c[116232>>2]|0)==0){ca=42;break}R=Nla(P*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];RS(14,1,130440,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];RS(14,0,130464,E);RS(14,1,130472,D);c[32572]=0;if((c[b>>2]|0)>0){Q=0;do{Y=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;aa=C+4|0;h[k>>3]=Y;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];RS(14,0,130480,C);Q=(c[32572]|0)+1|0;c[32572]=Q;}while((Q|0)<(c[b>>2]|0))}le[c[29182]&511](14);RS(14,1,130536,B);c[32568]=1;if((P|0)>=1){Q=R+1|0;aa=c[32590]|0;W=1;do{ba=p+(W+ -1+aa<<3)|0;h[ba>>3]=+h[j>>3]+ +h[ba>>3];a[R]=0;a[Q]=0;c[32574]=1;ba=aa;da=0;while(1){Y=+h[p+(da+ba<<3)>>3];c[A>>2]=R;ea=A+4|0;h[k>>3]=Y;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];nc(R|0,130520,A|0)|0;ea=c[32574]|0;c[32574]=ea+1;if((ea|0)>=(P|0)){break}ba=c[32590]|0;da=ea}c[z>>2]=R;RS(14,0,130528,z);da=c[32590]|0;ba=c[32568]|0;ea=p+(da+ -1+ba<<3)|0;h[ea>>3]=+h[ea>>3]- +h[j>>3];aa=da+(c[b>>2]|0)|0;c[32590]=aa;W=ba+1|0;c[32568]=W;}while((ba|0)<(P|0))}le[c[29182]&511](14);le[c[29182]&511](14);Ola(R);ca=42}else if((O|0)==5){P=q+4|0;W=(c[P>>2]|0)+(c[q>>2]|0)|0;aa=W+1|0;c[32594]=aa;Q=c[b>>2]|0;c[32584]=(W|0)<(Q|0)?aa:Q;Q=c[q>>2]|0;c[32602]=aa+Q;c[32588]=Q+W;W=(c[b>>2]|0)/(aa|0)|0;c[32598]=W+1;aa=c[x>>2]|0;c[32596]=aa+ -1;c[32606]=aa+W;c[s>>2]=0;h[16296]=+V(+(+h[t>>3]));W=c[32584]|0;c[32570]=1;if((W|0)<1){ca=75;break}aa=r;Q=1;while(1){ba=c[b>>2]|0;da=c[32594]|0;c[32576]=Q;ea=(da|0)<0;c:do{if(ea?(Q|0)>=(ba|0):(Q|0)<=(ba|0)){ga=da;ha=Q;ia=Q;while(1){ja=(ia-ha|0)/(ga|0)|0;c[32572]=ja+1;ka=ia+ -1|0;la=e+(ka<<3)|0;h[p+((c[32596]|0)+ja<<3)>>3]=+h[la>>3];ma=f+(ka<<3)|0;h[p+((c[32606]|0)+ja<<3)>>3]=+h[ma>>3];Y=+h[la>>3];h[N>>3]=Y;if(!(Y>=0.0)){na=-Y}else{na=Y}Y=+h[l>>3]*+h[ma>>3];if(!(Y>=0.0)){oa=-Y}else{oa=Y}Y=na>=oa?na:oa;_=+h[n+(ka<<3)>>3];if(!(_>=0.0)){pa=-_}else{pa=_}h[16293]=+h[16296]*(Y>=pa?Y:pa);h[N>>3]=+h[l>>3]*+h[ma>>3];Y=+t9(130344,N);h[16293]=Y;ma=c[32576]|0;ka=ma+ -1|0;la=e+(ka<<3)|0;_=+h[la>>3];T=Y+_-_;h[16293]=T;h[la>>3]=+h[la>>3]+T;la=f+(ka<<3)|0;h[la>>3]=+h[j>>3]*+h[16293]+ +h[la>>3];la=ma+da|0;c[32576]=la;if(!(ea?(la|0)>=(ba|0):(la|0)<=(ba|0))){break c}ga=c[32594]|0;ha=c[32570]|0;ia=la}}}while(0);he[aa&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ba=c[b>>2]|0;ea=c[32594]|0;da=c[32570]|0;c[32576]=da;ia=(ea|0)<0;d:do{if(ia?(da|0)>=(ba|0):(da|0)<=(ba|0)){ha=ea;ga=da;S=da;while(1){$=(S-ga|0)/(ha|0)|0;c[32572]=$+1;la=S+ -1|0;ma=e+(la<<3)|0;h[ma>>3]=+h[p+((c[32596]|0)+$<<3)>>3];T=+h[p+((c[32606]|0)+$<<3)>>3];$=f+(la<<3)|0;h[$>>3]=T;_=+h[ma>>3];h[N>>3]=_;if(!(_>=0.0)){qa=-_}else{qa=_}_=+h[l>>3]*T;if(!(_>=0.0)){ra=-_}else{ra=_}_=qa>=ra?qa:ra;T=+h[n+(la<<3)>>3];if(!(T>=0.0)){sa=-T}else{sa=T}h[16293]=+h[16296]*(_>=sa?_:sa);h[N>>3]=+h[l>>3]*+h[$>>3];_=+t9(130344,N);h[16293]=_;$=c[32576]|0;T=+h[e+($+ -1<<3)>>3];Y=_+T-T;h[16293]=Y;T=1.0/Y;h[16302]=T;la=$-(c[P>>2]|0)|0;ma=(la|0)>1?la:1;c[32578]=ma;la=c[b>>2]|0;ka=(c[q>>2]|0)+$|0;ja=(la|0)<=(ka|0)?la:ka;c[32580]=ja;ta=fa(c[32588]|0,$)|0;ua=ta-(c[q>>2]|0)|0;c[32582]=ua;c[32568]=ma;if((ma|0)<=(ja|0)){ta=~la;la=~ka;ka=~((ta|0)>(la|0)?ta:la);la=(ma|0)>(ka|0)?ma:ka;Y=T;ka=ma;while(1){ma=ka+ -1|0;h[p+(ma+ua<<3)>>3]=(+h[o+(ma<<3)>>3]- +h[g+(ma<<3)>>3])*Y;if((ka|0)>=(ja|0)){break}Y=+h[16302];ka=ka+1|0}c[32568]=la+1}ka=$+ea|0;c[32576]=ka;ja=c[32570]|0;if(!(ia?(ka|0)>=(ba|0):(ka|0)<=(ba|0))){va=ja;break d}ha=c[32594]|0;ga=ja;S=ka}}else{va=da}}while(0);da=va+1|0;c[32570]=da;if((va|0)<(W|0)){Q=da}else{ca=75;break a}}i=y;return 0}else if((O|0)==3){i=y;return 0}else if((O|0)==4){Q=c[q>>2]|0;W=q+4|0;P=c[W>>2]|0;aa=c[b>>2]|0;R=fa(P+1+(Q<<1)|0,aa)|0;c[32568]=1;if((R|0)>=1){da=fa(aa,P+(Q<<1)+1|0)|0;Q=(da|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(R|0)){P=P+1|0}else{break}}c[32568]=Q?2:da+1|0}ne[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[32602]=(c[W>>2]|0)+1+(c[q>>2]<<1);ca=75}else{P=c[b>>2]|0;R=fa(P,P)|0;c[32568]=1;if((R|0)!=0){P=(R|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(R|0)){aa=aa+1|0}else{break}}c[32568]=P?2:R+1|0}ne[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){ca=42;break}c[32590]=0;aa=c[b>>2]|0;if((c[116232>>2]|0)==0){ca=42;break}W=Nla(aa*20|0)|0;da=M;h[k>>3]=+h[d>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];RS(14,1,130440,M);da=L;h[k>>3]=+h[j>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];RS(14,0,130464,L);RS(14,1,130472,K);c[32572]=0;if((c[b>>2]|0)>0){da=0;do{Y=+h[e+(da<<3)>>3];c[J>>2]=da+1;Q=J+4|0;h[k>>3]=Y;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];RS(14,0,130480,J);da=(c[32572]|0)+1|0;c[32572]=da;}while((da|0)<(c[b>>2]|0))}le[c[29182]&511](14);RS(14,1,130496,I);c[32568]=1;if((aa|0)>=1){da=W+1|0;R=c[32590]|0;P=1;do{Q=p+(P+ -1+R<<3)|0;h[Q>>3]=+h[j>>3]+ +h[Q>>3];a[W]=0;a[da]=0;c[32574]=1;Q=R;ba=0;while(1){Y=+h[p+(ba+Q<<3)>>3];c[H>>2]=W;ia=H+4|0;h[k>>3]=Y;c[ia>>2]=c[k>>2];c[ia+4>>2]=c[k+4>>2];nc(W|0,130520,H|0)|0;ia=c[32574]|0;c[32574]=ia+1;if((ia|0)>=(aa|0)){break}Q=c[32590]|0;ba=ia}c[G>>2]=W;RS(14,0,130528,G);ba=c[32590]|0;Q=c[32568]|0;ia=p+(ba+ -1+Q<<3)|0;h[ia>>3]=+h[ia>>3]- +h[j>>3];R=ba+(c[b>>2]|0)|0;c[32590]=R;P=Q+1|0;c[32568]=P;}while((Q|0)<(aa|0))}le[c[29182]&511](14);le[c[29182]&511](14);Ola(W);ca=42}}while(0);if((ca|0)==42){cV(p,b,b,q+80|0,m)|0;i=y;return 0}else if((ca|0)==75){iV(p,130408,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function XU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[32640]=(c[h>>2]|0)+1+(c[e>>2]<<1);jV(d,130560,a,e,h,e+80|0,b,130568)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{gV(d,a,a,e+80|0,b,130568)|0;i=f;return 0}return 0}function YU(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[130576]&1)){a[130576]=1;ZU(130624,130592,130672,130608,130656,130680,130664,130688)|0;h[16327]=+(c[32656]|0);f=c[32648]|0;h[16323]=+(f|0);if((c[32668]|0)==0){h[16325]=0.0;c[e>>2]=1-f;g=+s9(130616,e)}else{h[16325]=1.0;c[e>>2]=1-f;g=+s9(130616,e)*.5}h[16326]=g;h[16330]=g*+h[16327];h[16329]=+(c[32664]|0);h[16331]=+(c[32666]|0);j=+h[16335];h[16338]=j;k=1.0/+h[16336];if(!(k>=j)){break}h[16338]=k*(g+1.0)}}while(0);if((pV(b,130712,1,1)|0)!=0){g=+h[16326];h[16337]=g;l=g;i=d;return+l}if((pV(b,130720,1,1)|0)!=0){g=+h[16338];h[16337]=g;l=g;i=d;return+l}if((pV(b,130728,1,1)|0)!=0){g=+h[16327];h[16337]=g;l=g;i=d;return+l}if((pV(b,130736,1,1)|0)!=0){g=+h[16330];h[16337]=g;l=g;i=d;return+l}if((pV(b,130744,1,1)|0)!=0){g=+h[16323];h[16337]=g;l=g;i=d;return+l}if((pV(b,130752,1,1)|0)!=0){g=+h[16325];h[16337]=g;l=g;i=d;return+l}if((pV(b,130760,1,1)|0)!=0){g=+h[16329];h[16337]=g;l=g;i=d;return+l}if((pV(b,130768,1,1)|0)!=0){g=+h[16335];h[16337]=g;l=g;i=d;return+l}if((pV(b,130776,1,1)|0)!=0){g=+h[16331];h[16337]=g;l=g;i=d;return+l}if((pV(b,130784,1,1)|0)==0){l=+h[16337];i=d;return+l}else{g=+h[16336];h[16337]=g;l=g;i=d;return+l}return 0.0}function ZU(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[130896]&1){q=131264;r=c[32816]|0;c[b>>2]=r;s=131200;t=c[32800]|0;c[d>>2]=t;u=131240;v=c[32810]|0;c[e>>2]=v;w=131248;x=+h[16406];h[f>>3]=x;y=131280;z=c[32820]|0;c[g>>2]=z;A=131328;B=+h[16416];h[j>>3]=B;C=131288;D=c[32822]|0;c[k>>2]=D;E=131336;F=+h[16417];h[l>>3]=F;i=m;return 0}a[130896]=1;h[16407]=0.0;h[16401]=1.0;h[16402]=2.0;_U(131264,131200,131240,131352)|0;h[16397]=+(c[32816]|0);c[n>>2]=0-(c[32800]|0);G=+s9(131176,n);h[16396]=G;h[16406]=G;H=+h[16402];h[16397]=H/3.0;I=+h[16401];J=I*.5;h[16404]=J;K=-J;h[o>>3]=K;h[16418]=+$U(131176,o);L=131344;h[16415]=+$U(L,L);h[o>>3]=K;h[16397]=+$U(131320,o);K=+$U(131176,131344);h[16397]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[16397]=K;h[16406]=1.0;M=+h[16407];if(K<1.0&K>M){N=K;while(1){h[16406]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+$U(o,p);h[16398]=K;h[o>>3]=-K;h[16398]=+$U(131232,o);K=+$U(131232,131184);h[16397]=K;h[o>>3]=-K;h[16398]=+$U(131232,o);K=+$U(131232,131184);h[16397]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[16406]=G}G=I/+(c[32816]|0);h[16409]=G;h[16413]=I;c[32798]=1;p=1;O=I;do{h[o>>3]=O*G;O=+$U(o,131256);h[16413]=O;p=p+1|0;c[32798]=p;}while((p|0)<4);h[16396]=+$U(131208,131304);aV(131368,131208,131264)|0;h[o>>3]=-+h[16401];aV(131360,o,131264)|0;aV(131312,131168,131264)|0;h[o>>3]=-+h[16396];aV(131296,o,131264)|0;c[32806]=0;p=c[32842]|0;L=c[32840]|0;P=c[32828]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[32824]|0)){if(Q){c[32820]=p;R=0;S=25;break}if((P-p|0)==3){c[32820]=p+ -1+(c[32800]|0);c[32806]=1;R=1;S=25;break}else{c[32820]=(p|0)<=(P|0)?p:P;a[130904]=1;S=26;break}}else{T=Q&(L|0)==(c[32824]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[32820]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[32820]=(p|0)<=(L|0)?p:L;a[130904]=1;S=26;break}}T=c[32824]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[32820]=(V|0)<=(T|0)?V:T;a[130904]=1;S=26;break}if((P-U|0)==3){c[32820]=((p|0)>=(L|0)?p:L)+ -1+(c[32800]|0);R=0;S=25;break}else{c[32820]=U;a[130904]=1;S=26;break}}}while(0);if((S|0)==25){if(a[130904]&1){S=26}else{W=R}}if((S|0)==26){a[130896]=0;qaa(131376)|0;H9(131400,131280,4)|0;_9()|0;W=c[32806]|0}if((W|0)==0){X=(c[32838]|0)!=0|0}else{X=1}c[32806]=X;h[16416]=1.0;X=c[32820]|0;W=1-X|0;c[n>>2]=W;c[32798]=1;if((X|0)<=0){O=+h[16409];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+$U(o,131256);h[16416]=I;n=X+1|0;c[32798]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}bV(131264,131200,131280,131224,131288,131336)|0;q=131264;r=c[32816]|0;c[b>>2]=r;s=131200;t=c[32800]|0;c[d>>2]=t;u=131240;v=c[32810]|0;c[e>>2]=v;w=131248;x=+h[16406];h[f>>3]=x;y=131280;z=c[32820]|0;c[g>>2]=z;A=131328;B=+h[16416];h[j>>3]=B;C=131288;D=c[32822]|0;c[k>>2]=D;E=131336;F=+h[16417];h[l>>3]=F;i=m;return 0}function _U(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[130792]&1){l=a[130864]&1;m=c[32718]|0;c[b>>2]=m;n=130840;o=c[32710]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=130888;r=c[32722]|0;c[f>>2]=r;i=g;return 0}a[130792]=1;h[16356]=1.0;h[16350]=1.0;h[16352]=1.0;s=1.0;do{s=s*2.0;h[16350]=s;h[16352]=+$U(130800,130848);h[j>>3]=-s;t=+$U(130816,j);h[16352]=t;}while(t==1.0);h[16351]=1.0;t=+$U(130800,130808);h[16352]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[16351]=v;w=+$U(130800,130808);h[16352]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[16357]=.25;h[16360]=x;h[j>>3]=-s;t=+$U(130816,j);h[16352]=t;y=~~(t+.25);c[32718]=y;t=+(y|0);h[16351]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[16353]=+$U(j,k);w=+$U(130824,130800);h[16352]=w;z=w==s;a[130864]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[16353]=+$U(j,k);w=+$U(130824,130800);h[16352]=w;if(z&w==s){a[130864]=0;A=0}else{A=z}h[j>>3]=u;w=+$U(j,130800);h[16354]=w;h[j>>3]=u;z=w==s&+$U(j,130880)>x;c[32722]=z?A&1:0;c[32710]=0;h[16350]=1.0;h[16352]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[32710]=k;s=x*t;h[16350]=s;h[16352]=+$U(130800,130848);h[j>>3]=-s;w=+$U(130816,j);h[16352]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=130840;o=c[32710]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=130888;r=c[32722]|0;c[f>>2]=r;i=g;return 0}function $U(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function aV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[16426]=g;j=1.0/+(c[d>>2]|0);h[16435]=j;h[16434]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+$U(f,131472);h[16428]=k;h[16430]=g;h[16431]=g;h[16432]=g;h[16433]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[16426]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+$U(f,131472);h[16428]=g;h[f>>3]=g*k;k=+$U(f,131472);h[16430]=k;h[16432]=0.0;c[32854]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[16432]=q;c[32854]=b+1;n=q}h[f>>3]=m*j;p=+$U(f,131472);h[16429]=p;h[f>>3]=p/j;r=+$U(f,131472);h[16431]=r;h[16433]=0.0;o=c[d>>2]|0;c[32854]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[16433]=v;c[32854]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function bV(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[32878]=1;c[32886]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[32878]=q;r=l+1|0;c[32886]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[32882]=n;u=n}else{c[32882]=m;c[32886]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[32888]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[32886]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[16442]=x;y=w+-1.0;h[16438]=y;h[16437]=0.0;v=c[b>>2]|0;c[32872]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[16438]=B;if(w<1.0){h[16440]=w}C=+$U(131496,131504);h[16437]=C;e=b+1|0;c[32872]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[16440];h[16437]=A;z=A}}while(0);v=c[f>>2]|0;c[32872]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+$U(k,131560);h[16437]=z;f=E+1|0;c[32872]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function cV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[32894]=1;m=1;do{c[32900]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=dV(j,a+(m+b+(fa(m,l)|0)<<3)|0,131608)|0;q=c[32894]|0;r=p+ -1+q|0;c[32896]=r;c[e+(q+ -1<<2)>>2]=r;r=c[32896]|0;q=c[32894]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[16449]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[16449];t=q}u=fa(t,l)|0;h[16449]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;eV(j,131592,a+(t-l+u<<3)|0,131608)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[32900]|0;c[32892]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[32896]|0;x=fa(w,l)|0;h[16449]=+h[a+(x+b+v<<3)>>3];y=c[32894]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[16449];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=131608;fV(k,131592,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[32892]|0;w=A+1|0;c[32892]=w;}while((A|0)<(u|0))}}while(0);q=c[32894]|0;m=q+1|0;c[32894]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function dV(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[32992]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[16497]=k;l=(c[d>>2]|0)+1|0;c[32992]=l;m=c[a>>2]|0;c[32990]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[16497]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[32992]=l;a=n+1|0;c[32990]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[16497]=v;c[32990]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[16497]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[32990]=f+1;g=C;i=e;return g|0}function eV(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[32976]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[32976]=l;i=f;return 0}l=(g|0)%5|0;c[32978]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[32976]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[32976]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[32976]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[32976]=o;i=f;return 0}function fV(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[32962]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[32960]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[32960]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[32960]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[32960]=s;i=j;return 0}}while(0);c[32964]=1;c[32966]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[32964]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[32966]=s;u=s}else{u=1}s=c[a>>2]|0;c[32960]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[32964]=t;u=x+(c[g>>2]|0)|0;c[32966]=u;a=w+1|0;c[32960]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function gV(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[32912]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[32904]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[32906]=o;p=f+(o+ -1<<3)|0;h[16454]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[16454]}c[k>>2]=(c[d>>2]|0)-m;o=131608;fV(k,131632,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[32904]|0;m=o+1|0;c[32904]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[32910]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[32904]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[16454]=-s;c[k>>2]=g;g=131608;fV(k,131632,a+(p-l<<3)|0,g,f,g)|0;g=c[32910]|0;q=g+1|0;c[32910]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[32904]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=131608;s=+hV(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[16454]=s;q=c[32904]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[32904]=n;}while((q|0)<(m|0));t=c[32912]|0}if((t|0)<1){i=j;return 0}c[32910]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[32904]=n;c[k>>2]=(c[d>>2]|0)-n;b=131608;s=+hV(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[32904]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[32906]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[16454]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[16454]}q=c[32910]|0;m=q+1|0;c[32910]=m;}while((q|0)<(t|0));i=j;return 0}function hV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[16494]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[32982]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[32980]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[16494]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[32980]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[32980]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[16494]=t;u=u+5|0;}while((u|0)<=(m|0));c[32980]=u;k=t;i=g;return+k}}while(0);c[32984]=1;c[32986]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[32984]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[32986]=u;y=u}else{y=1}u=c[a>>2]|0;c[32980]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[16494]=t;x=C+(c[d>>2]|0)|0;c[32984]=x;y=B+(c[f>>2]|0)|0;c[32986]=y;a=z+1|0;c[32980]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function iV(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[32922]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[32928]=n;o=c[d>>2]|0;p=c[32922]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[32930]=o;do{if((q|0)>(n|0)){c[32938]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[32926]=s;t=c[e>>2]|0;c[32914]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[32914]=t+1}u=r+1|0;c[32938]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[32938]=o;c[32936]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[32918]=1;t=o;o=1;while(1){c[32940]=o+1;p=t+1|0;c[32938]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[32914]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[32914]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[32932]=s;c[l>>2]=s+1;s=dV(l,a+((c[32922]|0)+b+(fa(o,m)|0)<<3)|0,131608)|0;p=s+ -1|0;c[32920]=p+(c[32922]|0);s=c[32918]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[32920]|0;p=c[32918]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[32922]|0;if((s|0)==(u|0)){y=s}else{h[16462]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[16462];y=u}h[16462]=-1.0/+h[a+(y+b+n<<3)>>3];eV(131728,131696,a+(y-m+n<<3)|0,131608)|0;u=c[32936]|0;z=(c[g+((c[32918]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[32936]=u;A=c[32922]|0;c[32934]=A;z=c[32940]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[32916]=z;B=z;z=A;while(1){A=(c[32920]|0)+ -1|0;c[32920]=A;C=z+ -1|0;c[32934]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[16462]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[16462];F=C}C=131608;fV(131728,131696,a+((c[32922]|0)-m+(fa(c[32918]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[32916]|0;D=C+1|0;c[32916]=D;if((C|0)>=(u|0)){break a}B=D;z=c[32934]|0}}}while(0);n=c[32918]|0;s=n+1|0;c[32918]=s;if((n|0)>=(r|0)){break}t=c[32938]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[32922]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function jV(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[32946]=n;f=c[d>>2]|0;o=f+ -1|0;c[32958]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[32942]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[32956]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[32944]=k;q=j+(k+ -1<<3)|0;h[16474]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[16474]}k=131608;fV(131824,131792,a+((c[32946]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[32942]|0;f=k+1|0;c[32942]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[32950]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[32942]=k;q=c[32946]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[32956]=s;u=q-s|0;c[32952]=u;q=k-s|0;c[32954]=q;h[16474]=-t;s=131608;fV(131824,131792,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[32950]|0;r=s+1|0;c[32950]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[32942]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[32956]=r;s=o-r|0;c[32952]=s;q=n-r|0;c[32954]=q;r=131608;t=+hV(131824,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[16474]=t;r=c[32942]|0;q=j+(r+ -1<<3)|0;o=c[32946]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[32942]=n;}while((r|0)<(f|0));v=o;w=c[32958]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[32950]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[32942]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[32956]=(n|0)<=(b|0)?n:b;b=131608;t=+hV(131824,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[32942]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[32944]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[16474]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[16474]}n=c[32950]|0;b=n+1|0;c[32950]=b;if((n|0)>=(w|0)){break}o=c[32946]|0;v=b}i=l;return 0}function kV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[32970]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[32968]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[32968]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[32968]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[32968]=o;i=g;return 0}}while(0);c[32972]=1;c[32974]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[32972]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[32974]=o;q=o}else{q=1}o=c[a>>2]|0;c[32968]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[32972]=p;q=s+(c[f>>2]|0)|0;c[32974]=q;a=r+1|0;c[32968]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function lV(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+mV(131984);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+nV(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+nV(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+nV(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+nV(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function mV(a){a=a|0;i=i;return+(+h[131992+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function nV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function oV(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+mV(132024);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Me[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+nV(b,e);c[E>>2]=2;Me[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){wV(b,b,f,g,132032,N,132024,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+nV(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=Jma(ga|0,0,Z+ -2|0,0)|0;Z=Bma(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}vV(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Me[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);lV(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+nV(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Me[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+nV(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+nV(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+nV(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}yV(b,b,s,t,v,w,x,D)|0;xV(b,b,f,g,w,x)|0;W=132024;xV(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Me[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Me[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function pV(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[132056]=1;f=d[b]|0;c[33010]=f;b=d[e]|0;c[33012]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[33010]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[33012]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}



function uX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=Nla(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=Nla(c[y>>2]<<2)|0;vX(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;rma(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;rma(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((CV(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=wX(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){rma(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;rma(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;Ola(x);Ola(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;TS(5,1,153040,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];nc(q|0,153072,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;TS(5,0,153080,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=116728;K=c[29182]|0;le[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=153088;aa=$;VS(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];TS(5,0,153080,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=116728;K=c[29182]|0;le[K&511](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=153088;aa=$;VS(O,aa,g);return 0}function vX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;tma(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}oe[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function wX(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=Pla(d,4)|0;r=Pla(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;Ola(q);Ola(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;Ola(q);Ola(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){Ola(q);Ola(r);i=o;return v|0}if((n|0)==0){v=-1;Ola(q);Ola(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];RS(5,1,153192,p);xX(s,d,f,c[g>>2]|0,j,l,m);if((c[116196>>2]|0)==0){v=-1;Ola(q);Ola(r);i=o;return v|0}le[c[29182]&511](5);v=-1;Ola(q);Ola(r);i=o;return v|0}function xX(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;tma(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];RS(5,0,153224,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function yX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=oc(153240,153264)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=Xd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;qb(n|0);do{}while((Xd(n|0)|0)!=10);q=c[b+152>>2]|0;r=Pla(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=Pla(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=Pla(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Ya(n|0,153272,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Ya(n|0,153272,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=Pla(s,8)|0;x=v}}while(0);mc(153280,j|0)|0;mc(153336,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];mc(153296,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];mc(153320,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}vb(153336)|0;dd(n|0)|0;c[b+460>>2]=0;i=d;return 0}function zX(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}Ola(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){Ola(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}Ola(l);i=d;return 0}function AX(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function BX(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+CX(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[116212>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];RS(9,1,153400,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];RS(9,0,153512,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}le[c[29182]&511](9);g=1;i=b;return g|0}function CX(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;RX(b);g=f+540|0;oe[c[(c[g>>2]|0)+84>>2]&127](f)|0;oe[c[(c[g>>2]|0)+36>>2]&127](f)|0;oe[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;De[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function DX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+CX(b,1.0);if((c[116212>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}RS(9,1,153536,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(9,0,153600,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(9,0,153560,s)}RS(9,1,153624,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;RS(9,0,153696,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];RS(9,0,153648,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;RS(9,0,153784,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(9,0,153720,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;RS(9,0,153872,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];RS(9,0,153816,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}le[c[29182]&511](9);RS(9,1,153904,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=oe[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;RS(9,0,153696,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];RS(9,0,153648,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}le[c[29182]&511](9);le[c[29182]&511](9);i=d;return}function EX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[116212>>2]|0)!=0){mW(b,9)}if((c[116272>>2]|0)==0){i=d;return}RS(24,1,153928,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){RS(24,1,153968,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];RS(24,0,153992,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}le[c[29182]&511](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}RS(24,1,154048,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];RS(24,0,154072,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}le[c[29182]&511](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){RS(24,1,154104,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(24,0,153992,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}le[c[29182]&511](24)}p=b+124|0;if((c[p>>2]|0)>0){RS(24,1,154128,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;RS(24,0,154152,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}le[c[29182]&511](24)}H=b+128|0;if((c[H>>2]|0)>0){RS(24,1,154200,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?154272:154280;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?154272:154280;t=(a[(c[l>>2]|0)+n|0]|0)!=0?154272:154280;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;RS(24,0,154224,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}le[c[29182]&511](24)}n=b+132|0;if((c[n>>2]|0)>0){RS(24,1,154288,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;RS(24,0,154312,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}le[c[29182]&511](24)}le[c[29182]&511](24);i=d;return}function FX(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;RS(9,0,154360,z);if((f|0)==0){jW(b);kW(b);C=6}else{if((a[f]|0)!=0){GX(b,f,g)}jW(b);kW(b);if((a[f]|0)==0){C=6}}if((C|0)==6){oe[c[(c[A>>2]|0)+84>>2]&127](b)|0;oe[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(lma(d,155848)|0)==0|0;f=(lma(d,155856)|0)==0;z=(lma(d,155864)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;TS(1,0,154408,y);TS(1,0,154440,x);c[w>>2]=155848;c[w+4>>2]=155656;TS(1,0,154464,w);c[v>>2]=155856;c[v+4>>2]=155736;TS(1,0,154464,v);c[u>>2]=155864;c[u+4>>2]=155784;TS(1,0,154464,u);VS(c[b+536>>2]|0,154496,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(lma(e,c[154520+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;TS(1,0,154552,s);TS(1,0,154440,r);t=1;do{u=c[154584+(t<<2)>>2]|0;c[q>>2]=c[154520+(t<<2)>>2];c[q+4>>2]=u;TS(1,0,154464,q);t=t+1|0;}while((t|0)<7);VS(c[b+536>>2]|0,154496,p)}}while(0);p=c[154480+(D<<2)>>2]|0;c[o>>2]=c[154392+(D<<2)>>2];c[o+4>>2]=p;RS(9,0,154616,o);o=(D|0)==2;if(o){p=c[154584+(F<<2)>>2]|0;c[n>>2]=c[154520+(F<<2)>>2];c[n+4>>2]=p;RS(9,0,154656,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=HX(b,F,j)|0;break}if((D|0)==3){IX(b,j);I=0;break}else{VS(c[b+536>>2]|0,154696,m)}}}while(0);if((TW(b,1)|0)!=0){J=-2;EX(b);K=15;L=K;M=154720;N=M;RS(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];UV(b,R,V);W=287;gW(b);X=293;lW(b);Y=288;bW(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=oe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=De[ha&63](b,1)|0;ja=296;hW(b);i=k;return J|0}if((LW(b,1)|0)!=0){J=-3;EX(b);K=15;L=K;M=154720;N=M;RS(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];UV(b,R,V);W=287;gW(b);X=293;lW(b);Y=288;bW(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=oe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=De[ha&63](b,1)|0;ja=296;hW(b);i=k;return J|0}m=(BW(b,1)|0)==0;J=m?I:-4;EX(b);K=15;L=K;M=154720;N=M;RS(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];UV(b,R,V);W=287;gW(b);X=293;lW(b);Y=288;bW(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=oe[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=De[ha&63](b,1)|0;ja=296;hW(b);i=k;return J|0}function GX(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];RS(9,0,155880,z);z=HT(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;VS(C,155920,y)}RS(9,0,155960,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=IT(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=LX(c[d+(C*112|0)+4>>2]|0)|0;E=IT(A,D)|0;Ola(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((mma(E,156e3,6)|0)==0){if((c[116212>>2]|0)==0){break}}else{D=mma(E,156008,6)|0;if((c[116212>>2]|D|0)==0){break}}c[v>>2]=E;TS(9,0,156016,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;OT(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(9,0,155984,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}RS(9,0,156072,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=IT(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=LX(c[G+(w*112|0)+4>>2]|0)|0;v=IT(A,F)|0;Ola(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];TS(9,0,156096,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;OT(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];RS(9,0,155984,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}RS(9,0,156152,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=IT(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=LX(c[t+(x*112|0)+4>>2]|0)|0;K=IT(A,C)|0;Ola(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];TS(9,0,156096,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;OT(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];RS(9,0,155984,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}RS(9,0,156176,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=IT(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=LX(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=IT(A,u)|0;Ola(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];TS(9,0,156224,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;OT(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;RS(9,0,156208,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}RS(9,0,156280,l);l=b+144|0;if((c[l>>2]|0)<=0){FT(A);i=f;return}o=b+32|0;b=0;do{x=IT(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=LX(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=IT(A,n)|0;Ola(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];TS(9,0,156328,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;OT(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?154272:154280;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;RS(9,0,156312,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));FT(A);i=f;return}function HX(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;TV(a,+h[a+240>>3]);gW(a);lW(a);bW(a);nW(a);sX(a);cW(a);gW(a);e=JX(a,b,c)|0;lW(a);bW(a);hW(a);lW(a);i=d;return e|0}function IX(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;TV(b,+h[b+240>>3]);gW(b);lW(b);uX(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=Pla(c[y>>2]|0,8)|0;A=b+124|0;B=Pla(c[A>>2]|0,4)|0;C=b+128|0;D=Pla(c[C>>2]|0,1)|0;E=b+132|0;F=Pla(c[E>>2]|0,4)|0;G=b+536|0;US(c[G>>2]|0,(z|0)!=0|0,154752,t);US(c[G>>2]|0,(B|0)!=0|0,154752,s);US(c[G>>2]|0,(D|0)!=0|0,154752,r);US(c[G>>2]|0,(F|0)!=0|0,154752,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[116212>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];nc(x|0,154768,p|0)|0;p=oc(x|0,154784)|0;c[o>>2]=154800;Bd(p|0,154792,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];Bd(p|0,154792,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Yd(10,p|0)|0;H=p}RS(9,1,154808,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;oe[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];RS(9,0,154832,l);if((c[116212>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Bd(H|0,154856,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];Bd(H|0,154856,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Yd(10,H|0)|0}if((TW(b,0)|0)!=0){break a}if((LW(b,0)|0)!=0){break a}if((BW(b,0)|0)!=0){break a}oW(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);le[c[29182]&511](9);if((c[116212>>2]|0)!=0){dd(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}Ola(z);Ola(B);Ola(D);Ola(F)}else{h[b+304>>3]=1.0;oe[c[w+80>>2]&127](b)|0}dW(b);if((uX(b,1,1)|0)!=1){i=e;return}oe[c[(c[v>>2]|0)+80>>2]&127](b)|0;dW(b);if((uX(b,1,1)|0)!=1){i=e;return}TS(1,0,154864,f);i=e;return}function JX(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=MX(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){RS(9,0,154968,u);if((c[b+184>>2]|0)==0){De[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}Ola(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){RS(9,0,155e3,t);De[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;Ola(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){RS(9,1,155072,s);t=Nla(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+CX(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+CX(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}RS(9,1,155096,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];RS(9,0,155120,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];RS(9,0,155120,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];RS(9,0,155120,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[116212>>2]|0)!=0){le[c[29182]&511](9);le[c[29182]&511](9)}Ola(t);NX(v);H=MX(b)|0;if((c[H>>2]|0)!=0){$=H;break}RS(9,0,155144,n);Ola(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}RS(9,0,155176,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){RS(9,0,155192,l);KX($,d,1,e);DX(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+CX($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){Ola(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){Ola(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){Ola(v);c[l>>2]=0}KX($,d,0,e);DX(b,$);+CX($,1.0)}else{RS(9,0,155216,j)}RS(9,1,155240,g);DX(b,$);b=BX($)|0;if((c[116212>>2]|0)!=0){le[c[29182]&511](9)}NX($);y=b;i=f;return y|0}function KX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=Nla(c[p>>2]<<3)|0;r=q;s=+CX(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;PX(a,r);Ola(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=155368;F=E;RS(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;RS(9,0,155280,m);if(!t){OX(a)}switch(b|0){case 1:{G=WX(a)|0;break};case 2:{G=UX(a)|0;break};case 4:{H=12;break a;break};case 5:{H=13;break a;break};case 6:{H=14;break a;break};case 3:{G=YX(a,n,e)|0;break};default:{H=15;break a}}lW(o);bW(o);hW(o);lW(o);s=+CX(a,1.0);v=(G|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}RS(9,0,155328,k);DX(o,a);K=s}else{RS(9,0,155344,j);if(v&s==x){y=w;H=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;H=23;break}}if((H|0)==12){TX(a)|0}else if((H|0)==13){TX(a)|0}else if((H|0)==14){SX(o,a,0)|0}else if((H|0)==15){VS(c[o+536>>2]|0,155304,l)}else if((H|0)==23){PX(a,r);Ola(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=155368;F=E;RS(9,0,F,g);i=f;return}}function LX(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=pma(b|0)|0;do{if((d|0)==0){e=Nla(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=Nla(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((kma(e,156384,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;rma(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((kma(e,156384,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function MX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=Nla(64)|0;z=y;US(0,(y|0)!=0|0,156392,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=Pla(Z,8)|0;c[E>>2]=y;US(0,(y|0)!=0|0,156392,w);w=Pla(Z,8)|0;c[F>>2]=w;US(0,(w|0)!=0|0,156392,v);v=Pla(Z,8)|0;c[G>>2]=v;US(0,(v|0)!=0|0,156392,u);u=Pla(Z,8)|0;c[H>>2]=u;US(0,(u|0)!=0|0,156392,t);t=Pla(Z,8)|0;c[I>>2]=t;US(0,(t|0)!=0|0,156392,s);s=Pla(Z,4)|0;t=s;c[J>>2]=t;US(0,(s|0)!=0|0,156392,r);RS(9,0,156408,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;RS(9,0,156432,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];RS(9,0,156520,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];RS(9,0,156568,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];RS(9,0,156624,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;RS(9,0,156680,l);c[j>>2]=ya;RS(9,0,156752,j);j=Pla(sa,8)|0;c[K>>2]=j;US(0,(j|0)!=0|0,156392,g);g=Nla(sa<<3)|0;c[L>>2]=g;US(0,(g|0)!=0|0,156392,f);f=Nla(ya<<3)|0;c[M>>2]=f;US(0,(f|0)!=0|0,156392,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function NX(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){Ola(d)}d=c[a+28>>2]|0;if((d|0)!=0){Ola(d)}d=c[a+32>>2]|0;if((d|0)!=0){Ola(d)}d=c[a+36>>2]|0;if((d|0)!=0){Ola(d)}d=c[a+40>>2]|0;if((d|0)!=0){Ola(d)}d=c[a+44>>2]|0;if((d|0)!=0){Ola(d)}d=c[a+48>>2]|0;if((d|0)!=0){Ola(d)}d=c[a+52>>2]|0;if((d|0)!=0){Ola(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;Ola(e);i=b;return}Ola(d);e=a;Ola(e);i=b;return}function OX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=Pla(o,8)|0;q=Pla(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=Pla(s,8)|0;u=Pla(s,8)|0;v=Pla(o,8)|0;w=Pla(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+CX(b,1.0);s=c[n>>2]|0;if((s|0)>0){rma(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+CX(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){rma(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;RS(9,0,156792,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}Ola(p);Ola(q);Ola(t);Ola(u);Ola(v);Ola(w);i=d;return}function PX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function QX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function RX(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function SX(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;VS(c[a+536>>2]|0,156864,d);return 0}function TX(a){a=a|0;a=i;i=i+8|0;VS(0,156896,a);return 0}function UX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[116212>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=Pla((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;US(0,(n|0)!=0|0,156936,b);c[39238]=c[a+60>>2];c[39240]=c[a+48>>2];tV(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;Ola(n);c[39238]=0;c[39240]=0;n=BX(a)|0;i=b;return n|0}function VX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[39240];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[39238];h[d>>3]=+CX(f,1.0);i=e;return}function WX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=Nla(x)|0;z=y;A=Nla(x)|0;x=A;US(0,(y|0)!=0|0,156968,n);US(0,(A|0)!=0|0,156968,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[116212>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+CX(a,1.0);h[o>>3]=D;if(D!=0.0){c[39246]=c[a+60>>2];c[39248]=c[a+48>>2];qV(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[39246]=0;c[39248]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];RS(9,0,157e3,l)}D=+CX(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];RS(9,0,157104,j);j=c[u>>2]|0;do{if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];TS(9,0,157120,g);F=-1;i=b;return F|0}else if((j|0)==4){TS(9,0,157336,d);F=-4;i=b;return F|0}else if((j|0)==2){TS(9,0,157200,f);F=-2;i=b;return F|0}else if((j|0)==3){TS(9,0,157264,e);F=-3;i=b;return F|0}}while(0);F=BX(a)|0;i=b;return F|0}function XX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[39248];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[39246];h[d>>3]=+CX(f,1.0);i=e;return}function YX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;RS(9,1,157392,g);if((c[116212>>2]|0)==0){l=0}else{l=(k|0)/10|0}ZX(a,d,k,l,b,j);c[f>>2]=c[j>>2];RS(9,0,157416,f);le[c[29182]&511](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=BX(a)|0;if((b|0)==0){m=0;i=e;return m|0}TS(9,0,157432,e);m=b;i=e;return m|0}function ZX(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=Nla(fa(N,M)|0)|0;P=Nla(M<<3)|0;Q=Nla(N)|0;R=Q;S=Nla(N)|0;T=S;V=Nla(N)|0;W=V;X=Nla(N)|0;Y=+h[f>>3];if((c[116212>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];nc(N|0,157480,I|0)|0;I=oc(N|0,157496)|0;c[H>>2]=157512;Bd(I|0,157504,H|0)|0;c[G>>2]=157528;Bd(I|0,157504,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];Bd(I|0,157504,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Yd(10,I|0)|0;c[E>>2]=0;Bd(I|0,157536,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Bd(I|0,157544,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];Bd(I|0,157544,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Yd(10,I|0)|0;Z=I}else{Z=0}US(0,(O|0)!=0|0,157552,B);US(0,(P|0)!=0|0,157552,A);US(0,(Q|0)!=0|0,157552,z);US(0,(S|0)!=0|0,157552,y);US(0,(V|0)!=0|0,157552,x);US(0,(X|0)!=0|0,157552,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{QX(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+CX(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;QX(a,la);+CX(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];RS(9,0,157568,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){tma(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);QX(a,R);za=+CX(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}rma(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}QX(a,T);if(+CX(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}rma(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}rma(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}QX(a,W);Ba=+CX(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}QX(a,W);Ba=+CX(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}rma(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];RS(9,0,157608,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;Bd(Z|0,157536,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];Bd(Z|0,157544,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];Bd(Z|0,157544,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Yd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];TS(9,0,157656,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];TS(9,0,157672,p);VS(0,157688,o)}QX(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){Ola(S);Ola(Q);Ola(V);Ola(X);Ola(P);Ola(O);i=j;return}c[n>>2]=ia;Bd(Z|0,157536,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Bd(Z|0,157544,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];Bd(Z|0,157544,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Yd(10,Z|0)|0;dd(Z|0)|0;Ola(S);Ola(Q);Ola(V);Ola(X);Ola(P);Ola(O);i=j;return}function _X(a,b){a=a|0;b=b|0;i=i;return}function $X(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;rU(3);uU(0);w=+mU(0);rU(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];Bd(v|0,157768,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];Bd(v|0,157768,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];Bd(v|0,157768,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];Bd(v|0,157776,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;Bd(v|0,157776,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];Bd(v|0,157784,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Bd(v|0,157768,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];Bd(v|0,157768,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;Bd(v|0,157776,l|0)|0;break}else{c[m>>2]=0-E;Bd(v|0,157776,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;Bd(v|0,157776,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;Bd(v|0,157776,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Yd(10,v|0)|0;uU(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];Bd(v|0,157784,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Yd(10,v|0)|0;uU(3);i=e;return}function aY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=oc(c[r>>2]|0,157792)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=ae(c[(Tc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;US(t,(s|0)!=0|0,157800,q);c[p>>2]=157856;Bd(s|0,157784,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=157864;Bd(s|0,157784,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];Bd(s|0,157784,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];Bd(s|0,157784,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];Bd(s|0,157784,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];Bd(s|0,157784,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];Bd(s|0,157784,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];Bd(s|0,157784,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];Bd(s|0,157784,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Yd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];Bd(s|0,157784,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Yd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function bY(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;rU(3);dd(d|0)|0;uU(3);i=b;return}function cY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;Zda(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];_da(p,f)|0;dY(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;eY(a,b,157880,c[j>>2]|0,c[g>>2]|0,o,8);Ola(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];_da(p,e)|0;i=d;return}function dY(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=Pla(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;US(c[b+536>>2]|0,(p|0)!=0|0,158160,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function eY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;pY(a,b,d,e,f,h);Yda(l,g,fa(fa(f,e)|0,h)|0)|0;if(tca(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];VS(l,158112,k)}else{i=j;return}}function fY(a){a=a|0;var b=0;b=i;if((hZ(a+4|0)|0)!=0){i=b;return}wca(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function gY(a){a=a|0;Xc(a|0)|0;ad()}function hY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=Tla(320)|0;tma(q|0,0,320)|0;iY(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;rU(3);t=a+8|0;u=jY(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=kY(a,b,u+s|0)|0;u=q+184|0;lY(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;lY(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;mY(q,c[x>>2]|0,36);if(tca(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];VS(y,157936,e)}else{eY(a,b,157968,4,11,157888,1);nY((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;eY(a,b,157976,c[g>>2]|0,c[j>>2]|0,e,1);Ola(e);c[f>>2]=0;nY((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;eY(a,b,157984,c[g>>2]|0,c[j>>2]|0,e,1);Ola(e);c[f>>2]=0;oY(a,b,k,g,j,c[r>>2]|0,s);eY(a,b,158e3,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;Zda(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];dY(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;eY(a,b,157880,c[j>>2]|0,c[g>>2]|0,n,8);Zda(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=qY(q+240|0)|0;w=qY(q+264|0)|0;p=qY(q+288|0)|0;pY(a,b,158016,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);Ola(n);Ola(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;Eda(s)|0;Ola(v);uU(3);i=d;return}}function iY(a){a=a|0;var b=0;b=i;r$(a);i=b;return}function jY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(v_(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(v_(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(v_(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function kY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=Nla(e<<2)|0;e=l;c[l>>2]=158568;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=158608;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(v_(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(v_(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(v_(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function lY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;gZ(a,b,c);i=d;return}function mY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(fZ(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){wca(d,4);i=e;return}else{uca(d,0);i=e;return}}function nY(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=pma(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=Pla((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;US(0,(o|0)!=0|0,158088,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;Ama(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;uY(q,pma(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=Pla(1,1)|0;c[d>>2]=q;US(0,(q|0)!=0|0,158088,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function oY(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=Pla(c[f>>2]<<2,4)|0;c[e>>2]=g;US(c[d+536>>2]|0,(g|0)!=0|0,158136,k);g=s+240|0;f=qY(g)|0;h=s+264|0;t=qY(h)|0;u=s+288|0;v=qY(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=qY(g)|0;D=qY(h)|0;E=qY(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==2){F=1;G=2}else if(z<<24>>24==1){vY(l,b,A+(v*52|0)+4|0);xY(n,b);if(!(wY(l,n)|0)){H=w;break}F=(c[(yY(l)|0)+4>>2]|0)+1|0;G=1}else if(z<<24>>24==0){vY(l,g,A+(v*52|0)+4|0);xY(m,g);if(!(wY(l,m)|0)){H=w;break}F=(c[(yY(l)|0)+4>>2]|0)+1|0;G=2}else{H=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=G;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=F}else{c[z+(w+1<<2)>>2]=0-F}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;H=w+4|0}else{H=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=H;v=A}else{I=H;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){H=d+44|0;v=s+276|0;w=I;t=0;while(1){F=c[H>>2]|0;do{if((a[F+(t*52|0)+48|0]|0)==0){f=a[F+(t*52|0)+8|0]|0;if(f<<24>>24==1){vY(l,v,F+(t*52|0)+4|0);xY(p,v);J=(wY(l,p)|0)&1}else if(f<<24>>24==0){vY(l,h,F+(t*52|0)+4|0);xY(o,h);f=wY(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;G=(c[(c[H>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(yY(l)|0)+4>>2]|0;if(G){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);F=t+1|0;if((F|0)<(c[x>>2]|0)){w=K;t=F}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){vY(l,d,y+(t*52|0)+4|0);xY(r,d);M=(wY(l,r)|0)&1}else if(x<<24>>24==0){vY(l,u,y+(t*52|0)+4|0);xY(q,u);x=wY(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(yY(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function pY(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(pma(d|0)|0)+1;e=m;Yda(e,l,20)|0;if(tca(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];VS(l,158112,k)}Yda(e,d,c[f>>2]|0)|0;if(tca(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];VS(m,158112,j)}else{i=h;return}}function qY(a){a=a|0;var b=0,d=0;b=i;d=c[(cZ(a)|0)>>2]|0;i=b;return d|0}function rY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;rU(3);do{if(sca(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];_da(k,e)|0;k=qY(h+240|0)|0;m=qY(h+264|0)|0;l=qY(h+288|0)|0;pY(a,b,158016,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);fY(h)}else{if((h|0)!=0){break}c[g>>2]=0;uU(3);i=d;return}}while(0);sY(j);Vla(h);c[g>>2]=0;uU(3);i=d;return}function sY(a){a=a|0;var b=0;b=i;AZ(a);i=b;return}function tY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;rU(3);uU(0);h[j>>3]=+mU(0);rU(0);l=k;m=d+4|0;Yda(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){Yda(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){Yda(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);Yda(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);Yda(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);Yda(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(tca(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];VS(t,158056,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;uU(3);i=e;return}}function uY(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((mma(b,158272,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((mma(b,158272,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function vY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;QY(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];GY(a,f);i=e;return}function wY(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=EY(a,b)|0;i=c;return d|0}function xY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;HY(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];GY(a,e);i=d;return}function yY(a){a=a|0;var b=0,c=0;b=i;c=zY(AY(a)|0)|0;i=b;return c|0}function zY(a){a=a|0;var b=0,c=0;b=i;c=DY(a)|0;i=b;return c|0}function AY(a){a=a|0;var b=0,d=0;b=i;d=BY((c[a>>2]|0)+16|0)|0;i=b;return d|0}function BY(a){a=a|0;var b=0,c=0;b=i;c=CY(a)|0;i=b;return c|0}function CY(a){a=a|0;i=i;return a|0}function DY(a){a=a|0;i=i;return a|0}function EY(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(FY(a,b)|0)^1;i=c;return d|0}function FY(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function GY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];PY(a,e);i=d;return}function HY(a,b){a=a|0;b=b|0;var c=0;c=i;IY(a,JY(b)|0);i=c;return}function IY(a,b){a=a|0;b=b|0;var c=0;c=i;OY(a,b);i=c;return}function JY(a){a=a|0;var b=0,c=0;b=i;c=KY(LY(a+4|0)|0)|0;i=b;return c|0}function KY(a){a=a|0;var b=0,c=0;b=i;c=NY(a)|0;i=b;return c|0}function LY(a){a=a|0;var b=0,c=0;b=i;c=MY(a)|0;i=b;return c|0}function MY(a){a=a|0;i=i;return a|0}function NY(a){a=a|0;i=i;return a|0}function OY(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function PY(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function QY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=SY(b)|0;RY(f,b,d,h,JY(b)|0);HY(g,b);do{if(EY(f,g)|0){h=TY(b)|0;if(UY(h,d,VY(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);HY(a,b);i=e;return}function RY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;ZY(h);a:do{if((e|0)==0){j=f}else{k=TY(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(_Y(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;ZY(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;ZY(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);IY(a,j);i=g;return}function SY(a){a=a|0;var b=0,d=0;b=i;d=c[(JY(a)|0)>>2]|0;i=b;return d|0}function TY(a){a=a|0;var b=0,c=0;b=i;c=XY(a+8|0)|0;i=b;return c|0}function UY(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=WY(0,b,c)|0;i=a;return d|0}function VY(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function WY(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function XY(a){a=a|0;var b=0,c=0;b=i;c=YY(a)|0;i=b;return c|0}function YY(a){a=a|0;i=i;return a|0}function ZY(a){a=a|0;var b=0;b=i;$Y(a,-1);i=b;return}function _Y(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=WY(0,b,c)|0;i=a;return d|0}function $Y(a,b){a=a|0;b=b|0;b=i;aZ(a,0);i=b;return}function aZ(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function bZ(a){a=a|0;i=i;return c[a+4>>2]|0}function cZ(a){a=a|0;var b=0,c=0;b=i;c=dZ(a+8|0)|0;i=b;return c|0}function dZ(a){a=a|0;var b=0,c=0;b=i;c=eZ(a)|0;i=b;return c|0}function eZ(a){a=a|0;i=i;return a|0}function fZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 9:case 25:{h=158216;break};case 8:{h=158192;break};case 13:case 29:{h=158264;break};case 60:{h=158256;break};case 52:case 20:{h=158224;break};case 24:{h=158200;break};case 1:case 17:{h=158184;break};case 12:{h=158240;break};case 56:{h=158208;break};case 28:{h=158248;break};case 48:case 16:{h=158176;break};case 5:case 21:{h=158232;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=oc(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if(($c(j|0,0,2)|0)==0){g=a;i=e;return g|0}dd(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function gZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function hZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}iZ(d,f,102);f=oe[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((dd(jZ(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}kZ(d);g=h;i=b;return g|0}function iZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;rZ(a,b,c);i=d;return}



function uR(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=Ne[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=Ne[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=Ne[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=Ne[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function vR(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((xR(wR(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((xR(wR(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=wR(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((xR(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=wR(k,a,b)|0;n=h;}while((xR(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=wR(k,a,b)|0;while(1){if((xR(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=wR(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=wR(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function wR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;ie[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function xR(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function yR(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function zR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 12:{c[h>>2]=14;j=1;break};case 11:{c[h>>2]=14;j=55;break};case 14:{j=0;break};case 15:{c[h>>2]=14;j=0;break};case 13:{c[h>>2]=14;j=56;break};case 16:{if((Ne[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,113800)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 29:{c[h>>2]=16;j=2;break};default:{k=10}}}while(0);if((k|0)==10){j=DR(h,a)|0}i=g;return j|0}function AR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case 26:{j=9;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 33:{c[h>>2]=17;k=0;break};case 15:{k=0;break};default:{k=CR(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=DR(h,a)|0}i=g;return k|0}function BR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((Ne[c[e+28>>2]&63](e,b,d,113784)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((Ne[c[e+28>>2]&63](e,b,d,113792)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=DR(h,a)|0;l=k;i=g;return l|0}function CR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 16:{if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,113560)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,113568)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,113576)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,113584)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};default:{}}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function DR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function ER(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function FR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==15){g=11}else if((b|0)==22){c[e>>2]=25;g=11}else{g=DR(e,a)|0}i=f;return g|0}function GR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else{g=DR(e,a)|0}i=f;return g|0}function HR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=DR(e,a)|0}i=f;return g|0}function IR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=29;g=18}else if((b|0)==15){g=17}else{g=DR(e,a)|0}i=f;return g|0}function JR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=DR(e,a)|0}i=f;return g|0}function KR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==13){g=56}else if((b|0)==11){g=55}else if((b|0)==15){g=0}else if((b|0)==29){c[e>>2]=16;g=2}else{g=DR(e,a)|0}i=f;return g|0}function LR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((Ne[c[e+28>>2]&63](e,b,d,113600)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,113608)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function MR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=DR(e,a)|0}i=f;return g|0}function NR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=34;g=21}else if((b|0)==15){g=17}else{g=DR(e,a)|0}i=f;return g|0}function OR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=DR(e,a)|0}i=f;return g|0}function PR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=DR(e,a)|0;h=g;i=f;return h|0}return 0}function QR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}else if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,113616)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,113624)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function RR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{j=39;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 30:{c[h>>2]=40;j=53;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 20:{if((Ne[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,113632)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 32:{c[h>>2]=40;j=54;break};case 31:{c[h>>2]=40;j=52;break};default:{k=10}}}while(0);if((k|0)==10){j=DR(h,a)|0}i=g;return j|0}function SR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else{g=DR(e,a)|0}i=f;return g|0}function TR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 32:{c[e>>2]=40;g=54;break};case 30:{c[e>>2]=40;g=53;break};case 31:{c[e>>2]=40;g=52;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 15:{g=39;break};default:{g=DR(e,a)|0}}i=f;return g|0}function UR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};default:{g=DR(e,a)|0;h=g;i=f;return h|0}}return 0}function VR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=DR(e,a)|0}i=f;return g|0}function WR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else{g=DR(e,a)|0}i=f;return g|0}function XR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==15){g=33}else{g=DR(e,a)|0}i=f;return g|0}function YR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((Ne[m&63](n,o,p,c[113640+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((Ne[m&63](n,o,p,113584)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function ZR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}else if((f|0)==20){if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,113744)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,113752)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,113768)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function _R(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=DR(e,a)|0}i=f;return g|0}function $R(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else if((b|0)==15){g=33}else{g=DR(e,a)|0}i=f;return g|0}function aS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else{g=DR(e,a)|0}i=f;return g|0}function bS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=DR(e,a)|0}i=f;return g|0}function cS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=DR(e,a)|0}i=f;return g|0}function dS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=DR(e,a)|0}i=f;return g|0}function eS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=DR(e,a)|0}i=f;return g|0}function fS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,113600)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,113608)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function gS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=DR(e,a)|0}i=f;return g|0}function hS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=DR(e,a)|0}i=f;return g|0}function iS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;f=a;do{if((f|0)==18){if((Ne[c[b+28>>2]&63](b,d,e,113776)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function jS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=DR(e,a)|0}i=f;return g|0}function kS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,113600)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,113608)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function lS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=58;g=13}else{g=DR(e,a)|0}i=f;return g|0}function mS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=DR(e,a)|0}i=f;return g|0}function nS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=DR(e,a)|0;h=g;i=f;return h|0}return 0}function oS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=DR(e,a)|0;h=g;i=f;return h|0}return 0}function pS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=DR(e,a)|0}i=f;return g|0}function qS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 16:{if((Ne[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,113800)|0)==0){j=9;break a}c[h>>2]=15;k=3;break};case 13:{k=56;break};case 15:{k=0;break};case 11:{k=55;break};case 29:{c[h>>2]=16;k=2;break};case 14:{k=0;break};default:{j=9}}}while(0);if((j|0)==9){k=DR(h,a)|0}i=g;return k|0}function rS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=DR(e,a)|0}i=f;return g|0}function sS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((Ne[c[e+28>>2]&63](e,b,d,113600)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((Ne[c[e+28>>2]&63](e,b,d,113608)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}}while(0);j=DR(h,a)|0;k=j;i=g;return k|0}function tS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=DR(e,a)|0}i=f;return g|0}function uS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=DR(e,a)|0}i=f;return g|0}function vS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==15){g=3}else{g=DR(e,a)|0}i=f;return g|0}function wS(){i=i;return}function xS(){i=i;return}function yS(){var a=0;a=i;Wa(113808,0)|0;i=a;return}function zS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;c[a+8>>2]=b;c[a>>2]=d;b=a+4|0;c[b>>2]=rT(d)|0;if((d|0)>0){g=0}else{i=f;return}do{a=c[e>>2]|0;h=c[a>>2]|0;c[e>>2]=a+4;c[(c[b>>2]|0)+(g<<2)>>2]=h;g=g+1|0;}while((g|0)<(d|0));i=f;return}function AS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;xc(113816,29,1,e|0)|0;zd(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;xc(113848,54,1,g|0)|0;zd(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;xc(113904,47,1,a|0)|0;zd(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;Bd(k|0,113952,d|0)|0;zd(k|0)|0;f=0;i=b;return f|0}function BS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[a>>2]|0;f=c[e>>2]|0;g=(b|0)>1;a:do{if(g){h=1;while(1){j=h+1|0;if((c[c[a+(h<<2)>>2]>>2]|0)!=(f|0)){break}if((j|0)<(b|0)){h=j}else{break a}}cb(114016,114080,103,114104)}}while(0);if((f|0)<=0){i=d;return}h=c[e+4>>2]|0;e=0;b:while(1){j=c[h+(e<<2)>>2]|0;if(g){k=1;while(1){l=k+1|0;if((j|0)!=(c[(c[(c[a+(k<<2)>>2]|0)+4>>2]|0)+(e<<2)>>2]|0)){m=10;break b}if((l|0)<(b|0)){k=l}else{break}}}k=e+1|0;if((k|0)<(f|0)){e=k}else{m=12;break}}if((m|0)==10){cb(114136,114080,109,114104)}else if((m|0)==12){i=d;return}}function CS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;Bd(j|0,114208,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;Bd(n|0,114240,e|0)|0;k=0;i=d;return k|0}function DS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function ES(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=rT(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function FS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=rT(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function GS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[41338]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=114296;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Oe[p&63](0,f,114320,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function HS(a,b){a=a|0;b=b|0;var d=0;d=i;if((AS(a)|0)==0){cb(114376,114080,347,114400)}do{if((b|0)>0){if((c[a>>2]|0)<(b|0)){break}i=d;return c[(c[a+4>>2]|0)+(b+ -1<<2)>>2]|0}}while(0);cb(114432,114080,348,114400);return 0}function IS(){var a=0,b=0,d=0;a=i;b=116176|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=116288|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=116400|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[116180>>2]=1;c[116184>>2]=1;i=a;return}function JS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?116536:116552;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;Bd(a|0,116512,e|0)|0;i=d;return}function KS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=116400+(d<<2)|0;o=116288+(d<<2)|0;p=116600+(b<<2)|0;q=114880+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=116584;mc(116568,l|0)|0;s=116584}else{if((c[29040]|0)==(d|0)){if((c[o>>2]|0)>0){t=116584}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;mc(116568,m|0)|0;do{if((c[29040]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=116584;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;mc(116592,k|0)|0;c[n>>2]=b;c[29040]=d;if((c[o>>2]|0)>0){g=0;while(1){mc(116624,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;vb(e|0)|0;r=0;e=e+(w+1)|0;f=1}vb(e|0)|0;zd(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function LS(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[116600+(a<<2)>>2]|0;c[j>>2]=c[114880+(b<<2)>>2];c[j+4>>2]=k;mc(116632,j|0)|0;MS(e);if((g|0)==0){Pd(((d|0)!=0?116672:116720)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=zd(m|0)|0;i=f;return}vb(116800)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];mc(116680,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=zd(m|0)|0;i=f;return}xc(116704,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=zd(m|0)|0;i=f;return}function MS(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==38){xc(116744,5,1,e|0)|0}else if(b<<24>>24==62){xc(116760,4,1,e|0)|0}else if(b<<24>>24==60){xc(116752,4,1,e|0)|0}else if(b<<24>>24==0){break}else{Yd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function NS(a){a=a|0;var b=0;b=116288+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function OS(a){a=a|0;var b=0;b=(a|0)==0;c[29184]=b?1:19;c[29182]=b?7:284;i=i;return}function PS(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;xc(116704,11,1,b|0)|0;zd(b|0)|0;i=a;return}function QS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[116176+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;sc(j|0,2048,e|0,h|0)|0;xe[c[29184]&31](1,a,b,j,0,d);i=g;return}function RS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[116176+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;sc(h|0,2048,d|0,g|0)|0;xe[c[29184]&31](1,a,b,h,0,0);i=f;return}function SS(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[29042]|0)==0){if((c[116176+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;sc(k|0,2048,e|0,j|0)|0;xe[c[29184]&31](2,a,b,k,0,d);i=g;return}function TS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[29042]|0)==0){if((c[116176+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;sc(j|0,2048,d|0,h|0)|0;xe[c[29184]&31](2,a,b,j,0,0);i=f;return}function US(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;sc(b|0,2048,d|0,g|0)|0;xe[c[29184]&31](4,2,0,b,0,0);if((a|0)==0){h=rd(c[28452]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function VS(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;sc(g|0,2048,b|0,f|0)|0;xe[c[29184]&31](5,2,0,g,0,0);if((a|0)==0){h=rd(c[28452]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function WS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;sc(h|0,2048,d|0,g|0)|0;xe[c[29184]&31](5,2,0,h,0,b);if((a|0)==0){j=rd(c[28452]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function XS(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;WS(a,e,116872,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;SS(26,0,e,116808,m);i=j;return+b}return 0.0}function YS(a,b){a=a|0;b=b|0;var c=0;c=i;ES(a,b,pT(b)|0);i=c;return}function ZS(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function _S(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;ZS(c[d+8>>2]|0,b,a);i=e;return}function $S(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;YS(a,b);h=g;c[g>>2]=e;_S(d,0,a);if((b|0)>1){j=1}else{i=f;return}do{d=c[h>>2]|0;e=c[d>>2]|0;c[h>>2]=d+4;_S(e,j,a);j=j+1|0;}while((j|0)<(b|0));i=f;return}function aT(a){a=a|0;i=i;return}function bT(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=Nla(16)|0;US(0,(d|0)!=0|0,116920,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function cT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;Ola(c[f>>2]|0);Ola(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function dT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;US(0,(a|0)!=0|0,116936,f);f=Nla(8)|0;g=f;US(0,(f|0)!=0|0,116920,e);e=a+8|0;h=Nla(c[e>>2]|0)|0;c[f>>2]=h;US(0,(h|0)!=0|0,116920,d);rma(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function eT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;US(0,(a|0)!=0|0,116936,f);f=Nla(8)|0;g=f;US(0,(f|0)!=0|0,116920,e);e=a+8|0;h=Nla(c[e>>2]|0)|0;c[f>>2]=h;US(0,(h|0)!=0|0,116920,d);rma(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function fT(a){a=a|0;var b=0;b=i;i=i+8|0;US(0,(a|0)!=0|0,116936,b);i=b;return c[a+12>>2]|0}function gT(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;US(0,(a|0)!=0|0,116936,d);d=a;US(0,(c[d>>2]|0)!=0|0,116960,b);i=b;return c[c[d>>2]>>2]|0}function hT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;Ola(c[e>>2]|0);Ola(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function iT(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;US(0,(a|0)!=0|0,116936,d);d=a;US(0,(c[d>>2]|0)!=0|0,116976,b);i=b;return c[d>>2]|0}function jT(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;US(0,d&1,117008,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function kT(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;US(0,(a|0)!=0|0,117008,d);d=a;US(0,(c[d>>2]|0)!=0|0,117032,b);i=b;return c[d>>2]|0}function lT(){var a=0,b=0,d=0;a=i;b=Nla(16)|0;c[29276]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=Nla(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function mT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=sT(a)|0;zc(117112)|0;tT(d);a=c[29276]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;kc(117112)|0;tma(g|0,0,d|0)|0;i=b;return g|0}function nT(){var a=0,b=0,d=0,e=0;a=i;b=c[29276]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;Ola(c[b>>2]|0);Ola(b);if((d|0)==0){break}else{b=d}}e=c[29276]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function oT(a){a=a|0;var b=0,d=0;b=i;d=oe[c[117064>>2]&127](a<<3)|0;i=b;return d|0}function pT(a){a=a|0;var b=0,d=0;b=i;d=oe[c[117064>>2]&127](a<<2)|0;i=b;return d|0}function qT(a){a=a|0;var b=0,d=0;b=i;d=oe[c[117064>>2]&127](a<<2)|0;i=b;return d|0}function rT(a){a=a|0;var b=0,d=0;b=i;d=oe[c[117064>>2]&127](a<<2)|0;i=b;return d|0}function sT(a){a=a|0;i=i;return a+7&-8|0}function tT(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[29276]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=Nla(16)|0;c[f+12>>2]=d;c[29276]=f;c[f+4>>2]=0;d=uT((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=Nla(d)|0;c[f>>2]=a;i=b;return}function uT(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function vT(a){a=a|0;var b=0,c=0;b=i;c=pma(a|0)|0;i=b;return c|0}function wT(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;vma(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];nc(m|0,l|0,f|0)|0;f=xT(m)|0;i=e;return f|0}function xT(a){a=a|0;var b=0,c=0,d=0;b=i;c=pma(a|0)|0;d=BT(c)|0;rma(d|0,a|0,c|0)|0;i=b;return d|0}function yT(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;vma(g+1|0,d|0)|0;c[f>>2]=b;nc(k|0,j|0,f|0)|0;f=xT(k)|0;i=e;return f|0}function zT(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+40|0;l=i;i=i+400|0;m=k;n=l;a[m]=37;l=k+1|0;if(e<<24>>24==0){c[h>>2]=d;nc(l|0,117144,h|0)|0;o=g;p=o;c[p>>2]=b;q=40;r=q;s=nc(n|0,m|0,g|0)|0;t=xT(n)|0;i=f;return t|0}else{c[j>>2]=d;nc(l|0,117136,j|0)|0;o=g;p=o;c[p>>2]=b;q=40;r=q;s=nc(n|0,m|0,g|0)|0;t=xT(n)|0;i=f;return t|0}return 0}function AT(b,d,e,f){b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;j=g;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+400|0;p=n;q=o;a[p]=37;o=n+1|0;if(e<<24>>24==0){c[l>>2]=d;c[l+4>>2]=f;nc(o|0,117160,l|0)|0}else{c[m>>2]=d;c[m+4>>2]=f;nc(o|0,117152,m|0)|0}m=j;h[k>>3]=b;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];nc(q|0,p|0,j|0)|0;j=xT(q)|0;i=g;return j|0}function BT(b){b=b|0;var d=0,e=0;d=i;e=oe[c[117068>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function CT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=vT(a)|0;e=vT(b)|0;f=BT(e+d|0)|0;rma(f|0,a|0,d|0)|0;rma(f+d|0,b|0,e|0)|0;i=c;return f|0}function DT(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=lma(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function ET(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 3:{f=2;break a;break};case 4:{f=2;break a;break};case 2:{f=4;break a;break};case 1:{f=4;break a;break};case 0:{f=8;break a;break};case 5:{f=1;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function FT(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){dd(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){Ola(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{Ola(c[(c[f>>2]|0)+(g<<4)>>2]|0);Ola(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;Ola(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){Ola(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{Ola(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}Ola(d);c[g>>2]=0;i=b;return}function GT(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(pma(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function HT(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=oc(b|0,117328)|0;m=d;c[m>>2]=l;if((l|0)==0){n=ae(c[(Tc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Ed(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=ub(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=117336;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[117304+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=117360;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=117384;E=131;break}G=ET(D)|0;if((G|0)==-1){n=117416;E=131;break}D=c[q>>2]|0;H=Nla(D)|0;if((ub(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=117464;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=117488;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((lma(H,c[117280+(C<<2)>>2]|0)|0)!=0){n=117512;E=131;break}Ola(H);H=118088;b:do{switch(C|0){case 2:{if(d<<24>>24==1){if((I|0)==0){K=1;E=129;break b}F=D+1|0;G=0;while(1){L=Nla(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=L;if((ub(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=117712;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;L=G+1|0;if(L>>>0<I>>>0){G=L}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}G=fa(D,I)|0;N=Nla(G+1|0)|0;if((ub(N|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;F=(I|0)==0;L=0;do{O=Nla(G)|0;c[(c[v>>2]|0)+(L<<4)+4>>2]=O;if(!F){O=0;do{P=a[N+((fa(D,O)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+O|0]=P;O=O+1|0;}while(O>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+I|0]=0;L=L+1|0;}while(L>>>0<D>>>0)}Ola(N);M=0;E=130;break};case 3:{L=fa(I<<2,D)|0;Q=Nla(L)|0;if((ub(Q|0,L|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}L=c[v>>2]|0;F=0;do{G=fa(D,F)|0;c[L+(F<<4)+8>>2]=(c[Q+(G<<2)>>2]|0)==1;c[L+(F<<4)+12>>2]=c[Q+(G+1<<2)>>2];F=F+1|0;}while(F>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}F=c[v>>2]|0;L=0;do{c[F+(L<<4)+8>>2]=(c[Q+(L<<2)>>2]|0)==1;c[F+(L<<4)+12>>2]=c[Q+(D+L<<2)>>2];L=L+1|0;}while(L>>>0<D>>>0)}}while(0);Ola(Q);hc(c[v>>2]|0,c[u>>2]|0,16,54);M=d;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=117776;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=117832;E=131;break a}c[w>>2]=D;L=fa(I,D)|0;if((a[l]|0)==1){F=Nla(L<<3)|0;c[x>>2]=F;if((ub(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=117872;E=131;break a}}else{F=Nla(L<<2)|0;c[x>>2]=Nla(fa(D<<3,I)|0)|0;if((ub(F|0,J|0,1,c[m>>2]|0)|0)!=1){n=117872;E=131;break a}if((L|0)!=0){G=c[x>>2]|0;O=0;do{h[G+(O<<3)>>3]=+g[F+(O<<2)>>2];O=O+1|0;}while(O>>>0<L>>>0)}Ola(F)}L=c[w>>2]|0;if(!(L>>>0>1)){M=1;E=130;break b}O=(I|0)==2;G=1;while(1){if(O){P=c[x>>2]|0;if(+h[P+(G<<3)>>3]!=+h[P+(L+G<<3)>>3]){n=117904;E=131;break a}}P=G+1|0;if(P>>>0<L>>>0){G=P}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}if((I|0)==0){n=117776;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=117984;E=131;break a}c[w>>2]=I;G=fa(I,D)|0;if((a[l]|0)==1){L=Nla(G<<3)|0;c[x>>2]=Nla(fa(D<<3,I)|0)|0;if((ub(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=117872;E=131;break a}if((D|0)!=0){O=0;do{F=c[x>>2]|0;P=0;do{h[F+((fa(I,O)|0)+P<<3)>>3]=+h[L+((fa(D,P)|0)+O<<3)>>3];P=P+1|0;}while(P>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}Ola(L)}else{O=Nla(G<<2)|0;c[x>>2]=Nla(fa(D<<3,I)|0)|0;if((ub(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=117872;E=131;break a}if((D|0)!=0){P=0;do{F=c[x>>2]|0;R=0;do{h[F+((fa(I,P)|0)+R<<3)>>3]=+g[O+((fa(D,R)|0)+P<<2)>>2];R=R+1|0;}while(R>>>0<I>>>0);P=P+1|0;}while(P>>>0<D>>>0)}Ola(O)}P=c[w>>2]|0;if(!(P>>>0>1)){M=d;E=130;break b}G=(D|0)==2;L=1;while(1){if(G){R=c[x>>2]|0;if(+h[R+(L<<3)>>3]!=+h[R+(P+L<<3)>>3]){n=117904;E=131;break a}}R=L+1|0;if(R>>>0<P>>>0){L=R}else{M=d;E=130;break}}break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=118024;E=131;break a}c[z>>2]=D;c[A>>2]=Ab(c[m>>2]|0)|0;c[B>>2]=Pla(c[z>>2]<<1,4)|0;if(($c(c[m>>2]|0,J|0,1)|0)==-1){n=118056;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=118024;E=131;break a}c[z>>2]=I;c[A>>2]=Ab(c[m>>2]|0)|0;c[B>>2]=Pla(c[z>>2]<<1,4)|0;L=fa(I,D)|0;if((a[l]|0)==1){P=Nla(L<<3)|0;if((ub(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=118056;E=131;break a}if((I|0)!=0){G=D<<3;O=(D|0)==0;R=D<<3;F=0;do{S=Nla(G)|0;c[(c[B>>2]|0)+(F<<2)>>2]=S;if(!O){S=P+(fa(R,F)|0)|0;rma(c[(c[B>>2]|0)+(F<<2)>>2]|0,S|0,R|0)|0}F=F+1|0;}while(F>>>0<I>>>0)}F=c[z>>2]|0;R=F<<1;if(F>>>0<R>>>0){O=D<<3;G=(D|0)==0;S=F;do{T=Nla(O)|0;c[(c[B>>2]|0)+(S<<2)>>2]=T;if(!G){T=c[B>>2]|0;U=c[T+(S-F<<2)>>2]|0;V=c[T+(S<<2)>>2]|0;T=0;do{h[V+(T<<3)>>3]=-+h[U+(T<<3)>>3];T=T+1|0;}while(T>>>0<D>>>0)}S=S+1|0;}while(S>>>0<R>>>0)}Ola(P)}else{R=Nla(L<<2)|0;if((ub(R|0,J|0,1,c[m>>2]|0)|0)!=1){n=118056;E=131;break a}if((I|0)!=0){S=D<<3;F=(D|0)==0;G=0;do{O=Nla(S)|0;c[(c[B>>2]|0)+(G<<2)>>2]=O;if(!F){O=c[(c[B>>2]|0)+(G<<2)>>2]|0;T=0;do{h[O+(T<<3)>>3]=+g[R+((fa(D,G)|0)+T<<2)>>2];T=T+1|0;}while(T>>>0<D>>>0)}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;F=G<<1;if(G>>>0<F>>>0){S=D<<3;L=(D|0)==0;P=G;do{T=Nla(S)|0;c[(c[B>>2]|0)+(P<<2)>>2]=T;if(!L){T=c[B>>2]|0;O=c[T+(P-G<<2)>>2]|0;U=c[T+(P<<2)>>2]|0;T=0;do{h[U+(T<<3)>>3]=-+h[O+(T<<3)>>3];T=T+1|0;}while(T>>>0<D>>>0)}P=P+1|0;}while(P>>>0<F>>>0)}Ola(R)}if(($c(c[m>>2]|0,J|0,1)|0)==-1){n=118056;E=131;break a}else{M=d;E=130}break};case 1:{F=d<<24>>24==0;c[u>>2]=F?D:I;P=Nla((F?D:I)<<4)|0;c[v>>2]=P;c:do{if(d<<24>>24==1){if((I|0)==0){W=0;break}G=D+1|0;L=P;S=0;while(1){c[L+(S<<4)>>2]=Nla(G)|0;if((ub(c[(c[v>>2]|0)+(S<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=117712;E=131;break a}a[(c[(c[v>>2]|0)+(S<<4)>>2]|0)+D|0]=0;T=c[v>>2]|0;c[T+(S<<4)+8>>2]=-1;c[T+(S<<4)+12>>2]=-1;GT(c[T+(S<<4)>>2]|0);T=S+1|0;if(!(T>>>0<I>>>0)){W=I;break c}L=c[v>>2]|0;S=T}}else{W=I}}while(0);if(!F){M=d;E=130;break b}P=fa(D,W)|0;X=Nla(P+1|0)|0;if((ub(X|0,P|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){P=W+1|0;R=(W|0)==0;S=0;do{L=Nla(P)|0;c[(c[v>>2]|0)+(S<<4)>>2]=L;if(!R){L=0;do{G=a[X+((fa(D,L)|0)+S)|0]|0;a[(c[(c[v>>2]|0)+(S<<4)>>2]|0)+L|0]=G;L=L+1|0;}while(L>>>0<W>>>0)}a[(c[(c[v>>2]|0)+(S<<4)>>2]|0)+W|0]=0;L=c[v>>2]|0;c[L+(S<<4)+8>>2]=-1;c[L+(S<<4)+12>>2]=-1;GT(c[L+(S<<4)>>2]|0);S=S+1|0;}while(S>>>0<D>>>0)}Ola(X);M=0;E=130;break};case 0:{if((D|0)!=4){n=117536;E=131;break a}if((I|0)!=11){n=117576;E=131;break a}if((ub(f|0,44,1,c[m>>2]|0)|0)==1){Y=0}else{n=117616;E=131;break a}while(1){S=0;do{a[k+S|0]=a[j+((S<<2)+Y)|0]|0;S=S+1|0;}while(S>>>0<11);a[k+11|0]=0;if((Y|0)==3){break}S=Y+1|0;if(S>>>0<4){Y=S}else{M=d;E=130;break b}}if((mma(t,c[29296]|0,8)|0)==0){M=1;E=130;break b}if((mma(t,c[29302]|0,9)|0)==0){M=0;E=130}else{n=117648;E=131;break a}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=K;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){Ola(X);n=117712;i=e;return n|0}else if((E|0)==46){Ola(N);n=117712;i=e;return n|0}else if((E|0)==52){Ola(Q);n=117744;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function IT(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Jd(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,54)|0;i=d;return b|0}function JT(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=118128;o=n;p=118176;q=p;r=118200;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=118128;o=n;p=118176;q=p;r=118200;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=Nla(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){$c(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((ub(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}Ola(r);t=0;i=e;return t|0}else{k=Nla(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){$c(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((ub(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}Ola(k);Ola(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);Ola(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function KT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=118128;r=q;s=118176;t=s;u=118224;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=118128;r=q;s=118176;t=s;u=118224;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){$c(o|0,t+(r<<3)|0,0)|0;f=(ub(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{$c(o|0,t+(r<<2)|0,0)|0;if((ub(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function LT(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function MT(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function NT(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function OT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+NT(b)<e){q=1;i=f;return q|0}if(+MT(b)>e){q=1;i=f;return q|0}if((JT(b,1)|0)==0){q=1;i=f;return q|0}LT(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+KT(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+KT(a,b,d,o);i=f;return q|0}if(+KT(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+KT(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function PT(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function QT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;zS(a,b,d,g);i=f;return}function RT(a,b){a=a|0;b=b|0;var c=0;c=i;ES(a,b,oT(b)|0);i=c;return}function ST(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=oT(FS(a,b,f)|0)|0;i=e;return}function TT(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((AS(a)|0)==0){cb(118256,118280,127,118304)}if((AS(b)|0)==0){cb(118328,118280,128,118304)}if((CS(a,b)|0)==0){cb(118352,118280,129,118304)}e=DS(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+PT(a,b);UT(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function UT(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function VT(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function WT(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;UT(c[d+8>>2]|0,b,a);i=e;return}function XT(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0;f=i;i=i+24|0;g=f;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=Nla(b<<2)|0;n=m;if((m|0)==0){cb(118392,118280,617,118400)}o=l;c[l>>2]=e;c[m>>2]=d;if((b|0)>1){e=1;do{l=c[o>>2]|0;p=c[l>>2]|0;c[o>>2]=l+4;c[m+(e<<2)>>2]=p;e=e+1|0;}while((e|0)<(b|0))}BS(n,b);n=c[d>>2]|0;if((n|0)==4){e=c[d+4>>2]|0;o=c[e>>2]|0;p=c[e+4>>2]|0;l=c[e+8>>2]|0;q=c[e+12>>2]|0;c[g>>2]=b;c[g+4>>2]=o;c[g+8>>2]=p;c[g+12>>2]=l;c[g+16>>2]=q;ST(a,5,g)}else if((n|0)==2){g=c[d+4>>2]|0;q=c[g>>2]|0;l=c[g+4>>2]|0;c[j>>2]=b;c[j+4>>2]=q;c[j+8>>2]=l;ST(a,3,j)}else if((n|0)==3){j=c[d+4>>2]|0;l=c[j>>2]|0;q=c[j+4>>2]|0;g=c[j+8>>2]|0;c[h>>2]=b;c[h+4>>2]=l;c[h+8>>2]=q;c[h+12>>2]=g;ST(a,4,h)}else if((n|0)==1){n=c[c[d+4>>2]>>2]|0;c[k>>2]=b;c[k+4>>2]=n;ST(a,2,k)}else{cb(118424,118280,639,118400)}if((b|0)<=0){Ola(m);i=f;return}k=a+8|0;a=0;n=0;while(1){d=m+(n<<2)|0;h=DS(c[d>>2]|0)|0;if((h|0)>0){g=a;q=0;while(1){r=+PT(c[d>>2]|0,q);UT(c[k>>2]|0,g,r);l=q+1|0;if((l|0)<(h|0)){q=l;g=g+1|0}else{break}}s=h+a|0}else{s=a}g=n+1|0;if((g|0)<(b|0)){a=s;n=g}else{break}}Ola(m);i=f;return}function YT(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;RT(a,b);j=g;c[g>>2]=e;WT(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;WT(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function ZT(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=GS(a,b,f)|0;f=VT(c[a+8>>2]|0,d)|0;i=e;return f|0}function _T(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=Nla(d<<2)|0;if((j|0)==0){cb(118392,118280,784,118488)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){cb(118464,118280,795,118488)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){cb(118512,118280,798,118488)}else if((s|0)==17){cb(118552,118280,800,118488)}else if((s|0)==22){cb(118552,118280,804,118488)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=oT(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=rT(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){Ola(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+PT(a,k+s|0);UT(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}Ola(j);i=g;return}function $T(a){a=a|0;var b=0,c=0,d=0.0,e=0,f=0.0,g=0.0,h=0;b=i;if((AS(a)|0)==0){cb(118600,118280,1547,118624)}c=DS(a)|0;if((c|0)==0){d=0.0;i=b;return+d}else{e=0;f=0.0}while(1){g=f+ +PT(a,e);h=e+1|0;if(h>>>0<c>>>0){f=g;e=h}else{d=g;break}}i=b;return+d}function aU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Nla(20)|0;US(0,(f|0)!=0|0,118640,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=Pla(e,b)|0;c[f>>2]=a;US(0,(a|0)!=0|0,118640,d);i=d;return f|0}function bU(a){a=a|0;var b=0;b=i;Ola(c[a>>2]|0);Ola(a);i=b;return}function cU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;US(0,(c[h>>2]|0)>0|0,118656,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;US(0,(g|0)>(b|0)|0,118680,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;US(0,(0-f|0)<(b|0)|0,118680,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function dU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=Pla(c[d>>2]<<1,c[e>>2]|0)|0;US(0,(f|0)!=0|0,118640,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=cU(a,j)|0;h=c[e>>2]|0;rma(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;Ola(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function eU(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){dU(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;rma((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function fU(a){a=a|0;i=i;return c[a+12>>2]|0}function gU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;US(0,(c[j>>2]|0)>0|0,118656,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;US(0,(h|0)>(b|0)|0,118680,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;US(0,b>>>31^1,118680,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=cU(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function hU(a){a=a|0;i=i;return c[(c[29678]|0)+(a<<2)>>2]|0}function iU(a){a=a|0;i=i;return c[(c[29680]|0)+(a<<2)>>2]|0}function jU(a){a=a|0;i=i;return c[(c[29682]|0)+(a<<2)>>2]|0}function kU(a){a=a|0;i=i;return c[(c[29684]|0)+(a<<2)>>2]|0}function lU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[29680]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[29682]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[29678]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function mU(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[29686]|0;e=+nU(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function nU(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function oU(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[29688]|0;e=+nU(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function pU(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[29690]|0;e=+nU(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function qU(a){a=a|0;i=i;return 0}function rU(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[29692]|0)+(a<<3)|0)|0;d=(c[29678]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function sU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[29686]|0;f=e+(a<<3)|0;g=c[29690]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[29684]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[29678]|0)+(a<<2)>>2]|0);e=c[29688]|0;g=e+(a<<3)|0;tU(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;lU(a);d=c[29686]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[29678]|0)+(a<<2)>>2]=0;i=b;return}function tU(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(wU(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function uU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[29692]|0;f=c[29686]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function vU(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=Pla(a,8)|0;c[29686]=d;e=Pla(a,8)|0;c[29688]=e;f=Pla(a,8)|0;c[29690]=f;g=Pla(a,8)|0;c[29692]=g;h=Pla(a,4)|0;c[29678]=h;j=Pla(a,4)|0;c[29684]=j;k=a<<2;l=Nla(k)|0;c[29680]=l;m=Pla(a,4)|0;c[29682]=m;tma(l|0,-1,k|0)|0;if((d|0)==0){cb(118776,118792,393,118808)}if((e|0)==0){cb(118816,118792,394,118808)}if((f|0)==0){cb(118832,118792,395,118808)}if((g|0)==0){cb(118848,118792,396,118808)}if((h|0)==0){cb(118864,118792,397,118808)}if((l|0)==0){cb(118888,118792,398,118808)}if((m|0)==0){cb(118912,118792,399,118808)}if((j|0)==0){cb(118936,118792,400,118808)}else{i=b;return}}function wU(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function xU(a,b){a=a|0;b=b|0;var c=0;c=i;ES(a,b,qT(b)|0);i=c;return}function yU(a,b,d){a=a|0;b=b|0;d=d|0;c[a+(b<<2)>>2]=d;i=i;return}function zU(a,b){a=a|0;b=b|0;i=i;return a+(b<<2)|0}function AU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;yU(c[d+8>>2]|0,b,a);i=e;return}function BU(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+16|0;g=f;xU(a,b);h=g;c[g>>2]=e;AU(d,0,a);if((b|0)>1){j=1}else{i=f;return}do{d=c[h>>2]|0;e=c[d>>2]|0;c[h>>2]=d+4;AU(e,j,a);j=j+1|0;}while((j|0)<(b|0));i=f;return}function CU(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=GS(a,b,f)|0;f=zU(c[a+8>>2]|0,d)|0;i=e;return f|0}function DU(a,b){a=+a;b=b|0;var c=0,d=0,e=0,f=0.0,g=0.0,h=0,j=0.0,k=0.0;c=i;d=(b|0)<0;e=d?0-b|0:b;if((e|0)==0){f=1.0}else{b=e;g=a;a=1.0;while(1){if((b&1|0)==0){h=b;j=a}else{h=b+ -1|0;j=a*g}if((h+1|0)>>>0<3){f=j;break}else{b=(h|0)/2|0;g=g*g;a=j}}}if(!d){k=f;i=c;return+k}k=1.0/f;i=c;return+k}function EU(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==2){c[j>>2]=c[b+8>>2];n=j+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];SS(17,0,o,120720,j);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];j=g+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];SS(17,0,o,120816,g);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];g=l+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];SS(17,0,o,120616,l);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];l=m+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];SS(17,0,o,120568,m);i=e;return}else{m=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=m;m=f+8|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];SS(17,0,o,120880,f);i=e;return}}function FU(a){a=a|0;var b=0;b=i;Ola(c[a+12>>2]|0);Ola(c[a+4>>2]|0);Ola(c[a+8>>2]|0);i=b;return}function GU(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;HU(a,e);i=d;return}function HU(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[t>>2]|0;Jc(e|0,a|0,b|0)|0;zd(e|0)|0;i=d;return}function IU(a){a=a|0;var b=0,d=0;b=i;d=c[r>>2]|0;Pd(a|0,d|0)|0;zd(d|0)|0;le[c[41342]&511](0);i=b;return}function JU(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[r>>2]|0;Jc(e|0,a|0,b|0)|0;zd(e|0)|0;le[c[41342]&511](0);i=d;return}function KU(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;JU(a,e);i=d;return}function LU(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[15713]=.5;h[15699]=1.0;h[15736]=.25;h[15711]=2.0;h[15738]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[31434]=A;B=c[d>>2]|0;c[31364]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[31364]=D;if((C|0)<(B|0)){C=D}else{break}}}c[31362]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[15714]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[15714]=F;G=F}else{G=E}D=c[d>>2]|0;c[31364]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[31364]=I;if((H|0)>=(D|0)){break a}E=+h[15714];H=I}}}while(0);D=C+1|0;c[31362]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[15718]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[15683]=0.0;h[15685]=0.0;h[15689]=0.0;h[15746]=0.0;c[31360]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[15683]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[15685]+ +h[B>>3]*F;h[15685]=E;F=+h[I>>3];M=+h[15689]+F*F;h[15689]=M;F=+h[H>>3];h[15746]=+h[15746]+F*F;H=A+1|0;c[31360]=H;F=+h[15683];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[31430]=A;E=G/J;h[15735]=E;C=c[d>>2]|0;c[31364]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[15743]=0.0;h[15745]=0.0;I=c[b>>2]|0;c[31360]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[15712]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[15743]=ba;ca=E+aa*aa;h[15745]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[31360]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[31430]=A;h[15735]=E;h[15685]=Z;h[15689]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[31364]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[31360]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[31360]=A+1;da=+h[15685];ea=+h[15689];ga=+h[15683]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[15734]=K;c[31458]=0;h[15742]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[31458]=C;K=+h[15699]/+V(+ga);h[15714]=K;h[15737]=0.0;h[15739]=0.0;B=c[b>>2]|0;c[31360]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[15737]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[15737]=oa;pa=+h[15739]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[15739]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[15685];L=+h[15683];N=+h[15714];D=D+1|0;la=ma}c[31360]=B+1;ia=+h[15683];ja=pa;ka=oa}N=+h[15713];L=ka*N*ka;h[15730]=L;J=ja*N*ja;h[15731]=J;h[15690]=J+(L+ia*(+h[15746]+ia*N));N=+h[15711];h[125528>>3]=N*ka*ia;h[125536>>3]=N*ja*ia;h[125544>>3]=L-J;h[125552>>3]=ka*ja;la=125560|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[31360]=10;la=c[d>>2]|0;c[31364]=1;if((la|0)>=1){D=1;while(1){h[15730]=0.0;h[15731]=0.0;h[15732]=0.0;A=c[b>>2]|0;c[31360]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[15730]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[15731]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[15732]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[31360]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[15736]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[15730]*+h[15732];h[t+(U+D<<3)>>3]=+h[15731]*+h[15732];J=+h[15730];L=+h[15731];h[t+(P+D<<3)>>3]=+h[15736]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[15713]*+h[15730]*+h[15731];na=D+1|0;c[31364]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[31360]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[31372]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[31360]=B;if((la|0)<(D|0)){la=B}else{break}}}c[31368]=1;la=1;do{D=c[d>>2]|0;c[31376]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[31376]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[31364]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[31364]=D+1}na=c[31434]|0;c[31362]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[15710]=0.0;ma=c[d>>2]|0;c[31364]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[15710]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[31364]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[15710]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[31364]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[15710];Ca=Ca+1|0}c[31364]=ta+1}Ca=B+1|0;c[31362]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[31364]=1;if((A|0)<1){break}else{Ea=1}while(1){h[15710]=0.0;B=c[b>>2]|0;c[31362]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[15710]=N;Ca=na+1|0;c[31362]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[31364]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[31362]=1;if((A|0)>=1){ta=1;while(1){h[15710]=0.0;c[31360]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[15710]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[31360]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[31362]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[31368]=la;}while((la|0)<6);la=c[l>>2]|0;c[31364]=1;h[15710]=0.0;c[31360]=1;L=+h[15713];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[125600+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[125600+(A+ -1<<3)>>3]+L;h[15710]=L;A=A+1|0;}while((A|0)<6);h[15690]=+h[15690]- +h[15700]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[15730]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[15731]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[15732]=O;h[125528>>3]=+h[125528>>3]-J-N*(O+K);h[125560>>3]=+h[125560>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[15730]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[15731]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[15732]=J;h[125536>>3]=+h[125536>>3]-O-N*(K-J);h[125568>>3]=+h[125568>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[15730]=J;h[125544>>3]=+h[125616>>3]+(+h[125544>>3]-J- +h[125608>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[15730]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[15731]=K;Oa=+h[15713];h[125552>>3]=+h[125552>>3]-J-K*Oa;h[125576>>3]=+h[125576>>3]- +h[125624>>3]+ +h[125632>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[15730]=K;h[125584>>3]=+h[125584>>3]-Oa*K;h[15710]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[31364]=la+1;c[31360]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[125600+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[125600+(ta+ -1<<3)>>3]+N;h[15710]=N;ta=ta+1|0;c[31360]=ta;}while((ta|0)<6);K=+h[15718];h[15720]=K*+h[15690]+ +h[15700]+N;J=+h[15711];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[15730]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[15731]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[15732]=R;T=R+(K*+h[125528>>3]+O+S);h[125768>>3]=T;O=K*+h[125560>>3]+S-R;h[125800>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[15730]=R;S=+h[I>>3]*+h[ma>>3];h[15731]=S;Z=+h[Ma>>3]*+h[Na>>3];h[15732]=Z;h[125776>>3]=K*+h[125536>>3]+R+S-Z;h[125808>>3]=K*+h[125568>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[15730]=Z;R=+h[125608>>3]+(Z+K*+h[125544>>3])- +h[125616>>3];h[125784>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[15730]=Z;h[125792>>3]=Z+K*+h[125552>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[125576>>3]+ +h[125624>>3]- +h[125632>>3];h[125816>>3]=J;h[125824>>3]=+h[15718]*+h[125584>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[15720]+T+R+O+J;h[15710]=K;h[15740]=K;h[15741]=K;c[31466]=0;J=+h[15738]/50.0;h[15714]=J;h[15700]=+h[15699];c[31360]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[125608>>3]=Z;W=+Y(+Pa);h[125616>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[125600+(Ma+ -1<<3)>>3]=Z;Q=+h[125608>>3]*G+ +h[125616>>3]*W;h[125600+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[125616>>3];ca=+h[125608>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[125760+(Ma<<3)>>3]*+h[125600+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[15741]=Ra;c[31466]=Na;h[15730]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[15731]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[31362]=10;h[15710]=Ra;h[15719]=Pa;h[15744]=O;c[31360]=50;if((Xa|0)==49){h[15731]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[15730]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[15716]=0.0;if(Ya!=Za){S=Ya-Ua;h[15730]=S;T=Za-Ua;h[15731]=T;R=+h[15713]*(S-T)/(S+T);h[15716]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[15719]=R;T=+X(+R);h[125608>>3]=T;S=+Y(+R);h[125616>>3]=S;c[31362]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[125600+(Na+ -1<<3)>>3]=T;W=+h[125608>>3]*G+ +h[125616>>3]*S;h[125600+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[125616>>3];N=+h[125608>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[15741]=0.0;c[31362]=1;Na=1;do{ma=Na+ -1|0;Ma=125600+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[125520+(ma<<3)>>3]*+h[Ma>>3];h[15741]=+h[15741]+ +h[125760+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[31362]=10;Na=c[l>>2]|0;c[31364]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[125600+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[31362]=6;c[31364]=Na+1}h[15709]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[15683]=0.0;h[15730]=0.0;h[15731]=0.0;Ma=c[b>>2]|0;c[31360]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[125608>>3]*+h[la>>3]+ +h[125616>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[15683]=+h[15683]+G*G;bb=+h[15730]+ +h[la>>3]*+h[ta>>3];h[15730]=bb;G=+h[ta>>3];cb=+h[15731]+G*G;h[15731]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[31360]=Ma+1;$a=cb;ab=bb}ma=c[31458]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[15742];S=+h[15740];h[15742]=G>=S?G:S}S=+h[15741];if(!(S>=0.0)){db=-S}else{db=S}G=+h[15742];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[15742]=S;c[31360]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[15714]=N;R=+h[15709]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[15718];la=ta+1|0;c[31360]=la;if((ta|0)>=(Na|0)){break b}S=+h[15731];G=+h[15730];ta=la}}}while(0);Na=c[d>>2]|0;c[31364]=1;if((Na|0)>=1){Ma=1;while(1){h[15710]=0.0;ta=c[b>>2]|0;c[31362]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[15710]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[31362]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[15709]*+h[p+(la+ -1+Ma<<3)>>3]- +h[15718]*+h[q+(Ma+ -1<<3)>>3]);h[15714]=G;c[31360]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[15714];I=I+1|0}c[31360]=la+1}I=Ma+1|0;c[31364]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[15689]=0.0;h[15685]=0.0;Ma=c[b>>2]|0;c[31360]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[15689]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[15685]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[31360]=Ma+1;hb=kb;ib=jb}S=+h[15683];G=S*ib-hb*hb;h[15734]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[125496]=1;C=c[l>>2]|0;c[31364]=1;if((C|0)<1){lb=125592;mb=+h[15699];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[125600+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[31362]=6;c[31364]=C+1;lb=125592;mb=+h[15699];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function MU(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[15766]=.5;h[15762]=1.0;h[15778]=6.283185307179586;z=+h[n>>3];h[15775]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[31538]=A;c[31546]=0;B=c[d>>2]|0;c[31498]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[31498]=B+1}c[31496]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[15767]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[15767]=F;G=F}else{G=z}H=c[d>>2]|0;c[31498]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[15767];I=I+1|0}c[31498]=H+1}I=B+1|0;c[31496]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[15750]=0.0;D=c[b>>2]|0;c[31494]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[15750]=+h[15750]+G*G;A=p+1|0;c[31494]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[31498]=1;if((p|0)>=1){D=1;while(1){h[15767]=0.0;h[15765]=0.0;y=c[b>>2]|0;c[31496]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[15767]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[15765]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[31496]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[15767]=G;h[15765]=+h[g>>3]*L;g=c[b>>2]|0;c[31494]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[15765]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[15767];H=H+1|0}c[31494]=g+1}H=D+1|0;c[31498]=H;if((D|0)<(p|0)){D=H}else{break}}}h[15751]=0.0;h[15753]=0.0;h[15760]=0.0;D=c[b>>2]|0;c[31494]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[15751]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[15753]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[15760]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[31494]=D+1;O=R;P=T;Q=S}S=+h[15750];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[15771]=U;h[15767]=0.0;if(Q*Q>S*.99*O){h[15767]=+h[15762]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[15766]*U*Z);h[15763]=P;if(O*+h[15775]<P*P*.01){h[15767]=+h[15762]}n=c[b>>2]|0;c[31494]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[15771]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[15767]*U;if((D|0)>=(n|0)){break}e=D;P=+h[15771];D=D+1|0;p=e}c[31494]=n+1;_=0}while(1){n=_+1|0;c[31546]=n;h[15750]=0.0;h[15753]=0.0;h[15754]=0.0;p=c[b>>2]|0;c[31494]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[15750]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[15753]=da;Z=+h[H>>3];ea=P+Z*Z;h[15754]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[31494]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[15767]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[15772]=U;D=c[b>>2]|0;c[31494]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[15772];U=+h[15753];O=+h[15750];g=g+1|0;H=e}c[31494]=D+1}H=c[d>>2]|0;c[31498]=1;if((H|0)>=1){g=1;while(1){h[15765]=0.0;p=c[b>>2]|0;c[31496]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[15765]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[31496]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[15765]=O;e=c[b>>2]|0;c[31494]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[15765];l=l+1|0}c[31494]=e+1}l=g+1|0;c[31498]=l;if((g|0)<(H|0)){g=l}else{break}}}h[15755]=0.0;h[15756]=0.0;h[15757]=0.0;h[15758]=0.0;h[15759]=0.0;g=c[b>>2]|0;c[31494]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[15755]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[15756]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[15757]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[15758]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[15759]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[31494]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[15766];O=U*na;h[15755]=O;P=U*ma-O;h[15758]=P;Z=O+la+P;h[15779]=Z;h[15781]=Z;h[15780]=Z;c[31548]=0;a[126016]=1;W=+h[15778]/50.0;h[15767]=W;c[31494]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[15781]=wa;c[31548]=p;h[15776]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[15777]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[15770]=ta;h[15761]=ua;h[15764]=va;h[15763]=wa;c[31494]=50;h[15780]=wa;if((za|0)==49){h[15777]=Z;Ba=Z}else if((za|0)==0){h[15776]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[15777]}h[15768]=0.0;S=+h[15776];if(S!=Ba){Q=S-Aa;h[15776]=Q;S=Ba-Aa;h[15777]=S;T=U*(Q-S)/(Q+S);h[15768]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[15770]=T;S=+X(+T);h[15761]=S;Q=+Y(+T);h[15764]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[15763]=T;p=c[b>>2]|0;c[31494]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[15761]*+h[y>>3]+ +h[15764]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[15764];Q=+h[15761];H=H+1|0;g=e}c[31494]=p+1;Da=+h[15763]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[15779];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function NU(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[126472]=1;a[126464]=1;c[126484>>2]=6;qaa(126480)|0;e=c[d>>2]|0;c[31614]=1;if((e|0)>=1){d=1;do{H9(126600,b+(d+ -1)|0,1)|0;o=c[31614]|0;d=o+1|0;c[31614]=d;}while((o|0)<(e|0))}_9()|0;e=c[g>>2]|0;if((e|0)==1){c[126508>>2]=a[126464]&1?6:0;qaa(126504)|0;H9(126600,h,4)|0;_9()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[126532>>2]=a[126464]&1?6:0;qaa(126528)|0;H9(126600,h,4)|0;H9(126600,j,4)|0;_9()|0}j=c[k>>2]|0;if((j|0)==1){c[126556>>2]=a[126464]&1?6:0;qaa(126552)|0;H9(126600,l,8)|0;_9()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[126580>>2]=a[126464]&1?6:0;qaa(126576)|0;H9(126600,l,8)|0;H9(126600,m,8)|0;_9()|0}if((c[f>>2]|0)==2){p9(126608,0)|0}else{i=n;return 0}return 0}



function qV(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[141588>>2]=6;qaa(141584)|0;H9(142328,j,4)|0;_9()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[34698]=0;c[35304]=0;c[35292]=0;a[141192]=0;t=c[e>>2]|0;c[34252]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[34698]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[34252]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[34252]=1;if((v|0)>=1){x=1;while(1){h[133480+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[34252]=v+1}c[35296]=2;x=c[e>>2]|0;c[34252]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[34254]=1;if((E|0)<1){F=C}else{G=1;while(1){h[133480+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[34254]=E+1;F=+h[B>>3]}h[133480+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[35296]=G;D=G}G=z+1|0;c[34252]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[34698]|0;y=z+1|0;c[34694]=y;c[34252]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[34254]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[133480+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[34254]=x+1}re[u&63](e,b,136840+(z+ -1<<3)|0)|0;c[35304]=(c[35304]|0)+1;if((c[j>>2]|0)>=1){c[141612>>2]=6;qaa(141608)|0;H9(142328,141216,4)|0;H9(142328,136840+((c[34252]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[34254]=1;if((v|0)>=1){A=1;do{H9(142328,b+(A+ -1<<3)|0,8)|0;B=c[34254]|0;A=B+1|0;c[34254]=A;}while((B|0)<(v|0))}_9()|0}v=c[34252]|0;z=v+1|0;c[34252]=z;}while((v|0)<(y|0))}y=c[35292]|0;b:while(1){c[35292]=y+1;c[35204]=1;c[35200]=1;C=+h[17105];h[17601]=C;h[17603]=C;z=c[34694]|0;c[34252]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[136840+(A+ -1<<3)>>3];do{if(!(C<=K)){c[35204]=A;L=+h[136840+(A+ -1<<3)>>3];h[17601]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[35200]=A;L=+h[136840+(A+ -1<<3)>>3];h[17603]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[34252]=z+1;H=O}A=c[e>>2]|0;c[34252]=1;if((A|0)>=1){v=1;while(1){h[138960+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[34252]=A+1}c[34252]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[34254]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=138960+(Q+ -1<<3)|0;h[B>>3]=+h[133480+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[34254]=x+1;P=v}}while(0);v=P+1|0;c[34252]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[34254]=1;if((z|0)>=1){K=+(c[34698]|0);v=1;while(1){A=138960+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[34254]=z+1}v=c[e>>2]|0;c[34252]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[138960+(B<<3)>>3];h[141240+(B<<3)>>3]=K+(K- +h[133480+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[34252]=v+1}re[u&63](e,141240,141232)|0;A=(c[35304]|0)+1|0;c[35304]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[141636>>2]=6;qaa(141632)|0;H9(142328,141216,4)|0;H9(142328,141232,8)|0;B=c[e>>2]|0;c[34254]=1;if((B|0)>=1){E=1;do{H9(142328,141240+(E+ -1<<3)|0,8)|0;G=c[34254]|0;E=G+1|0;c[34254]=E;}while((G|0)<(B|0))}_9()|0}}while(0);K=+h[17654];c:do{if(!(K>=+h[17603])){z=c[e>>2]|0;c[34252]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[138960+(v<<3)>>3];h[141408+(v<<3)>>3]=I+(+h[141240+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[34252]=z+1}re[u&63](e,141408,141400)|0;A=(c[35304]|0)+1|0;c[35304]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[141660>>2]=6;qaa(141656)|0;H9(142328,141216,4)|0;H9(142328,141400,8)|0;B=c[e>>2]|0;c[34254]=1;if((B|0)>=1){E=1;do{H9(142328,141408+(E+ -1<<3)|0,8)|0;G=c[34254]|0;E=G+1|0;c[34254]=E;}while((G|0)<(B|0))}_9()|0}}while(0);I=+h[17675];if(I>=+h[17603]){R=118;break}v=c[e>>2]|0;c[34252]=1;A=c[35204]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[133480+((z*21|0)+ -22+A<<3)>>3]=+h[141408+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[34252]=v+1}h[136840+(A+ -1<<3)>>3]=I}else{z=c[34694]|0;c[34252]=1;if((z|0)>=1){B=c[35204]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[136840+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[34252]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[17601])){E=c[e>>2]|0;c[34252]=1;z=c[35204]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[133480+((B*21|0)+ -22+z<<3)>>3]=+h[141240+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[34252]=E+1}h[17601]=K;h[136840+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[34252]=1;if((B|0)>=1){A=c[35204]|0;v=1;while(1){x=v+ -1|0;h[141408+(x<<3)>>3]=+h[133480+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[138960+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[34252]=B+1}re[u&63](e,141408,141400)|0;v=(c[35304]|0)+1|0;c[35304]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[141684>>2]=6;qaa(141680)|0;H9(142328,141216,4)|0;H9(142328,141400,8)|0;z=c[e>>2]|0;c[34254]=1;if((z|0)>=1){E=1;do{H9(142328,141408+(E+ -1<<3)|0,8)|0;x=c[34254]|0;E=x+1|0;c[34254]=E;}while((x|0)<(z|0))}_9()|0}}while(0);I=+h[17675];if(!(I>+h[17601])){A=c[e>>2]|0;c[34252]=1;v=c[35204]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[133480+((B*21|0)+ -22+v<<3)>>3]=+h[141408+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[34252]=A+1}h[136840+(v+ -1<<3)>>3]=I;break}B=c[34694]|0;c[34252]=1;if((B|0)<1){break}else{S=1}do{z=c[35200]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[34254]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=133480+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[133480+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[133480+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[34254]=E+1}re[u&63](e,b,136840+(S+ -1<<3)|0)|0;G=(c[35304]|0)+1|0;c[35304]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[141708>>2]=6;qaa(141704)|0;H9(142328,141216,4)|0;H9(142328,136840+((c[34252]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[34254]=1;if((x|0)>=1){G=1;do{H9(142328,b+(G+ -1<<3)|0,8)|0;T=c[34254]|0;G=T+1|0;c[34254]=G;}while((T|0)<(x|0))}_9()|0}}while(0);z=c[34252]|0;S=z+1|0;c[34252]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[34252]=1;v=c[35204]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[133480+((A*21|0)+ -22+v<<3)>>3]=+h[141240+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[34252]=B+1}h[136840+(v+ -1<<3)>>3]=+h[17654]}A=c[35292]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[17604]=0.0;h[17650]=0.0;A=c[34694]|0;c[34252]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[17650]=0.0/K;c[34252]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[136840+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[17650]=I;c[34252]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[136840+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[17604]=$;c[34252]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[17604]=I;do{if(!(I<=+h[k>>3])){if((c[35304]|0)>(c[g>>2]|0)){break}a[141192]=0;c[35292]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[34252]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[34254]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[133480+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[34254]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[34252]=v+1}re[u&63](e,b,f)|0;B=(c[35304]|0)+1|0;c[35304]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[141732>>2]=6;qaa(141728)|0;H9(142328,141216,4)|0;H9(142328,s,8)|0;z=c[e>>2]|0;c[34254]=1;if((z|0)>=1){E=1;do{H9(142328,b+(E+ -1<<3)|0,8)|0;x=c[34254]|0;E=x+1|0;c[34254]=E;}while((x|0)<(z|0))}_9()|0;ba=c[35304]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[141852>>2]=6;qaa(141848)|0;_9()|0;c[141876>>2]=6;qaa(141872)|0;B=c[e>>2]|0;c[34252]=1;if((B|0)>=1){A=1;do{H9(142328,b+(A+ -1<<3)|0,8)|0;v=c[34252]|0;A=v+1|0;c[34252]=A;}while((v|0)<(B|0))}_9()|0;c[141900>>2]=6;qaa(141896)|0;H9(142328,s,8)|0;_9()|0}if(a[141192]&1){I=+h[17650];K=+h[17696]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[141192]=1;da=+h[17650]}h[17696]=da;c[35292]=0;y=0}if((c[j>>2]|0)>=0){c[141924>>2]=6;qaa(141920)|0;H9(142328,141216,4)|0;_9()|0;c[141948>>2]=6;qaa(141944)|0;y=c[e>>2]|0;c[34252]=1;if((y|0)>=1){B=1;do{H9(142328,b+(B+ -1<<3)|0,8)|0;A=c[34252]|0;B=A+1|0;c[34252]=B;}while((A|0)<(y|0))}_9()|0;c[141972>>2]=6;qaa(141968)|0;H9(142328,s,8)|0;_9()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[141996>>2]=6;qaa(141992)|0;_9()|0}h[17603]=+h[f>>3];c[35306]=0;y=c[34694]|0;c[34252]=1;if((y|0)>=1){B=1;while(1){A=136840+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[34252]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[34254]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=133480+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[141408+(E+ -1<<3)>>3]=+h[133480+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[34254]=v+1}re[u&63](e,141408,A)|0;c[35306]=(c[35306]|0)+1;c[35304]=(c[35304]|0)+1;E=c[34252]|0;I=+h[136840+(E+ -1<<3)>>3];if(I>=+h[17603]){B=E;continue}h[17603]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[142020>>2]=6;qaa(142016)|0;H9(142328,141216,4)|0;H9(142328,140824,8)|0;E=c[e>>2]|0;c[34254]=1;if((E|0)>=1){z=1;do{H9(142328,141408+(z+ -1<<3)|0,8)|0;G=c[34254]|0;z=G+1|0;c[34254]=z;}while((G|0)<(E|0))}_9()|0;B=c[34252]|0}}B=c[34698]|0;c[34252]=1;do{if((B|0)<1){h[17130]=+h[17105];c[34252]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[34262]=E;z=c[e>>2]|0;c[34254]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[141240+(A+ -1<<3)>>3]=(+h[133480+(v+ -21<<3)>>3]+ +h[133480+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[34254]=z+1}re[u&63](e,141240,138800+(y+ -1<<3)|0)|0;c[35306]=(c[35306]|0)+1;c[35304]=(c[35304]|0)+1;A=c[34252]|0;y=A+1|0;c[34252]=y;}while((A|0)<(B|0));y=c[34698]|0;I=+h[17105];h[17130]=I;c[34252]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[34262]=A;c[34264]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[34254]=1;E=1;while(1){v=E+1|0;c[34266]=v;G=c[e>>2]|0;c[34256]=1;if((G|0)>=1){x=c[34264]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[141408+(T+ -1<<3)>>3]=(+h[133480+(U+x<<3)>>3]+ +h[133480+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[34256]=G+1}re[u&63](e,141408,141400)|0;c[35306]=(c[35306]|0)+1;c[35304]=(c[35304]|0)+1;T=c[34252]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[34254]|0;la=U+x|0;c[34258]=la;I=+h[17130];h[139120+(la+ -1<<3)>>3]=(+h[17675]+I- +h[138800+(v<<3)>>3]- +h[138800+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[34254]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[34252]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[34698]|0;c[34258]=0;c[34252]=1;E=(y|0)<1;if(E){c[34252]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=Jma(A|0,0,y+ -2|0,0)|0;A=Bma(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[139120+(U+ -1<<3)>>3]=(+h[136840+(v<<3)>>3]+ka- +h[138800+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[34262]=v+1;c[34258]=(z|1)+A;c[34252]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=138800+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[136840+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[34262]=T+1;c[34252]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[34258]=0;c[34252]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[34252]=1;if((B|0)>=1){A=1;while(1){h[140840+(A+ -1<<3)>>3]=+h[133480+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[34252]=B+1}c[34252]=1;do{if(ma){c[34252]=1}else{A=1;while(1){z=A+1|0;c[34262]=z;v=c[e>>2]|0;c[34254]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=133480+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[133480+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[34254]=v+1}c[34252]=z;if((A|0)<(na|0)){A=z}else{break}}c[34252]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[34262]=A;y=c[e>>2]|0;c[34254]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[133480+(T+oa<<3)>>3]=+h[133480+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[34254]=y+1}c[34252]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=139120;rV(B,138792,B,141e3,141576,q,141160)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[142044>>2]=6;qaa(142040)|0;_9()|0}c[q>>2]=2;if((c[35304]|0)>(c[g>>2]|0)){R=312;break}c[142068>>2]=6;qaa(142064)|0;_9()|0;B=c[e>>2]|0;c[34252]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[34252]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[141756>>2]=6;qaa(141752)|0;H9(142328,g,4)|0;_9()|0;c[141780>>2]=6;qaa(141776)|0;H9(142328,140832,8)|0;_9()|0;c[141804>>2]=6;qaa(141800)|0;u=c[e>>2]|0;c[34252]=1;if((u|0)>=1){E=1;do{H9(142328,b+(E+ -1<<3)|0,8)|0;z=c[34252]|0;E=z+1|0;c[34252]=E;}while((z|0)<(u|0))}_9()|0;c[141828>>2]=6;qaa(141824)|0;H9(142328,s,8)|0;_9()|0;i=r;return 0}else if((R|0)==226){u=c[34698]|0;c[35302]=u-(c[35394]|0);c[34252]=1;E=(u|0)<1;do{if(E){h[17647]=0.0;c[34252]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[136840+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=136840+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[139120+(sa+ -1<<3)>>3]*+h[138800+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[34258]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[34254]=z;h[17647]=0.0;c[34252]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[136840+(v<<3)>>3]*+h[138800+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[17647]=wa;c[34252]=u+1;qa=wa}}while(0);h[17647]=+h[17130]-qa;s=c[e>>2]|0;c[34252]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[141408+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=141408+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[136840+(T+ -1<<3)>>3]*+h[133480+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[34252]=s+1;c[34254]=xa}v=c[e>>2]|0;c[34252]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=140840+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[141408+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[34252]=v+1}if((c[j>>2]|0)>=0){c[142092>>2]=6;qaa(142088)|0;H9(142328,141176,8)|0;z=c[e>>2]|0;c[34252]=1;if((z|0)>=1){s=1;do{H9(142328,140840+(s+ -1<<3)|0,8)|0;u=c[34252]|0;s=u+1|0;c[34252]=s;}while((u|0)<(z|0))}_9()|0;c[142116>>2]=6;qaa(142112)|0;_9()|0}z=c[e>>2]|0;c[34252]=1;if((z|0)>=1){s=c[34698]|0;v=1;while(1){c[34254]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[136840+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=136840+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[139120+(Aa+ -1<<3)>>3]*+h[133480+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[34258]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[34256]=E;c[34254]=s+1}T=c[e>>2]|0;c[34254]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=137096+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[136840+(Ea+ -1<<3)>>3]*+h[133480+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[34254]=T+1;c[34258]=Ca;c[34256]=Da}za=v+1|0;c[34252]=za;if((v|0)<(z|0)){v=za}else{break}}}c[34254]=0;v=c[e>>2]|0;c[34252]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[137096+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[34254]=Ga;c[34252]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[142140>>2]=6;qaa(142136)|0;H9(142328,141208,4)|0;_9()|0;c[34696]=1;z=1;d:while(1){c[34258]=z;do{if((z|0)>(c[e>>2]|0)){s=c[34696]|0;if((s|0)==1){c[142164>>2]=6;qaa(142160)|0;_9()|0;rV(137096,138792,139120,141e3,141576,q,141160)|0;c[142188>>2]=6;qaa(142184)|0;_9()|0;c[34696]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[34696]=2;c[34268]=0;c[34270]=0;s=c[e>>2]|0;c[34252]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=Jma(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=Bma(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=137096+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=137096+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[137096+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[34272]=Na;c[34270]=Ta;c[34268]=Ia;c[34254]=Ma;c[34252]=s+1}c[142212>>2]=6;qaa(142208)|0;_9()|0;c[34268]=0;u=c[e>>2]|0;c[34252]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=137096+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[34268]=Wa;c[34252]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[34268]=T;s=c[e>>2]|0;c[34252]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[34262]=B;Qa=za+la|0;c[34268]=Qa;Pa=B+5|0;c[34264]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[34696]|0)==3){c[142284>>2]=6;qaa(142280)|0;Pa=c[34264]|0;Qa=c[34262]|0;c[34254]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{H9(142328,139120+(B+ -1<<3)|0,8)|0;Qa=c[34254]|0;B=Qa+1|0;c[34254]=B;}while((Qa|0)<(Pa|0))}_9()|0}else{c[142260>>2]=6;qaa(142256)|0;Pa=c[34264]|0;B=c[34262]|0;c[34254]=B;if((B|0)<=(Pa|0)){x=B;do{H9(142328,137096+(x+ -1<<3)|0,8)|0;B=c[34254]|0;x=B+1|0;c[34254]=x;}while((B|0)<(Pa|0))}_9()|0}Pa=c[34252]|0;x=Pa+1|0;c[34252]=x;if((Pa|0)>=(s|0)){break e}E=c[34258]|0;la=c[34268]|0;za=x}}}while(0);c[142308>>2]=6;qaa(142304)|0;_9()|0;z=(c[34258]|0)+6|0}c[142236>>2]=6;qaa(142232)|0;H9(142328,141224,4)|0;_9()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);re[p&63](e,b,f)|0;i=r;return 0}function rV(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[35602]=c[b>>2];c[g>>2]=1;if((c[35602]|0)<1){i=k;return 0}c[g>>2]=0;sV(a,142408,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[35602]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[35594]=f;c[35600]=g;c[35606]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=Jma(a|0,0,g+ -2|0,0)|0;m=Bma(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[35586]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=Jma(p|0,0,a-n|0,0)|0;p=Bma(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[35586]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[35584]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[35584]=j}c[35596]=g;c[35598]=f;c[35604]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[17796]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[17796]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[17796]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[35604]=D;E=v+ -1|0;c[35596]=E;F=w+ -1|0;c[35598]=F;q=D;v=E;w=F}c[35588]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[35590]=t;c[35600]=0;c[35606]=l-g;i=k;return 0}function sV(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[17810]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[17810]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[17810];c[35610]=1;c[35612]=0;n=c[b>>2]|0;c[35624]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[35614]=0;c[35626]=1;do{if((o|0)>=1){p=1;q=c[35612]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[17809]=m;u=(p|0)==(o|0);if(u){l=m*+h[17810];h[17811]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[17809]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[17811]=+h[17811]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[35614]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[35614]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[17809];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[35626]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[35608]=y;c[35616]=x;c[35612]=s;break}else if((D|0)==26){D=0;c[35608]=y;c[35616]=x;c[35612]=s;break}}}while(0);m=+V(+(+h[17811]));h[17811]=m;H=+h[17809];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[35612]|0)+ -1<<3)>>3]=G;G=+h[17811]/+h[17809];h[j+((c[35608]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[35612]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[35610]|0;O=c[35624]|0}}while(0);b=N+O|0;c[35610]=b;o=O+1|0;c[35624]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[35608]=y;c[35616]=x;c[35612]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function tV(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[35650]=n;o=(c[d>>2]|0)-n|0;c[35672]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[35670]=s;a[142624]=1;t=c[b>>2]|0;u=t+1|0;c[35666]=u;v=c[b>>2]|0;w=u+v|0;c[35664]=w;u=w+(c[b>>2]|0)|0;c[35668]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[35658]=w;x=w+(c[d>>2]|0)|0;c[35652]=x;y=x+(c[b>>2]|0)|0;c[35654]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[35660]=z;A=z+(c[d>>2]|0)|0;c[35674]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[35676]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[35648]=C;D=C+(c[b>>2]|0)|0;c[35662]=D;uV(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,142680,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);qaa(142712)|0;_9()|0;i=m;return 0}function uV(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[17924]=.5;h[17915]=1.0;h[17955]=.1;F=(c[a>>2]|0)+1|0;c[35826]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[35818]=H;I=(c[b>>2]|0)-F|0;c[35872]=I;F=c[j>>2]|0;c[35926]=(F|0)<1?1:F;F=c[a>>2]|0;c[35810]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[35812]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[35812]=J+1}L=c[u>>2]|0;c[35808]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[35808]=L+1}K=j+1|0;c[35810]=K;if((j|0)<(F|0)){j=K}else{break}}}c[35814]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[35814]=H+1}H=c[b>>2]|0;c[35812]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[35810]=M;c[35812]=H+1}N=+h[e>>3];O=N*N;h[17960]=O;h[17946]=+h[17915]/O;h[17947]=+V(+(+h[17924]))/O;c[35816]=0;H=y;y=A;M=0;a:while(1){c[35828]=M;F=M-(c[a>>2]|0)|0;c[35852]=F;j=M+1|0;c[35816]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[35902]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[35840]=L;K=L+G|0;c[35838]=K;if((K|0)>(c[a>>2]|0)){c[35902]=L;G=K-(c[a>>2]|0)|0;c[35840]=G;c[35838]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[17937]=O;L=c[35826]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[17937]=N;R=N}else{R=O}O=+h[e>>3];h[17938]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[17938]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[17938];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[35810]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[35810]=S+1}if((M|0)>=(c[35926]|0)){T=j;U=159;break}while(1){re[H&63](a,d,143224)|0;if((c[g>>2]|0)==3){qaa(143752)|0;H9(143920,143264,4)|0;H9(143920,143224,8)|0;I=c[a>>2]|0;c[35808]=1;if((I|0)>=1){F=1;do{H9(143920,d+(F+ -1<<3)|0,8)|0;L=c[35808]|0;F=L+1|0;c[35808]=F;}while((L|0)<(I|0))}_9()|0}I=c[35816]|0;do{if((I|0)>(c[b>>2]|0)){F=c[35856]|0;if((F|0)==-1){break a}h[17956]=0.0;c[35814]=0;L=c[a>>2]|0;c[35810]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[17956]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[17929]=N;if((X|0)==(G|0)){ea=N*+h[17924];h[17929]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[17956]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[35814]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[35808]=Y;c[35810]=L+1;W=Z}J=c[b>>2]|0;c[35812]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[17956]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[35812]=J+1;ia=ja}O=+h[17903];ba=+h[17932];N=O-ba-ia;h[17923]=N;h[17942]=+h[17941];h[17941]=+h[17940];if(!(N>=0.0)){ka=-N}else{ka=N}h[17940]=ka;if(+h[17952]>+h[17918]){c[35900]=I}h[17948]=ba;do{if(O<ba){h[17932]=O;h[17965]=0.0;G=c[a>>2]|0;c[35808]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[17965]=+h[17965]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[35808]=G+1;h[A>>3]=ma}}while(0);c[35898]=F;if((F|0)<=0){O=+h[17956];if(O>=0.0){U=190;break a}ba=+h[17903];N=+h[17948];ea=(ba-N)/O;h[17953]=ea;O=+h[17955];do{if(!(ea<=O)){na=+h[17924]*+h[17945];h[A>>3]=na;oa=+h[17952];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[17945]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[17945]=qa;ra=qa;break}}else{qa=+h[17924]*+h[17952];h[17945]=qa;ra=qa}}while(0);ea=+h[17918];if(!(ra<=ea*1.5)){sa=ra}else{h[17945]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[17960]=ea;c[35914]=0;h[17961]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[35870]|0;c[35914]=J;oa=+h[17915];h[17961]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[35812]=1;if((J|0)<1){va=F}else{L=c[35872]|0;oa=ua;K=1;ca=F;while(1){h[17943]=0.0;c[35810]=1;if((L|0)<1){wa=0.0}else{X=c[35832]|0;aa=K+C|0;qa=+h[17915];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[17929]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[17943]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[35810]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[17925]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[17929]=za;h[17964]=0.0;$=c[a>>2]|0;c[35810]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[17964]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[35810]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[17929]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[17961]=Fa;c[35856]=K;Ga=Fa;Ha=K}aa=K+1|0;c[35812]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}AV(a,b,s,t,143328,u,w,143400,143424,x)|0;ca=c[35856]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[17903];c[35814]=0;J=c[a>>2]|0;c[35808]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[17929]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[17929];G=G+1|0;da=da+1|0}da=X+aa|0;c[35814]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[35810]=La;c[35808]=J+1}h[L>>3]=0.0;X=c[35872]|0;c[35810]=1;aa=(X|0)<1;if(!aa){F=c[35832]|0;K=1;while(1){da=fa(K,B)|0;O=+h[17923]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[17929]=Oa;G=c[b>>2]|0;c[35812]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[17929];$=$+1|0}c[35812]=G+1}$=K+1|0;c[35810]=$;if((K|0)<(X|0)){K=$}else{break}}}h[17934]=0.0;K=c[a>>2]|0;c[35808]=1;if((K|0)>=1){F=1;while(1){O=+h[17923]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[17934]=+h[17934]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[35808]=K+1;h[A>>3]=Pa}F=c[35898]|0;do{if((F|0)==0){if(!(+h[17945]==+h[17918])){break}O=+h[17953];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[35918]=0;break}L=c[b>>2]|0;c[35812]=1;if((L|0)>=1){J=o+((c[35870]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[35812]=L+1}h[17927]=0.0;$=c[a>>2]|0;c[35808]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[17921]=0.0;G=c[b>>2]|0;c[35812]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[17921]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[35812]=G+1;Sa=Ta}h[17927]=+h[17927]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[35808]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[17927]*100.0}J=c[35918]|0;c[35918]=J+1;if(+h[17934]<Ra){c[35918]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[35808]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[35808]=J+1}$=c[35818]|0;c[35814]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[35814]=$+1}c[35810]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[35812]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[35812]=Na+1;Ua=Wa}if((L|0)<(c[35832]|0)){h[J>>3]=-Ua}Va=L+1|0;c[35810]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[35812]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[35810]=Xa;c[35812]=L+1}c[35918]=0}}while(0);O=+h[17903];ea=+h[17948];if(O<ea){c[35870]=ca}oa=+h[17955];if(O<=ea+oa*+h[17956]|(F|0)>0){U=54;break}c[35856]=0;Ia=0;Ja=+h[17945];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[17903];oa=+h[17903];do{if((I|0)==1){h[17922]=oa;h[17932]=oa;c[35870]=1;Ya=1}else{if(!(oa<+h[17932])){Ya=I;break}h[17932]=oa;c[35870]=I;Ya=I}}while(0);F=c[35828]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[35838]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[35840]|0;Va=K+aa|0;c[35814]=Va;if(+h[17937]<0.0){aa=X+(c[a>>2]|0)|0;c[35838]=aa;Za=aa}else{Za=X}if(+h[17938]<0.0){X=K+(c[a>>2]|0)|0;c[35840]=X;_a=X}else{_a=K}K=fa(c[35852]|0,B)|0;h[t+(K-B<<3)>>3]=+h[17946];h[t+(Ya+C+K<<3)>>3]=+h[17946];h[t+(Za-B+K<<3)>>3]=-+h[17946];h[t+(_a-B+K<<3)>>3]=-+h[17946];h[q+(Va+ -1<<3)>>3]=(+h[17922]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[17903])/(+h[17937]*+h[17938])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[35852]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[17924]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[17924]/+h[e>>3];ea=+h[17947];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[17947];h[t+(X+K<<3)>>3]=+h[17947];K=(fa(Va+1|0,Va)|0)/2|0;c[35814]=K;ea=(+h[17922]- +h[17903])/+h[e>>3];h[17929]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[17924]*(+h[X>>3]+ +h[17929]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[17922])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[17915]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[17915]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[17924]*+h[17960]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[17918]=oa;h[17945]=oa;c[35832]=1;h[17940]=0.0;h[17941]=0.0;c[35918]=0;h[17965]=0.0;F=c[a>>2]|0;c[35808]=1;if((F|0)<1){U=53;break}ca=c[35870]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[17965]=+h[17965]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[35808]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[35900]=c[35816];U=54;continue}else if((U|0)==54){U=0;c[35856]=0;I=(c[35826]|0)+ -1|0;K=c[a>>2]|0;zV(a,b,l,n,p,q,r,143560,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,143696)|0;h[17917]=0.0;K=c[a>>2]|0;c[35808]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[17917]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[35808]=K+1;ab=cb}oa=+h[17945];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[17952]=O;ea=+h[17918];if(!(O<+h[17924]*ea)){db=ab;U=62;break}c[35856]=-1;O=+h[17955];N=O*oa;h[17945]=N;h[17953]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[17945]=ea;eb=ea}if((c[35816]|0)<=((c[35900]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[17962]*.125*ea;h[17929]=N;oa=+h[17940];ba=+h[17941];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[17942];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[17964]=O;I=c[b>>2]|0;c[35812]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[17921]=0.0;X=c[a>>2]|0;c[35810]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[17921]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[35810]=X+1;jb=lb}if(jb>ea){c[35856]=F;h[17964]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[35812]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[17953]>0.0){U=54;continue}ea=+h[17952];O=+h[17918];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[17924];h[17945]=O;ea=hb/+h[f>>3];h[17953]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[17918]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[17918]=na;ob=na;break}}else{na=+h[f>>3];h[17918]=na;ob=na}}while(0);h[17945]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){qaa(143800)|0;_9()|0}qaa(143824)|0;H9(143920,143344,8)|0;H9(143920,143264,4)|0;_9()|0;qaa(143848)|0;H9(143920,143456,8)|0;ca=c[a>>2]|0;c[35808]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];H9(143920,y,8)|0;I=c[35808]|0;F=I+1|0;c[35808]=F;}while((I|0)<(ca|0))}_9()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[17924]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[17918];O=na>=ea?na:ea;h[17954]=O;ea=O*O;h[17917]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[17965];if(db<=ea*.001){h[17958]=ea*.25;ca=c[b>>2]|0;c[35812]=1;if((ca|0)>=1){F=1;while(1){h[17921]=0.0;I=c[a>>2]|0;c[35808]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[17921]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[35808]=I+1;pb=qb}h[17929]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[17924]*+h[17965];h[17921]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[35808]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[17929]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[17924]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[17921]*+h[n+(F+C+Va<<3)>>3]+ +h[17958]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[35820]=aa;c[35810]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[35810]=Va;rb=Va}c[35808]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[35812]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[35872]|0;c[35812]=1;if((F|0)>=1){ca=1;while(1){h[17939]=0.0;X=c[b>>2]|0;c[35808]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[17939]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[35808]=I;if((K|0)>=(X|0)){break b}O=+h[17939];K=I}}}while(0);X=c[a>>2]|0;c[35810]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[17958]*+h[17939]*+h[l+(I<<3)>>3];h[17921]=O;Va=c[b>>2]|0;c[35808]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[17921]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[35808]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[35832]|0)){h[17921]=-+h[17921]}L=c[b>>2]|0;c[35808]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[17921]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[35808]=L+1}J=K+1|0;c[35810]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[35808]=1;if((K|0)>=1){X=c[35832]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[35820]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[17929]=ub;c[35810]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[17929];aa=aa+1|0}aa=J+1|0;c[35810]=aa;vb=aa}c[35808]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[35812]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[35814]=0;ca=c[a>>2]|0;c[35810]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[35812]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[17924]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[35812]=aa+1}c[35808]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[35814]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[35808]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[35810]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[35810]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[35810]=J+1}h[17965]=0.0}if((c[35856]|0)>0){F=(c[35826]|0)+ -1|0;MU(a,b,l,n,s,t,143328,u,143424,143632,v,143552,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[35812]=1;if((F|0)>=1){L=1;while(1){h[17930]=0.0;h[17931]=0.0;h[17921]=0.0;ca=c[a>>2]|0;c[35810]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[17930]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[17931]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[17921]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[35810]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[17924]+Ab);h[w+(K<<3)>>3]=+h[17921];K=L+1|0;c[35812]=K;if((L|0)<(F|0)){L=K}else{break}}}h[17925]=0.0;L=c[35872]|0;c[35812]=1;if((L|0)>=1){F=1;while(1){h[17921]=0.0;J=c[b>>2]|0;c[35808]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[17921]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[35808]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[17925];if((F|0)<(c[35832]|0)){h[17925]=O+ea;na=-Eb;h[17921]=na;Gb=na}else{h[17925]=O-ea;Gb=Eb}K=c[b>>2]|0;c[35808]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[17921];X=X+1|0}c[35808]=K+1}X=F+1|0;c[35812]=X;if((F|0)<(L|0)){F=X}else{break}}}h[17933]=0.0;h[17912]=0.0;F=c[a>>2]|0;c[35810]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[17921]=0.0;X=c[b>>2]|0;c[35808]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[17921]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[35808]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[17933]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[35822]=K;Va=c[a>>2]|0;c[35812]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[17921]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[35812]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[17933]+ +h[17921]*+h[ca>>3];h[17933]=O;na=+h[17912]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[17912]=na;aa=L+1|0;c[35810]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[17917];h[17925]=+h[17925]+(Ib*Ib+ea*(Ib+(Ib+ +h[17965])+ea*+h[17924]))-Hb;L=w+((c[35870]|0)+ -1<<3)|0;h[L>>3]=+h[17915]+ +h[L>>3];L=c[35856]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[17915]+ +h[17944]*+h[17925]/(ea*ea);h[17929]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;LU(a,b,l,n,s,t,143328,u,143480,143424,v,x,w,143400,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[35808]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[35808]=L+1}F=c[35816]|0;aa=F+1|0;c[35816]=aa;if((F|0)>=(c[35926]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[35816]=T+ -1;if((c[g>>2]|0)<=0){break}qaa(143728)|0;_9()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}qaa(143776)|0;_9()|0}}while(0);Nb=+h[17932];if(Nb<=+h[17903]){U=c[a>>2]|0;c[35808]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[35808]=U+1;Ob=+h[17932]}h[17903]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}qaa(143872)|0;H9(143920,143264,4)|0;_9()|0;qaa(143896)|0;H9(143920,143224,8)|0;g=c[a>>2]|0;c[35808]=1;if((g|0)>=1){a=1;do{H9(143920,d+(a+ -1<<3)|0,8)|0;U=c[35808]|0;a=U+1|0;c[35808]=a;}while((U|0)<(g|0))}_9()|0;i=z;return 0}function vV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){tma(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){tma(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function wV(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+mV(143928);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+nV(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+nV(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+nV(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function xV(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function yV(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+mV(143936);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=Jma(u|0,0,t+ -2|0,0)|0;t=Bma(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function zV(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[18012]=.5;h[18030]=6.283185307179586;v=+h[l>>3];h[18025]=v*v;c[36046]=0;l=c[b>>2]|0;c[36064]=l;c[36062]=l;w=c[b>>2]|0;c[35986]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[35986]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[35986]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[35986]=w+1}z=c[d>>2]|0;c[35990]=1;if((z|0)>=1){e=1;while(1){h[18016]=0.0;A=c[b>>2]|0;c[35988]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[18016]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[35988]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[18016]=v;C=c[b>>2]|0;c[35986]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[18016];F=F+1|0}c[35986]=C+1}F=e+1|0;c[35990]=F;if((e|0)<(z|0)){e=F}else{break}}}c[36e3]=0;e=c[b>>2]|0;c[35988]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[36e3]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[35986]=H;c[35988]=e+1}do{if((y|0)==0){h[18014]=0.0;h[17996]=0.0;w=c[b>>2]|0;c[35986]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[17996]=+h[17996]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[35986]=w+1}h[r>>3]=0.0;D=+h[17996];if(D==0.0){O=55;break a}h[18001]=0.0;h[18004]=0.0;h[17999]=D;h[18019]=D;P=D;Q=0.0;R=0.0;S=+h[18025];T=0}else{if((y|0)>(x|0)){h[17998]=0.0;h[18005]=0.0;h[18006]=0.0;z=c[b>>2]|0;c[35986]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[17998]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[18005]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[18006]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[35986]=z+1;U=ba;W=$;Z=aa}D=+h[18012];v=D*(+h[18009]-Z);h[17997]=v;_=+h[18002];ca=_+v;h[18013]=ca;h[18017]=ca;h[18015]=ca;c[36056]=0;a[144024]=1;da=+h[18030]/50.0;h[18016]=da;c[35986]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[18015]=ka;c[36056]=w;h[18026]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[18027]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[18021]=ha;h[18007]=ia;h[18010]=ja;h[18018]=ka;c[35986]=50;h[18017]=ka;if((la|0)==0){h[18026]=ka;O=46}else if((la|0)==49){h[18027]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[18027]}h[18021]=0.0;ga=+h[18026];if(ga!=na){ea=ga-ma;h[18026]=ea;ga=na-ma;h[18027]=ga;oa=D*(ea-ga)/(ea+ga);h[18021]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[18021]=oa;ga=+X(+oa);h[18007]=ga;ea=+Y(+oa);h[18010]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[18022]=oa;h[17999]=0.0;w=c[b>>2]|0;c[35986]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[18007]*+h[J>>3]+ +h[18010]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[17999]+sa*sa;h[17999]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[18010];ea=+h[18007];F=F+1|0;z=K}c[35986]=w+1;qa=ta;ra=+h[18022]}ea=ra+ +h[18014];h[18014]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[18005]=0.0;z=c[b>>2]|0;c[35988]=1;do{if((z|0)<1){ea=+h[18029];h[18020]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[18005]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[35988]=z+1;ea=+h[18029];h[18020]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[17996];h[18016]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[18016]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[18020];oa=+h[17999];v=+h[18005];_=oa/v;ca=ea<=_?ea:_;h[18020]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[17999];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[18012]*Ca);h[18011]=ca;h[18014]=+h[18014]+ca;h[18024]=Ba;h[17999]=0.0;z=c[b>>2]|0;c[35986]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[18020]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[17999]+oa*oa;h[17999]=Ga;Ha=+h[18020];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[35986]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[18029]){if(+h[18011]<=+h[18014]*.01){O=55;break a}if(Fa<=+h[18019]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[18024];h[18016]=ca;h[17996]=0.0;h[18001]=0.0;h[18004]=0.0;w=c[b>>2]|0;c[35986]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[17996]+ca*ca;h[17996]=La;J=m+(F<<3)|0;Ma=+h[18001]+ +h[K>>3]*+h[J>>3];h[18001]=Ma;ca=+h[J>>3];Na=+h[18004]+ca*ca;h[18004]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[18016];Ja=Ja+1|0;Ka=J}c[35986]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[18025];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[36062]=y;ua=+h[17999];va=y}if(ua<=+h[18019]*1.0e-4){O=55;break a}h[18002]=0.0;h[18009]=0.0;z=c[b>>2]|0;c[35986]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[18002]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[18009]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[35986]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[18008]=ca;oa=+h[18025];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[36046]=J;_=+V(+(v-ca*ca));h[18016]=_;v=oa/_;h[18026]=v;oa=ca/_;h[18027]=oa;w=c[b>>2]|0;c[35986]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[18027];Ta=+h[18026];Ua=Ua+1|0;Va=K}c[35986]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[36046]=e;v=S-R;h[18016]=v;h[18029]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function AV(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[18039]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[36084]=t;c[36074]=1;c[36068]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[36074]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[18041]=D;C=+h[x>>3]/D;h[18048]=C;z=+h[f+(B+y<<3)>>3]/D;h[18049]=z;B=c[d>>2]|0;c[36066]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[18041]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[18041];if((x|0)>=(B|0)){break}D=+h[18049];z=+h[18048];x=x+1|0}c[36066]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[36068]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[18048]=z;if((c[g>>2]|0)>1){D=-z;h[18048]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[18049]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[36066]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[18049]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[18048];t=t+1|0;x=A}c[36066]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[18046]=z;x=k+(w<<3)|0;H=+h[x>>3];h[18040]=H;D=H*H;h[18050]=D;h[18047]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[18039];a[144344]=0;do{if((u|0)==1){z=+h[18047];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[18041]=z;D=+h[18048]/z;h[18049]=D;H=+h[18040]/z;h[18048]=H;x=c[d>>2]|0;c[36066]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[18049];D=+h[18048];w=w+1|0;t=s}c[36066]=x+1;J=+h[18041]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[36070]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[36070]=u;M=u}t=u+1-M|0;c[36072]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[18047];z=+h[f+(t+w<<3)>>3]/D;h[18041]=z;h[18048]=z*+h[l>>3];H=+h[18040];h[18049]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[18041]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[18039]/+V(+(+h[18050]+z*N*z));h[18044]=C;if(!(D>=0.0)){O=-D}else{O=D}h[18045]=C*+V(+O);t=c[d>>2]|0;c[36066]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[18045]*(+h[A>>3]- +h[18048]*+h[n+(G<<3)>>3]- +h[18049]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[18041];z=+h[18040];H=+h[18044];v=v+1|0}c[36066]=t+1;P=+h[18047]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[144344]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[36066]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[18041]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[18041];K=Q+1|0;c[36066]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[36068]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[36076]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[18040];N=+h[18047];J=(+h[18046]*+h[f>>3]-O*P)/N;h[18048]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[18049]=P;c[36066]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[36066]=q;if((f|0)>=(b|0)){break a}N=+h[18049];O=+h[18048];f=q}}}while(0);b=R+1|0;c[36068]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function BV(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function CV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((BV(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(144408,144424,116,144448)}else if((s|0)==14){i=g;return o|0}return 0}function DV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((lma(w,c[144456+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[144560+(x<<2)>>2]|0;c[q>>2]=c[144456+(x<<2)>>2];c[q+4>>2]=y;RS(23,0,144632,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=Pla(D,8)|0;c[e+40>>2]=B;D=b+536|0;US(c[D>>2]|0,(B|0)!=0|0,144672,p);B=Pla(c[A>>2]|0,4)|0;c[e+36>>2]=B;US(c[D>>2]|0,(B|0)!=0|0,144672,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=Pla(c[C>>2]|0,4)|0;c[e+24>>2]=Nla(8)|0;C=Nla(4)|0;c[e+20>>2]=C;c[C>>2]=c[116232>>2];US(c[D>>2]|0,(C|0)!=0|0,144672,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=Nla(C)|0;A=e+44|0;c[A>>2]=Nla(C)|0;C=Pla(15,4)|0;E=e+12|0;c[E>>2]=C;US(c[D>>2]|0,(C|0)!=0|0,144672,m);C=Pla(5,4)|0;c[e+4>>2]=C;US(c[D>>2]|0,(C|0)!=0|0,144672,l);C=Pla(5,4)|0;c[e+8>>2]=C;US(c[D>>2]|0,(C|0)!=0|0,144672,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=Nla(C)|0;c[e+76>>2]=Nla(C)|0;c[e+80>>2]=Nla(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((oe[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){RS(23,0,144688,j)}else{RS(1,0,144760,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[116268>>2]|c[29042]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=144592;W=V;VS(Q,W,r)}c[t>>2]=w;TS(23,1,144488,t);t=1;do{w=c[144560+(t<<2)>>2]|0;c[s>>2]=c[144456+(t<<2)>>2];c[s+4>>2]=w;TS(23,0,144544,s);t=t+1|0;}while((t|0)<8);le[c[29182]&511](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=144592;W=V;VS(Q,W,r);return 0}function EV(a){a=a|0;var b=0;b=i;Ola(c[a+40>>2]|0);Ola(c[a+36>>2]|0);Ola(c[a+20>>2]|0);Ola(c[a+12>>2]|0);Ola(c[a+4>>2]|0);Ola(c[a+8>>2]|0);Ola(a);i=b;return 0}function FV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;US(c[N>>2]|0,(c[M>>2]|0)!=0|0,144856,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){RS(3,0,144888,B);RS(3,0,144928,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];oe[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];RS(3,0,144952,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];RS(23,0,144992,y);if((c[z>>2]|0)==1){gU(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){AX(a)|0;oe[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 7:{OU(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 3:{OU(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 6:{OU(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 5:{OU(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 4:{OU(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){OU(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{OU(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){zd(_|0)|0;zd($|0)|0;TS(3,0,145024,x);RS(3,0,145112,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){zd(_|0)|0;zd($|0)|0;$=OV(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){AX(a)|0;oe[c[(c[ba>>2]|0)+40>>2]&127](a)|0}oe[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];TS(1,0,145136,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[116188>>2]|0)!=0){RS(3,1,145168,u);c[s>>2]=c[z>>2];RS(3,0,145192,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];RS(3,0,145216,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];RS(3,0,145248,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];RS(3,0,145288,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];RS(3,0,145336,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];RS(3,0,145384,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];RS(3,0,145424,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];RS(3,0,145464,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];RS(3,0,145504,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];RS(3,0,145552,f);le[c[29182]&511](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(145592,145624,410,145656)}RS(3,0,145672,e);S=0;i=d;return S|0}function GV(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;AX(g)|0;a=f+540|0;oe[c[(c[a>>2]|0)+40>>2]&127](g)|0;oe[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function HV(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;AX(l)|0;b=k+540|0;oe[c[(c[b>>2]|0)+40>>2]&127](l)|0;oe[c[(c[b>>2]|0)+28>>2]&127](l)|0;QV(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function IV(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];AX(g)|0;l=e+540|0;oe[c[(c[l>>2]|0)+40>>2]&127](g)|0;oe[c[(c[l>>2]|0)+28>>2]&127](g)|0;oe[c[(c[l>>2]|0)+32>>2]&127](g)|0;re[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function JV(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;RV(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function KV(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;AX(l)|0;b=k+540|0;oe[c[(c[b>>2]|0)+40>>2]&127](l)|0;oe[c[(c[b>>2]|0)+28>>2]&127](l)|0;PV(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function LV(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function MV(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;SV(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function NV(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function OV(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-1:{TS(3,0,145024,l);m=1;i=b;return m|0};case-11:{TS(1,0,146080,d);m=-11;i=b;return m|0};case-8:{TS(1,0,145848,g);m=-8;i=b;return m|0};case-7:{TS(1,0,145808,h);m=-7;i=b;return m|0};case-33:{TS(1,0,146216,b);m=-33;i=b;return m|0};case-6:{TS(1,0,145736,j);m=-6;i=b;return m|0};case-9:{TS(1,0,145896,f);m=-9;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-12:{TS(1,0,146168,c);m=-12;i=b;return m|0};case-2:{TS(1,0,145696,k);m=-2;i=b;return m|0};case-10:{TS(1,0,145984,e);m=-10;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function PV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}oe[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function QV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;oe[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function RV(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+yd(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+yd(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;GV(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}



function gp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,15952,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}cm(t,c[ib>>2]|0,jb);jb=+h[t>>3];pm(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);jb=+h[v>>3];cm(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[w>>3];pm(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+32>>3];qb=+yd(1.0e-13,+(+h[w+40>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,16024,18312,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{cm(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);sb=+h[z>>3];pm(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);sb=+h[B>>3];cm(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[C>>3];pm(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+40>>3]- +h[E>>3]));pb=1.0- +h[C+32>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,16024,18312,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{cm(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);vb=+h[F>>3];pm(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);vb=+h[H>>3];cm(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);sb=+h[I>>3];pm(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);sb=+h[K>>3];cm(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[L>>3];pm(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[N>>3])|0)<<24>>24==0){cm(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[O>>3];pm(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Q,c[ib>>2]|0,+h[P+24>>3],+h[P+192>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(R,c[ib>>2]|0,+h[Q+24>>3],+h[Q+192>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(S,c[ib>>2]|0,jb,pb,+h[Q+24>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+192>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+208>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}cm(T,c[ib>>2]|0,+h[xb+24>>3]);qb=+h[T>>3];pm(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);qb=+h[V>>3];cm(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[W>>3];pm(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);pb=+h[Y>>3];cm(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[Z>>3];pm(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm($,c[ib>>2]|0,+h[_+24>>3],+h[_+192>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(aa,c[ib>>2]|0,+h[$+24>>3],+h[$+192>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(ba,c[ib>>2]|0,jb,rb,+h[$+24>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+192>>3],0.0);zb=+h[ba>>3];cm(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);rb=+h[ca>>3];pm(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+40>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+200>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+32>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,16336,18312,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+32>>3];Cb=+h[ca+40>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,16024,18312,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+200>>3]-wb}wb=+h[tb+24>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,15952,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,15952,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}cm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];pm(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Hb=+h[ia>>3];cm(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Fb=+h[ja>>3];pm(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,15952,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,15952,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,15952,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}qb=Kb+-273.15;dm(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];cm(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[na>>3];pm(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);qb=+h[pa>>3];cm(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[qa>>3];pm(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+32>>3];rb=+yd(1.0e-13,+(+h[qa+40>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,16024,18312,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{cm(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Lb=+h[ta>>3];pm(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Lb=+h[va>>3];cm(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[wa>>3];pm(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+40>>3]- +h[ya>>3]));Eb=1.0- +h[wa+32>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,16024,18312,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{cm(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Ob=+h[za>>3];pm(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Ob=+h[Ba>>3];cm(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Lb=+h[Ca>>3];pm(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Lb=+h[Ea>>3];cm(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Fa>>3];pm(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[Ha>>3])|0)<<24>>24==0){cm(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Ia>>3];pm(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Ka,c[ib>>2]|0,+h[Ja+24>>3],+h[Ja+192>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(La,c[ib>>2]|0,+h[Ka+24>>3],+h[Ka+192>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+24>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+192>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+208>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}cm(Na,c[ib>>2]|0,+h[Qb+24>>3]);rb=+h[Na>>3];pm(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);rb=+h[Pa>>3];cm(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[Qa>>3];pm(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Eb=+h[Sa>>3];cm(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Ta>>3];pm(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Va,c[ib>>2]|0,+h[Ua+24>>3],+h[Ua+192>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(Wa,c[ib>>2]|0,+h[Va+24>>3],+h[Va+192>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Xa,c[ib>>2]|0,qb,Bb,+h[Va+24>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+192>>3],0.0);Cb=+h[Xa>>3];cm(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Bb=+h[Ya>>3];pm(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+40>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+200>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+32>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,16336,18312,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+32>>3];Tb=+h[Ya+40>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,16024,18312,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+200>>3]-Pb}Pb=+h[Mb+24>>3];Wb=Pb+-273.15;Cb=+h[Mb+192>>3];om($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];cm(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Pb=+h[ab>>3];pm(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Pb=+h[cb>>3];cm(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Wb=+h[db>>3];pm(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+24>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,16952,18312,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+24>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+200>>3]-ub);ub=+h[Yb+192>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,16952,18312,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+192>>3];ac=+h[Yb+24>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+32>>3];Gb=+yd(1.0e-13,+(+h[Yb+40>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,16024,18312,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+24>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,16952,18312,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+24>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+200>>3];ic=+h[gc+192>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,16952,18312,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+192>>3];kc=+h[gc+24>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+32>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+40>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2288|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2288|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,16024,18312,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2288|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function hp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;jm(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+208>>3]*.999;l=j;m=l+2224|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;rm(e,c[f>>2]|0,+h[d+24>>3],+h[d+192>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+2224|0;n=m;h[n>>3]=k;i=b;return}}function ip(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+504>>3];k=+yd(1.0e-13,+(+h[g+40>>3]-j));l=+h[g+1144>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,15688,18320,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2056|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+40>>3]- +h[f+504>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+504>>3];j=+h[x+40>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2192>>3];k=+h[x+1144>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+208>>3]- +h[x+2224>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+208>>3]- +h[x+2224>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+208>>3]- +h[x+2224>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+208>>3]- +h[x+2224>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,15752,18320,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1144>>3];C=+h[L+504>>3];D=+h[L+40>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+2224>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,15688,18320,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2056|0;w=v;h[w>>3]=n;i=d;return}function jp(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+32>>3]- +h[a+520>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+2216|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+200>>3]- +h[a+2056>>3];g=a;j=g+2216|0;k=j;h[k>>3]=f;i=b;return}function kp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+200>>3]- +h[b+2216>>3];i=i;return}function lp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+536>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+2216>>3];o=+h[g+2192>>3]*k+ +h[g+1144>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,15896,18328,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+2216>>3];q=+h[v+536>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+2048>>3]*(1.0-q)+ +h[r+528>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+2208|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+2208|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,15896,18328,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+2208|0;C=B;h[C>>3]=z;i=d;return}function mp(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2992>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2968>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2976>>3];h[a+8>>3]=+h[d+2768>>3];h[e+8>>3]=+h[d+2744>>3];h[f+8>>3]=+h[d+2752>>3];i=i;return}function np(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+208>>3]=+h[b>>3];h[a+192>>3]=+h[b+8>>3];gp(f);hp(f);ip(f);jp(f);kp(f);lp(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+568|0;j=+h[g>>3];b=f+24|0;k=+h[b>>3];l=j*k;a=f+192|0;m=f+2208|0;h[d>>3]=+h[f+2296>>3]*l*l+(+h[f+40>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+208>>3]);h[d+8>>3]=+h[f+2040>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+2288>>3]));i=e;return}function op(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;dn(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+328>>3]*.999;l=j;m=l+3720|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;hn(e,c[f>>2]|0,+h[d+152>>3],+h[d+320>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+3720|0;n=m;h[n>>3]=k;i=b;return}}function pp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,17216,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}Zm(t,c[ib>>2]|0,jb);jb=+h[t>>3];en(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);jb=+h[v>>3];Zm(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);pb=+h[w>>3];en(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+136>>3];qb=+yd(1.0e-13,+(+h[w+160>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,17288,18336,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{Zm(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);sb=+h[z>>3];en(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);sb=+h[B>>3];Zm(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);jb=+h[C>>3];en(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+160>>3]- +h[E>>3]));pb=1.0- +h[C+136>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,17288,18336,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{Zm(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);vb=+h[F>>3];en(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);vb=+h[H>>3];Zm(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);sb=+h[I>>3];en(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);sb=+h[K>>3];Zm(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);jb=+h[L>>3];en(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+160>>3]- +h[N>>3])|0)<<24>>24==0){Zm(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);jb=+h[O>>3];en(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jn(Q,c[ib>>2]|0,+h[P+152>>3],+h[P+320>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;kn(R,c[ib>>2]|0,+h[Q+152>>3],+h[Q+320>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;an(S,c[ib>>2]|0,jb,pb,+h[Q+152>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+320>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+328>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}Zm(T,c[ib>>2]|0,+h[xb+152>>3]);qb=+h[T>>3];en(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);qb=+h[V>>3];Zm(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);pb=+h[W>>3];en(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);pb=+h[Y>>3];Zm(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);jb=+h[Z>>3];en(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jn($,c[ib>>2]|0,+h[_+152>>3],+h[_+320>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;kn(aa,c[ib>>2]|0,+h[$+152>>3],+h[$+320>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;an(ba,c[ib>>2]|0,jb,rb,+h[$+152>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+320>>3],0.0);zb=+h[ba>>3];Zm(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);rb=+h[ca>>3];en(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+160>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+304>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+136>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,17592,18336,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+136>>3];Cb=+h[ca+160>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,17288,18336,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+304>>3]-wb}wb=+h[tb+152>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,17216,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,17216,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}Zm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];en(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Hb=+h[ia>>3];Zm(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Fb=+h[ja>>3];en(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,17216,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,17216,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,17216,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}qb=Kb+-273.15;$m(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];Zm(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[na>>3];en(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);qb=+h[pa>>3];Zm(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Eb=+h[qa>>3];en(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+136>>3];rb=+yd(1.0e-13,+(+h[qa+160>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,17288,18336,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{Zm(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Lb=+h[ta>>3];en(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Lb=+h[va>>3];Zm(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[wa>>3];en(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+160>>3]- +h[ya>>3]));Eb=1.0- +h[wa+136>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,17288,18336,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{Zm(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Ob=+h[za>>3];en(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Ob=+h[Ba>>3];Zm(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Lb=+h[Ca>>3];en(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Lb=+h[Ea>>3];Zm(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[Fa>>3];en(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+160>>3]- +h[Ha>>3])|0)<<24>>24==0){Zm(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[Ia>>3];en(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jn(Ka,c[ib>>2]|0,+h[Ja+152>>3],+h[Ja+320>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;kn(La,c[ib>>2]|0,+h[Ka+152>>3],+h[Ka+320>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;an(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+152>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+320>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+328>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}Zm(Na,c[ib>>2]|0,+h[Qb+152>>3]);rb=+h[Na>>3];en(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);rb=+h[Pa>>3];Zm(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Eb=+h[Qa>>3];en(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Eb=+h[Sa>>3];Zm(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[Ta>>3];en(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jn(Va,c[ib>>2]|0,+h[Ua+152>>3],+h[Ua+320>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;kn(Wa,c[ib>>2]|0,+h[Va+152>>3],+h[Va+320>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;an(Xa,c[ib>>2]|0,qb,Bb,+h[Va+152>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+320>>3],0.0);Cb=+h[Xa>>3];Zm(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Bb=+h[Ya>>3];en(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+160>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+304>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+136>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,17592,18336,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+136>>3];Tb=+h[Ya+160>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,17288,18336,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+304>>3]-Pb}Pb=+h[Mb+152>>3];Wb=Pb+-273.15;Cb=+h[Mb+320>>3];an($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];Zm(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Pb=+h[ab>>3];en(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Pb=+h[cb>>3];Zm(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Wb=+h[db>>3];en(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+152>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,18200,18336,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+152>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+304>>3]-ub);ub=+h[Yb+320>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,18200,18336,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+320>>3];ac=+h[Yb+152>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+136>>3];Gb=+yd(1.0e-13,+(+h[Yb+160>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,17288,18336,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+152>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,18200,18336,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+152>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+304>>3];ic=+h[gc+320>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,18200,18336,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+320>>3];kc=+h[gc+152>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+136>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+160>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+3728|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+3728|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,17288,18336,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+3728|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function qp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3464>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));l=+h[g+1912>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,16984,18368,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3696|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+160>>3]- +h[f+3464>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3464>>3];j=+h[x+160>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2120>>3];k=+h[x+1912>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+328>>3]- +h[x+3720>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+328>>3]- +h[x+3720>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+328>>3]- +h[x+3720>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+328>>3]- +h[x+3720>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,17040,18368,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1912>>3];C=+h[L+3464>>3];D=+h[L+160>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+3720>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,16984,18368,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3696|0;w=v;h[w>>3]=n;i=d;return}function rp(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+136>>3]- +h[a+3480>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+3712|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+304>>3]- +h[a+3696>>3];g=a;j=g+3712|0;k=j;h[k>>3]=f;i=b;return}function sp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3688>>3]=+h[b+304>>3]- +h[b+3712>>3];i=i;return}function tp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3496>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+3712>>3];o=+h[g+2120>>3]*k+ +h[g+1912>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,17168,18376,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+3712>>3];q=+h[v+3496>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+3688>>3]*(1.0-q)+ +h[r+3488>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+3704|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+3704|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,17168,18376,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+3704|0;C=B;h[C>>3]=z;i=d;return}function up(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4560>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4536>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4544>>3];h[a+8>>3]=+h[d+4672>>3];h[e+8>>3]=+h[d+4648>>3];h[f+8>>3]=+h[d+4656>>3];i=i;return}function vp(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+320>>3]=+h[b>>3];h[a+328>>3]=+h[b+8>>3];op(f);pp(f);qp(f);rp(f);sp(f);tp(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+3704|0;b=f+152|0;a=f+3528|0;j=f+320|0;h[d>>3]=+h[f+3680>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+3728>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+3736>>3]*m*m+(+h[f+160>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+328>>3]);i=e;return}function wp(a){a=a|0;c[a+4>>2]=267;c[a>>2]=2;c[a+56>>2]=0;c[a+32>>2]=22;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=329;c[a+80>>2]=2;c[a+136>>2]=0;c[a+112>>2]=23;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=342;c[a+160>>2]=3;c[a+216>>2]=0;c[a+192>>2]=24;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=377;c[a+240>>2]=2;c[a+296>>2]=0;c[a+272>>2]=25;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=420;c[a+320>>2]=1;c[a+376>>2]=0;c[a+352>>2]=26;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=459;c[a+400>>2]=2;c[a+456>>2]=0;c[a+432>>2]=27;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=476;c[a+480>>2]=2;c[a+536>>2]=0;c[a+512>>2]=28;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=776;c[a+560>>2]=2;c[a+616>>2]=0;c[a+592>>2]=29;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=803;c[a+640>>2]=3;c[a+696>>2]=0;c[a+672>>2]=30;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=833;c[a+720>>2]=2;c[a+776>>2]=0;c[a+752>>2]=31;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;c[a+804>>2]=871;c[a+800>>2]=2;c[a+856>>2]=0;c[a+832>>2]=32;c[a+820>>2]=0;c[a+824>>2]=0;c[a+828>>2]=-1;c[a+836>>2]=53;c[a+884>>2]=919;c[a+880>>2]=1;c[a+936>>2]=0;c[a+912>>2]=33;c[a+900>>2]=0;c[a+904>>2]=0;c[a+908>>2]=-1;c[a+916>>2]=54;c[a+964>>2]=946;c[a+960>>2]=2;c[a+1016>>2]=0;c[a+992>>2]=34;c[a+980>>2]=0;c[a+984>>2]=0;c[a+988>>2]=-1;c[a+996>>2]=55;c[a+1044>>2]=976;c[a+1040>>2]=2;c[a+1096>>2]=0;c[a+1072>>2]=35;c[a+1060>>2]=0;c[a+1064>>2]=0;c[a+1068>>2]=-1;c[a+1076>>2]=56;i=i;return}function xp(a){a=a|0;i=i;return}function yp(a,b){a=a|0;b=b|0;i=i;return}function zp(a){a=a|0;i=i;return}function Ap(a,b){a=a|0;b=b|0;c[b>>2]=c[18440+(a<<2)>>2];i=i;return c[18448+(a<<2)>>2]|0}function Bp(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;f=(uW(+h[c[c[b+4>>2]>>2]>>3],+h[(c[b+400>>2]|0)+3352>>3],a[c[b+360>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=f?1.0:-1.0;i=e;return 0}function Cp(a){a=a|0;i=i;return c[18448+(a<<2)>>2]|0}function Dp(b,d){b=b|0;d=d|0;var e=0,f=0.0,g=0.0;e=i;f=+h[c[c[b+4>>2]>>2]>>3];g=+h[(c[b+400>>2]|0)+3352>>3];if((d|0)==0){a[c[b+352>>2]|0]=f>=g|0;i=e;return 0}else{d=uW(f,g,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=d;i=e;return 0}return 0}function Ep(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;RS(8,1,18456,g);g=b+4|0;j=c[c[g>>2]>>2]|0;l=a[(c[j+16>>2]|0)+8|0]|0;m=a[(c[b+408>>2]|0)+8|0]|0;if(l<<24>>24==m<<24>>24){n=j;o=0}else{c[f>>2]=m<<24>>24;c[f+4>>2]=l<<24>>24;RS(8,0,18488,f);n=c[c[g>>2]>>2]|0;o=1}p=+h[(c[n+8>>2]|0)+3352>>3];q=+h[(c[b+400>>2]|0)+3352>>3];if(p!=q){b=e;h[k>>3]=q;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=e+8|0;h[k>>3]=p;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];RS(8,0,18544,e);r=1}else{r=o}if((c[116208>>2]|0)==0){i=d;return r|0}le[c[29182]&511](8);i=d;return r|0}function Fp(a){a=a|0;i=i;return c[20520+(a<<2)>>2]|0}function Gp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=i;i=i+8|0;h=b+4|0;c[(c[(c[c[h>>2]>>2]|0)+12>>2]|0)+8>>2]=-1;do{if((Hp(1)|0)==0){j=-1.0}else{pn(g,c[b+536>>2]|0,20648,c[c[b+428>>2]>>2]|0,1);if((a[g]|0)!=0){c[(c[(c[c[h>>2]>>2]|0)+12>>2]|0)+8>>2]=1}if((Hp(2)|0)==0){j=+(c[(c[(c[c[h>>2]>>2]|0)+12>>2]|0)+8>>2]|0);break}else{cb(20656,20688,124,20760)}}}while(0);if(!((xW(j,0.0)|0)<<24>>24==0)){i=d;return}h=CT(CT(CT(CT(CT(20840,c[c[b+428>>2]>>2]|0)|0,20864)|0,20896)|0,20912)|0,20920)|0;g=c[b+536>>2]|0;b=c[41338]|0;k=e;l=27200;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];Oe[b&63](g,e,h,f);i=d;return}function Hp(a){a=a|0;i=i;return(a|0)==1|0}function Ip(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=i;i=i+8|0;h=b+4|0;c[(c[(c[c[h>>2]>>2]|0)+12>>2]|0)+4>>2]=-1;do{if((Hp(1)|0)==0){j=-1.0}else{pn(g,c[b+536>>2]|0,20648,c[(c[b+428>>2]|0)+4>>2]|0,1);if((a[g]|0)!=0){c[(c[(c[c[h>>2]>>2]|0)+12>>2]|0)+4>>2]=1}if((Hp(2)|0)==0){j=+(c[(c[(c[c[h>>2]>>2]|0)+12>>2]|0)+4>>2]|0);break}else{cb(20656,20688,202,21040)}}}while(0);if(!((xW(j,0.0)|0)<<24>>24==0)){i=d;return}h=CT(CT(CT(CT(CT(20840,c[(c[b+428>>2]|0)+4>>2]|0)|0,20864)|0,20896)|0,20912)|0,20920)|0;g=c[b+536>>2]|0;b=c[41338]|0;k=e;l=27200;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];Oe[b&63](g,e,h,f);i=d;return}function Jp(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=c[b+424>>2]|0;if((a[j+54|0]|0)==0){h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+4032>>3]=1.0;k=b+320|0;l=b+536|0;m=1.0}else{n=b+536|0;o=b+320|0;Kl(e,c[n>>2]|0,c[c[o>>2]>>2]|0,0,a[j+55|0]|0);p=+h[e>>3];h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+4032>>3]=p;k=o;l=n;m=p}n=b+4|0;Jl(f,c[l>>2]|0,c[c[k>>2]>>2]|0,m);b=c[(c[c[n>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=+h[f>>3];Hl(g,c[l>>2]|0,c[c[k>>2]>>2]|0,+h[b+4032>>3]);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+4016>>3]=+h[g>>3];i=d;return}function Kp(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=i;i=i+8|0;h=b+4|0;c[c[(c[c[h>>2]>>2]|0)+12>>2]>>2]=-1;do{if((Hp(1)|0)==0){j=-1.0}else{pn(g,c[b+536>>2]|0,20648,c[(c[b+428>>2]|0)+16>>2]|0,1);if((a[g]|0)!=0){c[c[(c[c[h>>2]>>2]|0)+12>>2]>>2]=1}if((Hp(2)|0)==0){j=+(c[c[(c[c[h>>2]>>2]|0)+12>>2]>>2]|0);break}else{cb(20656,20688,338,21120)}}}while(0);if(!((xW(j,0.0)|0)<<24>>24==0)){i=d;return}h=CT(CT(CT(CT(CT(20840,c[(c[b+428>>2]|0)+16>>2]|0)|0,20864)|0,20896)|0,20912)|0,20920)|0;g=c[b+536>>2]|0;b=c[41338]|0;k=e;l=27200;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];Oe[b&63](g,e,h,f);i=d;return}function Lp(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0.0,S=0.0,T=0.0,U=0.0,V=0.0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+8|0;RS(21,1,21200,N);N=b+4|0;O=b+416|0;P=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+152>>3]- +h[(c[O>>2]|0)+712>>3];h[d>>3]=P;Q=Fp(0)|0;c[M>>2]=1;c[M+4>>2]=Q;Q=M+8|0;h[k>>3]=P;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];RS(21,0,21232,M);P=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+160>>3]- +h[(c[O>>2]|0)+760>>3];h[d+8>>3]=P;M=Fp(1)|0;c[L>>2]=2;c[L+4>>2]=M;M=L+8|0;h[k>>3]=P;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];RS(21,0,21232,L);P=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+136>>3]- +h[(c[O>>2]|0)+48>>3];h[d+16>>3]=P;L=Fp(2)|0;c[K>>2]=3;c[K+4>>2]=L;L=K+8|0;h[k>>3]=P;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];RS(21,0,21232,K);K=c[(c[c[N>>2]>>2]|0)+8>>2]|0;P=+h[K+128>>3]+ +h[(c[O>>2]|0)+64>>3]*+h[K+3576>>3]*-658.3278472679394;h[d+24>>3]=P;K=Fp(3)|0;c[J>>2]=4;c[J+4>>2]=K;K=J+8|0;h[k>>3]=P;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];RS(21,0,21232,J);J=c[O>>2]|0;K=c[(c[c[N>>2]>>2]|0)+8>>2]|0;P=+h[J+928>>3]+(-(+h[J+960>>3]*+h[J+976>>3]*(+h[K+2640>>3]+(+h[K+2648>>3]+ +h[K+2656>>3])))- +h[K+3832>>3]);h[d+32>>3]=P;K=Fp(4)|0;c[I>>2]=5;c[I+4>>2]=K;K=I+8|0;h[k>>3]=P;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];RS(21,0,21232,I);I=c[O>>2]|0;P=+h[I+952>>3];K=c[c[N>>2]>>2]|0;R=+h[(c[K+8>>2]|0)+3832>>3];S=+h[I+936>>3];T=+h[I+944>>3];do{if(S!=0.0){U=T/S}else{if(T==0.0){U=T;break}U=T/+XS(c[b+536>>2]|0,S,21248,0,+h[K>>3],(a[b+319|0]|0)!=0|0)}}while(0);S=P-R*U;h[d+40>>3]=S;K=Fp(5)|0;c[H>>2]=6;c[H+4>>2]=K;K=H+8|0;h[k>>3]=S;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];RS(21,0,21232,H);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+88>>3]+-293.15;h[d+48>>3]=S;H=Fp(6)|0;c[G>>2]=7;c[G+4>>2]=H;H=G+8|0;h[k>>3]=S;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];RS(21,0,21232,G);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+64>>3]+-293.15;h[d+56>>3]=S;G=Fp(7)|0;c[F>>2]=8;c[F+4>>2]=G;G=F+8|0;h[k>>3]=S;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];RS(21,0,21232,F);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+104>>3]+-101325.0;h[d+64>>3]=S;F=Fp(8)|0;c[E>>2]=9;c[E+4>>2]=F;F=E+8|0;h[k>>3]=S;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];RS(21,0,21232,E);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+80>>3]+-101325.0;h[d+72>>3]=S;E=Fp(9)|0;c[D>>2]=10;c[D+4>>2]=E;E=D+8|0;h[k>>3]=S;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];RS(21,0,21232,D);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+96>>3]- +h[(c[O>>2]|0)+72>>3];h[d+80>>3]=S;D=Fp(10)|0;c[C>>2]=11;c[C+4>>2]=D;D=C+8|0;h[k>>3]=S;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];RS(21,0,21232,C);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+72>>3]- +h[(c[O>>2]|0)+72>>3];h[d+88>>3]=S;C=Fp(11)|0;c[B>>2]=12;c[B+4>>2]=C;C=B+8|0;h[k>>3]=S;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];RS(21,0,21232,B);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+1792>>3]- +h[(c[O>>2]|0)+88>>3];h[d+96>>3]=S;B=Fp(12)|0;c[A>>2]=13;c[A+4>>2]=B;B=A+8|0;h[k>>3]=S;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];RS(21,0,21232,A);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+1800>>3]- +h[(c[O>>2]|0)+88>>3];h[d+104>>3]=S;A=Fp(13)|0;c[z>>2]=14;c[z+4>>2]=A;A=z+8|0;h[k>>3]=S;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];RS(21,0,21232,z);S=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+144>>3]- +h[(c[O>>2]|0)+1256>>3];h[d+112>>3]=S;z=Fp(14)|0;c[y>>2]=15;c[y+4>>2]=z;z=y+8|0;h[k>>3]=S;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(21,0,21232,y);y=c[O>>2]|0;z=c[(c[c[N>>2]>>2]|0)+8>>2]|0;S=+h[y+1472>>3]+(-(+h[y+1504>>3]*+h[y+1520>>3]*(+h[z+2664>>3]+(+h[z+2672>>3]+ +h[z+2680>>3])))- +h[z+3840>>3]);h[d+120>>3]=S;z=Fp(15)|0;c[x>>2]=16;c[x+4>>2]=z;z=x+8|0;h[k>>3]=S;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(21,0,21232,x);x=c[O>>2]|0;S=+h[x+1496>>3];z=c[c[N>>2]>>2]|0;U=+h[(c[z+8>>2]|0)+3840>>3];R=+h[x+1480>>3];P=+h[x+1488>>3];do{if(R!=0.0){V=P/R}else{if(P==0.0){V=P;break}V=P/+XS(c[b+536>>2]|0,R,21288,0,+h[z>>3],(a[b+319|0]|0)!=0|0)}}while(0);R=S-U*V;h[d+128>>3]=R;z=Fp(16)|0;c[w>>2]=17;c[w+4>>2]=z;z=w+8|0;h[k>>3]=R;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];RS(21,0,21232,w);R=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+24>>3]+-293.15;h[d+136>>3]=R;w=Fp(17)|0;c[v>>2]=18;c[v+4>>2]=w;w=v+8|0;h[k>>3]=R;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];RS(21,0,21232,v);R=+h[c[(c[c[N>>2]>>2]|0)+8>>2]>>3]+-293.15;h[d+144>>3]=R;v=Fp(18)|0;c[u>>2]=19;c[u+4>>2]=v;v=u+8|0;h[k>>3]=R;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];RS(21,0,21232,u);R=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+40>>3]+-101325.0;h[d+152>>3]=R;u=Fp(19)|0;c[t>>2]=20;c[t+4>>2]=u;u=t+8|0;h[k>>3]=R;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];RS(21,0,21232,t);R=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+16>>3]+-101325.0;h[d+160>>3]=R;t=Fp(20)|0;c[s>>2]=21;c[s+4>>2]=t;t=s+8|0;h[k>>3]=R;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];RS(21,0,21232,s);R=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+32>>3]- +h[(c[O>>2]|0)+440>>3];h[d+168>>3]=R;s=Fp(21)|0;c[r>>2]=22;c[r+4>>2]=s;s=r+8|0;h[k>>3]=R;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];RS(21,0,21232,r);R=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+8>>3]- +h[(c[O>>2]|0)+440>>3];h[d+176>>3]=R;r=Fp(22)|0;c[q>>2]=23;c[q+4>>2]=r;r=q+8|0;h[k>>3]=R;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(21,0,21232,q);R=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+1032>>3]- +h[(c[O>>2]|0)+456>>3];h[d+184>>3]=R;q=Fp(23)|0;c[p>>2]=24;c[p+4>>2]=q;q=p+8|0;h[k>>3]=R;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];RS(21,0,21232,p);R=+h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+1040>>3]- +h[(c[O>>2]|0)+456>>3];h[d+192>>3]=R;p=Fp(24)|0;c[o>>2]=25;c[o+4>>2]=p;p=o+8|0;h[k>>3]=R;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];RS(21,0,21232,o);Gp(b);o=b+420|0;R=+((c[(c[o>>2]|0)+12>>2]|0)-(c[(c[(c[c[N>>2]>>2]|0)+12>>2]|0)+8>>2]|0)|0);h[d+200>>3]=R;p=Fp(25)|0;c[n>>2]=26;c[n+4>>2]=p;p=n+8|0;h[k>>3]=R;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];RS(21,0,21232,n);Ip(b);R=+((c[(c[o>>2]|0)+132>>2]|0)-(c[(c[(c[c[N>>2]>>2]|0)+12>>2]|0)+4>>2]|0)|0);h[d+208>>3]=R;n=Fp(26)|0;c[m>>2]=27;c[m+4>>2]=n;n=m+8|0;h[k>>3]=R;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];RS(21,0,21232,m);Jp(b);R=+h[(c[O>>2]|0)+1056>>3]- +h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+4032>>3];h[d+216>>3]=R;m=Fp(27)|0;c[l>>2]=28;c[l+4>>2]=m;m=l+8|0;h[k>>3]=R;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];RS(21,0,21232,l);R=+h[(c[O>>2]|0)+1040>>3]- +h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+4024>>3];h[d+224>>3]=R;l=Fp(28)|0;c[j>>2]=29;c[j+4>>2]=l;l=j+8|0;h[k>>3]=R;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];RS(21,0,21232,j);R=+h[(c[O>>2]|0)+1048>>3]- +h[(c[(c[c[N>>2]>>2]|0)+8>>2]|0)+4016>>3];h[d+232>>3]=R;O=Fp(29)|0;c[g>>2]=30;c[g+4>>2]=O;O=g+8|0;h[k>>3]=R;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];RS(21,0,21232,g);Kp(b);R=+((c[(c[o>>2]|0)+232>>2]|0)-(c[c[(c[c[N>>2]>>2]|0)+12>>2]>>2]|0)|0);h[d+240>>3]=R;d=Fp(30)|0;c[f>>2]=31;c[f+4>>2]=d;d=f+8|0;h[k>>3]=R;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];RS(21,0,21232,f);if((c[116260>>2]|0)==0){i=e;return 0}le[c[29182]&511](21);i=e;return 0}function Mp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+624>>3];i=i;return}function Np(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1544>>3]=+h[b+1336>>3];i=i;return}function Op(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+81|0]=a[d+67|0]|0;i=i;return}function Pp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+536>>3]=+h[b+1360>>3];i=i;return}function Qp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+1360>>3];i=i;return}function Rp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+1344>>3]*.5;i=i;return}function Sp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+1344>>3]*.5;i=i;return}function Tp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+632>>3];i=i;return}function Up(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1480>>3]=+h[b+648>>3];i=i;return}function Vp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1488>>3]=+h[b+656>>3]*+h[b+1480>>3];i=i;return}function Wp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1440>>3]=+h[b+1336>>3];i=i;return}function Xp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1416>>3]=+h[b+1352>>3]*3.141592653589793;i=i;return}function Yp(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+1352>>3];h[b+1408>>3]=d*d*.7853981633974483;i=i;return}function Zp(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+1408>>3];i=i;return}function _p(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+1408>>3];i=i;return}function $p(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1416>>3];j=+h[f+1408>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+XS(c[b+536>>2]|0,g,21328,21320,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+512>>3]=l*4.0;i=d;return}function aq(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1416>>3];j=+h[f+1408>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+XS(c[b+536>>2]|0,g,21328,21352,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+520>>3]=l*4.0;i=d;return}function bq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1328>>3]=+h[b+1224>>3];i=i;return}function cq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1320>>3]=+h[b+1120>>3];i=i;return}function dq(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1144>>3]*+h[f+1096>>3];if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+1304|0;o=n;h[o>>3]=l;i=d;return}p=+XS(c[b+536>>2]|0,g,21368,21360,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+1304|0;o=n;h[o>>3]=l;i=d;return}function eq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1256>>3]=+h[b+1160>>3];i=i;return}function fq(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1104>>3];if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+1248|0;o=n;h[o>>3]=l;i=d;return}p=+XS(c[b+536>>2]|0,g,21392,21384,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+1248|0;o=n;h[o>>3]=l;i=d;return}function gq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1232>>3]=+h[b+1128>>3];i=i;return}function hq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+1096>>3];i=i;return}function iq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+816>>3];i=i;return}function jq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+816>>3];i=i;return}function kq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+800>>3]*.5;i=i;return}function lq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+800>>3]*.5;i=i;return}function mq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+960>>3]=+h[b+632>>3];i=i;return}function nq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+936>>3]=+h[b+648>>3];i=i;return}function oq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+944>>3]=+h[b+656>>3]*+h[b+936>>3];i=i;return}function pq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+896>>3]=+h[b+792>>3];i=i;return}function qq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+808>>3]*3.141592653589793;i=i;return}function rq(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+808>>3];h[b+864>>3]=d*d*.7853981633974483;i=i;return}function sq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+864>>3];i=i;return}function tq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+864>>3];i=i;return}function uq(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+872>>3];j=+h[f+864>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+XS(c[b+536>>2]|0,g,21408,21400,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+144>>3]=l*4.0;i=d;return}function vq(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+872>>3];j=+h[f+864>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+XS(c[b+536>>2]|0,g,21408,21432,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+152>>3]=l*4.0;i=d;return}function wq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+688>>3]=+h[b+624>>3];i=i;return}function xq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+712>>3]=+h[b+688>>3];i=i;return}function yq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+616>>3];i=i;return}function zq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+760>>3]=+h[b+680>>3];i=i;return}function Aq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+48>>3];n=e;h[k>>3]=+h[l+56>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=+h[a+760>>3];o=+h[a+712>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];mn(g,e,m,o,d);h[(c[j>>2]|0)+720>>3]=+h[g>>3];i=b;return}function Bq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+680>>3];i=i;return}function Cq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+848>>3];i=i;return}function Dq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+72>>3];n=e;h[k>>3]=+h[l+80>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+848>>3]+ +h[a+880>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];vm(g,e,m,293.15,d);h[(c[j>>2]|0)+840>>3]=+h[g>>3];i=b;return}function Eq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+912>>3]=+h[b+880>>3];i=i;return}function Fq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+904>>3]=+h[b+848>>3];i=i;return}function Gq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1392>>3]=+h[b+680>>3];i=i;return}function Hq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1424>>3]=+h[b+1392>>3];i=i;return}function Iq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+440>>3];n=e;h[k>>3]=+h[l+448>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+1392>>3]+ +h[a+1424>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];vm(g,e,m,293.15,d);h[(c[j>>2]|0)+1384>>3]=+h[g>>3];i=b;return}function Jq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1456>>3]=+h[b+1424>>3];i=i;return}function Kq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1448>>3]=+h[b+1392>>3];i=i;return}function Lq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3152>>3]=+h[(c[a+416>>2]|0)+488>>3]*.5;i=i;return}function Mq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3144>>3]=(+h[b+480>>3]+ +h[b+488>>3])*.5;i=i;return}function Nq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3136>>3]=+h[(c[a+416>>2]|0)+480>>3]*.5;i=i;return}function Oq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3128>>3]=+h[b+504>>3]*+h[b+488>>3]*+h[b+1336>>3];i=i;return}function Pq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=+h[b+496>>3]*+h[b+480>>3]*+h[b+1336>>3];i=i;return}function Qq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=+h[(c[a+416>>2]|0)+120>>3]*.5;i=i;return}function Rq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=(+h[b+112>>3]+ +h[b+120>>3])*.5;i=i;return}function Sq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=+h[(c[a+416>>2]|0)+112>>3]*.5;i=i;return}function Tq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=+h[b+136>>3]*+h[b+120>>3]*+h[b+792>>3];i=i;return}function Uq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=+h[b+128>>3]*+h[b+112>>3]*+h[b+792>>3];i=i;return}function Vq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2896>>3]=1.0- +h[c[a+416>>2]>>3];i=i;return}function Wq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+416|0;n=c[m>>2]|0;o=+h[n>>3];p=f;h[k>>3]=+h[n+8>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;p=c[f>>2]|0;n=c[m>>2]|0;o=+h[n+584>>3];q=+h[n+600>>3];n=e;m=g;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];xm(j,p,o,q,e);e=c[f>>2]|0;f=d;p=j;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];c[f+20>>2]=c[p+20>>2];c[f+24>>2]=c[p+24>>2];c[f+28>>2]=c[p+28>>2];wm(l,e,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3912>>3]=+h[l>>3];i=b;return}function Xq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+416|0;n=c[m>>2]|0;o=+h[n>>3];p=f;h[k>>3]=+h[n+8>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;p=c[f>>2]|0;n=c[m>>2]|0;o=+h[n+584>>3];q=+h[n+600>>3];n=e;m=g;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];xm(j,p,o,q,e);e=c[f>>2]|0;f=d;p=j;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];c[f+20>>2]=c[p+20>>2];c[f+24>>2]=c[p+24>>2];c[f+28>>2]=c[p+28>>2];Cm(l,e,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3904>>3]=+h[l>>3];i=b;return}function Yq(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=(+h[b+144>>3]+ +h[b+152>>3])*.5;i=i;return}function Zq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=1.0- +h[c[a+416>>2]>>3];i=i;return}function _q(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=(+h[b+512>>3]+ +h[b+520>>3])*.5;i=i;return}function $q(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=0.0;i=i;return}function ar(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=0.0;i=i;return}function br(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=0.0;i=i;return}function cr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2656>>3]=0.0;i=i;return}function dr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2648>>3]=0.0;i=i;return}function er(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2640>>3]=0.0;i=i;return}function fr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+2896>>3]),1.0e-13);k=+h[c[b+416>>2]>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3864|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3864|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,21448,21440,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3864|0;p=o;h[p>>3]=m;i=d;return}function gr(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;YT(e,1,+h[c[a+416>>2]>>3],b+16|0);g=c[a+536>>2]|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[a+3912>>3];l=+h[a+3904>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Hm(f,g,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3856>>3]=+h[f>>3];i=b;return}function hr(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Bm(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3904>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3848>>3]=+xd(+(+h[d>>3]),+(+h[a+3912>>3]*.999));i=b;return}function ir(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=b+536|0;k=c[j>>2]|0;l=b+416|0;m=c[l>>2]|0;n=+h[m+1440>>3];o=+h[m+1480>>3];do{if(n!=0.0){p=n;q=m;r=o/n}else{if(o==0.0){p=n;q=m;r=o;break}s=o/+XS(k,n,21496,21488,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);t=c[l>>2]|0;p=+h[t+1440>>3];q=t;r=s}}while(0);n=+h[q+1520>>3];o=+h[q+1528>>3];m=b+4|0;t=c[c[m>>2]>>2]|0;s=+h[(c[t+8>>2]|0)+3136>>3];u=+h[q+512>>3];v=+h[q+528>>3];w=(v+v)*.5;v=+h[q+1488>>3];do{if(p!=0.0){x=q;y=v/p}else{if(v==0.0){x=q;y=v;break}z=v/+XS(c[j>>2]|0,p,21496,21488,+h[t>>3],(a[b+319|0]|0)!=0|0);x=c[l>>2]|0;y=z}}while(0);Yl(e,k,r,n,n,o,o,s,u,w,y,+h[x+1464>>3]);y=+h[e>>3];e=c[j>>2]|0;x=c[l>>2]|0;w=+h[x+1440>>3];u=+h[x+1480>>3];do{if(w!=0.0){A=w;B=x;C=u/w}else{if(u==0.0){A=w;B=x;C=u;break}s=u/+XS(e,w,21496,21488,+h[c[c[m>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[l>>2]|0;A=+h[k+1440>>3];B=k;C=s}}while(0);w=+h[B+1520>>3];u=+h[B+1528>>3];x=c[c[m>>2]>>2]|0;k=c[x+8>>2]|0;s=+h[k+3144>>3];o=+h[k+2696>>3];n=(+h[B+528>>3]+ +h[B+536>>3])*.5;r=+h[B+1488>>3];do{if(A!=0.0){D=B;E=r/A}else{if(r==0.0){D=B;E=r;break}p=r/+XS(c[j>>2]|0,A,21496,21488,+h[x>>3],(a[b+319|0]|0)!=0|0);D=c[l>>2]|0;E=p}}while(0);Yl(f,e,C,w,w,u,u,s,o,n,E,+h[D+1464>>3]);E=+h[f>>3];f=c[j>>2]|0;D=c[l>>2]|0;n=+h[D+1440>>3];o=+h[D+1480>>3];do{if(n!=0.0){F=n;G=D;H=o/n}else{if(o==0.0){F=n;G=D;H=o;break}s=o/+XS(f,n,21496,21488,+h[c[c[m>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[l>>2]|0;F=+h[e+1440>>3];G=e;H=s}}while(0);n=+h[G+1520>>3];o=+h[G+1528>>3];D=c[c[m>>2]>>2]|0;s=+h[(c[D+8>>2]|0)+3152>>3];u=+h[G+520>>3];w=+h[G+536>>3];C=(w+w)*.5;w=+h[G+1488>>3];if(F!=0.0){I=G;J=w/F;K=I;L=K+1464|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3840|0;$=_;h[$>>3]=S;i=d;return}if(w==0.0){I=G;J=w;K=I;L=K+1464|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3840|0;$=_;h[$>>3]=S;i=d;return}A=w/+XS(c[j>>2]|0,F,21496,21488,+h[D>>3],(a[b+319|0]|0)!=0|0);I=c[l>>2]|0;J=A;K=I;L=K+1464|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3840|0;$=_;h[$>>3]=S;i=d;return}function jr(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=b+536|0;k=c[j>>2]|0;l=b+416|0;m=c[l>>2]|0;n=+h[m+896>>3];o=+h[m+936>>3];do{if(n!=0.0){p=n;q=m;r=o/n}else{if(o==0.0){p=n;q=m;r=o;break}s=o/+XS(k,n,21536,21528,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);t=c[l>>2]|0;p=+h[t+896>>3];q=t;r=s}}while(0);n=+h[q+976>>3];o=+h[q+984>>3];m=b+4|0;t=c[c[m>>2]>>2]|0;s=+h[(c[t+8>>2]|0)+3024>>3];u=+h[q+144>>3];v=+h[q+160>>3];w=(v+v)*.5;v=+h[q+944>>3];do{if(p!=0.0){x=q;y=v/p}else{if(v==0.0){x=q;y=v;break}z=v/+XS(c[j>>2]|0,p,21536,21528,+h[t>>3],(a[b+319|0]|0)!=0|0);x=c[l>>2]|0;y=z}}while(0);Yl(e,k,r,n,n,o,o,s,u,w,y,+h[x+920>>3]);y=+h[e>>3];e=c[j>>2]|0;x=c[l>>2]|0;w=+h[x+896>>3];u=+h[x+936>>3];do{if(w!=0.0){A=w;B=x;C=u/w}else{if(u==0.0){A=w;B=x;C=u;break}s=u/+XS(e,w,21536,21528,+h[c[c[m>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[l>>2]|0;A=+h[k+896>>3];B=k;C=s}}while(0);w=+h[B+976>>3];u=+h[B+984>>3];x=c[c[m>>2]>>2]|0;k=c[x+8>>2]|0;s=+h[k+3032>>3];o=+h[k+2720>>3];n=(+h[B+160>>3]+ +h[B+168>>3])*.5;r=+h[B+944>>3];do{if(A!=0.0){D=B;E=r/A}else{if(r==0.0){D=B;E=r;break}p=r/+XS(c[j>>2]|0,A,21536,21528,+h[x>>3],(a[b+319|0]|0)!=0|0);D=c[l>>2]|0;E=p}}while(0);Yl(f,e,C,w,w,u,u,s,o,n,E,+h[D+920>>3]);E=+h[f>>3];f=c[j>>2]|0;D=c[l>>2]|0;n=+h[D+896>>3];o=+h[D+936>>3];do{if(n!=0.0){F=n;G=D;H=o/n}else{if(o==0.0){F=n;G=D;H=o;break}s=o/+XS(f,n,21536,21528,+h[c[c[m>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[l>>2]|0;F=+h[e+896>>3];G=e;H=s}}while(0);n=+h[G+976>>3];o=+h[G+984>>3];D=c[c[m>>2]>>2]|0;s=+h[(c[D+8>>2]|0)+3040>>3];u=+h[G+152>>3];w=+h[G+168>>3];C=(w+w)*.5;w=+h[G+944>>3];if(F!=0.0){I=G;J=w/F;K=I;L=K+920|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3832|0;$=_;h[$>>3]=S;i=d;return}if(w==0.0){I=G;J=w;K=I;L=K+920|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3832|0;$=_;h[$>>3]=S;i=d;return}A=w/+XS(c[j>>2]|0,F,21536,21528,+h[D>>3],(a[b+319|0]|0)!=0|0);I=c[l>>2]|0;J=A;K=I;L=K+920|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3832|0;$=_;h[$>>3]=S;i=d;return}function kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3824>>3]=+h[b+3904>>3]+-273.15;i=i;return}function lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3816>>3]=+h[b+3912>>3]*1.0e-5;i=i;return}function mr(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2632>>3]=+h[b+488>>3]*+h[b+1416>>3];i=i;return}function nr(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2624>>3]=+h[b+480>>3]*+h[b+1416>>3];i=i;return}function or(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2600>>3]=+h[b+120>>3]*+h[b+872>>3];i=i;return}function pr(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2592>>3]=+h[b+112>>3]*+h[b+872>>3];i=i;return}



function RD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28992]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1512>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1512>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(29e3,wT(+h[(c[g>>2]|0)+1512>>3],28240)|0)|0;g=c[41340]|0;j=e;k=37304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[28992]=1;i=d;return}function SD(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29168]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+224>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+224>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(29184,yT(c[(c[g>>2]|0)+224>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=37592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[29168]=1;i=d;return}function TD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29440]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(29448,wT(+h[(c[g>>2]|0)+1496>>3],28240)|0)|0;g=c[41340]|0;j=e;k=37736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[29440]=1;i=d;return}function UD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29560]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(29568,wT(+h[(c[g>>2]|0)+1472>>3],28240)|0)|0;g=c[41340]|0;j=e;k=37888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[29560]=1;i=d;return}function VD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29680]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1456>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1456>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(29688,wT(+h[(c[g>>2]|0)+1456>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[29680]=1;i=d;return}function WD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29848]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1448>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1448>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(29856,wT(+h[(c[g>>2]|0)+1448>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[29848]=1;i=d;return}function XD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30016]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+472>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+472>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(30024,wT(+h[(c[g>>2]|0)+472>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[30016]=1;i=d;return}function YD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30160]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+464>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+464>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(30168,wT(+h[(c[g>>2]|0)+464>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[30160]=1;i=d;return}function ZD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30304]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1424>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1424>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(30312,wT(+h[(c[g>>2]|0)+1424>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[30304]=1;i=d;return}function _D(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30440]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+208>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(30448,yT(c[(c[g>>2]|0)+208>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=39e3;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[30440]=1;i=d;return}function $D(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30664]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+204>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(30672,yT(c[(c[g>>2]|0)+204>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=39264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[30664]=1;i=d;return}function aE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30904]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(30912,wT(+h[(c[g>>2]|0)+456>>3],28240)|0)|0;g=c[41340]|0;j=e;k=39392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[30904]=1;i=d;return}function bE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31008]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+448>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+448>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(31016,wT(+h[(c[g>>2]|0)+448>>3],28240)|0)|0;g=c[41340]|0;j=e;k=39688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[31008]=1;i=d;return}function cE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31144]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+440>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+440>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(31152,wT(+h[(c[g>>2]|0)+440>>3],28240)|0)|0;g=c[41340]|0;j=e;k=39688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[31144]=1;i=d;return}function dE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31280]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1400>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1400>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(31288,wT(+h[(c[g>>2]|0)+1400>>3],28240)|0)|0;g=c[41340]|0;j=e;k=39864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[31280]=1;i=d;return}function eE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31432]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+196>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(31440,yT(c[(c[g>>2]|0)+196>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=40128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[31432]=1;i=d;return}function fE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31664]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1392>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(31672,wT(+h[(c[g>>2]|0)+1392>>3],28240)|0)|0;g=c[41340]|0;j=e;k=40296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[31664]=1;i=d;return}function gE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31800]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+192>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(31808,yT(c[(c[g>>2]|0)+192>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=40544;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[31800]=1;i=d;return}function hE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32024]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+188>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(32032,yT(c[(c[g>>2]|0)+188>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=40800;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[32024]=1;i=d;return}function iE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32248]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+172>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(32256,yT(c[(c[g>>2]|0)+172>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=41048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[32248]=1;i=d;return}function jE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32464]&1){i=d;return}g=b+420|0;if(!((yW(+(c[(c[g>>2]|0)+168>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=CT(32472,yT(c[(c[g>>2]|0)+168>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=41168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[32464]=1;i=d;return}function kE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32560]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1384>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1384>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(32568,wT(+h[(c[g>>2]|0)+1384>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[32560]=1;i=d;return}function lE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32704]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1376>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1376>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(32712,wT(+h[(c[g>>2]|0)+1376>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[32704]=1;i=d;return}function mE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32832]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(32840,wT(+h[(c[g>>2]|0)+1360>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[32832]=1;i=d;return}function nE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32936]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(32944,wT(+h[(c[g>>2]|0)+1352>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[32936]=1;i=d;return}function oE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33032]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1336>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(33040,wT(+h[(c[g>>2]|0)+1336>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[33032]=1;i=d;return}function pE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33136]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+164>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+164>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(33144,yT(c[(c[g>>2]|0)+164>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=33408;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[33136]=1;i=d;return}function qE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33432]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+160>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=CT(33440,yT(c[(c[g>>2]|0)+160>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=33640;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[33432]=1;i=d;return}function rE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33664]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1152>>3],1.0e-13)|0)<<24>>24==0)){i=d;return}b=CT(33672,wT(+h[(c[g>>2]|0)+1152>>3],28240)|0)|0;g=c[41340]|0;j=e;k=33744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[33664]=1;i=d;return}function sE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33768]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1144>>3],1.0e-13)|0)<<24>>24==0)){i=d;return}b=CT(33776,wT(+h[(c[g>>2]|0)+1144>>3],28240)|0)|0;g=c[41340]|0;j=e;k=33848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[33768]=1;i=d;return}function tE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33872]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(33880,wT(+h[(c[g>>2]|0)+1136>>3],28240)|0)|0;g=c[41340]|0;j=e;k=33952;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[33872]=1;i=d;return}function uE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33976]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(33984,wT(+h[(c[g>>2]|0)+1128>>3],28240)|0)|0;g=c[41340]|0;j=e;k=34056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[33976]=1;i=d;return}function vE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34080]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(34088,wT(+h[(c[g>>2]|0)+1112>>3],28240)|0)|0;g=c[41340]|0;j=e;k=34160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[34080]=1;i=d;return}function wE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34184]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1104>>3],1.0e-60)|0)<<24>>24==0)){i=d;return}b=CT(34192,wT(+h[(c[g>>2]|0)+1104>>3],28240)|0)|0;g=c[41340]|0;j=e;k=34264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[34184]=1;i=d;return}function xE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34288]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(34296,wT(+h[(c[g>>2]|0)+1096>>3],28240)|0)|0;g=c[41340]|0;j=e;k=34368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[34288]=1;i=d;return}function yE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34392]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+156>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(34400,yT(c[(c[g>>2]|0)+156>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=34600;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[34392]=1;i=d;return}function zE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34624]&1){i=d;return}g=b+420|0;if(!((yW(+(c[(c[g>>2]|0)+152>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=CT(34632,yT(c[(c[g>>2]|0)+152>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=34808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[34624]=1;i=d;return}function AE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34832]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+148>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(34840,yT(c[(c[g>>2]|0)+148>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=35160;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[34832]=1;i=d;return}function BE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35184]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+144>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=CT(35192,yT(c[(c[g>>2]|0)+144>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=35432;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[35184]=1;i=d;return}function CE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35456]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(35464,wT(+h[(c[g>>2]|0)+224>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[35456]=1;i=d;return}function DE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35632]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+216>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+216>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(35640,wT(+h[(c[g>>2]|0)+216>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[35632]=1;i=d;return}function EE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35768]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+208>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+208>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(35776,wT(+h[(c[g>>2]|0)+208>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[35768]=1;i=d;return}function FE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35904]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1024>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1024>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(35912,wT(+h[(c[g>>2]|0)+1024>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[35904]=1;i=d;return}function GE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36032]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+1016>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+1016>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(36040,wT(+h[(c[g>>2]|0)+1016>>3],28240)|0)|0;g=c[41340]|0;j=e;k=45120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[36032]=1;i=d;return}function HE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36184]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+140>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+140>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=CT(36192,yT(c[(c[g>>2]|0)+140>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=45384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[36184]=1;i=d;return}function IE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36440]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(36448,wT(+h[(c[g>>2]|0)+1008>>3],28240)|0)|0;g=c[41340]|0;j=e;k=42024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[36440]=1;i=d;return}function JE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36568]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(36576,wT(+h[(c[g>>2]|0)+168>>3],28240)|0)|0;g=c[41340]|0;j=e;k=36792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[36568]=1;i=d;return}function KE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36680]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(36688,wT(+h[(c[g>>2]|0)+160>>3],28240)|0)|0;g=c[41340]|0;j=e;k=36792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[36680]=1;i=d;return}function LE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36816]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(36824,wT(+h[(c[g>>2]|0)+984>>3],28240)|0)|0;g=c[41340]|0;j=e;k=36944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[36816]=1;i=d;return}function ME(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36968]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(36976,wT(+h[(c[g>>2]|0)+976>>3],28240)|0)|0;g=c[41340]|0;j=e;k=37096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[36968]=1;i=d;return}function NE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37120]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+968>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+968>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(37128,wT(+h[(c[g>>2]|0)+968>>3],28240)|0)|0;g=c[41340]|0;j=e;k=37304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[37120]=1;i=d;return}function OE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37328]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+124>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(37336,yT(c[(c[g>>2]|0)+124>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=37592;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[37328]=1;i=d;return}function PE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37616]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(37624,wT(+h[(c[g>>2]|0)+952>>3],28240)|0)|0;g=c[41340]|0;j=e;k=37736;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[37616]=1;i=d;return}function QE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37760]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(37768,wT(+h[(c[g>>2]|0)+928>>3],28240)|0)|0;g=c[41340]|0;j=e;k=37888;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[37760]=1;i=d;return}function RE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37912]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+912>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+912>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(37920,wT(+h[(c[g>>2]|0)+912>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[37912]=1;i=d;return}function SE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38104]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+904>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+904>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(38112,wT(+h[(c[g>>2]|0)+904>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[38104]=1;i=d;return}function TE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38296]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(38304,wT(+h[(c[g>>2]|0)+104>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[38296]=1;i=d;return}function UE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38440]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+96>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+96>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(38448,wT(+h[(c[g>>2]|0)+96>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[38440]=1;i=d;return}function VE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38608]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+880>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+880>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(38616,wT(+h[(c[g>>2]|0)+880>>3],28240)|0)|0;g=c[41340]|0;j=e;k=38752;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[38608]=1;i=d;return}function WE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38776]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+108>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+108>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(38784,yT(c[(c[g>>2]|0)+108>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=39e3;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[38776]=1;i=d;return}function XE(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39024]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+104>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+104>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(39032,yT(c[(c[g>>2]|0)+104>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=39264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[39024]=1;i=d;return}function YE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39288]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+88>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(39296,wT(+h[(c[g>>2]|0)+88>>3],28240)|0)|0;g=c[41340]|0;j=e;k=39392;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[39288]=1;i=d;return}function ZE(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39416]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+80>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+80>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(39424,wT(+h[(c[g>>2]|0)+80>>3],28240)|0)|0;g=c[41340]|0;j=e;k=39688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[39416]=1;i=d;return}function _E(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39552]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+72>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+72>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(39560,wT(+h[(c[g>>2]|0)+72>>3],28240)|0)|0;g=c[41340]|0;j=e;k=39688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[39552]=1;i=d;return}function $E(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39712]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+856>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+856>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(39720,wT(+h[(c[g>>2]|0)+856>>3],28240)|0)|0;g=c[41340]|0;j=e;k=39864;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[39712]=1;i=d;return}function aF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39888]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+96>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(39896,yT(c[(c[g>>2]|0)+96>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=40128;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[39888]=1;i=d;return}function bF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40152]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+848>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+848>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(40160,wT(+h[(c[g>>2]|0)+848>>3],28240)|0)|0;g=c[41340]|0;j=e;k=40296;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[40152]=1;i=d;return}function cF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40320]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+92>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+92>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(40328,yT(c[(c[g>>2]|0)+92>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=40544;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[40320]=1;i=d;return}function dF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40568]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+88>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(40576,yT(c[(c[g>>2]|0)+88>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=40800;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[40568]=1;i=d;return}function eF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40824]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+72>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(40832,yT(c[(c[g>>2]|0)+72>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=41048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[40824]=1;i=d;return}function fF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41072]&1){i=d;return}g=b+420|0;if(!((yW(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0)<<24>>24==0)){i=d;return}b=CT(41080,yT(c[(c[g>>2]|0)+68>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=41168;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[41072]=1;i=d;return}function gF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41192]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+840>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+840>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(41200,wT(+h[(c[g>>2]|0)+840>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[41192]=1;i=d;return}function hF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41360]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+832>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+832>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(41368,wT(+h[(c[g>>2]|0)+832>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[41360]=1;i=d;return}function iF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41512]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(41520,wT(+h[(c[g>>2]|0)+816>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[41512]=1;i=d;return}function jF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41640]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(41648,wT(+h[(c[g>>2]|0)+808>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41744;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[41640]=1;i=d;return}function kF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41768]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+792>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(41776,wT(+h[(c[g>>2]|0)+792>>3],28240)|0)|0;g=c[41340]|0;j=e;k=41872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[41768]=1;i=d;return}function lF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41896]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(41904,wT(+h[(c[g>>2]|0)+784>>3],28240)|0)|0;g=c[41340]|0;j=e;k=42024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[41896]=1;i=d;return}function mF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42048]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+64>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(42056,wT(+h[(c[g>>2]|0)+64>>3],28240)|0)|0;g=c[41340]|0;j=e;k=42152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[42048]=1;i=d;return}function nF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42176]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+56>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+56>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(42184,wT(+h[(c[g>>2]|0)+56>>3],28240)|0)|0;g=c[41340]|0;j=e;k=42448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[42176]=1;i=d;return}function oF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42312]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+48>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+48>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(42320,wT(+h[(c[g>>2]|0)+48>>3],28240)|0)|0;g=c[41340]|0;j=e;k=42448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[42312]=1;i=d;return}function pF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42472]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+60>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(42480,yT(c[(c[g>>2]|0)+60>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=42696;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[42472]=1;i=d;return}function qF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42720]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+56>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(42728,yT(c[(c[g>>2]|0)+56>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=42960;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[42720]=1;i=d;return}function rF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42984]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+760>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+760>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(42992,wT(+h[(c[g>>2]|0)+760>>3],28240)|0)|0;g=c[41340]|0;j=e;k=43112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[42984]=1;i=d;return}function sF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43136]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+52>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(43144,yT(c[(c[g>>2]|0)+52>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=43360;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[43136]=1;i=d;return}function tF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43384]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+48>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(43392,yT(c[(c[g>>2]|0)+48>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=43608;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[43384]=1;i=d;return}function uF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43632]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(43640,wT(+h[(c[g>>2]|0)+744>>3],28240)|0)|0;g=c[41340]|0;j=e;k=43816;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[43632]=1;i=d;return}function vF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43840]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(43848,wT(+h[(c[g>>2]|0)+736>>3],28240)|0)|0;g=c[41340]|0;j=e;k=43944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[43840]=1;i=d;return}function wF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43968]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+728>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+728>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(43976,wT(+h[(c[g>>2]|0)+728>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[43968]=1;i=d;return}function xF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44144]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+720>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+720>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(44152,wT(+h[(c[g>>2]|0)+720>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[44144]=1;i=d;return}function yF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44312]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+712>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+712>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(44320,wT(+h[(c[g>>2]|0)+712>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[44312]=1;i=d;return}function zF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44464]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+40>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(44472,wT(+h[(c[g>>2]|0)+40>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44560;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[44464]=1;i=d;return}function AF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44584]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+32>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+32>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(44592,wT(+h[(c[g>>2]|0)+32>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[44584]=1;i=d;return}function BF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44704]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+24>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+24>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(44712,wT(+h[(c[g>>2]|0)+24>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44824;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[44704]=1;i=d;return}function CF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44848]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+704>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+704>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(44856,wT(+h[(c[g>>2]|0)+704>>3],28240)|0)|0;g=c[41340]|0;j=e;k=44960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[44848]=1;i=d;return}function DF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44984]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+696>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+696>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(44992,wT(+h[(c[g>>2]|0)+696>>3],28240)|0)|0;g=c[41340]|0;j=e;k=45120;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[44984]=1;i=d;return}function EF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45144]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+40>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=CT(45152,yT(c[(c[g>>2]|0)+40>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=45384;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[45144]=1;i=d;return}function FF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45408]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+32>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(45416,yT(c[(c[g>>2]|0)+32>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=45704;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[45408]=1;i=d;return}function GF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45728]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+28>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(45736,yT(c[(c[g>>2]|0)+28>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=45968;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[45728]=1;i=d;return}function HF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45992]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+24>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(46e3,yT(c[(c[g>>2]|0)+24>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=46216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[45992]=1;i=d;return}function IF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46240]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(46248,wT(+h[(c[g>>2]|0)+688>>3],28240)|0)|0;g=c[41340]|0;j=e;k=46336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[46240]=1;i=d;return}function JF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46360]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(46368,wT(+h[(c[g>>2]|0)+680>>3],28240)|0)|0;g=c[41340]|0;j=e;k=46456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[46360]=1;i=d;return}function KF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46480]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(46488,wT(+h[(c[g>>2]|0)+672>>3],28240)|0)|0;g=c[41340]|0;j=e;k=46584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[46480]=1;i=d;return}function LF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46608]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(46616,wT(+h[(c[g>>2]|0)+664>>3],28240)|0)|0;g=c[41340]|0;j=e;k=46704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[46608]=1;i=d;return}function MF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46728]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(46736,wT(+h[(c[g>>2]|0)+656>>3],28240)|0)|0;g=c[41340]|0;j=e;k=46832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[46728]=1;i=d;return}function NF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46856]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+20>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(46864,yT(c[(c[g>>2]|0)+20>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=47088;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[46856]=1;i=d;return}function OF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47112]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+16>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=CT(47120,yT(c[(c[g>>2]|0)+16>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=47336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[47112]=1;i=d;return}function PF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47360]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(47368,wT(+h[(c[g>>2]|0)+624>>3],28240)|0)|0;g=c[41340]|0;j=e;k=47464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[47360]=1;i=d;return}function QF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47488]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(47496,wT(+h[(c[g>>2]|0)+616>>3],28240)|0)|0;g=c[41340]|0;j=e;k=47592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[47488]=1;i=d;return}function RF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47616]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+16>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(47624,wT(+h[(c[g>>2]|0)+16>>3],28240)|0)|0;g=c[41340]|0;j=e;k=47712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[47616]=1;i=d;return}function SF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47736]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+8>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(47744,wT(+h[(c[g>>2]|0)+8>>3],28240)|0)|0;g=c[41340]|0;j=e;k=47976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[47736]=1;i=d;return}function TF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47856]&1){i=d;return}g=b+416|0;b=yW(+h[c[g>>2]>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[c[g>>2]>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(47864,wT(+h[c[g>>2]>>3],28240)|0)|0;g=c[41340]|0;j=e;k=47976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[47856]=1;i=d;return}function UF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48e3]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+608>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+608>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(48008,wT(+h[(c[g>>2]|0)+608>>3],28240)|0)|0;g=c[41340]|0;j=e;k=48136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[48e3]=1;i=d;return}function VF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48160]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+600>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+600>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(48168,wT(+h[(c[g>>2]|0)+600>>3],28240)|0)|0;g=c[41340]|0;j=e;k=48280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[48160]=1;i=d;return}function WF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48304]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+592>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+592>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(48312,wT(+h[(c[g>>2]|0)+592>>3],28240)|0)|0;g=c[41340]|0;j=e;k=48424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[48304]=1;i=d;return}function XF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48448]&1){i=d;return}g=b+416|0;b=yW(+h[(c[g>>2]|0)+584>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[g>>2]|0)+584>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(48456,wT(+h[(c[g>>2]|0)+584>>3],28240)|0)|0;g=c[41340]|0;j=e;k=48568;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[48448]=1;i=d;return}function YF(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48592]&1){i=d;return}g=b+420|0;b=yW(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(wW(+(c[(c[g>>2]|0)+8>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=CT(48600,yT(c[(c[g>>2]|0)+8>>2]|0,29176)|0)|0;g=c[41340]|0;h=e;j=48832;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ke[g&15](e,b,f);a[48592]=1;i=d;return}function ZF(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48856]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4008>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4008>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(48864,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4008>>3],28240)|0)|0;g=c[41340]|0;j=e;k=49808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[48856]=1;i=d;return}function _F(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49008]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4e3>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4e3>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(49016,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+4e3>>3],28240)|0)|0;g=c[41340]|0;j=e;k=49808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[49008]=1;i=d;return}function $F(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49160]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(49168,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3208>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[49160]=1;i=d;return}function aG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49288]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3200>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3200>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(49296,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3200>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[49288]=1;i=d;return}function bG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49464]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3992>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3992>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(49472,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3992>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[49464]=1;i=d;return}function cG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49648]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(49656,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3984>>3],28240)|0)|0;g=c[41340]|0;j=e;k=49808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[49648]=1;i=d;return}function dG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49832]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(49840,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2912>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[49832]=1;i=d;return}function eG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49960]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(49968,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2904>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[49960]=1;i=d;return}function fG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50128]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3952>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3952>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(50136,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3952>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[50128]=1;i=d;return}function gG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50312]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(50320,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3944>>3],28240)|0)|0;g=c[41340]|0;j=e;k=50416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[50312]=1;i=d;return}function hG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50440]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3920>>3],.001)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3920>>3],.25)|0)<<24>>24==0)){i=d;return}b=CT(50448,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3920>>3],28240)|0)|0;g=c[41340]|0;j=e;k=52096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[50440]=1;i=d;return}function iG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50656]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(50664,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2896>>3],28240)|0)|0;g=c[41340]|0;j=e;k=52272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[50656]=1;i=d;return}function jG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50800]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3912>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3912>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(50808,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3912>>3],28240)|0)|0;g=c[41340]|0;j=e;k=50944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[50800]=1;i=d;return}function kG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50968]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3904>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3904>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(50976,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3904>>3],28240)|0)|0;g=c[41340]|0;j=e;k=51104;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[50968]=1;i=d;return}function lG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51128]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],.001)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],.25)|0)<<24>>24==0)){i=d;return}b=CT(51136,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3896>>3],28240)|0)|0;g=c[41340]|0;j=e;k=52096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[51128]=1;i=d;return}function mG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51264]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(51272,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2888>>3],28240)|0)|0;g=c[41340]|0;j=e;k=52272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[51264]=1;i=d;return}function nG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51408]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2816>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2816>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(51416,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2816>>3],28240)|0)|0;g=c[41340]|0;j=e;k=51576;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[51408]=1;i=d;return}function oG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51600]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2784>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(51608,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2784>>3],28240)|0)|0;g=c[41340]|0;j=e;k=51768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[51600]=1;i=d;return}function pG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51792]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2712>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2712>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(51800,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2712>>3],28240)|0)|0;g=c[41340]|0;j=e;k=52448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[51792]=1;i=d;return}function qG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51944]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],.001)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],.25)|0)<<24>>24==0)){i=d;return}b=CT(51952,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3888>>3],28240)|0)|0;g=c[41340]|0;j=e;k=52096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[51944]=1;i=d;return}function rG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52120]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(52128,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2704>>3],28240)|0)|0;g=c[41340]|0;j=e;k=52272;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[52120]=1;i=d;return}function sG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52296]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(52304,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2688>>3],28240)|0)|0;g=c[41340]|0;j=e;k=52448;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[52296]=1;i=d;return}function tG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52472]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3880>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3880>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(52480,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3880>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[52472]=1;i=d;return}function uG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52712]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(52720,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3872>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[52712]=1;i=d;return}function vG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52864]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(52872,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3864>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[52864]=1;i=d;return}function wG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53040]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(53048,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3856>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[53040]=1;i=d;return}function xG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53224]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(53232,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3848>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53400;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[53224]=1;i=d;return}function yG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53424]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(53432,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3840>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[53424]=1;i=d;return}function zG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53560]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(53568,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3832>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[53560]=1;i=d;return}function AG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53720]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(53728,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2616>>3],28240)|0)|0;g=c[41340]|0;j=e;k=53848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[53720]=1;i=d;return}function BG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53872]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2608>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2608>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(53880,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2608>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[53872]=1;i=d;return}function CG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54064]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(54072,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3808>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[54064]=1;i=d;return}function DG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54272]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(54280,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2384>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[54272]=1;i=d;return}function EG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54448]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(54456,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2376>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54608;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[54448]=1;i=d;return}function FG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54632]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2344>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(54640,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2344>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[54632]=1;i=d;return}function GG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54816]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(54824,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3792>>3],28240)|0)|0;g=c[41340]|0;j=e;k=54960;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[54816]=1;i=d;return}function HG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54984]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(54992,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3784>>3],28240)|0)|0;g=c[41340]|0;j=e;k=55128;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[54984]=1;i=d;return}function IG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55152]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3776>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3776>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(55160,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3776>>3],28240)|0)|0;g=c[41340]|0;j=e;k=55312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[55152]=1;i=d;return}function JG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55336]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3768>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3768>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(55344,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3768>>3],28240)|0)|0;g=c[41340]|0;j=e;k=55488;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[55336]=1;i=d;return}function KG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55512]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3760>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3760>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=CT(55520,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3760>>3],28240)|0)|0;g=c[41340]|0;j=e;k=55656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[55512]=1;i=d;return}function LG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55680]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3752>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(55688,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3752>>3],28240)|0)|0;g=c[41340]|0;j=e;k=55832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[55680]=1;i=d;return}function MG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55856]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3744>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3744>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(55864,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3744>>3],28240)|0)|0;g=c[41340]|0;j=e;k=56e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[55856]=1;i=d;return}



function ew(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+184>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+184|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+184>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+168>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+168|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+168>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+8>>3]=k;SW(a,3)|0;j=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+184>>3]=+h[j>>3];h[f+168>>3]=+h[j+8>>3];Qn(a);Rn(a);Sn(a);Tn(a);Un(a);Vn(a);i=b;return}function fw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;dn(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+152>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3464>>3]=+xd(+(+h[d>>3]),+(+h[a+160>>3]*.999));i=b;return}function gw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3464>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,25904,25896,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3472>>3]=m*.6219647130774989;i=d;return}function hw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+160>>3];k=+h[g+136>>3];l=+h[g+3464>>3]*(k+ +h[g+1912>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3504|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3504|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,25968,25960,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3504|0;r=q;h[r>>3]=o;i=d;return}function iw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3464>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));l=+h[g+1912>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,25904,26064,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3480>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function jw(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3496>>3]=+yd(+(+h[d+136>>3]- +h[d+3480>>3]),0.0);i=b;return}function kw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3488>>3]=+h[b+136>>3]- +h[b+3496>>3];i=i;return}function lw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3496>>3];k=1.0-j;l=+h[g+1912>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,26080,26072,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3496>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3488>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3528|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3528|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,26080,26072,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3528|0;z=y;h[z>>3]=w;i=d;return}function mw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+152>>3]*+h[g+3528>>3];k=+h[g+160>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,26120,26112,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3544|0;p=o;h[p>>3]=m;i=d;return}function nw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=+h[(c[a+416>>2]|0)+752>>3]*+h[b+3544>>3];i=i;return}function ow(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+128>>3]=+h[(c[a+416>>2]|0)+64>>3]*+h[b+3576>>3]*658.3278472679394;i=i;return}function pw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1968>>3]=+h[b+128>>3]*.001519;i=i;return}function qw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3576>>3];k=+h[g+1960>>3]- +h[g+136>>3]*+h[g+3568>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,26168,26160,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+304|0;p=o;h[p>>3]=m;i=d;return}function rw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2120>>3]=-+h[b+304>>3];i=i;return}function sw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3576>>3];k=+h[g+1968>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+1984|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+1984|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,26168,26184,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+1984|0;p=o;h[p>>3]=m;i=d;return}function tw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0;d=i;e=b+4|0;f=(xW(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+944>>3],0.0)|0)<<24>>24==0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;do{if(f){k=j;l=+h[j+1984>>3]}else{m=+yd(+(+h[j+944>>3]),1.0e-15);n=m+1.0e-15;o=m*+h[j+1040>>3];if(n!=0.0){k=j;l=o/n;break}if(o==0.0){k=j;l=o;break}m=o/+XS(c[b+536>>2]|0,n,25392,26192,+h[g>>3],(a[b+319|0]|0)!=0|0);k=c[(c[c[e>>2]>>2]|0)+8>>2]|0;l=m}}while(0);h[k+2728>>3]=l*+h[k+944>>3];i=d;return}function uw(a){a=a|0;var b=0,d=0,e=0,f=0.0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3344>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=+h[e+1984>>3]}else{f=100.0}h[e+2736>>3]=f*+h[e+3344>>3];i=b;return}function vw(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(-+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+1688>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+2744>>3]=-(+h[(a?e+1984|0:e+1792|0)>>3]*+h[e+1688>>3]);i=b;return}function ww(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+2728>>3]+(+h[b+2736>>3]+ +h[b+2744>>3]);i=i;return}function xw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=+h[b+1952>>3]/.001519;i=i;return}function yw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0,q=0,r=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+944>>3];k=+yd(+-j,1.0e-15);l=+yd(+j,1.0e-15);j=k+l;m=k*+h[g+1984>>3]+l*+h[g+1040>>3];if(j!=0.0){n=g;o=m/j;p=n;q=p+336|0;r=q;h[r>>3]=o;i=d;return}if(m==0.0){n=g;o=m;p=n;q=p+336|0;r=q;h[r>>3]=o;i=d;return}l=m/+XS(c[b+536>>2]|0,j,26208,26200,+h[f>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[e>>2]>>2]|0)+8>>2]|0;o=l;p=n;q=p+336|0;r=q;h[r>>3]=o;i=d;return}function zw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+944>>3];if(j>=0.0){k=g;l=j*+h[g+1040>>3];m=k;n=m+896|0;o=n;h[o>>3]=l;i=d;return}p=+yd(+-j,1.0e-15);q=p+1.0e-15;r=p*+h[g+1984>>3];do{if(q!=0.0){s=j;t=g;u=r/q}else{if(r==0.0){s=j;t=g;u=r;break}p=r/+XS(c[b+536>>2]|0,q,25560,26272,+h[f>>3],(a[b+319|0]|0)!=0|0);v=c[(c[c[e>>2]>>2]|0)+8>>2]|0;s=+h[v+944>>3];t=v;u=p}}while(0);k=t;l=u*s;m=k;n=m+896|0;o=n;h[o>>3]=l;i=d;return}function Aw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=+h[b+888>>3]- +h[b+896>>3];i=i;return}function Bw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+992>>3]/.001519;i=i;return}function Cw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3336>>3]=+h[(c[a+416>>2]|0)+1080>>3]*+h[b+1984>>3];i=i;return}function Dw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3296>>3]=+h[(c[a+416>>2]|0)+1088>>3]- +h[b+3336>>3];i=i;return}function Ew(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3320>>3]=+h[b+1232>>3]*+h[b+1088>>3]+ +h[b+1240>>3]*+h[d+3336>>3];i=i;return}function Fw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3312>>3]=+h[(c[a+416>>2]|0)+1184>>3]*+h[b+3320>>3];i=i;return}function Gw(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3304>>3]=+h[b+1192>>3]*+h[d+3312>>3]+(+h[b+1200>>3]*+h[b+1312>>3]+ +h[b+1208>>3]*+h[d+144>>3]);i=i;return}function Hw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3272>>3]=+h[(c[a+416>>2]|0)+1216>>3]*+h[b+3304>>3];i=i;return}function Iw(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=a+416|0;do{if((xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3272>>3],+h[(c[e>>2]|0)+1320>>3])|0)<<24>>24==0){if((vW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3272>>3],+h[(c[e>>2]|0)+1328>>3])|0)<<24>>24==0){f=(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3272|0;break}else{f=(c[e>>2]|0)+1328|0;break}}else{f=(c[e>>2]|0)+1320|0}}while(0);h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3328>>3]=+h[f>>3];i=b;return}function Jw(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3264>>3]=+h[b+1288>>3]*+h[d+3328>>3]+ +h[b+1296>>3]*+h[d+3272>>3];i=i;return}function Kw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3280>>3]=+h[(c[a+416>>2]|0)+1304>>3]*+h[b+3264>>3];i=i;return}function Lw(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3288>>3]=+h[b+1264>>3]*+h[b+1088>>3]+(+h[b+1272>>3]*+h[d+3336>>3]+ +h[b+1280>>3]*+h[d+3280>>3]);i=i;return}function Mw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=+h[(c[a+416>>2]|0)+1248>>3]*+h[b+3288>>3];i=i;return}function Nw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[(c[a+416>>2]|0)+1072>>3]*+h[b+3328>>3];i=i;return}function Ow(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3256>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3256|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3256>>3]);h[c[(c[f>>2]|0)+372>>2]>>3]=k;SW(a,4)|0;h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+3256>>3]=+h[c[(c[f>>2]|0)+364>>2]>>3];Yn(a);Zn(a);_n(a);$n(a);ao(a);bo(a);i=b;return}function Pw(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+928>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+784>>3]=+h[(a?e+816|0:e+808|0)>>3];i=b;return}function Qw(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+928>>3];h[b+856>>3]=d*+h[(!(d>=0.0)?b+592|0:b+3672|0)>>3];i=i;return}function Rw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+856>>3]- +h[b+864>>3];i=i;return}function Sw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3592>>3]=+h[b+3256>>3]*1.0e-5;i=i;return}function Tw(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;Jm(d,c[a+536>>2]|0,293.15);e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3600>>3]=+xd(+(+h[d>>3]),+(+h[e+3256>>3]*.999));i=b;return}function Uw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3600>>3];k=+h[g+3256>>3];do{if(j!=0.0){l=g;m=k/j}else{if(k==0.0){l=g;m=k;break}n=k/+XS(c[b+536>>2]|0,j,26288,26280,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3640>>3]=m*.01598094902253916;i=d;return}function Vw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3600>>3];k=+yd(1.0e-13,+(+h[g+3256>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,26328,26320,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3608>>3]=m*.6219647130774989;i=d;return}function Ww(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3600>>3];k=+yd(1.0e-13,+(+h[g+3256>>3]-j));if(k!=0.0){l=k;m=g;n=.99/l;o=j*n;p=o*.6219647130774989;q=+xd(+p,1.0);r=m;s=r+3616|0;t=s;h[t>>3]=q;i=d;return}u=+XS(c[b+536>>2]|0,k,26328,26392,+h[f>>3],(a[b+319|0]|0)!=0|0);l=u;m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=.99/l;o=j*n;p=o*.6219647130774989;q=+xd(+p,1.0);r=m;s=r+3616|0;t=s;h[t>>3]=q;i=d;return}function Xw(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3632>>3]=+yd(+(.01- +h[d+3616>>3]),0.0);i=b;return}function Yw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=.01- +h[b+3632>>3];i=i;return}function Zw(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0,u=0,v=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3632>>3];k=1.0-j;if(k!=0.0){l=k;m=j;n=g;o=f}else{j=+XS(c[b+536>>2]|0,k,26408,26400,+h[f>>3],(a[b+319|0]|0)!=0|0);f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;l=j;m=+h[g+3632>>3];n=g;o=f}j=284.1807127034489/l;l=1.0-m;m=+h[n+3624>>3];if(l!=0.0){p=n;q=m/l;r=q*461.5233290850878;s=j+r;t=p;u=t+3648|0;v=u;h[v>>3]=s;i=d;return}if(m==0.0){p=n;q=m;r=q*461.5233290850878;s=j+r;t=p;u=t+3648|0;v=u;h[v>>3]=s;i=d;return}k=m/+XS(c[b+536>>2]|0,l,26408,26400,+h[o>>3],(a[b+319|0]|0)!=0|0);p=c[(c[c[e>>2]>>2]|0)+8>>2]|0;q=k;r=q*461.5233290850878;s=j+r;t=p;u=t+3648|0;v=u;h[v>>3]=s;i=d;return}function _w(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3648>>3]*293.15;k=+h[g+3256>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3664|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3664|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,26448,26440,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3664|0;p=o;h[p>>3]=m;i=d;return}function $w(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3656>>3]=+h[b+3672>>3]+ +h[b+3648>>3]*-293.15;i=i;return}function ax(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0;d=i;i=i+120|0;e=d;f=d+32|0;g=d+48|0;j=d+80|0;k=d+112|0;l=b+536|0;m=c[l>>2]|0;n=b+4|0;o=c[(c[c[n>>2]>>2]|0)+8>>2]|0;p=+h[o+3256>>3];q=+h[o+1152>>3];o=f;r=26488;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];c[o+8>>2]=c[r+8>>2];im(j,m,p,q,f);f=g;m=j;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];m=c[l>>2]|0;f=e;j=g;c[f+0>>2]=c[j+0>>2];c[f+4>>2]=c[j+4>>2];c[f+8>>2]=c[j+8>>2];c[f+12>>2]=c[j+12>>2];c[f+16>>2]=c[j+16>>2];c[f+20>>2]=c[j+20>>2];c[f+24>>2]=c[j+24>>2];c[f+28>>2]=c[j+28>>2];mm(k,m,e);e=c[b+416>>2]|0;q=+h[k>>3]*+h[e+1336>>3]*+h[e+496>>3];e=c[c[n>>2]>>2]|0;k=c[e+8>>2]|0;p=+h[k+928>>3];if(q!=0.0){s=k;t=p/q;u=s;v=u+848|0;w=v;h[w>>3]=t;i=d;return}if(p==0.0){s=k;t=p;u=s;v=u+848|0;w=v;h[w>>3]=t;i=d;return}x=p/+XS(c[l>>2]|0,q,26504,26480,+h[e>>3],(a[b+319|0]|0)!=0|0);s=c[(c[c[n>>2]>>2]|0)+8>>2]|0;t=x;u=s;v=u+848|0;w=v;h[w>>3]=t;i=d;return}function bx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+848>>3],+h[f+808>>3],+h[f+752>>3],+h[(c[a+416>>2]|0)+512>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+648>>3]=+h[d>>3];i=b;return}function cx(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=(xW(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+928>>3],0.0)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[e+728>>3]=+h[(a?e+760|0:e+752|0)>>3];i=b;return}function dx(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+600>>3]=+h[b+1440>>3]*+h[b+512>>3]*+h[d+728>>3]*+h[b+1464>>3]*.7853981633974483;i=i;return}function ex(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+928>>3];if(!(d>=0.0)){e=b+1032|0}else{e=(c[a+416>>2]|0)+576|0}h[b+880>>3]=d*+h[e>>3];i=i;return}function fx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+984>>3]=+h[b+880>>3]- +h[b+888>>3];i=i;return}function gx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+984>>3]/.001519;i=i;return}function hx(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+928>>3];if(!(d>=0.0)){e=+h[b+32>>3]}else{e=.01}h[b+904>>3]=d*e;i=i;return}function ix(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[b+904>>3]- +h[b+912>>3];i=i;return}function jx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+928>>3]- +h[b+936>>3];i=i;return}function kx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1080>>3];k=+h[g+1e3>>3]- +h[g+32>>3]*+h[g+1016>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,26736,26728,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+200|0;p=o;h[p>>3]=m;i=d;return}function lx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=-+h[b+200>>3];i=i;return}function mx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3120>>3];k=+h[g+1016>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2296|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2296|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,26760,26752,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2296|0;p=o;h[p>>3]=m;i=d;return}function nx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[e+1336>>3]*+h[j+584>>3]*+h[e+496>>3];l=+h[j+928>>3]+ +h[j+936>>3];if(k!=0.0){m=j;n=l/k;o=n*.5;p=m;q=p+360|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=j;n=l;o=n*.5;p=m;q=p+360|0;r=q;h[r>>3]=o;i=d;return}s=l/+XS(c[b+536>>2]|0,k,26792,26784,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=s;o=n*.5;p=m;q=p+360|0;r=q;h[r>>3]=o;i=d;return}function ox(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+952>>3]=+h[b+360>>3]*+h[d+496>>3]*+h[d+1336>>3]*((+h[b+16>>3]- +h[b+3256>>3])/1.5+(+h[b+624>>3]+ +h[b+632>>3]*.5));i=i;return}function px(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2104>>3]=+h[b+968>>3]+ +h[b+952>>3];i=i;return}function qx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+1080>>3];k=+h[g+2104>>3]- +h[g+1016>>3]*+h[g+576>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+2040|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+2040|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,26736,26856,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+2040|0;p=o;h[p>>3]=m;i=d;return}function rx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+208>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+208|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+208>>3]);e=c[f>>2]|0;h[c[e+452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+192>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+192|0;h[(c[e+448>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+192>>3]);h[(c[(c[f>>2]|0)+452>>2]|0)+8>>3]=k;SW(a,5)|0;j=c[(c[f>>2]|0)+444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+208>>3]=+h[j>>3];h[f+192>>3]=+h[j+8>>3];fo(a);go(a);ho(a);io(a);jo(a);ko(a);i=b;return}function sx(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;Nl(d,c[a+536>>2]|0,+h[f+360>>3],+h[f+816>>3],+h[f+760>>3],+h[(c[a+416>>2]|0)+512>>3]);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+656>>3]=+h[d>>3];i=b;return}function tx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+704>>3]=+h[b+928>>3]*+h[b+3136>>3];i=i;return}function ux(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+1688>>3];h[b+1640>>3]=d*+h[(!(d>=0.0)?b+1792|0:b+1984|0)>>3];i=i;return}function vx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1744>>3]=+h[b+1640>>3]- +h[b+1648>>3];i=i;return}function wx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+1744>>3]/.001519;i=i;return}function xx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[b+136>>3]*+h[b+3576>>3];i=i;return}function yx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3536>>3]=+h[b+3552>>3]- +h[b+3528>>3]*+h[b+152>>3];i=i;return}function zx(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3576>>3];k=+h[g+3560>>3]- +h[g+3568>>3]*+h[g+3536>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,26168,26864,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3680|0;p=o;h[p>>3]=m;i=d;return}function Ax(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+320>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+320|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+UW(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+320>>3]);e=c[f>>2]|0;h[c[e+532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+328>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+328|0;h[(c[e+528>>2]|0)+8>>3]=+h[g>>3];k=+UW(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+328>>3]);h[(c[(c[f>>2]|0)+532>>2]|0)+8>>3]=k;SW(a,6)|0;j=c[(c[f>>2]|0)+524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+320>>3]=+h[j>>3];h[f+328>>3]=+h[j+8>>3];no(a);oo(a);po(a);qo(a);ro(a);so(a);i=b;return}function Bx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3584>>3]=+h[b+3576>>3]*+h[b+3536>>3];i=i;return}function Cx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1008>>3]=+h[b+624>>3];i=i;return}function Dx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1e3>>3]=+h[b+792>>3];i=i;return}function Ex(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+47|0]=a[d+33|0]|0;i=i;return}function Fx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+624>>3];i=i;return}function Gx(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+27|0]=a[d+22|0]|0;i=i;return}function Hx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+W(+(+h[b+752>>3]*.75),.6666666666666666)*3.141592653589793;i=i;return}function Ix(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+728>>3]=+h[b+648>>3];i=i;return}function Jx(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+736>>3]=+h[b+656>>3]*+h[b+728>>3];i=i;return}function Kx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=0.0;i=i;return}function Lx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3240>>3]=0.0;i=i;return}function Mx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3232>>3]=0.0;i=i;return}function Nx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3224>>3]=0.0;i=i;return}function Ox(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3216>>3]=0.0;i=i;return}function Px(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4008>>3]=0.0;i=i;return}function Qx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4e3>>3]=0.0;i=i;return}function Rx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3208>>3]=0.0;i=i;return}function Sx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=.01;i=i;return}function Tx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3992>>3]=45263.2387446934;i=i;return}function Ux(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3984>>3]=0.0;i=i;return}function Vx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3184>>3]=.01;i=i;return}function Wx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3176>>3]=0.0;i=i;return}function Xx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3168>>3]=0.0;i=i;return}function Yx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3160>>3]=0.0;i=i;return}function Zx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=0.0;i=i;return}function _x(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=0.0;i=i;return}function $x(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3096>>3]=0.0;i=i;return}function ay(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3080>>3]=.01;i=i;return}function by(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=100.0;i=i;return}function cy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3976>>3]=293.15;i=i;return}function dy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=0.0;i=i;return}function ey(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=0.0;i=i;return}function fy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=0.0;i=i;return}function gy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3e3>>3]=0.0;i=i;return}function hy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=0.0;i=i;return}function iy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=0.0;i=i;return}function jy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=0.0;i=i;return}function ky(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=0.0;i=i;return}function ly(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=0.0;i=i;return}function my(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=0.0;i=i;return}function ny(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=0.0;i=i;return}function oy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=0.0;i=i;return}function py(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=0.0;i=i;return}function qy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=0.0;i=i;return}function ry(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3968>>3]=0.0;i=i;return}function sy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3960>>3]=293.15;i=i;return}function ty(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2912>>3]=0.0;i=i;return}function uy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=.01;i=i;return}function vy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3]=45263.2387446934;i=i;return}function wy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3944>>3]=0.0;i=i;return}function xy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3936>>3]=20.0;i=i;return}function yy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3928>>3]=20.0;i=i;return}function zy(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[c[b+416>>2]>>3];f=e/.01801528-e/.0289651159+34.52428788658843;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+XS(c[b+536>>2]|0,f,26880,26872,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3920>>3]=1.0/j;i=d;return}function Ay(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3896>>3]=.02879012713067693;i=i;return}function By(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2888>>3]=.99;i=i;return}function Cy(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+4|0]=1;i=i;return}function Dy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=0.0;i=i;return}function Ey(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+5|0]=1;i=i;return}function Fy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function Gy(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+6|0]=1;i=i;return}function Hy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function Iy(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+7|0]=1;i=i;return}function Jy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=0.0;i=i;return}function Ky(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=0.0;i=i;return}function Ly(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=0.0;i=i;return}function My(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=0.0;i=i;return}function Ny(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2752>>3]=0.0;i=i;return}function Oy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3888>>3]=.02879012713067693;i=i;return}function Py(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=.99;i=i;return}function Qy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=.99;i=i;return}function Ry(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3880>>3]=.0101010101010101;i=i;return}function Sy(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+3|0]=0;i=i;return}function Ty(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function Uy(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+2|0]=0;i=i;return}function Vy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=0.0;i=i;return}function Wy(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+1|0]=0;i=i;return}function Xy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=0.0;i=i;return}function Yy(b){b=b|0;a[c[(c[c[b+4>>2]>>2]|0)+16>>2]|0]=0;i=i;return}function Zy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3872>>3]=.0101010101010101;i=i;return}function _y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=.99;i=i;return}function $y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2616>>3]=0.0;i=i;return}function az(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2608>>3]=.01;i=i;return}function bz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3808>>3]=45263.2387446934;i=i;return}function cz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=1.0e+60;i=i;return}function dz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=1.0;i=i;return}function ez(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=1.0e+60;i=i;return}function fz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=1.0;i=i;return}function gz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=1.0e+60;i=i;return}function hz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=1.0;i=i;return}function iz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=1.0e+60;i=i;return}function jz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=1.0;i=i;return}function kz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=0.0;i=i;return}function lz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=0.0;i=i;return}function mz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=0.0;i=i;return}function nz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=0.0;i=i;return}function oz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2488>>3]=0.0;i=i;return}function pz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2480>>3]=0.0;i=i;return}function qz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2472>>3]=0.0;i=i;return}function rz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2464>>3]=0.0;i=i;return}function sz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2456>>3]=0.0;i=i;return}function tz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2448>>3]=0.0;i=i;return}function uz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2440>>3]=0.0;i=i;return}function vz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2432>>3]=0.0;i=i;return}function wz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2400>>3]=0.0;i=i;return}function xz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2408>>3]=0.0;i=i;return}function yz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2416>>3]=0.0;i=i;return}function zz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2424>>3]=0.0;i=i;return}function Az(a){a=a|0;var b=0.0;b=+W(+(+h[(c[a+416>>2]|0)+752>>3]*.238732414637843),.6666666666666666)*12.56637061435917;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2392>>3]=b;i=i;return}function Bz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3192>>3]=.99;i=i;return}function Cz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=i;i=i+8|0;h=b+420|0;c[(c[h>>2]|0)+232>>2]=-1;do{if((Hp(1)|0)==0){j=-1.0}else{pn(g,c[b+536>>2]|0,20648,c[(c[b+428>>2]|0)+16>>2]|0,1);if((a[g]|0)!=0){c[(c[h>>2]|0)+232>>2]=1}if((Hp(2)|0)==0){j=+(c[(c[h>>2]|0)+232>>2]|0);break}else{cb(20656,20688,7408,26960)}}}while(0);if(!((xW(j,0.0)|0)<<24>>24==0)){i=d;return}h=CT(CT(CT(CT(CT(20840,c[(c[b+428>>2]|0)+16>>2]|0)|0,20864)|0,20896)|0,20912)|0,20920)|0;g=c[b+536>>2]|0;b=c[41338]|0;k=e;l=27200;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];Oe[b&63](g,e,h,f);i=d;return}function Dz(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=i;i=i+8|0;h=b+420|0;c[(c[h>>2]|0)+132>>2]=-1;do{if((Hp(1)|0)==0){j=-1.0}else{pn(g,c[b+536>>2]|0,20648,c[(c[b+428>>2]|0)+4>>2]|0,1);if((a[g]|0)!=0){c[(c[h>>2]|0)+132>>2]=1}if((Hp(2)|0)==0){j=+(c[(c[h>>2]|0)+132>>2]|0);break}else{cb(20656,20688,7486,27040)}}}while(0);if(!((xW(j,0.0)|0)<<24>>24==0)){i=d;return}h=CT(CT(CT(CT(CT(20840,c[(c[b+428>>2]|0)+4>>2]|0)|0,20864)|0,20896)|0,20912)|0,20920)|0;g=c[b+536>>2]|0;b=c[41338]|0;k=e;l=27200;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];Oe[b&63](g,e,h,f);i=d;return}function Ez(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0.0,k=0,l=0;d=i;i=i+32|0;e=d;f=d+24|0;g=i;i=i+8|0;h=b+420|0;c[(c[h>>2]|0)+12>>2]=-1;do{if((Hp(1)|0)==0){j=-1.0}else{pn(g,c[b+536>>2]|0,20648,c[c[b+428>>2]>>2]|0,1);if((a[g]|0)!=0){c[(c[h>>2]|0)+12>>2]=1}if((Hp(2)|0)==0){j=+(c[(c[h>>2]|0)+12>>2]|0);break}else{cb(20656,20688,7564,27120)}}}while(0);if(!((xW(j,0.0)|0)<<24>>24==0)){i=d;return}h=CT(CT(CT(CT(CT(20840,c[c[b+428>>2]>>2]|0)|0,20864)|0,20896)|0,20912)|0,20920)|0;g=c[b+536>>2]|0;b=c[41338]|0;k=e;l=27200;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];c[k+12>>2]=c[l+12>>2];c[k+16>>2]=c[l+16>>2];c[k+20>>2]=c[l+20>>2];Oe[b&63](g,e,h,f);i=d;return}function Fz(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);bt(b);ct(b);dt(b);et(b);ft(b);gt(b);ht(b);it(b);jt(b);kt(b);lt(b);mt(b);nt(b);ot(b);pt(b);qt(b);rt(b);st(b);tt(b);ut(b);vt(b);wt(b);xt(b);yt(b);zt(b);At(b);Bt(b);Ct(b);Dt(b);Et(b);Ft(b);Gt(b);Ht(b);It(b);Jt(b);Kt(b);Lt(b);Mt(b);Nt(b);Ot(b);Pt(b);Qt(b);Rt(b);St(b);Tt(b);Ut(b);Vt(b);Wt(b);Xt(b);Yt(b);Zt(b);_t(b);$t(b);au(b);bu(b);cu(b);du(b);eu(b);fu(b);gu(b);hu(b);iu(b);ju(b);ku(b);lu(b);mu(b);nu(b);ou(b);pu(b);qu(b);ru(b);su(b);tu(b);uu(b);vu(b);wu(b);xu(b);yu(b);zu(b);Au(b);Bu(b);Cu(b);Du(b);Eu(b);Fu(b);Gu(b);Hu(b);Iu(b);Ju(b);Ku(b);Lu(b);Mu(b);Nu(b);Ou(b);Pu(b);Qu(b);Ru(b);Su(b);Tu(b);Uu(b);Vu(b);Wu(b);Xu(b);Yu(b);Zu(b);_u(b);$u(b);av(b);bv(b);cv(b);dv(b);ev(b);fv(b);gv(b);hv(b);iv(b);jv(b);kv(b);lv(b);mv(b);nv(b);ov(b);pv(b);qv(b);rv(b);sv(b);tv(b);uv(b);vv(b);wv(b);xv(b);yv(b);zv(b);Av(b);Bv(b);Cv(b);Dv(b);Ev(b);Fv(b);Gv(b);Hv(b);Iv(b);Jv(b);Kv(b);Lv(b);Mv(b);Nv(b);Ov(b);Pv(b);Qv(b);Rv(b);Sv(b);Tv(b);Uv(b);Vv(b);Wv(b);Xv(b);Yv(b);Zv(b);_v(b);$v(b);aw(b);bw(b);cw(b);dw(b);ew(b);fw(b);gw(b);hw(b);iw(b);jw(b);kw(b);lw(b);mw(b);nw(b);ow(b);pw(b);qw(b);rw(b);sw(b);tw(b);uw(b);vw(b);ww(b);xw(b);yw(b);zw(b);Aw(b);Bw(b);Cw(b);Dw(b);Ew(b);Fw(b);Gw(b);Hw(b);Iw(b);Jw(b);Kw(b);Lw(b);Mw(b);Nw(b);Ow(b);Pw(b);Qw(b);Rw(b);Sw(b);Tw(b);Uw(b);Vw(b);Ww(b);Xw(b);Yw(b);Zw(b);_w(b);$w(b);ax(b);bx(b);cx(b);dx(b);ex(b);fx(b);gx(b);hx(b);ix(b);jx(b);kx(b);lx(b);mx(b);nx(b);ox(b);px(b);qx(b);rx(b);sx(b);tx(b);ux(b);vx(b);wx(b);xx(b);yx(b);zx(b);Ax(b);Bx(b);Cx(b);Dx(b);Ex(b);Fx(b);Gx(b);Hx(b);Ix(b);Jx(b);Kx(b);Lx(b);Mx(b);Nx(b);Ox(b);Px(b);Qx(b);Rx(b);Sx(b);Tx(b);Ux(b);Vx(b);Wx(b);Xx(b);Yx(b);Zx(b);_x(b);$x(b);ay(b);by(b);cy(b);dy(b);ey(b);fy(b);gy(b);hy(b);iy(b);jy(b);ky(b);ly(b);my(b);ny(b);oy(b);py(b);qy(b);ry(b);sy(b);ty(b);uy(b);vy(b);wy(b);xy(b);yy(b);zy(b);Ay(b);By(b);Cy(b);Dy(b);Ey(b);Fy(b);Gy(b);Hy(b);Iy(b);Jy(b);Ky(b);Ly(b);My(b);Ny(b);Oy(b);Py(b);Qy(b);Ry(b);Sy(b);Ty(b);Uy(b);Vy(b);Wy(b);Xy(b);Yy(b);Zy(b);_y(b);$y(b);az(b);bz(b);cz(b);dz(b);ez(b);fz(b);gz(b);hz(b);iz(b);jz(b);kz(b);lz(b);mz(b);nz(b);oz(b);pz(b);qz(b);rz(b);sz(b);tz(b);uz(b);vz(b);wz(b);xz(b);yz(b);zz(b);Az(b);Bz(b);Cz(b);Dz(b);Ez(b);a[d]=0;i=c;return 0}function Gz(a){a=a|0;i=i;return}function Hz(a){a=a|0;i=i;return 0}function Iz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+480>>3]=+h[(c[a+416>>2]|0)+1384>>3];i=i;return}function Jz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+592>>3]=+h[(c[a+416>>2]|0)+1384>>3];i=i;return}function Kz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+640>>3]=(+h[b+1448>>3]- +h[b+1456>>3])/3.0;i=i;return}function Lz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+632>>3]=(+h[b+1448>>3]- +h[b+1456>>3])/3.0;i=i;return}function Mz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+624>>3]=(+h[b+1448>>3]- +h[b+1456>>3])/3.0;i=i;return}function Nz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+144>>3]=+h[(c[a+416>>2]|0)+1256>>3];i=i;return}function Oz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1304>>3]=+h[(c[a+416>>2]|0)+840>>3];i=i;return}function Pz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1416>>3]=+h[(c[a+416>>2]|0)+840>>3];i=i;return}function Qz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1464>>3]=(+h[b+904>>3]- +h[b+912>>3])/3.0;i=i;return}function Rz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1456>>3]=(+h[b+904>>3]- +h[b+912>>3])/3.0;i=i;return}function Sz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1448>>3]=(+h[b+904>>3]- +h[b+912>>3])/3.0;i=i;return}function Tz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+152>>3]=+h[(c[a+416>>2]|0)+712>>3];i=i;return}function Uz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3552>>3]=+h[(c[a+416>>2]|0)+720>>3];i=i;return}function Vz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+160>>3]=+h[(c[a+416>>2]|0)+760>>3];i=i;return}function Wz(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;RS(9,1,27440,x);if((c[116212>>2]|0)!=0){le[c[29182]&511](9)}RS(9,1,27464,w);if((c[116212>>2]|0)!=0){le[c[29182]&511](9)}RS(9,1,27488,v);if((c[116212>>2]|0)!=0){le[c[29182]&511](9)}Iz(a);Jz(a);Kz(a);Lz(a);Mz(a);Nz(a);Oz(a);Pz(a);Qz(a);Rz(a);Sz(a);Tz(a);Uz(a);Vz(a);RS(9,1,27512,u);u=a+4|0;y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+480>>3];v=a+8|0;a=c[v>>2]|0;h[a+6816>>3]=y;c[t>>2]=c[a+6724>>2];a=t+4|0;h[k>>3]=y;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];RS(9,0,27536,t);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+592>>3];t=c[v>>2]|0;h[t+8384>>3]=y;c[s>>2]=c[t+8292>>2];t=s+4|0;h[k>>3]=y;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];RS(9,0,27536,s);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+640>>3];s=c[v>>2]|0;h[s+9056>>3]=y;c[r>>2]=c[s+8964>>2];s=r+4|0;h[k>>3]=y;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];RS(9,0,27536,r);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+632>>3];r=c[v>>2]|0;h[r+8944>>3]=y;c[q>>2]=c[r+8852>>2];r=q+4|0;h[k>>3]=y;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];RS(9,0,27536,q);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+624>>3];q=c[v>>2]|0;h[q+8832>>3]=y;c[p>>2]=c[q+8740>>2];q=p+4|0;h[k>>3]=y;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];RS(9,0,27536,p);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+144>>3];p=c[v>>2]|0;h[p+2112>>3]=y;c[o>>2]=c[p+2020>>2];p=o+4|0;h[k>>3]=y;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];RS(9,0,27536,o);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+1304>>3];o=c[v>>2]|0;h[o+18352>>3]=y;c[n>>2]=c[o+18260>>2];o=n+4|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];RS(9,0,27536,n);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+1416>>3];n=c[v>>2]|0;h[n+19920>>3]=y;c[m>>2]=c[n+19828>>2];n=m+4|0;h[k>>3]=y;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];RS(9,0,27536,m);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+1464>>3];m=c[v>>2]|0;h[m+20592>>3]=y;c[l>>2]=c[m+20500>>2];m=l+4|0;h[k>>3]=y;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];RS(9,0,27536,l);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+1456>>3];l=c[v>>2]|0;h[l+20480>>3]=y;c[j>>2]=c[l+20388>>2];l=j+4|0;h[k>>3]=y;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];RS(9,0,27536,j);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+1448>>3];j=c[v>>2]|0;h[j+20368>>3]=y;c[g>>2]=c[j+20276>>2];j=g+4|0;h[k>>3]=y;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];RS(9,0,27536,g);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+152>>3];g=c[v>>2]|0;h[g+2224>>3]=y;c[f>>2]=c[g+2132>>2];g=f+4|0;h[k>>3]=y;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];RS(9,0,27536,f);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+3552>>3];f=c[v>>2]|0;h[f+49824>>3]=y;c[e>>2]=c[f+49732>>2];f=e+4|0;h[k>>3]=y;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];RS(9,0,27536,e);y=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+160>>3];u=c[v>>2]|0;h[u+2336>>3]=y;c[d>>2]=c[u+2244>>2];u=d+4|0;h[k>>3]=y;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];RS(9,0,27536,d);if((c[116212>>2]|0)==0){i=b;return 0}le[c[29182]&511](9);i=b;return 0}function Xz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3192>>3]=.99;i=i;return}function Yz(a){a=a|0;var b=0.0;b=+W(+(+h[(c[a+416>>2]|0)+752>>3]*.238732414637843),.6666666666666666)*12.56637061435917;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2392>>3]=b;i=i;return}function Zz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2424>>3]=0.0;i=i;return}function _z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2416>>3]=0.0;i=i;return}function $z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2408>>3]=0.0;i=i;return}function aA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2400>>3]=0.0;i=i;return}function bA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2432>>3]=0.0;i=i;return}function cA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2440>>3]=0.0;i=i;return}function dA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2448>>3]=0.0;i=i;return}function eA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2456>>3]=0.0;i=i;return}function fA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2464>>3]=0.0;i=i;return}function gA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2472>>3]=0.0;i=i;return}function hA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2480>>3]=0.0;i=i;return}function iA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2488>>3]=0.0;i=i;return}function jA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=0.0;i=i;return}function kA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=0.0;i=i;return}function lA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=0.0;i=i;return}function mA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=0.0;i=i;return}function nA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=1.0;i=i;return}function oA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=1.0e+60;i=i;return}function pA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=1.0;i=i;return}function qA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=1.0e+60;i=i;return}function rA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=1.0;i=i;return}function sA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=1.0e+60;i=i;return}function tA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=1.0;i=i;return}function uA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=1.0e+60;i=i;return}function vA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3808>>3]=45263.2387446934;i=i;return}function wA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2608>>3]=.01;i=i;return}function xA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2616>>3]=0.0;i=i;return}function yA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=.99;i=i;return}function zA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3872>>3]=.0101010101010101;i=i;return}function AA(b){b=b|0;a[c[(c[c[b+4>>2]>>2]|0)+16>>2]|0]=0;i=i;return}function BA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=0.0;i=i;return}function CA(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+1|0]=0;i=i;return}function DA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=0.0;i=i;return}function EA(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+2|0]=0;i=i;return}function FA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function GA(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+3|0]=0;i=i;return}function HA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3880>>3]=.0101010101010101;i=i;return}function IA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2640>>3]=0.0;i=i;return}function JA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2648>>3]=0.0;i=i;return}function KA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2656>>3]=0.0;i=i;return}function LA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=0.0;i=i;return}function MA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=0.0;i=i;return}function NA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=0.0;i=i;return}function OA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=.99;i=i;return}function PA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=.99;i=i;return}function QA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3888>>3]=.02879012713067693;i=i;return}function RA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=1.0- +h[c[a+416>>2]>>3];i=i;return}function SA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2752>>3]=0.0;i=i;return}function TA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=0.0;i=i;return}function UA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=0.0;i=i;return}function VA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=0.0;i=i;return}function WA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=0.0;i=i;return}function XA(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+7|0]=1;i=i;return}function YA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function ZA(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+6|0]=1;i=i;return}function _A(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function $A(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+5|0]=1;i=i;return}function aB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=0.0;i=i;return}function bB(b){b=b|0;a[(c[(c[c[b+4>>2]>>2]|0)+16>>2]|0)+4|0]=1;i=i;return}function cB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2888>>3]=.99;i=i;return}function dB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3896>>3]=.02879012713067693;i=i;return}function eB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+416|0;n=c[m>>2]|0;o=+h[n>>3];p=f;h[k>>3]=+h[n+8>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;p=c[f>>2]|0;n=c[m>>2]|0;o=+h[n+584>>3];q=+h[n+600>>3];n=e;m=g;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];xm(j,p,o,q,e);e=c[f>>2]|0;f=d;p=j;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];c[f+20>>2]=c[p+20>>2];c[f+24>>2]=c[p+24>>2];c[f+28>>2]=c[p+28>>2];Cm(l,e,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3904>>3]=+h[l>>3];i=b;return}function fB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3824>>3]=+h[b+3904>>3]+-273.15;i=i;return}function gB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=a+416|0;n=c[m>>2]|0;o=+h[n>>3];p=f;h[k>>3]=+h[n+8>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];YT(g,2,o,f);f=a+536|0;p=c[f>>2]|0;n=c[m>>2]|0;o=+h[n+584>>3];q=+h[n+600>>3];n=e;m=g;c[n+0>>2]=c[m+0>>2];c[n+4>>2]=c[m+4>>2];c[n+8>>2]=c[m+8>>2];xm(j,p,o,q,e);e=c[f>>2]|0;f=d;p=j;c[f+0>>2]=c[p+0>>2];c[f+4>>2]=c[p+4>>2];c[f+8>>2]=c[p+8>>2];c[f+12>>2]=c[p+12>>2];c[f+16>>2]=c[p+16>>2];c[f+20>>2]=c[p+20>>2];c[f+24>>2]=c[p+24>>2];c[f+28>>2]=c[p+28>>2];wm(l,e,d);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3912>>3]=+h[l>>3];i=b;return}function hB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0,m=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;YT(e,1,+h[c[a+416>>2]>>3],b+16|0);g=c[a+536>>2]|0;j=a+4|0;a=c[(c[c[j>>2]>>2]|0)+8>>2]|0;k=+h[a+3912>>3];l=+h[a+3904>>3];a=d;m=e;c[a+0>>2]=c[m+0>>2];c[a+4>>2]=c[m+4>>2];c[a+8>>2]=c[m+8>>2];Hm(f,g,k,l,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3856>>3]=+h[f>>3];i=b;return}function iB(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=b;e=a+4|0;Bm(d,c[a+536>>2]|0,+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+3904>>3]);a=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[a+3848>>3]=+xd(+(+h[d>>3]),+(+h[a+3912>>3]*.999));i=b;return}function jB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3816>>3]=+h[b+3912>>3]*1.0e-5;i=i;return}function kB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;b=i;i=i+120|0;d=b;e=b+96|0;f=i;i=i+16|0;g=i;i=i+96|0;j=i;i=i+8|0;YT(f,1,+h[c[a+416>>2]>>3],b+112|0);c[g>>2]=27552;h[g+8>>3]=.01801528;h[g+16>>3]=-13423382.81725291;h[g+24>>3]=549760.6476280135;h[g+32>>3]=1.0e3;k=g+40|0;l=27560;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=g+52|0;k=27576;c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];k=g+64|0;l=27592;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];l=g+76|0;k=27608;c[l+0>>2]=c[k+0>>2];c[l+4>>2]=c[k+4>>2];c[l+8>>2]=c[k+8>>2];h[g+88>>3]=461.5233290850878;k=c[a+536>>2]|0;l=a+4|0;a=c[(c[c[l>>2]>>2]|0)+8>>2]|0;m=+h[a+3856>>3];n=+h[a+3912>>3];a=e;o=f;c[a+0>>2]=c[o+0>>2];c[a+4>>2]=c[o+4>>2];c[a+8>>2]=c[o+8>>2];o=d+0|0;a=g+0|0;g=o+96|0;do{c[o>>2]=c[a>>2];o=o+4|0;a=a+4|0}while((o|0)<(g|0));em(j,k,m,190.0,647.0,n,e,d,1.0e-13);h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+2384>>3]=+h[j>>3];i=b;return}function lB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=+h[c[a+416>>2]>>3];n=a+4|0;o=f;h[k>>3]=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+2712>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];YT(g,2,m,f);f=a+536|0;a=c[f>>2]|0;o=c[(c[c[n>>2]>>2]|0)+8>>2]|0;m=+h[o+3912>>3];p=+h[o+2384>>3];o=e;q=g;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];Ml(j,a,m,p,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Sl(l,e,d);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+2376>>3]=+h[l>>3];i=b;return}function mB(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=+h[c[a+416>>2]>>3];n=a+4|0;o=f;h[k>>3]=+h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+2712>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];YT(g,2,m,f);f=a+536|0;a=c[f>>2]|0;o=c[(c[c[n>>2]>>2]|0)+8>>2]|0;m=+h[o+3912>>3];p=+h[o+2384>>3];o=e;q=g;c[o+0>>2]=c[q+0>>2];c[o+4>>2]=c[q+4>>2];c[o+8>>2]=c[q+8>>2];Ml(j,a,m,p,e);e=c[f>>2]|0;f=d;a=j;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];Vl(l,e,d);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+2344>>3]=+h[l>>3];i=b;return}function nB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3848>>3];k=+yd(1.0e-13,+(+h[g+3912>>3]-j));do{if(k!=0.0){l=g;m=j/k}else{if(j==0.0){l=g;m=j;break}n=j/+XS(c[b+536>>2]|0,k,27632,27624,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+3792>>3]=m*.6219647130774989;i=d;return}function oB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2896>>3]=1.0- +h[c[a+416>>2]>>3];i=i;return}function pB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+yd(+(+h[g+2896>>3]),1.0e-13);k=+h[c[b+416>>2]>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3864|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3864|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,27704,27696,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3864|0;p=o;h[p>>3]=m;i=d;return}function qB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3912>>3];k=+h[c[b+416>>2]>>3];l=+h[g+3848>>3]*(k+ +h[g+2896>>3]*.6219647130774989);if(l!=0.0){m=g;n=k/l;o=j*n;p=m;q=p+3800|0;r=q;h[r>>3]=o;i=d;return}if(k==0.0){m=g;n=k;o=j*n;p=m;q=p+3800|0;r=q;h[r>>3]=o;i=d;return}s=k/+XS(c[b+536>>2]|0,l,27752,27744,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j*n;p=m;q=p+3800|0;r=q;h[r>>3]=o;i=d;return}function rB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3848>>3];k=+yd(1.0e-13,+(+h[g+3912>>3]-j));l=+h[g+2896>>3];do{if(k!=0.0){m=g;n=l/k}else{if(l==0.0){m=g;n=l;break}o=l/+XS(c[b+536>>2]|0,k,27632,27848,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=o}}while(0);h[m+3784>>3]=+xd(+(j*n*.6219647130774989),1.0);i=d;return}function sB(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3776>>3]=+yd(+(+h[c[a+416>>2]>>3]- +h[d+3784>>3]),0.0);i=b;return}function tB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3768>>3]=+h[c[a+416>>2]>>3]- +h[b+3776>>3];i=i;return}function uB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0,p=0.0,q=0.0,r=0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3776>>3];k=1.0-j;l=+h[g+2896>>3];do{if(k!=0.0){m=j;n=g;o=f;p=l/k}else{if(l==0.0){m=j;n=g;o=f;p=l;break}q=l/+XS(c[b+536>>2]|0,k,27864,27856,+h[f>>3],(a[b+319|0]|0)!=0|0);r=c[c[e>>2]>>2]|0;s=c[r+8>>2]|0;m=+h[s+3776>>3];n=s;o=r;p=q}}while(0);k=p*287.0512249529787;p=1.0-m;m=+h[n+3768>>3];if(p!=0.0){t=n;u=m/p;v=u*461.5233290850878;w=k+v;x=t;y=x+3760|0;z=y;h[z>>3]=w;i=d;return}if(m==0.0){t=n;u=m;v=u*461.5233290850878;w=k+v;x=t;y=x+3760|0;z=y;h[z>>3]=w;i=d;return}l=m/+XS(c[b+536>>2]|0,p,27864,27856,+h[o>>3],(a[b+319|0]|0)!=0|0);t=c[(c[c[e>>2]>>2]|0)+8>>2]|0;u=l;v=u*461.5233290850878;w=k+v;x=t;y=x+3760|0;z=y;h[z>>3]=w;i=d;return}function vB(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3752>>3]=+h[b+3856>>3]- +h[b+3760>>3]*+h[b+3904>>3];i=i;return}function wB(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3904>>3]*+h[g+3760>>3];k=+h[g+3912>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+3744|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+3744|0;p=o;h[p>>3]=m;i=d;return}q=k/+XS(c[b+536>>2]|0,j,27904,27896,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+3744|0;p=o;h[p>>3]=m;i=d;return}function xB(b){b=b|0;var d=0,e=0.0,f=0.0,g=0,j=0.0,k=0;d=i;e=+h[c[b+416>>2]>>3];f=e/.01801528-e/.0289651159+34.52428788658843;if(f!=0.0){g=b+4|0;j=f}else{k=b+4|0;g=k;j=+XS(c[b+536>>2]|0,f,27952,27944,+h[c[c[k>>2]>>2]>>3],(a[b+319|0]|0)!=0|0)}h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3920>>3]=1.0/j;i=d;return}function yB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3928>>3]=20.0;i=i;return}function zB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3936>>3]=20.0;i=i;return}function AB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3944>>3]=0.0;i=i;return}function BB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3]=45263.2387446934;i=i;return}function CB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=.01;i=i;return}function DB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2912>>3]=0.0;i=i;return}function EB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3960>>3]=293.15;i=i;return}function FB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3968>>3]=0.0;i=i;return}function GB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=0.0;i=i;return}function HB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=0.0;i=i;return}function IB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=0.0;i=i;return}function JB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=0.0;i=i;return}function KB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=0.0;i=i;return}function LB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=0.0;i=i;return}function MB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=0.0;i=i;return}function NB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=0.0;i=i;return}function OB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=0.0;i=i;return}function PB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=0.0;i=i;return}function QB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3e3>>3]=0.0;i=i;return}function RB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=0.0;i=i;return}function SB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=0.0;i=i;return}function TB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=0.0;i=i;return}function UB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3976>>3]=293.15;i=i;return}function VB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=100.0;i=i;return}function WB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3080>>3]=.01;i=i;return}function XB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3096>>3]=0.0;i=i;return}function YB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=0.0;i=i;return}function ZB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=0.0;i=i;return}function _B(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3160>>3]=0.0;i=i;return}function $B(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3168>>3]=0.0;i=i;return}function aC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3176>>3]=0.0;i=i;return}function bC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3184>>3]=.01;i=i;return}function cC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3984>>3]=0.0;i=i;return}function dC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3992>>3]=45263.2387446934;i=i;return}function eC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3200>>3]=.01;i=i;return}function fC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3208>>3]=0.0;i=i;return}function gC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4e3>>3]=0.0;i=i;return}function hC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4008>>3]=0.0;i=i;return}function iC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3216>>3]=0.0;i=i;return}function jC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3224>>3]=0.0;i=i;return}function kC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3232>>3]=0.0;i=i;return}function lC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3240>>3]=0.0;i=i;return}function mC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=0.0;i=i;return}function nC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+616>>3];i=i;return}function oC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+688>>3]=+h[b+624>>3];i=i;return}function pC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+712>>3]=+h[b+688>>3];i=i;return}function qC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+728>>3]=+h[b+648>>3];i=i;return}function rC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+736>>3]=+h[b+656>>3]*+h[b+728>>3];i=i;return}function sC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+760>>3]=+h[b+680>>3];i=i;return}function tC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0,o=0.0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+48>>3];n=e;h[k>>3]=+h[l+56>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=+h[a+760>>3];o=+h[a+712>>3];a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];mn(g,e,m,o,d);h[(c[j>>2]|0)+720>>3]=+h[g>>3];i=b;return}function uC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+768>>3]=+W(+(+h[b+752>>3]*.75),.6666666666666666)*3.141592653589793;i=i;return}function vC(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+27|0]=a[d+22|0]|0;i=i;return}function wC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+784>>3]=+h[b+624>>3];i=i;return}function xC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+680>>3];i=i;return}function yC(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+808>>3];h[b+864>>3]=d*d*.7853981633974483;i=i;return}function zC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+808>>3]*3.141592653589793;i=i;return}function AC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+848>>3];i=i;return}function BC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+72>>3];n=e;h[k>>3]=+h[l+80>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+848>>3]+ +h[a+880>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];vm(g,e,m,293.15,d);h[(c[j>>2]|0)+840>>3]=+h[g>>3];i=b;return}function CC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+896>>3]=+h[b+792>>3];i=i;return}function DC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+904>>3]=+h[b+848>>3];i=i;return}function EC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+912>>3]=+h[b+880>>3];i=i;return}function FC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+936>>3]=+h[b+648>>3];i=i;return}function GC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+944>>3]=+h[b+656>>3]*+h[b+936>>3];i=i;return}function HC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+960>>3]=+h[b+632>>3];i=i;return}function IC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+112>>3]=+h[b+800>>3]*.5;i=i;return}function JC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=+h[(c[a+416>>2]|0)+112>>3]*.5;i=i;return}function KC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2592>>3]=+h[b+112>>3]*+h[b+872>>3];i=i;return}function LC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+120>>3]=+h[b+800>>3]*.5;i=i;return}function MC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=+h[(c[a+416>>2]|0)+120>>3]*.5;i=i;return}function NC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=(+h[b+112>>3]+ +h[b+120>>3])*.5;i=i;return}function OC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2600>>3]=+h[b+120>>3]*+h[b+872>>3];i=i;return}function PC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+128>>3]=+h[b+864>>3];i=i;return}function QC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=+h[b+128>>3]*+h[b+112>>3]*+h[b+792>>3];i=i;return}function RC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+136>>3]=+h[b+864>>3];i=i;return}function SC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=+h[b+136>>3]*+h[b+120>>3]*+h[b+792>>3];i=i;return}function TC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+872>>3];j=+h[f+864>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+XS(c[b+536>>2]|0,g,28040,28032,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+144>>3]=l*4.0;i=d;return}function UC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+872>>3];j=+h[f+864>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+XS(c[b+536>>2]|0,g,28040,28064,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+152>>3]=l*4.0;i=d;return}function VC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=(+h[b+144>>3]+ +h[b+152>>3])*.5;i=i;return}function WC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+816>>3];i=i;return}function XC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+168>>3]=+h[b+816>>3];i=i;return}function YC(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=b+536|0;k=c[j>>2]|0;l=b+416|0;m=c[l>>2]|0;n=+h[m+896>>3];o=+h[m+936>>3];do{if(n!=0.0){p=n;q=m;r=o/n}else{if(o==0.0){p=n;q=m;r=o;break}s=o/+XS(k,n,28080,28072,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);t=c[l>>2]|0;p=+h[t+896>>3];q=t;r=s}}while(0);n=+h[q+976>>3];o=+h[q+984>>3];m=b+4|0;t=c[c[m>>2]>>2]|0;s=+h[(c[t+8>>2]|0)+3024>>3];u=+h[q+144>>3];v=+h[q+160>>3];w=(v+v)*.5;v=+h[q+944>>3];do{if(p!=0.0){x=q;y=v/p}else{if(v==0.0){x=q;y=v;break}z=v/+XS(c[j>>2]|0,p,28080,28072,+h[t>>3],(a[b+319|0]|0)!=0|0);x=c[l>>2]|0;y=z}}while(0);Yl(e,k,r,n,n,o,o,s,u,w,y,+h[x+920>>3]);y=+h[e>>3];e=c[j>>2]|0;x=c[l>>2]|0;w=+h[x+896>>3];u=+h[x+936>>3];do{if(w!=0.0){A=w;B=x;C=u/w}else{if(u==0.0){A=w;B=x;C=u;break}s=u/+XS(e,w,28080,28072,+h[c[c[m>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[l>>2]|0;A=+h[k+896>>3];B=k;C=s}}while(0);w=+h[B+976>>3];u=+h[B+984>>3];x=c[c[m>>2]>>2]|0;k=c[x+8>>2]|0;s=+h[k+3032>>3];o=+h[k+2720>>3];n=(+h[B+160>>3]+ +h[B+168>>3])*.5;r=+h[B+944>>3];do{if(A!=0.0){D=B;E=r/A}else{if(r==0.0){D=B;E=r;break}p=r/+XS(c[j>>2]|0,A,28080,28072,+h[x>>3],(a[b+319|0]|0)!=0|0);D=c[l>>2]|0;E=p}}while(0);Yl(f,e,C,w,w,u,u,s,o,n,E,+h[D+920>>3]);E=+h[f>>3];f=c[j>>2]|0;D=c[l>>2]|0;n=+h[D+896>>3];o=+h[D+936>>3];do{if(n!=0.0){F=n;G=D;H=o/n}else{if(o==0.0){F=n;G=D;H=o;break}s=o/+XS(f,n,28080,28072,+h[c[c[m>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[l>>2]|0;F=+h[e+896>>3];G=e;H=s}}while(0);n=+h[G+976>>3];o=+h[G+984>>3];D=c[c[m>>2]>>2]|0;s=+h[(c[D+8>>2]|0)+3040>>3];u=+h[G+152>>3];w=+h[G+168>>3];C=(w+w)*.5;w=+h[G+944>>3];if(F!=0.0){I=G;J=w/F;K=I;L=K+920|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3832|0;$=_;h[$>>3]=S;i=d;return}if(w==0.0){I=G;J=w;K=I;L=K+920|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3832|0;$=_;h[$>>3]=S;i=d;return}A=w/+XS(c[j>>2]|0,F,28080,28072,+h[D>>3],(a[b+319|0]|0)!=0|0);I=c[l>>2]|0;J=A;K=I;L=K+920|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3832|0;$=_;h[$>>3]=S;i=d;return}function ZC(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+47|0]=a[d+33|0]|0;i=i;return}function _C(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1e3>>3]=+h[b+792>>3];i=i;return}function $C(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1008>>3]=+h[b+624>>3];i=i;return}function aD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+1096>>3];i=i;return}function bD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1232>>3]=+h[b+1128>>3];i=i;return}function cD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1104>>3];if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+1248|0;o=n;h[o>>3]=l;i=d;return}p=+XS(c[b+536>>2]|0,g,28120,28112,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+1248|0;o=n;h[o>>3]=l;i=d;return}function dD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1256>>3]=+h[b+1160>>3];i=i;return}function eD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0,n=0,o=0,p=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1144>>3]*+h[f+1096>>3];if(g!=0.0){j=g;k=f;l=1.0/j;m=k;n=m+1304|0;o=n;h[o>>3]=l;i=d;return}p=+XS(c[b+536>>2]|0,g,28136,28128,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);j=p;k=c[e>>2]|0;l=1.0/j;m=k;n=m+1304|0;o=n;h[o>>3]=l;i=d;return}function fD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1320>>3]=+h[b+1120>>3];i=i;return}function gD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1328>>3]=+h[b+1224>>3];i=i;return}function hD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1392>>3]=+h[b+680>>3];i=i;return}function iD(a){a=a|0;var b=0,d=0.0;b=c[a+416>>2]|0;d=+h[b+1352>>3];h[b+1408>>3]=d*d*.7853981633974483;i=i;return}function jD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1416>>3]=+h[b+1352>>3]*3.141592653589793;i=i;return}function kD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1424>>3]=+h[b+1392>>3];i=i;return}function lD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0.0,n=0;b=i;i=i+24|0;d=b;e=b+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=a+416|0;l=c[j>>2]|0;m=+h[l+440>>3];n=e;h[k>>3]=+h[l+448>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];YT(f,2,m,e);e=c[a+536>>2]|0;a=c[j>>2]|0;m=(+h[a+1392>>3]+ +h[a+1424>>3])*.5;a=d;n=f;c[a+0>>2]=c[n+0>>2];c[a+4>>2]=c[n+4>>2];c[a+8>>2]=c[n+8>>2];vm(g,e,m,293.15,d);h[(c[j>>2]|0)+1384>>3]=+h[g>>3];i=b;return}function mD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1440>>3]=+h[b+1336>>3];i=i;return}function nD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1448>>3]=+h[b+1392>>3];i=i;return}function oD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1456>>3]=+h[b+1424>>3];i=i;return}function pD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1480>>3]=+h[b+648>>3];i=i;return}function qD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1488>>3]=+h[b+656>>3]*+h[b+1480>>3];i=i;return}function rD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+632>>3];i=i;return}function sD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+480>>3]=+h[b+1344>>3]*.5;i=i;return}function tD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3136>>3]=+h[(c[a+416>>2]|0)+480>>3]*.5;i=i;return}function uD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2624>>3]=+h[b+480>>3]*+h[b+1416>>3];i=i;return}function vD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+488>>3]=+h[b+1344>>3]*.5;i=i;return}function wD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3152>>3]=+h[(c[a+416>>2]|0)+488>>3]*.5;i=i;return}function xD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3144>>3]=(+h[b+480>>3]+ +h[b+488>>3])*.5;i=i;return}function yD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2632>>3]=+h[b+488>>3]*+h[b+1416>>3];i=i;return}function zD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+496>>3]=+h[b+1408>>3];i=i;return}function AD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=+h[b+496>>3]*+h[b+480>>3]*+h[b+1336>>3];i=i;return}function BD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+504>>3]=+h[b+1408>>3];i=i;return}function CD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3128>>3]=+h[b+504>>3]*+h[b+488>>3]*+h[b+1336>>3];i=i;return}function DD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1416>>3];j=+h[f+1408>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+XS(c[b+536>>2]|0,g,28160,28152,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+512>>3]=l*4.0;i=d;return}function ED(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1416>>3];j=+h[f+1408>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+XS(c[b+536>>2]|0,g,28160,28184,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+520>>3]=l*4.0;i=d;return}function FD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=(+h[b+512>>3]+ +h[b+520>>3])*.5;i=i;return}function GD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+528>>3]=+h[b+1360>>3];i=i;return}function HD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+536>>3]=+h[b+1360>>3];i=i;return}function ID(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0,y=0.0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0.0,F=0.0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;j=b+536|0;k=c[j>>2]|0;l=b+416|0;m=c[l>>2]|0;n=+h[m+1440>>3];o=+h[m+1480>>3];do{if(n!=0.0){p=n;q=m;r=o/n}else{if(o==0.0){p=n;q=m;r=o;break}s=o/+XS(k,n,28200,28192,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);t=c[l>>2]|0;p=+h[t+1440>>3];q=t;r=s}}while(0);n=+h[q+1520>>3];o=+h[q+1528>>3];m=b+4|0;t=c[c[m>>2]>>2]|0;s=+h[(c[t+8>>2]|0)+3136>>3];u=+h[q+512>>3];v=+h[q+528>>3];w=(v+v)*.5;v=+h[q+1488>>3];do{if(p!=0.0){x=q;y=v/p}else{if(v==0.0){x=q;y=v;break}z=v/+XS(c[j>>2]|0,p,28200,28192,+h[t>>3],(a[b+319|0]|0)!=0|0);x=c[l>>2]|0;y=z}}while(0);Yl(e,k,r,n,n,o,o,s,u,w,y,+h[x+1464>>3]);y=+h[e>>3];e=c[j>>2]|0;x=c[l>>2]|0;w=+h[x+1440>>3];u=+h[x+1480>>3];do{if(w!=0.0){A=w;B=x;C=u/w}else{if(u==0.0){A=w;B=x;C=u;break}s=u/+XS(e,w,28200,28192,+h[c[c[m>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[l>>2]|0;A=+h[k+1440>>3];B=k;C=s}}while(0);w=+h[B+1520>>3];u=+h[B+1528>>3];x=c[c[m>>2]>>2]|0;k=c[x+8>>2]|0;s=+h[k+3144>>3];o=+h[k+2696>>3];n=(+h[B+528>>3]+ +h[B+536>>3])*.5;r=+h[B+1488>>3];do{if(A!=0.0){D=B;E=r/A}else{if(r==0.0){D=B;E=r;break}p=r/+XS(c[j>>2]|0,A,28200,28192,+h[x>>3],(a[b+319|0]|0)!=0|0);D=c[l>>2]|0;E=p}}while(0);Yl(f,e,C,w,w,u,u,s,o,n,E,+h[D+1464>>3]);E=+h[f>>3];f=c[j>>2]|0;D=c[l>>2]|0;n=+h[D+1440>>3];o=+h[D+1480>>3];do{if(n!=0.0){F=n;G=D;H=o/n}else{if(o==0.0){F=n;G=D;H=o;break}s=o/+XS(f,n,28200,28192,+h[c[c[m>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);e=c[l>>2]|0;F=+h[e+1440>>3];G=e;H=s}}while(0);n=+h[G+1520>>3];o=+h[G+1528>>3];D=c[c[m>>2]>>2]|0;s=+h[(c[D+8>>2]|0)+3152>>3];u=+h[G+520>>3];w=+h[G+536>>3];C=(w+w)*.5;w=+h[G+1488>>3];if(F!=0.0){I=G;J=w/F;K=I;L=K+1464|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3840|0;$=_;h[$>>3]=S;i=d;return}if(w==0.0){I=G;J=w;K=I;L=K+1464|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3840|0;$=_;h[$>>3]=S;i=d;return}A=w/+XS(c[j>>2]|0,F,28200,28192,+h[D>>3],(a[b+319|0]|0)!=0|0);I=c[l>>2]|0;J=A;K=I;L=K+1464|0;M=L;N=+h[M>>3];Yl(g,f,H,n,n,o,o,s,u,C,J,N);O=g;P=O;Q=+h[P>>3];R=E+Q;S=y+R;T=c[m>>2]|0;U=c[T>>2]|0;V=U;W=V+8|0;X=W;Y=c[X>>2]|0;Z=Y;_=Z+3840|0;$=_;h[$>>3]=S;i=d;return}function JD(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+81|0]=a[d+67|0]|0;i=i;return}function KD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1544>>3]=+h[b+1336>>3];i=i;return}function LD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1552>>3]=+h[b+624>>3];i=i;return}function MD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28232]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(28248,wT(+h[(c[g>>2]|0)+1552>>3],28240)|0)|0;g=c[41340]|0;j=e;k=42024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[28232]=1;i=d;return}function ND(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28448]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(28456,wT(+h[(c[g>>2]|0)+536>>3],28240)|0)|0;g=c[41340]|0;j=e;k=36792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[28448]=1;i=d;return}function OD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28632]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(28640,wT(+h[(c[g>>2]|0)+528>>3],28240)|0)|0;g=c[41340]|0;j=e;k=36792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[28632]=1;i=d;return}function PD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28744]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(28752,wT(+h[(c[g>>2]|0)+1528>>3],28240)|0)|0;g=c[41340]|0;j=e;k=36944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[28744]=1;i=d;return}function QD(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28864]&1){i=d;return}g=b+416|0;if(!((yW(+h[(c[g>>2]|0)+1520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(28872,wT(+h[(c[g>>2]|0)+1520>>3],28240)|0)|0;g=c[41340]|0;j=e;k=37096;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[28864]=1;i=d;return}



function Xka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=Nla((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=Nla((l<<2)+4|0)|0;if((p|0)==0){Ola(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}bla(d,e)|0;e=bla(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 3:{E=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;G=c[D+(u+ -4<<2)>>2]|0;H=u+ -5|0;c[h>>2]=H;if(k){I=c[G+4>>2]|0;J=G+16|0;c[G+20>>2]=(c[(c[I>>2]|0)+20>>2]|0)+(c[D+(H<<2)>>2]|0)+(c[(c[I+4>>2]|0)+20>>2]|0)+((c[J>>2]|0)>0?2:0);K=J;L=c[h>>2]|0}else{K=G+16|0;L=H}H=c[D+(L+ -1<<2)>>2]|0;G=L+ -2|0;c[h>>2]=G;J=c[D+(G<<2)>>2]|0;G=L+ -3|0;c[h>>2]=G;I=c[D+(G<<2)>>2]|0;if((c[K>>2]|0)<=0){M=1;N=w;O=x;P=y;Q=z;R=H;S=0;T=B;break b}if(k){U=0}else{ela(b,E,J)|0;c[(c[r>>2]|0)+(J<<2)>>2]=1;J=ela(b,F,I)|0;c[(c[r>>2]|0)+(I<<2)>>2]=1;U=J}M=1;N=w;O=x;P=y;Q=z+2|0;R=H;S=U;T=B;break};case 0:{H=u+ -2|0;c[h>>2]=H;J=c[D+(H<<2)>>2]|0;H=J;I=J+12|0;F=c[I>>2]|0;if((F|0)>-1){E=0;do{V=A+(E<<2)|0;E=E+1|0}while((c[V>>2]|0)>-1);c[V>>2]=F<<1;c[A+(E<<2)>>2]=-1;do{if(!k){G=0;while(1){if((c[p+(G<<2)>>2]|0)>-1){G=G+1|0}else{break}}c[(c[s>>2]|0)+(F*12|0)+8>>2]=0;if((G|0)<=0){break}W=Nla((G<<2)+4|0)|0;X=W;if((W|0)==0){Y=w;Z=y;_=z;$=A;aa=12;ba=B;break a}c[(c[s>>2]|0)+(F*12|0)+8>>2]=X;ca=c[p>>2]|0;if((ca|0)>-1){da=X;ea=ca;ca=0;while(1){c[da>>2]=ea;fa=ca+1|0;ga=c[p+(fa<<2)>>2]|0;ha=W+(fa<<2)|0;if((ga|0)>-1){ca=fa;ea=ga;da=ha}else{ia=ha;break}}}else{ia=X}c[ia>>2]=-1}}while(0);F=bla(d,c[I>>2]|0)|0;if((F|0)!=0){Y=w;Z=y;_=z;$=A;aa=F;ba=B;break a}F=bla(d,6)|0;if((F|0)!=0){Y=w;Z=y;_=z;$=A;aa=F;ba=B;break a}}F=c[J>>2]|0;do{if((F|0)==3){E=c[J+4>>2]|0;da=c[E>>2]|0;ea=c[E+4>>2]|0;E=(c[A>>2]|0)>-1;ca=x+1|0;W=bla(d,E?ca:x)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=bla(d,E?x:B)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=bla(d,A)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=bla(d,(c[A>>2]|0)>>>31^1)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=bla(d,J)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=ea;ea=bla(d,W)|0;if((ea|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ea;pa=B;break}ea=da;da=bla(d,ea)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=bla(d,3)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=bla(d,W)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=bla(d,0)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=bla(d,2)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=bla(d,ea)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}da=bla(d,0)|0;if((da|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=da;pa=B;break}if((c[A>>2]|0)>-1){if(k){qa=w;ra=y;sa=0}else{da=dla(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){ea=c[t>>2]|0;W=0;while(1){ta=ea+(W<<2)|0;ua=W+1|0;if((c[ta>>2]|0)>-1){W=ua}else{break}}c[ta>>2]=B;c[ea+(ua<<2)>>2]=w;c[ea+(W+2<<2)>>2]=-1;va=-1;wa=y+1|0}else{va=w;wa=y}X=c[A>>2]|0;if((X|0)>-1){E=c[s>>2]|0;G=X;X=0;do{ha=(G|0)/2|0;if((G&1|0)==0){c[E+(ha*12|0)>>2]=B}else{c[E+(ha*12|0)+4>>2]=B}X=X+1|0;G=c[A+(X<<2)>>2]|0;}while((G|0)>-1)}c[A>>2]=-1;qa=va;ra=wa;sa=da}c[A>>2]=-1;xa=qa;ya=ca;za=ra;Aa=z+1|0;Ba=sa;Ca=x}else{xa=w;ya=x;za=y;Aa=z;Ba=0;Ca=B}if((c[J+16>>2]|0)<=0){ja=v;ka=xa;la=ya;ma=za;na=Aa;oa=Ba;pa=Ca;break}ja=v;ka=xa;la=ya+2|0;ma=za;na=Aa;oa=Ba;pa=ya+1|0}else if((F|0)==0){G=c[c[J+4>>2]>>2]|0;if(!((G|0)>-1|(G|0)==-4)){ja=v;ka=w;la=x;ma=y;na=z;oa=0;pa=B;break}if(!((c[A>>2]|0)>-1)){ja=v;ka=w;la=x;ma=y;na=z;oa=0;pa=B;break}if(k){c[J+20>>2]=1;Da=w;Ea=y;Fa=0}else{G=dla(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){X=c[t>>2]|0;E=0;while(1){Ga=X+(E<<2)|0;Ha=E+1|0;if((c[Ga>>2]|0)>-1){E=Ha}else{break}}c[Ga>>2]=B;c[X+(Ha<<2)>>2]=w;c[X+(E+2<<2)>>2]=-1;Ia=-1;Ja=y+1|0}else{Ia=w;Ja=y}ca=c[A>>2]|0;if((ca|0)>-1){da=c[s>>2]|0;W=ca;ca=0;do{ea=(W|0)/2|0;if((W&1|0)==0){c[da+(ea*12|0)>>2]=B}else{c[da+(ea*12|0)+4>>2]=B}ca=ca+1|0;W=c[A+(ca<<2)>>2]|0;}while((W|0)>-1)}c[A>>2]=-1;Da=Ia;Ea=Ja;Fa=G}c[A>>2]=-1;ja=v;ka=Da;la=x+1|0;ma=Ea;na=z+1|0;oa=Fa;pa=x}else if((F|0)==1){W=c[J+4>>2]|0;ca=c[W>>2]|0;da=c[W+4>>2]|0;W=bla(d,J)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=bla(d,5)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=bla(d,da)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=bla(d,0)|0;if((W|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=W;pa=B;break}W=ca+20|0;E=bla(d,(c[W>>2]|0)+x|0)|0;if((E|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=E;pa=B;break}if((c[W>>2]|0)>0){W=(c[da+20>>2]|0)>0;Ka=(W&1)+x|0;La=W?x:-1}else{Ka=x;La=-1}W=bla(d,La)|0;if((W|0)!=0){ja=v;ka=w;la=Ka;ma=y;na=z;oa=W;pa=B;break}W=bla(d,4)|0;if((W|0)!=0){ja=v;ka=w;la=Ka;ma=y;na=z;oa=W;pa=B;break}W=bla(d,ca)|0;if((W|0)!=0){ja=v;ka=w;la=Ka;ma=y;na=z;oa=W;pa=B;break}ja=v;ka=w;la=Ka;ma=y;na=z;oa=bla(d,0)|0;pa=B}else if((F|0)==2){W=c[J+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Ma=1}else{Ma=a[W+12|0]&1}ca=bla(d,Ma)|0;if((ca|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ca;pa=B;break}}else{ca=bla(d,B)|0;if((ca|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ca;pa=B;break}ca=bla(d,a[W+12|0]&1)|0;if((ca|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ca;pa=B;break}}ca=bla(d,J)|0;if((ca|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ca;pa=B;break}ca=bla(d,1)|0;if((ca|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ca;pa=B;break}ca=bla(d,c[W>>2]|0)|0;if((ca|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ca;pa=B;break}ca=bla(d,0)|0;if((ca|0)!=0){ja=v;ka=w;la=x;ma=y;na=z;oa=ca;pa=B;break}if(!((c[A>>2]|0)>-1)){if((a[W+12|0]&1)==0){ja=0;ka=w;la=x;ma=y;na=z;oa=0;pa=B;break}}if(k){Na=w;Oa=y;Pa=0}else{ca=dla(b,H,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[W+12|0]&1)==0?v:1;if((w|0)>-1){W=c[t>>2]|0;da=0;while(1){Qa=W+(da<<2)|0;Ra=da+1|0;if((c[Qa>>2]|0)>-1){da=Ra}else{break}}c[Qa>>2]=B;c[W+(Ra<<2)>>2]=w;c[W+(da+2<<2)>>2]=-1;Sa=-1;Ta=y+1|0}else{Sa=w;Ta=y}G=c[A>>2]|0;if((G|0)>-1){E=c[s>>2]|0;X=G;G=0;do{ea=(X|0)/2|0;if((X&1|0)==0){c[E+(ea*12|0)>>2]=B}else{c[E+(ea*12|0)+4>>2]=B}G=G+1|0;X=c[A+(G<<2)>>2]|0;}while((X|0)>-1)}c[A>>2]=-1;Na=Sa;Oa=Ta;Pa=ca}c[A>>2]=-1;ja=0;ka=Na;la=x+1|0;ma=Oa;na=z+1|0;oa=Pa;pa=x}else{ja=v;ka=w;la=x;ma=y;na=z;oa=0;pa=B}}while(0);H=c[I>>2]|0;if((H|0)>-1){Ua=0}else{M=ja;N=ka;O=la;P=ma;Q=na;R=A;S=oa;T=pa;break b}do{Va=p+(Ua<<2)|0;Ua=Ua+1|0}while((c[Va>>2]|0)>-1);c[Va>>2]=H;c[p+(Ua<<2)>>2]=-1;M=ja;N=ka;O=la;P=ma;Q=na;R=A;S=oa;T=pa;break};case 4:{I=u+ -2|0;c[h>>2]=I;J=c[D+(I<<2)>>2]|0;I=u+ -3|0;c[h>>2]=I;M=v;N=w;O=c[D+(I<<2)>>2]|0;P=y;Q=z;R=A;S=0;T=(J|0)>-1?J:B;break};case 6:{J=u+ -2|0;c[h>>2]=J;I=c[D+(J<<2)>>2]|0;J=0;do{Wa=A+(J<<2)|0;J=J+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=I<<1|1;c[A+(J<<2)>>2]=-1;H=0;while(1){if((c[p+(H<<2)>>2]|0)>-1){H=H+1|0}else{break}}c[p+(H+ -1<<2)>>2]=-1;M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break};case 1:{J=u+ -2|0;c[h>>2]=J;I=c[D+(J<<2)>>2]|0;if(k){J=c[(c[c[I+4>>2]>>2]|0)+20>>2]|0;F=u+ -3|0;c[h>>2]=F;c[I+20>>2]=(c[D+(F<<2)>>2]|0)+J;M=v;N=-1;O=x;P=y;Q=z;R=A;S=0;T=B;break b}else{J=u+ -3|0;c[h>>2]=J;F=c[D+(J<<2)>>2]|0;J=u+ -4|0;c[h>>2]=J;I=(F|0)==0;M=I&1;N=I?w:c[D+(J<<2)>>2]|0;O=x;P=y;Q=z;R=A;S=0;T=B;break b}break};case 5:{J=u+ -2|0;c[h>>2]=J;I=c[D+(J<<2)>>2]|0;if(!k){M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break b}J=c[I+4>>2]|0;c[I+20>>2]=(c[(c[J+4>>2]|0)+20>>2]|0)+(c[(c[J>>2]|0)+20>>2]|0);M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B;break};case 2:{J=A;while(1){if((c[J>>2]|0)>-1){J=J+4|0}else{M=v;N=w;O=x;P=y;Q=z;R=J;S=0;T=B;break}}break};default:{M=v;N=w;O=x;P=y;Q=z;R=A;S=0;T=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(S|0)==0){u=D;v=M;w=N;x=O;y=P;z=Q;A=R;B=T}else{Y=N;Z=P;_=Q;$=R;aa=S;ba=T;break a}}}else{Y=-1;Z=0;_=0;$=n;aa=e;ba=0}}while(0);do{if(k){Xa=Z}else{e=c[$>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;T=e;e=0;do{S=(T|0)/2|0;if((T&1|0)==0){c[n+(S*12|0)>>2]=ba}else{c[n+(S*12|0)+4>>2]=ba}e=e+1|0;T=c[$+(e<<2)>>2]|0;}while((T|0)>-1)}c[$>>2]=-1;if(!((Y|0)>-1)){Xa=Z;break}T=c[f+36>>2]|0;e=0;while(1){Ya=T+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ba;c[T+(Za<<2)>>2]=Y;c[T+(e+2<<2)>>2]=-1;Xa=Z+1|0}}while(0);c[f+48>>2]=_;c[f+40>>2]=_;c[f+44>>2]=Xa;Ola(m);Ola(p);o=aa;i=g;return o|0}function Yka(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==3){h=c[g+4>>2]|0;j=Yka(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){k=j;l=10;break a}m=h+4|0}else if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){m=j;break}n=c[h>>2]|0;h=_ka(c[n+28>>2]|0,c[n+24>>2]|0,b,d,e)|0;if((h|0)==0){m=j}else{k=h;l=10;break a}}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;n=_ka(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((n|0)!=0){k=n;l=10;break a}n=Yka(c[h>>2]|0,b,d,e)|0;if((n|0)==0){m=j}else{k=n;l=10;break a}}else{k=0;l=10;break a}}while(0);g=c[m>>2]|0}if((l|0)==10){i=f;return k|0}return 0}function Zka(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{Ola(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}Ola(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){Ola(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){Ola(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}Ola(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{Ola(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}Ola(m)}m=c[d+32>>2]|0;if((m|0)!=0){Ola(m)}m=c[d+20>>2]|0;if((m|0)!=0){Ola(m)}m=c[d+36>>2]|0;if((m|0)!=0){Ola(m)}Ola(d);i=b;return}function _ka(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=Nla(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){Ola(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=Nla((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function $ka(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=lla(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=lla(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=lla(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function ala(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=bla(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=bla(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=bla(a,r)|0}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=bla(a,r)|0}else if((q|0)==1){r=c[o+4>>2]|0;s=bla(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}B=bla(a,c[r+4>>2]|0)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function bla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=Qla(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;bla(a,b)|0;i=d;return 0}return 0}function cla(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;bla(d,e)|0;e=bla(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==3){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=lla(b,0,0,1,32)|0;if((F|0)==0){G=20;break b}H=lla(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=20;break b}c[F>>2]=3;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;I=bla(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=bla(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=bla(d,F+4|0)|0;if((I|0)!=0){v=s;w=I;break a}I=bla(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=bla(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=F;M=bla(d,0)|0}else if((z|0)==2){F=c[u+4>>2]|0;I=bla(d,c[F>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=bla(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=c[F>>2]|0;y=c[F+4>>2]|0;D=c[F+8>>2]|0;x=a[F+12|0]|0;F=lla(b,0,0,1,32)|0;if((F|0)==0){G=40;break b}E=lla(b,0,0,1,16)|0;H=F+4|0;c[H>>2]=E;if((E|0)==0){G=40;break b}c[F>>2]=2;c[F+8>>2]=-1;c[F+12>>2]=-1;c[E>>2]=I;c[E+4>>2]=y;c[E+8>>2]=D;D=E+12|0;a[D]=a[D]&-2|x&1;c[F+16>>2]=c[I+16>>2];c[t>>2]=F;A=s;B=r;t=c[H>>2]|0;s=A;r=B;continue b}else if((z|0)==1){H=c[u+4>>2]|0;F=c[H>>2]|0;I=H+4|0;x=c[I>>2]|0;D=lla(b,0,0,1,32)|0;if((D|0)==0){G=29;break b}E=lla(b,0,0,1,8)|0;y=D+4|0;c[y>>2]=E;if((E|0)==0){G=29;break b}c[D>>2]=1;c[D+8>>2]=-1;c[D+12>>2]=-1;c[E>>2]=F;c[(c[y>>2]|0)+4>>2]=x;c[D+16>>2]=(c[x+16>>2]|0)+(c[F+16>>2]|0);c[t>>2]=D;D=c[y>>2]|0;c[D>>2]=0;y=D+4|0;c[y>>2]=0;F=bla(d,c[I>>2]|0)|0;if((F|0)!=0){v=s;w=F;break a}F=bla(d,0)|0;if((F|0)!=0){v=s;w=F;break a}F=bla(d,y)|0;if((F|0)!=0){v=s;w=F;break a}F=bla(d,1)|0;if((F|0)!=0){v=s;w=F;break a}F=bla(d,c[H>>2]|0)|0;if((F|0)!=0){v=s;w=F;break a}J=r;K=s;L=D;M=bla(d,0)|0}else if((z|0)==0){D=c[u+4>>2]|0;F=c[D+8>>2]|0;H=c[D>>2]|0;y=c[D+4>>2]|0;do{if((H|0)>-1|(H|0)==-4){N=r;O=y;P=H;Q=s+1|0;R=(c[g>>2]|0)+F|0}else{if(!((H|0)==-3)){N=r;O=y;P=H;Q=s;R=F;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=y;P=-3;Q=s;R=F;break}c[h+(y<<2)>>2]=1;N=0;O=y;P=-3;Q=s;R=F}}while(0);F=lla(b,0,0,1,32)|0;y=F;do{if((F|0)==0){S=0}else{H=lla(b,0,0,1,20)|0;c[F+4>>2]=H;if((H|0)==0){S=0;break}c[F>>2]=0;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=P;c[H+4>>2]=O;c[H+8>>2]=R;S=y}}while(0);c[t>>2]=S;y=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=y;break}c[k>>2]=R;J=N;K=Q;L=t;M=y}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function dla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=lla(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=lla(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=lla(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=lla(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function ela(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=lla(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=lla(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=lla(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=lla(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function fla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function gla(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=205464}else{j=b;k=205464;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((pma(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Sc(e|0,f|0,205752,g|0)|0)+1|0;i=d;return h|0}function hla(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=Nla(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=Nla(y)|0;if((z|0)==0){A=12;break}tma(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=Rka(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((wka(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((wka(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((wka(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((wka(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(wka(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(wka(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(wka(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(wka(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){tma(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=Rka(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((wka(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((wka(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((wka(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((wka(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(wka(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(wka(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(wka(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(wka(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((Aka(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=Mka(X)|0;qb=_a+24|0;if((Aka(fb,c[qb>>2]|0)|0)!=0){break}fb=Kka(X)|0;if((Aka(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((Aka(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=Kka(X)|0;if((Aka(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=Mka(X)|0;if((Aka(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}Ola(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=jla(0,0)|0;if((S|0)==0){A=12;break}R=lla(S,0,0,0,32)|0;Q=R;if((R|0)==0){kla(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=Nla(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=Nla(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=Nla(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){tma(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){tma(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=Rka(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((wka(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((wka(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((wka(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((wka(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(wka(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(wka(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(wka(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(wka(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=lla(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=lla(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;ila(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((mma(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=Rka(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=Rka(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((wka(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((wka(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((wka(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((wka(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(wka(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(wka(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(wka(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(wka(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((Aka(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=Mka(tc)|0;aa=Ca+24|0;if((Aka(qa,c[aa>>2]|0)|0)!=0){break}qa=Kka(tc)|0;if((Aka(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((Aka(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=Kka(tc)|0;if((Aka(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=Mka(tc)|0;if((Aka(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=lla(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=lla(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){kla(S);if((Eb|0)!=0){Ola(O)}if((Kb|0)!=0){Ola(Kb)}if((Lb|0)==0){A=12;break a}Ola(N);A=12;break a}else if((sa|0)==67){kla(S);if((Eb|0)!=0){Ola(O)}if((Kb|0)!=0){Ola(Kb)}if((Lb|0)==0){A=12;break a}Ola(N);A=12;break a}else if((sa|0)==169){kla(S);if((Eb|0)!=0){Ola(O)}if((Kb|0)!=0){Ola(Kb)}if((Lb|0)==0){A=12;break a}Ola(N);A=12;break a}else if((sa|0)==176){kla(S);if((Eb|0)!=0){Ola(O)}if((Kb|0)!=0){Ola(Kb)}if((Lb|0)==0){A=12;break a}Ola(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);kla(S);if((Jb|0)!=0){Ola(Jb)}if((Gb|0)!=0){Ola(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}Ola(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}ila(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}Ola(m);p=A;i=g;return p|0}function ila(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function jla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=Pla(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function kla(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;Ola(e);i=b;return}else{f=d}while(1){Ola(c[f>>2]|0);d=c[f+4>>2]|0;Ola(f);if((d|0)==0){break}else{f=d}}e=a;Ola(e);i=b;return}function lla(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=Nla(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=Nla(p)|0;c[o>>2]=r;if((r|0)==0){Ola(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}tma(m|0,0,h|0)|0;j=m;i=g;return j|0}function mla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((nla(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function nla(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function ola(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function pla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function qla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function rla(a){a=a|0;i=i;return}function sla(a){a=a|0;c[a>>2]=205768;i=i;return}function tla(a){a=a|0;var b=0;b=i;Bb(a|0);Vla(a);i=b;return}function ula(a){a=a|0;var b=0;b=i;Bb(a|0);i=b;return}function vla(a){a=a|0;i=i;return 205784}function wla(a){a=a|0;i=i;return}function xla(a){a=a|0;i=i;return}function yla(a){a=a|0;i=i;return}function zla(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Ala(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Bla(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Cla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=Gla(b,205896,205952,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Oe[c[(c[h>>2]|0)+28>>2]&63](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function Dla(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Ela(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Oe[c[(c[h>>2]|0)+28>>2]&63](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Fla(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Oe[c[(c[l>>2]|0)+28>>2]&63](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Oe[c[(c[m>>2]|0)+28>>2]&63](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function Gla(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;xe[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}ie[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function Hla(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;xe[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;ie[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;ie[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;ie[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;ie[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function Ila(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;ie[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;xe[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function Jla(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function Kla(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;xe[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;xe[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function Lla(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;xe[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function Mla(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function Nla(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[51550]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=206240+(j<<2)|0;l=206240+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[51550]=f&~(1<<h)}else{if(n>>>0<(c[206216>>2]|0)>>>0){nd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{nd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[206208>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=206240+(r<<2)|0;o=206240+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[51550]=f&~(1<<t)}else{if(n>>>0<(c[206216>>2]|0)>>>0){nd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{nd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[206208>>2]|0;if((n|0)!=0){f=c[206220>>2]|0;e=n>>>3;n=e<<1;g=206240+(n<<2)|0;m=c[51550]|0;j=1<<e;do{if((m&j|0)==0){c[51550]=m|j;u=206240+(n+2<<2)|0;v=g}else{e=206240+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[206216>>2]|0)>>>0)){u=e;v=h;break}nd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[206208>>2]=o;c[206220>>2]=s;p=k;i=b;return p|0}n=c[206204>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[206504+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[206216>>2]|0;if(h>>>0<k>>>0){nd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){nd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){nd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){nd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){nd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{nd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=206504+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[206204>>2]=c[206204>>2]&~(1<<h);break a}else{if(s>>>0<(c[206216>>2]|0)>>>0){nd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[206216>>2]|0)>>>0){nd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[206208>>2]|0;if((h|0)!=0){s=c[206220>>2]|0;k=h>>>3;h=k<<1;f=206240+(h<<2)|0;m=c[51550]|0;g=1<<k;do{if((m&g|0)==0){c[51550]=m|g;A=206240+(h+2<<2)|0;B=f}else{k=206240+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[206216>>2]|0)>>>0)){A=k;B=e;break}nd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[206208>>2]=t;c[206220>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[206204>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[206504+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[206504+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[206208>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[206216>>2]|0;if(t>>>0<f>>>0){nd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){nd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){nd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){nd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){nd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{nd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=206504+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[206204>>2]=c[206204>>2]&~(1<<e);break c}else{if(t>>>0<(c[206216>>2]|0)>>>0){nd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[206216>>2]|0)>>>0){nd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=206240+(t<<2)|0;s=c[51550]|0;r=1<<e;do{if((s&r|0)==0){c[51550]=s|r;S=206240+(t+2<<2)|0;T=f}else{e=206240+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[206216>>2]|0)>>>0)){S=e;T=k;break}nd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=206504+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[206204>>2]|0;l=1<<U;if((f&l|0)==0){c[206204>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[206216>>2]|0;if(W>>>0<k>>>0){nd()}if(r>>>0<k>>>0){nd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[206208>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[206220>>2]|0;if(W>>>0>15){c[206220>>2]=X+q;c[206208>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[206208>>2]=0;c[206220>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[206212>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[206212>>2]=W;X=c[206224>>2]|0;c[206224>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[51668]|0)==0){X=ob(30)|0;if((X+ -1&X|0)==0){c[206680>>2]=X;c[206676>>2]=X;c[206684>>2]=-1;c[206688>>2]=-1;c[206692>>2]=0;c[206644>>2]=0;c[51668]=(yc(0)|0)&-16^1431655768;break}else{nd()}}}while(0);X=q+48|0;W=c[206680>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[206640>>2]|0;do{if((U|0)!=0){T=c[206632>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[206644>>2]&4|0)==0){U=c[206224>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=206648|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[206212>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[206676>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[206632>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[206640>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[206680>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[206644>>2]=c[206644>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[206632>>2]|0)+ga|0;c[206632>>2]=ia;if(ia>>>0>(c[206636>>2]|0)>>>0){c[206636>>2]=ia}ia=c[206224>>2]|0;W=206648|0;i:do{if((ia|0)==0){aa=c[206216>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[206216>>2]=fa}c[206648>>2]=fa;c[206652>>2]=ga;c[206660>>2]=0;c[206236>>2]=c[51668];c[206232>>2]=-1;aa=0;do{ha=aa<<1;$=206240+(ha<<2)|0;c[206240+(ha+3<<2)>>2]=$;c[206240+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[206224>>2]=fa+ja;c[206212>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[206228>>2]=c[206688>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[206212>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[206224>>2]=ia+na;c[206212>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[206228>>2]=c[206688>>2];break i}}while(0);if(fa>>>0<(c[206216>>2]|0)>>>0){c[206216>>2]=fa}aa=fa+ga|0;$=206648|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[206224>>2]|0)){ca=(c[206212>>2]|0)+X|0;c[206212>>2]=ca;c[206224>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[206220>>2]|0)){ca=(c[206208>>2]|0)+X|0;c[206208>>2]=ca;c[206220>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=206240+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[206216>>2]|0)>>>0){nd()}if((c[V+12>>2]|0)==(ha|0)){break}nd()}}while(0);if((L|0)==(V|0)){c[51550]=c[51550]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[206216>>2]|0)>>>0){nd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}nd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[206216>>2]|0)>>>0){nd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){nd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{nd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=206504+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[206204>>2]=c[206204>>2]&~(1<<t);break k}else{if(T>>>0<(c[206216>>2]|0)>>>0){nd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[206216>>2]|0)>>>0){nd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=206240+(Z<<2)|0;t=c[51550]|0;T=1<<ca;do{if((t&T|0)==0){c[51550]=t|T;xa=206240+(Z+2<<2)|0;ya=ea}else{ca=206240+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[206216>>2]|0)>>>0)){xa=ca;ya=V;break}nd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=206504+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[206204>>2]|0;L=1<<za;if((ea&L|0)==0){c[206204>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[206216>>2]|0;if(Ba>>>0<S>>>0){nd()}if(T>>>0<S>>>0){nd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=206648|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[206224>>2]=fa+Ha;c[206212>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[206228>>2]=c[206688>>2];c[ba+4>>2]=27;X=206648|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[206648>>2]=fa;c[206652>>2]=ga;c[206660>>2]=0;c[206656>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=206240+(da<<2)|0;aa=c[51550]|0;f=1<<M;do{if((aa&f|0)==0){c[51550]=aa|f;Ia=206240+(da+2<<2)|0;Ja=ha}else{M=206240+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[206216>>2]|0)>>>0)){Ia=M;Ja=T;break}nd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=206504+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[206204>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[206204>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[206216>>2]|0;if(Ma>>>0<f>>>0){nd()}if(M>>>0<f>>>0){nd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[206212>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[206212>>2]=W;ia=c[206224>>2]|0;c[206224>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Tc()|0)>>2]=12;p=0;i=b;return p|0}



function Vn(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,14584,s);ib=lb;jb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}cm(t,c[ib>>2]|0,jb);jb=+h[t>>3];pm(u,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(v,c[ib>>2]|0,jb,+h[u>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);jb=+h[v>>3];cm(w,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[w>>3];pm(x,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(y,c[ib>>2]|0,pb,+h[x>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+8>>3];qb=+yd(1.0e-13,+(+h[w+16>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,14656,14576,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{cm(z,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);sb=+h[z>>3];pm(A,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(B,c[ib>>2]|0,sb,+h[A>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);sb=+h[B>>3];cm(C,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[C>>3];pm(D,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(E,c[ib>>2]|0,jb,+h[D>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+16>>3]- +h[E>>3]));pb=1.0- +h[C+8>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,14656,14576,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{cm(F,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);vb=+h[F>>3];pm(G,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(H,c[ib>>2]|0,vb,+h[G>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);vb=+h[H>>3];cm(I,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);sb=+h[I>>3];pm(J,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(K,c[ib>>2]|0,sb,+h[J>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);sb=+h[K>>3];cm(L,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[L>>3];pm(M,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(N,c[ib>>2]|0,jb,+h[M>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[N>>3])|0)<<24>>24==0){cm(O,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[O>>3];pm(P,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Q,c[ib>>2]|0,+h[P>>3],+h[P+168>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(R,c[ib>>2]|0,+h[Q>>3],+h[Q+168>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(S,c[ib>>2]|0,jb,pb,+h[Q>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+168>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+184>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}cm(T,c[ib>>2]|0,+h[xb>>3]);qb=+h[T>>3];pm(U,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(V,c[ib>>2]|0,qb,+h[U>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);qb=+h[V>>3];cm(W,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);pb=+h[W>>3];pm(X,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Y,c[ib>>2]|0,pb,+h[X>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);pb=+h[Y>>3];cm(Z,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);jb=+h[Z>>3];pm(_,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm($,c[ib>>2]|0,+h[_>>3],+h[_+168>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(aa,c[ib>>2]|0,+h[$>>3],+h[$+168>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(ba,c[ib>>2]|0,jb,rb,+h[$>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+168>>3],0.0);zb=+h[ba>>3];cm(ca,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);rb=+h[ca>>3];pm(ea,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+16>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+176>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+8>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,14968,14576,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+8>>3];Cb=+h[ca+16>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,14656,14576,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+176>>3]-wb}wb=+h[tb>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,14584,r);Gb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,14584,q);Hb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}cm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];pm(ha,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Hb=+h[ia>>3];cm(ja,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Fb=+h[ja>>3];pm(ka,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,14584,p);Ib=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,14584,o);Jb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,14584,n);Kb=+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]}qb=Kb+-273.15;dm(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];cm(na,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[na>>3];pm(oa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);qb=+h[pa>>3];cm(qa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[qa>>3];pm(ra,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+8>>3];rb=+yd(1.0e-13,+(+h[qa+16>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,14656,14576,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{cm(ta,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Lb=+h[ta>>3];pm(ua,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Lb=+h[va>>3];cm(wa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[wa>>3];pm(xa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+16>>3]- +h[ya>>3]));Eb=1.0- +h[wa+8>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,14656,14576,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{cm(za,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Ob=+h[za>>3];pm(Aa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Ob=+h[Ba>>3];cm(Ca,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Lb=+h[Ca>>3];pm(Da,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Lb=+h[Ea>>3];cm(Fa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Fa>>3];pm(Ga,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+16>>3]- +h[Ha>>3])|0)<<24>>24==0){cm(Ia,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Ia>>3];pm(Ja,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Ka,c[ib>>2]|0,+h[Ja>>3],+h[Ja+168>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(La,c[ib>>2]|0,+h[Ka>>3],+h[Ka+168>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Ma,c[ib>>2]|0,qb,Eb,+h[Ka>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+168>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+184>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}cm(Na,c[ib>>2]|0,+h[Qb>>3]);rb=+h[Na>>3];pm(Oa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);rb=+h[Pa>>3];cm(Qa,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Eb=+h[Qa>>3];pm(Ra,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Eb=+h[Sa>>3];cm(Ta,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);qb=+h[Ta>>3];pm(Ua,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Va,c[ib>>2]|0,+h[Ua>>3],+h[Ua+168>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(Wa,c[ib>>2]|0,+h[Va>>3],+h[Va+168>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Xa,c[ib>>2]|0,qb,Bb,+h[Va>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+168>>3],0.0);Cb=+h[Xa>>3];cm(Ya,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Bb=+h[Ya>>3];pm(Za,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+16>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+176>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+8>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,14968,14576,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+8>>3];Tb=+h[Ya+16>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,14656,14576,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+176>>3]-Pb}Pb=+h[Mb>>3];Wb=Pb+-273.15;Cb=+h[Mb+168>>3];om($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];cm(ab,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Pb=+h[ab>>3];pm(bb,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Pb=+h[cb>>3];cm(db,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);Wb=+h[db>>3];pm(eb,c[ib>>2]|0,+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]);dm(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[c[(c[c[gb>>2]>>2]|0)+8>>2]>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,15584,14576,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+176>>3]-ub);ub=+h[Yb+168>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,15584,14576,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+168>>3];ac=+h[Yb>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+8>>3];Gb=+yd(1.0e-13,+(+h[Yb+16>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,14656,14576,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,15584,14576,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+176>>3];ic=+h[gc+168>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,15584,14576,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+168>>3];kc=+h[gc>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+8>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+16>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2304|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2304|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,14656,14576,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2304|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function Wn(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2656>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2632>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2640>>3];h[a+8>>3]=+h[d+2432>>3];h[e+8>>3]=+h[d+2408>>3];h[f+8>>3]=+h[d+2416>>3];i=i;return}function Xn(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+184>>3]=+h[b>>3];h[a+168>>3]=+h[b+8>>3];Qn(f);Rn(f);Sn(f);Tn(f);Un(f);Vn(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+456|0;j=+h[g>>3];k=+h[f>>3];l=j*k;b=f+168|0;a=f+2232|0;h[d>>3]=+h[f+2312>>3]*l*l+(+h[f+16>>3]*(j*+h[b>>3]+k*+h[a>>3])-l*+h[f+184>>3]);h[d+8>>3]=+h[f+2064>>3]+(+h[a>>3]*+h[f>>3]+(+h[g>>3]*+h[b>>3]- +h[f+2304>>3]));i=e;return}function Yn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0;b=i;i=i+24|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;YT(e,1,.01,b+16|0);g=c[a+536>>2]|0;j=a+4|0;k=+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3256>>3];a=d;l=e;c[a+0>>2]=c[l+0>>2];c[a+4>>2]=c[l+4>>2];c[a+8>>2]=c[l+8>>2];Pm(f,g,k,293.15,d);h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+3672>>3]=+h[f>>3];i=b;return}function Zn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0;b=i;i=i+120|0;d=b;e=b+96|0;f=b+112|0;g=i;i=i+48|0;j=i;i=i+8|0;l=i;i=i+48|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+96|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;YT(n,1,.01,m);m=l;h[k>>3]=575.573102;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+8|0;h[k>>3]=.931782653;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+16|0;h[k>>3]=.00722271286;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+24|0;h[k>>3]=-734255737.0e-14;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+32|0;h[k>>3]=4.95504349e-9;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=l+40|0;h[k>>3]=-1.336933246e-12;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(p,7,-39479.6083,l);l=j;h[k>>3]=17.24205775;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];YT(q,2,-33039.7431,j);j=g;h[k>>3]=-2412.698562;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+8|0;h[k>>3]=4.64611078;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+16|0;h[k>>3]=.002291998307;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+24|0;h[k>>3]=-6.836830479999999e-7;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+32|0;h[k>>3]=9.426468930000001e-11;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=g+40|0;h[k>>3]=-4.82238053e-15;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];YT(r,7,1034972.096,g);g=f;h[k>>3]=-7.97814851;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];YT(s,2,-13842.86509,f);c[o>>2]=14304;h[o+8>>3]=.01801528;h[o+16>>3]=-13423382.81725291;h[o+24>>3]=549760.6476280135;h[o+32>>3]=1.0e3;f=o+40|0;g=p;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];g=o+52|0;f=q;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];f=o+64|0;g=r;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];g=o+76|0;f=s;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];h[o+88>>3]=461.5233290850878;f=c[a+536>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;u=+h[a+3672>>3];v=+h[a+3256>>3];a=e;s=n;c[a+0>>2]=c[s+0>>2];c[a+4>>2]=c[s+4>>2];c[a+8>>2]=c[s+8>>2];s=d+0|0;a=o+0|0;o=s+96|0;do{c[s>>2]=c[a>>2];s=s+4|0;a=a+4|0}while((s|0)<(o|0));em(t,f,u,190.0,647.0,v,e,d,1.0e-13);h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3]=+h[t>>3];i=b;return}function _n(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0.0,x=0,y=0.0;b=i;i=i+104|0;d=b;e=b+32|0;f=b+48|0;g=b+80|0;j=b+96|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+32|0;o=i;i=i+16|0;p=i;i=i+32|0;q=i;i=i+8|0;r=i;i=i+8|0;s=a+4|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+32>>3];v=l;h[k>>3]=+h[t+1144>>3];c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];YT(m,2,u,l);l=a+536|0;v=c[l>>2]|0;t=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[t+40>>3];w=+h[t+24>>3];t=g;x=m;c[t+0>>2]=c[x+0>>2];c[t+4>>2]=c[x+4>>2];c[t+8>>2]=c[x+8>>2];Ml(n,v,u,w,g);g=c[l>>2]|0;v=f;x=n;c[v+0>>2]=c[x+0>>2];c[v+4>>2]=c[x+4>>2];c[v+8>>2]=c[x+8>>2];c[v+12>>2]=c[x+12>>2];c[v+16>>2]=c[x+16>>2];c[v+20>>2]=c[x+20>>2];c[v+24>>2]=c[x+24>>2];c[v+28>>2]=c[x+28>>2];Rl(q,g,f);w=+h[q>>3];q=j;h[k>>3]=.99;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];YT(o,2,.01,j);j=c[l>>2]|0;q=c[(c[c[s>>2]>>2]|0)+8>>2]|0;u=+h[q+3256>>3];y=+h[q+1152>>3];q=e;f=o;c[q+0>>2]=c[f+0>>2];c[q+4>>2]=c[f+4>>2];c[q+8>>2]=c[f+8>>2];Ml(p,j,u,y,e);e=c[l>>2]|0;l=d;j=p;c[l+0>>2]=c[j+0>>2];c[l+4>>2]=c[j+4>>2];c[l+8>>2]=c[j+8>>2];c[l+12>>2]=c[j+12>>2];c[l+16>>2]=c[j+16>>2];c[l+20>>2]=c[j+20>>2];c[l+24>>2]=c[j+24>>2];c[l+28>>2]=c[j+28>>2];Rl(r,e,d);d=c[a+416>>2]|0;h[(c[(c[c[s>>2]>>2]|0)+8>>2]|0)+680>>3]=+h[d+496>>3]*(w- +h[r>>3])*+h[d+1440>>3];i=b;return}function $n(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=c[b+416>>2]|0;f=+h[e+496>>3]*+h[e+1440>>3];e=b+4|0;g=c[c[e>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+680>>3];l=-k;if(f!=0.0){m=j;n=l/f;o=m;p=o+624|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+624|0;q=p;h[q>>3]=n;i=d;return}k=l/+XS(c[b+536>>2]|0,f,15616,15608,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+624|0;q=p;h[q>>3]=n;i=d;return}function ao(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=f;h[k>>3]=.99;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(g,2,.01,f);f=a+536|0;m=c[f>>2]|0;n=a+4|0;a=c[(c[c[n>>2]>>2]|0)+8>>2]|0;o=+h[a+3256>>3];p=+h[a+1152>>3];a=e;q=g;c[a+0>>2]=c[q+0>>2];c[a+4>>2]=c[q+4>>2];c[a+8>>2]=c[q+8>>2];Ml(j,m,o,p,e);e=c[f>>2]|0;f=d;m=j;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];Sl(l,e,d);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+752>>3]=+h[l>>3];i=b;return}function bo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0;b=i;i=i+56|0;d=b;e=b+32|0;f=b+48|0;g=i;i=i+16|0;j=i;i=i+32|0;l=i;i=i+8|0;m=f;h[k>>3]=.99;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];YT(g,2,.01,f);f=a+536|0;m=c[f>>2]|0;n=a+4|0;a=c[(c[c[n>>2]>>2]|0)+8>>2]|0;o=+h[a+3256>>3];p=+h[a+1152>>3];a=e;q=g;c[a+0>>2]=c[q+0>>2];c[a+4>>2]=c[q+4>>2];c[a+8>>2]=c[q+8>>2];Ml(j,m,o,p,e);e=c[f>>2]|0;f=d;m=j;c[f+0>>2]=c[m+0>>2];c[f+4>>2]=c[m+4>>2];c[f+8>>2]=c[m+8>>2];c[f+12>>2]=c[m+12>>2];c[f+16>>2]=c[m+16>>2];c[f+20>>2]=c[m+20>>2];c[f+24>>2]=c[m+24>>2];c[f+28>>2]=c[m+28>>2];Vl(l,e,d);h[(c[(c[c[n>>2]>>2]|0)+8>>2]|0)+808>>3]=+h[l>>3];i=b;return}function co(a,b){a=a|0;b=b|0;var d=0;d=c[a+8>>2]|0;h[c[b+16>>2]>>3]=+h[d+45664>>3];h[c[b+8>>2]>>3]=+h[d+45640>>3];h[c[b+12>>2]>>3]=+h[d+45648>>3];i=i;return}function eo(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0;f=i;i=i+8|0;g=f;j=b;k=b+4|0;h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+3256>>3]=+h[d>>3];Yn(j);Zn(j);_n(j);$n(j);ao(j);bo(j);l=+h[b+304>>3];j=b+536|0;d=c[(c[c[k>>2]>>2]|0)+8>>2]|0;m=b+416|0;n=c[m>>2]|0;o=+h[n+528>>3];_l(g,c[j>>2]|0,+h[d+624>>3],+h[d+808>>3],+h[d+816>>3],+h[d+752>>3],+h[d+760>>3],+h[d+3136>>3],+h[n+512>>3],+h[d+2664>>3]*+h[n+1504>>3],(o+o)*.5,+h[n+1496>>3]/3.0,+h[n+1464>>3]);o=+h[g>>3];g=c[c[k>>2]>>2]|0;k=c[g+8>>2]|0;p=+h[k+928>>3];q=l+-1.0;n=c[m>>2]|0;r=+h[k+624>>3]- +h[k+2664>>3]*+h[n+1504>>3]*+h[n+1520>>3];s=+h[n+1472>>3];t=+h[n+1480>>3];if(s!=0.0){u=n;v=t/s;w=r*v;x=q*w;y=u;z=y+1440|0;A=z;B=+h[A>>3];C=o*B;D=l*C;E=x-D;F=p+E;h[e>>3]=F;i=f;return}if(t==0.0){u=n;v=t;w=r*v;x=q*w;y=u;z=y+1440|0;A=z;B=+h[A>>3];C=o*B;D=l*C;E=x-D;F=p+E;h[e>>3]=F;i=f;return}G=t/+XS(c[j>>2]|0,s,14224,15672,+h[g>>3],(a[b+319|0]|0)!=0|0);u=c[m>>2]|0;v=G;w=r*v;x=q*w;y=u;z=y+1440|0;A=z;B=+h[A>>3];C=o*B;D=l*C;E=x-D;F=p+E;h[e>>3]=F;i=f;return}function fo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;jm(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+208>>3]*.999;l=j;m=l+2224|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;rm(e,c[f>>2]|0,+h[d+24>>3],+h[d+192>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+2224|0;n=m;h[n>>3]=k;i=b;return}}function go(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+504>>3];k=+yd(1.0e-13,+(+h[g+40>>3]-j));l=+h[g+1144>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,15688,15680,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2056|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+40>>3]- +h[f+504>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+504>>3];j=+h[x+40>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2192>>3];k=+h[x+1144>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+208>>3]- +h[x+2224>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+208>>3]- +h[x+2224>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+208>>3]- +h[x+2224>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+208>>3]- +h[x+2224>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,15752,15680,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1144>>3];C=+h[L+504>>3];D=+h[L+40>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+2224>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,15688,15680,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2056|0;w=v;h[w>>3]=n;i=d;return}function ho(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+32>>3]- +h[a+520>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+2216|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+200>>3]- +h[a+2056>>3];g=a;j=g+2216|0;k=j;h[k>>3]=f;i=b;return}function io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+200>>3]- +h[b+2216>>3];i=i;return}function jo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+536>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+2216>>3];o=+h[g+2192>>3]*k+ +h[g+1144>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,15896,15888,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+2216>>3];q=+h[v+536>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+2048>>3]*(1.0-q)+ +h[r+528>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+2208|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+2208|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,15896,15888,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+2208|0;C=B;h[C>>3]=z;i=d;return}function ko(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,15952,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}cm(t,c[ib>>2]|0,jb);jb=+h[t>>3];pm(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);jb=+h[v>>3];cm(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[w>>3];pm(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+32>>3];qb=+yd(1.0e-13,+(+h[w+40>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,16024,15944,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{cm(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);sb=+h[z>>3];pm(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);sb=+h[B>>3];cm(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[C>>3];pm(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+40>>3]- +h[E>>3]));pb=1.0- +h[C+32>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,16024,15944,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{cm(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);vb=+h[F>>3];pm(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);vb=+h[H>>3];cm(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);sb=+h[I>>3];pm(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);sb=+h[K>>3];cm(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[L>>3];pm(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[N>>3])|0)<<24>>24==0){cm(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[O>>3];pm(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Q,c[ib>>2]|0,+h[P+24>>3],+h[P+192>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(R,c[ib>>2]|0,+h[Q+24>>3],+h[Q+192>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(S,c[ib>>2]|0,jb,pb,+h[Q+24>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+192>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+208>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}cm(T,c[ib>>2]|0,+h[xb+24>>3]);qb=+h[T>>3];pm(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);qb=+h[V>>3];cm(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);pb=+h[W>>3];pm(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);pb=+h[Y>>3];cm(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);jb=+h[Z>>3];pm(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm($,c[ib>>2]|0,+h[_+24>>3],+h[_+192>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(aa,c[ib>>2]|0,+h[$+24>>3],+h[$+192>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(ba,c[ib>>2]|0,jb,rb,+h[$+24>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+192>>3],0.0);zb=+h[ba>>3];cm(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);rb=+h[ca>>3];pm(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+40>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+200>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+32>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,16336,15944,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+32>>3];Cb=+h[ca+40>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,16024,15944,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+200>>3]-wb}wb=+h[tb+24>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,15952,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,15952,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}cm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];pm(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Hb=+h[ia>>3];cm(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Fb=+h[ja>>3];pm(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,15952,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,15952,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,15952,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]}qb=Kb+-273.15;dm(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];cm(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[na>>3];pm(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);qb=+h[pa>>3];cm(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[qa>>3];pm(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+32>>3];rb=+yd(1.0e-13,+(+h[qa+40>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,16024,15944,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{cm(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Lb=+h[ta>>3];pm(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Lb=+h[va>>3];cm(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[wa>>3];pm(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+40>>3]- +h[ya>>3]));Eb=1.0- +h[wa+32>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,16024,15944,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{cm(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Ob=+h[za>>3];pm(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Ob=+h[Ba>>3];cm(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Lb=+h[Ca>>3];pm(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Lb=+h[Ea>>3];cm(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Fa>>3];pm(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+40>>3]- +h[Ha>>3])|0)<<24>>24==0){cm(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Ia>>3];pm(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Ka,c[ib>>2]|0,+h[Ja+24>>3],+h[Ja+192>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(La,c[ib>>2]|0,+h[Ka+24>>3],+h[Ka+192>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+24>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+192>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+208>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}cm(Na,c[ib>>2]|0,+h[Qb+24>>3]);rb=+h[Na>>3];pm(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);rb=+h[Pa>>3];cm(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Eb=+h[Qa>>3];pm(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Eb=+h[Sa>>3];cm(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);qb=+h[Ta>>3];pm(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;sm(Va,c[ib>>2]|0,+h[Ua+24>>3],+h[Ua+192>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tm(Wa,c[ib>>2]|0,+h[Va+24>>3],+h[Va+192>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;om(Xa,c[ib>>2]|0,qb,Bb,+h[Va+24>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+192>>3],0.0);Cb=+h[Xa>>3];cm(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Bb=+h[Ya>>3];pm(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+40>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+200>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+32>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,16336,15944,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+32>>3];Tb=+h[Ya+40>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,16024,15944,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+200>>3]-Pb}Pb=+h[Mb+24>>3];Wb=Pb+-273.15;Cb=+h[Mb+192>>3];om($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];cm(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Pb=+h[ab>>3];pm(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Pb=+h[cb>>3];cm(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);Wb=+h[db>>3];pm(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]);dm(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+24>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+24>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,16952,15944,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+24>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+200>>3]-ub);ub=+h[Yb+192>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,16952,15944,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+192>>3];ac=+h[Yb+24>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+32>>3];Gb=+yd(1.0e-13,+(+h[Yb+40>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,16024,15944,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+24>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,16952,15944,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+24>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+200>>3];ic=+h[gc+192>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,16952,15944,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+192>>3];kc=+h[gc+24>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+32>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+40>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2288|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2288|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,16024,15944,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+2288|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function lo(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+2992>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+2968>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+2976>>3];h[a+8>>3]=+h[d+2768>>3];h[e+8>>3]=+h[d+2744>>3];h[f+8>>3]=+h[d+2752>>3];i=i;return}function mo(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+208>>3]=+h[b>>3];h[a+192>>3]=+h[b+8>>3];fo(f);go(f);ho(f);io(f);jo(f);ko(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+568|0;j=+h[g>>3];b=f+24|0;k=+h[b>>3];l=j*k;a=f+192|0;m=f+2208|0;h[d>>3]=+h[f+2296>>3]*l*l+(+h[f+40>>3]*(j*+h[a>>3]+k*+h[m>>3])-l*+h[f+208>>3]);h[d+8>>3]=+h[f+2040>>3]+(+h[m>>3]*+h[b>>3]+(+h[g>>3]*+h[a>>3]- +h[f+2288>>3]));i=e;return}function no(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+536|0;g=a+4|0;dn(d,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3]);if((vW(+h[d>>3],+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3]*.999)|0)<<24>>24==0){d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=d;k=+h[d+328>>3]*.999;l=j;m=l+3720|0;n=m;h[n>>3]=k;i=b;return}else{d=c[(c[c[g>>2]>>2]|0)+8>>2]|0;hn(e,c[f>>2]|0,+h[d+152>>3],+h[d+320>>3]);j=c[(c[c[g>>2]>>2]|0)+8>>2]|0;k=+h[e>>3];l=j;m=l+3720|0;n=m;h[n>>3]=k;i=b;return}}function oo(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3464>>3];k=+yd(1.0e-13,+(+h[g+160>>3]-j));l=+h[g+1912>>3];do{if(k!=0.0){m=l/k}else{if(l==0.0){m=l;break}m=l/+XS(c[b+536>>2]|0,k,16984,16976,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(j*m*.6219647130774989,1.0)|0)<<24>>24==0){n=0.0;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3696|0;w=v;h[w>>3]=n;i=d;return}f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=xW(1.0e-13,+h[f+160>>3]- +h[f+3464>>3])|0;f=c[c[e>>2]>>2]|0;x=c[f+8>>2]|0;m=+h[x+3464>>3];j=+h[x+160>>3];k=+yd(1.0e-13,+(j-m));l=k*k;y=k*+h[x+2120>>3];k=+h[x+1912>>3];z=g<<24>>24!=0;do{if(l!=0.0){if(z){A=0.0}else{A=+h[x+328>>3]- +h[x+3720>>3]}B=k;C=m;D=j;E=x;F=f;G=(y-k*A)/l}else{if(z){H=0.0}else{H=+h[x+328>>3]- +h[x+3720>>3]}if(y-k*H==0.0){if(z){I=0.0}else{I=+h[x+328>>3]- +h[x+3720>>3]}B=k;C=m;D=j;E=x;F=f;G=y-k*I;break}else{if(z){J=0.0}else{J=+h[x+328>>3]- +h[x+3720>>3]}K=(y-k*J)/+XS(c[b+536>>2]|0,l,17040,16976,+h[f>>3],(a[b+319|0]|0)!=0|0);g=c[c[e>>2]>>2]|0;L=c[g+8>>2]|0;B=+h[L+1912>>3];C=+h[L+3464>>3];D=+h[L+160>>3];E=L;F=g;G=K;break}}}while(0);l=m*G;G=+h[E+3720>>3];m=+yd(1.0e-13,+(D-C));do{if(m!=0.0){M=B/m}else{if(B==0.0){M=B;break}M=B/+XS(c[b+536>>2]|0,m,16984,16976,+h[F>>3],(a[b+319|0]|0)!=0|0)}}while(0);n=(l+G*M)*.6219647130774989;o=c[e>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3696|0;w=v;h[w>>3]=n;i=d;return}function po(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;e=(xW(+h[a+136>>3]- +h[a+3480>>3],0.0)|0)<<24>>24==0;a=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(e){f=0.0;g=a;j=g+3712|0;k=j;h[k>>3]=f;i=b;return}f=+h[a+304>>3]- +h[a+3696>>3];g=a;j=g+3712|0;k=j;h[k>>3]=f;i=b;return}function qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3688>>3]=+h[b+304>>3]- +h[b+3712>>3];i=i;return}function ro(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0,q=0.0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+3496>>3];k=1.0-j;l=k*k;m=l!=0.0;n=+h[g+3712>>3];o=+h[g+2120>>3]*k+ +h[g+1912>>3]*n;do{if(m){p=n;q=j;r=g;s=f;t=o/l}else{if(o==0.0){p=n;q=j;r=g;s=f;t=o;break}k=o/+XS(c[b+536>>2]|0,l,17168,17160,+h[f>>3],(a[b+319|0]|0)!=0|0);u=c[c[e>>2]>>2]|0;v=c[u+8>>2]|0;p=+h[v+3712>>3];q=+h[v+3496>>3];r=v;s=u;t=k}}while(0);o=t*287.0512249529787;t=+h[r+3688>>3]*(1.0-q)+ +h[r+3488>>3]*p;if(m){w=r;x=t/l;y=x*461.5233290850878;z=o+y;A=w;B=A+3704|0;C=B;h[C>>3]=z;i=d;return}if(t==0.0){w=r;x=t;y=x*461.5233290850878;z=o+y;A=w;B=A+3704|0;C=B;h[C>>3]=z;i=d;return}p=t/+XS(c[b+536>>2]|0,l,17168,17160,+h[s>>3],(a[b+319|0]|0)!=0|0);w=c[(c[c[e>>2]>>2]|0)+8>>2]|0;x=p;y=x*461.5233290850878;z=o+y;A=w;B=A+3704|0;C=B;h[C>>3]=z;i=d;return}function so(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0.0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0.0,qb=0.0,rb=0.0,sb=0.0,tb=0,ub=0.0,vb=0.0,wb=0.0,xb=0,yb=0.0,zb=0.0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0,Nb=0.0,Ob=0.0,Pb=0.0,Qb=0,Rb=0.0,Sb=0.0,Tb=0.0,Ub=0,Vb=0.0,Wb=0.0,Xb=0.0,Yb=0,Zb=0,_b=0.0,$b=0.0,ac=0.0,bc=0.0,cc=0,dc=0,ec=0.0,fc=0.0,gc=0,hc=0,ic=0.0,jc=0.0,kc=0.0,lc=0.0,mc=0,nc=0.0,oc=0.0,pc=0.0,qc=0.0,rc=0.0,sc=0.0,tc=0.0,uc=0.0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0,Ac=0,Bc=0;d=i;i=i+152|0;e=d;f=d+24|0;g=d+48|0;j=d+72|0;l=d+96|0;m=d+120|0;n=d+144|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+8|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+8|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=b+4|0;hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3];if(hb>0.0){ib=b+536|0;jb=hb}else{kb=c[41338]|0;lb=b+536|0;mb=c[lb>>2]|0;nb=s;h[k>>3]=hb;c[nb>>2]=c[k>>2];c[nb+4>>2]=c[k+4>>2];nb=kb;kb=m;ob=18344;c[kb+0>>2]=c[ob+0>>2];c[kb+4>>2]=c[ob+4>>2];c[kb+8>>2]=c[ob+8>>2];c[kb+12>>2]=c[ob+12>>2];c[kb+16>>2]=c[ob+16>>2];c[kb+20>>2]=c[ob+20>>2];Oe[nb&63](mb,m,17216,s);ib=lb;jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}Zm(t,c[ib>>2]|0,jb);jb=+h[t>>3];en(u,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(v,c[ib>>2]|0,jb,+h[u>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);jb=+h[v>>3];Zm(w,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);pb=+h[w>>3];en(x,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(y,c[ib>>2]|0,pb,+h[x>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);x=c[c[gb>>2]>>2]|0;w=c[x+8>>2]|0;pb=+h[w+136>>3];qb=+yd(1.0e-13,+(+h[w+160>>3]- +h[y>>3]));rb=1.0-pb;do{if(qb!=0.0){sb=rb/qb}else{if(rb==0.0){sb=rb;break}sb=rb/+XS(c[ib>>2]|0,qb,17288,17208,+h[x>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(pb- +xd(+(jb*sb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){tb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;ub=0.0}else{Zm(z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);sb=+h[z>>3];en(A,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(B,c[ib>>2]|0,sb,+h[A>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);sb=+h[B>>3];Zm(C,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);jb=+h[C>>3];en(D,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(E,c[ib>>2]|0,jb,+h[D>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);D=c[c[gb>>2]>>2]|0;C=c[D+8>>2]|0;jb=+yd(1.0e-13,+(+h[C+160>>3]- +h[E>>3]));pb=1.0- +h[C+136>>3];do{if(jb!=0.0){vb=pb/jb}else{if(pb==0.0){vb=pb;break}vb=pb/+XS(c[ib>>2]|0,jb,17288,17208,+h[D>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(sb*vb*.6219647130774989,1.0)|0)<<24>>24==0){wb=0.0}else{Zm(F,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);vb=+h[F>>3];en(G,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(H,c[ib>>2]|0,vb,+h[G>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);vb=+h[H>>3];Zm(I,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);sb=+h[I>>3];en(J,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(K,c[ib>>2]|0,sb,+h[J>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);sb=+h[K>>3];Zm(L,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);jb=+h[L>>3];en(M,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(N,c[ib>>2]|0,jb,+h[M>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+160>>3]- +h[N>>3])|0)<<24>>24==0){Zm(O,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);jb=+h[O>>3];en(P,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);pb=+h[P>>3];P=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jn(Q,c[ib>>2]|0,+h[P+152>>3],+h[P+320>>3]);qb=+h[Q>>3];Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;kn(R,c[ib>>2]|0,+h[Q+152>>3],+h[Q+320>>3]);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;an(S,c[ib>>2]|0,jb,pb,+h[Q+152>>3]+-273.16,1.0,qb,+h[R>>3],+h[Q+320>>3],0.0);Q=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;xb=Q;yb=+h[Q+328>>3]- +h[S>>3]}else{xb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;yb=0.0}Zm(T,c[ib>>2]|0,+h[xb+152>>3]);qb=+h[T>>3];en(U,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(V,c[ib>>2]|0,qb,+h[U>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);qb=+h[V>>3];Zm(W,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);pb=+h[W>>3];en(X,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Y,c[ib>>2]|0,pb,+h[X>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);pb=+h[Y>>3];Zm(Z,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);jb=+h[Z>>3];en(_,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);rb=+h[_>>3];_=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jn($,c[ib>>2]|0,+h[_+152>>3],+h[_+320>>3]);zb=+h[$>>3];$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;kn(aa,c[ib>>2]|0,+h[$+152>>3],+h[$+320>>3]);$=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;an(ba,c[ib>>2]|0,jb,rb,+h[$+152>>3]+-273.16,1.0,zb,+h[aa>>3],+h[$+320>>3],0.0);zb=+h[ba>>3];Zm(ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);rb=+h[ca>>3];en(ea,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(fa,c[ib>>2]|0,rb,+h[ea>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);rb=+h[fa>>3];fa=c[c[gb>>2]>>2]|0;ea=c[fa+8>>2]|0;jb=+h[ea+160>>3];Ab=+yd(1.0e-13,+(jb-qb));qb=Ab*+yd(1.0e-13,+(jb-pb));pb=+h[ea+304>>3];Ab=-(pb*+yd(1.0e-13,+(jb-sb)));sb=+h[ea+136>>3];pb=Ab-yb*(1.0-sb);do{if(qb!=0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb/qb}else{if(pb==0.0){Bb=sb;Cb=jb;Db=fa;Eb=pb;break}yb=pb/+XS(c[ib>>2]|0,qb,17592,17208,+h[fa>>3],(a[b+319|0]|0)!=0|0);ea=c[c[gb>>2]>>2]|0;ca=c[ea+8>>2]|0;Bb=+h[ca+136>>3];Cb=+h[ca+160>>3];Db=ea;Eb=yb}}while(0);qb=vb*Eb;Eb=+yd(1.0e-13,+(Cb-rb));rb=1.0-Bb;do{if(Eb!=0.0){Fb=rb/Eb}else{if(rb==0.0){Fb=rb;break}Fb=rb/+XS(c[ib>>2]|0,Eb,17288,17208,+h[Db>>3],(a[b+319|0]|0)!=0|0)}}while(0);wb=(qb+zb*Fb)*.6219647130774989}Db=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;tb=Db;ub=+h[Db+304>>3]-wb}wb=+h[tb+152>>3];if(wb>0.0){Gb=wb}else{tb=c[41338]|0;Db=c[ib>>2]|0;fa=r;h[k>>3]=wb;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=tb;tb=l;ea=18344;c[tb+0>>2]=c[ea+0>>2];c[tb+4>>2]=c[ea+4>>2];c[tb+8>>2]=c[ea+8>>2];c[tb+12>>2]=c[ea+12>>2];c[tb+16>>2]=c[ea+16>>2];c[tb+20>>2]=c[ea+20>>2];Oe[fa&63](Db,l,17216,r);Gb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}if(Gb>0.0){Hb=Gb}else{r=c[41338]|0;l=c[ib>>2]|0;Db=q;h[k>>3]=Gb;c[Db>>2]=c[k>>2];c[Db+4>>2]=c[k+4>>2];Db=r;r=j;fa=18344;c[r+0>>2]=c[fa+0>>2];c[r+4>>2]=c[fa+4>>2];c[r+8>>2]=c[fa+8>>2];c[r+12>>2]=c[fa+12>>2];c[r+16>>2]=c[fa+16>>2];c[r+20>>2]=c[fa+20>>2];Oe[Db&63](l,j,17216,q);Hb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}Zm(ga,c[ib>>2]|0,Hb);Hb=+h[ga>>3];en(ha,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(ia,c[ib>>2]|0,Hb,+h[ha>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Hb=+h[ia>>3];Zm(ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Fb=+h[ja>>3];en(ka,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(la,c[ib>>2]|0,Fb,+h[ka>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Fb=+h[la>>3];zb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3];if(zb>0.0){Ib=zb}else{la=c[41338]|0;ka=c[ib>>2]|0;ja=p;h[k>>3]=zb;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=la;la=g;ia=18344;c[la+0>>2]=c[ia+0>>2];c[la+4>>2]=c[ia+4>>2];c[la+8>>2]=c[ia+8>>2];c[la+12>>2]=c[ia+12>>2];c[la+16>>2]=c[ia+16>>2];c[la+20>>2]=c[ia+20>>2];Oe[ja&63](ka,g,17216,p);Ib=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}if(Ib>0.0){Jb=Ib}else{p=c[41338]|0;g=c[ib>>2]|0;ka=o;h[k>>3]=Ib;c[ka>>2]=c[k>>2];c[ka+4>>2]=c[k+4>>2];ka=p;p=f;ja=18344;c[p+0>>2]=c[ja+0>>2];c[p+4>>2]=c[ja+4>>2];c[p+8>>2]=c[ja+8>>2];c[p+12>>2]=c[ja+12>>2];c[p+16>>2]=c[ja+16>>2];c[p+20>>2]=c[ja+20>>2];Oe[ka&63](g,f,17216,o);Jb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}if(Jb>0.0){Kb=Jb}else{o=c[41338]|0;f=c[ib>>2]|0;g=n;h[k>>3]=Jb;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=o;o=e;ka=18344;c[o+0>>2]=c[ka+0>>2];c[o+4>>2]=c[ka+4>>2];c[o+8>>2]=c[ka+8>>2];c[o+12>>2]=c[ka+12>>2];c[o+16>>2]=c[ka+16>>2];c[o+20>>2]=c[ka+20>>2];Oe[g&63](f,e,17216,n);Kb=+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]}qb=Kb+-273.15;$m(ma,c[ib>>2]|0,qb*4200.0,qb*2050.0+-333.0e3,Kb+-273.16,.1);Kb=+h[ma>>3];Zm(na,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[na>>3];en(oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(pa,c[ib>>2]|0,qb,+h[oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);qb=+h[pa>>3];Zm(qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Eb=+h[qa>>3];en(ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(sa,c[ib>>2]|0,Eb,+h[ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);ra=c[c[gb>>2]>>2]|0;qa=c[ra+8>>2]|0;Eb=+h[qa+136>>3];rb=+yd(1.0e-13,+(+h[qa+160>>3]- +h[sa>>3]));Bb=1.0-Eb;do{if(rb!=0.0){Lb=Bb/rb}else{if(Bb==0.0){Lb=Bb;break}Lb=Bb/+XS(c[ib>>2]|0,rb,17288,17208,+h[ra>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((xW(Eb- +xd(+(qb*Lb*.6219647130774989),1.0),0.0)|0)<<24>>24==0){Mb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Nb=0.0}else{Zm(ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Lb=+h[ta>>3];en(ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(va,c[ib>>2]|0,Lb,+h[ua>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Lb=+h[va>>3];Zm(wa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[wa>>3];en(xa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(ya,c[ib>>2]|0,qb,+h[xa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);xa=c[c[gb>>2]>>2]|0;wa=c[xa+8>>2]|0;qb=+yd(1.0e-13,+(+h[wa+160>>3]- +h[ya>>3]));Eb=1.0- +h[wa+136>>3];do{if(qb!=0.0){Ob=Eb/qb}else{if(Eb==0.0){Ob=Eb;break}Ob=Eb/+XS(c[ib>>2]|0,qb,17288,17208,+h[xa>>3],(a[b+319|0]|0)!=0|0)}}while(0);if((vW(Lb*Ob*.6219647130774989,1.0)|0)<<24>>24==0){Pb=0.0}else{Zm(za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Ob=+h[za>>3];en(Aa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Ba,c[ib>>2]|0,Ob,+h[Aa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Ob=+h[Ba>>3];Zm(Ca,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Lb=+h[Ca>>3];en(Da,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Ea,c[ib>>2]|0,Lb,+h[Da>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Lb=+h[Ea>>3];Zm(Fa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[Fa>>3];en(Ga,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Ha,c[ib>>2]|0,qb,+h[Ga>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);if((xW(1.0e-13,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+160>>3]- +h[Ha>>3])|0)<<24>>24==0){Zm(Ia,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[Ia>>3];en(Ja,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Eb=+h[Ja>>3];Ja=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jn(Ka,c[ib>>2]|0,+h[Ja+152>>3],+h[Ja+320>>3]);rb=+h[Ka>>3];Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;kn(La,c[ib>>2]|0,+h[Ka+152>>3],+h[Ka+320>>3]);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;an(Ma,c[ib>>2]|0,qb,Eb,+h[Ka+152>>3]+-273.16,1.0,rb,+h[La>>3],+h[Ka+320>>3],0.0);Ka=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Qb=Ka;Rb=+h[Ka+328>>3]- +h[Ma>>3]}else{Qb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Rb=0.0}Zm(Na,c[ib>>2]|0,+h[Qb+152>>3]);rb=+h[Na>>3];en(Oa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Pa,c[ib>>2]|0,rb,+h[Oa>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);rb=+h[Pa>>3];Zm(Qa,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Eb=+h[Qa>>3];en(Ra,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(Sa,c[ib>>2]|0,Eb,+h[Ra>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Eb=+h[Sa>>3];Zm(Ta,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);qb=+h[Ta>>3];en(Ua,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Bb=+h[Ua>>3];Ua=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jn(Va,c[ib>>2]|0,+h[Ua+152>>3],+h[Ua+320>>3]);Cb=+h[Va>>3];Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;kn(Wa,c[ib>>2]|0,+h[Va+152>>3],+h[Va+320>>3]);Va=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;an(Xa,c[ib>>2]|0,qb,Bb,+h[Va+152>>3]+-273.16,1.0,Cb,+h[Wa>>3],+h[Va+320>>3],0.0);Cb=+h[Xa>>3];Zm(Ya,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Bb=+h[Ya>>3];en(Za,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(_a,c[ib>>2]|0,Bb,+h[Za>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Bb=+h[_a>>3];_a=c[c[gb>>2]>>2]|0;Za=c[_a+8>>2]|0;qb=+h[Za+160>>3];vb=+yd(1.0e-13,+(qb-rb));rb=vb*+yd(1.0e-13,+(qb-Eb));Eb=+h[Za+304>>3];vb=-(Eb*+yd(1.0e-13,+(qb-Lb)));Lb=+h[Za+136>>3];Eb=vb-Rb*(1.0-Lb);do{if(rb!=0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb/rb}else{if(Eb==0.0){Sb=Lb;Tb=qb;Ub=_a;Vb=Eb;break}Rb=Eb/+XS(c[ib>>2]|0,rb,17592,17208,+h[_a>>3],(a[b+319|0]|0)!=0|0);Za=c[c[gb>>2]>>2]|0;Ya=c[Za+8>>2]|0;Sb=+h[Ya+136>>3];Tb=+h[Ya+160>>3];Ub=Za;Vb=Rb}}while(0);rb=Ob*Vb;Vb=+yd(1.0e-13,+(Tb-Bb));Bb=1.0-Sb;do{if(Vb!=0.0){Wb=Bb/Vb}else{if(Bb==0.0){Wb=Bb;break}Wb=Bb/+XS(c[ib>>2]|0,Vb,17288,17208,+h[Ub>>3],(a[b+319|0]|0)!=0|0)}}while(0);Pb=(rb+Cb*Wb)*.6219647130774989}Ub=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;Mb=Ub;Nb=+h[Ub+304>>3]-Pb}Pb=+h[Mb+152>>3];Wb=Pb+-273.15;Cb=+h[Mb+320>>3];an($a,c[ib>>2]|0,Wb*4200.0,Wb*2050.0+-333.0e3,Pb+-273.16,.1,Cb*4200.0,Cb*2050.0,Cb,0.0);Cb=+h[$a>>3];Zm(ab,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Pb=+h[ab>>3];en(bb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(cb,c[ib>>2]|0,Pb,+h[bb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Pb=+h[cb>>3];Zm(db,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);Wb=+h[db>>3];en(eb,c[ib>>2]|0,+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]);$m(fb,c[ib>>2]|0,Wb,+h[eb>>3],+h[(c[(c[c[gb>>2]>>2]|0)+8>>2]|0)+152>>3]+-273.16,1.0);Wb=+h[fb>>3];fb=c[c[gb>>2]>>2]|0;eb=c[fb+8>>2]|0;rb=+h[eb+152>>3];Vb=rb*(+da(+hb)*575.573102+rb*(rb*(rb*(rb*(rb*-2.673866492e-13+1.2387608725e-9)+-2447519123333333.0e-21)+.00361135643)+.931782653)+-33039.7431)+39479.6083;do{if(rb!=0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb/rb}else{if(Vb==0.0){Xb=rb;Yb=eb;Zb=fb;_b=Vb;break}hb=Vb/+XS(c[ib>>2]|0,rb,18200,17208,+h[fb>>3],(a[b+319|0]|0)!=0|0);db=c[c[gb>>2]>>2]|0;cb=c[db+8>>2]|0;Xb=+h[cb+152>>3];Yb=cb;Zb=db;_b=hb}}while(0);rb=(_b*461.5233290850878+15970877.13625291)*(+h[Yb+304>>3]-ub);ub=+h[Yb+320>>3];do{if(Xb!=0.0){$b=ub;ac=Xb;bc=ub/Xb}else{if(ub==0.0){$b=ub;ac=Xb;bc=ub;break}_b=ub/+XS(c[ib>>2]|0,Xb,18200,17208,+h[Zb>>3],(a[b+319|0]|0)!=0|0);Yb=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;$b=+h[Yb+320>>3];ac=+h[Yb+152>>3];bc=_b}}while(0);ub=ac*-2.673866492e-13+1.2387608725e-9;_b=ac*ub+-2447519123333333.0e-21;Vb=ac*_b+.00361135643;hb=ac*Vb+.931782653;Bb=ac*hb;Sb=ac*(Xb*(bc*575.573102+(ac*(ac*(ac*(ac*$b*-2.673866492e-13+$b*ub)+$b*_b)+$b*Vb)+$b*hb))+$b*(+da(+wb)*575.573102+Bb+-33039.7431))-$b*(ac*(+da(+Gb)*575.573102+Bb+-33039.7431)+39479.6083);Bb=+DU(ac,-2);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;ac=+h[Yb+136>>3];Gb=+yd(1.0e-13,+(+h[Yb+160>>3]-Fb));Fb=1.0-ac;do{if(Gb!=0.0){cc=Yb;dc=Zb;ec=Fb/Gb}else{if(Fb==0.0){cc=Yb;dc=Zb;ec=Fb;break}$b=Fb/+XS(c[ib>>2]|0,Gb,17288,17208,+h[Zb>>3],(a[b+319|0]|0)!=0|0);fb=c[c[gb>>2]>>2]|0;cc=c[fb+8>>2]|0;dc=fb;ec=$b}}while(0);Gb=Sb*Bb*(ac- +yd(+(ac- +xd(+(Hb*ec*.6219647130774989),1.0)),0.0))*461.5233290850878;ec=+h[cc+152>>3];Hb=ec*(+da(+zb)*-196.827561+ec*(ec*(ec*(ec*(ec*4.37046382e-13+-1.9850744925e-9)+3556199766666667.0e-21)+-.002880506865)+5.00915511)+-176.796731)+-10099.5016;do{if(ec!=0.0){fc=ec;gc=cc;hc=dc;ic=Hb/ec}else{if(Hb==0.0){fc=ec;gc=cc;hc=dc;ic=Hb;break}zb=Hb/+XS(c[ib>>2]|0,ec,18200,17208,+h[dc>>3],(a[b+319|0]|0)!=0|0);Zb=c[c[gb>>2]>>2]|0;Yb=c[Zb+8>>2]|0;fc=+h[Yb+152>>3];gc=Yb;hc=Zb;ic=zb}}while(0);ec=(ic*-287.0512249529787+-29438.51785840345)*+h[gc+304>>3];ic=+h[gc+320>>3];do{if(fc!=0.0){jc=ic;kc=fc;lc=ic/fc}else{if(ic==0.0){jc=ic;kc=fc;lc=ic;break}Hb=ic/+XS(c[ib>>2]|0,fc,18200,17208,+h[hc>>3],(a[b+319|0]|0)!=0|0);gc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;jc=+h[gc+320>>3];kc=+h[gc+152>>3];lc=Hb}}while(0);ic=kc*4.37046382e-13+-1.9850744925e-9;Hb=kc*ic+3556199766666667.0e-21;zb=kc*Hb+-.002880506865;ac=kc*zb+5.00915511;Bb=kc*ac;Sb=kc*(fc*(lc*-196.827561+(kc*(kc*(kc*(kc*jc*4.37046382e-13+jc*ic)+jc*Hb)+jc*zb)+jc*ac))+jc*(+da(+Ib)*-196.827561+Bb+-176.796731))-jc*(kc*(+da(+Jb)*-196.827561+Bb+-176.796731)+-10099.5016);Bb=+DU(kc,-2);hc=c[c[gb>>2]>>2]|0;gc=c[hc+8>>2]|0;kc=+h[gc+136>>3];Jb=1.0-kc;jc=Bb*Jb*Sb*287.0512249529787;Sb=Kb*Nb;Nb=+yd(1.0e-13,+(+h[gc+160>>3]-Wb));if(Nb!=0.0){mc=gc;nc=Jb/Nb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+3728|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}if(Jb==0.0){mc=gc;nc=Jb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+3728|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}Wb=Jb/+XS(c[ib>>2]|0,Nb,17288,17208,+h[hc>>3],(a[b+319|0]|0)!=0|0);mc=c[(c[c[gb>>2]>>2]|0)+8>>2]|0;nc=Wb;oc=Pb*nc;pc=oc*.6219647130774989;qc=+xd(+pc,1.0);rc=kc-qc;sc=+yd(+rc,0.0);tc=Cb*sc;uc=Sb+tc;vc=jc+uc;wc=ec+vc;xc=Gb+wc;yc=rb+xc;zc=mc;Ac=zc+3728|0;Bc=Ac;h[Bc>>3]=yc;i=d;return}function to(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+4560>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+4536>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+4544>>3];h[a+8>>3]=+h[d+4672>>3];h[e+8>>3]=+h[d+4648>>3];h[f+8>>3]=+h[d+4656>>3];i=i;return}function uo(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0.0,l=0.0,m=0.0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+320>>3]=+h[b>>3];h[a+328>>3]=+h[b+8>>3];no(f);oo(f);po(f);qo(f);ro(f);so(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;g=f+3704|0;b=f+152|0;a=f+3528|0;j=f+320|0;h[d>>3]=+h[f+3680>>3]+(+h[g>>3]*+h[b>>3]+(+h[a>>3]*+h[j>>3]- +h[f+3728>>3]));k=+h[a>>3];l=+h[b>>3];m=k*l;h[d+8>>3]=+h[f+3736>>3]*m*m+(+h[f+160>>3]*(k*+h[j>>3]+l*+h[g>>3])-m*+h[f+328>>3]);i=e;return}



function NG(a){a=a|0;var b=0;b=i;Xz(a);Yz(a);Zz(a);_z(a);$z(a);aA(a);bA(a);cA(a);dA(a);eA(a);fA(a);gA(a);hA(a);iA(a);jA(a);kA(a);lA(a);mA(a);nA(a);oA(a);pA(a);qA(a);rA(a);sA(a);tA(a);uA(a);vA(a);wA(a);xA(a);yA(a);zA(a);AA(a);BA(a);CA(a);DA(a);EA(a);FA(a);GA(a);HA(a);IA(a);JA(a);KA(a);LA(a);MA(a);NA(a);OA(a);PA(a);QA(a);RA(a);SA(a);TA(a);UA(a);VA(a);WA(a);XA(a);YA(a);ZA(a);_A(a);$A(a);aB(a);bB(a);cB(a);dB(a);eB(a);fB(a);gB(a);hB(a);iB(a);jB(a);kB(a);lB(a);mB(a);nB(a);oB(a);pB(a);qB(a);rB(a);sB(a);tB(a);uB(a);vB(a);wB(a);xB(a);yB(a);zB(a);AB(a);BB(a);CB(a);DB(a);EB(a);FB(a);GB(a);HB(a);IB(a);JB(a);KB(a);LB(a);MB(a);NB(a);OB(a);PB(a);QB(a);RB(a);SB(a);TB(a);UB(a);VB(a);WB(a);XB(a);YB(a);ZB(a);_B(a);$B(a);aC(a);bC(a);cC(a);dC(a);eC(a);fC(a);gC(a);hC(a);iC(a);jC(a);kC(a);lC(a);mC(a);nC(a);oC(a);pC(a);qC(a);rC(a);sC(a);tC(a);uC(a);vC(a);wC(a);xC(a);yC(a);zC(a);AC(a);BC(a);CC(a);DC(a);EC(a);FC(a);GC(a);HC(a);IC(a);JC(a);KC(a);LC(a);MC(a);NC(a);OC(a);PC(a);QC(a);RC(a);SC(a);TC(a);UC(a);VC(a);WC(a);XC(a);YC(a);ZC(a);_C(a);$C(a);aD(a);bD(a);cD(a);dD(a);eD(a);fD(a);gD(a);hD(a);iD(a);jD(a);kD(a);lD(a);mD(a);nD(a);oD(a);pD(a);qD(a);rD(a);sD(a);tD(a);uD(a);vD(a);wD(a);xD(a);yD(a);zD(a);AD(a);BD(a);CD(a);DD(a);ED(a);FD(a);GD(a);HD(a);ID(a);JD(a);KD(a);LD(a);MD(a);ND(a);OD(a);PD(a);QD(a);RD(a);SD(a);TD(a);UD(a);VD(a);WD(a);XD(a);YD(a);ZD(a);_D(a);$D(a);aE(a);bE(a);cE(a);dE(a);eE(a);fE(a);gE(a);hE(a);iE(a);jE(a);kE(a);lE(a);mE(a);nE(a);oE(a);pE(a);qE(a);rE(a);sE(a);tE(a);uE(a);vE(a);wE(a);xE(a);yE(a);zE(a);AE(a);BE(a);CE(a);DE(a);EE(a);FE(a);GE(a);HE(a);IE(a);JE(a);KE(a);LE(a);ME(a);NE(a);OE(a);PE(a);QE(a);RE(a);SE(a);TE(a);UE(a);VE(a);WE(a);XE(a);YE(a);ZE(a);_E(a);$E(a);aF(a);bF(a);cF(a);dF(a);eF(a);fF(a);gF(a);hF(a);iF(a);jF(a);kF(a);lF(a);mF(a);nF(a);oF(a);pF(a);qF(a);rF(a);sF(a);tF(a);uF(a);vF(a);wF(a);xF(a);yF(a);zF(a);AF(a);BF(a);CF(a);DF(a);EF(a);FF(a);GF(a);HF(a);IF(a);JF(a);KF(a);LF(a);MF(a);NF(a);OF(a);PF(a);QF(a);RF(a);SF(a);TF(a);UF(a);VF(a);WF(a);XF(a);YF(a);ZF(a);_F(a);$F(a);aG(a);bG(a);cG(a);dG(a);eG(a);fG(a);gG(a);hG(a);iG(a);jG(a);kG(a);lG(a);mG(a);nG(a);oG(a);pG(a);qG(a);rG(a);sG(a);tG(a);uG(a);vG(a);wG(a);xG(a);yG(a);zG(a);AG(a);BG(a);CG(a);DG(a);EG(a);FG(a);GG(a);HG(a);IG(a);JG(a);KG(a);LG(a);MG(a);i=b;return 0}function OG(b){b=b|0;var c=0;c=i;a[b+314|0]=0;PG(b);i=c;return 0}function PG(a){a=a|0;var b=0;b=i;kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);yf(a);zf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Mf(a);Nf(a);Sf(a);Tf(a);Yf(a);Zf(a);ig(a);jg(a);lg(a);mg(a);pg(a);qg(a);wg(a);xg(a);yg(a);Bg(a);Kg(a);Lg(a);Og(a);Pg(a);Sg(a);Tg(a);Zg(a);_g(a);$g(a);ch(a);dh(a);eh(a);nh(a);oh(a);rh(a);sh(a);uh(a);wh(a);xh(a);Dh(a);Eh(a);Fh(a);Hh(a);Uh(a);bi(a);ci(a);hi(a);ii(a);li(a);oi(a);pi(a);qi(a);ri(a);si(a);ui(a);Bi(a);Ni(a);Oi(a);Pi(a);Ri(a);bj(a);cj(a);dj(a);oj(a);pj(a);yj(a);zj(a);Lj(a);Nj(a);Yj(a);Zj(a);_j(a);$j(a);ak(a);bk(a);ck(a);dk(a);ek(a);fk(a);hk(a);ik(a);jk(a);pk(a);qk(a);vk(a);zk(a);Ik(a);Jk(a);Lk(a);Mk(a);Nk(a);Ok(a);Pk(a);Qk(a);Rk(a);Sk(a);Tk(a);Uk(a);Vk(a);Wk(a);Xk(a);Yk(a);Zk(a);_k(a);$k(a);al(a);bl(a);cl(a);dl(a);el(a);fl(a);gl(a);hl(a);il(a);jl(a);kl(a);ll(a);ml(a);nl(a);ol(a);pl(a);ql(a);rl(a);sl(a);i=b;return}function QG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56200]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(56216,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1984>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[56200]=1;i=d;return}function RG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56384]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3672>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3672>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(56392,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3672>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[56384]=1;i=d;return}function SG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56608]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3664>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3664>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(56616,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3664>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[56608]=1;i=d;return}function TG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56744]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3656>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3656>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(56752,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3656>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[56744]=1;i=d;return}function UG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56896]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3648>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3648>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=CT(56904,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3648>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[56896]=1;i=d;return}function VG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57032]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3632>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3632>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(57040,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3632>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[57032]=1;i=d;return}function WG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57264]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3624>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3624>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(57272,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3624>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[57264]=1;i=d;return}function XG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57416]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3616>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3616>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(57424,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3616>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[57416]=1;i=d;return}function YG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57560]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3608>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3608>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(57568,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3608>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[57560]=1;i=d;return}function ZG(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57704]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3600>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3600>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(57712,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3600>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[57704]=1;i=d;return}function _G(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57872]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(57880,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3576>>3],56208)|0)|0;g=c[41340]|0;j=e;k=58040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[57872]=1;i=d;return}function $G(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58064]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(58072,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1976>>3],56208)|0)|0;g=c[41340]|0;j=e;k=58160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[58064]=1;i=d;return}function aH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58184]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(58192,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1968>>3],56208)|0)|0;g=c[41340]|0;j=e;k=58280;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[58184]=1;i=d;return}function bH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58304]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1960>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1960>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(58312,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1960>>3],56208)|0)|0;g=c[41340]|0;j=e;k=58456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[58304]=1;i=d;return}function cH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58480]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2792>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2792>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(58488,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2792>>3],56208)|0)|0;g=c[41340]|0;j=e;k=59056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[58480]=1;i=d;return}function dH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58720]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2800>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2800>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(58728,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2800>>3],56208)|0)|0;g=c[41340]|0;j=e;k=59056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[58720]=1;i=d;return}function eH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58888]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2808>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2808>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(58896,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2808>>3],56208)|0)|0;g=c[41340]|0;j=e;k=59056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[58888]=1;i=d;return}function fH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59080]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2760>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2760>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(59088,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2760>>3],56208)|0)|0;g=c[41340]|0;j=e;k=59584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[59080]=1;i=d;return}function gH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59248]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2768>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2768>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(59256,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2768>>3],56208)|0)|0;g=c[41340]|0;j=e;k=59584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[59248]=1;i=d;return}function hH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59416]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2776>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2776>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(59424,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2776>>3],56208)|0)|0;g=c[41340]|0;j=e;k=59584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[59416]=1;i=d;return}function iH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59608]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1920>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1920>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(59616,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1920>>3],56208)|0)|0;g=c[41340]|0;j=e;k=60248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[59608]=1;i=d;return}function jH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59768]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1928>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1928>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(59776,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1928>>3],56208)|0)|0;g=c[41340]|0;j=e;k=60248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[59768]=1;i=d;return}function kH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59928]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1936>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1936>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(59936,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1936>>3],56208)|0)|0;g=c[41340]|0;j=e;k=60248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[59928]=1;i=d;return}function lH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60088]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(60096,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1944>>3],56208)|0)|0;g=c[41340]|0;j=e;k=60248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[60088]=1;i=d;return}function mH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60272]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(60280,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+160>>3],56208)|0)|0;g=c[41340]|0;j=e;k=85832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[60272]=1;i=d;return}function nH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60408]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(60416,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+136>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[60408]=1;i=d;return}function oH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60544]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3552>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3552>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(60552,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3552>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[60544]=1;i=d;return}function pH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60688]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3544>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3544>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(60696,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3544>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[60688]=1;i=d;return}function qH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60816]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(60824,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+152>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[60816]=1;i=d;return}function rH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60944]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(60952,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1912>>3],56208)|0)|0;g=c[41340]|0;j=e;k=61080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[60944]=1;i=d;return}function sH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61104]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(61112,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3536>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[61104]=1;i=d;return}function tH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61248]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=CT(61256,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3528>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[61248]=1;i=d;return}function uH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61384]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],.001)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],.25)|0)<<24>>24==0)){i=d;return}b=CT(61392,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3520>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[61384]=1;i=d;return}function vH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61520]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(61528,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3512>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[61520]=1;i=d;return}function wH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61664]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(61672,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3496>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[61664]=1;i=d;return}function xH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61808]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3488>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3488>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(61816,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3488>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[61808]=1;i=d;return}function yH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61952]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(61960,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3480>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[61952]=1;i=d;return}function zH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62088]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(62096,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3472>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[62088]=1;i=d;return}function AH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62224]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(62232,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3464>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[62224]=1;i=d;return}function BH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62392]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=CT(62400,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+128>>3],56208)|0)|0;g=c[41340]|0;j=e;k=62504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[62392]=1;i=d;return}function CH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62528]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(62536,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1904>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[62528]=1;i=d;return}function DH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62648]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(62656,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1896>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[62648]=1;i=d;return}function EH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62800]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1888>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1888>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(62808,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1888>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[62800]=1;i=d;return}function FH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62952]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1880>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1880>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(62960,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1880>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[62952]=1;i=d;return}function GH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63104]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1872>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1872>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(63112,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1872>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63104]=1;i=d;return}function HH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63256]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(63264,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1840>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63256]=1;i=d;return}function IH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63352]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(63360,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1848>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63352]=1;i=d;return}function JH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63448]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(63456,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1824>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63448]=1;i=d;return}function KH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63552]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(63560,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1832>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63552]=1;i=d;return}function LH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63656]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(63664,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63656]=1;i=d;return}function MH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63760]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(63768,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1816>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63760]=1;i=d;return}function NH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63864]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(63872,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+112>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63864]=1;i=d;return}function OH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63976]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(63984,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+120>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[63976]=1;i=d;return}function PH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64088]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(64096,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1792>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[64088]=1;i=d;return}function QH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64184]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(64192,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1800>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[64184]=1;i=d;return}function RH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64280]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(64288,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1776>>3],56208)|0)|0;g=c[41340]|0;j=e;k=78240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[64280]=1;i=d;return}function SH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64432]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(64440,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1784>>3],56208)|0)|0;g=c[41340]|0;j=e;k=78240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[64432]=1;i=d;return}function TH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64584]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1760>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1760>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(64592,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1760>>3],56208)|0)|0;g=c[41340]|0;j=e;k=78584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[64584]=1;i=d;return}function UH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64744]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1768>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1768>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(64752,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1768>>3],56208)|0)|0;g=c[41340]|0;j=e;k=78584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[64744]=1;i=d;return}function VH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64904]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1688>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1688>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(64912,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1688>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[64904]=1;i=d;return}function WH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65120]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(65128,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1696>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[65120]=1;i=d;return}function XH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65280]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(65288,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1704>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[65280]=1;i=d;return}function YH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65440]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1664>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1664>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(65448,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1664>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[65440]=1;i=d;return}function ZH(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65600]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1672>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1672>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(65608,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1672>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[65600]=1;i=d;return}function _H(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65760]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1680>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1680>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(65768,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1680>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[65760]=1;i=d;return}function $H(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65920]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(65928,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1640>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[65920]=1;i=d;return}function aI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66072]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1648>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1648>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(66080,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1648>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[66072]=1;i=d;return}function bI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66224]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1656>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1656>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(66232,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1656>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[66224]=1;i=d;return}function cI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66376]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1616>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1616>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(66384,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1616>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[66376]=1;i=d;return}function dI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66528]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(66536,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1624>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[66528]=1;i=d;return}function eI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66680]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(66688,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1632>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[66680]=1;i=d;return}function fI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66832]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(66840,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2320>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[66832]=1;i=d;return}function gI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66992]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(67e3,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2328>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[66992]=1;i=d;return}function hI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67152]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(67160,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2336>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[67152]=1;i=d;return}function iI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67312]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(67320,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1576>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[67312]=1;i=d;return}function jI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67488]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1584>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1584>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(67496,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1584>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[67488]=1;i=d;return}function kI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67664]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1592>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1592>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(67672,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1592>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[67664]=1;i=d;return}function lI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67840]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(67848,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2352>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[67840]=1;i=d;return}function mI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68e3]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(68008,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2360>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[68e3]=1;i=d;return}function nI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68160]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2368>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(68168,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2368>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[68160]=1;i=d;return}function oI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68320]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1552>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1552>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(68328,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1552>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[68320]=1;i=d;return}function pI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68496]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(68504,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1560>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[68496]=1;i=d;return}function qI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68672]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(68680,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1568>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[68672]=1;i=d;return}function rI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68848]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1424>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1424>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(68856,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1424>>3],56208)|0)|0;g=c[41340]|0;j=e;k=83520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[68848]=1;i=d;return}function sI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69056]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1432>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(69064,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1432>>3],56208)|0)|0;g=c[41340]|0;j=e;k=83520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[69056]=1;i=d;return}function tI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69264]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1440>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1440>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(69272,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1440>>3],56208)|0)|0;g=c[41340]|0;j=e;k=83520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[69264]=1;i=d;return}function uI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69472]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(69480,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+104>>3],56208)|0)|0;g=c[41340]|0;j=e;k=85832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[69472]=1;i=d;return}function vI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69624]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(69632,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+96>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[69624]=1;i=d;return}function wI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69776]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1416>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1416>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(69784,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1416>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[69776]=1;i=d;return}function xI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69936]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1408>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1408>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(69944,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1408>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[69936]=1;i=d;return}function yI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70080]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(70088,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+88>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70080]=1;i=d;return}function zI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70224]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1400>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1400>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(70232,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1400>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70224]=1;i=d;return}function AI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70384]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1392>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1392>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=CT(70392,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1392>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70384]=1;i=d;return}function BI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70536]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],.001)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],.25)|0)<<24>>24==0)){i=d;return}b=CT(70544,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1384>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70536]=1;i=d;return}function CI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70680]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1376>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1376>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(70688,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1376>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70680]=1;i=d;return}function DI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70840]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1360>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1360>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(70848,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1360>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[70840]=1;i=d;return}function EI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71e3]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1352>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1352>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(71008,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1352>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71e3]=1;i=d;return}function FI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71160]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1344>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1344>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(71168,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1344>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71160]=1;i=d;return}function GI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71312]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1336>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1336>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(71320,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1336>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71312]=1;i=d;return}function HI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71464]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1328>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1328>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(71472,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1328>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71464]=1;i=d;return}function II(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71640]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(71648,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+80>>3],56208)|0)|0;g=c[41340]|0;j=e;k=85832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71640]=1;i=d;return}function JI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71792]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(71800,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+72>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71792]=1;i=d;return}function KI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71944]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1304>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1304>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(71952,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1304>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[71944]=1;i=d;return}function LI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72104]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1296>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1296>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(72112,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1296>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72104]=1;i=d;return}function MI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72248]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(72256,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+64>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72248]=1;i=d;return}function NI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72392]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1288>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1288>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(72400,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1288>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72392]=1;i=d;return}function OI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72552]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1280>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1280>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=CT(72560,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1280>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72552]=1;i=d;return}function PI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72704]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1272>>3],.001)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1272>>3],.25)|0)<<24>>24==0)){i=d;return}b=CT(72712,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1272>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72704]=1;i=d;return}function QI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72848]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1264>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1264>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(72856,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1264>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[72848]=1;i=d;return}function RI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73008]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1248>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1248>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(73016,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1248>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73008]=1;i=d;return}function SI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73168]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1240>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1240>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(73176,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1240>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73168]=1;i=d;return}function TI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73328]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1232>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1232>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(73336,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1232>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73328]=1;i=d;return}function UI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73480]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1224>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1224>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(73488,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1224>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73480]=1;i=d;return}function VI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73632]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(73640,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1216>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73632]=1;i=d;return}function WI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73808]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(73816,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1168>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73808]=1;i=d;return}function XI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73928]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(73936,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1176>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[73928]=1;i=d;return}function YI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74048]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3440>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3440>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(74056,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3440>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74048]=1;i=d;return}function ZI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74216]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3432>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3432>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(74224,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3432>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74216]=1;i=d;return}function _I(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74368]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3424>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3424>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(74376,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3424>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74368]=1;i=d;return}function $I(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74528]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=CT(74536,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3416>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74528]=1;i=d;return}function aJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74680]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(74688,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3400>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74680]=1;i=d;return}function bJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74848]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(74856,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3392>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[74848]=1;i=d;return}function cJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75008]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(75016,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3384>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[75008]=1;i=d;return}function dJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75168]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3376>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3376>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(75176,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3376>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[75168]=1;i=d;return}function eJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75328]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(75336,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3368>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[75328]=1;i=d;return}function fJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75512]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(75520,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3344>>3],56208)|0)|0;g=c[41340]|0;j=e;k=75696;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[75512]=1;i=d;return}function gJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75720]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(75728,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3256>>3],56208)|0)|0;g=c[41340]|0;j=e;k=75856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[75720]=1;i=d;return}function hJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75880]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(75888,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1152>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[75880]=1;i=d;return}



function iN(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;h=i;i=i+152|0;j=h+112|0;k=h+120|0;l=h+144|0;m=f;f=g;do{if((m|0)!=0){if((c[m+28>>2]|0)==0){break}if((c[m+12>>2]|0)==0){break}if((c[m>>2]|0)==0){if((c[m+4>>2]|0)!=0){break}}g=c[m+28>>2]|0;if((c[g>>2]|0)==11){c[g>>2]=12}n=c[m+12>>2]|0;o=c[m+16>>2]|0;p=c[m>>2]|0;q=c[m+4>>2]|0;r=c[g+56>>2]|0;s=c[g+60>>2]|0;t=q;u=o;v=0;a:while(1){b:do{switch(c[g>>2]|0){case 4:{w=59;break};case 5:{w=71;break};case 2:{w=43;break};case 3:{w=51;break};case 1:{while(1){if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}c[g+16>>2]=r;if((c[g+16>>2]&255|0)!=8){c[m+24>>2]=93424;c[g>>2]=29;continue a}if((c[g+16>>2]&57344|0)!=0){c[m+24>>2]=93480;c[g>>2]=29;continue a}if((c[g+32>>2]|0)!=0){c[c[g+32>>2]>>2]=r>>>8&1}if((c[g+16>>2]&512|0)!=0){a[l]=r;a[l+1|0]=r>>>8;c[g+24>>2]=rN(c[g+24>>2]|0,l,2)|0}r=0;s=0;c[g>>2]=2;w=43;break};case 8:{w=116;break};case 9:{while(1){if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}x=(r>>>24&255)+(r>>>8&65280)+((r&65280)<<8)+((r&255)<<24)|0;c[g+24>>2]=x;c[m+48>>2]=x;r=0;s=0;c[g>>2]=10;w=130;break};case 12:{w=134;break};case 6:{w=86;break};case 7:{w=101;break};case 0:{if((c[g+8>>2]|0)==0){c[g>>2]=12;continue a}while(1){if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}do{if((c[g+8>>2]&2|0)!=0){if((r|0)!=35615){break}c[g+24>>2]=rN(0,0,0)|0;a[l]=r;a[l+1|0]=r>>>8;c[g+24>>2]=rN(c[g+24>>2]|0,l,2)|0;r=0;s=0;c[g>>2]=1;continue a}}while(0);c[g+16>>2]=0;if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+48>>2]=-1}do{if((c[g+8>>2]&1|0)!=0){if((((((r&255)<<8)+(r>>>8)|0)>>>0)%31|0|0)!=0){break}if((r&15|0)!=8){c[m+24>>2]=93424;c[g>>2]=29;continue a}r=r>>>4;s=s-4|0;y=(r&15)+8|0;x=y;z=g+36|0;do{if((c[g+36>>2]|0)==0){c[z>>2]=x}else{if(!(x>>>0>(c[z>>2]|0)>>>0)){break}c[m+24>>2]=93456;c[g>>2]=29;continue a}}while(0);c[g+20>>2]=1<<y;z=qN(0,0,0)|0;c[g+24>>2]=z;c[m+48>>2]=z;c[g>>2]=(r&512|0)!=0?9:11;r=0;s=0;continue a}}while(0);c[m+24>>2]=93400;c[g>>2]=29;continue a;break};case 10:{w=130;break};case 11:{w=133;break};case 13:{r=r>>>(s&7);s=s-(s&7)|0;while(1){if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}if((r&65535|0)!=(r>>>16^65535|0)){c[m+24>>2]=93560;c[g>>2]=29;continue a}else{c[g+64>>2]=r&65535;r=0;s=0;c[g>>2]=14;if((f|0)==6){break a}else{w=153;break b}}break};case 14:{w=153;break};case 15:{w=154;break};case 16:{while(1){if(!(s>>>0<14)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}c[g+96>>2]=(r&31)+257;r=r>>>5;s=s-5|0;c[g+100>>2]=(r&31)+1;r=r>>>5;s=s-5|0;c[g+92>>2]=(r&15)+4;r=r>>>4;s=s-4|0;do{if(!((c[g+96>>2]|0)>>>0>286)){if((c[g+100>>2]|0)>>>0>30){break}c[g+104>>2]=0;c[g>>2]=17;w=169;break b}}while(0);c[m+24>>2]=93592;c[g>>2]=29;continue a;break};case 17:{w=169;break};case 18:{w=179;break};case 20:{w=214;break};case 19:{w=213;break};case 21:{w=236;break};case 22:{w=242;break};case 23:{w=254;break};case 24:{break};case 26:{do{if((c[g+8>>2]|0)!=0){while(1){if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}u=u-o|0;z=m+20|0;c[z>>2]=(c[z>>2]|0)+u;z=g+28|0;c[z>>2]=(c[z>>2]|0)+u;if((u|0)!=0){z=c[g+24>>2]|0;x=n+(0-u)|0;A=u;if((c[g+16>>2]|0)!=0){B=rN(z,x,A)|0}else{B=qN(z,x,A)|0}c[g+24>>2]=B;c[m+48>>2]=B}u=o;A=r;if((c[g+16>>2]|0)!=0){C=A}else{C=(A>>>24&255)+(r>>>8&65280)+((r&65280)<<8)+((r&255)<<24)|0}if((C|0)!=(c[g+24>>2]|0)){c[m+24>>2]=93880;c[g>>2]=29;continue a}else{r=0;s=0;break}}}while(0);c[g>>2]=27;w=294;break};case 25:{if((o|0)==0){break a}A=n;n=A+1|0;a[A]=c[g+64>>2];o=o+ -1|0;c[g>>2]=20;continue a;break};case 27:{w=294;break};case 28:{w=303;break a;break};case 29:{w=304;break a;break};case 30:{w=305;break a;break};default:{w=306;break a}}}while(0);do{if((w|0)==43){while(1){w=0;if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;A=p;p=A+1|0;r=r+((d[A]|0)<<s)|0;s=s+8|0;w=43}if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+4>>2]=r}if((c[g+16>>2]&512|0)!=0){a[l]=r;a[l+1|0]=r>>>8;a[l+2|0]=r>>>16;a[l+3|0]=r>>>24;c[g+24>>2]=rN(c[g+24>>2]|0,l,4)|0}r=0;s=0;c[g>>2]=3;w=51}else if((w|0)==130){w=0;if((c[g+12>>2]|0)==0){w=131;break a}A=qN(0,0,0)|0;c[g+24>>2]=A;c[m+48>>2]=A;c[g>>2]=11;w=133}else if((w|0)==153){w=0;c[g>>2]=15;w=154}else if((w|0)==169){while(1){w=0;if(!((c[g+104>>2]|0)>>>0<(c[g+92>>2]|0)>>>0)){break}while(1){if(!(s>>>0<3)){break}if((q|0)==0){break a}q=q+ -1|0;A=p;p=A+1|0;r=r+((d[A]|0)<<s)|0;s=s+8|0}A=g+104|0;x=c[A>>2]|0;c[A>>2]=x+1;b[g+112+((e[93360+(x<<1)>>1]|0)<<1)>>1]=r&7;r=r>>>3;s=s-3|0;w=169}while(1){D=g;if(!((c[g+104>>2]|0)>>>0<19)){break}x=D+104|0;A=c[x>>2]|0;c[x>>2]=A+1;b[g+112+((e[93360+(A<<1)>>1]|0)<<1)>>1]=0}c[g+108>>2]=D+1328;c[g+76>>2]=c[g+108>>2];c[g+84>>2]=7;v=nN(0,g+112|0,19,g+108|0,g+84|0,g+752|0)|0;if((v|0)!=0){c[m+24>>2]=93632;c[g>>2]=29;continue a}else{c[g+104>>2]=0;c[g>>2]=18;w=179;break}}else if((w|0)==294){w=0;if((c[g+8>>2]|0)==0){w=302;break a}if((c[g+16>>2]|0)==0){w=302;break a}while(1){if(!(s>>>0<32)){break}if((q|0)==0){break a}q=q+ -1|0;A=p;p=A+1|0;r=r+((d[A]|0)<<s)|0;s=s+8|0}if((r|0)==(c[g+28>>2]|0)){w=301;break a}c[m+24>>2]=93904;c[g>>2]=29;continue a}}while(0);do{if((w|0)==51){while(1){w=0;if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;A=p;p=A+1|0;r=r+((d[A]|0)<<s)|0;s=s+8|0;w=51}if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+8>>2]=r&255;c[(c[g+32>>2]|0)+12>>2]=r>>>8}if((c[g+16>>2]&512|0)!=0){a[l]=r;a[l+1|0]=r>>>8;c[g+24>>2]=rN(c[g+24>>2]|0,l,2)|0}r=0;s=0;c[g>>2]=4;w=59}else if((w|0)==133){w=0;if((f|0)==5|(f|0)==6){break a}else{w=134}}else if((w|0)==154){w=0;E=c[g+64>>2]|0;if((E|0)==0){c[g>>2]=11;continue a}if(E>>>0>q>>>0){E=q}if(E>>>0>o>>>0){E=o}if((E|0)==0){break a}rma(n|0,p|0,E|0)|0;q=q-E|0;p=p+E|0;o=o-E|0;n=n+E|0;A=g+64|0;c[A>>2]=(c[A>>2]|0)-E;continue a}else if((w|0)==179){c:while(1){w=0;if(!((c[g+104>>2]|0)>>>0<((c[g+96>>2]|0)+(c[g+100>>2]|0)|0)>>>0)){break}while(1){A=j;x=(c[g+76>>2]|0)+((r&(1<<c[g+84>>2])-1)<<2)|0;b[A+0>>1]=b[x+0>>1]|0;b[A+2>>1]=b[x+2>>1]|0;if((d[j+1|0]|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}if((e[j+2>>1]|0|0)<16){r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;x=b[j+2>>1]|0;A=g+104|0;z=c[A>>2]|0;c[A>>2]=z+1;b[g+112+(z<<1)>>1]=x;w=179;continue}do{if((e[j+2>>1]|0|0)==16){while(1){if(!(s>>>0<((d[j+1|0]|0)+2|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;if((c[g+104>>2]|0)==0){w=190;break c}y=e[g+112+((c[g+104>>2]|0)-1<<1)>>1]|0;E=3+(r&3)|0;r=r>>>2;s=s-2|0}else{if((e[j+2>>1]|0|0)==17){while(1){if(!(s>>>0<((d[j+1|0]|0)+3|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;y=0;E=3+(r&7)|0;r=r>>>3;s=s-3|0;break}else{while(1){if(!(s>>>0<((d[j+1|0]|0)+7|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;y=0;E=11+(r&127)|0;r=r>>>7;s=s-7|0;break}}}while(0);if(((c[g+104>>2]|0)+E|0)>>>0>((c[g+96>>2]|0)+(c[g+100>>2]|0)|0)>>>0){w=202;break}while(1){x=E;E=x+ -1|0;if((x|0)==0){w=179;continue c}x=g+104|0;z=c[x>>2]|0;c[x>>2]=z+1;b[g+112+(z<<1)>>1]=y}}if((w|0)==190){w=0;c[m+24>>2]=93664;c[g>>2]=29}else if((w|0)==202){w=0;c[m+24>>2]=93664;c[g>>2]=29}if((c[g>>2]|0)==29){continue a}if((e[g+624>>1]|0|0)==0){c[m+24>>2]=93696;c[g>>2]=29;continue a}c[g+108>>2]=g+1328;c[g+76>>2]=c[g+108>>2];c[g+84>>2]=9;v=nN(1,g+112|0,c[g+96>>2]|0,g+108|0,g+84|0,g+752|0)|0;if((v|0)!=0){c[m+24>>2]=93736;c[g>>2]=29;continue a}c[g+80>>2]=c[g+108>>2];c[g+88>>2]=6;v=nN(2,g+112+(c[g+96>>2]<<1)|0,c[g+100>>2]|0,g+108|0,g+88|0,g+752|0)|0;if((v|0)!=0){c[m+24>>2]=93768;c[g>>2]=29;continue a}else{c[g>>2]=19;if((f|0)==6){break a}else{w=213;break}}}}while(0);if((w|0)==59){w=0;do{if((c[g+16>>2]&1024|0)!=0){while(1){if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}c[g+64>>2]=r;if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+20>>2]=r}if((c[g+16>>2]&512|0)!=0){a[l]=r;a[l+1|0]=r>>>8;c[g+24>>2]=rN(c[g+24>>2]|0,l,2)|0}r=0;s=0}else{if((c[g+32>>2]|0)==0){break}c[(c[g+32>>2]|0)+16>>2]=0}}while(0);c[g>>2]=5;w=71}else if((w|0)==134){w=0;if((c[g+4>>2]|0)!=0){r=r>>>(s&7);s=s-(s&7)|0;c[g>>2]=26;continue}while(1){if(!(s>>>0<3)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}c[g+4>>2]=r&1;r=r>>>1;s=s-1|0;z=r&3;if((z|0)==1){jN(g);c[g>>2]=19;if((f|0)==6){w=142;break}}else if((z|0)==2){c[g>>2]=16}else if((z|0)==3){c[m+24>>2]=93536;c[g>>2]=29}else if((z|0)==0){c[g>>2]=13}r=r>>>2;s=s-2|0;continue}else if((w|0)==213){w=0;c[g>>2]=20;w=214}do{if((w|0)==71){w=0;if((c[g+16>>2]&1024|0)!=0){E=c[g+64>>2]|0;if(E>>>0>q>>>0){E=q}if((E|0)!=0){do{if((c[g+32>>2]|0)!=0){if((c[(c[g+32>>2]|0)+16>>2]|0)==0){break}y=(c[(c[g+32>>2]|0)+20>>2]|0)-(c[g+64>>2]|0)|0;if((y+E|0)>>>0>(c[(c[g+32>>2]|0)+24>>2]|0)>>>0){F=(c[(c[g+32>>2]|0)+24>>2]|0)-y|0}else{F=E}rma((c[(c[g+32>>2]|0)+16>>2]|0)+y|0,p|0,F|0)|0}}while(0);if((c[g+16>>2]&512|0)!=0){c[g+24>>2]=rN(c[g+24>>2]|0,p,E)|0}q=q-E|0;p=p+E|0;z=g+64|0;c[z>>2]=(c[z>>2]|0)-E}if((c[g+64>>2]|0)!=0){break a}}c[g+64>>2]=0;c[g>>2]=6;w=86}else if((w|0)==214){w=0;do{if(q>>>0>=6){if(!(o>>>0>=258)){break}c[m+12>>2]=n;c[m+16>>2]=o;c[m>>2]=p;c[m+4>>2]=q;c[g+56>>2]=r;c[g+60>>2]=s;uN(m,u);n=c[m+12>>2]|0;o=c[m+16>>2]|0;p=c[m>>2]|0;q=c[m+4>>2]|0;r=c[g+56>>2]|0;s=c[g+60>>2]|0;if((c[g>>2]|0)!=11){continue a}c[g+7108>>2]=-1;continue a}}while(0);c[g+7108>>2]=0;while(1){z=j;x=(c[g+76>>2]|0)+((r&(1<<c[g+84>>2])-1)<<2)|0;b[z+0>>1]=b[x+0>>1]|0;b[z+2>>1]=b[x+2>>1]|0;if((d[j+1|0]|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}do{if((d[j]|0|0)!=0){if((a[j]&240|0)!=0){break}x=k;z=j;b[x+0>>1]=b[z+0>>1]|0;b[x+2>>1]=b[z+2>>1]|0;while(1){z=j;x=(c[g+76>>2]|0)+((e[k+2>>1]|0)+((r&(1<<(d[k+1|0]|0)+(d[k]|0))-1)>>>(d[k+1|0]|0))<<2)|0;b[z+0>>1]=b[x+0>>1]|0;b[z+2>>1]=b[x+2>>1]|0;if(((d[k+1|0]|0)+(d[j+1|0]|0)|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;x=p;p=x+1|0;r=r+((d[x]|0)<<s)|0;s=s+8|0}r=r>>>(d[k+1|0]|0);s=s-(d[k+1|0]|0)|0;x=g+7108|0;c[x>>2]=(c[x>>2]|0)+(d[k+1|0]|0)}}while(0);r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;x=g+7108|0;c[x>>2]=(c[x>>2]|0)+(d[j+1|0]|0);c[g+64>>2]=e[j+2>>1]|0;if((d[j]|0|0)==0){c[g>>2]=25;continue a}if((a[j]&32|0)!=0){c[g+7108>>2]=-1;c[g>>2]=11;continue a}if((a[j]&64|0)!=0){c[m+24>>2]=93792;c[g>>2]=29;continue a}else{c[g+72>>2]=a[j]&15;c[g>>2]=21;w=236;break}}}while(0);if((w|0)==86){w=0;do{if((c[g+16>>2]&2048|0)!=0){if((q|0)==0){break a}E=0;do{x=E;E=x+1|0;y=d[p+x|0]|0;do{if((c[g+32>>2]|0)!=0){if((c[(c[g+32>>2]|0)+28>>2]|0)==0){break}if(!((c[g+64>>2]|0)>>>0<(c[(c[g+32>>2]|0)+32>>2]|0)>>>0)){break}x=g+64|0;z=c[x>>2]|0;c[x>>2]=z+1;a[(c[(c[g+32>>2]|0)+28>>2]|0)+z|0]=y}}while(0);if((y|0)==0){break}}while(E>>>0<q>>>0);if((c[g+16>>2]&512|0)!=0){c[g+24>>2]=rN(c[g+24>>2]|0,p,E)|0}q=q-E|0;p=p+E|0;if((y|0)!=0){break a}}else{if((c[g+32>>2]|0)==0){break}c[(c[g+32>>2]|0)+28>>2]=0}}while(0);c[g+64>>2]=0;c[g>>2]=7;w=101}else if((w|0)==236){w=0;if((c[g+72>>2]|0)!=0){while(1){if(!(s>>>0<(c[g+72>>2]|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}z=g+64|0;c[z>>2]=(c[z>>2]|0)+(r&(1<<c[g+72>>2])-1);r=r>>>(c[g+72>>2]|0);s=s-(c[g+72>>2]|0)|0;z=g+7108|0;c[z>>2]=(c[z>>2]|0)+(c[g+72>>2]|0)}c[g+7112>>2]=c[g+64>>2];c[g>>2]=22;w=242}do{if((w|0)==101){w=0;do{if((c[g+16>>2]&4096|0)!=0){if((q|0)==0){break a}E=0;do{z=E;E=z+1|0;y=d[p+z|0]|0;do{if((c[g+32>>2]|0)!=0){if((c[(c[g+32>>2]|0)+36>>2]|0)==0){break}if(!((c[g+64>>2]|0)>>>0<(c[(c[g+32>>2]|0)+40>>2]|0)>>>0)){break}z=g+64|0;x=c[z>>2]|0;c[z>>2]=x+1;a[(c[(c[g+32>>2]|0)+36>>2]|0)+x|0]=y}}while(0);if((y|0)==0){break}}while(E>>>0<q>>>0);if((c[g+16>>2]&512|0)!=0){c[g+24>>2]=rN(c[g+24>>2]|0,p,E)|0}q=q-E|0;p=p+E|0;if((y|0)!=0){break a}}else{if((c[g+32>>2]|0)==0){break}c[(c[g+32>>2]|0)+36>>2]=0}}while(0);c[g>>2]=8;w=116}else if((w|0)==242){while(1){w=0;x=j;z=(c[g+80>>2]|0)+((r&(1<<c[g+88>>2])-1)<<2)|0;b[x+0>>1]=b[z+0>>1]|0;b[x+2>>1]=b[z+2>>1]|0;if((d[j+1|0]|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0;w=242}if((a[j]&240|0)==0){z=k;x=j;b[z+0>>1]=b[x+0>>1]|0;b[z+2>>1]=b[x+2>>1]|0;while(1){x=j;z=(c[g+80>>2]|0)+((e[k+2>>1]|0)+((r&(1<<(d[k+1|0]|0)+(d[k]|0))-1)>>>(d[k+1|0]|0))<<2)|0;b[x+0>>1]=b[z+0>>1]|0;b[x+2>>1]=b[z+2>>1]|0;if(((d[k+1|0]|0)+(d[j+1|0]|0)|0)>>>0<=s>>>0){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}r=r>>>(d[k+1|0]|0);s=s-(d[k+1|0]|0)|0;z=g+7108|0;c[z>>2]=(c[z>>2]|0)+(d[k+1|0]|0)}r=r>>>(d[j+1|0]|0);s=s-(d[j+1|0]|0)|0;z=g+7108|0;c[z>>2]=(c[z>>2]|0)+(d[j+1|0]|0);if((a[j]&64|0)!=0){c[m+24>>2]=93824;c[g>>2]=29;continue a}else{c[g+68>>2]=e[j+2>>1]|0;c[g+72>>2]=a[j]&15;c[g>>2]=23;w=254;break}}}while(0);if((w|0)==116){w=0;do{if((c[g+16>>2]&512|0)!=0){while(1){if(!(s>>>0<16)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}if((r|0)!=(c[g+24>>2]&65535|0)){c[m+24>>2]=93512;c[g>>2]=29;continue a}else{r=0;s=0;break}}}while(0);if((c[g+32>>2]|0)!=0){c[(c[g+32>>2]|0)+44>>2]=c[g+16>>2]>>9&1;c[(c[g+32>>2]|0)+48>>2]=1}z=rN(0,0,0)|0;c[g+24>>2]=z;c[m+48>>2]=z;c[g>>2]=11;continue}else if((w|0)==254){w=0;if((c[g+72>>2]|0)!=0){while(1){if(!(s>>>0<(c[g+72>>2]|0)>>>0)){break}if((q|0)==0){break a}q=q+ -1|0;z=p;p=z+1|0;r=r+((d[z]|0)<<s)|0;s=s+8|0}z=g+68|0;c[z>>2]=(c[z>>2]|0)+(r&(1<<c[g+72>>2])-1);r=r>>>(c[g+72>>2]|0);s=s-(c[g+72>>2]|0)|0;z=g+7108|0;c[z>>2]=(c[z>>2]|0)+(c[g+72>>2]|0)}c[g>>2]=24}if((o|0)==0){break}E=u-o|0;do{if((c[g+68>>2]|0)>>>0>E>>>0){E=(c[g+68>>2]|0)-E|0;do{if(E>>>0>(c[g+44>>2]|0)>>>0){if((c[g+7104>>2]|0)==0){break}c[m+24>>2]=93848;c[g>>2]=29;continue a}}while(0);z=g;if(E>>>0>(c[g+48>>2]|0)>>>0){E=E-(c[z+48>>2]|0)|0;G=(c[g+52>>2]|0)+((c[g+40>>2]|0)-E)|0}else{G=(c[z+52>>2]|0)+((c[g+48>>2]|0)-E)|0}if(!(E>>>0>(c[g+64>>2]|0)>>>0)){break}E=c[g+64>>2]|0}else{G=n+(0-(c[g+68>>2]|0))|0;E=c[g+64>>2]|0}}while(0);if(E>>>0>o>>>0){E=o}o=o-E|0;z=g+64|0;c[z>>2]=(c[z>>2]|0)-E;do{z=G;G=z+1|0;x=n;n=x+1|0;a[x]=a[z]|0;z=E+ -1|0;E=z;}while((z|0)!=0);if((c[g+64>>2]|0)!=0){continue}c[g>>2]=20}if((w|0)==131){c[m+12>>2]=n;c[m+16>>2]=o;c[m>>2]=p;c[m+4>>2]=q;c[g+56>>2]=r;c[g+60>>2]=s;H=2;I=H;i=h;return I|0}else if((w|0)==142){r=r>>>2;s=s-2|0}else if((w|0)==301){r=0;s=0;w=302}else if((w|0)==304){v=-3}else if((w|0)==305){H=-4;I=H;i=h;return I|0}else if((w|0)==306){H=-2;I=H;i=h;return I|0}if((w|0)==302){c[g>>2]=28;w=303}if((w|0)==303){v=1}c[m+12>>2]=n;c[m+16>>2]=o;c[m>>2]=p;c[m+4>>2]=q;c[g+56>>2]=r;c[g+60>>2]=s;do{if((c[g+40>>2]|0)!=0){w=312}else{if((u|0)==(c[m+16>>2]|0)){break}if(!((c[g>>2]|0)>>>0<29)){break}if((c[g>>2]|0)>>>0<26){w=312;break}if((f|0)!=4){w=312}}}while(0);do{if((w|0)==312){if((kN(m,c[m+12>>2]|0,u-(c[m+16>>2]|0)|0)|0)==0){break}c[g>>2]=30;H=-4;I=H;i=h;return I|0}}while(0);t=t-(c[m+4>>2]|0)|0;u=u-(c[m+16>>2]|0)|0;s=m+8|0;c[s>>2]=(c[s>>2]|0)+t;s=m+20|0;c[s>>2]=(c[s>>2]|0)+u;s=g+28|0;c[s>>2]=(c[s>>2]|0)+u;do{if((c[g+8>>2]|0)!=0){if((u|0)==0){break}s=c[g+24>>2]|0;r=(c[m+12>>2]|0)+(0-u)|0;q=u;if((c[g+16>>2]|0)!=0){J=rN(s,r,q)|0}else{J=qN(s,r,q)|0}c[g+24>>2]=J;c[m+48>>2]=J}}while(0);if((c[g>>2]|0)==19){K=1}else{K=(c[g>>2]|0)==14}c[m+44>>2]=(c[g+60>>2]|0)+((c[g+4>>2]|0)!=0?64:0)+((c[g>>2]|0)==11?128:0)+(K?256:0);if((t|0)==0){if((u|0)==0){w=325}else{w=324}}else{w=324}if((w|0)==324){if((f|0)==4){w=325}}do{if((w|0)==325){if((v|0)!=0){break}v=-5}}while(0);H=v;I=H;i=h;return I|0}}while(0);H=-2;I=H;i=h;return I|0}function jN(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d+76>>2]=93928;c[d+84>>2]=9;c[d+80>>2]=95976;c[d+88>>2]=5;i=b;return}function kN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+48|0;f=a;a=b;b=d;d=c[f+28>>2]|0;do{if((c[d+52>>2]|0)==0){c[d+52>>2]=re[c[f+32>>2]&63](c[f+40>>2]|0,1<<c[d+36>>2],1)|0;if((c[d+52>>2]|0)!=0){break}g=1;h=g;i=e;return h|0}}while(0);if((c[d+40>>2]|0)==0){c[d+40>>2]=1<<c[d+36>>2];c[d+48>>2]=0;c[d+44>>2]=0}f=d;do{if(b>>>0>=(c[d+40>>2]|0)>>>0){rma(c[f+52>>2]|0,a+(0-(c[d+40>>2]|0))|0,c[d+40>>2]|0)|0;c[d+48>>2]=0;c[d+44>>2]=c[d+40>>2]}else{j=(c[f+40>>2]|0)-(c[d+48>>2]|0)|0;if(j>>>0>b>>>0){j=b}rma((c[d+52>>2]|0)+(c[d+48>>2]|0)|0,a+(0-b)|0,j|0)|0;b=b-j|0;if((b|0)!=0){rma(c[d+52>>2]|0,a+(0-b)|0,b|0)|0;c[d+48>>2]=b;c[d+44>>2]=c[d+40>>2];break}k=d+48|0;c[k>>2]=(c[k>>2]|0)+j;if((c[d+48>>2]|0)==(c[d+40>>2]|0)){c[d+48>>2]=0}if(!((c[d+44>>2]|0)>>>0<(c[d+40>>2]|0)>>>0)){break}k=d+44|0;c[k>>2]=(c[k>>2]|0)+j}}while(0);g=0;h=g;i=e;return h|0}function lN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;do{if((d|0)!=0){if((c[d+28>>2]|0)==0){break}if((c[d+36>>2]|0)==0){break}a=c[d+28>>2]|0;if((c[a+52>>2]|0)!=0){me[c[d+36>>2]&127](c[d+40>>2]|0,c[a+52>>2]|0)}me[c[d+36>>2]&127](c[d+40>>2]|0,c[d+28>>2]|0);c[d+28>>2]=0;e=0;f=e;i=b;return f|0}}while(0);e=-2;f=e;i=b;return f|0}function mN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=b;b=d;do{if((f|0)!=0){if((b|0)==0){break}if((c[b+28>>2]|0)==0){break}if((c[b+32>>2]|0)==0){break}if((c[b+36>>2]|0)==0){break}d=c[b+28>>2]|0;g=re[c[b+32>>2]&63](c[b+40>>2]|0,1,7116)|0;if((g|0)==0){h=-4;j=h;i=e;return j|0}k=0;do{if((c[d+52>>2]|0)!=0){k=re[c[b+32>>2]&63](c[b+40>>2]|0,1<<c[d+36>>2],1)|0;if((k|0)!=0){break}me[c[b+36>>2]&127](c[b+40>>2]|0,g);h=-4;j=h;i=e;return j|0}}while(0);l=f+0|0;m=b+0|0;n=l+56|0;do{a[l]=a[m]|0;l=l+1|0;m=m+1|0}while((l|0)<(n|0));rma(g|0,d|0,7116)|0;do{if((c[d+76>>2]|0)>>>0>=(d+1328|0)>>>0){if(!((c[d+76>>2]|0)>>>0<=(d+7104+ -4|0)>>>0)){break}c[g+76>>2]=g+1328+((((c[d+76>>2]|0)-(d+1328)|0)/4|0)<<2);c[g+80>>2]=g+1328+((((c[d+80>>2]|0)-(d+1328)|0)/4|0)<<2)}}while(0);c[g+108>>2]=g+1328+((((c[d+108>>2]|0)-(d+1328)|0)/4|0)<<2);if((k|0)!=0){rma(k|0,c[d+52>>2]|0,1<<c[d+36>>2]|0)|0}c[g+52>>2]=k;c[f+28>>2]=g;h=0;j=h;i=e;return j|0}}while(0);h=-2;j=h;i=e;return j|0}function nN(d,f,g,h,j,k){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+272|0;m=l+168|0;n=l+208|0;o=l+240|0;p=d;d=f;f=g;g=h;h=j;j=k;k=0;while(1){if(!(k>>>0<=15)){break}b[n+(k<<1)>>1]=0;k=k+1|0}q=0;while(1){if(!(q>>>0<f>>>0)){break}r=n+((e[d+(q<<1)>>1]|0)<<1)|0;b[r>>1]=(b[r>>1]|0)+1<<16>>16;q=q+1|0}r=c[h>>2]|0;s=15;while(1){if(!(s>>>0>=1)){break}if((e[n+(s<<1)>>1]|0|0)!=0){break}s=s+ -1|0}if(r>>>0>s>>>0){r=s}if((s|0)==0){a[m]=64;a[m+1|0]=1;b[m+2>>1]=0;t=g;u=c[t>>2]|0;c[t>>2]=u+4;t=u;u=m;b[t+0>>1]=b[u+0>>1]|0;b[t+2>>1]=b[u+2>>1]|0;u=g;t=c[u>>2]|0;c[u>>2]=t+4;u=t;t=m;b[u+0>>1]=b[t+0>>1]|0;b[u+2>>1]=b[t+2>>1]|0;c[h>>2]=1;v=0;w=v;i=l;return w|0}t=1;while(1){if(!(t>>>0<s>>>0)){break}if((e[n+(t<<1)>>1]|0|0)!=0){break}t=t+1|0}if(r>>>0<t>>>0){r=t}u=1;k=1;while(1){x=u;if(!(k>>>0<=15)){break}u=x<<1;u=u-(e[n+(k<<1)>>1]|0)|0;if((u|0)<0){y=24;break}k=k+1|0}if((y|0)==24){v=-1;w=v;i=l;return w|0}do{if((x|0)>0){if((p|0)!=0){if((s|0)==1){break}}v=-1;w=v;i=l;return w|0}}while(0);b[o+2>>1]=0;k=1;while(1){if(!(k>>>0<15)){break}b[o+(k+1<<1)>>1]=(e[o+(k<<1)>>1]|0)+(e[n+(k<<1)>>1]|0);k=k+1|0}q=0;while(1){if(!(q>>>0<f>>>0)){break}if((e[d+(q<<1)>>1]|0|0)!=0){x=o+((e[d+(q<<1)>>1]|0)<<1)|0;z=b[x>>1]|0;b[x>>1]=z+1<<16>>16;b[j+((z&65535)<<1)>>1]=q}q=q+1|0}o=p;if((o|0)==1){A=96104;A=A+ -514|0;B=96168;B=B+ -514|0;C=256}else if((o|0)==0){o=j;B=o;A=o;C=19}else{A=96232;B=96296;C=-1}o=0;q=0;k=t;f=c[g>>2]|0;z=r;x=0;D=-1;E=1<<r;F=E-1|0;if((p|0)==1){if(!(E>>>0>852)){y=44}}else{y=44}do{if((y|0)==44){if((p|0)==2){if(E>>>0>592){break}}while(1){a[m+1|0]=k-x;do{if((e[j+(q<<1)>>1]|0|0)<(C|0)){a[m]=0;b[m+2>>1]=b[j+(q<<1)>>1]|0}else{if((e[j+(q<<1)>>1]|0|0)>(C|0)){a[m]=b[B+((e[j+(q<<1)>>1]|0)<<1)>>1];b[m+2>>1]=b[A+((e[j+(q<<1)>>1]|0)<<1)>>1]|0;break}else{a[m]=96;b[m+2>>1]=0;break}}}while(0);G=1<<k-x;H=1<<z;t=H;do{H=H-G|0;I=f+((o>>>x)+H<<2)|0;J=m;b[I+0>>1]=b[J+0>>1]|0;b[I+2>>1]=b[J+2>>1]|0;}while((H|0)!=0);G=1<<k-1;while(1){K=G;if((o&G|0)==0){break}G=K>>>1}if((K|0)!=0){o=o&G-1;o=o+G|0}else{o=0}q=q+1|0;H=n+(k<<1)|0;J=(b[H>>1]|0)+ -1<<16>>16;b[H>>1]=J;if((J&65535|0)==0){if((k|0)==(s|0)){break}k=e[d+((e[j+(q<<1)>>1]|0)<<1)>>1]|0}if(!(k>>>0>r>>>0)){continue}if((o&F|0)==(D|0)){continue}if((x|0)==0){x=r}f=f+(t<<2)|0;z=k-x|0;u=1<<z;while(1){if(!((z+x|0)>>>0<s>>>0)){break}u=u-(e[n+(z+x<<1)>>1]|0)|0;if((u|0)<=0){break}z=z+1|0;u=u<<1}E=E+(1<<z)|0;if((p|0)==1){if(E>>>0>852){y=75;break}}if((p|0)==2){if(E>>>0>592){y=75;break}}D=o&F;a[(c[g>>2]|0)+(D<<2)|0]=z;a[(c[g>>2]|0)+(D<<2)+1|0]=r;b[(c[g>>2]|0)+(D<<2)+2>>1]=(f-(c[g>>2]|0)|0)/4|0}if((y|0)==75){v=1;w=v;i=l;return w|0}if((o|0)!=0){a[m]=64;a[m+1|0]=k-x;b[m+2>>1]=0;G=f+(o<<2)|0;J=m;b[G+0>>1]=b[J+0>>1]|0;b[G+2>>1]=b[J+2>>1]|0}J=g;c[J>>2]=(c[J>>2]|0)+(E<<2);c[h>>2]=r;v=0;w=v;i=l;return w|0}}while(0);v=1;w=v;i=l;return w|0}function oN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=b;b=c;if((a|0)!=0){e=e+(b-b)|0}a=Nla(fa(e,b)|0)|0;i=d;return a|0}function pN(a,b){a=a|0;b=b|0;a=i;i=i+16|0;Ola(b);i=a;return}function qN(a,b,c){a=a|0;b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+48|0;f=a;a=b;b=c;c=f>>>16&65535;f=f&65535;g=a;if((b|0)==1){f=f+(d[g]|0)|0;if(f>>>0>=65521){f=f-65521|0}c=c+f|0;if(c>>>0>=65521){c=c-65521|0}h=f|c<<16;j=h;i=e;return j|0}if((g|0)==0){h=1;j=h;i=e;return j|0}if(b>>>0<16){while(1){g=b;b=g+ -1|0;if((g|0)==0){break}g=a;a=g+1|0;f=f+(d[g]|0)|0;c=c+f|0}if(f>>>0>=65521){f=f-65521|0}c=(c>>>0)%65521|0;h=f|c<<16;j=h;i=e;return j|0}while(1){k=b;if(!(b>>>0>=5552)){break}b=k-5552|0;g=347;do{f=f+(d[a]|0)|0;c=c+f|0;f=f+(d[a+1|0]|0)|0;c=c+f|0;f=f+(d[a+2|0]|0)|0;c=c+f|0;f=f+(d[a+3|0]|0)|0;c=c+f|0;f=f+(d[a+4|0]|0)|0;c=c+f|0;f=f+(d[a+5|0]|0)|0;c=c+f|0;f=f+(d[a+6|0]|0)|0;c=c+f|0;f=f+(d[a+7|0]|0)|0;c=c+f|0;f=f+(d[a+8|0]|0)|0;c=c+f|0;f=f+(d[a+9|0]|0)|0;c=c+f|0;f=f+(d[a+10|0]|0)|0;c=c+f|0;f=f+(d[a+11|0]|0)|0;c=c+f|0;f=f+(d[a+12|0]|0)|0;c=c+f|0;f=f+(d[a+13|0]|0)|0;c=c+f|0;f=f+(d[a+14|0]|0)|0;c=c+f|0;f=f+(d[a+15|0]|0)|0;c=c+f|0;a=a+16|0;l=g+ -1|0;g=l;}while((l|0)!=0);f=(f>>>0)%65521|0;c=(c>>>0)%65521|0}if((k|0)!=0){while(1){if(!(b>>>0>=16)){break}b=b-16|0;f=f+(d[a]|0)|0;c=c+f|0;f=f+(d[a+1|0]|0)|0;c=c+f|0;f=f+(d[a+2|0]|0)|0;c=c+f|0;f=f+(d[a+3|0]|0)|0;c=c+f|0;f=f+(d[a+4|0]|0)|0;c=c+f|0;f=f+(d[a+5|0]|0)|0;c=c+f|0;f=f+(d[a+6|0]|0)|0;c=c+f|0;f=f+(d[a+7|0]|0)|0;c=c+f|0;f=f+(d[a+8|0]|0)|0;c=c+f|0;f=f+(d[a+9|0]|0)|0;c=c+f|0;f=f+(d[a+10|0]|0)|0;c=c+f|0;f=f+(d[a+11|0]|0)|0;c=c+f|0;f=f+(d[a+12|0]|0)|0;c=c+f|0;f=f+(d[a+13|0]|0)|0;c=c+f|0;f=f+(d[a+14|0]|0)|0;c=c+f|0;f=f+(d[a+15|0]|0)|0;c=c+f|0;a=a+16|0}while(1){k=b;b=k+ -1|0;if((k|0)==0){break}k=a;a=k+1|0;f=f+(d[k]|0)|0;c=c+f|0}f=(f>>>0)%65521|0;c=(c>>>0)%65521|0}h=f|c<<16;j=h;i=e;return j|0}function rN(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+40|0;g=f+32|0;h=d;do{if((h|0)==0){j=0}else{c[g>>2]=1;d=b;k=h;l=e;if((a[g]|0)!=0){j=sN(d,k,l)|0;break}else{j=tN(d,k,l)|0;break}}}while(0);i=f;return j|0}function sN(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=b;b=e;e=a;e=~e;while(1){if((b|0)==0){break}if((g&3|0)==0){break}a=g;g=a+1|0;e=c[96360+(((e^(d[a]|0))&255)<<2)>>2]^e>>>8;b=b+ -1|0}a=g;while(1){if(!(b>>>0>=32)){break}h=a;a=h+4|0;e=e^c[h>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];h=a;a=h+4|0;e=e^c[h>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];b=b-32|0}while(1){j=a;if(!(b>>>0>=4)){break}a=j+4|0;e=e^c[j>>2];e=c[99432+((e&255)<<2)>>2]^c[98408+((e>>>8&255)<<2)>>2]^c[97384+((e>>>16&255)<<2)>>2]^c[96360+(e>>>24<<2)>>2];b=b-4|0}g=j;if((b|0)==0){k=e;l=~k;e=l;m=e;i=f;return m|0}do{j=g;g=j+1|0;e=c[96360+(((e^(d[j]|0))&255)<<2)>>2]^e>>>8;j=b+ -1|0;b=j;}while((j|0)!=0);k=e;l=~k;e=l;m=e;i=f;return m|0}function tN(a,b,e){a=a|0;b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;f=i;i=i+40|0;g=a;a=b;b=e;e=(g>>>24&255)+(g>>>8&65280)+((g&65280)<<8)+((g&255)<<24)|0;e=~e;while(1){if((b|0)==0){break}if((a&3|0)==0){break}g=a;a=g+1|0;e=c[100456+((e>>>24^(d[g]|0))<<2)>>2]^e<<8;b=b+ -1|0}g=a;g=g+ -4|0;while(1){if(!(b>>>0>=32)){break}h=g+4|0;g=h;e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];h=g+4|0;g=h;e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];b=b-32|0}while(1){h=g+4|0;g=h;if(!(b>>>0>=4)){break}e=e^c[h>>2];e=c[100456+((e&255)<<2)>>2]^c[101480+((e>>>8&255)<<2)>>2]^c[102504+((e>>>16&255)<<2)>>2]^c[103528+(e>>>24<<2)>>2];b=b-4|0}a=g;if((b|0)==0){j=e;k=~j;e=k;l=e;m=l>>>24;n=m&255;o=e;p=o>>>8;q=p&65280;r=n+q|0;s=e;t=s&65280;u=t<<8;v=r+u|0;w=e;x=w&255;y=x<<24;z=v+y|0;i=f;return z|0}do{g=a;a=g+1|0;e=c[100456+((e>>>24^(d[g]|0))<<2)>>2]^e<<8;g=b+ -1|0;b=g;}while((g|0)!=0);j=e;k=~j;e=k;l=e;m=l>>>24;n=m&255;o=e;p=o>>>8;q=p&65280;r=n+q|0;s=e;t=s&65280;u=t<<8;v=r+u|0;w=e;x=w&255;y=x<<24;z=v+y|0;i=f;return z|0}function uN(f,g){f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;h=i;i=i+184|0;j=h+144|0;k=f;f=c[k+28>>2]|0;l=(c[k>>2]|0)+ -1|0;m=l+((c[k+4>>2]|0)-5)|0;n=(c[k+12>>2]|0)+ -1|0;o=n+(0-(g-(c[k+16>>2]|0)))|0;g=n+((c[k+16>>2]|0)-257)|0;p=c[f+40>>2]|0;q=c[f+44>>2]|0;r=c[f+48>>2]|0;s=c[f+52>>2]|0;t=c[f+56>>2]|0;u=c[f+60>>2]|0;v=c[f+76>>2]|0;w=c[f+80>>2]|0;x=(1<<c[f+84>>2])-1|0;y=(1<<c[f+88>>2])-1|0;a:do{if(u>>>0<15){z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0;z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0}z=j;A=v+((t&x)<<2)|0;b[z+0>>1]=b[A+0>>1]|0;b[z+2>>1]=b[A+2>>1]|0;while(1){B=d[j+1|0]|0;t=t>>>B;u=u-B|0;B=d[j]|0;if((B|0)==0){C=6;break}if((B&16|0)!=0){C=8;break}if((B&64|0)!=0){C=55;break a}A=j;z=v+((e[j+2>>1]|0)+(t&(1<<B)-1)<<2)|0;b[A+0>>1]=b[z+0>>1]|0;b[A+2>>1]=b[z+2>>1]|0}do{if((C|0)==6){C=0;z=n+1|0;n=z;a[z]=b[j+2>>1]}else if((C|0)==8){C=0;D=e[j+2>>1]|0;B=B&15;if((B|0)!=0){if(u>>>0<B>>>0){z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0}D=D+(t&(1<<B)-1)|0;t=t>>>B;u=u-B|0}if(u>>>0<15){z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0;z=l+1|0;l=z;t=t+((d[z]|0)<<u)|0;u=u+8|0}z=j;A=w+((t&y)<<2)|0;b[z+0>>1]=b[A+0>>1]|0;b[z+2>>1]=b[A+2>>1]|0;while(1){B=d[j+1|0]|0;t=t>>>B;u=u-B|0;B=d[j]|0;if((B&16|0)!=0){break}if((B&64|0)!=0){C=52;break a}A=j;z=w+((e[j+2>>1]|0)+(t&(1<<B)-1)<<2)|0;b[A+0>>1]=b[z+0>>1]|0;b[A+2>>1]=b[z+2>>1]|0}z=e[j+2>>1]|0;B=B&15;do{if(u>>>0<B>>>0){A=l+1|0;l=A;t=t+((d[A]|0)<<u)|0;u=u+8|0;if(!(u>>>0<B>>>0)){break}A=l+1|0;l=A;t=t+((d[A]|0)<<u)|0;u=u+8|0}}while(0);z=z+(t&(1<<B)-1)|0;t=t>>>B;u=u-B|0;B=n-o|0;if(!(z>>>0>B>>>0)){E=n+(0-z)|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;D=D-3|0;}while(D>>>0>2);if((D|0)==0){break}A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;if(!(D>>>0>1)){break}A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;break}B=z-B|0;if(B>>>0>q>>>0){if((c[f+7104>>2]|0)!=0){C=22;break a}}E=s+ -1|0;do{if((r|0)==0){E=E+(p-B)|0;if(!(B>>>0<D>>>0)){break}D=D-B|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=B+ -1|0;B=A;}while((A|0)!=0);E=n+(0-z)|0}else{if(!(r>>>0<B>>>0)){E=E+(r-B)|0;if(!(B>>>0<D>>>0)){break}D=D-B|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=B+ -1|0;B=A;}while((A|0)!=0);E=n+(0-z)|0;break}E=E+(p+r-B)|0;B=B-r|0;if(!(B>>>0<D>>>0)){break}D=D-B|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=B+ -1|0;B=A;}while((A|0)!=0);E=s+ -1|0;if(!(r>>>0<D>>>0)){break}B=r;D=D-B|0;do{A=E+1|0;E=A;F=n+1|0;n=F;a[F]=a[A]|0;A=B+ -1|0;B=A;}while((A|0)!=0);E=n+(0-z)|0}}while(0);while(1){if(!(D>>>0>2)){break}z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0;z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0;z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0;D=D-3|0}if((D|0)==0){break}z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0;if(!(D>>>0>1)){break}z=E+1|0;E=z;A=n+1|0;n=A;a[A]=a[z]|0}}while(0);if(!(l>>>0<m>>>0)){break}}while(n>>>0<g>>>0);do{if((C|0)==22){c[k+24>>2]=104552;c[f>>2]=29}else if((C|0)==52){c[k+24>>2]=104584;c[f>>2]=29}else if((C|0)==55){if((B&32|0)!=0){c[f>>2]=11;break}else{c[k+24>>2]=104608;c[f>>2]=29;break}}}while(0);D=u>>>3;l=l+(0-D)|0;u=u-(D<<3)|0;t=t&(1<<u)-1;c[k>>2]=l+1;c[k+12>>2]=n+1;if(l>>>0<m>>>0){G=5+(m-l)|0}else{G=5-(l-m)|0}c[k+4>>2]=G;if(n>>>0<g>>>0){H=257+(g-n)|0;I=k;J=I;K=J+16|0;L=K;c[L>>2]=H;M=t;N=f;O=N;P=O+56|0;Q=P;c[Q>>2]=M;R=u;S=f;T=S;U=T+60|0;V=U;c[V>>2]=R;i=h;return}else{H=257-(n-g)|0;I=k;J=I;K=J+16|0;L=K;c[L>>2]=H;M=t;N=f;O=N;P=O+56|0;Q=P;c[Q>>2]=M;R=u;S=f;T=S;U=T+60|0;V=U;c[V>>2]=R;i=h;return}}function vN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function wN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function xN(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function yN(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Cb(104640,n|0)|0;i=m;return 0}function zN(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=pV(a,104648)|0;z=pV(b,104648)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((pV(a,104656)|0)!=0){C=5;break}if((pV(a,104664)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((pV(b,104656)|0)!=0){break}if((pV(b,104664)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){tma(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}tma(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}tma(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Cb(104672,r|0)|0;i=q;return 0}function AN(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(pV(a,104680)|0)!=0;v=c[(u?f:g)>>2]|0;w=pV(e,104688)|0;x=pV(b,104696)|0;c[p>>2]=0;do{if(u){y=4}else{if((pV(a,104704)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((pV(b,104680)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((pV(d,104688)|0)==0){if((pV(d,104712)|0)!=0){break}if((pV(d,104720)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((pV(e,104696)|0)==0){if((pV(e,104688)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){tma(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(pV(d,104688)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Cb(104728,p|0)|0;i=o;return 0}function BN(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}DN(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}EN(104744,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Cb(104736,l|0)|0;i=k;return 0}function CN(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+YU(104768);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(vN(l,z,104776)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){xN(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;wN(l,n,d+(x-o+v<<3)|0,104776)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;yN(l,m,104784,d+(B+y<<3)|0,104776,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Cb(104760,k|0)|0;i=j;return 0}function DN(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=104816;u=GN(104800,104792,104808,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;CN(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;FN(k,d,e,m,l,f,104800)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;FN(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,104800)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;AN(104824,104832,104840,104856,n,k,104864,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=104840;zN(H,H,k,l,n,104872,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,104864,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);CN(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Cb(104792,j|0)|0;i=h;return 0}function EN(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(pV(a,104880)|0)!=0;do{if(n){o=5}else{if((pV(a,104888)|0)!=0){o=5;break}if((pV(a,104896)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=104912;FN(d,h,j,q,b,g,q)|0;AN(104920,104928,104936,104952,b,d,104960,e,f,h,j)|0;AN(104920,104968,104936,104976,b,d,104960,e,f,h,j)|0;i=l;return 0}else{AN(104920,104968,104992,104976,b,d,104960,e,f,h,j)|0;AN(104920,104928,104992,104952,b,d,104960,e,f,h,j)|0;FN(d,h,j,104912,b,g,105008)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Cb(104904,m|0)|0;i=l;return 0}function FN(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function GN(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=pma(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;w9(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;w9(t,o+1|0,1,2);l=m;w9(l,o+3|0,1,3);o=n;w9(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==3){if((v9(t,105016,1,2)|0)==0){if((v9(l,105032,1,3)|0)==0){v=128;i=k;return v|0}if((v9(l,105040,1,3)|0)==0){v=128;i=k;return v|0}if((v9(l,105048,1,3)|0)==0){v=128;i=k;return v|0}if((v9(l,105056,1,3)|0)==0){v=128;i=k;return v|0}if((v9(l,105064,1,3)|0)==0){v=128;i=k;return v|0}n=(v9(l,105072,1,3)|0)==0;v=n?128:0;i=k;return v|0}if((v9(t,105096,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}n=(v9(l,105104,1,3)|0)==0;v=n?32:0;i=k;return v|0}if(u<<24>>24==68|u<<24>>24==83){w=141}else if(u<<24>>24==67|u<<24>>24==90){w=138}else{v=0;i=k;return v|0}do{if((w|0)==138){if((v9(t,105120,1,2)|0)==0){n=(v9(l,105104,1,3)|0)==0;v=n?32:0;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=141;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((v9(t,105128,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((v9(o,105136,1,2)|0)!=0){if((v9(o,105144,1,2)|0)==0){break}if((v9(o,105152,1,2)|0)==0){break}if((v9(o,105160,1,2)|0)==0){break}if((v9(o,105168,1,2)|0)==0){break}if((v9(o,105176,1,2)|0)==0){break}if((v9(o,105184,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((v9(t,105192,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((v9(o,105136,1,2)|0)!=0){if((v9(o,105144,1,2)|0)==0){break}if((v9(o,105152,1,2)|0)==0){break}if((v9(o,105160,1,2)|0)==0){break}if((v9(o,105168,1,2)|0)==0){break}if((v9(o,105176,1,2)|0)==0){break}if((v9(o,105184,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else if((m|0)==2){if((v9(t,105016,1,2)|0)==0){if((v9(l,105032,1,3)|0)==0){v=2;i=k;return v|0}if((v9(l,105040,1,3)|0)==0){v=2;i=k;return v|0}if((v9(l,105048,1,3)|0)==0){v=2;i=k;return v|0}if((v9(l,105056,1,3)|0)==0){v=2;i=k;return v|0}if((v9(l,105064,1,3)|0)==0){v=2;i=k;return v|0}if((v9(l,105072,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((v9(t,105096,1,2)|0)==0){m=(v9(l,105024,1,3)|0)==0;if(m|(p|q)^1){v=m?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==68|u<<24>>24==83){w=94}else if(u<<24>>24==67|u<<24>>24==90){w=91}else{v=2;i=k;return v|0}do{if((w|0)==91){if((v9(t,105120,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==67|u<<24>>24==90){break}else if(u<<24>>24==68|u<<24>>24==83){w=94;break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((v9(t,105128,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}m=a[l]|0;if(m<<24>>24==77){if((v9(o,105136,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105144,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105152,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105160,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105168,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105176,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(m<<24>>24==71){if((v9(o,105136,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105144,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105152,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105160,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105168,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105176,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((v9(t,105192,1,2)|0)!=0){v=2;i=k;return v|0}m=a[l]|0;if(m<<24>>24==77){if((v9(o,105136,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105144,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105152,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105160,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105168,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105176,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(m<<24>>24==71){if((v9(o,105136,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105144,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105152,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105160,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105168,1,2)|0)==0){v=2;i=k;return v|0}if((v9(o,105176,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else{if((v9(t,105016,1,2)|0)==0){if((v9(l,105024,1,3)|0)==0){v=64;i=k;return v|0}if((v9(l,105032,1,3)|0)==0){v=32;i=k;return v|0}if((v9(l,105040,1,3)|0)==0){v=32;i=k;return v|0}if((v9(l,105048,1,3)|0)==0){v=32;i=k;return v|0}if((v9(l,105056,1,3)|0)==0){v=32;i=k;return v|0}if((v9(l,105064,1,3)|0)==0){v=32;i=k;return v|0}if((v9(l,105072,1,3)|0)==0){v=32;i=k;return v|0}m=(v9(l,105080,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((v9(t,105088,1,2)|0)==0){m=(v9(l,105024,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((v9(t,105096,1,2)|0)==0){m=(v9(l,105024,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(v9(l,105104,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(v9(l,105112,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==67|u<<24>>24==90){if((v9(t,105120,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((v9(l,105024,1,3)|0)==0){v=64;i=k;return v|0}if((v9(l,105104,1,3)|0)==0){v=32;i=k;return v|0}m=(v9(l,105112,1,3)|0)==0;v=m?64:1;i=k;return v|0}else if(u<<24>>24==68|u<<24>>24==83){w=29}}while(0);do{if((w|0)==29){if((v9(t,105128,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((v9(o,105136,1,2)|0)!=0){if((v9(o,105144,1,2)|0)==0){break}if((v9(o,105152,1,2)|0)==0){break}if((v9(o,105160,1,2)|0)==0){break}if((v9(o,105168,1,2)|0)==0){break}if((v9(o,105176,1,2)|0)==0){break}if((v9(o,105184,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((v9(o,105136,1,2)|0)!=0){if((v9(o,105144,1,2)|0)==0){break}if((v9(o,105152,1,2)|0)==0){break}if((v9(o,105160,1,2)|0)==0){break}if((v9(o,105168,1,2)|0)==0){break}if((v9(o,105176,1,2)|0)==0){break}if((v9(o,105184,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((v9(t,105192,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((v9(o,105136,1,2)|0)!=0){if((v9(o,105144,1,2)|0)==0){break}if((v9(o,105152,1,2)|0)==0){break}if((v9(o,105160,1,2)|0)==0){break}if((v9(o,105168,1,2)|0)==0){break}if((v9(o,105176,1,2)|0)==0){break}if((v9(o,105184,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==71){do{if((v9(o,105136,1,2)|0)!=0){if((v9(o,105144,1,2)|0)==0){break}if((v9(o,105152,1,2)|0)==0){break}if((v9(o,105160,1,2)|0)==0){break}if((v9(o,105168,1,2)|0)==0){break}if((v9(o,105176,1,2)|0)==0){break}if((v9(o,105184,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((v9(t,105200,1,2)|0)==0){if((v9(l,105024,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((v9(t,105208,1,2)|0)==0){if((v9(l,105024,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((v9(t,105176,1,2)|0)==0){o=(v9(l,105080,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((v9(t,105216,1,2)|0)==0){o=(v9(l,105224,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((v9(t,105232,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};case 6:{t=c[f>>2]|0;u=c[g>>2]|0;v=~~(+(((t|0)>(u|0)?u:t)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};case 10:{v=HN(105248,105256,105264)|0;i=k;return v|0};case 11:{v=HN(105272,105256,105264)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=IN(b,d,e,f,g,h,j)|0;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function HN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function IN(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(u9(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 15:{p=o;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 12:{p=75;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};default:{p=-1;i=j;return p|0}}return 0}function JN(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=KN(a,0,0)|0;i=b;return c|0}function KN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=LN(a,b,c,0)|0;i=d;return e|0}function LN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=oe[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=Nla(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=49;c[f+8>>2]=283}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=oe[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){le[c[b+8>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=oe[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){le[c[b+20>>2]&511](c[j+392>>2]|0);le[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=WO(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}le[c[j+20>>2]&511](c[j+44>>2]|0);le[c[j+20>>2]&511](c[j+392>>2]|0);le[c[j+20>>2]&511](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;XO(j+416|0,j+12|0);XO(j+440|0,j+12|0);NN(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}QN(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=pP()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=gP()|0}k=j;l=k;i=g;return l|0}function MN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function NN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=37;yR(f+256|0);if((b|0)!=0){g=ON(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;hP(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function ON(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((dO(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function PN(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((dO(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((dO(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=gO(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=ON(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((dO(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((dO(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((kO(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((dO(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=gO(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function QN(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;le[c[e+20>>2]&511](c[g+36>>2]|0);RN(c[g+44>>2]|0,e);le[c[e+20>>2]&511](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;le[c[e+20>>2]&511](f)}RN(c[h+376>>2]|0,e);RN(c[e+372>>2]|0,e);SN(e+416|0);SN(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}TN(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);le[c[e+20>>2]&511](c[e+392>>2]|0);le[c[e+20>>2]&511](c[e+464>>2]|0);le[c[e+20>>2]&511](c[e+8>>2]|0);le[c[e+20>>2]&511](c[e+44>>2]|0);le[c[e+20>>2]&511](c[e+396>>2]|0);le[c[e+20>>2]&511](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){le[c[e+252>>2]&511](c[e+244>>2]|0)}le[c[e+20>>2]&511](e);i=d;return}



function F0(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Xb=i;i=i+16|0;Yb=i;i=i+8|0;Zb=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;P0(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){VS(0,162376,n)}if(p){ec=Ed(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;RS(23,0,162520,m);Q0(q);R0(q,e,8);if(!(S0(q)|0)){c[l>>2]=e;VS(0,162560,l)}wba(r);l=q;T0(l,r)|0;yba(s,r);while(1){e=T0(l,r)|0;if(!(sca(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}rca(t,162640,r);Zba(s,t)|0;Iba(t)}t=Ed(dca(s)|0)|0;U0(q);Iba(s);Iba(r);V0(q);fc=t}if((fc|0)==0){RS(23,0,162728,g);X0(o);i=f;return}wba(u);wba(v);c[k>>2]=fc;RS(23,0,162648,k);k=_b(fc|0,162640)|0;if((k|0)!=0){g=k;do{k=Tla(12)|0;Cba(k,g);t=eca(k,162680,0)|0;cca(w,k,0,t);Jba(u,w)|0;Iba(w);cca(x,k,t+1|0,(Pba(k)|0)+~t|0);Jba(v,x)|0;Iba(x);Jba(n0(o,u)|0,v)|0;t=dca(u)|0;k=dca(v)|0;c[j>>2]=t;c[j+4>>2]=k;RS(23,0,162688,j);g=_b(0,162640)|0;}while((g|0)!=0)}Ola(fc);fc=a+12|0;Cba(y,160776);g=n0(fc,y)|0;Cba(z,160776);if((W0(o,z)|0)==0){Cba(B,160776);gc=1;hc=0;ic=n0(fc,B)|0}else{Cba(A,160776);gc=0;hc=1;ic=n0(o,A)|0}Jba(g,ic)|0;if(gc){Iba(B)}if(hc){Iba(A)}Iba(z);Iba(y);Cba(C,160648);y=n0(fc,C)|0;Cba(D,160648);if((W0(o,D)|0)==0){Cba(F,160648);jc=1;kc=0;lc=n0(fc,F)|0}else{Cba(E,160648);jc=0;kc=1;lc=n0(o,E)|0}Jba(y,lc)|0;if(jc){Iba(F)}if(kc){Iba(E)}Iba(D);Iba(C);Cba(G,160680);C=n0(fc,G)|0;Cba(H,160680);if((W0(o,H)|0)==0){Cba(J,160680);mc=1;nc=0;oc=n0(fc,J)|0}else{Cba(I,160680);mc=0;nc=1;oc=n0(o,I)|0}Jba(C,oc)|0;if(mc){Iba(J)}if(nc){Iba(I)}Iba(H);Iba(G);Cba(K,160712);G=n0(fc,K)|0;Cba(L,160712);if((W0(o,L)|0)==0){Cba(N,160712);pc=0;qc=1;rc=n0(fc,N)|0}else{Cba(M,160712);pc=1;qc=0;rc=n0(o,M)|0}Jba(G,rc)|0;if(qc){Iba(N)}if(pc){Iba(M)}Iba(L);Iba(K);Cba(O,160744);K=n0(fc,O)|0;Cba(P,160744);if((W0(o,P)|0)==0){Cba(R,160744);sc=1;tc=0;uc=n0(fc,R)|0}else{Cba(Q,160744);sc=0;tc=1;uc=n0(o,Q)|0}Jba(K,uc)|0;if(sc){Iba(R)}if(tc){Iba(Q)}Iba(P);Iba(O);Cba(S,160808);O=n0(fc,S)|0;Cba(T,160808);if((W0(o,T)|0)==0){Cba(V,160808);vc=1;wc=0;xc=n0(fc,V)|0}else{Cba(U,160808);vc=0;wc=1;xc=n0(o,U)|0}Jba(O,xc)|0;if(vc){Iba(V)}if(wc){Iba(U)}Iba(T);Iba(S);Cba(W,160848);S=n0(fc,W)|0;Cba(X,160848);if((W0(o,X)|0)==0){Cba(Z,160848);yc=1;zc=0;Ac=n0(fc,Z)|0}else{Cba(Y,160848);yc=0;zc=1;Ac=n0(o,Y)|0}Jba(S,Ac)|0;if(yc){Iba(Z)}if(zc){Iba(Y)}Iba(X);Iba(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=G0(Y,_)|0;Cba($,159752);Ac=n0(yc,$)|0;c[aa>>2]=Z;yc=G0(Y,aa)|0;Cba(ba,159608);if((W0(o,n0(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=G0(Y,ea)|0;Cba(fa,159752);Bc=1;Cc=0;Dc=n0(yc,fa)|0}else{c[ca>>2]=Z;yc=G0(Y,ca)|0;Cba(da,159608);Bc=0;Cc=1;Dc=n0(o,n0(yc,da)|0)|0}Jba(Ac,Dc)|0;if(Bc){Iba(fa)}if(Cc){Iba(da)}Iba(ba);Iba($);c[ga>>2]=Z;Ac=G0(zc,ga)|0;Cba(ha,159752);yc=n0(Ac,ha)|0;c[ia>>2]=Z;Ac=G0(zc,ia)|0;Cba(ja,159608);if((W0(o,n0(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=G0(zc,ma)|0;Cba(na,159752);Ec=1;Fc=0;Gc=n0(Ac,na)|0}else{c[ka>>2]=Z;Ac=G0(zc,ka)|0;Cba(la,159608);Ec=0;Fc=1;Gc=n0(o,n0(Ac,la)|0)|0}Jba(yc,Gc)|0;if(Ec){Iba(na)}if(Fc){Iba(la)}Iba(ja);Iba(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=G0(Hc,oa)|0;Cba(pa,159752);ja=n0(ha,pa)|0;c[qa>>2]=Z;ha=G0(Hc,qa)|0;Cba(ra,159608);if((W0(o,n0(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=G0(Hc,ua)|0;Cba(va,159752);Ic=1;Jc=0;Kc=n0(ha,va)|0}else{c[sa>>2]=Z;ha=G0(Hc,sa)|0;Cba(ta,159608);Ic=0;Jc=1;Kc=n0(o,n0(ha,ta)|0)|0}Jba(ja,Kc)|0;if(Ic){Iba(va)}if(Jc){Iba(ta)}Iba(ra);Iba(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=G0(X,wa)|0;Cba(xa,159752);ra=n0(pa,xa)|0;c[ya>>2]=Z;pa=G0(X,ya)|0;Cba(za,159608);if((W0(o,n0(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=G0(X,Ca)|0;Cba(Da,159752);Lc=1;Mc=0;Nc=n0(pa,Da)|0}else{c[Aa>>2]=Z;pa=G0(X,Aa)|0;Cba(Ba,159608);Lc=0;Mc=1;Nc=n0(o,n0(pa,Ba)|0)|0}Jba(ra,Nc)|0;if(Lc){Iba(Da)}if(Mc){Iba(Ba)}Iba(za);Iba(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=G0(Z,Ea)|0;Cba(Fa,159752);Ba=n0(za,Fa)|0;c[Ga>>2]=xa;za=G0(Z,Ga)|0;Cba(Ha,159608);if((W0(o,n0(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=G0(Z,Ka)|0;Cba(La,159752);Oc=1;Pc=0;Qc=n0(za,La)|0}else{c[Ia>>2]=xa;za=G0(Z,Ia)|0;Cba(Ja,159608);Oc=0;Pc=1;Qc=n0(o,n0(za,Ja)|0)|0}Jba(Ba,Qc)|0;if(Oc){Iba(La)}if(Pc){Iba(Ja)}Iba(Ha);Iba(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=G0(xa,Ma)|0;Cba(Na,159752);Ja=n0(Ha,Na)|0;c[Oa>>2]=Fa;Ha=G0(xa,Oa)|0;Cba(Pa,159608);if((W0(o,n0(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=G0(xa,Sa)|0;Cba(Ta,159752);Rc=1;Sc=0;Tc=n0(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=G0(xa,Qa)|0;Cba(Ra,159608);Rc=0;Sc=1;Tc=n0(o,n0(Ha,Ra)|0)|0}Jba(Ja,Tc)|0;if(Rc){Iba(Ta)}if(Sc){Iba(Ra)}Iba(Pa);Iba(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=G0(Fa,Ua)|0;Cba(Va,159752);Ra=n0(Pa,Va)|0;c[Wa>>2]=Na;Pa=G0(Fa,Wa)|0;Cba(Xa,159608);if((W0(o,n0(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=G0(Fa,_a)|0;Cba($a,159752);Uc=1;Vc=0;Wc=n0(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=G0(Fa,Ya)|0;Cba(Za,159608);Uc=0;Vc=1;Wc=n0(o,n0(Pa,Za)|0)|0}Jba(Ra,Wc)|0;if(Uc){Iba($a)}if(Vc){Iba(Za)}Iba(Xa);Iba(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=G0(Na,ab)|0;Cba(bb,159752);Za=n0(Xa,bb)|0;c[cb>>2]=Va;Xa=G0(Na,cb)|0;Cba(db,159608);if((W0(o,n0(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=G0(Na,gb)|0;Cba(hb,159752);Xc=1;Yc=0;Zc=n0(Xa,hb)|0}else{c[eb>>2]=Va;Xa=G0(Na,eb)|0;Cba(fb,159608);Xc=0;Yc=1;Zc=n0(o,n0(Xa,fb)|0)|0}Jba(Za,Zc)|0;if(Xc){Iba(hb)}if(Yc){Iba(fb)}Iba(db);Iba(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=G0(Va,ib)|0;Cba(jb,159752);fb=n0(db,jb)|0;c[kb>>2]=bb;db=G0(Va,kb)|0;Cba(lb,159608);if((W0(o,n0(db,lb)|0)|0)==0){c[ob>>2]=bb;db=G0(Va,ob)|0;Cba(pb,159752);_c=1;$c=0;ad=n0(db,pb)|0}else{c[mb>>2]=bb;db=G0(Va,mb)|0;Cba(nb,159608);_c=0;$c=1;ad=n0(o,n0(db,nb)|0)|0}Jba(fb,ad)|0;if(_c){Iba(pb)}if($c){Iba(nb)}Iba(lb);Iba(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=G0(bb,qb)|0;Cba(rb,159752);nb=n0(lb,rb)|0;c[sb>>2]=jb;lb=G0(bb,sb)|0;Cba(tb,159608);if((W0(o,n0(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=G0(bb,wb)|0;Cba(xb,159752);bd=1;cd=0;dd=n0(lb,xb)|0}else{c[ub>>2]=jb;lb=G0(bb,ub)|0;Cba(vb,159608);bd=0;cd=1;dd=n0(o,n0(lb,vb)|0)|0}Jba(nb,dd)|0;if(bd){Iba(xb)}if(cd){Iba(vb)}Iba(tb);Iba(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=G0(jb,yb)|0;Cba(zb,159752);vb=n0(tb,zb)|0;c[Ab>>2]=rb;tb=G0(jb,Ab)|0;Cba(Bb,159608);if((W0(o,n0(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=G0(jb,Eb)|0;Cba(Fb,159752);ed=1;fd=0;gd=n0(tb,Fb)|0}else{c[Cb>>2]=rb;tb=G0(jb,Cb)|0;Cba(Db,159608);ed=0;fd=1;gd=n0(o,n0(tb,Db)|0)|0}Jba(vb,gd)|0;if(ed){Iba(Fb)}if(fd){Iba(Db)}Iba(Bb);Iba(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=G0(rb,Gb)|0;Cba(Hb,159752);Db=n0(Bb,Hb)|0;c[Ib>>2]=zb;Bb=G0(rb,Ib)|0;Cba(Jb,159608);if((W0(o,n0(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=G0(rb,Mb)|0;Cba(Nb,159752);hd=0;id=1;jd=n0(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=G0(rb,Kb)|0;Cba(Lb,159608);hd=1;id=0;jd=n0(o,n0(Bb,Lb)|0)|0}Jba(Db,jd)|0;if(id){Iba(Nb)}if(hd){Iba(Lb)}Iba(Jb);Iba(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=G0(zb,Ob)|0;Cba(Pb,159752);Lb=n0(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=G0(zb,Qb)|0;Cba(Rb,159608);if((W0(o,n0(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=G0(zb,Ub)|0;Cba(Vb,159752);kd=1;ld=0;md=n0(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=G0(zb,Sb)|0;Cba(Tb,159608);kd=0;ld=1;md=n0(o,n0(Jb,Tb)|0)|0}Jba(Lb,md)|0;if(kd){Iba(Vb)}if(ld){Iba(Tb)}Iba(Rb);Iba(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=G0(b,Wb)|0;Cba(Xb,159752);Pb=n0(Hb,Xb)|0;c[Yb>>2]=a;Hb=G0(b,Yb)|0;Cba(Zb,159608);if((W0(o,n0(Hb,Zb)|0)|0)==0){c[bc>>2]=a;Hb=G0(b,bc)|0;Cba(cc,159752);nd=1;od=0;pd=n0(Hb,cc)|0}else{c[$b>>2]=a;Hb=G0(b,$b)|0;Cba(ac,159608);nd=0;od=1;pd=n0(o,n0(Hb,ac)|0)|0}Jba(Pb,pd)|0;if(nd){Iba(cc)}if(od){Iba(ac)}Iba(Zb);Iba(Xb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}RS(23,0,162712,h);Iba(v);Iba(u);X0(o);i=f;return}function G0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=n3(a,f,b)|0;l=c[k>>2]|0;ZY(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}p3(j,a,b);q3(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];o3(g,e);r3(j);j=c[f>>2]|0;s3(a,j,k,t3(g)|0);k=u3(g)|0;r3(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function H0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=R1(a,f,b)|0;l=c[k>>2]|0;ZY(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}T1(j,a,b);U1(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];S1(g,e);V1(j);j=c[f>>2]|0;W1(a,j,k,X1(g)|0);k=Y1(g)|0;V1(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function I0(a,b){a=a|0;b=b|0;var c=0;c=i;Jba(b,a)|0;i=c;return}function J0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;I1(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];A1(a,f);i=e;return}function K0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=y1(a,b)|0;i=c;return d|0}function L0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;B1(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];A1(a,e);i=d;return}function M0(a){a=a|0;var b=0,c=0;b=i;c=v1(a)|0;i=b;return c|0}function N0(a){a=a|0;var b=0;b=i;U5(a);i=b;return}function O0(a){a=a|0;var b=0;b=i;H5(a);i=b;return}function P0(a,b){a=a|0;b=b|0;b=i;o4(a,0);i=b;return}function Q0(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;Fca(d);e=a;c[e>>2]=162780;f=d;c[f>>2]=162800;d=a+8|0;xda(a,162812|0,d);c[e>>2]=162780;c[f>>2]=162800;G$(d);i=b;return}function R0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(fZ(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){wca(d,4);i=e;return}else{uca(d,0);i=e;return}}function S0(a){a=a|0;var b=0,c=0;b=i;c=q1(a+8|0)|0;i=b;return c|0}function T0(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=p1(a,b,Dca(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function U0(a){a=a|0;var b=0;b=i;if((hZ(a+8|0)|0)!=0){i=b;return}wca(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function V0(a){a=a|0;var b=0;b=i;u1(a,162808);Aca(a+108|0);i=b;return}function W0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Y0(a,b)|0;i=c;return d|0}function X0(a){a=a|0;var b=0;b=i;w5(a);i=b;return}function Y0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=_0(a)|0;ZY(e);if((f|0)==0){g=0;i=d;return g|0}h=$0(a)|0;a=f;while(1){f=a+16|0;if(a1(h,b,f)|0){j=a}else{if(!(b1(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;ZY(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function Z0(a){a=a|0;var b=0,c=0;b=i;c=KY(h1(a+4|0)|0)|0;i=b;return c|0}function _0(a){a=a|0;var b=0,d=0;b=i;d=c[(Z0(a)|0)>>2]|0;i=b;return d|0}function $0(a){a=a|0;var b=0,c=0;b=i;c=f1(a+8|0)|0;i=b;return c|0}function a1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=c1(0,b,c)|0;i=a;return d|0}function b1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=c1(0,b,c)|0;i=a;return d|0}function c1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=d1(b,c)|0;i=a;return d|0}function d1(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(fca(a,b)|0)<0;i=c;return d|0}function e1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=kma(a,b,c)|0;i=d;return e|0}function f1(a){a=a|0;var b=0,c=0;b=i;c=g1(a)|0;i=b;return c|0}function g1(a){a=a|0;i=i;return a|0}function h1(a){a=a|0;var b=0,c=0;b=i;c=i1(a)|0;i=b;return c|0}function i1(a){a=a|0;i=i;return a|0}function j1(a,b){a=a|0;b=b|0;var c=0;a=i;c=l1(0,b,0)|0;i=a;return c|0}function k1(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function l1(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Tla(b)|0;i=c;return a|0}function m1(a){a=a|0;var b=0,c=0;b=i;c=pma(a|0)|0;i=b;return c|0}function n1(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=o1(b,c,e)|0;i=d;return g|0}function o1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=b_(0,a,b)|0;i=c;return(d?b:a)|0}function p1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;Cda(f,a,1);if(!(Fda(f)|0)){i=e;return a|0}Yba(b);f=0;while(1){g=Lca(Bca(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(TZ(g,-1)|0){h=2;j=f;break}k=f+1|0;l=UZ(g)|0;if(YZ(l,d)|0){h=0;j=k;break}_ba(b,l);if((Gba(b)|0)==-17){h=4;j=k;break}else{f=k}}wca(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function q1(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function r1(a){a=a|0;var b=0;b=i;V0(a);Vla(a);i=b;return}function s1(a){a=a|0;var b=0;b=i;V0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function t1(a){a=a|0;var b=0;b=i;r1(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function u1(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];HZ(a+8|0);i=d;return}function v1(a){a=a|0;var b=0,d=0;b=i;d=w1((c[a>>2]|0)+16|0)|0;i=b;return d|0}function w1(a){a=a|0;var b=0,c=0;b=i;c=x1(a)|0;i=b;return c|0}function x1(a){a=a|0;i=i;return a|0}function y1(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(z1(a,b)|0)^1;i=c;return d|0}function z1(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function A1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];H1(a,e);i=d;return}function B1(a,b){a=a|0;b=b|0;var c=0;c=i;C1(a,D1(b)|0);i=c;return}function C1(a,b){a=a|0;b=b|0;var c=0;c=i;G1(a,b);i=c;return}function D1(a){a=a|0;var b=0,c=0;b=i;c=KY(E1(a+4|0)|0)|0;i=b;return c|0}function E1(a){a=a|0;var b=0,c=0;b=i;c=F1(a)|0;i=b;return c|0}function F1(a){a=a|0;i=i;return a|0}function G1(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function H1(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function I1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=K1(b)|0;J1(f,b,d,h,D1(b)|0);B1(g,b);do{if(y1(f,g)|0){h=L1(b)|0;if(M1(h,d,N1(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);B1(a,b);i=e;return}function J1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;ZY(h);a:do{if((e|0)==0){j=f}else{k=L1(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(Q1(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;ZY(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;ZY(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);C1(a,j);i=g;return}function K1(a){a=a|0;var b=0,d=0;b=i;d=c[(D1(a)|0)>>2]|0;i=b;return d|0}function L1(a){a=a|0;var b=0,c=0;b=i;c=O1(a+8|0)|0;i=b;return c|0}function M1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=c1(0,b,c)|0;i=a;return d|0}function N1(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function O1(a){a=a|0;var b=0,c=0;b=i;c=P1(a)|0;i=b;return c|0}function P1(a){a=a|0;i=i;return a|0}function Q1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=c1(0,b,c)|0;i=a;return d|0}function R1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=K1(h)|0;ZY(e);if((a|0)==0){j=D1(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(c1(0,d,a)|0){m=l;j=c[m>>2]|0;ZY(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(c1(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;ZY(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function S1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];N2(a,e);i=d;return}function T1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=s2(d)|0;d=u2(n,1)|0;v2(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];t2(j,d,h);w2(0,l2((x2(j)|0)+16|0)|0,e);e=y2(j)|0;a[e+4|0]=1;z2(0,j2((x2(j)|0)+28|0)|0);a[e+5|0]=1;A2(m,j);U1(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];S1(b,g);V1(m);V1(j);i=f;return}function U1(a,b){a=a|0;b=b|0;var c=0;c=i;q2(a,b);i=c;return}function V1(a){a=a|0;var b=0;b=i;f2(a);i=b;return}function W1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;ZY(f);c[e>>2]=0;ZY(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=b2(a)|0;b=c[c[e>>2]>>2]|0;ZY(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(D1(a)|0)>>2]|0;J_(e,c[d>>2]|0);d=c2(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function X1(a){a=a|0;var b=0,d=0;b=i;d=c[($1(a)|0)>>2]|0;i=b;return d|0}function Y1(a){a=a|0;var b=0,d=0;b=i;d=Z1(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function Z1(a){a=a|0;var b=0,c=0;b=i;c=_1(a)|0;i=b;return c|0}function _1(a){a=a|0;i=i;return a|0}function $1(a){a=a|0;var b=0,c=0;b=i;c=a2(a)|0;i=b;return c|0}function a2(a){a=a|0;i=i;return a|0}function b2(a){a=a|0;i=i;return a|0}function c2(a){a=a|0;var b=0,c=0;b=i;c=d2(a+8|0)|0;i=b;return c|0}function d2(a){a=a|0;var b=0,c=0;b=i;c=e2(a)|0;i=b;return c|0}function e2(a){a=a|0;i=i;return a|0}function f2(a){a=a|0;var b=0;b=i;g2(a,0);i=b;return}function g2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=Z1(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}i2(h2(e)|0,f);i=d;return}function h2(a){a=a|0;var b=0,c=0;b=i;c=p2(a)|0;i=b;return c|0}function i2(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;k2(f,l2(d+16|0)|0)}if((d|0)==0){i=e;return}m2(c[b>>2]|0,d,1);i=e;return}function j2(a){a=a|0;i=i;return a|0}function k2(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;o2(d,0,c);i=b;return}function l2(a){a=a|0;i=i;return a|0}function m2(a,b,c){a=a|0;b=b|0;c=c|0;c=i;n2(0,b,0);i=c;return}function n2(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Vla(b);i=c;return}function o2(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Iba(c);i=b;return}function p2(a){a=a|0;i=i;return a+4|0}function q2(a,b){a=a|0;b=b|0;var c=0;c=i;r2(a,b);i=c;return}function r2(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function s2(a){a=a|0;var b=0,c=0;b=i;c=L2(a+4|0)|0;i=b;return c|0}function t2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];D2(a,b,f);i=e;return}function u2(a,b){a=a|0;b=b|0;var c=0;a=i;c=C2(0,b,0)|0;i=a;return c|0}function v2(a,b){a=a|0;b=b|0;var c=0;c=i;B2(a,b);i=c;return}function w2(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}yba(b,c);i=a;return}function x2(a){a=a|0;var b=0,d=0;b=i;d=c[($1(a)|0)>>2]|0;i=b;return d|0}function y2(a){a=a|0;var b=0,c=0;b=i;c=h2(a)|0;i=b;return c|0}function z2(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function A2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;q2(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];S1(h,f);U1(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];S1(a,e);V1(h);i=d;return}function B2(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function C2(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Tla(b<<5)|0;i=c;return a|0}function D2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(F2(g)|0)>>2]|0;g=G2(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];E2(b,a,f);i=e;return}function E2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];H2(a,b,f);i=e;return}function F2(a){a=a|0;i=i;return a|0}function G2(a){a=a|0;i=i;return a|0}function H2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(J2(g)|0)>>2]|0;g=K2(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];I2(b,a,f);i=e;return}function I2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(J2(f)|0)>>2];f=K2(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function J2(a){a=a|0;i=i;return a|0}function K2(a){a=a|0;i=i;return a|0}function L2(a){a=a|0;var b=0,c=0;b=i;c=M2(a)|0;i=b;return c|0}function M2(a){a=a|0;i=i;return a|0}function N2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=Y1(O2(b)|0)|0;h=K2(y2(O2(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];E2(g,a,e);i=d;return}function O2(a){a=a|0;i=i;return c[a>>2]|0}function P2(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function Q2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];X2(a,e);i=d;return}function R2(a,b){a=a|0;b=b|0;var c=0;c=i;S2(a,T2(b)|0);i=c;return}function S2(a,b){a=a|0;b=b|0;var c=0;c=i;W2(a,b);i=c;return}function T2(a){a=a|0;var b=0,c=0;b=i;c=KY(U2(a+4|0)|0)|0;i=b;return c|0}function U2(a){a=a|0;var b=0,c=0;b=i;c=V2(a)|0;i=b;return c|0}function V2(a){a=a|0;i=i;return a|0}function W2(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function X2(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Y2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=_2(b)|0;Z2(f,b,d,h,T2(b)|0);R2(g,b);do{if($2(f,g)|0){h=a3(b)|0;if(a1(h,d,b3(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);R2(a,b);i=e;return}function Z2(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;ZY(h);a:do{if((e|0)==0){j=f}else{k=a3(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(b1(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;ZY(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;ZY(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);S2(a,j);i=g;return}function _2(a){a=a|0;var b=0,d=0;b=i;d=c[(T2(a)|0)>>2]|0;i=b;return d|0}function $2(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(P2(a,b)|0)^1;i=c;return d|0}function a3(a){a=a|0;var b=0,c=0;b=i;c=c3(a+8|0)|0;i=b;return c|0}function b3(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function c3(a){a=a|0;var b=0,c=0;b=i;c=d3(a)|0;i=b;return c|0}function d3(a){a=a|0;i=i;return a|0}function e3(a,b){a=a|0;b=b|0;b=i;i=i+8|0;f3(a,b);i=b;return}function f3(a,b){a=a|0;b=b|0;b=i;g3(a,0);i=b;return}function g3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;h3(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;i3(f,0,e);e=D1(b)|0;c[(b2(b)|0)>>2]=e;i=d;return}function h3(a){a=a|0;var b=0;b=i;l3(a);i=b;return}function i3(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;j3(b,c,f);i=e;return}function j3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(B$(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;k3(d,b,f);i=e;return}function k3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(B$(e)|0)>>2];i=d;return}function l3(a){a=a|0;var b=0;b=i;m3(a);i=b;return}function m3(a){a=a|0;var b=0;b=i;E$(a);i=b;return}function n3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=n4(h)|0;ZY(e);if((a|0)==0){j=A3(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(WY(0,d,a)|0){m=l;j=c[m>>2]|0;ZY(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(WY(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;ZY(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function o3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];l4(a,e);i=d;return}function p3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=S3(d)|0;d=U3(n,1)|0;V3(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];T3(j,d,h);W3(0,V_((X3(j)|0)+16|0)|0,e);e=Y3(j)|0;a[e+4|0]=1;Z3(0,L3((X3(j)|0)+20|0)|0);a[e+5|0]=1;_3(m,j);q3(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];o3(b,g);r3(m);r3(j);i=f;return}function q3(a,b){a=a|0;b=b|0;var c=0;c=i;Q3(a,b);i=c;return}function r3(a){a=a|0;var b=0;b=i;G3(a);i=b;return}function s3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;ZY(f);c[e>>2]=0;ZY(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=z3(a)|0;b=c[c[e>>2]>>2]|0;ZY(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(A3(a)|0)>>2]|0;J_(e,c[d>>2]|0);d=B3(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function t3(a){a=a|0;var b=0,d=0;b=i;d=c[(x3(a)|0)>>2]|0;i=b;return d|0}function u3(a){a=a|0;var b=0,d=0;b=i;d=v3(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function v3(a){a=a|0;var b=0,c=0;b=i;c=w3(a)|0;i=b;return c|0}function w3(a){a=a|0;i=i;return a|0}function x3(a){a=a|0;var b=0,c=0;b=i;c=y3(a)|0;i=b;return c|0}function y3(a){a=a|0;i=i;return a|0}function z3(a){a=a|0;i=i;return a|0}function A3(a){a=a|0;var b=0,c=0;b=i;c=KY(E3(a+4|0)|0)|0;i=b;return c|0}function B3(a){a=a|0;var b=0,c=0;b=i;c=C3(a+8|0)|0;i=b;return c|0}function C3(a){a=a|0;var b=0,c=0;b=i;c=D3(a)|0;i=b;return c|0}function D3(a){a=a|0;i=i;return a|0}function E3(a){a=a|0;var b=0,c=0;b=i;c=F3(a)|0;i=b;return c|0}function F3(a){a=a|0;i=i;return a|0}function G3(a){a=a|0;var b=0;b=i;H3(a,0);i=b;return}function H3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=v3(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}J3(I3(e)|0,f);i=d;return}function I3(a){a=a|0;var b=0,c=0;b=i;c=P3(a)|0;i=b;return c|0}function J3(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;K3(f,L3(d+20|0)|0)}if((d|0)==0){i=e;return}M3(c[b>>2]|0,d,1);i=e;return}function K3(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;O3(d,0,c);i=b;return}function L3(a){a=a|0;i=i;return a|0}function M3(a,b,c){a=a|0;b=b|0;c=c|0;c=i;N3(0,b,0);i=c;return}function N3(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Vla(b);i=c;return}function O3(a,b,c){a=a|0;b=b|0;c=c|0;b=i;X0(c);i=b;return}function P3(a){a=a|0;i=i;return a+4|0}function Q3(a,b){a=a|0;b=b|0;var c=0;c=i;R3(a,b);i=c;return}function R3(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function S3(a){a=a|0;var b=0,c=0;b=i;c=j4(a+4|0)|0;i=b;return c|0}function T3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];b4(a,b,f);i=e;return}function U3(a,b){a=a|0;b=b|0;var c=0;a=i;c=a4(0,b,0)|0;i=a;return c|0}function V3(a,b){a=a|0;b=b|0;var c=0;c=i;$3(a,b);i=c;return}function W3(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function X3(a){a=a|0;var b=0,d=0;b=i;d=c[(x3(a)|0)>>2]|0;i=b;return d|0}function Y3(a){a=a|0;var b=0,c=0;b=i;c=I3(a)|0;i=b;return c|0}function Z3(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}P0(b,a);i=a;return}function _3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Q3(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];o3(h,f);q3(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];o3(a,e);r3(h);i=d;return}function $3(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function a4(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Tla(b<<5)|0;i=c;return a|0}function b4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(d4(g)|0)>>2]|0;g=e4(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c4(b,a,f);i=e;return}function c4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];f4(a,b,f);i=e;return}function d4(a){a=a|0;i=i;return a|0}function e4(a){a=a|0;i=i;return a|0}function f4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(h4(g)|0)>>2]|0;g=i4(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];g4(b,a,f);i=e;return}function g4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(h4(f)|0)>>2];f=i4(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function h4(a){a=a|0;i=i;return a|0}function i4(a){a=a|0;i=i;return a|0}function j4(a){a=a|0;var b=0,c=0;b=i;c=k4(a)|0;i=b;return c|0}function k4(a){a=a|0;i=i;return a|0}function l4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=u3(m4(b)|0)|0;h=i4(Y3(m4(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c4(g,a,e);i=d;return}function m4(a){a=a|0;i=i;return c[a>>2]|0}function n4(a){a=a|0;var b=0,d=0;b=i;d=c[(A3(a)|0)>>2]|0;i=b;return d|0}function o4(a,b){a=a|0;b=b|0;b=i;i=i+8|0;p4(a,b);i=b;return}function p4(a,b){a=a|0;b=b|0;b=i;q4(a,0);i=b;return}function q4(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;r4(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;s4(f,0,e);e=T2(b)|0;c[(t4(b)|0)>>2]=e;i=d;return}function r4(a){a=a|0;var b=0;b=i;w4(a);i=b;return}function s4(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;u4(b,c,f);i=e;return}function t4(a){a=a|0;i=i;return a|0}function u4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(B$(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;v4(d,b,f);i=e;return}function v4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(B$(e)|0)>>2];i=d;return}function w4(a){a=a|0;var b=0;b=i;x4(a);i=b;return}function x4(a){a=a|0;var b=0;b=i;E$(a);i=b;return}function y4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=_2(h)|0;ZY(e);if((a|0)==0){j=T2(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(c1(0,d,a)|0){m=l;j=c[m>>2]|0;ZY(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(c1(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;ZY(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function z4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];u5(a,e);i=d;return}function A4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=$4(d)|0;d=b5(n,1)|0;c5(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];a5(j,d,h);d5(0,l2((e5(j)|0)+16|0)|0,e);e=f5(j)|0;a[e+4|0]=1;g5(0,S4((e5(j)|0)+28|0)|0);a[e+5|0]=1;h5(m,j);B4(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];z4(b,g);C4(m);C4(j);i=f;return}function B4(a,b){a=a|0;b=b|0;var c=0;c=i;Z4(a,b);i=c;return}function C4(a){a=a|0;var b=0;b=i;N4(a);i=b;return}function D4(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;ZY(f);c[e>>2]=0;ZY(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=t4(a)|0;b=c[c[e>>2]>>2]|0;ZY(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(T2(a)|0)>>2]|0;J_(e,c[d>>2]|0);d=K4(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function E4(a){a=a|0;var b=0,d=0;b=i;d=c[(I4(a)|0)>>2]|0;i=b;return d|0}function F4(a){a=a|0;var b=0,d=0;b=i;d=G4(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function G4(a){a=a|0;var b=0,c=0;b=i;c=H4(a)|0;i=b;return c|0}function H4(a){a=a|0;i=i;return a|0}function I4(a){a=a|0;var b=0,c=0;b=i;c=J4(a)|0;i=b;return c|0}function J4(a){a=a|0;i=i;return a|0}function K4(a){a=a|0;var b=0,c=0;b=i;c=L4(a+8|0)|0;i=b;return c|0}function L4(a){a=a|0;var b=0,c=0;b=i;c=M4(a)|0;i=b;return c|0}function M4(a){a=a|0;i=i;return a|0}function N4(a){a=a|0;var b=0;b=i;O4(a,0);i=b;return}function O4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=G4(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Q4(P4(e)|0,f);i=d;return}function P4(a){a=a|0;var b=0,c=0;b=i;c=Y4(a)|0;i=b;return c|0}function Q4(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;R4(f,S4(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;T4(f,l2(d+16|0)|0)}if((d|0)==0){i=e;return}U4(c[b>>2]|0,d,1);i=e;return}function R4(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;X4(d,0,c);i=b;return}function S4(a){a=a|0;i=i;return a|0}function T4(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;W4(d,0,c);i=b;return}function U4(a,b,c){a=a|0;b=b|0;c=c|0;c=i;V4(0,b,0);i=c;return}function V4(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Vla(b);i=c;return}function W4(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Iba(c);i=b;return}function X4(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Iba(c);i=b;return}function Y4(a){a=a|0;i=i;return a+4|0}function Z4(a,b){a=a|0;b=b|0;var c=0;c=i;_4(a,b);i=c;return}function _4(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function $4(a){a=a|0;var b=0,c=0;b=i;c=s5(a+4|0)|0;i=b;return c|0}function a5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];k5(a,b,f);i=e;return}function b5(a,b){a=a|0;b=b|0;var c=0;a=i;c=j5(0,b,0)|0;i=a;return c|0}function c5(a,b){a=a|0;b=b|0;var c=0;c=i;i5(a,b);i=c;return}function d5(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}yba(b,c);i=a;return}function e5(a){a=a|0;var b=0,d=0;b=i;d=c[(I4(a)|0)>>2]|0;i=b;return d|0}function f5(a){a=a|0;var b=0,c=0;b=i;c=P4(a)|0;i=b;return c|0}function g5(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}wba(b);i=a;return}function h5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;Z4(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];z4(h,f);B4(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];z4(a,e);C4(h);i=d;return}function i5(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function j5(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Tla(b*40|0)|0;i=c;return a|0}function k5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(m5(g)|0)>>2]|0;g=n5(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];l5(b,a,f);i=e;return}function l5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];o5(a,b,f);i=e;return}function m5(a){a=a|0;i=i;return a|0}function n5(a){a=a|0;i=i;return a|0}function o5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(q5(g)|0)>>2]|0;g=r5(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];p5(b,a,f);i=e;return}function p5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(q5(f)|0)>>2];f=r5(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function q5(a){a=a|0;i=i;return a|0}function r5(a){a=a|0;i=i;return a|0}function s5(a){a=a|0;var b=0,c=0;b=i;c=t5(a)|0;i=b;return c|0}function t5(a){a=a|0;i=i;return a|0}function u5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=F4(v5(b)|0)|0;h=r5(f5(v5(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];l5(g,a,e);i=d;return}function v5(a){a=a|0;i=i;return c[a>>2]|0}function w5(a){a=a|0;var b=0;b=i;x5(a);i=b;return}function x5(a){a=a|0;var b=0;b=i;y5(a);i=b;return}function y5(a){a=a|0;var b=0;b=i;z5(a,_2(a)|0);i=b;return}function z5(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;ZY(d);if((b|0)==0){i=d;return}z5(a,c[b>>2]|0);z5(a,c[b+4>>2]|0);e=$4(a)|0;A5(e,B5(b+16|0)|0);U4(e,b,1);i=d;return}function A5(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;C5(d,0,c);i=b;return}function B5(a){a=a|0;i=i;return a|0}function C5(a,b,c){a=a|0;b=b|0;c=c|0;b=i;D5(c);i=b;return}function D5(a){a=a|0;var b=0;b=i;E5(a);i=b;return}function E5(a){a=a|0;var b=0;b=i;F5(a);i=b;return}function F5(a){a=a|0;var b=0;b=i;G5(a);i=b;return}function G5(a){a=a|0;var b=0;b=i;Iba(a+12|0);Iba(a);i=b;return}function H5(a){a=a|0;var b=0;b=i;I5(a+180|0);I5(a+168|0);I5(a+156|0);I5(a+144|0);I5(a+132|0);I5(a+120|0);I5(a+108|0);I5(a+96|0);I5(a+84|0);I5(a+72|0);I5(a+60|0);I5(a+48|0);I5(a+36|0);I5(a+24|0);X0(a+12|0);X0(a);i=b;return}function I5(a){a=a|0;var b=0;b=i;J5(a);i=b;return}function J5(a){a=a|0;var b=0;b=i;K5(a);i=b;return}function K5(a){a=a|0;var b=0;b=i;L5(a);i=b;return}function L5(a){a=a|0;var b=0;b=i;M5(a,n4(a)|0);i=b;return}function M5(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;ZY(d);if((b|0)==0){i=d;return}M5(a,c[b>>2]|0);M5(a,c[b+4>>2]|0);e=S3(a)|0;N5(e,O5(b+16|0)|0);M3(e,b,1);i=d;return}function N5(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;P5(d,0,c);i=b;return}function O5(a){a=a|0;i=i;return a|0}function P5(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Q5(c);i=b;return}function Q5(a){a=a|0;var b=0;b=i;R5(a);i=b;return}function R5(a){a=a|0;var b=0;b=i;S5(a);i=b;return}function S5(a){a=a|0;var b=0;b=i;T5(a);i=b;return}function T5(a){a=a|0;var b=0;b=i;X0(a+4|0);i=b;return}function U5(a){a=a|0;var b=0;b=i;V5(a);i=b;return}function V5(a){a=a|0;var b=0;b=i;W5(a);i=b;return}function W5(a){a=a|0;var b=0;b=i;X5(a,K1(a)|0);i=b;return}function X5(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;ZY(d);if((b|0)==0){i=d;return}X5(a,c[b>>2]|0);X5(a,c[b+4>>2]|0);e=s2(a)|0;Y5(e,x1(b+16|0)|0);m2(e,b,1);i=d;return}function Y5(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;Z5(d,0,c);i=b;return}function Z5(a,b,c){a=a|0;b=b|0;c=c|0;b=i;_5(c);i=b;return}function _5(a){a=a|0;var b=0;b=i;$5(a);i=b;return}function $5(a){a=a|0;var b=0;b=i;a6(a);i=b;return}function a6(a){a=a|0;var b=0;b=i;b6(a);i=b;return}function b6(a){a=a|0;var b=0;b=i;Iba(a);i=b;return}function c6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;d6(a);f6(g,b);g6(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];e6(a,f,e);i=d;return a|0}function d6(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;z5(a,_2(a)|0);c[(K4(a)|0)>>2]=0;d=T2(a)|0;c[(t4(a)|0)>>2]=d;ZY(b);c[d>>2]=0;i=b;return}function e6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;o6(h,a);if(!(p6(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];h6(j,g);o=r6(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];q6(l,a,f,o);s6(b)|0;}while(p6(b,d)|0);i=e;return}function f6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;m6(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];h6(a,e);i=d;return}function g6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;i6(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];h6(a,e);i=d;return}function h6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];l6(a,e);i=d;return}function i6(a,b){a=a|0;b=b|0;var c=0;c=i;j6(a,Z0(b)|0);i=c;return}function j6(a,b){a=a|0;b=b|0;var c=0;c=i;k6(a,b);i=c;return}function k6(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function l6(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function m6(a,b){a=a|0;b=b|0;var d=0;d=i;j6(a,c[(n6(b)|0)>>2]|0);i=d;return}function n6(a){a=a|0;i=i;return a|0}function o6(a,b){a=a|0;b=b|0;var c=0;c=i;g6(a,b);i=c;return}function p6(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=y7(a,b)|0;i=c;return d|0}function q6(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];A6(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];z6(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];Q2(a,g);D5(l);i=f;return}function r6(a){a=a|0;var b=0,c=0;b=i;c=w6(a)|0;i=b;return c|0}function s6(a){a=a|0;var b=0;b=i;t6(a)|0;i=b;return a|0}function t6(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=u6(c[d>>2]|0)|0;i=b;return a|0}function u6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;ZY(b);if((e|0)==0){e=a;while(1){a=N_(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=v6(c[d>>2]|0)|0;i=b;return g|0}return 0}function v6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;ZY(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;ZY(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function w6(a){a=a|0;var b=0,d=0;b=i;d=x6((c[a>>2]|0)+16|0)|0;i=b;return d|0}function x6(a){a=a|0;var b=0,c=0;b=i;c=y6(a)|0;i=b;return c|0}function y6(a){a=a|0;i=i;return a|0}function z6(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=E6(b,h,j,e)|0;h=c[p>>2]|0;ZY(l);if((h|0)!=0){q=h;S2(a,q);i=f;return}G6(o,b,e);H6(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];F6(m,g);I6(o);o=c[j>>2]|0;D4(b,o,p,J6(m)|0);p=K6(m)|0;I6(m);q=p;S2(a,q);i=f;return}function A6(a,b){a=a|0;b=b|0;var c=0;c=i;B6(a,b);i=c;return}function B6(a,b){a=a|0;b=b|0;var c=0;c=i;C6(a,b);i=c;return}function C6(a,b){a=a|0;b=b|0;var c=0;c=i;D6(a,b);i=c;return}function D6(a,b){a=a|0;b=b|0;var c=0;c=i;yba(a,b);yba(a+12|0,b+12|0);i=c;return}function E6(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;R2(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];m7(l,k);do{if(!(l7(b,l)|0)){k=a3(a)|0;x=o7(b)|0;if(n7(k,e,x)|0){break}w=n7(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];s7(r,h,1,0);R2(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];m7(t,g);do{if(!(l7(r,t)|0)){if(n7(k,e,o7(r)|0)|0){break}y=r7(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;ZY(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;p7(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];m7(o,j);do{if(!(l7(n,o)|0)){j=a3(a)|0;if(n7(j,o7(q7(n)|0)|0,e)|0){break}y=r7(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;ZY(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function F6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];j7(a,e);i=d;return}function G6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=$4(d)|0;d=b5(n,1)|0;X6(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];W6(j,d,h);Y6(0,B5((Z6(j)|0)+16|0)|0,e);a[(_6(j)|0)+4|0]=1;$6(m,j);H6(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];F6(b,g);I6(m);I6(j);i=f;return}function H6(a,b){a=a|0;b=b|0;var c=0;c=i;U6(a,b);i=c;return}function I6(a){a=a|0;var b=0;b=i;P6(a);i=b;return}function J6(a){a=a|0;var b=0,d=0;b=i;d=c[(N6(a)|0)>>2]|0;i=b;return d|0}function K6(a){a=a|0;var b=0,d=0;b=i;d=L6(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function L6(a){a=a|0;var b=0,c=0;b=i;c=M6(a)|0;i=b;return c|0}function M6(a){a=a|0;i=i;return a|0}function N6(a){a=a|0;var b=0,c=0;b=i;c=O6(a)|0;i=b;return c|0}function O6(a){a=a|0;i=i;return a|0}function P6(a){a=a|0;var b=0;b=i;Q6(a,0);i=b;return}function Q6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=L6(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}S6(R6(e)|0,f);i=d;return}function R6(a){a=a|0;var b=0,c=0;b=i;c=T6(a)|0;i=b;return c|0}function S6(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;A5(f,B5(d+16|0)|0)}if((d|0)==0){i=e;return}U4(c[b>>2]|0,d,1);i=e;return}function T6(a){a=a|0;i=i;return a+4|0}function U6(a,b){a=a|0;b=b|0;var c=0;c=i;V6(a,b);i=c;return}function V6(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function W6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];d7(a,b,f);i=e;return}function X6(a,b){a=a|0;b=b|0;var c=0;c=i;c7(a,b);i=c;return}function Y6(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}a7(b,c);i=a;return}function Z6(a){a=a|0;var b=0,d=0;b=i;d=c[(N6(a)|0)>>2]|0;i=b;return d|0}function _6(a){a=a|0;var b=0,c=0;b=i;c=R6(a)|0;i=b;return c|0}function $6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;U6(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];F6(h,f);H6(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];F6(a,e);I6(h);i=d;return}function a7(a,b){a=a|0;b=b|0;var c=0;c=i;b7(a,b);i=c;return}function b7(a,b){a=a|0;b=b|0;var c=0;c=i;C6(a,b);i=c;return}function c7(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function d7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(m5(g)|0)>>2]|0;g=f7(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];e7(b,a,f);i=e;return}function e7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];g7(a,b,f);i=e;return}function f7(a){a=a|0;i=i;return a|0}function g7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(q5(g)|0)>>2]|0;g=i7(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];h7(b,a,f);i=e;return}function h7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(q5(f)|0)>>2];f=i7(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function i7(a){a=a|0;i=i;return a|0}function j7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=K6(k7(b)|0)|0;h=i7(_6(k7(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];e7(g,a,e);i=d;return}function k7(a){a=a|0;i=i;return c[a>>2]|0}function l7(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function m7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];x7(a,e);i=d;return}function n7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=c1(0,b,c)|0;i=a;return d|0}function o7(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function p7(a,b){a=a|0;b=b|0;var d=0;d=i;S2(a,c[(t4(b)|0)>>2]|0);i=d;return}function q7(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=v7(c[d>>2]|0)|0;i=b;return a|0}function r7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=_2(a)|0;ZY(e);if((h|0)==0){j=T2(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=a3(a)|0;a=h;while(1){h=a+16|0;if(n7(j,d,h)|0){l=a;m=c[l>>2]|0;ZY(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(n7(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;ZY(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function s7(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;t7(b,d);c[a>>2]=c[b>>2];i=e;return}function t7(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;u7(b,c,e);i=d;return}function u7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{q7(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{t6(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function v7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;ZY(b);if((e|0)==0){e=a;while(1){a=N_(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=w7(c[d>>2]|0)|0;i=b;return g|0}return 0}function w7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;ZY(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;ZY(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function x7(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function y7(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(l7(a,b)|0)^1;i=c;return d|0}function z7(a){a=a|0;var b=0;b=i;i=i+128|0;P0(a,b);P0(a+12|0,b+8|0);A7(a+24|0,b+16|0);A7(a+36|0,b+24|0);A7(a+48|0,b+32|0);A7(a+60|0,b+40|0);A7(a+72|0,b+48|0);A7(a+84|0,b+56|0);A7(a+96|0,b+64|0);A7(a+108|0,b+72|0);A7(a+120|0,b+80|0);A7(a+132|0,b+88|0);A7(a+144|0,b+96|0);A7(a+156|0,b+104|0);A7(a+168|0,b+112|0);A7(a+180|0,b+120|0);i=b;return}function A7(a,b){a=a|0;b=b|0;b=i;B7(a,0);i=b;return}function B7(a,b){a=a|0;b=b|0;b=i;i=i+8|0;C7(a,b);i=b;return}function C7(a,b){a=a|0;b=b|0;b=i;D7(a,0);i=b;return}function D7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;E7(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;F7(f,0,e);e=A3(b)|0;c[(z3(b)|0)>>2]=e;i=d;return}function E7(a){a=a|0;var b=0;b=i;I7(a);i=b;return}function F7(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;G7(b,c,f);i=e;return}function G7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(B$(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;H7(d,b,f);i=e;return}function H7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(B$(e)|0)>>2];i=d;return}function I7(a){a=a|0;var b=0;b=i;J7(a);i=b;return}function J7(a){a=a|0;var b=0;b=i;E$(a);i=b;return}function K7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[173244>>2]|0;if((m|0)==0){n=0}else{o=Tla(12)|0;Cba(o,m);n=o}if((c[173160>>2]|0)!=0){c[29042]=1}if((n|0)==0){c[116180>>2]=1;c[116184>>2]=1;i=b;return}do{if((eca(n,163384,0)|0)==-1){yba(g,n);wba(h);o=c[28616]|0;m=(o|0)<28;while(1){p=eca(g,163392,0)|0;q=(p|0)!=-1;if(q){cca(j,g,0,p);Jba(h,j)|0;Iba(j);cca(k,g,p+1|0,-1);Jba(g,k)|0;Iba(k)}else{Jba(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){Cba(l,c[114880+(s<<2)>>2]|0);p=L7(h,l)|0;Iba(l);if(p){c[116176+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){TS(1,1,163400,f);if(m){v=o}else{w=116728;x=c[29182]|0;le[x&511](1);y=dca(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=163440;E=D;VS(0,E,a)}do{p=c[116048+(v<<2)>>2]|0;c[e>>2]=c[114880+(v<<2)>>2];c[e+4>>2]=p;TS(1,0,163424,e);v=v+1|0;}while((v|0)<28);w=116728;x=c[29182]|0;le[x&511](1);y=dca(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=163440;E=D;VS(0,E,a)}else if((t|0)==20){TS(1,1,163400,d);w=116728;x=c[29182]|0;le[x&511](1);y=dca(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=163440;E=D;VS(0,E,a)}else if((t|0)==23){Iba(h);Iba(g);break}}else{o=1;do{c[116176+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[116180>>2]=1;c[116184>>2]=1;if((c[116212>>2]|0)!=0){c[116272>>2]=1}if((c[116268>>2]|0)==1){c[116276>>2]=1}if((c[116248>>2]|0)!=0){c[116244>>2]=1}if((c[116256>>2]|0)!=0){c[116244>>2]=1}if((c[116208>>2]|0)!=0){c[116204>>2]=1}if((c[116252>>2]|0)!=0){c[116244>>2]=1}if((c[116200>>2]|0)!=0){c[116196>>2]=1}Iba(n);Vla(n);i=b;return}function L7(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=Gba(b)|0;if((e|0)!=(Gba(c)|0)){f=0;i=d;return f|0}g=Hba(b)|0;h=Hba(c)|0;if(zba(b)|0){f=(e1(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function M7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[173252>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Tla(12)|0;l=k;Cba(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(N7(l,c[148480+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=dca(l)|0;TS(1,1,163472,g);g=c[148564>>2]|0;c[f>>2]=c[148484>>2];c[f+4>>2]=g;TS(1,0,163424,f);f=c[148568>>2]|0;c[e>>2]=c[148488>>2];c[e+4>>2]=f;TS(1,0,163424,e);e=c[148572>>2]|0;c[d>>2]=c[148492>>2];c[d+4>>2]=e;TS(1,0,163424,d);le[c[29182]&511](1);VS(0,163528,a)}else if((n|0)==6){i=b;return j|0}return 0}function N7(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(gca(a,b)|0)==0;i=c;return d|0}function O7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[173236>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Tla(12)|0;l=k;Cba(l,h);if((k|0)==0){j=1;i=b;return j|0}Cba(f,163552);k=L7(l,f)|0;Iba(f);if(k){j=1;i=b;return j|0}Cba(g,163560);k=L7(l,g)|0;Iba(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=dca(l)|0;TS(1,1,163568,e);c[d>>2]=163552;c[d+4>>2]=163624;TS(1,0,163424,d);c[a>>2]=163560;c[a+4>>2]=163640;TS(1,0,163424,a);le[c[29182]&511](1);VS(0,163528,b)}return 0}function P7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;Rda(f,a);if(!(Uda(f)|0)){Sda(f);i=d;return a|0}j=m1(b)|0;b8(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((bZ(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=Cca(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];e8(h,e,b,m,k,l,n);if(!(c8(h)|0)){Sda(f);i=d;return a|0}wca(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);Sda(f);i=d;return a|0}function Q7(a){a=a|0;var b=0;b=i;Xda(a,Dca(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;Eda(a)|0;i=b;return a|0}function R7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;Cba(h,d);rca(k,163648,h);z0(j,k,163656);Iba(k);k=dca(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((lma(c[n+4>>2]|0,163664)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((lma(k,163672)|0)==0){Iba(j);Iba(h);i=f;return}d=Vka(g,k,1)|0;if((d|0)!=0){m=l;tma(m|0,0,2048)|0;gla(d,g,m,2048)|0;Vda(P7(P7(P7(P7(P7(185640,163680)|0,k)|0,163720)|0,m)|0,163736)|0,103)|0;Iba(j);Iba(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(hla(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==0){r=(hla(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==1){q=(hla(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){d=b+4|0;m=o;o=0;while(1){p=c[d>>2]|0;if((a[p+(o*60|0)+56|0]|0)==0){l=(hla(g,c[p+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(o*60|0)+56|0]=l;s=c[k>>2]|0}else{s=m}l=o+1|0;if((l|0)<(s|0)){m=s;o=l}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;m=b+4|0;k=(e|0)==0;d=b+20|0;l=0;do{p=c[s>>2]|0;do{if((a[p+(l*52|0)+48|0]|0)==0){n=a[p+(l*52|0)+8|0]|0;if(n<<24>>24==0){q=(hla(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(l*52|0)+48|0]|0)!=0){break}a[(c[m>>2]|0)+((c[q+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(hla(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(l*52|0)+48|0]|0)!=0|k){break}a[(c[d>>2]|0)+((c[n+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);l=l+1|0;}while((l|0)<(c[o>>2]|0))}o=b+120|0;l=c[o>>2]|0;if((l|0)>0){d=b+8|0;k=l;l=0;while(1){s=c[d>>2]|0;if((a[s+(l*48|0)+44|0]|0)==0){m=(hla(g,c[s+(l*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(l*48|0)+44|0]=m;t=c[o>>2]|0}else{t=k}m=l+1|0;if((m|0)<(t|0)){k=t;l=m}else{break}}}l=b+216|0;if((c[l>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;d=b+24|0;m=0;do{s=c[t>>2]|0;do{if((a[s+(m*52|0)+48|0]|0)==0){p=a[s+(m*52|0)+8|0]|0;if(p<<24>>24==0){n=(hla(g,c[s+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(m*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(p<<24>>24==1){p=(hla(g,c[s+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(m*52|0)+48|0]=p;p=c[t>>2]|0;if((a[p+(m*52|0)+48|0]|0)!=0|o){break}a[(c[d>>2]|0)+((c[p+(m*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[l>>2]|0))}l=b+124|0;m=c[l>>2]|0;if((m|0)>0){d=b+12|0;o=m;m=0;while(1){t=c[d>>2]|0;if((a[t+(m*52|0)+48|0]|0)==0){k=(hla(g,c[t+(m*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(m*52|0)+48|0]=k;u=c[l>>2]|0}else{u=o}k=m+1|0;if((k|0)<(u|0)){o=u;m=k}else{break}}}m=b+220|0;if((c[m>>2]|0)>0){u=b+44|0;o=b+12|0;l=(e|0)==0;e=b+28|0;b=0;do{d=c[u>>2]|0;do{if((a[d+(b*52|0)+48|0]|0)==0){k=a[d+(b*52|0)+8|0]|0;if(k<<24>>24==0){t=(hla(g,c[d+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=t;t=c[u>>2]|0;if((a[t+(b*52|0)+48|0]|0)!=0){break}a[(c[o>>2]|0)+((c[t+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(k<<24>>24==1){k=(hla(g,c[d+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=k;k=c[u>>2]|0;if((a[k+(b*52|0)+48|0]|0)!=0|l){break}a[(c[e>>2]|0)+((c[k+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[m>>2]|0))}Zka(g);Iba(j);Iba(h);i=f;return}function S7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[173100>>2]|0;H=c[173228>>2]|0;I=c[2]|0;if((c[116276>>2]|0)==0){if(!((c[173048>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Db(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;RS(23,0,163784,l);l=c[173172>>2]|0;do{if((l|0)==0){M=0}else{if((lma(l,163808)|0)==0){M=1;break}if((lma(l,163816)|0)==0){M=0;break}if((lma(l,163824)|0)==0){M=2;break}c[j>>2]=l;TS(1,0,163832,j);M=0}}while(0);if((qU(M)|0)!=0){c[g>>2]=l;TS(1,0,163904,g)}if((c[2]|0)!=0){a9(d+56|0);vU((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);rU(0);rU(6);sU(3);sU(4);sU(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+hma(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];RS(1,0,163992,f)}do{if((c[173156>>2]|0)!=0){f=Tla(12)|0;J=f;Cba(J,c[173284>>2]|0);if((f|0)==0){break}f=dca(J)|0;c[d+280>>2]=f;c[e>>2]=f;RS(23,0,164048,e)}}while(0);e=c[173280>>2]|0;wba(m);if((e|0)==0){Cba(p,c[d+88>>2]|0);Cba(q,164096);T7(o,p,q);z0(n,o,c[d+284>>2]|0);Jba(m,n)|0;Iba(n);Iba(o);Iba(q);Iba(p)}else{Kba(m,e)|0}Cba(r,164104);Cba(s,164104);Cba(t,164104);Cba(u,164104);Cba(v,164104);Cba(w,164104);e=c[173048>>2]|0;if((c[173068>>2]|0)!=0){Kba(r,c[173196>>2]|0)|0}if((c[173084>>2]|0)!=0){Kba(s,c[173212>>2]|0)|0}if((c[173064>>2]|0)!=0){Kba(t,c[173192>>2]|0)|0}if((c[173072>>2]|0)==0){O=0.0}else{Kba(u,c[173200>>2]|0)|0;O=+hma(dca(u)|0)}if((c[173076>>2]|0)==0){P=1}else{Kba(v,c[173204>>2]|0)|0;P=Lc(dca(v)|0)|0}if((c[173136>>2]|0)!=0){Kba(w,c[173264>>2]|0)|0}yba(x,m);yba(y,r);yba(z,s);yba(A,t);yba(B,w);p=U7(d,x,y,z,A,O,P,B,e)|0;Iba(B);Iba(A);Iba(z);Iba(y);Iba(x);if((p|0)!=0|g^1){Q=p}else{rU(5);p=r8(d)|0;uU(5);RS(1,0,164112,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;Iba(w);Iba(v);Iba(u);Iba(t);Iba(s);Iba(r);Iba(m);i=b;return R|0}Q=d+88|0;Cba(D,c[Q>>2]|0);z0(C,D,164144);Iba(D);Cba(F,c[Q>>2]|0);z0(E,F,164160);Iba(F);uU(0);F=c[173248>>2]|0;Q=dca(C)|0;D=dca(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;Q8(d,Q,D,(F|0)!=0?F:164176,I,p,dca(m)|0)|0;Iba(E);Iba(C);R=0;Iba(w);Iba(v);Iba(u);Iba(t);Iba(s);Iba(r);Iba(m);i=b;return R|0}function T7(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;xba(a,d);e=Gba(b)|0;f=Gba(c)|0;hca(a,Hba(b)|0,e,f+e|0);$ba(a,Hba(c)|0,f)|0;i=d;return}function U7(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((Gba(j)|0)==0){u=0}else{u=dca(j)|0}yba(r,b);b=(V7(a,r,k)|0)==0;Iba(r);if(!b){v=-1;i=l;return v|0}Cba(s,164104);b=a+280|0;r=N7(s,c[b>>2]|0)|0;Iba(s);do{if(r){w=3}else{s=1;k=0;do{Cba(t,c[164320+(s<<2)>>2]|0);j=N7(t,c[b>>2]|0)|0;Iba(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];TS(1,0,164400,q);TS(1,0,163400,p);s=1;do{j=c[164432+(s<<2)>>2]|0;c[o>>2]=c[164320+(s<<2)>>2];c[o+4>>2]=j;TS(1,0,163424,o);s=s+1|0;}while((s|0)<20);VS(c[a+536>>2]|0,163528,n)}}while(0);c[m>>2]=c[164320+(w<<2)>>2];RS(23,0,164512,m);m=dca(d)|0;d=dca(e)|0;e=qX(a,m,d,dca(f)|0,g,h,w,u)|0;me[c[157764>>2]&127](157736,a);v=e;i=l;return v|0}function V7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[39434]=Ed(dca(b)|0)|0;c[157740>>2]=g;c[157744>>2]=d;d=a+284|0;do{if((c[40844]|0)==0){g=c[d>>2]|0;if((lma(164184,g)|0)==0){h=0;break}if((lma(164192,g)|0)==0){c[157752>>2]=64;c[157756>>2]=65;c[157764>>2]=66;h=0;break}if((lma(164200,g)|0)==0){c[157752>>2]=67;c[157756>>2]=68;c[157760>>2]=69;c[157764>>2]=70;h=1;break}if((lma(164208,g)|0)==0){c[157752>>2]=71;c[157756>>2]=72;c[157760>>2]=73;c[157764>>2]=74;h=1;break}if((lma(164216,g)|0)==0){c[157752>>2]=75;c[157756>>2]=76;c[157764>>2]=77;h=0;break}g=P7(185640,164224)|0;Vda(P7(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);R7(a+8|0,c[a+288>>2]|0,h);me[c[157752>>2]&127](157736,a);a=c[39434]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;RS(23,0,164248,f);j=0;i=e;return j|0}function W7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;IS();do{if((i9(a,b)|0)==0){if((k9(a,b)|0)!=0){break}do{if((c[173104>>2]|0)!=0){w=c[173232>>2]|0;if((lma(w,164632)|0)==0){OS(1);break}if((lma(w,164640)|0)==0){OS(0);break}else{c[p>>2]=w;TS(1,0,164648,p);zd(0)|0;Hd(0)}}}while(0);if((c[173060>>2]|0)==0){K7(0,0);qW(d);if((d|0)==0){Vda(P7(185640,165016)|0,103)|0}c[d+300>>2]=M7(0,0)|0;c[d+292>>2]=O7(0,0)|0;w0(d+8|0,d+240|0);zW(d)|0;HW(d)|0;QW(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}Vda(P7(185640,165080)|0,103)|0;x=1;i=e;return x|0}}while(0);c[40844]=c[173128>>2];x=0;i=e;return x|0}Cba(u,c[173188>>2]|0);w=1;while(1){y=121288+(w<<2)|0;Cba(v,c[y>>2]|0);z=L7(u,v)|0;Iba(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=dca(u)|0;TS(1,0,164920,g);c[f>>2]=c[b>>2];TS(1,0,164960,f);zd(0)|0;Hd(0)}A=c[125312+(w<<2)>>2]|0;do{if((A|0)==1){z=c[125184+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;RS(1,1,164720,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[125184+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;RS(1,1,164760,n);break}else{c[m>>2]=z;TS(1,1,164600,m);break}}}while(0);if((w|0)==29){A=1;do{z=c[164432+(A<<2)>>2]|0;c[h>>2]=c[164320+(A<<2)>>2];c[h+4>>2]=z;RS(1,0,163424,h);A=A+1|0;}while((A|0)<20);D=116728;E=c[29182]|0;le[E&511](1);F=zd(0)|0;Hd(0)}else if((w|0)==11){A=1;do{z=c[164888+(A<<2)>>2]|0;c[j>>2]=c[164856+(A<<2)>>2];c[j+4>>2]=z;RS(1,0,163424,j);A=A+1|0;}while((A|0)<7);D=116728;E=c[29182]|0;le[E&511](1);F=zd(0)|0;Hd(0)}else if((w|0)==7){A=1;do{z=c[164840+(A<<2)>>2]|0;c[k>>2]=c[164824+(A<<2)>>2];c[k+4>>2]=z;RS(1,0,163424,k);A=A+1|0;}while((A|0)<4);D=116728;E=c[29182]|0;le[E&511](1);F=zd(0)|0;Hd(0)}else if((w|0)==19){A=c[28616]|0;if((A|0)<28){G=A}else{D=116728;E=c[29182]|0;le[E&511](1);F=zd(0)|0;Hd(0)}do{A=c[116048+(G<<2)>>2]|0;c[l>>2]=c[114880+(G<<2)>>2];c[l+4>>2]=A;RS(1,0,163424,l);G=G+1|0;}while((G|0)<28);D=116728;E=c[29182]|0;le[E&511](1);F=zd(0)|0;Hd(0)}else{D=116728;E=c[29182]|0;le[E&511](1);F=zd(0)|0;Hd(0)}}}while(0);c[t>>2]=c[b>>2];RS(1,1,164536,t);t=1;do{b=c[125312+(t<<2)>>2]|0;do{if((b|0)==1){F=c[123192+(t<<2)>>2]|0;c[s>>2]=c[121288+(t<<2)>>2];c[s+4>>2]=F;RS(1,0,164552,s)}else{F=c[121288+(t<<2)>>2]|0;if((b|0)==2){E=c[123192+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;RS(1,0,164568,r);break}else{c[q>>2]=F;TS(1,0,164600,q);break}}}while(0);t=t+1|0;}while((t|0)<31);le[c[29182]&511](1);zd(0)|0;Hd(0);return 0}function X7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[41278]|0;vb(166760)|0;c[l>>2]=c[m+88>>2];mc(165120,l|0)|0;vb(166776)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];mc(165144,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];mc(165184,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];mc(165216,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];mc(165248,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];mc(165280,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];mc(165312,b|0)|0;vb(166800)|0;i=a;return}function Y7(a,b){a=a|0;b=+b;i=i;return}



function jZ(a){a=a|0;var b=0,d=0;b=i;d=nZ(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function kZ(a){a=a|0;var b=0;b=i;lZ(a);i=b;return}function lZ(a){a=a|0;var b=0;b=i;mZ(a,0);i=b;return}function mZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=nZ(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}oe[c[(oZ(e)|0)>>2]&127](f)|0;i=d;return}function nZ(a){a=a|0;var b=0,c=0;b=i;c=qZ(a)|0;i=b;return c|0}function oZ(a){a=a|0;var b=0,c=0;b=i;c=pZ(a)|0;i=b;return c|0}function pZ(a){a=a|0;i=i;return a+4|0}function qZ(a){a=a|0;i=i;return a|0}function rZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(tZ(f)|0)>>2]|0;sZ(a,d,c[(uZ(g)|0)>>2]|0);i=e;return}function sZ(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;vZ(a,b,c);i=d;return}function tZ(a){a=a|0;i=i;return a|0}function uZ(a){a=a|0;i=i;return a|0}function vZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(xZ(f)|0)>>2]|0;wZ(a,d,c[(yZ(g)|0)>>2]|0);i=e;return}function wZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(xZ(f)|0)>>2];c[a+4>>2]=c[(yZ(g)|0)>>2];i=e;return}function xZ(a){a=a|0;i=i;return a|0}function yZ(a){a=a|0;i=i;return a|0}function zZ(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function AZ(a){a=a|0;var b=0;b=i;BZ(a+300|0);BZ(a+288|0);BZ(a+276|0);BZ(a+264|0);BZ(a+252|0);BZ(a+240|0);CZ(a);i=b;return}function BZ(a){a=a|0;var b=0;b=i;m_(a);i=b;return}function CZ(a){a=a|0;var b=0;b=i;DZ(a,158320);Aca(a+104|0);i=b;return}function DZ(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];HZ(a+4|0);i=d;return}function EZ(a){a=a|0;var b=0;b=i;CZ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function FZ(a){a=a|0;var b=0;b=i;CZ(a);Vla(a);i=b;return}function GZ(a){a=a|0;var b=0;b=i;FZ(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function HZ(a){a=a|0;var b=0;b=i;IZ(a);i=b;return}function IZ(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=158448;hZ(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}Wla(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}Wla(e)}}while(0);Jca(b);i=d;return}function JZ(a){a=a|0;var b=0;b=i;HZ(a);Vla(a);i=b;return}function KZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;oe[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=k_(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=l_(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;Tca(h,0,0,0);Yca(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}Wla(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=Ula(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=Ula(h)|0;a[b+97|0]=1;i=e;return}function LZ(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;Tca(e,0,0,0);Yca(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}Wla(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}Wla(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=Ula(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(h_(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=Ula(o)|0;a[k]=1;i=f;return e|0}return 0}function MZ(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Kc(4)|0;sla(n);Zd(n|0,205840,128)}n=d_(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((oe[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){lY(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=Jma(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if(($c(p|0,q|0,f|0)|0)==0){p=Ab(c[m>>2]|0)|0;lY(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];g_(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{lY(a,-1,-1);i=g;return}}}while(0);lY(a,-1,-1);i=g;return}function NZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((oe[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=zZ(d)|0;if(($c(j|0,k|0,0)|0)==0){f_(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{lY(a,-1,-1);i=e;return}}}while(0);lY(a,-1,-1);i=e;return}function OZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Kc(4)|0;sla(m);Zd(m|0,205840,128)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=d_(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=Rca(s)|0;u=(fa(t-(Qca(s)|0)|0,p)|0)+r|0;v=0;break}p=Qca(s)|0;if((p|0)==(Rca(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=e_(t,g,x,o,p-(Pca(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=Rca(w)|0;u=q-(Qca(w)|0)|0;v=0}}while(0);if(($c(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;Tca(b,0,0,0);c[m>>2]=0}else{q=b;y=Vca(q)|0;do{if((y|0)!=(Uca(q)|0)){if((De[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=c_(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((xc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((zd(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function PZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=ZZ(b)|0;o=b;if((Qca(o)|0)==0){p=e+1|0;Tca(o,e,p,p)}if(n){q=0}else{n=Rca(o)|0;c[f>>2]=(n-(Pca(o)|0)|0)/2|0;c[g>>2]=4;q=c[(_Z(f,g)|0)>>2]|0}g=Qca(o)|0;do{if((g|0)==(Rca(o)|0)){sma(Pca(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=Rca(o)|0;n=Pca(o)|0;p=ub(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=Pca(o)|0;Tca(o,n,n+q|0,n+(p+q)|0);r=XZ(a[Qca(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;sma(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(_Z(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=ub(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Kc(4)|0;sla(t);Zd(t|0,205840,128)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=Pca(o)|0;if(($Z(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;Tca(o,f,f,c[s>>2]|0);r=XZ(a[Qca(o)|0]|0)|0;break}s=c[k>>2]|0;f=Pca(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}Tca(o,f,p,s);r=XZ(a[Qca(o)|0]|0)|0}else{r=XZ(a[g]|0)|0}}while(0);if((Pca(o)|0)!=(e|0)){m=r;i=d;return m|0}Tca(o,0,0,0);m=r;i=d;return m|0}function QZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=Pca(g)|0;j=Qca(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(TZ(d,-1)|0){Sca(g,-1);f=WZ(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=UZ(d)|0;do{if(h){if(YZ(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);Sca(g,-1);a[Qca(g)|0]=b;f=d;i=e;return f|0}function RZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}SZ(b);l=b;m=Uca(l)|0;n=Wca(l)|0;if(!(TZ(d,-1)|0)){if((Vca(l)|0)==0){Yca(l,f,f+1|0)}f=UZ(d)|0;a[Vca(l)|0]=f;Xca(l,1)}f=Vca(l)|0;o=Uca(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Kc(4)|0;u=t;sla(u);v=205840;w=128;Zd(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=Uca(l)|0;A=Vca(l)|0;B=VZ(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=Uca(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((xc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;Yca(l,B,Vca(l)|0);B=Wca(l)|0;Xca(l,B-(Uca(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Kc(4)|0;u=t;sla(u);v=205840;w=128;Zd(t|0,v|0,w|0)}else if((D|0)==14){q=(Vca(l)|0)-C|0;if((xc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((xc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);Yca(l,m,n)}k=WZ(d)|0;i=e;return k|0}function SZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;Tca(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;Yca(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;Yca(f,h,h+(g+ -1)|0);break}}else{Yca(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function TZ(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function UZ(a){a=a|0;i=i;return a&255|0}function VZ(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Me[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function WZ(a){a=a|0;var b=0,c=0;b=i;c=TZ(a,-1)|0;i=b;return(c?0:a)|0}function XZ(a){a=a|0;i=i;return a&255|0}function YZ(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function ZZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;Yca(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;Tca(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;Tca(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function _Z(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=a_(b,c,e)|0;i=d;return g|0}function $Z(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Me[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function a_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=b_(0,b,a)|0;i=c;return(d?b:a)|0}function b_(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function c_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Ee[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function d_(a){a=a|0;var b=0,d=0;b=i;d=oe[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function e_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=Ee[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function f_(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function g_(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function h_(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=i_(b,c,e)|0;i=d;return g|0}function i_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=j_(0,a,b)|0;i=c;return(d?b:a)|0}function j_(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function k_(a){a=a|0;var b=0,c=0;b=i;c=sia(a,190344)|0;i=b;return c|0}function l_(a){a=a|0;var b=0,d=0;b=i;d=oe[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function m_(a){a=a|0;var b=0;b=i;n_(a);i=b;return}function n_(a){a=a|0;var b=0;b=i;o_(a);i=b;return}function o_(a){a=a|0;var b=0;b=i;p_(a,SY(a)|0);i=b;return}function p_(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;ZY(d);if((b|0)==0){i=d;return}p_(a,c[b>>2]|0);p_(a,c[b+4>>2]|0);r_(q_(a)|0,b,1);i=d;return}function q_(a){a=a|0;var b=0,c=0;b=i;c=t_(a+4|0)|0;i=b;return c|0}function r_(a,b,c){a=a|0;b=b|0;c=c|0;c=i;s_(0,b,0);i=c;return}function s_(a,b,c){a=a|0;b=b|0;c=c|0;c=i;Vla(b);i=c;return}function t_(a){a=a|0;var b=0,c=0;b=i;c=u_(a)|0;i=b;return c|0}function u_(a){a=a|0;i=i;return a|0}function v_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=w_(a,f,b)|0;l=c[k>>2]|0;ZY(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}y_(j,a,b);z_(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];x_(g,e);A_(j);j=c[f>>2]|0;B_(a,j,k,C_(g)|0);k=D_(g)|0;A_(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function w_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=SY(h)|0;ZY(e);if((a|0)==0){j=JY(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(WY(0,d,a)|0){m=l;j=c[m>>2]|0;ZY(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(WY(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;ZY(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function x_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];p$(a,e);i=d;return}function y_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=q_(d)|0;d=__(n,1)|0;$_(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];Z_(j,d,h);a$(0,V_((b$(j)|0)+16|0)|0,e);e=c$(j)|0;a[e+4|0]=1;d$(0,U_((b$(j)|0)+20|0)|0);a[e+5|0]=1;e$(m,j);z_(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];x_(b,g);A_(m);A_(j);i=f;return}function z_(a,b){a=a|0;b=b|0;var c=0;c=i;X_(a,b);i=c;return}function A_(a){a=a|0;var b=0;b=i;Q_(a);i=b;return}function B_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;ZY(f);c[e>>2]=0;ZY(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=I_(a)|0;b=c[c[e>>2]>>2]|0;ZY(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(JY(a)|0)>>2]|0;J_(e,c[d>>2]|0);d=K_(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function C_(a){a=a|0;var b=0,d=0;b=i;d=c[(G_(a)|0)>>2]|0;i=b;return d|0}function D_(a){a=a|0;var b=0,d=0;b=i;d=E_(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function E_(a){a=a|0;var b=0,c=0;b=i;c=F_(a)|0;i=b;return c|0}function F_(a){a=a|0;i=i;return a|0}function G_(a){a=a|0;var b=0,c=0;b=i;c=H_(a)|0;i=b;return c|0}function H_(a){a=a|0;i=i;return a|0}function I_(a){a=a|0;i=i;return a|0}function J_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=N_(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;ZY(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;ZY(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(N_(j)|0){p=j}else{o=c[k>>2]|0;O_(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;P_(p);i=e;return}else if((l|0)==14){if(N_(j)|0){p=c[k>>2]|0;P_(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;O_(q);i=e;return}else if((l|0)==17){i=e;return}}function K_(a){a=a|0;var b=0,c=0;b=i;c=L_(a+8|0)|0;i=b;return c|0}function L_(a){a=a|0;var b=0,c=0;b=i;c=M_(a)|0;i=b;return c|0}function M_(a){a=a|0;i=i;return a|0}function N_(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function O_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;ZY(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=N_(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function P_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;ZY(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=N_(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Q_(a){a=a|0;var b=0;b=i;R_(a,0);i=b;return}function R_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=E_(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}T_(S_(e)|0,f);i=d;return}function S_(a){a=a|0;var b=0,c=0;b=i;c=W_(a)|0;i=b;return c|0}function T_(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}r_(c[a>>2]|0,b,1);i=d;return}function U_(a){a=a|0;i=i;return a|0}function V_(a){a=a|0;i=i;return a|0}function W_(a){a=a|0;i=i;return a+4|0}function X_(a,b){a=a|0;b=b|0;var c=0;c=i;Y_(a,b);i=c;return}function Y_(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Z_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];h$(a,b,f);i=e;return}function __(a,b){a=a|0;b=b|0;var c=0;a=i;c=g$(0,b,0)|0;i=a;return c|0}function $_(a,b){a=a|0;b=b|0;var c=0;c=i;f$(a,b);i=c;return}function a$(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function b$(a){a=a|0;var b=0,d=0;b=i;d=c[(G_(a)|0)>>2]|0;i=b;return d|0}function c$(a){a=a|0;var b=0,c=0;b=i;c=S_(a)|0;i=b;return c|0}function d$(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function e$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;X_(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];x_(h,f);z_(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];x_(a,e);A_(h);i=d;return}function f$(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function g$(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Tla(b*24|0)|0;i=c;return a|0}function h$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(j$(g)|0)>>2]|0;g=k$(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];i$(b,a,f);i=e;return}function i$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];l$(a,b,f);i=e;return}function j$(a){a=a|0;i=i;return a|0}function k$(a){a=a|0;i=i;return a|0}function l$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(n$(g)|0)>>2]|0;g=o$(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];m$(b,a,f);i=e;return}function m$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(n$(f)|0)>>2];f=o$(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function n$(a){a=a|0;i=i;return a|0}function o$(a){a=a|0;i=i;return a|0}function p$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=D_(q$(b)|0)|0;h=o$(c$(q$(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];i$(g,a,e);i=d;return}function q$(a){a=a|0;i=i;return c[a>>2]|0}function r$(a){a=a|0;var b=0;b=i;i=i+48|0;s$(a);lY(a+184|0,0,0);lY(a+200|0,0,0);t$(a+240|0,b);t$(a+252|0,b+8|0);t$(a+264|0,b+16|0);t$(a+276|0,b+24|0);t$(a+288|0,b+32|0);t$(a+300|0,b+40|0);i=b;return}function s$(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;Fca(d);e=a;c[e>>2]=158292;f=d;c[f>>2]=158312;d=a+4|0;Mda(a,158324|0,d);c[e>>2]=158292;c[f>>2]=158312;G$(d);i=b;return}function t$(a,b){a=a|0;b=b|0;b=i;u$(a,0);i=b;return}function u$(a,b){a=a|0;b=b|0;b=i;i=i+8|0;v$(a,b);i=b;return}function v$(a,b){a=a|0;b=b|0;b=i;w$(a,0);i=b;return}function w$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;x$(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;y$(f,0,e);e=JY(b)|0;c[(I_(b)|0)>>2]=e;i=d;return}function x$(a){a=a|0;var b=0;b=i;C$(a);i=b;return}function y$(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;z$(b,c,f);i=e;return}function z$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(B$(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;A$(d,b,f);i=e;return}function A$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(B$(e)|0)>>2];i=d;return}function B$(a){a=a|0;i=i;return a|0}function C$(a){a=a|0;var b=0;b=i;D$(a);i=b;return}function D$(a){a=a|0;var b=0;b=i;E$(a);i=b;return}function E$(a){a=a|0;var b=0;b=i;F$(a);i=b;return}function F$(a){a=a|0;c[a>>2]=0;i=i;return}function G$(a){a=a|0;var b=0;b=i;H$(a);i=b;return}function H$(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;Oca(j);c[d>>2]=158448;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;ZY(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;Kca(g,j);l=I$(g)|0;qia(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=re[r&63](d,0,4096)|0;i=e;return}Kca(h,j);c[k>>2]=k_(h)|0;qia(h);a[f]=(l_(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=re[r&63](d,0,4096)|0;i=e;return}function I$(a){a=a|0;var b=0,c=0;b=i;c=ria(a,190344)|0;i=b;return c|0}function J$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;rU(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){K$(a,b,c[f>>2]|0,h);uU(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=Qla(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;VS(k,158720,e)}K$(a,b,l,h);uU(3);i=d;return}function K$(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;uU(0);k=+mU(0);rU(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function L$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=Nla(24)|0;rU(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;US(c[m>>2]|0,l>>>31^1,158776,f);f=b+8|0;b=c[a+8>>2]|0;l=M$(b,f)|0;c[g+20>>2]=l;l=M$(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=Nla(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;VS(k,158856,e)}else{c[h>>2]=0;c[a+12>>2]=g;uU(3);i=d;return}}function M$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function N$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;rU(3);u=b;v=oc(c[u>>2]|0,158920)|0;if((v|0)==0){O$(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=ae(c[(Tc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;VS(w,158928,q)}xc(158984,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];Bd(v|0,159032,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];Bd(v|0,159056,o|0)|0;xc(159080,40,1,v|0)|0;xc(159128,11,1,v|0)|0;xc(159144,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];P$(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Yd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{xc(159160,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;P$(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Yd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];Bd(v|0,159184,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;P$(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Yd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];Bd(v|0,159184,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;P$(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Yd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];Bd(v|0,159184,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;P$(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Yd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];Bd(v|0,159184,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;P$(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Yd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];Bd(v|0,159184,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;P$(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Yd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];Bd(v|0,159184,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;P$(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Yd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}O$(t);if((dd(v|0)|0)==0){Ola(c[r>>2]|0);c[r>>2]=0;uU(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];VS(e,159200,f)}}function O$(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}Ola(a);c[d>>2]=0;i=b;return}function P$(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];Bd(a|0,159248,f|0)|0;i=e;return}function Q$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=Tla(192)|0;tma(m|0,0,192)|0;R$(m);c[a+12>>2]=m;n=m;o=a;mY(n,c[o>>2]|0,36);if(tca(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];VS(a,159288,g)}else{g=m;Yda(g,159264,14)|0;Zda(h,g);a=zZ(h)|0;h=m+184|0;c[h>>2]=a;Yda(g,159280,4)|0;S$(n,b+8|0);Zda(j,g);b=zZ(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;lY(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];_da(g,f)|0;T$(n,-4-m+b|0);b=c[j>>2]|0;lY(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];_da(g,e)|0;uU(3);i=d;return}}function R$(a){a=a|0;var b=0;b=i;k0(a);i=b;return}function S$(a,b){a=a|0;b=b|0;var c=0;c=i;V$(a,3);W$(a,159464);V$(a,0);W$(a,159472);V$(a,2);f0(a,b);g0(a,b);W$(a,159480);V$(a,0);i=c;return}function T$(a,b){a=a|0;b=b|0;var d=0;d=i;c[39864]=Md(b|0)|0;Yda(a,159456,4)|0;i=d;return}function U$(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;Zda(l,q);r=zZ(l)|0;T$(b,0);Zda(m,q);l=zZ(m)|0;V$(b,1);W$(b,159352);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;X$(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);Y$(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{Y$(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{Z$(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{_$(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{W$(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}Zda(n,q);u=zZ(n)|0;n=qma(0,r|0,32)|0;lY(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];_da(q,k)|0;T$(b,u-l|0);lY(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];_da(q,j)|0;i=g;return}function V$(b,d){b=b|0;d=d|0;var e=0;e=i;a[159440]=-33;c[39862]=Md(d|0)|0;d=b;Yda(d,159440,1)|0;Yda(d,159448,4)|0;i=e;return}function W$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Md(pma(d|0)|0)|0;a[159432]=-37;g=b;Yda(g,159432,1)|0;Yda(g,f,4)|0;Yda(g,d,pma(d|0)|0)|0;i=e;return}function X$(b,d){b=b|0;d=d|0;var e=0;e=i;a[159416]=-35;c[39856]=Md(d|0)|0;d=b;Yda(d,159416,1)|0;Yda(d,159424,4)|0;i=e;return}function Y$(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[159400]=-53;e0(c);e=b;Yda(e,159400,1)|0;Yda(e,159408,8)|0;i=d;return}function Z$(b,d){b=b|0;d=d|0;var e=0;e=i;a[159384]=-46;c[39848]=Md(d|0)|0;d=b;Yda(d,159384,1)|0;Yda(d,159392,4)|0;i=e;return}function _$(b,c){b=b|0;c=c|0;var d=0;d=i;a[159376]=c?-61:-62;Yda(b,159376,1)|0;i=d;return}function $$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;U$(e,+h[f>>3],a,f);U$(e,+h[b+248>>3],a,f);i=d;return}function a0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;Zda(j,p);o=zZ(j)|0;T$(b,0);Zda(k,p);j=zZ(k)|0;V$(b,1);W$(b,159360);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;X$(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;Y$(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{Y$(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{Z$(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{_$(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{W$(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}Zda(l,p);s=zZ(l)|0;l=qma(0,o|0,32)|0;lY(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];_da(p,g)|0;T$(b,s-j|0);lY(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];_da(p,f)|0;i=e;return}function b0(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;fY(a);rU(3);if((a|0)!=0){c0(a);Vla(a)}c[d>>2]=0;uU(3);i=b;return}function c0(a){a=a|0;var b=0;b=i;d0(a);i=b;return}function d0(a){a=a|0;var b=0;b=i;CZ(a);i=b;return}function e0(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Md(1)|0)==1){f=e;g=c[f+4>>2]|0;j=159408;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[159408+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function f0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;W$(a,159352);V$(a,4);W$(a,159488);V$(a,0);W$(a,159496);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;X$(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);W$(a,159504);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{W$(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{W$(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{W$(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{W$(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=159592;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];h0(a,b,e);W$(a,159528);V$(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);i0(a,159504,159536);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;i0(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;i0(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;i0(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;i0(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function g0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;W$(a,159360);V$(a,4);W$(a,159488);V$(a,0);W$(a,159496);o=g+1+j+l+n|0;X$(a,o);W$(a,159504);if((c[f>>2]|0)>0){n=b;l=0;do{W$(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{W$(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{W$(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{W$(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=159512;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];h0(a,b,e);W$(a,159528);V$(a,o);i0(a,159504,159536);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;i0(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;i0(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;i0(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;i0(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function h0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;W$(b,159560);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}V$(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?159504:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}j0(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?159504:w;if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}j0(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{s=k<<24>>24==2?159504:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=s}j0(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?159504:C;if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}j0(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function i0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;W$(a,b);V$(a,1);W$(a,159544);W$(a,c);i=d;return}function j0(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;W$(a,b);V$(a,d?2:1);W$(a,159568);W$(a,c);if(!d){i=e;return}W$(a,159576);W$(a,159584);i=e;return}function k0(a){a=a|0;var b=0;b=i;s$(a);i=b;return}function l0(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;Cba(e,159608);yba(d,n0(a,e)|0);m0(d,b+4|0);Iba(d);Iba(e);Cba(g,159616);yba(f,n0(a,g)|0);o0(f,b);Iba(f);Iba(g);Cba(j,159632);yba(h,n0(a,j)|0);m0(h,b+8|0);Iba(h);Iba(j);Cba(l,159648);yba(k,n0(a,l)|0);m0(k,b+12|0);Iba(k);Iba(l);Cba(n,159664);yba(m,n0(a,n)|0);p0(m,b+16|0,0);Iba(m);Iba(n);Cba(p,159680);yba(o,n0(a,p)|0);p0(o,b+20|0,0);Iba(o);Iba(p);Cba(r,159696);yba(q,n0(a,r)|0);p0(q,b+24|0,0);Iba(q);Iba(r);Cba(t,159704);yba(s,n0(a,t)|0);p0(s,b+28|0,0);Iba(s);Iba(t);Cba(v,159720);yba(u,n0(a,v)|0);p0(u,b+32|0,0);Iba(u);Iba(v);i=c;return}function m0(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){TS(22,0,162928,d);i=d;return}else{c[b>>2]=Ed(dca(a)|0)|0;i=d;return}}function n0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=y4(a,f,b)|0;l=c[k>>2]|0;ZY(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}A4(j,a,b);B4(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];z4(g,e);C4(j);j=c[f>>2]|0;D4(a,j,k,E4(g)|0);k=F4(g)|0;C4(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function o0(a,b){a=a|0;b=b|0;var d=0;d=i;if((gca(a,159896)|0)==0){c[b>>2]=1;i=d;return}if((gca(a,159904)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Lc(dca(a)|0)|0;i=d;return}}function p0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((gca(a,159872)|0)==0){c[b>>2]=d}if((gca(a,159896)|0)==0){c[b>>2]=1;i=e;return}if((gca(a,159904)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Lc(dca(a)|0)|0;i=e;return}}function q0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;Cba(j,159736);yba(g,n0(b,j)|0);y=d+48|0;r0(g,y);Iba(g);Iba(j);Cba(m,159752);yba(l,n0(b,m)|0);j=d+56|0;s0(l,j,0.0);Iba(l);Iba(m);Cba(o,159760);yba(n,n0(b,o)|0);m=d+32|0;r0(n,m);Iba(n);Iba(o);Cba(q,159768);yba(p,n0(b,q)|0);o=d+33|0;r0(p,o);Iba(p);Iba(q);Cba(s,159784);yba(r,n0(b,s)|0);q=d+40|0;s0(r,q,1.0);Iba(r);Iba(s);Cba(u,159792);yba(t,n0(b,u)|0);s=d+16|0;s0(t,s,-1.7976931348623157e+308);Iba(t);Iba(u);Cba(w,159800);yba(v,n0(b,w)|0);u=d+24|0;s0(v,u,1.7976931348623157e+308);Iba(v);Iba(w);Cba(x,159608);w=dca(n0(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?159896:159904;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?159872:159880;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?159872:159888;c[f+20>>2]=j;c[f+24>>2]=m?159872:159880;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?159872:159888;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];RS(4,0,159808,f);Iba(x);i=e;return}function r0(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(gca(b,159896)|0)==0|0;i=d;return}function s0(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((gca(a,159872)|0)==0){h[b>>3]=c;i=d;return}if((gca(a,159896)|0)==0){h[b>>3]=1.0;i=d;return}if((gca(a,159904)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+hma(dca(a)|0);i=d;return}}function t0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;Cba(h,159736);yba(g,n0(b,h)|0);s=d+13|0;r0(g,s);Iba(g);Iba(h);Cba(k,159752);yba(j,n0(b,k)|0);h=d+16|0;p0(j,h,0);Iba(j);Iba(k);Cba(m,159760);yba(l,n0(b,m)|0);k=d+12|0;r0(l,k);Iba(l);Iba(m);Cba(o,159792);yba(n,n0(b,o)|0);m=d+4|0;p0(n,m,-2147483648);Iba(n);Iba(o);Cba(q,159800);yba(p,n0(b,q)|0);o=d+8|0;p0(p,o,2147483647);Iba(p);Iba(q);Cba(r,159608);q=dca(n0(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?159896:159904;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?159872:159880;c[f+8>>2]=s;c[f+12>>2]=b?159872:159888;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;RS(4,0,159912,f);Iba(r);i=e;return}function u0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;Cba(h,159736);yba(g,n0(b,h)|0);o=d+5|0;r0(g,o);Iba(g);Iba(h);Cba(k,159752);yba(j,n0(b,k)|0);h=d+6|0;r0(j,h);Iba(j);Iba(k);Cba(m,159760);yba(l,n0(b,m)|0);k=d+4|0;r0(l,k);Iba(l);Iba(m);Cba(n,159608);m=dca(n0(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?159896:159904;h=(a[k]|0)!=0?159896:159904;c[f>>2]=m;c[f+4>>2]=b?159872:159880;c[f+8>>2]=o;c[f+12>>2]=b?159872:159888;c[f+16>>2]=h;RS(4,0,159968,f);Iba(n);i=e;return}function v0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;Cba(h,159736);yba(g,n0(b,h)|0);m=d+4|0;r0(g,m);Iba(g);Iba(h);Cba(k,159752);yba(j,n0(b,k)|0);h=d+8|0;m0(j,h);Iba(j);Iba(k);Cba(l,159608);k=dca(n0(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?159872:159880;c[f+8>>2]=m;c[f+12>>2]=b?159872:159888;RS(4,0,160008,f);Iba(l);i=e;return}function w0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;sb=i;i=i+16|0;tb=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;ic=i;i=i+16|0;jc=i;i=i+16|0;kc=i;i=i+8|0;lc=i;i=i+16|0;mc=i;i=i+16|0;nc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;x0(qa);wba(ra);y0(sa,ta);y0(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[173056>>2]|0)==0){Cba(za,c[b+80>>2]|0);z0(ya,za,160032);Jba(ra,ya)|0;Iba(ya);Iba(za)}else{Kba(ra,c[173184>>2]|0)|0}ta=oc(dca(ra)|0,160048)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=dca(ra)|0;VS(0,160056,pa)}else{Wc=0}}while(0);pa=JN(0)|0;if((pa|0)==0){dd(Wc|0)|0;VS(0,160160,oa)}UN(pa,Vc);VN(pa,8,63);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;tma(oa|0,0,1024)|0;while(1){za=ub(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((WN(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){dd(Wc|0)|0;oa=dca(ra)|0;ya=cO($N(pa)|0)|0;za=aO(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;TS(1,0,160240,na);QN(pa);VS(0,160328,ma)}else if((Xc|0)==14){dd(Wc|0)|0;break}}else{if((WN(pa,Vc,pma(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=cO($N(pa)|0)|0;ta=aO(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;Bd(za|0,160352,la|0)|0;za=c[va>>2]|0;ta=cO($N(pa)|0)|0;oa=aO(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;TS(1,0,160368,ka);QN(pa);VS(0,160328,ja)}}while(0);ja=qa;Cba(Ca,160456);D0(Ba,ja,Ca);E0(Da,ja);ka=C0(Ba,Da)|0;Iba(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=dca(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;TS(1,0,160464,ia)}else{Cba(Ea,160456);Ba=lma(Da,dca(n0(ja,Ea)|0)|0)|0;Iba(Ea);if((Ba|0)==0){break}QN(pa);Cba(Fa,160456);Ba=dca(n0(ja,Fa)|0)|0;va=dca(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;TS(1,0,160512,ha);Iba(Fa);VS(0,160328,ga)}}while(0);F0(qa,b,c[173268>>2]|0,c[173272>>2]|0);RS(23,1,160608,fa);fa=qa+12|0;Cba(Ha,160648);yba(Ga,n0(fa,Ha)|0);ga=d;s0(Ga,ga,0.0);Iba(Ga);Iba(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];RS(23,0,160664,ea);Cba(Ja,160680);yba(Ia,n0(fa,Ja)|0);ea=d+8|0;s0(Ia,ea,1.0);Iba(Ia);Iba(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];RS(23,0,160696,da);Cba(La,160712);yba(Ka,n0(fa,La)|0);da=d+24|0;s0(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);Iba(Ka);Iba(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];RS(23,0,160728,ca);Cba(Na,160744);yba(Ma,n0(fa,Na)|0);ca=d+32|0;s0(Ma,ca,1.0e-5);Iba(Ma);Iba(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];RS(23,0,160760,ba);Cba(Pa,160776);yba(Oa,n0(fa,Pa)|0);ba=d+40|0;m0(Oa,ba);Iba(Oa);Iba(Pa);c[aa>>2]=c[ba>>2];RS(23,0,160784,aa);Cba(Ra,160808);yba(Qa,n0(fa,Ra)|0);aa=d+44|0;m0(Qa,aa);Iba(Qa);Iba(Ra);c[$>>2]=c[aa>>2];RS(23,0,160824,$);Cba(Ta,160848);yba(Sa,n0(fa,Ta)|0);fa=d+48|0;m0(Sa,fa);Iba(Sa);Iba(Ta);c[_>>2]=c[fa>>2];RS(23,0,160864,_);Cba(Va,160888);yba(Ua,n0(ja,Va)|0);_=d+268|0;m0(Ua,_);Iba(Ua);Iba(Va);c[Z>>2]=c[_>>2];RS(23,0,160912,Z);if((c[116268>>2]|0)!=0){le[c[29182]&511](23)}Cba(eb,160936);yba(db,n0(ja,eb)|0);p0(db,Wa,0);Iba(db);Iba(eb);Cba(gb,160968);yba(fb,n0(ja,gb)|0);p0(fb,Xa,0);Iba(fb);Iba(gb);Cba(ib,161e3);yba(hb,n0(ja,ib)|0);p0(hb,Ya,0);Iba(hb);Iba(ib);Cba(kb,161024);yba(jb,n0(ja,kb)|0);p0(jb,_a,0);Iba(jb);Iba(kb);Cba(mb,161056);yba(lb,n0(ja,mb)|0);p0(lb,Za,0);Iba(lb);Iba(mb);Cba(ob,161096);yba(nb,n0(ja,ob)|0);p0(nb,ab,0);Iba(nb);Iba(ob);Cba(qb,161128);yba(pb,n0(ja,qb)|0);p0(pb,$a,0);Iba(pb);Iba(qb);Cba(sb,161168);yba(rb,n0(ja,sb)|0);p0(rb,cb,0);Iba(rb);Iba(sb);Cba(vb,161200);yba(tb,n0(ja,vb)|0);p0(tb,bb,0);Iba(tb);Iba(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){tb=b+108|0;if((c[Xa>>2]|0)!=((c[tb>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}sb=b+132|0;if((c[_a>>2]|0)!=(c[sb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=161744;RS(4,1,161720,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=G0(lb,wb)|0;l0(ib,jb+(kb*112|0)|0);q0(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(xb,161760);jb=(gca(n0(ib,xb)|0,159896)|0)==0;Iba(xb);if(!jb){break}c[N>>2]=c[hb>>2];RS(4,0,161776,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);Cba(yb,c[hb>>2]|0);c[(H0(sa,yb)|0)>>2]=kb;Iba(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[M>>2]=161808;RS(4,1,161720,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=G0(lb,zb)|0;l0(fb,gb+(jb*112|0)|0);q0(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Ab,161760);gb=(gca(n0(fb,Ab)|0,159896)|0)==0;Iba(Ab);if(!gb){break}c[L>>2]=c[eb>>2];RS(4,0,161776,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);Cba(Bb,c[eb>>2]|0);c[(H0(sa,Bb)|0)>>2]=jb;Iba(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[K>>2]=161832;RS(4,1,161720,K);ib=c[Wa>>2]<<1;if(((c[tb>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=G0(mb,Cb)|0;l0(gb,hb+(fb*112|0)|0);q0(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Db,161760);hb=(gca(n0(gb,Db)|0,159896)|0)==0;Iba(Db);if(!hb){break}c[J>>2]=c[db>>2];RS(4,0,161776,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);Cba(Eb,c[db>>2]|0);c[(H0(sa,Eb)|0)>>2]=fb;Iba(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[tb>>2]|0)-lb|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[I>>2]=161848;RS(4,1,161720,I);if((c[rb>>2]|0)>0){lb=b+4|0;tb=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=G0(tb,Fb)|0;l0(mb,kb+(ib*60|0)|0);t0(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Gb,161760);kb=(gca(n0(mb,Gb)|0,159896)|0)==0;Iba(Gb);if(!kb){break}c[H>>2]=c[gb>>2];RS(4,0,161776,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);Cba(Hb,c[gb>>2]|0);c[(H0(sa,Hb)|0)>>2]=ib;Iba(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[G>>2]=161872;RS(4,1,161720,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{tb=c[rb>>2]|0;c[Ib>>2]=lb;mb=G0(ib,Ib)|0;l0(mb,tb+(lb*48|0)|0);u0(mb,tb+(lb*48|0)+36|0);fb=tb+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Jb,161760);tb=(gca(n0(mb,Jb)|0,159896)|0)==0;Iba(Jb);if(!tb){break}c[F>>2]=c[fb>>2];RS(4,0,161776,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);Cba(Kb,c[fb>>2]|0);c[(H0(sa,Kb)|0)>>2]=lb;Iba(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[E>>2]=161896;RS(4,1,161720,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=G0(lb,Lb)|0;l0(mb,ib+(rb*52|0)|0);v0(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Mb,161760);ib=(gca(n0(mb,Mb)|0,159896)|0)==0;Iba(Mb);if(!ib){break}c[D>>2]=c[gb>>2];RS(4,0,161776,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);Cba(Nb,c[gb>>2]|0);c[(H0(sa,Nb)|0)>>2]=rb;Iba(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[C>>2]=161920;RS(4,1,161720,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=G0(rb,Ob)|0;l0(mb,lb+(pb*112|0)|0);q0(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Pb,161760);lb=(gca(n0(mb,Pb)|0,159896)|0)==0;Iba(Pb);if(!lb){break}c[B>>2]=c[fb>>2];RS(4,0,161776,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);Cba(Qb,c[fb>>2]|0);c[(H0(ua,Qb)|0)>>2]=pb;Iba(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[A>>2]=161936;RS(4,1,161720,A);if((c[sb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=G0(pb,Rb)|0;l0(mb,rb+(nb*60|0)|0);t0(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Sb,161760);rb=(gca(n0(mb,Sb)|0,159896)|0)==0;Iba(Sb);if(!rb){break}c[z>>2]=c[gb>>2];RS(4,0,161776,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);Cba(Tb,c[gb>>2]|0);c[(H0(ua,Tb)|0)>>2]=nb;Iba(Tb);nb=nb+1|0;}while((nb|0)<(c[sb>>2]|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[y>>2]=161960;RS(4,1,161720,y);if((c[qb>>2]|0)>0){sb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[sb>>2]|0;c[Ub>>2]=ja;mb=G0(nb,Ub)|0;l0(mb,pb+(ja*48|0)|0);u0(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Vb,161760);pb=(gca(n0(mb,Vb)|0,159896)|0)==0;Iba(Vb);if(!pb){break}c[x>>2]=c[fb>>2];RS(4,0,161776,x);a[(c[sb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);Cba(Wb,c[fb>>2]|0);c[(H0(ua,Wb)|0)>>2]=ja;Iba(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}c[w>>2]=161984;RS(4,1,161720,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;sb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=sb;mb=G0(ja,Xb)|0;l0(mb,nb+(sb*52|0)|0);v0(mb,nb+(sb*52|0)+36|0);gb=nb+(sb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}else{if((c[173052>>2]|0)!=0){break}Cba(Yb,161760);nb=(gca(n0(mb,Yb)|0,159896)|0)==0;Iba(Yb);if(!nb){break}c[v>>2]=c[gb>>2];RS(4,0,161776,v);a[(c[qb>>2]|0)+(sb*52|0)+48|0]=1}}while(0);Cba(Zb,c[gb>>2]|0);c[(H0(ua,Zb)|0)>>2]=sb;Iba(Zb);sb=sb+1|0;}while((sb|0)<(c[ob>>2]|0))}if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}RS(4,1,162008,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){sb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=G0(sb,_b)|0;l0(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);wba($b);c[bc>>2]=ja;mb=G0(sb,bc)|0;Cba(cc,162048);yba(ac,n0(mb,cc)|0);I0(ac,$b);Iba(ac);Iba(cc);mb=(gca($b,162056)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;RS(4,0,162072,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=G0(sb,ec)|0;Cba(fc,162112);yba(dc,n0(nb,fc)|0);I0(dc,$b);Iba(dc);Iba(fc);J0(wa,sa,$b);J0(xa,ua,$b);L0(gc,sa);do{if(K0(wa,gc)|0){nb=c[(M0(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{L0(hc,ua);if(K0(xa,hc)|0){fb=c[(M0(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((gca($b,162128)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);Iba($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}rca(jc,162136,$b);z0(ic,jc,162160);Iba(jc);c[s>>2]=dca(ic)|0;VS(0,162176,s)}}while(0);if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}RS(4,1,162184,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;sb=0;while(1){c[kc>>2]=sb;gb=G0(ja,kc)|0;l0(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);wba(lc);c[nc>>2]=sb;gb=G0(ja,nc)|0;Cba(pc,162048);yba(mc,n0(gb,pc)|0);I0(mc,lc);Iba(mc);Iba(pc);gb=(gca(lc,162056)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[p>>2]=c[nb+(sb*52|0)+16>>2];c[p+4>>2]=fb;RS(4,0,162072,p);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[rc>>2]=sb;fb=G0(ja,rc)|0;Cba(sc,162112);yba(qc,n0(fb,sc)|0);I0(qc,lc);Iba(qc);Iba(sc);J0(wa,sa,lc);J0(xa,ua,lc);L0(tc,sa);if(K0(wa,tc)|0){fb=c[(M0(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{L0(uc,ua);if(!(K0(xa,uc)|0)){break}nb=c[(M0(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}Iba(lc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break c}}rca(wc,162224,lc);z0(vc,wc,162160);Iba(wc);c[o>>2]=dca(vc)|0;VS(0,162176,o)}}while(0);if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}RS(4,1,162248,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){sb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=G0(sb,xc)|0;l0(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);wba(yc);c[Ac>>2]=ja;fb=G0(sb,Ac)|0;Cba(Bc,162048);yba(zc,n0(fb,Bc)|0);I0(zc,yc);Iba(zc);Iba(Bc);fb=(gca(yc,162056)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;RS(4,0,162072,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=G0(sb,Dc)|0;Cba(Ec,162112);yba(Cc,n0(gb,Ec)|0);I0(Cc,yc);Iba(Cc);Iba(Ec);J0(wa,sa,yc);J0(xa,ua,yc);L0(Fc,sa);if(K0(wa,Fc)|0){gb=c[(M0(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{L0(Gc,ua);if(!(K0(xa,Gc)|0)){break}nb=c[(M0(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}Iba(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}rca(Ic,162288,yc);z0(Hc,Ic,162160);Iba(Ic);c[l>>2]=dca(Hc)|0;VS(0,162176,l)}}while(0);if((c[116192>>2]|0)!=0){le[c[29182]&511](4)}RS(4,1,162312,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;sb=0;while(1){c[Jc>>2]=sb;gb=G0(ja,Jc)|0;l0(gb,(c[qb>>2]|0)+(sb*52|0)+12|0);wba(Kc);c[Mc>>2]=sb;gb=G0(ja,Mc)|0;Cba(Nc,162048);yba(Lc,n0(gb,Nc)|0);I0(Lc,Kc);Iba(Lc);Iba(Nc);gb=(gca(Kc,162056)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(sb*52|0)>>2]=fb;c[g>>2]=c[nb+(sb*52|0)+16>>2];c[g+4>>2]=fb;RS(4,0,162072,g);fb=c[qb>>2]|0;if((a[c[fb+(sb*52|0)+16>>2]|0]|0)==36){a[fb+(sb*52|0)+48|0]=1}c[Pc>>2]=sb;fb=G0(ja,Pc)|0;Cba(Qc,162112);yba(Oc,n0(fb,Qc)|0);I0(Oc,Kc);Iba(Oc);Iba(Qc);J0(wa,sa,Kc);J0(xa,ua,Kc);L0(Rc,sa);if(K0(wa,Rc)|0){fb=c[(M0(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(sb*52|0)+4>>2]=fb;a[nb+(sb*52|0)+8|0]=0}else{L0(Sc,ua);if(!(K0(xa,Sc)|0)){break}nb=c[(M0(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(sb*52|0)+4>>2]=nb;a[fb+(sb*52|0)+8|0]=1}Iba(Kc);sb=sb+1|0;if((sb|0)>=(c[ob>>2]|0)){break e}}rca(Uc,162352,Kc);z0(Tc,Uc,162160);Iba(Uc);c[f>>2]=dca(Tc)|0;VS(0,162176,f)}}while(0);if((c[116192>>2]|0)==0){QN(pa);N0(ua);N0(sa);Iba(ra);O0(qa);i=e;return}le[c[29182]&511](4);QN(pa);N0(ua);N0(sa);Iba(ra);O0(qa);i=e;return}}while(0);if((c[116264>>2]|c[29042]|0)==0){QN(pa);Yc=zd(0)|0;Hd(-1)}TS(22,1,161240,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;TS(22,0,161288,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;TS(22,0,161336,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;TS(22,0,161384,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;TS(22,0,161432,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;TS(22,0,161480,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;TS(22,0,161528,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;TS(22,0,161576,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;TS(22,0,161624,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;TS(22,0,161672,P);le[c[29182]&511](22);QN(pa);Yc=zd(0)|0;Hd(-1)}function x0(a){a=a|0;var b=0;b=i;z7(a);i=b;return}function y0(a,b){a=a|0;b=b|0;b=i;e3(a,0);i=b;return}function z0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;xba(a,d);e=Gba(b)|0;f=m1(c)|0;hca(a,Hba(b)|0,e,f+e|0);$ba(a,c,f)|0;i=d;return}function A0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((lma(b,162984)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{Cba(g,v);w=n0(u,g)|0;Kba(w,c[d+((t|1)<<2)>>2]|0)|0;Iba(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((lma(b,163008)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{Cba(h,g);u=n0(t,h)|0;Kba(u,c[d+((v|1)<<2)>>2]|0)|0;Iba(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((lma(b,163032)|0)!=0){do{if((lma(b,163288)|0)!=0){if((lma(b,163296)|0)==0){break}if((lma(b,163304)|0)==0){break}if((lma(b,163312)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=G0(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){Cba(r,c[t>>2]|0);w=n0(g,r)|0;Kba(w,c[d+((u|1)<<2)>>2]|0)|0;Iba(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=G0(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}Cba(s,163320);Kba(n0(x,s)|0,b)|0;Iba(s);i=e;return}P0(j,k);wba(l);wba(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{Cba(n,g);t=n0(j,n)|0;Kba(t,c[d+((x|1)<<2)>>2]|0)|0;Iba(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}Cba(o,163048);Jba(l,n0(j,o)|0)|0;Iba(o);Cba(p,163064);Jba(m,n0(j,p)|0)|0;Iba(p);c[k>>2]=Lc(dca(l)|0)|0;if((gca(m,163080)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((gca(m,163088)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((gca(m,163096)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((gca(m,163104)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((gca(m,163112)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((gca(m,163120)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((gca(m,163128)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((gca(m,163136)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((gca(m,163144)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((gca(m,163152)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((gca(m,163160)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((gca(m,163168)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((gca(m,163176)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((gca(m,163184)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=dca(m)|0;Cba(q,159608);N=dca(n0(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;US(0,(O|0)!=0|0,163192,f);Iba(q);c6(G0(c[b>>2]|0,s)|0,j)|0;Iba(m);Iba(l);X0(j);i=e;return}function B0(a,b){a=a|0;b=b|0;i=i;return}function C0(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=P2(a,b)|0;i=c;return d|0}function D0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Y2(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];Q2(a,f);i=e;return}function E0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;R2(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];Q2(a,e);i=d;return}



function DL(a,b){a=a|0;b=+b;var d=0,e=0.0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0,q=0.0,r=0.0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0.0;d=i;i=i+248|0;e=b;b=1.7976931348623157e+308;f=a;do{if((f|0)!=0){if((c[f+8>>2]|0)==0){g=91;break}a=c[f+8>>2]|0;j=c[f+12>>2]|0;k=c[f+16>>2]|0;do{if((c[f+60>>2]|0)>>>0>0){if(e>+h[f+72>>3]){h[f+72>>3]=e;break}l=+h[f+64>>3];m=l;i=d;return+m}}while(0);a:do{if((c[f+28>>2]|0)==3){if((c[f+60>>2]|0)!=0){break}n=+h[a>>3];o=+h[a+((fa(j-1|0,k)|0)<<3)>>3];c[f+80>>2]=1;p=0;while(1){if(!(p>>>0<(j-1|0)>>>0)){break}q=+h[a+((fa(p,k)|0)<<3)>>3];r=+h[a+((fa(p+1|0,k)|0)<<3)>>3];do{if(r>n){if((AL(r,o)|0)!=0){break}s=(c[f+24>>2]|0)==3;t=(AL(q,r)|0)!=0;if(s){if(t){break}n=r;s=f+80|0;c[s>>2]=(c[s>>2]|0)+1;break}else{if(!t){break}n=r;t=f+80|0;c[t>>2]=(c[t>>2]|0)+1;break}}}while(0);p=p+1|0}c[f+96>>2]=Pla(c[f+80>>2]|0,8)|0;if((c[f+96>>2]|0)==0){IU(90072);l=b;m=l;i=d;return+m}n=+h[a>>3];t=0;p=0;if((c[f+24>>2]|0)==3){while(1){if(!(p>>>0<(j-1|0)>>>0)){break a}if(!(t>>>0<(c[f+80>>2]|0)>>>0)){break a}o=+h[a+((fa(p,k)|0)<<3)>>3];r=+h[a+((fa(p+1|0,k)|0)<<3)>>3];do{if(r>n){if((AL(o,r)|0)!=0){c[(c[f+96>>2]|0)+(t<<3)>>2]=p+1;break}else{n=r;c[(c[f+96>>2]|0)+(t<<3)>>2]=p;c[(c[f+96>>2]|0)+(t<<3)+4>>2]=p+1;t=t+1|0;break}}else{c[(c[f+96>>2]|0)+(t<<3)+4>>2]=p+1}}while(0);p=p+1|0}}while(1){if(!(p>>>0<(j-1|0)>>>0)){break a}if(!(t>>>0<(c[f+80>>2]|0)>>>0)){break a}r=+h[a+((fa(p,k)|0)<<3)>>3];o=+h[a+((fa(p+1|0,k)|0)<<3)>>3];do{if(o>n){if((AL(r,o)|0)==0){c[(c[f+96>>2]|0)+(t<<3)+4>>2]=p+1;break}n=o;c[(c[f+96>>2]|0)+(t<<3)+4>>2]=p;t=t+1|0;if(!(t>>>0<(c[f+80>>2]|0)>>>0)){break}c[(c[f+96>>2]|0)+(t<<3)>>2]=p+1}else{c[(c[f+96>>2]|0)+(t<<3)>>2]=p+1}}while(0);p=p+1|0}}}while(0);e=e- +h[f+48>>3];b:do{if(e<0.0){b=0.0}else{if(!(j>>>0>1)){break}n=+h[a>>3];o=+h[a+((fa(j-1|0,k)|0)<<3)>>3];r=o-n;if((c[f+28>>2]|0)!=3){if(e<n){b=n;break}if(!(e<o)){break}if((c[f+24>>2]|0)==2){b=o;break}u=yL(a,j,k,c[f+20>>2]|0,e+1.0e-10*r)|0;b=o;v=u+1|0;while(1){if(!(v>>>0<(j-1|0)>>>0)){break b}w=+h[a+((fa(v,k)|0)<<3)>>3];if(w>e){q=+h[a+((fa(v+1|0,k)|0)<<3)>>3];x=w;if((c[f+24>>2]|0)==3){g=83;break}if((AL(x,q)|0)!=0){g=85;break}}v=v+1|0}if((g|0)==83){b=x;break}else if((g|0)==85){b=w;break}}if((c[f+84>>2]|0)!=0){c[f+84>>2]=1+(((c[f+84>>2]|0)>>>0)%((c[f+80>>2]|0)>>>0)|0);if((c[f+84>>2]|0)==(c[f+80>>2]|0)){b=o+ +h[f+88>>3];p=f+88|0;h[p>>3]=+h[p>>3]+r;break}else{v=c[(c[f+96>>2]|0)+((c[f+84>>2]|0)-1<<3)+4>>2]|0;q=+h[a+((fa(v,k)|0)<<3)>>3];b=q+ +h[f+88>>3];break}}q=n;h[f+88>>3]=+T(+((e-n)/r))*r;e=e- +h[f+88>>3];do{if(e<n){e=e+r}else{if(!(e>o)){break}e=e-r}}while(0);u=yL(a,j,k,c[f+20>>2]|0,e+1.0e-10*r)|0;b=o;v=u+1|0;while(1){if(!(v>>>0<(j-1|0)>>>0)){break}y=+h[a+((fa(v,k)|0)<<3)>>3];n=+h[a+((fa(v+1|0,k)|0)<<3)>>3];if(y>e){z=y;if((c[f+24>>2]|0)==3){g=52;break}if((AL(z,n)|0)!=0){g=54;break}}v=v+1|0}if((g|0)==52){b=z}else if((g|0)==54){b=y}c[f+84>>2]=1;if(u>>>0<(j-1|0)>>>0){A=u}else{A=j-1|0}p=A;v=0;while(1){if(!(v>>>0<p>>>0)){break}n=+h[a+((fa(v,k)|0)<<3)>>3];B=+h[a+((fa(v+1|0,k)|0)<<3)>>3];do{if(B>q){if((AL(B,o)|0)!=0){break}t=(c[f+24>>2]|0)==3;s=(AL(n,B)|0)!=0;if(t){if(s){break}q=B;t=f+84|0;c[t>>2]=(c[t>>2]|0)+1;break}else{if(!s){break}q=B;s=f+84|0;c[s>>2]=(c[s>>2]|0)+1;break}}}while(0);v=v+1|0}b=b+ +h[f+88>>3];if((c[f+84>>2]|0)!=(c[f+80>>2]|0)){break}p=f+88|0;h[p>>3]=+h[p>>3]+r}}while(0);if(b<1.7976931348623157e+308){b=b+ +h[f+48>>3]}if(!(b>+h[f+64>>3])){break}h[f+64>>3]=b;k=f+60|0;c[k>>2]=(c[k>>2]|0)+1}else{g=91}}while(0);if((g|0)==91){IU(90216)}l=b;m=l;i=d;return+m}function EL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,h=0.0;e=i;i=i+40|0;f=b;b=d;d=a;do{if((d|0)!=0){if((c[d+32>>2]|0)!=1){break}if((f|0)==0){if((c[d+8>>2]|0)!=0){break}}if((c[d+8>>2]|0)!=0){Ola(c[d+8>>2]|0)}c[d+8>>2]=FL(c[d+4>>2]|0,c[d>>2]|0,d+12|0,d+16|0,b,f)|0;if((c[d+8>>2]|0)==0){g=0.0;h=g;i=e;return+h}do{if((c[d+24>>2]|0)==2){if((c[d+12>>2]|0)!=2){break}c[d+24>>2]=1}}while(0);if((sL(d)|0)!=0){if((c[d+24>>2]|0)!=2){break}wL(c[d+56>>2]|0);c[d+56>>2]=tL(c[d+8>>2]|0,c[d+12>>2]|0,c[d+16>>2]|0,c[d+36>>2]|0,c[d+40>>2]|0)|0;break}else{g=0.0;h=g;i=e;return+h}}}while(0);g=1.0;h=g;i=e;return+h}function FL(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;j=a;a=b;b=d;d=e;e=f;f=0;if((j|0)==0){k=f;i=g;return k|0}if((a|0)==0){k=f;i=g;return k|0}if((b|0)==0){k=f;i=g;return k|0}if((d|0)==0){k=f;i=g;return k|0}l=0;m=Va(a|0,46)|0;do{if((m|0)!=0){if(0!=(mma(m,90312,4)|0)){if(0!=(mma(m,90320,4)|0)){break}}l=1}}while(0);if((e|0)==1){c[h>>2]=j;c[h+4>>2]=a;GU(90328,h)}h=j;j=a;a=b;b=d;if((l|0)!=0){f=GL(h,j,a,b)|0;k=f;i=g;return k|0}else{f=HL(h,j,a,b)|0;k=f;i=g;return k|0}return 0}function GL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;f=i;i=i+16|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=a;a=b;b=d;d=e;e=0;do{if((n|0)!=0){if((a|0)==0){break}if((b|0)==0){break}if((d|0)==0){break}o=0;p=IM(a,0)|0;if((p|0)==0){c[m>>2]=a;KU(90368,m);q=0;r=q;i=f;return r|0}s=TM(p,n)|0;if((s|0)==0){LM(p)|0;c[l>>2]=n;c[l+4>>2]=a;KU(90856,l);q=0;r=q;i=f;return r|0}t=s;if((c[s+4>>2]|0)!=2){MM(t);LM(p)|0;c[k>>2]=n;KU(91080,k);q=0;r=q;i=f;return r|0}u=s;if((c[t+16>>2]|0)!=6){MM(u);LM(p)|0;c[j>>2]=n;KU(91128,j);q=0;r=q;i=f;return r|0}t=s;if((c[u+20>>2]|0)!=0){MM(t);LM(p)|0;c[h>>2]=n;KU(91192,h);q=0;r=q;i=f;return r|0}e=Nla((fa(c[c[t+32>>2]>>2]|0,c[(c[s+32>>2]|0)+4>>2]|0)|0)<<3)|0;t=s;if((e|0)==0){MM(t);LM(p)|0;IU(90072);q=0;r=q;i=f;return r|0}u=c[c[t+32>>2]>>2]|0;t=c[(c[s+32>>2]|0)+4>>2]|0;v=0;while(1){if((o|0)!=0){break}if(!(v>>>0<u>>>0)){break}o=OM(p,s,e+((fa(v,t)|0)<<3)|0,v,u,t)|0;v=v+1|0}MM(s);LM(p)|0;if((o|0)==0){c[b>>2]=u;c[d>>2]=t;break}Ola(e);c[b>>2]=0;c[d>>2]=0;c[g>>2]=n;c[g+4>>2]=u;c[g+8>>2]=t;c[g+12>>2]=a;KU(91232,g);q=0;r=q;i=f;return r|0}}while(0);q=e;r=q;i=f;return r|0}function HL(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;g=i;i=i+24|0;j=g;k=i;i=i+16|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b;b=d;d=e;e=f;f=0;do{if((u|0)!=0){if((b|0)==0){break}if((d|0)==0){break}if((e|0)==0){break}c[s>>2]=64;v=0;w=0;x=0;y=1;z=oc(b|0,90360)|0;if((z|0)==0){c[q>>2]=b;KU(90368,q);A=0;B=A;i=g;return B|0}c[r>>2]=Nla(64)|0;C=z;if((c[r>>2]|0)==0){dd(C|0)|0;IU(90072);A=0;B=A;i=g;return B|0}D=IL(r,s,C)|0;C=D;E=c[r>>2]|0;if((D|0)!=0){Ola(E);dd(z|0)|0;if((C|0)<0){c[p>>2]=b;KU(90432,p)}A=0;B=A;i=g;return B|0}if(0!=(mma(E,90496,2)|0)){E=pma(c[r>>2]|0)|0;do{if((E|0)==0){Ola(c[r>>2]|0);dd(z|0)|0;c[o>>2]=b;KU(90504,o)}else{D=a[c[r>>2]|0]|0;if((E|0)==1){Ola(c[r>>2]|0);dd(z|0)|0;c[n>>2]=b;c[n+4>>2]=D<<24>>24;KU(90600,n);break}else{F=a[(c[r>>2]|0)+1|0]|0;Ola(c[r>>2]|0);dd(z|0)|0;c[m>>2]=b;c[m+4>>2]=D<<24>>24;c[m+8>>2]=F<<24>>24;KU(90712,m);break}}}while(0);A=0;B=A;i=g;return B|0}E=c[(lc()|0)>>2]|0;while(1){if((IL(r,s,z)|0)!=0){break}y=y+1|0;G=_b(c[r>>2]|0,90824)|0;if((G|0)==0){continue}if(0!=(lma(G,90832)|0)){if(0!=(lma(G,90840)|0)){continue}}G=_b(0,90824)|0;if((G|0)==0){continue}if(0!=(lma(G,u)|0)){continue}v=1;G=_b(0,90824)|0;if((G|0)==0){continue}w=Xb(G|0,t|0,10)|0;if((a[c[t>>2]|0]|0)!=0){continue}G=_b(0,90824)|0;if((G|0)==0){continue}x=Xb(G|0,t|0,10)|0;if((a[c[t>>2]|0]|0)==0){H=31;break}}a:do{if((H|0)==31){F=0;D=0;f=Nla((fa(w,x)|0)<<3)|0;if((f|0)==0){c[d>>2]=0;c[e>>2]=0;Ola(c[r>>2]|0);dd(z|0)|0;IU(90072);A=f;B=A;i=g;return B|0}while(1){if((C|0)!=0){break a}if(!(F>>>0<w>>>0)){break a}I=0;y=y+1|0;J=IL(r,s,z)|0;C=J;if((J|0)!=0){break a}while(1){if((I|0)>=((c[s>>2]|0)-1|0)){break}if((a[(c[r>>2]|0)+I|0]|0)!=32){if((a[(c[r>>2]|0)+I|0]|0)!=9){break}}I=I+1|0}if((a[(c[r>>2]|0)+I|0]|0)==0){continue}if((a[(c[r>>2]|0)+I|0]|0)==35){continue}G=_b((c[r>>2]|0)+I|0,90848)|0;b:while(1){if(!(F>>>0<w>>>0)){break}if(!(D>>>0<x>>>0)){break}if((G|0)==0){break}if((a[G]|0)==35){break}J=G;do{if((a[E]|0)==46){h[f+((fa(F,x)|0)+D<<3)>>3]=+ima(J,t)}else{K=G;if(0==(fc(J|0,46)|0)){h[f+((fa(F,x)|0)+D<<3)>>3]=+ima(K,t);break}L=Nla((pma(K|0)|0)+1|0)|0;if((L|0)==0){H=55;break b}vma(L|0,G|0)|0;K=fc(L|0,46)|0;a[K]=a[E]|0;h[f+((fa(F,x)|0)+D<<3)>>3]=+ima(L,t);if((a[c[t>>2]|0]|0)!=0){C=1}Ola(L)}}while(0);J=D+1|0;D=J;if((J|0)==(x|0)){F=F+1|0;D=0}if((C|0)!=0){break}G=_b(0,90848)|0}if((H|0)==55){H=0;c[d>>2]=0;c[e>>2]=0;Ola(c[r>>2]|0);dd(z|0)|0;C=1;IU(90072)}if((G|0)==0){continue}if((a[G]|0)!=35){break}}C=1}}while(0);Ola(c[r>>2]|0);dd(z|0)|0;if((v|0)==0){c[l>>2]=u;c[l+4>>2]=b;KU(90856,l);A=f;B=A;i=g;return B|0}if((C|0)==0){c[d>>2]=w;c[e>>2]=x;break}Ola(f);f=0;c[d>>2]=0;c[e>>2]=0;if((C|0)==-1){c[k>>2]=u;c[k+4>>2]=w;c[k+8>>2]=x;c[k+12>>2]=b;KU(90904,k);break}else{c[j>>2]=y;c[j+4>>2]=u;c[j+8>>2]=w;c[j+12>>2]=x;c[j+16>>2]=b;KU(90992,j);break}}}while(0);A=f;B=A;i=g;return B|0}function IL(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+64|0;g=b;b=d;d=e;if((ce(c[g>>2]|0,c[b>>2]|0,d|0)|0)==0){h=-1;j=h;i=f;return j|0}e=fc(c[g>>2]|0,10)|0;k=e;if((e|0)!=0){a[k]=0;h=0;j=h;i=f;return j|0}while(1){e=fc(c[g>>2]|0,10)|0;k=e;if((e|0)!=0){l=6;break}e=c[b>>2]|0;m=b;c[m>>2]=c[m>>2]<<1;m=Qla(c[g>>2]|0,c[b>>2]|0)|0;if((m|0)==0){l=8;break}c[g>>2]=m;if((ce((c[g>>2]|0)+(e-1)|0,e+1|0,d|0)|0)==0){l=10;break}}if((l|0)==6){a[k]=0;h=0;j=h;i=f;return j|0}else if((l|0)==8){IU(90072);h=1;j=h;i=f;return j|0}else if((l|0)==10){h=0;j=h;i=f;return j|0}return 0}function JL(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+32|0;d=b;b=0;a:do{if((d|0)!=0){if((lma(d,91392)|0)==0){break}e=pma(d|0)|0;f=0;while(1){if(!(f>>>0<e>>>0)){break a}if((a[d+f|0]|0)!=32){break}f=f+1|0}b=1}}while(0);i=c;return b|0}function KL(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d+8|0;f=b;b=f;g=c[b+4>>2]|0;h=e;c[h>>2]=c[b>>2];c[h+4>>2]=g;g=e;a[g]=a[g]^a[e+7|0];g=e+7|0;a[g]=a[g]^a[e];g=e;a[g]=a[g]^a[e+7|0];g=e+1|0;a[g]=a[g]^a[e+6|0];g=e+6|0;a[g]=a[g]^a[e+1|0];g=e+1|0;a[g]=a[g]^a[e+6|0];g=e+2|0;a[g]=a[g]^a[e+5|0];g=e+5|0;a[g]=a[g]^a[e+2|0];g=e+2|0;a[g]=a[g]^a[e+5|0];g=e+3|0;a[g]=a[g]^a[e+4|0];g=e+4|0;a[g]=a[g]^a[e+3|0];g=e+3|0;a[g]=a[g]^a[e+4|0];g=e;e=c[g+4>>2]|0;h=f;c[h>>2]=c[g>>2];c[h+4>>2]=e;e=f;J=c[e+4>>2]|0;i=d;return c[e>>2]|0}function LL(b){b=b|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+16|0;f=e+8|0;g=b;b=g;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=f;a[h]=(d[h]|0)^(d[f+7|0]|0);h=f+7|0;a[h]=(d[h]|0)^(d[f]|0);h=f;a[h]=(d[h]|0)^(d[f+7|0]|0);h=f+1|0;a[h]=(d[h]|0)^(d[f+6|0]|0);h=f+6|0;a[h]=(d[h]|0)^(d[f+1|0]|0);h=f+1|0;a[h]=(d[h]|0)^(d[f+6|0]|0);h=f+2|0;a[h]=(d[h]|0)^(d[f+5|0]|0);h=f+5|0;a[h]=(d[h]|0)^(d[f+2|0]|0);h=f+2|0;a[h]=(d[h]|0)^(d[f+5|0]|0);h=f+3|0;a[h]=(d[h]|0)^(d[f+4|0]|0);h=f+4|0;a[h]=(d[h]|0)^(d[f+3|0]|0);h=f+3|0;a[h]=(d[h]|0)^(d[f+4|0]|0);h=f;f=c[h+4>>2]|0;j=g;c[j>>2]=c[h>>2];c[j+4>>2]=f;f=g;J=c[f+4>>2]|0;i=e;return c[f>>2]|0}function ML(b){b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=b;c[e>>2]=c[f>>2];b=e;a[b]=a[b]^a[e+3|0];b=e+3|0;a[b]=a[b]^a[e];b=e;a[b]=a[b]^a[e+3|0];b=e+1|0;a[b]=a[b]^a[e+2|0];b=e+2|0;a[b]=a[b]^a[e+1|0];b=e+1|0;a[b]=a[b]^a[e+2|0];c[f>>2]=c[e>>2];i=d;return c[f>>2]|0}function NL(b){b=b|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=b;c[f>>2]=c[g>>2];b=f;a[b]=(d[b]|0)^(d[f+3|0]|0);b=f+3|0;a[b]=(d[b]|0)^(d[f]|0);b=f;a[b]=(d[b]|0)^(d[f+3|0]|0);b=f+1|0;a[b]=(d[b]|0)^(d[f+2|0]|0);b=f+2|0;a[b]=(d[b]|0)^(d[f+1|0]|0);b=f+1|0;a[b]=(d[b]|0)^(d[f+2|0]|0);c[g>>2]=c[f>>2];i=e;return c[g>>2]|0}function OL(c){c=c|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=d+8|0;f=c;b[e>>1]=b[f>>1]|0;c=e;a[c]=a[c]^a[e+1|0];c=e+1|0;a[c]=a[c]^a[e];c=e;a[c]=a[c]^a[e+1|0];b[f>>1]=b[e>>1]|0;i=d;return b[f>>1]|0}function PL(c){c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e+8|0;g=c;b[f>>1]=b[g>>1]|0;c=f;a[c]=(d[c]|0)^(d[f+1|0]|0);c=f+1|0;a[c]=(d[c]|0)^(d[f]|0);c=f;a[c]=(d[c]|0)^(d[f+1|0]|0);b[g>>1]=b[f>>1]|0;i=e;return b[g>>1]|0}function QL(b){b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=c+8|0;e=b;g[d>>2]=+g[e>>2];b=d;a[b]=a[b]^a[d+3|0];b=d+3|0;a[b]=a[b]^a[d];b=d;a[b]=a[b]^a[d+3|0];b=d+1|0;a[b]=a[b]^a[d+2|0];b=d+2|0;a[b]=a[b]^a[d+1|0];b=d+1|0;a[b]=a[b]^a[d+2|0];g[e>>2]=+g[d>>2];i=c;return+(+g[e>>2])}function RL(b){b=b|0;var c=0,d=0,e=0;c=i;i=i+16|0;d=c+8|0;e=b;h[d>>3]=+h[e>>3];b=d;a[b]=a[b]^a[d+7|0];b=d+7|0;a[b]=a[b]^a[d];b=d;a[b]=a[b]^a[d+7|0];b=d+1|0;a[b]=a[b]^a[d+6|0];b=d+6|0;a[b]=a[b]^a[d+1|0];b=d+1|0;a[b]=a[b]^a[d+6|0];b=d+2|0;a[b]=a[b]^a[d+5|0];b=d+5|0;a[b]=a[b]^a[d+2|0];b=d+2|0;a[b]=a[b]^a[d+5|0];b=d+3|0;a[b]=a[b]^a[d+4|0];b=d+4|0;a[b]=a[b]^a[d+3|0];b=d+3|0;a[b]=a[b]^a[d+4|0];h[e>>3]=+h[d>>3];i=c;return+(+h[e>>3])}function SL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+512|0;j=i;i=i+512|0;k=a;a=b;b=d;d=0;l=0;if((b|0)<1){m=0;n=m;i=e;return n|0}o=(b|0)<512?b:512;if((c[a+4>>2]|0)==0){c[a>>2]=h;p=ub(h|0,1,o|0,c[k>>2]|0)|0;q=a+4|0;c[q>>2]=(c[q>>2]|0)+p;d=d+(c[a+4>>2]|0)|0}c[a+16>>2]=o;c[a+12>>2]=j;p=iN(a,3)|0;if((p|0)==1){m=d;n=m;i=e;return n|0}if((p|0)!=0){c[g>>2]=p;TL(91888,g);m=d;n=m;i=e;return n|0}if((c[a+16>>2]|0)==0){l=l+o|0;if((b-l|0)<512){r=b-l|0}else{r=512}o=r;c[a+16>>2]=o;c[a+12>>2]=j}while(1){if((l|0)>=(b|0)){break}if((c[a+4>>2]|0)==0){c[a>>2]=h;r=ub(h|0,1,o|0,c[k>>2]|0)|0;g=a+4|0;c[g>>2]=(c[g>>2]|0)+r;d=d+(c[a+4>>2]|0)|0}p=iN(a,3)|0;if((p|0)==1){break}if((p|0)!=0){s=18;break}if((c[a+16>>2]|0)!=0){continue}l=l+o|0;if((b-l|0)<512){t=b-l|0}else{t=512}o=t;c[a+16>>2]=o;c[a+12>>2]=j}if((s|0)==18){c[f>>2]=p;TL(91888,f)}if((c[a+4>>2]|0)!=0){$c(c[k>>2]|0,0-(c[a+4>>2]|0)|0,1)|0;d=d-(c[a+4>>2]|0)|0;c[a+4>>2]=0}m=d;n=m;i=e;return n|0}function TL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;f=i;i=i+16|0;c[f>>2]=b;b=dM(a,f)|0;c[e>>2]=b;KU(92440,e);Ola(b);i=d;return}function UL(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+48|0;f=a;a=b;b=c;c=d;d=0;a:do{if((f|0)==0){g=3}else{if((a|0)==0){g=3;break}if((c|0)<1){h=0;break}switch(b|0){case 7:{d=4;break};case 4:{d=2;break};case 1:{d=1;break};case 12:{d=8;break};case 2:{d=1;break};case 5:{d=4;break};case 6:{d=4;break};case 13:{d=8;break};case 9:{d=8;break};case 3:{d=2;break};default:{h=0;break a}}SL(f,a,fa(c,d)|0)|0;h=c}}while(0);if((g|0)==3){h=0}i=e;return h|0}function VL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;TL(91928,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;TL(91928,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function WL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=16;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;TL(91968,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;TL(91968,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function XL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+32|0;m=i;i=i+8|0;n=a;a=b;b=d;d=0;if((b|0)==0){o=0;p=o;i=e;return p|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(ub(l|0,1,1,c[n>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;q=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((q|0)!=0){c[k>>2]=q;TL(92008,k);o=d;p=o;i=e;return p|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)==0){break}if(!((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1)){break}c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(ub(l|0,1,1,c[n>>2]|0)|0)|0;q=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((q|0)!=0){r=10;break}}if((r|0)==10){c[j>>2]=q;TL(92008,j);o=d;p=o;i=e;return p|0}c[m>>2]=c[b>>2];c[m+4>>2]=c[b+4>>2];if((c[n+20>>2]|0)!=0){ML(m)|0;ML(m+4|0)|0}if((c[m>>2]&65535|0)!=5){TL(92048,h);o=d;p=o;i=e;return p|0}h=c[m+4>>2]|0;if(((h|0)%8|0|0)!=0){s=8-((h|0)%8|0)|0}else{s=0}h=h+s|0;if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(ub(l|0,1,1,c[n>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=h;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b+8;q=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((q|0)!=0){c[g>>2]=q;TL(92008,g);o=d;p=o;i=e;return p|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){t=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{t=0}u=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!t){break}c[u>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(ub(l|0,1,1,c[n>>2]|0)|0)|0;q=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((q|0)!=0){r=26;break}}if((r|0)==26){c[f>>2]=q;TL(92008,f);o=d;p=o;i=e;return p|0}if((c[u>>2]|0)!=0){$c(c[n>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}o=d;p=o;i=e;return p|0}function YL(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;TL(92112,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;TL(92112,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function ZL(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+32|0;k=a;a=b;b=d;d=0;if((b|0)==0){l=0;m=l;i=f;return m|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=j;d=d+(ub(j|0,1,1,c[k>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=e;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[h>>2]=b;TL(92152,h);l=d;m=l;i=f;return m|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){n=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{n=0}o=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!n){break}c[o>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=j;d=d+(ub(j|0,1,1,c[k>>2]|0)|0)|0;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){p=11;break}}if((p|0)==11){c[g>>2]=b;TL(92152,g);l=d;m=l;i=f;return m|0}if((c[o>>2]|0)!=0){$c(c[k>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}l=d;m=l;i=f;return m|0}function _L(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[a+4>>2]|0)==0){c[a+4>>2]=1;c[a>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0}c[a+16>>2]=4;c[a+12>>2]=b;b=iN(a,0)|0;if((b|0)!=0){c[g>>2]=b;TL(92192,g);k=d;l=k;i=e;return l|0}while(1){if((c[a+16>>2]|0)!=0){m=(c[a+4>>2]|0)!=0^1}else{m=0}n=a+4|0;if(!m){break}c[n>>2]=1;c[a>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0;b=iN(a,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;TL(92192,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[a+4>>2]|0)|0,1)|0;d=d-(c[a+4>>2]|0)|0;c[a+4>>2]=0}k=d;l=k;i=e;return l|0}function $L(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+1024|0;l=a;a=b;b=d;d=e;e=0;if((b|0)==0){m=0;n=m;i=f;return n|0}if((d|0)<1){TL(92232,j);m=e;n=m;i=f;return n|0}do{if((c[a+4>>2]|0)==0){j=k;if((d|0)>1024){c[a+4>>2]=ub(j|0,1,1024,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k;break}else{c[a+4>>2]=ub(j|0,1,d|0,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k;break}}}while(0);c[a+16>>2]=d;c[a+12>>2]=b;b=iN(a,3)|0;if((b|0)==1){m=e;n=m;i=f;return n|0}if((b|0)!=0){c[h>>2]=b;TL(92264,h);m=e;n=m;i=f;return n|0}while(1){if((c[a+16>>2]|0)==0){break}if(!((c[a+4>>2]|0)!=0^1)){break}do{if((d-e|0)>1024){c[a+4>>2]=ub(k|0,1,1024,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k}else{h=k;if((d-e|0)<1){c[a+4>>2]=ub(h|0,1,1,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k;break}else{c[a+4>>2]=ub(h|0,1,d-e|0,c[l>>2]|0)|0;e=e+(c[a+4>>2]|0)|0;c[a>>2]=k;break}}}while(0);b=iN(a,3)|0;if((b|0)==1){break}if((b|0)!=0&(b|0)!=-5){o=22;break}}if((o|0)==22){c[g>>2]=b;TL(92264,g)}if((c[a+4>>2]|0)!=0){$c(c[l>>2]|0,0-(c[a+4>>2]|0)|0,1)|0;e=e-(c[a+4>>2]|0)|0;c[a+4>>2]=0}m=e;n=m;i=f;return n|0}function aM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;TL(92304,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;TL(92304,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function bM(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+32|0;j=a;a=b;b=d;d=0;if((b|0)==0){k=0;l=k;i=e;return l|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0}c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=8;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[g>>2]=b;TL(92352,g);k=d;l=k;i=e;return l|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){m=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{m=0}n=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!m){break}c[n>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=h;d=d+(ub(h|0,1,1,c[j>>2]|0)|0)|0;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){o=11;break}}if((o|0)==11){c[f>>2]=b;TL(92352,f);k=d;l=k;i=e;return l|0}if((c[n>>2]|0)!=0){$c(c[j>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}k=d;l=k;i=e;return l|0}function cM(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+32|0;m=a;a=b;b=d;d=0;if((b|0)==0){n=0;o=n;i=h;return o|0}if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)==0){c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(ub(l|0,1,1,c[m>>2]|0)|0)|0}p=(fa(e,f)|0)+g|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]=p;c[(c[(c[a+52>>2]|0)+32>>2]|0)+12>>2]=b;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){c[k>>2]=b;TL(92400,k);n=d;o=n;i=h;return o|0}while(1){if((c[(c[(c[a+52>>2]|0)+32>>2]|0)+16>>2]|0)!=0){q=(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)!=0^1}else{q=0}r=(c[(c[a+52>>2]|0)+32>>2]|0)+4|0;if(!q){break}c[r>>2]=1;c[c[(c[a+52>>2]|0)+32>>2]>>2]=l;d=d+(ub(l|0,1,1,c[m>>2]|0)|0)|0;b=iN(c[(c[a+52>>2]|0)+32>>2]|0,0)|0;if((b|0)!=0){s=11;break}}if((s|0)==11){c[j>>2]=b;TL(92400,j);n=d;o=n;i=h;return o|0}if((c[r>>2]|0)!=0){$c(c[m>>2]|0,0-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;d=d-(c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]|0)|0;c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0}n=d;o=n;i=h;return o|0}function dM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+56|0;e=d+24|0;f=a;a=b;c[e>>2]=c[a>>2];b=(eM(0,0,f,e)|0)+1|0;e=Nla(b+1|0)|0;if((e|0)!=0){eM(e,b,f,a)|0;g=e;h=g;i=d;return h|0}else{g=0;h=g;i=d;return h|0}return 0}function eM(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=EM(a,b,c,d)|0;i=e;return f|0}function fM(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+32|0;e=d+16|0;c[e>>2]=b;b=dM(a,e)|0;i=d;return b|0}function gM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;f=i;i=i+16|0;c[f>>2]=b;b=dM(a,f)|0;c[e>>2]=b;GU(92440,e);Ola(b);i=d;return}function hM(a){a=a|0;var b=0,c=0;b=i;i=i+16|0;switch(a|0){case 12:{c=8;break};case 6:{c=4;break};case 2:{c=1;break};case 3:{c=2;break};case 1:{c=1;break};case 4:{c=2;break};case 13:{c=8;break};case 5:{c=4;break};case 7:{c=4;break};case 9:{c=8;break};default:{c=0}}i=b;return c|0}function iM(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+120|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=f;f=j;j=k;k=l;l=0;v=0;do{if((u|0)!=0){if((f|0)==0){break}if((c[u>>2]|0)==0){break}a:do{switch(j|0){case 1:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(ub(s|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(a[s]|0);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(ub(s|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(a[s]|0);w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(ub(o|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(ML(o)|0);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(ub(o|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(c[o>>2]|0);w=w+1|0}}break};case 2:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(ub(t|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(d[t]|0);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(ub(t|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(d[t]|0);w=w+1|0}}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(ub(r|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+((PL(r)|0)&65535);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(ub(r|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(e[r>>1]|0);w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(ub(q|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+((OL(q)|0)<<16>>16);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(ub(q|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+(b[q>>1]|0);w=w+1|0}}break};case 9:{v=8;x=(c[u+20>>2]|0)!=0;l=l+(ub(f|0,v|0,k|0,c[u>>2]|0)|0)|0;if(!x){break a}w=0;while(1){if((w|0)>=(k|0)){break a}+RL(f+(w<<3)|0);w=w+1|0}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(ub(n|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+QL(n);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(ub(n|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+g[n>>2];w=w+1|0}}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(k|0)){break a}l=l+(ub(p|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+((NL(p)|0)>>>0);w=w+1|0}}else{while(1){if((w|0)>=(k|0)){break a}l=l+(ub(p|0,v|0,1,c[u>>2]|0)|0)|0;h[f+(w<<3)>>3]=+((c[p>>2]|0)>>>0);w=w+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(l,v)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function jM(f,g,j,k,l){f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;i=i+1176|0;n=m+72|0;o=f;f=g;g=j;j=l;l=0;p=0;a:do{switch(k|0){case 3:{p=2;q=(j|0)<=512;if((c[o+20>>2]|0)!=0){if(q){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+((OL(n+(r<<1)|0)|0)<<16>>16);r=r+1|0}}j=j-512|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<9)|0;s=0;while(1){if((s|0)>=512){break}h[g+(r+s<<3)>>3]=+((OL(n+(s<<1)|0)|0)<<16>>16);s=s+1|0}r=r+512|0}j=j-(r-512)|0;$L(o,f,n,fa(j,p)|0)|0;s=0;while(1){if((s|0)>=(j|0)){break a}h[g+(r+s<<3)>>3]=+((OL(n+(s<<1)|0)|0)<<16>>16);s=s+1|0}}else{if(q){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(b[n+(r<<1)>>1]|0);r=r+1|0}}j=j-512|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<9)|0;t=0;while(1){if((t|0)>=512){break}h[g+(r+t<<3)>>3]=+(b[n+(t<<1)>>1]|0);t=t+1|0}r=r+512|0}j=j-(r-512)|0;$L(o,f,n,fa(j,p)|0)|0;t=0;while(1){if((t|0)>=(j|0)){break a}h[g+(r+t<<3)>>3]=+(b[n+(t<<1)>>1]|0);t=t+1|0}}break};case 4:{p=2;q=(j|0)<=512;if((c[o+20>>2]|0)!=0){if(q){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+((PL(n+(r<<1)|0)|0)&65535);r=r+1|0}}j=j-512|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<9)|0;u=0;while(1){if((u|0)>=512){break}h[g+(r+u<<3)>>3]=+((PL(n+(u<<1)|0)|0)&65535);u=u+1|0}r=r+512|0}j=j-(r-512)|0;$L(o,f,n,fa(j,p)|0)|0;u=0;while(1){if((u|0)>=(j|0)){break a}h[g+(r+u<<3)>>3]=+((PL(n+(u<<1)|0)|0)&65535);u=u+1|0}}else{if(q){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(e[n+(r<<1)>>1]|0);r=r+1|0}}j=j-512|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<9)|0;v=0;while(1){if((v|0)>=512){break}h[g+(r+v<<3)>>3]=+(e[n+(v<<1)>>1]|0);v=v+1|0}r=r+512|0}j=j-(r-512)|0;$L(o,f,n,fa(j,p)|0)|0;v=0;while(1){if((v|0)>=(j|0)){break a}h[g+(r+v<<3)>>3]=+(e[n+(v<<1)>>1]|0);v=v+1|0}}break};case 6:{p=4;q=(j|0)<=256;if((c[o+20>>2]|0)!=0){if(q){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+((NL(n+(r<<2)|0)|0)>>>0);r=r+1|0}}j=j-256|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<8)|0;w=0;while(1){if((w|0)>=256){break}h[g+(r+w<<3)>>3]=+((NL(n+(w<<2)|0)|0)>>>0);w=w+1|0}r=r+256|0}j=j-(r-256)|0;$L(o,f,n,fa(j,p)|0)|0;w=0;while(1){if((w|0)>=(j|0)){break a}h[g+(r+w<<3)>>3]=+((NL(n+(w<<2)|0)|0)>>>0);w=w+1|0}}else{if(q){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+((c[n+(r<<2)>>2]|0)>>>0);r=r+1|0}}j=j-256|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<8)|0;x=0;while(1){if((x|0)>=256){break}h[g+(r+x<<3)>>3]=+((c[n+(x<<2)>>2]|0)>>>0);x=x+1|0}r=r+256|0}j=j-(r-256)|0;$L(o,f,n,fa(j,p)|0)|0;x=0;while(1){if((x|0)>=(j|0)){break a}h[g+(r+x<<3)>>3]=+((c[n+(x<<2)>>2]|0)>>>0);x=x+1|0}}break};case 9:{p=8;q=(c[o+20>>2]|0)!=0;$L(o,f,g,fa(j,p)|0)|0;if(!q){break a}r=0;while(1){if((r|0)>=(j|0)){break a}+RL(g+(r<<3)|0);r=r+1|0}break};case 5:{p=4;q=(j|0)<=256;if((c[o+20>>2]|0)!=0){if(q){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(ML(n+(r<<2)|0)|0);r=r+1|0}}j=j-256|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<8)|0;y=0;while(1){if((y|0)>=256){break}h[g+(r+y<<3)>>3]=+(ML(n+(y<<2)|0)|0);y=y+1|0}r=r+256|0}j=j-(r-256)|0;$L(o,f,n,fa(j,p)|0)|0;y=0;while(1){if((y|0)>=(j|0)){break a}h[g+(r+y<<3)>>3]=+(ML(n+(y<<2)|0)|0);y=y+1|0}}else{if(q){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(c[n+(r<<2)>>2]|0);r=r+1|0}}j=j-256|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<8)|0;z=0;while(1){if((z|0)>=256){break}h[g+(r+z<<3)>>3]=+(c[n+(z<<2)>>2]|0);z=z+1|0}r=r+256|0}j=j-(r-256)|0;$L(o,f,n,fa(j,p)|0)|0;z=0;while(1){if((z|0)>=(j|0)){break a}h[g+(r+z<<3)>>3]=+(c[n+(z<<2)>>2]|0);z=z+1|0}}break};case 2:{p=1;if((j|0)<=1024){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(d[n+r|0]|0);r=r+1|0}}j=j-1024|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<10)|0;A=0;while(1){if((A|0)>=1024){break}h[g+(r+A<<3)>>3]=+(d[n+A|0]|0);A=A+1|0}r=r+1024|0}j=j-(r-1024)|0;$L(o,f,n,fa(j,p)|0)|0;A=0;while(1){if((A|0)>=(j|0)){break a}h[g+(r+A<<3)>>3]=+(d[n+A|0]|0);A=A+1|0}break};case 1:{p=1;if((j|0)<=1024){$L(o,f,n,fa(j,p)|0)|0;r=0;while(1){if((r|0)>=(j|0)){break a}h[g+(r<<3)>>3]=+(a[n+r|0]|0);r=r+1|0}}j=j-1024|0;r=0;while(1){if((r|0)>=(j|0)){break}$L(o,f,n,p<<10)|0;B=0;while(1){if((B|0)>=1024){break}h[g+(r+B<<3)>>3]=+(a[n+B|0]|0);B=B+1|0}r=r+1024|0}j=j-(r-1024)|0;$L(o,f,n,fa(j,p)|0)|0;B=0;while(1){if((B|0)>=(j|0)){break a}h[g+(r+B<<3)>>3]=+(a[n+B|0]|0);B=B+1|0}break};default:{C=0;D=C;i=m;return D|0}}}while(0);l=fa(j,p)|0;C=l;D=C;i=m;return D|0}function kM(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+128|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((c[v>>2]|0)==0){break}a:do{switch(j|0){case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(o|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+QL(o);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(o|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+g[o>>2];x=x+1|0}}break};case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(r|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+((OL(r)|0)<<16>>16);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(r|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(b[r>>1]|0);x=x+1|0}}break};case 1:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(t|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(a[t]|0);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(t|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(a[t]|0);x=x+1|0}}break};case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(s|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+((PL(s)|0)&65535);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(s|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(e[s>>1]|0);x=x+1|0}}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(q|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+((NL(q)|0)>>>0);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(q|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+((c[q>>2]|0)>>>0);x=x+1|0}}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(p|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(ML(p)|0);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(p|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(c[p>>2]|0);x=x+1|0}}break};case 2:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(u|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(d[u]|0);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(u|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+(d[u]|0);x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(n|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+RL(n);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(n|0,w|0,1,c[v>>2]|0)|0)|0;g[f+(x<<2)>>2]=+h[n>>3];x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(l,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function lM(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;i=i+136|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=f;f=j;j=k;k=l;l=m;m=0;x=0;do{if((w|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 2:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}$L(w,f,u,x)|0;g[j+(y<<2)>>2]=+(d[u]|0);y=y+1|0}break};case 6:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,r,x)|0;g[j+(y<<2)>>2]=+((NL(r)|0)>>>0);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,r,x)|0;g[j+(y<<2)>>2]=+((c[r>>2]|0)>>>0);y=y+1|0}}break};case 5:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,q,x)|0;g[j+(y<<2)>>2]=+(ML(q)|0);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,q,x)|0;g[j+(y<<2)>>2]=+(c[q>>2]|0);y=y+1|0}}break};case 3:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,s,x)|0;g[j+(y<<2)>>2]=+((OL(s)|0)<<16>>16);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,s,x)|0;g[j+(y<<2)>>2]=+(b[s>>1]|0);y=y+1|0}}break};case 1:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}$L(w,f,v,x)|0;g[j+(y<<2)>>2]=+(a[v]|0);y=y+1|0}break};case 9:{x=8;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,o,x)|0;g[j+(y<<2)>>2]=+RL(o);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,o,x)|0;g[j+(y<<2)>>2]=+h[o>>3];y=y+1|0}}break};case 4:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,t,x)|0;g[j+(y<<2)>>2]=+((PL(t)|0)&65535);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,t,x)|0;g[j+(y<<2)>>2]=+(e[t>>1]|0);y=y+1|0}}break};case 7:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,p,x)|0;g[j+(y<<2)>>2]=+QL(p);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,j+(y<<2)|0,x)|0;y=y+1|0}}break};default:{z=0;A=z;i=n;return A|0}}}while(0);m=fa(l,x)|0;z=m;A=z;i=n;return A|0}}while(0);z=0;A=z;i=n;return A|0}function mM(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0;m=i;i=i+144|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=m+128|0;w=m+136|0;x=f;f=j;j=k;k=l;l=0;y=0;do{if((x|0)!=0){if((f|0)==0){break}if((c[x>>2]|0)==0){break}a:do{switch(j|0){case 1:{y=1;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(v|0,y|0,1,c[x>>2]|0)|0)|0;A=a[v]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(v|0,y|0,1,c[x>>2]|0)|0)|0;A=a[v]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 13:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(q|0,y|0,1,c[x>>2]|0)|0)|0;A=LL(q)|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=J;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(q|0,y|0,1,c[x>>2]|0)|0)|0;B=q;A=c[B+4>>2]|0;C=f+(z<<3)|0;c[C>>2]=c[B>>2];c[C+4>>2]=A;z=z+1|0}}break};case 12:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(p|0,y|0,1,c[x>>2]|0)|0)|0;A=KL(p)|0;C=f+(z<<3)|0;c[C>>2]=A;c[C+4>>2]=J;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(p|0,y|0,1,c[x>>2]|0)|0)|0;C=p;A=c[C+4>>2]|0;B=f+(z<<3)|0;c[B>>2]=c[C>>2];c[B+4>>2]=A;z=z+1|0}}break};case 7:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(o|0,y|0,1,c[x>>2]|0)|0)|0;D=+QL(o);A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(o|0,y|0,1,c[x>>2]|0)|0)|0;D=+g[o>>2];A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}break};case 9:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(n|0,y|0,1,c[x>>2]|0)|0)|0;D=+RL(n);A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(n|0,y|0,1,c[x>>2]|0)|0)|0;D=+h[n>>3];A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}break};case 5:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(r|0,y|0,1,c[x>>2]|0)|0)|0;A=ML(r)|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(r|0,y|0,1,c[x>>2]|0)|0)|0;A=c[r>>2]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 6:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(s|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=NL(s)|0;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(s|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=c[s>>2];c[A+4>>2]=0;z=z+1|0}}break};case 3:{y=2;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(t|0,y|0,1,c[x>>2]|0)|0)|0;A=(OL(t)|0)<<16>>16;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(t|0,y|0,1,c[x>>2]|0)|0)|0;A=b[t>>1]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 2:{y=1;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(w|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=d[w]|0;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(w|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=d[w]|0;c[A+4>>2]=0;z=z+1|0}}break};case 4:{y=2;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(u|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=(PL(u)|0)&65535;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(u|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=e[u>>1]|0;c[A+4>>2]=0;z=z+1|0}}break};default:{E=0;F=E;i=m;return F|0}}}while(0);l=fa(l,y)|0;E=l;F=E;i=m;return F|0}}while(0);E=0;F=E;i=m;return F|0}function nM(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;n=i;i=i+152|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=n+136|0;x=n+144|0;y=f;f=j;j=k;k=l;l=m;m=0;z=0;do{if((y|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 13:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,r,z)|0;B=LL(r)|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=J;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,r,z)|0;C=r;B=c[C+4>>2]|0;D=j+(A<<3)|0;c[D>>2]=c[C>>2];c[D+4>>2]=B;A=A+1|0}}break};case 9:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,o,z)|0;E=+RL(o);B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;D=j+(A<<3)|0;c[D>>2]=~~E>>>0;c[D+4>>2]=B;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,o,z)|0;E=+h[o>>3];B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;D=j+(A<<3)|0;c[D>>2]=~~E>>>0;c[D+4>>2]=B;A=A+1|0}}break};case 5:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,s,z)|0;B=ML(s)|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,s,z)|0;B=c[s>>2]|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}break};case 2:{z=1;A=0;while(1){if((A|0)>=(l|0)){break a}$L(y,f,w,z)|0;B=j+(A<<3)|0;c[B>>2]=d[w]|0;c[B+4>>2]=0;A=A+1|0}break};case 6:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,t,z)|0;B=j+(A<<3)|0;c[B>>2]=NL(t)|0;c[B+4>>2]=0;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,t,z)|0;B=j+(A<<3)|0;c[B>>2]=c[t>>2];c[B+4>>2]=0;A=A+1|0}}break};case 12:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,q,z)|0;B=KL(q)|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=J;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,q,z)|0;D=q;B=c[D+4>>2]|0;C=j+(A<<3)|0;c[C>>2]=c[D>>2];c[C+4>>2]=B;A=A+1|0}}break};case 3:{z=2;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,u,z)|0;B=(OL(u)|0)<<16>>16;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,u,z)|0;B=b[u>>1]|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}break};case 7:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,p,z)|0;E=+QL(p);B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,p,z)|0;E=+g[p>>2];B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}break};case 4:{z=2;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,v,z)|0;B=j+(A<<3)|0;c[B>>2]=(PL(v)|0)&65535;c[B+4>>2]=0;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,v,z)|0;B=j+(A<<3)|0;c[B>>2]=e[v>>1]|0;c[B+4>>2]=0;A=A+1|0}}break};case 1:{z=1;A=0;while(1){if((A|0)>=(l|0)){break a}$L(y,f,x,z)|0;B=a[x]|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}break};default:{F=0;G=F;i=n;return G|0}}}while(0);m=fa(l,z)|0;F=m;G=F;i=n;return G|0}}while(0);F=0;G=F;i=n;return G|0}function oM(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0,F=0;m=i;i=i+144|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=m+128|0;w=m+136|0;x=f;f=j;j=k;k=l;l=0;y=0;do{if((x|0)!=0){if((f|0)==0){break}if((c[x>>2]|0)==0){break}a:do{switch(j|0){case 2:{y=1;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(w|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=d[w]|0;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(w|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=d[w]|0;c[A+4>>2]=0;z=z+1|0}}break};case 6:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(s|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=NL(s)|0;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(s|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=c[s>>2];c[A+4>>2]=0;z=z+1|0}}break};case 13:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(q|0,y|0,1,c[x>>2]|0)|0)|0;A=LL(q)|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=J;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(q|0,y|0,1,c[x>>2]|0)|0)|0;B=q;A=c[B+4>>2]|0;C=f+(z<<3)|0;c[C>>2]=c[B>>2];c[C+4>>2]=A;z=z+1|0}}break};case 4:{y=2;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(u|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=(PL(u)|0)&65535;c[A+4>>2]=0;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(u|0,y|0,1,c[x>>2]|0)|0)|0;A=f+(z<<3)|0;c[A>>2]=e[u>>1]|0;c[A+4>>2]=0;z=z+1|0}}break};case 12:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(p|0,y|0,1,c[x>>2]|0)|0)|0;A=KL(p)|0;C=f+(z<<3)|0;c[C>>2]=A;c[C+4>>2]=J;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(p|0,y|0,1,c[x>>2]|0)|0)|0;C=p;A=c[C+4>>2]|0;B=f+(z<<3)|0;c[B>>2]=c[C>>2];c[B+4>>2]=A;z=z+1|0}}break};case 5:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(r|0,y|0,1,c[x>>2]|0)|0)|0;A=ML(r)|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(r|0,y|0,1,c[x>>2]|0)|0)|0;A=c[r>>2]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 7:{y=4;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(o|0,y|0,1,c[x>>2]|0)|0)|0;D=+QL(o);A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(o|0,y|0,1,c[x>>2]|0)|0)|0;D=+g[o>>2];A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}break};case 3:{y=2;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(t|0,y|0,1,c[x>>2]|0)|0)|0;A=(OL(t)|0)<<16>>16;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(t|0,y|0,1,c[x>>2]|0)|0)|0;A=b[t>>1]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};case 9:{y=8;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(n|0,y|0,1,c[x>>2]|0)|0)|0;D=+RL(n);A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(n|0,y|0,1,c[x>>2]|0)|0)|0;D=+h[n>>3];A=+U(D)>=1.0?D>0.0?(ka(+T(D/4294967296.0),4294967295.0)|0)>>>0:~~+ea((D- +(~~D>>>0))/4294967296.0)>>>0:0;B=f+(z<<3)|0;c[B>>2]=~~D>>>0;c[B+4>>2]=A;z=z+1|0}}break};case 1:{y=1;z=0;if((c[x+20>>2]|0)!=0){while(1){if((z|0)>=(k|0)){break a}l=l+(ub(v|0,y|0,1,c[x>>2]|0)|0)|0;A=a[v]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}else{while(1){if((z|0)>=(k|0)){break a}l=l+(ub(v|0,y|0,1,c[x>>2]|0)|0)|0;A=a[v]|0;B=f+(z<<3)|0;c[B>>2]=A;c[B+4>>2]=((A|0)<0)<<31>>31;z=z+1|0}}break};default:{E=0;F=E;i=m;return F|0}}}while(0);l=fa(l,y)|0;E=l;F=E;i=m;return F|0}}while(0);E=0;F=E;i=m;return F|0}function pM(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;n=i;i=i+152|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=n+136|0;x=n+144|0;y=f;f=j;j=k;k=l;l=m;m=0;z=0;do{if((y|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 3:{z=2;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,u,z)|0;B=(OL(u)|0)<<16>>16;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,u,z)|0;B=b[u>>1]|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}break};case 12:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,q,z)|0;B=KL(q)|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=J;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,q,z)|0;C=q;B=c[C+4>>2]|0;D=j+(A<<3)|0;c[D>>2]=c[C>>2];c[D+4>>2]=B;A=A+1|0}}break};case 1:{z=1;A=0;while(1){if((A|0)>=(l|0)){break a}$L(y,f,x,z)|0;B=a[x]|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}break};case 7:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,p,z)|0;E=+QL(p);B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;D=j+(A<<3)|0;c[D>>2]=~~E>>>0;c[D+4>>2]=B;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,p,z)|0;E=+g[p>>2];B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;D=j+(A<<3)|0;c[D>>2]=~~E>>>0;c[D+4>>2]=B;A=A+1|0}}break};case 2:{z=1;A=0;while(1){if((A|0)>=(l|0)){break a}$L(y,f,w,z)|0;B=j+(A<<3)|0;c[B>>2]=d[w]|0;c[B+4>>2]=0;A=A+1|0}break};case 4:{z=2;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,v,z)|0;B=j+(A<<3)|0;c[B>>2]=(PL(v)|0)&65535;c[B+4>>2]=0;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,v,z)|0;B=j+(A<<3)|0;c[B>>2]=e[v>>1]|0;c[B+4>>2]=0;A=A+1|0}}break};case 13:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,r,z)|0;B=LL(r)|0;D=j+(A<<3)|0;c[D>>2]=B;c[D+4>>2]=J;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,r,z)|0;D=r;B=c[D+4>>2]|0;C=j+(A<<3)|0;c[C>>2]=c[D>>2];c[C+4>>2]=B;A=A+1|0}}break};case 9:{z=8;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,o,z)|0;E=+RL(o);B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,o,z)|0;E=+h[o>>3];B=+U(E)>=1.0?E>0.0?(ka(+T(E/4294967296.0),4294967295.0)|0)>>>0:~~+ea((E- +(~~E>>>0))/4294967296.0)>>>0:0;C=j+(A<<3)|0;c[C>>2]=~~E>>>0;c[C+4>>2]=B;A=A+1|0}}break};case 6:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,t,z)|0;B=j+(A<<3)|0;c[B>>2]=NL(t)|0;c[B+4>>2]=0;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,t,z)|0;B=j+(A<<3)|0;c[B>>2]=c[t>>2];c[B+4>>2]=0;A=A+1|0}}break};case 5:{z=4;A=0;if((c[y+20>>2]|0)!=0){while(1){if((A|0)>=(l|0)){break a}$L(y,f,s,z)|0;B=ML(s)|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}else{while(1){if((A|0)>=(l|0)){break a}$L(y,f,s,z)|0;B=c[s>>2]|0;C=j+(A<<3)|0;c[C>>2]=B;c[C+4>>2]=((B|0)<0)<<31>>31;A=A+1|0}}break};default:{F=0;G=F;i=n;return G|0}}}while(0);m=fa(l,z)|0;F=m;G=F;i=n;return G|0}}while(0);F=0;G=F;i=n;return G|0}function qM(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+128|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((c[v>>2]|0)==0){break}a:do{switch(j|0){case 1:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(t|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=a[t]|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(t|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=a[t]|0;x=x+1|0}}break};case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(s|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=(PL(s)|0)&65535;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(s|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=e[s>>1]|0;x=x+1|0}}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(q|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=NL(q)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(q|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=c[q>>2];x=x+1|0}}break};case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(r|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=(OL(r)|0)<<16>>16;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(r|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=b[r>>1]|0;x=x+1|0}}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(p|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=ML(p)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(p|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=c[p>>2];x=x+1|0}}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(o|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+QL(o);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(o|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+g[o>>2];x=x+1|0}}break};case 2:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(u|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=d[u]|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(u|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=d[u]|0;x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(n|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+RL(n);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(n|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+h[n>>3];x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(l,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function rM(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;i=i+136|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=f;f=j;j=k;k=l;l=m;m=0;x=0;do{if((w|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 1:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}$L(w,f,v,x)|0;c[j+(y<<2)>>2]=a[v]|0;y=y+1|0}break};case 2:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}$L(w,f,u,x)|0;c[j+(y<<2)>>2]=d[u]|0;y=y+1|0}break};case 3:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,s,x)|0;c[j+(y<<2)>>2]=(OL(s)|0)<<16>>16;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,s,x)|0;c[j+(y<<2)>>2]=b[s>>1]|0;y=y+1|0}}break};case 6:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,r,x)|0;c[j+(y<<2)>>2]=NL(r)|0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,r,x)|0;c[j+(y<<2)>>2]=c[r>>2];y=y+1|0}}break};case 5:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,q,x)|0;c[j+(y<<2)>>2]=ML(q)|0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,q,x)|0;c[j+(y<<2)>>2]=c[q>>2];y=y+1|0}}break};case 4:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,t,x)|0;c[j+(y<<2)>>2]=(PL(t)|0)&65535;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,t,x)|0;c[j+(y<<2)>>2]=e[t>>1]|0;y=y+1|0}}break};case 9:{x=8;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,o,x)|0;c[j+(y<<2)>>2]=~~+RL(o);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,o,x)|0;c[j+(y<<2)>>2]=~~+h[o>>3];y=y+1|0}}break};case 7:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,p,x)|0;c[j+(y<<2)>>2]=~~+QL(p);y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,p,x)|0;c[j+(y<<2)>>2]=~~+g[p>>2];y=y+1|0}}break};default:{z=0;A=z;i=n;return A|0}}}while(0);m=fa(l,x)|0;z=m;A=z;i=n;return A|0}}while(0);z=0;A=z;i=n;return A|0}function sM(f,j,k,l){f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+128|0;n=m+64|0;o=m+72|0;p=m+80|0;q=m+88|0;r=m+96|0;s=m+104|0;t=m+112|0;u=m+120|0;v=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((c[v>>2]|0)==0){break}a:do{switch(j|0){case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(s|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=(PL(s)|0)&65535;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(s|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=e[s>>1]|0;x=x+1|0}}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(q|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=NL(q)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(q|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=c[q>>2];x=x+1|0}}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(o|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+QL(o)>>>0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(o|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+g[o>>2]>>>0;x=x+1|0}}break};case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(r|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=(OL(r)|0)<<16>>16;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(r|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=b[r>>1]|0;x=x+1|0}}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(p|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=ML(p)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(p|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=c[p>>2];x=x+1|0}}break};case 2:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(u|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=d[u]|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(u|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=d[u]|0;x=x+1|0}}break};case 1:{w=1;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(t|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=a[t]|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(t|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=a[t]|0;x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}l=l+(ub(n|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+RL(n)>>>0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}l=l+(ub(n|0,w|0,1,c[v>>2]|0)|0)|0;c[f+(x<<2)>>2]=~~+h[n>>3]>>>0;x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(l,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function tM(f,j,k,l,m){f=f|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;i=i+136|0;o=n+72|0;p=n+80|0;q=n+88|0;r=n+96|0;s=n+104|0;t=n+112|0;u=n+120|0;v=n+128|0;w=f;f=j;j=k;k=l;l=m;m=0;x=0;do{if((w|0)!=0){if((j|0)==0){break}if((f|0)==0){break}a:do{switch(k|0){case 1:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}$L(w,f,v,x)|0;c[j+(y<<2)>>2]=a[v]|0;y=y+1|0}break};case 3:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,s,x)|0;c[j+(y<<2)>>2]=(OL(s)|0)<<16>>16;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,s,x)|0;c[j+(y<<2)>>2]=b[s>>1]|0;y=y+1|0}}break};case 9:{x=8;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,o,x)|0;c[j+(y<<2)>>2]=~~+RL(o)>>>0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,o,x)|0;c[j+(y<<2)>>2]=~~+h[o>>3]>>>0;y=y+1|0}}break};case 6:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,r,x)|0;c[j+(y<<2)>>2]=NL(r)|0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,r,x)|0;c[j+(y<<2)>>2]=c[r>>2];y=y+1|0}}break};case 4:{x=2;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,t,x)|0;c[j+(y<<2)>>2]=(PL(t)|0)&65535;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,t,x)|0;c[j+(y<<2)>>2]=e[t>>1]|0;y=y+1|0}}break};case 7:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,p,x)|0;c[j+(y<<2)>>2]=~~+QL(p)>>>0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,p,x)|0;c[j+(y<<2)>>2]=~~+g[p>>2]>>>0;y=y+1|0}}break};case 5:{x=4;y=0;if((c[w+20>>2]|0)!=0){while(1){if((y|0)>=(l|0)){break a}$L(w,f,q,x)|0;c[j+(y<<2)>>2]=ML(q)|0;y=y+1|0}}else{while(1){if((y|0)>=(l|0)){break a}$L(w,f,q,x)|0;c[j+(y<<2)>>2]=c[q>>2];y=y+1|0}}break};case 2:{x=1;y=0;while(1){if((y|0)>=(l|0)){break a}$L(w,f,u,x)|0;c[j+(y<<2)>>2]=d[u]|0;y=y+1|0}break};default:{z=0;A=z;i=n;return A|0}}}while(0);m=fa(l,x)|0;z=m;A=z;i=n;return A|0}}while(0);z=0;A=z;i=n;return A|0}function uM(e,f,j,k){e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+128|0;m=l+64|0;n=l+72|0;o=l+80|0;p=l+88|0;q=l+96|0;r=l+104|0;s=l+112|0;t=l+120|0;u=e;e=f;f=j;j=k;k=0;v=0;do{if((u|0)!=0){if((e|0)==0){break}if((c[u>>2]|0)==0){break}a:do{switch(f|0){case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(p|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=NL(p)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(p|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=c[p>>2];w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(q|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=OL(q)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(q|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=b[q>>1]|0;w=w+1|0}}break};case 2:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(t|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=d[t]|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(t|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=d[t]|0;w=w+1|0}}break};case 9:{v=8;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(m|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+RL(m);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(m|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+h[m>>3];w=w+1|0}}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(r|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=PL(r)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(r|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=b[r>>1]|0;w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(o|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=ML(o)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(o|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=c[o>>2];w=w+1|0}}break};case 1:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(s|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=a[s]|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(s|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=a[s]|0;w=w+1|0}}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(n|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+QL(n);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(n|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+g[n>>2];w=w+1|0}}break};default:{x=0;y=x;i=l;return y|0}}}while(0);k=fa(k,v)|0;x=k;y=x;i=l;return y|0}}while(0);x=0;y=x;i=l;return y|0}



function iJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76024]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(76032,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1144>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76024]=1;i=d;return}function jJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76176]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(76184,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1136>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76176]=1;i=d;return}function kJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76328]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(76336,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1128>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76328]=1;i=d;return}function lJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76496]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(76504,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1112>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76496]=1;i=d;return}function mJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76648]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(76656,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1120>>3],56208)|0)|0;g=c[41340]|0;j=e;k=76800;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76648]=1;i=d;return}function nJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76824]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(76832,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1080>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76824]=1;i=d;return}function oJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76920]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(76928,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1088>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77016;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[76920]=1;i=d;return}function pJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77040]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(77048,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1064>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77040]=1;i=d;return}function qJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77144]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(77152,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1072>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77144]=1;i=d;return}function rJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77272]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(77280,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1048>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77272]=1;i=d;return}function sJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77368]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(77376,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1056>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77464;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77368]=1;i=d;return}function tJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77488]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(77496,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+48>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77488]=1;i=d;return}function uJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77600]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(77608,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+56>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77712;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77600]=1;i=d;return}function vJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77736]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(77744,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1032>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77736]=1;i=d;return}function wJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77832]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(77840,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1040>>3],56208)|0)|0;g=c[41340]|0;j=e;k=77928;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77832]=1;i=d;return}function xJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77952]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(77960,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1016>>3],56208)|0)|0;g=c[41340]|0;j=e;k=78240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[77952]=1;i=d;return}function yJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78096]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(78104,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1024>>3],56208)|0)|0;g=c[41340]|0;j=e;k=78240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78096]=1;i=d;return}function zJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78264]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1e3>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1e3>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(78272,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1e3>>3],56208)|0)|0;g=c[41340]|0;j=e;k=78584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78264]=1;i=d;return}function AJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78424]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1008>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1008>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(78432,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1008>>3],56208)|0)|0;g=c[41340]|0;j=e;k=78584;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78424]=1;i=d;return}function BJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78608]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+928>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+928>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(78616,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+928>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78608]=1;i=d;return}function CJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78768]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+936>>3],-1.0e+60)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+936>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(78776,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+936>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78768]=1;i=d;return}function DJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78928]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(78936,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+944>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79072;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[78928]=1;i=d;return}function EJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79096]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+904>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+904>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(79104,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+904>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79096]=1;i=d;return}function FJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79248]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+912>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+912>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(79256,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+912>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79248]=1;i=d;return}function GJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79400]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+920>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+920>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(79408,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+920>>3],56208)|0)|0;g=c[41340]|0;j=e;k=79552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79400]=1;i=d;return}function HJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79576]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+880>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+880>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(79584,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+880>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79576]=1;i=d;return}function IJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79728]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+888>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+888>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(79736,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+888>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79728]=1;i=d;return}function JJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79880]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(79888,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+896>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[79880]=1;i=d;return}function KJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80056]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(80064,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+856>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80056]=1;i=d;return}function LJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80208]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+864>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+864>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(80216,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+864>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80208]=1;i=d;return}function MJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80360]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+872>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+872>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(80368,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+872>>3],56208)|0)|0;g=c[41340]|0;j=e;k=80512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80360]=1;i=d;return}function NJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80536]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(80544,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+808>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80536]=1;i=d;return}function OJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80696]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+816>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+816>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(80704,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+816>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80696]=1;i=d;return}function PJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80856]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+824>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+824>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(80864,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+824>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[80856]=1;i=d;return}function QJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81016]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+832>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+832>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(81024,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+832>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81016]=1;i=d;return}function RJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81200]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(81208,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+784>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81200]=1;i=d;return}function SJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81368]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(81376,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+792>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81368]=1;i=d;return}function TJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81536]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+800>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+800>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(81544,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+800>>3],56208)|0)|0;g=c[41340]|0;j=e;k=81704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81536]=1;i=d;return}function UJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81728]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(81736,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+752>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81728]=1;i=d;return}function VJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81888]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(81896,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+760>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[81888]=1;i=d;return}function WJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82048]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(82056,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+768>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82048]=1;i=d;return}function XJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82208]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(82216,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+776>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82208]=1;i=d;return}function YJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82392]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(82400,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+728>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82392]=1;i=d;return}function ZJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82560]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(82568,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+736>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82560]=1;i=d;return}function _J(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82728]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+744>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+744>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(82736,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+744>>3],56208)|0)|0;g=c[41340]|0;j=e;k=82896;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82728]=1;i=d;return}function $J(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82920]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(82928,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+600>>3],56208)|0)|0;g=c[41340]|0;j=e;k=83520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[82920]=1;i=d;return}function aK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83120]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(83128,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+608>>3],56208)|0)|0;g=c[41340]|0;j=e;k=83520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83120]=1;i=d;return}function bK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83320]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],-1.0e5)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(83328,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+616>>3],56208)|0)|0;g=c[41340]|0;j=e;k=83520;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83320]=1;i=d;return}function cK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83544]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(83552,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3],56208)|0)|0;g=c[41340]|0;j=e;k=85832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83544]=1;i=d;return}function dK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83688]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(83696,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83688]=1;i=d;return}function eK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83840]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(83848,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+592>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[83840]=1;i=d;return}function fK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84e3]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(84008,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+584>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84e3]=1;i=d;return}function gK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84144]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(84152,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+24>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84144]=1;i=d;return}function hK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84288]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(84296,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+576>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84288]=1;i=d;return}function iK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84440]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=CT(84448,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+568>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84440]=1;i=d;return}function jK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84584]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],.001)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],.25)|0)<<24>>24==0)){i=d;return}b=CT(84592,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84584]=1;i=d;return}function kK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84728]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(84736,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+552>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84728]=1;i=d;return}function lK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84888]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(84896,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+536>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[84888]=1;i=d;return}function mK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85048]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(85056,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+528>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85048]=1;i=d;return}function nK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85208]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(85216,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+520>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85208]=1;i=d;return}function oK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85360]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(85368,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+512>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85360]=1;i=d;return}function pK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85512]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(85520,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+504>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85512]=1;i=d;return}function qK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85688]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(85696,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+16>>3],56208)|0)|0;g=c[41340]|0;j=e;k=85832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85688]=1;i=d;return}function rK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85856]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(85864,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86008;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[85856]=1;i=d;return}function sK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86032]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],-1.0e10)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],1.0e10)|0)<<24>>24==0)){i=d;return}b=CT(86040,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+480>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86192;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[86032]=1;i=d;return}function tK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86216]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],1.0e5)|0)<<24>>24==0)){i=d;return}b=CT(86224,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+472>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86360;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[86216]=1;i=d;return}function uK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86384]&1){i=d;return}g=b+4|0;b=yW(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0)|0;if(!(b<<24>>24==0|(wW(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],1.0e4)|0)<<24>>24==0)){i=d;return}b=CT(86392,wT(+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[86384]=1;i=d;return}function vK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86552]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],-1.0e8)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(86560,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+464>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86704;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[86552]=1;i=d;return}function wK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86728]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],1.0e7)|0)<<24>>24==0)){i=d;return}b=CT(86736,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+456>>3],56208)|0)|0;g=c[41340]|0;j=e;k=86872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[86728]=1;i=d;return}function xK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86896]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],.001)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],.25)|0)<<24>>24==0)){i=d;return}b=CT(86904,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+448>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[86896]=1;i=d;return}function yK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87064]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(87072,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+440>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87064]=1;i=d;return}function zK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87248]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(87256,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+424>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87248]=1;i=d;return}function AK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87432]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(87440,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+416>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87432]=1;i=d;return}function BK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87616]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(87624,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+408>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87768;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87616]=1;i=d;return}function CK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87792]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],1.0)|0)<<24>>24==0)){i=d;return}b=CT(87800,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+400>>3],56208)|0)|0;g=c[41340]|0;j=e;k=87944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87792]=1;i=d;return}function DK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87968]&1){i=d;return}g=b+4|0;b=yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],0.0)|0;if(!(b<<24>>24==0|(wW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],1.0e8)|0)<<24>>24==0)){i=d;return}b=CT(87976,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+392>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88144;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[87968]=1;i=d;return}function EK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88168]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(88176,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+344>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[88168]=1;i=d;return}function FK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88288]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(88296,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+352>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[88288]=1;i=d;return}function GK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88432]&1){i=d;return}g=b+4|0;if(!((yW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=CT(88440,wT(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+336>>3],56208)|0)|0;g=c[41340]|0;j=e;k=88544;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ke[g&15](e,b,f);a[88432]=1;i=d;return}function HK(a){a=a|0;var b=0;b=i;QG(a);RG(a);SG(a);TG(a);UG(a);VG(a);WG(a);XG(a);YG(a);ZG(a);_G(a);$G(a);aH(a);bH(a);cH(a);dH(a);eH(a);fH(a);gH(a);hH(a);iH(a);jH(a);kH(a);lH(a);mH(a);nH(a);oH(a);pH(a);qH(a);rH(a);sH(a);tH(a);uH(a);vH(a);wH(a);xH(a);yH(a);zH(a);AH(a);BH(a);CH(a);DH(a);EH(a);FH(a);GH(a);HH(a);IH(a);JH(a);KH(a);LH(a);MH(a);NH(a);OH(a);PH(a);QH(a);RH(a);SH(a);TH(a);UH(a);VH(a);WH(a);XH(a);YH(a);ZH(a);_H(a);$H(a);aI(a);bI(a);cI(a);dI(a);eI(a);fI(a);gI(a);hI(a);iI(a);jI(a);kI(a);lI(a);mI(a);nI(a);oI(a);pI(a);qI(a);rI(a);sI(a);tI(a);uI(a);vI(a);wI(a);xI(a);yI(a);zI(a);AI(a);BI(a);CI(a);DI(a);EI(a);FI(a);GI(a);HI(a);II(a);JI(a);KI(a);LI(a);MI(a);NI(a);OI(a);PI(a);QI(a);RI(a);SI(a);TI(a);UI(a);VI(a);WI(a);XI(a);YI(a);ZI(a);_I(a);$I(a);aJ(a);bJ(a);cJ(a);dJ(a);eJ(a);fJ(a);gJ(a);hJ(a);iJ(a);jJ(a);kJ(a);lJ(a);mJ(a);nJ(a);oJ(a);pJ(a);qJ(a);rJ(a);sJ(a);tJ(a);uJ(a);vJ(a);wJ(a);xJ(a);yJ(a);zJ(a);AJ(a);BJ(a);CJ(a);DJ(a);EJ(a);FJ(a);GJ(a);HJ(a);IJ(a);JJ(a);KJ(a);LJ(a);MJ(a);NJ(a);OJ(a);PJ(a);QJ(a);RJ(a);SJ(a);TJ(a);UJ(a);VJ(a);WJ(a);XJ(a);YJ(a);ZJ(a);_J(a);$J(a);aK(a);bK(a);cK(a);dK(a);eK(a);fK(a);gK(a);hK(a);iK(a);jK(a);kK(a);lK(a);mK(a);nK(a);oK(a);pK(a);qK(a);rK(a);sK(a);tK(a);uK(a);vK(a);wK(a);xK(a);yK(a);zK(a);AK(a);BK(a);CK(a);DK(a);EK(a);FK(a);GK(a);i=b;return 0}function IK(a){a=a|0;i=i;return 1}function JK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=21;c[a+48>>2]=21;c[a+72>>2]=Pla(21,8)|0;a=Pla(21,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=Pla(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=Nla(84)|0;c[(c[d>>2]|0)+52>>2]=a;a=Nla(776)|0;c[(c[d>>2]|0)+56>>2]=a;a=Nla(84)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=13;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e+80>>2]=17;c[e+68>>2]=17;c[e+76>>2]=17;c[e+64>>2]=8;c[e+56>>2]=3;c[e+60>>2]=2;c[e+52>>2]=12;c[e+48>>2]=12;c[e+44>>2]=12;c[e+40>>2]=8;c[e+36>>2]=8;c[e+32>>2]=8;c[e+72>>2]=5;c[e+24>>2]=2;c[e+28>>2]=3;c[e+20>>2]=8;c[e+16>>2]=8;c[e+12>>2]=8;c[e+8>>2]=12;c[e+4>>2]=12;c[e>>2]=12;f=12;g=12;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=21){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}KK(e,c[a+56>>2]|0);a=c[d>>2]|0;LK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;MK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;NK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;OK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;PK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;QK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;RK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;SK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;TK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;UK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;VK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;WK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;XK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;YK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;ZK(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;_K(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;$K(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;aL(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;bL(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;cL(c[a+52>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+80>>2]=1;c[a+68>>2]=2;c[a+76>>2]=3;c[a+64>>2]=4;c[a+56>>2]=5;c[a+72>>2]=5;c[a+60>>2]=6;c[a+24>>2]=6;c[a+52>>2]=7;c[a+20>>2]=7;c[a+48>>2]=8;c[a+16>>2]=8;c[a+44>>2]=9;c[a+12>>2]=9;c[a+40>>2]=10;c[a+28>>2]=10;c[a+36>>2]=11;c[a+8>>2]=11;c[a+32>>2]=12;c[a+4>>2]=12;c[a>>2]=13;i=b;return 0}function KK(a,b){a=a|0;b=b|0;var d=0;d=a+80|0;c[b+((c[d>>2]|0)+ -17<<2)>>2]=0;c[b+((c[d>>2]|0)+ -16<<2)>>2]=1;c[b+((c[d>>2]|0)+ -15<<2)>>2]=2;c[b+((c[d>>2]|0)+ -14<<2)>>2]=3;c[b+((c[d>>2]|0)+ -13<<2)>>2]=4;c[b+((c[d>>2]|0)+ -12<<2)>>2]=5;c[b+((c[d>>2]|0)+ -11<<2)>>2]=7;c[b+((c[d>>2]|0)+ -10<<2)>>2]=6;c[b+((c[d>>2]|0)+ -9<<2)>>2]=18;c[b+((c[d>>2]|0)+ -8<<2)>>2]=11;c[b+((c[d>>2]|0)+ -7<<2)>>2]=12;c[b+((c[d>>2]|0)+ -6<<2)>>2]=13;c[b+((c[d>>2]|0)+ -5<<2)>>2]=14;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=20;i=i;return}function LK(a,b){a=a|0;b=b|0;var d=0;d=a+68|0;c[b+((c[d>>2]|0)+ -17<<2)>>2]=0;c[b+((c[d>>2]|0)+ -16<<2)>>2]=1;c[b+((c[d>>2]|0)+ -15<<2)>>2]=2;c[b+((c[d>>2]|0)+ -14<<2)>>2]=3;c[b+((c[d>>2]|0)+ -13<<2)>>2]=4;c[b+((c[d>>2]|0)+ -12<<2)>>2]=5;c[b+((c[d>>2]|0)+ -11<<2)>>2]=7;c[b+((c[d>>2]|0)+ -10<<2)>>2]=6;c[b+((c[d>>2]|0)+ -9<<2)>>2]=18;c[b+((c[d>>2]|0)+ -8<<2)>>2]=11;c[b+((c[d>>2]|0)+ -7<<2)>>2]=12;c[b+((c[d>>2]|0)+ -6<<2)>>2]=13;c[b+((c[d>>2]|0)+ -5<<2)>>2]=14;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=20;i=i;return}function MK(a,b){a=a|0;b=b|0;var d=0;d=a+76|0;c[b+((c[d>>2]|0)+ -17<<2)>>2]=0;c[b+((c[d>>2]|0)+ -16<<2)>>2]=1;c[b+((c[d>>2]|0)+ -15<<2)>>2]=2;c[b+((c[d>>2]|0)+ -14<<2)>>2]=3;c[b+((c[d>>2]|0)+ -13<<2)>>2]=4;c[b+((c[d>>2]|0)+ -12<<2)>>2]=5;c[b+((c[d>>2]|0)+ -11<<2)>>2]=7;c[b+((c[d>>2]|0)+ -10<<2)>>2]=6;c[b+((c[d>>2]|0)+ -9<<2)>>2]=18;c[b+((c[d>>2]|0)+ -8<<2)>>2]=11;c[b+((c[d>>2]|0)+ -7<<2)>>2]=12;c[b+((c[d>>2]|0)+ -6<<2)>>2]=13;c[b+((c[d>>2]|0)+ -5<<2)>>2]=14;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=20;i=i;return}function NK(a,b){a=a|0;b=b|0;var d=0;d=a+64|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=3;c[b+((c[d>>2]|0)+ -7<<2)>>2]=4;c[b+((c[d>>2]|0)+ -6<<2)>>2]=5;c[b+((c[d>>2]|0)+ -5<<2)>>2]=7;c[b+((c[d>>2]|0)+ -4<<2)>>2]=6;c[b+((c[d>>2]|0)+ -3<<2)>>2]=18;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=16;i=i;return}function OK(a,b){a=a|0;b=b|0;var d=0;d=a+56|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=15;c[b+((c[d>>2]|0)+ -2<<2)>>2]=14;c[b+((c[d>>2]|0)+ -1<<2)>>2]=16;i=i;return}function PK(a,b){a=a|0;b=b|0;var d=0;d=a+60|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=15;c[b+((c[d>>2]|0)+ -1<<2)>>2]=14;i=i;return}function QK(a,b){a=a|0;b=b|0;var d=0;d=a+52|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=8;c[b+((c[d>>2]|0)+ -11<<2)>>2]=9;c[b+((c[d>>2]|0)+ -10<<2)>>2]=10;c[b+((c[d>>2]|0)+ -9<<2)>>2]=11;c[b+((c[d>>2]|0)+ -8<<2)>>2]=12;c[b+((c[d>>2]|0)+ -7<<2)>>2]=13;c[b+((c[d>>2]|0)+ -6<<2)>>2]=15;c[b+((c[d>>2]|0)+ -5<<2)>>2]=14;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=20;i=i;return}function RK(a,b){a=a|0;b=b|0;var d=0;d=a+48|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=8;c[b+((c[d>>2]|0)+ -11<<2)>>2]=9;c[b+((c[d>>2]|0)+ -10<<2)>>2]=10;c[b+((c[d>>2]|0)+ -9<<2)>>2]=11;c[b+((c[d>>2]|0)+ -8<<2)>>2]=12;c[b+((c[d>>2]|0)+ -7<<2)>>2]=13;c[b+((c[d>>2]|0)+ -6<<2)>>2]=15;c[b+((c[d>>2]|0)+ -5<<2)>>2]=14;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=20;i=i;return}function SK(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=8;c[b+((c[d>>2]|0)+ -11<<2)>>2]=9;c[b+((c[d>>2]|0)+ -10<<2)>>2]=10;c[b+((c[d>>2]|0)+ -9<<2)>>2]=11;c[b+((c[d>>2]|0)+ -8<<2)>>2]=12;c[b+((c[d>>2]|0)+ -7<<2)>>2]=13;c[b+((c[d>>2]|0)+ -6<<2)>>2]=15;c[b+((c[d>>2]|0)+ -5<<2)>>2]=14;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=20;i=i;return}function TK(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=8;c[b+((c[d>>2]|0)+ -7<<2)>>2]=9;c[b+((c[d>>2]|0)+ -6<<2)>>2]=10;c[b+((c[d>>2]|0)+ -5<<2)>>2]=11;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=13;c[b+((c[d>>2]|0)+ -2<<2)>>2]=15;c[b+((c[d>>2]|0)+ -1<<2)>>2]=14;i=i;return}function UK(a,b){a=a|0;b=b|0;var d=0;d=a+36|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=8;c[b+((c[d>>2]|0)+ -7<<2)>>2]=9;c[b+((c[d>>2]|0)+ -6<<2)>>2]=10;c[b+((c[d>>2]|0)+ -5<<2)>>2]=11;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=13;c[b+((c[d>>2]|0)+ -2<<2)>>2]=15;c[b+((c[d>>2]|0)+ -1<<2)>>2]=14;i=i;return}function VK(a,b){a=a|0;b=b|0;var d=0;d=a+32|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=8;c[b+((c[d>>2]|0)+ -7<<2)>>2]=9;c[b+((c[d>>2]|0)+ -6<<2)>>2]=10;c[b+((c[d>>2]|0)+ -5<<2)>>2]=11;c[b+((c[d>>2]|0)+ -4<<2)>>2]=12;c[b+((c[d>>2]|0)+ -3<<2)>>2]=13;c[b+((c[d>>2]|0)+ -2<<2)>>2]=15;c[b+((c[d>>2]|0)+ -1<<2)>>2]=14;i=i;return}function WK(a,b){a=a|0;b=b|0;var d=0;d=a+72|0;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=6;c[b+((c[d>>2]|0)+ -1<<2)>>2]=18;i=i;return}function XK(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=6;i=i;return}function YK(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=7;c[b+((c[d>>2]|0)+ -2<<2)>>2]=6;c[b+((c[d>>2]|0)+ -1<<2)>>2]=16;i=i;return}function ZK(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=1;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=6;i=i;return}function _K(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=1;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=6;i=i;return}function $K(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=1;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=3;c[b+((c[d>>2]|0)+ -4<<2)>>2]=4;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=7;c[b+((c[d>>2]|0)+ -1<<2)>>2]=6;i=i;return}function aL(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=1;c[b+((c[d>>2]|0)+ -10<<2)>>2]=2;c[b+((c[d>>2]|0)+ -9<<2)>>2]=3;c[b+((c[d>>2]|0)+ -8<<2)>>2]=4;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=7;c[b+((c[d>>2]|0)+ -5<<2)>>2]=6;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=20;i=i;return}function bL(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -12<<2)>>2]=0;c[b+((c[d>>2]|0)+ -11<<2)>>2]=1;c[b+((c[d>>2]|0)+ -10<<2)>>2]=2;c[b+((c[d>>2]|0)+ -9<<2)>>2]=3;c[b+((c[d>>2]|0)+ -8<<2)>>2]=4;c[b+((c[d>>2]|0)+ -7<<2)>>2]=5;c[b+((c[d>>2]|0)+ -6<<2)>>2]=7;c[b+((c[d>>2]|0)+ -5<<2)>>2]=6;c[b+((c[d>>2]|0)+ -4<<2)>>2]=16;c[b+((c[d>>2]|0)+ -3<<2)>>2]=19;c[b+((c[d>>2]|0)+ -2<<2)>>2]=17;c[b+((c[d>>2]|0)+ -1<<2)>>2]=20;i=i;return}function cL(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -12<<2)>>2]=0;c[b+((c[a>>2]|0)+ -11<<2)>>2]=1;c[b+((c[a>>2]|0)+ -10<<2)>>2]=2;c[b+((c[a>>2]|0)+ -9<<2)>>2]=3;c[b+((c[a>>2]|0)+ -8<<2)>>2]=4;c[b+((c[a>>2]|0)+ -7<<2)>>2]=5;c[b+((c[a>>2]|0)+ -6<<2)>>2]=7;c[b+((c[a>>2]|0)+ -5<<2)>>2]=6;c[b+((c[a>>2]|0)+ -4<<2)>>2]=16;c[b+((c[a>>2]|0)+ -3<<2)>>2]=19;c[b+((c[a>>2]|0)+ -2<<2)>>2]=17;c[b+((c[a>>2]|0)+ -1<<2)>>2]=20;i=i;return}function dL(a){a=a|0;i=i;return 1}function eL(a){a=a|0;i=i;return 1}function fL(a){a=a|0;i=i;return 1}function gL(a){a=a|0;i=i;return 0}function hL(a){a=a|0;i=i;return 0}function iL(a){a=a|0;i=i;return 0}function jL(a){a=a|0;i=i;return 0}function kL(a){a=a|0;i=i;return 0}function lL(a,b){a=a|0;b=b|0;i=i;return-1}function mL(a,b){a=a|0;b=b|0;i=i;return-1}function nL(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function oL(){i=i;return 88568}function pL(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+40|0;f=b;b=c;c=d;do{if((f|0)!=0){if((b|0)==0){break}if((c|0)!=0){g=lma(f,b)|0}else{while(1){d=Dma(a[f]|0)|0;if((d|0)==(Dma(a[b]|0)|0)){h=(a[f]|0)!=0}else{h=0}j=f;if(!h){break}f=j+1|0;b=b+1|0}d=Dma(a[j]|0)|0;g=d-(Dma(a[b]|0)|0)|0}do{if((g|0)<0){g=1}else{if((g|0)==0){g=2;break}else{g=3;break}}}while(0);k=g;l=k;i=e;return l|0}}while(0);k=2;l=k;i=e;return l|0}function qL(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;n=i;i=i+152|0;o=n+96|0;p=n+104|0;q=n+120|0;r=a;a=b;b=d;d=e;e=f;s=g;f=j;j=k;k=Pla(1,104)|0;do{if((k|0)!=0){c[k+24>>2]=l;c[k+28>>2]=m;c[k+40>>2]=j;do{if(j>>>0>0){c[k+36>>2]=Nla(c[k+40>>2]<<2)|0;t=k;if((c[k+36>>2]|0)!=0){rma(c[t+36>>2]|0,f|0,c[k+40>>2]<<2|0)|0;break}Ola(t);IU(90072);u=0;v=u;i=n;return v|0}}while(0);h[k+48>>3]=s;c[k+32>>2]=rL(r,a)|0;t=c[k+32>>2]|0;if((t|0)==0){c[k+12>>2]=d;c[k+16>>2]=e;c[k+8>>2]=b;do{if((c[k+24>>2]|0)==2){if((c[k+12>>2]|0)!=2){break}c[k+24>>2]=1}}while(0);w=k;if((sL(k)|0)==0){c[w+8>>2]=0;break}if((c[w+24>>2]|0)==2){c[k+56>>2]=tL(b,c[k+12>>2]|0,c[k+16>>2]|0,f,c[k+40>>2]|0)|0}c[k+8>>2]=Nla((fa(c[k+12>>2]|0,c[k+16>>2]|0)|0)<<3)|0;if((c[k+8>>2]|0)!=0){rma(c[k+8>>2]|0,b|0,(fa(c[k+12>>2]|0,c[k+16>>2]|0)|0)<<3|0)|0;break}if(j>>>0>0){Ola(c[k+36>>2]|0)}Ola(k);k=0;IU(90072);break}else if((t|0)==1){c[k+4>>2]=Nla((pma(r|0)|0)+1|0)|0;if((c[k+4>>2]|0)==0){if(j>>>0>0){Ola(c[k+36>>2]|0)}Ola(k);k=0;IU(90072);break}vma(c[k+4>>2]|0,r|0)|0;c[k>>2]=Nla((pma(a|0)|0)+1|0)|0;w=k;if((c[k>>2]|0)!=0){vma(c[w>>2]|0,a|0)|0;break}Ola(c[w+4>>2]|0);if(j>>>0>0){Ola(c[k+36>>2]|0)}Ola(k);k=0;IU(90072);break}else if((t|0)==3){break}else if((t|0)==2){if((uL(r,0,p,o,k+8|0)|0)!=0){break}c[k+12>>2]=c[p>>2];c[k+16>>2]=c[p+4>>2];if((c[o>>2]|0)!=0){c[q>>2]=c[k+12>>2];c[q+4>>2]=c[k+16>>2];w=Nla((fa(c[q>>2]|0,c[q+4>>2]|0)|0)<<3)|0;if((w|0)==0){if(j>>>0>0){Ola(c[k+36>>2]|0)}Ola(k);k=0;IU(90072);break}x=0;while(1){if(!(x>>>0<(c[q+4>>2]|0)>>>0)){break}y=0;while(1){if(!(y>>>0<(c[q>>2]|0)>>>0)){break}z=(fa(y,c[q+4>>2]|0)|0)+x|0;h[w+((fa(x,c[q>>2]|0)|0)+y<<3)>>3]=+h[(c[k+8>>2]|0)+(z<<3)>>3];y=y+1|0}x=x+1|0}c[k+8>>2]=w;c[k+12>>2]=c[q+4>>2];c[k+16>>2]=c[q>>2];c[k+32>>2]=3}do{if((c[k+24>>2]|0)==2){if((c[k+12>>2]|0)!=2){break}c[k+24>>2]=1}}while(0);if((sL(k)|0)==0){break}if((c[k+24>>2]|0)!=2){break}c[k+56>>2]=tL(c[k+8>>2]|0,c[k+12>>2]|0,c[k+16>>2]|0,f,c[k+40>>2]|0)|0;break}else{IU(90104);break}}else{IU(90072)}}while(0);u=k;v=u;i=n;return v|0}function rL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=d;f=b;b=JL(a)|0;a=JL(f)|0;if((b|0)!=0){g=(a|0)==0?2:1;h=g;i=d;return h|0}if((a|0)!=0){c[e>>2]=f;KU(91304,e)}g=0;h=g;i=d;return h|0}function sL(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0;b=i;i=i+48|0;d=b;e=i;i=i+48|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+8|0;l=a;a=1;a:do{if((l|0)!=0){m=c[l+12>>2]|0;n=c[l+16>>2]|0;vma(j|0,91392)|0;if((c[l+32>>2]|0)==0){o=j}else{o=c[l+4>>2]|0}do{if(!(m>>>0<1)){if(n>>>0<2){break}if((c[l+8>>2]|0)==0){break a}if(!(m>>>0>1)){break a}p=c[l+8>>2]|0;do{if((c[l+28>>2]|0)==3){if(!(+h[p+((fa(m-1|0,n)|0)<<3)>>3]- +h[p>>3]<=0.0)){break}c[f>>2]=o;KU(91632,f);a=0;q=a;r=q;i=b;return r|0}}while(0);s=0;if((c[l+24>>2]|0)==2){while(1){if(!(s>>>0<(m-1|0)>>>0)){break a}t=+h[p+((fa(s,n)|0)<<3)>>3];u=+h[p+((fa(s+1|0,n)|0)<<3)>>3];if(t>=u){break}s=s+1|0}c[e>>2]=o;c[e+4>>2]=m;c[e+8>>2]=n;c[e+12>>2]=o;c[e+16>>2]=s+1;v=e+20|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[e+28>>2]=o;c[e+32>>2]=s+2;v=e+36|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];KU(91400,e);a=0;q=a;r=q;i=b;return r|0}else{while(1){if(!(s>>>0<(m-1|0)>>>0)){break a}w=+h[p+((fa(s,n)|0)<<3)>>3];x=+h[p+((fa(s+1|0,n)|0)<<3)>>3];if(w>x){break}s=s+1|0}c[d>>2]=o;c[d+4>>2]=m;c[d+8>>2]=n;c[d+12>>2]=o;c[d+16>>2]=s+1;p=d+20|0;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[d+28>>2]=o;c[d+32>>2]=s+2;p=d+36|0;h[k>>3]=x;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];KU(91752,d);a=0;q=a;r=q;i=b;return r|0}}}while(0);c[g>>2]=o;c[g+4>>2]=m;c[g+8>>2]=n;KU(91536,g);a=0;q=a;r=q;i=b;return r|0}}while(0);q=a;r=q;i=b;return r|0}function tL(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0;g=i;i=i+120|0;j=a;a=b;b=d;d=e;e=f;f=0;do{if((j|0)!=0){if((d|0)==0){break}if(!(a>>>0>2)){break}f=Nla((fa(a-1|0,e)|0)*24|0)|0;if((f|0)==0){IU(90072);k=0;l=k;i=g;return l|0}m=Nla(a+3<<3)|0;if((m|0)==0){Ola(f);IU(90072);k=0;l=k;i=g;return l|0}n=0;while(1){if(!(n>>>0<e>>>0)){break}o=0;while(1){if(!(o>>>0<(a-1|0)>>>0)){break}p=fa(o+1|0,b)|0;q=fa(o,b)|0;r=+h[j+((fa(o+1|0,b)|0)<<3)>>3];h[m+(o+2<<3)>>3]=(+h[j+(p+((c[d+(n<<2)>>2]|0)-1)<<3)>>3]- +h[j+(q+((c[d+(n<<2)>>2]|0)-1)<<3)>>3])/(r- +h[j+((fa(o,b)|0)<<3)>>3]);o=o+1|0}h[m>>3]=+h[m+16>>3]*3.0- +h[m+24>>3]*2.0;h[m+8>>3]=+h[m+16>>3]*2.0- +h[m+24>>3];h[m+(a+1<<3)>>3]=+h[m+(a<<3)>>3]*2.0- +h[m+(a-1<<3)>>3];h[m+(a+2<<3)>>3]=+h[m+(a<<3)>>3]*3.0- +h[m+(a-1<<3)>>3]*2.0;o=0;while(1){if(!(o>>>0<(a-1|0)>>>0)){break}r=+h[j+((fa(o+1|0,b)|0)<<3)>>3];s=r- +h[j+((fa(o,b)|0)<<3)>>3];q=f+(((fa(o,e)|0)+n|0)*24|0)|0;r=+U(+(+h[m+(o+3<<3)>>3]- +h[m+(o+2<<3)>>3]));t=r+ +U(+(+h[m+(o+1<<3)>>3]- +h[m+(o<<3)>>3]));r=+h[m+(o+1<<3)>>3];if(t>0.0){u=+U(+(r- +h[m+(o<<3)>>3]))/t;h[q+16>>3]=(1.0-u)*+h[m+(o+1<<3)>>3]+u*+h[m+(o+2<<3)>>3]}else{h[q+16>>3]=.5*r+ +h[m+(o+2<<3)>>3]*.5}r=+U(+(+h[m+(o+4<<3)>>3]- +h[m+(o+3<<3)>>3]));t=r+ +U(+(+h[m+(o+2<<3)>>3]- +h[m+(o+1<<3)>>3]));r=+h[m+(o+2<<3)>>3];if(t>0.0){u=+U(+(r- +h[m+(o+1<<3)>>3]))/t;t=(1.0-u)*+h[m+(o+2<<3)>>3]+u*+h[m+(o+3<<3)>>3]}else{t=.5*r+ +h[m+(o+3<<3)>>3]*.5}h[q+8>>3]=(+h[m+(o+2<<3)>>3]*3.0- +h[q+16>>3]*2.0-t)/s;h[q>>3]=(+h[q+16>>3]+t- +h[m+(o+2<<3)>>3]*2.0)/(s*s);o=o+1|0}n=n+1|0}Ola(m)}}while(0);k=f;l=k;i=g;return l|0}function uL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;IU(90272);i=e;return 1}function vL(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;if((d|0)==0){i=b;return}do{if((c[d+8>>2]|0)!=0){if((c[d+32>>2]|0)!=1){e=5;break}Ola(c[d+8>>2]|0);c[d+8>>2]=0}else{e=5}}while(0);do{if((e|0)==5){if((c[d+8>>2]|0)==0){break}if((c[d+32>>2]|0)!=0){if((c[d+32>>2]|0)!=3){break}}Ola(c[d+8>>2]|0);c[d+8>>2]=0}}while(0);do{if((c[d+40>>2]|0)>>>0>0){if((c[d+36>>2]|0)==0){break}Ola(c[d+36>>2]|0);c[d+36>>2]=0}}while(0);if((c[d+4>>2]|0)!=0){Ola(c[d+4>>2]|0);c[d+4>>2]=0}if((c[d>>2]|0)!=0){Ola(c[d>>2]|0);c[d>>2]=0}if((c[d+96>>2]|0)!=0){Ola(c[d+96>>2]|0);c[d+96>>2]=0}wL(c[d+56>>2]|0);Ola(d);d=0;i=b;return}function wL(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=a;if((c|0)!=0){Ola(c);c=0}i=b;return}function xL(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=+e;f=+f;var g=0,j=0,k=0.0,l=0.0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;g=i;i=i+288|0;j=b;k=d;d=e;e=f;f=0.0;b=a;do{if((b|0)!=0){if((c[b+8>>2]|0)==0){break}if((c[b+36>>2]|0)==0){break}l=k;k=k- +h[b+48>>3];do{if(k>=0.0){if(!(d<1.7976931348623157e+308)){break}if(!(d==e)){break}if(!(+h[b+48>>3]>=d)){break}m=0.0;n=m;i=g;return+n}}while(0);if(!(k>=0.0)){break}a=c[b+8>>2]|0;o=c[b+12>>2]|0;p=c[b+16>>2]|0;q=(c[(c[b+36>>2]|0)+(j-1<<2)>>2]|0)-1|0;if((o|0)==1){f=+h[a+(q<<3)>>3];break}r=0;do{if((c[b+28>>2]|0)==3){s=+h[a>>3];t=+h[a+((fa(o-1|0,p)|0)<<3)>>3];u=t-s;do{if(d==e){if(!(l>=d)){break}v=(c[b+96>>2]|0)+((c[b+84>>2]|0)-1<<3)|0;if((c[b+24>>2]|0)==3){w=c[v>>2]|0}else{w=c[v+4>>2]|0}f=+h[a+((fa(w,p)|0)+q<<3)>>3];m=f;n=m;i=g;return+n}}while(0);do{if(d>e){if(!(l>=e)){break}if(!(+h[b+48>>3]<e)){break}f=+h[a+((fa(c[(c[b+96>>2]|0)+((c[b+84>>2]|0)-1<<3)>>2]|0,p)|0)+q<<3)>>3];m=f;n=m;i=g;return+n}}while(0);v=c[(c[b+96>>2]|0)+((c[b+84>>2]|0)-1<<3)>>2]|0;x=c[(c[b+96>>2]|0)+((c[b+84>>2]|0)-1<<3)+4>>2]|0;k=k- +h[b+88>>3];do{if(k<s){k=k+u}else{if(!(k>t)){break}k=k-u}}while(0);c[b+20>>2]=yL(a,o,p,c[b+20>>2]|0,k)|0;if((c[b+20>>2]|0)>>>0<v>>>0){k=+h[a+((fa(v,p)|0)<<3)>>3]}if(!((c[b+20>>2]|0)>>>0>=x>>>0)){break}if((c[b+84>>2]|0)==1){k=+h[a+((fa(v,p)|0)<<3)>>3];break}else{k=+h[a+((fa(x,p)|0)<<3)>>3];break}}else{if(k<+h[a>>3]){r=-1;break}if(!(k>+h[a+((fa(o-1|0,p)|0)<<3)>>3])){break}r=1;if((c[b+28>>2]|0)==3){break}if(!(d==e&d<1.7976931348623157e+308)){break}if(!(l>=d)){break}r=0}}while(0);if((r|0)==0){y=yL(a,o,p,c[b+20>>2]|0,k)|0;c[b+20>>2]=y;do{if((c[b+28>>2]|0)!=3){if(!(d==e&d<1.7976931348623157e+308)){break}if(!(l>=d)){break}if(k>=+h[a+((fa(o-1|0,p)|0)<<3)>>3]){y=o-1|0}f=+h[a+((fa(zL(b,y)|0,p)|0)+q<<3)>>3];m=f;n=m;i=g;return+n}}while(0);z=c[b+24>>2]|0;if((z|0)==3){if(k>=+h[a+((fa(y+1|0,p)|0)<<3)>>3]){y=y+1|0}f=+h[a+((fa(y,p)|0)+q<<3)>>3];break}else if((z|0)==1){l=+h[a+((fa(y,p)|0)<<3)>>3];u=+h[a+((fa(y+1|0,p)|0)<<3)>>3];t=+h[a+((fa(y,p)|0)+q<<3)>>3];s=+h[a+((fa(y+1|0,p)|0)+q<<3)>>3];if((AL(l,u)|0)!=0){f=s;break}else{f=t+(s-t)*(k-l)/(u-l);break}}else if((z|0)==2){if((c[b+56>>2]|0)==0){break}z=(fa(y,c[b+40>>2]|0)|0)+(j-1)|0;A=(c[b+56>>2]|0)+(z*24|0)|0;k=k- +h[a+((fa(y,p)|0)<<3)>>3];f=+h[a+((fa(y,p)|0)+q<<3)>>3];f=f+((+h[A>>3]*k+ +h[A+8>>3])*k+ +h[A+16>>3])*k;break}else{IU(90128);break}}else{A=c[b+28>>2]|0;if((A|0)==4){IU(90160);break}else if((A|0)==1){if((r|0)==1){B=+h[a+((fa(o-1|0,p)|0)+q<<3)>>3]}else{B=+h[a+(q<<3)>>3]}f=B;break}else if((A|0)==2){if((r|0)==1){C=o-2|0}else{C=0}z=C;l=+h[a+((fa(z,p)|0)<<3)>>3];u=+h[a+((fa(z,p)|0)+q<<3)>>3];if((c[b+24>>2]|0)!=2){t=+h[a+((fa(z+1|0,p)|0)<<3)>>3];s=+h[a+((fa(z+1|0,p)|0)+q<<3)>>3];if((AL(l,t)|0)!=0){f=s;break}else{f=u+(s-u)*(k-l)/(t-l);break}}if((c[b+56>>2]|0)==0){break}D=(fa(z,c[b+40>>2]|0)|0)+(j-1)|0;E=(c[b+56>>2]|0)+(D*24|0)|0;if((r|0)==1){t=+h[a+((fa(z+1|0,p)|0)<<3)>>3];s=+h[a+((fa(z+1|0,p)|0)+q<<3)>>3];f=t-l;f=(+h[E>>3]*3.0*f+ +h[E+8>>3]*2.0)*f+ +h[E+16>>3];f=s+f*(k-t);break}else{f=u+ +h[E+16>>3]*(k-l);break}}else if((A|0)==3){break}else{IU(90184);break}}}}while(0);m=f;n=m;i=g;return+n}function yL(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;var f=0,g=0,j=0.0,k=0,l=0,m=0,n=0;f=i;i=i+72|0;g=a;a=c;c=d;j=e;d=0;k=b-1|0;do{if(j<+h[g+((fa(c,a)|0)<<3)>>3]){k=c}else{b=c;if(j>=+h[g+((fa(c+1|0,a)|0)<<3)>>3]){d=b;break}l=b;m=l;i=f;return m|0}}while(0);while(1){n=d;if(!(k>>>0>(d+1|0)>>>0)){break}c=((n+k|0)>>>0)/2|0;b=c;if(j<+h[g+((fa(c,a)|0)<<3)>>3]){k=b;continue}else{d=b;continue}}l=n;m=l;i=f;return m|0}function zL(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0;d=i;i=i+64|0;e=a;a=b;b=a;if((e|0)==0){f=b;i=d;return f|0}if((c[e+8>>2]|0)==0){f=b;i=d;return f|0}g=c[e+8>>2]|0;j=c[e+16>>2]|0;k=a;while(1){if(!(k>>>0>0)){l=11;break}m=+h[g+((fa(k-1|0,j)|0)<<3)>>3];n=+h[g+((fa(k,j)|0)<<3)>>3];a=(c[e+24>>2]|0)==3;o=(AL(m,n)|0)!=0;if(a){if(!o){l=7;break}}else{if(!o){l=9;break}}k=k+ -1|0}if((l|0)==7){b=k-1|0;f=b;i=d;return f|0}else if((l|0)==9){b=k;f=b;i=d;return f|0}else if((l|0)==11){f=b;i=d;return f|0}return 0}function AL(a,b){a=+a;b=+b;var c=0,d=0.0,e=0.0,f=0.0,g=0;c=i;i=i+40|0;d=a;a=b;b=+U(+d);e=+U(+a);f=b>e?b:e;if(f<1.0e-10){f=1.0e-10}f=f*1.0e-10;g=+U(+(a-d))<f|0;i=c;return g|0}function BL(a){a=a|0;var b=0,d=0.0,e=0,f=0.0;b=i;i=i+32|0;d=0.0;e=a;if((e|0)==0){f=d;i=b;return+f}if((c[e+8>>2]|0)==0){f=d;i=b;return+f}d=+h[c[e+8>>2]>>3];f=d;i=b;return+f}function CL(a){a=a|0;var b=0,d=0.0,e=0,f=0.0;b=i;i=i+40|0;d=0.0;e=a;if((e|0)==0){f=d;i=b;return+f}if((c[e+8>>2]|0)==0){f=d;i=b;return+f}d=+h[(c[e+8>>2]|0)+((fa((c[e+12>>2]|0)-1|0,c[e+16>>2]|0)|0)<<3)>>3];f=d;i=b;return+f}



function RN(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;le[c[a+20>>2]&511](c[b+16>>2]|0);le[c[a+20>>2]&511](b)}i=d;return}function SN(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;le[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;le[c[(c[d+20>>2]|0)+8>>2]&511](a);a=e}i=b;return}function TN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;eO(f,g+20|0);while(1){d=fO(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}le[c[b+8>>2]&511](c[d+20>>2]|0)}jO(g);jO(g+132|0);jO(g+20|0);jO(g+40|0);jO(g+60|0);SN(g+80|0);SN(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;le[m&511](o);i=e;return}le[c[b+8>>2]&511](c[g+184>>2]|0);le[c[b+8>>2]&511](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;le[m&511](o);i=e;return}function UN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function VN(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function WN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((XN(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=ZN(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{rma(f|0,b|0,d|0)|0;j=_N(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=Ne[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=38;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==3){Oe[c[(c[h+144>>2]|0)+52>>2]&63](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}else if((d|0)==1|(d|0)==0){c[h+480>>2]=2}j=1;k=j;i=g;return k|0}function XN(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=UO()|0}if((a[e+236|0]|0)!=0){f=PN(e,107056)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function YN(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function ZN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;sma(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=oe[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;rma(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;le[c[e+20>>2]&511](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function _N(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((XN(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=Ne[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=38;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Oe[c[(c[g+144>>2]|0)+52>>2]&63](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function $N(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function aO(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Oe[c[(c[d+144>>2]|0)+52>>2]&63](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function bO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Ke[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];ie[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Ke[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function cO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[105280+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function dO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;rma((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=De[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=oe[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){rma(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function eO(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function fO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function gO(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=oe[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){tma(c[m>>2]|0,0,g|0)|0;g=hO(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=hO(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((iO(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=oe[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}tma(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=hO(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}le[c[(c[b+16>>2]|0)+8>>2]&511](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=oe[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){tma(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function hO(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function iO(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function jO(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}le[e&511](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}le[e&511](c[d>>2]|0);i=b;return}function kO(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[106864+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[106904+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=De[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=oe[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=oe[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}le[c[j+20>>2]&511](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;rma(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Ke[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function lO(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((re[((a[e+236|0]&255|0)!=0?35:36)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=TO(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function mO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=Ne[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=nO(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function nO(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=Ee[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=oO(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){ie[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);MN(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}v=gO(o,l+132|0,106936,36)|0;if((v|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[v+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((Ee[c[o+112>>2]&63](c[o+116>>2]|0,0,c[v+20>>2]|0,c[v+16>>2]|0,c[v+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((oe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}le[c[o+88>>2]&511](c[o+4>>2]|0);h=0;break};case 57:{w=oO(o,1,e,c[n>>2]|0)|0;if((w|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=tO(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 34:{c[o+344>>2]=sO(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=107040}else{x=(s|0)==32?107024:107048}if((uO(o+416|0,x)|0)==0){r=111;break a}if((vO(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=106944;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=106952;r=102;break};case 25:{c[o+332>>2]=106960;r=102;break};case 26:{c[o+332>>2]=106968;r=102;break};case 27:{c[o+332>>2]=106976;r=102;break};case 28:{c[o+332>>2]=106984;r=102;break};case 29:{c[o+332>>2]=107e3;r=102;break};case 6:{a[o+489|0]=0;c[o+316>>2]=gO(o,l+132|0,106936,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((Ne[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=pO(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}qO(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=pO(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}ie[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;MN(o+416|0);h=0;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=xO(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((wO(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((dO(o+416|0)|0)<<24>>24!=0)){r=145;break a}}v=o+428|0;z=c[v>>2]|0;c[v>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((dO(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;v=c[z>>2]|0;c[z>>2]=v+1;a[v]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;xe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);MN(o+416|0);h=0;break};case 30:{c[o+332>>2]=107008;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((wO(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((dO(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;v=c[u>>2]|0;c[u>>2]=v+1;a[v]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((dO(o+416|0)|0)<<24>>24!=0)){r=128;break a}}v=o+428|0;u=c[v>>2]|0;c[v>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;xe[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);MN(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=pO(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=106936}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((oe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=gO(o,l+132|0,106936,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 12:{if((a[l+128|0]|0)==0){break c}A=yO(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;u=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=u;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;Ce[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=u}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;Ce[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}u=pO(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=u;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;xe[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;Ce[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((re[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}u=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[u+16>>2];c[o+316>>2]=0;break c}v=pO(u,b,e,c[n>>2]|0)|0;if((v|0)==0){r=190;break a}c[o+316>>2]=gO(o,l,v,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}u=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(v|0)){c[l+92>>2]=c[u+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[u+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{u=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[u+16>>2];c[o+316>>2]=0;break c}v=pO(u,b,e,c[n>>2]|0)|0;if((v|0)==0){r=202;break a}c[o+316>>2]=gO(o,l+132|0,v,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}u=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(v|0)){c[l+92>>2]=c[u+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[u+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 58:{if((c[o+80>>2]|0)!=0){bO(o,b,e,c[n>>2]|0)}h=0;D=zO(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=pO(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 21:{if((Ne[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}u=pO(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=220;break a}qO(u);c[o+340>>2]=u;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}u=pO(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=225;break a}c[q>>2]=e;ie[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,u,c[o+340>>2]|0);h=0}}while(0);MN(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;ie[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);MN(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){u=o+12|0;if((c[o+468>>2]|0)==0){v=c[u>>2]|0;c[o+468>>2]=32;c[o+464>>2]=oe[v&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}v=c[u+4>>2]|0;u=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=De[v&63](u,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=De[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=BO(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=pO(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}u=gO(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((u|0)==0){r=279;break a}if((a[u+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((u|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Ke[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[u+32|0]|0)!=0){r=287;break a}if((c[u+4>>2]|0)!=0){F=CO(o,u,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[u+32|0]=1;E=(Ee[c[o+112>>2]&63](c[o+116>>2]|0,0,c[u+20>>2]|0,c[u+16>>2]|0,c[u+24>>2]|0)|0)!=0;a[u+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((oe[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=sO(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=oe[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;Ke[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 2:{r=75;break a;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((FO(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((EO(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((Ne[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=pO(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=BO(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=sO(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=DO(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;Ke[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=pO(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}qO(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}bO(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=Ne[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((Ee[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=w;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){w=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=gO(o,l+132|0,106936,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((Ee[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=w;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((oe[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=39;I=rO(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=40;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function oO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((ne[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=pO(n+440|0,p,b,s+(De[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=pO(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Oe[c[n+140>>2]&63](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}bO(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=pO(n+440|0,e,d,m+(De[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=TO(n,f)|0;MN(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){MN(n+440|0)}q=0;r=q;i=g;return r|0}function pO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((vO(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((dO(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function qO(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function rO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=IO(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((QO(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function sO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=pO(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=gO(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((RO(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function tO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((dO(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=pO(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=gO(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=gO(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((dO(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((dO(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=gO(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function uO(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((dO(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function vO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((dO(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){ie[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((dO(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function wO(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=oe[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=De[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function xO(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=SO(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((dO(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function yO(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((dO(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(Ne[c[b+20>>2]&63](b,e,f,j)|0){case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 6:case 9:{if((vO(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case 0:{r=49;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=pO(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=gO(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=yO(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(Ee[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 7:{r=28;break};case-4:{r=24;break a;break};case 10:{s=De[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=ZO(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((dO(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};case-1:{r=46;break a;break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((dO(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function zO(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=Ne[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){bO(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function AO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=zO(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=41;k=mO(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function BO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=oe[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=De[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=oe[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function CO(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=oe[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=Ne[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=nO(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=IO(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=42;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function DO(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=oe[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;HO(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function EO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){bO(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(De[c[a+32>>2]&63](a,b)|0)|0;k=pO(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=De[c[a+36>>2]&63](a,e)|0;e=pO(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){GO(e);Ke[c[g+64>>2]&15](c[g+4>>2]|0,k,e);MN(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function FO(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){bO(g,a,b,d)}h=1;j=h;i=f;return j|0}k=pO(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){GO(k);me[c[g+68>>2]&127](c[g+4>>2]|0,k);MN(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function GO(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function HO(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}HO(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function IO(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=Ne[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;D=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;E=De[c[e+32>>2]&63](e,D)|0;if((E|0)!=(c[C+8>>2]|0)){B=112;break a}if((kma(c[C+4>>2]|0,D,E)|0)!=0){B=112;break a}E=y+312|0;c[E>>2]=(c[E>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){E=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((E|0)==0){break}F=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[E]|0)==0){break}G=E;E=G+1|0;H=F;F=H+1|0;a[H]=a[G]|0}G=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}H=F;F=H+1|0;a[H]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}H=G;G=H+1|0;I=F;F=I+1|0;a[I]=a[H]|0}}}while(0);a[F]=0}}while(0);me[c[y+56>>2]&127](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}bO(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}E=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){me[c[y+104>>2]&127](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 9:{a[p]=re[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){Ke[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}bO(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=pO(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}E=gO(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((E|0)!=0){break}G=y;if((c[y+120>>2]|0)!=0){Ke[c[G+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[G+80>>2]|0)==0){break b}bO(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((E|0)==0){B=41;break a}if((a[E+34|0]|0)==0){B=43;break a}}if((a[E+32|0]|0)!=0){B=50;break a}if((c[E+28>>2]|0)!=0){B=52;break a}C=y;if((c[E+4>>2]|0)!=0){G=y;if((a[C+308|0]|0)!=0){J=CO(G,E,0)|0;if((J|0)!=0){B=60;break a}else{break b}}H=y;if((c[G+120>>2]|0)!=0){Ke[c[H+120>>2]&15](c[y+4>>2]|0,c[E>>2]|0,0);break b}if((c[H+80>>2]|0)==0){break b}bO(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}bO(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[E+32|0]=1;C=KO(y)|0;a[E+32|0]=0;if((C|0)==0){B=63;break a}if((Ee[c[y+112>>2]&63](c[y+116>>2]|0,C,c[E+20>>2]|0,c[E+16>>2]|0,c[E+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;H=1;c[t>>2]=pO(y+416|0,e,C,C+(De[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];K=LO(y,e,c[m>>2]|0,t,s)|0;if((K|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Ke[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);H=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}me[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);H=0}do{if((H&255|0)!=0){if((c[y+80>>2]|0)==0){break}bO(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);MN(y+416|0);while(1){if((c[s>>2]|0)==0){break}H=c[s>>2]|0;if((c[y+104>>2]|0)!=0){me[c[y+104>>2]&127](c[y+4>>2]|0,c[c[H>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[H+4>>2]=c[y+376>>2];c[y+376>>2]=H;c[(c[H>>2]|0)+4>>2]=c[H+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case 11:{if((EO(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 8:{H=y;do{if((c[y+72>>2]|0)!=0){le[c[H+72>>2]&511](c[y+4>>2]|0)}else{if((c[H+80>>2]|0)==0){break}bO(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);L=NO(y,e,n,g,h,j)|0;if((L|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{H=c[y+60>>2]|0;if((H|0)==0){if((c[y+80>>2]|0)==0){break b}bO(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Ke[H&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];ie[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Ke[H&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Ke[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}bO(y,e,c[m>>2]|0,c[n>>2]|0);break};case-2:{B=28;break a;break};case-4:{B=17;break a;break};case-1:{B=25;break a;break};case 1:case 2:{H=y;if((c[y+368>>2]|0)!=0){M=c[H+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{M=oe[c[H+12>>2]&127](48)|0;if((M|0)==0){B=72;break a}c[M+36>>2]=oe[c[y+12>>2]&127](32)|0;if((c[M+36>>2]|0)==0){B=74;break a}c[M+40>>2]=(c[M+36>>2]|0)+32}c[M+44>>2]=0;c[M>>2]=c[y+364>>2];c[y+364>>2]=M;c[M+16>>2]=0;c[M+20>>2]=0;c[M+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[M+8>>2]=De[c[e+32>>2]&63](e,c[M+4>>2]|0)|0;H=y+312|0;c[H>>2]=(c[H>>2]|0)+1;H=(c[M+4>>2]|0)+(c[M+8>>2]|0)|0;c[r>>2]=c[M+4>>2];c[q>>2]=c[M+36>>2];while(1){ie[c[e+60>>2]&31](e,r,H,q,(c[M+40>>2]|0)+ -1|0);N=(c[q>>2]|0)-(c[M+36>>2]|0)|0;if((c[r>>2]|0)==(H|0)){break}E=(c[M+40>>2]|0)-(c[M+36>>2]|0)<<1;C=De[c[y+16>>2]&63](c[M+36>>2]|0,E)|0;if((C|0)==0){B=80;break a}c[M+36>>2]=C;c[M+40>>2]=C+E;c[q>>2]=C+N}c[M+24>>2]=N;c[M+12>>2]=c[M+36>>2];a[c[q>>2]|0]=0;O=LO(y,e,c[m>>2]|0,M+12|0,M+44|0)|0;if((O|0)!=0){B=82;break a}H=y;do{if((c[y+52>>2]|0)!=0){Ke[c[H+52>>2]&15](c[y+4>>2]|0,c[M+12>>2]|0,c[y+392>>2]|0)}else{if((c[H+80>>2]|0)==0){break}bO(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);MN(y+416|0);break};case 0:{B=24;break a;break};case 13:{if((FO(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case 10:{H=De[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((H|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){E=c[C+60>>2]|0;G=c[y+4>>2]|0;I=ZO(H,u)|0;Ke[E&15](G,u,I);break b}if((c[C+80>>2]|0)==0){break b}bO(y,e,c[m>>2]|0,c[n>>2]|0);break};case-3:{B=6;break a;break};default:{if((c[y+80>>2]|0)==0){break b}bO(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Ke[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}bO(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=J;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){le[c[y+20>>2]&511](M);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=O;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=K;Q=P;i=l;return Q|0}else if((B|0)==107){P=MO(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=D;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=MO(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=L;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=43;P=L;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Ke[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];ie[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Ke[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}bO(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function JO(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=Ne[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=nO(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=IO(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=41;m=Ne[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=nO(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=39;k=IO(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function KO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((dO(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((dO(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);eO(e,b+60|0);a:while(1){k=fO(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((dO(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((dO(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((dO(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((dO(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){eO(e,b);b:while(1){b=fO(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((dO(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((dO(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((dO(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}



function vM(e,f,j,k,l){e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+136|0;n=m+72|0;o=m+80|0;p=m+88|0;q=m+96|0;r=m+104|0;s=m+112|0;t=m+120|0;u=m+128|0;v=e;e=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((e|0)==0){break}a:do{switch(j|0){case 2:{w=1;x=0;while(1){if((x|0)>=(k|0)){break a}$L(v,e,t,w)|0;b[f+(x<<1)>>1]=d[t]|0;x=x+1|0}break};case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,s,w)|0;b[f+(x<<1)>>1]=PL(s)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,s,w)|0;b[f+(x<<1)>>1]=b[s>>1]|0;x=x+1|0}}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,p,w)|0;b[f+(x<<1)>>1]=ML(p)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,p,w)|0;b[f+(x<<1)>>1]=c[p>>2];x=x+1|0}}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,o,w)|0;b[f+(x<<1)>>1]=~~+QL(o);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,o,w)|0;b[f+(x<<1)>>1]=~~+g[o>>2];x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,n,w)|0;b[f+(x<<1)>>1]=~~+RL(n);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,n,w)|0;b[f+(x<<1)>>1]=~~+h[n>>3];x=x+1|0}}break};case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,r,w)|0;b[f+(x<<1)>>1]=OL(r)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,r,w)|0;b[f+(x<<1)>>1]=b[r>>1]|0;x=x+1|0}}break};case 1:{w=1;x=0;while(1){if((x|0)>=(k|0)){break a}$L(v,e,u,w)|0;b[f+(x<<1)>>1]=a[u]|0;x=x+1|0}break};case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,q,w)|0;b[f+(x<<1)>>1]=NL(q)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,q,w)|0;b[f+(x<<1)>>1]=c[q>>2];x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(k,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function wM(e,f,j,k){e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+128|0;m=l+64|0;n=l+72|0;o=l+80|0;p=l+88|0;q=l+96|0;r=l+104|0;s=l+112|0;t=l+120|0;u=e;e=f;f=j;j=k;k=0;v=0;do{if((u|0)!=0){if((e|0)==0){break}if((c[u>>2]|0)==0){break}a:do{switch(f|0){case 2:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(t|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=d[t]|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(t|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=d[t]|0;w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(q|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=OL(q)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(q|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=b[q>>1]|0;w=w+1|0}}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(p|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=NL(p)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(p|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=c[p>>2];w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(o|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=ML(o)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(o|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=c[o>>2];w=w+1|0}}break};case 1:{v=1;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(s|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=a[s]|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(s|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=a[s]|0;w=w+1|0}}break};case 9:{v=8;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(m|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+RL(m);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(m|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+h[m>>3];w=w+1|0}}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(r|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=PL(r)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(r|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=b[r>>1]|0;w=w+1|0}}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}k=k+(ub(n|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+QL(n);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}k=k+(ub(n|0,v|0,1,c[u>>2]|0)|0)|0;b[e+(w<<1)>>1]=~~+g[n>>2];w=w+1|0}}break};default:{x=0;y=x;i=l;return y|0}}}while(0);k=fa(k,v)|0;x=k;y=x;i=l;return y|0}}while(0);x=0;y=x;i=l;return y|0}function xM(e,f,j,k,l){e=e|0;f=f|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;m=i;i=i+136|0;n=m+72|0;o=m+80|0;p=m+88|0;q=m+96|0;r=m+104|0;s=m+112|0;t=m+120|0;u=m+128|0;v=e;e=f;f=j;j=k;k=l;l=0;w=0;do{if((v|0)!=0){if((f|0)==0){break}if((e|0)==0){break}a:do{switch(j|0){case 6:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,q,w)|0;b[f+(x<<1)>>1]=NL(q)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,q,w)|0;b[f+(x<<1)>>1]=c[q>>2];x=x+1|0}}break};case 7:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,o,w)|0;b[f+(x<<1)>>1]=~~+QL(o);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,o,w)|0;b[f+(x<<1)>>1]=~~+g[o>>2];x=x+1|0}}break};case 9:{w=8;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,n,w)|0;b[f+(x<<1)>>1]=~~+RL(n);x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,n,w)|0;b[f+(x<<1)>>1]=~~+h[n>>3];x=x+1|0}}break};case 4:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,s,w)|0;b[f+(x<<1)>>1]=PL(s)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,s,w)|0;b[f+(x<<1)>>1]=b[s>>1]|0;x=x+1|0}}break};case 1:{w=1;x=0;while(1){if((x|0)>=(k|0)){break a}$L(v,e,u,w)|0;b[f+(x<<1)>>1]=a[u]|0;x=x+1|0}break};case 5:{w=4;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,p,w)|0;b[f+(x<<1)>>1]=ML(p)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,p,w)|0;b[f+(x<<1)>>1]=c[p>>2];x=x+1|0}}break};case 2:{w=1;x=0;while(1){if((x|0)>=(k|0)){break a}$L(v,e,t,w)|0;b[f+(x<<1)>>1]=d[t]|0;x=x+1|0}break};case 3:{w=2;x=0;if((c[v+20>>2]|0)!=0){while(1){if((x|0)>=(k|0)){break a}$L(v,e,r,w)|0;b[f+(x<<1)>>1]=OL(r)|0;x=x+1|0}}else{while(1){if((x|0)>=(k|0)){break a}$L(v,e,r,w)|0;b[f+(x<<1)>>1]=b[r>>1]|0;x=x+1|0}}break};default:{y=0;z=y;i=m;return z|0}}}while(0);l=fa(k,w)|0;y=l;z=y;i=m;return z|0}}while(0);y=0;z=y;i=m;return z|0}function yM(d,e,f,j){d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+128|0;l=k+64|0;m=k+72|0;n=k+80|0;o=k+88|0;p=k+96|0;q=k+104|0;r=k+112|0;s=k+120|0;t=d;d=e;e=f;f=j;j=0;u=0;do{if((t|0)!=0){if((d|0)==0){break}if((c[t>>2]|0)==0){break}a:do{switch(e|0){case 2:{u=1;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(s|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[s]|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(s|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[s]|0;v=v+1|0}}break};case 4:{u=2;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(q|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=PL(q)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(q|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=b[q>>1];v=v+1|0}}break};case 3:{u=2;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(p|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=OL(p)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(p|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=b[p>>1];v=v+1|0}}break};case 6:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(o|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=NL(o)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(o|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=c[o>>2];v=v+1|0}}break};case 7:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(m|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+QL(m);v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(m|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+g[m>>2];v=v+1|0}}break};case 9:{u=8;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(l|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+RL(l);v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(l|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+h[l>>3];v=v+1|0}}break};case 1:{u=1;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(r|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[r]|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(r|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[r]|0;v=v+1|0}}break};case 5:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(n|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=ML(n)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(n|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=c[n>>2];v=v+1|0}}break};default:{w=0;x=w;i=k;return x|0}}}while(0);j=fa(j,u)|0;w=j;x=w;i=k;return x|0}}while(0);w=0;x=w;i=k;return x|0}function zM(d,e,f,j,k){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+136|0;m=l+72|0;n=l+80|0;o=l+88|0;p=l+96|0;q=l+104|0;r=l+112|0;s=l+120|0;t=l+128|0;u=d;d=e;e=f;f=j;j=k;k=0;v=0;do{if((u|0)!=0){if((e|0)==0){break}if((d|0)==0){break}a:do{switch(f|0){case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,n,v)|0;a[e+w|0]=~~+QL(n);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,n,v)|0;a[e+w|0]=~~+g[n>>2];w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,o,v)|0;a[e+w|0]=ML(o)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,o,v)|0;a[e+w|0]=c[o>>2];w=w+1|0}}break};case 1:{v=1;w=0;while(1){if((w|0)>=(j|0)){break a}$L(u,d,t,v)|0;a[e+w|0]=a[t]|0;w=w+1|0}break};case 2:{v=1;w=0;while(1){if((w|0)>=(j|0)){break a}$L(u,d,s,v)|0;a[e+w|0]=a[s]|0;w=w+1|0}break};case 9:{v=8;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,m,v)|0;a[e+w|0]=~~+RL(m);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,m,v)|0;a[e+w|0]=~~+h[m>>3];w=w+1|0}}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,r,v)|0;a[e+w|0]=PL(r)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,r,v)|0;a[e+w|0]=b[r>>1];w=w+1|0}}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,p,v)|0;a[e+w|0]=NL(p)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,p,v)|0;a[e+w|0]=c[p>>2];w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,q,v)|0;a[e+w|0]=OL(q)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,q,v)|0;a[e+w|0]=b[q>>1];w=w+1|0}}break};default:{x=0;y=x;i=l;return y|0}}}while(0);k=fa(j,v)|0;x=k;y=x;i=l;return y|0}}while(0);x=0;y=x;i=l;return y|0}function AM(d,e,f,j){d=d|0;e=e|0;f=f|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;k=i;i=i+128|0;l=k+64|0;m=k+72|0;n=k+80|0;o=k+88|0;p=k+96|0;q=k+104|0;r=k+112|0;s=k+120|0;t=d;d=e;e=f;f=j;j=0;u=0;do{if((t|0)!=0){if((d|0)==0){break}if((c[t>>2]|0)==0){break}a:do{switch(e|0){case 4:{u=2;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(q|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=PL(q)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(q|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=b[q>>1];v=v+1|0}}break};case 7:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(m|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+QL(m);v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(m|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+g[m>>2];v=v+1|0}}break};case 2:{u=1;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(s|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[s]|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(s|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[s]|0;v=v+1|0}}break};case 5:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(n|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=ML(n)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(n|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=c[n>>2];v=v+1|0}}break};case 3:{u=2;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(p|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=OL(p)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(p|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=b[p>>1];v=v+1|0}}break};case 1:{u=1;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(r|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[r]|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(r|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=a[r]|0;v=v+1|0}}break};case 9:{u=8;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(l|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+RL(l);v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(l|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=~~+h[l>>3];v=v+1|0}}break};case 6:{u=4;v=0;if((c[t+20>>2]|0)!=0){while(1){if((v|0)>=(f|0)){break a}j=j+(ub(o|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=NL(o)|0;v=v+1|0}}else{while(1){if((v|0)>=(f|0)){break a}j=j+(ub(o|0,u|0,1,c[t>>2]|0)|0)|0;a[d+v|0]=c[o>>2];v=v+1|0}}break};default:{w=0;x=w;i=k;return x|0}}}while(0);j=fa(j,u)|0;w=j;x=w;i=k;return x|0}}while(0);w=0;x=w;i=k;return x|0}function BM(d,e,f,j,k){d=d|0;e=e|0;f=f|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;l=i;i=i+136|0;m=l+72|0;n=l+80|0;o=l+88|0;p=l+96|0;q=l+104|0;r=l+112|0;s=l+120|0;t=l+128|0;u=d;d=e;e=f;f=j;j=k;k=0;v=0;do{if((u|0)!=0){if((e|0)==0){break}if((d|0)==0){break}a:do{switch(f|0){case 2:{v=1;w=0;while(1){if((w|0)>=(j|0)){break a}$L(u,d,s,v)|0;a[e+w|0]=a[s]|0;w=w+1|0}break};case 9:{v=8;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,m,v)|0;a[e+w|0]=~~+RL(m);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,m,v)|0;a[e+w|0]=~~+h[m>>3];w=w+1|0}}break};case 5:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,o,v)|0;a[e+w|0]=ML(o)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,o,v)|0;a[e+w|0]=c[o>>2];w=w+1|0}}break};case 7:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,n,v)|0;a[e+w|0]=~~+QL(n);w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,n,v)|0;a[e+w|0]=~~+g[n>>2];w=w+1|0}}break};case 3:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,q,v)|0;a[e+w|0]=OL(q)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,q,v)|0;a[e+w|0]=b[q>>1];w=w+1|0}}break};case 6:{v=4;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,p,v)|0;a[e+w|0]=NL(p)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,p,v)|0;a[e+w|0]=c[p>>2];w=w+1|0}}break};case 1:{v=1;w=0;while(1){if((w|0)>=(j|0)){break a}$L(u,d,t,v)|0;a[e+w|0]=a[t]|0;w=w+1|0}break};case 4:{v=2;w=0;if((c[u+20>>2]|0)!=0){while(1){if((w|0)>=(j|0)){break a}$L(u,d,r,v)|0;a[e+w|0]=PL(r)|0;w=w+1|0}}else{while(1){if((w|0)>=(j|0)){break a}$L(u,d,r,v)|0;a[e+w|0]=b[r>>1];w=w+1|0}}break};default:{x=0;y=x;i=l;return y|0}}}while(0);k=fa(j,v)|0;x=k;y=x;i=l;return y|0}}while(0);x=0;y=x;i=l;return y|0}function CM(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+88|0;k=a;a=b;b=e;e=g;g=h;h=0;l=hM(b)|0;$c(c[k>>2]|0,fa(f,l)|0,1)|0;e=fa(l,e-1|0)|0;a:do{switch(d|0){case 14:{if((e|0)==0){h=h+(mM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(mM(k,a+(m<<3)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 10:{if((e|0)==0){h=h+(uM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(uM(k,a+(m<<1)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 15:{if((e|0)==0){h=h+(oM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(oM(k,a+(m<<3)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 7:{if((e|0)==0){h=h+(kM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(kM(k,a+(m<<2)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 12:{if((e|0)==0){h=h+(qM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(qM(k,a+(m<<2)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 8:{if((e|0)==0){h=h+(yM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(yM(k,a+m|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 9:{if((e|0)==0){h=h+(AM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(AM(k,a+m|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 13:{if((e|0)==0){h=h+(sM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(sM(k,a+(m<<2)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 11:{if((e|0)==0){h=h+(wM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(wM(k,a+(m<<1)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};case 6:{if((e|0)==0){h=h+(iM(k,a,b,g)|0)|0;break a}m=0;while(1){if((m|0)>=(g|0)){break a}h=h+(iM(k,a+(m<<3)|0,b,1)|0)|0;$c(c[k>>2]|0,e|0,1)|0;m=m+1|0}break};default:{n=0;o=n;i=j;return o|0}}}while(0);n=h;o=n;i=j;return o|0}function DM(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+232|0;l=k+96|0;m=a;a=b;b=d;d=e;e=f;f=g;g=h;h=j;j=0;n=l+0|0;o=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));do{if((m|0)!=0){if((b|0)==0){break}if((c[m>>2]|0)==0){break}g=g+ -1|0;mN(l,a)|0;UL(m,l,e,f)|0;a:do{switch(d|0){case 9:{n=b;if((g|0)==0){j=j+(BM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(BM(m,l,n+p|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 6:{n=b;if((g|0)==0){j=j+(jM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(jM(m,l,n+(p<<3)|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 15:{n=b;if((g|0)==0){j=j+(pM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(pM(m,l,n+(p<<3)|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 13:{n=b;if((g|0)==0){j=j+(tM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(tM(m,l,n+(p<<2)|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 14:{n=b;if((g|0)==0){j=j+(nM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(nM(m,l,n+(p<<3)|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 10:{n=b;if((g|0)==0){j=j+(vM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(vM(m,l,n+(p<<1)|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 12:{n=b;if((g|0)==0){j=j+(rM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(rM(m,l,n+(p<<2)|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 11:{n=b;if((g|0)==0){j=j+(xM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(xM(m,l,n+(p<<1)|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 8:{n=b;if((g|0)==0){j=j+(zM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(zM(m,l,n+p|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};case 7:{n=b;if((g|0)==0){j=j+(lM(m,l,n,e,h)|0)|0;break a}p=0;while(1){if((p|0)>=(h|0)){break a}j=j+(lM(m,l,n+(p<<2)|0,e,1)|0)|0;UL(m,l,e,g)|0;p=p+1|0}break};default:{}}}while(0);lN(l)|0;q=j;r=q;i=k;return r|0}}while(0);q=0;r=q;i=k;return r|0}function EM(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0;j=i;i=i+160|0;k=j+104|0;l=j+112|0;m=d;d=e;e=f;c[l>>2]=c[g>>2];g=0;f=0;n=0;o=0;c[k>>2]=0;p=-1;q=e;e=q+1|0;r=a[q]|0;a:while(1){if((g|0)==7){break}if((r<<24>>24|0)==0){g=7}switch(g|0){case 2:{if(($d(r&255|0)|0)!=0){f=(f*10|0)+((r<<24>>24)-48)|0;q=e;e=q+1|0;r=a[q]|0;continue a}if((r<<24>>24|0)==42){q=l;s=c[q>>2]|0;t=c[s>>2]|0;c[q>>2]=s+4;f=t;t=e;e=t+1|0;r=a[t]|0;g=3;continue a}else{g=3;continue a}break};case 3:{if((r<<24>>24|0)==46){g=4;t=e;e=t+1|0;r=a[t]|0;continue a}else{g=5;continue a}break};case 4:{if(($d(r&255|0)|0)!=0){if((p|0)<0){p=0}p=(p*10|0)+((r<<24>>24)-48)|0;t=e;e=t+1|0;r=a[t]|0;continue a}else{if((r<<24>>24|0)==42){t=l;s=c[t>>2]|0;q=c[s>>2]|0;c[t>>2]=s+4;p=q;q=e;e=q+1|0;r=a[q]|0;g=5;continue a}else{g=5;continue a}}break};case 5:{q=r<<24>>24;do{if((q|0)==76){n=3;s=e;e=s+1|0;r=a[s]|0}else if((q|0)==104){n=1;s=e;e=s+1|0;r=a[s]|0}else if((q|0)==108){n=2;s=e;e=s+1|0;r=a[s]|0;if((r<<24>>24|0)!=108){break}n=4;s=e;e=s+1|0;r=a[s]|0}}while(0);g=6;continue a;break};case 0:{if((r<<24>>24|0)==37){g=1}else{XM(m,k,d,r)}q=e;e=q+1|0;r=a[q]|0;continue a;break};case 1:{switch(r<<24>>24|0){case 48:{o=o|16;q=e;e=q+1|0;r=a[q]|0;continue a;break};case 43:{o=o|2;q=e;e=q+1|0;r=a[q]|0;continue a;break};case 45:{o=o|1;q=e;e=q+1|0;r=a[q]|0;continue a;break};case 32:{o=o|4;q=e;e=q+1|0;r=a[q]|0;continue a;break};case 35:{o=o|8;q=e;e=q+1|0;r=a[q]|0;continue a;break};default:{g=2;continue a}}break};case 6:{b:do{switch(r<<24>>24|0){case 99:{q=l;s=c[q>>2]|0;t=c[s>>2]|0;c[q>>2]=s+4;XM(m,k,d,t&255);break};case 37:{XM(m,k,d,r);break};case 120:{u=43;break};case 111:{o=o|64;t=l;s=c[t>>2]|0;q=c[s>>2]|0;c[t>>2]=s+4;v=q;YM(m,k,d,v,8,f,p,o);break};case 119:{q=e;e=q+1|0;r=a[q]|0;break};case 88:{o=o|32;u=43;break};case 117:{o=o|64;q=l;s=c[q>>2]|0;t=c[s>>2]|0;c[q>>2]=s+4;v=t;YM(m,k,d,v,10,f,p,o);break};case 69:{o=o|32;u=46;break};case 102:{t=l;s=c[t>>2]|0;w=+h[s>>3];c[t>>2]=s+8;x=w;ZM(m,k,d,x,f,p,o);break};case 105:case 100:{s=l;t=c[s>>2]|0;q=c[t>>2]|0;c[s>>2]=t+4;v=q;YM(m,k,d,v,10,f,p,o);break};case 115:{q=l;t=c[q>>2]|0;s=c[t>>2]|0;c[q>>2]=t+4;y=s;y=(y|0)!=0?s:93288;if((p|0)==-1){p=pma(y|0)|0}do{if((f|0)>0){if((p|0)<0){break}if((f|0)<=(p|0)){break}p=f}}while(0);_M(m,k,d,y,o,f,p);break};case 110:{if((n|0)==1){s=l;t=c[s>>2]|0;q=c[t>>2]|0;c[s>>2]=t+4;b[q>>1]=c[k>>2];break b}if((n|0)==2){q=l;t=c[q>>2]|0;s=c[t>>2]|0;c[q>>2]=t+4;c[s>>2]=c[k>>2];break b}s=l;t=c[s>>2]|0;q=c[t>>2]|0;c[s>>2]=t+4;if((n|0)==4){c[q>>2]=c[k>>2];break b}else{c[q>>2]=c[k>>2];break b}break};case 112:{q=l;t=c[q>>2]|0;s=c[t>>2]|0;c[q>>2]=t+4;y=s;YM(m,k,d,y,16,f,p,o);break};case 71:{o=o|32;u=48;break};case 101:{u=46;break};case 103:{u=48;break};default:{}}}while(0);if((u|0)==43){u=0;o=o|64;s=l;t=c[s>>2]|0;q=c[t>>2]|0;c[s>>2]=t+4;v=q;YM(m,k,d,v,16,f,p,o)}else if((u|0)==46){u=0;q=l;t=c[q>>2]|0;w=+h[t>>3];c[q>>2]=t+8;x=w;ZM(m,k,d,x,f,p,o)}else if((u|0)==48){u=0;t=l;q=c[t>>2]|0;w=+h[q>>3];c[t>>2]=q+8;x=w;ZM(m,k,d,x,f,p,o)}q=e;e=q+1|0;r=a[q]|0;g=0;f=0;n=0;o=0;p=-1;continue a;break};default:{continue a}}}if((d|0)==0){z=c[k>>2]|0;i=j;return z|0}if((c[k>>2]|0)>>>0<(d-1|0)>>>0){a[m+(c[k>>2]|0)|0]=0;z=c[k>>2]|0;i=j;return z|0}if(!(d>>>0>0)){z=c[k>>2]|0;i=j;return z|0}a[m+(d-1)|0]=0;z=c[k>>2]|0;i=j;return z|0}function FM(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+48|0;g=f+32|0;c[g>>2]=e;e=eM(a,b,d,g)|0;i=f;return e|0}function GM(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+32|0;e=0;if((c|0)!=256){f=e;i=d;return f|0}e=HM(a,b)|0;f=e;i=d;return f|0}function HM(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+24|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=d;d=e;e=0;b[l>>1]=0;p=0;e=oc(o|0,92680)|0;if((e|0)==0){q=0;r=q;i=f;return r|0}p=Nla(44)|0;if((p|0)==0){dd(e|0)|0;q=0;r=q;i=f;return r|0}c[p>>2]=0;c[p+4>>2]=0;c[p+8>>2]=0;c[p+12>>2]=0;c[p+16>>2]=0;c[p+20>>2]=0;c[p+24>>2]=0;c[p+28>>2]=0;c[p+32>>2]=0;c[n>>2]=yc(0)|0;c[p>>2]=e;c[k>>2]=o;c[p+12>>2]=fM(92552,k)|0;c[p+24>>2]=1;c[p+20>>2]=0;c[p+4>>2]=Pla(1,128)|0;c[p+8>>2]=Pla(1,16)|0;k=(c[p+4>>2]|0)+0|0;o=k+128|0;do{a[k]=32;k=k+1|0}while((k|0)<(o|0));k=c[p+4>>2]|0;if((d|0)==0){o=Qb(n|0)|0;c[j>>2]=92760;c[j+4>>2]=1;c[j+8>>2]=5;c[j+12>>2]=2;c[j+16>>2]=o;s=FM(k,116,92688,j)|0;a[(c[p+4>>2]|0)+115|0]=0}else{c[h>>2]=d;s=FM(k,116,92552,h)|0}a[(c[p+4>>2]|0)+s|0]=32;FM(c[p+8>>2]|0,15,92768,g)|0;c[p+16>>2]=256;b[l>>1]=19785;b[m>>1]=256;s=xc(c[p+4>>2]|0,1,116,c[p>>2]|0)|0;s=xc(c[p+8>>2]|0,1,8,c[p>>2]|0)|0;s=xc(m|0,2,1,c[p>>2]|0)|0;s=xc(l|0,2,1,c[p>>2]|0)|0;q=p;r=q;i=f;return r|0}function IM(d,e){d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=d;d=e;e=0;o=0;p=0;do{if((d&1|0)==0){e=oc(n|0,92448)|0;if((e|0)!=0){break}q=0;r=q;i=f;return r|0}else{s=n;if((d&1|0)!=1){o=GM(s,0,d&-2)|0;q=o;r=q;i=f;return r|0}e=oc(s|0,92456)|0;if((e|0)!=0){break}o=GM(n,0,d&-2)|0;q=o;r=q;i=f;return r|0}}while(0);o=Nla(44)|0;if(0==(o|0)){TL(92464,k);dd(e|0)|0;q=0;r=q;i=f;return r|0}c[o>>2]=e;c[o+4>>2]=Pla(128,1)|0;c[o+8>>2]=Pla(8,1)|0;c[o+12>>2]=0;c[o+20>>2]=0;c[o+16>>2]=0;p=p+(ub(c[o+4>>2]|0,1,116,e|0)|0)|0;a[(c[o+4>>2]|0)+116|0]=0;p=p+(ub(c[o+8>>2]|0,1,8,e|0)|0)|0;p=p+((ub(m|0,2,1,e|0)|0)<<1)|0;p=p+(ub(l|0,1,2,e|0)|0)|0;a:do{if(128==(p|0)){c[o+20>>2]=-1;do{if((b[l>>1]|0)==19785){c[o+20>>2]=0}else{if((b[l>>1]|0)!=18765){break}c[o+20>>2]=1;OL(m)|0}}while(0);c[o+16>>2]=b[m>>1]|0;if((c[o+16>>2]|0)==256){t=17}else{if((c[o+16>>2]|0)==512){t=17}}do{if((t|0)==17){if(!(-1!=(c[o+20>>2]|0))){break}c[o+28>>2]=Ab(c[o>>2]|0)|0;c[o+32>>2]=0;break a}}while(0);c[o+16>>2]=0}}while(0);do{if(0==(c[o+16>>2]|0)){if(0!=(c[o+4>>2]|0)){Ola(c[o+4>>2]|0)}if(0!=(c[o+8>>2]|0)){Ola(c[o+8>>2]|0)}c[o+4>>2]=0;c[o+8>>2]=0;c[o>>2]=e;c[o+16>>2]=16;c[o+20>>2]=0;c[o+24>>2]=d;c[o+28>>2]=0;c[o+32>>2]=0;JM(o)|0;t=KM(o)|0;if(0==(t|0)){c[j>>2]=n;TL(92512,j);LM(o)|0;o=0;break}else{MM(t);JM(o)|0;break}}}while(0);if(0==(o|0)){q=o;r=q;i=f;return r|0}c[h>>2]=n;c[o+12>>2]=fM(92552,h)|0;c[o+24>>2]=d;if((c[o+16>>2]|0)==512){dd(c[o>>2]|0)|0;c[o>>2]=0;LM(o)|0;o=0;c[g>>2]=n;TL(92560,g)}q=o;r=q;i=f;return r|0}function JM(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;a=c[d+16>>2]|0;if((a|0)==512){c[d+32>>2]=0}else if((a|0)==256){$c(c[d>>2]|0,128,0)|0}else if((a|0)==16){$c(c[d>>2]|0,0,0)|0}else{e=-1;f=e;i=b;return f|0}e=0;f=e;i=b;return f|0}function KM(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;i=i+88|0;e=b+16|0;f=b+80|0;g=a;a=0;do{if((g|0)!=0){if((c[g>>2]|0)==0){break}h=NM()|0;a=h;if(0==(h|0)){j=0;k=j;i=b;return k|0}c[(c[a+52>>2]|0)+20>>2]=g;h=Ab(c[g>>2]|0)|0;c[(c[a+52>>2]|0)+12>>2]=h;h=ub(e|0,4,1,c[g>>2]|0)|0;if((h|0)==0){Ola(a);j=0;k=j;i=b;return k|0}c[f>>2]=16909060;do{if((c[e>>2]|0)<0|(c[e>>2]|0)>4052){if((ML(e)|0)<=4052){break}MM(a);j=0;k=j;i=b;return k|0}}while(0);l=~~+T(+(+(c[e>>2]|0)/1.0e3));c[e>>2]=(c[e>>2]|0)-(l*1e3|0);m=~~+T(+(+(c[e>>2]|0)/100.0));c[e>>2]=(c[e>>2]|0)-(m*100|0);n=~~+T(+(+(c[e>>2]|0)/10.0));c[e>>2]=(c[e>>2]|0)-(n*10|0);o=~~+T(+(+(c[e>>2]|0)));p=l;if((p|0)==1){c[g+20>>2]=(d[f]|0|0)!=1}else if((p|0)==0){c[g+20>>2]=(d[f]|0|0)!=4}else{MM(a);j=0;k=j;i=b;return k|0}if(0!=(m|0)){MM(a);j=0;k=j;i=b;return k|0}switch(n|0){case 5:{c[a+8>>2]=2;break};case 4:{c[a+8>>2]=4;break};case 3:{c[a+8>>2]=3;break};case 2:{c[a+8>>2]=5;break};case 1:{c[a+8>>2]=7;break};case 0:{c[a+8>>2]=9;break};default:{MM(a);j=0;k=j;i=b;return k|0}}n=o;if((n|0)==0){c[a+16>>2]=6}else if((n|0)==2){c[a+16>>2]=5}else if((n|0)==1){c[a+16>>2]=4}else{MM(a);j=0;k=j;i=b;return k|0}c[a+4>>2]=2;c[a+32>>2]=Nla(8)|0;if(0==(c[a+32>>2]|0)){MM(a);j=0;k=j;i=b;return k|0}h=ub(e|0,4,1,c[g>>2]|0)|0;if((c[g+20>>2]|0)!=0){ML(e)|0}c[c[a+32>>2]>>2]=c[e>>2];if((h|0)==0){MM(a);j=0;k=j;i=b;return k|0}h=ub(e|0,4,1,c[g>>2]|0)|0;if((c[g+20>>2]|0)!=0){ML(e)|0}c[(c[a+32>>2]|0)+4>>2]=c[e>>2];n=a;if((h|0)==0){MM(n);j=0;k=j;i=b;return k|0}h=ub(n+20|0,4,1,c[g>>2]|0)|0;if((h|0)==0){MM(a);j=0;k=j;i=b;return k|0}h=ub(e|0,4,1,c[g>>2]|0)|0;if((h|0)==0){MM(a);j=0;k=j;i=b;return k|0}if((c[g+20>>2]|0)!=0){ML(e)|0}if((c[e>>2]|0)<1){MM(a);j=0;k=j;i=b;return k|0}c[a+36>>2]=Nla(c[e>>2]|0)|0;n=a;if(0==(c[a+36>>2]|0)){MM(n);j=0;k=j;i=b;return k|0}h=ub(c[n+36>>2]|0,1,c[e>>2]|0,c[g>>2]|0)|0;if((h|0)==0){MM(a);j=0;k=j;i=b;return k|0}n=Ab(c[g>>2]|0)|0;c[(c[a+52>>2]|0)+16>>2]=n;n=fa(c[c[a+32>>2]>>2]|0,c[(c[a+32>>2]|0)+4>>2]|0)|0;o=fa(n,hM(c[a+8>>2]|0)|0)|0;if((c[a+20>>2]|0)!=0){o=o<<1}$c(c[g>>2]|0,o|0,1)|0;j=a;k=j;i=b;return k|0}}while(0);j=0;k=j;i=b;return k|0}function LM(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;if(0==(d|0)){i=b;return 0}if((c[d>>2]|0)!=0){dd(c[d>>2]|0)|0}if((c[d+4>>2]|0)!=0){Ola(c[d+4>>2]|0)}if((c[d+8>>2]|0)!=0){Ola(c[d+8>>2]|0)}if((c[d+12>>2]|0)!=0){Ola(c[d+12>>2]|0)}Ola(d);i=b;return 0}function MM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+80|0;d=a;a=0;if((d|0)==0){i=b;return}if((c[d+32>>2]|0)!=0){a=1;e=0;while(1){if(!(e>>>0<(c[d+4>>2]|0)>>>0)){break}a=fa(a,c[(c[d+32>>2]|0)+(e<<2)>>2]|0)|0;e=e+1|0}Ola(c[d+32>>2]|0)}if((c[d+36>>2]|0)!=0){Ola(c[d+36>>2]|0)}a:do{if((c[d+40>>2]|0)!=0){b:do{switch(c[d+16>>2]|0){case 4:case 9:case 8:case 11:case 10:case 13:case 12:case 15:case 14:case 7:case 6:{if((c[d+44>>2]|0)!=0){break a}if(0==(c[d+40>>2]|0)){break a}f=c[d+40>>2]|0;if((c[d+20>>2]|0)!=0){g=f;Ola(c[g>>2]|0);Ola(c[g+4>>2]|0);Ola(g);break a}else{Ola(f);break a}break};case 2:{if((c[d+44>>2]|0)!=0){break b}if(0==(c[d+40>>2]|0)){break b}f=c[d+40>>2]|0;g=c[(c[d+52>>2]|0)+24>>2]|0;e=0;while(1){if(!(e>>>0<(fa(a,g)|0)>>>0)){break}MM(c[f+(e<<2)>>2]|0);e=e+1|0}Ola(c[d+40>>2]|0);break a;break};case 1:{break};case 5:{if((c[d+44>>2]|0)!=0){break a}f=c[d+40>>2]|0;if((c[f+4>>2]|0)!=0){Ola(c[f+4>>2]|0)}if((c[f+12>>2]|0)!=0){Ola(c[f+12>>2]|0)}do{if((c[d+20>>2]|0)!=0){if(0==(c[f+24>>2]|0)){h=31;break}g=c[f+24>>2]|0;Ola(c[g>>2]|0);Ola(c[g+4>>2]|0);Ola(g)}else{h=31}}while(0);do{if((h|0)==31){if((c[f+24>>2]|0)==0){break}Ola(c[f+24>>2]|0)}}while(0);Ola(f);break a;break};default:{break a}}}while(0);if((c[d+44>>2]|0)!=0){break}if(0==(c[d+40>>2]|0)){break}g=c[d+40>>2]|0;e=0;while(1){if(!(e>>>0<a>>>0)){break}MM(c[g+(e<<2)>>2]|0);e=e+1|0}Ola(c[d+40>>2]|0)}}while(0);if(0!=(c[d+52>>2]|0)){if((c[d+48>>2]|0)==1){lN(c[(c[d+52>>2]|0)+32>>2]|0)|0;Ola(c[(c[d+52>>2]|0)+32>>2]|0)}do{if(0!=(c[(c[d+52>>2]|0)+28>>2]|0)){if(!((c[(c[d+52>>2]|0)+24>>2]|0)>>>0>0)){break}e=0;while(1){if(!(e>>>0<(c[(c[d+52>>2]|0)+24>>2]|0)>>>0)){break}if(0!=(c[(c[(c[d+52>>2]|0)+28>>2]|0)+(e<<2)>>2]|0)){Ola(c[(c[(c[d+52>>2]|0)+28>>2]|0)+(e<<2)>>2]|0)}e=e+1|0}Ola(c[(c[d+52>>2]|0)+28>>2]|0)}}while(0);Ola(c[d+52>>2]|0);c[d+52>>2]=0}Ola(d);i=b;return}function NM(){var a=0,b=0,d=0,e=0;a=i;i=i+8|0;b=Nla(56)|0;if(0==(b|0)){d=b;i=a;return d|0}c[b>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;c[b+24>>2]=0;c[b+28>>2]=0;c[b+32>>2]=0;c[b+36>>2]=0;c[b+40>>2]=0;c[b+44>>2]=0;c[b+48>>2]=0;c[b+52>>2]=Nla(36)|0;e=b;if(0==(c[b+52>>2]|0)){Ola(e);b=0;d=b;i=a;return d|0}else{c[c[e+52>>2]>>2]=0;c[(c[b+52>>2]|0)+4>>2]=0;c[(c[b+52>>2]|0)+8>>2]=-1;c[(c[b+52>>2]|0)+20>>2]=0;c[(c[b+52>>2]|0)+12>>2]=0;c[(c[b+52>>2]|0)+16>>2]=0;c[(c[b+52>>2]|0)+28>>2]=0;c[(c[b+52>>2]|0)+24>>2]=0;c[(c[b+52>>2]|0)+32>>2]=0;d=b;i=a;return d|0}return 0}function OM(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+64|0;j=a;a=b;b=d;d=e;e=f;f=g;g=0;if(!(((c[a+16>>2]|0)+ -6|0)>>>0<10)){k=-1;l=k;i=h;return l|0}m=c[j+16>>2]|0;if((m|0)==16){g=QM(j,a,b,d,e,f)|0}else if((m|0)==512){g=1}else if((m|0)==256){g=PM(j,a,b,d,e,f)|0}k=g;l=k;i=h;return l|0}function PM(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+168|0;j=h+88|0;k=h+96|0;l=a;a=b;b=d;d=e;e=f;f=g;g=0;m=1;n=0;if((c[l+16>>2]|0)==16){o=-1;p=o;i=h;return p|0}$c(c[l>>2]|0,c[(c[a+52>>2]|0)+16>>2]|0,0)|0;do{if((c[a+48>>2]|0)==0){ub(j|0,4,2,c[l>>2]|0)|0;if((c[l+20>>2]|0)!=0){ML(j)|0;ML(j+4|0)|0}c[a+8>>2]=c[j>>2]&255;if((c[j>>2]&-65536|0)!=0){$c(c[l>>2]|0,-4,1)|0;n=4+(c[j>>2]>>16)|0;break}else{n=8+(c[j+4>>2]|0)|0;break}}else{if((c[a+48>>2]|0)!=1){break}c[(c[(c[a+52>>2]|0)+32>>2]|0)+4>>2]=0;g=mN(k,c[(c[a+52>>2]|0)+32>>2]|0)|0;_L(l,k,j)|0;if((c[l+20>>2]|0)!=0){ML(j)|0;ML(j+4|0)|0}c[a+8>>2]=c[j>>2]&255;if((c[j>>2]&-65536|0)!=0){n=4+(c[j>>2]>>16)|0;break}_L(l,k,j+4|0)|0;if((c[l+20>>2]|0)!=0){ML(j+4|0)|0}n=8+(c[j+4>>2]|0)|0}}while(0);if(((n|0)%8|0|0)!=0){n=n+(8-((n|0)%8|0))|0}q=0;while(1){if((q|0)>=(c[a+4>>2]|0)){break}m=fa(m,c[(c[a+32>>2]|0)+(q<<2)>>2]|0)|0;q=q+1|0}do{if(((fa(e,f-1|0)|0)+d+1|0)>(m|0)){g=1}else{q=a;if((c[a+48>>2]|0)==0){if((c[q+20>>2]|0)==0){CM(l,b,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;break}r=b;CM(l,c[r>>2]|0,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;$c(c[l>>2]|0,(c[(c[a+52>>2]|0)+16>>2]|0)+n|0,0)|0;ub(j|0,4,2,c[l>>2]|0)|0;if((c[l+20>>2]|0)!=0){ML(j)|0;ML(j+4|0)|0}c[a+8>>2]=c[j>>2]&255;if((c[j>>2]&-65536|0)!=0){$c(c[l>>2]|0,-4,1)|0}CM(l,c[r+4>>2]|0,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;break}if((c[q+48>>2]|0)!=1){break}if((c[a+20>>2]|0)==0){DM(l,k,b,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;lN(k)|0;break}q=b;DM(l,k,c[q>>2]|0,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;$c(c[l>>2]|0,c[(c[a+52>>2]|0)+16>>2]|0,0)|0;lN(k)|0;g=mN(k,c[(c[a+52>>2]|0)+32>>2]|0)|0;SL(l,k,n)|0;c[k+4>>2]=0;_L(l,k,j)|0;if((c[l+20>>2]|0)!=0){ML(j)|0}c[a+8>>2]=c[j>>2]&255;if((c[j>>2]&-65536|0)==0){SL(l,k,4)|0}DM(l,k,c[q+4>>2]|0,c[a+16>>2]|0,c[a+8>>2]|0,d,e,f)|0;lN(k)|0}}while(0);switch(c[a+16>>2]|0){case 12:{c[a+8>>2]=5;c[a+12>>2]=4;break};case 13:{c[a+8>>2]=6;c[a+12>>2]=4;break};case 10:{c[a+8>>2]=3;c[a+12>>2]=2;break};case 6:{c[a+8>>2]=9;c[a+12>>2]=8;break};case 11:{c[a+8>>2]=4;c[a+12>>2]=2;break};case 8:{c[a+8>>2]=1;c[a+12>>2]=1;break};case 9:{c[a+8>>2]=2;c[a+12>>2]=1;break};case 7:{c[a+8>>2]=7;c[a+12>>2]=4;break};case 14:{c[a+8>>2]=12;c[a+12>>2]=8;break};case 15:{c[a+8>>2]=13;c[a+12>>2]=8;break};default:{}}o=g;p=o;i=h;return p|0}function QM(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+104|0;j=a;a=b;b=d;d=e;e=f;f=g;g=1;k=0;l=0;$c(c[j>>2]|0,c[(c[a+52>>2]|0)+16>>2]|0,0)|0;switch(c[a+8>>2]|0){case 5:{l=12;break};case 9:{l=6;break};case 7:{l=7;break};case 4:{l=11;break};case 3:{l=10;break};case 2:{l=9;break};default:{m=1;n=m;i=h;return n|0}}c[a+12>>2]=hM(c[a+8>>2]|0)|0;o=0;while(1){if(!(o>>>0<(c[a+4>>2]|0)>>>0)){break}g=fa(g,c[(c[a+32>>2]|0)+(o<<2)>>2]|0)|0;o=o+1|0}if(((fa(e,f-1|0)|0)+d+1|0)>>>0>g>>>0){m=1;n=m;i=h;return n|0}if((c[a+20>>2]|0)!=0){o=b;p=fa(g,c[a+12>>2]|0)|0;CM(j,c[o>>2]|0,l,c[a+8>>2]|0,d,e,f)|0;$c(c[j>>2]|0,(c[(c[a+52>>2]|0)+16>>2]|0)+p|0,0)|0;CM(j,c[o+4>>2]|0,l,c[a+8>>2]|0,d,e,f)|0}else{CM(j,b,l,c[a+8>>2]|0,d,e,f)|0}m=k;n=m;i=h;return n|0}function RM(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+24|0;d=a;a=0;if((d|0)==0){e=0;f=e;i=b;return f|0}g=c[d+16>>2]|0;if((g|0)==256){a=SM(d)|0}else if((g|0)==16){a=KM(d)|0}e=a;f=e;i=b;return f|0}function SM(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+64|0;l=i;i=i+128|0;m=b;b=0;if((m|0)==0){n=0;o=n;i=d;return o|0}p=Ab(c[m>>2]|0)|0;q=ub(h|0,4,1,c[m>>2]|0)|0;if((q|0)==0){n=0;o=n;i=d;return o|0}q=ub(j|0,4,1,c[m>>2]|0)|0;if((c[m+20>>2]|0)!=0){ML(h)|0;ML(j)|0}r=c[h>>2]|0;do{if((r|0)==14){h=0;b=NM()|0;c[(c[b+52>>2]|0)+12>>2]=p;c[(c[b+52>>2]|0)+20>>2]=m;h=h+(ub(l|0,4,6,c[m>>2]|0)|0)|0;if((c[m+20>>2]|0)!=0){NL(l)|0;NL(l+4|0)|0;NL(l+8|0)|0;NL(l+12|0)|0;NL(l+16|0)|0;NL(l+20|0)|0}do{if((c[l>>2]|0)==6){s=c[l+8>>2]|0;c[b+16>>2]=s&255;c[b+20>>2]=s&2048;c[b+24>>2]=s&1024;c[b+28>>2]=s&512;if((c[b+16>>2]|0)!=5){break}c[b>>2]=c[l+12>>2]}}while(0);a:do{if((c[l+16>>2]|0)==5){c[b+4>>2]=(c[l+20>>2]|0)/4|0;c[b+32>>2]=Nla(c[b+4>>2]<<2)|0;t=l;u=c[b+4>>2]|0;if(((c[b+4>>2]|0)%2|0|0)!=0){h=h+(ub(t|0,4,u+1|0,c[m>>2]|0)|0)|0}else{h=h+(ub(t|0,4,u|0,c[m>>2]|0)|0)|0}v=0;if((c[m+20>>2]|0)!=0){while(1){if((v|0)>=(c[b+4>>2]|0)){break a}u=NL(l+(v<<2)|0)|0;c[(c[b+32>>2]|0)+(v<<2)>>2]=u;v=v+1|0}}else{while(1){if((v|0)>=(c[b+4>>2]|0)){break a}c[(c[b+32>>2]|0)+(v<<2)>>2]=c[l+(v<<2)>>2];v=v+1|0}}}}while(0);h=h+(ub(l|0,4,2,c[m>>2]|0)|0)|0;if((c[m+20>>2]|0)!=0){NL(l)|0}do{if((c[l>>2]|0)==1){if((c[m+20>>2]|0)!=0){w=NL(l+4|0)|0}else{w=c[l+4>>2]|0}u=w;if(((w|0)%8|0|0)==0){v=u}else{v=u+(8-((w|0)%8|0))|0}h=h+(ub(l|0,1,v|0,c[m>>2]|0)|0)|0;c[b+36>>2]=Nla(w+1|0)|0;rma(c[b+36>>2]|0,l|0,w|0)|0;a[(c[b+36>>2]|0)+w|0]=0}else{if((c[l>>2]&65535|0)!=1){break}if((c[l>>2]&-65536|0)==0){break}u=(c[l>>2]&-65536)>>>16;c[b+36>>2]=Nla(u+1|0)|0;rma(c[b+36>>2]|0,l+4|0,u|0)|0;a[(c[b+36>>2]|0)+u|0]=0}}while(0);do{if((c[b+16>>2]|0)==2){UM(m,b)|0}else{if((c[b+16>>2]|0)==1){VM(m,b)|0;break}if((c[b+16>>2]|0)!=16){break}WM(m,b)|0}}while(0);h=Ab(c[m>>2]|0)|0;c[(c[b+52>>2]|0)+16>>2]=h;$c(c[m>>2]|0,(c[j>>2]|0)+8+p|0,0)|0}else if((r|0)==15){h=k+0|0;u=h+64|0;do{c[h>>2]=0;h=h+4|0}while((h|0)<(u|0));h=0;b=NM()|0;c[b+36>>2]=0;c[b+40>>2]=0;c[b+32>>2]=0;c[b>>2]=0;c[b+8>>2]=0;c[b+16>>2]=0;c[b+12>>2]=0;c[b+44>>2]=0;c[b+48>>2]=1;c[(c[b+52>>2]|0)+20>>2]=m;c[(c[b+52>>2]|0)+12>>2]=p;u=Pla(1,56)|0;c[(c[b+52>>2]|0)+32>>2]=u;c[(c[(c[b+52>>2]|0)+32>>2]|0)+32>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+36>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+40>>2]=0;c[c[(c[b+52>>2]|0)+32>>2]>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+12>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]=0;c[(c[(c[b+52>>2]|0)+32>>2]|0)+16>>2]=0;q=hN(c[(c[b+52>>2]|0)+32>>2]|0,92784,56)|0;if((q|0)!=0){c[g>>2]=q;TL(92792,g);MM(b);break}h=h+(VL(m,b,k)|0)|0;if((c[m+20>>2]|0)!=0){NL(k)|0;NL(k+4|0)|0}u=c[k+4>>2]|0;if((c[k>>2]|0)!=14){TL(92824,f);$c(c[m>>2]|0,(c[j>>2]|0)-h|0,1)|0;MM(b);b=0;break}h=h+(WL(m,b,k)|0)|0;if((c[m+20>>2]|0)!=0){NL(k)|0;NL(k+8|0)|0;NL(k+12|0)|0}do{if((c[k>>2]|0)==6){s=c[k+8>>2]|0;c[b+16>>2]=s&255;c[b+20>>2]=s&2048;c[b+24>>2]=s&1024;c[b+28>>2]=s&512;if((c[b+16>>2]|0)!=5){break}c[b>>2]=c[k+12>>2]}}while(0);h=h+(XL(m,b,k)|0)|0;if((c[m+20>>2]|0)!=0){NL(k)|0;NL(k+4|0)|0}b:do{if((c[k>>2]|0)==5){u=c[k+4>>2]|0;c[b+4>>2]=(u|0)/4|0;c[b+32>>2]=Nla(c[b+4>>2]<<2)|0;v=0;if((c[m+20>>2]|0)!=0){while(1){if((v|0)>=(c[b+4>>2]|0)){break b}t=NL(k+(2+v<<2)|0)|0;c[(c[b+32>>2]|0)+(v<<2)>>2]=t;v=v+1|0}}else{while(1){if((v|0)>=(c[b+4>>2]|0)){break b}c[(c[b+32>>2]|0)+(v<<2)>>2]=c[k+(2+v<<2)>>2];v=v+1|0}}}}while(0);h=h+(YL(m,b,k)|0)|0;if((c[m+20>>2]|0)!=0){NL(k)|0}do{if((c[k>>2]|0)==1){if((c[m+20>>2]|0)!=0){x=NL(k+4|0)|0}else{x=c[k+4>>2]|0}u=x;if(((x|0)%8|0|0)==0){v=u}else{v=u+(8-((x|0)%8|0))|0}c[b+36>>2]=Nla(v+1|0)|0;h=h+(ZL(m,b,c[b+36>>2]|0,v)|0)|0;a[(c[b+36>>2]|0)+x|0]=0}else{if((c[k>>2]&65535|0)!=1){break}if((c[k>>2]&-65536|0)==0){break}u=(c[k>>2]&-65536)>>>16;c[b+36>>2]=Nla(u+1|0)|0;rma(c[b+36>>2]|0,k+4|0,u|0)|0;a[(c[b+36>>2]|0)+u|0]=0}}while(0);do{if((c[b+16>>2]|0)==2){UM(m,b)|0}else{if((c[b+16>>2]|0)!=1){break}VM(m,b)|0}}while(0);$c(c[m>>2]|0,0-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0)|0,1)|0;h=Ab(c[m>>2]|0)|0;c[(c[b+52>>2]|0)+16>>2]=h;$c(c[m>>2]|0,(c[j>>2]|0)+8+p|0,0)|0}else{c[e>>2]=c[m+12>>2];TL(92864,e);n=0;o=n;i=d;return o|0}}while(0);n=b;o=n;i=d;return o|0}function TM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=a;a=b;b=0;do{if((g|0)!=0){if((a|0)==0){break}a:do{if((c[g+16>>2]|0)==512){while(1){b=RM(g)|0;if((b|0)==0){break}h=b;do{if((c[b+36>>2]|0)!=0){if((lma(c[h+36>>2]|0,a)|0)==0){break}MM(b);b=0}else{MM(h);b=0}}while(0);if(0!=(b|0)){break a}if((c[g+32>>2]|0)>=(c[g+36>>2]|0)){break a}}TL(92632,f)}else{h=Ab(c[g>>2]|0)|0;$c(c[g>>2]|0,c[g+28>>2]|0,0)|0;do{b=RM(g)|0;if((b|0)==0){j=19;break}k=b;do{if((c[b+36>>2]|0)!=0){if((lma(c[k+36>>2]|0,a)|0)==0){break}MM(b);b=0}else{MM(k);b=0}}while(0);if((b|0)!=0){break}}while((Ud(c[g>>2]|0)|0)!=0^1);if((j|0)==19){TL(92632,e)}$c(c[g>>2]|0,h|0,0)|0}}while(0);l=b;m=l;i=d;return m|0}}while(0);l=0;m=l;i=d;return m|0}function UM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+64|0;n=i;i=i+64|0;o=b;b=d;d=0;p=1;q=0;r=0;while(1){if((r|0)>=(c[b+4>>2]|0)){break}p=fa(p,c[(c[b+32>>2]|0)+(r<<2)>>2]|0)|0;r=r+1|0}a:do{if((c[b+48>>2]|0)!=0){s=m+0|0;t=s+64|0;do{c[s>>2]=0;s=s+4|0}while((s|0)<(t|0));d=d+(aM(o,b,m)|0)|0;if((c[o+20>>2]|0)!=0){NL(m)|0;NL(m+4|0)|0}if((c[m>>2]&65535|0)!=5){gM(93168,l);u=d;v=u;i=e;return v|0}w=c[m+4>>2]|0;d=d+(bM(o,b,m)|0)|0;if((c[o+20>>2]|0)!=0){NL(m)|0;NL(m+4|0)|0}x=c[m+4>>2]|0;x=(x|0)/(w|0)|0;c[b+12>>2]=4;if(((fa(x,w)|0)%8|0|0)!=0){r=8-((fa(x,w)|0)%8|0)|0}else{r=0}if((x|0)!=0){y=Nla((fa(x,w)|0)+r|0)|0;d=d+(cM(o,b,y,x,w,r)|0)|0;c[(c[b+52>>2]|0)+24>>2]=x;z=Pla(x,4)|0;c[(c[b+52>>2]|0)+28>>2]=z;r=0;while(1){if((r|0)>=(x|0)){break}z=Nla(w)|0;c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]=z;rma(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]|0,y+(fa(r,w)|0)|0,w|0)|0;a[(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]|0)+(w-1)|0]=0;r=r+1|0}Ola(y)}else{c[(c[b+52>>2]|0)+24>>2]=0;c[(c[b+52>>2]|0)+28>>2]=0}z=fa(p,x)|0;c[b>>2]=fa(z,c[b+12>>2]|0)|0;if((c[b>>2]|0)==0){u=d;v=u;i=e;return v|0}c[b+40>>2]=Nla(c[b>>2]|0)|0;if((c[b+40>>2]|0)==0){u=d;v=u;i=e;return v|0}q=c[b+40>>2]|0;r=0;while(1){if((r|0)>=(p|0)){break}z=0;while(1){if((z|0)>=(x|0)){break}c[q+((fa(r,x)|0)+z<<2)>>2]=NM()|0;A=Ed(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(z<<2)>>2]|0)|0;c[(c[q+((fa(r,x)|0)+z<<2)>>2]|0)+36>>2]=A;z=z+1|0}r=r+1|0}r=0;while(1){if((r|0)>=(fa(p,x)|0)){break a}y=Ab(c[o>>2]|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+12>>2]=y-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0);d=d+(VL(o,b,m)|0)|0;if((c[o+20>>2]|0)!=0){NL(m)|0;NL(m+4|0)|0}y=c[m+4>>2]|0;do{if((c[m>>2]|0)!=14){c[k>>2]=r;TL(93200,k);MM(c[q+(r<<2)>>2]|0);c[q+(r<<2)>>2]=0}else{z=c[q+(r<<2)>>2]|0;if((y|0)==0){c[z+4>>2]=0;break}c[z+48>>2]=1;d=d+(WL(o,b,m)|0)|0;y=y-16|0;if((c[o+20>>2]|0)!=0){NL(m)|0;NL(m+4|0)|0;NL(m+8|0)|0;NL(m+12|0)|0}do{if((c[m>>2]|0)==6){z=c[m+8>>2]|0;c[(c[q+(r<<2)>>2]|0)+16>>2]=z&255;c[(c[q+(r<<2)>>2]|0)+20>>2]=z&2048;c[(c[q+(r<<2)>>2]|0)+24>>2]=z&1024;c[(c[q+(r<<2)>>2]|0)+28>>2]=z&512;if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)!=5){break}c[c[q+(r<<2)>>2]>>2]=c[m+12>>2]}else{c[j>>2]=c[m>>2];TL(93048,j);d=d+(SL(o,c[(c[b+52>>2]|0)+32>>2]|0,y)|0)|0}}while(0);d=d+(XL(o,b,m)|0)|0;y=y-8|0;if((c[o+20>>2]|0)!=0){NL(m)|0;NL(m+4|0)|0}do{if((c[m>>2]|0)==5){z=0;c[(c[q+(r<<2)>>2]|0)+4>>2]=c[m+4>>2];y=y-(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)|0;A=(c[q+(r<<2)>>2]|0)+4|0;c[A>>2]=(c[A>>2]|0)/4|0;A=Nla(c[(c[q+(r<<2)>>2]|0)+4>>2]<<2)|0;c[(c[q+(r<<2)>>2]|0)+32>>2]=A;z=0;b:do{if((c[o+20>>2]|0)!=0){while(1){if((z|0)>=(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)){break b}A=NL(m+8+(z<<2)|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+32>>2]|0)+(z<<2)>>2]=A;z=z+1|0}}else{while(1){if((z|0)>=(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)){break b}c[(c[(c[q+(r<<2)>>2]|0)+32>>2]|0)+(z<<2)>>2]=c[m+(2+z<<2)>>2];z=z+1|0}}}while(0);if(((c[(c[q+(r<<2)>>2]|0)+4>>2]|0)%2|0|0)==0){break}y=y-4|0}}while(0);d=d+(YL(o,b,m)|0)|0;y=y-8|0;z=Pla(1,56)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+32>>2]=z;z=mN(c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+32>>2]|0,c[(c[b+52>>2]|0)+32>>2]|0)|0;if((z|0)!=0){c[h>>2]=z;TL(93096,h)}z=Ab(c[o>>2]|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+16>>2]=z-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0);do{if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)==2){d=d+(UM(o,c[q+(r<<2)>>2]|0)|0)|0}else{if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)!=1){break}d=d+(VM(o,c[q+(r<<2)>>2]|0)|0)|0}}while(0);$c(c[o>>2]|0,c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+16>>2]|0,0)|0;d=d+(SL(o,c[(c[b+52>>2]|0)+32>>2]|0,y)|0)|0}}while(0);r=r+1|0}}else{s=n+0|0;t=s+64|0;do{c[s>>2]=0;s=s+4|0}while((s|0)<(t|0));d=d+(ub(n|0,4,2,c[o>>2]|0)|0)|0;if((c[o+20>>2]|0)!=0){NL(n)|0;NL(n+4|0)|0}if((c[n>>2]&65535|0)!=5){gM(93168,g);u=d;v=u;i=e;return v|0}w=c[n+4>>2]|0;d=d+(ub(n|0,4,2,c[o>>2]|0)|0)|0;if((c[o+20>>2]|0)!=0){NL(n)|0;NL(n+4|0)|0}x=c[n+4>>2]|0;x=(x|0)/(w|0)|0;c[b+12>>2]=4;c[(c[b+52>>2]|0)+24>>2]=x;y=Pla(x,4)|0;c[(c[b+52>>2]|0)+28>>2]=y;r=0;while(1){if((r|0)>=(x|0)){break}y=Nla(w)|0;c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]=y;d=d+(ub(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]|0,1,w|0,c[o>>2]|0)|0)|0;a[(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(r<<2)>>2]|0)+(w-1)|0]=0;r=r+1|0}if(((fa(x,w)|0)%8|0|0)!=0){$c(c[o>>2]|0,8-((fa(x,w)|0)%8|0)|0,1)|0;d=d+(8-((fa(x,w)|0)%8|0))|0}y=fa(p,x)|0;c[b>>2]=fa(y,c[b+12>>2]|0)|0;if((c[b>>2]|0)==0){u=d;v=u;i=e;return v|0}c[b+40>>2]=Nla(c[b>>2]|0)|0;if((c[b+40>>2]|0)==0){u=d;v=u;i=e;return v|0}q=c[b+40>>2]|0;r=0;while(1){if((r|0)>=(p|0)){break}y=0;while(1){if((y|0)>=(x|0)){break}c[q+((fa(r,x)|0)+y<<2)>>2]=NM()|0;z=Ed(c[(c[(c[b+52>>2]|0)+28>>2]|0)+(y<<2)>>2]|0)|0;c[(c[q+((fa(r,x)|0)+y<<2)>>2]|0)+36>>2]=z;y=y+1|0}r=r+1|0}r=0;while(1){if((r|0)>=(fa(p,x)|0)){break a}y=Ab(c[o>>2]|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+12>>2]=y;d=d+(ub(n|0,4,2,c[o>>2]|0)|0)|0;if((c[o+20>>2]|0)!=0){NL(n)|0;NL(n+4|0)|0}y=c[n+4>>2]|0;if((c[n>>2]|0)!=14){break}z=c[q+(r<<2)>>2]|0;if((y|0)==0){c[z+4>>2]=0}else{c[z+48>>2]=0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+32>>2]=0;d=d+(ub(n|0,4,6,c[o>>2]|0)|0)|0;if((c[o+20>>2]|0)!=0){NL(n)|0;NL(n+4|0)|0;NL(n+8|0)|0;NL(n+12|0)|0;NL(n+16|0)|0;NL(n+20|0)|0}y=y-24|0;do{if((c[n>>2]|0)==6){z=c[n+8>>2]|0;c[(c[q+(r<<2)>>2]|0)+16>>2]=z&255;c[(c[q+(r<<2)>>2]|0)+20>>2]=z&2048;c[(c[q+(r<<2)>>2]|0)+24>>2]=z&1024;c[(c[q+(r<<2)>>2]|0)+28>>2]=z&512;if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)!=5){break}c[c[q+(r<<2)>>2]>>2]=c[n+12>>2]}}while(0);c:do{if((c[n+16>>2]|0)==5){z=c[n+20>>2]|0;y=y-z|0;c[(c[q+(r<<2)>>2]|0)+4>>2]=(z|0)/4|0;z=Nla(c[(c[q+(r<<2)>>2]|0)+4>>2]<<2)|0;c[(c[q+(r<<2)>>2]|0)+32>>2]=z;z=n;A=c[(c[q+(r<<2)>>2]|0)+4>>2]|0;if(((c[(c[q+(r<<2)>>2]|0)+4>>2]|0)%2|0|0)!=0){d=d+(ub(z|0,4,A+1|0,c[o>>2]|0)|0)|0;y=y-4|0}else{d=d+(ub(z|0,4,A|0,c[o>>2]|0)|0)|0}A=0;if((c[o+20>>2]|0)!=0){while(1){if((A|0)>=(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)){break c}z=NL(n+(A<<2)|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+32>>2]|0)+(A<<2)>>2]=z;A=A+1|0}}else{while(1){if((A|0)>=(c[(c[q+(r<<2)>>2]|0)+4>>2]|0)){break c}c[(c[(c[q+(r<<2)>>2]|0)+32>>2]|0)+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0}}}}while(0);d=d+(ub(n|0,1,8,c[o>>2]|0)|0)|0;y=y-8|0;A=Ab(c[o>>2]|0)|0;c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+16>>2]=A;do{if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)==2){d=d+(UM(o,c[q+(r<<2)>>2]|0)|0)|0}else{if((c[(c[q+(r<<2)>>2]|0)+16>>2]|0)!=1){break}d=d+(VM(o,c[q+(r<<2)>>2]|0)|0)|0}}while(0);$c(c[o>>2]|0,(c[(c[(c[q+(r<<2)>>2]|0)+52>>2]|0)+16>>2]|0)+y|0,0)|0}r=r+1|0}A=Ab(c[o>>2]|0)|0;c[f>>2]=r;c[f+4>>2]=A;TL(93248,f);MM(c[q+(r<<2)>>2]|0);c[q+(r<<2)>>2]=0;u=d;v=u;i=e;return v|0}}while(0);u=d;v=u;i=e;return v|0}function VM(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+64|0;o=i;i=i+64|0;p=b;b=d;d=0;q=0;r=1;s=0;while(1){if((s|0)>=(c[b+4>>2]|0)){break}r=fa(r,c[(c[b+32>>2]|0)+(s<<2)>>2]|0)|0;s=s+1|0}c[b+12>>2]=4;c[b>>2]=fa(r,c[b+12>>2]|0)|0;c[b+40>>2]=Nla(c[b>>2]|0)|0;t=b;if((c[b+40>>2]|0)==0){c[m>>2]=c[t+36>>2];TL(92920,m);u=d;v=u;i=e;return v|0}q=c[t+40>>2]|0;a:do{if((c[b+48>>2]|0)!=0){t=n+0|0;m=t+64|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(m|0));s=0;b:while(1){if((s|0)>=(r|0)){break a}c[q+(s<<2)>>2]=NM()|0;do{if(0==(c[q+(s<<2)>>2]|0)){c[l>>2]=s;TL(92960,l)}else{t=Ab(c[p>>2]|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+12>>2]=t-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0);c[n>>2]=0;c[n+4>>2]=0;d=d+(VL(p,b,n)|0)|0;if((c[p+20>>2]|0)!=0){NL(n)|0;NL(n+4|0)|0}t=c[n+4>>2]|0;if((t|0)==0){break}w=s;if((c[n>>2]|0)!=14){break b}c[(c[q+(w<<2)>>2]|0)+48>>2]=1;d=d+(WL(p,b,n)|0)|0;t=t-16|0;if((c[p+20>>2]|0)!=0){NL(n)|0;NL(n+4|0)|0;NL(n+8|0)|0;NL(n+12|0)|0}do{if((c[n>>2]|0)==6){m=c[n+8>>2]|0;c[(c[q+(s<<2)>>2]|0)+16>>2]=m&255;c[(c[q+(s<<2)>>2]|0)+20>>2]=m&2048;c[(c[q+(s<<2)>>2]|0)+24>>2]=m&1024;c[(c[q+(s<<2)>>2]|0)+28>>2]=m&512;if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)!=5){break}c[c[q+(s<<2)>>2]>>2]=c[n+12>>2]}else{c[j>>2]=c[n>>2];TL(93048,j);d=d+(SL(p,c[(c[b+52>>2]|0)+32>>2]|0,t)|0)|0}}while(0);d=d+(XL(p,b,n)|0)|0;t=t-8|0;if((c[p+20>>2]|0)!=0){NL(n)|0;NL(n+4|0)|0}do{if((c[n>>2]|0)==5){m=0;c[(c[q+(s<<2)>>2]|0)+4>>2]=c[n+4>>2];t=t-(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)|0;x=(c[q+(s<<2)>>2]|0)+4|0;c[x>>2]=(c[x>>2]|0)/4|0;x=Nla(c[(c[q+(s<<2)>>2]|0)+4>>2]<<2)|0;c[(c[q+(s<<2)>>2]|0)+32>>2]=x;m=0;c:do{if((c[p+20>>2]|0)!=0){while(1){if((m|0)>=(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)){break c}x=NL(n+8+(m<<2)|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+32>>2]|0)+(m<<2)>>2]=x;m=m+1|0}}else{while(1){if((m|0)>=(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)){break c}c[(c[(c[q+(s<<2)>>2]|0)+32>>2]|0)+(m<<2)>>2]=c[n+(2+m<<2)>>2];m=m+1|0}}}while(0);if(((c[(c[q+(s<<2)>>2]|0)+4>>2]|0)%2|0|0)==0){break}t=t-4|0}}while(0);d=d+(YL(p,b,n)|0)|0;t=t-8|0;if((c[p+20>>2]|0)!=0){NL(n)|0;NL(n+4|0)|0}do{if((c[n+4>>2]|0)>>>0>0){m=0;if((c[n>>2]|0)==1){m=c[n+4>>2]|0;if(((m|0)%8|0|0)>0){m=m+(8-((m|0)%8|0))|0}x=Nla(m+1|0)|0;c[(c[q+(s<<2)>>2]|0)+36>>2]=x;d=d+(ZL(p,b,c[(c[q+(s<<2)>>2]|0)+36>>2]|0,m)|0)|0;a[(c[(c[q+(s<<2)>>2]|0)+36>>2]|0)+m|0]=0;t=t-m|0;break}else{if((c[n>>2]&65535|0)!=1){break}if((c[n>>2]&-65536|0)==0){break}m=(c[n>>2]&-65536)>>>16;x=Nla(m+1|0)|0;c[(c[q+(s<<2)>>2]|0)+36>>2]=x;rma(c[(c[q+(s<<2)>>2]|0)+36>>2]|0,n+4|0,m|0)|0;a[(c[(c[q+(s<<2)>>2]|0)+36>>2]|0)+m|0]=0;break}}}while(0);m=Pla(1,56)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+32>>2]=m;m=mN(c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+32>>2]|0,c[(c[b+52>>2]|0)+32>>2]|0)|0;if((m|0)!=0){c[h>>2]=m;TL(93096,h)}m=Ab(c[p>>2]|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+16>>2]=m-(c[(c[(c[b+52>>2]|0)+32>>2]|0)+4>>2]|0);do{if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)==2){d=d+(UM(p,c[q+(s<<2)>>2]|0)|0)|0}else{if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)!=1){break}d=d+(VM(p,c[q+(s<<2)>>2]|0)|0)|0}}while(0);$c(c[p>>2]|0,c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+16>>2]|0,0)|0;d=d+(SL(p,c[(c[b+52>>2]|0)+32>>2]|0,t)|0)|0}}while(0);s=s+1|0}c[k>>2]=w;TL(93e3,k);MM(c[q+(s<<2)>>2]|0);c[q+(s<<2)>>2]=0}else{s=0;d:while(1){if((s|0)>=(r|0)){break a}c[q+(s<<2)>>2]=NM()|0;do{if((c[q+(s<<2)>>2]|0)!=0){m=Ab(c[p>>2]|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+12>>2]=m;m=ub(o|0,4,2,c[p>>2]|0)|0;if((m|0)==0){break}d=d+m|0;if((c[p+20>>2]|0)!=0){NL(o)|0;NL(o+4|0)|0}m=c[o+4>>2]|0;if((m|0)==0){break}y=s;if((c[o>>2]|0)!=14){break d}c[(c[q+(y<<2)>>2]|0)+48>>2]=0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+32>>2]=0;d=d+(ub(o|0,4,6,c[p>>2]|0)|0)|0;if((c[p+20>>2]|0)!=0){NL(o)|0;NL(o+4|0)|0;NL(o+8|0)|0;NL(o+12|0)|0;NL(o+16|0)|0;NL(o+20|0)|0}m=m-24|0;do{if((c[o>>2]|0)==6){x=c[o+8>>2]|0;c[(c[q+(s<<2)>>2]|0)+16>>2]=x&255;c[(c[q+(s<<2)>>2]|0)+20>>2]=x&2048;c[(c[q+(s<<2)>>2]|0)+24>>2]=x&1024;c[(c[q+(s<<2)>>2]|0)+28>>2]=x&512;if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)!=5){break}c[c[q+(s<<2)>>2]>>2]=c[o+12>>2]}}while(0);e:do{if((c[o+16>>2]|0)==5){t=c[o+20>>2]|0;m=m-t|0;c[(c[q+(s<<2)>>2]|0)+4>>2]=(t|0)/4|0;t=Nla(c[(c[q+(s<<2)>>2]|0)+4>>2]<<2)|0;c[(c[q+(s<<2)>>2]|0)+32>>2]=t;t=o;x=c[(c[q+(s<<2)>>2]|0)+4>>2]|0;if(((c[(c[q+(s<<2)>>2]|0)+4>>2]|0)%2|0|0)!=0){d=d+(ub(t|0,4,x+1|0,c[p>>2]|0)|0)|0;m=m-4|0}else{d=d+(ub(t|0,4,x|0,c[p>>2]|0)|0)|0}x=0;if((c[p+20>>2]|0)!=0){while(1){if((x|0)>=(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)){break e}t=NL(o+(x<<2)|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+32>>2]|0)+(x<<2)>>2]=t;x=x+1|0}}else{while(1){if((x|0)>=(c[(c[q+(s<<2)>>2]|0)+4>>2]|0)){break e}c[(c[(c[q+(s<<2)>>2]|0)+32>>2]|0)+(x<<2)>>2]=c[o+(x<<2)>>2];x=x+1|0}}}}while(0);d=d+(ub(o|0,1,8,c[p>>2]|0)|0)|0;m=m-8|0;if((c[p+20>>2]|0)!=0){NL(o)|0;NL(o+4|0)|0}x=0;do{if((c[o+4>>2]|0)>>>0>0){if((c[o>>2]|0)!=1){break}x=c[o+4>>2]|0;if(((x|0)%8|0|0)>0){x=x+(8-((x|0)%8|0))|0}m=m-x|0;$c(c[p>>2]|0,x|0,1)|0}}while(0);x=Ab(c[p>>2]|0)|0;c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+16>>2]=x;if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)==2){d=d+(UM(p,c[q+(s<<2)>>2]|0)|0)|0}if((c[(c[q+(s<<2)>>2]|0)+16>>2]|0)==1){d=d+(VM(p,c[q+(s<<2)>>2]|0)|0)|0}$c(c[p>>2]|0,(c[(c[(c[q+(s<<2)>>2]|0)+52>>2]|0)+16>>2]|0)+m|0,0)|0}else{c[g>>2]=s;TL(92960,g)}}while(0);s=s+1|0}x=Ab(c[p>>2]|0)|0;c[f>>2]=y;c[f+4>>2]=x;TL(93128,f);MM(c[q+(s<<2)>>2]|0);c[q+(s<<2)>>2]=0}}while(0);u=d;v=u;i=e;return v|0}function WM(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+48|0;e=a;a=b;b=1;f=0;g=0;h=0;while(1){if((h|0)>=(c[a+4>>2]|0)){break}b=fa(b,c[(c[a+32>>2]|0)+(h<<2)>>2]|0)|0;h=h+1|0}c[a+40>>2]=Nla(b<<2)|0;if((c[a+40>>2]|0)==0){f=0;c[a+12>>2]=0;c[a>>2]=0;j=f;i=d;return j|0}c[a+12>>2]=4;c[a>>2]=fa(b,c[a+12>>2]|0)|0;g=c[a+40>>2]|0;h=0;while(1){if((h|0)>=(b|0)){break}c[g+(h<<2)>>2]=RM(e)|0;h=h+1|0}j=f;i=d;return j|0}function XM(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=d;if((c[h>>2]|0)>>>0<e>>>0){a[b+(c[h>>2]|0)|0]=f}f=h;c[f>>2]=(c[f>>2]|0)+1;i=g;return}function YM(b,c,d,e,f,g,h,j){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+136|0;l=k+80|0;m=b;b=c;c=d;d=e;e=f;f=g;g=h;h=j;j=0;n=0;o=0;p=0;q=0;if((g|0)<0){g=0}r=d;do{if((h&64|0)==0){if((d|0)<0){j=45;r=0-d|0;break}if((h&2|0)!=0){j=43;break}if((h&4|0)==0){break}j=32}}while(0);if((h&32|0)!=0){q=1}do{d=n;n=d+1|0;a[l+d|0]=a[((q|0)!=0?93304:93328)+((r>>>0)%(e>>>0)|0)|0]|0;r=(r>>>0)/(e>>>0)|0;if((r|0)==0){break}}while((n|0)<20);if((n|0)==20){n=n+ -1|0}a[l+n|0]=0;p=g-n|0;o=f-((g|0)>=(n|0)?g:n)-((j|0)!=0?1:0)|0;if((p|0)<0){p=0}if((o|0)<0){o=0}if((h&16|0)!=0){p=(p|0)>=(o|0)?p:o;o=0}if((h&1|0)!=0){o=0-o|0}while(1){if((o|0)<=0){break}XM(m,b,c,32);o=o+ -1|0}if((j|0)!=0){XM(m,b,c,j&255)}if((p|0)>0&(p|0)>0){do{XM(m,b,c,48);p=p+ -1|0;}while((p|0)>0)}while(1){if((n|0)<=0){break}p=n+ -1|0;n=p;XM(m,b,c,a[l+p|0]|0)}while(1){if((o|0)>=0){break}XM(m,b,c,32);o=o+1|0}i=k;return}function ZM(b,c,d,e,f,g,j){b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0;k=i;i=i+768|0;l=k+72|0;m=k+384|0;n=k+744|0;o=k+752|0;p=b;b=c;c=d;q=e;d=f;f=g;g=j;j=0;r=0;s=0;t=0;u=0;v=0;if((f|0)<0){f=6}e=+$M(q);do{if(q<0.0){j=45}else{if((g&2|0)!=0){j=43;break}if((g&4|0)==0){break}j=32}}while(0);if((f|0)>16){f=16}q=e;+aN(q,n);w=+cN(f);h[o>>3]=+(bN(w*(e- +h[n>>3]))|0);e=+h[o>>3];if(e>=+cN(f)){h[n>>3]=+h[n>>3]+1.0;e=+cN(f);h[o>>3]=+h[o>>3]-e}do{q=+h[n>>3]*.1;+aN(q,n);x=~~((q- +h[n>>3]+.05)*10.0);y=r;r=y+1|0;a[l+y|0]=a[((v|0)!=0?93304:93328)+x|0]|0;if(!(+h[n>>3]!=0.0)){break}}while((r|0)<311);if((r|0)==311){r=r+ -1|0}a[l+r|0]=0;do{if(+h[o>>3]!=0.0){do{q=+h[o>>3]*.1;+aN(q,o);x=~~((q- +h[o>>3]+.05)*10.0);n=s;s=n+1|0;a[m+n|0]=a[((v|0)!=0?93304:93328)+x|0]|0;if(!(+h[o>>3]!=0.0)){break}}while((s|0)<311);if((s|0)!=311){break}s=s+ -1|0}}while(0);a[m+s|0]=0;t=d-r-f-1-((j|0)!=0?1:0)|0;d=f-s|0;u=d;u=(u|0)<0?0:d;if((t|0)<0){t=0}if((g&1|0)!=0){t=0-t|0}a:do{if((g&16|0)!=0){if((t|0)<=0){break}if((j|0)!=0){XM(p,b,c,j&255);t=t+ -1|0;j=0}while(1){if((t|0)<=0){break a}XM(p,b,c,48);t=t+ -1|0}}}while(0);while(1){if((t|0)<=0){break}XM(p,b,c,32);t=t+ -1|0}if((j|0)!=0){XM(p,b,c,j&255)}while(1){if((r|0)<=0){break}j=r+ -1|0;r=j;XM(p,b,c,a[l+j|0]|0)}b:do{if((f|0)>0){XM(p,b,c,46);while(1){if((u|0)<=0){break}XM(p,b,c,48);u=u+ -1|0}while(1){if((s|0)<=0){break b}l=s+ -1|0;s=l;XM(p,b,c,a[m+l|0]|0)}}}while(0);while(1){if((t|0)>=0){break}XM(p,b,c,32);t=t+1|0}i=k;return}function _M(b,c,d,e,f,g,h){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+80|0;k=b;b=c;c=d;d=e;e=f;f=g;g=h;h=0;if((d|0)==0){d=93296}l=0;while(1){if((a[d+l|0]|0)==0){break}l=l+1|0}m=f-l|0;l=m;l=(l|0)<0?0:m;if((e&1|0)!=0){l=0-l|0}while(1){if((l|0)<=0){break}if((h|0)>=(g|0)){break}XM(k,b,c,32);l=l+ -1|0;h=h+1|0}while(1){if((a[d]|0)==0){break}if((h|0)>=(g|0)){break}e=d;d=e+1|0;XM(k,b,c,a[e]|0);h=h+1|0}while(1){if((l|0)>=0){n=17;break}if((h|0)>=(g|0)){n=17;break}XM(k,b,c,32);l=l+1|0;h=h+1|0}if((n|0)==17){i=j;return}}function $M(a){a=+a;var b=0,c=0.0;b=i;i=i+16|0;c=a;a=c;if(c<0.0){a=-c}i=b;return+a}function aN(a,b){a=+a;b=b|0;var c=0,d=0,e=0.0,f=0,g=0.0,j=0,k=0.0,l=0.0,m=0.0;c=i;i=i+72|0;d=c+56|0;e=a;f=b;a=e;g=1.0;b=0;while(1){if((b|0)>=100){break}j=~~a;if(+(j|0)<=a+1.0){if(+(j|0)>=a-1.0){break}}a=a*.1;g=g*10.0;b=b+1|0}if((b|0)==100){h[f>>3]=0.0;k=0.0;l=k;i=c;return+l}if((b|0)!=0){m=+aN(e- +(j|0)*g,d);h[f>>3]=+(j|0)*g+ +h[d>>3];k=m;l=k;i=c;return+l}else{h[f>>3]=+(j|0);k=a- +h[f>>3];l=k;i=c;return+l}return 0.0}function bN(a){a=+a;var b=0,c=0.0,d=0,e=0;b=i;i=i+16|0;c=a;d=~~c;c=c- +(d|0);if(!(c>=.5)){e=d;i=b;return e|0}d=d+1|0;e=d;i=b;return e|0}function cN(a){a=a|0;var b=0,c=0,d=0.0,e=0.0;b=i;i=i+16|0;c=a;d=1.0;while(1){e=d;if((c|0)==0){break}d=e*10.0;c=c+ -1|0}i=b;return+e}function dN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+24|0;d=a;do{if((d|0)!=0){if((c[d+28>>2]|0)==0){break}a=c[d+28>>2]|0;c[a+28>>2]=0;c[d+20>>2]=0;c[d+8>>2]=0;c[d+24>>2]=0;if((c[a+8>>2]|0)!=0){c[d+48>>2]=c[a+8>>2]&1}c[a>>2]=0;c[a+4>>2]=0;c[a+12>>2]=0;c[a+20>>2]=32768;c[a+32>>2]=0;c[a+56>>2]=0;c[a+60>>2]=0;e=a+1328|0;c[a+108>>2]=e;c[a+80>>2]=e;c[a+76>>2]=e;c[a+7104>>2]=1;c[a+7108>>2]=-1;f=0;g=f;i=b;return g|0}}while(0);f=-2;g=f;i=b;return g|0}function eN(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;do{if((d|0)!=0){if((c[d+28>>2]|0)==0){break}a=c[d+28>>2]|0;c[a+40>>2]=0;c[a+44>>2]=0;c[a+48>>2]=0;e=dN(d)|0;f=e;i=b;return f|0}}while(0);e=-2;f=e;i=b;return f|0}function fN(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=a;a=b;do{if((e|0)!=0){if((c[e+28>>2]|0)==0){break}b=c[e+28>>2]|0;do{if((a|0)<0){f=0;a=0-a|0}else{f=(a>>4)+1|0;if((a|0)>=48){break}a=a&15}}while(0);do{if((a|0)!=0){if(!((a|0)<8|(a|0)>15)){break}g=-2;h=g;i=d;return h|0}}while(0);do{if((c[b+52>>2]|0)!=0){if((c[b+36>>2]|0)==(a|0)){break}me[c[e+36>>2]&127](c[e+40>>2]|0,c[b+52>>2]|0);c[b+52>>2]=0}}while(0);c[b+8>>2]=f;c[b+36>>2]=a;g=eN(e)|0;h=g;i=d;return h|0}}while(0);g=-2;h=g;i=d;return h|0}function gN(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+56|0;h=b;b=d;d=e;e=f;do{if((d|0)!=0){if((a[d]|0)!=(a[93352]|0)){break}if((e|0)!=56){break}if((h|0)==0){j=-2;k=j;i=g;return k|0}c[h+24>>2]=0;if((c[h+32>>2]|0)==0){c[h+32>>2]=34;c[h+40>>2]=0}if((c[h+36>>2]|0)==0){c[h+36>>2]=61}f=re[c[h+32>>2]&63](c[h+40>>2]|0,1,7116)|0;if((f|0)==0){j=-4;k=j;i=g;return k|0}c[h+28>>2]=f;c[f+52>>2]=0;l=fN(h,b)|0;if((l|0)!=0){me[c[h+36>>2]&127](c[h+40>>2]|0,f);c[h+28>>2]=0}j=l;k=j;i=g;return k|0}}while(0);j=-6;k=j;i=g;return k|0}function hN(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=gN(a,15,b,c)|0;i=d;return e|0}



function Ola(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[206216>>2]|0;if(d>>>0<f>>>0){nd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){nd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){nd()}if((p|0)==(c[206220>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[206208>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=206240+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){nd()}if((c[m+12>>2]|0)==(p|0)){break}nd()}}while(0);if((u|0)==(m|0)){c[51550]=c[51550]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){nd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}nd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){nd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){nd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){nd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{nd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=206504+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[206204>>2]=c[206204>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[206216>>2]|0)>>>0){nd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[206216>>2]|0)>>>0){nd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){nd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){nd()}do{if((C&2|0)==0){if((l|0)==(c[206224>>2]|0)){f=(c[206212>>2]|0)+t|0;c[206212>>2]=f;c[206224>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[206220>>2]|0)){i=b;return}c[206220>>2]=0;c[206208>>2]=0;i=b;return}if((l|0)==(c[206220>>2]|0)){f=(c[206208>>2]|0)+t|0;c[206208>>2]=f;c[206220>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=206240+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[206216>>2]|0)>>>0){nd()}if((c[E+12>>2]|0)==(l|0)){break}nd()}}while(0);if((w|0)==(E|0)){c[51550]=c[51550]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[206216>>2]|0)>>>0){nd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}nd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[206216>>2]|0)>>>0){nd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){nd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{nd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=206504+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[206204>>2]=c[206204>>2]&~(1<<g);break b}else{if(d>>>0<(c[206216>>2]|0)>>>0){nd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[206216>>2]|0)>>>0){nd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[206220>>2]|0)){J=f;break}c[206208>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=206240+(C<<2)|0;G=c[51550]|0;j=1<<t;do{if((G&j|0)==0){c[51550]=G|j;K=206240+(C+2<<2)|0;L=e}else{t=206240+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[206216>>2]|0)>>>0)){K=t;L=a;break}nd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=206504+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[206204>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[206204>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[206216>>2]|0;if(O>>>0<K>>>0){nd()}if(f>>>0<K>>>0){nd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[206232>>2]|0)+ -1|0;c[206232>>2]=s;if((s|0)==0){Q=206656|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[206232>>2]=-1;i=b;return}function Pla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=Nla(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}tma(b|0,0,e|0)|0;i=d;return b|0}function Qla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=Nla(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Tc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=Rla(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=Nla(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;rma(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;Ola(a);e=g;i=d;return e|0}function Rla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[206216>>2]|0;if(h>>>0<l>>>0){nd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){nd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){nd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[206680>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;Sla(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[206224>>2]|0)){m=(c[206212>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[206224>>2]=a+b;c[206212>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[206220>>2]|0)){h=(c[206208>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[206208>>2]=r;c[206220>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=206240+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){nd()}if((c[h+12>>2]|0)==(k|0)){break}nd()}}while(0);if((m|0)==(h|0)){c[51550]=c[51550]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){nd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}nd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){nd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){nd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){nd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{nd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=206504+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[206204>>2]=c[206204>>2]&~(1<<u);break a}else{if(t>>>0<(c[206216>>2]|0)>>>0){nd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[206216>>2]|0)>>>0){nd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;Sla(a+b|0,r);o=a;i=d;return o|0}return 0}function Sla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[206216>>2]|0;if(j>>>0<m>>>0){nd()}if((k|0)==(c[206220>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[206208>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=206240+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){nd()}if((c[q+12>>2]|0)==(k|0)){break}nd()}}while(0);if((r|0)==(q|0)){c[51550]=c[51550]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){nd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}nd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){nd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){nd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){nd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{nd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=206504+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[206204>>2]=c[206204>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[206216>>2]|0)>>>0){nd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[206216>>2]|0)>>>0){nd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[206216>>2]|0;if(e>>>0<z>>>0){nd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[206224>>2]|0)){t=(c[206212>>2]|0)+p|0;c[206212>>2]=t;c[206224>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[206220>>2]|0)){i=d;return}c[206220>>2]=0;c[206208>>2]=0;i=d;return}if((f|0)==(c[206220>>2]|0)){t=(c[206208>>2]|0)+p|0;c[206208>>2]=t;c[206220>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=206240+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){nd()}if((c[u+12>>2]|0)==(f|0)){break}nd()}}while(0);if((h|0)==(u|0)){c[51550]=c[51550]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){nd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}nd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){nd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){nd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){nd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{nd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=206504+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[206204>>2]=c[206204>>2]&~(1<<j);break b}else{if(m>>>0<(c[206216>>2]|0)>>>0){nd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[206216>>2]|0)>>>0){nd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[206216>>2]|0)>>>0){nd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[206220>>2]|0)){G=t;break}c[206208>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=206240+(B<<2)|0;D=c[51550]|0;b=1<<p;do{if((D&b|0)==0){c[51550]=D|b;H=206240+(B+2<<2)|0;I=A}else{p=206240+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[206216>>2]|0)>>>0)){H=p;I=a;break}nd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=206504+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[206204>>2]|0;B=1<<J;if((a&B|0)==0){c[206204>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[206216>>2]|0)>>>0){nd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[206216>>2]|0;if(L>>>0<B>>>0){nd()}if(G>>>0<B>>>0){nd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function Tla(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=Nla(d)|0;if((e|0)!=0){f=6;break}a=c[51674]|0;c[51674]=0+a;if((a|0)==0){f=5;break}Le[a&7]()}if((f|0)==5){d=Kc(4)|0;c[d>>2]=206712;Zd(d|0,206760,136)}else if((f|0)==6){i=b;return e|0}return 0}function Ula(a){a=a|0;var b=0,c=0;b=i;c=Tla(a)|0;i=b;return c|0}function Vla(a){a=a|0;var b=0;b=i;if((a|0)!=0){Ola(a)}i=b;return}function Wla(a){a=a|0;var b=0;b=i;Vla(a);i=b;return}function Xla(a){a=a|0;var b=0;b=i;Bb(a|0);Vla(a);i=b;return}function Yla(a){a=a|0;var b=0;b=i;Bb(a|0);i=b;return}function Zla(a){a=a|0;i=i;return 206728}function _la(){var a=0;a=Kc(4)|0;c[a>>2]=206712;Zd(a|0,206760,136)}function $la(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,zc=0.0,Ac=0.0,Bc=0,Cc=0,Dc=0.0,Ec=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==1){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else if((e|0)==2){j=53;k=-1074}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=cma(b)|0}}while((pd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=cma(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[206776+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=cma(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[206792+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=cma(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=cma(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=cma(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=cma(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=cma(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=cma(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=zma(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=zma(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=cma(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){bma(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=zma(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=ama(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){bma(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=uma(q|0,n|0,2)|0;o=zma(p|0,J|0,-32,-1)|0;p=zma(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Tc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Tc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=zma(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=yma(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=zma(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+kd(+(+dma(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Tc()|0)>>2]=34}l=+ema(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=cma(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=cma(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=cma(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=zma(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=zma(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=cma(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=ama(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){bma(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=zma(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Tc()|0)>>2]=22;bma(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Tc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Tc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[206808+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[206808+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[206808+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=uma(c[Ra>>2]|0,0,29)|0;Qa=zma(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=Kma(Qa|0,Ta|0,1e9,0)|0;pa=Lma(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=uma(c[Ua>>2]|0,0,29)|0;Ra=zma(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=Kma(Ra|0,Sa|0,1e9,0)|0;Pa=Lma(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[206800+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+kd(+(+dma(1.0,105-tc|0)),+sc);vc=+Fc(+sc,+(+dma(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){zc=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Ac=xc;break}}Ac=la*.25+xc}else{if(na>>>0>5e8){Ac=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Ac=la*.5+xc;break}else{Ac=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){zc=Ac;break}if(+Fc(+Ac,1.0)!=0.0){zc=Ac;break}zc=Ac+1.0}}while(0);la=yc+zc-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Bc=uc;Cc=kc;Dc=la}else{Bc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Cc=kc+1|0;Dc=la*.5}if((Cc+50|0)<=(p|0)){if(!((Bc|0)!=0&zc!=0.0)){Ec=Cc;Gc=Dc;break}}c[(Tc()|0)>>2]=34;Ec=Cc;Gc=Dc}else{Ec=kc;Gc=la}}while(0);l=+ema(Gc,Ec);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=cma(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=cma(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Tc()|0)>>2]=22;bma(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Tc()|0)>>2]=22;bma(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function ama(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=cma(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=cma(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=cma(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=Jma(q|0,m|0,10,0)|0;b=J;g=zma(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=zma(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=cma(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=cma(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=yma(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function bma(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function cma(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=gma(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function dma(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=uma(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function ema(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+dma(a,b);i=c;return+d}function fma(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){re[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function gma(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((fma(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((re[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function hma(a){a=a|0;var b=0,c=0.0;b=i;c=+ima(a,0);i=b;return+c}function ima(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;bma(e,0);h=+$la(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function jma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;bma(e,0);h=+$la(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function kma(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function lma(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function mma(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function nma(){c[46778]=p;c[46820]=p;c[51462]=p;c[51692]=p}function oma(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}ic(116);ic(111);ic(111);ic(32);ic(109);ic(97);ic(110);ic(121);ic(32);ic(115);ic(101);ic(116);ic(106);ic(109);ic(112);ic(115);ic(32);ic(105);ic(110);ic(32);ic(97);ic(32);ic(102);ic(117);ic(110);ic(99);ic(116);ic(105);ic(111);ic(110);ic(32);ic(99);ic(97);ic(108);ic(108);ic(44);ic(32);ic(98);ic(117);ic(105);ic(108);ic(100);ic(32);ic(119);ic(105);ic(116);ic(104);ic(32);ic(97);ic(32);ic(104);ic(105);ic(103);ic(104);ic(101);ic(114);ic(32);ic(118);ic(97);ic(108);ic(117);ic(101);ic(32);ic(102);ic(111);ic(114);ic(32);ic(77);ic(65);ic(88);ic(95);ic(83);ic(69);ic(84);ic(74);ic(77);ic(80);ic(83);ic(10);ga(0);return 0}function pma(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function qma(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function rma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function sma(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{rma(b,c,d)|0}return b|0}function tma(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function uma(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function vma(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function wma(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function xma(){return wma(o)|0}function yma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function zma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function Ama(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function Bma(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function Cma(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function Dma(a){a=a|0;if((a|0)<65)return a|0;if((a|0)>90)return a|0;return a-65+97|0}function Ema(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function Fma(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function Gma(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function Hma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=yma(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=yma((Mma(i,b,yma(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function Ima(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=yma(h^a,j^b,h,j)|0;b=J;Mma(m,b,yma(k^d,l^e,k,l)|0,J,g)|0;l=yma(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function Jma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=Gma(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function Kma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Mma(a,b,c,d,0)|0;return(J=J,e)|0}function Lma(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;Mma(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function Mma(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((Fma(l|0)|0)>>>0);return(J=n,o)|0}p=(Ema(l|0)|0)-(Ema(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(Ema(l|0)|0)-(Ema(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(Ema(j|0)|0)+33-(Ema(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=Fma(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=zma(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;yma(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=yma(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function Nma(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return he[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Oma(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ie[a&31](b|0,c|0,d|0,e|0,f|0)}function Pma(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return je[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function Qma(a,b){a=a|0;b=+b;ke[a&1](+b)}function Rma(a,b){a=a|0;b=b|0;le[a&511](b|0)}function Sma(a,b,c){a=a|0;b=b|0;c=c|0;me[a&127](b|0,c|0)}function Tma(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return ne[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function Uma(a,b){a=a|0;b=b|0;return oe[a&127](b|0)|0}function Vma(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;pe[a&1](b|0,c|0,+d,e|0)}function Wma(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function Xma(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return re[a&63](b|0,c|0,d|0)|0}function Yma(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return se[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function Zma(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return te[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function _ma(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ue[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function $ma(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ve[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function ana(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return we[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function bna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;xe[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function cna(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;ye[a&3](b|0,c|0,+d,e|0,f|0)}function dna(a,b,c){a=a|0;b=b|0;c=+c;return ze[a&1](b|0,+c)|0}function ena(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;Ae[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function fna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;Be[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function gna(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;Ce[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function hna(a,b,c){a=a|0;b=b|0;c=c|0;return De[a&63](b|0,c|0)|0}function ina(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return Ee[a&63](b|0,c|0,d|0,e|0,f|0)|0}function jna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return Fe[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function kna(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+Ge[a&1](b|0,+c,+d)}function lna(a,b,c){a=a|0;b=b|0;c=c|0;return+He[a&1](b|0,c|0)}function mna(a){a=a|0;return Ie[a&7]()|0}function nna(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return Je[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function ona(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ke[a&15](b|0,c|0,d|0)}function pna(a){a=a|0;Le[a&7]()}function qna(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Me[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function rna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return Ne[a&63](b|0,c|0,d|0,e|0)|0}function sna(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Oe[a&63](b|0,c|0,d|0,e|0)}function tna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function una(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function vna(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function wna(a){a=+a;ga(3)}function xna(a){a=a|0;ga(4)}function yna(a){a=a|0;Hd(a|0)}function zna(a,b){a=a|0;b=b|0;ga(5)}function Ana(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function Bna(a){a=a|0;ga(7);return 0}function Cna(a){a=a|0;return Uc(a|0)|0}function Dna(a){a=a|0;return Qd(a|0)|0}function Ena(a){a=a|0;return Cc(a|0)|0}function Fna(a){a=a|0;return Ed(a|0)|0}function Gna(a){a=a|0;return rd(a|0)|0}function Hna(a){a=a|0;return zd(a|0)|0}function Ina(a){a=a|0;return dd(a|0)|0}function Jna(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function Kna(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function Lna(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function Mna(a,b,c){a=a|0;b=b|0;c=c|0;return Bd(a|0,b|0,c|0)|0}function Nna(a,b,c){a=a|0;b=b|0;c=c|0;return nc(a|0,b|0,c|0)|0}function Ona(a,b,c){a=a|0;b=b|0;c=c|0;return Ya(a|0,b|0,c|0)|0}function Pna(a,b,c){a=a|0;b=b|0;c=c|0;return Fd(a|0,b|0,c|0)|0}function Qna(a,b,c){a=a|0;b=b|0;c=c|0;return Cd(a|0,b|0,c|0)|0}function Rna(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function Sna(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function Tna(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function Una(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function Vna(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function Wna(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function Xna(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function Yna(a,b){a=a|0;b=+b;ga(18);return 0}function Zna(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function _na(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function $na(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function aoa(a,b){a=a|0;b=b|0;ga(22);return 0}function boa(a,b){a=a|0;b=b|0;return Wd(a|0,b|0)|0}function coa(a,b){a=a|0;b=b|0;return mc(a|0,b|0)|0}function doa(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function eoa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function foa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function goa(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function hoa(a,b){a=a|0;b=b|0;ga(26);return 0.0}function ioa(){ga(27);return 0}function joa(){return jb()|0}function koa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function loa(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function moa(){ga(30)}function noa(){_c()}function ooa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function poa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function qoa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return xc(a|0,b|0,c|0,d|0)|0}function roa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Sc(a|0,b|0,c|0,d|0)|0}function soa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}




// EMSCRIPTEN_END_FUNCS
var he=[tna,GV,IV,NV,Q8,tna,tna,tna];var ie=[una,MP,NP,qQ,rQ,VQ,WQ,rR,sR,tR,Jla,Ila,Hla,_T,eP,fP,SS,QS,una,una,una,una,una,una,una,una,una,una,una,una,una,una];var je=[vna,qX];var ke=[wna,sW];var le=[xna,rn,sn,wp,xp,Gz,zp,NS,CZ,FZ,EZ,GZ,Oda,Nda,Qda,Pda,HZ,JZ,V0,r1,s1,t1,zda,yda,Bda,Ada,a8,m8,z8,A8,B8,D8,F8,vaa,waa,Caa,Daa,Jaa,Kaa,Qaa,Raa,bba,aba,gba,fba,iba,jba,sba,rba,zca,yca,Ica,Hca,kda,jda,Ida,Hda,Kda,Jda,aea,$da,cea,bea,iea,hea,xca,jea,gea,kea,mea,lea,uia,sea,rea,xea,wea,Wea,Vea,yfa,xfa,Mfa,Lfa,_fa,Zfa,mga,lga,zga,yga,Cga,Bga,Gga,Fga,Rga,Qga,aha,$ga,lha,kha,wha,vha,Gha,Fha,Oha,Nha,Uha,Tha,_ha,Zha,dia,cia,mia,lia,Kia,Jia,hia,$ia,Gja,Fja,Ija,Hja,nea,tia,wia,Tia,hja,sja,Dja,Eja,ula,tla,wla,zla,xla,yla,Ala,Bla,Yla,Xla,xl,yna,kf,lf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,yf,zf,Df,Ef,Ff,Gf,Hf,If,Jf,Kf,Mf,Nf,Sf,Tf,Yf,Zf,ig,jg,lg,mg,pg,qg,wg,xg,yg,Bg,Kg,Lg,Og,Pg,Sg,Tg,Zg,_g,$g,ch,dh,eh,nh,oh,rh,sh,uh,wh,xh,Dh,Eh,Fh,Hh,Uh,bi,ci,hi,ii,li,oi,pi,qi,ri,si,ui,Bi,Ni,Oi,Pi,Ri,bj,cj,dj,oj,pj,yj,zj,Lj,Nj,Yj,Zj,_j,$j,ak,bk,ck,dk,ek,fk,hk,ik,jk,pk,qk,vk,zk,Ik,Jk,Lk,Mk,Nk,Ok,Pk,Qk,Rk,Sk,Tk,Uk,Vk,Wk,Xk,Yk,Zk,_k,$k,al,bl,cl,dl,el,fl,gl,hl,il,jl,kl,ll,ml,nl,ol,pl,ql,rl,sl,Ola,PS,df,cW,gW,bW,tX,iW,rX,uU,lW,jW,kW,hW,nW,sX,oW,dW,qW,X7,rW,V9,uaa,via,oka,yha,vka,uka,tka,ska,rka,qka,Iba,kca,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna,xna];var me=[zna,yp,_X,KZ,Zca,xaa,Eaa,Laa,Saa,lda,Jga,Kga,Lga,Mga,Oga,Pga,Uga,Vga,Wga,Xga,Zga,_ga,dha,eha,fha,gha,iha,jha,oha,pha,qha,rha,tha,uha,bia,gia,Nja,Pja,Rja,Oja,Qja,Sja,VV,zn,Hn,On,Wn,co,lo,to,Bo,Io,Qo,Yo,ep,mp,up,KU,GU,TL,gM,pN,mW,B0,aY,$X,bY,hY,tY,cY,rY,Q$,a0,$$,b0,L$,J$,N$,c9,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna,zna];var ne=[Ana,tP,mP,HV,JV,KV,LV,MV];var oe=[Bna,ul,OG,tl,ff,gf,hf,Hz,Wz,Fp,Fz,NG,HK,Ep,Cp,IK,JK,dL,eL,fL,gL,hL,iL,jL,kL,Cna,Dna,Ena,mT,Nla,Fna,OZ,cda,PZ,fda,bda,I8,yaa,qda,sda,tda,pda,Faa,Gaa,Maa,eda,Taa,Uaa,cba,hba,eea,$fa,Tja,Vja,Xja,bka,dka,Zja,$ja,nga,Uja,Wja,Yja,cka,eka,_ja,aka,Hga,Iga,Nga,Sga,Tga,Yga,bha,cha,hha,mha,nha,sha,dja,eja,gja,Jja,Lja,Kja,Mja,Xia,Yia,_ia,nja,oja,rja,yja,zja,Cja,vla,Zla,AX,Gna,Hna,yX,zX,Ina,Q7,r8,zW,HW,QW,AW,KW,RW,maa,gma,Bna,Bna,Bna,Bna,Bna,Bna,Bna,Bna,Bna,Bna,Bna,Bna,Bna,Bna,Bna];var pe=[Jna,YT];var qe=[Kna,qV];var re=[Lna,Bp,DP,JP,hQ,nQ,MQ,SQ,LZ,dda,hda,_ca,mda,rda,zaa,vda,Naa,mba,nba,qea,vea,$ha,eia,Mia,Oia,Ria,xia,Cia,Eia,Hia,Cla,Z7,ZT,CU,oN,qP,hP,oP,uP,Mna,Nna,Ona,uX,W7,S7,Pna,eaa,Qna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna,Lna];var se=[Rna,uV];var te=[Sna,OU];var ue=[Tna,Gfa,Jfa,Ufa,Wfa,Tna,Tna,Tna];var ve=[Una,Aga,Dga,xha,Bha,Hha,Jha,Una];var we=[Vna,oV];var xe=[Wna,KS,MZ,G8,nda,$ca,zfa,Afa,Efa,Kfa,Nfa,Ofa,Sfa,Xfa,aia,fia,Mla,Lla,Kla,LS,Wna,Wna,Wna,Wna,Wna,Wna,Wna,Wna,Wna,Wna,Wna,Wna];var ye=[Xna,IW,JW,Xna];var ze=[Yna,wl];var Ae=[Zna,yea,Aea,Cea,Eea,Gea,Iea,Kea,Mea,Oea,Qea,Sea,Xea,Zea,$ea,bfa,dfa,ffa,hfa,jfa,lfa,nfa,pfa,Dfa,Ffa,Rfa,Tfa,aga,bga,cga,dga,ega,oga,pga,qga,rga,sga,Sha,Yha,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna,Zna];var Be=[_na,Pha,Vha,_na];var Ce=[$na,fga,tga,$na];var De=[aoa,ef,Lp,Dp,Ap,lL,mL,FP,GP,IP,jQ,kQ,mQ,OQ,PQ,RQ,XQ,YQ,ZQ,_Q,$Q,aR,bR,cR,QZ,RZ,J8,K8,uda,Aaa,Haa,wda,gda,Oaa,Vaa,ida,Lia,Nia,Pia,Bia,Dia,Fia,iX,TW,LW,BW,SW,boa,fM,Qla,bP,cP,dP,coa,DT,EW,eX,XW,GW,doa,fla,aoa,aoa,aoa];var Ee=[eoa,oea,tea,Sia,cja,fja,Iia,Wia,Zia,mja,pja,xja,Aja,zR,qS,rS,ER,BR,oS,pS,FR,GR,HR,IR,JR,eS,fS,XR,QR,LR,KR,MR,NR,PR,OR,CR,AR,RR,SR,TR,UR,VR,WR,YR,ZR,_R,$R,dS,bS,aS,cS,kS,gS,hS,iS,jS,lS,mS,nS,sS,tS,uS,vS,Bfa];var Fe=[foa,FX];var Ge=[goa,UW];var He=[hoa,YU];var Ie=[ioa,oL,joa,nT,raa,saa,paa,ioa];var Je=[koa,tV];var Ke=[loa,$7,lba,fea,ST,VS,VX,XX,A0,b9,loa,loa,loa,loa,loa,loa];var Le=[moa,noa,lT,yS,zl,moa,moa,moa];var Me=[ooa,nL,aja,bja,Uia,Via,ija,kja,tja,vja,YW,ooa,ooa,ooa,ooa,ooa];var Ne=[poa,xP,yP,zP,AP,BP,CP,EP,HP,LP,bQ,cQ,dQ,eQ,fQ,gQ,iQ,lQ,pQ,GQ,HQ,IQ,JQ,KQ,LQ,NQ,QQ,UQ,Qia,yia,zia,Aia,Gia,XV,qoa,FM,pV,VO,YN,rO,AO,mO,JO,OO,MO,PO,vP,$O,jP,kP,rP,sP,Uea,Hfa,roa,poa,poa,poa,poa,poa,poa,poa,poa,poa];var Oe=[soa,KP,oQ,TQ,NZ,_7,H8,oda,ada,pea,uea,Dla,Ela,Fla,TS,RS,ZV,BU,QT,US,XT,$S,An,In,Pn,Xn,eo,mo,uo,Co,Jo,Ro,Zo,fp,np,vp,w9,lP,WS,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa,soa];return{_testSetjmp:Cma,_saveSetjmp:oma,_bitshift64Ashr:qma,_free:Ola,_main:yl,_rand_r:wma,_realloc:Qla,_i64Add:zma,_memmove:sma,_tolower:Dma,_memset:tma,_malloc:Nla,_strncpy:Ama,_memcpy:rma,_strlen:pma,_bitshift64Lshr:Bma,_bitshift64Shl:uma,_i64Subtract:yma,_strcpy:vma,_calloc:Pla,_rand:xma,__GLOBAL__I_a:Xaa,runPostSets:nma,stackAlloc:Pe,stackSave:Qe,stackRestore:Re,setThrew:Se,setTempRet0:Ve,setTempRet1:We,setTempRet2:Xe,setTempRet3:Ye,setTempRet4:Ze,setTempRet5:_e,setTempRet6:$e,setTempRet7:af,setTempRet8:bf,setTempRet9:cf,dynCall_iiiiiiii:Nma,dynCall_viiiii:Oma,dynCall_iiiiidiii:Pma,dynCall_vd:Qma,dynCall_vi:Rma,dynCall_vii:Sma,dynCall_iiiiiiiiiii:Tma,dynCall_ii:Uma,dynCall_viidi:Vma,dynCall_iiiiiiiiiiiiii:Wma,dynCall_iiii:Xma,dynCall_iiiiiiiiiiiiiiiiiiiiiii:Yma,dynCall_iiiiiiiiiiiiiiiiiiiii:Zma,dynCall_viiiiid:_ma,dynCall_viiiiiiii:$ma,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:ana,dynCall_viiiiii:bna,dynCall_viidii:cna,dynCall_iid:dna,dynCall_viiiiiii:ena,dynCall_viiiiiid:fna,dynCall_viiiiiiiii:gna,dynCall_iii:hna,dynCall_iiiiii:ina,dynCall_iiiiidi:jna,dynCall_didd:kna,dynCall_dii:lna,dynCall_i:mna,dynCall_iiiiiiiiii:nna,dynCall_viii:ona,dynCall_v:pna,dynCall_iiiiiiiii:qna,dynCall_iiiii:rna,dynCall_viiii:sna}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_exp": _exp, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "_fscanf": _fscanf, "___cxa_guard_acquire": ___cxa_guard_acquire, "_log10": _log10, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "_isblank": _isblank, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "_sinh": _sinh, "_sysconf": _sysconf, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_tanh": _tanh, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "__isLeapYear": __isLeapYear, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_ctime": _ctime, "___cxa_is_number_type": ___cxa_is_number_type, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "__reallyNegative": __reallyNegative, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_strchr": _strchr, "_mktime": _mktime, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_localeconv": _localeconv, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_vsnprintf": _vsnprintf, "_strtoull_l": _strtoull_l, "_asctime": _asctime, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_fseek": _fseek, "__ZSt9terminatev": __ZSt9terminatev, "_asctime_r": _asctime_r, "_isxdigit": _isxdigit, "_fclose": _fclose, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_tan": _tan, "_copysign": _copysign, "__parseInt64": __parseInt64, "__getFloat": __getFloat, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "_cosh": _cosh, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_strdup": _strdup, "_asprintf": _asprintf, "__formatString": __formatString, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "_lis_vector_create": _lis_vector_create, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_mkport": _mkport, "_feof": _feof, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_fgetc": _fgetc, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_solver_destroy": _lis_solver_destroy, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_fgets": _fgets, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _tolower = Module["_tolower"] = asm["_tolower"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






